/*
 * Google Code Jam
 * ckkampy@gmail.com
 * Bathroom Stalls
 */
package pkg1;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

public class Main {
    private static BigInteger two = new BigInteger("2");
    private static BigInteger three = new BigInteger("3");
    private static BigInteger four = new BigInteger("4");
    public static void main(String[] args) throws FileNotFoundException, IOException {
       try(BufferedReader br = new BufferedReader(new FileReader("C-small-2-attempt2.in"))) {
           StringBuilder sb = new StringBuilder();
           String line = br.readLine();
           List<String> results = new ArrayList<>();
           int count = 0;
           BigInteger numOfEmptyStash;
           BigInteger numOfUser;
           BigInteger maxDistance;
           BigInteger minDistance;
           BigInteger[] maxMinValue;
           while (line != null) {
               if (count != 0) {
                   numOfEmptyStash = new BigInteger(line.split(" ")[0]);
                   numOfUser = new BigInteger(line.split(" ")[1]);
                   maxMinValue = getMinMaxDistance(numOfEmptyStash, numOfUser);
                   maxDistance = maxMinValue[0];
                   minDistance = maxMinValue[1];
                   results.add(maxDistance + " " + minDistance);
               }
               line = br.readLine();
               count++;
           }
           
           int index = 1;
           for (String r : results) {
               sb.append("Case #").append(index).append(": ").append(r).append("\n");
               index++;
           }
           System.out.println(sb.toString());
           try (PrintWriter out = new PrintWriter(new FileWriter("C-small-2-attempt2.out", false), true)) {
               out.write(sb.toString());
           }
       }
    }
    
    private static BigInteger[] getMinMaxDistance(BigInteger numOfEmptyStash, BigInteger numOfUser) {
        BigInteger[] results = new BigInteger[2];
        if (numOfEmptyStash.divide(numOfUser).compareTo(two) < 0) {
            results[0] = BigInteger.ZERO;
            results[1] = BigInteger.ZERO;
            return results;
        }
        else if (numOfEmptyStash.divide(numOfUser).compareTo(three) < 0) {
            results[0] = BigInteger.ONE;
            results[1] = BigInteger.ZERO;
            return results;
        }
        else if (numOfEmptyStash.divide(numOfUser).compareTo(four) < 0) {
            results[0] = BigInteger.ONE;
            results[1] = BigInteger.ONE;
            return results;
        }
        
        //System.out.println("Case: " + numOfEmptyStash + " " + numOfUser);
        List<BigInteger> listOfMaxEmptyStashes = new ArrayList<>();
        listOfMaxEmptyStashes.add(numOfEmptyStash);
        BigInteger currentLargestEmptyCount;
        BigInteger firstNumAfterSplit, secondNumAfterSplit;
        int index = 0;
        for (BigInteger count = BigInteger.ZERO; count.compareTo(numOfUser) < 0; count = count.add(BigInteger.ONE)) {
            currentLargestEmptyCount = findLargestEmptyCount(listOfMaxEmptyStashes);
            if (currentLargestEmptyCount.mod(two).equals(BigInteger.ZERO)) {
                firstNumAfterSplit = currentLargestEmptyCount.divide(two);
                secondNumAfterSplit = firstNumAfterSplit.subtract(BigInteger.ONE);
            }
            else {
                firstNumAfterSplit = currentLargestEmptyCount.subtract(BigInteger.ONE).divide(two);
                secondNumAfterSplit = firstNumAfterSplit;
            }
            listOfMaxEmptyStashes.add(firstNumAfterSplit);
            listOfMaxEmptyStashes.add(secondNumAfterSplit);
            listOfMaxEmptyStashes = removeValueFromList(listOfMaxEmptyStashes, currentLargestEmptyCount);
            System.out.println("Current List:" + listOfMaxEmptyStashes);
            if (count.compareTo(numOfUser.subtract(BigInteger.ONE)) == 0) {
                if (currentLargestEmptyCount.mod(two).equals(BigInteger.ZERO)) {
                    results[0] = currentLargestEmptyCount.divide(two);
                    results[1] = results[0].subtract(BigInteger.ONE);
                }
                else {
                    results[0] = currentLargestEmptyCount.subtract(BigInteger.ONE).divide(two);
                    results[1] = results[0];
                }
                
            }
        }

        return results;
    }
    
    private static BigInteger findLargestEmptyCount(List<BigInteger> inputList) {
        BigInteger result = BigInteger.ZERO;
        for (BigInteger r : inputList) {
            if (result.compareTo(r) < 0)
                result = r;
        }

        return result;
    }
    
    private static BigInteger findSmallestEmptyCount(List<BigInteger> inputList) {
        BigInteger result = BigInteger.ZERO;
        int count = 1;
        for (BigInteger r : inputList) {
            if (count == 1)
                result = r;
            else{
                if (result.compareTo(r) > 0)
                    result = r;
            }
            count++;
        }

        return result;
    }
    
    private static List<BigInteger> removeValueFromList(List<BigInteger> inputList, BigInteger value) {
        for (BigInteger r : inputList) {
            if (value.compareTo(r) == 0) {
                inputList.remove(r);
                break;
            }
        }

        return inputList;
    }
    
    
}
