import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class FairAndSquare {

    final static String Problem = "FairAndSquare";
    final static String DIR = "D:\\GoogleCodeJam2013\\" + Problem + "\\";
    public static String lines[][] = null;
    public static int counts[] = null;
    public static int lineNum = 0;

    public static void readData() {
        FileReader fr = null;
        try {
            fr = new FileReader(DIR + "input.in");
            BufferedReader br = new BufferedReader(fr);
            lineNum = Integer.parseInt(br.readLine());
            lines = new String[lineNum][2];
            for (int i = 0; i < lineNum; i++) {
                String line = br.readLine();
                lines[i] = line.split(" ");
            }
        } catch (FileNotFoundException ex) {
            System.out.println(ex.getMessage());
        } catch (IOException ex) {
            System.out.println(ex.getMessage());
        } catch (Exception ex) {
            System.out.println(ex.getMessage());
        } finally {
            try {
                fr.close();
            } catch (IOException ex) {
                System.out.println(ex.getMessage());
            } catch (Exception ex) {
                System.out.println(ex.getMessage());
            }
        }
    }

    public static void writeData() {
        FileWriter fw = null;
        try {
            fw = new FileWriter(DIR + "output.txt");
            BufferedWriter bw = new BufferedWriter(fw);
            for (int i = 0; i < lineNum; i++) {
                bw.write("Case #" + (i + 1) + ": " + counts[i]);
                bw.newLine();
            }
            bw.flush();
        } catch (IOException ex) {
            System.out.println(ex.getMessage());
        } catch (Exception ex) {
            System.out.println(ex.getMessage());
        } finally {
            try {
                fw.close();
            } catch (IOException ex) {
                System.out.println(ex.getMessage());
            } catch (Exception ex) {
                System.out.println(ex.getMessage());
            }
        }
    }

    public static void solver() {
        counts = new int[lineNum];
        for (int i = 0; i < lines.length; i++) {
            int count = 0;
            int start = Integer.parseInt(lines[i][0]);
            int end = Integer.parseInt(lines[i][1]);
            for (int j = start; j <= end; j++) {
                StringBuilder originalSq = new StringBuilder(Integer.toString(j));
                String oSq = originalSq.toString();
                String oSqRev = originalSq.reverse().toString();
                if (oSq.equals(oSqRev)) {
                    int sqrt = (int) Math.sqrt(j);
                    if (sqrt * sqrt == j) {
                        StringBuilder originalSqrt = new StringBuilder(Integer.toString(sqrt));
                        String oSqrt = originalSqrt.toString();
                        String oSqrtRev = originalSqrt.reverse().toString();
                        if (oSqrt.equals(oSqrtRev)) {
                            count++;
                        }
                    }
                }
            }
            counts[i] = count;
        }

    }

    public static void main(String[] args) {
        readData();
        solver();
        writeData();
    }
}
