package codejam2014_cookie_clicker_alpha;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class BigCookie {

	/**
	 * Google Code Jam 2014 - Cookie Clicker Alpha problem
	 * (c)2014 Annelies Odermann
	 */
	
	public static void main(String[] args) {
		
		try {
			Scanner readFile = new Scanner(new File("B-small-attempt0.in"));
			
			PrintWriter writeFile = new PrintWriter(new File("results.txt"));
			
			
			int maxCases = Integer.parseInt(readFile.nextLine().trim());
			int thisCase = 0;
			
			while (thisCase < maxCases){
				thisCase ++;
				double lowestTime = findLowestTime(readFile.nextDouble(), readFile.nextDouble(), readFile.nextDouble());
				System.out.println("Case #" + thisCase + ": " + lowestTime);
				writeFile.println("Case #" + thisCase + ": " + lowestTime);
			}
			
			readFile.close();
			writeFile.close();
			
		} catch (FileNotFoundException e) {
			System.out.println("File could not be read.");
		}
		

	}
	
	public static double findLowestTime(double c, double f, double x){
		int farms = 0;
		double lowest = x / 2;
		double thisTime;
		
		do {
			farms ++;
			thisTime = 0;
			for (int i = 0; i < farms; i ++){
				thisTime += c / (2 + (f * i));
			}
			thisTime += x / (2 + (f * farms));
			if (thisTime < lowest){
				lowest = thisTime;
			}
		} while (thisTime == lowest);
		
		return lowest;
	}

}
