/*
 * Let's make a standing ovation for our friend!
 *
 * Determines the minimum number of shyness-zero friends we need to invite to
 * give our friend a standing ovation.
 *
 * Program to be run with java Ovation < infile > outfile
 */

import java.util.Scanner;

public class Ovation{
    
    public static void main(String[] args){
        Scanner scan = new Scanner(System.in);
        
        int numberTests = scan.nextInt();
        
        for(int test = 0; test < numberTests; test++){
            int sMax = scan.nextInt();
            int size = sMax+1;
            int[] audience = new int[size];
            
            String shynessStr = scan.next();
            for(int index = 0; index < size; index++){
                char tmpChar = shynessStr.charAt(index);
                audience[index] = Character.getNumericValue(tmpChar);
            }
            
            int sumAudienceClapping = 0;
            int maxNeededToAdd = 0;
            int neededToAdd;
            for(int index = 0; index < size; index++){
                /*
                * Calculates the maximum difference between those clapping so
                * far and the threshold of shyness needed to get these folks
                * clapping.
                */
                neededToAdd = index - sumAudienceClapping;
                if(neededToAdd > maxNeededToAdd){
                    maxNeededToAdd = neededToAdd;
                }
                sumAudienceClapping += audience[index];
            }
            
            System.out.println("Case #" + (test+1) + ": " + maxNeededToAdd);
        }
        
        
    }
}