import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;


public class QualA {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		QualA round1aa = new QualA();
		round1aa.execute("input.in", "output.out");
	}
	
	private void execute(String inFileName, String outFileName){
		FileHelper helper = new FileHelper();
		try {
			helper.init(inFileName, outFileName);
			String currentLine = null;
			int totalTestCases = 0;
			try{
				totalTestCases = Integer.parseInt(helper.getNextLine());
			}catch(NumberFormatException e){
				System.err.println("First line is not a number.");
				e.printStackTrace();
				System.exit(0);
			}
			String number;
			char[] bits;
			String result;
			int flipIndex = -1;
			for(int currentTestCase=0; currentTestCase < totalTestCases; currentTestCase++){
				number = null;result = null;
				number = helper.getNextLine();
				bits = number.toCharArray();
				flipIndex = bits.length;
				//System.out.println(number);
				if(number.length() == 1){
					helper.putNextLine(currentTestCase+1, number);
				}else{
					for(int i=bits.length-1; i>0;i--){
						if(Character.getNumericValue(bits[i]) < Character.getNumericValue(bits[i-1])){
							flipIndex = i;
							bits[i-1]= Character.forDigit(Character.getNumericValue(bits[i-1])-1, 10);
							}
						}
					//System.out.println(bits);
					
					if(flipIndex < bits.length){
						result = number.substring(0,flipIndex-1);
						result = result.concat(String.valueOf(bits[flipIndex-1]));
						for(int x=flipIndex;x<number.length();x++){
							result = result.concat("9");
						}
						if(result.charAt(0)=='0'){
							result=result.substring(1);
						}
					}else{
						result = number;
					}
					//System.out.println(result);
					helper.putNextLine(currentTestCase+1, result);
				}
			}
		}catch(FileNotFoundException e){
			System.err.println("Error while initiating input file.");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Error while reading next line or creating output file.");
			e.printStackTrace();
		}finally{
			try {
				helper.cleanup();
			} catch (IOException e) {
				System.err.println("Error while closing streams.");
				e.printStackTrace();
			}
		}
	}
	
	private class FileHelper{
		private BufferedReader br = null;
		private BufferedWriter bw = null;
		private void init(final String inFfileName, final String outFileName) throws IOException{
			br = new BufferedReader(new FileReader(inFfileName));
			bw = new BufferedWriter(new FileWriter(outFileName));
		}
		
		private String getNextLine() throws IOException{
			String currentLine;
			while ((currentLine = br.readLine()) != null) {
				return currentLine;
			}
			return null;
		}
		
		private void cleanup() throws IOException{
			br.close();
			bw.flush();
			bw.close();
		}
		
		private void putNextLine(int currentTestCase, String content) throws IOException{
			bw.append("Case #").append(Integer.toString(currentTestCase)).append(": ").append(content).append("\n");
		}
	}

}
