import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

import com.sun.xml.internal.ws.util.StringUtils;


public class QualA {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		QualA round1aa = new QualA();
		round1aa.execute("input.in", "output.out");
	}
	
	private void execute(String inFileName, String outFileName){
		FileHelper helper = new FileHelper();
		try {
			helper.init(inFileName, outFileName);
			String currentLine = null;
			int totalTestCases = 0;
			try{
				totalTestCases = Integer.parseInt(helper.getNextLine());
			}catch(NumberFormatException e){
				System.err.println("First line is not a number.");
				e.printStackTrace();
				System.exit(0);
			}
			int ans, multiplier, currentInt = 0;
			Set digits = null;
			
			for(int currentTestCase=0; currentTestCase < totalTestCases; currentTestCase++){
				ans= 0; multiplier = 1;
				digits = new HashSet();
				currentLine = helper.getNextLine();
				currentInt = Integer.parseInt(currentLine);
				if(currentInt == 0){
					helper.putNextLine(currentTestCase+1, "INSOMNIA");
					continue;
				}
				do{
					digits.addAll(this.convertToSet(Integer.toString(currentInt*multiplier)));
					multiplier++;
				}while(digits.size()<10);
				ans = currentInt*(multiplier - 1);
				helper.putNextLine(currentTestCase+1, Integer.toString(ans));
			}
		}catch(FileNotFoundException e){
			System.err.println("Error while initiating input file.");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Error while reading next line or creating output file.");
			e.printStackTrace();
		}finally{
			try {
				helper.cleanup();
			} catch (IOException e) {
				System.err.println("Error while closing streams.");
				e.printStackTrace();
			}
		}
	}
	private static Set convertToSet(String string) {

	      Set resultSet = new HashSet();
	      for (int i = 0; i < string.length(); i++) {
	          resultSet.add(new Character(string.charAt(i)));
	      }
	      return resultSet;
	  }
	
	private class FileHelper{
		private BufferedReader br = null;
		private BufferedWriter bw = null;
		private void init(final String inFfileName, final String outFileName) throws IOException{
			br = new BufferedReader(new FileReader(inFfileName));
			bw = new BufferedWriter(new FileWriter(outFileName));
		}
		
		private String getNextLine() throws IOException{
			String currentLine;
			while ((currentLine = br.readLine()) != null) {
				return currentLine;
			}
			return null;
		}
		
		private void cleanup() throws IOException{
			br.close();
			bw.flush();
			bw.close();
		}
		
		private void putNextLine(int currentTestCase, String content) throws IOException{
			bw.append("Case #").append(Integer.toString(currentTestCase)).append(": ").append(content).append("\n");
		}
	}

}
