import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class QualA {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		QualA round1aa = new QualA();
		round1aa.execute("input.in", "output.out");
	}
	
	private void execute(String inFileName, String outFileName){
		FileHelper helper = new FileHelper();
		try {
			helper.init(inFileName, outFileName);
			String currentLine = null;
			int totalTestCases = 0;
			try{
				totalTestCases = Integer.parseInt(helper.getNextLine());
			}catch(NumberFormatException e){
				System.err.println("First line is not a number.");
				e.printStackTrace();
				System.exit(0);
			}
			StringBuilder currentNum =new StringBuilder();
			ArrayList divisors = new ArrayList();
			helper.putNextLine(1, "");
			
				currentNum =new StringBuilder();
				currentNum.append("1");
				currentLine = helper.getNextLine();
				StringTokenizer currentLineTokens = new StringTokenizer(currentLine, " ");
				int N = Integer.parseInt(currentLineTokens.nextToken());
				int J = Integer.parseInt(currentLineTokens.nextToken());
				for(int i=0;i<N-2;i++){
					currentNum.append("0");
				}
				currentNum.append("1");
				BigInteger currentValue = BigInteger.ZERO;
				do{
					//System.out.println("J:"+J+", currentNum:"+currentNum);
					divisors.clear();
					for(int base=2;base<11;base++){
						currentValue = new BigInteger(currentNum.toString(), base);
							BigInteger devisor = isPrime(currentValue);
							if(!devisor.equals(BigInteger.ZERO)){
								divisors.add(devisor);
							}else{
								break;
							}
					}
					if(divisors.size()==9){
						StringBuilder builder = new StringBuilder();
						for (int index=0; index<divisors.size();index++) {
						    builder.append(divisors.get(index)+" ");
						}
						String text = builder.toString();
						helper.putNextLine(currentNum.toString()+" "+text);
						J--;
					}
					
					String tempString = currentNum.substring(1,currentNum.length()-1);
					int tempValue = Integer.parseInt(tempString, 2);
					tempValue++;
					currentNum.replace(1, currentNum.length()-1, String.format("%30s", Integer.toBinaryString(tempValue)).replace(' ', '0'));
				}while(J>0 && !currentNum.toString().equals("11111111111111111111111111111111"));
				if(currentNum.toString().equals("11111111111111111111111111111111")){
					helper.putNextLine("Bummer, too less probability risk!!");
				}
		}catch(FileNotFoundException e){
			System.err.println("Error while initiating input file.");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Error while reading next line or creating output file.");
			e.printStackTrace();
		}finally{
			try {
				helper.cleanup();
			} catch (IOException e) {
				System.err.println("Error while closing streams.");
				e.printStackTrace();
			}
		}
	}
	
	private BigInteger isPrime(BigInteger n) {
		if (n.mod(BigInteger.valueOf(2))==BigInteger.ZERO) return BigInteger.valueOf(2);
		if(n.isProbablePrime(1)){
			return BigInteger.ZERO;
		};
		BigInteger i=BigInteger.valueOf(3);
	    while(i.multiply(i).compareTo(BigInteger.valueOf(100000000)) <0) { //risk to short circuit against time which may result in not finding all values.
	        if(n.mod(i).equals(BigInteger.ZERO)){
	            return i;
	        }
	        i=i.nextProbablePrime();
	    }
	    return BigInteger.ZERO;
	}
	
	private class FileHelper{
		private BufferedReader br = null;
		private BufferedWriter bw = null;
		private void init(final String inFfileName, final String outFileName) throws IOException{
			br = new BufferedReader(new FileReader(inFfileName));
			bw = new BufferedWriter(new FileWriter(outFileName));
		}
		
		private String getNextLine() throws IOException{
			String currentLine;
			while ((currentLine = br.readLine()) != null) {
				return currentLine;
			}
			return null;
		}
		
		private void cleanup() throws IOException{
			br.close();
			bw.flush();
			bw.close();
		}
		
		private void putNextLine(int currentTestCase, String content) throws IOException{
			bw.append("Case #").append(Integer.toString(currentTestCase)).append(": ").append(content).append("\n");
		}
		
		private void putNextLine(String content) throws IOException{
			bw.append(content).append("\n");
		}
	}

}
