import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
/**
 * An algorithm that will find all possible combinations of 'welcome to code jam'
 * @author Chandrakant Dhome
 */
public class B {
	private static String inputFileName = "A-large.in";
	private static String outputFileName = "OutputLarge.out";
	private BufferedReader fileReader = null;
	private DataOutputStream fileWriter = null;
	
	public static void main(String[] args) {
		B processor = new B();
		processor.process();
	}
	private void process() {
		fileReader = getInputStreamFromFileName(inputFileName);
		if(fileReader == null){
			System.out.println("Cannot read from input file.");
			return;
		}
		fileWriter = getOutputStreamFromFileName(outputFileName);
		if(fileWriter == null){
			System.out.println("Cannot write to output file.");
			return;
		}
		int noOfTestCases = 0;
	
		try {
			noOfTestCases = new Integer(fileReader.readLine()).intValue();
		} catch (NumberFormatException e) {
			e.printStackTrace();
			System.out.println("First line does not contain no of test cases.");
			return;
		} catch (IOException e) {
			e.printStackTrace();
			System.out.println("Error reading file, "+inputFileName);
			return;
		}
		int testCnt = 0;
		String[] inputVar = null;
		int noOfSnappers = 0;
		int snaps = 0;
		double firstOnCount = 0;
		if(noOfTestCases > 0){
			while(testCnt < noOfTestCases){
				try {
					inputVar = fileReader.readLine().split("[\\s]+");
					noOfSnappers = Integer.parseInt(inputVar[0]);
					snaps = Integer.parseInt(inputVar[1]);
					firstOnCount = Math.pow(2, noOfSnappers);
					if(snaps % firstOnCount == (firstOnCount-1)){
						fileWriter.writeBytes("Case #"+(testCnt+1)+": ON\n");
					}else{
						fileWriter.writeBytes("Case #"+(testCnt+1)+": OFF\n");
					}
					
				} catch (IOException e) {
					System.out.println("Cannot read from file.");
					e.printStackTrace();
				}
				testCnt++;
			}
		}else{
			System.out.println("No test cases to execute...Exiting.");
		}
		try {
			fileReader.close();
			fileWriter.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.out.println("File reader/writer cannot be closed...Exiting.");
		}
	}
	
	public static BufferedReader getInputStreamFromFileName(String fileName){
		try {
			InputStream fileInStream = new FileInputStream(fileName);
			InputStream dataInStream = new DataInputStream(fileInStream);
			BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(dataInStream));
			return bufferedReader;
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	//Should use BufferedWriter but for contest I need to see updated file ASAP.
	public static DataOutputStream getOutputStreamFromFileName(String fileName){
		try {
			OutputStream fileOutStream = new FileOutputStream(fileName);
			DataOutputStream dataOutStream = new DataOutputStream(fileOutStream);
			return dataOutStream;
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return null;
	}
}
