import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;


public class QualA {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		QualA round1aa = new QualA();
		round1aa.execute("input.in", "output.out");
	}
	
	private void execute(String inFileName, String outFileName){
		FileHelper helper = new FileHelper();
		try {
			helper.init(inFileName, outFileName);
			String currentLine = null;
			int totalTestCases = 0;
			try{
				totalTestCases = Integer.parseInt(helper.getNextLine());
			}catch(NumberFormatException e){
				System.err.println("First line is not a number.");
				e.printStackTrace();
				System.exit(0);
			}
			int firstAns,secondndAns = 0;
			ArrayList<String> firstCards, secondCards = null;
			for(int currentTestCase=0; currentTestCase < totalTestCases; currentTestCase++){
				firstAns = 0; secondndAns = 0;
				firstAns = Integer.parseInt(helper.getNextLine());
				int pointer=0;
				for(pointer=0; pointer < firstAns; pointer++){
					currentLine = helper.getNextLine();
				}
				firstCards = new ArrayList<String>(Arrays.asList(currentLine.split(" ")));
				while(pointer < 4){
					currentLine = helper.getNextLine();
					pointer++;
				}
				currentLine = helper.getNextLine();
				secondndAns = Integer.parseInt(currentLine);
				for(pointer=0; pointer < secondndAns; pointer++){
					currentLine = helper.getNextLine();
				}
				secondCards = new ArrayList<String>(Arrays.asList(currentLine.split(" ")));
				while(pointer < 4){
					currentLine = helper.getNextLine();
					pointer++;
				}
				String guessedCard = null;
				String currentCard = null;
				boolean duplicateFound = false;
				
				Iterator<String> iter = firstCards.iterator();
				while(iter.hasNext()){
					currentCard = iter.next();
					if(secondCards.contains(currentCard)){
						if(guessedCard == null){
							guessedCard = currentCard;
						}else{
							helper.putNextLine(currentTestCase+1, "Bad magician!");
							duplicateFound = true;
							break;
						}
					}
				}
				if(!duplicateFound){
					if(guessedCard!= null){
						helper.putNextLine(currentTestCase+1, guessedCard);
					}else{
						helper.putNextLine(currentTestCase+1, "Volunteer cheated!");
					}
				}
			}
		}catch(FileNotFoundException e){
			System.err.println("Error while initiating input file.");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Error while reading next line or creating output file.");
			e.printStackTrace();
		}finally{
			try {
				helper.cleanup();
			} catch (IOException e) {
				System.err.println("Error while closing streams.");
				e.printStackTrace();
			}
		}
	}
	
	private class FileHelper{
		private BufferedReader br = null;
		private BufferedWriter bw = null;
		private void init(final String inFfileName, final String outFileName) throws IOException{
			br = new BufferedReader(new FileReader(inFfileName));
			bw = new BufferedWriter(new FileWriter(outFileName));
		}
		
		private String getNextLine() throws IOException{
			String currentLine;
			while ((currentLine = br.readLine()) != null) {
				return currentLine;
			}
			return null;
		}
		
		private void cleanup() throws IOException{
			br.close();
			bw.flush();
			bw.close();
		}
		
		private void putNextLine(int currentTestCase, String content) throws IOException{
			bw.append("Case #").append(Integer.toString(currentTestCase)).append(": ").append(content).append("\n");
		}
	}

}
