import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
/**
 * An algorithm that will find all possible combinations of 'welcome to code jam'
 * @author Chandrakant Dhome
 */
public class A {
	private static String inputFileName = "C-small-attempt0.in";
	private static String outputFileName = "OutputC.out";
	private BufferedReader fileReader = null;
	private DataOutputStream fileWriter = null;
	
	public static void main(String[] args) {
		A processor = new A();
		processor.process();
	}
	private void process() {
		fileReader = getInputStreamFromFileName(inputFileName);
		if(fileReader == null){
			System.out.println("Cannot read from input file.");
			return;
		}
		fileWriter = getOutputStreamFromFileName(outputFileName);
		if(fileWriter == null){
			System.out.println("Cannot write to output file.");
			return;
		}
		int noOfTestCases = 0;
	
		try {
			noOfTestCases = new Integer(fileReader.readLine()).intValue();
		} catch (NumberFormatException e) {
			e.printStackTrace();
			System.out.println("First line does not contain no of test cases.");
			return;
		} catch (IOException e) {
			e.printStackTrace();
			System.out.println("Error reading file, "+inputFileName);
			return;
		}
		int testCnt = 0;
		String[] firstLine = null;
		String[] groupMembers = null;
		int[][] groupBox = null;
		int trips = 0;
		int capacity = 0;
		int noOfGroups = 0;
		if(noOfTestCases > 0){
			while(testCnt < noOfTestCases){
				try {
					firstLine = fileReader.readLine().split("[\\s]+");
					trips = Integer.parseInt(firstLine[0]);
					capacity = Integer.parseInt(firstLine[1]);
					noOfGroups = Integer.parseInt(firstLine[2]);
					groupMembers = fileReader.readLine().split("[\\s]+");
					groupBox = new int[noOfGroups][2];
					int totalPPL = 0;
					for(int i=0;i<noOfGroups;i++){
						totalPPL+=Integer.parseInt(groupMembers[i]);
					}
					for(int i=0;i<noOfGroups;i++){
						int total = 0;
						int offset = 0;
						
						for(offset = i; (total<=capacity && total <= totalPPL);offset=((offset+1)% (noOfGroups))){
							total += Integer.parseInt(groupMembers[offset]); 
						}
						if(offset == 0){
							offset = noOfGroups - 1;
						}else{
							offset-=1;
						}
						total -= Integer.parseInt(groupMembers[offset]);
						groupBox[i][0]=total;
						groupBox[i][1]=offset;
					}
					long totalEarnings = 0;
					for(int tripNo=0, offset=0; tripNo < trips; tripNo++){
						totalEarnings += groupBox[offset][0];
						offset = groupBox[offset][1];
					}
					//System.out.println(totalEarnings);
					fileWriter.writeBytes("Case #"+(testCnt+1)+": "+totalEarnings+"\n");
				} catch (IOException e) {
					System.out.println("Cannot read from file.");
					e.printStackTrace();
				}
				testCnt++;
			}
		}else{
			System.out.println("No test cases to execute...Exiting.");
		}
		try {
			fileReader.close();
			fileWriter.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.out.println("File reader/writer cannot be closed...Exiting.");
		}
	}
	
	public static BufferedReader getInputStreamFromFileName(String fileName){
		try {
			InputStream fileInStream = new FileInputStream(fileName);
			InputStream dataInStream = new DataInputStream(fileInStream);
			BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(dataInStream));
			return bufferedReader;
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	//Should use BufferedWriter but for contest I need to see updated file ASAP.
	public static DataOutputStream getOutputStreamFromFileName(String fileName){
		try {
			OutputStream fileOutStream = new FileOutputStream(fileName);
			DataOutputStream dataOutStream = new DataOutputStream(fileOutStream);
			return dataOutStream;
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return null;
	}
}
