import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
/**
 * @author Chandrakant Dhome
 */
public class A {
	private static String inputFileName = "A-small-attempt0.in";
	private static String outputFileName = "OutputA.out";
	private BufferedReader fileReader = null;
	private DataOutputStream fileWriter = null;
	
	public static void main(String[] args) {
		A processor = new A();
		processor.process();
	}
	private void process() {
		fileReader = getInputStreamFromFileName(inputFileName);
		if(fileReader == null){
			System.out.println("Cannot read from input file.");
			return;
		}
		fileWriter = getOutputStreamFromFileName(outputFileName);
		if(fileWriter == null){
			System.out.println("Cannot write to output file.");
			return;
		}
		int noOfTestCases = 0;
	
		try {
			noOfTestCases = new Integer(fileReader.readLine()).intValue();
		} catch (NumberFormatException e) {
			e.printStackTrace();
			System.out.println("First line does not contain no of test cases.");
			return;
		} catch (IOException e) {
			e.printStackTrace();
			System.out.println("Error reading file, "+inputFileName);
			return;
		}
		int testCnt = 0;
		int wires = 0;
		int Ai = 0;
		int Bi = 0;
		int Xi = 0;
		int Yi = 0;
		String[] wirePointes = null;
		int noOfCrossing = 0;
		for(testCnt = 0; testCnt < noOfTestCases; testCnt ++){
			noOfCrossing = 0;
				try {
					wires = (new Integer(fileReader.readLine())).intValue();
					wirePointes = fileReader.readLine().split("[\\s]+");
					Ai = (new Integer(wirePointes[0])).intValue();
					Bi = (new Integer(wirePointes[1])).intValue();
					for(int wireNo=1;wireNo<wires;wireNo++){
						wirePointes = fileReader.readLine().split("[\\s]+");
						Xi = (new Integer(wirePointes[0])).intValue();
						Yi = (new Integer(wirePointes[1])).intValue();
						if((Ai < Xi && Bi > Yi) || (Ai > Xi && Bi < Yi)){
							noOfCrossing++;
						}
					}
					//System.out.println("Case #"+(testCnt+1)+": " + noOfCrossing);
					fileWriter.writeBytes("Case #"+(testCnt+1)+": " + noOfCrossing + "\n");
				} catch (IOException e) {
					System.out.println("Cannot read from file.");
					e.printStackTrace();
				}
		}
		try {
			fileReader.close();
			fileWriter.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.out.println("File reader/writer cannot be closed...Exiting.");
		}
	}
	
	public static BufferedReader getInputStreamFromFileName(String fileName){
		try {
			InputStream fileInStream = new FileInputStream(fileName);
			InputStream dataInStream = new DataInputStream(fileInStream);
			BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(dataInStream));
			return bufferedReader;
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	//Should use BufferedWriter but for contest I need to see updated file ASAP.
	public static DataOutputStream getOutputStreamFromFileName(String fileName){
		try {
			OutputStream fileOutStream = new FileOutputStream(fileName);
			DataOutputStream dataOutStream = new DataOutputStream(fileOutStream);
			return dataOutStream;
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return null;
	}
}
