import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;


public class QualA {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		QualA round1aa = new QualA();
		round1aa.execute("input.in", "output.out");
	}
	
	private void execute(String inFileName, String outFileName){
		FileHelper helper = new FileHelper();
		try {
			helper.init(inFileName, outFileName);
			String currentLine = null;
			int totalTestCases = 0;
			try{
				totalTestCases = Integer.parseInt(helper.getNextLine());
			}catch(NumberFormatException e){
				System.err.println("First line is not a number.");
				e.printStackTrace();
				System.exit(0);
			}
			int numberOfStalls;
			int numPersons;
			int maxP;
			int maxPWthOneFree;
			
			
			for(int currentTestCase=0; currentTestCase < totalTestCases; currentTestCase++){
				numberOfStalls = 0;numPersons = 0; maxP = 0; maxPWthOneFree = 0;
				currentLine = helper.getNextLine();
				numberOfStalls = Integer.parseInt(currentLine.substring(0, currentLine.indexOf(' ')));
				numPersons = Integer.parseInt(currentLine.substring(currentLine.indexOf(' ')).trim());
				maxP = this.getMaxP(numberOfStalls);
				maxPWthOneFree = this.getMaxPWthOneFree(numberOfStalls);
				//System.out.println(maxP + "," +maxPWthOneFree);
				if(numPersons >= numberOfStalls){
					//System.out.println("0 0");
					helper.putNextLine(currentTestCase+1, "0 0");
				}else if(numPersons > maxPWthOneFree){
					//System.out.println("0 0");
					helper.putNextLine(currentTestCase+1, "0 0");
				}else if(numPersons > maxP){
					//System.out.println("1 0");
					helper.putNextLine(currentTestCase+1, "1 0");
				}else{
					List<Integer> stallLength = new ArrayList<Integer>();
					stallLength.add(Integer.valueOf(numberOfStalls));
					String result = getRL(stallLength, numPersons);
					//System.out.println(result);
					helper.putNextLine(currentTestCase+1, result);
				}
			}
		}catch(FileNotFoundException e){
			System.err.println("Error while initiating input file.");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Error while reading next line or creating output file.");
			e.printStackTrace();
		}finally{
			try {
				helper.cleanup();
			} catch (IOException e) {
				System.err.println("Error while closing streams.");
				e.printStackTrace();
			}
		}
	}
	
	private int getMaxP(int number){
		
		int maxP = 0;
		if(number < 3){
			maxP = 0;
		}else if(number > 2 && number < 6){
			maxP = 1;
		}else{
			if(number % 2 != 0){
				maxP = maxP + 1 + (2*getMaxP(number/2));
			}else{
				maxP = maxP + 1 + getMaxP(number/2);
				maxP = maxP + getMaxP(number/2 -1);
			}
		}
		return maxP;
	}
	
	
	private int getMaxPWthOneFree(int number){
		int maxP = 0;
		if(number < 2){
			maxP = 0;
		}else if(number == 2  || number == 3){
			maxP = 1;
		}else{
			if(number % 2 != 0){
				maxP = maxP + 1 + (2*getMaxPWthOneFree(number/2));
			}else{
				maxP = maxP + 1 + getMaxPWthOneFree(number/2);
				maxP = maxP + getMaxPWthOneFree(number/2 -1);
			}
		}
		return maxP;
	}
	
	private String getRL(List<Integer> stallLength, int numP){
		int maxFree = Collections.max(stallLength);
		if(numP == 1){
			//System.out.println(maxFree);
			if(maxFree %2 == 0){
				return maxFree/2 +" " + (maxFree/2-1);
			}else{
				return maxFree/2 +" " + maxFree/2;
			}
		}else{
			stallLength.remove(stallLength.indexOf(maxFree));
			if(maxFree %2 != 0){
				stallLength.add(maxFree/2);
				stallLength.add(maxFree/2);
			}else{
				stallLength.add(maxFree/2);
				stallLength.add((maxFree/2)-1);
			}
			//System.out.println(stallLength);
			return getRL(stallLength, numP-1);
		}
	}
	
	private class FileHelper{
		private BufferedReader br = null;
		private BufferedWriter bw = null;
		private void init(final String inFfileName, final String outFileName) throws IOException{
			br = new BufferedReader(new FileReader(inFfileName));
			bw = new BufferedWriter(new FileWriter(outFileName));
		}
		
		private String getNextLine() throws IOException{
			String currentLine;
			while ((currentLine = br.readLine()) != null) {
				return currentLine;
			}
			return null;
		}
		
		private void cleanup() throws IOException{
			br.close();
			bw.flush();
			bw.close();
		}
		
		private void putNextLine(int currentTestCase, String content) throws IOException{
			bw.append("Case #").append(Integer.toString(currentTestCase)).append(": ").append(content).append("\n");
		}
	}

}
