import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Round1AA {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Round1AA round1aa = new Round1AA();
		round1aa.execute("input.in", "output.out");
	}
	
	private void execute(String inFileName, String outFileName){
		FileHelper helper = new FileHelper();
		try {
			helper.init(inFileName, outFileName);
			String currentLine;
			int totalTestCases = 0;
			try{
				totalTestCases = Integer.parseInt(helper.getNextLine());
			}catch(NumberFormatException e){
				System.err.println("First line is not a number.");
				e.printStackTrace();
				System.exit(0);
			}
			long numberOfRings = 0;
			double currentPaint = 0;
			for(int currentTestCase=0; currentTestCase < totalTestCases; currentTestCase++){
				currentLine = helper.getNextLine();
				long radius = Long.parseLong(currentLine.substring(0, currentLine.indexOf(" ")));
				double amount = Long.parseLong(currentLine.substring(currentLine.indexOf(" ") + 1));
				numberOfRings = 1;
				currentPaint = (radius*2 + 1);;
				amount = amount - currentPaint;
				radius = radius + 1;
				do{
					numberOfRings++;
					currentPaint = (radius * 2)  + 3;
					amount = amount - currentPaint;
					radius = radius + 2;
				}while(amount>=0);
				helper.putNextLine(currentTestCase+1, Long.toString(numberOfRings-1));
			}
		}catch(FileNotFoundException e){
			System.err.println("Error while initiating input file.");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Error while reading next line or creating output file.");
			e.printStackTrace();
		}finally{
			try {
				helper.cleanup();
			} catch (IOException e) {
				System.err.println("Error while closing streams.");
				e.printStackTrace();
			}
		}
	}
	
	private class FileHelper{
		private BufferedReader br = null;
		private BufferedWriter bw = null;
		private void init(final String inFfileName, final String outFileName) throws IOException{
			br = new BufferedReader(new FileReader(inFfileName));
			bw = new BufferedWriter(new FileWriter(outFileName));
		}
		
		private String getNextLine() throws IOException{
			String currentLine;
			while ((currentLine = br.readLine()) != null) {
				return currentLine;
			}
			return null;
		}
		
		private void cleanup() throws IOException{
			br.close();
			bw.flush();
			bw.close();
		}
		
		private void putNextLine(int currentTestCase, String content) throws IOException{
			bw.append("Case #").append(Integer.toString(currentTestCase)).append(": ").append(content).append("\n");
		}
	}

}
