import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.RoundingMode;


public class QualA {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		QualA round1aa = new QualA();
		round1aa.execute("input.in", "output.out");
	}
	
	private void execute(String inFileName, String outFileName){
		FileHelper helper = new FileHelper();
		try {
			helper.init(inFileName, outFileName);
			String currentLine = null;
			String[] currentEntries;
			int totalTestCases = 0;
			BigDecimal C, F, X;
			BigDecimal noOfFarms = BigDecimal.ZERO;
			BigDecimal ans = BigDecimal.ZERO;
			BigDecimal initialCookieRate = new BigDecimal(2);
			try{
				totalTestCases = Integer.parseInt(helper.getNextLine());
			}catch(NumberFormatException e){
				System.err.println("First line is not a number.");
				e.printStackTrace();
				System.exit(0);
			}
			for(int currentTestCase=0; currentTestCase < totalTestCases; currentTestCase++){
				ans = BigDecimal.ZERO;
				noOfFarms = BigDecimal.ZERO;
				currentLine = helper.getNextLine();
				currentEntries = currentLine.split(" ");
				C = new BigDecimal(currentEntries[0]);
				F = new BigDecimal(currentEntries[1]);
				X = new BigDecimal(currentEntries[2]);
				while( (X.divide((initialCookieRate.add((F.multiply(noOfFarms)))), 7, RoundingMode.HALF_UP)).compareTo(( (X.divide((initialCookieRate.add((F.multiply((noOfFarms.add(new BigDecimal(1))))))), 7, RoundingMode.HALF_UP) ).add(( C.divide((initialCookieRate.add((F.multiply(noOfFarms)))), 7, RoundingMode.HALF_UP) ) ))) == 1){
					ans = ans.add((C.divide((initialCookieRate.add((F.multiply(noOfFarms)))), 7, RoundingMode.HALF_UP)));
					noOfFarms = noOfFarms.add(new BigDecimal(1));
				}
				ans = ans.add((X.divide((initialCookieRate.add((F.multiply(noOfFarms)))), 7, RoundingMode.HALF_UP)));
				helper.putNextLine(currentTestCase+1, String.format("%.7f", ans));
			}
		}catch(FileNotFoundException e){
			System.err.println("Error while initiating input file.");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Error while reading next line or creating output file.");
			e.printStackTrace();
		}finally{
			try {
				helper.cleanup();
			} catch (IOException e) {
				System.err.println("Error while closing streams.");
				e.printStackTrace();
			}
		}
	}
	
	private class FileHelper{
		private BufferedReader br = null;
		private BufferedWriter bw = null;
		private void init(final String inFfileName, final String outFileName) throws IOException{
			br = new BufferedReader(new FileReader(inFfileName));
			bw = new BufferedWriter(new FileWriter(outFileName));
		}
		
		private String getNextLine() throws IOException{
			String currentLine;
			while ((currentLine = br.readLine()) != null) {
				return currentLine;
			}
			return null;
		}
		
		private void cleanup() throws IOException{
			br.close();
			bw.flush();
			bw.close();
		}
		
		private void putNextLine(int currentTestCase, String content) throws IOException{
			bw.append("Case #").append(Integer.toString(currentTestCase)).append(": ").append(content).append("\n");
		}
	}

}
