import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
/**
 * An algorithm that will find all possible combinations of 'welcome to code jam'
 * @author Chandrakant Dhome
 */
public class WelcomeTOCodeJAM {
	private static String inputFileName = "C-small-attempt0.in";
	private static String outputFileName = "Output.out";
	private BufferedReader fileReader = null;
	private BufferedWriter fileWriter = null;
	private int noOfCombinations = 0;
	
	public static void main(String[] args) {
		WelcomeTOCodeJAM processor = new WelcomeTOCodeJAM();
		processor.process();
	}
	private void process() {
		fileReader = FileHandler.getInputStreamFromFileName(inputFileName);
		if(fileReader == null){
			System.out.println("Cannot read from input file.");
			return;
		}
		fileWriter = FileHandler.getOutputStreamFromFileName(outputFileName);
		if(fileWriter == null){
			System.out.println("Cannot write to output file.");
			return;
		}
		int noOfTestCases = 0;
	
		try {
			noOfTestCases = new Integer(fileReader.readLine()).intValue();
		} catch (NumberFormatException e) {
			e.printStackTrace();
			System.out.println("First line does not contain no of test cases.");
			return;
		} catch (IOException e) {
			e.printStackTrace();
			System.out.println("Error reading file, "+inputFileName);
			return;
		}
		String welcomeString = "welcome to code jam";
		String inputString = null;
		int testCnt = 0;
		if(noOfTestCases > 0){
			while(testCnt < noOfTestCases){
				try {
					inputString = fileReader.readLine();
					noOfCombinations = 0;
					findPossibleCombinations(inputString, welcomeString, 0);
					fileWriter.append("Case #"+(testCnt+1)+": "+formatString(noOfCombinations, 4, '0')+"\n");
				} catch (IOException e) {
					System.out.println("Cannot read from file.");
					e.printStackTrace();
				}
				testCnt++;
			}
		}else{
			System.out.println("No test cases to execute...Exiting.");
		}
		try {
			fileReader.close();
			fileWriter.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.out.println("File reader/writer cannot be closed...Exiting.");
		}
	}
	private void findPossibleCombinations(String inputString,
			String welcomeString, int index) {
		if(welcomeString == null || welcomeString.length() == 0){
			noOfCombinations++;
			return;
		}
		while(inputString.indexOf(welcomeString.charAt(0), index) > -1){
			findPossibleCombinations(inputString, welcomeString.substring(1), inputString.indexOf(welcomeString.charAt(0), index)+1);
			index = inputString.indexOf(welcomeString.charAt(0), index)+1;
		}
	}
	
	private String formatString(int output, int requiredLength, char buffer){
		String outputString = new Integer(output).toString();
		StringBuilder formattedStringBuilder = new StringBuilder( "" );
		String formattedString = "";
		int length = outputString.length();
		while (length++ < requiredLength)
		{
			formattedStringBuilder.append('0');
		}
		formattedString = formattedStringBuilder.append(output).toString();
		return formattedString;
	}
}
