import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class InfiniteHouseOfPancakes {
	
	public static void main(String[] args) {
		// Template starts here
		BufferedReader br = null;
		try {
			br = new BufferedReader(new FileReader("input.txt"));
			int numTestCase = Integer.valueOf(br.readLine());
			for(int testCase=1; testCase<=numTestCase; testCase++)
			{
				System.out.print("Case #" + testCase + ": ");
				
				// Read each test case
				// Int
				int numDiners = Integer.valueOf(br.readLine());
				// Array
				String[] qArray = br.readLine().split(" ");
				int[] plates = new int[numDiners];
				for(int i=0; i<numDiners; i++)
				{
					plates[i] = Integer.valueOf(qArray[i]);
				}
				
				int maxPancakes = max(plates);
				int[] numPeople = new int[maxPancakes+1];
				for(int i=0; i<plates.length; i++)
				{
					numPeople[plates[i]]++;
				}
				
				int numMinutes = calculateMinutes(0, numPeople);
				
				// Print output
				System.out.println(numMinutes);
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		// Template ends here
	}
	
	private static int calculateMinutes(int currentMinutes, int[] numPeople)
	{
		int maxPancakes = maxPancakes(numPeople);
		if(maxPancakes <= 3)
		{
			return currentMinutes + maxPancakes;
		}
		int halfPancakes = maxPancakes/2;
		int numPeopleWithMaxPancakes = numPeople[maxPancakes];
		if(numPeopleWithMaxPancakes >= halfPancakes)
		{
			return currentMinutes + maxPancakes;
		}
		numPeople[maxPancakes] = 0;
		numPeople[maxPancakes-halfPancakes] += numPeopleWithMaxPancakes;
		numPeople[halfPancakes] += numPeopleWithMaxPancakes;
		
		int additionalMinute = Math.min(maxPancakes, calculateMinutes(numPeopleWithMaxPancakes, numPeople));
		return currentMinutes + additionalMinute;
	}
	
	private static int maxPancakes(int[] numPeople)
	{
		for(int i=numPeople.length-1; i>=0; i--)
		{
			if(numPeople[i] > 0)
			{
				return i;
			}
		}
		return 0;
	}
	
	private static int max(int[] array)
	{
		int max = 0;
		for(int i=0; i<array.length; i++)
		{
			if(array[i] > max)
			{
				max = array[i];
			}
		}
		return max;
	}
	
//	private int count(int match, int[] array)
//	{
//		int count = 0;
//		for(int i=0; i<array.length; i++)
//		{
//			if(array[i] == match)
//			{
//				count++;
//			}
//		}
//		return count;
//	}
	
}
