import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;


public class War {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		BufferedReader br = null;
		try {
			br = new BufferedReader(new FileReader("src/input.txt"));
			int numTestCase = Integer.valueOf(br.readLine());
			for(int i=1; i<=numTestCase; i++)
			{
				int numBlock = Integer.valueOf(br.readLine());
				String[] naomiStr = br.readLine().split(" ");
				String[] kenStr = br.readLine().split(" ");
				ArrayList<Double> naomi = new ArrayList<Double>(numBlock);
				ArrayList<Double> ken = new ArrayList<Double>(numBlock);				
				for(int j=0; j<numBlock; j++)
				{
					naomi.add(Double.valueOf(naomiStr[j]));
					ken.add(Double.valueOf(kenStr[j]));
				}
				
				Collections.sort(naomi);
				Collections.sort(ken);
				
				System.out.print("Case #" + i + ": ");
				System.out.print(deceitfulWar(0, (ArrayList<Double>)naomi.clone(), (ArrayList<Double>)ken.clone()) + " ");
				System.out.print(normalWar(0, naomi, ken));
				System.out.println();
				
				
				
			}
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
	
	public static int normalWar(int currentNaomiScore, ArrayList<Double> naomi, ArrayList<Double> ken)
	{
		if(naomi.size() == 0)
		{
			return currentNaomiScore;
		}
		Double chosenNaomi = Collections.min(naomi);
		naomi.remove(chosenNaomi);
		Double chosenKen = kenChoose(chosenNaomi, ken);
		ken.remove(chosenKen);
		if(chosenKen < chosenNaomi)
		{
			return normalWar(currentNaomiScore + 1, naomi, ken);
		}
		else
		{
			return normalWar(currentNaomiScore, naomi, ken);
		}
	}
	
	public static Double kenChoose(Double chosenNaomi, ArrayList<Double> ken)
	{
		for(int i=0; i<ken.size(); i++)
		{
			if(chosenNaomi < ken.get(i))
			{
				return ken.get(i);
			}
		}
		return ken.get(0);
	}
	
	public static int deceitfulWar(int currentNaomiScore, ArrayList<Double> naomi, ArrayList<Double> ken)
	{
		if(naomi.size() == 0)
		{
			return currentNaomiScore;
		}
		Double chosenNaomi = naomiChooseDeceitful(Collections.min(ken), naomi);
		naomi.remove(chosenNaomi);
		Double chosenKen = Collections.min(ken);
		ken.remove(chosenKen);
		if(chosenKen < chosenNaomi)
		{
			return deceitfulWar(currentNaomiScore + 1, naomi, ken);
		}
		else
		{
			return deceitfulWar(currentNaomiScore, naomi, ken);
		}
	}
	
	public static Double naomiChooseDeceitful(Double minKen, ArrayList<Double> naomi)
	{
		for(int i=0; i<naomi.size(); i++)
		{
			if(minKen < naomi.get(i))
			{
				return naomi.get(i);
			}
		}
		return naomi.get(0);
	}
}
