package jam.round1.b;

import java.io.IOException;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		String file = "B-small-attempt1";
		ProblemInputProcessor pip = new ProblemInputProcessor(file + ".in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator(file + ".out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {
			og.printOneLineTestResult(problemInput.solve());
		}
		pip.endProcess();
		og.end();
		System.out.println("Done");
	}
	
	public static void mainDebug(String[] args) {
		String input = "";
		ProblemInputProcessor debugProcessor = new ProblemInputProcessor(input.split("\n"));
		String result = debugProcessor.getNextTestCase().solve();
		System.out.println(result);
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {
	
	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}
	
	public ProblemInputProcessor(String[] inputs) {
		super(inputs);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		String[] s = getNextLine().split(" ");
		return new ProblemInput(Integer.parseInt(s[0]), Integer.parseInt(s[1]));
	}

}

class ProblemInput {

	private int b;
	private int m;
	
	private boolean[][] matrix;
	
	private final static String POSSIBLE = "POSSIBLE";
	private final static String IMPOSSIBLE = "IMPOSSIBLE";
	
	public ProblemInput(int b, int m) {
		this.b = b;
		this.m = m;
		matrix = new boolean[b][b];
	}
	

	public String solve() {
		for(int i = 0; i<b-1; i++) {
			matrix[i][i+1] = true;
		}
		int wayNb = 1;
		if(wayNb == m) {
			return POSSIBLE + printMatrix();
		}
		for(int i=0; i<b; i++) {
			for(int j=i+2; j <b; j++) {
				matrix[i][j] = true;
				wayNb += i == 0 ? 1 : i;
				if(wayNb == m) {
					return POSSIBLE + printMatrix();
				}
				else if(wayNb > m) {
					return IMPOSSIBLE;
				}
			}
		}
		return IMPOSSIBLE;
	}
	
	public String printMatrix() {
		StringBuilder sb = new StringBuilder();
		for(int i = 0; i < b; i++) {
			sb.append("\n");
			for(int j = 0; j < b; j++) {
				sb.append(matrix[i][j] ? "1" : "0");
			}
		}
		return sb.toString();
	}
	
	

}
