package jam.roundb.a;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		ProblemInputProcessor pip = new ProblemInputProcessor("A-large.in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator("A-large.out",
				pip.getNumberOfTestCases());

		for (ProblemInput problemInput : pip) {
			og.printOneLineTestResult(problemInput.solve());
		}
		pip.endProcess();
		og.end();
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {
	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		String[] line1 = getNextLine().split(" ");
		String[] line2 = getNextLine().split(" ");
		return new ProblemInput(Integer.parseInt(line1[1]),
				Integer.parseInt(line1[0]), line2);
	}

}

class ProblemInput {

	int maxSize = 100;
	int n;
	long a;
	List<Integer> motes;

	public ProblemInput(int n, int a, String[] smotes) {
		this.n = n;
		this.a = a;
		this.motes = new ArrayList<Integer>();
		for (String s : smotes) {
			motes.add(Integer.parseInt(s));
		}
		Collections.sort(motes);
	}

	public String solve() {
		if (a == 1) {
			return "" + n;
		}
		long currentMoteSize = a;
		int numIntroducedOp = 0;
		int processed = 0;
		int minOp = n;
		for (Integer mote : motes) {
			if (mote < currentMoteSize) {
				currentMoteSize += mote;
				processed++;
			} else {
				// is delete better than adding X motes
				int remaining = n - processed;
				int numRequired = 0;
				while (currentMoteSize <= mote) {
					currentMoteSize += currentMoteSize - 1;
					numRequired++;
				}
				if (numRequired > remaining) {
					numIntroducedOp += remaining;
					if (minOp <= numIntroducedOp) {
						numIntroducedOp = minOp;
					}
					break;
				} else {
					if (minOp <= (numIntroducedOp + numRequired)) {
						numIntroducedOp = minOp;
						break;
					} else {
						minOp = numIntroducedOp + remaining;
						numIntroducedOp += numRequired;
						currentMoteSize += mote;
						processed++;
					}
				}
			}
		}
		return "" + numIntroducedOp;
	}

}
