package jam.qualif.c;

import java.io.IOException;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		String file = "C-small-attempt3";
		ProblemInputProcessor pip = new ProblemInputProcessor(file + ".in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator(file + ".out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {
			//System.out.println("\n" + problemInput.r +" "+ problemInput.c +" "+problemInput.m);
			//System.out.println(problemInput.solve());
			//og.printTestResult("\n" + problemInput.r +" "+ problemInput.c +" "+problemInput.m+"\n"+ problemInput.solve());
			og.printTestResult("\n"+ problemInput.solve());
		}
		pip.endProcess();
		og.end();
		System.out.println("Done");
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {

	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		String[] inputs = getNextLine().split(" ");
		return new ProblemInput(Integer.parseInt(inputs[0]),
				Integer.parseInt(inputs[1]), Integer.parseInt(inputs[2]));
	}

}

class ProblemInput {

	private static final String IMPOSSIBLE = "Impossible";

	int r;
	int c;
	int m;

	public ProblemInput(int r, int c, int m) {
		this.r = r;
		this.c = c;
		this.m = m;
	}

	public String solve() {
		if (r == 1) {
			StringBuilder sb = new StringBuilder();
			for (int i = 0; i < m; i++) {
				sb.append("*");
			}
			int end = c - 1;
			for (int i = m; i < end; i++) {
				sb.append(".");
			}
			sb.append("c");
			return sb.toString();
		} else if (c == 1) {
			StringBuilder sb = new StringBuilder();
			for (int i = 0; i < m; i++) {
				sb.append("*\n");
			}
			int end = r - 1;
			for (int i = m; i < end; i++) {
				sb.append(".\n");
			}
			sb.append("c");
			return sb.toString();
		} else {
			if(m == r*c -1) {
				char[][] grid = new char[r][c];
				for(int i = 0; i < r; i++) {
					for(int j = 0; j < c; j++) {
						grid[i][j] = '*';
					}
				}
				grid[0][0] = 'c';
				return printGrid(grid);
			}
			if (m > (r * c - 4)) {
				return IMPOSSIBLE;
			}
			char[][] grid = new char[r][c];
			grid[r-1][c-1] = 'c';
			// diagonal filling
			int i = 0;
			int j = 0;
			while(m >0) {
				if(c > r) {
					grid[i][j] = '*';
					m--;
					i--;
					j++;
					if(i < 0 || j >= c) {
						int offset = i+j+1;
						i = offset >= r ? r-1 : offset;
						j = offset-i;
					}				
					if(i == r-2 && j == c-2) {
						i = r-3;
						j = c-1;
					}
				}
				else {
					grid[i][j] = '*';
					m--;
					i++;
					j--;
					if(j < 0 || i >= r) {
						int offset = i+j+1;
						j = offset >= c ? c-1 : offset;
						i = offset-j;
					}				
					if(i == r-2 && j == c-2) {
						i = r-1;
						j = c-3;
					}
				}
			}
			return printGrid(grid);

		}
	}

	private String printGrid(char[][] grid) {
		StringBuilder sb = new StringBuilder();
		int end = r - 1;
		for (int i = 0; i < r; i++) {
			for (int j = 0; j < c; j++) {
				if (grid[i][j] == 0) {
					sb.append(".");
				} else {
					sb.append(grid[i][j]);
				}
			}
			if (i < end) {
				sb.append("\n");
			}
		}
		return sb.toString();
	}

}
