package jam.round1.b;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		String file = "B-small-attempt0";
		ProblemInputProcessor pip = new ProblemInputProcessor(file + ".in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator(file + ".out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {
			og.printOneLineTestResult(problemInput.solve());
		}
		pip.endProcess();
		og.end();
		System.out.println("Done");
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {
	
	
	
	
	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		String[] s = getNextLine().split(" ");
		return new ProblemInput(s[0], s[1]);
	}

}

class ProblemInput {

	private int length;
	private int[] c;
	private int[] j;
	
	public ProblemInput(String c, String j) {
		this.length = c.length();
		this.c = getBoard(c);
		this.j = getBoard(j);
	}
	
	private int[] getBoard(String b) {
		int[] r = new int[length];
		for(int i = 0; i < length; i++) {
			char c = b.charAt(i);
			r[i] = c == '?' ? -1 : Integer.parseInt(""+c);
		}
		return r;
	}

	public String solve() {
		int acc = 0;
		int acj = 0;
		for(int i = 0; i < length; i ++) {
			if(c[i] >= 0 && j[i] >= 0) {
				// nothing to do
			}
			else if(c[i] < 0 && j[i] >= 0) {
				if(acc == acj) {
					c[i] = j[i];
				} else if(acc < acj) {
					c[i] = 9;
				} else {
					c[i] = 0;
				}
			} else if(c[i] >= 0 && j[i] < 0) {
				if(acc == acj) {
					j[i] = c[i];
				} else if(acc < acj) {
					j[i] = 0;
				} else {
					j[i] = 9;
				}
			} else {
				if(acc == acj) {
					c[i] = 0;
					j[i] = 0;
				} else if(acc < acj) {
					c[i] = 9;
					j[i] = 0;
				} else {
					c[i] = 0;
					j[i] = 9;
				}
			}
			acc = acc * 10 + c[i];
			acj = acj * 10 + j[i];
		}
		return printRes();
	}
	
	private String printRes() {
		StringBuilder sb = new StringBuilder();
		for(int i = 0; i<length; i ++) {
			sb.append(c[i]); 
		}
		sb.append(' ');
		for(int i = 0; i<length; i ++) {
			sb.append(j[i]); 
		}
		return sb.toString();
	}
	
	

}
