package jam.qualif.a;


public class Grid {

	private char[][] grid = new char[4][4];

	private static final String X_WIN = "X won";
	private static final String O_WIN = "O won";
	private static final String DRAW = "Draw";
	private static final String NOT_COMPLETED = "Game has not completed";

	private static final char X = 'X';
	private static final char O = 'O';
	private static final char T = 'T';
	private static final String DOT = ".";

	String defaultStatus;

	public void setLine(String s, int i) {
		grid[i] = s.toCharArray();
		if (defaultStatus == null && s.contains(DOT)) {
			defaultStatus = NOT_COMPLETED;
		}
	}

	public char get(int i, int j) {
		return grid[i][j];
	}

	public String findStatus() {
		if (defaultStatus == null) {
			defaultStatus = DRAW;
		}
		String status = defaultStatus;
		status = processLines();
		if (status != defaultStatus) {
			return status;
		}
		status = processColumns();
		if (status != defaultStatus) {
			return status;
		}
		status = processDiagonals();
		return status;

	}

	private String processLines() {
		for (int i = 0; i < 4; i++) {
			String status = getStatus(grid[i]);
			if (status != defaultStatus) {
				return status;
			}
		}
		return defaultStatus;
	}

	private String processColumns() {
		for (int i = 0; i < 4; i++) {
			String status = getStatus(grid[0][i], grid[1][i], grid[2][i],
					grid[3][i]);
			if (status != defaultStatus) {
				return status;
			}
		}
		return defaultStatus;
	}

	private String processDiagonals() {
		String status = getStatus(grid[0][0], grid[1][1], grid[2][2],
				grid[3][3]);
		if (status != defaultStatus) {
			return status;
		} else {
			return getStatus(grid[0][3], grid[1][2], grid[2][1], grid[3][0]);
		}
	}

	private String getStatus(char... c) {
		int numOs = 0;
		int numTs = 0;
		int numXs = 0;
		for (int i = 0; i < 4; i++) {
			switch (c[i]) {
			case O:
				numOs++;
				break;
			case T:
				numTs++;
				break;
			case X:
				numXs++;
				break;
			default:
				return defaultStatus;
			}
		}
		if (numOs + numTs == 4) {
			return O_WIN;
		} else if (numXs + numTs == 4) {
			return X_WIN;
		} else {
			return defaultStatus;
		}
	}

}
