package jam.round1.a;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		String file = "A-large";
		ProblemInputProcessor pip = new ProblemInputProcessor(file + ".in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator(file + ".out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {
			og.printOneLineTestResult(problemInput.solve());
		}
		pip.endProcess();
		og.end();
		System.out.println("Done");
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {
	
	
	
	
	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		return new ProblemInput(getNextLine());
	}

}

class ProblemInput {

	public static String ZERO = "ZERO";
	public static String ONE = "ONE";
	public static String TWO = "TWO";
	public static String THREE = "THREE";
	public static String FOUR = "FOUR";
	public static String FIVE = "FIVE";
	public static String SIX = "SIX";
	public static String SEVEN = "SEVEN";
	public static String EIGHT = "EIGHT";
	public static String NINE = "NINE";
	
	public static String[] NUM = { ZERO, ONE, TWO, THREE, FOUR, FIVE, SIX, SEVEN, EIGHT, NINE };
	
	HashMap<Character, Integer> map = new HashMap<>();

	public ProblemInput(String s) {
		for(int i = 0; i < s.length(); i++) {
			Character c = s.charAt(i);
			Integer num = map.get(c);
			if(num == null) {
				map.put(c, 1);
			} else {
				map.put(c, num + 1);
			}
		}
	}

	public String solve() {
		List<Integer> result = new ArrayList<>();
		
		// zero
		while(containsChar('Z')) {
			removeString(NUM[0]);
			result.add(0);
		}
		// eight
		while(containsChar('G')) {
			removeString(NUM[8]);
			result.add(8);
		}
		// six
		while(containsChar('X')) {
			removeString(NUM[6]);
			result.add(6);
		}
		// two
		while(containsChar('W')) {
			removeString(NUM[2]);
			result.add(2);
		}
		// three
		while(containsChar('H')) {
			removeString(NUM[3]);
			result.add(3);
		}		
		// four
		while(containsChar('U')) {
			removeString(NUM[4]);
			result.add(4);
		}
		// seven
		while(containsChar('S')) {
			removeString(NUM[7]);
			result.add(7);
		}		

		// five
		while(containsChar('F')) {
			removeString(NUM[5]);
			result.add(5);
		}		
		// one
		while(containsChar('O')) {
			removeString(NUM[1]);
			result.add(1);
		}
		// nine
		while(containsChar('N')) {
			removeString(NUM[9]);
			result.add(9);
		}		
		
		Collections.sort(result);
		StringBuilder sb = new StringBuilder();
		for(Integer i : result) {
			sb.append(i);
		}
		return sb.toString();
	}
	
	public boolean containsChar(char c) {
		return map.containsKey(c);
	}
	
	public void removeString(String s) {
		for(int i = 0; i< s.length(); i ++) {
			removeChar(s.charAt(i));
		}
	}
	
	public void removeChar(char c) {
		int n = map.get(c);
		if(n == 1) {
			map.remove(c);
		} else {
			map.put(c, n-1);
		}
	}

}
