package jam.qualif.c;

import java.io.IOException;
import java.util.Arrays;
import java.util.TreeSet;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		ProblemInputProcessor pip = new ProblemInputProcessor(
				"C-small-attempt0.in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator("C-small-attempt0.out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {

			og.printOneLineTestResult(Long.toString(problemInput.solveSmall()));
		}
		pip.endProcess();
		og.end();
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {

	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		String[] line = getNextLine().split(" ");
		return new ProblemInput(Long.parseLong(line[0]),Long.parseLong(line[1]));
	}

}

class ProblemInput {
	long a;
	long b;

	public ProblemInput(long a, long b) {
		this.a = a;
		this.b = b;
	}
	
	public long solveSmall() {
		TreeSet<Long> fairAndSquare = new TreeSet<Long>(Arrays.asList(1L,4L,9L,121L,484L));
		return fairAndSquare.subSet(a, true, b, true).size();
		
	}
}
