package jam.qualif.a;

import java.io.IOException;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		String file = "A-small-attempt0";
		ProblemInputProcessor pip = new ProblemInputProcessor(file + ".in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator(file + ".out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {
			og.printOneLineTestResult(problemInput.solve());
		}
		pip.endProcess();
		og.end();
		System.out.println("Done");
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {

	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		String[] inputs = getNextLine().split(" ");
		int smax = Integer.parseInt(inputs[0]);
		int[] shynesslevels = new int[smax+1];
		for (int i = 0; i <= smax; i++) {
			shynesslevels[i] = Integer.parseInt("" + inputs[1].charAt(i));
		}
		return new ProblemInput(smax, shynesslevels);
	}

}

class ProblemInput {

	int smax;
	int[] s;

	public ProblemInput(int smax, int[] shynesslevels) {
		this.smax = smax;
		this.s = shynesslevels;
	}

	public String solve() {
		int friends = 0;
		int standUps = 0;
		for(int i=0; i <= smax; i++) {
			if(standUps >= i) {
				standUps += s[i];
			} else {
				friends += i - standUps;
				standUps = i + s[i];
			}
		}
		return Integer.toString(friends);
	}

}
