package jam.round1.b;

import java.io.IOException;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		String file = "B-small-attempt0";
		ProblemInputProcessor pip = new ProblemInputProcessor(
				file+".in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator(file+".out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {
			og.printOneLineTestResult(problemInput.solve());
		}
		pip.endProcess();
		og.end();
		System.out.println("Done");
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {

	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		String[] inputs = getNextLine().split(" ");
		return new ProblemInput(Integer.parseInt(inputs[0]),Integer.parseInt(inputs[1]),Integer.parseInt(inputs[2]));
	}
	

}

class ProblemInput {

	int a;
	int b;
	int k;
	

	public ProblemInput(int a, int b, int k) {
		this.a = a;
		this.b = b;
		this.k = k;
	}

	public String solve() {
		if(k >= a || k >= b) {
			return Integer.toString(a*b);
		}
		int result = 0;
		for(int i = 0; i < a; i++) {
			for(int j = 0; j < b; j++) {
				if((i&j) < k) {
					result++;
				}
			}
		}
		return Integer.toString(result);
	}

}
