package jam.qualif.b;

import java.io.IOException;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		String file = "B-small-attempt0";
		ProblemInputProcessor pip = new ProblemInputProcessor(file + ".in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator(file + ".out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {
			og.printOneLineTestResult(problemInput.solve());
		}
		pip.endProcess();
		og.end();
		System.out.println("Done");
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {

	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		return new ProblemInput(getNextLine());
	}

}

class ProblemInput {

	String stack;

	public ProblemInput(String s) {
		stack  = s;
	}

	public String solve() {
		int res = 0;
		char happy = stack.charAt(0);
		int length = stack.length();
		for(int i = 1; i < length; i++) {
			char c = stack.charAt(i);
			if(c != happy) {
				happy = happy == '+' ? '-' : '+';
				res++;
			}
		}
		if(happy != '+') {
			res++;
		}
		return Integer.toString(res);
	}

}
