package jam.qualif.a;

import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		String file = "A-small-attempt0";
		ProblemInputProcessor pip = new ProblemInputProcessor(file + ".in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator(file + ".out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {
			og.printOneLineTestResult(problemInput.solve());
		}
		pip.endProcess();
		og.end();
		System.out.println("Done");
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {

	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		return new ProblemInput(Integer.parseInt(getNextLine()));
	}

}

class ProblemInput {

	int n;

	public ProblemInput(int n) {
		this.n = n;
	}

	public String solve() {
		if(n == 0) {
			return "INSOMNIA";
		}
		int sum = n;
		Set<Character> present = new HashSet<Character>();
		getDigits(sum, present);
		while(present.size() < 10) {
			sum += n;
			getDigits(sum, present);
		}		
		return ""+sum;
	}
	
	public void getDigits(int n, Set<Character> set) {
		String s = Integer.toString(n);
		for(int i = 0; i < s.length(); i++) {
			set.add(s.charAt(i));
		}
	}

}
