package jam.qualif.b;

public class Lawn {

	private static int MAX = 100;
	private static String SEPARATOR = " ";

	int[][] grid;
	int n;
	int m;

	boolean possible = true;

	public Lawn(int n, int m) {
		this.n = n;
		this.m = m;
		grid = new int[n][m];
	}

	public void setLine(String s, int i) {
		String[] line = s.split(SEPARATOR);
		for (int j = 0; j < m; j++) {
			grid[i][j] = Integer.parseInt(line[j]);
			if (grid[i][j] > MAX || grid[i][j] < 1) {
				possible = false;
			}
		}
	}

	public boolean isPossible() {
		if (!possible) {
			return possible;
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				possible = isSquarePossible(i, j);
				if (!possible) {
					return possible;
				}
			}
		}
		return possible;
	}

	private boolean isSquarePossible(int i, int j) {
		// square is possible iff it is the max of a line or a column
		boolean result = false;
		int max = grid[i][j];
		// check line
		for (int k = 0; k < m; k++) {
			result = grid[i][k] <= max;
			if (!result) {
				break;
			}
		}
		if (!result) {
			for (int k = 0; k < n; k++) {
				result = grid[k][j] <= max;
				if (!result) {
					break;
				}
			}
		}
		return result;
	}

}
