package jam.qualif.d;

import java.io.IOException;
import java.util.TreeSet;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		String file = "D-large";
		ProblemInputProcessor pip = new ProblemInputProcessor(file + ".in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator(file + ".out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {
			og.printOneLineTestResult(problemInput.solve());
		}
		pip.endProcess();
		og.end();
		System.out.println("Done");
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {

	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		int n = Integer.parseInt(getNextLine());
		String[] naomis = getNextLine().split(" ");
		String[] kens = getNextLine().split(" ");
		return new ProblemInput(n, naomis, kens);
	}

}

class ProblemInput {

	int n;
	TreeSet<Double> naomiBlocks = new TreeSet<Double>();
	TreeSet<Double> kenBlocks = new TreeSet<Double>();

	public ProblemInput(int n, String[] naomis, String[] kens) {
		this.n = n;
		for (int i = 0; i < n; i++) {
			naomiBlocks.add(Double.parseDouble(naomis[i]));
			kenBlocks.add(Double.parseDouble(kens[i]));
		}
	}

	public String solve() {
		TreeSet<Double> naomiBlocks2 = new TreeSet<Double>(naomiBlocks);
		TreeSet<Double> kenBlocks2 = new TreeSet<Double>(kenBlocks);
		int pointwar = 0;
		int pointdeceitwar = 0;
		for (int i = 0; i < n; i++) {
			// war
			{
				Double nao = naomiBlocks2.pollLast();
				if (nao > kenBlocks2.last()) {
					pointwar++;
					kenBlocks2.pollFirst();
				} else {
					kenBlocks2.remove(kenBlocks2.higher(nao));
				}
			}
			// deceitful War
			{
				Double nao = naomiBlocks.first();
				if(nao < kenBlocks.first()) {
					naomiBlocks.pollFirst();
					kenBlocks.pollLast();
				} else {
					naomiBlocks.pollFirst();
					kenBlocks.pollFirst();
					pointdeceitwar++;
				}
			}
		}
		return pointdeceitwar + " " + pointwar; 

	}

}
