package jam.qualif.b;

import java.io.IOException;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.Locale;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		String file = "B-large";
		ProblemInputProcessor pip = new ProblemInputProcessor(
				file+".in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator(file+".out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {
			og.printOneLineTestResult(problemInput.solve());
		}
		pip.endProcess();
		og.end();
		System.out.println("Done");
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {

	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		String[] inputs = getNextLine().split(" ");
		return new ProblemInput(Double.parseDouble(inputs[0]), Double.parseDouble(inputs[1]), Double.parseDouble(inputs[2]));
	}
	

}

class ProblemInput {
	
	private final static DecimalFormat DF = new DecimalFormat("#.#######",DecimalFormatSymbols.getInstance(Locale.US));
	
	double c;
	double f;
	double x;
	
	public ProblemInput(double c, double f, double x) {
		this.c = c;
		this.f = f;
		this.x = x;
	}



	public String solve() {
		int n = 0;
		// we define tf(n) being the time to buy n farms
		double tf = 0;
		// we  define t(n) the time to buy X cookies with n farms
		double tmin = x/2;
		boolean end = false;
		while(!end) {
			tf = tf + (c / (n*f + 2));
			if(tf >= tmin) {
				end = true;
			} else {
				n++;
				double t = tf + (x / (2+n*f));
				if(t < tmin) {
					tmin = t;
				}
			}
		}
		return DF.format(tmin);
	}

}
