package jam.qualif.b;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		String file = "B-small-attempt2";
		ProblemInputProcessor pip = new ProblemInputProcessor(file + ".in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator(file + ".out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {
			og.printOneLineTestResult(problemInput.solve());
		}
		pip.endProcess();
		og.end();
		System.out.println("Done");
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {

	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		int d = Integer.parseInt(getNextLine());
		int[] p = new int[d];
		String[] parsedP = getNextLine().split(" ");
		for (int i = 0; i < d; i++) {
			p[i] = Integer.parseInt(parsedP[i]);
		}
		return new ProblemInput(d, p);
	}

}

class ProblemInput {

	int d;
	List<Integer> p = new ArrayList<Integer>();

	public ProblemInput(int d, int[] p) {
		this.d = d;
		for(int i =0; i< d; i++) {
			this.p.add(p[i]);
		}
		Collections.sort(this.p);
	}

	public String solve() {
		int maxSim = 1;
		int spec = 0;
		for (Integer pi : p) {
			if(pi <= 3) {
				maxSim = pi > maxSim ? pi : maxSim;
				continue;
			}
			if(pi <= maxSim) {
				continue;
			}
			// additional special minutes
			int newSpec = 0;
			int newMaxim = pi;
			int j = spec;
			while(pi > maxSim) {
				pi = pi/2 + pi%2;
				j++;
				int max = maxSim > pi ? maxSim : pi;
				if(max + j < newMaxim + newSpec) {
					newMaxim = max;
					newSpec = j;
				}
			}
			maxSim = newMaxim;
			spec = newSpec;
		}
		return Integer.toString(maxSim + spec);
	}

}
