package jam.qualif.a;

import java.io.IOException;
import java.util.ArrayList;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		String file = "A-small-attempt0";
		ProblemInputProcessor pip = new ProblemInputProcessor(
				file+".in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator(file+".out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {
			og.printOneLineTestResult(problemInput.solve());
		}
		pip.endProcess();
		og.end();
		System.out.println("Done");
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {

	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		int answer1 = Integer.parseInt(getNextLine());
		int[][] arr1 = getGrid();
		int answer2 = Integer.parseInt(getNextLine());
		int[][] arr2 = getGrid();
		return new ProblemInput(answer1, answer2, arr1, arr2);
	}
	
	private int[][] getGrid() {
		int[][] grid = new int[4][4];
		for(int i=0; i < 4; i++) {
			String[] row = getNextLine().split(" ");
			for(int j=0; j <4;j++) {
				grid[i][j] = Integer.parseInt(row[j]);
			}
		}
		return grid;
	}

}

class ProblemInput {
	
	private final static String BAD = "Bad magician!";
	private final static String CHEAT = "Volunteer cheated!";

	int answer1;
	int answer2;
	int[][] arr1;
	int[][] arr2;
	
	public ProblemInput(int answer1, int answer2, int[][] arr1, int[][] arr2) {
		this.answer1 = answer1-1;
		this.answer2 = answer2-1;
		this.arr1 = arr1;
		this.arr2 = arr2;
	}

	public String solve() {
		ArrayList<Integer> row1 = new ArrayList<Integer>();
		ArrayList<Integer> row2 = new ArrayList<Integer>();
		for(int i = 0; i<4; i++) {
			row1.add(arr1[answer1][i]);
			row2.add(arr2[answer2][i]);
		}
		row1.retainAll(row2);
		if(row1.size() == 1) {
			return row1.get(0).toString();
		} else if(row1.size() > 1) {
			return BAD;
		} else {
			return CHEAT;
		}
		
		
	}

}
