package jam.qualif.d;

import java.io.IOException;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		String file = "D-small-attempt1";
		ProblemInputProcessor pip = new ProblemInputProcessor(file + ".in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator(file + ".out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {
			og.printOneLineTestResult(problemInput.solve());
		}
		pip.endProcess();
		og.end();
		System.out.println("Done");
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {

	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		String[] input = getNextLine().split(" ");
		int x = Integer.parseInt(input[0]);
		int r = Integer.parseInt(input[1]);
		int c = Integer.parseInt(input[2]);
		return new ProblemInput(x, r, c);
	}

}

class ProblemInput {

	static final String RICHARD = "RICHARD";
	static final String GABRIEL = "GABRIEL";

	int x;
	int r;
	int c;

	public ProblemInput(int x, int r, int c) {
		this.x = x;
		this.r = r;
		this.c = c;
	}

	public String solve() {
		if (richardWin()) {
			return RICHARD;
		}
		return GABRIEL;
	}

	public boolean richardWin() {
		if (r == 1 && c == 1) {
			return x > 1;
		}
		if (r == 1 || c == 1) {
			if(r * c == 3) {
				return x >= 2;
			}
			return x > 2;
		}
		if (r == 2 && c == 2) {
			return x > 2;
		}
		if (r == 3 && c == 3) {
			return x == 2 || x == 4;
		}
		if (r == 4 && c == 4) {
			return x == 3;
		}
		if ((r == 2 && c == 3) || (r == 3 && c == 2)) {
			return x == 4;
		}
		if ((r == 2 && c == 4) || (r == 4 && c == 2)) {
			return x >= 3;
		}
		return false;
	}

}
