package jam.qualif.c;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.TreeSet;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		ProblemInputProcessor pip = new ProblemInputProcessor(
				"C-large-1.in");
		pip.startProcess();
		ProblemInput.buildLarge();
		OutputGenerator og = new OutputGenerator("C-large-1.out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {

			og.printOneLineTestResult(Long.toString(problemInput.solveLarge()));
		}
		pip.endProcess();
		og.end();
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {

	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		String[] line = getNextLine().split(" ");
		return new ProblemInput(Long.parseLong(line[0]),
				Long.parseLong(line[1]));
	}

}

class ProblemInput {

	static TreeSet<Long> fairAndSquare = new TreeSet<Long>(Arrays.asList(1L,
			4L, 9L, 121L, 484L));

	long a;
	long b;

	public ProblemInput(long a, long b) {
		this.a = a;
		this.b = b;
	}

	public long solveSmall() {
		return fairAndSquare.subSet(a, true, b, true).size();
	}

	public long solveLarge() {
		return fairAndSquare.subSet(a, true, b, true).size();
	}

	public static void buildLarge() throws IOException {
		long limit = 100000000000000L;
		// squares of palindrome being a palindrome have uneven digits + starts
		// with a 1 or a 4
		FileInputStream fis = new FileInputStream("fair_squares");
		BufferedReader br = new BufferedReader(new InputStreamReader(fis));
		String line = br.readLine();
		while (line != null) {
			long l = Long.parseLong(line);
			if (l <= limit) {
				fairAndSquare.add(l);
			}
			line = br.readLine();
		}
		if (br != null) {
			try {
				br.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

}
