package jam.round1.a;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import file.input.InputProcessor;
import file.output.OutputGenerator;

public class Main {

	public static void main(String[] args) throws IOException {
		String file = "A-large";
		ProblemInputProcessor pip = new ProblemInputProcessor(file + ".in");
		pip.startProcess();
		OutputGenerator og = new OutputGenerator(file + ".out",
				pip.getNumberOfTestCases());
		for (ProblemInput problemInput : pip) {
			og.printOneLineTestResult(problemInput.solve());
		}
		pip.endProcess();
		og.end();
		System.out.println("Done");
	}
	
	public static void mainDebug(String[] args) {
		String input = "";
		ProblemInputProcessor debugProcessor = new ProblemInputProcessor(input.split("\n"));
		String result = debugProcessor.getNextTestCase().solve();
		System.out.println(result);
	}

}

class ProblemInputProcessor extends InputProcessor<ProblemInput> {	
	
	public ProblemInputProcessor(String inputFile) {
		super(inputFile);
	}

	public ProblemInputProcessor(String[] split) {
		super(split);
	}

	@Override
	protected ProblemInput getNextTestCase() {
		return new ProblemInput(Integer.parseInt(getNextLine()), getNextLine().split(" "));
	}

}

class ProblemInput {
	
	int n;
	int[] p;
	int total;
	
	static char[] alphabet = {'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'};

	public ProblemInput(int n, String[] p) {
		this.n = n;
		this.p = new int[n];
		this.total = 0;
		for(int i=0; i<n; i++) {
			this.p[i] = Integer.parseInt(p[i]);
			total += this.p[i];
		}
	}

	public String solve() {
		// copy p
		int[] q = new int[n];
		List<String> instructions = new ArrayList<>();
		for(int i=0; i<n; i++) {
			while(q[i] < p[i]) {
				// first move
				q[i] += 1;
				String instr = Character.toString(alphabet[i]);
				// second move
				for(int j=i+1; j < n; j++) {
					if(q[j] < p[j]) {
						q[j] += 1;
						instr += alphabet[j];
						break;
					}
				}
				instructions.add(instr);
			}
		}
		StringBuilder sb = new StringBuilder();
		for(int i = instructions.size()-1; i >= 0; i--) {
			sb.append(instructions.get(i));
			sb.append(' ');
		}
		sb.deleteCharAt(sb.length()-1);
		return sb.toString();
	}
}
