

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Arrays;
import java.util.List;

public class CGReader {
	public static String SEPARATOR = " ";
	private BufferedReader read;
	private List<String> vals;
	private int position = 0;
	public CGReader (String file){
		try {
			read = new BufferedReader(
					new FileReader(file));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private void recharge() throws IOException{
		if (vals == null || vals.isEmpty() || position >= vals.size()){
			String line = readLine();
			String[] words = line.split(SEPARATOR);
			vals = Arrays.asList(words);
			position = 0;
		}
	}

	public String readLine() throws IOException{
		return read.readLine();
	}
	
	public String readString() throws IOException{
		recharge();
		return vals.get(position++);
	}
	
	public int readInt() throws IOException{
		recharge();
		return Integer.parseInt(vals.get(position++));
	}
	
	public long readLong() throws IOException{
		recharge();
		return Long.parseLong(vals.get(position++));
	}
	
	public double readDouble() throws IOException{
		recharge();
		return Double.parseDouble(vals.get(position++));
	}

}
