import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;


public class Fractiles {
	public List<Integer>findIndexs(int K, int C, int S){
		List<Integer> indexs = new ArrayList<Integer>();
		Set<Integer> cases = new HashSet<Integer>();
		for (int i = 0; i < K; i++) {
			cases.add(i);
		}
		Map<Integer, HashSet<Integer>> index2Cases = new HashMap<Integer, HashSet<Integer>>();
		for (int i = 0; i < K; i++) {
			ArrayList<Integer> res = GIndices(i, K, C);
			for (int r: res){
				if (index2Cases.containsKey(r)) index2Cases.get(r).add(i);
				else{
					HashSet<Integer> value = new HashSet<Integer>();
					value.add(i);
					index2Cases.put(r, value);
				}
			}
		}
		
		while(!cases.isEmpty()) {
			int maxlen = 0;
			int key = 0;
			for (int k : index2Cases.keySet()){
				if (index2Cases.get(k).size() > maxlen){
					maxlen = index2Cases.get(k).size();
					key = k;
				}
			}
			HashSet<Integer> copy = new HashSet<Integer>();
			for (int i : index2Cases.get(key)) {
				cases.remove(i);
				copy.add(i);
			}
			for (int i : copy){
				for (HashSet<Integer> s : index2Cases.values()) {
					s.remove(i);
				}
			}
			indexs.add(key);
		}
		return indexs;
	}
	
	ArrayList<Integer> GIndices(int firstG, int K, int C){
		ArrayList<Integer> gi = new ArrayList<Integer>();
		//let false represent L, true represent G
	    boolean[] tiles = new boolean[K];
	    tiles[firstG] = true;
		for (int c = 2; c <= C; c++) {
			/*Double len = Math.pow(K,c);
			boolean[] nextLayer = new boolean[len.intValue()];
			for (int i = 0; i < tiles.length; i++){
				if (!tiles[i]) nextLayer[i*K+firstG] = true;
				else {
					for (int j = 0; j < K; j++) nextLayer[i*K+j] = true;
				}
			}*/
			if(tiles[0]) {
				for (int i = 0; i < K; i++) tiles[i] = true;
			}
		}
		//for(int i = 0; i < tiles.length; i++){
		for(int i = 0; i < K; i++){
			if (tiles[i]) gi.add(i+1);
		}
		return gi;
	}
	public static void main(String[] args) throws IOException {
		Fractiles ft = new Fractiles();
		String inputPath = args[0];
		String outputPath = args[1];
		FileReader fileReader = new FileReader(inputPath);
        BufferedReader bufferedReader = new BufferedReader(fileReader);
        String line = null;
        int size = Integer.parseInt(bufferedReader.readLine());
        String[] tests = new String[size];
        int i = 0;
        while(i < size && (line = bufferedReader.readLine()) != null) {
            tests[i] = line;
            i++;
        }   
        // Always close files.
        bufferedReader.close();
		ArrayList<String> output = new ArrayList<String>();
		for (int j = 0; j < size; j++) {
			String[] KCS = tests[j].split(" "); 
			int K = Integer.parseInt(KCS[0]);
			int C = Integer.parseInt(KCS[1]);
			int S = Integer.parseInt(KCS[2]);
			List<Integer> indices = ft.findIndexs(K, C, S);
			String out = new String();
			if (indices.size() <= S) {
				for (int id : indices) out+=" "+id;
			}
			else out = " IMPOSSIBLE";
            output.add("Case #"+(j+1)+":"+out);
		}
		
		Path file = Paths.get(outputPath);
		Files.write(file, output, Charset.forName("UTF-8"));
	}

}
