import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.*;


public class CountingSheep {
	public int count(int N) {
		if (N == 0) return 0;
		HashSet<Integer> nums = new HashSet<Integer>(Arrays.asList(0, 1, 2, 3, 4, 5, 6, 7, 8, 9));
		int i = 1;
		while(!nums.isEmpty()){
			int number = i*N;
		    while (number > 0) {
		        int digit = ( number % 10);
		        number = number / 10;
		        if (nums.contains(digit)) nums.remove(digit);
		   }
		   i++;
		}
		return (i-1)*N;
	}
	
	public static void main(String[] args) throws IOException{
		CountingSheep cs = new CountingSheep();
		String inputPath = args[0];
		String outputPath = args[1];
		FileReader fileReader = new FileReader(inputPath);
        BufferedReader bufferedReader = new BufferedReader(fileReader);
        String line = null;
        ArrayList<Integer> tests = new ArrayList<Integer>();
        while((line = bufferedReader.readLine()) != null) {
            tests.add(Integer.parseInt(line));
        }   
        // Always close files.
        bufferedReader.close();  
		int total = tests.get(0);
		ArrayList<String> output = new ArrayList<String>();
		for (int i = 1; i <= total; i++) {
			int out = cs.count(tests.get(i));
			if (out != 0) output.add("Case #"+i+": "+out);
			else output.add("Case #"+i+": INSOMNIA");
		}
		
		Path file = Paths.get(outputPath);
		Files.write(file, output, Charset.forName("UTF-8"));
	}

}
