import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;


public class Pancakes {
	
	public int flipAllPancakes(String input){
		char[] pancakes = input.toCharArray();
		int count = 0;
		int end = pancakes.length-1;
		while(end >= 0) {
			int s = 0;
			//check 0 - e of the pancakes, the e - tail are all +
			while(end >= 0 && pancakes[end] == '+') end--;
			if (end < 0) break;
			//check if the head is -
			while(s < pancakes.length && pancakes[s] == '+') s++;
			
			if (s != 0) {
			    flip(pancakes, s-1);
			    count++;
			}
			if (end >= 0) {
			    flip(pancakes, end);
			    count++;
			}
		}
		return count;
	}
	
	public void flip(char[] pancakes, int e){
		char[] cakestoflip = new char[e+1];
		for (int i = 0; i <=e; i++){
			cakestoflip[e-i] = pancakes[i];
		}
		for (int i = 0; i <= e; i++){
			if (cakestoflip[i] == '+') pancakes[i] = '-';
			else pancakes[i] = '+';
		}
	}
	
	public static void main(String[] args) throws IOException{
		Pancakes pc = new Pancakes();
		String inputPath = args[0];
		String outputPath = args[1];
		FileReader fileReader = new FileReader(inputPath);
        BufferedReader bufferedReader = new BufferedReader(fileReader);
        String line = null;
        int size = Integer.parseInt(bufferedReader.readLine());
        String[] tests = new String[size];
        int i = 0;
        while(i < size && (line = bufferedReader.readLine()) != null) {
            tests[i] = line;
            i++;
        }   
        // Always close files.
        bufferedReader.close();
		ArrayList<String> output = new ArrayList<String>();
		for (int j = 0; j < size; j++) {
			int out = pc.flipAllPancakes(tests[j]);
            output.add("Case #"+(j+1)+": "+out);
            System.out.println(out);
		}
		
		Path file = Paths.get(outputPath);
		Files.write(file, output, Charset.forName("UTF-8"));
	}

}
