package ch.googlecodejam.qualround;

import java.util.ArrayList;
import java.util.HashMap;

public class SpeakingInTongues {

    private static HashMap<String, String> mappingTable = new HashMap<String, String>();
    
    static {
        mappingTable.put("a", "y");
        mappingTable.put("b", "h");
        mappingTable.put("c", "e");
        mappingTable.put("d", "s");
        mappingTable.put("e", "o");
        mappingTable.put("f", "c");
        mappingTable.put("g", "v");
        mappingTable.put("h", "x");
        mappingTable.put("i", "d");
        mappingTable.put("j", "u");
        mappingTable.put("k", "i");
        mappingTable.put("l", "g");
        mappingTable.put("m", "l");
        mappingTable.put("n", "b");
        mappingTable.put("o", "k");
        mappingTable.put("p", "r");
        mappingTable.put("q", "z");
        mappingTable.put("r", "t");
        mappingTable.put("s", "n");
        mappingTable.put("t", "w");
        mappingTable.put("u", "j");
        mappingTable.put("v", "p");
        mappingTable.put("w", "f");
        mappingTable.put("x", "m");
        mappingTable.put("y", "a");
        mappingTable.put("z", "q");
        mappingTable.put(" ", " ");
    }
    
    public static String solve(ArrayList<String> row) {
       
        StringBuilder result = new StringBuilder();
        for(int lineNumber = 0; lineNumber < row.size(); lineNumber++) {
            
            String toTranslate = row.get(lineNumber);
            result.append("Case #" + (lineNumber + 1) + ": ");
            translateLine(result, toTranslate);
            result.append("\n");
            
        }
        
        return result.toString();
    }

    private static void translateLine(StringBuilder result, String toTranslate) {
        
        for(int letterIndex = 0; letterIndex < toTranslate.length(); letterIndex++) {
            
            char letter = toTranslate.charAt(letterIndex);
            String letterToTranslate = String.valueOf(letter);
            
            if(mappingTable.containsKey(letterToTranslate)) {
                String translatedLetter = mappingTable.get(letterToTranslate);
                result.append(translatedLetter);
            } else {
                System.out.print("Buchstabe " + letter + " unbekannt");
            }
        }
    }
}
