import java.io.*;
import java.util.*;

public class CountingSheep{

	public static void main(String[] args){

		String inFileName = "A-large.in";
		String outFileName = "countingSheepLarge.txt";
		String line = null;
        int nb_inputs = 1;

		try {

            FileReader fileReader = new FileReader(inFileName);

            // Always wrap FileReader in BufferedReader.
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            if((line = bufferedReader.readLine()) != null) {
                nb_inputs = Integer.parseInt(line);
            }
            int[] outputs = new int[nb_inputs];

            int line_nb = 1;
            while((line = bufferedReader.readLine()) != null && line_nb <= nb_inputs){
				int n = Integer.parseInt(line);
                int factor = 1;
                boolean[] flags = new boolean[10];
                flags = updateFlags(flags,n*factor);
                while(!isAllTrue(flags) && n != 0){
                    factor++;
                    flags = updateFlags(flags,n*factor);
                }
                outputs[line_nb-1] = n*factor;
                line_nb++;
            } 
            // close file
            bufferedReader.close();


            FileWriter fileWriter = new FileWriter(outFileName);

            // Always wrap FileWriter in BufferedWriter.
            BufferedWriter bufferedWriter = new BufferedWriter(fileWriter);

            for(int i = 0 ; i < outputs.length ; i++){
                String output = "";
                if(outputs[i] == 0){
                    output = "INSOMNIA";
                }
                else{
                    output = String.valueOf(outputs[i]);
                }
                bufferedWriter.write("Case #" + (i+1) + ": " + output);
                bufferedWriter.newLine();
            }

            // Always close files.
            bufferedWriter.close();
         
        }
        catch(FileNotFoundException ex) {
            System.out.println( "Unable to open file");                
        }
        catch(IOException ex) {
            System.out.println( "Error reading file");                  
            // or : ex.printStackTrace();
        }
	}

    private static boolean isAllTrue(boolean[] a){
        boolean flag = true;
        for(int i = 0; i< a.length ; i++){
            if(a[i] == false){
                flag = false;
                break;
            }
        }
        return flag;
    }

    public static boolean[] updateFlags(boolean[] flags, int n){
        int temp = n;
        while(temp > 0){
            int nb = temp%10;
            flags[nb] = true;
            temp = temp / 10;
        }
        return flags;
    }
}

