package BathroomStalls;

import TidyNumbers.*;

import java.io.IOException;
import java.io.PrintWriter;

public class Stalls {

    private TestStore store;

    private int[] baseVal(int stalls, int people) {

        int it = (int) Math.floor(Math.log(people)/Math.log(2));
        int[] current = new int[2];
        current[1] = it;

        while(it > 0) {
            stalls = (stalls-1)/2;
            it--;
        }

        current[0] = stalls;

        return current;

    }

    public Stalls(String filename) {

        try {
            store = new TestStore(filename);

            PrintWriter writer = new PrintWriter("/Users/Charlie/Desktop/stallsSolution.txt", "UTF-8");

            for(int i=0; i<store.getCases(); i++) {

                int[] current = store.getNext(i);
                int stalls = current[0];
                int people = current[1];

                int[] baseVals = baseVal(stalls, people);
                int baseVal = baseVals[0];
                int n = baseVals[1];
                int power = (int) Math.pow(2, n);

                int large = (stalls - power + 1) - baseVal*(power);

                int choice = 0;

                if(large >= (people-power+1)) {
                    choice = baseVal+1;
                } else choice = baseVal;

                int max=0;
                int min=0;

                if(choice % 2 != 0) min=max=choice/2;
                else {
                    max = choice/2;
                    min = max-1;
                }

                writer.println("Case #" + (i+1) + ": " + max + " " + min);

            }

            writer.close();

        } catch (IOException i) {
            System.out.println("Invalid filename");
        }

    }

    public static void main(String[] args) {
        new Stalls("/Users/Charlie/Desktop/C-small-2-attempt0.in.txt");
    }

}
