package BathroomStalls;

import TidyNumbers.*;

import java.io.IOException;
import java.io.PrintWriter;

public class Stalls {

    private TestStore store;

    private long[] baseVal(long stalls, long people) {

        long it = (long) Math.floor(Math.log(people)/Math.log(2));
        long[] current = new long[2];
        current[1] = it;

        while(it > 0) {
            stalls = (stalls-1)/2;
            it--;
        }

        current[0] = stalls;

        return current;

    }

    public Stalls(String filename) {

        try {
            store = new TestStore(filename);

            PrintWriter writer = new PrintWriter("/Users/Charlie/Desktop/stallsSolution.txt", "UTF-8");

            for(int i=0; i<store.getCases(); i++) {

                long[] current = store.getNext(i);
                long stalls = current[0];
                long people = current[1];

                long[] baseVals = baseVal(stalls, people);
                long baseVal = baseVals[0];
                long n = baseVals[1];
                long power = (long) Math.pow(2, n);

                long large = (stalls - power + 1) - baseVal*(power);

                long choice = 0;

                if(large >= (people-power+1)) {
                    choice = baseVal+1;
                } else choice = baseVal;

                long max=0;
                long min=0;

                if(choice % 2 != 0) min=max=choice/2;
                else {
                    max = choice/2;
                    min = max-1;
                }

                writer.println("Case #" + (i+1) + ": " + max + " " + min);

            }

            writer.close();

        } catch (IOException i) {
            System.out.println("Invalid filename");
        }

    }

    public static void main(String[] args) {
        new Stalls("/Users/Charlie/Desktop/C-large.in.txt");
    }

}
