import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Main{

	/**
	 * @param args
	 */
	public static void main(String[] args){
		try{
			final File file = new File(args[0]);
			final Scanner scanner = new Scanner(file);
			final String name = file.getName();
			final LawnMower lawnMower = new LawnMower(new File(name.substring(0, name.length() - 2) + "out"));

			boolean start = true;
			boolean dimensions = false;
			boolean done = false;
			int noOfCases = 0;
			int caseNo = 0;
			int lineNo = 0;
			int n = 0, m = 0;
			while(scanner.hasNextLine() && caseNo <= noOfCases){
				final String line = scanner.nextLine();
				if(start){
					noOfCases = Integer.parseInt(line);
					start = false;
					dimensions = true;
					caseNo = 1;
				}else if(dimensions){
					final Scanner dimScanner = new Scanner(line);
					if(dimScanner.hasNext()){
						n = dimScanner.nextInt();
						if(dimScanner.hasNext()){
							m = dimScanner.nextInt();
						}
					}
					dimScanner.close();
					lawnMower.create(n, m);
					dimensions = false;
				}else{
					lawnMower.addLine(lineNo, line);
					lineNo++;
					if(lineNo == n){
						//mown vertical
						for(int i = 0; i < m; i++){
							if(!lawnMower.mowVertical(i)){
								lawnMower.output(caseNo, 0);
								done = true;
								break;
							}
						}
						if(!done){
							lawnMower.output(caseNo, 1);
						}
						//reset all
						done = false;
						caseNo++;
						lineNo = 0;
						dimensions = true;
					}
				}
			}
			lawnMower.close();
			scanner.close();
		}catch(FileNotFoundException e){
			e.printStackTrace();
		}
	}

	public static class LawnMower{
		public final static String[] OUTCOMES = { "NO", "YES"};
		public int[][] squares, lawn;
		public PrintWriter out;

		public LawnMower(File file){
			try{
				out = new PrintWriter(new FileWriter(file));
			}catch(IOException e){
				e.printStackTrace();
			}
		}

		public final void create(int n, int m){
			squares = new int[n][m];
			lawn = new int[n][m];
		}

		public final void addLine(int line, String l){
			final Scanner scanner = new Scanner(l);
			for(int i = 0; i < squares[0].length; i++){
				if(scanner.hasNext()){
					squares[line][i] = scanner.nextInt();
					lawn[line][i] = squares[line][i];
				}
			}
			scanner.close();
			mowHorizontal(line);
		}

		public final void mowHorizontal(int l){
			int max = 0;
			for(int i = 0; i < squares[l].length; i++){
				if(squares[l][i] > max){
					max = squares[l][i];
				}
			}
			for(int i = 0; i < lawn[l].length; i++){
				lawn[l][i] = max;
			}
		}

		public final boolean mowVertical(int l){
			int max = 0;
			for(int i = 0; i < squares.length; i++){
				if(squares[i][l] > max){
					max = squares[i][l];
				}
			}
			for(int i = 0; i < lawn.length; i++){
				if(lawn[i][l] > max){
					lawn[i][l] = max;
				}
				if(lawn[i][l] != squares[i][l]){
					return false;
				}
			}
			return true;
		}

		public final void output(int caseNo, int t){
			final String s = "Case #" + caseNo + ": " + OUTCOMES[t];
			System.out.println(s);
			out.println(s);
		}

		public final void close(){
			out.close();
		}
	}

}
