import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main{

	final static String FILE_NAME = "C:\\Users\\Kamil\\Downloads\\A-small-attempt0.in";
	final static String OUTPUT_FILE_NAME = "C:\\Users\\Kamil\\Downloads\\output.txt";
	final static Charset ENCODING = StandardCharsets.UTF_8;

	public static void main(String[] args){
		try{
			List<String> lines = readSmallTextFile(FILE_NAME);

			int testCases = Integer.parseInt(lines.get(0));

			List<String> answers = new ArrayList<String>();
			for(int i = 0; i < testCases; i++){
				answers.add(getAnswer(i + 1, lines, 1 + (i * 10), 1 + ((i + 1) * 10)));
			}
			writeSmallTextFile(answers, OUTPUT_FILE_NAME);

		}catch(IOException e){
			e.printStackTrace();
		}
	}

	public static String getAnswer(int c, List<String> lines, int start, int end){
		int firstGuess = Integer.parseInt(lines.get(start));
		int secondGuess = Integer.parseInt(lines.get(start + 5));

		int[] possibleAnswers = getNumbers(lines.get(start + firstGuess));
		int[] possibleAnswers2 = getNumbers(lines.get(start + 5 + secondGuess));

		int answer = -1;
		int count = 0;

		for(int i = 0; i < possibleAnswers.length; i++){
			for(int j = 0; j < possibleAnswers2.length; j++){
				if(possibleAnswers[i] == possibleAnswers2[j]){
					answer = possibleAnswers[i];
					count++;
				}
			}
		}

		return answer(c, count, answer);
	}

	public static int[] getNumbers(String line){
		String[] strings = line.split(" ");
		int[] output = new int[strings.length];
		for(int i = 0; i < strings.length; i++){
			output[i] = Integer.parseInt(strings[i]);
		}
		return output;
	}

	public static String answer(int c, int i, int val){
		String string = "Case #" + c + ": ";
		if(i == 0){
			string += "Volunteer cheated!";
		}else if(i == 1){
			string += String.valueOf(val);
		}else{
			string += "Bad magician!";
		}
		return string;
	}

	public static List<String> readSmallTextFile(String aFileName) throws IOException{
		Path path = Paths.get(aFileName);
		return Files.readAllLines(path, ENCODING);
	}

	public static void writeSmallTextFile(List<String> aLines, String aFileName) throws IOException{
		Path path = Paths.get(aFileName);
		Files.write(path, aLines, ENCODING);
	}

	public static void readLargerTextFile(String aFileName) throws IOException{
		Path path = Paths.get(aFileName);
		try (Scanner scanner = new Scanner(path, ENCODING.name())){
			while(scanner.hasNextLine()){
				//DO SOMETHING
			}
		}
	}

	/*
	public static void writeLargerTextFile(String aFileName, List<String> aLines) throws IOException {
	    Path path = Paths.get(aFileName);
	    try (BufferedWriter writer = Files.newBufferedWriter(path, ENCODING)){
	      for(String line : aLines){
	        writer.write(line);
	        writer.newLine();
	      }
	    }
	  }*/
}
