import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class FairAndSquare{

	/**
	 * @param args
	 */
	public static void main(String[] args){
		try{
			final File file = new File(args[0]);
			final Scanner scanner = new Scanner(file);
			final String name = file.getName();
			final Determiner det = new Determiner(new File(name.substring(0, name.length() - 2) + "out"));

			boolean start = true;
			int noOfCases = 0;
			int caseNo = 0;
			int low = 0, high = 0;
			while(scanner.hasNextLine() && caseNo <= noOfCases){
				final String line = scanner.nextLine();
				if(start){
					noOfCases = Integer.parseInt(line);
					start = false;
					caseNo = 1;
				}else{
					final Scanner lineScanner = new Scanner(line);
					if(lineScanner.hasNextInt()){
						low = lineScanner.nextInt();
						if(lineScanner.hasNextInt()){
							high = lineScanner.nextInt();
						}
					}
					lineScanner.close();
					det.analyse(caseNo, low, high);
					caseNo++;
					low = 0;
					high = 0;
				}
			}
			det.close();
			scanner.close();
		}catch(FileNotFoundException e){
			e.printStackTrace();
		}
	}

	public static class Determiner{
		public PrintWriter out;
		public final int MAX = 1000000;
		public boolean[] done = new boolean[MAX];
		public boolean[] pallindromes = new boolean[MAX];
		public boolean[] doneSquare = new boolean[MAX];
		public boolean[] squares = new boolean[MAX];

		public Determiner(File file){
			try{
				out = new PrintWriter(new FileWriter(file));
			}catch(IOException e){
				e.printStackTrace();
			}
		}

		public final void analyse(int caseNo, int low, int high){
			int count = 0;
			for(int i = low; i <= high; i++){
				if(isPallindrome(i)){
					if(isSquareOfPallindrome(i)){
						count++;
					}
				}
			}
			output(caseNo, count);
		}

		public boolean isPallindrome(int i){
			if(i < MAX){
				if(done[i]){
					return pallindromes[i];
				}
				done[i] = true;
			}
			if(i < 10){
				pallindromes[i] = true;
				done[i] = true;
				return true;
			}
			final String s = Integer.toString(i);
			final int length = s.length();
			final int len = length / 2;
			for(int c = 0; c < len; c++){
				if(s.charAt(c) != s.charAt(length - 1 - c)){
					if(i < MAX){
						pallindromes[i] = false;
					}
					return false;
				}
			}
			if(i < MAX){
				pallindromes[i] = true;
			}
			return true;
		}

		public boolean isSquareOfPallindrome(int i){
			if(i < MAX){
				if(doneSquare[i]){
					return squares[i];
				}
				doneSquare[i] = true;
			}
			final int sqrt = (int) Math.sqrt((double) i);
			if(sqrt * sqrt == i){
				if(isPallindrome(sqrt)){
					if(i < MAX){
						squares[i] = true;
					}
					return true;
				}
			}
			if(i < MAX){
				squares[i] = false;
			}
			return false;
		}

		public final void output(int caseNo, int t){
			final String s = "Case #" + caseNo + ": " + t;
			System.out.println(s);
			out.println(s);
		}

		public final void close(){
			out.close();
		}
	}

}
