import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

public class Main{

	final static String FILE_NAME = "C:\\Users\\Kamil\\workspace\\CodeJam\\src\\in.in";
	//final static String FILE_NAME = "C:\\Users\\Kamil\\workspace\\CodeJam\\src\\test.txt";
	final static String OUTPUT_FILE_NAME = "C:\\Users\\Kamil\\workspace\\CodeJam\\src\\output.txt";
	final static Charset ENCODING = StandardCharsets.UTF_8;

	public static void main(String[] args){
		try{
			List<String> lines = readSmallTextFile(FILE_NAME);

			int testCases = Integer.parseInt(lines.get(0));

			List<String> answers = new ArrayList<String>();
			for(int i = 0; i < testCases; i++){
				answers.add(getAnswers(i + 1, getNumbers(lines.get(i * 3 + 2)), getNumbers(lines.get(i * 3 + 3))));
			}
			writeSmallTextFile(answers, OUTPUT_FILE_NAME);

		}catch(IOException e){
			e.printStackTrace();
		}
	}

	public static String getAnswers(int c, double[] nWeights, double[] kWeights){
		int deceitScore = 0;
		int score = 0;

		Arrays.sort(nWeights);
		Arrays.sort(kWeights);

		int kSmall = 0;
		int nSmall = 0;
		int kBig = kWeights.length - 1;
		for(int i = nWeights.length - 1; i >= 0; i--){
			if(nWeights[i] > kWeights[kBig]){
				score++;
			}else{
				kBig--;
			}
			if(nWeights[nSmall] < kWeights[kSmall]){
				//get rid of kens biggest block
				nSmall++;
			}else{
				nSmall++;
				kSmall++;
				deceitScore++;
			}
		}
		return getCase(c, deceitScore, score);
	}

	public static double[] getNumbers(String s){
		String[] split = s.split(" ");
		double[] nums = new double[split.length];
		for(int i = 0; i < split.length; i++){
			nums[i] = Double.parseDouble(split[i]);
		}
		return nums;
	}

	public static String getCase(int c, int s1, int s2){
		return "Case #" + c + ": " + String.valueOf(s1) + " " + String.valueOf(s2);
	}

	public static List<String> readSmallTextFile(String aFileName) throws IOException{
		Path path = Paths.get(aFileName);
		return Files.readAllLines(path, ENCODING);
	}

	public static void writeSmallTextFile(List<String> aLines, String aFileName) throws IOException{
		Path path = Paths.get(aFileName);
		Files.write(path, aLines, ENCODING);
	}

	public static void readLargerTextFile(String aFileName) throws IOException{
		Path path = Paths.get(aFileName);
		try (Scanner scanner = new Scanner(path, ENCODING.name())){
			while(scanner.hasNextLine()){
				//DO SOMETHING
			}
		}
	}

	/*
	public static void writeLargerTextFile(String aFileName, List<String> aLines) throws IOException {
	    Path path = Paths.get(aFileName);
	    try (BufferedWriter writer = Files.newBufferedWriter(path, ENCODING)){
	      for(String line : aLines){
	        writer.write(line);
	        writer.newLine();
	      }
	    }
	  }*/
}
