import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main{

	final static String FILE_NAME = "C:\\Users\\Kamil\\workspace\\CodeJam\\src\\in.in";
	//final static String FILE_NAME = "C:\\Users\\Kamil\\workspace\\CodeJam\\src\\test.txt";
	final static String OUTPUT_FILE_NAME = "C:\\Users\\Kamil\\workspace\\CodeJam\\src\\output.txt";
	final static Charset ENCODING = StandardCharsets.UTF_8;

	public static void main(String[] args){
		try{
			List<String> lines = readSmallTextFile(FILE_NAME);

			int testCases = Integer.parseInt(lines.get(0));

			List<String> answers = new ArrayList<String>();
			for(int i = 0; i < testCases; i++){
				answers.add(getAnswer(i + 1, lines.get(i + 1)));
			}
			writeSmallTextFile(answers, OUTPUT_FILE_NAME);

		}catch(IOException e){
			e.printStackTrace();
		}
	}

	public static String getAnswer(int problem, String line){
		double[] numbers = getNumbers(line);

		double startRate = 2.0;

		double farmCost = numbers[0];
		double addRateFarm = numbers[1];
		double goal = numbers[2];

		double currentRate = startRate;

		double timeSoFar = 0;

		double timeToGoal = goal / currentRate;
		double timeToFarm = farmCost / currentRate;
		double newRate = currentRate + addRateFarm;
		double timeToGoalWithFarm = timeToFarm + (goal / newRate);

		while(timeToGoalWithFarm < timeToGoal){
			currentRate = newRate;
			timeSoFar += timeToFarm;

			timeToGoal = goal / currentRate;
			timeToFarm = farmCost / currentRate;
			newRate = currentRate + addRateFarm;
			timeToGoalWithFarm = timeToFarm + (goal / newRate);
		}

		timeSoFar += timeToGoal;

		return answer(problem, timeSoFar);
	}

	public static double[] getNumbers(String line){
		String[] strings = line.split(" ");
		double[] output = new double[strings.length];
		for(int i = 0; i < strings.length; i++){
			output[i] = Double.parseDouble(strings[i]);
		}
		return output;
	}

	public static String answer(int c, double val){
		return "Case #" + c + ": " + String.valueOf(val);
	}

	public static List<String> readSmallTextFile(String aFileName) throws IOException{
		Path path = Paths.get(aFileName);
		return Files.readAllLines(path, ENCODING);
	}

	public static void writeSmallTextFile(List<String> aLines, String aFileName) throws IOException{
		Path path = Paths.get(aFileName);
		Files.write(path, aLines, ENCODING);
	}

	public static void readLargerTextFile(String aFileName) throws IOException{
		Path path = Paths.get(aFileName);
		try (Scanner scanner = new Scanner(path, ENCODING.name())){
			while(scanner.hasNextLine()){
				//DO SOMETHING
			}
		}
	}

	/*
	public static void writeLargerTextFile(String aFileName, List<String> aLines) throws IOException {
	    Path path = Paths.get(aFileName);
	    try (BufferedWriter writer = Files.newBufferedWriter(path, ENCODING)){
	      for(String line : aLines){
	        writer.write(line);
	        writer.newLine();
	      }
	    }
	  }*/
}
