import java.io.*;
import java.util.*;

public class Problem1 {
    public static void main(String args[]) throws IOException {
        final String INPUT = "A-large.in";
        final String OUTPUT = "output_file.txt";

        BufferedReader in = new BufferedReader(new FileReader(INPUT));
        PrintWriter out = new PrintWriter(new File(OUTPUT));

        int testCases = Integer.parseInt(in.readLine());
        for (int test = 1; test <= testCases; test++) {
            String[] line = in.readLine().split(" ");
            String pancakes = line[0];
            int K = Integer.parseInt(line[1]);
            int moves = makeHappy(pancakes, K);
            if (moves == -1) {
                out.println("Case #"+test+": IMPOSSIBLE");
            }
            else {
                out.println("Case #"+test+": "+moves);
            }
        }

        in.close();
        out.close();
    }

    private static int makeHappy(String pancakes, int fliperSize) {
        int count = 0;
        while(pancakes.indexOf("-") != -1 && pancakes.indexOf("-") <= pancakes.length()-fliperSize) {
            int blankPancake = pancakes.indexOf("-");
            String originalPancakes = pancakes;
            pancakes = originalPancakes.substring(0, blankPancake);
            for (int i = blankPancake; i < blankPancake+fliperSize; i++) {
                if (originalPancakes.charAt(i) == '-') {
                    pancakes += "+";
                }
                else {
                    pancakes += "-";
                }
            }
            pancakes += originalPancakes.substring(blankPancake+fliperSize);
            count++;
        }
        if (pancakes.indexOf("-") == -1) {
            return count;
        }
        return -1;
    }
}
