package com.boney.codejam;

import java.io.File;
import java.io.FileWriter;
import java.math.BigDecimal;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

import com.google.common.collect.Lists;

public class DeceitfulWar {

	private static final BigDecimal SMALL_VAL = BigDecimal.valueOf(0.0000001d);
	private static final String PATH = "C:/Boney/CodeJam/DeceitfulWar";

	private void doTheJob() throws Exception {
		Scanner scanner = new Scanner(new File(PATH + "/input.txt"));
		FileWriter fileWriter = new FileWriter(new File(PATH + "/output.txt"));
		int totalTestCases = Integer.parseInt(scanner.next());
		System.out.println("Total test cases : " + totalTestCases);
		for (int i = 0; i < totalTestCases; i++) {
			int origNaomiPoints = 0;
			int numberOfBlocks = scanner.nextInt();
			List<BigDecimal> blocksNaomi = Lists.newArrayList();
			List<BigDecimal> blocksKen = Lists.newArrayList();
			System.out.println("Test Case " + (i + 1) + " Blocks : " + numberOfBlocks);
			for (int j = 0; j < numberOfBlocks; j++) {
				blocksNaomi.add(scanner.nextBigDecimal());
			}
			for (int j = 0; j < numberOfBlocks; j++) {
				blocksKen.add(scanner.nextBigDecimal());
			}
			System.out.println("Naomi Blocks : " + blocksNaomi);
			Collections.sort(blocksKen);
			System.out.println("Ken Blocks : " + blocksKen);
			int pointsNaomi = 0;
			int pointsKen = 0;

			List<BigDecimal> blocksKenPlaying = Lists.newArrayList(blocksKen);
			List<BigDecimal> blocksNaomiPlaying = Lists.newArrayList(blocksNaomi);
			for (BigDecimal naomiBlock : blocksNaomiPlaying) {
				// System.out.println("Naomi played " + naomiBlock);
				BigDecimal kenBlockChosen = blocksKenPlaying.get(0);
				for (BigDecimal kenBlock : blocksKenPlaying) {
					if (kenBlock.compareTo(naomiBlock) > 0) {
						if (!((kenBlockChosen.compareTo(naomiBlock) > 0) && (kenBlockChosen.compareTo(kenBlock) < 0))) {
							kenBlockChosen = kenBlock;
						}
					}
				}
				// System.out.println("Ken played " + kenBlockChosen);
				blocksKenPlaying.remove(kenBlockChosen);
				if (kenBlockChosen.compareTo(naomiBlock) > 0) {
					pointsKen++;
				} else {
					pointsNaomi++;
				}
			}

			System.out.println("Ken : " + pointsKen + " Naomi : " + pointsNaomi);
			origNaomiPoints = pointsNaomi;
			pointsKen = 0;
			pointsNaomi = 0;
			Collections.sort(blocksNaomi);

			for (int j = 0; j < numberOfBlocks; j++) {
				BigDecimal kensLargest = Collections.max(blocksKen);
				BigDecimal kensSmallest = Collections.min(blocksKen);
				BigDecimal naomiPlayedWieght = Collections.min(blocksNaomi);
				if (naomiPlayedWieght.compareTo(kensSmallest) < 0) {
					// get rid of his max with my smallest
					blocksNaomi.remove(naomiPlayedWieght);
					// System.out.println("Naomi played " + naomiPlayedWieght +
					// " pretending it to be " +
					// kensLargest.subtract(SMALL_VAL));
					naomiPlayedWieght = kensLargest.subtract(SMALL_VAL);
				} else {
					blocksNaomi.remove(naomiPlayedWieght);
					// System.out.println("Naomi played " + naomiPlayedWieght +
					// " pretending it to be " + kensLargest.add(SMALL_VAL));
					naomiPlayedWieght = kensLargest.add(SMALL_VAL);
				}

				BigDecimal kenBlockChosen = blocksKen.get(0);
				for (BigDecimal kenBlock : blocksKen) {
					if (kenBlock.compareTo(naomiPlayedWieght) > 0) {
						if (!((kenBlockChosen.compareTo(naomiPlayedWieght) > 0) && (kenBlockChosen.compareTo(kenBlock) < 0))) {
							kenBlockChosen = kenBlock;
						}
					}
				}
				blocksKen.remove(kenBlockChosen);
				// System.out.println("Ken played " + kenBlockChosen);
				if (kenBlockChosen.compareTo(naomiPlayedWieght) > 0) {
					pointsKen++;
				} else {
					pointsNaomi++;
				}
			}
			System.out.println("Ken : " + pointsKen + " Naomi : " + pointsNaomi);
			fileWriter.write("Case #" + (i + 1) + ": " + pointsNaomi + " " + origNaomiPoints + "\n");
		}
		fileWriter.flush();
		fileWriter.close();
		scanner.close();
	}

	public static void main(String[] args) throws Exception {
		DeceitfulWar mt = new DeceitfulWar();
		mt.doTheJob();
	}

}
