package com.boney.codejam;

import java.io.File;
import java.io.FileWriter;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;

public class ProblemA {

	private static final String PATH = "C:/Boney/CodeJam/";

	private void doTheJob() throws Exception {
		Scanner scanner = new Scanner(new File(PATH + "ProblemA-input.txt"));
		FileWriter fileWriter = new FileWriter(new File(PATH + "ProblemA-output.txt"));
		int totalTestCases = Integer.parseInt(scanner.next());
		System.out.println("Total test cases : " + totalTestCases);
		for (int i = 0; i < totalTestCases; i++) {
			System.out.println("Test Case " + (i + 1));
			int n = scanner.nextInt();
			List<char[]> strings = Lists.newArrayList();
			int maxCharCount = 4098;
			for (int j = 0; j < n; j++) {
				String nextString = scanner.next();
				strings.add(nextString.toCharArray());
			}
			char[][] strs = new char[n][maxCharCount];

			for (int x = 0; x < n; x++) {
				char[] a = strings.get(x);
				for (int j = 0; j < a.length; j++) {
					strs[x][j] = a[j];
				}

				for (int j = a.length; j < maxCharCount; j++) {
					strs[x][j] = ' ';
				}
				// System.out.println(Arrays.toString(strs[x]));
			}

			int actionCount = 0;
			boolean impossible = false;

			for (int x = 0; x < maxCharCount; x++) {
				Map<Character, Integer> charCount = Maps.newHashMap();
				for (int y = 0; y < n; y++) {
					if (charCount.get(strs[y][x]) == null) {
						charCount.put(strs[y][x], 1);
					} else {
						charCount.put(strs[y][x], charCount.get(strs[y][x]) + 1);
					}
				}
				charCount = sortByValue(charCount);
				System.out.println(charCount);
				char charToMatch = charCount.entrySet().iterator().next().getKey();
				if ((charCount.size() == 1) && (charToMatch == ' ')) {
					continue;
				}
				List<Integer> mismatched = Lists.newArrayList();
				for (int y = 0; y < n; y++) {
					if (charToMatch != strs[y][x]) {
						mismatched.add(y);
					}
				}
				int prevActionCount = actionCount;
				if (mismatched.size() == 0) {
					continue;
				} else {
					for (int mm : mismatched) {
						if ((x > 0) && ((strs[mm][x - 1]) == charToMatch)) {
							actionCount++;
							insertElementAtPosition(strs[mm], charToMatch, x - 1);
							// System.out.println("Insert " + charToMatch +
							// " at " + (x - 1) + " for " + mm + " - " +
							// Arrays.toString(strs[mm]));

							// for (int j = 0; j < n; j++) {
							// System.out.println("Processed " +
							// Arrays.toString(strs[j]));
							// }
						} else if (x > 0) {
							int d = x;
							while (true) {
								if ((strs[mm][d] == strs[mm][d - 1]) || (((d + 1) > maxCharCount) && (strs[mm][d] == strs[mm][d + 1]))) {
									actionCount++;
									deleteElementAtPosition(strs[mm], d - 1);
									// System.out.println("Delete " + (d - 1) +
									// " for " + mm + " - " +
									// Arrays.toString(strs[mm]));

									// for (int j = 0; j < n; j++) {
									// System.out.println("Processed " +
									// Arrays.toString(strs[j]));
									// }
								} else {
									impossible = true;
									break;
								}
								if (((d + 1) == maxCharCount) || (strs[mm][x] == charToMatch)) {
									break;
								}
							}
						}
					}
				}
				if (actionCount == prevActionCount) {
					impossible = true;
					break;
				}

			}

			for (int j = 0; j < n; j++) {
				System.out.println("Processed " + Arrays.toString(strs[j]));
			}
			System.out.println("Action count " + actionCount + " " + impossible);
			if (impossible) {
				fileWriter.write("Case #" + (i + 1) + ": Fegla Won\n");
			} else {
				fileWriter.write("Case #" + (i + 1) + ": " + actionCount + "\n");
			}

		}
		fileWriter.flush();
		fileWriter.close();
		scanner.close();
	}

	static Map sortByValue(Map map) {
		List list = new LinkedList<>(map.entrySet());
		Collections.sort(list, new Comparator() {
			@Override
			public int compare(Object o1, Object o2) {
				return -1 * ((Comparable) ((Map.Entry) (o1)).getValue()).compareTo(((Map.Entry) (o2)).getValue());
			}
		});

		Map result = new LinkedHashMap();
		for (Iterator it = list.iterator(); it.hasNext();) {
			Map.Entry entry = (Map.Entry) it.next();
			result.put(entry.getKey(), entry.getValue());
		}
		return result;
	}

	private static void insertElementAtPosition(char a[], char b, int pos) {
		for (int i = a.length - 1; i > pos; i--) {
			a[i] = a[i - 1];
		}
		a[pos] = b;
	}

	private static void deleteElementAtPosition(char a[], int pos) {
		for (int i = pos; i < (a.length - 1); i++) {
			a[i] = a[i + 1];
		}
		a[a.length - 1] = ' ';
	}

	public static void main(String[] args) throws Exception {
		ProblemA mt = new ProblemA();
		mt.doTheJob();
		char[] t1 = new char[5];
		t1[0] = '1';
		t1[1] = '2';
		t1[2] = '3';
		t1[3] = '4';
		t1[4] = '5';
		deleteElementAtPosition(t1, 2);
		System.out.println(Arrays.toString(t1));
	}
}
