package com.boney.codejam;

import java.io.File;
import java.io.FileWriter;
import java.util.List;
import java.util.Scanner;

import org.apache.commons.collections.CollectionUtils;

import com.google.common.collect.Lists;
import com.google.common.primitives.Ints;

public class MagicTrick {

	private static final String PATH = "C:/Boney/CodeJam/MagicTrick";

	private void doTheJob() throws Exception {
		Scanner scanner = new Scanner(new File(PATH + "/input.txt"));
		FileWriter fileWriter = new FileWriter(new File(PATH + "/output.txt"));
		int totalTestCases = Integer.parseInt(scanner.next());
		System.out.println("Total test cases : " + totalTestCases);
		for (int i = 0; i < totalTestCases; i++) {
			System.out.println("Test Case " + (i + 1));
			int row1 = Integer.parseInt(scanner.next());
			int[][] firstCards = new int[4][4];
			readCardsIntoArray(scanner, firstCards);

			List<Integer> firstRowCards = Ints.asList(firstCards[row1 - 1]);
			System.out.println("The card is in row " + firstRowCards);

			int row2 = Integer.parseInt(scanner.next());
			int[][] secondCards = new int[4][4];
			readCardsIntoArray(scanner, secondCards);

			List<Integer> secondRowCards = Ints.asList(secondCards[row2 - 1]);
			System.out.println("The card is in row " + secondRowCards);

			List<Integer> intersected = Lists.newArrayList();
			for (int val : secondRowCards) {
				if (firstRowCards.contains(val)) {
					intersected.add(val);
				}
			}
			System.out.println("Results " + intersected);
			if (intersected.size() == 1) {
				fileWriter.write("Case #" + (i + 1) + ": " + intersected.get(0) + "\n");
			} else if (CollectionUtils.isEmpty(intersected)) {
				fileWriter.write("Case #" + (i + 1) + ": Volunteer cheated!\n");
			} else if (intersected.size() > 1) {
				fileWriter.write("Case #" + (i + 1) + ": Bad magician!\n");
			}
		}
		fileWriter.flush();
		fileWriter.close();
	}

	private void readCardsIntoArray(Scanner scanner, int[][] firstCards) {
		for (int x = 0; x < 4; x++) {
			for (int y = 0; y < 4; y++) {
				firstCards[x][y] = Integer.parseInt(scanner.next());
			}
		}
	}

	public static void main(String[] args) throws Exception {
		MagicTrick mt = new MagicTrick();
		mt.doTheJob();
	}

}
