package com.boney.codejam;

import java.io.File;
import java.io.FileWriter;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Scanner;

public class CookieFarm {

	private static final String PATH = "C:/Boney/CodeJam/Cookie";

	private void doTheJob() throws Exception {
		Scanner scanner = new Scanner(new File(PATH + "/input.txt"));
		FileWriter fileWriter = new FileWriter(new File(PATH + "/output.txt"));
		int totalTestCases = Integer.parseInt(scanner.next());
		System.out.println("Total test cases : " + totalTestCases);
		for (int i = 0; i < totalTestCases; i++) {
			System.out.println("Test Case " + (i + 1));
			BigDecimal costPerFarm = new BigDecimal(scanner.next());
			BigDecimal extraCookiesPerSec = new BigDecimal(scanner.next());
			BigDecimal cookiesNeeded = new BigDecimal(scanner.next());
			System.out.println("Cookies " + costPerFarm + " " + extraCookiesPerSec + " " + cookiesNeeded);
			BigDecimal seconds = BigDecimal.ZERO;
			BigDecimal rate = BigDecimal.ONE.add(BigDecimal.ONE); // :)
			if ((cookiesNeeded.compareTo(costPerFarm) <= 0) || (extraCookiesPerSec.compareTo(BigDecimal.ZERO) == 0)) {
				seconds = cookiesNeeded.divide(rate);
				System.out.println("Case #" + (i + 1) + ": " + seconds.setScale(7).toPlainString() + "\n");
				fileWriter.write("Case #" + (i + 1) + ": " + seconds.setScale(7).toPlainString() + "\n");
			} else {
				BigDecimal secondsConsumed = BigDecimal.ZERO;
				BigDecimal secondsRequiredCurrent = BigDecimal.ZERO;
				BigDecimal secondsWithAnotherFarm = BigDecimal.ZERO;
				BigDecimal secondsMakingFarm = BigDecimal.ZERO;
				do {
					secondsConsumed = secondsConsumed.add(secondsMakingFarm);
					secondsRequiredCurrent = cookiesNeeded.divide(rate, 7, RoundingMode.HALF_UP);
					if (costPerFarm.compareTo(BigDecimal.ZERO) > 0) {
						secondsMakingFarm = costPerFarm.divide(rate, 7, RoundingMode.HALF_UP);
						secondsWithAnotherFarm = secondsMakingFarm.add(cookiesNeeded.divide(rate.add(extraCookiesPerSec), 7, RoundingMode.HALF_UP));
					} else {
						rate = rate.add(BigDecimal.valueOf(10000000000000000L));
						secondsRequiredCurrent = cookiesNeeded.divide(rate, 7, RoundingMode.HALF_UP);
						break;
					}
					rate = rate.add(extraCookiesPerSec);
				} while (secondsRequiredCurrent.compareTo(secondsWithAnotherFarm) > 0);
				System.out.println("Seconds Current " + secondsRequiredCurrent + " " + secondsWithAnotherFarm);
				secondsConsumed = secondsConsumed.add(secondsRequiredCurrent);
				System.out.println("Case #" + (i + 1) + ": " + secondsConsumed.setScale(7).toPlainString());
				fileWriter.write("Case #" + (i + 1) + ": " + secondsConsumed.setScale(7).toPlainString() + "\n");
				secondsConsumed.add(secondsRequiredCurrent);
			}
		}
		fileWriter.flush();
		fileWriter.close();
		scanner.close();
	}

	public static void main(String[] args) throws Exception {
		CookieFarm mt = new CookieFarm();
		mt.doTheJob();
	}

}
