package com.google.codejam.clue.welcome;

import java.util.HashSet;
import java.util.Set;

public class CompiledPattern {
	private Set<Character>[] charVariations;
	private final int wordLength; 
	public CompiledPattern(int wordLength){
		this.wordLength = wordLength;
		charVariations = new Set[wordLength];
	}
	public void addCharVariation(int position, char variant){
		Set<Character> positionVariationsSet = charVariations[position];
		if (positionVariationsSet == null) {
			positionVariationsSet = new HashSet<Character>();
			charVariations[position] = positionVariationsSet; 			
		}
		positionVariationsSet.add(variant);
	}
	
	public boolean allowedVariation(int position, char variant){
		Set<Character> positionVariationsSet = charVariations[position];
		if (positionVariationsSet != null && positionVariationsSet.contains(variant)) {
			return true;
		} else {
			return false;
		}
	}
	
	public boolean wordMatches(char[] word)
	{
		for (int i=0; i<wordLength; i++) {
			if (!allowedVariation(i, word[i])) {
				return false;
			}
		}
		return true;
	}
}
