import java.io.FileInputStream;
import java.io.InputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.util.Scanner;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "B-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("b.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		Scanner in = new Scanner(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskB solver = new TaskB();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskB {
    public void solve(int testNumber, Scanner in, PrintWriter out) {
        int n = in.nextInt();
        double v = in.nextDouble();
        double x = in.nextDouble();

        if (n == 1) {
            double r = in.nextDouble();
            double c = in.nextDouble();

            if (Math.abs(x - c) < 0.000001) {
                out.format("Case #%d: %f\n", testNumber, v / r);
                return ;
            }
            out.format("Case #%d: %s\n", testNumber, "IMPOSSIBLE");
            return ;
        }

        double[] r = new double[n];
        double[] c = new double[n];
        double[] bili = new double[n];
        double[] second = new double[n];

        for (int i = 0; i < n; i++) {
            r[i] = in.nextDouble();
            c[i] = in.nextDouble();
        }

        if (c[0] > c[1]) {
            double rr = r[0];
            r[0] = r[1];
            r[1] = rr;

            double cc = c[0];
            c[0] = c[1];
            c[1] = cc;
        }

        bili[0] = (c[1] - x) / (c[1] - c[0]);
        bili[1] = 1 - bili[0];

        if (bili[0] < 0 || bili[1] < 0) {
            out.format("Case #%d: %s\n", testNumber, "IMPOSSIBLE");
            return ;
        }

        second[0] = v * bili[0] / r[0];
        second[1] = v * bili[1] / r[1];

        double ans = Math.max(second[0], second[1]);
        out.format("Case #%d: %f\n", testNumber, ans);
    }
}

