package dijkstra;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class Dijkstra {

	private final static String SOURCE = "C:\\GCJ\\Dijkstra";
	private static BufferedReader br = null;
	private static BufferedWriter bw = null;
	private int uno = 0, i = 1, j = 2, k = 3;
	static Factor[][] matriz = new Factor[][] {
			{ new Factor(true, '1'), new Factor(true, 'i'),
					new Factor(true, 'j'), new Factor(true, 'k') },
			{ new Factor(true, 'i'), new Factor(false, '1'),
					new Factor(true, 'k'), new Factor(false, 'j') },
			{ new Factor(true, 'j'), new Factor(false, 'k'),
					new Factor(false, '1'), new Factor(true, 'i') },
			{ new Factor(true, 'k'), new Factor(true, 'j'),
					new Factor(false, 'i'), new Factor(false, '1') } };

	public static void main(String[] args) {
		try {
			br = new BufferedReader(new FileReader(SOURCE + "\\input.txt"));
			bw = new BufferedWriter(new FileWriter(SOURCE + "\\output.txt"));
			int numCasos = Integer.parseInt(br.readLine());
			caso: for (int caso = 0; caso < numCasos; caso++) {
				String[] ln = br.readLine().split(" ");
				String linea = br.readLine();
				int longitud = Integer.parseInt(ln[0]);
				int repetir = Integer.parseInt(ln[1]);
				String cadena = "";
				for (int i = 0; i < repetir; i++) {
					cadena += linea;
				}
				if (!validacionesIniciales(cadena)) {
					escribir("Case #" + (caso + 1) + ": NO");
					continue;
				}
				if (cadena.equals("ijk")) {
					escribir("Case #" + (caso + 1) + ": YES");
					continue;
				}
				if (procesarCuaternios(cadena, 0)) {
					escribir("Case #" + (caso + 1) + ": YES");
					continue;
				}
				escribir("Case #" + (caso + 1) + ": NO");
			}

		} catch (Exception e) {
			System.out.println("Error general");
			e.printStackTrace();
		} finally {
			try {
				br.close();
				bw.close();
			} catch (Exception e) {
			}
		}
	}

	private static boolean procesarCuaternios(String cadena, int index) {
		char[] ijk = new char[] { 'i', 'j', 'k' };
		int caracterInicial = 0;
		principal: for (int i = 0; i < 3; i++) {
			Factor res = new Factor(true, cadena.charAt(caracterInicial));
			for (int c = caracterInicial + 1; c < cadena.length(); c++) {
				Factor f = new Factor(true, cadena.charAt(c));
				res = multiplicarFactores(res, f);
				if (res.signo == true && res.valor == ijk[i]) {
					caracterInicial = c + 1;
					if (i == 2 && c != cadena.length() - 1) {
						continue;
					}
					continue principal;
				}
			}
			return false;
		}
		return true;
	}

	private static Factor multiplicarFactores(Factor f1, Factor f2) {
		boolean multi = f1.signo == f2.signo;
		Factor fr = new Factor(
				matriz[f1.getIndex()][f2.getIndex()].signo == multi,
				matriz[f1.getIndex()][f2.getIndex()].valor);
		return fr;
	}

	private static boolean validacionesIniciales(String cadena) {
		if (cadena.length() < 3) {
			return false;
		}
		if (cadena.length() == 3 && !cadena.equals("ijk")) {
			return false;
		}
		return true;
	}

	/**
	 * Escribe en el archivo output.txt
	 */
	private static void escribir(String cadena) {
		try {
			bw.write(cadena + "\r\n");
			System.out.println(cadena);
		} catch (Exception e) {
			System.out.println("Error al escribir");
			e.printStackTrace();
		}
	}

	/**
	 * Convierte una cadena en un ARRAY INT
	 */
	private static int[] aArrayInt(String cadena) {
		String[] arrayStr = cadena.split(" ");
		int[] arrayInt = new int[arrayStr.length];
		int c = 0;
		for (String str : arrayStr) {
			arrayInt[c++] = Integer.parseInt(str);
		}
		return arrayInt;
	}
}

class Factor {
	boolean signo;
	char valor;

	public Factor(boolean signo, char valor) {
		this.signo = signo;
		this.valor = valor;
	}

	public Factor() {
	}

	int getIndex() {
		switch (valor) {
		case '1':
			return 0;
		case 'i':
			return 1;
		case 'j':
			return 2;
		case 'k':
			return 3;
		default:
			return 4;
		}
	}

	@Override
	public String toString() {
		return (signo ? "" : "-") + valor;
	}
}