package revengeOfThePancakes;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledThreadPoolExecutor;

public class RevengeOfThePancakes implements Runnable {

	private PrintWriter out;

	final String file = "C:\\GCJ\\GCJ\\src\\"
			+ this.getClass().getPackage().getName() + "\\input";
	Random rnd = new Random(42);

	static class InputData {
		String s;

		InputData(FastReader in) throws IOException {
			s = in.next();
		}

		void solve(PrintWriter out) {

			out.println(iniciarOrden());
		}

		int iniciarOrden() {
			s = s.substring(0, s.lastIndexOf('-') + 1);
			if (s.length() == 0) {
				return 0;
			}
			boolean[] pancs = new boolean[s.length()];
			char[] cs = s.toCharArray();
			for (int i = 0; i < s.length(); i++) {
				pancs[i] = cs[i] == '+';
			}
			// return 0;
			return ordenar(pancs, pancs.length);
		}

		int ordenar(boolean[] p, int index) {
			int movs = 0;
			for (int i = 0; i < index - 1; i++) {
				if (p[i] != p[i + 1]) {
					movs += ordenar(p, i + 1);
				}
			}
			invertir(p, index);
			return movs + 1;
		}

		void invertir(boolean[] p, int index) {
			boolean[] copia = Arrays.copyOf(p, p.length);
			for (int i = 0; i < index; i++) {
				p[i] = !copia[(index - 1) - i];
			}
		}
	}

	static class Solver implements Callable<String> {

		InputData data;

		Solver(InputData data) {
			this.data = data;
		}

		@Override
		public String call() throws Exception {
			StringWriter out = new StringWriter();
			data.solve(new PrintWriter(out));
			return out.toString();
		}

	}

	public void run() {
		try {
			FastReader in = new FastReader(new BufferedReader(new FileReader(
					file + ".in")));
			out = new PrintWriter(file + ".out");

			ScheduledThreadPoolExecutor service = new ScheduledThreadPoolExecutor(
					7);

			int tests = in.nextInt();
			@SuppressWarnings("unchecked")
			Future<String>[] ts = new Future[tests];
			for (int test = 0; test < tests; ++test) {
				ts[test] = service.submit(new Solver(new InputData(in)));
			}
			for (int test = 0; test < tests; ++test) {
				while (!ts[test].isDone()) {
					Thread.sleep(500);
				}
				// System.err.println("Test " + test);
				out.print("Case #" + (test + 1) + ": ");
				System.out.print("Case #" + (test + 1) + ": ");
				out.print(ts[test].get());
				System.out.print(ts[test].get());
			}
			service.shutdown();

			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	static class FastReader {
		public FastReader(BufferedReader in) {
			this.in = in;
			eat("");
		}

		private StringTokenizer st;
		private BufferedReader in;

		void eat(String s) {
			st = new StringTokenizer(s);
		}

		String next() throws IOException {
			while (!st.hasMoreTokens()) {
				String line = in.readLine();
				if (line == null) {
					return null;
				}
				eat(line);
			}
			return st.nextToken();
		}

		int nextInt() throws IOException {
			return Integer.parseInt(next());
		}

		long nextLong() throws IOException {
			return Long.parseLong(next());
		}

		double nextDouble() throws IOException {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new RevengeOfThePancakes().run();
	}

}
