package coinjam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.Locale;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledThreadPoolExecutor;

public class CoinJam implements Runnable {

	private PrintWriter out;

	final String file = "C:\\GCJ\\GCJ\\src\\"
			+ this.getClass().getPackage().getName() + "\\input";
	Random rnd = new Random(42);

	static class InputData {
		int N, J, contadorExitosos = 0;

		InputData(FastReader in) throws IOException {
			N = in.nextInt();
			J = in.nextInt();

		}

		void solve(PrintWriter out) {
			out.println("");
			jamcoin: for (int i = 0; contadorExitosos < J; i++) {
				String jamcoin = "1" + aBinario(i, N - 2) + "1";
				long[] factores = new long[9];
				for (int b = 2; b <= 10; b++) {
					long factor = esPrimo(interpretarDesdeBase(jamcoin, b));
//					System.out
//							.println(b + ".\t " + jamcoin + "\t"
//									+ interpretarDesdeBase(jamcoin, b) + " % "
//									+ factor);
					if (factor < 0) {
						continue jamcoin;
					}
					factores[b - 2] = factor;
				}
				String resultado = jamcoin;
				for (int d = 0; d < factores.length; d++) {
					resultado += " " + factores[d];
				}
				out.println(resultado);
				contadorExitosos++;
			}
		}

		long interpretarDesdeBase(String num, int base) {
			long sum = 0;
			for (int i = 0; i < num.length(); i++) {
				sum += (Byte.parseByte(num.charAt(i) + "") * Math.pow(base,
						num.length() - i - 1));
			}
			return sum;
		}

		String aBinario(long num, int longitud) {
			int exp = 0, binario = 0;
			while (num != 0) {
				int digito = (int) (num % 2);
				binario += digito * (int) Math.pow(10, exp++);
				num /= 2;
			}
			String binarioS = binario + "";
			while (binarioS.length() < longitud) {
				binarioS = "0" + binarioS;
			}
			return binarioS;
		}

		long esPrimo(long n) {
			if (n == 2 || n == 3)
				return -1;
			if (n % 2 == 0)
				return 2;
			if (n % 3 == 0)
				return 3;
			if (n % 5 == 0)
				return 5;
			long sqrtN = (long) Math.sqrt(n) + 1;
			for (long i = 6L; i <= sqrtN; i += 6) {
				if (n % (i - 1) == 0)
					return i - 1;
				if (n % (i + 1) == 0)
					return i + 1;
			}
			return -1;
		}
	}

	static class Solver implements Callable<String> {

		InputData data;

		Solver(InputData data) {
			this.data = data;
		}

		@Override
		public String call() throws Exception {
			StringWriter out = new StringWriter();
			data.solve(new PrintWriter(out));
			return out.toString();
		}

	}

	public void run() {
		try {
			FastReader in = new FastReader(new BufferedReader(new FileReader(
					file + ".in")));
			out = new PrintWriter(file + ".out");

			ScheduledThreadPoolExecutor service = new ScheduledThreadPoolExecutor(
					7);

			int tests = in.nextInt();
			@SuppressWarnings("unchecked")
			Future<String>[] ts = new Future[tests];
			for (int test = 0; test < tests; ++test) {
				ts[test] = service.submit(new Solver(new InputData(in)));
			}
			for (int test = 0; test < tests; ++test) {
				while (!ts[test].isDone()) {
					Thread.sleep(500);
				}
				// System.err.println("Test " + test);
				out.print("Case #" + (test + 1) + ": ");
				System.out.print("Case #" + (test + 1) + ": ");
				out.print(ts[test].get());
				System.out.print(ts[test].get());
			}
			service.shutdown();

			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	static class FastReader {
		public FastReader(BufferedReader in) {
			this.in = in;
			eat("");
		}

		private StringTokenizer st;
		private BufferedReader in;

		void eat(String s) {
			st = new StringTokenizer(s);
		}

		String next() throws IOException {
			while (!st.hasMoreTokens()) {
				String line = in.readLine();
				if (line == null) {
					return null;
				}
				eat(line);
			}
			return st.nextToken();
		}

		int nextInt() throws IOException {
			return Integer.parseInt(next());
		}

		long nextLong() throws IOException {
			return Long.parseLong(next());
		}

		double nextDouble() throws IOException {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new CoinJam().run();
	}

}
