package infiniteHouseOfPancakes;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;

public class InfiniteHouseOfPancakes {

	private final static String SOURCE = "C:\\GCJ\\Infinite_House_of_Pancakes";
	private static BufferedReader br = null;
	private static BufferedWriter bw = null;

	public static void main(String[] args) {
		try {
			br = new BufferedReader(new FileReader(SOURCE + "\\input.txt"));
			bw = new BufferedWriter(new FileWriter(SOURCE + "\\output.txt"));
			int numCasos = Integer.parseInt(br.readLine());
			caso: for (int caso = 0; caso < numCasos; caso++) {
				int diners = Integer.parseInt(br.readLine());
				String platesStr = br.readLine();
				ArrayList<Integer> plates = convertirAArray(platesStr);
				Collections.sort(plates);
				int cantidadMayor = plates.get(plates.size() - 1);
				int calculado = calcular(plates, cantidadMayor, 0);
				escribir("Case #" + (caso + 1) + ": " + calculado);

			}

		} catch (Exception e) {
			System.out.println("Error general");
			e.printStackTrace();
		} finally {
			try {
				br.close();
				bw.close();
			} catch (Exception e) {
			}
		}
	}

	private static int calcular(ArrayList<Integer> plates, int cantidadInicial,
			int movs) {
		Collections.sort(plates);
		int minimaCantidad = plates.get(plates.size() - 1);
		if (minimaCantidad == 1) {
			return cantidadInicial;
		}
		plates.remove(plates.size() - 1);
		int mov1 = minimaCantidad / 2;
		int mov2 = minimaCantidad - mov1;
		plates.add(mov1);
		plates.add(mov2);
		Collections.sort(plates);
		int nuevaCantidadMin = plates.get(plates.size() - 1) + ++movs;
		if (cantidadInicial <= nuevaCantidadMin) {
			return calcular(plates, cantidadInicial, movs);
		} else {
			return calcular(plates, nuevaCantidadMin, movs);
		}
	}

	private static ArrayList<Integer> convertirAArray(String str) {
		ArrayList<Integer> plates = new ArrayList<Integer>();
		str = str.replace(" ", "");
		for (int i = 0; i < str.length(); i++) {
			plates.add(Integer.parseInt(((Character) str.charAt(i)).toString()));
		}
		return plates;
	}

	/**
	 * Escribe en el archivo output.txt
	 */
	private static void escribir(String cadena) {
		try {
			bw.write(cadena + "\r\n");
			System.out.println(cadena);
		} catch (Exception e) {
			System.out.println("Error al escribir");
			e.printStackTrace();
		}
	}

	/**
	 * Convierte una cadena en un ARRAY INT
	 */
	private static int[] aArrayInt(String cadena) {
		String[] arrayStr = cadena.split(" ");
		int[] arrayInt = new int[arrayStr.length];
		int c = 0;
		for (String str : arrayStr) {
			arrayInt[c++] = Integer.parseInt(str);
		}
		return arrayInt;
	}
}
