
import edu.princeton.cs.algs4.StdIn;

public class PancakeFlipper{
    
    private char[] s;
    private int flip_num;
    private int num_steps = 0;
    
    public PancakeFlipper(String S, int K){
        this.s = S.toCharArray();
        this.flip_num = K;
    }
    
    public boolean flippable(){
        int i = 0;
        boolean flipped = true;
        boolean end = false;
                
        while (!end){
            boolean loop = true;
            while (loop && !end) {
                if (s[i] == '-') {
                    for (int j = i; j < i + flip_num; j++){
                        s[j] = flip(s[j]);                                          
                    }
                    loop = false;
                    num_steps += 1;
//                    System.out.println(s);
                }
                i++;
                if (i == s.length-flip_num+1) {end = true;}
            }
        }
        for (int j = s.length - flip_num; j< s.length; j++){
            if (s[j] == '+') {flipped = flipped && true;}
            else {flipped = flipped && false;}
        }
        return flipped;
               
    }
    
    private char flip(char n) {
        if (n=='-') {return '+';}
        return '-';
    }
    
    public int count_steps() {
        return num_steps;
    }
    
    public static void main(String[] args){
        int n = Integer.parseInt(args[0]);
        System.out.println(n);
        String st = StdIn.readLine();
        PancakeFlipper flipper = new PancakeFlipper(st,n);
        boolean flipped = flipper.flippable();
        if (flipped) {
            int steps = flipper.count_steps();
            System.out.println("Number of steps "+ ": " + steps);
        }
        else {System.out.println("Number of steps" + ": IMPOSSIBLE");}
    }
}