

import java.io.*;
import java.util.*;


public class Quality {
    public static final PrintStream out = System.out;
    public static final BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    public int numCases;
    
    long M;
    long F;
    int N;
    long[] P;
    long[] S;
    
    Map<Point,Long> best;
    Set<Point> todo;
    
    public void doCase(int caseNumber) throws Exception {
        {
            String line = in.readLine();
            Scanner scan = new Scanner(line);
            M = scan.nextInt();
            F = scan.nextInt();
            N = scan.nextInt();
        }
        P = new long[N];
        S = new long[N];
        for(int i = 0; i < N; i++) {
            String line = in.readLine();
            Scanner scan = new Scanner(line);
            P[i] = scan.nextInt();
            S[i] = scan.nextInt();
        }
        
        long PutterCheapest = Long.MAX_VALUE;
        for(int i = 0; i < N; i++) {
            if(P[i] < PutterCheapest) PutterCheapest = P[i];
        }
                
        
        best = new HashMap<Quality.Point,Long>();
        best.put(new Point(M-F,0),0L);
        
        todo = new HashSet<Quality.Point>();
        todo.add(new Point(M-F,0));

        long max = 0;
        while(!todo.isEmpty()) {
            Set<Point> oldtodo = todo;
            todo = new HashSet<Quality.Point>();
            
            for(Point point : oldtodo) {
                int cheapest = -1;
                for(int i = 0; i < N; i++) {
                    if(point.daysSinceBought <= S[i] && point.money >= P[i]) {
                        if(cheapest < 0 || P[i] < P[cheapest]) {
                            cheapest = i;
                        }
                    }
                }
                if(cheapest >= 0 && P[cheapest] > PutterCheapest + F) {
                    Point newPoint = new Point(point.money-P[cheapest],point.daysSinceBought+1);
                    Long oldBest = best.get(newPoint);
                    if(oldBest==null || oldBest.longValue() < best.get(point)+1) {
                        best.put(newPoint,best.get(point)+1);
                        if(best.get(point)+1 > max) max = best.get(point)+1;
                        todo.add(newPoint);
                    }
                }
                else {
                    if(point.daysSinceBought>0 && point.money>=F) {
                        Point newPoint = new Point(point.money-F,0);
                        Long oldBest = best.get(newPoint);
                        if(oldBest==null || oldBest.longValue() < best.get(point)) {
                            best.put(newPoint,best.get(point));
                            todo.add(newPoint);
                        }
                    }
                }
            }
        }
        System.out.println(max);
    }
    
    public void run() throws Exception {
        numCases = Integer.parseInt(in.readLine().trim());
        for (int i = 1; i <= numCases; i++) {
            out.print("Case #" + i + ": ");
            doCase(i);
        }
    }
    
    public static void main(String[] args) throws Exception {
        new Quality().run();
    }
    
    static class Point {
        long money, daysSinceBought;
        Point(long r, long c) {
            this.money = r;
            this.daysSinceBought = c;
        }
        @Override
        public int hashCode() {
            final int prime = 31;
            int result = 1;
            result = (int)(prime * result + daysSinceBought);
            result = (int)(prime * result + money);
            return result;
        }
        @Override
        public boolean equals(Object obj) {
            if (this == obj) return true;
            if (obj == null) return false;
            if (getClass() != obj.getClass()) return false;
            Point other = (Point) obj;
            if (daysSinceBought != other.daysSinceBought) return false;
            if (money != other.money) return false;
            return true;
        }
        @Override
        public String toString() {
            return "Point [r=" + money + ", c=" + daysSinceBought + "]";
        }
    }


}
