
import java.io.*;
import java.util.*;

public class SpeakingInTongues {
    public static final PrintStream out = System.out;
    public static final BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    public int numCases;
    
    Map<String,String> mapping = new HashMap<String,String>();
    
    public void doCase(int caseNumber) throws Exception {
        String line = in.readLine();
        //Scanner scan = new Scanner(line);
        String result = translate(line);
        out.println(result);
    }
    
    public void run() throws Exception {
        figureOutMapping();
        
        numCases = Integer.parseInt(in.readLine().trim());
        for (int i = 1; i <= numCases; i++) {
            out.print("Case #" + i + ": ");
            doCase(i);
        }
    }
    
    public String translate(String input) {
        String result = "";
        for (int i = 0; i< input.length(); i++) {
            result += mapping.get(String.valueOf(input.charAt(i)));
        }
        return result;
    }
    
    void figureOutMapping() {
        String input = "ejp mysljylc kd kxveddknmc re jsicpdrysi rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd de kr kd eoya kw aej tysr re ujdr lkgc jv y qee";
        String output = "our language is impossible to understand there are twenty six factorial possibilities so it is okay if you want to just give up a zoo";

        for (int i = 0; i< input.length(); i++) {
            mapping.put(String.valueOf(input.charAt(i)), String.valueOf(output.charAt(i)));
        }
        
        for (char ch = 'a'; ch <= 'z'; ch++) {
            if(mapping.get(String.valueOf(ch))==null) {
                mapping.put(String.valueOf(ch),"q");
                break;
            }
        }
    }
    
    /**
     * @param args
     */
    public static void main(String[] args) throws Exception {
        new SpeakingInTongues().run();
    }

}
