
import java.io.*;
import java.util.*;

public class Mountain {
    public static final PrintStream out = System.out;
    public static final BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    public int numCases;
    
    public void doCase(int caseNumber) throws Exception {
        String line = in.readLine();
        Scanner scan = new Scanner(line);
        int numMountains = scan.nextInt();
        int[] highest = new int[numMountains];
        line = in.readLine();
        scan = new Scanner(line);
        for(int i = 1; i < numMountains; i++) {
            highest[i] = scan.nextInt();
        }
        
        int[] heights = new int[numMountains+1];
        
        boolean impossible = setHeights(heights,1,numMountains,0,highest);
        
        if(impossible) {
            out.println(" Impossible");
        }
        else {
            int min = 0;
            for(int i = 1; i <= numMountains; i++) {
                if(heights[i] < min) min = heights[i];
            }
            for(int i = 1; i <= numMountains; i++) {
                heights[i] += 1-min;
            }
            for(int i = 1; i <= numMountains; i++) {
                out.print(" ");
                out.print(heights[i]);
            }
            out.println();
        }
    }
    
    public boolean setHeights(int[] heights,int start,int end,int slope,int[] highest) {
        if(start==end) return false;
        int myhighest = highest[start];
        if(myhighest > end) return true;
        if(setHeights(heights,myhighest,end,slope,highest)) return true;
        heights[start] = heights[myhighest]-slope*(myhighest-start);
        return(setHeights(heights,start+1,myhighest,slope+1,highest));
    }
    
    public void run() throws Exception {
        numCases = Integer.parseInt(in.readLine().trim());
        for (int i = 1; i <= numCases; i++) {
            out.print("Case #" + i + ":");
            doCase(i);
        }
    }
    
    public static void main(String[] args) throws Exception {
        new Mountain().run();
    }

}
