
import java.io.*;
import java.util.*;

public class Vine {
    public static final PrintStream out = System.out;
    public static final BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    public int numCases;
    
    public void doCase(int caseNumber) throws Exception {
        String line = in.readLine();
        Scanner scan = new Scanner(line);
        
        int N = scan.nextInt();
        int[] dist = new int[N];
        int[] length = new int[N];
        for(int i = 0; i < N; i++) {
            line = in.readLine();
            scan = new Scanner(line);
            dist[i] = scan.nextInt();
            length[i] = scan.nextInt();
        }
        
        line = in.readLine();
        scan = new Scanner(line);
        int D = scan.nextInt();
        
        int[] catchLength = new int[N];
        catchLength[0] = dist[0];
        
        List<Integer> changeList = new ArrayList<Integer>(N);
        changeList.add(0);
        do {
             for(int i : changeList) {
                 if(D - dist[i] <= catchLength[i]) {
                     out.println("YES");
                     return;
                 }
             }
             
             boolean[] newchanged = new boolean[N];
             List<Integer> newChangeList = new ArrayList<Integer>(N);
             for(int i : changeList) {
                 for(int j = i - 1; j>=0; j--) {
                     if(dist[j] < dist[i] - catchLength[i]) break;
                     int newCatchLength = Math.min(length[j],dist[i]-dist[j]);
                     if(newCatchLength > catchLength[j]) {
                         catchLength[j] = newCatchLength;
                         if(!newchanged[j]) {
                             newChangeList.add(j);
                             newchanged[j] = true;
                         }
                     }
                 }
                 for(int j = i + 1; j<N; j++) {
                     if(dist[j] > dist[i] + catchLength[i]) break;
                     int newCatchLength = Math.min(length[j],dist[j]-dist[i]);
                     if(newCatchLength > catchLength[j]) {
                         catchLength[j] = newCatchLength;
                         if(!newchanged[j]) {
                             newChangeList.add(j);
                             newchanged[j] = true;
                         }
                     }
                 }
             }
             
             changeList = newChangeList;
        } while(!changeList.isEmpty());
        
        out.println("NO");
    }
    
    public void run() throws Exception {
        numCases = Integer.parseInt(in.readLine().trim());
        for (int i = 1; i <= numCases; i++) {
            out.print("Case #" + i + ": ");
            doCase(i);
        }
    }
    
    public static void main(String[] args) throws Exception {
        new Vine().run();
    }

}
