package com.g0531.b;

import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.StringTokenizer;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

public class Test {

	// private static final String TASK = "sample";
	private static final String TASK = "B-small-attempt3";
	// private static final String TASK = "A-small-attempt2";
	// private static final String TASK = "A-large";

	int n;
	ArrayList<Long> alist = new ArrayList<Long>();

	public Test(InputReader reader) throws IOException {
		n = reader.nextInt();
		for (int i = 0; i < n; i ++){
			long tmp = reader.nextLong();
			alist.add(tmp);
		}
	}

	private String solve() throws Exception {
		int count = 0;
		boolean flag = true;
		while(alist.size() > 0) {
			long a = Long.MAX_VALUE;
			int aIndex = 0;
			for (int i = 0; i < alist.size(); i++){
				if (alist.get(i) < a) {
					a = alist.get(i);
					aIndex = i;
				}
			}
			int b = alist.size() - 1 - aIndex;
			int c = aIndex;
			if (b < c) {
				count += b;
			} else {
				count += c;
			}
			alist.remove(aIndex);
		}
		
		return "" + count;
	}
	
	private void swap (ArrayList<Long> list, int a) {
		long x = list.remove(a);
		long y = list.remove(a);
		list.add(a, x);
		list.add(a, y);
	}
	
	public static void main(String[] args) throws Exception {
		String directory = new File("src\\"
			+ Test.class.getPackage().getName().replace(".", "/")).getAbsolutePath() +
			"\\";
		String inName = directory + TASK + ".in";
		String outName = directory + TASK + ".out";

		try (InputReader reader = new InputReader(inName);
				OutputWriter writer = new OutputWriter(outName)) {
			ExecutorService executorService = Executors.newFixedThreadPool(1); // TODO

			int testCaseN = reader.nextInt();
			final String[] result = new String[testCaseN];
			for (int i = 0; i < testCaseN; i++) {
				final Test test = new Test(reader);
				final int ii = i;
				executorService.submit(new Runnable() {
					@Override
					public void run() {
						try {
							result[ii] = test.solve();
						} catch (Exception e) {
							e.printStackTrace();
							System.out.println("failure :: " + ii);
							throw new RuntimeException("failure :: " + ii, e);
						}
					}
				});
			}
			executorService.shutdown();
			executorService.awaitTermination(10, TimeUnit.MINUTES);

			for (int i = 0; i < testCaseN; i++) {
				writer.println("Case #" + (i + 1) + ": " + result[i]);
				if (result[i] == null) {
					System.out.println("failure : " + i);
					throw new RuntimeException("failure : " + i);
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("FileNotFound : " + e.getMessage());
		}
	}
	
	/** Utility **/
	public static class InputReader implements AutoCloseable {
		private final BufferedReader reader;
		private StringTokenizer tokenizer = new StringTokenizer("");
		public InputReader(String filename) throws FileNotFoundException {
			this.reader = new BufferedReader(new FileReader(filename));
		}
		public String nextToken() throws IOException {
			while (!tokenizer.hasMoreTokens()) {
				tokenizer = new StringTokenizer(reader.readLine());
			}
			return tokenizer.nextToken();
		}
		public int nextInt() throws IOException {
			return Integer.parseInt(nextToken());
		}
		public long nextLong() throws IOException {
			return Long.parseLong(nextToken());
		}
		public double nextDouble() throws IOException {
			return Double.parseDouble(nextToken());
		}
		public String nextString() throws IOException {
			return nextToken();
		}
		@Override
		public void close() throws Exception {
			reader.close();
		}
	}
	
	public static class OutputWriter implements AutoCloseable {
		private final PrintWriter writer;
		public OutputWriter(String file) throws FileNotFoundException {
			writer = new PrintWriter(file);
		}
		public void println(String str) {
			System.out.println(str);
			writer.println(str);
		}
		@Override
		public void close() throws Exception {
			writer.close();
		}
	}
	
}
