

import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Writer;
import java.util.InputMismatchException;
import java.util.StringTokenizer;

public class Main {
	public static final String PATH = "src/y2017/r0/a/";
	public static final String INPUT = PATH + "A-small-attempt0.in";
	public static final String OUTPUT = PATH + "output.txt";

	public static void main(String[] args) throws FileNotFoundException {
		InputStream inputStream = new FileInputStream(INPUT);
		OutputStream outputStream = new FileOutputStream(OUTPUT);
		InputReader in = new InputReader(inputStream);
		OutputWriter out = new OutputWriter(outputStream);
		Task solver = new Task();
		solver.solve(1, in, out);
		out.close();
	}
}

class Task {
	private char[] arr;
	private int t;
	private int k;
	private int len;
	private int cnt;

	public void solve(int testNumber, InputReader in, OutputWriter out) {
		t = in.nextInt();
		for (int testCase = 1; testCase <= t; testCase++) {
			out.print("Case #" + testCase + ": ");
			arr = in.next().toCharArray();
			k = in.nextInt();
			len = arr.length;
			cnt = 0;
			for (int i = 0; i <= len - k; i++) {
				if (arr[i] == '-') {
					cnt++;
					for (int j = i; j < i + k; j++) {
						arr[j] = arr[j] == '+' ? '-' : '+';
					}
				}
			}
			boolean isPossible = true;
			for (int i = len - k + 1; i < len; i++) {
				if (arr[i] == '-') {
					isPossible = false;
					break;
				}
			}
			if (isPossible) {
				out.print(cnt);
			} else {
				out.print("IMPOSSIBLE");
			}
			out.println();
		}
	}
}

class InputReader {
	private InputStream stream;
	private StringTokenizer st;
	private byte[] buf = new byte[1024];
	private int curChar;
	private int numChars;

	public InputReader(InputStream stream) {
		this.stream = stream;
	}

	public int read() {
		if (numChars == -1) {
			throw new InputMismatchException();
		} else {
			if (curChar >= numChars) {
				curChar = 0;
				try {
					numChars = stream.read(buf);
				} catch (IOException var2) {
					throw new InputMismatchException();
				}
				if (numChars <= 0) {
					return -1;
				}
			}
			return buf[curChar++];
		}
	}

	public boolean isSpace(int c) {
		return c == 10 || c == 13 || c == -1 || c == 9 || c == 32;
	}

	private boolean isEnd(int c) {
		return c == 10 || c == 13 || c == -1;
	}

	public String next() {
		int c = this.read();
		while (isSpace(c)) {
			c = this.read();
		}
		StringBuilder res = new StringBuilder();
		do {
			res.appendCodePoint(c);
		} while (!isSpace(c = this.read()));
		return res.toString();
	}

	public int nextInt() {
		int c = this.read();
		while (isSpace(c)) {
			c = this.read();
		}
		byte sgn = 1;
		if (c == 45) {
			sgn = -1;
			c = this.read();
		}
		int res = 0;
		while (c >= 48 && c <= 57) {
			res *= 10;
			res += c - 48;
			c = this.read();
			if (isSpace(c)) {
				return res * sgn;
			}
		}
		throw new InputMismatchException();
	}

	public String nextLine() {
		int c = read();
		while (isEnd(c)) {
			c = this.read();
		}
		StringBuilder res = new StringBuilder();
		do {
			res.appendCodePoint(c);
		} while (!isEnd(c = this.read()));
		return res.toString();
	}

	public long nextLong() {
		int c = read();
		while (isSpace(c))
			c = read();
		int sgn = 1;
		if (c == '-') {
			sgn = -1;
			c = read();
		}
		long res = 0;
		do {
			if (c < '0' || c > '9')
				throw new InputMismatchException();
			res *= 10;
			res += c - '0';
			c = read();
		} while (!isSpace(c));
		return res * sgn;
	}

	public String[] nextArray() {
		st = new StringTokenizer(this.nextLine());
		int cnt = st.countTokens();
		int idx = 0;
		String[] arr = new String[cnt];
		while (st.hasMoreTokens()) {
			arr[idx++] = st.nextToken();
		}
		return arr;
	}

	public String[] nextArray(int size) {
		String[] arr = new String[size];
		for (int i = 0; i < size; i++) {
			arr[i] = this.next();
		}
		return arr;
	}

	public int[] nextIntArray() {
		st = new StringTokenizer(this.nextLine());
		int cnt = st.countTokens();
		int idx = 0;
		int[] arr = new int[cnt];
		while (st.hasMoreTokens()) {
			arr[idx++] = Integer.parseInt(st.nextToken());
		}
		return arr;
	}

	public int[] nextIntArray(int size) {
		int[] arr = new int[size];
		for (int i = 0; i < size; i++) {
			arr[i] = this.nextInt();
		}
		return arr;
	}

	public long[] nextLongArray() {
		st = new StringTokenizer(this.nextLine());
		int cnt = st.countTokens();
		int idx = 0;
		long[] arr = new long[cnt];
		while (st.hasMoreTokens()) {
			arr[idx++] = this.nextLong();
		}
		return arr;
	}

	public long[] nextLongArray(int n) {
		long[] arr = new long[n];
		for (int i = 0; i < n; i++) {
			arr[i] = nextLong();
		}
		return arr;
	}

}

class OutputWriter {
	private final PrintWriter writer;

	public OutputWriter(OutputStream outputStream) {
		writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
	}

	public OutputWriter(Writer writer) {
		this.writer = new PrintWriter(writer);
	}

	public void print(char c) {
		writer.print(c);
	}

	public void print(int i) {
		writer.print(i);
	}

	public void print(long l) {
		writer.print(l);
	}

	public void print(double d) {
		writer.print(d);
	}

	public void print(String s) {
		writer.print(s);
	}

	public void print(int... integers) {
		int len = integers.length;
		for (int i = 0; i < len; i++) {
			writer.print(integers[i]);
		}
	}

	public void print(char delim, int... integers) {
		int len = integers.length;
		for (int i = 0; i < len; i++) {
			if (i != 0) {
				writer.print(delim);
			}
			writer.print(integers[i]);
		}
	}

	public void print(char... chars) {
		int len = chars.length;
		for (int i = 0; i < len; i++) {
			writer.print(chars[i]);
		}
	}

	public void print(char delim, char... chars) {
		int len = chars.length;
		for (int i = 0; i < len; i++) {
			if (i != 0) {
				writer.print(delim);
			}
			writer.print(chars[i]);
		}
	}

	public void print(Object... objects) {
		int len = objects.length;
		for (int i = 0; i < len; i++) {
			writer.print(objects[i]);
		}
	}

	public void print(char delim, Object... objects) {
		int len = objects.length;
		for (int i = 0; i < len; i++) {
			if (i != 0) {
				writer.print(delim);
			}
			writer.print(objects[i]);
		}
	}

	public void println() {
		writer.println();
	}

	public void close() {
		writer.close();
	}
}