import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Writer;
import java.util.InputMismatchException;
import java.util.StringTokenizer;

public class Main {
	public static final String PATH = "src/y2017/r1a/a/";
	public static final String INPUT = PATH + "A-small.in";
	public static final String INPUT2 = PATH + "A-large.in";
	public static final String OUTPUT = PATH + "output.txt";
	public static final String OUTPUT2 = PATH + "output2.txt";

	public static void main(String[] args) throws FileNotFoundException {
		// InputStream inputStream = new FileInputStream(INPUT2);
		// OutputStream outputStream = new FileOutputStream(OUTPUT2);
		InputStream inputStream = System.in;
		OutputStream outputStream = System.out;
		InputReader in = new InputReader(inputStream);
		OutputWriter out = new OutputWriter(outputStream);
		Task solver = new Task();
		int t = in.nextInt();
		for (int i = 1; i <= t; i++) {
			solver.solve(i, in, out);
		}
		out.close();
	}
}

class Task {
	private char[][] arr;
	private boolean[] isFull;
	private int nR;
	private int nC;

	public void solve(int testNumber, InputReader in, OutputWriter out) {
		out.print("Case #" + testNumber + ":");
		out.println();
		nR = in.nextInt();
		nC = in.nextInt();
		arr = new char[nR][nC];
		isFull = new boolean[nR];
		for (int i = 0; i < nR; i++) {
			String line = in.next();
			int start = -1;
			int end = -1;
			for (int j = 0; j < nC; j++) {
				arr[i][j] = line.charAt(j);
				if (arr[i][j] != '?') {
					if (start == -1) {
						start = j;
					}
					end = j;
				}
			}
			if (start == -1) {
				continue;
			}
			for (int j = 0; j < start; j++) {
				arr[i][j] = arr[i][start];
			}
			for (int j = start + 1; j <= end; j++) {
				if (arr[i][j] == '?') {
					arr[i][j] = arr[i][j - 1];
				}
			}
			for (int j = end + 1; j < nC; j++) {
				arr[i][j] = arr[i][end];
			}
			isFull[i] = true;
		}
		for (int i = 0; i < nR; i++) {
			if (isFull[i]) {
				for (int j = i - 1; j >= 0; j--) {
					if (isFull[j]) {
						break;
					}
					for (int k = 0; k < nC; k++) {
						arr[j][k] = arr[i][k];
					}
					isFull[j] = true;
				}
				for (int j = i + 1; j < nR; j++) {
					if (isFull[j]) {
						break;
					}
					for (int k = 0; k < nC; k++) {
						arr[j][k] = arr[i][k];
					}
					isFull[j] = true;
				}
			}
		}
		for (int i = 0; i < nR; i++) {
			for (int j = 0; j < nC; j++) {
				out.print(arr[i][j]);
			}
			out.println();
		}
	}
}

class InputReader {
	private InputStream stream;
	private StringTokenizer st;
	private byte[] buf = new byte[1024];
	private int curChar;
	private int numChars;

	public InputReader(InputStream stream) {
		this.stream = stream;
	}

	public int read() {
		if (numChars == -1) {
			throw new InputMismatchException();
		} else {
			if (curChar >= numChars) {
				curChar = 0;
				try {
					numChars = stream.read(buf);
				} catch (IOException var2) {
					throw new InputMismatchException();
				}
				if (numChars <= 0) {
					return -1;
				}
			}
			return buf[curChar++];
		}
	}

	public boolean isSpace(int c) {
		return c == 10 || c == 13 || c == -1 || c == 9 || c == 32;
	}

	private boolean isEnd(int c) {
		return c == 10 || c == 13 || c == -1;
	}

	public String next() {
		int c = this.read();
		while (isSpace(c)) {
			c = this.read();
		}
		StringBuilder res = new StringBuilder();
		do {
			res.appendCodePoint(c);
		} while (!isSpace(c = this.read()));
		return res.toString();
	}

	public int nextInt() {
		int c = this.read();
		while (isSpace(c)) {
			c = this.read();
		}
		byte sgn = 1;
		if (c == 45) {
			sgn = -1;
			c = this.read();
		}
		int res = 0;
		while (c >= 48 && c <= 57) {
			res *= 10;
			res += c - 48;
			c = this.read();
			if (isSpace(c)) {
				return res * sgn;
			}
		}
		throw new InputMismatchException();
	}

	public long nextLong() {
		int c = this.read();
		while (isSpace(c)) {
			c = this.read();
		}
		byte sgn = 1;
		if (c == 45) {
			sgn = -1;
			c = this.read();
		}
		long res = 0;
		while (c >= 48 && c <= 57) {
			res *= 10;
			res += c - 48;
			c = this.read();
			if (isSpace(c)) {
				return res * sgn;
			}
		}
		throw new InputMismatchException();
	}

	public String nextLine() {
		int c = read();
		while (isEnd(c)) {
			c = this.read();
		}
		StringBuilder res = new StringBuilder();
		do {
			res.appendCodePoint(c);
		} while (!isEnd(c = this.read()));
		return res.toString();
	}

	public String[] nextArray() {
		st = new StringTokenizer(this.nextLine());
		int cnt = st.countTokens();
		int idx = 0;
		String[] arr = new String[cnt];
		while (st.hasMoreTokens()) {
			arr[idx++] = st.nextToken();
		}
		return arr;
	}

	public String[] nextArray(int size) {
		String[] arr = new String[size];
		for (int i = 0; i < size; i++) {
			arr[i] = this.next();
		}
		return arr;
	}

	public int[] nextIntArray() {
		st = new StringTokenizer(this.nextLine());
		int cnt = st.countTokens();
		int idx = 0;
		int[] arr = new int[cnt];
		while (st.hasMoreTokens()) {
			arr[idx++] = Integer.parseInt(st.nextToken());
		}
		return arr;
	}

	public int[] nextIntArray(int size) {
		int[] arr = new int[size];
		for (int i = 0; i < size; i++) {
			arr[i] = this.nextInt();
		}
		return arr;
	}

	public long[] nextLongArray() {
		st = new StringTokenizer(this.nextLine());
		int cnt = st.countTokens();
		int idx = 0;
		long[] arr = new long[cnt];
		while (st.hasMoreTokens()) {
			arr[idx++] = this.nextLong();
		}
		return arr;
	}

	public long[] nextLongArray(int n) {
		long[] arr = new long[n];
		for (int i = 0; i < n; i++) {
			arr[i] = nextLong();
		}
		return arr;
	}

}

class OutputWriter {
	private final PrintWriter writer;

	public OutputWriter(OutputStream outputStream) {
		writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
	}

	public OutputWriter(Writer writer) {
		this.writer = new PrintWriter(writer);
	}

	public void print(char c) {
		writer.print(c);
	}

	public void print(int i) {
		writer.print(i);
	}

	public void print(String s) {
		writer.print(s);
	}

	public void print(int... integers) {
		int len = integers.length;
		for (int i = 0; i < len; i++) {
			writer.print(integers[i]);
		}
	}

	public void print(char delim, int... integers) {
		int len = integers.length;
		for (int i = 0; i < len; i++) {
			if (i != 0) {
				writer.print(delim);
			}
			writer.print(integers[i]);
		}
	}

	public void print(char... chars) {
		int len = chars.length;
		for (int i = 0; i < len; i++) {
			writer.print(chars[i]);
		}
	}

	public void print(char delim, char... chars) {
		int len = chars.length;
		for (int i = 0; i < len; i++) {
			if (i != 0) {
				writer.print(delim);
			}
			writer.print(chars[i]);
		}
	}

	public void print(Object... objects) {
		int len = objects.length;
		for (int i = 0; i < len; i++) {
			writer.print(objects[i]);
		}
	}

	public void print(char delim, Object... objects) {
		int len = objects.length;
		for (int i = 0; i < len; i++) {
			if (i != 0) {
				writer.print(delim);
			}
			writer.print(objects[i]);
		}
	}

	public void println() {
		writer.println();
	}

	public void close() {
		writer.close();
	}
}