import java.io.File;
import java.io.FileNotFoundException;
import java.math.BigInteger;
import java.util.Formatter;
import java.util.Scanner;

public class A {

	public String inFile;
	public String outFile;
	public static final String folder = "/Users/Aarthie/Desktop/thesis/CodeJam/";
	
	private Formatter outFileFormatter;
	private Scanner inFileScanner;
	private int caseNumber;
	
	public A() {
		super();
		caseNumber = 0;
		//inFile = folder + "A-large.in";
		inFile = folder + "A-small-attempt0.in";
		outFile = folder + "output.txt";
		openFiles();
		logic();
		closeFiles();
	}

	// -------------------------------------- LOGIC 
	private void logic() {
		String word = inFileScanner.next();
		int numTests = Integer.parseInt(word);
		for(int i=0; i<numTests; i++) {
			word = inFileScanner.next();
			BigInteger r = new BigInteger(word);
			word = inFileScanner.next();
			BigInteger t = new BigInteger(word);
			
			BigInteger one = BigInteger.valueOf(1L);
			BigInteger two = BigInteger.valueOf(2L);
			BigInteger three = BigInteger.valueOf(3L);
			BigInteger eight = BigInteger.valueOf(8L);
			BigInteger four = BigInteger.valueOf(4L);
			
			BigInteger b = r.multiply(two).add(three);
			BigInteger bSquared = b.multiply(b);
			
			BigInteger sqArgs = bSquared.add(
					eight.multiply(r.multiply(two).add(one).add(t.negate())).negate());
			
			BigInteger sqRoot = bigIntSqRootFloor(sqArgs);
			BigInteger result = sqRoot.add(b.negate()).divide(four).add(one);
					
			String caseString = result.toString();

			this.addLine(caseString);
		}
	}

	// -------------------------------------- FILE HANDLING 
	public void openFiles() {
		try {
			inFileScanner = new Scanner(new File(inFile));
			outFileFormatter = new Formatter(outFile);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			throw new IllegalStateException("file open error");
		}
	}
	
	public void addLine(String line) {
		caseNumber++;
		outFileFormatter.format("Case #%d: %s\n", caseNumber, line);
	}
	
	public void closeFiles() {
		inFileScanner.close();
		outFileFormatter.close();
	}
	
	public static BigInteger bigIntSqRootFloor(BigInteger x)
	        throws IllegalArgumentException {
	    if (x.compareTo(BigInteger.ZERO) < 0) {
	        throw new IllegalArgumentException("Negative argument.");
	    }
	    // square roots of 0 and 1 are trivial and
	    // y == 0 will cause a divide-by-zero exception
	    if (x == BigInteger.ZERO || x == BigInteger.ONE) {
	        return x;
	    } // end if
	    BigInteger two = BigInteger.valueOf(2L);
	    BigInteger y;
	    // starting with y = x / 2 avoids magnitude issues with x squared
	    for (y = x.divide(two);
	            y.compareTo(x.divide(y)) > 0;
	            y = ((x.divide(y)).add(y)).divide(two));
	    return y;
	} // end bigIntSqRootFloor

	// -------------------------------------- MAIN 
	public static void main(String[] args) {
		new A();
		System.out.println("Done");
	}

}
