import java.io.File;
import java.io.FileNotFoundException;
import java.util.Formatter;
import java.util.Scanner;

public class B {

	public String inFile;
	public String outFile;
	public static final String folder = "/Users/Aarthie/Desktop/thesis/CodeJam/";
	
	private Formatter outFileFormatter;
	private Scanner inFileScanner;
	private int caseNumber;
	
	public B() {
		super();
		caseNumber = 0;
		//inFile = folder + "A-large.in";
		inFile = folder + "B-small-attempt5.in";
		outFile = folder + "output.txt";
		openFiles();
		logic();
		closeFiles();
	}

	// -------------------------------------- LOGIC 
	private void logic() {
		String word = inFileScanner.next();
		int numTests = Integer.parseInt(word);
		for(int i=0; i<numTests; i++) {
			word = inFileScanner.next();
			int numRows = Integer.parseInt(word);
			word = inFileScanner.next();
			int numCols = Integer.parseInt(word);
			String caseString = "YES";
			int[][] grid = new int[numRows][numCols];
			for(int row=0; row<numRows; row++) {
				for(int col=0; col<numCols; col++) {
					word = inFileScanner.next();
					grid[row][col] = Integer.parseInt(word);
				}
			}

			for(int row=0; row<numRows; row++) {
				boolean possible;
				for(int col=0; col<numCols; col++) {
					possible = check(grid, row, col, numRows, numCols);
					if(!possible)
						caseString = "NO";
				}
			}

			this.addLine(caseString);
		}
	}
	
	private boolean check(int[][] grid, int row, int col, int numRows, int numCols) {
		int curHeight = grid[row][col];
		boolean possible = true;
		
		for(int x=0; x<numRows; x++)
			possible &= (curHeight >= grid[x][col]);
		if(possible)
			return true;
		
		possible = true;
		for(int x=0; x<numCols; x++) 
			possible &= (curHeight >= grid[row][x]);
				
		return possible;
	}

	// -------------------------------------- FILE HANDLING 
	public void openFiles() {
		try {
			inFileScanner = new Scanner(new File(inFile));
			outFileFormatter = new Formatter(outFile);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			throw new IllegalStateException("file open error");
		}
	}
	
	public void addLine(String line) {
		caseNumber++;
		outFileFormatter.format("Case #%d: %s\n", caseNumber, line);
	}
	
	public void closeFiles() {
		inFileScanner.close();
		outFileFormatter.close();
	}

	// -------------------------------------- MAIN 
	public static void main(String[] args) {
		new B();
		System.out.println("Done");
	}

}
