package edu.vk;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Formatter;
import java.util.Scanner;

public class CodeJam {

	public String inFile;
	public String outFile;
	public static final String folder = "/Users/Aarthie/Desktop/thesis/CodeJam/";
	
	private Formatter outFileFormatter;
	private Scanner inFileScanner;
	private int caseNumber;
	
	public CodeJam() {
		super();
		caseNumber = 0;
		inFile = folder + "A-small-attempt0.in";
		outFile = folder + "output.txt";
		openFiles();
		logic();
		closeFiles();
	}

	// -------------------------------------- LOGIC 
	private void logic() {
		while(inFileScanner.hasNext()) {
			String word = inFileScanner.next();
			int numTests = Integer.parseInt(word);
			for(int i=0; i<numTests; i++) {
				String caseString = null;
				int[][] xArray = new int[4][4];
				int[][] oArray = new int[4][4];
				boolean inComplete = false;
				for(int row=0; row<4; row++) {
					word = inFileScanner.next();
					for(int col=0; col<4; col++) {
						String character = word.substring(3-col, 4-col);
						if(character.equalsIgnoreCase("x") || character.equalsIgnoreCase("t"))
							xArray[row][col] = 1;
						if(character.equalsIgnoreCase("o") || character.equalsIgnoreCase("t"))
							oArray[row][col] = 1;
						if(character.equalsIgnoreCase("."))
							inComplete = true;
					}
				}
				// sum rows
				for(int row=0; row<4; row++) {
					int xSum = 0;
					int oSum = 0;
					for(int col=0; col<4; col++) {
						xSum += xArray[row][col];
						oSum += oArray[row][col];
					}
					if(xSum == 4) {
						caseString = "X won";
						break;
					}
					else if(oSum == 4) {
						caseString = "O won";
						break;
					}
				}
				// sum columns
				if(caseString == null) {
					for(int col=0; col<4; col++) {
						int xSum = 0;
						int oSum = 0;
						for(int row=0; row<4; row++) {
							xSum += xArray[row][col];
							oSum += oArray[row][col];
						}
						if(xSum == 4) {
							caseString = "X won";
							break;
						}
						else if(oSum == 4) {
							caseString = "O won";
							break;
						}
					}
				}
				
				if(caseString == null) {
					if((xArray[0][0] + xArray[1][1] + xArray[2][2] + xArray[3][3]) == 4 || 
							(xArray[0][3] + xArray[1][2] + xArray[2][1] + xArray[3][0]) == 4)
						caseString = "X won";
					else if((oArray[0][0] + oArray[1][1] + oArray[2][2] + oArray[3][3]) == 4 || 
							(oArray[0][3] + oArray[1][2] + oArray[2][1] + oArray[3][0]) == 4)
						caseString = "O won";
					else if(inComplete)
						caseString = "Game has not completed";
					else
						caseString = "Draw";
				}
				
				this.addLine(caseString);
			}
		}
	}
	
	// -------------------------------------- FILE HANDLING 
	public void openFiles() {
		try {
			inFileScanner = new Scanner(new File(inFile));
			outFileFormatter = new Formatter(outFile);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			throw new IllegalStateException("file open error");
		}
	}
	
	public void addLine(String line) {
		caseNumber++;
		outFileFormatter.format("Case #%d: %s\n", caseNumber, line);
	}
	
	public void closeFiles() {
		inFileScanner.close();
		outFileFormatter.close();
	}

	// -------------------------------------- MAIN 
	public static void main(String[] args) {
		new CodeJam();
	}

}
