import java.io.File;
import java.io.FileNotFoundException;
import java.util.Formatter;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class A {

	public String inFile;
	public String outFile;
	public static final String folder = "/Users/Aarthie/Desktop/thesis/CodeJam/round1c/";
	
	private Formatter outFileFormatter;
	private Scanner inFileScanner;
	private int caseNumber;
	
	public A() {
		super();
		caseNumber = 0;
		//inFile = folder + "A-large.in";
		inFile = folder + "A-small-attempt1.in";
		outFile = folder + "output.txt";
		openFiles();
		logic();
		closeFiles();
	}

	// -------------------------------------- LOGIC 
	private void logic() {
		String word = inFileScanner.next();
		int numTests = Integer.parseInt(word);
		for(int i=0; i<numTests; i++) {
			String name = inFileScanner.next();
			word = inFileScanner.next();
			int n = Integer.valueOf(word);
			String patternString = "(b|c|d|f|g|h|j|k|l|m|n|p|q|" +
					"r|s|t|v|w|x|y|z){%d,%d}";
			patternString = String.format(patternString, n, n);
			Pattern pattern = Pattern.compile(patternString);

		    Matcher matcher = pattern.matcher(name);
		    int count = 0;
		    while (matcher.find()) {
			    int strLen = name.length();
		    	int index = matcher.start();
		    	count += (index+1)*(strLen - matcher.end() + 1);
		    	name = name.substring(index+1);
		    	matcher = pattern.matcher(name);
		    }
			String caseString = Integer.toString(count);

			this.addLine(caseString);
		}
	}

	// -------------------------------------- FILE HANDLING 
	public void openFiles() {
		try {
			inFileScanner = new Scanner(new File(inFile));
			outFileFormatter = new Formatter(outFile);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			throw new IllegalStateException("file open error");
		}
	}
	
	public void addLine(String line) {
		caseNumber++;
		outFileFormatter.format("Case #%d: %s\n", caseNumber, line);
	}
	
	public void closeFiles() {
		inFileScanner.close();
		outFileFormatter.close();
	}
	
	// -------------------------------------- MAIN 
	public static void main(String[] args) {
		new A();
		System.out.println("Done");
	}

}
