import java.io.File;
import java.io.FileNotFoundException;
import java.util.Formatter;
import java.util.Scanner;

public class B {

	public String inFile;
	public String outFile;
	public static final String folder = "/Users/Aarthie/Desktop/codejam2014/";
	
	private Formatter outFileFormatter;
	private Scanner inFileScanner;
	private int caseNumber;
	
	private double cost;
	private double rate;
	private double goal;
	
	public B() {
		super();
		caseNumber = 0;
		inFile = folder + "B/B-small-attempt0.in";
		outFile = inFile + ".out";
		openFiles();
		solve();
		closeFiles();
	}

	// -------------------------------------- LOGIC 
	private void solve() {
		String word = inFileScanner.next();
		int numTests = Integer.parseInt(word);
		for(int i=0; i<numTests; i++) {
			word = inFileScanner.next();
			this.cost = Double.parseDouble(word);
			word = inFileScanner.next();
			this.rate = Double.parseDouble(word);
			word = inFileScanner.next();
			this.goal = Double.parseDouble(word);
			double currentRate = 2;
			double time = calcTime(currentRate);
			this.addLine(String.format("%.7f", time));
		}
	}
	
	private double calcTime(double currentRate) {
		double time1 = this.goal / currentRate;
		double timeToGetFarm = this.cost/currentRate;
		double newRate = currentRate + this.rate;
		if(timeToGetFarm + this.goal/newRate < time1) {
			double time2 = timeToGetFarm + calcTime(newRate);
			return Math.min(time1, time2);
		}
		return time1;
	}

	// -------------------------------------- FILE HANDLING 
	public void openFiles() {
		try {
			inFileScanner = new Scanner(new File(inFile));
			outFileFormatter = new Formatter(outFile);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			throw new IllegalStateException("file open error");
		}
	}
	
	public void addLine(String line) {
		caseNumber++;
		outFileFormatter.format("Case #%d: %s\n", caseNumber, line);
	}
	
	public void closeFiles() {
		inFileScanner.close();
		outFileFormatter.close();
	}

	// -------------------------------------- MAIN 
	public static void main(String[] args) {
		new B();
		System.out.println("Done");
	}

}
