import java.io.File;
import java.io.FileNotFoundException;
import java.util.Formatter;
import java.util.Scanner;

public class C {

	public String inFile;
	public String outFile;
	public static final String folder = "/Users/Aarthie/Desktop/thesis/CodeJam/";
	
	private Formatter outFileFormatter;
	private Scanner inFileScanner;
	private int caseNumber;
	
	public C() {
		super();
		caseNumber = 0;
		inFile = folder + "C-small-attempt0.in";
		outFile = folder + "output.txt";
		openFiles();
		logic();
		closeFiles();
	}

	// -------------------------------------- LOGIC 
	private void logic() {
		String word = inFileScanner.next();
		int numTests = Integer.parseInt(word);
		for(int i=0; i<numTests; i++) {
			word = inFileScanner.next();
			int low = Integer.parseInt(word);
			word = inFileScanner.next();
			int high = Integer.parseInt(word);
			int count = 0;
			for(int j=(int) Math.ceil(Math.sqrt(low)); 
					j<=(int) Math.floor(Math.sqrt(high)); j++) {
				if(palindrome(j))
					if(palindrome(j*j))
						count++;
			}
			String caseString = Integer.toString(count);
			this.addLine(caseString);
		}
	}
	
	private boolean palindrome(int i) {
		if(i<10)
			return true;
		int trailingInt = i % 10;
		String number = Integer.toString(i);
		int leadingInt = Integer.parseInt(number.substring(0,1));
		if(trailingInt != leadingInt)
			return false;
		
		int length = number.length();
		int j = (int) (leadingInt*Math.pow(10, length));
		j = (i - j)/10;
		return palindrome(j);
	}

	// -------------------------------------- FILE HANDLING 
	public void openFiles() {
		try {
			inFileScanner = new Scanner(new File(inFile));
			outFileFormatter = new Formatter(outFile);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			throw new IllegalStateException("file open error");
		}
	}
	
	public void addLine(String line) {
		caseNumber++;
		outFileFormatter.format("Case #%d: %s\n", caseNumber, line);
	}
	
	public void closeFiles() {
		inFileScanner.close();
		outFileFormatter.close();
	}

	// -------------------------------------- MAIN 
	public static void main(String[] args) {
		new C();
		System.out.println("Done");
	}

}
