import java.util.HashMap;
import java.util.Scanner;
import java.io.File;

public class GoogleReseDecoder
 {
 	
 	HashMap<String,String> map; 
 	
 	public GoogleReseDecoder()
 	{
 	   map  = new HashMap<String,String>();
 	   
 	   // initialize known values
 	   map.put("y","a");
 	   map.put("q","z");
 	   map.put("e","o");
 	   
 	   // initialize manually found values by analyzing sample input
 	   
 	   map.put("a","y");
 	   map.put("b","h");
 	   map.put("c","e");
 	   map.put("d","s");
 	   map.put("f","c");
 	   map.put("g","v");
 	   map.put("h","x");
 	   map.put("i","d");
 	   map.put("j","u");
 	   map.put("k","i");
 	   map.put("l","g");
 	   map.put("m","l");
 	   map.put("n","b");
 	   map.put("o","k");
 	   map.put("p","r");
 	   map.put("r","t");
 	   map.put("s","n");
 	   map.put("t","w");
 	   map.put("u","j");
 	   map.put("v","p");
 	   map.put("w","f");
 	   map.put("x","m");
 	   map.put("z","q");
 	   
 	   map.put(" "," ");
 	   	
 	}
 	
 	public void decodeInputFile(String fileName) throws Exception
 	{
 	   Scanner fileScanner = new Scanner (new File (fileName) ); 	
 	   
 	   String line;
 	   
 	   line = fileScanner.nextLine();
 //	   System.out.println("line = "+line);
 	   
 	   int numberOfTestCases = Integer.parseInt(line.trim());
 	   
 	   
 	   
 	   for(int i = 1; i<= numberOfTestCases ; i++)
 	    {
 	       line = fileScanner.nextLine();	
 	       
 	        //System.out.println("line = "+line);
 	       
 	       System.out.print("Case #"+i+": ");	
 	       
 	       for(int j = 0; j<line.length(); j++)
 	        {
 	           String code = line.substring(j,j+1);
 	     //      System.out.print("code = "+code);
 	           String translation = map.get(code);
 	           System.out.print(translation);
 	        }
 	       System.out.println();	
 	    }
 	   
 	}
 	
    public static void main(String[] args) throws Exception
     { 
     	GoogleReseDecoder GRD = new GoogleReseDecoder();
     	String inputFileName = "A-small-attempt0.in";
     	
     	GRD.decodeInputFile(inputFileName);
     } 	
 }