package trie;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Trie {

    public static int N, M;
    public static String[] S = new String[8];
    public static List<Set<String>> servers;
    public static Scanner s;
    public static Writer w;

    public static void main(String[] args) {
        try {
            s = new Scanner(new BufferedReader(new FileReader("D-small-attempt0.in")));
//            s = new Scanner(System.in);
            w = new BufferedWriter(new FileWriter("D-small-attempt0.out"));

            s.useLocale(Locale.US);

            int T = s.nextInt();
            for (int t = 0; t < T; ++t) {
                process();
                out("Case #" + (t + 1) + ": " + most + " " + poss + "\n");
            }
            w.flush();
            w.close();
            s.close();
        } catch (IOException ex) {
            Logger.getLogger(Trie.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private static void process() {
        M = s.nextInt();
        N = s.nextInt();
        for (int i = 0; i < M; ++i) {
            S[i] = s.next();
        }
        servers = new ArrayList<>();
        for (int i = 0; i < N; ++i) {
            servers.add(new HashSet<>());
        }

        most = poss = 0;
        verteilen(0, 0);
    }

    static int most, poss;

    public static void verteilen(int k, int nodes) {
//        System.out.println("k: " + k + ", nodes: " + nodes);
        if (k == M) {
            for (int i = 0; i < N; ++i) {
                if (servers.get(i).isEmpty()) {
                    return;
                }
            }
            if (nodes == most) {
                poss = (poss + 1) % 1000000007;
            }
            if (nodes > most) {
                most = nodes;
                poss = 1;
            }
            return;
        }

        for (int s = 0; s < N; ++s) {
            int cnodes = nodes;
            List<String> remove = new ArrayList<>();
            for (int i = 0; i <= S[k].length(); ++i) {
                if (!servers.get(s).contains(S[k].substring(0, i))) {
                    servers.get(s).add(S[k].substring(0, i));
                    remove.add(S[k].substring(0, i));
                    cnodes++;
                }
            }
            verteilen(k + 1, cnodes);
            for (int i = 0; i < remove.size(); ++i) {
                servers.get(s).remove(remove.get(i));
            }
        }
    }

    private static void out(String s) {
//        System.out.print(s);
        
         try {
         w.write(s);
         } catch (IOException ex) {
         Logger.getLogger(Trie.class.getName()).log(Level.SEVERE, null, ex);
         }
    }
}
