package guru.java.cjcontest;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

public class AllYourBase {

	HashSet<Character> mAlphaSet;
	ArrayList<Character> mAlphaList;
	int mRadix;
	
	Character[] mCharArray;
	int[] mDigitArray; 
	
	HashMap<Character,Character> mAlphaMap;
	
	String mTarget;
	
	void init(String sCase){
		int len = sCase.length();
		//
		mAlphaSet = new HashSet<Character>();
		mAlphaList = new ArrayList<Character>();
		for(int i = 0 ; i<len; i++){
			Character c = sCase.charAt(i);
			if(mAlphaSet.add(c)){mAlphaList.add(c);};
		}
		//
		mRadix = mAlphaSet.size();

		//
		mCharArray = mAlphaList.toArray(new Character[mRadix]);
		//
		mDigitArray = new int[mRadix];
		
		for(int i = 2; i<mRadix; i++){
			mDigitArray[i] = i;
		}
		mDigitArray[0] = 1;
		mDigitArray[1] = 0;
		
		//
		mAlphaMap = new HashMap<Character,Character> ();
		for(int i = 0; i< mRadix; i++){
			
			int m = mDigitArray[i];
			if(m<10) m = m + '0';
			else m = m + 'a';
			
			Character value = (char)m;
			mAlphaMap.put(mCharArray[i], value);
		}
		
		StringBuffer ret = new StringBuffer();
		//
		for(int i = 0; i<len; i++){
			Character c = sCase.charAt(i);
			Character t = mAlphaMap.get(c);
			ret.append(t);
		}
		
		//
		
		mTarget = ret.toString();
		
	}
	
	
	String excute(String sCase) throws Exception {
		
		init(sCase);
		
		//
//		System.out.println(sCase);
//		System.out.println(mRadix);
//		for(int i = 0; i< mRadix; i++)System.out.print(mCharArray[i]);
//		System.out.println();
//		for(int i = 0; i< mRadix; i++)System.out.print(mDigitArray[i]);
//		System.out.println();
//		System.out.println(mTarget);
		
		//
		
		Long l = Long.valueOf(mTarget, mRadix);
		
		StringBuffer result = new StringBuffer();
		
		result.append(l);
		result.append("\n");
		return result.toString();
	}
	

	//
	String mFileInPath = "D:\\temp\\jam\\A-small-attempt0.in";
	String mFileOutPath = "D:\\temp\\jam\\QuestSolution.txt";

	File mFileIn = null;
	File mFileOut = null;

	BufferedReader mIFR = null;
	BufferedWriter mOFW = null;

	int mTotalCaseCount = 0;

	public static void main(String[] args) {
		AllYourBase quest = new AllYourBase();

		if (quest != null) {
			try {
				quest.resolve();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

		System.out.println("---=====Finished=====---");

	}

	public boolean resolve() throws Exception {
		boolean retval = true;

		setUp();

		try {
			for (int i = 0; i < mTotalCaseCount; i++) {
//				System.out.println("case : " + i);
				String sCase = mIFR.readLine();
				String sResult = excute(sCase);

				mOFW.write("Case #");
				mOFW.write("" + (i + 1));
				mOFW.write(": ");
				mOFW.write(sResult);

			}
		} catch (Exception e) {

			throw e;
		} finally {
			mOFW.flush();
		}

		tearDown();

		return retval;
	}

	void setUp() throws Exception {
		mFileIn = new File(mFileInPath);
		mFileOut = new File(mFileOutPath);

		if (!mFileIn.isFile() && mFileIn.canRead())
			throw new RuntimeException("input file not exist.");

		mFileOut.getParentFile().mkdirs();
		mFileOut.createNewFile();
		if (!mFileOut.isFile() && mFileOut.canWrite())
			throw new RuntimeException(
					"input file not exist or can't write to.");

		mIFR = new BufferedReader(new FileReader(mFileIn));
		mOFW = new BufferedWriter(new FileWriter(mFileOut));

		mTotalCaseCount = Integer.parseInt(mIFR.readLine());

	}

	void tearDown() throws Exception {
		mFileInPath = null;
		mFileOutPath = null;

		mFileIn = null;
		mFileOut = null;

		mIFR.close();
		mIFR = null;
		mOFW.close();
		mOFW = null;

		mTotalCaseCount = 0;
	}

	
}