package guru.java.cjcontest;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;
import java.util.AbstractMap.SimpleEntry;
import java.util.Map.Entry;

public class WatershedsQuest{

	public boolean resolve() throws Exception {
		boolean retval = true;

		setUp();

		try {
			for (int i = 0; i < mTotalCaseCount; i++) {
				String sCase = null;
				String sResult = excute(sCase);

				mOFW.write("Case #");
				mOFW.write("" + (i + 1));
				mOFW.write(": ");
				mOFW.write(sResult);

			}
		} catch (Exception e) {

			throw e;
		} finally {
			mOFW.flush();
		}

		tearDown();

		return retval;
	}

	
	String excute(String sCase) throws Exception {
		setUpMap();

		for (int i = 0; i < mMapHeight; i++) {
			for (int j = 0; j < mMapWidth; j++) {
				if (mSinkCharMap.get(i).get(j).value < 0)
					startFlow(i, j);
			}
		}

		return getOutput();
	}

	String getOutput() {
		StringBuffer temp = new StringBuffer();
		temp.append("\n");
		for (int i = 0; i < mMapHeight; i++) {
			for (int j = 0; j < mMapWidth; j++) {
				if (mSinkCharMap.get(i).get(j).value > 25
						|| mSinkCharMap.get(i).get(j).value < 0)
					System.out.println("mark out of boundary.");
				char temp01 = 'a';
				temp01 += mSinkCharMap.get(i).get(j).value;
				temp.append(temp01);
				if (j < mMapWidth - 1)
					temp.append(" ");
			}
			temp.append("\n");
		}

		return temp.toString();
	}

	int startFlow(final int i, final int j) {

		int temp = mSinkCharMap.get(i).get(j).value;

		if (temp >= 0) {
			return temp;
		}

		Entry<Integer, Integer> next = backTracFindPath(i, j);
		if (next != null) {
			temp = startFlow(next.getKey(), next.getValue());
		} else {
			temp = mSinkChar;
			mSinkChar++;
		}

		mSinkCharMap.get(i).get(j).value = temp;

		return temp;
	}

	Entry<Integer, Integer> backTracFindPath(final int i, final int j) {

		HashMap<Integer, Entry<Integer, Integer>> tempMap = new HashMap<Integer, Entry<Integer, Integer>>();

		if (i - 1 >= 0)
			if (!tempMap.containsKey(mElevationMap.get(i - 1).get(j)))
				tempMap.put(mElevationMap.get(i - 1).get(j),
						new SimpleEntry<Integer, Integer>(i - 1, j));
		if (j - 1 >= 0)
			if (!tempMap.containsKey(mElevationMap.get(i).get(j - 1)))
				tempMap.put(mElevationMap.get(i).get(j - 1),
						new SimpleEntry<Integer, Integer>(i, j - 1));
		if (j + 1 < mMapWidth)
			if (!tempMap.containsKey(mElevationMap.get(i).get(j + 1)))
				tempMap.put(mElevationMap.get(i).get(j + 1),
						new SimpleEntry<Integer, Integer>(i, j + 1));
		if (i + 1 < mMapHeight)
			if (!tempMap.containsKey(mElevationMap.get(i + 1).get(j)))
				tempMap.put(mElevationMap.get(i + 1).get(j),
						new SimpleEntry<Integer, Integer>(i + 1, j));

		if (tempMap.size() <= 0)
			return null;

		int index = 0;

		Set<Integer> tempSet = tempMap.keySet();
		Integer[] keyArray = new Integer[tempSet.size()];
		tempSet.toArray(keyArray);

		for (int k = 0; k < keyArray.length; k++) {
			if (keyArray[k] < keyArray[index]) {
				index = k;
			}
		}

		int a1 = mElevationMap.get(i).get(j);
		int a2 = keyArray[index];
		if (a1 > a2) {
			Integer oi = keyArray[index];
			return tempMap.get(oi);
		} else
			return null;

	}

	void setUpMap() throws Exception {
		String temp = mIFR.readLine();
		String params[] = temp.split(" ");
		mMapHeight = Integer.parseInt(params[0]);
		mMapWidth = Integer.parseInt(params[1]);

		mElevationMap.clear();
		mSinkCharMap.clear();
		mSinkChar = 0;
		for (int i = 0; i < mMapHeight; i++) {
			String rowStr = mIFR.readLine();
			String[] tkens = rowStr.split(" ");
			ArrayList<Integer> mapRow = new ArrayList<Integer>();
			ArrayList<MyInt> markRow = new ArrayList<MyInt>();
			for (int j = 0; j < mMapWidth; j++) {
				mapRow.add(Integer.parseInt(tkens[j]));
				markRow.add(new MyInt(-1));

			}
			mElevationMap.add(mapRow);
			mSinkCharMap.add(markRow);
		}

	};

	int mSinkChar = 0;
	int mMapHeight = 0;
	int mMapWidth = 0;
	ArrayList<ArrayList<Integer>> mElevationMap = new ArrayList<ArrayList<Integer>>();
	ArrayList<ArrayList<MyInt>> mSinkCharMap = new ArrayList<ArrayList<MyInt>>();

	class MyInt {
		public MyInt(int i) {
			value = i;
		}

		public int value = -1;
	};
	

	String mFileInPath = "D:\\temp\\jam\\B-large.in";
	String mFileOutPath = "D:\\temp\\jam\\QuestSolution.txt";

	File mFileIn = null;
	File mFileOut = null;

	BufferedReader mIFR = null;
	BufferedWriter mOFW = null;

	int mTotalCaseCount = 0;
	
	
	public static void main(String[] args) {
		WatershedsQuest quest = new WatershedsQuest();

		if (quest != null) {
			try {
				quest.resolve();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

		System.out.println("---=====Finished=====---");

	}





	void setUp() throws Exception {
		mFileIn = new File(mFileInPath);
		mFileOut = new File(mFileOutPath);

		if (!mFileIn.isFile() && mFileIn.canRead())
			throw new RuntimeException("input file not exist.");

		mFileOut.getParentFile().mkdirs();
		mFileOut.createNewFile();
		if (!mFileOut.isFile() && mFileOut.canWrite())
			throw new RuntimeException(
					"input file not exist or can't write to.");

		mIFR = new BufferedReader(new FileReader(mFileIn));
		mOFW = new BufferedWriter(new FileWriter(mFileOut));


		mTotalCaseCount = Integer.parseInt(mIFR.readLine());

	}

	void tearDown() throws Exception {
		mFileInPath = null;
		mFileOutPath = null;

		mFileIn = null;
		mFileOut = null;

		mIFR.close();
		mIFR = null;
		mOFW.close();
		mOFW = null;

		mTotalCaseCount = 0;
	}
	
}
