package google.code.jam;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class BathroomStall {

	public static void main(String[] args) {

		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int t = in.nextInt(); // Scanner has functions to read ints, longs,
								// strings, chars, etc.
		String input[] = new String[t];
		String pattern[] = new String[t];
		for (int i = 1; i <= t; ++i) {

			pattern[i - 1] = in.next();
			input[i - 1] = in.next();
		}
		for (int i = 0; i < t; i++) {
			// input
			String result = getStallResult(pattern[i], input[i]);
			System.out.println("Case #" + (i + 1) + ": " + result);
		}

	}

	private static String getStallResult(String N, String K) {
		int totalStall = Integer.valueOf(N);
		Stall stalls[] = new Stall[totalStall + 2];
		Stall guard1 = new Stall();
		guard1.isFilled = true;
		stalls[0] = guard1;
		
		Stall guard2 = new Stall();
		guard2.isFilled = true;
		stalls[totalStall + 2 - 1] = guard2;

		int len = N.length();
		int k = Integer.parseInt(K);
		for (int i = 1; i <= totalStall; i++) {
			Stall user = new Stall();
			user.ls = i-1;
			user.rs = totalStall - i;
			user.id = i;
			stalls[i] = user;
		}

		Stall result = null;

		while (k > 0) {
			List<Stall> sameMaximalMin = new ArrayList();
			List<Stall> sameMaximalMax = new ArrayList();
			int stallMinMax = Integer.MAX_VALUE;
			int stallMaxMax = Integer.MIN_VALUE;
			boolean first = true;
			for (int i = 1; i <= totalStall; i++) {
				if (stalls[i].isFilled) {
					continue;
				} else {
					if (first) {
						stallMinMax = (int) Math.min(stalls[i].ls, stalls[i].rs);
					//	stallMaxMax = (int) Math.max(stalls[i].ls, stalls[i].rs);
						first = false;
					} else {
						stallMinMax = (int) Math.max(stallMinMax, Math.min(stalls[i].ls, stalls[i].rs));
					//	stallMaxMax = (int) Math.max(stallMaxMax, Math.max(stalls[i].ls, stalls[i].rs));
					}

				}
			}

			for (int i = 1; i <= totalStall; i++) {
				if (stalls[i].isFilled) {
					continue;
				} else {
					int currMinMax = (int) Math.min(stalls[i].ls, stalls[i].rs);
					// int currMaxMax = (int)Math.max(stalls[i].ls,
					// stalls[i].rs);
					if (currMinMax == stallMinMax) {
						sameMaximalMin.add(stalls[i]);
					}
					// if(currMaxMax == stallMaxMax){
					// sameMaximalMax.add(stalls[i]);
					// }
				}
			}

			if (sameMaximalMin.size() == 1) {
				sameMaximalMin.get(0).setFilled(true);
				result = sameMaximalMin.get(0);
				updatelsrsForStalls(stalls, sameMaximalMin.get(0).id);
			} else {
				first = true;
				for (int i = 0; i < sameMaximalMin.size(); i++) {
					Stall stall = sameMaximalMin.get(i);
					if (stall.isFilled) {
						continue;
					} else {
						if(first){
							stallMaxMax = (int) Math.max(stall.ls, stall.rs);
							first = false;
						}else{
							stallMaxMax = (int) Math.max(stallMaxMax, Math.max(stall.ls,stall.rs));
						}
						
					}
				}
				
				for (int i = 0; i < sameMaximalMin.size(); i++) {
					Stall stall = sameMaximalMin.get(i);
					if (stall.isFilled) {
						continue;
					} else {
						int currMaxMax = (int) Math.max(stall.ls, stall.rs);
						
						if (currMaxMax == stallMaxMax) {
							sameMaximalMax.add(stall);
						}
					}
				}
				
				
				
				// if(sameMaximalMax.size()==1){
				if(sameMaximalMax.isEmpty()){
					System.out.println("break");
				}
				sameMaximalMax.get(0).setFilled(true);
				result = sameMaximalMax.get(0);
				updatelsrsForStalls(stalls, sameMaximalMax.get(0).id);
				// }else{
				//
				// }
			}

			k--;
		}
		int max = Math.max(result.getLs(), result.getRs());
		int min = Math.min(result.getLs(), result.getRs());
		return max + " " + min;
	}

	private static void updatelsrsForStalls(Stall[] stalls, int index) {
		// TODO Auto-generated method stub
		int leftIndex = index - 1;
		int rightIndex = index + 1;
		while (true) {
			if (leftIndex >= 1 && !stalls[leftIndex].isFilled) {
				stalls[leftIndex].rs = index - leftIndex-1;
				leftIndex--;
			}
			if (rightIndex < stalls.length - 1 && !stalls[rightIndex].isFilled) {
				stalls[rightIndex].ls = rightIndex - index-1;
				rightIndex++;
			}
			
			if((leftIndex==0 || stalls[leftIndex].isFilled)
					&& (rightIndex == stalls.length || stalls[rightIndex].isFilled) ){
				break;
			}
		}
	}

}

class Stall {
	boolean isFilled;
	int ls;
	int rs;
	int id;

	public int getLs() {
		return ls;
	}

	public boolean isFilled() {
		return isFilled;
	}

	public void setFilled(boolean isFilled) {
		this.isFilled = isFilled;
	}

	public void setLs(int ls) {
		this.ls = ls;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getRs() {
		return rs;
	}

	public void setRs(int rs) {
		this.rs = rs;
	}
}
