package google.code.jam;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Scanner;

public class FashionShow {

	public static void main(String[] args) {

		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int t = in.nextInt(); // Scanner has functions to read ints, longs,
								// strings, chars, etc.
		int N[] = new int[t];
		int M[] = new int[t];
		String placing[][] = null;
		List<String[][]> placedModels = new ArrayList();
		for (int i = 1; i <= t; ++i) {

			N[i - 1] = in.nextInt();
			M[i - 1] = in.nextInt();
			if (M[i - 1] != 0) {
				int k = M[i - 1];
				placing = new String[k][3];
				for (int x = 0; x < k; x++) {
					for (int y = 0; y < 3; y++) {
						placing[x][y] = in.next();
					}
				}
				placedModels.add(placing);
			} else {
				placedModels.add(null);
			}
		}
		for (int i = 0; i < t; i++) {
			// input
			if (M[i] == 0) {
				getModelPlacingM0(i + 1, N[i], M[i], placedModels.get(i));
			} else {
				getModelPlacing(i + 1, N[i], M[i], placedModels.get(i));
			}
			// System.out.println("Case #" + (i + 1) + ": " + result);
		}

	}

	private static void getModelPlacing(int caseNo, int N, int M, String[][] prePlaceModel) {
		char stage[][] = new char[N][N];

		int index = 0;
		
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				stage[i][j] = '.';

			}
		}

		for (int i = 0; i < M; i++) {

			char modelType = prePlaceModel[i][0].toCharArray()[0];
			int x = Integer.parseInt(prePlaceModel[i][1]);
			int y = Integer.parseInt(prePlaceModel[i][2]);
			stage[x - 1][y - 1] = modelType;
		}

		Map<String, Character> change = new HashMap();
		int totalPoint = 0;

		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				if (stage[i][j] != '.' && stage[i][j] != 'o') {
					if (canCharBePlaced(i, j, stage, 'o', N)) {
						stage[i][j] = 'o';
						totalPoint = totalPoint+2;
						change.put((i + 1) + " " + (j + 1), 'o');
					} else {
						totalPoint++;
					}
				} else if (stage[i][j] == 'o') {
					totalPoint = totalPoint + 2;
				}

			}
		}

		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				if (stage[i][j] == '.') {
					boolean isO = canCharBePlaced(i, j, stage, 'o', N);
					if (isO) {
						stage[i][j] = 'o';
						totalPoint = totalPoint + 2;
						change.put((i + 1) + " " + (j + 1), 'o');
						continue;
					}
					boolean isPlus = canCharBePlaced(i, j, stage, '+', N);
					if (isPlus) {
						stage[i][j] = '+';
						totalPoint++;
						change.put((i + 1) + " " + (j + 1), '+');
						continue;
					}
					boolean isX = canCharBePlaced(i, j, stage, 'x', N);
					if (isX) {
						stage[i][j] = 'x';
						totalPoint++;
						change.put((i + 1) + " " + (j + 1), 'x');
						continue;
					}
				}
			}
		}

		System.out.println("Case #" + caseNo + ": " + totalPoint + " " + change.size());
		Iterator it = change.entrySet().iterator();
		while (it.hasNext()) {
			Entry entry = (Entry) it.next();
			String key = (String) entry.getKey();
			char value = (char) entry.getValue();

			System.out.println(value + " " + key);
		}

	}

	private static boolean canCharBePlaced(int i, int j, char[][] stage, char c, int N) {

		// trying to put X checking horizontally and veritically
		boolean horizontal = true;
		boolean vertical = true;
		if (c == 'o' || c == 'x') {
			for (int x = 0; x < N; x++) {
				if (horizontal && vertical) {

					if (x!=i && stage[x][j] != '.' && stage[x][j] != '+') {
						vertical = false;
					}

					if (x!=j&& stage[i][x] != '.' && stage[i][x] != '+') {
						horizontal = false;
					}

				}
			}
		}

		boolean isFound = false;
		if (c == 'o' || c == '+') {
			int x = i-1;
			int y = j-1;
			while (x >= 0 && y >= 0) {
				if (stage[x][y] != '.' && stage[x][y] != 'x') {
					isFound = true;
					break;
				}
				x--;
				y--;
			}

			x = i+1;
			y = j+1;
			while (x < N && y < N) {
				if (stage[x][y] != '.' && stage[x][y] != 'x') {
					isFound = true;
					break;
				}
				x++;
				y++;
			}

			x = i-1;
			y = j+1;
			while (x >= 0 && y < N) {
				if (stage[x][y] != '.' && stage[x][y] != 'x') {
					isFound = true;
					break;
				}
				x--;
				y++;
			}

			x = i+1;
			y = j-1;
			while (x < N && y >= 0) {
				if (stage[x][y] != '.' && stage[x][y] != 'x') {
					isFound = true;
					break;
				}
				x++;
				y--;
			}
		}

		if (vertical && horizontal & !isFound) {
			return true;
		}

		return false;
	}

	private static void getModelPlacingM0(int caseNo, int N, int M, String[][] prePlaceModel) {

		char stage[][] = new char[N][N];

		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				stage[i][j] = '.';
			}
		}

		char type = 'o';
		Map<String, Character> change = new HashMap();
		int totalPoint = 0;
		if (N >= 4) {
			totalPoint = N * 2;
			if (N % 2 == 0) {
				placeO(stage, N);
			} else {
				placeO(stage, N - 1);
				stage[N - 1][N - 1] = type;
			}
		} else {
			if (N == 1) {
				stage[N - 1][N - 1] = type;
				totalPoint = totalPoint + 2;
				change.put((N) + " " + (N), type);
			} else if (N == 2) {
				stage[N - 2][N - 2] = type;
				totalPoint = totalPoint + 2;
				change.put((N - 1) + " " + (N - 1), type);
			} else {
				stage[N - 3][N - 3] = type; // 0,0
				totalPoint = totalPoint + 2;
				change.put((N - 2) + " " + (N - 2), type); // 1,1

				stage[N - 2][N - 1] = type; // 1,2
				totalPoint = totalPoint + 2;
				change.put((N - 1) + " " + (N), type); // 2,3
			}
		}

		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				if (stage[i][j] == '.') {
					char charToPlace = doesSymbolExistDiagAndHorOrVer(i, j, stage, N);
					// System.out.println(i+" " + j + " " + charToPlace);
					if (charToPlace == '.') {
						continue;
					} else {
						stage[i][j] = charToPlace;
						change.put((i + 1) + " " + (j + 1), charToPlace);
						totalPoint = totalPoint + 1;
					}
				}
			}
		}

		int totalChange = change.size();

		for (int i = 0; i < M; i++) {
			// for(int j=0;j<3;j++){
			char modeltype = prePlaceModel[i][0].toCharArray()[0];

			int x = Integer.parseInt(prePlaceModel[i][1]);
			int y = Integer.parseInt(prePlaceModel[i][2]);
			if (stage[x - 1][y - 1] == modeltype) {
				change.put((x) + " " + (y), '*');
				totalChange--;
				totalPoint--;
				if (modeltype == 'o') {
					totalPoint--;
				}
			}
			// }
		}
		System.out.println("Case #" + caseNo + ": " + totalPoint + " " + totalChange);
		Iterator it = change.entrySet().iterator();
		while (it.hasNext()) {
			Entry entry = (Entry) it.next();
			String key = (String) entry.getKey();
			char value = (char) entry.getValue();
			if (value == '*') {
				continue;
			} else {
				System.out.println(value + " " + key);
			}
		}

	}

	private static char doesSymbolExistDiagAndHorOrVer(int i, int j, char[][] stage, int N) {

		// trying to put X checking horizontally and veritically
		boolean horizontal = true;
		boolean vertical = true;
		for (int x = 0; x < N; x++) {
			if (horizontal && vertical) {

				if (stage[x][j] != '.' && stage[x][j] != '+') {
					vertical = false;
				}

				if (stage[i][x] != '.' && stage[i][x] != '+') {
					horizontal = false;
				}

			}
		}

		int x = i;
		int y = j;
		boolean isFound = false;
		while (x >= 0 && y >= 0) {
			if (stage[x][y] != '.' && stage[x][y] != 'x') {
				isFound = true;
				break;
			}
			x--;
			y--;
		}

		x = i;
		y = j;
		while (x < N && y < N) {
			if (stage[x][y] != '.' && stage[x][y] != 'x') {
				isFound = true;
				break;
			}
			x++;
			y++;
		}

		x = i;
		y = j;
		while (x >= 0 && y < N) {
			if (stage[x][y] != '.' && stage[x][y] != 'x') {
				isFound = true;
				break;
			}
			x--;
			y++;
		}

		x = i;
		y = j;
		while (x < N && y >= 0) {
			if (stage[x][y] != '.' && stage[x][y] != 'x') {
				isFound = true;
				break;
			}
			x++;
			y--;
		}

		if (vertical && horizontal) {
			return 'x';
		}

		if (!isFound) {
			return '+';
		}
		return '.';
	}

	private static void placeO(char[][] stage, int N) {
		// TODO Auto-generated method stub
		// if(N%2 == 0){
		if ((N - 2) % 6 != 0) {
			for (int i = 0; i < (N / 2); i++) {
				int j = 2 * i + 1;
				stage[i][j] = 'o';
			}
			for (int i = (N / 2); i < N; i++) {
				int j = (2 * i) % N;
				stage[i][j] = 'o';
			}
		}

		if ((N % 6) != 0) {
			for (int i = 0; i < (N / 2); i++) {
				int j = ((N / 2) + (2 * i) - 1) % N;
				stage[i][j] = 'o';
			}
			for (int i = (N / 2); i < N; i++) {
				int j = ((N / 2) + (2 * i) + 2) % N;
				stage[i][j] = 'o';
			}
		}
		// }

	}

}
