import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;


public class ProblemA {
	
	public static void main(String[] args) throws IOException {
		Scanner scanner = new Scanner(new BufferedReader(new FileReader(args[0] + ".in")));
		Writer writer = new BufferedWriter(new FileWriter(args[0] + ".out"));
		
		int T = Integer.parseInt(scanner.next());
		int N;

		for (int x = 1; x <= T; ++x) {
			N = Integer.parseInt(scanner.next());
			Map<Integer, List<Character>> map = new HashMap<Integer, List<Character>>();
			
			for (int i = 0; i < N; ++i) {
				map.put(i, new ArrayList<Character>(N));
				for (char c: scanner.next().toCharArray())
					map.get(i).add(c);					
				//System.err.println(map.get(i));
			}
			
			System.out.println("Case #" + x + ":");
			writer.write("Case #" + x + ":\n");
			
			double[] WP = new double[N];
			double[] OWP = new double[N];
			
			for (int i = 0; i < N; ++i) {				
				double nWins, nGames;
				nWins = nGames = 0.0;				
				double OWPSum = 0.0;
				
				for (int j = 0; j < map.get(i).size(); ++j) {
					switch (map.get(i).get(j)) {						
					case '1':
						++nWins;
					case '0':
						++nGames;
						double nOppWins, nOppGames;
						nOppWins = nOppGames = 0.0;						
						for (int k = 0; k < map.get(j).size(); ++k) {
							if (k != i) {
								switch (map.get(j).get(k)) {						
								case '1':
									++nOppWins;
								case '0':
									++nOppGames;
								default:
									break;
								}
							}
						}
						OWPSum += nOppWins / nOppGames;
						break;
					default:
						break;
					}
				}
				
				WP[i] = nWins / nGames;
				OWP[i] = OWPSum / nGames;
				//System.err.println("WP=" + WP[i]);
				//System.err.println("OWP=" + OWP[i]);				
			}
			
			for (int i = 0; i < N; ++i) {
				double OOWPSum = 0.0;
				int nGames = 0;
				
				for (int j = 0; j < map.get(i).size(); ++j) {
					switch (map.get(i).get(j)) {				
					case '1':
					case '0':
						OOWPSum += OWP[j];
						++nGames;
					}
				}
				
				double OOWP = OOWPSum / nGames;
				double RPI = 0.25 * WP[i] + 0.50 * OWP[i] + 0.25 * OOWP;
						
				System.out.println(RPI);
				writer.write(RPI + "\n");
			}			
		}
		
		writer.close();
		scanner.close();
	}
	
}
