import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Date;
import java.util.Scanner;
import java.util.SortedSet;
import java.util.TreeSet;


public class C {
	private static Scanner in;
	private static PrintWriter out; 
	
	private static int N;
	private static int C;
	
	private static TreeSet<Double> naomi;
	private static TreeSet<Double> ken;
	
	private static TreeSet<Double> naomi2;
	private static TreeSet<Double> ken2;
	
	static void solve() 
	{
		N = in.nextInt();
		debug(new Date(), "Num tests: ", N);
		
		naomi = new TreeSet<Double>();
		ken = new TreeSet<Double>();
		for(int i =0; i < N; i++)
		{
			C = in.nextInt();
			for(int j = 0; j < C; j++)
			{
				naomi.add(in.nextDouble());
			}
			for(int j = 0; j < C; j++)
			{
				ken.add(in.nextDouble());
			}
			naomi2 = new TreeSet<Double>(naomi);
			ken2 = new TreeSet<Double>(ken);
			solveTest(i+1);
		}
		debug(new Date(), " Done Solving.");
	}
	
	static void solveTest(int test)
	{
		int d = deceitful();
		
		naomi = naomi2;
		ken = ken2;
		
		int w = war();
		
		out.printf("Case #%d: %d %d%n", test, d, w);
	}
	
	/*
	 * when lowest 1 is less than lowest 2 eliminate lowest from 1 and highest from 2  else   eliminate lowest from 1 and lowest from 2 and increment by 1
	 */
	static int deceitful()
	{
		int res = 0;
		while(!naomi.isEmpty())
		{
			Double nl = naomi.first();
			Double kl = ken.first();
			if(nl > kl)
			{
				naomi.remove(nl);
				ken.remove(kl);
				res++;
			}
			else
			{
				naomi.remove(nl);
				Double kh = ken.last();
				ken.remove(kh);
			}
		}
		return res;
	}
	
	static int war()
	{
		int res = 0;
		while(!naomi.isEmpty())
		{
			Double nh = naomi.last();
			Double kh = ken.last();
			if(nh > kh)
			{
				naomi.remove(nh);
				Double kl = ken.first();
				ken.remove(kl);
				res++;
			}
			else
			{
				naomi.remove(nh);
				ken.remove(kh);
			}
		}
		return res;
	}
	
	
	
	public static void main(String[] args) throws FileNotFoundException
	{
		try
		{
			in = new Scanner(new File("c:\\codejam2014\\c\\small.in"));
			out = new PrintWriter("C:\\codejam2014\\c\\small.out");
			
			solve();
		}
		finally
		{
			if(in != null)
				in.close();
			if(out != null)
			{
				out.flush();
				out.close();
			}
		}
		
		debug(new Date(), " Done Solving.");
		
	}
	
	private static void debug(Object... objects)
	{
		StringBuilder builder = new StringBuilder();
		for(Object o : objects)
		{
			builder.append(String.valueOf(o));
		}
		debug(builder.toString());
	}
	
	private static void debug(String str)
	{
		System.out.println(str);
	}
		
}
