package other.google.codejam._2017._1B;

import java.util.*;

/**
 * Class description...
 * Created by Harrison Fang on April 22, 2017.
 */
public class StableNeighbors {

    static class Pair { char c; int n; Pair(char c, int n) { this.c = c; this.n = n; } }

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        for (int t = 1; t <= T; t++) {
            int N = in.nextInt();
            Pair[] colors = new Pair[6];
            colors[0] = new Pair('R', in.nextInt());
            colors[1] = new Pair('O', in.nextInt());
            colors[2] = new Pair('Y', in.nextInt());
            colors[3] = new Pair('G', in.nextInt());
            colors[4] = new Pair('B', in.nextInt());
            colors[5] = new Pair('V', in.nextInt());
            char[] arr = new char[N];
            if (backtrack(0, arr, colors)) {
                StringBuilder sb = new StringBuilder();
                for (int i = 0; i < N; i++)
                    sb.append(arr[i]);
                System.out.printf("Case #%d: %s%n", t, sb.toString());
            } else {
                System.out.printf("Case #%d: IMPOSSIBLE%n", t);
            }
        }
    }

    static boolean backtrack(int index, char[] arr, Pair[] colors) {
//        for (int i = 0; i < index; i++)
//            System.err.print(arr[i]);
//        System.err.println();

        Arrays.sort(colors, new Comparator<Pair>() {
            @Override
            public int compare(Pair o1, Pair o2) {
                return Integer.compare(o1.n, o2.n);
            }
        });

        for (int i = 0; i < colors.length; i++) {
            for (int j = 0; j < colors.length; j++) if (i != j && !isValid(colors[i].c, colors[j].c)) {
                if ((arr.length - index + 1) / 2 < colors[i].n + colors[j].n)
                    return false;
            }
        }

        if (index == 0) {
            for (int i = 0; i < colors.length; i++) {
                if (colors[i].n > 0) {
                    colors[i].n--;
                    arr[index] = colors[i].c;
                    if (backtrack(index + 1, arr, colors))
                        return true;
                    colors[i].n++;
                }
            }
        } else if (index == arr.length - 1) {
            for (int i = 0; i < colors.length; i++) {
                if (colors[i].n > 0 && isValid(arr[index - 1], colors[i].c) && isValid(arr[0], colors[i].c)) {
                    colors[i].n--;
                    arr[index] = colors[i].c;
                    return true;
                }
            }
        } else {
            for (int i = 0; i < colors.length; i++) {
                if (colors[i].n > 0 && isValid(arr[index - 1], colors[i].c)) {
                    colors[i].n--;
                    arr[index] = colors[i].c;
                    if (backtrack(index + 1, arr, colors))
                        return true;
                    colors[i].n++;
                }
            }
        }
        return false;
    }

    static boolean isValid(char c1, char c2) {
        int tmp = (getIndex(c1) - getIndex(c2) + 6) % 6;
        return tmp != 0 && tmp != 1 && tmp != 5;
    }

    static int getIndex (char c) {
        switch (c) {
            case 'R': return 0;
            case 'O': return 1;
            case 'Y': return 2;
            case 'G': return 3;
            case 'B': return 4;
            case 'V': return 5;
        }
        return -1;
    }
}