package other.google.codejam._2017.qualification;

import java.util.*;

/**
 * Class description...
 * Created by Harrison Fang on April 07, 2017.
 */
public class OversizedPancakeFlipper {

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();

        loop:
        for (int t = 1; t <= T; t++) {
            State start = new State(in.next().toCharArray());
            int K = in.nextInt();

            HashMap<State, Integer> visited = new HashMap<>();
            ArrayDeque<State> queue = new ArrayDeque<>();
            visited.put(start, 0);
            queue.offer(start);

            while (!queue.isEmpty()) {
                State s = queue.poll();
                if (isFinished(s.arr)) {
                    System.out.printf("Case #%d: %d%n", t, visited.get(s));
                    continue loop;
                }

//                for (int i = 0; i < s.arr.length; i++) {
//                    System.err.print(s.arr[i]);
//                }
//                System.err.println();

                for (int i = 0; i + K <= s.arr.length; i++) {
                    char[] arr = s.arr.clone();
                    for (int j = 0; j < K; j++) {
                        arr[i + j] = arr[i + j] == '+' ? '-' : '+';
                    }
                    State n = new State(arr);
                    if (!visited.containsKey(n)) {
                        visited.put(n, visited.get(s) + 1);
                        queue.offer(n);
                    }
                }
            }

            System.out.printf("Case #%d: IMPOSSIBLE%n", t);
        }
    }

    static boolean isFinished(char[] arr) {
        for (int i = 0; i < arr.length; i++) {
            if (arr[i] == '-') return false;
        }
        return true;
    }

    static class State {
        char[] arr;
        State(char[] arr) { this.arr = arr; }
        public int hashCode() {
            int hash = 0;
            for (int i = 0; i < arr.length; i++) {
                hash += (arr[i] == '+' ? 1 : 0) << i;
            }
            return hash;
        }
        public boolean equals(Object o) {
            State s = (State)o;
            return Arrays.equals(arr, s.arr);
        }
    }
}
