package other.google.codejam._2017._1B;

import java.util.*;

/**
 * Class description...
 * Created by Harrison Fang on April 22, 2017.
 */
public class PonyExpress {

    static double eps = 0.000001;
    static class Entry {
        int i; double d; Pair p;
        Entry(int i, double d, Pair p) {
            this.i = i; this.d = d;
            this.p = p;
        }
    }
    static class Pair { int a, b; Pair(int a, int b) { this.a = a; this.b = b; } }

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        for (int t = 1; t <= T; t++) {
            int N = in.nextInt(), Q = in.nextInt();
            Pair[] horses = new Pair[N];
            int[][] adj = new int[N][N];
            for (int i = 0; i < N; i++)
                horses[i] = new Pair(in.nextInt(), in.nextInt());
            for (int i = 0; i < N; i++)
                for (int j = 0; j < N; j++)
                    adj[i][j] = in.nextInt();
            StringBuilder sb = new StringBuilder();
            for (int q = 0; q < Q; q++) {
                int U = in.nextInt() - 1, V = in.nextInt() - 1;

                final double[] time = new double[N];
                final int[] dist = new int[N];
                final int[] speed = new int[N];

                Queue<Entry> queue = new PriorityQueue<Entry>(new Comparator<Entry>() {
                    @Override
                    public int compare(Entry o1, Entry o2) {
                        if (Math.abs(o1.d - o2.d) < eps)
                            return -Integer.compare(o1.p.b, o2.p.b);
                        return Double.compare(o1.d, o2.d);
                    }
                });
                queue.offer(new Entry(U, 0, new Pair(horses[U].a, horses[U].b)));
                Arrays.fill(time, Double.MAX_VALUE);
                dist[U] = horses[U].a;
                time[U] = 0;

                while (!queue.isEmpty()) {
                    Entry e = queue.poll();
                    int u = e.i;

//                    System.err.println(u + " (" + e.p.a + ", " + e.p.b + ") " + e.d);

                    if (u == V) {
                        break;
                    }

//                    if (time[u] - eps < e.d && dist[u] >= e.p.a) {
//                        System.err.println("here");
//                        continue;
//                    }

                    for (int v = 0; v < N; v++) {
                        if (adj[u][v] != -1) {
                            if (e.p.a >= adj[u][v]) {
                                double tt = e.d + (double)adj[u][v] / e.p.b;
                                int dd = e.p.a - adj[u][v];
                                if (tt < time[v] - eps) {
                                    time[v] = Math.min(time[v], tt);
                                    dist[v] = Math.max(dist[v], dd);
                                    dist[v] = Math.max(dist[v], horses[v].a);
                                    queue.offer(new Entry(v, tt, new Pair(dd, e.p.b)));
                                    queue.offer(new Entry(v, tt, new Pair(horses[v].a, horses[v].b)));
                                } else if (dd >= dist[v]) {
                                    dist[v] = Math.max(dist[v], dd);
                                    queue.offer(new Entry(v, tt, new Pair(dd, e.p.b)));
                                }
                            }
                        }
                    }
                }

                sb.append(time[V]).append(' ');
            }
            sb.deleteCharAt(sb.length() - 1);
            System.out.printf("Case #%d: %s%n", t, sb.toString());
        }
    }
}