package qual2016;

import java.util.*;

public class B {
	public static void main(String... args) {
		Scanner s = new Scanner(System.in);
		
		final int T = s.nextInt();
		for (int t = 1; t <= T; t++) {
			String st = s.next();
			System.out.printf("Case #%d: %d\n", t, solve(st));
		}
		
		s.close();
	}
	
	static Set<String> visited;
	
	public static int solve(String st) {
		visited = new HashSet<>();
		
		if (works(st)) return 0;
		
		Set<String> visited = new HashSet<>();
		Deque<SIPair> q = new ArrayDeque<>();
		q.addLast(new SIPair(st, 0));
		visited.add(st);
		
		while (!q.isEmpty()) {
			SIPair p = q.removeFirst();
			
			if (works(p.s)) return p.i;
			if (p.i > st.length()) break;
			
			for (int i = 1; i <= p.s.length(); i++) {
				String f = flipped(p.s, i);
				if (!visited.contains(f)) {
					visited.add(f);
					q.addLast(new SIPair(f, p.i + 1));
				}
			}
		}
		
		return st.length();
	}
	
	public static String flipped(String s, int depth) {
		StringBuilder sb = new StringBuilder();
		
		int i;
		for (i = 0; i < depth; i++) {
			sb.append((s.charAt(depth-i-1) == '+') ? '-' : '+');
		}
		for (; i < s.length(); i++) {
			sb.append(s.charAt(i));
		}
		
		return sb.toString();
	}
	
	public static boolean works(String s) {
		for (char c : s.toCharArray())
			if (c == '-')
				return false;
		return true;
	}
	
	static class SIPair {
		public String s;
		public int i;
		
		public SIPair(String s, int i) {
			this.s = s;
			this.i = i;
		}
	}
}
