import java.util.Queue;


public class Robot 
{	
	Queue<Instruction> classInstructions;
	int classCurrentLocation = 1;
	/**
	 * O or B, this Bot's ID basically
	 */
	String classBotID;
	public enum Move{WAIT, MOVEUP, MOVEDOWN, PUSH}
	
	Robot(Queue<Instruction> passedQueue, String passedBot)
	{
		classInstructions = passedQueue;
		this.classBotID = passedBot;
	}
	
	
	/**
	 * Take the current instruction in the main queue
	 * and decide what to do based on it
	 * @param passedInstruction
	 */
	Move DecideMove(Instruction passedInstruction)
	{
		String passedBot = passedInstruction.getBot();
		int passedButton = passedInstruction.getButton();
		Move currentMove;
		
		if (passedBot.equals(this.classBotID))
		{
			currentMove = currentBotMove(passedButton);
		}
		else
		{
			Instruction currentInstruction = classInstructions.peek();
			if (currentInstruction != null)
			{
				currentMove = inactiveBotMove(currentInstruction.button);
			}
			else
			{
				/**
				 * This will just make the bot wait
				 */
				currentMove = inactiveBotMove(this.classCurrentLocation);
			}
		}
		return currentMove;
	}

   /**
    * Returns what move this bot should make
    * @param passedButton
    * @return
    */
	private Move inactiveBotMove(int passedButton) {
		// TODO Auto-generated method stub
		
		if (passedButton == this.classCurrentLocation)
		{
			return Move.WAIT;
		}
		else if (passedButton < this.classCurrentLocation)
		{
			return Move.MOVEDOWN;
		}
		
		else if (passedButton > this.classCurrentLocation)
		{
			return Move.MOVEUP;
		}
		else
			//Error state ignore for now
			return null;
	}

 
	/**
	 * Duplicate logic, ignore for now
	 * @param passedButton
	 * @return
	 */
	private Move currentBotMove(int passedButton) {
		if (passedButton == this.classCurrentLocation)
		{
			return Move.PUSH;
		}
		else if (passedButton < this.classCurrentLocation)
		{
			return Move.MOVEDOWN;
		}		
		else if (passedButton > this.classCurrentLocation)
		{
			return Move.MOVEUP;
		}
		else
			//Error state ignore for now
			return null;
	}
	
	void MakeMove(Move passedMove)
	{
		if (passedMove == Move.MOVEDOWN)
		{
			this.classCurrentLocation--;
		}
		else if (passedMove == Move.MOVEUP)
		{
			this.classCurrentLocation++;
		}
		else if (passedMove == Move.PUSH)
		{
			this.classInstructions.remove();
		}
		else if (passedMove == Move.WAIT)
		{
			return;
		}
			
	}
	
	
}
