package magicka;

import java.util.LinkedList;
import java.util.Queue;

public class MagicWorker 
{
	static LinkedList<String> ProcessInstructions(InstructionQueue passedInstructions)
	{
		LinkedList<String> elements = new LinkedList<String>();
		
		Queue<String> invocations = passedInstructions.classInvokeQueue;
		
		while (!invocations.isEmpty())
		{
				elements = Invoke(passedInstructions, elements);																													
		}
		
		return elements;
	}
	
	static LinkedList<String>  Invoke(InstructionQueue passedInstructions, LinkedList<String> passedElements)
	{
		Queue<String> invocations = passedInstructions.classInvokeQueue;
		LinkedList<combinePair> combine = passedInstructions.classCombine;
		LinkedList<opposedPair> opposed = passedInstructions.classOpposed;
		
		String invoke = invocations.remove();
		
		
		if (passedElements.isEmpty())
		{
			passedElements.addLast(invoke);
			return passedElements;
		}
		
		passedElements = combinePair.Invoke(passedElements, invoke, combine);
		
		passedElements = opposedPair.Invoke(passedElements, invoke, opposed);
		
		return passedElements;
	}
}
