import java.util.Queue;


public class RobotOverlord 
{
	
	static int ProcessInstructions(InstructionQueue passedQueue)
	{
		Robot blueBot = new Robot(passedQueue.getClassBlueQueue(), "B");
		Robot orangeBot = new Robot(passedQueue.getClassOrangeQueue(), "O");
		
		Robot.Move blueMove;
		Robot.Move orangeMove;
		
		int moveCount = 0;
		
		Queue<Instruction> workingQueue = passedQueue.getClassFullQueue();
		
		Instruction currentInstruction;
		
		while (!workingQueue.isEmpty())
		{
			currentInstruction = workingQueue.peek();
			
			blueMove = blueBot.DecideMove(currentInstruction);
			orangeMove = orangeBot.DecideMove(currentInstruction);
		
			if (blueMove.equals(Robot.Move.PUSH) || orangeMove.equals(Robot.Move.PUSH))
			{
				workingQueue.remove();
			}
			blueBot.MakeMove(blueMove);
			orangeBot.MakeMove(orangeMove);
			
			moveCount++;
		}
		
		return moveCount;
	}

}
