package contest;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;


public class FileReader 
{
	File classWorkingFile;
	
	Queue<InstructionQueue> classFileQueue = new LinkedList<InstructionQueue>();

	
	/**
	 * Convenience method to open the file and read it into a queue
	 * Param The queue to read into
	 */
	Queue<InstructionQueue> ReadFileToQueue(File passedFile)
	{
		OpenFile(passedFile);
		ReadFile();
		return classFileQueue;

	}

	void OpenFile(File passedFile)
	{
		classWorkingFile = passedFile;
	}

	void ReadFile() 
	{	
		Scanner scanner = null;
		try
		{
			scanner = new Scanner(classWorkingFile);
		}
		catch(FileNotFoundException fnfe)
		{
			System.out.println("File not Found");
		}

		// I don't care about this
		int throwAway = scanner.nextInt();
		

		while (scanner.hasNextLine())
		{
			InstructionQueue tempQueue = ParseLineToQueue(scanner);
			this.classFileQueue.add(tempQueue);
		}
	}


	InstructionQueue ParseLineToQueue( Scanner scanner)
	{
		
		InstructionQueue workingQueue = new InstructionQueue();
		
		int handCount = scanner.nextInt();
		for (int i = 0; i < handCount; i++)
		{
			Card temp = readCard(scanner);
			workingQueue.classHand.addCard(temp);
		}
		
		int deckCount = scanner.nextInt();
		for (int i = 0; i < deckCount; i++)
		{
			Card temp = readCard(scanner);
			workingQueue.classDeck.addCard(temp);
		}
		
		
		return workingQueue;
	}
	
	Card readCard(Scanner scanner)
	{
		Card a = new Card();
		
		a.cards = scanner.nextInt();
		a.score = scanner.nextInt();
		a.turns = scanner.nextInt();
		
		return a;
	}
	

}
