/*
 * OrangeAndBlue.java created on May 6, 2011
 */

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;


/**
 * 
 * 
 * @author Jovan.Chohan
 */
public class OrangeAndBlue
{
	public static void main( String[] args ) throws Exception
	{
		BufferedReader in = new BufferedReader(new FileReader("C:\\Users\\jovan.chohan\\Downloads\\A-large.in"));
		BufferedWriter out = new BufferedWriter(new FileWriter("testoutput.txt"));

		int numTests = Integer.parseInt(in.readLine());
		for (int i = 0; i < numTests; i++)
		{
			String[] sequenceData = in.readLine().split(" ");
			int numButtons = Integer.parseInt(sequenceData[0]);
			SequenceArray sequenceArray = new SequenceArray(numButtons);
			for (int ii = 1; ii < sequenceData.length; ii++)
			{
				if (sequenceData[ii].equals("O"))
				{
					Sequence seq = new Sequence();
					seq.button = Integer.parseInt(sequenceData[ii + 1]);
					seq.completed = false;
					seq.robotColor = "O";
					sequenceArray.insert(seq);
				}
				else if (sequenceData[ii].equals("B"))
				{
					Sequence seq = new Sequence();
					seq.button = Integer.parseInt(sequenceData[ii + 1]);
					seq.completed = false;
					seq.robotColor = "B";
					sequenceArray.insert(seq);
				}
			}
			// 1 forward, 2 backward
			Robot orange = new Robot();
			orange.direction = 1;
			orange.position = 1;
			orange.finished = false;
			orange.destination = -1;

			Robot blue = new Robot();
			blue.direction = 1;
			blue.position = 1;
			blue.finished = false;
			blue.destination = -1;

			int currentTime = 0;
			while (sequenceArray.numBlue > 0 || sequenceArray.numOrange > 0)
			{
				Boolean buttonPressed = false;
				if (sequenceArray.numBlue > 0)
				{
					int blueDest = sequenceArray.getBlueDestination();
					if (blue.position == blueDest)
					{
						// stay there if its not his move
						int currMove = sequenceArray.currentMove;
						Sequence seq = sequenceArray.sequence[currMove];
						if (seq.robotColor.equals("B") && seq.button == blue.position)
						{
							// press the button
							buttonPressed = true;
							sequenceArray.numBlue--;
						}
					}
					else
					{
						if (blueDest > blue.position)
						{
							blue.position++;
						}
						else
						{
							blue.position--;
						}
					}
				}
				if (sequenceArray.numOrange > 0)
				{
					int orangeDest = sequenceArray.getOrangeDestination();
					if (orange.position == orangeDest)
					{
						// stay there if its not his move
						int currMove = sequenceArray.currentMove;
						Sequence seq = sequenceArray.sequence[currMove];
						if (seq.robotColor.equals("O") && seq.button == orange.position)
						{
							// press the button
							buttonPressed = true;
							sequenceArray.numOrange--;
						}
					}
					else
					{
						if (orangeDest > orange.position)
						{
							orange.position++;
						}
						else
						{
							orange.position--;
						}
					}
				}
				if (buttonPressed)
				{
					sequenceArray.currentMove++;
				}
				System.out.println("BluePosition: " + blue.position + " OrangePosition: " + orange.position);
				currentTime++;
			}

			out.write("Case #" + (i + 1) + ": " + currentTime + "\n");

		}
		out.flush();
		out.close();
	}
}


class Robot
{
	int		position;
	int		direction;
	Boolean	finished;
	int		destination;
}


class Sequence
{
	String	robotColor;
	int		button;
	Boolean	completed;
}


class SequenceArray
{
	Sequence[]	sequence;
	int			pos;
	int			numBlue;
	int			numOrange;
	int			currentMove;

	public SequenceArray( int x )
	{
		sequence = new Sequence[x];
		pos = 0;
		numBlue = 0;
		numOrange = 0;
		currentMove = 0;
	}

	public void insert( Sequence seq )
	{
		sequence[pos] = seq;
		if (seq.robotColor.equals("O"))
		{
			numOrange++;
		}
		else
		{
			numBlue++;
		}
		pos++;
	}

	public int getBlueDestination()
	{
		for (int i = currentMove; i <= pos; i++)
		{
			if (sequence[i].robotColor.equals("B"))
			{
				return sequence[i].button;
			}
		}
		return -1;
	}

	public int getOrangeDestination()
	{
		for (int i = currentMove; i <= pos; i++)
		{
			if (sequence[i].robotColor.equals("O"))
			{
				return sequence[i].button;
			}
		}
		return -1;
	}
}