package gcj;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;

public class TicTacToe {

	private static int[][] board = new int[4][4];

	private static String boardRows[] = new String[4];
	
	private static int X = 1;
	private static int O = 2;
	private static Map inputMap = new HashMap<Character, Integer>();
	
	private static int X_WIN = 1;
	private static int O_WIN = 2;
	private static int DRAW = 3;
	private static int INCOMPLETE = 4;
	private static int state = DRAW;
	
	private static String results[] = {
		"X won",
		"O won",
		"Draw",
		"Game has not completed"
	};

	public static void main(String [] args) {

		try {
			/* prep lookup table */
			inputMap.put('X', X);
			inputMap.put('O', O);
			inputMap.put('T', O + X);
			inputMap.put('.', 0);

			BufferedReader input = new BufferedReader(new InputStreamReader( new FileInputStream("C:\\Users\\Patio\\Desktop\\input.txt")));
			/* first line is number of cases */
			int numberOfCases = Integer.parseInt(input.readLine());
			for (int caseIndex = 0; caseIndex < numberOfCases; caseIndex++) {
				state = DRAW;
				boardRows[0] = input.readLine();
				boardRows[1] = input.readLine();
				boardRows[2] = input.readLine();
				boardRows[3] = input.readLine();
				/* Read blank line */
				input.readLine();
				/* Parse input */
				for (int lineIndex = 0; lineIndex < 4; lineIndex++) {
					for (int rowIndex = 0; rowIndex < 4; rowIndex++) {
						board[lineIndex][rowIndex] = ((Integer) inputMap.get(boardRows[rowIndex].charAt(lineIndex))).intValue();
						if (0 == board[lineIndex][rowIndex]) {
							/* Board is not full */
							state = INCOMPLETE;
						}
					}
				}
				
				/* Check board */
				/* Check 10 possible wins for each of X and O */
				if (X == (board[0][0] & board[0][1] & board[0][2] & board[0][3])) {
					state = X_WIN;
				} else if (O == (board[0][0] & board[0][1] & board[0][2] & board[0][3])) {
					state = O_WIN;
				} else if (X == (board[1][0] & board[1][1] & board[1][2] & board[1][3])) {
					state = X_WIN;
				} else if (O == (board[1][0] & board[1][1] & board[1][2] & board[1][3])) {
					state = O_WIN;
				} else if (X == (board[2][0] & board[2][1] & board[2][2] & board[2][3])) {
					state = X_WIN;
				} else if (O == (board[2][0] & board[2][1] & board[2][2] & board[2][3])) {
					state = O_WIN;
				} else if (X == (board[3][0] & board[3][1] & board[3][2] & board[3][3])) {
					state = X_WIN;
				} else if (O == (board[3][0] & board[3][1] & board[3][2] & board[3][3])) {
					state = O_WIN;
				} else if (X == (board[0][0] & board[1][0] & board[2][0] & board[3][0])) {
					state = X_WIN;
				} else if (O == (board[0][0] & board[1][0] & board[2][0] & board[3][0])) {
					state = O_WIN;
				} else if (X == (board[0][1] & board[1][1] & board[2][1] & board[3][1])) {
					state = X_WIN;
				} else if (O == (board[0][1] & board[1][1] & board[2][1] & board[3][1])) {
					state = O_WIN;
				} else if (X == (board[0][2] & board[1][2] & board[2][2] & board[3][2])) {
					state = X_WIN;
				} else if (O == (board[0][2] & board[1][2] & board[2][2] & board[3][2])) {
					state = O_WIN;
				} else if (X == (board[0][3] & board[1][3] & board[2][3] & board[3][3])) {
					state = X_WIN;
				} else if (O == (board[0][3] & board[1][3] & board[2][3] & board[3][3])) {
					state = O_WIN;
				} else if (X == (board[0][0] & board[1][1] & board[2][2] & board[3][3])) {
					state = X_WIN;
				} else if (O == (board[0][0] & board[1][1] & board[2][2] & board[3][3])) {
					state = O_WIN;
				} else if (X == (board[0][3] & board[1][2] & board[2][1] & board[3][0])) {
					state = X_WIN;
				} else if (O == (board[0][3] & board[1][2] & board[2][1] & board[3][0])) {
					state = O_WIN;
				}
				System.out.println("Case #" + (caseIndex + 1) + ": " + results[state - 1]);
			}
		} catch (Throwable e) {
			e.printStackTrace();
		}
	}
}
