package gcj;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;

public class Lawnmower {

	public static void main(String [] args) {

		try {
			BufferedReader input = new BufferedReader(new InputStreamReader( new FileInputStream("C:\\Users\\Patio\\Desktop\\input.txt")));
			/* first line is number of cases */
			int numberOfCases = Integer.parseInt(input.readLine());
			for (int caseIndex = 0; caseIndex < numberOfCases; caseIndex++) {
				String[] dimensions = input.readLine().split(" ");
				int rows = Integer.parseInt(dimensions[0]);
				int columns = Integer.parseInt(dimensions[1]);
				int lawn[][] = new int[rows][columns];
				boolean legalLawn[][] = new boolean[rows][columns];
				for (int rowIndex = 0; rowIndex < rows; rowIndex++) {
					String[] sections = input.readLine().split(" ");
					for (int columnIndex = 0; columnIndex < columns; columnIndex++) {
						lawn[rowIndex][columnIndex] = Integer.parseInt(sections[columnIndex]);
						legalLawn[rowIndex][columnIndex] = false;
					}
				}
				/* Small set. Any square with a 1 in it must have all 1s in either the row or column. Mark solved squares as we go. */
				boolean rowFailed = false;
				boolean columnFailed = false;
				boolean failed = false;
				for (int rowIndex = 0; rowIndex < rows && !failed; rowIndex++) {
					for (int columnIndex = 0; columnIndex < columns && !failed; columnIndex++) {
						rowFailed = false;
						columnFailed = false;
						failed = false;
						if (1 == lawn[rowIndex][columnIndex] && false == legalLawn[rowIndex][columnIndex]) {
							/* Check row first. Then column, success in row does NOT preclude checking column, always check both. */
							for (int columnCheckIndex = 0; columnCheckIndex < columns; columnCheckIndex++) {
								if (1 != lawn[rowIndex][columnCheckIndex]) {
									rowFailed = true;
									break;
								}
							}
							for (int rowCheckIndex = 0; rowCheckIndex < rows; rowCheckIndex++) {
								if (1 != lawn[rowCheckIndex][columnIndex]) {
									columnFailed = true;
									break;
								}
							}
							if (rowFailed && columnFailed) {
								failed = true;
								break;
							}
						}
					}
				}
				
				System.out.println("Case #" + (caseIndex + 1) + ": " + (failed ? "NO" : "YES"));
			}
		} catch (Throwable e) {
			e.printStackTrace();
		}
	}
}
