import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;


public class Pancake {

	public static void main(String[] args) {

		try {
			BufferedReader input = new BufferedReader(new InputStreamReader( new FileInputStream("C:\\Users\\Patio\\Desktop\\input.txt")));
			/* plateCount[index + onePancakePlateIndex - 1] indicates how many plates contain <index> pancakes. */
			int[] plateCount = new int[11];
			/* first line is number of cases */
			int numberOfCases = Integer.parseInt(input.readLine());
			for (int caseIndex = 0; caseIndex < numberOfCases; caseIndex++) {
				for (int loop = 0; loop < 11; loop++) {
					plateCount[loop] = 0;
				}
				/* Points to the index that indicates how many plates currently have 1 pancake on them. each time we do a regular minute, this is incremented to effect a '--' on each element, rather than actually shifting every item down one position. */
				int onePancakePlateIndex = 1;
				/* Since max pancakes is 1000, can always choose to eat for 1000 minutes straight with no specials. */
				int bestTime = 1000;
				/* Indicates how many pancakes are on the largest plate, there may be more than one such plate. */
				int largestPlateIndex = 10;
				int nextLargestPlateIndex = 10;
				int specialMinutes = 0;
				int regularMinutes = 0;
				int numberOfDiners = Integer.parseInt(input.readLine());
				String[] pancakeCounts = input.readLine().split(" ");
				/* Count all the plates and the number of pancakes on them. */
				for (String pancakes : pancakeCounts) {
					plateCount[Integer.parseInt(pancakes)]++;
				}
				do {
					/* Starting with the currently largest plate(s) do:
					 * 	a regular minute if the number of pancakes is odd
					 *  a special minute if it is even and splitting all the largest plates saves time compared to just doing all regular minutes for each pancake on the plate
					 *  all regular minutes for the remainder, in which case we are done.
					 */
					while (0 == plateCount[largestPlateIndex] && largestPlateIndex >= onePancakePlateIndex - 1) largestPlateIndex--;
					if (largestPlateIndex < onePancakePlateIndex) {
						break;
					}
					nextLargestPlateIndex = largestPlateIndex - 1;
					while (nextLargestPlateIndex >= onePancakePlateIndex - 1 && 0 == plateCount[nextLargestPlateIndex]) nextLargestPlateIndex--;
					/* Number of pancakes on largest plate is largestPlateIndex - onePancakePlateIndex + 1. */
					int largestPlateSize = largestPlateIndex - onePancakePlateIndex + 1;
					if (1 == (largestPlateSize) % 2) {
						/* The number of pancakes is odd. do a regular minute. */
						regularMinutes++;
						onePancakePlateIndex++;
					} else {
						/* Even, check to see if splitting is better than just continuing to eat non stop. */
						/* Split cost is number of special minutes needed to split all stacks (plateCount) plus number of regular minutes required to eat resulting stacks (max[original size / 2, next largest]). */
						int nextLargestPlateSize = 0;
						if (nextLargestPlateIndex < onePancakePlateIndex) {
							nextLargestPlateSize = (largestPlateIndex - onePancakePlateIndex + 1) / 2;
						} else if ((largestPlateIndex - onePancakePlateIndex + 1) / 2 > nextLargestPlateIndex - onePancakePlateIndex + 1) {
							nextLargestPlateSize = (largestPlateIndex - onePancakePlateIndex + 1) / 2;
						} else {
							nextLargestPlateSize = nextLargestPlateIndex - onePancakePlateIndex + 1;
						}
						int splitCost = nextLargestPlateSize + plateCount[largestPlateIndex];
						int regularCost = largestPlateSize;
						if (splitCost > regularCost) {
							/* Done, just eat all the remaining in a row. */
							regularMinutes += regularCost;
							break;
						} else {
							/* Splitting is better, do split. Only count the special minutes now though, more splitting may be better than the splitCost indicates. */
							specialMinutes += plateCount[largestPlateIndex];
							/* Move split plates to the corresponding entries. */
							plateCount[((largestPlateIndex - onePancakePlateIndex + 1) / 2) + onePancakePlateIndex - 1] += plateCount[largestPlateIndex] * 2;
							/* Remove large plates from large entry. */
							plateCount[largestPlateIndex] = 0;
						}
					}
				} while (true);
				System.out.println("Case #" + (caseIndex + 1) + ": " + (regularMinutes + specialMinutes));
			}
		} catch (Throwable e) {
			e.printStackTrace();
		}
	}
}
