import java.util.*;
import java.io.*;

public class b {
    private int toInt(String s) {
        int r = 0;

        for(int i = 0; i < s.length(); ++i) {
            if(s.charAt(i) == '+') {
                r |= (1 << i);         
            } 
        }

        return r;
    }

    private int flip(int b, int k, int n) {
        int r = b, left = 0, right = 0;

        for(int i = 0; i < n; ++i) {
            if(((b >> i) & 1) == 1) {
                if(i > k) {
                    left |= (1 << i); 
                }
            } else {
                if(i <= k) {
                    right |= (1 << (k - i)); 
                }
            }
        }

        return left | right;
    }

    private int solve(String s) {
        int r = 0, n = s.length();
        boolean[] vis = new boolean[1 << n];
        int[] dis = new int[1 << n];

        int top = toInt(s);

        Queue<Integer> q = new LinkedList<>();
        q.add(top);
        vis[top] = true;

        while(q.size() > 0) {
            top = q.remove();        
            
            if(top == (1 << n) - 1) {
                r = dis[top];
                break;
            } 

            for(int i = 0; i < n; ++i) {
                int next = flip(top, i, n);
                if(!vis[next]) {
                    q.add(next); 
                    vis[next] = true;
                    dis[next] = dis[top] + 1;
                } 
            }
        }

        return r;
    }

    private void solve() throws IOException {
        int T = nextInt();

        for(int t = 1; t <= T; ++t) {
            String s = nextLine(); 

            int r = solve(s);
            out.println(String.format("Case #%d: %d", t, r));
            debug(String.format("Case #%d: %d", t, r));
        }


    }

    static void debug(Object...o) {
        System.err.println(Arrays.deepToString(o));
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            String s = br.readLine();
            if(s != null) {
                st = new StringTokenizer(s);
            }
        }
        if(st.hasMoreTokens()) {
            return st.nextToken();
        } else {
            return null;
        }
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    String nextLine(){
        String str = "";
        try {
            str = br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return str;
    }

    private void run(String filename) throws IOException {
        br = new BufferedReader(new FileReader(filename));
        //br = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
        out = new PrintWriter(filename + ".out");
        solve();
        out.close();
    }

    public static void main(String[] args) throws IOException {
        String filename = args[0].endsWith(".in") ? args[0] : "b.in";

        new b().run(filename);
    }
}
