import java.util.*;
import java.io.*;

public class Main {

    class State {
        String s;
        int d;
        State(String s, int d) {
            this.s = s;
            this.d = d;
        }
    }

    String flip(String s, int from, int to) {
        char[] c = s.toCharArray();

        for (int i = from; i < to; ++i) {
            if (c[i] == '+') {
                c[i] = '-';
            }  else {
                c[i] = '+';
            }
        }

        return new String(c);
    }

    int solve(String s, int k) {
        Queue<State> q = new LinkedList<>();
        q.add(new State(s, 0));
        Set<String> seen = new HashSet<>();

        while(q.size() > 0) {
            State top = q.remove();
            String t = top.s;
            int d = top.d;

            if (t.indexOf('-') < 0) {
                return d;
            }

            for (int i = 0; i + k <= s.length(); ++i) {
                String next = flip(t, i, i + k);
                if (!seen.contains(next)) {
                    q.add(new State(next, d + 1));
                    seen.add(next);
                }
            }
        }

        return -1;
    }

    private void solve() throws IOException {
        int t = nextInt();
        for (int i = 1; i <= t; ++i) {
            String s = next();
            int k = nextInt();
            int ans = solve(s, k);

            out.print(String.format("Case #%d: ", i));
            if (ans < 0) {
                out.println("IMPOSSIBLE");
            } else {
                out.println(ans);
            }
        }
        int k = solve("---+-++-", 3);
    }

    static void debug(Object...o) {
        System.err.println(Arrays.deepToString(o));
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            String s = br.readLine();
            if(s != null) {
                st = new StringTokenizer(s);
            }
        }
        if(st.hasMoreTokens()) {
            return st.nextToken();
        } else {
            return null;
        }
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    String nextLine(){
        String str = "";
        try {
            str = br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return str;
    }

    private void run() throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
        solve();
        out.close();
    }

    public static void main(String[] args) throws IOException {
        new Main().run();
    }
}
