import java.util.*;
import java.io.*;

public class Main {

    long solve(long n) {
        Queue<Long> q = new LinkedList<>();
        q.add(0l);

        long r = 0;
        while(q.size() > 0) {
            long top = q.remove();
            r = Math.max(r, top);

            int last = (int) (top % 10);
            for (int i = last > 0 ? last : 1; i < 10; ++i) {
                long next = top * 10 + i;
                if (next <= n) {
                    q.add(next);
                }
            }
        }

        return r;
    }

    private void solve() throws IOException {
        int t = nextInt();
        for (int i = 1; i <= t; ++i) {
            long n = nextLong();
            long ans = solve(n);
            out.println(String.format("Case #%d: %d", i, ans));
        }
    }

    static void debug(Object...o) {
        System.err.println(Arrays.deepToString(o));
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            String s = br.readLine();
            if(s != null) {
                st = new StringTokenizer(s);
            }
        }
        if(st.hasMoreTokens()) {
            return st.nextToken();
        } else {
            return null;
        }
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    String nextLine(){
        String str = "";
        try {
            str = br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return str;
    }

    private void run() throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
        solve();
        out.close();
    }

    public static void main(String[] args) throws IOException {
        new Main().run();
    }
}
