import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

public class JamCoins {

	BigInteger factor(BigInteger n, BigInteger c) {
		BigInteger two = new BigInteger("2");
		if (n.remainder(two).equals(BigInteger.ZERO))
			return two;

		BigInteger h = BigInteger.ONE;
		BigInteger t = BigInteger.ONE;
		BigInteger g = BigInteger.ZERO;
		do {

			h = h.multiply(h).add(c).remainder(n);
			h = h.multiply(h).add(c).remainder(n);
			t = t.multiply(t).add(c).remainder(n);
			g = t.subtract(h).gcd(n);

		} while (g.equals(BigInteger.ONE));

		if (g.isProbablePrime(1))
			return g;
		return factor(g, c.add(BigInteger.ONE));
	}
	
    BigInteger getDivisor(BigInteger input, BigInteger base) {

		BigInteger divisor = null;
		BigInteger num=input;
		BigInteger ten = new BigInteger("10");
		BigInteger numberInBaseTen = BigInteger.ZERO;
		int x = 0;
		do {
			BigInteger digit = num.remainder(ten);
			numberInBaseTen = numberInBaseTen.add(digit.multiply(base.pow(x)));
			x++;
			num = num.divide(ten);
		} while (!num.equals(BigInteger.ZERO));

		BigInteger index = BigInteger.valueOf(2);
		boolean divisorFound = false;
		boolean isPrime = false;
		if(numberInBaseTen.isProbablePrime(1)) {
			isPrime =true;
		}
		if (!isPrime) {
//			do {
				return factor(numberInBaseTen,BigInteger.ONE);
				/*
				if (numberInBaseTen.remainder(index).equals(BigInteger.ZERO)) {
					divisor = index;
					divisorFound = true;
					break;
				}

				if (index.equals(numberInBaseTen)) {
					isPrime = true;
					break;
				}
				// index = index.add(BigInteger.ONE);
				index = index.nextProbablePrime();
				// System.out.println(index);

			} while (!isPrime && !divisorFound);
		*/
		}
		return divisor;

	}

	List<BigInteger> isJamCoin(BigInteger num) {

//		System.out.println("num"+ num);
 		List<BigInteger> divisors = new ArrayList<BigInteger>();
		boolean firstDigit = true;
		boolean middleDigit = true;
		boolean lastDigit = true;
		BigInteger number=num;
		BigInteger ten = new BigInteger("10");
		BigInteger digit = num.remainder(ten);
		if (!digit.equals(BigInteger.ONE)) {
			lastDigit = false;
		}
		if (lastDigit) {
			do {
				digit = num.remainder(ten);
				if (!(digit.equals(BigInteger.ONE) || digit
						.equals(BigInteger.ZERO))) {
					middleDigit = false;
					break;
				}
				num = num.divide(ten);
			} while (!num.equals(BigInteger.ZERO));

			if (middleDigit && !digit.equals(BigInteger.ONE)) {
				firstDigit = false;
			}
		}

		if (firstDigit && middleDigit && lastDigit) {
			if(number.isProbablePrime(1))
			{
				return null;
			}
			else {
				for (int i = 2; i <= 10; i++) {
//					System.out.println("i=" + i);

					BigInteger divisor = getDivisor(number,
							BigInteger.valueOf(i));
					if (divisor == null)
						return null;
					else
						divisors.add(divisor);

					// }
					// System.out.println("dvisors for num " +number);
					// System.out.println(divisor);

					// System.out.println("iend");
				}
			}

			return divisors;
		}
		return null;

	}

	ArrayList<String> getJamCoins(int n, int k) {
		ArrayList<String> output = new ArrayList<String>();
		BigInteger ten = BigInteger.TEN;
		BigInteger num = ten.pow(n-1);
		BigInteger limit = ten.pow(n);
		int jamCoins = 0;
		
		Long x=new BigInteger("2").pow(n-1).longValue();

		Long y=new BigInteger("2").pow(n).longValue();
		System.out.println("x : "+x);
		System.out.println("y :" + y);
		for (long i=x;i<y && jamCoins < k ;i++) {
			System.out.println("jamCoins"+ jamCoins);
			BigInteger x1=new BigInteger(Long.toBinaryString(i));
			List<BigInteger> divisors = isJamCoin(x1);
			if (divisors != null) {
				jamCoins++;
				StringBuffer sb = new StringBuffer();
				sb.append(x1);
				sb.append(" ");
				for (BigInteger d : divisors) {
					sb.append(d);
					sb.append(" ");
				}
				output.add(sb.toString().trim());
			
			}
		}
/*
		while (jamCoins < k && num.compareTo(limit)<0) {
			System.out.println("jamCoins"+ jamCoins);

			System.out.println("num"+ num);
			List<BigInteger> divisors = isJamCoin(num);
			if (divisors != null) {
				jamCoins++;
				StringBuffer sb = new StringBuffer();
				sb.append(num);
				sb.append(" ");
				for (BigInteger d : divisors) {
					sb.append(d);
					sb.append(" ");
				}
				output.add(sb.toString().trim());
			
			}
			num = num.add(BigInteger.ONE);
		}
	*/
		return output;

	}

	public static void main(String[] args) {
//		JamCoins jamCoins = new JamCoins();
//		 System.out.println(jamCoins.isJamCoin(new BigInteger("100011")));
//		 System.out.println(jamCoins.getDivisor(new BigInteger("111111"), new
//		 BigInteger("10")));
//		System.out.println(jamCoins.getJamCoins(6, 3));
		String fileName="C:\\gcj\\CodeJam\\files\\problem2\\C-Large.in";
		try {
		
			PrintStream ps=new PrintStream("C:\\gcj\\CodeJam\\files\\problem2\\C-Large.out");
			FileReader fr=new FileReader(fileName);
			BufferedReader br=new BufferedReader(fr);
			String line=br.readLine();
			int t=Integer.parseInt(line);
			
			for(int i=1;i<=t;i++) {
				line=br.readLine();
				if(line!=null) {
					JamCoins jamCoins=new JamCoins();
					String[] s=line.split(" ");
					int n=Integer.parseInt(s[0]);
					int k=Integer.parseInt(s[1]);
					
					ps.println("Case #"+i+": ");
					
					List<String> l=jamCoins.getJamCoins(n, k);
					
					for (String str : l) {
						ps.println(str);
					}
				}
			}
			ps.close();
			br.close();
			fr.close();
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	

	}
}
