package googlecodejam2013;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Reader;

public class TicTacToeTomek {
	private static String X_WON="X won";
	private static String O_WON="O won";
	private static String DRAW="Draw";
	private static String GAME_NOT_COMPLETED="Game has not completed";
	
	public String getGameStatus(Character[][] board){
		boolean isGameNotCompleted = false;
		for(int i=0; i <4; i++){
			String status = getLineStatus(board[i][0], board[i][1],board[i][2],board[i][3]);
			if(status.equals(X_WON) || status.equals(O_WON)){
				return status;
			}else if(!isGameNotCompleted && status.equals(GAME_NOT_COMPLETED)){
				isGameNotCompleted = true;
			}
		}
		
		for(int i=0; i <4; i++){
			String status = getLineStatus(board[0][i], board[1][i],board[2][i],board[3][i]);
			if(status.equals(X_WON) || status.equals(O_WON)){
				return status;
			}else if(!isGameNotCompleted && status.equals(GAME_NOT_COMPLETED)){
				isGameNotCompleted = true;
			}
		}
		
		{//Diagonal one
			String status = getLineStatus(board[0][0], board[1][1],board[2][2],board[3][3]);
			if(status.equals(X_WON) || status.equals(O_WON)){
				return status;
			}else if(!isGameNotCompleted && status.equals(GAME_NOT_COMPLETED)){
				isGameNotCompleted = true;
			}
		}
		

		{//Diagonal two
			String status = getLineStatus(board[0][3], board[1][2],board[2][1],board[3][0]);
			if(status.equals(X_WON) || status.equals(O_WON)){
				return status;
			}else if(!isGameNotCompleted && status.equals(GAME_NOT_COMPLETED)){
				isGameNotCompleted = true;
			}
		}
		
		if(isGameNotCompleted){
			return GAME_NOT_COMPLETED;
		}
		return DRAW;
	}
	
	private String getLineStatus(Character one, Character two, Character three, Character four){
		Character[] arr = new Character[4];
		arr[0]=one;
		arr[1]=two;
		arr[2]=three;
		arr[3]=four;

		int xCount = 0;
		int oCount = 0;
		int tCount = 0;
		int dotCount = 0;
		
		for(Character c: arr){
			if(c == 'X'){
				xCount++;
			}
			else if(c == 'O'){
				oCount++;
			}else if(c == 'T'){
				tCount++;
			}else{
				dotCount++;
			}
		}
		if(xCount == 4 || (xCount == 3 && tCount == 1)){
			return X_WON;
		}else if(oCount == 4 || (oCount == 3 && tCount == 1)){
			return O_WON;
		}else if(dotCount > 0)
		{
			return GAME_NOT_COMPLETED;
		}else {
			return "";
		}
	}
	
	public static void main(String[] argv) {
		try {
			long startTime = System.currentTimeMillis();
			Reader reader = new FileReader("C:\\Users\\AvinashS\\Desktop\\google\\tictactoe\\small.in");
			BufferedReader bufReader = new BufferedReader(reader);
			String x = bufReader.readLine();
			int numOfTestCases = Integer.parseInt(x);
			int count = 0;
	
			File file = new File("C:\\Users\\AvinashS\\Desktop\\google\\tictactoe\\small.out");
			FileWriter writer = new FileWriter(file);
	
			for(count =1; count<= numOfTestCases; count++) {
				Character[][] board = getBoard(bufReader);
				String output = new TicTacToeTomek().getGameStatus(board);
				writer.write("Case #" + count + ": " + output);
				System.out.println("Case #" + count + ": "+ output);
				if(count != numOfTestCases){
					bufReader.readLine();//To read empty line
				}
			}
			writer.close();
			System.out.println("Total time = "
					+ (System.currentTimeMillis() - startTime));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private static Character[][] getBoard(BufferedReader bufReader) throws IOException{
		Character[][] board = new Character[4][4];
		for(int i=0; i < 4;i++){
			String line = bufReader.readLine().trim();
			char[] cArr = line.toCharArray();
			board[i][0] =  cArr[0];
			board[i][1] =  cArr[1];
			board[i][2] =  cArr[2];
			board[i][3] =  cArr[3];
		}
		return board;
	}
}
