package googlecodejam2013;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Reader;
import java.util.ArrayList;

public class LawnMover {

	public boolean isPossible(int[][] pattern, int n, int m){
		for(int i=0; i < n; i++){
			for(int j=0; j < m; j++){
				if(!isNumberPossible(pattern, i, j, n, m, pattern[i][j])){
					return false;
				}
			}
		}
		return true;
	}
	
	private boolean isNumberPossible(int[][] pattern, int row, int col, int n, int m, int num){
		boolean isColPossible = true;
		boolean isRowPossible = true;
		for(int j=0; j < m; j++){
			if(pattern[row][j] > num){
				isRowPossible = false;
				break;
			}
		}
		
		for(int i= 0; i < n; i++){
			if(pattern[i][col] > num){
				isColPossible =  false;
				break;
			}
		}
		return isColPossible || isRowPossible;
	}
	
	public static void main(String[] argv) {
		try {
			long startTime = System.currentTimeMillis();
			Reader reader = new FileReader("C:\\Users\\AvinashS\\Desktop\\google\\lawnmover\\sample.in");
			BufferedReader bufReader = new BufferedReader(reader);
			String x = bufReader.readLine();
			int numOfTestCases = Integer.parseInt(x);
			int count = 0;
	
			File file = new File("C:\\Users\\AvinashS\\Desktop\\google\\lawnmover\\sample.out");
			FileWriter writer = new FileWriter(file);
			for(count =1; count<= numOfTestCases; count++) {
				ArrayList<Integer> nAndM = getIntegerList(bufReader.readLine());
				;
				String output = (new LawnMover().isPossible(getLawnPattern(bufReader, nAndM.get(0), nAndM.get(1)), nAndM.get(0), nAndM.get(1)) ? "YES":"NO");
				writer.write("Case #" + count + ": " + output+"\n");
				System.out.println("Case #" + count + ": " + output);
			}
			writer.close();
			System.out.println("Total time = " + (System.currentTimeMillis() - startTime));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private static int[][] getLawnPattern(BufferedReader bufReader, int n, int m) throws IOException{
		int[][] pattern = new int[n][m];
		
		for(int i =0; i <n; i++){
			ArrayList<Integer> rowList = getIntegerList(bufReader.readLine());
			
			for(int j=0; j<m;j++){
				pattern[i][j] = rowList.get(j);
			}
		}
		return pattern;
	}
	
	private static ArrayList<Integer> getIntegerList(String s) {
		ArrayList<Integer> intList = new ArrayList<Integer>();
		String[] strArr = s.split(" ");
		for (String str : strArr) {
			intList.add(Integer.parseInt(str.trim()));
		}
		return intList;
	}
	
}
