package codejam2014;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.Reader;
import java.util.ArrayList;
import java.util.Collections;

public class DeceitfulWar {

	public int getDeceitfulWarScore(ArrayList<Float> naomiBlocks, ArrayList<Float> kenBlocks){
		Collections.sort(naomiBlocks);
		Collections.sort(kenBlocks);
		
		int numberOfBlocks = naomiBlocks.size();
		int kenEnd = numberOfBlocks -1;//as both has same number of blocks
		int kenPointer = 0;
		int naomiWin =0;
		
		for(int i =0; i < naomiBlocks.size(); i++){
			if(kenBlocks.get(kenPointer).compareTo(naomiBlocks.get(i)) > 0){
				kenEnd--;//Naomi bound to loose this, she will let it go with biggest of ken
				continue;
			}
			naomiWin ++;//Can win by telling a weight higher than max of ken's weight
			kenPointer++;//ken will play its lowest at this point
		}
		return naomiWin;
	}
	
	public int getWarScore(ArrayList<Float> naomiBlocks, ArrayList<Float> kenBlocks){
		Collections.sort(naomiBlocks);
		Collections.sort(kenBlocks);
		
		int naomiWin =0;
		int kenPointer = 0;
		
		for(int i =0; i < naomiBlocks.size(); i++){
			while(kenBlocks.get(kenPointer).compareTo(naomiBlocks.get(i)) < 0){
				naomiWin++;
				kenPointer++;
				if(kenPointer >= kenBlocks.size()){
					break;
				}
			}
			kenPointer++;
			if(kenPointer >= kenBlocks.size()){
				break;
			}
		}
		return naomiWin;
	}
	
	public static void main(String[] argv) {
		try {
			long startTime = System.currentTimeMillis();
			Reader reader = new FileReader("C:\\Users\\AvinashS\\Desktop\\google\\war\\small.in");
			BufferedReader bufReader = new BufferedReader(reader);
			String x = bufReader.readLine();
			int numOfTestCases = Integer.parseInt(x);
			int count = 0;
	
			File file = new File("C:\\Users\\AvinashS\\Desktop\\google\\war\\small.out");
			FileWriter writer = new FileWriter(file);
			for(count =1; count<= numOfTestCases; count++) {
				bufReader.readLine();//ignore number of blocks input
				ArrayList<Float> naomiBlocks = getFloatList(bufReader.readLine());
				ArrayList<Float> kenBlocks = getFloatList(bufReader.readLine());
				int deceitfulScore =  new DeceitfulWar().getDeceitfulWarScore(naomiBlocks, kenBlocks);
				String output = new DeceitfulWar().getWarScore(naomiBlocks, kenBlocks)+"";
				writer.write("Case #" + count + ": " +deceitfulScore + " "+ output+"\n");
				System.out.println("Case #" + count + ": " + deceitfulScore +" " + output);
			}
			writer.close();
			System.out.println("Total time = " + (System.currentTimeMillis() - startTime));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private static ArrayList<Float> getFloatList(String s) {
		ArrayList<Float> intList = new ArrayList<Float>();
		String[] strArr = s.split(" ");
		for (String str : strArr) {
			intList.add(Float.parseFloat(str.trim()));
		}
		return intList;
	}
}
