import java.io.File;
import java.io.FileWriter;
import java.util.*;

public class R1B1 {
    private static final String input = "B-large.in";


    public static String solve(Scanner input, int test) {
        Map<String, Integer> map = new HashMap<>();
        int N = input.nextInt();
        int R = input.nextInt();
        map.put("R", R);
        int O = input.nextInt();
        map.put("RY", O);
        int Y = input.nextInt();
        map.put("Y", Y);
        int G = input.nextInt();
        map.put("YB", G);
        int B = input.nextInt();
        map.put("B", B);
        int V = input.nextInt();
        map.put("RB", V);

        Map<String, String> pair = new HashMap<>();
        pair.put("YB", "R");
        pair.put("RB", "Y");
        pair.put("RY", "B");

        String a = build("YB", map, pair, N);
        String b = build("RB", map, pair, N);
        String c = build("RY", map, pair, N);

        R = map.getOrDefault("R", 0) + a==null? 0:1;
        Y = map.getOrDefault("Y", 0) + b==null? 0:1;
        B = map.getOrDefault("B", 0) + c==null? 0:1;

        int half = N/2;
        if (R>half || B>half || Y>half) return "IMPOSSIBLE";
        List<int[]> l = new ArrayList<>();
        l.add(new int[]{'R', R});
        l.add(new int[]{'B', B});
        l.add(new int[]{'Y', Y});
        Collections.sort(l, (a1,a2)-> {
            return a2[1] - a1[1];
        });

        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < l.get(0)[1]; i++) {
            sb.append((char) l.get(0)[0]);
        }
        for (int i = 0; i < l.get(1)[1]; i++) {
            sb.insert(i*2+1, (char) l.get(1)[0]);
        }
        for (int i = 0; i < l.get(2)[1]; i++) {
            sb.insert(i*3+1, (char) l.get(2)[0]);
        }
        if (a==null && b==null)
            return c==null? "IMPOSSIBLE": c;
        if (a==null && c==null)
            return b==null? "IMPOSSIBLE": b;
        if (c==null && b==null)
            return a==null? "IMPOSSIBLE": a;

        String ret = sb.toString();
        int idx = 0;
        if (a!=null && !a.isEmpty()) {
            idx = ret.indexOf(a.charAt(0));
            ret = ret.substring(0, idx) + a + ret.substring(idx+1);
            idx += a.length();
        }
        if (b!=null && !b.isEmpty()) {
            idx = ret.indexOf(b.charAt(0));
            ret = ret.substring(0, idx) + b + ret.substring(idx+1);
            idx += b.length();
        }
        if (c!=null && !c.isEmpty()) {
            idx = ret.indexOf(c.charAt(0));
            ret = ret.substring(0, idx) + c + ret.substring(idx+1);
            idx += c.length();
        }

        return ret;
    }

    static String build(String combo, Map<String, Integer> map, Map<String, String> pair, int N) {
        if (map.get(combo) == 0) return null;
        StringBuilder sb = new StringBuilder();
        String other = pair.get(combo);
        int count = map.get(other);
        if (count < map.get(combo) + 1 && N > map.get(combo) * map.get(other)) {
            return null;
        }
        if (count >= map.get(combo) + 1) {
            sb.append(other);
        } else if (count < map.get(combo)) {
            return null;
        } else if (N > map.get(combo) + map.get(other) ){
            assert count == map.get(combo);
            return null;
        }
        assert count >= map.get(combo);

        Map<String, String> c = new HashMap<>();
        c.put("YB", "G");
        c.put("RB", "V");
        c.put("RY", "O");
        for (int i = 0; i < map.get(combo); i++) {
            sb.append(c.get(combo));
            sb.append(other);
        }

        map.put(other, map.get(other) - map.get(combo) -1);
        if (map.get(other) == 0) map.remove(other);
        map.remove(combo);

        return sb.toString();
    }

    public static void main(String[] args) {
        try {
            Scanner in = new Scanner(new File(input));
            FileWriter out = new FileWriter(new File("dat.out"));
            int n = in.nextInt();

            for (int i=0;i<n;i++) {
                out.write(String.format("Case #%s: %s\n", i+1, solve(in, i+1)));
            }
            out.flush();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
