package compete;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class Tomek {

	static PrintWriter out;

	private static void print(String string) {
		out.println(string);
	}

	public static void main(String[] args) {
		File f = new File("input");
		try {
			out = new PrintWriter(new BufferedWriter(new FileWriter("output")));
			Scanner sc = new Scanner(f);

			// number of test cases
			int n = sc.nextInt();
			sc.nextLine();

			for (int i = 0; i < n; i++) {
				char[][] config = new char[4][4];
				boolean hasSpace = false;
				for (int j = 0; j < 4; j++) {
					String line = sc.nextLine();
					if (line.contains(".")) hasSpace = true;
					config[j] = line.toCharArray();
//					print(Arrays.toString(config[j]));
				}
				// solve it
				solve(i + 1, config, hasSpace);
				if (sc.hasNext())
					sc.nextLine();
			}

		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			out.close();
		}
	}

	private static void solve(int index, char[][] config, boolean hasSpace) {
		String res = "";

		boolean xWin = checkStatus('X', config);
		boolean oWin = checkStatus('O', config);

		if (xWin && oWin) {
			res = "Draw";
		} else if (xWin) {
			res = "X won";
		} else if (oWin) {
			res = "O won";
		} else if (hasSpace) {
			res = "Game has not completed";
		} else {
			res = "Draw";
		}
		print(String.format("Case #%s: %s", index, res));
	}

	private static boolean checkStatus(char c, char[][] config) {

		char[] four = new char[4];
		for (int i = 0; i < 4; i++) {

			four = config[i];
			if (checkFour(c, four))
				return true;

			four = new char[4];
			for (int j = 0; j < 4; j++)
				four[j] = config[j][i];
			if (checkFour(c, four))
				return true;
		}

		// check diagonal
		four[0] = config[0][0];
		four[1] = config[1][1];
		four[2] = config[2][2];
		four[3] = config[3][3];
		if (checkFour(c, four))
			return true;

		four[0] = config[0][3];
		four[1] = config[1][2];
		four[2] = config[2][1];
		four[3] = config[3][0];
		if (checkFour(c, four))
			return true;

		return false;
	}

	private static boolean checkFour(char c, char[] four) {
		boolean win = true;
		for (int j = 0; j < 4; j++) {
			if (four[j] != c && four[j] != 'T') {
				win = false;
				break;
			}
		}
		return win;
	}
}
