package me.derekzeng.codejam;
import java.util.*;
import java.io.*;


public class Codejam {
    public static long[] solve(long n, long k) {
        TreeMap<Long, Long> map = new TreeMap<>();
        map.put(n, 1L);

        long[] ret = null;
        while (!map.isEmpty() && k > 0) {
            // largest segment;
            long s = map.lastKey();
            long m = Math.min(map.get(s), k);
            map.remove(s);

            long half = s/2;
            if (s%2==1) {
                map.put(half, map.getOrDefault(half, 0L) + 2 * m);
                ret = new long[]{half, half};
            } else {
                map.put(half, map.getOrDefault(half, 0L) + m);
                map.put(half - 1, map.getOrDefault(half - 1, 0L) + m);
                ret = new long[]{half, half - 1};
            }
            k-=m;
        }

        return ret;
    }

    public static void main(String[] args) {
        try {
            Scanner in = new Scanner(new File("input.dat"));
            FileWriter out = new FileWriter(new File("output.dat"));
            int n = in.nextInt();

            for (int i=0;i<n;i++) {
                long m = in.nextLong();
                long k = in.nextLong();
                long[] res = solve(m, k);
                out.write(String.format("Case #%s: %s %s\n", i+1, res[0], res[1]));
            }
            out.flush();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
