package me.derekzeng.codejam;
import java.util.*;
import java.io.*;


public class Codejam {
    public static int[] solve(int n, int k) {
        Queue<int[]> queue = new PriorityQueue<>(1, (a,b)-> {
            int len1 = a[1] - a[0];
            int len2 = b[1] - b[0];
            return len1==len2?a[0] - b[0]: len2 - len1;
        });
        queue.offer(new int[]{0, n});
        int[] ret = null;
        while (!queue.isEmpty() && k > 0) {
            // largest segment;
            int[] segment = queue.poll();
            int len = segment[1] - segment[0];
            int[] left, right;
            if (len % 2 == 1) {
                left = new int[]{segment[0], segment[0] + len/2};
                right = new int[]{segment[1] - len/2, segment[1]};
            } else {
                left = new int[]{segment[0], segment[0] + len/2-1};
                right = new int[]{segment[1] - len/2, segment[1]};
            }
            queue.offer(left);
            queue.offer(right);
            ret = new int[]{right[1]-right[0], left[1]-left[0]};
            k--;
        }

        return ret;
    }

    public static void main(String[] args) {
        try {
            Scanner in = new Scanner(new File("input.dat"));
            FileWriter out = new FileWriter(new File("output.dat"));
            int n = in.nextInt();

            for (int i=0;i<n;i++) {
                int m = in.nextInt();
                int k = in.nextInt();
                int[] res = solve(m, k);
                out.write(String.format("Case #%s: %s %s\n", i+1, res[0], res[1]));
            }
            out.flush();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
