import java.io.File;
import java.io.FileWriter;
import java.util.Arrays;
import java.util.DoubleSummaryStatistics;
import java.util.Scanner;


public class R1B3 {
    private static final String input = "C-small-attempt0.in";


    public static String solve(Scanner input, int test) {
        int n = input.nextInt();
        int q = input.nextInt();  // 1 for small
        long[][] horses = new long[n][2];
        long[] path = new long[n];
        for (int i = 0; i < n; i++) {
            // dist, speed
            horses[i] = new long[]{input.nextLong(), input.nextLong()};
        }
        long[][] dist = new long[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                dist[i][j] = input.nextLong();
            }
            if (i<n-1)
                path[i] = dist[i][i+1];
        }

        input.nextInt(); // start
        input.nextInt(); // end
        double best = getBest(path, horses, 0, 0, 0, 0);

        return "" + best;
    }

    static double getBest(long[] path, long[][] horses, int cur, double curTime, double curSpeed, double distRemaining) {
        if (cur == path.length) {
            return curTime;
        }

        if (distRemaining < path[cur]) {
            if (horses[cur][0] < path[cur]) return Double.MAX_VALUE;

            // change
            return getBest(path, horses, cur+1, curTime + ((double) path[cur] / horses[cur][1]), horses[cur][1], horses[cur][0] - path[cur]);
        }

        return Math.min(
                getBest(path, horses, cur+1, curTime + ((double) path[cur] / horses[cur][1]), horses[cur][1], horses[cur][0] - path[cur]),
                getBest(path, horses, cur+1, curTime + ((double) path[cur]) / curSpeed, curSpeed, distRemaining - path[cur])
        );
    }

    public static void main(String[] args) {
        try {
            Scanner in = new Scanner(new File(input));
            FileWriter out = new FileWriter(new File("dat.out"));
            int n = in.nextInt();

            for (int i=0;i<n;i++) {
                out.write(String.format("Case #%s: %s\n", i+1, solve(in, i+1)));
            }
            out.flush();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
