package compete;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Fair {
	static PrintWriter out;

	private static void print(String string) {
		out.println(string);
	}

	public static void main(String[] args) {
		File f = new File("input");
		try {
			out = new PrintWriter(new BufferedWriter(new FileWriter("output")));
			Scanner sc = new Scanner(f);

			// number of test cases
			int n = sc.nextInt();

			for (int i = 0; i < n; i++) {

				int A = sc.nextInt();
				int B = sc.nextInt();

				// solve it
				solve(i + 1, A, B);
			}

		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			out.close();
		}
	}

	private static void solve(int index, int a, int b) {
		int total = 0;

		for (int i = a; i <= b; i++) {
			if (isFairAndSquare(i)) {
				total++;
			}
		}

		print(String.format("Case #%s: %s", index, total));
	}

	private static boolean isFairAndSquare(int i) {
		return isPalindrome(i) && isSquare(i);
	}

	private static boolean isSquare(int i) {
		double sqrt = Math.sqrt(i);
		int sq = (int) sqrt;
		return sq * sq == i && isPalindrome(sq);
	}

	private static boolean isPalindrome(int i) {
		String num = i + "";
		char[] chs = num.toCharArray();

		for (int j = 0; j < chs.length / 2; j++) {
			char c1 = chs[j];
			char c2 = chs[chs.length - j - 1];
			if (c1 != c2)
				return false;
		}
		return true;
	}
}
