package compete;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

public class Lawnmower {
	static PrintWriter out;

	private static void print(String string) {
		out.println(string);
	}

	public static void main(String[] args) {
		File f = new File("input");
		try {
			out = new PrintWriter(new BufferedWriter(new FileWriter("output")));
			Scanner sc = new Scanner(f);

			// number of test cases
			int n = sc.nextInt();

			for (int i = 0; i < n; i++) {

				int N = sc.nextInt();
				int M = sc.nextInt();

				Integer[][] pattern = new Integer[N][M];

				for (int j = 0; j < N; j++) {
					for (int k = 0; k < M; k++) {
						pattern[j][k] = sc.nextInt();
					}
					// print(Arrays.toString(pattern[j]));
				}
				// solve it
				solve(i + 1, N, M, pattern);
			}

		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			out.close();
		}
	}

	private static void solve(int index, int n, int m, Integer[][] pattern) {

		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (!checkCell(i, j, pattern)) {
					print(String.format("Case #%s: %s", index, "NO"));
					return;
				}
			}
		}
		print(String.format("Case #%s: %s", index, "YES"));
	}

	private static boolean checkCell(int i, int j, Integer[][] pattern) {
		int ele = pattern[i][j];
		List<Integer> l = new ArrayList<Integer>();
		l.addAll(Arrays.asList(pattern[i]));
		Collections.sort(l);
		if (ele == l.get(l.size() -1 )) return true;
		
		l.clear();
		for (int k=0;k<pattern.length;k++) {
			l.add(pattern[k][j]);
		}
		
		Collections.sort(l);
		if (ele == l.get(l.size() -1 )) return true;
		
		return false;
	}
}
