package com.google.codejam.searchswitches;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

public class SearchSwitch {

	public void go() throws Exception  {
		BufferedReader br = new BufferedReader(new FileReader("C:\\Topcoder\\gcj\\A-small-attempt2.in"));
		int N = Integer.parseInt(br.readLine());
		for(int i=0; i<N; i++) {
			TestCase testCase = parseTestCase(br, i+1);
			testCase.process();
		}
	}
	
	TestCase parseTestCase(BufferedReader br, int caseno) throws Exception  {
		TestCase testCase = new TestCase();
		testCase.setCaseNumber(caseno);
		int S =  Integer.parseInt(br.readLine());
		testCase.setSearchEngines(S);
		for(int i=0; i<S; i++) {
			String searchEngine = br.readLine();
			testCase.getSearchEngineList().add(searchEngine);
		}
		
		int Q = Integer.parseInt(br.readLine());
		for(int i=0; i<Q; i++) {
			String query = br.readLine();
			testCase.getQueryList().add(query);
		}
		return testCase;
	}
	
	public static void main(String[] args)  throws Exception {
		new SearchSwitch().go();
	}
}


class TestCase {
	int caseNumber;
	int searchEngines;
	Set<String> searchEngineList = new HashSet<String>();
	
	int queries;
	List<String> queryList = new LinkedList<String>();
	
	
	
	public void process() {
		Set<String> searchList = cloneSet(searchEngineList);
		int switches = 0;
		Iterator<String> itq = queryList.iterator();
		while(itq.hasNext()) {
			String query = itq.next();
			if(searchList.contains(query)) {
				searchList.remove(query);
			}
			if(searchList.size() == 0) {
				switches++;
				searchList = cloneSet(searchEngineList);
				searchList.remove(query);
			}
		}
		System.out.println("Case #" + caseNumber + ": " + switches);
	}

	private Set<String> cloneSet(Set<String> source) {
		Set<String> destination = new HashSet<String>();
		Iterator<String> it = source.iterator();
		while(it.hasNext()) {
			destination.add(it.next());
		}
		return destination;
	}
	
	public int getSearchEngines() {
		return searchEngines;
	}
	public void setSearchEngines(int searchEngines) {
		this.searchEngines = searchEngines;
	}
	public Set<String> getSearchEngineList() {
		return searchEngineList;
	}
	public void setSearchEngineList(Set<String> searchEngineList) {
		this.searchEngineList = searchEngineList;
	}
	public int getQueries() {
		return queries;
	}
	public void setQueries(int queries) {
		this.queries = queries;
	}
	public List<String> getQueryList() {
		return queryList;
	}
	public void setQueryList(List<String> queryList) {
		this.queryList = queryList;
	}

	public int getCaseNumber() {
		return caseNumber;
	}

	public void setCaseNumber(int caseNumber) {
		this.caseNumber = caseNumber;
	}
	
	
}


