package com.google.codejam.searchswitches;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.StringTokenizer;

public class Trains {

	public void go() throws Exception  {
		BufferedReader br = new BufferedReader(new FileReader("C:\\Topcoder\\gcj\\B-large.in"));
		int N = Integer.parseInt(br.readLine());
		for(int i=0; i<N; i++) {
			TrainTestCase testCase = new TrainTestCase(br, i + 1);
			testCase.process();
		}
	}
	
	public static void main(String[] args)  throws Exception {
		new Trains().go();
	}
}


class TrainTestCase {
	int turnaround;
	int testNo;
	List<TrainSchedule> scheduleA = new LinkedList<TrainSchedule>();
	List<TrainSchedule> scheduleB = new LinkedList<TrainSchedule>();
	public TrainTestCase(BufferedReader br, int testNo) throws Exception {
		this.testNo = testNo;
		turnaround  =  Integer.parseInt(br.readLine());
		String line = br.readLine();
		StringTokenizer tokenizer = new StringTokenizer(line, " ");
		int na = Integer.parseInt(tokenizer.nextToken());
		int nb = Integer.parseInt(tokenizer.nextToken());
		for(int i=0; i<na; i++) {
			line = br.readLine();
			tokenizer = new StringTokenizer(line, " ");
			scheduleA.add(new TrainSchedule(tokenizer.nextToken(), tokenizer.nextToken()));
		}
		for(int i=0; i<nb; i++) {
			line = br.readLine();
			tokenizer = new StringTokenizer(line, " ");
			scheduleB.add(new TrainSchedule(tokenizer.nextToken(), tokenizer.nextToken()));
		}
		
	}
	
	public void process() {
		int size = 24 * 60 + turnaround;
		short[] freeA = new short[size];
		short[] freeB = new short[size];
		int minA = 0; 
		int minB = 0;
		Iterator<TrainSchedule> it = scheduleA.iterator();
		while(it.hasNext()) {
			TrainSchedule schedule = it.next();
			try {
				for(int i=schedule.getStartTime(); i<size; i++) {
					freeA[i]--;
					if(i >= schedule.getEndTime() + turnaround)
						freeB[i]++;
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
			
		}
		
		it = scheduleB.iterator();
		while(it.hasNext()) {
			TrainSchedule schedule = it.next();
			try {
				for(int i=schedule.getStartTime(); i<size; i++) {
					freeB[i]--;
					if(i >= schedule.getEndTime() + turnaround)
						freeA[i]++;
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
			
		}

		for(int i=0; i<size; i++) {
			minA = Math.min(minA, freeA[i]);
			minB = Math.min(minB, freeB[i]);
		}

		System.out.println("Case #" + testNo + ": " + 
				Math.abs(minA) + " " + 
				Math.abs(minB));
		
	}
}

class TimeSnap {
	public static int freeTrainsA = 0;
	public static int freeTrainsB = 0;
	
}


class TrainSchedule {
	int startTime;
	int endTime;
	
	public TrainSchedule(String start, String end) {
		startTime = toInt(start);
		endTime = toInt(end);
	}
	
	private int toInt(String s) {
		int hh = Integer.parseInt(s.substring(0, 2));
		int mm = Integer.parseInt(s.substring(3, 5));
		return hh * 60 + mm;
		
	}
	
	public int getStartTime() {
		return startTime;
	}
	
	public int getEndTime() {
		return endTime;
	}
}
