package com.codejam.cookieclicker;

import java.text.DecimalFormat;

public class Executor {

	public static String execute(TestCase testCase) {
		double productionCapability = 2;
		double newFarmCost = testCase.newFarmCost;
		double targetProduction = testCase.targetProduction;
		double timeTakenForExpansion = 0;
		double attempt1Time = 0;
		double attempt2Time = 0;
		
		do{			
			attempt1Time = calculateProductionTime(targetProduction, productionCapability) + timeTakenForExpansion;
			//sell
			timeTakenForExpansion += testCase.newFarmCost/productionCapability;
			productionCapability += testCase.productionGain;
			attempt2Time = calculateProductionTime(targetProduction, productionCapability) + timeTakenForExpansion;
		} while(attempt1Time > attempt2Time);
		DecimalFormat df = new DecimalFormat();
		df.setMinimumFractionDigits(7);
		df.setMaximumFractionDigits(7);
		return df.format(attempt1Time).replace(",", "");
	}

	private static double calculateProductionTime(double targetProduction, double productionCapability) {
		return targetProduction/productionCapability;
	}

}
