package com.codejam.deceitfulwar;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

public class Executor {

	public static String execute(TestCase testCase) {
		long naomiDecietfulWarScore = getNaomiDecietfulWarScore(testCase);
		long naomiWarScore = getNaomiWarScore(testCase);
		
		return naomiDecietfulWarScore+" "+naomiWarScore;
	}

	private static long getNaomiDecietfulWarScore(TestCase testCase) {
		List<Double> naomiWeightBlock = new ArrayList<Double>(testCase.getNaomiBlocksWeight());
		long naomiScore = 0;
		for(int i = 0; i < testCase.getKenBlocksWeight().size(); i++){
			if(hasMoreWeightBlock1(naomiWeightBlock, testCase.getKenBlocksWeight().get(i))){
				naomiScore++;
			}
		}
		return naomiScore;
	}
	
	private static boolean hasMoreWeightBlock1(List<Double> naomiWeightBlock, Double kenBlockWeight) {
		for(int i = 0; i < naomiWeightBlock.size(); i++){
			if(naomiWeightBlock.get(i) > kenBlockWeight){
				naomiWeightBlock.remove(i);
				return true;
			}			
		}
		naomiWeightBlock.remove(0);
		return false;
	}

	private static long getNaomiWarScore(TestCase testCase) {
		List<Double> kenWeightBlock = new ArrayList<Double>(testCase.getKenBlocksWeight());
		long kenScore = 0;
		for(int i = 0; i < testCase.getNaomiBlocksWeight().size(); i++){
			if(hasMoreWeightBlock(kenWeightBlock, testCase.getNaomiBlocksWeight().get(i))){
				kenScore++;
			}
		}
		return testCase.getNaomiBlocksWeight().size()-kenScore;
	}

	private static boolean hasMoreWeightBlock(List<Double> kenWeightBlock, Double naomiBlockWeight) {
		for(int i = 0; i < kenWeightBlock.size(); i++){
			if(kenWeightBlock.get(i) > naomiBlockWeight){
				kenWeightBlock.remove(i);
				return true;
			}			
		}
		kenWeightBlock.remove(0);
		return false;
	}

	private static boolean isNaomiBlockHeaviest(Double blockWeightNaomi,TestCase testCase) {
		for (Double blockWeightKen : testCase.getKenBlocksWeight()) {
			if (blockWeightNaomi < blockWeightKen)
				return false;
		}
		return true;
	}

}
