package com.codejam.fs;


import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;

public class FairAndSquare {

	/**
	 * @param args
	 * @throws IOException
	 * @throws NumberFormatException
	 */
	public static void main(String[] args) throws NumberFormatException,
			IOException {
		List<TestCase> cases = FileParser.getTestCases("C:\\C-small-attempt1 (1).in");
		List<String> result = new ArrayList<String>();
		StringBuilder sb = new StringBuilder();
		int count = 1;
		for (TestCase testCase : cases) {
			//long resultL = getResult(testCase);
			sb.append("Case #" + count + ": " + getResult(testCase) + "\n");
			count++;
		}
		PrintStream out = null;
		try {
			out = new PrintStream(new FileOutputStream("C:\\out.txt"));
			out.print(sb.toString());
		} finally {
			if (out != null)
				out.close();
		}
	}

	private static long getResult(TestCase testCase) {
		long fns = 0;
		for (long i = getRoundedSqrt(testCase.from); i <= testCase.to; i++) {
			long sqr = i*i;
			if(sqr > testCase.to){
				return fns;
			}
			if (isFair(sqr)) {
				if (isFair(i)){
					fns++;
					//System.out.println(i);
				}				
			}
		}
		return fns;
	}

	private static long getRoundedSqrt(long from) {
		double sqrt = Math.sqrt(from);
		long rounded = (long) sqrt;
		if(sqrt % 1D > 0){
			rounded = ((long) sqrt)+1;
		}
		return rounded;
	}

	private static boolean isFair(long n) {
		if(n % 10 == 0){
			return false;
		}
		 long num = n;
		 long rev = 0;
		 while (num > 0)
		 {
		      long dig = num % 10;
		      rev = rev * 10 + dig;
		      num = num / 10;
		 }
		if(n == rev){
			return true;
		}
		return false;
	}
	
	public final static long isPerfectSquare(long value)
	{
		
	  /*if (n < 0)
	    return false;

	  long tst = (long)(Math.sqrt(n));
	  return tst*tst == n;*/
		double sqrt = Math.sqrt(value);
		if( sqrt % 1F > 0F){
			return -1;
		}
		return (long) sqrt;
	}
}
