import java.io.*;
import java.util.*;

public class Solution4 {
    private final static long maxPrime = 10000000L;
    private final static long MAX = 100000000000000L;
    private final static long SIZE = 1000000L;
    private final static long CAPACITY = 100000000L;
    
    private static boolean[] isPal = new boolean[(int)maxPrime+1];
    private static long[] count = new long[(int)SIZE+1];
    
    private static boolean isPalindrome(Long N) {
        String s = N.toString();
        int length = s.length();
        
        for(int i = 0; i < length/2; ++i) {
            if(s.charAt(i) != s.charAt(length-1-i))
                return false;
        }
        
        return true;
    }
    
    private static void initialize() {
        Arrays.fill(isPal, false);
        
        for(long i = 1; i <= maxPrime; ++i) {
            
            if(isPalindrome(i)) {
                isPal[(int)i] = true;
                long num = i*i;
                
                if(isPalindrome(num))
                    count[(int)(num/CAPACITY)]++;
            }
            
        }
        
        for(int i = 1; i <= SIZE; ++i)
            count[i] += count[i-1];
    }
    
    public static void main(String[] args) {
        InputReader in = new InputReader(System.in);
        
        int T = in.readInt();
        
        initialize();
        
        for(int c = 1; c <= T; ++c) {
            int A = in.readInt();
            int B = in.readInt();
            
            int countA = 0;
            int countB = 0;

            if(A <= B) {
            
            int idx = (int)(A/CAPACITY);        
            if(idx > 0)
                countA += count[idx-1];      
            long start = (long)Math.ceil(Math.sqrt(idx*CAPACITY));
            for(long i = start; i < Math.sqrt(A); ++i) {
                if(isPal[(int)i]) {
                    long num = i*i;
                    if(isPalindrome(num))
                        countA++;
                }
            }
            
            idx = (int)(B/CAPACITY);        
            if(idx > 0)
                countB += count[idx-1];      
            start = (long)Math.ceil(Math.sqrt(idx*CAPACITY));
            for(long i = start; i <= Math.sqrt(B); ++i) {
                if(isPal[(int)i]) {
                    long num = i*i;
                    if(isPalindrome(num))
                        countB++;
                }
            }
            
            
            System.out.println("Case #"+c+": "+(countB-countA));
            }
            else
                System.out.println("Case #"+c+": 0");
        }
        
        System.exit(0);
    }
}

class InputReader {
    private int numChars;
    private int curChar;
    private byte[] buf = new byte[1024];
    private InputStream stream;
 
    public InputReader(InputStream stream) {
        this.stream = stream;
    }
 
    public int read() {
        if(numChars < 0)
            return 0;
        if(curChar >= numChars) {
            curChar = 0;
            try {
                numChars = stream.read(buf);
            }
            catch(IOException e) {
                return 0;
            }
            if(numChars <= 0) {
                return -1;
            }
        }
        return buf[curChar++];
    }
 
    public int readInt() {
        int c = read();
        while(isSpaceChar(c)) {
            c = read();
        }
        int res = 0;
        int sgn = 1;
        if(c == '-') {
            sgn = -1;
            c = read();
        }
        do {
            if(c < '0' || c > '9')
                return 0;
            res *= 10;
            res += c-'0';
            c = read();
        } while(!isSpaceChar(c));
 
        return res*sgn;
    }
 
    public static boolean isSpaceChar(int c) {
        return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
    }
}     