import java.io.*;
import java.util.*;

public class C {
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter out = new PrintWriter(System.out);

		int T = Integer.parseInt(br.readLine());
		for (int t = 1; t <= T; ++t) {
			StringTokenizer st = new StringTokenizer(br.readLine());
			int N = Integer.parseInt(st.nextToken());
			int K = Integer.parseInt(st.nextToken());
			PriorityQueue<Interval> pq = new PriorityQueue<Interval>(K, new IntervalComparator());
			Interval int1 = new Interval(1, N);
			pq.add(int1);
			for (int i = 0; i < K-1; ++i) {
				Interval temp = pq.remove();
				int end = temp.end;
				int start = temp.start;
				int mid = (end-start)/2 + start;
				Interval new1 = new Interval(start, mid-1);
				Interval new2 = new Interval(mid+1, end);
				pq.add(new1);
				pq.add(new2);
			}
			
			Interval temp = pq.remove();
			int mid = (temp.end-temp.start)/2 + temp.start;
			int Ls = mid-temp.start;
			int Rs = temp.end-mid;
			int num1 = Math.max(Ls, Rs);
			int num2 = Math.min(Ls, Rs);
			out.println("Case #"+t+": "+num1+" "+num2);
		}

		out.flush();
		System.exit(0);
	}

}

class IntervalComparator implements Comparator<Interval>
{
	public int compare(Interval int1, Interval int2) {
		int end1 = int1.end;
		int start1 = int1.start;
		int mid1 = (end1-start1)/2 + start1;
		int Ls1 = mid1-start1;
		int Rs1 = end1-mid1;
	
		int end2 = int2.end;
		int start2 = int2.start;
		int mid2 = (end2-start2)/2 + start2;
		int Ls2 = mid2-start2;
		int Rs2 = end2-mid2;
	
		if (Math.min(Ls1, Rs1) > Math.min(Ls2, Rs2)) {
			return -1;
		}
		else if (Math.min(Ls1, Rs1) < Math.min(Ls2, Rs2)) {
			return 1;
		}
		else {
			if (Math.max(Ls1, Rs1) > Math.max(Ls2, Rs2)) {
				return -1;
			}
			else if (Math.max(Ls1, Rs1) < Math.max(Ls2, Rs2)) {
				return 1;
			}
			else {
				return mid1-mid2;
			}
		}
	}
}

class Interval {
	public int start;
	public int end;
	public Interval(int start, int end) {
		this.start = start;
		this.end = end;
	}
}			 
