import java.io.*;

public class Solution3 {
    private static int[] count = new int[10001];
    
    private static boolean isPalindrome(Integer N) {
        String s = N.toString();
        int length = s.length();
        
        for(int i = 0; i < length/2; ++i) {
            if(s.charAt(i) != s.charAt(length-1-i))
                return false;
        }
        
        return true;
    }
    
    private static void initialize() {
        for(int i = 1; i <= 1000; ++i) {
            int num = i*i;
            if(isPalindrome(i) && num <= 1000 && isPalindrome(num))
                count[num]++;
        }
        
        for(int i = 1; i <= 1000; ++i)
            count[i] += count[i-1];
    }
    
    public static void main(String[] args) {
        InputReader in = new InputReader(System.in);
        
        int T = in.readInt();
        
        initialize();
        
        for(int c = 1; c <= T; ++c) {
            int A = in.readInt();
            int B = in.readInt();
            
            System.out.println("Case #"+c+": "+(count[B]-count[A-1]));
        }
        
        System.exit(0);
    }
}

class InputReader {
    private int numChars;
    private int curChar;
    private byte[] buf = new byte[1024];
    private InputStream stream;
 
    public InputReader(InputStream stream) {
        this.stream = stream;
    }
 
    public int read() {
        if(numChars < 0)
            return 0;
        if(curChar >= numChars) {
            curChar = 0;
            try {
                numChars = stream.read(buf);
            }
            catch(IOException e) {
                return 0;
            }
            if(numChars <= 0) {
                return -1;
            }
        }
        return buf[curChar++];
    }
 
    public int readInt() {
        int c = read();
        while(isSpaceChar(c)) {
            c = read();
        }
        int res = 0;
        int sgn = 1;
        if(c == '-') {
            sgn = -1;
            c = read();
        }
        do {
            if(c < '0' || c > '9')
                return 0;
            res *= 10;
            res += c-'0';
            c = read();
        } while(!isSpaceChar(c));
 
        return res*sgn;
    }
 
    public static boolean isSpaceChar(int c) {
        return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
    }
}     