package travel;

import java.io.FileReader;
import java.io.LineNumberReader;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class Watershed {
	public static void main(String[] args) throws Exception {

		LineNumberReader reader = new LineNumberReader(new FileReader(
//				"C:/univ/samp.in"));
//	"C:/codejam/watershed/sample.in"));
	"C:/codejam/watershed/B-small-attempt0.in"));
		int numMaps = Integer.parseInt(reader.readLine());
		for (int i = 0; i < numMaps; i++) {

			String[] areas = reader.readLine().split(" ");
			int h = Integer.parseInt(areas[0]);
			int w = Integer.parseInt(areas[1]);

			int[][] matrix = new int[w+2][h+2];

			//initialize borders
			for (int x=0; x<w+2; x++) {
				matrix[x][0] = 101;
				matrix[x][h+1] = 101;
			}

			for (int y=0; y<h+2; y++) {
				matrix[0][y] = 101;
				matrix[w+1][y] = 101;
			}

			//read map in
			for (int y=1; y<h+1; y++) {
				String[] rowContents = reader.readLine().split(" ");

				for (int x=1; x<w+1; x++) {
					matrix[x][y] = Integer.parseInt(rowContents[x-1]);
				}
			}

			//print
//			for (int y=0; y<h+2; y++) {
//				for (int x=0; x<w+2; x++) {
//					System.out.print(matrix[x][y] + " ");
//				}
//				System.out.print("\n");
//			}
			int[] northElevs = new int[w*h];
			int[] westElevs = new int[w*h];
			int[] eastElevs = new int[w*h];
			int[] southElevs = new int[w*h];
			int[] elevations = new int[w*h];
			int[] basins = new int[w*h];

			int[] northPos = new int[w*h];
			int[] westPos = new int[w*h];
			int[] eastPos = new int[w*h];
			int[] southPos = new int[w*h];

			//fill up directions
			for (int y=1; y<h+1; y++) {
				for (int x=1; x<w+1; x++) {
					int linearPos = w*(y-1) + (x-1);
					elevations[linearPos] = matrix[x][y];
					northElevs[linearPos] = matrix[x][y-1];
					westElevs[linearPos] = matrix[x-1][y];
					eastElevs[linearPos] = matrix[x+1][y];
					southElevs[linearPos] = matrix[x][y+1];

					northPos[linearPos] = linearPos - w;
					westPos[linearPos] = linearPos - 1;
					eastPos[linearPos] = linearPos + 1;
					southPos[linearPos] = linearPos + w;
				}
			}

			for (int k=0; k<w*h; k++) {
				boolean foundBasin = false;
				int currentPos = k;
				while (!foundBasin) {
					int min = northElevs[currentPos];
					if (min > westElevs[currentPos]) min = westElevs[currentPos];
					if (min > eastElevs[currentPos]) min = eastElevs[currentPos];
					if (min > southElevs[currentPos]) min = southElevs[currentPos];

					if (elevations[currentPos] > min) {
						if (min == northElevs[currentPos])
							currentPos = northPos[currentPos];
						else if (min == westElevs[currentPos])
							currentPos = westPos[currentPos];
						else if (min == eastElevs[currentPos])
							currentPos = eastPos[currentPos];
						else if (min == southElevs[currentPos])
							currentPos = southPos[currentPos];
					} else {
						basins[k] = currentPos;
						foundBasin = true;
					}
				}
			}

//			System.out.println(basins);


			//convert to letters
			String[] letters = new String[w*h];
			for (int k=0; k<w*h; k++) {
				letters[k] = null;
			}

			int currentNumber = basins[0];
			char currentChar = 'a';
			for (int k=0; k<w*h; k++) {
				if (letters[k] == null) {
					currentNumber = basins[k];
					letters[k] = "" + currentChar;
					for (int l=0; l<w*h; l++) {
						if (basins[l] == currentNumber) {
							letters[l] = "" + currentChar;
						}
					}
					currentChar++;
				}
			}

			System.out.println("Case #" + (i+1) + ":");
			int currentPosition = 0;
			for (int y = 0; y < h; y++) {
				for (int x = 0; x < w; x++) {
					System.out.print(letters[currentPosition++] + " ");
				}
				System.out.print("\n");
			}
//			System.out.println("\n");

//			int numEngines = Integer.parseInt(reader.readLine());
//			Map engines = new HashMap();
//			for (int j=0; j<numEngines; j++) {
//				engines.put(reader.readLine(), Boolean.FALSE);
//			}
//
//			int numQueries = Integer.parseInt(reader.readLine());
//			List queries = new ArrayList();
//			for (int j=0; j<numQueries; j++) {
//				queries.add(reader.readLine());
//			}
//
//			SavingTheUniverse s = new SavingTheUniverse();
//			System.out.println("Case #" + (i+1) + ": " + s.execute(engines, queries));
		}

	}

	String execute(Map engines, List queries) {

		int numEngines = engines.size();

		int switches = 0;

		//Iterator i = queries.iterator();
		int i = 0;
		while (i < queries.size()) {
			int counter = 0;
			while (counter < numEngines && i < queries.size()) {
				String query = (String) queries.get(i++);
				if (((Boolean) engines.get(query)).booleanValue()) {

				} else {
					engines.put(query, Boolean.TRUE);
					counter++;
				}
			}
			if (counter == numEngines) {
				switches++;
			    reset(engines);
			    i--;
			}

		}

		return "" + switches;
	}

	void reset(Map engines) {
		for (Iterator i = engines.keySet().iterator(); i.hasNext();) {
			engines.put((String) i.next(), Boolean.FALSE );
		}
	}


}
