package travel;

import java.io.FileReader;
import java.io.LineNumberReader;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class TrainTimetable {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		
		LineNumberReader reader = new LineNumberReader(new FileReader(
				"C:/train/B-large.in"));
		int numLines = Integer.parseInt(reader.readLine());
		for (int i = 0; i < numLines; i++) {
			int turnaroundTime = Integer.parseInt(reader.readLine());
			String[] tokens = reader.readLine().split(" ");

			int ab = Integer.parseInt(tokens[0]);
			int ba = Integer.parseInt(tokens[1]);

			List trips = new ArrayList();
			TrainTimetable t = new TrainTimetable();
			for (int j=0; j<(ab + ba); j++) {
				String[] times = reader.readLine().split(" ");
				
				Date departureTime = toDate(times[0]);
				
				if (j<ab) //A-B
					trips.add(t.new Trip("A", "B", departureTime, toArrivalDate(times[1], turnaroundTime)));
				else
					trips.add(t.new Trip("B", "A", departureTime, toArrivalDate(times[1], turnaroundTime)));
			}
			
			Collections.sort(trips);
			System.out.println("Case #" + (i+1) + ": " + t.execute(trips));
		}		
		
	}

	String execute(List trips) {
		
		int a=0, b=0;
		List stationA = new ArrayList();
		List stationB = new ArrayList();


		for (Iterator i=trips.iterator(); i.hasNext(); ) {
			Trip trip = (Trip) i.next();
			if ("A".equals(trip.departureStation)) {
				if (stationA.isEmpty() || trip.departureTime.before((Date) stationA.get(0))) { //need a new train
					a++;
				} else { //there's an available train at station
					stationA.remove(0);
				}
				stationB.add(trip.arrivalTime);
				Collections.sort(stationB);
			} else {
				if (stationB.isEmpty() || trip.departureTime.before((Date) stationB.get(0))) { //need a new train
					b++;
				} else { //there's an available train at station
					stationB.remove(0);
				}
				stationA.add(trip.arrivalTime);
				Collections.sort(stationA);
			}
				
		}
		
		return "" + a + " " + b;
	}
	
	static Date toDate(String time) throws Exception {
		return new SimpleDateFormat("HH:mm").parse(time);
	}

	static Date toArrivalDate(String time, int turnaroundTime) throws Exception {
		Date arrivalDate = new SimpleDateFormat("HH:mm").parse(time);
		Calendar cal = Calendar.getInstance();
		cal.setTime(arrivalDate);
		cal.add(Calendar.MINUTE, turnaroundTime);
		return cal.getTime();
	}

	class Trip implements Comparable {
		String departureStation;
		String arrivalStation;
		Date departureTime;
		Date arrivalTime;
		
		Trip(String departureStation, String arrivalStation, Date departureTime, Date arrivalTime) {
			this.departureStation = departureStation;
			this.arrivalStation = arrivalStation;
			this.departureTime = departureTime;
			this.arrivalTime = arrivalTime;
		}
		
		public String toString() {
			return departureStation + "-" + arrivalStation + " " + departureTime + " " + arrivalTime;
		}
		
		public int compareTo(Object to) {
			return departureTime.compareTo(((Trip) to).departureTime);
		}
	}
}
