import java.io.*;
import java.util.*;
import java.text.DecimalFormat;
import java.math.BigInteger;

public class FairAndSquare  {

	private static boolean checkFair(BigInteger square, BigInteger squareRoot) {
		boolean isFair = false;
		String squareString = square.toString();
		String squareRootString = squareRoot.toString();
		for(int i=0;i<squareString.length();i++) {
			if(squareString.charAt(i) == squareString.charAt(squareString.length() - 1 - i )) continue;
			else return isFair;
		}
		for(int i=0;i<squareRootString.length();i++) {
			if(squareRootString.charAt(i) == squareRootString.charAt(squareRootString.length() - 1 - i )) continue;
			else return isFair;
		}
		isFair = true;
		return isFair;
	}

	public static String process(String input) {
		String output = "";		
		output = "" + 0;	
		String array [] = input.split(" ");
		BigInteger start = new BigInteger(array[0]);
		BigInteger stop = new BigInteger(array[1]);
		BigInteger counter = start;
		BigInteger outputCounter = BigInteger.ZERO;
		BigInteger other = BigInteger.ONE;
		stop = stop.add(BigInteger.ONE);
		Map<BigInteger, BigInteger> squares = new LinkedHashMap<BigInteger, BigInteger>();
		while(other.pow(2).max(stop).equals(stop)) {
			squares.put(other.pow(2), other);
			other = other.add(BigInteger.ONE);
		}
		// System.out.println(" start " + start + " stop " + stop + " squares " + squares);
		while(counter.equals(stop) == false) {
			if(squares.containsKey(counter) && checkFair(counter, squares.get(counter))) {
				//System.out.print("  " + counter);				
				outputCounter = outputCounter.add(BigInteger.ONE);
			}
			counter = counter.add(BigInteger.ONE);
			
		}
		output = outputCounter.toString();
		return output;
	}

	public static void main(String [] args) throws Exception {
		BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(System.in));	
		BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(System.out));
		
		String input = bufferedReader.readLine();
		boolean flag = true;
		Integer numberOfTestCases = 0;
		Integer counter = 0;
		String [] inputArray = null;
		String [] outputArray = null;
		
		// input 
		while(input != null) {
		    if(flag) {
				numberOfTestCases = new Integer(input);
				flag = false;
				inputArray = new String[numberOfTestCases];
				outputArray = new String[numberOfTestCases];
			}
			else {
				inputArray[counter] = input;
				counter++;
			}
			input = bufferedReader.readLine();
		}
		
		// processing
		counter = 0;
		while(counter < inputArray.length) {
			outputArray[counter] = process(inputArray[counter]);
			counter++;			
		}	
		
		
		// output
		counter = 0;
		while(counter < numberOfTestCases) {
			bufferedWriter.write("Case #" + (counter + 1) + ": " + outputArray[counter]);
			bufferedWriter.newLine();
			bufferedWriter.flush();
			counter++;
		}

		bufferedReader.close();		
		bufferedWriter.close();
		bufferedWriter = null;
		bufferedReader = null;
	}
}