package round1a;

import java.io.File;
import java.util.Scanner;

/**
 * @author Jason Huang
 * 
 */
public class Rotate {

	public static void main(String[] args) {
		
		Scanner scanner = new Scanner(System.in);

		int count = scanner.nextInt();

		for (int i = 1; i <= count; i++) {
			int N = scanner.nextInt();
			int K = scanner.nextInt();

			char[][] board = new char[N][];

			for (int j = 0; j < N; j++) {
				board[j] = scanner.next().toCharArray();
				// rotate and fall

				int p = board[j].length - 1;
				int q;

				while (true) {
					// find first empty spot
					for (; p >= 0 && board[j][p] != '.'; p--)
						;

					// find first non-empty spot
					for (q = p - 1; q >= 0 && board[j][q] == '.'; q--)
						;

					if (p < 0 || q < 0) {
						break;
					}

					board[j][p] = board[j][q];
					board[j][q] = '.';
				}
			}//

			boolean r = checkWin(board, 'R', K);
			boolean b = checkWin(board, 'B', K);

			if (r && b) {
				System.out.println("Case #" + i + ": Both");
			} else if (r && !b) {
				System.out.println("Case #" + i + ": Red");
			} else if (!r && b) {
				System.out.println("Case #" + i + ": Blue");
			} else {
				System.out.println("Case #" + i + ": Neither");
			}
		}

	}

	private static boolean checkWin(char[][] board, char c, int K) {

		for (int i = 0; i < board.length; i++) {
			for (int j = 0; j < board[0].length; j++) {
				if (board[i][j] != c) {
					continue;
				}

				int count = 0;

				// check if [i][j] is the end of win

				for (int m = i, n = j; m >= 0 && count < K; m--) {
					if (board[m][n] == c) {
						count++;
					} else {
						break;
					}
				}

				if (count == K) {
					return true;
				}

				count = 0;
				for (int m = i, n = j; m < board.length && count < K; m++) {
					if (board[m][n] == c) {
						count++;
					} else {
						break;
					}
				}

				if (count == K) {
					return true;
				}
				
				
				count = 0;
				for (int m = i, n = j; n >= 0 && count < K; n--) {
					if (board[m][n] == c) {
						count++;
					} else {
						break;
					}
				}

				if (count == K) {
					return true;
				}

				
				count = 0;
				for (int m = i, n = j; m >= 0 && n >= 0 && count < K; m--, n--) {
					if (board[m][n] == c) {
						count++;
					} else {
						break;
					}
				}

				if (count == K) {
					return true;
				}

				count = 0;
				for (int m = i, n = j; m < board.length && n >= 0 && count < K; m++, n--) {
					if (board[m][n] == c) {
						count++;
					} else {
						break;
					}
				}

				if (count == K) {
					return true;
				}
			}
		}

		return false;
	}

}
