/**
 * 
 */
package round0;

import java.math.BigInteger;
import java.util.Arrays;
import java.util.Scanner;

/**
 * @author Jason Huang
 *
 */
public class FairWarning {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		Scanner scanner = new Scanner(System.in);
		
		int count = scanner.nextInt();
		
		for(int i = 1; i <= count; i++){
			int n = scanner.nextInt();

			BigInteger[] events = new BigInteger[n];
			
			for(int j = 0; j < n; j++){
				events[j] = new BigInteger(scanner.next());
			}

			Arrays.sort(events);
			
			BigInteger[] intervals = new BigInteger[n-1];
			
			for(int j = 1; j < n; j++){
				intervals[j-1] = events[j].subtract( events[j - 1] );
			}
			
			BigInteger T = getMaxT(intervals);
			
			BigInteger ans = null;
			
			if(T.compareTo(BigInteger.ONE) == 0){
				ans = BigInteger.ZERO;
			} else {
				ans = T.subtract( (events[0].mod(T)) );
			}
			
			System.out.println("Case #" + i + ": " + ans);

		}

	}

	private static BigInteger getMaxT(BigInteger[] intervals) {
		if(intervals.length == 1){
			return intervals[0];
		} else {
			return gcd(intervals, intervals.length);
		}
	}

	private static BigInteger gcd(BigInteger[] intervals, int length) {
		
		if(length == 2){
			return gcd0(intervals[0], intervals[1]);
		}
		
		BigInteger d = gcd(intervals, length - 1);
		
		return gcd0(d, intervals[length - 1]);
	}

	private static BigInteger gcd0(BigInteger m, BigInteger n) {

		while (n.compareTo(BigInteger.ZERO) > 0) {
			BigInteger r = m.mod(n);
			m = n;
			n = r;
		}
		return m;
	}

}
