package round1B;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;

public class Repeater {
	HashSet<String> charMap;
	ArrayList<String> charArr;
	ArrayList<String> strArr;
	String[] strings;
	String baseStr;
	int[][] distMap;
	
	public Repeater(String[] strs) {
		charMap = new HashSet<String>();
		strings = strs;
	}
	
	
	boolean sameChars() {
		int minIndx=0, min=Integer.MAX_VALUE;
		// smallest string
		for(int str=0 ; str<strings.length ; str++) {
			if(strings[str].length() < min) {
				min = strings[str].length();
				minIndx = str;
			}
		}
		System.out.println(strings[minIndx] +" "+ minIndx);
		
		// Initiate char map
		for(int i=0; i<strings[minIndx].length() ; i++ ) {
			charMap.add(strings[minIndx].substring(i,i+1));
		}
		
		StringBuffer bs = new StringBuffer();
		for(String s: charMap) {
			bs.append(s);
		}
		baseStr = bs.toString();
		System.out.println(baseStr +" "+ charMap.size());

		distMap = new int[strings.length+1][charMap.size()];		
		charArr = new ArrayList<String>(charMap);
		System.out.println(charArr.toString());
		strArr = new ArrayList<String>(Arrays.asList(strings));
		strArr.add(baseStr);
		
		for(int str=0 ; str<strArr.size() ; str++) {
			for(int c=0 ; c<strArr.get(str).length() ; c++) {
				String chr = strArr.get(str).substring(c,c+1);
				if (!charMap.contains(chr)) {
					return false;
				}else {
					distMap[str][charArr.indexOf(chr)]++;
				}
			}
		}

		for(int i=0 ; i<strArr.size() ; i++) {
			System.out.println(Arrays.toString(distMap[i]));
		}
		return true;
	}
	
	int distance() {
		int dist=0;
		ArrayList<String> visited = new ArrayList<String>();
		visited.add(baseStr);
		
		ArrayList<String> nvisited = new ArrayList<String>();
		for(String s: strings) {
			nvisited.add(s);
		}
		
		while(!nvisited.isEmpty()) {
			String nearestUnvisited = null;
			int mindist=Integer.MAX_VALUE;
			for(String vnode: visited) {
				for(String nvnode : nvisited) {
					int cdist = 0;
					for(int c=0 ; c<charMap.size() ; c++) {
						cdist += Math.abs(distMap[strArr.indexOf(vnode)][c]- distMap[strArr.indexOf(nvnode)][c]);
					}
					if(cdist<mindist) {
						mindist = cdist;
						nearestUnvisited = nvnode;
					}
				}
			}
			visited.add(nearestUnvisited);
			nvisited.remove(nearestUnvisited);
			dist += mindist;
		}
		
		
		return dist;
	}
	
	boolean allSame() {
		String s = strings[0];
		for(String s1: strings) {
			if(!s1.equals(s)) return false;
		}
		return true;
	}
	
	static String repeaterCount(String[] strs) {
		Repeater rp = new Repeater(strs);
		if(!rp.sameChars()) return "Fegla Won";
		
		//Check if all are same
		if(rp.allSame()) return 0+"";
		
		return rp.distance()+"";
	}
	
	static void outputWriter(String[] outputs, String outpath) {
		File opfile = new File(outpath);
		if (!opfile.exists()) {
			try {
				opfile.createNewFile();
			} catch (IOException e) {
				System.err.println("Unable to create output file:" + outpath);
				return;
			}
		}
		Writer owriter = null;
		try {
			owriter = new OutputStreamWriter(new FileOutputStream(opfile));
			for (String testOut : outputs) {
				owriter.write(testOut);
			}
		} catch (FileNotFoundException e) {
			System.err.println("Created file not found:" + outpath);
			return;
		} catch (IOException e) {
			System.err.println("Unable to write on file:" + outpath);
			return;
		} finally {
			try {
				if (owriter != null)
					owriter.close();
			} catch (IOException e) {
				System.err.println("Failed to close resource:" + outpath);
			}
		}
	}

	public static void main(String[] args) {
		System.out.println("Enter absolute file path: input");
		Scanner inputScanner = new Scanner(System.in);
		String inpath = inputScanner.next();
		String outpath = inpath + ".out";
		inputScanner.close();

		System.out.println("File name: " + inpath);
		try {
			inputScanner = new Scanner(new File(inpath));
		} catch (FileNotFoundException e) {
			System.err.println(inpath + " file not found!!");
			return;
		}

		// Hope input file is formatted correctly.
		int testCases = inputScanner.nextInt();
		System.out.println("File has " + testCases + " testcases");
		inputScanner.nextLine();
		String[] outputs = new String[testCases];
		for (int t = 0; t < testCases; t++) {
			int strs = inputScanner.nextInt();
			inputScanner.nextLine();
			String[] input = new String[strs];
			for(int i=0 ; i<strs; i++) {
				input[i] = inputScanner.nextLine();
			}

			System.out.println(Arrays.toString(input));
			String answer = repeaterCount(input);
			outputs[t] = "Case #" + (t + 1) + ": " + answer + "\n";
			System.out.println(outputs[t]);
		}

		outputWriter(outputs, outpath);
	}
}
