package jam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.HashSet;
import java.util.Scanner;

public class MagicSolver {
	static String magic(int[][] pattern1, int[][] pattern2, int row1, int row2) {
		HashSet<Integer> pattern1Cards = new HashSet<Integer>(pattern1[0].length);
		for(int col=0; col<pattern1[0].length ; col++) {
			pattern1Cards.add(pattern1[row1][col]);
		}
		
		int matchingCards = 0, matchCard=-1;
		for(int col=0; col<pattern2[0].length ; col++) {
			int card = pattern2[row2][col];
			if (pattern1Cards.contains(card)) {
				if (matchingCards == 0) {
					matchCard = card;
				}
				matchingCards++;				
			}
		}
		if (matchingCards == 0) {
			return "Volunteer cheated!";
		}else if (matchingCards > 1) {
			return "Bad magician!";
		}
		return ""+matchCard;		
	}
	
	static void outputWriter(String[] outputs, String outpath) {
		File opfile = new File(outpath);
		if (!opfile.exists()) {
			try {
				opfile.createNewFile();
			} catch (IOException e) {
				System.err.println("Unable to create output file:"+outpath);
				return;
			}			
		}
		Writer owriter = null;
		try {
			owriter = new OutputStreamWriter(new FileOutputStream(opfile));
			for(String testOut: outputs) {
				owriter.write(testOut);				
			}
		} catch (FileNotFoundException e) {
			System.err.println("Created file not found:"+outpath);
			return;
		} catch (IOException e) {
			System.err.println("Unable to write on file:"+outpath);
			return;
		}finally{
			try {
				if(owriter != null) owriter.close();
			} catch (IOException e) {
				System.err.println("Failed to close resource:"+outpath);
			}
		}
	}
	
	public static void main(String[] args) {
		System.out.println("Enter absolute file path: input && output");
		Scanner inputScanner = new Scanner(System.in);
		String inpath = inputScanner.next();
		String outpath = inpath+".out";
		inputScanner.close();
		
		System.out.println("File name: "+ inpath);
		try {
			inputScanner = new Scanner(new File(inpath));
		} catch (FileNotFoundException e) {
			System.err.println(inpath+" file not found!!");
			return;
		}
		
		// Hope input file is formatted correctly.
		int testCases = inputScanner.nextInt();
		System.out.println("File has "+testCases+" testcases");
		String[] outputs = new String[testCases];
		for(int t=0 ; t<testCases ; t++) {
			int[] rows= new int[2];
			int[][][] patterns = new int[2][4][4];
			for(int arr=0 ; arr<2 ; arr++) {
				rows[arr] = inputScanner.nextInt();
				inputScanner.nextLine();
				System.out.println("row: " + rows[arr]);
				for(int l=0 ; l<4 ; l++) {
					String line = inputScanner.nextLine();
					Scanner numberifier = new Scanner(line);
					numberifier.useDelimiter(" ");
					System.out.println(line);
					for(int c=0 ; c<4 ; c++) {
						patterns[arr][l][c] = numberifier.nextInt();
					}
				}
			}
			String answer = magic(patterns[0], patterns[1], rows[0]-1, rows[1]-1);
			outputs[t] = "Case #"+(t+1)+": "+answer+"\n";
			System.out.println(outputs[t]);
		}
		
		outputWriter(outputs, outpath);
	}
}
