package jam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

public class DeceitfulWar {
	int indxOfStratagic(double nomis, Double[] ken, boolean[] kenBurnt) {
		int indx = -1;
		for (int i = 0; i < ken.length; i++) { // Just heavier
			if (!kenBurnt[i]) {
				if (ken[i] > nomis) {
					kenBurnt[i] = true;
					indx = i;
					break;
				}
			}
		}
		if (indx == -1) { // Lightest
			for (int i = 0; i < ken.length; i++) {
				if (!kenBurnt[i]) {
					kenBurnt[i] = true;
					indx = i;
					break;
				}
			}
		}
		return indx;
	}
	
//	int winDecRec(ArrayList<Double> nomi, ArrayList<Double> ken) {
//		if(nomi.size() == 1) {
//			return nomi.remove(0) > ken.remove(0) ? 1:0;
//		}
//		
//		// Strategy 1 : force ken to loose heaviest
//		double kenheaviest = ken.get(ken.size()-1);
//		double nomilightest = nomi.get(0);
//		
//		// Strategy 2 : force ken to loose lightest
//		
//		return 0;
//	}

	int winDeceit(Double[] nomi, Double[] ken) {
		int result = 0;
		// Sort nomi and ken
		Arrays.sort(nomi);
		Arrays.sort(ken);
		
		int deceitWar = 0;
		for (int i = ken.length - 1; i >= 0; i--) {
			double kenheaviest = ken[i];
			double nomilightest = nomi[ken.length - 1 - i];
			if (nomilightest > kenheaviest) {
				deceitWar++;
			}
		}
		result = deceitWar;
		
		deceitWar = 0;
		boolean[] nomiBurnt = new boolean[nomi.length];
		for (int i = 0; i < ken.length; i++) {
			double kenlightest = ken[i];
			double nomifakeHeaviest = nomi[indxOfStratagic(kenlightest, nomi, nomiBurnt)];
			if (nomifakeHeaviest > kenlightest) {
				deceitWar++;
			}
		}
		
		
		return Math.max(result, deceitWar);
	}
	
	int winfare(Double[] nomi, Double[] ken) {
		int result = 0;
		boolean[] kenBurnt = new boolean[ken.length];
		// Sort nomi and ken
		Arrays.sort(nomi);
		Arrays.sort(ken);
		
		System.out.println(Arrays.toString(nomi));
		System.out.println(Arrays.toString(ken));

		int fareWar = 0;
	
		for (int i = nomi.length - 1; i >= 0; i--) {
			double nomiheaviest = nomi[i];
			double kenStratagic = ken[indxOfStratagic(nomiheaviest, ken, kenBurnt)];
			if (nomiheaviest > kenStratagic) {
				fareWar++;
			}
		}

		result = fareWar;
		return result;
	}

	int[] win(Double[] nomi, Double[] ken) {
		int[] ans = new int[2];
		ans[0] = winDeceit(nomi, ken);
		ans[1] = winfare(nomi, ken);
		return ans;	
	}
	
	static void outputWriter(String[] outputs, String outpath) {
		File opfile = new File(outpath);
		if (!opfile.exists()) {
			try {
				opfile.createNewFile();
			} catch (IOException e) {
				System.err.println("Unable to create output file:" + outpath);
				return;
			}
		}
		Writer owriter = null;
		try {
			owriter = new OutputStreamWriter(new FileOutputStream(opfile));
			for (String testOut : outputs) {
				owriter.write(testOut);
			}
		} catch (FileNotFoundException e) {
			System.err.println("Created file not found:" + outpath);
			return;
		} catch (IOException e) {
			System.err.println("Unable to write on file:" + outpath);
			return;
		} finally {
			try {
				if (owriter != null)
					owriter.close();
			} catch (IOException e) {
				System.err.println("Failed to close resource:" + outpath);
			}
		}
	}

	public static void main(String[] args) {
		System.out.println("Enter absolute file path: input");
		Scanner inputScanner = new Scanner(System.in);
		String inpath = inputScanner.next();
		String outpath = inpath + ".out";
		inputScanner.close();

		System.out.println("File name: " + inpath);
		try {
			inputScanner = new Scanner(new File(inpath));
		} catch (FileNotFoundException e) {
			System.err.println(inpath + " file not found!!");
			return;
		}

		// Hope input file is formatted correctly.
		int testCases = inputScanner.nextInt();
		inputScanner.nextLine();
		System.out.println("File has " + testCases + " testcases");
		String[] outputs = new String[testCases];
		for (int t = 0; t < testCases; t++) {
			int blocks = inputScanner.nextInt();
			Double[][] players = new Double[2][blocks];
			inputScanner.nextLine();
			for (int player = 0; player < 2; player++) {
				String line = inputScanner.nextLine();
				Scanner doublizer = new Scanner(line);
				doublizer.useDelimiter(" ");
				
				for(int b=0 ; b<blocks ; b++) {
					players[player][b] = doublizer.nextDouble();
				}
			}

			DeceitfulWar cw = new DeceitfulWar();
			int[] answer = cw.win(players[0], players[1]);
			outputs[t] = "Case #" + (t + 1) + ": " + answer[0] +" "+ answer[1] +"\n";
			System.out.println(outputs[t]);
		}

		outputWriter(outputs, outpath);
	}

}
