import java.util.*;
import java.io.*;

public class DeceitfulWar {
	TreeSet<Double> naomi = new TreeSet<Double>();
	TreeSet<Double> ken = new TreeSet<Double>();
	private int num = 0;
	
	DeceitfulWar(int num, String[] naomi, String[] ken) {
		this.num = num;
		this.naomi = this.parseTree(naomi);
		this.ken = this.parseTree(ken);
	}
	
	public int solveDeceitful() {
		int count = 0;
		TreeSet<Double> copyNaomi = (TreeSet<Double>) naomi.clone();
		
		for (Double i : ken) {
			Double higher = copyNaomi.higher(i);
			if (higher != null) { // remove integer from tree
				copyNaomi.remove(higher);
				count++;
			} else {
				break;
			}
		}
		
		return count;
	}
	
	public int solveNormal() {
		int ftw = 0;
		//int bkw = 0;

		TreeSet<Double> copyNaomi = (TreeSet<Double>) naomi.clone();
		TreeSet<Double> copyKen = (TreeSet<Double>) ken.clone();
		// Forward count
		for (Double i : copyNaomi) {
			Double higher = copyKen.higher(i);
			if (higher != null) {
				copyKen.remove(higher);
				ftw++;
			} else {
				break;
			}
		}
		
		copyNaomi = (TreeSet<Double>) naomi.clone();
		copyKen = (TreeSet<Double>) ken.clone();
		
		/*
		// Backward count
		Iterator<Double> it = copyNaomi.descendingIterator();
		while(it.hasNext()) {
			Double next = it.next();
			Double higher = copyKen.higher(next);
			if (higher != null) {
				copyKen.remove(higher);
				bkw++;
			} else {
				copyKen.remove(copyKen.first());
			}
		}
		*/
		return num - ftw;
	}
	
	public TreeSet<Double> parseTree(String[] str) {
		TreeSet<Double> result = new TreeSet<Double>();
		
		for (String s : str) {
			Double d = Double.parseDouble(s);
			result.add(d);
		}
		
		return result;
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try (BufferedReader br = new BufferedReader(new FileReader(args[0]+".in")))
		{
			try(BufferedWriter bw = new BufferedWriter(new FileWriter(args[0]+".out"))) {			
				String line;
				
				int T = Integer.parseInt(br.readLine());
				for (int i = 1; i <= T; i++) {
					int N = Integer.parseInt(br.readLine());
					
					DeceitfulWar solver = new DeceitfulWar(N, br.readLine().split(" "), br.readLine().split(" "));
					
					// Write out result
					String ans = solver.solveDeceitful() + " " + solver.solveNormal();
					bw.write("Case #" + i + ": " + ans + '\n');
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
 
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
