import java.util.*;
import java.io.*;

public class Dashboard {
	public static class Info {
		ArrayList<Character> ch = new ArrayList<Character>();
		ArrayList<Integer> freq = new ArrayList<Integer>();
		
		Info(ArrayList<Character> ch, ArrayList<Integer> fr) {
			this.ch = ch;
			this.freq = fr;
		}
		
		public boolean equals(Object obj) {
			if (obj == null) return false;
			if (this == obj) return true;
			
			if (!(obj instanceof Info)) return false;
			Info o = (Info) obj;
			
			return ch.equals(o.ch);
		}
	}
	
	public static Info process(String s) {
		int f = 0;
		char c = s.charAt(0);
		
		ArrayList<Character> ch = new ArrayList<Character>();
		ArrayList<Integer> fr = new ArrayList<Integer>();
		ch.add(c);
		
		for (int i = 0; i < s.length(); i++){
			if (s.charAt(i) == c) {
				f++;
			} else {
				fr.add(f);
				
				c = s.charAt(i);
				f = 1;
				ch.add(c);
			}
		}
		
		fr.add(f);
		
		return new Info(ch, fr);
	}
	
	public static int diff(Info target, Info test) {
		int sum = 0;
		for (int i = 0; i < target.freq.size(); i++) {
			sum += Math.abs(test.freq.get(i) - target.freq.get(i));
		}
		
		return sum;
	}
	
	public static boolean possible(Info[] i) {
		Info ii = i[0];
		boolean possible = true;
		for (Info a : i) {
			possible &= ii.equals(a);
		}
		
		return possible;
	}
	
	public static String solve(String[] str, int N) {
		Info[] all = new Info[N];
		for (int i = 0; i < N; i++) {
			all[i] = process(str[i]);
		}
		
		int count = 0;
		int M = all[0].freq.size();
		
		int[] mean = new int[M];
		Arrays.fill(mean, 0);
		
		if (!possible(all)) return "Fegla Won";
		
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < M; j++) {
				mean[j] += all[i].freq.get(j);
			}
		}
		
		for (int i = 0; i < M; i++) mean[i] = mean[i] / N;
		
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < M; j++) {
				count += Math.abs(all[i].freq.get(j) - mean[j]);
			}
		}
		
		return count + "";
	}
	
	public static void main(String[] args) throws IOException {
		String filename = "A-small-attempt0";
		try (Scanner sc = new Scanner(new File(filename + ".in"))) {
			try (PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter(filename + ".out")))) {
				int T = sc.nextInt();
				for (int i = 1; i <= T; i++) {
					int N = sc.nextInt();
					String[] A = new String[N];
					for (int j = 0; j < N; j++) A[j] = sc.next();
					
					pw.printf("Case #%d: %s\n", i, solve(A, N));
				}	
			}
		}
	}
}
