import java.util.*;
import java.io.*;

public class Cookies {
	private double C = 0;
	private double F = 0;
	private double T = 0;
	
	Cookies(double C, double F){
		this.C = C;
		this.F = F;
		
		// Time taken to break even
		this.T = C / F;
	}
	
	public double time(double total, double rate, double goal) {
		if (total < C) {
			// Wait until enough cookies to make a decision
			if ((goal - total) > (C - total)) {
				// If having enough money to buy new fact before reaching goal
				// Reach the decision point
				double earn = C - total;
				double timeTaken = earn / rate;
				
				return timeTaken + time(C, rate, goal);
			} else {
				// Reach the goal anyway
				return (goal - total) / rate;
			}
		} else {
			// Decide to buy or not
			if (T * rate + total < goal) { // Break even before reach goal
				return time(total - C, rate + F, goal);
			} else { // just finish
				return (goal - total) / rate;
			}
		}
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// Read file
		try (BufferedReader br = new BufferedReader(new FileReader(args[0])))
		{
			try(BufferedWriter bw = new BufferedWriter(new FileWriter("result.out"))) {			
				String line;
				
				int T = Integer.parseInt(br.readLine());
				
				for (int i = 1; i <= T; i++) {
					// Read in only the answer row
					line = br.readLine();
					String[] inputStr = line.split(" ");
					double[] input = new double[3];
					for (int j = 0; j < 3; j++) {
						input[j] = Double.parseDouble(inputStr[j]);
					}
					
					Cookies solver = new Cookies(input[0], input[1]);
					double ans = solver.time(0, 2, input[2]);
					String ansStr = String.format("%.7f", ans);
					bw.write("Case #" + i + ": " + ansStr +'\n');
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
 
		} catch (IOException e) {
			e.printStackTrace();
		} 
	}

}
