package qualification.round;

import java.util.*;
import java.io.*;

public class Question3 {

    public static void main(String[] args) throws Exception {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        for (int i = 1; i <= t; ++i) {
            int N = in.nextInt();
            int K = in.nextInt();
            Position[] positions = new Position[N + 2];
            positions[0] = new Position(0, N + 1, true, 0);
            positions[N + 1] = new Position(N + 1, 0, true, N + 1);
            for (int k = 1; k <= N; k++) {
                positions[k] = new Position(k - 1, N - k, false , k);
            }
            int result = -1;
            for (int k = 1; k <= K; k++) {
                result = findPosition(positions, K);
                positions[result].isVisited = true;
                updatePosition(positions, result);
            }
            int maxResult = Math.max(positions[result].left, positions[result].right);
            int minResult = Math.min(positions[result].left, positions[result].right);
            System.out.println("Case #" + i + ": " + maxResult + " " + minResult);

        }
    }

    public static void updatePosition(Position[] positions, int result) {
        int left = result - 1;
        Position resultPosition = positions[result];
        while (left > 0 && !positions[left].isVisited) {
            positions[left].right = resultPosition.pos - positions[left].pos - 1;
            left--;
        }
        positions[result].left = result - positions[left].pos - 1;
        int right = result + 1;
        while (right < positions.length && !positions[right].isVisited) {
            positions[right].left = positions[right].pos - resultPosition.pos - 1;
            right++;
        }
        positions[result].right = positions[right].pos - result - 1;
    }

    public static int findPosition(Position[] positions, int K) {
        List<Position> positionList = new ArrayList<>();
        int min = -1;
        for (int i = 1; i <= positions.length - 1; i++) {
            Position position = positions[i];
            if (!position.isVisited) {
                int current_min = Math.min(position.left, position.right);
                if (current_min == min) {
                    positionList.add(position);
                } else if (current_min > min) {
                    positionList = new ArrayList<>();
                    positionList.add(position);
                    min = current_min;
                }
            }
        }
        int max = -1;
        List<Position> newPositionList = new ArrayList<>();
        if (positionList.size() > 1) {
            for (int i = 0; i < positionList.size(); i++) {
                Position position = positionList.get(i);
                int current_max = Math.max(position.left, position.right);
                if (current_max > max) {
                    max = current_max;
                    newPositionList = new ArrayList<>();
                    newPositionList.add(position);
                } else if (current_max == max) {
                    newPositionList.add(position);
                }

            }
        }
        if (newPositionList.size() >= 1) {
            positionList = newPositionList;
        }

        return positionList.get(0).pos;
    }

    static class Position {
        int left = 0;
        int right = 0;
        boolean isVisited = false;
        int pos = 0;
        Position(int left, int right, boolean isVisited, int pos) {
            this.left = left;
            this.right = right;
            this.isVisited = isVisited;
            this.pos = pos;
        }
    }
}