

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class SavingTheUniverse {

	private static int totalCases;
	private static StringBuffer sb = new StringBuffer();

	public static void main(String[] args) {
		System.out.println("Input filepath = ");
		Scanner in = new Scanner(System.in);
		String inputFilePath = in.nextLine();
		readAndProcess(inputFilePath);
		System.out.println("Output filepath = ");
		String outputFilePath = in.nextLine();
		writeOutputFile(outputFilePath);
	}

	private static void readAndProcess(String filePath) {
		BufferedReader in = null;
		try {
			in = new BufferedReader(new FileReader(filePath));
			totalCases = Integer.parseInt(in.readLine());

			for (int i = 1; i <= totalCases; i++) {
				int sEngines = Integer.parseInt(in.readLine());
				List<String> engines = new ArrayList<String>(sEngines);
				for (int j = 0; j < sEngines; j++) {
					engines.add(in.readLine());
				}

				int[] occurs = new int[sEngines];
				int sQueries = Integer.parseInt(in.readLine());
				String lastQuery = null;
				String switchedQuery = null;
				int switches = 0;
				int searchEng = sEngines;
				for (int j = 0; j < sQueries; j++) {
					String line = in.readLine();
					if (!line.equals(lastQuery)) {
						lastQuery = line;
						int index = engines.indexOf(line);
						int occur = occurs[index];
						if (0 == occur && !line.equals(switchedQuery)) {
							searchEng--;
						}

						if (searchEng == 0) {
							switches++;
							searchEng = sEngines - 1;
							switchedQuery = line;
							occurs = new int[sEngines];
						} else {
							occurs[index] = 1;
						}
					}
				}
				sb.append("Case #" + i + ": " + switches + "\n");
			}

		} catch (FileNotFoundException e) {
			System.err.println("File not found");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Unable to read from file reader");
			e.printStackTrace();
		} finally {
			try {
				in.close();
			} catch (IOException e) {
				System.err.println("Unable to close the file reader");
				e.printStackTrace();
			}
		}
	}

	private static void writeOutputFile(String filePath) {
		BufferedWriter outputFileWriter = null;
		try {
			outputFileWriter = new BufferedWriter(new FileWriter(filePath));
			outputFileWriter.write(sb.toString());
		} catch (FileNotFoundException e) {
			System.err.println("File not found");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Unable to read from file reader");
			e.printStackTrace();
		} finally {
			try {
				outputFileWriter.close();
			} catch (IOException e) {
				System.err.println("Unable to close the file reader");
				e.printStackTrace();
			}
		}
	}

}
