import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.StringTokenizer;

public class AllienLanguage {

	private static int D;
	private static StringBuffer sb = new StringBuffer();

	public static void main(String[] args) {
		System.out.println("Input filepath = ");
		Scanner in = new Scanner(System.in);
		String inputFilePath = in.nextLine();
		readAndProcess(inputFilePath);
		System.out.println("Output filepath = ");
		String outputFilePath = in.nextLine();
		writeOutputFile(outputFilePath);
	}

	private static void readAndProcess(String filePath) {
		BufferedReader in = null;
		try {
			in = new BufferedReader(new FileReader(filePath));
			StringTokenizer strTok = new StringTokenizer(in.readLine());
			int L = Integer.parseInt(strTok.nextToken());
			D = Integer.parseInt(strTok.nextToken());
			int N = Integer.parseInt(strTok.nextToken());
			List wordLetter = new ArrayList(D);

			for (int i = 0; i < D; i++) {
				wordLetter.add(in.readLine().toCharArray());
			}
			for (int j = 0; j < N; j++) {

				int wordsPossible = 0;
				char[] wordCase = in.readLine().toCharArray();
				if (wordCase != null && wordCase.length >= L) {
					List tempWordLetter = new ArrayList(D);
					List removedWordLetter = new ArrayList();
					tempWordLetter.addAll(wordLetter);
					int braceStatus = 0;

					int letterIndex = 0;
					for (int k = 0; k < wordCase.length; k++) {
						if (letterIndex == L) {
							letterIndex++;
							break;
						}
						char letter = wordCase[k];
						if (letter == '(') {
							braceStatus = 1;
							continue;
						} else if (letter == ')') {
							braceStatus = 0;
							letterIndex++;
							removedWordLetter.clear();
							continue;
						}

						if (braceStatus == 0 || braceStatus == 1) {
							if (braceStatus == 1) {
								braceStatus = 2;
							}
							int len = tempWordLetter.size();

							for (int i = 0; i < len; i++) {
								char[] word = (char[]) tempWordLetter.get(i);
								if (word[letterIndex] != letter) {
									if (braceStatus == 2) {
										removedWordLetter.add(word);
									}
									tempWordLetter.remove(i);
									i--;
									len--;
								}
							}
						}

						if (braceStatus == 2) {
							int len = removedWordLetter.size();
							for (int i = 0; i < len; i++) {
								char[] word = (char[]) removedWordLetter.get(i);
								if (word[letterIndex] == letter) {
									tempWordLetter.add(word);

									removedWordLetter.remove(i);
									i--;
									len--;
								}

							}
						}
						if (tempWordLetter.size() == 0
								&& removedWordLetter.size() == 0) {
							break;
						}
						if (braceStatus == 0) {
							letterIndex++;
						}
					}
					if (letterIndex == L)
						wordsPossible = tempWordLetter.size();
				}
				int caseId = j+1;
				sb.append("Case #" + caseId + ": " + wordsPossible + "\n");
			}

		} catch (FileNotFoundException e) {
			System.err.println("File not found");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Unable to read from file reader");
			e.printStackTrace();
		} finally {
			try {
				in.close();
			} catch (IOException e) {
				System.err.println("Unable to close the file reader");
				e.printStackTrace();
			}
		}
	}

	private static void writeOutputFile(String filePath) {
		BufferedWriter outputFileWriter = null;
		try {
			outputFileWriter = new BufferedWriter(new FileWriter(filePath));
			outputFileWriter.write(sb.toString());
		} catch (FileNotFoundException e) {
			System.err.println("File not found");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Unable to read from file reader");
			e.printStackTrace();
		} finally {
			try {
				outputFileWriter.close();
			} catch (IOException e) {
				System.err.println("Unable to close the file reader");
				e.printStackTrace();
			}
		}
	}

}
