import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class Welcome {

	private static int N;
	private static StringBuffer sb = new StringBuffer();

	public static void main(String[] args) {
		System.out.println("Input filepath = ");
		Scanner in = new Scanner(System.in);
		String inputFilePath = in.nextLine();
		readAndProcess(inputFilePath);
		System.out.println("Output filepath = ");
		String outputFilePath = in.nextLine();
		writeOutputFile(outputFilePath);
	}

	private static void readAndProcess(String filePath) {
		BufferedReader in = null;
		try {
			in = new BufferedReader(new FileReader(filePath));
			N = Integer.parseInt(in.readLine());
			char[] welStr = "welcome to code jam".toCharArray();
			int len = welStr.length;

			for (int i = 1; i <= N; i++) {
				char[] caseString = in.readLine().toCharArray();
				if (caseString == null || caseString.length == 0
						|| caseString.length < welStr.length) {
					String result = "0000";
					sb.append("Case #" + i + ": " + result + "\n");
					continue;
				}
				int[] firstWelStrInd = new int[len];
				int k = 0;
				for (int j = 0; j < caseString.length; j++) {
					if (caseString[j] == welStr[k]) {
						firstWelStrInd[k] = j;
						k++;
						if (k == len) {
							break;
						}
					}
				}
				if (k != len) {
					String result = "0000";
					sb.append("Case #" + i + ": " + result + "\n");
					continue;
				}
				int[] lastWelStrInd = new int[len];
				k = len - 1;
				boolean match = true;
				for (int j = caseString.length - 1; j >= 0; j--) {
					if (caseString[j] == welStr[k]) {
						lastWelStrInd[k] = j;

						if (firstWelStrInd[k] != lastWelStrInd[k]) {
							match = false;
						}
						if (k == 0) {
							break;
						}
						k--;
					}
				}
				if (match) {
					String result = "0001";
					sb.append("Case #" + i + ": " + result + "\n");
					continue;
				}
				long total = 1l;
				k = len - 1;
				for (int j = 0; j < len; j++) {
					if (firstWelStrInd[j] < lastWelStrInd[j]) {
						int diff = lastWelStrInd[j] - firstWelStrInd[j];
						if (diff == 1) {
							total = total * 2l;
						} else {
							long occurs = 2l;
							for (int m = firstWelStrInd[j] + 1; m < lastWelStrInd[j]; m++) {
								if (caseString[m] == welStr[j]) {
									occurs++;
								}
							}
							total = total * occurs;
						}
					}
				}
				
				String result = "0000" + total % 10000;
				result = result.substring(result.length() - 4, result.length());
				sb.append("Case #" + i + ": " + result + "\n");

			}

		} catch (FileNotFoundException e) {
			System.err.println("File not found");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Unable to read from file reader");
			e.printStackTrace();
		} finally {
			try {
				in.close();
			} catch (IOException e) {
				System.err.println("Unable to close the file reader");
				e.printStackTrace();
			}
		}
	}

	private static void writeOutputFile(String filePath) {
		BufferedWriter outputFileWriter = null;
		try {
			outputFileWriter = new BufferedWriter(new FileWriter(filePath));
			outputFileWriter.write(sb.toString());
		} catch (FileNotFoundException e) {
			System.err.println("File not found");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Unable to read from file reader");
			e.printStackTrace();
		} finally {
			try {
				outputFileWriter.close();
			} catch (IOException e) {
				System.err.println("Unable to close the file reader");
				e.printStackTrace();
			}
		}
	}

}
