

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class TrainTimetable {
	private static int totalCases;
	private static StringBuffer sb = new StringBuffer();

	static class Train implements Comparable<Train> {
		private int sTime = 0;
		private int eTime = 0;
		public boolean fromA = false;

		public void setSTime(String time) {
			Scanner s1 = new Scanner(time);
			s1.useDelimiter(":");
			int hr = s1.nextInt();
			int min = s1.nextInt();
			sTime = min + (hr * 60);
			s1.close();
		}

		public void setETime(String time) {
			Scanner s1 = new Scanner(time);
			s1.useDelimiter(":");
			int hr = s1.nextInt();
			int min = s1.nextInt();
			eTime = min + (hr * 60);
			s1.close();
		}

		public int getSTime() {
			return sTime;
		}

		public int getETime() {
			return eTime;
		}

		public int compareTo(Train t) {
			int diff = sTime - t.sTime;
			if (diff == 0) {
				int diff2 = eTime - t.eTime;
				return diff2;
			} else {
				return diff;
			}

		}
	}

	public static void main(String[] args) {
		System.out.println("Input filepath = ");
		Scanner in = new Scanner(System.in);
		String inputFilePath = in.nextLine();
		readAndProcess(inputFilePath);
		System.out.println("Output filepath = ");
		String outputFilePath = in.nextLine();
		writeOutputFile(outputFilePath);
		in.close();
	}

	private static void readAndProcess(String filePath) {
		BufferedReader in = null;
		try {
			in = new BufferedReader(new FileReader(filePath));
			totalCases = Integer.parseInt(in.readLine());

			for (int i = 1; i <= totalCases; i++) {
				int turnTime = Integer.parseInt(in.readLine());
				Scanner s1 = new Scanner(in.readLine());
				int nA = s1.nextInt();
				int nB = s1.nextInt();
				s1.close();

				List<Train> a = new ArrayList<Train>(nA + nB);
				for (int j = 1; j <= nA; j++) {
					Train t = new Train();
					Scanner s2 = new Scanner(in.readLine());
					t.setSTime(s2.next());
					t.setETime(s2.next());
					s2.close();
					t.fromA = true;
					a.add(t);
				}

				for (int j = 1; j <= nB; j++) {
					Train t = new Train();
					Scanner s2 = new Scanner(in.readLine());
					t.setSTime(s2.next());
					t.setETime(s2.next());
					s2.close();
					t.fromA = false;
					a.add(t);
				}
				Collections.sort(a);
				int aT = 0;
				int bT = 0;

				List<Train> aTrains = new ArrayList<Train>();
				List<Train> bTrains = new ArrayList<Train>();
				for (int j = 0; j < nA + nB; j++) {
					Train t = a.get(j);
					if (t.fromA) {
						if (bTrains.size() == 0) {
							aT++;
							aTrains.add(t);
						} else {
							boolean trainExist = false;
							for (int k = 0; k < bTrains.size(); k++) {
								Train bTrain = bTrains.get(k);
								if (checkForSameTrain(bTrain, t, turnTime)) {
									bTrains.remove(k);
									aTrains.add(t);
									trainExist = true;
									break;
								}
							}
							if (!trainExist) {
								aTrains.add(t);
								aT++;
							}
						}
					} else {
						if (aTrains.size() == 0) {
							bT++;
							bTrains.add(t);
						} else {
							boolean trainExist = false;
							for (int k = 0; k < aTrains.size(); k++) {
								Train aTrain = aTrains.get(k);
								if (checkForSameTrain(aTrain, t, turnTime)) {
									aTrains.remove(k);
									bTrains.add(t);
									trainExist = true;
									break;
								}
							}
							if (!trainExist) {
								bTrains.add(t);
								bT++;
							}
						}
					}
				}

				sb.append("Case #" + i + ": " + aT + " " + bT + "\n");
			}

		} catch (FileNotFoundException e) {
			System.err.println("File not found");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Unable to read from file reader");
			e.printStackTrace();
		} finally {
			try {
				in.close();
			} catch (IOException e) {
				System.err.println("Unable to close the file reader");
				e.printStackTrace();
			}
		}
	}

	private static boolean checkForSameTrain(Train train, Train train2,
			int turnTime) {
		int eTrain = train.getETime() + turnTime;
		if (train2.getSTime() - eTrain >= 0) {
			return true;
		}
		return false;
	}

	private static void writeOutputFile(String filePath) {
		BufferedWriter outputFileWriter = null;
		try {
			outputFileWriter = new BufferedWriter(new FileWriter(filePath));
			outputFileWriter.write(sb.toString());
		} catch (FileNotFoundException e) {
			System.err.println("File not found");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Unable to read from file reader");
			e.printStackTrace();
		} finally {
			try {
				outputFileWriter.close();
			} catch (IOException e) {
				System.err.println("Unable to close the file reader");
				e.printStackTrace();
			}
		}
	}
}
