
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

public class A {
	private static int totalCases;
	private static StringBuffer sb = new StringBuffer();

	public static void main(String[] args) {
		System.out.println("Input filepath = ");
		Scanner in = new Scanner(System.in);
		String inputFilePath = in.nextLine();
		readAndProcess(inputFilePath);
		System.out.println("Output filepath = ");
		String outputFilePath = in.nextLine();
		writeOutputFile(outputFilePath);
	}

	private static void readAndProcess(String filePath) {
		BufferedReader in = null;
		try {
			in = new BufferedReader(new FileReader(filePath));
			totalCases = Integer.parseInt(in.readLine());

			for (int i = 1; i <= totalCases; i++) {
				Scanner s = new Scanner(in.readLine());
				int p = s.nextInt();
				int k = s.nextInt();
				int l = s.nextInt();
				int[] letters = new int[l];
				s = new Scanner(in.readLine());
				for (int j = 0; j < l; j++) {
					letters[j] = s.nextInt();
				}
				String ans = null;
				if (l > k * p) {
					ans = "Impossible";
				} else {
					Arrays.sort(letters);
					int press = 1;
					int keys = k;
					int max = 0;
					for (int j = l - 1; j >= 0; j--, keys--) {
						if (keys == 0) {
							press++;
							keys = k;
						}
						max = max + (letters[j] * press);
					}
					ans = Integer.toString(max);
				}

				sb.append("Case #" + i + ": " + ans + "\n");
			}
		} catch (FileNotFoundException e) {
			System.err.println("File not found");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Unable to read from file reader");
			e.printStackTrace();
		} finally {
			try {
				in.close();
			} catch (IOException e) {
				System.err.println("Unable to close the file reader");
				e.printStackTrace();
			}
		}
	}

	private static void writeOutputFile(String filePath) {
		BufferedWriter out = null;
		try {
			out = new BufferedWriter(new FileWriter(filePath));
			out.write(sb.toString());
		} catch (IOException e) {
			System.err.println("Unable to read from file reader");
			e.printStackTrace();
		} finally {
			try {
				out.close();
			} catch (IOException e) {
				System.err.println("Unable to close the file reader");
				e.printStackTrace();
			}
		}
	}
}
