package com.company;

import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int TOTAL_CASES = in.nextInt();
        for (int zz = 1; zz <= TOTAL_CASES; zz++) {
            int R = in.nextInt(); // rows
            int C = in.nextInt(); // cols
            int M = in.nextInt(); // mines

            int[][] field = new int[R][C];
            for (int i = 0; i < R; i++) {
                for (int j = 0; j < C; j++) {
                    field[i][j] = 0; // empty
                }
            }
            field[0][0] = 1; // start cell

            if (M % R == 0) {
                for (int i = 0; i < R; i++) {
                    for (int j = 1; j <= M / R; j++) {
                        field[i][C - j] = 2; // mine
                    }
                }
                M = 0;
            } else if (M % C == 0) {
                for (int j = 0; j < C; j++) {
                    for (int i = 1; i <= M / C; i++) {
                        field[R - i][j] = 2; // mine
                    }
                }
                M = 0;
            }

            int minDimension = Math.min(R, C);
            while ((R > 1 || C > 1) && M >= minDimension) {
                if (R == 3 && M == 3) {
                    M = 0;
                    // fill last column with mines
                    for (int i = 0; i < R; i++) {
                        field[i][C - 1] = 2; // mine
                    }
                    C--; // now consider field without that column
                    continue;
                } else if (C == 3 && M == 3) {
                    M = 0;
                    // fill last row with mines
                    for (int j = 0; j < C; j++) {
                        field[R - 1][j] = 2; // mine
                    }
                    R--; // now consider field without that row
                    continue;
                }

                if (C == minDimension) {
                    M = M - minDimension;
                    // fill last row with mines
                    for (int j = 0; j < C; j++) {
                        field[R - 1][j] = 2; // mine
                    }
                    R--; // now consider field without that row
                } else { // R == minDimension
                    M = M - minDimension;
                    // fill last column with mines
                    for (int i = 0; i < R; i++) {
                        field[i][C - 1] = 2; // mine
                    }
                    C--; // now consider field without that column
                }
                minDimension = Math.min(R, C);
            }

//            printField(zz, field);
//            System.out.println("M = " + M);

            if (M == 0) {
                printField(zz, field);
            } else {
                if (M == 1 && (R == 2 || C == 2)) {
                    System.out.format("Case #%d: \nImpossible\n", zz);
                } else if (R > 2 && C > 2 && (R + C - 1) - 4 >= M) {
                    boolean processed = false;
                    for (int j = C - 1; j > 1 && M > 0; j--) {
                        field[R - 1][j] = 2;
                        M--;
                        processed = true;
                    }

                    for (int i = R - (processed ? 2 : 1); i > 1 && M > 0; i--) {
                        field[i][C - 1] = 2;
                        M--;
                    }

                    printField(zz, field);
                } else {
                    System.out.format("Case #%d: \nImpossible\n", zz);
                }
            }
        }
    }

    private static void printField(int zz, int[][] field) {
        int r = field.length;
        int c = field[0].length;
        System.out.format("Case #%d: \n", zz);
        for (int i = 0; i < r; i++) {
            for (int j = 0; j < c; j++) {
                if (field[i][j] == 1) {
                    System.out.print("c");
                } else if (field[i][j] == 2) {
                    System.out.print("*");
                } else {
                    System.out.print(".");
                }
            }
            System.out.println();
        }
    }
}
