package com.company;

import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;

// cat ~/Downloads/file.in | java com.company.Main > ~/Desktop/file.out
public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        in.useLocale(Locale.US);
        int TOTAL_CASES = in.nextInt();
        for (int zz = 1; zz <= TOTAL_CASES; zz++) {
            int N = in.nextInt();
            float[] naomiBlocks = readFloatArray(in, N);
            float[] kenBlocks = readFloatArray(in, N);

            Arrays.sort(naomiBlocks);
            Arrays.sort(kenBlocks);

            int y = getY(naomiBlocks, kenBlocks);
            int z = getZ(naomiBlocks, kenBlocks);
            System.out.format("Case #%d: %d %d\n", zz, y, z);
        }
    }

    private static int getY(float[] naomiBlocks, float[] kenBlocks) {
        int M = kenBlocks.length;
        int j = 0;
        int y = 0;
        for (float chosenNaomi : naomiBlocks) {
            if (kenBlocks[j] > chosenNaomi) {
                M--; // remove the heaviest (last) ken's blocks
                continue;
            } else {
                j++; // move to the next ken's block
                y++;
            }

            if (j == M) {
                break;
            }
        }
        return y;
    }

    private static int getZ(float[] naomiBlocks, float[] kenBlocks) {
        int j = 0;
        int N = naomiBlocks.length;
        for (int i = 0; i < N; i++) {
            float chosenNaomi = naomiBlocks[i];

            boolean kenBlockFound = false;
            while (j < N) {
                if (kenBlocks[j++] > chosenNaomi) {
                    kenBlockFound = true;
                    break; // ken's block which is heavier than naomi's found
                }
            }

            if (j == N) {
                if (kenBlockFound) {
                    return N - i - 1;
                } else {
                    return N - i;
                }
            }
        }
        return 0;
    }

    public static float[] readFloatArray(Scanner sc, int length) {
        float[] array = new float[length];
        for (int i = 0; i < length; i++) {
            array[i] = sc.nextFloat();
        }
        return array;
    }
}
