package com.ilatypov;

import java.util.*;
import java.io.*;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.

        for (int i = 1; i <= t; ++i) {
            int n = in.nextInt();
            int j = in.nextInt();
            int found = 0;

            System.out.println("Case #" + i + ":");

            String[] candidates = getJamCoinCandidates(n);
            for (String candidate : candidates) {
                int divisor = -1;
                int[] divisors = new int[9];

                for (int base = 2; base <= 10; base++) {
                    long v = Long.parseLong(candidate, base);
                    divisor = getDivisor(v);
                    if (divisor != -1) divisors[base - 2] = divisor;
                    else break;
                }

                if (divisor == -1) continue;

                System.out.print(candidate);
                for (int d = 0; d < divisors.length; d++)
                    System.out.print(" " + divisors[d]);
                System.out.println();

                found++;
                if (found == j)
                    break;
            }
        }
    }

    private static String[] getJamCoinCandidates(int length) {
        int innerLength = 2 << (length - 3);
        String[] candidates = new String[innerLength];

        for (int i = 0; i < innerLength; i++) {
            StringBuilder sb = new StringBuilder(length);

            sb.append('1');
            String binary = Integer.toBinaryString(i);
            for (int x = 0; x < length - 2 - binary.length(); x++)
                sb.append('0');
            sb.append(binary);
            sb.append('1');

            candidates[i] = sb.toString();
        }
        return candidates;
    }

    private static int getDivisor(long n) {
        if (n % 2 == 0) return 2;
        for (int i = 3; i*i <= n; i+=2) {
            if (n % i == 0)
                return i;
        }
        return -1;
    }
}