package alien2;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Alien2 {
	static Node root = new Node();
	
	static class Node {
		Map<Character, Node> map = new HashMap<Character, Node>();
		
		Node getOrCreateSubNode(Character character) {
			Node result = getSubNode(character);
			if (result != null) {
				return result;
			} else {
				result = new Node();
				map.put(character, result);
				return result;
			}
		}
		
		Node getSubNode(Character character) {
			return map.get(character);
		}
	}
	

	public static void main(String[] args) throws Exception {
		BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream("/tmp/A-small-attempt1.in")));
//		BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream("/tmp/alien.in")));
		
		PrintStream out = new PrintStream(new FileOutputStream("/tmp/out.txt"));
		
		String firstLine = reader.readLine();
		String firstLineParts[] = firstLine.split(" ");
//		int l = Integer.parseInt(firstLineParts[0]);
		int d = Integer.parseInt(firstLineParts[1]);
		int n = Integer.parseInt(firstLineParts[2]);
		
		for (int wordIndex = 0; wordIndex < d ; wordIndex++) {
			String word = reader.readLine();
			addWord(word);
		}
		
		for (int caseIndex = 1; caseIndex <= n; caseIndex++) {
			String testCase = reader.readLine();
			
			int solution = solve(testCase);
			
			String output = "Case #" + caseIndex + ": " + solution;
			System.out.println(output);
			out.println(output);
		}
		
		String extra = reader.readLine();
		System.out.println("extra: " + extra);
	}
	
	static void addWord(String word) {
		System.out.println("word: " + word);
		Node node = root;
		for (int i=0; i < word.length(); i++) {
			node = node.getOrCreateSubNode(word.charAt(i));
		}
	}
	
	static int solve(String testCase) {
		System.out.println("testCase: " + testCase);
		return solve(testCase, 0, root);
	}
	
	static int solve(String testCase, int index, Node node) {
		if (node.map.isEmpty()) { // leaf, we're at the end of the word
			assert testCase.length() == index;
			return 1;
		}
		char c = testCase.charAt(index++);
		if (c == '(') {
			
			List<Character> pos = new ArrayList<Character>();
			
			c = testCase.charAt(index++);
			while (c != ')') {
				pos.add(c);
				c = testCase.charAt(index++);
			}
			
			int solutionCount = 0;
			for (Character p : pos) {
				Node subNode = node.getSubNode(p);
				if (subNode != null) {
					solutionCount += solve(testCase, index, subNode);
				}
			}
				
			return solutionCount;
		} else {
			Node subNode = node.getSubNode(c);
			if (subNode == null) {
				return 0;
			} else {
				return solve(testCase, index, subNode);
			}
		}
	}

}
