package codejam;

import utils.ProblemSolver;

abstract public class CodeJam extends ProblemSolver {

	abstract public class Case extends Readable {
		public final int caseNr = getThisReadingIndex() + 1;
		
		abstract public String solve();
		
		public String output() {
			return "Case #" + caseNr + ": " + solve();
		}
	}
	
	public CodeJam(String filename) {
		super(filename);
	}
	
	public void go(Class<? extends Case> caseClass) {
		for (Case caze : readCountAndList(caseClass)) {
			print(caze.output());
		}
		if (! atNewLine()) {
			throw new RuntimeException("Not at end of line at end");
		}
		String line = readLine();
		if (line != null) {
			throw new RuntimeException("More input remains: " + line);
		}
	}
}
