package welcome;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Welcome {
	static final String WELCOME = "welcome to code jam";
	static final int L = WELCOME.length();
	
	static Map<Character, List<Integer>> charToPositions = new HashMap<Character, List<Integer>>();
	
	static {
		for (int i=0; i<L; i++) {
			List<Integer> lst = charToPositions.get(WELCOME.charAt(i));
			if (lst == null) {
				lst = new ArrayList<Integer>();
				charToPositions.put(WELCOME.charAt(i), lst);
			}
			lst.add(i);
		}
	}
	
	public static void main(String[] args) throws Exception {
		BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream("/tmp/C-small-attempt0.in")));
//		BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream("/tmp/welcome.in")));
		
		PrintStream out = new PrintStream(new FileOutputStream("/tmp/out.txt"));
		
		String firstLine = reader.readLine();
		int n = Integer.parseInt(firstLine);
		
		for (int i=0; i<n; i++) {
			String line = reader.readLine();

			String output = "Case #" + (i+1) + ": " + Integer.toString(10000 + solve(line)).substring(1);
			System.out.println(output);
			out.println(output);
		}
	}

	static int solve(String s) {
		int[] pap = new int[L];
		
		for (int i=0; i < s.length(); i++) {
			List<Integer> welcomePositions = charToPositions.get(s.charAt(i));
			if (welcomePositions != null) {
				for (int welcomePosition : welcomePositions) {
					pap[welcomePosition] = (pap[welcomePosition] + (welcomePosition==0? 1 : pap[welcomePosition-1])) % 10000; 
				}
			}
		}
		
		return pap[L-1];
	}
}
