import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

/**
 * Created by coendevente on 08-04-17.
 */
public class BRoundOneAlt {
    public static String fileName = "/Users/coendevente/IdeaProjects/CodeJam2016/src/B-small-attempt1.in";

    public static File file = new File(fileName);
    public static Scanner sc;

    static {
        try {
            sc = new Scanner(file);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    public static int[] colors = new int[] {0, 0, 0, 0, 0, 0};
                                         // R, O, Y, G, B, V

    public static char intToChar (int i) {
        char[] c = new char[] {'R', 'O', 'Y', 'G', 'B', 'V'};
        return c[i];
    }

    public static int charToInt (char c) {
        switch (c) {
            case 'R':
                return 0;
            case 'O':
                return 1;
            case 'Y':
                return 2;
            case 'G':
                return 3;
            case 'B':
                return 4;
            case 'V':
                return 5;
            default:
                return 6;
        }
    }

    public static boolean canPutAtIdx(char c, int idx) {
        int i1;
        int i2;
        if (stalls.size() == 0) {
            return true;
        }
        if (stalls.size() == 1) {
            return ! haveSameColor( c, stalls.get(0) );
        }
//        System.out.println("hey");

        if (idx == 0) {
            i1 = 0;
            i2 = stalls.size() - 1;
        } else {
            i1 = idx;
            i2 = idx - 1;
        }
        return ! haveSameColor( c, stalls.get(i1) ) && ! haveSameColor( c, stalls.get(i2) );
    }

    public static boolean haveSameColor(char c1, char c2) {
        char[] prim1 = toPrimary(c1);
        char[] prim2 = toPrimary(c2);

        boolean haveSame = false;
        for (int i = 0; i < prim1.length; ++ i) {
            for (int j = 0; j < prim2.length; ++ j) {
                if (prim1[i] == prim2[j]) {
                    haveSame = true;
                }
            }
        }

        return haveSame;
    }

    public static char[] toPrimary(char c1) {
        switch (c1) {
            case 'O':
                return new char[] {'R', 'Y'};
            case 'G':
                return new char[] {'Y', 'B'};
            case 'V':
                return new char[] {'R', 'B'};
            default:
                return new char[] {c1};
        }
    }

    public static boolean isCurrentlyValid(int idx) {
        int i1;
        int i2;
        if (idx == 0) {
            i1 = 1;
            i2 = N - 1;
        } else if (idx == N - 1) {
            i1 = N - 2;
            i2 = 0;
        } else {
            i1 = idx - 1;
            i2 = idx + 1;
        }

        return ! haveSameColor( stalls.get(idx), stalls.get(i1) ) && ! haveSameColor( stalls.get(idx), stalls.get(i2) );
    }
    public static boolean wouldBeValid(char c, int idx) {
        int i1;
        int i2;
        if (idx == 0) {
            i1 = 0;
            i2 = N - 1;
        } else {
            i1 = idx;
            i2 = idx - 1;
        }

        return ! haveSameColor( c, stalls.get(i1) ) && ! haveSameColor( c, stalls.get(i2) );
    }

    public static int N;
    public static ArrayList<Character> stalls;

    public static void run(int caseNr) {
        N = sc.nextInt();

        stalls = new ArrayList<>();

        for (int i = 0; i < 6; i ++) {
            int n = sc.nextInt();
            for (int j = 0; j < n; j ++) {
                stalls.add(intToChar(i));
            }
        }

        boolean anyChanged = true;

        while (anyChanged) {
//            System.out.println(stalls);

            anyChanged = false;
            for (int i = 0; i < stalls.size(); i ++) {
                if (! isCurrentlyValid(i)) {
                    boolean wasReplaced = false;
                    for (int j = 0; j < N && ! wasReplaced; ++ j) {
                        if (wouldBeValid( stalls.get(i), j )) {
                            stalls.add(j, stalls.get(i));
                            if (j < i) {
                                stalls.remove(i + 1);
                            } else {
                                stalls.remove(i);
                            }
                            wasReplaced = true;
                            anyChanged = true;
                        }
                    }
                }
            }
        }

        boolean possible = true;
        for (int i = 0; i < N; ++ i) {
            if (! isCurrentlyValid(i)) {
                possible = false;
            }
        }

        System.out.print("Case #" + caseNr + ": ");

        if (! possible) {
            System.out.print("IMPOSSIBLE");
        } else {
            for (Character c : stalls) {
                System.out.print(c);
            }
        }

        System.out.println();
    }

    public static void main(String[] args) {
        int T = sc.nextInt();
        for (int i = 0; i < T; ++ i) {
            run(i + 1);
        }
    }
}
