package src;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main {

	final static String inputPath = "src/inputFile.txt";
	final static String outputPath = "src/outputFile.txt";
	final static int maxTries = 40;
	static List<Integer> result = new ArrayList<Integer>();

	public static void main(String[] args) {
		readInput(inputPath);
		createOutput(outputPath);
	}

	private static void readInput(String Filepath) {
		int[] pancakes;
		FileReader reader;
		List<Object> pancakeArrays = new ArrayList<Object>();
		List<Integer> counter = new ArrayList<Integer>();
		try {
			reader = new FileReader(Filepath);
			Scanner in = new Scanner(new BufferedReader(reader));
			int t = in.nextInt();
			;
			for (int i = 0; i < t; i++) {

				pancakeArrays.clear();
				counter.clear();
				String p = in.next();
				pancakes = new int[p.length()];

				for (int j = 0; j < p.length(); j++) {
					if (p.charAt(j) == '+') {
						pancakes[j] = 1;
					} else {
						pancakes[j] = 0;
					}
				}

				int k = in.nextInt();
				pancakeArrays.add(pancakes);
				counter.add(0);
				result.add(solveTestCase(pancakeArrays, k, counter));
			}

			in.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}

	private static int solveTestCase(List<Object> pancakeArray, int k, List<Integer> counter) {

		int bestResult = Integer.MAX_VALUE;
		int totalRounds = 0;
		while(!pancakeArray.isEmpty() && totalRounds < 50000){

			int[] pancakes= (int[]) pancakeArray.remove(0);
			int count = counter.remove(0);
			
			if (count >= maxTries) {
				// not solution found
				continue;
			}
			
			if(count >= bestResult){
				//found already better result				
				continue;
			}

			if (sumIntArray(pancakes) == pancakes.length) {
				// found result
				bestResult = Math.min(bestResult, count);
				continue;
			}
			
			for(int i = 0; i <= pancakes.length - k; i++){		
				if(i != count-1){ //don't flip twice at the beginning
					pancakeArray.add(flipPancakes(pancakes.clone(), i, k));
					counter.add(count+1);
				}
				
			}
			totalRounds++;
		}
		
		return bestResult;
	}

	
	private static int[] flipPancakes(int[] pancakes, int index, int k){
		
		for(int i = index; i < index + k; i++){
			pancakes[i] = (pancakes[i] + 1) % 2;
		}
		
		return pancakes;
		
	}
	
	private static int sumIntArray(int[] x) {
		int result = 0;
		for (int i = 0; i < x.length; i++) {
			result += x[i];
		}
		return result;
	}

	/**
	 * print output in correct format
	 * 
	 * @param FilePath
	 */
	private static void createOutput(String FilePath) {
		FileWriter writer;

		try {
			writer = new FileWriter(FilePath);
			for (int i = 0; i < result.size(); i++) {

				if(result.get(i) >= maxTries){
					writer.write("Case #" + (i + 1) + ": IMPOSSIBLE\n");
					
				}else{
					writer.write("Case #" + (i + 1) + ": " + result.get(i) + "\n");
				}

			}
			writer.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println(e.getMessage());
			e.printStackTrace();
		}

	}
}