package src;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main {

	final static String inputPath = "src/inputFile.txt";
	final static String outputPath = "src/outputFile.txt";
	static List<Long> result = new ArrayList<Long>();

	public static void main(String[] args) {
		readInput(inputPath);
		createOutput(outputPath);
	}

	private static void readInput(String Filepath) {
		FileReader reader;
		try {
			reader = new FileReader(Filepath);
			Scanner in = new Scanner(new BufferedReader(reader));
			int t = in.nextInt();
			;
			for (int i = 0; i < t; i++) {

				long startNumber = in.nextLong(); 

				result.add(solveTestCase(startNumber));

			}

			in.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}

	private static long solveTestCase(long startNumber) {

		while (startNumber > 9) {

			if (isAscendingOrder(startNumber)) {
				return startNumber;
			}else{
				startNumber = jumpSomeNumbers(startNumber);
				//detect wrong digit on index x
				//divide by 10^x
				//subtract 1
				//add (10^x)-1
			}
		}

		return startNumber;
	}
	
	private static long jumpSomeNumbers(long curNumber){
		BigInteger lastModulo;
		BigInteger curModulo;
		BigInteger localCurNumber;
		int count = 0;
		
		localCurNumber = BigInteger.valueOf(curNumber);
		lastModulo = localCurNumber.mod(BigInteger.TEN);

		while (localCurNumber.longValue() > 0) {
			curModulo = localCurNumber.mod(BigInteger.TEN);

			if (lastModulo.longValue() < curModulo.longValue()) {
					//do some magic here
				localCurNumber = localCurNumber.subtract(BigInteger.ONE);
				localCurNumber = localCurNumber.multiply(BigInteger.TEN.pow(count));//  10^count;
				
				localCurNumber = localCurNumber.add((BigInteger.TEN.pow(count)).subtract(BigInteger.ONE));
				//curNumber +=  Math.pow(10L, count) - 1L;
				//reset lastModulo and curModulo
				lastModulo = localCurNumber.mod(BigInteger.TEN);
				//lastModulo = curNumber % 10L;
				curModulo = BigInteger.ZERO;
				
				return localCurNumber.longValue();
				
			} else {
				lastModulo = curModulo;
				localCurNumber = localCurNumber.divide(BigInteger.TEN);
				count++;
			}
		}

		return localCurNumber.longValue();
	}

	private static boolean isAscendingOrder(long curNumber) {
		long lastModulo;
		long curModulo;

		lastModulo = curNumber % 10L;

		while (curNumber > 0) {
			curModulo = curNumber % 10L;

			if (lastModulo < curModulo) {
				return false;

			} else {
				lastModulo = curModulo;
				curNumber = curNumber / 10;
			}
		}

		return true;
	}

	/**
	 * print output in correct format
	 * 
	 * @param FilePath
	 */
	private static void createOutput(String FilePath) {
		FileWriter writer;

		try {
			writer = new FileWriter(FilePath);
			for (int i = 0; i < result.size(); i++) {

				writer.write("Case #" + (i + 1) + ": " + result.get(i) + "\n");

			}
			writer.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println(e.getMessage());
			e.printStackTrace();
		}

	}
}