package src;


import java.util.*;
import java.io.*;

public class Main {

	final static String inputPath = "src/inputFile.txt";
	final static String outputPath = "src/outputFile.txt";
	static double[] result;

	public static void main(String[] args) {
		readInput(inputPath);
		createOutput(outputPath);
	}

	/**
	 * read input file and execute each testcase
	 * @param Filepath
	 */
	private static void readInput(String Filepath) {
		FileReader reader;
		long[][] horses;
		try {
			reader = new FileReader(Filepath);
			Scanner in = new Scanner(new BufferedReader(reader));
			int t = in.nextInt();

			result = new double[t];
			for (int i = 0; i < t; i++) {

				// each testcase
				long destination = in.nextLong();
				int n= in.nextInt(); // number of horses
				
				horses = new long[n][2];
				
				for (int j = 0; j < n; j++) {
					horses[j][0] = in.nextLong();
					horses[j][1] = in.nextLong();
				}

				result[i] = solveTestCase(destination,horses);
				
			}

			in.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}

	/**
	 *
	 */
	private static double solveTestCase(long destination, long[][] horses) {
		double result = 0.0;
		double longestTime = 0.0;
		double curTime = 0.0;
		double distToGo = 0.0;
		for(int i = 0; i < horses.length; i++){			
			distToGo = destination - horses[i][0];
			curTime = distToGo / horses[i][1] ;
			longestTime = (curTime > longestTime) ? curTime : longestTime;		
		}
		
		result = destination / longestTime;

		return  result;
		
	}
	
	private static String getStringRepresentation(ArrayList<Character> list)
	{    
	    StringBuilder builder = new StringBuilder(list.size());
	    for(Character ch: list)
	    {
	        builder.append(ch);
	    }
	    return builder.toString();
	}

	/**
	 * print output in correct format
	 * 
	 * @param FilePath
	 */
	private static void createOutput(String FilePath) {
		FileWriter writer;

		try {
			writer = new FileWriter(FilePath);
			for (int i = 0; i < result.length; i++) {

				writer.write("Case #" + (i + 1) + ": " + result[i] + "\n");

			}
			writer.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println(e.getMessage());
			e.printStackTrace();
		}

	}
}