package src;


import java.util.*;
import java.io.*;

public class Main {

	final static String inputPath = "src/inputFile.txt";
	final static String outputPath = "src/outputFile.txt";
	static List<Integer> stalls = new ArrayList<>();
	static int[][] result;
	static int maxDist,minDist;

	public static void main(String[] args) {
		readInput(inputPath);
		createOutput(outputPath);
	}

	private static void readInput(String Filepath) {
		FileReader reader;
		try {
			reader = new FileReader(Filepath);
			Scanner in = new Scanner(new BufferedReader(reader));
			int t = in.nextInt();

			result = new int[t][2];
			for (int i = 0; i < t; i++) {

				// each testcase
				int n = in.nextInt();
				stalls.clear();

				stalls.add(1); // guard left most
				stalls.add(n + 2); // guard right most

				int p = in.nextInt(); // person which enter the stalls

				solveTestCase(p);
				result[i][0] = maxDist;
				result[i][1] = minDist;				
				

			}

			in.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}

	private static void solveTestCase(int numberOfPersons) {
	
		int spaceToNext = 0;
		int bestStall = 0;

		for (int p = 0; p < numberOfPersons; p++) {

			if (stalls.size() == 2) { // only two guards
				bestStall = stalls.get(1) / 2 + stalls.get(1) % 2;
				stalls.add(bestStall);
				minDist = (bestStall - stalls.get(0))-1; //count empty stall
				maxDist = (stalls.get(1)- bestStall)-1;
			} else {

				int curMaxSpace = 0;
				for (int i = 0; i < stalls.size() - 1; i++) {
					
					spaceToNext = (stalls.get(i+1) - stalls.get(i))-1; //space between current ant next stall			
					
					
					if (spaceToNext > curMaxSpace) {
						// found new maximum minimum value
						// found current best stall
						bestStall = stalls.get(i) + ((stalls.get(i+1) - stalls.get(i)) / 2);
						
						minDist = (bestStall - stalls.get(i))-1;
						maxDist = (stalls.get(i+1)- bestStall)-1;
						curMaxSpace = spaceToNext;
					}
				}
				stalls.add(bestStall);
			}			
			Collections.sort(stalls); //sortiere die nummer der belegten stalls aufsteigend
		}

	}

	/**
	 * print output in correct format
	 * 
	 * @param FilePath
	 */
	private static void createOutput(String FilePath) {
		FileWriter writer;

		try {
			writer = new FileWriter(FilePath);
			for (int i = 0; i < result.length; i++) {

				writer.write("Case #" + (i + 1) + ": " + result[i][0] + " " + result[i][1] + "\n");

			}
			writer.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println(e.getMessage());
			e.printStackTrace();
		}

	}
}