package src;

import java.util.*;
import java.io.*;

public class Main {

	final static String inputPath = "src/inputFile.txt";
	final static String outputPath = "src/outputFile.txt";
	static int[] stalls ;
	static String[] result;
	static int[] ponys;
	static int maxDist, minDist;

	public static void main(String[] args) {
		readInput(inputPath);
		createOutput(outputPath);
	}

	/**
	 * read input file and execute each testcase
	 * 
	 * @param Filepath
	 */
	private static void readInput(String Filepath) {
		FileReader reader;
		try {
			reader = new FileReader(Filepath);
			Scanner in = new Scanner(new BufferedReader(reader));
			int t = in.nextInt();

			result = new String[t];
			for (int i = 0; i < t; i++) {

				// each testcase
				stalls = new int[in.nextInt()];
				ponys = new int[6];
				for (int j = 0; j < 6; j++) {
					ponys[j] = in.nextInt();
				}

				result[i] = solveTestCase();

			}

			in.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}

	/**
	 *
	 */
	private static String solveTestCase() {
		ArrayList<Character> result = new ArrayList<Character>();
		int curPony = -1;
		int curStall = 0;
		int shuffle = 0;
		
		if(maxValue(ponys) > (stalls.length/2)){
			return "IMPOSSIBLE";
		}
		
		// first pony
		for (int i = 0; i < ponys.length; i++) {
			if (ponys[i] > 0) {
				stalls[curStall] = i;
				curPony = i;
				ponys[i]--; // remove from list
				curStall++;
				break;
			}
		}

		if (curPony == -1) {
			return "IMPOSSIBLE";
		}

		int selectedPony = 0;
		for (int i = 1; i < stalls.length; i++) {
			// fill all stalls
			shuffle = i;
			switch (curPony) {
			
			case 0: // curPony is Red -> next Pony can be Y, G,B 2,3,4
				selectedPony = takePonyI(shuffle, 2, 3, 4);
				if (selectedPony == -1) {
					return "IMPOSSIBLE";
				} else {
					stalls[i] = selectedPony;
					curPony = selectedPony;
				}
				break;
				
			case 1: // cur is Orange -> next is B 4
				selectedPony = takePonyI(shuffle,4);
				if (selectedPony == -1) {
					return "IMPOSSIBLE";
				} else {
					stalls[i] = selectedPony;
					curPony = selectedPony;
				}
				break;
				
			case 2: // cur is Yellow -> next is R, B, V 0,4,5
				selectedPony = takePonyI(shuffle,0, 4, 5);
				if (selectedPony == -1) {
					return "IMPOSSIBLE";
				} else {
					stalls[i] = selectedPony;
					curPony = selectedPony;
				}

				break;
				
			case 3: // cur is Green -> next is R 0
				selectedPony = takePonyI(shuffle,0);
				if (selectedPony == -1) {
					return "IMPOSSIBLE";
				} else {
					stalls[i] = selectedPony;
					curPony = selectedPony;
				}
				break;

			case 4: // cur is Blue -> next is R, O, Y 0,1,2
				selectedPony = takePonyI(shuffle, 0, 1, 2);
				if (selectedPony == -1) {
					return "IMPOSSIBLE";
				} else {
					stalls[i] = selectedPony;
					curPony = selectedPony;
				}
				break;

			case 5: // cur is Violet -> next is Y 2
				selectedPony = takePonyI(shuffle,2);
				if (selectedPony == -1) {
					return "IMPOSSIBLE";
				} else {
					stalls[i] = selectedPony;
					curPony = selectedPony;
				}
				break;

			default:
				break;
			}
		}

		//check last and first pony
		switch (curPony) {
		case 0:
			if(stalls[0] == 0 || stalls[0] == 1 || stalls[0] == 5){
				stalls[stalls.length-1] = stalls[stalls.length-2];
				stalls[stalls.length-2] = curPony;
				//return "IMPOSSIBLE";
			}
			break;
		case 1:
			if(stalls[0] == 0 || stalls[0] == 1 || stalls[0] == 2|| stalls[0] == 3||  stalls[0] == 5){
				return "IMPOSSIBLE";
			}
			break;
		case 2:
			if(stalls[0] == 1 || stalls[0] == 2 || stalls[0] == 3){
				stalls[stalls.length-1] = stalls[stalls.length-2];
				stalls[stalls.length-2] = curPony;
				//return "IMPOSSIBLE";
			}
			break;
		case 3:
			if(stalls[0] == 1 || stalls[0] == 2 || stalls[0] == 3 || stalls[0] == 4||  stalls[0] == 5){
				return "IMPOSSIBLE";
			}
			break;
		case 4:
			if(stalls[0] == 3 || stalls[0] == 4 || stalls[0] == 5){
				stalls[stalls.length-1] = stalls[stalls.length-2];
				stalls[stalls.length-2] = curPony;
				//return "IMPOSSIBLE";
			}
			break;
		case 5:
			if(stalls[0] == 0 || stalls[0] == 1 || stalls[0] == 3|| stalls[0] == 4||  stalls[0] == 5){
				return "IMPOSSIBLE";
			}
			break;

		default:
			break;
		}
		
		for(int i = 0; i< stalls.length ; i++){
			switch (stalls[i]) {
			case 0:
				result.add('R');
				break;
			case 1:
				result.add('O');
				break;
			case 2:
				result.add('Y');
				break;
			case 3:
				result.add('G');
				break;
			case 4:
				result.add('B');
				break;
			case 5:
				result.add('V');
				break;

			default:
				break;
			}
		}
		
		return getStringRepresentation(result);

	}
	
	
	private static int maxValue(int[] x){
		int max = x[0];
		for (int i = 0; i < x.length; i++) {
			max = (max > x[i]) ? max : x[i];
		}
		
		return max;
	}

	private static int takePonyI(int shuffle, int... i) {

		//shuffle = stallIndex
		// get the kind with most amount
		int maxNumber =  -1;
		int maxIndex = i[0];
		
		int prePony = -1;
		//prefer 1 3 and 5
		
		
		if(shuffle > 1){
			prePony = stalls[shuffle-2];
		}
		
		int curIndex = 0;
		for (int j = 0; j < i.length; j++) {			
			curIndex = i[(shuffle + j) % i.length];			
					
			if(curIndex == 1 || curIndex == 3 || curIndex == 5){
				//prefer mixed color -
				if (ponys[curIndex] > 0){
					maxIndex = curIndex;
					maxNumber = ponys[curIndex];
					break; //quit for loop
					
				}
			}
			
			if (ponys[curIndex] > 0 && ponys[curIndex] == maxNumber && prePony == curIndex) {
				//prefer prePony
				maxIndex = curIndex;
				maxNumber = ponys[curIndex];
			}
			
			if (ponys[curIndex] > 0 && ponys[curIndex] > maxNumber) {
				
				//kind with most ponys
				maxIndex = curIndex;
				maxNumber = ponys[curIndex];
			}			
		}
		
		if(maxNumber == -1){
			//error
			return maxNumber;
		}else{
			ponys[maxIndex]--;
			return maxIndex;
		}
	}

	private static String getStringRepresentation(ArrayList<Character> list) {
		StringBuilder builder = new StringBuilder(list.size());
		for (Character ch : list) {
			builder.append(ch);
		}
		return builder.toString();
	}

	/**
	 * print output in correct format
	 * 
	 * @param FilePath
	 */
	private static void createOutput(String FilePath) {
		FileWriter writer;

		try {
			writer = new FileWriter(FilePath);
			for (int i = 0; i < result.length; i++) {

				writer.write("Case #" + (i + 1) + ": " + result[i] + "\n");

			}
			writer.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println(e.getMessage());
			e.printStackTrace();
		}

	}
}