
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Collections;
import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.Scanner;


public class ProblemB {

    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(new FileReader("/Users/hadoop/B-small-attempt4.in.txt"));
        PrintWriter pw = new PrintWriter(new FileWriter("/Users/hadoop/problemB4.txt"));
        
        int T = sc.nextInt();
        for(int cs = 1; cs <= T; cs++)
        {
            pw.printf("Case #%d: ", cs);
            System.out.printf("Case #%d: ", cs);
            solver(sc, pw);
        }
        
        pw.flush();
        pw.close();
        sc.close();
    }
    
    private static void solver(Scanner sc, PrintWriter pw)
    {
        int D  = sc.nextInt();
        PriorityQueue<Counter> maxpq = new PriorityQueue<>();
        for(int i = 0; i < D; i++){
            int val = sc.nextInt();
            System.out.print(val  + ",");
            maxpq.add(new Counter(val,1));
        }
        
        int iter = getMinMins(maxpq);
        pw.println(iter);
        System.out.println(iter);
    }
    
    private static int getMinMins(PriorityQueue<Counter> maxpq) {
        if(maxpq.isEmpty()) return 0;
        if(maxpq.peek().key <= 3) return maxpq.peek().key;
        
        Counter c = null;
        int firstVal = maxpq.isEmpty() ? 0 : maxpq.peek().key;
        int count = 0; 
        
        while(!maxpq.isEmpty()){
            c = maxpq.remove();
            count += c.val; 
            if(maxpq.isEmpty() || maxpq.peek().key != firstVal) break;
        }
        
        if(firstVal % 2 == 0) {
            maxpq.add(new Counter((int)firstVal/2,count * 2));
        }
        else {
            maxpq.add(new Counter((int)firstVal/2,count));
            maxpq.add(new Counter(firstVal - (int)firstVal /2,count));
        }

        int minMins = getMinMins(maxpq);
        return Math.min(firstVal, count + minMins );
    }
    
    private static class Counter implements Comparable{
        int key ;
        int val;
        
        private Counter(int key, int val) {
            this.key = key; 
            this.val = val; 
        }
        
        private void addVal(int val){
            this.val += val; 
        }
        
        public int compare(Counter o1, Counter o2) {
            return o2.key - o1.key;
        }

        @Override
        public int compareTo(Object o) {
            return ((Counter) o).key - this.key;
        }
        
    }
   
}
