import java.util.*;
import java.io.*;

/**
  * @author Mighty Cohadar 
  */
public class Bravo {

	final int n;
	final int[][] A;
	final int[][] R;

	public Bravo(int n, int[][] A) {
		this.n = n;
		this.A = A;
		this.R = new int[n][n];
	}

	public static void sort(int[][] A) {
		for (int i = 0; i < A.length; i++) {
			for (int j = i + 1; j < A.length; j++) {
				if (A[i][0] > A[j][0]) {
					int[] T = A[i];
					A[i] = A[j];
					A[j] = T;
				}
			}
		}
	}

	int ny;
	int nx;
	int na;

	public boolean addRow() {
		for (int x = 0; x < n; x++) {
			if (x < nx) {
				if (R[ny][x] != A[na][x]) {
					return false;
				}	
			} else {
				R[ny][x] = A[na][x];	
			}
			if (R[ny-1][x] >= R[ny][x]) {
				return false;
			}
		}
		return true;
	}

	public boolean addColumn() {
		for (int y = 0; y < n; y++) {
			if (y < ny) {
				if (R[y][nx] != A[na][y]) {
					return false;
				}
			} else {
				R[y][nx] = A[na][y];	
			}
			if (R[y][nx-1] >= R[y][nx]) {
				return false;
			}
		}
		return true;
	}

	public void rec() {
		if (ny < n && na < A.length) {
			if (addRow()) {
				ny++;
				na++;
				rec();	
			}
		}
		if (nx < n && na < A.length) {
			if (addColumn()) {
				nx++;
				na++;
				rec();
			}
		}
	}

	public int[] solve() {
		sort(A);
		for (int i = 0; i < n; i++) {
			R[0][i] = A[0][i];
			R[i][0] = A[1][i];
		}
		na = 2;
		ny = 1;
		nx = 1;
		rec();
		// debug(R);
		if (ny < n) {
			return R[n - 1];	
		} else {
			int[] C = new int[n];
			for (int i = 0; i < n; i++) {
				C[i] = R[i][n - 1];
			}
			return C;
		}
	}

	public static Bravo load(Scanner scanner) {
		int n = scanner.nextInt();
		assert 2 <= n && n <= 50 : "out of range, n: " + n;
		int[][] A = new int[2 * n - 1][];
		for (int i = 0; i < A.length; i++) {
			A[i] = scanArray(scanner, n);	
		}
		return new Bravo(n, A);
	}	

	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		int t = scanner.nextInt();
		assert 1 <= t && t <= 50 : "out of range, t: " + t;
		for (int it = 1; it <= t; it++) {
			Bravo o = Bravo.load(scanner);
			System.out.printf("Case #%d: %s\n", it, join(o.solve(), " "));
		}
	}

	static int[] scanArray(Scanner scanner, int n) {
		int[] A = new int[n];
		for (int i = 0; i < n; i++) {
			A[i] = scanner.nextInt();
		}
		return A;
	}

	static String join(int[] A, String delimiter) {
		StringBuilder sb = new StringBuilder();
		for (int a : A) {
			sb.append(a);
			sb.append(delimiter);
		}
		if (sb.length() >= delimiter.length()) {
			sb.setLength(sb.length() - delimiter.length());
		}			
		return sb.toString();
	}

	static void debug(Object...os) {
		System.err.printf("%.65536s\n", Arrays.deepToString(os));
	}	

	static void debug(int[][] M) {
		for (int y = 0; y < M.length; y++) {
			for (int x = 0; x < M[0].length; x++) {
				System.err.print(M[y][x]);
				System.err.print(' ');
			}
			System.err.println();
		}
		System.err.println();
	}

}
