package yr2013.qround.qB;

import java.io.*;
import java.util.*;
import java.lang.Math;

public class B{

	// User Defined Variable
	int N = 0; 
	int M = 0; 
	int[][] A; 
	
	void readParam(){
		N = in.nextInt();
		M = in.nextInt();
		A = new int[N][M];
		for(int i=0; i<N; i++){
			for(int j=0; j<M; j++){
				A[i][j] = in.nextInt();
			}
		}
	}
	
	void solve(){
		int[][] arr = new int[N][M];
		int[] hMax = new int[N];
		int[] vMax = new int[M];

		// Find Max
		for(int i=0; i<N; i++){
			int max = Integer.MIN_VALUE;
			for(int j=0; j<M; j++){
				max = Math.max(max, A[i][j]);
			}
			hMax[i] = max;
		}
		for(int j=0; j<M; j++){
			int max = Integer.MIN_VALUE;
			for(int i=0; i<N; i++){
				max = Math.max(max, A[i][j]);
			}
			vMax[j] = max;
		}
		
		// Chk H
		for(int i=0; i<N; i++){
			for(int j=0; j<M; j++){
				if (A[i][j]==hMax[i]) arr[i][j]++;
			}
		}
		
		// Chk V
		for(int j=0; j<M; j++){
			for(int i=0; i<N; i++){
				if (A[i][j]==vMax[j]) arr[i][j]++;
			}
		}
		
		// Chk R
		for(int i=0; i<N; i++){
			for(int j=0; j<M; j++){
				if (arr[i][j] <= 0) {
					out.printf("NO\n");
					return;
				}
			}
		}
		out.printf("YES\n");
	}
	
	// -----------------------------No Need To Amend Below---------------------------
	// Common
	static String DATA_SET = "Default";
	int NUM_OF_CASE = 0;
	Scanner in;
	PrintStream out;

	
	void setFile() throws Exception{
		File inFile = new File(DATA_SET+".in");
		File outFile = new File(DATA_SET+".out");
		in = new Scanner(inFile);
		out = new PrintStream(outFile);
	}
	
	void run() throws Exception{
		setFile();
		NUM_OF_CASE = in.nextInt();
		for(int c = 1; c <= NUM_OF_CASE; c++){
			readParam();
			out.printf("Case #%d: ", c);
			solve();
		}
	}
	
	/**
	 * @param args
	 * @throws FileNotFoundException 
	 */
	public static void main(String[] args) throws Exception {
		if (args.length>0) DATA_SET = args[0];
		(new B()).run();
	}

}
