package yr2013.qround.qD;

import java.io.*;
import java.util.*;
import java.lang.Math;

public class D{
	
	/*
	 * Input

The first line of the input gives the number of test cases, T. 
T test cases follow. Each test case begins with a single line containing two positive integers K and N, 
representing the number of keys you start with and the number of chests you need to open.

This is followed by a line containing K integers, representing the types of the keys that you start with.

After that, there will be N lines, each representing a single chest. Each line will begin with integers Ti and Ki, 
indicating the key type needed to open the chest and the number of keys inside the chest. These two integers will be followed by Ki more integers, 
indicating the types of the keys contained within the chest.
	3
1 4
1

1 0
1 2 1 3
2 0
3 1 2

3 3
1 1 1
1 0
1 0
1 0
1 1
2
1 1 1


Case #1: 2 1 4 3
Case #2: 1 2 3
Case #3: IMPOSSIBLE


	 * 
	 * */
	

	// User Defined Variable
	int K = 0; 
	int C = 0; 
	int[] KEY_TYPE;
	int[] C_TYPE;
	Vector<Vector<Integer>> C_KEY_TYPE;
	
	void readParam(){
		K = in.nextInt();
		C = in.nextInt();
		KEY_TYPE = new int[200];
		for(int i=0;i<K;i++){
			KEY_TYPE[in.nextInt()-1]++;
		}
		C_TYPE = new int[C];
		C_KEY_TYPE = new Vector<Vector<Integer>>();
		for(int i=0;i<C;i++){
			C_TYPE[i] = in.nextInt()-1;
			int C_KEY = in.nextInt();
			Vector<Integer> vType = new Vector<Integer>();
			for(int j=0;j<C_KEY;j++){
				vType.add(in.nextInt()-1);
			}
			C_KEY_TYPE.add(vType);
		}
	}
	
	boolean[] bOpened;
	Vector<Integer> ans;
	int[] tmp_KEY_TYPE;
	void solve(){
		bOpened = new boolean[C];
		tmp_KEY_TYPE = new int[200];
		for(int i=0;i<C;i++){
			ans = new Vector<Integer>();
			Arrays.fill(bOpened, false);
			System.arraycopy(KEY_TYPE, 0, tmp_KEY_TYPE, 0, KEY_TYPE.length);
			if (DFS(i)){
				for(int a: ans){
					out.printf("%d ",a+1);
				}
				out.printf("\n");
				return;
			}
		}
		out.printf("IMPOSSIBLE\n");
	}
	
	// c: chest
	boolean DFS(int c) {
		if (   c<C_TYPE.length
			&& C_TYPE[c]<tmp_KEY_TYPE.length
			&& tmp_KEY_TYPE[C_TYPE[c]]>0){
			tmp_KEY_TYPE[C_TYPE[c]]--;
			Vector<Integer> vType = C_KEY_TYPE.get(c);
			for(int t: vType){
				tmp_KEY_TYPE[t]++;
			}
			bOpened[c] = true;
			ans.add(c);
			int openCnt = 0;
			for(int i=0; i<C; i++){
				if (!bOpened[i]){
					if (DFS(i)) return true;
				}else
					openCnt++;
			}
			if(openCnt==C) return true;
		}
		return false;
	}

	// -----------------------------No Need To Amend Below---------------------------
	// Common
	static String DATA_SET = "Default";
	int NUM_OF_CASE = 0;
	Scanner in;
	PrintStream out;

	
	void setFile() throws Exception{
		File inFile = new File(DATA_SET+".in");
		File outFile = new File(DATA_SET+".out");
		in = new Scanner(inFile);
		out = new PrintStream(outFile);
	}
	
	void run() throws Exception{
		setFile();
		NUM_OF_CASE = in.nextInt();
		for(int c = 1; c <= NUM_OF_CASE; c++){
			readParam();
			out.printf("Case #%d: ", c);
			solve();
		}
	}
	
	/**
	 * @param args
	 * @throws FileNotFoundException 
	 */
	public static void main(String[] args) throws Exception {
		if (args.length>0) DATA_SET = args[0];
		(new D()).run();
	}

}
