package yr2013.qround.qA;

import java.io.*;
import java.util.*;
import java.lang.Math;

public class A{

	// User Defined Variable
	String[] L; 
	
	/*
	Input

	The first line of the input gives the number of test cases, T. 
	T test cases follow. 
	Each test case consists of 4 lines with 4 characters each, 
	with each character being 'X', 'O', '.' or 'T' (quotes for clarity only). 
	Each test case is followed by an empty line.
	
XXXT
....
OO..
....

XOXT
XXOO
OXOX
XXOO
	
	*/
	
	void readParam(){
		L = new String[4];
		for(int i=0; i<4; i++){
			L[i] = in.next();
		}
		//in.nextLine();
	}
	
	void solve(){
		boolean xWin=false;
		boolean oWin=false;
		if (chkV('X') || chkH('X') || chkD('X')) xWin=true;
		if (chkV('O') || chkH('O') || chkD('O')) oWin=true;
		
		
		if (xWin && oWin){
			out.printf("Draw\n");
		}else if (xWin){
			out.printf("X won\n");
		}else if (oWin){
			out.printf("O won\n");
		}else if (!chkF()){
			out.printf("Game has not completed\n");
		}else{
			out.printf("Draw\n");
		}
		
	}
	
	boolean chkV(char ch){
		for(int j=0; j<4; j++){
			int cnt = 0;
			for(int i=0; i<4; i++){
				if (L[i].charAt(j)==ch || L[i].charAt(j)=='T'){
					cnt++;
				}
			}
			if (cnt==4) return true;
		}
		return false;
	}

	boolean chkH(char ch){
		for(int i=0; i<4; i++){
			int cnt = 0;
			for(int j=0; j<4; j++){
				if (L[i].charAt(j)==ch || L[i].charAt(j)=='T'){
					cnt++;
				}
			}
			if (cnt==4) return true;
		}
		return false;
	}

	boolean chkD(char ch){
		int cnt = 0;
		for(int i=0; i<4; i++){
			if (L[i].charAt(i)==ch || L[i].charAt(i)=='T'){
				cnt++;
			}
		}
		if (cnt==4) return true;
		cnt = 0;
		for(int i=0; i<4; i++){
			if (L[4-i-1].charAt(i)==ch || L[4-i-1].charAt(i)=='T'){
				cnt++;
			}
		}
		if (cnt==4) return true;
		
		return false;
	}
	
	boolean chkF(){
		for(int i=0; i<4; i++){
			for(int j=0; j<4; j++){
				if (L[i].charAt(j)=='.'){
					return false;
				}
			}
		}
		return true;
	}
	
	// -----------------------------No Need To Amend Below---------------------------
	// Common
	static String DATA_SET = "Default";
	int NUM_OF_CASE = 0;
	Scanner in;
	PrintStream out;

	
	void setFile() throws Exception{
		File inFile = new File(DATA_SET+".in");
		File outFile = new File(DATA_SET+".out");
		in = new Scanner(inFile);
		out = new PrintStream(outFile);
	}
	
	void run() throws Exception{
		setFile();
		NUM_OF_CASE = in.nextInt();
		for(int c = 1; c <= NUM_OF_CASE; c++){
			readParam();
			out.printf("Case #%d: ", c);
			solve();
		}
	}
	
	/**
	 * @param args
	 * @throws FileNotFoundException 
	 */
	public static void main(String[] args) throws Exception {
		if (args.length>0) DATA_SET = args[0];
		(new A()).run();
	}

}
