package qr.c;

import Template.*;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.Arrays;
import java.util.HashMap;

/**
 *
 * @author CuteCoke
 */
public class C {
    //private static String TASK_NAME = "C-small";
    //private static String TASK_NAME = "C-large";

    //private static String TASK_NAME = "sample";
    private static String TASK_NAME = "C-small-attempt1";


    // ----------------------------------------------------------//
    final String IN_FILE = TASK_NAME + ".in";
    final String OUT_FILE = TASK_NAME + ".out";

    public int solve() {
        return 0;
    }

    public void doMain() throws Exception {
        try {

            Scanner sc1 = null;
            BufferedReader br = new BufferedReader(new FileReader(IN_FILE));
            BufferedWriter bw = new BufferedWriter(new FileWriter(OUT_FILE));

            int T = Integer.parseInt(br.readLine());

            for (int a = 0; a < T; a++) {
                bw.write("Case #" + (a + 1) + ": ");
                sc1 = new Scanner(br.readLine());

                int N = sc1.nextInt();
                int[] C = new int[N];
                sc1 = new Scanner(br.readLine());
                for (int i = 0; i < N; i++) {
                    C[i] = sc1.nextInt();
                }

                String ans = solve(N, C);
                bw.write(ans + "\n");
            }
            br.close();
            bw.close();

        } catch (FileNotFoundException e) {
            System.err.println("In File: " + (new File(IN_FILE)).getAbsolutePath());
            System.err.println("Out File: " + (new File(OUT_FILE)).getAbsolutePath());
            e.printStackTrace(System.err);
        }
    }

    public static void main(String[] s) throws Exception {
        try {
            C test = new C();
            test.doMain();
        } catch (Exception e) {
            e.printStackTrace(System.err);
        }
    }

    boolean[] bSel = null;
    String[] arrS = null;
    int[] arrI = null;
    int max = Integer.MIN_VALUE;
    int size = 0;
    HashMap<String,String> hsSumCache = new HashMap<String,String>();

    private String solve(int N, int[] C) {
        bSel=new boolean[N];
        arrS = new String[N];
        arrI = C;
        max = Integer.MIN_VALUE;
        size = N;
        for (int i = 0; i < N; i++) {
            arrS[i] = numToBase(C[i], 2);
        }

        rr(N/2-1);
        //rr(0);

        String res = (max==Integer.MIN_VALUE)?"NO":max+"";
        return res;
    }

    private void rr(int pos){
        for (int i = pos; i < size; i++) {
            if (bSel[i]) continue;
            bSel[i]=true;

            ArrayList<Integer> arrPile1 = new ArrayList<Integer>();
            ArrayList<Integer> arrPile2 = new ArrayList<Integer>();
            for (int j = 0; j < size; j++) {
                if(bSel[j])
                    arrPile1.add(j);
                else
                    arrPile2.add(j);
            }

            if (arrPile1.size()>0 && arrPile2.size()>0){
                //System.out.println("arrPile1 = " + listToStr(arrPile1));
                //System.out.println("arrPile2 = " + listToStr(arrPile2));

                String rPile1 = getBase2Sum(arrS, arrPile1);
                String rPile2 = getBase2Sum(arrS, arrPile2);
                int lenPileNo = Math.max(rPile1.length(), rPile2.length());
                rPile1 = fillZero(rPile1, lenPileNo);
                rPile2 = fillZero(rPile2, lenPileNo);

                if(rPile1.equals(rPile2)){
                    //System.out.println("Eq: [Equal] arrPile1: "+rPile1+"; arrPile12: "+rPile2);
                    max = Math.max(max, Math.max(getBase10Sum(arrI, arrPile1), getBase10Sum(arrI, arrPile2)));
                }else{
                    //System.out.println("Eq: [Not Equal] arrPile1: "+rPile1+"; arrPile12: "+rPile2);
                }
                //System.out.println("max: "+max);
            }

            rr(pos+1);
            bSel[i]=false;
        }
    }

    private int baseToNum(String sBaseNum, int base) {
        int num = 0;
        for (int i = 0; i < sBaseNum.length(); i++) {
            num = num * base + (sBaseNum.charAt(i) - '0');
        }
        return num;
    }

    private String numToBase(int num, int base) {
        String sBaseNum = "";
        while (num > 0) {
            int tmp = num % base;
            sBaseNum = tmp + sBaseNum;
            num /= base;
        }
        return sBaseNum;
    }

    int getBase10Sum(int[] arrFullList, ArrayList<Integer> lPos){
        int res = 0;
        for (int i = 0; i < lPos.size(); i++) {
            res += arrFullList[lPos.get(i)];
        }
        return res;
    }
    String getBase2Sum(String[] arrFullList, ArrayList<Integer> lPos){
        String res = "";
        for (int i = 0; i < lPos.size(); i++) {
            String ws = arrFullList[lPos.get(i)];
            int len = 0;
            if (ws.length()>res.length()){
                len=ws.length();
                res=fillZero(res,len);
            }else{
                len=res.length();
                ws=fillZero(ws,len);
            }
            res = sum(len,res,ws);
        }
        return res;
    }
    String fillZero(String s, int len){
        String z = "";
        int slen = s.length();
        int sz = len - slen;
        for(int i=0;i<sz;i++)
            z += "0";
        return z+s;
    }

    private String sum(int len, String s1, String s2) {
        String res = "";
        //System.out.println("hsSumCache("+s1+","+s2+") = "+hsSumCache.get(s1+s2));
        String cache = hsSumCache.get(s1+"+"+s2);
        if (cache==null){
            for(int i=0;i<len;i++){
                if (s1.charAt(i)==s2.charAt(i))
                    res = res + "0";
                else
                    res = res + "1";
            }
            hsSumCache.put(s1+"+"+s2, res);
            hsSumCache.put(s2+"+"+s1, res);
        }else{
            //System.out.println("[Cache]");
            res = cache;
        }
        //System.out.println("res = "+res);
        return res;
    }

    private static String listToStr(ArrayList<Integer> lst){
        String res = "";
        for(int i: lst){
            res += ("".equals(res)?"":", ") + i;
        }
        return "{" + res + "}";
    }

}

