/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package yr2009.qround.b;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Vector;

/**
 *
 * @author CuteCoke
 */
public class Watersheds {
    private static final String FILE_NAME = "B-small-attempt0.in";
    private static boolean bDebug = false;
    private static int iLabelCounter = (int)'a';

    public static void main(String args[]) throws IOException, ParseException {
     Watersheds ws = new Watersheds();

        // Using Hard Code
        /*int W = 3;
        int H = 3;
        int[] map = new int[]{9,6,3,5,9,6,3,5,9};

        for (int y=0; y<H; y++){
            for (int x=0; x<W; x++){
                int xy = getXY(W, H, x+1, y+1);
                System.out.print(map[xy-1] + " ");
            }
            System.out.println();
        }
        String[] sOutput = ws.processWatersheds(map, W, H);
        System.out.println("Case #1: ");// Do Output
        for (int y=0; y<H; y++){
            for (int x=0; x<W; x++){
                int xy = getXY(W, H, x+1, y+1);
                System.out.print(sOutput[xy-1] + " ");
            }
            System.out.println();
        }*/
        

        // Using File
        File f = new File(FILE_NAME);
        if (bDebug ) System.out.println("Reading file : " + f.getAbsolutePath() + " (exists? "+f.exists()+")...");
        BufferedReader br = new BufferedReader(new FileReader(FILE_NAME));
        String sContent = "";
        int counter = 1;
        String sHeader = br.readLine();
        while ((sContent = br.readLine()) != null) {
         if (bDebug ) System.out.println("sContent = " + sContent);
         String[] arrStr = sContent.split(" ");
         int H = Integer.parseInt(arrStr[0]);
         int W = Integer.parseInt(arrStr[1]);

            if (bDebug ) System.out.println("Case #" + counter + ": ----------------------- ");
            int[] map = readBlock(br, H, W);

            if (bDebug ){
                for (int y=0; y<H; y++){
                    for (int x=0; x<W; x++){
                        int xy = getXY(W, H, x+1, y+1);
                        System.out.print(map[xy-1] + " ");
                    }
                    System.out.println();
                }
            }

            String[] sOutput = ws.processWatersheds(map, W, H);
            System.out.println("Case #"+counter+": ");// Do Output
            for (int y=0; y<H; y++){
                for (int x=0; x<W; x++){
                    int xy = getXY(W, H, x+1, y+1);
                    System.out.print(sOutput[xy-1] + " ");
                }
                System.out.println();
            }
            counter++;
        }
    }

    public static int[] readBlock(BufferedReader br, int iH, int iW) throws IOException, ParseException{
        Vector v = new Vector();
        int cnt = 0;
        for (int i = 0; i < iH; i++){
            String sTmpStr = br.readLine();
            String[] arrStr = sTmpStr.split(" ");
            for (int j = 0; j < arrStr.length; j++){
                v.add(new Integer(arrStr[j]));
                cnt++;
            }
        }
        int[] iOut = new int[v.size()];
        for (int i = 0; i < v.size(); i++){
            iOut[i] = ((Integer)v.get(i)).intValue();
        }
        return iOut;
    }


    private String[] processWatersheds(int[] map, int W, int H){
        //SET ALL FOUND NEXT CELL = FALSE
        //SET ALL CELL LABEL = NO LABEL

        //LOOP MAP
        //  IF FOUND NEXT CELL = FALSE THEN
        //      FOR THE CELL, FIND THE NEXT CELL
        //      WHILE CAN GET NEXT CELL
        //          SET FOUND NEXT CELL = TRUE
        //          STORE NEXT CELL IN ARRAY
        //          ASSIGN NEXT CELL TO BE CURRENT CELL
        //      END WHILE
        //      IF NO NEXT CELL THEN
        //          IT IS A SINK
        //          GET NEW LABEL
        //      END IF
        //  END IF
        //END LOOP

        //LOOP MAP
        //  IF WITHOUT LABEL THEN
        //      WHILE GET NEXT CELL
        //          IF NEXT CELL WITH LABEL THEN
        //              THIS LABEL = NEXT CELL LABEL
        //              ASSIGN LABEL TO ALL CELL IN THE STORED Vector ALSO
        //          ELSE
        //              STORE NEXT CELL IN Vector
        //              THIS CELL = NEXT CELL
        //          END IF
        //      END WHILE
        //  END IF
        //END LOOP

        int iMapSize = map.length;
        boolean[] bFoundNextCell = generateBooleanList(iMapSize, false);
        String[] sLabel = generateStringList(iMapSize, "");
        int[] iNextCellArr = new int[iMapSize];
        setLabel('a');
        for (int i = 0; i < iMapSize; i++){
            if (!bFoundNextCell[i]){
                int iNextCell = -1;
                int iCurrCell = i;
                while ((iNextCell = getNextCell(map, W, H, iCurrCell)) > 0 && (!bFoundNextCell[iCurrCell])){
                    bFoundNextCell[iCurrCell] = true;
                    iNextCellArr[iCurrCell] = iNextCell;
                    iCurrCell = iNextCell;
                }
                if (iNextCell < 0 && !bFoundNextCell[iCurrCell]){//IT IS A SINK
                    bFoundNextCell[iCurrCell] = true;
                    iNextCellArr[iCurrCell] = -1;
                    sLabel[iCurrCell] = getLabel()+"";
                }
            }
        }

        Vector vNoLabelCell = new Vector();
        for (int i = 0; i < iMapSize; i++){
            if ("".equals(sLabel[i])){
                int iCurrCell = i;
                String myLabel = "";
                int iFoundCnt = 0;
                while ("".equals(myLabel = sLabel[iCurrCell]) && (iFoundCnt <= iMapSize)){
                    vNoLabelCell.add(iCurrCell);
                    iCurrCell = iNextCellArr[iCurrCell];
                    iFoundCnt++;
                }
                for (int j = 0; j < vNoLabelCell.size(); j++){
                    Integer c = (Integer)vNoLabelCell.get(j);
                    sLabel[c.intValue()] = myLabel;
                }
                vNoLabelCell.clear();
            }
        }

        return sLabel;
    }

    private int getNextCell(int[] map, int W, int H, int iCurrCell){
        //LOOP THROUGH 4 SIDE, FIND THE LOWEST ALT
        //LOOP ORDER: NORTH, WEST, EAST, SOUTH
        //FOR SAME ALT, NO OVERRIDE IS ALLOW. ONLY SMALLER CAN OVERRIDE

        int x = getX(W, H, iCurrCell+1);
        int y = getY(W, H, iCurrCell+1);
        int NORTH   = getXY(W, H, x, y-1);
        int WEST    = getXY(W, H, x-1, y);
        int EAST    = getXY(W, H, x+1, y);
        int SOUTH   = getXY(W, H, x, y+1);
        int iNextCell = -1;

        int iMin = 99999;
        if (NORTH!=-1 && map[NORTH-1] < iMin){
            iMin = map[NORTH-1];
            iNextCell = NORTH-1;
        }
        if (WEST!=-1 && map[WEST-1] < iMin){
            iMin = map[WEST-1];
            iNextCell = WEST-1;
        }
        if (EAST!=-1 && map[EAST-1] < iMin){
            iMin = map[EAST-1];
            iNextCell = EAST-1;
        }
        if (SOUTH!=-1 && map[SOUTH-1] < iMin){
            iMin = map[SOUTH-1];
            iNextCell = SOUTH-1;
        }
        if (map[iCurrCell] <= iMin) return -1;
        return iNextCell;
    }

    private static int getX(int W, int H, int xy){
        if (xy <=0 || xy > W*H) return -1;
        int r = xy % W;
        if (r==0) return W;
        return r;
    }

    private static int getY(int W, int H, int xy){
        if (xy <=0 || xy > W*H) return -1;
        return Math.round((float)(Math.ceil((float)xy / (float)W)));
    }

    private static int getXY(int W, int H, int x, int y){
        int iOut = -1;
        if ( x <= 0 || x > W) return -1;
        if ( y <= 0 || y > H) return -1;
        iOut = ((y-1)*W+x);
        return iOut;
    }

    private char getLabel(){
        return (char)iLabelCounter++;
    }

    private void setLabel(char ch){
        iLabelCounter = (int)ch;
    }

    private boolean[] generateBooleanList(int iSize, boolean bValue){
        boolean[] bArr = new boolean[iSize];
        for (int i = 0; i < iSize; i++)
            bArr[i] = bValue;
        return bArr;
    }
    private String[] generateStringList(int iSize, String sValue){
        String[] sArr = new String[iSize];
        for (int i = 0; i < iSize; i++)
            sArr[i] = sValue;
        return sArr;
    }

}
 