import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;

public class Main {
	public static int W, H, B;
	public static Node[][] nodes;
	public static EndNode end = new EndNode();
	public static int[][][][] usage;

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(
				new FileInputStream("in.txt")));
		FileOutputStream fos = new FileOutputStream("out.txt");
		int T = Integer.parseInt(br.readLine());
		for (int k = 0; k < T; k++) {
			String st = br.readLine();
			String[] sts = st.split("\\s+");
			W = Integer.parseInt(sts[0]);
			H = Integer.parseInt(sts[1]);
			B = Integer.parseInt(sts[2]);
			usage = new int[W][H + 1][3][3];
			nodes = new Node[W][H];
			for (int i = 0; i < W; i++)
				for (int i2 = 0; i2 < H; i2++)
					nodes[i][i2] = new Node(i, i2);
			for (int i = 0; i < B; i++) {
				String st2 = br.readLine();
				String[] sts2 = st2.split("\\s+");
				int x1 = Integer.parseInt(sts2[0]);
				int y1 = Integer.parseInt(sts2[1]);
				int x2 = Integer.parseInt(sts2[2]);
				int y2 = Integer.parseInt(sts2[3]);
				for (int i2 = x1; i2 <= x2; i2++)
					for (int i3 = y1; i3 <= y2; i3++)
						nodes[i2][i3].setOccupied();
			}
			// Ford-Fulkerson maybe
			StartNode start = new StartNode();
			// Find path...
			int maxflow = 0;
			while (true) {
				Node[][] back = new Node[W][H];
				boolean[][] processed = new boolean[W][H];
				Node from = null;
				ArrayList<Node> processing = new ArrayList<Node>();
				processing.add(start);
				for (int i = 0; i < processing.size(); i++) {
					Node on = processing.get(i);
					for (Node to : on.neighbors()) {
						if (to == end) {
							from = on;
							break;
						}
						if (!processed[to.x][to.y]) {
							processed[to.x][to.y] = true;
							processing.add(to);
							back[to.x][to.y] = on;
						}
					}
				}
				// All done!
				if (from == null)
					break;
				System.out.println("Path!");
				ArrayList<Node> seq = new ArrayList<Node>();
				seq.add(end);
				Node on = from;
				while (on != null) {
					seq.add(on);
					if (on == start)
						break;
					else
						on = back[on.x][on.y];
				}
				Node[] realseq = new Node[seq.size()];
				for (int i = seq.size() - 1; i >= 0; i--)
					realseq[seq.size() - i - 1] = seq.get(i);
				System.out.println(Arrays.toString(realseq));
				for (int i = 1; i < realseq.length - 1; i++) {
					on = realseq[i];
					Node next = realseq[i + 1];
					if (next == end)
						usage[on.x][on.y][norm(0)][norm(1)] = 1;
					else if (on.y < next.y)
						usage[on.x][on.y][norm(0)][norm(1)] = 1;
					else if (on.y == next.y) {
						int dif = next.x - on.x;
						if (usage[on.x][on.y][norm(dif)][norm(0)] == 0) {
							usage[on.x][on.y][norm(dif)][norm(0)] = 1;
						} else {
							usage[next.x][next.y][norm(-dif)][norm(0)] = 1;
						}
					}
					else if (on.y > next.y) {
						usage[on.x][on.y][norm(0)][norm(-1)] = 0;
					}
				}
				int totFlow = 0;
				for (int i = 0; i < W; i++)
					totFlow += usage[i][H - 1][norm(0)][norm(1)];
				System.out.println("Flow = " + totFlow);
				if (totFlow > maxflow)
					maxflow = totFlow;
			}
			System.out.println("Next...");
			fos.write(("Case #" + (k + 1) + ": " + maxflow + "\n").getBytes());
		}
		fos.close();
	}
	public static int norm(int i) {
		return i+1;
	}

	static boolean valid(int x, int y) {
		return x >= 0 && y >= 0 && x < W && y < H;
	}

	private static class Node {
		private boolean occupied;
		public int x, y;

		public Node(int x, int y) {
			occupied = false;
			this.x = x;
			this.y = y;
		}

		public void setOccupied() {
			occupied = true;
		}

		public ArrayList<Node> neighbors() {
			ArrayList<Node> good = new ArrayList<Node>();
			int i = 0;
			int i2 = 1;
			if (valid(x + i, y + i2))
				if (!nodes[x + i][y + i2].occupied
						&& usage[x][y][norm(i)][norm(i2)] != 1)
					good.add(nodes[x + i][y + i2]);
			// -1,0
			i = -1;
			i2 = 0;
			if (valid(x + i, y + i2))
				if (!nodes[x - 1][y].occupied && usage[x][y][norm(i)][norm(i2)] == 0)
					good.add(nodes[x - 1][y]);
				else if (!nodes[x - 1][y].occupied
						&& usage[x - 1][y][norm(-i)][norm(i2)] == 1)
					good.add(nodes[x - 1][y]);
			// 1,0
			i = 1;
			i2 = 0;
			if (valid(x + i, y + i2))
				if (!nodes[x + 1][y].occupied && usage[x][y][norm(i)][norm(i2)] == 0)
					good.add(nodes[x + 1][y]);
				else if (!nodes[x + 1][y].occupied
						&& usage[x + 1][y][norm(-i)][norm(i2)] == 1)
					good.add(nodes[x + 1][y]);
			i = 0;
			i2 = -1;
			if (valid(x + i, y + i2))
				if (!nodes[x + i][y + i2].occupied
						&& usage[x][y][norm(i)][norm(i2)] != 0)
					good.add(nodes[x + i][y + i2]);
			if (y == H - 1)
				good.add(end);
			//System.out.println("From " + this + " to " + good);
			return good;
		}

		public String toString() {
			return "(" + x + ", " + y + ")";
		}
	}

	private static class StartNode extends Node {
		public StartNode() {
			super(0, 0);
		}

		public ArrayList<Node> neighbors() {
			ArrayList<Node> good = new ArrayList<>();
			for (int i = 0; i < W; i++)
				if (!nodes[i][0].occupied)
					good.add(nodes[i][0]);
			return good;
		}
	}

	private static class EndNode extends Node {
		public EndNode() {
			super(-1, -1);
		}

		public ArrayList<Node> neighbors() {
			return new ArrayList<Node>();
		}
	}
}
