
import java.math.BigInteger;
import java.util.ArrayList;
import java.io.*;
import java.util.Collections;

public class FairSquareLong {
    public static void main(String[] args) {
        try {
            //Generate List
            BufferedReader br=new BufferedReader(new InputStreamReader(new FileInputStream("fair.in")));
            BufferedWriter bw=new BufferedWriter(new OutputStreamWriter(new FileOutputStream("fair.out")));
            int N=Integer.parseInt(br.readLine());
            ArrayList<BigInteger> fairAndSquares=new ArrayList<BigInteger>();
            int[] base=new int[25];
            BigInteger c=null;
            fairAndSquares.add(new BigInteger("1"));
            fairAndSquares.add(new BigInteger("4"));
            fairAndSquares.add(new BigInteger("9"));
            while(inc(base)) {
                StringBuilder st=new StringBuilder("");
                boolean allOne=true;
                boolean started=false;
                for(int i=0;i<base.length;i++) {
                    if(base[i]!=0)
                        started=true;
                    if(base[i]!=1 && started)
                        allOne=false;
                    st.append(base[i]);
                }
                for(int i=base.length-1;i>=0;i--)
                    st.append(base[i]);
                String fst=removeLTZ(st.toString());
                BigInteger dat=new BigInteger(fst);
                if(isPal((c=dat.multiply(dat)).toString())) {
                    fairAndSquares.add(c);
                }
                if(allOne) {
                    StringBuilder stb=new StringBuilder("2");
                    for(int i=0;i<dat.toString().length()-2;i++) {
                        stb.append("0");
                    }
                    stb.append("2");
                    String fstb=stb.toString();
                    dat=new BigInteger(fstb);
                    if(isPal((c=dat.multiply(dat)).toString())) {
                        fairAndSquares.add(c);
                    }
                }
            }
            for(int i=0;i<N;i++) {
                String line=br.readLine().trim();
                String[] vals=line.split("\\s+");
                BigInteger min=new BigInteger(vals[0]);
                BigInteger max=new BigInteger(vals[1]);
                int st=Collections.binarySearch(fairAndSquares, min);
                int en=Collections.binarySearch(fairAndSquares, max);
                if(st>=0 && en>=0)
                    bw.write("Case #"+(i+1)+": "+((en-st)+1)+"\n");
                else if(st>=0)
                    bw.write("Case #"+(i+1)+": "+((-en-st-1))+"\n");
                else if(en>=0)
                    bw.write("Case #"+(i+1)+": "+((en-(-st))+2)+"\n");
                else
                    bw.write("Case #"+(i+1)+": "+((-en-(-st)))+"\n");
            }
            bw.close();
        }
        catch(Exception e) {
            
        }
    }
    public static boolean isPal(String st) {
        for(int i=0;i<st.length()/2;i++) {
            if(st.charAt(i)!=st.charAt(st.length()-i-1))
                return false;
        }
        return true;
    }
    public static boolean inc(int[] data) {
        data[data.length-1]++;
        for(int i=data.length-1;i>0;i--) {
            if(data[i]==2) {
                data[i]=0;
                data[i-1]++;
            }
        }
        return data[0]!=2;
    }
    public static String removeLTZ(String st) {
        while(st.startsWith("0"))
            st=st.substring(1);
        while(st.endsWith("0"))
            st=st.substring(0, st.length()-1);
        return st;
    }
}
