import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.InputMismatchException;

public class CodeJam1AB {
    private static InputReader in;
    private static OutputWriter out;


    private static void solve() throws Exception {
        int t = in.readInt();
        for (int i = 1; i <= t; ++i) {
            out.print("Case #" + i + ": ");
            int n = in.readInt();
            int[][] heights = new int[2 * n - 1][n];
            for (int j = 0; j < heights.length; ++j) {
                for (int k = 0; k < n; ++k) {
                    heights[j][k] = in.readInt();
                }
            }
            int[][] grid = new int[n][n];
            Arrays.sort(heights, new Comparator<int[]>() {
                @Override
                public int compare(int[] o1, int[] o2) {
                    return Integer.compare(o1[0], o2[0]);
                }
            });

            for (int j = 0; j < n; ++j) {
                grid[0][j] = heights[0][j];
                grid[j][0] = heights[1][j];
            }
            int xindex = 1;
            int yindex = 1;
            int xsaved = -1;
            int ysaved = -1;
            for (int j = 2; j + 1 < heights.length; j = j + 2) {
                boolean flag = false;
                for (int k = 0; k < n; ++k) {
                    if (heights[j][k] <= grid[xindex - 1][k]) {
                        flag = true;
                        break;
                    }
                    if (heights[j + 1][k] <= grid[k][yindex - 1]) {
                        flag = true;
                        break;
                    }
                }
                if (!flag) {
                    if (heights[j][0] != grid[0][yindex]) {
                        ysaved = yindex;
                        yindex++;
                    } else if (heights[j + 1][0] != grid[xindex][0]) {
                        xsaved = xindex;
                        xindex++;
                    }
                    for (int k = 0; k < n; ++k) {
                        grid[xindex][k] = heights[j + 1][k];
                        grid[k][yindex] = heights[j][k];
                    }

                } else {
                    if (heights[j + 1][0] != grid[0][yindex]) {
                        ysaved = yindex;
                        yindex++;
                    } else if (heights[j][0] != grid[xindex][0]) {
                        xsaved = xindex;
                        xindex++;
                    }

                    for (int k = 0; k < n; ++k) {
                        grid[xindex][k] = heights[j][k];
                        grid[k][yindex] = heights[j + 1][k];
                    }

                }
            }
            boolean flag = true;
            if (grid[n - 1][0] == heights[2 * n - 2][0]) {
                for (int k = 0; k < n; ++k) {
                    if (heights[2 * n - 2][k] <= grid[n - 2][k]) {
                        flag = false;
                        break;
                    }
                }
                if (flag) {
                    if ((xsaved == -1) && (ysaved == -1)) {
                        ysaved = n - 1;
                    }
                    for (int k = 0; k < n; ++k) {
                        grid[n - 1][k] = heights[2 * n - 2][k];
                    }
                } else {
                    if ((xsaved == -1) && (ysaved == -1)) {

                        xsaved = n - 1;
                    }
                    for (int k = 0; k < n; ++k) {
                        grid[k][n - 1] = heights[2 * n - 2][k];
                    }
                }
            } else {
                if ((xsaved == -1) && (ysaved == -1)) {
                    xsaved = n - 1;
                }
                for (int k = 0; k < n; ++k) {
                    grid[k][n - 1] = heights[2 * n - 2][k];
                }
            }

            if (xsaved != -1) {
                for (int k = 0; k < n; ++k) {
                    out.print(grid[xsaved][k] + " ");
                }
                out.println();
            } else {
                for (int k = 0; k < n; ++k) {
                    out.print(grid[k][ysaved] + " ");
                }
                out.println();
            }
        }

    }


    public static void main(String[] args) throws Exception {
        in = new InputReader(new FileInputStream("input_b_small.in"));
        out = new OutputWriter(new FileOutputStream("output_b_small.txt"));
        solve();
        out.close();
    }


    private static class InputReader {
        private InputStream stream;
        private byte[] buffer;
        private int currentIndex;
        private int bytesRead;

        public InputReader(InputStream stream) {
            this.stream = stream;
            buffer = new byte[131072];
        }


        public InputReader(InputStream stream, int bufferSize) {
            this.stream = stream;
            buffer = new byte[bufferSize];
        }


        private int read() throws IOException {
            if (currentIndex >= bytesRead) {
                currentIndex = 0;
                bytesRead = stream.read(buffer);
                if (bytesRead <= 0) {
                    return -1;
                }
            }
            return buffer[currentIndex++];
        }

        public String readString() throws IOException {
            int c = read();
            while (!isPrintable(c)) {
                c = read();
            }
            StringBuilder result = new StringBuilder();
            do {
                result.appendCodePoint(c);
                c = read();
            } while (isPrintable(c));
            return result.toString();
        }

        public int readInt() throws Exception {
            int c = read();
            int sign = 1;
            while (!isPrintable(c)) {
                c = read();
            }
            if (c == '-') {
                sign = -1;
                c = read();
            }
            int result = 0;
            do {
                if ((c < '0') || (c > '9')) {
                    throw new InputMismatchException();
                }
                result *= 10;
                result += (c - '0');
                c = read();
            } while (isPrintable(c));
            return sign * result;
        }

        public long readLong() throws Exception {
            int c = read();
            int sign = 1;
            while (!isPrintable(c)) {
                c = read();
            }
            if (c == '-') {
                sign = -1;
                c = read();
            }
            long result = 0;
            do {
                if ((c < '0') || (c > '9')) {
                    throw new InputMismatchException();
                }
                result *= 10;
                result += (c - '0');
                c = read();
            } while (isPrintable(c));
            return sign * result;
        }

        public double readDouble() throws Exception {
            int c = read();
            int sign = 1;
            while (!isPrintable(c)) {
                c = read();
            }
            if (c == '-') {
                sign = -1;
                c = read();
            }
            boolean fraction = false;
            double multiplier = 1;
            double result = 0;
            do {
                if ((c == 'e') || (c == 'E')) {
                    return sign * result * Math.pow(10, readInt());
                }
                if ((c < '0') || (c > '9')) {
                    if ((c == '.') && (!fraction)) {
                        fraction = true;
                        c = read();
                        continue;
                    }
                    throw new InputMismatchException();
                }
                if (fraction) {
                    multiplier /= 10;
                    result += (c - '0') * multiplier;
                    c = read();
                } else {
                    result *= 10;
                    result += (c - '0');
                    c = read();
                }
            } while (isPrintable(c));
            return sign * result;
        }

        private boolean isPrintable(int c) {
            return ((c > 32) && (c < 127));
        }
    }

    private static class OutputWriter {
        private PrintWriter writer;

        public OutputWriter(OutputStream outputStream) {
            writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
        }

        public OutputWriter(Writer writer) {
            this.writer = new PrintWriter(writer);
        }

        public void print(Object... objects) {
            for (int i = 0; i < objects.length; i++) {
                if (i != 0) {
                    writer.print(' ');
                }
                writer.print(objects[i]);
            }
        }

        public void println(Object... objects) {
            print(objects);
            writer.println();
        }

        public void close() {
            writer.close();
        }

        public void flush() {
            writer.flush();
        }
    }
}