
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.LinkedList;
import java.util.Queue;
import java.util.StringTokenizer;

public class RandomTests {

//    4
//    1 0
//    1 1
//    4 0
//    4 47
//            Case #1: OFF
//    Case #2: ON
//    Case #3: OFF
//    Case #4: ON

    public static void main(String args[]) throws Exception {
        // Google code jam prob 1
        
//        probA();
//        probB();
        probC();
    }

//    3
//    3 26000000 11000000 6000000
//    3 1 10 11
//    2 800000000000000000001 900000000000000000001
//
//    Output
//     
//    Case #1: 4000000
//    Case #2: 0
//    Case #3: 99999999999999999999

    private static void probC() throws Exception {
        String file = "C.in";

        BufferedReader in = new BufferedReader(new InputStreamReader(ClassLoader.getSystemResourceAsStream(file)));
        int nCases = Integer.parseInt(in.readLine());
        for (int c = 0; c < nCases; c++) {
            StringTokenizer st = new StringTokenizer(in.readLine());
            BigInteger[] input = new BigInteger[Integer.valueOf(st.nextToken())];
            BigInteger[] diff = new BigInteger[input.length - 1];
            
            BigInteger min = null, gcd = null;
            for (int i = 0; i < input.length; i++) {
                input[i] = new BigInteger(st.nextToken());
                if (i == 0) {
                    min = input[i];
                } else {
                    diff[i-1] = input[i].subtract(input[i-1]).abs();
                    min = min.min(input[i]);
                    if (i == 1) {
                        gcd = diff[0];
                    } else {
                        gcd = diff[i-1].gcd(diff[i-2]);
                    }
                }
                
            }
            BigInteger result = min.mod(gcd).equals(BigInteger.ZERO)?BigInteger.ZERO:gcd.subtract(min.mod(gcd));
            System.out.printf("Case #%d: %s\n", c+1, result.toString());
        }

    }

    private static void probB() throws NumberFormatException, IOException {
        String file = "B.in";

        BufferedReader in = new BufferedReader(new InputStreamReader(ClassLoader.getSystemResourceAsStream(file)));
        int nCases = Integer.parseInt(in.readLine());
        for (int c = 0; c < nCases; c++) {
            StringTokenizer st = new StringTokenizer(in.readLine());
            long r = Long.parseLong(st.nextToken());
            long k = Long.parseLong(st.nextToken());
            int n = Integer.parseInt(st.nextToken());
            st = new StringTokenizer(in.readLine());
//            Queue<Long> queue = new LinkedList<Long>();
            long[] queue = new long[n];
            int index = 0;
            while(st.hasMoreTokens()) {
//                queue.offer(Long.parseLong(st.nextToken()));
                queue[index++] = Long.parseLong(st.nextToken());
            }
            
            long total = 0;
            int p = 0;
            for (int i = 0; i < r; i++) {
                long x = 0;
                
                
                for (int t = 0; t < queue.length; t++) {
                    if (x + queue[p] > k) {
//                        p--;
//                        if (p < 0) {
//                            p = queue.length-1;
//                        }
                        break;
                    }
                    x += queue[p];
                    p++;
                    if (p >= queue.length) {
                        p = 0;
                    }
                }
                total += x;
            }
            System.out.println("Case #" + (c+1) + ": " + total);
        }
    
}

    private static void probA() throws NumberFormatException, IOException {
        String file = "A-sample.in";

        BufferedReader in = new BufferedReader(new InputStreamReader(ClassLoader.getSystemResourceAsStream(file)));
        int n = Integer.parseInt(in.readLine());
        for (int i = 0; i < n; i++) {
            StringTokenizer st = new StringTokenizer(in.readLine());
            int a = Integer.parseInt(st.nextToken());
            long b = Long.parseLong(st.nextToken());
            long mask = (1 << a) - 1;
            boolean r = ((b & mask) == mask);
            System.out.println("Case #" + (i+1) + ": " + (r?"ON":"OFF"));
        }
}
    
    
//    Input
//    
//    Output
//     
//    3
//    4 6 4
//    1 4 2 1
//    100 10 1
//    1
//    5 5 10
//    2 4 2 3 4 2 1 2 1 3
//            Case #1: 21
//    Case #2: 100
//    Case #3: 20

}
