package gcj2008.round1c.captainnemo;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class ProblemOne {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
	
		if( args.length < 1 ) {
			System.err.println( "Missing command-line argument. " +
								"Please provide location of input file." );
			return;
		}
		
		Scanner fin = null;
		try {
			fin = new Scanner(new FileInputStream(args[0]));
		} catch (FileNotFoundException e) {
			System.err.println( e.getMessage() );
		}
		if( fin == null ) {
			System.err.println( "Error opening input file." );
			return;
		}
			
		/**
		 * The number of cases.
		 */
		int N = fin.nextInt();
			
		/**
		 * The maximum number of letters that can appear on one key
		 */
		int P;
		
		/**
		 * The number of keys available.
		 */
		int K;
		
		/**
		 * The number of letters in the alphabet
		 */
		int L;
		
		/**
		 * The frequencies of each letter (size = L)
		 */
		int[] freq;
		
		/**
		 * The smallest possible scalar products
		 */
		int[] answers = new int[N];
		
		for( int n = 0; n < N; n++ ) {
			
			answers[n] = 0;
			
			P = fin.nextInt();
			K = fin.nextInt();
			L = fin.nextInt();
			
			freq = new int[L];
			
			for( int l = 0; l < L; l++ ) {
				freq[l] = fin.nextInt();
			}//~for...L
			
			Arrays.sort(freq);
			
			for( int l = 0; l < L; l++ ) {
				
				answers[n] += freq[L-l-1] * ((l + K) / K);
				
			}
			
		}//~for...N
		
		FileOutputStream fOutStream = null;
		try {
			fOutStream = new FileOutputStream( args[0].concat(".out") );
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		PrintWriter pw = new PrintWriter( new OutputStreamWriter(fOutStream) );
		
		for( int n = 0; n < N; n++ ) {
			pw.println("Case #" + (n+1) + ": " + answers[n] );
		}
		
		pw.close();
		
	}//~main
	
	private class Pair {
		
		int freq;
		
		
	}
	
}
