package gcj2008.round1A.CaptainNemo;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class ProblemOne {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
	
		if( args.length < 1 ) {
			System.err.println( "Missing command-line argument. " +
								"Please provide location of input file." );
			return;
		}
		
		try {

			Scanner fin = null;
			try {
				fin = new Scanner(new FileInputStream(args[0]));
			} catch (FileNotFoundException e) {
				System.err.println( e.getMessage() );
			}
			if( fin == null ) {
				System.err.println( "Error opening input file." );
				return;
			}
			
			/**
			 * The number of cases.
			 */
			int T = fin.nextInt();
			
			/**
			 * The size of the vector, per case
			 */
			int N;
			
			/**
			 * The vectors
			 */
			int[] x,y;
			
			/**
			 * The smallest possible scalar products
			 */
			int[] products = new int[T];
			
			for( int t = 0; t < T; t++ ) {
		    	
		    	products[t] = 0;
		    	
		    	N = fin.nextInt();
		    	
		    	x = new int[N];
		    	y = new int[N];
		    	
		    	for( int n = 0; n < N; n++ ) {
		    		x[n] = fin.nextInt();
		    	}//~for...N
		    	for( int n = 0; n < N; n++ ) {
		    		y[n] = fin.nextInt();
		    	}//~for...N
		    	
		    	Arrays.sort(x);
		    	Arrays.sort(y);
		    	
		    	for( int n = 0; n < N; n++ ) {
		    		products[t] += x[n] * y[N-n-1]; 
		    	}
		    	
		    }//~for...T
			
			FileOutputStream fOutStream = new FileOutputStream( args[0].concat(".out") );
		    PrintWriter pw = new PrintWriter( new OutputStreamWriter(fOutStream) );
		    
		    for( int t = 0; t < T; t++ ) {
		    	pw.println("Case #" + (t+1) + ": " + products[t] );
		    }
		    
		    pw.close();
		    
		} catch( Exception e ) {
			System.err.println( e.getMessage() );
		}//~try/catch
	
	}//~main
	
}
