import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.BufferedWriter;
import java.util.InputMismatchException;
import java.io.PrintStream;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.FileInputStream;
import java.io.Writer;
import java.math.BigInteger;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream;
		try {
			inputStream = new FileInputStream("gettingthedigits.in");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("gettingthedigits.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		InputReader in = new InputReader(inputStream);
		OutputWriter out = new OutputWriter(outputStream);
		GettingTheDigits solver = new GettingTheDigits();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class GettingTheDigits {

    String[] vals = new String[] {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
    char[] decideChar = new char[] {'Z', 'X', 'G', 'W', 'U', 'O', 'R', 'F', 'S', 'I'};
    int[] deciderVal = new int[] {0, 6, 8, 2, 4, 1, 3, 5, 7, 9};

    public void solve(int testNumber, InputReader in, OutputWriter out) {
        char[] chars = in.readString().toCharArray();
        int[] inputCnt = new int[26];
        for (int i = 0; i < chars.length; i++) {
            inputCnt[chars[i] - 'A']++;
        }

        int[] outputCnt = new int[10];
        for (int i = 0; i < decideChar.length; i++) {
            int cnt = inputCnt[decideChar[i] - 'A'];
            if (cnt == 0)
                continue;

            outputCnt[deciderVal[i]] = cnt;
            for (int j = 0; j < cnt; j++) {
                String s = vals[deciderVal[i]];
                for (int k = 0; k < s.length(); k++) {
                    inputCnt[s.charAt(k) - 'A']--;
                }
            }
        }

        String res = "";
        for (int i = 0; i < outputCnt.length; i++) {
            for (int j = 0; j < outputCnt[i]; j++) {
                res += String.valueOf(i);
            }
        }

        for (int i = 0; i < inputCnt.length; i++) {
            if (inputCnt[i] > 0 || inputCnt[i] < 0) {
                System.out.println("Wrong for " + new String(chars));
                break;
            }
        }

        out.printLine("Case #" + testNumber + ": " + res);
        //out.printLine(new String(chars));
    }
}

class InputReader {
    private InputStream stream;
    private byte[] buf = new byte[1024];
    private int curChar;
    private int numChars;
    private SpaceCharFilter filter;

    public InputReader(InputStream stream) {
        this.stream = stream;
    }

    public int read() {
        if (numChars == -1)
            throw new InputMismatchException();
        if (curChar >= numChars) {
            curChar = 0;
            try {
                numChars = stream.read(buf);
            } catch (IOException e) {
                throw new InputMismatchException();
            }
            if (numChars <= 0)
                return -1;
        }
        return buf[curChar++];
    }

    public String readString() {
        int c = read();
        while (isSpaceChar(c))
            c = read();
        StringBuilder res = new StringBuilder();
        do {
            res.appendCodePoint(c);
            c = read();
        } while (!isSpaceChar(c));
        return res.toString();
    }

    public boolean isSpaceChar(int c) {
        if (filter != null)
            return filter.isSpaceChar(c);
        return isWhitespace(c);
    }

    public static boolean isWhitespace(int c) {
        return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
    }

    public String next() {
        return readString();
    }

    public interface SpaceCharFilter {
        public boolean isSpaceChar(int ch);
    }
}

class OutputWriter {
    private final PrintWriter writer;

    public OutputWriter(OutputStream outputStream) {
        writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
    }

    public void print(Object...objects) {
        for (int i = 0; i < objects.length; i++) {
            if (i != 0)
                writer.print(' ');
            writer.print(objects[i]);
        }
    }

    public void printLine(Object...objects) {
        print(objects);
        writer.println();
    }

    public void close() {
        writer.close();
    }

}

