package com.coldroid.competitiveprogramming.gcj2015;

import com.coldroid.competitiveprogramming.Solution;

import java.util.Scanner;

/**
 * Solution is a helper class which takes care of setting up the {@link Scanner} to do input/output. Outputting to
 * standard out will output to the file. In the interest of making this code stand alone I am putting my main() method
 * in this class.
 */
public class StandingOvation extends Solution {

    public static void main(String[] arguments) {
        new StandingOvation().solve("A-small-attempt1.in", "standing_ovation.out");
    }

    @Override
    public void solve(Scanner scanner) {
        int testCases = scanner.nextInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {
            print("Case #%d: %d", testCase, minimumFriendInvitesRequired(scanner));
        }
    }

    public int minimumFriendInvitesRequired(Scanner scanner) {
        int friendInvites = 0;
        int standingSoFar = 0;
        int maxShyness = scanner.nextInt();
        String shyness = scanner.next();
        for (int i = 0; i <= maxShyness; i++) {
            int nShyPeople = Character.getNumericValue(shyness.charAt(i));
            if (nShyPeople > 0 && standingSoFar < i) {
                int friendsNeeded = i - standingSoFar;
                standingSoFar += friendsNeeded;
                friendInvites += friendsNeeded;
            }
            standingSoFar += nShyPeople;
        }
        return friendInvites;
    }
}
