package com.coldroid.competitiveprogramming.gcj2015;

import com.coldroid.competitiveprogramming.Solution;

import java.util.Collections;
import java.util.PriorityQueue;
import java.util.Scanner;

/**
 * Solution is a helper class which takes care of setting up the {@link Scanner} to do input/output. Outputting to
 * standard out will output to the file. In the interest of making this code stand alone I am putting my main() method
 * in this class.
 */
public class InfinitePancakes extends Solution {

    private PriorityQueue<Integer> mPancakeStacks = new PriorityQueue<>(Collections.reverseOrder());

    public static void main(String[] arguments) {
        new InfinitePancakes().solve("B-small-attempt2.in", "pancakes.out");
    }

    @Override
    public void solve(Scanner scanner) {
        int testCases = scanner.nextInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {
            mPancakeStacks.clear();
            print("Case #%d: %d", testCase, minutesToEatPancakes(scanner));
        }
    }

    private int minutesToEatPancakes(Scanner scanner) {
        int nonEmptyPlates = scanner.nextInt();
        while (nonEmptyPlates-- > 0) {
            mPancakeStacks.add(scanner.nextInt());
        }

        int fastestSplitTime = Integer.MAX_VALUE;
        int fastestTime = mPancakeStacks.peek();
        int splitsSoFar = 0;
        while (true) {
            int topStack = mPancakeStacks.peek();
            if (topStack == 1) {
                return fastestTime;
            }
            while (mPancakeStacks.peek() == topStack) {
                splitsSoFar++;
                int pancakes = mPancakeStacks.poll();
                mPancakeStacks.offer(pancakes / 2);
                mPancakeStacks.offer((pancakes + 1) / 2);
            }

            int newAttemptTime = splitsSoFar + mPancakeStacks.peek();
            if (newAttemptTime < fastestTime) {
                fastestTime = newAttemptTime;
            }
            if (newAttemptTime > fastestSplitTime) {
                return fastestTime;
            }
            fastestSplitTime = newAttemptTime;
        }
    }
}
