import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;


public class Main {

	public static String INPUT = "C:/Users/Colton5007/Desktop/GCJ/Input/";
	public static String OUTPUT = "C:/Users/Colton5007/Desktop/GCJ/Output/";
	
	public Scanner sc;
	public PrintWriter pw;
	
	public static void main(String[] args) {
		try {
			new Main(System.currentTimeMillis());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public Main(long start) throws IOException {
		File input = new File(INPUT + "input.in");
		if(input.exists()) {
			System.out.println("Input File Found");
			sc = new Scanner(input);
		} else {
			System.out.println("Input File Does Not Exist");
			return;
		}
		File output = new File(OUTPUT + "output.out");
		if(!output.exists()){
			System.out.println("Output File Created");
			output.createNewFile();
		} else {
			System.out.println("Output File Found");
		}
		pw = new PrintWriter(output);
		solve(scan(), start);
	}
	
	public ArrayList<String> scan() {
		ArrayList<String> lines = new ArrayList<String>();
		int lineCount = 0;
		System.out.println();
		while(sc.hasNextLine()) {
			lines.add(sc.nextLine());
			lineCount++;
		}
		System.out.println("Scanned " + lineCount + " lines");
		sc.close();
		return lines;
	}
	
	private void copy(File dest) throws IOException {
		Scanner sc = new Scanner(new File("C:/Users/Colton5007/Documents/Old Desktop/GCJ Workspace/GCJ2016/src/Main.java"));
		PrintWriter pw = new PrintWriter(dest);
		while (sc.hasNextLine()) {
			pw.println(sc.nextLine());
		}
		sc.close();
		pw.flush();
		pw.close();
	}
	
	public void solve(ArrayList<String> lines, long start) {
		int cases = Integer.parseInt(lines.get(0));
		String answer = "";
		for(int i = 1; i < cases+1; i++) {
			int flipCount = 0;
			ArrayList<Boolean> pancakes = new ArrayList<Boolean>();
			for(int j = 0; j < lines.get(i).length(); j++) {
				pancakes.add(lines.get(i).charAt(j) == '+' ? true : false);
			}
			if(pancakes.size() > 1) {
				for(int j = 1; j < pancakes.size(); j++) {
					boolean curPancake = pancakes.get(j-1);
					if(pancakes.get(j) != curPancake) {
						for(int k = 0; k < j; k++) {
							pancakes.set(k, !curPancake);
						}
						flipCount++;
					}
				}
			} 
			if(pancakes.get(0) == false) {
				flipCount++;
			}
			answer= flipCount + "";
			pw.println("Case #" + i + ": " + answer);
			System.out.println("Case #" + i + ": " + answer);
		}
		System.out.println("Done in " + (System.currentTimeMillis() - start) + " ms");
		pw.flush();
		pw.close();
		
		try {
			copy(new File(OUTPUT + "Main.java"));
		} catch (IOException e) {}
	}
	
}
