import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Scanner;

public class Main {

	public static String INPUT = "C:/Users/Colton5007/Desktop/GCJ/Input/";
	public static String OUTPUT = "C:/Users/Colton5007/Desktop/GCJ/Output/";

	public Scanner sc;
	public PrintWriter pw;

	public static void main(String[] args) {
		try {
			new Main(System.currentTimeMillis());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public Main(long start) throws IOException {
		File input = new File(INPUT + "input.in");
		if (input.exists()) {
			System.out.println("Input File Found");
			sc = new Scanner(input);
		} else {
			System.out.println("Input File Does Not Exist");
			return;
		}
		File output = new File(OUTPUT + "output.out");
		if (!output.exists()) {
			System.out.println("Output File Created");
			output.createNewFile();
		} else {
			System.out.println("Output File Found");
		}
		pw = new PrintWriter(output);
		solve(scan(), start);
	}

	public ArrayList<String> scan() {
		ArrayList<String> lines = new ArrayList<String>();
		int lineCount = 0;
		System.out.println();
		while (sc.hasNextLine()) {
			lines.add(sc.nextLine());
			lineCount++;
		}
		System.out.println("Scanned " + lineCount + " lines");
		sc.close();
		return lines;
	}

	private void copy(File dest) throws IOException {
		Scanner sc = new Scanner(
				new File("C:/Users/Colton5007/Documents/Old Desktop/GCJ Workspace/GCJ2016/src/Main.java"));
		PrintWriter pw = new PrintWriter(dest);
		while (sc.hasNextLine()) {
			pw.println(sc.nextLine());
		}
		sc.close();
		pw.flush();
		pw.close();
	}

	long isPrime(BigInteger n) {
		// check if n is a multiple of 2
		if (n.mod(BigInteger.valueOf(2)) == BigInteger.ZERO && !n.equals(BigInteger.valueOf(2)))
			return 2;
		// if not, then just check the odds
		for (int i = 3; i * i <= 500; i += 2) {
			if (n.mod(BigInteger.valueOf(i)) == BigInteger.ZERO)
				return i;
		}
		return 1;
	}

	public String makeZeroes(int length) {
		String temp = "";
		for (int i = 0; i < length; i++) {
			temp += "0";
		}
		return temp;
	}

	public void solve(ArrayList<String> lines, long start) {
		int cases = Integer.parseInt(lines.get(0));
		for (int i = 1; i < cases + 1; i++) {
			boolean completed = false;
			ArrayList<String> jamcoins = new ArrayList<String>();
			int length = Integer.parseInt(lines.get(1).split(" ")[0]);
			int jamcoinCount = Integer.parseInt(lines.get(1).split(" ")[1]);
			String coin = "1" + makeZeroes(length-2) + "1";
			//System.out.println(coin);
			while (!completed) {
				String temp = coin;
				for (int base : new int[] { 2, 3, 4, 5, 6, 7, 8, 9, 10 }) {
					BigInteger j = new BigInteger(coin, base);
					System.out.println(j);
					long divisor = isPrime(j);
					if(divisor != 1) {
						temp += " " + divisor;
					} else {
						temp = "";
						break;
					}
				}
				if(!temp.equalsIgnoreCase("")) {
					jamcoins.add(temp);
					System.out.println(temp);
				}
				completed = jamcoins.size() == jamcoinCount;
				if(!completed) {
					BigInteger temp1 = new BigInteger(coin, 2);
					int temp2 = Integer.parseInt("10", 2);
					temp1 = temp1.add(BigInteger.valueOf(temp2));
					coin = temp1.toString(2);
					//System.out.println(coin);
				}
			}
			pw.println("Case #" + i + ": ");
			System.out.println("Case #" + i + ": ");
			for(String a : jamcoins) {
				System.out.println(a);
				pw.println(a);
			}
		}
		System.out.println("Done in " + (System.currentTimeMillis() - start) + " ms");
		pw.flush();
		pw.close();

		try {
			copy(new File(OUTPUT + "Main.java"));
		} catch (IOException e) {
		}
	}

}
