import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class Main {

	public static String INPUT = "C:/Users/Colton/Desktop/GCJ/Input/";
	public static String OUTPUT = "C:/Users/Colton/Desktop/GCJ/Output/";

	public Scanner sc;
	public PrintWriter pw;

	public static void main(String[] args) {
		try {
			new Main(System.currentTimeMillis());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public Main(long start) throws IOException {
		File input = new File(INPUT + "input.in");
		if (input.exists()) {
			System.out.println("Input File Found");
			sc = new Scanner(input);
		} else {
			System.out.println("Input File Does Not Exist");
			return;
		}
		File output = new File(OUTPUT + "output.out");
		if (!output.exists()) {
			System.out.println("Output File Created");
			output.createNewFile();
		} else {
			System.out.println("Output File Found");
		}
		pw = new PrintWriter(output);
		solve(scan(), start);
	}

	public ArrayList<String> scan() {
		ArrayList<String> lines = new ArrayList<String>();
		int lineCount = 0;
		System.out.println();
		while (sc.hasNextLine()) {
			lines.add(sc.nextLine());
			lineCount++;
		}
		System.out.println("Scanned " + lineCount + " lines");
		sc.close();
		return lines;
	}

	public List<Integer> runMinute(List<Integer> list, int largest, int sameLargest, int nextLargest, int sameNextLargest) {
		if(largest%3==0 || largest%2==0) {
			
			if((largest%3==0 && sameLargest < largest/3-1) && (largest/3 * 2 <= nextLargest|| nextLargest <=largest/3) && sameNextLargest < 2) {
				list.set(list.size() - 1, list.get(list.size() - 1) / 3);
				list.add(list.get(list.size() - 1) * 2);
			} else if(largest%2==0 && largest - sameLargest >= nextLargest && sameLargest < largest / 2) {
				list.set(list.size() - 1, list.get(list.size() - 1) / 2);
				list.add(list.get(list.size() - 1));
			} else {
				for (int j = list.size() - 1; j > -1; j--) {
					if (list.get(j) == 1) {
						list.remove(j);
					} else {
						list.set(j, list.get(j) - 1);
					}
				}
			}
		} else {
			for (int j = list.size() - 1; j > -1; j--) {
				if (list.get(j) == 1) {
					list.remove(j);
				} else {
					list.set(j, list.get(j) - 1);
				}
			}
		}
		return list;
	}
	
	public void solve(ArrayList<String> lines, long start) {
		int cases = Integer.parseInt(lines.get(0));
		for (int i = 1; i < cases + 1; i++) {
			String plates[] = lines.get(i * 2).split(" ");

			List<Integer> list = new ArrayList<Integer>();

			for (String s : plates) {
				list.add(Integer.parseInt(s));
			}
			Collections.sort(list);
			int minute = 0;
			System.out.println(list);
			while (list.size() != 0) {
				int nextLargest = 0;
				int sameNextLargest = 0;
				int largest = list.get(list.size() - 1);
				int sameLargest = 0;
				boolean trueFound = false;
				for (int j = list.size() - 1; j > -1; j--) {
					if (largest == list.get(j)) {
						sameLargest++;
					} else {
						if (!trueFound){
							nextLargest = list.get(j);
						trueFound=true;
						}
					}
				}
				for (int j = list.size() - 1; j > -1; j--) {
					if(nextLargest==list.get(j)) sameNextLargest++;
				}
				list = runMinute(list, largest, sameLargest, nextLargest, sameNextLargest);
				minute++;
				Collections.sort(list);
				System.out.println(list);
			}

			System.out.println("Case #" + i + ": " + minute);
			pw.println("Case #" + i + ": " + minute);
		}
		System.out.println("Done in " + (System.currentTimeMillis() - start)
				+ " ms");
		pw.flush();
		pw.close();
	}

}
