import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;


public class Main {

	public static String INPUT = "C:/Users/Colton/Desktop/GCJ/Input/";
	public static String OUTPUT = "C:/Users/Colton/Desktop/GCJ/Output/";
	
	public Scanner sc;
	public PrintWriter pw;
	
	public static void main(String[] args) {
		try {
			new Main(System.currentTimeMillis());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public Main(long start) throws IOException {
		File input = new File(INPUT + "input.in");
		if(input.exists()) {
			System.out.println("Input File Found");
			sc = new Scanner(input);
		} else {
			System.out.println("Input File Does Not Exist");
			return;
		}
		File output = new File(OUTPUT + "output.out");
		if(!output.exists()){
			System.out.println("Output File Created");
			output.createNewFile();
		} else {
			System.out.println("Output File Found");
		}
		pw = new PrintWriter(output);
		solve(scan(), start);
	}
	
	public ArrayList<String> scan() {
		ArrayList<String> lines = new ArrayList<String>();
		int lineCount = 0;
		System.out.println();
		while(sc.hasNextLine()) {
			lines.add(sc.nextLine());
			lineCount++;
		}
		System.out.println("Scanned " + lineCount + " lines");
		sc.close();
		return lines;
	}
	
	public void solve(ArrayList<String> lines, long start) {
		int cases = Integer.parseInt(lines.get(0));
		for(int i = 1; i < cases+1; i++) {
			int shynessMax = Integer.parseInt(lines.get(i).split(" ")[0]);
			int people_needed = 0;
			int currentStanding = 0;
			for(int j = 0; j < shynessMax+1; j++) {
				int amount = Integer.parseInt(lines.get(i).split(" ")[1].charAt(j) + "");
				if(j <= currentStanding){
					currentStanding+=amount;
				}else{
					people_needed+=(j-currentStanding);
					currentStanding = currentStanding + amount + (j-currentStanding);
				}
				
			}
			pw.println("Case #" + i + ": " + people_needed);
			System.out.println("Case #" + i + ": " + people_needed);
		}
		System.out.println("Done in " + (System.currentTimeMillis() - start) + " ms");
		pw.flush();
		pw.close();
	}
	
}
