import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;

public class Main {

	public static String INPUT = "D:/Users/Colton/Desktop/GCJ/Input/";
	public static String OUTPUT = "D:/Users/Colton/Desktop/GCJ/Output/";

	public Scanner sc;
	public PrintWriter pw;

	public static void main(String[] args) {
		try {
			new Main(System.currentTimeMillis());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public Main(long start) throws IOException {
		File input = new File(INPUT + "input.in");
		if (input.exists()) {
			System.out.println("Input File Found");
			sc = new Scanner(input);
		} else {
			System.out.println("Input File Does Not Exist");
			return;
		}
		File output = new File(OUTPUT + "output.out");
		if (!output.exists()) {
			System.out.println("Output File Created");
			output.createNewFile();
		} else {
			System.out.println("Output File Found");
		}
		pw = new PrintWriter(output);
		solve(scan(), start);
	}

	public ArrayList<String> scan() {
		ArrayList<String> lines = new ArrayList<String>();
		int lineCount = 0;
		System.out.println();
		while (sc.hasNextLine()) {
			lines.add(sc.nextLine());
			lineCount++;
		}
		System.out.println("Scanned " + lineCount + " lines");
		sc.close();
		return lines;
	}

	public void solve(ArrayList<String> lines, long start) {
		int cases = Integer.parseInt(lines.get(0));
		for (int i = 1; i < cases + 1; i++) {
			int firstMethod = 0;
			int secondMethod = 0;
			int shroomSize = Integer.parseInt(lines.get(i * 2 -1));
			ArrayList<Integer> shrooms = new ArrayList<Integer>();
			for(String s : lines.get(i * 2).split(" ")) shrooms.add(Integer.parseInt(s));
			int high = 0;
			int highestDifference = 0;
			int cur = shrooms.get(0);
			for(int j = 0; j < shrooms.size(); j++) {
				if(shrooms.get(j) > high){
					high = shrooms.get(j);
				} else {
					firstMethod += high-shrooms.get(j);
					high = shrooms.get(j);
				}
				if(cur > shrooms.get(j) && highestDifference < cur-shrooms.get(j)){
					highestDifference = cur-shrooms.get(j);
				} 
				cur = shrooms.get(j);
			}
			for(int j = 0; j < shrooms.size()-1; j++) {
				if(shrooms.get(j) < highestDifference) {
					secondMethod += shrooms.get(j);
				} else {
					secondMethod += highestDifference;
				}
			}
			
			System.out.println("Case #" + i + ": " + firstMethod + " " + secondMethod);
			pw.println("Case #" + i + ": " + firstMethod + " " + secondMethod);
		}

		System.out.println("Done in " + (System.currentTimeMillis() - start)
				+ " ms");
		pw.flush();
		pw.close();
	}

}
