import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;

public class Main {

	public static String INPUT = "C:/Users/Colton/Desktop/GCJ/Input/";
	public static String OUTPUT = "C:/Users/Colton/Desktop/GCJ/Output/";
	
	public Scanner sc;
	public PrintWriter pw;
	public static void main(String[] args) {
		try {
			new Main(System.currentTimeMillis());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public Main(long start) throws IOException {
		File input = new File(INPUT + "input.in");
		if (input.exists()) {
			System.out.println("Input File Found");
			sc = new Scanner(input);
		} else {
			System.out.println("Input File Does Not Exist");
			return;
		}
		File output = new File(OUTPUT + "output.out");
		if (!output.exists()) {
			System.out.println("Output File Created");
			output.createNewFile();
		} else {
			System.out.println("Output File Found");
		}
		pw = new PrintWriter(output);
		solve(scan(), start);
	}

	public ArrayList<String> scan() {
		ArrayList<String> lines = new ArrayList<String>();
		int lineCount = 0;
		System.out.println();
		while (sc.hasNextLine()) {
			lines.add(sc.nextLine());
			lineCount++;
		}
		System.out.println("Scanned " + lineCount + " lines");
		sc.close();
		return lines;
	}

	public void solve(ArrayList<String> lines, long start) {
		int cases = Integer.parseInt(lines.get(0));
		System.out.println("Cases: " + cases);
		for (int i = 1; i <= cases; i++) {
			String winner = "";
			String[] parsedInput = lines.get(i).split(" ");
			int[][] maxHang = {{1, 1}, {1, 2}, {2, 2}, {2,3}};
			int x = Integer.parseInt(parsedInput[0]);
			int rows = Integer.parseInt(parsedInput[1]);
			int cols = Integer.parseInt(parsedInput[2]);
			int largestAxis = 0;
			int smallestAxis = 0;
			if(rows > cols){
				largestAxis=rows;
				smallestAxis=cols;
			} else{
				largestAxis=cols;
				smallestAxis=rows;
			}
			if(rows * cols%x==0 && largestAxis >= x && (maxHang[x-1][0] <= smallestAxis && maxHang[x-1][1] <= largestAxis)) {
				if(largestAxis==4 && smallestAxis==2 && x==4){
					winner = "RICHARD";
				} else {
					winner = "GABRIEL";
				}
				
			} else {
				winner = "RICHARD";
			}
			System.out.println("Case #" + i + ": " + winner + " " + x + "-ominoe " + rows + "x" + cols + " largest=" + largestAxis +" smallest=" + smallestAxis + " hang=" + maxHang[x-1][0] + ", " + maxHang[x-1][1]);
			pw.println("Case #" + i + ": " + winner);
		}
		System.out.println("Done in " + (System.currentTimeMillis() - start)
				+ " ms");
		pw.flush();
		pw.close();
	}

}
