import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.PriorityQueue;
import java.util.StringTokenizer;

public class C {

	public static void main(String[] args) throws Exception {
//        InputReader br = new InputReader(System.in);
		InputReader br = new InputReader(new FileInputStream("src/C-small-attempt0.in"));
		BufferedWriter bw = new BufferedWriter(new FileWriter("C.out"));
		int t = br.nextInt();
		int[] speed = new int[100];
		int[] range = new int[100];
		int[][] route = new int[100][100];
		double[][] time = new double[100][100];
		for (int x = 0; x != t; ++x) {
			int n = br.nextInt();
			int q = br.nextInt();
			for (int i = 0; i != n; ++i) {
				range[i] = br.nextInt();
				speed[i] = br.nextInt();
			}
			for (int i = 0; i != n; ++i) {
				for (int j = 0; j != n; ++j) {
					route[i][j] = br.nextInt();
					time[i][j] = -1;
				}
				time[i][i] = 0;
			}
			for (int i = 0; i != n; ++i) {
				PriorityQueue<QueueItem> queue = new PriorityQueue<>();
				for (int j = 0; j != n; ++j) {
					if (route[i][j] != -1) {
						int dst = route[i][j];
						if (dst > range[i]) {
							continue;
						}
						double newTime = dst / (double) speed[i];
						time[i][j] = newTime;
						queue.add(new QueueItem(newTime, dst, j));
					}
				}
				while (!queue.isEmpty()) {
					QueueItem item = queue.poll();
					if (item.time > time[i][item.city]) {
						continue;
					}
					time[i][item.city] = item.time;
					for (int j = 0; j != n; ++j) {
						if (route[item.city][j] != -1) {
							if (time[i][j] != -1 && time[i][j] <= item.time) {
								continue;
							}

							int dst = route[item.city][j];
							if (dst + item.distanceTraveled > range[i]) {
								continue;
							}
							double newTime = item.time + (dst / (double) speed[i]);
							if (time[i][j] != -1 && time[i][j] < newTime) {
								continue;
							}
							time[i][j] = newTime;
							queue.add(new QueueItem(newTime, dst + item.distanceTraveled, j));
						}
					}
				}
			}
			bw.write(String.format("Case #%d: ", x + 1));
			for (int z = 0; z != q; ++z) {
				int from = br.nextInt() - 1;
				int to = br.nextInt() - 1;
				Double[] qTime = new Double[n];
				qTime[from] = 0.;

				PriorityQueue<QueueLast> queue = new PriorityQueue<>();
				for (int j = 0; j != n; ++j) {
					if (time[from][j] != -1 && j != from) {
						qTime[j] = time[from][j];
						queue.add(new QueueLast(time[from][j], j));
					}
				}
				while (true) {
					QueueLast item = queue.poll();
					if (qTime[item.city] < item.time) {
						continue;
					}
					if (item.city == to) {
						bw.write(String.format("%.9f ", item.time).replace(",","."));
						break;
					}
					for (int j = 0; j != n; ++j) {
						if (time[item.city][j] != -1) {
							double newTime = time[item.city][j] + item.time;
							if (qTime[j] == null || qTime[j] > newTime) {
								qTime[j] = newTime;
								queue.add(new QueueLast(newTime, j));
							}
						}
					}
				}
			}
			bw.newLine();
		}

		bw.close();
	}

	static class QueueLast implements Comparable<QueueLast> {
		double time;
		int city;

		public QueueLast(double time, int city) {
			this.time = time;
			this.city = city;
		}

		@Override
		public int compareTo(QueueLast o) {
			return Double.compare(time, o.time);
		}
	}

	static class QueueItem implements Comparable<QueueItem> {
		double time;
		int distanceTraveled;
		int city;

		public QueueItem(double time, int distanceTraveled, int city) {
			this.time = time;
			this.distanceTraveled = distanceTraveled;
			this.city = city;
		}

		@Override
		public int compareTo(QueueItem o) {
			return Double.compare(time, o.time);
		}
	}

	static class InputReader {
		public BufferedReader reader;
		public StringTokenizer tokenizer;

		public InputReader(InputStream stream) {
			reader = new BufferedReader(new InputStreamReader(stream), 32768);
			tokenizer = null;
		}

		public String next() {
			while (tokenizer == null || !tokenizer.hasMoreTokens()) {
				try {
					tokenizer = new StringTokenizer(reader.readLine());
				} catch (IOException e) {
					throw new RuntimeException(e);
				}
			}
			return tokenizer.nextToken();
		}

		public void close() throws IOException {
			reader.close();
		}

		public int nextInt() {
			return Integer.parseInt(next());
		}

		public double nextDouble() {
			return Double.parseDouble(next());
		}

	}
}
