import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.PriorityQueue;
import java.util.Queue;
import java.util.StringTokenizer;

public class C {

	public static void main(String[] args) throws Exception {
//        InputReader br = new InputReader(System.in);
		InputReader br = new InputReader(new FileInputStream("src/C_1.in"));
		int T = br.nextInt();
		for (int x = 0; x != T; ++x) {
			solveCase(br);
		}
	}

	private static void solveCase(InputReader br) {
		int r, c;
		r = br.nextInt();
		c = br.nextInt();
		char[][] a = new char[r][c];
		int[][] m = new int[r][c];
		for (int i = 0; i != r; ++i) {
			String s = br.next();
			for (int j = 0; j != c; ++j) {
				a[i][j] = s.charAt(j);
			}
		}
		for (int i = 0; i != r; ++i) {
			for (int j = 0; j != c; ++j) {
				if (check(a[i][j]) != 1) {
					continue;
				}
				m[i][j] = 1;
				boolean bad = false;
				for (int k = j - 1; k >= 0; --k) {
					int tmp = check(a[i][k]);
					if (tmp == 1) {
						bad = true;
						break;
					}
					if (tmp == 2) {
						break;
					}
				}
				if (!bad) {
					for (int k = j + 1; k < c; ++k) {
						int tmp = check(a[i][k]);
						if (tmp == 1) {
							bad = true;
							break;
						}
						if (tmp == 2) {
							break;
						}
					}
					if (!bad) {
						a[i][j] = '-';
						for (int k = j - 1; k >= 0; --k) {
							int tmp = check(a[i][k]);
							if (tmp == 2) {
								break;
							}
							++m[i][k];
						}
						for (int k = j + 1; k < c; ++k) {
							int tmp = check(a[i][k]);
							if (tmp == 2) {
								break;
							}
							++m[i][k];
						}
					}
				}
				if (bad) {
					for (int k = i - 1; k >= 0; --k) {
						int tmp = check(a[k][j]);
						m[k][j]++;
						if (tmp == 1) {
							print("IMPOSSIBLE");
							return;
						}
						if (tmp == 2) {
							break;
						}
					}
					for (int k = i + 1; k < r; ++k) {
						int tmp = check(a[k][j]);
						m[k][j]++;
						if (tmp == 1) {
							print("IMPOSSIBLE");
							return;
						}
						if (tmp == 2) {
							break;
						}
					}
					a[i][j]='|';
				}
			}
		}
		for (int i = 0; i != r; ++i) {
			for (int j = 0; j != c; ++j) {
				if (a[i][j] != '-') {
					continue;
				}
				int min = Integer.MAX_VALUE;
				for (int k = j - 1; k >= 0; --k) {
					int tmp = check(a[i][k]);
					if (tmp == 2) {
						break;
					}
					min = Math.min(min, m[i][k]);
				}
				if (min > 1) {
					for (int k = j + 1; k < c; ++k) {
						int tmp = check(a[i][k]);
						if (tmp == 2) {
							break;
						}
						min = Math.min(min, m[i][k]);
					}
				}
				if (min <= 1) {
					continue;
				}

				boolean bad = false;
				for (int k = i - 1; k >= 0; --k) {
					int tmp = check(a[k][j]);
					if (tmp == 1) {
						bad = true;
						break;
					}
					if (tmp == 2) {
						break;
					}
				}
				if (bad) {
					continue;
				}
				for (int k = i + 1; k < r; ++k) {
					int tmp = check(a[k][j]);
					if (tmp == 1) {
						bad = true;
						break;
					}
					if (tmp == 2) {
						break;
					}
				}
				if (bad) {
					continue;
				}


				// replace
				a[i][j] = '|';
				for (int k = j - 1; k >= 0; --k) {
					int tmp = check(a[i][k]);
					if (tmp == 2) {
						break;
					}
					m[i][k]--;
				}
				for (int k = j + 1; k < c; ++k) {
					int tmp = check(a[i][k]);
					if (tmp == 2) {
						break;
					}
					m[i][k]--;
				}

				for (int k = i - 1; k >= 0; --k) {
					int tmp = check(a[k][j]);
					m[k][j]++;
					if (tmp == 2) {
						break;
					}
				}
				for (int k = i + 1; k < r; ++k) {
					int tmp = check(a[k][j]);
					m[k][j]++;
					if (tmp == 2) {
						break;
					}
				}
			}
		}
		StringBuilder sb = new StringBuilder("POSSIBLE");
		for (int i = 0; i != r; ++i) {
			sb.append("\n");
			for (int j = 0; j != c; ++j) {
				sb.append(a[i][j]);
				if (check(a[i][j]) == 0 && m[i][j] == 0) {
					print("IMPOSSIBLE");
					return;
				}
			}
		}
		print(sb.toString());
	}

	static int check(char c) {
		if (c == '-' || c == '|') {
			return 1;
		}
		if (c == '#') {
			return 2;
		}
		return 0;
	}

	static int CASE_NO = 1;

	static void print(String out) {
		System.out.println(String.format("CASE #%d: %s", CASE_NO++, out));
	}

	static class InputReader {
		public BufferedReader reader;
		public StringTokenizer tokenizer;

		public InputReader(InputStream stream) {
			reader = new BufferedReader(new InputStreamReader(stream), 32768);
			tokenizer = null;
		}

		public String next() {
			while (tokenizer == null || !tokenizer.hasMoreTokens()) {
				try {
					tokenizer = new StringTokenizer(reader.readLine());
				} catch (IOException e) {
					throw new RuntimeException(e);
				}
			}
			return tokenizer.nextToken();
		}

		public void close() throws IOException {
			reader.close();
		}

		public int nextInt() {
			return Integer.parseInt(next());
		}

		public double nextDouble() {
			return Double.parseDouble(next());
		}

	}
}
