import java.io.*;

public class FairAndSquare {
	public static boolean isFair(long number) {
		String nString = new Long(number).toString();
		String rString = new StringBuilder(nString).reverse().toString();
		return (number == Double.parseDouble(rString));
	}
	
	public static boolean isFairAndSquare(double number) {
		if (isFair((long)number)) {
			double root = Math.sqrt(number);
			double root_without_decimals = Math.floor(root);
			if (root == root_without_decimals) {
				return isFair((long)root);
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	public static int numberOfFairAndSquaresInRange(double lowest, double highest) 	{
		int counter = 0;
		for (double number=lowest; number<=highest; number++) {
			if (isFairAndSquare(number)) {
				counter++;
			}
		}
		return counter;
	}
	
	public static void main(String[] args) throws IOException {
		String inputFile = args[0];
		String outputFile = args[1];
		
		StringBuilder output = new StringBuilder();
		
		BufferedReader br = new BufferedReader(new FileReader(inputFile));
		BufferedWriter bw = new BufferedWriter(new FileWriter(outputFile));
		
		int numberOfCases = Integer.parseInt(br.readLine());
		
		for (int caseIndex=1; caseIndex<=numberOfCases; caseIndex++) {
			String caseString = br.readLine();
			String[] highLowStrings = caseString.split(" ");
			double lowest = Double.parseDouble(highLowStrings[0]);
			double highest = Double.parseDouble(highLowStrings[1]);
			int count = numberOfFairAndSquaresInRange(lowest, highest);
			output.append("Case #" + caseIndex+": " + count + "\n");
		}
		
		String outputString = output.toString();
		bw.write(outputString);
		bw.close();
	}
}