import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class TicTacToeTomek {

	static char [] [] board;
	public static void main (String [] args) throws IOException{

		//Timing
		//long s = System.currentTimeMillis ();

		//Set up the reader and printer
		BufferedReader in = new BufferedReader (new FileReader ("IN.txt"));
		PrintWriter out = new PrintWriter (new BufferedWriter (new FileWriter ("OUT.txt")));
		int noCases = Integer.parseInt(in.readLine());
		
		//Solve the cases
		for (int caseNo = 1; caseNo <= noCases; caseNo++){
			board = new char [4] [];
			for (int i = 0; i < 4; i++){
				board [i] = in.readLine().toCharArray();
			}
			String answer = getAnswer();
			out.println(String.format("Case #%d: %s", caseNo, answer));
			//Read in the blank line
			in.readLine();
		}

		//Close the files
		in.close();
		out.close();

		//Timing
		//long e = System.currentTimeMillis();
		//System.out.println((e - s) / 1000.0);

		//Terminate the program
		System.exit(0);

	} //Main method
	
	static String getAnswer(){
		//Check if X won
		if (wonVertical('X') || wonHorizontal('X') || wonDiagonal('X'))
			return "X won";
		
		//Check if O won
		if (wonVertical('O') || wonHorizontal('O') || wonDiagonal('O'))
			return "O won";
		
		//Look for a blank spot to see if it is a draw
		for (int row = 0; row < 4; row++)
			for (int col = 0; col < 4; col++){
				if (board[row][col] == '.')
					return "Game has not completed";
			}
		return "Draw";
	}
	
	static boolean wonVertical(char ch){
		for (int col = 0; col < 4; col++){
			boolean good = true;
			for (int row = 0; row < 4; row++){
				if (board[row][col] == ch || board [row][col] == 'T');
				else
					good = false;
			}
			if (good)
				return true;
		}
		return false;
	}
	
	static boolean wonHorizontal(char ch){
		for (int row = 0; row < 4; row++){
			boolean good = true;
			for (int col = 0; col < 4; col++){
				if (board[row][col] == ch || board [row][col] == 'T');
				else
					good = false;
			}
			if (good)
				return true;
		}
		return false;
	}
	
	static boolean wonDiagonal (char ch){
		boolean good = true;
		for (int row = 0, col = 0; row < 4; row++, col++){
			if (board[row][col] == ch || board[row][col] == 'T');
			else
				good = false;
		}
		if (good)
			return true;
		good = true;
		for (int row = 3, col = 0; row >= 0; row--, col++){
			if (board[row][col] == ch || board[row][col] == 'T');
			else
				good = false;
		}
		if (good)
			return true;
		return false;
	}
}
