import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;

public class FairAndSquare {

	static BigInteger aValue;
	static BigInteger bValue;
	static long noFairAndSquare;

	public static void main (String [] args) throws IOException{

		//Timing
		//long s = System.currentTimeMillis ();

		//Set up the reader and printer
		BufferedReader in = new BufferedReader (new FileReader ("IN.txt"));
		PrintWriter out = new PrintWriter (new BufferedWriter (new FileWriter ("OUT.txt")));
		int noCases = Integer.parseInt(in.readLine());

		//Solve the cases
		for (int caseNo = 1; caseNo <= noCases; caseNo++){
			String [] ints = in.readLine().split(" ");
			String answer = getAnswer(ints[0], ints[1]);
			out.println(String.format("Case #%d: %s", caseNo, answer));
		}
		//Insert code here TODO edit

		//Close the files
		in.close();
		out.close();

		//Timing
		//long e = System.currentTimeMillis();
		//System.out.println((e - s) / 1000.0);

		//Terminate the program
		System.exit(0);

	} //Main method

	static String getAnswer(String a, String b){
		noFairAndSquare = 0;
		aValue = new BigInteger(a);
		bValue = new BigInteger(b);
		for (char digit = '1'; digit <= '9'; digit++){
			buildPalindrome("" + digit);
		}
		return String.valueOf(noFairAndSquare);
	}

	//Finds prime palindromes
	static void buildPalindrome(String num){

		//Check the value
		BigInteger value = new BigInteger(num);
		BigInteger square = value.pow(2);
		if (square.compareTo(bValue) > 0){
			return;
		}
		if (isPalindrome(square.toString()))
			if (square.compareTo(aValue) >= 0)
				noFairAndSquare++;

		//Make an array to insert the palindrome into
		char [] newNum = new char [num.length() + 2];
		int midPoint = num.length() / 2 + 1;
		for (int i = 0; i < midPoint; i++){
			newNum [i] = num.charAt(i);
		}
		for (int i = midPoint + 1; i < newNum.length; i++){
			newNum [i] = num.charAt(i - 2);
		}

		//Duplicate middle digit
		for (char digit = '0'; digit < ':'; digit++){
			newNum [midPoint] = digit;
			buildPalindrome(new String (newNum));
		}

		newNum = new char [num.length() + 1];
		for (int i = 0; i < midPoint; i++){
			newNum [i] = num.charAt(i);
		}
		newNum[midPoint] = newNum[midPoint-1];
		for (int i = midPoint + 1; i < newNum.length; i++){
			newNum [i] = num.charAt(i - 1);
		}
		buildPalindrome(new String (newNum));
	}

	//Sees if it is a palindrome
	static boolean isPalindrome (String str)
	{
		int maxCheckPos = str.length () / 2;
		int lengthLess1 = str.length () - 1;
		for (int check = 0 ; check < maxCheckPos ; check++)
		{
			if (str.charAt (check) != str.charAt (lengthLess1 - check))
			{
				return false;
			}
		}
		return true;
	}
}
