package qualification2015;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Collections;
import java.util.PriorityQueue;

public class Pancakes {

	public static void main (String [] args) throws IOException{

		//Timing
		//long s = System.currentTimeMillis ();

		//Set up the reader and printer
		BufferedReader in = new BufferedReader (new FileReader ("IN.txt"));
		PrintWriter out = new PrintWriter (new BufferedWriter (new FileWriter ("OUT.txt")));
		int noCases = Integer.parseInt(in.readLine());
		
		//Solve the cases
		for (int caseNo = 1; caseNo <= noCases; caseNo++){
			
			int numDiners = Integer.parseInt(in.readLine());//really the number of diners with non-empty plates but w/e
			PriorityQueue<Integer> p = new PriorityQueue<Integer>(10*numDiners, Collections.reverseOrder());
			String [] data = in.readLine().split(" ");
			for (String str : data)
				p.add(Integer.parseInt(str));
			
			int min = p.peek();
			int penalty = 0;
			do
			{
				min = Math.min(min, penalty + p.peek());
				penalty++;
				int c = p.poll();
				p.add(c-c/2);
				p.add(c/2);
			}while (penalty + p.peek() < min);
			
			String answer = String.valueOf(min);
			out.println(String.format("Case #%d: %s", caseNo, answer));
			//out.flush();//So I can see how my program is doing
		}

		//Close the files
		in.close();
		out.close();

		//Timing
		//long e = System.currentTimeMillis();
		//System.out.println((e - s) / 1000.0);

		//Terminate the program
		System.exit(0);

	} //Main method
}
