import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class Lawnmower {

	public static void main (String [] args) throws IOException{

		//Timing
		//long s = System.currentTimeMillis ();

		//Set up the reader and printer
		BufferedReader in = new BufferedReader (new FileReader ("IN.txt"));
		PrintWriter out = new PrintWriter (new BufferedWriter (new FileWriter ("OUT.txt")));
		int noCases = Integer.parseInt(in.readLine());
		
		//Solve the cases
		for (int caseNo = 1; caseNo <= noCases; caseNo++){
			String [] ints = in.readLine().split(" ");
			int noRows = Integer.parseInt(ints[0]);
			int noCols = Integer.parseInt(ints[1]);
			int [] [] lawn = new int [noRows] [noCols];
			for (int i = 0; i < noRows; i++){
				ints = in.readLine().split(" ");
				for (int j = 0; j < noCols; j++){
					lawn[i][j] = Integer.parseInt(ints[j]);
				}
			}
			String answer = getAnswer(lawn);
			out.println(String.format("Case #%d: %s", caseNo, answer));
		}

		//Close the files
		in.close();
		out.close();

		//Timing
		//long e = System.currentTimeMillis();
		//System.out.println((e - s) / 1000.0);

		//Terminate the program
		System.exit(0);

	} //Main method
	
	static String getAnswer(int [] [] lawn){
		
		//Find the maximum grass height in each row and column
		int [] maxRows = new int [lawn.length];
		for (int row = 0; row < lawn.length; row++){
			int maxLength = Integer.MIN_VALUE;
			for (int col = 0; col < lawn[0].length; col++){
				if (maxLength < lawn[row][col])
					maxLength = lawn[row][col];
			}
			maxRows[row] = maxLength;
		}
		int [] maxCols = new int [lawn[0].length];
		for (int col = 0; col < lawn[0].length; col++){
			int maxLength = Integer.MIN_VALUE;
			for (int row = 0; row < lawn.length; row++){
				if (maxLength < lawn[row][col])
					maxLength = lawn[row][col];
			}
			maxCols[col] = maxLength;
		}
		
		//Check to see that each square can be mowed
		for (int row = 0; row < lawn.length; row++){
			for (int col = 0; col < lawn[0].length; col++){
				if (lawn[row][col] < maxRows[row] && lawn[row][col] < maxCols[col])
					return "NO";
			}
		}
		return "YES";
	}
}
