import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;


public class TheRepeater {
	String[] toCompare;
	List<List<Character>> toCompareStacks;
	long blockSizes[][];
	public TheRepeater(String[] toCompare){
		this.toCompare = toCompare;
	}
	public boolean isPosible(){
		toCompareStacks = new LinkedList<>();
		for(String s: toCompare){
			List<Character> stack = new LinkedList<>();
			Character last = 0;
			for(int i = 0;i<s.length();i++){
				Character current = s.charAt(i);
				if(current != last){
					last = current;
					stack.add(current);
				}
			}
			toCompareStacks.add(stack);
		}
		if(toCompareStacks.size() == 0 || toCompareStacks.size() == 1)
			return true;
		List<Character> baseCompare = toCompareStacks.get(0);
		for(int i = 1;i<toCompareStacks.size();i++){
			List<Character> comparing = toCompareStacks.get(i);
			if(comparing.size() != baseCompare.size())
				return false;
			for(int j = 0;j<baseCompare.size();j++)
				if(baseCompare.get(j)!=comparing.get(j))
					return false;
		}
		return true;
	}
	public int getSmallestTries(){
		if(toCompareStacks.size() == 0 || toCompareStacks.size() == 1)
			return 0;
		blockSizes = new long[toCompare.length][toCompareStacks.get(0).size()];
		for(int i = 0;i<toCompare.length;i++){
			String current = toCompare[i];
			char lastChar = 0;
			if(current.length()>0)
				lastChar = current.charAt(0);
			int pos = 0;
			for(int j = 0;j<current.length();j++){
				char currentChar = current.charAt(j);
				if(currentChar != lastChar){
					lastChar = currentChar;
					pos++;
				}
				blockSizes[i][pos]++;
			}
		}
		int totalMoves = 0;
		for(int i = 0;i<blockSizes[0].length;i++){
			int prom = 0;
			for(int j = 0;j<blockSizes.length;j++)
				prom += blockSizes[j][i];
			prom /= blockSizes.length;
			for(int j = 0;j<blockSizes.length;j++){
				totalMoves += Math.abs(prom-blockSizes[j][i]);//deviation
			}
				
		}
		return totalMoves;
	}
	public static void main(String[] args) throws IOException{
		BufferedReader bf = new BufferedReader(new FileReader("input_repeater.txt"));
		int nTest = Integer.parseInt(bf.readLine());
		for(int t = 1;t<=nTest;t++){
			int nStrings = Integer.parseInt(bf.readLine());
			String[] stringsToCompare = new String[nStrings];
			for(int i = 0;i<nStrings;i++)
				stringsToCompare[i] = bf.readLine();

			TheRepeater rep = new TheRepeater(stringsToCompare);
			if(!rep.isPosible()){
				System.out.println("Case #"+t+": Fegla Won");
				continue;
			}
			System.out.println("Case #"+t+": "+rep.getSmallestTries());
			
			
		}
		bf.close();
	}
}
