/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codejam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Le Thanh Cong
 */
public class FlySwatter
{

    private static double COMPARE = 1.0E-7;
    private static final int HS = 4;
    private static Double allArea = 0D;

    private static double calculateMissAreaByY(double newR, double curX, double newg, double curY)
    {
        double missArea = 0.0;
        double temp = Math.sqrt(newR * newR - ((curY + newg) * (curY + newg)));

        if (curX + newg <= temp)
        {
            return HS * newg * newg / allArea;
        }
        else if (Math.sqrt(newR * newR - (curY * curY)) <= newg + curX)
        {
            temp = Math.sqrt(newR * newR - (curX * curX));
            newg = Math.min(newg, newg - curY + temp);
            double sliceWidth = newg / 2;
            double y, y1;

            int iterations = 1;

            for (;;)
            {

                double x = curY;
                double oldArea = missArea;
                missArea = 0;
                while (x < curY + newg)
                {

                    y = Math.sqrt(newR * newR - (x * x));
                    x += sliceWidth;

                    y1 = Math.sqrt(newR * newR - (x * x));
                    missArea += HS * (sliceWidth * (y + y1)) / allArea;
                    x += sliceWidth;
                }

                ++iterations;

                if (Math.abs((oldArea - missArea)) < COMPARE)
                {
                    break;
                }
                sliceWidth /= 2;
            }
            missArea -= HS * newg * curX / allArea;
        }
        else
        {
            double baseArea = newg * (temp - curX);
            newg = curX + newg - temp;
            double sliceWidth = newg / 2;
            double y, y1;

            int iterations = 1;
            for (;;)
            {

                double x = temp;
                double oldArea = missArea;
                missArea = 0;
                while (x < temp + newg)
                {
                    y = Math.sqrt(newR * newR - (x * x));
                    x += sliceWidth;

                    y1 = Math.sqrt(newR * newR - (x * x));
                    missArea += HS * (sliceWidth * (y + y1)) / allArea;
                    x += sliceWidth;
                }

                ++iterations;

                if (Math.abs((oldArea - missArea)) < COMPARE)
                {
                    break;
                }
                sliceWidth /= 2;
            }
            missArea -= HS * newg * curY / allArea;
            missArea += HS * baseArea / allArea;
        }

        return missArea;
    }

    private static double calculateMissAreaByX(double newR, double curX, double newg, double curY)
    {
        double missArea1 = 0.0;
        double temp = Math.sqrt(newR * newR - (curY * curY));
        newg = Math.min(newg, temp - curX);
        double sliceWidth = newg / 2;
        double y, y1;

        int iterations = 1;
        for (;;)
        {

            double x = curX;
            double old1 = missArea1;
            missArea1 = 0;
            while (x < curX + newg)
            {

                y = Math.sqrt(newR * newR - (x * x));
                x += sliceWidth;

                y1 = Math.sqrt(newR * newR - (x * x));
                missArea1 += HS * (sliceWidth * (y + y1)) / allArea;
                x += sliceWidth;
            }

            ++iterations;

            if (Math.abs((missArea1 - old1)) < COMPARE)
            {
                break;
            }
            sliceWidth /= 2;
        }
        missArea1 -= HS * newg * curY / allArea;

        return missArea1;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {
        FileReader inFile = null;
        FileWriter outFile = null;
        PrintWriter out = null;
        BufferedReader input = null;

        try
        {
            inFile = new FileReader("C:\\C-small-attempt2.in");
            outFile = new FileWriter("C:\\C-small-attempt2.out");
            out = new PrintWriter(outFile);
            input = new BufferedReader(inFile);
            Long T = null;
            String line = null;
            String[] arr = null;
            Double P = 0D;
            Double f, R, t, r, g, newR, newr, newg;
            Double cur = 0D;
            Double missArea = 0D;

            // Read number of test case
            Long N = Long.valueOf(input.readLine());
            for (int i = 0; i < N; i++)
            {
                line = input.readLine();
                arr = line.split(" ");
                f = Double.valueOf(arr[0]);
                R = Double.valueOf(arr[1]);
                t = Double.valueOf(arr[2]);
                r = Double.valueOf(arr[3]);
                g = Double.valueOf(arr[4]);

                newR = R - t - f;
                newr = r + f;
                newg = g - 2 * f;
                //loopCount = (int) Math.round(newg / dis);

                if (newg <= 0 || newR <= 0)
                {
                    P = 1D;
                }
                else if (f == 0)
                {
                    P = 0D;
                }
                else
                {
                    cur = newr;
                    missArea = 0D;
                    allArea = R * R * Math.PI;
                    while (cur < newR)
                    {
                        //for (int lIndex = 0; lIndex < loopCount; lIndex++)
                        {
                            //curPos = cur + lIndex * dis;
                            if (cur < newR)
                            {
                                Double M = Math.sqrt(newR * newR - cur * cur);
                                if (M > newr)
                                {
                                    Double K = newr;
                                    while (K < M)
                                    {
                                        K += newg;
                                        if (K > M)
                                        {
                                            missArea += calculateMissAreaByX(newR, cur, newg, K - newg);
                                        }
                                        else
                                        {
                                            missArea += calculateMissAreaByY(newR, cur, newg, K - newg);
                                        }
                                        K += 2 * newr;
                                    }
                                }
                            }
                        }
                        cur += newg + 2 * newr;
                    }
                    P = 1 - missArea;
                    if (P < 0)
                    {
                        P = 0D;
                    }
                }

                out.println(String.format("Case #%d: %10.6f", new Object[]{i + 1, P}));
            }

        }
        catch (Exception ex)
        {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }
        finally
        {
            try
            {
                if (input != null)
                {
                    input.close();
                }
                if (out != null)
                {
                    out.close();
                }
            }
            catch (IOException ex)
            {
                Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

}
