import java.io.File;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.Map.Entry;
import java.util.TreeMap;

public class Stall {
	public void generateStallMinMaxes() {
		try {
			File file = new File("C-small-2-attempt0.in");
			int line = 0;
			Scanner scanner = new Scanner(file);
			while(scanner.hasNextLine()) {
				String text = scanner.nextLine();
				line++;
				
				if(line == 1) continue;
				
				String[] inputs = text.split(" ");
				long[] result = getMinMaxSpaceOfLastPerson(Long.parseLong(inputs[0]), 
						Long.parseLong(inputs[1]));
				System.out.println("Case #" + (line - 1) + ": " + result[0] + " " + result[1]);
			}
		} catch(Exception ex) {
			System.out.println(ex);
		}
	}
	
	public long[] getMinMaxSpaceOfLastPerson(long s, long p) {
		if(s <= p) return new long[] { 0, 0 };
		
		TreeMap<Long, Long> map = new TreeMap<Long, Long>();
		map.put(s, 1L);
		
		long left = 0, right = 0;
		
		while(p > 0) {
			Entry<Long, Long> entry = map.lastEntry();
			
			long size = entry.getKey();
			long count = entry.getValue();
			long mid = size / 2;
			
			left = mid;
			right = mid * 2 == size ? mid - 1 : mid;
			
			count--;
			
			if(count <= 0) 
				map.remove(size);
			else
				map.put(size, count);
			
			if(map.containsKey(left))
				map.put(left, map.get(left) + 1);
			else
				map.put(left, 1L);
			
			if(map.containsKey(right))
				map.put(right, map.get(right) + 1);
			else
				map.put(right, 1L);
			
			p--;
		}
		
		return new long[] { Math.max(left, right), Math.min(left, right) };
	}
}
