import java.io.File;
import java.util.Scanner;

public class Tidy {	
	public void generateLastTidyNumbers() {
		try {
			File file = new File("B-large.in.txt");
			int line = 0;
			Scanner scanner = new Scanner(file);
			while(scanner.hasNextLine()) {
				String text = scanner.nextLine();
				line++;
				
				if(line == 1) continue;
				
				System.out.println("Case #" + (line - 1) + ": " + lastTidyNumber(Long.parseLong(text)));
			}
		} catch(Exception ex) {
			System.out.println(ex);
		}
	}
	
	public long lastTidyNumber(long number) {
		if(number < 10) return number;
		
		long originalNumber = number;
		long factor = getFactor(number);
		long previous = Long.MIN_VALUE;
		long result = 0;
		
		while(factor > 0) {
			long current = number / factor;
			
			if(current < previous) 
				break;
			
			result = result * 10 + current;
			previous = current;
			number %= factor;
			factor /= 10;
		}
		
		if(factor <= 0) return originalNumber;
		
		result--;
		
		while(factor > 0) {
			result = result * 10 + 9;
			factor /= 10;
		}
		
		return lastTidyNumber(result);
	}
	
	private long getFactor(long number) {
		if(0 <= number && number < 10) return 1;
		
		long factor = 1;
		
		while(number > 10) {
			factor *= 10;
			number /= 10;
		}
		
		return factor;
	}
}
