import java.io.File;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.Map.Entry;
import java.util.TreeMap;

public class Stall {
	public void generateStallMinMaxes() {
		try {
			File file = new File("C-small-1-attempt0.in");
			int line = 0;
			Scanner scanner = new Scanner(file);
			while(scanner.hasNextLine()) {
				String text = scanner.nextLine();
				line++;
				
				if(line == 1) continue;
				
				String[] inputs = text.split(" ");
				int[] result = getMinMaxSpaceOfLastPerson(Integer.parseInt(inputs[0]), 
						Integer.parseInt(inputs[1]));
				System.out.println("Case #" + (line - 1) + ": " + result[0] + " " + result[1]);
			}
		} catch(Exception ex) {
			System.out.println(ex);
		}
	}
	
	public int[] getMinMaxSpaceOfLastPerson(int s, int p) {
		if(s <= p) return new int[] { 0, 0 };
		
		char[] stalls = new char[s];
		
		for(int i = 0; i < s; i++) stalls[i] = '.';
		
		TreeMap<Integer, ArrayList<Space>> map = new TreeMap<Integer, ArrayList<Space>>();
		
		ArrayList<Space> list = new ArrayList<Space>();
		Space st = new Space(0, s - 1);
		list.add(st);
		map.put(s, list);
		
		int left = 0, right = 0;
		
		while(p > 0) {
			Space space = takeSpace(map);
			
			int mid = (space.start + space.end) / 2;
			stalls[mid] = 'O';
			
			left = mid - space.start;
			addSpace(map, left, space.start, mid - 1);
			
			right = space.end - mid;
			addSpace(map, right, mid + 1, space.end);
			
			p--;
		}
		
		return new int[] { Math.max(left, right), Math.min(left, right) };
	}
	
	private void addSpace(TreeMap<Integer, ArrayList<Space>> map, int size, int start, int end) {
		Space space = new Space(start, end);
		
		if(map.containsKey(size)) {
			map.get(size).add(space);
		} else {
			ArrayList<Space> spaces = new ArrayList<Space>();
			spaces.add(space);
			map.put(size, spaces);
		}
	}
	
	private Space takeSpace(TreeMap<Integer, ArrayList<Space>> map) {
		Entry<Integer, ArrayList<Space>> entry = map.lastEntry();
		ArrayList<Space> spaces = entry.getValue();
		Space space = spaces.get(0);
		
		spaces.remove(0);
		if(spaces.size() == 0)
			map.remove(entry.getKey());
		else
			map.put(entry.getKey(), spaces);
		
		return space;
	}
	
	class Space {
		public int start;
		public int end;
		
		public Space(int s, int e) {
			start = s;
			end = e;
		}
	}
}
