import java.math.BigDecimal;
public class Bullseye {
	
	
	private BigDecimal radius, paintVolume; 
	private long numRings;
	private BigDecimal totalVolume = BigDecimal.ZERO;
	private BigDecimal paintArea;
	private BigDecimal bigPI = BigDecimal.valueOf(Math.PI);
	
	public Bullseye(long r, long t)
	{	//r = initial radius
		//t = milliliters of black paint
		radius = BigDecimal.valueOf(r);
//		radius = r;
		paintVolume = BigDecimal.valueOf(t);
		numRings = 0;
		paintArea = paintVolume.multiply(bigPI);
//		paintArea = paintVolume * Math.PI;
	}
	
	private void paintRing()
	{
		BigDecimal radiusPlusOne = BigDecimal.ONE.add(radius);
		BigDecimal radiusPlusOneSquared = radiusPlusOne.multiply(radiusPlusOne);
//		BigDecimal rp1s = (radius + 1.0d) * (radius + 1.0d);
//		BigDecimal rp1s = radius * radius + 2 * radius + 1;
//		BigDecimal rs = radius * radius;
		BigDecimal radiusSquared = radius.multiply(radius);
		
//		BigDecimal area = (Math.PI * rp1s) - (Math.PI * rs);	//Area of paint required for one more
		BigDecimal temp1 = radiusPlusOneSquared.multiply(bigPI);
		BigDecimal temp2 = radiusSquared.multiply(bigPI);
		BigDecimal area = temp1.subtract(temp2);
//		BigDecimal area = Math.PI * (rp1s - rs);
	
//		BigDecimal volume = area / Math.PI;
		BigDecimal volume = area.divide(bigPI);
//		System.out.println("Volume = " + volume + "\nPaint = " + paintVolume);
		
		if(area.compareTo(paintArea) <= 0)
		{
			++numRings;
			radius = radius.add(BigDecimal.valueOf(2));
			paintArea = paintArea.subtract(area);
			paintVolume = paintVolume.subtract(volume);
		}
		else
		{
			paintVolume = BigDecimal.valueOf(-1);
		}
		
		/*
		if(area <= paintArea)	//There is enough paint; Paint a ring
		{
			++numRings;
			radius += 2.0d;
			paintArea -= area;
			paintVolume = paintVolume - volume;
		}
		else
		{ 
			System.out.println("Paint Volume  = " + paintVolume);
			System.out.println("Needed Volume = " + volume);
			paintVolume = -1; 
		}	//Not enough paint; Quick fix for infinite loop
		*/
	}
	
	public long getRingCount()
	{
		while(paintVolume.compareTo(BigDecimal.ZERO) >= 0)
		{
			paintRing();
		}
		
		return numRings;
	}
	
	private double areaToML(double area)
	{
		return area / Math.PI;
	}
	
}
