import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class CJ9 {

	static BufferedReader br;

	public static void main(String[] args) throws IOException {

		File f = new File("input.in");
		br = new BufferedReader(new InputStreamReader(new FileInputStream(f)));
		PrintWriter pw = new PrintWriter(new FileWriter(new File("output.txt")));

		int t = readInt();

		for (int i = 1; i <= t; i++) {

			int[] arr = readIntArr();
			String s = solve(arr);
			pw.println("Case #" + i + ": " + s);
			pw.flush();
			System.out.println(i);
		}
		pw.close();
		br.close();

	}

	static String solve(int[] arr) {
		int b = arr[0];
		long m = arr[1];

		int nmd = b - 1;

		long num[] = new long[nmd];
		num[nmd - 1] = 1;
		for (int i = nmd - 1; i-- > 0;) {
			num[i] = 1;
			for (int j = i + 1; j < nmd; j++) {
				num[i] += num[j];
			}
		}

		if (m > num[0])
			return "IMPOSSIBLE";

		String ret = "POSSIBLE";
		boolean[][] bl = new boolean[b][b];
		for (int i = 0; i < b - 1; i++) {
			for (int j = i + 1; j < b; j++) {
				bl[i][j] = true;
			}
		}

		long tnum = num[0];
		int cmx = nmd - 1;
		while (tnum > m&& cmx > 0) {
			long rm = rmc(cmx);
			if (tnum - rm >= m ) {
				//System.out.println(rm);
				tnum -= rm;
				for (int i = 0; i < b; i++) {
					bl[cmx][i] = false;
				}
				cmx--;
			}else break;
		}

		//System.out.println(tnum+" "+m);
		int nr = (int) (tnum - m);
		for (int i = b; i-- > 0; i++) {
			if (nr == 0)
				break;
			bl[0][i] = false;
			nr--;
		}

		for (int i = b - 1; i-- > 1;) {
			if (nr == 0)
				break;
			bl[i][b - 1] = false;
			nr--;
		}
		int cn = 1;
		
		while (nr > 0) {
			for (int j = b - 2; j-- > cn + 1;) {
				if (nr == 0)
					break;
				bl[cn][j] = false;
				nr--;
			}
			cn++;
			if(cn>b-2)break;
		}

		for(int i=0;i<b;i++){
			StringBuilder sb=new StringBuilder("\n");
			for(int j=0;j<b;j++){
				if(bl[i][j])sb.append("1");
				else sb.append("0");
			}
			ret+=sb.toString();
		}
		return ret;

	}

	static long rmc(int vl) {
		// System.out.println(vl);
		long num[] = new long[vl + 1];
		num[vl] = 1;
		for (int i = vl; i-- > 0;) {

			for (int j = i + 1; j <= vl; j++) {
				num[i] += num[j];
			}
		}
		return num[0];
	}

	static public String readString() throws IOException {
		return br.readLine();

	}

	static public long readLong() throws IOException {
		return Long.parseLong(br.readLine());
	}

	static public int readInt() throws IOException {
		return Integer.parseInt(br.readLine());
	}

	static public int[] readIntArr() throws IOException {
		String[] str = br.readLine().split(" ");
		int arr[] = new int[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Integer.parseInt(str[i]);
		return arr;
	}

	static public Integer[] readOIntArr() throws IOException {
		String[] str = br.readLine().split(" ");
		Integer arr[] = new Integer[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = new Integer(str[i]);
		return arr;
	}

	static public double[] readDoubleArr() throws IOException {
		String[] str = br.readLine().split(" ");
		double arr[] = new double[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Double.parseDouble(str[i]);
		return arr;
	}

	static public Double[] readODoubleArr() throws IOException {
		String[] str = br.readLine().split(" ");
		Double arr[] = new Double[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = new Double(str[i]);
		return arr;
	}

	static public long[] readLongArr() throws IOException {
		String[] str = br.readLine().split(" ");
		long arr[] = new long[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Long.parseLong(str[i]);
		return arr;
	}

	static public Long[] readOLongArr() throws IOException {
		String[] str = br.readLine().split(" ");
		Long arr[] = new Long[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = new Long(str[i]);
		return arr;
	}

	static public double readDouble() throws IOException {
		return Double.parseDouble(br.readLine());
	}
}