import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashSet;

public class GCJ4 {

	static BufferedReader br;

	public static void main(String[] args) throws IOException {

		File f = new File("input.in");
		br = new BufferedReader(new InputStreamReader(new FileInputStream(f)));
		PrintWriter pw = new PrintWriter(new FileWriter(new File("output.txt")));

		int t = readInt();

		for (int i = 1; i <= t; i++) {

			String s = solve();
			pw.println("Case #" + i + ": " + s);
			pw.flush();
			System.out.println(i);
		}
		pw.close();
		br.close();

	}

	static class PC implements Comparable<PC> {

		int r;
		int h;
		double ar;
		int ix;

		public PC(int r, int h, int i) {
			ix = i;
			this.r = r;
			this.h = h;
			ar = Math.PI * 2 * r * h;

		}

		@Override
		public int compareTo(PC arg0) {
			return Double.compare(arg0.ar, ar);

		}

	}

	static String solve() throws IOException {

		int[] arr = readIntArr();
		int n = arr[0];
		int k = arr[1];

		PC[] parr = new PC[n];
		for (int i = 0; i < n; i++) {
			int[] ar = readIntArr();
			parr[i] = new PC(ar[0], ar[1], i);
		}

		Arrays.sort(parr);
		PC pmr = parr[0];
		for (int i = 1; i < k; i++) {
			if (parr[i].r > pmr.r) {
				pmr = parr[i];
			}

		}

		PC cs = null;
		double ma = Math.PI * pmr.r * pmr.r;
		for (int i = k; i < n; i++) {
			if (cs == null) {
				if (parr[i].r > pmr.r) {

					double diff = Math.PI * parr[i].r * parr[i].r - ma;
					if (diff + parr[i].ar > parr[k - 1].ar) {
						cs = parr[i];
					}
				}

			} else {
				if (parr[i].r > cs.r) {
					double diff = Math.PI * parr[i].r * parr[i].r - Math.PI * cs.r * cs.r;
					if (diff + parr[i].ar > cs.ar) {
						cs = parr[i];
					}
				}
			}
		}

		double ttl = 0;
		for (int i = 0; i < k - 1; i++) {
			ttl += parr[i].ar;
			// System.out.println(parr[i].r);
		}
		if (cs == null) {
			// System.out.println(parr[k - 1].r);
			ttl += parr[k - 1].ar;
			ttl += Math.PI * pmr.r * pmr.r;
		} else {
			ttl += cs.ar;
			ttl += Math.PI * cs.r * cs.r;
			// System.out.println(ttl);

		}

		return "" + ttl;
	}

	static public String readString() throws IOException {
		return br.readLine();

	}

	static public long readLong() throws IOException {
		return Long.parseLong(br.readLine());
	}

	static public int readInt() throws IOException {
		return Integer.parseInt(br.readLine());
	}

	static public int[] readIntArr() throws IOException {
		String[] str = br.readLine().split(" ");
		int arr[] = new int[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Integer.parseInt(str[i]);
		return arr;
	}

	static public Integer[] readOIntArr() throws IOException {
		String[] str = br.readLine().split(" ");
		Integer arr[] = new Integer[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = new Integer(str[i]);
		return arr;
	}

	static public double[] readDoubleArr() throws IOException {
		String[] str = br.readLine().split(" ");
		double arr[] = new double[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Double.parseDouble(str[i]);
		return arr;
	}

	static public Double[] readODoubleArr() throws IOException {
		String[] str = br.readLine().split(" ");
		Double arr[] = new Double[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = new Double(str[i]);
		return arr;
	}

	static public long[] readLongArr() throws IOException {
		String[] str = br.readLine().split(" ");
		long arr[] = new long[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Long.parseLong(str[i]);
		return arr;
	}

	static public Long[] readOLongArr() throws IOException {
		String[] str = br.readLine().split(" ");
		Long arr[] = new Long[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = new Long(str[i]);
		return arr;
	}

	static public double readDouble() throws IOException {
		return Double.parseDouble(br.readLine());
	}
}