import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;
import java.util.TreeSet;

public class GCJ1 {

	static BufferedReader br;

	public static void main(String[] args) {

		try {
			br = new BufferedReader(new InputStreamReader(new FileInputStream(
					new File("input.txt"))));
			int numCase = readInt();
			PrintWriter out = new PrintWriter(new FileWriter("output.txt"));
			for (int ncs = 0; ncs < numCase; ncs++) {

				StringBuilder sb = new StringBuilder("Case #");
				sb.append(ncs + 1);
				sb.append(": ");
				sb.append(process());

				out.println(sb.toString());
				out.flush();
			}
			br.close();
			out.close();

		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	static String process() throws IOException {
		int n = readInt();
		int[] arr = readIntArr();

		int[] nh = new int[1001];
		TreeSet<Integer> ts = new TreeSet<Integer>();
		for (int i = 0; i < n; i++) {
			ts.add(arr[i]);
			nh[arr[i]]++;
		}

		return "" + calc(ts, nh);
	}

	static int calc(TreeSet<Integer> ts, int[] nh) {
		int mx = ts.last();
		if (mx < 4) {
			return mx;
		}
		
		nh[mx]--;
		if (nh[mx] == 0)
			ts.pollLast();
		

		TreeSet<Integer> ts2 = (TreeSet<Integer>) ts.clone();
		int[]nhc=new int[nh.length];
		System.arraycopy(nh, 0, nhc, 0, nh.length);
		int mv = mx;
		for (int i = 1; i < mx / 2; i++) {
			int diff = mx - i;
			ts.add(i);
			ts.add(diff);
			nh[i]++;
			nh[diff]++;
			
			mv = Math.min(mv, 1 + calc(ts,nh));
			ts=ts2;
			ts2 = (TreeSet<Integer>) ts.clone();
			System.arraycopy(nhc, 0, nh, 0, nh.length);
			

		}
		return mv;

	}

	

	static public String readLine() throws IOException {
		return br.readLine();

	}

	static public String readString() throws IOException {
		return br.readLine();

	}

	static public long readlong() throws IOException {
		return Long.parseLong(br.readLine());
	}

	static public int readInt() throws IOException {
		return Integer.parseInt(br.readLine());
	}

	static public int[] readIntArr() throws IOException {
		String[] str = br.readLine().split(" ");
		int arr[] = new int[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Integer.parseInt(str[i]);
		return arr;
	}

	static public double[] readDoubleArr() throws IOException {
		String[] str = br.readLine().split(" ");
		double arr[] = new double[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Double.parseDouble(str[i]);
		return arr;
	}

	static public long[] readLongArr() throws IOException {
		String[] str = br.readLine().split(" ");
		long arr[] = new long[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Long.parseLong(str[i]);
		return arr;
	}

	static public double readDouble() throws IOException {
		return Double.parseDouble(br.readLine());
	}
}
