import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.TreeSet;

public class GCJ2 {

	static BufferedReader br;

	public static void main(String[] args) throws IOException {

		File f = new File("input.in");
		br = new BufferedReader(new InputStreamReader(new FileInputStream(f)));
		PrintWriter pw = new PrintWriter(new FileWriter(new File("output.txt")));

		int t = readInt();

		for (int i = 1; i <= t; i++) {

			String s = solve();
			pw.println("Case #" + i + ": " + s);
			pw.flush();
			System.out.println(i);
		}
		pw.close();
		br.close();

	}

	static class Space implements Comparable<Space> {
		long l;
		long ind;

		public Space(long ll, long i) {
			l = ll;
			ind = i;
		}

		@Override
		public int compareTo(Space arg0) {
			if (l < arg0.l)
				return -1;
			else if (l == arg0.l)
				return Long.compare(ind, arg0.ind);
			return 1;
		}

		public boolean equas(Object o) {
			Space s = (Space) o;
			return l == s.l && ind == s.ind;
		}

	}

	static String solve() throws IOException {

		long arr[] = readLongArr();
		long pmx = 0;
		long pmn = Long.MAX_VALUE;

		TreeSet<Space> ts = new TreeSet<Space>();
		int ci = 0;
		ts.add(new Space(arr[0], ci));
		ci++;
		long k = arr[1];
		for (long i = 0; i < k; i++) {
			Space s = ts.last();

			ts.remove(s);
			long sp = s.l;
			sp--;
			long mn = sp / 2;
			long mx = (sp + 1) / 2;
			pmx = mx;
			pmn = mn;
			ci++;
			ts.add(new Space(mn, ci));
			ci++;
			ts.add(new Space(mx, ci));

		}
		return pmx + " " + pmn;
	}

	static public String readString() throws IOException {
		return br.readLine();

	}

	static public long readLong() throws IOException {
		return Long.parseLong(br.readLine());
	}

	static public int readInt() throws IOException {
		return Integer.parseInt(br.readLine());
	}

	static public int[] readIntArr() throws IOException {
		String[] str = br.readLine().split(" ");
		int arr[] = new int[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Integer.parseInt(str[i]);
		return arr;
	}

	static public Integer[] readOIntArr() throws IOException {
		String[] str = br.readLine().split(" ");
		Integer arr[] = new Integer[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = new Integer(str[i]);
		return arr;
	}

	static public double[] readDoubleArr() throws IOException {
		String[] str = br.readLine().split(" ");
		double arr[] = new double[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Double.parseDouble(str[i]);
		return arr;
	}

	static public Double[] readODoubleArr() throws IOException {
		String[] str = br.readLine().split(" ");
		Double arr[] = new Double[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = new Double(str[i]);
		return arr;
	}

	static public long[] readLongArr() throws IOException {
		String[] str = br.readLine().split(" ");
		long arr[] = new long[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Long.parseLong(str[i]);
		return arr;
	}

	static public Long[] readOLongArr() throws IOException {
		String[] str = br.readLine().split(" ");
		Long arr[] = new Long[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = new Long(str[i]);
		return arr;
	}

	static public double readDouble() throws IOException {
		return Double.parseDouble(br.readLine());
	}
}