import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.HashMap;

public class GCJ3 {

	static BufferedReader br;

	public static void main(String[] args) throws IOException {

		File f = new File("input.in");
		br = new BufferedReader(new InputStreamReader(new FileInputStream(f)));
		PrintWriter pw = new PrintWriter(new FileWriter(new File("output.txt")));

		int t = readInt();

		for (int i = 1; i <= t; i++) {

			String s = solve();
			pw.println("Case #" + i + ": " + s);
			pw.flush();
			System.out.println(i);
		}
		pw.close();
		br.close();

	}

	static String solve() throws IOException {
		memo = new HashMap<String, long[]>();
		long arr[] = readLongArr();
		long n = arr[0];
		long k = arr[1];

		long l[] = rec(n, k);
		return l[0] + " " + l[1];
	}

	static HashMap<String, long[]> memo;

	static long[] rec(long n, long k) {
		String s = n + " " + k;
		long ret[] = memo.get(s);
		if (ret == null) {
			long sp = n - 1;
			long mx = (sp + 1) / 2;
			long mn = sp / 2;
			if (k == 1) {

				long[] retv = { mx, mn };
				memo.put(s, retv);
				return retv;

			} else {
				long a[] = rec(mx, (k + 1) / 2);
				long b[] = rec(mn, k / 2);
				if (a[1] > b[1]) {
					memo.put(s, a);
					return a;
				} else if (a[1] == b[1]) {
					if (a[0] < b[0]) {
						memo.put(s, b);
						return b;

					} else {
						memo.put(s, a);
						return a;
					}
				} else {
					memo.put(s, b);
					return b;
				}
			}
		}
		return ret;
	}

	static public String readString() throws IOException {
		return br.readLine();

	}

	static public long readLong() throws IOException {
		return Long.parseLong(br.readLine());
	}

	static public int readInt() throws IOException {
		return Integer.parseInt(br.readLine());
	}

	static public int[] readIntArr() throws IOException {
		String[] str = br.readLine().split(" ");
		int arr[] = new int[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Integer.parseInt(str[i]);
		return arr;
	}

	static public Integer[] readOIntArr() throws IOException {
		String[] str = br.readLine().split(" ");
		Integer arr[] = new Integer[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = new Integer(str[i]);
		return arr;
	}

	static public double[] readDoubleArr() throws IOException {
		String[] str = br.readLine().split(" ");
		double arr[] = new double[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Double.parseDouble(str[i]);
		return arr;
	}

	static public Double[] readODoubleArr() throws IOException {
		String[] str = br.readLine().split(" ");
		Double arr[] = new Double[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = new Double(str[i]);
		return arr;
	}

	static public long[] readLongArr() throws IOException {
		String[] str = br.readLine().split(" ");
		long arr[] = new long[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = Long.parseLong(str[i]);
		return arr;
	}

	static public Long[] readOLongArr() throws IOException {
		String[] str = br.readLine().split(" ");
		Long arr[] = new Long[str.length];
		for (int i = 0; i < arr.length; i++)
			arr[i] = new Long(str[i]);
		return arr;
	}

	static public double readDouble() throws IOException {
		return Double.parseDouble(br.readLine());
	}
}