import java.util.*;
import java.io.*;

public class Main {

  public static void main(String[] args) {
    HashSet<Long> set = new HashSet<Long>();
    
    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
    int testCaseNum = in.nextInt();

    for (int i = 1; i <= testCaseNum; i++) {
      int n = in.nextInt();
      int m = in.nextInt();

      ArrayList<String> list;
      if (n == 16)  list = genJamBinarySmall();
      else list = genJamBinaryLarge();

      process(i, n, m, list, set);
    }
  }

  public static void process(int idx, int n, int m, ArrayList<String> bins, HashSet<Long> set) {
    StringBuffer ret = new StringBuffer("Case #");
    ret.append(idx);
    ret.append(":");

    int div[] = new int[9];

    // print output result
    System.out.println(ret);

    for (int i = 0; i < bins.size(); i++) {
      if (check(bins.get(i), set, div)) {
        if (m == 0) break;
        System.out.print(bins.get(i) + " ");
        for (int j = 0; j < 8; j++) {
          System.out.print(div[j] + " ");
        }
        System.out.print(div[8]);
        System.out.println("");
        m--;
      }
    }
    
  }

  public static boolean check(String bin, HashSet<Long> set, int[] div) {
    long num;
    for(int i = 2; i < 11; i++) {
      num = baseConv(bin, i);
      if(isPrime(num, set, i-2, div)) { 
        return false;
      }
    }

    return true;
  }

  public static boolean isPrime(long num, HashSet<Long> set, int pos, int[] div) {
    long testNum = (long)Math.ceil(Math.sqrt(num));

    if(set.contains(num)) {
      return true;
    }

    if (num == 2) {
      return true;
    }
    else if ((num % 2) == 0) {
      div[pos] = 2;
      return false;
    }

    for(long i = 3; i < testNum; i = i + 2) {
      if (num % i == 0) {
        div[pos] = (int)i;
        return false;
      }
    }

    set.add(num);
    return true;

  }

  public static ArrayList<String> genJamBinaryTiny() {
    ArrayList<String> list = new ArrayList<String>();
    long limit = 1;
    int limitLen = 4;
    limit = 1 << limitLen;

    for (long i = 0; i < limit; i++) {
      list.add("1" + String.format("%4s", Long.toBinaryString(i)).replace(' ', '0') + "1");
    }
    
    return list;
  }

  public static ArrayList<String> genJamBinarySmall() {
    ArrayList<String> list = new ArrayList<String>();
    long limit = 1;
    int limitLen = 14;
    limit = 1 << limitLen;

    for (long i = 0; i < limit; i++) {
      list.add("1" + String.format("%14s", Long.toBinaryString(i)).replace(' ', '0') + "1");
    }
    
    return list;
  }

  public static ArrayList<String> genJamBinaryLarge() {
    ArrayList<String> list = new ArrayList<String>();
    long limit = 1;
    int limitLen = 30;
    limit = 1 << limitLen;

    for (long i = 0; i < limit; i++) {
      list.add("1" + String.format("%31s", Long.toBinaryString(i)).replace(' ', '0') + "1");
    }
   
    return list;
  }

  public static long baseConv(String bin, int base) {
    return Long.parseLong(bin, base);
  }
}
