package ru.control9;

import javafx.util.converter.BigIntegerStringConverter;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

public class C {
    private static int t;
    private static PrintWriter out;
    private static Scanner in;

    public static void main(String[] args) throws FileNotFoundException {
        in = new Scanner(new BufferedReader(new FileReader("c.in")));
        out = new PrintWriter("c.out");
        t = in.nextInt();
        for (int i = 1; i <= t; i++ ) {
            solve(i);
        }
        out.flush();
    }

    private static void solve(int caseNumber) {
        int n = in.nextInt();
        int j = in.nextInt();
        int found = 0;
        out.println(String.format("Case #%s: ", caseNumber));
        for (long c = (1L << (n-1)) + 1; c < 1L << (n+2) ; c +=2) {
            String cc = Long.toBinaryString(c);
            boolean coin = true;
            for (int r = 2; r <= 10; r++) {
                BigInteger b = new BigInteger(cc, r);
                if (isPrime(b)) {
                    coin = false;
                    break;
                }
            }
            if (coin) {
//                System.out.println("FOUND");
                out.print(cc);
                for (int r = 2; r <= 10; r++) {
                    BigInteger b = new BigInteger(cc, r);
                    out.print(" ");
                    out.print(findDivisor(b));
                }
                out.println();
                found++;
                if (found == j) break;
            }
        }
    }

    private static BigInteger findDivisor(BigInteger l) {
        for (long div = 2; l.compareTo(BigInteger.valueOf(div).multiply(BigInteger.valueOf(div))) >= 0; div++) {
            if (l.remainder( BigInteger.valueOf(div)).equals(BigInteger.ZERO)) return BigInteger.valueOf(div);
        }
        return BigInteger.valueOf(-1);
    }

    private static boolean isPrime(BigInteger l) {
        for (long div = 2; div < 100000 && (l.compareTo(BigInteger.valueOf(div).multiply(BigInteger.valueOf(div))) >= 0); div++) {
            if (l.remainder( BigInteger.valueOf(div)).equals(BigInteger.ZERO)) return false;
        }
        return true;
    }
}
