package ru.control9.google.jam;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;

public class A {
    private static final Path input = Paths.get("A.in");
    private static final Path output = Paths.get("A.out");

    public static void main(String[] args) throws IOException {
        new A().solve();
    }

    private void solve() throws IOException {
        List<String> inputs = Files.readAllLines(input);
        int t = Integer.valueOf(inputs.get(0));
        List<String> results = new ArrayList<>(t);
        for (int i = 1; i <= t; i++) {
            results.add("Case #"+i+": "+solveCase(inputs.get(i)));
        }
        Files.write(output, results);
    }

    private String solveCase(String input) {
        String[] split = input.split(" ");
        boolean[] pans = getPans(split[0]);
        int k = Integer.valueOf(split[1]);
        int s = pans.length;
        int counter = 0;

        for (int i = 0; i < s; i++)
        {
            if (pans[i]) continue;
            if (i + k > s) return "IMPOSSIBLE";
            counter++;
            for (int j = 0; j < k; j++) {
                pans[i+j] = ! pans[i+j];
            }
        }
        return String.valueOf(counter);
    }

    private boolean[] getPans(String s) {
        char[] c = s.toCharArray();
        boolean[] result = new boolean[c.length];

        for (int i = 0; i < c.length; i++)
        {
            result[i] = c[i] == '+';
        }

        return result;
    }
}
