import java.util.*;
import java.io.*;

public class Mirrors
{
  public static double length(int x1, int y1, int x2, int y2)
  {
    double length = Math.sqrt(Math.pow(x1 - x2,2) + Math.pow(y1 - y2,2));
    return length;
  }
  
  public static boolean reflection(boolean[][] hall, int x, int y, int x2, int y2, double distance, double[][] slope, String[][] direction)
  {
    // System.out.println("Coordinates:" + x + " " + y + "," + x2 + " " + y2);
    if (!hall[x2][y2])
    {
      //System.out.println("0");
      return false;
    }  
    if (length(x,y,x2,y2) <= distance)
    {
   //   System.out.println("1 " + length(x,y,x2,y2) + " " + distance);
      return true;
    }
    else if (obstacle(hall,x2,y2,slope,direction)) 
    {
     // System.out.println("obst");
      return false;
    }
    else if (x == x2 || y == y2)
    {
      System.out.println("2");
      return true;
    }
    else if (direction.equals("upRight") && hall[x2-1][y2] && hall[x2][y2-1])
    {
   //   System.out.println("3");
      return true;
    }
    else if (direction.equals("upLeft") && hall[x2+1][y2] && hall[x2][y2-1]) 
    {
    //  System.out.println("4");
      return true;
    }
    else if (direction.equals("bottomRight") && hall[x2-1][y2] && hall[x2][y2+1])
    {
    //  System.out.println("5");
      return true;
    }
    else if (direction.equals("bottomLeft") && hall[x2+1][y2] && hall[x2][y2+1]) 
    {
     // System.out.println("6");
      return true;
    }
    else if (direction.equals("upRight") && !(hall[x2-1][y2] && hall[x2][y2-1])) 
    {
     // System.out.println("7");
      return false;
    }
    else if (direction.equals("upLeft") && !(hall[x2+1][y2] && hall[x2][y2-1])) 
    {
    //  System.out.println("8");
      return false;
    }
    else if (direction.equals("bottomRight") && !(hall[x2-1][y2] && hall[x2][y2+1])) 
    {
     // System.out.println("9");
      return false;
    }
    else if (direction.equals("bottomLeft") && !(hall[x2+1][y2] && hall[x2][y2+1])) 
    {
     // System.out.println("10");
      return false;
    }
   // System.out.println("11");
    return false;
  }
  
  public static boolean obstacle(boolean[][] hall, int x, int y, double[][] slope, String[][] direction)
  {
    for (int i = 0;i < hall.length;i++)
    {
      for (int j = 0; j < hall[0].length;j++)
      {
        // System.out.println(x + " " + y + " " + i + " " + j + " " + direction[i][j] + " " +(direction[x][y]));
        //if (slope[x][y] == slope[i][j] && direction[i][j].equals(direction[x][y]))
        //  return true;
      }
    }
    return false;
  }
  
  public static void main (String []args) throws IOException
  {
    final String INPUT_FILE = "D-small-attempt0.in";
    final String OUTPUT_FILE = "out2.out";
    
    BufferedReader input = new BufferedReader(new FileReader(INPUT_FILE));
    PrintWriter out = new PrintWriter(new FileWriter(OUTPUT_FILE));
    
    int repeats = Integer.parseInt(input.readLine());
    
    for (int k = 0; k < repeats; k++)
    {
      String t = input.readLine();
      //  System.out.println(t);
      StringTokenizer g = new StringTokenizer(t);
      int yLength = Integer.parseInt(g.nextToken());
      int xLength = Integer.parseInt(g.nextToken());
      boolean[][] hall = new boolean[xLength][yLength];
      Double distance = Double.parseDouble(g.nextToken());
      int x = 0;
      int y = 0;
      int count = 0;
      String[][] direction = new String[xLength][yLength];
      
      for (int j = 0; j < yLength; j++)
      {
        String line = input.readLine();
        for (int i = 0; i < xLength; i++)
        {
          if (line.charAt(i) == '#') hall[i][j] = true;
          else if (line.charAt(i) == '.') hall[i][j] = false;
          else if (line.charAt(i) == 'X') 
          {
            x = i;
            y = j;
            hall[i][j] = false;
          }
        }
      }
      //System.out.println(x + " " + y + " " + xLength + " " + yLength);
      double[][] slope = new double[xLength][yLength];
      for (int i = 0; i < xLength; i++)
      {
        for (int j = 0; j < yLength; j++)
        {
          if (hall[i][j])
          {
            if (i == x)
            {
              slope[i][j] = 0;
              direction[i][j] = "straightLine";
            }
            else if (j == y)
            {
              slope[i][j] = 0;
              direction[i][j] = "straightLine";
            }
            else
            {
              slope[i][j] = (j - y)/(i - x);
              if (i > x && j > y) direction[i][j] = "upRight";
              else if (i > x && j < y) direction[i][j] = "upLeft";
              else if (i < x && j > y) direction[i][j] = "bottomRight";
              else if (i < x && j < y) direction[i][j] = "bottomLeft";
              else direction[i][j] = "straightLine";
            }
          }
          else direction[i][j] = "noMirror";
        }
      }
      
      for (int i = 0; i < xLength; i++)
      {
        for (int j = 0; j < yLength; j++)
        {
          if (reflection(hall,x,y,i,j,distance,slope,direction)) count++;
        }
      }
      
      out.println("Case #" + (k + 1) + ": " + count);
    }
    out.close();
    input.close();
  }
}