/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package alienlanguage;
import java.util.*;
/**
 *
 * @author Jatin
 */
public class Trie {
    char ch;
    Map<Character,Trie> tries;

    public Trie(){
        ch = 0;
        tries = new HashMap<Character,Trie>();
    }

    public int numberOfMatches(String s,int i){ //returns number of matches of string s starting at index i
        if(i == s.length()) return 1;
        char ch = s.charAt(i);
        if(ch != '('){
            Trie next = getPrefixedBy(ch);
            if(next == null) return 0;
            else return next.numberOfMatches(s, i+1);
        }
        else{
            int j = i+1;
            while(s.charAt(j) != ')') j++;
            int number = 0;
            for(int k = i+1; k != j;k++){
                ch = s.charAt(k);
                Trie next = getPrefixedBy(ch);
                if(next == null) continue;
                number += next.numberOfMatches(s, j+1);
            }
            return number;
        }
    }

    public void insert(String s,int i){ //insert string s starting at index i into the subsequent tries
        if(i == s.length()) return;
        char ch = s.charAt(i);
        Trie next = tries.get(new Character(ch));
        if(next == null){
            next = new Trie();
            next.ch = ch;
            tries.put(ch, next);
            next.insert(s,i+1);
        }
        else{
            next.insert(s, i+1);
        }
    }

    public Trie getPrefixedBy(char ch){
        return tries.get(new Character(ch));
    }
}
