import java.io.*;
import java.util.*;

public class Solution {

    private BufferedReader in;
    private PrintWriter out;
    private StringTokenizer st;

    private String next() throws Exception {
        if(st == null || !st.hasMoreElements())
            st = new StringTokenizer(in.readLine());
        return st.nextToken();
    }

    private int nextInt() throws Exception {
        return Integer.parseInt(next());
    }
    private long nextLong() throws Exception {
        return Long.parseLong(next());
    }
    private double nextDouble() throws Exception {
        return Double.parseDouble(next());
    }

    private String solve(long n) {
        if (n < 10) {
            return Long.toString(n);
        }
        char[] c = Long.toString(n).toCharArray();
        boolean ok = true;
        for (int i = 1; i < c.length; i++) {
            if (c[i - 1] > c[i]) {
                ok = false;
                break;
            }
        }
        if (ok) {
            return Long.toString(n);
        }
        long k = 0;
        for (int i = 0; i < c.length; i++) {
            k = k * 10 + 1;
        }
        if (n < k) {
            long ans = 0;
            for (int i = 0; i < c.length - 1; i++) {
                ans = ans * 10 + 9;
            }
            return Long.toString(ans);
        }
        int ind = 0;
        for (int i = 1; i < c.length; i++) {
            if (c[i - 1] > c[i]) {
                ind = i - 1;
                break;
            }
        }
        c[ind] -= 1;
        while (ind - 1 >=0 && c[ind - 1] > c[ind]) {
            c[ind - 1] -= 1;
            ind--;
        }
        for (int i = ind + 1; i < c.length; i++) {
            c[i] = '9';
        }
        return new String(c);
    }

    private String tupoi(long n) {
        while(true) {
            String s = Long.toString(n);
            char[] c = s.toCharArray();
            if (c.length == 1) return s;
            boolean ok = true;
            for(int i = 1; i < c.length; i++) {
                if (c[i - 1] > c[i]) ok = false;
            }
            if (ok) return s;
            n--;
        }
    }

    private void run() throws Exception {
        in = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
        // The solution of the problem goes here
        int T = nextInt();
        for (int t = 1; t <= T; t++) {
            long n = nextLong();
            String ans = solve(n);
            // String ans2 = tupoi(n);
            // if (!ans.equals(ans2))
            out.println("Case #" + t + ": " + ans);
        }
        out.close();
    }

    public static void main(String[] args) throws Exception {
        new Solution().run();
    }
}
