import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Arrays;
import java.util.LinkedHashSet;
import java.util.Set;

public class Main {
    public static void main(String... args) throws IOException {
        String name1 = "C-small-attempt1.in";
        String name2 = "C-small-attempt1.out";

        try (BufferedReader in = new BufferedReader(new InputStreamReader(Main.class.getResourceAsStream(name1)));
             BufferedWriter out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(new File(name2))))) {
            final long[] arr = new long[9];

            for (int i = 0, total = Integer.parseInt(in.readLine()); i < total; i++) {
                String[] parts = in.readLine().split(" ");
                int n = Integer.parseInt(parts[0]);
                int j = Integer.parseInt(parts[1]);
                int base = (int)Math.pow(2, n) - 1;

                for (int k = 1; k < n - 1; k++)
                    base &= ~(1 << k);

                Set<Jamcoin> jamcoins = new LinkedHashSet<>();

                for (int k = 0, max = (int)Math.pow(2, n - 2) - 1; k <= max && jamcoins.size() < j; k++) {
                    String num = Long.toBinaryString(base | k << 1);
                    long[] div = calcDivision(num, arr);

                    if (div != null)
                        jamcoins.add(new Jamcoin(num, div));
                }

                if (i != 0) {
                    out.newLine();
                    System.out.println();
                }

                out.append(String.format("Case #%d:", i + 1));
                System.out.print(String.format("Case #%d:", i + 1));

                for (Jamcoin jamcoin : jamcoins) {
                    out.newLine();
                    out.append(jamcoin.num);
                    System.out.println();
                    System.out.print(jamcoin.num);

                    for (long div : jamcoin.div) {
                        out.append(' ').append(Long.toString(div));
                        System.out.print(' ');
                        System.out.print(Long.toString(div));
                    }
                }
            }
        }
    }

    private static long[] calcDivision(String str, long... arr) {
        for (int radix = 2; radix <= 10; radix++) {
            long div = getDivision(Long.valueOf(str, radix));

            if (div < 0)
                return null;

            arr[radix - 2] = div;
        }

        return arr;
    }

    private static long getDivision(long num) {
        if (num % 2 == 0)
            return 2;

        for (long i = 3; i * i <= num; i += 2)
            if (num % i == 0)
                return i;

        return -1;
    }

    private static class Jamcoin {
        private final String num;
        private final long[] div;

        public Jamcoin(String num, long[] div) {
            this.num = num;
            this.div = Arrays.copyOf(div, div.length);
        }

        @Override
        public String toString() {
            return num;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (!(o instanceof Jamcoin)) return false;

            Jamcoin jamcoin = (Jamcoin)o;

            return num.equals(jamcoin.num);
        }

        @Override
        public int hashCode() {
            return num.hashCode();
        }
    }
}
