package cop.google;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.regex.Pattern;

/**
 * @author Oleg Cherednik
 * @since 12.04.2014
 */
public class CookieClickerAlpha {
	private static final Pattern COMPILE = Pattern.compile(" ");

	public static void main(String... args) throws Exception {
//		run("test1");
//		run("test2");
		run("small");
	}

	private static void run(String fileName) throws Exception {
		try (BufferedReader in = new BufferedReader(new FileReader(new File(fileName + ".in")));
		     BufferedWriter out = new BufferedWriter(new FileWriter(new File(fileName + ".out")))) {

			for (int i = 0, T = Integer.parseInt(in.readLine()); i < T; i++)
				write(out, getTime(in), i);
		}
	}

	private static double getTime(BufferedReader in) throws IOException {
		double[] data = readCase(in);

		final double C = data[0];
		final double F = data[1];
		final double X = data[2];

		double totalTime = 0;
		double currF = 2;
		double minTime, currTime = Integer.MAX_VALUE;

		do {
			minTime = currTime;
			currTime = X / currF + totalTime;
			totalTime += C / currF;
			currF += F;
		} while (Double.compare(currTime, minTime) < 0);

		return minTime;
	}

	private static double[] readCase(BufferedReader in) throws IOException {
		String[] data = COMPILE.split(in.readLine());
		return new double[] { Double.parseDouble(data[0]), Double.parseDouble(data[1]), Double.parseDouble(data[2]) };
	}

	private static void write(BufferedWriter out, double time, int i) throws IOException {
		if (i > 0)
			out.write("\n");

		String str = String.format("Case #%1d: %2$.7f", i + 1, time).replace(',', '.');
		out.write(str);

		System.out.println(str);
	}
}
