package cop.google;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.regex.Pattern;

/**
 * @author Oleg Cherednik
 * @since 12.04.2014
 */
public class MagicTrick {
	private static final Pattern COMPILE = Pattern.compile(" ");

	public static void main(String... args) throws Exception {
//		run("test");
		run("small");
	}

	private static void run(String fileName) throws Exception {
		try (BufferedReader in = new BufferedReader(new FileReader(new File(fileName + ".in")));
		     BufferedWriter out = new BufferedWriter(new FileWriter(new File(fileName + ".out")))) {

			for (int i = 0, T = Integer.parseInt(in.readLine()); i < T; i++)
				write(out, getTime(in), i);
		}
	}

	private static String getTime(BufferedReader in) throws IOException {
		int[] row1 = readCase(in);
		int[] row2 = readCase(in);
		int card = 0;
		int total = 0;

		for (int val : row1) {
			int pos = Arrays.binarySearch(row2, val);

			if (pos < 0)
				continue;

			card = row2[pos];
			total++;
		}

		if (total == 1)
			return Integer.toString(card);
		return total == 0 ? "Volunteer cheated!" : "Bad magician!";
	}

	private static int[] readCase(BufferedReader in) throws IOException {
		int row = Integer.parseInt(in.readLine());
		int[] arr = new int[4];

		for (int i = 0; i < 4; i++) {
			String str = in.readLine();

			if (i != row - 1)
				continue;

			int j = 0;

			for (String val : COMPILE.split(str))
				arr[j++] = Integer.parseInt(val);
		}

		Arrays.sort(arr);

		return arr;
	}

	private static void write(BufferedWriter out, String res, int i) throws IOException {
		if (i > 0)
			out.write("\n");

		String str = String.format("Case #%d: %s", i + 1, res);
		out.write(str);

		System.out.println(str);
	}
}
