package cop.google;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.regex.Pattern;

/**
 * @author Oleg Cherednik
 * @since 12.04.2014
 */
public class DeceitfulWar {
	private static final Pattern COMPILE = Pattern.compile(" ");

	public static void main(String... args) throws Exception {
//		run("test");
//		run("small1");
//		run("small2");
//		run("small3");
		run("large");
	}

	private static void run(String fileName) throws Exception {
		try (BufferedReader in = new BufferedReader(new FileReader(new File(fileName + ".in")));
		     BufferedWriter out = new BufferedWriter(new FileWriter(new File(fileName + ".out")))) {

			for (int i = 0, T = Integer.parseInt(in.readLine()); i < T; i++)
				write(out, gatData(in), i);
		}
	}

	private static int[] gatData(BufferedReader in) throws IOException {
		int N = Integer.parseInt(in.readLine());
		int[] blocksNaomi = getBlocks(in, N);
		int[] blocksKen = getBlocks(in, N);

		return new int[] { playDeceitfulWar(blocksNaomi, blocksKen, N), playWar(blocksNaomi, blocksKen, N) };
	}

	private static int playDeceitfulWar(int[] blocksNaomi, int[] blocksKen, int N) {
		int score = 0;

		for (int i = 0, j = i; i < N; i++) {
			if (blocksNaomi[i] > blocksKen[j]) {
				score++;
				j++;
			}
		}

		return score;
	}

	private static int playWar(int[] blocksNaomi, int[] blocksKen, int N) {
		int score = 0;

		for (int i = N - 1, j = i; i >= 0; i--) {
			if (blocksNaomi[i] > blocksKen[j])
				score++;
			else
				j--;
		}

		return score;
	}

	private static int[] getBlocks(BufferedReader in, int N) throws IOException {
		int i = 0;
		int[] blocks = new int[N];

		for (String weight : COMPILE.split(in.readLine()))
			blocks[i++] = Double.valueOf(Double.parseDouble(weight) * 1000).intValue();

		Arrays.sort(blocks);

		return blocks;
	}

	private static void write(BufferedWriter out, int[] res, int i) throws IOException {
		if (i > 0)
			out.write("\n");

		String str = String.format("Case #%d: %d %d", i + 1, res[0], res[1]);
		out.write(str);

		System.out.println(str);
	}
}
