import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;


public class MineSweeper {
	int R;
	int C;
	int M;
	int B;
	String warningFlag = "";
	boolean[][] grid;
	public MineSweeper(int C, int R, int M){
		this.R = R;
		this.C = C;
		this.M = M;
		B = C*R-M;
		grid = new boolean[C][R];
		for(int i = 0 ; i < C ; i++){
			for(int j = 0 ; j < R ; j ++)
				grid[i][j]=true;
		}
	}
	public void solve(){
		if(M == 0)
			return;
		int j = 0;
		if(B==1){
			grid[0][0]=false;
			return;
		}
		if(C==1){
			if(B>2){
				warningFlag = "Impossible";
				return;
			}
			else{
				grid[0][0]=false;
				if(B==2)
					grid[0][1]=false;
				return;
			}
		}
		if(R==1){
			if(B>2){
				warningFlag = "Impossible";
				return;
			}
			else{
				grid[0][0]=false;
				if(B==2)
					grid[1][0]=false;
				return;
			}
		}
		if(B/C>=2){
			if(M%C!=C-1){
				for(j = 0 ; j < B/C ; j ++){
					for(int i = 0 ; i < C ; i++){
						grid[i][j] = false;
					}
				}
				for(int i = 0 ; i < B%C ; i++){
					grid[i][j] = false;
				}
				for(int i = B%C ; i < C ; i++){
					grid[i][j] = true;
				}
				j++;
				while(j< R){
					for(int i = 0 ; i < C ; i++){
						grid[i][j] = true;
					}
					j++;
				}	
				return;
			}else{
				if(B/C>2){
					for(j = 0 ; j < B/C - 1 ; j++){
						for(int i = 0 ; i < C ; i++){
							grid[i][j] = false;
						}
					}
					for(int i = 0 ; i < C-1 ; i++){
						grid[i][j] = false;
					}
					for(int i = C-1 ; i < C ; i++){
						grid[i][j] = true;
					}
					j++;
					for(int i = 0 ; i < 2 ; i++){
						grid[i][j] = false;
					}
					for(int i = 2; i < C ; i++){
						grid[i][j] = true;
					}
					j++;
					while(j < R){
						for(int i = 0 ; i < C ; i++){
							grid[i][j] = true;
						}
						j++;
					}
					return;
				}
			}
		}
		if(B/R>=2){
			if(M%R!=R-1){
				for(j = 0 ; j < B/R ; j ++){
					for(int i = 0 ; i < R ; i++){
						grid[j][i] = false;
					}
				}
				for(int i = 0 ; i < B%R ; i++){
					grid[j][i] = false;
				}
				for(int i = B%R ; i < R ; i++){
					grid[j][i] = true;
				}
				j++;
				while(j< C){
					for(int i = 0 ; i < R ; i++){
						grid[j][i] = true;
					}
					j++;
				}	
				return;
			}else{
				if(B/R>2){
					for(j = 0 ; j < B/R - 1 ; j++){
						for(int i = 0 ; i < R ; i++){
							grid[j][i] = false;
						}
					}
					for(int i = 0 ; i < R-2 ; i++){
						grid[j][i] = false;
					}
					for(int i = R-1 ; i < R ; i++){
						grid[j][i] = true;
					}
					j++;
					for(int i = 0 ; i < 2 ; i++){
						grid[j][i] = false;
					}
					for(int i = 2; i < R ; i++){
						grid[j][i] = true;
					}
					j++;
					while(j < C){
						for(int i = 0 ; i < R ; i++){
							grid[j][i] = true;
						}
						j++;
					}
					return;
				}
			}
		}
		if(B%2==0&&B>=4){
			for(int i = 0 ; i < B/2 ; i++){
				for(int y = 0 ; y < 2 ; y++){
					grid[i][y] = false;
				}
			}
			return;
		}
		if(B%2==1&&B>=9){
			int k = (B-3)/2;
			for(int i = 0 ; i < k ; i++){
				for(int y = 0 ; y < 2 ; y++){
					grid[i][y] = false;
				}
			}
			for(int i = 0 ; i < 3 ; i++){
				grid[i][2]= false;
			}
			return;
		}
		warningFlag = "Impossible";
	}
	public String toString(){
		if(warningFlag.equals("Impossible"))
			return "Impossible";
		String res = "c";
		if(M==0)
			return "Impossible";
			for(int j = 0 ; j < R ; j++){
				for(int i = 0 ; i < C ; i ++){
				if(!(i==0&&j==0)){
					if(grid[i][j])
						res+="*";
					else
						res+=".";
				}
			}
			res+="\n";
		}
		return res;
	}
	public static void main(String[] args){
		try {
			Scanner sc = new Scanner(new File("C-small-attempt3.in"));
			PrintWriter pw = new PrintWriter(new File("Output.txt"));
			int nbTest = sc.nextInt();
			for(int i = 0 ; i < nbTest ; i ++){
				MineSweeper ms = new MineSweeper(sc.nextInt(),sc.nextInt(),sc.nextInt());
				ms.solve();
				System.out.println("Case #" + (i+1) + ":\n"+ms);
				pw.println("Case #" + (i+1) + ":\n"+ms);
			}
			sc.close();
			pw.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
