import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;


public class TheRepeater {
	
	public static void main(String[] args) {
		//Open The file
		BufferedReader br=null;
		try {
			br = new BufferedReader(new FileReader("A-large.in"));
			//br = new BufferedReader(new InputStreamReader(System.in));
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//FileWriter fstream = new FileWriter("out.txt");
		//BufferedWriter out = new BufferedWriter(fstream);
		
		//Get the test case number
		int casenum = readLineAsInt(br);
		
		//Process each case
		for(int j = 1; j <= casenum; j++)
		{
			int numStrings = readLineAsInt(br);
			
			//Read the selected row
			String[] s = new String[numStrings];
			String[] sig = new String[numStrings];
			List<List<Integer>> sigCounts = new ArrayList<List<Integer>>();
			try {
				for (int strnum=0;strnum<numStrings;strnum++)
				{	
					s[strnum] = br.readLine();
					sig[strnum] = getSig(s[strnum]);
					sigCounts.add(getSigCount(s[strnum]));
				}
					
			} catch (IOException e) {
				e.printStackTrace();
			}
			
			boolean done = false;
			for(String str: sig)
			{
				if(!sig[0].equals(str))
				{
					printResult(j, -1);
					done = true;
					break;
				}
			}
			if(done)
				continue;
			
			int totalDiff = 0;
			for(int i=0;i<sig[0].length();i++)
			{
				int[] charCnt = new int[numStrings];
				int sum = 0;
				for(int strnum=0;strnum<numStrings;strnum++)
				{
					charCnt[strnum] = sigCounts.get(strnum).get(i);
					sum+=charCnt[strnum];
				}
				if(sum%numStrings==0)
				{
					totalDiff += getDiffSum(charCnt, sum/numStrings);
				}
				else
				{//System.out.println(sum+" "+numStrings);
				//for(int c:charCnt)
					//System.out.println(c);
				//System.out.println();
					totalDiff+= Math.min(getDiffSum(charCnt, sum/numStrings), getDiffSum(charCnt,1+sum/numStrings));
				}
			}
			printResult(j, totalDiff);
		}
		try {
			br.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

		
		@SuppressWarnings("finally")
		public static int readLineAsInt(BufferedReader br)
		{
			int val = 0;
			try {
				val = Integer.parseInt(br.readLine());
			} catch (NumberFormatException e) {
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}finally{
				return val;
			}
		}
		
		public static void printStringArray(String[] s)
		{
			for(String str:s)
			{
				System.out.print(str+", ");
			}
			System.out.println("");
		}
		
		public static void printResult(int caseNum,int value)
		{
			System.out.print("Case #"+caseNum+": ");
			if(value==-1)
				System.out.println("Fegla Won");
			else
				System.out.println(value);
		}
		
		public static String getSig(String str)
		{
			String sig = "";
			char prev = ' ';
			for(int i=0;i<str.length();i++)
			{
				if(str.charAt(i)!=prev)
				{
					sig = sig+str.charAt(i);
					prev = str.charAt(i);
				}
			}
			return sig;
		}
		
		public static List<Integer> getSigCount(String str)
		{
			List<Integer> sig = new ArrayList<Integer>();
			char prev = ' ';
			for(int i=0;i<str.length();i++)
			{
				if(str.charAt(i)!=prev)
				{
					sig.add(1);
					prev = str.charAt(i);
				}
				else
				{
					Integer xx = sig.get(sig.size()-1)+1;
					sig.set(sig.size()-1, xx);
				}
			}
			return sig;
		}
		
		public static int getDiffSum(int[] counts,int mean)
		{
			int sum = 0;
			for(int i:counts)
			{
				sum+=Math.abs(i-mean);
			}
			return sum;
		}
}