package qualification;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import java.util.StringTokenizer;

public class CMainLarge {

	public static void main(String[] args) {
		String inputFileName = args[0];
		String outputFileName = args[1];
		BufferedReader reader = null;
		File outputfile = new File(outputFileName);
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(outputfile);
		} catch (FileNotFoundException e1) {
			System.err.println("Output file not found");
			System.exit(1);
		}

		DataOutputStream dos = new DataOutputStream(fos);
		try {
			reader = new BufferedReader(new FileReader(inputFileName));

			String numberOfCasesStr = reader.readLine(); // Number of cases
			int numberOfCases = Integer.valueOf(numberOfCasesStr); // Default:
																	// number of
																	// cases
			Set<Long> fairAndSquare = new HashSet<Long>();
			List<Long> baseNumbers = generateBaseNumbers(1000000000000000000L);
			for (int i = 0; i < numberOfCases; i++) {
				System.out.println("Case #" + (i + 1));
				// Read Case
				StringTokenizer tokenizer = new StringTokenizer(
						reader.readLine());
				long a = Long.valueOf(tokenizer.nextToken());
				long b = Long.valueOf(tokenizer.nextToken());

				// Solve Case
				int result = 0;
				if (a <= 1 && 1 <= b) {
					result++;
				}
				
				if (a <= 4 && 4 <= b) {
					result++;
				}
				
				if (a <= 9 && 9 <= b) {
					result++;
				}
				
				for (Long baseNumber : baseNumbers) {
					Long square = baseNumber * baseNumber;
					if (square > b) {
						break;
					}
					if (isPalindrome(square)) {
						result++;
						System.out.println(square);
					}
				}


				try {
					dos.writeBytes("Case #" + (i + 1) + ": " + result + "\n");
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("Input file not found");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

	private static List<Long> generateBaseNumbers(long max) {
		List<Long> baseNumbers = new LinkedList<Long>();
		long maxRoot = (long) Math.sqrt(max);
		int numOfDigits = String.valueOf(maxRoot).length();
		for (int i = 2; i <= numOfDigits; i++) {
			Iterable<String> strings = base3(i);
			Iterator<String> iterator = strings.iterator();
			while (iterator.hasNext()) {
				String number = iterator.next();
				Long longValue = Long.valueOf(number);
				if (!number.startsWith("0") && isPalindrome(longValue)) {
					baseNumbers.add(longValue);
				}
			}
		}
		return baseNumbers;

	}

	static Iterable<String> base3(final int digits) {
		  return new Iterable<String>() {

		    public Iterator<String> iterator() {
		      return new Iterator<String>() {

		        private final String pad;
		        {
		          final StringBuilder buf = new StringBuilder(digits);
		          for (int n = digits; n >= 0; --n) {
		            buf.append('0');
		          }
		          pad = buf.toString();
		        }

		        private final int hi = (int) Math.pow(3, digits);
		        private int cursor;

		        public boolean hasNext() {
		          return cursor < hi;
		        }

		        public String next() {
		          final String rsl = Integer.toString(cursor++, 3);
		          return pad.substring(0, digits - rsl.length()) + rsl;
		        }

		        public void remove() {
		          throw new UnsupportedOperationException();
		        }
		      };
		    }
		  };
	}

	private static boolean isPalindrome(long n) {
		char[] nChars = String.valueOf(n).toCharArray();
		int start = 0;
		int end = nChars.length - 1;
		boolean palindrome = true;
		while (start <= end) {
			if (nChars[start] == nChars[end]) {
				start++;
				end--;
				continue;
			} else {
				palindrome = false;
				break;
			}
		}
		// if (palindrome) {
		// System.out.println(n + " is palindrome");
		// }
		return palindrome;
	}
}
