package round1c;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;
import java.util.StringTokenizer;

public class CMain {

	public static void main(String[] args) {
		String inputFileName = args[0];
		String outputFileName = args[1];
		BufferedReader reader = null;
		File outputfile = new File(outputFileName);
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(outputfile);
		} catch (FileNotFoundException e1) {
			System.err.println("Output file not found");
			System.exit(1);
		}

		DataOutputStream dos = new DataOutputStream(fos);
		try {
			reader = new BufferedReader(new FileReader(inputFileName));

			String numberOfCasesStr = reader.readLine(); // Number of cases
			int numberOfCases = Integer.valueOf(numberOfCasesStr); // Default:
																	// number of
																	// cases
			for (int z = 0; z < numberOfCases; z++) {
				System.out.println("Case #" + (z + 1));
				// Read Case
				StringTokenizer tokenizer = new StringTokenizer(
						reader.readLine());
				int N = Integer.valueOf(tokenizer.nextToken());
				long L = Long.valueOf(tokenizer.nextToken());
				long H = Long.valueOf(tokenizer.nextToken());

				tokenizer = new StringTokenizer(reader.readLine());
				List<Long> frequencies = new LinkedList<Long>();

				Long minFreq = L;
				Long frequency = null;
				for (int i = 0; i < N; i++) {
					frequencies.add(Long.valueOf(tokenizer.nextToken()));
				}

				Collections.sort(frequencies);

				for (int i = 0; i < N; i++) {
					long musicianFrequency = frequencies.get(i);
					for (long j = minFreq; j <= H; j++) {
						if (j % musicianFrequency == 0
								|| musicianFrequency % j == 0) {
							boolean divisor = true;
							if (i < N-1) {
								for (int k = i + 1; k < N; k++) {
									long otherMusicianFrequency = frequencies
											.get(k);
									if (!(j % otherMusicianFrequency == 0 || otherMusicianFrequency
											% j == 0)) {
										divisor = false;
										break;
									}
								}
							} else {
								divisor = false;
							}
							if (divisor) {
								frequency = j;
								break;
							} else {
								minFreq = j;
							}
						}
						if (frequency != null) {
							break;
						}
					}

				}

				// Solve Case
				String result;
				if (frequency == null) {
					result = "NO";
				} else {
					result = String.valueOf(frequency);
				}

				try {
					dos.writeBytes("Case #" + (z + 1) + ": " + result + "\n");
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("Input file not found");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}
}
