package qualification;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashSet;
import java.util.Set;
import java.util.StringTokenizer;

public class CMain {

	public static void main(String[] args) {
		String inputFileName = args[0];
		String outputFileName = args[1];
		BufferedReader reader = null;
		File outputfile = new File(outputFileName);
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(outputfile);
		} catch (FileNotFoundException e1) {
			System.err.println("Output file not found");
			System.exit(1);
		}

		DataOutputStream dos = new DataOutputStream(fos);
		try {
			reader = new BufferedReader(new FileReader(inputFileName));

			String numberOfCasesStr = reader.readLine(); // Number of cases
			int numberOfCases = Integer.valueOf(numberOfCasesStr); // Default:
																	// number of
																	// cases
			Set<Long> fairAndSquare = new HashSet<Long>();
			for (int i = 0; i < numberOfCases; i++) {
				System.out.println("Case #" + (i + 1));
				// Read Case
				StringTokenizer tokenizer = new StringTokenizer(
						reader.readLine());
				long a = Long.valueOf(tokenizer.nextToken());
				long b = Long.valueOf(tokenizer.nextToken());

				// Solve Case
				int result = 0;
				Set<Long> notFairAndSquare = new HashSet<Long>();

				for (long n = a; n <= b; n++) {
					if (notFairAndSquare.contains(n)) {
						continue;
					}
					if (!isPalindrome(n)) {
						continue;
					}
					long sqrt;
					double squareRoot = Math.sqrt(n);
					sqrt = (long) squareRoot;
					if (sqrt * sqrt == n) {
						if (fairAndSquare.contains(sqrt)) {
							if (isPalindrome(n)) {
								result++;
								fairAndSquare.add(n);
							}
						} else if (isPalindrome(sqrt)) {
							if (isPalindrome(n)) {
								result++;
								fairAndSquare.add(n);
							}
						}
					} else {
						continue;
					}

				}

				try {
					dos.writeBytes("Case #" + (i + 1) + ": " + result + "\n");
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("Input file not found");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

	private static boolean isPalindrome(long n) {
		char[] nChars = String.valueOf(n).toCharArray();
		int start = 0;
		int end = nChars.length - 1;
		boolean palindrome = true;
		while (start <= end) {
			if (nChars[start] == nChars[end]) {
				start++;
				end--;
				continue;
			} else {
				palindrome = false;
				break;
			}
		}
		if (palindrome) {
			System.out.println(n + " is palindrome");
		}
		return palindrome;
	}
}
