package round1;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class AMain {

	private static class Horse implements Comparable<Horse> {
		Integer position;
		Integer speed;

		public Horse(Integer position, Integer speed) {
			this.position = position;
			this.speed = speed;
		}

		@Override
		public int compareTo(Horse o) {
			return this.position.compareTo(o.position);
		}

	}

	public static void main(String[] args) {
		String inputFileName = args[0];
		String outputFileName = args[1];
		BufferedReader reader = null;
		File outputfile = new File(outputFileName);
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(outputfile);
		} catch (FileNotFoundException e1) {
			System.err.println("Output file not found");
			System.exit(1);
		}

		DataOutputStream dos = new DataOutputStream(fos);
		try {
			reader = new BufferedReader(new FileReader(inputFileName));

			String numberOfCasesStr = reader.readLine(); // Number of cases
			int numberOfCases = Integer.valueOf(numberOfCasesStr); // Default: number of cases
			for (int i = 0; i < numberOfCases; i++) {
				System.out.println("Case #" + (i + 1));
				// Read Case
				StringTokenizer tokenizer = new StringTokenizer(reader.readLine());
				final Integer D = Integer.valueOf(tokenizer.nextToken());
				final Integer N = Integer.valueOf(tokenizer.nextToken());
				Set<Horse> horses = new TreeSet<Horse>();
				for (int j = 0; j < N; j++) {
					tokenizer = new StringTokenizer(reader.readLine());
					final Integer ki = Integer.valueOf(tokenizer.nextToken());
					if (ki < D) {
						final Integer si = Integer.valueOf(tokenizer.nextToken());
						horses.add(new Horse(ki, si));
					}
				}

				// Solve Case
				double maxTimeToDestination = 0.0;
				for (Horse horse : horses) {
					final Integer position = horse.position;
					final Integer speed = horse.speed;

					double timeToDestination = (D - position) / (double) speed;
					if (timeToDestination > maxTimeToDestination) {
						maxTimeToDestination = timeToDestination;
					} else {
						break;
					}
				}

				double speedToDestination = D / maxTimeToDestination;
				String result = String.valueOf(speedToDestination);

				try {
					dos.writeBytes("Case #" + (i + 1) + ": " + result + "\n");
				} catch (FileNotFoundException e) {
					e.printStackTrace();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("Input file not found");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}
}
