package round1c;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;
import java.util.StringTokenizer;

public class AMain {

	public static void main(String[] args) {
		String inputFileName = args[0];
		String outputFileName = args[1];
		BufferedReader reader = null;
		File outputfile = new File(outputFileName);
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(outputfile);
		} catch (FileNotFoundException e1) {
			System.err.println("Output file not found");
			System.exit(1);
		}

		DataOutputStream dos = new DataOutputStream(fos);
		try {
			reader = new BufferedReader(new FileReader(inputFileName));

			String numberOfCasesStr = reader.readLine(); // Number of cases
			int numberOfCases = Integer.valueOf(numberOfCasesStr); // Default:
																	// number of
																	// cases
			for (int z = 0; z < numberOfCases; z++) {
				System.out.println("Case #" + (z + 1));
				// Read Case
				StringTokenizer tokenizer = new StringTokenizer(
						reader.readLine());
				int rows = Integer.valueOf(tokenizer.nextToken());
				int columns = Integer.valueOf(tokenizer.nextToken());
				char[][] image = new char[rows][columns];
				char[][] result = image;
				int numBlues = 0;
				for (int i = 0; i < rows; i++) {
					String rowStr = reader.readLine();
					int blueRow = 0;
					for (int j = 0; j < columns;j++) {
						char tile = rowStr.charAt(j);
						image[i][j] = tile;
						if (tile == '#') {
							numBlues++;
							blueRow++;
						}
					}
					if (blueRow != 0 && (blueRow % 2 != 0)) {
						result = null;
						numBlues = -1;
						for (int k = i+1; k < rows; k++ ) {
							reader.readLine();
						}
						break;
					}
				}
				
				if (numBlues == -1 || (numBlues % 4 != 0)) {
					result = null;
				}
				
				Boolean[][] tilesPainted = new Boolean[rows][columns];
				
				if (result != null) {
					if (numBlues > 0) {
						for (int i = 0; i < rows; i++) {
							for (int j = 0; j < columns; j++) {
								if (tilesPainted[i][j] == null || (tilesPainted[i][j] != null && !tilesPainted[i][j])) {
									char tile = image[i][j];
									if (tile == '#') {
										if ((j + 1 > columns) || (i + 1 > rows)) {
											result = null;
											break;
										} else {
											result[i][j] = '/';
											result[i+1][j] = '\\';
											result[i][j+1] = '\\';
											result[i+1][j+1] = '/';
											
											tilesPainted[i+1][j] = true;
											tilesPainted[i][j+1] = true;
											tilesPainted[i+1][j+1] = true;
										}
									}									
								}
							}
							if (result == null) {
								break;
							}
						}
					} else {
						result = image;
					}
				}
				
				try {
					dos.writeBytes("Case #" + (z + 1) + ":\n");
					if (result == null) {
						dos.writeBytes("Impossible\n");
					} else {
						for (int i = 0; i < rows; i++) {
							for (int j = 0; j < columns; j++) {
								char c = result[i][j];
								dos.writeByte(c);
							}
							dos.writeBytes("\n");
						}						
					}

				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("Input file not found");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}
}
