package round1b;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.Random;
import java.util.StringTokenizer;

public class BMain {

	public static void main(String[] args) {
		String inputFileName = args[0];
		String outputFileName = args[1];
		BufferedReader reader = null;
		File outputfile = new File(outputFileName);
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(outputfile);
		} catch (FileNotFoundException e1) {
			System.err.println("Output file not found");
			System.exit(1);
		}

		DataOutputStream dos = new DataOutputStream(fos);
		try {
			reader = new BufferedReader(new FileReader(inputFileName));

			String numberOfCasesStr = reader.readLine(); // Number of cases
			int numberOfCases = Integer.valueOf(numberOfCasesStr); // Default:
																	// number of
																	// cases
			for (int i = 0; i < numberOfCases; i++) {
				System.out.println("Case #" + (i + 1));
				// Read Case
				StringTokenizer tokenizer = new StringTokenizer(reader.readLine());
				final String C = tokenizer.nextToken();
				final String J = tokenizer.nextToken();

				// Solve Case
				String result = "";
				char[] cDigits = C.toCharArray();
				final char[] jDigits = J.toCharArray();
				int firsCNumIndex = firstNumIndex(cDigits);
				int firsJNumIndex = firstNumIndex(jDigits);
				int minIndex = Math.min(firsJNumIndex, firsCNumIndex);
				for (int j = 0; j < minIndex; j++) {
					cDigits[j] = '0';
					jDigits[j] = '0';
				}
				int lastBothNumIndex = 0;
				for (int j = minIndex; j < cDigits.length; j++) {
					if (cDigits[j] != '?') {
						if (jDigits[j] == '?') {
							jDigits[j] = cDigits[j];
						} else {
							lastBothNumIndex = j;
						}
					} else {
						if (jDigits[j] == '?') {
							if (cDigits[lastBothNumIndex] < jDigits[lastBothNumIndex]) {
								cDigits[j] = '9';
								jDigits[j] = '0';
							} else if (cDigits[lastBothNumIndex] > jDigits[lastBothNumIndex]) {
								cDigits[j] = '0';
								jDigits[j] = '9';
							} else {
								cDigits[j] = '0';
								jDigits[j] = '0';
							}
						} else {
							cDigits[j] = jDigits[j];
						}
					}
				}
				for (int j = 0; j < cDigits.length; j++) {
					result = result.concat(String.valueOf(cDigits[j]));
				}
				result = result.concat(" ");
				for (int j = 0; j < jDigits.length; j++) {
					result = result.concat(String.valueOf(jDigits[j]));
				}

				try {
					dos.writeBytes("Case #" + (i + 1) + ": " + result + "\n");
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("Input file not found");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

	private static int firstNumIndex(char[] cDigits) {
		int firsNumIndex;
		for (firsNumIndex = 0; firsNumIndex < cDigits.length; firsNumIndex++) {
			if (cDigits[firsNumIndex] != '?') {
				break;
			}
		}
		return firsNumIndex;
	}
}
