package round1b;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.Arrays;
import java.util.Random;
import java.util.StringTokenizer;

public class AMain {

	public static void main(String[] args) {
		String inputFileName = args[0];
		String outputFileName = args[1];
		BufferedReader reader = null;
		File outputfile = new File(outputFileName);
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(outputfile);
		} catch (FileNotFoundException e1) {
			System.err.println("Output file not found");
			System.exit(1);
		}

		DataOutputStream dos = new DataOutputStream(fos);
		try {
			reader = new BufferedReader(new FileReader(inputFileName));

			String numberOfCasesStr = reader.readLine(); // Number of cases
			int numberOfCases = Integer.valueOf(numberOfCasesStr); // Default:
																	// number of
																	// cases
			for (int i = 0; i < numberOfCases; i++) {
				System.out.println("Case #" + (i+1));
				// Read Case
				StringTokenizer tokenizer = new StringTokenizer(reader.readLine());
				long A = Long.valueOf(tokenizer.nextToken());
				int N = Integer.valueOf(tokenizer.nextToken());
				
				tokenizer = new StringTokenizer(reader.readLine());
				long[] motes = new long[N];
				for (int j = 0; j < N; j++) {
					motes[j] = Long.valueOf(tokenizer.nextToken());
				}
				
				
				
				
				// Solve Case
				Integer result = 0;
				Arrays.sort(motes);
				result = osmos(A,motes, result);
				
				
				try {
					dos.writeBytes("Case #" + (i+1) + ": " + result.toString().trim() + "\n");
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("Input file not found");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

	private static int osmos(long a, long[] motes, int moves) {
		if (motes.length == 0) {
			return moves;
		} else {
			long m = motes[0];
			if (a > m) {
				return osmos(a + m, Arrays.copyOfRange(motes, 1, motes.length), moves);
			} else {
				if (motes.length == 1) {
					return moves + 1;
				}
				int movesRemove = osmos(a,Arrays.copyOf(motes, motes.length-1),moves + 1);
				int movesAdd = Integer.MAX_VALUE;
				if (a > 1) {
					long[] motesPlus = Arrays.copyOf(motes, motes.length+1);
					motesPlus[motesPlus.length-1] = a - 1;
					Arrays.sort(motesPlus);
					movesAdd = osmos(a, motesPlus, moves + 1);
				}
				return Math.min(movesAdd, movesRemove);
			}
		}
		
	}
}
