package round1b;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.StringTokenizer;

public class AMain {

	private static List<Integer> number = new ArrayList<>();

	public static void main(String[] args) {
		String inputFileName = args[0];
		String outputFileName = args[1];
		BufferedReader reader = null;
		File outputfile = new File(outputFileName);
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(outputfile);
		} catch (FileNotFoundException e1) {
			System.err.println("Output file not found");
			System.exit(1);
		}

		DataOutputStream dos = new DataOutputStream(fos);
		try {
			reader = new BufferedReader(new FileReader(inputFileName));

			String numberOfCasesStr = reader.readLine(); // Number of cases
			int numberOfCases = Integer.valueOf(numberOfCasesStr); // Default:
																	// number of
																	// cases
			for (int i = 0; i < numberOfCases; i++) {
				System.out.println("Case #" + (i + 1));
				// Read Case
				StringTokenizer tokenizer = new StringTokenizer(reader.readLine());
				final String s = tokenizer.nextToken();

				// Solve Case
				String temp = s;
				while (temp.length() > 0) {
					temp = process(temp, 'Z', "ZERO", 0);
					temp = process(temp, 'W', "TWO", 2);
					temp = process(temp, 'U', "FOUR", 4);
					temp = process(temp, 'F', "FIVE", 5);
					temp = process(temp, 'X', "SIX", 6);
					temp = process(temp, 'V', "SEVEN", 7);
					temp = process(temp, 'G', "EIGHT", 8);
					temp = process(temp, 'O', "ONE", 1);
					temp = process(temp, 'H', "THREE", 3);
					temp = process(temp, 'N', "NINE", 9);
				}
				String result = "";
				Collections.sort(number);
				for (Integer n : number) {
					result = result.concat(String.valueOf(n));
				}
				number.clear();

				try {
					dos.writeBytes("Case #" + (i + 1) + ": " + result + "\n");
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("Input file not found");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

	private static String process(String temp, char ch, String numStr, int numInt) {
		int indexOfZ = 0;
		while (indexOfZ != -1) {
			indexOfZ = temp.indexOf(ch);
			if (indexOfZ != -1) {
				// there's a zero
				temp = remove(temp, numStr);
				number.add(numInt);
			}
		}
		return temp;
	}

	private static String remove(String temp, String string) {
		String ret = temp;
		for (char c : string.toCharArray()) {
			int indexOf = ret.indexOf(c);
			ret = ret.substring(0, indexOf).concat(ret.substring(indexOf + 1, ret.length()));
		}
		return ret;
	}
}
