package qualification;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.Arrays;
import java.util.Random;
import java.util.StringTokenizer;

public class BMain {

	public static void main(String[] args) {
		String inputFileName = args[0];
		String outputFileName = args[1];
		BufferedReader reader = null;
		File outputfile = new File(outputFileName);
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(outputfile);
		} catch (FileNotFoundException e1) {
			System.err.println("Output file not found");
			System.exit(1);
		}

		DataOutputStream dos = new DataOutputStream(fos);
		try {
			reader = new BufferedReader(new FileReader(inputFileName));

			String numberOfCasesStr = reader.readLine(); // Number of cases
			int numberOfCases = Integer.valueOf(numberOfCasesStr); // Default: number of cases
			for (int i = 0; i < numberOfCases; i++) {
				System.out.println("Case #" + (i+1));
				// Read Case
				StringTokenizer tokenizer = new StringTokenizer(reader.readLine());
				final String number = tokenizer.nextToken();
				
				// Solve Case
				String result = number;
				final char[] digitsArray = number.toCharArray();
				char[] resultArray = Arrays.copyOf(digitsArray, digitsArray.length);
				if (!isTidy(digitsArray)) {
					final int numOfDigits = resultArray.length;
					resultArray[numOfDigits - 1] = '9';
					boolean carry = true;
					for (int digitIndex = numOfDigits - 1; digitIndex >= 0; digitIndex--) {
						if (carry) {
							if (digitIndex > 0) {
								resultArray[digitIndex] = '9';
								carry = Character.getNumericValue(digitsArray[digitIndex-1]) <= 1;
							} else {
								resultArray = Arrays.copyOfRange(resultArray, 1, numOfDigits);
							}
						} else {
							final int digitMinusOne = Character.getNumericValue(digitsArray[digitIndex]) - 1;
							resultArray[digitIndex] = Character.forDigit(digitMinusOne, 10);
							final char[] prefixArray = Arrays.copyOfRange(resultArray, 0, digitIndex + 1);
							if (isTidy(prefixArray)) {
								break;
							} else {
								resultArray[digitIndex] = '9';
								carry = Character.getNumericValue(digitsArray[digitIndex-1]) <= 1;
								continue;
							}
						}
					}
					result = String.valueOf(resultArray);
				} 
				
				try {
					dos.writeBytes("Case #" + (i+1) + ": " + result + "\n");
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("Input file not found");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

	private static boolean isTidy(char[] digitsArray) {
		boolean tidy = true;
		int currentDigit = digitsArray[0];
		for (int i = 1; i < digitsArray.length; i++) {
			final int digit = digitsArray[i];
			if (digit >= currentDigit) {
				currentDigit = digit;
			} else {
				tidy = false;
				break;
			}
		}
		return tidy;
	}
}
