package qualification;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Random;
import java.util.StringTokenizer;

public class CMain {

	public static void main(String[] args) {
		String inputFileName = args[0];
		String outputFileName = args[1];
		BufferedReader reader = null;
		File outputfile = new File(outputFileName);
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(outputfile);
		} catch (FileNotFoundException e1) {
			System.err.println("Output file not found");
			System.exit(1);
		}

		DataOutputStream dos = new DataOutputStream(fos);
		try {
			reader = new BufferedReader(new FileReader(inputFileName));

			String numberOfCasesStr = reader.readLine(); // Number of cases
			int numberOfCases = Integer.valueOf(numberOfCasesStr); // Default:
																	// number of
																	// cases
			for (int i = 0; i < numberOfCases; i++) {
				System.out.println("Case #" + (i + 1));
				// Read Case
				StringTokenizer tokenizer = new StringTokenizer(reader.readLine());
				final Integer n = Integer.valueOf(tokenizer.nextToken());
				final Integer j = Integer.valueOf(tokenizer.nextToken());

				// Solve Case
				StringBuilder resultBuilder = new StringBuilder();
				int numGenerated = 0;
				int[] internalNumbers = new int[n - 2];
				while (numGenerated < j) {
					StringBuilder numBuilder = new StringBuilder();
					for (int k = 0; k < internalNumbers.length; k++) {
						numBuilder.append(internalNumbers[k]);
					}
					String coinStr = "1" + numBuilder.toString() + "1";
					List<Long> divisors = new ArrayList<>();
					for (int base = 2; base <= 10; base++) {
						BigInteger numberInBase = new BigInteger(coinStr, base);
						long firstDivisor = firstNonTrivialDivisor(numberInBase);
						if (firstDivisor == 1L) {
							break;
						} else {
							divisors.add(firstDivisor);
						}
					}
					if (divisors.size() == 9) {
						StringBuilder coinBuilder = new StringBuilder();
						coinBuilder.append(coinStr.trim()).append(" ");
						divisors.stream().forEach(d -> coinBuilder.append(d).append(" "));
						resultBuilder.append(coinBuilder.toString().trim()).append("\n");
						numGenerated++;
					}
					internalNumbers = nextBinary(internalNumbers);
				}

				try {
					dos.writeBytes("Case #" + (i + 1) + ":\n" + resultBuilder.toString().trim() + "\n");
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("Input file not found");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

	private static long firstNonTrivialDivisor(BigInteger numberInBase) {
		if (numberInBase.mod(BigInteger.valueOf(2)).equals(BigInteger.ZERO)) {
			return 2L;
		}
		for (long i = 3; i < 1000; i += 2) {
			if (numberInBase.mod(BigInteger.valueOf(i)).equals(BigInteger.ZERO)) {
				return i;
			}
		}
		return 1L;
	}

	private static int[] nextBinary(int[] digits) {
		final int length = digits.length;
		if (length > 0) {
			int index = length - 1;
			int digit = digits[index];
			if (digit == 0) {
				digits[index] = 1;
			} else {
				int[] head = Arrays.copyOf(digits, digits.length - 1);
				head = nextBinary(head);
				System.arraycopy(head, 0, digits, 0, head.length);
				digits[digits.length - 1] = 0;
			}
		}
		return digits;
	}
}
