package qualification;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;

public class AMain {

	public static void main(String[] args) {
		String inputFileName = args[0];
		String outputFileName = args[1];
		BufferedReader reader = null;
		File outputfile = new File(outputFileName);
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(outputfile);
		} catch (FileNotFoundException e1) {
			System.err.println("Output file not found");
			System.exit(1);
		}

		DataOutputStream dos = new DataOutputStream(fos);
		try {
			reader = new BufferedReader(new FileReader(inputFileName));

			String numberOfCasesStr = reader.readLine(); // Number of cases
			int numberOfCases = Integer.valueOf(numberOfCasesStr); // Default:
																	// number of
																	// cases
			for (int i = 0; i < numberOfCases; i++) {
				System.out.println("Case #" + (i + 1));
				StringTokenizer tokenizer = new StringTokenizer(
						reader.readLine());
				Symbol[][] board = new Symbol[4][4];

				boolean emptyCells = false;
				for (int j = 0; j < 4; j++) {
					String row = tokenizer.nextToken();
					System.out.println(row);
					char[] charArray = row.toCharArray();
					for (int k = 0; k < 4; k++) {
						if (charArray[k] == '.') {
							board[j][k] = Symbol.EMPTY;
							emptyCells = true;
						} else {
							board[j][k] = Symbol.valueOf(String
									.valueOf(charArray[k]));
						}
					}
					String readLine = reader.readLine();
					if (readLine != null) {
						tokenizer = new StringTokenizer(readLine);
					}
				}

				// Solve Case
				String result;

				// Check diagonals
				boolean winner = true;
				boolean first = true;
				Symbol last = null;
				for (int j = 0; j < 4; j++) {
					if (first) {
						last = board[j][j];
						if (last == Symbol.EMPTY) {
							winner = false;
							break;
						}
						first = false;
					} else {
						if (board[j][j] == Symbol.EMPTY) {
							winner = false;
							break;
						}
						if (board[j][j] == last || board[j][j] == Symbol.T
								|| last == Symbol.T) {
							if (last == Symbol.T) {
								last = board[j][j];
							}
							continue;
						} else {
							winner = false;
							break;
						}
					}
				}
				if (winner) {
					result = last.toString() + " won";
				} else {
					winner = true;
					first = true;
					for (int j = 0; j < 4; j++) {
						if (first) {
							last = board[3 - j][j];
							if (last == Symbol.EMPTY) {
								winner = false;
								break;
							}
							first = false;
						} else {
							if (board[3 - j][j] == Symbol.EMPTY) {
								winner = false;
								break;
							}
							if (board[3 - j][j] == last
									|| board[3 - j][j] == Symbol.T
									|| last == Symbol.T) {
								if (last == Symbol.T) {
									last = board[3-j][j];
								}
								continue;
							} else {
								winner = false;
								break;
							}
						}
					}
				}

				if (winner) {
					result = last.toString() + " won";
				} else {
					// Check rows
					for (int j = 0; j < 4; j++) {
						first = true;
						winner = true;
						for (int k = 0; k < 4; k++) {
							if (first) {
								last = board[j][k];
								if (last == Symbol.EMPTY) {
									winner = false;
									break;
								}
								first = false;
							} else {
								if (board[j][k] == Symbol.EMPTY) {
									winner = false;
									break;
								}
								if (board[j][k] == last
										|| board[j][k] == Symbol.T
										|| last == Symbol.T) {
									if (last == Symbol.T) {
										last = board[j][k];
									}
									continue;
								} else {
									winner = false;
									break;
								}
							}
						}
						if (winner) {
							break;
						}
					}

					if (winner) {
						result = last.toString() + " won";
					} else {
						// Check columns
						for (int j = 0; j < 4; j++) {
							first = true;
							winner = true;
							for (int k = 0; k < 4; k++) {
								if (first) {
									last = board[k][j];
									if (last == Symbol.EMPTY) {
										winner = false;
										break;
									}
									first = false;
								} else {
									if (board[k][j] == Symbol.EMPTY) {
										winner = false;
										break;
									}
									if (board[k][j] == last
											|| board[k][j] == Symbol.T
											|| last == Symbol.T) {
										if (last == Symbol.T) {
											last = board[k][j];
										}
										continue;
									} else {
										winner = false;
										break;
									}
								}
							}
							if (winner) {
								break;
							}
						}

						if (winner) {
							result = last.toString() + " won";
						} else {
							if (emptyCells) {
								result = "Game has not completed";
							} else {
								result = "Draw";
							}
						}
					}
				}

				try {
					dos.writeBytes("Case #" + (i + 1) + ": "
							+ result.toString().trim() + "\n");
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("Input file not found");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

	private enum Symbol {
		O, X, T, EMPTY;
	}
}
