package qualification;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashSet;
import java.util.Set;
import java.util.StringTokenizer;

public class AMain {

	private static final String INSOMNIA = "INSOMNIA";

	public static void main(String[] args) {
		String inputFileName = args[0];
		String outputFileName = args[1];
		BufferedReader reader = null;
		File outputfile = new File(outputFileName);
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(outputfile);
		} catch (FileNotFoundException e1) {
			System.err.println("Output file not found");
			System.exit(1);
		}

		DataOutputStream dos = new DataOutputStream(fos);
		try {
			reader = new BufferedReader(new FileReader(inputFileName));

			String numberOfCasesStr = reader.readLine(); // Number of cases
			int numberOfCases = Integer.valueOf(numberOfCasesStr); // Default: number of cases
			for (int i = 0; i < numberOfCases; i++) {
				System.out.println("Case #" + (i + 1));
				// Read Case
				StringTokenizer tokenizer = new StringTokenizer(reader.readLine());
				String nStr = tokenizer.nextToken();
				final Long n = Long.valueOf(nStr);

				// Solve Case
				String result = new String();
				String mStr = null;
				if (n.equals(0L)) {
					result = INSOMNIA;
				} else {
					Set<String> digits = new HashSet<>();
					int mult = 1;
					Long m = n;
					while (digits.size() < 10) {
						m = n * mult;
						mStr = m.toString();
						for (int j = 0; j < mStr.length(); j++) {
							digits.add(String.valueOf(mStr.charAt(j)));
						}
						mult++;
					}
					result = mStr;
				}
				

				try {
					dos.writeBytes("Case #" + (i + 1) + ": " + result.toString().trim() + "\n");
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("Input file not found");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

}
