package qualification;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.stream.IntStream;

public class DMain {

	private static final String IMPOSSIBLE = "IMPOSSIBLE";

	public static void main(String[] args) {
		String inputFileName = args[0];
		String outputFileName = args[1];
		BufferedReader reader = null;
		File outputfile = new File(outputFileName);
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(outputfile);
		} catch (FileNotFoundException e1) {
			System.err.println("Output file not found");
			System.exit(1);
		}

		DataOutputStream dos = new DataOutputStream(fos);
		try {
			reader = new BufferedReader(new FileReader(inputFileName));

			String numberOfCasesStr = reader.readLine(); // Number of cases
			int numberOfCases = Integer.valueOf(numberOfCasesStr); // Default:
																	// number of
																	// cases
			for (int i = 0; i < numberOfCases; i++) {
				System.out.println("Case #" + (i+1));
				// Read Case
				StringTokenizer tokenizer = new StringTokenizer(reader.readLine());

				// Solve Case
				StringBuilder resultBuilder = new StringBuilder();
				final Integer k = Integer.valueOf(tokenizer.nextToken());
				final Integer c = Integer.valueOf(tokenizer.nextToken());
				final Integer s = Integer.valueOf(tokenizer.nextToken());
				
				if (c.equals(1)) {
					if (s >= k) {
						IntStream.range(1, k + 1).forEach(n -> resultBuilder.append(n).append(" "));
					} else {
						resultBuilder.append(IMPOSSIBLE);
					}
				} else {
					// Complexity > 1
					int numOfTiles = (k % 2 == 0) ? k / 2 : (k / 2) + 1;
					if (s >= numOfTiles) {
						int currentIndex = (k / 2) + 1;
						for (int j = 0; j < numOfTiles; j++) {
							resultBuilder.append(currentIndex).append(" ");
							currentIndex += k + 1;
						}
					} else {
						resultBuilder.append(IMPOSSIBLE);
					}
				}

				try {
					dos.writeBytes("Case #" + (i+1) + ": " + resultBuilder.toString().trim() + "\n");
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("Input file not found");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}
}
