package qualification;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashSet;
import java.util.Random;
import java.util.Set;
import java.util.StringTokenizer;

public class CMain {

	public static void main(String[] args) {
		String inputFileName = args[0];
		String outputFileName = args[1];
		BufferedReader reader = null;
		File outputfile = new File(outputFileName);
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(outputfile);
		} catch (FileNotFoundException e1) {
			System.err.println("Output file not found");
			System.exit(1);
		}

		DataOutputStream dos = new DataOutputStream(fos);
		try {
			reader = new BufferedReader(new FileReader(inputFileName));

			String numberOfCasesStr = reader.readLine(); // Number of cases
			int numberOfCases = Integer.valueOf(numberOfCasesStr); // Default:
																	// number of
																	// cases
			for (int i = 0; i < numberOfCases; i++) {
				System.out.println("Case #" + (i + 1));
				// Read Case
				StringTokenizer tokenizer = new StringTokenizer(
						reader.readLine());
				int A = Integer.valueOf(tokenizer.nextToken());
				int B = Integer.valueOf(tokenizer.nextToken());

				// Solve Case
				int result = 0;

				if (A >= 10) {
					Set<Integer> paired = new HashSet<Integer>();
					for (int n = A; n <= B; n++) {
						if (!paired.contains(n)) {
							String nString = String.valueOf(n);
							int numOfDigits = nString.length();
							int numberOfRecycled = 0;
							for (int j = 0; j < numOfDigits - 1; j++) {
								String recycled = nString.substring(j + 1,
										numOfDigits)
										+ nString.substring(0, j + 1);
								int m = Integer.valueOf(recycled);
								if (!paired.contains(m)) {
									if (n >= A && m > n && B > m) {
										numberOfRecycled++;
										paired.add(m);
									}
								}

							}
							result += ((numberOfRecycled + 1) * (numberOfRecycled)) / 2;
							paired.add(n);
						}
					}
				}

				try {
					dos.writeBytes("Case #" + (i + 1) + ": " + result + "\n");
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		} catch (FileNotFoundException e) {
			System.out.println("Input file not found");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}
}
