
import java.io.*;
import java.util.*;
import java.math.*;
import static java.lang.Math.*;
import static java.lang.Integer.parseInt;
import static java.lang.Long.parseLong;
import static java.lang.Double.parseDouble;
import static java.lang.String.*;

public class Main {
    
    public static void main(String[] args) throws IOException {
        BufferedReader in = new BufferedReader//(new InputStreamReader(System.in));
                                           (new FileReader("B-large.in"));
        StringBuilder out = new StringBuilder();
        StringTokenizer tk; 
        PrintWriter pw = new PrintWriter("output.out", "UTF-8");
            
        String s;
        int i,ans;
        int tc = parseInt(in.readLine());
        for(int cnt=1; cnt<=tc; cnt++) {
            out.append("Case #").append(cnt).append(": ");
            
            ans = 0;
            s = in.readLine();
            
            while(!check(s)) {
                i=1;
                while(i<s.length() && s.charAt(i)==s.charAt(0))
                    i++;
                s = flip(s,i);
                ans++;
            }
            out.append(ans).append("\n");
        }
        
        //System.out.print(out);
        
        pw.print(out);
        pw.close();
    }
    
    static int BFS(String s) {
        Queue<state> q = new LinkedList<state>();
        q.add(new state(s,0));
        
        Set<String> vis = new HashSet<String>();
        vis.add(s);
        
        state st,ns;
        
        while(!q.isEmpty()) {
            st = q.remove();
            
            if(check(st.s)) return st.cost;
            
            for(int i=0; i<=st.s.length(); i++) {
                ns = new state(flip(st.s,i),st.cost+1);
                if(!vis.contains(ns.s)) {
                    vis.add(ns.s);
                    q.add(ns);
                }
            }
        }
        return -1;
    }
    
    static String flip(String s,int ind) {
        StringBuilder sb = new StringBuilder();
        
        for(int i=0; i<ind; i++) {
            sb.append(s.charAt(i)=='+' ? '-' : '+');
        }
        sb = sb.reverse();
        
        for(int i=ind; i<s.length(); i++)
            sb.append(s.charAt(i));
        
        return sb.toString();
    }
    
    static boolean check(String s) {
        for(int i=0; i<s.length(); i++)
            if(s.charAt(i)=='-')
                return false;
        return true;
    }
}

class state {
    String s;
    int cost;
    public state(String s,int c) {
        this.s = s;
        this.cost = c;
    }
}
