package yearOf2017;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Set;

public class PancakesK {

	public static void main(String[] args) throws IOException {
		FileReader inFile = new FileReader("yearOf2017/A-small-attempt0.in");
		File outFile = new File("yearOf2017/testOutput.txt");
		if (!outFile.exists()) {
		     outFile.createNewFile();
		  }
		
		BufferedReader reader = new BufferedReader(inFile);
		PrintWriter writer = new PrintWriter(outFile);
		
		int cases = Integer.parseInt(reader.readLine());
		int caseIdx = 1;
		
		while(caseIdx <= cases){
			String seq = reader.readLine();
			String[] input = seq.split(" ");
			
			String s = input[0];
			int K = Integer.valueOf(input[1]);
			
			if(s.indexOf('-') < 0){
				writer.println("Case #" + caseIdx + ": 0");
				caseIdx++;
				continue;
			}
			
			// check overlap part
			int len = s.length();
			if(len - K < K - 1 && s.substring(len-K, K).indexOf('-') > -1 && s.substring(len-K, K).indexOf('+') > -1){
				writer.println("Case #" + caseIdx + ": IMPOSSIBLE");
				caseIdx++;
				continue;
			}
			
			
			String result = bfs(s, K);
			writer.println("Case #" + caseIdx + ": " + result);
			
			caseIdx += 1;
		}
		
		writer.close();
		reader.close();
	}
	
	private static String bfs(String s, int K){
		int step = 0;
		Queue<String> queue = new LinkedList<>();
		queue.add(s);
		Set<String> visited = new HashSet<>();
		
		while(!queue.isEmpty()){
			int size = queue.size();
			
			for(int i = 0; i < size; i++){
				String curr = queue.poll();
				
				if(curr.indexOf('-') < 0){
					return step+"";
				}
				
				if(visited.add(curr)){
				    for(int start = 0; start <= curr.length() - K; start++){
					    String next = getFlip(curr, start, K);
					    if(!visited.contains(next)) queue.add(next);
				    }
				}
			}
			
			step++;
		}
		
		return "IMPOSSIBLE";
	
	}
	
	private static String getFlip(String s, int start, int k){
		char[] sArray = s.toCharArray();
		
		//flip
		for(int j = 0; j < k; j++ ){
			if(sArray[start+j] == '+') sArray[start+j] = '-';
			else sArray[start+j] = '+';
		}
		return getString(sArray);
	}
	
	private static String getString(char[] sArray){
		StringBuilder sb = new StringBuilder();
		for(char c : sArray){
			sb.append(c);
		}
		
		return sb.toString();
	}

}
