package yearOf2017;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

public class Cake {

	public static void main(String[] args) throws IOException {
		FileReader inFile = new FileReader("yearOf2017/A-small-attempt0.in");
		File outFile = new File("yearOf2017/testOutput.txt");
		if (!outFile.exists()) {
		     outFile.createNewFile();
		  }
		
		BufferedReader reader = new BufferedReader(inFile);
		PrintWriter writer = new PrintWriter(outFile);
		
		int cases = Integer.parseInt(reader.readLine());
		int caseIdx = 1;
		
		while(caseIdx <= cases){
			String[] matrix = reader.readLine().split(" ");
			int m = Integer.valueOf(matrix[0]);
			int n = Integer.valueOf(matrix[1]);
			
			char[][] cake = new char[m][n];
			List<Integer> emptyRows = new ArrayList<>();
			int i = 0;
			
			while(i < m){
				char pre = '-';
				String row = reader.readLine();
				for(int j = 0; j < n; j++){
					char c = row.charAt(j);
					
					if(c != '?'){
						cake[i][j] = c;
						if(pre == '-'){
							for(int k = 0; k < j; k++) cake[i][k] = c;
						}
						pre = c;
					}
					else if(c == '?' && pre != '-'){
						cake[i][j] = pre;
					}
					else if(c == '?' && pre == '-' && j == n-1) emptyRows.add(i);	
				}
				i++;
			}
			
			if(emptyRows.size() > 0){
				int start = 0;
				while(start < emptyRows.size() && emptyRows.get(start) == start) start++;
				
				if(start == 0){
					for(int r : emptyRows){
						for(int c = 0; c < n; c++){
							cake[r][c] = cake[r-1][c];
						}
					}
				}
				else{
					for(int r = start - 1; r >= 0; r--){
						for(int c = 0; c < n; c++){
							cake[r][c] = cake[r+1][c];
						}
					}
					
					for(int re = start; re < emptyRows.size(); re++){
						int ro = emptyRows.get(re);
						for(int c = 0; c < n; c++){
							cake[ro][c] = cake[ro-1][c];
						}
					}
				}
				
			}
			
			//Write result
			writer.println("Case #" + caseIdx + ":");
			for(int x = 0; x < m; x++){
				for(int y = 0; y < n-1; y++){
					writer.print(cake[x][y]);
				}
				writer.println(cake[x][n-1]);
			}
			
			caseIdx++;
			
		}
		
		reader.close();
		writer.close();

	}

}
