package yearOf2016;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;

public class CoinJam {
	public HashSet<int[]> nextNb(int[] toCheck, int N){
		HashSet<int[]> nb = new HashSet<>();
		for(int i = 0; i < N-1; i++){
			if(toCheck[i] == 0){
				int[] toAdd = toCheck.clone(); 
				toAdd[i] = 1;
				nb.add(toAdd);
			}
		}
		return nb;
	}
	
	public double[] checkCJ(int[] toCheck, int N){
		double[] result = new double[10];
		Arrays.fill(result, -1);
		for(int base = 2; base < 11; base++){
			double num = 0;
			for(int i = 0; i < N; i++){
				num += Math.pow(base, N-1 - i)*toCheck[i];				
			}
			
			result[0] = num;
			
			for(double d = 2; d <= Math.sqrt(num); d++){
				if(num % d == 0){
					result[base-1] = d;
					d = num;
				}
			}
			
			if(result[base-1] == -1){
				base = 11;
			}
		}
		
		return result;
	}
	
	public void run() throws IOException{
		File inFile = new File("yearOf2016/testInput.txt");
		File outFile = new File("yearOf2016/testOutput.txt");
		if (!outFile.exists()) {
		     outFile.createNewFile();
		}
		
		Scanner reader = new Scanner(inFile);
		PrintWriter writer = new PrintWriter(outFile);
		
		int cases = reader.nextInt();
		int caseIdx = 1;
		
		while(caseIdx <= cases){
			writer.println("Case #" + caseIdx + ": ");
			int N = reader.nextInt();
			int J = reader.nextInt();
			
			int[] num = new int[N];
			Arrays.fill(num, 0);
			num[0] = 1;
			num[N-1] = 1;
			
			Queue<int[]> candi = new LinkedList<>();
			candi.add(num);
			
			HashSet<Double> collect = new HashSet<>();
			
			while(J > 0 && !candi.isEmpty()){
				int[] toCheck = candi.poll();
				
				candi.addAll(nextNb(toCheck, N));
				
				double[] result = checkCJ(toCheck, N);
				boolean flag = true;
				
				for(int i = 1; i < 10; i++){
					if(result[i] == -1){
						flag = false;
					}
				}
				
				if(flag && collect.add(result[0])){
					for(int idx = 0; idx < N; idx++){
						writer.print(toCheck[idx]);
					}
					writer.print(" ");
					for(int j = 1; j < 10; j++){
						writer.print((int)result[j] + " ");
					}
					writer.println(" ");
					J -= 1;
				}
			}
			
			caseIdx += 1;
		}
		
		writer.close();
		reader.close();

	}

	public static void main(String[] args) throws IOException{
		CoinJam tester = new CoinJam();
		tester.run();
	}
	
}
