package yearOf2017;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;

public class Color {

	public static void main(String[] args) throws IOException {
		FileReader inFile = new FileReader("yearOf2017/B-small-attempt0.in");
		File outFile = new File("yearOf2017/testOutput.txt");
		if (!outFile.exists()) {
		     outFile.createNewFile();
		  }
		
		BufferedReader reader = new BufferedReader(inFile);
		PrintWriter writer = new PrintWriter(outFile);
		
		int cases = Integer.parseInt(reader.readLine());
		int caseIdx = 1; 
		
		char[] colorDict = new char[7];
		colorDict[1] = 'R';
		colorDict[2] = 'O';
		colorDict[3] = 'Y';
		colorDict[4] = 'G';
		colorDict[5] = 'B';
		colorDict[6] = 'V';
		
		while(caseIdx <= cases){
			String[] inData = reader.readLine().split(" ");
			HashMap<Integer, Integer> map = new HashMap<>();
			int N = Integer.valueOf(inData[0]);
			
			for(int i = 1; i<=6; i++){
				if(Integer.valueOf(inData[i]) != 0){
					map.put(i, Integer.valueOf(inData[i]));
				}
			}
			
			int colors = map.keySet().size();
			
			if((colors < 2 && N > 1) || (colors == 2 && N%2 != 0)){
				writer.println("Case #" + caseIdx + ": IMPOSSIBLE");
				caseIdx++;
				continue;
			}
			
			int maxCount = 0;
			int maxColor = 0;
			for(int i : map.keySet()){
				if(map.get(i) > maxCount){
					maxCount = map.get(i);
					maxColor = i;
				}
			}
			
			if(2*maxCount > N ){
				writer.println("Case #" + caseIdx + ": IMPOSSIBLE");
				caseIdx++;
				continue;
			}
			
			ArrayList<StringBuilder> list = new ArrayList<>();
			
			for(int i = 0; i < maxCount; i++){
				StringBuilder sb = new StringBuilder();
				sb.append(colorDict[maxColor]);
				list.add(sb);
			}
			map.remove(maxColor);
			
			int idx = 0;
			for(int cor : map.keySet()){
				int num = map.get(cor);
				while(num > 0){
					list.get(idx%maxCount).append(colorDict[cor]);
					idx++;
					num--;
				}
			}
			
			for(int i = 1; i < maxCount; i++){
				list.get(0).append(list.get(i));
			}
			
			
			writer.println("Case #" + caseIdx + ": " + list.get(0).toString());
			caseIdx++;
		}
		
		reader.close();
		writer.close();

	}

}
