package yearOf2017;

import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class TidyNum {

	public static void main(String[] args) throws IOException {
		FileReader inFile = new FileReader("yearOf2017/B-small-attempt1.in");
		File outFile = new File("yearOf2017/testOutput.txt");
		if (!outFile.exists()) {
		     outFile.createNewFile();
		  }
		
		Scanner reader = new Scanner(inFile);
		PrintWriter writer = new PrintWriter(outFile);
		
		int cases = reader.nextInt();
		int caseIdx = 1;
		
		while(caseIdx <= cases){
			int num = reader.nextInt();
			int tidy = getTidy(num);
			
			//int tidy2 = getTidy2(num);
			//if(tidy != tidy2) System.out.println(num + " " + tidy + " " +tidy2);
			
			writer.println("Case #" + caseIdx + ": " + tidy);
			caseIdx++;
		}
		
		reader.close();
		writer.close();

	}
	
	private static int getTidy(int n){
		String s = n+"";
		int len = s.length();
		if(len == 1) return n;
		
		int[] digits = new int[len];
		
		for(int i = 0; i < len; i++){
			digits[i] = s.charAt(i) - '0';
		}
		
		int start = 0;
		
		while(start < len - 1 && digits[start] <= digits[start+1]) start++;
		if(start == len - 1) return n;
		
		for(int j = start + 1; j < len; j++) digits[j] = 9;
		digits[start] -= 1;
		
		int curr = start;
		while(curr > 0 && digits[curr] < digits[curr-1]){
			digits[curr] = 9;
			curr--;
			digits[curr] -= 1;
		}
		
		StringBuilder sb = new StringBuilder();
		
		for(int i = 0; i < len; i++){
			if(digits[i] != 0) sb.append(digits[i]);
		}
		
		return Integer.valueOf(sb.toString());
	}
	
	private static int getTidy2(int n){
		int curr = n;
		while(!isTidy(curr)) curr--;
		return curr;
	}
	
	private static boolean isTidy(int n){
		if(n < 10) return true;
		String num = n +"";
		int len = num.length();
		
		int[] digits = new int[len];
		
		for(int i = 0; i < len; i++){
			digits[i] = num.charAt(i) - '0';
		}
		
		int start = 0;
		
		while(start < len - 1 && digits[start] <= digits[start+1]) start++;
		
		return start == len - 1;
	}

}
