package yearOf2017;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Collections;
import java.util.PriorityQueue;

public class Bathroom {

	public static void main(String[] args) throws IOException {
		FileReader inFile = new FileReader("yearOf2017/C-large.in");
		File outFile = new File("yearOf2017/testOutput.txt");
		if (!outFile.exists()) {
		     outFile.createNewFile();
		  }
		
		BufferedReader reader = new BufferedReader(inFile);
		PrintWriter writer = new PrintWriter(outFile);
		
		int cases = Integer.parseInt(reader.readLine());
		int caseIdx = 1;
		
		while(caseIdx <= cases){
			String[] nums = reader.readLine().split(" ");
			Long n = Long.valueOf(nums[0]);
			Long k = Long.valueOf(nums[1]);
			//Long[] result = getMaxMin(n, k);
			Long[] result2 = getMaxMin2(n,k);
			
			//if(!result[0].equals(result2[0]) || !result[1].equals(result2[1])){
			//	System.out.println(n + " " + k + ": " + result[0] + ", " + result[1] + " : " + result2[0] + ", " + result2[1]);
			//}

			writer.println("Case #" + caseIdx + ": " + result2[0] + " " + result2[1]);
			caseIdx++;
		}
		
		reader.close();
		writer.close();

	}
	
	private static Long[] getMaxMin(Long n, Long k){
		Long curr = k;
		PriorityQueue<Long> queue = new PriorityQueue<>(Collections.reverseOrder());
		queue.add(n);
		
		while(curr > 1 && queue.peek() > (long)1){
			Long space = queue.poll();
			queue.add(space/2);
			queue.add((space-1)/2);
			curr--;
		}
		
		Long currSpace = queue.poll();
		return new Long[]{currSpace/2, (currSpace-1)/2};
	}
	
	private static Long[] getMaxMin2(Long n, Long k){
		int powerK = getPower(k);
		int powerN = getPower(n);
		
		if(powerK == powerN) return new Long[] {0L,0L};
		
		Long upperBound = n;
		Long powerTwoK = 1L;
		for(int i = 0; i < powerK; i++){
			upperBound >>= 1;
		    powerTwoK <<= 1;
		}
		
		Long diff = k - powerTwoK + 1;
		
		Long upperCount = n - (upperBound * powerTwoK) + 1;
		
		if(diff > upperCount) upperBound = Math.max(upperBound - 1, 0);
		Long lowerBound = Math.max(upperBound - 1, 0);
		
		return new Long[]{upperBound/2, lowerBound/2};
		
	}
	
	private static int getPower(Long n){
		Long nCopy = n;
		int power = 0;
		while(nCopy > 1){
			nCopy >>= 1;
			power++;
		}
		
		return power;
	}

}
