import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintStream;

public class FairAndSquare {

	private byte[] getDigits(double x) {
		String tmp = Double.toString(x).split("\\.")[0];
		byte[] result = new byte[tmp.length()];
		for (int i = 0; i < result.length; i++) {
			result[i] = (byte) (tmp.charAt(i) - 48);
		}
		return result;
	}

	private double buildDouble(byte[] digits) {
		double result = 0;
		for (int i = 0; i < digits.length; i++) {
			result = (result * 10) + digits[i];
		}
		return result;
	}

	public double getFirstPalIn(double x, double y) {
		byte[] digits = getDigits(x);
		for (int i = 0; i < digits.length / 2; i++) {
			digits[digits.length - i - 1] = digits[i];
		}
		double attempt = buildDouble(digits);
		int length = digits.length;
		digits = null;
		if (attempt <= y) {
			if (attempt >= x) {
				return attempt;
			} else {
				for (int i = 0; i < length / 2; i++) {
					attempt = attempt / 10;
				}
				attempt = (attempt + 1);
				attempt=buildDouble(getDigits(attempt));
				for (int i = 0; i < length / 2; i++) {
					attempt = attempt * 10;
				}
				return (getFirstPalIn(attempt, y));
			}

		} else {
			return -1;
		}
	}


	public boolean isPal(double x) {
		byte[] digits = getDigits(x);
		for (int i = 0; i < digits.length / 2; i++) {
			if (digits[i] != digits[digits.length - i - 1]) {
				return false;
			}
		}
		return true;
	}

	public int solve(double x, double y) {
		int result = 0;
		x = Math.sqrt(x);
		y = Math.sqrt(y);
		double current = getFirstPalIn(x, y);
		while (current != -1) {
			if (isPal(current * current)) {
				result++;
			}
			current = getFirstPalIn(current + 1, y);
		}
		return result;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {

			BufferedReader reader = new BufferedReader(new FileReader(new File(
					"C-small-attempt0.in")));
			int length = Integer.parseInt(reader.readLine());

			double[][] input = new double[length][2];
			for (int i = 0; i < length; i++) {
				String[] limits = reader.readLine().split(" ");
				input[i][0]=Double.parseDouble(limits[0]);
				input[i][1]=Double.parseDouble(limits[1]);
			}
			reader.close();

			FairAndSquare solver = new FairAndSquare();

			PrintStream output = new PrintStream("out.txt");

			for (int i = 0; i < input.length; i++) {
				output.println("Case #" + (i + 1) + ": " + solver.solve(input[i][0], input[i][1]));
			}
			output.close();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		
		
		
	}

}
