import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintWriter;

public class Minesweeper {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			BufferedReader reader = new BufferedReader(new FileReader(new File(
					"C-small-attempt2.in")));
			int length = Integer.parseInt(reader.readLine());
			Minesweeper[] boards = new Minesweeper[length];
			Minesweeper tmp = null;
			String[] str;
			for (int i = 0; i < length; i++) {
				tmp = new Minesweeper();
				str = reader.readLine().split(" ");
				tmp.R = Integer.parseInt(str[0]);
				tmp.C = Integer.parseInt(str[1]);
				tmp.M = Integer.parseInt(str[2]);
				boards[i] = tmp;
			}
			reader.close();

			PrintWriter output = new PrintWriter("out.txt");

			for (int i = 0; i < boards.length; i++) {
				output.println("Case #" + (i + 1) + ": ");
				output.println(boards[i].solve());
			}
			output.close();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	int R = 0;
	int C = 0;
	int M = 0;

	public String solve() {
		int tot = R * C;
		int fullRows = M / C;
		int mines = M % C;
		if (M > tot) {
			return "Impossible";
		} else {
			if (M == tot - 1) {
				StringBuffer result = new StringBuffer();
				for(int i=0;i<R-1;i++){
					for(int j=0;j<C;j++){
						result.append("*");
					}
					result.append("\n");
				}
				for(int j=0;j<C-1;j++){
					result.append("*");
				}
				result.append("c");
				return result.toString();
			} else {
				if (fullRows > R - 2) {
					fullRows = R - 2;
					mines = M - (fullRows * C);
				}
				StringBuffer result = new StringBuffer();
				if (fullRows == R - 2) {
					if (mines != 0) {
						if (mines % 2 != 0) {
							return "Impossible";
						} else {
							int line = mines / 2;
							if (line > C - 2) {
								return "Impossible";
							}
							for (int i = 0; i < fullRows; i++) {
								for (int j = 0; j < C; j++) {
									result.append("*");
								}
								result.append("\n");
							}
							for (int j = 0; j < line; j++) {
								result.append("*");
							}
							for (int j = 0; j < C - line; j++) {
								result.append(".");
							}
							result.append("\n");

							for (int j = 0; j < line; j++) {
								result.append("*");
							}
							for (int j = 0; j < C - line - 1; j++) {
								result.append(".");
							}
							result.append("c");
						}
					} else {
						// Riempi tutte le righe e clicca in basso a destra
						for (int i = 0; i < fullRows; i++) {
							for (int j = 0; j < C; j++) {
								result.append("*");
							}
							result.append("\n");
						}
						for (int i = 0; i < R - fullRows - 1; i++) {
							for (int j = 0; j < C; j++) {
								result.append(".");
							}
							result.append("\n");
						}
						for (int j = 0; j < C - 1; j++) {
							result.append(".");
						}
						result.append("c");
					}
				} else {
					if (mines == C - 1) {
						// Lascia due buchi in fondo e metti l'ultima a capo
						for (int i = 0; i < fullRows; i++) {
							for (int j = 0; j < C; j++) {
								result.append("*");
							}
							result.append("\n");
						}

						for (int j = 0; j < C - 2; j++) {
							result.append("*");
						}
						int added=0;
						if(C>2){
							result.append("..\n*");
							added=2;
						}else{
							result.append("*");
							added=1;
						}
						for (int j = 0; j < C - 1; j++) {
							result.append(".");
						}
						result.append("\n");

						for (int i = 0; i < R - fullRows - added -1; i++) {
							for (int j = 0; j < C; j++) {
								result.append(".");
							}
							result.append("\n");
						}
						for (int j = 0; j < C - 1; j++) {
							result.append(".");
						}
						result.append("c");

					} else {
						// Riempi l'ultima riga fin che puoi.
						for (int i = 0; i < fullRows; i++) {
							for (int j = 0; j < C; j++) {
								result.append("*");
							}
							result.append("\n");
						}

						for (int j = 0; j < mines; j++) {
							result.append("*");
						}
						for (int j = 0; j < C - mines; j++) {
							result.append(".");
						}
						result.append("\n");

						for (int i = 0; i < R - fullRows - 2; i++) {
							for (int j = 0; j < C; j++) {
								result.append(".");
							}
							result.append("\n");
						}
						for (int j = 0; j < C - 1; j++) {
							result.append(".");
						}
						result.append("c");
					}
				}

				return result.toString();
			}
		}
	}
}
