import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.mathIT.numbers.BigNumbers;

import com.google.common.collect.Collections2;
import com.google.common.io.LineReader;

public class B {

	public static void main(String[] args) throws NumberFormatException,
			IOException {
//		String input = "tst.txt";
		 String input = "C-small-attempt1.in";
		// String input = "B-large.in";

		String output = "out.txt";
		PrintWriter writer = new PrintWriter(output);

		// parse input
		LineReader lineReader = new LineReader(new FileReader(input));

		int testCount = Integer.parseInt(lineReader.readLine());
		for (int i = 0; i < testCount; i++) {
			writer.print("Case #" + (i + 1) + ": ");
			System.out.print("Case #" + (i + 1) + ": ");
			solve(lineReader, writer);
		}

		writer.close();
	}

	private static void solve(LineReader lineReader, PrintWriter writer)
			throws IOException {
		String[] fst = lineReader.readLine().split(" ");
		int playersCnt = Integer.parseInt(fst[0]);
		BigInteger lowTone = new BigInteger(fst[1]);
		BigInteger highTone = new BigInteger(fst[2]);

		String[] snd = lineReader.readLine().split(" ");
		List<BigInteger> tones = new ArrayList<BigInteger>();
		for (String s : snd) {
			tones.add(new BigInteger(s));
		}

		Collections.sort(tones);
		Collections.reverse(tones);

		BigInteger lcm = BigInteger.ONE;
		Set<BigInteger> res = new HashSet<BigInteger>();

		for (BigInteger bi : tones) {
			List<BigInteger> dec = primeDecomp(bi);
			if (dec == null) {
				continue;
			}

			res.addAll(dec);

			BigInteger partRes = BigInteger.ONE;
			for (BigInteger i : res) {
				partRes = partRes.multiply(i);
			}

			if (partRes.compareTo(highTone) > 0) {
				writer.println("NO");
				System.out.println("NO");
				return;
			}
		}

		BigInteger partRes = BigInteger.ONE;
		for (BigInteger i : res) {
			partRes = partRes.multiply(i);
		}

		if (lowTone.compareTo(partRes) > 0) {
			BigInteger[] arr = lowTone.divideAndRemainder(partRes);
			BigInteger d = arr[0];
			if (!arr[1].equals(BigInteger.ZERO)) {
				d.add(BigInteger.ONE);
			}
			partRes = d.multiply(partRes);
			
			if (partRes.compareTo(highTone) > 0 || partRes.compareTo(lowTone) > 0) {
				writer.println("NO");
				System.out.println("NO");
				return;
			}
		}

		writer.println(partRes.toString());
		System.out.println(partRes.toString());
	}

	private static final BigInteger two = BigInteger.valueOf(2);

	public static List<BigInteger> primeDecomp(BigInteger a) {
		// impossible for values lower than 2
		if (a.compareTo(two) < 0) {
			return null;
		}

		// quickly handle even values
		List<BigInteger> result = new ArrayList<BigInteger>();
		while (a.and(BigInteger.ONE).equals(BigInteger.ZERO)) {
			a = a.shiftRight(1);
			result.add(two);
		}

		// left with odd values
		if (!a.equals(BigInteger.ONE)) {
			BigInteger b = BigInteger.valueOf(3);
			while (b.compareTo(a) < 0) {
				if (b.isProbablePrime(10)) {
					BigInteger[] dr = a.divideAndRemainder(b);
					if (dr[1].equals(BigInteger.ZERO)) {
						result.add(b);
						a = dr[0];
					}
				}
				b = b.add(two);
			}
			result.add(b); // b will always be prime here...
		}
		return result;
	}

}
