import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.io.FileUtils;

public class ProblemA {

	public static void main(String[] args) throws IOException {
	
//		.10
//		0.1
//		10.
//		Case c = new Case(3);
//		c.matrix = new Integer[][] {{null, 1, 0}, {0, null, 1}, {1, 0, null}};
//		c.solve();
		
//		.11.
//		0.00
//		01.1
//		.10.
//		Case c1 = new Case(4);
//		c1.matrix = new Integer[][] {{null, 1, 1, null}, {0, null, 0, 0}, {0, 1, null, 1}, {null, 1, 0, null}};
//		c1.solve();
		
		List<String> lines = FileUtils.readLines(new File(args[0]));
		int n = Integer.parseInt(lines.get(0));
		int line = 1;
		for (int i = 0; i < n; i++) {
			System.out.println("Case #" + (i + 1) + ":");
			int size = Integer.parseInt(lines.get(line));
			line++;
			Case c = new Case(size);
			Integer[][] matrix = new Integer[size][size];
			for (int j = 0; j < size; j++) {
				Integer[] m = new Integer[size];
				for (int k = 0; k < size; k++) {
					if (lines.get(line).charAt(k) == '1') {
						m[k] = 1;
					} else if (lines.get(line).charAt(k) == '0') {
						m[k] = 0;
					}
				}
				matrix[j] = m;
				line++;
			}
			c.matrix = matrix;
			c.solve();
//			line += size;
		}
		
	}

	
}

class Case {
	int size;
	Integer[][] matrix;
	Integer[] oponents;
	Double[] wp;
	Double[] owpRowWin;
	Double[] owpRowLose;
	Double[] owp;
	Double[] oowp;

	Case(int size) {
		this.size = size;
		this.oponents = new Integer[size];
		this.wp = new Double[size];
		this.owpRowWin = new Double[size];
		this.owpRowLose = new Double[size];
		this.owp = new Double[size];
		this.oowp = new Double[size];
		
		for (int i = 0; i < size; i++) {
			this.oponents[i] = 0;
			this.wp[i] = 0.0;
			this.wp[i] = 0.0;
			this.owpRowWin[i] = 0.0;
			this.owpRowLose[i] = 0.0;
			this.owp[i] = 0.0;
			this.oowp[i] = 0.0;
		}
	}
	
	void solve() {
		for (int row = 0; row < size; row++) {
			for (int col = 0; col < size; col++) {
				if (matrix[row][col] != null) {
					wp[row] += matrix[row][col];
					oponents[row]++;
				}
			}
			owpRowWin[row] = (wp[row] - 1) / (oponents[row] - 1);
			owpRowLose[row] = wp[row] / (oponents[row] - 1);
			// row lose -> owp = wp
			wp[row] /= oponents[row];
		}
		
		for (int r = 0; r < size; r++) {
			//RPI = 0.25 * WP + 0.50 * OWP + 0.25 * OOWP
			for (int c = 0; c < size; c++) {
				if (matrix[r][c] != null && matrix[r][c] == 1) {
					owp[r] += owpRowLose[c]; 
				} else if (matrix[r][c] != null && matrix[r][c] == 0) {
					owp[r] += owpRowWin[c];
				}
			}
			owp[r] /= oponents[r];
		}
		
		for (int r = 0; r < size; r++) {
			//RPI = 0.25 * WP + 0.50 * OWP + 0.25 * OOWP
			for (int c = 0; c < size; c++) {
				if (matrix[r][c] != null) {
					oowp[r] += owp[c]; 
				}
			}
			oowp[r] /= oponents[r];
		}
		
		for (int r = 0; r < size; r++) {
			System.out.println(0.25* (wp[r] + 2* owp[r] + oowp[r]));
		}
	}
}
