import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.Stack;

import org.apache.commons.io.FileUtils;

public class Magics {
	final static int SIZE = 'Z' - 'A' + 1;

	public static void main(String[] args) {
//		Input input1 = new Input();
//		input1.combining[pos('Q')][pos('F')] = 'T';
//		input1.combining[pos('F')][pos('Q')] = 'T';
//		input1.opposing[pos('R')] = 'F';
//		input1.opposing[pos('F')] = 'R';
//		input1.input = "QF";
//		input1.input = "QEF";
//		input1.input = "RFE";
//		input1.input = "REF";
//		input1.input = "RQF";
//		input1.input = "RFQ";
		
		try {
			List<String> lines = FileUtils.readLines(new File(args[0]));
			for (int i = 1; i < lines.size(); i++) {
				System.out.println("Case #" + i + ": " + compute(parse(lines.get(i))).toString());
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private static Input parse(String line) {
		Input result = new Input();
		String[] items = line.split(" ");
		
		int combNum = Integer.parseInt(items[0]);
		for (int i = 0; i < combNum; i++) {
			String comb = items[i + 1];
			result.combining[pos(comb.charAt(0))][pos(comb.charAt(1))] = comb.charAt(2);
			result.combining[pos(comb.charAt(1))][pos(comb.charAt(0))] = comb.charAt(2);
		}
		
		int opNum = Integer.parseInt(items[combNum + 1]);
		for (int i = 0; i < opNum; i++) {
			String op = items[i + combNum + 2];
			result.opposing[pos(op.charAt(0))] = op.charAt(1);
			result.opposing[pos(op.charAt(1))] = op.charAt(0);
		}
		
		result.input = items[combNum + opNum + 3];
		
		return result;
	}

	static int pos(char c) {
		return c - 'A';
	}

	static Stack<Character> compute(Input input) {
		Stack<Character> result = new Stack<Character>();
		int[] charsInResult = new int[SIZE];

		for (int i = 0; i < input.input.length(); i++) {
			char c = input.input.charAt(i);

			result.push(c);
			charsInResult[pos(c)]++;

			// combining
			while (true) {
				if (result.size() > 1) {
					char top = result.pop();
					char underTop = result.pop();

					char combined = input.combining[pos(top)][pos(underTop)];
					if (combined != 0) {
						result.push(combined);
						charsInResult[pos(combined)]++;
						charsInResult[pos(top)]--;
						charsInResult[pos(underTop)]--;
					} else {
						result.push(underTop);
						result.push(top);
						break;
					}
				} else {
					break;
				}
			}

			// opposing
			if (result.size() > 1) {
				char opposingToTop = input.opposing[pos(result.peek())];
				if (opposingToTop != 0 && charsInResult[pos(opposingToTop)] != 0) {
					// clean
					for (int j = 0; j < charsInResult.length; j++) {
						charsInResult[j] = 0;
					}
					result.clear();
				} 
			}
		}

		return result;
	}
}

class Input {
	char[] opposing = new char[Magics.SIZE];
	char[][] combining = new char[Magics.SIZE][Magics.SIZE];
	String input;
};
