import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.io.FileUtils;

public class Robots {

	public static int compute(List<RobotButton> list) {
		int bluePos = 1;
		int redPos = 1;
		int blueLastPushTime = 0;
		int redLastPushTime = 0;
		boolean lastMoveBlue = list.get(0).blueRobot;

		for (RobotButton item : list) {
			int time = 1;

			if (item.blueRobot) {
				int dist = Math.abs(bluePos - item.button);
				if (lastMoveBlue == item.blueRobot) {
					time += dist;
				} else {
					time += Math.max(dist, redLastPushTime - blueLastPushTime);
				}

				bluePos = item.button;
				blueLastPushTime += time;
			} else {
				int dist = Math.abs(redPos - item.button);
				if (lastMoveBlue == item.blueRobot) {
					time += dist;
				} else {
					time += Math.max(dist, blueLastPushTime - redLastPushTime);
				}

				redPos = item.button;
				redLastPushTime += time;
			}

			lastMoveBlue = item.blueRobot;
		}

		return Math.max(redLastPushTime, blueLastPushTime);
	}

	public static void main(String[] args) {
		// O 2 B 1 B 2 O 4
		// List<RobotButton> list = new ArrayList<RobotButton>();
		// list.add(new RobotButton(false, 2));
		// list.add(new RobotButton(true, 1));
		// list.add(new RobotButton(true, 2));
		// list.add(new RobotButton(false, 4));

		// O 5 O 8 B 100
		// List<RobotButton> list = new ArrayList<RobotButton>();
		// list.add(new RobotButton(false, 5));
		// list.add(new RobotButton(false, 8));
		// list.add(new RobotButton(true, 100));

		// B 2 B 1
		// List<RobotButton> list = new ArrayList<RobotButton>();
		// list.add(new RobotButton(true, 2));
		// list.add(new RobotButton(true, 1));

		List<RobotButton> list;
		try {
			List<String> lines = FileUtils.readLines(new File(args[0]));
			for (int i = 1; i < lines.size(); i++) {
				System.out.println("Case #" + i + ": " + compute(parse(lines.get(i))));
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private static List<RobotButton> parse(String line) {
		List<RobotButton> result = new ArrayList<RobotButton>();
		String[] chars = line.split(" ");
		for (int j = 1; j < chars.length; j += 2) {
			result.add(new RobotButton(chars[j].equals("B"), Integer
					.parseInt(chars[j + 1])));
		}
		return result;
	}
}

class RobotButton {
	public RobotButton(boolean blueRobot, int button) {
		this.blueRobot = blueRobot;
		this.button = button;
	}

	boolean blueRobot;
	int button;
}
