package gcj;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.LinkedList;

import com.google.common.base.Charsets;
import com.google.common.io.Files;

public class A {
	public static void main(String[] args) throws IOException {
		new A().compute(args[0]);
	}

	private void compute(String inputFile) throws IOException {
		LinkedList<String> lines = new LinkedList<String>(Arrays.asList(Files.toString(new File(inputFile), Charsets.UTF_8).split("\r?\n")));
		
		int t = Integer.parseInt(lines.pop());
		
		for (int i = 0; i < t; i++) {
			char[][] input = parse(lines);
			String result = getResult(input);
			System.out.println("Case #" + (i + 1) +  ": " + result);
			if (!lines.isEmpty()) {
				lines.pop();
			}
		}
	}

	private String getResult(char[][] input) {
		if (playerWon('X', input)) {
			return "X won";
		}
		if (playerWon('O', input)) {
			return "O won";
		}
		if (boardFull(input)) {
			return "Draw";
		}
		
		return "Game has not completed";
	}

	private boolean boardFull(char[][] input) {
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				if (input[i][j] == '.') {
					return false;
				}
			}
		}
		return true;
	}

	private boolean playerWon(char player, char[][] input) {
		for (int i = 0; i < 4; i++) {
			if (winPosition(player, input[0][i], input[1][i], input[2][i], input[3][i])) {
				return true;
			}
			
			if (winPosition(player, input[i][0], input[i][1], input[i][2], input[i][3])) {
				return true;
			}
		}
		
		if (winPosition(player, input[0][0], input[1][1], input[2][2], input[3][3])) {
			return true;
		}
		
		if (winPosition(player, input[3][0], input[2][1], input[1][2], input[0][3])) {
			return true;
		}
		
		return false;
	}
	
	

	private boolean winPosition(char player, char... input) {
		for (int c : input) {
			if (c != player && c != 'T') {
				return false;
			}
		}
		return true;
	}

	private char[][] parse(LinkedList<String> lines) {
		char[][] result = new char[4][4];
		for (int i = 0; i < 4; i++) {
			result[i] = lines.pop().toCharArray();
		}
		return result;
	}
}
