package googlecodejam;

import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.Arrays;

public class LawnMower {

	/**
	 * 
	 */
	public static void main(String[] args) throws IOException{
		String[] solution = solve();
		printOutAnswers(solution);
	}
	public static String[] solve(){
		Scanner k = new Scanner(System.in);
		int testCases = k.nextInt();
		k.nextLine();
		
		
		String[] solution = new String[testCases];
		
		for (int x = 1; x <= testCases; x++)
		{
			int n = k.nextInt();
			int m = k.nextInt();
			int[][] lawn = new int[n][m];
			int[] largeVals = new int[n*m];
			for (int a=0; a<n; a++)
			{
				for (int b=0; b<m; b++)
				{
					lawn[a][b]=k.nextInt();
					largeVals[a*m + b] = lawn[a][b];
				}
				k.nextLine();
			}
			
			Arrays.sort(largeVals);
			for (int a = 0; a < largeVals.length/2; a++)
			{
				int temp = largeVals[a];
				largeVals[a] = largeVals[largeVals.length-a-1];
				largeVals[largeVals.length-a-1] = temp;
			}
			
			int[][] currentLawn = resetLawn(n,m, largeVals[0]);
			
			int prev=1000;
			
			for (int a = 0; a < largeVals.length; a++)
			{
				if (largeVals[a]!= prev)
				{
					currentLawn = changeVertical(currentLawn, lawn, n, m, largeVals[a]);
					currentLawn = changeHorizontal(currentLawn, lawn, n, m, largeVals[a]);
				}
				prev = largeVals[a];
			}
		
			boolean result = compareLawns(lawn, currentLawn, n, m);
			
			if (result)
			{
				solution[x-1] = "Case #" + x + ": YES";
			}
			else
				solution[x-1] = "Case #" + x + ": NO";
		}
		return solution;
	}
	public static int[][] resetLawn(int n, int m, int largeVal)
	{
		int[][] currentLawn = new int[n][m];
		for (int a=0; a<n; a++)
		{
			for (int b=0; b<m; b++)
			{
				currentLawn[a][b]=largeVal;
			}
		}
		return currentLawn;
	}
	public static int[][] changeVertical(int[][] currentLawn,int[][] desiredLawn, int n, int m, int largeVal)
	{
		boolean rowCheck;
		for(int c=0; c<m; c++)
		{
			rowCheck = false;
			if (desiredLawn[0][c]<=largeVal)
			{
				rowCheck = true;
				for (int d=0; d<n-1; d++)
				{
					if(desiredLawn[d+1][c]>largeVal)
					{
						rowCheck = false;
						break;
					}
				}
			}
			
			if (rowCheck)
			{
				for (int d=0; d<n; d++)
				{
					if(currentLawn[d][c]>largeVal)
					{
						currentLawn[d][c]=largeVal;
					}
				}
			}		
		}
		return currentLawn;
	}
	public static int[][] changeHorizontal(int[][] currentLawn, int[][] desiredLawn, int n, int m, int largeVal)
	{
		boolean rowCheck;
		for(int c=0; c<n; c++)
		{
			rowCheck = false;
			if (desiredLawn[c][0]<=largeVal)
			{
				rowCheck = true;
				for (int d=0; d<m-1; d++)
				{
					if(desiredLawn[c][d+1]>largeVal)
					{
						rowCheck = false;
						break;
					}
				}
			}
			if (rowCheck)
			{
				for (int d=0; d<m; d++)
				{
					if(currentLawn[c][d]>largeVal)
					{
						currentLawn[c][d]=largeVal;
					}
				}
			}		
		}
		return currentLawn;
	}
	public static boolean compareLawns(int[][]lawn, int[][]currentLawn, int n, int m)
	{
		boolean compare=true;
		
		for (int a=0; a<n; a++)
		{
			for (int b=0; b<m; b++)
			{
				if (lawn[a][b]!=currentLawn[a][b])
				{
					compare = false;
					break;
				}
			}
		}
		return compare;
	}
	public static void printOutAnswers(String[] solution) throws IOException
	{
		//print out caseStorer and write to a file
		PrintWriter out = new PrintWriter(new FileWriter("/Users/davidlong"+
		"/Desktop/javaoutputs/lawnMowerLarge.txt"));
		
		for (int x = 0; x < solution.length; x++)
		{
			out.println(solution[x]);
			System.out.println(solution[x]);
		}
		
		out.close();
	}
}

