package googlecodejam;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;
public class TicTacToe {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException{
		Scanner k = new Scanner(System.in);
		int testCases = k.nextInt();
		k.nextLine();
		int[][] board = new int[4][4];
		
		String[] answer = new String[testCases];
		
		for (int x = 1; x <= testCases; x++)
		{
			board = new int[4][4];
			String line;
			char letter;
			boolean isDot = false;
			boolean isT = false;
			int xPosOfT=0, yPosOfT=0;
			
			for (int a = 0; a <= 3; a++)
			{
				line = k.nextLine();
				for (int b = 0; b <=3; b++)
				{
					letter = line.charAt(b);
					
					if (letter == '.')
					{
						board[a][b] = 0;
						isDot = true;
					}
					else if (letter == 'X')
					{
						board[a][b] = 1;
					}
					else if (letter == 'O')
					{
						board[a][b] = 2;
					}
					else if (letter == 'T')
					{
						board[a][b] = 3;
						xPosOfT = a;
						yPosOfT = b;
						isT = true;
					}	
				}
			}
			k.nextLine();
			char status = checkWin(board, isT, xPosOfT, yPosOfT);
			if (status == '.' && !isDot)
				answer[x-1] = "Case #" + x + ": Draw";
			else if (status == '.' && isDot)
				answer[x-1] = "Case #" + x + ": Game has not completed";
			else if (status == 'X')
				answer[x-1] = "Case #" + x + ": X won";
			else if (status == 'O')
				answer[x-1] = "Case #" + x + ": O won";
		}
		
		printOutAnswers(answer);
	}
	public static char checkWin(int[][] board,boolean isT, int xPos, int yPos)
	{
		int winner=0;
		char ans;
		
		for (int a = 0; a<=3; a++)
		{
			if (board[a][1]==board[a][2] &&
				board[a][1]==board[a][3] &&
				board[a][1]==board[a][0] &&
				(board[a][1]==1 || board[a][1]==2))
			{
				winner = board[a][1];
				break;
			}
		}
		for (int a = 0; a<=3; a++)
		{
			if (board[1][a]==board[2][a] &&
				board[1][a]==board[3][a] &&
				board[1][a]==board[0][a] &&
				(board[1][a]==1 || board[1][a]==2))
			{
				winner = board[1][a];
				break;
			}
		}
		if (board[0][0]==board[1][1] &&
				board[1][1]==board[2][2] &&
				board[2][2]==board[3][3] &&
				(board[1][1]==1 || board[1][1]==2))
			{
				winner = board[1][1];
			}
		else if (board[3][0]==board[2][1] &&
				board[2][1]==board[1][2] &&
				board[1][2]==board[0][3] &&
				(board[3][0]==1 || board[3][0]==2))
			{
				winner = board[3][0];
			}
		
		if (isT)
		{
			if (board[(xPos+1)%4][yPos]==board[(xPos+2)%4][yPos] &&
				board[(xPos+1)%4][yPos]==board[(xPos+3)%4][yPos] &&
				(board[(xPos+1)%4][yPos]==1 || board[(xPos+1)%4][yPos]==2))
				winner = board[(xPos+1)%4][yPos];
			else if (board[xPos][(yPos+1)%4]==board[xPos][(yPos+2)%4] &&
					board[xPos][(yPos+1)%4]==board[xPos][(yPos+3)%4] &&
					(board[xPos][(yPos+1)%4]==1 || board[xPos][(yPos+1)%4]==2))
					winner = board[xPos][(yPos+1)%4];
			if (xPos == yPos)
			{
				if (board[(xPos+1)%4][(yPos+1)%4]==board[(xPos+2)%4][(yPos+2)%4] &&
					board[(xPos+1)%4][(yPos+1)%4]==board[(xPos+3)%4][(yPos+3)%4] &&
					(board[(xPos+1)%4][(yPos+1)%4]==1 || board[(xPos+1)%4][(yPos+1)%4]==2))
					winner = board[(xPos+1)%4][(yPos+1)%4];
			}
			
			if (xPos + yPos ==3)
			{
				int pos1 = (yPos-1)%4;
				if (pos1<0) pos1 += 4;
				int pos2 = (yPos-2)%4;
				if (pos2<0) pos2 += 4;
				int pos3 = (yPos-3)%4;
				if (pos3<0) pos3 += 4;
			
				if (board[(xPos+1)%4][pos1]==board[(xPos+2)%4][pos2] &&
					board[(xPos+1)%4][pos1]==board[(xPos+3)%4][pos3] &&
					(board[(xPos+1)%4][pos1]==1 || board[(xPos+1)%4][pos1]==2))
					winner = board[(xPos+1)%4][pos1];
			}
		}
		
		if (winner == 1)
		{
			ans = 'X';
		}
		else if (winner == 2)
		{
			ans = 'O';
		}
		else
			ans = '.';
			
		return ans;	
	}
	public static void printOutAnswers(String[] solution) throws IOException
	{
		//print out caseStorer and write to a file
		PrintWriter out = new PrintWriter(new FileWriter("/Users/davidlong"+
		"/Desktop/javaoutputs/tictactoe.txt"));
		
		for (int x = 0; x < solution.length; x++)
		{
			out.println(solution[x]);
			System.out.println(solution[x]);
		}
		
		out.close();
	}
}
