package googlecodejam;

import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class LawnMowerSmall {

	/**
	 * 
	 */
	public static void main(String[] args) throws IOException{
		String[] solution = solve();
		printOutAnswers(solution);
	}
	public static String[] solve(){
		Scanner k = new Scanner(System.in);
		int testCases = k.nextInt();
		k.nextLine();
		
		String[] solution = new String[testCases];
		
		for (int x = 1; x <= testCases; x++)
		{
			int n = k.nextInt();
			int m = k.nextInt();
			int[][] lawn = new int[n][m];
			for (int a=0; a<n; a++)
			{
				for (int b=0; b<m; b++)
				{
					lawn[a][b]=k.nextInt();
				}
				k.nextLine();
			}
			
			int[][] currentLawn = resetLawn(n,m);
			
			currentLawn = changeVertical(currentLawn, lawn, n, m);
			currentLawn = changeHorizontal(currentLawn, lawn, n, m);
			
			boolean result = compareLawns(lawn, currentLawn, n, m);
			
			if (result)
			{
				solution[x-1] = "Case #" + x + ": YES";
			}
			else
				solution[x-1] = "Case #" + x + ": NO";
		}
		return solution;
	}
	public static int[][] resetLawn(int n, int m)
	{
		int[][] currentLawn = new int[n][m];
		for (int a=0; a<n; a++)
		{
			for (int b=0; b<m; b++)
			{
				currentLawn[a][b]=2;
			}
		}
		return currentLawn;
	}
	public static int[][] changeVertical(int[][] currentLawn,int[][] lawn, int n, int m)
	{
		boolean rowCheck;
		for(int c=0; c<m; c++)
		{
			rowCheck = false;
			if (lawn[0][c]<2)
			{
				rowCheck = true;
				for (int d=0; d<n-1; d++)
				{
					if(lawn[d+1][c]>1)
					{
						rowCheck = false;
						break;
					}
				}
			}
			
			if (rowCheck)
			{
				for (int d=0; d<n; d++)
				{
					if(currentLawn[d][c]>1)
					{
						currentLawn[d][c]=1;
					}
				}
			}		
		}
		return currentLawn;
	}
	public static int[][] changeHorizontal(int[][] currentLawn, int[][] lawn, int n, int m)
	{
		boolean rowCheck;
		for(int c=0; c<n; c++)
		{
			rowCheck = false;
			if (lawn[c][0]<2)
			{
				rowCheck = true;
				for (int d=0; d<m-1; d++)
				{
					if(lawn[c][d+1]>1)
					{
						rowCheck = false;
						break;
					}
				}
			}
			if (rowCheck)
			{
				for (int d=0; d<m; d++)
				{
					if(currentLawn[c][d]>1)
					{
						currentLawn[c][d]=1;
					}
				}
			}		
		}
		return currentLawn;
	}
	public static boolean compareLawns(int[][]lawn, int[][]currentLawn, int n, int m)
	{
		boolean compare=true;
		
		for (int a=0; a<n; a++)
		{
			for (int b=0; b<m; b++)
			{
				if (lawn[a][b]!=currentLawn[a][b])
				{
					compare = false;
					break;
				}
			}
		}
		return compare;
	}
	public static void printOutAnswers(String[] solution) throws IOException
	{
		//print out caseStorer and write to a file
		PrintWriter out = new PrintWriter(new FileWriter("/Users/davidlong"+
		"/Desktop/javaoutputs/lawnMowerSmall.txt"));
		
		for (int x = 0; x < solution.length; x++)
		{
			out.println(solution[x]);
			System.out.println(solution[x]);
		}
		
		out.close();
	}
}

