import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.omg.CORBA.INTERNAL;

/**
 * 
 */

/**
 * @author Debol
 *
 */
public class ReadComputeAndWrite {

	/**
	 * @param args
	 */
	private static List<String> allLines = new ArrayList<>();
	private static List<TestCase> testCases = new ArrayList<>();
	private static List<Table> tables = new ArrayList<>();
	private static int lineNumber = 0;

	
	public static void main(String[] args) {
		loadFile("A-small-attempt0.in");
		loadData();
		solve();
		outputList(allLines,"output.out");
	}
	
	public static void solve(){
		allLines = new ArrayList<>();
		int i = 1;
		for(TestCase t: testCases){
			allLines.add("Case #"+i+": "+t.solve());
			i++;
		}
	}
	
	public static void loadData(){
		int numOfTests = (Integer.parseInt(allLines.get(lineNumber)));
		testCases = new ArrayList<>(numOfTests);
		lineNumber++;
		for(int i= 0 ; i < numOfTests ; i++){
			TestCase testCase = loadTestCase();
			testCases.add(i, testCase);
		}
	}
	
	public static TestCase loadTestCase() {
		TestCase t= new TestCase();
		t.setFirstQuestion((Integer.parseInt(allLines.get(lineNumber))));
		lineNumber++;
		Table table1 = loadTable();
		t.setSecondQuestion((Integer.parseInt(allLines.get(lineNumber))));
		lineNumber++;
		Table table2 = loadTable();
		t.setTable(0, table1);
		t.setTable(1, table2);
		return t;
	}
	
	public static Table loadTable(){
		Table t = new Table();
		for(int i=0 ; i<4 ; i++){
			Row r = loadCards();
			t.setRow(i, r);
			lineNumber++;
		}
		return t;
	}

	public static Row loadCards(){
		Row row = new Row();
		String [] lineData =  allLines.get(lineNumber).split(" ");
		for(int i= 0 ; i<lineData.length; i++){
			Card c = new Card(Integer.parseInt(lineData[i]));
			row.setCard(i, c);
		}
		return row;
		
	}
	
	

	public static void outputList(List<String> data, String location) {
		
		for(String line: data){
			System.out.println(line);
		}
		Writer writer = null;
		
		try {
			writer = new BufferedWriter(new FileWriter(new File(location)));
			Iterator<String> it = data.iterator();
			while(it.hasNext()){
				String line = it.next();
				writer.write(line+'\n');
			}
		} catch (IOException e) {
			System.out.println("Problem writing file");
			e.printStackTrace();
		}finally{
			try {
				if(writer != null)
					writer.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		
	}


	public static void loadFile(String file){
		BufferedReader bf = null;
		try {
			bf = new BufferedReader(new FileReader(new File(file)));
		} catch (FileNotFoundException e) {
			System.out.println("File not found");
			e.printStackTrace();
		}
		
		try {
			while(bf.ready()){
					allLines.add(bf.readLine());
			}
		} catch (IOException e) {
			System.out.println("Problem reading the file");
			e.printStackTrace();
		}
	}

}
