
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;

public class FirstRoundProbC {
	public static final int MOD = 100003;
	public static final String problemType = "large";
	static int[][] mem = new int[501][501];
	static long[][] combMem = new long[501][501];
	public static void main(String[] args) {
		try {
			String input = problemType.startsWith("s") ? "C-" + problemType + "-attempt1.in" : "C-" + problemType + ".in";
			
			BufferedReader br = new BufferedReader(new FileReader(input));
			PrintWriter pw = new PrintWriter(new FileWriter(input + "Res.txt"));

			String s = br.readLine();

			for(int i = 0; i < combMem.length; i++) {
				Arrays.fill(combMem[i], -1);
			}
			for(int i = 0; i < mem.length; i++) {
				Arrays.fill(mem[i], -1);
			}
			
			int NR_CASES = Integer.parseInt(s);
			for(int CASE = 1; CASE <= NR_CASES; CASE++) {
				s = br.readLine();
				
				int n = Integer.parseInt(s);
				int res = 0;
				for(int i = 1; i < n; i++) {
					res += fnc(n, i);
					res = res % MOD;
				}

				pw.println("Case #" + CASE + ": " + res);
			}

			pw.close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	static long fnc(int n, int pos) {
		if(mem[n][pos] >= 0) {
			return mem[n][pos];
		}
		if(pos == 1) {
			return 1;
		}
		long res = 0;
		for(int x = Math.max(2 * pos - n, 1); x < pos; x++) {
			res += fnc(pos, x) * comb(n - 1 - pos, pos - x - 1);
			res = res % MOD;
		}
		
		mem[n][pos] = (int)res;
		return res;
	}
	
	static long comb(int n, int a) {
		if(combMem[n][a] >= 0) {
			return combMem[n][a];
		}
		BigInteger res = BigInteger.ONE;
		for(int i = a + 1; i <= n; i++) {
			res = res.multiply(BigInteger.valueOf(i));
			res = res.divide(BigInteger.valueOf(i - a));
		}
		
		res = res.mod(BigInteger.valueOf(MOD));
		combMem[n][a] = res.intValue();
		return combMem[n][a];
	}
	
	static int func(int n) {
		if(n == 2) {
			return 1;
		}
		if(n == 3) {
			return 2;
		}
		if(n == 4) {
			return 3;
		}
		if(n == 5) {
			return 5;
		}
		if(n == 6) {
			return 8;
		}
		
		int res = func(n - 1) + func(n - 2);
		res = res % MOD;
		
		return res;
	}
}
