package gcj;

import java.io.*;
import java.math.*;
import java.util.*;

/**
 * Author: Igor Covganet
 * Created: Jul 26, 2008
 */
public class R11 {
	static final String inputFileName = "A-large.in.txt";
	static PrintWriter pw = null;
	static {
		try {
			pw = new PrintWriter(new FileWriter("output1.txt"));
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(inputFileName));
			String str = br.readLine();
			int nr = Integer.parseInt(str);
			for(int i = 1; i <= nr; i++) {
				String[] strs = br.readLine().split(" ");
				// n, A, B, C, D, x0, y0 and M
				int n = Integer.parseInt(strs[0]);
				int A = Integer.parseInt(strs[1]);
				int B = Integer.parseInt(strs[2]);
				int C = Integer.parseInt(strs[3]);
				int D = Integer.parseInt(strs[4]);
				int x0 = Integer.parseInt(strs[5]);
				int y0 = Integer.parseInt(strs[6]);
				int M = Integer.parseInt(strs[7]);
				
				long[] xs = new long[n];
				long[] ys = new long[n];
				xs[0] = x0;
				ys[0] = y0;
				
				for (int j = 1; j < ys.length; j++) {
				  xs[j] = (A * xs[j - 1] + B) % M;
				  ys[j] = (C * ys[j - 1] + D) % M;
				}
				
				R11 app = new R11();
				System.out.println("case " + i);
				long res = app.solve(xs, ys);
				pw.println("Case #" + i + ": " + res);
			}
			
			pw.close();
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	long solve(long[] xs, long[] ys) {
		long res = 0;
		long n00 = 0, n01 = 0, n02 = 0;
		long n10 = 0, n11 = 0, n12 = 0;
		long n20 = 0, n21 = 0, n22 = 0;
		for(int i = 0; i < xs.length; i++) {
			if(xs[i]%3 == 0) {
				if(ys[i]%3 == 0)
					n00++;
				if(ys[i]%3 == 1)
					n01++;
				if(ys[i]%3 == 2)
					n02++;
			}
			if(xs[i]%3 == 1) {
				if(ys[i]%3 == 0)
					n10++;
				if(ys[i]%3 == 1)
					n11++;
				if(ys[i]%3 == 2)
					n12++;
			}
			if(xs[i]%3 == 2) {
				if(ys[i]%3 == 0)
					n20++;
				if(ys[i]%3 == 1)
					n21++;
				if(ys[i]%3 == 2)
					n22++;
			}
		}
		
		res += n00*(n00 - 1)*(n00 - 2)/6;
		res += n00*n01*n02;
		res += n00*n10*n20;
		res += n00*n11*n22;
		res += n00*n12*n21;
		
		res += n01*(n01 - 1)*(n01 - 2)/6;
		res += n01*n10*n22;
		res += n01*n11*n21;
		res += n01*n12*n20;

		res += n02*(n02 - 1)*(n02 - 2)/6;
		res += n02*n10*n21;
		res += n02*n11*n20;
		res += n02*n12*n22;

		res += n10*(n10 - 1)*(n10 - 2)/6;
		res += n10*n11*n12;

		res += n11*(n11 - 1)*(n11 - 2)/6;

		res += n12*(n12 - 1)*(n12 - 2)/6;

		res += n20*(n20 - 1)*(n20 - 2)/6;
		res += n20*n21*n22;
		
		res += n21*(n21 - 1)*(n21 - 2)/6;
		
		res += n22*(n22 - 1)*(n22 - 2)/6;
		
		return res;
	}
}
