import java.io.*;
import java.util.*;

public class Prob4 {
	public static final String IMP = "IMPOSSIBLE";
	
	public static void main(String[] args) throws Exception {
		long time1 = System.currentTimeMillis();
		
		PrintWriter pw = new PrintWriter(new FileWriter("out4.txt"));
		BufferedReader br = new BufferedReader(new FileReader("D-small-attempt0.in"));
		
		int nrTests = Integer.parseInt(br.readLine());
		for(int testNr = 1; testNr <= nrTests; testNr++) {
			String[] strs = br.readLine().split(" ");
			int k = Integer.parseInt(strs[0]), n = Integer.parseInt(strs[1]);
			
			int[] startTypes = new int[k];
			strs = br.readLine().split(" ");
			for(int i = 0; i < startTypes.length; i++) {
				startTypes[i] = Integer.parseInt(strs[i]);
			}
			
			int[] ts = new int[n];
			int[][] ks = new int[n][];
			for(int i = 0; i < n; i++) {
				strs = br.readLine().split(" ");
				ts[i] = Integer.parseInt(strs[0]);
				ks[i] = new int[strs.length - 2];
				for(int j = 0; j < ks[i].length; j++) {
					ks[i][j] = Integer.parseInt(strs[2 + j]);
				}
			}
			
			int[] startKeys = new int[n];
			for(int i = 0; i < startKeys.length; i++) {
				for(int j = 0; j < startTypes.length; j++) {
					if(startTypes[j] == ts[i]) {
						startKeys[i]++;
					}
				}
			}
			
			int[][] nrGiven = new int[n][n];
			for(int i = 0; i < n; i++) {
				for(int j = 0; j < n; j++) {
					for(int u = 0; u < ks[j].length; u++) {
						if(ks[j][u] == ts[i]) {
							nrGiven[i][j]++;
						}
					}
				}
			}

			int[][] dp = new int[(1 << n)][];
			LinkedList<Integer> q = new LinkedList<Integer>();
			q.add(0);
			dp[0] = new int[] {};
			while(q.size() > 0) {
				int state = q.removeFirst();
				
				for(int i = 0; i < n; i++) {
					if((state & (1 << i)) != 0) {
						continue;
					}
					
					int nrKeys = startKeys[i];
					for(int j = 0; j < n; j++) {
						if((state & (1 << j)) == 0) {
							continue;
						}
						nrKeys += nrGiven[i][j];
						if(ts[j] == ts[i]) {
							nrKeys--;
						}
					}
					if(nrKeys > 0) {
						int newState = (state | (1 << i));
						boolean shouldAdd = (dp[newState] == null);
						if(dp[newState] != null) {
							for(int u = 0; u < dp[state].length; u++) {
								if(dp[state][u] < dp[newState][u]) {
									shouldAdd = true;
									break;
								}
								if(dp[state][u] > dp[newState][u]) {
									break;
								}
							}
						} else {
							dp[newState] = new int[dp[state].length + 1];
							q.add(newState);
						}
						if(shouldAdd) {
							System.arraycopy(dp[state], 0, dp[newState], 0, dp[state].length);
							dp[newState][dp[state].length] = i;
						}
					}
				}
			}
			
			String res = IMP;
			if(dp[(1 << n) - 1] != null) {
				res = "" + (dp[(1 << n) - 1][0] + 1);
				for(int i = 1; i < n; i++) {
					res += " " + (dp[(1 << n) - 1][i] + 1);
				}
			}
			
			pw.println("Case #" + testNr + ": " + res);
		}
		
		br.close();
		pw.close();
		long time2 = System.currentTimeMillis();
		System.out.println("processed in " + (time2 - time1) + " ms");
	}
}
