package gcj;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;

public class Fly {
	static final String inputFileName = "C-small-attempt0.in.txt";
	//static final String inputFileName = "/home/igor/Desktop/C-small.in";
	static PrintWriter pw = null;
	static {
		try {
			pw = new PrintWriter(new FileWriter("output3.txt"));
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(inputFileName));
			String str = br.readLine();
			int nr = Integer.parseInt(str);
			for(int i = 1; i <= nr; i++) {
				String[] strs = br.readLine().split(" ");
				double f = Double.parseDouble(strs[0]);
				double R = Double.parseDouble(strs[1]);
				double t = Double.parseDouble(strs[2]);
				double r = Double.parseDouble(strs[3]);
				double g = Double.parseDouble(strs[4]);
				
				Fly app = new Fly();
				System.out.println("case " + i);
				double res = app.solve(f, R, t, r, g);
				if(i != 1) {
					pw.println();
				}
				pw.print("Case #" + i + ": " + res);
			}
			
			pw.close();
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	double solve(double f, double R, double t, double r, double g) {
		/** first, if the fly doesn't fit in the square, it has no chance */
		if(g <= 2*f)
			return 1;
		
		// will keep the surface in which the fly can escape!
		double res = 0;
		
		/** go along the line, calc the nr of squares and the probability inside the last square */
		double rsq = (R - t)*(R - t), rfsq = (R - t - f)*(R - t - f);
		// R = r + y * (g + 2*r) + x + t
		int nrFullSquares = R - t - r >= g ? 1 + (int)((R - t - r - g)/(g + 2*r)) : 0;
		// go up and for each line calc nr squares
		for(int i = 0; i < nrFullSquares; i++) {
			// we're on the square above i-th string
			double height = r + i*(g + 2*r);
			double bottomD = Math.sqrt(rsq - height*height);
			double upD = Math.sqrt(rsq - (height + g)*(height + g));
			
			int nrSquares = upD >= g ? 1 + (int)((upD - g)/(g + 2*r)) : 0;
			res += nrSquares * (g - 2*f)*(g - 2*f);
			
			// get the surface from the last, non full squares of this row
			double x = r + nrSquares*(g + 2*r);
			
			// we have some cases here, like:
			// upD < x || upD > x && bottomD < x + g || bootmD > x + g
			if(x + g <= upD) {
				System.out.println("ERROR 1");
			}
			while(x + g < bottomD) {
				// calculate the area between x and x + g
				double dif2 = Math.sqrt(rsq - (x + g)*(x + g)) - height;
				if(dif2 < 0) {
					System.out.println("ERROR 2");
				}
				
				double x1 = x + f, x2 = x + g - f;
				double y1 = height + f, y2 = height + g - f;
				double y3 = Math.sqrt(rfsq - x2*x2);
				if(y3 < height + f) {
					// now we have almost a triangle
					double x3 = Math.sqrt(rfsq - y1*y1);
					if(x3 > x1) {
						double y4 = Math.sqrt(rfsq - x1*x1);
						if(y4 > y2) {
							// it's a kind of rectangle
							double x5 = Math.sqrt(rfsq - y2*y2);
							
							double angle = Math.asin(y2/(R - t - f)) - Math.asin(y1/(R - t - f));
							double area1 = angle*rfsq/2.0;
							double area2 = y2*(x5 - x1)/2.0;
							double area3 = x1*(y2 - y1)/2.0;
							double area4 = y1*(x3 - x1)/2.0;
							
							double plusRes = area1 + area2 - area3 - area4;
							if(plusRes < 0) {
								System.out.println("ERROR 3");
							}
							res += plusRes;
						} else {
							// we have a triangle here
							double angle = Math.asin(y4/(R - t - f)) - Math.asin(y1/(R - t - f));
							double area1 = angle*rfsq/2.0;
							double area3 = x1*(y4 - y1)/2.0;
							double area4 = y1*(x3 - x1)/2.0;

							double plusRes = area1 - area3 - area4;
							if(plusRes < 0) {
								System.out.println("ERROR 4");
							}
							res += plusRes;
						}
					} else {
						// nothing to do here
					}
				} else {
					// now we're going to have a reactangle
					double x3 = Math.sqrt(rfsq - y2*y2);
					if(x3 > x1) {
						// a real rectangle
						double angle = Math.asin(y2/(R - t - f)) - Math.asin(y3/(R - t - f));
						double area1 = angle*rfsq/2.0;
						double area2 = y2*(x3 - x1)/2.0;
						double area3 = x2*(y3 - y1)/2.0;
						double area4 = x1*(y2 - y1)/2.0;
						double area5 = y1*(x2 - x1)/2.0;
						
						double plusRes = area1 + area2 + area3 - area4 - area5;
						if(plusRes < 0) {
							System.out.println("ERROR 5");
						}
						res += plusRes;
					} else {
						double y4 = Math.sqrt(rfsq - x1*x1);
						if(y4 > y2) {
							System.out.println("ERROR 6");
						}

						double angle = Math.asin(y4/(R - t - f)) - Math.asin(y3/(R - t - f));
						double area1 = angle*rfsq/2.0;
						double area2 = x2*(y3 - y1)/2.0;
						double area3 = x1*(y4 - y1)/2.0;
						double area4 = y1*(x2 - x1)/2.0;

						double plusRes = area1 + area2 - area3 - area4;
						if(plusRes < 0) {
							System.out.println("ERROR 5");
						}
						res += plusRes;
					}
				}
				
				// increment x to next square
				x += g + 2*r;
			}

			if(x >= bottomD - 2*f) {
				// everything is calculated here
				continue;
			}
			
			// calculate the area between x and bottomD
			double x1 = x + f, x2 = bottomD;
			double y1 = height + f, y2 = height + g - f;
			double y3 = rfsq > x2*x2 ? Math.sqrt(rfsq - x2*x2) : 0;
			if(y3 < height + f) {
				// now we have almost a triangle
				double x3 = Math.sqrt(rfsq - y1*y1);
				if(x3 > x1) {
					double y4 = Math.sqrt(rfsq - x1*x1);
					if(y4 > y2) {
						// it's a kind of rectangle
						double x5 = Math.sqrt(rfsq - y2*y2);
						
						double angle = Math.asin(y2/(R - t - f)) - Math.asin(y1/(R - t - f));
						double area1 = angle*rfsq/2.0;
						double area2 = y2*(x5 - x1)/2.0;
						double area3 = x1*(y2 - y1)/2.0;
						double area4 = y1*(x3 - x1)/2.0;
						
						double plusRes = area1 + area2 - area3 - area4;
						if(plusRes < 0) {
							System.out.println("ERROR 3");
						}
						res += plusRes;
					} else {
						// we have a triangle here
						double angle = Math.asin(y4/(R - t - f)) - Math.asin(y1/(R - t - f));
						double area1 = angle*rfsq/2.0;
						double area3 = x1*(y4 - y1)/2.0;
						double area4 = y1*(x3 - x1)/2.0;

						double plusRes = area1 - area3 - area4;
						if(plusRes < 0) {
							System.out.println("ERROR 4");
						}
						res += plusRes;
					}
				} else {
					// nothing to do here
				}
			} else {
				// now we're going to have a reactangle
				double x3 = Math.sqrt(rfsq - y2*y2);
				if(x3 > x1) {
					// a real rectangle
					double angle = Math.asin(y2/(R - t - f)) - Math.asin(y3/(R - t - f));
					double area1 = angle*rfsq/2.0;
					double area2 = y2*(x3 - x1)/2.0;
					double area3 = x2*(y3 - y1)/2.0;
					double area4 = x1*(y2 - y1)/2.0;
					double area5 = y1*(x2 - x1)/2.0;
					
					double plusRes = area1 + area2 + area3 - area4 - area5;
					if(plusRes < 0) {
						System.out.println("ERROR 5");
					}
					res += plusRes;
				} else {
					double y4 = Math.sqrt(rfsq - x1*x1);
					if(y4 > y2) {
						System.out.println("ERROR 6");
					}

					double angle = Math.asin(y4/(R - t - f)) - Math.asin(y3/(R - t - f));
					double area1 = angle*rfsq/2.0;
					double area2 = x2*(y3 - y1)/2.0;
					double area3 = x1*(y4 - y1)/2.0;
					double area4 = y1*(x2 - x1)/2.0;

					double plusRes = area1 + area2 - area3 - area4;
					if(plusRes < 0) {
						System.out.println("ERROR 7");
					}
					res += plusRes;
				}
			}
		}
		
		// now let's calc the area in the last upper row
		double y = r + nrFullSquares*(g + 2*r);
		if(y < R - t - 2*f) {
			// we have something left
			double y1 = y + f;
			double bottomD = Math.sqrt(rfsq - y1*y1);
			double x = r;
			while(x + g - f < bottomD) {
				double x1 = x + f, x2 = x + g - f;
				double y2 = Math.sqrt(rfsq - x1*x1);
				double y3 = Math.sqrt(rfsq - x2*x2);
				
				double angle = Math.asin(y2/(R - t - f)) - Math.asin(y3/(R - t - f));
				double area1 = angle*rfsq/2.0;
				double area2 = x2*(y3 - y1)/2.0;
				double area3 = x1*(y2 - y1)/2.0;
				double area4 = y1*(x2 - x1)/2.0;

				double plusRes = area1 + area2 - area3 - area4;
				if(plusRes < 0) {
					System.out.println("ERROR 8");
				}
				res += plusRes;
				
				x += g + 2*r;
			}
			
			// the last area left, between x and bottomD
			if(x + f < bottomD) {
				double x1 = x + f;
				double x2 = bottomD;
				double y2 = Math.sqrt(rfsq - x1*x1);

				double angle = Math.asin(y2/(R - t - f)) - Math.asin(y1/(R - t - f));
				double area1 = angle*rfsq/2.0;
				double area2 = x1*(y2 - y1)/2.0;
				double area3 = y1*(x2 - x1)/2.0;

				double plusRes = area1 - area2 - area3;
				if(plusRes < 0) {
					System.out.println("ERROR 9");
				}
				res += plusRes;
			}
		}

		return 1.0 - (res * 4.0 / R / R / Math.PI);
	}
}
