package gcj;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;

/**
 * Author: Igor Covganet
 * Created: Aug 2, 2008
 */
public class R22 {
	static final String inputFileName = "B-small-attempt1.in.txt";
	static PrintWriter pw = null;
	static {
		try {
			pw = new PrintWriter(new FileWriter("output2.txt"));
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		long a = System.currentTimeMillis();
		try {
			BufferedReader br = new BufferedReader(new FileReader(inputFileName));
			String str = br.readLine();
			int nr = Integer.parseInt(str);
			for(int i = 1; i <= nr; i++) {
				String[] strs = br.readLine().split(" ");
				// A, B, and P
				int N = Integer.parseInt(strs[0]);
				int M = Integer.parseInt(strs[1]);
				int A = Integer.parseInt(strs[2]);
				
				R22 app = new R22();
				System.out.println("case " + i);
				String res = app.solve2(N, M, A);
				pw.println("Case #" + i + ": " + res);
			}
			
			pw.close();
		}catch (Exception e) {
			e.printStackTrace();
		}
		long b = System.currentTimeMillis();
		System.out.println(b - a);
	}
	
	String solve2(int N, int M, int A) {
		if(A >= N*M*2)
			return "IMPOSSIBLE";
		
		for(int x1 = 0 ; x1 <= N; x1++) {
			for(int x2 = x1; x2 <= N; x2++) {
				for(int x3 = x2; x3 <= N; x3++) {
					if((x2 + x3 - 2*x1)*M < A) {
						continue;
					}
					for(int y1 = 0; y1 <= M; y1++) {
						for(int y2 = 0; y2 <= M; y2++) {
							int val2 = (x3 - x1)*(y2 - y1);
							for(int y3 = 0; y3 <= M; y3++) {
								int area = (x2 - x1)*(y3 - y1) - val2;
								if(area > A&&y3 > y1)
									break;
								
								if(Math.abs(area) == A) {
									return x1 + " " + y1 + " " + x2 + " " + y2 + " " + x3 + " " + y3;
								}
							}
						}
					}
				}
			}
		}
		return "IMPOSSIBLE";
	}
}
