package gcj;

import java.io.*;
import java.math.*;
import java.util.*;

/**
 * Author: Igor Covganet
 * Created: Jul 26, 2008
 */
public class R11 {
	static final String inputFileName = "A-small-attempt2.in.txt";
	static PrintWriter pw = null;
	static {
		try {
			pw = new PrintWriter(new FileWriter("output1.txt"));
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(inputFileName));
			String str = br.readLine();
			int nr = Integer.parseInt(str);
			for(int i = 1; i <= nr; i++) {
				String[] strs = br.readLine().split(" ");
				// n, A, B, C, D, x0, y0 and M
				int n = Integer.parseInt(strs[0]);
				int A = Integer.parseInt(strs[1]);
				int B = Integer.parseInt(strs[2]);
				int C = Integer.parseInt(strs[3]);
				int D = Integer.parseInt(strs[4]);
				int x0 = Integer.parseInt(strs[5]);
				int y0 = Integer.parseInt(strs[6]);
				int M = Integer.parseInt(strs[7]);
				
				long[] xs = new long[n];
				long[] ys = new long[n];
				xs[0] = x0;
				ys[0] = y0;
				
				for (int j = 1; j < ys.length; j++) {
				  xs[j] = (A * xs[j - 1] + B) % M;
				  ys[j] = (C * ys[j - 1] + D) % M;
				}
				
				R11 app = new R11();
				System.out.println("case " + i);
				long res = app.solve(xs, ys);
				pw.println("Case #" + i + ": " + res);
			}
			
			pw.close();
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	long solve(long[] xs, long[] ys) {
		long res = 0;
		for(int i = 0; i < xs.length; i++) {
			for(int j = i + 1; j < xs.length; j++) {
				for(int k = j + 1; k < xs.length; k++) {
					if(xs[i] == xs[j]&&ys[i] == ys[j])
						continue;
					if(xs[i] == xs[k]&&ys[i] == ys[k])
						continue;
					if(xs[k] == xs[j]&&ys[k] == ys[j])
						continue;

					if((xs[i] + xs[j] + xs[k])%3 == 0&&(ys[i] + ys[j] + ys[k])%3 == 0)
						res++;
				}
			}
		}
		
		return res;
	}
}
