package gcj;

import java.io.*;
import java.math.*;
import java.util.*;

/**
 * Author: Igor Covganet
 * Created: Jul 26, 2008
 */
public class R12 {
	static final String inputFileName = "B-small-attempt0.in.txt";
	static PrintWriter pw = null;
	static {
		try {
			pw = new PrintWriter(new FileWriter("output2.txt"));
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	static ArrayList<Integer> primesList = getPrimes();
	
	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(inputFileName));
			String str = br.readLine();
			int nr = Integer.parseInt(str);
			for(int i = 1; i <= nr; i++) {
				String[] strs = br.readLine().split(" ");
				// A, B, and P
				int A = Integer.parseInt(strs[0]);
				int B = Integer.parseInt(strs[1]);
				int P = Integer.parseInt(strs[2]);
				
				R12 app = new R12();
				System.out.println("case " + i);
				long res = app.solve(A, B, P);
				pw.println("Case #" + i + ": " + res);
			}
			
			pw.close();
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	long solve(int A, int B, int P) {
		int[] setNr = new int[B + 1];
		for(int i = A; i <= B; i++)
			setNr[i] = i;
		
		for(int i = A; i < B; i++) {
			for(int j = i + 1; j <= B; j++) {
				for(int p : primesList) {
					if(p < P)
						continue;
					
					if(i%p == 0&&j%p == 0) {
						for(int k = A; k <= B; k++) {
							if(k != j&&setNr[k] == setNr[j]) {
								setNr[k] = setNr[i];
							}
						}
						setNr[j] = setNr[i];
					}
				}
			}
		}

		int res = 0;
		for(int i = A; i <= B; i++) {
			if(setNr[i] == i)
				res++;
		}
		return res;
	}
	
	static ArrayList<Integer> getPrimes() {
		ArrayList<Integer> primes = new ArrayList<Integer>();
		primes.add(2);
		primes.add(3);
		primes.add(5);
		for(int i = 7; i <= 1000; i += 2) {
			boolean isPrime = true;
			for(int p : primes) {
				if(i % p == 0) {
					isPrime = false;
					break;
				}
			}
			
			if(isPrime)
				primes.add(i);
		}
		
		return primes;
	}
}
