import java.io.*;
import java.util.*;

public class SecondRoundProbA {
	public static final String problemType = "small";
	public static void main(String[] args) {
		try {
			String input = problemType.startsWith("s") ? "A-" + problemType + "-attempt1.in" : "A-" + problemType + ".in";
			
			BufferedReader br = new BufferedReader(new FileReader(input));
			PrintWriter pw = new PrintWriter(new FileWriter(input + "Res.txt"));

			String s = br.readLine();

			int NR_CASES = Integer.parseInt(s);
			for(int CASE = 1; CASE <= NR_CASES; CASE++) {
				s = br.readLine();
				int k = Integer.parseInt(s);
				
				int[][] map = new int[2 * k - 1][2 * k - 1];
				for(int i = 0; i < 2 * k - 1; i++) {
					Arrays.fill(map[i], -1);
					s = br.readLine();
					char[] chrs = s.toCharArray();
					for(int j = 0; j < chrs.length; j++) {
						map[i][j] = (chrs[j] == ' ') ? -1 : chrs[j] - '0';
					}
				}
				
				if(k == 1) {
					int res = 0;
					pw.println("Case #" + CASE + ": " + res);
					continue;
				}
				
				int res = (2 * k - 1) * (2 * k - 1) - k * k;
				for(int i = k; i >= 0; i--) {
					boolean ok = true;
					for(int dir = 0; dir < 4; dir++) {
						ok = true;
						// UP
						int x = 0, y = 0;
						if(dir == 0) {
							x = i - 1;
							y = k - 1;
						} else if(dir == 1) {
							x = 2 * k - 2 - (i - 1);
							y = k - 1;
						} else if(dir == 2) {
							x = k - 1;
							y = i - 1;
						} else if(dir == 3) {
							x = k - 1;
							y = 2 * k - 2 - (i - 1);
						}

						for(int j = x - i + 1; j < x + i && ok; j++) {
							for(int a = y - i + 1; a < y + i; a++) {
								if(Math.abs(j - x) + Math.abs(a - y) > i - 1) {
									continue;
								}
								
								if(map[j][a] != map[j][2 * y - a]) {
									ok = false;
									break;
								}
								if(map[j][a] != map[2 * x - j][a]) {
									ok = false;
									break;
								}
							}
						}
						if(ok) {
							System.out.println("i = " + i);
							res = (2 * k - i) * (2 * k - i) - k * k;
							break;
						}
					}
					if(ok) {
						break;
					}
				}
				
				pw.println("Case #" + CASE + ": " + res);
			}

			pw.close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
}
