import java.io.*;
import java.math.*;
import java.util.*;

class CodeJam16QC 
{
	public static void main(String[] args) throws Exception
	{
		File file = new File("D:\\C-small-practice.in");
		File outFile = new File("D:\\C-small-practice.out");

		BufferedReader br = new BufferedReader(new FileReader(file));
		BufferedWriter bw = new BufferedWriter(new FileWriter(outFile));

		int testCases = Integer.parseInt(br.readLine());
		for(int t=1;t<=testCases;t++)
		{
			bw.write("Case #" + t +": \n");
			String input = br.readLine();
			StringTokenizer strToken = new StringTokenizer(input);
			int count = strToken.countTokens();
			//Reads in the numbers to the array
			int[] arr = new int[count];

			for(int x = 0;x < count;x++){
				arr[x] = Integer.parseInt((String)strToken.nextElement());
			}

			int N = arr[0];
			int J = arr[1];

			int allCase = 0;

			BigInteger current = BigInteger.valueOf(2);
			BigInteger finalValue = current.pow(N);
			//2^N
			current = current.pow(N - 1);
			//2^N +1 (1xxx1)
			current = current.add(BigInteger.ONE);

			while (current.compareTo(finalValue) == -1)
			{
				System.out.println("Checking : "+current.toString(2));

				boolean isAllNotPrime = true;
				String printOut = current.toString(2)+" ";

				for (int i = 2; i <= 10; i++)
				{
					BigInteger checking = new BigInteger(current.toString(2),i);
					LinkedList factors = tdFactors(checking);
					if (factors.size() > 1)
					{
						// not prime
						System.out.print(checking.toString()+"-"+factors.get(0)+" ");
						printOut += factors.get(0)+" ";
					}
					else
					{
						//prime
						isAllNotPrime = false;
						System.out.print(checking.toString()+"-"+"PRIME ");
						printOut += "PRIME ";
					}
					System.out.println();
				}

				if (isAllNotPrime)
				{
					bw.write(printOut+"\n");
					allCase++;
				}

				current = current.add(BigInteger.valueOf(2));

				if (allCase >= J)
				{
					break;
				}
			}
		}
		br.close();
		bw.close();
	}
	public static LinkedList tdFactors(BigInteger n)
{
		BigInteger two = BigInteger.valueOf(2);
		LinkedList fs = new LinkedList();

		if (n.compareTo(two) < 0)
		{
			throw new IllegalArgumentException("must be greater than one");
		}

		while (n.mod(two).equals(BigInteger.ZERO))
		{
			fs.add(two);
			n = n.divide(two);
		}

		if (n.compareTo(BigInteger.ONE) > 0)
		{
			BigInteger f = BigInteger.valueOf(3);
			while (f.multiply(f).compareTo(n) <= 0)
			{
				if (n.mod(f).equals(BigInteger.ZERO))
				{
					fs.add(f);
					n = n.divide(f);
				}
				else
				{
					f = f.add(two);
				}
			}
			fs.add(n);
		}

		return fs;
	}
}
