import java.io.*;

class CodeJam16QA 
{
	public static void main(String[] args) throws Exception
	{
		File file = new File("D:\\A-large.in");
		File outFile = new File("D:\\A-large.out");

		BufferedReader br = new BufferedReader(new FileReader(file));
		BufferedWriter bw = new BufferedWriter(new FileWriter(outFile));

		int testCases = Integer.parseInt(br.readLine());
		for(int t=1;t<=testCases;t++)
		{
			long N = Long.parseLong(br.readLine());

			if (N == 0)
			{
				//this is the only case that digit cannot be completed
				bw.write("Case #" + t +": INSOMNIA\n");
				continue;
			}

			boolean[] digitFound = new boolean[10];
			for (int i = 0; i <= 9; i++)
			{
				digitFound[i] = false;
			}

			long currentMultiply = 0;

			do
			{
				currentMultiply++;
				long number = N * currentMultiply;

				while (number > 0) 
				{
					digitFound[(int)(number % 10)] = true;
					number = number / 10;
				}
			}
			while (!areAllTrue(digitFound));

			bw.write("Case #" + t +": "+(N * currentMultiply)+"\n");
		}
		br.close();
		bw.close();
	}

	public static boolean areAllTrue(boolean[] array)
	{
		for(boolean b : array) if(!b) return false;
		return true;
	}
}
