import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;


public class B {
	
	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	    
		int testCases = Integer.parseInt(in.readLine());
		
		for (int testCaseCount = 1; testCaseCount <= testCases; testCaseCount++) {
			String input = in.readLine();
			Scanner s = new Scanner(input);
			
			int size = s.nextInt();
			ArrayList<Integer> list = new ArrayList<Integer>(size);
			
			s = new Scanner(in.readLine());
			
			while (s.hasNextInt()) {
				list.add(s.nextInt());
			}
			
			int minCount = Integer.MAX_VALUE;
			int maxIndex = maxIndex(list);
			for (int i = 0; i < list.size(); i++) {
				int result = sort(maxIndex, i, (ArrayList<Integer>) list.clone());
				if (result < minCount)
					minCount = result;
			}
			
			System.out.println("Case #" + testCaseCount + ": " + minCount);

		}
	}
	
	public static int sort(int maxIndex, int m, ArrayList<Integer> arr) {
		int count = 0;
		
		while (true) {
			int swaps = 0;
			for (int i = 0; i < m - 1; i++) {
				if (arr.get(i) > arr.get(i + 1)) {
					int temp = arr.get(i+1);
					arr.set(i+1, arr.get(i));
					arr.set(i, temp);
					swaps++;
				}
			}

			for (int i = arr.size() - 1; i > m; i--) {
				if (arr.get(i) > arr.get(i - 1)) {
					int temp = arr.get(i-1);
					arr.set(i-1, arr.get(i));
					arr.set(i, temp);
					swaps++;
				}
			}
			
			count += swaps;
			if (swaps == 0) {
				break;
			}
		}
		return count;
	}
	
	public static int maxIndex(ArrayList<Integer> arr) {
		int largest = Integer.MIN_VALUE;
		int index = -1;
		for (int i = 0; i < arr.size(); i++) {
			int curr = arr.get(i);
			if (curr > largest) {
				largest = curr;
				index = i;
			}
		}
		return index;
	}
	
	public static boolean isValidAscending(int end, ArrayList<Integer> arr) {
		for (int i = 0; i < end - 1; i++) {
			if (arr.get(i) > arr.get(i+1)) {
				return false;
			}
		}
		return true;
	}
	
	public static boolean isValidDescending(int start, ArrayList<Integer> arr) {
		for (int i = start; i < arr.size() - 1; i++) {
			if (arr.get(i) < arr.get(i+1)) {
				return false;
			}
		}
		return true;
	}
	
	private static class ReverseComparator implements Comparator<Integer> {
		@Override
		public int compare(Integer o1, Integer o2) {
			return o2.compareTo(o1);
		}
	}

	
}
