import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Scanner;
import java.util.TreeSet;


public class Round1B1 {
	public static void main(String[] args) throws IOException {
		
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	    
		int testCases = Integer.parseInt(in.readLine());
		
		for (int testCaseCount = 1; testCaseCount <= testCases; testCaseCount++) {
			String input = in.readLine();
			
			int wordCount = Integer.parseInt(input);
			ArrayList<String> words = new ArrayList<String>();
			
			for (int i = 0; i < wordCount; i++) {
				words.add(in.readLine());
			}
			
			int[] frequencies = new int[words.size()];
			
			boolean fail = false;
			for (int i = 0; i < words.size(); i++) {
				if (fail)
					break;
				
				for (int j = 0; j < words.size(); j++) {
					Integer curr = frequencies[i];
					int diff = diff(words.get(i), words.get(j));
					
					if (diff == -1) {
						System.out.println("Case #" + testCaseCount + ": Fegla Won");
						fail = true;
						break;
					}
					
					frequencies[i] = frequencies[i] + diff;
					
				}
			}
			
			Arrays.sort(frequencies);
			
			if (!fail) {
				System.out.println("Case #" + testCaseCount + ": " + frequencies[0]);
			}
		}
		
		System.out.println(diff("abbab", "abbbab"));
	}
	
	public static int diff(String s1, String s2) {
		ArrayList<CharTuple> s1List = new ArrayList<CharTuple>();
		ArrayList<CharTuple> s2List = new ArrayList<CharTuple>();
		
		Character lastUnique = null;
		int count = 0;
		for (int i = 0; i < s1.length(); i++) {
			if (lastUnique == null) {
				count = 1;
				lastUnique = s1.charAt(i);
			} else if (!lastUnique.equals(s1.charAt(i))) {
				s1List.add(new CharTuple(lastUnique, count));
				lastUnique = s1.charAt(i);
				count = 1;
			} else {
				count++;
			}
		}
		s1List.add(new CharTuple(lastUnique, count));
		
		lastUnique = null;
		count = 0;
		for (int i = 0; i < s2.length(); i++) {
			if (lastUnique == null) {
				count = 1;
				lastUnique = s2.charAt(i);
			} else if (!lastUnique.equals(s2.charAt(i))) {
				s2List.add(new CharTuple(lastUnique, count));
				lastUnique = s2.charAt(i);
				count = 1;
			} else {
				count++;
			}
		}
		s2List.add(new CharTuple(lastUnique, count));
		
		if (s1List.size() != s2List.size()) {
			return -1;
		} else {
			for (int i = 0; i < s1List.size(); i++) {
				if (s1List.get(i).myChar != s2List.get(i).myChar)
					return -1;
			}
			
			int diff = 0;
			for (int i = 0; i < s1List.size(); i++) {
				int f1 = s1List.get(i).freq;
				int f2 = s2List.get(i).freq;
				diff += Math.abs(f1 - f2);
			}
			return diff;
		}
	}
}
