import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.HashSet;
import java.util.Set;

class Combine {
	char c1;
	char c2;
	char result;
}

class Opposed {
	char o1;
	char o2;
}

public class Main {

	private static final String SPACE = " ";

	private static String solve(Combine[] combines, Opposed[] opposites,
			String in) {
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < in.length(); i++) {
			if (sb.length() == 0)
				sb.append(in.charAt(i));
			else {
				boolean haveCombined = false;
				char candidate = sb.charAt(sb.length() - 1);
				for (int j = 0; j < combines.length; j++) {
					if ((combines[j].c1 == in.charAt(i) && combines[j].c2 == candidate)
							|| (combines[j].c2 == in.charAt(i) && combines[j].c1 == candidate)) {
						sb.deleteCharAt(sb.length() - 1);
						sb.append(combines[j].result);
						haveCombined = true;
						break;
					}
				}
				if (!haveCombined) {
					Set<Character> candidates = new HashSet<Character>();
					for (int j = 0; j < opposites.length; j++) {
						if (opposites[j].o1 == in.charAt(i)
								|| opposites[j].o2 == in.charAt(i)) {
							candidates
									.add(opposites[j].o1 == in.charAt(i) ? opposites[j].o2
											: opposites[j].o1);
						}
					}
					for (int j = 0; j < sb.length(); j++) {
						if (candidates.contains(sb.charAt(j))) {
							sb.delete(0, sb.length());
							break;
						}
					}
					if(sb.length() > 0){
						sb.append(in.charAt(i));
					}
				}
			}
		}
		StringBuilder res = new StringBuilder();
		res.append('[');
		for (int i = 0; i < sb.length() - 1; i++) {
			res.append(sb.charAt(i));
			res.append(", ");
		}
		if (sb.length() > 0) {
			res.append(sb.charAt(sb.length() - 1));
		}
		res.append(']');
		return res.toString();
	}

	public static void main(String[] args) {
		try {
			FileInputStream is = new FileInputStream("B-small-attempt0.in");
			BufferedReader br = new BufferedReader(new InputStreamReader(
					new DataInputStream(is)));
			String line = br.readLine();
			int T = Integer.parseInt(line);
			for (int i = 1; i <= T; i++) {
				line = br.readLine();
				String[] tokens = line.split(SPACE);
				Combine[] combines = new Combine[Integer.valueOf(tokens[0])];
				Opposed[] opposites = new Opposed[Integer
						.valueOf(tokens[combines.length+1])];
				for (int j = 1; j <= combines.length; j++) {
					Combine c = new Combine();
					c.c1 = tokens[j].charAt(0);
					c.c2 = tokens[j].charAt(1);
					c.result = tokens[j].charAt(2);
					combines[j - 1] = c;
				}
				for (int j = combines.length + 2; j < combines.length
						+ opposites.length + 2; j++) {
					Opposed o = new Opposed();
					o.o1 = tokens[j].charAt(0);
					o.o2 = tokens[j].charAt(1);
					opposites[j-combines.length-2] = o;
				}

				String in = tokens[tokens.length - 1];

				System.out.println("Case #" + i + ": "
						+ solve(combines, opposites, in));
			}
		} catch (Exception e) {
			// do nothing
		}
	}

}
