import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

enum Robot {
	Orange, Blue
}

class Button {
	int order;
	int buttonNumber;
}

public class Main {

	private static final String SPACE = " ";
	private static final String O = "O";

	private static int solve(List<Button> blue, List<Button> orange) {
		int time = 0;
		int blueCounter = 0;
		int orangeCounter = 0;
		int bluePosition = 1;
		int orangePosition = 1;

		while (blueCounter < blue.size() && orangeCounter < orange.size()) {
			if (blue.get(blueCounter).order < orange.get(orangeCounter).order) {
				// move blue to its button and press it
				int timeForCurrentOperation = Math
						.abs(blue.get(blueCounter).buttonNumber - bluePosition) + 1;
				time += timeForCurrentOperation;
				bluePosition = blue.get(blueCounter).buttonNumber;
				blueCounter++;
				// move orange to its button
				if (Math.abs(orangePosition
						- orange.get(orangeCounter).buttonNumber) <= timeForCurrentOperation) {
					orangePosition = orange.get(orangeCounter).buttonNumber;
				} else {
					if (orangePosition < orange.get(orangeCounter).buttonNumber) {
						orangePosition += timeForCurrentOperation;
					} else {
						orangePosition -= timeForCurrentOperation;
					}
				}
			} else {
				// move orange to its button and press it
				int timeForCurrentOperation = Math.abs(orange
						.get(orangeCounter).buttonNumber - orangePosition) + 1;
				time += timeForCurrentOperation;
				orangePosition = orange.get(orangeCounter).buttonNumber;
				orangeCounter++;
				// move blue to its button
				if (Math.abs(bluePosition - blue.get(blueCounter).buttonNumber) <= timeForCurrentOperation) {
					bluePosition = blue.get(blueCounter).buttonNumber;
				} else {
					if (bluePosition < blue.get(blueCounter).buttonNumber) {
						bluePosition += timeForCurrentOperation;
					} else {
						bluePosition -= timeForCurrentOperation;
					}
				}
			}
		}

		if (blueCounter == blue.size()) {
			while (orangeCounter < orange.size()) {
				time += Math.abs(orange.get(orangeCounter).buttonNumber
						- orangePosition) + 1;
				orangePosition = orange.get(orangeCounter).buttonNumber;
				orangeCounter++;
			}
		} else {
			while (blueCounter < blue.size()) {
				time += Math.abs(blue.get(blueCounter).buttonNumber
						- bluePosition) + 1;
				bluePosition = blue.get(blueCounter).buttonNumber;
				blueCounter++;
			}
		}

		return time;
	}

	public static void main(String[] args) {

		try {
			FileInputStream is = new FileInputStream("A-large.in");
			BufferedReader br = new BufferedReader(new InputStreamReader(
					new DataInputStream(is)));

			String line = br.readLine();
			int count = Integer.parseInt(line);
			for (int i = 1; i <= count; i++) {
				line = br.readLine();
				String[] tokens = line.split(SPACE);
				int length = Integer.valueOf(tokens[0]) * 2 + 1;
				List<Button> blue = new ArrayList<Button>();
				List<Button> orange = new ArrayList<Button>();
				for (int j = 1; j < length; j += 2) {
					Button button = new Button();
					button.order = j / 2;
					button.buttonNumber = Integer.valueOf(tokens[j + 1]);
					if (tokens[j].equals(O))
						orange.add(button);
					else
						blue.add(button);
				}
				System.out.println("Case #" + i + ": " + solve(blue, orange));
			}
		} catch (Exception e) {
			// do nothing
		}

	}

}
