import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

class Result{
	int opponent;
	int res;
	
	Result(int op, int r){
		opponent = op;
		res = r;
	}
}

class Team {
	int nr;
	List<Result> opponents = new ArrayList<Result>();
	double rpi = 0;
	double wp  = 0;
	int    NrWp = 0;
	double owp = 0;
	double oowp = 0;
}

public class Main {

	public static void solve(List<Team> teams){
		//calculate WP
		for(Team team : teams){
			int i = 0;
			for(Result result : team.opponents){
				team.wp += result.res;
				i++;
			}
			team.NrWp = i;
			team.wp /= i;
		}
		
		//calculate OWP
		for(Team team : teams){
			int i = 0;
			for(Result result : team.opponents){
				Team opponent = teams.get(result.opponent);
				double candidate = opponent.wp * opponent.NrWp;
				double candidateNrWp = opponent.NrWp;
				for(Result opRes : opponent.opponents){
					if(opRes.opponent == team.nr){
						candidate -= opRes.res;
						candidateNrWp -= 1;
					}
				}
				team.owp += candidate/candidateNrWp;
				i++;
			}
			team.owp /= i;
		}
		
		//calculate OOWP
		for(Team team : teams){
			int i = 0;
			for(Result result : team.opponents){
				Team opponent = teams.get(result.opponent);
				team.oowp += opponent.owp;
				i++;
			}
			team.oowp /= i;
		}
		
		for(Team team : teams){
			team.rpi = 0.25* team.wp + 0.5*team.owp +  0.25*team.oowp;
			System.out.println(team.rpi);
		}
	}
	
	public static void main(String[] args){
		int N;
		
		try {
			// Open the file that is the first
			// command line parameter
			FileInputStream fstream = new FileInputStream("A-small-attempt0 (1).in");
			// Get the object of DataInputStream
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));

			N = Integer.valueOf(br.readLine());
            String line;
			
			for (int i = 1; i <= N; i++) {
				line = br.readLine();
				int nrTeams = Integer.valueOf(line);
				List<Team> teams = new ArrayList<Team>();
				for(int j = 0; j < nrTeams; j++){
					line = br.readLine();
					Team team = new Team();
					team.nr = j;
					for(int k = 0; k < line.length(); k++){
						if(line.charAt(k) == '.')
							continue;
						if(line.charAt(k) == '1')
							team.opponents.add(new Result(k, 1));
						if(line.charAt(k) == '0')
							team.opponents.add(new Result(k, 0));
					}
					teams.add(team);
				}
				System.out.println("Case #" + i + ":\n");
				Main.solve(teams);
			}

			// Close the input stream
			in.close();
		} catch (Exception e) {// Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
	}
	
}
