import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

class Point {
	double val;
	int nrVendors;
}

class Group {
	double min;
	double max;
	int nrVendors;
	double minExt;
	double maxExt;
}

public class Main {

	private static double solve(int D, Point[] points){
		int i = 0;
		List<Group> groups = new ArrayList<Group>();
		Group first = new Group();
		first.min = points[0].val;
		first.max = points[0].val;
		first.nrVendors = points[0].nrVendors;
		double extension = D * (first.nrVendors-1);
		double length = first.max - first.min;
		first.minExt = first.min - (extension-length)/2;
		first.maxExt = first.max + (extension-length)/2;
		i++;
		groups.add(first);
		while(i < points.length){
			Group candidate = new Group();
			candidate.min = points[i].val;
			candidate.max = points[i].val;
			candidate.nrVendors = points[i].nrVendors;
			extension = D * (candidate.nrVendors-1);
			length = candidate.max - candidate.min;
			candidate.minExt = candidate.min - (extension-length)/2;
			candidate.maxExt = candidate.max + (extension-length)/2;
		
			if(candidate.minExt <= groups.get(groups.size()-1).maxExt){
				Group group = groups.get(groups.size()-1);
				group.max = points[i].val;
				group.nrVendors += points[i].nrVendors;
				extension = D * (group.nrVendors-1);
				length = group.max - group.min;
				group.minExt = group.min - (extension-length)/2;
				group.maxExt = group.max + (extension-length)/2;
				//review groups list
				int j = groups.size()-1;
				while(j > 0 && groups.get(j).minExt <= groups.get(j-1).maxExt){
					groups.remove(j--);
					Group gr = groups.get(j);
					gr.max = group.max;
					gr.nrVendors += group.nrVendors;
					extension = D * (gr.nrVendors-1);
					length = gr.max - gr.min;
					gr.minExt = gr.min - (extension-length)/2;
					gr.maxExt = gr.max + (extension-length)/2;
				}
			} else {
				groups.add(candidate);
			}
			i++;
		}
		
		double maxMove = 0;
		for(Group group : groups){
			double maxDist1 = group.maxExt-group.max;
			double maxDist2 = group.min - group.minExt;
			if(maxDist1 > maxMove)
				maxMove = maxDist1;
			if(maxDist2 > maxMove)
				maxMove = maxDist2;
		}
		
		return maxMove;
	}
	
	public static void main(String[] args){
		
		int N;
		
		try {
			// Open the file that is the first
			// command line parameter
			FileInputStream fstream = new FileInputStream("B-small-attempt2.in");
			// Get the object of DataInputStream
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));

			N = Integer.valueOf(br.readLine());
            String line;
			
			for (int i = 1; i <= N; i++) {
				line = br.readLine();
				String[] tokens = line.split(" ");
				int C = Integer.valueOf(tokens[0]);
				int D = Integer.valueOf(tokens[1]);
				
				Point[] points = new Point[C];
				for(int j = 0; j < C; j++){
					line = br.readLine();
					tokens = line.split(" ");
					Point p = new Point();
					p.val = Double.valueOf(tokens[0]);
					p.nrVendors = Integer.valueOf(tokens[1]);
					points[j] = p;
				}
				
				double res = Main.solve(D, points);
				System.out.println("Case #" + i + ": " + res);
			}

			// Close the input stream
			in.close();
		} catch (Exception e) {// Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
		
	}
	
}
