import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class Codejam2_1 {

	private static int N;
	private static final String FileIn = "C-small-attempt0.in";
	private static final String FileOut = "out";

	public static void main(String[] args) {
		try {
			PrintStream ps = new PrintStream(new FileOutputStream(FileOut));
			BufferedReader br = new BufferedReader(new FileReader(FileIn));
			String s = br.readLine();
			StringTokenizer st = new StringTokenizer(s);
			N = Integer.valueOf(st.nextToken());
			for (int i = 1; i <= N; i++) {
				s = br.readLine();
				st = new StringTokenizer(s);
				int r = Integer.valueOf(st.nextToken());
				List<Point> points = new ArrayList<Point>();
				int maxX = 0;
				int maxY = 0;
				for (int j = 0; j < r; j++) {
					s = br.readLine();
					st = new StringTokenizer(s);
					int x1 = Integer.valueOf(st.nextToken());
					int y1 = Integer.valueOf(st.nextToken());
					int x2 = Integer.valueOf(st.nextToken());
					int y2 = Integer.valueOf(st.nextToken());
					if (x1 > maxX)
						maxX = x1;
					if (x2 > maxX)
						maxX = x2;
					if (y1 > maxY)
						maxY = y1;
					if (y2 > maxY)
						maxY = y2;
					points.add(new Point(x1, y1));
					points.add(new Point(x2, y2));
				}
				int[][] matrix = new int[Math.max(maxY + 2,maxX+2)][Math.max(maxX + 2,maxY+2)];
				for (int j = 0; j < points.size(); j += 2) {
					for (int k = points.get(j).x; k <= points.get(j+1).x; k++) {
						for (int l = points.get(j).y; l <= points.get(j+1).y; l++) {
							matrix[l][k] = 1;
						}
					}
				}
				ps.print("Case #" + i + ": " + solve(matrix) + "\n");
			}
			ps.flush();
		} catch (IOException e) {
			System.out.println("Problem reading or writing file");
		}
	}

	private static int solve(int[][] matrix) {
		int time = 0;
		int total = 0;
		for (int i = 1; i < matrix.length; i++)
			for (int j = 1; j < matrix.length; j++) {
				if (matrix[i][j] == 1)
					total++;
			}
		while (total > 0) {
			List<Point> toBorn = new ArrayList<Point>();
			List<Point> toDie = new ArrayList<Point>();
			for (int i = 1; i < matrix.length-1; i++)
				for (int j = 1; j < matrix[0].length-1; j++) {
					if (matrix[i][j] == 1 && matrix[i - 1][j] == 0
							&& matrix[i][j - 1] == 0) {
						toDie.add(new Point(i, j));
					}
					if (matrix[i][j] == 0 && matrix[i - 1][j] == 1
							&& matrix[i][j - 1] == 1) {
						toBorn.add(new Point(i, j));
					}
				}
			total += toBorn.size();
			total -= toDie.size();
			for (Point point : toDie) {
				matrix[point.x][point.y] = 0;
			}
			for (Point point : toBorn) {
				matrix[point.x][point.y] = 1;
			}
			time++;
		}
		return time;
	}

	static class Point {
		int x;
		int y;

		Point(int x, int y) {
			this.x = x;
			this.y = y;
		}
	}

}
