import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.StringTokenizer;


public class FairWarning {

	private static int T;
	
	public static void main(String[] args){
		try{ 
			PrintStream ps = new PrintStream(new FileOutputStream("small.out"));
			BufferedReader br = new BufferedReader(new FileReader("B-small-attempt0.in"));
			String s = br.readLine();
			StringTokenizer st = new StringTokenizer(s);
			T = Integer.valueOf(st.nextToken());
			for(int i = 1; i <= T; i++){
				s = br.readLine();
				st = new StringTokenizer(s);
				int N = Integer.valueOf(st.nextToken());
				List<BigInteger> times = new ArrayList<BigInteger>();
				for(int j = 0; j < N; j++){
					BigInteger time = new BigInteger(st.nextToken());
					if(!time.equals(BigInteger.ZERO))
						times.add(time);
				}
				if(times.size() == 1)
					ps.println("Case #" + i + ": 0");
				else
					ps.println("Case #" + i + ": " + solve(times));
			}
		} catch (IOException e){
			System.out.println("Problem reading or writing file");
		}
	}
	
	private static BigInteger solve(List<BigInteger> times){
		Collections.sort(times);
		List<BigInteger> diffs = new ArrayList<BigInteger>();
		for(int i = 0; i < times.size()-1; i++){
			diffs.add(times.get(i+1).subtract(times.get(i)));
		}
		BigInteger cmmdc = cmmdc(diffs);
		BigInteger timeDiff = cmmdc.subtract(times.get(0).mod(cmmdc));
		if(cmmdc.equals(timeDiff))
			return BigInteger.ZERO;
		else 
			return timeDiff;
	}
	
	/*private static BigInteger cmmdc(BigInteger x, BigInteger y){
		BigInteger rest = x.mod(y);
		while(!rest.equals(BigInteger.ZERO)){
			x = y;
			y = rest;
			rest = x.mod(y);
		}
		return y;
	}*/
	
	private static BigInteger cmmdc(List<BigInteger> array){
		while(array.size() != 1){
			List<BigInteger> aux = new ArrayList<BigInteger>();
			if(array.size() % 2 == 1){
				for(int i = 0 ; i < array.size()-1; i+=2){
					aux.add(array.get(i).gcd(array.get(i+1)));
				}
				aux.add(array.get(array.size()-1));
			} else {
				for(int i = 0 ; i < array.size(); i+=2){
					aux.add(array.get(i).gcd(array.get(i+1)));
				}
			}
			array = aux;
		}
		return array.get(0);
	}
	
}
