import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;


public class SpeakingInTongues {

	static HashMap<Character, Character> map = new HashMap<Character, Character>();
	
	static {
		map.put('y', 'a');
		map.put('n', 'b');
		map.put('f', 'c');
		map.put('i', 'd');
		map.put('c', 'e');
		map.put('w', 'f');
		map.put('l', 'g');
		map.put('b', 'h');
		map.put('k', 'i');
		map.put('u', 'j');
		
		map.put('o', 'k');
		map.put('m', 'l');
		map.put('x', 'm');
		map.put('s', 'n');
		map.put('e', 'o');
		map.put('v', 'p');
		map.put('z', 'q');
		map.put('p', 'r');
		map.put('d', 's');
		map.put('r', 't');
		
		map.put('j', 'u');
		map.put('g', 'v');
		map.put('t', 'w');
		map.put('h', 'x');
		map.put('a', 'y');
		map.put('q', 'z');
	}
	
	public static String translate(String in){
		StringBuilder sb = new StringBuilder();
		for(int i = 0; i < in.length(); i++){
			if(in.charAt(i) == ' ')
				sb.append(' ');
			else
				sb.append(map.get(in.charAt(i)));
		}
		return sb.toString();
	}
	
	public static void main(String[] args){
		
		List<String> res = new ArrayList<String>();
		try {
			FileInputStream fstream = new FileInputStream("A-small-attempt0 (2).in");
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			int cases = Integer.valueOf(br.readLine());
			for(int i = 0; i < cases; i++) {
				String line = br.readLine();
				//System.out.println(line);
				//System.out.println(translate(line));
				res.add(translate(line));
			}
			in.close();
		} catch (Exception e) {
			System.err.println("Error: " + e.getMessage());
		}
		
		//System.out.println(res.size());
		
		try {
			// Create file
			File fout = new File("out.txt");
			FileWriter fstream = new FileWriter(fout);
			BufferedWriter out = new BufferedWriter(fstream);
			for (int i = 0; i < res.size(); i++){
				out.write("Case #" + (i+1) + ": " + res.get(i)); 
				out.newLine();
			}
			// Close the output stream
			out.close();
		} catch (Exception e) {// Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
		
	}
	
}
