import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;

public class SenateEvac {

	static final String ALPH = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
			long numTestCases = Long.parseLong(br.readLine());

			for (int testID = 0; testID < numTestCases; testID++) {
				int numParties = Integer.parseInt(br.readLine());

				ArrayList<Integer> p = new ArrayList<>();
				String[] ln = br.readLine().split(" ");
				int totalLeft = 0;
				for (int partyID = 0; partyID < numParties; partyID++) {
					int num = Integer.parseInt(ln[partyID]);
					p.add(num);
					totalLeft += num;
				}

				StringBuilder res = new StringBuilder();
				while (totalLeft > 2) {
					// Find max
					int maxInd = findMax(p);

					if (rem2Legal(p, maxInd, totalLeft)) {
						// Remove 2 legal
						p.set(maxInd, p.get(maxInd) - 2);
						res.append(ALPH.substring(maxInd, maxInd+1) + ALPH.substring(maxInd,maxInd+1) + " ");
						totalLeft -= 2;
					} else if (rem1Legal(p, maxInd, totalLeft)) {
						// Remove 1 legal
						p.set(maxInd, p.get(maxInd) - 1);
						res.append(ALPH.substring(maxInd,maxInd+1) + " ");
						totalLeft -= 1;
					} else {
						// find second max
						int secondMaxInt = findSecondMax(p, maxInd);
						p.set(maxInd, p.get(maxInd) - 1);
						p.set(secondMaxInt, p.get(secondMaxInt) - 1);
						res.append(ALPH.substring(maxInd,maxInd+1) + ALPH.substring(secondMaxInt,secondMaxInt+1) + " ");
						totalLeft -= 2;
					}
				}

				// remove last 2
				int ind1 = -1, ind2 = -1;
				for (int i = 0; i < p.size(); i++) {
					if (p.get(i) == 1) {
						if (ind1 == -1) {
							ind1 = i;
						} else {
							ind2 = i;
							break;
						}
					}
				}
				res.append(ALPH.substring(ind1,ind1+1) + ALPH.substring(ind2,ind2+1) + " ");

				System.out.println("Case #" + (testID + 1) + ": " + res.toString());
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static int findMax(ArrayList<Integer> p) {
		int max = 0, index = -1;
		for (int i = 0; i < p.size(); i++) {
			if (p.get(i) > max) {
				max = p.get(i);
				index = i;
			}
		}
		return index;
	}

	private static int findSecondMax(ArrayList<Integer> p, int maxInd) {
		int max = 0, index = -1;
		for (int i = 0; i < p.size(); i++) {
			if (p.get(i) > max && i != maxInd) {
				max = p.get(i);
				index = i;
			}
		}
		return index;
	}

	private static boolean rem1Legal(ArrayList<Integer> p, int remInd, int totalLeft) {
		totalLeft -= 1;
		for (int i = 0; i < p.size(); i++) {
			double percentage;
			if (i != remInd) {
				percentage = ((double) p.get(i)) / (double) totalLeft;
			} else {
				percentage = ((double) (p.get(i) - 1)) / (double) totalLeft;
			}
			if (percentage > 0.5) {
				return false;
			}
		}
		return true;
	}

	private static boolean rem2Legal(ArrayList<Integer> p, int remInd, int totalLeft) {
		totalLeft -= 2;
		for (int i = 0; i < p.size(); i++) {
			double percentage;
			if (i != remInd) {
				percentage = ((double) p.get(i)) / (double) totalLeft;
			} else {
				percentage = ((double) (p.get(i) - 2)) / (double) totalLeft;
			}
			if (percentage > 0.5) {
				return false;
			}
		}
		return true;
	}

}
