import java.awt.geom.Line2D;
import java.io.File;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

class Stock implements Comparable<Stock>{

	public int x[] = new int[1000];
	public int y[] = new int[1000];
	public int K;

	public int compareTo(Stock o) {

		for(int i = 0 ; i < K ; i++){
			if(y[i] < o.y[i])
				return -1;
			if(y[i] > o.y[i])
				return 1;
		}
		return 0;
	}
}

public class Main {

	boolean connected[][] = new boolean[1000][1000];
	int N, man[] = new int[1000];
	int M, woman[] = new int[1000];
	boolean visited[] = new boolean[1000];

	boolean match(int manIndex){

		for(int i = 0 ; i < M ; i++){
			if(!connected[manIndex][i]||visited[i])continue;

			visited[i] = true;
			if(woman[i] == -1 || match(woman[i])){
				man[manIndex] = i;
				woman[i] = manIndex;
				return true;
			}
		}
		return false;
	}

	int S, K;
	Stock[] arr = new Stock[1000];

	public void solve() throws Exception{

		Scanner sc = new Scanner(new File("C-large.in"));
		PrintWriter pw = new PrintWriter("C-large.out");

		for(int i = 0 ; i < 1000 ; i++)
			arr[i] = new Stock();

		//Scanner sc = new Scanner(new File("1.in"));
		//PrintWriter pw = new PrintWriter("1.out");
		//PrintWriter pw = new PrintWriter(System.out);

		int tt = sc.nextInt();

		for(int t = 1 ; t <= tt ; t++){
			S = sc.nextInt();
			K = sc.nextInt();

			for(int i = 0 ; i < S ; i++){
				arr[i].K = K;
				for(int j = 0 ; j < K ; j++){
					arr[i].x[j] = j;
					arr[i].y[j] = sc.nextInt();
				}
			}

			Arrays.sort(arr, 0, S);

			N = M = S;
			for(int i = 0 ; i < N ; i++)
				for(int j = 0 ; j < M ; j++)
					connected[i][j] = false;

			for(int i = 0 ; i < N ; i++)
				for(int j = i+1 ; j < N ; j++)
					if(ok(i, j))
						connected[i][j] = true;

			//Match
			int cnt = 0;
			Arrays.fill(man, -1);
			Arrays.fill(woman, -1);
			for(int i = 0 ; i < N ; i++)
				if(man[i] == -1){
					Arrays.fill(visited, false);
					if(match(i))cnt++;
				}
			//System.out.println("Case #" + t + ": " + (N-cnt));
			pw.println("Case #" + t + ": " + (N-cnt));
		}

		pw.close();
	}

	private boolean ok(int i, int j) {

		for(int a = 0 ; a < K-1 ; a++){
			Line2D.Double l1 = new Line2D.Double(arr[i].x[a], arr[i].y[a], arr[i].x[a+1], arr[i].y[a+1]);
			for(int b = 0 ; b < K-1 ; b++){
				Line2D.Double l2 = new Line2D.Double(arr[j].x[b], arr[j].y[b], arr[j].x[b+1], arr[j].y[b+1]);

				if(l1.intersectsLine(l2))
					return false;
			}
		}
		return true;
	}

	public static void main(String[] args) throws Exception {

		new Main().solve();
	}
}
