import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Main {
	
	static class Symbol{
		
		char s;
		boolean negative;
		public Symbol(char S, boolean Negative)
		{
			s = S;
			negative = Negative;
		}
		
		public Symbol copySymbol()
		{
			return new Symbol(this.s, this.negative);
		}
		
		@Override
		public boolean equals(Object o)
		{
			return (this.s == ((Symbol)o).s)&&(this.negative==((Symbol)o).negative);
		}
		
		@Override
		public String toString()
		{
			return (negative?"-":"") + Character.toString(s);
		}
	}
	
	static Symbol I;
	static Symbol J;
	static Symbol K;
	static StringBuilder out;
	static Symbol[][] multiplyArray;
	static int L;
	static long X;
	static Symbol[][] DPfirst;
	static Symbol[] DPlast;
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader("input.in"));
		out = new StringBuilder();
		int T = Integer.parseInt(in.readLine());
		Long start = System.currentTimeMillis();
		I = new Symbol ('i', false);
		J = new Symbol ('j', false);
		K = new Symbol ('k', false);
		multiplyArray = new Symbol[4][4];
		setMultiply();
		
		for(int t=0; t<T; t++)
		{
			String[] line = in.readLine().split(" ");
			L = Integer.parseInt(line[0]);
			X = Long.parseLong(line[1]);
			String base = in.readLine();
			char[] chars = base.toCharArray();
			char first;
			boolean moreThanOneCharType = false;
			first = chars[0];
			for(int i=1; i<L; i++) //handle special case of only one type of character being used in list, which makes it impossible to solve
			{
				if(chars[i]!=first)
				{
					moreThanOneCharType = true;
					break;
				}
			}
			
			if(((L*X)<3)||L<=1||!moreThanOneCharType) //handle special case of not enough characters to result in a 3 character solution
			{
				out.append("Case #");
				out.append((t+1));
				out.append(": NO\r\n");
				System.out.println("Case #" + (t+1) + ": NO");
				continue;
			}
			
			
			//precompute
			DPfirst = new Symbol[L][L];
			DPlast = new Symbol[L];
			//DPfirst[0][0] = new Symbol(chars[0], false);
			DPlast[L-1] = new Symbol(chars[L-1], false);
			
			for(int i=0; i<L; i++)
			{
				DPfirst[i][i] = new Symbol(chars[i], false);
				for(int j=i+1; j<L; j++)
					DPfirst[i][j] = multiply(DPfirst[i][j-1], new Symbol(chars[j], false));
				
			}
			
			for(int i=L-2; i>=0; i--)
			{
				DPlast[i] = multiply(new Symbol(chars[i], false), DPlast[i+1]);
			}
			
			//iterate through options
			
			boolean canFindSolution = findIs();
			if(canFindSolution)
				System.out.println("Case #" + (t+1) + ": YES");
			else
				System.out.println("Case #" + (t+1) + ": NO");
			
			out.append("Case #");
			out.append((t+1));
			if(canFindSolution)
				out.append(": YES");
			else
				out.append(": NO");
			out.append("\r\n");
		}
		
		BufferedWriter fOut = new BufferedWriter(new FileWriter("output.txt"));
		fOut.write(out.toString());
		fOut.close();
		Long end = System.currentTimeMillis();
		System.out.println("Time: " + (end-start));

	}
	
	static boolean findIs()
	{
		long length = L*X;
		long substringCount = 0;
		int substringIndex = 0;
		for(long n = 0; n<length-2; n++)
		{
			if(substringIndex==L)
			{
				substringIndex = 0;
				substringCount++;
			}
			Symbol current = DPfirst[0][substringIndex];
			if(substringCount>0)
			{
				Symbol substring = getMultipleOfSubstring(substringCount);
				current = multiply(substring,current);
			}
			
			if(current.s==I.s && current.negative==I.negative)
			{
				boolean done = findJs(substringIndex, substringCount);
				if(done)
					return true;
			}
			substringIndex++;
		}
		return false;
	}
	
	static boolean findJs(int l, long x)
	{
		long length = L*X;
		long substringCount = 0;
		int substringIndex = l+1;
		int startSubstringIndex = substringIndex%L;
		boolean finishedFirst = false;
		
		for(long n = (x*L)+l+1; n<length-1; n++)
		{
			if(substringIndex==L)
			{
				substringIndex = 0;
				if(!finishedFirst)
					finishedFirst=true;
				else
					substringCount++;
			}
			Symbol current = null;
			if(!finishedFirst)
				current = DPfirst[startSubstringIndex][substringIndex];
			else
				current = DPfirst[startSubstringIndex][L-1];
				
			
			if(substringCount>0)
			{
				Symbol substring = getMultipleOfSubstring(substringCount);
				current = multiply(current, substring);
			}
			
			if(finishedFirst)
			{
				Symbol endString = DPfirst[0][substringIndex];
				current = multiply(current, endString);
			}
			
			if(current.s==J.s && current.negative==J.negative)
			{
				boolean done = findK(substringIndex, substringCount+x+(finishedFirst?1:0));
				if(done)
					return true;
			}
			substringIndex++;
		}
		return false;
	}
	
	static boolean findK(int l, long x)
	{
		
		if(l+1==L)
		{
			l=0;
			x++;
		}
		else
			l++;
		int substringIndex = l;
		Symbol current = DPlast[substringIndex];
		x++;
		if(X-x!=0)
			current = multiply(current, getMultipleOfSubstring(X-x));
		
		if(current.s==K.s && current.negative==K.negative)
		{
			return true;
		}
		return false;
	}
	
	static Symbol getMultipleOfSubstring(long x)
	{
		Symbol single = DPfirst[0][L-1];
		Symbol newSymbol = single.copySymbol();
		
		for(long i =1; i<x; i++)
		{
			newSymbol = multiply(newSymbol, single);
		}
		return newSymbol;
	}
	
	static Symbol multiply(Symbol f, Symbol l)
	{
		int row = 0;
		int col = 0;
		switch(f.s)
		{
			case 'i':
				row = 1;
				break;
			case 'j':
				row = 2;
				break;
			case 'k':
				row = 3;
				break;
		}
		
		switch(l.s)
		{
			case 'i':
				col = 1;
				break;
			case 'j':
				col = 2;
				break;
			case 'k':
				col = 3;
				break;
		}
		
		Symbol newS = multiplyArray[row][col].copySymbol(); 
		newS.negative = (newS.negative && !f.negative) || (!newS.negative && f.negative);
		newS.negative = (newS.negative && !l.negative) || (!newS.negative && l.negative);
		
		return newS;
	}
	
	static void setMultiply()
	{
		multiplyArray[0][0] = new Symbol('1', false);
		multiplyArray[0][1] = new Symbol('i', false);
		multiplyArray[0][2] = new Symbol('j', false);
		multiplyArray[0][3] = new Symbol('k', false);
		
		multiplyArray[1][0] = new Symbol('i', false);
		multiplyArray[1][1] = new Symbol('1', true);
		multiplyArray[1][2] = new Symbol('k', false);
		multiplyArray[1][3] = new Symbol('j', true);
		
		multiplyArray[2][0] = new Symbol('j', false);
		multiplyArray[2][1] = new Symbol('k', true);
		multiplyArray[2][2] = new Symbol('1', true);
		multiplyArray[2][3] = new Symbol('i', false);
		
		multiplyArray[3][0] = new Symbol('k', false);
		multiplyArray[3][1] = new Symbol('j', false);
		multiplyArray[3][2] = new Symbol('i', true);
		multiplyArray[3][3] = new Symbol('1', true);
		
	}

}
