package com.donguyen.googlecodejam.codejam2016;

import sun.rmi.runtime.Log;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.nio.channels.InterruptedByTimeoutException;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

/**
 * Created by dont on 9/4/2016.
 */
public class CoinJam {
//    public static void main(String[] args) {
//        try {
//            File file = new File("D:\\C\\precomputation.in");
//            if(!file.exists()) {
//                precomputation(file);
//            }
//            Scanner scanner = new Scanner(file);
//            ArrayList<Integer> primes = new ArrayList<>();
//            while(scanner.hasNextInt()) {
//                primes.add(scanner.nextInt());
//            }
//            boolean stop = true;
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//    }

    public static ArrayList<BigInteger> primes = new ArrayList<>();
    public static void main(String[] args) {
        try {
            List<String> inputs = Files.readAllLines(new File("D:\\C\\C-small-attempt0.in").toPath());
            FileWriter fw = new FileWriter("D:\\C\\C-small-attempt0.out");

//            File file = new File("D:\\C\\precomputation.in");
//            if(!file.exists()) {
//                precomputation(file);
//            }
//            Scanner scanner = new Scanner(file);
//            primes = new ArrayList<>();
//            while(scanner.hasNextInt()) {
//                primes.add(new BigInteger(String.valueOf(scanner.nextInt())));
//            }

            precomputation();

            int T = Integer.valueOf(inputs.get(0));
            for(int i=1; i<=T; i++) {
                String[] listInputs = inputs.get(i).split(" ");
                int N = Integer.valueOf(listInputs[0]);
                int J = Integer.valueOf(listInputs[1]);

                fw.write("Case #" + i + ":\n");
                int numResults = 0;
                int number = 0;
                while (numResults < J) {
                    int[] subArr = convertNumToArray(number, N-2);
                    int[] arr = initArr(subArr, N);
                    boolean isCoinJam = true;
                    BigInteger[] factors = new BigInteger[9];
                    BigInteger bigNegative1 = new BigInteger("-1");
                    for(int u=2; u<=10; u++) {
                        BigInteger currentNum = convertArrToNum(arr, u);
                        BigInteger factor = findFactor(currentNum);
                        if(factor.equals(bigNegative1)) {
                            isCoinJam = false;
                            break;
                        } else {
                            factors[u-2] = factor;
                        }
                    }
                    if(isCoinJam) {
                        numResults++;

                        // print the coin jam
                        for(int ch : arr) {
                            fw.write(String.valueOf(ch));
                        }
                        for(BigInteger factor : factors) {
                            fw.write(" " + factor);
                        }
                        if(numResults < J) {
                            fw.write("\n");
                        }
                        fw.flush();
                    }
                    number++;
                }
            }
            fw.flush();
            fw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static BigInteger findFactor(BigInteger currentNum) {
        BigInteger big0 = new BigInteger("0");
        for(BigInteger prime : primes) {
            if(prime.compareTo(currentNum) >= 0)
                return new BigInteger("-1");

            if(currentNum.mod(prime).equals(big0)) {
                return prime;
            }
        }

        return new BigInteger("-1");
    }

    private static BigInteger convertArrToNum(int[] arr, int u) {
        BigInteger bigU = new BigInteger(String.valueOf(u));
        BigInteger result = new BigInteger("0");

        int[] reverseArr = reverse(arr);
        BigInteger degree = new BigInteger("1");
        for(int i=0; i<reverseArr.length; i++) {
            if(i > 0) {
                degree = degree.multiply(bigU);
            }
            if(reverseArr[i] == 1) {
                result = result.add(degree);
            }
        }

        return result;
    }

    private static int[] reverse(int[] arr) {
        int[] result = new int[arr.length];
        for(int i=0; i<arr.length; i++) {
            result[i] = arr[arr.length-1-i];
        }

        return result;
    }

    private static int[] initArr(int[] arr, int n) {
        int[] result = new int[n];
        result[0] = 1;
        result[n-1] = 1;
        for(int i=1; i<n-1; i++) {
            result[i] = arr[i-1];
        }

        return result;
    }

    private static int[] convertNumToArray(int number, int n) {
        int[] result = new int[n];
        for (int i = n-1; i >= 0; i--) {
            result[n-1-i] = (number & (1 << i)) != 0 ? 1 : 0;
        }

        return result;
    }

//    private static void precomputation(File file) {
//        try {
//            FileWriter fw = new FileWriter(file);
//            int count = 0;
//            int num = 2;
//            while(count < 1000000) {
//                if(isPrime(num)) {
//                    fw.write(num + " ");
//                    fw.flush();
//                    count++;
//                }
//                num++;
//            }
//            fw.flush();
//            fw.close();
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//    }

    private static void precomputation() {
        int count = 0;
        int num = 2;
        while(count < 1000000) {
            if(isPrime(num)) {
                primes.add(new BigInteger(String.valueOf(num)));
                count++;
            }
            num++;
        }
    }

    private static boolean isPrime(int num) {
        if(num == 2)
            return true;

        int squareNum = (int) (Math.sqrt(num)+1);
        for(int i=2; i < squareNum; i++) {
            if(num % i == 0) {
                return false;
            }
        }

        return true;
    }
}
