import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;


public class OPF {
	
	static final String FILE_IN = "A-small-attempt0.in";
	static final String FILE_OUT = "out.txt";

	public static void main(String[] args) throws IOException {
		BufferedReader r = new BufferedReader(new FileReader(FILE_IN));
		BufferedWriter w = new BufferedWriter(new FileWriter(FILE_OUT));
		
		int T = Integer.parseInt(r.readLine());
		int caseNum = 0;

		while (r.ready()){
				String p; int S;
				p = r.readLine();
				S = Integer.parseInt(p.split(" ")[1]);
				p = p.split(" ")[0];
				
				int[] pan = new int[p.length()];
				for (int i=0; i<p.length(); i++){
					pan[i] = p.charAt(i) == '+' ? 1 : 0;
				}
				
				int flips = 0;
				
				// Check for too short
				if (pan.length < S){
					w.write("Case #"+ ++caseNum + ": "+"IMPOSSIBLE"+"\n");
					break;
				}
				
				for (int i=0; i<p.length(); i++){
					//Consider range [i, i+S-1]					
					//If first bit in 0, do flip
					if (pan[i] == 0){
						pan = flip(pan,i,i+S-1);
						flips++;
					}
					
					//Check if at end range
					if (i+S >= pan.length){
						if (!allOnes(pan)){
							flips = -1;
						}
						break;
					}
				}
				
				//Print result out
				if (flips > -1){
					w.write("Case #"+ ++caseNum + ": "+flips+"\n");
				}
				else {
					w.write("Case #"+ ++caseNum + ": "+"IMPOSSIBLE"+"\n");
				}
				
		}
		
		r.close();
		w.close();

	}
	
	private static int[] flip(int[] a, int x, int y){
		for (int i=x; i<=y; i++){
			a[i] = a[i] == 0 ? 1 : 0;
		}
		return a;
	}
	
	private static boolean allOnes(int[] a){
		for (int i : a){
			if (i == 0)
				return false;
		}
		return true;
	}

}
