import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Pancakes {
	
	static final String FILE_IN = "B-small-attempt1.in";
	static final String FILE_OUT = "out.txt";

	public static void main(String[] args) throws IOException {
		BufferedReader r = new BufferedReader(new FileReader(FILE_IN));
		BufferedWriter w = new BufferedWriter(new FileWriter(FILE_OUT));
		
		int T = Integer.parseInt(r.readLine());
		String s;
		int caseNum = 0;
		while (r.ready()){
			caseNum++;
			s = r.readLine();
			// Strings are immutable, make an array
			char[] stack = s.toCharArray();
			// Solve it
			int count = solve(stack);
			w.write("Case #"+caseNum+": "+count+"\n");
		}
		
		r.close();
		w.close();
	}
	
	private static int solve(char[] stack){
		int count = 0, indexPointer = stack.length-1;
		while (indexPointer >= 0){
			if (stack[indexPointer] == '-'){
				if (stack[0] == '-'){
					stack = flip(stack, indexPointer);
					count++;
				}
				else if (stack[0] == '+'){
					// Count the +s on top
					int plusIndex;
					for (plusIndex = 0; stack[plusIndex] == '+'; plusIndex++);
					stack = flip(stack, plusIndex-1);
					count++;
				}
			}
			else{
				indexPointer--;
			}
		}
		return count;
	}
	
	private static char[] flip(char[] stack, int flipIndex){
		int start = 0, fin = flipIndex;
		char temp;
		while(start<fin){
			temp = stack[start];
			stack[start] = invert(stack[fin]);
			stack[fin] = invert(temp);
			start++;
			fin--;
		}		
		if (start==fin){
			stack[start] = invert(stack[start]);
		}
		return stack;		
	}
	
	private static char invert(char x){
		switch (x){
		case '-':
			return '+';
		case '+':
			return '-';
		}
		return '\0';
	}
	

}
