import java.util.*;

public class Solution {

    public class Stall {
        int idx;
        int ls = 0;
        int rs = 0;
        int min = 0;
        int max = 0;
        boolean occupied = false;

        public Stall(int i, int l, int r) {
            idx = i;
            ls = l;
            rs = r;
            min = Math.min(ls,rs);
            max = Math.max(ls,rs);
        }

        public String toString() {
            String str = idx+":"+ls+":"+rs+":"+min+":"+max;
            return(str);
        }
    }

    public class Stalls {
        int n;
        Stall[]a;

        public Stalls(int n) {
            this.n = n;
            // allocate array of nodes
            a = new Stall[n];
            for (int i=0; i < n; i++) {
                a[i] = new Stall(i, i, (n-i-1));
            }
        }

        public Stall addPerson() {
            // Find min(Ls,Rs)
            Queue<Stall> minQ = new LinkedList<Stall>();
            int maxMin = 0;
            for (int i=0; i < n; i++) {
                if (!a[i].occupied) {
                    if (a[i].min >= maxMin) {
                        minQ.add(a[i]);
                        maxMin = a[i].min;
                    }
                }
            }
            // If queue empty then we're all full
            if (minQ.isEmpty()) {
                return(null);
            }
            // If we've got more than one get max(Ls,Rs)
            Stall stall = minQ.remove();
            if (!minQ.isEmpty()) {
                Queue<Stall> maxQ = new LinkedList<Stall>();
                int maxMax = 0;
                if (stall.min == maxMin) {
                    maxMax = stall.max;
                    maxQ.add(stall);
                }
                while (!minQ.isEmpty()) {
                    Stall t = minQ.remove();
                    if (t.min == maxMin && t.max >= maxMax) {
                        maxQ.add(t);
                        maxMax = t.max;
                    }
                }
                // If we still have multiple then use leftmost
                while (!maxQ.isEmpty()) {
                    stall = maxQ.remove();
                    if (stall.max == maxMax) {
                        break;
                    }
                }
            }
            // Set stall to occupied
            stall.occupied = true;

            // Now recalc spaces to left of me
            for (int i=stall.idx-1; i >= 0; i--) {
                int space = stall.idx - i - 1;
                a[i].rs = space;
                a[i].min = Math.min(a[i].ls, a[i].rs);
                a[i].max = Math.max(a[i].ls, a[i].rs);
                if (a[i].occupied) { 
                    stall.ls = space;
                    stall.min = Math.min(stall.ls, stall.rs);
                    stall.max = Math.max(stall.ls, stall.rs);
                    break;
                }
            }
            // Now recalc spaces to right of me
            for (int i=stall.idx+1; i < n; i++) {
                int space = i - stall.idx - 1;
                a[i].ls = space;
                a[i].min = Math.min(a[i].ls, a[i].rs);
                a[i].max = Math.max(a[i].ls, a[i].rs);
                if (a[i].occupied) {
                    stall.rs = space;
                    stall.min = Math.min(stall.ls, stall.rs);
                    stall.max = Math.max(stall.ls, stall.rs);
                    break;
                }
            }
            return(stall);
        }

        public String toString() {
            String str = "";
            for (int i=0; i < n; i++) {
                str += a[i]+" ";
            }

            return(str);
        }
    }

    public String solve(int n, int k) {
        // Create new stalls
        Stalls s = new Stalls(n);

        // Now add each person in order
        Stall stall = null;
        for (int i=0; i < k; i++) {
            stall = s.addPerson();
        }
        // create string
        String st = stall.max+" "+stall.min;
        return(st);
    }

    public static void main(String [] args) {
        Scanner in = new Scanner(System.in);
        Solution s = new Solution();
        int t = in.nextInt();
        for (int i=0; i < t; i++) {
            int n = in.nextInt();
            int k = in.nextInt();
            System.out.println("Case #"+(i+1)+": "+s.solve(n, k));
        }
    }
}

