/**
 * @Author <a href="mailto:serafin.sedano@gmail.com">Serafin Sedano</a>
 */
package org.detryo;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

/**
 * @author <a href="mailto:serafin.sedano@gmail.com">Serafin Sedano</a>
 */
public class Template
{
    private static final String INPUT_SMALL = "B-small-attempt0.in";

    private static final String OUTPUT_SMALL = "B-small-attempt0.out";

    public static void main(String[] args)
    {
        int currentCase = 1;
        StringBuilder output = new StringBuilder();

        try (Scanner sc = new Scanner(new File(INPUT_SMALL)))
        {
            int cases = sc.nextInt();

            for (int i = 0; i < cases; i++)
            {
                output.append("Case #").append(currentCase).append(": ");
                int a = sc.nextInt();
                int b = sc.nextInt();
                int k = sc.nextInt();
                int t = 0;
                for (int n = 0; n < a; n++)
                {
                    String na = String.format("%032d", Integer.valueOf(Integer.toBinaryString(n)));
                    for (int l = 0; l < b; l++)
                    {
                        String lb = String.format("%032d", Integer.valueOf(Integer.toBinaryString(l)));
                        String g = "";
                        int max = Math.max(na.length(), lb.length());
                        for (int lk = 0; lk < max; lk++)
                        {
                            char aa = '0';
                            if (lk < na.length())
                            {
                                aa = na.charAt(lk);
                            }
                            char ba = '0';
                            if (lk < lb.length())
                            {
                                ba = lb.charAt(lk);
                            }
                            if (aa == '1' && ba == '1')
                            {
                                g += '1';
                            }
                            else
                            {
                                g += '0';
                            }
                        }
                        
                        String reverse = reverse(g);
                        int lk = Integer.parseUnsignedInt(g, 2);
                        if (lk < k)
                        {
                            t++;
                        }
                        else
                        {
                            t = t;
                        }
                    }
                }
                output.append(t).append("\n");
                currentCase++;
            }
            writeOutputToFile(output.toString());
        }
        catch (Exception e)
        {
            System.out.println(output.toString());
            System.out.println(e.getMessage());
            System.out.println(e.getClass());
        }

    }

    /**
     * @param g
     * @return
     */
    private static String reverse(String g)
    {
        char[] c = g.toCharArray();
        for (int n = 0; n < c.length / 2; n++)
        {
            char aux = c[n];
            c[n] = c[c.length - 1 - n];
            c[c.length - 1 - n] = aux;
        }
        return new String(c);
    }

    /**
     * @param charArray
     * @return
     */
    private static char[] fill(char[] charArray)
    {
        char[] cs = new char[32];
        Arrays.fill(cs, '0');
        for (int i = charArray.length - 1; i >= 0; i--)
        {
            cs[charArray.length - i] = charArray[i];
        }
        return cs;
    }

    private static void writeOutputToFile(String out)
    {
        try (PrintWriter writer = new PrintWriter(OUTPUT_SMALL))
        {
            writer.write(out);
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
    }
}
