/**
 * @Author <a href="mailto:serafin.sedano@gmail.com">Serafin Sedano</a>
 */
package org.detryo;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

/**
 * @author <a href="mailto:serafin.sedano@gmail.com">Serafin Sedano</a>
 */
public class DeceitfulWar
{
    private static final String INPUT_SMALL = "D-small-attempt2.in";

    private static final String OUTPUT_SMALL = "D-small-attempt2.out";

    public static void main(String[] args) throws Exception
    {
        int currentCase = 1;
        StringBuilder output = new StringBuilder();

        try (Scanner sc = new Scanner(new File(INPUT_SMALL)))
        {
            int cases = sc.nextInt();

            for (int i = 0; i < cases; i++)
            {
                output.append("Case #").append(currentCase).append(": ");
                int blocks = sc.nextInt();
                double[] naomi = new double[blocks];
                double[] ken = new double[blocks];
                for (int j = 0; j < naomi.length; j++)
                {
                    naomi[j] = sc.nextDouble();
                }
                for (int j = 0; j < ken.length; j++)
                {
                    ken[j] = sc.nextDouble();
                }
                Arrays.sort(naomi);
                Arrays.sort(ken);

                int dec = playDeceitful(naomi, ken);
                int ord = playOrdinary(naomi, ken);

                output.append(dec).append(" ").append(ord);

                output.append("\n");

                for (int j = 0; j < naomi.length; j++)
                {
                    System.out.print(String.format("%.7f ", naomi[j]));
                }
                System.out.println();
                for (int j = 0; j < ken.length; j++)
                {
                    System.out.print(String.format("%.7f ", ken[j]));
                }
                System.out.println();
                currentCase++;
            }
            writeOutputToFile(output.toString());
        }
    }

    /**
     * @param naomi
     * @param ken
     * @return
     */
    private static int playOrdinary(double[] naomi, double[] ken)
    {
        int score = 0;
        for (int i = 0, j = 0; i < naomi.length && j < ken.length; j++, i++)
        {
            while (j < ken.length && naomi[i] > ken[j])
            {
                j++;
            }
            if (j < ken.length && naomi[i] < ken[j])
            {
                score++;
            }
        }
        return naomi.length - score;
    }

    /**
     * @param naomi
     * @param ken
     * @return
     */
    private static int playDeceitful(double[] naomi, double[] ken)
    {
        int score = 0;
        for (int i = naomi.length, j = ken.length; i > 0 && j > 0; j--, i--)
        {
            while (j > 0 && naomi[i - 1] > ken[j - 1])
            {
                j--;
            }
            if (j > 0 && naomi[i - 1] > ken[j - 1])
            {
                score++;
            }
        }

        return score;
    }

    private static void writeOutputToFile(String out)
    {
        try (PrintWriter writer = new PrintWriter(OUTPUT_SMALL))
        {
            writer.write(out);
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
    }
}
