/**
 * @Author <a href="mailto:serafin.sedano@gmail.com">Serafin Sedano</a>
 */
package org.detryo;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

/**
 * @author <a href="mailto:serafin.sedano@gmail.com">Serafin Sedano</a>
 */
public class Magician
{
    private static final String INPUT_SMALL = "A-small-attempt0.in";

    private static final String OUTPUT_SMALL = "A-small-attempt0.out";

    private static final int ROWS = 4;

    public static void main(String[] args) throws Exception
    {
        int currentCase = 1;
        StringBuilder output = new StringBuilder();

        try (Scanner sc = new Scanner(new File(INPUT_SMALL)))
        {
            int cases = sc.nextInt();

            for (int i = 0; i < cases; i++)
            {
                int first = nextInt(sc);
                Set<String> row1 = getRow(sc, first);
                int second = nextInt(sc);
                Set<String> row2 = getRow(sc, second);
                row1.retainAll(row2);

                solve(currentCase, output, row1);
                currentCase++;
            }
            writeOutputToFile(output.toString());
        }
    }

    private static int nextInt(Scanner sc)
    {
        int first = sc.nextInt();
        sc.nextLine();
        return first;
    }

    private static void solve(int currentCase, StringBuilder output, Set<String> row1)
    {
        output.append("Case #").append(currentCase).append(": ");
        int elements = row1.size();
        switch (elements)
        {
            case 0:
            {
                output.append("Volunteer cheated!\n");
                break;
            }
            case 1:
            {
                String card = row1.iterator().next();
                output.append(card).append("\n");
                break;
            }
            default:
            {
                output.append("Bad magician!\n");
            }
        }
    }

    private static Set<String> getRow(Scanner sc, int first)
    {
        String row = null;
        for (int j = 1; j <= ROWS; j++)
        {
            if (first == j)
            {
                row = sc.nextLine();
            }
            else
            {
                sc.nextLine();
            }
        }
        if (row != null)
        {
            return new HashSet<>(Arrays.asList(row.split(" ")));
        }
        throw new RuntimeException("There is no such line");
    }

    private static void writeOutputToFile(String out)
    {
        try (PrintWriter writer = new PrintWriter(OUTPUT_SMALL))
        {
            writer.write(out);
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
    }
}
