/**
 * @Author <a href="mailto:serafin.sedano@gmail.com">Serafin Sedano</a>
 */
package org.detryo;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * @author <a href="mailto:serafin.sedano@gmail.com">Serafin Sedano</a>
 */
public class CookieJar
{
    private static final String INPUT_SMALL = "B-small-attempt0.in";

    private static final String OUTPUT_SMALL = "B-small-attempt0.out";
    
    private static final String LARGE = "B-large.in"; private static final String OUT = "B-large.out";
    

    public static void main(String[] args) throws Exception
    {
        int currentCase = 1;
        StringBuilder output = new StringBuilder();

        try (Scanner sc = new Scanner(new File(LARGE)))
        {
            int cases = sc.nextInt();

            for (int i = 0; i < cases; i++)
            {
                double c = sc.nextDouble();
                double f = sc.nextDouble();
                double x = sc.nextDouble();
                sc.nextLine();

                double solve = solve(c, f, x);
                output.append("Case #").append(currentCase).append(": ")
                    .append(String.format("%.7f", solve)).append("\n");
                currentCase++;
            }
            writeOutputToFile(output.toString());
        }
    }

    private static double solve(double c, double f, double x)
    {
        double pr = 2;
        double a = 0;

        double current = x / pr;
        double farm = c / pr;
        double inc = pr + f;
        double next = a + farm + (x / inc);
        while (current > next)
        {
            a += farm;
            current = next;
            pr = inc;
            farm = c / pr;
            inc = pr + f;
            next = a + farm + (x / inc);
        }
        return current;
    }

    private static void writeOutputToFile(String out)
    {
        try (PrintWriter writer = new PrintWriter(OUT))
        {
            writer.write(out);
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
    }
}
