package C;

import java.io.IOException;
import java.math.BigInteger;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Main {

	public static String convertFromBaseToBase(String number, int from, int to) {
		return Long.toString(Long.parseLong(number, from), to);
	}
	
	public static boolean isProbablePrime(String s) {
		BigInteger n = new BigInteger(s);
		return n.isProbablePrime(1000000);
	}
	
	// N ... Length of the JamCoin
	// J ... Amount of JamCoins to be generated
	public static Map<String, List<Long>> generateJamCoins(int N, int J) {
		Map<String, List<Long>> coins = new HashMap<String, List<Long>>();
		String tmp = "1";
		for(int i = 0; i < N - 2; i++) {
			tmp += "0";
		}
		tmp += "1";
		int min = Integer.parseInt(convertFromBaseToBase(tmp, 2, 10));
		for(int i = min; coins.size() < J; i += 2) {
			String coin = convertFromBaseToBase(""+i, 10, 2);
			boolean isCoin = true;
			List<Long> divisors = new ArrayList<Long>();
			for(int j = 2; j <= 10; j++) {
				long number = Long.parseLong(convertFromBaseToBase(coin, j, 10));
				if(isProbablePrime(""+number)) {
					isCoin = false;
					break;
				} else {
					for(long k = 2; k < number; k++) {
						if(number % k == 0) {
							divisors.add(k);
							break;
						}
					}
				}
			}
			if(isCoin) {
				coins.put(coin, divisors);
			}
		}
		
		return coins;
	}
	
	public static void main(String[] args) throws IOException {
		List<String> lines = Files.readAllLines(Paths.get("C-small-attempt0.in"));
		int amount = new Integer(lines.get(0));
		StringBuilder sb = new StringBuilder();
		for(int i = 1; i <= amount; i++) {
			String s = lines.get(i);
			Pattern pattern = Pattern.compile("^(\\d+) (\\d+)$");
			Matcher matcher = pattern.matcher(s);
			if(matcher.find()) {
				int N = Integer.parseInt(matcher.group(1));
				int J = Integer.parseInt(matcher.group(2));
				sb.append("Case #" + i + ":\n");
				for(Entry<String, List<Long>> entry : generateJamCoins(N, J).entrySet()) {
					sb.append(entry.getKey() + " ");
					for(long divisor : entry.getValue()) {
						sb.append(divisor + " ");
					}
					sb.append("\n");
				}
			}
		}
		Files.write(Paths.get("C-small-attempt0.out"), sb.toString().getBytes());
	}

}
