package C;

import java.io.IOException;
import java.math.BigInteger;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Main {

	public static String convertFromBaseToBase(String number, int from, int to) {
		return new BigInteger(number, from).toString(to);
	}
	
	public static boolean isProbablePrime(String s) {
		BigInteger n = new BigInteger(s);
		return n.isProbablePrime(1000000);
	}
	
	// N ... Length of the JamCoin
	// J ... Amount of JamCoins to be generated
	public static Map<String, List<BigInteger>> generateJamCoins(int N, int J) throws IOException {
		List<String> primes = Files.readAllLines(Paths.get("primes1000000.txt"));
		List<BigInteger> biPrimes = new ArrayList<BigInteger>();
		for(String prime : primes) {
			biPrimes.add(new BigInteger(prime));
		}
		Map<String, List<BigInteger>> coins = new HashMap<String, List<BigInteger>>();
		String tmp = "1";
		for(int i = 0; i < N - 2; i++) {
			tmp += "0";
		}
		tmp += "1";
		BigInteger min = new BigInteger(convertFromBaseToBase(tmp, 2, 10));
		BigInteger two = new BigInteger("2");
		for(BigInteger i = min; coins.size() < J; i = i.add(two)) {
			String coin = convertFromBaseToBase(""+i, 10, 2);
			boolean isCoin = true;
			List<BigInteger> divisors = new ArrayList<BigInteger>();
			for(int j = 2; j <= 10; j++) {
				BigInteger number = new BigInteger(convertFromBaseToBase(coin, j, 10));
				if(isProbablePrime(""+number)) {
					isCoin = false;
					break;
				} else {
					for(BigInteger prime : biPrimes) {
						if(number.mod(prime).equals(BigInteger.ZERO)) divisors.add(prime);
					}
				}
			}
			if(isCoin) {
				coins.put(coin, divisors);
				System.out.println(coins.size());
			}
		}
		
		return coins;
	}
	
	public static void main(String[] args) throws IOException {
		List<String> lines = Files.readAllLines(Paths.get("C-large.in"));
		int amount = new Integer(lines.get(0));
		StringBuilder sb = new StringBuilder();
		for(int i = 1; i <= amount; i++) {
			String s = lines.get(i);
			Pattern pattern = Pattern.compile("^(\\d+) (\\d+)$");
			Matcher matcher = pattern.matcher(s);
			if(matcher.find()) {
				int N = Integer.parseInt(matcher.group(1));
				int J = Integer.parseInt(matcher.group(2));
				sb.append("Case #" + i + ":\n");
				for(Entry<String, List<BigInteger>> entry : generateJamCoins(N, J).entrySet()) {
					sb.append(entry.getKey() + " ");
					for(BigInteger divisor : entry.getValue()) {
						sb.append(divisor + " ");
					}
					sb.append("\n");
				}
			}
		}
		Files.write(Paths.get("C-large.out"), sb.toString().getBytes());
	}

}
