package prob3;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Bathroom {
	
	static String infile = "D:\\Dev\\algo\\CodeJamPractice\\2017Qual\\prob3\\input.in", 
			outfile = "D:\\Dev\\algo\\CodeJamPractice\\2017Qual\\prob3\\output.out";
	static String prefix = "Case #", suffix1 = ": YES", suffix2 = ": NO";
	static BufferedReader br;
	static BufferedWriter bw;
	
	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new FileReader(infile));
		bw = new BufferedWriter(new FileWriter(outfile));
		solve();
		bw.flush();
		bw.close();
		br.close();
	}
	
	static void solve() throws IOException {
		int T = Integer.parseInt(getNextLine());
		for(int i=1;i<=T;i++) {
			String[] in = getNextLine().split(" ");
			long n = Long.parseLong(in[0]);
			long k = Long.parseLong(in[1]);
			
			//People gone in till last equal division
			long treeDepth = (long)Math.floor(Math.log(k)/Math.log(2.0));
			long peopleEntered = (long)Math.pow(2, treeDepth) - 1;
			
			long remBath = n - peopleEntered;
			long equalDivSize = remBath/(peopleEntered+1);
			long spareDivCount = remBath%(peopleEntered+1);
			
			long peoplePending = k - peopleEntered;
			long lastSlotSize = equalDivSize;
			if(peoplePending<=spareDivCount) {
				lastSlotSize++;
			}
			
			if(lastSlotSize%2==0) {
				writeLine(prefix + i + ": " + lastSlotSize/2 + " " + (lastSlotSize/2-1));
			} else {
				writeLine(prefix + i + ": " + (lastSlotSize-1)/2 + " " + (lastSlotSize-1)/2);
			}
		}
	}
	
	static void writeLine(String next) throws IOException {
		bw.write(next);
		bw.write("\n");
	}
	
	static String getNextLine() throws IOException {
		String next = br.readLine();
		if(next==null) return null;
 		while(next!=null && next.trim().isEmpty()) {
			next = br.readLine();
		}
 		return next;
	}

}
