import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.util.InputMismatchException;


public class ProblemB {
	
	public static void main(String[] args) throws IOException {
		String inputFileName = "B-small-attempt1.in";
		Reader reader = new Reader(new FileInputStream(inputFileName));
		
		String outputFileName = inputFileName.split("\\.")[0] + ".out";
		File file = new File(outputFileName);
		file.createNewFile();
		BufferedWriter out = new BufferedWriter(new FileWriter(file.getAbsoluteFile()));
		

		int T = (int) reader.nextInt();
		
		for (int t = 1; t <= T; t++) {
			String answer = "";
			
			int B = (int) reader.nextInt();
			long N = reader.nextInt();
			
			long[] M = new long[B + 1];
			long minM = Long.MAX_VALUE;
			for (int i = 1; i <= B; i++) {
				M[i] = reader.nextInt();
				
				if (M[i] < minM) {
					minM = M[i];
				}
			}
			
			long currIndex = B;
			long barberNo = -1;
			long barberNo2 = -1;
			
			if (currIndex >= N) {
				barberNo = N;
				barberNo2 = N;
			} else {
				barberNo = getBarberNo(M, N, 0, N * minM, minM);
				
				
				/*
				for (int i = 1; i <= N; i++) {
					long currTime = i * minM;
					for (int j = 1; j < M.length; j++) {
						if ((currTime % M[j]) / minM == 0) {
							currIndex++;
						}
						
						if (currIndex == N) {
							barberNo2 = j;
							break;
						}
					}
					
					if (barberNo2 != -1) {
						break;
					}
				}
				*/
			}
			
			answer = "Case #" + t + ": " + barberNo;// + " " + barberNo2;
			
			if (t != T) {
				answer = answer + "\n";
			}
			
			out.write(answer);
			System.out.print(answer);
		}
		
		
		out.flush();
		out.close();
	}
	
	static int getBarberNo(long[] M, long N, long start, long end, long minM) {
		long currTime = (start + end) / 2;
		
		long peopleShavedSoFar = 0;
		for (int i = 1; i < M.length; i++) {
			peopleShavedSoFar = peopleShavedSoFar + currTime / M[i]; 
		}
		
		long currIndex = peopleShavedSoFar;
		if (peopleShavedSoFar == N || end == start + 1) {
			currTime = currTime - minM - 1;
			peopleShavedSoFar = 0;
			for (int i = 1; i < M.length; i++) {
				peopleShavedSoFar = peopleShavedSoFar + currTime / M[i]; 
			}
			currIndex = peopleShavedSoFar;
			for (currTime = currTime; true; currTime++) {
				for (int j = 1; j < M.length; j++) {
					if (currTime % M[j] == 0) {
						currIndex++;
					}
					if (currIndex == N) {
						return j;
					}
				}
			}
		}
		else if (peopleShavedSoFar == N - 1) {
			for (long i = currTime; true; i++) {
				for (int j = 1; j < M.length; j++) {
					if (i % M[j] == 0) {
						return j;
					}
				}
			}
		} else if (peopleShavedSoFar >= N) {
			return getBarberNo(M, N, start, currTime, minM);
		} else {
			return getBarberNo(M, N, currTime, end, minM);
		}
		
		
	}
	
	static class Reader {

		private InputStream stream;
		private byte[] buf = new byte[1024 * 1024];
		private int curChar;
		private int numChars;

		public Reader(InputStream stream) {
			this.stream = stream;
		}

		public int read() {
			if (numChars == -1)
				throw new InputMismatchException();
			if (curChar >= numChars) {
				curChar = 0;
				try {
					numChars = stream.read(buf);
				} catch (IOException e) {
					throw new InputMismatchException();
				}
				if (numChars <= 0)
					return -1;
			}
			return buf[curChar++];
		}
		
		public long nextInt() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			int sgn = 1;
			if (c == '-') {
				sgn = -1;
				c = read();
			}
			long res = 0;
			do {
				if (c < '0' || c > '9')
					throw new InputMismatchException();
				res *= 10;
				res += c & 15;
				c = read();
			} while (!isSpaceChar(c));
			return res * sgn;
		}

		public String next() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			StringBuilder res = new StringBuilder();
			do {
				res.appendCodePoint(c);
				c = read();
			} while (!isSpaceChar(c));
			return res.toString();
		}

		public static boolean isSpaceChar(int c) {
			return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
		}

	}
}