package codejam2016;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.HashMap;
import java.util.Queue;
import java.util.Scanner;

public class ProblemC {
	public static void main(String[] args) throws IOException {
		String inputFilename = "C-small-attempt0.in";
		String outputFilename = inputFilename + ".out";

		// Standard input
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

		// File input
		br = new BufferedReader(new InputStreamReader(new FileInputStream(inputFilename)));

		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outputFilename)));

		String line = br.readLine();
		int T = (int) Integer.parseInt(line.trim());

		for (int i = 0; i < T; i++) {
			String answer = "Case #" + (i + 1) + ": ";
			System.out.println(answer);
			bw.write(answer + "\n");


			line = br.readLine().trim();
			String[] strings = line.split(" ");
			int N = (int) Integer.parseInt(strings[0]);
			int J = (int) Integer.parseInt(strings[1]);
			
			long maxLimitOfCenter = (1 << (N - 2)) - 1;
			
			long count = 0;
			for (long k = 0; k <= maxLimitOfCenter && count < J; k++) {
				String str = "1" + String.format("%" + (N - 2) + "s", Long.toBinaryString(k)).replace(" ", "0") + "1";
				
				String result = validateJamCoin(str);
				if (!"0".equalsIgnoreCase(result)) {
					System.out.println(str + result);
					bw.write(str + result + "\n");
					count++;
				}
			}

			
		}
		br.close();
		bw.close();
	}

	public static String validateJamCoin(String str) {
		String result = "";
		if (str.length() < 2)
			return "0";

		if (str.charAt(0) != '1' || str.charAt(str.length() - 1) != '1')
			return "0";

		for (int i = 0; i < str.length(); i++) {
			if (str.charAt(i) != '1' && str.charAt(i) != '0') {
				return "0";
			}
		}
		
		for (int base = 2; base <= 10; base++) {
			long num = getNumber(str, base);
			long nonTrivialDivisor = getNonTrivialDivisor(num);
			if (nonTrivialDivisor == 0) {
				return "0";
			} else {
				result = result + " " + nonTrivialDivisor;
			}
		}
		return result;
	}

	public static long getNumber(String str, int base) {
		return Long.parseUnsignedLong(str, base);
	}

	public static long getNonTrivialDivisor(long n) {
		if (n == 2)
			return 0;
		// check if n is a multiple of 2
		if (n % 2 == 0)
			return 2;
		// if not, then just check the odds
		for (long i = 3; i * i <= n; i += 2) {
			if (n % i == 0)
				return i;
		}
		return 0;
	}
}
