import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.text.DecimalFormat;
import java.util.ArrayList;


public class ProblemB {
    public static void main(String[] args) {
        BufferedReader r = null;
        BufferedWriter bw = null;
        FileWriter fw = null;
        
        try {
            InputStreamReader myInputStreamReader = new InputStreamReader(
                    new FileInputStream("B-small-attempt0.in"));
            r = new BufferedReader(myInputStreamReader);
            
            File file = new File("B-small-attempt0.out");
            
            if (!file.exists()) {
                file.createNewFile();
            }
            
            fw = new FileWriter(file.getAbsoluteFile());
            bw = new BufferedWriter(fw);

            String line = r.readLine().toString();
            int T = Integer.parseInt(line);
            
            int[][] firstArrangement = new int[4][4];
            int[][] secondArrangement = new int[4][4];
            
            for (int t = 0; t < T; t++) {
                double answer = 0;
                
                line = r.readLine().toString();
                String[] inputStrings = line.split(" ");
                
                double C = Double.parseDouble(inputStrings[0]);
                double F = Double.parseDouble(inputStrings[1]);
                double X = Double.parseDouble(inputStrings[2]);
                
                
                double currentProductionRate = 2;
                
                double timeTakenWithoutBuyingAFarm = X / currentProductionRate;
                double timeTakenWithAFram = C / currentProductionRate + X / (currentProductionRate + F);
                
                while (timeTakenWithAFram < timeTakenWithoutBuyingAFarm) {
                    answer = answer + C / currentProductionRate;
                    
                    currentProductionRate += F;
                    
                    timeTakenWithoutBuyingAFarm = X / currentProductionRate;
                    timeTakenWithAFram = C / currentProductionRate + X / (currentProductionRate + F);
                }
                
                answer += X / currentProductionRate;
                
                
                DecimalFormat decimalFormat = new DecimalFormat("#.0000000");
                String strAnswer = decimalFormat.format(answer);
                
                String strCase = "Case #" + (t + 1) + ": ";
                System.out.println(strCase + strAnswer);
                bw.write(strCase + strAnswer);
                if (t < T - 1) {
                    bw.write("\n");
                }
                
            }

        } catch (NumberFormatException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                r.close();
                bw.close();
                fw.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
    
    private static ArrayList<Integer> commonNumbers(int[][] firstArrangement, int[][] secondArrangement, int firstRow, int secondRow) {
        ArrayList<Integer> commonNumbers = new ArrayList<Integer>();
        
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                if (firstArrangement[firstRow - 1][i] == secondArrangement[secondRow - 1][j]) {
                    commonNumbers.add(firstArrangement[firstRow - 1][i]);
                }
            }
        }
        
        return commonNumbers;
    }
}
