import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;

public class ProblemD {
	public static void main(String[] args) {
		BufferedReader r = null;
		BufferedWriter bw = null;
        FileWriter fw = null;
        
		try {
			InputStreamReader myInputStreamReader = new InputStreamReader(
					new FileInputStream("D-large.in"));
			r = new java.io.BufferedReader(myInputStreamReader);

			File file = new File("D-large.out");

			if (!file.exists()) {
				file.createNewFile();
			}

			fw = new FileWriter(file.getAbsoluteFile());
			bw = new BufferedWriter(fw);

			String[] inputStrings;
			String line = r.readLine().toString();
			int T = Integer.parseInt(line);

			for (int t = 0; t < T; t++) {
				line = r.readLine();
				int N = Integer.parseInt(line);

				ArrayList<Weight> naomiWeights = new ArrayList<Weight>();
				ArrayList<Weight> tempNaomiWeights = new ArrayList<Weight>();
				line = r.readLine();
				inputStrings = line.split(" ");

				for (int i = 0; i < inputStrings.length; i++) {
					naomiWeights.add(new Weight(Double
							.parseDouble(inputStrings[i]), true));
					tempNaomiWeights.add(new Weight(Double
							.parseDouble(inputStrings[i]), true));
				}

				line = r.readLine();
				inputStrings = line.split(" ");

				ArrayList<Weight> kenWeights = new ArrayList<Weight>();
				ArrayList<Weight> tempKenWeights = new ArrayList<Weight>();
				for (int i = 0; i < inputStrings.length; i++) {
					kenWeights.add(new Weight(Double
							.parseDouble(inputStrings[i]), false));
					tempKenWeights.add(new Weight(Double
							.parseDouble(inputStrings[i]), false));
				}

				Collections.sort(naomiWeights, new Comparator<Weight>() {

					@Override
					public int compare(Weight o1, Weight o2) {
						if (o1.mass < o2.mass) {
							return -1;
						}

						if (o1.mass > o2.mass) {
							return 1;
						}

						return 0;
					}
				});

				Collections.sort(kenWeights, new Comparator<Weight>() {

					@Override
					public int compare(Weight o1, Weight o2) {
						if (o1.mass < o2.mass) {
							return -1;
						}

						if (o1.mass > o2.mass) {
							return 1;
						}

						return 0;
					}
				});
				
				Collections.sort(tempNaomiWeights, new Comparator<Weight>() {
					
					@Override
					public int compare(Weight o1, Weight o2) {
						if (o1.mass < o2.mass) {
							return -1;
						}
						
						if (o1.mass > o2.mass) {
							return 1;
						}
						
						return 0;
					}
				});
				
				Collections.sort(tempKenWeights, new Comparator<Weight>() {
					
					@Override
					public int compare(Weight o1, Weight o2) {
						if (o1.mass < o2.mass) {
							return -1;
						}
						
						if (o1.mass > o2.mass) {
							return 1;
						}
						
						return 0;
					}
				});

				int warKenPoints = 0;
				int warNaomiPoints = 0;
				while (naomiWeights.size() > 0) {
					Weight naomiWeight = naomiWeights.remove(0);
					for (Weight weight : kenWeights) {
						if (weight.mass > naomiWeight.mass) {
							warKenPoints = warKenPoints + 1;
							kenWeights.remove(weight);

							break;
						}
					}

					if (naomiWeights.size() != kenWeights.size()) {
						kenWeights.remove(0);

						warNaomiPoints++;
					}

				}

				kenWeights = tempNaomiWeights;
				naomiWeights = tempKenWeights;
				int dWarKenPoints = 0;
				int dWarNaomiPoints = 0;
				while (naomiWeights.size() > 0) {
					Weight naomiWeight = naomiWeights.remove(0);
					for (Weight weight : kenWeights) {
						if (weight.mass > naomiWeight.mass) {
							dWarKenPoints++;
							kenWeights.remove(weight);

							break;
						}
					}

					if (naomiWeights.size() != kenWeights.size()) {
						kenWeights.remove(0);

						dWarNaomiPoints++;
					}

				}

				String strCase = "Case #" + (t + 1) + ": ";

				System.out.println(strCase + dWarKenPoints + " "
						+ warNaomiPoints);
				
				bw.write(strCase + dWarKenPoints + " "
						+ warNaomiPoints);
                if (t < T - 1) {
                    bw.write("\n");
                }

			}

		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
			    r.close();
			    bw.close();
			    fw.close();
			} catch (IOException e) {
			    e.printStackTrace();
			}
		}
	}

	private static class Weight {
		public boolean isNaomis = true;
		public double mass = 0;

		public Weight(double mass, boolean isNaomis) {
			this.mass = mass;
			this.isNaomis = isNaomis;
		}
		
		@Override
		public String toString() {
			// TODO Auto-generated method stub
			return "" + this.mass;
		}
	}
}
