package round1a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.text.DecimalFormat;

public class ProblemA {
	public static void main(String args[]){
		try{
			FileInputStream fileInputStream = new FileInputStream(args[0] + ".in");
			DataInputStream in = new DataInputStream(fileInputStream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			
			FileWriter fstream = new FileWriter(args[0] + ".out");
			BufferedWriter out = new BufferedWriter(fstream);
			
			String[] inputs;
			String strLine;
			
			strLine = br.readLine();
			int T = Integer.parseInt(strLine);
			
			for(int i = 1; i <= T; i++){
				strLine = br.readLine();
				
				inputs = strLine.split(" ");
				int A = Integer.parseInt(inputs[0]);
				int B = Integer.parseInt(inputs[1]) - A;
				
				strLine = br.readLine();
				inputs = strLine.split(" ");
				
				float[] p = new float[A];
				for(int j = 0; j < A; j++){
					p[j] = Float.parseFloat(inputs[j]);
				}
				
				int totalKeystrokes;
				float[] expectedKeystrokes = new float[A + 2];
				
				// Keystrokes if I press enter right away
				totalKeystrokes =  1 + A + B + 1;
				expectedKeystrokes[A + 1] = totalKeystrokes;
				
				for(int backspaces = 0; backspaces <= A; backspaces++){
					// Case word is right
					int requiredKeyStrokesCaseA = backspaces * 2 + B + 1;
					float probabilityOfRight = 1;
					for(int j = 0; j < (A - backspaces); j++){
						probabilityOfRight = probabilityOfRight * p[j];
					}
					
					// Case word is wrong
					int requiredKeyStrokesCaseB = backspaces * 2 + B + 1 + A + B + 1;
					float probablityOfWrong = 1 - probabilityOfRight;
					
					expectedKeystrokes[backspaces] = probabilityOfRight * requiredKeyStrokesCaseA + probablityOfWrong * requiredKeyStrokesCaseB;
				}
				
				DecimalFormat decimalFormat = new DecimalFormat();
				decimalFormat.setMinimumFractionDigits(6);
				decimalFormat.setMaximumFractionDigits(6);
				
				String result = decimalFormat.format(min(expectedKeystrokes));
				
				System.out.println("Case #" + i + ": " + result);
				out.write("Case #" + i + ": " + result + "\n");
			}
			out.close();
		} catch (Exception e) {
			System.err.println("Error: " + e.getMessage());
		}
	}
	
	private static float min(float[] array){
		float result = array[0];
		for(int i = 1; i < array.length; i++){
			result = result < array[i] ? result : array[i];
		}
		return result;
	}
}
