import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Arrays;


public class ProblemB {
    public static void main(String[] args) {
        BufferedReader r = null;
        BufferedWriter bw = null;
        FileWriter fw = null;
        
        try {
            InputStreamReader myInputStreamReader = new InputStreamReader(
                    new FileInputStream("B-small-attempt0.in"));
            r = new BufferedReader(myInputStreamReader);
            
            File file = new File("B-small-attempt0.out");
            
            if (!file.exists()) {
                file.createNewFile();
            }
            
            fw = new FileWriter(file.getAbsoluteFile());
            bw = new BufferedWriter(fw);

            String line = r.readLine().toString();
            int T = Integer.parseInt(line);
            
            for (int t = 0; t < T; t++) {
                line = r.readLine().toString();
                String[] inputStrings = line.split(" ");
                int A = Integer.parseInt(inputStrings[0]);
                int B = Integer.parseInt(inputStrings[1]);
                int K = Integer.parseInt(inputStrings[2]);
                
                
                long possiblePairs = 0;
                for (int i = 0; i < A; i++) {
					for (int j = 0; j < B; j++) {
						int result = i & j;
						if (result < K) {
							possiblePairs++;
						}
					}
				}
                
                
                String strAnswer = "" + possiblePairs;
                
                
                
                String strCase = "Case #" + (t + 1) + ": ";
                System.out.println(strCase + strAnswer);
                bw.write(strCase + strAnswer);
                if (t < T - 1) {
                    bw.write("\n");
                }
                
                
            }

        } catch (NumberFormatException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                r.close();
                bw.close();
                fw.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
    
    private static boolean compare(long[] outlets, long[] devices, long switches) {
    	long[] tempOutlets = new long[outlets.length];
    	for (int i = 0; i < tempOutlets.length; i++) {
			tempOutlets[i] = outlets[i] ^ switches;
		}
    	Arrays.sort(tempOutlets);
    	for (int i = 0; i < devices.length; i++) {
			if (devices[i] != tempOutlets[i]) {
				return false;
			}
		}
    	return true;
    }
}
