/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.google.code.jam.jctest;

import java.util.ArrayList;
import java.util.HashMap;

/**
 *
 * @author jjchen1
 */
public class JamCoin {
    
    /**
    * This constructor takes no argument
    */
    public JamCoin()
    {
        //
    }
    
    /**
     * This method loads file and dig jam coin.
     * @param inputFile
     * @return String
     */
    public String loadFileAndDigJamCoin(String inputFile)
    {
        String resultStr = "";
        ArrayList<String> lines = FileConnector.readLines(inputFile);
        int numOfCases = Integer.parseInt(lines.get(0));
        for(int i=1; i<=numOfCases; i++){
            String n_j_str =  lines.get(i);
            
            resultStr += "Case #"+i+":  \n "+(""+digJamCoins(i, n_j_str)) +"\n";
            
        }
        FileConnector.writeToFile("C-result.out", resultStr, false);
        return resultStr;
    }
    
    /**
     * This method finds [J] jam coins with input number len[N]
     * 
     *  A jamcoin is a string of N ≥ 2 digits with the following properties:

           - Every digit is either 0 or 1.
           - The first digit is 1 and the last digit is 1.
           - If you interpret the string in any base between 2 and 10, inclusive, 
           - the resulting number is not prime.
     *
     *  Sample Output:
     *   Case #1:
            100011 5 13 147 31 43 1121 73 77 629
            111111 21 26 105 1302 217 1032 513 13286 10101
            111001 3 88 5 1938 7 208 3 20 11
                
     * 
     * @param caseNum
     * @param n_j_str
     * @return 
     */
    public String digJamCoins(int caseNum, String n_j_str)
    {
        ArrayList<String> results = new ArrayList<>();
        
        String[] inputs = GenericUtil.extractTokenArray(n_j_str, " ");
        int coinLen = Integer.parseInt(inputs[0]);
        int reqNumOfCoins = Integer.parseInt(inputs[1]);
        
        String minStr = "1"+GenericUtil.padLeadingZero(1, coinLen-1);
        String maxStr = "1"+Integer.toBinaryString((int)Math.pow(2, coinLen-1)-1);
        //System.out.println("N="+coinLen+", J="+reqNumOfCoins+" min:"+minStr+"; max: "+maxStr);
        
        // Base, DividerFound
        long factor = 1;
        HashMap<Integer, Long> baseMap = new HashMap<>();
        String factors = "";
        int count = 0;
        long min = Long.parseLong(minStr, 2);
        long max = Long.parseLong(maxStr, 2);
        for(long number = min; number <=max; number++)
        {
            String numBinStr = Long.toBinaryString(number);
            if(numBinStr.endsWith("1"))
            {
                // For each base 2-10, Permute between 100001 - 111111
                baseMap.clear();
                factors = "";
                for(int base=2; base<=10; base++)
                {
                    long decVal = Long.parseLong(numBinStr, base);
                    factor = GenericUtil.isNotPrime(decVal);
                    if(factor!=decVal && factor!=1){
                        baseMap.put(base, factor);
                        //System.out.println("numBinStr: "+numBinStr+", base: "+base+", decVal="+decVal+", div = "+factor);
                        factors +=" "+factor;
                    } 
                }
                //System.out.println("numBinStr: "+numBinStr+", tableSize: "+baseMap.size() +", factors: "+factors);
                if(baseMap.size()==9){ // all base found non-prime
                    results.add("\t"+numBinStr+" "+factors);
                    count++;
                    if(count >= reqNumOfCoins){
                        break;
                    }
                } 
            }
            
            
        }
        
        String reportStr="";
        for(String rep : results){
            reportStr += rep+"\n";
        }
        
        return reportStr;
    }
    
    
}
