/*
 * The JJC Public Community License
 *
 * Copyright 2016 Jinghong Janice Chen
 *
 * Permission is hereby granted, free of charge, to Google personal obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including the rights to use, copy, merge, distribute
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/**
 * $Id$
 *
 * Filename: CJProblemA.java
 * 
 * Purpose:  This class defines [TODO description to be supplied]
 * 
 * Project: Code Jam Rounds
 * 
 * Subsystem: com.google.code.jam.round1A
 * 
 * Author: Jinghong Janice Chen 
 * 
 * Create Date: Apr 15, 2016
 * 
 * Revision: 1.0
 * 
 * Notes:
 * <pre>
 * -----------------------------------------------------
 * Revision History
 * =================
 * Date        			Name          	    Change
 * ----        			-----------         -------
 * Apr 15, 2016                 Jinghong Chen       Initial version
 * </pre>
 */

package com.google.code.jam.round1A;

import java.util.ArrayList;

/**
 * This class defines [TODO description to be supplied]
 *
 * @author jjchen1
 * @version 1.0
 * @since 1.0
 */
public class CJProblemA {

    //private static String  srcId;

    /**
    * Constructor for CJProblemA
    */
    public CJProblemA()
    {
       //
    }
    
    ////// class member functions

    /**
     * This method loads file and start jamming ...
     * @param inputFile
     * @return String
     */
    public String loadInputAndGo(String inputFile)
    {
        String resultStr = "";

        ArrayList<String> lines = FileConnector.readLines(inputFile);
        int numOfCases = Integer.parseInt(lines.get(0));
        for(int i=1; i<=numOfCases; i++){
            resultStr += "Case #"+i+": "+ goJamming(i, lines.get(i)) +"\n";
        }
        FileConnector.writeToFile(inputFile.replaceAll("in", "out"), resultStr, false);

        return resultStr;
    }

    /**
     * This method gets last word
     *
     * @param caseNum
     * @param str
     * @return 
     */
    public String goJamming(int caseNum, String str)
    {
        //System.out.println("Case# "+caseNum+", Input: "+str);
        
        String lastWord = str.substring(0, 1);
        int firstCharAscii =0;
        char newChar;
        int newASCII =0; 
        for(int i=1; i<str.length(); i++){
            newChar = str.charAt(i); 
            newASCII = (int) newChar;
            
            firstCharAscii = (int)lastWord.charAt(0); // current 1st char
            if(newASCII < firstCharAscii){ // move to the right
                lastWord += newChar;
            } else { // move the left
                lastWord = newChar + lastWord; // 
            }
        }

        return lastWord;
    }
    

    //////////////////////////
    /**
     * This method provides quick unit testing
     * @param args
     */
    public static void main(String[] args)
    {
        CJProblemA jc = new CJProblemA();
        
        System.out.println(jc.goJamming(1, "CAB"));
        
    }
}
