/*
 * The JJC Public Community License
 *
 * Copyright 2017 Jinghong Janice Chen
 *
 * Permission is hereby granted, free of charge, to Google personal obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including the rights to use, copy, merge, distribute
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/**
 * $Id$
 *
 * Filename: FlipPancakes.java
 * 
 * Purpose:  This class defines [TODO description to be supplied]
 * 
 * Project: Code Jam Rounds
 * 
 * Subsystem: com.google.codejam2017.round0
 * 
 * Author: Jinghong Janice Chen 
 * 
 * Create Date: Apr 8, 2017
 * 
 * Revision: 1.0
 * 
 * Notes:
 * <pre>
 * -----------------------------------------------------
 * Revision History
 * =================
 * Date        			Name          	    Change
 * ----        			-----------         -------
 * Apr 8, 2017                 Jinghong Chen       Initial version
 * </pre>
 */

package com.google.codejam2017.round0;

import com.google.codejam2017.round0.FileConnector;
import java.util.ArrayList;

/**
 * This class defines [TODO description to be supplied]
 *
 * @author jjchen1
 * @version 1.0
 * @since 1.0
 */
public class FlipPancakes {

    //private static String  srcId;

    /**
    * Constructor for FlipPancakes
    */
    public FlipPancakes()
    {
       //
    }
    
    ////// class member functions

    /**
     * This method loads file and start processing
     * 
     * @param inputFile
     * @param outputFile
     * @return 
     */
    public String loadInputAndGo(String inputFile, String outputFile)
    {
        String resultStr = "";
        ArrayList<String> lines = FileConnector.readLines(inputFile);
        int numOfCases = Integer.parseInt(lines.get(0)); 
        for(int i=1; i<=numOfCases; i++){
            String pancakeStr =  lines.get(i);
            String[] tokens = GenericUtil.extractTokenArray(pancakeStr, " ");
            int numK = Integer.parseInt(tokens[1]);
            int numOfFlips =findMinNumOfFlips(tokens[0], numK);
            resultStr += "Case #"+i+":  "+((numOfFlips==-1)?"IMPOSSIBLE":""+numOfFlips) +"\n";
        }
        FileConnector.writeToFile(outputFile, resultStr, false);
        return resultStr;
    }
    
    /**
     * This method gets numOfFlips for each string starts with "+" recursively.
     * 
     * @param sourceStr
     * @param flipK
     * @return int
     */
    public int findMinNumOfFlips(String sourceStr, int flipK)
    {
        int currentNumOfFlips = 0;
        int firstIndexMinus = -1;
        String tmpStr = "";
        if(sourceStr.startsWith("+")){
            
            firstIndexMinus = sourceStr.indexOf("-");
            if(firstIndexMinus == -1){ // No "-". All "+". Good.
                return 0; // STOP point
            } 
            else {
                tmpStr = sourceStr.substring(firstIndexMinus);
                if(tmpStr.length()<flipK){
                    return -1;
                }
                
                int tmpNumFlips = findMinNumOfFlips(tmpStr, flipK);
                return (tmpNumFlips==-1)?tmpNumFlips:(currentNumOfFlips+tmpNumFlips);
                
            }
        } else if(sourceStr.startsWith("-")){
            
            if(sourceStr.length()<flipK){
                return -1;
            }
            
            // Flip first K char and form new string
            tmpStr = "";
            for(int j=0; j<sourceStr.length(); j++){
                if(j<flipK){
                    tmpStr += (sourceStr.charAt(j)=='-')?'+':'-';
                } else {
                    tmpStr += sourceStr.charAt(j);
                }
            }
            currentNumOfFlips++;
            int tmpNumFlips = findMinNumOfFlips(tmpStr, flipK);
            return (tmpNumFlips==-1)?tmpNumFlips:(currentNumOfFlips+tmpNumFlips);
            
        } else { // Something wrong with input.
            System.out.println(" wrong input: "+sourceStr);
        }
        
        return currentNumOfFlips;
    }
    
}