/*
 * The JJC Public Community License
 *
 * Copyright 2016 Jinghong Janice Chen
 *
 * Permission is hereby granted, free of charge, to Google personal obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including the rights to use, copy, merge, distribute
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/**
 * $Id$
 *
 * Filename: JCRoundAMainController.java
 * 
 * Purpose:  This class defines main controller.
 * 
 * Project: Code Jam Rounds
 * 
 * Subsystem: com.google.code.jam.round1A
 * 
 * Author: Jinghong Janice Chen 
 * 
 * Create Date: Apr 15, 2016
 * 
 * Revision: 1.0
 * 
 * Notes:
 * <pre>
 * -----------------------------------------------------
 * Revision History
 * =================
 * Date        			Name          	    Change
 * ----        			-----------         -------
 * Apr 15, 2016                 Jinghong Chen       Initial version
 * </pre>
 */

package com.google.code.jam.round1A;

/**
 * This class defines main controller (driver).
 *
 * @author jjchen1
 * @version 1.0
 * @since 1.0
 */

public class JCRoundAMainController {

   private static JCRoundAMainController  instance;

    private String srcId   = "JCRoundAMainController";
    
    /**
    * Constructor for JCRoundAMainController
    */
    private JCRoundAMainController()
    {
       //super(JCRoundAMainController.class.getName());

    }
    
    /**
     * This method provides singleton instance.
     * 
     * @return JCRoundAMainController
     */
    public static synchronized JCRoundAMainController getInstance()
    {
        if (null == instance){
            instance = new JCRoundAMainController();
        }
        return instance;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) 
    {
        //System.out.println("Hello Code Jam 2016 Round 1");

        //JCRoundAMainController jam = JCRoundAMainController.getInstance();
        //jam.testProblem1();

        try
        {
            int problemNum = 1;
            if(problemNum==1){ 
                CJProblemA probA = new CJProblemA();
                //String results = probA.loadInputAndGo("./A-test1.in");
                String results = probA.loadInputAndGo("./A-small-attempt0.in");
                //String results = probA.loadInputAndGo("./A-large.in");
                System.out.println(results);

            } else if (problemNum==2){ 
//                CJProblemB probB = new CJProblemB();
//                String results = probB.loadInputAndGo("./B-small-attempt0.in");
//                //String results = probB.loadInputAndGo("./B-large.in");
//                System.out.println(results);

            } else if (problemNum==3){ 
//                CJProblemC probC = new CJProblemC();
//                String results = probC.loadInputAndGo("./C-small-attempt0.in");
//                //String results = probC.loadInputAndGo("./C-large.in");
//                System.out.println(results);

            } else if (problemNum==4){ 
//                CJProblemD probD = new CJProblemD();
//                String results = probD.loadInputAndGo("./D-small-attempt0.in");
//                //String results = probD.loadInputAndGo("./D-large.in");
//                System.out.println(results);
            }
        }  catch (Exception e){
            e.printStackTrace();
        }

    }
}
