/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.google.code.jam.jctest;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

/**
 *
 * @author jjchen1
 */
public class FileConnector {
    
    private static String srcId = FileConnector.class.getName();

    /**
     * Constructor for FileConnector
     */
    public FileConnector()
    {
        super();
    }
    
    /**
     * This method checks if file exists.
     * 
     * @param fileName
     * @return long (timestamp of last modified. -1 if file non-exist)
     * 
     */
    public static long isFileExist(String fileName)
    {
        File file = new File(fileName);
        if(!file.exists())
        {
            //LogService.log(FileConnector.class.getName(), LogLevel.WARN, "File: " + fileName + " doesn't exist.");
            return -1;
        }
        return file.lastModified();
    }
    
    /**
     * This method writes data to file. If the data contains the binary, the string should contains correct
     * representation of the character for for the binary.
     * 
     * @param fileName
     * @param data
     * @param isAppend
     * @return boolean
     * 
     */
    public static boolean writeToFile(String fileName, String data, boolean isAppend)
    {
        boolean isSuccess = false;
        try
        {
            FileWriter outFile = new FileWriter(fileName, isAppend);
            outFile.write(data);
            outFile.flush();
            outFile.close();
            isSuccess = true;
        }
        catch(Exception e)
        {
            //LogService.logException(srcId, e, true);
        }
        return isSuccess;
    }

    /**
     * Reads the content of a text file as lines
     *
     * @param aFileName File name
     * @return The content of a file as lines
     */
    public static ArrayList<String> readLines(String aFileName)
    {
        try {
            ArrayList<String> lines = new ArrayList<>();
            try (BufferedReader reader = new BufferedReader( new FileReader(aFileName) )) {
                String line;
                
                while ((line = reader.readLine()) != null) {
                    lines.add( line );
                }
            }

            return lines;
        }
        catch (FileNotFoundException ex) {
        	ex.printStackTrace();
        }
        catch (IOException ex) {
        	ex.printStackTrace();
        }

        return null;
    }
    
}
