/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.google.code.jam.jctest;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 *
 * @author jjchen1
 */
public class CountingSheep {
    
    /**
    * This constructor takes no argument
    */
    public CountingSheep()
    {
        //
    }
    
    public List<String> readLines(String aFileName)
    {
        try {
            List<String> lines = new ArrayList<>();
            try (BufferedReader reader = new BufferedReader( new FileReader(aFileName) )) {
                String line;
                
                while ((line = reader.readLine()) != null) {
                    lines.add( line );
                }
            }

            return lines;
        }
        catch (FileNotFoundException ex) {
        }
        catch (IOException ex) {
        }

        return null;
    }
    
    public boolean writeToFile(String fileName, String data, boolean isAppend)
    {
        boolean isSuccess = false;
        try
        {
            try (FileWriter outFile = new FileWriter(fileName, isAppend)) {
                outFile.write(data);
                outFile.flush();
            }
            isSuccess = true;
        }
        catch(Exception e)
        {
            //
        }
        return isSuccess;
    }
    
    /**
     * This method loads input and computer result.
     * 
     * Input
     *   The first line of the input gives the number of test cases, T. 
     *   T test cases follow. Each consists of one line with a single number N, the number Bleatrix has chosen.
     * Output
     *   For each test case, output one line containing Case #x: y, where x is the test case number (starting from 1) 
     *   and y is the last number that Bleatrix will name before falling asleep, according to the rules described in 
     *   the statement. 
     *   
     * Limits  1 ≤ T ≤ 100. 
     * Small dataset
     *    0 ≤ N ≤ 200. 
     * Large dataset
     *    N ≤ 10^6.
     * 
     * 
        Problem

Bleatrix Trotter the sheep has devised a strategy that helps her fall asleep faster. First, she picks a number N. Then she starts naming N, 2 × N, 3 × N, and so on. Whenever she names a number, she thinks about all of the digits in that number. She keeps track of which digits (0, 1, 2, 3, 4, 5, 6, 7, 8, and 9) she has seen at least once so far as part of any number she has named. Once she has seen each of the ten digits at least once, she will fall asleep.

Bleatrix must start with N and must always name (i + 1) × N directly after i × N. For example, suppose that Bleatrix picks N = 1692. She would count as follows:

    N = 1692. Now she has seen the digits 1, 2, 6, and 9.
    2N = 3384. Now she has seen the digits 1, 2, 3, 4, 6, 8, and 9.
    3N = 5076. Now she has seen all ten digits, and falls asleep. ???

What is the last number that she will name before falling asleep? If she will count forever, print INSOMNIA instead. 
        
     * 
     * @param inputFile
     * @return String
     */
    public String readAndCounting(String inputFile)
    {
        
        String resultStr = "";
        ArrayList<String> lines = (ArrayList<String>) readLines(inputFile);
        int numOfCases = Integer.parseInt(lines.get(0));
        for(int i=1; i<=numOfCases; i++){
            int numberN =  Integer.parseInt(lines.get(i));
            resultStr += "Case #"+i+":\t"+countToLastNumber(i, numberN) +"\n";
        }
        
        //writeToFile("A-smal-attempt0.out", resultStr, false);
        writeToFile("A-large.out", resultStr, false);
        
        return resultStr;
    }
    
    /**
     * This method counts to last number within limit
     * @param caseNum
     * @param numberN
     * @return String
     */
    public String countToLastNumber(int caseNum, int numberN)
    {
        String insomnia = "INSOMNIA";
        if(numberN == 0){
            return insomnia;
        }
        
        HashMap<Integer, Integer> sheepCountingMap = new HashMap<>();
        boolean found = false;
        int i = 0;
        int numOfDigits = 0;
        int currNumber = numberN;
        int temp;
        int counter = 0;
        int maxCounter = 0;
        while(!found){
            currNumber = (++i)*numberN;
            //System.out.println("CurrNumber: "+currNumber);
            
            numOfDigits = (""+currNumber).length();
            temp = currNumber;
            while(numOfDigits>0){
                int key = temp % 10;
                if(!sheepCountingMap.containsKey(key)){
                    sheepCountingMap.put(key, 1);
                    //System.out.println("    key ="+key+";  Table size: "+sheepCountingMap.size());
                } else {
                    counter++;
                }
                temp /= 10;
                numOfDigits--;
            }
            
            if(sheepCountingMap.size()==10){
                found = true;
            }  
            
            maxCounter = 6000 / numOfDigits ;
            if(counter>maxCounter){ 
                System.out.println(" *** Case "+caseNum+":   counter="+counter+"; max: "+maxCounter+"; numberN: "+numberN);
                return insomnia;
            }
        }
        
        System.out.println("In: "+currNumber+", Case "+caseNum+":   counter="+counter);
        System.out.println(" maxCounter = "+maxCounter);
        return ""+currNumber;
    }
}




