/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.google.code.jam.jctest;

import java.util.StringTokenizer;

/**
 *
 * @author jjchen1
 */
public class GenericUtil {
    private static String srcId = FileConnector.class.getName();

    /**
     * Constructor for FileConnector
     */
    public GenericUtil()
    {
        super();
    }
    
    /**
     * 
     * @param tokenStr
     * @param delimiter
     * @return
     * @throws NullPointerException 
     */
    public static String[] extractTokenArray(final String tokenStr, final String delimiter) throws NullPointerException
    {
        if(tokenStr == null)
        {
            throw new NullPointerException("Supplied tokenStr is null.");
        }
        
        if(delimiter == null)
        {
            throw new NullPointerException("Supplied delimiter is null.");
        }
        
        StringTokenizer st = new StringTokenizer(tokenStr, delimiter);
        String[] cmdArray = new String[st.countTokens()];
        int i = 0;
        while (st.hasMoreTokens())
        {
            cmdArray[i] = st.nextToken();
            i++;
        }
        st = null;
        return cmdArray;
        
    }
    
    /**
     * This method checks if number is not prime number.
     * If it is not, it will return one of its divider.
     * If it is prime, it returns itself.
     * 
     * @param number
     * @return 
     */
    public static long isNotPrime(long number)
    {
        //check if number is a multiple of 2
        if (number%2==0) {
            return 2; // false - not a prime
        }
        
        // Try out dividers
        for(long iFactor=3; iFactor*iFactor<=number; iFactor+=2) {
            if(number % iFactor == 0){
                return iFactor; // false - not a prime return a divider
            }
        }
        return number;
    }
    
    /**
     * Convert binary string in base to decimal representation
     * @param binaryString
     * @param base
     * @return int (decimal value)
     */
    public int convertBinaryToNumber(String binaryString, int base)
    {
        int decimal = Integer.parseInt(binaryString, base);
        return decimal;
    }
    
    /**
     * This method pad leading zeros
     * @param number
     * @param numDigits
     * @return String
     */
    public static String padLeadingZero(final long number, final int numDigits)
    {
        String numberStr = "";

        int offset = numDigits;
        while (offset > 0)
        {
            offset--;
            if (number < Math.pow(10, offset))
            {
                numberStr += "0";
            }
            else
            {
                numberStr += number;
                break;
            }
        }

        return numberStr;
    }
}
