/*
 * The JJC Public Community License
 *
 * Copyright 2017 Jinghong Janice Chen
 *
 * Permission is hereby granted, free of charge, to Google personal obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including the rights to use, copy, merge, distribute
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/**
 * $Id$
 *
 * Filename: JcCodeJamMainController.java
 * 
 * Purpose:  This class defines [TODO description to be supplied]
 * 
 * Project: Code Jam Rounds
 * 
 * Subsystem: com.google.codejam2017.round0
 * 
 * Author: Janice Chen 
 * 
 * Create Date: Apr 8, 2017
 * 
 * Revision: 1.0
 * 
 * Notes:
 * <pre>
 * -----------------------------------------------------
 * Revision History
 * =================
 * Date        			Name          	    Change
 * ----        			-----------         -------
 * Apr 8, 2017                  Janice Chen         Initial version
 * </pre>
 */

package com.google.codejam2017.round0;

/**
 *
 * @author jjchen1
 */
public class JcCodeJamMainController {
    
    private static JcCodeJamMainController  instance;

    private String  subsystemName   = "unknown";
    
    /**
    * Constructor for JcCodeJamMainController
    */
    private JcCodeJamMainController()
    {
       //super(JcCodeJamMainController.class.getName());
    }
    
    /**
     * This method provides singleton instance.
     * 
     * @return EcsMainController
     */
    public static synchronized JcCodeJamMainController getInstance()
    {
        if (null == instance){
            instance = new JcCodeJamMainController();
        }
        return instance;
    }
    
    /**
    * This is the main driver.
    * @param args
    *            Usage: AppName 
    */
   public static void main(String[] args)
   {
       //System.out.println("Hello Code Jam 2017!");
       //JcCodeJamMainController jam = JcCodeJamMainController.getInstance();
       //jam.testProblem1();
       
       String results = "INVALID";
       String filePath = "./data/round0-2017/";
       int problemNum = 1;
       if(problemNum==1){ // flipping pancake
            //System.out.println("FlipPancakes");
            FlipPancakes pancakes = new FlipPancakes();
            //results = pancakes.loadInputAndGo(filePath+"A-test.in", filePath+"A-test.out");
            //results = pancakes.loadInputAndGo(filePath+"A-small-attempt0.in", filePath+"A-small-attempt0.out");
            results = pancakes.loadInputAndGo(filePath+"A-large.in", filePath+"A-large.out");
            System.out.println(results);
       } 
       else if (problemNum==2){ // tidy number
           
           //long number = (long) Math.pow(2, 60); //1152921504606846976> 10^18
           //System.out.println(""+number);
           
           //System.out.println("TidyNumber");
            //TidyNumber tidyNumber = new TidyNumber();
            //results = tidyNumber.loadInputAndGo(filePath+"B-small-attempt0.in", filePath+"B-test.out");
            //results = tidyNumber.loadInputAndGo(filePath+"B-small-attempt0.in", filePath+"B-small-attempt0.out");
            //results = tidyNumber.loadInputAndGo(filePath+"B-large.in", filePath+"B-large.out");
            //System.out.println(results);
       } 
//       else if (problemNum==3){ // Coin Jam
//            JamCoin coin = new JamCoin();
//            String results = coin.loadInputAndGo("./C-large.in");
//            System.out.println(results);
//            
//       } else if (problemNum==4){ // Fractiles
//            Fractiles tile = new Fractiles();
//            //String results = tile.loadInputAndGo("./test1.txt");
//            String results = tile.loadInputAndGo("./D-small-attempt0.in");
//            //String results = tile.loadInputAndGo("./D-large.in");
//            //System.out.println(results);
//       }

   }
}