/*
 * The JJC Public Community License
 *
 * Copyright 2017 Jinghong Janice Chen
 *
 * Permission is hereby granted, free of charge, to Google personal obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including the rights to use, copy, merge, distribute
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/**
 * $Id$
 *
 * Filename: TidyNumber.java
 * 
 * Purpose:  This class defines [TODO description to be supplied]
 * 
 * Project: Code Jam Rounds
 * 
 * Subsystem: com.google.codejam2017.round0
 * 
 * Author: Jinghong Janice Chen 
 * 
 * Create Date: Apr 8, 2017
 * 
 * Revision: 1.0
 * 
 * Notes:
 * <pre>
 * -----------------------------------------------------
 * Revision History
 * =================
 * Date        			Name          	    Change
 * ----        			-----------         -------
 * Apr 8, 2017                  Jinghong Chen       Initial version
 * </pre>
 */

package com.google.codejam2017.round0;

import java.util.ArrayList;

/**
 * This class defines [TODO description to be supplied]
 *
 * @author jjchen1
 * @version 1.0
 * @since 1.0
 */
public class TidyNumber {

    //private static String  srcId;

    /**
    * Constructor for TidyNumber
    */
    public TidyNumber()
    {
       //
    }
    
    ////// class member functions

    public String loadInputAndGo(String inputFile, String outputFile)
    {
        String resultStr = "";
        ArrayList<String> lines = FileConnector.readLines(inputFile);
        int numOfCases = Integer.parseInt(lines.get(0)); 
        for(int i=1; i<=numOfCases; i++){
            String line =  lines.get(i);
            String lastTydyNumber =findLastTidyNumber(line);
            if(lastTydyNumber.startsWith("0")){
                lastTydyNumber = lastTydyNumber.substring(1);
            }
            resultStr += "Case #"+i+":  "+lastTydyNumber +"\n";
        }
        FileConnector.writeToFile(outputFile, resultStr, false);
        return resultStr;
    }
    
    /**
     * This method performs what is needed to [...]
     *
     * @param numberStr
     * @return 
     */
    public String findLastTidyNumber(String numberStr)
    {
        if(numberStr.length()==1){
            return numberStr;
        }
        
        int len = numberStr.length();
        if(isTidy(numberStr, len)){
            return numberStr;
        }
        
        String resultStr = "";
        String tmpStr = "";
        int currDigit;
        int nextDigit;
        
        boolean dropFound = false;
        for(int index=0; index<len; index++)
        {
            if(!dropFound) {
                tmpStr = numberStr.substring(index, index+1);
                currDigit =  Integer.parseInt(tmpStr);
                nextDigit =  Integer.parseInt(numberStr.substring(index+1, index+2));

                if(currDigit <= nextDigit){
                    resultStr += tmpStr; // keep
                    
                } else {// currDigit>nextDigit
                    currDigit = currDigit-1;
                    
                    tmpStr = ""+currDigit;
                    resultStr += tmpStr;
                    dropFound = true;
                }
            } else {
                tmpStr = "9";
                resultStr += tmpStr; // change to "9";
            }
        }
        
        if(dropFound){
            return findLastTidyNumber(resultStr);
        }
        
        return resultStr;
    }
    
    /**
     * 
     * @param numberStr
     * @param len
     * @return 
     */
    public boolean isTidy(String numberStr, int len)
    {
        if(numberStr.length()==1){
            return true;
        }
        
        boolean isTidy = true;
        String tmpStr = "";
        int currDigit;
        int nextDigit;
        for(int index=0; index<len-1; index++)
        {
            tmpStr = numberStr.substring(index, index+1);
            currDigit =  Integer.parseInt(numberStr.substring(index, index+1));
            nextDigit =  Integer.parseInt(numberStr.substring(index+1, index+2));

            if(currDigit > nextDigit){
                return false;
            } 
        }
        return isTidy;
    }
}