/*
 * The JJC Public Community License
 *
 * Copyright 2016 Jinghong Janice Chen
 *
 * Permission is hereby granted, free of charge, to Google personal obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including the rights to use, copy, merge, distribute
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/**
 * $Id$
 *
 * Filename: GenericUtil.java
 * 
 * Purpose:  This class defines [TODO description to be supplied]
 * 
 * Project: Code Jam Rounds
 * 
 * Subsystem: com.google.code.jam.round1A
 * 
 * Author: Jinghong Janice Chen 
 * 
 * Create Date: Apr 12, 2016
 * 
 * Revision: 1.0
 * 
 * Notes:
 * <pre>
 * -----------------------------------------------------
 * Revision History
 * =================
 * Date        			Name          	    Change
 * ----        			-----------         -------
 * Apr 12, 2016                 Jinghong Chen       Initial version
 * </pre>
 */

package com.google.code.jam.round1A;

/**
 * This class defines [TODO description to be supplied]
 *
 * @author jjchen1
 * @version 1.0
 * @since 1.0
 */
import java.util.StringTokenizer;

/**
 *
 * @author jjchen1
 */
public class GenericUtil {
    
    /**
     * Constructor for FileConnector
     */
    public GenericUtil()
    {
        super();
    }
    
    
    
    
    
    /**
     * 
     * @param tokenStr
     * @param delimiter
     * @return
     * @throws NullPointerException 
     */
    public static String[] extractTokenArray(final String tokenStr, final String delimiter) throws NullPointerException
    {
        if(tokenStr == null)
        {
            throw new NullPointerException("Supplied tokenStr is null.");
        }
        
        if(delimiter == null)
        {
            throw new NullPointerException("Supplied delimiter is null.");
        }
        
        StringTokenizer st = new StringTokenizer(tokenStr, delimiter);
        String[] cmdArray = new String[st.countTokens()];
        int i = 0;
        while (st.hasMoreTokens())
        {
            cmdArray[i] = st.nextToken();
            i++;
        }
        st = null;
        return cmdArray;
        
    }
    
    /**
     * This method checks if number is not prime number.
     * If it is not, it will return one of its divider.
     * If it is prime, it returns itself.
     * 
     * @param number
     * @return 
     */
    public static long isNotPrime(long number)
    {
        //check if number is a multiple of 2
        if (number%2==0) {
            return 2; // false - not a prime
        }
        
        // Try out dividers
        for(long iFactor=3; iFactor*iFactor<=number; iFactor+=2) {
            if(number % iFactor == 0){
                return iFactor; // false - not a prime return a divider
            }
        }
        return number;
    }
    
    /**
     * Convert binary string in base to decimal representation
     * @param binaryString
     * @param base
     * @return int (decimal value)
     */
    public int convertBinaryToNumber(String binaryString, int base)
    {
        int decimal = Integer.parseInt(binaryString, base);
        return decimal;
    }
    
    /**
     * This method pad leading zeros
     * @param number
     * @param numDigits
     * @return String
     */
    public static String padLeadingZero(final long number, final int numDigits)
    {
        String numberStr = "";

        int offset = numDigits;
        while (offset > 0)
        {
            offset--;
            if (number < Math.pow(10, offset))
            {
                numberStr += "0";
            }
            else
            {
                numberStr += number;
                break;
            }
        }

        return numberStr;
    }
}
