import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;


public class FashionPolice {

	static File fi = new File("C-small-attempt0.in");
	static File fo = new File("C-small-attempt0.out");
	static String[] file;

	FileReader fr;
	BufferedReader reader;

	static FileWriter fw;
	static BufferedWriter writer;

	static Scanner sin = null;
	static FileInputStream fin;

	public static void main(String[] args) {
		run();


	}


	public static void run()
	{
		try {
			fo.createNewFile();
			fin = new FileInputStream(fi);
			fw = new FileWriter(fo);
			writer=new BufferedWriter(fw);

			try {
				sin = new Scanner(fin);

				int numOfCases = sin.nextInt();
				int j, p, s, k;


				for(int casenum = 0; casenum<numOfCases; casenum++)
				{	
					//System.out.printf("Case %d %n",casenum);
					//printCase(sin);
					//printCase(sin);


					j=sin.nextInt();
					p=sin.nextInt();
					s=sin.nextInt();
					k=sin.nextInt();

					System.out.println();
					try {
						writer.write("Case #" + (casenum+1) + ": ");
						ArrayList<Triple> outfits = calcOutfits(j, p, s, k);
						writer.write(outfits.size() + "\n");
						for(Triple outfit : outfits) {
							writer.write(outfit.toString() + "\n");
						}
						writer.flush();
					} catch (IOException e1) {e1.printStackTrace();}
					
				}
			} finally {
				sin.close();
				writer.close();
			}

		} catch(IOException e) {e.printStackTrace();}

	}

	private static class Triple {
		int fst, snd, trd;
		public String toString() {
			return fst + " " + snd + " " + trd;
		}
		public boolean equals(Object other) {
			if(other == null || !(other instanceof Triple)) {
				return false;
			}
			Triple ot = (Triple) other;
			return fst == ot.fst && snd == ot.snd && trd == ot.trd;
		}
		@Override
		public int hashCode() {
			return fst*10000+snd*100 + trd; //Should work for our purposes
		}
	}
	/*
	private static class Duple {
		int fst, snd;
		public boolean equals(Object other) {
			if(other == null || !(other instanceof Duple)) {
				return false;
			}
			Duple ot = (Duple) other;
			return fst == ot.fst && snd == ot.snd;
		}
		@Override
		public int hashCode() {
			return fst*100 + snd; //Should work for our purposes
		}
	}*/
	private static ArrayList<Triple> calcOutfits(int j, int p,
			int s, int k) {
		ArrayList<Triple> outfits = new ArrayList<Triple>();
		Map<Triple,Integer> combinationUsage = new HashMap<>();
		for(int i1=0; i1<j; i1++) {
			for(int i2=0; i2<p; i2++) {
				for(int i3=0; i3<s; i3++) {
					if(isValid(combinationUsage, i1, i2, i3, k)) {
						Triple t = new Triple();
						t.fst = i1+1;
						t.snd = i2+1;
						t.trd = i3+1;
						outfits.add(t);
						
						addOrIncrement(combinationUsage, i1, i2, 1);
						addOrIncrement(combinationUsage, i1, i3, 2);
						addOrIncrement(combinationUsage, i2, i3, 3);
					}
				}
			}
		}
		return outfits;
	}


	private static boolean isValid(Map<Triple,Integer> combinationUsage, int j, int p,
			int s, int k) {
		Triple jp = new Triple();
		jp.fst = j; jp.snd = p; jp.trd = 1;
		if(combinationUsage.containsKey(jp) && !(combinationUsage.get(jp) < k)) {
			return false;
		}
		Triple js = new Triple();
		js.fst = j; js.snd = s; js.trd = 2;
		if(combinationUsage.containsKey(js) && !(combinationUsage.get(js) < k)) return false;
		Triple ps = new Triple();
		ps.fst = p; ps.snd = s; ps.trd = 3;
		if(combinationUsage.containsKey(ps) && !(combinationUsage.get(ps) < k)) return false;
		return true;
	}
	
	public static void addOrIncrement(Map<Triple,Integer> combinationUsage, int a, int b, int type) {
		Triple ab = new Triple(); ab.fst = a; ab.snd = b; ab.trd = type;
		if(combinationUsage.containsKey(ab)) {
			combinationUsage.replace(ab, combinationUsage.get(ab)+1);
		} else {
			combinationUsage.put(ab, 1);
		}
	}


	public static void printCase(Scanner s)
	{
		System.out.printf("row choice: %d %n", s.nextInt());
		s.nextLine();
		for(int i=1;i<5;i++)
			System.out.printf("line %d: %s %n",i, s.nextLine());
	}
}