import java.io.*;
import java.util.ArrayList;
import java.util.Date;
import java.util.LinkedList;

/**
 * Date: 03/05/2014
 * Time: 18:06
 */

public class TheRepeater {

    int caseNum = 0;

    public static void main(String[] args) throws IOException {
        new TheRepeater().doSomething();
    }

    void doSomething() throws IOException {
        try {
            File test = new File("stuff").getAbsoluteFile();
            File[] inList = test.listFiles(new FilenameFilter() {
                @Override
                public boolean accept(File dir, String name) {
                    return name.toLowerCase().contains(".in");
                }
            });
            File fIn = inList[0];
            for (int i = 1; i < inList.length; i++) {
                if (new Date(fIn.lastModified()).compareTo(new Date(inList[i].lastModified())) < 0) {
                    fIn = inList[i];
                }
            }
            File fOut = new File("stuff" + File.separator + "TheRepeater.out");
            BufferedReader in = new BufferedReader(new FileReader(fIn));
            BufferedWriter out = new BufferedWriter(new FileWriter(fOut));
            int n = Integer.valueOf(in.readLine());
            for (caseNum = 1; caseNum <= n; caseNum++) {
                // System.out.println("Case #" + caseNum + ": ");
                out.write("Case #" + caseNum + ": " + solve(in));
                out.newLine();
            }
            in.close();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    void read(BufferedReader in) throws IOException {

    }

    String solve(BufferedReader in) throws IOException {
        int n = Integer.valueOf(in.readLine());
        String[] words = new String[n];
        char c;
        int count;
        int actions = 0;

        for (int i = 0; i < n; i++) {
            words[i] = in.readLine();
        }

        LinkedList<Pair>[] w = new LinkedList[n];
        for (int i = 0; i < n; i++) {
            w[i] = new LinkedList<Pair>();
            c = words[i].charAt(0);
            count = 1;
            for (int j = 1; j < words[i].length(); j++) {
                if (words[i].charAt(j) == c) {
                    count++;
                } else {
                    w[i].add(new Pair(c, count));
                    c = words[i].charAt(j);
                    count = 1;
                }
            }
            w[i].add(new Pair(c, count));
        }

        int size = w[0].size();
        for (int i = 1; i < w.length; i++) {
            if (size != w[i].size()) {
                return "Fegla Won";
            }
        }

        for (int i = 0; i < w[0].size(); i++) {
            c = w[0].get(i).c;
            count = w[0].get(i).n;
            for (int j = 1; j < w.length; j++) {
                if (c == w[j].get(i).c) {
                    count = count + w[j].get(i).n;
                } else {
                    return "Fegla Won";
                }
            }
            count = count / n;
            for (int j = 0; j < w.length; j++) {
                actions = actions + Math.abs(count - w[j].get(i).n);
            }
        }

        return Integer.toString(actions);
    }

    static class Pair {
        char c;
        int n;

        public Pair(char c, int n) {
            this.c = c;
            this.n = n;
        }
        public String toString() {
            return "[" + c + ", " + n + "]";
        }
    }
}
