import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Lawnmower {

    Square[][] lawn;
    BufferedReader read;
    BufferedWriter write;
    
    public static void main(String[] args) {
        new Lawnmower().doSomething();
    }
    
    public void doSomething() {
        File f = new File("test");
        File output = new File("output");
        try {
            output.delete();
            output.createNewFile();
            read = new BufferedReader(new FileReader(f));
            write = new BufferedWriter(new FileWriter(output));
            int n = Integer.valueOf(read.readLine());
            for (int i = 1; i <= n; i++) {
                read();
                System.out.println(this);
                write.write("Case #" + i + ": " + solve());
                write.newLine();
            }
            read.close();
            write.close();
            
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    void read() throws IOException {
        String lawnSize = read.readLine();
        int x = Integer.valueOf(lawnSize.split(" ")[0]);
        int y = Integer.valueOf(lawnSize.split(" ")[1]);
        lawn = new Square[x][y];
        for (int i = 0; i < x; i++) {
            String[] heights = read.readLine().split(" ");
            for (int j = 0; j < y; j++) {
                lawn[i][j] = new Square(Integer.valueOf(heights[j]));
            }
        }
    }
    
    String solve() {
        boolean fromStart = true;
        int lineHeight = -1;
        for (int i = 0; i < lawn.length; i++) {
            if (fromStart) {
                lineHeight = lawn[i][0].h;
            } else {
                fromStart = true;
            }
            for (int j = 0; j < lawn[0].length; j++) {
                if (lawn[i][j].h == lineHeight) {
                    lawn[i][j].finishedX = true;
                } else if (lawn[i][j].h < lineHeight) {
                    lawn[i][j].finishedX = false; //gnarf
                } else {
                    fromStart = false;
                    lineHeight = lawn[i][j].h;
                    i--; //gnarf
                    break;
                }
            }
        }
        
        for (int j = 0; j < lawn[0].length; j++) {
            if (fromStart) {
                lineHeight = lawn[0][j].h;
            } else {
                fromStart = true;
            }
            for (int i = 0; i < lawn.length; i++) {
                if (lawn[i][j].h == lineHeight) {
                    lawn[i][j].finishedY = true;
                } else if (lawn[i][j].h < lineHeight) {
                    lawn[i][j].finishedY = false;
                } else {
                    fromStart = false;
                    lineHeight = lawn[i][j].h;
                    j--; //gnarf
                    break;
                }
            }
        }

        for (int i = 0; i < lawn.length; i++) {
            for (int j = 0; j < lawn[0].length; j++) {
                if (!(lawn[i][j].finishedX || lawn[i][j].finishedY)) {
                    return "NO";
                }
            }
        }
        return "YES";
    }
    
//    void writeFinished() {
//        for (int i = 0; i < lawn.length; i++) {
//            for (int j = 0; j < lawn[0].length; j++) {
//                System.out.print(lawn[i][j].finished + " ");
//            }
//            System.out.println();
//        }
//    }
    
    public String toString() {
        String s = "";
        for (int i = 0; i < lawn.length; i++) {
            for (int j = 0; j < lawn[0].length; j++) {
                s = s + (lawn[i][j] + " ");
            }
            s = s + "\n";
        }
        return s;
    }
    
    class Square {

        int h = 0;
        boolean finishedX = false;
        boolean finishedY = false;
        
        public Square(int height) {
            h = height;
        }
        
        public String toString() {
            return h + "";
        }
    }
}
