import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;


public class FairAndSquare {

    BufferedReader read;
    BufferedWriter write;
    
    BigInteger low;
    BigInteger high;
    
    String currentPalindrome = "1";
    BigInteger currentSquare = new BigInteger("1");
    
    
    public static void main(String[] args) {
        new FairAndSquare().doSomething();
    }
    
    public void doSomething() {
        File f = new File("test");
        File output = new File("output");
        try {
            output.delete();
            output.createNewFile();
            read = new BufferedReader(new FileReader(f));
            write = new BufferedWriter(new FileWriter(output));
            int n = Integer.valueOf(read.readLine());
            for (int i = 1; i <= n; i++) {
                read();
                write.write("Case #" + i + ": " + solve());
                write.newLine();
                reset();
            }
            read.close();
            write.close();
            
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    void read() throws IOException {
        String[] s = read.readLine().split(" ");
        low = new BigInteger(s[0]);
        high = new BigInteger(s[1]);
    }
    
    String solve() {
        BigInteger found = new BigInteger("0");
        currentSquare = new BigInteger(currentPalindrome).pow(2);
        while (currentSquare.compareTo(low) < 0) {
            currentSquare = nextSquare();
        }
        
        while (currentSquare.compareTo(high) <= 0) {
            if (isPalindrome()) {
                found = found.add(BigInteger.ONE);
            }
            currentSquare = nextSquare();
        }
        
        return found.toString();
    }
    
    boolean isPalindrome() {
        String s = currentSquare.toString();
        for (int i = 0; i < s.length() / 2; i++) {
            if (s.charAt(i) != s.charAt(s.length() - 1 - i)) {
                return false;
            } else {
            }
        }
//        System.out.println("Length: " + s.length() + " Root: " + currentPalindrome);
//        System.out.println(s);
        return true;
    }
    
    BigInteger nextSquare() {
        currentPalindrome = nextPalindrome();
        return new BigInteger(currentPalindrome).pow(2);
    }

    String nextPalindrome() {
        int a = -1;
        int b = -1;
        int[] s = stringToIntArr(currentPalindrome);
        if (s.length == 1) {
            s[0]++;
            if (s[0] > 3) {
                s[0] = 0;
                a = -1;
                b = 1;
            } else {
                return intArrToString(s);
          }
        } else if (s.length % 2 != 0) {
            s[s.length / 2]++;
//            if (s[s.length / 2] > 9) {////////////////////////////////
            if (s[s.length / 2] > 2) {
                s[s.length / 2] = 0;
                a = s.length / 2 - 1;
                b = s.length / 2 + 1;
            } else {
                return intArrToString(s);
            }
        } else {
            a = s.length / 2 - 1;
            b = s.length / 2;
        }
        while (true) {
            if (a < 0) {
                //create smallest palindrome of new length
                int oldLength = s.length;
                s = new int[oldLength + 1];
                s[0] = 1;
                s[s.length - 1] = 1;
//                System.out.println(s.length + " - " + currentPalindrome.toString().length());
                return intArrToString(s);
            } else {
                s[a]++;
                s[b]++;
//                if (s[a] > 9) {///////////////////////////
                if (s[a] > 2) {
//                    System.out.println("test: " + Arrays.toString(s));
                    s[a] = 0;
                    s[b] = 0;
                    a--;
                    b++;
                } else {
                    return intArrToString(s);
                }
            }
        }
    }
    
    int[] stringToIntArr(String s) {
        int[] n = new int[s.length()];
        for (int i = 0; i < s.length(); i++) {
            n[i] = s.charAt(i) - 48;
        }
        return n;
    }
    
    String intArrToString(int[] n) {
        String s = "";
        for (int i = 0; i < n.length; i++) {
            s = s + n[i];
        }
        return s;
    }
    
    void reset() {
        currentPalindrome = "1";
        currentSquare = new BigInteger("1");
    }
}
