import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class TicTacToe {

    int[][] stuff;
    BufferedReader read;
    BufferedWriter write;
    
    String xWin = "X won";
    String oWin = "O won";
    String draw = "Draw";
    String notF = "Game has not completed";
    
    public static void main(String[] args) {
        new TicTacToe().doSomething();
    }
    
    public void doSomething() {
        File f = new File("test");
        File output = new File("output");
        try {
            output.delete();
            output.createNewFile();
            read = new BufferedReader(new FileReader(f));
            write = new BufferedWriter(new FileWriter(output));
            int n = Integer.valueOf(read.readLine());
            for (int i = 1; i <= n; i++) {
                read();
                write.write("Case #" + i + ": " + solve());
                write.newLine();
            }
            read.close();
            write.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    public void read() throws IOException {
        stuff = new int[4][4];
        for (int i = 0; i < 4; i++) {
            String s = read.readLine();
            for (int j = 0; j < 4; j++) {
                stuff[i][j] = trans(s.charAt(j));
            }
        }
        // read empty line
        read.readLine();
    }
    
    public String solve() {
        boolean notfinished = false;
        
        for (int i = 0; i < 4; i++) {
            int h = stuff[i][0] + stuff[i][1] + stuff[i][2] + stuff[i][3];
            int v = stuff[0][i] + stuff[1][i] + stuff[2][i] + stuff[3][i];
            if (h < 500) {
                if (h <= 5) {
                    return xWin;
                } else if (h >= 35) {
                    return oWin;
                }
            } else {
                notfinished = true;
            }
            if (v < 500) {
                if (v <= 5) {
                    return xWin;
                } else if (v >= 35) {
                    return oWin;
                }
            } else {
                notfinished = true;
            }
        }
        
        int x = stuff[3][0] + stuff[2][1] + stuff[1][2] + stuff[0][3];
        int y = stuff[0][0] + stuff[1][1] + stuff[2][2] + stuff[3][3];
        
        if (x < 500) {
            if (x <= 5) {
                return xWin;
            } else if (x >= 35) {
                return oWin;
            }
        }
        if (y < 500) {
            if (y <= 5) {
                return xWin;
            } else if (y >= 35) {
                return oWin;
            }
        }
        
        if (notfinished) {
            return notF;
        } else {
            return draw;
        }
    }
    
    int trans(char c) {
        if (c == '.') {
            return 500;
        } else if (c == 'T') {
            return 5;
        } else if (c == 'X') {
            return 0;
        } else if (c == 'O') {
            return 10;
        } else {
            return -1;
        }
    }
}
