package google_code_jam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;

public class Main_Fair_and_Square {

	
	public static List<String> GetInputData(String path) throws IOException {
		List<String> inputData = new ArrayList<String>();
		BufferedReader reader = new BufferedReader(new InputStreamReader(
				new FileInputStream(new File(path))));
		String line = null;
		while ((line = reader.readLine()) != null) {
			inputData.add(line);
		}
		reader.close();
		return inputData;
	}
	
	public static boolean CheckFair(String data){
		boolean check = false;
		int dataLength = data.length();
		if(dataLength == 1)
			check = true;
		else{
			int i = 0 ;
			int j = dataLength-1;
		  for( ; i<=j ; i++ ,j--){
			  if(data.charAt(i) == data.charAt(j))
				  continue;
			  else
				  break;
		  }
		  if(i == j+1 || i == j+2){
			  check = true;
		  }
		}
		return check;
	}
	
	public static List<Long> GetSecandLarge(){
		 List<Long> getNums = new ArrayList<Long>();
		 for(long i = 1 ; i <= 10000000 ; i++ ){
			 String checki = String.valueOf(i);
			 if(CheckFair(checki)){
				 long ii = i*i;
				 String checkii = String.valueOf(ii); 
				 if(CheckFair(checkii)){
					 getNums.add(ii);  
				 }				 
			 }				 
		 }
		 return getNums;
	}
	
	public static String GetFairNumber(String[] lineData, List<Long> getNums){
		String fairNumber = "";
        long lowerdata = Long.parseLong(lineData[0]);
        long higherdata = Long.parseLong(lineData[1]);      
		int i = 0 ; 
		int j = getNums.size()-1;
		int lowindex = 0;
		int hightindex = getNums.size()-1;
		for(i = 0 ; i < getNums.size() ; i++){
			if(getNums.get(i) < lowerdata){
				lowindex = i+1;
			}				
			else if(getNums.get(i) == lowerdata){
				lowindex = i;
				break;
			}else{
				break;
			}

		}
		for(; j > 0 ; j--){
			if(getNums.get(j) > higherdata){
				hightindex = j-1;
			}
			else if(getNums.get(j) == higherdata){
				hightindex = j;
				break;
			}else{
				break;
			}
				
		}
		int result = 0;
		if(hightindex-lowindex+1 >= 0)
			result = hightindex-lowindex+1;
		fairNumber = Integer.toString(result);
		return fairNumber;
	}
		
	public static void main(String[] args) throws IOException {
		List<String> inputData = GetInputData("C-large-1.in");
		List<Long> getNums = GetSecandLarge();
		int T = Integer.parseInt(inputData.get(0));
		String[] result = new String[T];
		for(int i = 0 ; i < T; i++){
			String[] lineData = inputData.get(i+1).trim().split(" ");
			result[i] = GetFairNumber(lineData,getNums);
		}
		File test = new File("fair_square_result.in");
		PrintStream out = new PrintStream(new FileOutputStream(test));
		System.setOut(out);
		for (int i = 0; i < T; i++) {
			System.out.println("Case #" + (i + 1) + ": " + result[i]);
		}		
	}

}
