/*
ID: creativ7
LANG: JAVA
TASK: C
*/

import java.io.*;
import java.util.*;

public class C
{
	static PriorityQueue<Segment> queue = new PriorityQueue<>();
	//static TreeSet<Long> set = new TreeSet<>();
	
	public static void solve()
	{
		int TESTS = in.nextInt();
		
		o:
		for (int CASE = 1; CASE <= TESTS; CASE++)
		{
			long n = in.nextLong();
			long k = in.nextLong();
			
			if (n == k)
			{
				out.println("Case #" + CASE + ": 0 0");
				continue o;
			}
			
			queue.clear();
			queue.add(new Segment(0, n - 1));
			/*set.clear();
			set.add(-1L);
			set.add(n);*/
			
			for (int i = 1; i < k; i++)
			{
				Segment segment = queue.remove();
				
				long middle = segment.getMiddle();
				//set.add(middle);
			}
			
			Segment segment = queue.remove();
			long middle = segment.getMiddle();
			//set.add(middle);
			long l = middle - segment.a;
			long r = segment.b - middle;
			
			//System.out.println(set);
			out.println("Case #" + CASE + ": " + Math.max(l, r) + " " + Math.min(l, r));
			
		}
		
	}
	
	static class Segment implements Comparable<Segment>
	{
		//left stall exclusive
		long a;
		//right stall exclusive
		long b;
		long len;
		long middle = Long.MIN_VALUE;
		
		public Segment(long a, long b)
		{
			this.a = a;
			this.b = b;
			
			len = b - a + 1;
		}
		
		public long getMiddle()
		{
			if (middle == Long.MIN_VALUE)
				middle = (a + b) / 2;
			
			if (a <= middle - 1)
				queue.add(new Segment(a, middle - 1));
			if (b >= middle + 1)
				queue.add(new Segment(middle + 1, b));
			
			return middle;
		}
		
		@Override
		public int compareTo(Segment o)
		{
			if (len == o.len)
			{
				if (a == o.a)
					return Long.compare(b, o.b);
				return Long.compare(a, o.a);
			}
			return Long.compare(o.len, len);
		}
		
		@Override
		public boolean equals(Object o)
		{
			if (this == o) return true;
			if (o == null || getClass() != o.getClass()) return false;
			
			Segment segment = (Segment) o;
			
			if (a != segment.a) return false;
			return b == segment.b;
		}
		
		@Override
		public int hashCode()
		{
			long result = a;
			result = 31 * result + b;
			
			return Long.hashCode(result);
		}
	}
	
	
	public static InputReader in = new InputReader("C");
	public static PrintWriter out;
	
	public static void main(String[] args) throws IOException
	{
		out = new PrintWriter(new BufferedWriter(new FileWriter("C.out")));
		//out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));
		long startTime = System.currentTimeMillis();
		
		solve();
		
		long endTime = System.currentTimeMillis();
		System.out.printf("Took %.2f sec\n", (endTime - startTime) / 1000.0);
		
		out.close();
	}
	
	//reader by Petr Mitrichev
	static class InputReader
	{
		public BufferedReader reader;
		public StringTokenizer tokenizer;
		
		public InputReader(String fileName)
		{
			try
			{
				reader = new BufferedReader(new FileReader(new File(fileName + ".in")), 32768);
				//reader = new BufferedReader(new InputStreamReader(System.in)), 32768);
			}
			catch (Exception ex)
			{
				throw new NullPointerException("Input file does not exist! Put it in the project folder.");
			}
			tokenizer = null;
		}
		
		public String next()
		{
			while (tokenizer == null || !tokenizer.hasMoreTokens())
			{
				try
				{
					tokenizer = new StringTokenizer(reader.readLine());
				}
				catch (IOException e)
				{
					throw new RuntimeException(e);
				}
			}
			return tokenizer.nextToken();
		}
		
		public int nextInt()
		{
			return Integer.parseInt(next());
		}
		
		public double nextDouble()
		{
			return Double.parseDouble(next());
		}
		
		public long nextLong()
		{
			return Long.parseLong(next());
		}
		
		/**
		 * When you call next(), that entire line will be skipped.
		 * No flushing buffers.
		 * Doesn't work when you want to scan the remaining line.
		 *
		 * @return entire line
		 */
		public String nextLine()
		{
			String str = "";
			try
			{
				str = reader.readLine();
				tokenizer = null;
			}
			catch (IOException e)
			{
				throw new RuntimeException(e);
			}
			return str;
		}
	}
}
