/*
gahwonlee1
*/

import java.io.*;
import java.util.*;

public class A
{
	static HashMap<Coord, Character> coords;
	
	public static void solve()
	{
		int CASES = in.nextInt();
		
		for (int CASE = 1; CASE <= CASES; CASE++)
		{
			int r = in.nextInt();
			int c = in.nextInt();
			coords = new HashMap<>();
			
			for (int i = 0; i < r; i++)
			{
				char[] grid = in.next().toCharArray();
				for (int j = 0; j < c; j++)
				{
					if (grid[j] != '?')
						coords.put(new Coord(j, i), grid[j]);
				}
			}
			
			ArrayDeque<Rect[]> deque = new ArrayDeque<>();
			deque.add(new Rect[]{new Rect(0, 0, c, r)});
			
			o:
			while (!deque.isEmpty())
			{
				Rect[] rects = deque.remove();
				//print(r, c, rects);
				HashSet<Character> foundChars = new HashSet<>();
				char[] dict = new char[rects.length];
				
				try
				{
					//for all rectangles
					for (int i = 0; i < rects.length; i++)
					{
						boolean containsAnother = false;
						
						for (Map.Entry<Coord, Character> entry : coords.entrySet())
						{
							//if it contains an initial
							if (rects[i].contains(entry.getKey()))
							{
								if (containsAnother || foundChars.contains(entry.getValue() ))
								{
									//bad
									throw new ArithmeticException();
								}
								
								foundChars.add(entry.getValue());
								dict[i] = entry.getValue();
								containsAnother = true;
							}
						}
						
						//if a rect doesnt contain any char
						if (!containsAnother)
							continue o;
					}
					
					if (foundChars.size() != coords.size())
					{
						//bad
						throw new ArithmeticException();
					}
				}
				catch (ArithmeticException e)
				{
					//split
					for (int i = 0; i < rects.length; i++)
					{
						for (int j = rects[i].x1 + 1, jMax = rects[i].x2; j < jMax; j++)
						{
							Rect[] newRects = new Rect[rects.length + 1];
							System.arraycopy(rects, 0, newRects, 1, rects.length);
							
							newRects[0] = new Rect(rects[i].x1, rects[i].y1, j, rects[i].y2);
							newRects[i + 1] = new Rect(j, rects[i].y1, rects[i].x2, rects[i].y2);
							
							deque.add(newRects);
						}
						
						for (int j = rects[i].y1 + 1, jMax = rects[i].y2; j < jMax; j++)
						{
							Rect[] newRects = new Rect[rects.length + 1];
							System.arraycopy(rects, 0, newRects, 1, rects.length);
							
							newRects[0] = new Rect(rects[i].x1, rects[i].y1, rects[i].x2, j);
							newRects[i + 1] = new Rect(rects[i].x1, j, rects[i].x2, rects[i].y2);
							
							deque.add(newRects);
						}
						
					}
					
					continue;
				}
				
				//good
				out.println("Case #" + CASE + ":");
				char[][] grid = new char[r][c];
				
				for (int i = 0; i < rects.length; i++)
				{
					for (int y = rects[i].y1; y < rects[i].y2; y++)
					{
						for (int x = rects[i].x1; x < rects[i].x2; x++)
						{
							grid[y][x] = dict[i];
						}
					}
				}
				
				//print
				for (char[] chars : grid)
				{
					for (char aChar : chars)
					{
						out.print(aChar);
					}
					out.println();
				}
				break;
			}
			
		}
		
	}
	
	static void print(int r, int c, Rect[] rects)
	{
		char ccc = 'a';
		char[][] grid = new char[r][c];
		
		for (Rect rect : rects)
		{
			for (int y = rect.y1; y < rect.y2; y++)
			{
				for (int x = rect.x1; x < rect.x2; x++)
				{
					grid[y][x] = ccc;
				}
			}
			ccc++;
		}
		
		//print
		for (char[] chars : grid)
		{
			for (char aChar : chars)
			{
				System.out.print(aChar);
			}
			System.out.println();
		}
		System.out.println(Arrays.toString(rects));
	}
	
	static class Rect
	{
		int x1;
		int y1;
		int x2;
		int y2;
		
		public Rect(int x1, int y1, int x2, int y2)
		{
			this.x1 = x1;
			this.y1 = y1;
			this.x2 = x2;
			this.y2 = y2;
		}
		
		public boolean contains(Coord c)
		{
			return x1 <= c.x && c.x < x2 && y1 <= c.y && c.y < y2;
		}
		
		@Override
		public String toString()
		{
			return "Rect{" +
				x1 +
				", " + y1 +
				", " + x2 +
				", " + y2 +
				'}';
		}
	}
	
	public static class Coord
	{
		public int x;
		public int y;
		
		public Coord(int x, int y)
		{
			this.x = x;
			this.y = y;
		}
		
		public int getX()
		{
			return x;
		}
		
		public void setX(int x)
		{
			this.x = x;
		}
		
		public int getY()
		{
			return y;
		}
		
		public void setY(int y)
		{
			this.y = y;
		}
		
		@Override
		public boolean equals(Object o)
		{
			if (this == o) return true;
			if (o == null || getClass() != o.getClass()) return false;
			
			Coord coord = (Coord) o;
			
			if (x != coord.x) return false;
			return y == coord.y;
		}
		
		@Override
		public int hashCode()
		{
			int result = x;
			result = 31 * result + y;
			return result;
		}
		
		@Override
		public String toString()
		{
			return "Coord{" +
				"x=" + x +
				", y=" + y +
				'}';
		}
	}
	
	public static InputReader in = new InputReader("A");
	public static PrintWriter out;
	
	public static void main(String[] args) throws IOException
	{
		out = new PrintWriter(new BufferedWriter(new FileWriter("A.out")));
		//out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));
		long startTime = System.currentTimeMillis();
		
		solve();
		
		long endTime = System.currentTimeMillis();
		System.out.printf("Took %.2f sec\n", (endTime - startTime) / 1000.0);
		
		out.close();
	}
	
	//reader by Petr Mitrichev
	static class InputReader
	{
		public BufferedReader reader;
		public StringTokenizer tokenizer;
		
		public InputReader(String fileName)
		{
			try
			{
				reader = new BufferedReader(new FileReader(new File(fileName + ".in")), 32768);
				//reader = new BufferedReader(new InputStreamReader(System.in)), 32768);
			}
			catch (Exception ex)
			{
				throw new NullPointerException("Input file does not exist! Put it in the project folder.");
			}
			tokenizer = null;
		}
		
		public String next()
		{
			while (tokenizer == null || !tokenizer.hasMoreTokens())
			{
				try
				{
					tokenizer = new StringTokenizer(reader.readLine());
				}
				catch (IOException e)
				{
					throw new RuntimeException(e);
				}
			}
			return tokenizer.nextToken();
		}
		
		public int nextInt()
		{
			return Integer.parseInt(next());
		}
		
		public double nextDouble()
		{
			return Double.parseDouble(next());
		}
		
		public long nextLong()
		{
			return Long.parseLong(next());
		}
		
		/**
		 * When you call next(), that entire line will be skipped.
		 * No flushing buffers.
		 * Doesn't work when you want to scan the remaining line.
		 *
		 * @return entire line
		 */
		public String nextLine()
		{
			String str = "";
			try
			{
				str = reader.readLine();
				tokenizer = null;
			}
			catch (IOException e)
			{
				throw new RuntimeException(e);
			}
			return str;
		}
	}
}
