import java.util.*;

public class Up {

	static int best = Integer.MAX_VALUE/10;
	static Map<Integer, Integer> ntoi;
	static int[] arr;
	static int n;
	
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		
		int ncs = sc.nextInt();
		for(int cs = 0; cs < ncs; cs++) {
			best = Integer.MAX_VALUE/10;
			n = sc.nextInt();
			arr = new int[n];
			ntoi = new HashMap<Integer, Integer>();
			for(int i = 0; i < n; i++) {
				arr[i] = sc.nextInt();
				ntoi.put(arr[i], i);
			}
			
			permutation(arr, new int[n], new boolean[n], 0);
			
			System.out.printf("Case #%d: %d\n", cs+1, best);
		}
	}
	
	
	public static void handle(int[] perm) {
		boolean has = false;
		for(int i = 0; i < perm.length; i++) {
			int curr = perm[i];
			int next = i+1 >= perm.length ? -1 : perm[i+1];
			int prev = i-1 < 0 ? -1 : perm[i-1];
			if(curr > prev && curr > next) {
				if(has) return;
				has = true;
			}
		}
		
		Map<Integer, Integer> nton = new HashMap<Integer, Integer>();
		for(int i = 0; i < perm.length; i++) {
			nton.put(perm[i], i);

		}
		
		int[] na = new int[n];
		for(int i = 0; i < arr.length; i++) {
			na[i] = nton.get(arr[i]);
		}
		
		int count = inversionCount(na, 0, n);
		best = Math.min(best, count);
	}
	
	public static int inversionCount(int[] arr, int lo, int hi) {
		if(hi - lo == 1) return 0;
		
		int split = (lo + hi)/2;
		int acc = inversionCount(arr, lo, split) + inversionCount(arr, split, hi);
		
		int[] sorted = new int[hi - lo];
		int rd1 = lo, rd2 = split, wr = 0;
		while(wr < sorted.length) {
			if(rd1 != split && (rd2 == hi || arr[rd1] < arr[rd2])) sorted[wr++] = arr[rd1++];
			else {
				sorted[wr++] = arr[rd2++];
				acc += split - rd1;
			}
		}
		System.arraycopy(sorted, 0, arr, lo, wr);
		return acc;
	}
	
	
	/*
	 * Generates all nPr (n "pick" r) permutations of items
	 * Running time: O(nPr) [n = arr.length, r = perm.length]
	 * Tested on: nothing
	 * Usage: arr = the array to permute. perm = empty array of the same type as arr. set perm's length
	 * equal to the desired r value in nPr. taken = default boolean array same length as arr. nextloc = 0
	 * Note: nPn = n!
	 */
	public static void permutation(int[] arr, int[] perm, boolean[] taken, int nextloc) {
		if(nextloc >= perm.length) {
			handle(perm); 
			return;
		}
		
		for(int loc = 0; loc < arr.length; loc++) {
			if(taken[loc]) continue;
			perm[nextloc] = arr[loc];
			taken[loc] = true;
			permutation(arr, perm, taken, nextloc + 1);
			taken[loc] = false;
		}
	}
}
