import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.Console;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;


public class Starship {
	
	public static void main(String[] args) throws NumberFormatException, IOException {
		
		BufferedReader input =  new BufferedReader(new FileReader("input.txt"));
		BufferedWriter output = new BufferedWriter(new FileWriter("output.txt")); 
		
		int T = Integer.parseInt( input.readLine() );
		
		for(int i=0;i<T;i++) {
			String line = input.readLine();
			StringTokenizer tok = new StringTokenizer(line);
			
			int L = Integer.parseInt(tok.nextToken());
			long t = Long.parseLong(tok.nextToken());
			int N = Integer.parseInt(tok.nextToken());
			int C = Integer.parseInt(tok.nextToken());
			
			int[] c = new int[C];
			for(int j = 0; j<C; j++)
				c[j] = Integer.parseInt(tok.nextToken());
			
			long h = -1;
			
			if (L==0)
				h = compute0(N, c);
			else if (L==1) {
				int lb = N - C;
				if (lb<0) lb = 0;
				
				for(int j=N-1; j>=lb; j--) {
					long ch = compute(N, c, t, 1, j, 0);
					
					if ((h==-1) || (ch < h)) h = ch;
				}
			}
			else if (L==2) {
				int lb1 = N - C;
				if (lb1<0) lb1 = 0;
				
				int lb2 = N - C*2;
				if (lb2<0) lb2 = 0;
				
				for(int j=N-1; j>=lb1; j--) {
					for(int k=j-1; k>=lb2; k--) {
						long ch = compute(N, c, t, 2, j, k);

						if ((h==-1) || (ch < h)) h = ch;
					}
				}
			}
			
			System.out.println("Test " + i);
			
			output.write("Case #" + (i+1) + ": " + h);
			output.newLine();	
		}
		
		output.close();
	}

	private static long compute0(int N, int[] c) {
		int C = c.length;
		
		long sc = 0;
		for(int i=0; i<C; i++)
			sc += c[i];
		
		int fulls = (N - (N%C)) / C;
		
		long rest = 0;
		for(int i=0;i<N%C; i++)
			rest += c[i];

		return fulls * sc + rest;
	}

	private static long compute(int N, int[] c, long t, int L, int p1, int p2) {
		long full = compute0(N, c) * 2;
		
		if (L>0)
			full -= save(N, c, t, p1);
		if (L>1)
			full -= save(N, c, t, p2);
		
		return full;
	}

	private static long save(int n, int[] c, long t, int p1) {
		long t0 = compute0(p1, c) * 2;
		
		long dif = 0;
		if (t0 < t)
			dif = t - t0;
		
		return c[p1 % c.length] - dif/2;
	}
	
}
