import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class BotTrust {

	public static void main(String[] args) throws NumberFormatException, IOException {
		
		BufferedReader input =  new BufferedReader(new FileReader("input.txt"));
		BufferedWriter output = new BufferedWriter(new FileWriter("output.txt")); 
		
		int T = Integer.parseInt( input.readLine() );
		
		
		for(int i=0;i<T;i++) {
			
			String[] l = input.readLine().split(" ");
			
			int N = Integer.parseInt(l[0]);
			
			int t = 0; // current time
			int[] rp = new int[] {1, 1}; // current position
			int[] rt = new int[] {0, 0}; // last computation time
			
			// sequence
			for(int j = 0; j<N; j++) {

				int ix = l[j*2+1].equals("O") ? 0 : 1;
				int to = Integer.parseInt(l[j*2+2]);
				
				int idleBefore = t - rt[ix];
				int timeToMove = Math.abs(to - rp[ix]);
				rp[ix] = to;
				
				timeToMove -= idleBefore; // parallel moving with other robot
				if (timeToMove < 0) timeToMove = 0;
				
				t += timeToMove + 1; // do the move, and press the button.
				rt[ix] = t; // computation to current frame
			}
			
			output.write("Case #" + (i+1) + ": " + t);
			output.newLine();
		}
		
		output.close();
	}
	
}
