import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigInteger;

public class ThemePark {

	public static void main(String[] args) throws Exception {

		BufferedReader input = new BufferedReader(new FileReader("input.txt"));
		BufferedWriter output = new BufferedWriter(new FileWriter("output.txt"));

		int T = Integer.parseInt(input.readLine());

		for (int i = 0; i < T; i++) {

			String[] l = input.readLine().split(" ");

			// int is enough to hold 10^9
			int R = Integer.parseInt(l[0]);
			int k = Integer.parseInt(l[1]);
			int N = Integer.parseInt(l[2]);
			
			l = input.readLine().split(" ");
			
			int[] g = new int[N];
			for(int j=0; j<N; j++)
				g[j] = Integer.parseInt(l[j]);
			
			
			int[] g_earn = new int[N]; // how much do we earn for a round if the queue starts at g_earn[i]
			int[] g_next = new int[N]; // next queue will start at g_next[i] if this round it starts at i
			
			// build g_earn, g_next lookup tables
			for(int j=0; j<N; j++) {
				int c = j;
				int ck = 0; // int is enough, as c_earn <= k
				
				for(int z = 0; z<N; z++) { // don't put passengers twice ;)
					if (ck + g[c] > k) break;
					ck += g[c];
					c = (c+1)%N;
				}
				
				g_earn[j] = ck;
				g_next[j] = c;
			}
			
			long earnings = 0L;
			
			int qpos = 0; // queue position
			// start the ride :)
			for(int j=0; j<R; j++) {
				
				int c_earn = g_earn[qpos];
				earnings = earnings + c_earn;
				qpos = g_next[qpos];
				
				// TODO: detect the loop and just run the loop as many times 
			}
			
			output.write("Case #" + (i + 1) + ": " + earnings);
			output.newLine();
		}

		output.close();
	}

}
