import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigInteger;


public class FairWarning {

	public static void main(String[] args) throws Exception {
		
		BufferedReader input = new BufferedReader(new FileReader("input.txt"));
		BufferedWriter output = new BufferedWriter(new FileWriter("output.txt"));

		int T = Integer.parseInt(input.readLine());

		for (int i = 0; i < T; i++) {

			String[] l = input.readLine().split(" ");
			
			int N = Integer.parseInt(l[0]);
			
			BigInteger[] t = new BigInteger[N];
			
			
			BigInteger gcd = null;
			BigInteger closestEvent = null;
			
			for(int j=0;j<N;j++) {
				BigInteger ct = new BigInteger(l[j+1]); 
				t[j] = ct;
				
				if (closestEvent == null) closestEvent = ct;
				else if (closestEvent.compareTo(ct) > 0) closestEvent = ct;
				
				if (j>0) {
					BigInteger lastInt = t[j-1].subtract(t[j]).abs();
					
					if (gcd != null) {
						gcd = computeGcd(gcd, lastInt);
					} else gcd = lastInt;
				}
			}
			
			//BigInteger y = closestEvent.add(gcd);
			
			// compute the next anniversary.
			// we just need the divisor... as the next anniversary will be in (divisor+1) * gcd from the last occured event. 
			BigInteger[] tmp = closestEvent.divideAndRemainder(gcd);
			
			BigInteger z;
			if (tmp[1].equals( BigInteger.ZERO ))
				z = tmp[0];
			else 
				z = tmp[0].add(BigInteger.ONE);
			
			BigInteger nextAnniversary = gcd.multiply(z).subtract( closestEvent );
			  
			
			output.write("Case #" + (i + 1) + ": " + nextAnniversary);
			output.newLine();
		}
		
		output.close();
	}
	
	public static BigInteger computeGcd(BigInteger a, BigInteger b) {
		// hey, we have a gcd implementation in BigInteger ;)
		return a.gcd(b);
	}
	
}
