import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;


public class Hair {

   public static void main(String[] arts) {
      new Hair();
   }

   Hair() {
      Scanner s = null;
      try {
         s = new Scanner(new File("B-small-attempt1.in"));
      } catch (FileNotFoundException e) {
         e.printStackTrace();
      }
      long numCases = s.nextLong();
      s.nextLine();

      for (int i = 0; i < numCases; i++) {
         System.out.println("Case #" + (i + 1) + ": " + getNumber(s.nextLine(), s.nextLine()));
      }

      s.close();
   }

   int getNumber(String place, String barbers) {
      Scanner s = new Scanner(place);
      int numBarbers = s.nextInt();
      int spot = s.nextInt();
      s.close();
      s = new Scanner(barbers);
      int[] times = getCounts(numBarbers, "", barbers);
      s.close();
      
      int numPerThingy = 1;
      for (int i : times) {
         numPerThingy *= i;
      }
      
      int numServed = 0;
      for (int i : times) {
         numServed += numPerThingy / i;
      }
      
      spot %= numServed;

      Simulator sim = new Simulator(spot, times);
      return sim.simulate();
   }

   int[] getCounts(int num, String empty, String str) {
      Scanner s = new Scanner(str);
      int[] counts = new int[num];

      for (int i = 0; i < num; i++) {
         counts[i] = s.nextInt();
      }
      s.close();
      return counts;
   }
}

class Simulator {
   int spot;
   int[] times;

   Barber[] barbers;

   public Simulator(int line, int[] cutTimes) {
      spot = line;
      times = cutTimes;
      barbers = new Barber[times.length];
      for (int i = 0; i < times.length; i++) {
         barbers[i] = new Barber(times[i], i + 1);
      }
   }

   int simulate() {
      if (spot <= barbers.length) {
         return spot == 0 ? barbers.length : spot;
      }
      
      spot -= barbers.length;
      
      while (true) {
         for (Barber b : barbers) {
            if (b.update()) {
               spot--;
               if (spot == 0) {
                  return b.ID;
               }
            }
         }
      }
   }

   class Barber {
      final int TIME, ID;
      int timeLeft;
      Barber(int cutTime, int id) {
         TIME = cutTime;
         ID = id;
         timeLeft = TIME;
      }

      boolean update() {
         timeLeft--;
         if (ID == 1) {
//            System.out.println(timeLeft);
         }
         // 0 or -1?
         if (timeLeft == 0) {
            timeLeft = TIME;
            return true;
         } else {
            return false;
         }
      }
   }
}




















