package sg.edu.nus.cs2020;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class PancakeStack {

	public PancakeStack() {
		// TODO Auto-generated constructor stub
	}
	public int searchSad(StringBuilder stack){
		for(int i=0; i<stack.length(); i++){
			Character x=stack.charAt(i);
			if (x.equals('-')){
				return i;
			}
		}
		return stack.length();
	}
	
	public int searchHappy(StringBuilder stack){
		for(int i=0; i<stack.length(); i++){
			Character x=stack.charAt(i);
			if (x.equals('+')){
				return i;
			}
		}
		return stack.length();
	}
	
	public int recursiveSort(StringBuilder stack){
		//System.out.println(stack);
		if (searchSad(stack)==stack.length()){
			return 0;
		}
		else if(searchHappy(stack)==stack.length()){
			flip(stack.length()-1, stack);
			return 1;
		}
		else{
			Character start=stack.charAt(0);
			if(start.equals('-')){
				int index=searchHappy(stack);
				flip(index-1, stack);
				return recursiveSort(stack)+1;
			}
			else{
				int index=searchSad(stack);
				flip(index-1, stack);
				return recursiveSort(stack)+1;
				
			}
		}
	}
	
	public void sortStacks(String input, String output){
		try {
			FileReader fr=new FileReader(input);
			BufferedReader br=new BufferedReader(fr);
			int inputs=Integer.parseInt(br.readLine());
			FileWriter fw=new FileWriter(output);
			BufferedWriter bw=new BufferedWriter(fw);
			for(int i=0; i<inputs; i++){
				StringBuilder stack=new StringBuilder(br.readLine());
				bw.write("Case #"+(i+1)+": ");
				bw.write(Integer.toString(recursiveSort(stack)));
				bw.write("\n");
			}
			br.close();
			bw.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		
		
	}
	
	public String flip(int index, StringBuilder pancakeStack){
		if (index>=pancakeStack.length()){
			throw new IllegalArgumentException();
		}
		else{
			StringBuilder subString=new StringBuilder(pancakeStack.substring(0, index+1));
			subString.reverse();
			for (int i=0; i<subString.length(); i++){
				if(subString.charAt(i)=='+'){
					subString.setCharAt(i, '-');
				}
				else{
					subString.setCharAt(i, '+');
				}
			}
			pancakeStack.replace(0, index+1, subString.toString());
			return pancakeStack.toString();
		}
	}
	
	public static void main(String[] args){
		PancakeStack revenge=new PancakeStack();
		System.out.println(revenge.recursiveSort(new StringBuilder("------")));
		System.out.println(revenge.recursiveSort(new StringBuilder("+++++++")));
		System.out.println(revenge.recursiveSort(new StringBuilder("--+-")));
		revenge.sortStacks("B-small-attempt1.in", "data-B-small.txt");
	}

}
