import java.util.*;

public class A {
	public static final long MOD = 1000002013;
	public static long N;
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int numCases = in.nextInt();
		StringBuilder output = new StringBuilder();
		for (int caseNum = 1; caseNum <= numCases; ++caseNum) {
			output.append(String.format("Case #%d: ", caseNum));
			long numStations = in.nextInt();
			N = numStations;
			int numPairs = in.nextInt();
			HashMap<Long, Long> enter = new HashMap<Long, Long>();
			HashMap<Long, Long> exit = new HashMap<Long, Long>();
			// enter.put(i, j) = at station i, j people arrive.
			ArrayList<Pair> starts = new ArrayList<Pair>();
			ArrayList<Pair> ends = new ArrayList<Pair>();
			long expectedCost = 0;
			
			for (int i = 0; i < numPairs; ++i) {
				long start = in.nextInt();
				long end = in.nextInt();
				long count = in.nextInt();
				if (enter.containsKey(start)) {
					enter.put(start, count + enter.get(start));
				} else {
					enter.put(start, count);
				}
				
				if (exit.containsKey(end)) {
					exit.put(end, count + exit.get(end));
				} else {
					exit.put(end, count);
				}
				expectedCost += (formula(start, end) % MOD) *count;
				expectedCost %= MOD;
				starts.add(new Pair(start, end, count));
				ends.add(new Pair(start, end, count));
			}
			Pair.flip = false;
			Collections.sort(starts);
			Pair.flip = true;
			Collections.sort(ends);
			
			int startPtr = 0;
			long reducedCost = 0;
			for (int endPtr = 0; endPtr < ends.size(); ++endPtr) {
				startPtr = 0;
				while (startPtr < starts.size() && starts.get(startPtr).start <= ends.get(endPtr).end) {
					++startPtr;
				}
				--startPtr;
				Pair end = ends.get(endPtr);
				long endCount = ends.get(endPtr).count;
				while (startPtr >= 0 && endCount != 0) {
					Pair start = starts.get(startPtr);
					long curStartCount = start.count;
					if (curStartCount >= endCount) {
						reducedCost += (formula(start.start, end.end) % MOD) * endCount;
						reducedCost %= MOD;
						curStartCount -= endCount;
						start.count -= endCount;
						endCount -= endCount;
					} else {
						reducedCost += (formula(start.start, end.end) % MOD) * curStartCount;
						reducedCost %= MOD;
						start.count = 0;
						endCount -= curStartCount;
					}
					--startPtr;
				}
			}
			output.append( (expectedCost - reducedCost + MOD) % MOD);
			output.append('\n');
		}
		System.out.print(output);
	}
	
	public static long formula(long s, long e) {
		if (s == e)
			return 0;
		long diff = e - s;
		return N*diff - diff*(diff+1)/2;
	}
}

class Pair implements Comparable<Pair> {
	long start;
	long end;
	long count;
	static boolean flip;
	
	public Pair(long s, long e, long c) {
		start = s;
		end = e;
		count = c;
		flip = false;
	}
	
	public int compareTo(Pair p) {
		if (!flip)
			return (int)(start - p.start);
		return (int)(end - p.end);
	}
}