import java.util.*;

public class A
{
	public static void main(String[] args)
	{
		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		for (int test = 1; test <= t; ++test)
		{
			int r = in.nextInt();
			int c = in.nextInt();
			char[][] board = new char[r][];
			for (int i = 0; i < r; ++i)
				board[i] = in.next().toCharArray();
			
			String result = solve(board);
			System.out.printf("Case #%d: %s\n", test, result);
		}
	}
	
	public static String solve(char[][] board)
	{
		int[] dx = {0, 0, 1, -1};
		int[] dy = {1, -1, 0, 0};
		int[][] forbiddenCount = new int[board.length][board[0].length];
		int totalChange = 0;
		boolean impossible = false;
		
		// coming from top
		for (int col = 0; col < board[0].length; ++col)
		{
			for (int row = 0; row < board.length; ++row)
			{
				if (board[row][col] == '.')
					continue;
					
				forbiddenCount[row][col] += 1;
				
				if (forbiddenCount[row][col] == 4)
					impossible = true;
					
				if (board[row][col] == '^')
					++totalChange;
				break;
			}
		}
		
		// coming from bottom
		for (int col = 0; col < board[0].length; ++col)
		{
			for (int row = board.length-1; row >= 0; --row)
			{
				if (board[row][col] == '.')
					continue;
					
				forbiddenCount[row][col] += 1;
				
				if (forbiddenCount[row][col] == 4)
					impossible = true;
					
				if (board[row][col] == 'v')
					++totalChange;
				break;
			}
		}
		
		// coming from left
		for (int row = board.length-1; row >= 0; --row)
		{
			for (int col = 0; col < board[0].length; ++col)
			{
				if (board[row][col] == '.')
					continue;
					
				forbiddenCount[row][col] += 1;
				
				if (forbiddenCount[row][col] == 4)
					impossible = true;
					
				if (board[row][col] == '<')
					++totalChange;
				break;
			}
		}
		
		// coming from right
		for (int row = board.length-1; row >= 0; --row)
		{
			for (int col = board[0].length-1; col >= 0; --col)
			{
				if (board[row][col] == '.')
					continue;
					
				forbiddenCount[row][col] += 1;
				
				if (forbiddenCount[row][col] == 4)
					impossible = true;
					
				if (board[row][col] == '>')
					++totalChange;
				break;
			}
		}
		
		if (impossible)
			return "IMPOSSIBLE";
		
		return "" + totalChange;
	}
}