import java.util.*;

public class B
{
	public static void main(String[] args)
	{
		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		for (int caseNum = 1; caseNum <= t; ++caseNum)
		{
			int n = in.nextInt();
			int k = in.nextInt();
			double[] probs = new double[n];
			for (int i = 0; i < n; ++i)
				probs[i] = in.nextDouble();
			
			double answer = findAnswerSmall(k, probs);
			System.out.printf("Case #%d: %.10f\n", caseNum, answer);
		}
	}
	
	public static double findAnswerSmall(int k, double[] probs)
	{
		double max = -1.0;
		for (int mask = 0; mask < (1 << probs.length); ++mask)
		{
			if (Integer.bitCount(mask) != k)
				continue;
			double[] status = new double[probs.length + 1];
			status[0] = 1.0;
			
			for (int i = 0; i < probs.length; ++i)
			{
				if ((mask & (1 << i)) != 0)
				{
					//System.out.printf("Before apply dp of %.3f: %s\n", probs[i], Arrays.toString(status));
					applyDp(status, probs[i]);
					//System.out.printf("After apply dp: %s\n", Arrays.toString(status));
				}
			}
			
			double option = status[k/2];
			max = Math.max(option, max);
		}
		
		return max;
	}
	
	public static double findAnswer(int k, double[] probs)
	{
		// dp[i] = probability that we have i members vote YES
		double[] dp = new double[1];
		dp[0] = 1.0;
		
		// used[i] means member i is already part of the committee
		boolean[] used = new boolean[probs.length];
		
		return findAnswer(k, probs, used, dp);
	}
	
	public static double findAnswer(int leftToSelect, double[] probs, boolean[] used, double[] status)
	{
		if (leftToSelect == 0)
		{
			return status[status.length/2];
		}
		
		// Brute force with assumption that we can 'greedily' choose next 2 members, in terms of
		// "if we choose those 2 members, the resulting probability of a tie is maximized"
		int bestFirst = -1;
		int bestSecond = -1;
		double bestProb = -1.0;
		for (int first = 0; first < probs.length; ++first)
		{
			if (used[first]) continue;
			for (int second = first + 1; second < probs.length; ++second)
			{
				if (used[second]) continue;
				
				double[] copy = applyDp(status, probs[first], probs[second]);
				
				double option = copy[copy.length/2];
				if (option > bestProb)
				{
					bestFirst = first;
					bestSecond = second;
					bestProb = option;
				}
			}
		}
		
		double[] newStatus = applyDp(status, probs[bestFirst], probs[bestSecond]);
		
		used[bestFirst] = true;
		used[bestSecond] = true;
		return findAnswer(leftToSelect - 2, probs, used, newStatus);
	}
	
	public static double[] applyDp(double[] status, double prob1, double prob2)
	{
		// make a copy of status, length+2
		double[] copy = new double[status.length + 2];
		System.arraycopy(status, 0, copy, 0, status.length);
		
		applyDp(copy, prob1);
		applyDp(copy, prob2);
		
		return copy;
	}
	
	public static void applyDp(double[] status, double p)
	{
		for (int i = status.length - 1; i >= 0; --i)
		{
			if (i > 0)
				status[i] = status[i] * (1.0 - p) + status[i-1] * p;
			else
				status[i] = status[i] * (1.0 - p);
		}
	}
	
}