import java.util.*;

public class Bsmall
{
	public static double EPS = 0.00000001;
	public static void main(String[] args)
	{
		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		for (int test = 1; test <= t; ++test)
		{
			int n = in.nextInt();
			double vol = in.nextDouble();
			double temp = in.nextDouble();
			// [i][0] = rate
			// [i][1] = temp
			double[][] water = new double[n][2];
			for (int i = 0; i < n; ++i)
			{
				water[i][0] = in.nextDouble();
				water[i][1] = in.nextDouble();
			}
			
			String result = solve(water, vol, temp);
			System.out.printf("Case #%d: %s\n", test, result);
		}
	}
	
	public static String solve(double[][] water, double vol, double temp)
	{
		if (water.length == 1)
		{
			// only one temp, and it doesn't match
			if (!equal(temp, water[0][1]))
				return "IMPOSSIBLE";
			
			return String.format("%.15f", vol / water[0][0]);
		}
		
		// target temp must be in between given temps
		if (! ((water[0][1] <= temp && temp <= water[1][1]) || (water[0][1] >= temp && temp >= water[1][1])) )
		{
			return "IMPOSSIBLE";
		}
		
		if (equal(water[0][1], water[1][1]))
		{
			double min = Math.max(vol / water[0][0], vol / water[1][0]);
			return String.format("%.15f", min);
		}
		
		double t2 = (temp*vol - water[0][1]*vol) / ( (water[1][1] - water[0][1])*water[1][0]);
		
		double t1 = (vol - water[1][0]*t2) / water[0][0];
		
		double time = Math.max(t1, t2);
		
		return String.format("%.15f", time);
	}
	
	public static boolean equal(double a, double b)
	{
		return Math.abs(a - b) < EPS;
	}
}