import java.util.*;

public class D {
  public static void main(String[] args) {
    Scanner in = new Scanner(System.in);
    int t = in.nextInt();
    for (int test = 1; test <= t; ++test) {
      int numStrings = in.nextInt();
      int numServers = in.nextInt();
      String[] strings = new String[numStrings];
      for (int i = 0; i < numStrings; ++i) {
        strings[i] = in.next();
      }
      int[] assignments = new int[numStrings];
      int mostNodes = 0;
      int numWays = 1;
      do {
        int subTotal = 0;
        for (int i = 0; i < numServers; ++i) {
          ArrayList<String> server = new ArrayList<String>();
          for (int j = 0; j < numStrings; ++j) {
            if (assignments[j] == i) {
              server.add(strings[j]);
            }
          }
          subTotal += makeTrie(server);
        }
        if (subTotal > mostNodes) {
          mostNodes = subTotal;
          numWays = 1;
        } else if (subTotal == mostNodes) {
          ++numWays;
        }
      } while (nextAssignment(assignments, numServers));
      System.out.printf("Case #%d: %d %d\n", test, mostNodes, numWays);
    }
  }
  
  public static int makeTrie(ArrayList<String> strings) {
    if (strings.size() == 0) return 0;
    int numNodes = 0;
    Queue<String> queue = new LinkedList<String>();
    queue.offer("");
    while (!queue.isEmpty()) {
      ++numNodes;
      String prefix = queue.poll();
      HashSet<String> distinct = new HashSet<String>();
      for (int i = 0; i < strings.size(); ++i) {
        String cur = strings.get(i);
        if (cur.startsWith(prefix) && cur.length() > prefix.length()) {
          distinct.add(cur.substring(0, prefix.length()+1));
        }
      }
      Iterator<String> it = distinct.iterator();
      while (it.hasNext()) {
        queue.offer(it.next());
      }
    }
    return numNodes;
  }
  
  public static boolean nextAssignment(int[] assignments, int numServers) {
    int carry = 1;
    int index = 0;
    while (carry != 0 && index < assignments.length) {
      assignments[index]++;
      if (assignments[index] < numServers) {
        carry = 0;
      } else {
        assignments[index] = 0;
        ++index;
      }
    }
    return index != assignments.length;
  }
}