import java.util.*;

public class A
{
	public static void main(String[] args)
	{
		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		for (int caseNum = 1; caseNum <= t; ++caseNum)
		{
			int n = in.nextInt();
			int r = in.nextInt();
			int p = in.nextInt();
			int s = in.nextInt();
			String answer = findAnswer(n, r, p, s);
			System.out.printf("Case #%d: %s\n", caseNum, answer);
		}
	}
	
	public static String findAnswer(int n, int r, int p, int s)
	{
		String rock = generateWinner(n, 'R');
		String paper = generateWinner(n, 'P');
		String scissors = generateWinner(n, 'S');
		String[] possibilities = {rock, paper, scissors};
		
		ArrayList<String> valid = new ArrayList<String>();
		for (String sb : possibilities)
		{
			if (isValid(sb, r, p, s))
			{
				valid.add(sb);
			}
		}
		
		Collections.sort(valid);
		if (valid.size() == 0)
		{
			return "IMPOSSIBLE";
		}
		
		return valid.get(0);
	}
	
	public static boolean isValid(String tourney, int r, int p, int s)
	{
		int rCount = 0;
		int pCount = 0;
		int sCount = 0;
		for (int i = 0; i < tourney.length(); ++i)
		{
			char c = tourney.charAt(i);
			if (c == 'R')
				++rCount;
			else if (c == 'P')
				++pCount;
			else if (c == 'S')
				++sCount;
		}
		
		return rCount == r && pCount == p && sCount == s;
	}
	
	public static String generateWinner(int depth, char winner)
	{
		// Base case
		if (depth == 0)
		{
			return "" + winner;
		}
		
		// Recursion
		char loser;
		switch (winner)
		{
			case 'R':
				loser = 'S';
				break;
			case 'P':
				loser = 'R';
				break;
			case 'S':
				loser = 'P';
				break;
			default:
				throw new RuntimeException("We're not playing Spock-Paper-Scissors-Rock-Lizard!");
		}
		
		String win = generateWinner(depth-1, winner);
		String lose = generateWinner(depth-1, loser);
		if (win.compareTo(lose) > 0)
			return lose + win;
		return win + lose;
	}	
}