import java.util.*;

public class D
{
	public static void main(String[] args)
	{
		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		for (int caseNum = 1; caseNum <= t; ++caseNum)
		{
			int n = in.nextInt();
			int[] workers = new int[n];
			for (int i = 0; i < n; ++i)
			{
				workers[i] = Integer.parseInt(in.next(), 2);
			}
			
			int bestCost = n*n;
	NewMask:for (int mask = 0; mask < (1 << (n*n)); ++mask)
			{
				// given mask, calculate how much to apply mask
				// mask is resulting state, we need to make sure it is super set
				// calculate if result after applying mask works
				int maskCopy = mask;
				int maskCost = 0;
				int[] copy = new int[n];
				for (int i = 0; i < n; ++i)
				{
					int maskPiece = maskCopy % (1 << n);
					maskCopy >>= n;
					if ( (maskPiece & workers[i]) == workers[i])
					{
						copy[i] = maskPiece;
						maskCost += Integer.bitCount(maskPiece) - Integer.bitCount(workers[i]);
					}
					else
					{
						continue NewMask;
					}
				}
				
				if (check(copy))
				{
					bestCost = Math.min(bestCost, maskCost);
				}
			}
			
			System.out.printf("Case #%d: %d\n", caseNum, bestCost);
		}
	}
	
	public static boolean check(int[] workers)
	{
		boolean allGood = true;
		for (int lastWorker = 0; lastWorker < workers.length; ++lastWorker)
		{
			ArrayList<Integer> notAllowedWorkers = new ArrayList<Integer>();
			notAllowedWorkers.add(lastWorker);
			int toCover = workers[lastWorker];
			allGood &= !canCover(workers, notAllowedWorkers, toCover);
		}
		
		return allGood;
	}
	
	public static boolean canCover(int[] workers, ArrayList<Integer> notAllowedWorkers, int toCover)
	{
		if (toCover == 0)
			return true;
		
		for (int nextWorker = 0; nextWorker < workers.length; ++nextWorker)
		{
			if (notAllowedWorkers.contains(nextWorker))
				continue;
			if ((workers[nextWorker] & toCover) == 0)
				continue;
			
			for (int bit = 0; bit < workers.length; ++bit)
			{
				int bitVal = 1 << bit;
				if (( (workers[nextWorker] & bitVal) == bitVal) && ((toCover & bitVal) == bitVal))
				{
					notAllowedWorkers.add(nextWorker);
					toCover -= bitVal;
					boolean canCover = canCover(workers, notAllowedWorkers, toCover);
					notAllowedWorkers.remove(((Integer)nextWorker));
					toCover += bitVal;
					
					if (canCover)
						return true;
				}
			}
		}
		
		return false;
	}
}