import java.io.IOException;


public class QRoundA extends CodeJam{
	
	
	private static char X = 'X';
	private static char O = 'O';
	private static char T = 'T';
	private static char E = '.';
	private static char grid[][] = new char[4][4];

	public QRoundA(String file) throws Exception {
		super(file);

	}
	
	@Override
	public Object processCase(int caseNumber) throws Exception {
		for (int i = 0; i < 4; i++) {
			String line = readLine();
			if(line.equals("")){
				line = readLine();
			}
			int size = line.length();
			for (int j = 0; j < size; j++) {
				grid[i][j] = line.charAt(j);
			}
		}
		return gameStatus();	
	}
	
	
	public static void main(String[] args) throws IOException, InterruptedException, Exception {
		new QRoundA("A-small-attempt0.in").start();
		
//		testGrid();
//		System.out.println(gameStatus());
	}
	
	
	public static String gameStatus(){
		if(isWinner(O)){
			return "O won";
		}
		if(isWinner(X)){
			return "X won";
		}
		if(isFull()){
			return "Draw";
		}
		if(hasEmptySpace()){
			return "Game has not completed";
		}
			return null;
	}
	
	public static void testGrid(){
		
		grid[0][0] = E; grid[0][1] = E; grid[0][2] = E; grid[0][3] = E; 
		grid[1][0] = E; grid[1][1] = E; grid[1][2] = E; grid[1][3] = E; 
		grid[2][0] = E; grid[2][1] = E; grid[2][2] = E; grid[2][3] = E; 
		grid[3][0] = E; grid[3][1] = E; grid[3][2] = E; grid[3][3] = E; 
	
		
	}
	
	public static boolean isWinner(char symbol){
		if (wonOnLeftDiagonal(symbol)){
			return true;
		}
		if(wonOnRightDiagonal(symbol)){
			return true;
		}
		if(wonOnHorizonal(symbol)){
			return true;			
		}
		if(wonOnVertical(symbol)){
			return true;			
		}
		return false;
	}
	public static boolean wonOnLeftDiagonal(char symbol){
		// Check for \ line
		for (int i = 0; i <= 3; i++) {
			if (grid[i][i] != symbol && grid[i][i] != T || grid[i][i] == E){
				return false;
			}
		}	
		return true;
	}
	public static boolean wonOnRightDiagonal(char symbol){
		// Check for / line
		int ii = 3;
		for (int i = 0; i <= 3; i++) {
			if (grid[i][ii] != symbol && grid[i][ii] != T || grid[i][ii] == E){
				return false;
			}
			ii--;
		}
		return true;
	}
	

	public static boolean wonOnHorizonal(char symbol){
		// Check for horizontal lines
		for (int i = 0; i <= 3; i++) {
			boolean allEqual = true;
			for (int j = 0; j <= 3; j++) {
				if (grid[i][j] != symbol && grid[i][j] != T || grid[i][j] == E){
					allEqual = false;
					break;
				}
			}
			if(allEqual){
				return true;
			}
		}
		return false;
	}
	
	public static boolean wonOnVertical(char symbol){

		// Check for vertical lines
		for (int i = 0; i <= 3; i++) {
			boolean allEqual = true;
			for (int j = 0; j <= 3; j++) {
				if (grid[j][i] != symbol && grid[j][i] != T || grid[j][i] == E){
					allEqual = false;
					break;
				}
			}
			if(allEqual){
				return true;
			}
		}
		return false;
	}
	

	
	public static boolean isFull(){
		for (int i = 0; i < grid.length; i++) {
			for (int j = 0; j < grid.length; j++) {
				if(grid[i][j] == E){
					return false;
				}
			}
		}
		return true;
	}
	
	public static boolean isEmpty(){
		for (int i = 0; i < grid.length; i++) {
			for (int j = 0; j < grid.length; j++) {
				if(grid[i][j] == O || grid[i][j] == X){
					return false;
				}
			}
		}
		return true;
	}
	
	public static boolean hasEmptySpace(){
		for (int i = 0; i < grid.length; i++) {
			for (int j = 0; j < grid.length; j++) {
				if(grid[i][j] == E){
					return true;					
				}
			}
		}
		return false;
	}
	

	
	
	
	

}