import java.io.IOException;
import java.util.ArrayList;


public class QRoundC extends CodeJam {

	public QRoundC(String file) throws Exception {
		super(file);
	}

	@Override
	public Object processCase(int caseNumber) throws Exception {
		String line = readLine();
		String limits[] = line.split(" ");
		return result(limits[0], limits[1]);
	}

	
	
	private Object result(String minimum, String maximum) {
		int min = Integer.parseInt(minimum);
		int max = Integer.parseInt(maximum);
		return checkNumber(min, max);		
	}

	public int checkNumber(int min, int max){
		ArrayList<Integer> listOfValidNums = new ArrayList<Integer>();
		for (int i = min; i <= max; i++) {
			if(isSquare(i) && isPalindrome(i)){
				listOfValidNums.add(i);							
			}
		}
		
		return listOfValidNums.size();
	}
	
	
	public boolean isPalindrome(int num){
		String number = String.valueOf(num);
		if(number.length() == 1){
			return true;
		}
		
		int e = number.length() -1;
		for (int i = 0; i < number.length(); i++) {
			if(number.charAt(i) != number.charAt(e)){
				return false;
			}
			e--;
		}
		
		return true;
	}
	public boolean isSquare(int num){
		double sqrt = Math.sqrt(num);
		int perfection = (int) Math.abs(sqrt);
		double imperfection = sqrt - perfection;
		if(imperfection > 0){
			return false;
		}
		if(isPalindrome(perfection)){
			return true;
		}
		return false;
	}
	public static void main(String[] args) throws IOException, InterruptedException, Exception {
		new QRoundC("C-small-attempt1.in").start();
	}
	
	
}
