package org.jchien.codejam.cj2017.r1b;

import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.Scanner;

/**
 * @author jchien
 */
public class StableNeighborsSmall {
    private class Color {
        char ch;
        int cnt;
        int priority = 0;

        private Color(char ch, int cnt) {
            this.ch = ch;
            this.cnt = cnt;
        }

        private char getCh() {
            return ch;
        }

        private int getCnt() {
            return cnt;
        }

        private int getPriority() {
            return priority;
        }
    }

    public StableNeighborsSmall() {
    }

    public void run() {
        Scanner in = new Scanner(System.in);
        int z = in.nextInt();

        for (int cn=1; cn <= z; cn++) {
            int n = in.nextInt();
            int r = in.nextInt();
            int o = in.nextInt();
            int y = in.nextInt();
            int g = in.nextInt();
            int b = in.nextInt();
            int v = in.nextInt();

            int half = n / 2;
            if (r > half || y > half || b > half) {
                System.out.println("Case #" + cn + ": IMPOSSIBLE");
                continue;
            }

            PriorityQueue<Color> pq = new PriorityQueue<>(
                    Comparator.comparing(Color::getCnt, Comparator.reverseOrder())
                            .thenComparing(Color::getPriority, Comparator.reverseOrder())
                            .thenComparing(Color::getCh, Comparator.naturalOrder())
            );

            if (r > 0) {
                pq.add(new Color('R', r));
            }
            if (y > 0) {
                pq.add(new Color('Y', y));
            }
            if (b > 0) {
                pq.add(new Color('B', b));
            }

            boolean first = true;
            Color requeue = null;
            StringBuilder ans = new StringBuilder();
            while (!pq.isEmpty()) {
                Color color = pq.remove();
                ans.append(color.ch);
                color.cnt--;

                if (first) {
                    first = false;
                    color.priority = 1;
                }

                if (requeue != null) {
                    pq.add(requeue);
                    requeue = null;
                }

                if (color.cnt > 0) {
                    requeue = color;
                }
            }

            System.out.println("Case #" + cn + ": " + ans);
        }
    }

    public static void main(String[] args) {
        StableNeighborsSmall p = new StableNeighborsSmall();
        p.run();
    }
}
