package org.jchien.codejam.cj2016.r1b;

import java.util.Scanner;

/**
 * @author jchien
 */
public class CloseMatch2 {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int z = in.nextInt();
        for (int y=1; y <= z; y++) {
            String c = in.next();
            String j = in.next();

            StringBuilder cans = new StringBuilder();
            StringBuilder jans = new StringBuilder();

            // diff 0 means c and j can have same score
            // diff -1 means c is larger
            // diff 1 means j is larger
            int diff = 0;
            int len = c.length();

            for (int i=0; i < len; i++) {
                char cch = c.charAt(i);
                char jch = j.charAt(i);

                if (cch != '?' && jch != '?') {
                    cans.append(cch);
                    jans.append(jch);

                    if (diff == 0) {
                        if (cch > jch) {
                            diff = -1;
                        } else if (cch < jch) {
                            diff = 1;
                        }
                    }
                } else if (cch == '?' && jch == '?') {
                    if (diff == 0) {
                        // need to look ahead here
                        int nextDelta = getNextDelta(c, j, i);
                        boolean eq = canBeEq(c, j, i);
                        if (nextDelta <= 5 && nextDelta >= -5 && eq) {
                            cans.append('0');
                            jans.append('0');
                        } else if (nextDelta >= 5) {
                            // c's next digit is bigger
                            cans.append('0');
                            jans.append('1');
                            diff = 1;
                        } else if (nextDelta <= -5) {
                            // j's next digit is bigger
                            cans.append('1');
                            jans.append('0');
                            diff = -1;
                        }
                    } else if (diff == -1) {
                        cans.append('0');
                        jans.append('9');
                    } else if (diff == 1) {
                        cans.append('9');
                        jans.append('0');
                    }
                } else if (cch == '?') {
                    // jch is not ?
                    jans.append(jch);

                    if (diff == 0) {
                        int nextDelta = getNextDelta(c, j, i);
                        boolean eq = canBeEq(c, j, i);
                        if (nextDelta <= 5 && nextDelta >= -5 && eq) {
                            cans.append(jch);
                        } else if (nextDelta >= 5) {
                            // c's next digit is bigger
                            cans.append(getPrev(jch));
                            diff = 1;
                        } else if (nextDelta <= -5) {
                            // j's next digit is bigger
                            cans.append(jch);
                            //diff = -1; // make no inference
                        }
                    } else if (diff == -1) {
                        cans.append('0');
                    } else if (diff == 1) {
                        cans.append('9');
                    }
                } else if (jch == '?') {
                    // cch is not ?
                    cans.append(cch);

                    if (diff == 0) {
                        int nextDelta = getNextDelta(c, j, i);
                        boolean eq = canBeEq(c, j, i);
                        if (nextDelta <= 5 && nextDelta >= -5 && eq) {
                            jans.append(cch);
                        } else if (nextDelta >= 5) {
                            // c's next digit is bigger
                            jans.append(cch);
                            //diff = 1; // make no inference
                        } else if (nextDelta <= -5) {
                            // j's next digit is bigger
                            jans.append(getPrev(cch));
                            diff = -1;
                        }
                    } else if (diff == -1) {
                        jans.append('9');
                    } else if (diff == 1) {
                        jans.append('0');
                    }
                }
            }

            System.out.println("Case #" + y + ": " + cans.toString() + " " + jans.toString());
        }
    }

    private static int getNextDelta(String c, String j, int index) {
        int next = index + 1;
        if (next >= c.length()) {
            return 0;
        }
        char cnext = c.charAt(next);
        char jnext = j.charAt(next);

        if (cnext == '?' || jnext == '?') {
            return 0;
        }

        return cnext - jnext;
    }

    private static boolean canBeEq(String c, String j, int index) {
        for (int i=index+2; i < c.length(); i++) {
            if (c.charAt(i) != j.charAt(i)) {
                return false;
            }
        }
        return true;
    }

    private static char getPrev(char digit) {
        if (digit == '0') {
            return '0';
        }
        return (char)(digit - 1);
    }

}
