package org.jchien.codejam.cj2017.qr;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

/**
 * @author jchien
 */
public class FashionShow {

    private static class Model {
        char m;
        int r;
        int c;

        private Model(char m, int r, int c) {
            this.m = m;
            this.r = r;
            this.c = c;
        }
    }

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int z = in.nextInt();

        for (int y=1; y <= z; y++) {
            int n = in.nextInt();
            int numModels = in.nextInt();

            boolean[] allpr = new boolean[n];
            boolean[] allpc = new boolean[n];
            boolean[] allxdl = new boolean[2*n - 1];
            boolean[] allxdr = new boolean[2*n - 1];
            Arrays.fill(allpr, true);
            Arrays.fill(allpc, true);
            Arrays.fill(allxdl, true);
            Arrays.fill(allxdr, true);

            char[][] g = new char[n][n];
            for (int i=0; i < n; i++) {
                Arrays.fill(g[i], '.');
            }

            int pts = 0;

            List<Model> changedModels = new ArrayList<>();
            for (int i=0; i < numModels; i++) {
                char m = in.next().charAt(0);
                int r = in.nextInt()-1;
                int c = in.nextInt()-1;

                if (m == 'x' || m == 'o') {
                    allpr[r] = false;
                    allpc[c] = false;
                }
                if (m == '+' || m == 'o') {
                    allxdl[dlp(r, c)] = false;
                    allxdr[drp(n, r, c)] = false;
                }
                g[r][c] = m;
            }

            for (int r=0; r < n; r++) {
                for (int c=0; c < n; c++) {
                    boolean nx = g[r][c] == '+' || g[r][c] == 'o';
                    boolean np = g[r][c] == 'x' || g[r][c] == 'o';

                    boolean apr = allpr[r] || np;
                    boolean apc = allpc[c] || np;
                    boolean axdl = allxdl[dlp(r, c)] || nx;
                    boolean axdr = allxdr[drp(n, r, c)] || nx;

                    if (apr && apc && axdl && axdr) {
                        if (g[r][c] != 'o') {
                            changedModels.add(new Model('o', r, c));
                        }
                        g[r][c] = 'o';
                        allpr[r] = false;
                        allpc[c] = false;
                        allxdl[dlp(r, c)] = false;
                        allxdr[drp(n, r, c)] = false;
                    } else if (apr && apc && g[r][c] == '.') {
                        if (g[r][c] != 'x') {
                            changedModels.add(new Model('x', r, c));
                        }
                        g[r][c] = 'x';
                        allpr[r] = false;
                        allpc[c] = false;
                    } else if (axdl && axdr && g[r][c] == '.') {
                        if (g[r][c] != '+') {
                            changedModels.add(new Model('+', r, c));
                        }
                        g[r][c] = '+';
                        allxdl[dlp(r, c)] = false;
                        allxdr[drp(n, r, c)] = false;
                    }

                    if (g[r][c] == 'o') {
                        pts += 2;
                    } else if (g[r][c] != '.') {
                        pts += 1;
                    }
                }
            }

            System.out.println("Case #" + y + ": " + pts + " " + changedModels.size());
            for (Model m : changedModels) {
                System.out.println(m.m + " " + (m.r+1) + " " + (m.c+1));
            }
            /*for (int r=0; r < n; r++) {
                for (int c=0; c < n; c++) {
                    System.out.print(g[r][c]);
                }
                System.out.println();
            }*/
        }
    }

    // return index into allxdl
    private static int dlp(int r, int c) {
        return r + c;
    }

    // return index into allxdr
    private static int drp(int n, int r, int c) {
        return r - c + n - 1;
    }
}
