package org.jchien.codejam.cj2017.qr;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

/**
 * @author jchien
 */
public class BathroomStallsFast {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int z = in.nextInt();

        for (int y=1; y <= z; y++) {
            long n = in.nextLong();
            long k = in.nextLong();

            long lastRowDepth = (long)(Math.log10(k) / Math.log10(2));
            long lastRowSize = (long)Math.pow(2, lastRowDepth);
            long lastRowPos = k - lastRowSize;

            //System.out.println("k=" + k + ", lastRowDepth=" + lastRowDepth + ", lastRowSize=" + lastRowSize + ", lastRowPos=" + lastRowPos);

            List<Integer> route = new ArrayList<>();
            long depth = lastRowDepth;
            long rowSize = lastRowSize;
            long rowPos = lastRowPos;
            while (depth > 0) {
                long prevRowSize = rowSize / 2;
                if (rowPos >= prevRowSize) {
                    route.add(1);
                    rowPos -= prevRowSize;
                } else {
                    route.add(0);
                    // rowPos stays the same
                }

                rowSize = prevRowSize;
                depth--;
            }
            Collections.reverse(route);

            long p = n;
            rowSize = 1;
            int routeIdx = 0;
            while (rowSize < lastRowSize) {
                long sizeRem = p - 1;
                long s1 = sizeRem / 2 + (sizeRem % 2);
                long s2 = sizeRem / 2;
                long[] sizes = { s1, s2 };

                int branch = route.get(routeIdx);
                p = sizes[branch];

                routeIdx++;
                rowSize *= 2;
            }

            long sizeRem = p - 1;
            long min = sizeRem / 2;
            long max = sizeRem  / 2 + (sizeRem % 2);
            System.out.println("Case #" + y + ": " + max + " " + min);
        }
    }
}
