package org.jchien.codejam.qr2016;

import java.util.Scanner;

/**
 * @author jchien
 */
public class RevengeOfThePancakes {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int z = in.nextInt();

        for (int y=1; y <= z; y++) {
            String str = in.next();
            int len = str.length();
            boolean[] state = new boolean[len];
            for (int i=0; i < len; i++) {
                state[i] = str.charAt(i) == '+';
            }

            int moves = 0;

            int end = getEnd(state);
            while (end > 0) {
                int flipLen = getMinusPrefixLen(state);
                if (flipLen > 0) {
                    state = flip(state, flipLen);
                } else {
                    int bestFlip = 0;
                    int bestPrefixLen = 0;

                    for (int i=1; i < end; i++) {
                        int prefixLen = getMinusPrefixLen(flip(state, i));
                        if (prefixLen > bestPrefixLen) {
                            bestFlip = i;
                            bestPrefixLen = prefixLen;
                        }
                    }
                    state = flip(state, bestFlip);
                }
                moves++;
                end = getEnd(state);
            }

            System.out.println("Case #" + y + ": " + moves);
        }
    }

    private static int getMinusPrefixLen(boolean[] state) {
        for (int i=0; i < state.length; i++) {
            if (state[i]) {
                return i;
            }
        }
        return state.length;
    }

    private static int getEnd(boolean[] state) {
        int end = state.length;
        while (end > 0 && state[end-1]) {
            end--;
        }
        return end;
    }

    private static boolean[] flip(boolean[] state, int n) {
        boolean[] ret = new boolean[state.length];
        System.arraycopy(state, n, ret, n, state.length-n);
        for (int i=0; i < n; i++) {
            ret[i] = !state[n-1-i];
        }
        return ret;
    }
}
