package org.jchien.codejam.cj2016.r1b;

import java.util.*;

/**
 * @author jchien
 */
public class GettingTheDigits {
    private static class Word {
        String str;
        int digit;

        int[] wordCnts = new int[26];

        private Word(String str, int digit) {
            this.str = str;
            this.digit = digit;

            for (int i=0; i < str.length(); i++) {
                char ch = str.charAt(i);
                int index = getIndex(ch);
                wordCnts[index]++;
            }
        }
    }

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int z = in.nextInt();

        Word[] words = {
                new Word("ZERO", 0),
                new Word("TWO", 2),
                new Word("SIX", 6),
                new Word("EIGHT", 8),
                new Word("SEVEN", 7),
                new Word("FIVE", 5),
                new Word("THREE", 3),
                new Word("NINE", 9),
                new Word("FOUR", 4),
                new Word("ONE", 1),
        };

        for (int y=1; y <= z; y++) {
            int[] cnts = new int[26];

            String s = in.next();
            List<Integer> ans = new ArrayList<Integer>();

            for (int i=0; i < s.length(); i++) {
                char ch = s.charAt(i);
                int index = getIndex(ch);
                cnts[index]++;
            }

            for (int i=0; i < words.length; i++) {
                Word word = words[i];
                int cnt = takeAvailable(cnts, word);
                //System.out.println(word.str + " " + cnt);
                for (int j=0; j < cnt; j++) {
                    ans.add(word.digit);
                }
            }

            Collections.sort(ans);

            System.out.print("Case #" + y + ": ");
            for (Integer digit : ans) {
                System.out.print(digit);
            }
            System.out.println();
        }
    }

    private static int getIndex(char ch) {
        return ch - 'A';
    }

    private static int takeAvailable(int[] cnts, Word word) {
        int available = Integer.MAX_VALUE;
        for (int i=0; i < word.wordCnts.length; i++) {
            if (word.wordCnts[i] == 0) {
                continue;
            }
            available = Math.min(available, cnts[i] / word.wordCnts[i]);
        }

        for (int i=0; i < word.wordCnts.length; i++) {
            int removeCnt = word.wordCnts[i] * available;
            cnts[i] -= removeCnt;
        }

        return available;
    }
}
