package org.jchien.codejam.cj2017.qr;

import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.Scanner;

/**
 * @author jchien
 */
public class BathroomStalls {
    private static class Part {
        long start;
        long size;

        private Part(long start, long size) {
            this.start = start;
            this.size = size;
        }

        @Override
        public String toString() {
            return "Part{" +
                    "start=" + start +
                    ", size=" + size +
                    '}';
        }
    }

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int z = in.nextInt();

        Comparator<Part> comp = new Comparator<Part>() {
            @Override
            public int compare(Part o1, Part o2) {
                long d = o2.size - o1.size;
                if (d < 0) {
                    return -1;
                }
                if (d > 0) {
                    return 1;
                }
                d = o1.start - o2.start;
                if (d < 0) {
                    return -1;
                }
                if (d > 0) {
                    return 1;
                }
                return 0;
            }
        };

        for (int y=1; y <= z; y++) {
            long n = in.nextLong();
            long k = in.nextLong();

            PriorityQueue<Part> pq = new PriorityQueue<>(comp);
            Part init = new Part(0, n);
            pq.add(init);
            //System.out.println(pq);

            while (k > 1) {
                Part p = pq.remove();

                long sizeRem = p.size-1;

                long size1 = sizeRem / 2;
                long start1 = p.start;

                long size2 =  sizeRem / 2 + (sizeRem % 2);
                long start2 = p.start + size1 + 1;

                if (size1 > 0) {
                    pq.add(new Part(start1, size1));
                }
                if (size2 > 0) {
                    pq.add(new Part(start2, size2));
                }

                k--;
                //System.out.println(pq);
            }


            Part p = pq.remove();
            long sizeRem = p.size-1;
            long min = sizeRem / 2;
            long max = sizeRem  / 2 + (sizeRem % 2);
            System.out.println("Case #" + y + ": " + max + " " + min);
        }
    }
}
