package codejam;

import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class Welcome {
    private static final char[] pattern = "welcome to code jam".toCharArray();

    private char[] input;

    private Map<Entry, Integer> cache;

    public class Entry {
        public int patternIdx;

        public int inputIdx;

        public Entry(int patternIdx, int inputIdx) {
            this.patternIdx = patternIdx;
            this.inputIdx = inputIdx;
        }

        @Override
        public boolean equals(Object obj) {
            Entry o = (Entry) obj;
            return o.patternIdx == this.patternIdx && o.inputIdx == this.inputIdx;
        }

        @Override
        public int hashCode() {
            return patternIdx + inputIdx;
        }
    }

    public void run(InputStream in) {
        Scanner scanner = new Scanner(in);

        int n = scanner.nextInt();
        scanner.nextLine();

        for (int i = 0; i < n; i++) {
            input = scanner.nextLine().toCharArray();
            cache = new HashMap<Entry, Integer>();
            int r = this.findOcurrences(0, 0);
            System.out.printf("Case #%d: %04d", i + 1, r);
            System.out.println();
        }
    }

    private int findOcurrences(int patternIdx, int inputIdx) {
        if (patternIdx == pattern.length) {
            return 1;
        }

        char c = pattern[patternIdx];

        int count = 0;
        for (int i = inputIdx; i < input.length; i++) {
            if (input[i] == c) {
                Entry e = new Entry(patternIdx, i);
                if (cache.containsKey(e)) {
                    count += cache.get(e);
                } else {
                    int r = this.findOcurrences(patternIdx + 1, i + 1) % 10000;
                    count += r;
                    cache.put(e, r);
                }
            }
        }

        return count % 10000;
    }

    public static void main(String[] args) {
        new Welcome().run(System.in);
    }
}
