package codejam.y2012.r3;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

/**
 * @author Ilya Lantuh
 */
public class Task2 {

    static class Cell {
        int x;
        int y;
    }

    static Scanner input;
    static BufferedWriter output;

    static int[][] c;
    static int cc;
    static int S;
    static int n;

    public static void main(String[] args) throws Exception {
        input = new Scanner(new File("D:/Programming/Projects/CodeJam/input.txt"));
        output = new BufferedWriter(new FileWriter("D:/Programming/Projects/CodeJam/output.txt"));
        int T = input.nextInt();
        for (int i = 1; i <= T; i++) {
            String result = getResult();
            System.out.println("Case #" + i + ": " + result);
            output.write("Case #" + i + ": " + result);
            output.newLine();
        }
        output.close();
    }

    public static String getResult() {
        S = input.nextInt();
        int M = input.nextInt();

        n = 2 * S;

        c = new int[n][n];
        cc = 1;

        List<Cell> moves = new ArrayList<Cell>(M);

        for (int i = 0; i < M; i++) {
            Cell move = new Cell();
            move.x = input.nextInt();
            move.y = input.nextInt();
            moves.add(move);
        }

        for (int i = 0; i < M; i++) {
            Cell move = moves.get(i);
            int x = move.x;
            int y = move.y;
            boolean ring = false;
            boolean bridge = false;
            boolean fork = false;

            List<Integer> toReplace = new LinkedList<Integer>();

            int color = -1;
            int uncolored = 0;
            int neighbors = 0;

            if (x > 1 && Math.abs(x - 1 - y) < S) {
                neighbors++;
                if (c[x - 1][y] == 0) uncolored++;
                else color = c[x - 1][y];
            }

            if (y > 1 && Math.abs(x - y - 1) < S) {
                neighbors++;
                if (c[x][y - 1] == 0) uncolored++;
                else if (color == -1) color = c[x][y - 1];
                else {
                    toReplace.add(c[x][y - 1]);
                }
            }

            if (y > 1 && x > 1) {
                neighbors++;
                if (c[x - 1][y - 1] == 0) uncolored++;
                else if (color == -1) color = c[x - 1][y - 1];
                else {
                    toReplace.add(c[x - 1][y - 1]);
                }
            }

            if (x < n - 1 && Math.abs(x + 1 - y) < S) {
                neighbors++;
                if (c[x + 1][y] == 0) uncolored++;
                else if (color == -1) color = c[x + 1][y];
                else {
                    toReplace.add(c[x + 1][y]);
                }
            }

            if (y < n - 1 && Math.abs(x - y + 1) < S) {
                neighbors++;
                if (c[x][y + 1] == 0) uncolored++;
                else if (color == -1) color = c[x][y + 1];
                else {
                    toReplace.add(c[x][y + 1]);
                }
            }

            if (x < n - 1 && y < n - 1) {
                neighbors++;
                if (c[x + 1][y + 1] == 0) uncolored++;
                else if (color == -1) color = c[x + 1][y + 1];
                else {
                    toReplace.add(c[x + 1][y + 1]);
                }
            }

            if ((neighbors == 6 && uncolored >= 2) || (neighbors == 4 && uncolored >= 1) || (neighbors == 3 && uncolored == 1)) {
                if (x < n - 1 && c[x + 1][y] != 0) {
                    if (y < n - 1 && c[x][y + 1] != 0) {
                        if (c[x + 1][y] == c[x][y + 1] && c[x + 1][y + 1] == 0) ring = true;
                    }
                    if (x > 1 && y > 1 && c[x - 1][y - 1] != 0) {
                        if (c[x + 1][y] == c[x - 1][y - 1] && c[x][y - 1] == 0) ring = true;
                    }
                }
                if (y < n - 1 && c[x][y + 1] != 0) {
                    if (x > 1 && y > 1 && c[x - 1][y - 1] != 0) {
                        if (c[x][y + 1] == c[x - 1][y - 1] && c[x - 1][y] == 0) ring = true;
                    }
                }
                if (x > 1 && c[x - 1][y] != 0) {
                    if (y > 1 && c[x][y - 1] != 0) {
                        if (c[x - 1][y] == c[x][y - 1] && c[x - 1][y - 1] == 0) ring = true;
                    }
                    if (x < n - 1 && y < n - 1 && c[x + 1][y + 1] != 0) {
                        if (c[x - 1][y] == c[x + 1][y + 1] && c[x][y + 1] == 0) ring = true;
                    }
                }
                if (y > 1 && c[x][y - 1] != 0) {
                    if (x < n - 1 && y < n - 1 && c[x + 1][y + 1] != 0) {
                        if (c[x][y - 1] == c[x + 1][y + 1] && c[x + 1][y] == 0) ring = true;
                    }
                }
                if (x > 1 && y > 1 && x < n - 1 && y < n - 1) {
                    if (c[x + 1][y + 1] == c[x - 1][y - 1] && c[x + 1][y + 1] != 0) ring = true;
                }
                if (x > 1 && x < n - 1) {
                    if (c[x + 1][y] == c[x - 1][y] && c[x + 1][y] != 0) ring = true;
                }
                if (y > 1 && y < n - 1) {
                    if (c[x][y + 1] == c[x][y - 1] && c[x][y + 1] != 0) ring = true;
                }
            }

            if (color == -1) color = cc++;
            c[x][y] = color;

            for (int oldcolor : toReplace) {
                replace(oldcolor, color);
            }

            bridge = isBridge();
            fork = isFork();

            if (!ring && !bridge && !fork) continue;

            StringBuilder sb = new StringBuilder();
            if (bridge) {
                if (sb.length() != 0) sb.append("-");
                sb.append("bridge");
            }
            if (fork) {
                if (sb.length() != 0) sb.append("-");
                sb.append("fork");
            }
            if (ring) {
                if (sb.length() != 0) sb.append("-");
                sb.append("ring");
            }
            sb.append(" in move " + (i + 1));
            return sb.toString();
        }

        return "none";
    }

    static boolean isBridge() {
        int[] r = new int[cc];
        r[c[1][1]]++;
        r[c[S][1]]++;
        r[c[n - 1][S]]++;
        r[c[n - 1][n - 1]]++;
        r[c[S][n - 1]]++;
        r[c[1][S]]++;
        for (int i = 1; i < cc; i++) {
            if (r[i] > 1) return true;
        }
        return false;
    }

    static boolean isFork() {
        int[] r = new int[cc];
        for (int i = 2; i < S; i++) {
            r[c[i][1]]++;
            r[c[S + i - 1][i]]++;
            r[c[n - 1][S + i - 1]]++;
            r[c[S + i - 1][n - 1]]++;
            r[c[i][S + i - 1]]++;
            r[c[1][i]]++;
        }
        for (int i = 1; i < cc; i++) {
            if (r[i] > 2) return true;
        }
        return false;
    }

    static void replace(int oldcolor, int newcolor) {
        for (int i = 1; i < n; i++) {
            for (int j = 1; j < n; j++) {
                if (c[i][j] == oldcolor) c[i][j] = newcolor;
            }
        }
    }

}
