package codejam.y2014.r0;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.Locale;
import java.util.Scanner;

/**
 * @author Ilya Lantuh
 */
public class Task2 {

    static Scanner input;
    static BufferedWriter output;

    static class Bounds {
        int left;
        int right;
        int center;

        Bounds(int left, int right) {
            this.left = left;
            this.right = right;
            this.center = (left + right) / 2;
        }
    }

    public static void main(String[] args) throws Exception {
        Locale.setDefault(Locale.US);
        input = new Scanner(new File("D:/Programming/Projects/CodeJam/input.txt"));
        output = new BufferedWriter(new FileWriter("D:/Programming/Projects/CodeJam/output.txt"));
        int T = input.nextInt();
        for (int i = 1; i <= T; i++) {
            String result = getResult();
            System.out.println("Case #" + i + ": " + result);
            output.write("Case #" + i + ": " + result);
            output.newLine();
        }
        output.close();
    }

    static double C = 0;
    static double F = 0;
    static double X = 0;

    public static String getResult() {
        C = input.nextDouble();
        F = input.nextDouble();
        X = input.nextDouble();
        Bounds bounds = new Bounds(0, (int) X);
        while (true) {
            if (bounds.right - bounds.left == 1) {
                double res = Math.min(getTotalSeconds(bounds.left), getTotalSeconds(bounds.right));
                return String.format("%.7f", res);
            }
            double p = getTotalSeconds(bounds.center - 1);
            double c = getTotalSeconds(bounds.center);
            double n = getTotalSeconds(bounds.center + 1);
            if (p > c && c > n) bounds = new Bounds(bounds.center, bounds.right);
            else if (p < c && c < n) bounds = new Bounds(bounds.left, bounds.center);
            else return String.format("%.7f", c);
        }
    }

    private static double getTotalSeconds(int farms) {
        if (farms < 0) return Double.MAX_VALUE;
        double result = 0;
        double currentSpeed = 2;
        for (int i = 0; i < farms; i++) {
            result += C / currentSpeed;
            currentSpeed += F;
        }
        result += X / currentSpeed;
        return result;
    }

}
