package codejam.y2014.r0;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Locale;
import java.util.Scanner;

/**
 * @author Ilya Lantuh
 */
public class Task4 {

    static Scanner input;
    static BufferedWriter output;

    public static void main(String[] args) throws Exception {
        Locale.setDefault(Locale.US);
        input = new Scanner(new File("D:/Programming/Projects/CodeJam/input.txt"));
        output = new BufferedWriter(new FileWriter("D:/Programming/Projects/CodeJam/output.txt"));
        int T = input.nextInt();
        for (int i = 1; i <= T; i++) {
            String result = getResult();
            System.out.println("Case #" + i + ": " + result);
            output.write("Case #" + i + ": " + result);
            output.newLine();
        }
        output.close();
    }

    public static String getResult() {
        int N = input.nextInt();
        LinkedList<Double> naomi = new LinkedList<Double>();
        LinkedList<Double> ken = new LinkedList<Double>();
        for (int i = 0; i < N; i++) {
            naomi.add(input.nextDouble());
        }
        for (int i = 0; i < N; i++) {
            ken.add(input.nextDouble());
        }
        Collections.sort(naomi);
        Collections.sort(ken);
        int warScore = calculateWarScore((LinkedList<Double>) naomi.clone(), (LinkedList<Double>) ken.clone());
        int dwScore = 0;
        while (naomi.size() > 0) {
            if (naomi.getFirst() < ken.getFirst()) {
                naomi.removeFirst();
                ken.removeLast();
            } else {
                naomi.removeFirst();
                ken.removeFirst();
                dwScore++;
            }
        }
        return dwScore + " " + warScore;
    }

    static int calculateWarScore(LinkedList<Double> naomi, LinkedList<Double> ken) {
        for (int i = 0; i < naomi.size(); i++) {
            double n = naomi.get(i);
            boolean found = false;
            for (int j = 0; j < ken.size(); j++) {
                if (ken.get(j) > n) {
                    ken.remove(j);
                    found = true;
                    break;
                }
            }
            if (!found) return naomi.size() - i;
        }
        return 0;
    }
}
