package codejam.y2011.r2;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.math.BigInteger;
import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: Cronos
 * Date: 04.06.11
 * Time: 22:49
 * To change this template use File | Settings | File Templates.
 */
public class Task3 {

    static Scanner input;
    static BufferedWriter output;

    public static void main(String[] args) throws Exception {
        input = new Scanner(new File("D:/Programming/Projects/CodeJam/input.txt"));
        output = new BufferedWriter(new FileWriter("D:/Programming/Projects/CodeJam/output.txt"));
        int T = input.nextInt();
        for (int i = 1; i <= T; i++) {
            String result = getResult();
            System.out.println("Case #" + i + ": " + result);
            output.write("Case #" + i + ": " + result);
            output.newLine();
        }
        output.close();
    }

    static Set<Integer> primes = new HashSet<Integer>();
    static Set<Integer> primePowers = new HashSet<Integer>();

    public static String getResult() {
        long n = input.nextLong();
        long min = countMin(n);
        long max = countMax(n);
        return Long.toString(Math.abs(max - min));
    }

    public static long countMin(long n) {
        long sum = 0;
        long res = 0;
        for (long i = 1; i <= n; i++) {
            if (sum == 0) {
                sum = i;
                res++;
                continue;
            }
            if (sum % i != 0) {
                sum = (sum * i) / BigInteger.valueOf(sum).gcd(BigInteger.valueOf(i)).intValue();
                res++;
            }
        }
        return res;
    }

    public static long countMax(long n) {
        long sum = 0;
        long res = 0;
        for (long i = n; i > 0; i--) {
            if (sum == 0) {
                sum = i;
                res++;
                continue;
            }
            if (sum % i != 0) {
                sum = (sum * i) / BigInteger.valueOf(sum).gcd(BigInteger.valueOf(i)).intValue();
                res++;
            }
        }
        return res;
    }

    public static void generatePrimes(long n) {
        for (int i = 2; i <= n; i++) {
            primes.add(i);
        }
        List<Integer> outfiltered = new LinkedList<Integer>();
        for (int i = 2; i <= n; i++) {
            for (int j = 2 * i; j <= n; j += i) {
                outfiltered.add(j);
            }
        }
        primes.removeAll(outfiltered);
    }

    public static void generatePrimePowers(long n) {
        primePowers.add(1);
        for (int prime : primes) {
            for (int i = prime; i <= n; i *= prime) {
                primePowers.add(i);
            }
        }
    }

}
