import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

public class ProblemB {	
	public static final boolean debugging = true;
	public static final boolean showOutput = true;
	
	public static void debugPrint(String s) {
		if (debugging) { System.out.println(s); }
	}
	
	public static void debugPrintAndWrite(PrintWriter writer, String s) {
		if (showOutput) { System.out.println(s); }
		writer.print(s);
	}
	
	public static String solveForThree(String first, int firstCount, String second, int secondCount, String third, int thirdCount) {
		String ans = "";
		
		for (int i = 0; i < firstCount; i++) {
			ans += first;
		}
		
		for (int i = 0; i < secondCount; i++) {
			ans += second;
		}

		for (int i = 0; i < thirdCount; i++) {
			ans += third;
		}
		
		return ans;
	}
	
	public static String solveEven(int n, int r, int y, int b) {
		int ryPairs = 0;
		int ybPairs = 0;
		int brPairs = 0;
		
		if (r > y && r > b) {
			ybPairs = (y + b - r) / 2;
			ryPairs = y - ybPairs;
			brPairs = b - ybPairs;
		} else if (y > r && y > b) {
			brPairs = (b + r - y) / 2;
			ybPairs = b - brPairs;
			ryPairs = r - brPairs;
		} else if (b > r && b > y){
			ryPairs = (r + y - b) / 2;
			brPairs = r - ryPairs;
			ybPairs = y - ryPairs;
		} 
		
		else if (r == y && y > b) {
			brPairs = b / 2;
			ybPairs = brPairs;
			ryPairs = r - brPairs;
		} else if (b == y && y > r) {
			brPairs = r / 2;
			ryPairs = brPairs;
			ybPairs = y - brPairs;
		} else if (r == b && b > y) {
			ryPairs = y / 2;
			ybPairs = ryPairs;
			brPairs = r - ryPairs;
		} 
		
		else if (r == y && y == b){
			ryPairs = n / 6;
			ybPairs = ryPairs;
			brPairs = ryPairs;
		} 
		
		debugPrint("RY pairs " + ryPairs + ", YB pairs " + ybPairs + ", BR pairs " + brPairs);
		
		if (ryPairs == 0) {
			return solveForThree("BY", ybPairs, "BR", brPairs, "", 0);
		} else if (ybPairs == 0) {
			return solveForThree("RY", ryPairs, "RB", brPairs, "", 0);
		} else if (brPairs == 0) {
			return solveForThree("YB", ybPairs, "YR", ryPairs, "", 0);
		} else {
			return solveForThree("RB", brPairs, "YR", ryPairs, "BY", ybPairs);
		}
	}
	
	public static String solveOdd(int n, int r, int y, int b) {
		char[] unordered = new char[n];
		char[] order = new char[n];
		
		for (int i = 0; i < r; i++) {
			unordered[i] = 'R';
		}
		for (int i = r; i < r+y; i++) {
			unordered[i] = 'Y';
		}
		for (int i = r+y; i < n; i++) {
			unordered[i] = 'B';
		}
		
		int counter = 0;
		for (int i = 0; i < n; i += 2) {
			order[i] = unordered[counter];
			counter++;
		}
		
		for (int i = 1; i < n; i += 2) {
			order[i] = unordered[counter];
			counter++;
		}
		
		String ans = "";
		
		for (int i = 0; i < n; i++) {
			ans += order[i];
		}
		
		return ans;
		
	}
	
	public static boolean checkPossible(int n, int r, int o, int y, int g, int b, int v) {
		if (2 * r > n || 2 * y > n || 2 * b > n) {
			return false;
		} else {
			return true;
		}
	}
	
	public static void nextCase(long caseNum, PrintWriter writer, Scanner scanner) {
		int n = scanner.nextInt();
		int r = scanner.nextInt();
		int o = scanner.nextInt();
		int y = scanner.nextInt();
		int g = scanner.nextInt();
		int b = scanner.nextInt();
		int v = scanner.nextInt();
		
		String ans;
		
		debugPrint("RYB is " + r + " " + y + " " + b + ", n is " + n);
		
		if (!checkPossible(n,r,o,y,g,b,v)) {
			ans = "IMPOSSIBLE";
		} else if (n % 2 == 1) {
			ans = solveOdd(n, r, y, b);
		} else {
			ans = solveEven(n, r, y, b);
		}
		
		debugPrintAndWrite(writer, "Case #" + caseNum + ": " + ans);
	}
	
	public static void main(String[] args) throws Exception {
		String fileName = "B-small-attempt2";
		PrintWriter writer = new PrintWriter(fileName + ".out", "UTF-8");
		Scanner scanner = new Scanner(new File(fileName + ".in"));
		int t = scanner.nextInt();
		
		for (int i = 0; i < t; i++) {
			long startTime = System.nanoTime();
			debugPrint("Case #" + (i+1));
			
			nextCase(i+1, writer, scanner);
			
			if (i < t - 1) {
				writer.println("");
			}
			
			long endTime = System.nanoTime();
			debugPrint("Case #" + (i+1) + " took " + ((float) (endTime - startTime))/(float) 1000000000);
		}
		
		writer.close();
		scanner.close();
	}
}
