import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;


public class ProblemCTrial3 {
	public static class Pair<S, T> {
	    public final S max;
	    public final T min;

	    public Pair(S max, T min) { 
	        this.max = max;
	        this.min = min;
	    }
	}
	
	public static Pair<Long, Long> split(long space) {
		long minSplit;
		long maxSplit;
		
        space =	space - 1;
		long halfSpace = space / 2;
		if (space % 2 == 0) {
			maxSplit = halfSpace;
			minSplit = halfSpace;
		} else {
			maxSplit = halfSpace + 1;
			minSplit = halfSpace;
		}
		
		//System.out.println("Space " + (space+1) + " split into " + maxSplit + " " + minSplit);
		return new Pair<Long, Long>(maxSplit, minSplit);
	}
	
	public static void processStalls(long n, long k, PrintWriter writer, long case_num) {
		long largeSpace = n;
		long smallSpace = 0;
		long largeSpaceCount = 1;
		long smallSpaceCount = 0;
		long counter = k;
		
		while (counter > largeSpaceCount + smallSpaceCount) {
			counter -= (largeSpaceCount + smallSpaceCount);
			
			Pair<Long, Long> largeSpaceSplit = split(largeSpace);
			largeSpace = largeSpaceSplit.max;
			
			if (smallSpaceCount > 0) {
				Pair<Long, Long> smallSpaceSplit = split(smallSpace);
				smallSpace = smallSpaceSplit.min;
				
				if (largeSpace == smallSpace) {
					largeSpaceCount = largeSpaceCount * 2 + smallSpaceCount * 2;
					smallSpaceCount = 0;
				} else if (largeSpaceSplit.min == smallSpace) {
					smallSpaceCount = 2 * smallSpaceCount + largeSpaceCount;
				} else if (smallSpaceSplit.max == largeSpace) {
					largeSpaceCount = 2 * largeSpaceCount + smallSpaceCount;
				}
			} else {
				smallSpace = largeSpaceSplit.min;
				
				if (largeSpace == smallSpace) {
					largeSpaceCount = largeSpaceCount * 2;
				} else {
					smallSpaceCount = largeSpaceCount;
				}
			}

			//System.out.println("Large space size " + largeSpace + " and count " + largeSpaceCount);
			//System.out.println("Small space size " + smallSpace + " and count " + smallSpaceCount);
		}
		
		long space;
		
		if (counter <= largeSpaceCount) {
			space = largeSpace;
		} else {
			space = smallSpace;
		}
		
		//System.out.println("Final split of space " + space);
		Pair<Long, Long> finalSplit = split(space);
		
		String ans = finalSplit.max + " " + finalSplit.min;
		writer.print("Case #" + case_num + ": " + ans);
	}
	
	public static void next_case(long case_num, PrintWriter writer, Scanner scanner) {
		long stallNum = scanner.nextLong();
		long personNum = scanner.nextLong();
		
		//System.out.println("Case " + case_num + ": " + stallNum + " stalls, " + personNum + " people");
		processStalls(stallNum, personNum, writer, case_num);
	}
	
	public static void main(String[] args) throws Exception {
		String fileName = "C-large";
		PrintWriter writer = new PrintWriter(fileName + ".out", "UTF-8");
		Scanner scanner = new Scanner(new File(fileName + ".in"));
		int t = scanner.nextInt();
		
		for (int i = 0; i < t; i++) {
			next_case(i+1, writer, scanner);
			
			if (i < t - 1) {
				writer.println("");
			}
		}
		
		writer.close();
		scanner.close();
	}
}
