import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

public class ProblemA {	
	public static char[] solveCake(char[] pieces, int r, int c) {
		//int[] firstIndex = new int[r];
		char[] firstChar = new char[r];
		
		for (int i = 0; i < r; i++) {
			//firstIndex[i] = -1;
			firstChar[i] = '?';
			
			for (int j = 0; j < c; j++) {
				char tmp = pieces[i*c + j];
				if (tmp != '?') {
					firstChar[i] = tmp;
					break;
				}
			}
		}
		
		for (int i = 0; i < r; i++) {
			if (firstChar[i] != '?') {
				int j = 0;
				char first = firstChar[i];
				char tmp;
				
				while (j < c) {
					tmp = pieces[i*c + j];
					
					if (tmp == '?') {
						pieces[i*c + j] = first;
					} else {
						first = tmp;
					}
					
					j++;
				}
			}
		}
		
		int firstRow = -1;
		
		for (int i = 0; i < r; i++) {
			if (firstChar[i] != '?') {
				firstRow = i;
				break;
			}
		}
		
		for (int i = firstRow - 1; i >= 0; i--) {
			for (int j = 0; j < c; j++) {
				pieces[i*c + j] = pieces[firstRow*c + j];
			}
		}
		
		for (int i = firstRow + 1; i < r; i++) {
			if (firstChar[i] == '?') {
				for (int j = 0; j < c; j++) {
					pieces[i*c + j] = pieces[(i-1)*c + j];
				}
			}
		}
		
		return pieces;
	}
	
	
	public static void nextCase(long caseNum, PrintWriter writer, Scanner scanner) {
		int r = scanner.nextInt();
		int c = scanner.nextInt();
		char[] pieces = new char[r*c];
		
		for (int i = 0; i < r; i++) {
			String slice = scanner.next();
			for (int j = 0; j < c; j++) {
				pieces[i*c + j] = slice.charAt(j);
			}
		}
		
		pieces = solveCake(pieces, r, c);

		writer.print("Case #" + caseNum + ":");
		
		for (int i = 0; i < r; i++) {
			writer.println("");
			for (int j = 0; j < c; j++) {
				writer.print(pieces[i*c+j]);
			}
		}
	}
	
	public static void main(String[] args) throws Exception {
		String fileName = "A-small-attempt0";
		PrintWriter writer = new PrintWriter(fileName + ".out", "UTF-8");
		Scanner scanner = new Scanner(new File(fileName + ".in"));
		int t = scanner.nextInt();
		
		for (int i = 0; i < t; i++) {
			nextCase(i+1, writer, scanner);
			
			if (i < t - 1) {
				writer.println("");
			}
		}
		
		writer.close();
		scanner.close();
	}
}
