import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Scanner;

public class ProblemA {	
	public static final String fileName = "A-small-attempt0"; 
	public static final boolean debugging = false;
	public static final boolean showOutput = true;
	
	
	public static void debugPrint(String s) {
		if (debugging) { System.out.println(s); }
	}
	
	public static void debugPrintAndWrite(PrintWriter writer, String s) {
		if (showOutput) { System.out.println(s); }
		writer.print(s);
	}
	
	public static class Pancake {
	    public final long r;
	    public final long h;
	    public final long topSurface;
	    public final long sideSurface;

	    public Pancake(long r, long h) { 
	        this.r = r;
	        this.h = h;
	        this.topSurface = this.r * this.r;
	        this.sideSurface = (long)2.0 * this.r * this.h;
	    }
	    
	    public long topSurface() {
	    	return this.topSurface;
	    }
	    
	    public long sideSurface() {
	    	return this.sideSurface;
	    }
	}
	
	public static class PancakeComparator implements Comparator<Pancake> {
		public int compare(Pancake p1, Pancake p2) {
			return Long.compare(p2.sideSurface(), p1.sideSurface());
		}
	}
	
	public static long withBottomI(ArrayList<Pancake> pancakes, int i, int k) {
		debugPrint("Next trial");
		Pancake p0 = pancakes.get(i);
		debugPrint("Use pancake with (" + p0.r + ", " + p0.h + ")");
		long surface = p0.topSurface() + p0.sideSurface();
		k--;
		
		for (int j = 0; j < pancakes.size(); j++) {
			if (k == 0) {
				 break;
			}
			
			Pancake p = pancakes.get(j);
			if (j != i && p.r <= p0.r) {
				debugPrint("Use pancake with (" + p.r + ", " + p.h + ")");
				surface += p.sideSurface();
				k--;
			}
		}
		
		debugPrint("Result " + (surface*Math.PI) + " " + surface);
		
		return surface;
	}
	
	public static void nextCase(long caseNum, PrintWriter writer, Scanner scanner) {
		int n = scanner.nextInt();
		int k = scanner.nextInt();
	    
		ArrayList<Pancake> pancakes = new ArrayList<Pancake>();
		
		for (int i = 0; i < n; i++) {
			pancakes.add(new Pancake(scanner.nextLong(), scanner.nextLong()));
		}
		
		Collections.sort(pancakes, new PancakeComparator());
		
		double ans = 0;
		
		for (int i = 0; i < n; i++) {
			ans = Double.max(ans, withBottomI(pancakes, i, k));
		}
		
		debugPrintAndWrite(writer, "Case #" + caseNum + ": " + (ans * Math.PI));
	}
	
	public static void main(String[] args) throws Exception {
		PrintWriter writer = new PrintWriter(fileName + ".out", "UTF-8");
		Scanner scanner = new Scanner(new File(fileName + ".in"));
		int t = scanner.nextInt();
		
		for (int i = 0; i < t; i++) {
			long startTime = System.nanoTime();
			debugPrint("Case #" + (i+1));
			
			nextCase(i+1, writer, scanner);
			
			if (i < t - 1) {
				writer.println("");
			}
			
			long endTime = System.nanoTime();
			debugPrint("Case #" + (i+1) + " took " + ((float) (endTime - startTime))/(float) 1000000000);
		}
		
		writer.close();
		scanner.close();
	}
}
