import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

public class ProblemC {	
	public static int leftDist(Boolean stalls[], int index) {
		int dist = index - 1;
		
		for (int i = index - 1; i >= 0; i--) {
			if (stalls[i]) {
				dist = index - i - 1;
				break;
			}
		}
		
		return dist;
	}
	
	public static int rightDist(Boolean stalls[], int index) {
		int dist = stalls.length - index - 2;
		
		for (int i = index + 1; i < stalls.length; i++) {
			if (stalls[i]) {
				dist = i - index - 1;
				break;
			}
		}
		
		return dist;
	}
	
	public static void printStalls(Boolean stalls[]) {
		String str = "";
		
		for (int i = 0; i < stalls.length; i++) {
			if (stalls[i]) {
				str += 'X';
			}
			else {
				str += 'O';
			}
		}
		
		System.out.println(str);
	}
	
	public static Boolean[] occupyNextStall(Boolean stalls[], PrintWriter writer, Boolean print, long case_num) {
		int minDist = -1;
		int maxDist = -1;
		int bestStall = -1;
		
		for (int i = 1; i < stalls.length - 1; i++) {
			if (!stalls[i]) {
				int leftDist = leftDist(stalls, i);
				int rightDist = rightDist(stalls, i);
				int localMinDist = Integer.min(leftDist, rightDist);
				int localMaxDist = Integer.max(leftDist, rightDist);
				if (localMinDist > minDist || (localMinDist == minDist && localMaxDist > maxDist)) {
					minDist = localMinDist;
					maxDist = localMaxDist;
					bestStall = i;
				}
			}
		}
		
		stalls[bestStall] = true;

		if (print) {
			String ans = maxDist + " " + minDist;
			writer.print("Case #" + case_num + ": " + ans);
		}
		
		return stalls;
	}
	
	public static void next_case(long case_num, PrintWriter writer, Scanner scanner) {
		int stallNum = scanner.nextInt();
		int personNum = scanner.nextInt();
		Boolean stalls[] = new Boolean[stallNum + 2];
		
		stalls[0] = true;
		stalls[stallNum + 1] = true;
		for (int i = 0; i < stallNum; i++) {
			stalls[i+1] = false;
		}
		
		for (int i = 0; i < personNum; i++) {
			if (i == personNum - 1) {
				stalls = occupyNextStall(stalls, writer, true, case_num);
			} else {
				stalls = occupyNextStall(stalls, writer, false, case_num);
			}
		}
	}
	
	public static void main(String[] args) throws Exception {
		String fileName = "C-small-1-attempt0";
		PrintWriter writer = new PrintWriter(fileName + ".out", "UTF-8");
		Scanner scanner = new Scanner(new File(fileName + ".in"));
		int t = scanner.nextInt();
		
		for (int i = 0; i < t; i++) {
			next_case(i+1, writer, scanner);
			
			if (i < t - 1) {
				writer.println("");
			}
		}
		
		writer.close();
		scanner.close();
	}
}
