import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

public class ProblemA {	
	public static final boolean debugging = false;
	public static final boolean showOutput = true;
	
	public static void debugPrint(String s) {
		if (debugging) { System.out.println(s); }
	}
	
	public static void debugPrintAndWrite(PrintWriter writer, String s) {
		if (showOutput) { System.out.println(s); }
		writer.print(s);
	}
	
	public static double cruiseSpeed(double d, double k, double s) {
		return (s * d / (d - k));
	}
	
	public static void nextCase(long caseNum, PrintWriter writer, Scanner scanner) {
		double d = scanner.nextDouble();
		int n = scanner.nextInt();
		
		double minSpeed = -1;
		
		for (int i = 0; i < n; i++) {
			double speed = cruiseSpeed(d, scanner.nextDouble(), scanner.nextDouble());
			debugPrint("Speed "  + speed);
			if (minSpeed == -1 || speed < minSpeed) {
				minSpeed = speed;
			}
		}
		
		debugPrintAndWrite(writer, "Case #" + caseNum + ": " + minSpeed);
	}
	
	public static void main(String[] args) throws Exception {
		String fileName = "A-large";
		PrintWriter writer = new PrintWriter(fileName + ".out", "UTF-8");
		Scanner scanner = new Scanner(new File(fileName + ".in"));
		int t = scanner.nextInt();
		
		for (int i = 0; i < t; i++) {
			long startTime = System.nanoTime();
			debugPrint("Case #" + (i+1));
			
			nextCase(i+1, writer, scanner);
			
			if (i < t - 1) {
				writer.println("");
			}
			
			long endTime = System.nanoTime();
			debugPrint("Case #" + (i+1) + " took " + ((float) (endTime - startTime))/(float) 1000000000);
		}
		
		writer.close();
		scanner.close();
	}
}
