import java.io.File;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class B {	
	
	public static float probOfTie(float[] probs, PrintWriter writer) {
		int l = probs.length;
		int half = l / 2;
		
		float prob = 0;
		int max = (int) Math.pow(2, l);
		for (int i = 0; i < max; i++) {
			if (Integer.bitCount(i) == half) {
				float prod = 1;
				
				for (int j = 0; j < l; j++) {
					if (((i & ( 1 << j )) >> j) == 1) {
						prod *= probs[j];
					} else {
						prod *= 1 - probs[j];
					}
				}
				
				prob += prod;
			}
		}
		
		return prob;
	}
	
	public static void nextCase(long caseNum, PrintWriter writer, Scanner scanner) {
		int n = scanner.nextInt();
		int k = scanner.nextInt();
		
		float[] probs = new float[n];
		
		for (int i = 0; i < n; i++) {
			probs[i] = scanner.nextFloat();
		}
		
		Arrays.sort(probs);
		
		float maxProb = 0;
		int max = (int) Math.pow(2, n);
		for (int i = 0; i < max; i++) {
			if (Integer.bitCount(i) == k) {
				float[] chosen = new float[k];
				int counter = 0;
				
				for (int j = 0; j < n; j++) {
					if (((i & ( 1 << j )) >> j) == 1) {
						chosen[counter] = probs[j];
						counter++;
					} 
				}
				
				maxProb = Float.max(maxProb, probOfTie(chosen, writer));
			}
		}
		
		writer.print("Case #" + caseNum + ": " + maxProb);
	}
	
	public static void main(String[] args) throws Exception {
		String fileName = "B-small-attempt2";
		PrintWriter writer = new PrintWriter(fileName + ".out", "UTF-8");
		Scanner scanner = new Scanner(new File(fileName + ".in"));
		int t = scanner.nextInt();
		
		for (int i = 0; i < t; i++) {
			nextCase(i+1, writer, scanner);
			
			if (i < t - 1) {
				writer.println("");
			}
		}
		
		writer.close();
		scanner.close();
	}
}
