import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;

public class ProblemC {	
	public static final String fileName = "C-small-1-attempt1"; 
	public static final boolean debugging = true;
	public static final boolean showOutput = true;
	
	public static void debugPrint(String s) {
		if (debugging) { System.out.println(s); }
	}
	
	public static void debugPrintAndWrite(PrintWriter writer, String s) {
		if (showOutput) { System.out.println(s); }
		writer.print(s);
	}
	
	public static void nextCase(long caseNum, PrintWriter writer, Scanner scanner) {
		int n = scanner.nextInt();
		int k = scanner.nextInt();
		double u = scanner.nextDouble();
		ArrayList<Double> probs = new ArrayList<Double>();
		ArrayList<Double> sums = new ArrayList<Double>();
		assert(n == k);
		double sum = 0;
		
		for (int i = 0; i < n; i++) {
			double next = scanner.nextDouble();
			probs.add(next);
			sum += next;
			sums.add(sum);
		}
		
		Collections.sort(probs);
		
		int index = 0;
		
		while (index < n && sums.get(index) + u >= (double)(index+1) * probs.get(index)) {
			index++;
		}
		index--;
		
		double adj = (sums.get(index) + u) / (double) (index+1);
		
		debugPrint((index+1) + " " + adj);
		
		double prob = Math.pow(adj, index + 1);
		
		for (int i = index+1; i < n; i++) {
			prob *= probs.get(i);
		}
		
		debugPrintAndWrite(writer, "Case #" + caseNum + ": " + prob);
	}
	
	public static void main(String[] args) throws Exception {
		PrintWriter writer = new PrintWriter(fileName + ".out", "UTF-8");
		Scanner scanner = new Scanner(new File(fileName + ".in"));
		int t = scanner.nextInt();
		
		for (int i = 0; i < t; i++) {
			long startTime = System.nanoTime();
			debugPrint("Case #" + (i+1));
			
			nextCase(i+1, writer, scanner);
			
			if (i < t - 1) {
				writer.println("");
			}
			
			long endTime = System.nanoTime();
			debugPrint("Case #" + (i+1) + " took " + ((float) (endTime - startTime))/(float) 1000000000);
		}
		
		writer.close();
		scanner.close();
	}
}
