import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

public class ProblemB {	
	public static int findBreakingIndex(Integer digits[]) {
		for (int i = 1; i < digits.length; i++) {
			if (digits[i] < digits[i-1]) {
				for (int j = i; j >= 2; j--) {
					if (digits[j-1] > digits[j-2]) {
						return j;
					}
				}
				
				return 1;
			}
		}
		
		return digits.length;
	}
	
	public static Integer[] adjustFromIndex(Integer digits[], int index) {
		digits[index-1] = digits[index-1] - 1;
		for (int i = index; i < digits.length; i++) {
			digits[i] = 9;
		}
		
		return digits;
	}

	public static String digitsToString(Integer digits[]) {
		String str = "";
		Boolean foundLeadingDigit = false;
		
		for (int i = 0; i < digits.length; i++) {
			if (digits[i] != 0) {
				foundLeadingDigit = true;
			}
			
			if (foundLeadingDigit) {
				str += digits[i];
			}
		}
		
		return str;
	}
	
	public static void next_case(long case_num, PrintWriter writer, Scanner scanner) {
		String num = scanner.next();
		Integer digits[] = new Integer[num.length()];
		
		for (int i = 0; i < num.length(); i++) {
			digits[i] = Character.getNumericValue(num.charAt(i));
		}

		int breakingIndex = findBreakingIndex(digits);
		
		if (breakingIndex != digits.length) {
			digits = adjustFromIndex(digits, breakingIndex);
		}
		
		String ans = digitsToString(digits);

		writer.print("Case #" + case_num + ": " + ans);
	}
	
	public static void main(String[] args) throws Exception {
		String fileName = "B-large";
		PrintWriter writer = new PrintWriter(fileName + ".out", "UTF-8");
		Scanner scanner = new Scanner(new File(fileName + ".in"));
		int t = scanner.nextInt();
		
		for (int i = 0; i < t; i++) {
			next_case(i+1, writer, scanner);
			
			if (i < t - 1) {
				writer.println("");
			}
		}
		
		writer.close();
		scanner.close();
	}
}
