import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * @author rudy
 */
public class HotDogs {
    private double d;

    class Interval {
        double center;
        int howMany;

        Interval(double center, int howMany) {
            this.center = center;
            this.howMany = howMany;
        }

        public double left() {
            return center - ((howMany-1) /2) * d;
        }

        public double right() {
            return center + ((howMany-1) /2) * d;
        }
    }

    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new BufferedInputStream(new FileInputStream("B-small-attempt0.in")));
        PrintStream out =  new PrintStream(new BufferedOutputStream(new FileOutputStream("B-small-attempt0.out"))); //System.out;
        int nTests = scanner.nextInt();
        for (int test = 1; test <= nTests; test++) {
            new HotDogs().solve(test, scanner, out);
        }

        scanner.close();
        out.close();
    }

    private void solve(int test, Scanner scanner, PrintStream out) {
        int c = scanner.nextInt();
        d = scanner.nextInt();
        double sum = 0;
        double max = Double.NEGATIVE_INFINITY;
        double min = Double.POSITIVE_INFINITY;
        int cnt = 0;
        int[] p = new int[c];
        int[] v = new int[c];
        List<Interval> all = new ArrayList<Interval>(c);
        for (int f = 0; f < c; f++) {
            p[f] = scanner.nextInt();
            v[f] = scanner.nextInt();
            cnt += v[f];
            if (min > p[f])
                min = p[f];
            if (max < p[f])
                max = p[f];
            all.add(new Interval(p[f], v[f]));
        }
        double []initialPos = new double[cnt];
        int i=0;
        for (int f = 0; f < c; f++) {
            for (int g=0; g< v[f]; g++)
                initialPos[i++] = p[f];
        }
        while (true) {
            boolean conflict = false;
            for (int f = 0; f < all.size() - 1; f++) {
                Interval unu = all.get(f);
                Interval next = all.get(f + 1);
                if (unu.right() + d > next.left()) {

                    Interval newInt = new Interval(
//                            (unu.center * unu.howMany + next.center * next.howMany) / (unu.howMany + next.howMany),
//                            unu.center  + ((next.center-unu.center) * next.howMany) / (unu.howMany + next.howMany),
                            (unu.center  + next.center) /2f,
                            unu.howMany + next.howMany);
                    all.remove(f + 1);
                    all.remove(f);
                    all.add(f, newInt);
                    conflict = true;
                    break;
                }
            }
            if (!conflict)
                break;
        }
        double [] dest = new double[cnt];
        int crt = 0;
        for (Interval interval: all) {
            double pos = interval.center - (d * (double)(interval.howMany - 1))/2f;
            for (int f = 0; f < interval.howMany; f++) {
                dest[crt ++] = pos;
                pos +=d;
            }
        }
        double distMax = 0;
        for (int f=0; f< dest.length; f++) {
            if (distMax < Math.abs(initialPos[f]- dest[f])) {
                distMax = Math.abs(initialPos[f]- dest[f]);
            }
        }
        out.printf("Case #%d: %6f\n", test, distMax);
    }
    /*
    void aa(){
        for (int f = 0; f < c; f++) {
            sum += ((double) p[f] - min) * (double) v[f];
            cnt += v[f];
        }
        double center = (sum - min * cnt) / cnt;
        double crtDest = center - ((double) d) * ((double) cnt / 2f);
        double maximDist = 0;
        for (int f = 0; f < c; f++) {
            if (crtDest < center) {
                double dist = Math.abs(crtDest - p[f]);
                if (dist > maximDist)
                    maximDist = dist;
            }
            crtDest += d * (p[f] - 1);
            if (crtDest > center) {
                double dist = Math.abs(crtDest - p[f]);
                if (dist > maximDist)
                    maximDist = dist;
            }
            crtDest += d;
        }

    } */
}
