import java.io.*;
import java.util.*;

/**
 * @author rudy
 * @version 1.0
 *          Date: Sep 3, 2009 12:10:05 PM
 */
public class Water {
    public static void main(String[] args) throws FileNotFoundException {
        new Water().solve();
    }

    private static class Coord {
        int x;
        int y;

        public Coord(int x, int y) {
            this.x = x;
            this.y = y;
        }

        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            Coord coord = (Coord) o;

            return x == coord.x && y == coord.y;

        }

        public int hashCode() {
            int result;
            result = x;
            result = 31 * result + y;
            return result;
        }
    }

    private static enum Direction {
        N {
            public void advance(Coord c) {
                c.y--;
            }
        },
        W {
            public void advance(Coord c) {
                c.x--;
            }
        },
        E {

            public void advance(Coord c) {
                c.x++;
            }
        },
        S{
            public void advance(Coord c) {
                c.y++;
            }
        },
        ;
        public abstract void advance(Coord c);

    }
    private static class Cell {
        Direction dir = null;
        Character label;
        int heigth;

        public Cell(int heigth) {
            this.heigth = heigth;
        }

        public boolean isSink() {
            return dir == null;
        }
    }

    public void solve() throws FileNotFoundException {

        final InputStream inputStream =
//                System.in;
                new FileInputStream("/home/cornelr/b-small.in");
        Scanner scanner = new Scanner(new BufferedInputStream(inputStream));
        final PrintStream stream =
//                System.out;
                new PrintStream(new BufferedOutputStream(new FileOutputStream("/home/cornelr/b-small.out")));
        int nT = scanner.nextInt();
        scanner.nextLine();
        for (int nTest = 1; nTest <= nT; nTest++) {
            int h = scanner.nextInt();
            int w = scanner.nextInt();
            int n = h + 2;
            int m = w + 2;
            Cell[][] a = new Cell[n][m];
            for (Cell [] row: a)
                for (int f = 0; f < row.length; f++)
                    row [f] = new Cell(99999);
            for (int f = 1; f < n - 1 ; f++)
                for (int g = 1; g < m - 1; g++)
                    a[f][g].heigth = scanner.nextInt();
            // set orientation
            List<Coord> sinks = new ArrayList<Coord>(30);
            for (int f = 1 ; f < n - 1; f++)
                for (int g = 1; g < m - 1; g++) {
                    int minHeigth = a[f][g].heigth;
                    for (Direction dir: Direction.values()) {
                        Coord coord = new Coord(g, f);
                        dir.advance(coord);
                        if (a[coord.y][coord.x].heigth < minHeigth) {
                            minHeigth = a[coord.y][coord.x].heigth;
                            a[f][g].dir = dir;
                        }
                    }
                    if (a[f][g].dir == null) {
                        sinks.add(new Coord(g , f));
                    }

                }
            char crt = 'a';
            for (Coord sink: sinks) {
                Character ch = crt;
                crt ++;
                LinkedList<Coord> queue = new LinkedList<Coord>();
                queue.add(sink);
                while (!queue.isEmpty()) {
                    Coord c = queue.removeFirst();
                    Cell cell = a[c.y][c.x];
                    cell.label = ch;
                    for (Direction d: Direction.values()) {
                        Coord copy = new Coord(c.x, c.y);
                        d.advance(copy);
                        Coord another = new Coord(copy.x, copy.y);
                        if (a[copy.y][copy.x].dir != null) {
                            a[copy.y][copy.x].dir.advance(copy);
                            if (copy.equals(c)) {
                                queue.add(another);
                            }
                        }
                    }
                }
            }
            char [] rewrite = new char[256];
            Arrays.fill(rewrite,'0');
            char label = 'a';
            for (int f = 1; f < n - 1; f++)
                for (int g = 1; g < m - 1; g++) {
                    char basin = a[f][g].label;
                    if (rewrite[basin] == '0') {
                        rewrite[basin] = label++;
                    }
                    a[f][g].label = rewrite[basin];
                }
            stream.printf("Case #%d:\n", nTest);
            for (int f = 1; f < n - 1; f++) {
                for (int g = 1; g < m - 2; g++) {
                    stream.printf("%c ", a[f][g].label);
                }
                stream.printf("%c\n", a[f][m - 2].label);
            }
        }
        stream.flush();
        stream.close();
    }
}
