import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author rudy
 */
public class B {
    private static interface MatchChecker {
        Result matcher(String input);
    }

    static class Result {
        private boolean found;
        private String resulting;

        Result(boolean found, String resulting) {
            this.found = found;
            this.resulting = resulting;
        }

        public boolean found() {
            return found;
        }

        public String resulting() {
            return resulting;
        }
    }

    static class Combiner implements MatchChecker {
        private Pattern regex;
        private String replacement;

        Combiner(char a, char b, char r) {
            this.regex = Pattern.compile(String.format("^(.*)((%c%c)|(%c%c))$", a, b, b, a));
            this.replacement = "" + r;
        }

        public Result matcher(String input) {
            Matcher matcher = regex.matcher(input);
            if (matcher.matches()) {
                String group = matcher.group(1);
                return new Result(true, group + replacement);
            } else {
                return new Result(false, input);
            }
        }
    }

    static class Opposer implements MatchChecker {
        private Pattern regex1;
        private Pattern regex2;

        Opposer(char a, char b) {
            this.regex1 = Pattern.compile(String.format("^.*%c.*%c$", a, b));
            this.regex2 = Pattern.compile(String.format("^.*%c.*%c$", b, a));
        }

        public Result matcher(String input) {
            Matcher matcher1 = regex1.matcher(input);
            Matcher matcher2 = regex2.matcher(input);
            if (matcher1.matches() || matcher2.matches()) {
                return new Result(true, "");
            } else {
                return new Result(false, input);
            }
        }
    }

    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new FileInputStream("B-small-attempt0.in"));
        PrintStream out = System.out;
        out = new PrintStream(new FileOutputStream("B-small-attempt0.out"));
        int nTests = scanner.nextInt();
        for (int test = 1; test <= nTests; test++) {
            List<MatchChecker> lst = new ArrayList<MatchChecker>();
            int c = scanner.nextInt();

            for (int f = 0; f < c; f++) {
                char[] rule = scanner.next().toCharArray();
                lst.add(new Combiner(rule[0], rule[1], rule[2]));
            }

            int d = scanner.nextInt();
            for (int f = 0; f < d; f++) {
                char[] rule = scanner.next().toCharArray();
                lst.add(new Opposer(rule[0], rule[1]));
            }
            int n = scanner.nextInt();
            String crt = "";
            for (char aChar : scanner.next().toCharArray()) {
                crt += aChar;
                for (boolean found = true; found; ) {
                    found = false;
                    for (MatchChecker mc : lst) {
                        Result matcher = mc.matcher(crt);
                        crt = matcher.resulting();
                        if (matcher.found()) {
                            found = true;
                            break;
                        }
                    }
                }
            }

            out.printf("Case #%d: [", test);
            boolean isFirst = true;
            for (char x : crt.toCharArray()) {
                if (!isFirst)
                    out.print(", ");
                isFirst = false;
                out.print(x);
            }
            out.println("]");
        }
        out.close();
    }

}
