import com.sun.org.apache.xpath.internal.operations.Div;
import sun.rmi.runtime.NewThreadAction;

import java.io.*;
import java.math.BigInteger;
import java.util.Scanner;

/**
 * @author rudy
 */
public class RPI {
    static class Fraction {
        long num;
        long div;

        Fraction(long num, long div) {
            this.num = num;
            this.div = div;

        }

        Fraction add(Fraction frac){
            Fraction fraction = new Fraction(0,0);
            fraction.num = this.num * frac.div + frac.num * this.div ;
            fraction.div = this.div * frac.div;
            long gcd = BigInteger.valueOf(fraction.num).gcd(BigInteger.valueOf(fraction.div)).longValue();
            fraction.num /= gcd;
            fraction.div /= gcd;
            return fraction;
        }
        public double toDouble() {
            return ((double)num) / (double) div;
        }
    }
    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new BufferedInputStream(new FileInputStream("A-large.in")));
        PrintStream out = new PrintStream(new BufferedOutputStream(new FileOutputStream("A-large.out"))); //System.out;
        int nTests = scanner.nextInt();
        for (int test = 1; test <= nTests; test++) {
            int n = scanner.nextInt();
            char [][] a = new char[n][];
            for (int f = 0; f< n; f++) {
                a[f] = scanner.next().toCharArray();
            }
            Fraction wp [] = new Fraction[n];
            for (int f= 0; f< n; f++) {
                wp[f] = new Fraction(0, 0);
                for (char c: a[f]) {
                    switch (c) {
                        case '1':
                            wp[f].num ++;
                            wp[f].div ++;
                            break;
                        case '0':
                            wp[f].div ++;
                            break;
                        default:
                            break;
                    }
                }
            }
            Fraction owp[] = new Fraction[n];
            for (int f=0; f< n; f++) {
                owp[f] = new Fraction(0, 1);
                int cnt = 0;
                for (int g=0; g< n; g++) {
                    if (f == g)
                        continue;
                    if (a[f][g] == '.')
                        continue; //owp[f] = owp[f].add(new Fraction(wp[g].num, wp[g].div));
                    if (a[f][g] == '1') {
                        owp[f] = owp[f].add(new Fraction(wp[g].num, wp[g].div - 1));
                        cnt ++;
                    }
                    if (a[f][g] == '0') {
                        owp[f] = owp[f].add(new Fraction(wp[g].num - 1, wp[g].div - 1));
                        cnt ++;
                    }
                }
                owp[f].div *= cnt;
            }
            Fraction oowp[] = new Fraction[n];
            for (int f=0; f< n; f++) {
                oowp[f] = new Fraction(0, 1);
                int cnt = 0;
                for (int g=0; g< n; g++) {
                    if (f == g)
                        continue;
                    if (a[f][g] == '.')
                        continue;
                    oowp[f] = oowp[f].add(owp[g]);
                    cnt ++;
                }
                oowp[f].div *= cnt;
            }
            out.printf("Case #%d:\n", test);
            for (int f=0; f< n; f++) {
                out.printf("%6f\n", .25d * wp[f].toDouble() + 0.5f*owp[f].toDouble() + 0.25*oowp[f].toDouble());
            }

        }
        scanner.close();
        out.close();
    }
}
