import java.io.*;
import java.math.BigInteger;
import java.util.*;

import static java.lang.Math.*;

public class Solution implements Runnable {

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new Solution()).start();
	}

	PrintWriter cout;

	BufferedReader cin;

	StringTokenizer stok;

	public void run() {
		try {
			cout = new PrintWriter("output.txt");
			cin = new BufferedReader(new FileReader("input.txt"));
			solveA();
			// solveB();
			// solveC();
			cin.close();
			cout.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(234);
		}
	}

	String improve(String s) {
		int n = s.length();
		if (s.length() <= 2)
			return s;
		String fir = improve(s.substring(0, n / 2));
		String sec = improve(s.substring(n / 2));
		if ((sec + fir).compareTo(fir + sec) < 0)
			return sec + fir;
		return fir + sec;
	}
	
	private void solveA() throws Exception {
		int t = nextInt();
		for (int tt = 0; tt < t; ++tt) {
			int n = nextInt();
			n = (1 << n);
			int r = nextInt();
			int p = nextInt();
			int s = nextInt();
			String res = "";
			String[] st = new String[3];
			st[0] = "P";
			st[1] = "R";
			st[2] = "S";
			
			for (int tr = 0; tr < 3; ++tr) {
				int cp = 0;
				int cr = 0;
				int cs = 0;
				StringBuilder sb = new StringBuilder(st[tr]);
				while(sb.length() < n) {
					StringBuilder sb2 = new StringBuilder("");
					for (int i = 0; i < sb.length(); ++i) {
						char c = sb.charAt(i);
						if (c == 'P') {
							sb2.append("PR");
						}
						if (c == 'R') {
							sb2.append("RS");
						}
						if (c == 'S') {
							sb2.append("PS");
						}
					}
					sb = new StringBuilder(sb2.toString());
				}
				for (int i = 0; i < sb.length(); ++i) {
					if (sb.charAt(i) == 'P')
						++cp;
					if (sb.charAt(i) == 'R')
						++cr;
					if (sb.charAt(i) == 'S')
						++cs;
				}
				//cout.println("pop = " + sb.toString());
				if (r == cr && s == cs && p == cp) {
					String cand = improve(sb.toString());
					//cout.println("cand = " + cand);
					if (res.length() == 0 || cand.compareTo(res) < 0)
						res = cand;
				}
			}

			
			
			cout.print("Case #" + (tt + 1) + ": ");

			if (res.length() == 0)
				cout.println("IMPOSSIBLE");
			else
				cout.println(res);
		}
	}

	private void solveB() throws Exception {
		int t = nextInt();

		for (int tt = 0; tt < t; ++tt) {
			int n = nextInt();

			cout.println();
		}
	}

	private void solveC() throws Exception {
		int t = nextInt();
		for (int tt = 0; tt < t; ++tt) {

			cout.print("Case #" + (tt + 1) + ": ");
		}
	}

	private long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	private String next() throws Exception {
		while (stok == null || !stok.hasMoreTokens()) {
			stok = new StringTokenizer(cin.readLine());
		}
		return stok.nextToken();
	}

}