import java.io.*;
import java.math.BigInteger;
import java.util.*;

import static java.lang.Math.*;

public class Solution implements Runnable {

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new Solution()).start();
	}

	PrintWriter cout;

	BufferedReader cin;

	StringTokenizer stok;

	public void run() {
		try {
			cout = new PrintWriter("output.txt");
			cin = new BufferedReader(new FileReader("input.txt"));
			solveC();
			cin.close();
			cout.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(234);
		}
	}
	int f[] = new int[123];

	int d[][][][][];
	class w {
		int mask, l, r, hl, hr, sz;
		w(int m, int ll, int rr, int hll, int hrr, int sdz) {
			mask = m;
			l = ll;
			r = rr;
			hl = hll;
			hr = hrr;
			sz = sdz;
		}
		public String toString() {
			return "mask = 0x" + Integer.toBinaryString(mask) + ", l = " + l + ", r = " + r + ", hl = " + hl + ", hr = " + hr + ", size = " + sz;
		}
	}
	
	int N;
	
	int update_res (w v, int res) {
		if (v.sz < res)
			return res;
		for (int i = 0; i < N; i++) {
			if (( v.mask & (1 << i) ) > 0)
				continue;
			if (f[i] != v.l && f[i] != v.r)
				continue;
			if (v.hl == 0 && f[v.l] != i)
				continue;
			if (v.hr == 0 && f[v.r] != i)
				continue;
			//cout.println("WState = " + v + ", adding " + i);
			return v.sz + 1;
		}
		return res;
	}
	
	private void solveC() throws Exception {
		int t = nextInt();
		for (int tt = 0; tt < t; ++tt) {
			N = nextInt();
			for (int i = 0; i < N; ++i) {
				f[i] = nextInt() - 1;
			}
			d = new int[1 << N][N][N][2][2];
			LinkedList<w> q = new LinkedList<w>();
			for (int i = 0; i < N; ++i) {
				q.addLast(new w(1 << i, i, i, 0, 0, 1));
				d[1 << i][i][i][0][0] = 1;
			}
			int res = 1;
			
			while (!q.isEmpty()) {
				w v = q.pop();
				//cout.println("State = " + v);
				res = update_res (v, res);
				for (int i = 0; i < N; ++i) {
					if ((v.mask & (1 << i)) == 0) {
						// put to left
						if (v.hl == 1 || f[v.l] == i) {
							int new_mask = v.mask | (1 << i);
							int happy = (f[i] == v.l) ? 1 : 0;
							int happyr = (v.hr == 1 || (v.sz == 1 && f[v.r] == i)) ? 1 : 0;
							if (d[new_mask][i][v.r][happy][happyr] == 0) {
								w vv = new w(new_mask, i, v.r, happy, happyr, v.sz + 1);
								d[new_mask][i][v.r][happy][happyr] = 1;
								q.addLast(vv);
							}
						}
						// put to right
						if (v.sz > 1 && (v.hr == 1 || f[v.r] == i)) {
							int new_mask = v.mask | (1 << i);
							int happy = (f[i] == v.r) ? 1 : 0;
							if (d[new_mask][v.l][i][v.hl][happy] == 0) {
								w vv = new w(new_mask, v.l, i, v.hl, happy, v.sz + 1);
								d[new_mask][v.l][i][v.hl][happy] = 1;
								q.addLast(vv);
							}
						}	
					}
				}
			}
			
			cout.print("Case #" + (tt + 1) + ": ");
			cout.println(res);
		}
	}
	
	
	
	

	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	private String next() throws Exception {
		while (stok == null || !stok.hasMoreTokens()) {
			stok = new StringTokenizer(cin.readLine());
		}
		return stok.nextToken();
	}

}