/*
 * Author skreys
 * 
 */

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class Solution implements Runnable {

	final double EPS = 1e-9;

	BufferedReader cin;

	StringTokenizer stok;

	PrintWriter cout;

	int nextInt() throws Exception {
		while (stok == null || !stok.hasMoreTokens()) {
			stok = new StringTokenizer(cin.readLine());
		}
		return Integer.parseInt(stok.nextToken());
	}

	String next() throws Exception {
		while (stok == null || !stok.hasMoreTokens()) {
			stok = new StringTokenizer(cin.readLine());
		}
		return stok.nextToken();
	}

	public static void main(String args[]) throws Exception {
		(new Solution()).run();
	}

	public void run() {
		try {
			cin = new BufferedReader(new FileReader("second-division.in"));
			cout = new PrintWriter(new FileWriter("second-division.out"));
			solve();
			cout.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void solve() throws Exception {
		int T = nextInt();

		ArrayList<BigInteger> list = new ArrayList<BigInteger>();
		ArrayList<String> s = new ArrayList<String>();
		s.add("");

		while (s.size() > 0) {
			ArrayList<String> s2 = new ArrayList<String>();
			for (String ss : s) {
				// move from even palindrom to odd
				for (char c = '0'; c <= '2'; c++) {
					String cand = ss + c
							+ (new StringBuffer(ss)).reverse().toString();
					if (ok(cand, BigInteger.ONE, BigInteger.TEN.pow(110))) {
						list.add(new BigInteger(cand));
						// cout.println(cand + ", ");
						// s2.add(ss + c);
					}
				}
				// move from even palindrom to even
				for (char c = '0'; c <= '2'; c++) {
					String cand = ss + c + "" + c
							+ (new StringBuffer(ss)).reverse().toString();
					if (ok(cand, BigInteger.ONE, BigInteger.TEN.pow(110))) {
						// cout.println(cand + ", ");
						list.add(new BigInteger(cand));
						s2.add(ss + c);
					}
				}
			}
			s = s2;
		}

		list.add(BigInteger.valueOf(3));
		Collections.sort(list);
		//for (BigInteger by : list)
		//	cout.println(by + ",");

		for (int t = 0; t < T; t++) {
			int ans = 0;
			String a = next(), b = next();
			BigInteger A = new BigInteger(a);
			BigInteger B = new BigInteger(b), C;
			for (BigInteger bb : list) {
				C = bb.multiply(bb);
				if (B.compareTo(C) < 0)break;
				if (A.compareTo(C) <= 0)
					++ans;
			}

			cout.println("Case #" + (t + 1) + ": " + ans);
		}

	}

	private boolean ok(String s, BigInteger A, BigInteger B) {
		BigInteger n = new BigInteger(s);
		n = n.multiply(n);
		if (n.compareTo(A) < 0 || n.compareTo(B) > 0)
			return false;
		s = n.toString();
		for (int i = 0; i < s.length(); i++) {
			if (s.charAt(i) != s.charAt(s.length() - 1 - i))
				return false;
		}
		return true;
	}

}
