import java.io.*;
import java.math.BigInteger;
import java.util.*;

import static java.lang.Math.*;

public class Solution implements Runnable {

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new Solution()).start();
	}

	PrintWriter cout;

	BufferedReader cin;

	StringTokenizer stok;

	public void run() {
		try {
			cout = new PrintWriter("output.txt");
			cin = new BufferedReader(new FileReader("input.txt"));
			solveB();
			cin.close();
			cout.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(234);
		}
	}

	int[][] state = new int[51][51];
	int[][] b = new int[51][51];
	int[][] a = new int[151][151];
	int r[] = new int[51];
	int c[] = new int[51];
	int n;
	boolean found;

	void release_col(int l, int c) {
		for (int r = 0; r < n; ++r) {
			--state[r][c];
			if (state[r][c] == 0)
				b[r][c] = 0;
		}
	}

	void release_row(int l, int r) {
		for (int c = 0; c < n; ++c) {
			--state[r][c];
			if (state[r][c] == 0)
				b[r][c] = 0;
		}
	}

	void update_row(int l, int r) {
		for (int c = 0; c < n; ++c) {
			++state[r][c];
			b[r][c] = a[l][c];
		}
	}

	void update_col(int l, int c) {
		for (int r = 0; r < n; ++r) {
			++state[r][c];
			b[r][c] = a[l][r];
		}
	}

	boolean match_row(int l, int r) {
		for (int c = 0; c < n; ++c) {
			if (state[r][c] > 0 && b[r][c] != a[l][c])
				return false;
			// all numbers above must be less
			for (int i = 0; i < r; ++i) {
				if (b[i][c] >= a[l][c])
					return false;
			}
			// all numbers below must be greater
			for (int i = r + 1; i < n; ++i) {
				if (b[i][c] <= a[l][c] && b[i][c] > 0)
					return false;
			}
		}
		return true;
	}

	boolean match_col(int l, int c) {
		for (int r = 0; r < n; ++r) {
			if (state[r][c] > 0 && b[r][c] != a[l][r])
				return false;
			// all numbers left must be less
			for (int i = 0; i < c; ++i) {
				if (b[r][i] >= a[l][r])
					return false;
			}
			// all numbers right must be greater
			for (int i = c + 1; i < n; ++i) {
				if (b[r][i] <= a[l][r] && b[r][i] > 0)
					return false;
			}
		}
		return true;
	}

	void draw_pos(int l) {
		cout.print("Trying to put list #" + (l + 1) + ":");
		for (int i = 0; i < n; i++)
			cout.print(" " + a[l][i]);
		cout.println();
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; j++) {
				if (b[i][j] == 0)
					cout.print(".");
				else
					cout.print(b[i][j]);
			}
			cout.println();
		}
		cout.println();
	}

	void go(int list) {
		if (found)
			return;
		
		//cout.println("  list = " + list + ", n + n = " + (n+n));
		if (list+1 == n + n) {
			found = true;
			//cout.println("FOUND SOLUTION !!!");
			return;
		}
		//draw_pos(list);
		for (int row = 0; row < n; ++row) {
			if (found)
				return;
			if (r[row] == 0) {
				if (match_row(list, row)) {
					update_row(list, row);
					r[row] = 1;
					go(list + 1);
					if (found)
						return;
					release_row(list, row);
					r[row] = 0;
				}
			}
		}
		for (int col = 0; col < n; ++col) {
			if (found)
				return;
			if (c[col] == 0) {
				if (match_col(list, col)) {
					update_col(list, col);
					c[col] = 1;
					go(list + 1);
					if (found)
						return;
					release_col(list, col);
					c[col] = 0;
				}
			}
		}
	}

	private void solveB() throws Exception {
		int t = nextInt();
		for (int tt = 0; tt < t; ++tt) {
			n = nextInt();
			for (int i = 0; i < n + n - 1; ++i) {
				for (int j = 0; j < n; ++j)
					a[i][j] = nextInt();
				for (int j = i - 1; j >= 0; --j) {
					boolean less = true;
					for (int k = 0; k < n; ++k) {
						if (a[j][k] < a[j + 1][k])
							break;
						if (a[j][k] > a[j + 1][k]) {
							less = false;
							break;
						}
					}
					if (!less) {
						for (int k = 0; k < n; ++k) {
							int tmp = a[j][k];
							a[j][k] = a[j + 1][k];
							a[j + 1][k] = tmp;
						}
					} else
						break;
				}
			}

			for (int i = 0; i < n; i++) {
				c[i] = r[i] = 0;
				for (int j = 0; j < n; j++)
					state[i][j] = b[i][j] = 0;
			}
			found = false;
			go(0);

			cout.print("Case #" + (tt + 1) + ":");
			for (int i = 0; i < n; i++)
				for (int j = 0; j < n; j++)
					if (state[i][j] != 2)
						cout.print(" " + b[i][j]);
			cout.println();
		}
	}

	private void solveA() throws Exception {
		int t;
		t = nextInt();
		// t = 100;
		for (int tt = 0; tt < t; ++tt) {
			String s;
			s = next();
			// s = "";for (int y = 0; y < 1000; y++)
			// s = "B" + s;
			String p = "";
			for (int i = 0; i < s.length(); ++i) {
				if (("" + s.charAt(i) + p).compareTo(p + s.charAt(i)) > 0)
					p = "" + s.charAt(i) + p;
				else
					p = p + "" + s.charAt(i);
			}
			cout.print("Case #" + (tt + 1) + ": ");
			cout.println(p);
		}
	}

	private void solveC() throws Exception {
		int t = nextInt();
		for (int tt = 0; tt < t; ++tt) {

			cout.print("Case #" + (tt + 1) + ":");
			cout.println();
		}
	}

	private void solveD() throws Exception {
		int t = nextInt();
		for (int tt = 0; tt < t; ++tt) {

			cout.print("Case #" + (tt + 1) + ":");
			cout.println();
		}
	}

	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	private String next() throws Exception {
		while (stok == null || !stok.hasMoreTokens()) {
			stok = new StringTokenizer(cin.readLine());
		}
		return stok.nextToken();
	}

}