import java.io.*;
import java.math.BigInteger;
import java.text.DecimalFormat;
import java.util.*;

import static java.lang.Math.*;

public class Solution implements Runnable {

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new Solution()).start();
	}

	PrintWriter cout;

	BufferedReader cin;

	StringTokenizer stok;

	public void run() {
		try {
			cout = new PrintWriter("output.txt");
			cin = new BufferedReader(new FileReader("input.txt"));
			// solveA();
			// solveB();
			solveC();
			cin.close();
			cout.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(234);
		}
	}

	String improve(String s) {
		int n = s.length();
		if (s.length() <= 2)
			return s;
		String fir = improve(s.substring(0, n / 2));
		String sec = improve(s.substring(n / 2));
		if ((sec + fir).compareTo(fir + sec) < 0)
			return sec + fir;
		return fir + sec;
	}
	
	private void solveA() throws Exception {
		int t = nextInt();
		for (int tt = 0; tt < t; ++tt) {
			int n = nextInt();
			//int n = 12;
			n = (1 << n);
			int r = nextInt();
			int p = nextInt();
			int s = nextInt();
			//int r = 1365, p =  1366 , s = 1365;
			String res = "";
			String[] st = new String[3];
			st[0] = "P";
			st[1] = "R";
			st[2] = "S";
			
			for (int tr = 0; tr < 3; ++tr) {
				int cp = 0;
				int cr = 0;
				int cs = 0;
				StringBuilder sb = new StringBuilder(st[tr]);
				while(sb.length() < n) {
					StringBuilder sb2 = new StringBuilder("");
					for (int i = 0; i < sb.length(); ++i) {
						char c = sb.charAt(i);
						if (c == 'P') {
							sb2.append("PR");
						}
						if (c == 'R') {
							sb2.append("RS");
						}
						if (c == 'S') {
							sb2.append("PS");
						}
					}
					sb = new StringBuilder(sb2.toString());
				}
				for (int i = 0; i < sb.length(); ++i) {
					if (sb.charAt(i) == 'P')
						++cp;
					if (sb.charAt(i) == 'R')
						++cr;
					if (sb.charAt(i) == 'S')
						++cs;
				}
				//cout.println("pop = " + sb.toString());
				//cout.println(cr + " " + cp + " " + cs);
				if (r == cr && s == cs && p == cp) {
					String cand = improve(sb.toString());
					//cout.println("cand = " + cand);
					if (res.length() == 0 || cand.compareTo(res) < 0)
						res = cand;
				}
			}

			
			
			cout.print("Case #" + (tt + 1) + ": ");

			if (res.length() == 0)
				cout.println("IMPOSSIBLE");
			else
				cout.println(res);
		}
	}
	
	double tupo(int n, int k, double[] p) {
		double res = 0;
		for (int mask = 0; mask < (1 << n); ++mask) {
			
			int cnt = 0;
			for (int i = 0; i < n; i++) {
				if ((mask & (1 << i)) > 0) {
					++cnt;
					if (cnt > k)
						break;
				}
			}
			if (cnt == k) {
				double sum = 0;
				for (int nmask = mask; nmask > 0; nmask = ((nmask - 1) & mask)) {
					int cnt2 = 0;
					double pp = 1.;
					for (int i = 0; i < n; i++) {
						if ((nmask & (1 << i)) > 0) {
							++cnt2;
							pp *= p[i];
							if (cnt2 + cnt2 > k)
								break;
						} else {
							if ((mask & (1 << i)) > 0)
								pp *= (1.00000000 - p[i]);
						}
					}
					if (cnt2 + cnt2 == k) {
						sum += pp;
					}
				}
				if (sum > res) {
					res = sum;
				}
			}
		}
		
		return res;
	}

	private void solveB() throws Exception {
		int t = nextInt();

		for (int tt = 0; tt < t; ++tt) {
			int n = nextInt();
			int k = nextInt();
			double[] p = new double[n];
			for (int i = 0; i < n; ++i)
				p[i] = Double.parseDouble(next());
			
			double tupo = tupo(n, k, p);
			
			double res = 0;
			
			int kk = k / 2;
			
			double[][][] d = new double[n + 1][kk + 2][kk + 2];
			d[0][0][0] = 1.0;
			for (int i = 0; i < n; ++i) {
				for (int no = 0; no <= kk && no <= i; ++no) {
					for (int yes = 0; yes <= kk && yes <= i - no; ++yes) {
						d[i + 1][no + 1][yes] += d[i][no][yes] * (1.000000000000 - p[i]);
						d[i + 1][no][yes + 1] += d[i][no][yes] * p[i];
						d[i + 1][no][yes] += d[i][no][yes];
					}
				}
			}

			res = d[n][kk][kk];
			cout.print("Case #" + (tt + 1) + ": ");
			cout.println(res);
			if (Math.abs(tupo - res) > 1e-7) {
				cout.println("      ALARM     " + tupo + "   vs   " + res);
			}
		}
	}
	
	int f[][][];
	boolean works(int n, int wmask, int mmask, int mask) {
		if (f[wmask][mmask][mask] != 0)
			return f[wmask][mmask][mask] == 1;
		
		if (wmask == ((1 << n) - 1))
			return true;
		
		for (int i = 0; i < n; ++i) {
			if ((wmask & (1 << i)) > 0)
				continue;
			int can = 0;
			for (int j = 0; j < n; ++j) {
				if ((mmask & (1 << j)) > 0)
					continue;
				int bit = i * n + j;
				if ((mask & (1 << bit)) == 0)
					continue;
				can = 1;
				if (!works(n, wmask | (1 << i), mmask | (1 << j), mask)) {
					f[wmask][mmask][mask] = -1;
					return false;
				}
			}
			if (can == 0) {
				f[wmask][mmask][mask] = -1;
				return false;
			}
		}
		f[wmask][mmask][mask] = 1;
		return true;
	}

	private void solveC() throws Exception {
		int t = nextInt();
		for (int tt = 0; tt < t; ++tt) {
			f = new int[17][17][1 << (16)];
			
			int n = nextInt();
			String []op = new String[n + 1];
			op[n] = "";
			for(int i = 0; i < n; i++) {
				op[i] = next();
				op[n] += op[i];
			}
			int res = n * n;
			int mask = Integer.parseInt(op[n], 2);
			
			//System.out.println("Mask = " + mask);
			
			for (int m = 0; m < (1 << (n * n)); ++m) {
				if ((m & mask) > 0)
					continue;
				
				int cost = 0;
				for (int i = 0; i < n * n; i++)
					if ((m & (1 << i)) > 0)
						++cost;
				if (cost >= res)
					continue;
				int nm = mask | m;
				//System.out.println("    newMask = " + nm + " " + cost + " " + works(n, 0, 0, nm));
				if (works(n, 0, 0, nm)) {
					res = cost;
				}
			}

			cout.print("Case #" + (tt + 1) + ": " + res + "\n");
		}
	}

	private long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	private String next() throws Exception {
		while (stok == null || !stok.hasMoreTokens()) {
			stok = new StringTokenizer(cin.readLine());
		}
		return stok.nextToken();
	}

}