package codejam2016.round1b;

import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.*;

import codejam2016.round1b.template.AbstractSolver;

public class SolverB extends AbstractSolver {

	@Override
	protected String solveCase() {
		char[] C = read().toCharArray();
		char[] J = read().toCharArray();
		StringBuilder newC = new StringBuilder();
		StringBuilder newJ = new StringBuilder();
		int cmp = 0;
		// < 0    C is smaller
		// == 0   C == J
		// > 0    C is larger
		for (int i = 0; i < C.length; i++) {
			char cChar = C[i];
			char jChar = J[i];
			int cCharInt = Character.digit(cChar, 10);
			int jCharInt = Character.digit(jChar, 10);
			boolean cQuestionMark = cChar == '?';
			boolean jQuestionMark = jChar == '?';
			if (!cQuestionMark) {
				newC.append(cCharInt);
			}
			if (!jQuestionMark) {
				newJ.append(jCharInt);
			}
			if (cmp == 0) {
				// Do look-ahead
				int cCarryBit = 0;
				int jCarryBit = 0;
				if (i + 1 < C.length && C[i + 1] != '?' && J[i + 1] != '?') {
					//int cNextInt = ((int)C[i + 1]) - ((int)'0');
					//int jNextInt = ((int)J[i + 1]) - ((int)'0');
					int cNextInt = Character.digit(C[i + 1], 10);
					int jNextInt = Character.digit(J[i + 1], 10);
					if (cNextInt + 5 < jNextInt && cCharInt < 9) {
						cCarryBit = 1;
					} else if (cNextInt > jNextInt + 5 && jCharInt < 9) {
						jCarryBit = 1;
					}
				}
				if (cQuestionMark && jQuestionMark) {
					newC.append(cCarryBit);
					newJ.append(jCarryBit);
				} else if (cQuestionMark) {
					if (jCharInt == 9) {
						newC.append(jCharInt);
					} else {
						newC.append(jCharInt + cCarryBit);
					}
				} else if (jQuestionMark) {
					if (cCharInt == 9) {
						newJ.append(cCharInt);
					} else {
						newJ.append(cCharInt + jCarryBit);
					}
				} else {
					cmp = cCharInt - jCharInt;
				}
			} else if (cmp < 0) {
				if (cQuestionMark) {
					newC.append('9');
				}
				if (jQuestionMark) {
					newJ.append('0');
				}
			} else {
				if (cQuestionMark) {
					newC.append('0');
				}
				if (jQuestionMark) {
					newJ.append('9');
				}
			}
		}
		return newC.toString() + " " + newJ.toString();
	}

	public static void main(String[] args) throws IOException {
		SolverB s = new SolverB();

		Path resourcePath = Paths.get("resources", "codejam2016", "round1b", "b");
		/*
		s.solve(resourcePath, "weird");
		s.solve(resourcePath, "example");
		s.solve(resourcePath, "B-small-attempt0");
		s.solve(resourcePath, "B-small-attempt1");
		*/
		//s.solve(resourcePath, "B-small-attempt2");
		s.solve(resourcePath, "B-small-attempt3");
		//s.solve(resourcePath, "B-large");
	}

}
