package abc.b;

import java.util.ArrayList;
import java.util.List;

import abc.template.AbstractCase;
import abc.template.AbstractSolver;

public class SolverB extends AbstractSolver {

	@Override
	protected List<AbstractCase> parseInputLines(List<String> lines) {
		List<List<String>> groupedCases = groupByFixedCase(lines, 1);
		List<AbstractCase> cases = new ArrayList<>();
		for (int i = 0; i < groupedCases.size(); i++) {
			List<String> caseTexts = groupedCases.get(i);
			cases.add(new CaseB(i + 1, caseTexts.get(0)));
		}
		return cases;
	}

	@Override
	protected boolean useMultithreading() {
		return false;
	}

	public static void main(String[] args) throws Exception {
		long time = System.currentTimeMillis();
		SolverB solver = new SolverB();

		solver.solve("b/example.in");
		solver.solve("b/B-small-attempt0.in");
		//solver.solve("b/B-large.in");

		System.err.println("Time: " + (System.currentTimeMillis() - time) + "ms");
	}
}