package abc.a;

import java.util.ArrayList;
import java.util.List;

import abc.template.AbstractCase;
import abc.template.AbstractSolver;

public class SolverA extends AbstractSolver {

	@Override
	protected List<AbstractCase> parseInputLines(List<String> lines) {
		List<List<String>> groupedCases = groupByFixedCase(lines, 1);
		List<AbstractCase> cases = new ArrayList<>();
		for (int i = 0; i < groupedCases.size(); i++) {
			List<String> caseTexts = groupedCases.get(i);
			long n = Long.parseLong(caseTexts.get(0));
			cases.add(new CaseA(i + 1, n));
		}
		return cases;
	}

	@Override
	protected boolean useMultithreading() {
		return false;
	}

	public static void main(String[] args) throws Exception {
		long time = System.currentTimeMillis();
		SolverA solver = new SolverA();

		solver.solve("a/A-small-attempt0.in");
		solver.solve("a/A-large.in");
		//solver.solve("a/test.in");
		//solver.solve("a/A-small-practice.in");
		//solver.solve("a/A-large-practice.in");

		System.err.println("Time: " + (System.currentTimeMillis() - time) + "ms");
	}
}