package abc.a;

import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

import abc.template.AbstractCase;

public class CaseA extends AbstractCase {

	private final long n;

	public CaseA(int caseNumber, long n) {
		super(caseNumber);
		this.n = n;
	}

	@Override
	protected String doCalculation() {
		Set<Integer> charactersToSee = IntStream.rangeClosed(0, 9).map(x -> x + '0').boxed().collect(Collectors.toSet());
		long currentValue = n;
		long previousValue = -1;
		int i;
		for (i = 2; !charactersToSee.isEmpty() && currentValue != previousValue; i++) {
			List<Integer> seenChars = String.valueOf(currentValue).chars().boxed().collect(Collectors.toList());
			charactersToSee.removeAll(seenChars);
			previousValue = currentValue;
			currentValue = n * i;
		}
		if (!charactersToSee.isEmpty()) {
			return "INSOMNIA";
		}
		return String.valueOf(previousValue);
	}

}
