package abc.c;

import java.util.ArrayList;
import java.util.List;

import abc.template.AbstractCase;
import abc.template.AbstractSolver;

public class SolverC extends AbstractSolver {

	@Override
	protected List<AbstractCase> parseInputLines(List<String> lines) {
		List<List<String>> groupedCases = groupByFixedCase(lines, 1);
		List<AbstractCase> cases = new ArrayList<>();
		for (int i = 0; i < groupedCases.size(); i++) {
			List<String> caseTexts = groupedCases.get(i);
			String[] line = caseTexts.get(0).split(" ");
			int jamcoinLength = Integer.parseInt(line[0]);
			int nrOfJamcoins = Integer.parseInt(line[1]);
			cases.add(new CaseC(i + 1, jamcoinLength, nrOfJamcoins));
		}
		return cases;
	}

	@Override
	protected boolean useMultithreading() {
		return false;
	}

	public static void main(String[] args) throws Exception {
		long time = System.currentTimeMillis();
		SolverC solver = new SolverC();

		//solver.solve("c/example.in");
		solver.solve("c/C-small-attempt0.in");
		//solver.solve("c/C-large.in");

		System.err.println("Time: " + (System.currentTimeMillis() - time) + "ms");
	}
}