package tttt;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class Main {
	
	public static List<Board> parseLines(List<String> lines) {
		Util.assertTrue(lines.size() > 2);
		int nrOfBoards = Integer.parseInt(lines.get(0));
		Util.assertTrue(lines.size() >= nrOfBoards * 5);
		
		List<Board> output = new ArrayList<>();
		for(int i = 0; i < nrOfBoards; i++) {
			int boardIndex = (i * 5) + 1;
			String line1 = lines.get(boardIndex );
			String line2 = lines.get(boardIndex + 1);
			String line3 = lines.get(boardIndex + 2);
			String line4 = lines.get(boardIndex + 3);
			Util.assertTrue(line1.length() == 4);
			Util.assertTrue(line2.length() == 4);
			Util.assertTrue(line3.length() == 4);
			Util.assertTrue(line4.length() == 4);
			Board board = new Board(line1, line2, line3, line4);
			output.add(board);
		}
		return output;
	}
	
	public static void solve(String inputFileName, String outputFileName) throws IOException {
		List<String> lines = Util.readFile(inputFileName);
		List<Board> boards = parseLines(lines);
		
		int boardNumber = 1;
		List<String> outputLines = new ArrayList<>();
		for(Board board : boards) {
			outputLines.add(board.getStatus(boardNumber));
			boardNumber++;
		}

		Util.writeToStdout(outputLines);
		Util.writeToFile(outputFileName, outputLines);
	}
	
	public static void main(String[] args) throws Exception {
		solve("input/A-small-attempt0.in", "output/A-small-attempt0.out");
	}
}
