package fas;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class Main {
	
	public static List<Case> parseLines(List<String> lines) {
		Util.assertTrue(lines.size() >= 2);
		int nrOfCases = Integer.parseInt(lines.get(0));
		Util.assertTrue(lines.size() >= nrOfCases + 1);
		
		List<Case> cases = new ArrayList<>();
		for(int i = 1; i <= nrOfCases; i++) {
			String[] currentLine = lines.get(i).split(" ");
			Util.assertTrue(currentLine.length == 2);
			cases.add(new Case(Integer.parseInt(currentLine[0]), Integer.parseInt(currentLine[1])));
		}
		return cases;
	}
	
	public static void solve(String inputFileName, String outputFileName) throws IOException {
		List<String> lines = Util.readFile(inputFileName);
		List<Case> cases = parseLines(lines);
		
		int boardNumber = 1;
		List<String> outputLines = new ArrayList<>();
		for(Case caseItem : cases) {
			outputLines.add(caseItem.getStatus(boardNumber));
			boardNumber++;
		}

		Util.writeToStdout(outputLines);
		Util.writeToFile(outputFileName, outputLines);
	}
	
	public static void main(String[] args) throws Exception {
		//solve("input/example.in", "output/example.out");
		solve("input/C-small-attempt0.in", "output/C-small-attempt0.out");
	}
}
