package fas;




public class Case {

	private final long a;
	private final long b;
	
	public Case(long a, long b) {
		this.a = a;
		this.b = b;
		Util.assertTrue(0 <= a);
		Util.assertTrue(0 <= b);
		Util.assertTrue(a <= b);
	}

	public String getStatus(int boardNumber) {
		StringBuilder sb = new StringBuilder();
		sb.append("Case #").append(boardNumber).append(": ").append(calculateStatus());
		return sb.toString();
	}
	
	private int calculateStatus() {
		int count = 0;
		for(long i = (long)Math.sqrt(a); i < ((long)Math.sqrt(b) + 1); i++) {
			if(isPalindrome(i)) {
				long squared = i * i;
				if(isPalindrome(squared) && squared >= a && squared <= b) {
					count++;
				}
			}
		}
		return count;
	}
	
	private boolean isPalindrome(long number) {
		String stringValue = String.valueOf(number);
		int stringLength = stringValue.length();
		for(int i = 0; i < (stringLength / 2) + 1; i++) {
			if (stringValue.charAt(i) != stringValue.charAt((stringLength - i) - 1)) {
				return false;
			}
		}
		return true;
	}
}
