package codejam2017.qualification;

import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;

import codejam2017.qualification.template.AbstractSolver;

public class Solver2017_Q_A extends AbstractSolver {

	@Override
	protected String solveCase() {
		char[] array = read().toCharArray();
		int arrayLength = array.length;
		int flipperSize = readInt();
		int flipCount = 0;
		
		for (int i = 0; i + flipperSize <= arrayLength; i++) {
			char cursor = array[i];
			if (cursor == '-') {
				// flip
				for (int j = i; j < i + flipperSize; j++) {
					if (array[j] == '-') {
						array[j] = '+';
					} else {
						array[j] = '-';
					}
				}
				flipCount++;
			}
		}
		for (int i = (arrayLength - flipperSize) + 1; i < arrayLength; i++) {
			char cursor = array[i];
			if (cursor == '-') {
				return "IMPOSSIBLE";
			}
		}
		return "" + flipCount;
	}
	
	public static void main(String[] args) throws IOException {
		Solver2017_Q_A s = new Solver2017_Q_A();

		Path resourcePath = Paths.get("qualification", "a");
		//s.solve(resourcePath, "example");
		//s.solve(resourcePath, "testcases");
		s.solve(resourcePath, "A-small-attempt0");
		//s.solve(resourcePath, "A-large");
	}

}
