package tttt;

import java.util.HashSet;
import java.util.Set;

public class Board {
	
	private char[] fields;
	
	public Board(String line1, String line2, String line3, String line4) {
		fields = new char[16];
		for(int i = 0; i < line1.length(); i++)
			fields[i] = line1.charAt(i);
		for(int i = 0; i < line2.length(); i++)
			fields[i + 4] = line2.charAt(i);
		for(int i = 0; i < line3.length(); i++)
			fields[i + 8] = line3.charAt(i);
		for(int i = 0; i < line4.length(); i++)
			fields[i + 12] = line4.charAt(i);
		
		for(char c : fields) {
			Util.assertTrue(c == '.' || c == 'X' || c == 'O' || c == 'T');
		}
	}

	public String getStatus(int boardNumber) {
		StringBuilder sb = new StringBuilder();
		sb.append("Case #").append(boardNumber).append(": ").append(calculateStatus());
		return sb.toString();
	}
	
	private String calculateStatus() {
		char wildcard = 'T';
		char[] players = {'X', 'O'};
		for(char player : players) {
			Set<Character> validChars = new HashSet<>();
			validChars.add(player);
			validChars.add(wildcard);
			for(int x = 0; x < 4; x++) {
				if(validChars.contains(get(x, 0)) && validChars.contains(get(x, 1)) && validChars.contains(get(x, 2)) && validChars.contains(get(x, 3))) {
					return player + " won";
				}
			}
		
			for(int y = 0; y < 4; y++) {
				if(validChars.contains(get(0, y)) && validChars.contains(get(1, y)) && validChars.contains(get(2, y)) && validChars.contains(get(3, y))) { 
					return player + " won";
				}
			}
			
			if(validChars.contains(get(0, 0)) && validChars.contains(get(1, 1)) && validChars.contains(get(2, 2)) && validChars.contains(get(3, 3))) { 
				return player + " won";
			}
			if(validChars.contains(get(3, 0)) && validChars.contains(get(2, 1)) && validChars.contains(get(1, 2)) && validChars.contains(get(0, 3))) { 
				return player + " won";
			}
		}
		
		for(int i = 0; i < 16; i++) {
			if(fields[i] == '.') {
				return "Game has not completed";
			}
		}
	    return "Draw";
	}
	
	private char get(int x, int y) {
		return fields[x + (y * 4)];
	}
}
