package qualification;

import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Scanner;

public class SolverB {

	private static final Path RESOURCE_PATH = Paths.get("resources/qualification/b");

	public static void main(String[] args) throws IOException {
		SolverB s = new SolverB();

		//s.solve("example.in");
		//s.solve("testcases.in");
		s.solve("B-small-attempt0.in");
		//s.solve("B-large.in");
	}

	private String solveCase(Scanner scanner) {
		long number = scanner.nextLong();
		while (!isTidy(number)) {
			number--;
		}
		return ""+ number;
	}
	
	private boolean isTidy(long number) {
		char[] numberArray = String.valueOf(number).toCharArray();
		int lastDigit = '0';
		for (char c : numberArray) {
			int cNum = c;
			if (lastDigit > cNum) {
				return false;
			}
			lastDigit = cNum;
		}
		return true;
	}
	
	private void solve(String filename) throws IOException {
		Path inputFile = RESOURCE_PATH.resolve(filename);
		if (filename.endsWith(".ın")) {
			filename = filename.substring(0, filename.length() - 3);
		}
		Path outputFile = RESOURCE_PATH.resolve(filename + ".out.txt");
		try ( //
				Scanner scanner = new Scanner(Files.newBufferedReader(inputFile)); //
				PrintWriter writer = new PrintWriter(Files.newBufferedWriter(outputFile)); //
		) {
			int nrOfCases = scanner.nextInt();
			for (int caseNr = 1; caseNr <= nrOfCases; caseNr++) {
				writer.println("Case #" + caseNr + ": " + solveCase(scanner));
			}
		}
	}
	
}
