package abc.b;

import java.util.ArrayDeque;
import java.util.HashSet;
import java.util.Queue;
import java.util.Set;

import abc.template.AbstractCase;

public class CaseB extends AbstractCase {

	private final String startingPancakeStack;

	public CaseB(int caseNumber, String string) {
		super(caseNumber);
		this.startingPancakeStack = string;
	}

	@Override
	protected String doCalculation() {
		int length = startingPancakeStack.length();
		int nrOfManeuvers = 0;
		Set<String> seenCombinations = new HashSet<>();
		Queue<String> newQueue = new ArrayDeque<>();
		Queue<String> queue = new ArrayDeque<>();
		newQueue.add(startingPancakeStack);
		while (!newQueue.isEmpty()) {
			queue = newQueue;
			newQueue = new ArrayDeque<>();
			while (!queue.isEmpty()) {
				String pancakeStack = queue.poll();
				if (seenCombinations.contains(pancakeStack)) {
					continue;
				}
				if (isDone(pancakeStack)) {
					return String.valueOf(nrOfManeuvers);
				}
				seenCombinations.add(pancakeStack);
				for (int i = 1; i <= length; i++) {
					newQueue.add(doFlip(pancakeStack, i));
				}
			}
			nrOfManeuvers++;
		}
		return String.valueOf("-1");
	}

	private static String doFlip(String pancakeStack, int pancakes) {
		char[] pancakesInMotion = pancakeStack.toCharArray();
		// Reverse
		for (int i = 0; i < pancakes / 2; i++) {
			char temp = pancakesInMotion[i];
			pancakesInMotion[i] = pancakesInMotion[(pancakes - i) - 1];
			pancakesInMotion[(pancakes - i) - 1] = temp;
		}
		// Swap '-' and '+'
		for (int i = 0; i < pancakes; i++) {
			if (pancakesInMotion[i] == '+') {
				pancakesInMotion[i] = '-';
			} else {
				pancakesInMotion[i] = '+';
			}
		}
		return String.valueOf(pancakesInMotion);
	}

	private static boolean isDone(String pancakeStack) {
		return pancakeStack.chars().allMatch(c -> c == '+');
	}

}
