package qualification;

import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Arrays;
import java.util.Scanner;

public class SolverB {

	private static final Path RESOURCE_PATH = Paths.get("resources/qualification/b");

	public static void main(String[] args) throws IOException {
		SolverB s = new SolverB();

		//s.solve("example.in");
		//s.solve("testcases.in");
		//s.solve("B-small-attempt0.in");
		s.solve("B-large.in");
	}

	private String solveCase(Scanner scanner) {
		char[] numberArray = scanner.next().toCharArray();
		while(true) {
			if (isTidy(numberArray)) {
				return "" + String.valueOf(numberArray);
			}
			numberArray = decrementCleverly(numberArray);
		}
	}
	
	private char[] decrementCleverly(char[] numberArray) {
		int lastDigit = 0;
		for (int i = 0; i < numberArray.length; i++) {
			int cNum = numberArray[i] - '0';
			if (lastDigit > cNum) {
				for (int j = i; j < numberArray.length; j++) {
					numberArray[j] = '9';
				}
				for (int j = i - 1; j >= 0; j--) {
					if (j == 0 && numberArray[j] == '1') {
						return Arrays.copyOfRange(numberArray, 1, numberArray.length);
					} else if (numberArray[j] == lastDigit) {
						numberArray[j] = '9';
					} else {
						numberArray[j] = (char) (numberArray[j] - 1);
						return numberArray;
					}
				}
				return numberArray;
			}
			lastDigit = cNum;
		}
		throw new RuntimeException("should be unreachable!");
	}

	private boolean isTidy(char[] numberArray) {
		int lastDigit = 0;
		for (char c : numberArray) {
			int cNum = c - '0';
			if (lastDigit > cNum) {
				return false;
			}
			lastDigit = cNum;
		}
		return true;
	}
	
	private void solve(String filename) throws IOException {
		Path inputFile = RESOURCE_PATH.resolve(filename);
		if (filename.endsWith(".in")) {
			filename = filename.substring(0, filename.length() - 3);
		}
		Path outputFile = RESOURCE_PATH.resolve(filename + ".out.txt");
		try ( //
				Scanner scanner = new Scanner(Files.newBufferedReader(inputFile)); //
				PrintWriter writer = new PrintWriter(Files.newBufferedWriter(outputFile)); //
		) {
			int nrOfCases = scanner.nextInt();
			for (int caseNr = 1; caseNr <= nrOfCases; caseNr++) {
				writer.println("Case #" + caseNr + ": " + solveCase(scanner));
			}
		}
	}
	
}
