package round1B.problemA;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Scanner;

public class FileFixIt {

	static Scanner sc;

	static int T;
	static int N;
	static int M;

	static Dir rootDir;
	static Path[] existing;
	static Path[] path;
	
	static void init() {
		existing = new Path[100];
		path = new Path[100];
		rootDir = new Dir("/");

	}

	static void reset() {
		rootDir.subs.clear();
	}

	
	
	
	public static void main(String[] args) throws FileNotFoundException {
		//sc = new Scanner(new File("src/round1B/problemA/sample.in"));
		//sc = new Scanner(new File("src/round1B/problemA/A-small-attempt0.in"));
		sc = new Scanner(System.in);
	
		T = sc.nextInt();
		init();
		
		for(int t=1; t<=T; t++) {
			N = sc.nextInt();
			M = sc.nextInt();
			reset();
			
			for(int i=0; i<N; i++) {
				existing[i] = new Path(sc.next().substring(1));
				existing[i].setDirs();
				//existing[i].printDirs();
				rootDir.addPath(existing[i],0);
			}
			for(int j=0; j<M; j++) {
				path[j] = new Path(sc.next().substring(1));
				path[j].setDirs();
				//path[j].printDirs();
			}
			
			Arrays.sort(path,0,M);
			int res=0;
			for(int j=0; j<M; j++) {
				//System.out.print("Adding Path ");
				//path[j].printDirs();
				res += rootDir.addPath(path[j], 0);
			}
			
			System.out.println("Case #"+t+": "+ res);
			
		}
	}
}

class Path implements Comparable<Path> {
	String name;
	String dirs[];
	int ndirs;

	Path(String n) {
		name = n;
		dirs = new String[100];
		ndirs = 0;
	}
	
	public void setDirs() {
		dirs = name.split("/");
		ndirs = dirs.length;
	}
	
	public void printDirs() {
		for(int i=0; i<ndirs; i++) {
			System.out.print("["+dirs[i]+"]");
		}
		System.out.println();
	}
	
	@Override
	public int compareTo(Path p) {
		return this.ndirs - p.ndirs;
	}
	
}


class Dir {
	String name;
	HashMap<String, Dir> subs;
	
	Dir(String n) {
		name = n;
		subs = new HashMap<String, Dir>();
	}
	
	int addPath(Path p, int d) {
		
		if(d >= p.ndirs) {
			return 0;
		}
		
		if(subs.containsKey(p.dirs[d])) {
			return subs.get(p.dirs[d]).addPath(p, d+1);
		}
		else {
			subs.put(p.dirs[d], new Dir(p.dirs[d]));
			return 1 + subs.get(p.dirs[d]).addPath(p, d+1);
			
		}
	}
}

