package qr.a;

import java.io.File;
import java.util.Scanner;

public class Saving {

	//static Scanner sc;
	static final int MAXF = 1000;
	static int N;
	static int S;
	static int Q;
	static String engines[];
	static String queries[];
	static int freqs[];
	static int minFreq;
	static int indexMinFreq;
	static int res;
	
	private static int engine(String s) {
		for(int i=0; i<S; i++) {
			if(s.equals(engines[i])) {
				return i;
			}
		}
		return -1;
	}
	
	private static void updateFreqs(int pos) {
		for(int i=0; i<S; i++) {
			freqs[i] = 0;
		}
		for(int q=pos; q<Q; q++) {
			if(q > pos) {
				if(!queries[q-1].equals(queries[q])) {
					freqs[engine(queries[q])]++;
				}
			}
			else {
				freqs[engine(queries[q])]++;
			}
		}
		
	}
	
	private static void printFreqs() {
		for(int i=0;i<S;i++) {
			System.out.println(engines[i] +": "+ freqs[i]);
		}
	}
	
	private static void searchMinFreq() {
		indexMinFreq = -1;
		minFreq = MAXF+1;
		for(int i=0; i<S; i++) {
			if(freqs[i] < minFreq) {
				minFreq = freqs[i];
				indexMinFreq = i;
			}
		}
	}
	
	// finds the engine that was last found since query q
	private static int findLast(int q) {
		boolean found[] = new boolean[S];
		int pos = q;
		int index;
		int founds = 0;
		for(int i=0; i<S; i++) {
			found[i] = false;
		}
		while(pos < Q) {
			index = engine(queries[pos]);
			if( !found[index]) {
				found[index] = true;
				founds++;				
			}
			if(founds == S) {
				return index;
			}
			pos++;
		}
		return -1;
	}
	
	private static void solve() {
		res = 0;
		searchMinFreq();
		
		// special (easy) cases
		if(minFreq == 0) {
			return;
		}
		/*
		if(minFreq == 1) {
			res = 1;
			return;
		}*/
		
		int q=0;
		while(minFreq >= 1) {
			int current = findLast(q);	
			while(current != engine(queries[q]) ) {
				//System.out.println("q["+q+"]="+queries[q]+", current: "+ current +"("+engines[current]+")");
				q++;
			}
			res++;
			updateFreqs(q);
			//printFreqs();
			searchMinFreq();
		}
		
		// final cases
		if(minFreq == 0) {
			return;
		}/*
		if(minFreq == 1) {
			res += 1;
			return;
		}*/
		
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		Scanner sc;
		try {
			sc = new Scanner(new File("A-large.in"));
			//sc = new Scanner(new File("A-small-attempt02.in"));
			//Scanner sc = new Scanner(System.in);
		} catch (Exception e) {
			e.printStackTrace();
			return;
		}
		N = sc.nextInt();
		for(int n=0; n<N; n++) {
			
			res = 0;
			S = sc.nextInt();
			engines = new String[S];
			freqs = new int[S];
			sc.nextLine();
			for(int i=0; i<S; i++) {
				engines[i] = new String(sc.nextLine());
				//System.out.println("ENGINE["+i+"]: "+engines[i]);
				freqs[i] = 0;
			}
			Q = sc.nextInt();
			queries = new String[Q];
			sc.nextLine();
			//System.out.println("S="+S+", Q="+Q);
			for(int q=0; q<Q; q++) {
				queries[q] = new String(sc.nextLine());
				//System.out.println("query["+q+"]: "+queries[q]+", engine "+ engine(queries[q]));
				if(q>0) {
					// if the next is different than the previous
					if(!queries[q-1].equals(queries[q])) {
						freqs[engine(queries[q])]++;
					}
				}
				else {
					freqs[engine(queries[q])]++;
				}
				
			}

			//printFreqs();
			
			solve();
			
			System.out.println("Case #"+ (n+1) + ": "+ res);
			//System.out.println("--------------------------------------------");
			
		}
		
		
		

	}



}
