package qualification2010.problemC;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class ThemePark {

	static Scanner sc;

	static final int MAX_GROUPS = 1000;
	
	static int T;
	static int R;
	static int K;
	static int N;
	
	static int groups[];
	static int next;
	
	static void init() {
		groups = new int[MAX_GROUPS];
	}
	
	static void readGroups() {
		for(int i=0; i<N; i++) {
			groups[i] = sc.nextInt();
		}
	}
	
	static void reset() {
		next = 0;
	}
	
	static int runRollerCoaster() {
		int sum = 0;
		int round, groupsInside;
		
		for(int r=0; r<R; r++) {
			round = 0;
			groupsInside = 0;
			
			while(round + groups[next] <= K && groupsInside < N) {
				round += groups[next];
				next = (next+1)%N;
				groupsInside++;
			}
			
			sum += round;
			
		}
		
		return sum;
	}
	
	public static void main(String[] args) throws FileNotFoundException {
		//sc = new Scanner(new File("src/qualification2010/problemC/sample.in"));
		sc = new Scanner(System.in);

		int res;
		init();
		T = sc.nextInt();
		
		for(int t=1; t<=T; t++) {
			reset();
			R = sc.nextInt();
			K = sc.nextInt();
			N = sc.nextInt();
			readGroups();
			
			res = runRollerCoaster();
			
			System.out.println("Case #" + t + ": "+ res);

		}
	}
}
