package round1C.problemA;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class Rope {

	static Scanner sc;

	static final int MAX_WIRES = 1000;
	
	static int T;
	static int N;
	static Wire wires[];

	static void init() {
		wires = new Wire[MAX_WIRES];
	}
	
	static int calculate() {

		int intersections = 0;
		for(int i=0; i<N; i++) {
			for(int j=i+1; j<N; j++) {
				if(wires[i].intersects(wires[j])) {
					intersections++;
				}
			}
		}
		
		return intersections;
	}
	
	public static void main(String[] args) throws FileNotFoundException {
		//sc = new Scanner(new File("src/qualification2010/problemA/A-small-attempt0.in"));
		sc = new Scanner(System.in);
	
		T = sc.nextInt();
		
		int a,b,res;
		init();
		
		for(int t=1; t<=T; t++) {
			N = sc.nextInt();
			
		
			for(int i=0; i<N; i++) {
				a = sc.nextInt();
				b = sc.nextInt();
				wires[i] = new Wire(a,b);
			}
			
			res = calculate();
			System.out.println("Case #" + t + ": " + res);
			
		}
	}
}

class Wire {
	int a;
	int b;
	
	Wire(int a, int b) {
		this.a = a;
		this.b = b;
	}
	
	boolean intersects (Wire other) {
		
		if(this.a < other.a && this.b > other.b)
			return true;
		
		if(this.a > other.a && this.b < other.b)
			return true;
		
		return false;
		
	}
	
	
}