package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class ProblemC
{
	String inputFile = "C-small.in";
	String outputFile = "C-small.out";

	// String inputFile = "C-large.in";
	// String outputFile = "C-large.out";

	BufferedReader in = null;
	BufferedWriter out = null;

	public static void main(String[] args)
	{
		ProblemC prog = new ProblemC();

		prog.openFiles();
		prog.solution();
		prog.closeFiles();

		System.out.println("THE END");
	}

	private void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}
	}

	private void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}

	private void solution()
	{
		try
		{
			String s = in.readLine();

			StringTokenizer st = new StringTokenizer(s);

			int T = Integer.parseInt(st.nextToken());

			System.out.println(T);

			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();

				st = new StringTokenizer(s);

				int N = Integer.parseInt(st.nextToken());
				long L = Long.parseLong(st.nextToken());
				long H = Long.parseLong(st.nextToken());

				long[] data = new long[N];

				s = in.readLine();
				st = new StringTokenizer(s);

				for (int j = 0; j < N; j++)
				{
					data[j] = Long.parseLong(st.nextToken());
				}

				long answer = solveOne(N, L, H, data);

				System.out.println("result:" + answer);

				out.write("Case #" + Integer.toString(i + 1) + ": ");

				if (answer == -1)
				{
					out.write("NO");
				}
				else
				{
					out.write(Long.toString(answer));
				}

				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}

	private long solveOne(int N, long L, long H, long[] data)
	{
		for (long note = L; note <= H; note++)
		{
			boolean good = true;
			
			for (int i = 0; i < N; i++)
			{
				if (note % data[i] != 0 && data[i] % note != 0)
				{
					good = false;
					break;
				}
			}
			
			if (good)
			{
				return note;
			}
		}

		return -1;
	}
}
