package gcj;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class ProblemA
{
	private final String inputFile = "A-small.in";
	private final String outputFile = "A-small.out";

	private BufferedReader in = null;
	private BufferedWriter out = null;

	public static void main(String[] args)
	{
		ProblemA prog = new ProblemA();

		prog.openFiles();
		prog.solution();
		prog.closeFiles();

		System.out.println("THE END");
	}

	private void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}
	}

	private void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}

	private void solution()
	{
		try
		{
			String s = in.readLine();

			StringTokenizer st = new StringTokenizer(s);

			int T = Integer.parseInt(st.nextToken());

			System.out.println(T);

			// read and write data
			for (int i = 0; i < T; i++)
			{
				int firstNr;
				int secondNr;
				int[][] firstData = new int[4][4];
				int[][] secondData = new int[4][4];

				s = in.readLine();
				st = new StringTokenizer(s);

				firstNr = Integer.parseInt(st.nextToken());
				
				for (int j = 0; j < 4; j++)
				{
					s = in.readLine();
					st = new StringTokenizer(s);

					for (int k = 0; k < 4; k++)
					{
						firstData[j][k] = Integer.parseInt(st.nextToken());
					}
				}
				
				s = in.readLine();
				st = new StringTokenizer(s);

				secondNr = Integer.parseInt(st.nextToken());
				
				for (int j = 0; j < 4; j++)
				{
					s = in.readLine();
					st = new StringTokenizer(s);

					for (int k = 0; k < 4; k++)
					{
						secondData[j][k] = Integer.parseInt(st.nextToken());
					}
				}

				String answer = solveOne(firstData[firstNr-1], secondData[secondNr-1]);

				System.out.println("#" + i + " result: " + answer);

				out.write("Case #" + Integer.toString(i + 1) + ": " + answer);
				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}

	private String solveOne(int[] line1, int[] line2)
	{	
		int n = 0;
		int count = 0;
		for (int i = 0; i < 4; i++)
		{
			for (int j = 0; j < 4; j++)
			{
				if (line1[i] == line2[j])
				{
					count++;
					n = line1[i];
				}
			}
		}
		
		if (count == 0)
		{
			return "Volunteer cheated!";
		}
		else if (count == 1)
		{
			return Integer.toString(n);
		}
		else if (count > 1)
		{
			return "Bad magician!";
		}
		
	    return null;
	}
}
