package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;


public class ProblemC
{
	String inputFile = "C-small.in";
	String outputFile = "C-small.out";
	
//	String inputFile = "C-large.in";
//	String outputFile = "C-large.out";

	BufferedReader in = null;
	BufferedWriter out = null;

	public static void main(String[] args)
	{
		ProblemC prog = new ProblemC();
		
		prog.openFiles();
		prog.solution();
		prog.closeFiles();
		
		System.out.println("THE END");
	}

	private void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}	
	}

	private void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}
	
	private void solution()
	{
		try
		{
			String s = in.readLine();
		
			StringTokenizer st = new StringTokenizer(s);
		
			int T = Integer.parseInt(st.nextToken());
		
			System.out.println(T);
		
			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();
				
				st = new StringTokenizer(s);
				
				int R = Integer.parseInt(st.nextToken());
				
				System.out.println(i + 1 + ".");

				int N = 101;
				
				int[][] rows = new int[N][N];
				
				for (int p = 0; p < R; p++)
				{
					s = in.readLine();
					
					st = new StringTokenizer(s);
					
					int X1 = Integer.parseInt(st.nextToken());
					int Y1 = Integer.parseInt(st.nextToken());
					int X2 = Integer.parseInt(st.nextToken());
					int Y2 = Integer.parseInt(st.nextToken());
					
					for (int j = X1; j <= X2; j++)
						for (int k = Y1; k <= Y2; k++)
							rows[j][k] = 1;
				}
				
				long answer = solveOne(rows, N);
				
				System.out.println(answer);
				out.write("Case #" + Integer.toString(i+1) + ": " + Long.toString(answer));
				out.newLine();
				
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}
	
	private long solveOne(int[][] rows, int N)
	{
		long result = 0;

		while (!empty(rows, N))
		{
			int[][] rows2 = new int[N][N];
			
			for (int i = 1; i < N; i++)
				for(int j = 1; j < N; j++)
				{
					if (rows[i][j] == 0 && rows[i-1][j] == 1 && rows[i][j-1] == 1)
						rows2[i][j] = 1;
					else if (rows[i][j] == 1 && rows[i-1][j] == 0 && rows[i][j-1] == 0)
						rows2[i][j] = 0;
					else
						rows2[i][j] = rows[i][j];
					
				}
			
			for (int i = 1; i < N; i++)
				for(int j = 1; j < N; j++)
					rows[i][j] = rows2[i][j];
			
			result++;
		}
			
			
		return result;
	}	
	
	private boolean empty(int[][] rows, int N)
	{
		for (int i = 0; i < N; i++)
			for (int j = 0; j < N; j++)
				if (rows[i][j] != 0)
					return false;
		
		return true;
	}
}
