package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class ProblemB_small
{
	private final String inputFile = "B-small.in";
	private final String outputFile = "B-small.out";

	private BufferedReader in = null;
	private BufferedWriter out = null;

	public static void main(String[] args)
	{
		ProblemB_small prog = new ProblemB_small();

		prog.openFiles();
		prog.solution();
		prog.closeFiles();

		System.out.println("THE END");
	}

	private void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}
	}

	private void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}

	private void solution()
	{
		try
		{
			String s = in.readLine();

			StringTokenizer st = new StringTokenizer(s);

			int T = Integer.parseInt(st.nextToken());

			System.out.println(T);

			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();
				
				st = new StringTokenizer(s);

				int N = Integer.parseInt(st.nextToken());
				int M = Integer.parseInt(st.nextToken());

				int[][] data = new int[N][M];

				// reads data
				for (int j = 0; j < N; j++)
				{
					s = in.readLine();

					st = new StringTokenizer(s);
					
					for (int k = 0; k < M; k++)
					{						
						data[j][k] = Integer.parseInt(st.nextToken());
					}
				}

				boolean answer = solveOne(N, M, data);

				System.out.println("result:" + answer);

				if (answer)
				{
					out.write("Case #" + Integer.toString(i + 1) + ": " + "YES");
				}
				else
				{
					out.write("Case #" + Integer.toString(i + 1) + ": " + "NO");
				}
				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}

	private boolean solveOne(int N, int M, int[][] data)
	{
		if (N == 1 || M == 1)
		{
			return true;
		}
		
		for (int i = 0; i < N; i++)
		{
			for (int j = 0; j < M; j++)
			{
				if (data[i][j] == 1)
				{
					if (!isLineAllOnes(i, j, N, M, data))
					{
						return false;
					}
				}
			}
		}
		
		return true;
	}
	
	private boolean isLineAllOnes(int i, int j, int N, int M, int[][] data)
	{
		boolean goodLine = true;
		
		for (int k = 0; k < N; k++)
		{
			if (data[k][j] != 1)
			{
				goodLine = false;
				break;
			}
		}
		
		if (goodLine)
		{
			return true;
		}
		
		goodLine = true;
		
		for (int k = 0; k < M; k++)
		{
			if (data[i][k] != 1)
			{
				goodLine = false;
				break;
			}
		}
		
		if (goodLine)
		{
			return true;
		}
		
		return false;
	}
}
