import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.StringTokenizer;

public class A
{
	String inputFile = "A-small.in";
	String outputFile = "A-small.out";
	
//	String inputFile = "A-large.in";
//	String outputFile = "A-large.out";
	
	public static void main(String[] args)
	{
		A pr = new A();
		pr.solution();
	}
	
	private void solution()
	{
		BufferedReader in = null;
		BufferedWriter out = null;
		
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}	
		
		String s = "";
		
		// read first line
		try
		{
			s = in.readLine();
		}
		catch (IOException e)
		{
			System.out.println("Error reading first line!");
		}
		
		StringTokenizer st = new StringTokenizer(s);
		
		int T = Integer.parseInt(st.nextToken());
		
		System.out.println(T);
		
		// read and write data
		try
		{
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();
				
				System.out.println(i + 1 + ".");
				System.out.println(s);
				
				long r = solveOne(s);
				
				System.out.println(r);
				
				out.write("Case #" + Integer.toString(i+1) + ": " + Long.toString(r));
				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
		
		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}
	
	private long solveOne(String s)
	{
		long result = 0;
		
		HashSet<Character> set = new HashSet<Character>();
		
		for (int i = 0; i < s.length(); i++)
			set.add(s.charAt(i));
		
		int base = set.size();
		if (base == 1)
			base = 2;
		
		HashMap<Character, Integer> map = new HashMap<Character, Integer>();
		
		map.put(s.charAt(0), 1);
		
		int value = 0;
		
		for (int i = 1; i < s.length(); i++)
		{
			if (!map.containsKey(s.charAt(i)))
			{
				map.put(s.charAt(i), value);
				if (value == 0)
					value = 2;
				else
					value++;
			}		
		}
		
		int k = s.length() - 1;
		
		for (int i = 0; i < s.length(); i++)
		{
			result += Math.pow(base, k) * map.get(s.charAt(i));
			k--;
		}
		
		return result;
	}	
}
