package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class ProblemB
{
	private final String inputFile = "B-small.in";
	private final String outputFile = "B-small.out";

	private BufferedReader in = null;
	private BufferedWriter out = null;

	public static void main(String[] args)
	{
		ProblemB prog = new ProblemB();

		prog.openFiles();
		prog.solution();
		prog.closeFiles();

		System.out.println("THE END");
	}

	private void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}
	}

	private void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}

	private void solution()
	{
		try
		{
			String s = in.readLine();

			StringTokenizer st = new StringTokenizer(s);

			int T = Integer.parseInt(st.nextToken());

			System.out.println(T);

			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();
				st = new StringTokenizer(s);

				double C = Double.parseDouble(st.nextToken());
				double F = Double.parseDouble(st.nextToken());
				double X = Double.parseDouble(st.nextToken());

				String answer = solveOne(C, F, X);

				System.out.println("#" + i + " result: " + answer);

				out.write("Case #" + Integer.toString(i + 1) + ": " + answer);
				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}

	private String solveOne(double C, double F, double X)
	{
		// System.out.println(C + " " + F + " " + X);

		double time = 0.0;
		double cookieRate = 2.0;

		if (C > X)
		{
			time = X / cookieRate;
		}
		else
		{
			time = C / cookieRate;
			while (true)
			{
				// double timeNextFactory = C / cookieRate;

				double timeWithoutFactory = (X - C) / cookieRate;
				double timeWithFactory = X / (cookieRate + F);

				//System.out.println(time + "\t" + timeWithoutFactory + "\t" + timeWithFactory);

				if (timeWithoutFactory > timeWithFactory)
				{
					cookieRate += F;
					time += C / cookieRate;
				}
				else
				{
					time += timeWithoutFactory;
					break;
				}
			}
		}
		
		return Double.toString(time);
	}
}
