package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class ProblemC_small
{
	private final String inputFile = "C-small.in";
	private final String outputFile = "C-small.out";

	private BufferedReader in = null;
	private BufferedWriter out = null;

	public static void main(String[] args)
	{
		ProblemC_small prog = new ProblemC_small();

		prog.openFiles();
		prog.solution();
		prog.closeFiles();

		System.out.println("THE END");
	}

	private void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}
	}

	private void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}

	private void solution()
	{
		try
		{
			String s = in.readLine();

			StringTokenizer st = new StringTokenizer(s);

			int T = Integer.parseInt(st.nextToken());

			System.out.println(T);

			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();

				st = new StringTokenizer(s);

				int A = Integer.parseInt(st.nextToken());
				int B = Integer.parseInt(st.nextToken());

				int answer = solveOne(A, B);

				System.out.println("result:" + answer);

				out.write("Case #" + Integer.toString(i + 1) + ": " + answer);
				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}

	private int solveOne(int A, int B)
	{
		int result = 0;
		
		int n = (int) Math.sqrt(A);
		
		boolean end = false;
		
		while (!end)
		{
			int m = n * n;
			
			if (m > B)
			{
				end = true;
			}
			else if (m >= A && isPalindrome(n) && isPalindrome(m))
			{
				result++;
			}
			
			n++;
		}

		return result;
	}

	private boolean isPalindrome(int n)
	{
		String s = Integer.toString(n);
		
		for (int i = 0; i < s.length() / 2; i++)
		{
			if (s.charAt(i) != s.charAt(s.length() - i -1))
			{
				return false;
			}
		}
		
		return true;
	}
}
