package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;


public class ProblemC
{
	String inputFile = "C-small.in";
	String outputFile = "C-small.out";
	
//	String inputFile = "C-large.in";
//	String outputFile = "C-large.out";

	BufferedReader in = null;
	BufferedWriter out = null;

	public static void main(String[] args)
	{
		ProblemC prog = new ProblemC();
		
		prog.openFiles();
		prog.solution();
		prog.closeFiles();
		
		System.out.println("THE END");
	}

	private void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}	
	}

	private void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}
	
	private void solution()
	{
		try
		{
			String s = in.readLine();
		
			StringTokenizer st = new StringTokenizer(s);
		
			int T = Integer.parseInt(st.nextToken());
		
			System.out.println(T);
		
			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();
				
				st = new StringTokenizer(s);
				
				int n = Integer.parseInt(st.nextToken());
				
				System.out.println(i + 1 + ".");
				System.out.println(s + " - " + n);
				
				long answer = solveOne(n);
				
				answer = answer % 100003;
				
				System.out.println(answer);
				
				out.write("Case #" + Integer.toString(i+1) + ": " + Long.toString(answer));
				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}
	
	private long solveOne(int n)
	{
		long result = 0;
		
		int step = 0;
		String s = "";
		
		boolean end = false;
		
		while (!end)
		{
			s = Integer.toBinaryString(step);
			
			while (s.length() < n-1)
			{
				s = "0" + s;
			}

			if (s.charAt(s.length()-1) == '1')
			{

				end = true;
				for (int i = 0; i < s.length(); i++)
					if (s.charAt(i) == '0')
						end = false;

				ArrayList<Integer> subset = new ArrayList<Integer>();

				int number = 2;

				for (int i = 0; i < s.length(); i++)
				{
					if (s.charAt(i) == '1')
						subset.add(number);

					number++;
				}

				int index = subset.size();
				
				while (subset.contains(index))
					index = subset.indexOf(index) + 1;
				
				if (index == 1)
					result++;
				
//				for (int i = subset.size() - 1 ; i >= 0; i--)
//				{
//					System.out.print(subset.get(i) + "_");
//					
//				}
//				System.out.println();
			}
			
			step++;
		}
		
		return result;
	}
}
