import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.StringTokenizer;

public class A_AL
{
	String inputFile = "A-large.in";
	String outputFile = "A-large.out";

	String[] word;
	
	public static void main(String[] args)
	{
		A_AL a = new A_AL();
		a.solution();
	}
	
	private void solution()
	{
		BufferedReader in = null;
		BufferedWriter out = null;
		
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}	
		
		String s = "";
		
		try
		{
			s = in.readLine();
		}
		catch (IOException e)
		{
			System.out.println("Error reading first line!");
		}
		
		StringTokenizer st = new StringTokenizer(s);
		
		int L = Integer.parseInt(st.nextToken());
		int D = Integer.parseInt(st.nextToken());
		int N = Integer.parseInt(st.nextToken());
		
		System.out.println(L + " " + D + " " + N);
		
		try
		{
			word = new String[D]; 
			
			for (int i = 0; i < D; i++)
				word[i] = in.readLine();
			
			for (int i = 0; i < N; i++)
			{
				s = in.readLine();
				
				System.out.println(i + 1 + ".");
				System.out.println(s);
				
				int r = solveOneStr(s);
				
				System.out.println(r);
				
				out.write("Case #" + Integer.toString(i+1) + ": " + Integer.toString(r));
				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
		
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}
	
	private int solveOneStr(String s)
	{
		HashMap<Integer, HashSet<Character>> map = new HashMap<Integer, HashSet<Character>>();
		
		HashSet<Character> set = null;

		int k = 0;
		for (int i = 0; i < s.length(); i++)
		{
			char c = s.charAt(i);
			
			if (c == '(')
			{
				set = new HashSet<Character>();
				
				while (c != ')')
				{
					i++;
					c = s.charAt(i);
					if (c != ')')
						set.add(c);
				}
			}
			else
			{
				set = new HashSet<Character>();
				set.add(c);
			}
				
			map.put(k, set);
			k++;
		}
		
		int result = 0;
		
		for (int i = 0; i < word.length; i++)
		{
			String currentWord = word[i];
			
			boolean goodWord = true;
			
			for (int j = 0; j < currentWord.length(); j++)
			{
				HashSet<Character> set2 = map.get(j);
			
				if (!set2.contains(currentWord.charAt(j)))
				{
					goodWord = false;
					break;
				}
			}
			
			if (goodWord)
				result++;
		}
		
		return result;
	}	
}
