import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class C
{
	String inputFile = "C-small.in";
	String outputFile = "C-small.out";
	
	public static void main(String[] args)
	{
		C pr = new C();
		pr.solution();
	}
	
	int[] resultList = null;
	
	BufferedReader in = null;
	BufferedWriter out = null;

	int solveCase = 0;
	
	private void solution()
	{
		
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}	
		
		String s = "";
		
		// read first line
		try
		{
			s = in.readLine();
		}
		catch (IOException e)
		{
			System.out.println("Error reading first line!");
		}
		
		StringTokenizer st = new StringTokenizer(s);
		
		int T = Integer.parseInt(st.nextToken());
		
		resultList = new int[T+1];
		for (int i = 0; i<resultList.length; i++)
			resultList[i] = Integer.MAX_VALUE;
		
		// read and write data
		try
		{
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();
				st = new StringTokenizer(s);
				
				int P = Integer.parseInt(st.nextToken());
				int Q = Integer.parseInt(st.nextToken());
				
				int[] list = new int[Q];
				
				s = in.readLine();
				st = new StringTokenizer(s);
				
				for (int j = 0; j < list.length; j++ )
					list[j] = Integer.parseInt(st.nextToken()) - 1;
				
				System.out.println(i + 1 + ".");
				System.out.println(s);
				
				solveCase = i+1;
				
				solveOne(s, P, Q, list);
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
		
		// close output file
		try
		{
			for (int i = 1; i < resultList.length; i++)
			{
		    	out.write("Case #" + Integer.toString(i) + ": " + Integer.toString(resultList[i]));
				out.newLine();
			}
				
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}
	
	private int solveOne(String s, int P, int Q, int[] list)
	{
		int result = 0;
		
		permutation(list, list.length, P, Q);
		
		return result;
	}
	
    private void permutation(int[] list, int n, int P, int Q)
    {
        if (n == 1)
        {
//        	for (int i = 0; i < list.length; i++)
//        		System.out.print(list[i]+"-");
//        	System.out.println();
        	
        	int result = solveOnePermutation(list, P, Q);
        	
        	if (result < resultList[solveCase])
        		resultList[solveCase] = result;
        	
            return;
        }
        
        for (int i = 0; i < n; i++)
        {
            swap(list, i, n-1);
            permutation(list, n-1, P, Q);
            swap(list, i, n-1);
        }
    }  

    private void swap(int[] a, int i, int j)
    {
        int c;
        
        c = a[i];
        a[i] = a[j];
        a[j] = c;
    }
    
    private int solveOnePermutation(int[] list, int P, int Q)
    {
    	int result = 0;
    	
    	boolean[] free = new boolean[P];
    	
    	for (int i = 0; i < free.length; i++)
    		free[i] = false;
    	
    	for (int i = 0; i < list.length; i++)
    	{
    		free[list[i]] = true;
    		
    		int k = list[i] + 1;
    		while (k < P && !free[k])
    			k++;
    	
  			result += k - (list[i]) - 1;
  			
  			k = list[i] - 1;
  			while (k >= 0 && !free[k])
  				k--;
  			
  			if (k < 0)
  				k = 0;
  				
  			result += (list[i]) - k;
    	}
    	
//    	System.out.println(result);

    	return result;
    }
    
}
