package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class ProblemB
{
	private final String inputFile = "B-small.in";
	private final String outputFile = "B-small.out";

	// private final String inputFile = "B-large.in";
	// private final String outputFile = "B-large.out";

	private BufferedReader in = null;
	private BufferedWriter out = null;

	public static void main(String[] args)
	{
		ProblemB prog = new ProblemB();

		prog.openFiles();
		prog.solution();
		prog.closeFiles();

		System.out.println("THE END");
	}

	private void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}
	}

	private void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}

	private void solution()
	{
		try
		{
			String s = in.readLine();

			StringTokenizer st = new StringTokenizer(s);

			int T = Integer.parseInt(st.nextToken());

			System.out.println(T);

			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();

				st = new StringTokenizer(s);

				int D = Integer.parseInt(st.nextToken());

				s = in.readLine();

				st = new StringTokenizer(s);

				int[] data = new int[D];

				for (int j = 0; j < D; j++)
				{
					data[j] = Integer.parseInt(st.nextToken());
				}

				int answer = solveOne(D, data);

				System.out.println("#" + i + " result: " + answer);

				out.write("Case #" + Integer.toString(i + 1) + ": " + answer);
				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}

	private int solveOne(int D, int[] data)
	{
		// find the biggest below 4
		// therefore you can forget about all the others that are below 4
		int max = 0;

		for (int i = 0; i < D; i++)
		{
			if (data[i] > max && data[i] < 4)
			{
				max = data[i];
			}
		}

		// find how many special minutes you need
		// split everything that is bigger than 4 until it becomes smaller
		int special = 0;

		for (int i = 0; i < D; i++)
		{

			int addition = 0;

			while (data[i] >= 4)
			{
				if (addition == 0)
				{
					special++;
				}
				else
				{
					special += addition * 2;
				}

				addition++;

				if (data[i] % 2 == 0)
				{
					data[i] = data[i] / 2;
				}
				else
				{
					data[i] = ((data[i] - 1) / 2) + 1;
				}
			}
			
			if (data[i] > max)
			{
				max = data[i];
			}
		}

		System.out.println(max + " " + special);
		
		return max + special;
	}
}
