package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;


public class ProblemA
{
	String inputFile = "A-small.in";
	String outputFile = "A-small.out";
	
//	String inputFile = "A-large.in";
//	String outputFile = "A-large.out";

	BufferedReader in = null;
	BufferedWriter out = null;

	public static void main(String[] args)
	{
		ProblemA prog = new ProblemA();
		
		prog.openFiles();
		prog.solution();
		prog.closeFiles();
		
		System.out.println("THE END");
	}

	private void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}	
	}

	private void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}
	
	private void solution()
	{
		try
		{
			String s = in.readLine();
		
			StringTokenizer st = new StringTokenizer(s);
		
			int T = Integer.parseInt(st.nextToken());
		
			System.out.println(T);
		
			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();
				
				st = new StringTokenizer(s);
				
				int N = Integer.parseInt(st.nextToken());
				int M = Integer.parseInt(st.nextToken());
				
				System.out.println(s + " - " + N + " " + M);
				
				ArrayList<String> exists = new ArrayList<String>();
				ArrayList<String> need = new ArrayList<String>();
				
				for (int j = 0; j < N; j++)
				{
					s = in.readLine();
					
					exists.add(s);
				}
				for (int j = 0; j < M; j++)
				{
					s = in.readLine();
					
					need.add(s);
				}

				long answer = solveOne(exists, need, N, M);
				
				System.out.println(answer);
				
				out.write("Case #" + Integer.toString(i+1) + ": " + Long.toString(answer));
				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}
	
	private long solveOne(ArrayList<String> exists, ArrayList<String> need, int N, int M)
	{
		long result = 0;
		
		for (int i = 0; i < M; i++)
		{
			String current = need.get(i);
			
			StringTokenizer st = new StringTokenizer(current, "/");
			
			String check = "/";
			
			while (st.hasMoreTokens())
			{
				check += st.nextToken();

				if (!exists.contains(check))
				{
					exists.add(check);
					result++;
				}

				check += "/";
			}
		}
		
		return result;
	}
}
