import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;


public class A_Snapper_Chain
{
	String inputFile = "A-small.in";
	String outputFile = "A-small.out";
	
//	String inputFile = "A-large.in";
//	String outputFile = "A-large.out";

	BufferedReader in = null;
	BufferedWriter out = null;

	public static void main(String[] args)
	{
		A_Snapper_Chain prog = new A_Snapper_Chain();
		
		prog.openFiles();
		prog.solution();
		prog.closeFiles();
	}

	public void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}	
	}

	public void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}
	
	public void solution()
	{
		try
		{
			String s = in.readLine();
		
			StringTokenizer st = new StringTokenizer(s);
		
			int T = Integer.parseInt(st.nextToken());
		
			System.out.println(T);
		
			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();
				
				st = new StringTokenizer(s);
				
				int N = Integer.parseInt(st.nextToken());
				int K = Integer.parseInt(st.nextToken());
				
				System.out.println(i + 1 + ".");
				System.out.println(s + " - " + N + " " + K);
				
				String answer = "";
				
				if (solveOne(N, K))
					answer = "ON";
				else
					answer = "OFF";
				
				System.out.println(answer);
				
				out.write("Case #" + Integer.toString(i+1) + ": " + answer);
				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}
	
	private long powerOfTwo(int N)
	{
		long answer = 1;
		
		for (int i = 0; i < N; i++)
			answer *= 2;
		
		return answer;
	}
	
	private boolean solveOne(int N, long K)
	{
		// if (K+1) divisible 2^N then light is ON, else OFF 
		if ((K+1) % powerOfTwo(N) == 0)
			return true;
		
		return false;
	}
}
