package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class ProblemA
{
	String inputFile = "A-small.in";
	String outputFile = "A-small.out";

	// String inputFile = "A-large.in";
	// String outputFile = "A-large.out";

	BufferedReader in = null;
	BufferedWriter out = null;

	public static void main(String[] args)
	{
		ProblemA prog = new ProblemA();

		prog.openFiles();
		prog.solution();
		prog.closeFiles();

		System.out.println("THE END");
	}

	private void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}
	}

	private void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}

	private void solution()
	{
		try
		{
			String s = in.readLine();

			StringTokenizer st = new StringTokenizer(s);

			int T = Integer.parseInt(st.nextToken());

			System.out.println(T);

			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();

				st = new StringTokenizer(s);

				int R = Integer.parseInt(st.nextToken());
				int C = Integer.parseInt(st.nextToken());

				char[][] data = new char[R][C];

				for (int j = 0; j < R; j++)
				{
					s = in.readLine();

					for (int k = 0; k < C; k++)
					{
						data[j][k] = s.charAt(k);
					}
				}

				char[][] answer = solveOne(R, C, data);

				System.out.println("result:" + answer);

				out.write("Case #" + Integer.toString(i + 1) + ": ");
				out.newLine();

				if (answer == null)
				{
					out.write("Impossible");
					out.newLine();
				}
				else
				{

					for (int j = 0; j < R; j++)
					{
						for (int k = 0; k < C; k++)
						{
							out.write(answer[j][k]);
						}
						out.newLine();
					}
				}
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}

	private char[][] solveOne(int R, int C, char[][] data)
	{
		boolean found = true;

		while (found)
		{
			found = false;
			for (int i = 0; i < R - 1; i++)
			{
				for (int j = 0; j < C - 1; j++)
				{
					if (data[i][j] == '#')
					{
						found = true;

						data[i][j] = '/';
						if (data[i][j + 1] == '#')
						{
							data[i][j + 1] = '\\';
						}
						else
						{
							return null;
						}

						if (data[i + 1][j] == '#')
						{
							data[i + 1][j] = '\\';
						}
						else
						{
							return null;
						}

						if (data[i + 1][j + 1] == '#')
						{
							data[i + 1][j + 1] = '/';
						}
						else
						{
							return null;
						}
					}
				}
			}
		}
		for (int i = 0; i < R; i++)
			for (int j = 0; j < C; j++)
				if (data[i][j] == '#')
					return null;

		return data;
	}

	private double calcWP(int t, int N, char[][] data)
	{
		double wins = 0;
		double total = 0;

		for (int i = 0; i < N; i++)
		{
			if (data[t][i] == '0' || data[t][i] == '1')
			{
				total++;
				if (data[t][i] == '1')
				{
					wins++;
				}
			}
		}

		if (total == 0)
		{
			return 1;
		}

		return wins / total;
	}

	private double calcWPspec(int t, int notCalc, int N, char[][] data)
	{
		double wins = 0;
		double total = 0;

		for (int i = 0; i < N; i++)
		{
			if (i != notCalc)
			{
				if (data[t][i] == '0' || data[t][i] == '1')
				{
					total++;
					if (data[t][i] == '1')
					{
						wins++;
					}
				}
			}
		}

		return wins / total;
	}

	private double calcOWP(int t, int N, char[][] data)
	{
		double totalWP = 0;
		double total = 0;

		for (int i = 0; i < N; i++)
		{
			if (data[t][i] == '0' || data[t][i] == '1')
			{
				totalWP += calcWPspec(i, t, N, data);
				total++;
			}
		}

		if (total == 0)
		{
			return 0;
		}

		return totalWP / total;
	}

	private double calcOOWP(int t, int N, char[][] data)
	{
		double totalOWP = 0;
		double total = 0;

		for (int i = 0; i < N; i++)
		{
			if (data[t][i] == '0' || data[t][i] == '1')
			{
				totalOWP += calcOWP(i, N, data);
				total++;
			}
		}

		if (total == 0)
		{
			return 0;
		}

		return totalOWP / total;
	}

}
