package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class ProblemA
{
//	String inputFile = "A-small.in";
//	String outputFile = "A-small.out";

	 String inputFile = "A-large.in";
	 String outputFile = "A-large.out";

	BufferedReader in = null;
	BufferedWriter out = null;

	public static void main(String[] args)
	{
		ProblemA prog = new ProblemA();

		prog.openFiles();
		prog.solution();
		prog.closeFiles();

		System.out.println("THE END");
	}

	private void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}
	}

	private void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}

	private void solution()
	{
		try
		{
			String s = in.readLine();

			StringTokenizer st = new StringTokenizer(s);

			int T = Integer.parseInt(st.nextToken());

			System.out.println(T);

			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();

				st = new StringTokenizer(s);

				int N = Integer.parseInt(st.nextToken());

				System.out.println(s + " - " + N);

				char[] R = new char[N];
				int[] P = new int[N];

				for (int j = 0; j < N; j++)
				{
					R[j] = st.nextToken().charAt(0);
					P[j] = Integer.parseInt(st.nextToken());
				}

				long answer = solveOne(N, R, P);

				System.out.println("result:" + answer);

				out.write("Case #" + Integer.toString(i + 1) + ": "
						+ Long.toString(answer));
				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}

	private long solveOne(int N, char[] R, int[] P)
	{
		long result = 0;

		boolean[] done = new boolean[N];

		int targetO = findFirstFalseButton('O', R, P, done, N);
		int targetB = findFirstFalseButton('B', R, P, done, N);

		int posO = 1;
		int posB = 1;

		boolean end = false;

		// the number of the button that has to be pushed
		int pushIndex = 0;

		while (!end)
		{
			result++;
			
			if (posO == targetO && posB == targetB)
			{ // both robots at their targets
				if (R[pushIndex] == 'O')
				{
					done[pushIndex] = true;
					pushIndex++;
					targetO = findFirstFalseButton('O', R, P, done, N);
				}
				else if (R[pushIndex] == 'B')
				{
					done[pushIndex] = true;
					pushIndex++;
					targetB = findFirstFalseButton('B', R, P, done, N);
				}
			}
			else if (posO == targetO)
			{ // only O is at his target
				if (R[pushIndex] == 'O')
				{
					done[pushIndex] = true;
					pushIndex++;
					targetO = findFirstFalseButton('O', R, P, done, N);
				}

				if (targetB >= 0)
				{ // if B has a target move be towards it
					if (targetB > posB)
					{
						posB++;
					}
					else
					{
						posB--;
					}
				}
			}
			else if (posB == targetB)
			{ // only B is at his target
				if (R[pushIndex] == 'B')
				{
					done[pushIndex] = true;
					pushIndex++;
					targetB = findFirstFalseButton('B', R, P, done, N);
				}

				if (targetO >= 0)
				{ // if O has a target move be towards it
					if (targetO > posO)
					{
						posO++;
					}
					else
					{
						posO--;
					}
				}
			}
			else
			{ // no robots are at their targets
				if (targetB >= 0)
				{ // if B has a target move be towards it
					if (targetB > posB)
					{
						posB++;
					}
					else
					{
						posB--;
					}
				}
				
				if (targetO >= 0)
				{ // if O has a target move be towards it
					if (targetO > posO)
					{
						posO++;
					}
					else
					{
						posO--;
					}
				}
			}

			if (allTrue(done))
			{
				end = true;
			}
		}

		return result;
	}

	private int findFirstFalseButton(char C, char[] R, int[] P, boolean[] done,
			int N)
	{
		for (int i = 0; i < N; i++)
		{
			if (R[i] == C && !done[i])
			{
				return P[i];
			}
		}

		return -1;
	}

	private boolean allTrue(boolean[] list)
	{
		for (int i = 0; i < list.length; i++)
		{
			if (!list[i])
			{
				return false;
			}
		}

		return true;
	}
}
