package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;

public class ProblemB
{
	String inputFile = "B-small.in";
	String outputFile = "B-small.out";

	// String inputFile = "B-large.in";
	// String outputFile = "B-large.out";

	BufferedReader in = null;
	BufferedWriter out = null;

	public static void main(String[] args)
	{
		ProblemB prog = new ProblemB();

		prog.openFiles();
		prog.solution();
		prog.closeFiles();

		System.out.println("THE END");
	}

	private void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}
	}

	private void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}

	private void solution()
	{
		try
		{
			String s = in.readLine();

			StringTokenizer st = new StringTokenizer(s);

			int T = Integer.parseInt(st.nextToken());

			System.out.println(T);

			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();

				st = new StringTokenizer(s);
				System.out.println(s);

				int C = Integer.parseInt(st.nextToken());

				List<String> combine = new ArrayList<String>();

				for (int j = 0; j < C; j++)
				{
					combine.add(st.nextToken());
				}

				int D = Integer.parseInt(st.nextToken());

				List<String> opposed = new ArrayList<String>();

				for (int j = 0; j < D; j++)
				{
					opposed.add(st.nextToken());
				}

				int N = Integer.parseInt(st.nextToken());

				String invoke = st.nextToken();

				String answer = solveOne(combine, opposed, invoke);

				System.out.println("result:" + answer);

				out.write("Case #" + Integer.toString(i + 1) + ": "
						+ Arrays.toString(answer.toCharArray()));
				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}

	private String solveOne(List<String> combine, List<String> opposed,
			String invoke)
	{
		// build data

		Map<String, Character> combineMap = new HashMap<String, Character>();

		for (String oneCombine : combine)
		{
			String key = oneCombine.substring(0, 2);
			Character value = oneCombine.charAt(2);

			combineMap.put(key, value);
			combineMap.put(new StringBuffer(key).reverse().toString(), value);
		}

		Map<Character, Character> opposedMap = new HashMap<Character, Character>();

		for (String oneOpposed : opposed)
		{
			Character char1 = oneOpposed.charAt(0);
			Character char2 = oneOpposed.charAt(1);

			opposedMap.put(char1, char2);
			opposedMap.put(char2, char1);
		}

		// for (String key : combineMap.keySet())
		// {
		// System.out.println(key + "=" + combineMap.get(key));
		// }
		// for (Character key : opposedMap.keySet())
		// {
		// System.out.println(key + "=" + opposedMap.get(key));
		// }

		// build result

		StringBuilder result = new StringBuilder();

		for (int i = 0; i < invoke.length(); i++)
		{
			char currentChar = invoke.charAt(i);

			if (result.length() > 0)
			{
				char lastChar = result.charAt(result.length() - 1);

				String seq1 = Character.toString(lastChar)
						+ Character.toString(currentChar);
				String seq2 = Character.toString(currentChar)
						+ Character.toString(lastChar);

				if (combineMap.containsKey(seq1)
						|| combineMap.containsKey(seq2))
				{ // check if the last char can be combined with the current
					result.replace(result.length() - 1, result.length(),
							Character.toString(combineMap.get(seq1)));
				}
				else if (opposedMap.containsKey(currentChar)
						&& (this.containsChar(result,
								opposedMap.get(currentChar))))
				{ // check if there are opposed char of the current char
					result = new StringBuilder();
				}
				else
				{ // add new char to result
					result.append(currentChar);
				}
			}
			else
			{
				result.append(currentChar);
			}
		}

		return result.toString();
	}

	private boolean containsChar(StringBuilder sb, char c)
	{
		for (int i = 0; i < sb.length(); i++)
		{
			if (sb.charAt(i) == c)
			{
				return true;
			}
		}

		return false;

	}
}
