package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class ProblemA
{
//	String inputFile = "A-small.in";
//	String outputFile = "A-small.out";

	 String inputFile = "A-large.in";
	 String outputFile = "A-large.out";

	BufferedReader in = null;
	BufferedWriter out = null;

	public static void main(String[] args)
	{
		ProblemA prog = new ProblemA();

		prog.openFiles();
		prog.solution();
		prog.closeFiles();

		System.out.println("THE END");
	}

	private void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}
	}

	private void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}

	private void solution()
	{
		try
		{
			String s = in.readLine();

			StringTokenizer st = new StringTokenizer(s);

			int T = Integer.parseInt(st.nextToken());

			System.out.println(T);

			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();

				st = new StringTokenizer(s);

				int N = Integer.parseInt(st.nextToken());

				char[][] data = new char[N][N];

				System.out.println(s + " - " + N);

				for (int j = 0; j < N; j++)
				{
					s = in.readLine();

					for (int k = 0; k < N; k++)
					{
						data[j][k] = s.charAt(k);
					}
				}

				double[] answer = solveOne(N, data);

				System.out.println("result:" + answer);

				out.write("Case #" + Integer.toString(i + 1) + ": ");
				out.newLine();
				
				for (int j = 0; j < N; j++)
				{
					out.write(Double.toString(answer[j]));
					out.newLine();
				}
						
				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}

	private double[] solveOne(int N, char[][] data)
	{
		double[] result = new double[N];
		
		for (int i = 0; i < N; i++)
		{
			double wp = calcWP(i, N, data);
			double owp = calcOWP(i, N, data);
			double oowp = calcOOWP(i, N, data);
			
			double rpi = 0.25 * wp + 0.50 * owp + 0.25 * oowp;
			
			result[i] = rpi;
		}

		return result;
	}

	private double calcWP(int t, int N, char[][] data)
	{
		double wins = 0;
		double total = 0;

		for (int i = 0; i < N; i++)
		{
			if (data[t][i] == '0' || data[t][i] == '1')
			{
				total++;
				if (data[t][i] == '1')
				{
					wins++;
				}
			}
		}
		
		if (total == 0)
		{
			return 1;
		}
		
		return wins / total;
	}

	private double calcWPspec(int t, int notCalc, int N, char[][] data)
	{
		double wins = 0;
		double total = 0;

		for (int i = 0; i < N; i++)
		{
			if (i != notCalc)
			{
				if (data[t][i] == '0' || data[t][i] == '1')
				{
					total++;
					if (data[t][i] == '1')
					{
						wins++;
					}
				}
			}
		}

		return wins / total;
	}

	private double calcOWP(int t, int N, char[][] data)
	{
		double totalWP = 0;
		double total = 0;
		
		for (int i = 0; i < N; i++)
		{
			if (data[t][i] == '0' || data[t][i] == '1')
			{
				totalWP += calcWPspec(i, t, N, data);
				total++;
			}
		}
		
		if (total == 0)
		{
			return 0;
		}
		
		return totalWP / total;
	}

	private double calcOOWP(int t, int N, char[][] data)
	{
		double totalOWP = 0;
		double total = 0;
		
		for (int i = 0; i < N; i++)
		{
			if (data[t][i] == '0' || data[t][i] == '1')
			{
				totalOWP += calcOWP(i, N, data);
				total++;
			}
		}
		
		if (total == 0)
		{
			return 0;
		}
		
		return totalOWP / total;
	}

}
