import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;


public class C_Theme_Park
{
	String inputFile = "C-small.in";
	String outputFile = "C-small.out";
	
//	String inputFile = "C-large.in";
//	String outputFile = "C-large.out";

	BufferedReader in = null;
	BufferedWriter out = null;

	public static void main(String[] args)
	{
		C_Theme_Park prog = new C_Theme_Park();
		
		prog.openFiles();
		prog.solution();
		prog.closeFiles();
		
		System.out.println("THE END");
	}

	public void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}	
	}

	public void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}
	
	public void solution()
	{
		try
		{
			String s = in.readLine();
		
			StringTokenizer st = new StringTokenizer(s);
		
			int T = Integer.parseInt(st.nextToken());
		
			System.out.println(T);
		
			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();
				
				st = new StringTokenizer(s);
				
				long R = Integer.parseInt(st.nextToken());
				long k = Integer.parseInt(st.nextToken());
				int N = Integer.parseInt(st.nextToken());

				System.out.println(i + 1 + ".");
//				System.out.println(s + " - " + R + " " + k + " " + N);
				
				s = in.readLine();
				
				st = new StringTokenizer(s);
				
				long[] g = new long[N];
				
//				System.out.print(s + " - ");
				
				for (int j = 0; j < N; j++)
				{
					g[j] = Integer.parseInt(st.nextToken());
					
//					System.out.print(g[j] + " ");
				}
				
//				System.out.println();

				long answer = solveOne(R, k, N, g);
				
				System.out.println("answer: " + answer);
				
				out.write("Case #" + Integer.toString(i+1) + ": " + Long.toString(answer));
				out.newLine();
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}

	private class Division
	{
		private int startIndex;
		private int endIndex;
		private long value;
		
		public Division(int startIndex, int endIndex, long value)
		{
			this.startIndex = startIndex;
			this.endIndex = endIndex;
			this.value = value;
		}
		
		public int getEndIndex()
		{
			return endIndex;
		}
		
		public long getValue()
		{
			return value;
		}
	}
	
	private long solveOne(long R, long k, int N, long[] g)
	{
		long answer = 0;
		
		Division[] div = new Division[N];
		
		for (int i = 0; i < N; i++)
		{
			long value = 0;
			
			int j = i;
			int endIndex = i;
			int startIndex = i;
			while (true)
			{
				if (value + g[j] <= k)
				{
					value += g[j];
					endIndex = j;
				}
				else
					break;
				
				if (j < N-1)
					j++;
				else
					j = 0;
				
				if (j == startIndex) // one person can sit just once on the rollercoaster in one round
					break;
			}
			
			div[i] = new Division(i, endIndex, value);
		}
		
//		System.out.print("div: ");
//		for (int i = 0; i < N; i++)
//			System.out.print(div[i].getValue() + "-" + div[i].getEndIndex() + " ");
//		System.out.println();
		
		int nextDiv = 0;
		
		for (int i = 0; i < R; i++)
		{
			answer += div[nextDiv].getValue();
			
			int endIndex = div[nextDiv].getEndIndex(); 
			
			if (endIndex == N-1)
				nextDiv = 0;
			else
				nextDiv = endIndex + 1; 
		}
		
		return answer;
	}
}

