package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;


public class ProblemC
{
	String inputFile = "C-small.in";
	String outputFile = "C-small.out";
	
//	String inputFile = "C-large.in";
//	String outputFile = "C-large.out";

	BufferedReader in = null;
	BufferedWriter out = null;

	public static void main(String[] args)
	{
		ProblemC prog = new ProblemC();
		
		prog.openFiles();
		prog.solution();
		prog.closeFiles();
		
		System.out.println("THE END");
	}

	private void openFiles()
	{
		// init input file
		try
		{
			in = new BufferedReader(new FileReader(inputFile));
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Input file not found!");
		}

		// init output file
		try
		{
			out = new BufferedWriter(new FileWriter(outputFile));
		}
		catch (IOException ex)
		{
			System.out.println("Error writing output file!");
		}	
	}

	private void closeFiles()
	{
		// close input file
		try
		{
			in.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing input!");
		}

		// close output file
		try
		{
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Error closing output!");
		}
	}
	
	private void solution()
	{
		try
		{
			String s = in.readLine();
		
			StringTokenizer st = new StringTokenizer(s);
		
			int T = Integer.parseInt(st.nextToken());
		
			System.out.println(T);
		
			// read and write data
			for (int i = 0; i < T; i++)
			{
				s = in.readLine();
				
				st = new StringTokenizer(s);
				
				int M = Integer.parseInt(st.nextToken());
				int N = Integer.parseInt(st.nextToken());
				
				System.out.println(i + 1 + ".");
				
				char[][] rows = new char[M][N];
				
				for (int j = 0; j < M; j++)
				{
					s = in.readLine();
					
					String r = "";
					for (int k = 0; k < s.length(); k++)
					{
						int number = Integer.parseInt(Character.toString(s.charAt(k)), 16);
						
						String temp = Integer.toBinaryString(number);
						
						while (temp.length() < 4)
							temp = "0" + temp;
						
						r = r + temp;
					}
					
					rows[j] = r.toCharArray();
				}
				
				long answer = solveOne(M, N, rows, i+1);
				
				System.out.println(answer);
				
			}
		}
		catch (IOException e)
		{
			System.out.println("Error reading!");
		}
	}
	
	private long solveOne(int M, int N, char[][] rows, int caseNr)
	{
		int typeNr = 0;
		
		int size = Math.min(M, N);
		
		int[] nr = new int[size + 1];
		
		while (size > 0)
		{
			int found = 0;
			
			for (int i = 0; i < M - size + 1; i++)
			{
				for (int j = 0; j < N - size + 1; j++)
				{
					if (isChessTable(i, j, size, rows))
					{
						found++;
						// remove that table
						for (int k = i; k < i + size; k++)
						{
							for (int l = j; l < j + size; l++)
							{
								rows[k][l] = 'X';
							}
						}
					}
				}
			}	
			
			nr[size] = found;
			if (found > 0)
				typeNr++;

			size--;
		}

		try
		{
			out.write("Case #" + Integer.toString(caseNr) + ": " + Long.toString(typeNr));
			out.newLine();

			for (int i = nr.length - 1; i > 0; i--)
			{
				if (nr[i] > 0)
				{
					out.write(Integer.toString(i) + " " + Integer.toString(nr[i]));
					out.newLine();
				}
			}
		}
		catch (IOException ex)
		{
			System.out.println("Error");
		}
		return typeNr;
	}
	
	private boolean isChessTable(int i, int j, int size, char[][] rows)
	{
		for (int k = i; k < i + size; k++)
			for (int l = j; l < j + size; l++)
				if (rows[k][l] == 'X')
					return false;
		
		for (int k = i; k < i + size; k++)
			for (int l = j; l < j + size - 1; l++)
				if (rows[k][l] == rows[k][l+1])
				{
					return false;
				}
		
		// check first column
		for (int k = i; k < i + size - 1; k++)
			if (rows[k][j] == rows[k+1][j])
				return false;
		
		return true;
	}
}
