package tw.cosecant.q;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashSet;

import com.sun.org.apache.bcel.internal.generic.NEW;

import sun.nio.cs.MS1250;

public class GCJ2014QC {

	/**
	 * @param args
	 * @throws IOException 
	 * @throws NumberFormatException 
	 */
	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream("C-small-attempt0.in")));
		int caseCount = Integer.parseInt(in.readLine());
		for (int i = 0 ; i < caseCount ;i ++){
			String[] vals = (in.readLine().split("\\s"));
			int row = Integer.parseInt(vals[0]);
			int col = Integer.parseInt(vals[1]);
			int mineCount = Integer.parseInt(vals[2]);
			MineField mf = solve(row, col, mineCount);
			System.out.println("Case #"+(i+1)+":");
			if (mf.isSolution()){
				mf.printField();	    		
			}else{
				System.out.println("Impossible");	
			}
		}

	}

	private static MineField solve(int row, int col, int mineCount) {
		MineField mf = new MineField(row, col, mineCount);
		while (!mf.isSolution()) {
			if (mf.solList.size() == 0 || mf.currMineCount < mf.targetMineCount) break;
			mf.calcSols();
			mf.click();
		}
		return mf;


	}

	public static class ClickPosition{
		public int x;
		public int y;
		public int diff;
		public ClickPosition(int x, int y) {
			this.x = x;
			this.y = y;
		}

		public void setDiff(int diff){
			this.diff = diff;
		}

		@Override
		public boolean equals(Object arg0) {
			if (arg0 instanceof ClickPosition){
				ClickPosition o2 = (ClickPosition) arg0;
				return o2.x == this.x && o2.y == this.y;
			}
			return false;
		}

		@Override
		public int hashCode() {
			return Integer.valueOf(x*50+y).hashCode();
		}

		public String toString() {
			return "" + diff;
		}
	}

	public static class MineField{
		public boolean[][] field;
		public int targetMineCount;
		public int currMineCount;
		public ArrayList<ClickPosition> solList = new ArrayList<ClickPosition>();

		public ClickPosition lastPosition;

		public MineField(int row, int col, int mineCount){
			field = new boolean[row][col];
			targetMineCount = mineCount;
			currMineCount = row * col - 1;

			solList.add(new ClickPosition(0, 0));
		}

		public void calcSols() {
			for(ClickPosition pos : solList){
				int d = getDiff(pos.x + 1 , pos.y) +
						getDiff(pos.x + 1 , pos.y + 1) +
						getDiff(pos.x + 1 , pos.y - 1) +
						getDiff(pos.x - 1 , pos.y + 1) +
						getDiff(pos.x , pos.y + 1);
				pos.setDiff(d);
			}			
			for (int i = solList.size() -1 ; i >= 0 ; i--){
				if (solList.get(i).diff == 0) solList.remove(i);
			}
			Collections.sort(solList, new Comparator<ClickPosition>() {

				@Override
				public int compare(ClickPosition o1, ClickPosition o2) {
					return o1.diff - o2.diff;
				}

			});
//			System.out.println(solList);
		}

		public void printField() {
			for (int i = 0; i < field.length; i++) {
				for (int j = 0; j < field[i].length; j++) {
					if (i == 0 && j == 0){ 
						System.out.print('c'); 
//					}else if(solList.contains(new ClickPosition(i, j))){
//						System.out.print('s');
					}else{					
						System.out.print(field[i][j] ? '.' : '*');
					}
				}
				System.out.println();
			}

		}

		public boolean isSolution() {
			return targetMineCount == currMineCount ;			
		}

		public void genSols(ClickPosition pos){
			if (check(pos.x+1, pos.y)){
				ClickPosition p1 = new ClickPosition(pos.x+1, pos.y);
				if (!solList.contains(p1))
					solList.add(p1);
			}
			if (check(pos.x, pos.y+1)){
				ClickPosition p1 = new ClickPosition(pos.x, pos.y+1);
				if (!solList.contains(p1))
					solList.add(p1);				
			}
		}

		public void click() {
//			this.printField();
			ClickPosition pos = null;
			
			for (ClickPosition tryPick : solList){
				if (tryPick.diff == currMineCount - targetMineCount){
					pos = tryPick;
					break;
				}
			}
			if (pos == null) pos = solList.get(0);
			solList.remove(pos);
			if (pos.diff == 0) return;
			reveal(pos.x + 1 , pos.y);
			reveal(pos.x + 1 , pos.y + 1);
			reveal(pos.x , pos.y + 1);
			reveal(pos.x - 1 , pos.y + 1);
			reveal(pos.x + 1 , pos.y - 1);
			
			genSols(pos);
		}

		private boolean check(int i, int j) {
			return i >= 0 && j >= 0 && i < field.length && j < field[0].length;
		}

		private int getDiff(int i, int j) {
			if (check(i,j)){
				return field[i][j] ? 0 : 1;
			}			
			return 0;
		}

		private void reveal(int i, int j) {
			if (check(i,j) && !field[i][j]){
				field[i][j] = true;
				currMineCount --;
			}						
		}
	}

}
