import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class MagicPrick
{
	static Console console;

	int oldBoard[][], newBoard[][];

	int oldSelectedRow, newSelectedRow;

	public MagicPrick() throws FileNotFoundException
	{
		console = initializeFileConsole("A-small-attempt0.in", "A-small-attempt0.out");
	}

	public static void main(String[] args) throws Exception
	{
		MagicPrick solver = new MagicPrick();
		int numberOfTests = console.nextInt();

		for (int currentTest = 1; currentTest <= numberOfTests; currentTest++)
		{
			solver.readTest();
			solver.solveTest(currentTest);
		}

		console.close();
	}

	private void solveTest(int testIndex)
	{
		int intersection[] = new int[4];
		int intersectionSize = 0;

		for (int column = 0; column < 4; column++)
		{
			for (int newColumn = 0; newColumn < 4; newColumn++)
				if (newBoard[newSelectedRow][newColumn] == oldBoard[oldSelectedRow][column])
				{
					intersection[intersectionSize] = oldBoard[oldSelectedRow][column];
					intersectionSize++;
					break;
				}
		}

		String answer = null;

		if (intersectionSize == 1)
		{
			answer = String.valueOf(intersection[0]);
		}
		if (intersectionSize > 1)
		{
			answer = "Bad magician!";
		}
		if (intersectionSize < 1)
		{
			answer = "Volunteer cheated!";
		}

		console.write(String.format("Case #%d: %s\r\n", testIndex, answer));
	}

	private void readTest() throws Exception
	{
		oldBoard = new int[4][];
		newBoard = new int[4][];

		for (int i = 0; i < 4; i++)
		{
			oldBoard[i] = new int[4];
			newBoard[i] = new int[4];
		}

		// Read first position
		oldSelectedRow = console.nextInt() - 1;
		for (int i = 0; i < 4; i++)
			for (int j = 0; j < 4; j++)
				oldBoard[i][j] = console.nextInt();

		// Read second position
		newSelectedRow = console.nextInt() - 1;
		for (int i = 0; i < 4; i++)
			for (int j = 0; j < 4; j++)
				newBoard[i][j] = console.nextInt();
	}

	private static Console initializeFileConsole(String inputFileName, String outputFileName)
			throws FileNotFoundException
	{
		FileInputStream fileInputStream = new FileInputStream(new File(inputFileName));
		FileOutputStream fileOutputStream = new FileOutputStream(new File(outputFileName));

		return new Console(fileInputStream, fileOutputStream);
	}

	private static Console initializeConsole()
	{
		return new Console(System.in, System.out);
	}

	static class Console
	{
		BufferedReader in;

		PrintWriter out;

		StringTokenizer line;

		public Console(InputStream in, OutputStream out)
		{
			this.in = new BufferedReader(new InputStreamReader(in));
			this.out = new PrintWriter(out);
		}

		public void close()
		{
			try
			{
				in.close();
				out.flush();
				out.close();
			}
			catch (IOException e)
			{
			}
		}

		public void write(String message)
		{
			out.write(message);
		}

		public String next() throws IOException
		{
			while ((line == null) || !line.hasMoreTokens())
			{
				line = new StringTokenizer(in.readLine());
			}
			return line.nextToken();
		}

		public int nextInt() throws Exception
		{
			return Integer.parseInt(next());
		}
	}
}
