package task1;
import java.io.IOException;
import java.util.LinkedList;
import java.util.Queue;

import org.apache.commons.lang3.Pair;
import org.apache.commons.math.util.MathUtils;

import base.Main;


public class Task1 extends Main<Task1> {
	
	Queue<Pair<String, Integer>> sequence = new LinkedList<Pair<String,Integer>>();
	Queue<Integer> oSequence = new LinkedList<Integer>();
	Queue<Integer> bSequence = new LinkedList<Integer>();
	
	private int oPos = 1;
	private int bPos = 1;
	
	private final static String ORANGE = "O";
	private final static String BLUE = "B";
	
	private int time = 0;
	
	public Task1(int testCaseNum) throws IOException {
		this.testCaseNum = testCaseNum;
	}

	@Override
	protected Task1 calculate() {
		
		while(!sequence.isEmpty())
		{
			// nth step is coming;
			act();
			time++;
		}
		return this;
	}
	
	private int needToMove(boolean orange)
	{
		Queue<Integer> seq = null;
		int pos = 0;
		if(orange)
		{	
			seq = oSequence;
			pos = oPos;
		}
		else
		{
			seq = bSequence;
			pos = bPos;
		}

		// Nothing to do
		if(seq.isEmpty())
		{
			return 0;
		}
		else
		{
			return MathUtils.sign(seq.peek()-pos);
		}
	}
	
	private void localAct(boolean orange, int needToMove, boolean top, Queue<Integer> seq)
	{
		if(needToMove == 0)
		{
			if(top)
			{
				sequence.poll();
				seq.poll();
			}
			else
			{
				// doNothing
			}
		}
		else
		{
			if(orange)
			{
				oPos += needToMove;	
			}
			else
			{
				bPos += needToMove;
			}
		}
	}
	
	private void act(){
		int oNeedToMove = needToMove(true);
		boolean oTop = ORANGE.equals(sequence.peek().left);
		int bNeedToMove = needToMove(false);
		boolean bTop = BLUE.equals(sequence.peek().left);
		
		localAct(true, oNeedToMove, oTop, oSequence);
		localAct(false, bNeedToMove, bTop, bSequence);
	}
	
	@Override
	protected Task1 in() {
		int numButtons = inputScanner.nextInt();
		for(int index = 0; index < numButtons; index++)
		{
			String robot = inputScanner.next();
			Integer button = inputScanner.nextInt();
			if(ORANGE.equals(robot.trim()))
			{
				oSequence.offer(button);
			}
			else if(BLUE.equals(robot.trim()))
			{
				bSequence.offer(button);
			}
			else
				throw new IllegalArgumentException("Robot is illegal: "+robot);
			
			sequence.offer(new Pair<String, Integer>(robot.trim(), button));
		}
		
		return this;
	}

	@Override
	protected void out() {
		try {
			outputWriter.append("Case #"+testCaseNum+": "+time+"\n");
		} catch(IOException e)
		{
			throw new IllegalStateException();
		}
	}
}
