package base;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public abstract class Main<T extends Main<?>> {

	
	protected Scanner inputScanner;
	protected FileWriter outputWriter;

	protected int testCaseNum;
	
	protected abstract T calculate();
	protected abstract T in() throws IOException;
	protected abstract void out() throws IOException;
	
	public Main(int testCaseNum) {
		this.testCaseNum = testCaseNum;
	}
	
	public void run()
	{
		try{
			in().calculate().out();
		} catch (IOException e)
		{
			throw new IllegalStateException(e);
		}
	}
	public Scanner getInputScanner() {
		return inputScanner;
	}
	public Main<T> setInputScanner(Scanner inputScanner) {
		this.inputScanner = inputScanner;
		return this;
	}
	public FileWriter getOutputWriter() {
		return outputWriter;
	}
	public Main<T> setOutputWriter(FileWriter outputWriter) {
		this.outputWriter = outputWriter;
		return this;
	}
}
