import java.io.BufferedReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;


public class Quaternions {
	public static void main(String[] args) {
		try
		{
			BufferedReader f = new BufferedReader(new InputStreamReader(System.in));
			int t = Integer.parseInt(f.readLine());
			FileWriter fout = new FileWriter("quaternions.out");
			int[][] table = {
					{1, 2, 3, 4},
					{2, -1, 4, -3},
					{3, -4, -1, 2},
					{4, 3, -2, -1}
			};
			for(int i = 1; i <= t; i++)
			{
				StringTokenizer st = new StringTokenizer(f.readLine());
				int l = Integer.parseInt(st.nextToken());
				int x = Integer.parseInt(st.nextToken());
				String s = f.readLine();
				int[] s1 = new int[l];
				for(int j = 0; j < l; j++)
				{
					char c = s.charAt(j);
					if(c == 'i')
						s1[j] = 2;
					else if(c == 'j')
						s1[j] = 3;
					else
						s1[j] = 4;		
				}
				int[] result = new int[4];
				int a = s1[0];
				int numNegatives = 0;
				for(int j = 1; j < l; j++)
				{
					a = table[a-1][s1[j]-1];
					if(a < 0)
					{
						numNegatives++;
						a = -1*a;
					}
				}
				if(numNegatives%2 == 1)
					a = -1*a;
				result[0] = 1;
				result[1] = a;
				if(a == 1)
				{
					result[2] = 1;
					result[3] = 1;
				}
				else if(a == -1)
				{
					result[2] = 1;
					result[3] = -1;
				}
				else
				{
					result[2] = -1;
					result[3] = -1*a;
				}
				if(result[x%4] != -1)
				{
					System.out.println("Case #" + i + ": NO\n");
					fout.write("Case #" + i + ": NO\n");
					continue;
				}
				System.out.println(Arrays.toString(result));
				int[][] numNeededForI = new int[4][2];
				for(int j = 0; j < 4; j++)
				{
					if(result[j] == 1)
						numNeededForI[j][0] = 2;
					else if(result[j] == 2)
						numNeededForI[j][0] = 1;
					else if(result[j] == 3)
						numNeededForI[j][0] = 4;
					else if(result[j] == 4)
						numNeededForI[j][0] = -3;
					else if(result[j] == -1)
						numNeededForI[j][0] = -2;
					else if(result[j] == -2)
						numNeededForI[j][0] = -1;
					else if(result[j] == -3)
						numNeededForI[j][0] = -4;
					else if(result[j] == -4)
						numNeededForI[j][0] = 3;
				}
				for(int j = 0; j < 4; j++)
				{
					if(s1[0] == numNeededForI[j][0])
						numNeededForI[j][1] = 1;
					else
					{
						int b = s1[0];
						for(int k = 1; k < l; k++)
						{
							boolean isNegative = false;
							if(b < 0)
							{
								isNegative = true;
								b = -1*b;
							}
							b = table[b-1][s1[k]-1];
							if(isNegative)
								b = -1*b;
							if(b == numNeededForI[j][0])
							{
								numNeededForI[j][1] = k+1;
								break;
							}
						}
					}
				}
				//for(int j = 0; j < 4; j++)
				//{
				//	System.out.println(numNeededForI[j][0] + " " + numNeededForI[j][1]);
				//}
				int[][] numNeededForK = new int[4][2];
				for(int j = 0; j < 4; j++)
				{
					if(result[j] == 1)
						numNeededForK[j][0] = 4;
					else if(result[j] == 2)
						numNeededForK[j][0] = -3;
					else if(result[j] == 3)
						numNeededForK[j][0] = 2;
					else if(result[j] == 4)
						numNeededForK[j][0] = 1;
					else if(result[j] == -1)
						numNeededForK[j][0] = -4;
					else if(result[j] == -2)
						numNeededForK[j][0] = 3;
					else if(result[j] == -3)
						numNeededForK[j][0] = -2;
					else if(result[j] == -4)
						numNeededForK[j][0] = -1;
				}
				for(int j = 0; j < 4; j++)
				{
					if(s1[l-1] == numNeededForK[j][0])
						numNeededForK[j][1] = l;
					else
					{
						int b = s1[0];
						for(int k = l-2; k >= 0; k--)
						{
							boolean isNegative = false;
							if(b < 0)
							{
								isNegative = true;
								b = -1*b;
							}
							b = table[s1[k]-1][b-1];
							if(isNegative)
								b = -1*b;
							if(b == numNeededForK[j][0])
							{
								numNeededForK[j][1] = k+1;
								break;
							}
						}
					}
				}
				//for(int j = 0; j < 4; j++)
				//{
				//	System.out.println(numNeededForK[j][0] + " " + numNeededForK[j][1]);
				//}
				boolean found = false;
				for(int j = 0; j < 4; j++)
				{
					if(numNeededForK[j][1] == 0)
						continue;
					for(int k = 0; k < 4; k++)
					{
						if(found)
							break;
						if(numNeededForI[k][1] == 0)
							continue;
						if(numNeededForK[j][1] - numNeededForI[k][1] > 1)
						{
							if(j + k + 1 <= x)
								found = true;
						}
						else
						{
							if(j + k + 2 <= x)
								found = true;
						}
					}
				}
				if(found)
				{
					System.out.println("Case #" + i + ": YES\n");
					fout.write("Case #" + i + ": YES\n");
				}
				else
				{
					System.out.println("Case #" + i + ": NO\n");
					fout.write("Case #" + i + ": NO\n");
				}
			}
			f.close();
			fout.close();
		}
		catch(IOException e)
		{
			System.out.println(e);
		}
	}

}
