import java.io.BufferedReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class PlayTheDragon {
	private static final int INF = (int) Math.pow(10, 9);
	public static int[][][][] steps;
	public static boolean[][][][] visited;
	public static int recurse(int hd, int ad, int hk, int ak, int buf, int deb, int max) {
		//System.out.println(hd + " " + ad + " " + hk + " " + ak);
		if(hk <= 0) {
			return 0;
		} else if(hd <= 0) {
			return INF;
		} else if(ad >= hk) {
			return 1;
		} else if(visited[hd][ad][hk][ak]) {
			return INF;
		} else if(steps[hd][ad][hk][ak] != -1) {
			return steps[hd][ad][hk][ak];
		}
		visited[hd][ad][hk][ak] = true;
		int debAk = Math.max(0, ak - deb);
		int a = recurse(   hd - ak, 	   ad, hk - ad,    ak, buf, deb, max);
		int b = recurse(   hd - ak,  ad + buf,      hk,    ak, buf, deb, max);
		int c = recurse(  max - ak,        ad,      hk,    ak, buf, deb, max);
		int d = recurse(hd - debAk,        ad,      hk, debAk, buf, deb, max);
		visited[hd][ad][hk][ak] = false;
		int answer = Math.min(a, Math.min(b, Math.min(c, d))) + 1;
		steps[hd][ad][hk][ak] = answer;
		return answer;
	}
	public static void main(String[] args) throws IOException {
		BufferedReader f = new BufferedReader(new InputStreamReader(System.in));
		int t = Integer.parseInt(f.readLine());
		FileWriter fout = new FileWriter("playthedragon.out");
		for(int num = 1; num <= t; num++)
		{
			StringTokenizer st = new StringTokenizer(f.readLine());
			int hd = Integer.parseInt(st.nextToken());
			int ad = Integer.parseInt(st.nextToken());
			int hk = Integer.parseInt(st.nextToken());
			int ak = Integer.parseInt(st.nextToken());
			int b = Integer.parseInt(st.nextToken());
			int d = Integer.parseInt(st.nextToken());
			steps = new int[hd + 1][hk + 1][hk + 1][ak + 1];
			for(int i1 = 0; i1 <= hd; i1++) {
				for(int i2 = 0; i2 <= hk; i2++) {
					for(int i3 = 0; i3 <= hk; i3++) {
						for(int i4 = 0; i4 <= ak; i4++) {
							steps[i1][i2][i3][i4] = -1;
						}
					}
				}
			}
			visited = new boolean[hd + 1][hk + 1][hk + 1][ak + 1];
			int ans = recurse(hd, ad, hk, ak, b, d, hd);
			String output = ans + "";
			if(ans >= INF) {
				output = "IMPOSSIBLE";
			}
			System.out.println("Case #" + num + ": " + output);
			fout.write("Case #" + num + ": " + output + "\n");
		}
		f.close();
		fout.close();
	}
}
