import java.io.BufferedReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Ratatouille {
	public static boolean satisfiesUpperBound(int num, double req, double pack) {
		return (pack <= 1.1*num*req);
	}
	public static boolean satisfiesLowerBound(int num, double req, double pack) {
		return (pack >= 0.9*num*req);
	}
	public static void main(String[] args) throws IOException {
		BufferedReader f = new BufferedReader(new InputStreamReader(System.in));
		int t = Integer.parseInt(f.readLine());
		FileWriter fout = new FileWriter("ratatouille.out");
		for(int num = 1; num <= t; num++)
		{
			int maxServings = (int) Math.pow(10, 6);
			StringTokenizer st = new StringTokenizer(f.readLine());
			int n = Integer.parseInt(st.nextToken());
			int p = Integer.parseInt(st.nextToken());
			double[] reqs = new double[n];
			st = new StringTokenizer(f.readLine());
			for(int i = 0; i < n; i++) {
				reqs[i] = Double.parseDouble(st.nextToken());
			}
			double[][] packs = new double[n][p];
			for(int i = 0; i < n; i++) {
				st = new StringTokenizer(f.readLine());
				for(int j = 0; j < p; j++) {
					packs[i][j] = Double.parseDouble(st.nextToken());
				}
				Arrays.sort(packs[i]);
			}
			int numKits = 0;
			int[][] pointers = new int[n][2];
			boolean done = false;
			for(int i = 1; i <= maxServings; i++) {
				int minSize = Integer.MAX_VALUE;
				for(int j = 0; j < n; j++) {
					int head = pointers[j][0];
					int tail = pointers[j][1];
					while(tail < p && satisfiesUpperBound(i, reqs[j], packs[j][tail])) {
						tail++;
					}
					//System.out.println(head);
					while(head < tail && !satisfiesLowerBound(i, reqs[j], packs[j][head])) {
						head++;
					}
					pointers[j][0] = head;
					pointers[j][1] = tail;
					minSize = Math.min(minSize, tail - head);
					if(head == tail && tail == p) {
						done = true;
					}
				}
				numKits += minSize;
				for(int j = 0; j < n; j++) {
					pointers[j][0] += minSize;
				}
				if(done)
					break;
			}
			System.out.println("Case #" + num + ": " + numKits);
			fout.write("Case #" + num + ": " + numKits + "\n");
		}
		f.close();
		fout.close();
	}
}
