package com.nolmecolindor.gcj2011.round2;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Scanner;

class Problem_B {

	int maxX;
	int maxY;
	int expectedM;
	
	int[][] cell;
	
//	void dump() {
//		for (int y = 0; y < maxY; y++) {
//			for (int x = 0; x < maxX; x++) System.out.print(" " + cell[x][y]);
//			System.out.println();
//		}
//	}

	boolean solved;
	int size;
	int currentX;
	int currentY;
	
	long sumX;
	long sumY;
	long sumW;
	
	void check() {
		long expectedSumX = sumW * (2 * currentX + size - 1);
		long expectedSumY = sumW * (2 * currentY + size - 1);
		solved = 
			(sumX == expectedSumX) 
			&& (sumY == expectedSumY)
		;
//		System.out.println("Tried size " + size + " at (" + currentX + ", " + currentY + "). " + solved);
//		System.out.println("Expected: (" + expectedSumX + ", " + expectedSumY + "); got: (" + sumX + ", " + sumY + ").");
	}
	
	void restart(final int startX, final int startY) {
		currentX = startX;
		currentY = startY;
		sumX = 0;
		sumY = 0;
		sumW = 0;
		int w;
		for (int x = currentX; x < currentX + size; x++) {
			for (int y = currentY; y < currentY + size; y++) {
				if (
						((x == currentX) && (y == currentY))
						|| ((x == currentX + size - 1) && (y == currentY))
						|| ((x == currentX) && (y == currentY + size - 1))
						|| ((x == currentX + size - 1) && (y == currentY + size - 1))
				) {
					w = - expectedM;
				} else { 
					w = cell[x][y];
				}
				sumX += w * x * 2;
				sumY += w * y * 2;
				sumW += w;
			}
		}
		
		
		check();
	}
	
	void moveDown() {
		// TODO
		currentY++;
		check();
	}
	
	void moveRight() {
		// TODO
		currentX++;
		check();
	}

	void moveUp() {
		// TODO-
		currentY--;
		check();
	}

	boolean canDo(int testSize) {
		solved = false;
		size = testSize;
//		restart(0, 0);
//		while (!solved) {
//			while (!solved && (currentY + testSize < maxY)) moveDown();
//			if (solved || (currentX + testSize == maxX)) break;
//			moveRight();
//			while (!solved && (currentY > 0)) moveUp();
//			if (solved || (currentX + testSize == maxX)) break;
//			moveRight();
//		}
		
		for (int x = 0; x + size <= maxX; x++) {
			for (int y = 0; y + size <= maxY; y++) {
				restart(x, y);
				if (solved) return true;
			}
		}
		
		return solved;
	}
	
	String solve(final Scanner input) {
		maxY = input.nextInt();
		maxX = input.nextInt();
		expectedM = input.nextInt();
		String row;
		
		cell = new int[maxX][];
		for (int x = 0; x < maxX; x++) cell[x] = new int[maxY];

		for (int y = 0; y < maxY; y++) {
			row = input.next();
			for (int x = 0; x < maxX; x++) {
				cell[x][y] = Integer.parseInt(row.substring(x, x+1)); // + expectedM;
			}
		}
		
		for (int size = Math.min(maxX, maxY); size >= 3; size --) if (canDo(size)) return Integer.toString(size);
		return "IMPOSSIBLE";
	}
	
	void solveAll(final Scanner input) throws NumberFormatException, IOException {
		final int cases = input.nextInt();
		for (int caseNum = 1; caseNum <= cases; caseNum++) {
			System.out.println("Case #" + caseNum + ": " + solve(input));
		}
	}
	
	public static void main(final String[] args) {
		try {
			final Scanner input = new Scanner(((args.length == 2) && args[0].equals("--input")) ? new FileInputStream(args[1]) : System.in);
			new Problem_B().solveAll(input);
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
