package com.nolmecolindor.gcj2011;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Scanner;

public class Problem_A_0 {

	private static class Task {
		public final int who;
		public final int where;
		public int minFinishTime;
		public boolean known;
		public Task myNextTask;
		public Task nextTask;
		
		public Task(final int who, final int where) {
			this.who = who;
			this.where = where;
		}

		public void cantFinishBefore(final int time) {
			if (known) return;
			if (time > minFinishTime) minFinishTime = time;
		}
	}
	
	private final static int ORANGE = 0;
	private final static int BLUE = 1;
	
//	private final static String[] names = new String[] { "Orange", "Blue" };
	
	private final static int MIN_ROBOTS = ORANGE;
	private final static int MAX_ROBOTS = BLUE;
	
	private Task[] firstTask = new Task[MAX_ROBOTS + 1];
	private Task[] lastTask = new Task[MAX_ROBOTS + 1];
	private Task totalFirstTask;
	private Task totalLastTask;

	private int solve(final Scanner input) {
		int robot;
		// Prepare initial states
		for (robot = MIN_ROBOTS; robot <= MAX_ROBOTS; robot++) {
			firstTask[robot] = new Task(robot, 1) {{
				minFinishTime = 0;
				known = true;
			}};
			lastTask[robot] = firstTask[robot];
			if (robot == MIN_ROBOTS) {
				totalFirstTask = firstTask[robot];
			} else {
				totalLastTask.nextTask = firstTask[robot];
			}
			totalLastTask = lastTask[robot];

		}
		
		// Read tasks
		final int steps = input.nextInt();
		String robotName;
		Task newTask;
		for (int step = 1; step <= steps; step++) {
			robotName = input.next();
			robot = robotName.equals("B") ? BLUE : ORANGE;
			newTask = new Task(robot, input.nextInt());
//			System.out.println("Found new task: " + names[newTask.who] + "('"+robotName+"') @ " + newTask.where);
			lastTask[robot].myNextTask = newTask;
			lastTask[robot] = newTask;
			totalLastTask.nextTask = newTask;
			totalLastTask = newTask;
		}
		
		// Add finishing state
		newTask = new Task(-1, 0);
		totalLastTask.nextTask = newTask;
		totalLastTask = newTask;
		
		// Do the calculation
		
		Task myNextTask;
		for (Task currentTask = totalFirstTask; currentTask != totalLastTask; currentTask = currentTask.nextTask) {
//			System.out.println("Time: " + currentTask.minFinishTime + "; who: " + names[currentTask.who] + "; where: " + currentTask.where);
			myNextTask = currentTask.myNextTask; 
			if (myNextTask != null) {	// Update my next task
				myNextTask.cantFinishBefore(currentTask.minFinishTime + Math.abs(currentTask.where - myNextTask.where) + 1);
			}
			if (currentTask.nextTask.who != currentTask.who) { // Update global next task
				currentTask.nextTask.cantFinishBefore(currentTask.minFinishTime + 1);
			}
		}
		
		return totalLastTask.minFinishTime - 1;
	}
	
	
	private void solveAll(final Scanner input) throws NumberFormatException, IOException {
		final int cases = input.nextInt();
		for (int caseNum = 1; caseNum <= cases; caseNum++) {
			System.out.println("Case #" + caseNum + ": " + solve(input));
		}
	}
	
	public static void main(final String[] args) {
		try {
			final Scanner input = new Scanner(((args.length == 2) && args[0].equals("--input")) ? new FileInputStream(args[1]) : System.in);
			new Problem_A_0().solveAll(input);
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
