package com.nolmecolindor.gcj2011.round2;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Scanner;
import java.util.TreeMap;

class Problem_A {

	final Map<Integer, Integer> speedPath = new TreeMap<Integer, Integer>();
	
	String solve(final Scanner input) {
		speedPath.clear();
		int totalLength = input.nextInt();
		double walkingSpeed = input.nextInt();
		double runningSpeed = input.nextInt();
		double runTime = input.nextInt();
		int walkways = input.nextInt();
		int plainLength = totalLength;
		int start;
		int end;
		int length;
		int speed;
		Integer existing;
		
		for (int i = 0; i < walkways; i++) {
			start = input.nextInt();
			end = input.nextInt();
			speed = input.nextInt();
			length = end - start;
			existing = speedPath.get(speed);
			speedPath.put(speed, (existing == null) ? length : (existing + length));
			plainLength -= length;
		}
		
		if (plainLength > 0) speedPath.put(0, plainLength);
		
		double time = 0;
		double possibleLength;
		double actualLength;
		double remainingLength;
		double usedTime;
		
		for (Entry<Integer, Integer> e: speedPath.entrySet()) {
			speed = e.getKey();
			length = e.getValue();
//			System.out.println("Speed: " + speed + "; length: " + length);
			if (runTime > 0) {
				possibleLength = (speed + runningSpeed) * runTime;
				actualLength = (possibleLength > length) ? length : possibleLength;
				usedTime = actualLength / (speed + runningSpeed);
				runTime -= usedTime;
//				System.out.println("Running for " + actualLength + "m, " + usedTime + " secs.");
				remainingLength = length - actualLength;
				time += usedTime + remainingLength / (speed + walkingSpeed);
			} else {
				time += (double)length / (speed + walkingSpeed);
			}
//			System.out.println("Time is now " + time);
			
		}
		return Double.toString(time);
	}

	
	void solveAll(final Scanner input) throws NumberFormatException, IOException {
		final int cases = input.nextInt();
		for (int caseNum = 1; caseNum <= cases; caseNum++) {
			System.out.println("Case #" + caseNum + ": " + solve(input));
		}
	}
	
	public static void main(final String[] args) {
		try {
			final Scanner input = new Scanner(((args.length == 2) && args[0].equals("--input")) ? new FileInputStream(args[1]) : System.in);
			new Problem_A().solveAll(input);
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
