package chandra.google.codejam.bff;



import java.io.IOException;
import java.net.URISyntaxException;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import chandra.google.codejam.utils.InputReader;
import chandra.google.codejam.utils.OutputWriter;

public class BFF {
	
	private static final String OUPUT_FILE_NAME = "outputfile_bff_small";
	private static final String LINE_SEPARATOR = "line.separator";
	//public static String INPUT_FILE = "A-small-practice.in";
	public static final String INPUT_FILE_NAME = "inputfile_bff";
	
	
	
	public static void main(String[] args) {
		InputReader inputReader = new InputReader(INPUT_FILE_NAME);
	    
	    List<String> lines=null;
		try {
			lines = inputReader.getFileLines();
		} catch (IOException e) {
			e.printStackTrace();
			return;
		} catch (URISyntaxException e) {
			e.printStackTrace();
			return;
		}
	  		
		BFF bff = new BFF();
		try {
			bff.solve(lines);
		} catch (ParseException e) {
			e.printStackTrace();
			StringBuffer stringBuffer = new StringBuffer("Invalid Input");
			stringBuffer.append(System.getProperty(LINE_SEPARATOR));
			stringBuffer.append(e.getMessage());
			OutputWriter.create(OUPUT_FILE_NAME,stringBuffer);
		}

	}
	
	private void solve(List<String> lines) throws ParseException {
		StringBuffer buffer = new StringBuffer();
		
		int numberOfTestCases =  Integer.parseInt(lines.get(0));
		
		//validate input
//		if(numberOfTestCases != (2*lines.size()-1)){
//			throw new ParseException("Invalid no of cases -"+numberOfTestCases,numberOfTestCases);
//		}		
		
		for(int i=0;i<numberOfTestCases;i++){
			
			int N = Integer.parseInt(lines.get(2*i+1));
			String bffs = lines.get(2*i+2);
			
			buffer.append(solveEachCase(i,N, bffs));
			
			buffer.append(System.getProperty(LINE_SEPARATOR));
		}
		
		OutputWriter.create(OUPUT_FILE_NAME, buffer);
	}
	
	private String solveEachCase(int caseNo,int N, String bffs) {
		Map<Integer, List<Integer>> bffMap = new HashMap<Integer, List<Integer>> ();
		Integer [] included = new Integer[N];
		Boolean [] present = new Boolean[N];
		Map<Integer, Integer> hisBFF = new HashMap<Integer,Integer>();
		for(int i=0; i<N; i++) {
			included[i]=-1;
			present[i]= false;
		}
		
		String [] inputBffs = bffs.split(" ");
		for(int i=0; i<inputBffs.length; i++) {
			hisBFF.put(new Integer(i), Integer.parseInt(inputBffs[i]));
			List<Integer> myBff = new ArrayList<Integer>();
			Integer key = Integer.parseInt(inputBffs[i]);
			List<Integer> value = bffMap.get(key-1);
			if(value == null) {
				myBff.add(i);
				bffMap.put(key-1, myBff);
			}
			else {
				value.add(i);
				bffMap.put(key-1, value);
			}			
		}
		for(Integer key : bffMap.keySet()) {
			if(bffMap.get(key).size() >= 2) {
				present[key] = true;
			}
		}
		int totalCount = 0;
		boolean markEveryone = true;
		for(int i=0; i < present.length; i++) {
			if(present[i]) {
				markEveryone = false;
				List<Integer> temp = bffMap.get(i);
				for(Integer temp1:temp) {
					included[i] = i;
					if(i==0) {
						included[N-1] = N-1;
						included[1] = 1;
					}
					else if(i==(N-1)) {
						included[N-2] = N-2;
						included[0] = 0;
					}
					else {
							included[i-1] = i-1;
							included[i+1] = i+1;
					}
					
				}
			}
		}
		if(markEveryone) {
			totalCount = N;
		}
		else {
			
			if(included[0] >= 0) {
				totalCount++;
			}
			else if(included[N-1] >= 0) {
				totalCount++;
			}
			
			for(int i=1; i < N-1 ; i++) {
				if(included[i] >= 0) {
					totalCount++;
				}
				else {
					int bff = hisBFF.get(i);
					int prev, next;
					if(bff==0) {
						prev = N-1;
						next = 1;
					}
					else if(bff==(N-1)) {
						prev = N-2;
						next = 0;
					}
					else {
						prev = i-1;
						next = i+1;
					}
					if(included[prev] == -1) {
						included[prev] = i;
						totalCount++;
					}
					else if(included[next] == -1) {
						included[next] = i;
						totalCount++;
					}
				}
			}
		}
		
		
		return "Case #"+(caseNo+1)+": "+totalCount;
	}
}


