package chandra.google.codejam.lastword;



import java.io.IOException;
import java.math.BigInteger;
import java.net.URISyntaxException;
import java.text.ParseException;
import java.util.LinkedList;
import java.util.List;

import chandra.google.codejam.utils.InputReader;
import chandra.google.codejam.utils.OutputWriter;

public class LastWord {
	
	private static final String OUPUT_FILE_NAME = "outputfile_lastword_small";
	private static final String LINE_SEPARATOR = "line.separator";
	//public static String INPUT_FILE = "A-small-practice.in";
	public static final String INPUT_FILE_NAME = "inputfile_lastword";
	
	
	
	public static void main(String[] args) {
		InputReader inputReader = new InputReader(INPUT_FILE_NAME);
	    
	    List<String> lines=null;
		try {
			lines = inputReader.getFileLines();
		} catch (IOException e) {
			e.printStackTrace();
			return;
		} catch (URISyntaxException e) {
			e.printStackTrace();
			return;
		}
	  		
		LastWord coinJam = new LastWord();
		try {
			coinJam.solve(lines);
		} catch (ParseException e) {
			e.printStackTrace();
			StringBuffer stringBuffer = new StringBuffer("Invalid Input");
			stringBuffer.append(System.getProperty(LINE_SEPARATOR));
			stringBuffer.append(e.getMessage());
			OutputWriter.create(OUPUT_FILE_NAME,stringBuffer);
		}

	}
	
	private void solve(List<String> lines) throws ParseException {
		StringBuffer buffer = new StringBuffer();
		
		int numberOfTestCases =  Integer.parseInt(lines.get(0));
		
		//validate input
		if(numberOfTestCases != (lines.size()-1)){
			throw new ParseException("Invalid no of cases -"+numberOfTestCases,numberOfTestCases);
		}		
		
		for(int i=0;i<numberOfTestCases;i++){
			
			String input = lines.get(i+1);	
			
			buffer.append(solveEachCase(i+1,input));
			
			buffer.append(System.getProperty(LINE_SEPARATOR));
		}
		
		OutputWriter.create(OUPUT_FILE_NAME, buffer);
	}
	
	private String solveEachCase(int caseNo, String input) {
		String finalResult = null;
		StringBuilder output = new StringBuilder();
		LinkedList<Character> out = new LinkedList<>();
		out.addFirst(input.charAt(0));
		for(int i=1; i<input.length();i++) {
			Character curr = input.charAt(i);
			if(out.size() == 1) {
				if(out.getFirst().charValue() <= curr.charValue()) {
					out.addFirst(curr);
				}
				else {
					out.addLast(curr);
				}
			}
			else {
				if(out.getFirst().charValue() <= curr.charValue()) {
					out.addFirst(curr);
				}
				else {
					out.addLast(curr);
				}
			}
		}
		for(int i=0; i<input.length();i++) {
			output.append(out.get(i));
		}
		
		return "Case #"+caseNo+": "+output.toString();
	}
}


