package chandra.google.codejam.fractiles;


import java.io.IOException;
import java.net.URISyntaxException;
import java.text.ParseException;
import java.util.List;

import chandra.google.codejam.utils.InputReader;
import chandra.google.codejam.utils.OutputWriter;

public class Fractiles {
	
	private static final String OUPUT_FILE_NAME = "outputfile_fractiles_small";
	private static final String LINE_SEPARATOR = "line.separator";
	//public static String INPUT_FILE = "A-small-practice.in";
	public static final String INPUT_FILE_NAME = "inputfile_fractiles";
	
	
	public static void main(String[] args) {
		InputReader inputReader = new InputReader(INPUT_FILE_NAME);
	    
	    List<String> lines=null;
		try {
			lines = inputReader.getFileLines();
		} catch (IOException e) {
			e.printStackTrace();
			return;
		} catch (URISyntaxException e) {
			e.printStackTrace();
			return;
		}
	  		
		Fractiles fractiles = new Fractiles();
		try {
			fractiles.solve(lines);
		} catch (ParseException e) {
			e.printStackTrace();
			StringBuffer stringBuffer = new StringBuffer("Invalid Input");
			stringBuffer.append(System.getProperty(LINE_SEPARATOR));
			stringBuffer.append(e.getMessage());
			OutputWriter.create(OUPUT_FILE_NAME,stringBuffer);
		}

	}
	
	private void solve(List<String> lines) throws ParseException {
		StringBuffer buffer = new StringBuffer();
		
		int numberOfTestCases =  Integer.parseInt(lines.get(0));
		
		//validate input
		if(numberOfTestCases != (lines.size()-1)){
			throw new ParseException("Invalid no of cases -"+numberOfTestCases,numberOfTestCases);
		}
		
		for(int i=0;i<numberOfTestCases;i++){
			
			String inputStack = lines.get(i+1);		
			
			String [] inputs = inputStack.split(" ");
			
			int K = Integer.parseInt(inputs[0]);
			int C = Integer.parseInt(inputs[1]);
			int S = Integer.parseInt(inputs[2]);
			
			buffer.append(solveEachCase(i+1,K,C,S));
			
			buffer.append(System.getProperty(LINE_SEPARATOR));
		}
		
		OutputWriter.create(OUPUT_FILE_NAME, buffer);
	}
	
	private String solveEachCase(int caseNo, int K, int C, int S) {
		String finalResult = null;
		if(K==1 && S==1) {
			finalResult = "Case #"+caseNo+": 1";
		}
		else if(K > S) {
			finalResult = "Case #"+caseNo+": IMPOSSIBLE";
		}
		else {
			int i = 1;
			finalResult = "Case #"+caseNo+":";
			while (i <= K) {
				finalResult = finalResult +" "+i;
				i++;
				if(i >= S)
					break;
			}
		}		
		return finalResult;
	}
}



