package benedek1;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class A_MagicTrick {

	final static String PROBLEM_NAME = "magictrick";
    final static String WORK_DIR = "c:\\GCJ\\" + PROBLEM_NAME + "\\";

	private void solve(Scanner sc, PrintWriter pw) {
		int firstRowNumber = sc.nextInt();
		Map<Integer, Integer> cards = goThrough(sc, firstRowNumber, (Map) new HashMap<>()) ;
		int secondRowNumber = sc.nextInt();
		cards = goThrough(sc, secondRowNumber, cards) ;
		
		pw.println(doTrick(cards));
	}
	
	public String doTrick(Map<Integer, Integer> cards) {
		List<Integer> doubled = new ArrayList<>();
		for (int key : cards.keySet()) {
			if (cards.get(key) == 2) {
				doubled.add(key);
			}
		}
		
		if (doubled.size() == 1) return doubled.get(0).toString();
		else if (doubled.size() > 1) return "Bad magician!";
		else return "Volunteer cheated!";
	}
	
	private Map<Integer, Integer> goThrough(Scanner sc, int row, Map<Integer, Integer> cards) {
		
		for (int i=0; i<row; i++) {
			sc.nextLine();
		}
		for (int i=1; i<=4; i++) {
			int card = sc.nextInt();
			if (cards.get(card) == null) {
				cards.put(card, 1);
			} else {
				cards.put(card, cards.get(card)+1);
			}
		}
		for (int i=row; i<=4; i++) {
			sc.nextLine();
		}
		
		return cards;
		
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		Scanner sc = new Scanner(new FileReader(WORK_DIR + "input.txt"));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + "MagicTrick_small.txt"));
        int caseCnt = sc.nextInt();
        for (int caseNum=0; caseNum<caseCnt; caseNum++) {
            System.out.println("Processing test case " + (caseNum + 1));
            pw.print("Case #" + (caseNum+1) + ": ");
            new A_MagicTrick().solve(sc, pw);
        }
        pw.flush();
        pw.close();
        sc.close();	}
}
