package hu.herba.codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * 
 * @author csorbazoli
 * 
 */
public class HappyPancakes {

	public static void main(String[] args) {
		if (args.length < 1) {
			// process all files in input folder
			for (File input : new File("./input").listFiles()) {
				if (input.getName().endsWith(".in")) {
					System.out.println("Processing: " + input.getName() + "...");
					new HappyPancakes().process(input);
				}
			}
		} else {
			File input = new File("./input", args[0]);
			if (!input.canRead()) {
				error("Input file not found: " + input.getAbsolutePath());
			}
			new HappyPancakes().process(input);
		}
		System.out.println("READY");
	}

	private static void error(String msg) {
		System.err.println(msg);
		System.exit(-1);

	}

	private void process(File input) {
		// process input file
		try {
			Scanner scan = new Scanner(input);
			// open output
			PrintWriter out = new PrintWriter(new File("./output", input.getName().replace(".in", ".out")));
			try {
				// number of test cases
				int T = scan.nextInt();
				for (int i = 0; i < T; i++) {
					processTestCase(i + 1, scan, out);
				}
			} finally {
				out.close();
			}
		} catch (FileNotFoundException e) {
			error(e.getMessage());
		}

	}

	private void processTestCase(int caseNum, Scanner scan, PrintWriter out) {
		boolean debug = false;
		if (caseNum == 0) {
			debug = true;
		}
		// get N
		StringBuilder result = new StringBuilder("Case #" + caseNum + ": ");
		String S = scan.next(); // S consinst of + and - (happy vs. unhappy)
		if (debug) {
			System.out.print(caseNum + "# " + S + " -> ");
		}
		result.append(calculateOutput(S));
		// whole product should be i*j*k = -1
		System.out.println(result.toString());
		out.println(result.toString());
	}

	private String calculateOutput(String s) {
		int i = s.length() - 1;
		char cur = s.charAt(i);
		int ret = cur == '+' ? 0 : 1;
		char next;
		while (i > 0) {
			next = s.charAt(i - 1);
			if (cur != next) {
				ret++;
			}
			cur = next;
			i--;
		}
		return Integer.toString(ret);
	}

}
