package ro.derbederos.codejam2013.tictactoe;

import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class ProblemA {

    @SuppressWarnings({ "deprecation" })
    static List<Input> readInput(String fileName) throws NumberFormatException, IOException {
        DataInputStream data = new DataInputStream(new FileInputStream(fileName));
        List<Input> result;
        try {
            int dataSize = Integer.parseInt(data.readLine());
            result = new ArrayList<Input>(dataSize);
            for (int i = 0; i < dataSize; i++) {
                Input input = new Input();
                data.readLine().getChars(0, 4, input.table[0], 0);
                data.readLine().getChars(0, 4, input.table[1], 0);
                data.readLine().getChars(0, 4, input.table[2], 0);
                data.readLine().getChars(0, 4, input.table[3], 0);
                data.readLine();
                result.add(input);
            }
        } finally {
            data.close();
        }
        return result;
    }

    static boolean wonX(char input[][], char winner) {
        for (int i = 0; i < 4; i++) {
            int sum = 0;
            for (int j = 0; j < 4; j++) {
                if (input[i][j] == winner || input[i][j] == 'T') {
                    sum++;
                }
            }
            if (sum == 4)
                return true;
        }
        for (int j = 0; j < 4; j++) {
            int sum = 0;
            for (int i = 0; i < 4; i++) {
                if (input[i][j] == winner || input[i][j] == 'T') {
                    sum++;
                }
            }
            if (sum == 4)
                return true;
        }
        int sum = 0;
        for (int i = 0; i < 4; i++) {
            if (input[i][i] == winner || input[i][i] == 'T') {
                sum++;
            }
        }
        if (sum == 4)
            return true;
        sum = 0;
        for (int i = 0; i < 4; i++) {
            if (input[i][3 - i] == winner || input[i][3 - i] == 'T') {
                sum++;
            }

        }
        if (sum == 4)
            return true;
        return false;
    }

    static boolean tableFull(char[][] input) {
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                if (input[i][j] == '.') {
                    return false;
                }
            }
        }
        return true;
    }

    public static String getResult(Input input) {
        boolean wonX = wonX(input.table, 'X');
        boolean wonY = wonX(input.table, 'O');
        boolean tableFull = tableFull(input.table);
        if (wonX == wonY && tableFull)
            return "Draw";
        if (wonX)
            return "X won";
        if (wonY)
            return "O won";
        return "Game has not completed";
    }

    public static void main(String[] args) throws Exception {
        List<Input> inputs = readInput("etc/A-small-attempt2.in");
        for (int i = 0; i < inputs.size(); i++) {
            String result = getResult(inputs.get(i));
            System.out.println("Case #" + (i + 1) + ": " + result);
        }
    }

    static class Input {
        char[][] table = new char[4][4];
    }
}
