package ro.derbederos.codejam2013;

import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class ProblemB {

    static int[] readInts(String s) {
        String[] ss = s.split(" ");
        int result[] = new int[ss.length];
        for (int i = 0; i < result.length; i++) {
            result[i] = Integer.parseInt(ss[i]);
        }
        return result;
    }

    @SuppressWarnings({ "deprecation" })
    static List<Input> readInput(String fileName) throws NumberFormatException, IOException {
        DataInputStream data = new DataInputStream(new FileInputStream(fileName));
        List<Input> result;
        try {
            int dataSize = Integer.parseInt(data.readLine());
            result = new ArrayList<Input>(dataSize);
            for (int i = 0; i < dataSize; i++) {
                Input input = new Input();
                int nm[] = readInts(data.readLine());
                input.table = new int[nm[0]][];
                for (int jj = 0; jj < nm[0]; jj++) {
                    input.table[jj] = readInts(data.readLine());
                }
                input.n = nm[0];
                input.m = nm[1];
                result.add(input);
            }
        } finally {
            data.close();
        }
        return result;
    }


    public static boolean getResult(int input[][],int n,int m) {
        int lawn[][] = new int[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                lawn[i][j] = 2;
            }
        }
        //HORIZONTAL CUT
        for (int i = 0; i < n; i++) {
            int sum = 0;
            for (int j = 0; j < m; j++) {
                if (input[i][j] == 1) {
                    sum++;
                }
            }
            if (sum == m) {
                for (int j = 0; j < m; j++) {
                    lawn[i][j] = 1;
                }
            }
        }
        //VERICAL CUT
        for (int j = 0; j < m; j++) {
            int sum = 0;
            for (int i = 0; i < n; i++) {
                if (input[i][j] == 1) {
                    sum++;
                }
            }
            if (sum == n) {
                for (int i = 0; i < n; i++) {
                    lawn[i][j] = 1;
                }
            }
        }
        //COMPARISON 
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (lawn[i][j] != input[i][j]) {
                    return false;
                }
            }
        }
        return true;
    }

    public static void main(String[] args) throws Exception {
        List<Input> inputs = readInput("etc/B-small-attempt0.in");
        for (int i = 0; i < inputs.size(); i++) {
            boolean result = getResult(inputs.get(i).table, inputs.get(i).n, inputs.get(i).m);
            System.out.println("Case #" + (i + 1) + ": " + (result ? "YES" : "NO"));
        }
    }

    static class Input {
        int n, m;
        int[][] table;
    }
}
