package cc.sixi.cj2017;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class ProblemA {

    private final static String input = "A-large.in";
    private final static String output = "A-large.out";

    public static void main(String[] args) throws FileNotFoundException {
        BufferedInputStream source = new BufferedInputStream(
                new FileInputStream(input));
        try (Scanner scan = new Scanner(source);
             PrintWriter pw = new PrintWriter(output);) {
            int t = scan.nextInt();
            for (int i = 1; i <= t; i++) {
                String s = scan.next();
                int k = scan.nextInt();
                String result = processTestCase(s, k);
                pw.printf("Case #%d: %s\n", i, result);
            }
        }
    }

    private static String processTestCase(String s, int k) {
        char c[] = s.toCharArray();
        int turns = 0;
        int n = s.length();
        int i = 0;
        while (i < n - k + 1) {
            if (c[i] == '-') {
                turns++;
                flip(c, i, k);
            }
            i++;
        }
        for (; i < n; i++) {
            if (c[i] == '-') {
                return "IMPOSSIBLE";
            }
        }
        return String.valueOf(turns);
    }

    private static void flip(char[] c, int i, int k) {
        for (int j = i; j < i + k; j++) {
            c[j] = (c[j] == '-') ? '+' : '-';
        }
    }
}
