package com.cst1.gcj2016;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;
import java.util.stream.IntStream;

/**
 * @author camiel
 */
public class Slides {
  private final static String BASE_DIR =
    "/Users/camiel/Documents/projects/google_code_jam/solutions/2016_round1C";


  public static void main(String[] args) throws IOException {
    solveAll("B-small-attempt2");
  }

  private static String formatAnswer(int i, String answer) {
    return String.format("Case #%d: %s", i + 1, answer);
  }

  private static void solveAll(String name) throws IOException {
    try (
      Scanner sc = new Scanner(new File(String.format("%s/input/%s.in", BASE_DIR, name)));
      PrintWriter out = new PrintWriter(String.format("%s/output/%s.out", BASE_DIR, name), StandardCharsets.UTF_8.name());
    ) {

      IntStream
        .range(0, sc.nextInt())
        .boxed()
        .map(i -> formatAnswer(i, solveCase(sc.nextInt(), sc.nextInt())))
        .forEach(out::print);
    }
  }

  private static boolean canReach(boolean[][] matrix, List<Integer> path) {
    if (!matrix[0][path.get(0)]) {
      return false;
    }

    for (int i = 0; i < path.size() - 1; i++) {
      if (!matrix[path.get(i)][path.get(i + 1)]) {
        return false;
      }
    }

    return matrix[path.get(path.size() - 1)][matrix.length - 1];
  }

  private static int countReach(boolean[][] matrix, List<Integer> path, int m, int j) {
    int tot = 0;

    if (j == path.size() - 1) {
      if (canReach(matrix, path)) {
        tot += 1;
      }
    } else {
      for (int i = j; i < path.size(); i++) {
        if (matrix[path.get(i)][path.get(j + 1)]) {
          Collections.swap(path, i, j);
          int count = countReach(matrix, path, m, j + 1);
          Collections.swap(path, j, i);

          if (count == -1) {
            return count;
          }

          tot += count;

          if (tot > m) {
            return -1;
          }
        }
      }
    }

    return tot;
  }

  private static List<List<Integer>> paths = null;

  private static boolean isValid(boolean[][] matrix, int m) {
    int total = 0;

    if (matrix[0][matrix.length - 1]) {
      total += 1;
    }

    if (paths == null) {
      paths = new ArrayList<>();
      paths.add(new ArrayList<>());

      for (int i = 0; i < matrix.length - 2; i++) {
        List<List<Integer>> newPaths = new ArrayList<>();

        for (List<Integer> path : paths) {
          newPaths.add(path);

          List<Integer> pathWithI = new ArrayList<>(path);
          pathWithI.add(i + 1);
          newPaths.add(pathWithI);
        }

        paths = newPaths;
      }
    }

    for (List<Integer> path : paths) {
      total += countReach(matrix, path, m, 0);
    }

    return total == m;
  }

  private static boolean generateMatrices(boolean[][] matrix, int m, int j) {
    if (j < matrix.length - 1) {
      for (int k1 = 0; k1 < matrix.length; k1++) {
        if (k1 != j) {
          matrix[j][k1] = true;

          if (generateMatrices(matrix, m, j + 1)) {
            return true;
          }

          for (int k2 = 0; k2 < matrix.length; k2++) {
            if (k2 != j && k2 != k1) {
              matrix[j][k2] = true;
              if (generateMatrices(matrix, m, j + 1)) {
                return true;
              }
              matrix[j][k2] = false;
            }
          }
          matrix[j][k1] = false;
        }
      }
    } else {
      return isValid(matrix, m);
    }

    return false;
  }

  private static String solveCase(int b, int m) {
    paths = null;

    StringBuilder result = new StringBuilder();
    boolean[][] matrix = new boolean[b][];
    for (int i = 0; i < b; i++) {
      matrix[i] = new boolean[b];
    }

    if (generateMatrices(matrix, m, 0)) {
      result.append("POSSIBLE\n");
      for (boolean[] row : matrix) {
        List<String> rowStr = new ArrayList<>();
        for (boolean connected : row) {
          if (connected) {
            rowStr.add("1");
          } else {
            rowStr.add("0");
          }
        }
        result.append(String.join(" ", rowStr));
        result.append("\n");
      }
    } else {
      result.append("IMPOSSIBLE\n");
    }

    return result.toString();
  }
}
