package com.cst1.gcj2016;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

/**
 * @author camiel
 */
@SuppressWarnings("OptionalGetWithoutIsPresent")
public class SenateEvacuation {
  private final static String BASE_DIR =
    "/Users/camiel/Documents/projects/google_code_jam/solutions/2016_round1C";


  public static void main(String[] args) throws IOException {
    solveAll("A-large");
  }

  private static String formatAnswer(int i, String answer) {
    return String.format("Case #%d: %s", i + 1, answer);
  }

  private static void solveAll(String name) throws IOException {
    try (
      Scanner sc = new Scanner(new File(String.format("%s/input/%s.in", BASE_DIR, name)));
      PrintWriter out = new PrintWriter(String.format("%s/output/%s.out", BASE_DIR, name), StandardCharsets.UTF_8.name());
    ) {

      IntStream
        .range(0, Integer.parseInt(sc.nextLine()))
        .boxed()
        .map(i -> formatAnswer(i, solveCase(sc)))
        .forEach(out::println);
    }
  }

  private static char toPartyChar(int index) {
    return (char) (((int) 'A') + index);
  }

  private static String solveCase(Scanner sc) {
    sc.nextLine();
    List<Integer> parties = new ArrayList<>(
      Arrays
        .stream(sc.nextLine().split(" "))
        .map(Integer::parseInt)
        .collect(Collectors.toList()));

    StringBuilder result = new StringBuilder();
    List<Integer> remainingParties = new ArrayList<>();

    int max = parties.stream().mapToInt(i -> i).max().getAsInt();
    int secondMax = max;
    for (int p = 0; p < parties.size(); p++) {
      if (parties.get(p) == max) {
        remainingParties.add(p);
      }

      if (remainingParties.size() >= 2) {
        break;
      }
    }

    if (remainingParties.size() == 1) {
      secondMax = 0;
      for (int p = 0; p < parties.size(); p++) {
        if (p != remainingParties.get(0)) {
          secondMax = Math.max(secondMax, parties.get(p));
        }
      }

      for (int p = 0; p < parties.size(); p++) {
        if (parties.get(p) == secondMax) {
          remainingParties.add(p);
          break;
        }
      }
    }

    while (parties.get(remainingParties.get(0)) > secondMax) {
      result.append(toPartyChar(remainingParties.get(0)));
      parties.set(remainingParties.get(0), parties.get(remainingParties.get(0)) - 1);

      result.append(" ");
    }

    while (parties.get(remainingParties.get(1)) > secondMax) {
      result.append(toPartyChar(remainingParties.get(1)));
      parties.set(remainingParties.get(1), parties.get(remainingParties.get(1)) - 1);

      result.append(" ");
    }

    boolean hasLeft = true;
    while (hasLeft) {
      hasLeft = false;
      int c = 0;

      for (int p = 0; p < parties.size(); p++) {
        if (!remainingParties.contains(p)) {
          if (c < 2 && parties.get(p) > 0) {
            parties.set(p, parties.get(p) - 1);
            result.append(toPartyChar(p));
            c++;
            result.append(" ");
          }

          hasLeft = hasLeft || parties.get(p) > 0;
        }
      }
    }

    for (int i = 0; i < parties.get(remainingParties.get(0)); i++) {
      result.append(toPartyChar(remainingParties.get(0)));
      result.append(toPartyChar(remainingParties.get(1)));
      result.append(" ");
    }

    return result.toString().trim();
  }
}
