import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

public class B {
    private static StringTokenizer st;
    private static BufferedReader br;
    public static long MOD = 1000000007;

    public static void print(Object x) {
        System.out.println(x + "");
    }
    public static void printArr(long[] x) {
        StringBuilder s = new StringBuilder();
        for (int i = 0; i < x.length; i++) {
            s.append(x[i] + " ");
        }
        print(s);
    }
    public static void printArr(int[] x) {
        StringBuilder s = new StringBuilder();
        for (int i = 0; i < x.length; i++) {
            s.append(x[i] + " ");
        }
        print(s);
    }
    public static void printArr(char[] x) {
        StringBuilder s = new StringBuilder();
        for (int i = 0; i < x.length; i++) {
            s.append(x[i] + "");
        }
        print(s);
    }
    public static String join(Collection<?> x, String space) {
        if (x.size() == 0) return "";
        StringBuilder sb = new StringBuilder();
        boolean first = true;
        for (Object elt : x) {
            if (first) first = false;
            else sb.append(space);
            sb.append(elt);
        }
        return sb.toString();
    }

    public static String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            String line = br.readLine();
            st = new StringTokenizer(line.trim());
        }
        return st.nextToken();
    }
    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static int N;
    public static int K;
    public static double[] prob;

    public static double solve(int left) {
        double[] curProbs = new double[K];
        for (int i = 0; i < left; i++) {
            curProbs[i] = prob[i];
        }
        for (int i = left; i < K; i++)
            curProbs[i] = prob[N + left - i - 1];

        double[] distribution = new double[K+1]; // probability distribution of yes votes
        distribution[0] = 1;
        for (int i = 0; i < K; i++) {
            double p = curProbs[i];
            double[] nextDistribution = new double[K+1];
            for (int count = 0; count < K; count++) {
                nextDistribution[count + 1] += distribution[count] * p;
                nextDistribution[count] += distribution[count] * (1 - p);
            }
            distribution = nextDistribution;
        }

        return distribution[K/2];
    }

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new FileReader("input.txt"));

        int T = nextInt();
        for (int t = 1; t <= T; t++) {
            N = nextInt();
            K = nextInt();

            List<Double> voters = new ArrayList<>();
            for (int i = 0; i < N; i++)
                voters.add(nextDouble());
            Collections.sort(voters);
            prob = new double[N];
            for (int i = 0; i < N; i++)
                prob[i] = voters.get(i);

            double success = 0;
            for (int leftCount = 0; leftCount <= K; leftCount++) {
                success = Math.max(success, solve(leftCount));
            }
            System.out.printf("Case #%d: %.8f%n", t, success);
        }
    }
}
