import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

public class Main {
    private static StringTokenizer st;
    private static BufferedReader br;
    public static long MOD = 1000000007;

    public static void print(Object x) {
        System.out.println(x + "");
    }
    public static void printArr(long[] x) {
        StringBuilder s = new StringBuilder();
        for (int i = 0; i < x.length; i++) {
            s.append(x[i] + " ");
        }
        print(s);
    }
    public static void printArr(int[] x) {
        StringBuilder s = new StringBuilder();
        for (int i = 0; i < x.length; i++) {
            s.append(x[i] + " ");
        }
        print(s);
    }
    public static void printArr(char[] x) {
        StringBuilder s = new StringBuilder();
        for (int i = 0; i < x.length; i++) {
            s.append(x[i] + "");
        }
        print(s);
    }
    public static String join(Collection<?> x, String space) {
        if (x.size() == 0) return "";
        StringBuilder sb = new StringBuilder();
        boolean first = true;
        for (Object elt : x) {
            if (first) first = false;
            else sb.append(space);
            sb.append(elt);
        }
        return sb.toString();
    }

    public static String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            String line = br.readLine();
            st = new StringTokenizer(line.trim());
        }
        return st.nextToken();
    }
    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    // lex smallest string w/ winner s
    public static char[] expand(char s, int levels) {
        if (levels == 0) return new char[] {s};

        char[] children;
        if (s == 'R') children = new char[] {'R', 'S'};
        else if (s == 'P') children = new char[] {'P', 'R'};
        else children = new char[] {'P', 'S'};

        String left;
        String right;
        left = new String(expand(children[0], levels - 1));
        right = new String(expand(children[1], levels - 1));
        String total;

        if (left.compareTo(right) < 0) total = left + right;
        else total = right + left;

        return total.toCharArray();
    }

    public static boolean matches(char[] s, int R, int P, int S) {
        for (char c : s) {
            if (c == 'R') R -= 1;
            if (c == 'P') P -= 1;
            if (c == 'S') S -= 1;
        }
        if (R != 0) return false;
        if (P != 0) return false;
        if (S != 0) return false;
        return true;
    }

    public static String lesser(String a, String b) {
        if (a == null) return b;
        if (b == null) return a;
        if (a.compareTo(a) > 0) return a;
        return b;
    }

    public static void main(String[] args) throws IOException {
        // br = new BufferedReader(new InputStreamReader(System.in));
        br = new BufferedReader(new FileReader("input.txt"));

        int T = nextInt();
        for (int t = 1; t <= T; t++) {
            int N = nextInt();
            int R = nextInt();
            int P = nextInt();
            int S = nextInt();

            String best = null;
            char[] rTop = expand('R', N);
            char[] pTop = expand('P', N);
            char[] sTop = expand('S', N);
            if (matches(rTop, R, P, S)) best = new String(rTop);
            if (matches(pTop, R, P, S)) best = lesser(best, new String(pTop));
            if (matches(sTop, R, P, S)) best = lesser(best, new String(sTop));

            if (best == null) {
                System.out.printf("Case #%d: IMPOSSIBLE%n", t);
            } else {
                System.out.printf("Case #%d: %s%n", t, best);
            }
        }
    }
}
