import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.*;

public class Main {
    private static StringTokenizer st;
    private static BufferedReader br;
    public static long MOD = 1000000007;
    public static double EPS = 0.000001;

    public static void print(Object x) {
        System.out.println(x + "");
    }
    public static String join(Collection<?> x, String space) {
        if (x.size() == 0) return "";
        StringBuilder sb = new StringBuilder();
        boolean first = true;
        for (Object elt : x) {
            if (first) first = false;
            else sb.append(space);
            sb.append(elt);
        }
        return sb.toString();
    }

    public static String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            String line = br.readLine();
            st = new StringTokenizer(line.trim());
        }
        return st.nextToken();
    }
    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static boolean tidy(int[] digits, int m) {
        for (int i = 1; i < m; i++) {
            if (digits[i] < digits[i-1]) {
                return false;
            }
        }
        return true;
    }

    public static String solve(String N) {
        int m = N.length();
        int[] digits = new int[m];
        for (int i = 0; i < m; i++) {
            digits[i] = Integer.parseInt(N.charAt(i) + "");
        }

        if (tidy(digits, m)) {
            return N;
        }

        int last = -1;
        for (int i = 0; i < m; i++) {
            if (digits[i] <= last) {
                digits[i-1] -= 1;
                for (int j = i; j < m; j++) {
                    digits[j] = 9;
                }
                break;
            }
            last = digits[i];
        }

        String s = "";
        int i = 0;
        if (digits[0] == 0) {
            i = 1;
        }
        for (; i < m; i++) {
            s += digits[i];
        }
        return s;
    }

    public static void main(String[] args) throws IOException {
        // br = new BufferedReader(new InputStreamReader(System.in));
        br = new BufferedReader(new FileReader("input.txt"));

        int T = nextInt();
        for (int t = 1; t <= T; t++) {
            String N = nextToken();

            System.out.printf("Case #%d: %s%n", t, solve(N));
        }
    }
}
