package googleCodeJam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

public class SavingTheUniverse {
	
	private int cases;
	private int engineCount;
	private int queryCount;
	private String[] engines;
	private String[] queries;
	private ArrayList<String> useable;
	
	private int switches = 0;
	
	private BufferedReader in;
	private BufferedWriter out;
	private String inputFile;
	private String outputFile;
	private String line;
	private String output = "";

	
	public SavingTheUniverse(String inputFile){
		this.inputFile = inputFile;
		this.outputFile = this.inputFile.replace(".in", ".out");
		
		try {
			in = new BufferedReader(new FileReader(this.inputFile));
			out = new BufferedWriter(new FileWriter(this.outputFile));
			
			cases = Integer.parseInt(in.readLine());
			int x;
			for(x=1;x<=cases;x++){
				int i;
				
				line = in.readLine();
				engineCount = Integer.parseInt(line);
				engines = new String[engineCount];
				for(i=0;i<engineCount;i++){
					engines[i] = in.readLine();
				}
				
				line = in.readLine();
				queryCount = Integer.parseInt(line);
				queries = new String[queryCount];
				
				for(i=0;i<queryCount;i++){
					queries[i]=in.readLine();
				}
				
				useable = new ArrayList<String>(engineCount);
				initUseable();
				calcEngine(0);
				
				output = "Case #" + x + ": "+switches;
				/*output += "[";
				for(String en : engines){
					output += en+",";
				}
				output +="]\n";

				output +="[";
				for(String qu : queries){
					output +=qu+",";
				}
				output +="]";*/
				
				out.write(output);
				if(x != cases)
					out.newLine();
				
				
				System.out.println(output);
				switches = 0;
			}
			in.close();
			out.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private void calcEngine(int startIdx){
		String engine = null;
		int i;
		int switchAt;
		
		for(i=startIdx; i<queries.length; i++){
			if(useable.size() > 1){
				useable.remove(engines[find(engines,queries[i])]);
			}
			else {
				engine = useable.get(0);
				initUseable();
				break;
			}
		}
		
		if(engine == null){
			switchAt = -1;
		}
		else {
			switchAt = find(queries,engine,startIdx);
		}
		
		if(switchAt == -1){
			/*System.out.print("Use ");
			if(engine == null){
				for(int x=0;x<useable.size();x++){
					System.out.print(useable.get(x));
					if(x+1<useable.size())
						System.out.print(", ");
				}
			}
			else{
				System.out.print(engine);
			}
			System.out.print(" until the end.\n");*/
			return;
		}
		
		//System.out.println("Use "+engine+" until query "+(switchAt+1)+".");
		
		switches++;
		
		calcEngine(switchAt);
	}
	
	private <T extends Comparable<T>> int find(T[] a, T search, int offset){
		int i;
		for(i=offset;i<a.length;i++){
			if(a[i].compareTo(search) == 0){
				break;
			}
		}
		if (i>=a.length)
			return -1;
		else
			return i;
	}
	
	private <T extends Comparable<T>> int find(T[] a, T search){
		int i;
		for(i=0;i<a.length;i++){
			if(a[i].compareTo(search) == 0){
				break;
			}
		}
		if (i>=a.length)
			return -1;
		else
			return i;
	}
	
	private void initUseable(){
		useable.clear();
		for(String engine : engines){
			useable.add(engine);
		}
	}
	
	public static void main(String[] args){
		SavingTheUniverse gcj = new SavingTheUniverse("A-large-savingtheuniverse.in");
	}
}
