import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class C_CoinJam {

	public static void main(String[] args) {
		Reader.init();
		
		int T = Reader.nextInt();
		int N, J;
		
		ArrayList<CoinJam> coinJamList = new ArrayList<CoinJam>();
		long mid;
		long base;
		
		for(int main=0; main<T; main++) {
			coinJamList.clear();
			
			N = Reader.nextInt();
			J = Reader.nextInt();
			
			mid = 0;
			base = (1 << (N-1)) + 1;
			
			while(coinJamList.size() < J) {
				try {
					String coinJamStr = Long.toBinaryString(base + (mid<<1));
					CoinJam coinJam = new CoinJam(coinJamStr);
					coinJamList.add(coinJam);
				} catch (Exception e) {
				} finally {
					mid++;
				}
			}

			System.out.println("Case #" + (main+1) + ":");
			for(CoinJam coinJam : coinJamList) {
				System.out.println(coinJam.toString());
			}
		}
	}
	
	static class CoinJam {
		private String coinJamStr;
		private long[] divisors;
		
		public CoinJam(String coinJamStr) throws Exception {
			divisors = new long[11];
			if(!isCoinJam(coinJamStr)) throw new Exception("Not a coin jam!");
			this.coinJamStr = coinJamStr;
		}
		
		private boolean isCoinJam(String coinJamStr) {
			for(int radix=2; radix<=10; radix++) {
				long number = Long.parseLong(coinJamStr, radix);
				divisors[radix] = findDivisor(number);
				if(divisors[radix] == -1) return false;
			}
			
			return true;
		}
		
		private long findDivisor(long number) {
			long root = (long) Math.sqrt(number);
			if(number%2 == 0) return 2;
			for(long divisor = 3; divisor<=root; divisor+=2) {
				if(number % divisor == 0) return divisor;
			}
			return -1;
		}

		@Override
		public String toString() {
			StringBuilder builder = new StringBuilder(coinJamStr).append(" ");
			for(int radix=2; radix<=10; radix++)
				builder.append(divisors[radix]).append(" ");
			return builder.toString();
		}
	}
	
	static class Reader {
		private static BufferedReader in;
		private static StringTokenizer tokenizer;
		
		public static void init() {
			in = new BufferedReader(new InputStreamReader(System.in));
			tokenizer = new StringTokenizer("");
		}
		
		public static String next() {
			while(!tokenizer.hasMoreTokens())
				try {
					tokenizer = new StringTokenizer(in.readLine());
				} catch (IOException e) {
				}
			return tokenizer.nextToken();
		}
		
		public static int nextInt() {
			return Integer.parseInt(next());
		}
		
		public static long nextLong() {
			return Long.parseLong(next());
		}
	}
}
