import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;

public class A_CountingSheep {

	public static void main(String[] args) {
		Reader.init();
		
		int T = Reader.nextInt();
		boolean[] hasSeen = new boolean[10];
		
		String N_str; // String format of N
		long N; // Long format of N
		long max; // Maximum number to loop
		
		for(int main=0; main<T; main++) {
			N_str = Reader.next();
			N = Long.parseLong(N_str);
			max = power(10, N_str.length() * 2);
			
			// Initialize flag array
			Arrays.fill(hasSeen, false);
			
			int count;
			for(count=1; count<=max && !isAllChecked(hasSeen); count++) {
				checkDigits(hasSeen, String.valueOf(N * count));
			}

			if(isAllChecked(hasSeen)) printAnswer(main+1, String.valueOf((count-1) * N));
			else printAnswer(main+1, "INSOMNIA");
		}
	}
	
	private static long power(int base, int power) {
		long result = 1;
		for(int i=0; i<power; i++) result *= base;
		return result;
	}
	
	private static boolean isAllChecked(boolean[] array) {
		for(int i=0; i<array.length; i++)
			if(!array[i]) return false;
		return true;
	}
	
	private static void checkDigits(boolean[] array, String number) {
		char[] arr = number.toCharArray();
		for(char c : arr) {
			array[c-'0'] = true;
//			System.out.println("Seen " + (c-'0') + "!");
		}
	}
	
	private static void printAnswer(int caseNum, String answer) {
		System.out.println("Case #" + caseNum + ": " + answer);
	}
	
	static class Reader {
		private static BufferedReader in;
		private static StringTokenizer tokenizer;
		
		public static void init() {
			in = new BufferedReader(new InputStreamReader(System.in));
			tokenizer = new StringTokenizer("");
		}
		
		public static String next() {
			while(!tokenizer.hasMoreTokens())
				try {
					tokenizer = new StringTokenizer(in.readLine());
				} catch (IOException e) {
				}
			return tokenizer.nextToken();
		}
		
		public static int nextInt() {
			return Integer.parseInt(next());
		}
		
		public static long nextLong() {
			return Long.parseLong(next());
		}
	}

}
