import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class B_RevengeOfThePancakes {

	public static void main(String[] args) {
		Reader.init();
		
		int T = Reader.nextInt();
		for(int main=0; main<T; main++) {
			boolean[] stack = convertStringToBooleanArray(Reader.next());

			int done = findLastDone(stack, stack.length);
			int count = 0;

			while(done > 0) {
				if(stack[0]) {
					// Top of stack is (+)
					flip(stack, 0, findLastNotDoneTrue(stack, done));
				} else {
					// Top of stack is (-)
					flip(stack, 0, done);
				}
				count ++;
				done = findLastDone(stack, done);
			}
			
			System.out.println("Case #" + (main+1) + ": " + count);
		}
	}
	
	private static boolean[] convertStringToBooleanArray(String string) {
		char[] charArr = string.toCharArray();
		boolean[] boolArr = new boolean[charArr.length];
		for(int i=0; i<charArr.length; i++)
			boolArr[i] = (charArr[i] == '+');
		return boolArr;
	}
	
	private static int findLastDone(boolean[] arr, int originalDone) {
		while(originalDone > 0 && arr[originalDone-1]) originalDone--;
		return originalDone;
	}
	
	private static int findLastNotDoneTrue(boolean[] arr, int done) {
		while(!arr[done-1]) done--;
		return done;
	}
	
	private static void flip(boolean[] arr, int begin, int end) {
		boolean t;
		while(begin < end) {
			t = arr[begin];
			arr[begin] = !arr[end-1];
			arr[end-1] = !t;
			
			begin++;
			end--;
		}
		
//		if(begin == end) arr[begin] = !arr[end];
	}

	static class Reader {
		private static BufferedReader in;
		private static StringTokenizer tokenizer;
		
		public static void init() {
			in = new BufferedReader(new InputStreamReader(System.in));
			tokenizer = new StringTokenizer("");
		}
		
		public static String next() {
			while(!tokenizer.hasMoreTokens())
				try {
					tokenizer = new StringTokenizer(in.readLine());
				} catch (IOException e) {
				}
			return tokenizer.nextToken();
		}
		
		public static int nextInt() {
			return Integer.parseInt(next());
		}
		
		public static long nextLong() {
			return Long.parseLong(next());
		}
	}
}
