import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Collections;
import java.util.LinkedList;

public class ProblemB {

	public static void main(String[] args) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader(new File(
				args[0])));
		BufferedWriter writer = new BufferedWriter(new FileWriter(new File(
				args[1])));

		int numCases = Integer.parseInt(reader.readLine());

		for (int caseNumber = 0; caseNumber < numCases; caseNumber++) {
			reader.readLine();
			LinkedList<Integer> plates = new LinkedList<Integer>();

			for (String plateString : reader.readLine().split(" ")) {
				plates.add(Integer.parseInt(plateString));
			}

			int penalty = 0;
			int maxPlate = 0;
			
			Collections.sort(plates);
			int limitPlate = plates.getLast();

			while (true) {
				
				Collections.sort(plates);
				maxPlate = plates.getLast();

				double split = (double) maxPlate / 2;
				int improvement = (int) Math.ceil(split) + 1 + penalty;
				
				boolean improved = improvement < maxPlate;
				
				if (improved) {
					int plate1 = (int) Math.ceil(split);
					int plate2 = (int) Math.floor(split);
					plates.removeLast();
					plates.add(plate1);
					plates.add(plate2);

					penalty++;
				} else {
					break;
				}
			}
			
			int result = maxPlate + penalty;
			
			if (result > limitPlate)
			{
				result = limitPlate;
			}

			writer.write("Case #" + (caseNumber + 1) + ": " + (result) + "\n");
		}

		reader.close();
		writer.close();
	}
}
