import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Main {

	public static void main(String[] args) throws Exception {

		BufferedReader reader = new BufferedReader(new FileReader(new File(
				args[0])));
		BufferedWriter writer = new BufferedWriter(new FileWriter(new File(
				args[1])));

		int numCases = readNumberLine(reader);

		for (int caseNum = 1; caseNum <= numCases; caseNum++) {
			int[][] chosenRows = new int[2][];

			for (int answerIndex = 0; answerIndex < 2; answerIndex++) {
				int answer = readNumberLine(reader);

				for (int lineIndex = 0; lineIndex < 4; lineIndex++) {
					if (answer == lineIndex + 1) {
						chosenRows[answerIndex] = readNumbersLine(reader);
					}
					else
					{
						reader.readLine();
					}
				}
			}

			int matchCount = 0;
			int matchingNum = 0;

			for (int i = 0; i < 4; i++) {
				for (int j = 0; j < 4; j++) {
					if (chosenRows[0][i] == chosenRows[1][j]) {
						matchingNum = chosenRows[0][i];
						matchCount++;
					}
				}
			}

			writer.write("Case #" + caseNum + ": ");
			
			switch (matchCount) {
			case 1:
				writer.write(String.valueOf(matchingNum));
				break;
			case 0:
				writer.write("Volunteer cheated!");
				break;
			default:
				writer.write("Bad magician!");
			}
			
			writer.write("\n");
		}
		
		reader.close();
		writer.close();

	}

	private static int readNumberLine(BufferedReader reader) throws IOException {
		return Integer.parseInt(reader.readLine());
	}

	private static int[] readNumbersLine(BufferedReader reader)
			throws IOException {
		String line = reader.readLine();
		String lineParts[] = line.split(" ");
		int numbers[] = new int[lineParts.length];

		for (int i = 0; i < lineParts.length; i++) {
			numbers[i] = Integer.parseInt(lineParts[i]);
		}

		return numbers;
	}

}
