import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Main {

	public static void main(String[] args) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader(new File(
				args[0])));
		BufferedWriter writer = new BufferedWriter(new FileWriter(new File(
				args[1])));
		
		int numCases = readNumberLine(reader);
		
		for (int caseIndex = 0; caseIndex < numCases; caseIndex ++)
		{
			writer.write("Case #" + (caseIndex + 1) + ":\n");
			
			int[] caseConf = readNumbersLine(reader);
			int height = caseConf[0];
			int width = caseConf[1];
			int numMines = caseConf[2];
			int gridSize = width * height;
			boolean ok = false;
			
			if (width == 1 || height == 1)
			{
				ok = gridSize - numMines >= 2;
			}
			else
			{
				ok = gridSize - numMines >= 4;
			}
			
			if (!ok)
			{
				writer.write("Impossible\n");
			}
			else
			{
				int minesPlaced = 0;
				int remainingPlaces = gridSize;
				
				for (int h = height - 1; h >= 0; h--)
				{
					for (int w = width - 1; w >= 0; w--)
					{
						if ((h > 1 || w > 1) && (minesPlaced < numMines))
						{
							writer.write("*");
							minesPlaced ++;
						}
						else if (h > 0 || w > 0)
						{
							writer.write(".");
						}
						else
						{
							writer.write("c");
						}
						
						remainingPlaces --;
					}
					writer.write("\n");
				}
			}
		}
		
		reader.close();
		writer.close();
	}
	
	private static int readNumberLine(BufferedReader reader) throws IOException {
		return Integer.parseInt(reader.readLine());
	}

	private static int[] readNumbersLine(BufferedReader reader)
			throws IOException {
		String line = reader.readLine();
		String lineParts[] = line.split(" ");
		int numbers[] = new int[lineParts.length];

		for (int i = 0; i < lineParts.length; i++) {
			numbers[i] = Integer.parseInt(lineParts[i]);
		}

		return numbers;
	}

}
