package lawnmower;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

public class B {

	static File input = new File("input.txt");
	static Scanner reader;
	static ArrayList<int[][]> testCases = new ArrayList<int[][]>();
	
	public static void main(String[] args) {
		try {
			reader = new Scanner(input);
		} catch (FileNotFoundException e) {	e.printStackTrace();	}
		
		try {	
			createTestCases();	
		} catch (IOException e) {	e.printStackTrace();	}
		
		int i = 1;
		for (int[][] testCase : testCases) {
			String result = (isMowable(testCase)) ? "YES" : "NO";
			System.out.println("Case #"+i+++": "+result);
		}
		
	}

	private static boolean isMowable(int[][] lawn){
		do {
			ArrayList<Integer> columns = new ArrayList<Integer>();
			ArrayList<Integer> lines = new ArrayList<Integer>();
			
			//Checking which columns/lines are the same height all the way
			for (int i = 0; i < lawn.length; i++) {
				if (isSame(lawn[i]))
					lines.add(i);
			}
			
			for (int i = 0; i < lawn[0].length; i++) {
				int[] column = new int[lawn.length];
				for (int j = 0; j < column.length; j++) {
					column[j]=lawn[j][i];
				}
				if (isSame(column))
					columns.add(i);
			}
			
			//checking if we have any lines
			if (lines.isEmpty() && columns.isEmpty())
				return false;
			
			//adding 1mm to the height of the grass in such columns
			for (int i : lines) {
				for (int j = 0; j < lawn[i].length; j++) {
					lawn[i][j]++;
				}
			}
			
			for (int i : columns) {
				for (int j = 0; j < lawn.length; j++) {
					if (!lines.contains(j))
						lawn[j][i]++;
				}
			}
		} while (!is100(lawn));
		return true;
	}
	
	private static boolean isSame(int[] values){
		int l=values[0];
		for (int i : values) {
			if (i!=l || i>=100) return false;
		}
		return true;
	}
	
	private static boolean is100(int[][] lawn) {
		for (int[] is : lawn) {
			for (int i : is) {
				if (i!=100)
					return false;
			}
		}
		return true;
	}

	private static void createTestCases() throws IOException {
		int cases = reader.nextInt();
		reader.nextLine();
		for (int caseNumber = 0; caseNumber < cases; caseNumber++) {
			int[][] testCase = new int[reader.nextInt()][reader.nextInt()];
			for (int i = 0; i < testCase.length; i++) {
				for (int j = 0; j < testCase[i].length; j++) {
					testCase[i][j]=reader.nextInt();
				}
			}		
			
			testCases.add(testCase);
			if (caseNumber!=cases-1) reader.nextLine();
		}
	}
}
