package fairAndSquare;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.Vector;

public class C {
	
	static File input = new File("input.txt");
	static Scanner reader;
	static Vector<BigInteger[]> testCases = new Vector<BigInteger[]>();
	
	public static void main(String[] args) {
		try {
			reader = new Scanner(input);
		} catch (FileNotFoundException e) {	e.printStackTrace();	}
		
		try {	
			createTestCases();	
		} catch (IOException e) {	e.printStackTrace();	}
		
		int i=1;
		for (BigInteger[] line : testCases) {
			System.out.println("Case #"+i+++": "+getFairAndSquare(line[0], line[1]));
		}
		
	}

	private static String getFairAndSquare(BigInteger min, BigInteger max) {
		BigInteger sqrtMin = sqrt(min);
		BigInteger sqrtMax = sqrt(max);
		int count=0;
		
		for (BigInteger i = new BigInteger(sqrtMin.toByteArray()); i.compareTo(sqrtMax)<=0; i=i.add(BigInteger.ONE)) {
			if (isPalindrome(i)){
				BigInteger iSquared = i.multiply(i);
				if (iSquared.compareTo(min)>=0) {
					if (isPalindrome(iSquared))
						count++;
				}
			}
		}
		return ""+count;
	}
	
	

	private static boolean isPalindrome(BigInteger i) {
		char[] n = i.toString().toCharArray();
		int size = (int) Math.ceil(n.length/2);
		for (int j = 0; j < size; j++) {
			if (n[j]!=n[n.length-j-1])
				return false;
		}
		return true;
	}

	private static BigInteger sqrt(BigInteger x) {
		if (x.equals(BigInteger.ONE))
			return BigInteger.ONE;
	    BigInteger TWO = BigInteger.valueOf(2);
	    BigInteger y;
	    //Newton's iteration to a precision of 1, rounded down.
	    for (y = x.divide(TWO); y.compareTo(x.divide(y)) > 0; y = ((x.divide(y)).add(y)).divide(TWO)){ }
	    return y;
	}

	private static void createTestCases() throws IOException {
		int cases = reader.nextInt();
		reader.nextLine();
		for (int caseNumber = 0; caseNumber < cases; caseNumber++) {
			BigInteger[] testCase = new BigInteger[2];
			testCase[0]=new BigInteger(reader.next());
			testCase[1]=new BigInteger(reader.next());			
			
			testCases.add(testCase);
			if (caseNumber!=cases-1) reader.nextLine();
		}
	}
	
	
}
