package ticTacToeTomek;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Scanner;
import java.util.Vector;

public class A {
	
	static File input = new File("input.txt");
	static Scanner reader;
	static Vector<char[][]> testCases = new Vector<char[][]>();
	
	public static void main(String[] args) {
		try {
			reader = new Scanner(input);
		} catch (FileNotFoundException e) {	e.printStackTrace();	}
		
		try {	
			createTestCases();	
		} catch (IOException e) {	e.printStackTrace();	}
		
		int i=1;
		for (char[][] game : testCases) {
			System.out.println("Case #"+i+++": "+getGameStatus(game));
		}
		
	}

	private static void createTestCases() throws IOException {
		int cases = reader.nextInt();
		reader.nextLine();
		for (int caseNumber = 0; caseNumber < cases; caseNumber++) {
			char[][] testCase = new char[4][4];
			
			for (int i = 0; i < 4; i++) {
				String line = reader.nextLine();
				
				for (int j = 0; j < 4; j++) {
					testCase[i][j]=line.charAt(j);
				}
			}
			
			testCases.add(testCase);
			if (caseNumber!=cases-1) reader.nextLine();
		}
	}

	private static String getGameStatus(char[][] game){
		//Lines
		for (char[] cs : game) {
			if (new String(cs).equalsIgnoreCase("xxxx")) return "X won";
			if (new String(cs).equalsIgnoreCase("oooo")) return "O won";
			char lastChar = (cs[0]!='T') ? cs[0] : cs[1];
			for (int i = 1; i < 4; i++) {
				if ((cs[i]!=lastChar && cs[i]!='T') || cs[i]=='.') break;
				if (i==3) return lastChar+" won";
			}
		}
		
		//Columns
		for (int col = 0; col < 4; col++) {
			String cs = new String(game[0][col]+""+game[1][col]+""+game[2][col]+""+game[3][col]);
			
			if (cs.equalsIgnoreCase("xxxx")) return "X won";
			if (cs.equalsIgnoreCase("oooo")) return "O won";
			char lastChar = (cs.charAt(0)!='T') ? cs.charAt(0) : cs.charAt(0);
			for (int i = 1; i < 4; i++) {
				if ((cs.charAt(i)!=lastChar && cs.charAt(i)!='T') || cs.charAt(i)=='.') break;
				if (i==3) return lastChar+" won";
			}
		}
		
		//Diagonals
		char lastChar = (game[0][0]!='T') ? game[0][0] : game[1][1];
		for (int i = 1; i < 4; i++) {
			if ((game[i][i]!=lastChar && game[i][i]!='T') || game[i][i]=='.') break;
			if (i==3) return lastChar+" won";
		}
		lastChar = (game[3][0]!='T') ? game[3][0] : game[2][1];
		for (int i = 1; i < 4; i++) {
			if ((game[3-i][i]!=lastChar && game[3-i][i]!='T') || game[3-i][i]=='.') break;
			if (i==3) return lastChar+" won";
		}
		
		//Unfinished
		for (char[] cs : game) {
			for (char c : cs) {
				if (c == '.')
					return "Game has not completed";
			}
		}
		
		return "Draw";
	}
}
