import java.io.*;
import java.util.*;

public class Minesweeper{

   public static void main(String[] args){
      Scanner k = null;
      try{
        k = new Scanner(new File("C-small-attempt0.in"));
      }catch(FileNotFoundException e){
         e.printStackTrace();
      }
      if(k!=null){

      
      int cases = Integer.parseInt(k.nextLine());
     
      String[] out  = new String[cases];
      for(int i = 0;  i< cases ; i++){
         String line  = k.nextLine();
         System.out.println(line);
         String[]  arr = line.split(" ");
         System.out.println(Arrays.toString(arr));
         
         int rows = Integer.parseInt(arr[0]);
         int cols = Integer.parseInt(arr[1]);
         int mines  = Integer.parseInt(arr[2]);
         
         String result = "";
         
         //do some magic here,
         String[][] grid = null;
         boolean possible = false;
         int t = 0;
         while(!possible && ((mines <=20 && t<500) || (mines >50 && mines <50 && t<1000) || (mines >50 && t<5000) )){
            
               
               
               grid = getGrid(rows,cols, mines);
               possible = isSolvable(grid);
               t++;
         }
         
         if(possible){
            for(int m = 0; m< rows; m++){
               for(int h = 0; h< cols; h++){
                  result+= grid[m][h];
               }
               if(m!=rows -1)
                  result+="\n";
            }
            
         }else{
            result = "Impossible";
         }
            
         
            
           
         
         out[i] = result;
         
      }
      
      output(out);
      System.out.println(Arrays.toString(out));
      
     
      }
      }
      public static String[][] copy(String[][] grid){
        
         int rows = grid.length;
         int cols = grid[0].length;
         String[][] grid2 = new String[rows][cols];

         for(int i = 0; i< rows; i++){
            for(int j = 0; j< cols; j++){
               grid2[i][j] = grid[i][j];
            }
         }

         return grid2;
      }
      public static boolean isSolvable(String[][] grid){
         //try diff positions of c
         System.out.println("At issolvable method");
         for(int i = 0; i< grid.length; i++){
            for(int j = 0; j< grid[0].length; j++){
               System.out.println("Checking solvability at "+ i+ " " + j);
               if(grid[i][j] == "*"){
               
                 continue;
               }                 
              
                  
               else{
                  String[][] mygrid = copy(grid);
                  System.out.println("Testing the grid");
                  solve(mygrid, i ,j);
                  if(checkWin(mygrid)){
                     grid[i][j] = "c";
                     return true;
                   }
               }
            }
         }
         
            
            return false;
         
      }
      
      
      public static String[][] getGrid(int rows, int cols, int mines){
         System.out.println("Grid made");
         String[][] grid = new String[rows][cols];
         for(int i = 0; i< rows; i++){
            for(int j = 0; j< cols; j++){
               grid[i][j] = ".";
            }
            
         }
          System.out.println(Arrays.toString(grid));
         
         int p = 0;
        while (p < mines) {
            int x = Math.abs((int) ((Math.random() * cols)));
            int y = Math.abs((int) ((Math.random() * rows)));
            if (!grid[y][x].equals("*")){
                grid[y][x] = "*";
                System.out.println(y + " + " + x);
                p++;
            }

        }
        System.out.println(grid);
        return grid;
      }
      
   
   
   public static void output(String[] list) {
      BufferedWriter bw = null;
      try {
         bw = new BufferedWriter(new FileWriter(new File("C-small-output.in")));
         
      }catch(IOException e){
         e.printStackTrace();
      }
      if(bw!= null){
   
   
   System.out.println("Output flowing");//for tracing
   // build a string for each case
   for (int i = 0; i < list.length; i++) {
      String sb = "";

      sb += "Case #" + (i + 1) + ":\n" + list[i];
     
      //System.out.println(sb);
      try{
         bw.write(sb);
         bw.newLine();
      }catch(IOException e){
         e.printStackTrace();
      }
      
   }
   try{
         
         bw.close();
      }catch(IOException e){
         e.printStackTrace();
      }

  
   
  }
  }
  
  public static void solve(String[][] grid, int i,int j){
   int rows = grid.length; int cols = grid[0].length;
      if(getMinesAround(grid, i, j) > 0){
         String x = getMinesAround(grid, i ,j) + "";
         grid[i][j] = x;
      }else if(getMinesAround(grid, i, j) == 0){
         grid[i][j] = "0";
         if(i-1>=0 && grid[i-1][j]==".")
            solve(grid, i-1, j);
         if(i-1>=0 && j-1>=0 && grid[i-1][j-1]==".")
            solve(grid,i-1, j-1);
         if(i+1<rows && j+1<cols && grid[i+1][j+1]=="." )
            solve(grid,i+1,j+1);
         if(i-1>=0 && j+1< cols && grid[i-1][j+1]==".")
            solve(grid,i-1,j+1);
         if(i+1<rows && j+1<cols && grid[i+1][j+1]==".")
            solve(grid,i+1,j+1);
         
         if(i+1< rows && grid[i+1][j]==".")
            solve(grid, i+1, j);
         
         if(i+1<rows && j-1>=0 && grid[i+1][j-1]==".")
            solve(grid, i+1, j-1);
         if(j+1<cols && grid[i][j+1]==".")
            solve(grid, i,j+1);
            
         if(j-1>=0 && grid[i][j-1]==".")
            solve(grid, i, j-1);
      }
  }
  public static boolean checkWin(String[][] grid){
      for(int i = 0; i< grid.length; i++){
            for(int j = 0; j< grid[0].length; j++){
               if(grid[i][j].equals("."))
                  return false;
            }
       }
       return true;

  }
  
  public static int getMinesAround(String[][] grid, int i,int j){
      int noOfMines = 0;
      int cols = grid[0].length;
      int rows = grid.length;
      if(i-1>=0 && grid[i-1][j].equals("*")){
         noOfMines++;
      }
      if(i-1>=0 && j-1>=0 &&grid[i-1][j-1].equals("*")){
         noOfMines++;
      }
      if(i-1>=0 && j+1<cols && grid[i-1][j+1].equals("*")){
         noOfMines++;
      }
      
      if(i+1<rows && j+1<cols && grid[i+1][j+1].equals("*")){
         noOfMines++;
      }
      if(i+1< rows &&  grid[i+1][j].equals("*")){
         noOfMines++;
      }
      if(i+1<rows && j-1>=0 && grid[i+1][j-1].equals("*")){
         noOfMines++;
      }
      if(j+1<cols && grid[i][j+1].equals("*")){
         noOfMines++;
      }
      if( j-1>=0 && grid[i][j-1].equals("*")){
         noOfMines++;
      }







    
        return noOfMines;
  }

}