package codejam;

import java.io.*;
import java.math.BigInteger;
import java.util.Scanner;

/**
 * Created by evgen on 09.04.2016.
 */
public class CoinJam {



    final static String PROBLEM_NAME = "coin";
    final static String WORK_DIR = "C:\\Users\\evgen\\Desktop\\" + PROBLEM_NAME + "\\";
    final static String INPUT_FILE_NAME = "input.txt";
    final static String OUTPUT_FILE_NAME = "output.txt";
    public static final String OUT_FORMATTER = "Case #%d:\n%s";

    String solve(Scanner in, PrintWriter pw) {
        int N = in.nextInt();
        int J = in.nextInt();
        StringBuilder sb1 = new StringBuilder();
        StringBuilder sb2 = new StringBuilder();
        StringBuilder res = new StringBuilder();
        sb1.append(1);
        sb2.append(1);
        for(int i = 0; i < N - 2; i++) {
            sb1.append(0);
            sb2.append(1);
        }
        sb1.append(1);
        sb2.append(1);
        long START = Long.parseLong(sb1.toString(), 2);
        long END = Long.parseLong(sb2.toString(), 2);
        int total = 0;
        for(long i = START; i <= END; i+=2) {
            if (isPrime(i)) {
                continue;
            }
            String s = Long.toBinaryString(i);
            boolean isFound = true;
            for(int l = 3; l <= 10; l++) {
                BigInteger b = new BigInteger(s, l);
                if (b.isProbablePrime(100000)) {
                    isFound = false;
                    break;
                }
            }
            if (isFound) {
                res.append(s);
                total++;

                for(int l = 2; l <= 10; l++) {
                    BigInteger b = new BigInteger(s, l);
                    BigInteger t = BigInteger.valueOf(2);
                    while (!b.remainder(t).equals(BigInteger.ZERO)) {
                        t = t.add(BigInteger.ONE);
                    }
                    res.append(' ').append(t.toString());
                }


                res.append("\n");
            }

            if (total == J) {
                break;
            }
        }

        return res.toString();
    }
    private boolean isPrime(long l) {
        if (l == 1) {
            return true;
        }
        if (l % 2 == 0) {
            return false;
        }

        for (long i = 3; i < Math.sqrt(l) + 1; i += 2) {
            if (l % i == 0) {
                return false;
            }
        }
        return true;
    }


    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new FileReader(WORK_DIR + INPUT_FILE_NAME));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR+ OUTPUT_FILE_NAME));
//        Scanner sc = new Scanner(new StringReader("1\n" +
//                "6 3"));
//        PrintWriter pw = new PrintWriter(System.out);
        int caseCnt = sc.nextInt();
        CoinJam coinJam = new CoinJam();
        for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
            System.out.println("Processing test case " + (caseNum + 1));
            pw.println(String.format(OUT_FORMATTER, (caseNum + 1), coinJam.solve(sc, pw)));
        }
        pw.flush();
        pw.close();
        sc.close();
    }
}
