package codejam;

import java.io.*;
import java.util.Scanner;

/**
 * Created by evgen on 09.04.2016.
 */
public class CountingSheep {

    final static String PROBLEM_NAME = "sheep";
    final static String WORK_DIR = "C:\\Users\\evgen\\Desktop\\" + PROBLEM_NAME + "\\";
    final static String INPUT_FILE_NAME = "input.txt";
    final static String OUTPUT_FILE_NAME = "output.txt";


    public static final String INSOMNIA = "INSOMNIA";
    public static final String OUT_FORMATTER = "Case #%d: %s";


    String solve(Scanner in, PrintWriter pw) {
        long N = in.nextLong();
        if (N == 0) {
            return INSOMNIA;
        }
        boolean[] digit = new boolean[10];
        int dig = 0;
        for (long n = 1; n < 100000000000L; n++) {
            long r = n * N;
            long cur = r;
            while (cur != 0) {
                int b = (int) (cur % 10);
                cur /= 10;
                if (!digit[b]) {
                    digit[b] = true;
                    dig++;
                }
            }
            if (dig == 10) {
                return Long.toString(r);
            }
        }
        return INSOMNIA;
    }

    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new FileReader(WORK_DIR + INPUT_FILE_NAME));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR
                + OUTPUT_FILE_NAME));
        int caseCnt = sc.nextInt();
        CountingSheep countingSheep = new CountingSheep();
        for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
            System.out.println("Processing test case " + (caseNum + 1));
            pw.println(String.format(OUT_FORMATTER, (caseNum + 1), countingSheep.solve(sc, pw)));
        }
        pw.flush();
        pw.close();
        sc.close();
    }
}
