package codejam;

import java.io.IOException;
import java.io.InputStream;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.StandardOpenOption;
import java.util.Arrays;
import java.util.Scanner;
import java.util.TreeSet;

public class InfiniteHouseOfPancakes {
    
    private static boolean debug = false;
    private static StringBuilder sb = new StringBuilder();

    public static void main(String[] args) throws IOException {
        String fileNameToLoad = "/home/culvert/Downloads/B-small-attempt0.in";
        Scanner in = new Scanner(getInputStream(fileNameToLoad));
        int T = in.nextInt();
        for (int t = 0; t < T; t++) {
            writeTestCase(t + 1);
            int D = in.nextInt();
            int[] dinners = new int[D];
            TreeSet<Integer> set = new TreeSet<>();
            for (int i = 0; i < D; i++) {
                int cakes = in.nextInt();
                set.add(cakes);
                dinners[i] = cakes;
            }
            Arrays.sort(dinners);
            
            int maxRes = dinners[dinners.length - 1]; // max of pancakes
            int res = maxRes;
            
            for (int div = 2; div < res; div++) {
                int posRes = 0;
                for (int dinner : dinners) {
                    posRes += (dinner - 1) / div;
                }
                res = Math.min(res, posRes + div);
            }
            sb.append(res).append('\n');
        }
        
        writeResult();
    }
    
    private static void writeResult() throws IOException {
        System.out.println(sb.toString());
        Path path1 = FileSystems.getDefault().getPath("codejam2a.txt");
        Files.write(path1, sb.toString().getBytes(), StandardOpenOption.CREATE);//create new, over
    }

    private static void writeTestCase(int t) {
        sb.append("Case #").append(t).append(": ");
    }

    private static InputStream getInputStream(String fileName) throws IOException {
        if (debug) {
            return System.in;
        } else {
            Path path = FileSystems.getDefault().getPath(fileName);
            return Files.newInputStream(path);
        }
    } 
    
}
