package codejam;

import java.io.*;
import java.util.Scanner;

/**
 * Created by evgen on 09.04.2016.
 */
public class Pancakes {

    final static String PROBLEM_NAME = "pancakes";
    final static String WORK_DIR = "C:\\Users\\evgen\\Desktop\\" + PROBLEM_NAME + "\\";
    final static String INPUT_FILE_NAME = "B-large.in";
    final static String OUTPUT_FILE_NAME = "output.txt";


    public static final String OUT_FORMATTER = "Case #%d: %s";


    String solve(Scanner in, PrintWriter pw) {
        String inp = in.next();
        int size = inp.length();
        boolean[] stack = new boolean[inp.length()];
        for (int i = 0; i < inp.length(); i++) {
            stack[i] = '+' == inp.charAt(i);
        }
        int res = 0;
        for (int i = size - 1; i >= 0; i--) {
            if (stack[i]) {
                continue;
            }
            if (stack[0]) {
                for (int k = 0; k <= i; k++) {
                    if (!stack[k]) {
                        flip(stack, k - 1);
                        res++;
                        break;
                    }
                }
            }
            res++;
            flip(stack, i);
        }
        return Integer.toString(res);
    }

    private void flip(boolean[] stack, int m) {
        int i = 0;
        int j = m;
        while (i <= j) {
            if (i == j) {
                stack[i] = !stack[i];
                break;
            }
            boolean tmp = stack[i];
            stack[i] = !stack[j];
            stack[j] = !tmp;

            i++;
            j--;
        }
    }

    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new FileReader(WORK_DIR + INPUT_FILE_NAME));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR+ OUTPUT_FILE_NAME));
//        Scanner sc = new Scanner(new StringReader("1\n+-"));
//        PrintWriter pw = new PrintWriter(System.out);
        int caseCnt = sc.nextInt();
        Pancakes pancakes = new Pancakes();
        for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
            System.out.println("Processing test case " + (caseNum + 1));
            pw.println(String.format(OUT_FORMATTER, (caseNum + 1), pancakes.solve(sc, pw)));
        }
        pw.flush();
        pw.close();
        sc.close();
    }

}
