import java.io.*;
import java.util.ArrayList;
import java.util.HashSet;
import java.math.BigInteger;

/**
 * @author mondodello
 */
public class GCJ_JamCode_Large {

    public static BigInteger calcGCDWrapper(ArrayList<BigInteger> numbers) {
        int len = numbers.size();
        BigInteger gcd = numbers.get(0);

        if (len == 1) {
            return gcd;
        }

        for (int i = 0; i < len; i++) {
            BigInteger number = numbers.get(i);
            gcd = calcGCD(gcd, number);
        }
        return gcd;
    }

    public static BigInteger calcGCD(BigInteger x, BigInteger y) {
        while (!(y.compareTo(BigInteger.ZERO)==0)) {
            BigInteger temp = y;
            y = x.remainder(y);
            x = temp;
        }
        return x;
    }

    public static BigInteger calcMin(HashSet<BigInteger> dataSet) {

        BigInteger[] numbers = new BigInteger[dataSet.size()];
        dataSet.toArray(numbers);

        BigInteger minSoFar = numbers[0];

        int len = numbers.length;
        for (int i = 0; i < len; i++) {
            BigInteger currNum = numbers[i];


            if (minSoFar.compareTo(currNum) == 1) {
                minSoFar = currNum;
            }
        }
        return minSoFar;
    }

    public static void main(String[] args) throws IOException {
//        String inputFileName = "C:\\GCJ\\B-small.in";
//        String outputFileName = "C:\\GCJ\\B-small.out_2";

//        String inputFileName = "C:\\GCJ\\test.in";
//        String outputFileName = "C:\\GCJ\\test.out";

        String inputFileName = "C:\\GCJ\\B-small.in";
        String outputFileName = "C:\\GCJ\\B-small.out";

        //Setting up the I/O streams
        BufferedReader br = new BufferedReader(new FileReader(inputFileName));
        PrintWriter pw = new PrintWriter(new FileWriter(outputFileName));

        int numOfTestCases = Integer.parseInt(br.readLine());

        for (int i = 0; i < numOfTestCases; i++) {
            String temp[] = br.readLine().split(" ");

            int numOfEvents = Integer.parseInt(temp[0]);

            HashSet<BigInteger> listOfEventsTimeStamps = new HashSet<BigInteger>();
            ArrayList<BigInteger> listOfEventsTimesDiff = new ArrayList<BigInteger>();


            for (int j = 1; j <= numOfEvents; j++) {
                BigInteger currItem = new BigInteger(temp[j]);
                listOfEventsTimeStamps.add(currItem);
            }

            int numOfDistinctEvents = listOfEventsTimeStamps.size();
            BigInteger[] listOfEventsTimes = new BigInteger[numOfDistinctEvents];
            listOfEventsTimeStamps.toArray(listOfEventsTimes);

            BigInteger minTime = BigInteger.ZERO;
            BigInteger maxGCD = BigInteger.ZERO;

            if (numOfDistinctEvents > 2) {
                for (int j = 1; j < numOfDistinctEvents; j++) {
                    BigInteger prevItem = listOfEventsTimes[j - 1];
                    BigInteger currItem = listOfEventsTimes[j];
                    listOfEventsTimesDiff.add(currItem.subtract(prevItem).abs());
                }

                listOfEventsTimesDiff.add(listOfEventsTimes[0].subtract(listOfEventsTimes[numOfDistinctEvents - 1]).abs());

                minTime = calcMin(listOfEventsTimeStamps);
                maxGCD = calcGCDWrapper(listOfEventsTimesDiff);
            } else {
                if (numOfDistinctEvents == 2) {
                    minTime = calcMin(listOfEventsTimeStamps);

                    BigInteger num1 = listOfEventsTimes[0];
                    BigInteger num2 = listOfEventsTimes[1];

/*
                    if( ((num1 > num2) && ((num1%num2)==0)) || ((num2 > num1) && ((num2%num1)==0))){
                        maxGCD = calcGCD(num2, num1);
                    } else {
                        maxGCD = Math.abs(num1-num2);
                    }
*/

                    maxGCD = calcGCD(num2, num1);
                    BigInteger diffBetweenTheNumbers = num1.subtract(num2).abs();

                    if (maxGCD.compareTo(BigInteger.ONE)!=0) {
                        if (maxGCD == diffBetweenTheNumbers) {
                            pw.println("Case #" + (i + 1) + ": " + 0);
                            continue;
                        } else {
                            maxGCD = diffBetweenTheNumbers;
                        }
                    } else {
                        maxGCD = diffBetweenTheNumbers;
                    }

                } else if (numOfDistinctEvents == 1) {
                    pw.println("Case #" + (i + 1) + ": " + 0);
                    continue;
                }
            }


            if ((maxGCD.compareTo(BigInteger.ZERO) == 0) || (maxGCD.compareTo(BigInteger.ONE) == 0)) {
                pw.println("Case #" + (i + 1) + ": " + 0);
                continue;
            }

            BigInteger minMod = minTime.mod(maxGCD);

            BigInteger y = BigInteger.ZERO;
            if (minTime.compareTo(maxGCD) == -1) {     // minTime < maxGCD
                y = maxGCD.subtract(minTime);
            } else if (minTime.compareTo(maxGCD) == 1) {             // minTime > maxGCD
                y = maxGCD.subtract(minMod);
            }
            pw.println("Case #" + (i + 1) + ": " + y);
        }

        br.close();
        pw.close();
    }
}
