/**
 *  @author mondodello
 *
 */

import java.io.*;
import java.util.ArrayList;

public class GCJ_Round1_Prog1 {

    static void rotate(int N, String[] matrix) {

        for (int i = 0; i < N; i++) {
            matrix[i] = gravitize(N, matrix[i]);
        }

        char[][] newMatrix = new char[N][N];

        for (int i = (N - 1), j = 0; (i >= 0) && (j < N); i--, j++) {
            String currRow = matrix[i];
            for (int k = 0; k < N; k++) {
                newMatrix[k][j] = currRow.charAt(k);
            }
        }

        for (int i = 0; i < N; i++) {
            StringBuffer s = new StringBuffer();
            for (int j = 0; j < N; j++) {
                s.append(newMatrix[i][j]);
            }
            matrix[i] = s.toString();
        }
    }

    static String gravitize(int N, String column) {

        int dotCount = 0;

        ArrayList<Character> contents = new ArrayList<Character>();

        for (int i = 0; i < N; i++) {
            char currChar = column.charAt(i);
            if (currChar == '.') {
                dotCount++;
            } else {
                contents.add(currChar);
            }
        }

        StringBuffer tempStr = new StringBuffer(N);

        for (int i = 0; i < dotCount; i++) {
            tempStr.append('.');
        }

        for (int i = 0; i < (N - dotCount); i++) {
            tempStr.append(contents.get(i));
        }

        return tempStr.toString();
    }

    static boolean searchRows(String[] matrix, char searchChar, int N, int K) {
        boolean searchKeyFound = false;
        for (int i = 0; i < N && !searchKeyFound; i++) {
            String currStr = matrix[i];
            searchKeyFound = searchInString(currStr, searchChar, K);
        }
        return searchKeyFound;
    }


    static boolean searchColumns(String[] matrix, char searchChar, int N, int K) {
        boolean searchKeyFound = false;

        char[][] newMatrix = new char[N][N];
        for (int i = 0; i < N; i++) {
            newMatrix[i] = matrix[i].toCharArray();
        }

        for (int i = 0; i < N && !searchKeyFound; i++) {
            StringBuffer currCol = new StringBuffer();
            for (int j = 0; j < N; j++) {
                currCol.append(newMatrix[j][i]);
            }
            searchKeyFound = searchInString(currCol.toString(), searchChar, K);
        }
        return searchKeyFound;
    }


    static boolean searchLRDiagonals(String[] matrix, char searchChar, int N, int K) {
        boolean searchKeyFound = false;

        char[][] newMatrix = new char[N][N];
        for (int i = 0; i < N; i++) {
            newMatrix[i] = matrix[i].toCharArray();
        }

        for (int currColIndex = 0; (currColIndex < N) && !searchKeyFound; currColIndex++) {
            StringBuffer currDiagonal = new StringBuffer();

            int rowIndex = 0;
            int colIndex = currColIndex;
            while ((rowIndex < N) && (colIndex < N)) {
                System.out.println("rowIndex = " + rowIndex + ", collIndex = " + colIndex);
                currDiagonal.append(newMatrix[rowIndex][colIndex]);
                colIndex++;
                rowIndex++;
            }
            searchKeyFound = searchInString(currDiagonal.toString(), searchChar, K);
            System.out.println("searchKeyFound = " + searchKeyFound);
        }


        for (int currRowIndex = 0; (currRowIndex <= (N - K)) && !searchKeyFound; currRowIndex++) {

            StringBuffer currDiagonal = new StringBuffer();

            int rowIndex = currRowIndex;
            int colIndex = 0;
            while ((colIndex < N) && (rowIndex < N)) {
                currDiagonal.append(newMatrix[rowIndex][colIndex]);
                colIndex++;
                rowIndex++;
            }
            searchKeyFound = searchInString(currDiagonal.toString(), searchChar, K);
        }

        return searchKeyFound;
    }


    static boolean searchRLDiagonals(String[] matrix, char searchChar, int N, int K) {
        boolean searchKeyFound = false;

        char[][] newMatrix = new char[N][N];
        for (int i = 0; i < N; i++) {
            newMatrix[i] = matrix[i].toCharArray();
        }

        for (int currColIndex = K - 1; (currColIndex < N) && !searchKeyFound; currColIndex++) {
            StringBuffer currDiagonal = new StringBuffer();

            int rowIndex = 0;
            int colIndex = currColIndex;
            while ((colIndex >= 0) && (rowIndex < N)) {
                currDiagonal.append(newMatrix[rowIndex][colIndex]);
                rowIndex++;
                colIndex--;
            }
            searchKeyFound = searchInString(currDiagonal.toString(), searchChar, K);
        }

        for (int currColIndex = N - K; (currColIndex > 1) && !searchKeyFound; currColIndex--) {
            StringBuffer currDiagonal = new StringBuffer();

            int rowIndex = 0;
            int colIndex = currColIndex;
            while ((colIndex < N) && (rowIndex >= 0)) {
                currDiagonal.append(newMatrix[rowIndex][colIndex]);
                rowIndex--;
                colIndex++;
            }
            searchKeyFound = searchInString(currDiagonal.toString(), searchChar, K);
        }

        return searchKeyFound;
    }

    static boolean searchInString(String s, char searchChar, int K) {
        StringBuffer searchKey = new StringBuffer(K);

        for (int i = 0; i < K; i++) {
            searchKey.append(searchChar);
        }

        return (s.indexOf(searchKey.toString()) != -1);
    }

    public static void main(String[] args) throws IOException {

        // Setting up the I/O streams
        BufferedReader br = new BufferedReader(new FileReader("C:\\GCJ\\A-small.in"));
        PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter("C:\\GCJ\\A-small.out")));

        int numOfTestCases = Integer.parseInt(br.readLine());

        for (int i = 0; i < numOfTestCases; i++) {
            String temp[] = br.readLine().split(" ");

            int N = Integer.parseInt(temp[0]);
            int K = Integer.parseInt(temp[1]);

            String[] matrix = new String[N];

            for (int j = 0; j < N; j++) {
                matrix[j] = br.readLine();
            }

            rotate(N, matrix);

            boolean charRFoundInRows, charBFoundInRows, charRFoundInCols, charBFoundInCols,
                    charRFoundInLRDia, charRFoundInRLDia, charBFoundInLRDia, charBFoundInRLDia;

            charRFoundInRows = searchRows(matrix, 'R', N, K);
            System.out.println("charRFoundInRows = " + charRFoundInRows);

            charBFoundInRows = searchRows(matrix, 'B', N, K);
            System.out.println("charBFoundInRows = " + charBFoundInRows);

            charRFoundInCols = searchColumns(matrix, 'R', N, K);
            System.out.println("charRFoundInCols = " + charRFoundInCols);

            charBFoundInCols = searchColumns(matrix, 'B', N, K);
            System.out.println("charBFoundInCols = " + charBFoundInCols);

            charRFoundInLRDia = searchLRDiagonals(matrix, 'R', N, K);
            System.out.println("charRFoundInLRDia = " + charRFoundInLRDia);

            charBFoundInLRDia = searchLRDiagonals(matrix, 'B', N, K);
            System.out.println("charBFoundInLRDia = " + charBFoundInLRDia);

            charRFoundInRLDia = searchRLDiagonals(matrix, 'R', N, K);
            System.out.println("charRFoundInRLDia = " + charRFoundInRLDia);

            charBFoundInRLDia = searchRLDiagonals(matrix, 'B', N, K);
            System.out.println("charBFoundInRLDia = " + charBFoundInRLDia);

            boolean isRedThere = charRFoundInRows || charRFoundInCols || charRFoundInLRDia || charRFoundInRLDia;
            boolean isBlueThere = charBFoundInRows || charBFoundInCols || charBFoundInLRDia || charBFoundInRLDia;

            if (isRedThere && isBlueThere) {
                pw.println("Case #" + (i + 1) + ": Both");
            } else if (isRedThere) {
                pw.println("Case #" + (i + 1) + ": Red");
            } else if (isBlueThere) {
                pw.println("Case #" + (i + 1) + ": Blue");
            } else {
                pw.println("Case #" + (i + 1) + ": Neither");
            }
        }

        // Closing the I/O streams
        br.close();
        pw.close();
    }
}
