package com.cur10us;

import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class Main {

    public static void main(String[] args) throws IOException {
        final BufferedReader br = new BufferedReader(new FileReader(new File("Problem-1.txt")));
        final PrintWriter pw = new PrintWriter(new File("Problem-1-OUT.txt"));

        int numOfTestCases = Integer.parseInt(br.readLine());

        for (int i = 0 ; i < numOfTestCases ; i++) {
            final String currentLine = br.readLine();
            final String[] temp = currentLine.split(" ");

            int n = Integer.parseInt(temp[0]);
            final String dataString = temp[1];

            List<Integer> shynessData = new ArrayList<Integer>(n);

            for (int j = 0 ; j < n+1; j++) {
                shynessData.add(dataString.charAt(j) - '0');
            }

            int solution = solveTestCase(n+1, shynessData);

            pw.println(String.format("Case #%d: %d", (i + 1), solution));
        }

        br.close();
        pw.close();
    }

    private static int solveTestCase(int nShynessLevels, final List<Integer> nAudienceAvailablePerShyness) {
        int reqNumOfAdditionalGuestsSoFar = 0;

        final List<Integer> cNAvailableAudiencePerShyness = new ArrayList<Integer>(Collections.nCopies(nShynessLevels, 0));

        // cNAvailableAudiencePerShyness(i) = cNAvailableAudiencePerShyness(i-1) + S(s-1);
        for (int i = 1 ; i < nShynessLevels ; i++) {
            cNAvailableAudiencePerShyness.set(i,
                    cNAvailableAudiencePerShyness.get(i - 1) + nAudienceAvailablePerShyness.get(i - 1));
        }

        for (int shynessLevel = nShynessLevels-1 ; shynessLevel >= 1 ; shynessLevel--) {

            Integer availableAudienceMembersForThisShynessLevel = cNAvailableAudiencePerShyness.get(shynessLevel);
            availableAudienceMembersForThisShynessLevel += reqNumOfAdditionalGuestsSoFar;
            if (availableAudienceMembersForThisShynessLevel < shynessLevel) {
                int deficit = (shynessLevel - availableAudienceMembersForThisShynessLevel);
                reqNumOfAdditionalGuestsSoFar += deficit;
            }
        }

        return reqNumOfAdditionalGuestsSoFar;
    }
}
