import java.io.*;
import java.util.BitSet;
import java.util.HashMap;
import java.util.Set;

/**
 * @author mondodello
 */

public class GCJ_Round1C_First {

    public static void main(String[] args) throws IOException {
        //Setting up the streams
        BufferedReader br = new BufferedReader(new FileReader("C:\\GCJ\\A-small.in"));
        PrintWriter pw = new PrintWriter(new FileWriter("C:\\GCJ\\A-small.out"));


        int numOfTestCases = Integer.parseInt(br.readLine());

        // Logic for processing each individual test case
        for (int i = 0; i < numOfTestCases; i++) {

            int numOfWindows = Integer.parseInt(br.readLine());

            BitSet leftEndPoints = new BitSet(numOfWindows + 1);
            BitSet rightEndPoints = new BitSet(numOfWindows + 1);
            HashMap<Integer, Integer> R_to_L_Map = new HashMap<Integer, Integer>(numOfWindows);

            for (int j = 0; j < numOfWindows; j++) {
                String[] temp = br.readLine().split(" ");

                int leftEndPoint = Integer.parseInt(temp[0]);
                leftEndPoints.set(leftEndPoint);
                int rightEndPoint = Integer.parseInt(temp[1]);
                rightEndPoints.set(rightEndPoint);

                R_to_L_Map.put(rightEndPoint, leftEndPoint);
            }

/*
            if(numOfWindows == 1) {
                pw.println("Case #" + (i+1) + ": " + 0);
                continue;
            }
*/

            int len = rightEndPoints.cardinality();

            int currRightEndPoint = -1;
            int numOfIntersections = 0;

            for (int j = 0; j < len; j++) {
                currRightEndPoint = rightEndPoints.nextSetBit(currRightEndPoint + 1);

                int currLeftEndPoint = R_to_L_Map.get(currRightEndPoint);

                R_to_L_Map.remove(currRightEndPoint);

                Set<Integer> rightEndPointSet = R_to_L_Map.keySet();

                int rightSideSize = rightEndPointSet.size();
                Integer[] rightEndPointList = new Integer[rightSideSize];
                rightEndPointSet.toArray(rightEndPointList);

                for (int k = 0; k < rightSideSize; k++) {
                    int tempRightPt = rightEndPointList[k];
                    int tempLeftPt = R_to_L_Map.get(tempRightPt);

                    if (((tempLeftPt < currLeftEndPoint) && (tempRightPt > currRightEndPoint)) || ((tempLeftPt > currLeftEndPoint) && (tempRightPt < currRightEndPoint)))
                    {
                        numOfIntersections++;
                    }
                }
            }
            pw.println("Case #" + (i + 1) + ": " + numOfIntersections);

        }

        //Closing the streams
        br.close();
        pw.close();
    }
}
