import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class CoinJam {
    private static Map<String, List<Integer>> ALL_COIN_JAMS = new HashMap<>();

    public static void main(String[] args) throws FileNotFoundException {
        PrintWriter pw = new PrintWriter(new File("/WorkingFolder/Code/Java/C.out"));

        int N = 16;
        int J = 50;

        int numOfUndecidedBits = N - 2;

        int numOfRows = (int) Math.pow(2, numOfUndecidedBits);

        for (int i = 0; i < numOfRows; i++) {

            StringBuilder sb = new StringBuilder("1");

            for (int j = 0; j < numOfUndecidedBits; j++) {
                int val = numOfRows * j + i;
                int ret = (1 & (val >>> j));

                boolean bit = ret != 0;

                sb.append(bit ? "1" : "0");

            }
            sb.append("1");

            process(sb.toString());

            if (ALL_COIN_JAMS.size() == J) {
                break;
            }
        }

        printSolution(pw);

        pw.close();
    }

    private static void printSolution(PrintWriter pw) {
        System.out.println("Case #1:");
        pw.println("Case #1:");

        for (Map.Entry<String, List<Integer>> entry : ALL_COIN_JAMS.entrySet()) {
            System.out.print(entry.getKey());
            pw.print(entry.getKey());

            for (Integer n : entry.getValue()) {
                System.out.print(" " + n);
                pw.print(" " + n);
            }
            System.out.println();
            pw.println();
        }
    }

    private static void process(String binaryString) {
        List<Integer> setOfDivisors = new ArrayList<>();
        for (int base = 2; base <= 10; base++) {

            long candidate = Long.parseLong(binaryString, base);

            int i = 2;
            long j = (long) Math.sqrt(candidate);

            while (i < j) {
                if (candidate % i == 0) {
                    setOfDivisors.add(i);
                    break;
                }
                i++;
            }
        }

        if (setOfDivisors.size() == 9) {
            ALL_COIN_JAMS.put(binaryString, setOfDivisors);
        }
    }
}
