import java.io.*;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by <code>mondodello</code>.
 * <p/>
 * Powered by <tt>IntelliJ IDEA Community Edition</tt>.
 */

public class GCJ_2011_Qualifying_Magicka {

    public static void main(String[] args) throws IOException {
        String inputFile = "C:\\MyFOLDERS\\Programming\\GoogleCodeJam\\magicka-in.txt";
        String outputFile = "C:\\MyFOLDERS\\Programming\\GoogleCodeJam\\magicka-out.txt";

        BufferedReader br = new BufferedReader(new FileReader(inputFile));
        PrintWriter pw = new PrintWriter(new FileWriter(outputFile));

        String s = br.readLine();

        int numOfTestCases = Integer.parseInt(s);

        for (int t = 0; t < numOfTestCases; t++) {

            // process each test case for C, D, Invocation string
            String[] temp = br.readLine().split(" ");

            int C = Integer.parseInt(temp[0]);

            Map<String, String> combinations = new HashMap<String, String>(2 * C);
            for (int i = 1; i <= C; i++) {
                String currCombination = temp[i];

                StringBuffer combPair = new StringBuffer(currCombination.substring(0, 2));
                String target = currCombination.substring(2);

                combinations.put(combPair.toString(), target);
                combinations.put(combPair.reverse().toString(), target);
            }

            int D = Integer.parseInt(temp[C + 1]);
            int beginIdxD = C + 2;
            int endIdxD = (beginIdxD+D-1);

            Map<String, String> oppositions = new HashMap<String, String>(2 * D);
            for (int i = beginIdxD; i <= endIdxD; i++) {
                String currOpposition = temp[i];

                String char1 = currOpposition.substring(0,1);
                String char2 = currOpposition.substring(1);

                oppositions.put(char1, char2);
                oppositions.put(char2, char1);
            }

            int N = Integer.parseInt(temp[endIdxD + 1]);
            String invocationSeq = temp[endIdxD + 2];

            StringBuffer invocationBuffer = new StringBuffer(" ");
            for (int i = 0; i < N; i++) {
                char currChar = invocationSeq.charAt(i);

                String combTarget = combinations.get(invocationBuffer.substring(invocationBuffer.length() - 1) + currChar);
                String oppTarget = oppositions.get(String.valueOf(currChar));

                if (combTarget != null) {
                    invocationBuffer.setCharAt(invocationBuffer.length() - 1, combTarget.charAt(0));
                } else if (oppTarget!=null && invocationBuffer.indexOf(oppTarget) != -1) {
                    invocationBuffer.setLength(1);
                } else {
                    invocationBuffer.append(currChar);
                }
            }

            // print the result in the required format
            int len = invocationBuffer.length();
            System.out.print("Case #" + (t+1) + ": [");
            pw.print("Case #" + (t+1) + ": [");
            if (len > 1) {
                for (int i = 1; i < len; i++) {
                    System.out.print(invocationBuffer.charAt(i) + (i == (len - 1) ? "]" : ", "));
                    pw.print(invocationBuffer.charAt(i) + (i == (len - 1) ? "]" : ", "));
                }
            } else {
                System.out.print("]");
                pw.print("]");
            }
            System.out.println("");
            pw.println("");
        }

        br.close();
        pw.close();

        System.exit(0);
    }
}