package curdled.standing_ovation;

import curdled.common.FileReader;
import curdled.common.FileWriter;
import curdled.common.ResponseCreator;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

/**
 * Created by Joe on 11/04/2015.
 */
public class Main {
    public static String inToOut(String pathName){
        String[] str = pathName.split("\\.");
        StringBuilder b = new StringBuilder();
        for (String s : str){
            if(!s.equals("in")) {
                b.append(s);
                b.append(".");
            }

        }
        b.append("out");
        return b.toString();
    }

    public static void writeStringToFile(String pathName, String value) throws FileNotFoundException {
        PrintWriter writer = new PrintWriter(pathName);
        writer.print(value);
        writer.close();
    }

    public static void run(String fileName) throws IOException {
        ResponseCreator res = new ResponseCreator();
        FileReader r = new FileReader(fileName);
        List<String> problem = r.getProblem();
        for (int i = 0; i != r.getProbelmSize(); i++) {
            res.append(solve(problem.get(i )));
        }
        writeStringToFile(inToOut(fileName), res.toString());
    }

    public static String solve(String problem){
        String[] str = problem.split(" ");
        int peopleNeeded  = 0;
        int potential = 0;
        for (char s : str[1].toCharArray()){
            potential += Character.getNumericValue(s);
            if(potential == 0)
                peopleNeeded++;
            else{
                potential--;
            }
        }
        return Integer.toString(peopleNeeded);
    }

    public static void main(String[] args){
        try {
            run("A-small-attempt0.in");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
