import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.MathContext;
import java.math.RoundingMode;





public class CookieClicker {

	
	public static void main(String[] args) {
		/*double l = 100.34567990;
        
        BigDecimal unScaledBD = BigDecimal.valueOf(l);
        BigDecimal scaledBD = BigDecimal.valueOf(l).setScale(6, RoundingMode.HALF_UP);
         
        //2 decimal places rounding with half up rounding mode
        System.out.println(unScaledBD.subtract(scaledBD).compareTo(new BigDecimal("0.000001")));
        System.out.println(new BigDecimal("-0.000001").compareTo(unScaledBD.subtract(scaledBD)));
        System.out.println(unScaledBD.subtract(scaledBD));
        System.out.println(BigDecimal.valueOf(3.599d).compareTo(BigDecimal.valueOf(3.599d)));*/
		
	/*	BigDecimal bd1 = new BigDecimal("526.1904761904761");
		BigDecimal bd2 = new BigDecimal("526.1904762");
		BigDecimal epsilon = new BigDecimal("1e-6");
		BigDecimal negEpsilon = epsilon.negate();
		//-epsilon <= x - y <= epsilon
		boolean isOK = ((negEpsilon.compareTo(bd1.subtract(bd2))<=0) && (epsilon.compareTo(bd1.subtract(bd2))>=0));
		System.out.println(isOK);
		System.out.println("Neg:"+(negEpsilon.compareTo(bd1.subtract(bd2))<=0));
		System.out.println("POS:"+(epsilon.compareTo(bd1.subtract(bd2))>=0));*/
		
		
		CookieClicker cookieClicker = new CookieClicker("B-large.in", "B-large.out");
		cookieClicker.clickCookies();
	}
	
	private InputReader inpReader = null;
	private OutPutWriter outWriter = null;
	
	public CookieClicker(String inputFileName, String outputFileName)
	{
		inpReader = new InputReader(inputFileName);
		outWriter = new OutPutWriter(outputFileName);
	}
	
	public void clickCookies()
	{
		CookieInputReaderIterator inputReaderIterator = new CookieInputReaderIterator(this.inpReader);
		while(inputReaderIterator.hasNext())
		{
			Input input = inputReaderIterator.getNext();
			BigDecimal elapsedTime = calculate(input);
			//outWriter.write(elapsedTime.setScale(7,RoundingMode.HALF_UP).toString());
			this.outWriter.write(elapsedTime.toString());
		}
	}
	
	public BigDecimal calculate(Input input)
	{
		BigDecimal elapsedTime = BigDecimal.valueOf(0.0d);
		BigDecimal currentRate = BigDecimal.valueOf(2.0d);
		
		MathContext mathContext = MathContext.DECIMAL64;
		
		if(input.X.compareTo(input.C)<=0)
		{
			elapsedTime = input.X.divide(currentRate,mathContext);
		}
		else
		{
			while(true)
			{
				elapsedTime = elapsedTime.add(input.C.divide(currentRate,mathContext),mathContext);
				BigDecimal t1 = input.X.subtract(input.C,mathContext).divide(currentRate,mathContext);
				BigDecimal t2 =input.X.divide(currentRate.add(input.F,mathContext),mathContext);
				if(t1.compareTo(t2)<=0)
				{
					elapsedTime = elapsedTime.add(t1,mathContext);
					break;
				}
				currentRate=currentRate.add(input.F,mathContext);
			}
		}
		return elapsedTime;
	}
	
	private static class Input
	{
		BigDecimal C;
		BigDecimal F;
		BigDecimal X;
	}
	
	
	private interface InputReaderIterator{
		public boolean hasNext();
		public Input getNext();
	}

	private class CookieInputReaderIterator  implements InputReaderIterator{
		int numberOfInputsRead = 0;
		InputReader inFileReader = null;
		public CookieInputReaderIterator(InputReader inFileReader)
		{
			this.inFileReader = inFileReader;
		}
		
		@Override
		public boolean hasNext() {
			return numberOfInputsRead < this.inFileReader.T;
		}
		
		@Override
		public Input getNext() {
			String[] inputStrings = this.inFileReader.readLine().split(" ");
			Input input = new Input();
			input.C = new BigDecimal(inputStrings[0]);
			input.F = new BigDecimal(inputStrings[1]);
			input.X = new BigDecimal(inputStrings[2]);
			this.numberOfInputsRead++;
			return input;
		}
	}
	
	private static class InputReader
	{
		BufferedReader inFileReader = null;
		int T = -1;
		
		public InputReader(String fileName)
		{
			try {
				inFileReader = new BufferedReader(new FileReader(fileName));
				try {
					T = Integer.parseInt(inFileReader.readLine());
				} catch (NumberFormatException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} 
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		public String readLine()
		{
			String inputLine = "";
			try {
				inputLine = this.inFileReader.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return inputLine;
		}
		
		public void shutDown()
		{
			if(inFileReader !=null)
			{
				try {
					inFileReader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		
		/*public InputReaderIterator iterator()
		{
			return ;
		}*/
	}

	private static class OutPutWriter
	{
		BufferedWriter outPutFileWriter = null;
		int currentOutPutNumber = 1;
		public OutPutWriter(String fileName)
		{
			try {
				outPutFileWriter = new BufferedWriter(new FileWriter(fileName));
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		public boolean write(String outputText)
		{
			boolean status = false;
			try {
				if(outPutFileWriter != null)
				{
					if(this.currentOutPutNumber>1)
					{
						outPutFileWriter.newLine();
					}
					outPutFileWriter.write("Case #"+this.currentOutPutNumber+": "+outputText);
					this.currentOutPutNumber++;
					//outPutFileWriter.newLine();
					outPutFileWriter.flush();
					status = true;
				}
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return status;
		}
		
		public void shutDown()
		{
			if(outPutFileWriter !=null)
			{
				try {
					outPutFileWriter.flush();
					outPutFileWriter.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}
	
	
}
