import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;


public class Magician {
public static void main(String[] args) {
	Magician magician = new Magician("C:\\important_contents\\Algos\\WS\\CodeJam2014\\A-small-attempt1.in", "C:\\important_contents\\Algos\\WS\\CodeJam2014\\A-small-attempt1.out");
	magician.doMagic();
}

private InputReader inpReader = null;
private OutPutWriter outWriter = null;

public Magician(String inputFileName, String outputFileName)
{
	inpReader = new InputReader(inputFileName);
	outWriter = new OutPutWriter(outputFileName);
}

public void doMagic()
{
	MagicInputReaderIterator inputReaderIterator = new MagicInputReaderIterator(inpReader);
	Set<Integer> elementsOfFirstSelectedRow = new HashSet<Integer>();
	while(inputReaderIterator.hasNext())
	{
		elementsOfFirstSelectedRow.clear();
		Input input = inputReaderIterator.getNext();
		int firstSelectedRow = input.volunteerSelectedRows[0];
		for(int j=0;j<input.cardLayOuts.get(0)[firstSelectedRow].length;j++)
		{
			elementsOfFirstSelectedRow.add(input.cardLayOuts.get(0)[firstSelectedRow][j]);
		}
		int secondSelectedRow = input.volunteerSelectedRows[1];
		int numberOfHits = 0;
		Integer hitEntry = null;
		for(int j=0;j<input.cardLayOuts.get(1)[secondSelectedRow].length;j++)
		{
			if(elementsOfFirstSelectedRow.contains(input.cardLayOuts.get(1)[secondSelectedRow][j]))
			{
				hitEntry = input.cardLayOuts.get(1)[secondSelectedRow][j];
				numberOfHits++;
			}
		}
		if(numberOfHits == 1)
		{
			this.outWriter.write(hitEntry.toString());
		}
		else if(numberOfHits > 1)
		{
			this.outWriter.write("Bad magician!");
		}
		else
		{
			this.outWriter.write("Volunteer cheated!");
		}
	}
	this.inpReader.shutDown();
	this.outWriter.shutDown();
}



private static class Input{
	private int[] volunteerSelectedRows = new int[2];
	private List<Integer[][]> cardLayOuts = new ArrayList<Integer[][]>();
	
	/*public Input(int[] volunteerSelectedRows,List<Integer[][]> cardLayOut){
		this.volunteerSelectedRows = volunteerSelectedRows;
		this.cardLayOuts = cardLayOuts;
	}*/
}

private interface InputReaderIterator{
	public boolean hasNext();
	public Input getNext();
}

private class MagicInputReaderIterator  implements InputReaderIterator{
	int numberOfInputsRead = 0;
	InputReader inFileReader = null;
	public MagicInputReaderIterator(InputReader inFileReader)
	{
		this.inFileReader = inFileReader;
	}
	
	@Override
	public boolean hasNext() {
		return numberOfInputsRead < this.inFileReader.T;
	}
	
	@Override
	public Input getNext() {
		Input input = new Input();
		for(int numberOfVolunteerInputs=0;numberOfVolunteerInputs<2;numberOfVolunteerInputs++)
		{
			int volunteerSelectedRow = Integer.parseInt(inFileReader.readLine()); 
			Integer[][] cardLayOut = new Integer[4][4];
			for(int i=0;i<4;i++)
			{
				
					String[] inNumbers = inFileReader.readLine().split(" ");
					for(int j=0;j<inNumbers.length;j++)
					{
						cardLayOut[i][j]=Integer.valueOf(inNumbers[j]);
					} 
				 
			}
			input.volunteerSelectedRows[numberOfVolunteerInputs] = volunteerSelectedRow-1;
			input.cardLayOuts.add(cardLayOut);
		}
		this.numberOfInputsRead++;
		return input;
	}
}

private static class InputReader
{
	BufferedReader inFileReader = null;
	int T = -1;
	
	public InputReader(String fileName)
	{
		try {
			inFileReader = new BufferedReader(new FileReader(fileName));
			try {
				T = Integer.parseInt(inFileReader.readLine());
			} catch (NumberFormatException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} 
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public String readLine()
	{
		String inputLine = "";
		try {
			inputLine = this.inFileReader.readLine();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return inputLine;
	}
	
	public void shutDown()
	{
		if(inFileReader !=null)
		{
			try {
				inFileReader.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	/*public InputReaderIterator iterator()
	{
		return ;
	}*/
}

private static class OutPutWriter
{
	BufferedWriter outPutFileWriter = null;
	int currentOutPutNumber = 1;
	public OutPutWriter(String fileName)
	{
		try {
			outPutFileWriter = new BufferedWriter(new FileWriter(fileName));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public boolean write(String outputText)
	{
		boolean status = false;
		try {
			if(outPutFileWriter != null)
			{
				if(this.currentOutPutNumber>1)
				{
					outPutFileWriter.newLine();
				}
				outPutFileWriter.write("Case #"+this.currentOutPutNumber+": "+outputText);
				this.currentOutPutNumber++;
				//outPutFileWriter.newLine();
				outPutFileWriter.flush();
				status = true;
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return status;
	}
	
	public void shutDown()
	{
		if(outPutFileWriter !=null)
		{
			try {
				outPutFileWriter.flush();
				outPutFileWriter.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
}

}
