import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;


public class GoogleCodeJamProblemB {

	public static final String FILE_NAME = "B-small-attempt0";
	public static final String INPUT_FILE_NAME = FILE_NAME + ".in";
	public static final String OUTPUT_FILE_NAME = FILE_NAME  + ".out";
	
	FileWriter outStream;
    BufferedWriter out;
    BigInteger zero = new BigInteger("0");
    
	public int n;
	public BigInteger [] a;
	public BigInteger [] diff;
	public int C;
	
	BigInteger gcd(BigInteger b1, BigInteger b2){
		
		while (b1.compareTo(zero) != 0 && b2.compareTo(zero) != 0){
			b1 = b1.divideAndRemainder(b2)[1];
			if (b1.compareTo(zero) != 0)
				b2 = b2.divideAndRemainder(b1)[1];
		}
		return b1.add(b2);
	}
	
//	public void quickSort(int L, int R){
//		if (L >= R) return;
//		int mid = (L + R) >> 1;
//		//BigInteger midBig = (a[L].add(a[R]).divide(new BigInteger("2")));
//		int i = L, j = R;
//		while (i < j){
//			while (a[i].compareTo(a[mid]) < 0) i++;
//			while (a[j].compareTo(a[mid]) > 0) j--;
//			if (i < j){
//				BigInteger temp = a[i];
//				a[i] = a[j];
//				a[j] = temp;
//				i++; j--;
//			}
//		}
//		quickSort(L, j);
//		quickSort(i, R);
//	}
//	
//	public void sort(){
//		quickSort(0, n - 1);
//	}
	
	
	public void doit(BufferedReader br, int testNo) throws IOException {
		//n = br.read();
		String s = br.readLine();
		int pos = s.indexOf(" ");
		n = Integer.parseInt(s.substring(0, pos));
		s = s.substring(pos + 1);
		for (int j = 0; j < n; j++) {
			if (j != n - 1) {
				pos = s.indexOf(" ");
				a[j] = new BigInteger(s.substring(0, pos));
				s = s.substring(pos + 1);
			} else {
				a[j] = new BigInteger(s);
			}
		}
		
//		for (int i = 0; i < n; i++){
//			System.out.println(a[i]);
//		}
		
		for (int i = 1; i < n; i++){
			diff[i - 1] = a[i].subtract(a[i - 1]);
			if (diff[i - 1].compareTo(zero) < 0){
				diff[i - 1] = diff[i - 1].negate();
			}
		}
		
//		for (int i = 0; i < n - 1; i++){
//			System.out.println(diff[i]);
//		}

		BigInteger g = diff[0];
		for (int i = 1; i < n - 1; i++)
			g = gcd(g, diff[i]);
		
		//System.out.println(g);

		out.write("Case #" + testNo + ": ");
		
		if (g.compareTo(new BigInteger("1")) == 0) {
			out.write(0 + "\n");
			return;
		}
		
		BigInteger maxNumber = a[0];
		for (int i = 1; i < n; i++)
			if (a[i].compareTo(maxNumber) > 0) maxNumber = a[i];
		
		BigInteger remain = maxNumber.divideAndRemainder(g)[1];
		if (remain.compareTo(zero) == 0){
			out.write(0 + "\n");			
		} else {
			out.write(g.subtract(remain) + "\n");
		}
	}
	
	public void solve(){
		a = new BigInteger [2000];
		diff = new BigInteger [2000];
		
		FileInputStream fstream = null;
		try {
			fstream = new FileInputStream(INPUT_FILE_NAME);
			outStream = new FileWriter(OUTPUT_FILE_NAME);
			out = new BufferedWriter(outStream);
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	    // Get the object of DataInputStream
	    DataInputStream in = new DataInputStream(fstream);	
	    BufferedReader br = new BufferedReader(new InputStreamReader(in));
	        
	    try {
			int C = Integer.parseInt(br.readLine());
			
			for (int i = 0; i < C; i++){
				doit(br, i + 1);
			}
			
			out.close();
			
		} catch (IOException e) {
			e.printStackTrace();
		}     
	        		
	}
	
	public static void main(String arg[]){
		GoogleCodeJamProblemB problemB = new GoogleCodeJamProblemB();
		problemB.solve();
		
	        
	}
}
