package com.ladro.google.snapper;

import java.util.Scanner;

public class Snapper {

	private final int m_firstOn;

	public Snapper(int N) {
		m_firstOn = (int) (Math.pow(2, N)) - 1;
	}

	public boolean solve(int K) {
		long summer = m_firstOn;
		while (true) {
			if (summer == K) {
				return true;
			} else if (summer > K) {
				return false;
			}
			summer++;
			summer += m_firstOn;
		}
	}

	public static int[] getNandK(Scanner scanner) {
		String[] parts = scanner.nextLine().split("\\s+");
		return new int[] { Integer.parseInt(parts[0]), Integer.parseInt(parts[1]) };
	}

	public static void main(String[] args) {
		Scanner s = new Scanner(System.in);
		int numberCases = Integer.parseInt(s.nextLine());
		Snapper[] cachedSnappers = new Snapper[31];
		for (int caseNumber = 1; caseNumber <= numberCases; caseNumber++) {
			StringBuffer output = new StringBuffer("Case #" + caseNumber + ": ");
			int[] nandK = getNandK(s);
			if (cachedSnappers[nandK[0]] == null) {
				cachedSnappers[nandK[0]] = new Snapper(nandK[0]);
			}
			boolean onOrOff = cachedSnappers[nandK[0]].solve(nandK[1]);
			if (onOrOff) {
				output.append("ON");
			} else {
				output.append("OFF");
			}
			System.out.println(output.toString());
		}
	}
}
