package codejam.qualification;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

/**
 * @author Cheng Chen
 * @since Apr 9, 2016
 */

public class RevengeOfThePancakes {
	
	public static void main(String[] args) {
		int casetotal = 0;
		int casenumber = 1;
		int totalline = 0;
		String line = "";
		
		try (FileReader fr = new FileReader("data/B-large.in"); BufferedReader br = new BufferedReader(fr); FileWriter fw = new FileWriter("data/B-large.out1"); PrintWriter bw = new PrintWriter(fw);) {
			while ((line = br.readLine()) != null) {
				if (totalline == 0) {
					casetotal = Integer.parseInt(line);
				} else if (casenumber > casetotal) {
					System.out.println("###Error: The casenumber has problem!!!");
					System.out.println("###Error: This error happened in line number" + totalline);
					System.exit(0);
				} else {
					/**
					 * processing
					 */
					
					int times = getFlipTime(line);
					bw.println("Case #" + casenumber + ": " + times);
					
					casenumber++;
				}
				totalline++;
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	private static int getFlipTime(String line) {
		int length = line.length();
		
		if (length ==0) return 0;
		
		if (length == 1 && line.charAt(0) == '+')
			return 0;
		
		if (length == 1 && line.charAt(0) == '-')
			return 1;
		
		if (line.charAt(length - 1) == '+') {
			// calculate the position of first - from right
			// for example "+++-++", the i will be 3
			int i = length - 1;
			while (i >= 0) {
				if (line.charAt(i) == '-')
					break;
				i--;
			}
			return getFlipTime(line.substring(0, i + 1));
		}
		
		//line ends with '-'
		//two conditon: 
		//1.line starts with -, flip the whole one
		if(line.charAt(0)=='-'){
			return 1+getFlipTime(flipAndReverseString(line));
		}
		//2.line starts with +, flip the first part of + to -, and then reverse the whole string
		else{
			StringBuilder firstPart=new StringBuilder();
			int i=0;
			for(;i<line.length();i++){
				if(line.charAt(i)=='+')
					firstPart.append("-");
				else
					break;
			}
			firstPart.append(line.substring(i, line.length()));
			return 2+getFlipTime(flipAndReverseString(firstPart.toString()));
		}
	}

	private static String flipAndReverseString(String line) {
	      StringBuilder sb=new StringBuilder();
	      StringBuilder lb=new StringBuilder(line);
	      lb=lb.reverse();
	      
	      for(int i=0;i<lb.length();i++){
	      	if(lb.charAt(i)=='+')
	      		sb.append("-");
	      	else
	      		sb.append("+");
	      }
	      return sb.toString();
      }
	
}
