package codejam.qualification;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

/**
 * @author Cheng Chen
 * @since Apr 9, 2016
 */

public class CoinJam {
	
	public static void main(String[] args) {
		int casetotal = 0;
		int casenumber = 1;
		int totalline = 0;
		String line = "";
		
		try (FileReader fr = new FileReader("data/C-small-attempt0.in"); BufferedReader br = new BufferedReader(fr); FileWriter fw = new FileWriter("data/C-small-attempt0.out"); PrintWriter bw = new PrintWriter(fw);) {
			while ((line = br.readLine()) != null) {
				if (totalline == 0) {
					casetotal = Integer.parseInt(line);
				} else if (casenumber > casetotal) {
					System.out.println("###Error: The casenumber has problem!!!");
					System.out.println("###Error: This error happened in line number" + totalline);
					System.exit(0);
				} else {
					/**
					 * processing
					 */
					int jamJoinLength = Integer.parseInt(line.split(" ")[0]);
					int jamJoinNumber = Integer.parseInt(line.split(" ")[1]);
					
					StringBuilder sb = new StringBuilder();
					ArrayList<String> numberCandiates = new ArrayList<String>();
					sb.append("1");
					backtrack(numberCandiates, sb, jamJoinLength - 1);
					
					bw.println("Case #" + casenumber + ":");
					
					for (String candidate : numberCandiates) {
						if (jamJoinNumber == 0)
							break;
						String nontrivalDivisor = getNontrivalDivisor(candidate);
						if (nontrivalDivisor != null) {
							bw.print(candidate);
							bw.println(nontrivalDivisor);
							jamJoinNumber--;
						}
					}
					
					casenumber++;
				}
				totalline++;
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	private static String getNontrivalDivisor(String candidate) {
		StringBuilder sb = new StringBuilder();
		for (int base = 2; base <= 10; base++) {
			long number = getNumber(candidate, base);
			
			// check if n is a multiple of 2
			if (number % 2 == 0) {
				sb.append(" ").append(2);
				continue;
			}
			
			boolean isPrime = true;
			// if not, then just check the odds
			for (long i = 3; i * i <= number; i += 2) {
				if (number % i == 0) {
					sb.append(" ").append(i);
					isPrime = false;
					break;
				}
			}
			
			if (isPrime)
				return null;
		}
		return sb.toString();
	}
	
	private static long getNumber(String candidate, int base) {
		long result = 0;
		for (char c : candidate.toCharArray()) {
			result *= base;
			if (c == '1')
				result += 1;
		}
		return result;
	}
	
	private static void backtrack(ArrayList<String> numberCandiates, StringBuilder sb, int targetLength) {
		if (sb.length() == targetLength) {
			sb.append("1");
			numberCandiates.add(sb.toString());
			return;
		}
		
		int length = sb.length();
		sb.append("1");
		backtrack(numberCandiates, sb, targetLength);
		
		sb.setLength(length);
		sb.append("0");
		backtrack(numberCandiates, sb, targetLength);
	}
	
}
