package codejam.round1c;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.IllegalFormatException;

/**
 * Author: Cheng Chen Date: Apr 12, 2014 Function:
 */

public class SenateEvacuation {
	public static void main(String[] args) {
		int casetotal = 0;
		int casenumber = 1;
		int totalline = 0;
		String line = "";
		
		try (FileReader fr = new FileReader("data/A-large.in");
		            BufferedReader br = new BufferedReader(fr);
		            FileWriter fw = new FileWriter("data/A-large.out");
		            PrintWriter bw = new PrintWriter(fw);) {
			while ((line = br.readLine()) != null) {
				if (totalline == 0) {
					casetotal = Integer.parseInt(line);
					totalline++;
					continue;
				}
				
				if (casenumber > casetotal) {
					System.out.println("###Error: The casenumber has problem!!!");
					System.out.println("###Error: This error happened in line number"
					            + totalline);
					throw new IOException("###Error: The casenumber has problem!!!");
				}
				
				/**
				 * processing
				 */
				int numberOfTestCases=Integer.parseInt(line);
				totalline++;
				
				int[] parties=new int[numberOfTestCases];
				
				line = br.readLine();
				String[] arr=line.split(" ",numberOfTestCases);
				for(int i=0;i<parties.length;i++){
					parties[i]=Integer.parseInt(arr[i]);
				}
				
				StringBuilder sb=new StringBuilder();
				getSenateEvacuation(parties,sb);
				bw.println("Case #"+casenumber+": "+sb.substring(0, sb.length()-1));
				
				casenumber++;
				totalline++;
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}

	private static void getSenateEvacuation(int[] parties, StringBuilder sb) {
	      int largestIndex=getMaxixumIndex(parties,-1);
	      int secondLargetIndex=getMaxixumIndex(parties,largestIndex);
	      
	      int total=0;
	      for(int p:parties)
	      	total+=p;
	      
	      if(largestIndex==-1 && secondLargetIndex==-1)
	      	return;
	      else if(secondLargetIndex==-1 || total%2==1){
	      	sb.append((char)('A'+largestIndex));
	      	sb.append(" ");
	      	parties[largestIndex]--;
	      	getSenateEvacuation(parties,sb);
	      }
	      else{
	      	if(largestIndex<secondLargetIndex){
		      	sb.append((char)('A'+largestIndex));
		      	sb.append((char)('A'+secondLargetIndex));
	      	}
	      	else{
	      		sb.append((char)('A'+secondLargetIndex));
	      		sb.append((char)('A'+largestIndex));
	      	}
	      	sb.append(" ");
	      	parties[largestIndex]--;
	      	parties[secondLargetIndex]--;
	      	getSenateEvacuation(parties,sb);
	      }
	      
      }

	private static int getMaxixumIndex(int[] parties, int exclude) {
		int result=-1;
		int maxValue=Integer.MIN_VALUE;
	      for(int i=0;i<parties.length;i++){
	      	if(i!=exclude && parties[i]>0)
		      	if(parties[i]>=maxValue){
		      		result=i;
		      		maxValue=parties[i];
		      	}
	      }
	      return result;
      }
	
}
