package codejam.qualification;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.HashSet;

/**
 * @author Cheng Chen
 * @since Apr 9, 2016
 */

public class CountingSheep {
	
	public static void main(String[] args) {
		int casetotal = 0;
		int casenumber = 1;
		int totalline = 0;
		String line = "";
		
		try (FileReader fr = new FileReader("data/A-small-attempt0.in"); BufferedReader br = new BufferedReader(fr); FileWriter fw = new FileWriter("data/A-small-attempt0.out"); PrintWriter bw = new PrintWriter(fw);) {
			while ((line = br.readLine()) != null) {
				if (totalline == 0) {
					casetotal = Integer.parseInt(line);
				} else {
					if (casenumber > casetotal) {
						System.out.println("###Error: The casenumber has problem!!!");
						System.out.println("###Error: This error happened in line number" + totalline);
						System.exit(0);
					}
					
					/**
					 * processing
					 */
					int base = Integer.parseInt(line);
					
					if (base == 0) {
						bw.println("Case #" + casenumber + ": INSOMNIA");
					} else {
						HashSet<Long> dp = new HashSet<Long>();
						HashSet<Integer> tenNumber = new HashSet<Integer>();
						
						int i = 1;
						while (i < Long.MAX_VALUE / base) {
							int thisNumber = base * i;
							if (dp.contains(thisNumber)) {
								bw.println("Case #" + casenumber + ": INSOMNIA");
								break;
							}
							
							putNumberDigit(thisNumber, tenNumber);
							
							if (tenNumber.size() == 10) {
								bw.println("Case #" + casenumber + ": " + thisNumber);
								break;
							}
							
							i++;
						}
					}
					
					casenumber++;
				}
				totalline++;
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	private static void putNumberDigit(int thisNumber, HashSet<Integer> tenNumber) {
		while (thisNumber != 0) {
			tenNumber.add(thisNumber % 10);
			thisNumber /= 10;
		}
	}
	
}
