import java.io.*;
import java.util.*;
import java.lang.*;
import java.math.*;

public class CoinJam {

    boolean areAllNotPrime(Long[] arr) {
        for (int i=0;i<arr.length;i++) {
            if (isPrime(arr[i])) {
                return false;
            }
        }
        return true;
    }

    boolean isPrime(Long n) {
        if (n%2L==0) return false;
        for(long i=3L;i*i<=n;i+=2L) {
            if(n%i==0)
                return false;
        }
        return true;
}

    private Long firstDivisor(Long n) {
        long sqrtN = (long)Math.sqrt(n)+1;
        for (long i = 2L; i <= sqrtN; i++) {
            if (n % i == 0) {
                return i;
            } 
        }
        return 0L;
    }

    private String randomize() {
        double r = Math.random();
        if (r<0.5) return "0";
        else return "1";
    }

    private String generateJamCoin(int N) {
        String s = "1";
        for (int i=0;i<N-2;i++) {
            s = s.concat(randomize());
        }
        s = s.concat("1");
        return s;
    }

    private String solve(int N, int J) {
        String result = "";
        
        for (int j=0; j<J;) {
            boolean found = false;
            String jamcoin;
            while(!found) {
                jamcoin = generateJamCoin(N);                

                //Long numberInBase;
                Long[] jamcoinBases = new Long[9];

                for (int b=2; b<11; b++) {
                    jamcoinBases[b-2] = Long.parseLong(jamcoin,b);
                }

               if (areAllNotPrime(jamcoinBases)) {
                    //Jamcoin found
                    found=true;
                    j++;
                    result+=jamcoin;
                    result+=" ";
                    //System.out.println(jamcoin);
                    for (int k=0;k<jamcoinBases.length;k++) {
                        result+=firstDivisor(jamcoinBases[k]);
                        result+=" ";
                    }
                    //System.out.println(result);
                    result+="\n"; 
                } else {
                    //generate another jamcoin
                    found=false;
                    break;
                }                                         
            }
               
        }
        return result;
        
    } 

    
    CoinJam() throws IOException {
        File in = new File("C-small-attempt2.in");
        PrintWriter out = new PrintWriter("C-small-attempt2.out");

        try {
            Scanner sc = new Scanner(in);
            Integer T = sc.nextInt();
            sc.nextLine();
                for (int t=1; t<T+1; t++) {
                    out.println("Case #" + t + ": \n" + solve(sc.nextInt(), sc.nextInt()));
                }
            sc.close();

        } catch (Exception e) {
            e.printStackTrace();
        }

        out.close();
    }
    
    public static void main(String[] args) throws IOException {
        new CoinJam();
    }
}