import java.io.*;
import java.util.*;

public class CountingSheep {
    private BufferedReader in;
    private PrintWriter out;
    private StringTokenizer st;
    
    int N;
    int choice;
    
    private String solve(int choice) {
        int result = 0;
        if (choice == 0) {
            return "INSOMNIA";
        } else if (choice == 1) {
            return "10";
        } else {
            HashSet<Integer> digits = new HashSet<Integer>();
            int total = 0;
            int i = 1;
            while (digits.size()!=10) {
                result = choice * i;
                i++;
                total = result;
                //Add to set
                while (total > 0) {
                    digits.add(total%10);
                    total = total/10;

                }
            }
            return Integer.toString(result);

        }        
        
    }


    
    CountingSheep() throws IOException {
        in = new BufferedReader(new FileReader("A-large.in"));
        out = new PrintWriter("A-large.out");
        eat("");
        
        int T = nextInt();
        for(int t = 1; t <= T; t++){
            choice = nextInt();
           
            out.println("Case #" + t + ": " + solve(choice));
        }
        
        in.close();
        out.close();
    }
    
    private void eat(String str) {
        st = new StringTokenizer(str);
    }
    
    String next() throws IOException {
        while (!st.hasMoreTokens()) {
            String line = in.readLine();
            if (line == null) {
                return null;
            }
            eat(line);
        }
        return st.nextToken();
    }
    
    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }
    
    long nextLong() throws IOException {
        return Long.parseLong(next());
    }
    
    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    public static void main(String[] args) throws IOException {
        new CountingSheep();
    }
}