import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;

public final class BLarge{
	public static void main(final String[] args) throws IOException{
		//		final String format="small";
		final String format="large";
		final BufferedReader br=new BufferedReader(new FileReader("B-"+format+".in"));
		final PrintStream out=new PrintStream(new File("B-"+format+".out"));
		//		final PrintStream out=System.out;
		final byte T=Byte.valueOf(br.readLine());
		// T cases
		int nbCases=T;
		int x=0;
		while(nbCases-->0){
			++x;
			final String[] szArgs=br.readLine().split(" ");
			final byte H=Byte.valueOf(szArgs[0]);
			final byte W=Byte.valueOf(szArgs[1]);
			System.err.println("L="+T);
			System.err.println("H="+H);
			System.err.println("W="+W);
			final short[][] map=new short[H][];
			final char[][] mapOut=new char[H][];
			for(int l=0; l<H; ++l){
				final String[] row=br.readLine().split(" ");
				map[l]=new short[W];
				mapOut[l]=new char[W]; // remplie avec des zros par dfaut
				int c=W;
				while(c-->0){
					map[l][c]=Short.valueOf(row[c]);
				}
			}
			System.err.println("map : "+H*W+" cells");
			char nextSink=1;
			for(int l=0; l<H; ++l){
				for(int c=0; c<W; ++c){
					System.err.print(map[l][c]+" ");
					mapOut[l][c]=BLarge.getSink(nextSink, map, mapOut, l, c);
					if(mapOut[l][c]==nextSink){
						++nextSink;
					}
				}
				System.err.println();
			}
			out.println("Case #"+x+":");
			for(int l=0; l<H; ++l){
				out.print(BLarge.getCharacter(mapOut[l][0]));
				for(int c=1; c<W; ++c){
					out.print(" "+BLarge.getCharacter(mapOut[l][c]));
				}
				out.println();
			}
		}
	}

	private static final char getCharacter(final char c){
		return (char)(c+'a'-1);
	}

	private static final char getSink(final char nextSink, final short[][] map, final char[][] mapOut, final int l, final int c){
		char ret=0;
		int lTmp=l;
		int cTmp=c;
		final short[] nwes=new short[4];
		byte bstIndex;
		while(ret==0){
			System.err.println("cell : "+lTmp+";"+cTmp);
			if(mapOut[lTmp][cTmp]>0){
				// is Sink or has Sink
				ret=mapOut[lTmp][cTmp];
				System.err.println(" > sink : "+BLarge.getCharacter(ret));
				continue;
			}
			// try in right order North,West,East,South
			nwes[0]=BLarge.tryCell(map, lTmp-1, cTmp);
			nwes[1]=BLarge.tryCell(map, lTmp, cTmp-1);
			nwes[2]=BLarge.tryCell(map, lTmp, cTmp+1);
			nwes[3]=BLarge.tryCell(map, lTmp+1, cTmp);
			// recherche de l'endroit ou l'eau peut tomber en comparant  la case courante
			bstIndex=BLarge.checkBest(nwes, map[lTmp][cTmp]);
			switch(bstIndex){
				case 0: //North
					--lTmp;
					System.err.println(" > going north...");
					break;
				case 1: //West
					--cTmp;
					System.err.println(" > going west...");
					break;
				case 2: //East
					++cTmp;
					System.err.println(" > going east...");
					break;
				case 3: //South
					++lTmp;
					System.err.println(" > going south...");
					break;
				default: // si best<0 => new Sink
					mapOut[lTmp][cTmp]=nextSink;//il peut y avoir des doubles affectations  cause de cette instruction, mais c'est pas grave
					ret=nextSink;
					System.err.println(" > new sink : "+BLarge.getCharacter(ret));
					break;
			}
		}
		return ret;
	}

	/**
	 * @param map
	 * @param lTmp
	 * @param cTmp
	 * @return altitude or MAX_VALUE if out of map
	 */
	private static final short tryCell(final short[][] map, final int lTmp, final int cTmp){
		if(lTmp<0) return Short.MAX_VALUE;
		if(cTmp<0) return Short.MAX_VALUE;
		if(lTmp>=map.length) return Short.MAX_VALUE;
		if(cTmp>=map[0].length) return Short.MAX_VALUE;
		return map[lTmp][cTmp];
	}

	private static final byte checkBest(final short[] altNWES, final short alt){
		final int cnt=altNWES.length;
		byte bst=-1;
		for(byte i=0; i<cnt; ++i){
			if((bst<0||altNWES[i]<altNWES[bst])&&altNWES[i]<alt){
				bst=i;
			}
		}
		return bst;
	}
}
