import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Vector;

public final class YayaA{
	public static void main(final String[] args) throws IOException{
		final BufferedReader br=new BufferedReader(new FileReader(args[0]+'-'+args[1]));
		final PrintStream out;
		if(args.length<3){
			out=System.out;
		}
		else{
			out=new PrintStream(new File(args[0]+'-'+args[2]));
		}
		final short T=Short.valueOf(br.readLine());
		final Object[] responses=new Object[T];
		final Thread[] pool=new Thread[T];
		short nbCases=-1;
		while(++nbCases<T){
			pool[nbCases]=new Thread(new P(nbCases, responses, br.readLine()));
			pool[nbCases].start();
		}
		synchronized(responses){
			while(YayaA.size(responses)<T){
				try{
					responses.wait();
				}
				catch(final InterruptedException e){
					// nothing to do
				}
			}
		}
		nbCases=-1;
		while(++nbCases<T){
			out.println(responses[nbCases]);
		}
	}

	private static final short size(final Object[] responses){
		short nbCases=(short)responses.length;
		short sz=0;
		while(nbCases-->0){
			if(responses[nbCases]!=null){
				++sz;
			}
		}
		return sz;
	}

	private static final class P implements Runnable{
		private static final CharSequence toAnswer(final short x, final BigInteger res){
			final StringBuilder ans=new StringBuilder("Case #");
			ans.append(x+1);
			ans.append(": ");
			ans.append(res.toString(10));
			return ans;
		}
		private final short x;
		private final Object[] r;
		private final String aNb;

		public P(final short x, final Object[] r, final String c){
			this.x=x;
			this.r=r;
			this.aNb=c;
		}

		@Override
		public void run(){
			final BigInteger secs=check(this.aNb);
			synchronized(this.r){
				this.r[this.x]=toAnswer(this.x, secs);
				System.err.println("["+Thread.currentThread().getId()+"] "+this.r[this.x]);
				this.r.notify();
			}
		}
	}
	private static final BigInteger check(final String aNb){
		final int cnt=aNb.length();
		final Vector<String> chiffres=new Vector<String>(cnt);
		String c;
		int k=0;
		while(++k<cnt){
			if(aNb.charAt(0)==aNb.charAt(k)){
				continue;
			}
			c=""+aNb.charAt(k);
			if(!chiffres.contains(c)){
				chiffres.add(c);
			}
		}
		if(chiffres.size()<1){
			chiffres.add(".");
		}
		chiffres.insertElementAt(""+aNb.charAt(0), 1);
		//		System.out.println(chiffres);
		final int sz=chiffres.size();
		final char[] digs=new char[sz];
		for(int i=0; i<sz; ++i){
			digs[i]=chiffres.get(i).charAt(0);
		}
		return baseChange(digs, aNb);
	}

	private static final BigInteger baseChange(final char[] digs, final String nb){
		final int b=digs.length;
		final BigInteger base=BigInteger.valueOf(b);
		BigInteger pow=BigInteger.ONE;
		BigInteger res=BigInteger.ZERO;
		char c;
		int i;
		int n=nb.length();
		while(n-->0){
			c=nb.charAt(n);
			for(i=0; i<b; ++i){
				if(digs[i]==c){
					break;
				}
			}
			res=res.add(pow.multiply(BigInteger.valueOf(i)));
			//			System.err.println(c+" found at index "+i+" (pow = "+pow+") => res = "+res);
			pow=pow.multiply(base);
		}
		return res;
	}
	//	/**
	//	 * @deprecated 4 debug only
	//	 * @param millis
	//	 */
	//	@Deprecated
	//	private static final void sleep(final long millis){
	//		try{
	//			Thread.sleep(millis);
	//		}
	//		catch(final InterruptedException e){}
	//	}
}
