/**
 * Google Code Jam 09
 */
package org.eu.cybot.gcj09.welcome;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.HashMap;
import java.util.Map;

/**
 * @author cybot
 * Welcome to Code Jam
 */
public class WelcomeToCodeJam {

	private static Map<String, Integer> result_store = new HashMap<String, Integer>();

	/**
	 * Count occurences of needle in haystack (recursively)
	 * @param haystack String to search
	 * @param needle String to look for
	 * @return number of occurences
	 */
	private static int stringCounts(String needle, String haystack)
	{
		if (needle.length() == 0)
			return 1;

		int sum = 0;

		String key = needle + ',' + haystack;
		if (result_store.containsKey(key))
		{
			return result_store.get(key);
		}

		char start = needle.charAt(0);
		for (int i = 0; i < haystack.length(); ++i)
		{
			if (needle.length() > haystack.length())
				break;

			if (haystack.charAt(i) == start)
			{
				sum += stringCounts(needle.substring(1), haystack.substring(i));
				if (sum >= 10000)
					sum = sum % 10000;
			}
		}

		result_store.put(key, sum);
		return sum;
	}
	
	/**
	 * main
	 * @param args
	 */
	public static void main(String[] args) {
		File in = new File("/tmp/C-large.in");
		File out = new File("out_we.txt");
		BufferedReader br = null;
		BufferedWriter bw = null;

		try
		{
			br = new BufferedReader(new FileReader(in));
			bw = new BufferedWriter(new FileWriter(out));
		}
		catch (Exception e) {
			System.err.println("Unable to open file: " + e);
			return;
		}
		try {
			// Parse first line
			String line = br.readLine();

			int N = Integer.parseInt(line);

			NumberFormat formatter = new DecimalFormat("0000");
			for (int i = 0; i < N; ++i)
			{
				line = br.readLine();
				bw.write("Case #" + (i+1) + ": " + formatter.format(stringCounts("welcome to code jam", line)) + "\n");
			}

			br.close();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
			return;
		}
	}
}
