/**
 * Google Code Jam
 */
package org.eu.cybot.gcj09.decisiontree;

import java.util.Vector;

/**
 * @author cybot
 *
 */
public class Node {

	private float weight;
	private String feature;
	private Node child1;
	private Node child2;

	/**
	 * @param weight the weight to set
	 */
	public void setWeight(float weight) {
		this.weight = weight;
	}

	/**
	 * @param feature the feature to set
	 */
	public void setFeature(String feature) {
		this.feature = new String(feature);
	}

	/**
	 * @return the child1
	 */
	public Node getChild1() {
		return child1;
	}

	/**
	 * @param child1 the child1 to set
	 */
	public void setChild1(Node child1) {
		this.child1 = child1;
	}

	/**
	 * @return the child2
	 */
	public Node getChild2() {
		return child2;
	}

	/**
	 * @param child2 the child2 to set
	 */
	public void setChild2(Node child2) {
		this.child2 = child2;
	}

	public Node()
	{
		this.weight = 0;
		feature = null;
		child1 = null;
		child2 = null;
	}

	public Node(float weight)
	{
		this.weight = weight;
		feature = null;
		child1 = null;
		child2 = null;
	}

	public Node(float weight, String feature)
	{
		this.weight = weight;
		this.feature = new String(feature);
		child1 = null;
		child2 = null;
	}

	public boolean isLeaf()
	{
		return feature == null;
	}

	public float getWeight()
	{
		return weight;
	}

	public float getCuteness(Vector<String> features)
	{
		if (isLeaf())
			return weight;
		else
		{
			if (features.contains(feature))
				return weight * child1.getCuteness(features);
			else
				return weight * child2.getCuteness(features);
		}
	}

	public String toString()
	{
		return "(" + weight + (isLeaf() ? "" : " " + feature + ": " + child1 + ", " + child2) + ")";
	}
}
