/**
 * Google Code Jam 09
 */
package org.eu.cybot.gcj09.decisiontree;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Stack;
import java.util.Vector;

/**
 * @author cybot
 *
 */
public class DecisionTree {
	/**
	 * main
	 * @param args
	 */
	public static void main(String[] args) {
		File in = new File("/tmp/A-small-attempt0.in"); // /tmp/A-large.in
		File out = new File("out_dt.txt");
		BufferedReader br = null;
		BufferedWriter bw = null;
		NumberFormat formatter = new DecimalFormat("0.0000000");
		
		int N;

		try
		{
			br = new BufferedReader(new FileReader(in));
			bw = new BufferedWriter(new FileWriter(out));
		}
		catch (Exception e) {
			System.err.println("Unable to open file: " + e);
			return;
		}
		try {
			// Parse first line
			String line = br.readLine();

			N = Integer.parseInt(line);
			for (int i = 0; i < N; ++i)
			{
				// Parse first line of the test case
				line = br.readLine();
				int L = Integer.parseInt(line);

				Node root = new Node();
				Node node = null;
				Stack<Node> node_stack;
				node_stack = new Stack<Node>();
				node_stack.push(root);

				for (int j = 0; j < L; ++j)
				{
					// Parse decision tree
					line = br.readLine();
					int pos = 0;

					while(line.charAt(pos) == ' ')
						++pos; // skip spaces

					if (line.charAt(pos++) != '(')
					{
						if (line.charAt(pos-1) == ')')
							continue;
						System.err.println("Parse error: no opening parenthesis found:\n" + line);
						return;
					}

					node = node_stack.pop();

					while(line.charAt(pos) == ' ')
						++pos; // skip spaces

					// Parse weight
					String number = new String();
					char c;
					while((c = line.charAt(pos++)) != ' ')
					{
						if (c == ')')
						{
							--pos;
							break;
						}
						number += c;
					}
					float weight = Float.parseFloat(number);

					while(line.charAt(pos) == ' ')
						++pos; // skip spaces

					if (line.charAt(pos) != ')')
					{
						// sub-tree
						node.setWeight(weight);
						
						String feature = new String();
						while(pos != line.length() && (c = line.charAt(pos++)) != ' ')
						{
							feature += c;
						}
						node.setFeature(feature);

						Node child1 = new Node(0);
						Node child2 = new Node(0);
						node.setChild1(child1);
						node.setChild2(child2);
						node_stack.push(child2);
						node_stack.push(child1);
					}
					else
					{
						node.setWeight(weight);
					}
				}

				System.out.println(root);

				line = br.readLine();
				int A = Integer.parseInt(line);

				bw.write("Case #" + (i+1) + ":\n");

				for (int j = 0; j < A; ++j)
				{
					line = br.readLine();
					String[] tokens = line.split(" ");
					if (tokens.length < 2 || Integer.parseInt(tokens[1]) != (tokens.length - 2))
					{
						System.err.println("Parse Error: Animal line");
						return;
					}
					Vector<String> features = new Vector<String>();
					for (int k = 2; k < tokens.length; ++k)
						features.add(tokens[k]);
					bw.write(formatter.format(root.getCuteness(features)) + "\n");
				}

			}
			br.close();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
			return;
		}
	}
}
