package QualificationRound.q2;

/*
 * Copyright 2015 Nischal M
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */


import QualificationRound.q1.FileUtilForQ2;

import java.util.ArrayList;

public class RevengeOfThePancakes {

    private static int moveCounter = 0;

    private static StringBuilder flip(StringBuilder old) {
        ++moveCounter;
        old.reverse();
        for (int it = 0; it < old.length(); ++it) {
            if (old.charAt(it) == '+') {
                old.deleteCharAt(it);
                old.insert(it, '-');
            } else {
                old.deleteCharAt(it);
                old.insert(it, '+');
            }
        }
        return old;
    }

    public static void main(String[] args) {
        ArrayList<String> values = FileUtilForQ2.getValues();
        ArrayList<Integer> output = new ArrayList<>();

        int T = Integer.parseInt(values.remove(0)), t = -1;
        --T;

        while (t != T) {
            String order = values.get(++t);
            int len = order.length();
            for (int st = 0; st < len; ++st) {
                char c = order.charAt(st);
                if (c == '-') {
                    StringBuilder temp;
                    //flip above -
                    if (st != 0) {
                        temp = new StringBuilder(order.substring(0, st));
                        temp = flip(temp);
                        temp.append(order.subSequence(st, len));
                        order = temp.toString();
                    }
                    //flip till -
                    while (st != order.length() && order.charAt(st) == '-')
                        ++st;

                    temp = new StringBuilder(order.substring(0, st));
                    temp = flip(temp);
                    temp.append(order.substring(st, len));
                    order = temp.toString();
                }
            }
            output.add(moveCounter);
            moveCounter = 0;
        }

        FileUtilForQ2.putValues(output);

    }

}

