package QualificationRound;

/*
 * Copyright 2015 Nischal M
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */


import java.util.ArrayList;

public class CountingSheep {

    private static int[] digits = new int[10];

    private static ArrayList<Integer> getDigits(int value) {
        ArrayList<Integer> list = new ArrayList<>();
        while (value != 0) {
            int R = value % 10;
            if (!list.contains(R)) list.add(R);
            value = value / 10;
        }
        return list;
    }

    private static void setup() {
        for (int i = 0; i < 10; ++i) digits[i] = 0;
    }

    private static boolean checkAllOnes() {
        for (int i = 0; i < 10; ++i)
            if (digits[i] == 0) return false;
        return true;
    }

    private static void update(ArrayList<Integer> updateValues) {
        updateValues.forEach(i -> digits[i] = 1);
    }

    public static void main(String[] args) {
        ArrayList<Integer> values = FileUtil.getValues("C:\\Users\\Cyplops\\IdeaProjects\\CodeJam2016\\A-small-attempt1.in"),
                outputValues = new ArrayList<>();

        int T = values.remove(0), t = -1;
        --T;

        while (t != T) {
            int V = values.get(++t);
            if (V == 0) {
                outputValues.add(-1);
                continue;
            }

            setup();

            int i = 0;
            while (!checkAllOnes()) {
                if (i == Integer.MAX_VALUE) {
                    System.out.println("abort!!!!!");
                    System.exit(1);
                }
                ++i;
                update(getDigits(V * i));
            }
            outputValues.add(V * i);
        }

        FileUtil.putValues(outputValues);
    }

}
