package qualification;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class CookieClickerLarge {

	public static void debug(Object...args) {
		System.out.println(Arrays.deepToString(args));
	}
	
	public static void main(String...args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter pw = new PrintWriter(System.out, true);
		solve(br, pw);
	}

	private static void solve(BufferedReader br, PrintWriter pw) throws Exception {
		int cases = Integer.parseInt(br.readLine());
		for (int c = 1; c <= cases; c++) {
			pw.printf("Case #%d: %s\n", c, solveCase(br, pw));
		}
	}

	private static Object solveCase(BufferedReader br, PrintWriter pw) throws Exception {
		StringTokenizer st = new StringTokenizer(br.readLine());
		double c = Double.parseDouble(st.nextToken());
		double f = Double.parseDouble(st.nextToken());
		double x = Double.parseDouble(st.nextToken());
		
		int maxS = (int)(10000*x) + 2;
		
		double s = 2;
		
		double val = 0;
		double bval = x / s;
		// sum a series that has a strictly increasing derivative + sum of series that has a strictly decreasing derivative will
		// have only one extremum (since f'(x) = g'(x) can only happen once)
		for (int i=0;i<maxS;i++,s+=f) {			
			val += (c/s);
			if (val + x/(s+f) >= bval) {
				return bval;
			}
			else {
				bval = val + x/(s+f);
			}
		}
		
		return bval;
	}
}
