package qualification;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Mines {

	public static void debug(Object...args) {
		System.out.println(Arrays.deepToString(args));
	}
	
	public static void main(String...args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter pw = new PrintWriter(System.out, true);
		solve(br, pw);
	}

	private static void solve(BufferedReader br, PrintWriter pw) throws Exception {
		int cases = Integer.parseInt(br.readLine());
		for (int c = 1; c <= cases; c++) {
			pw.printf("Case #%d: %s\n", c, solveCase(br));
		}
	}

	private static Object solveCase(BufferedReader br) throws Exception {
		StringTokenizer st = new StringTokenizer(br.readLine());
		int r = Integer.parseInt(st.nextToken());
		int c = Integer.parseInt(st.nextToken());
		int m = Integer.parseInt(st.nextToken());
		int nm = r*c - m - 1;
		
		if (m == r*c) return "\nImpossible";
		
		if (r == 1 || c == 1) {
			StringBuilder bob = new StringBuilder("\n");
			for (int i=0;i<r;i++) {
				for (int j=0;j<c;j++) {
					if (i == j && i == 0) bob.append("c");
					else if (nm-- > 0) bob.append(".");
					else bob.append("*");
				}
				bob.append("\n");
			}
			return bob.deleteCharAt(bob.length()-1).toString();
		}
		
		if (nm > 0 && nm < 3) return "\nImpossible";
		
		StringBuilder bob = new StringBuilder("\n");
		for (int i=0;i<r;i++) {
			for (int j=0;j<c;j++) {
				if (i == j && i == 0) bob.append("c");
				else if ((nm > 0 && i > 0) || (nm > 2 && i == 0)) {
					bob.append(".");
					nm--;
				}
				else bob.append("*");
			}
			bob.append("\n");
		}
		return bob.deleteCharAt(bob.length()-1).toString();
	}
}
