package qualification;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class CookieClicker {

	public static void debug(Object...args) {
		System.out.println(Arrays.deepToString(args));
	}
	
	public static void main(String...args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter pw = new PrintWriter(System.out, true);
		solve(br, pw);
	}

	private static void solve(BufferedReader br, PrintWriter pw) throws Exception {
		int cases = Integer.parseInt(br.readLine());
		for (int c = 1; c <= cases; c++) {
			pw.printf("Case #%d: %s\n", c, solveCase(br, pw));
		}
	}

	private static Object solveCase(BufferedReader br, PrintWriter pw) throws Exception {
		StringTokenizer st = new StringTokenizer(br.readLine());
		Double c = Double.parseDouble(st.nextToken());
		Double f = Double.parseDouble(st.nextToken());
		Double x = Double.parseDouble(st.nextToken());
		
		int maxi = (int)Math.ceil(x);
		int l = 0, h = maxi, mid = 0;
		double t1 = 0, t2 = 0;
		
		while (l < h) {
			mid = l + (h - l)/2;
			t1 = val(mid,c,f,x);
			t2 = val(mid+1,c,f,x);
			
			//debug(mid, l, h, t1, t2);
			
			if (t1 <= t2) {
				h = mid;
			}
			else {
				l = mid + 1;
			}
		}
		
		//debug("Done ", mid, l, h, t1, t2);
		t1 = val(l,c,f,x);
		t2 = val(l+1,c,f,x);
		if ((l == h) && (t1 <= t2)) {
			//debug(mid, l, h, t1, t2);			
			return t1;
		}
		else {
			//debug(mid, l, h, maxi, val(maxi, c, f, x));
		    return val(maxi, c, f, x);
		}
		
	}

	private static double val(int mid, double c, double f, double x) {
		
		double val = 0;
		double st = 2;
		for (int i=0;i<mid;i++,st+=f) {
			val += (c/st);
		}
		return val + x/st;
	}
}
