
import java.util.Scanner;
import java.io.*;
import java.util.ArrayList;

public class BotTrust
{

	int numTestCases;
	int numButtons[];
	ArrayList<Integer>[] orangeMoves;
	ArrayList<Integer>[] blueMoves;
	ArrayList<String>[] moveOrder;
	
	class Robot
	{
		public int position;
		public int index;
		public int target;
		public ArrayList<Integer> moves;
		
		public Robot(ArrayList<Integer> mov)
		{
			this.moves = mov;
			this.position = 1;
			this.index = 0;
			if (this.moves.size() == 0)
			{
				return;
			}
			this.target = this.moves.get(index);
		}
		
		
		public boolean makeMovement(boolean isYourTurn)
		{
			//System.out.println(target);
			if (position != target)
			{
				if (position < target)
					position++;
				if (position > target)
					position--;
				return false;
			}
			
			if (isYourTurn == true)
			{
				index++;
				if (index != moves.size())
					target = moves.get(index);
				return true;
			}
			
			return false;
		}
	}
	
	public int getTestCases()
	{
		return numTestCases;
	}
	
	public BotTrust loadTestCases(Scanner s)
	{
		BotTrust b = new BotTrust();
		b.numTestCases = s.nextInt();
		b.blueMoves = new ArrayList[b.numTestCases];
		b.orangeMoves = new ArrayList[b.numTestCases];
		b.moveOrder = new ArrayList[b.numTestCases];
		b.numButtons = new int[b.numTestCases];
		for (int loopCases = 0; loopCases < b.numTestCases; loopCases++)
		{
			int n = s.nextInt();
			b.numButtons[loopCases] = n;
			ArrayList<Integer> orangeList = new ArrayList<Integer>();
			ArrayList<Integer> blueList = new ArrayList<Integer>();
			ArrayList<String> moves = new ArrayList<String>();
			for (int loopButtons = 0; loopButtons < n; loopButtons++)
			{
				String token = s.next();
				if (token.compareToIgnoreCase("O") == 0)
				{
					moves.add("O");
					orangeList.add(s.nextInt());
				}
				else if (token.compareToIgnoreCase("B") == 0)
				{
					moves.add("B");
					blueList.add(s.nextInt());
				}
				else 
				{
					System.out.println("Bad input from source.");
				}
			}
			b.blueMoves[loopCases] = blueList;
			b.orangeMoves[loopCases] = orangeList;
			b.moveOrder[loopCases] = moves;
		}
		return b;
	}
	
	public int getMinMoves(int testCase)
	{
		int moves = 0;
		Robot blue = new Robot(blueMoves[testCase]);
		Robot orange = new Robot(orangeMoves[testCase]);
		for (int buttonsPressed = 0; buttonsPressed < numButtons[testCase]; buttonsPressed++)
		{
			if (moveOrder[testCase].get(buttonsPressed).equals("O"))
			{
				//System.out.println("orange!");
				do
				{
					blue.makeMovement(false);
					moves++;
				}while (!orange.makeMovement(true));
			}
			else
			{
				//System.out.println("blue!");
				do
				{
					orange.makeMovement(false);
					moves++;
				}while (!blue.makeMovement(true));
			}
			//System.out.println("moves: " +moves);
			
		}
		return moves;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException
	{
		Scanner sc = new Scanner(new File("TestInput.txt"));
		BotTrust b = new BotTrust();
		b = b.loadTestCases(sc);
		for (int i = 0; i < b.getTestCases(); i++)
		{
			System.out.println("Case #" + (i + 1) + ": " + b.getMinMoves(i));
		}
	}

}
