import java.io.File;
import java.io.IOException;
import java.util.Scanner;


public class CandySplitter
{
	int numTestCases;
	int[][] testCases;
	
	public int getNumTestCases()
	{
		return numTestCases;
	}
	
	public void loadTestCases(Scanner sc)
	{
		numTestCases = sc.nextInt();
		testCases = new int[numTestCases][];
		for (int i = 0; i < numTestCases; i++)
		{
			testCases[i] = new int[sc.nextInt()];
			for (int j = 0; j < testCases[i].length; j++)
			{
				testCases[i][j] = sc.nextInt();
			}
		}
	}
	
	public String solveCase(int cse)
	{
		if (!isPossible(cse))
			return "NO";
		
		//as long as it is possible, Sean can have all the candy but the smallest.
		int smallest = testCases[cse][0];
		int sum = 0;
		for (int i: testCases[cse])
		{
			sum = sum + i;
			smallest = Math.min(smallest, i);
		}
		sum = sum - smallest;
		return Integer.toString(sum);
	}
	
	//we know it is possible when all numbers "add" to 0
	private boolean isPossible(int cse)
	{
		String runningTotal = "0";
		for (int i: testCases[cse])
		{
			runningTotal = patrickAdd(runningTotal, Integer.toBinaryString(i));
		}
		
		if (Integer.parseInt(runningTotal, 2) == 0)
			return true;
		
		return false;
	}
	
	private String patrickAdd(String op1, String op2)
	{
		String result;
		int lengthDiff = Math.abs(op1.length() - op2.length());
		if (op1.length() > op2.length())
		{
			result = op1.substring(0, lengthDiff);
			op1 = op1.substring(lengthDiff, op1.length());
		}
		else
		{
			result = op2.substring(0, lengthDiff);
			op2 = op2.substring(lengthDiff, op2.length());
		}
		
		for (int i = 0; i < op1.length(); i++)
		{
			if (op1.charAt(i) == op2.charAt(i))
				result = result + "0";
			else
				result = result + "1";
		}
		return result;
	}
	
	public static void main(String[] args) throws IOException
	{
		Scanner sc = new Scanner(new File("C-small-attempt0.in"));
		CandySplitter c = new CandySplitter();
		c.loadTestCases(sc);
		for (int i = 0; i < c.getNumTestCases(); i++)
		{
			System.out.println("Case #" + (i + 1) + ": " + c.solveCase(i));
		}
	}

}
