package com.wcyiu.codejam.model;

import java.util.ArrayList;

/**
 * Created by YIU on 9/4/2016.
 */
public class JamCoinProducer {
    private ArrayList<JamCoin> coins;
    private int length;
    private int numberOfCoins;

    public JamCoinProducer(int length, int numberOfCoins) {
        this.length = length;
        this.numberOfCoins = numberOfCoins;
        coins = new ArrayList<>(numberOfCoins);
        init();
    }

    private void init() {
        String startCoin = "1";
        for (int i = 1; i < length; i++) {
            startCoin += i == length - 1 ? "1" : "0";
        }
        JamCoin coin = new JamCoin(startCoin, length);
        while ( coins.size() < numberOfCoins) {
            if (coin.isJamCoin())
                coins.add(coin);
            if(!coin.hasNext())
                break;
            coin = coin.nextJamCoin();
        }
    }

    public String getOutput() {
        String output = "";
        for (int i = 0; i < coins.size(); i++) {
            output += coins.get(i).output();
            if (i != coins.size() - 1)
                output += "\n";
        }
        return output;
    }


}
