package com.wcyiu.codejam;

import com.wcyiu.codejam.model.PancakeStack;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Main {

    private ArrayList<PancakeStack> cases;

    public Main() {
        this.cases = new ArrayList<>();
    }

    private void readInput(String filePath) {
        try {
            BufferedReader br = new BufferedReader(new FileReader(filePath));
            int noOfCases = Integer.parseInt(br.readLine());
            for (int i = 0; i < noOfCases; i++) {
                PancakeStack pancakeStack = new PancakeStack(br.readLine());
                cases.add(pancakeStack);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private void writeOutput(String filePath) {
        FileWriter fw = null;
        try {
            fw = new FileWriter(filePath);
            for (int i = 0; i < cases.size(); i++) {
                fw.write("Case #" + (i + 1) + ": " + cases.get(i).getFlipped() + "\n");
            }
            fw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
//        Main sample = new Main();
//        sample.readInput("./sample.in");
//        sample.writeOutput("./sample.out");

//        Main smallDataset = new Main();
//        smallDataset.readInput("./B-small-attempt1.in");
//        smallDataset.writeOutput("./B-small-attempt1.out");

        Main largeDataset = new Main();
        largeDataset.readInput("./B-large.in");
        largeDataset.writeOutput("./B-large.out");
    }
}
