package com.wcyiu.codejam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;

public class MainC {

    private static class Info {
        private int L;
        private int R;
        private int d;

        public Info(int l, int r, int d) {
            L = l;
            R = r;
            this.d = d;
        }
    }

    private static class MaxDistanceComparator implements Comparator<Info> {
        @Override
        public int compare(Info o1, Info o2) {
            return o2.d - o1.d;
        }
    }

    public static void main(String[] args) {
//        String in = "./C-sample.in";
//        String out = "./C-sample.out";
//        String in = "./C-small-1-attempt0.in";
//        String out = "./C-small-1-attempt0.out";
        String in = "./C-small-2-attempt1.in";
        String out = "./C-small-2-attempt1.out";
//        String in = "./C-large.in";
//        String out = "./C-large.out";

        try {
            BufferedReader br = new BufferedReader(new FileReader(in));
            FileWriter fw = new FileWriter(out);
            int T = Integer.parseInt(br.readLine());
            for (int i = 0; i < T; i++) {
                String NK = br.readLine();
                int N = Integer.parseInt(NK.split(" ")[0]);
                int K = Integer.parseInt(NK.split(" ")[1]);

                PriorityQueue<Info> queue = new PriorityQueue<>(new MaxDistanceComparator());
                queue.add(new Info(0, N + 1, N + 1));
                for (int k = 0; k < K; k++) {
                    Info info = queue.poll();
                    int S = info.L + info.d / 2;
                    queue.add(new Info(info.L, S, S - info.L));
                    queue.add(new Info(S, info.R, info.R - S));
                    if (k == K - 1) {
                        int Ls = S - info.L - 1;
                        int Rs = info.R - S - 1;
                        if (Ls < 0) {
                            Ls = 0;
                        }
                        if (Rs < 0) {
                            Rs = 0;
                        }
                        fw.write("Case #" + (i + 1) + ": " + Math.max(Ls, Rs) + " " + Math.min(Ls, Rs) + "\n");
                    }
                }
            }
            fw.close();

        } catch (IOException e) {
            e.printStackTrace();
        }

    }
}
