package com.wcyiu.codejam.model;

import java.math.BigInteger;
import java.util.ArrayList;

/**
 * Created by YIU on 9/4/2016.
 */
public class JamCoin {
    private String coin;
    private int length;
    private ArrayList<BigInteger> values;

    public JamCoin(String coin, int length) {
        this.coin = coin;
        this.length = length;
        this.values = new ArrayList<>();
        init();
    }

    private void init() {
        for (int i = 2; i <= 10; i++) {
            BigInteger result = new BigInteger(coin, i);
            values.add(result);
        }
    }


    private BigInteger getNontrivalDivisor(BigInteger n) {
        BigInteger prime = BigInteger.valueOf(2);
        while (n.compareTo(prime) > 0) {
            if (n.mod(prime).equals(BigInteger.ZERO)) {
                return prime;
            }
            prime = prime.nextProbablePrime();
        }
        return BigInteger.ZERO;
    }


    public boolean isJamCoin() {
        boolean isJamCoin = true;
        for (BigInteger value : values) {
            if (value.isProbablePrime(Integer.MAX_VALUE)) {
                isJamCoin = false;
                break;
            }
        }
        return isJamCoin;
    }


    public JamCoin nextJamCoin() {
        String nextStr = "1" + leftPad(Integer.toBinaryString(Integer.parseInt(coin.substring(1, coin.length() - 1), 2) + 1), length - 2) + "1";
        return new JamCoin(nextStr, length);
    }

    public boolean hasNext() {
        String nextStr = "1" + leftPad(Integer.toBinaryString(Integer.parseInt(coin.substring(1, coin.length() - 1), 2) + 1), length - 2) + "1";
        return nextStr.length() == length;
    }

    public String output() {
        String output = coin + " ";
        for (int i = 0; i < values.size(); i++) {
            output += String.valueOf(getNontrivalDivisor(values.get(i)));
            if (i != values.size() - 1)
                output += " ";
        }
        return output;
    }

    public static String leftPad(String str, int length) {
        String result = str;
        while (result.length() < length) {
            result = "0" + result;
        }
        return result;
    }

    @Override
    public String toString() {
        return coin;
    }
}
