package com.wcyiu.codejam.model;

/**
 * Created by YIU on 9/4/2016.
 */
public class PancakeStack {
    private int flipped;
    private int[] pancakes;

    public PancakeStack(String input) {
        pancakes = new int[input.length()];
        for (int i = 0; i < input.length(); i++) {
            char face = input.charAt(i);
            if (face == '+')
                pancakes[i] = 1;
            else if (face == '-')
                pancakes[i] = -1;
        }
        flipped = 0;
        start();
    }

    private void start() {
        int lastNegativePosition = findLastNegative();
        while (lastNegativePosition != -1) {
            if (pancakes[0] > 0 && lastNegativePosition > 0)
                flip(findLastNegativeSegmentStart());
            else
                flip(lastNegativePosition + 1);
            lastNegativePosition = findLastNegative();
        }
    }

    private int findLastNegativeSegmentStart() {
        int lastNegativeStart = -1;
        for (int i = pancakes.length - 1; i >= 0; i--) {
            if (pancakes[i] < 0) {
                if (i > 0 && pancakes[i - 1] > 0) {
                    lastNegativeStart = i;
                    break;
                }
            }
        }
        return lastNegativeStart;
    }

    private int findLastNegative() {
        int lastNegative = -1;
        for (int i = pancakes.length - 1; i >= 0; i--) {
            if (pancakes[i] < 0) {
                lastNegative = i;
                break;
            }
        }
        return lastNegative;
    }

    private int countPositive(int length) {
        int count = 0;
        for (int i = 0; i < length; i++) {
            if (pancakes[i] > 0) {
                count++;
            }
        }
        return count;
    }

    private int countNegative(int length) {
        int count = 0;
        for (int i = 0; i < length; i++) {
            if (pancakes[i] < 0) {
                count++;
            }
        }
        return count;
    }


    private void flip(int length) {
        //flip
        for (int i = 0; i < length; i++) {
            pancakes[i] *= -1;
        }
        //reverse
        for (int i = 0; i < length / 2; i++) {
            int temp = pancakes[i];
            pancakes[i] = pancakes[length - i - 1];
            pancakes[length - i - 1] = temp;
        }
        flipped++;
    }


    public String getFlipped() {
        return String.valueOf(flipped);
    }
}
