import java.io.BufferedReader;
import java.io.FileReader;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;


public class r_C_FlySwatter_CZ {
	public int 		totNum;
	public double	radFly;
	public double	orgradOuter;
	public double	radOuter;
	public double	thickOuter;
	public double	radString;
	public double	lenGrid;
	
	
	public r_C_FlySwatter_CZ() {
		try {
			BufferedReader in = new BufferedReader(new FileReader("d:\\my\\code_jam\\C-large.in"));
			String line = in.readLine();
			if(line != null) {
				this.totNum =  new Integer(line.trim()).intValue();
			}
			
			for(int i=0;i<this.totNum;i++) {
				line = in.readLine();
				if(line != null) {
					String[] tempList = line.trim().split(" ");
					this.radFly = new Double(tempList[0].trim()).doubleValue();
					this.orgradOuter = new Double(tempList[1].trim()).doubleValue();
					this.thickOuter = new Double(tempList[2].trim()).doubleValue();
					this.radString = new Double(tempList[3].trim()).doubleValue();
					this.lenGrid = new Double(tempList[4].trim()).doubleValue();
					
					this.radOuter = this.orgradOuter - this.thickOuter - this.radFly;
				}
				
				BigDecimal prob = new BigDecimal(this.calculateProb()).setScale(6,BigDecimal.ROUND_HALF_UP);
				System.out.println("Case #"+(i+1)+": "+prob);
			}
			in.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	double calculateProb() {
		if (this.radFly>=this.lenGrid/2.0) {
			return 1.0;
		} else {
			//calculate area of 1/4 circle
			double totArea = Math.PI*this.orgradOuter*this.orgradOuter/4.0;
			double sucArea = 0.0;
			
			double row = 0.0;
			double col = 0.0;
			int rowTag = 1;
			while(rowTag==1) {
				int colTag = 1;
				while(colTag==1) {
					double startX =this.radString + this.radFly + col*(this.lenGrid+this.radString*2.0); 
					double startY =this.radString + this.radFly + row*(this.lenGrid+this.radString*2.0); 
					int posTag = judgePositon(startX, startY);
					if(posTag==-1) {
						colTag = 0;
						col = 0.0;
					} else {
						double tempArea = this.calGridArea(startX, startY, posTag);
						sucArea += tempArea;
						col += 1.0;
					}
				}
				row += 1.0;
				if((this.radString + this.radFly + row*(this.lenGrid+this.radString*2.0))>this.radOuter) {
					rowTag = 0;
				}				
			}
			return 1.0-sucArea/totArea;
		}
	}
	double calGridArea(double x, double y, int tag) {
		if(tag==0) {
			return (this.lenGrid-2.0*this.radFly)*(this.lenGrid-2.0*this.radFly);			
		} else if(tag==1) {
			double interPoint1X = x;
			double interPoint1Y = Math.sqrt(this.radOuter*this.radOuter-x*x);
			double interPoint2X = Math.sqrt(this.radOuter*this.radOuter-y*y);
			double interPoint2Y = y;
			double cEdge = this.calDistance(interPoint1X, interPoint1Y, interPoint2X, interPoint2Y);
			double bEdge = this.calDistance(0.0, 0.0, interPoint2X, interPoint2Y);
			double aEdge = this.calDistance(interPoint1X, interPoint1Y, 0.0, 0.0);
			double angle = 2.0*(Math.asin(cEdge/2.0/aEdge));
			double sectorArea = angle*this.radOuter*this.radOuter/2.0;
			double p = (aEdge+bEdge+cEdge)/2.0;
			double triangleArea = Math.sqrt(p*(p-aEdge)*(p-bEdge)*(p-cEdge));
			double succArea = Math.abs(interPoint1Y-y)*Math.abs(interPoint2X-x)/2.0+sectorArea-triangleArea;
			return succArea;			
		} else if(tag==2) {
			double interPoint1Y = y+this.lenGrid-2.0*this.radFly;
			double interPoint1X = Math.sqrt(this.radOuter*this.radOuter-interPoint1Y*interPoint1Y);			
			double interPoint2X = x+this.lenGrid-2.0*this.radFly;
			double interPoint2Y = Math.sqrt(this.radOuter*this.radOuter-interPoint2X*interPoint2X);
			double cEdge = this.calDistance(interPoint1X, interPoint1Y, interPoint2X, interPoint2Y);
			double bEdge = this.calDistance(0.0, 0.0, interPoint2X, interPoint2Y);
			double aEdge = this.calDistance(interPoint1X, interPoint1Y, 0.0, 0.0);
			double angle = 2.0*(Math.asin(cEdge/2.0/aEdge));
			double sectorArea = angle*this.radOuter*this.radOuter/2.0;
			double p = (aEdge+bEdge+cEdge)/2.0;
			double triangleArea = Math.sqrt(p*(p-aEdge)*(p-bEdge)*(p-cEdge));
			double succArea = (this.lenGrid-2.0*this.radFly)*(this.lenGrid-2.0*this.radFly)-Math.abs(interPoint1Y-interPoint2Y)*Math.abs(interPoint2X-interPoint1X)/2.0+sectorArea-triangleArea;
			return succArea;
		} else if(tag==3) {
			double interPoint1Y = y+this.lenGrid-2.0*this.radFly;
			double interPoint1X = Math.sqrt(this.radOuter*this.radOuter-interPoint1Y*interPoint1Y);
			double interPoint2Y = y;
			double interPoint2X = Math.sqrt(this.radOuter*this.radOuter-interPoint2Y*interPoint2Y);
			double cEdge = this.calDistance(interPoint1X, interPoint1Y, interPoint2X, interPoint2Y);
			double bEdge = this.calDistance(0.0, 0.0, interPoint2X, interPoint2Y);
			double aEdge = this.calDistance(interPoint1X, interPoint1Y, 0.0, 0.0);
			double angle = 2.0*(Math.asin(cEdge/2.0/aEdge));
			double sectorArea = angle*this.radOuter*this.radOuter/2.0;
			double p = (aEdge+bEdge+cEdge)/2.0;
			double triangleArea = Math.sqrt(p*(p-aEdge)*(p-bEdge)*(p-cEdge));
			double succArea = Math.abs(interPoint1Y-interPoint2Y)*Math.abs(interPoint2X+interPoint1X-2.0*x)/2.0+sectorArea-triangleArea;
			return succArea;
		} else if(tag==4) {
			double interPoint1X = x;
			double interPoint1Y = Math.sqrt(this.radOuter*this.radOuter-interPoint1X*interPoint1X);
			double interPoint2X = x+this.lenGrid-2.0*this.radFly;
			double interPoint2Y = Math.sqrt(this.radOuter*this.radOuter-interPoint2X*interPoint2X);
			double cEdge = this.calDistance(interPoint1X, interPoint1Y, interPoint2X, interPoint2Y);
			double bEdge = this.calDistance(0.0, 0.0, interPoint2X, interPoint2Y);
			double aEdge = this.calDistance(interPoint1X, interPoint1Y, 0.0, 0.0);
			double angle = 2.0*(Math.asin(cEdge/2.0/aEdge));
			double sectorArea = angle*this.radOuter*this.radOuter/2.0;
			double p = (aEdge+bEdge+cEdge)/2.0;
			double triangleArea = Math.sqrt(p*(p-aEdge)*(p-bEdge)*(p-cEdge));
			double succArea = Math.abs(interPoint1X-interPoint2X)*Math.abs(interPoint2Y+interPoint1Y-2.0*y)/2.0+sectorArea-triangleArea;
			return succArea;
		} else {
			return 0.0;
		}
	}
	
	int judgePositon(double x, double y) {
		double disSPoint = this.calDistance(x,y,0.0,0.0);
		double disUPoint = this.calDistance(x,y+this.lenGrid-2.0*this.radFly,0.0,0.0);
		double disRPoint = this.calDistance(x+this.lenGrid-2.0*this.radFly,y,0.0,0.0);
		double disFPoint = this.calDistance(x+this.lenGrid-2.0*this.radFly,y+this.lenGrid-2.0*this.radFly,0.0,0.0);
		if(disSPoint<this.radOuter&&disUPoint<this.radOuter&&disRPoint<this.radOuter&&disFPoint<this.radOuter) {
			return 0;
		} else if (disSPoint<this.radOuter&&disUPoint>this.radOuter&&disRPoint>this.radOuter&&disFPoint>this.radOuter) {
			return 1;
		} else if (disSPoint<this.radOuter&&disUPoint<this.radOuter&&disRPoint<this.radOuter&&disFPoint>this.radOuter) {
			return 2;
		} else if (disSPoint<this.radOuter&&disUPoint<this.radOuter&&disRPoint>this.radOuter&&disFPoint>this.radOuter) {
			return 3;
		} else if (disSPoint<this.radOuter&&disUPoint>this.radOuter&&disRPoint<this.radOuter&&disFPoint>this.radOuter) {
			return 4;
		} else {
			return -1;
		}
	}
	
	double calDistance(double x1, double y1, double x2, double y2) {
		return Math.sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
	}
	
	
	public static void main(String[] args) {
	    new r_C_FlySwatter_CZ();
	}
}
