/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package codejamczg;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.stream.Collectors;

/**
 *
 * @author CZG
 */
public class CodeJamCZG {

    static String Path = "input/2017/";
    static String problem = "A";
    static String type = "small-attempt1";
    static String InputFile = problem+"-"+type+".in";
    static String OutputFile = problem+"-"+type+".out";
    static String filename,fileOut;
    static int LinesPerBlock =1;
    static List <String> lines;
    static List <String> linesout = new ArrayList<>();
    static PrintWriter pw;
    static int nCases;
    static List <List<String>> Cases;
    
    
    public static void main(String[] args) {
        try {
            ReadInputFile();
            BuildTestCases();
        } catch (IOException ex) {
        }
        BuildTestCases();
        //Aqui empieza la magia.
        for(int i=0;i<nCases;i++){
            linesout.add("Case #"+(i+1)+": "+OversizedPancakeFlipper(Cases.get(i)));  
            System.out.println("Case #"+(i+1)+": "+OversizedPancakeFlipper(Cases.get(i)));
        }
        try {
            WriteOutputFile(linesout);
        } catch (IOException ex) {
        }//Acà termina la magia*/
        //System.out.println("Case #"+(0+1)+": "+Pancakes(Cases.get(0)));
    }
    
    
    public static void ReadInputFile() throws IOException{
        filename = new File(new File(Path),InputFile).getPath();
        lines = Files.lines(Paths.get(filename)).collect(Collectors.toList());
    }
    public static void WriteOutputFile(List <String> lines) throws IOException{
        fileOut = new File(Path + OutputFile).getPath();
        pw = new PrintWriter(new File(fileOut));
        for(int i=0;i<nCases;i++){
            pw.println(linesout.get(i));
        }
        pw.close();
        //pw.flush();
    }
    public static void BuildTestCases() {
        nCases = Integer.parseInt(lines.get(0));
        // Build Test Cases
        Cases = new ArrayList<>(nCases);
        for (int iT = 0; iT < nCases; iT++)
        {
            Cases.add(lines
                                .stream()
                                .skip(iT * LinesPerBlock + 1)
                                .limit(LinesPerBlock)
                                .collect(Collectors.toList())
            );
        }
    }
    
    public static String OversizedPancakeFlipper(List<String> Case){
        String pancake = Case.get(0).split(" ")[0];
        int K  = Integer.parseInt(Case.get(0).split(" ")[1]);
        List<Integer> p = PancakeToInts(pancake);
        int resultado = PancakeSolver(p,K);
        return (resultado < 0) ? "IMPOSSIBLE":String.valueOf(resultado);
    }
    
    public static List<Integer> PancakeToInts(String pancake){
        List<Integer> p = new ArrayList<>();
        for(char ch : pancake.toCharArray()){
            if(ch == '+'){
                p.add(1);
            }else{
                p.add(0); 
            }
        }
        return p;
    }
    
    public static int PancakeSolver(List<Integer> p,int K){
        int N = p.size();
        int ones = suma(p);
        int ceros = N-ones;
        int movs = 0;
        
        if(ones == N){
            return movs=0;
        }else if(ones == 0){
            if(N%K==0){return (N/K);}
            else{ return -N;}
        }else if(ceros < K){
            return -N;
        }else{
            //1000010010 K=3
            //1111010010
            //System.out.println("p antes: "+p.toString());
            for(int i = 0; i<N-K ;i++){
                if(p.get(i)==0){
                    if(suma(p.subList(i,i+K))==0){
                        for(int j = i; j < i+K ;j++){
                            p.set(j, 1);
                        }
                        movs++;
                    }
                }    
            }
            
            //System.out.println("p  post: "+p.toString()+" "+movs);
            
            
            List<Integer>p1 = new ArrayList<>();
            for(int i = 0; i < N;i++){
                if(p.get(i) == 0){
                    p1 = p.subList(i, N);
                    break;
                }
            }
            
            if(p1.size()>=K){
                for(int j = 0; j < K ;j++){
                    if(p1.get(j)==0){
                        p1.set(j,1);
                    }else if(p1.get(j)==1){
                        p1.set(j,0);
                    }
                }
                movs++;
                movs += PancakeSolver(p1,K);
            }else{
                movs=-N;
               
                }
            return movs;
        }
    }
    
    public static int suma(List<Integer> p){
        return p.stream().mapToInt(Integer::intValue).sum();
    }
    
//    //Empieza TidyNumbers
//    public static String TidyNumbers(List<String> Case){
//        List<String> digits = Arrays.asList(Case.get(0).split(""));
//        if(isTidy(digits)){
//            return BuildNumber(digits);
//        }else{
//            for(int i = digits.size()-1;i >=0 ;i--){
//                if(Integer.parseInt(digits.get(i)) < Integer.parseInt(digits.get(i-1))){
//                    digits.set(i,"9");
//                    digits.set(i-1,String.valueOf(Integer.parseInt(digits.get(i-1))-1));
//                    break;
//                }
//                digits.set(i, "9");
//            }
//            return TidyNumbers(Arrays.asList(BuildNumber(digits)));
//        }
//    }
//    
//    public static boolean isTidy(List<String> digits){
//        for(int i = 0;i <= digits.size()-2;i++){
//            if(Integer.parseInt(digits.get(i)) > Integer.parseInt(digits.get(i+1))){return false;}
//        }
//        return true;
//
//    }
//    
//    public static String BuildNumber(List<String> digits){
//        return String.join("",digits).replaceFirst("^0+(?!$)", "");
//    }    
//    //Termina TidyNumbers
    
    
//    //Empieza CoinJam
//    public static String CoinJam(List <String> Case){
//        String[] data = Case.get(0).split(" ");
//        int N = Integer.parseInt(data[0]);
//        int J = Integer.parseInt(data[1]);
//        int count=0;
//        String Jmin="10000000000000000000000000000001";
//        String resultado="\n";
//        List<String> Js = new ArrayList<>();
//        List<List<Integer>> casos = ArmaCasos(N,1);
//        List<List<Integer>> aux;
//        int sep = 2;
//        do {
//            aux=ArmaCasos(N,sep);
//            casos.addAll(aux);
//            sep++;
//        }while (aux.size()>31);
//        StringBuilder JJ = new StringBuilder(Jmin);                
//        for(List<Integer> c:casos){
//            for(int x:c){
//                JJ.setCharAt(x, '1');   
//            }
//            Js.add(JJ.toString());
//            JJ = new StringBuilder(Jmin);
//        }
//        Js = Js.stream().distinct().collect(Collectors.toList());
//        Collections.sort(Js);
//        int ok=0;
//        for(String j:Js){
//            String test= isJC(j);
//            if(test!=""){
//                resultado = resultado + test+"\n";
//                if(ok<=J){
//                   ok++;
//                }
//            }
//            if(ok==J){
//                break;
//            }   
//        }
//        return resultado;
//    }
//    public static String isJC(String j){
//        String res = j;
//        List<BigInteger> bases = Base(j);
//        for(BigInteger b : bases){
//            if(BigPrime(b)){
//                res="";
//                return res;
//            }else{
//                res=res+" "+Divisors(b);
//            }    
//        }
//        return res;
//    }
//    public static List<BigInteger> Base(String s){
//        char [] ch = s.toCharArray();
//        BigInteger suma = BigInteger.ZERO;
//        List <BigInteger> bases = new ArrayList<>();
//        for (int base=2;base<=10;base++){
//            for(int i=0;i<ch.length;i++){
//                BigInteger index = BigInteger.valueOf(Long.parseLong(String.valueOf(ch[i])));
//                BigInteger pot = new BigDecimal(Math.pow((double)base, (double)ch.length-1-i)).toBigInteger();
//                suma=suma.add(index.multiply(pot));
//             }
//            bases.add(suma);
//            suma=BigInteger.ZERO;
//        }
//        return bases;
//    }
//    public static BigInteger Divisors(BigInteger s){
//        BigInteger num = s;
//        List<BigInteger> div = new ArrayList<>();
//        div.add(BigInteger.ONE);
//        BigInteger d = BigInteger.valueOf(2);
//        while(num.compareTo(d)>0 || num.equals(d)){
//            if(num.remainder(d).equals(BigInteger.ZERO)){
//                div.add(d);    
//                break;
//            }else{
//                if(d.remainder(BigInteger.valueOf(2)).equals(BigInteger.ZERO)){
//                    d=d.add(BigInteger.valueOf(1));
//                }else{
//                    d=d.add(BigInteger.valueOf(2));
//                }
//                if(num.remainder(d).equals(BigInteger.ZERO)){
//                    div.add(d);
//                    break;
//                }
//            } 
//        }
//        return div.get(1);
//    }
//    public static boolean BigPrime(BigInteger l){
//        if(l.compareTo(BigInteger.valueOf(2))>0 && 
//           l.remainder(BigInteger.valueOf(2)).equals(BigInteger.ZERO)){
//            return false;
//        }
//        BigInteger top = sqrt(l).add(BigInteger.ONE);
//        for(BigInteger i = BigInteger.valueOf(3); i.compareTo(top) < 0 && i.compareTo(BigInteger.valueOf(10000))<0; i=i.add(BigInteger.valueOf(2))){
//            if(l.remainder(i).equals(BigInteger.ZERO)) {return false;}
//        }
//        return true;
//    }
//    public static BigInteger sqrt(BigInteger n) {
//       BigInteger a = BigInteger.ONE;
//       BigInteger b = new BigInteger(n.shiftRight(5).add(new BigInteger("8")).toString());
//       
//       while(b.compareTo(a) >= 0)
//       {
//           BigInteger mid = new BigInteger(a.add(b).shiftRight(1).toString());
//           if(mid.multiply(mid).compareTo(n) > 0) b = mid.subtract(BigInteger.ONE);
//           else a = mid.add(BigInteger.ONE);
//       }
//       return a.subtract(BigInteger.ONE);
//   }
//   public static List<List<Integer>> ArmaCasos(int n, int sep){
//       List<List<Integer>> res = new ArrayList<>();
//       List<Integer> aux;
//       
//       for(int i=0;i<(n-2)/2;i++){
//           if(i==0){
//               aux = new ArrayList<>();
//               res.add(aux);
//           }else{
//               for(int a=1;a<n-1;a++){
//                   aux = new ArrayList<>();
//                   for(int b=a;b<n-1;b+=sep){
//                       if(aux.size()<2*i){
//                           aux.add(b);
//                       }else{ break; }
//                   }
//                   if(aux.size()==2*i){
//                       res.add(aux);
//                   }
//               }
//           }
//       }
//       for(int i=0;i<(n-2)/2;i++){
//           if(i==0){
//               aux = new ArrayList<>();
//               res.add(aux);
//           }else{
//               for(int a=1;a<n-1;a++){
//                   aux = new ArrayList<>();
//                   for(int b=a;b<n-1;b+=sep){
//                       if(aux.size()<2*i+1){
//                           aux.add(b);
//                       }else{ break; }
//                   }
//                   if(aux.size()==2*i+1){
//                       res.add(aux);
//                   }
//               }
//           }
//       }
//       return res;
//   }  
//    public static boolean Prime(long l){
//        if (l > 2 && l % 2 == 0) {return false;}
//        int top = (int)Math.sqrt(l) + 1;
//        for(int i = 3; i < top; i+=2){
//            if(l % i == 0) {return false;}
//        }
//        return true;
//    }
//    //Termina CoinJam
    
}
