package A;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;

/**
 * Created by bence on 2017.04.29.
 */
public class A {
    private static final String IN_FILENAME = "src/A/A-large.in";
    private static final String OUT_FILENAME = "src/A/out.txt";

    public static double getMax(ArrayList<Pancake> pancakes)
    {
        Pancake mostRad = Collections.max(pancakes, (p1,p2) -> Long.compare(p1.r,p2.r));
        double val = pancakes.stream().map(p -> 1.0* p.r * p.h).reduce(0.0, (a,b) -> a+b);
        return Math.PI * (mostRad.r * mostRad.r + 2*val);
    }

    public static void main(String[] args)
    {
        try{
            BufferedReader in = new BufferedReader(new FileReader(IN_FILENAME));
            PrintWriter out = new PrintWriter(OUT_FILENAME);

            String line = in.readLine();
            String[] splited = line.split(" ");
            int testcaseCount = Integer.parseInt(splited[0]);

            for(int i = 1; i<= testcaseCount; i++)
            {
                line = in.readLine();
                splited = line.split(" ");
                int n = Integer.parseInt(splited[0]);
                int k = Integer.parseInt(splited[1]);

                ArrayList<Pancake> pancakes = new ArrayList<Pancake>();
                for (int j = 0; j < n; j++)
                {
                    line = in.readLine();
                    splited = line.split(" ");
                    long ri = Integer.parseInt(splited[0]);
                    long hi = Integer.parseInt(splited[1]);

                    Pancake p = new Pancake();
                    p.r = ri;
                    p.h = hi;
                    pancakes.add(p);
                }
                Collections.sort(pancakes, (p1,p2) -> Long.compare(p1.h * p1.r, p2.h*p2.r));
                //descending order
                Collections.reverse(pancakes);
                //take first k
                ArrayList<Pancake> selected = new ArrayList<Pancake>();
                for (int j = 0; j< k; j++)
                {
                    selected.add(pancakes.get(j));
                }

                if (n > k)
                {
                    ArrayList<Pancake> omitted = new ArrayList<Pancake>();
                    for (int j = k; j < n; j++) {
                        omitted.add(pancakes.get(j));
                    }
                    //get the one with the highest radius not in selected collection
                    Pancake mostRad = Collections.max(omitted, (p1,p2) -> {
                        int compRes = Long.compare(p1.r,p2.r);
                        if (compRes == 0)
                        {
                            return Long.compare(p1.h * p1.r , p2.h*p2.r);
                        }
                        return compRes;
                    });
                    //get the highest rad from selected
                    double maxRad = Collections.max(selected, (p1,p2) -> Long.compare(p1.r,p2.r)).r;
                    if (mostRad.r > maxRad) {
                        double gain = (mostRad.r * mostRad.r + 2 * mostRad.r * mostRad.h - maxRad *maxRad) * Math.PI;
                        Pancake weakest = selected.get(k-1);
                        double loss = weakest.h * weakest.r * 2 * Math.PI;
                        if (gain > loss)
                        {
                            selected.remove(weakest);
                            selected.add(mostRad);
                        }
                    }
                }

                out.println("Case #" + i + ": " + getMax(selected));
            }
            out.close();

        } catch (Exception e)
        {
            e.printStackTrace();
        }

    }

}

class Pancake {
    public long r;
    public long h;
}