package B;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;

/**
 * Created by bence on 2017.04.30..
 * Statemachine implementation
 */
public class B {

    private static final String IN_FILENAME = "src/B/B-large.in";
    private static final String OUT_FILENAME = "src/B/out.txt";

    private static final int CAMERON = 0;
    private static final int JAMIE = 1;

    public static void main(String[] args)
    {
        try{
            BufferedReader in = new BufferedReader(new FileReader(IN_FILENAME));
            PrintWriter out = new PrintWriter(OUT_FILENAME);

            String line = in.readLine();
            String[] splited = line.split(" ");
            int testcaseCount = Integer.parseInt(splited[0]);

            for(int i = 1; i<= testcaseCount; i++)
            {
                line = in.readLine();
                splited = line.split(" ");
                int ac = Integer.parseInt(splited[0]);
                int aj = Integer.parseInt(splited[1]);


                ArrayList<Activity> cAct = new ArrayList<Activity>();
                for (int j = 0; j < ac; j++)
                {
                    line = in.readLine();
                    splited = line.split(" ");
                    int ci = Integer.parseInt(splited[0]);
                    int di = Integer.parseInt(splited[1]);
                    cAct.add(new Activity(ci,di,CAMERON));
                }

                ArrayList<Activity> jAct = new ArrayList<Activity>();
                for (int j = 0; j < aj; j++)
                {
                    line = in.readLine();
                    splited = line.split(" ");
                    int ji = Integer.parseInt(splited[0]);
                    int ki = Integer.parseInt(splited[1]);
                    jAct.add(new Activity(ji,ki,JAMIE));
                }

                ArrayList<Activity> allAct = new ArrayList<>();
                allAct.addAll(cAct);
                allAct.addAll(jAct);
                allAct.sort((a1, a2) -> Integer.compare(a1.start, a2.start));

                int minSwaps = 2;

                if (allAct.size() > 1){
                    int[] time = {0,0};
                    int swap = 0;
                    ArrayList<Integer>[] alloc = new ArrayList[2];
                    alloc[JAMIE] = new ArrayList<>();
                    alloc[CAMERON] = new ArrayList<>();


                    Activity prev = allAct.get(0);
                    time[prev.parent] += prev.dur();


                    for (int j = 1; j< allAct.size();j++)
                    {
                        Activity curr = allAct.get(j);
                        if (curr.parent == prev.parent)
                        {
                            time[curr.parent] += curr.freeB(prev);
                            time[curr.parent] += curr.dur();
                            alloc[curr.parent].add(curr.freeB(prev));
                        } else {
                            time[curr.parent] += curr.dur();
                            swap++;
                        }
                        prev = curr;
                    }

                    if (prev.parent == allAct.get(0).parent)
                    {
                        time[prev.parent] += (allAct.get(0).start + 24*60 - prev.end);

                        alloc[prev.parent].add(allAct.get(0).start + 24*60 - prev.end);
                    } else {
                        swap++;
                    }
                    if (time[JAMIE] > 60*12 || time[CAMERON] > 60*12){

                        int over = JAMIE;
                        if (time[CAMERON] > 60*12){
                            over = CAMERON;
                        }

                        alloc[over].sort((a,b) -> Integer.compare(a,b));
                        Collections.reverse(alloc[over]);
                        int k = 0;
                        while (time[over] > 60*12)
                        {
                            time[over] -= alloc[over].get(k);
                            swap += 2;
                            k++;
                        }
                    }

                    minSwaps = swap;
                }



                out.println("Case #" + i + ": " + minSwaps);
            }
            out.close();

        } catch (Exception e)
        {
            e.printStackTrace();
        }

    }
}

class Activity{

    public Activity(int s, int e, int p)
    {
        start = s;
        end = e;
        parent = p;
    }
    public int start;
    public int end;
    public int parent;

    public int dur() {
        return end-start;
    }

    public int freeB(Activity a) {
        return start - a.end;
    }
}
