import java.io.IOException;
import java.math.BigInteger;
import java.util.Iterator;
import java.util.LinkedList;

/**
 * User: jlee
 * Date: 11/1/12
 * Time: 11:30 AM
 */
public class R11A2013 extends CodeJam {


    double inf = Double.MAX_VALUE;
    LinkedList<LinkedList<String>> list = new LinkedList<LinkedList<String>>();

    LinkedList<String> flatList = new LinkedList<String>();

    public R11A2013(String fileName) throws IOException {
        super(fileName);

    }

    protected void init() {



    }

    public static BigInteger bigIntSqRootFloor(BigInteger x)
            throws IllegalArgumentException {
        if (x.compareTo(BigInteger.ZERO) < 0) {
            throw new IllegalArgumentException("Negative argument.");
        }
        // square roots of 0 and 1 are trivial and
        // y == 0 will cause a divide-by-zero exception
        if (x == BigInteger.ZERO || x == BigInteger.ONE) {
            return x;
        } // end if
        BigInteger two = BigInteger.valueOf(2L);
        BigInteger y;
        // starting with y = x / 2 avoids magnitude issues with x squared
        for (y = x.divide(two);
             y.compareTo(x.divide(y)) > 0;
             y = ((x.divide(y)).add(y)).divide(two));
        return y;
    } // end bigIntSqRootFloor

    public static BigInteger bigIntSqRootCeil(BigInteger x)
            throws IllegalArgumentException {
        if (x.compareTo(BigInteger.ZERO) < 0) {
            throw new IllegalArgumentException("Negative argument.");
        }
        // square roots of 0 and 1 are trivial and
        // y == 0 will cause a divide-by-zero exception
        if (x == BigInteger.ZERO || x == BigInteger.ONE) {
            return x;
        } // end if
        BigInteger two = BigInteger.valueOf(2L);
        BigInteger y;
        // starting with y = x / 2 avoids magnitude issues with x squared
        for (y = x.divide(two);
             y.compareTo(x.divide(y)) > 0;
             y = ((x.divide(y)).add(y)).divide(two));
        if (x.compareTo(y.multiply(y)) == 0) {
            return y;
        } else {
            return y.add(BigInteger.ONE);
        }
    }


    protected int squareSum(String in) {
        int sum = 0;

        for (int i = 0; i < in.length(); i++) {
            int digit = (Integer.parseInt(in.charAt(i) + ""));
            sum += digit * digit;
        }

        return sum;
    }


    protected void solve() {
        try {
            String[] row = br.readLine().split("\\s+");

            BigInteger r = new BigInteger(row[0]);
            double dr = Double.parseDouble(row[0]);
            double dt = Double.parseDouble(row[1]);
            BigInteger t = new BigInteger(row[1]);
            BigInteger one = new BigInteger("1");
            BigInteger two = new BigInteger("2");

            //3141592653589793238462643383279

            BigInteger pi = new BigInteger("314159265358979323846");
            BigInteger tenTo20 = new BigInteger("100000000000000000000");
            //double k = (-(dr - 1) + Math.sqrt((dr - 1)* (dr - 1) + 2 * dt / Math.PI)) / 2;
            double k = (-(2* dr - 1) + Math.sqrt((2* dr - 1)* (2* dr - 1) + 8 * dt )) / 4;
            //k = Math.floor(k);
            System.out.println(k);
            BigInteger bk = new BigInteger(String.format("%.0f", Math.floor(k)));
            BigInteger compare = t;
            BigInteger estimate = two.multiply(bk).multiply(bk).add(two.multiply(r).subtract(one).multiply(bk));


            System.out.println(bk.toString() + " " + compare.toString() + " " + estimate.toString());

            while (estimate.compareTo(compare) != 1) {
                bk = bk.add(one);
                estimate = two.multiply(bk).multiply(bk).add(two.multiply(r).subtract(one).multiply(bk));
            }
            System.out.println(bk.subtract(one).toString());

            printResult(bk.subtract(one).toString());

        } catch (Exception e) {
            e.printStackTrace();
        }


    }

    public static void main(String[] args) {

        String fileName = "A-";

        if (args[0].compareTo("small") == 0) {
            fileName += "small";
        } else if (args[0].compareTo("large") == 0) {
            fileName += "large";
        } else if (args[0].compareTo("sample") == 0) {
            fileName += "sample";
        } else {
            System.out.println("small or large or sample");
            return;
        }

        if (args[1].compareTo("1") == 0) {
            fileName += "-practice.in.txt";
        } else {
            fileName += ".in.txt";
        }

        try {
            R11A2013 codeJam = new R11A2013(fileName);
            codeJam.run();
        } catch (IOException e) {
            System.err.print(e);
        }
    }
}
