package com.google.code.jam;


import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Scanner;

public class Magicka_2011 {

	public FileWriter outputWriter;
	public Scanner scanner;
	public final static String INPUT_FILE_NAME = "B-large.in";
	public String output = "";
	
	private HashMap<String, String> combinationMap = null;
	private ArrayList<String[]> opposedList = null;
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		String testCaseResult = null;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());
			
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				String[] infos = scanner.nextLine().split(" ");
				
				int nbCombination = Integer.parseInt(infos[0]);
				combinationMap = new HashMap<String, String>(2*nbCombination);
				for (int combIndex = 0; combIndex < nbCombination; combIndex++) {
					String _combinaison = infos[combIndex + 1].toUpperCase();
					String comb1 = _combinaison.substring(0, 2);
					String comb2 = Character.toString(comb1.charAt(1)) + Character.toString(comb1.charAt(0));
					String result = _combinaison.substring(2);
					combinationMap.put(comb1, result);
					combinationMap.put(comb2, result);
				}
				
				int nbOpposed = Integer.parseInt(infos[nbCombination + 1]);
				opposedList = new ArrayList<String[]>(nbOpposed);
				for (int opposedIndex = 0; opposedIndex < nbOpposed; opposedIndex++) {
					String _combinaison = infos[opposedIndex + nbCombination + 2].toUpperCase();
					String[] opposed = { _combinaison.substring(0, 1), _combinaison.substring(1)};
					opposedList.add(opposed);
				}
				
				int nbChar = Integer.parseInt(infos[nbOpposed + nbCombination + 2]);
				String invocations = infos[nbOpposed + nbCombination + 3].toUpperCase();
				
				String invocationsResult = invocations.substring(0, 1);
				for (int charIndex = 1; charIndex < nbChar; charIndex++) {
					invocationsResult += invocations.substring(charIndex, charIndex + 1);
					String newResult;
					do {
						newResult = compute(invocationsResult);
						if (newResult != null) {
							invocationsResult = newResult;
						} else {
							break;
						}
					} while (true);
				}

				testCaseResult = "[";
				int nbRes = invocationsResult.length();
				for (int i = 0; i < nbRes; i++) {
					if (i != 0) {
						testCaseResult += ", ";
					}
					testCaseResult += invocationsResult.charAt(i);
				}
				testCaseResult += "]";
				
				output += "Case #" + (testCaseNumber+1) + ": " + testCaseResult + "\n";
			}
		}
	}
	
	private String compute(String invocations) {
		String result = null;
		if (invocations.length() > 1) {
			String end = invocations.substring(invocations.length() - 2);
			String combinationResult = combinationMap.get(end);
			if (combinationResult != null) {
				result = invocations.substring(0, invocations.length() - 2) + combinationResult;
			} else {
				int nbOpposed = opposedList.size();
				for (int i = 0; i < nbOpposed; i ++) {
					String[] opposed = opposedList.get(i);
					boolean contains = (invocations.contains(opposed[0]) && invocations.contains(opposed[1]));
					if (contains) {
						return "";
					}
				}
			}
		}
		return result;
	}
	
	
	
	public void init() throws Exception {
		File temp = new File("output/" + this.getClass().getSimpleName());
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/" + this.getClass().getSimpleName() + "/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + this.getClass().getSimpleName() + "/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output, 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		Magicka_2011 instance = new Magicka_2011();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
