

import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Scanner;

public class C {

//	public final static String INPUT_FILE_NAME = "test.in";
	public final static String INPUT_FILE_NAME = "C-small-attempt2.in";
//	public final static String INPUT_FILE_NAME = "C-large.in";
	
	public FileWriter outputWriter;
	public Scanner scanner;
	public StringBuilder output = new StringBuilder();
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());
			
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				int testCaseResult = 0;
				int n = Integer.parseInt(scanner.nextLine());
				HashMap<String, Integer> wordCountLeft = new HashMap<String, Integer>();
				HashMap<String, Integer> wordCountRight = new HashMap<String, Integer>();
				ArrayList<Pair> pairs = new ArrayList<Pair>(n);
				for (int i = 0; i < n; i++) {
					String[] words = scanner.nextLine().split(" ");
					String leftWord = words[0];
					Integer leftCount = wordCountLeft.get(leftWord);
					if (leftCount == null) {
						wordCountLeft.put(leftWord, 1);
					} else {
						wordCountLeft.put(leftWord, leftCount + 1);
					}

					String rightWord = words[1];
					Integer rightCount = wordCountRight.get(rightWord);
					if (rightCount == null) {
						wordCountRight.put(rightWord, 1);
					} else {
						wordCountRight.put(rightWord, rightCount + 1);
					}
					
					pairs.add(new Pair(leftWord, rightWord));
				}
				HashSet<String> leftUsed = new HashSet<String>();
				HashSet<String> rightUsed = new HashSet<String>();
				for (Pair pair : pairs) {
					boolean compute = true;
					if (!leftUsed.contains(pair.leftWord)) {
						leftUsed.add(pair.leftWord);
						rightUsed.add(pair.rightWord);
						compute = false;
					} else if (!rightUsed.contains(pair.rightWord)) {
						int nbRight = wordCountRight.get(pair.rightWord);
						if (nbRight == 1) {
							compute = false;
						}
					}
					if (compute) {
//						int nbLeft = wordCountLeft.get(pair.leftWord);
//						int nbRight = wordCountRight.get(pair.rightWord);
//						if (nbLeft > 1 && nbRight > 1) {
							testCaseResult++;
//						}
					}
				}
				output.append("Case #" + (testCaseNumber+1) + ": " + testCaseResult + "\n");
			}
		}
	}
	
	private class Pair {
		private final String leftWord;
		private final String rightWord;
		Pair(String leftWord, String rightWord) {
			this.leftWord = leftWord;
			this.rightWord = rightWord;
		}
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	
	public void init() throws Exception {
		File temp = new File("output/");
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output.toString(), 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	public static void main(String[] args) throws Exception {
		C instance = new C();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
