

import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Scanner;

public class A {

//	public final static String INPUT_FILE_NAME = "test.in";
	public final static String INPUT_FILE_NAME = "A-small-attempt0.in";
//	public final static String INPUT_FILE_NAME = "A-large.in";
	
	public FileWriter outputWriter;
	public Scanner scanner;
	public StringBuilder output = new StringBuilder();
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());

			final Comparator<Party> comparator = new Comparator<Party>() {
				@Override
				public int compare(Party p1, Party p2) {
					return p2.members.compareTo(p1.members);
				}
			};
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				StringBuilder testCaseResult = new StringBuilder();
				int n = Integer.parseInt(scanner.nextLine());
				String[] members = scanner.nextLine().split(" ");
				ArrayList<Party> parties = new ArrayList<A.Party>(n);
				int count = 0;
				for (int i = 0; i < n; i++) {
					Party party = new Party();
					party.name = (char) ('A' + i);
					party.members = Integer.parseInt(members[i]);
					count += party.members;
					parties.add(party);
				}
				Collections.sort(parties, comparator);
				while (count > 1) {
					Party party = parties.get(0);
					int majority = (int) Math.floor((count - 2) / 2.f) + 1;
					Party nextParty = parties.get(1);
					if (nextParty.members < majority && party.members > 1) {
						party.members -= 2;
						testCaseResult.append(party.name);
						testCaseResult.append(party.name);
						testCaseResult.append(" ");
						count -= 2;
					} else {
						party.members--;
						testCaseResult.append(party.name);
						count--;
						if (count == 1 || count > 2) {
							nextParty.members--;
							testCaseResult.append(nextParty.name);
							count--;
						}
						testCaseResult.append(" ");
					}
					Collections.sort(parties, comparator);
				}
				if (count > 0) {
					Party party = parties.get(0);
					testCaseResult.append(party.name);
				}
				
				output.append("Case #" + (testCaseNumber+1) + ": " + testCaseResult + "\n");
			}
		}
	}
	
	private class Party {
		char name;
		Integer members;
		public String toString() {
			return (name + ": " + members.intValue());
		}
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	
	public void init() throws Exception {
		File temp = new File("output/");
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output.toString(), 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	public static void main(String[] args) throws Exception {
		A instance = new A();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
