package com.google.code.jam;


import java.io.File;
import java.io.FileWriter;
import java.util.Scanner;

public class Round1C_2011_C {

	public FileWriter outputWriter;
	public Scanner scanner;
	public final static String INPUT_FILE_NAME = "C-small-attempt2.in";
	public String output = "";
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		String testCaseResult = null;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				String[] infos = scanner.nextLine().split(" ");
				int N = Integer.parseInt(infos[0]);
				int L = Integer.parseInt(infos[1]);
				int H = Integer.parseInt(infos[2]);
				String[] freqs = scanner.nextLine().split(" ");
				
				long lcm = 1;
				long prevFreq = Long.parseLong(freqs[0]);
				for (int freqInd = 1; freqInd < N; freqInd++) {
					long freq = Long.parseLong(freqs[freqInd]);
					if (prevFreq != 1) {
						long gcd = gcd(prevFreq, freq);
						if (gcd == 1) {
							lcm = lcm(lcm, prevFreq * freq);
						} else {
							lcm = lcm(lcm, gcd);
						}
						if (lcm > H) {
							lcm = 0;
							break;
						}
					}
					prevFreq = freq;
				}
				
				if (lcm >= L) {
					testCaseResult = Long.toString(lcm);
				} else if (lcm > 0) {
					long a = lcm;
					do {
						lcm += a;
					} while (lcm < L);
					if (lcm <= H) {
						testCaseResult = Long.toString(lcm);
					} else {
						testCaseResult = "NO";
					}
				} else {
					if (L == 1) {
						testCaseResult = "1";
					} else {
						testCaseResult = "NO";
					}
				}
				
				output += "Case #" + (testCaseNumber+1) + ": " + testCaseResult + "\n";
			}
		}
	}
	
	public long gcd(long a, long b) {
		if (b==0) return a;
		return gcd(b,a%b);
	}
	
	public long lcm(long a, long b) {
		return (a * b / gcd(a, b));
	}
	
	public void init() throws Exception {
		File temp = new File("output/" + this.getClass().getSimpleName());
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/" + this.getClass().getSimpleName() + "/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + this.getClass().getSimpleName() + "/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output, 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		Round1C_2011_C instance = new Round1C_2011_C();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
