package com.googlecodejam.gcj2013.round1B;

import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;

public class A {

//	public final static String INPUT_FILE_NAME = "test.in";
//	public final static String INPUT_FILE_NAME = "A-small-attempt4.in";
	public final static String INPUT_FILE_NAME = "A-large.in";
	
	public FileWriter outputWriter;
	public Scanner scanner;
	public StringBuilder output = new StringBuilder();
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		int testCaseResult = 0;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());
			
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				String[] infos = scanner.nextLine().split(" ");
				double a = Double.parseDouble(infos[0]);
				int n = Integer.parseInt(infos[1]);
				String[] rawSizes = scanner.nextLine().split(" ");
				ArrayList<Integer> sizes = new ArrayList<Integer>(n);
				for (int i = 0; i < n; i++) {
					sizes.add(Integer.valueOf(rawSizes[i]));
				}
				Collections.sort(sizes);
				
				double moteSize = a;
				if (moteSize == 1) {
					// Can never absorbe
					testCaseResult = n;
				} else {
					testCaseResult = 0;
					for (int i = 0; i < n; i++) {
						double otherMoteSize = sizes.get(i).doubleValue();
						if (moteSize <= otherMoteSize) {
							double nbAdds = nbAdds(moteSize, otherMoteSize);
							if (nbAdds >= n - i) {
								// Delete all
								testCaseResult += n - i;
								if (testCaseResult >= n) {
									testCaseResult = n;
								}
								break;
							} else if (nbAdds > 1) {
								testCaseResult += nbAdds;
								moteSize = Math.pow(2, nbAdds) * (moteSize - 1.) + 1. + otherMoteSize;
								if (testCaseResult >= n) {
									testCaseResult = n;
									break;
								}
							} else {
								testCaseResult++;
								moteSize += moteSize - 1 + otherMoteSize;
							}
						} else {
							moteSize += otherMoteSize;
						}
					}
				}
				
				output.append("Case #" + (testCaseNumber+1) + ": " + testCaseResult + "\n");
			}
		}
	}
	
	private double nbAdds(double currentSize, double otherMoteSize) {
		double nbAdds = Math.ceil(log2((otherMoteSize - 1.) / (currentSize - 1.)));
		double result = Math.pow(2, nbAdds) * (currentSize - 1.) + 1.;
		if (result <= otherMoteSize) {
			nbAdds++;
		}
		return nbAdds;
	}
	
	private double log2(double x) {
		return (Math.log10(x) / Math.log10(2));
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	
	public void init() throws Exception {
		File temp = new File("output/");
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output.toString(), 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		A instance = new A();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
