package com.googlecodejam.gcj2013.qualificationround;

import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Scanner;

public class C {

//	public final static String INPUT_FILE_NAME = "test.in";
	public final static String INPUT_FILE_NAME = "C-small-attempt0.in";
//	public final static String INPUT_FILE_NAME = "C-large.in";
	
	public FileWriter outputWriter;
	public Scanner scanner;
	public String output = "";
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		int testCaseResult = 0;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());

			// Pre-calculus
			ArrayList<Double> results = new ArrayList<Double>();
			double max = Math.floor(Math.sqrt(Math.pow(10, 4)));
			for (double number = 1; number <= max; number++) {
				if (isPalindrome(number)) {
					double square = number * number;
					int unit = (int) (square % 10);
					if (unit == 0 || unit == 2 || unit == 3 || unit == 7 || unit == 8) {
						continue;
					}
					if (isPalindrome(square)) {
						results.add(square);
					}
				}
			}

			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				testCaseResult = 0;
				String[] values = scanner.nextLine().split(" ");
				double a = Double.parseDouble(values[0]);
				double b = Double.parseDouble(values[1]);
				int nbResults = results.size();
				for (int i = 0; i < nbResults; i++) {
					double value = results.get(i);
					if (value < a) {
						continue;
					} else if (value > b) {
						break;
					} else {
						testCaseResult++;
					}
				}
				
				output += "Case #" + (testCaseNumber+1) + ": " + testCaseResult + "\n";
			}
		}
	}

	private boolean isPalindrome(double number) {
		return isPalindrome(String.format("%.0f", number));
	}
	
	private boolean isPalindrome(String number) {
		boolean isPalindrome = true;
		int length = number.length();
		int max = length / 2;
		for (int i = 0; i < max; i++) {
			if (number.charAt(i) != number.charAt(length - i - 1)) {
				isPalindrome = false;
				break;
			}
		}
		return isPalindrome;
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	
	public void init() throws Exception {
		File temp = new File("output/");
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output, 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		C instance = new C();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
