


import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Round1B_A {

	public FileWriter outputWriter;
	public Scanner scanner;
	public final static String INPUT_FILE_NAME = "A-large.in";
	public String output = "";
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		int testCaseResult = 0;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());
			
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				testCaseResult = 0;
				String[] line = scanner.nextLine().split(" ");
				int n = Integer.parseInt(line[0]);
				int m = Integer.parseInt(line[1]);
				List<Node> root = new ArrayList<Node>();
				for (int i = 0; i < n; i++) {
					String[] folders = scanner.nextLine().split("/");
					List<Node> nodes = root;
					for (int j = 1; j < folders.length; j++) {
						String folder = folders[j];
						boolean find = false;
						for (int f = 0; f < nodes.size(); f++) {
							Node node = nodes.get(f);
							if (node.folder.equals(folder)) {
								nodes = node.subFolders;
								find = true;
								break;
							}
						}
						if (!find) {
							Node node = new Node(folder);
							nodes.add(node);
							nodes = node.subFolders;
						}
					}
				}
				for (int i = 0; i < m; i++) {
					String[] folders = scanner.nextLine().split("/");
					List<Node> nodes = root;
					for (int j = 1; j < folders.length; j++) {
						String folder = folders[j];
						boolean find = false;
						for (int f = 0; f < nodes.size(); f++) {
							Node node = nodes.get(f);
							if (node.folder.equals(folder)) {
								nodes = node.subFolders;
								find = true;
								break;
							}
						}
						if (!find) {
							Node node = new Node(folder);
							nodes.add(node);
							testCaseResult++;
							nodes = node.subFolders;
						}
					}
				}
				
				output += "Case #" + (testCaseNumber+1) + ": " + testCaseResult + "\n";
			}
		}
	}
	
	
	class Node {
		String folder;
		List<Node> subFolders = new ArrayList<Node>();
		
		public Node(String folder) {
			this.folder = folder;
		}
		
		public String toString() {
			String s = folder + "{";
			for (Node n : subFolders) {
				s += n + ", ";
			}
			s += "}";
			return s;
		}
		
		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + getOuterType().hashCode();
			result = prime * result
					+ ((folder == null) ? 0 : folder.hashCode());
			return result;
		}
		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			Node other = (Node) obj;
			if (!getOuterType().equals(other.getOuterType()))
				return false;
			if (folder == null) {
				if (other.folder != null)
					return false;
			} else if (!folder.equals(other.folder))
				return false;
			return true;
		}
		private Round1B_A getOuterType() {
			return Round1B_A.this;
		}
		
	}
	
	
	public void init() throws Exception {
		File temp = new File("output/" + this.getClass().getSimpleName());
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/" + this.getClass().getSimpleName() + "/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + this.getClass().getSimpleName() + "/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output, 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		Round1B_A instance = new Round1B_A();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
