

import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Scanner;

public class A {

//	public final static String INPUT_FILE_NAME = "test.in";
		public final static String INPUT_FILE_NAME = "A-small-attempt1.in";
	//	public final static String INPUT_FILE_NAME = "A-large.in";

	public FileWriter outputWriter;
	public Scanner scanner;
	public StringBuilder output = new StringBuilder();

	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		int testCaseResult = 0;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());

			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				testCaseResult = 0;
				String line = scanner.nextLine();
				int n = Integer.parseInt(line);
				ArrayList<String> words = new ArrayList<String>(n);
				for (int i = 0; i < n; i++) {
					words.add(scanner.nextLine());
				}
				Collections.sort(words, new Comparator<String>() {
					@Override
					public int compare(String word1, String word2) {
						return (word2.length() - word1.length());
					}
				});
				int[] diffs = new int[n - 1];
				boolean win = true;
				for (int i = 0; i < n - 1; i++) {
					int nbDiffs = 0;
					String word1 = words.get(i);
					String word2 = words.get(i + 1);
					int indexWord1 = 0;
					int indexWord2 = 0;
					char previousChar = 0;
					int word1Length = word1.length();
					int word2Length = word2.length();
					do {
						char char1 = word1.charAt(indexWord1);
						char char2 = word2.charAt(indexWord2);
						if (char1 != char2) {
							if (char1 == previousChar) {
								indexWord1++;
								nbDiffs++;
							} else if (char2 == previousChar) {
								indexWord2++;
								nbDiffs++;
							} else {
								win = false;
								break;
							}
						} else {
							indexWord1++;
							indexWord2++;
							previousChar = char1;
						}
					} while (win && indexWord1 < word1Length && indexWord2 < word2Length);
//					if (indexWord1 != word1Length || indexWord2 != word2Length) {
//						win = false;
//					}
					if (win) {
						if (indexWord1 != word1Length) {
							for (int k = indexWord1; k < word1Length; k++) {
								if (word1.charAt(k) != previousChar) {
									win = false;
									break;
								} else {
									nbDiffs++;
								}
							}
						} else if (indexWord2 != word2Length) {
							for (int k = indexWord2; k < word2Length; k++) {
								if (word2.charAt(k) != previousChar) {
									win = false;
									break;
								} else {
									nbDiffs++;
								}
							}
						}
						diffs[i] = nbDiffs;
					}
				}
				if (win) {
					testCaseResult = 0;
					int size = (n % 2 == 0 ? n / 2 : (n + 1) / 2);
					for (int i = 0; i < size; i++) {
						int index2 = n - 2 - i;
						if (index2 == i) {
							testCaseResult = diffs[i] * (i + 1);
						} else {
							testCaseResult = (diffs[i] + diffs[index2]) * (i + 1);
						}
					}
					output.append("Case #" + (testCaseNumber+1) + ": " + testCaseResult + "\n");
				} else {
					output.append("Case #" + (testCaseNumber+1) + ": Fegla Won\n");
				}
			}
		}
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////////

	public void init() throws Exception {
		File temp = new File("output/");
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output.toString(), 0, output.length());
		scanner.close();
		outputWriter.close();
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		A instance = new A();
		long start = System.currentTimeMillis();

		instance.init();
		instance.run();
		instance.stop();

		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}

}
