package com.google.code.jam;


import java.io.File;
import java.io.FileWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class FairWarning {

	public FileWriter outputWriter;
	public Scanner scanner;
	public final static String INPUT_FILE_NAME = "B-large.in";
	public String output = "";
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		int nbTests;
		// Test start
		{
			nbTests = Integer.parseInt(scanner.nextLine());
			
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				String[] line = scanner.nextLine().split(" ");
				int nbEvents = Integer.parseInt(line[0]);
				
				List<BigInteger> events = new ArrayList<BigInteger>();
				for (int i = 1; i <= nbEvents; i++) {
					events.add(new BigInteger(line[i]));
				}
				Collections.sort(events);
				BigInteger minGCD = null;
				BigInteger minX = null;
				for (int i = 0; i < events.size() - 1; i++) {
					BigInteger event1 = events.get(i);
					BigInteger event2 = events.get(i + 1);
					if (!event1.equals(event2)) {
						BigInteger diff = event2.subtract(event1);
						BigInteger[] tab = event1.divideAndRemainder(diff);
						BigInteger quotien = tab[0];
						if (!tab[1].equals(BigInteger.ZERO)) {
							quotien = quotien.add(BigInteger.ONE);
						}
						BigInteger x = quotien.multiply(diff).subtract(event1);
						if (minX == null) {
							minX = x;
							minGCD = event2.subtract(event1);
						} else {
							if (x.compareTo(minX) < 0) {
								minX = x;
							}
							minGCD = minGCD.gcd(event2.subtract(event1));
						}
						if (minGCD.equals(BigInteger.ONE)) {
							minX = BigInteger.ZERO;
							break;
						}
					}
				}
				BigInteger res = minX.divideAndRemainder(minGCD)[1];
				output += "Case #" + (testCaseNumber+1) + ": " + res.toString() + "\n";
				
				
//				BigInteger a = events.get(0);
//				BigInteger b = events.get(1);
//				BigInteger minDiff = null;
//				if (!a.equals(b)) {
//					minDiff = b.subtract(a);
//				}
//				for (int i = 1; i < events.size() - 1; i++) {
//					BigInteger event1 = events.get(i);
//					BigInteger event2 = events.get(i + 1);
//					if (!event1.equals(event2)) {
//						BigInteger diff = event2.subtract(event1);
//						if (minDiff == null || diff.compareTo(minDiff) < 0) {
//							minDiff = diff;
//							a = event1;
//							b = event2;
//						}
//					}
//				}
//				BigInteger diff = b.subtract(a);
//				if (diff.equals(BigInteger.ZERO)) {
//					System.out.println("!!!");
//					output += "Case #" + (testCaseNumber+1) + ": 0\n";
//				} else {
//					BigInteger[] tab = a.divideAndRemainder(diff);
//					BigInteger quotien = tab[0];
//					if (!tab[1].equals(BigInteger.ZERO)) {
//						quotien = quotien.add(BigInteger.ONE);
//					}
//					BigInteger res = quotien.multiply(diff).subtract(a);
//					output += "Case #" + (testCaseNumber+1) + ": " + res.toString() + "\n";
//				}
				
				
//				BigInteger firstEvent = new BigInteger(line[1]);
//				BigInteger secondEvent = new BigInteger(line[2]);
//				if (firstEvent.compareTo(secondEvent) > 0) {
//					BigInteger temp = firstEvent;
//					firstEvent = secondEvent;
//					secondEvent = temp;
//				}
//				for (int i = 3; i <= nbEvents; i++) {
//					BigInteger event = new BigInteger(line[i]);
//					if (event.compareTo(firstEvent) < 0) {
//						secondEvent = firstEvent;
//						firstEvent = event;
//					} else if (event.compareTo(secondEvent) < 0) {
//						secondEvent = event;
//					}
//				}
//				BigInteger diff = secondEvent.subtract(firstEvent);
//				BigInteger[] tab = secondEvent.divideAndRemainder(diff);
//				BigInteger quotien = tab[0];
//				if (!tab[1].equals(BigInteger.ZERO)) {
//					quotien = quotien.add(BigInteger.ONE);
//				}
//				BigInteger res = quotien.multiply(diff).subtract(secondEvent);
//				System.out.println(res);
				
//				BigInteger gcd = firstEvent.gcd(secondEvent);
//				for (int i = 3; i <= nbEvents; i++) {
//					gcd = gcd.gcd(new BigInteger(line[i]));
//				}
//				output += "Case #" + (testCaseNumber+1) + ": " + gcd.toString() + "\n";
			}
		}
	}
	
	
	public void init() throws Exception {
		File temp = new File("output/" + this.getClass().getSimpleName());
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/" + this.getClass().getSimpleName() + "/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + this.getClass().getSimpleName() + "/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output, 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		FairWarning instance = new FairWarning();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
