


import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Scanner;

public class Round1C_A {

	public FileWriter outputWriter;
	public Scanner scanner;
	public final static String INPUT_FILE_NAME = "A-large.in";
	public String output = "";
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		int testCaseResult = 0;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());
			
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				int n = Integer.parseInt(scanner.nextLine());
				List<Wire> wires = new ArrayList<Wire>();
				for (int i = 0; i < n; i++) {
					String[] line = scanner.nextLine().split(" ");
					int a = Integer.parseInt(line[0]);
					int b = Integer.parseInt(line[1]);
					wires.add(new Wire(a, b, b - a));
				}
				Collections.sort(wires, new Comparator<Wire>() {
					@Override
					public int compare(Wire o1, Wire o2) {
						return o1.x - o2.x;
					}
				});
				testCaseResult = 0;
				int size = wires.size();
				for (int i = 0; i < size; i++) {
					Wire w = wires.get(i);
						int pos = i+1;
						while (pos < size) {
							Wire w2 = wires.get(pos);
							if (w2.y < w.y){
								testCaseResult++;
							}
							pos++;
						}
				}
				
				output += "Case #" + (testCaseNumber+1) + ": " + testCaseResult + "\n";
			}
		}
	}
	
	class Wire {
		int x;
		int y;
		int length;
		
		public Wire(int x, int y, int length) {
			this.x = x;
			this.y = y;
			this.length = length;
		}
	}
	
	
	public void init() throws Exception {
		File temp = new File("output/" + this.getClass().getSimpleName());
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/" + this.getClass().getSimpleName() + "/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + this.getClass().getSimpleName() + "/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output, 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		Round1C_A instance = new Round1C_A();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
