package com.google.code.jam;


import java.io.File;
import java.io.FileWriter;
import java.util.Scanner;

public class Round1C_2011_A {

	public FileWriter outputWriter;
	public Scanner scanner;
	public final static String INPUT_FILE_NAME = "A-large.in";
	public String output = "";
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());
			
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				String line = scanner.nextLine();
				String[] infos = line.split(" ");
				int R = Integer.parseInt(infos[0]);
				int C = Integer.parseInt(infos[1]);
				char[][] picture = new char[R][C];
				for (int row = 0; row < R; row++) {
					String chars = scanner.nextLine();
					for (int col = 0; col < C; col++) {
						picture[row][col] = chars.charAt(col);
					}
				}
				try {
					for (int row = 0; row < R; row++) {
						for (int col = 0; col < C; col++) {
							char c = picture[row][col];
							if (c == '#') {
								picture[row][col] = '/';
								if (picture[row][col+1] == '#') {
									picture[row][col+1] = '\\';
								} else {
									throw new Exception();
								}
								if (picture[row+1][col] == '#') {
									picture[row+1][col] = '\\';
								} else {
									throw new Exception();
								}
								if (picture[row+1][col+1] == '#') {
									picture[row+1][col+1] = '/';
								} else {
									throw new Exception();
								}
							}
						}
					}
				} catch (Exception e) {
					picture = null;
				}
				output += "Case #" + (testCaseNumber+1) + ":\n";
				if (picture == null) {
					output += "Impossible\n";
				} else {
					for (int row = 0; row < R; row++) {
						for (int col = 0; col < C; col++) {
							output += Character.toString(picture[row][col]);
						}
						output += "\n";
					}
				}
				
			}
		}
	}
	
	
	public void init() throws Exception {
		File temp = new File("output/" + this.getClass().getSimpleName());
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/" + this.getClass().getSimpleName() + "/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + this.getClass().getSimpleName() + "/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output, 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		Round1C_2011_A instance = new Round1C_2011_A();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
