package com.googlecodejam.gcj2013.qualificationround;

import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Scanner;

public class D {

//	public final static String INPUT_FILE_NAME = "test.in";
	public final static String INPUT_FILE_NAME = "D-small-attempt3.in";
//	public final static String INPUT_FILE_NAME = "D-large.in";
	
	public FileWriter outputWriter;
	public Scanner scanner;
	public StringBuilder output = new StringBuilder();
	
	private int nbChests = 0;
	private HashMap<String, ArrayList<String>> chestsByKey = null;
	private HashMap<String, ArrayList<String>> keysByChest = null;
	private HashMap<String, String> chestToKey = null;
	private boolean found = false;
	private ArrayList<String> openOrder = null;
	private HashMap<String, Integer> keysCount = null;
	private StringComparator stringComparator = new StringComparator();
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());
			
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				String[] kn = scanner.nextLine().split(" ");
				int keysAtBeginningNumber_k = Integer.parseInt(kn[0]);
				nbChests = Integer.parseInt(kn[1]);
				keysCount = new HashMap<String, Integer>();
				String[] rawKeysAtBeginning = scanner.nextLine().split(" ");
				ArrayList<String> keysAtBeginning = new ArrayList<String>(keysAtBeginningNumber_k);
				for (int i = 0; i < keysAtBeginningNumber_k; i++) {
					String key = rawKeysAtBeginning[i];
					keysAtBeginning.add(key);
					
					Integer count = keysCount.get(key);
					if (count == null) {
						count = 1;
					} else {
						count++;
					}
					keysCount.put(key, count);
				}
				Collections.sort(keysAtBeginning);
				chestsByKey = new HashMap<String, ArrayList<String>>(nbChests);
				keysByChest = new HashMap<String, ArrayList<String>>(nbChests);
				chestToKey = new HashMap<String, String>(nbChests);
				openOrder = new ArrayList<String>(nbChests);
				for (int i = 0; i < nbChests; i++) {
					String chestName = Integer.toString(i + 1);
					String[] chestDescription = scanner.nextLine().split(" ");
					String keyToOpenChest_ti = chestDescription[0];
					chestToKey.put(chestName, keyToOpenChest_ti);
					int numberOfKeysInsideChest_ki = Integer.parseInt(chestDescription[1]);
					ArrayList<String> chestsOfKey = chestsByKey.get(keyToOpenChest_ti);
					if (chestsOfKey == null) {
						chestsOfKey = new ArrayList<String>();
						chestsByKey.put(keyToOpenChest_ti, chestsOfKey);
					}
					chestsOfKey.add(chestName);
					ArrayList<String> keysOfChest = new ArrayList<String>(numberOfKeysInsideChest_ki);
					keysByChest.put(chestName, keysOfChest);
					for (int j = 0; j < numberOfKeysInsideChest_ki; j++) {
						String key = chestDescription[j+2];
						keysOfChest.add(key);
						Integer count = keysCount.get(key);
						if (count == null) {
							count = 1;
						} else {
							count++;
						}
						keysCount.put(key, count);
					}
				}
				boolean impossible = false;
				for (String key : keysCount.keySet()) {
					ArrayList<String> chests = chestsByKey.get(key);
					if (chests != null && keysCount.get(key).intValue() < chests.size()) {
						impossible = true;
						break;
					}
				}
				// Compute
				found = false;
				if (!impossible) {
					ArrayList<String> keysInHand = new ArrayList<String>(keysAtBeginning);
					HashSet<String> openedChests = new HashSet<String>(nbChests);
					open(keysInHand, openedChests);
				}
				
				output.append("Case #" + (testCaseNumber+1) + ":");
				if (found) {
					for (String s : openOrder) {
						output.append(" " + s);
					}
				} else {
					output.append(" IMPOSSIBLE");
				}
				output.append("\n");
			}
		}
	}
	
	private void open(ArrayList<String> keysInHand, HashSet<String> openedChests) {
		ArrayList<String> chestsOpenable = chestsOpenableWithKeys(keysInHand);
		for (String chest : chestsOpenable) {
			if (found) {
				break;
			}
			if (!openedChests.contains(chest)) {
				openOrder.add(chest);
				
				if (openOrder.size() == nbChests) {
					found = true;
					break;
				}
				
				ArrayList<String> newKeysInHand = new ArrayList<String>(keysInHand);
				String keyUsed = chestToKey.get(chest);
				newKeysInHand.remove(keyUsed);
				
				HashSet<String> newOpenedChests = new HashSet<String>(openedChests);
				newOpenedChests.add(chest);
				
				ArrayList<String> keys = keysByChest.get(chest);
				newKeysInHand.addAll(keys);
				
				// Verification
				int nbNecessaryKeys = 0;
				ArrayList<String> chests = chestsByKey.get(keyUsed);
				for (String c : chests) {
					if (!newOpenedChests.contains(c)) {
						nbNecessaryKeys++;
					}
				}
				if (nbNecessaryKeys > 0) {
					int haveKey = 0;
					for (String key : newKeysInHand) {
						if (key.equals(keyUsed)) {
							haveKey++;
						}
					}
					if (haveKey < nbNecessaryKeys) {
						for (String chestOpenable : chestsOpenableWithKeys(newKeysInHand)) {
							for (String k : keysByChest.get(chestOpenable)) {
								if (k.equals(keyUsed)) {
									haveKey++;
								}
							}
						}
						if (haveKey < nbNecessaryKeys) {
							openOrder.remove(openOrder.size() - 1);
							continue;
						}
					}
				}

				open(newKeysInHand, newOpenedChests);
			}
		}
		if (!found) {
			if (openedChests.size() == nbChests) {
				found = true;
			} else if (openOrder.size() > 0) {
				openOrder.remove(openOrder.size() - 1);
			}
		}
	}
	
	private ArrayList<String> chestsOpenableWithKeys(ArrayList<String> keys) {
		ArrayList<String> chestsOpenable = new ArrayList<String>();
		HashSet<String> treatedKeys = new HashSet<String>(keys.size());
		for (String key : keys) {
			if (!treatedKeys.contains(key)) {
				treatedKeys.add(key);
				ArrayList<String> chests = chestsByKey.get(key);
				if (chests != null) {
					chestsOpenable.addAll(chests);						
				}
			}
		}
		chestsOpenable.removeAll(openOrder);
		Collections.sort(chestsOpenable, stringComparator);
		return chestsOpenable;
	}
	
	private class StringComparator implements Comparator<String> {
		@Override
		public int compare(String s1, String s2) {
			int delta = s1.length() - s2.length();
			if (delta == 0) {
				return s1.compareTo(s2);
			}
			return delta;
		}
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	
	public void init() throws Exception {
		File temp = new File("output/");
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output.toString(), 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		D instance = new D();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
