

import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Scanner;

public class D {

//	public final static String INPUT_FILE_NAME = "test.in";
	public final static String INPUT_FILE_NAME = "D-small-attempt2.in";
//	public final static String INPUT_FILE_NAME = "D-large.in";
	
	public FileWriter outputWriter;
	public Scanner scanner;
	public StringBuilder output = new StringBuilder();
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());
			
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				String testCaseResult = null;
				
				String[] line = scanner.nextLine().split(" ");
				int n = Integer.parseInt(line[0]);
				int m = Integer.parseInt(line[1]);
				
				HashMap<String, Count> constraints = new HashMap<String, D.Count>();
				for (int i = 0; i < n; i++) {
					constraints.put(getRowKey(i), new Count());
					constraints.put(getColKey(i), new Count());
					constraints.put("d1" + i, new Count());
					constraints.put("d1" + (-i), new Count());
					constraints.put("d2" + i, new Count());
					constraints.put("d2" + (i + n - 1), new Count());
				}
				
				HashMap<String, Character> grid = new HashMap<String, Character>();

				int points = 0;
				for (int i = 0; i < m; i++) {
					line = scanner.nextLine().split(" ");
					char symbol = line[0].charAt(0);
					int r = Integer.parseInt(line[1]) - 1;
					int c = Integer.parseInt(line[2]) - 1;
					grid.put(getGridKey(r, c), symbol);

					Count rowConstraint = constraints.get(getRowKey(r));
					Count colConstraint = constraints.get(getColKey(c));
					Count diag1Constraint = constraints.get(getDiag1Key(r, c));
					Count diag2Constraint = constraints.get(getDiag2Key(r, c));
					switch (symbol) {
						case '+':
							rowConstraint.nbP++;
							colConstraint.nbP++;
							diag1Constraint.nbP++;
							diag2Constraint.nbP++;
							points++;
							break;
						case 'x':
							rowConstraint.nbX++;
							colConstraint.nbX++;
							diag1Constraint.nbX++;
							diag2Constraint.nbX++;
							points++;
							break;
						case 'o':
							rowConstraint.nbO++;
							colConstraint.nbO++;
							diag1Constraint.nbO++;
							diag2Constraint.nbO++;
							points += 2;
							break;
						default:
							break;
					}
				}
				
				int modified = 0;
				ArrayList<GridUpdate> updates = new ArrayList<GridUpdate>();
				for (int row = 0; row < n; row++) {
					for (int col = 0; col < n; col++) {
						Count rowConstraint = constraints.get(getRowKey(row));
						Count colConstraint = constraints.get(getColKey(col));
						Count diag1Constraint = constraints.get(getDiag1Key(row, col));
						Count diag2Constraint = constraints.get(getDiag2Key(row, col));
						Character currentChar = grid.get(getGridKey(row, col));
						int rowX = rowConstraint.nbX;
						int rowO = rowConstraint.nbO;
						int colX = colConstraint.nbX;
						int colO = colConstraint.nbO;
						int diag1P = diag1Constraint.nbP;
						int diag1O = diag1Constraint.nbO;
						int diag2P = diag2Constraint.nbP;
						int diag2O = diag2Constraint.nbO;
						if (currentChar != null) {
							switch (currentChar) {
								case 'x':
									rowX--;
									colX--;
									break;
								case '+':
									diag1P--;
									diag2P--;
									break;
								default:
									break;
							}
						}
						// o?
						if (rowO == 0 && colO == 0 && diag1O == 0 && diag2O == 0 &&
							rowX == 0 && colX == 0 && diag1P == 0 && diag2P == 0) {
							if (currentChar != null) {
								if (currentChar == 'x') {
									points++;
									rowConstraint.nbX--;
									colConstraint.nbX--;
									diag1Constraint.nbX--;
									diag2Constraint.nbX--;
								} else if (currentChar == '+') {
									points++;
									rowConstraint.nbP--;
									colConstraint.nbP--;
									diag1Constraint.nbP--;
									diag2Constraint.nbP--;
								} else {
									System.out.println("Error!");
								}
							} else {
								points += 2;
							}
							modified++;
							updates.add(new GridUpdate('o', row, col));
							grid.put(getGridKey(row, col), 'o');
							rowConstraint.nbO++;
							colConstraint.nbO++;
							diag1Constraint.nbO++;
							diag2Constraint.nbO++;
						} else if (currentChar == null) {
							// +?
							if (diag1O == 0 && diag2O == 0 &&
								diag1P == 0 && diag2P == 0) {
								modified++;
								points++;
								updates.add(new GridUpdate('+', row, col));
								grid.put(getGridKey(row, col), '+');
								rowConstraint.nbP++;
								colConstraint.nbP++;
								diag1Constraint.nbP++;
								diag2Constraint.nbP++;
							}
							// x?
							else if (rowO == 0 && colO == 0 &&
									rowX == 0 && colX == 0) {
								modified++;
								points++;
								updates.add(new GridUpdate('x', row, col));
								grid.put(getGridKey(row, col), 'x');
								rowConstraint.nbX++;
								colConstraint.nbX++;
								diag1Constraint.nbX++;
								diag2Constraint.nbX++;
							}
						}
					}
				}
				testCaseResult = points + " " + modified;
				for (int i = 0; i < modified; i++) {
					GridUpdate update = updates.get(i);
					testCaseResult += "\n" + Character.toString(update.symbol) + " " + (update.r + 1) + " " + (update.c + 1);
				}
				
				output.append("Case #" + (testCaseNumber+1) + ": " + testCaseResult + "\n");
			}
		}
	}
	
	private static String getRowKey(int r) {
		return ("r" + r);
	}
	
	private static String getColKey(int c) {
		return ("c" + c);
	}
	
	private static String getDiag1Key(int r, int c) {
		return ("d1" + (r - c));
	}
	
	private static String getDiag2Key(int r, int c) {
		return ("d2" + (r + c));
	}
	
	private static String getGridKey(int r, int c) {
		return (r + "-" + c);
	}
	
	
	private static class Count {
		private int nbX = 0;
		private int nbP = 0;
		private int nbO = 0;
	}
	
	private static class GridUpdate {
		private final char symbol;
		private final int r;
		private final int c;
		private GridUpdate(char symbol, int r, int c) {
			this.symbol = symbol;
			this.r = r;
			this.c = c;
		}
	}
	
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	
	public void init() throws Exception {
		File temp = new File("output/");
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output.toString(), 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	public static void main(String[] args) throws Exception {
		D instance = new D();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
