package com.google.code.jam;


import java.io.File;
import java.io.FileWriter;
import java.util.Scanner;

public class SnapperChain {

	public FileWriter outputWriter;
	public Scanner scanner;
	public final static String INPUT_FILE_NAME = "A-large.in";
	public String output = "";
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		String testCaseResult = null;
		int nbTests;
		// Test start
		{
			nbTests = Integer.parseInt(scanner.nextLine());
			
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				String[] line = scanner.nextLine().split(" ");
				int n = Integer.parseInt(line[0]);
				long k = Long.parseLong(line[1]);
				long pow2N = (long) Math.pow(2, n);
				if (k % pow2N == (pow2N - 1)) {
					testCaseResult = "ON";
				} else {
					testCaseResult = "OFF";
				}
				output += "Case #" + (testCaseNumber+1) + ": " + testCaseResult + "\n";
			}
		}
	}
	
	
	public void init() throws Exception {
		File temp = new File("output/" + this.getClass().getSimpleName());
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/" + this.getClass().getSimpleName() + "/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + this.getClass().getSimpleName() + "/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output, 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		SnapperChain instance = new SnapperChain();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
