package com.google.code.jam;


import java.io.File;
import java.io.FileWriter;
import java.util.Scanner;

public class BotTrust {

	public FileWriter outputWriter;
	public Scanner scanner;
	public final static String INPUT_FILE_NAME = "A-large.in";
	public String output = "";
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());
			
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				int oTime = 0;
				int bTime = 0;
				int oPos = 1;
				int bPos = 1;
				int globalTime = 0;
				
				String[] infos = scanner.nextLine().split(" ");
				int nbButtonsToPush = Integer.parseInt(infos[0]);
				for (int i = 0; i < nbButtonsToPush; i++) {
					boolean isBlueBot = "B".equalsIgnoreCase(infos[1 + i * 2]);
					int buttonPos = Integer.parseInt(infos[(1 + i) * 2]);
					if (isBlueBot) {
						int timeToMove = Math.abs(buttonPos - bPos);
						int delta = Math.max(0, timeToMove - (globalTime - bTime));
						
						bTime = globalTime + delta + 1;
						bPos = buttonPos;
						globalTime = bTime;
					} else {
						int timeToMove = Math.abs(buttonPos - oPos);
						int delta = Math.max(0, timeToMove - (globalTime - oTime));
						
						oTime = globalTime + delta + 1;
						oPos = buttonPos;
						globalTime = oTime;
					}
				}
				output += "Case #" + (testCaseNumber+1) + ": " + globalTime + "\n";
			}
		}
	}
	
	
	public void init() throws Exception {
		File temp = new File("output/" + this.getClass().getSimpleName());
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/" + this.getClass().getSimpleName() + "/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + this.getClass().getSimpleName() + "/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output, 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		BotTrust instance = new BotTrust();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
