

import java.io.File;
import java.io.FileWriter;
import java.util.HashSet;
import java.util.Scanner;

public class A {

//	public final static String INPUT_FILE_NAME = "test.in";
//	public final static String INPUT_FILE_NAME = "A-small-attempt0.in";
	public final static String INPUT_FILE_NAME = "A-large.in";
	
	public FileWriter outputWriter;
	public Scanner scanner;
	public StringBuilder output = new StringBuilder();
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());
			
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				String line = scanner.nextLine();
				long n = Long.parseLong(line);
				if (n == 0) {
					output.append("Case #" + (testCaseNumber+1) + ": INSOMNIA\n");
				} else {
					HashSet<Character> remaining = new HashSet<Character>();
					for (int i = 0; i < 10; i++) {
						remaining.add(Character.forDigit(i, 10));
					}
					long lastNumber = n;
					long factor = 1;
					while (remaining.size() > 0) {
						long newNumber = factor * n;
						removeDigits(newNumber, remaining);
						lastNumber = newNumber;
						factor++;
					}
					output.append("Case #" + (testCaseNumber+1) + ": " + lastNumber + "\n");
				}
			}
		}
	}
	
	private void removeDigits(long number, HashSet<Character> remaining) {
		String s = Long.toString(number);
		int length = s.length();
		for (int i = 0; i < length; i++) {
			char c = s.charAt(i);
			remaining.remove(c);
		}
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	
	public void init() throws Exception {
		File temp = new File("output/");
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output.toString(), 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	public static void main(String[] args) throws Exception {
		A instance = new A();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
