package com.google.code.jam;


import java.io.File;
import java.io.FileWriter;
import java.util.Scanner;

public class ThemePark {

	public FileWriter outputWriter;
	public Scanner scanner;
	public final static String INPUT_FILE_NAME = "C-small-attempt0.in";
	public String output = "";
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		int testCaseResult = 0;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());
			
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				String[] line = scanner.nextLine().split(" ");
				long maxRuns = Long.parseLong(line[0]);
				long maxCapacity = Long.parseLong(line[1]);
				int nbGroups = Integer.parseInt(line[2]);
				String[] groupsSizeTemp = scanner.nextLine().split(" ");
				int[] groupsSize = new int[nbGroups];
				for (int i = 0; i < nbGroups; i++) {
					groupsSize[i] = Integer.parseInt(groupsSizeTemp[i]);
				}
				int pos = 0;
				testCaseResult = 0;
				for (int run = 0; run < maxRuns; run++) {
					int nbPos = 0;
					int capacity = 0;
					do {
						capacity += groupsSize[pos%nbGroups];
						nbPos++;
					} while ((capacity + groupsSize[(++pos)%nbGroups] <= maxCapacity) && nbPos < nbGroups);
					testCaseResult += capacity;
				}
				output += "Case #" + (testCaseNumber+1) + ": " + testCaseResult + "\n";
			}
		}
	}
	
	
	public void init() throws Exception {
		File temp = new File("output/" + this.getClass().getSimpleName());
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/" + this.getClass().getSimpleName() + "/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + this.getClass().getSimpleName() + "/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output, 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		ThemePark instance = new ThemePark();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
