

import java.io.File;
import java.io.FileWriter;
import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.Scanner;

public class C {

//	public final static String INPUT_FILE_NAME = "test.in";
	public final static String INPUT_FILE_NAME = "C-small-1-attempt0.in";
//	public final static String INPUT_FILE_NAME = "C-small-2-attempt0.in";
//	public final static String INPUT_FILE_NAME = "C-large.in";
	
	public FileWriter outputWriter;
	public Scanner scanner;
	public StringBuilder output = new StringBuilder();
	
	public void run() throws Exception {
		// Commons variables
		int testCaseNumber = 0;
		// Test start
		{
			int nbTests = Integer.parseInt(scanner.nextLine());
			
			for (testCaseNumber = 0; testCaseNumber < nbTests; testCaseNumber++) {
				String testCaseResult = null;
				String[] line = scanner.nextLine().split(" ");
				long n = Long.parseLong(line[0]);
				long k = Long.parseLong(line[1]);
				if (n == k) {
					testCaseResult = "0 0";
				} else {
					PriorityQueue<Long> queue = new PriorityQueue<Long>(new Comparator<Long>() {
						@Override
						public int compare(Long s1, Long s2) {
							return (int) (s2 - s1);
						}
					});
					queue.add(n);
					long right = 0;
					long left = 0;
					for (int i = 0; i < k; i++) {
						long stall = queue.poll();
						right = (stall - 1) / 2;
						left = stall - 1 - right;
						if (right > 0) {
							queue.add(right);
						}
						if (left > 0) {
							queue.add(left);
						}
					}
					testCaseResult = Math.max(left, right) + " " + Math.min(left, right);
				}
				output.append("Case #" + (testCaseNumber+1) + ": " + testCaseResult + "\n");
			}
		}
	}
	
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////
	
	public void init() throws Exception {
		File temp = new File("output/");
		if (!temp.exists()) {
			temp.mkdir();
		}
		// Output file
		outputWriter = new FileWriter("output/output.txt", false);
		// Input file
		scanner = new Scanner(new File("resources/" + INPUT_FILE_NAME));
	}

	public void stop() throws Exception {
		// Closing files
		outputWriter.write(output.toString(), 0, output.length());
		scanner.close();
		outputWriter.close();
	}
	
	public static void main(String[] args) throws Exception {
		C instance = new C();
		long start = System.currentTimeMillis();
		
		instance.init();
		instance.run();
		instance.stop();
		
		System.out.println("Finished in " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
