import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main {

	private static final String aFileName = "input.in";
	final static Charset ENCODING = StandardCharsets.UTF_8;

	private static int cases;
	private static int[] answer;
	private static int r;

	public static void main(String[] args) {
		Path path = Paths.get(aFileName);
		try (Scanner scanner = new Scanner(path, ENCODING.name())) {

			cases = scanner.nextInt();
			answer = new int[cases];
			
			for (int h = 0; h < cases; h++)
				answer[h] = 0;

			for (r = 0; r < cases; r++) {

				int a = scanner.nextInt();
				int b = scanner.nextInt();
				
				for (int k=a; k <= b; k++)
				{
					double sqrt = Math.sqrt(k);
					if (Math.ceil(sqrt) == (int)sqrt)
					{
						if (isFair((int) sqrt))
							if (isFair(k))
							{
								answer[r] ++;
								System.out.println(k);
							}
					}
				}

			}

			writeToFile();

		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static boolean isFair(int k) {

		ArrayList<String> list = new ArrayList<String>();
		int kCopy=k;
		int count=-1;
		while (kCopy!=0)
		{
			list.add(Integer.toString(kCopy%10));
			kCopy /=10;
			count++;
		}
		for (int j=0; j <list.size(); j++)
		{
			double pow = Math.pow(10,count);
			kCopy += (pow)*Integer.parseInt(list.get(j));
			count--;
		}
		if (k == kCopy)
			return true;
		else 
			return false;
		
	}

	private static void writeToFile() {

		File file = new File("output.txt");

		// if file doesnt exists, then create it
		try {
			if (!file.exists()) {

				file.createNewFile();
			}
			FileWriter fw = new FileWriter(file.getAbsoluteFile());
			BufferedWriter bw = new BufferedWriter(fw);
			for (int k = 0; k < cases; k++) {
				String content = "Case #" + Integer.toString(k + 1) + ": " + Integer.toString(answer[k]) + "\n";
				bw.write(content);
			}
			bw.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
