package com.danny;

import java.io.FileWriter;
import java.io.IOException;
import java.util.*;

/**
 * Created by danny on 4/9/16.
 */
public class CoinJam {

    private static Map<Long, Integer> divisors = new HashMap<>();

    public static void main(String[] args) throws IOException {

        int n = Integer.valueOf(args[0]);
        int j = Integer.valueOf(args[1]);

        FileWriter fileWriter = new FileWriter(args[2]);

        HashSet<CoinJamString> coinJamStrings = new HashSet<>();


        while (coinJamStrings.size() < j) {

            String coinJam = getRandomString(n);

            List<Integer> res = isCoinJam(coinJam);

            if (res.size() == 9) {

                coinJamStrings.add(new CoinJamString(coinJam, res));
            }

        }

        fileWriter.write("Case #1:\n");

        for (CoinJamString coinJamString : coinJamStrings) {
            fileWriter.write(coinJamString.toString());
            fileWriter.write("\n");
        }

        fileWriter.close();

    }

    private final static Random random = new Random();

    private static String getRandomString(int n) {


        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append(1);


        for (int i = 0; i < n - 2; i++) {
            stringBuilder.append(random.nextInt(2));
        }

        stringBuilder.append(1);

        return stringBuilder.toString();
    }

    private static List<Integer> isCoinJam(String coinJam) {

        ArrayList<Integer> res = new ArrayList<>();

        for (int i = 2; i <= 10; i++) {

            Long num = Long.valueOf(coinJam, i);

            Integer integer = divisors.getOrDefault(num, -1);

            if (integer == -1) {

                integer = divisor(num);
                divisors.put(num, integer);

            }

            if (integer == 1) {
                return res;
            } else {
                res.add(integer);
            }

        }

        return res;

    }

    private static int divisor(Long num) {


        int max = (int) Math.sqrt(num) + 1;

        for (int i = 2; i < max; i++) {

            if (num % i == 0) {
                return i;
            }
        }

        return 1;
    }


    private static class CoinJamString {

        private String coinJam;

        private List<Integer> divisors;

        private CoinJamString(String coinJam, List<Integer> divisors) {
            this.coinJam = coinJam;
            this.divisors = divisors;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            CoinJamString that = (CoinJamString) o;

            return coinJam != null ? coinJam.equals(that.coinJam) : that.coinJam == null;

        }

        @Override
        public int hashCode() {
            return coinJam != null ? coinJam.hashCode() : 0;
        }

        @Override
        public String toString() {

            StringBuilder sb = new StringBuilder();

            sb.append(coinJam).append(' ');

            for (Integer divisor : divisors) {
                sb.append(divisor).append(' ');
            }

            return sb.toString();
        }
    }
}
