package com.danny;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class PancakeRevenge {

    public static void main(String[] args) throws IOException {

        String inputFile = args[0];

        Scanner scanner = new Scanner(new FileReader(inputFile));

        scanner.useDelimiter("\n");

        FileWriter fileWriter = new FileWriter(inputFile + ".out");

        int testCases = scanner.nextInt();

        for (int i = 0; i < testCases; i++) {

            String pancakeString = scanner.next();

            int result = calculate(pancakeString);
            fileWriter.write(String.format("Case #%d: %d%n", i + 1, result));

        }

        fileWriter.close();
        scanner.close();

    }

    private static int calculate(String pancakeString) {

        int flips = 0;

        char flipped = '-';

        int i = pancakeString.length() - 1;
        while (i >= 0) {

            char c = pancakeString.charAt(i);

            // greedy pick last
            if (c == flipped) {
                flips++;
            } else {
                i--;
                continue;
            }

            while (c == flipped && --i >= 0) {
                c = pancakeString.charAt(i);
            }

            flipped = flipped == '+' ? '-' : '+';
        }

        return flips;

    }
}
