package com.danny;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.HashSet;
import java.util.Scanner;

/**
 * Created by danny on 4/9/16.
 */
public class CountingSheep {

    public static void main(String[] args) throws IOException {

        String inputFile = args[0];

        Scanner scanner = new Scanner(new FileReader(inputFile));

        scanner.useDelimiter("\n");

        FileWriter fileWriter = new FileWriter(inputFile + ".out");

        int cases = scanner.nextInt();

        for (int i = 0; i < cases; i++) {

            int input = scanner.nextInt();

            String res = calculate(input);

            fileWriter.write(String.format("Case #%d: %s%n", i + 1, res));
        }

        fileWriter.close();
        scanner.close();
    }

    private static String calculate(int input) {

        if (input == 0) {
            return "INSOMNIA";
        }

        HashSet<Character> digitsSeen = new HashSet<>();

        BigInteger val = new BigInteger(String.valueOf(input));

        while (true) {

            String s = val.toString();

            addAll(digitsSeen, s);

            if (digitsSeen.size() == 10) {
                return s;
            }

            val = val.add(BigInteger.valueOf(input));

        }

    }

    private static void addAll(HashSet<Character> digitsSeen, String s) {

        for (char c : s.toCharArray()) {
            digitsSeen.add(c);
        }

    }

}
