package problem3;

import java.util.*;
import java.io.*;

public class Main {

    private static TreeMap<Long, TreeSet<Long>> segments = new TreeMap<>();

    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        for (int testCase = 1; testCase <= t; ++testCase) {
            long n = in.nextLong();
            long k = in.nextLong();
//            System.out.println("n[" + n + "] k[" + k + "]");
            performTest(n, k, testCase);
//            performTestPQueue(n, k, testCase);
        }
//        performTest(999, 999, 3);
//        performTest(9999, 9999, 4);
//        performTest(99999, 99999, 5);
//        performTest(999999, 999999, 6);
//        performTest(9999999, 9999999, 7);
//        performTest(99999999, 99999999, 8);
//        performTestPQueue(999, 999, 3);
//        performTestPQueue(9999, 9999, 4);
//        performTestPQueue(99999, 99999, 5);
//        performTestPQueue(999999, 999999, 6);
//        performTestPQueue(9999999, 9999999, 7);

//        performTest(4, 2, 1);
//        performTestPQueue(4, 2, 1);
//        performTest(5, 2, 2);
//        performTestPQueue(5, 2, 2);
//        performTest(5, 2, 3);
//        performTestPQueue(5, 2, 3);
//        performTest(1000, 1000, 4);
//        performTestPQueue(1000, 1000, 4);
//        performTest(1000, 1, 5);
//        performTestPQueue(1000, 1, 5);
    }

    private static void performTest(long n, long k, int testCase) {

        long leftSize = 0;
        long rightSize = 0;
        
        segments.clear();
        
//        long startTime = System.nanoTime();
        TreeSet<Long> n_set = new TreeSet();
        n_set.add(0L);
        segments.put(n, n_set);

        for (int i = 0; i < k; ++i) {
            Map.Entry<Long, TreeSet<Long>> bestChoices = segments.lastEntry();
            Long bestSize = bestChoices.getKey();
            TreeSet<Long> remainingSizes = bestChoices.getValue();
            Long firstIdx = remainingSizes.pollFirst();
            if (remainingSizes.isEmpty()) {
                segments.remove(bestSize);
            }

            long remaingPlaces = bestSize - 1;
            leftSize = remaingPlaces / 2;
            rightSize = remaingPlaces - leftSize;

            long leftIdx = firstIdx;
            long rightIdx = leftIdx + leftSize + 1;

            if (leftSize > 0) {
                addToTreeSet(leftSize, leftIdx);
            }
            if (rightSize > 0) {
                addToTreeSet(rightSize, rightIdx);
            }
        }

//        long elapsedTime = (System.nanoTime() - startTime) / 1000000;
        System.out.println("Case #" + testCase + ": " + rightSize + " " + leftSize);
//        System.out.println("Case #" + testCase + ": " + n + ": " + elapsedTime + ": " + rightSize + " " + leftSize);
    }

    private static void addToTreeSet(long size, long idx) {
        TreeSet<Long> set = segments.get(size);
        if (set == null) {
            set = new TreeSet<>();
            segments.put(size, set);
        }
        set.add(idx);
    }

//    private static void performTestPQueue(long n, long k, int testCase) {
//
//        long leftSize = 0;
//        long rightSize = 0;
//        long startTime = System.nanoTime();
//        PriorityQueue<Segment> pQueue = new PriorityQueue<>();
//        pQueue.add(new Segment(n, 0));
//
//        for (int i = 0; i < k; ++i) {
//            Segment bestSegm = pQueue.poll();
//            long remaingPlaces = bestSegm.size - 1;
//            leftSize = remaingPlaces / 2;
//            rightSize = remaingPlaces - leftSize;
//
//            long leftIdx = bestSegm.firstIdx;
//            long rightIdx = leftIdx + leftSize + 1;
//
//            if (leftSize > 0) {
//                pQueue.add(new Segment(leftSize, leftIdx));
//            }
//            if (rightSize > 0) {
//                pQueue.add(new Segment(rightSize, rightIdx));
//            }
//        }
//
//        long elapsedTime = (System.nanoTime() - startTime) / 1000000;
////        System.out.println("Case #" + testCase + ": " + rightSize + " " + leftSize);
//        System.out.println("Case #" + testCase + ": " + n + ": " + elapsedTime + ": " + rightSize + " " + leftSize);
//    }
//
//    private static class Segment implements Comparable<Segment> {
//
//        long size;
//        long firstIdx;
//
//        public Segment(long size, long firstIdx) {
//            this.size = size;
//            this.firstIdx = firstIdx;
//        }
//
//        @Override
//        public int compareTo(Segment t) {
//            if (this.size > t.size) {
//                return -1;
//            }
//            if (this.size < t.size) {
//                return 1;
//            }
//            if (this.firstIdx > t.firstIdx) {
//                return -1;
//            }
//            if (this.firstIdx < t.firstIdx) {
//                return 1;
//            }
//            return 0;
//        }
//    }

}
