package problem2;

import java.util.*;
import java.io.*;

public class Main {

    private static final int O = 0;
    private static final int G = 1;
    private static final int V = 2;

    private static final int R = 3;
    private static final int Y = 4;
    private static final int B = 5;

    private static final int[][] COMP = {
        {0, 0, 0, 0, 0, 1}, // O
        {0, 0, 0, 1, 0, 0}, // G
        {0, 0, 0, 0, 1, 0}, // V
        {0, 1, 0, 0, 1, 1}, // R
        {0, 0, 1, 1, 0, 1}, // Y
        {1, 0, 0, 1, 1, 0} //  B
    //   O  G  V  R  Y  B
    };

    private static final char[] CONV = {'O', 'G', 'V', 'R', 'Y', 'B'};

    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        for (int testCase = 1; testCase <= t; ++testCase) {
            long[] unicorns = new long[6];

            int n = in.nextInt();
            unicorns[R] = in.nextLong();
            unicorns[O] = in.nextLong();
            unicorns[Y] = in.nextLong();
            unicorns[G] = in.nextLong();
            unicorns[B] = in.nextLong();
            unicorns[V] = in.nextLong();
            performTest(testCase, n, unicorns);
        }
//        long[] unicorns = new long[6];
//        unicorns[R] = 2;
//        unicorns[O] = 0;
//        unicorns[Y] = 1;
//        unicorns[G] = 0;
//        unicorns[B] = 1;
//        unicorns[V] = 0;
//        performTest(1, 4, unicorns);
    }

    private static void performTest(int testCase, int n, long... unicorns) {

        int[] result = new int[n];
        int idx = 0;

        int horse = getIdxMax(unicorns);
        unicorns[horse]--;
        result[idx++] = horse;
        while (idx < n) {
            horse = getIdxMax(
                    COMP[result[idx - 1]][O] * unicorns[O],
                    COMP[result[idx - 1]][G] * unicorns[G],
                    COMP[result[idx - 1]][V] * unicorns[V],
                    0, 0, 0);
            if (horse < 0) {
                horse = getIdxMax(0, 0, 0,
                        COMP[result[idx - 1]][R] * unicorns[R],
                        COMP[result[idx - 1]][Y] * unicorns[Y],
                        COMP[result[idx - 1]][B] * unicorns[B]);
            }
            if (horse < 0) {
                break;
            } else {
                unicorns[horse]--;
                result[idx++] = horse;
            }
        }

        StringBuilder builder = new StringBuilder();
        for (int c : result) {
            builder.append(CONV[c]);
        }

        if (idx >= n && COMP[result[0]][result[n - 1]] > 0) {
            System.out.println("Case #" + testCase + ": " + builder.toString());
        } else {
            System.out.println("Case #" + testCase + ": IMPOSSIBLE");
        }

    }

    private static int getIdxMax(long... unicorns) {
        long max = 0;
        int maxIdx = -1;

        for (int i = 0; i < unicorns.length; ++i) {
            if (unicorns[i] > max) {
                max = unicorns[i];
                maxIdx = i;
            }
        }
        return maxIdx;
    }
}
