package problem1;

import java.util.*;
import java.io.*;

public class Main {

    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        for (int testCase = 1; testCase <= t; ++testCase) {
            long D = in.nextLong();
            long N = in.nextLong();
            ArrayList<HorseInfo> info = new ArrayList();
            for(int n = 0; n < N; ++n){
                long k = in.nextLong();
                long s = in.nextLong();
                info.add(new HorseInfo(k, s));
            }
            performTest(D, info, testCase);
        }
    }

    private static void performTest(double D, ArrayList<HorseInfo> infos, int testCase) {
        double maxTime = 0.;
        for(HorseInfo info : infos){
            double distance = D - info.initialPos;
            double speed = info.maxSpeed;
            double time = distance / speed;
            maxTime = Math.max(maxTime, time);
        }
        
        System.out.println(String.format(Locale.US, "Case #%d: %.6f", testCase, (D/maxTime)));
    }

    private static class HorseInfo{
        double initialPos;
        double maxSpeed;

        public HorseInfo(long initialPos, long maxSpeed) {
            this.initialPos = initialPos;
            this.maxSpeed = maxSpeed;
        }
    }
    
}
