package problem2;

import java.util.*;
import java.io.*;

public class Main {

    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        for (int testCase = 1; testCase <= t; ++testCase) {
            long n = in.nextLong();
            performTest(n, testCase);
        }
//        performTest(4332, 1);
    }

    private static void performTest(long n, int testCase) {
        int[] digits = new int[20];
        for (int i = 0; i < digits.length; ++i) {
            digits[i] = 0;
        }

        long tmp = n;
        int nDigit = 0;
        while (tmp > 0) {
            digits[nDigit++] = (int) (tmp % 10);
            tmp = tmp / 10;
        }

        long result = n;

        int breakIdx = getBreakIdx(digits, nDigit);
        if (breakIdx > 0) {
            int breakValue = digits[breakIdx];

//            System.out.println("breakIdx : " + breakIdx);
//            System.out.println("breakValue : " + breakValue);

            breakValue--;
            for (int i = breakIdx + 1; i < nDigit; ++i) {
                if (digits[i] > breakValue) {
                    breakValue = digits[i] - 1;
                    breakIdx = i;
                }
            }
            long pow = (long) Math.pow(10, breakIdx);
            result = (n / pow * pow) - 1;
        }

        System.out.println("Case #" + testCase + ": " + result);
    }

    private static int getBreakIdx(int[] digits, int len) {
        for (int i = len - 1; i > 0; --i) {
            if (digits[i - 1] < digits[i]) {
                return i;
            }
        }
        return 0;
    }

    private static void print(int[] digits, int len) {
        for (int i = 0; i < len; ++i) {
            int d = digits[i];
            System.out.print(d);
        }
        System.out.println();
    }
}
