package problem3;

import java.util.*;
import java.io.*;

public class Main {

    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        for (int testCase = 1; testCase <= t; ++testCase) {
            long n = in.nextLong();
            long k = in.nextLong();
            performTest(n, k, testCase);
        }
//        performTest(999, 999, 3);
//        performTest(9999, 9999, 4);
//        performTest(99999, 99999, 5);
//        performTest(999999, 999999, 6);
    }

    private static void performTest(long n, long k, int testCase) {

        long leftSize = 0;
        long rightSize = 0;
        long startTime = System.nanoTime();
        PriorityQueue<Segment> pQueue = new PriorityQueue<>();
        pQueue.add(new Segment(n, 0));

        for (int i = 0; i < k; ++i) {
            Segment bestSegm = pQueue.poll();
            long remaingPlaces = bestSegm.size - 1;
            leftSize = remaingPlaces / 2;
            rightSize = remaingPlaces - leftSize;

            long leftIdx = bestSegm.firstIdx;
            long rightIdx = leftIdx + leftSize + 1;

            if (leftSize > 0) {
                pQueue.add(new Segment(leftSize, leftIdx));
            }
            if (rightSize > 0) {
                pQueue.add(new Segment(rightSize, rightIdx));
            }
        }

        long elapsedTime = (System.nanoTime() - startTime) / 1000000;
        System.out.println("Case #" + testCase + ": " + rightSize + " " + leftSize);
//        System.out.println("Case #" + testCase + ": " + n + ": " + elapsedTime);
    }

    private static class Segment implements Comparable<Segment> {

        long size;
        long firstIdx;

        public Segment(long size, long firstIdx) {
            this.size = size;
            this.firstIdx = firstIdx;
        }

        @Override
        public int compareTo(Segment t) {
            if (this.size > t.size) {
                return -1;
            }
            if (this.size < t.size) {
                return 1;
            }
            if (this.firstIdx > t.firstIdx) {
                return -1;
            }
            if (this.firstIdx < t.firstIdx) {
                return 1;
            }
            return 0;
        }
    }

}
