package com.tzyangtang.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Scanner;

public class A {

    public static void main(String[] args) {
        try {
            // C:\dev\code-jam\file\a\A-small-attempt1.in
            BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
            String stdin = reader.readLine();
            File file = new File(stdin.replace("in", "out"));
            file.createNewFile();
            FileWriter fw = new FileWriter(file.getAbsoluteFile());
            BufferedWriter bw = new BufferedWriter(fw);
            Scanner in = new Scanner(new BufferedReader(new FileReader(stdin)));

            int t = in.nextInt();
            for (int i = 1; i <= t; ++i) {
                String rowData = in.next();
                int numOfPancakes = rowData.length();
                int size = in.nextInt();
                // how many distinct flips
                int distinctFlips = numOfPancakes - size + 1;
                boolean success = false;
                int minimumFlips = -1;
                for (int j = 0; j <= distinctFlips; j++) {
                    System.out.println("j:" + j);
                    ArrayList<ArrayList<Integer>> result = combine(distinctFlips, j);
                    for (ArrayList<Integer> a : result) {
                        char[] pancakes = rowData.toCharArray();
                        System.out.print("flip index:");
                        for (Integer index : a) {
                            System.out.print(" " + index);
                            flip(pancakes, size, index);
                        }
                        System.out.println();
                        if (allSidesUp(pancakes)) {
                            success = true;
                            break;
                        }
                    }
                    if (success) {
                        minimumFlips = j;
                        break;
                    }
                }

                String msg = "Case #" + i + ": " + ((minimumFlips == -1) ? "IMPOSSIBLE" : minimumFlips);
                System.out.println(msg);
                bw.write(msg);
                bw.newLine();
            }

            bw.flush();
            bw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static boolean allSidesUp(char[] pancakes) {
        for (char pancake : pancakes) {
            if (pancake == '-') {
                return false;
            }
        }
        return true;
    }

    private static void flip(char[] pancakes, int size, int start) {
        for (int i = start - 1; i < start + size - 1; i++) {
            if (pancakes[i] == '-') {
                pancakes[i] = '+';
            } else {
                pancakes[i] = '-';
            }
        }
    }

    static private ArrayList<ArrayList<Integer>> combine(int n, int k) {
        ArrayList<ArrayList<Integer>> result = new ArrayList<ArrayList<Integer>>();
        if (n <= 0 || n < k)
            return result;
        ArrayList<Integer> item = new ArrayList<Integer>();
        dfs(n, k, 1, item, result);
        return result;
    }

    static private void dfs(int n, int k, int start, ArrayList<Integer> item,
                            ArrayList<ArrayList<Integer>> res) {
        if (item.size() == k) {
            res.add(new ArrayList<Integer>(item));
            return;
        }
        for (int i = start; i <= n; i++) {
            item.add(i);
            dfs(n, k, i + 1, item, res);
            item.remove(item.size() - 1);
        }
    }
}
