package com.tzyangtang.googlecodejam.qualification.c;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class C {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		int numberOfCase;
		Scanner scanner = null;
		FileWriter fw;
		BufferedWriter bw;

		try {
			File file = new File(args[1]);
			if (!file.exists()) {
				file.createNewFile();
			}
			fw = new FileWriter(file.getAbsoluteFile());
			bw = new BufferedWriter(fw);
			scanner = new Scanner(new File(args[0]));
			numberOfCase = scanner.nextInt();
			for (int i = 0; i < numberOfCase; i++) {
				long startTime = System.currentTimeMillis();
				int length = scanner.nextInt();
				int repeats = scanner.nextInt();
				String pattern = scanner.next();
				int totalLength = length * repeats;
				StringBuilder sb = new StringBuilder();
				boolean pass = false;
				if (totalLength >= 3) {
					for (int j = 0; j < repeats; j++) {
						sb.append(pattern);
					}
					char[] finalString = sb.toString().toCharArray();
					char[][] cache = new char[totalLength + 1][totalLength + 1];
					int[][] cacheSign = new int[totalLength + 1][totalLength + 1];
					int sum = 0;
					if (pattern.indexOf('i') != -1)
						sum++;
					if (pattern.indexOf('j') != -1)
						sum++;
					if (pattern.indexOf('k') != -1)
						sum++;
					if (sum >= 2) {
						for (int x = 1; x < totalLength - 1; x++) {
							for (int y = x + 1; y < totalLength; y++) {
								if (calc(finalString, cache, cacheSign, 0, x,
										'i')
										&& calc(finalString, cache, cacheSign,
												x, y, 'j')
										&& calc(finalString, cache, cacheSign,
												y, totalLength, 'k')) {
									pass = true;
									break;
								}
							}
						}
					}
				}
				long endTime = System.currentTimeMillis();
				long totalTime = endTime - startTime;
				System.out.println();
				sb = new StringBuilder();
				if (pass)
					sb.append("Case #" + (i + 1) + ": " + "YES");
				else
					sb.append("Case #" + (i + 1) + ": " + "NO");
				String msg = sb.toString().trim() + "\n";
				System.out.print(msg + ",totalTime:" + (totalTime / 1000)
						+ " sec");
				bw.write(msg);
			}
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			scanner.close();
		}
	}

	public static boolean calc(char[] a, char[][] cache, int[][] cacheSign,
			int start, int end, char target) {

		if (cache[start][end] != 0) {
			if (cacheSign[start][end] == 1 && cache[start][end] == target) {
				return true;
			} else {
				return false;
			}
		}

		char cur = a[start];
		int curSign = 1;
		int jumpStart = start;
		if (cache[start][end - 1] != 0) {
			cur = cache[start][end - 1];
			curSign = cacheSign[start][end - 1];
			jumpStart = (end - 2);
		}

		for (int i = jumpStart + 1; i < end; i++) {
			if (cur == ' ') {
				cur = a[i];
			} else if (cur == 'i') {
				if (a[i] == 'i') {
					cur = ' ';
					curSign *= -1;
				} else if (a[i] == 'j') {
					cur = 'k';
				} else if (a[i] == 'k') {
					cur = 'j';
					curSign *= -1;
				}
			} else if (cur == 'j') {
				if (a[i] == 'i') {
					cur = 'k';
					curSign *= -1;
				} else if (a[i] == 'j') {
					cur = ' ';
					curSign *= -1;
				} else if (a[i] == 'k') {
					cur = 'i';
				}
			} else if (cur == 'k') {
				if (a[i] == 'i') {
					cur = 'j';
				} else if (a[i] == 'j') {
					cur = 'i';
					curSign *= -1;
				} else if (a[i] == 'k') {
					cur = ' ';
					curSign *= -1;
				}
			}

			cache[start][i + 1] = cur;
			cacheSign[start][i + 1] = curSign;
		}

		cache[start][end] = cur;
		cacheSign[start][end] = curSign;
		if (cacheSign[start][end] == 1 && cache[start][end] == target) {
			// System.out.println("start:" + start + ",end:" + end + ",target:"
			// + target + ",return:" + true);
			return true;
		} else {
			// System.out.println("start:" + start + ",end:" + end + ",target:"
			// + target + ",return:" + false);
			return false;
		}
	}
}
