package com.tzyangtang.codejam.round1b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.Scanner;

import com.tzyangtang.codejam.qualification.C;

public class A {

    public static void main(String[] args) {
        try {
            // C:\dev\code-jam\file\round1b\a\A-large.in
            BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
            String stdin = reader.readLine();
            File file = new File(stdin.replace("in", "out"));
            file.createNewFile();
            FileWriter fw = new FileWriter(file.getAbsoluteFile());
            BufferedWriter bw = new BufferedWriter(fw);
            Scanner in = new Scanner(new BufferedReader(new FileReader(stdin)));

            int t = in.nextInt();
            for (int i = 1; i <= t; ++i) {
                long dest = in.nextLong();
                int numberOfHorses = in.nextInt();
                PriorityQueue<Horse> queue = new PriorityQueue<Horse>(1000, new Comparator<Horse>() {
                    @Override
                    public int compare(Horse o1, Horse o2) {
                        if (o1.position > o2.position) {
                            return -1;
                        } else if (o1.position < o2.position) {
                            return 1;
                        } else {
                            return 0;
                        }
                    }
                });

                for (int j = 0; j < numberOfHorses; j++) {
                    Horse h = new Horse();
                    h.position = in.nextLong();
                    h.speed = in.nextInt();
                    queue.add(h);
                }

                // find the slowest one, who controls the final time
                double accumulateTime = 0;
                double currentDest = dest;
                Horse first = queue.remove();
                while (!queue.isEmpty()) {
                    Horse second = queue.remove();
                    if (second.speed <= first.speed) {
                        accumulateTime = accumulateTime + (currentDest - second.position) / second.speed;
                        currentDest = second.position;
                    } else {
                        double time = (first.position - second.position) / (second.speed - first.speed);
                        double collidePosition = first.position + (first.speed * time);
                        // collide
                        if (collidePosition < currentDest) {
                            accumulateTime = accumulateTime + (currentDest - collidePosition) / first.speed;
                            currentDest = collidePosition;
                        } else {
                            // won't collide
                            accumulateTime = accumulateTime + (currentDest - second.position) / second.speed;
                            currentDest = second.position;
                        }
                    }
                    first = second;
                }
                accumulateTime = accumulateTime + (currentDest - first.position) / first.speed;
                double optimizeSpeed = dest / accumulateTime;

                String msg = "Case #" + i + ": " + String.format("%.6f", optimizeSpeed);
                System.out.println(msg);
                bw.write(msg);
                bw.newLine();
            }

            bw.flush();
            bw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    static class Horse {
        int speed;
        long position;
    }
}
