package com.tzyangtang.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.Scanner;

public class C {

    public static void main(String[] args) {
        try {
            // C:\dev\code-jam\file\c\C-small-2-attempt1.in
            BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
            String stdin = reader.readLine();
            File file = new File(stdin.replace("in", "out"));
            file.createNewFile();
            FileWriter fw = new FileWriter(file.getAbsoluteFile());
            BufferedWriter bw = new BufferedWriter(fw);
            Scanner in = new Scanner(new BufferedReader(new FileReader(stdin)));

            int t = in.nextInt();
            for (int i = 1; i <= t; ++i) {
                int numerOfStalls = in.nextInt();
                int numberOfPersons = in.nextInt();
                PriorityQueue<Span> queue = new PriorityQueue<>(1000, new Comparator<Span>() {
                    @Override
                    public int compare(Span o1, Span o2) {
                        int result = o1.getLength() - o2.getLength();
                        if (result == 0) {
                            result = o2.left - o1.left;
                        }
                        return result * -1;
                    }
                });
                queue.add(new Span(0, numerOfStalls - 1));
                Span maxSpan = new Span(0, numerOfStalls - 1);
                for (int j = numberOfPersons; j > 0; --j) {
                    maxSpan = queue.remove();
                    int chosenStall = (maxSpan.left + maxSpan.right) / 2;
                    if (chosenStall != maxSpan.left) {
                        queue.add(new Span(maxSpan.left, chosenStall - 1));
                    }
                    if (chosenStall != maxSpan.right) {
                        queue.add(new Span(chosenStall + 1, maxSpan.right));
                    }
                }
                System.out.println(maxSpan);
                int max = 0;
                int min = 0;
                if (maxSpan.getLength() > 1) {
                    max = maxSpan.getLength() / 2;
                    if (maxSpan.getLength() % 2 == 0) {
                        min = max - 1;
                    } else {
                        min = max;
                    }
                }
                String msg = "Case #" + i + ": " + max + " " + min;
                System.out.println(msg);
                bw.write(msg);
                bw.newLine();
            }

            bw.flush();
            bw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    static class Span {
        int left;
        int right;

        Span(int left, int right) {
            this.left = left;
            this.right = right;
        }

        int getLength() {
            return this.right - this.left + 1;
        }

        @Override
        public String toString() {
            return "left:" + this.left + ",right=" + this.right;
        }
    }
}
