package com.dabar.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GettingTheDigits {
	
	public static void main(String[] args) throws IOException {
	//System.out.println(DoWork("NOOINXESE"));

		String file = args[0];
		
		List<String> fileRows = new ArrayList<String>();
		try (BufferedReader br = new BufferedReader(new FileReader(file))) {
		    String line;
		    while ((line = br.readLine()) != null) {
		       // process the line.
		    	fileRows.add(line);
		    }
		}
		
		File outFile = new File(file+".out");
		if (!outFile .exists()) {
			outFile .createNewFile();
		}

		FileWriter fw = new FileWriter(outFile .getAbsoluteFile());
		BufferedWriter bw = new BufferedWriter(fw);
		
		int numOfTests = Integer.parseInt(fileRows.get(0));
		for (int i=1;i<=numOfTests;i++) {
			String result = "Case #"+i+": " +DoWork(fileRows.get(i));
			System.out.println(result);
			bw.write(result);
			bw.newLine();
		}
		
		bw.close();
		

	}
	
	//ZERO  //Z  //4
	//ONE	//3
	//TWO     W 3
	//THREE    5
	//FOUR  U 4
	//FIVE  4
	//SIX X 3
	//SEVEN   5 
	//EIGHT G 5
	//NINE  4
	
	private static String[] nums = new String[] { "ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE" };
	
	
	private static String DoWork(String data) {
		Map<String,Integer> counts = new HashMap<String, Integer>();
		ArrayList<Integer> phoneNum = new ArrayList<Integer>();
		for (int i=0;i<data.length();i++) {
			String v = data.substring(i,i+1);
			if (counts.containsKey(v)) {
				Integer x = counts.get(v);
				counts.put(v, ++x);
			} else
			{
				counts.put(v, 1);
			}
		}
		//ZERO
		if (counts.containsKey("Z")) {
			int n = counts.get("Z");
			if (n>0) {
			for(int i=0;i<n;i++)
				phoneNum.add(0);
			counts.put("Z", 0);
			int c = counts.get("E");
			counts.put("E", c-n);
			c = counts.get("R");
			counts.put("R", c-n);
			c = counts.get("O");
			counts.put("O", c-n);
			}
		}
		//TWO 
		if (counts.containsKey("W")) {
			int n = counts.get("W");
			if (n>0) {
			for(int i=0;i<n;i++)
				phoneNum.add(2);
			counts.put("W", 0);
			int c = counts.get("T");
			counts.put("T", c-n);
			c = counts.get("O");
			counts.put("O", c-n);
			}
		}
		//FOUR
		if (counts.containsKey("U")) {
			int n = counts.get("U");
			if (n>0) {
			for(int i=0;i<n;i++)
				phoneNum.add(4);
			counts.put("U", 0);
			int c = counts.get("F");
			counts.put("F", c-n);
			c = counts.get("R");
			counts.put("R", c-n);
			c = counts.get("O");
			counts.put("O", c-n);
			}
		}
		//SIX
		if (counts.containsKey("X")) {
	
			int n = counts.get("X");
			if (n>0) {
			for(int i=0;i<n;i++)
				phoneNum.add(6);
			counts.put("X", 0);
			int c = counts.get("S");
			counts.put("S", c-n);
			c = counts.get("I");
			counts.put("I", c-n);
			}
		}
		//EIGHT
		if (counts.containsKey("G")) {
			int n = counts.get("G");
			if (n>0) {
			for(int i=0;i<n;i++)
				phoneNum.add(8);
			counts.put("G", 0);
			int c = counts.get("E");
			counts.put("E", c-n);
			c = counts.get("I");
			counts.put("I", c-n);
			 c = counts.get("H");
				counts.put("H", c-n);
				c = counts.get("T");
				counts.put("T", c-n);
			}
		}
		//FIVE F
		if (counts.containsKey("F")) {
			int n = counts.get("F");
			if (n>0) {
			for(int i=0;i<n;i++)
				phoneNum.add(5);
			counts.put("F", 0);
			int c = counts.get("I");
			counts.put("I", c-n);
			c = counts.get("V");
			counts.put("V", c-n);
			c = counts.get("E");
			counts.put("E", c-n);
			}
		}
		//SEVEN V
		if (counts.containsKey("V")) {
			int n = counts.get("V");
			if (n>0) {
			for(int i=0;i<n;i++)
				phoneNum.add(7);
			counts.put("V", 0);
			int c = counts.get("E");
			counts.put("E", c-(2*n));
			c = counts.get("N");
			counts.put("N", c-n);
			 c = counts.get("S");
				counts.put("S", c-n);
			}
		}
		//THREE
		if (counts.containsKey("R")) {
			int n = counts.get("R");
			if (n>0) {
			for(int i=0;i<n;i++)
				phoneNum.add(3);
			counts.put("R", 0);
			int c = counts.get("E");
			counts.put("E", c-(2*n));
			c = counts.get("T");
			counts.put("T", c-n);
			 c = counts.get("H");
				counts.put("H", c-n);
			}
		}
		//ONE
		if (counts.containsKey("O")) {
			int n = counts.get("O");
			if (n>0) {
			for(int i=0;i<n;i++)
				phoneNum.add(1);
			counts.put("O", 0);
			int c = counts.get("E");
			counts.put("E", c-n);
			c = counts.get("N");
			counts.put("N", c-n);
			}
		
		}
		//NINE
		if (counts.containsKey("E")) {
			int n = counts.get("E");
			if (n>0) {
			for(int i=0;i<n;i++)
				phoneNum.add(9);
			counts.put("E", 0);
			int c = counts.get("N");
			counts.put("N", c-(2*n));
			c = counts.get("I");
			counts.put("I", c-n);
			}
		}
		
		for (String k : counts.keySet()) {
			int n = counts.get(k);
			if (n > 0) {
				System.out.println("***************" + data + " " + k + ":" + n);
				break;
			}
		}
		
		
		/*
		for(int i=0;i<10;i++) {
			if (i==0,2,4,6,8,5,7) {
				continue;
			}
			boolean found = true;
			while (found) {
			String target = nums[i];

			for (int j=0;j<target.length() && found;j++) {
				String v = target.substring(j,j+1);
				int need = i==3 && v.equals("E") ? 2 : 1;
				if (!counts.containsKey(v) || counts.get(v) < need)
				{
					found =false;
				}
			}
			if (found) {
				phoneNum.add(i);
				for (int j=0;j<target.length() && found;j++) {
					String v = target.substring(j,j+1);
					Integer x = counts.get(v);
					counts.put(v, --x);
				}
				
			}
			}
			
		}
		*/
		StringBuilder sb = new StringBuilder();
		phoneNum.sort(null);
		for (int i=0;i<phoneNum.size();i++) {
			sb.append(phoneNum.get(i));
		}
		return sb.toString();
	}

}
