package com.dabar.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class BleatrixPotter {
	
	private static long maxTries = 100;
	

	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		
		String file = args[0];
		
		List<String> fileRows = new ArrayList<String>();
		try (BufferedReader br = new BufferedReader(new FileReader(file))) {
		    String line;
		    while ((line = br.readLine()) != null) {
		       // process the line.
		    	fileRows.add(line);
		    }
		}
		
		File outFile = new File(file+".out");
		if (!outFile .exists()) {
			outFile .createNewFile();
		}

		FileWriter fw = new FileWriter(outFile .getAbsoluteFile());
		BufferedWriter bw = new BufferedWriter(fw);
		
		int numOfTests = Integer.parseInt(fileRows.get(0));
		for (int i=1;i<=numOfTests;i++) {
			String result = "Case #"+i+": " +PrintMultiples(Long.parseLong(fileRows.get(i)));
			System.out.println(result);
			bw.write(result);
			bw.newLine();
		}
		
		bw.close();

	}

	private static String PrintMultiples(long n) {
		boolean[] seen = new boolean[10];
		for (long i=1;i<maxTries;i++) {
			String result = Long.toString(i*n);
			boolean allTrue=true;
			for (int j=0;j<result.length();j++) {
				char c = result.charAt(j);
				seen[((int)c)-48]=true;
				//System.out.println(c+"="+(int)c);
			}
			//System.out.println(n + " * " + i + " = " + i*n + seen[0]+ seen[1]+ seen[2]+ seen[3]+ seen[4]+ seen[5]+ seen[6]+ seen[7]+ seen[8]+ seen[9]);
			
			
			for (int j=0;j<10;j++)
			{
				if (!seen[j]) {
					allTrue=false;
					break;
				}
			}
			if (allTrue) {
				return result;
			}
			
		}
		return "INSOMNIA";
	}
}
