package googlerese;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Translate {
	
	private static Map<Character,Character> mapping;
	
	static {
		mapping = new HashMap<Character,Character>();
		mapping.put('a', 'y');
		mapping.put('b', 'h');
		mapping.put('c', 'e');
		mapping.put('d', 's');
		mapping.put('e', 'o');
		mapping.put('f', 'c');
		mapping.put('g', 'v');
		mapping.put('h', 'x');
		mapping.put('i', 'd');
		mapping.put('j', 'u');
		mapping.put('k', 'i');
		mapping.put('l', 'g');
		mapping.put('m', 'l');
		mapping.put('n', 'b');
		mapping.put('o', 'k');
		mapping.put('p', 'r');
        mapping.put('q', 'z');//process of elimination
		mapping.put('r', 't');
		mapping.put('s', 'n');
		mapping.put('t', 'w');
		mapping.put('u', 'j');
		mapping.put('v', 'p');
		mapping.put('w', 'f');
		mapping.put('x', 'm');
		mapping.put('y', 'a');
		mapping.put('z', 'q');
		mapping.put(' ',' ');
		
	}
	
	public static void main(String[] args) {
		
		if (args.length !=1)
			throw new IllegalArgumentException("No file specified");
		
		List<String> data = new ArrayList<String>();
		try{
			   FileInputStream fstream = new FileInputStream(args[0]);
			   DataInputStream in = new DataInputStream(fstream);
			   BufferedReader br = new BufferedReader(new InputStreamReader(in));
			   String strLine;
			   while ((strLine = br.readLine()) != null)   {
				   data.add(strLine);
			   }
			   in.close();
			     }catch (Exception e){//Catch exception if any
			   System.err.println("Error: " + e.getMessage());
			   }
		
		if (data.size() ==0)
			throw new IllegalArgumentException("No data in file");
	
		int noTestCases = Integer.parseInt(data.get(0));
		if (data.size() != noTestCases+1) 
			throw new IllegalArgumentException("Number of test cases is not "+noTestCases);
		
		for (int i=1;i<=noTestCases;i++) {
			System.out.println("Case #"+i+": "+translateMessage(data.get(i)));
		}
		
		
	}
	
	
	public static Map<Character,Character> getMapping() {return mapping;}
	
	public static String translateMessage(String in) {  
		StringBuilder out = new StringBuilder();
		
		for (int i=0;i<in.length();i++ ) {
			char c = in.charAt(i);
			Character o = mapping.get(c);
			if (o == null)
				throw new IllegalArgumentException("Invalid character found: "+c);
			out.append(o);
		}
		
		return out.toString();
	}

}
