import java.util.*;

public class Mines {
  public static void main(String[] args) {
    Scanner sc = new Scanner(System.in);
    int t = sc.nextInt();
    for (int ti = 0; ti < t; ti++) {
      int r = sc.nextInt();
      int c = sc.nextInt();
      int m = sc.nextInt();
      System.out.println("Case #" + (ti + 1) + ":");
      int grid[] = null;
      if (r == 1) {
        if (m < c) {
          grid = new int[1];
          grid[0] = m;
        }
      }
      else if (c == 1) {
        if (m < r) {
          grid = new int[r];
          for (int i = 0; i < m; i++) {
            grid[i] = 1;
          }
        }
      }
      else {
        grid = canWin(new int[r], 0, c, m, r, c);
      }
      if (grid != null) {
        char[][] grid2 = makeCharGrid(grid, r, c);
        grid2[r - 1][c - 1] = 'c';
        printGrid(grid2);
      }
      else {
        System.out.println("Impossible");
      }
    }
  }

  public static int[] canWin(int[] grid, int row, int cols, int m, int r, int c) {
    // System.out.println("Start");
    // printGrid(grid, r, c);
    // System.out.println("row=" + row + ", m=" + m);
    // System.out.println();
    if (row == grid.length || m == 0) {
      int[] canWinResult = canWinGrid(grid, cols, r, c);
      if (m == 0 && canWinResult != null) {
        return canWinResult;
      }
      else {
        return null;
      }
    }
    int m2 = m;
    for (int i = 1; i <= (row == 0 ? cols : grid[row - 1]) && m2 - i >= 0; i++) {
      // System.out.println("i=" + i + ", m2=" + m2 + ", row=" + row);
      // printGrid(grid, r, c);
      // System.out.println();
      grid[row] = i;
      int[] result = canWin(grid, row + 1, cols, m2 - i, r, c);
      if (result != null) {
        return grid;
      }
    }
    grid[row] = 0;
    return null;
  }

  public static int[] canWinGrid(int[] grid, int length, int r, int c) {
    // printGrid(grid, r, c);
    if (grid[grid.length - 1] == grid[grid.length - 2]) {
      int i = 0;
      for (; i < grid.length && grid[i] == length; i++);
      if (i == grid.length) {
        return null;
      }
      else if (grid[i] < length - 1) {
        return grid;
      }
    }
    else {
      for (int i = 0; i < grid.length - 1; i++) {
        if (grid[i] != length) {
          return null;
        }
      }
      if (grid[grid.length - 1] == length - 1) {
        return grid;
      }
    }
    return null;
  }
  
  public static char[][] makeCharGrid(int[] grid, int r, int c) {
    char[][] grid2 = new char[r][c];
    for (int i = 0; i < r; i++) {
      for (int j = 0; j < grid[i]; j++) {
        grid2[i][j] = '*';
      }
      for (int j = grid[i]; j < c; j++) {
        if (i == r - 1 && j == c - 1) {
          grid2[i][j] = 'c';
        }
        else {
          grid2[i][j] = '.';
        }
      }
    }
    return grid2;
  }
  public static void printGrid(char[][] grid) {
    for (int i = 0; i < grid.length; i++) {
      for (int j = 0; j < grid[0].length; j++) {
        System.out.print(grid[i][j]);
      }
      System.out.println();
    }
  }
}
