import java.util.*;

public class Main{
	public static void main(String[] args){
		Scanner sc = new Scanner(System.in);
		int t = sc.nextInt();
		for(int i = 1; i <= t; i++){
			int n = sc.nextInt();
			int w = sc.nextInt();
			int l = sc.nextInt();
			LinkedList<Student> stus = new LinkedList<Student>();
			for(int j = 0; j < n; j++){
				stus.add(new Student(sc.nextInt(), j));
			}
			Collections.sort(stus, new SortByR());
			System.out.printf("Case #%d: %s\n", i, solve(stus, w, l));
		}
	}
	public static String solve(LinkedList<Student> stus, int w, int l){
		StringBuffer sb = new StringBuffer();
		HashMap<Student, String> map = new HashMap<Student, String>();
		LinkedList<Student> row;

		int lastRowHeight = -1;
		while(stus.size() > 0){
			row = new LinkedList<Student>();

			Student tmp = stus.removeFirst();
			int lastPos = tmp.r;
			row.addLast(tmp);
			if(lastRowHeight == -1){
				lastRowHeight = 0;
			}
			else{
				lastRowHeight += tmp.r;
			}
			while(stus.size() > 0 && stus.getFirst().r + lastPos <= w){
				tmp = stus.removeFirst();
				lastPos += 2 * tmp.r;
				row.addLast(tmp);
			}

			lastPos = 0 - row.getFirst().r;
			for(Student i : row){
				map.put(i, ((lastPos + i.r) + " " + lastRowHeight));
				//System.out.println(i + ":" + sb.toString());
				lastPos += 2 * i.r;
			}
			lastRowHeight += row.getFirst().r;
			//System.out.println("-----------------");
		}

		LinkedList<Student> all = new LinkedList<Student>();
		for(Student s : map.keySet()){
			all.add(s);
		}
		Collections.sort(all, new SortByNum());
		for(Student s : all){
			sb.append(map.get(s) + " ");
		}
		return sb.substring(0, sb.length() - 1);

	}
	static class Student{
		int r;
		int num;
		public Student(int R, int N){
			r = R;
			num = N;
		}
	}
	static class SortByR implements Comparator<Student>{
		public boolean equals(Object o){
			return false;
		}
		public int compare(Student s1, Student s2){
			if(s1.r > s2.r){
				return -1;
			}
			else if(s1.r < s2.r){
				return 1;
			}
			else{
				return 0;
			}
		}
	}
	static class SortByNum implements Comparator<Student>{
		public boolean equals(Object o){
			return false;
		}
		public int compare(Student s1, Student s2){
			if(s1.num > s2.num){
				return 1;
			}
			else if(s1.num < s2.num){
				return -1;
			}
			else{
				return 0;
			}
		}
	}
}