import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class Main {

	private int numberOfCases;
	private Scanner scanner;

	private Sean sean;

	public Main() {
		sean = new Sean();
	}

	public static void main(String[] args) {
		Main main = new Main();
		main.fileTest();
	}

	private void fileTest() {
		FileReader fr = null;
		FileWriter fw = null;

		try {
			fr = new FileReader("C-large.in");
			fw = new FileWriter("C-large.out");
			scanner = new Scanner(fr);
			numberOfCases = scanner.nextInt();

			for (int i = 0; i < numberOfCases; i++) {
				int n = scanner.nextInt();

				List<Integer> decimals = new ArrayList<Integer>();
				for (int j = 0; j < n; j++) {
					int c = scanner.nextInt();
					decimals.add(c);
				}
				String result = null;
				try {
					result = "" + sean.keep(decimals);
				} catch (RuntimeException e) {
					result = "NO";
				}
				fw.write("Case #" + (i + 1) + ": " + result + "\n");
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (fr != null)
					fr.close();
			} catch (IOException e) {
				e.printStackTrace();
			}

			try {
				if (fw != null)
					fw.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}

class NumberUtils {
	protected int maxNumberOfDigits(List<String> binaries) {
		int numberOfDigits = 0;
		for(String binary : binaries) {
			int strBinaryLength = binary.length();
			if ( strBinaryLength > numberOfDigits) numberOfDigits = strBinaryLength;
		}
		return numberOfDigits;
	}
	
	protected List<String> toBinaries(List<Integer> decimals) {
		List<String> binaries = new ArrayList<String>();
		for(int i=0; i< decimals.size(); i++) {
			binaries.add(Integer.toBinaryString(decimals.get(i)));
		}
		return binaries;
	}
}

class Patrick {
	
	private NumberUtils numberUtils;
	
	public Patrick() {
		numberUtils = new NumberUtils();
	}
	
	protected String add(List<Integer> decimals) {
		List<String> binaries = numberUtils.toBinaries(decimals);
		int numberOfDigits = numberUtils.maxNumberOfDigits(binaries);
		
		StringBuffer result = new StringBuffer();
		for (int i=0; i < numberOfDigits; i++) {
			int xor = 0;
			for(String binary : binaries) {
				int numberOfZeros = numberOfDigits - binary.length();
				StringBuffer sb = new StringBuffer();
				for(int j=0; j<numberOfZeros; j++) {
					sb.append("0");
				}
				String number = sb.append(binary).toString();
				
				xor = xor ^ Integer.parseInt(String.format("%c", number.charAt(i)));
			}
			result.append(xor);
		}
		int firstIndex = result.indexOf("1");
		if (firstIndex > 0) {
			return result.substring(firstIndex, result.length());
		} else {
			return result.toString();
		}
	}
}

class Sean {

	private Patrick patrick;

	public Sean() {
		patrick = new Patrick();
	}

	protected Integer keep(List<Integer> decimals) {
		
		if (patrick.add(decimals).contains("1")) {
			throw new RuntimeException();
		}
		
		Collections.sort(decimals);
		Integer keep = 0;
		
		List<Integer> sBag = null;
		List<Integer> pBag = null;
		
		sBag = new ArrayList<Integer>();
		pBag = new ArrayList<Integer>();
		
		List<Integer> pPile = new ArrayList<Integer>();
		while(decimals.size() > 0) {
			pPile.add(decimals.get(0));
			decimals.remove(decimals.get(0));
			String aPile = patrick.add(pPile);
			String sPile = patrick.add(decimals);
			
			if (aPile.equals(sPile)) {
				sBag.addAll(decimals);
				pBag.addAll(pPile);
				decimals.removeAll(decimals);
				decimals.removeAll(pPile);
			}
		}
		
		for(int i=0; i<sBag.size(); i++) {
			keep += sBag.get(i);
		}
		if (keep == 0) throw new RuntimeException();
		return keep;
	}
}