package com.tagliola.codejam2014.round1c.problem2;

import java.io.*;
import java.math.*;
import java.util.*;

import com.google.common.base.*;
import com.google.common.io.*;

public class Problem2
{
    public static void main(String[] args) throws NumberFormatException, IOException
    {
        new Problem2(args[0]);
    }

    public Problem2(String aFileName) throws NumberFormatException, IOException
    {
        PrintStream myPrintStream = new PrintStream(new File("src/main/resources/" + aFileName + ".out"));
        LineReader myLineReader = getLineReader(aFileName + ".in");
        int myNumberOfCases = Integer.parseInt(myLineReader.readLine());
        for (int myCase = 1; myCase <= myNumberOfCases; myCase++)
        {
            String myResult = "Case #" + myCase + ": " + performCase(myLineReader);
            
            System.out.println(myResult);
            myPrintStream.println(myResult);
        }
        myPrintStream.close();
    }

    private String performCase(LineReader aLineReader) throws IOException
    {
        int numberOfCars = Integer.valueOf(aLineReader.readLine());
        List<String> myCars = Splitter.on(' ').splitToList(aLineReader.readLine());
        
        Problem2Case mProblem2Case = new Problem2Case(myCars);
        return mProblem2Case.calculate();
    }

    private LineReader getLineReader(String aFileName)
    {
        InputStream myResourceAsStream = getClass().getClassLoader().getResourceAsStream(aFileName);
        LineReader myLineReader = new LineReader(new InputStreamReader(myResourceAsStream));
        return myLineReader;
    }
}
