package com.tagliola.codejam2014.qualify.mineweeper;

import java.io.*;
import java.util.*;

import com.google.common.base.*;
import com.google.common.io.*;

public class MineSweeper
{
    public static void main(String[] args) throws NumberFormatException, IOException
    {
        new MineSweeper(args[0]);
    }

    public MineSweeper(String aFileName) throws NumberFormatException, IOException
    {
        PrintStream myPrintStream = new PrintStream(new File(aFileName + ".out"));
        LineReader myLineReader = getLineReader(aFileName + ".in");
        int myNumberOfCases = Integer.parseInt(myLineReader.readLine());
        for (int myCase = 1; myCase <= myNumberOfCases; myCase++)
        {
            String myResult = "Case #" + myCase + ":" + performCase(myLineReader);
            
            System.out.println(myResult);
            myPrintStream.println(myResult);
        }
        myPrintStream.close();
    }

    private String performCase(LineReader aLineReader) throws IOException
    {
        List<String> mySplit = Splitter.on(' ').splitToList(aLineReader.readLine());
        
        int myRows = Integer.parseInt(mySplit.get(0));
        int myCells = Integer.parseInt(mySplit.get(1));
        int myMines = Integer.parseInt(mySplit.get(2));
        
        MineSweeperCase myMineSweeperCase = new MineSweeperCase(myRows, myCells, myMines);
        return myMineSweeperCase.calculate();
    }

    private LineReader getLineReader(String aFileName)
    {
        InputStream myResourceAsStream = getClass().getClassLoader().getResourceAsStream(aFileName);
        LineReader myLineReader = new LineReader(new InputStreamReader(myResourceAsStream));
        return myLineReader;
    }
}
