package com.tagliola.codejam2014.qualify.deceitfulwar;

import java.io.*;
import java.math.*;
import java.util.*;

import com.google.common.base.*;
import com.google.common.collect.*;
import com.google.common.io.*;

public class DeceitfulWar
{
    public static void main(String[] args) throws NumberFormatException, IOException
    {
        new DeceitfulWar(args[0]);
    }

    public DeceitfulWar(String aFileName) throws NumberFormatException, IOException
    {
        PrintStream myPrintStream = new PrintStream(new File(aFileName + ".out"));
        LineReader myLineReader = getLineReader(aFileName + ".in");
        int myNumberOfCases = Integer.parseInt(myLineReader.readLine());
        for (int myCase = 1; myCase <= myNumberOfCases; myCase++)
        {
            myLineReader.readLine();
            String myResult = "Case #" + myCase + ": " + performCase(myLineReader);
            
            System.out.println(myResult);
            myPrintStream.println(myResult);
        }
        myPrintStream.close();
    }

    private String performCase(LineReader aLineReader) throws IOException
    {
        Set<BigDecimal> myNaomi = readBlocks(aLineReader.readLine());
        Set<BigDecimal> myKen = readBlocks(aLineReader.readLine());
        
        DeceitfulWarCase myMineSweeperCase = new DeceitfulWarCase(myNaomi, myKen);
        return Joiner.on(' ').join(myMineSweeperCase.calculate());
    }

    private Set<BigDecimal> readBlocks(String aLine) throws IOException
    {
        Set<BigDecimal> myBlocks = Sets.newHashSet();
        for (String myBlock : Splitter.on(' ').splitToList(aLine))
        {
            myBlocks.add(new BigDecimal(myBlock));
        }
        return myBlocks;
    }

    private LineReader getLineReader(String aFileName)
    {
        InputStream myResourceAsStream = getClass().getClassLoader().getResourceAsStream(aFileName);
        LineReader myLineReader = new LineReader(new InputStreamReader(myResourceAsStream));
        return myLineReader;
    }
}
