package com.tagliola.codejam2014.qualify.cookieclicker;

import java.io.*;
import java.math.*;
import java.util.*;

import com.google.common.base.*;
import com.google.common.collect.*;
import com.google.common.collect.Sets.SetView;
import com.google.common.io.*;

public class CookieClicker
{
    public static void main(String[] args) throws NumberFormatException, IOException
    {
        new CookieClicker(args[0]);
    }

    public CookieClicker(String aFileName) throws NumberFormatException, IOException
    {
        PrintStream myPrintStream = new PrintStream(new File(aFileName + ".out"));
        LineReader myLineReader = getLineReader(aFileName + ".in");
        int myNumberOfCases = Integer.parseInt(myLineReader.readLine());
        for (int myCase = 1; myCase <= myNumberOfCases; myCase++)
        {
            String myResult = "Case #" + myCase + ": " + performCase(myLineReader);
            
            System.out.println(myResult);
            myPrintStream.println(myResult);
        }
        myPrintStream.close();
    }

    private String performCase(LineReader aLineReader) throws IOException
    {
        List<String> mySplit = Splitter.on(' ').splitToList(aLineReader.readLine());
        
        BigDecimal myFarmPrice = new BigDecimal(mySplit.get(0));
        BigDecimal myFarmRate = new BigDecimal(mySplit.get(1));
        BigDecimal myTarget = new BigDecimal(mySplit.get(2));
        
        CookieClickerCase myCookieClickerCase = new CookieClickerCase(myFarmPrice, myFarmRate, myTarget);
        BigDecimal myResult = myCookieClickerCase.calculate();
        return myResult.setScale(7, RoundingMode.UP).stripTrailingZeros().toPlainString();
    }

    private LineReader getLineReader(String aFileName)
    {
        InputStream myResourceAsStream = getClass().getClassLoader().getResourceAsStream(aFileName);
        LineReader myLineReader = new LineReader(new InputStreamReader(myResourceAsStream));
        return myLineReader;
    }
}
