package com.tagliola.codejam2014.qualify.magictrick;

import java.io.*;
import java.util.*;

import com.google.common.base.*;
import com.google.common.collect.*;
import com.google.common.collect.Sets.SetView;
import com.google.common.io.*;

public class MagicTrick
{
    public static void main(String[] args) throws NumberFormatException, IOException
    {
        new MagicTrick(args[0]);
    }

    public MagicTrick(String aFileName) throws NumberFormatException, IOException
    {
        PrintStream myPrintStream = new PrintStream(new File(aFileName + ".out"));
        LineReader myLineReader = getLineReader(aFileName + ".in");
        int myNumberOfCases = Integer.parseInt(myLineReader.readLine());
        for (int myCase = 1; myCase <= myNumberOfCases; myCase++)
        {
            String myResult = "Case #" + myCase + ": " + performCase(myCase, myLineReader);
            
            System.out.println(myResult);
            myPrintStream.println(myResult);
        }
        myPrintStream.close();
    }

    private String performCase(int aCase, LineReader aLineReader) throws IOException
    {
        Set<String> myFirstGrid = Sets.newHashSet(readGrid(aLineReader));
        Set<String> mySecondGrid = Sets.newHashSet(readGrid(aLineReader));
        
        SetView<String> myDifference = Sets.intersection(myFirstGrid, mySecondGrid);
        switch(myDifference.size())
        {
            case 0 : return "Volunteer cheated!";
            case 1: return Iterables.getOnlyElement(myDifference);
            default: return "Bad magician!";
        }
    }

    private LineReader getLineReader(String aFileName)
    {
        InputStream myResourceAsStream = getClass().getClassLoader().getResourceAsStream(aFileName);
        LineReader myLineReader = new LineReader(new InputStreamReader(myResourceAsStream));
        return myLineReader;
    }

    private static List<String> readGrid(LineReader myLineReader) throws IOException
    {
        List<String> mySplitToList = null;
        int myRowNumber = Integer.parseInt(myLineReader.readLine());
        for (int myRow = 1; myRow <= 4; myRow++)
        {
            String myRowLine = myLineReader.readLine();
            if (myRow == myRowNumber)
            {
                mySplitToList = Splitter.on(' ').splitToList(myRowLine);
            }
        }
        return mySplitToList;
    }
}
