package com.tagliola.codejam2014.qualify.deceitfulwar;

import java.math.*;
import java.util.*;

import com.google.common.collect.*;

class DeceitfulWarCase
{
    private Set<BigDecimal> theNaomi;
    private Set<BigDecimal> theKen;

    public DeceitfulWarCase(Set<BigDecimal> aNaomi, Set<BigDecimal> aKen)
    {
        theNaomi = aNaomi;
        theKen = aKen;
    }

    public List<Integer> calculate()
    {
        System.out.println(theNaomi);
        System.out.println(theKen);
        System.out.println();
        List<Integer> myScores = Lists.newArrayList();
        myScores.add(playDeceitfulWar());
        myScores.add(playWar());
        return myScores;
    }

    private int playDeceitfulWar()
    {
        int myScore = 0;
        
        LinkedList<BigDecimal> myNaomi = Lists.newLinkedList(Sets.newTreeSet(theNaomi));
        LinkedList<BigDecimal> myKen = Lists.newLinkedList(Sets.newTreeSet(theKen));
        
        while (!myNaomi.isEmpty())
        {
            if (myNaomi.removeFirst().compareTo(myKen.getFirst()) < 0)
            {
                myKen.removeLast();
            }
            else
            {
                myScore++;
                myKen.removeFirst();
            }
        }
        
        return myScore;
    }

    private int playWar()
    {
        int myScore = 0;
        
        LinkedList<BigDecimal> myNaomi = Lists.newLinkedList(Sets.newTreeSet(theNaomi));
        SortedSet<BigDecimal> myKen = Sets.newTreeSet(theKen);
        
        while (!myNaomi.isEmpty())
        {
            BigDecimal myNaomiBlock = myNaomi.removeFirst();
            SortedSet<BigDecimal> myTailSet = myKen.tailSet(myNaomiBlock);
            if (myTailSet.isEmpty())
            {
                myScore++;
                myKen.remove(myKen.first());
            }
            else
            {
                myTailSet.remove(myTailSet.first());
            }
        }
        
        return myScore;
    }
}
