package com.tagliola.codejam2014.round1b.problem1;

import java.util.*;

import com.google.common.collect.*;

class Problem1Case
{
    private List<Word> theWords = Lists.newArrayList();

    public Problem1Case(List<String> aWords)
    {
        for (String aWord : aWords)
        {
            theWords.add(new Word(aWord));
        }
    }

    public String calculate()
    {
        int myMovements = 0;
        Word myFirstWord = theWords.get(0);

        for (int myIndex = 0; myIndex < myFirstWord.theSegments.size(); myIndex++)
        {
            int myTotalLength = 0;
            char myCharacter = myFirstWord.theSegments.get(myIndex).theCharacter;
            
            for (Word myWord : theWords)
            {
                if (myWord.theSegments.size() != myFirstWord.theSegments.size())
                {
                    return "Fegla Won";
                }
                Segment mySegment = myWord.theSegments.get(myIndex);
                if (myCharacter != mySegment.theCharacter)
                {
                    return "Fegla Won";
                }
                myTotalLength += mySegment.theLength;
            }
            int myTargetLength = Math.round((float) myTotalLength / theWords.size());
            
            for (Word myWord : theWords)
            {
                Segment mySegment = myWord.theSegments.get(myIndex);
                myMovements += Math.abs(mySegment.theLength - myTargetLength);
            }
        }
        
        return Integer.toString(myMovements);
    }
    
    class Word
    {
        private List<Segment> theSegments = Lists.newArrayList();
        
        public Word(String aWord)
        {
            Segment myCurrentSegment = null;
            for (Character myCharacter : Lists.charactersOf(aWord))
            {
                char myCharValue = myCharacter.charValue();
                if (myCurrentSegment == null || myCurrentSegment.isDifferent(myCharValue))
                {
                    myCurrentSegment = new Segment(myCharValue);
                    theSegments.add(myCurrentSegment);
                }
                else
                {
                    myCurrentSegment.inc();
                }
            }
        }
    }
    
    class Segment
    {
        private char theCharacter;
        private int theLength = 1;
        
        public Segment(char aCharacter)
        {
            theCharacter = aCharacter;
        }

        public void inc()
        {
            theLength++;
            
        }

        public boolean isDifferent(char aCharValue)
        {
            return aCharValue != theCharacter;
        }
    }
}
