package g430q1;

import java.util.Arrays;
import java.util.HashMap;

public class SolutionDfs {
    public double getMaxSurface(long[][] cakes, int k) {
        // sort the cakes first
        Arrays.sort(cakes, (c1, c2) -> {
            if (c1[0] != c2[0]) return Long.signum(c2[0] - c1[0]);
            return Long.signum(c2[1] - c1[1]);
        });
        HashMap<Integer[], Long> map = new HashMap<>();
        Long result = getMaxSurface(cakes, k, 0, 0L, map);
        return result * Math.PI;
    }

    private Long getMaxSurface(long[][] cakes, int k, int index, Long area, HashMap<Integer[], Long> map) {
        Integer[] key = new Integer[]{index, k};
        if (map.containsKey(key)) {
            return map.get(key);
        } else if (k == 0) {
            return area;
        }

        Long maxArea = -1L;
        for (int i = index; i < cakes.length; i++) {
            long top = cakes[i][0] * cakes[i][0];
            if (index == 0) area = top;
            long side = 2L * cakes[i][0] * cakes[i][1];
            area += side;
            Long currentArea = getMaxSurface(cakes, k - 1, i + 1, area, map);
            maxArea = Math.max(maxArea, currentArea);
            area -= side;
        }

        map.put(key, maxArea);
        return maxArea;
    }
}
