package g414q2;

import java.util.Arrays;

public class Solution {
    public int findNumberOfKits(int[] ingredients, int[][] ingredientPackages) {
        for (int i = 0; i < ingredientPackages.length; i++) {
            Arrays.sort(ingredientPackages[i]);
        }

        int kits = 0;
        int[] indexes = new int[ingredients.length];
        while (!isDone(ingredientPackages[0].length, indexes)) {
            if (isValid(ingredients, ingredientPackages, indexes)) {
                kits++;
                for (int i = 0; i < indexes.length; i++) {
                    indexes[i]++;
                }
            } else {
                double minPkgs = Integer.MAX_VALUE;
                int minIndex = 0;
                for (int i = 0; i < ingredients.length; i++) {
                    int size = ingredientPackages[i][indexes[i]];
                    double pkgs = size / ingredients[i];
                    if (minPkgs > pkgs) {
                        minPkgs = pkgs;
                        minIndex = i;
                    }
                }

                indexes[minIndex]++;
            }
        }

        return kits;
    }

    private boolean isValid(int[] ingredients, int[][] ingredientPackages, int[] indexes) {
        int minNum = Integer.MAX_VALUE;
        int maxNum = Integer.MIN_VALUE;
        for (int i = 0; i < ingredients.length; i++) {
            int num = ingredientPackages[i][indexes[i]] / ingredients[i];
            minNum = Math.min(minNum, (int)Math.floor((double)ingredientPackages[i][indexes[i]] / (double)ingredients[i]));
            maxNum = Math.max(maxNum, (int)Math.ceil((double)ingredientPackages[i][indexes[i]] / (double)ingredients[i]));
        }

        for (int i = minNum; i <= maxNum; i++) {
            if (isValidSize(ingredients, ingredientPackages, indexes, i)) {
                return true;
            }
        }

        return false;
    }

    private boolean isValidSize(int[] ingredients, int[][] ingredientPackages, int[] indexes, int size) {
        for (int i = 0; i < ingredients.length; i++) {
            double lowerBound = ingredients[i] * size * 0.9d;
            double upperBound = ingredients[i] * size * 1.1d;
            if (ingredientPackages[i][indexes[i]] < lowerBound || ingredientPackages[i][indexes[i]] > upperBound) {
                return false;
            }
        }

        return true;
    }

    private boolean isDone(int numberOfPackages, int[] indexes) {
        for (int i = 0; i < indexes.length; i++) {
            if (indexes[i] >= numberOfPackages) {
                return true;
            }
        }

        return false;
    }
}
