import java.io.*;

class Line{
    int xr, yr;
    int xl, yl;
    double m;
}

class Test000{
    int testCases;
    Line[] ln;
    int n;
    int[] res;
    
    public static void main(String[] arg){
        if(arg.length != 2){
            System.out.println("\nPass <input_filename>, <output_filename> as cmd args\n");
            System.exit(1);
        }
        
        Test000 a = new Test000();
        
        a.read(arg[0]);
        
        a.write(arg[1]);
    }    
    
    void read(String filename){
        File f = new File(filename);
        try{
            FileInputStream fin = new FileInputStream(f);
            LineNumberReader lr = new LineNumberReader(new InputStreamReader(fin));
            
            // Take input
            testCases = Integer.parseInt(lr.readLine());
            res = new int[testCases];
            for(int i = 0; i < testCases; i++){
                String s = lr.readLine();
                String[] tmp = s.split(" ");
                
                n = Integer.parseInt(tmp[0]);
                ln = new Line[n];
                for(int j = 0; j < n; j++){
                    s = lr.readLine();
                    tmp = s.split(" ");
                    ln[j] = new Line();
                    ln[j].xl = 0;
                    ln[j].yl = Integer.parseInt(tmp[0]);
                    ln[j].xr = 10000;
                    ln[j].yr = Integer.parseInt(tmp[1]);
                    ln[j].m = ((double)(ln[j].yr - ln[j].yl))/(ln[j].xr - ln[j].xl);
                }
                sort();
                res[i] = solve();
            }
            
            fin.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    void write(String filename){
        File f = new File(filename);
        try{
            FileOutputStream fout = new FileOutputStream(f);
            
            // call working func()
            StringBuffer s = new StringBuffer();
            
            for(int i = 0; i < testCases; i++){
                s.append("Case #" + String.valueOf(i+1) + ": " + res[i] +"\n");
            }
            
            // write to file
            byte[] b = s.toString().getBytes();
            fout.write(b);
            fout.flush();
            fout.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    static void display(int[] s){
        for(int i = 0; i < s.length; i++)
            System.out.print(String.valueOf(s[i]) + " ");
    }
    
    void sort(){
        for(int i = 0; i < n; i++){
            for(int j = i + 1; j < n ; j++){
                if(ln[i].yl < ln[j].yl){
                    Line t = ln[i];
                    ln[i] = ln[j];
                    ln[j] = t;
                }
            }
        }
    }
    
    int solve(){
        int count = 0;
        for(int i = 0; i < n; i++){
            for(int j = i + 1; j < n ; j++){
                if(ln[i].m != ln[j].m){
                    if(ln[i].yr  < ln[j].yr){
                        count ++;
                    }
                }
            }
        }
        return count;
    }
}