import java.io.*;

class RollerCoasterRide{
    int testCases;
    int[] maxSize;
    int[] maxRides;
    int[][] groupSize;
    
    public static void main(String[] arg){
        if(arg.length != 2){
            System.out.println("\nPass <input_filename>, <output_filename> as cmd args\n");
            System.exit(1);
        }
        RollerCoasterRide a = new RollerCoasterRide();
        a.read(arg[0]);
        
        /*System.out.println("\ntestCases = " + a.testCases);
        
        System.out.println("\nmaxRides = \n");
        display(a.maxRides);
        
        System.out.println("\nmaxSize = \n");
        display(a.maxSize);
        
        System.out.println("\ngroupSize = \n");
        display2(a.groupSize);
        
        System.out.println("\n getEuros() = \n");
        display(a.getEuros());*/
        
        a.write(arg[1]);
    }    
    
    void read(String filename){
        File f = new File(filename);
        try{
            FileInputStream fin = new FileInputStream(f);
            LineNumberReader lr = new LineNumberReader(new InputStreamReader(fin));
            
            testCases = Integer.parseInt(lr.readLine());
            maxSize = new int[testCases];
            maxRides = new int[testCases];
            groupSize = new int[testCases][];
            
            for(int i = 0; i < testCases; i++){
                String s = lr.readLine();
                String[] tmp = s.split(" ");
                maxRides[i] = Integer.parseInt(tmp[0]);
                maxSize[i] = Integer.parseInt(tmp[1]);
                
                int n = Integer.parseInt(tmp[2]);
                groupSize[i] = new int[n];
                
                s = lr.readLine();
                tmp = s.split(" ");
                
                for(int j = 0; j < n; j++){
                    groupSize[i][j] = Integer.parseInt(tmp[j]);    
                }
            }
            fin.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    void write(String filename){
        File f = new File(filename);
        try{
            FileOutputStream fout = new FileOutputStream(f);
            int[] euros = getEuros();
            String s = new String();
            for(int i = 0; i < testCases; i++)
                s += "Case #" + String.valueOf(i+1) + ": " + String.valueOf(euros[i]) + "\n";
            byte[] b = s.getBytes();
            fout.write(b);
            fout.flush();
            fout.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    static void display(int[] s){
        for(int i = 0; i < s.length; i++)
            System.out.print(String.valueOf(s[i]) + " ");
    }
    
    static void display2(int[][] s){
        for(int i = 0; i < s.length; i++){
            for(int j = 0; j < s[i].length ; j++)
                System.out.print(String.valueOf(s[i][j]) + " ");
            System.out.println();
        }
    }
    
    int[] getEuros(){
        int[] euros = new int[testCases];
        
        for(int i = 0; i < testCases; i++){
            int totalPersons = 0;
            int j = 0;
            
            for(int k = 0; k < maxRides[i]; k++){
                int persons = 0;
                int n = 0;
                
                while(n < groupSize[i].length){
                    if(persons + groupSize[i][j] <= maxSize[i])
                        persons += groupSize[i][j];
                    else
                        break;
                    j = (j+1) % groupSize[i].length;
                    n++;
                }
                totalPersons += persons;
            }
            euros[i] = totalPersons;
        }
        return euros;
    }
}