import java.io.*;
import java.math.*;

class FairWarning{
    int testCases;
    BigInteger[][] eventTimes;
    
    public static void main(String[] arg){
        if(arg.length != 2){
            System.out.println("\nPass <input_filename>, <output_filename> as cmd args\n");
            System.exit(1);
        }
        FairWarning a = new FairWarning();
        a.read(arg[0]);
        
        /*System.out.println("\n testCases = " + a.testCases);
        for(int i = 0; i < a.testCases; i++){
            System.out.println("\nCase " + i + "\n");
            display(a.eventTimes[i]);
            System.out.println();
        }*/
        
        a.write(arg[1]);
    }    
    
    void read(String filename){
        File f = new File(filename);
        try{
            FileInputStream fin = new FileInputStream(f);
            LineNumberReader lr = new LineNumberReader(new InputStreamReader(fin));
            
            testCases = Integer.parseInt(lr.readLine());
            eventTimes = new BigInteger[testCases][];
            
            for(int i = 0; i < testCases; i++){
                String s = lr.readLine();
                String[] tmp = s.split(" ");
                
                eventTimes[i] = new BigInteger[Integer.parseInt(tmp[0])];
                
                for(int j = 1; j <= eventTimes[i].length; j++)
                    eventTimes[i][j-1] = new BigInteger(tmp[j]);
            }
            fin.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    void write(String filename){
        File f = new File(filename);
        try{
            FileOutputStream fout = new FileOutputStream(f);
            BigInteger[] res = getY();
            StringBuffer s = new StringBuffer();
            for(int i = 0; i < res.length; i++)
                s.append("Case #" + String.valueOf(i+1) + ": " + res[i].toString() + "\n");
            byte[] b = s.toString().getBytes();
            fout.write(b);
            fout.flush();
            fout.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    static void display(BigInteger[] s){
        for(int i = 0; i < s.length; i++)
            System.out.print(s[i] + " ");
    }
    
    BigInteger[] getY(){
        BigInteger[] res = new BigInteger[testCases];
        for(int i = 0; i < testCases; i++){
            int n = eventTimes[i].length;
            BigInteger[] diff = new BigInteger[(n*(n-1))/2];
            
            //System.out.println("\nCase " + i + "\n");
            int x = 0;
            for(int j = 0; j < n; j++){
                for(int k = j + 1; k < n; k++){
                    diff[x] = eventTimes[i][j].subtract(eventTimes[i][k]).abs();
                    //System.out.print(" " + diff[x]);
                    x++;
                }
            }
            
            BigInteger gcd = BigInteger.ONE;
            if(diff.length == 1)
                gcd = diff[0];
            else{
                for(x = 0; x < diff.length - 1; x++){
                      gcd = diff[x].gcd(diff[x+1]);
                }
            }
            //System.out.println("\ngcd = " + gcd);
            
            BigInteger inc = new BigInteger("2");
            BigInteger tmp;
            while(true){
                BigInteger[] b = eventTimes[i][0].divideAndRemainder(gcd);
                tmp = gcd.subtract(b[1]);
                //System.out.println("\n tmp = " + tmp + " b[0] = " + b[0] + " b[1]  = " + b[1]);
                
                x = 1;
                for(int j = 1; j < n; j++){
                    BigInteger tmp2 = eventTimes[i][j].divideAndRemainder(gcd)[1];
                    int eq = tmp.compareTo(gcd.subtract(tmp2));
                    //System.out.println("\n" + j +" tmp2 = " + tmp2);
                    if(eq == 0)
                        x++;
                    else
                        break;
                }
                if(x == n)
                    break;
                gcd = gcd.multiply(inc);
                inc.add(BigInteger.ONE);
            }
            //System.out.println("\nat end gcd = " + gcd);
            if(gcd.compareTo(tmp) == 0)
                res[i] = BigInteger.ZERO;
            else
                res[i] = tmp;
            //System.out.println("\nres["+ i +"] = " + res[i]);
        }
        return res;
    }
}