import java.io.*;

class Snapper{
    int testCases;
    int[] noOfSnappers;
    int[] snaps;
    
    public static void main(String[] arg){
        if(arg.length != 2){
            System.out.println("\nPass <input_filename>, <output_filename> as cmd args\n");
            System.exit(1);
        }
        Snapper a = new Snapper();
        a.read(arg[0]);
        
        a.write(arg[1]);
    }    
    
    void read(String filename){
        File f = new File(filename);
        try{
            FileInputStream fin = new FileInputStream(f);
            LineNumberReader lr = new LineNumberReader(new InputStreamReader(fin));
            
            testCases = Integer.parseInt(lr.readLine());
            noOfSnappers = new int[testCases];
            snaps = new int[testCases];
            
            for(int i = 0; i < testCases; i++){
                String s = lr.readLine();
                String[] tmp = s.split(" ");
                noOfSnappers[i] = Integer.parseInt(tmp[0]);
                snaps[i] = Integer.parseInt(tmp[1]);
            }
            fin.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    void write(String filename){
        File f = new File(filename);
        try{
            FileOutputStream fout = new FileOutputStream(f);
            boolean[] res = isON();
            StringBuffer s = new StringBuffer();
            for(int i = 0; i < testCases; i++){
                if(res[i])
                    s.append("Case #" + String.valueOf(i+1) + ": ON\n");
                else
                    s.append("Case #" + String.valueOf(i+1) + ": OFF\n");
            }
            byte[] b = s.toString().getBytes();
            fout.write(b);
            fout.flush();
            fout.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    static void display(int[] s){
        for(int i = 0; i < s.length; i++)
            System.out.print(String.valueOf(s[i]) + " ");
    }
    
    
    boolean[] isON(){
        boolean[] res = new boolean[testCases];
        
        for(int i = 0; i < testCases; i++){
            int twoPowN = 1;
            for (int j = 0; j < noOfSnappers[i]; j++){
                twoPowN *= 2;
            }
            int steps = (snaps[i] + 1) % (twoPowN);
            if(steps == 0 && snaps[i] != 0)
                res[i] = true;
            else
                res[i] = false;
        }
        return res;
    }
}