import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Paths;

public class StandingOvation {

	public static int[] getShyLevels(String detailShyLevels)  {
		int[] shyLevels = new int[detailShyLevels.length()];
		for (int i = 0; i < detailShyLevels.length(); i++)  {
			shyLevels[i] = new Integer(detailShyLevels.substring(i, i + 1)).intValue();
		}
		return shyLevels;
	}
	
	public static int getTotalPeople(String detailShyLevels)  {
		int result = 0;
		for (int i = 0; i < detailShyLevels.length(); i++)  {
			result += new Integer(detailShyLevels.substring(i, i+ 1)).intValue();
		}
		return result;
	}

	public static int compute(int minShyLevel, int[] shyLevels, int totalPeople, int extraPeopleAdded)  {
		int numPeopleWhoWillStand = 0;
		int index = 0;
		for (int i = 0; i < shyLevels.length; i++)  {
			if (i <= numPeopleWhoWillStand)  {
				numPeopleWhoWillStand += shyLevels[i];
				index = i;
			}
		}

		if (numPeopleWhoWillStand < totalPeople) {
		
			int actualMinShyLevel = 0;
			for (int i = index; i < shyLevels.length; i++)  {
				if (shyLevels[i] > 0)  {
					actualMinShyLevel = i;
					break;
				}
			}
			
			if (actualMinShyLevel > numPeopleWhoWillStand)  {
				// Get Help!
				int extraHelp = actualMinShyLevel - numPeopleWhoWillStand;
				shyLevels[0] += extraHelp;
				return compute(minShyLevel, shyLevels, totalPeople + extraHelp, extraPeopleAdded + extraHelp);
			}
		}
		
		return extraPeopleAdded;
	}
	
	public static void main(String[] args)  {
		
		try {
			
			PrintWriter writer = new PrintWriter("C:/Users/lcheeme1/Documents/A-large.out");
			int i = 0;
			int numCases = 0;
			
			for (String line : Files.readAllLines(Paths.get("C:/Users/lcheeme1/Documents/A-large.in"))) {
//			for (String line : Files.readAllLines(Paths.get("C:/Users/lcheeme1/Documents/A-small.txt"))) {
				if (i == 0)  {
					numCases = (new Integer(line)).intValue();
				}
				else {
					String data[] = line.split(" ");
					int output = compute(new Integer(data[0]).intValue(), getShyLevels(data[1]), getTotalPeople(data[1]), 0);
					System.out.println(line + ":" + output);
					writer.println("Case #" + i + ": " + output);
				}
				i++;
			}
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}		
	}
}

