import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class Main {
    final int One = 1;
    final int Pi = 2;
    final int Pj = 3;
    final int Pk = 4;

    static int tab[][] = {
            {1, 2, 3, 4},
            {2, -1, 4, -3},
            {3, -4, -1, 2},
            {4, 3, -2, -1}
    };

    static int mult(int q0, int q1) {
        int neg = 1;
        if (q0 < 0) {
            neg *= -1; q0 *= -1;
        }
        if (q1 < 0) {
            neg *= -1; q1 *= -1;
        }
        return neg * tab[q0 - 1][q1 - 1];
    }

    private static boolean solve(String s, int repeat) {
        List<Integer> pat = new ArrayList<Integer>(s.length() * repeat);
        for (int i = 0; i < repeat; i++) {
            for (int j = 0; j < s.length(); j++) {
                int v = 1;
                switch (s.charAt(j)) {
                    case 'i':
                        v = 2; break;
                    case 'j':
                        v = 3; break;
                    case 'k':
                        v = 4; break;
                }
                pat.add(v);
            }
        }

        int iend = span(pat, 0, 2);
        if (iend >= 0) {
            int jend = span(pat, iend, 3);
            if (jend >= 0) {
                // System.out.println("i:" + iend + " j:" + jend);
                return product(pat, jend) == 4;
            }
        }
        return false;
    }

    private static int span(List<Integer> pat, int idx, int target) {
        int v = 1;

        while (v != target && idx < pat.size()) {
            v = mult(v, pat.get(idx));
            idx++;
        }
        if (v == target) {
            return idx;
        }
        return -1;
    }

    private static int product(List<Integer> pat, int idx) {
        int v;
        for (v = 1; idx < pat.size(); idx++) {
            v = mult(v, pat.get(idx));
        }
        return v;
    }

    private static void solveAll(LineNumberReader in) throws IOException {
        int nProblem = Integer.valueOf(in.readLine().trim());

        for (int i = 0; i < nProblem; i++) {
            StringTokenizer tokenizer = new StringTokenizer(in.readLine());
            int l = Integer.valueOf(tokenizer.nextToken());
            int repeat = Integer.valueOf(tokenizer.nextToken());

            String line = in.readLine();
            System.out.println(String.format("Case #%d: %s", i + 1,
                    solve(line, repeat) ? "YES" : "NO", line));
        }
    }

    public static void main(String[] args) throws IOException {
        InputStream in = System.in;
        if (args.length > 0) {
            in = new FileInputStream(args[0]);
        }
        solveAll(new LineNumberReader(new InputStreamReader(in)));
        in.close();
    }
}

