import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;
import java.util.stream.Collectors;

public class Main {

    private static void solveAll(LineNumberReader in) throws IOException {
        int nProblem = Integer.valueOf(in.readLine().trim());

        for (int i = 0; i < nProblem; i++) {
            String line = in.readLine();
            StringTokenizer tokenizer = new StringTokenizer(line);
            int maxSynth = Integer.valueOf(tokenizer.nextToken());
            List<Integer> ppls = new ArrayList<Integer>(maxSynth + 1);

            String s = tokenizer.nextToken();

            for (int j = 0; j <= maxSynth; j++) {
                ppls.add(s.charAt(j) - '0');
            }

            System.out.println(String.format("Case #%d: %d", i + 1,
                    solve(maxSynth, ppls), line));
        }
    }

    private static int solve(int maxSynth, List<Integer> ppls) {
        int nStanding = 0;
        int needed = 0;
        for (int i = 0; i <= maxSynth; i++) {
            if (nStanding < i) {
                needed++;
                nStanding++;
            }
            nStanding += ppls.get(i);
        }
        return needed;
    }

    public static void main(String[] args) throws IOException {
        InputStream in = System.in;
        if (args.length > 0) {
            in = new FileInputStream(args[0]);
        }
        solveAll(new LineNumberReader(new InputStreamReader(in)));
        in.close();
    }
}
