import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;
import java.util.stream.IntStream;

public class Main {
    private static int guess(List<Integer> nps, int intermediate) {
        int nSpecial = 0;
        for (int np : nps) {
            nSpecial += (np - 1) / intermediate;
        }
        return nSpecial + intermediate;
    }

    private static int solve(final List<Integer> nps) {
        int maxPs = nps.stream().max(Integer::compare).get();

        return IntStream.range(1, maxPs + 1).map(n -> guess(nps, n)).min().getAsInt();
    }

    private static void solveAll(LineNumberReader in) throws IOException {
        int nProblem = Integer.valueOf(in.readLine().trim());

        for (int i = 0; i < nProblem; i++) {
            int d = Integer.valueOf(in.readLine());

            String line = in.readLine();
            StringTokenizer tokenizer = new StringTokenizer(line);
            List<Integer> nps = new ArrayList<Integer>(d);
            for (int j = 0; j < d; j++) {
                Integer np = Integer.valueOf(tokenizer.nextToken());
                if (np > 0) {
                    nps.add(np);
                }
            }

            System.out.println(String.format("Case #%d: %d", i + 1,
                    solve(nps), line));
        }
    }

    public static void main(String[] args) throws IOException {
        InputStream in = System.in;
        if (args.length > 0) {
            in = new FileInputStream(args[0]);
        }
        solveAll(new LineNumberReader(new InputStreamReader(in)));
        in.close();
    }
}
