package com.forthgo.google.g2012r2;

import com.forthgo.math.Helper;

import java.awt.geom.Point2D;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * Created by Xan Gregg.
 * Date: 5/26/12
 */
public class ProblemB {
    public static void main(String[] args) {
        try {
            Scanner in = new Scanner(new File("B.in"));
            PrintWriter out = new PrintWriter(new FileWriter("B.out"));
//            PrintWriter out = new PrintWriter(System.out);
            int t = in.nextInt();
            for (int i = 0; i < t; i++) {
                int N = in.nextInt();
                int W = in.nextInt();
                int L = in.nextInt();
                out.printf("Case #%d:", i + 1);
                solve(in, out, N, W, L);
                //out.printf("Case #%d: %f%n", i + 1, k);
                out.flush();
            }
        } catch (IOException e) {
            throw new RuntimeException();
        }

    }

    private static void solve(Scanner in, PrintWriter out, int nc, int w, int h) {
        double[] r = new double[nc];
        for (int i = 0; i < nc; i++) {
            r[i] = in.nextDouble();
        }

        Point2D.Double [] pos = new Point2D.Double[nc];
        int [] index = Helper.sortedIndices(r);
        double x = 0;
        double y = 0;
        double cx = 0;
        double cy = 0;
        double yy = 0;
        for (int i = index.length - 1; i >= 0; i--) {
            int j = index[i];
            if (x == 0) {
                cx = 0;
            }
            else {
                cx = x + r[j];
            }
            if (cx > w) {
                cx = 0;
                y = yy;
            }
            if (y == 0) {
                cy = 0;
            }
            else {
                cy = y + r[j];
            }
            if (cy > h)
                throw new RuntimeException();
            pos[j] = new Point2D.Double(cx, cy);
            x = cx + r[j];
            yy = Math.max(yy, cy + r[j]);
        }
        for (int i = 0; i < nc; i++) {
            out.printf(" %d %d", (int)pos[i].getX(), (int)pos[i].getY());

        }
        out.printf("%n");

    }

    public static int[] sortedIndices(double[] x) {
        int[] ix = new int[x.length];
        int[] scratch = new int[x.length];
        for (int i = 0; i < ix.length; i++) {
            ix[i] = i;
        }
        mergeSortIndexed(x, ix, scratch, 0, x.length - 1);
        return ix;
    }

    private static void mergeSortIndexed(double[] x, int[] ix, int[] scratch, int lo, int hi) {
        if (lo == hi)
            return;
        int mid = (lo + hi + 1) / 2;
        mergeSortIndexed(x, ix, scratch, lo, mid - 1);
        mergeSortIndexed(x, ix, scratch, mid, hi);
        mergeIndexed(x, ix, scratch, lo, mid - 1, mid, hi);
    }

    private static void mergeIndexed(double[] x, int[] ix, int[] scratch, int lo1, int hi1, int lo2, int hi2) {
        int i = 0;
        int i1 = lo1;
        int i2 = lo2;
        int n1 = hi1 - lo1 + 1;
        int n2 = hi2 - lo2 + 1;
        while (i1 <= hi1 && i2 <= hi2) {
            if (x[ix[i1]] <= x[ix[i2]]) {
                scratch[i++] = ix[i1++];
            }
            else {
                scratch[i++] = ix[i2++];
            }
        }
        while (i1 <= hi1) {
            scratch[i++] = ix[i1++];
        }
        while (i2 <= hi2) {
            scratch[i++] = ix[i2++];
        }
        if (i != n1 + n2) {
            throw new RuntimeException();
        }
        for (int j = lo1; j <= hi1; j++) {
            ix[j] = scratch[j - lo1];
        }
        for (int j = lo2; j <= hi2; j++) {
            ix[j] = scratch[(j - lo2 + n1)];
        }
    }


}

