package com.forthgo.google;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.StringTokenizer;

/**
 * Created by Xan Gregg.
 * Date: 5/6/11
 */
public class Magicka {
    public static void main(String[] args) {
        try {
            BufferedReader in = new BufferedReader(new FileReader("../euler/src/com/forthgo/google/Magicka.in"));
            String line = in.readLine();
            StringTokenizer st = new StringTokenizer(line);
            int n = Integer.parseInt(st.nextToken());
            for (int i = 0; i < n; i++) {
                line = in.readLine();
                String y = solve(line);
                StringBuilder sb = new StringBuilder();

                for (int j = 0; j < y.length(); j++) {
                    if (j > 0)
                        sb.append(", ");
                    sb.append(y.charAt(j));
                }
                System.out.printf("Case #%d: [%s]%n", i + 1, sb.toString());
            }

        } catch (IOException e) {
            throw new RuntimeException();
        }

    }

    private static String solve(String line) {
        int[] baseMap = new int[256];
        int nb = 0;
        baseMap['Q'] = nb++;
        baseMap['W'] = nb++;
        baseMap['E'] = nb++;
        baseMap['R'] = nb++;
        baseMap['A'] = nb++;
        baseMap['S'] = nb++;
        baseMap['D'] = nb++;
        baseMap['F'] = nb++;
        StringTokenizer st = new StringTokenizer(line);
        char[][] combine = new char[nb][nb];
        int c = Integer.parseInt(st.nextToken());
        for (int i = 0; i < c; i++) {
            String abc = st.nextToken();
            int a = baseMap[abc.charAt(0)];
            int b = baseMap[abc.charAt(1)];
            char ch = abc.charAt(2);
            combine[a][b] = ch;
            combine[b][a] = ch;
        }
        boolean[][] opposed = new boolean[nb][26];
        int d = Integer.parseInt(st.nextToken());
        for (int i = 0; i < d; i++) {
            String ab = st.nextToken();
            int a = baseMap[ab.charAt(0)];
            int b = baseMap[ab.charAt(1)];
            opposed[a][b] = true;
            opposed[b][a] = true;
        }
        int[][] opposers = new int[nb][];
        for (int a = 0; a < nb; a++) {
            int oc = 0;
            for (int b = 0; b < nb; b++) {
                if (opposed[a][b])
                    oc++;
            }
            int io = 0;
            opposers[a] = new int[oc];
            for (int b = 0; b < nb; b++) {
                if (opposed[a][b])
                    opposers[a][io++] = b;
            }
        }
        int n = Integer.parseInt(st.nextToken());
        String spell = st.nextToken();
        if (n != spell.length())
            throw new RuntimeException();
        int[] count = new int[nb];
        int prev = -1;
        StringBuilder sb = new StringBuilder();
        outer:
        for (int i = 0; i < n; i++) {
            char ch = spell.charAt(i);
            int cur = baseMap[ch];
            if (prev >= 0) {
                char combo = combine[prev][cur];
                if (combo != 0) {
                    sb.deleteCharAt(sb.length() - 1);
                    sb.append(combo);
                    count[prev]--;
                    prev = -1;
                    continue;
                }
            }
            for (int j = 0; j < opposers[cur].length; j++) {
                int opp = opposers[cur][j];
                if (count[opp] > 0) {
                    sb.delete(0, sb.length());
                    count = new int[26];
                    prev = -1;
                    continue outer;
                }

            }
            sb.append(ch);
            count[cur]++;
            prev = cur;

        }

        return sb.toString();
    }
}
