package com.forthgo.google;

import java.io.*;
import java.util.StringTokenizer;

/**
 * Created by Xan Gregg.
 * Date: 5/6/11
 */
public class BotTrust {
    public static void main(String[] args) {
//        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        try {
            BufferedReader in = new BufferedReader(new FileReader("../euler/src/com/forthgo/google/BotTrust.txt"));
            String line = in.readLine();
            StringTokenizer st = new StringTokenizer(line);
            int n = Integer.parseInt(st.nextToken());
            for (int i = 0; i < n; i++) {
                line = in.readLine();
                long m = solve(line);
                System.out.printf("Case #%d: %d%n", i + 1, m);
            }

        } catch (IOException e) {
            throw new RuntimeException();
        }

    }

    private static long solve(String line) {
        StringTokenizer st = new StringTokenizer(line);
        int n = Integer.parseInt(st.nextToken());
        int[] bot = new int[n];
        int[] button = new int[n];
        for (int i = 0; i < n; i++) {
            bot[i] = st.nextToken().equals("B") ? 0 : 1;
            button[i] = Integer.parseInt(st.nextToken());
        }
        int [] pos = new int[]{1, 1};
        long [] time = new long[]{0, 0};
        for (int i = 0; i < n; i++) {
            int k = bot[i];
            time[k] += Math.abs(button[i] - pos[k]) + 1;
            if (time[k] <= time[1-k])
                time[k] = time[1 - k] + 1; // wait a turn
            pos[k] = button[i];
        }
        return Math.max(time[0], time[1]);
    }
}
