package com.forthgo.google.g2011r2;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

/**
 * Created by Xan Gregg.
 * Date: 6/4/11
 */
public class ProblemC {

    public static void main(String[] args) {
        try {
            Scanner in = new Scanner(new File("C.in"));
            PrintWriter out = new PrintWriter(System.out);
            int n = in.nextInt();
            for (int i = 0; i < n; i++) {
                long nn = in.nextLong();
                long s = solve(nn);
                out.printf("Case #%d: %d%n", i + 1, s);
                out.flush();
            }

        } catch (IOException e) {
            throw new RuntimeException();
        }

    }

    static boolean[] isPrime = new boolean[1001];

    static {
        Arrays.fill(isPrime, true);
        isPrime[0] = false;
        isPrime[1] = false;
        for (int i = 2; i < isPrime.length; i++) {  // sqrt
            if (isPrime[i]) {
                for (int j = i * 2; j < isPrime.length; j += i)
                    isPrime[j] = false;
            }
        }
    }

    private static long solve(long n) {
        if (n == 1)
            return 0;
       return costForward(n) - costReverse(n);
    }

    private static long costReverse(long n) {
        long cost = 0;
        for (int i = 2; i <= n; i++) {
            if (isPrime[i])
                cost++;
        }
        return cost;
    }

    private static long costForward(long n) {
        long cost = 1;
        long[] max = new long[(int) n + 1];
        for (long a = 2; a <= n; a++) {
            boolean needWaiter = false;
            long aa = a;
            for (int i = 2; i <= aa; i++) {
                if (!isPrime[i])
                    continue;
                int p = 0;
                while (aa % i == 0) {
                    aa /= i;
                    p++;
                }
                if (p > max[i]) {
                    max[i] = p;
                    needWaiter = true;
                }
            }
            if (needWaiter)
                cost++;
        }
        return cost;
    }

}

