package com.forthgo.google.g2011r2;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * Created by Xan Gregg.
 * Date: 6/4/11
 */
public class ProblemB {
    public static void main(String[] args) {
        try {
            Scanner in = new Scanner(new File("B.in"));
            PrintWriter out = new PrintWriter(System.out);
            int n = in.nextInt();
            for (int i = 0; i < n; i++) {
                int r = in.nextInt();
                int c = in.nextInt();
                int d = in.nextInt();
                String s = solve(in, r, c, d);
                out.printf("Case #%d: %s%n", i + 1, s);
                out.flush();
            }

        } catch (IOException e) {
            throw new RuntimeException();
        }

    }

    private static String solve(Scanner in, int r, int c, int d) {
        int [][] grid = new int[r][c];
        for (int i = 0; i < r; i++) {
            String s = in.next();
            //String s = in.nextLine();
            if (s.length() != c)
                throw new RuntimeException();
            for (int j = 0; j < c; j++) {
                grid[i][j] = d + (int) (s.charAt(j) - '0');
            }
        }
        for (int k = Math.min(r, c); k >= 3; k--) {
            if (possible(grid, k)) {
                return Integer.toString(k);
            }
        }
        return "IMPOSSIBLE";
    }

    private static boolean possible(int[][] grid, int k) {
        int kk = k / 2;
        for (int x = kk; x <= grid.length - kk - k % 2; x++) {
            for (int y = kk; y <= grid[0].length - kk - k % 2; y++) {
                if (k % 2 == 0 && possibleEven(grid, kk, x, y))
                    return true;
                if (k % 2 == 1 && possibleOdd(grid, kk, x, y))
                    return true;
            }
        }
        return false;
    }

    private static boolean possibleEven(int[][] grid, int s, int x, int y) {
        long mx = 0;
        long my = 0;
        for (int dx = -s; dx < s; dx++) {
            for (int dy = -s; dy < s; dy++) {
//                if (Math.abs(dx) == s && Math.abs(dy) == s)
//                    continue;   // corner
                if (dx == -s && (dy == -s || dy == s - 1))
                    continue;   // corner
                if (dx == s - 1 && (dy == -s || dy == s - 1))
                    continue;   // corner
                int w = grid[x + dx][y + dy];
                mx += (dx * 2 + 1) * w;
                my += (dy * 2 + 1) * w;
            }
        }
        return mx == 0 && my == 0;
    }

    private static boolean possibleOdd(int[][] grid, int s, int x, int y) {
        long mx = 0;
        long my = 0;
        for (int dx = -s; dx <= s; dx++) {
            for (int dy = -s; dy <= s; dy++) {
                if (Math.abs(dx) == s && Math.abs(dy) == s)
                    continue;   // corner
                int w = grid[x + dx][y + dy];
                mx += dx * w;
                my += dy * w;
            }
        }
        return mx == 0 && my == 0;
    }

}

