package com.forthgo.google.g2012r2;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.BitSet;
import java.util.Scanner;

/**
 * Created by Xan Gregg.
 * Date: 5/26/12
 */
public class ProblemA {
    public static void main(String[] args) {
        try {
            Scanner in = new Scanner(new File("A.in"));
            PrintWriter out = new PrintWriter(new FileWriter("A.out"));
//            PrintWriter out = new PrintWriter(System.out);
            int n = in.nextInt();
            in.nextLine();
            for (int i = 0; i < n; i++) {
                int nn = in.nextInt();
                out.printf("Case #%d:", i + 1);
                boolean diamond = solve(in, nn);
                out.printf(" %s%n", diamond ? "YES" : "NO");
                out.flush();
            }
        } catch (IOException e) {
            throw new RuntimeException();
        }

    }

    private static boolean solve(Scanner in, int nv) {
        long[] pos = new long[nv];
        long[] len = new long[nv];
        for (int i = 0; i < nv; i++) {
            pos[i] = in.nextInt();
            len[i] = in.nextInt();
        }
        if (pos[0] > len[0])
            throw new RuntimeException();
        long distance = in.nextInt();
        long[] needed = new long[nv];
        for (int iv = nv - 1; iv >= 0; iv--) {
            if (pos[iv] + len[iv] >= distance)
                needed[iv] = distance - pos[iv];
            else
                needed[iv] = Integer.MAX_VALUE;
            for (int jv = iv + 1; jv < nv && pos[jv] - pos[iv] <= len[iv]; jv++) {
                long d = pos[jv] - pos[iv];
                if (d < needed[iv] && d >= needed[jv])
                    needed[iv] = d;
            }
        }
        return needed[0] <= pos[0];
    }

    private static boolean solve2(Scanner in, int nv) {
        int[] pos = new int[nv];
        int[] len = new int[nv];
        for (int i = 0; i < nv; i++) {
            pos[i] = in.nextInt();
            len[i] = in.nextInt();
        }
        int distance = in.nextInt();
        int iv = 0;
        int elen = pos[iv]; // effective length
        while (true) {
            if (pos[iv] + elen >= distance)
                return true;
            int next = iv + 1;
            int besti = iv;
            int bestx = 0;
            while (next < nv && pos[next] - pos[iv] <= elen) {
                int x = pos[next] + Math.min(pos[next] - pos[iv], len[next]);
                if (x > bestx) {
                    besti = next;
                    bestx = x;
                }
                next++;
            }
            if (bestx == 0)
                return false;
            elen = Math.min(pos[besti] - pos[iv], len[besti]);
            iv = besti;
        }
    }


}

