import java.util.Scanner;

/**
 * Created by david on 11/04/15.
 */
public class DijkstraOptimized {
    private static final int I = 1;
    private static final int J = 2;
    private static final int K = 3;

    /*
     *  q ^ 4 = 1
      *
      *  r * 1 = r
      *
      *  r * q * q * q * q = r
     */
    private static int[][] quaternions;
    private static boolean[][] symbolsOfQuaternions;

    static {
        quaternions = new int[4][4];
        quaternions[0][0] = 0;
        quaternions[0][1] = 1;
        quaternions[0][2] = 2;
        quaternions[0][3] = 3;
        quaternions[1][0] = 1;
        quaternions[1][1] = 0;
        quaternions[1][2] = 3;
        quaternions[1][3] = 2;
        quaternions[2][0] = 2;
        quaternions[2][1] = 3;
        quaternions[2][2] = 0;
        quaternions[2][3] = 1;
        quaternions[3][0] = 3;
        quaternions[3][1] = 2;
        quaternions[3][2] = 1;
        quaternions[3][3] = 0;

        symbolsOfQuaternions = new boolean[4][4];
        symbolsOfQuaternions[0][0] = true;
        symbolsOfQuaternions[0][1] = true;
        symbolsOfQuaternions[0][2] = true;
        symbolsOfQuaternions[0][3] = true;
        symbolsOfQuaternions[1][0] = true;
        symbolsOfQuaternions[1][1] = false;
        symbolsOfQuaternions[1][2] = true;
        symbolsOfQuaternions[1][3] = false;
        symbolsOfQuaternions[2][0] = true;
        symbolsOfQuaternions[2][1] = false;
        symbolsOfQuaternions[2][2] = false;
        symbolsOfQuaternions[2][3] = true;
        symbolsOfQuaternions[3][0] = true;
        symbolsOfQuaternions[3][1] = true;
        symbolsOfQuaternions[3][2] = false;
        symbolsOfQuaternions[3][3] = false;
    }

    private static String stringOfQuaternions;
    private static int lengthOfRepetition;

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int numTestCases = scanner.nextInt();
        StringBuilder stringBuilder = new StringBuilder();

        for (int testCasesIterator = 0; testCasesIterator < numTestCases; testCasesIterator++) {
            scanner.nextInt();
            int repetitions = scanner.nextInt();
            stringBuilder.delete(0, stringBuilder.length());
            stringOfQuaternions = scanner.next();
            lengthOfRepetition = stringOfQuaternions.length();

            for (int repetitionsIterator = 0; repetitionsIterator < repetitions; repetitionsIterator++) {
                stringBuilder.append(stringOfQuaternions);
            }

            stringOfQuaternions = stringBuilder.toString();

            solve(testCasesIterator + 1);
        }
    }

    private static void solve(final int numTestCase) {
        if (findCharacter(0))
            System.out.println("Case #" + numTestCase + ": YES");
        else
            System.out.println("Case #" + numTestCase + ": NO");
    }

    private static boolean findCharacter(final int initialPosition) {
        int characterToFind = I;

        boolean symbol = true;
        int character = 0;

        int lengthOfStringOfQuaternions = stringOfQuaternions.length();

        for (int iterator = initialPosition; iterator < lengthOfStringOfQuaternions; iterator++) {
            symbol = (symbol == symbolsOfQuaternions[character][charToPosition(stringOfQuaternions.charAt(iterator))]);
            character = quaternions[character][charToPosition(stringOfQuaternions.charAt(iterator))];

            if (symbol && character == characterToFind) {
                if (characterToFind != K) {
                    characterToFind += 1;
                    character = 0;
                } else {
                    int charactersToAvoid = lengthOfRepetition * 4;
                    int deletableBlocks = (stringOfQuaternions.length() - 1 - iterator) / charactersToAvoid;
                    if (deletableBlocks > 0) {
                        iterator += deletableBlocks * charactersToAvoid;
                    }
                }
            }
        }

        return characterToFind == K && character == K && symbol;
    }

    private static int charToPosition(char character) {
        switch (character) {
            case '1':
                return 0;
            case 'i':
                return 1;
            case 'j':
                return 2;
            case 'k':
                return 3;
            default:
                return 0;
        }
    }
}
