package codejam;

import java.util.Scanner;

public class AlphabetCake {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int numTestCases, numRows, numColumns;
        char[][] cake;

        numTestCases = scanner.nextInt();

        for (int numCase = 1; numCase <= numTestCases; numCase++) {
            numRows = scanner.nextInt();
            numColumns = scanner.nextInt();
            cake = new char[numRows][numColumns];
            for (int row = 0; row < numRows; row++) {
                cake[row] = scanner.next().toCharArray();
                for (int column = 0; column < numColumns; column++) {
                    if (cake[row][column] != '?') {
                        if (column > 0 && cake[row][column - 1] == '?') {
                            fillLeft(row, column, cake);
                        }
                        if (column < numColumns - 1 && cake[row][column + 1] == '?') {
                            column = fillRight(row, column, cake, numColumns);
                        }
                    }
                }
            }

            for (int row = 0; row < numRows; row++) {
                if (cake[row][0] != '?') {

                    if (row > 0 && cake[row - 1][0] == '?') {
                        fillUp(row, cake, numColumns);
                    }

                    if (row < numRows - 1 && cake[row + 1][0] == '?') {
                        row = fillDown(row, cake, numRows, numColumns);
                    }
                }
            }

            System.out.println("Case #" + numCase + ":");
            print(cake, numRows, numColumns);
        }
    }

    private static int fillRight(int row, int column, char[][] cake, int numColumns) {
        int lastFilled = column;

        for (int columnIterator = column + 1; columnIterator < numColumns; columnIterator++) {
            if (cake[row][columnIterator] == '?') {
                cake[row][columnIterator] = cake[row][column];
                lastFilled = columnIterator;
            } else {
                columnIterator = numColumns;
            }
        }

        return lastFilled;
    }

    private static void fillLeft(int row, int column, char[][] cake) {
        for (int columnIterator = 0; columnIterator < column; columnIterator++) {
            cake[row][columnIterator] = cake[row][column];
        }
    }

    private static int fillDown(int row, char[][] cake, int numRows, int numColumns) {
        int lastFilled = row;

        for (int rowIterator = row + 1; rowIterator < numRows; rowIterator++) {
            if (cake[rowIterator][0] == '?') {
                lastFilled = rowIterator;
                for (int columnIterator = 0; columnIterator < numColumns; columnIterator++) {
                    cake[rowIterator][columnIterator] = cake[row][columnIterator];
                }
            } else {
                rowIterator = numRows;
            }
        }
        return lastFilled;
    }

    private static void fillUp(int row, char[][] cake, int numColumns) {
        for (int rowIterator = row - 1; rowIterator >= 0; rowIterator--) {
            for (int columnIterator = 0; columnIterator < numColumns; columnIterator++) {
                cake[rowIterator][columnIterator] = cake[row][columnIterator];
            }
        }
    }

    private static void print(char[][] cake, int numRows, int numColumns) {
        for (int row = 0; row < numRows; row++) {
            for (int column = 0; column < numColumns; column++) {
                System.out.print(cake[row][column]);
            }
            System.out.println();
        }
    }
}
