import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * Created by david on 12/04/14.
 */
public class MagicTrickSolver
{
	public static void main(String[] args)
	{
		InputStreamReader isr = new InputStreamReader(System.in);
		BufferedReader br = new BufferedReader(isr);

		try
		{
			int numCases = Integer.parseInt(br.readLine());

			for(int casesIterator = 0; casesIterator < numCases; casesIterator++)
			{
				solveCase(casesIterator + 1, br);
			}
		}
		catch (IOException e)
		{
		}
	}


	private static void solveCase(int numCase, BufferedReader br)
	{
		int card = 0;
		int actualCard = 0;
		try
		{
			int selectedRow;
			int[] selectedRowIntArray = new int[4];
			String[] selectedRowStringArray = new String[4];
			String selectedRowString;

			selectedRow = Integer.parseInt(br.readLine()) - 1;

			//	read previous lines
			readPreviousLines(selectedRow, br);

			selectedRowString = br.readLine();
			selectedRowStringArray = selectedRowString.split(" ");

			for(int valuesIterator = 0; valuesIterator < 4; valuesIterator++)
			{
				selectedRowIntArray[valuesIterator] = Integer.parseInt(selectedRowStringArray[valuesIterator]);
			}

			//	read next lines
			readPosteriorLines(selectedRow, br);

			//	select second row
			selectedRow = Integer.parseInt(br.readLine()) - 1;

			//	read previous lines
			readPreviousLines(selectedRow, br);

			selectedRowString = br.readLine();
			selectedRowStringArray = selectedRowString.split(" ");

			for(int valuesIterator = 0; valuesIterator < 4; valuesIterator++)
			{
				actualCard = Integer.parseInt(selectedRowStringArray[valuesIterator]);
				if(contains(selectedRowIntArray, actualCard))
				{
					if(card == 0)
					{
						card = actualCard;
					}
					else if(card > 0)
					{
						card = -1;
					}
				}
			}

			//	read next lines
			for(int rowIterator = selectedRow + 1; rowIterator < 4; rowIterator++)
			{
				br.readLine();
			}

			if(card == 0)
			{
				System.out.println("Case #" + numCase + ": Volunteer cheated!");
			}
			else if(card == -1)
			{
				System.out.println("Case #" + numCase + ": Bad magician!");
			}
			else
			{
				System.out.println("Case #" + numCase + ": " + card);
			}
		}
		catch (IOException e)
		{
		}
	}


	private static final void readPreviousLines(int selectedRow, BufferedReader br) throws IOException
	{
		for(int rowIterator = 0; rowIterator < selectedRow; rowIterator++)
		{
			br.readLine();
		}
	}


	private static final void readPosteriorLines(int selectedRow, BufferedReader br) throws IOException
	{
		for(int rowIterator = selectedRow + 1; rowIterator < 4; rowIterator++)
		{
			br.readLine();
		}
	}


	private static final boolean contains(int[] row, int value)
	{
		boolean output = false;

		for(int rowIterator = 0; rowIterator < 4 && !output; rowIterator++)
		{
			if(row[rowIterator] == value)
			{
				output = true;
			}
		}

		return output;
	}
}
