package com.dagova.manageYourEnergy;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.HashMap;

public class ManageYourEnergy
{
	public static int e;
	public static int r;
	public static int n;
	public static int[] v;
	public static HashMap<Integer, MapValue> partialSolutions;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception
	{
		BufferedReader br;
		PrintWriter writer;
		int numCases;
		String result;
		String[] lineSplit;
		
		
		br = new BufferedReader(new InputStreamReader(System.in));
		writer = new PrintWriter("/home/david/Desktop/manageYourEnergy.out");
		numCases = Integer.parseInt(br.readLine());
		
		for(int casesIterator = 1; casesIterator <= numCases; casesIterator++)
		{
			lineSplit = br.readLine().split(" ");
			e = Integer.parseInt(lineSplit[0]);
			r = Integer.parseInt(lineSplit[1]);
			n = Integer.parseInt(lineSplit[2]);
			v = new int[n];
			partialSolutions = new HashMap<Integer, MapValue>();
			
			lineSplit = br.readLine().split(" ");
			for(int vIterator = 0; vIterator < n; vIterator++)
			{
				v[vIterator] = Integer.parseInt(lineSplit[vIterator]);
			}
			
			result = "Case #" + casesIterator + ": " + recursion(0, 0, e);
			System.out.println(result);
			writer.println(result);
		}
		
		
		writer.close();
	}

	
	public static int recursion(int numActivity, int gain, int energy)
	{
		int output = 0;
		int possibleSolution;
		MapValue mapValue;
		int newGain;
		int newEnergy;
		
		//	estoy en la ultima, gasto toda la energía que me queda
		if(numActivity == n - 1)
		{
			output = gain + v[numActivity] * energy;
		}
		//	me quedan más, pruebo las opciones
		else
		{
			mapValue = partialSolutions.get(numActivity + 1);
			
			for(int energyIterator = r; energyIterator <= energy; energyIterator++)
			{
				newGain = gain + v[numActivity] * energyIterator;
				newEnergy = Math.min(e, energy - energyIterator + r);
				if(explore(newGain, newEnergy, mapValue))
				{
					possibleSolution = recursion(numActivity + 1, newGain, newEnergy);
				}
				else
				{
					possibleSolution = mapValue.gain;
				}
				
				if(possibleSolution > output)
				{
					output = possibleSolution;
				}
			}
		}
		
		return output;
	}
	
	
	public static boolean explore(int newGain, int newEnergy, MapValue mapValue)
	{	
		return mapValue == null || newGain > mapValue.gain || newEnergy > mapValue.energy;
	}
	
	
	public static class MapValue
	{
		public int gain;
		public int energy;
	}
}
