package com.dagova.ticTacToe;

import java.io.BufferedReader;
import java.io.IOException;

public class TicTacToeSolver
{
	private char[][] board;
	
	
	public TicTacToeSolver(BufferedReader br) throws IOException
	{
		board = new char[4][4];
		String row;
		
		for(int iterator = 3; iterator >= 0; iterator--)
		{
			row = br.readLine();
			board[iterator][0] = row.charAt(0);
			board[iterator][1] = row.charAt(1);
			board[iterator][2] = row.charAt(2);
			board[iterator][3] = row.charAt(3);
		}
	}
	
	
	public String solve()
	{
		String output = "";
		
		if(won('X'))
		{
			output = "X won";
		}
		else if(won('O'))
		{
			output = "O won";
		}
		else if(fullBoard())
		{
			output = "Draw";
		}
		else
		{
			output = "Game has not completed";
		}
		
		return output;
	}
	
	
	public boolean fullBoard()
	{
		boolean output = true;
		
		for(int rowIterator = 0; rowIterator < 4; rowIterator++)
		{
			for(int columIterator = 0; columIterator < 4; columIterator++)
			{
				if(board[rowIterator][columIterator] == '.')
				{
					output = false;
					columIterator = 4;
					rowIterator = 4;
				}
			}
		}
		
		return output;
	}
	
	
	public boolean won(char player)
	{
		boolean output = false;
		
		output = wonHorizontally(player);
		
		if(!output)
		{
			output = wonVertically(player);
		}
		
		if(!output)
		{
			output = wonDiagonallyToUp(player);
		}
		
		if(!output)
		{
			output = wonDiagonallyToDown(player);
		}
		
		return output;
	}
	
	
	public boolean wonHorizontally(char player)
	{
		boolean output = false;
		
		for(int rowIterator = 0; rowIterator < 4; rowIterator++)
		{	
			for(int columnIterator = 0; columnIterator < 4; columnIterator++)
			{
				if(!(board[rowIterator][columnIterator] == player) && !(board[rowIterator][columnIterator] == 'T'))
				{
					columnIterator = 4;
				}
				else
				{
					if(columnIterator == 3)
					{
						output = true;
						rowIterator = 4;
					}
				}
			}
		}
		
		return output;
	}
	
	
	public boolean wonVertically(char player)
	{
		boolean output = false;
		
		for(int columnIterator = 0; columnIterator < 4; columnIterator++)
		{	
			for(int rowIterator = 0; rowIterator < 4; rowIterator++)
			{
				if(!(board[rowIterator][columnIterator] == player) && !(board[rowIterator][columnIterator] == 'T'))
				{
					rowIterator = 4;
				}
				else
				{
					if(rowIterator == 3)
					{
						output = true;
						columnIterator = 4;
					}
				}
			}
		}
		
		return output;
	}
	
	
	public boolean wonDiagonallyToUp(char player)
	{
		boolean output = false;
		
		for(int iterator = 0; iterator < 4; iterator++)
		{
			if(!(board[iterator][iterator] == player) && !(board[iterator][iterator] == 'T'))
			{
				iterator = 4;
			}
			else
			{
				if(iterator == 3)
				{
					output = true;
				}
			}
		}
		
		return output;
	}
	
	
	public boolean wonDiagonallyToDown(char player)
	{
		boolean output = false;
		
		for(int iterator = 0; iterator < 4; iterator++)
		{
			if(!(board[3-iterator][iterator] == player) && !(board[3-iterator][iterator] == 'T'))
			{
				iterator = 4;
			}
			else
			{
				if(iterator == 3)
				{
					output = true;
				}
			}
		}
		
		return output;
	}
}
