package es.dagova;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;

public class CoinJam {

    public static void main(String[] args) throws IOException {
        int numCases;
        String line;
        String[] splitLine;

        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        numCases = Integer.parseInt(br.readLine());
        for(int numCase = 1; numCase <= numCases; numCase++) {
            line = br.readLine();
            splitLine = line.split(" ");
            System.out.println("Case #" + numCase + ":");
            solve(Integer.parseInt(splitLine[0]), Integer.parseInt(splitLine[1]));
        }
    }

    private static void solve(int length, int numJanCoins) {
        int foundJanCoins = 0;
        char[] candidate = new char[length];
        BigInteger interpretation;
        boolean validInterpretations;
        BigInteger[] interpretations = new BigInteger[9];

        candidate[0] = '1';
        candidate[length - 1] = '1';
        for(int iterator = 1; iterator < length - 1; iterator++) {
            candidate[iterator] = '0';
        }

        while(foundJanCoins < numJanCoins) {
            validInterpretations = true;
            for(int baseIterator = 2; baseIterator <= 10 && validInterpretations; baseIterator++) {
                interpretation = getInterpretation(candidate, baseIterator);
                if(interpretation.isProbablePrime(100)) {
                    validInterpretations = false;
                } else {
                    interpretations[baseIterator - 2] = interpretation;
                }
            }

            if(validInterpretations) {
                foundJanCoins++;
                System.out.print(new String(candidate));
                for(int baseIterator = 0; baseIterator < 9 && validInterpretations; baseIterator++) {
                    System.out.print(" " + getNonTrivialDivisor(interpretations[baseIterator], baseIterator + 3).toString());
                }
                System.out.println();
            }
            increaseOne(candidate);
        }

    }

    public static void increaseOne(char[] binaryNumber) {
        int pos = binaryNumber.length - 2;
        boolean continuee = true;

        while(continuee) {
            if(binaryNumber[pos] == '0') {
                binaryNumber[pos] = '1';
                continuee = false;
            } else {
                binaryNumber[pos] = '0';
                pos--;
            }
        }
    }

    public static BigInteger getInterpretation(char[] binaryNumber, int base) {
        BigInteger result = BigInteger.ZERO;
        BigInteger biBase = new BigInteger(Integer.toString(base));

        for(int iterator = binaryNumber.length - 1; iterator >= 0; iterator--) {
            if(binaryNumber[iterator] != '0') {
                result = result.add(biBase.pow(binaryNumber.length - 1 - iterator));
            }
        }

        return result;
    }

    // recommendation: base + 1
    public static BigInteger getNonTrivialDivisor(BigInteger interpretation, int recommendation) {
        BigInteger candidate = new BigInteger(Integer.toString(recommendation));

        if(!interpretation.mod(candidate).equals(BigInteger.ZERO)) {
            boolean continuee = true;
            candidate = new BigInteger(Integer.toString(2));
            while (continuee) {
                if(interpretation.mod(candidate).equals(BigInteger.ZERO)) {
                    continuee = false;
                } else {
                    candidate = candidate.add(BigInteger.ONE);
                }
            }
        }

        return candidate;
    }
}
