import java.io.*;
import java.math.BigDecimal;
import java.text.DecimalFormat;

/**
 * Created by david on 12/04/14.
 */
public class CookieClickerAlphaSolver
{
	private static DecimalFormat decimalFormat = new DecimalFormat("0.0000000");

	public static void main(String[] args)
	{
		InputStreamReader isr = new InputStreamReader(System.in);
		BufferedReader br = new BufferedReader(isr);
		StringBuilder output = new StringBuilder();

		try
		{
			int numCases = Integer.parseInt(br.readLine());

			for(int casesIterator = 0; casesIterator < numCases; casesIterator++)
			{
				output.append(solve(br, casesIterator + 1));
				if(casesIterator < numCases - 1)
					output.append("\n");
			}

			writeResultInFile(output.toString());
		}
		catch (IOException e)
		{
		}
	}


	private static String solve(BufferedReader br, int numCase) throws IOException
	{
		String output;
		BigDecimal actualProduction = new BigDecimal(2);
		BigDecimal actualTime = BigDecimal.ZERO;
		BigDecimal costInCookiesOfAFarm;
		BigDecimal farmProduction;
		BigDecimal goalOfCookies;
		boolean continuee = true;

		String[] splittedString = br.readLine().split(" ");
		costInCookiesOfAFarm = new BigDecimal(splittedString[0]);
//		Double.parseDouble(splittedString[0]);
		farmProduction = new BigDecimal(splittedString[1]);
//		farmProduction = Double.parseDouble(splittedString[1]);
		goalOfCookies = new BigDecimal(splittedString[2]);
//		goalOfCookies = Double.parseDouble(splittedString[2]);


		if(goalOfCookies.compareTo(costInCookiesOfAFarm) <= 0)
		{
			actualTime = actualTime.add(goalOfCookies.divide(actualProduction, 10, BigDecimal.ROUND_UP));
		}
		else
		{
			BigDecimal timeToBuyAFarm;
			BigDecimal timeNotBuyingFarm;
			BigDecimal timeBuyingFarm;
			do
			{
				timeToBuyAFarm = costInCookiesOfAFarm.divide(actualProduction, 10, BigDecimal.ROUND_UP);

				timeNotBuyingFarm = actualTime.add(goalOfCookies.divide(actualProduction, 10, BigDecimal.ROUND_UP));
				BigDecimal possibleProduction = actualProduction.add(farmProduction);
				BigDecimal timeWithPossibleProduction = goalOfCookies.divide(possibleProduction, 10, BigDecimal.ROUND_UP);
				timeBuyingFarm = actualTime.add(timeToBuyAFarm.add(timeWithPossibleProduction));
//				timeBuyingFarm = actualTime + timeToBuyAFarm + goalOfCookies/(actualProduction + farmProduction);

				if(timeNotBuyingFarm.compareTo(timeBuyingFarm) <= 0)
				{
					actualTime = timeNotBuyingFarm;
					continuee = false;
				}
				else
				{
					actualTime = actualTime.add(timeToBuyAFarm);
					actualProduction = actualProduction.add(farmProduction);
				}
			}
			while (continuee);
		}

		 output = "Case #" + numCase + ": " + decimalFormat.format(actualTime);
		System.out.println(output);

		return output;
	}


	public static void writeResultInFile(String text) throws IOException
	{

		File file = new File("/users/david/Desktop/cookieClickerAlphaSolver.out");

		// if file doesnt exists, then create it
		if (!file.exists()) {
			file.createNewFile();
		}

		FileWriter fw = new FileWriter(file.getAbsoluteFile());
		BufferedWriter bw = new BufferedWriter(fw);
		bw.write(text);
		bw.close();
	}
}
