package com.dagova.lawnmower;

import java.io.BufferedReader;

public class LawnmowerSolver
{
	private int[][] lawn;
	private int lawnWidth;
	private int lawnLarge;
	private int[] maxGrassHeightInRow;
	private int[] maxGrassHeightInColumn;
	
	
	public LawnmowerSolver(BufferedReader br) throws Exception
	{
		String[] lineSplit = br.readLine().split(" ");
		lawnLarge = Integer.parseInt(lineSplit[0]);
		lawnWidth = Integer.parseInt(lineSplit[1]);
		lawn = new int[lawnLarge][lawnWidth];
		int grassHeight;
		maxGrassHeightInRow = new int[lawnLarge];
		maxGrassHeightInColumn = new int[lawnWidth];
		
		
		for(int largeIterator = 0; largeIterator < lawnLarge; largeIterator++)
		{
			lineSplit = br.readLine().split(" ");
			for(int widthIterator = 0;widthIterator < lawnWidth; widthIterator++)
			{
				grassHeight = Integer.parseInt(lineSplit[widthIterator]);
				lawn[largeIterator][widthIterator] = grassHeight;
				maxGrassHeightInRow[largeIterator] = Math.max(maxGrassHeightInRow[largeIterator], grassHeight);
				maxGrassHeightInColumn[widthIterator] = Math.max(maxGrassHeightInColumn[widthIterator], grassHeight);
			}
		}
	}
	
	
	public String solve()
	{
		String output = "YES";
		
		for(int largeIterator = 0; largeIterator < lawnLarge; largeIterator++)
		{
			for(int widthIterator = 0;widthIterator < lawnWidth; widthIterator++)
			{
				int segment = lawn[largeIterator][widthIterator]; 
				
				if(segment< maxGrassHeightInRow[largeIterator] && segment < maxGrassHeightInColumn[widthIterator])
				{
					output = "NO";
					widthIterator = lawnWidth;
					largeIterator = lawnLarge;
				}
			}
		}
			
		return output;
	}
}
