package com.dagova.bullsEye;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;

public class BullsEye
{
	public static final BigInteger FOUR = new BigInteger("4");
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception
	{
		BufferedReader br;
		PrintWriter writer;
		int numCases;
		String result;
		String[] lineSplit;
		
		br = new BufferedReader(new InputStreamReader(System.in));
		writer = new PrintWriter("/home/david/Desktop/bullsEye.out");
		numCases = Integer.parseInt(br.readLine());
		
		for(int casesIterator = 1; casesIterator <= numCases; casesIterator++)
		{
			lineSplit = br.readLine().split(" ");
			result = "Case #" + casesIterator + ": " + solve(new BigInteger(lineSplit[0]), new BigInteger(lineSplit[1]));
			System.out.println(result);
			writer.println(result);
		}
		
		
		writer.close();
	}
	
	
	public static String solve(BigInteger r, BigInteger t)
	{
		BigInteger output = BigInteger.ZERO;
		
		BigInteger firstDiskArea = r.multiply(r);
		BigInteger firstRingRadius = r.add(BigInteger.ONE);
		BigInteger firstRingArea = firstRingRadius.multiply(firstRingRadius);
		BigInteger areasDifferences = firstRingArea.subtract(firstDiskArea);
		
		while(areasDifferences.compareTo(t) <= 0)
		{
			t = t.subtract(areasDifferences);
			output = output.add(BigInteger.ONE);
			areasDifferences = areasDifferences.add(FOUR);
		}
			
		return output.toString();
	}
}
