package codejam;

import java.util.*;

public class BathroomStalls {

    public static void main(String[] args) {
        boolean stop;
        int numTestCases;
        long numStalls, numPeople;
        Scanner scanner = new Scanner(System.in);

        numTestCases = scanner.nextInt();

        for (int testCase = 1; testCase <= numTestCases; testCase++) {
            numStalls = scanner.nextLong();
            numPeople = scanner.nextLong();

            Map<Long, Long> stallsGroupsAndTimes = new HashMap<>();
            Queue<Long> nextStallsGroupCapacity = new ArrayDeque<>();

            stallsGroupsAndTimes.put(numStalls, 1L);
            nextStallsGroupCapacity.add(numStalls);

            stop = false;
            while (!stop) {
                long currentStalls = nextStallsGroupCapacity.poll();
                long numGroups = stallsGroupsAndTimes.get(currentStalls);

                long freeStalls = currentStalls - 1;
                long quotient = freeStalls / 2L;
                long remainder = freeStalls % 2L;
                @SuppressWarnings("isRedundant")
                long leftSide = quotient;
                long rightSide = quotient + remainder;

                if (stallsGroupsAndTimes.containsKey(rightSide)) {
                    stallsGroupsAndTimes.put(rightSide, stallsGroupsAndTimes.get(rightSide) + numGroups);
                } else {
                    stallsGroupsAndTimes.put(rightSide, numGroups);
                    nextStallsGroupCapacity.add(rightSide);
                }
                if (stallsGroupsAndTimes.containsKey(leftSide)) {
                    stallsGroupsAndTimes.put(leftSide, stallsGroupsAndTimes.get(leftSide) + numGroups);
                } else {
                    stallsGroupsAndTimes.put(leftSide, numGroups);
                    nextStallsGroupCapacity.add(leftSide);
                }

                numPeople = numPeople - stallsGroupsAndTimes.get(currentStalls);
                if (numPeople <= 0) {
                    stop = true;
                    System.out.println("Case #" + testCase + ": " + rightSide + " " + leftSide);
                }
            }
        }
    }
}
