import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

/**
 * Created by david on 11/04/15.
 */
public class InfiniteHouseOfPancakes {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int numCases = scanner.nextInt();
        int numDinersWithNonEmptyPlates;
        TreeMap<Integer, Integer> pancakesMap = new TreeMap<Integer, Integer>();

        for (int casesIterator = 0; casesIterator < numCases; casesIterator++) {
            numDinersWithNonEmptyPlates = scanner.nextInt();
            pancakesMap.clear();

            for (int dinersIterator = 0; dinersIterator < numDinersWithNonEmptyPlates; dinersIterator++) {
                insertOrUpdate(pancakesMap, scanner.nextInt(), 1);
            }

            solve(casesIterator + 1, pancakesMap);
        }
    }

    private static void insertOrUpdate(TreeMap<Integer, Integer> pancakesMap, int numPancakes, int numDiners) {

        if (pancakesMap.containsKey(numPancakes)) {
            pancakesMap.replace(numPancakes, pancakesMap.get(numPancakes) + numDiners);
        } else {
            pancakesMap.put(numPancakes, numDiners);
        }
    }

    private static void solve(final int numCase, final TreeMap<Integer, Integer> pancakesMap) {
        boolean continuee = true;
        Map.Entry<Integer, Integer> lastPancakeAmmount;
        int numPancakes = 0;
        int numDiners;
        int temporalSolution = 0;
        int bestSolution = pancakesMap.lastKey();

        while (continuee) {
            lastPancakeAmmount = pancakesMap.pollLastEntry();
            numPancakes = lastPancakeAmmount.getKey();
            numDiners = lastPancakeAmmount.getValue();

            bestSolution = Math.min(bestSolution, temporalSolution + numPancakes);

            if (numPancakes % 2 == 0) {
                if ((numPancakes / 2) + numDiners < numPancakes) {
                    insertOrUpdate(pancakesMap, numPancakes / 2, numDiners * 2);
                    temporalSolution += numDiners;
                } else {
                    continuee = false;
                    temporalSolution += numPancakes;
                }
            } else {
                if (((numPancakes / 2) + 1) + numDiners < numPancakes) {
                    insertOrUpdate(pancakesMap, (numPancakes / 2) + 1, numDiners);
                    insertOrUpdate(pancakesMap, (numPancakes / 2), numDiners);
                    temporalSolution += numDiners;
                } else {
                    continuee = false;
                    temporalSolution += numPancakes;
                }
            }
        }

        bestSolution = Math.min(bestSolution, temporalSolution);

        System.out.println("Case #" + numCase + ": " + bestSolution);
    }
}
