package com.dagova.fairAndSquare;

import java.math.BigInteger;

public class FairAndSquareSolver
{
	private BigInteger limitInf;
	private BigInteger limitSup;
	private static final BigInteger TWO = new BigInteger("2");
	
	
	public FairAndSquareSolver(BigInteger limitInf, BigInteger limitSup)
	{
		this.limitInf = limitInf;
		this.limitSup = limitSup;
	}
	
	
	public BigInteger solve()
	{
		BigInteger output = BigInteger.ZERO;
		
		for(BigInteger iterator = new BigInteger(limitInf.toByteArray()); iterator.compareTo(limitSup) <= 0; iterator = iterator.add(BigInteger.ONE))
		{
			if(isPalindrome(iterator) && isSquare(iterator))
			{
				output = output.add(BigInteger.ONE);
			}
		}
		
		return output;
	}
	
	
	public boolean isPalindrome(BigInteger value)
	{
		boolean output = true;
		String valueString = value.toString();
		int valueLengthMinusOne = valueString.length() - 1;
		
		for(int iteratorDown = 0, iteratorUp = valueLengthMinusOne; iteratorDown < iteratorUp && output; iteratorDown++, iteratorUp--)
		{
			if(valueString.charAt(iteratorDown) != valueString.charAt(iteratorUp))
			{
				output = false;
			}
		}
		
		return output;
	}
	
	
	public boolean isSquare(BigInteger value)
	{
		boolean output = false;
		boolean squareFounded = false;
		
		BigInteger limitInfOfValue = BigInteger.ONE;
		BigInteger limitSupOfValue = value;
		BigInteger pivotOfValue = limitInfOfValue.add(limitSupOfValue).divide(TWO);
		BigInteger possibleValue;
		int possibleValueComparison;
		
		do
		{
			possibleValue = pivotOfValue.multiply(pivotOfValue);
			possibleValueComparison = possibleValue.compareTo(value);
			//	pivotOfValue is square root of value
			if(possibleValueComparison == 0)
			{
				squareFounded = true;
				output = isPalindrome(pivotOfValue);
			}
			else
			{
				//	square root of value is bigger than pivotOfValue
				if (possibleValueComparison < 0)
				{
					limitInfOfValue = pivotOfValue.add(BigInteger.ONE);
				}
				//	square root of value is smaller than pivotOfValue
				else
				{
					limitSupOfValue = pivotOfValue.subtract(BigInteger.ONE);
				}
				pivotOfValue = limitInfOfValue.add(limitSupOfValue).divide(TWO);
			}
			
			
		}
		while(!squareFounded && limitInfOfValue.compareTo(limitSupOfValue) < 0);
		
		return output;
	}
}
