import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class SheepCounting {

	public static void main(String[] args) {

		try {
			Scanner sc = new Scanner(new File(args[0]));
			FileWriter writer = new FileWriter(new File("SheepCounting.out"));
			final int numberOfCases = sc.nextInt();
			sc.nextLine();
			int currentCase = 0;
			while (currentCase < numberOfCases){
				final BigInteger n = new BigInteger(sc.nextLine());
				System.out.println("n:" + n);
				final BigInteger sleepNumber = getSleepNumber(n);
				System.out.println("Case #" + (currentCase + 1) + ": " +
						(!sleepNumber.equals(BigInteger.ZERO) ? "" + sleepNumber.multiply(n) : "INSOMNIA"));
				writer.write("Case #" + ++currentCase + ": " +
						(!sleepNumber.equals(BigInteger.ZERO) ? "" + sleepNumber.multiply(n) : "INSOMNIA") + "\n");
			}
			
//			for (int i = 990000; i < 1000001; i++){
//				writer.write("" + i + "\n");
//			}
			sc.close();
			writer.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}


	}

	private static BigInteger getSleepNumber(BigInteger n ) {
		Set<Integer> digits = new HashSet<>();
		BigInteger i = BigInteger.ZERO;
		while(digits.size() < 10 && !n.equals(BigInteger.ZERO)){
			i = i.add(BigInteger.ONE);
			final BigInteger product = n.multiply(i);
			final String productAsString = product.toString();
			for(int index = 0; index < productAsString.length(); index++){
				digits.add(Integer.parseInt(String.valueOf(productAsString.charAt(index))));
			}

		}
		return i;
	}

}
