import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class SheepCounting {

	public static void main(String[] args) {

		try {
			Scanner sc = new Scanner(new File(args[0]));
			FileWriter writer = new FileWriter(new File("SheepCounting.out"));
			final int numberOfCases = sc.nextInt();
			sc.nextLine();
			int currentCase = 0;
			while (currentCase < numberOfCases){
				final int n = sc.nextInt();
				System.out.println("n:" + n);
				if(sc.hasNextLine()){
					sc.nextLine();
				}
				final int sleepNumber = getSleepNumber(n);
				System.out.println("Case #" + (currentCase + 1) + ": " +
						(sleepNumber != 0 ? "" + sleepNumber*n : "INSOMNIA"));
				writer.write("Case #" + ++currentCase + ": " +
						(sleepNumber != 0 ? "" + sleepNumber*n : "INSOMNIA") + "\n");
			}
			
			sc.close();
			writer.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}


	}

	private static int getSleepNumber(int n ) {
		Set<Integer> digits = new HashSet<>();
		int i = 0;
		while(digits.size() < 10 & n != 0){
			i++;
			final Integer product = n * i;
			final String productAsString = product.toString();
			for(int index = 0; index < productAsString.length(); index++){
				digits.add(Integer.parseInt(String.valueOf(productAsString.charAt(index))));
			}

		}
		return i;
	}

}
