package clicker;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;

public class Main {

	public static final String CASE = "Case #";
	public static int numberOfCases = 0;
	public static int numberOfCookiesPerSecond = 2;
	public static double totalTime = 0;
	public static int totalNumberOfCookies;
	

	public static void main(String[] args){

		if(args.length != 1) {
			System.err.println("Invalid command line, exactly one argument required");
			System.exit(1);
		}
		try {
			FileInputStream fstream = new FileInputStream(args[0]);
			BufferedReader br = new BufferedReader(new InputStreamReader(fstream));
			FileWriter fw = new FileWriter("output.txt");
			BufferedWriter bw = new BufferedWriter(fw);
			String strLine;
			//Read File Line By Line
			numberOfCases = Integer.parseInt(br.readLine());

			for(int i = 0; i < numberOfCases; i++){
				bw.write(CASE + (i +1) + ": "); 
				bw.write(handleCase(br.readLine()) + "\n");
			}

			//Close the input stream
			fstream.close();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public static double handleCase(String input){
		
		String[] parameters = input.split(" ");
		final double c = Double.parseDouble(parameters[0]);
		final double f = Double.parseDouble(parameters[1]);
		final double x = Double.parseDouble(parameters[2]);	
		return checkCookies(numberOfCookiesPerSecond, c, f, x);


	}
	
	public static double checkCookies(double currentNumberOfCookiesPerSecond, 
			double c, double f, double x){
		final double totalTimeAtCurrentRate;
		final double totalTimeAtIncreasedRate;
		final double timeToNextFarm;
		totalTimeAtCurrentRate = x / currentNumberOfCookiesPerSecond;
		timeToNextFarm = c / currentNumberOfCookiesPerSecond;
		totalTimeAtIncreasedRate = timeToNextFarm + x / (currentNumberOfCookiesPerSecond + f);
		if (totalTimeAtCurrentRate < totalTimeAtIncreasedRate){
			return totalTimeAtCurrentRate;
		}
		return timeToNextFarm + checkCookies(currentNumberOfCookiesPerSecond + f, c, f, x);
	}
}
