import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;


public class Main {
	
	public static final String BAD = "Bad magician!";
	public static final String CHEAT = "Volunteer cheated!";
	public static final String CASE = "Case #";
	public static int numberOfCases = 0;
	
	public static FileWriter fw; 
	public static BufferedWriter bw; 
	public static void main(String[] args){
		
		if(args.length != 1) {
			  System.err.println("Invalid command line, exactly one argument required");
			  System.exit(1);
			}
			try {
				FileInputStream fstream = new FileInputStream(args[0]);
				 BufferedReader br = new BufferedReader(new InputStreamReader(fstream));
				 fw = new FileWriter("output.txt");
				 bw = new BufferedWriter(fw);
		            String strLine;
		            //Read File Line By Line
		            numberOfCases = Integer.parseInt(br.readLine());
		            
		            for(int i = 0; i < numberOfCases; i++){
		            	handleCase(br, i);
		            }
		            
		            //Close the input stream
		            fstream.close();
		            bw.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
	}

	public static void handleCase(BufferedReader br, int testCase){
		try {
			int firstRow = Integer.parseInt(br.readLine());
			List<Integer> firstCards = getRow(br, firstRow);
//			for(Integer i: firstCards){
//				System.out.println(i);
//			}
			int secondRow = Integer.parseInt(br.readLine());
			List<Integer> secondCards = getRow(br, secondRow);
//			for(Integer i: secondCards){
//				System.out.println(i);
//			}
			firstCards.retainAll(secondCards);
			
			bw.write(CASE + (testCase + 1) + ": ");
			if(firstCards.isEmpty()){
				bw.write(CHEAT + "\n");
			} else if( firstCards.size() == 1){
				bw.write(firstCards.get(0) + "\n");
			} else {				
				bw.write(BAD + "\n");
			}
			
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	
	}
	
	public static List<Integer> getRow(BufferedReader br, int row){
		List<Integer> chosenRow = new ArrayList<Integer>();
		try {
			String line;
			for(int i = 1; i <= 4; i++){
				line = br.readLine();
				if(i == row){
					final String[] cards = line.split(" ");
					for(int j = 0;j<cards.length;j++){
						chosenRow.add(Integer.parseInt(cards[j]));
					}
				}
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return chosenRow;
	}
}
