import java.io.File;
import java.io.IOException;
import java.util.HashSet;
import java.util.Scanner;


public class FairAndSquare {

	private static HashSet<Integer>[] validEndings;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		String file = args[0];
		setValidEndings(1000);
		int numCases = numCases(file);
		int[][] cases = new int[numCases][2];
		cases = getCases(file, numCases);
		
		String output = "";
		for (int i = 0; i < cases.length; i++) {
			System.out.println(cases[i][0] + " " + cases[i][1]);
			output += "Case #" + (i+1) + ": " + getFairAndSquare(cases[i]);
			output += "\n";
		}
		System.out.println(output);
	}
	
	
	
	private static int getFairAndSquare(int[] bounds) {
		int count = 0;
		int digits; boolean valid;
		for (int i = bounds[0]; i < bounds[1]+1; i++) {
			if (checkPalindrome(i) && checkSquare(i)) {
				count++;
			}
		}
		return count;
	}
	
	private static boolean checkPalindrome(int num) {
		int digits = (int)Math.ceil(Math.log10(num));
		//number of digits - avoid converting each one to string to speed up
		//check only first half of digits (and excl. middle digit)
		for (int j = 1; j < digits/2+1; j++) {
			int first = (int) ((double)(num)/Math.pow(10, digits-j) % 10);
			int last = (int) ((double)(num)/Math.pow(10, j-1) % 10);
			if (first != last || last == 0) {
				return false;
			}
		}
		return true;
	}
	
	private static boolean checkSquare(int num) {
		int sqrt = (int)Math.sqrt(num);
		if (sqrt*sqrt != num) {
			return false;
		} else {
			return checkPalindrome(sqrt);
		}
	}

	private static void setValidEndings(double maxValue) {
		int digits = (int)Math.ceil(Math.log10(maxValue));
		validEndings = (HashSet<Integer>[]) new HashSet[digits/2];
		for (int i=0; i<digits/2; i++) {
			validEndings[i] = new HashSet<Integer>();
			for (int j = (int) Math.pow(10, i); j < Math.pow(10, i+1); j++) {
				if (checkPalindrome(j)) {
					validEndings[i].add((int) (Math.pow(j, 2) % Math.pow(10, i+1)));
				}
			}
		}
	}

	private static int numCases(String filePath) {
		try {
			File f = new File(filePath);
			Scanner input = new Scanner(f);

			try {
					return input.nextInt();
			}
			finally {
				input.close();
			}
		}
		catch (IOException ex) {
			ex.printStackTrace();
		}
		return -1;
	}
	
	// Read in the text file and enter it into a 2d array
	private static int[][] getCases(String filePath, int numCases) {
		int[][] cases = new int[numCases][2];
		
		try {
			File f = new File(filePath);
			Scanner input = new Scanner(f);
			int nextInt;

			try {
				nextInt = input.nextInt(); //skip number of cases on first line
				for (int i = 0; i < numCases; i++) {
					cases[i][0] = input.nextInt();
					cases[i][1] = input.nextInt();
				}
			}
			finally {
				input.close();
			}
		}
		catch (IOException ex) {
			ex.printStackTrace();
		}

		return cases;

	}
}