
public class MainClass {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		String file = "C:\\Users\\Dan\\Downloads\\A-large.in";
		
		int numBoards = Reader.numBoards(file);
		char[][][] boards = Reader.readBoard(file, numBoards);
		
		String output = "";
		for (int i = 0; i < numBoards; i++) {
			output += "Case #" + (i+1) + ": ";
			switch (processBoard(boards[i])) {
			case 'd':
				output += "Draw";
				break;
			case 'n':
				output += "Game has not completed";
				break;
			case 'O':
				output += "O won";
				break;
			case 'X':
				output += "X won";
				break;
			default:
				output += processBoard(boards[i]);
			}
			
			output += "\n";
		}
		System.out.println(output);
	}

	private static char processFour(char[] row) {
		char c = row[0];
		if (c=='T') {
			c = row[1];
		} else if (c=='.') {
			return '.';
		}
		for (int i = 1; i < row.length; i++) {
			if (row[i]==c || row[i]=='T') {
				if (i == row.length-1) {
					return c;
				}
			} else {
				return 'n';
			}
		}
		return 'n';
	}
	
	private static char processBoard(char[][] board) {
		boolean finished = true;
		char c;
		for (int i = 0; i < board.length; i++) {
			if ((c = processFour(board[i])) != 'n') {
				if (c=='.') {
					finished = false;
				} else {
					return c;
				}
			}
			char[] temp = getColumn(board,i);
			if ((c = processFour(temp)) != 'n') {
				if (c=='.') {
					finished = false;
				} else {
					return c;
				}
			}
			temp = getDiagonal(board, i==1);
			if ((c = processFour(temp)) != 'n') {
				if (c=='.') {
					finished = false;
				} else {
					return c;
				}
			}
		}
		
		if (finished) {
			return 'd';
		} else {
			return 'n';
		}
	}
	
	private static char[] getDiagonal(char[][] board, boolean first) {
		char[] diag = new char[board.length]; 
		for (int i = 0; i < board.length; i++) {
			if (first) {
				diag[i] = board[i][i];
			} else {
				diag[i] = board[3-i][i];
			}
		}
		return diag;
	}

	private static char[] getColumn(char[][] board, int column) {
		char[] col = new char[board.length]; 
		for (int i = 0; i < board.length; i++) {
			col[i] = board[i][column];
		}
		return col;
	}

}
