import java.io.File;
import java.io.IOException;
import java.util.HashSet;
import java.util.Scanner;

public class Reader {
	
	// Read in the text file and return it as a hashmap of edges in a graph, hashcoded by the
	// node at the back of the edge
	public static HashSet<Integer> readSet(String filePath) {
		HashSet<Integer> temp = new HashSet<Integer>();
		
		try {
			File f = new File(filePath);
			Scanner input = new Scanner(f);

			try {
				int t1 = 0;

				while( input.hasNextInt() ) {
					
					t1=input.nextInt();
					
					temp.add(t1);

				}
			}
			finally {
				input.close();
			}
		}
		catch (IOException ex) {
			ex.printStackTrace();
		}

		return temp;

	}
	
	public static int numBoards(String filePath) {
		try {
			File f = new File(filePath);
			Scanner input = new Scanner(f);

			try {
					return input.nextInt();
			}
			finally {
				input.close();
			}
		}
		catch (IOException ex) {
			ex.printStackTrace();
		}
		return -1;
	}
	
	// Read in the text file and enter it into a 2d array
	public static char[][][] readBoard(String filePath, int numBoards) {
		char[][][] boards = new char[numBoards][4][4];
		
		try {
			File f = new File(filePath);
			Scanner input = new Scanner(f);
			String line;

			try {
				line = input.nextLine(); //skip int
				for (int i = 0; i < numBoards; i++) {
					//skip blank lines
					if ("".equals( (line=input.nextLine().trim())) ) {
						line=input.nextLine().trim();
					}
					for (int j = 0; j < 4; j++) {
						for (int k = 0; k < 4; k++) {
							boards[i][j][k] = line.charAt(k);
						}
						if (input.hasNextLine()) {
							line = input.nextLine().trim();
						}
					}
				}
			}
			finally {
				input.close();
			}
		}
		catch (IOException ex) {
			ex.printStackTrace();
		}

		return boards;

	}

}