import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;

public class GCJ2017Round1A_B {


    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            System.out.printf("Case #%d: %s\n", i, new GCJ2017Round1A_B().solve(sc));
        }
    }

    static class IngrRange implements Comparable<IngrRange> {
        int ingr;
        int packSize;
        int minServings;
        int maxServings;


        public IngrRange(int ingr, int packSize, int minServings, int maxServings) {
            this.ingr = ingr;
            this.packSize = packSize;
            this.minServings = minServings;
            this.maxServings = maxServings;
        }

        @Override
        public int compareTo(IngrRange o) {
            return packSize - o.packSize;
            // if (o.maxServings - maxServings == 0)
            // return o.maxServings - maxServings;
            // if (minServings - o.minServings != 0) return minServings - o.minServings;
            // return maxServings - o.maxServings;
        }

        @Override
        public String toString() {
            return "IngrRange [ingr=" + ingr + ", packSize=" + packSize + ", minServings="
                    + minServings + ", maxServings=" + maxServings + "]";
        }


    }

    private String solve(Scanner sc) throws Exception {
        int n = sc.nextInt();
        int p = sc.nextInt();
        int[] rs = new int[n];
        int[][] qs = new int[n][p];
        @SuppressWarnings("unchecked")
        ArrayList<IngrRange>[] ranges = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            rs[i] = sc.nextInt();
            ranges[i] = new ArrayList<>();
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < p; j++) {
                qs[i][j] = sc.nextInt();

                IngrRange range = new IngrRange(i, qs[i][j], (qs[i][j] * 100 + (rs[i]
                        * 110 - 1)) / (rs[i] * 110), (qs[i][j] * 100) / (rs[i] * 90));
                // System.out.println(range.toString());
                if (range.minServings <= range.maxServings) ranges[i].add(range);
            }
            Collections.sort(ranges[i]);
            // System.out.println(ranges[i].toString());
        }

        for (int i = 0; i < n; i++) {
            if (ranges[i].isEmpty()) return "0";
        }
        int[] curPos = new int[n];
        int ans = 0;
        mainLoop: while (true) {
            int minServings = 1;
            for (int i = 0; i < n; i++) {
                minServings = Math.max(minServings, ranges[i].get(curPos[i]).minServings);
            }
            for (int i = 0; i < n; i++) {
                while (ranges[i].get(curPos[i]).maxServings < minServings) {
                    // trash this package
                    curPos[i]++;
                    if (curPos[i] >= ranges[i].size()) break mainLoop;
                }
            }
            // use this
            ans++;
            // System.out.print("gen: ");
            // for (int i = 0; i < n; i++) {
            // System.out.print(curPos[i] + " ");
            // }
            // System.out.println();
            for (int i = 0; i < n; i++) {
                curPos[i]++;
                if (curPos[i] >= ranges[i].size()) break mainLoop;
            }
        }
        return Integer.toString(ans);

    }
}
