import java.util.Arrays;
import java.util.Scanner;


public class GCJ2015R2B {

    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            System.out.printf("Case #%d: %s%n", i, new GCJ2015R2B().solve(sc));
        }
    }

    int n;
    double v;
    double x;

    static class Source implements Comparable<Source> {
        final double r, c;

        public Source(double r, double c) {
            this.r = r;
            this.c = c;
        }

        @Override
        public int compareTo(Source o) {

            return (int) Math.signum(c - o.c);
        }

    }

    Source[] ss;
    double[] cs;
    final static double[] EPSS = {1.0E-16, 1.0E-15, 1.0E-14, 1.0E-13, 1.0E-12, 1.0E-11, 1.0E-10, 1.0E-9, 1.0E-8, 1.0E-7, };
    double EPS;

    boolean can(double time) {
        if (time == 0) return false;
        double objective = x * v;
        double remVol = v;
        double curObj = 0;
        double[] vols = new double[n];
        int r = 0;
        for (; r < n; r++) {
            double maxVol = ss[r].r * time;
            double vol = Math.min(maxVol, remVol);
            remVol -= vol;
            curObj += vol * ss[r].c;
            vols[r] = vol;
            if (curObj > objective + EPS) return false;
            if (remVol < EPS) {
                if (vol == maxVol) r++;
                break;
            }
        }
        if (remVol > EPS) return false;
        if (curObj + EPS > objective) return true;
        if (r == 0) r++;
        int l = 0;
        for (; r < n; r++) {
            double maxVolGain = Math.min(vols[l], ss[r].r * time - vols[r]);
            double maxDec = maxVolGain * ss[l].c;
            double maxInc = maxVolGain * ss[r].c;
            if (curObj - maxDec + maxInc < objective + EPS) {
                vols[l] -= maxVolGain;
                curObj += -maxDec + maxInc;
                vols[r] += maxVolGain;
                if (vols[r] + EPS > ss[r].r * time) r++;
                if (vols[l] < EPS) l++;
                if (l == r) r++;
                if (curObj + EPS > objective) return true;
            }
            else return true;
        }
        return false;
    }

    private String solve(Scanner sc) throws Exception {
        n = sc.nextInt();
        v = sc.nextDouble();
        x = sc.nextDouble();
        ss = new Source[n];
        for (int i = 0; i < n; i++) {
            ss[i] = new Source(sc.nextDouble(), sc.nextDouble());
        }
        Arrays.sort(ss);

        for (double eps : EPSS) {
            EPS = eps;
            double l = 0;
            double r = 1000000000;
            for (int i = 0; i < 500; i++) {
                double mid = (l + r) / 2;
                if (can(mid)) r = mid;
                else l = mid;
            }
            if (r < 900000000) return String.format("%.10f", r);
        }
        return "IMPOSSIBLE";
    }
}
