import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;
import java.util.TreeMap;
import java.util.TreeSet;


public class GCJ2014Round2C {

    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            System.out.printf("Case #%d: %d%n", i, new GCJ2014Round2C().solve(sc));
        }
    }

    @SuppressWarnings("unchecked")
    private int solve(Scanner sc) throws Exception {
        int w = sc.nextInt();
        int h = sc.nextInt();
        int b = sc.nextInt();
        int[] x0 = new int[b];
        int[] x1 = new int[b];
        int[] y0 = new int[b];
        int[] y1 = new int[b];
        TreeMap<Integer, Integer> xs = new TreeMap<>();
        TreeMap<Integer, Integer> ys = new TreeMap<>();
        for (int i = 0; i < b; i++) {
            x0[i] = sc.nextInt();
            y0[i] = sc.nextInt();
            x1[i] = sc.nextInt();
            y1[i] = sc.nextInt();
            for (int j = -1; j <= 1; j++) {
                xs.put(x0[i] + j, 1);
                xs.put(x1[i] + j, 1);
                ys.put(y0[i] + j, 1);
                ys.put(y1[i] + j, 1);
            }
        }
//        for (TreeMap<Integer, Integer> cs : new TreeMap[] { xs, ys }) {
//            int id = 0;
//            for (int i : cs.keySet()) {
//                cs.put(i, id++);
//            }
//        }
//        for (int i = 0; i < b; i++) {
//            x0[i] = xs.get(x0[i]);
//            x1[i] = xs.get(x1[i]);
//            y0[i] = ys.get(y0[i]);
//            y1[i] = ys.get(y1[i]);
//        }
//        w = xs.lastEntry().getValue();
//        h = ys.lastEntry().getValue();
        boolean[][] field = new boolean[h][w];
        for (int bi = 0; bi < b; bi++) {
            for (int y = y0[bi]; y <= y1[bi]; y++) {
                for (int x = x0[bi]; x <= x1[bi]; x++) {
                    field[y][x] = true;
                }
            }
        }
        int gn = 1 + w * h * 2 + 1;
        FlowAdjGraph g = new FlowAdjGraph(gn);
        for (int i = 0; i < w; i++) {
            g.add(0, 1 + i * 2 + 1, 1, 1);
            g.add(1 + ((h - 1) * w + i) * 2, gn - 1, 1, 1);
        }
        
        int dy[] = {1, 0 , -1, 0};
        int dx[] = {0 , -1, 0, 1};
        for (int y = 0; y < h; y++) {
            for (int x = 0; x < w; x++) {
                g.add(1 + (y * w + x) * 2 + 1, 1 + (y * w + x) * 2, 1, 1);
                for (int di = 0; di < 4; di++) {
                    int ny = y + dy[di];
                    int nx = x + dx[di];
                    if (nx < 0 || w <= nx || ny < 0 || h <= ny) continue;
                    if (field[y][x] || field[ny][nx]) continue;
                    g.add(1 + (y * w + x) * 2, 1 + (ny * w + nx) * 2 + 1, 1, 1);
                }
            }
        }
        
        return edmondsKarp(g, 0, gn - 1);
    }

    static class Edge {
        final int from, to, cost, capacity;

        public Edge(int from, int to, int cost) {
            this(from, to, cost, 0);
        }

        public Edge(int from, int to, int cost, int capacity) {
            this.from = from;
            this.to = to;
            this.cost = cost;
            this.capacity = capacity;
        }

        Edge getInv() {
            return new Edge(to, from, cost, capacity);
        }
    }

    /**
     * 逆辺をもった隣接リスト表現のネットワークグラフ。
     */
    static class FlowAdjGraph {
        final int numNodes;
        final ArrayList<ResidualEdge>[] edges;

        @SuppressWarnings("unchecked")
        public FlowAdjGraph(int n) {
            numNodes = n;
            edges = new ArrayList[n];
            for (int v = 0; v < n; v++) {
                edges[v] = new ArrayList<ResidualEdge>();
            }
        }

        void add(int from, int to, int cost, int capacity) {
            assert capacity >= 0;
            ResidualEdge e1 = new ResidualEdge(from, to, cost, capacity);
            ResidualEdge e2 = new ResidualEdge(to, from, -cost, 0);
            e1.reversedEdge = e2;
            e2.reversedEdge = e1;
            edges[from].add(e1);
            edges[to].add(e2);
        }

        void addArc(Edge e) {
            add(e.from, e.to, e.cost, e.capacity);
        }

        void addEdge(Edge e) {
            add(e.from, e.to, e.cost, e.capacity);
            add(e.to, e.from, e.cost, e.capacity);
            // 求めるものがコストフローでなければ、2辺をそれぞれの逆辺としてもよい
        }

        /** Resets flow */
        void resetFlow() {
            for (ArrayList<ResidualEdge> edge : edges) {
                for (ResidualEdge e : edge) {
                    e.residual = e.capacity;
                }
            }
        }
    }

    static class ResidualEdge {
        final int from, to, cost, capacity;
        int residual;
        ResidualEdge reversedEdge; // 逆辺

        public ResidualEdge(int from, int to, int cost, int capacity) {
            this.from = from;
            this.to = to;
            this.cost = cost;
            this.capacity = this.residual = capacity;
        }
    }

    static int edmondsKarp(FlowAdjGraph g, int s, int t) {
        int flow = 0;
        while (true) {
            ArrayList<ResidualEdge> path = findAugmentedPath(g.edges, s, t);
            if (path == null) break;
            int augedFlow = Integer.MAX_VALUE;
            for (ResidualEdge e : path) {
                augedFlow = Math.min(augedFlow, e.residual);
            }
            for (ResidualEdge e : path) {
                e.residual -= augedFlow;
                e.reversedEdge.residual += augedFlow;
            }
            flow += augedFlow;
        }
        return flow;
    }

    /**
     * @param edges
     * @param s
     * @param t
     * @return 増加道を構成する辺のリスト
     */
    private static ArrayList<ResidualEdge> findAugmentedPath(
            ArrayList<ResidualEdge>[] edges, int s, int t) {
        int n = edges.length;
        ResidualEdge[] prevE = new ResidualEdge[n];
        int[] prevV = new int[n];
        Arrays.fill(prevV, -1);
        Queue<Integer> queue = new LinkedList<Integer>();  // Java6ならArrayDequeにする
        queue.add(s);
        prevV[s] = -2;  // make sure source wont be rediscovered
        search: while (!queue.isEmpty()) {
            int v = queue.poll();
            for (ResidualEdge e : edges[v]) {
                if (e.residual > 0 && prevV[e.to] == -1) {
                    prevE[e.to] = e;
                    prevV[e.to] = v;
                    if (e.to == t) break search;
                    queue.add(e.to);
                }
            }
        }
        if (prevE[t] == null) return null;
        ArrayList<ResidualEdge> path = new ArrayList<ResidualEdge>();
        ResidualEdge e;
        for (int v = t;; v = prevV[v]) {
            e = prevE[v];
            if (e == null) break;
            path.add(e);  // 効率のためここで増加フローも計算したほうがよい
        }
        return path;
    }

}
