
import java.util.HashSet;
import java.util.Scanner;
import java.math.BigInteger;


public class GCJ2016QualC {

    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            System.out.printf("Case #%d:%n", i);
            new GCJ2016QualC().solve(sc);
        }
    }
    
    static final int[] smallPrimes = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439, 443, 449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541, };
    
    private void solve(Scanner sc) throws Exception {
        int n = sc.nextInt();
        int numJ = sc.nextInt();
        HashSet<String> dejavu = new HashSet<>();
        String[] ans = new String[numJ];
        int[][] proofs = new int[numJ][11];
        int numAns = 0;
        randomTrial: for (int i = 0; i < 10000000 && numAns < numJ; i++) {
            StringBuilder sb = new StringBuilder(n);
            sb.append(1);
            for (int j = 0; j < n - 2; j++) {
                sb.append(Math.random() < 0.5 ? 1 : 0);
            }
            sb.append(1);
            
            String candidateStr = sb.toString();
            if (!dejavu.add(candidateStr)) continue;
            for (int base = 2; base <= 10; base++) {
                BigInteger candidate = new BigInteger(candidateStr, base);
                int divisor = -1;
                for (int prime : smallPrimes) {
                    if (candidate.mod(BigInteger.valueOf(prime)).equals(BigInteger.ZERO)) {
                        divisor = prime;
                        break;
                    }
                }
                if (divisor == -1) continue randomTrial;
                proofs[numAns][base] = divisor;
            }
            ans[numAns] = candidateStr;
            
            // ついでに出力する
            System.out.print(ans[numAns]);
            for (int base = 2; base <= 10; base++) {
                System.out.print(" " +  proofs[numAns][base]);
            }
            System.out.println();
            
            numAns++;
        }
    }
}
