import java.util.Scanner;


public class GCJ2015QualC {

    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            System.out.printf("Case #%d: %s%n", i, new GCJ2015QualC().solve(sc));
        }
    }

    static final int ONE = 1;
    static final int I = 2;
    static final int J = 3;
    static final int K = 4;
    static final int[][] MAP = {
            { 1, I, J, K }, { I, -1, K, -J }, { J, -K, -1, I }, { K, J, -I, -1 } };

    int mul(int a, int b) {
        int sgn = a * b > 0 ? 1 : -1;
        return MAP[Math.abs(a) - 1][Math.abs(b) - 1] * sgn;
    }

    String toString(int a) {
        int sgn = a > 0 ? 1 : -1;
        a = Math.abs(a);
        return ((sgn == -1) ? "-" : "")
                + (a == I ? "i" : a == J ? "j" : a == K ? "k" : "1");
    }

    private String solve(Scanner sc) throws Exception {
        int L = sc.nextInt();
        long X = sc.nextLong();
        if (X >= 16) {
            X -= 16;
            X -= (X / 4) * 4;
            X += 16;
        }
        String s = sc.next();
        StringBuilder sb = new StringBuilder(s.length() * (int) X);
        while (X-- > 0)
            sb.append(s);
        s = sb.toString();

        int n = s.length();
        boolean[][][] dp = new boolean[3][9][n + 1];
        final int SHIFT = 4;
        dp[0][1 + SHIFT][0] = true;
        for (int i = 0; i < 3; i++) {
            for (int k = 0; k <= n; k++) {
                for (int j = 0; j < 9; j++) {
                    if (!dp[i][j][k]) continue;
                    int v1 = j - SHIFT;
                    // System.out.println(i + ", " + toString(j) + ", " + k);
                    boolean canSplit = (i == 0 && v1 == I) || (i == 1 && v1 == J)
                            || (i == 2 && v1 == K);
                    if (canSplit) {
                        if (i < 2) dp[i + 1][1 + SHIFT][k] = true;
                        else if (k == n) return "YES";
                    }
                    if (k == n) break;
                    char c = s.charAt(k);
                    int v2 = c == 'i' ? I : c == 'j' ? J : K;
                    int nv = mul(v1, v2);
                    dp[i][nv + SHIFT][k + 1] = true;
                }
            }
        }

        return "NO";
    }
}
