import java.util.Arrays;
import java.util.Scanner;


public class R2B {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            solve(sc, i);            
        }
    }

    private static void solve(Scanner sc, int t) {
        int n = sc.nextInt();
        int w = sc.nextInt();
        int l = sc.nextInt();
        
        Person[] ps = new Person[n];
        for (int i = 0; i < n; i++) {
            ps[i] = new Person(i, sc.nextInt());
        }
        Person[] ps2 = Arrays.copyOf(ps, n);
        Arrays.sort(ps);
//        System.out.println(Arrays.toString(ps));
        int nowW = ps[0].r; /* right most */
        int nowL = 0; /* top most */
        int nextL = ps[0].r;
        for (int i = 1; i < n; i++) {
            if (nowW + ps[i].r <= w) {
                ps[i].x = nowW + ps[i].r;
                ps[i].y = nowL;
                nowW += ps[i].r * 2;
            }
            else {
                nowL = nextL + ps[i].r;
                nextL = nowL + ps[i].r;
                nowW = ps[i].r;
                ps[i].x = 0;
                ps[i].y = nowL;
                if (nowL > l) throw new IllegalStateException();
            }
        }
        StringBuilder sb = new StringBuilder(n * 16).append("Case #").append(t).append(":");
        for (int i = 0; i < n; i++) {
            sb.append(" ").append(ps2[i].x).append(" ").append(ps2[i].y);
        }
        System.out.println(sb);
    }
    
    static class Person implements Comparable<Person> {
        final int i;
        final int r;
        double x;
        double y;
        public Person(int i, int r) {
            super();
            this.i = i;
            this.r = r;
        }
        @Override
        public int compareTo(Person o) {
            return -(r - o.r);
        }
        @Override
        public String toString() {
            return "Person [i=" + i + ", r=" + r + "]";
        }
        
    }

}
