import java.util.Arrays;
import java.util.HashMap;
import java.util.Scanner;


public class GCJ2014Round2B {

    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            System.out.printf("Case #%d: %d%n", i, new GCJ2014Round2B().solve(sc));
        }
    }

    private int solve(Scanner sc) throws Exception {
        int n = sc.nextInt();
        int[] as = new int[n];
        for (int i = 0; i < n; i++) {
            as[i] = sc.nextInt();
        }
        int[] aSorted = as.clone();
        Arrays.sort(aSorted);
        HashMap<Integer, Integer> ids = new HashMap<>();
        for (int i = 1; i <= n; i++) {
            ids.put(aSorted[i - 1], i);
        }
        for (int i = 0; i < n; i++) {
            as[i] = ids.get(as[i]);
        }
        int[] inverseAs = new int[n];
        for (int i = 0; i < n; i++) {
            inverseAs[i] = as[n - i - 1];  // noo its not inv but rev
        }

//         System.out.println("as = " + Arrays.toString(as));
        // System.out.println("invas = " + Arrays.toString(inverseAs));

        BinaryIndexedTree bitF = new BinaryIndexedTree(n*2);
        BinaryIndexedTree bitB = new BinaryIndexedTree(n*2);
        int[] bitBTemp = new int[n];
        int ansB = 0;
        for (int i = 0; i < n; i++) {
            ansB += i - bitB.sum(inverseAs[i]);
            bitB.add(inverseAs[i], 1);
            bitBTemp[i] = ansB;
        }
//         System.out.println("bitB = " + Arrays.toString(bitBTemp));
        int bestMoves = bitBTemp[n - 1];
        int ansF = 0;
        for (int i = 0; i < n; i++) {
            ansF += i - bitF.sum(as[i]);
            bitF.add(as[i], 1);
            int taigan = bitBTemp[n - i - 1];
            int moves = ansF + taigan;
            // System.out.println(ansF + " + " + taigan + " = " + moves);
            bestMoves = Math.min(bestMoves, moves);
        }
        return bestMoves;
    }

    /**
     * @see プログラミングコンテストチャレンジブック 第1版 p.159
     */
    public static class BinaryIndexedTree {
        final int[] data;
        final int n;

        public BinaryIndexedTree(int n) {
            this.n = n;
            data = new int[n + 1];
        }

        int sum(int i) {
            checkRange(i);
            int s = 0;
            while (i > 0) {
                s += data[i];
                i -= i & -i;
            }
            return s;
        }

        private void checkRange(int i) {
            if (i < 1 || n < i) throw new IllegalArgumentException("" + i + ", " + n);
        }

        void add(int i, int x) {
            checkRange(i);
            while (i <= n) {
                data[i] += x;
                i += i & -i;
            }
        }
    }
}
