package r2;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

public class Q2H {
	private static final double SMALL = 1e-14;
	private static boolean equals(double a, double b) {
		return Math.abs(a - b) < SMALL;
	}
	public static void main(String... args) {
		@SuppressWarnings("resource")
		Scanner in = new Scanner(System.in);
		int caseCount = in.nextInt();
		double[] R = new double[100];
		double[] C = new double[100];
		double[] cC = new double[100];
		for (int caseValue = 1; caseValue <= caseCount; caseValue++) {
			int N = in.nextInt();
			double V = in.nextDouble();
			double X = in.nextDouble();
			for (int i = 0; i < N; i++) {
				R[i] = in.nextDouble();
				C[i] = in.nextDouble();
			}
			double rEquals = 0;
			double amtU = 0;
			double amtD = 0;
			boolean[] u = new boolean[100];
			boolean[] d = new boolean[100];
			for (int i = 0; i < N; i++) {
				cC[i] = C[i] - X;
				if (equals(cC[i], 0)) {
					rEquals += R[i];
				} else if (cC[i] > 0) {
					amtU += cC[i] * R[i];
					u[i] = true;
				} else {
					amtD += -cC[i] * R[i];
					d[i] = true;
				}
			}
			dbg("rEquals", rEquals);
			dbg("amtU", amtU);
			dbg("amtD", amtD);
			dbg("u", u);
			dbg("d", d);
			String result;
			if (equals(amtU, 0) || equals(amtD, 0)) {
				if (equals(rEquals, 0)) {
					result = "IMPOSSIBLE";
				} else {
					dbg("WAY", "ONLY EQ");
					result = Double.toString(V / rEquals);
				}
			} else {
				dbg("WAY", "CONF");
				// amtU and amtD both positive.
				boolean[] uses;
				boolean[] conf;
				double confAmt;
				if (amtU > amtD) {
					uses = d;
					confAmt = amtD;
					conf = u;
				} else {
					uses = u;
					confAmt = amtU;
					conf = d;
				}
				rcConf.clear();
				for (int i = 0; i < N; i++) {
					if (conf[i]) {
						rcConf.add(new RC(R[i], cC[i]));
					}
				}
				rcConf.sort((a, b) -> {
					double cmp = a.cForEachR - b.cForEachR;
					return cmp > 0 ? 1 : (cmp < 0 ? -1 : 0);
				});
				double effectiveR = rEquals;
				for (int i = 0; i < N; i++) {
					if (uses[i]) {
						effectiveR += R[i];
					}
				}
				dbg("effectiveR(init)", effectiveR);
				dbg("rcConf", rcConf);
				double confAmtRemain = confAmt;
				for (int i = 0, iMax = rcConf.size(); i < iMax; i++) {
					RC rc = rcConf.get(i);
					if (rc.amt < confAmtRemain) {
						confAmtRemain -= rc.amt;
						effectiveR += rc.r;
						dbg("effectiveR+", rc.r);
					} else {
						double percentage = confAmtRemain / rc.amt;
						dbg("percentage", percentage);
						effectiveR += rc.r * percentage;
						dbg("effectiveR+", rc.r * percentage);
						break;
					}
				}
				dbg("effectiveR", effectiveR);
				result = Double.toString(V / effectiveR);
			}
			System.out.println("Case #" + caseValue + ": " + result);
		}
	}
	private static void dbg(String string, List<?> v) {
		dbg(string, v.toString());
	}
	private static void dbg(String string, boolean[] v) {
		dbg(string, Arrays.toString(v));
	}
	@SuppressWarnings("unused")
	private static void dbg(String string, String v) {
//		System.out.println(string + ": " + v);
	}
	private static void dbg(String string, double v) {
		dbg(string, Double.toString(v));
	}
	private static final class RC {
		public double r;
		public double c;
		public double cForEachR;
		public double amt;
		public RC(double r, double c) {
			this.r = r;
			this.c = c;
			this.cForEachR = c / r;
			this.amt = r * c;
		}
		@Override
		public String toString() {
			return "R=" + r + ",C=" + c;
		}
	}
	private static final List<RC> rcConf = new ArrayList<>(100);
}
