package r2;

import java.util.Scanner;

public class Q3 {
	private static enum Side {
		U, D, L, R;
	}
	private static final class Point {
		public int r, c;
		public Side side;
		public Point(int r, int c, Side side) {
			this.r = r;
			this.c = c;
			this.side = side;
		}
		@Override
		public String toString() {
			return "(" + r + "," + c + "," + side + ")";
		}
	}
	private static final class CannotMakeException extends Exception {
		private static final long serialVersionUID = -2816337462025780590L;
	}
	public static void main(String... args) {
		try (Scanner in = new Scanner(System.in)) {
			int T = in.nextInt();
			loopOverCase:
			for (int caseI = 0; caseI < T; caseI++) {
				int R = in.nextInt();
				int C = in.nextInt();
				int count = 2 * (R + C);
				int[] pairs = new int[count];
				for (int i = 0; i < count; i++) {
					pairs[i] = in.nextInt() - 1;
				}
				int[] pairTo = new int[count];
				for (int i = 0; i < count; i += 2) {
					pairTo[pairs[i]] = pairs[i + 1];
					pairTo[pairs[i + 1]] = pairs[i];
				}
				char[][] grid = new char[R][C]; {
					int pairCircleSize = count;
					int[] pairCircle = new int[count];
					System.arraycopy(pairTo, 0, pairCircle, 0, count);
					while (pairCircleSize > 0) {
						int pairedIndex1;
						int pairedIndex2;
						if (pairTo[pairCircle[0]] == pairCircle[pairCircleSize - 1]) {
							pairedIndex1 = pairCircleSize - 1;
							pairedIndex2 = 0;
						} else {
							for (pairedIndex1 = 0, pairedIndex2 = 1; pairedIndex1 < pairCircleSize - 1;
									pairedIndex1++, pairedIndex2++) {
								if (pairTo[pairCircle[pairedIndex1]] == pairCircle[pairedIndex2]) {
									break;
								}
							}
							if (pairedIndex1 == pairCircleSize - 1) {
								System.out.println("Case #" + (caseI + 1) + ":\nIMPOSSIBLE");
								continue loopOverCase;
							}
						}
						try {
							draw(grid, pairCircle[pairedIndex1], pairCircle[pairedIndex2]);
						} catch (CannotMakeException e) {
							System.out.println("Case #" + (caseI + 1) + ":\nIMPOSSIBLE");
							continue loopOverCase;
						}
						if (pairedIndex1 == pairCircleSize - 1) {
							System.arraycopy(pairCircle, 1, pairCircle, 0, pairCircleSize - 2);
						} else {
							int copyLength = pairCircleSize - 2 - pairedIndex1;
							if (copyLength > 0) {
								System.arraycopy(pairCircle, pairedIndex1 + 2, pairCircle, pairedIndex1, copyLength);
							}
						}
						pairCircleSize -= 2;
					}
					fill(grid);
				}
				System.out.println("Case #" + (caseI + 1) + ":");
				for (int r = 0; r < R; r++) {
					System.out.println(new String(grid[r]));
				}
			}
		}
	}

	private static void fill(char[][] grid) {
		int R = grid.length;
		int C = grid[0].length;
		for (int r = 0; r < R; r++) {
			for (int c = 0; c < C; c++) {
				if (grid[r][c] == 0) {
					grid[r][c] = '/';
				}
			}
		}
	}
	private static void draw(char[][] grid, int a, int b) throws CannotMakeException {
		int r = grid.length;
		int c = grid[0].length;
		Point at = getPoint(a, r, c);
		Point to = getPoint(b, r, c);
//		System.err.println("Connect " + a + " " + b);
		for (;;) {
//			System.err.println(at + " -> " + to);
			if (at.side == Side.D) {
				if (at.r + 1 < r) {
					if (grid[at.r + 1][at.c] == '\\') {
						at = new Point(at.r + 1, at.c, Side.R);
					} else {
						grid[at.r + 1][at.c] = '/';
						at = new Point(at.r + 1, at.c, Side.L);
					}
				} else {
					at = new Point(at.r + 1, at.c, null);
				}
			} else if (at.side == Side.U) {
				if (at.r - 1 >= 0) {
					if (grid[at.r - 1][at.c] == '\\') {
						at = new Point(at.r - 1, at.c, Side.L);
					} else {
						grid[at.r - 1][at.c] = '/';
						at = new Point(at.r - 1, at.c, Side.R);
					}
				} else {
					at = new Point(at.r - 1, at.c, null);
				}
			} else if (at.side == Side.L) {
				if (at.c - 1 >= 0) {
					if (grid[at.r][at.c - 1] == '/') {
						at = new Point(at.r, at.c - 1, Side.D);
					} else {
						grid[at.r][at.c - 1] = '\\';
						at = new Point(at.r, at.c - 1, Side.U);
					}
				} else {
					at = new Point(at.r, at.c - 1, null);
				}
			} else if (at.side == Side.R) {
				if (at.c + 1 < c) {
					if (grid[at.r][at.c + 1] == '/') {
						at = new Point(at.r, at.c + 1, Side.U);
					} else {
						grid[at.r][at.c + 1] = '\\';
						at = new Point(at.r, at.c + 1, Side.D);
					}
				} else {
					at = new Point(at.r, at.c + 1, null);
				}
			} else {
				throw new CannotMakeException();
			}
			if (at.r == to.r && at.c == to.c) {
				break;
			}
		}
	}

	private static Point getPoint(int a, int r, int c) {
		if (a < c) {
			return new Point(-1, a, Side.D);
		}
		a -= c;
		if (a < r) {
			return new Point(a, c, Side.L);
		}
		a -= r;
		if (a < c) {
			return new Point(r, c - 1 - a, Side.U);
		}
		a -= c;
		return new Point(r - 1 - a, -1, Side.R);
	}
}
