package r2;

import java.util.Scanner;

public class Q1 {
	private static final int DIR_NONE = 0;
	private static final int DIR_U = 1;
	private static final int DIR_R = 2;
	private static final int DIR_D = 3;
	private static final int DIR_L = 4;
	public static void main(String... args) {
		@SuppressWarnings("resource")
		Scanner in = new Scanner(System.in);
		int caseCount = in.nextInt();
		int[][] dir = new int[100][100];
		for (int caseValue = 1; caseValue <= caseCount; caseValue++) {
			int R = in.nextInt();
			int C = in.nextInt();
			for (int r = 0; r < R; r++) {
				String line = in.next();
				for (int c = 0; c < C; c++) {
					char ch = line.charAt(c);
					dir[r][c] = ch == '.' ? DIR_NONE :
						(ch == '^' ? DIR_U :
							(ch == '>' ? DIR_R :
								(ch == 'v' ? DIR_D : DIR_L)));
				}
			}
			boolean possible = true;
			int changed = 0;
			LOOP_POSSIBLE:
			for (int r = 0; r < R; r++) {
				for (int c = 0; c < C; c++) {
					int d = dir[r][c];
					if (d == DIR_NONE) {
						continue;
					}
					if (pointingOut(dir, R, C, r, c, d)) {
						if (d != DIR_U && hasArrowU(dir, R, C, r, c)) {
							changed++;
						} else if (d != DIR_R && hasArrowR(dir, R, C, r, c)) {
							changed++;
						} else if (d != DIR_D && hasArrowD(dir, R, C, r, c)) {
							changed++;
						} else if (d != DIR_L && hasArrowL(dir, R, C, r, c)) {
							changed++;
						} else {
							possible = false;
							break LOOP_POSSIBLE;
						}
					}
				}
			}
			System.out.println("Case #" + caseValue + ": " + (possible ? Integer.toString(changed) : "IMPOSSIBLE"));
		}
	}

	@SuppressWarnings("unused")
	private static boolean hasArrowL(int[][] dir, int R, int C, int r, int c) {
		for (int cc = c - 1; cc >= 0; cc--) {
			if (dir[r][cc] != DIR_NONE) {
				return true;
			}
		}
		return false;
	}
	@SuppressWarnings("unused")
	private static boolean hasArrowD(int[][] dir, int R, int C, int r, int c) {
		for (int rr = r + 1; rr < R; rr++) {
			if (dir[rr][c] != DIR_NONE) {
				return true;
			}
		}
		return false;
	}
	@SuppressWarnings("unused")
	private static boolean hasArrowR(int[][] dir, int R, int C, int r, int c) {
		for (int cc = c + 1; cc < C; cc++) {
			if (dir[r][cc] != DIR_NONE) {
				return true;
			}
		}
		return false;
	}
	@SuppressWarnings("unused")
	private static boolean hasArrowU(int[][] dir, int R, int C, int r, int c) {
		for (int rr = r - 1; rr >= 0; rr--) {
			if (dir[rr][c] != DIR_NONE) {
				return true;
			}
		}
		return false;
	}

	private static boolean pointingOut(int[][] dir, int R, int C, int r, int c, int d) {
		if (d == DIR_U) {
			return !hasArrowU(dir, R, C, r, c);
		}
		if (d == DIR_R) {
			return !hasArrowR(dir, R, C, r, c);
		}
		if (d == DIR_D) {
			return !hasArrowD(dir, R, C, r, c);
		}
		return !hasArrowL(dir, R, C, r, c);
	}
}
