import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**
 * 
 * @author daifei4321@gmail.com
 *
 */
public class R2_1 {
	private static Scanner in;
	private static void initSource(String[] args) {
		if (args.length == 0) {
			in = new Scanner(System.in);
		} else {
			try {
				in = new Scanner(new File(args[0]));
			} catch (FileNotFoundException e) {
				System.out.println(e.getMessage());
				System.exit(-1);
			}
		}
	}
	private static void opt(String msg) {
		System.out.println(msg);
	}
	private static void dbg(Object msg) {
//		System.err.println(msg);
	}
	public static void main(String[] args) {
		initSource(args);
		int caseMax = in.nextInt();
		dbg("Case Max = " + caseMax);
		for (int caseCount = 1; caseCount <= caseMax; caseCount++) {
			dbg("Case " + caseCount);
			int M = in.nextInt(), V = in.nextInt();
			Tree t = new Tree(M);
			for (int i = 0, max = (M - 1) / 2; i < max; i++) {
				int g = in.nextInt(), c = in.nextInt();
				t.inG[i] = (g == 1);
				t.inC[i] = (c == 1);
			}
			for (int i = 0, max = (M + 1) / 2; i < max; i++) {
				t.lf[i] = in.nextInt() == 1;
			}
			int value = t.make(1)[V];
			opt("Case #" + caseCount + ": " + (value == INF ? "IMPOSSIBLE" : value));
		}
	}
	static final int INF = Integer.MAX_VALUE;
	static class Tree {
		final int M;
		final boolean[] inG, inC, lf;
		public Tree(int M) {
			this.M = M;
			inG = new boolean[(M - 1) / 2];
			inC = new boolean[(M - 1) / 2];
			lf = new boolean[(M + 1) / 2];
		}
		public int[] make(int node) {
			if (node <= (M - 1) / 2) {
				int[] l = make(2 * node);
				int[] r = make(2 * node + 1);
				int vF = INF, vT = INF, temp;
				if (l[0] != INF && r[0] != INF) {
					temp = l[0] + r[0];
					if (temp < vF) {
						vF = temp;
					}
				}
				if (l[1] != INF && r[1] != INF) {
					temp = l[1] + r[1];
					if (temp < vT) {
						vT = temp;
					}
				}
				if (l[0] != INF && r[1] != INF) {
					temp = l[0] + r[1];
					if (inG[node - 1]) { // AND gate
						if (temp < vF) {
							vF = temp;
						}
						if (inC[node - 1]) {
							if (temp + 1 < vT) {
								vT = temp + 1;
							}
						}
					} else {
						if (temp < vT) {
							vT = temp;
						}
						if (inC[node - 1]) {
							if (temp + 1 < vF) {
								vF = temp + 1;
							}
						}
					}
				}
				if (l[1] != INF && r[0] != INF) {
					temp = l[1] + r[0];
					if (inG[node - 1]) { // AND gate
						if (temp < vF) {
							vF = temp;
						}
						if (inC[node - 1]) {
							if (temp + 1 < vT) {
								vT = temp + 1;
							}
						}
					} else {
						if (temp < vT) {
							vT = temp;
						}
						if (inC[node - 1]) {
							if (temp + 1 < vF) {
								vF = temp + 1;
							}
						}
					}
				}
				return new int[] {vF, vT};
			} else {
				if (lf[node - ((M - 1) / 2 + 1)]) {
					return new int[] {INF, 0};
				} else {
					return new int[] {0, INF};
				}
			}
		}
	}
}
