package r2;

import java.util.Scanner;

public class Q4 {
	public static void main(String... args) {
		try (Scanner in = new Scanner(System.in)) {
			int T = in.nextInt();
			for (int caseI = 0; caseI < T; caseI++) {
				int N = in.nextInt();
				char[][] grid = new char[N][];
				for (int i = 0; i < N; i++) {
					String next = in.next();
					assert(next.length() == N);
					grid[i] = next.toCharArray();
				}
				StringBuilder result = new StringBuilder();
				int needed = getNeeded(grid);
				result.append(needed);
				System.out.println("Case #" + (caseI + 1) + ": " + result);
			}
		}
	}

	private static int getNeeded(char[][] grid) {
		int N = grid.length;
		{
			int indexColValue0 = -1;
			int[] statusCols = new int[N];
			for (int c = 0; c < N; c++) {
				int count1 = 0;
				for (int r = 0; r < N; r++) {
					if (grid[r][c] == '1') {
						count1++;
					}
				}
				statusCols[c] = count1;
				if (count1 == 0) {
					indexColValue0 = c;
				}
			}
			int indexRowValue0 = -1;
			int[] statusRows = new int[N];
			for (int r = 0; r < N; r++) {
				int count1 = 0;
				for (int c = 0; c < N; c++) {
					if (grid[r][c] == '1') {
						count1++;
					}
				}
				statusRows[r] = count1;
				statusCols[r] = count1;
				if (count1 == 0) {
					indexRowValue0 = r;
				}
			}
			if (-1 != indexRowValue0 && -1 != indexColValue0) {
				return 1 + getNeeded(removeCell(grid, indexRowValue0, indexColValue0));
			}
		} {
			for (int r = 0; r < N; r++) {
				int colOf1 = -1;
				int count1 = 0;
				for (int c = 0; c < N; c++) {
					if (grid[r][c] == '1') {
						count1++;
						colOf1 = c;
					}
				}
				if (count1 == 1) {
					boolean findSingle1Failed = false;
					for (int rEach = 0; rEach < N; rEach++) {
						if (rEach != r && grid[rEach][colOf1] == '1') {
							findSingle1Failed = true;
							break;
						}
					}
					if (!findSingle1Failed) {
						return getNeeded(removeCell(grid, r, colOf1));
					}
				}
			}
		}
		int fillNeeded = 0;
		for (int r = 0; r < N; r++) {
			for (int c = 0; c < N; c++) {
				if (grid[r][c] == '0') {
					fillNeeded++;
				}
			}
		}
		return fillNeeded;
	}

	private static char[][] removeCell(char[][] grid, int removeR, int removeC) {
		int N = grid.length;
		char[][] newGrid = new char[N - 1][N - 1];
		for (int r = 0; r < N - 1; r++) {
			int oldR = r >= removeR ? r + 1 : r;
			for (int c = 0; c < N - 1; c++) {
				int oldC = c >= removeC ? c + 1 : c;
				newGrid[r][c] = grid[oldR][oldC];
			}
		}
		return newGrid;
	}
}
