package r2;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

public class Q3 {
	public static void main(String... args) {
		@SuppressWarnings("resource")
		Scanner in = new Scanner(System.in);
		int caseCount = Integer.parseInt(in.nextLine());
		for (int caseValue = 1; caseValue <= caseCount; caseValue++) {
			List<Line> lines = new ArrayList<>(20);
			dic.clear();
			int N = Integer.parseInt(in.nextLine());
			for (int i = 0; i < N; i++) {
				lines.add(new Line(in.nextLine()));
			}
			boolean[] types = new boolean[lines.size()];
			types[0] = false;
			types[1] = true;
			int minCommonInEachType = getMinCommonInEachType(N, lines, types, 2);
			System.out.println("Case #" + caseValue + ": " + minCommonInEachType);
		}
	}
	private static int getMinCommonInEachType(int N, List<Line> lines, boolean[] types, int newAt) {
		if (newAt < N) {
			types[newAt] = false;
			int a = getMinCommonInEachType(N, lines, types, newAt + 1);
			types[newAt] = true;
			int b = getMinCommonInEachType(N, lines, types, newAt + 1);
			return Math.min(a, b);
		}
		boolean[] inFalse = new boolean[dic.size()];
		for (int i = 0; i < N; i++) {
			Line line = lines.get(i);
			if (!types[i]) {
				int[] words = line.words;
				for (int j = 0, jMax = words.length; j < jMax; j++) {
					int word = words[j];
					inFalse[word] = true;
				}
			}
		}
		boolean[] inTrue = new boolean[dic.size()];
		for (int i = 0; i < N; i++) {
			Line line = lines.get(i);
			if (types[i]) {
				int[] words = line.words;
				for (int j = 0, jMax = words.length; j < jMax; j++) {
					int word = words[j];
					inTrue[word] = true;
				}
			}
		}
		int result = 0;
		for (int i = 0, iMax = inFalse.length; i < iMax; i++) {
			if (inFalse[i] && inTrue[i]) {
				result++;
			}
		}
		return result;
	}
	private static final Map<String, Integer> dic = new TreeMap<>();
	private static final class Line {
		public final int[] words;
		public Line(String line) {
			String[] words = line.split(" ");
			this.words = new int[words.length];
			for (int i = 0, iMax = words.length; i < iMax; i++) {
				String word = words[i];
				Integer v = dic.get(word);
				if (null == v) {
					v = dic.size();
					dic.put(word, v);
				}
				this.words[i] = v;
			}
		}
	}
}
