import java.util.*;

/**
 * Created by Daiki_Ikawa on 2017/04/08.
 */
public class ProblemD {

    public static void main(String[] args) {
        ProblemD m = new ProblemD();
        m.run();
    }


    void run() {
        Scanner sc = new Scanner(System.in);

        int t = sc.nextInt();
        for (int i = 0; i < t; i++) {
            int n = sc.nextInt();
            int m = sc.nextInt();

            sc.nextLine();

            String constraints[] = new String[m];

            for (int j = 0; j < m; j++) {
                constraints[j] = sc.nextLine();
            }

            System.out.print("Case #" + (i + 1) + ": " + solve(n, constraints));

        }

    }


    String solve(int n, String constraints[]) {
        int[][] map90 = new int[n][n];
        int[][] map45 = new int[n][n];

        for(int i = 0 ; i< n ; i++){
            map90[i][i] = 1;
        }
        for(int i =0 ; i < n; i++){
            map45[i][0] = 1;
        }
        for(int i = 1 ; i < n-1;i++){
            map45[i][n-1] = 1;
        }

        for(String query : constraints){
            String[] arr = query.split(" ");

            // map90
            if(arr[0].equals("o") || arr[0].equals("x")){
                int x = Integer.valueOf(arr[1])-1;
                int y = Integer.valueOf(arr[2])-1;

                int sx=0,sy=0;
                for(int i = 0; i< n; i++){
                    if(map90[x][i] == 1){
                        sy = i;
                    }
                    if(map90[i][y] == 1){
                        sx = i;
                    }
                }
                map90[x][sy]=0;
                map90[sx][y]=0;
                map90[x][y]=1;
                map90[sx][sy] = 1;
            }

            // map45
            if(arr[0].equals("o") || arr[0].equals("+")){
                int x = Integer.valueOf(arr[1])-1;
                int y = Integer.valueOf(arr[2])-1;


                int sx1 = 0,sy1 = 0;
                for(int xx = x, yy=y; xx < n && yy < n ; xx++,yy++){
                    if(map45[xx][yy] == 1){
                        map45[xx][yy] = 0;
                        sx1 = xx;
                        sy1 = yy;
                    }
                }
                for(int xx = x, yy=y; xx >= 0 && yy >= 0 ; xx--,yy--){
                    if(map45[xx][yy] == 1){
                        map45[xx][yy] = 0;
                        sx1 = xx;
                        sy1 = yy;
                    }
                }
                int sx2 = 0,sy2 = 0;
                for(int xx = x, yy=y; xx < n && yy >= 0 ; xx++,yy--){
                    if(map45[xx][yy] == 1){
                        map45[xx][yy] = 0;
                        sx2 = xx;
                        sy2 = yy;
                    }
                }
                for(int xx = x, yy=y; xx >= 0 && yy < n  ; xx--,yy++){
                    if(map45[xx][yy] == 1){
                        map45[xx][yy] = 0;
                        sx2 = xx;
                        sy2 = yy;
                    }
                }

                map45[x][y]=1;

                int ssx = sx1 + sx2 - x;
                int ssy = sy1 + sy2 - y;
                if(ssx >= 0 && ssx < n && ssy >=0 &&ssy < n){
                    map45[ssx][ssy] = 1;
                }
            }
        }

        List<String> answers = new ArrayList<String>(6*n);
        int point = 0;

        for(int i =0 ; i< n ;i++){
            for(int j = 0 ; j < n ; j++){
                if(map90[i][j] == 1 && map45[i][j]==1){
                   answers.add("o "+(i+1)+" "+(j+1));
                   point += 2;
                }else if(map90[i][j] == 1 ){
                    answers.add("x "+(i+1)+" "+(j+1));
                    point += 1;
                }else if( map45[i][j]==1){
                    answers.add("+ "+(i+1)+" "+(j+1));
                    point += 1;
                }
            }
        }

//        printanswer(n,map45,map90);
        Collections.sort(answers);
        Arrays.sort(constraints);

        List<String> filteredAnswer = new LinkedList<String>();
        for(String ans:answers){
            if(Arrays.binarySearch(constraints,ans) < 0){
               filteredAnswer.add(ans);
            }
        }

        StringBuilder result = new StringBuilder("");
        result.append(point+" "+filteredAnswer.size()+"\n");
        filteredAnswer.forEach(x -> result.append(x+"\n"));
        return result.toString();
    }

    void printanswer(int n,int[][] map45, int[][] map90){
        if(true){
            for(int i = 0; i< n ; i++){
                for(int j = 0; j <n ; j++){
                    if(map90[i][j] == 1 && map45[i][j]==1){
                        System.out.print("o");
                    }else if(map90[i][j] == 1 ){
                        System.out.print("x");
                    }else if( map45[i][j]==1){
                        System.out.print("+");
                    }else{
                        System.out.print(".");
                    }
                }
                System.out.println();
            }
        }
    }
}
