package com.dakura.gcj;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.*;


public class Rotate {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		new Rotate().run(args[0]);
	}
	void run(String inputFile) {
    	Scanner sc = null;
		try {
			sc = new Scanner(new File(inputFile));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		int numOfCases = sc.nextInt();
		for(int i=0; i < numOfCases; i++){
			int n = sc.nextInt();
			int k = sc.nextInt();
			sc.nextLine();
			char[][] board = new char[n][];
			for (int j=0; j < n; j++) {
				board[j] = sc.nextLine().toCharArray(); 
			}
			//printBoard(board);
			board = rotate(board);
			//printBoard(board);
			String result = evaluate(board, k);
			System.out.printf("Case #%d: %s\n", i+1, result);
		}
	}
	void printBoard(char[][] board) {
		for (char[] line : board) {
			for (char c : line) {
				System.out.print(c);
			}
			System.out.print('\n');
		}
	}
	char[][] rotate(char[][] b) {
		int n = b.length;
		char[][] rb = new char[n][n];
		for (int i=0; i < n; i++) {
			for (int j=n-1; j >= 0; j--) {
				//System.out.printf("%d %d\n", i,j);
				if (b[i][j] == '.') {
					rb[j][n-i-1] = '.';
				} else {
					int bottom = j;
					for (int k=j+1; k < n; k++) {
						if (rb[k][n-i-1] != '.') {
							break;
						} else {
							bottom = k;
						}
					}
					rb[bottom][n-i-1] = b[i][j];
					for (int k=j; k < bottom; k++) {
						rb[k][n-i-1] = '.';
					}
				}
			}
		}
		return rb;
	}
	String evaluate(char[][] b, int k) {
		int n = b.length;
		boolean isRwin = false;
		boolean isBwin = false;
		for (int i=0; i < n; i++) {
			line_loop:
			for (int j=0; j < n; j++) {
				if (b[i][j] == '.' ||
					(b[i][j] == 'R' && isRwin) ||
					(b[i][j] == 'B' && isBwin)) {
					continue;
				} 
				// right
				for (int l=j+1, row=1; l < n; l++) {
					if (b[i][l] != b[i][j]) {
						break;
					}
					//System.out.printf("row r %d %d (%d)\n", i, l, row);
					if (++row >= k) {
						//System.out.printf("row r ok ! %d %d (%d)\n", i, l, row);
						if (b[i][j] == 'R') { isRwin = true; }
						else { isBwin = true; }
						continue line_loop;
					}
				}
				// down
				for (int l=i+1, row=1; l < n; l++) {
					if (b[l][j] != b[i][j]) {
						break;
					}
					if (++row >= k) {
						if (b[i][j] == 'R') { isRwin = true; }
						else { isBwin = true; }
						continue line_loop;
					}
					//System.out.printf("row d %d %d (%d)\n", l, j, row);
				}
				// rd
				for (int l=i+1, m=j+1, row=1; l < n && m < n; l++, m++) {
					if (b[l][m] != b[i][j]) {
						break;
					}
					if (++row >= k) {
						if (b[i][j] == 'R') { isRwin = true; }
						else { isBwin = true; }
						continue line_loop;
					}
					//System.out.printf("row rd %d %d (%d)\n", l, m, row);
				}
				// ld
				for (int l=i+1, m=j-1, row=1; l < n && m >= 0; l++, m--) {
					if (b[l][m] != b[i][j]) {
						break;
					}
					if (++row >= k) {
						if (b[i][j] == 'R') { isRwin = true; }
						else { isBwin = true; }
						continue line_loop;
					}
					//System.out.printf("row ld %d %d (%d)\n", l, m, row);
				}
			}
		}
		if (!isRwin && !isBwin) {
			return "Neither";
		} else if (isRwin) {
			return (isBwin)? "Both" : "Red";
		} else {
			return "Blue";
		}
	}
}
