import static java.lang.Math.*;
import static java.math.BigInteger.*;
import static java.util.Arrays.*;
import static java.util.Collections.*;
import java.math.*;
import java.util.*;
import java.awt.Point;
import java.io.File;
import java.io.FileNotFoundException;

class Watersheds {
    public static void main(String[] args){
    	new Watersheds().run(args[0]);
    }
    private void run(String inputFile){
    	Scanner sc = null;
		try {
			sc = new Scanner(new File(inputFile));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		int numOfCases = sc.nextInt();
		for(int i=0; i < numOfCases; i++){
			// each maps(cases)
			Map map = new Map(sc.nextInt(),sc.nextInt(),sc);
			map.labelCells();
            System.out.printf("Case #%d:\n", i+1);
			map.printCells();
		}
    	
    }
}

class Map {
	Cell[][] cells = null;
	int height,width;
	static int maxAttitude = 10000;
	char label = 'a';
	static Cell emptyCell = new Cell(maxAttitude);
	public Map(int h, int w, Scanner sc){
		height = h;
		width = w;
		cells = new Cell[h][w];
		for(int y=0; y < h; y++){
			for(int x=0; x < w; x++){
				cells[y][x] = new Cell(sc.nextInt());
			}
		}
	}
	public void labelCells(){
		for(int y=0; y < height; y++){
			for(int x=0; x < width; x++){
				if(!cells[y][x].isLabeled()){
					ArrayList<Point> sinks = new ArrayList<Point>();
					NextFlow(new Point(x,y),sinks);
				}
			}
		}
	}
	public void printCells(){
		for(int y=0; y < height; y++){
			for(int x=0; x < width; x++){
				System.out.printf("%c ", cells[y][x].label);
			}
			System.out.printf("\n");
		}
	}
	private void NextFlow(Point cell, ArrayList<Point> sinks){
		Point next = cell;
		Point tmp = getNorth(cell);
		if(tmp != null && cells[tmp.y][tmp.x].attitude < cells[next.y][next.x].attitude){
			next = tmp;
		}
		tmp = getWest(cell);
		if(tmp != null && cells[tmp.y][tmp.x].attitude < cells[next.y][next.x].attitude){
			next = tmp;
		}
		tmp = getEast(cell);
		if(tmp != null && cells[tmp.y][tmp.x].attitude < cells[next.y][next.x].attitude){
			next = tmp;
		}
		tmp = getSouth(cell);
		if(tmp != null && cells[tmp.y][tmp.x].attitude < cells[next.y][next.x].attitude){
			next = tmp;
		}
		if(next == cell){
			// this is sink!
			if(!cells[cell.y][cell.x].isLabeled()){
				cells[cell.y][cell.x].label = label;
				label++;
			}
			for(int i=0; i < sinks.size(); i++){
				cells[sinks.get(i).y][sinks.get(i).x].label = cells[cell.y][cell.x].label; 
			}
			return;
		}
		sinks.add(cell);
		NextFlow(next,sinks);
	}
	private Point getNorth(Point p){
		if(p.y == 0){			return null; 				}
		else{					return new Point(p.x,p.y-1);	}
	}
	private Point getSouth(Point p){
		if(p.y == height-1){	return null;				}
		else{					return new Point(p.x,p.y+1);	}
	}
	private Point getWest(Point p){
		if(p.x == 0){			return null;				}
		else{					return new Point(p.x-1,p.y);	}
	}
	private Point getEast(Point p){
		if(p.x == width-1){		return null;				}
		else{					return new Point(p.x+1,p.y);	}
	}
}

class Cell {
	public char label;
	public int attitude;
	public Cell(int atti){
		label = '*';
		attitude = atti;
	}
	public boolean isLabeled(){
		return (label != '*');
	}
}
