package com.dakura.gcj;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Map;
import java.util.HashMap;
import java.util.Scanner;

public class ThemePark {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		new ThemePark().run(args[0]);
	}
	void run(String inputFile) {
    	Scanner sc = null;
		try {
			sc = new Scanner(new File(inputFile));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		int numOfCases = sc.nextInt();
		for(int i=0; i < numOfCases; i++){
			int numOfRuns = sc.nextInt();
			int capacity = sc.nextInt();
			int numOfGroups = sc.nextInt();
			int[] groups = new int[numOfGroups];
			for (int j=0; j < numOfGroups; j++) {
				groups[j] = sc.nextInt();
			}
			long result = calc(numOfRuns, capacity, groups);
			System.out.printf("Case #%d: %d\n", i+1, result);
		}
	}
	long calc(int numOfRuns, int capacity, int[] groups) {
		class RunInfo {
			int people;
			int nextTop;
			RunInfo(int p, int n) {
				people = p;
				nextTop = n;
			}
		}
		long result = 0;
		int top = 0;
		int room;
		Map<Integer, RunInfo> ref = new HashMap<Integer, RunInfo>();
		for (int i=0; i < numOfRuns; i++) {
			RunInfo r;
			if ((r = ref.get(top)) != null) {
				//System.out.print("hit hashmap\n");
				top = r.nextTop;
				result += r.people;
				continue;
			}
			room = capacity;
			int orgTop = top;
			for (int j=0; j < groups.length; j++) {
				if (room >= groups[top]) {
					result += groups[top];
					room -= groups[top];
					top = (top+1)%groups.length;
				} else {
					break;
				}
			}
			//System.out.printf("added hashmap %d\n",orgTop);
			ref.put(orgTop, new RunInfo(capacity-room,top));
		}
		return result;
	}
}
