import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.math.*;

public class BotTrust {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		new BotTrust().run(args[0]);
	}
	void run(String inputFile) {
    	Scanner sc = null;
		try {
			sc = new Scanner(new File(inputFile));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		int numOfCases = sc.nextInt();
		for (int i=0; i < numOfCases; i++) {
			int numOfOrders = sc.nextInt();
			Order[] orders = new Order[numOfOrders];
			for (int j=0; j < numOfOrders; j++) {
				orders[j] = new Order(sc.next(), sc.nextInt());
			}
			int result = calc(orders);
			System.out.printf("Case #%d: %d\n", i+1, result);
		}
	}
	Order nextBotOrder(String bot, Order[] orders, int from) {
		for (int i=from; i < orders.length; i++) {
			if (bot.equals(orders[i].bot)) {
				return orders[i];
			}
		}
		return null;
	}
	int calc(Order[] orders) {
		Bot bBot = new Bot("B");
		Bot oBot = new Bot("O");
		int time = 0;
		for (int i=0; i < orders.length; i++) {
			Bot thisTurn;
			Bot nextTurn;
			bBot.nextOrder = nextBotOrder(bBot.name, orders, i); 
			oBot.nextOrder = nextBotOrder(oBot.name, orders, i); 
			if (orders[i].bot.equals("B")) {	thisTurn = bBot; nextTurn = oBot;
			} else { thisTurn = oBot; nextTurn = bBot; }
			int period = Math.abs(orders[i].buttonId - thisTurn.pos) + 1;
			time += period;
			thisTurn.pos = orders[i].buttonId;
			//System.out.printf("Time#%d: %s pushed %d\n", time, thisTurn.name, thisTurn.pos);
			if (nextTurn.nextOrder != null) {
				int od = Math.min(period, Math.abs(nextTurn.nextOrder.buttonId - nextTurn.pos));
				nextTurn.pos = (nextTurn.pos > nextTurn.nextOrder.buttonId)? nextTurn.pos - od : nextTurn.pos + od;
			}
			//System.out.printf("Time#%d: B is %d, O is %d\n", time, bBot.pos, oBot.pos);
		}
		return time;
	}
	class Bot {
		String name;
		int pos;
		Order nextOrder;
		Bot(String name) {
			this.name = name;
			pos = 1;
		}
	}
	class Order {
		String bot;
		int buttonId;
		Order(String bot, int buttonId) {
			this.bot = bot;
			this.buttonId = buttonId;
		}
	}

}
