import static java.lang.Math.*;
import static java.math.BigInteger.*;
import static java.util.Arrays.*;
import static java.util.Collections.*;
import java.math.*;
import java.util.*;
import java.io.File;
import java.io.FileNotFoundException;

class AlienLanguage {
    public static void main(String[] args){
    	new AlienLanguage().run(args[0]);
    }
    String[] words;
    int wordsLen;
    int numOfWords;
    private void run(String inputFile){
    	Scanner sc = null;
		try {
			sc = new Scanner(new File(inputFile));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
    	// read length of a word
    	wordsLen = sc.nextInt();
    	
        // read number of words
    	numOfWords = sc.nextInt();

        // read number of cases
    	int numOfCase = sc.nextInt();

        // read words
        words = new String[numOfWords];
    	for(int i=0; i < numOfWords; i++){
    		words[i] = sc.next();
    	}

        // for each test case
        for(int j=0; j < numOfCase; j++){
            // read a signal
        	String signal = sc.next();
            int result = countPossibility(signal);

            // report it.
            System.out.printf("Case #%d: %d\n", j+1, result);
        }
    }
    private int countPossibility(String signal){
        int possibility = 0;

        // for each words
        for(int i=0; i < words.length; i++){

            // for each character
        	int j;
            for(j=0; j < wordsLen; j++){
                String letters = getLettersAt(signal,j);
                if(!checkPossibility(letters,words[i].charAt(j))){
                    // impossible!
                    break;
                }
            }
            if(j == wordsLen){
            	// possible!
            	possibility++;
            }
        }
        return possibility;
    }
    private String getLettersAt(String s, int idx){
    	int j = 0;
        for(int i=0; i < idx; i++){
        	// i is index of letter, j is index of byte
            if(s.charAt(j) == '('){
            	j = s.indexOf(')',j)+1;
            }else{
                j++;
            }
        }
        if(s.charAt(j) == '('){
        	return s.substring(j+1,s.indexOf(')',j));
        }else{
        	return s.substring(j,j+1);
        }
    }
    private boolean checkPossibility(String s, char c){
        return (s.indexOf(c) >= 0);
    }
}