import java.io.*;
import java.util.*;

import javax.management.RuntimeErrorException;

import static java.lang.Math.*;

/**
 * Google Code Jam 2011
 * Round 1B
 * Problem B
 * 
 * @author dalex
 */
public class B implements Runnable {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = new StringTokenizer("");
	
	String readString() throws IOException {
		while (!tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}
	
	int readInt() throws IOException {
		return Integer.parseInt(readString());
	}
	
	long readLong() throws IOException {
		return Long.parseLong(readString());
	}
	
	double readDouble() throws IOException {
		return Double.parseDouble(readString());
	}
	
	@Override
	public void run() {
		try {
			long t1 = System.currentTimeMillis();
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			Locale.setDefault(Locale.US);
			int tests = readInt();
			for (int t = 1; t <= tests; t++) {
				out.printf("Case #%d: ", t);
				solve();
				if (t % 50 == 0) System.err.println("case " + t + " completed");
			}
			
			in.close();
			out.close();
			long t2 = System.currentTimeMillis();
			System.err.println("Time = " + (t2 - t1));
		} catch (Throwable e) {
			e.printStackTrace(System.err);
			System.exit(-1);
		}
	}
	
	public static void main(String[] args) {
		new Thread(null, new B(), "", 256 * (1L << 20)).start();
	}
	
	// solution
	
	final double EPS = 1e-12;
	
	void solve() throws IOException {
		int n = readInt();
		long d = readInt();
		long[] x = new long[n];
		int[] c = new int[n];
		int all = 0;
		for (int i = 0; i < n; i++) {
			x[i] = readLong();
			c[i] = readInt();
			all += c[i];
		}
		if (all == 1) {
			out.println(0.0);
			return;
		}
		long[] p = new long[all];
		int z = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < c[i]; j++) {
				p[z++] = x[i];
			}
		}
		Arrays.sort(p);
		if (p.length != all || p.length != z || all != z) throw new RuntimeException();
		
		double left = 0.0, right = 1e20;
		for (int iter = 0; iter < 111; iter++) {
			boolean can = true;
			double time = (left + right) / 2;
//			if (time < 3) {
//				System.err.print("");
//			}
			double y = p[0] - time;
			for (int i = 1; i < all; i++) {
				if (p[i] + time - d < y) {
					can = false;
					break;
				}
				double cur = p[i] - time;
				if (cur - y >= d) {
					y = cur;
					continue;
				}
				if (cur - y < d) {
					y = y + d;
					continue;
				}
				throw new RuntimeException();
			}
			if (can) {
				right = time;
			} else {
				left = time;
			}
		}
		double ans = (left + right) / 2;
		out.printf("%.12f\n", ans);
	}
	
}
