
import java.io.*;
import java.util.*;
import static java.lang.Math.*;

/**
 * Google Code Jam 2011
 * Round 3
 * Problem D
 * 
 * @author dalex
 */
public class D implements Runnable {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = new StringTokenizer("");
	
	String readString() throws IOException {
		while (!tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}
	
	int readInt() throws IOException {
		return Integer.parseInt(readString());
	}
	
	long readLong() throws IOException {
		return Long.parseLong(readString());
	}
	
	double readDouble() throws IOException {
		return Double.parseDouble(readString());
	}
	
	@Override
	public void run() {
		try {
			long t1 = System.currentTimeMillis();
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			Locale.setDefault(Locale.US);
			int tests = readInt();
			int p = max(1, tests / 10);
			for (int t = 1; t <= tests; t++) {
				out.printf("Case #%d: ", t);
				solve();
				if (t % p == 0) System.err.println("Test " + t + " of " + tests + " completed");
			}
			in.close();
			out.close();
			long t2 = System.currentTimeMillis();
			System.err.println("Time = " + (t2 - t1));
		} catch (Throwable e) {
			e.printStackTrace(System.err);
			System.exit(-1);
		}
	}
	
	public static void main(String[] args) {
		new Thread(null, new D(), "", 256 * (1L << 20)).start();
	}
	
	// solution
	
	void solve() throws IOException {
		char[] s = readString().toCharArray();
		int[] a = new int[20];
		int n = 0;
		for (int i = 0; i < s.length; i++) {
			if (s[i] == '?') {
				a[n++] = s.length - i - 1;
			}
		}
		long p = 0;
		for (int i = 0; i < s.length; i++) {
			if (s[i] == '1') {
				p |= (1L << (s.length - i - 1));
			}
		}
		for (int mask = 0; mask < (1 << n); mask++) {
			long test = p;
			for (int i = 0; i < n; i++) {
				if (((1 << i) & mask) != 0) {
					test |= (1L << a[i]);
				}
			}
			if (isSquare(test)) {
				for (int i = s.length - 1; i >= 0; i--) {
					if ((test | (1L << i)) == test) {
						out.print(1);
					} else {
						out.print(0);
					}
				}
				out.println();
				return;
			}
		}
	}
	
	boolean isSquare(long p) {
		long left = 0, right = 1L << 31, mid = -1;
		for (int it = 0; it < 111; it++) {
			mid = (left + right) >> 1;
			if (mid * mid == p) return true;
			if (mid * mid < p) {
				left = mid;
			} else {
				right = mid;
			}
		}
		return false;
	}
	
}
