
import java.io.*;
import java.util.*;
import static java.lang.Math.*;

/**
 * Google Code Jam 2011
 * Round 3
 * Problem B
 * 
 * @author dalex
 */
public class B implements Runnable {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = new StringTokenizer("");
	
	String readString() throws IOException {
		while (!tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}
	
	int readInt() throws IOException {
		return Integer.parseInt(readString());
	}
	
	long readLong() throws IOException {
		return Long.parseLong(readString());
	}
	
	double readDouble() throws IOException {
		return Double.parseDouble(readString());
	}
	
	@Override
	public void run() {
		try {
			long t1 = System.currentTimeMillis();
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			Locale.setDefault(Locale.US);
			int tests = readInt();
			int p = max(1, tests / 10);
			for (int t = 1; t <= tests; t++) {
				out.printf("Case #%d: ", t);
				solve();
				if (t % p == 0) System.err.println("Test " + t + " of " + tests + " completed");
			}
			in.close();
			out.close();
			long t2 = System.currentTimeMillis();
			System.err.println("Time = " + (t2 - t1));
		} catch (Throwable e) {
			e.printStackTrace(System.err);
			System.exit(-1);
		}
	}
	
	public static void main(String[] args) {
		new Thread(null, new B(), "", 256 * (1L << 20)).start();
	}
	
	// solution
	
	int n;
	int[] a;
	
	int ans;
	
	void solve() throws IOException {
		n = readInt();
		if (n == 0) {
			out.println(0);
			return;
		}
		a = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = readInt();
		}
		ans = 0;
		gen(0, n-1);
		out.println(ans);
	}
	
	void gen(int L, int R) {
		if (L == R) {
			ans = max(ans, getAnswer());
		} else {
			for (int i = L; i <= R; i++) {
				swap(i, L);
				gen(L+1, R);
				swap(i, L);
			}
		}
	}
	
	void swap(int i, int j) {
		int t = a[i];
		a[i] = a[j];
		a[j] = t;
	}
	
	int getAnswer() {
		int i = 0;
		int best = 100500, cur = 1;
		while (i < n) {
			while (i+1 < n && a[i]+1 == a[i+1]) {
				i++;
				cur++;
			}
			best = min(best, cur);
			i++;
			cur = 1;
		}
		return best;
	}
	
}
