
import java.io.*;
import java.util.*;
import static java.lang.Math.*;

/**
 * Google Code Jam 2011
 * Round 2
 * Problem C
 * 
 * @author dalex
 */
public class C implements Runnable {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = new StringTokenizer("");
	
	String readString() throws IOException {
		while (!tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}
	
	int readInt() throws IOException {
		return Integer.parseInt(readString());
	}
	
	long readLong() throws IOException {
		return Long.parseLong(readString());
	}
	
	double readDouble() throws IOException {
		return Double.parseDouble(readString());
	}
	
	@Override
	public void run() {
		try {
			long t1 = System.currentTimeMillis();
			in = new BufferedReader(new FileReader("input.txt"));
			System.err.println(log(2,8));
			System.err.println(log(3,8));
			System.err.println(log(4,8));
			out = new PrintWriter("output.txt");
			Locale.setDefault(Locale.US);
			int tests = readInt();
			int p = max(1, tests / 10);
			for (int t = 1; t <= tests; t++) {
				out.printf("Case #%d: ", t);
				solve();
				if (t % p == 0) System.err.println("Test " + t + " of " + tests + " completed");
			}
			in.close();
			out.close();
			long t2 = System.currentTimeMillis();
			System.err.println("Time = " + (t2 - t1));
		} catch (Throwable e) {
			e.printStackTrace(System.err);
			System.exit(-1);
		}
	}
	
	public static void main(String[] args) {
		new Thread(null, new C(), "", 256 * (1L << 20)).start();
	}
	
	// solution
	
	int[] getPrimes(int max) {
		boolean[] p = new boolean[max + 1];
		for (int i = 2; i <= max; i++) {
			p[i] = true;
		}
		int count = 0;
		for (long i = 2; i <= max; i++) {
			if (p[(int) i]) {
				count++;
				for (long j = i * i; j <= max; j+= i) {
					p[(int)j] = false;
				}
			}
		}
		int[] a = new int[count];
		for (int i = 2, j = 0; i <= max; i++) {
			if (p[i]) {
				a[j++] = i;
			}
		}
		return a;
	}
	
	int[] p = getPrimes(1000 * 1000);
	
	void solve() throws IOException {
		long n = readLong();
		if (n == 1) {
			out.println(0);
			return;
		}
		long ans = 0;
		for (int x : p) {
			if (x > n) break;
			//int log = (int) floor(log(n) / log(x));
			int log = log(x, n);
			ans += log - 1;
		}
		out.println(ans + 1);
	}
	
	int log(long x, long max) {
		int count = 0;
		long b = x;
		while (b <= max) {
			b *= x;
			count++;
		}
		return count;
	}
	
}
