import java.io.*;
import java.util.*;
import static java.lang.Math.*;

/**
 * Google Code Jam 2011
 * Round 1B
 * Problem A
 * 
 * @author dalex
 */
public class A implements Runnable {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = new StringTokenizer("");
	
	String readString() throws IOException {
		while (!tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}
	
	int readInt() throws IOException {
		return Integer.parseInt(readString());
	}
	
	long readLong() throws IOException {
		return Long.parseLong(readString());
	}
	
	double readDouble() throws IOException {
		return Double.parseDouble(readString());
	}
	
	@Override
	public void run() {
		try {
			long t1 = System.currentTimeMillis();
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			Locale.setDefault(Locale.US);
			int tests = readInt();
			for (int t = 1; t <= tests; t++) {
				out.printf("Case #%d: ", t);
				solve();
			}
			in.close();
			out.close();
			long t2 = System.currentTimeMillis();
			System.err.println("Time = " + (t2 - t1));
		} catch (Throwable e) {
			e.printStackTrace(System.err);
			System.exit(-1);
		}
	}
	
	public static void main(String[] args) {
		new Thread(null, new A(), "", 256 * (1L << 20)).start();
	}
	
	// solution
	
	int n;
	int[][] a;
	double[] wp;
	double[] owp;
	double[] oowp;
	int[] played;
	
	void solve() throws IOException {
		n = readInt();
		a = new int[n][n];
		for (int i = 0; i < n; i++) {
			String s = readString();
			for (int j = 0; j < n; j++) {
				char c = s.charAt(j);
				if (c == '1') a[i][j] = 1;
				else if (c == '.') a[i][j] = -1;
			}
		}
		played = new int[n];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i != j && a[i][j] != -1) {
					played[i]++;
				}
			}
		}
		wp = new double[n];
		owp = new double[n];
		oowp = new double[n];
		for (int i = 0; i < n; i++) {
			wp[i] = wp(i);
			System.err.print(wp[i] + " ");
		}
		System.err.println();
		for (int i = 0; i < n; i++) {
			owp[i] = owp(i);
			System.err.print(owp[i] + " ");
		}
		System.err.println();
		for (int i = 0; i < n; i++) {
			oowp[i] = oowp(i);
			System.err.print(oowp[i] + " ");
		}
		System.err.println();
		
		out.println();
		for (int i = 0; i < n; i++) {
			double ans = 0.25*wp[i] + 0.5*owp[i] + 0.25*oowp[i];
			out.printf("%.12f\n", ans);
		}
		System.err.println();
	}
	
	double wp(int k) {
		if (played[k] == 0) return 0;
		int sum = 0;
		for (int i = 0; i < n; i++) {
			if (i == k) continue;
			if (a[k][i] == -1) continue;
			sum += a[k][i];
		}
		return ((double) sum) / played[k];
	}
	
	double owp(int k) {
		if (played[k] == 0) return 0;
		int[] t = new int[n];
		Arrays.fill(t, -1);
		for (int i = 0; i < n; i++) {
			if (a[i][k] >= 0) {
				t[i] = a[i][k];
				a[i][k] = -1;
				played[i]--;
			}
		}
		double ans = 0;
		for (int i = 0; i < n; i++) {
			if (i == k) continue;
			if (a[k][i] == -1) continue;
			ans += wp(i);
		}
		ans /= played[k];
		for (int i = 0; i < n; i++) {
			if (t[i] >= 0) {
				a[i][k] = t[i];
				played[i]++;
			}
		}
		return ans;
	}
	
	double oowp(int k) {
		if (played[k] == 0) return 0;
		double ans = 0;
		for (int i = 0; i < n; i++) {
			if (i == k) continue;
			if (a[k][i] == -1) continue;
			ans += owp[i];
		}
		ans /= played[k];
		return ans;
	}
	
}
