import java.util.ArrayDeque;
import java.util.BitSet;
import java.util.HashSet;
import java.util.Queue;
import java.util.Scanner;

public class Pancakes {

	private static int k;
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		
		int t = in.nextInt();
		
		for (int tt = 0 ; tt < t; tt++) {
			HashSet<BitSet> vis = new HashSet<BitSet>();
			String s = in.next();
			int sl = s.length();
			BitSet p = new BitSet(sl);
			for (int ss = 0; ss < sl; ss++) {
				p.set(ss, s.charAt(ss) == '+');
			}
			vis.add(p);
			
			k = in.nextInt();
			
			Queue<State> q = new ArrayDeque<State>();
			q.add(new State(p));
			
			int min = -1;
			while (!q.isEmpty()) {
				State st = q.poll();
				
				//check fixed
				if (st.p.cardinality() == sl) {
					min = st.steps;
					continue;
				}
				
				for (int i = 0; i <= sl-k; i++) {
					State st2 = st.clone();
					st2.flip(i);
					
					if (!vis.contains(st2.p)) {
						vis.add(st2.p);
						q.add(st2);
					}
				}
			}
			
			if (min == -1) {
				System.out.println("Case #" + (tt+1) + ": IMPOSSBILE");				
			} else {
				System.out.println("Case #" + (tt+1) + ": " + min);
			}
		}		
	}
	
	private static class State {
		
		int steps = 0;
		BitSet p;
		
		public State(BitSet p) {
			this.p = (BitSet) p.clone();
		}
		
		public State clone() {
			State copy = new State(this.p);
			copy.steps = this.steps;
			return copy;
		}
		
		public void flip (int s) {
			p.flip(s, s+k);
			steps++;
		}
	}

}
