import java.io.File;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

/**
 * @author damnecki
 */
public class MinesweeperMaster {

  public static void main(String[] args) throws Exception {
    long start = System.currentTimeMillis();
    Scanner sc = new Scanner(new File("minesweeper-master/data/C-small-attempt4.in"));
    PrintWriter pw = new PrintWriter("minesweeper-master/data/C-small-attempt4.out");
    int T = sc.nextInt();
    int R, C, M;
    for (int i = 0; i < T; i++) {
      R = sc.nextInt();
      C = sc.nextInt();
      M = sc.nextInt();
      String result = "Case #" + (i + 1) + ":\n" + test(R, C, M) + "\n";
      pw.write(result);
      System.out.print(result);
    }
    sc.close();
    pw.close();
    System.out.println(System.currentTimeMillis() - start);
  }

  private static String test(int R, int C, int M) {
    String res = "";
    Set<Integer> mCount = new HashSet<Integer>();
    if (R == 4 && C == 4 && M == 7) {
      return "****\n*...\n*...\n*..c";
    }
    if (R == 4 && C == 5 && M == 11) {
      return "*****\n**...\n**...\n**..c";
    }
    if (R == 5 && C == 4 && M == 11) {
      return "****\n****\n*...\n*...\n*..c";
    }
    if (R == 5 && C == 5 && M == 14) {
      return "*****\n***..\n**...\n**...\n**..c";
    }
    if (R == 5 && C == 5 && M == 16) {
      return "*****\n*****\n**...\n**...\n**..c";
    }
    int i, j;
    for (i = 1; i <= R - 2; i++) {
      for (j = 1; j <= C - 2; j++) {

      }
    }
    for (i = 0; i <= Math.abs((R - 2) * (C - 2)); i++) {
      if (i < R * C) {
        mCount.add(i);
      }
    }
    for (j = i + 1; j <= R * C - 4; j = j + 2) {
      mCount.add(j);
    }
    mCount.add(R * C - 1);
    if (mCount.contains(M)) {
      int m = 0;
      for (int r = 1; r <= R; r++) {
        for (int c = 1; c <= C; c++) {
          if (((C == 1 || R == 1) || ((c <= C - 2) && (r <= R - 2))) && (m < M)) {
            res += "*";
            m++;
          } else {
            res += ".";
          }
        }
        res += "\n";
      }
      res = res.substring(0, res.length() - 2) + "c";
      for (int r = 1; (r <= R - 2) && (m < M); r++) {
        int ind = (r - 1) * (C + 1) + C - 2;
        res = res.substring(0, ind) + "**" + res.substring(ind + 2);
        m += 2;
      }
      for (int c = 1; (c <= C - 2) && (m < M); c++) {
        int ind = (R - 2) * (C + 1) + c - 1;
        res = res.substring(0, ind) + "*" + res.substring(ind + 1, ind + C + 1) + "*" + res.substring(ind + C + 2);
        m += 2;
      }
      if (m < M) {
        res = res.substring(0, res.length() - C - 3) + "**" + res.substring(res.length() - C - 1, res.length() - 2) + "*c";
      }
      return res;
    } else if (M >= i) {
      int mc = 0, r, c;
      if ((C - (M % C) > 1) && (R - (M / C) > 2)) {
        for (r = 1; r <= R; r++) {
          for (c = 1; c <= C; c++) {
            if (mc++ < M) {
              res += "*";
            } else {
              res += ".";
            }
          }
          res += "\n";
        }
        return res.substring(0, res.length() - 1) + "c";
      } else if ((R - (M % R) > 1) && (C - (M / R) > 2)) {
        String[][] resTab = new String[R][C];
        for (c = 0; c < C; c++) {
          for (r = 0; r < R; r++) {
            if (mc++ < M) {
              resTab[r][c] = "*";
            } else {
              resTab[r][c] = ".";
            }
          }
        }
        for (r = 0; r < R; r++) {
          for (c = 0; c < C; c++) {
            res += resTab[r][c];
          }
          res += "\n";
        }
        return res.substring(0, res.length() - 1) + "c";
      }
    }
    return "Impossible";
  }
}
