import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.*;

public class Dijkstra {

  private static final Map<String, String> q = new HashMap<String, String>();
  static {
    q.put("11", "1");
    q.put("1i", "i");
    q.put("1j", "j");
    q.put("1k", "k");
    q.put("i1", "i");
    q.put("ii", "-1");
    q.put("ij", "k");
    q.put("ik", "-j");
    q.put("j1", "j");
    q.put("ji", "-k");
    q.put("jj", "-1");
    q.put("jk", "i");
    q.put("k1", "k");
    q.put("ki", "j");
    q.put("kj", "-i");
    q.put("kk", "-1");
  }

  public static void main(String[] args) throws Exception {
    Scanner sc = new Scanner(new File("data/dijkstra/C-small-attempt2.in"));
    BufferedWriter bw = new BufferedWriter(new FileWriter(new File("data/dijkstra/out6")));
    int t = sc.nextInt();
    for (int i = 0; i < t; i++) {
      double l = sc.nextDouble();
      double x = sc.nextDouble();
      List<String> strInput = Arrays.asList(sc.next().split(""));
      List<String> str = new ArrayList<String>();
      for (int j = 0; j < x; j++) {
        str.addAll(strInput);
      }
      String r = calc(str);
      //System.out.println("Case #" + (i + 1) + ": " + r);
      bw.write("Case #" + (i + 1) + ": " + r + "\n");
    }
    bw.close();
  }

  private static String calc(List<String> str) {
    String r = "NO";
    int c1 = 0, c2 = 0;
    int start1 = 0;
    String seed1 = null, seed2 = null;
    while (c1 > -1) {
      c1 = reducedToAtIndex(str, start1, seed1, "i");
      if (c1 > -1) {
        int start2 = c1 + 1;
        while (c2 > -1) {
          c2 = reducedToAtIndex(str, start2, seed2, "j");
          if (c2 > -1 && (c2 + 1 < str.size()) && reduce(str.subList(c2 + 1, str.size())).equals("k")) {
            r = "YES";
            break;
          }
          start2 = c2 + 1;
          seed2 = "j";
        }
      }
      if (r.equals("YES")) {
        break;
      }
      start1 = c1 + 1;
      seed1 = "i";
    }
    return r;
  }

  private static int reducedToAtIndex(List<String> str, int start, String seed, String expectedReduce) {
    if (start >= str.size()) {
      return -1;
    }
    String res;
    if (seed != null) {
      res = reduce(seed, str.get(start));
    } else {
      res = str.get(start);
    }
    if (res.equals(expectedReduce)) {
      return start;
    }
    int i = start + 1;
    while (i < str.size()) {
      res = reduce(res, str.get(i));
      if (res.equals(expectedReduce)) {
        return i;
      }
      i++;
    }
    return -1;
  }

  private static String reduce(List<String> str) {
    String res = str.get(0);
    for (int i = 1; i < str.size(); i++) {
      res = reduce(res, str.get(i));
    }
    return res;
  }

  private static String reduce(String a, String b) {
    String ab = a + b;
    boolean neg = (ab.length() == 3);
    String res = q.get(ab.replaceAll("\\-", ""));
    if (neg) {
      if (res.length() == 1) {
        return "-" + res;
      }
      return res.substring(1);
    }
    return res;
  }
}
