package uk.co.damon_hall.pancakes;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStreamReader;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        // Use file or piped input
        if(args.length > 0)
        {
            try
            {
                System.setIn(new FileInputStream(args[0]));
            }
            catch (FileNotFoundException ex)
            {
                System.out.println("FAILED TO LOAD PROVIDED FILE: " + args[0]);
            }

        }
        // Use a scanner to read the input
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        for (int i = 1; i <= t; ++i) {
            Main.solve(i, in.next().toCharArray(), in.nextInt());
        }
    }

    private static char flip(char pancake){
        return pancake == '-' ? '+' : '-';
    }

    private static void solve(int caseNumber, char[] pancakes, int flipper) {
        int flips = 0;
        for(int i = 0; i < pancakes.length; i++)
        {
            // Should flip?
            if(pancakes[i] == '-')
            {
                // Can flip?
                if(i + flipper > pancakes.length)
                {
                    // Cannot flip and therefore cannot complete
                    System.out.println("Case #" + caseNumber + ": IMPOSSIBLE");
                    return;
                }
                // Otherwise flip the pancakes
                for(int j = 0; j < flipper; j++)
                {
                    pancakes[i + j] = flip(pancakes[i + j]);
                }
                // Increment flip counter
                flips += 1;
            }
        }
        System.out.println("Case #" + caseNumber + ": " + flips);
    }
}
