package uk.co.damon_hall.pancakes;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStreamReader;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        // Use file or piped input
        if(args.length > 0)
        {
            try
            {
                System.setIn(new FileInputStream(args[0]));
            }
            catch (FileNotFoundException ex)
            {
                System.out.println("FAILED TO LOAD PROVIDED FILE: " + args[0]);
            }

        }
        // Use a scanner to read the input
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        for (int i = 1; i <= t; ++i) {
            Main.solve(i, in.next("[0-9]+").toCharArray());
        }
    }

    private static void solve(int caseNumber, char[] number) {
        // Find the last positive index
        int positiveUntil = number.length;
        for(int i = number.length - 1; i > 0; i--)
        {
            char before = number[i - 1];
            char after = number[i];
            if(i == positiveUntil)
            {
                after -= 1;
            }
            // Ensure that the sequence is ascending else move the positiveUntil index
            if(before > after)
            {
                positiveUntil = i - 1;
            }
        }
        // Then rewrite the number so that it is always ascending
        StringBuilder stringBuilder = new StringBuilder();
        for(int i = 0; i < number.length; i++)
        {
            if(i == positiveUntil)
            {
                char result = (char)(number[i] - 1);
                if(result != '0')
                {
                    stringBuilder.append(result);
                }
            }
            else if(i > positiveUntil)
            {
                stringBuilder.append('9');
            }
            else
            {
                stringBuilder.append(number[i]);
            }
        }
        System.out.println("Case #" + caseNumber + ": " + stringBuilder.toString());
    }
}
