package uk.co.damon_hall.pancakes;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStreamReader;
import java.util.*;

public class Main {
    public static void main(String[] args) {
        // Use file or piped input
        if(args.length > 0)
        {
            try
            {
                System.setIn(new FileInputStream(args[0]));
            }
            catch (FileNotFoundException ex)
            {
                System.out.println("FAILED TO LOAD PROVIDED FILE: " + args[0]);
            }

        }
        // Use a scanner to read the input
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        for (int i = 1; i <= t; ++i) {
            long n = in.nextLong();
            long k = in.nextLong();
            Main.solve(i, n, k);
        }
    }

    private static Pair<Long> split(long section, PriorityQueue<Long> set){
        section -= 1;
        long split = section / 2;
        Pair<Long> result = new Pair<>(split, section - split);
        // Add items to set?
        if(result.left > 1)
        {
            set.add(result.left);
            set.add(result.right);
        }
        else if(result.right > 1)
        {
            set.add(result.right);
        }
        // Return the resulting pair
        return result;
    }

    private static void solve(int caseNumber, long stalls, long people) {
        PriorityQueue<Long> spaces = new PriorityQueue<Long>(500000, Comparator.reverseOrder());
        spaces.add(stalls);
        // Place all the people
        Pair<Long> result = null;
        for(long i = 0; i < people; i++)
        {
            Long space = spaces.poll();
            if(space != null)
            {
                result = Main.split(space, spaces);
            }
            else
            {
                result = new Pair<>(new Long(0));
            }
        }
        System.out.println("Case #" + caseNumber + ": " + result);
    }
}
