package fun.codeslam;

import java.io.InputStreamReader;
import java.util.Scanner;

public class Main {
	public static void main(String[] args) {
		Scanner scanner = new Scanner(new InputStreamReader(System.in));

		Integer testCaseCount = scanner.nextInt();

		for (Integer testCaseNumber = 1; testCaseNumber <= testCaseCount; testCaseNumber++) {
			System.out.print("Case #" + testCaseNumber + ": ");
			System.out.print(solve(scanner) + "\n");
		}
	}

	private static String solve(Scanner scanner) {
		Field field = new Field(scanner);

		if (field.won(FieldValue.X)) {
			return "X won";
		} else if (field.won(FieldValue.O)) {
			return "O won";
		} else if (field.isFull()) {
			return "Draw";
		}
		return "Game has not completed";
	}
}

class Field {

	private static final int WIDTH = 4;

	FieldValue[][] fieldValues = new FieldValue[WIDTH][WIDTH];

	public Field(Scanner scanner) {
		scanner.nextLine();
		for (int x = 0; x < WIDTH; x++) {
			String line = scanner.nextLine();
			for (int y = 0; y < WIDTH; y++) {
				fieldValues[x][y] = FieldValue.parse(line.charAt(y));
			}
		}
	}

	public boolean isFull() {
		for (int x = 0; x < WIDTH; x++) {
			for (int y = 0; y < WIDTH; y++) {
				if (FieldValue.E.equals(fieldValues[x][y])) {
					return false;
				}
			}
		}
		return true;
	}

	public boolean won(FieldValue fieldValue) {
		for (int line = 0; line < WIDTH; line++) {
			int matches = 0;
			for (int field = 0; field < WIDTH; field++) {
				matches += fieldValues[line][field].matches(fieldValue) ? 1 : 0;
			}
			if (matches == 4)
				return true;
		}
		for (int line = 0; line < WIDTH; line++) {
			int matches = 0;
			for (int field = 0; field < WIDTH; field++) {
				matches += fieldValues[field][line].matches(fieldValue) ? 1 : 0;
			}
			if (matches == 4)
				return true;
		}
		if (fieldValues[0][0].matches(fieldValue)
				&& fieldValues[1][1].matches(fieldValue)
				&& fieldValues[2][2].matches(fieldValue)
				&& fieldValues[3][3].matches(fieldValue)) {
			return true;
		}
		if (fieldValues[3][0].matches(fieldValue)
				&& fieldValues[2][1].matches(fieldValue)
				&& fieldValues[1][2].matches(fieldValue)
				&& fieldValues[0][3].matches(fieldValue)) {
			return true;
		}
		return false;
	}
}

enum FieldValue {
	X {
		@Override
		public boolean matches(FieldValue otherValue) {
			return otherValue.equals(X) || otherValue.equals(T);
		}
	},
	O {
		@Override
		public boolean matches(FieldValue otherValue) {
			return otherValue.equals(O) || otherValue.equals(T);
		}
	},
	T {
		@Override
		public boolean matches(FieldValue otherValue) {
			return true;
		}
	},
	E {
		@Override
		public boolean matches(FieldValue otherValue) {
			return false;
		}
	};

	static FieldValue parse(char c) {
		switch (c) {
		case 'X':
			return X;
		case 'O':
			return O;
		case 'T':
			return T;
		default:
			return E;
		}
	}

	abstract public boolean matches(FieldValue otherValue);
}