package fun.codeslam;

import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.Scanner;

public class Main {
	public static void main(String[] args) {
		Scanner scanner = new Scanner(new InputStreamReader(System.in));

		Integer testCaseCount = scanner.nextInt();

		for (Integer testCaseNumber = 1; testCaseNumber <= testCaseCount; testCaseNumber++) {
			System.out.print("Case #" + testCaseNumber + ": ");
			System.out.print(solve(scanner) + "\n");
		}
	}

	private static String solve(Scanner scanner) {
		Range field = new Range(scanner);
		return field.matches().toString();
	}
}

class Range {

	BigInteger min;
	BigInteger max;

	public Range(Scanner scanner) {
		min = scanner.nextBigInteger();
		max = scanner.nextBigInteger();
	}

	public BigInteger matches() {
		BigInteger first = sqrt(min);
		BigInteger last = sqrt(max);
		BigInteger matches = BigInteger.ZERO;
		for (BigInteger i = first; i.compareTo(last) != 1; i = i.add(BigInteger.ONE)) {
			if (isPalindrome(i)) {
				BigInteger square = i.multiply(i);
				if (isPalindrome(square) && square.compareTo(min) != -1) {
					matches = matches.add(BigInteger.ONE);
				}
			}
		}
		return matches;
	}

	private boolean isPalindrome(BigInteger number) {
		String word = number.toString();
		int length = word.length();
		int halfLength = length / 2;
		for (int i = 0; i < halfLength; i++) {
			if (word.charAt(i) != word.charAt(length - 1 - i)) {
				return false;
			}
		}
		return true;
	}

    private static BigInteger sqrt(BigInteger n) {
    	BigInteger BigIntegerTWO = BigInteger.valueOf(2);
        BigInteger result = n.divide(BigIntegerTWO).add(BigInteger.ONE);
        BigInteger help = result.add(BigInteger.ONE);
        //while (result*result > x || (result+1)*(result+1)< x)
        while (result.multiply(result).compareTo(n) > 0 || help.multiply(help).compareTo(n) < 0) {
            result = result.add(n.divide(result)).divide(BigIntegerTWO);
            help = result.add(BigInteger.ONE);
        }
        return result;
    }

}