package fun.codeslam;

import java.io.InputStreamReader;
import java.util.Scanner;

public class Main {
	public static void main(String[] args) {
		Scanner scanner = new Scanner(new InputStreamReader(System.in));

		Integer testCaseCount = scanner.nextInt();

		for (Integer testCaseNumber = 1; testCaseNumber <= testCaseCount; testCaseNumber++) {
			System.out.print("Case #" + testCaseNumber + ": ");
			System.out.print(solve(scanner) + "\n");
		}
	}

	private static String solve(Scanner scanner) {
		Field field = new Field(scanner);
		if (field.possible()) {
			return "YES";
		}
		return "NO";
	}
}

class Field {

	int rowsCount;
	int columnsCount;
	
	int[][] heights;

	public Field(Scanner scanner) {
		
		rowsCount = scanner.nextInt();
		columnsCount = scanner.nextInt();
		
		heights = new int[rowsCount][columnsCount];

		for (int rowNumber = 0; rowNumber < rowsCount; rowNumber++) {
			for (int columnNumber = 0; columnNumber < columnsCount; columnNumber++) {
				heights[rowNumber][columnNumber] = scanner.nextInt();
			}
		}
	}

	public boolean possible() {
		boolean[][] levelReached = new boolean[rowsCount][columnsCount];

		for (int rowNumber = 0; rowNumber < rowsCount; rowNumber++) {
			int level = highestHeightsRow(rowNumber);
			for (int columnNumber = 0; columnNumber < columnsCount; columnNumber++) {
				if (heights[rowNumber][columnNumber] == level) {
					levelReached[rowNumber][columnNumber] = true;
				}
			}
		}
		for (int columnNumber = 0; columnNumber < columnsCount; columnNumber++) {
			int level = highestHeightsColumn(columnNumber);
			for (int rowNumber = 0; rowNumber < rowsCount; rowNumber++) {
				if (heights[rowNumber][columnNumber] == level) {
					levelReached[rowNumber][columnNumber] = true;
				}
			}
		}

		for (int rowNumber = 0; rowNumber < rowsCount; rowNumber++) {
			for (int columnNumber = 0; columnNumber < columnsCount; columnNumber++) {
				if (!levelReached[rowNumber][columnNumber]) {
					return false;
				}
			}
		}

		return true;
	}
	
	private int highestHeightsRow(int rowNumber) {
		int height = 0;
		for (int i=0; i<columnsCount; i++) {
			height = height < heights[rowNumber][i] ? heights[rowNumber][i] : height; 
		}
		return height;
	}
	
	private int highestHeightsColumn(int columnNumber) {
		int height = 0;
		for (int i=0; i<rowsCount; i++) {
			height = height < heights[i][columnNumber] ? heights[i][columnNumber] : height; 
		}
		return height;
	}
}