import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class C {
	Scanner sc;
	PrintWriter pw;
	
	int[][] a = new int[8][8];
	public void init() {
		int[][] b = 
			{{0,1,2,3},
			 {1,4,3,6},
			 {2,7,4,1},
			 {3,2,5,4}};
		for (int i=0; i<4; i++) {
			for (int j=0; j<4; j++) {
				a[i][j] = b[i][j];
				a[i][j+4] = (b[i][j] + 4) % 8;
				a[i+4][j] = (b[i][j] + 4) % 8;
				a[i+4][j+4] = b[i][j];
			}
		}
	}
	
	int c2n(char c) {
	   return c-'i'+1;
	}
	
	public boolean checkProduct(String l, long x) {
	   int p = 0, pAll = 0;
	   for (int i = 0; i < l.length(); i++) 
	      p = a[p][c2n(l.charAt(i))];
	   for (int i = 0; i < x%4; i++) 
	      pAll = a[pAll][p];
	   return pAll == 4;
	}
	
	public int findFirst(String s, int val) {
	   int crtVal = 0;
	   for (int i=0; i<s.length(); i++) {
	      crtVal = a[crtVal][c2n(s.charAt(i))];
	      if (crtVal == val) return (i+1);
	   }
	   return -1;
	}

	public int findLast(String s, int val) {
      int crtVal = 0;
      for (int i=s.length()-1; i>=0; i--) {
         crtVal = a[c2n(s.charAt(i))][crtVal];
         if (crtVal == val) return (s.length()-i);
      }
      return -1;
   }
	
	public String solve() {
		int n = sc.nextInt(); 
		long x = sc.nextLong();
		sc.nextLine();
		String l = sc.nextLine();
		if (l.length() != n) throw new AssertionError();
		boolean ok = checkProduct(l, x);
		if (!ok) return "NO";
		
		String s = "";
		for (int i=0; i<Math.min(x, 4); i++) s=s+l;
		
		int n1 = findFirst(s, 1);
		int n2 = findLast(s, 3);
		if (n1 == -1 || n2 == -1) return "NO";
		if (n1 + n2 < n * x) return "YES";
		else return "NO";
	}
	
	public void run() throws FileNotFoundException {
		sc = new Scanner(new File("C.in"));
		pw = new PrintWriter(new File("C.out"));
		
		init();
		int numTests = sc.nextInt();
		for (int testNum=1; testNum<=numTests; testNum++) {
			String result = solve();
	      pw.println("Case #" + testNum + ": " + result);
			System.out.println("Done: " + testNum);
		}
		
		sc.close();
		pw.close();
	}
	
	public static void main(String[] args) throws FileNotFoundException {
		C t = new C();
		t.run();
	}
}
