package round0;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Scanner;

public class D {
	Scanner sc;
	PrintWriter out;
	int [] keys = new int[201];
	int [] totalKeys = new int[201];
	Map <Integer, Integer>keysNeeded;
	List <Chest> chests = new ArrayList<Chest>();

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		File in = new File("round0/" + D.class.getSimpleName() + "s.in");
		File out = new File(in.getAbsolutePath().replace(".in", ".out"));
		new D(new Scanner(in), new PrintWriter(out)).solve();
	}

	private void solveCase() {
		int k = sc.nextInt();
		int c = sc.nextInt();
		keys = new int[201];
		totalKeys = new int[201];
		keysNeeded = new HashMap<Integer, Integer>(200);
		chests = new ArrayList<Chest>();
		
		for (int i = 0; i <= 200; i ++) {
			keys[i] = 0;
		}
		
		for (int i = 0; i < k; i ++) {
			int kt = sc.nextInt();
			keys[kt]++;
			totalKeys[kt]++;
		}
		
		for (int i = 0; i < c; i ++) {
			int keyType = sc.nextInt();
			Chest chest = new Chest(i + 1, keyType);
			if(keysNeeded.containsKey(keyType)) {
				keysNeeded.put(keyType, keysNeeded.get(keyType) + 1);
			} else {
				keysNeeded.put(keyType, 1);
			}
			int nk = sc.nextInt();
			for (int j = 0; j < nk; j++) {
				int kt = sc.nextInt();
				totalKeys[kt]++;
				if (chest.keys.containsKey(kt)) {
					chest.keys.put(kt, chest.keys.get(kt) + 1);
				} else {
					chest.keys.put(kt, 1);
				}
			}
			chests.add(chest);
		}
		
		List <Chest>opened = run(new ArrayList<Chest>());
		
		if (opened == null) {
			out.println(" IMPOSSIBLE");
			System.out.println(" IMPOSSIBLE");
		} else {
			for (Chest chest : opened) {
				out.print(" " + chest.index);
				System.out.print(" " + chest.index);
			}
			out.println();
			System.out.println();
		}
	}
	
	boolean checkKeys() {
		for (int i : keysNeeded.keySet()) {
			if (totalKeys[i] < keysNeeded.get(i)) {
				return false;
			}
		}
		
		for (Chest c1 : chests) {
			if (!c1.opened && keys[c1.keyType] == 0) {
				if (c1.keys.containsKey(c1.keyType) && c1.keys.get(c1.keyType) == totalKeys[c1.keyType]) {
					return false;
				}
			}
		}
		
		return true;
	}
	
	List <Chest>run(List <Chest> opened) {
		List <Chest> result = null;
		
		if (checkKeys()) {
			if (opened.size() == chests.size()) {
				result = opened;
			} else {
				for (Chest chest : chests) {
					if (!chest.opened && keys[chest.keyType] > 0) {
						int kn = keysNeeded.get(chest.keyType);
						keys[chest.keyType]--;
						keysNeeded.put(chest.keyType, kn - 1);
						totalKeys[chest.keyType]--;
						chest.opened = true;
						opened.add(chest);
						for (int kt : chest.keys.keySet()) {
							keys[kt] += chest.keys.get(kt);
							totalKeys[kt] += chest.keys.get(kt);
						}
						result = run(opened);
						if (result == null) {
							keys[chest.keyType]++;
							keysNeeded.put(chest.keyType, kn);
							totalKeys[chest.keyType]++;
							opened.remove(chest);
							chest.opened = false;
							for (int kt : chest.keys.keySet()) {
								keys[kt] -= chest.keys.get(kt);
								totalKeys[kt] -= chest.keys.get(kt);
							}
						} else {
							return result;
						}
					}
				}
			}
		}
		
		return result;
	}
	
	class Chest {
		int index;
		int keyType;
		Map <Integer, Integer> keys = new HashMap<Integer, Integer>();
		boolean opened = false;
		
		Chest(int index, int keyType) {
			this.index = index;
			this.keyType = keyType;
		}
	}

	public D(Scanner sc, PrintWriter out) {
		this.sc = sc;
		this.out = out;
	}

	public void solve() {
		int cases = sc.nextInt();

		for (int i = 1; i <= cases; i++) {
			System.out.printf("Case #%d:", i);
			out.printf("Case #%d:", i);
			solveCase();
		}

		sc.close();
		out.close();
	}
}