

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Locale;
import java.util.Scanner;
import java.util.Set;

public class C {
	Scanner sc;
	PrintWriter out;

	public static void main(String[] args) throws IOException {
		long iniTime = System.currentTimeMillis();
		
		Locale.setDefault(Locale.US);
		File in = new File("q/" + C.class.getSimpleName() + "1.in");
		File out = new File(in.getAbsolutePath().replace(".in", ".out"));
		new C(new Scanner(in), new PrintWriter(out)).solve();
		
		System.out.println("Time: " + (System.currentTimeMillis() - iniTime));
	}

	private void solveCase() throws IOException {
		int r = sc.nextInt();
		int c = sc.nextInt();
		int m = sc.nextInt();
		int e = r * c - m;
		char [][] grid = new char[r][c];
		
		for (int i = 0; i < r; i++) {
			for (int j = 0; j < c; j++) {
				grid[i][j] = '*';
			}
		}
		
		if (e > 1) {
			if (r > 1 && c > 1) {
				if ((r == 2 || c == 2) && e % 2 == 1) {
					System.out.println("Impossible");
					out.println("Impossible");
					return;
				} else if (e < 4) {
					System.out.println("Impossible");
					out.println("Impossible");
					return;
				} else if (!fill(grid, e)) {
					System.out.println("Impossible");
					out.println("Impossible");
					return;
				}
			} else {
				fill(grid, e);
			}
		}
		
		grid[0][0] = 'c';
		
		for (int i = 0; i < r; i++) {
			for (int j = 0; j < c; j++) {
				System.out.print(grid[i][j]);
				out.print(grid[i][j]);
			}
			System.out.println();
			out.println();
		}
	}
	
	private static boolean fill(char [][] grid, int e) {
		int n = 1;
		int x = grid.length;
		int y = grid[0].length;
		Set <Integer> rows = new HashSet<Integer>();
		Set <Integer> cols = new HashSet<Integer>();
		
		if (x >= y) {
			for (int r = 1; r < Math.max(x, y) && n < e; r++) {
				for (int i = 0; i < r && n < e; i++) {
					if (i < x && r < y) {
						grid[i][r] = '.';
						rows.add(i);
						cols.add(r);
						n++;
					}
				}
				
				for (int j = 0; j <= r && n < e; j++) {
					if (r < x && j < y) {
						grid[r][j] = '.';
						rows.add(r);
						cols.add(j);
						n++;
					}
				}
			}
		} else {
			for (int r = 1; r < Math.max(x, y) && n < e; r++) {
				for (int j = 0; j < r && n < e; j++) {
					if (r < x && j < y) {
						grid[r][j] = '.';
						rows.add(r);
						cols.add(j);
						n++;
					}
				}
				
				for (int i = 0; i <= r && n < e; i++) {
					if (i < x && r < y) {
						grid[i][r] = '.';
						rows.add(i);
						cols.add(r);
						n++;
					}
				}
			}
		}
		
		if (e % 2 == 1 && (rows.size() == 2 || cols.size() == 2)) {
			return false;
		}
		
		return true;
	}

	public C(Scanner sc, PrintWriter out) {
		this.sc = sc;
		this.out = out;
	}

	public void solve() throws NumberFormatException, IOException {
		int cases = sc.nextInt();

		for (int i = 1; i <= cases; i++) {
			System.out.printf("Case #%d:\n", i);
			out.printf("Case #%d:\n", i);
			solveCase();
		}

		sc.close();
		out.close();
	}
}