package round0;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Locale;
import java.util.Scanner;

public class C {
	public static char [] DIGITS = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};
	Scanner sc;
	PrintWriter out;

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		File in = new File("round0/" + C.class.getSimpleName() + "l2.in");
		File out = new File(in.getAbsolutePath().replace(".in", ".out"));
		new C(new Scanner(in), new PrintWriter(out)).solve();
	}

	private void solveCase() {
		BigInteger a = new BigInteger(sc.next());
		BigInteger b = new BigInteger(sc.next());
		BigInteger x1 = sqrt(a);
		BigInteger x2 = sqrt(b);
		int n = 0;
		
		if (!x1.multiply(x1).equals(a)) {
			x1 = x1.add(new BigInteger("1"));
		}
		
		for (int i = x1.toString().length(); i <= x2.toString().length(); i++) {
			char [] c = new char[i];
			
			for (int j = 0; j < c.length; j++) {
				c[j] = DIGITS[0];
			}
			c[0] = DIGITS[1];
			c[c.length - 1] = DIGITS[1];
			
			n += run(c, 0, x1, x2);
		}
		
		out.println(" " + n);
		System.out.println(" " + n);
	}
	
	int run(char [] c, int x, BigInteger x1, BigInteger x2) {
		int n = 0;
		int m = (c.length / 2 - 1) + c.length % 2;
		
		if (x == m) {
			for (int i = Integer.parseInt("" + c[x]); i < 10; i++) {
				c[x] = DIGITS[i];
				c[c.length - 1 - x] = DIGITS[i];
				BigInteger b = new BigInteger(new String(c));
				if (b.compareTo(x1) >= 0) {
					if (b.compareTo(x2) > 0) {
						break;
					}
					if (isFair(b.multiply(b))) {
						n++;
					}
				}
			}
			c[x] = DIGITS[0];
		} else {
			for (int i = Integer.parseInt("" + c[x]); i < 10; i++) {
				c[x] = DIGITS[i];
				c[c.length - 1 - x] = DIGITS[i];
				n += run(c, x + 1, x1, x2);
			}
		}
		
		return n;
	}
	
	BigInteger sqrt(BigInteger n) {
		BigInteger a = BigInteger.ONE;
		BigInteger b = new BigInteger(n.shiftRight(5).add(new BigInteger("8")).toString());
		while (b.compareTo(a) >= 0) {
			BigInteger mid = new BigInteger(a.add(b).shiftRight(1).toString());
			if (mid.multiply(mid).compareTo(n) > 0)
				b = mid.subtract(BigInteger.ONE);
			else
				a = mid.add(BigInteger.ONE);
		}
		return a.subtract(BigInteger.ONE);
	}
	
	boolean isFair(BigInteger b) {
		boolean result = true;
		String s = b.toString();
		int limit = s.length() / 2;
		
		for (int i = 0; i < limit; i++) {
			if (s.charAt(i) != s.charAt(s.length() - 1 - i)) {
				return false;
			}
		}
		
		return result;
	}

	public C(Scanner sc, PrintWriter out) {
		this.sc = sc;
		this.out = out;
	}

	public void solve() {
		int cases = sc.nextInt();

		for (int i = 1; i <= cases; i++) {
			System.out.printf("Case #%d:", i);
			out.printf("Case #%d:", i);
			solveCase();
		}

		sc.close();
		out.close();
	}
}