package round0;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class C {
	Scanner sc;
	PrintWriter out;

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		File in = new File("round0/" + C.class.getSimpleName() + "s.in");
		File out = new File(in.getAbsolutePath().replace(".in", ".out"));
		new C(new Scanner(in), new PrintWriter(out)).solve();
	}

	private void solveCase() {
		long a = sc.nextLong();
		long b = sc.nextLong();
		long x1 = (long) Math.sqrt(a);
		long x2 = (long) Math.sqrt(b);
		int n = 0;
		
		while(x1 <= x2) {
			if (isFair(new String("" + x1))) {
				if (isFair(new String("" + (x1 * x1)))) {
					if (x1 * x1 >= a) {
						n++;
					}
				}
			}
			x1++;
		}
		
		out.println(" " + n);
		System.out.println(" " + n);
	}
	
	boolean isFair(String s) {
		boolean result = true;
		int limit = s.length() / 2;
		
		for (int i = 0; i < limit; i++) {
			if (s.charAt(i) != s.charAt(s.length() - 1 - i)) {
				return false;
			}
		}
		
		return result;
	}

	public C(Scanner sc, PrintWriter out) {
		this.sc = sc;
		this.out = out;
	}

	public void solve() {
		int cases = sc.nextInt();

		for (int i = 1; i <= cases; i++) {
			System.out.printf("Case #%d:", i);
			out.printf("Case #%d:", i);
			solveCase();
		}

		sc.close();
		out.close();
	}
}