package round0;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;

public class A {
	BufferedReader in;
	PrintWriter out;

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		File in = new File("round0/" + A.class.getSimpleName() + "l.in");
		File out = new File(in.getAbsolutePath().replace(".in", ".out"));
		new A(new BufferedReader(new FileReader(in)), new PrintWriter(out)).solve();
	}

	private void solveCase() throws IOException {
		char [][] board = new char[4][4];
		
		for (int i = 0; i < 4; i++) {
			String line = in.readLine();
			for (int j = 0; j < 4; j++) {
				board[i][j] = line.charAt(j);
			}
		}
		in.readLine();
		
		boolean ended = true;
		for (int x = 0; x < 4; x++) {
			for (int y = 0; y < 4; y++) {
				char s = board[x][y];
				int n;
				if (s == 'X' || s == 'O') {
					for (int vx = -1; vx <= 1; vx++) {
						for (int vy = -1; vy <= 1; vy++) {
							if (vx != 0 || vy != 0) {
								n = 1;
								for (int i = 1; i < 4; i++) {
									int posx = x + vx*i;
									int posy = y + vy*i;
									if (posx >= 0 && posx < 4 && posy >= 0 && posy < 4) {
										char aux = board[posx][posy];
										if (aux == s || aux == 'T') {
											n++;
											if (n == 4) {
												out.println(s + " won");
												System.out.println(s + " won");
												return;
											}
										} else {
											break;
										}
									} else {
										break;
									}
								}
							}
						}
					}
				} else if (s == '.') {
					ended = false;
				}
			}
		}
		
		if (ended) {
			out.println("Draw");
			System.out.println("Draw");
		} else {
			out.println("Game has not completed");
			System.out.println("Game has not completed");
		}
	}

	public A(BufferedReader in, PrintWriter out) {
		this.in = in;
		this.out = out;
	}

	public void solve() throws NumberFormatException, IOException {
		int cases = Integer.parseInt(in.readLine());

		for (int i = 1; i <= cases; i++) {
			System.out.printf("Case #%d: ", i);
			out.printf("Case #%d: ", i);
			solveCase();
		}

		in.close();
		out.close();
	}
}