package codejam;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class TicTacToe {

    /**
     * @param args
     * @throws IOException
     */
    public static void main(String[] args) throws IOException {
        new TicTacToe(args);
    }

    public TicTacToe(String[] args) throws IOException {

        Scanner sc = null;
        BufferedWriter out = new BufferedWriter(new FileWriter(
                new File("output")));

        try {
            sc = new Scanner(new File(args[0]));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        int n = sc.nextInt();

        for (int i = 0; i < n; i++) {

            Boolean containsEmpty = false;
            char[][] a = new char[4][4];
            int xT = -1, yT = -1;

            for (int j = 0; j < 4; j++) {
                String str = sc.next();

                if (str.contains("."))
                    containsEmpty = true;

                int searchT = str.indexOf('T');
                if (searchT != -1) {
                    xT = j;
                    yT = searchT;
                }

                // a[j] = str.toCharArray
                for (int k = 0; k < 4; k++)
                    a[j][k] = str.charAt(k);
            }

            // for (int j = 0; j < 4; j++) {
            // for (int k = 0; k < 4; k++)
            // out.write(a[j][k]);
            // out.newLine();
            // }

            out.write("Case #" + (i + 1) + ": "
                    + checkResult(a, containsEmpty, xT, yT));
            out.newLine();
        }

        out.close();
    }

    private String checkResult(char[][] a, boolean containsEmpty,
            int xT, int yT) {

        String res = "no result";

        if (xT != -1 && yT != -1) {

            a[xT][yT] = 'X';
            res = checkWinner(a);
            if (res.length() < 9) {
                return res;
            }

            a[xT][yT] = 'O';
            res = checkWinner(a);
            if (res.length() < 9) {
                return res;
            }
        }

        res = checkWinner(a);
        if (res.length() < 9) {
            return res;
        }

        if (res.equals("no result")) {
            if (containsEmpty == false)
                return "Draw";
            if (containsEmpty == true)
                return "Game has not completed";
        }

        return "Invalid";

    }

    private String checkWinner(char[][] a) {
        for (int i = 0; i < 4; i++) {
            // check horizontal
            if (checkEqual(a[i][0], a[i][1], a[i][2], a[i][3])) {
                return a[i][0] + " won";
            }
            // check vertical
            if (checkEqual(a[0][i], a[1][i], a[2][i], a[3][i])) {
                return a[0][i] + " won";
            }
        }

        if (checkEqual(a[0][0], a[1][1], a[2][2], a[3][3])) {
            return a[0][0] + " won";
        }
        if (checkEqual(a[0][3], a[1][2], a[2][1], a[3][0])) {
            return a[0][3] + " won";
        }

        return "no result";
    }

    private boolean checkEqual(char c, char d, char e, char f) {
        return ((c != '.') && (c == d) && (d == e) && (e == f));
    }
}
