package codejam;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

public class Lawm {

    /**
     * @param args
     * @throws IOException
     */
    public static void main(String[] args) throws IOException {
        new Lawm(args);
    }

    public Lawm(String[] args) throws IOException {

        Scanner sc = null;
        BufferedWriter out = new BufferedWriter(new FileWriter(
                new File("output")));

        try {
            sc = new Scanner(new File(args[0]));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }

        int no = sc.nextInt();

        for (int k = 0; k < no; k++) {

            int n = sc.nextInt();
            int m = sc.nextInt();

            int[] maxLines = new int[n];
            int[] maxRaw = new int[m];
            int[][] a = new int[n][m];
            int[][] arot = new int[m][n];

            for (int i = 0; i < n; i++)
                for (int j = 0; j < m; j++) {
                    a[i][j] = sc.nextInt();
                    arot[j][i] = a[i][j];
                }

            maxLines = getMaxVex(n, m, a);
            maxRaw = getMaxVex(m, n, arot);

            if (checkValidity(out, n, m, maxLines, maxRaw, a) == false) {
                out.write("Case #" + (k + 1) + ": NO");
                out.newLine();
            } else {
                out.write("Case #" + (k + 1) + ": YES");
                out.newLine();
            }

        }
        out.close();
    }

    private boolean checkValidity(BufferedWriter out, int n, int m,
            int[] maxLines, int[] maxRaw, int[][] a)
            throws IOException {
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++) {
                if (a[i][j] != maxLines[i] && a[i][j] != maxRaw[j]) {
                    return false;
                }
            }
        return true;
    }

    private int[] getMaxVex(int n, int m, int[][] a) {

        int[] lines = new int[n];

        // compute max for each line
        for (int i = 0; i < n; i++) {
            int max = 0;

            for (int j = 0; j < m; j++) {
                if (a[i][j] > max) {
                    max = a[i][j];
                }
            }

            lines[i] = max;
        }

        return lines;
    }

}
