package cn.cdn;

import java.io.*;
import java.util.*;

public class SaveUniverse {
	
	public Vector<String> readFile(String filename)	{
		
		Vector<String> items = new Vector<String>();
		
		try{
			File infile = new File(filename);
			BufferedReader br = new BufferedReader(new FileReader(infile));

			String buf = null;
			buf = br.readLine();

			while(buf != null) {
				items.add(buf);
				buf = br.readLine();
			}
			br.close();

		}catch(FileNotFoundException e) {
			e.printStackTrace();
		}catch(IOException e) {
			e.printStackTrace();
		}
		
		return items;
		
	}
	
	public int caculateSwitchTimes(Vector<String> searchEngines, Vector<String> queries) {
		int ret = 0;
		
		HashMap seHM = new HashMap();
		int searchEngineNum = searchEngines.size();
		int healthNum = searchEngineNum;
		
		for(int i=0; i<searchEngineNum; i++)
		{
			seHM.put(searchEngines.elementAt(i), false);
		}
		
		int queryNum = queries.size();
		for(int i=0; i<queryNum; i++)
		{
			if(searchEngines.contains(queries.elementAt(i)))
			{
				if((Boolean)seHM.get(queries.elementAt(i))==false)
				{
					seHM.put(queries.elementAt(i), true);
					healthNum--;
				}
				
				if(healthNum==0)
				{
					ret++;
					for(int j=0; j<searchEngineNum; j++)
					{
						seHM.put(searchEngines.elementAt(j), false);
						healthNum = searchEngineNum;
					}
					seHM.put(queries.elementAt(i), true);
					healthNum--;
				}
			}
			
		}
		
		return ret;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		SaveUniverse su = new SaveUniverse();
		Vector<String> items = su.readFile("A-small-attempt2.in");
		
		try {
			BufferedWriter out = new BufferedWriter(
					new OutputStreamWriter(
							new FileOutputStream("out.txt")));
			
			int testCaseID  = 1;
			
			int searchEngineNum=0, queryNum=0;
			boolean readingSearchEngine=false, readingQuery=true;
			Vector<String> searchEngines, queries;
			
			searchEngines 	= new Vector<String>();
			queries 		= new Vector<String>();
			
			boolean firstTime = true;
			int itemLen = items.size();
			for(int i=1; i<itemLen; i++)
			{
				if( (queries.size() >= queryNum) && readingQuery)
				{
					if(!firstTime)
					{
						int switchTimes = su.caculateSwitchTimes(searchEngines, queries);
						out.write("Case #"+testCaseID+": "+switchTimes+"\r\n");
						System.out.print("Case #"+testCaseID+": "+switchTimes+"\r\n");
						testCaseID++;
					}
					firstTime = false;
					
					searchEngineNum = Integer.parseInt(items.elementAt(i));
					
					searchEngines.clear();
					queries.clear();
					
					readingSearchEngine = true;
					readingQuery 		= false;
					
					continue;
				}
				else if( (searchEngines.size() >= searchEngineNum) && readingSearchEngine)
				{
					queryNum = Integer.parseInt(items.elementAt(i));
					
					readingSearchEngine = false;
					readingQuery 		= true;
					
					continue;
				}
				
				if(readingSearchEngine)
					searchEngines.add(items.elementAt(i));
				else if(readingQuery)
					queries.add(items.elementAt(i));
			}
			
			int switchTimes = su.caculateSwitchTimes(searchEngines, queries);
			out.write("Case #"+testCaseID+": "+switchTimes+"\r\n");
			System.out.print("Case #"+testCaseID+": "+switchTimes+"\r\n");
			testCaseID++;
			
			out.flush();
			
			out.close();
			
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
