package cn.cdn;

import java.io.*;
import java.util.*;

public class Round1A {

	public Vector<String> readFile(String filename)	{
		
		Vector<String> items = new Vector<String>();
		
		try{
			File infile = new File(filename);
			BufferedReader br = new BufferedReader(new FileReader(infile));

			String buf = null;
			buf = br.readLine();

			while(buf != null) {
				items.add(buf);
				buf = br.readLine();
			}
			br.close();

		}catch(FileNotFoundException e) {
			e.printStackTrace();
		}catch(IOException e) {
			e.printStackTrace();
		}
		
		return items;
		
	}
	

	private long caculate(Vector<Long> x, Vector<Long> y, int vectorLen) {
		long ret = 0;
		
		Collections.sort(x);
		Collections.sort(y);
		
		for(int i=0; i<vectorLen; i++)
		{
			ret += x.elementAt(i) * y.elementAt(vectorLen-i-1);
		}
		
		return ret;
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {

		Round1A rd = new Round1A();
		Vector<String> lines = rd.readFile("A-small-attempt0.in");
		
		try {
			BufferedWriter out = new BufferedWriter(
					new OutputStreamWriter(
							new FileOutputStream("out.txt")));
			
			int testCaseNum = Integer.parseInt(lines.elementAt(0));
			int testCaseID  = 1;
			
			int vectorLen=0;
			Vector<Long> X, Y;
			
			X 	= new Vector<Long>();
			Y 	= new Vector<Long>();
			
			boolean testCaseReady = false;
			int lineLen = lines.size();
			for(int i=1; i<lineLen; i++)
			{
				if(i%3==1)
				{
					vectorLen = Integer.parseInt(lines.elementAt(i));
				}
				else if (i%3==2)
				{
					String[] ints = lines.elementAt(i).split(" ");
					if(ints.length!=vectorLen)
						System.err.println("Mismatch in reading input file.");
					for(int j=0; j<vectorLen; j++)
					{
						X.add(Long.parseLong(ints[j]));
					}
				}
				else if (i%3==0)
				{
					String[] ints = lines.elementAt(i).split(" ");
					if(ints.length!=vectorLen)
						System.err.println("Mismatch in reading input file.");
					for(int j=0; j<vectorLen; j++)
					{
						Y.add(Long.parseLong(ints[j]));
					}
					
					testCaseReady = true;
				}
				
				if(testCaseReady)
				{
					long smallestResult = rd.caculate(X, Y, vectorLen);
					X.clear();
					Y.clear();
					
					out.write("Case #"+testCaseID+": "+smallestResult+"\r\n");
					System.out.print("Case #"+testCaseID+": "+smallestResult+"\r\n");
					testCaseID++;
					testCaseReady = false;
				}
			}
			
			out.flush();
			out.close();
			
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
