import java.io.*;
import java.util.*;

public class Main{

	String inputFile = "C-small-attempt1.in";
	String outputFile = "C-small-attempt1-OUTPUT.txt";
	PrintStream output;
	Scanner fileScanner;
	int outputLine = 0;
	double start = System.currentTimeMillis();

	ArrayList<Integer> values; // list of lollies

	public Main(){
		newCodeJam();
		
		fileScanner.nextLine();
		while (fileScanner.hasNextLine()){
			fileScanner.nextLine(); // skip num of lollies
			String line = fileScanner.nextLine();
			Scanner scanner = new Scanner(line);

			values = new ArrayList<Integer>();
			while (scanner.hasNext()){
				values.add(scanner.nextInt());
			}

			println(solve());

		}

		output.close();
		System.out.println("Finished.");
		System.out.println("Time Taken: " + ((System.currentTimeMillis()-start)/1000) + " seconds.");
	}



	private String solve(){

		int sean = -1; // amount sean gets
		ArrayList<Integer> pile1;
		ArrayList<Integer> pile2;

		// split the candy
		ArrayList<Integer[]> combinations = Combinations.getAll(values);
		
		for (Integer[] combin : combinations){
			
			if (combin.length == values.size()){ // all values in one pile
				continue; // skip this combination
			}
			
			// set up the two piles
			pile1 = new ArrayList<Integer>();
			for (int i=0; i<combin.length; i++){
				pile1.add(combin[i]); // copy all from combin to pile1
				combin[i] = 0;
			}
			pile2 = new ArrayList<Integer>();
			for (Integer value : values){
				pile2.add(value); // pile2 = values
			}
			for (Integer i : pile1){
				pile2.remove(pile2.indexOf(i)); // if value in pile1 then remove from in pile2
			}
			
			// evaluate piles
			if (wrongSum(pile1) == wrongSum(pile2)){
				int maxPile = Math.max(correctSum(pile1), correctSum(pile2));
				if (maxPile > sean){
					sean = maxPile;
				}
			}
		}
		
		if (sean == -1) return "NO";
		return sean +"";
	}



	private static int correctSum(ArrayList<Integer> list){
		int sum = 0;
		for (Integer i : list){
			sum = sum + i;
		}
		return sum;
	}

	private static int wrongSum(ArrayList<Integer> list){
		// returns the result of Patrick's incorrect binary addition
		int sum = 0;
		for (Integer i : list){
			sum = sum ^ i;
		}
		return sum;
	}


	// CodeJam Utility Methods:

	public void newCodeJam(){
		System.out.print("\f");
		// open input file
		try {
			fileScanner = new Scanner(new File(inputFile));
		}catch(IOException e) {}
		// open output file
		try {
			output = new PrintStream(new File(outputFile));
		}catch(IOException ex) {}
	}

	public void println(String s){
		outputLine++;
		output.println("Case #" + outputLine + ": " + s);
	}
	
	public static void main(String[] args){
		new Main();
	}

}