import java.io.*;
import java.util.*;

public class Main{

	String inputFile = "B-small-attempt0.in";
	String outputFile = "B-small-attempt0-OUTPUT.txt";
	PrintStream output;
	Scanner fileScanner;
	int outputLine = 0;
	double start = System.currentTimeMillis();
	
	HashMap<String, Character> combinePairs;
	ArrayList<String> opposedPairs;
	ArrayList<Character> invokeList;
	ArrayList<Character> elementList;
	

	public Main(){
		newCodeJam();

		fileScanner.nextLine();
		while (fileScanner.hasNextLine()){
			String line = fileScanner.nextLine();
			Scanner scanner = new Scanner(line);

			// setup data structures
			combinePairs = new HashMap<String, Character>();
			opposedPairs = new ArrayList<String>();
			invokeList = new ArrayList<Character>();
			elementList = new ArrayList<Character>();
			
			// read in combine pairs
			int n = scanner.nextInt();
			for (int x=1; x<=n; x++){
				String s = scanner.next();
				combinePairs.put(""+s.charAt(0)+s.charAt(1), s.charAt(2));
				combinePairs.put(""+s.charAt(1)+s.charAt(0), s.charAt(2));
			}

			// read in opposed pairs
			n = scanner.nextInt();
			for (int x=1; x<=n; x++){
				String s = scanner.next();
				opposedPairs.add(""+s.charAt(0)+s.charAt(1));
				opposedPairs.add(""+s.charAt(1)+s.charAt(0));
			}
			
			// read in invoke list
			n = scanner.nextInt();
			String s = scanner.next();
			for (int x=0; x<n; x++){
				invokeList.add(s.charAt(x));
			}
			
			// output solution
			println( solve() +"");
		}

		output.close();
		System.out.println("\nFinished.");
		System.out.println("Time Taken: " + ((System.currentTimeMillis()-start)/1000) + " seconds.");
	}


	private String solve(){
		
		for (Character c : invokeList){
			elementList.add(c);			
			check();
		}
		
		String list = "[";
		if (elementList.size() > 0) list += elementList.get(0);
		for (int i=1; i<elementList.size(); i++){
			list += ", " + elementList.get(i);
		}
		list += "]";
		
		return list;
	}

	private void check(){
		
		if (elementList.size() < 2) return;
		String lastTwo = "" + elementList.get(elementList.size()-2) + elementList.get(elementList.size()-1);
		
		if (combinePairs.get(lastTwo) != null){ // combine
			elementList.remove(elementList.size()-1);
			elementList.remove(elementList.size()-1);
			elementList.add(combinePairs.get(lastTwo));
			check();
		}
		
		// opposed
		ArrayList<Character> opposedList = new ArrayList<Character>();
		for (String s : opposedPairs){
			if (s.charAt(0) == elementList.get(elementList.size()-1)){
				opposedList.add(s.charAt(1));
			}
		}
		for (Character c : opposedList){
			if (elementList.contains(c)){
				elementList.clear();
			}
		}
	}

	// CodeJam Utility Methods:

	public void newCodeJam(){
		System.out.print("\f");
		// open input file
		try {
			fileScanner = new Scanner(new File(inputFile));
		}catch(IOException e) {}
		// open output file
		try {
			output = new PrintStream(new File(outputFile));
		}catch(IOException ex) {}
	}

	public void println(String s){
		outputLine++;
		output.println("Case #" + outputLine + ": " + s);
	}

	public static void main(String[] args){
		new Main();
	}

}
