import java.io.*;
import java.util.*;

public class Main{

    String inputFile = "A-large.in";
    String outputFile = "A-large-OUTPUT.txt";
    PrintStream output;
    Scanner fileScanner;
    int outputLine = 0;
    double start = System.currentTimeMillis();
    
    int rows, cols;
    char[][] tiles;

    public Main(){
        newCodeJam();

        fileScanner.nextLine();
        while (fileScanner.hasNextLine()){
            String line = fileScanner.nextLine();
            Scanner scanner = new Scanner(line);
            
            rows = scanner.nextInt();
            cols = scanner.nextInt();
            tiles = new char[rows][cols];
            
            for (int r=0; r<rows; r++){
            	line = fileScanner.nextLine();
                for (int c=0; c<cols; c++){
                	tiles[r][c] = line.charAt(c);
                }
            }
            
            println(solve());
            
        }

        output.close();
        System.out.println("Finished.");
        System.out.println("Time Taken: " + ((System.currentTimeMillis()-start)/1000) + " seconds.");
    }
    
    
    private String solve(){
    	
    	coverBlueWithRed();
    	
    	if (noBlue()){
    		// return tiles[][]
    		String s = "";
    		for (int r=0; r<rows; r++){
    			s += "\n";
        		for (int c=0; c<cols; c++){
        			s += tiles[r][c];
        		}
        	}
    		return s;
    		
    	}else {
    		return "\nImpossible";
    	}
    }

    
    private void coverBlueWithRed(){
    	for (int r=0; r<=rows-2; r++){
    		for (int c=0; c<=cols-2; c++){
    			if (tiles[r][c]=='#' && tiles[r][c+1]=='#' && tiles[r+1][c]=='#' && tiles[r+1][c+1]=='#'){ // red possible
    				tiles[r][c] = '/';
    				tiles[r][c+1] = '\\';
    				tiles[r+1][c] = '\\';
    				tiles[r+1][c+1] = '/';
    			}
    		}
    	}
    }
    

    private boolean noBlue(){
    	for (int r=0; r<rows; r++){
    		for (int c=0; c<cols; c++){
    			if (tiles[r][c] == '#'){ // contains blue
    				return false;
    			}
    		}
    	}
    	return true;    	
    }
    
    
    
    // CodeJam Utility Methods:
    
    public void newCodeJam(){
        System.out.print("\f");
        // open input file
        try {
            fileScanner = new Scanner(new File(inputFile));
        }catch(IOException e) {}
        // open output file
        try {
            output = new PrintStream(new File(outputFile));
        }catch(IOException ex) {}
    }

    public void println(String s){
        outputLine++;
        output.println("Case #" + outputLine + ": " + s);
    }

    public static void main(String[] args){
        new Main();
    }

}