import java.io.*;
import java.util.*;

public class Main{

    String inputFile = "A-large.in";
    PrintStream output;
    Scanner fileScanner;
    int outputLine = 0;
    double start = System.currentTimeMillis();
    char[] grid;

    public Main(){
        newCodeJam();

        int N = Integer.parseInt(fileScanner.nextLine());
        
        for (int testCase = 1; testCase <= N; testCase++)
        {
        	int i = 0;
            grid = new char[16];
            
            for (int row = 1; row <= 4; row++)
            {
            	String line = fileScanner.nextLine();
	            for (int x=0; x<4; x++)
	            {
	            	grid[i] = line.charAt(x);
	        		i++;
	            }
        	}
            
            fileScanner.nextLine();
            
            solve (grid);
        }

        output.close();
        System.out.println("Finished.");
        System.out.println("Time Taken: " + ((System.currentTimeMillis()-start)/1000) + " seconds.");
    }

    
    private void solve (char[] grid)
    {
    	if (won('X'))
    	{
    		println("X won");
    	}
    	else if (won('O'))
    	{
    		println("O won");
    	}
    	else if (gridFull())
    	{
    		println("Draw");
    	}
    	else
    	{
    		println("Game has not completed");
    	}
    }

    
    private boolean won(char c)
    {
    	int count = 0;
    	// check rows
    	for (int r = 0; r < 4; r++)
    	{
    		count = 0;
    		for (int i = r*4; i < r*4+4; i++)
    		{
    			if (grid[i] == c || grid[i] == 'T')
    			{
    				count++;
    			}
    		}
    		if (count == 4)
    		{
    			return true;
    		}
    	}
    	
    	// check columns
    	for (int col = 0; col < 4; col++)
    	{
    		count = 0;
    		for (int i = col; i < 16; i+=4)
    		{
    			if (grid[i] == c || grid[i] == 'T')
    			{
    				count++;
    			}
    		}
    		if (count == 4)
    		{
    			return true;
    		}
    	}
    	
    	// check diagonal 1
		count = 0;
		for (int i = 0; i <= 15; i+=5)
		{
			if (grid[i] == c || grid[i] == 'T')
			{
				count++;
			}
		}
		if (count == 4)
		{
			return true;
		}
    	
		// check diagonal 2
		count = 0;
		for (int i = 3; i <= 12; i+=3)
		{
			if (grid[i] == c || grid[i] == 'T')
			{
				count++;
			}
		}
		if (count == 4)
		{
			return true;
		}
    	
    	return false;
    }
    
    
    private boolean gridFull()
    {
    	for (int i=0; i<16; i++)
    	{
    		if (grid[i] == '.')
    		{
    			return false;
    		}
    	}
    	return true;
    }
    
    
    // CodeJam Utility Methods:
    
    public void newCodeJam(){
        String outputFile = inputFile.substring(0, inputFile.length()-3) + "-OUTPUT.out";
        System.out.print("\f\n");
        // open input file
        try {
            fileScanner = new Scanner(new File(inputFile));
        }catch(IOException e) {
			System.out.println("ERROR: Input File (" + inputFile + ") Not Found.");
		}
        // open output file
        try {
            output = new PrintStream(new File(outputFile));
        }catch(IOException ex) {
			System.out.println("ERROR: Could not open output file " + outputFile);
		}
    }

    public void println(String s){
        outputLine++;
        output.println("Case #" + outputLine + ": " + s);

    	if (inputFile.charAt(1) == 'e'){ // "Test" input
        	System.out.println("Case #" + outputLine + ": " + s);
    	}
    }
		
    public static void main(String[] args){
        new Main();
    }

}