import java.io.*;
import java.util.*;

public class Main{

	String inputFile = "A-small-attempt0.in";
	String outputFile = "A-small-attempt0-OUTPUT.txt";
	PrintStream output;
	Scanner fileScanner;
	int outputLine = 0;
	double start = System.currentTimeMillis();

	ArrayList<Integer> blueList;
	ArrayList<Integer> orangeList;
	ArrayList<Character> moves;
	boolean buttonPushed;
	int bluePos = 1;
	int orangePos = 1;
	int time = 0;

	public Main(){
		newCodeJam();

		fileScanner.nextLine();
		while (fileScanner.hasNextLine()){
			String line = fileScanner.nextLine();
			Scanner scanner = new Scanner(line);
			scanner.next(); // skip count variable

			blueList = new ArrayList<Integer>();
			orangeList = new ArrayList<Integer>();
			moves = new ArrayList<Character>();

			while (scanner.hasNext()){
				if (scanner.next().equals("B")){
					moves.add('B');
					blueList.add(scanner.nextInt());
				}else {
					moves.add('O');
					orangeList.add(scanner.nextInt());
				}
			}

			println( solve() +"");
		}

		output.close();
		System.out.println("Finished.");
		System.out.println("Time Taken: " + ((System.currentTimeMillis()-start)/1000) + " seconds.");
	}



	private int solve(){
		bluePos = 1;
		orangePos = 1;
		time = 0;
		
		System.out.println("\n\nNEW SOLVE:");
		while (!blueList.isEmpty() || !orangeList.isEmpty()){
			buttonPushed = false;
			doOrangeMove();
			doBlueMove();
			time++;
		}

		return time;
	}

	private void doBlueMove(){
		if (blueList.isEmpty()) return;

		if (bluePos == blueList.get(0)){ // at button
			if (moves.get(0) == 'B' && !buttonPushed){ // allowed to push button
				buttonPushed = true;
				blueList.remove(0);
				moves.remove(0);
			}
		}else { // walk to button
			if(blueList.get(0) > bluePos){
				bluePos++;
			}else {
				bluePos--;
			}
		}
	}

	private void doOrangeMove(){
		if (orangeList.isEmpty()) return;

		if (orangePos == orangeList.get(0)){ // at button
			if (moves.get(0) == 'O' && !buttonPushed){ // allowed to push button
				buttonPushed = true;
				orangeList.remove(0);
				moves.remove(0);
			}
		}else { // walk to button
			if(orangeList.get(0) > orangePos){
				orangePos++;
			}else {
				orangePos--;
			}
		}
	}



	// CodeJam Utility Methods:

	public void newCodeJam(){
		System.out.print("\f");
		// open input file
		try {
			fileScanner = new Scanner(new File(inputFile));
		}catch(IOException e) {}
		// open output file
		try {
			output = new PrintStream(new File(outputFile));
		}catch(IOException ex) {}
	}

	public void println(String s){
		outputLine++;
		output.println("Case #" + outputLine + ": " + s);
	}

	public static void main(String[] args){
		new Main();
	}

}