import java.io.*;
import java.util.*;

public class Main{

    String inputFile = "B-small-attempt4.in";
    PrintStream output;
    Scanner fileScanner;
    int outputLine = 0;
    double start = System.currentTimeMillis();
    
    int N;
    int M;

    public Main(){
        newCodeJam();

        fileScanner.nextLine();
        while (fileScanner.hasNextLine()){
            
        	String line = fileScanner.nextLine();
            while (line.charAt(0) == '~')
            	line = fileScanner.nextLine();
        	
        	Scanner scanner = new Scanner(line);
            
            N = scanner.nextInt();
            M = scanner.nextInt();
            
            int[][] lawn = new int[N][M];
            
            for (int x = 0; x < N; x++)
            {
            	line = fileScanner.nextLine();
                scanner = new Scanner(line);
                
                for (int y = 0; y < M; y++)
                {
                	lawn[x][y] = scanner.nextInt();
                }
            }
            
            solve (lawn);
        }

        output.close();
        System.out.println("Finished.");
        System.out.println("Time Taken: " + ((System.currentTimeMillis()-start)/1000) + " seconds.");
    }

    
    private void solve(int[][] lawn)
    {
    	int h, maxRow, maxCol;
    	
    	for (int x = 0; x < N; x++)
        {
            for (int y = 0; y < M; y++)
            {
            	h = lawn[x][y];
            	
            	maxRow = 0;
            	for (int i = 0; i < N; i++)
                {
            		if (lawn[i][y] > maxRow && i!=x)
            		{
            			maxRow = lawn[i][y];
            		}
                }
            	
            	maxCol = 0;
            	for (int i = 0; i < M; i++)
                {
            		if (lawn[x][i] > maxCol && i!=y)
            		{
            			maxCol = lawn[x][i];
            		}
                }
            	
            	// too short
            	if (h < maxRow && h < maxCol)
            	{
            		println("NO");
            		return;
            	}
            }
        }

    	println("YES");
    }
   

    // CodeJam Utility Methods:
    
    public void newCodeJam(){
        String outputFile = inputFile.substring(0, inputFile.length()-3) + "-OUTPUT.out";
        System.out.print("\f\n");
        // open input file
        try {
            fileScanner = new Scanner(new File(inputFile));
        }catch(IOException e) {
			System.out.println("ERROR: Input File (" + inputFile + ") Not Found.");
		}
        // open output file
        try {
            output = new PrintStream(new File(outputFile));
        }catch(IOException ex) {
			System.out.println("ERROR: Could not open output file " + outputFile);
		}
    }

    public void println(String s){
        outputLine++;
        output.println("Case #" + outputLine + ": " + s);

    	if (inputFile.charAt(1) == 'e'){ // "Test" input
        	System.out.println("Case #" + outputLine + ": " + s);
    	}
    }

    public static void main(String[] args){
        new Main();
    }

}