import java.io.*;
import java.util.*;

public class Main{

	String inputFile = "C-small-attempt1.in";
	String outputFile = "C-small-attempt1-OUTPUT.txt";
	PrintStream output;
	Scanner fileScanner;
	int outputLine = 0;
	double start = System.currentTimeMillis();

	int N;
	int L;
	int H;
	ArrayList<Integer> players;

	public Main(){
		newCodeJam();

		fileScanner.nextLine();
		while (fileScanner.hasNextLine()){
			String line = fileScanner.nextLine();
			Scanner scanner = new Scanner(line);

			N = scanner.nextInt();
			L = scanner.nextInt();
			H = scanner.nextInt();

			line = fileScanner.nextLine();
			scanner = new Scanner(line);

			players = new ArrayList<Integer>();
			for (int x=0; x<N; x++){
				players.add(scanner.nextInt());
			}

			println(solve());

		}

		output.close();
		System.out.println("Finished.");
		System.out.println("Time Taken: " + ((System.currentTimeMillis()-start)/1000) + " seconds.");
	}


	private String solve(){

		for (int x=0; x<players.size()-1; x++){
			for (int y=x+1; y<players.size(); y++){
				int F1 = players.get(x);
				int F2 = players.get(y);
				if (F1 != 1 && F2 != 1){
					if (F1%F2 == 0){
						players.remove(x);
						x = 0;
						y = 0;
					}else if(F2%F1 == 0){
						players.remove(y);
						x = 0;
						y = 0;
					}
				}
			}
		}

		// return LCM of remaining freqencies
		int LCM = LCM (players);
		if (LCM >= L && LCM <= H){
			return LCM + "";
		}else if(LCM < L) {
			
			// multiply LCM to make it in range [L,H]
			int low = L / LCM;
			int high = H / LCM;
			for (int x=low; x<=high; x++){
				int value = LCM * x;
				if (value >= L && value <= H){
					return value + "";
				}
			}
			
		}
		
		return "NO";
		
	}

	private int LCM(ArrayList<Integer> a){
		int result = a.get(0);
		for (int x=1; x<a.size(); x++){
			result = LCM(result, a.get(x));
		}
		return result;
	}

	private int LCM(int x,int y){
		// calculate the Lowest Common Multiple of x and y
		return x * y / HCF(x, y);
	}

	private int HCF(int x,int y){
		// returns the Highest Common Factor (Greatest Common Divisor) of x and y
		if(x < y){
			int temp = x;
			x = y;
			y = temp;
		}
		while(true){
			int reminder = x % y;
			if (reminder == 0){
				return y;
			}else {
				x = y;
				y = reminder;
			}
		}
	}


	// CodeJam Utility Methods:

	public void newCodeJam(){
		System.out.print("\f");
		// open input file
		try {
			fileScanner = new Scanner(new File(inputFile));
		}catch(IOException e) {}
		// open output file
		try {
			output = new PrintStream(new File(outputFile));
		}catch(IOException ex) {}
	}

	public void println(String s){
		outputLine++;
		output.println("Case #" + outputLine + ": " + s);
	}

	public static void main(String[] args){
		new Main();
	}

}