import java.util.*;

public class Combinations {

	static ArrayList<String> intermediate;
 
	public static ArrayList<Integer[]> getAll(ArrayList<Integer> input){
		// return ArrayList of every combination
		// to only select combinations of r length: insert int r as parameter in getAll() and make int[] array be size r.
		
		intermediate = new ArrayList<String>();
		String alphabet = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
	    String elements = alphabet.substring(0, input.size());
		combin(elements); // generate ArrayList intermediate
		
		// convert intermediate to output using input
		ArrayList<Integer[]> output = new ArrayList<Integer[]>(); 
		for (String s : intermediate){
			//if (s.length() == r) // to only select combinations of r length: insert int r as parameter in getAll() and make int[] array be size r instead of int size.
				int size = s.length();
				Integer[] array = new Integer[size];
				for (int i=0; i<size; i++){
					int x = getIndex(s.charAt(i));
					array[i] = input.get(x); 
				}
				output.add(array);
			// }
		}
		
		output.remove(0); // remove ""
		return output;
	}
	
	
	private static void combin(String s) {
    	combin("", s);
    }
    private static void combin(String prefix, String s) {
    	intermediate.add(prefix);
        for (int i = 0; i < s.length(); i++)
            combin(prefix + s.charAt(i), s.substring(i + 1));
    }  
    
    private static int getIndex(char c){
    	// convert letter to number
    	if (c >= 97 && c <= 122){ // a = 0, b = 1
    		return c - 97;
    	}else {
    		return c - 39; // A = 26, B = 27
    	}
    }
    
}