/*
* Created by Daniel on Jul 16, 2008 at 10:17:53 PM
* $LastChangedBy$
* $LastChangedDate$
* $LastChangedRevision$
*/

import java.io.*;
import java.util.*;

public class Trains {
    public static void main( String[] args ) throws IOException {
        BufferedReader f = new BufferedReader( new FileReader( args[0] ) );
        BufferedWriter o = new BufferedWriter( new FileWriter( "out.txt" ) );

        try {
            int line = Integer.parseInt( f.readLine() );
            for( int l = 1; l <= line; l++ ) {
                o.append( "Case #" + l + ": " );
                o.append( doCase( f ) );
            }
        } finally {
            f.close();
            o.close();
        }
    }

    private static CharSequence doCase( BufferedReader f ) throws IOException {
        int turn = Integer.parseInt( f.readLine() );
        String[] trains = f.readLine().split( " " );
        int ab = Integer.parseInt( trains[0] );
        int ba = Integer.parseInt( trains[1] );

        List abs = new ArrayList(100);
        List bas = new ArrayList(100);

        for( int l = 0; l < ab; l++ ) {
            abs.add( time( f, turn ) );
        }

        for( int l = 0; l < ba; l++ ) {
            bas.add( time( f, turn ) );
        }

        Collections.sort( abs, new Comparator() {
            public int compare( Object o1, Object o2 ) {
                return Integer.valueOf( ((TrainTime)o1).start ).compareTo( Integer.valueOf( ((TrainTime)o2).start ) );
            }
        } );
        Collections.sort( bas, new Comparator() {
            public int compare( Object o1, Object o2 ) {
                return Integer.valueOf( ((TrainTime)o1).start ).compareTo( Integer.valueOf( ((TrainTime)o2).start ) );
            }
        } );

        return solve( abs, bas ) + '\n';
    }

    private static void travel( int currentTime, List<TrainTime> go, List<TrainTime> dontgo ) {
        Iterator<TrainTime> t = go.iterator();
        while( t.hasNext() ) {
            TrainTime tt = t.next();
            if( tt.start >= currentTime ) {
                t.remove();
                travel( tt.end + tt.turn, dontgo, go );
                return;
            }
        }

    }

    private static String solve( List<TrainTime> abs, List<TrainTime> bas ) {
        int trainsA = 0;
        int trainsB = 0;

        while( !abs.isEmpty() && !bas.isEmpty() ) {
            TrainTime a = abs.get( 0 );
            TrainTime b = bas.get( 0 );
            if( a.start < b.start ) {
                trainsA++;
                travel( 0, abs, bas );
            } else {
                trainsB++;
                travel( 0, bas, abs );
            }
        }

        trainsA += abs.size();
        trainsB += bas.size();

        return trainsA + " " + trainsB;
    }

    private static TrainTime time( BufferedReader f, int turn ) throws IOException {
        String[] sch = f.readLine().split( " " );
        String[] t = sch[0].split( ":" );
        int start = Integer.parseInt( t[0] ) * 60;
        start += Integer.parseInt( t[1] );

        t = sch[1].split( ":" );
        int end = Integer.parseInt( t[0] ) * 60;
        end += Integer.parseInt( t[1] );

        return new TrainTime( start, end, turn );
    }
    static class TrainTime {
        int start, end, turn;
        TrainTime( int s, int e, int t ) {
            start = s;
            end = e;
            turn = t;
        }
    }
}
