import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Scanner;

public class Pancakes {

	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(new File("pancakes\\B-large.in")))));
//		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int t = Integer.parseInt(in.nextLine());
		boolean[][] inputs = new boolean[t][];
		int[] outputs = new int[t];
		
		for (int i = 0; i < t; i++) {
			String line = in.nextLine();
			inputs[i] = new boolean[line.length()];
			for (int j = 0; j < line.length(); j++){
				inputs[i][j] = (line.charAt(j) == '+');
			}
		}
		
		for (int i = 0; i < inputs.length; i++) {
			boolean[] input = inputs[i];
			outputs[i] = getNumberOfStepsForAllPositives(input);
		}

		for (int i = 0; i < inputs.length; i++) {
			System.out.println("Case #" + (i+1) + ": " + outputs[i]);			
		}
	}
	
	private static int getNumberOfStepsForAllPositives(boolean[] input) {
		int numberOfFlippes = 0;
		boolean isTherePlusBefore = false;
		for (int currentLocation = 0; currentLocation < input.length;) {
			
			if (!input[currentLocation]) { // reached a minus
				int minusStreak = 1;
				if (currentLocation + 1 < input.length) {
					for (int startMinusStreak = currentLocation+1; startMinusStreak < input.length; startMinusStreak++) {
						if (!input[startMinusStreak]) {
							minusStreak += 1;
						}
						else {
							break;
						}
					}					
				}
				
				if (isTherePlusBefore) {
					numberOfFlippes += 2; 
				}
				else { 
					numberOfFlippes += 1;
				}
				currentLocation += minusStreak;
			}
			else { // reached a plus
				isTherePlusBefore = true;
				currentLocation +=1;
			}
		}
		return numberOfFlippes;
	}
}
