import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.Scanner;

public class CoinJam {

	private static class BooleanAndNumberPair {
		final boolean bool;
		final long number;
		
		public BooleanAndNumberPair(boolean bool, long number) {
			this.bool = bool;
			this.number = number;
		}
	}
	
	static int bigIntegersCacheSize = 100;
	static BigInteger[] bigIntegers = new BigInteger[bigIntegersCacheSize];
	static {
		for (int c = 0; c < bigIntegersCacheSize; c++) {
			bigIntegers[c] = BigInteger.valueOf((long) c);
		}
	}
	
	public static void main(String[] args) throws FileNotFoundException {
//		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(new File("coinJam\\C-small-attempt0.in")))));
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int t = in.nextInt();
		int N = in.nextInt();
		int J = in.nextInt();
		
		int max_combinations = (int) Math.pow(2, N - 2);
		int counterOfFound = 0;
		System.out.println("Case #1:");
		for (int i = 0; i < max_combinations && counterOfFound < J; i++) {
			String currentBinary = "1" + String.format("%"+(N-2)+"s", Integer.toBinaryString(i)).replace(' ', '0') + "1";
			int[] divisors = new int[9];
			if (checkIfBinaryIsCoinJam(currentBinary, divisors)) {
				counterOfFound++;
				System.out.print(currentBinary + " ");
				for (int j = 0; j < 8; j++) {
					System.out.print(divisors[j] + " ");
				}
				System.out.println(divisors[8]);
			}
		}
	}
	
	private static boolean checkIfBinaryIsCoinJam(String currentBinary, int[] divisors) {
		for (int base = 2; base <= 10; base++) {
			BooleanAndNumberPair result;
			try {
				long currentNumberInCurrentBase = Long.parseLong(currentBinary, base);
				result = isPrime(currentNumberInCurrentBase);
			} catch (Exception e) {
				BigInteger currentNumberInCurrentBase = new BigInteger(currentBinary, base);
				result = isPrime(currentNumberInCurrentBase);	
			}

			if (result.bool) {
				return false;
			}
			else {
				divisors[base-2] = (int) result.number;
			}
		}
		return true;
	}

	private static BooleanAndNumberPair isPrime(long n) {
	    if (n%2==0) return new BooleanAndNumberPair(false, 2);
	    
	    long i = 3;
	    for(i=3;i*i<=n;i+=2) {
	        if(n%i==0)
	            return new BooleanAndNumberPair(false, i);
	    }
	    return new BooleanAndNumberPair(true, 0);
	}
	
	private static BooleanAndNumberPair isPrime(BigInteger n) {
		if (n.mod(bigIntegers[2]).intValue() == 0) return new BooleanAndNumberPair(false, 2);	    
	    for(int i=3; i<bigIntegersCacheSize; i+=2) {
	        BigInteger ibig = bigIntegers[i];
	    	if(n.mod(ibig).intValue() == 0)
	            return new BooleanAndNumberPair(false, i);
	    }
	    return new BooleanAndNumberPair(true, 0);
	}
}
