import java.util.Arrays;
import java.util.Scanner;

public class DeceitfulWar {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int cases = scanner.nextInt();
        for (int i = 1; i <= cases; i++) {
            int blocks = scanner.nextInt();
            double[] naomi = readMasses(scanner, blocks);
            double[] ken = readMasses(scanner, blocks);
            System.out.print("Case #" + i + ": ");
            calculate(naomi, ken);
        }
        scanner.close();
    }

    private static void calculate(double[] naomi, double[] ken) {
        Arrays.sort(naomi);
        Arrays.sort(ken);

        int scoreKen = 0;
        while (!allGreaterThan(naomi, ken, scoreKen)) {
            scoreKen++;
        }
        System.out.println((naomi.length - scoreKen) + " " + calculateWar(naomi, ken));
    }

    private static boolean allGreaterThan(double[] naomi, double[] ken, int offset) {
        for (int i = naomi.length - 1; i >= offset; i--) {
            if (ken[i - offset] > naomi[i]) return false;
        }
        return true;
    }

    private static int calculateWar(double[] naomi, double[] ken) {
        int kk = 0;
        int scoreKen = 0;

        for (double n : naomi) {
            for (int i = kk; i < ken.length; i++) {
                if (ken[i] > n) {
                    scoreKen++;
                    kk = i + 1;
                    break;
                }
            }
        }

        return naomi.length - scoreKen;
    }

    private static double[] readMasses(Scanner scanner, int blocks) {
        double[] masses = new double[blocks];
        for (int i = 0; i < masses.length; i++) {
            masses[i] = scanner.nextDouble();
        }
        return masses;
    }

}
