import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;



/**
 * @author Daniel Barboza Franco
 * 
 */

public class TrainTimetable {

	private static BufferedReader in;
	
	static int a,b;
	static int na, nb;
	static int t;
	//static int lab,lba; // last index on arrival array
	
	private static int readInt() throws Exception{
		return Integer.parseInt(in.readLine());
	}
	

	private static int whichArrival(int na, int[] a, int l, int train) {
		
		int i;
		for(i=l+1; i<na; i++){
			
			if (a[i]+t <= train) {
			
				return i; 
			}
			
		}
		
		return l;
	}
	
	
	static int computeTrains(int nd,int d[], int na, int a[]) {
	
		int l = -1; // last useful arrival
		int trains = 0;
		
		int arrival=-1;
		
		for(int i=0; i < nd; i++){
			int departure = d[i];

			/*
			if (l<na) {
				arrival = whichArrival(na,a,l,departure);
				
			}
			else {
				trains+=1;
			}
			*/

			arrival = whichArrival(na,a,l,departure);
			
			if (arrival>l) {
				l=arrival;
			}
			else {
				trains+=1;
			}

			
		}
		
		return trains;
	}
	
	
	private static void readInMinutes(int[] d, int[] a, int i) throws Exception {

		StringTokenizer str = new StringTokenizer(in.readLine());

		
		int hd = Integer.parseInt(str.nextToken(": "));
		int md = Integer.parseInt(str.nextToken(": "));

		int ha = Integer.parseInt(str.nextToken(": "));
		int ma = Integer.parseInt(str.nextToken(": "));

		
		d[i] = hd * 60 + md;
		a[i] = ha * 60 + ma;
		
	}

	public static void caseN() throws Exception{
		
		t = readInt();
		a=b=0;
			
		StringTokenizer nanb = new StringTokenizer(in.readLine());
		na = Integer.parseInt(nanb.nextToken());
		nb = Integer.parseInt(nanb.nextToken());
		
		// departure and arrival arrays
		int dab[] = new int[na];
		int aab[] = new int[na];
		int dba[] = new int[nb];
		int aba[] = new int[nb];
		
		for(int ia=0; ia < na; ia++){
			readInMinutes(dab,aab,ia);
		}

		for(int ib=0; ib < nb; ib++){
			readInMinutes(dba,aba,ib);
		}

		Arrays.sort(dab);
		Arrays.sort(dba);
		Arrays.sort(aab);
		Arrays.sort(aba);

		a = computeTrains(na, dab, nb, aba);
		b = computeTrains(nb, dba, na, aab);

		System.out.println(a + " " + b);
	}
	


	public static void main(String[] args) throws Exception{

		
		in = new BufferedReader(new InputStreamReader(System.in));
		int n = readInt();
		
		for (int c = 1; c <= n; c++) {
			
			System.out.print("Case #" + c + ": ");
			caseN();
		}
	}

}
