import java.util.*;
import java.io.*;
import java.nio.*;
import java.nio.channels.*;

class Main {

    static BufferedReader reader;
    static StringTokenizer tokenizer;
	static PrintWriter out = new PrintWriter(Channels.newWriter(Channels.newChannel(System.out), "US-ASCII") );


    static void init(InputStream input) {
        reader = new BufferedReader(new InputStreamReader(input) );
        tokenizer = new StringTokenizer("");
    }

    static boolean hasNext() {
    	boolean eof = false;
    	String line = null;
    	
    	try {
			while (!eof && !tokenizer.hasMoreTokens()) {
				line = reader.readLine();
				
				if (line != null) {
					tokenizer = new StringTokenizer(line);
				}
				else {
					eof = true;
				}
			}
		}
		catch (Exception e) {
		}
        
        return !eof;
    }
    
    static String next() {
    
    	try {
			while ( ! tokenizer.hasMoreTokens() ) {
				tokenizer = new StringTokenizer(reader.readLine() );
			}
			
		}
		catch (Exception e) {
		
		}
        
        return tokenizer.nextToken();
    }

    static Integer nextInt() {
    	Integer ret = null;
    	
    	try {
    		ret = Integer.parseInt(next());
    	}
    	catch (Exception e) {
    	}
    	
        return ret;
    }

    static Double nextDouble() {
    	Double ret = null;
    	
    	try {
    		ret = Double.parseDouble(next());
    	}
    	catch (Exception e) {
    	}
    	
        return ret;
    }



	static double calculate(double c, double f, double x) {
		//ArrayList<Double> time = new ArrayList<Double>();
		//time.add(0.0);
		double ftime = 0.0;
		double time = x/2.0;
		double last = x; 
		int farms=0;
		
		while (time <= last) {
			if (farms > 0) {
				ftime = ftime + c/(f*(farms-1) + 2.0);
			}
			
			last = time;
			time = ftime + x/(f*farms + 2.0);
			farms++;
		}
	
		return last;
	}	

	public static void main (String args[]) {

		init(System.in);

		int t = nextInt();
		int tcase = 1;
		double c, f, x, time;

		while (hasNext()) {
			c = nextDouble();
			f = nextDouble();
			x = nextDouble();
			
			time = calculate(c, f, x);
			out.println("Case #" + tcase++ + ": " + String.format("%.7f", time));
		}
		out.close();
	}
}
