import java.util.*;
import java.io.*;
import java.nio.*;
import java.nio.channels.*;

class Main {

    static BufferedReader reader;
    static StringTokenizer tokenizer;
	static PrintWriter out = new PrintWriter(Channels.newWriter(Channels.newChannel(System.out), "US-ASCII") );


    static void init(InputStream input) {
        reader = new BufferedReader(new InputStreamReader(input) );
        tokenizer = new StringTokenizer("");
    }

    static boolean hasNext() {
    	boolean eof = false;
    	String line = null;
    	
    	try {
			while (!eof && !tokenizer.hasMoreTokens()) {
				line = reader.readLine();
				
				if (line != null) {
					tokenizer = new StringTokenizer(line);
				}
				else {
					eof = true;
				}
			}
		}
		catch (Exception e) {
		}
        
        return !eof;
    }
    
    static String next() {
    
    	try {
			while ( ! tokenizer.hasMoreTokens() ) {
				tokenizer = new StringTokenizer(reader.readLine() );
			}
			
		}
		catch (Exception e) {
		
		}
        
        return tokenizer.nextToken();
    }

    static Integer nextInt() {
    	Integer ret = null;
    	
    	try {
    		ret = Integer.parseInt(next());
    	}
    	catch (Exception e) {
    	}
    	
        return ret;
    }

	static int readCards(HashSet<Integer> row, int row_num) {
		int rep=0;
		int card=0;
		int num;
	
		for (int r=1; r<=4; r++) {
			for(int c=1; c<=4; c++) {
				num = nextInt();
				if (r==row_num  && !(row.add(num)))  {
					rep++;
					card = num;
				}
			}
		}
	
		return (rep == 1) ? card : -rep;
	
	}

	static void showRes(int tcase, int card) {
	
		out.print("Case #" + tcase + ": ");
		String res = "" + card;
	
		if (card <= 0) {		
			switch (-card) {
				case 0: res = "Volunteer cheated!";
						break;
				default: res = "Bad magician!"; 
						break;
			}
		}

		out.println(res);
	
	}

	public static void main (String args[]) {

		init(System.in);
		int t = nextInt();
		int tcase=0;
		
		HashSet<Integer> row;
		int fst;
		int sec;
		int card;
		
		
		while (hasNext()) {
			tcase++;
			
			row = new HashSet<Integer>();
			fst = nextInt();
			readCards(row, fst);

			sec = nextInt();						
			card = readCards(row, sec);

			showRes(tcase, card);

		}
		
		out.close();
	}
}
