import java.io.*;
import java.util.*;
public class B {
	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int T = Integer.parseInt(br.readLine());
		for(int i = 1; i <= T; i++) {
			String plate = br.readLine();
			System.out.println("Case #" + i + ": " + solve(plate));
		}
	}
	
	public static int solve(String plate) {
		int sz = plate.length();
		StringBuilder sb = new StringBuilder();
		for(int i = 0; i < sz; i++) sb.append("+");
		String goal = sb.toString();
		if(plate.equals(goal)) return 0;
		int ans = 0;
		HashSet<String> visited = new HashSet<String>(1000000);
		LinkedList<Pair> q = new LinkedList<>();
		q.add(new Pair(plate,0));
		while(!q.isEmpty()) {
			Pair cur = q.remove();
			if(cur.plate.equals(goal)) return cur.d;
			if(visited.contains(cur.plate)) continue;
			visited.add(cur.plate);
			for(int i = 1; i <= sz; i++) {
				String aux = flip(cur.plate, i);
				if(!visited.contains(aux)) q.add(new Pair(aux,cur.d+1));
			}
		}
		return -1;
	}
	
	public static String flip(String plate, int idx) {
		plate = new StringBuilder(plate.substring(0,idx)).reverse().toString() + plate.substring(idx,plate.length()); 
		char[] c = plate.toCharArray();
		for(int i = 0; i < idx; i++) {
			if( c[i] == '+' ) c[i] = '-';
			else c[i] = '+';
		}
		return new StringBuilder().append(c).toString();
	}
	
	protected static class Pair {
		String plate;
		int d;
		
		public Pair(String plate, int d) {
			this.plate = plate;
			this.d = d;
		}
	}
}
