package utils;

import java.io.FileWriter;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

public class Utils {
	
	// ouverture en ecriture d'un fichier
	// Rend un BufferedWriter --null si pas possible de l'crire
	
	public static BufferedWriter openWriteFile(File f){
		BufferedWriter bw = null;
		try{
			FileWriter fw = new FileWriter(f);
			bw = new BufferedWriter(fw);
		}catch (IOException ioe) {}
		if(bw == null) System.out.println(f.getAbsolutePath());
		return bw;
	}
	
	/**
	 *  Ouverture d'un fichier en lecture
	 *  Rend egalement un BufferedReader a --null si pas possible de l'ouvrir
	 * @param f fichier ) ouvrir
	 * @return
	 */
	
	
	public static BufferedReader openReadFile(File f){
		BufferedReader br = null;
		try{
			FileReader fr = new FileReader(f);
			br = new BufferedReader(fr);
		}catch(IOException ioe) {}
		if(br == null) System.out.println(f.getAbsolutePath());
		return br;
	}
	
	/**
	 *  Lecture dans un BufferedReader d'une chaine de caracteres
	 * @param br Buffered  lire
	 * @return la chaine lue
	 */
	
	public static String loadString(BufferedReader br){
		String s = "";
		try{
			s = br.readLine();
		}catch(IOException ioe) {}
		return s;
	}

	// La lecture d'un entier n'estqu'un parseInt de plus !!
	public static int readInteger(BufferedReader br) {
		return Integer.parseInt(loadString(br));
	}
	
	
	public static void ecrire(BufferedWriter bw,String chaine){
	    //File f = new File(chemin);
	    //BufferedWriter bw=openWriteFile(f);		
			try {
				bw.write(chaine);
				bw.newLine();
				//bw.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
	}
}
