import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Scanner;

public class CoinJam {

	private static int MAX_N = 16;
	private static int MAX_J = 50;

	private static Map<Integer, Map<String, List<Long>>> jamcoins = new HashMap<>();

	public static void main(String[] args) throws Exception {

		preComputeJamCoins();

		System.out.println("PRE COMPUTING FINISHED");

		Scanner scanner = new Scanner(System.in);
		while (true) {
			try {
				scanner.nextLine();

				String[] line = scanner.nextLine().split(" ");
				int n = Integer.parseInt(line[0]);
				int j = Integer.parseInt(line[1]);

				System.out.println("Case #1:");
				Map<String, List<Long>> jcs = jamcoins.get(n);
				int count = 0;
				for (Entry<String, List<Long>> jc : jcs.entrySet()) {
					count++;
					String list = jc.getValue().toString();
					System.out.println(String.format("%s %s", jc.getKey(), list.substring(1, list.length() - 1)).replaceAll(",", ""));
					if (count == j) {
						break;
					}
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	private static void preComputeJamCoins() {
		for (int i = 2; i <= MAX_N; i++) {
			String number = createNumber(i - 2);
			int jProduced = 0;

			while (number.contains("0")) {

				List<Long> divisors = getDivisors(number);
				if (divisors != null) {
					Map<String, List<Long>> jamcoinsN;
					if (jamcoins.containsKey(i)) {
						jamcoinsN = jamcoins.get(i);
					} else {
						jamcoinsN = new LinkedHashMap<String, List<Long>>();
						jamcoins.put(i, jamcoinsN);
					}

					jamcoinsN.put(number, divisors);

					jProduced++;
					System.out.println("JAM COINS FOUNDED =  " + jProduced);
				}

				if (jProduced == MAX_J) {
					break;
				}
				do {
					number = Integer.toString(Integer.parseInt(number, 2) + 1, 2);
				} while (!number.startsWith("1") || !number.endsWith("1"));

			}
			System.out.println("FINISHED " + i);
		}
	}

	private static String createNumber(int zeros) {
		StringBuilder sb = new StringBuilder();
		sb.append('1');
		for (int i = 0; i < zeros; i++) {
			sb.append('0');
		}
		sb.append('1');
		return sb.toString();
	}

	private static List<Long> getDivisors(String jamCoin) {
		List<Long> divisors = new ArrayList<Long>();
		for (int i = 2; i <= 10; i++) {
			long n = Long.parseLong(jamCoin, i);
			long divisor = getDivisor(n);
			if (divisor == -1) {
				return null;
			}
			divisors.add(divisor);
		}
		return divisors;
	}

	private static long getDivisor(long num) {
		if (num == 2)
			return -1;
		if (num % 2 == 0)
			return 2;
		for (int i = 3; i * i <= num; i += 2)
			if (num % i == 0)
				return i;
		return -1;
	}
}
