import java.io.BufferedReader;
import java.io.InputStreamReader;

public class TicTacToe {

	public static void main(String[] args) throws Exception {
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		int n = Integer.parseInt(reader.readLine());
		for (int i = 0; i < n; i++) {
			String[] table = new String[4];
			for (int x = 0; x < 4; x++) {
				table[x] = reader.readLine();
			}

			System.out.print("Case #" + (i + 1) + ": ");

			if (!horizontal(table) && !vertical(table) && !diagonal(table) && !gameNotCompleted(table)) {
				System.out.println("Draw");
			}

			reader.readLine();
		}
	}

	public static boolean horizontal(String[] table) {
		// horizontal
		for (int x = 0; x < 4; x++) {
			if (table[x].replaceFirst("X*T?X*", "").isEmpty()) {
				System.out.println("X won");
				return true;
			} else if (table[x].replaceFirst("O*T?O*", "").isEmpty()) {
				System.out.println("O won");
				return true;
			}
		}
		return false;
	}

	public static boolean vertical(String[] table) {
		// vertical
		String[] vertical = new String[4];
		for (int x = 0; x < 4; x++) {
			StringBuilder sb = new StringBuilder();
			sb.append(table[0].charAt(x));
			sb.append(table[1].charAt(x));
			sb.append(table[2].charAt(x));
			sb.append(table[3].charAt(x));
			vertical[x] = sb.toString();
		}

		for (int x = 0; x < 4; x++) {
			if (vertical[x].replaceFirst("X*T?X*", "").isEmpty()) {
				System.out.println("X won");
				return true;
			} else if (vertical[x].replaceFirst("O*T?O*", "").isEmpty()) {
				System.out.println("O won");
				return true;
			}
		}
		return false;

	}

	public static boolean diagonal(String[] table) {
		// diagonal
		String[] diagonal = new String[2];
		StringBuilder sb = new StringBuilder();
		sb.append(table[0].charAt(0));
		sb.append(table[1].charAt(1));
		sb.append(table[2].charAt(2));
		sb.append(table[3].charAt(3));
		diagonal[0] = sb.toString();
		sb = new StringBuilder();
		sb.append(table[0].charAt(3));
		sb.append(table[1].charAt(2));
		sb.append(table[2].charAt(1));
		sb.append(table[3].charAt(0));
		diagonal[1] = sb.toString();

		for (int x = 0; x < 2; x++) {
			if (diagonal[x].replaceFirst("X*T?X*", "").isEmpty()) {
				System.out.println("X won");
				return true;
			} else if (diagonal[x].replaceFirst("O*T?O*", "").isEmpty()) {
				System.out.println("O won");
				return true;
			}
		}
		return false;
	}

	public static boolean gameNotCompleted(String[] table) {
		for (int x = 0; x < 4; x++) {
			if (table[x].contains(".")) {
				System.out.println("Game has not completed");
				return true;
			}
		}
		return false;
	}

}
