package yr2016.round2;

import utils.FileIO;

import java.io.IOException;

public class A {
    public static void main(String[] args) throws IOException {
        FileIO io = new FileIO(A.class);
        A solution = new A();
        int T = Integer.parseInt(io.readLine());

        for (int t = 1; t <= T; t++) {
            int N = io.readInteger();
            int R = io.readInteger();
            int P = io.readInteger();
            int S = io.readInteger();
            char[] result = solution.solve(N, R, P, S);
            io.writeLineWithHeader(t, solution.reorder(String.copyValueOf(result)));

        }
        io.close();
    }

    private String reorder(String result) {
        if(result.equals("IMPOSSIBLE")){return result;}
        if(result.length() == 1){return result;}
        String first = reorder(result.substring(0, result.length() / 2));
        String second = reorder(result.substring(result.length() / 2, result.length()));
        if(first.compareTo(second) > 0){
            return second + first;
        }
        return  first + second;
    }

    private char[] solve(int n, int r, int p, int s) {
        if(n % 3 == 1){
            if(p == r && Math.abs(p - s) == 1){
                return build(n, 'P');
            }
            if(r == s && Math.abs(r - p) == 1){
                return build(n, 'R');
            }
            if(p == s && Math.abs(r - p) == 1){
                return build(n, 'S');
            }
        }
        if(n % 3 == 2){
            if(p == r && Math.abs(p - s) == 1){
                return build(n, 'R');
            }
            if(r == s && Math.abs(r - p) == 1){
                return build(n, 'S');
            }
            if(p == s && Math.abs(r - p) == 1){
                return build(n, 'P');
            }
        }
        if(n % 3 == 0){
            if(p == r && Math.abs(p - s) == 1){
                return build(n, 'S');
            }
            if(r == s && Math.abs(r - p) == 1){
                return build(n, 'P');
            }
            if(p == s && Math.abs(r - p) == 1){
                return build(n, 'R');
            }
        }
        return "IMPOSSIBLE".toCharArray();
    }

    private char[] build(int n, char ch) {
        if(n == 1){
            char[] cur = new char[2];
            if(ch == 'P'){
                cur[0] = 'P';
                cur[1] = 'R';
            } else if(ch == 'R'){
                cur[0] = 'R';
                cur[1] = 'S';
            } else if(ch == 'S'){
                cur[0] = 'P';
                cur[1] = 'S';
            }
            return cur;
        }
        char[] next = build(n - 1, ch);
        char[] cur = new char[1 << n];
        for (int i = 0; i < next.length; i ++){
            if(next[i] == 'P'){
                cur[(i<<1)] = 'P';
                cur[(i<<1) + 1] = 'R';
            } else if(next[i] == 'R'){
                cur[(i<<1)] = 'R';
                cur[(i<<1) + 1] = 'S';
            }else if(next[i] == 'S'){
                cur[(i<<1)] = 'P';
                cur[(i<<1) + 1] = 'S';
            }
        }
        return cur;
    }
}