import java.util.*;
import java.io.*;

public class C_solution {

    final static String FNAME = "c";

    public Scanner in;
    public PrintWriter out;

    public final static String PATTERN = "welcome to code jam";
    final static int MAX_SOURCE_SIZE = 500;
    final static int PATTERN_SIZE = PATTERN.length();

    int[][] table;

    void open() throws IOException {
        in = new Scanner(new File(FNAME + ".in"));
        out = new PrintWriter(new File(FNAME + ".out"));
    }

    void close() throws IOException {
        in.close();
        out.close();
    }

    private int search(String source, int start_source, int start_pattern) {
        int source_length = source.length();
        if (table[start_source][start_pattern] != -1) {
            return table[start_source][start_pattern];
        }
        if (source_length - start_source < PATTERN_SIZE - start_pattern) {
            table[start_source][start_pattern] = 0;
            return 0;
        }
        if (source_length - start_source == PATTERN_SIZE - start_pattern) {
            String subSource = source.substring(start_source, source_length);
            String subPattern = PATTERN.substring(start_pattern, PATTERN_SIZE);
            table[start_source][start_pattern] = (subSource.equals(subPattern)) ? 1 : 0;
            return table[start_source][start_pattern];
        }
        int total = 0;
        total += search(source, start_source + 1, start_pattern);
        total %= 10000;
        if (source.charAt(start_source) == PATTERN.charAt(start_pattern)) {
            total += search(source, start_source + 1, start_pattern + 1);
            total %= 10000;
        }
        table[start_source][start_pattern] = total;
        return total;
    }

    void run() {
        int tests = in.nextInt();
        in.nextLine();
        for (int i = 0; i < tests; i++) {
            String line = in.nextLine();
            table = new int[MAX_SOURCE_SIZE + 1][PATTERN_SIZE + 1];
            for (int j = 0; j < MAX_SOURCE_SIZE; j++) {
                for (int k = 0; k < PATTERN_SIZE; k++) {
                    table[j][k] = -1;
                }
            }
            int ans = search(line, 0, 0);
            int num = i + 1;
            out.print("Case #" + num + ": ");
            out.format("%04d%n", ans);
        }
    }

    public static void main(String[] args) throws IOException {
        C_solution solution = new C_solution();
        solution.open();
        solution.run();
        solution.close();
    }

}