import java.util.*;
import java.io.*;

public class B_solution {

    final static String FNAME = "b";
    final static int[] x_step = { 0, -1, 1, 0};
    final static int[] y_step = {-1,  0, 0, 1};

    public Scanner in;

    public PrintWriter out;

    void open() throws IOException {
        in = new Scanner(new File(FNAME + ".in"));
        out = new PrintWriter(new File(FNAME + ".out"));
    }

    void close() throws IOException {
        out.close();
    }

    private void go(int[][] mask, char[][] ans, int j, int k, char cur){
        if (ans[j][k] >= 'a' && ans[j][k] <= 'z') {
            return;
        }
        ans[j][k] = cur;
        for (int i = 0; i < 4; i++) {
            int msk = 1 << i;
            if ((msk & mask[j][k]) == msk) {
                go(mask, ans, j + y_step[i], k + x_step[i], cur);
            }
        }
    }

    void run() {
        int tests = in.nextInt();
        for (int i = 0; i < tests; i++) {
            int height = in.nextInt();
            int width = in.nextInt();
            int[][] field = new int[105][105];
            for (int j = 0; j < height; j++) {
                for (int k = 0; k < width; k++) {
                    field[j][k] = in.nextInt();
                }
            }

            int[][] mask = new int[105][105];
            for (int j = 0; j < height; j++) {
                for (int k = 0; k < width; k++) {
                    int ind = -1;
                    int min = field[j][k];
                    for (int l = 0; l < 4; l++) {
                        int x = k + x_step[l];
                        int y = j + y_step[l];
                        if (x >= 0 && y >= 0 && x < width && y < height && field[y][x] < min) {
                            ind = l;
                            min = field[y][x];
                        }
                    }
                    if (ind != -1) {
                        mask[j][k] |= 1 << ind;
                        mask[j + y_step[ind]][k + x_step[ind]] |= 1 << (3 - ind);
                    }
                }
            }

            char[][] ans = new char[105][105];
            char cur = 'a';
            for (int j = 0; j < height; j++) {
                for (int k = 0; k < width; k++) {
                    if (ans[j][k] < 'a' || ans[j][k] > 'z') {
                        go(mask, ans, j, k, cur);
                        cur++;
                    }
                }
            }


            int num = i + 1;
            out.println("Case #" + num + ":");
            for (int j = 0; j < height; j++) {
                for (int k = 0; k < width; k++) {
                    out.print(ans[j][k] + " ");
                }
                out.println();
            }
        }
    }

    public static void main(String[] args) throws IOException {
        B_solution solution = new B_solution();
        solution.open();
        solution.run();
        solution.close();
    }

}