import java.io.*;
import java.util.Locale;
import java.util.Scanner;

/**
 * Author: Daniil Tutubalin
 */
public class PasswordProblem {

    public static void main(String[] args) {
        try {
            Scanner input = new Scanner(new File("input.txt"));
            PrintStream output = new PrintStream(new FileOutputStream("output.txt"));
            solveTask(input, output);
        } catch (FileNotFoundException e) {
            System.out.println("input.txt not found");
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    private static void solveTask(Scanner input, PrintStream output) {

        input.useLocale(Locale.US); // use decimal point, not comma

        int testsCount = input.nextInt();

        for (int test=1; test<=testsCount; test++) {

            int typed = input.nextInt();
            int total = input.nextInt();

            double[] probChar = new double[typed];
            double[] allCorrectBefore = new double[typed+1];
            allCorrectBefore[0] = 1;

            double temp = 1;

            for (int i=0; i<typed; i++) {
                double prob = input.nextDouble();
                probChar[i] = prob;
                temp *= prob;
                allCorrectBefore[i+1] = temp;
            }

            double min = total+2; // if enter right away
            for (int i=0; i<=typed; i++) {
                double correctProb = allCorrectBefore[i];
                double incorrectProb = 1-correctProb;
                int backspaces = typed-i;
                int keystrokesIfCorrect = backspaces+(total-i)+1;
                int keystrokesIfIncorrect = keystrokesIfCorrect+total+1;
                double prob = correctProb*keystrokesIfCorrect + incorrectProb*keystrokesIfIncorrect;
                if (prob<min) min = prob;
            }

            String answer = String.format(Locale.UK, "%1.6f", min);


            System.out.print("Case #"+test+": ");
            System.out.println(answer);
            output.print("Case #"+test+": ");
            output.println(answer);
        }
    }
    


}
