import java.io.*;
import java.util.Scanner;

/**
 * Author: Daniil Tutubalin
 */
public class KingdomRush {

    private static int levels;
    private static int[] threshold1;
    private static int[] threshold2;
    private static boolean[] visited;
    private static boolean[] complete;
    private static int minLevelsVisited;

    public static void main(String[] args) {
        try {
            Scanner input = new Scanner(new File("input.txt"));
            PrintStream output = new PrintStream(new FileOutputStream("output.txt"));
            solveTask(input, output);
        } catch (FileNotFoundException e) {
            System.out.println("input.txt not found");
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    private static void solveTask(Scanner input, PrintStream output) {

        int testsCount = input.nextInt();

        for (int test=1; test<=testsCount; test++) {

            levels = input.nextInt();

            threshold1 = new int[levels];
            threshold2 = new int[levels];

            for (int i=0; i<levels; i++) {
                threshold1[i] = input.nextInt();
                threshold2[i] = input.nextInt();
            }

            visited = new boolean[levels]; // 1 star acquired
            complete = new boolean[levels]; // 2 stars acquired

            minLevelsVisited = Integer.MAX_VALUE;
            search(0, 0, 0);

            String answer;

            if (minLevelsVisited == Integer.MAX_VALUE) {
                answer = "Too Bad";
            } else {
                answer = String.valueOf(minLevelsVisited+levels);
            }

            System.out.print("Case #"+test+": ");
            System.out.println(answer);
            output.print("Case #"+test+": ");
            output.println(answer);
        }
    }

    private static void search(int stars, int levelsComplete, int levelsVisited) {
        if (levelsComplete == levels) {
            if (levelsVisited < minLevelsVisited) {
                minLevelsVisited = levelsVisited;
            }
        }
        for (int i=0; i<levels; i++) {
            if (!complete[i]) { // skip completed
                if (threshold2[i]<=stars) {
                    // can go 2 stars!
                    complete[i] = true;
                    search(stars + (visited[i]? 1 : 2), levelsComplete+1, levelsVisited);
                    complete[i] = false;
                } else if (levelsVisited+1<minLevelsVisited && !visited[i] && threshold1[i]<=stars) {
                    // can go only 1 star
                    visited[i] = true;
                    search(stars + 1, levelsComplete, levelsVisited+1);
                    visited[i] = false;
                }
            }
        }
    }

}
