import java.io.*;
import java.util.Locale;
import java.util.Scanner;

/**
 * Author: Daniil Tutubalin
 */
public class ProblemA {

    public static void main(String[] args) {
        try {
            Scanner input = new Scanner(new File("input.txt"));
            PrintStream output = new PrintStream(new FileOutputStream("output.txt"));
            solveTask(input, output);
        } catch (FileNotFoundException e) {
            System.out.println("input.txt not found");
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    private static void solveTask(Scanner input, PrintStream output) {

        input.useLocale(Locale.US); // use decimal point, not comma

        int testsCount = input.nextInt();

        for (int test=1; test<=testsCount; test++) {

            int count = input.nextInt();

            int [] values = new int[count];

            double sum = 0;
            for (int i=0; i<count; i++) {
                int value = input.nextInt();
                values[i] = value;
                sum += value;
            }

            double average = (double)sum / count;

            boolean[] calculated = new boolean[count];
            double percentage[] = new double[count];

            boolean repeat;
            int left = count;
            double sum2 = sum;
            do {
                repeat = false;
                for (int i=0; i<count; i++) {
                    if (!calculated[i]) {
                        if (values[i] > average*2) {
                            calculated[i] = true;
                            sum2 -= values[i];
                            percentage[i] = 0;
                            repeat = true;
                            left--;
                        }
                    }
                }
                if (left>0) {
                    average = (sum+sum2)/left/2;
                }
            } while (repeat);

            String answer = "";
            for (int i=0; i<count; i++) {
                if (!calculated[i]) {
                    if (sum == 0) {
                        percentage[i] = (100.0D/left);
                    } else {
                        percentage[i] = (100.0D*(average*2 - values[i]))/sum;
                    }
                }
            }

            for (int i=0; i<count; i++) {
                answer+=" "+String.format(Locale.UK, "%1.8f", percentage[i]);
            }

            System.out.print("Case #"+test+":");
            System.out.println(answer);
            output.print("Case #"+test+":");
            output.println(answer);
        }
    }
    


}
