import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class A {

	static class Node {

		String name;
		Map<String, Node> children;

		public Node(String name) {
			this.name = name;
			this.children = new HashMap<String, Node>();
		}

		public String toString() {
			return "name: " + name + ", children: " + children.toString();
		}
	}

	static void insertPath(Node node, List<String> path) {

		for (String dir : path) {
			if (dir.equals("")) continue;
			if (!node.children.containsKey(dir)) {
				Node child = new Node(dir);
				node.children.put(dir, child);
				node = child;
			} else {
				node = node.children.get(dir);
			}
		}
	}

	static long length(Node node) {
		long size = 1;
		for (String key : node.children.keySet()) {
			size += length(node.children.get(key));
		}
		return size;
	}

	static Node root;

	public static void main(String[] args) {

		Scanner in = new Scanner(System.in);
		StringBuilder out = new StringBuilder();

		int t = in.nextInt();
		for (int z = 1; z <= t; z++) {

			root = new Node("/");

			int n, m;
			n = in.nextInt();
			m = in.nextInt();
			in.nextLine();
			String[] line;
			for (int i = 0; i < n; i++) {
				line = in.nextLine().split("/");
				insertPath(root, Arrays.asList(line));
			}

			long lengthBefore = length(root);

			for (int i = 0; i < m; i++) {
				line = in.nextLine().split("/");
				insertPath(root, Arrays.asList(line));
			}
			long diff = length(root) - lengthBefore;

			out.append("Case #" + z + ": " + diff);
			out.append("\n");
		}

		System.out.print(out.toString());
	}

}
