import java.util.Scanner;


public class Watersheds {
	static char[][] label;
	static char nextLabel;
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int numMaps = sc.nextInt();
		StringBuilder out = new StringBuilder();
		for (int i = 0; i < numMaps; i++) {
			int numRows = sc.nextInt();
			int numCol = sc.nextInt();
			
			int[][] map = new int[numRows][numCol];
			
			for (int j = 0; j < numRows; j++) {
				for (int k = 0; k < numCol; k++) {
					map[j][k] = sc.nextInt();
				}
			}
			
			label = new char[numRows][numCol];
			nextLabel = 'a';
			for (int j = 0; j < numRows; j++) {
				for (int k = 0; k < numCol; k++) {
					if (label[j][k] == '\0') {
						process(map, j, k);
					}
				}
			}
			out.append("Case #" + (i+1) + ":\n");
			
			for (int j = 0; j < numRows; j++) {
				for (int k = 0; k < numCol; k++) {
					if (k > 0) out.append(" ");
					out.append(label[j][k]);
				}
				out.append("\n");
			}
		}
		System.out.print(out);
	}

	private static char process(int[][] map, int j, int k) {
		if (label[j][k] != '\0') return label[j][k];
		if (isSink(map, j, k)) {
			label[j][k] = nextLabel;
			return nextLabel++;
		}
		
		int minJ = j, minK = k;
		if (isValid(map, j-1, k) && map[j-1][k] < map[minJ][minK]) {
			minJ = j-1;
			minK = k;
		} 
		if (isValid(map, j, k-1) && map[j][k-1] < map[minJ][minK]) {
			minJ = j;
			minK = k-1;
		} 
		if (isValid(map, j, k+1) && map[j][k+1] < map[minJ][minK]) {
			minJ = j;
			minK = k+1;
		} 
		if (isValid(map, j+1, k) && map[j+1][k] < map[minJ][minK]) {
			minJ = j+1;
			minK = k;
		} 
		
		label[j][k] = process(map,minJ, minK);
		return label[j][k];
		
	}

	private static boolean isSink(int[][] map, int j, int k) {
		if (!isValid(map, j, k)) return false;
		
		if (isValid(map, j-1, k) && map[j-1][k] < map[j][k]) return false;
		if (isValid(map, j+1, k) && map[j+1][k] < map[j][k]) return false;
		if (isValid(map, j, k-1) && map[j][k-1] < map[j][k]) return false;
		if (isValid(map, j, k+1) && map[j][k+1] < map[j][k]) return false;
		return true;
	}

	private static boolean isValid(int[][] map, int i, int k) {
		return i >= 0 && i < map.length && k >= 0 && k < map[0].length;
	}


}
