import java.util.Scanner;


public class StockCharts {
	
	static int cont;
	static int[] cores; 
	
	public static void main(String[] args) {
		
		Scanner sc = new Scanner(System.in);
		
		int testCases = sc.nextInt();
		
		for (int i = 0; i < testCases; i++) {
			int n  = sc.nextInt();
			int k = sc.nextInt();
			
			int[][] charts = new int[n][k];
			for (int m = 0; m < n; m++) {
				for (int l = 0; l < k; l++) {
					charts[m][l] = sc.nextInt();
				}
			}
			boolean[][] grafo = new boolean[n][n];
			for (int m = 0; m < n; m++) {
				for (int l = m+1; l < n; l++) {
					if (interseccao(charts, m, l)) {
						grafo[m][l] = true;
						grafo[l][m] = true;
					}
				}
			}
			
//			printGrafo(grafo);
			cont = 0;
			cores = new int[n];
			for (int j = 0; j < n; j++) {
				cores[j] = -1;
			}
			for (int j = 0; j < n; j++) {
				if (cores[j] == -1) dfs(grafo,j, 0);				
			}
			System.out.println("Case #" + (i+1) + ": " + (cont+1));
		
		}
	}

	private static void printGrafo(boolean[][] grafo) {
		for (int i = 0; i < grafo.length; i++) {
			for (int j = 0; j < grafo[i].length; j++) {
				System.out.print(grafo[i][j] + " ");
			}
			System.out.println();
		}
	}

	private static void dfs(boolean[][] grafo, int i, int cor) {
		if (cont == 2) return;
		if (cores[i] == cor) return;
		if (cores[i] > -1) {
			cont = 2;
			return;
		}
		cores[i] = cor;
		cont = Math.max(cont, cor);
		
		for (int j = 0; j < grafo[i].length; j++) {
			if (grafo[i][j]) {
				dfs(grafo, j, (cor+1) % 2);
			}
		}
	}

	private static boolean interseccao(int[][] charts, int m, int l) {
		int lastM = charts[m][0];
		int lastL = charts[l][0];
		if (lastM == lastL) return true;
		for (int i = 1; i < charts[m].length; i++) {
			if ((lastM >= lastL && charts[m][i] <= charts[l][i]) ||
					(lastL >= lastM && charts[l][i] <= charts[m][i])) {
				return true;
			}
			lastM = charts[m][i];
			lastL = charts[l][i];
		}
		return false;
	}

}
