import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;


public class AlienLanguage {
	
	static class Token {
		List<Character> options;

		public Token() {
			super();
			options = new LinkedList<Character>();
		}
		
		public String toString() {
			return options.toString();
		}
		
	}
	public static void main(String[] args) {
		int numTokens, tamDict, testCases;
		Scanner sc = new Scanner(System.in);
		numTokens = sc.nextInt();
		tamDict = sc.nextInt();
		testCases = sc.nextInt();
		
		Set<String> dict = new HashSet<String>();
		Map<String, Boolean> mapa = new HashMap<String, Boolean>();
		for (int i = 0; i < tamDict; i++) {
			String word = sc.next();
			dict.add(word);
		}
		sc.nextLine();
		for (int i = 0; i < testCases; i++) {
			String line = sc.nextLine();
			Token[] tokens = tokenize(line, numTokens);
			int all = countOptions(tokens, dict, 0, "");
			System.out.println("Case #" + (i+1) + ": " + all);
		}
		
		
		
	}

	private static int countOptions(Token[] tokens, Set<String> dict, int i, String word) {
		if (i == tokens.length) {
			if (dict.contains(word.toString())) return 1;
			else return 0;
		}
		int counter = 0;
		for (char c : tokens[i].options) {
			if (startWith(dict, word+c))
				counter += countOptions(tokens, dict, i+1, word+c);
		}
		return counter;
	}

	private static boolean startWith(Set<String> dict, String string) {
		for (String word : dict) {
			if (word.startsWith(string)) return true;
		}
		return false;
	}

	private static Token[] tokenize(String line, int numTokens) {
		Token[] tokens = new Token[numTokens];
		char[] array = line.toCharArray();
		int index = 0;
		for (int i = 0; i < numTokens; i++) {
			tokens[i] = new Token();
			if (Character.isLetter(array[index])) {
				tokens[i].options.add(array[index]);
			} else {
				index++;
				while (array[index] != ')') {
					tokens[i].options.add(array[index]);
					index++;
				}
			}
			index++;
		}
		return tokens;
	}

}
