package qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;

public class Lawnmower {
	
	private static String path = "files/";
	private static String filename = "B-large";

	public static void main(String[] args) {
		Lawnmower func = new Lawnmower();
		try {
			func.resolve (path + filename + ".in", path + filename + ".out");
		} catch (Exception e) { }
	}
	
	private void resolve (String input, String output) throws FileNotFoundException, UnsupportedEncodingException, IOException {
		InputStreamReader isr = new InputStreamReader(new FileInputStream(input), "UTF-8");
		OutputStreamWriter osw = new OutputStreamWriter(new FileOutputStream(output), "UTF-8");
		BufferedReader br = new BufferedReader(isr);
		BufferedWriter bw = new BufferedWriter(osw);
		if (br != null) {
			int t = 0;
			String line = br.readLine();
			if (line != null) {
				// t:
				t = Integer.parseInt(line);
			}
			int n, m, p;
			String[] temp;
			int[][] lawn;
			int min = 101;
			int i = 0;
			while (i < t) {
				temp = br.readLine().split(" ");
				n = Integer.parseInt(temp[0]);
				m = Integer.parseInt(temp[1]);
				lawn = new int[n][m];				
				for (int j = 0; j < n; j++) {
					temp = br.readLine().split(" ");
					for (int k = 0; k < m; k++) {
						p = Integer.parseInt(temp[k]);
						lawn[j][k] = p;
						if (p < min) {
							min = p;
						}
					}
				}
				process(bw,lawn,n,m,min,i+1);
				i++;
			}
			br.close();
			isr.close();
			bw.close();
			osw.close();
		}
	}
	
	private void process (BufferedWriter bw, int[][] lawn, int n, int m, int min, int ncase) {
		boolean goOn = true;
		int i, j;
		for (i = 0; i < n; i++) {
			for (j = 0; j < m; j++) {
				if (lawn[i][j] != min) {
					lawn[i][j] = 0;
				}
			}
		}
		for (i = 0; i < n; i++) {
			goOn = true;
			for (j = 0; j < m; j++) {
				goOn = goOn && ((lawn[i][j] == 1) || (lawn[i][j] == -1));
			}
			if (goOn) {
				for (j = 0; j < m; j++) {
					lawn[i][j] = -1;
				}
			}
		}
		for (i = 0; i < m; i++) {
			goOn = true;
			for (j = 0; j < n; j++) {
				goOn = goOn && ((lawn[j][i] == 1) || (lawn[j][i] == -1));
			}
			if (goOn) {
				for (j = 0; j < n; j++) {
					lawn[j][i] = -1;
				}
			}
		}
		for (i = 0; i < n; i++) {
			for (j = 0; j < m; j++) {
				if (lawn[i][j] == -1) {
					lawn[i][j] = 0;
				}
			}
		}
		i = 0;
		goOn = true;
		while (goOn && (i < n)) {
			j = 0;
			while (goOn && (j < m)) {
				goOn = (lawn[i][j] == 0);
				j++;
			}
			i++;
		}
		writeOutput(bw, ncase, (goOn ? "YES" : "NO"));
	}
	
	private void writeOutput (BufferedWriter bw, int i, String text) {
		try {
			bw.write("Case #" + i + ": " + text);
			bw.newLine();
			System.out.println("Case #" + i + ": " + text);
		} catch (IOException ioe) { }
	}

}
