package qualification;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class TicTacToeTomek {

	public static void main(String[] args) {
		TicTacToeTomek tttt = new TicTacToeTomek();
		tttt.resolve("A-small-attempt0.in");
	}
	
	public void resolve (String input) {
		try {
			readInput(input);
		} catch (Exception e) { }
	}
	
	private void readInput (String input) throws FileNotFoundException, UnsupportedEncodingException, IOException {
		InputStreamReader isr = new InputStreamReader(new FileInputStream(input), "UTF-8");
		BufferedReader br = new BufferedReader(isr);
		if (br != null) {
			int t = 0;
			String line = br.readLine();
			if (line != null) {
				// t:
				t = Integer.parseInt(line);
			}
			String bline;
			String board[];
			int i = 0;
			while (i < t) {
				board = new String[10];
				board[4] = "";
				board[5] = "";
				board[6] = "";
				board[7] = "";
				board[8] = "";
				board[9] = "";
				for (int j = 0; j < 4; j++) {
					bline = br.readLine();
					board[j] = bline;
					board[4] = board[4] + bline.charAt(0);
					board[5] = board[5] + bline.charAt(1);
					board[6] = board[6] + bline.charAt(2);
					board[7] = board[7] + bline.charAt(3);
					board[8] = board[8] + bline.charAt(j);
					board[9] = board[9] + bline.charAt(3-j);
				}
				process(board,i+1);
				
				br.readLine();
				
				i++;
			}
			br.close();
		}
	}
	
	private void process (String[] board, int n) {
		boolean goOn = true;
		boolean finished = true;
		int i = 0;
		String bline;
		Matcher matcher;
		Pattern pXT = Pattern.compile("[X(T)*]{4}");
		Pattern pOT = Pattern.compile("[O(T)*]{4}");
		while (goOn && (i < board.length)) {
			bline = board[i];
			//System.out.println(i + ". Processing <" + bline + "> ...");
			matcher = pXT.matcher(bline);
			if (matcher.matches()) {
				System.out.println("Case #" + n + ": X won");
				goOn = false;
			}
			matcher = pOT.matcher(bline);
			if (matcher.matches()) {
				System.out.println("Case #" + n + ": O won");
				goOn = false;
			}
			if (bline.contains(".")) {
				finished = false;
			}
			i++;
		}
		if (goOn) {
			if (finished) {
				System.out.println("Case #" + n + ": Draw");
			} else {
				System.out.println("Case #" + n + ": Game has not completed");
			}			
		}
	}

}
