package qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;

public class FairAndSquare {
	
	private static String path = "files/";
	private static String filename = "C-small-attempt0";

	public static void main(String[] args) {
		FairAndSquare func = new FairAndSquare();
		try {
			func.resolve (path + filename + ".in", path + filename + ".out");
		} catch (Exception e) { }
	}
	
	private void resolve (String input, String output) throws FileNotFoundException, UnsupportedEncodingException, IOException {
		InputStreamReader isr = new InputStreamReader(new FileInputStream(input), "UTF-8");
		OutputStreamWriter osw = new OutputStreamWriter(new FileOutputStream(output), "UTF-8");
		BufferedReader br = new BufferedReader(isr);
		BufferedWriter bw = new BufferedWriter(osw);
		if (br != null) {
			int t = 0;
			String line = br.readLine();
			if (line != null) {
				// t:
				t = Integer.parseInt(line);
			}
			int a, b;
			String[] temp;
			int i = 0;
			while (i < t) {
				temp = br.readLine().split(" ");
				a = Integer.parseInt(temp[0]);
				b = Integer.parseInt(temp[1]);
				process(bw,a,b,i+1);
				i++;
			}
			br.close();
			isr.close();
			bw.close();
			osw.close();
		}
	}
	
	private void process (BufferedWriter bw, int a, int b, int ncase) {
		int i, sqrt, count = 0;
		for (i = a; i <= b; i++) {
			sqrt = hasSqrt(i);
			if ((sqrt != -1) && (isPalindrome(i)) && (isPalindrome(sqrt))) {
				count++;
			}
		}
		writeOutput (bw, ncase, count);
	}
	
	private int hasSqrt (int i) {
		double sqrt = Math.sqrt(i);
		long l = (long)sqrt;
		double d = sqrt-(double)l;
		if (d == 0) {
			return (int)l;
		} else {
			return -1;
		}
	}
	
	private boolean isPalindrome (Integer i) {
		boolean palindrome = true;
		String p = i.toString();
		int length = p.length();
		int middle = (int)Math.floor(length/2);
		if (length > 1) {
			int k = 0;
			while (palindrome && (k < middle)) {
				palindrome = (p.charAt(k) == p.charAt(length-1-k));
				k++;
			}
		}
		return palindrome;
	}
	
	private void writeOutput (BufferedWriter bw, int i, int count) {
		try {
			bw.write("Case #" + i + ": " + count);
			bw.newLine();
			System.out.println("Case #" + i + ": " + count);
		} catch (IOException ioe) { }
	}

}
