import java.io.*;
import java.util.*;

class SavingUniverse {
	int N;
	int S;
	int Q;
	int[][] c;
	int[][] s;
	String[] server;
	String[] query;
	
	FileReader filein;
	BufferedReader br;
	FileWriter fileout;
	BufferedWriter bw;
	
	public SavingUniverse(String filename1,String filename2) throws IOException
	{
		filein = new FileReader(filename1);
		br = new BufferedReader(filein);
		fileout = new FileWriter(filename2);
		bw = new BufferedWriter(fileout);
		
		String s = br.readLine();
		N = new Integer(s);
		
		int nbaris = 0;
		int nsolution = 0;
		
		while (s != null) {
			nbaris = 0;
			s = br.readLine();
			if (s == null)
			{
				break;
			}
			S = new Integer(s);
			server = new String[S];
			nbaris++;
			while (nbaris <= S)
			{
				s = br.readLine();
				server[nbaris-1] = s;
				nbaris++;
			}
			
			s = br.readLine();
			Q = new Integer(s);
			query = new String[Q];
			nbaris=1;
			
			while (nbaris <= Q)
			{
				s = br.readLine();
				query[nbaris-1] = s;
				nbaris++;
			}
			
			int x = computecountswitch();
			
			nsolution++;
			
			checksolution();
			
			if (x > 0)
			{
				int cs = constructsolution();
				printsolution(cs,nsolution);
			}
			else
			{
				printsolution(0,nsolution);
			}
		}
		
		bw.close();
		fileout.close();
		br.close();
		filein.close();
	}
	
	public int computecountswitch ()
	{
		if (Q != 0)
		{
			c = new int[S][Q];
			s = new int[S][Q];

			for (int j=0;j<S;j++)
			{
				if (query[0].equals(server[j]))
				{
					c[j][0] = 9999;
					s[j][0] = -1;
				}
				else
				{
					c[j][0] = 0;
					s[j][0] = j;
				}
			}	
				
			for (int i=1;i<Q;i++)
			{
				for (int j=0;j<S;j++)
				{
					if (query[i].equals(server[j]))
					{
						c[j][i] = 9999;
						s[j][i] = 9999;
					}
					else
					{
						int tempmin = 9999;
						int tempserver = -1;
						for (int k=0;k<S;k++)
						{
							if (k == j)
							{
								if (tempmin > c[k][i-1])
								{
									tempmin = c[k][i-1];
									tempserver = k;
								}
							}
							else
							{
								if (tempmin > (c[k][i-1] + 1))
								{
									tempmin = c[k][i-1] + 1;
									tempserver = k;
								}
							}
						}
						c[j][i] = tempmin;
						s[j][i] = tempserver;
						
					}
				}
			}
			return 1;
		}
		else
		{
			return 0;
		}
	}
	
	public int constructsolution()
	{
		int count = c[0][Q-1];
		for (int i=1;i<S;i++)
		{
			if (count > c[i][Q-1])
			{
				count = c[i][Q-1];
			}
		}
		return count;
	}
	
	public void printsolution(int i,int nsolution) throws IOException
	{
		String s = "Case #" + Integer.toString(nsolution) + ": " + Integer.toString(i); 
		bw.write(s + "\n");
	}
	
	public void checksolution()
	{
		for (int i=0;i<S;i++)
		{
			for (int j=0;j<Q;j++)
			{
				System.out.print(c[i][j] + " ");
			}
			System.out.println();
		}
		System.out.println();
		for (int i=0;i<S;i++)
		{
			for (int j=0;j<Q;j++)
			{
				System.out.print(s[i][j] + " ");
			}
			System.out.println();
		}
		System.out.println();
		System.out.println();
	}
	
	public static void main (String argv[]) throws IOException
	{
		String inputfilename = "A-large.in.txt";
		String outputfilename = "outputlarge.txt";
		SavingUniverse su = new SavingUniverse(inputfilename,outputfilename);
	}
}