import java.util.*;
import java.io.*;

class TrainTimetable {
	int N;
	int na;
	int nb;
	int turnaroundtime;
	int totalA;
	int totalB;
	int counterA;
	int counterB;
	
	String departureA[];
	String departureB[];
	String arrivalA[];
	String arrivalB[];
	
	int intdepartureA[];
	int intdepartureB[];
	int intarrivalA[];
	int intarrivalB[];
	
	FileReader filein;
	BufferedReader br;
	FileWriter fileout;
	BufferedWriter bw;
	
	public TrainTimetable (String filename1, String filename2) throws IOException
	{
		totalA = 0;
		totalB = 0;
		counterA = 0;
		counterB = 0;
		
		filein = new FileReader(filename1);
		br = new BufferedReader(filein);
		fileout = new FileWriter(filename2);
		bw = new BufferedWriter(fileout);
		
		String s = br.readLine();
		N = new Integer(s);
		
		int nbaris = 0;
		int nsolution = 0;
		
		while (s != null) {
				nbaris = 0;
				totalA = 0;
				totalB = 0;
				counterA = 0;
				counterB = 0;
				
				s = br.readLine();
				if (s == null)
				{
					break;
				}
				turnaroundtime = new Integer(s);
				s = br.readLine();
				StringTokenizer st = new StringTokenizer(s);
				na = new Integer(st.nextToken());
				nb = new Integer(st.nextToken());
				departureA = new String[na];
				arrivalB = new String[na];
				departureB = new String[nb];
				arrivalA = new String[nb];
				intdepartureA = new int[na];
				intarrivalB = new int[na];
				intdepartureB = new int[nb];
				intarrivalA = new int[nb];
				
				
				while (nbaris < na)
				{
					s = br.readLine();
					st = new StringTokenizer(s);
					departureA[nbaris] = st.nextToken();
					arrivalB[nbaris] = st.nextToken();
					nbaris++;
				}
				
				nbaris = 0;
				while (nbaris < nb)
				{
					s = br.readLine();
					st = new StringTokenizer(s);
					departureB[nbaris] = st.nextToken();
					arrivalA[nbaris] = st.nextToken();
					nbaris++;
				}
				
				converttoint();
				sortarray();
				computesolution();
				nsolution++;
				printsolution(nsolution);
		}
		
		bw.close();
		fileout.close();
		br.close();
		filein.close();
	}
	
	public void converttoint()
	{
		for (int i=0;i<na;i++)
		{			
			String[] splitA = departureA[i].split(":");
			int ha = new Integer(splitA[0]);
			int ma = new Integer(splitA[1]);
			intdepartureA[i] = ha*60 + ma;
			
			String[] splitB = arrivalB[i].split(":");
			int hb = new Integer(splitB[0]);
			int mb = new Integer(splitB[1]);
			intarrivalB[i] = hb*60 + mb;
		}
		for (int i=0;i<nb;i++)
		{			
			String[] splitA = departureB[i].split(":");
			int ha = new Integer(splitA[0]);
			int ma = new Integer(splitA[1]);
			intdepartureB[i] = ha*60 + ma;
			
			String[] splitB = arrivalA[i].split(":");
			int hb = new Integer(splitB[0]);
			int mb = new Integer(splitB[1]);
			intarrivalA[i] = hb*60 + mb;
		}
	}
	
	public void sortarray()
	{
		Arrays.sort(intdepartureA);
		Arrays.sort(intdepartureB);
		Arrays.sort(intarrivalA);
		Arrays.sort(intarrivalB);
	}
	
	/*public Bool lessthan(String A, String B)
	{
		String[] splitA = A.split(":");
		String[] splitB = B.split(":");
		
		int ha = new Integer(splitA[0]);
		int ma = new Integer(splitA[1]);
		int hb = new Integer(splitB[0]);
		int mb = new Integer(splitB[1]);
		
		Date d1 = new Date(1990,1,10,ha,ma+turnaroundtime);
		Date d2 = new Date(1990,1,10,hb,mb);
		
		if (d1.after(d2))
		{
			return false;
		}
		else
		{
			return true;
		}
	}*/
	
	public void computesolution()
	{
		int j = 0;
		
		for (int i=0;i<na;i++)
		{
			if ( (j < nb) && ((intarrivalA[j]+turnaroundtime) <= intdepartureA[i]) )
			{
				j++;
			}
			else
			{
				totalA++;
			}
		}
		j = 0;
		for (int i=0;i<nb;i++)
		{
			if ( (j < na) && ((intarrivalB[j]+turnaroundtime) <= intdepartureB[i]) )
			{
				j++;
			}
			else
			{
				totalB++;
			}
		}
	}
	
	public void printsolution(int nsolution) throws IOException
	{
		String s = "Case #" + Integer.toString(nsolution) + ": " + Integer.toString(totalA) + " " + Integer.toString(totalB); 
		bw.write(s + "\n");
	}
	
	public static void main (String argv[]) throws IOException
	{
		String inputfilename = "B-large.in.txt";
		String outputfilename = "outputlargeB.txt";
		TrainTimetable su = new TrainTimetable(inputfilename,outputfilename);
	}
}
