import java.util.*;
import java.io.*;

class MinimumScalarProduct {
	int[] A;
	int[] B;
	int nvector;
	int solution;
	
	FileReader filein;
	BufferedReader br;
	FileWriter fileout;
	BufferedWriter bw;
	
	public MinimumScalarProduct (String filename1, String filename2) throws IOException
	{
		filein = new FileReader(filename1);
		br = new BufferedReader(filein);
		fileout = new FileWriter(filename2);
		bw = new BufferedWriter(fileout);
		
		String s = br.readLine();
		int N = new Integer(s);
		
		int nsolution = 0;
		
		while (nsolution < N) {
			solution = 0;
			s = br.readLine();
			nvector = new Integer(s);
			A = new int[nvector];
			B = new int[nvector];
			
			s = br.readLine();
			StringTokenizer st = new StringTokenizer(s);
			s = br.readLine();
			StringTokenizer st2 = new StringTokenizer(s);
			
			for (int i=0;i<nvector;i++)
			{
				A[i] = new Integer(st.nextToken());
				B[i] = new Integer(st2.nextToken());
			}
			
			computesolution();
			nsolution++;
			printsolution(nsolution);	
		}
		
		bw.close();
		fileout.close();
		br.close();
		filein.close();
	}
	
	public void computesolution()
	{
		Arrays.sort(A);
		Arrays.sort(B);
		int j = 0;
		for (int i=A.length-1;i>=0;i--)
		{
			solution += (A[i] * B[j]);
			j++;
		}
	}
	
	public void printsolution(int nsolution) throws IOException
	{
		String s = "Case #" + Integer.toString(nsolution) + ": " + Integer.toString(solution); 
		bw.write(s + "\n");
	}

	public static void main (String args[]) throws IOException
	{
		String inputfilename = "A-small-attempt0.in.txt";
		String outputfilename = "Asmall-output.txt";
		MinimumScalarProduct su = new MinimumScalarProduct(inputfilename,outputfilename);
	}
}