package us.drob;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class Main {
    // Assumes pancakeStack is made up of `+` and `-` only.
    public static int computeNumFlips(String pancakeStack) {
        int numFlips = 0;
        char prevPancake = '+';
        for (int i = pancakeStack.length() - 1; i >= 0; i--) {
            if (pancakeStack.charAt(i) != prevPancake) {
                numFlips++;
                prevPancake = pancakeStack.charAt(i);
            }
        }
        return numFlips;
    }

    public static void main(String[] args) {
        if (args.length != 1) {
            System.out.println("Usage: java pancakes testfile");
            System.exit(1);
        }
        File file = new File(args[0]);
        Scanner scanner = null;
        try {
            scanner = new Scanner(file);
        } catch (FileNotFoundException e) {
            System.out.println(String.format("Unable to open test file: %s", file));
            e.printStackTrace();
            System.exit(1);
        }
        scanner.useDelimiter(System.getProperty("line.separator"));

        // Assuming here that the file is formatted as specified in the problem statement.
        int numCases = Integer.parseInt(scanner.next());
        for (int i = 0; i < numCases; i++) {
            String nextCase = scanner.next();
            int numFlips = computeNumFlips(nextCase);
            System.out.println(String.format("Case #%d: %d", i + 1, numFlips));
        }
    }
}
