package com.google.codejam;

import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.Map;

import com.google.common.collect.Maps;
import com.google.common.io.Files;
import com.google.gdata.util.common.base.Charsets;

public class ProblemA {

	public static void main (String [] args) throws IOException {
		if (args.length != 1) {
			System.err.println("Usage: ProblemA inputfile");
			return;
		}
		String filename = args[0];
		List<String> inputLines = Files.readLines(new File(filename), Charsets.US_ASCII);
		int T = Integer.parseInt(inputLines.get(0));
		List<String> testCases = inputLines.subList(1, inputLines.size());
		assert(T == testCases.size());
		Map<Character, Character> decoder = createDecoder();
		for (int i = 0; i < testCases.size(); i++) {
			processLine(testCases.get(i), i, decoder);
		}
	}
	
	private static void processLine(String line, int caseNum, Map<Character, Character> decoder) {
		String lineInEnglish = "";
		for (int i = 0; i < line.length(); i++) {
			char curr = line.charAt(i);
			Character translated = decoder.get(curr);
			lineInEnglish += (translated == null ? curr : translated);
		}
		System.out.println("Case #" + (caseNum+1) + ": " + lineInEnglish);
	}

	private static Map<Character, Character> createDecoder() {
		Map<Character, Character> decoder = Maps.newHashMap();
		decoder.put('a', 'y');
		decoder.put('b', 'h');
		decoder.put('c', 'e');
		decoder.put('d', 's');
		decoder.put('e', 'o');
		decoder.put('f', 'c');
		decoder.put('g', 'v');
		decoder.put('h', 'x');
		decoder.put('i', 'd');
		decoder.put('j', 'u');
		decoder.put('k', 'i');
		decoder.put('l', 'g');
		decoder.put('m', 'l');
		decoder.put('n', 'b');
		decoder.put('o', 'k');
		decoder.put('p', 'r');
		decoder.put('q', 'z');
		decoder.put('r', 't');
		decoder.put('s', 'n');
		decoder.put('t', 'w');
		decoder.put('u', 'j');
		decoder.put('v', 'p');
		decoder.put('w', 'f');
		decoder.put('x', 'm');
		decoder.put('y', 'a');
		decoder.put('z', 'q');
		
		return decoder;
	}

}