import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;


public class Dijkstra {
	public static void main(String[] args) throws FileNotFoundException {
		Scanner scan = new Scanner(new File("problem2.txt"));
		int numCases = scan.nextInt();
		for (int i = 0; i < numCases; i++) {
			scan.nextInt();
			int numRepeats = scan.nextInt();
			String letters = scan.next();
			String quaternions = "";
			for (int j = 0; j < numRepeats; j++) {
				quaternions += letters;
			}
			System.out.println("Case #" + (i + 1) + ": " + (doProblem(quaternions) ? "YES" : "NO"));
		}
		scan.close();
	}

	public static boolean doProblem(String quaternions) {
		boolean iFound = false;
		boolean jFound = false;
		boolean kFound = false;
		String iCurr = quaternions.charAt(0) + "";
		String jCurr = "";
		int jIndex = - 1;
		String kCurr = "";
		int kIndex = -1;

		if (quaternions.length() < 3)
			return false;

		for (int i = 0; i < quaternions.length() - 1; i++) {
			if (iCurr.equals("i")) {
				iFound = true;
				jCurr = quaternions.charAt(i + 1) + "";
				jIndex = i + 1;
				break;
			} else {
				iCurr = qMultiply(iCurr, quaternions.charAt(i + 1) + "");
			}
		}

		if (jIndex == -1)
			return false;

		for (int i = jIndex; i < quaternions.length() - 1; i++) {
			if (jCurr.equals("j")) {
				jFound = true;
				kCurr = quaternions.charAt(i + 1) + "";
				kIndex = i + 1;
				break;
			} else {
				jCurr = qMultiply(jCurr, quaternions.charAt(i + 1) + "");
			}
		}

		if (kIndex == -1)
			return false;

		for (int i = kIndex; i < quaternions.length() - 1; i++) {
				kCurr = qMultiply(kCurr, quaternions.charAt(i + 1) + "");
		}
		if (kCurr.equals("k"))
			kFound = true;
		return iFound && jFound && kFound;
	}

	public static String qMultiply(String q1, String q2) {
		if ((q1.charAt(0)) == ('-')) {
			String ans = "-" + qMultiply(q1.charAt(1) + "", q2);
			if (ans.length() == 3)
				return ans.charAt(2) + "";
			else
				return ans;
		}
		else if (q1.equals("1") && q2.equals("1")) {
			return "1";
		}
		else if (q1.equals(q2)) {
			return "-1";
		}
		else if (q1.equals("1")) {
			return q2;
		}
		else if (q1.equals("i")) {
			if (q2.equals("j"))
				return "k";
			else
				return "-j";
		}
		else if (q1.equals("j")) {
			if (q2.equals("i"))
				return "-k";
			else
				return "i";
		}
		else if (q1.equals("k")) {
			if (q2.equals("i"))
				return "j";
			else
				return "-i";
		}
		else
			return "whoops";
	}
}