package roundoneb.subab;

import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashSet;

import util.CodeJam;

public class MainSubB extends CodeJam {
	public static final String FILE_IN = "B/B-small-attempt1.in";
	public static final String FILE_OUT = "B/B-small-attempt1.out";

	public static int primes[] = {
	      2, 3, 5, 7, 11, 13, 17, 19, 23, 29 
	, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71 
	, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113 
	, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173 
	, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229 
	, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281 
	, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349 
	, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409 
	, 419, 421, 431, 433, 439, 443, 449, 457, 461, 463 
	, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541 
	, 547, 557, 563, 569, 571, 577, 587, 593, 599, 601 
	, 607, 613, 617, 619, 631, 641, 643, 647, 653, 659 
	, 661, 673, 677, 683, 691, 701, 709, 719, 727, 733 
	, 739, 743, 751, 757, 761, 769, 773, 787, 797, 809 
	, 811, 821, 823, 827, 829, 839, 853, 857, 859, 863 
	, 877, 881, 883, 887, 907, 911, 919, 929, 937, 941 
	, 947, 953, 967, 971, 977, 983, 991, 997 
	};
	
	MainSubB() throws IOException {
		super(FILE_IN, FILE_OUT);
		//super(FILE_IN, System.out);
	}

	void go() throws IOException {
		int cases = nextInt();
		for (int index = 0; index < cases; index++) {
			int a = nextInt();
			int b = nextInt();
			int p = nextInt();
			
			ArrayList<ArrayList<Integer>> sets = new ArrayList<ArrayList<Integer>>();
			for (int i = a; i <= b; i++) {
				
				ArrayList<Integer> set = new ArrayList<Integer>();
				set.add(i);
				sets.add(set);
			}
			
			ArrayList<Integer> primeList = new ArrayList<Integer>();
			for (int i = 0; i < sets.size(); i++) {

				ArrayList<Integer> set = sets.get(i);
				
				int current;
				for (int j = 0; j < set.size(); j++) {
					current = set.get(j).intValue();
					primeList.clear();
	
					for (int k = 0; k < primes.length; k++) {
						if (primes[k] < p) {
							continue;
						}
						if (current % primes[k] == 0) {
							primeList.add(primes[k]);
						}
					}
	
					for (int k = i + 1; k < sets.size(); k++) {
						int other = sets.get(k).get(0);
						
						for (int l = 0; l < primes.length; l++) {
							if (primes[l] < p) {
								continue;
							}
							if (other % primes[l] == 0) {
								if (primeList.contains(primes[l])) {
									//merge sets;
									sets.remove(k);
									set.add(other);
									k--;
									break;
								}
							}
						}
					}
				}
				
			}
				
			out.println("Case #" + (index + 1) + ": " + sets.size());
		}
	}
public static void main(String args[]) {
		try {
			MainSubB a = new MainSubB();
			a.go();			
		} catch(IOException ioe) {
			ioe.printStackTrace();
		}

	}
}
