package roundtwo.util;

import java.io.*;
import java.util.Scanner;

public abstract class CodeJam {

	protected PrintStream out;
	protected Scanner scanner;

	protected CodeJam(String fileIn) throws IOException {
		this(fileIn, fileIn + ".out");
	}

	protected CodeJam(String fileIn, String fileOut) throws IOException {
		this(fileIn, new PrintStream(fileOut));
	}

	private CodeJam(String fileIn, PrintStream out) throws IOException {
		scanner = new Scanner(new BufferedInputStream(new FileInputStream(fileIn)));
		scanner.useDelimiter("\\s+");
		this.out = out;
	}
	
	public abstract String go() throws IOException;
	
	public void run() throws IOException {
		int cases = scanner.nextInt();
		for (int index = 1; index <= cases; index++) {
			StringBuffer buffer = new StringBuffer("Case #");
			buffer.append(index);
			buffer.append(": ");
			buffer.append(go());
			String result = buffer.toString();
			System.out.println(result);
			out.println(result);
		}
	}

}
