package util;

import java.io.*;

public class CodeJam {

	protected PrintStream out;
	protected StreamTokenizer tokenizer;

	protected CodeJam(String fileIn) throws IOException {
		this(fileIn, System.out);
	}

	protected CodeJam(String fileIn, String fileOut) throws IOException {
		this(fileIn, new PrintStream(fileOut));
	}

	protected CodeJam(String fileIn, PrintStream out) throws IOException {
		tokenizer = new StreamTokenizer(new BufferedReader(new FileReader(fileIn)));
		this.out = out;
	}

	protected int nextInt() throws IOException {
		tokenizer.nextToken();
		assert(tokenizer.ttype == StreamTokenizer.TT_NUMBER);
		return (int)tokenizer.nval;
	}

	protected double nextDouble() throws IOException {
		tokenizer.nextToken();
		assert(tokenizer.ttype == StreamTokenizer.TT_NUMBER);
		return tokenizer.nval;
	}

	protected String nextWord() throws IOException {
		tokenizer.nextToken();
		assert(tokenizer.ttype == StreamTokenizer.TT_WORD);
		return tokenizer.sval;
	}
}
