package pretwo;

class Time implements Comparable<Time> {
	final int minutes;

	public Time(int hours, int minutes) {
		this.minutes = hours * 60 + minutes;
	}

	public Time(int minutes) {
		this.minutes = minutes;
	}

	public Time offset(int minutes) {
		return new Time(this.minutes + minutes);
	}

	@Override
	public int compareTo(Time other) {
		return minutes - other.minutes;
	}

	@Override
	public String toString() {
		StringBuffer buffer = new StringBuffer();
		int hh = minutes / 60;
		if (hh < 10) {
			buffer.append('0');
			buffer.append((char)('0' + hh));
		} else {
			buffer.append('1');
			buffer.append((char)('0' + hh - 10));
		}
		buffer.append(':');
		int mm = minutes % 60;
		if (mm < 10) {
			buffer.append('0');
			buffer.append((char)('0' + mm));
		} else {
			buffer.append(mm);
		}

		return buffer.toString();
	}
}