package roundonec.util;

import java.io.*;

public abstract class CodeJam {

	protected PrintStream out;
	protected StreamTokenizer tokenizer;

	protected CodeJam(String fileIn) throws IOException {
		this(fileIn, System.out);
	}

	protected CodeJam(String fileIn, String fileOut) throws IOException {
		this(fileIn, new PrintStream(fileOut));
	}

	protected CodeJam(String fileIn, PrintStream out) throws IOException {
		tokenizer = new StreamTokenizer(new BufferedReader(new FileReader(fileIn)));
		this.out = out;
	}
	
	public abstract String go() throws IOException;
	
	public void run() throws IOException {
		int cases = nextInt();
		for (int index = 0; index < cases; index++) {
			out.println("Case #" + (index + 1) + ": " + go());
		}
	}

	protected int nextInt() throws IOException {
		tokenizer.nextToken();
		assert(tokenizer.ttype == StreamTokenizer.TT_NUMBER);
		return (int)tokenizer.nval;
	}

	protected double nextDouble() throws IOException {
		tokenizer.nextToken();
		assert(tokenizer.ttype == StreamTokenizer.TT_NUMBER);
		return tokenizer.nval;
	}

	protected String nextWord() throws IOException {
		tokenizer.nextToken();
		assert(tokenizer.ttype == StreamTokenizer.TT_WORD);
		return tokenizer.sval;
	}
}
