package pretwo;

public class Event implements Comparable<Event> {
	public enum Type {
		ReadyA, ReadyB, LeavesA, LeavesB
	}

	private final Type type;
	private final Time time;

	public Event(Type type, Time time) {
		this.type = type;
		this.time = time;
	}

	public Type getType() {
		return type;
	}

	@Override
	public int compareTo(Event other) {
		int compare = time.compareTo(other.time);
		if (compare == 0) {
			return type.compareTo(other.type);
		}
		return compare;
	}

	@Override
	public String toString() {
		switch(type) {
			case LeavesA:
				return time + " a train leaves A";
			case LeavesB:
				return time + " a train leaves B";
			case ReadyA:
				return time + " a train is ready at A";
			case ReadyB:
				return time + " a train is ready at B";
		}
		return time.toString();
	}
}
