package roundonec.a;

import java.io.IOException;

import roundonec.util.CodeJam;

public class Main extends CodeJam {
	public static final String FILE_IN = "A/A-large.in";
	public static final String FILE_OUT = "A/A-large.out";

	Main() throws IOException {
		super(FILE_IN, FILE_OUT);
		//super(FILE_IN, System.out);
	}

	public static void main(String args[]) {
		try {
			Main a = new Main();
			a.run();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
	}

	@Override
	public String go() throws IOException {
		int lettersPerKey = nextInt();
		int keysAvailable = nextInt();
		long numLetters = nextInt();
		int freqencies[] = new int[(int) numLetters];
		for (int i = 0; i < numLetters; i++) {
			freqencies[i] = nextInt();
		}
		java.util.Arrays.sort(freqencies);

		long depth = 1;
		long totalPresses = 0;
		long index = numLetters - 1;
outerLoop:
		while (depth <= lettersPerKey) {
			long numKeysRem = keysAvailable;
			while (numKeysRem > 0) {
				totalPresses += depth * freqencies[(int) index];
				if (index == 0) {
					break outerLoop;
				}
				index--;
				numKeysRem--;
			}
			depth++;
		}

		if (depth != lettersPerKey + 1) {
			return Long.toString(totalPresses);
		}

		return "Impossible";
	}

}
