package preone;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Arrays;

public class Main {
	public static final String FILE_IN = "A-large.in";
	public static final String FILE_OUT = "A-large.out";
	public static final int MAX_ENGINES = 100;

	public static void main(String args[]) {
		try {
			//PrintStream out = System.out;
			PrintStream out = new PrintStream(FILE_OUT);
			BufferedReader in = new BufferedReader(new FileReader(FILE_IN));
			
			int cases = Integer.valueOf(in.readLine().trim());
			
			for (int caseIndex = 0; caseIndex < cases; caseIndex++) {
				int engineCount = Integer.valueOf(in.readLine().trim());
				String engines[] = new String[engineCount];
				for (int i = 0; i < engineCount; i++) {
					engines[i] = in.readLine().trim();
				}

				final int querieCount = Integer.valueOf(in.readLine().trim());
				final String queries[] = new String[querieCount];
				for (int j = 0; j < querieCount; j++) {
					queries[j] = in.readLine().trim();
				}

				int answer = saveTheUniverse(engines, queries);
				out.println("Case #" + (caseIndex + 1) + ": " + answer);
			}
			
		} catch(IOException ioe) {
			ioe.printStackTrace();
			return;
		}
	}
	
	public static int saveTheUniverse(final String[] engines, final String[] queries) {
		int switches = 0;
		int index = 0;
		while((index = next(engines, queries, index)) != queries.length) {
			switches++;
		}
		
		return switches;
	}

	private static final boolean notUsed[] = new boolean[MAX_ENGINES];
	private static int next(final String[] engines, final String[] queries, int offset) {
		Arrays.fill(notUsed, 0, engines.length, true);
		int remaining = engines.length;

		for (int i = offset; i < queries.length; i++) {
			for (int j = 0; j < engines.length; j++) {
				if (notUsed[j] && queries[i].equals(engines[j])) {
					notUsed[j] = false;
					remaining--;
					if (remaining == 0) {
						return i;
					}
				}
			}
		}

		return queries.length;
	}

}
