package roundonec.b;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;

import roundonec.util.CodeJam;

public class Main  {
	public static final String FILE_IN = "B/B-small-attempt0.in";
	public static final String FILE_OUT = "B/B-small-attempt0.out";

	static boolean isUgly(long l) {
		return (l % 2 == 0 || l % 3 == 0 || l % 5 == 0 || l % 7 == 0);
	}

	static long countUglies(ArrayList<Long> list) {
		return countUgliesHelper(list.get(0), list, 1);
	}
	
	static long countUgliesHelper(long current, ArrayList<Long> list, int index) {
		if (index == list.size()) {
			if (isUgly(current)) {
				return 1;
			}
			return 0;
		}

		long next = list.get(index++);
		long count = countUgliesHelper(current + next, list, index);
		count += countUgliesHelper(current - next, list, index);
		
		return count;
	}
	
	static long makeNumber(char digits[], int start, int end) {
		StringBuffer sb = new StringBuffer();
		for (int i = start; i < end; i++) {
			sb.append(digits[i]);
		}
		return Long.valueOf(sb.toString());
	}
		
	static long breakUp(ArrayList<Long> list, char[] digits, int start, int end) {
		if (start == end) {
			return countUglies(list);
		}
		
		long total = 0;
		int last = list.size();
		for (int i = start + 1; i <= end; i++) {
			list.add(makeNumber(digits, start, i));
			total += breakUp(list, digits, i, end);
			list.remove(last);
		}

		return total;
	}
	
	public static void main(String args[]) {
		try {
			//PrintStream out = System.out;
			PrintStream out = new PrintStream(FILE_OUT);
			BufferedReader in = new BufferedReader(new FileReader(FILE_IN));
			
			int cases = Integer.valueOf(in.readLine().trim());
			
			ArrayList<Long> list = new ArrayList<Long>();
			for (int caseIndex = 0; caseIndex < cases; caseIndex++) {
				String line = in.readLine().trim();
				char digits[] = new char[line.length()];
				line.getChars(0, digits.length, digits, 0);
				
				list.clear();
				long result = breakUp(list, digits, 0, digits.length);
				
				out.println("Case #" + (caseIndex + 1) + ": " + result);
			}
			
		} catch(IOException ioe) {
			ioe.printStackTrace();
		}
	}
}
