package pretwo;

import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.io.StreamTokenizer;
import java.util.Arrays;

public class Main {
	public static final String FILE_IN = "B/B-large.in";
	public static final String FILE_OUT = "B/B-large.out";

	public static void main(String args[]) {
		try {
			//PrintStream out = System.out;
			PrintStream out = new PrintStream(FILE_OUT);
			StreamTokenizer tokenizer = new StreamTokenizer(new FileReader(FILE_IN));

			int cases = nextInt(tokenizer);
			for (int i = 0; i < cases; i++) {
				int turnAroundTime = nextInt(tokenizer);
				int tripCountAB = nextInt(tokenizer);
				int tripCountBA = nextInt(tokenizer);

				Event events[] = new Event[(tripCountAB + tripCountBA) * 2];
				int index = 0;
				for (int j = 0; j < tripCountAB; j++) {
					events[index++] = new Event(Event.Type.LeavesA,
							nextTime(tokenizer));
					events[index++] = new Event(Event.Type.ReadyB,
							nextTime(tokenizer).offset(turnAroundTime));
				}
				for (int j = 0; j < tripCountBA; j++) {
					events[index++] = new Event(Event.Type.LeavesB,
							nextTime(tokenizer));
					events[index++] = new Event(Event.Type.ReadyA,
							nextTime(tokenizer).offset(turnAroundTime));
				}
				Arrays.sort(events);

				int trainsStartedAtA = 0;
				int trainsStartedAtB = 0;
				int trainsAtA = 0;
				int trainsAtB = 0;
				for (int j = 0; j < events.length ; j++) {
					//out.println(events[j]);
					switch(events[j].getType()) {
						case LeavesA:
							if (trainsAtA == 0) {
								//no trains, so one must have started here
								trainsStartedAtA++;
							} else {
								trainsAtA--;
							}
							break;
						case LeavesB:
							if (trainsAtB == 0) {
								//no trains, so one must have started here
								trainsStartedAtB++;
							} else {
								trainsAtB--;
							}
							break;
						case ReadyA:
							trainsAtA++;
							break;
						case ReadyB:
							trainsAtB++;
							break;
					}
				}
				out.println("Case #" + (i + 1) + ": " + trainsStartedAtA + " " + trainsStartedAtB);
			}
		} catch(IOException ioe) {
			ioe.printStackTrace();
		}
	}

	private static int nextInt(StreamTokenizer tokenizer) throws IOException {
		tokenizer.nextToken();
		assert(tokenizer.ttype == StreamTokenizer.TT_NUMBER);
		return (int)tokenizer.nval;
	}

	private static Time nextTime(StreamTokenizer tokenizer) throws IOException {
		int hours = nextInt(tokenizer);
		tokenizer.nextToken();
		assert(tokenizer.ttype == ':');
		return new Time(hours, nextInt(tokenizer));
	}
}
