package roundoneb.suba;

import java.io.IOException;
import java.util.ArrayList;

import util.CodeJam;

public class MainSubA extends CodeJam {
	public static final String FILE_IN = "a/A-small-attempt1.in";
	public static final String FILE_OUT = "a/A-small-attempt1.out";

	class Point {
		long x;
		long y;

		public Point(long x, long y) {
			this.x = x;
			this.y = y;
		}
	}

	MainSubA() throws IOException {
		super(FILE_IN, FILE_OUT);
		//super(FILE_IN, System.out);
	}

	void go() throws IOException {
		long cases = nextInt();
		for (long index = 0; index < cases; index++) {

			long n = nextInt();
			long A = nextInt();
			long B = nextInt();
			long C = nextInt();
			long D = nextInt();
			long x0 = nextInt();
			long y0 = nextInt();
			long M = nextInt();

			ArrayList<Point> pts = new ArrayList<Point>();

			long X = x0, Y = y0;
			pts.add(new Point(X, Y));
			for (long i = 1; i <= n - 1; i++) {
				X = (A * X + B) % M;
				Y = (C * Y + D) % M;
				pts.add(new Point(X, Y));
			}

			long count = 0;
			for (int i = 0; i < pts.size(); i++) {
				Point pt0 = pts.get(i);
				for (int j = i; j < pts.size(); j++) {
					Point pt1 = pts.get(j);
					if (pt0 == pt1) {
						continue;
					}

					for (int k = j; k < pts.size(); k++) {
						Point pt2 = pts.get(k);

						if (pt0 == pt2 || pt1 == pt2) {
							continue;
						}

						long centerX = (pt0.x + pt1.x + pt2.x) % 3;
						long centerY = (pt0.y + pt1.y + pt2.y) % 3;

						if (centerX == 0 && centerY == 0) {
							count++;
						}

					}
				}
			}

			out.println("Case #" + (index + 1) + ": " + count);
		}
	}

	public static void main(String args[]) {
		try {

			MainSubA a = new MainSubA();
			a.go();
		} catch (IOException io) {
			io.printStackTrace();
		}

	}
}
