package gcjijk;

import java.io.IOException;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;

public class Main{
    
    String filePath = new File("").getAbsolutePath();
    String readFilePath = filePath.concat("/src/gcjijk/text.in");
    String writeFilePath= filePath.concat("/src/gcjijk/text.out");
    
    String[] dataInLines;
    
    String[] dataOutLines;
    //1=1, i=2, j=3, k=4
    int[][] quat = {
        {1,2,3,4},
        {2,-1,4,-3},
        {3,-4,-1,2},
        {4,3,-2,-1}
    };
    
    public Main(){
        System.out.println("New Main Object");
    }
    
    public static void main(String[] args){
        Main m = new Main();
        m.Go();
    }
    
    public void Go(){
        System.out.println("Starting");
        readData();
        solve();
        writeData(dataOutLines);
    }
    
    //solve problem using algorithm and store answer to each test case as a string in string array dataOutLines
    public void solve(){
        System.out.println("Solving");
        
        String[] firstLine = dataInLines[0].split(" ");
        
        int testCases = Integer.parseInt(firstLine[0]);
        
        dataOutLines = new String[testCases];
        
        for(int i = 0; i < dataOutLines.length; i++){
            //algorithm here
            boolean answer;
            String line1[] = dataInLines[i*2+1].split(" ");
            String line2 = dataInLines[i*2+2];
            String actual = "";
            for(int j = 0; j < Integer.parseInt(line1[1]); j++){
                actual+=line2;
            }
            String[] characters = actual.split("");
            String charSearch = "i";
            String finalStr = "";
            String curChar = characters[0];
            for(int k = 1; k < characters.length; k++){
                if(curChar.equals(charSearch)){
                    finalStr+=curChar;
                    charSearch = nextChar(charSearch); 
                    curChar = characters[k];
                    continue;
                }
                String prevChar = curChar;
                curChar = quatSolve(curChar, characters[k]);
                System.out.print(prevChar+"*"+characters[k]+"="+curChar+",");
            }
            if(curChar.equals(charSearch)){
                finalStr+=curChar;
            }
            System.out.println("    "+finalStr);
            System.out.println(quatSolve(characters[0], characters[1]));
            answer = finalStr.equals("ijk");
            if(answer)
                dataOutLines[i] = "Case #"+(i+1)+": YES";
            else
                dataOutLines[i] = "Case #"+(i+1)+": NO";
        }
    }
    
    public String nextChar(String c){
        if(c.equals("i"))
            return "j";
        if(c.equals("j"))
            return "k";
        return "Error";
    }
    
    public String quatSolve(String s1, String s2){
        boolean hasNeg = false;
        if(s1.length() == 2)
            hasNeg = !hasNeg;
        if(s2.length() == 2)
            hasNeg = !hasNeg;
        int i1 = 0;
        int i2 = 0;
        //1=1, i=2, j=3, k=4
        if(s1.equals("-1") || s1.equals("1")) i1 = 1;
        else if(s1.equals("-i") || s1.equals("i")) i1 = 2;
        else if(s1.equals("-j") || s1.equals("j")) i1 = 3;
        else if(s1.equals("-k") || s1.equals("k")) i1 = 4;
        else System.out.println("Error");
        
        if(s2.equals("-1") || s2.equals("1")) i2 = 1;
        else if(s2.equals("-i") || s2.equals("i")) i2 = 2;
        else if(s2.equals("-j") || s2.equals("j")) i2 = 3;
        else if(s2.equals("-k") || s2.equals("k")) i2 = 4;
        else System.out.println("Error");
        
        int out = quat[i1-1][i2-1];
        if(out < 0)
            hasNeg = !hasNeg;
        out = Math.abs(out);
        
        String outStr = "";
        
        if(hasNeg)
            outStr += "-";
        
        if(out == 1) outStr+="1";
        else if(out == 2) outStr+="i";
        else if(out == 3) outStr+="j";
        else if(out == 4) outStr+="k";
        else System.out.println("Error");
        
        return outStr;
    }
    
    //method to read data into string array dataInLines
    public void readData(){
        try {
            ReadFile file = new ReadFile(readFilePath);
            dataInLines = file.OpenFile();
            System.out.println("Data Read");
        }
        catch (IOException e){System.out.println(e.getMessage());}
    }
    
    //method to write data in string array data to out file
    public void writeData(String[] data){
        String dataOut = "";
        System.out.println("Printing Answers");
        for(int i = 0; i < data.length; i++){
            dataOut+=data[i];
            if(i < data.length-1)
                dataOut+="\n";
            System.out.println(data[i]);
        }
        try{
            WriteFile file = new WriteFile(writeFilePath, true);
            file.writeToFile(dataOut);
        }
        catch (IOException e){System.out.println(e.getMessage());}
        System.out.println("Done Printing Answers");
    }
    
    //object that can return string array of all data in file
    public class ReadFile {
        
        private String path;
        
        public ReadFile(String file_path){
                path = file_path;
        }
        
        public String[] OpenFile() throws IOException {
            FileReader fr = new FileReader(path);
            BufferedReader textReader = new BufferedReader(fr);
            
            int numberOfLines = readLines();
            String[] textData = new String[numberOfLines];
            
            int i;
            
            for (i=0; i<numberOfLines; i++){
                textData[i] = textReader.readLine();
            }
            
            textReader.close();
            return textData;
        }
            
        int readLines() throws IOException {
            FileReader file_to_read = new FileReader(path);
            BufferedReader bf = new BufferedReader(file_to_read);
            
            String aLine;
            int numberOfLines = 0;
            
            while (( aLine = bf.readLine()) !=null) {
                numberOfLines++;
            }
            bf.close();
            
            return numberOfLines;
        }
    }
    
    //Write answer to file
    public class WriteFile {
        
        boolean append_to_file;
        private String path;
    
        public WriteFile(){
            append_to_file = false;
        }
    
        public WriteFile(String file_path) {
            path = file_path;
        }
        
        public WriteFile( String file_path, boolean append_value ) {
            path = file_path;
        }
        
        public void writeToFile (String textLine) throws IOException {
            FileWriter write =  new FileWriter(path, append_to_file);
            PrintWriter print_line = new PrintWriter(write);
            
            print_line.printf("%s", textLine);
            
            print_line.close();
        }
    }
    
}