package gcjihop;

import java.io.IOException;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;

public class Main{
    
    String filePath = new File("").getAbsolutePath();
    String readFilePath = filePath.concat("/src/gcjihop/text.in");
    String writeFilePath= filePath.concat("/src/gcjihop/text.out");
    
    String[] dataInLines;
    
    String[] dataOutLines;
    
    public Main(){
        System.out.println("New Main Object");
    }
    
    public static void main(String[] args){
        Main m = new Main();
        m.Go();
    }
    
    public void Go(){
        System.out.println("Starting");
        readData();
        solve();
        writeData(dataOutLines);
    }
    
    //solve problem using algorithm and store answer to each test case as a string in string array dataOutLines
    public void solve(){
        System.out.println("Solving");
        
        String[] firstLine = dataInLines[0].split(" ");
        
        int testCases = Integer.parseInt(firstLine[0]);
        
        dataOutLines = new String[testCases];
        int maxPancakes = 9;
        
        main:
        for(int i = 0; i < dataOutLines.length; i++){
            //algorithm here
            int answer;
            String line1 = dataInLines[i*2+1];
            String[] line2 = dataInLines[i*2+2].split(" ");
            int[] frequency = new int[maxPancakes];
            //ArrayList<Integer> plates = new ArrayList<Integer>();
            //int maxTime = 0;
            int specMin = 0;
            for(int k = 0; k < line2.length; k++){
                frequency[Integer.parseInt(line2[k])-1]++;
                System.out.print(line2[k]+",");
            }
            int maxNum = 0;
            outer:
            while(true){
                inner:
                for(int k = frequency.length-1; k >= 0; k--){
                    if(frequency[k] != 0){
                        maxNum = k+1;
                        break inner;
                    }
                }
                
                int maxNum2 = 0;
                inner2:
                for(int k = maxNum-2; k >= 0; k--){
                    if(frequency[k] != 0){
                        maxNum2 = k+1;
                        break inner2;
                    }
                }
                int maxLowerHalf = maxNum/2;
                int maxUpperHalf = maxNum - maxLowerHalf;
                System.out.print("   "+maxNum+","+frequency[maxNum-1]+","+maxNum2+",");
                if(maxNum2 != 0)
                    System.out.print(frequency[maxNum2-1]);
                if(frequency[maxNum-1]+maxUpperHalf > maxNum){
                    System.out.print(" Break1");
                    break outer;
                }
                if(maxNum-frequency[maxNum-1]>=maxNum2){
                    frequency[maxLowerHalf-1]+=frequency[maxNum-1];
                    frequency[maxUpperHalf-1]+=frequency[maxNum-1];
                    specMin += frequency[maxNum-1];
                    frequency[maxNum-1] = 0;
                    System.out.print(" Continue1");
                    continue outer;
                }
                else{
                    int freq = frequency[maxNum-1];
                    for(int k = maxNum-2; k > maxUpperHalf-1; k--){
                        freq+=frequency[k];
                    }
                    if(maxUpperHalf+freq <= maxNum){
                        frequency[maxLowerHalf-1]+=frequency[maxNum-1];
                        frequency[maxUpperHalf-1]+=frequency[maxNum-1];
                        specMin += frequency[maxNum-1];
                        frequency[maxNum-1] = 0;
                        System.out.print(" Continue2");
                        continue outer;
                    }
                    else{
                        System.out.print(" Break2");
                        break outer;
                    }
                }
            }
//            for(int k = 0; k < line2.length; k++){
//                plates.add(Integer.parseInt(line2[k]));
//                if(Integer.parseInt(line2[k]) > maxTime)
//                    maxTime = Integer.parseInt(line2[k]);
//                System.out.print(line2[k]+",");
//            }
//            int specMin = 0;
//            while (true){
//                int maxNum = 0;
//                for(int j = 0; j < plates.size(); j++){
//                    if(plates.get(j) > maxNum)
//                        maxNum = plates.get(j);
//                }
//                int halfMax = maxNum/2;
//                int otherHalfMax = maxNum-halfMax;
//                int freq = 0;
//                ArrayList<Integer> toAdd = new ArrayList<Integer>();
//                for(int j = 0; j < plates.size(); j++){
//                    if(plates.get(j) > otherHalfMax){
//                        freq++;
//                        plates.set(j, plates.get(j)-(plates.get(j)/2));
//                        toAdd.add(plates.get(j)/2);
//                    }
//                }
//                if(otherHalfMax+freq+specMin >= maxTime)
//                    break;
//                else{
//                    for(int l = 0; l < toAdd.size(); l++)
//                        plates.add(toAdd.get(l));
//                    specMin+=freq;
//                    maxTime = otherHalfMax+specMin;
//                }
//            }
           
            answer = maxNum+specMin;
            System.out.println("   MaxTime: "+answer);
            dataOutLines[i] = "Case #"+(i+1)+": "+answer;
        }
    }
    
    //method to read data into string array dataInLines
    public void readData(){
        try {
            ReadFile file = new ReadFile(readFilePath);
            dataInLines = file.OpenFile();
            System.out.println("Data Read");
        }
        catch (IOException e){System.out.println(e.getMessage());}
    }
    
    //method to write data in string array data to out file
    public void writeData(String[] data){
        String dataOut = "";
        System.out.println("Printing Answers");
        for(int i = 0; i < data.length; i++){
            dataOut+=data[i];
            if(i < data.length-1)
                dataOut+="\n";
            System.out.println(data[i]);
        }
        try{
            WriteFile file = new WriteFile(writeFilePath, true);
            file.writeToFile(dataOut);
        }
        catch (IOException e){System.out.println(e.getMessage());}
        System.out.println("Done Printing Answers");
    }
    
    //object that can return string array of all data in file
    public class ReadFile {
        
        private String path;
        
        public ReadFile(String file_path){
                path = file_path;
        }
        
        public String[] OpenFile() throws IOException {
            FileReader fr = new FileReader(path);
            BufferedReader textReader = new BufferedReader(fr);
            
            int numberOfLines = readLines();
            String[] textData = new String[numberOfLines];
            
            int i;
            
            for (i=0; i<numberOfLines; i++){
                textData[i] = textReader.readLine();
            }
            
            textReader.close();
            return textData;
        }
            
        int readLines() throws IOException {
            FileReader file_to_read = new FileReader(path);
            BufferedReader bf = new BufferedReader(file_to_read);
            
            String aLine;
            int numberOfLines = 0;
            
            while (( aLine = bf.readLine()) !=null) {
                numberOfLines++;
            }
            bf.close();
            
            return numberOfLines;
        }
    }
    
    //Write answer to file
    public class WriteFile {
        
        boolean append_to_file;
        private String path;
    
        public WriteFile(){
            append_to_file = false;
        }
    
        public WriteFile(String file_path) {
            path = file_path;
        }
        
        public WriteFile( String file_path, boolean append_value ) {
            path = file_path;
        }
        
        public void writeToFile (String textLine) throws IOException {
            FileWriter write =  new FileWriter(path, append_to_file);
            PrintWriter print_line = new PrintWriter(write);
            
            print_line.printf("%s", textLine);
            
            print_line.close();
        }
    }
    
}