import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Landmowner {
	private static BufferedWriter writer;
	private static boolean[] rows;
	private static int N;
	private static int M;
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		BufferedReader reader = null;
		try {
			reader = new BufferedReader(new FileReader("C:\\Users\\dvazquez\\Downloads\\B-small-attempt2.in"));
			initWriter("C:\\Users\\dvazquez\\Desktop\\landmower.out");
			
			int caseCount = Integer.parseInt(reader.readLine());
			for (int i = 0; i < caseCount; i++){				
				String[] size = reader.readLine().split(" ");
				N = Integer.parseInt(size[0]); 
				M = Integer.parseInt(size[1]);

				rows = new boolean[N];
				
				int[][] land = loadLand(reader);
				boolean res = checkRows(land) & checkCols(land);
				
				writeToFile("Case #" + (i+1) + ": " + ((res)? "YES" : "NO"));
			}
			
		} catch (IOException e) {
		} finally{
			if (reader != null){
				try { reader.close(); } catch (IOException e){}
			}
			if (writer != null){
				try { writer.close(); } catch (IOException e){}
			}
		}	
	}
	
	private static boolean checkRows(int[][] land){
		for (int i=0; i < N; i++){
			int enter = land[i][0];
			
			for (int j=1; j < M; j++){
				
				if (enter > land[i][j]){
					if (!checkColumn(land, j))				
						return false;
				}							
			}
			
			rows[i] = true;
		}
		
		return true;
	}
	
	private static boolean checkCols(int[][] land){
		for (int i=0; i<M; i++){
			int enter = land[0][i];
			
			for (int j=1; j < N; j++){
				if (enter > land[j][i]){
					if (!checkRow(land, j))
						return false;
				}
			}
			
		}		
		return true;
	}
	
	private static boolean checkRow(int[][] land, int row){
		return rows[row];
	}
	
	private static boolean checkColumn(int[][] land, int col){
		int row = 0;		
		int enter = land[row][col];
		while (row+1 < N){
			if (enter != land[row+1][col]) return false;
			row++;
		}
		
		return true;
	}
	
	private static int[][] loadLand(BufferedReader reader) throws IOException{
		int[][] land = new int[N][M];
		int r = 0;
		while (r < N){
			String[] tmp = reader.readLine().split(" ");
			for (int i=0; i< M; i++){
				land[r][i] = Integer.parseInt(tmp[i]);
			}			
			r++;
		}
		
		return land;
	}
	
	private static void printLand(int[][] land){
		int len = land[0].length;
		
		System.out.println("Land:");
		for (int i=0; i< land.length; i++){
			for (int j=0; j< len; j++){
				System.out.print(land[i][j]);
			}
			System.out.println();
		}
	}
	
	private static void initWriter(String output) {
		try {
			writer = new BufferedWriter(new FileWriter(output));			
		} catch (Exception e) {}
	}
	
	private static void writeToFile(String text) {
		try {
			writer.write(text);
			writer.newLine();
		} catch (Exception e) {}
	}
}
