import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;


public class Tester {
	private static BufferedWriter writer;
	private static boolean finished = true;
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		BufferedReader reader = null;
		try {
			reader = new BufferedReader(new FileReader("C:\\Users\\dvazquez\\Downloads\\A-large.in"));
			initWriter("C:\\Users\\dvazquez\\Desktop\\tictactoe.out");
			
			int caseCount = Integer.parseInt(reader.readLine());
			for (int i = 0; i < caseCount; i++){				
				writeToFile("Case #" + (i+1) + ": " + getResult(getTestBoard(reader)));
			}
			
		} catch (IOException e) {
		} finally{
			if (reader != null){
				try { reader.close(); } catch (IOException e){}
			}
			if (writer != null){
				try { writer.close(); } catch (IOException e){}
			}
		}		
	}
	
	private static void initWriter(String output) {
		try {
			writer = new BufferedWriter(new FileWriter(output));			
		} catch (Exception e) {}
	}
	
	private static void writeToFile(String text) {
		try {
			writer.write(text);
			writer.newLine();
		} catch (Exception e) {}
	}
	
	private static String getResult(char[][] board){
		final String xWonStr = "X won";
		final String oWonStr = "O won";
		String res = null;
		boolean xWon = true; boolean oWon = true;
		
		res = testRow(board, 0); if (!res.isEmpty()) return res; res = "";
		res = testRow(board, 1); if (!res.isEmpty()) return res; res = "";
		res = testRow(board, 2); if (!res.isEmpty()) return res; res = "";
		res = testRow(board, 3); if (!res.isEmpty()) return res; res = "";
		
		res = testColumn(board, 0); if (!res.isEmpty()) return res; res = "";
		res = testColumn(board, 1); if (!res.isEmpty()) return res; res = "";
		res = testColumn(board, 2); if (!res.isEmpty()) return res; res = "";
		res = testColumn(board, 3); if (!res.isEmpty()) return res; 
		
		// Diagonal up-down
		xWon = testX(board[0][0]) && testX(board[1][1]) && testX(board[2][2]) && testX(board[3][3]);				
		if (xWon) return xWonStr;
			
		oWon = testO(board[0][0]) && testO(board[1][1]) && testO(board[2][2]) && testO(board[3][3]);
		if (oWon) return oWonStr;

		// Diagonal down-up	
		xWon = testX(board[3][0]) && testX(board[2][1]) && testX(board[1][2]) && testX(board[0][3]);				
		if (xWon) return xWonStr;
				
		oWon = testO(board[3][0]) && testO(board[2][1]) && testO(board[1][2]) && testO(board[0][3]);
		if (oWon) return oWonStr;
		
		return (finished)? "Draw" : "Game has not completed";
	}
	
	private static String testRow(char[][] board, int row){
		boolean xWon = true; boolean oWon = true;
		
		for(char c : board[row]){ xWon &= (c == 'X' || c == 'T'); oWon &= (c == 'O' || c == 'T'); }		
		if (xWon) return "X won"; else if (oWon) return "O won";
		
		return "";
	}
	
	private static String testColumn(char[][] board, int col){		
		boolean xWon = testX(board[0][col]) && testX(board[1][col]) && testX(board[2][col]) && testX(board[3][col]);				
		if (xWon) return "X won";
		
		boolean oWon = testO(board[0][col]) && testO(board[1][col]) && testO(board[2][col]) && testO(board[3][col]);
		if (oWon) return "O won";
		
		return "";
	}
	
	private static boolean testX(char c){ return c == 'X' || c == 'T'; }
	
	private static boolean testO(char c){ return c == 'O' || c == 'T'; }

	private static char[][] getTestBoard(BufferedReader reader) throws IOException{
		finished = true;
		char[][] board = new char[4][4];		
		int processed = 0;
		
		while(processed < 4){
			int col = 0;
			for(char c : reader.readLine().toCharArray()){
				switch(c){				
				case '.': finished = false;
				default: board[processed][col] = c;
				}
				col++;
			}
			processed++;
		}		
		reader.readLine();
		return board;
	}
	
	private static void printBoard(char[][] board){
		System.out.println("Board:");
		for (int i = 0; i < 4; i++){
			for (int j = 0; j < 4; j++){
				System.out.print(board[i][j]);
			}
			System.out.println();
		}
		System.out.println();
	}
}