import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Scanner;

public class Main implements Runnable {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new Thread(new Main()).start();
	}

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			run1();
		} catch (IOException e) {
			throw new RuntimeException();
		}
	}

	int nextInt(StreamTokenizer st) throws IOException {
		st.nextToken();
		return (int) st.nval;
	}

	private List<Integer> kmp(String x, String a) {
		String s = a + "$" + x;
		int[] oppa = new int[s.length()];
		oppa[0] = 0;
		int tmp = 0;
		List<Integer> res = new ArrayList<Integer>();
		for (int i = 1; i < s.length(); i++) {
			while (tmp != 0 && s.charAt(tmp) != s.charAt(i)) {
				// System.out.println(i + " " + tmp);
				tmp = oppa[tmp - 1];
			}
			if (s.charAt(tmp) == s.charAt(i))
				tmp++;
			oppa[i] = tmp;
			if (tmp == a.length()) {
				res.add(i - a.length() - a.length());
			}
		}
		return res;
	}

	double nextDouble(StreamTokenizer st) throws IOException {
		st.nextToken();
		return st.nval;
	}

	String nextLine(StreamTokenizer st) throws IOException {
		st.nextToken();
		return st.sval;
	}

	int n;
	int[][] arr;
	boolean[] was;

	public void run1() throws IOException {
		Scanner sc = new Scanner(new FileReader("input.txt"));
		PrintWriter pw = new PrintWriter(new FileWriter("output.txt"));
		int tN = sc.nextInt();
		for (int tn = 1; tn <= tN; tn++) {
			n = sc.nextInt();
			arr = new int[n][4];
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < 4; j++)
					arr[i][j] = sc.nextInt();
			}
			was = new boolean[n];
			int res = 0;
			for (int i = 0; i < n; i++)
				if (!was[i]) {
					int[] oppa = find(i);
					res = Math.max(res, -oppa[0] + oppa[1] + oppa[2]);
				}

			pw.printf("Case #%d: %d\n", tn, res + 1);
		}
		pw.close();
	}

	int[] find(int a) {
		was[a] = true;
		int[] res = new int[] { arr[a][0] + arr[a][1], arr[a][2], arr[a][3] };
		for (int i = 0; i < n; i++)
			if (!was[i] && inter(arr[a][0], arr[a][1], arr[i][0], arr[i][1])
					&& inter(arr[a][2], arr[a][3], arr[i][2], arr[i][3])) {
				int[] tmp = find(i);
				if (tmp[0] < res[0])
					res[0] = tmp[0];
				res[1] = Math.max(res[1], tmp[1]);
				res[2] = Math.max(res[2], tmp[2]);
			}
		return res;
	}

	boolean inter(int a1, int a2, int b1, int b2) {
		return isin(a1, b1, b2) || isin(a2, b1, b2) || isin(b1, a1, a2)
				|| isin(b2, a1, a2);
	}

	boolean isin(int a, int b1, int b2) {
		return a >= b1 - 1 && a <= b2 + 1;
	}
}