import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Scanner;

public class Main implements Runnable {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new Thread(new Main()).start();
	}

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			run1();
		} catch (IOException e) {
			throw new RuntimeException();
		}
	}

	int nextInt(StreamTokenizer st) throws IOException {
		st.nextToken();
		return (int) st.nval;
	}

	private List<Integer> kmp(String x, String a) {
		String s = a + "$" + x;
		int[] oppa = new int[s.length()];
		oppa[0] = 0;
		int tmp = 0;
		List<Integer> res = new ArrayList<Integer>();
		for (int i = 1; i < s.length(); i++) {
			while (tmp != 0 && s.charAt(tmp) != s.charAt(i)) {
				// System.out.println(i + " " + tmp);
				tmp = oppa[tmp - 1];
			}
			if (s.charAt(tmp) == s.charAt(i))
				tmp++;
			oppa[i] = tmp;
			if (tmp == a.length()) {
				res.add(i - a.length() - a.length());
			}
		}
		return res;
	}

	double nextDouble(StreamTokenizer st) throws IOException {
		st.nextToken();
		return st.nval;
	}

	String nextLine(StreamTokenizer st) throws IOException {
		st.nextToken();
		return st.sval;
	}

	long mod = 100003;

	public void run1() throws IOException {
		Scanner sc = new Scanner(new FileReader("input.txt"));
		PrintWriter pw = new PrintWriter(new File("output.txt"));
		int tN = sc.nextInt();

		for (int tn = 1; tn <= tN; tn++) {
			int n = sc.nextInt();
			long[][] res = new long[n - 1][n];
			for (int i = 0; i < n - 1; i++) {
				res[i][0] = 0;
				res[i][1] = 1;
			}
			long[][] c = new long[n + 1][n + 2];
			for (int i = 0; i <= n; i++) {
				c[i][0] = c[i][i] = 1;
				for (int j = 1; j < i; j++)
					c[i][j] = (c[i - 1][j - 1] + c[i - 1][j]) % mod;
			}

			long r = 1;
			for (int len = 2; len < n; len++) {
				for (int last = len - 1; last < n - 1; last++) {
					for (int prevPos = 1; prevPos < len; prevPos++) {
						res[last][len] += res[len - 2][prevPos]
								* c[last - len + 1][len - prevPos - 1];
						res[last][len] %= mod;
					}
					res[last][len] %= mod;
				}
				r += res[n - 2][len];
			}
			pw.printf("Case #%d: %d\n", tn, r);
		}
		pw.close();
	}

}