import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;

public class Main implements Runnable {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new Thread(new Main()).start();
	}

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			run1();
		} catch (IOException e) {
			throw new RuntimeException();
		}
	}

	int nextInt(StreamTokenizer st) throws IOException {
		st.nextToken();
		return (int) st.nval;
	}

	private List<Integer> kmp(String x, String a) {
		String s = a + "$" + x;
		int[] oppa = new int[s.length()];
		oppa[0] = 0;
		int tmp = 0;
		List<Integer> res = new ArrayList<Integer>();
		for (int i = 1; i < s.length(); i++) {
			while (tmp != 0 && s.charAt(tmp) != s.charAt(i)) {
				// System.out.println(i + " " + tmp);
				tmp = oppa[tmp - 1];
			}
			if (s.charAt(tmp) == s.charAt(i))
				tmp++;
			oppa[i] = tmp;
			if (tmp == a.length()) {
				res.add(i - a.length() - a.length());
			}
		}
		return res;
	}

	double nextDouble(StreamTokenizer st) throws IOException {
		st.nextToken();
		return st.nval;
	}

	String nextLine(StreamTokenizer st) throws IOException {
		st.nextToken();
		return st.sval;
	}

	long mod = 10000000000l;

	public void run1() throws IOException {
		Scanner sc = new Scanner(new FileReader("input.txt"));
		PrintWriter pw = new PrintWriter(new File("output.txt"));
		int tn = sc.nextInt();
		for (int t = 1; t <= tn; t++) {
			int r = sc.nextInt();
			int k = sc.nextInt();
			int n = sc.nextInt();
			long[] c = new long[n];
			for (int i = 0; i < n; i++)
				c[i] = sc.nextInt();
			int[] ne = new int[n];
			long[] p = new long[n];
			for (int i = 0; i < n; i++) {
				int cur = i;
				int sum = 0;
				while (true) {
					if (sum + c[cur] > k)
						break;
					sum += c[cur];
					cur++;
					cur %= n;
					if (cur == i)
						break;
				}
				p[i] = sum;
				ne[i] = cur;
			}
			Object[] res = get(r, ne, p);
			long re = ((long[]) res[1])[0];
			pw.printf("Case #%d: " + re + "\n", t);
		}
		pw.close();
	}

	Object[] get(int k, int[] ne, long[] p) {
		if (k == 1)
			return new Object[] { ne, p };
		Object[] re = get(k / 2, ne, p);
		int[] nne = ((int[]) re[0]);
		long[] np = ((long[]) re[1]);
		int n = ne.length;
		int[] rne = new int[n];
		long[] rp = new long[n];
		for (int i = 0; i < n; i++) {
			rne[i] = nne[nne[i]];
			rp[i] = np[i] + np[nne[i]];
		}
		if (k % 2 == 0)
			return new Object[] { rne, rp };
		int[] nrne = new int[n];
		long[] nrp = new long[n];
		for (int i = 0; i < n; i++) {
			nrne[i] = rne[ne[i]];
			nrp[i] = p[i] + rp[ne[i]];
		}
		return new Object[] { nrne, nrp };
	}

}