import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class Main1 implements Runnable {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new Thread(new Main1()).start();
	}

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			run1();
		} catch (IOException e) {
			throw new RuntimeException();
		}
	}

	int nextInt(StreamTokenizer st) throws IOException {
		st.nextToken();
		return (int) st.nval;
	}

	private List<Integer> kmp(String x, String a) {
		String s = a + "$" + x;
		int[] oppa = new int[s.length()];
		oppa[0] = 0;
		int tmp = 0;
		List<Integer> res = new ArrayList<Integer>();
		for (int i = 1; i < s.length(); i++) {
			while (tmp != 0 && s.charAt(tmp) != s.charAt(i)) {
				// System.out.println(i + " " + tmp);
				tmp = oppa[tmp - 1];
			}
			if (s.charAt(tmp) == s.charAt(i))
				tmp++;
			oppa[i] = tmp;
			if (tmp == a.length()) {
				res.add(i - a.length() - a.length());
			}
		}
		return res;
	}

	double nextDouble(StreamTokenizer st) throws IOException {
		st.nextToken();
		return st.nval;
	}

	String nextLine(StreamTokenizer st) throws IOException {
		st.nextToken();
		return st.sval;
	}

	public void run1() throws IOException {
		Scanner sc = new Scanner(new FileReader("input.txt"));
		PrintWriter pw = new PrintWriter(new FileWriter("output.txt"));
		int max = 1000000;
		boolean[] isp = new boolean[max];
		Arrays.fill(isp, true);
		int pn = 0;
		isp[0] = isp[1] = false;
		for (int i = 2; i * i < max; i++) {
			if (isp[i]) {
				for (int j = i * i; j < max; j += i) {
					isp[j] = false;
				}
			}
		}
		for (int i = 0; i < max; i++)
			if (isp[i])
				pn++;
		int[] pl = new int[pn];
		int cur = 0;
		for (int i = 0; i < max; i++)
			if (isp[i])
				pl[cur++] = i;
		int tN = sc.nextInt();
		int[] bound = new int[] { 1, 10, 100, 1000, 10000, 100000, 1000000 };
		long time = -System.currentTimeMillis();
		for (int tn = 1; tn <= tN; tn++) {
			System.out.println(tn);
			int d = bound[sc.nextInt()];
			int n = sc.nextInt();
			long[] arr = new long[n];
			for (int i = 0; i < n; i++)
				arr[i] = sc.nextLong();
			long res = -1;
			if (n <= 2) {
				if (n == 2 && arr[0] == arr[1])
					pw.printf("Case #%d: %d\n", tn, arr[0]);
				else
					pw.printf("Case #%d: I don't know.\n", tn);
				continue;
			}
			oppa: for (int p : pl) {
				if (p > d)
					break;
				for (int t = 0; t < n - 3; t++) {
					if (((arr[t + 1] - arr[t]) * (arr[t + 3] - arr[t + 2])
							- (arr[t + 2] - arr[t + 1])
							* (arr[t + 2] - arr[t + 1])) % p != 0)
						continue oppa;
				}
				for (long a = 0; a < p; a++) {
					long b = ((arr[1] - arr[0] * a) % p + p) % p;
					boolean ok = arr[0] < p;
					for (int i = 2; i < n; i++)
						if (arr[i] != (a * arr[i - 1] + b) % p) {
							ok = false;
							break;
						}
					if (ok) {
						// System.out.println(p + " " + a + " " + b);
						if (res != -1 && res != (arr[n - 1] * a + b) % p) {
							res = -1;
							break oppa;
						}
						res = (arr[n - 1] * a + b) % p;
					}
				}
			}
			if (res == -1) {
				pw.printf("Case #%d: I don't know.\n", tn);
			} else
				pw.printf("Case #%d: %d\n", tn, res);
		}
		pw.close();
		System.out.println(time + System.currentTimeMillis());
	}

	long gcd(long a, long b) {
		return b == 0 ? a : gcd(b, a % b);
	}
}