import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;
import java.util.Set;

public class Main implements Runnable {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new Thread(new Main()).start();
	}

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			run1();
		} catch (IOException e) {
			throw new RuntimeException();
		}
	}

	int nextInt(StreamTokenizer st) throws IOException {
		st.nextToken();
		return (int) st.nval;
	}

	private List<Integer> kmp(String x, String a) {
		String s = a + "$" + x;
		int[] oppa = new int[s.length()];
		oppa[0] = 0;
		int tmp = 0;
		List<Integer> res = new ArrayList<Integer>();
		for (int i = 1; i < s.length(); i++) {
			while (tmp != 0 && s.charAt(tmp) != s.charAt(i)) {
				// System.out.println(i + " " + tmp);
				tmp = oppa[tmp - 1];
			}
			if (s.charAt(tmp) == s.charAt(i))
				tmp++;
			oppa[i] = tmp;
			if (tmp == a.length()) {
				res.add(i - a.length() - a.length());
			}
		}
		return res;
	}

	double nextDouble(StreamTokenizer st) throws IOException {
		st.nextToken();
		return st.nval;
	}

	String nextLine(StreamTokenizer st) throws IOException {
		st.nextToken();
		return st.sval;
	}

	long mod = 10000000000l;

	public void run1() throws IOException {
		Scanner sc = new Scanner(new FileReader("input.txt"));
		PrintWriter pw = new PrintWriter(new File("output.txt"));
		int tN = sc.nextInt();
		for (int tn = 1; tn <= tN; tn++) {
			int n = sc.nextInt();
			int m = sc.nextInt();
			sc.nextLine();
			Set<String> set = new HashSet<String>();
			for (int i = 0; i < n; i++) {
				String s = sc.nextLine() + '/';
				for(int c = 1; c < s.length(); c++) {
					if(s.charAt(c) == '/') {
						String tmp = s.substring(0, c);
						set.add(tmp);
					}
				}
			}
			int res = 0;
			for (int i = 0; i < m; i++) {
				String s = sc.nextLine() + '/';
				for(int c = 1; c < s.length(); c++) {
					if(s.charAt(c) == '/') {
						String tmp = s.substring(0, c);
						if(!set.contains(tmp)) {
							res++;
							set.add(tmp);
						}
					}
				}
			}
			pw.printf("Case #%d: %d\n", tn, res);
		}
		pw.close();
	}

}