package A;

import org.jgrapht.Graph;
import org.jgrapht.graph.*;
import org.jgrapht.WeightedGraph;
import org.jgrapht.graph.DefaultDirectedWeightedGraph;
import org.jgrapht.graph.DefaultEdge;
import org.jgrapht.graph.WeightedMultigraph;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        for (int i = 1; i <= t; ++i) {
            int totalDistance = in.nextInt();
            int n = in.nextInt();
            List<horse> horses = new LinkedList<>();
            for (int j = 0; j < n; j++) {
                horses.add(new horse(in.nextInt(), in.nextInt()));
            }
            System.out.println("Case #" + i + ": " + run(horses,totalDistance));
        }
    }

    private static String run(List<horse> horses, int distance){
        Collections.sort(horses);
        horses.get(0).arrivalTime = fastestArrival(horses.get(0),distance);
        for (int i = 1; i < horses.size(); i++) {
            double fastest = fastestArrival(horses.get(i),distance);
            if (fastest < horses.get(i-1).arrivalTime)
                horses.get(i).arrivalTime = horses.get(i-1).arrivalTime;
            else
                horses.get(i).arrivalTime=fastest;
        }
        double speed = speed(distance, horses.get(horses.size() - 1).arrivalTime);
        return Double.toString(speed);
    }

    private static double speed(int distance, double time){
        return ((double) distance) / time;
    }

    private static double fastestArrival(horse h, int distance){
        double toTravel = distance - h.start;
        return toTravel /  h.maxSpeed;
    }


}