package com.danwainwright.java.codejam.y2017.numbers.main;

import java.util.LinkedList;
import java.util.List;

public class Number {
    private List<Byte> digits;

    public Number(List<Byte> number){
        this.digits = number;
        trimLeadingZeros();
    }

    public Number(String number){
        this.digits = new LinkedList<>();
        for (char c : number.toCharArray()){
            digits.add(Byte.valueOf(Character.toString(c)));
        }
        trimLeadingZeros();
    }

    private void trimLeadingZeros(){
        while (digits.get(0) == 0){
            digits = digits.subList(1, digits.size());
        }
    }

    public void decrement(int position){
        assert position < digits.size();
        assert position >= 0;
        byte current = digits.get(position);
        int length = digits.size();
        List<Byte> temp = digits.subList(0, position);
        temp.add((byte) (current - 1));
        for (int i = position; i < length -1 ; i++) {
            temp.add((byte) 9);
        }
        digits = temp;
        trimLeadingZeros();
    }

    private int firstDecrease(){
        for (int i = 1; i < digits.size(); i++) {
            byte first = digits.get(i-1);
            byte second = digits.get(i);
            if (second < first)
                return i - 1;
        }
        return -1;
    }

    public void tidy(){
        boolean done = false;
        while (!done){
            int position = firstDecrease();
            if (position == - 1)
                done = true;
            else
                decrement(position);
        }
    }


    @Override
    public String toString() {
        StringBuilder number = new StringBuilder();
        for (Byte b : digits)
            number.append(b);
        return number.toString();
    }
}
