package C;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        for (int i = 1; i <= t; ++i) {
            int n = in.nextInt();
            int q = in.nextInt();
            List<City> cities= new LinkedList<>();
            List<List<City> >pairs = new LinkedList<>();
            for (int j = 0; j < n; j++)
                cities.add(new City(new horse(in.nextInt(), in.nextInt())));
            int[][] distances = new int[n][n];
            for (int j = 0; j < n; j++) {
                for (int k = 0; k < n; k++)
                    distances[j][k] = in.nextInt();
            }
            for (int j = 0; j < q; j++) {
                List<City> temp = new LinkedList<>();
                temp.add(cities.get(in.nextInt()-1));
                temp.add(cities.get(in.nextInt()-1));
                pairs.add(temp);
            }

            System.out.println("Case #" + i + ": " + run(distances, pairs, cities));
        }
    }

    private static String run(int[][] distances, List<List<City>> pairs, List<City> cities){
        if (pairs.size() != 1)
            System.out.println("Error");
        //Map<City, Integer> startDistances= new HashMap<>();
        //startDistances.put(cities.get(0),0);
        for (int i = 1; i < cities.size(); i++) {
            //startDistances.put(cities.get(i),startDistances.get(cities.get(i-1)) + distances[i-1][i]);
            cities.get(i-1).distanceToNext = distances[i-1][i];
        }
        double time = timeTo(pairs.get(0).get(1), pairs.get(0).get(0), pairs.get(0).get(0).horse, cities, 0);
        return Double.toString(time);
    }

    private static double timeTo(City to, City from, horse horse, List<City> cities, double current){
        if (to.equals(from))
            return current;
        City next = cities.get(cities.indexOf(from) + 1);
        double swap = timeTo(to, next, from.horse, cities,current + from.horse.time(from.distanceToNext));
        double dont = timeTo(to, next, horse, cities,current + horse.time(from.distanceToNext));
        return (Math.min(swap,dont));
    }

    private static City furthest(Map<City, Integer> distances, City city, horse horse){
        Set<City> reachable = new HashSet<>();
        for (City c : distances.keySet()){
            if (distances.get(c) < distances.get(city))
                continue;
            if ((distances.get(c) - distances.get(city)) <= horse.distanceLeft)
                reachable.add(c);
        }
        return Collections.max(reachable,
                (City c1, City c2) -> Integer.compare(distances.get(c1),distances.get(c2)));
    }


    private static boolean Switch(horse h, City city, Map<City, Integer> distances){
        if (city.horse.maxSpeed <= h.maxSpeed){
            if (h.distanceLeft > city.horse.distanceLeft)
                return false;
            if (furthest(distances,city,h) == furthest(distances,city,city.horse))
                return false;
            // more difficult
        } else {
            if (h.distanceLeft < city.horse.distanceLeft)
                return true;
            if (furthest(distances,city,h) == furthest(distances,city,city.horse))
                return true;
            //more difficult
        }

        //fastest to next switch place
        return false;
    }

}