import java.util.Scanner;

class Trie{
	TrieNode root;
	int counter;
	
	public Trie(){
		root = new TrieNode();
		counter = 0;
	}
	
	public void insert(String word){
		TrieNode curr = root;
		//System.out.println("inserting "+word);

		int len = word.length();
		int i;
		for(i=0;i<len;i++){
			if(curr.getNode(word.charAt(i)) == null){
				curr.setNode(word.charAt(i));
			}			
			//curr.updateFrequency(1);
			//System.out.println("updating si "+word.charAt(i));
			curr = curr.getNode(word.charAt(i));
			//curr.updateFrequency(1);
		}

		curr.updateFrequency(1);
	}
	
	public boolean search(String word){
		TrieNode curr = root;
		//System.out.println("Searching "+word);
		
		boolean isFound = true;
		int len = word.length();
		int i;
		for(i=0;i<len;i++){
			//System.out.println("search si "+word.charAt(i));
			if(curr.getNode(word.charAt(i)) == null){
				isFound = false;
				//System.out.println(word+" karakter "+word.charAt(i)+" "+i);
				//counter++;
				break;
			}
			
			curr = curr.getNode(word.charAt(i));
		}	
		
		if(isFound && curr.isExist()){
			//System.out.println(word+" ketemu");
			return true;
		}else{
			//System.out.println(word+" ga ketemu");
			counter++;
			return false;
		}		
	}
}

class TrieNode{
	private int frequency;
	private TrieNode[] node;
	
	public TrieNode(){
		node = new TrieNode[256];
		frequency = 0;
	}
	
	public void setNode(int idx){
		//char c = (char)idx;
		//System.out.println("setting si "+c);
		node[idx] = new TrieNode();
	}
	
	public TrieNode getNode(int idx){
		return node[idx];
	}
	
	public int getFrequency(){
		return frequency;
	}
	
	public void updateFrequency(int add){
		frequency+=add;
	}
	
	public boolean isExist(){
		if(frequency >= 1){
			return true;
		}
		return false;
	}
}

public class FixIt{
	public static void main(String[] args){
		Scanner sc = new Scanner(System.in);
		int T;
		int N;
		int M;
		Trie tr;
		
		T = sc.nextInt();
		for(int i=0;i<T;i++){
			tr = new Trie();
			N = sc.nextInt();
			M = sc.nextInt();
			
			for(int j=0;j<N;j++){
				/*String[] temp = sc.next().split("/");
				for(int k=0;k<temp.length;k++){
					System.out.println(temp[k]);
					tr.insert(temp[k]);				
				}*/
				String in2= sc.next();
				tr.insert(in2);
				//System.out.println("Inserting "+in2);
			}
			for(int j=0;j<M;j++){
			String tm="";
				boolean isInserted=true;
				String in = sc.next();
				String[] temp = in.split("/");
				for(int k=0;k<temp.length;k++){
					//System.out.println("hasil split "+temp[k]);
					if(!temp[k].equals(""))
						tm+="/"+temp[k];
					if(!temp[k].equals("") && !tr.search(tm)){
						//System.out.println("ga ketemu si "+tm);
						isInserted = false;
						//tr.counter++;
					}
					if(!isInserted){
						//System.out.println("insert si "+tm);
						tr.insert(tm);
					}					
				}						
				//System.out.println("yang tadi dicari "+tm);
			}
			System.out.println("Case #"+(i+1)+": "+tr.counter);
		}
	}
}