import java.util.Scanner;
import java.math.*;

class FairWarning{
	
	void quickSort(BigInteger arr[], int left, int right) {
		int index = partition(arr, left, right);
		if (left < index - 1){
			quickSort(arr, left, index - 1);
		}
		if (index < right){
			quickSort(arr, index, right);
		}
	}		
	
	int partition(BigInteger arr[], int left, int right)
	{
		int i = left, j = right;
		BigInteger tmp;
		BigInteger pivot = arr[(left + right) / 2];
		while (i <= j) {
			while (arr[i].compareTo(pivot) > 0){
				i++;
			}
			while (arr[j].compareTo(pivot) < 0){
				j--;
			}
			if (i <= j){
				  tmp = arr[i];
				  arr[i] = arr[j];
				  arr[j] = tmp;
				  i++;
				  j--;
			}
		}
		return i;
	}	
}

public class FairWarningTest{
	public static void main(String[] args){
		Scanner sc = new Scanner(System.in);
		
		FairWarning fw;
		int testCase;
		fw = new FairWarning();
		
		testCase = sc.nextInt();
		for(int i=0;i<testCase;i++){
			BigInteger maxY = null;
			BigInteger numbers[];
			boolean numbersExist[];
			int totalNum;
			
			totalNum = sc.nextInt();
			numbers = new BigInteger[totalNum];
			numbersExist = new boolean[totalNum];
			boolean isEven = true;
			for(int k=0;k<totalNum;k++){
				numbers[k] = new BigInteger(sc.next());
				if(isEven && numbers[k].mod(new BigInteger("2")).compareTo(new BigInteger("0")) == 0){
					isEven = false;
				}
			}
			fw.quickSort(numbers,0,totalNum-1);
			for(int z=0;z<totalNum-1;z++){
				if(numbers[z].compareTo(numbers[z+1]) == 0){
					numbersExist[z+1] = true;
				}
			}					
			
			/*maxY = numbers[totalNum-1];
			for(int k=totalNum-1;k>0;k--){
				if(!numbersExist[k-1]){
					maxY = maxY.mod(numbers[k-1]);
				}
			}*/
			maxY = numbers[0];
			for(int k=1;k<totalNum;k++){
				if(!numbersExist[k]){
					maxY = maxY.mod(numbers[k]);
				}
			}
			
			if(!isEven){
				System.out.println("Case #"+(i+1)+": "+maxY);			
			}else{
				if(maxY.compareTo(new BigInteger("0")) != 0){
					System.out.println("Case #"+(i+1)+": "+maxY.subtract(new BigInteger("1")));			
				}else{
					System.out.println("Case #"+(i+1)+": "+maxY);			
				}
			}
		}
	}
}