package com.danylevskyi.gcj2015;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Deque;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;
import java.util.Scanner;
import java.util.Stack;

public class Dijkstra {
	
	public static void main (String[] args) {
		
		File file = new File("C-small-attempt0.in");
		try {
			Scanner scan = new Scanner(file);
			FileWriter fWriter = new FileWriter(new File("C-small.out"));
			
			int numberOfTestCases = scan.nextInt();
			scan.nextLine();
			int L = 0, X = 0, x = 1;
			
			while (scan.hasNextLine() && x <= numberOfTestCases) {
				L = scan.nextInt();
				X = scan.nextInt();
				scan.nextLine();
				String s = scan.nextLine();
				Queue<Integer> str = new LinkedList<Integer>();
				for (int i = 0, j = 0; i < L*X; i++, j++) {
					if (i%L == 0 && i != 0) {
						j = 0;
					}
					if (s.charAt(j) == 'i') {
						str.add(2);
					} else if (s.charAt(j) == 'j') {
						str.add(3);
					} else {
						str.add(4);
					}
				}
				String y = Dijkstra.solve(str);
				fWriter.write("Case #"+x+": "+y+"\n"); 
			    fWriter.flush();
				x++;
			}
		    fWriter.close();
		    scan.close();
		} catch (FileNotFoundException eFile) {
			eFile.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public static String solve(Queue<Integer> str) {
		if (str.size() < 3) {
			return "NO";
		}

		final int[][] map = {
		  {1,  2,  3,  4},
		  {2, -1,  4, -3},
		  {3, -4, -1,  2},
		  {4,  3, -2, -1},
		};
		
		Stack<Integer> stack = new Stack<Integer>();
		stack.push(4);
		stack.push(3);
		stack.push(2);
		
		boolean i = false, j = false, k = false;
		
		while (!stack.isEmpty() && !str.isEmpty()) {
			int needle = stack.pop();
			int prev = str.remove();
			if (needle != prev) {
				int current = 0;
				int result = 0;
				int sign = 1;
				while (!str.isEmpty()) {
					current = str.remove();
					result = map[prev - 1][current - 1];
					if ((sign * result) != needle) {
						sign *= (int)Math.signum(result);
						prev = (int)Math.signum(result) * result;
					} else {
						if (needle == 2) {
							i = true;
						} else if (needle == 3) {
							j = true;
						} else if (needle == 4) {
							k = true;
						}
						break;
					}
				}
			} else {
				if (needle == 2) {
					i = true;
				} else if (needle == 3) {
					j = true;
				} else if (needle == 4) {
					k = true;
				}
			}
		}
		
		if (i && j && k && str.isEmpty()) {
			return "YES";
		} else {
			return "NO";
		}
	}
}
