import java.io.File;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.lang.System;
import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Random;
import java.util.Scanner;
import java.util.Set;

public class Jamcoins {
	public static void main(String args[]) {
		try {
		    File file = new File("C:\\Users\\oleksii\\workspace\\GCodeJam\\src\\C-small-attempt1.in");
		    File outFile = new File("C:\\Users\\oleksii\\workspace\\GCodeJam\\src\\C-small-attempt1.out");
		    BufferedWriter bw = new BufferedWriter(new FileWriter(outFile));
	    	Scanner scanner = new Scanner(file);
			String line = scanner.nextLine();
			int N = scanner.nextInt();
			int J = scanner.nextInt();
			char[] numArray = new char[N];
			numArray[0] = '1';
			numArray[N-1] = '1';
			for(int j = 1; j < N-1; j++) {
				numArray[j] = '0';
			}
			int i = 0, num = 0, rand = 0;
			boolean isJamCoin = true;
			int[] divisors;
			String jamcoin;
			Set<String> jamCoinsSet = new HashSet<String>(); 
    		bw.write("Case #1:\n");
			while (i < J) {
 				isJamCoin = true;
 				divisors = new int[9]; 
 				jamcoin = new String(numArray);
 				rand = Jamcoins.rand(1, N-2);
 				if (!jamCoinsSet.contains(jamcoin)) {
 					jamCoinsSet.add(jamcoin);
	 				for(int base = 2; base <= 10 && isJamCoin; base++) {
	 					num = Jamcoins.getNumberInBase(numArray, base);
	 					if (Jamcoins.isPrime(num)) {
	 						isJamCoin = false;
	 					} else {
	 						divisors[base-2] = Jamcoins.NonTrivialDivilorPolardAlgorithm(num);
	 					}
	 				}
	 				if(isJamCoin) {
	 	 				numArray[rand] = numArray[rand] == '1' ? '0' : '1';
	 	 	    		bw.write(jamcoin);
	 	 	    		for(int k: divisors) {
		 	 	    		bw.write(" "+k);
	 	 	    		}
	 	 	    		bw.write("\n");
	 					i++;
	 				}
 				} else {
 	 				numArray[rand] = numArray[rand] == '1' ? '0' : '1';
 				}
			}
			scanner.close();
		    bw.close();
		} catch(Exception e) {
			System.out.println(e.getMessage());
		}
	}
	public static int rand(int min, int max) {
	    Random rand = new Random();
	    int randomNum = rand.nextInt((max - min) + 1) + min;
	    return randomNum;
	}
	
	public static int NonTrivialDivilorPolardAlgorithm(int num) { 
	   int x = 2, y = 1, i = 0, stage = 2;
	   while (Jamcoins.gcd(num, Math.abs(x - y)) == 1) {
	     if (i == stage){
	       y = x;
	       stage = stage*2; 
	     }
	     x = (x*x + 1)*num;
	     i = i + 1;
	   }
	   return Jamcoins.gcd(num, Math.abs(x-y));
	 }
	
	public static int gcd(int a, int b) {
		int r = 0;
	    while (b != 0) {
	        r = a % b;
	        a = b;
	        b = r;
	    }
	    return a;
	}
	
	public static boolean isPrime(int num) {
	    if (num%2 == 0) {
	    	return false;
	    }
	    for(int i = 3; i*i <= num; i += 2) {
	        if(num%i == 0) {
	            return false;
	        }
	    }
	    return true;
	}
	
	
	public static int getNumberInBase(char[] jamcoin, int base) {
		int number = 1;
		for(int i = jamcoin.length - 2; i >= 0; i--) {
			number += (int)(jamcoin[i]-'0') * (int)Math.pow((double)base, (double)jamcoin.length - i - 1);
		}
		return number;
	}
}
