/**
 * 
 */
package snapperchain;

/**
 * @author danysk
 *
 */
public class Snapper implements PowerSource {
	
	private final PowerSource previous;
	private boolean isOn = false;
	
	public Snapper(PowerSource input){
		this.previous = input;
	}
	
	public void snap(){
		if(previous.givesPower()){
			isOn = !isOn;
		}
	}

	@Override
	public boolean givesPower() {
		return isOn && previous.givesPower();
	}
	
	public boolean isOn(){
		return isOn;
	}

	@Override
	public boolean getStatus() {
		return givesPower();
	}

	@Override
	public void switchStatus() {
		snap();
	}
	
	@Override
	public String toString(){
		return "*"+
			(isOn? "ON": "OFF")+
			"* "+
			(givesPower()? "OK": "DOWN");
	}
	

}
