/**
 * 
 */
package snapperchain;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

/**
 * @author danysk
 *
 */
public class SnapperChain {
	
	public static void main(String[] args){
		try {
			BufferedReader br = new BufferedReader(new FileReader("A-small-attempt0.in"));
			int linenum = Integer.parseInt(br.readLine());
			ExecutorService ex = Executors.newFixedThreadPool(Runtime.getRuntime().availableProcessors()*2/3);
			ArrayList<Future<Boolean>> results = new ArrayList<Future<Boolean>>(linenum);
			for(int i=0; i<linenum; i++){
				StringTokenizer tk = new StringTokenizer(br.readLine()," ");
				int n = Integer.parseInt(tk.nextToken());
				int k = Integer.parseInt(tk.nextToken());
				results.add(ex.submit(new Agent(n,k)));
			}
			br.close();
			ex.shutdown();
			BufferedWriter bw = new BufferedWriter(new FileWriter("output.txt"));
			for(int i=0; i<results.size(); i++){
				String res = results.get(i).get()? "ON": "OFF";
				bw.write("Case #"+(i+1)+": "+res+"\n");
			}
			bw.flush();
			bw.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (InterruptedException e) {
			e.printStackTrace();
		} catch (ExecutionException e) {
			e.printStackTrace();
		}
		
	}
}
