/**
 * 
 */
package snapperchain;

import java.util.ArrayList;

/**
 * @author danysk
 *
 */
public class Chain {
	
	private final ArrayList<PowerSource> chain;
	
	public Chain(int length){
		chain = new ArrayList<PowerSource>(length+1);
		if(length>0){
			chain.add(new PowerSource(){
				@Override
				public boolean givesPower() {
					return true;
				}

				@Override
				public boolean getStatus() {
					return true;
				}

				@Override
				public void switchStatus() {
				}});
		}
		for(int i=1; i<length+1;i++){
			chain.add(new Snapper(chain.get(i-1)));
		}
	}
	
	public void snap(){
		for(int i=chain.size()-1; i>0; i--){
			chain.get(i).switchStatus();
		}
	}
	
	public boolean getStatus(){
		return chain.get(chain.size()-1).getStatus();
	}
	
	@Override
	public String toString(){
		return chain.toString();
	}

}
