import java.util.Arrays;
import java.util.Map;
import java.util.HashMap;
import java.io.*;

/**
 * Create on 17/07/2008.
 */
public class SavingTheUniverse
{
    // flag: did I see S[i] in the current search
    static boolean[] found;
    // returns the index where the non full series end (exculding the next se)
    // or Q.length if it never ends
    static int maxNonFullSeries (int Q[], int start)
    {
        Arrays.fill(found, false);
        // total S found in the current search
        int totalFound = 0;

        for (int i = start; i < Q.length; i++)
        {
            if (!found[Q[i]])
            {
                found[Q[i]] = true;
                totalFound++;

                if (totalFound == found.length)
                    return i;
            }
        }
        return Q.length;
    }


    static int solveCase(int[] Q, int Sn, boolean trace)
    {
        found = new boolean[Sn];

        int currentIndex = 0;
        int transitions = 0;

        // look for the furtherest search
        while (true)
        {
            currentIndex = maxNonFullSeries(Q, currentIndex);

            if (currentIndex == Q.length) break;

            if (trace) System.out.println("Transition before " + currentIndex);

            transitions++;
         }

        return transitions;
    }

    public static void main(String[] args) throws IOException
    {
        // open the input file
        BufferedReader reader = new BufferedReader(new FileReader(args[0]));

        boolean trace = args.length >= 2 && Boolean.parseBoolean(args[1]);

        int nCases = Integer.parseInt(reader.readLine());

        BufferedWriter writer = new BufferedWriter(new FileWriter("out.txt"));

        for (int i = 0 ; i < nCases; i++)
        {
            int Sn = Integer.parseInt(reader.readLine());
            Map<String, Integer> searchEngineNames = new HashMap<String, Integer>(Sn * 2);
            for (int j = 0; j < Sn; j++)
                searchEngineNames.put(reader.readLine(), j);

            int Qn = Integer.parseInt(reader.readLine());
            int[] Q = new int[Qn];
            for (int j = 0; j < Qn; j++)
            {
                Q[j] = searchEngineNames.get(reader.readLine());
                if (trace) System.out.print(Q[j] + " ");
            }
            if (trace) System.out.println();

            int res = solveCase(Q, Sn, trace);

            System.out.println("Case #" +  (i+1) + ": " + res);

            writer.write("Case #" +  (i+1) + ": " + res + "\n");
        }
        writer.close();
    }


}

