package com.codejam.problem;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

public class ShipProblem {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
        new ShipProblem().solveProblem();
	}
	
	public void solveProblem() {
		BufferedReader bufferedReader = null;
		BufferedWriter bufferedWriter = null;
		try {
			bufferedReader = new BufferedReader(new FileReader(
					new File("D:/workspace/GoogleChallenge/A-large.in")));
			bufferedWriter =new BufferedWriter(new FileWriter(new File("D:/workspace/GoogleChallenge/output.txt")));
			String num = bufferedReader.readLine();
			int numberOfInput = 0;
			if (num != null) {
				numberOfInput = Integer.valueOf(num.trim());
				if (numberOfInput > 0) {
					while (numberOfInput > 0) {
						String input = bufferedReader.readLine();
						if (input != null) {
                            String output = processInput(input.trim());
                            if(output.equals("0")) {
                            	output = "INSOMNIA";
                            }
                            writeOutput(Integer.valueOf(num.trim()) - numberOfInput +1,output,bufferedWriter);
                            bufferedWriter.newLine();
						} else {
							System.out.println("Input is null");
						}
						numberOfInput --;
					}
				} else {
					System.out.println("Number of Input is not greater than 0");
				}
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		finally{
			
				try {
					if(bufferedReader != null){
					bufferedReader.close();
					}
					if(bufferedWriter != null){
						bufferedWriter.close();
						}
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		}
	}

	 private void writeOutput(int count, String output, BufferedWriter bufferedWriter) {
		// TODO Auto-generated method stub
		String outputString = "Case #"+count+": "+output;
		try {
			bufferedWriter.write(outputString);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	String processInput(String input) {
		String prvMul = "";
		 String currentMul = "";
		int num = 1;
		Set<String> conditionSet = new HashSet<String>();
		while(true){
			currentMul = multiply(num , input);
			markPresentDigits(currentMul, conditionSet);
			if(conditionSet.size() == 10 || prvMul.equals(currentMul)) {
				break;
			}
			prvMul = currentMul;
			num ++;
		}	
		return currentMul;
	}

	
	String multiply(int num, String input) {
		// TODO Auto-generated method stub
		int carry = 0;
		String output = "";
		for (int i = input.length() - 1; i >= 0; i--) {
			int indexValue = Integer.valueOf(input.charAt(i)+"");
			int result = indexValue * num + carry;
			if (i > 0) {
				carry = result / 10;
				output = (result % 10) +output; 
			} else {
				output = result + output;
			}
		}
		return output;
	}

	private void markPresentDigits(String input, Set<String> conditionSet) {
		// TODO Auto-generated method stub
		for(int i=0; i<input.length();i++){
			conditionSet.add(input.charAt(i)+"");
		}
	}
}
