import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;


public class Watersheds {
	
	public static void main(String[] args) throws FileNotFoundException {
		String fileName = "B-small-attempt0";
		Scanner scan = new Scanner(new File(fileName + ".in"));
		PrintWriter out = new PrintWriter(new File(fileName + ".out"));
		int C = scan.nextInt();
		int MAX = 110;
		int H, W;
		int[] qx = new int[MAX*MAX];
		int[] qy = new int[MAX*MAX];
		int[][] map = new int[MAX][MAX];
		int[][] labels = new int[MAX][MAX];
		int[] DX = {0, -1, 1, 0};
		int[] DY = {-1, 0, 0, 1};
		int labelCount, qs, qe, a, b, lowest, xx, yy, ind, currLabel;
		for (int c = 0; c < C; c++) {
			H = scan.nextInt();
			W = scan.nextInt();
			for (int i = 0; i < H; i++) {
				for (int j = 0; j < W; j++)
					map[i][j] = scan.nextInt();
				Arrays.fill(labels[i], 0, W, -1);
			}
			labelCount = 0;
			for (int i = 0; i < H; i++)
				for (int j = 0; j < W; j++)
					if (labels[i][j] == -1) {
						qs = qe = 0;
						qx[qe] = a = j;
						qy[qe++] = b = i;
						while (labels[b][a] == -1) {
							ind = -1; 
							lowest = Integer.MAX_VALUE;
							for (int k = 0; k < DX.length; k++) {
								xx = a + DX[k];
								yy = b + DY[k];
								if (xx >= 0 && xx < W && yy >= 0 && yy < H) {
									if (map[b][a] > map[yy][xx] && map[yy][xx] < lowest) {
										lowest = map[yy][xx];
										ind = k;
									}
								}
							}
							if (lowest != Integer.MAX_VALUE) {
								qx[qe] = a = a + DX[ind];
								qy[qe++] = b = b + DY[ind];
							} else break;
						}
						if (labels[b][a] != -1)
							currLabel = labels[b][a];
						else
							currLabel = labelCount++;
						while (qs < qe) {
							xx = qx[qs];
							yy = qy[qs++];
							labels[yy][xx] = currLabel;
						}
					}
			out.println("Case #" + (c+1) + ":");
			for (int i = 0; i < H; i++) {
				for (int j = 0; j < W; j++)
					if (j != W - 1)
						out.print((char)(labels[i][j] + 'a') + " ");
					else
						out.print((char)(labels[i][j] + 'a'));
				out.println();
			}
		}
		out.close();
	}
	
}
