import java.util.*;

public class WarGame {
	private int N;
	private ArrayList<Double> bn;
	private ArrayList<Double> bk;

	public WarGame(int N, ArrayList<Double> bn, ArrayList<Double> bk) {
		this.N = N;
		this.bn = bn;
		this.bk = bk;
		Collections.sort(this.bn);
		Collections.sort(this.bk);
	}
	
	int optWar(){
		int i = 0;
		int j = 0;
		int p = N;
		while (i < N && j < N) {
			if (bk.get(j++) > bn.get(i)) {
				p--;
				i++;
			}
		}
		return p;
	}
	
	int optDWar() {
		int i = 0;
		int j = 0;
		int p = 0;
		while (i < N && j < N) {
			if (bk.get(j) < bn.get(i++)) {
				p++;
				j++;
			}
		}
		return p;
	}

	public static void main(String[] args) {
		Scanner in = new Scanner (System.in);
		int T = in.nextInt();
		
		for (int i = 1; i <= T; i++) {
			int N = in.nextInt();
			ArrayList<Double> bn = new ArrayList<Double>();
			for (int j = 0; j < N; j++) {
				bn.add(in.nextDouble());
			}
			ArrayList<Double> bk = new ArrayList<Double>();
			for (int j = 0; j < N; j++) {
				bk.add(in.nextDouble());
			}
			WarGame wg = new WarGame(N, bn, bk);
			System.out.println("Case #" + i + ": " + wg.optDWar() + " " + wg.optWar());
		}
	}

}