package qualification;

import java.io.*;

public class Ovation {
	
	public int getMissingFriends(int maxShy, String audience) {
		if (audience.length() < 2) return 0;
		int add = 0;
		int sum = parseChar(audience, 0);
		for (int i = 1; i <= maxShy; i++) {
			if (sum >= maxShy) return add;
			// if sum is less than current index, add a difference
			if (sum < i) {
				add += i - sum;
				sum += i - sum;
			}
			// increase sum
			sum += parseChar(audience, i);
		}
		return add;
	}
	
	private int parseChar(String s, int i) {
		return Character.getNumericValue(s.charAt(i));
	}
	
	public void printCaseResult(int caseNum, int val) {
		System.out.println("Case #" + caseNum + ": " + val);
	}
	
	public static void main(String[] args) {
		BufferedReader br = null;
		Ovation o = new Ovation();
		try {
			br = new BufferedReader(new FileReader(args[0]));
			String s = br.readLine();			
			int T = 1;

			// Read input data
			while ((s = br.readLine()) != null) {
				String[] s2 = s.split(" ");
				int maxShy = Integer.parseInt(s2[0]);
				String audience = s2[1];
				int res = o.getMissingFriends(maxShy, audience);
				o.printCaseResult(T++, res);
			}
			
		} catch(FileNotFoundException e) {
			System.out.println("Could not read file. Usage: \"java Ovation fileName.txt\"");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br == null) return;
			try {
				br.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
