package qualification;

import java.io.*;
import java.util.*;

public class Pancakes {
	
	public int getMinTime(int[] input) {
		Comparator<Integer> c = new pancakeComparator<Integer>();
		PriorityQueue<Integer> diners = new PriorityQueue<Integer>(1000, c);
		ArrayList<Integer> times = new ArrayList<Integer>();
		
		// put integers from the input into the maxheap
		for (int i : input) {
			diners.add(i);
		}
		int n = 0;
		int t = diners.peek();
		times.add(t);
		while (diners.peek() > 3) {
			// remove max, split into halves, add them to heap
			int max = diners.poll();
			int half1 = max/2;
			int half2 = max - half1;
			diners.add(half1);
			diners.add(half2);
			n++;
			t = diners.peek() + n;
			times.add(t);
		}
		// return the min time from the list
		return Collections.min(times);
	}
	
	private class pancakeComparator<E> implements Comparator<E> {

		@Override
		public int compare(E i1, E i2) {
			return (Integer)i2 - (Integer)i1;
		}
		
	}
	
	public void printCaseResult(int caseNum, int val) {
		System.out.println("Case #" + caseNum + ": " + val);
	}
	
	public static void main(String[] args) {
		BufferedReader br = null;
		Pancakes p = new Pancakes();
		try {
			br = new BufferedReader(new FileReader(args[0]));
			String s = br.readLine();			
			int T = 1;

			// Read input data
			while ((s = br.readLine()) != null) {
				int n = Integer.parseInt(s);
				String s2 = br.readLine();
				String[] s3 = s2.split(" ");
				int[] data = new int[n];
				for (int i = 0; i < n; i++) {
					data[i] = Integer.parseInt(s3[i]);
				}
				p.printCaseResult(T++, p.getMinTime(data));
			}
			
		} catch(FileNotFoundException e) {
			System.out.println("Could not read file. Usage: \"java Pancakes fileName.txt\"");
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br == null) return;
			try {
				br.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
