import java.util.*;
import java.io.*;

public class Main {

	BufferedReader in;
	StringTokenizer str = null;
	PrintWriter out;
	
	private String next() throws Exception{
		while (str == null || !str.hasMoreElements())
			str = new StringTokenizer(in.readLine());
		return str.nextToken();
	}
	
	private int nextInt() throws Exception{
		return Integer.parseInt(next());
	}
	
	private long nextLong() throws Exception{
		return Long.parseLong(next());
	}
	
	private double nextDouble() throws Exception{
		return Double.parseDouble(next());
	}
	
	int []dp, from;
	public void run() throws Exception{
		in =  new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);

		init();

		int test = nextInt();
		for(int i = 0; i < test; ++i) {
			solve(i + 1);
		}
		out.close();
	}

	private void init(){
		int n = 1001;
		from = new int[n];
		dp = new int[n];
		for(int i = 1; i < n; ++i) dp[i] = i;
		for(int i = 2; i < n; ++i) {
			for(int j = 1; j < i; ++j) {
				if (dp[i] > Math.max(dp[j], dp[i-j]) + 1) {
					dp[i] = Math.max(dp[j], dp[i-j]) + 1;
					from[i] = j;
				}
			}
		}
	}

	TreeSet<Integer> heap;
	Map<Integer, Integer> map;

	final int oo = Integer.MAX_VALUE / 2;

	private void solve(int testCase) throws Exception{
		int n = nextInt(), ret = -oo;
		heap = new TreeSet<Integer>();
		map = new HashMap<Integer, Integer>();

		for(int i = 0; i < n; ++i) {
			int cake = nextInt();
			if (!map.containsKey(cake)) {
				map.put(cake, 0);
			}
			map.put(cake, map.get(cake) + 1);
			heap.add(cake);

			ret = Math.max(ret, cake);
		}

		int time = 0;
		while(heap.size() > 0) {
			int top = heap.pollLast();
			int beforeTop = 0;
			if (heap.size() > 0) beforeTop = heap.last();
			int count = map.get(top);

			int piece1 = from[top], piece2 = top - from[top];
			
			ret = Math.min(ret, Math.min(top, count + max(piece1, piece2, beforeTop)) + time);

			if (top > count + max(piece1, piece2, beforeTop)) {
				time += count;
				
				map.remove(top);
				if (!map.containsKey(piece1)) {
					map.put(piece1, 0);
				}
				map.put(piece1, map.get(piece1) + count);
				if (!map.containsKey(piece2)) {
					map.put(piece2, 0);
				}
				map.put(piece2, map.get(piece2) + count);
				heap.add(piece1);
				heap.add(piece2);
			}else break;
		}

		out.println("Case #" + testCase + ": " + ret);
	}

	private int max(int ...a) {
		int max = a[0];
		for(int i = 1; i < a.length; ++i) max = Math.max(max, a[i]);
		return max;
	}
		
	public static void main(String[] args) throws Exception{
		new Main().run();
	}
}
