import java.util.*;
import java.io.*;
import java.math.*;

public class Main {

	BufferedReader in;
	StringTokenizer str = null;

	private String next() throws Exception{
		if (str == null || !str.hasMoreElements())
			str = new StringTokenizer(in.readLine());
		return str.nextToken();
	}


	public void run() throws Exception{
		in = new BufferedReader(new FileReader("small.in"));
		PrintWriter out = new PrintWriter(new File("output.txt"));
		int c = Integer.parseInt(next());

		for(int step=0;step<c;step++){

			int n = Integer.parseInt(next());
			BigInteger a[] = new BigInteger[n];
			for(int i=0;i<n;i++) a[i] = new BigInteger(next());

			HashSet<BigInteger> hs = new HashSet<BigInteger>();
			for(int i=0;i<n;i++)
				for(int j=i+1;j<n;j++)	hs.add((a[i].subtract(a[j])).abs());

			BigInteger nod = new BigInteger("0");
			int cnt = 0;
			for(BigInteger num : hs){
				if (cnt == 0){
					nod = num;
					cnt++;
				}else nod = nod(nod, num);
			}
			if (nod.equals(BigInteger.ONE)){
				out.println("Case #"+(step+1)+": "+0);
			}else{
			        cnt = 0;
			        for(int i=0;i<n;i++)
			          if (a[i].mod(nod).equals(BigInteger.ZERO)) cnt++;
			        if (cnt == n){
			          out.println("Case #"+(step+1)+": "+0);
			        }else{

                			BigInteger d = a[0];
                			for(int i=1;i<n;i++)
                			  d = d.min(a[i]);
                			BigInteger k = d.divide(nod);
                			BigInteger b = (k.add(BigInteger.ONE)).multiply(nod);
                			BigInteger ret = b.subtract(d);
                			out.println("Case #"+(step+1)+": "+ret);
				}
			}
		}
		out.close();
	}

	private BigInteger nod(BigInteger a, BigInteger b){
		return (b.equals(BigInteger.ZERO))?a:nod(b,a.mod(b));
	}

	public static void main(String[] args) throws Exception{
		new Main().run();
	}
}

