import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class A {
	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int numCases = Integer.parseInt(br.readLine());
		for (int caseNumber = 1; numCases > 0; numCases--, caseNumber++) {
			String testCase = br.readLine();
			System.out.println("Case #" + caseNumber + ": " + solveCase(testCase));
		}
	}

	private static int solveCase(String testCase) {
		String[] actions = testCase.split(" ");
		String action = null;

		List<Integer> blueActions = new ArrayList<Integer>();
		List<Integer> orangeActions = new ArrayList<Integer>();

		for (int counter = 1; counter < actions.length; counter = counter + 2) {
			action = actions[counter];
			if (action != null && action.equalsIgnoreCase("O")) {
				orangeActions.add(Integer.parseInt(actions[counter + 1]));
			} else {
				blueActions.add(Integer.parseInt(actions[counter + 1]));
			}
		}

		if (blueActions.size() == 0) {
			blueActions.add(0);
		}
		if (orangeActions.size() == 0) {
			orangeActions.add(0);
		}

		Robot blueRobot = new Robot(blueActions);
		Robot orangeRobot = new Robot(orangeActions);
		return playPortal(actions, blueRobot, orangeRobot);
	}

	private static int playPortal(String[] actions, Robot blueRobot, Robot orangeRobot) {
		int steps = 0;
		for (int counter = 1; counter < actions.length; counter = counter + 2) {
			// at every step you have to make a decision for both robots
			boolean buttonpress = false;
			if (actions[counter].equalsIgnoreCase("O")) {
				while (!buttonpress) {
					buttonpress = orangeRobot.pressButtonOrMove();
					blueRobot.moveTo(blueRobot.pos, blueRobot.target);
					steps++;
				}
			} else {
				while (!buttonpress) {
					buttonpress = blueRobot.pressButtonOrMove();
					orangeRobot.moveTo(orangeRobot.pos, orangeRobot.target);
					steps++;
				}
			}
		}
		return steps;
	}
}

class Robot {
	int pos;
	int target;
	List<Integer> actions;

	public Robot(List<Integer> actions) {
		pos = 1;
		this.actions = actions;
		target = actions.get(0);
	}

	protected boolean pressButtonOrMove() {
		// are you at the right position?
		if (pos != target) {
			moveTo(this.pos, this.target);
			return false;
		}
		updateTarget();
		return true;
	}

	private void updateTarget() {
		this.actions.remove(0);
		if (actions.size() > 0)
			this.target = this.actions.get(0);
	}

	protected boolean moveTo(int pos, int target) {
		if (pos > target) {
			this.pos--;
			return true;
		}
		if (pos < target) {
			this.pos++;
			return true;
		}
		return false;
	}
}
