import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Magicka {
	static boolean combined = false;

	public static void main(String[] args) throws IOException, NumberFormatException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int numCases = Integer.parseInt(br.readLine());
		for (int caseNumber = 1; numCases > 0; numCases--, caseNumber++) {
			String testCase = br.readLine();
			System.out.println("Case #" + caseNumber + ": " + solveCase(testCase));
		}
	}

	private static List<String> solveCase(String testCase) {
		String[] strings = testCase.split(" ");
		int numCombiners = Integer.parseInt(strings[0]);
		int numDecombiners = Integer.parseInt(strings[1 + numCombiners]);
		int spellLength = Integer.parseInt(strings[2 + numCombiners + numDecombiners]);

		String spellString = strings[strings.length - 1];
		Map<String, String> combinersMap = getCombiners(numCombiners, strings);
		List<String> decombinersList = getDecombiners(numCombiners, numDecombiners, strings);

		return playMagicka(combinersMap, decombinersList, spellLength, spellString);

	}

	private static Map<String, String> getCombiners(int numCombiners, String[] strings) {
		Map<String, String> combinersMap = new HashMap<String, String>();
		for (int counter = 1; numCombiners > 0; numCombiners--, counter++) {
			combinersMap.put(strings[counter].substring(0, 2), strings[counter].substring(2));
			combinersMap.put(new StringBuffer(strings[counter].substring(0, 2)).reverse().toString(), strings[counter].substring(2));
		}
		return combinersMap;
	}

	private static List<String> getDecombiners(int numCombiners, int numDecombiners, String[] strings) {
		List<String> decombinersList = new ArrayList<String>();
		for (int counter = numCombiners + 2; numDecombiners > 0; numDecombiners--, counter++) {
			decombinersList.add(strings[counter].substring(0, 1) + strings[counter].substring(1));
			decombinersList.add(strings[counter].substring(1) + strings[counter].substring(0, 1));
		}
		return decombinersList;
	}

	private static List<String> playMagicka(Map<String, String> combinersMap, List<String> decombinersList, int spellLength, String spellString) {
		// put checks if spellLength = 0
		List<String> finalSpell = new ArrayList<String>();
		String[] spellArr = new String[spellLength];

		for (int counter = 0; counter < spellLength; counter++) {
			spellArr[counter] = spellString.substring(counter, counter + 1);
		}
		finalSpell.add(spellArr[0]);

		for (int counter = 1; counter < spellLength; counter++) {
			finalSpell = tryCombine(finalSpell, spellArr[counter], combinersMap);
			if (combined) {
				continue;
			}

			finalSpell = tryDecombine(finalSpell, spellArr[counter], decombinersList);
		}
		return finalSpell;
	}

	private static List<String> tryCombine(List<String> finalSpell, String newSpell, Map<String, String> combinersMap) {
		if (finalSpell.size() > 0) {
			String combinedElement = combinersMap.get(finalSpell.get(finalSpell.size() - 1) + newSpell);
			if (combinedElement != null) {
				finalSpell.set(finalSpell.size() - 1, combinedElement);
				combined = true;
			} else {
				combined = false;
			}
		} else {
			finalSpell.add(newSpell);
			combined = true;
		}
		return finalSpell;

	}

	private static List<String> tryDecombine(List<String> finalSpell, String newSpell, List<String> decombinersList) {
		int finalSpellSize = finalSpell.size();
		for (int counter = 0; counter < finalSpellSize; counter++) {
			if (decombinersList.contains(finalSpell.get(counter) + newSpell)) {
				return new ArrayList<String>();
			}
		}
		finalSpell.add(newSpell);
		return finalSpell;
	}
}
