import java.util.ArrayList;



public class SmartInstance 
{
	long nbSpeedBooster;
	long nbStartBooster;
	long hoursWork;
	long  nbStars;
	int nbDistances;
	long[] distances;
	double totalTime = 0;
	long[] usedBooster;
	
	int lowestBoostIndex = -1;
	boolean shouldCheckForMinBooster = false;
	
	int specialCaseIndex = -1;
	double specialCaseTotalTime = -1;
	
	public void init(String[] param)
	{
		nbSpeedBooster = Long.valueOf(param[0]);
		hoursWork = Long.valueOf(param[1]);
		nbStars = Long.valueOf(param[2]);
		nbDistances = Integer.valueOf(param[3]);
		
		distances = new long[nbDistances];
		usedBooster = new long[nbDistances];
		
		for (int i = 0; i < nbDistances; i++)
		{
			distances[i] = Long.valueOf(param[4 + i]);
			usedBooster[i] = 0;
		}
	}

	public void solve()
	{
		totalTime = 0;
		int index = 0;
		nbStartBooster = nbSpeedBooster;
		//boolean hasUsedBooster = false;
		long lowestBoostUsed = -1;

		for (int i = 0; i < nbStars; i++)
		{
			if (totalTime < hoursWork)
			{
				specialCaseIndex = index;
				specialCaseTotalTime = totalTime;
				//System.out.println("adding  " + distances[index] * 2);
				totalTime += (distances[index] * 2);
				index = (index + 1) % nbDistances;
				
			}
			else
			{
				if (hoursWork == totalTime)
				{
					specialCaseIndex = -1;
					specialCaseTotalTime = -1;
				}
				
				if (nbSpeedBooster == 0)
				{
					if (nbStartBooster > 0)
					{
						if (shouldCheckForMinBooster == true)
						{
							lowestBoostUsed = getLowestBoost();
							shouldCheckForMinBooster = false;
						}
						if (distances[index] > distances[lowestBoostIndex])
						{
							usedBooster[index]++;
							usedBooster[lowestBoostIndex]--;
							if (usedBooster[lowestBoostIndex] == 0)
								shouldCheckForMinBooster = true;
						}
					}
				//	System.out.println("adding  " + distances[index] * 2);
					totalTime += (distances[index] * 2);
					index = (index + 1) % nbDistances;
				}
				else
				{
					shouldCheckForMinBooster = true;
			//		System.out.println("adding  " + distances[index] * 2);
					totalTime += (distances[index] * 2);
					usedBooster[index]++;
					nbSpeedBooster--;
					index = (index + 1) % nbDistances;
				}
			}
			
		}
		
		for (int i = 0; i < usedBooster.length; i++)
		{
			totalTime -= distances[i] * usedBooster[i];
		}
		
		checkForSpecialCase();
	}

	private void checkForSpecialCase() 
	{
		
		if (nbStartBooster == 0)
			return;
		
		if (specialCaseIndex == -1)
			return;
		
		long min =  getLowestBoost();
		
		if (min == -1)
			return;
		
		double travelDist = distances[specialCaseIndex];
		
		//System.out.println("travelDist:" + travelDist);
		
		double hoursWorkLefet = hoursWork - specialCaseTotalTime;
		
		double DistanceAlreadyDone = hoursWorkLefet / 2;
		double DistLeft = travelDist - DistanceAlreadyDone;
		
		//System.out.println("DistLeft: " + DistLeft);
		//System.out.println("min : " + min);
		if (DistLeft > min)
		{
			double check = DistLeft - min;
			//System.out.println("DistLeft - min : " + check);
			totalTime -= DistLeft - min;
		}
	}

	private long getLowestBoost() 
	{
		long min = -1;
		
		for (int i = 0; i < usedBooster.length; i++)
		{
			if ((distances[i] < min) || (min == -1))
			{
				if (usedBooster[i] > 0)
				{
					min = distances[i]; 
					lowestBoostIndex = i;
				}
			}
		}
		
		return min;
	}

	/*private double removeSpeedBooster(int i) 
	{
		double removed = 0;
		long Xbig = 0;
		
		while (nbSpeedBooster > 0)
		{
			int value = calculateXbiggest(i);
		}
		return i;	
	}*/
}