import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;


public class mainParser {

	/**
	 * @param args
	 * @throws IOException 
	 */
	
	static String fileSource = "A-small-attempt0.in";
	
	static int nbCase = -1;
	static String folder = "C:\\code_Jam\\Round_1\\robot\\";
	static ArrayList<String> Instances = new ArrayList<String>();
	static ArrayList<String> Solutions = new ArrayList<String>();
	
	public static void main(final String[] args) throws IOException
	{
		// TODO Auto-generated method stub
		openFile();
		solve();
		outputFile();
	}

	private static void solve() 
	{
		// TODO Auto-generated method stub
		
		for (String inst : Instances)
		{
			String[] param = inst.split(" ");
			
			solveInstance(param);
		}
		
	}

	private static void solveInstance(String[] param) 
	{
		int nbButton = Integer.parseInt(param[0]);
		
		int bluePos = 1;
		int orPos = 1;
		int blueNext = -1;
		int orNext = -1;
		
		int buttonDone = 0;
		boolean blueToAct = true;
		
		blueToAct = isBlueTurnToAct(param, buttonDone);
		
		blueNext = getNextButton(buttonDone, param, true);
		orNext = getNextButton(buttonDone, param, false);
		
		boolean finished = false;
		int time = 0;
		
		while (finished != true)
		{
			time++;
			System.out.println();
			System.out.println("Tour " + time);
			System.out.println();
			
			boolean pushedThisTurn = false;
			
			if (bluePos == blueNext)
			{
				System.out.println("Blue push");
				if (blueToAct == true)
				{
					pushedThisTurn = true;
					buttonDone++;
					blueNext = getNextButton(buttonDone, param, true);
					blueToAct = isBlueTurnToAct(param, buttonDone);
				}
			}
			else
				if (bluePos < blueNext)
				{			
					bluePos++;
					System.out.println("Blue + 1 => " + bluePos);
				}
				else
				{
					bluePos--;
					System.out.println("Blue - 1");
				}
			
			if (orPos == orNext)
			{
				if (pushedThisTurn == false)
				{
					System.out.println("or push");
					if (blueToAct == false)
					{
						pushedThisTurn = true;
						buttonDone++;
						orNext = getNextButton(buttonDone, param, false);
						blueToAct = isBlueTurnToAct(param, buttonDone);
					}
				}
			}
			else
				if (orPos < orNext)
				{
					System.out.println("or + 1");
					orPos++;
				}
				else
				{
					System.out.println("or - 1");
					orPos--;
				}
			if (buttonDone == nbButton)
			{
				Solutions.add("" + time);
				System.out.println("Added solution : " + time);
				return;
			}
		}
	}

	

	private static boolean isBlueTurnToAct(String[] param, int buttonDone) 
	{	
		// TODO Auto-generated method stub
		if (param.length <= ((buttonDone*2) + 1))
			return false;
		if ("B".equals(param[(buttonDone*2) + 1]))
			return true;
		else
			return false;
	}

	private static int getNextButton(int buttonDone, String[] param, boolean isBlue) 
	{
		boolean found = false;
		
		int testColor = (buttonDone*2) + 1;
		int testButton = (buttonDone*2) + 2;
			
		while (found != true)
		{
			if (param.length <= testColor)
				return -1;
			if ("B".equals(param[testColor]))
			{
				if (isBlue == true)
				{
					return Integer.parseInt(param[testButton]);
				}
				else
				{
					testColor += 2;
					testButton += 2;
				}
			}
			else
				if ("O".equals(param[testColor]))
				{
					if (isBlue == false)
					{
						return Integer.parseInt(param[testButton]);
					}
					else
					{
						testColor += 2;
						testButton += 2;
					}
				}	
		}
		return -1;
	}

	private static ArrayList<String> openFile()
	{
		// TODO Auto-generated method stub
		FileReader fr = null;
		BufferedReader br = null;
		
		try {
			fr = new FileReader(folder + fileSource);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		br = new BufferedReader(fr);
			
		
		String line = null;
		try {
			
			line = br.readLine();
			nbCase = Integer.parseInt(line);
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		ArrayList<String> lines = new ArrayList<String>();
		
		for (int i = 0; i < 5000; i++)
		{
			try {
				
				line = br.readLine();
				if (line == null)
					return (lines);
				
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			lines.add(line);
			Instances.add(line);
		}
		return lines;
	}
	
	private static void outputFile() throws IOException 
	{
		 // Create file 
	    FileWriter fstreamDebug = new FileWriter(folder + "debug.txt");
	    BufferedWriter outDebug = new BufferedWriter(fstreamDebug);
	    outDebug.write("nbCase = " + nbCase);
	    System.out.println("nbCase = " + nbCase);
	    
	    //
	    
	    // Create file solutions
	    FileWriter fstreamOut = new FileWriter(folder + "output.txt");
	    BufferedWriter out = new BufferedWriter(fstreamOut);
 
	    int i = 0;
	    for (String s : Solutions)
	    {
	    	i++;
	    	out.write("Case #" + i + ": " + s);
	    	out.newLine();
	    }
	    
	    //Close the output stream
	    outDebug.close();
	    out.close();
	}
	
	
}
