import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

public class C {

	public static void main(String[] args) throws FileNotFoundException {
		Scanner s = new Scanner(new File("C.in"));
		PrintStream o = new PrintStream(new File("C.out"));		
		int x = s.nextInt();
		
		for (int i = 0;i < x; i++) {
			o.println("Case #" + (i+1) + ": ");
			
			int n = s.nextInt();
			int j = s.nextInt();
			
			solve(n, j, o);
			
		}
		s.close();
		o.close();

	}

	private static void solve(int n, int j, PrintStream o) {
		boolean[] digits = new boolean[n];
		Arrays.fill(digits, false);
		digits[0] = true;
		digits[n-1] = true;
		int count = 0;
		while (count < j) {

			int[] divisors = getDivisors(digits);
			boolean zero = false;
			for (int i = 0;i < divisors.length; i++) {
				if (divisors[i]==0) {
					zero = true;
				}
			}
			
			if (!zero) {
				o.print(show(digits));
				for (int i = 0;i < divisors.length; i++) {
					o.print(" " + divisors[i]);
				}
				o.println();
				o.flush();
				count++;
				//System.out.println(count);
			}
			if (count == j)
				return;
			inc(digits);
		}
	}
	
	private static int[] getDivisors(boolean[] digits) {
		int[] div = new int[9];
		for (int i = 2; i <=10; i++) {
			long n = getNum(digits, i);
			div[i-2] = getDivisor(n);
		}
		return div;
	}

	private static int getDivisor(long num) {
		for (int i = 2; i < Math.sqrt(num) + 1; i++) {
			if (num % i == 0)
				return i;
		}
		return 0;
	}

	private static long getNum(boolean[] digits, int b) {
		long result = 0;
		long base = 1;
		for (int i = 0;i < digits.length; i++) {
			if (digits[i])
				result += base;
			base *= b;
		}
		return result;
	}

	private static String show(boolean[] digits) {
		String s = "";
		for (int i = 0;i < digits.length; i++) {
			s = (digits[i]?"1":"0") + s;
		}
		return s;
	}

	private static void inc(boolean[] digits) {
		int i = 1;
		while (true) {
			if (!digits[i]){
				digits[i] = true;
				return;
			} else {
				digits[i] = false;
			}
			i++;
			
		}
		
	}

}
