import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Set;

public class NextNumber implements Runnable {
	BufferedReader in;
	BufferedWriter out;
	static String inputFile = "";
	static String outputFile = "";
	Set<String> permutations;

	static {
		inputFile = NextNumber.class.getName() + ".in";
		outputFile = NextNumber.class.getName() + ".txt";
	}

	public int iread() throws Exception {
		return Integer.parseInt(readword());
	}

	public double dread() throws Exception {
		return Double.parseDouble(readword());
	}

	public long longread() throws Exception {
		return Long.parseLong(readword());
	}

	public String lread() throws Exception {
		return in.readLine();
	}

	public String readword() throws Exception {
		int c = in.read();
		while (c >= 0 && c <= ' ') {
			c = in.read();

		}
		if (c < 0)
			return "";
		StringBuilder bld = new StringBuilder();
		while (c > ' ') {
			bld.append((char) c);
			c = in.read();

		}
		return bld.toString();
	}

	public void solve() throws Exception {
		int n = iread();

		String t = String.valueOf(n);

		permutations = new HashSet<String>();
		permute("",t);        


		String[] combo = permutations.toArray(new String[permutations.size()]);

		ArrayList<Integer> icombo = new ArrayList<Integer>();
		for(int i=0; i < combo.length; i++){
			icombo.add(Integer.parseInt(combo[i]));
		}
		Collections.sort(icombo);
		int index = icombo.indexOf(n);
		
		if (index == icombo.size()-1){
			String t2 = String.valueOf(n);
			t2 = t2 + "0";
			permutations = new HashSet<String>();
			permute("",t2);        


			String[] combo2 = permutations.toArray(new String[permutations.size()]);

			ArrayList<Integer> icombo2 = new ArrayList<Integer>();
			for(int i=0; i < combo2.length; i++){
				icombo2.add(Integer.parseInt(combo2[i]));
			}
			Collections.sort(icombo2);
			int index2 = icombo2.indexOf(n);
			
			index2++;
			out.write(icombo2.get(index2) + "\n");
		}
		else {
			index++;
			out.write(icombo.get(index) + "\n");
		}

		System.out.println(icombo);


		/*Iterator it = permutations.iterator();        
		while(it.hasNext()) {
			System.out.println(it.next());
		}
		System.out.println("count = "+permutations.size());*/
	}

	public void permute(String fixedPart,String variablePart) {
		if(variablePart.length()>1) {
			for(int i=0;i<variablePart.length();i++) {
				variablePart = shift(variablePart);
				this.permutations.add(fixedPart+variablePart);                
				permute(fixedPart+variablePart.charAt(0),variablePart.substring(1) );                
			}
		} else {
			this.permutations.add(fixedPart+variablePart);
		}
	}
	public static String shift(String var) {
		String result = ""+var.charAt(var.length()-1);
		result += var.substring(0,var.length()-1);
		return result;
	}

	public void run() {
		try {
			in = new BufferedReader(new FileReader(inputFile));
			out = new BufferedWriter(new FileWriter(outputFile));
			//			in = new BufferedReader( new InputStreamReader(System.in));
			//			out = new BufferedWriter( new OutputStreamWriter(System.out));
			int tests = iread();
			for (int i = 0; i < tests; i++) {
				out.write("Case #" + (i + 1) + ": ");
				solve();
			}
			out.flush();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new Thread(new NextNumber()).start();
	}
}
