import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintStream;

public class Rotate implements Runnable {
	BufferedReader in;
	BufferedWriter out;
	static String inputFile = "";
	static String outputFile = "";
	PrintStream p = System.out;
	char[][] rotb;
	int[][] dirmoves;
	int max;
	int numToWin;
	static {
		//	inputFile = Rotate.class.getName() + ".in";
		inputFile = "A-large.in";
		outputFile = Rotate.class.getName() + ".txt";
	}

	public int iread() throws Exception {
		return Integer.parseInt(readword());
	}

	public double dread() throws Exception {
		return Double.parseDouble(readword());
	}

	public long longread() throws Exception {
		return Long.parseLong(readword());
	}

	public String lread() throws Exception {
		return in.readLine();
	}

	public String readword() throws Exception {
		int c = in.read();
		while (c >= 0 && c <= ' ') {
			c = in.read();

		}
		if (c < 0)
			return "";
		StringBuilder bld = new StringBuilder();
		while (c > ' ') {
			bld.append((char) c);
			c = in.read();

		}
		return bld.toString();
	}

	public void solve() throws Exception {
		int n = iread();
		int k = iread();
		
		max = n;
		numToWin = k;
		char[][] board = new char[n][n];

		for (int i = 0; i < board.length; i++) {

			String temp = readword();
			board[i] = temp.toCharArray();


		}

		rotb = new char[n][n];
		int j = 0;
		for (int y = 0; y < rotb.length; y++) {
			j = n-1;
			for (int x=0; x <rotb.length; x++) {
				rotb[y][x] = board[j][y];

				j--;
			}
		}





		for (int a= 0; a< n; a++){
			for (int x = 0; x < rotb.length; x++) {

				for (int y = n-2; y >= 0; y--) {

					if(rotb[y+1][x] == '.'){
						rotb[y+1][x] = rotb[y][x];
						rotb[y][x] = '.';
					}

				}
			}
		}

		dirmoves = new int[8][2];
		dirmoves[0][0] = 0;
		dirmoves[0][1] = -1;
		dirmoves[1][0] = 1;
		dirmoves[1][1] = -1;
		dirmoves[2][0] = 1;
		dirmoves[2][1] = 0;
		dirmoves[3][0] = 1;
		dirmoves[3][1] = 1;
		dirmoves[4][0] = 0;
		dirmoves[4][1] = 1;
		dirmoves[5][0] = -1;
		dirmoves[5][1] = 1;
		dirmoves[6][0] = -1;
		dirmoves[6][1] = 0;
		dirmoves[7][0] = -1;
		dirmoves[7][1] = -1;
		
		boolean redwin = false;
		
		search:
		for(int i=0; i< rotb.length; i++){
			
			for (int m = 0; m < rotb.length; m++) {
				if(rotb[m][i] == 'R'){
					for(int d=0; d< 8; d++){
						redwin = recurse(1, i, m, d);
						if (redwin){
							break search;
						}
					}
				}
			}
		}
		
		boolean bluewin = false;
		searchblue:
			for(int i=0; i< rotb.length; i++){
				
				for (int m = 0; m < rotb.length; m++) {
					if(rotb[m][i] == 'B'){
						for(int d=0; d< 8; d++){
							bluewin = recurseB(1, i, m, d);
							if (bluewin){
								break searchblue;
							}
						}
					}
				}
			}
		
		if (redwin && bluewin){
			out.write("Both\n");
		}
		else if(redwin){
			out.write("Red\n");
		}
		else if(bluewin){
			out.write("Blue\n");
		}
		else{
			out.write("Neither\n");
		}

	}

	public boolean recurse(int curNuminRow,int xvalue,int yvalue,int dir){
		xvalue = xvalue + dirmoves[dir][0];
		yvalue = yvalue + dirmoves[dir][1];
		
		if(xvalue <0 || xvalue >= max ){
			return false;
		}
		
		if(yvalue <0 || yvalue >= max ){
			return false;
		}
		
		if (rotb[yvalue][xvalue] == 'R'){
			curNuminRow++;
			if(curNuminRow == numToWin){
//				System.out.println("won");
				return true;
			}
			else{
				return recurse(curNuminRow, xvalue, yvalue, dir);
			}
				
		}
		else{
			return false;
		}
	}
	
	public boolean recurseB(int curNuminRow,int xvalue,int yvalue,int dir){
		xvalue = xvalue + dirmoves[dir][0];
		yvalue = yvalue + dirmoves[dir][1];
		
		if(xvalue <0 || xvalue >= max ){
			return false;
		}
		
		if(yvalue <0 || yvalue >= max ){
			return false;
		}
		
		if (rotb[yvalue][xvalue] == 'B'){
			curNuminRow++;
			if(curNuminRow == numToWin){
		//		System.out.println("won");
				return true;
			}
			else{
				return recurseB(curNuminRow, xvalue, yvalue, dir);
			}
				
		}
		else{
			return false;
		}
	}
	public void run() {
		try {
			in = new BufferedReader(new FileReader(inputFile));
			out = new BufferedWriter(new FileWriter(outputFile));
			//			in = new BufferedReader( new InputStreamReader(System.in));
			//			out = new BufferedWriter( new OutputStreamWriter(System.out));
			int tests = iread();
			for (int i = 0; i < tests; i++) {
				out.write("Case #" + (i + 1) + ": ");
				solve();
			}
			out.flush();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new Thread(new Rotate()).start();
	}
}
