import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class SnapperChain implements Runnable {
	BufferedReader in;
	BufferedWriter out;
	static String inputFile = "";
	static String outputFile = "";

	static {
		inputFile = SnapperChain.class.getName() + ".in";
		outputFile = SnapperChain.class.getName() + ".txt";
	}

	public int iread() throws Exception {
		return Integer.parseInt(readword());
	}

	public double dread() throws Exception {
		return Double.parseDouble(readword());
	}

	public long longread() throws Exception {
		return Long.parseLong(readword());
	}

	public String lread() throws Exception {
		return in.readLine();
	}

	public String readword() throws Exception {
		int c = in.read();
		while (c >= 0 && c <= ' ') {
			c = in.read();

		}
		if (c < 0)
			return "";
		StringBuilder bld = new StringBuilder();
		while (c > ' ') {
			bld.append((char) c);
			c = in.read();

		}
		return bld.toString();
	}

	public void solve() throws Exception {
		int n = iread();
		int m = iread();
		
		int base = (int)Math.pow(2, n) -1;
		int dif = (int)Math.pow(2,n);

		if (m < base){
			out.write("OFF\n");
			return;
		}
		else{
			int temp = m-base;
			if ((temp % dif) == 0){
				out.write("ON\n");
			}
			else{
				out.write("OFF\n");
			}
		}
	}

	public void run() {
		try {
			in = new BufferedReader(new FileReader(inputFile));
			out = new BufferedWriter(new FileWriter(outputFile));
			//			in = new BufferedReader( new InputStreamReader(System.in));
			//			out = new BufferedWriter( new OutputStreamWriter(System.out));
			int tests = iread();
			for (int i = 0; i < tests; i++) {
				out.write("Case #" + (i + 1) + ": ");
				solve();
			}
			out.flush();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new Thread(new SnapperChain()).start();
	}
}
