import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Random;
import java.util.Scanner;

public class B {

	class Circle implements Comparable<Circle> {
		int k, r;
		double x, y;

		Circle(int k, int r) {
			this.k = k;
			this.r = r;
		}

		public void setCenter(double x, double y) {
			this.x = x;
			this.y = y;
		}

		public String toString() {
			return String.format("%.10f %.10f", x, y);
		}

		public boolean intersects(Circle o) {
			double dx = x - o.x;
			double dy = y - o.y;
			double d = Math.hypot(dx, dy);
			return r + o.r >= Math.round(Math.floor(d + 1e-10));
		}

		@Override
		public int compareTo(Circle o) {
			if (r == o.r)
				return k - o.k;
			return o.r - r;
		}
	}

	private void work() throws IOException {
		// Scanner sc = new Scanner(new FileReader("B-large.in"));
		// PrintWriter pw = new PrintWriter(new FileWriter("B-large.out"));
		Scanner sc = new Scanner(new FileReader("B-small-attempt2.in"));
		PrintWriter pw = new PrintWriter(new FileWriter("B-small-attempt2.out"));
		// Scanner sc = new Scanner(new FileReader("b.in"));
		// PrintWriter pw = new PrintWriter(new FileWriter("b.out"));
		List<Circle> list = new ArrayList<Circle>();
		Circle[] circles = new Circle[1010];
		int nc = sc.nextInt();
		Random rnd = new Random();
		for (int tc = 1; tc <= nc; tc++) {
			int n = sc.nextInt();
			int w = sc.nextInt();
			int l = sc.nextInt();
			list.clear();
			for (int i = 0; i < n; i++) {
				int r = sc.nextInt();
				circles[i] = new Circle(i, r);
				list.add(circles[i]);
			}
			Collections.sort(list);
			list.get(0).setCenter(0, 0);
			if (n > 1)
				list.get(1).setCenter(w, l);

			boolean done = false;
			int cnt = 0;
			while (!done) {
				done = true;
				for (int i = 2; i < n; i++) {
					int x = rnd.nextInt(w + 1);
					int y = rnd.nextInt(l + 1);
					list.get(i).setCenter(x, y);
				}
				for (int i = 0; i < n && done; i++) {
					for (int j = i + 1; j < n; j++) {
						if (list.get(i).intersects(list.get(j))) {
							done = false;
							break;
						}
					}
				}
			}

			pw.printf("Case #%d:", tc);
			for (int i = 0; i < n; i++) {
				pw.print(" " + circles[i]);
			}
			pw.println();
		}
		pw.close();
	}

	public static void main(String[] args) throws IOException {
		new B().work();
	}

}
