import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Scanner;
import java.util.Set;

public class C {

	private void work() throws Exception {
		String fileName = "C-small-attempt0";
		Scanner sc = new Scanner(new BufferedReader(new FileReader(fileName
				+ ".in")));
		PrintWriter pw = new PrintWriter(new FileWriter(fileName + ".out"));
		int[] s = new int[1 << 20];
		for (int i = 0; i < s.length; i++) {
			s[i] = i;
		}

		for (int i = 2; i * i < s.length; i++) {
			if (s[i] == i) {
				for (int j = i * i; j < s.length; j += i) {
					s[j] = i;
				}
			}
		}

		List<BigInteger> p = new ArrayList<BigInteger>();
		for (int i = 2; i < s.length; i++) {
			if (s[i] == i)
				p.add(BigInteger.valueOf(i));
		}
		BigInteger slen = BigInteger.valueOf(s.length);

		Map<String, List<BigInteger>> m = new HashMap<String, List<BigInteger>>();
		Set<String> seen = new HashSet<String>();
		Random rnd = new Random();
		int nc = sc.nextInt();
		for (int tc = 1; tc <= nc; tc++) {
			int n = sc.nextInt();
			int j = sc.nextInt();
			m.clear();
			seen.clear();
			while (m.size() < j) {
				StringBuilder sb = new StringBuilder("1");
				for (int i = 0; i < n - 2; i++) {
					sb.append(rnd.nextBoolean() ? '0' : '1');
				}
				sb.append('1');
				String num = sb.toString();
				if (seen.contains(num))
					continue;
				seen.add(num);

				List<BigInteger> list = new ArrayList<BigInteger>();
				for (int base = 2; base <= 10; base++) {
					BigInteger x = new BigInteger(num, base);
					if (x.isProbablePrime(5))
						break;

					BigInteger val;
					if (x.compareTo(slen) < 0) {
						val = BigInteger.valueOf(s[(int) x.longValue()]);
					} else {
						val = get(x, p);
					}
					if (val.compareTo(x) == 0)
						break;
					list.add(val);
				}
				if (list.size() == 9)
					m.put(num, list);
			}
			pw.printf("Case #%d:\n", tc);
			for (Map.Entry<String, List<BigInteger>> e : m.entrySet()) {
				pw.print(e.getKey());
				for (BigInteger bi : e.getValue())
					pw.printf(" %s", bi.toString());
				pw.println();
			}
		}
		sc.close();
		pw.close();
	}

	private BigInteger get(BigInteger x, List<BigInteger> p) {
		for (BigInteger pp : p) {
			if (pp.multiply(pp).compareTo(x) > 0)
				break;
			if (x.mod(pp).compareTo(BigInteger.ZERO) == 0)
				return pp;
		}
		return x;
	}

	public static void main(String[] args) throws Exception {
		new C().work();
	}

}
