import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class B {
	private final static int SIEVE_SIZE = 1000000;
	private boolean[] nonPrimes = new boolean[SIEVE_SIZE];
	private final static int PRIMES_SIZE = 78498;
	private long[] primes = new long[PRIMES_SIZE];
	private int n, sets[];

	private void union(int s1, int s2) {
		sets[s1] = s2;
	}

	private int find(int index) {
		if (sets[index] == index)
			return index;
		return sets[index] = find(sets[index]);
	}

	private void work() throws IOException {
		sieve();
		int mm = 1;
		primes[0] = 2;
		for (int i = 3; i < SIEVE_SIZE; i += 2) {
			if (!nonPrimes[i])
				primes[mm++] = i;
		}
		sets = new int[1000010];
		String filename = "B-small-attempt0.";
		BufferedReader br = new BufferedReader(new FileReader(filename + "in"));
		PrintWriter pw = new PrintWriter(filename + "out");
		int N = Integer.parseInt(br.readLine().trim());
		long[] pf0 = new long[32];
		long[] pf1 = new long[32];
		for (int tc = 1; tc <= N; tc++) {
			StringTokenizer st = new StringTokenizer(br.readLine());
			long a = Long.parseLong(st.nextToken());
			long b = Long.parseLong(st.nextToken());
			long p = Long.parseLong(st.nextToken());
			n = (int) (b - a + 1);
			for (int i = 0; i < n; i++) {
				sets[i] = i;
			}
			for (int i = 0; i < n; i++) {
				int k0 = 0;
				long t = i + a;
				for (int ii = 0; ii < PRIMES_SIZE; ii++) {
					if (primes[ii] * primes[ii] > t)
						break;
					if (t % primes[ii] == 0) {
						if (primes[ii] >= p)
							pf0[k0++] = primes[ii];
						while (t % primes[ii] == 0)
							t /= primes[ii];
					}
				}
				if (t > 1 && t >= p)
					pf0[k0++] = t;
				for (int j = i + 1; j < n; j++) {
					int k1 = 0;
					long t1 = j + a;
					for (int ii = 0; ii < PRIMES_SIZE; ii++) {
						if (primes[ii] * primes[ii] > t1)
							break;
						if (t1 % primes[ii] == 0) {
							if (primes[ii] >= p)
								pf1[k1++] = primes[ii];
							while (t1 % primes[ii] == 0)
								t1 /= primes[ii];
						}
					}
					if (t1 > 1 && t1 >= p)
						pf1[k1++] = t1;
					boolean ok = false;
					for (int ii = 0; ii < k0 && !ok; ii++) {
						for (int jj = 0; jj < k1; jj++) {
							if (pf0[ii] == pf1[jj]) {
								ok = true;
								break;
							}
						}
					}
					if (ok) {
						int s1 = find(i);
						int s2 = find(j);
						if (s1 != s2)
							union(s1, s2);
					}
				}
			}
			int cnt = 0;
			for (int i = 0; i < n; i++) {
				if (sets[i] == i)
					cnt++;
			}
			pw.printf("Case #%d: %d\n", tc, cnt);
		}
		br.close();
		pw.close();
	}

	private void sieve() {
		nonPrimes[0] = true;
		nonPrimes[1] = true;
		for (int i = 4; i < SIEVE_SIZE; i += 2) {
			nonPrimes[i] = true;
		}
		for (int i = 3; i <= (int) Math.round(Math.sqrt(SIEVE_SIZE)) + 1; i += 2) {
			if (!nonPrimes[i]) {
				int tmp = i * i;
				while (tmp < SIEVE_SIZE) {
					nonPrimes[tmp] = true;
					tmp += i << 1;
				}
			}
		}
	}

	public static void main(String[] args) throws IOException {
		B bbb = new B();
		bbb.work();
	}
}
