import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class Water {

	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new FileReader("B-large.in"));
		PrintWriter pw = new PrintWriter(new FileWriter("B-large.out"));
		int[] dx = { -1, 0, 0, 1 };
		int[] dy = { 0, -1, 1, 0 };
		int oo = 999999999;
		int[][] g = new int[105][105];
		for (int i = 0; i < g.length; i++) {
			g[0][i] = g[i][0] = oo;
		}
		int[][][] adj = new int[105][105][4];
		int[][] deg = new int[105][105];
		char[][] labels = new char[105][105];
		char[] map = new char[256];
		int[] q = new int[1 << 20];
		int qs, qe;
		int nc = sc.nextInt();
		for (int tc = 1; tc <= nc; tc++) {
			int m = sc.nextInt();
			int n = sc.nextInt();
			for (int i = 0; i < m + 2; i++) {
				g[i][n + 1] = oo;
			}
			for (int i = 0; i < n + 2; i++) {
				g[m + 1][i] = oo;
			}
			for (int i = 1; i <= m; i++) {
				for (int j = 1; j <= n; j++) {
					int h = sc.nextInt();
					g[i][j] = h;
					deg[i][j] = 0;
					labels[i][j] = '@';
				}
			}
			int sinkCount = 0;
			qs = qe = 0;
			for (int i = 1; i <= m; i++) {
				for (int j = 1; j <= n; j++) {
					int lowest = oo + 1; // <gasp>
					int bx = -1;
					int by = -1;
					int dir = -1;
					for (int k = 0; k < 4; k++) {
						int tx = i + dx[k];
						int ty = j + dy[k];
						if (g[tx][ty] < lowest) {
							lowest = g[tx][ty];
							bx = tx;
							by = ty;
							dir = k;
						}
					}
					if (lowest < g[i][j]) {
						adj[bx][by][deg[bx][by]++] = 3 - dir;
					} else {
						q[qe++] = i;
						q[qe++] = j;
						labels[i][j] = (char) ('a' + sinkCount++);
					}
				}
			}
			while (qs < qe) {
				int x = q[qs++];
				int y = q[qs++];
				for (int i = 0; i < deg[x][y]; i++) {
					int dir = adj[x][y][i];
					int nx = x + dx[dir];
					int ny = y + dy[dir];
					if (labels[nx][ny] == '@') {
						labels[nx][ny] = labels[x][y];
						q[qe++] = nx;
						q[qe++] = ny;
					}
				}
			}
			Arrays.fill(map, '@');
			char next = 'a';
			for (int i = 1; i <= m; i++) {
				for (int j = 1; j <= n; j++) {
					if (map[labels[i][j]] == '@')
						map[labels[i][j]] = next++;
				}
			}
			pw.printf("Case #%d:\n", tc);
			for (int i = 1; i <= m; i++) {
				for (int j = 1; j <= n; j++) {
					if (j > 1)
						pw.print(" ");
					pw.print(map[labels[i][j]]);
				}
				pw.println();
			}
		}
		pw.close();
	}

}
