import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

public class A {
	static class Fraction implements Comparable<Fraction> {
		public BigInteger n, d;

		public Fraction(long n, long d) {
			this(BigInteger.valueOf(n), BigInteger.valueOf(d));
		}

		public Fraction(BigInteger nn, BigInteger dd) {
			n = nn;
			d = dd;
			BigInteger g = n.gcd(d);
			n = n.divide(g);
			d = d.divide(g);
		}

		public static Fraction pow(Fraction f, int k) {
			BigInteger nn = f.n.pow(k);
			BigInteger dd = f.d.pow(k);
			return new Fraction(nn, dd);
		}

		public static Fraction add(Fraction f1, Fraction f2) {
			BigInteger nn = f1.n.multiply(f2.d).add(f1.d.multiply(f2.n));
			BigInteger dd = f1.d.multiply(f2.d);
			return new Fraction(nn, dd);
		}

		public static Fraction subtract(Fraction f1, Fraction f2) {
			BigInteger nn = f1.n.multiply(f2.d).subtract(f1.d.multiply(f2.n));
			BigInteger dd = f1.d.multiply(f2.d);
			return new Fraction(nn, dd);
		}

		public static Fraction multiply(Fraction f1, Fraction f2) {
			return new Fraction(f1.n.multiply(f2.n), f1.d.multiply(f2.d));
		}

		public static Fraction divide(Fraction f1, Fraction f2) {
			return new Fraction(f1.n.multiply(f2.d), f1.d.multiply(f2.n));
		}

		public boolean equals(Object o) {
			Fraction f = (Fraction) o;
			return n.compareTo(f.n) == 0 && d.compareTo(f.d) == 0;
		}

		public int hashCode() {
			return 31 * n.hashCode() + d.hashCode();
		}

		public int compareTo(Fraction fraction) {
			BigInteger a = n.multiply(fraction.d);
			BigInteger b = d.multiply(fraction.n);
			return a.compareTo(b);
		}

		public String toString() {
			return n + " / " + d;
		}

		public double doubleValue() {
			return n.doubleValue() / d.doubleValue();
		}
	}

	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new FileReader("A-large.in"));
		PrintWriter pw = new PrintWriter(new FileWriter("A-large.out"));
		Fraction[] wp = new Fraction[111];
		Fraction[] owp = new Fraction[111];
		Fraction[] oowp = new Fraction[111];
		int[] op = new int[111];
		int[] win = new int[111];
		int nc = sc.nextInt();
		for (int tc = 1; tc <= nc; tc++) {
			pw.printf("Case #%d:\n", tc);
			int n = sc.nextInt();
			char[][] t = new char[n][];
			for (int i = 0; i < n; i++) {
				t[i] = sc.next().toCharArray();
				op[i] = win[i] = 0;
				for (int j = 0; j < n; j++) {
					if (t[i][j] != '.') {
						op[i]++;
						if (t[i][j] == '1')
							win[i]++;
					}
				}
			}
			for (int i = 0; i < n; i++) {
				if (op[i] == 0) {
					wp[i] = new Fraction(0, 1);
					owp[i] = new Fraction(0, 1);
					continue;
				}
				wp[i] = new Fraction(win[i], op[i]);
				owp[i] = new Fraction(0, 1);
				for (int j = 0; j < n; j++) {
					if (i == j)
						continue;
					if (op[j] > 1) {
						if (t[i][j] == '1') {
							owp[i] = Fraction.add(owp[i], new Fraction(win[j],
									op[j] - 1));
						}
						if (t[i][j] == '0') {
							owp[i] = Fraction.add(owp[i], new Fraction(
									win[j] - 1, op[j] - 1));
						}
					}
				}
				owp[i] = Fraction.multiply(owp[i], new Fraction(1, op[i]));
			}
			for (int i = 0; i < n; i++) {
				oowp[i] = new Fraction(0, 1);
				for (int j = 0; j < t.length; j++) {
					if (t[i][j] != '.') {
						oowp[i] = Fraction.add(oowp[i], owp[j]);
					}
				}
				oowp[i] = Fraction.multiply(oowp[i], new Fraction(1, op[i]));
			}
			for (int i = 0; i < n; i++) {
				double res = 0.25 * wp[i].doubleValue();
				res += 0.5 * owp[i].doubleValue();
				res += 0.25 * oowp[i].doubleValue();
				pw.println(res);
				// System.out.println(res);
			}
		}
		pw.close();
	}
}
