import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;
import java.util.Set;

public class C {

	class Node {
		int x, y;
		Node prev;

		Node(int x, int y, Node prev) {
			this.x = x;
			this.y = y;
			this.prev = prev;
		}

		public int hashCode() {
			return 31 * x + y;
		}

		public boolean equals(Object o) {
			Node n = (Node) o;
			return x == n.x && y == n.y;
		}
	}

	private void work() throws IOException {
		// Scanner sc = new Scanner(new FileReader("C-large.in"));
		// PrintWriter pw = new PrintWriter(new FileWriter("C-large.out"));
		Scanner sc = new Scanner(new FileReader("C-small-attempt0.in"));
		PrintWriter pw = new PrintWriter(new FileWriter("C-small-attempt0.out"));
		// Scanner sc = new Scanner(new FileReader("c.in"));
		// PrintWriter pw = new PrintWriter(new FileWriter("c.out"));

		Queue<Node> q = new LinkedList<Node>();
		Set<Node> s = new HashSet<Node>();

		int[] dx = { -1, 0, 1, 0 };
		int[] dy = { 0, 1, 0, -1 };

		int nc = sc.nextInt();
		for (int tc = 1; tc <= nc; tc++) {
			int w = sc.nextInt();
			int h = sc.nextInt();
			int b = sc.nextInt();
			boolean[][] g = new boolean[h][w];
			while (b-- > 0) {
				int x0 = sc.nextInt();
				int y0 = sc.nextInt();
				int x1 = sc.nextInt();
				int y1 = sc.nextInt();
				for (int i = y0; i <= y1; i++) {
					for (int j = x0; j <= x1; j++) {
						g[i][j] = true;
					}
				}
			}
			int flow = 0;
			for (int start = 0; start < w; start++) {
				if (g[0][start])
					continue;

				q.clear();
				s.clear();
				Node cur = new Node(start, 0, null);
				q.add(cur);
				s.add(cur);
				Node res = null;
				while (!q.isEmpty()) {
					cur = q.poll();
					if (cur.y == h - 1) {
						res = cur;
						break;
					}
					for (int i = 0; i < 4; i++) {
						int tx = cur.x + dx[i];
						if (tx < 0 || tx == w)
							continue;
						int ty = cur.y + dy[i];
						if (ty < 0 || ty == h)
							continue;
						if (!g[ty][tx]) {
							Node nn = new Node(tx, ty, cur);
							if (!s.contains(nn)) {
								q.add(nn);
								s.add(nn);
							}
						}
					}
				}
				if (res != null) {
					flow++;
					while (res != null) {
						g[res.y][res.x] = true;
						res = res.prev;
					}
				}
			}
			pw.printf("Case #%d: %d\n", tc, flow);
		}
		pw.close();
	}

	public static void main(String[] args) throws IOException {
		new C().work();
	}
}
