import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class C {

	Set<List<Integer>> rooms;
	int[] col;
	int[] list;

	private void work() throws IOException {
		Scanner sc = new Scanner(new FileReader("C-small-attempt0.in"));
		PrintWriter pw = new PrintWriter(new FileWriter("C-small-attempt0.out"));
		int[] u = new int[5];
		int[] v = new int[5];
		int nc = sc.nextInt();
		for (int tc = 1; tc <= nc; tc++) {
			int n = sc.nextInt();
			int m = sc.nextInt();
			for (int i = 0; i < m; i++) {
				u[i] = sc.nextInt();
			}
			for (int i = 0; i < m; i++) {
				v[i] = sc.nextInt();
			}
			Map<Integer, Set<Integer>> g = new HashMap<Integer, Set<Integer>>();
			for (int i = 1; i <= n; i++) {
				int l = i - 1;
				if (l == 0)
					l = n;
				int r = i + 1;
				if (r > n)
					r = 1;
				g.put(i, new HashSet<Integer>());
				g.get(i).add(l);
				g.get(i).add(r);
			}
			for (int i = 0; i < m; i++) {
				g.get(u[i]).add(v[i]);
				g.get(v[i]).add(u[i]);
			}
			rooms = new HashSet<List<Integer>>();
			for (int i = 1; i <= n; i++) {
				boolean[] seen = new boolean[n + 1];
				list = new int[n];
				list[0] = i;
				seen[i] = true;
				dfs(i, g, seen, 1, -1);
			}
			int min = 10000;
			for (List<Integer> room : rooms) {
				if (room.size() < min)
					min = room.size();
			}
			// System.out.println(rooms);
			col = new int[n + 1];
			try {
				go(1, min, n);
			} catch (Exception e) {
				pw.printf("Case #%d: %d\n", tc, min);
				for (int i = 1; i <= n; i++) {
					if (i > 1)
						pw.print(" ");
					pw.print(col[i]);
				}
				pw.println();
			}
		}
		pw.close();
	}

	private void go(int k, int max, int n) {
		if (k == n + 1) {
			boolean ok = true;
			Set<Integer> t = new HashSet<Integer>();
			for (List<Integer> room : rooms) {
				t.clear();
				for (int i : room)
					t.add(col[i]);
				if (t.size() < max) {
					ok = false;
					break;
				}
			}
			if (ok)
				throw new RuntimeException();
		} else {
			for (int i = 1; i <= max; i++) {
				col[k] = i;
				go(k + 1, max, n);
			}
		}
	}

	private void dfs(int u, Map<Integer, Set<Integer>> g, boolean[] seen,
			int k, int par) {
		for (int v : g.get(u)) {
			if (par == v)
				continue;
			if (seen[v]) {
				List<Integer> room = new ArrayList<Integer>();
				for (int i = 0; i < k; i++) {
					room.add(list[i]);
				}
				Collections.sort(room);
				rooms.add(room);
			} else {
				seen[v] = true;
				list[k] = v;
				dfs(v, g, seen, k + 1, u);
				seen[v] = false;
			}
		}
	}

	public static void main(String[] args) throws IOException {
		new C().work();
	}

}
