import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Map;
import java.util.PriorityQueue;
import java.util.Scanner;
import java.util.TreeMap;

public class A {
	class Card implements Comparable<Card> {
		int origin;
		long count;

		public Card(int origin, long count) {
			this.origin = origin;
			this.count = count;
		}

		@Override
		public int compareTo(Card o) {
			if (origin > o.origin)
				return -1;
			if (origin < o.origin)
				return 1;
			return 0;
		}
	}

	private void work() throws IOException {
		Scanner sc = new Scanner(new FileReader("A-large.in"));
		PrintWriter pw = new PrintWriter(new FileWriter("A-large.out"));
		// Scanner sc = new Scanner(new FileReader("A-small-attempt0.in"));
		// PrintWriter pw = new PrintWriter(new
		// FileWriter("A-small-attempt0.out"));
		// Scanner sc = new Scanner(new FileReader("a.in"));
		// PrintWriter pw = new PrintWriter(new FileWriter("a.out"));

		TreeMap<Integer, Long> on = new TreeMap<Integer, Long>();
		TreeMap<Integer, Long> off = new TreeMap<Integer, Long>();
		PriorityQueue<Card> cards = new PriorityQueue<Card>();

		BigInteger MOD = BigInteger.valueOf(1000002013);

		int nc = sc.nextInt();
		for (int tc = 1; tc <= nc; tc++) {
			int n = sc.nextInt();
			int m = sc.nextInt();
			on.clear();
			off.clear();
			BigInteger res = BigInteger.ZERO;
			while (m-- > 0) {
				int s = sc.nextInt();
				int e = sc.nextInt();
				long p = sc.nextInt();
				res = res.add(getVal(e - s, n, p));

				if (on.containsKey(s)) {
					on.put(s, on.get(s) + p);
				} else {
					on.put(s, p);
				}
				if (off.containsKey(e)) {
					off.put(e, off.get(e) + p);
				} else {
					off.put(e, p);
				}
			}

			cards.clear();

			int onN = on.size();
			int[] onPos = new int[onN];
			long[] onCount = new long[onN];
			int kk = 0;
			for (Map.Entry<Integer, Long> e : on.entrySet()) {
				onPos[kk] = e.getKey();
				onCount[kk] = e.getValue();
				kk++;
			}

			int offN = off.size();
			int[] offPos = new int[offN];
			long[] offCount = new long[offN];
			kk = 0;
			for (Map.Entry<Integer, Long> e : off.entrySet()) {
				offPos[kk] = e.getKey();
				offCount[kk] = e.getValue();
				kk++;
			}

			int onK = 0;
			int offK = 0;

			while (offK < offN) {
				while (onK < onN && onPos[onK] <= offPos[offK]) {
					cards.add(new Card(onPos[onK], onCount[onK]));
					onK++;
				}
				while (offK < offN
						&& ((onK >= onN) || onPos[onK] > offPos[offK])) {
					long tt = offCount[offK];
					while (tt > 0) {
						Card c = cards.poll();
						if (c.count > tt) {
							res = res.subtract(getVal(offPos[offK] - c.origin,
									n, tt));
							c.count -= tt;
							tt = 0;
							cards.add(c);
						} else {
							res = res.subtract(getVal(offPos[offK] - c.origin,
									n, c.count));
							tt -= c.count;
						}
					}
					offK++;
				}
			}

			res = res.mod(MOD);
			pw.printf("Case #%d: %d\n", tc, res.intValue());
		}
		pw.close();
	}

	private BigInteger getVal(long d, int n, long p) {
		long t = (d + 1) * n - d * (d + 1) / 2;
		return BigInteger.valueOf(t).multiply(BigInteger.valueOf(p));
	}

	public static void main(String[] args) throws IOException {
		new A().work();
	}
}
