import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class GCJ_B {

    class Train {
	public int s, e, k, side;

	public Train(int s, int e, int k, int side) {
	    this.s = s;
	    this.e = e;
	    this.k = k;
	    this.side = side;
	}

	public boolean equals(Object o) {

	    Train train = (Train) o;

	    if (e != train.e) {
		return false;
	    }
	    if (k != train.k) {
		return false;
	    }
	    if (s != train.s) {
		return false;
	    }
	    if (side != train.side) {
		return false;
	    }

	    return true;
	}

	public int hashCode() {
	    int result;
	    result = s;
	    result = 31 * result + e;
	    result = 31 * result + k;
	    result = 31 * result + side;
	    return result;
	}

    }

    private void work() throws IOException {
	String fileName = "B-small-attempt1.";
	BufferedReader br = new BufferedReader(new FileReader(fileName + "in"));
	PrintWriter pw = new PrintWriter(new FileWriter(fileName + "out"));
	int N = Integer.parseInt(br.readLine().trim());
	TreeSet<Train> all = new TreeSet<Train>(new Comparator<Train>() {
	    public int compare(Train t1, Train t2) {
		if (t1.s == t2.s) {
		    if (t1.e == t2.e) {
			return t1.k - t2.k;
		    }
		    return t1.e - t2.e;
		}
		return t1.s - t2.s;
	    }
	});
	TreeSet<Train> A = new TreeSet<Train>(new Comparator<Train>() {
	    public int compare(Train t1, Train t2) {
		if (t1.s == t2.s) {
		    if (t1.e == t2.e) {
			return t1.k - t2.k;
		    }
		    return t1.e - t2.e;
		}
		return t1.s - t2.s;
	    }
	});
	TreeSet<Train> B = new TreeSet<Train>(new Comparator<Train>() {
	    public int compare(Train t1, Train t2) {
		if (t1.s == t2.s) {
		    if (t1.e == t2.e) {
			return t1.k - t2.k;
		    }
		    return t1.e - t2.e;
		}
		return t1.s - t2.s;
	    }
	});
	boolean[] skip = new boolean[222];
	for (int tc = 1; tc <= N; tc++) {
	    int T = Integer.parseInt(br.readLine().trim());
	    StringTokenizer st = new StringTokenizer(br.readLine());
	    int NA = Integer.parseInt(st.nextToken());
	    int NB = Integer.parseInt(st.nextToken());
	    all.clear();
	    A.clear();
	    B.clear();
	    int k = 0;
	    while (k < NA) {
		st = new StringTokenizer(br.readLine());
		int s = timeToInt(st.nextToken());
		int e = timeToInt(st.nextToken());
		Train train = new Train(s, e, k, 0);
		all.add(train);
		A.add(train);
		k++;
	    }
	    while (k < NA + NB) {
		st = new StringTokenizer(br.readLine());
		int s = timeToInt(st.nextToken());
		int e = timeToInt(st.nextToken());
		Train train = new Train(s, e, k, 1);
		all.add(train);
		B.add(train);
		k++;
	    }
	    int as = 0;
	    int bs = 0;
	    Arrays.fill(skip, false);
	    for (Train train : all) {
		if (skip[train.k]) {
		    continue;
		}
		skip[train.k] = true;
		if (train.side == 0) {
		    as++;
		    boolean changed = true;
		    int next = 1;
		    int time = train.e + T;
		    A.remove(train);
		    while (changed) {
			changed = false;
			if (next == 0) {
			    Train toRemove = null;
			    for (Train oppTrain : A) {
				if (oppTrain.s < time) {
				    continue;
				}
				toRemove = oppTrain;
				changed = true;
				break;
			    }
			    if (toRemove != null) {
				A.remove(toRemove);
				skip[toRemove.k] = true;
				time = toRemove.e + T;
				next = 1;
			    }
			} else {
			    Train toRemove = null;
			    for (Train oppTrain : B) {
				if (oppTrain.s < time) {
				    continue;
				}
				toRemove = oppTrain;
				changed = true;
				break;
			    }
			    if (toRemove != null) {
				B.remove(toRemove);
				skip[toRemove.k] = true;
				time = toRemove.e + T;
				next = 0;
			    }
			}
		    }
		} else {
		    bs++;
		    boolean changed = true;
		    int next = 0;
		    int time = train.e + T;
		    B.remove(train);
		    while (changed) {
			changed = false;
			if (next == 0) {
			    Train toRemove = null;
			    for (Train oppTrain : A) {
				if (oppTrain.s < time) {
				    continue;
				}
				toRemove = oppTrain;
				changed = true;
				break;
			    }
			    if (toRemove != null) {
				A.remove(toRemove);
				skip[toRemove.k] = true;
				time = toRemove.e + T;
				next = 1;
			    }
			} else {
			    Train toRemove = null;
			    for (Train oppTrain : B) {
				if (oppTrain.s < time) {
				    continue;
				}
				toRemove = oppTrain;
				changed = true;
				break;
			    }
			    if (toRemove != null) {
				B.remove(toRemove);
				skip[toRemove.k] = true;
				time = toRemove.e + T;
				next = 0;
			    }
			}
		    }
		}
	    }
	    pw.printf("Case #%d: %d %d\n", tc, as, bs);
	}
	br.close();
	pw.close();
    }

    private int timeToInt(String s) {
	StringTokenizer st = new StringTokenizer(s, ":");
	int t = 60 * Integer.parseInt(st.nextToken());
	t += Integer.parseInt(st.nextToken());
	return t;
    }

    public static final void main(String[] args) throws IOException {
	GCJ_B bbb = new GCJ_B();
	bbb.work();
    }
}
