import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class D {

	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new FileReader("D-small-attempt2.in"));
		PrintWriter pw = new PrintWriter(new FileWriter("D-small.out"));
		int nc = sc.nextInt();
		for (int tc = 1; tc <= nc; tc++) {
			int n = sc.nextInt();
			int m = sc.nextInt();
			long x1 = sc.nextInt();
			long y1 = sc.nextInt();
			long x2 = sc.nextInt();
			long y2 = sc.nextInt();
			double d = dist(x1, y1, x2, y2);
			pw.printf("Case #%d:", tc);
			while (m-- > 0) {
				long x3 = sc.nextInt();
				long y3 = sc.nextInt();
				double r1 = dist(x1, y1, x3, y3);
				double r2 = dist(x2, y2, x3, y3);
				pw.printf(" %f", area(d, r1, r2));
			}
			pw.println();
		}
		pw.close();
	}

	private static double area(double d, double r1, double r2) {
		return smallArea(d, r1, r2)
				+ smallArea(d, r2, r1)
				- 0.5
				* Math.sqrt((-d + r1 + r2) * (d + r1 - r2) * (d - r1 + r2)
						* (d + r1 + r2));
	}

	private static double smallArea(double d, double r1, double r2) {
		return r1 * r1 * Math.acos((d * d + r1 * r1 - r2 * r2) / (2 * d * r1));
	}

	private static double dist(long x1, long y1, long x2, long y2) {
		long dx = x1 - x2;
		long dy = y1 - y2;
		return Math.hypot(dx, dy);
	}

}
