import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class C {

	private void work() throws IOException {
		Scanner sc = new Scanner(new BufferedReader(new FileReader("C-small-attempt0.in")));
		PrintWriter pw = new PrintWriter(new FileWriter("C-small-attempt0.out"));
		int nc = sc.nextInt();
		for (int tc = 1; tc <= nc; tc++) {
			n = sc.nextInt();
			int q = sc.nextInt();

			long[] maxDistance = new long[n];
			speed = new long[n];
			for (int i = 0; i < n; i++) {
				maxDistance[i] = sc.nextInt();
				speed[i] = sc.nextInt();
			}

			d = new long[n][n];
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					d[i][j] = sc.nextInt();
				}
			}

			maxK = new int[n];
			for (int i = 0; i < n; i++) {
				long dd = 0;
				maxK[i] = i;
				for (int j = i + 1; j < n; j++) {
					if (maxDistance[i] < dd + d[j - 1][j])
						break;
					maxK[i] = j;
					dd += d[j - 1][j];
				}
			}

			while (q-- > 0) {
				int u = sc.nextInt() - 1;
				int v = sc.nextInt() - 1;
				memo = new double[n][n];
				for (int i = 0; i < n; i++) {
					Arrays.fill(memo[i], Double.NEGATIVE_INFINITY);
					memo[i][n - 1] = 0;
				}

				pw.printf("Case #%d: %.8f\n", tc, 1.0 * d[0][1] / speed[0] + solveSmall(0, 1));
			}
		}
		pw.close();
		sc.close();
	}

	private int n, maxK[];
	private long[] speed, d[];
	private double[][] memo;

	private double solveSmall(int horse, int city) {
		if (memo[horse][city] >= 0)
			return memo[horse][city];
		double ret = 1.0 * d[city][city + 1] / speed[city] + solveSmall(city, city + 1);
		if (maxK[horse] > city) {
			double t = 1.0 * d[city][city + 1] / speed[horse] + solveSmall(horse, city + 1);
			if (t < ret)
				ret = t;
		}
		return memo[horse][city] = ret;
	}

	public static void main(String[] args) throws IOException {
		new C().work();
	}
}
