import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class A {

	class Pancake implements Comparable<Pancake> {
		long r, h;

		Pancake(long r, long h) {
			this.r = r;
			this.h = h;
		}

		@Override
		public int compareTo(Pancake o) {
			if (r == o.r) {
				if (h > o.h)
					return -1;
				if (h < o.h)
					return 1;
				return 0;
			}
			if (r > o.r)
				return -1;
			return 1;
		}
	}

	private void work() throws IOException {
		Scanner sc = new Scanner(new BufferedReader(new FileReader("A-small-attempt0.in")));
		PrintWriter pw = new PrintWriter(new FileWriter("A-small-attempt0.out"));

		int nc = sc.nextInt();
		for (int tc = 1; tc <= nc; tc++) {
			n = sc.nextInt();
			k = sc.nextInt();
			p = new Pancake[n];
			for (int i = 0; i < n; i++) {
				p[i] = new Pancake(sc.nextInt(), sc.nextInt());
			}
			Arrays.sort(p);

			memo = new long[n][n + 1];
			for (int i = 0; i < memo.length; i++) {
				Arrays.fill(memo[i], -1);
			}
			go(0, k);
			long best = 0;
			for (int i = 0; i <= n - k; i++) {
				long t = p[i].r * p[i].r + 2 * p[i].r * p[i].h + 2 * go(i + 1, k - 1);
				if (t > best)
					best = t;
			}

			pw.printf("Case #%d: %.8f\n", tc, best * Math.PI);
		}
		pw.close();
		sc.close();
	}

	private int n, k;
	private Pancake[] p;
	private long[][] memo;

	private long go(int cur, int rem) {
		if (cur >= n || rem == 0)
			return 0;

		if (memo[cur][rem] >= 0)
			return memo[cur][rem];
		long ret = p[cur].r * p[cur].h + go(cur + 1, rem - 1);
		long t = go(cur + 1, rem);
		if (t > ret)
			ret = t;

		return memo[cur][rem] = ret;
	}

	public static void main(String[] args) throws IOException {
		new A().work();
	}
}
