import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;

public class FileFixIt 
{
	private Scanner fileIn;
	private PrintWriter fileOut;
	
	public static void main(String[] args) throws IOException 
	{
		FileFixIt app = new FileFixIt();
		app.start();
	}
	
	private FileFixIt()
	{		
	}
	
	private void start() throws IOException
	{
		fileIn = new Scanner(new FileReader("A-small-attempt3.in"));
        fileOut = new PrintWriter(new FileWriter("A-small-attempt3.out", false));
		
		int caseCount = fileIn.nextInt(10);
		
		for(int i=1; i<=caseCount; i++)		
			fileOut.println("Case #" + i + ": " + function());
		fileOut.flush();
	}
	
	class Dir
	{
		public String name;
		public ArrayList<Dir> children = new ArrayList<Dir>();
		
		Dir(String name)
		{
			this.name = name;
		}
		
		public int add(String childName)
		{
			for(int i=0; i<children.size(); i++)
				if(children.get(i).name.equals(childName))
					return i;
			
			children.add(new Dir(childName));
			return -1;
		}
		
		public int check(Dir root, String[] pathArray)
		{
			int count = 0;
			Dir currentDir = root;
			
			for(int i=1; i<pathArray.length; i++)
			{
				int searchIndex = currentDir.add(pathArray[i]);
				
				if(searchIndex == -1)
				{
					currentDir = currentDir.children.get(currentDir.children.size()-1);
					count++;
					continue;
				}
				
				currentDir = currentDir.children.get(searchIndex);
			}
			
			return count;
		}
	}

	private int function() 
	{
		int N = fileIn.nextInt(10);
		int M = fileIn.nextInt(10);
		int count = 0;
		Dir root = new Dir("root");
		
		for(int i=0; i<N; i++)
		{
			String line = fileIn.next();
			String[] pathArray = line.split("/");

			root.check(root, pathArray);
		}
		
		for(int i=0; i<M; i++)
		{
			String line = fileIn.next();
			String[] pathArray = line.split("/");
			
			count += root.check(root, pathArray);
		}
		
		return count;
	}
}