import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;


public class Solution implements Runnable {
	
	private static final String YES = "YES";
	private static final String NO = "NO";
	
	private BufferedReader in;
	private StringTokenizer st;
	private PrintWriter out;
	
	private String solve(int[] x, int[] y, int d) {
		int n = x.length;
		int[] maxSwing = new int[n];
		maxSwing[0] = x[0];
		for (int i = 0; i < n; i++) {
			if (maxSwing[i] == 0) {
				continue;
			}
			if (x[i] + maxSwing[i] >= d) {
				return YES;
			}
			for (int j = i + 1; j < n; j++) {
				if (x[i] + maxSwing[i] >= x[j]) {
					maxSwing[j] = Math.max(maxSwing[j], Math.min(y[j], x[j] - x[i]));
				}
			}
		}
		return NO;
	}
	
	private void solve() throws IOException {
		int t = nextInt();
		for (int test = 1; test <= t; test++) {
			int n = nextInt();
			int[] x = new int[n];
			int[] y = new int[n];
			for (int i = 0; i < n; i++) {
				x[i] = nextInt();
				y[i] = nextInt();
			}
			int d = nextInt();
			String answer = solve(x, y, d);
			out.println("Case #" + test + ": " + answer);
		}
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Throwable e) {
			apstenu(e);
		} finally {
			out.close();
		}
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	private String next() throws IOException {
		while (!st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}
	
	private void apstenu(Throwable e) {
		e.printStackTrace();
		System.exit(1);
	}
	
	public Solution(String filename) {
		try {
			in = new BufferedReader(new FileReader(filename + ".in"));
			st = new StringTokenizer("");
			out = new PrintWriter(new FileWriter(filename + ".out"));
		} catch (IOException e) {
			apstenu(e);
		}
	}
	
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Solution("data").run();
	}
	
}
