import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.Locale;
import java.util.StringTokenizer;

public class Solution implements Runnable {
	
	private PrintStream out;
	private BufferedReader in;
	private StringTokenizer st;
	
	public void solve() throws IOException {
		long time0 = System.currentTimeMillis();
		
		int t = nextInt();
		for (int test = 1; test <= t; test++) {
			int n = nextInt();
			int p = nextInt();
			int[] g = new int[n];
			for (int i = 0; i < n; i++) {
				g[i] = nextInt();
			}
			int answer = solve(n, p, g);
			out.println("Case #" + test + ": " + answer);
		}
		
		System.err.println("time: " + (System.currentTimeMillis() - time0) + " ms.");
	}
	
	private int solve(int n, int p, int[] g) {
		int[] r = new int[p];
		for (int i = 0; i < n; i++) {
			r[g[i] % p]++;
		}
		int answer = 0;
		int rem = 0;
		mainloop:while (n > 0) {
			if (rem == 0) {
				answer++;
			}
			if (r[(p - rem) % p] > 0) {
				n -= 1;
				r[(p - rem) % p]--;
				rem = 0;
				continue mainloop;
			}
			for (int i = 0; i < p; i++) {
				if (r[i] > 0 && r[(2 * p - rem - i) % p] > 0) {
					n -= 2;
					r[i]--;
					r[(2 * p - rem - i) % p]--;
					rem = 0;
					continue mainloop;
				}
			}
			for (int i = 0; i < p; i++) {
				for (int j = 0; j <= i; j++) {
					if (r[i] > 0 && r[j] > 0 && r[(3 * p - rem - i - j) % p] > 0) {
						n -= 3;
						r[i]--;
						r[j]--;
						r[(3 * p - rem - i - j) % p]--;
						rem = 0;
						continue mainloop;
					}
				}
			}
			for (int i = 0; i < p; i++) {
				if (r[i] > 0) {
					n -= 1;
					r[i]--;
					rem = (rem + i) % p;
					continue mainloop;
				}
			}
		}
		return answer;
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}
	
	public long nextLong() throws IOException {
		return Long.parseLong(next());
	}
	
	public int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	public String next() throws IOException {
		while (!st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}
	
	@Override
	public void run() {
		try {
			solve();
			out.close();
		} catch (Throwable e) {
			throw new RuntimeException(e);
		}
	}
	
	public Solution(String name) throws IOException {
		Locale.setDefault(Locale.US);
		if (name == null) {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintStream(new BufferedOutputStream(System.out));
		} else {
			in = new BufferedReader(new InputStreamReader(new FileInputStream(name + ".in")));
			out = new PrintStream(new BufferedOutputStream(new FileOutputStream(name + ".out")));
		}
		st = new StringTokenizer("");
	}
	
	public static void main(String[] args) throws IOException {
		new Thread(new Solution(null)).start();
	}
}
