import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.Locale;
import java.util.StringTokenizer;

public class Solution implements Runnable {
	
	private PrintStream out;
	private BufferedReader in;
	private StringTokenizer st;
	
	public void solve() throws IOException {
		long time0 = System.currentTimeMillis();
		
		int t = nextInt();
		for (int test = 1; test <= t; test++) {
			int ac = nextInt();
			int aj = nextInt();
			int[] bc = new int[ac];
			int[] cc = new int[ac];
			int[] bj = new int[aj];
			int[] cj = new int[aj];
			for (int i = 0; i < ac; i++) {
				bc[i] = nextInt();
				cc[i] = nextInt();
			}
			for (int i = 0; i < aj; i++) {
				bj[i] = nextInt();
				cj[i] = nextInt();
			}
			int answer = solve(bc, cc, bj, cj);
			out.println("Case #" + test + ": " + answer);
		}
		
		System.err.println("time: " + (System.currentTimeMillis() - time0) + " ms.");
	}
	
	private int solve(int[] cfrom, int[] cto, int[] jfrom, int[] jto) {
		boolean[] cbusy = new boolean[24 * 60];
		for (int i = 0; i < cfrom.length; i++) {
			for (int j = cfrom[i]; j < cto[i]; j++) {
				cbusy[j] = true;
			}
		}
		boolean[] jbusy = new boolean[24 * 60];
		for (int i = 0; i < jfrom.length; i++) {
			for (int j = jfrom[i]; j < jto[i]; j++) {
				jbusy[j] = true;
			}
		}
		int inf = 2 * cfrom.length + 2 * jfrom.length + 1;
		int answer = inf;
		int[][] cans = new int[24 * 60 + 1][12 * 60 + 1];
		int[][] jans = new int[24 * 60 + 1][12 * 60 + 1];
		
		// c
		for (int i = 0; i < cans.length; i++) {
			for (int j = 0; j < cans[i].length; j++) {
				cans[i][j] = inf;
				jans[i][j] = inf;
			}
		}
		cans[0][0] = 0;
		for (int t = 0; t < 24 * 60; t++) {
			if (!cbusy[t]) {
				for (int ct = 0; ct + 1 <= 12 * 60; ct++) {
					cans[t + 1][ct + 1] = Math.min(cans[t + 1][ct + 1], cans[t][ct]);
				}
			}
			if (!cbusy[t]) {
				for (int ct = 0; ct + 1 <= 12 * 60; ct++) {
					cans[t + 1][ct + 1] = Math.min(cans[t + 1][ct + 1], jans[t][ct] + 1);
				}
			}
			if (!jbusy[t]) {
				for (int ct = 0; ct <= 12 * 60; ct++) {
					jans[t + 1][ct] = Math.min(jans[t + 1][ct], jans[t][ct]);
				}
			}
			if (!jbusy[t]) {
				for (int ct = 0; ct <= 12 * 60; ct++) {
					jans[t + 1][ct] = Math.min(jans[t + 1][ct], cans[t][ct] + 1);
				}
			}
		}
		answer = Math.min(answer, cans[24 * 60][12 * 60]);
		answer = Math.min(answer, jans[24 * 60][12 * 60] + 1);
		
		// j
		for (int i = 0; i < cans.length; i++) {
			for (int j = 0; j < cans[i].length; j++) {
				cans[i][j] = inf;
				jans[i][j] = inf;
			}
		}
		jans[0][0] = 0;
		for (int t = 0; t < 24 * 60; t++) {
			if (!cbusy[t]) {
				for (int ct = 0; ct + 1 <= 12 * 60; ct++) {
					cans[t + 1][ct + 1] = Math.min(cans[t + 1][ct + 1], cans[t][ct]);
				}
			}
			if (!cbusy[t]) {
				for (int ct = 0; ct + 1 <= 12 * 60; ct++) {
					cans[t + 1][ct + 1] = Math.min(cans[t + 1][ct + 1], jans[t][ct] + 1);
				}
			}
			if (!jbusy[t]) {
				for (int ct = 0; ct <= 12 * 60; ct++) {
					jans[t + 1][ct] = Math.min(jans[t + 1][ct], jans[t][ct]);
				}
			}
			if (!jbusy[t]) {
				for (int ct = 0; ct <= 12 * 60; ct++) {
					jans[t + 1][ct] = Math.min(jans[t + 1][ct], cans[t][ct] + 1);
				}
			}
		}
		answer = Math.min(answer, cans[24 * 60][12 * 60] + 1);
		answer = Math.min(answer, jans[24 * 60][12 * 60]);
		
		return answer;
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}
	
	public long nextLong() throws IOException {
		return Long.parseLong(next());
	}
	
	public int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	public String next() throws IOException {
		while (!st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}
	
	@Override
	public void run() {
		try {
			solve();
			out.close();
		} catch (Throwable e) {
			throw new RuntimeException(e);
		}
	}
	
	public Solution(String name) throws IOException {
		Locale.setDefault(Locale.US);
		if (name == null) {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintStream(new BufferedOutputStream(System.out));
		} else {
			in = new BufferedReader(new InputStreamReader(new FileInputStream(name + ".in")));
			out = new PrintStream(new BufferedOutputStream(new FileOutputStream(name + ".out")));
		}
		st = new StringTokenizer("");
	}
	
	public static void main(String[] args) throws IOException {
		new Thread(new Solution(null)).start();
	}
}
