import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class Solution implements Runnable {
	
	private static final String NO_SOLUTION = "Volunteer cheated!";
	private static final String MULTIPLE_ANSWERS = "Bad magician!";
	
	private PrintWriter out;
	private BufferedReader in;
	private StringTokenizer st;
	
	private String solve(int r0, int[][] a0, int r1, int[][] a1) {
		int[] selected = new int[16];
		for (int i = 0; i < a0[r0 - 1].length; i++) {
			selected[a0[r0 - 1][i] - 1]++;
		}
		for (int i = 0; i < a1[r1 - 1].length; i++) {
			selected[a1[r1 - 1][i] - 1]++;
		}
		int cnt = 0;
		for (int i = 0; i < selected.length; i++) {
			if (selected[i] == 2) {
				cnt++;
			}
		}
		if (cnt == 0) {
			return NO_SOLUTION;
		}
		if (cnt > 1) {
			return MULTIPLE_ANSWERS;
		}
		for (int i = 0; i < selected.length; i++) {
			if (selected[i] == 2) {
				return "" + (i + 1);
			}
		}
		return null;
	}
	
	private void solve() throws IOException {
		int t = nextInt();
		for (int test = 1; test <= t; test++) {
			int r0 = nextInt();
			int[][] a0 = new int[4][4];
			for (int i = 0; i < a0.length; i++) {
				for (int j = 0; j < a0[i].length; j++) {
					a0[i][j] = nextInt();
				}
			}
			int r1 = nextInt();
			int[][] a1 = new int[4][4];
			for (int i = 0; i < a1.length; i++) {
				for (int j = 0; j < a1[i].length; j++) {
					a1[i][j] = nextInt();
				}
			}
			String answer = solve(r0, a0, r1, a1);
			out.println("Case #" + test + ": " + answer);
		}
	}
	
	@Override
	public void run() {
		try {
			solve();
		} catch (IOException e) {
			apstenu(e);
		} finally {
			out.close();
			try {
				in.close();
			} catch (IOException e) {
				apstenu(e);
			}
		}
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextString());
	}
	
	private String nextString() throws IOException {
		while (!st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	private void apstenu(Throwable t) {
		System.err.println(t);
		System.exit(239);
	}
	
	public Solution() throws IOException {
		out = new PrintWriter(new FileWriter("data.out"));
		in = new BufferedReader(new FileReader("data.in"));
		st = new StringTokenizer("");
	}
	
	public static void main(String[] args) throws IOException {
		new Thread(new Solution()).start();
	}

}
