import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;


public class Solution implements Runnable {
	
	private PrintWriter out;
	private BufferedReader in;
	private StringTokenizer st;
	
	private void solve() throws IOException {
		int t = nextInt();
		for (int test = 1; test <= t; test++) {
			int n = nextInt();
			double[] a = new double[n];
			for (int i = 0; i < n; i++) {
				a[i] = nextDouble();
			}
			double[] b = new double[n];
			for (int i = 0; i < n; i++) {
				b[i] = nextDouble();
			}
			int y = solveCheat(a, b);
			int z = solveHonest(a, b);
			out.println("Case #" + test + ": " + y + " " + z);
		}
	}
	
	private int solveHonest(double[] a, double[] b) {
		int answer = 0;
		Arrays.sort(a);
		boolean[] used = new boolean[b.length];
		for (int i = 0; i < a.length; i++) {
			int found = -1;
			for (int j = 0; j < b.length; j++) {
				if (!used[j] && a[i] < b[j]) {
					found = j;
					break;
				}
			}
			if (found == -1) {
				answer++;
				for (int j = 0; j < b.length; j++) {
					if (!used[j]) {
						found = j;
						break;
					}
				}
			}
			used[found] = true;
		}
		return answer;
	}

	private int solveCheat(double[] a, double[] b) {
		int answer = 0;
		Arrays.sort(a);
		Arrays.sort(b);
		int i = a.length - 1;
		for (int j = b.length - 1; j >= 0; j--) {
			if (a[i] > b[j]) {
				answer++;
				i--;
			}
		}
		return answer;
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (IOException e) {
			apstenu(e);
		} finally {
			out.close();
			try {
				in.close();
			} catch (IOException e) {
				apstenu(e);
			}
		}
	}
	
	private double nextDouble() throws IOException {
		return Double.parseDouble(nextString());
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextString());
	}
	
	private String nextString() throws IOException {
		while (!st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	private void apstenu(Throwable t) {
		System.err.println(t);
		System.exit(239);
	}
	
	public Solution() throws IOException {
		out = new PrintWriter(new FileWriter("data.out"));
		in = new BufferedReader(new FileReader("data.in"));
		st = new StringTokenizer("");
	}
	
	public static void main(String[] args) throws IOException {
		new Thread(new Solution()).start();
	}

}
