import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class Solution implements Runnable {
	
	private static final int INF = 1000000001;
	
	private BufferedReader in;
	private StringTokenizer st;
	private PrintWriter out;
	
	private void solve() throws IOException {
		int t = nextInt();
		for (int test = 1; test <= t; test++) {
			int n = nextInt();
			int[] a = new int[n];
			for (int i = 0; i < n; i++) {
				a[i] = nextInt();
			}
			out.println("Case #" + test + ": " + solve(n, a));
		}
	}
	
	private int solve(int n, int[] a) {
		int answer = 0;
		int left = 0;
		int right = n - 1;
		for (int i = 0; i < n; i++) {
			int mini0 = -1;
			int mina0 = INF;
			for (int j = left; j <= right; j++) {
				if (mina0 > a[j]) {
					mina0 = a[j];
					mini0 = j;
				}
			}
			int mini1 = -1;
			int mina1 = INF;
			for (int j = right; j >= left; j--) {
				if (mina1 > a[j]) {
					mina1 = a[j];
					mini1 = j;
				}
			}
			if (mini0 - left < right - mini1) {
				for (int j = mini0; j > left; j--) {
					int tmp = a[j];
					a[j] = a[j - 1];
					a[j - 1] = tmp;
					answer++;
				}
				left++;
			} else {
				for (int j = mini1; j < right; j++) {
					int tmp = a[j];
					a[j] = a[j + 1];
					a[j + 1] = tmp;
					answer++;
				}
				right--;
			}
		}
		return answer;
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	private String next() throws IOException {
		while (!st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}
	
	public Solution(String filename) {
		try {
			in = new BufferedReader(new FileReader(filename + ".in"));
			st = new StringTokenizer("");
			out = new PrintWriter(new FileWriter(filename + ".out"));
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Solution("data").run();
	}
}
