import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;

public class Solution implements Runnable {
	
	private PrintStream out;
	private BufferedReader in;
	private StringTokenizer st;
	
	public void solve() throws IOException {
		long time0 = System.currentTimeMillis();
		
		int t = nextInt();
		for (int test = 1; test <= t; test++) {
			int n = nextInt();
			int c = nextInt();
			int m = nextInt();
			int[] p = new int[m];
			int[] b = new int[m];
			for (int i = 0; i < m; i++) {
				p[i] = nextInt() - 1;
				b[i] = nextInt() - 1;
			}
			String answer = solve(n, c, m, p, b);
			out.println("Case #" + test + ": " + answer);
		}
		
		System.err.println("time: " + (System.currentTimeMillis() - time0) + " ms.");
	}
	
	private String solve(int n, int c, int m, int[] p, int[] b) {
		int[][] cnt = new int[2][n];
		for (int i = 0; i < m; i++) {
			cnt[b[i]][p[i]]++;
		}
		int rides = cnt[0][0] + cnt[1][0];
		int[] free = new int[] {cnt[1][0], cnt[0][0]};
		for (int i = 1; i < n; i++) {
			for (int j = 0; j < 2; j++) {
				int f = Math.min(free[j], cnt[j][i]);
				cnt[j][i] -= f;
				free[j] -= f;
			}
		}
		int promo = 0;
		for (int i = 1; i < n; i++) {
			for (int j = 0; j < 2; j++) {
				int f = Math.min(free[j], cnt[j][i]);
				cnt[j][i] -= f;
				free[j] -= f;
			}
			rides += cnt[0][i];
			free[1] += cnt[0][i];
			rides += cnt[1][i];
			free[0] += cnt[1][i];
		}
		int join = Math.min(free[0], free[1]);
		promo += join;
		rides -= join;
		return rides + " " + promo;
	}
	
	private void add(TreeMap<Integer, Integer> map, int a, int b) {
		if (!map.containsKey(a)) {
			map.put(a, b);
		} else {
			map.put(a, map.get(a) + b);
		}
		if (map.get(a) == 0) {
			map.remove(a);
		}
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}
	
	public long nextLong() throws IOException {
		return Long.parseLong(next());
	}
	
	public int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	public String next() throws IOException {
		while (!st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}
	
	@Override
	public void run() {
		try {
			solve();
			out.close();
		} catch (Throwable e) {
			throw new RuntimeException(e);
		}
	}
	
	public Solution(String name) throws IOException {
		Locale.setDefault(Locale.US);
		if (name == null) {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintStream(new BufferedOutputStream(System.out));
		} else {
			in = new BufferedReader(new InputStreamReader(new FileInputStream(name + ".in")));
			out = new PrintStream(new BufferedOutputStream(new FileOutputStream(name + ".out")));
		}
		st = new StringTokenizer("");
	}
	
	public static void main(String[] args) throws IOException {
		new Thread(new Solution(null)).start();
	}
}
