import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.Locale;
import java.util.StringTokenizer;

public class Solution implements Runnable {
	
	private static final String IMPOSSIBLE = "IMPOSSIBLE";
	
	private PrintStream out;
	private BufferedReader in;
	private StringTokenizer st;
	
	public void solve() throws IOException {
		long time0 = System.currentTimeMillis();
		
		int t = nextInt();
		for (int test = 1; test <= t; test++) {
			int n = nextInt();
			int r = nextInt();
			int ry = nextInt();
			int y = nextInt();
			int yb = nextInt();
			int b = nextInt();
			int rb = nextInt();
			String answer = solve(n, r, ry, y, yb, b, rb);
			if (answer != null && answer.length() != n) {
				throw new RuntimeException("Am i a stupid idiot?");
			}
			if (answer == null) {
				answer = IMPOSSIBLE;
			}
			out.println("Case #" + test + ": " + answer);
		}
		
		System.err.println("time: " + (System.currentTimeMillis() - time0) + " ms.");
	}
	
	private String solve(int n, int r, int ry, int y, int yb, int b, int rb) {
		StringBuilder buf = new StringBuilder();
		if (r + yb == n) {
			if (r != yb) {
				return null;
			} else {
				for (int i = 0; i < r; i++) {
					buf.append("RG");
				}
				return buf.toString();
			}
		}
		if (y + rb == n) {
			if (y != rb) {
				return null;
			} else {
				for (int i = 0; i < y; i++) {
					buf.append("YV");
				}
				return buf.toString();
			}
		}
		if (b + ry == n) {
			if (b != ry) {
				return null;
			} else {
				for (int i = 0; i < b; i++) {
					buf.append("BO");
				}
				return buf.toString();
			}
		}
		if (r < yb + 1) {
			return null;
		} else {
			r -= yb;
		}
		if (y < rb + 1) {
			return null;
		} else {
			y -= rb;
		}
		if (b < ry + 1) {
			return null;
		} else {
			b -= ry;
		}
		if (r > y + b) {
			return null;
		}
		if (y > r + b) {
			return null;
		}
		if (b > r + y) {
			return null;
		}
		String rbig = null;
		String rs = "R";
		if (yb > 0) {
			StringBuilder tmp = new StringBuilder();
			tmp.append("R");
			for (int i = 0; i < yb; i++) {
				tmp.append("GR");
			}
			rbig = tmp.toString();
		}
		String ybig = null;
		String ys = "Y";
		if (rb > 0) {
			StringBuilder tmp = new StringBuilder();
			tmp.append("Y");
			for (int i = 0; i < rb; i++) {
				tmp.append("VY");
			}
			ybig = tmp.toString();
		}
		String bbig = null;
		String bs = "B";
		if (ry > 0) {
			StringBuilder tmp = new StringBuilder();
			tmp.append("B");
			for (int i = 0; i < ry; i++) {
				tmp.append("OB");
			}
			bbig = tmp.toString();
		}
		if (y > r) {
			String tmp = rbig;
			rbig = ybig;
			ybig = tmp;
			tmp = rs;
			rs = ys;
			ys = tmp;
			int itmp = r;
			r = y;
			y = itmp;
		}
		if (b > r) {
			String tmp = rbig;
			rbig = bbig;
			bbig = tmp;
			tmp = rs;
			rs = bs;
			bs = tmp;
			int itmp = r;
			r = b;
			b = itmp;
		}
		for (int i = 0; i < r; i++) {
			if (rbig != null) {
				buf.append(rbig);
				rbig = null;
			} else {
				buf.append(rs);
			}
			if (i < y) {
				if (ybig != null) {
					buf.append(ybig);
					ybig = null;
				} else {
					buf.append(ys);
				}
			}
			if (r - 1 - i < b) {
				if (bbig != null) {
					buf.append(bbig);
					bbig = null;
				} else {
					buf.append(bs);
				}
			}
		}
		return buf.toString();
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}
	
	public long nextLong() throws IOException {
		return Long.parseLong(next());
	}
	
	public int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	public String next() throws IOException {
		while (!st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}
	
	@Override
	public void run() {
		try {
			solve();
			out.close();
		} catch (Throwable e) {
			throw new RuntimeException(e);
		}
	}
	
	public Solution(String name) throws IOException {
		Locale.setDefault(Locale.US);
		if (name == null) {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintStream(new BufferedOutputStream(System.out));
		} else {
			in = new BufferedReader(new InputStreamReader(new FileInputStream(name + ".in")));
			out = new PrintStream(new BufferedOutputStream(new FileOutputStream(name + ".out")));
		}
		st = new StringTokenizer("");
	}
	
	public static void main(String[] args) throws IOException {
		new Thread(new Solution(null)).start();
	}
}
