import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;

public class Solution implements Runnable {
	
	private static final String[] encoded = {
		"ejp mysljylc kd kxveddknmc re jsicpdrysi",
		"rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd",
		"de kr kd eoya kw aej tysr re ujdr lkgc jv",
		"qz"
	};
	private static final String[] decoded = {
		"our language is impossible to understand",
		"there are twenty six factorial possibilities",
		"so it is okay if you want to just give up",
		"zq"
	};
	
	private BufferedReader in;
	private PrintWriter out;
	
	private void solve() throws NumberFormatException, IOException {
		char[] code = new char['z' - 'a' + 1];
		for (int i = 0; i < encoded.length; i++) {
			fillCode(code, encoded[i], decoded[i]);
		}
		int t = Integer.parseInt(in.readLine());
		for (int test = 1; test <= t; test++) {
			String input = in.readLine();
			String output = convert(input, code);
			out.println("Case #" + test + ": " + output);
		}
	}
	
	private String convert(String input, char[] code) {
		StringBuilder buf = new StringBuilder();
		for (int i = 0; i < input.length(); i++) {
			char c = input.charAt(i);
			if ('a' <= c && c <= 'z') {
				buf.append(code[c - 'a']);
			} else {
				buf.append(c);
			}
		}
		return buf.toString();
	}

	private void fillCode(char[] code, String from, String to) {
		for (int i = 0; i < from.length(); i++) {
			char f = from.charAt(i);
			char t = to.charAt(i);
			if ('a' <= f && f <= 'z') {
				code[f - 'a'] = t;
			}
		}
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Throwable e) {
			apstenu(e);
		} finally {
			out.close();
		}
	}
	
	private void apstenu(Throwable e) {
		e.printStackTrace();
		System.exit(1);
	}
	
	public Solution(String filename) {
		try {
			in = new BufferedReader(new FileReader(filename + ".in"));
			out = new PrintWriter(new FileWriter(filename + ".out"));
		} catch (IOException e) {
			apstenu(e);
		}
	}
	
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Solution("data").run();
	}
	
}
