import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class Solution implements Runnable {
	
	private PrintWriter out;
	private BufferedReader in;
	private StringTokenizer st;
	
	private double solve(double c, double f, double x) {
		double mm = Math.max(x / c - 2 / f, 0);
		int m0 = (int) Math.floor(mm);
		int m1 = (int) Math.ceil(mm);
		double c0 = cost(m0, c, f, x);
		double c1 = cost(m1, c, f, x);
		return Math.min(c0, c1);
	}
	
	private double cost(int m, double c, double f, double x) {
		double time = 0;
		for (int i = 0; i < m; i++) {
			time += c / (2 + i * f);
		}
		time += x / (2 + m * f);
		return time;
	}

	private void solve() throws IOException {
		int t = nextInt();
		for (int test = 1; test <= t; test++) {
			double c = nextDouble();
			double f = nextDouble();
			double x = nextDouble();
			double answer = solve(c, f, x);
			out.println("Case #" + test + ": " + answer);
		}
	}
	
	@Override
	public void run() {
		try {
			solve();
		} catch (IOException e) {
			apstenu(e);
		} finally {
			out.close();
			try {
				in.close();
			} catch (IOException e) {
				apstenu(e);
			}
		}
	}
	
	private double nextDouble() throws IOException {
		return Double.parseDouble(nextString());
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextString());
	}
	
	private String nextString() throws IOException {
		while (!st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	private void apstenu(Throwable t) {
		System.err.println(t);
		System.exit(239);
	}
	
	public Solution() throws IOException {
		out = new PrintWriter(new FileWriter("data.out"));
		in = new BufferedReader(new FileReader("data.in"));
		st = new StringTokenizer("");
	}
	
	public static void main(String[] args) throws IOException {
		new Thread(new Solution()).start();
	}

}
