import java.io.*;
import java.util.*;

/**
 * @author Mikhail Dvorkin
 */
public class B implements Runnable {
	private Scanner in;
	private PrintWriter out;
	
	class Event implements Comparable<Event> {
		int da, db, time;

		public Event(int da, int db, int time) {
			this.da = da;
			this.db = db;
			this.time = time;
		}

		public int compareTo(Event that) {
			return time - that.time;
		}
	}
	
	private int readTime() {
		String s = in.next();
		int a = s.charAt(0) - '0';
		int b = s.charAt(1) - '0';
		int c = s.charAt(3) - '0';
		int d = s.charAt(4) - '0';
		return (10 * a + b) * 60 + 10 * c + d;
	}

	private void solve(int testCase) {
		int t = in.nextInt();
		int na = in.nextInt();
		int nb = in.nextInt();
		List<Event> events = new ArrayList<Event>();
		for (int i = 0; i < na + nb; i++) {
			int t1 = 2 * readTime() + 1;
			int t2 = 2 * (readTime() + t);
			if (i < na) {
				events.add(new Event(-1, 0, t1));
				events.add(new Event(0, 1, t2));
			} else {
				events.add(new Event(0, -1, t1));
				events.add(new Event(1, 0, t2));
			}
		}
		Collections.sort(events);
		int initA = 0;
		int initB = 0;
		int curA = 0;
		int curB = 0;
		for (Event event : events) {
			if (event.da > 0) curA++;
			if (event.db > 0) curB++;
			if (event.da < 0) {
				if (curA > 0)
					curA--;
				else
					initA++;
			}
			if (event.db < 0) {
				if (curB > 0)
					curB--;
				else
					initB++;
			}
		}
		out.println("Case #" + testCase + ": " + initA + " " + initB);
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new Thread(new B()).start();
	}

	public void run() {
		try {
			in = new Scanner(new FileReader("b.in"));
			out = new PrintWriter("b.out");
			int n = in.nextInt();
			for (int i = 1; i <= n; i++)
				solve(i);
			in.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
