package round1.first;

import java.io.IOException;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import practice.DaRosIO;

public class First
{
	private DaRosIO io = new DaRosIO();

	public static void main(String[] args)
	{
		try
		{
			new First().run();
		} catch (IOException e)
		{
			e.printStackTrace();
		}
	}

	private List<String> outputLines = new LinkedList<String>();
	private Map<String, Integer> nextOccurMap = new HashMap<String, Integer>();

	private void run() throws IOException
	{
		List<String> lines = io.readInput("search_sm3");

		int numInputs = Integer.parseInt(lines.get(0));
		
//		if (numInputs + 1 != lines.size())
//		{
//			System.out.println("ERROR! N = " + numInputs + "   Lines = " + lines.size());
//			return;
//		}
		
		int lastInputStart = 0;
		for (int i = 0; i < numInputs; i++)
		{
			int numEngines = Integer.parseInt(lines.get(lastInputStart + 1));
			int numQueries = Integer.parseInt(lines.get(lastInputStart + 2 + numEngines));
			
			String[] engines = new String[numEngines];
			for (int j = 0; j < numEngines; j++)
			{
				engines[j] = lines.get(lastInputStart + 2 + j);
			}
			
			String[] queries = new String[numQueries];
			for (int j = 0; j < numQueries; j++)
			{
				queries[j] = lines.get(lastInputStart + 2 + numEngines + 1 + j);
			}
			
			lastInputStart += (2 + numEngines + numQueries);
			
			nextOccurMap.clear();
			if (queries.length > 0)
				nextOccurMap.put(queries[0], new Integer(0));
			
			int numSwitches = 0;
			for (int j = 0; j < numQueries; j++)
			{
				int pos = findOcurr(engines, queries[j]);
				if (pos < 0)
					continue;
				
				String engName = engines[pos];
				Integer nextOccurPos = nextOccurMap.get(engName);
				if (nextOccurPos != null)
					continue;
				
				nextOccurMap.put(engName, new Integer(pos));
				
				if (nextOccurMap.size() == numEngines)
				{
					numSwitches++;
					nextOccurMap.clear();
					nextOccurMap.put(engName, new Integer(pos));
				}
			}
			
			outputLines.add("Case #" + (i+1) + ": " + numSwitches + " \n");
		}
		
		io.buildOutput("search_sm3", outputLines);
	}

	private int findOcurr(String[] engines, String query)
	{
		for (int i = 0; i < engines.length; i++)
		{
			if (engines[i].equals(query))
				return i;
		}
		
		return -1;
	}

}
