package round1a.prob1;

import java.io.IOException;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;

import practice.DaRosIO;

public class Prob1
{
	private static final String FILENAME = "prob1_sm";
	
	private DaRosIO io = new DaRosIO();

	public static void main(String[] args)
	{
		try
		{
			new Prob1().run();
		} catch (IOException e)
		{
			e.printStackTrace();
		}
	}

	private List<String> outputLines = new LinkedList<String>();

	private void run() throws IOException
	{
		List<String> lines = io.readInput(FILENAME);

		int numInputs = Integer.parseInt(lines.get(0));
		
		int inputStart = 1;
		for (int i = 0; i < numInputs; i++)
		{
			int size = Integer.parseInt(lines.get(inputStart));

			String[] vecXString = lines.get(inputStart + 1).split(" ");
			String[] vecYString= lines.get(inputStart + 2).split(" ");
			inputStart += 3;

			int[] vecX = new int[size];
			int[] vecY = new int[size];
			boolean[] usedY = new boolean[size];
			
			for (int j = 0; j < size; j++)
			{
				vecX[j] = Integer.parseInt(vecXString[j]);
				vecY[j] = Integer.parseInt(vecYString[j]);
				usedY[j] = false;
			}
			
			Arrays.sort(vecX);
			Arrays.sort(vecY);
			
			int productValue = 0;
			
			int sizeNeg = 0;
			for (int j = 0; j < size; j++)
			{
				if (vecX[j] < 0)
					sizeNeg++;
				else
					break;
			}
			
			for (int j = 0; j < sizeNeg; j++)
			{
				int greater = greaterIndex(vecY, usedY);
				productValue += vecX[j]*vecY[greater];
				
				usedY[greater] = true;
			}
			
			for (int j = size - 1; j >= sizeNeg; j--)
			{
				int smaller = greaterNeg(vecY, usedY);
				productValue += vecX[j]*vecY[smaller];
				
				usedY[smaller] = true;
			}
			
			outputLines.add("Case #" + (i+1) + ": " + productValue + "\n");
		}
		
		io.buildOutput(outputLines);
	}

	private int greaterIndex(int[] vec, boolean[] used)
	{
		for (int i = vec.length - 1; i >= 0; i--)
		{
			if (used[i] == true)
				continue;

			return i;
		}

		System.out.println("ERROR!");
		return -1;
	}
	
	private int greaterNeg(int[] vec, boolean[] used)
	{
		for (int i = 0; i < vec.length; i++)
		{
			if (used[i] == true)
				continue;

			return i;
		}

		System.out.println("ERROR!");
		return -1;
	}

}
