package round1a.prob2;

import java.io.IOException;
import java.util.LinkedList;
import java.util.List;

import practice.DaRosIO;

public class Milk
{
	private static final String FILENAME = "milk_sm4";
	
	private DaRosIO io = new DaRosIO();

	public static void main(String[] args)
	{
		try
		{
			new Milk().run();
		} catch (IOException e)
		{
			e.printStackTrace();
		}
	}

	private List<String> outputLines = new LinkedList<String>();

	private void run() throws IOException
	{
		List<String> lines = io.readInput(FILENAME);

		int numInputs = Integer.parseInt(lines.get(0));
		
		int inputStart = 1;
		for (int i = 0; i < numInputs; i++)
		{
			int numFlavors = Integer.parseInt(lines.get(inputStart++));
			int numClients = Integer.parseInt(lines.get(inputStart++));

			Client[] client = new Client[numClients];
			
			for (int j = 0; j < numClients; j++)
			{
				String[] clientString = lines.get(inputStart++).split(" ");
				
				int numOrders = Integer.parseInt(clientString[0]);
				
				client[j] = new Client(numOrders);
				
				for (int k = 0; k < numOrders; k++)
				{
					int flavor = Integer.parseInt(clientString[1 + 2*k + 0]);
					int isMalted = Integer.parseInt(clientString[1 + 2*k + 1]);
					
					client[j].setFlavor(k, flavor);
					client[j].setMalted(k, isMalted);
				}
			}
			
			int currentAnswer[] = new int[numFlavors];
			for (int j = 0; j < numFlavors; j++)
			{
				currentAnswer[j] = 0;
			}
			
			int smallerAnswer = 999;
			String answer = null;
			for (int binAnswer = 0; binAnswer < 2049; binAnswer++)
			{
				for (int j = 0; j < numFlavors; j++)
				{
					int val = (binAnswer & (2 << j));
					if (val > 0)
						currentAnswer[j] = 1;
					else
						currentAnswer[j] = 0;
				}
				
				boolean sats = true;
				for (Client c : client)
				{
					if (c.isSatisfied(currentAnswer, numFlavors) == false)
					{
						sats = false;
						break;
					}
				}
				
				if (sats)
				{
					int answSize = 0;
					for (int j = 0; j < numFlavors; j++)
					{
						if (((2 << j) & binAnswer) > 0)
							answSize++;
					}
					
					if (answSize < smallerAnswer)
					{
						smallerAnswer = answSize;
						
						answer = "";
						
						for (int j = 0; j < numFlavors; j++)
						{
							answer += Integer.toString(currentAnswer[j]);
							if (j < numFlavors - 1)
								answer += " ";
						}
					}
				}
			}
			
			if (smallerAnswer == 999)
				answer = "IMPOSSIBLE";
			
//			for (Client c : client)
//			{
//				if (c.isSatisfied(currentAnswer) == false)
//				{
//					answer = "IMPOSSIBLE";
//					break;
//				}
//			}
//			
//			if (answer == null)
//			{
//				answer = "";
//				
//				for (int j = 0; j < numFlavors; j++)
//				{
//					answer += Integer.toString(currentAnswer[j]);
//					if (j < numFlavors - 1)
//						answer += " ";
//				}
//			}
			
			outputLines.add("Case #" + (i+1) + ": " + answer + "\n");
		}
		
		io.buildOutput(outputLines);
	}

	private int wantsMalted(Client[] clients, int flavorNum)
	{
		for (Client c : clients)
		{
			if (c.wantsMalted(flavorNum))
				return 1;
		}
		
		return 0;
	}

}
