package round1a.prob2;

public class Client
{
	private int flavors[];
	private boolean malted[];
	private final int numOrders;

	public Client(int numOrders)
	{
		this.numOrders = numOrders;
		
		flavors = new int[numOrders];
		malted = new boolean[numOrders];
	}

	public int getFlavor(int i)
	{
		return flavors[i];
	}

	public void setFlavor(int i, int flv)
	{
		this.flavors[i] = flv;
	}

	public boolean getMalted(int i)
	{
		return malted[i];
	}

	public void setMalted(int i, int malted)
	{
		this.malted[i] = (malted == 1);
	}

	public boolean wantsMalted(int flavorNum)
	{
		for (int i = 0; i < numOrders; i++)
		{
			if (flavors[i] == flavorNum)
				return (malted[i]);
		}
		
		return false;
	}

	public boolean isSatisfied(int[] order, int numFlavors)
	{
		for (int i = 0; i < numOrders; i++)
		{
			for (int j = 0; j < numFlavors; j++)
			{
				if (flavors[i] == (j+1))
				{
					boolean x = (order[j] == 1);
					if (malted[i] == x)
						return true;
				}
			}
		}
		
		return false;
	}


}
