package round2;

import java.io.IOException;
import java.util.LinkedList;
import java.util.List;

import practice.DaRosIO;

public class Triangs
{
	private static final String FILENAME = "trian_sm";

	private DaRosIO io = new DaRosIO();

	public static void main(String[] args)
	{
		try
		{
			new Triangs().run();
		} catch (IOException e)
		{
			e.printStackTrace();
		}
	}

	private List<String> outputLines = new LinkedList<String>();

	private void run() throws IOException
	{
		List<String> lines = io.readInput(FILENAME);

		int numInputs = Integer.parseInt(lines.get(0));

		for (int lineNum = 0; lineNum < numInputs; lineNum++)
		{
			String[] infos = lines.get(lineNum + 1).split(" ");

			int N = Integer.parseInt(infos[0]);
			int M = Integer.parseInt(infos[1]);
			int A = Integer.parseInt(infos[2]);

			int x[] = new int[3];
			int y[] = new int[3];
			
			int ansX[] = new int[3];
			int ansY[] = new int[3];

			x[0] = 0;
			y[0] = 0;

			boolean found = false;
			
			for (x[1] = 0; x[1] <= N && !found; x[1]++)
			{
				for (y[1] = 0; y[1] <= M && !found; y[1]++)
				{
					for (x[2] = 0; x[2] <= N && !found; x[2]++)
					{
						for (y[2] = 0; y[2] <= M && !found; y[2]++)
						{
							found = calcArea(A, x, y);
							
							if (found)
							{
								ansX[0] = x[0];
								ansY[0] = y[0];
								ansX[1] = x[1];
								ansY[1] = y[1];
								ansX[2] = x[2];
								ansY[2] = y[2];
							}
						}
					}
				}
			}
			
			String answer;
			if (!found)
			{
				answer = "IMPOSSIBLE";
			}
			else
			{
				answer = ansX[0] + " " + ansY[0] + " " + ansX[1] + " " + ansY[1] + " " + ansX[2] + " " + ansY[2] + " ";  
			}

			outputLines.add("Case #" + (lineNum + 1) + ": " + answer + "\n");
		}

		io.buildOutput(outputLines);
	}

	private boolean calcArea(int A, int[] x, int[] y)
	{
		int value = Math.abs((x[1]*y[0]-x[0]*y[1])+(x[2]*y[1]-x[1]*y[2])+(x[0]*y[2]-x[2]*y[0]));
		
		return (value == A);
	}

}
