package codejam;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;

public class Deceitful {
	
	public static ArrayList<Double> warNaomi = new ArrayList<Double>();
	public static ArrayList<Double> warKen = new ArrayList<Double>();
	public static ArrayList<Double> deceitfulWarNaomi = new ArrayList<Double>();
	public static ArrayList<Double> deceitfulWarKen = new ArrayList<Double>();

	public static void main(String[] args){
		
		Scanner in = null;
		try {
			in = new Scanner(new FileReader("input.in"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
		int numTestCases = Integer.parseInt(in.nextLine());
		for(int i = 1; i <= numTestCases; i++) {
			int numBlocks = in.nextInt();
			in.nextLine();
			for(int j = 1; j <= numBlocks; j++){
				double d = in.nextDouble();
				warNaomi.add(d);
				deceitfulWarNaomi.add(d);
			}
			in.nextLine();
			for(int j = 1; j <= numBlocks; j++){
				double d = in.nextDouble();
				warKen.add(d);
				deceitfulWarKen.add(d);
			}
			System.out.printf("\nCase #%d: %d %d", i, deceitfulWar(), war());
		}	
	}
	
	public static int war()
	{
		int kenPoints = 0;
		int naomiPoints = 0;
		
		Collections.sort(warNaomi);
		Collections.sort(warKen);
		
		while(warNaomi.size() > 0)
		{
			double chosenNaomi = warNaomi.remove(warNaomi.size()-1);
			double chosenKen = chooseWarKen(chosenNaomi);
			if(chosenKen > chosenNaomi)
				kenPoints++;
			else
				naomiPoints++;
		}
		return naomiPoints;
	}
	
	public static double chooseWarKen(double chosenNaomi)
	{
		int chosen = 0;
		for(int i = 0; i < 	warKen.size(); i++)
		{
			if (warKen.get(i) > chosenNaomi)
			{
				chosen = i;
				break;
			}
		}	
		return warKen.remove(chosen);
	}
	
	public static int deceitfulWar()
	{
		int kenPoints = 0;
		int naomiPoints = 0;
		
		Collections.sort(deceitfulWarNaomi);
		Collections.sort(deceitfulWarKen);
		
		while(deceitfulWarNaomi.size() > 0)
		{
			double chosenNaomi = deceitfulWarNaomi.get(deceitfulWarNaomi.size()-1);			
			if(hasGreater(chosenNaomi))
				chosenNaomi = deceitfulWarNaomi.remove(0);
			else
				chosenNaomi = deceitfulWarNaomi.remove(deceitfulWarNaomi.size()-1);
			double chosenKen = deceitfulWarKen.get(chooseDeceitfulWarKen(chosenNaomi));	
			double toldNaomi = deceitfulWarKen.get(deceitfulWarKen.size()-1) - 0.000001;
			chosenKen = deceitfulWarKen.remove(chooseDeceitfulWarKen(toldNaomi));
			if(chosenKen > chosenNaomi)
				kenPoints++;
			else
				naomiPoints++;
		}
		return naomiPoints;
	}
	
	public static int chooseDeceitfulWarKen(double chosenNaomi)
	{
		int chosen = 0;
		for(int i = 0; i < 	deceitfulWarKen.size(); i++)
		{
			if (deceitfulWarKen.get(i) > chosenNaomi)
			{
				chosen = i;
				break;
			}
		}	
		return chosen;
	}
	
	public static boolean hasGreater(double chosenNaomi)
	{
		for(int i = 0; i < 	deceitfulWarKen.size(); i++)
		{
			if (deceitfulWarKen.get(i) > chosenNaomi)
			{
				return true;
			}
		}	
		return false;
	}
}
