import java.math.BigInteger;
import edu.princeton.cs.algs4.StdIn;
import edu.princeton.cs.algs4.StdOut;
import edu.princeton.cs.algs4.StdRandom;

public class Coinjam {
    private static int N = 16;
    private static int J = 50;

    private static String getRandomJamcoin() {
        String jamcoin = "1";
        for (int i = 0; i < N-2; i++) jamcoin += StdRandom.uniform(2);
        jamcoin += "1";
        return jamcoin;
    }

    private static BigInteger getValue(String jamcoin, String base) {
        BigInteger b = new BigInteger(base);
        BigInteger number = new BigInteger("1");
        BigInteger power = new BigInteger("1");
        for (int i = N-2; i >= 0; i--) {
            power = power.multiply(b);
            if (jamcoin.charAt(i) == '1')
                number = number.add(power);
        }
        return number;
    }

    private static boolean mayNotBeJamcoin(String jamcoin) {
        BigInteger value;
        for (int b = 2; b <=10; b++) {
            value = getValue(jamcoin, Integer.toString(b));
            if (value.isProbablePrime(1))  return true;
        }
        return false;
    }

    private static void outputJamcoin(String jamcoin) {
        StdOut.print(jamcoin);
        for (int b = 2; b <=10; b++) {
            BigInteger number = getValue(jamcoin, Integer.toString(b));
            outputDivisor(number);
        }
        StdOut.println();
    }

    private static void outputDivisor(BigInteger number) {
        BigInteger d = new BigInteger("2");
        while (true) {
            BigInteger[] result = number.divideAndRemainder(d);
            if (number.remainder(d).equals(BigInteger.ZERO)) {
                StdOut.print(" " + d);
                return;
            }
            d = d.add(BigInteger.ONE);
        }
    }

    public static void main(String[] args) {
        StdOut.println("Case #1:");
        for (int j = 0; j < J; j++) {
            String jamcoin = getRandomJamcoin();
            while (mayNotBeJamcoin(jamcoin)) jamcoin = getRandomJamcoin();
            outputJamcoin(jamcoin);
        }
    }
}
