package gcj.a;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;

public class TestCase {
	private static AtomicInteger lastCaseNumber = new AtomicInteger(0);
	
	public TestCase() {
		this.caseNumber = lastCaseNumber.incrementAndGet();
	}
	
	private List<String> selectedCards = null;
	private int caseNumber;

	/**
	 * Print a precisely formatted result message
	 */
	public void printResult() {
		String message="";
		if (selectedCards!=null) {
			if (selectedCards.size()==1) {
				message=selectedCards.get(0);
			} else if (selectedCards.isEmpty()) {
				message="Volunteer cheated!";
			} else {
				message="Bad magician!";
			}
		} else {
			message="Bad programmer!";
		}
		StringBuilder builder = new StringBuilder();
		builder.append("Case #");
		builder.append(caseNumber);
		builder.append(": ");
		builder.append(message);
		System.out.println(builder.toString());
	}
	
	/**
	 * Record the row of cards selected by the user
	 * @param cards
	 */
	public void addSelection(List<String> cards) {
		if (selectedCards==null) {
			selectedCards=new ArrayList<String>();
			selectedCards.addAll(cards);
		}
		else
			selectedCards.retainAll(cards);
	}
}
