package gcj;

import java.io.BufferedWriter;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.MathContext;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;

public class TestCase {
	private static AtomicInteger lastCaseNumber = new AtomicInteger(0);
	public static int LINES_PER_TEST = 1;

	private PrintWriter writer = null;
	private int caseNumber;
	
	int count;
	String[] values;

	public TestCase() {
		this.caseNumber = lastCaseNumber.incrementAndGet();
	}
	
	public TestCase(BufferedWriter writer) {
		this();
		this.writer  = new PrintWriter(writer);
	}


	/**
	 * Print a precisely formatted result message
	 */
	public void printResult(Integer count) {
		String message = "";
		
		writer.print("Case #");
		writer.print(caseNumber);
		writer.print(": ");
		writer.println(count.toString());
	}

	private void solve(int[] values) {
		int count = 0;
		int a = values[0];
		int b = values[1];
		int k = values[2];
		for (int i=0; i<a; i++) {
			for (int j=0; j<b; j++) {
				int and = i&j;
//				System.out.println(""+i+"&"+j+"="+and);
				if (and<k) {
					count++;
				}
			}
		}
		System.out.println("for "+a+","+b+": "+count+" combinations");
		printResult(count);
	}
	
	public void process(String[] input) {
		if (input.length != LINES_PER_TEST)
			throw new Error("Invalid Input");
		
		String[] intStrings = input[0].split(" ");
		final int length = intStrings.length;
		int[] ints = new int[length];
		for (int i=0; i<length; i++) {
			ints[i]=Integer.parseInt(intStrings[i]);
		}
		
		
		solve(ints);
	}
}
