package gcj.a;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.List;

public class MagicTrick {

	public static void main(String[] args) {
		MagicTrick trick = new MagicTrick();
		trick.processFile("inputs.txt");
	}

	/**
	 * Process an input file
	 * @param fileName
	 */
	private void processFile(String fileName)  {
		InputStream in = this.getClass().getClassLoader().getResourceAsStream(fileName);
		BufferedReader reader = new BufferedReader(new InputStreamReader(in));
		try {
			final int testCount = getInt(reader);
			for (int test = 0; test < testCount; test++) {
				TestCase testCase = new TestCase();
				for (int round = 0; round < 2; round++) {
					int choice = getInt(reader);
					List<String> cards = getCards(choice, reader);

					testCase.addSelection(cards);
				}
				testCase.printResult();
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {
				if (reader!=null) reader.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	/**
	 * Read the next set of lines, but parse and return only the row selected by the user
	 * @param choice - which row was selected
	 * @param reader - file reader
	 * @return a list of cards in the chosen row
	 * @throws IOException
	 */
	private List<String> getCards(int choice, BufferedReader reader) throws IOException {
		List<String> result = null;
		for (int i = 0; i < 4; i++) {
			String line = reader.readLine();
			if (line==null)
				throw new IOException("Unexpected end of file");
			if (choice-1 == i) {
				result = Arrays.asList(line.split(" "));
			}
		}
		return result;
	}

	/**
	 * Read and parse the next line, which is expected to contain a single integer
	 * @param reader
	 * @return single integer contained on the line
	 * @throws IOException 
	 */
	private int getInt(BufferedReader reader) throws IOException {
		String line = reader.readLine();
		if (line == null)
			throw new IOException("Unexpected end of file");
		int result = Integer.parseInt(line);
		return result;
	}
	
	

}
