/// uses http://introcs.cs.princeton.edu/java/stdlib/javadoc/StdIn.html
import java.util.*;
public class Trie {
    static class Node {
        int count;
        long coverages = -1;
        Node[] kids = new Node[27];
        String S;
        int worst() {
            int result = Math.min(count, n);
            for (int i=1; i<27; i++) if (kids[i] != null)
                result += kids[i].worst();
            return result;
        }
        long coverages() {
            //System.out.println("?"+S+" "+count);
            if (coverages != -1) return coverages;
            if (count < n) return 0;
            if (count == n) return fact[n];
            int[] k = new int[27];
            for (int i=0; i<27; i++) if (kids[i] != null) k[i] = kids[i].count;
            boolean hasn = false;
            for (int i=0; i<27; i++) if (k[i] >= n) hasn = true;
           // System.out.println(Arrays.toString(k));
            long result = 1;
            if (hasn) {
                for (int i=0; i<27; i++) {
                    if (k[i] >= n) result *= kids[i].coverages();
                    else result *= ntake[k[i]];
                    result %= MOD;
                }
            }
            else result = foo(k);
            //System.out.println("$"+S+" "+result+"!");
            coverages = result;
            return coverages;
        }
    }    
    
    static int n;
    static long MOD = 1_000_000_007;
    static long[] ntake;
    static long[] fact;
    static long[][] choose;
    static void make() {
        ntake = new long[n+1];
        ntake[0] = 1;
        for (int i=1; i<=n; i++) {
            ntake[i] = ntake[i-1]*(n+1-i);
            ntake[i] %= MOD;
        }
        choose = new long[n+1][n+1];
        choose[0][0]=1;
        for (int i=1; i<=n; i++) {
            for (int j=0; j<=n; j++) {
                choose[i][j] = choose[i-1][j];
                if (j>0) choose[i][j] += choose[i-1][j-1];
                choose[i][j] %= MOD;
            }
        }
        fact = new long[n+1];
        fact[0] = 1;
        for (int i=1; i<=n; i++) fact[i] = (i*fact[i-1])%MOD;
        //System.out.println(Arrays.toString(ntake));
        //System.out.println(Arrays.toString(fact));
        //System.out.println(Arrays.deepToString(choose));
    }
    
    static long foo(int[] v) {
        long[][] dp = new long[28][n+1];
        dp[0][0] = 1;
        for (int i=0; i<27; i++) {
            for (int j=0; j<=n; j++) {
                for (int k=0; k<=n; k++) {
                    if (k<j) continue;
                    if (k<v[i]) continue;
                    if (k>j+v[i]) continue;
                    long tmp = choose[n-j][k-j];
                    tmp *= choose[j][v[i]-k+j];
                    tmp %= MOD;
                    tmp *= fact[v[i]];
                    tmp %= MOD;
                    tmp *= dp[i][j];
                    tmp %= MOD;
                    dp[i+1][k] += tmp;
                    dp[i+1][k] %= MOD;
                }
            }
        }
        return dp[27][n]; 
    }
        
    public static void main(String[] args) {
        int t = StdIn.readInt();
        for (int T=1; T<=t; T++) {
            System.out.print("Case #"+T+": ");
            int m = StdIn.readInt();
            n = StdIn.readInt();
            make();
            String[] text = new String[m];
            Node root = new Node();
            root.S = "";
            for (int i=0; i<m; i++) {
                text[i] = StdIn.readString()+"@";
                Node nd = root;
                for (int p=0; p<text[i].length(); p++) {
                    nd.count++;
                    if (nd.kids[text[i].charAt(p)-'@']==null) {
                        nd.kids[text[i].charAt(p)-'@'] = new Node();
                        nd.kids[text[i].charAt(p)-'@'].S = text[i].substring(0, p+1);
                    }
                    nd = nd.kids[text[i].charAt(p)-'@'];
                }
            }
            int x = root.worst();
            System.out.print(x+" ");
            if (root.count <= n) {
                System.out.println(ntake[root.count]);
            }
            else
                System.out.println(root.coverages());
        }
    }
}
            