package round1b;

import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

public class B {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws java.io.IOException {
//		final String inputFile = "input/B-sample.txt";
//		final String outputFile = "output/B-sample-out.txt";
//		 final String inputFile = "input/B-small-attempt1.in";
//		 final String outputFile = "output/B-small-out.txt";
		 final String inputFile = "input/B-large.in";
		 final String outputFile = "output/B-large-out.txt";

		final Scanner scanner = new Scanner(new File(inputFile));
		final PrintWriter writer = new PrintWriter(outputFile);

		final int numCases = scanner.nextInt();
		System.out.println(String.format("There are %d cases", numCases));
		scanner.nextLine();

		for (int caseNum = 1; caseNum <= numCases; caseNum++) {
			String number = scanner.nextLine();
			System.out.println(number);

			String answer = nextNumber(number);

			System.out.println(String.format("Case #%d: %s", caseNum, answer));
			writer.println(String.format("Case #%d: %s", caseNum, answer));
		}

		writer.flush();
		writer.close();
	}

	public static String nextNumber(String number) {
		int[] digits = new int[10];
		int currentDigit = 9;
		int smallestDigit = 9;
		boolean descending = true;
		int pivot = 0;
		for (int pos = 0; pos < number.length(); pos++) {
			int digit = number.charAt(pos) - '0';
			digits[digit]++;
			if (digit > currentDigit) {
				pivot = pos - 1;
				descending = false;
			}
			if (digit < smallestDigit && digit > 0) {
				smallestDigit = digit;
			}
			currentDigit = digit;
		}
		if (descending) {
			return String.format("%d%s", smallestDigit, smallest(number.replaceFirst(Integer.toString(smallestDigit), ""), 0));
		}
		String first = number.substring(0, pivot);
		String last = number.substring(pivot + 1);
		int pivotDigit = number.charAt(pivot) - '0';
		return String.format("%s%s", first, replaceFirstBiggerThan(last, pivotDigit));
	}

	/**
	 * @param number
	 *            the number to permute
	 * @param extra
	 *            the extra digit to add to the list
	 * @return the smallest number which is a permutation of the digits of the
	 *         given number and the given extra digit
	 */
	public static String smallest(String number, int extra) {
		int[] digits = new int[10];
		for (int pos = 0; pos < number.length(); pos++) {
			int digit = number.charAt(pos) - '0';
			digits[digit]++;
		}
		digits[extra]++;
		StringBuilder builder = new StringBuilder();
		for (int i = 0; i <= 9; i++) {
			for (int j = 0; j < digits[i]; j++) {
				builder.append(i);
			}
		}
		return builder.toString();
	}

	public static String replaceFirstBiggerThan(String number, int pivot) {
		for (int digit = pivot + 1; digit <= 9; digit++) {
			String digitString = Integer.toString(digit);
			if (number.indexOf(digitString) >= 0) {
				return digitString + smallest(number.replaceFirst(digitString, ""), pivot);
			}
		}
		throw new IllegalArgumentException(String.format("%s did not contain a digit greater than %d", number, pivot));
	}
}
