package codejam09.qualification.welcome;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

public class Welcome {

    /**
     * @param args
     */
    public static void main(String[] args) throws IOException {
	final BufferedReader reader = new BufferedReader(new FileReader("input/C-large.in"));
	final PrintWriter writer = new PrintWriter("output/C-large-out.txt");
	final int numCases = Integer.parseInt(reader.readLine());
	System.out.println(String.format("There are %d cases", numCases));
	final String target = "welcome to code jam";
	for (int i = 1; i <= numCases; i++) {
	    final String line = reader.readLine();
	    System.out.println(line);
	    int result = countMatches(target, line);
	    System.out.println(String.format("Case #%d: %04d", i, result));
	    writer.println(String.format("Case #%d: %04d", i, result));
	}
	writer.flush();
	writer.close();

    }
    
    private static int countMatches(final String target, final String source) {
	int len = target.length();
	if (len == 0) {
	    return 1;
	}
	if (len == 1) {
	    return count(target.charAt(0), source);
	}
	int midpoint = len/2;
	char midchar = target.charAt(midpoint);
	String first = target.substring(0, midpoint);
	String last = target.substring(midpoint + 1);
	String stripped = source.replaceAll(String.format("[^%s]", target), "");
	int result = 0;
	int splitPosition = stripped.indexOf(midchar, midpoint);
	while (splitPosition >= 0) {
	    result += countMatches(first, stripped.substring(0, splitPosition)) * countMatches(last, stripped.substring(splitPosition + 1));
	    result %= 10000;
	    splitPosition = stripped.indexOf(midchar, splitPosition + 1);
	}
	return result;
    }

    private static int count(final char target, final String source) {
	int count = 0;
	for (int i = 0; i < source.length(); i++) {
	    if (source.charAt(i) == target) count++;
	}
	return count;
    }

}
