package round1c;

import static org.junit.Assert.*;

import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

import org.junit.Test;

public class C {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws java.io.IOException {
//		final String inputFile = "input/C-sample.txt";
//		final String outputFile = "output/C-sample-out.txt";
		 final String inputFile = "input/C-small-attempt0.in";
		 final String outputFile = "output/C-small-out.txt";
		// final String inputFile = "input/C-large.in";
		// final String outputFile = "output/C-large-out.txt";

		final Scanner scanner = new Scanner(new File(inputFile));
		final PrintWriter writer = new PrintWriter(outputFile);

		final int numCases = scanner.nextInt();
		System.out.println(String.format("There are %d cases", numCases));

		for (int caseNum = 1; caseNum <= numCases; caseNum++) {
			final int p = scanner.nextInt();
			final int q = scanner.nextInt();
			final int[] releases = new int[q];
			for (int i = 0; i < q; i++) {
				releases[i] = scanner.nextInt();
			}

			int answer = cost(1, p, releases);

			System.out.println("Finished case " + caseNum);
			writer.println(String.format("Case #%d: %d", caseNum, answer));
		}

		writer.flush();
		writer.close();
	}

	@Test
	public void testCost() throws Exception {
		assertEquals(7, cost(1, 8, new int[] { 3 }));
		assertEquals(35, cost(1, 20, new int[] { 3, 6, 14 }));
	}

	public static int cost(int left, int right, int[] releases) {
		if (releases.length == 0) {
			return 0;
		}
		if (releases.length == 1) {
			return right - left;
		}
		int bestGuess = (right - left) * releases.length;
		for (int i = 0; i < releases.length; i++) {
			int initialCost = right - left;
			int leftCost, rightCost;
			if (i > 0) {
				int[] leftReleases = new int[i];
				System.arraycopy(releases, 0, leftReleases, 0, i);
				leftCost = cost(left, releases[i] - 1, leftReleases);
			} else {
				leftCost = 0;
			}
			if (i < releases.length - 1) {
				int[] rightReleases = new int[releases.length - i - 1];
				System.arraycopy(releases, i + 1, rightReleases, 0, releases.length - i - 1);
				rightCost = cost(releases[i] + 1, right, rightReleases);
			} else {
				rightCost = 0;
			}
			int cost = initialCost + leftCost + rightCost;
			if (cost < bestGuess) {
				bestGuess = cost;
			}
		}
		return bestGuess;
	}

}
