package googlecodejam2014;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;

public class DeceitfulWar {
	final static Boolean DEBUG_ENABLE = false;
	final static Boolean TIMER_ENABLE = false;

	final static String FILE_NAME = "D-large";// <<<--------

	final static String BASE = "C:/CodeJam/" + FILE_NAME;
	final static String INPUT = BASE + ".in";
	final static String OUTPUT = BASE + ".out";
	static Scanner in;
	static PrintWriter out;

	private static void caseSolver() {

		int n = in.nextInt();
		in.nextLine();
		int deceitfulWarPoints = 0;
		int warPoints = 0;
		List<Double> naomiRocks = new ArrayList<Double>();
		List<Double> kenRocks = new ArrayList<Double>();
		
		for (int i = 0; i < n; i++)
			naomiRocks.add(in.nextDouble());
		if (in.hasNextLine())
			in.nextLine();
		for (int i = 0; i < n; i++)
			kenRocks.add(in.nextDouble());
		if (in.hasNextLine())
			in.nextLine();

		Collections.sort(naomiRocks);// 1st rock is the lightest
		Collections.sort(kenRocks);
//		System.out.println(naomiRocks);
//		System.out.println(kenRocks);	
		List<Double> naomiRocks1 = new ArrayList<Double>(naomiRocks);
		List<Double> kenRocks1 = new ArrayList<Double>(kenRocks);

		// Naomi should always choose the lightest rock she have saying
		// that it weights more than ken's second heaviest rock.
		// On that way, ken will discard his best rock, or if he can't
		// win will choose the lightest
		for (int i = n - 1; i >= 0; i--) {
			if (naomiRocks.get(i) < kenRocks.get(0)) {
				break;
			} else if (naomiRocks.get(0) > kenRocks.get(i)) {
				deceitfulWarPoints += i + 1;
				break;
			}else {
				for (int j = 0; j <= i; j++) {
					if (naomiRocks.get(j) > kenRocks.get(0)) {
						naomiRocks.remove(j);
						kenRocks.remove(0);
						deceitfulWarPoints++;
						break;
					}
				}
			}
		}

		// War Game
		for (int i = 0, m = n - 1; i < n; i++, m--) {
			if (naomiRocks1.get(0) > kenRocks1.get(m)) {
				warPoints += (m + 1);
				break;
			} else if (naomiRocks1.get(m) < kenRocks1.get(0)) {
				break;
			} else {
				for (int j = 0; j < m; j++) {
					if (naomiRocks1.get(0) < kenRocks1.get(j)) {
						naomiRocks1.remove(0);
						kenRocks1.remove(j);
						break;
					}
				}
			}

		}
		out.print(deceitfulWarPoints + " " + warPoints);

	}

	public static void main(String[] args) {
		try {
			in = new Scanner(new FileReader(INPUT));
			in.useLocale(Locale.US);
			out = new PrintWriter(OUTPUT);

			int number_of_cases = in.nextInt();
			in.nextLine();
			for (int c = 0; c < number_of_cases; c++) {
				out.print("Case #" + (c + 1) + ": ");
				if (DEBUG_ENABLE)
					System.out.println("Solving case " + (c + 1) + "...");
				if (TIMER_ENABLE) {
					long startTime = System.currentTimeMillis();
					caseSolver();
					long endTime = System.currentTimeMillis();
					System.out.println((endTime - startTime) + " ms");
				} else
					caseSolver();

				out.println();
			}
			out.println();
			out.flush();
			out.close();
			in.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

}