package googlecodejam2014;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class CookieClickerAlpha {
	final static Boolean DEBUG_ENABLE = true;
	final static Boolean TIMER_ENABLE = false;

	final static String FILE_NAME = "CookieClickerAlpha";// <<<--------

	final static String BASE = "C:/CodeJam/" + FILE_NAME;
	final static String INPUT = BASE + ".in";
	final static String OUTPUT = BASE + ".out";
	static Scanner in;
	static PrintWriter out;

	public static void main(String[] args) {
		try {
			in = new Scanner(new FileReader(INPUT));
			in.useLocale(Locale.US);
			out = new PrintWriter(OUTPUT);

			int number_of_cases = in.nextInt();
			in.nextLine();
			for (int c = 0; c < number_of_cases; c++) {
				out.print("Case #" + (c + 1) + ": ");
				if (DEBUG_ENABLE)
					System.out.println("Solving case " + (c + 1) + "...");
				if (TIMER_ENABLE) {
					long startTime = System.currentTimeMillis();
					caseSolver();
					long endTime = System.currentTimeMillis();
					System.out.println((endTime - startTime) + " ms");
				} else
					caseSolver();

				out.println();
			}
			out.println();
			out.flush();
			out.close();
			in.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	private static void caseSolver() {
		//if(in.hasNextLine()) in.nextLine();
		Double c = in.nextDouble();
		Double f = in.nextDouble();
		Double x = in.nextDouble();
		Double t = 0.0;
		boolean isBestContinue = true;
		int numberOfFarms = 0;

		while (isBestContinue) {
			Double timeToDecision = c / (numberOfFarms * f + 2);
			Double timeIfBuy = timeToDecision + x / ((numberOfFarms + 1) * f + 2);
			Double timeIfContinue = x / (numberOfFarms * f + 2);
			if(timeIfContinue<timeIfBuy){
				isBestContinue=false;
				t+=timeIfContinue;
			} else{
				t+=timeToDecision;
				numberOfFarms++;
			}
		}
		out.print(t);
	}
}
