package googlecodejam2014;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Scanner;

public class MagicTrick {
	final static Boolean DEBUG_ENABLE = true;
	final static Boolean TIMER_ENABLE = true;

	final static String FILE_NAME = "magictrick";// <<<--------

	final static String BASE = "C:/CodeJam/" + FILE_NAME;
	final static String INPUT = BASE + ".in";
	final static String OUTPUT = BASE + ".out";
	static Scanner in;
	static PrintWriter out;

	public static void main(String[] args) {
		try {
			in = new Scanner(new FileReader(INPUT));
			//
			out = new PrintWriter(OUTPUT);

			int number_of_cases = in.nextInt();
			in.nextLine();
			for (int c = 0; c < number_of_cases; c++) {
				out.print("Case #" + (c + 1) + ": ");
				if (DEBUG_ENABLE)
					System.out.println("Solving case " + (c + 1) + "...");
				if (TIMER_ENABLE) {
					long startTime = System.currentTimeMillis();
					caseSolver();
					long endTime = System.currentTimeMillis();
					System.out.println((endTime - startTime) + " ms");
				} else
					caseSolver();

				out.println();
			}
			out.println();
			out.flush();
			out.close();
			in.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	private static void caseSolver() {
		HashSet<Integer> possibleCards = new HashSet<Integer>();
		int n = 0;
		int foundedCard = 0;
		int card;
		
		int rowChoosed = in.nextInt();
		in.nextLine();
		for (int i = 0; i < 4; i++) {
			if (i == rowChoosed - 1) {
				for (int j = 0; j < 4; j++)
					possibleCards.add(in.nextInt());
			}
			in.nextLine();
		}
		rowChoosed = in.nextInt();
		in.nextLine();
		for (int i = 0; i < 4; i++) {
			if (i == rowChoosed - 1) {
				for (int j = 0; j < 4; j++) {
					card = in.nextInt();
					if (possibleCards.contains(card)) {
						foundedCard = card;
						n++;
					}
				}
			}
			in.nextLine();
		}
		if (n == 1) {
			out.print(foundedCard);
		} else if (n > 1) {
			out.print("Bad magician!");
		} else
			out.print("Volunteer cheated!");

		return;
	}
}