package exercices;

import java.io.*;
import java.util.*;
import java.util.Scanner;

public class Main {

	
	private static char[][] readInput(Scanner capt) {
		
		char[][] game = new char[4][4];
		for(int i = 0; i < 4; ++i) {
			String line = capt.nextLine();
			for (int j = 0; j < 4; ++j) {
				game[i][j] = line.charAt(j);
			}
		}
		
		return game;
	}
	
	
	private static String calculateResult(char[][] game) {
		
		//** . means fail the row/diagonal/column doesn't define a winner. **

		char diagonalA = 'T', diagonalB = 'T';
		
		boolean completed = true;
		
		for(int i = 0; i < 4; ++i) {
			char currentRow = 'T';
			char currentColumn = 'T';
			for(int j = 0; j < 4; ++j) {
				if(game[i][j] != 'T') {
					
					//Calculate the current row.
					if(currentRow == 'T') currentRow = game[i][j];
					else if (currentRow != game[i][j]) currentRow = '.';
					
					//Calculate diagonal A.
					if(i == j && diagonalA == 'T') diagonalA = game[i][j];
					else if (i == j && diagonalA != game[i][j]) diagonalA = '.';
					
					//Calculate diagonal B.
					if(i+j == 3 && diagonalB == 'T') diagonalB = game[i][j];
					else if (i+j == 3 && diagonalB != game[i][j]) diagonalB = '.';
					
					//If empty the game isn't over.
					if(game[i][j] == '.') completed = false;
				}
				if(game[j][i] != 'T') {
					//Calculate the current Column.
					if(currentColumn == 'T') currentColumn = game[j][i];
					else if (currentColumn != game[j][i]) currentColumn = '.';
				}
			}
			
			if (currentRow != '.') return currentRow + " won";
			if (currentColumn != '.') return currentColumn + " won"; 
		}
		
		if (diagonalA != '.') return diagonalA + " won";
		if (diagonalB != '.') return diagonalB + " won";
		if(completed) return "Draw";
		
		return "Game has not completed";
	}
	
//	private static void writeResult(int numCase, float result) {
//		System.out.print("Case #" + numCase + ": ");
//		System.out.printf("%.6f", result);
//		System.out.print("\n");
//	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		Locale.setDefault(Locale.US);
		
		Scanner capt = new Scanner(System.in);
		
		//At first we read the number of cases.
		int numCases = capt.nextInt();
		
		//For every case we'll calculate the result and we'll print it.
		for (int i = 0; i < numCases; ++i) {
			
			//There are an empty line between games.
			capt.nextLine();
		
			//Read input.
			char[][] game = readInput(capt);
			
			//Calculate result.
			String result = calculateResult(game);
			
			//Print result.
			System.out.println("Case #" + (i+1) + ": " + result);
		}

	}

}
