package exercices;

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class CopyOfMain {
	
	private static Vector<Object> sqrt(BigInteger n) {
		  BigInteger a = BigInteger.ONE;
		  BigInteger b = new BigInteger(n.shiftRight(5).add(new BigInteger("8")).toString());
		  while(b.compareTo(a) >= 0) {
		    BigInteger mid = new BigInteger(a.add(b).shiftRight(1).toString());
		    if(mid.multiply(mid).compareTo(n) > 0) b = mid.subtract(BigInteger.ONE);
		    else a = mid.add(BigInteger.ONE);
		  }
		  
		  Vector<Object> result = new Vector<Object>();
		  result.add(a.subtract(BigInteger.ONE));
		  result.add(b);
		  
		  return result;
		}
	
	private static boolean isPalindrom(BigInteger number) {
		String num = number.toString();
		int middle = num.length() / 2;
		
		for(int i = 0; i < middle; ++i) {
			if(num.charAt(i) != num.charAt(num.length() - i - 1)) return false;
		}
		return true;
	}
	
	
	private static int calculateResult(int a, int b, int[] elements) {
		
		int minimum = -1;
		int middle = 0;
		
		Arrays.sort(elements);
		
		int numRemovs;
		
		for (int i = 0; i < elements.length; ++i) {
			if(elements[i] >= a) {
				numRemovs = middle + elements.length - i;
				
				if (numRemovs < minimum || minimum == -1) {
					minimum = numRemovs;
				}
				
				while(elements[i] >= a) {
					++middle;
					a += a-1;
				}
				
				a += elements[i];
				
				if (middle >= minimum) return minimum;
			}
			else a += elements[i];
		}
		
		return middle;
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		Locale.setDefault(Locale.US);
		
		Scanner capt = new Scanner(System.in);
		
		//At first we read the number of cases.
		int numCases = capt.nextInt();
		
		//For every case we'll calculate the result and we'll print it.
		for (int i = 0; i < numCases; ++i) {
			
			//There are an empty line between games.
			int a = capt.nextInt();
			int b = capt.nextInt();
			
			int[] elements = new int[b];
			
			for(int j = 0; j < b; ++j) {
				elements[j] = capt.nextInt();
			}
			
			//Calculate result.
			int number;
			if (a == 1) number = b;
			else number = calculateResult(a, b, elements);
			
			//Print result.
			System.out.println("Case #" + (i+1) + ": " + number);
		}

	}

}
