package gcj;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 *
 * @author David
 */
public class GCJ {

    public static void main(String[] args) throws Exception {
        
        Scanner sc = new Scanner(new FileInputStream("input.txt"));
        PrintWriter pw = new PrintWriter(new FileOutputStream("out.txt"));
        boolean[] checkNum = new boolean[10];
        for(int i=0;i<10;i++){
            checkNum[i] = false;
        }
        
        int numTest = Integer.parseInt(sc.nextLine());
          
        for(int i=0;i<numTest;i++) {
            String pancake = sc.nextLine();
            String[] cake = pancake.split("");
            
            System.out.println("test case: " + (i+1) + " " + pancake);
            
            if(isSuccess(cake)) {
                System.out.println("all correct");
                pw.println("Case #" + (i+1) + ": 0");
            }else{
                int count = 0;
                boolean done = false;
                String[] currentCake = cake;
                
                while(!done) {
                    count++;
                    currentCake = flipMost(currentCake);
              
                    if(isSuccess(currentCake)) {
                        done = true;
                    }
                }
                
                pw.println("Case #" + (i+1) + ": " + count);
                
            }
          
        }
       
        sc.close();
        pw.close();
    }
    
    public static String flip(String cake) {
        if(cake.equals("+")) {
            return "-";
        }else{
            return "+";
        }
    }
    
    public static String[] flipMost(String[] cake) {
        String[] flipedCake = new String[cake.length];
                
        String first = cake[0];
        boolean stop = false;

        for(int i=0;i<cake.length;i++){
            if(cake[i].equals(first) && !stop) {
                flipedCake[i] = flip(cake[i]);
            }else{
                stop = true;
                flipedCake[i] = cake[i];
            }
        }       
    
        return flipedCake;
    }
    
   
    public static boolean isSuccess(String[] cake) {
        int happy = 0;
        for(int i=0;i<cake.length;i++){
            if(cake[i].equals("+")) {
                happy++;
            }
        }
        
        if(happy == cake.length) {
            return true;
        }else{
            return false;
        }
    }
}
