import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Scanner;


public class Template {

	/**
	 * @param args
	 * @throws FileNotFoundException 
	 */
	public static void main(String[] args) throws FileNotFoundException {
		String filename = "A-small-attempt1.in";
		Scanner s = new Scanner(new File(filename));
		int T = s.nextInt();
		for (int testcase = 1; testcase <= T; testcase++){
			int N = s.nextInt();
			State state = new State();
			state.rows = new int[N];
			for (int i = 0; i < N; i++) {
				int val = s.nextInt(2);
				val = Integer.reverse(val);
				val >>>= (32 - N);
				state.rows[i] = val;
				
			}
			//state.print();
			
			HashSet<State> visited = new HashSet<State>();
			
			LinkedList<State> q = new LinkedList<State>();
			q.add(state);
			visited.add(state);
			
			
			while(true) {
				state = q.removeFirst();
				boolean win = true;
				for (int i = 0; i < N; i++) {
					if (!state.ok(i)) {
						win = false;
						break;
					}
				}
				if (win) break;
				
				for (int i = 0; i < N-1; i++){
					if (state.rows[i+1] < state.rows[i]){
						State next = state.swap(i, i+1);
						if (!visited.contains(next)) {
							visited.add(next);
							q.addLast(next);
						}
					}
				}
			}
			//System.out.println("done");
			//state.print();
			System.out.printf("Case #%d: %d\n", testcase, state.moves);
		}
	}
	
	static class State {
		int[] rows;
		int moves = 0;
		int hc;
		
		@Override
		public int hashCode() {
			if (hc == 0){
				hc = 1;
				for (int i = 0; i < rows.length; i++){
					hc += rows[i];
					hc *= 17; 
				}
			}
			return hc;
		}
		
		boolean ok(int row) {
			return rows[row] < (1 << (1 + row));
		}
		
		void print(){
			for(int i = 0; i < rows.length; i++){
				String s = Integer.toBinaryString(rows[i]);
				while (s.length() < rows.length)
					s = "0" + s;
				System.out.println(s + " " + ok(i));
			}
		}
		
		State swap(int i, int j) {
			State next = new State();
			next.rows = rows.clone();
			next.rows[i] = rows[j];
			next.rows[j] = rows[i];
			next.moves = moves+1;
			return next;
		}
		
		@Override
		public boolean equals(Object obj) {
			State other = (State) obj;
			return Arrays.equals(rows, other.rows);
		}
	}

}
