package B;

import java.awt.Point;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.Scanner;

public class B {

    public static void main(String[] args) throws FileNotFoundException {
        Scanner s = new Scanner(new File("B-large.in"));
//        Scanner s = new Scanner(new File("testB.in"));
        
        int TESTS = s.nextInt();
        
        
        for(int test = 1; test <= TESTS; test++){
            int R = s.nextInt();
            int C = s.nextInt();
            map = new int[R][C];
 
            for (int r = 0; r < R; r++)
            for (int c = 0; c < C; c++)
                map[r][c] = s.nextInt();
            
            Point[][] flowOut = new Point[R][C];
            for (int r = 0; r < R; r++){
                for (int c = 0; c < C; c++){
                    int flowOutDir = flowOut(r, c);
                    if (flowOutDir == -1)
                        flowOut[r][c] = new Point(r,c);
                    else
                        flowOut[r][c] = new Point(r + dr[flowOutDir], c + dc[flowOutDir]);
                    //System.out.print(flowOut[r][c].x + "," + flowOut[r][c].y + "\t");
                }
                
                //System.out.println();
            }
            char[][] colored = new char[R][C];
            for (char[] row : colored)
                Arrays.fill(row, '?');
            char next = 'a';
            for (int r = 0; r < R; r++){
                for (int c = 0; c < C; c++) {
                    if (colored[r][c] == '?'){
                        //System.out.println("search..");
                        LinkedList<Point> q = new LinkedList<Point>();
                        Point p = new Point(r,c);
                        while (colored[p.x][p.y] == '?' && !flowOut[p.x][p.y].equals(p)) {
                            q.add(p);
                            p = flowOut[p.x][p.y];
                        }
                        if (colored[p.x][p.y] != '?') {
                            //System.out.println("Existing sink found at " + p);
                            char ch = colored[p.x][p.y];
                            for (Point color : q)
                                colored[color.x][color.y] = ch;
                        } else { //new sink
                            //System.out.println("New sink found at " + p);
                            q.add(p);
                            for (Point color : q)
                                colored[color.x][color.y] = next;
                            next++;
                        }
                    }
                }
            }
            System.out.printf("Case #%d:\n", test);
            for (int r = 0; r < R; r++){
                for (int c = 0; c < C; c++){
                    if (c > 0)
                        System.out.print(' ');
                    System.out.print(colored[r][c]);
                }
                System.out.println();
            }
            
        }
    }
    
    static int[][] map;
    static int[] dr = {-1, 0, 0, 1};
    static int[] dc = {0, -1, 1, 0};
    static int[] rdr = {1, 0, 0, -1};
    static int[] rdc = {0, 1, -1, 0};
    
    //true if flows from a to b
    static int flowOut(int r, int c){
        int best = -1;
        int bestGap = 0;
        for (int i = 0; i < 4; i++){
            int gap = (height(r, c) - height(r + dr[i], c + dc[i]));
            if (gap > bestGap){
                bestGap = gap;
                best = i;
            }
        }
        return best;
    }
    
    static int height(int r, int c){
        if (r < 0 || c < 0 || r >= map.length || c >= map[0].length)
            return 999999;
        return map[r][c];
    }
    
    static boolean sink(int r, int c) {
        for (int i = 0; i < 4; i++)
            if (height(r, c) > height(r + dr[i], c + dc[i]))
                return false;
        return true;
    }

}
