/*
 ID:
 LANG: JAVA
 TASK:
 */

import java.util.*;
import java.lang.*;
import java.io.*;

class TicTacToe {
    public static void main(String[] args) throws IOException {
        
        BufferedReader reader = new BufferedReader(new FileReader("tictactoe.in"));
        PrintWriter writer = new PrintWriter(new BufferedWriter(new FileWriter("tictactoe.out")));
        char[][] board = new char[4][4];
        int numCases = Integer.parseInt(reader.readLine());
        
        for(int i = 0; i < numCases; i++) {
            
            //Read in test case
            for (int k = 0; k < 4; k++) {
                String line = reader.readLine();
                for (int j = 0; j < line.length(); j++) {
                    board[k][j] = line.charAt(j);
                }
            }
            reader.readLine(); //eat line
            
            writer.println("Case #" + (i + 1) + ": " + solve(board));
            //System.out.println("Case #" + (i + 1) + ": " + solve(board));
                        
        }
        reader.close();
        writer.close();
        System.exit(0);
        
        
    }
    
    public static String solve(char[][] board) {
        
        int answer = evaluateBoard(board);
        if (answer == 1) {
            return "X won";
        }
        
        if (answer == 0) {
            return "O won";
        }
        
        if (answer == -1 && boardIsFull(board)) {
            return "Draw";
        }
        
        return "Game has not completed";
        
    }
    
    public static int evaluateBoard(char[][] board) {
        for (int r = 0; r < 4; r++) {
            for (int c = 0; c < 4; c++) {
                if (board[r][c] == '.' || board[r][c] == 'T')
                    continue;
                //test in all directions
                //Test south
                boolean good = true;
                for (int dr = 1; dr < 4; dr++) {
                    if (!inBounds(dr + r, c)) {
                        good = false;
                        break;
                    }
                    
                    if (compareValues(board, r, c, dr, 0)) {
                        good = false;
                        break;
                    }
                }
                if (good) {
                    return eval(board, r, c);
                }
                
                //test southeast
                good = true;
                for (int dr = 1, dc = 1; dr < 4; dr++, dc++) {
                    if (!inBounds(r + dr, c + dc)) {
                        good = false;
                        break;
                    }
                        
                    if (compareValues(board, r, c, dr, dc)) {
                        good = false;
                        break;
                    }
                }
                
                if (good) {
                    return eval(board, r, c);
                }
                
                //test east
                good = true;
                for (int dc = 1; dc < 4; dc++) {
                    if (!inBounds(r, c + dc)) {
                        good = false;
                        break;
                    }
                    
                    if (compareValues(board, r, c, 0, dc)) {
                        good = false;
                        break;
                    }
                }
                if (good) {
                   return eval(board, r, c);
                }
                
                //test northeast
                good = true;
                for (int dr = -1, dc = 1; dr > -4; dr--, dc++) {
                    if (!inBounds(r + dr, c + dc)) {
                        good = false;
                        break;
                    }
                    if (compareValues(board, r, c, dr, dc)) {
                        good = false;
                        break;
                    }
                    
                }
                if (good) {
                    return eval(board, r, c);
                }
                
                //test north
                good = true;
                for (int dr = -1; dr > -4; dr--) {
                    if (!inBounds(r + dr, c)) {
                        good = false;
                        break;
                    }
                    
                    if (compareValues(board, r, c, dr, 0)) {
                        good = false;
                        break;
                    }
                }
                if (good) {
                   return eval(board, r, c);
                }
                
                //test north west
                good = true;
                for (int dr = -1, dc = -1; dr > -4; dr--, dc--) {
                    if (!inBounds(r + dr, c + dc)) {
                        good = false;
                        break;
                    }
                        
                    if (compareValues(board, r, c, dr, dc)) {
                        good = false;
                        break;
                    }
                }
                
                if (good) {
                    return eval(board, r, c);
                }
                
                //test west
                good = true;
                for (int dc = -1; dc > -4; dc--) {
                    if (!inBounds(r, c + dc)) {
                        good = false;
                        break;
                    }
                    
                    if (compareValues(board, r, c, 0, dc)) {
                        good = false;
                        break;
                    }
                }
                   
                if (good) {
                    return eval(board, r, c);
                }
                
                //test southwest
                good = true;
                for (int dr = 1, dc = -1; dr < 4; dr++, dc--) {
                    if (!inBounds(r + dr, c + dc)) {
                        good = false;
                        break;
                    }
                        
                    if (compareValues(board, r, c, dr, dc)) {
                        good = false;
                        break;
                    }
                }
                
                if (good) {
                    return eval(board, r, c);
                }             
                               
                
            }
        }
        return -1;
    }
    
    public static boolean boardIsFull(char[][] board) {
        int count = 0;
        for (int row = 0; row < 4; row++) {
            for (int col = 0; col < 4; col++) {
                if (board[row][col] != '.') {
                    count++;
                }
            }
        }
        return (count == 16);
    }
    
    public static boolean inBounds(int row, int col) {
        return (row >= 0 && row < 4 && col >= 0 && col < 4);
    }
    
    public static int eval(char[][] board, int r, int c) {
        
        if (board[r][c] == 'X') {
            return 1;
        } 
        return 0;
    }
    
    public static boolean compareValues(char[][] board, int r, int c, int dr, int dc) {
        if (board[r][c] == board[r + dr][c + dc] || board[r + dr][c + dc] == 'T') 
            return false;
        return true;
    }
    
    public static void printBoard(char[][] board) {
        for (int row = 0; row < 4; row++) {
             for (int col = 0; col < 4; col++) {
                  System.out.print(board[row][col]);
             }
             System.out.println();
        }
        System.out.println();
    }
}