/*
 * @author David Horat
 */

package b;

import java.io.*;
import java.util.*;

public class Main {

    private static final String in_file = "C:\\B-small-attempt1.in";
    private static final String out_file = "C:\\B-small-attempt1.out";

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        (new Main()).run();
    }

    public void run() {
        try {
          BufferedReader input =  new BufferedReader(new FileReader(in_file));
          BufferedWriter out =  new BufferedWriter(new FileWriter(out_file));
          try {
            int nc; // Number of cases
            nc = Integer.valueOf(input.readLine()).intValue();
            System.out.println("N = " + nc);
            // Treat each case
            for (int i = 0; i < nc; i++) {
                // Load all search engines of this case
                String num = input.readLine();
                // Solve this case
                int casen = i+1;
                long steps = solveCase(num, new int[num.length() - 1], 0);
                String solution = "Case #" + casen + ": " + steps;
                System.out.println(solution);
                out.write(solution + "\n");
            }
          }
          finally {
            input.close();
            out.close();
          }
        }
        catch (IOException ex){
          ex.printStackTrace();
        }
    }

    private long parse_num(String num, int[] signs) {
        long res = 0;
        int last_op = 0;
        String exp = String.valueOf(num.charAt(0));
        for (int i = 0; i < num.length()-1; i++) {
            if (signs[i] == 0) {
                exp = exp.concat(String.valueOf(num.charAt(i+1)));
            } else if (signs[i] == 1) {
                if (last_op == 0) {
                    res = Long.parseLong(exp);
                } else if (last_op == 1) {
                    res += Long.parseLong(exp);
                } else if (last_op == 2) {
                    res -= Long.parseLong(exp);
                }
                last_op = 1;
                exp = String.valueOf(num.charAt(i+1));
            } else if (signs[i] == 2) {
                if (last_op == 0) {
                    res = Long.parseLong(exp);
                } else if (last_op == 1) {
                    res += Long.parseLong(exp);
                } else if (last_op == 2) {
                    res -= Long.parseLong(exp);
                }
                last_op = 2;
                exp = String.valueOf(num.charAt(i+1));                
            }
        }
        if (last_op == 0) {
            res = Long.parseLong(exp);
        } else if (last_op == 1) {
            res += Long.parseLong(exp);
        } else if (last_op == 2) {
            res -= Long.parseLong(exp);
        }
        return res;
    }

    private int is_ugly(long num) {
        if (num == 0) return 1;
        if (num % 2 == 0) return 1;
        if (num % 3 == 0) return 1;
        if (num % 5 == 0) return 1;
        if (num % 7 == 0) return 1;
        return 0;
    }

    private long solveCase(String num, int[] signs, int idx) {
        long res = 0;
        if (signs.length == 0) return is_ugly(Long.parseLong(num));
        long total = (long)Math.pow(3, num.length()-1);
        for (int i = 0; i < total; i++) {
            long tmp = i;
            for (int j = 0; j < signs.length; j++) {
                signs[j] = (int) (tmp % 3);
                tmp = tmp / 3;
            }
            res += is_ugly(parse_num(num, signs));
        }
        return res;
    }

}
