/*
 * @author David Horat
 */

package b;

import java.io.*;
import java.util.*;

public class Main {

    private static final String in_file = "C:\\B-small-attempt1.in";
    private static final String out_file = "C:\\B-small-attempt1.out";

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        (new Main()).run();
    }

    public void run() {
        try {
          BufferedReader input =  new BufferedReader(new FileReader(in_file));
          BufferedWriter out =  new BufferedWriter(new FileWriter(out_file));
          try {
            int nc; // Number of cases
            nc = Integer.valueOf(input.readLine()).intValue();
            System.out.println("N = " + nc);
            // Treat each case
            for (int i = 0; i < nc; i++) {
                String line = input.readLine();
                String[] data = line.split("\\s+");
                // A, B, P
                long A = Long.parseLong(data[0]);
                long B = Long.parseLong(data[1]);
                long P = Long.parseLong(data[2]);
                // Solve this case
                int casen = i+1;
                long steps = solveCase(A, B, P);
                String solution = "Case #" + casen + ": " + steps;
                System.out.println(solution);
                out.write(solution + "\n");
            }
          }
          finally {
            input.close();
            out.close();
          }
        }
        catch (IOException ex){
          ex.printStackTrace();
        }
    }

    public static boolean isPrime(long n) {
            boolean prime = true;
            for (long i = 3; i <= Math.sqrt(n); i += 2)
                    if (n % i == 0) {
                            prime = false;
                            break;
                    }
            if (( n%2 !=0 && prime && n > 2) || n == 2) {
                    return true;
            } else {
                    return false;
            }
    }

    private void reorganize(ArrayList<ArrayList<Long>> sets) {
        for (int i = 0; i < sets.size(); i++) {
            ArrayList<Long> s = sets.get(i);
            for (int k = 0; k < s.size(); k++) {
                Long f = s.get(k);
                for (int j = i+1; j < sets.size(); j++) {
                    ArrayList<Long> z = sets.get(j);
                    // Si el set Z contiene un factor f de S, el set Z
                    // se borrará y S contendrá todos los factores de Z.
                    if (z.contains(f)) {
                        for (Long a : z) {
                            if (! s.contains(a)) s.add(a);
                        }
                        sets.remove(j);
                    }
                }
            }
        }
    }

    private boolean shareFactor(long A, long B, long P) {
        ArrayList<Long> AFactors = new ArrayList<Long>();
        ArrayList<Long> BFactors = new ArrayList<Long>();
        // Prime factors of A
        for (long i = P; i <= A; i++) {
            if (isPrime(i)) {
                if (A % i == 0) {
                    AFactors.add(new Long(i));
                }
            }
        }
        //System.out.println(A + ": " + AFactors.toString());
        // Prime factors of B
        for (long i = P; i <= B; i++) {
            if (isPrime(i)) {
                if (B % i == 0) {
                    BFactors.add(new Long(i));
                }
            }
        }
        //System.out.println(B + ": " + BFactors.toString());
        // Check if they share one
        for (int i = 0; i < AFactors.size(); i++) {
            if (BFactors.contains(AFactors.get(i))) {
//                System.out.println(A + ": " + AFactors.toString());
//                System.out.println(B + ": " + BFactors.toString());
//                System.out.println("They share the " + AFactors.get(i));
                return true;
            }
        }
        //System.out.println("They dont share");
        return false;
    }

    private long solveCase2(long A, long B, long P) {
        long groups = B - A + 2;
        for (long i = A; i <= B; i++) {
            for (long j = A; j <= B; j++) {
                if (i!=j) {
                if (shareFactor(i, j, P)) {
                    groups--;
                    break;
                }
                }
            }
        }
        return groups;
    }

    private ArrayList<Long> factorize(long n, long P) {
        ArrayList<Long> NFactors = new ArrayList<Long>();
        for (long i = P; i <= n; i++) {
            if (isPrime(i)) {
                if (n % i == 0) {
                    NFactors.add(new Long(i));
                }
            }
        }
        return NFactors;
    }

    private long solveCase(long A, long B, long P) {
        ArrayList<ArrayList<Long>> sets = new ArrayList<ArrayList<Long>>();
        // For each number check
        for (long i = A; i <= B; i++) {
            ArrayList<Long> factors = factorize(i, P);
            System.out.println(i + ": " + factors.toString());
            // If one of its factors is contained in one of the sets
            boolean done = false;
            for (Long f : factors) {
                for (ArrayList s : sets) {
                    if (s.contains(f)) {
                        done = true;
                        // Add all factors to this set
                        for (Long n : factors) {
                            if (! s.contains(n)) s.add(n);
                        }
                        // Reorganize sets
                        reorganize(sets);
                        break;
                    }
                }
                if (done) break;
            }
            if (!done) {
                sets.add(factors);
            }
        }
        return sets.size();
    }
}
