/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package traintimetable;

import java.io.*;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author qhordav
 */
public class Main {


    private static final String in_file = "C:\\B-small-attempt0.in";
    private static final String out_file = "C:\\B-small-attempt0.out";

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        (new Main()).run();
    }

    public void run() {
        try {
          BufferedReader input =  new BufferedReader(new FileReader(in_file));
          BufferedWriter out =  new BufferedWriter(new FileWriter(out_file));
          try {
            int n; // Number of cases
            n = Integer.valueOf(input.readLine()).intValue();
            System.out.println("N = " + n);
            // Treat each case
            for (int i = 0; i < n; i++) {
                // Get T, NA and NB
                int t = Integer.parseInt(input.readLine());
                System.out.println("T = " + t);
                String line = input.readLine();
                //System.out.println(line);
                String[] data = line.split("\\s+");
                //System.out.println(data[0]);
                //System.out.println(data[1]);
                int na = Integer.parseInt(data[0]);
                System.out.println("NA = " + na);
                int nb = Integer.parseInt(data[1]);
                System.out.println("NB = " + nb);
                // Get NA times
                DateFormat df = new SimpleDateFormat("HH:mm");
                Date[][] naTimes = new Date[na][2];
                for (int j = 0; j < na; j++) {
                    data = input.readLine().split("\\s+");
                    try {
                        naTimes[j][0] = df.parse(data[0]);
                        naTimes[j][1] = df.parse(data[1]);
                    } catch (ParseException ex) {
                        Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
                    }
                    System.out.println(df.format(naTimes[j][0]) + " " + df.format(naTimes[j][1]));
                }
                // Get NB times
                Date[][] nbTimes = new Date[nb][2];
                for (int j = 0; j < nb; j++) {
                    data = input.readLine().split("\\s+");
                    try {
                        nbTimes[j][0] = df.parse(data[0]);
                        nbTimes[j][1] = df.parse(data[1]);
                    } catch (ParseException ex) {
                        Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
                    }
                    System.out.println(df.format(nbTimes[j][0]) + " " + df.format(nbTimes[j][1]));
                }
                // Solve case
                int casen = i + 1;
                String res = "Case #" + casen + ": " + solveCase(t, na, naTimes, nb, nbTimes);
                System.out.println(res);
                out.write(res + "\n");
            }
          }
          finally {
            input.close();
            out.close();
          }
        }
        catch (IOException ex){
          ex.printStackTrace();
        }
    }

    private String solveCase(int t, int na, Date[][] naTimes, int nb, Date[][] nbTimes) {
        int naTrains = 0;
        int nbTrains = 0;
        boolean[] naFilled = new boolean[na];
        boolean[] nbFilled = new boolean[nb];
        while (isSlotFree(naFilled) || isSlotFree(nbFilled)) {
            int naIdx = searchBestTime(na, naTimes, naFilled);
            int nbIdx = searchBestTime(nb, nbTimes, nbFilled);
            if (compareBestTime(naIdx, naTimes, nbIdx, nbTimes)) {
                fillTime(t, naIdx, na, naTimes, naFilled, nb, nbTimes, nbFilled);
                naTrains++;
            } else {
                fillTime(t, nbIdx, nb, nbTimes, nbFilled, na, naTimes, naFilled);
                nbTrains++;
            }
        }
        return naTrains + " " + nbTrains;
    }


    /**
     * Returns the index of the naTimes array for the earliest possible time.
     * It takes into account both the departure and arrival time.
     * @return boolean
     */
    private int searchBestTime(int na, Date[][] naTimes, boolean[] naFilled) {
        if (!isSlotFree(naFilled)) return -1;
        int idx = -1;
        Date[] naBestTime = null;
        
        for (int i = 0; i < na; i++) {
            if (naFilled[i] == false) {
                if (naBestTime == null) {
                    naBestTime = new Date[2];
                    naBestTime[0] = naTimes[i][0];
                    naBestTime[1] = naTimes[i][1];
                    idx = i;
                }
                if (naTimes[i][0].before(naBestTime[0]) || naTimes[i][0].equals(naBestTime[0])) {
                    if (naTimes[i][1].before(naBestTime[1]) || naTimes[i][1].equals(naBestTime[1])) {
                        naBestTime[0] = naTimes[i][0];
                        naBestTime[1] = naTimes[i][1];
                        idx = i;
                    }
                }
            }
        }
        
        return idx;
    }

    /**
     * Returns true if naTimes[naIdx] is better than naTimes[nbIdx].
     * @return boolean
     */
    private boolean compareBestTime(int naIdx, Date[][] naTimes, int nbIdx, Date[][] nbTimes) {
        if (naIdx == -1) return false; // naTime cannot be compared. nbTime wins.
        if (nbIdx == -1) return true; // nbTime cannot be compared naTime wins.
        if (naTimes[naIdx][0].before(nbTimes[nbIdx][0])) {
            return true;
        } else if (naTimes[naIdx][0].equals(nbTimes[nbIdx][0])) {
            if (naTimes[naIdx][1].before(nbTimes[nbIdx][1])) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }

    /**
     * Simulates the path for a train and updates the timetables (naFilled and nbFilled).
     */
    private void fillTime(int t, int idx, int na, Date[][] naTimes, boolean[] naFilled, int nb, Date[][] nbTimes, boolean[] nbFilled) {
        Date nbStartTime = new Date();
        int nextIdx = idx;
        while (nextIdx != -1) {
            naFilled[nextIdx] = true;
            nbStartTime.setTime(naTimes[nextIdx][1].getTime() + t*1000*60);
            nextIdx = fitTime(nbStartTime, nb, nbTimes, nbFilled);
            if (nextIdx != -1) {
                nbFilled[nextIdx] = true;
                nbStartTime.setTime(nbTimes[nextIdx][1].getTime() + t*1000*60);
                nextIdx = fitTime(nbStartTime, na, naTimes, naFilled);
            }
        }
    }

    /**
     * Search the best time in naTimes for a concrete startTime and returns its index.
     * @return
     */
    private int fitTime(Date startTime, int na, Date[][] naTimes, boolean[] naFilled) {
        int idx = -1;
        Date bestTime = null;
        for (int i = 0; i < na; i++) {
            if (naFilled[i] == false) {
                if (bestTime  == null) {
                    if ((startTime.before(naTimes[i][0]) || startTime.equals(naTimes[i][0]))) {
                        bestTime = naTimes[i][0];
                        idx = i;
                    }
                } else {
                    if ((startTime.before(naTimes[i][0]) || startTime.equals(naTimes[i][0]))
                            && naTimes[i][0].before(bestTime)) {
                        bestTime = naTimes[i][0];
                        idx = i;
                    }
                }
            }
        }
        return idx;
    }

    /**
     * Returns true if there is a free slot (false) in the naFilled array.
     * @return boolean
     */
    private boolean isSlotFree(boolean[] naFilled) {
        for (int i = 0; i < naFilled.length; i++) {
            if (naFilled[i] == false) {
                return true;
            }                
        }
        return false;
    }
}
