/*
 * @author David Horat
 */

package a;

import java.io.*;
import java.util.*;

public class Main {

    private static final String in_file = "C:\\A-small-attempt0.in";
    private static final String out_file = "C:\\A-small-attempt0.out";

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        (new Main()).run();
    }

    public void run() {
        try {
          BufferedReader input =  new BufferedReader(new FileReader(in_file));
          BufferedWriter out =  new BufferedWriter(new FileWriter(out_file));
          try {
            int nc; // Number of cases
            nc = Integer.valueOf(input.readLine()).intValue();
            System.out.println("N = " + nc);
            // Treat each case
            for (int i = 0; i < nc; i++) {
                String line = input.readLine();
                String[] data = line.split("\\s+");
                int max_per_key = Integer.parseInt(data[0]);
                int keys = Integer.parseInt(data[1]);
                int num = Integer.parseInt(data[2]);
                line = input.readLine();
                data = line.split("\\s+");
                long[] msg = new long[num];
                for (int j = 0; j < data.length; j++) {
                    msg[j] = Long.parseLong(data[j]);
                }
                // Solve this case
                int casen = i+1;
                long steps = solveCase(max_per_key, keys, num, msg);
                String solution;
                if (steps == -1) {
                    solution = "Case #" + casen + ": Impossible";
                } else {
                    solution = "Case #" + casen + ": " + steps;
                }
                System.out.println(solution);
                out.write(solution + "\n");
            }
          }
          finally {
            input.close();
            out.close();
          }
        }
        catch (IOException ex){
          ex.printStackTrace();
        }
    }

    private int select_most_frequent(long[] msg, ArrayList<Integer> idx_used) {
        int idx = -1;
        long val = -1;
        for (int i = 0; i < msg.length; i++) {
            if (msg[i] > val) {
                if (! idx_used.contains(i)) {
                    idx = i;
                    val = msg[i];
                }
            }
        }
        idx_used.add(idx);
        return idx;
    }

    private long solveCase(int max_per_key, int keys, int num, long[] msg) {
        if (num > keys * max_per_key) return -1;
        ArrayList<Integer> idx_used = new ArrayList<Integer>();
        long res = 0;
        int alph_count = 0;
        int idx_selected;
        for (int i = 1; i <= max_per_key; i++) {
            for (int j = 0; j < keys; j++) {
                if (alph_count == num) break;
                else alph_count++;
                idx_selected = select_most_frequent(msg, idx_used);
                res += msg[idx_selected] * i;
            }
        }
        return res;
    }

}
