package round1;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;
import java.util.TreeSet;

public class Task3 {
	
	private static int[][] board;

	private static int[] calc(int[][] _board) {
		board = _board;
		int[] res = new int[board.length+board[0].length]; 
		boolean flag = true;
		while( flag ){
			int biggestSize = 0, biggestPosX = 0, biggestPosY = 0, newSize;
			for( int x = 0; x < board.length - biggestSize; x++ ){
				for( int y = 0; y < board[x].length - biggestSize; y++ ){
					if( board[x][y] == 2 )
						continue;
					newSize = whatSize( x, y);
//					System.out.println( newSize + " " + x + " " + y );
					if( newSize > biggestSize ){
						biggestSize = newSize;
						biggestPosX = x;
						biggestPosY = y;
					}
				}
			}
			if( biggestSize == 0 )
				flag = false;
			else {
				for( int a = 0; a < biggestSize; a++ )
					for( int b = 0; b < biggestSize; b++ )
						board[biggestPosX+a][biggestPosY+b] = 2;
				res[biggestSize]++;
//				System.out.println("erg:" + biggestSize + " " + biggestPosX + "  " + biggestPosY );
			}
		}
		return res;
	}
	
	private static int whatSize(int x, int y) {
		int curSize = 1;
		int color = board[x][y];
		int cColor = color == 1 ? 0 : 1;
		ra: while( curSize+x<board.length && curSize+y<board[0].length ){
			for( int i = 0; i <= curSize; i++ ){
				if( (i+curSize) % 2 == 0 ) {
					if ( board[x+i][y+curSize] != color || board[x+curSize][y+i] != color )
						break ra;
				} else if ( board[x+i][y+curSize] != cColor || board[x+curSize][y+i] != cColor )
					break ra;
			}
			curSize++;
		}
		return curSize;
	}

	///////////////////static/////////////////////////////////
	private static FileWriter fw = null;
	
	public static void main(String[] args) {
		String task = "C-small-attempt0";
		try { fw = new FileWriter( "Round1/Outputs/" + task + ".out" );
		} catch (IOException e) { e.printStackTrace(); }
		String[] input = readFromFile( "Round1/Inputs/" + task + ".in" );
		
		int line = 1;
		int p = new Integer( input[0] );
		for(int i = 0; i < p; i++ ){
			String[] s = input[line++].split(" ");
			int m = new Integer( s[0] );
			int n = new Integer( s[1] );
			int[][] board = new int[m][n];
			for( int j = 0; j < m; j++ ){
				int ni = 0;
				for( char c : input[line++].toCharArray() ){
					int hex = c >= 'A' ? c - 55 : c - 48;
					board[j][ni*4+3] = hex % 2;
					hex = hex / 2;
					board[j][ni*4+2] = hex % 2;
					hex = hex / 2;
					board[j][ni*4+1] = hex % 2;
					hex = hex / 2;
					board[j][ni*4] = hex % 2;
					hex = hex / 2;
					ni++;
				}
			}
			int[] res = calc( board );
			List<String> ausg = new LinkedList<String>();
			for(int j = res.length-1; j>0; j--)
				if( res[j] != 0 )
					ausg.add( Integer.toString(j) + " " + res[j] );
			writeToFile( "Case #" + (i+1) + ": " + ausg.size() );
			for( String str : ausg )
				writeToFile( str );
		}
		if ( fw != null ) 
		    try { fw.close(); } catch ( IOException e ) { } 
	}

	private static String[] readFromFile( String fileName ){
		List<String> rows = new LinkedList<String>();
		try {
			BufferedReader in = new BufferedReader(new FileReader(fileName));
			String zeile = null;
			while ((zeile = in.readLine()) != null) {
				rows.add( zeile );
			}
		} catch (IOException e) { e.printStackTrace(); }
		return rows.toArray( new String[ rows.size() ] );
	}
	
	private static void writeToFile( String line ){
		try { fw.write( line + "\n" );
		} catch (IOException e) {e.printStackTrace();}
		System.out.println( line );
	}
}
