package qualification;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

public class AlienLanguage {
	
	private static Set<String> 			words 		= new TreeSet<String>();
	private static List<Set<Character>>	posLetters;
	
	private static int getPossAmount(String pattern, int l) {
		char[][] possChars = new char[l][26];
		int state = 0; // 0 = exact; 1 = in ()
		int pos = 0;
		int letters = 0;
		for( char c : pattern.toCharArray() ){
			if( c == '(' ){
				state = 1;
				letters = 0;
			} else if( c == ')' ){
				state = 0;
				letters = 0;
				pos++;
			} else {
				if( posLetters.get(pos).contains( c )){
						possChars[pos][letters] = c;
					if( state == 1 )
						letters++;
				}
				if( state == 0 )
						pos++;
			}
		}
		
		Set<String> possibleWords = new TreeSet<String>();
		Set<String> wordsToDel = new TreeSet<String>();
		possibleWords.addAll( words );
		for( String str : possibleWords ){
			for(int i = 0; i < l; i++){
				boolean flag = false;
				for( int j = 0; j < 26 && possChars[i][j] != 0 ; j ++ )
					if( possChars[i][j] == str.charAt(i) ){
						flag = true;
						break;
					}
				if( !flag )
					wordsToDel.add( str );
			}
		}
		possibleWords.removeAll( wordsToDel );
		return possibleWords.size();
		
//		LinkedList<String> possibleWords = new LinkedList<String>();
//		possibleWords.add("");
//		for( char[] ca : possChars ){
//			LinkedList<String> longerWords = new LinkedList<String>();
//			for( char c : ca ){
//				if( c == 0 ){
//					if( longerWords.isEmpty() )
//						return 0;
//					break;
//				}
//				else
//					for( String str : possibleWords )
//						longerWords.add( str + c );
//			}
//			possibleWords.clear();
//			possibleWords.addAll( longerWords );
//		}
//		int amount = 0;
//		for(String word : possibleWords){
//			if( words.contains( word ) )
//				amount++;
//		}
//		
//		return amount;
	}
	
///////////////////static/////////////////////////////////
	private static FileWriter fw = null;
	
	public static void main(String[] args) {
		String task = "A-large";
		try { fw = new FileWriter( "Qualification/Outputs/" + task + ".out" );
		} catch (IOException e) { e.printStackTrace(); }
		String[] input = readFromFile( "Qualification/Inputs/" + task + ".in" );
		
		String[] s0 = input[0].split(" ");
		int l = new Integer(s0[0]);
		int d = new Integer(s0[1]);
		int n = new Integer(s0[2]);
		posLetters = new ArrayList<Set<Character>>();
		for(int i = 0; i < l; i++ )
			posLetters.add(new TreeSet<Character>());
		for(int i = 1; i <= d; i++ ){
			int j = 0;
			for( char c : input[i].toCharArray() ){
				posLetters.get(j++).add(c);
			}
			words.add( input[i] );
		}
		for(int i = d+1; i <= d+n; i++ )
			writeToFile( "Case #" + (i-d) + ": " + getPossAmount( input[i], l ) );
		if ( fw != null ) 
		    try { fw.close(); } catch ( IOException e ) { } 
	}

	private static String[] readFromFile( String fileName ){
		List<String> rows = new LinkedList<String>();
		try {
			BufferedReader in = new BufferedReader(new FileReader(fileName));
			String zeile = null;
			while ((zeile = in.readLine()) != null) {
				rows.add( zeile );
			}
		} catch (IOException e) { e.printStackTrace(); }
		return rows.toArray( new String[ rows.size() ] );
	}
	
	private static void writeToFile( String line ){
		try { fw.write( line + "\n" );
		} catch (IOException e) {e.printStackTrace();}
		System.out.println( line );
	}
}
