package round1;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;

public class Node {
	String name;
	LinkedList<Node> children = new LinkedList<Node>();
	public Node( String name ){
		this.name = name;
	}
	public int create( String path ){
		String[] s = path.split("/");
		if( s.length == 1 )
			return 0;
		for( Node no : children )
			if( no.name.equals( s[1] ))
				return no.create( path.substring( s[1].length() + 1 ) );
		Node n = new Node( s[1] );
		children.add( n );
		if( s.length > 2 )
			return n.create( path.substring( s[1].length() + 1 ) ) + 1;
		else 
			return 1;
	}
	
	private static int calc(List<String> paths, List<String> newPaths) {
		Node root = new Node("home");
		int ret = 0;
		for( String s : paths )
			root.create( s );
		for( String s : newPaths )
			ret += root.create( s );
		return ret;
	}
	
///////////////////static/////////////////////////////////
	private static FileWriter fw = null;
	
	public static void main(String[] args) {
		String task = "A-small-attempt0";
		try { fw = new FileWriter( "Round1/Outputs/" + task + ".out" );
		} catch (IOException e) { e.printStackTrace(); }
		String[] input = readFromFile( "Round1/Inputs/" + task + ".in" );
//		String[] input = new String[]{
//				"3",
//				"0 2",
//				"/home/gcj/finals",
//				"/home/gcj/quals",
//				"2 1",
//				"/chicken",
//				"/chicken/egg",
//				"/chicken",
//				"1 3",
//				"/a",
//				"/a/b",
//				"/a/c",
//				"/b/b"
//		};
		
		int line = 1;
		int p = new Integer( input[0] );
		for(int i = 0; i < p; i++ ){
			String[] s = input[line++].split(" ");
			int n = new Integer( s[0] );
			int m = new Integer( s[1] );
			List<String> paths = new LinkedList<String>();
			List<String> newPaths = new LinkedList<String>();
			for( int j = 0; j < n; j++ )
				paths.add( input[line++] );
			for( int j = 0; j < m; j++ )
				newPaths.add( input[line++] );
			writeToFile( "Case #" + (i+1) + ": " + calc( paths, newPaths) );
		}
		if ( fw != null ) 
		    try { fw.close(); } catch ( IOException e ) { } 
	}

	private static String[] readFromFile( String fileName ){
		List<String> rows = new LinkedList<String>();
		try {
			BufferedReader in = new BufferedReader(new FileReader(fileName));
			String zeile = null;
			while ((zeile = in.readLine()) != null) {
				rows.add( zeile );
			}
		} catch (IOException e) { e.printStackTrace(); }
		return rows.toArray( new String[ rows.size() ] );
	}
	
	private static void writeToFile( String line ){
		try { fw.write( line + "\n" );
		} catch (IOException e) {e.printStackTrace();}
		System.out.println( line );
	}
}
