import java.util.*;
import static java.lang.System.out;

/**
 * Lawnmower
 * NOTE: Good design practices are mostly ignored in programming contests.
 * @author DavidJennings
 *
 */
public class GCJ2013QualRoundProblemB {
	private Scanner in = new Scanner(System.in);
	
	public static void main(String args[]) {
		try {
			(new GCJ2013QualRoundProblemB()).goGo();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void goGo() {
		int T = in.nextInt();
		for (int i = 0; i < T; i++) {
			String value = "NO";
			if (isPatternPossible()) {
				value = "YES";
			}
			out.println("Case #" + (i + 1) + ": " + value);
		}
	}
	
	private boolean isPatternPossible() {
		int N = in.nextInt();
		int M = in.nextInt();
		
		int[][] pattern = new int[N][M];
		TreeSet<Integer> activeRows = new TreeSet<Integer>();
		TreeSet<Integer> activeCols = new TreeSet<Integer>();
		
		for (int r = 0; r < N; r++) {
			for (int c = 0; c < M; c++) {
				pattern[r][c] = in.nextInt();
			}
		}
		for (int r = 0; r < N; r++) {
			activeRows.add(r);
		}
		for (int c = 0; c < M; c++) {
			activeCols.add(c);
		}
		// can't go back down when removing rows and cols
		int masterLowestRowValue = -1;
		int masterLowestColValue = -1;
		
		while (!activeRows.isEmpty() && !activeCols.isEmpty()) {
			// find lowest values
			int lowestRowValue = 101;
			int rowIndex = -1;
			for (Integer r : activeRows) {
				if (pattern[r][activeCols.first()] < lowestRowValue) {
					lowestRowValue = pattern[r][activeCols.first()];
					rowIndex = r;
				}
			}
			if (lowestRowValue < masterLowestRowValue) {
				return false;
			} else {
				masterLowestRowValue = lowestRowValue;
			}
			int lowestColValue = 101;
			int colIndex = -1;
			for (Integer c : activeCols) {
				if (pattern[activeRows.first()][c] < lowestColValue) {
					lowestColValue = pattern[activeRows.first()][c];
					colIndex = c;
				}
			}
			if (lowestColValue < masterLowestColValue) {
				return false;
			} else {
				masterLowestColValue = lowestColValue;
			}
			
			if (lowestRowValue < lowestColValue) {
				// check row index for all the same
				for (Integer c : activeCols) {
					if (pattern[rowIndex][c] != lowestRowValue) {
						return false;
					}
				}
				activeRows.remove(rowIndex); // success row
			} else if (lowestRowValue > lowestColValue) {
				for (Integer r : activeRows) {
					if (pattern[r][colIndex] != lowestColValue) {
						return false;
					}
				}
				activeCols.remove(colIndex); // success col
			} else { // equal, try both
				// consume which one works
				boolean worked = true;
				
				for (Integer c : activeCols) {
					if (pattern[rowIndex][c] != lowestRowValue) {
						worked = false;
						break;
					}
				}
				
				if (worked) {
					activeRows.remove(rowIndex); // success row
				} else {
					for (Integer r : activeRows) {
						if (pattern[r][colIndex] != lowestColValue) {
							return false;
						}
					}
					activeCols.remove(colIndex); // success col
				}
			}
		}
		return true;
	}
}
