import static java.lang.System.out;
import java.text.DecimalFormat;
import java.util.Scanner;

/**
 * Problem B. Cookie Clicker Alpha
 * NOTE: Good design practices are mostly ignored in programming contests.
 * 
 * @author DavidJennings
 */
public class GCJ2014QualProblemB {

    public static final double BASE_RATE = 2.0;
    public static final DecimalFormat df = new DecimalFormat("0.0000000");
    private Scanner in = new Scanner(System.in);

    public static void main(String args[]) {
        try {
            (new GCJ2014QualProblemB()).goGo();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void goGo() {
        int T = in.nextInt();

        for (int i = 1; i <= T; i++) {
            double C = in.nextDouble();
            double F = in.nextDouble();
            double X = in.nextDouble();
            String result = findResult(C, F, X);
            out.println("Case #" + i + ": " + result);
        }
    }

    private String findResult(final double C, final double F, final double X) {
        double time = 0.0;
        double curRate = BASE_RATE;
        // new rate plus obtaining new rate cost is less than current rate cost
        while (((X / (curRate + F)) + (C / curRate)) < (X / curRate)) {
            time += C / curRate;
            curRate += F;
        }
        // consume remaining
        time += X / curRate;

        return df.format(time);
    }
}
