import java.util.*;
import static java.lang.System.out;

/**
 * Problem A. Magic Trick
 * NOTE: Good design practices are mostly ignored in programming contests.
 * 
 * @author DavidJennings
 */
public class GCJ2014QualProblemA {

    private Scanner in = new Scanner(System.in);
    public static final String BAD = "Bad magician!";
    public static final String CHEAT = "Volunteer cheated!";

    public static void main(String args[]) {
        try {
            (new GCJ2014QualProblemA()).goGo();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void goGo() {
        int T = in.nextInt();

        for (int i = 1; i <= T; i++) {
            int firstChoice = in.nextInt() - 1;
            Grid firstGrid = Grid.parseGrid(in);
            int secondChoice = in.nextInt() - 1;
            Grid secondGrid = Grid.parseGrid(in);
            String result = findResult(firstChoice, firstGrid,
                    secondChoice, secondGrid);
            out.println("Case #" + i + ": " + result);
        }
    }

    private String findResult(int fC, Grid fG, int sC, Grid sG) {
        Set<Integer> fPossible = fG.getRowValues(fC);
        Set<Integer> sPossible = sG.getRowValues(sC);
        fPossible.retainAll(sPossible);
        String output = BAD;

        if (fPossible.size() == 1) {
            output = String.valueOf(fPossible.iterator().next());
        } else if (fPossible.size() == 0) {
            output = CHEAT;
        }

        return output;
    }

    private static class Grid {
        private static final int SIZE = 4;
        public int[][] G = new int[SIZE][SIZE];

        private Grid() {
        }

        public static Grid parseGrid(Scanner in) {
            Grid grid = new Grid();
            for (int r = 0; r < SIZE; r++) {
                for (int c = 0; c < SIZE; c++) {
                    grid.G[r][c] = in.nextInt();
                }
            }
            return grid;
        }

        public Set<Integer> getRowValues(int r) {
            Set<Integer> set = new HashSet<Integer>();
            for (int c = 0; c < G.length; c++) {
                set.add(G[r][c]);
            }
            return set;
        }
    }
}
