import java.util.*;
import static java.lang.System.out;

/**
 * Tic-Tac-Toe-Tomek
 * NOTE: Good design practices are mostly ignored in programming contests.
 * @author DavidJennings
 *
 */
public class GCJ2013QualRoundProblemA {
	public static final int BOARD_SIZE = 4;
	private Scanner in = new Scanner(System.in);
	
	public static void main(String args[]) {
		try {
			(new GCJ2013QualRoundProblemA()).goGo();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void goGo() {
		int T = in.nextInt();
		for (int i = 0; i < T; i++) {
			in.nextLine(); // go to next line
			char[][] board = new char[BOARD_SIZE][BOARD_SIZE];
			for (short j = 0; j < BOARD_SIZE; j++) {
				String line = in.nextLine();
				for (short k = 0; k < BOARD_SIZE; k++) {
					board[j][k] = line.charAt(k);
				}
			}
			String result = processBoard(board);
			out.println("Case #" + (i + 1) + ": " + result);
		}
	}
	
	private String processBoard(char[][] board) {
		char[] players = new char[] { 'X', 'O' };
		for (byte p = 0; p < players.length; p++) {
			char[] values = new char[BOARD_SIZE];
			// test diagonals
			for (short k = 0; k < BOARD_SIZE; k++) {
				values[k] = board[k][k];
			}
			if (testWin(players[p], values)) {
				return players[p] + " won";
			}
			for (short k = 0; k < BOARD_SIZE; k++) {
				values[k] = board[k][BOARD_SIZE - 1 - k];
			}
			if (testWin(players[p], values)) {
				return players[p] + " won";
			}
			// test across and down
			char[] valuesDown = new char[BOARD_SIZE];
			for (short r = 0; r < BOARD_SIZE; r++) {
				for (short c = 0; c < BOARD_SIZE; c++) {
					values[c] = board[r][c];
					valuesDown[c] = board[c][r];
				}
				if (testWin(players[p], values)) { // across
					return players[p] + " won";
				}
				if (testWin(players[p], valuesDown)) { // down
					return players[p] + " won";
				}
			}
		}
		// no winner found
		if (gameCompleted(board)) {
			return "Draw";
		} else {
			return "Game has not completed";
		}
	}
	
	private boolean testWin(char player, char[] values) {
		short count = 0;
		for (short i = 0; i < values.length; i++) {
			if (values[i] == player || values[i] == 'T') {
				count++;
			}
		}
		return (count == values.length);
	}
	
	private boolean gameCompleted(char[][] board) {
		for (short i = 0; i < BOARD_SIZE; i++) {
			for (short j = 0; j < BOARD_SIZE; j++) {
				if (board[i][j] == '.') {
					return false;
				}
			}
		}
		return true;
	}
}
