
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

public class FairAndSquare
{

	private static PrintWriter pw;
	private static boolean test;
	private static BufferedReader br;

	public static void main( String[] args ) throws Exception
	{
		// Imprimir a la consola (true) o al archivo (false)
		test = false;
		String baseName = "C-small-attempt1"; // Nombre del archivo

		pw = null;
		if( !test )
		{
			pw = new PrintWriter( new File( "./data/" + baseName + ".out" ) );
		}

		// Abrir el archivo con los datos de entrada
		br = new BufferedReader( new FileReader( new File( "./data/" + baseName + ".in" ) ) );

		solucionarProblema( );

		// Si no era una prueba, cerrar el archivo de salida
		if( !test )
		{
			pw.close( );
		}

	}

	/**
	 * Imprimir una solucin al problema <br/>
	 * . Si el atributo test es verdadero, imprime a la salida estndar. Si es falso imprime al archivo de salida.
	 * @param solucion
	 */
	private static void imprimirSolucion( String solucion )
	{
		if( test )
		{
			System.out.println( solucion );
		}
		else
		{
			pw.println( solucion );
		}
	}

	/**
	 * Este es el mtodo que realmente soluciona el problema
	 * @throws IOException
	 */
	private static void solucionarProblema( ) throws IOException
	{
		int cases = Integer.parseInt( br.readLine( ) );
		int i = 0;
		while( i < cases )
		{
			String [] split = br.readLine().split(" ");
			int respuesta = solve(Integer.parseInt(split[0]), Integer.parseInt(split[1]));
			String solucion = "Case #" + ( i + 1 ) + ": " + respuesta;
			imprimirSolucion( solucion );
			i++;
		}
	}

	private static int solve( int inicio, int fin )
	{
		int raizInic = (int) Math.sqrt(inicio);
		if (Math.pow(raizInic, 2) < inicio)
		{
			raizInic ++;
		}
		int actual = darPalindromeMasCercano(raizInic);
		int contador = 0;
		int potencia = (int) Math.pow(actual, 2);
		while (potencia <= fin) {
			if (esPalindrome(potencia))
			{
				contador++;
			}
			actual = darPalindromeMasCercano( actual+1 );
			potencia = (int) Math.pow(actual, 2);
		}
		return contador;
	}

	private static int darPalindromeMasCercano ( int numero )
	{
		while (true)
		{
			if (esPalindrome(numero))
			{
				return numero;
			}
			else 
			{
				numero ++;
			}
		}
		
	}

	private static boolean esPalindrome ( int numero )
	{
		String numeroS = numero+"";
		int longitud = numeroS.length();
		int mitad = longitud/2;
		boolean esPalindrome = true;
		for (int i = 0; i < mitad && esPalindrome; i++) 
		{
			esPalindrome = numeroS.charAt(longitud-1-i) == numeroS.charAt(i);
		}
		return esPalindrome;
	}

	private static int avancePalindromes ( int numeroA )
	{
		String numeroAnterior = numeroA+"";
		int longitud = numeroAnterior.length();
		int numero = numeroA;
		if (longitud == 1)
		{
			return numero + 1;
		}
		else if (longitud % 2 == 0)	
		{
			int mitad = longitud /2;
			while (mitad < longitud)
			{
				char medio = numeroAnterior.charAt(mitad);
				if (Integer.parseInt(medio+"")!= 9)
				{
					int mascara = (int) Math.pow(10, mitad)+ (int) Math.pow(10, longitud-mitad-1);
					return numero + mascara;
				}
				mitad++;
			}
			return (int) Math.pow(10, longitud)+ 1;
		}
		else 
		{
			int mitad = longitud /2;
			int amplitud = 0;

			while (mitad + amplitud < longitud)
			{
				char medio = numeroAnterior.charAt(mitad + amplitud);
				if (Integer.parseInt(medio+"")!= 9)
				{
					int mascara = (int) Math.pow(10, mitad + amplitud)+ (int) Math.pow(10, mitad - amplitud);
					return numero + mascara;
				}
				amplitud++;
			}
			return (int) Math.pow(10, longitud)+ 1;
		}
	}

}