import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

public class Lawnmower
{

	private static PrintWriter pw;
	private static boolean test;
	private static BufferedReader br;

	public static void main( String[] args ) throws Exception
	{
		// Imprimir a la consola (true) o al archivo (false)
		test = false;
		String baseName = "B-small-attempt5"; // Nombre del archivo

		pw = null;
		if( !test )
		{
			pw = new PrintWriter( new File( "./data/" + baseName + ".out" ) );
		}

		// Abrir el archivo con los datos de entrada
		br = new BufferedReader( new FileReader( new File( "./data/" + baseName + ".in" ) ) );

		solucionarProblema( );

		// Si no era una prueba, cerrar el archivo de salida
		if( !test )
		{
			pw.close( );
		}

	}

	/**
	 * Imprimir una solucin al problema <br/>
	 * . Si el atributo test es verdadero, imprime a la salida estndar. Si es falso imprime al archivo de salida.
	 * @param solucion
	 */
	private static void imprimirSolucion( String solucion )
	{
		if( test )
		{
			System.out.println( solucion );
		}
		else
		{
			pw.println( solucion );
		}
	}

	/**
	 * Este es el mtodo que realmente soluciona el problema
	 * @throws IOException
	 */
	private static void solucionarProblema( ) throws IOException
	{
		int cases = Integer.parseInt( br.readLine( ) );
		int i = 0;
		while( i < cases )
		{
			String [] nXm = br.readLine().split(" ");
			int n = Integer.parseInt( nXm[ 0 ] );
			int m = Integer.parseInt( nXm[ 1 ] );
			int [ ][ ] plano = new int [ n ] [ m ];
			for ( int j = 0; j < n; j++ ) 
			{	
				String linea = br.readLine();
				String[ ] filaActual = linea.split(" "); 
				for (int k = 0; k < m; k++) {
					plano [ j ][ k ] = Integer.parseInt(filaActual[ k ]);
				}
			}
			String respuesta = solve (plano, n , m);
			String solucion = "Case #" + ( i + 1 ) + ": " + respuesta;
			imprimirSolucion( solucion );
			i++;
		}
	}

	private static String solve( int[][] plano, int n, int m )
	{
		boolean correcto = true;
		ArrayList<Integer> ns = new ArrayList<Integer>();
		for (int i = 0; i < n; i++ )
		{
			ns.add(i);
		}

		ArrayList<Integer> ms = new ArrayList<Integer>();
		for (int i = 0; i < m; i++ )
		{
			ms.add(i);
		}
		int menor = 1;
		while ( menor <= 100 && ms.size() != 0 && ns.size()!= 0 && correcto)
		{
			for (int i = 0; i < ns.size( ) && correcto; i++) 
			{
				boolean removerFila = false;
				for (int j = 0; j < ms.size() && correcto && !removerFila; j++) {
					Integer fila = ns.get( i );
					Integer columna = ms.get( j );
					int actual = plano [ fila ][ columna ];
					if ( actual == menor)
					{
						//FILA
						boolean menorFila = true;
						for (int k = 0; k < ms.size() && menorFila; k++) {
							menorFila = actual == plano[fila][ms.get(k)];
						}
						
						//Columna
						boolean menorColumna = true;
						for (int k = 0; k < ns.size() && menorColumna; k++) {
							menorColumna = actual == plano[ns.get(k)][columna];
						}
						
						if (menorFila)
						{
							ns.remove(fila);
							removerFila = true;
							i--;
						}
						if (menorColumna)
						{
							ms.remove(columna);
							j--;
						}
						if ( !menorFila && ! menorColumna)
						{
							correcto = false;
						}
					}
				}
			}
			menor ++;
		}
		if ( correcto )
		{
			return "YES";
		}
		else 
		{
			return "NO";
		}

	}

}