import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Stack;

public class Treasure
{

	private static PrintWriter pw;
	private static boolean test;
	private static BufferedReader br;

	public static void main( String[] args ) throws Exception
	{
		// Imprimir a la consola (true) o al archivo (false)
		test = false;
		String baseName = "D-small-attempt2"; // Nombre del archivo

		pw = null;
		if( !test )
		{
			pw = new PrintWriter( new File( "./data/" + baseName + ".out" ) );
		}

		// Abrir el archivo con los datos de entrada
		br = new BufferedReader( new FileReader( new File( "./data/" + baseName + ".in" ) ) );

		solucionarProblema( );

		// Si no era una prueba, cerrar el archivo de salida
		if( !test )
		{
			pw.close( );
		}

	}

	/**
	 * Imprimir una solucin al problema <br/>
	 * . Si el atributo test es verdadero, imprime a la salida estndar. Si es falso imprime al archivo de salida.
	 * @param solucion
	 */
	private static void imprimirSolucion( String solucion )
	{
		if( test )
		{
			System.out.println( solucion );
		}
		else
		{
			pw.println( solucion );
		}
	}

	/**
	 * Este es el mtodo que realmente soluciona el problema
	 * @throws IOException
	 */
	private static void solucionarProblema( ) throws IOException
	{
		int cases = Integer.parseInt( br.readLine( ) );
		int i = 0;
		while( i < cases )
		{
				//Keys and chests
				String [] kYn =  br.readLine().split(" ");
				//Keys
				int cantidadLlaves = Integer.parseInt( kYn[ 0 ] );
				ArrayList<String> llaves = new ArrayList<String>();
				String [] lineaLlaves = br.readLine().split(" ");
				for (int j = 0; j < cantidadLlaves; j++) 
				{
					llaves.add( lineaLlaves[ j ] );
				}
				//Chests
				int cantidadChests = Integer.parseInt( kYn[ 1 ] );
				ArrayList< Chest > chests = new ArrayList< Chest >( );
				for ( int j = 0; j < cantidadChests; j++ )
				{
					Chest e = new Chest(br.readLine(), j+1);
					chests.add(e);
				}
				Stack<Integer> camino = new Stack<Integer>();
				Collections.sort(llaves);
				System.out.println(i);
				solve(llaves, chests, camino);
				String respuesta = "";
				if (camino.isEmpty())
				{
					respuesta = " IMPOSSIBLE";
				}
				else 
				{
					Object [] caminoRespuesta = camino.toArray();
					for (int j = 0; j < caminoRespuesta.length; j++) {
						respuesta += " "+ (Integer) caminoRespuesta[j];
					}
				}
				String solucion = "Case #" + ( i + 1 ) + ":" + respuesta;
				imprimirSolucion( solucion );
			
			i++;
		}
	}

	private static boolean solve( ArrayList<String> llaves, ArrayList<Chest> chests, Stack< Integer > camino )
	{

		for (int i = 0; i < llaves.size( ); i++) 
		{
			for (int j = 0; j < chests.size( ); j++) 
			{
				ArrayList< String > nuevasLlaves = chests.get(j).abrirChest(llaves.get(i));
				if ( nuevasLlaves != null)
				{
					ArrayList<String> llavesActual = (ArrayList<String>) llaves.clone();
					ArrayList< Chest > chestsActual = (ArrayList<Chest>) chests.clone( );
					llavesActual.remove( i );
					llavesActual.addAll( nuevasLlaves );
					Collections.sort(llavesActual);
					Chest actual = chestsActual.remove( j );
					camino.push( actual.darId( ) );
					if ( chestsActual.size() != 0 && llavesActual.size() != 0)
					{
						if (solve(llavesActual, chestsActual, camino))
						{
							return true;
						}
					}
					else if ( chestsActual.size()==0)
					{
						return true;
					}
					camino.pop();
				}
			}
		}
		return false;
	}

}