import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

public class TicTacToe
{

	private static PrintWriter pw;
	private static boolean test;
	private static BufferedReader br;

	public static void main( String[] args ) throws Exception
	{
		// Imprimir a la consola (true) o al archivo (false)
		test = false;
		String baseName = "A-large"; // Nombre del archivo

		pw = null;
		if( !test )
		{
			pw = new PrintWriter( new File( "./data/" + baseName + ".out" ) );
		}

		// Abrir el archivo con los datos de entrada
		br = new BufferedReader( new FileReader( new File( "./data/" + baseName + ".in" ) ) );

		solucionarProblema( );

		// Si no era una prueba, cerrar el archivo de salida
		if( !test )
		{
			pw.close( );
		}

	}

	/**
	 * Imprimir una solucin al problema <br/>
	 * . Si el atributo test es verdadero, imprime a la salida estndar. Si es falso imprime al archivo de salida.
	 * @param solucion
	 */
	private static void imprimirSolucion( String solucion )
	{
		if( test )
		{
			System.out.println( solucion );
		}
		else
		{
			pw.println( solucion );
		}
	}

	/**
	 * Este es el mtodo que realmente soluciona el problema
	 * @throws IOException
	 */
	private static void solucionarProblema( ) throws IOException
	{
		char [ ][ ] tablero = new char [ 4] [ 4 ];
		int cases = Integer.parseInt( br.readLine( ) );
		int i = 0;
		while( i < cases )
		{
			for ( int j = 0; j < 4; j++ ) 
			{	
				String linea = br.readLine();
				tablero[ j ] = linea.toCharArray(); 
			}
			String respuesta = solve (tablero);
			String solucion = "Case #" + ( i + 1 ) + ": " + respuesta;
			imprimirSolucion( solucion );
			br.readLine();
			i++;
		}
	}

	private static String solve( char[][] tictac )
	{
		char actualCorrecto = 'F';
		boolean espacio = false;
		//Caso primera diagonal
		boolean diagonal1 = true;
		for ( int i = 0; i < 4 && diagonal1; i++ )
		{
			char leido = tictac[i][i];
			if ( leido == '.')
			{
				espacio = true;
				diagonal1 = false;
			}
			else if (leido != 'T' && actualCorrecto == 'F')
			{
				actualCorrecto = leido;
			}
			else if ( leido != 'T' && actualCorrecto != leido )
			{
				diagonal1 = false;
			}
		}	
		if ( diagonal1 )
		{
			return actualCorrecto + " won";
		}
		actualCorrecto = 'F';

		//Caso Segunda diagonal
		boolean diagonal2 = true;
		for ( int i = 0; i < 4 && diagonal2; i++ )
		{
			char leido = tictac[i][3-i];
			if ( leido == '.')
			{
				espacio = true;
				diagonal2 = false;
			}
			else if (leido != 'T' && actualCorrecto == 'F')
			{
				actualCorrecto = leido;
			}
			else if ( leido != 'T' && actualCorrecto != leido )
			{
				diagonal2 = false;
			}
		}	
		if ( diagonal2 )
		{
			return actualCorrecto + " won";
		}

		//Filas
		boolean filas = false;
		for ( int i = 0; i < 4 && !filas; i++ )
		{
			actualCorrecto = 'F';
			boolean filaActual = true;
			for (int j = 0; j < 4 && filaActual; j++) {
				char leido =  tictac[i][j];
				if ( leido == '.' )
				{
					espacio = true;
					filaActual = false;
				}
				else if (leido != 'T' && actualCorrecto == 'F')
				{
					actualCorrecto = leido;
				}
				else if (leido != 'T' && actualCorrecto != leido)
				{
					filaActual = false;
				}
			}
			filas = filaActual;
		}
		if ( filas )
		{
			return actualCorrecto + " won";
		}

		//columnas
		boolean columnas = false;
		for ( int j = 0; j < 4 && !columnas; j++ )
		{
			actualCorrecto = 'F';
			boolean columnaActual = true;
			for (int i = 0; i < 4 && columnaActual; i++) {
				char leido =  tictac[i][j];
				if ( leido == '.' )
				{
					espacio = true;
					columnaActual = false;
				}
				else if (leido != 'T' && actualCorrecto == 'F')
				{
					actualCorrecto = leido;
				}
				else if (leido != 'T' && actualCorrecto != leido)
				{
					columnaActual = false;
				}
			}
			columnas = columnaActual;
		}
		if ( columnas )
		{
			return actualCorrecto + " won";
		}

		if ( espacio )
		{
			return "Game has not completed";
		}
		else 
		{
			return "Draw";
		}

	}

}