package codejam.qualy;

import java.io.FileReader;
import java.io.IOException;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.StringTokenizer;

public class BotTrust {

	public static void main(String[] args) throws IOException {
		List<String> input = readLines("A-large.in");
		int N = Integer.valueOf(input.get(0).trim());

		for (int i = 1; i <= N; i++) {
			int secs = solve(input.get(i).trim());
			System.out.println("Case #" + i + ": " + secs);
		}

	}

	private static int solve(String test) {
		int count = 0;

		int destO = -1;
		int destB = -1;

		int posO = 1;
		int posB = 1;

		int actionIndexO = -1;
		int actionIndexB = -1;

		boolean inActionO = false;
		boolean inActionB = false;

		StringTokenizer tokenizer = new StringTokenizer(test, " ");
		List<String> actions = new ArrayList<String>();

		int instr = Integer.valueOf(tokenizer.nextToken());
		for(int i = 0; i < instr; i++){
			String robot = tokenizer.nextToken();
			String number = tokenizer.nextToken();
			actions.add(robot + " " + number);
		}

		while (true) {

			if (!inActionO) {
				for (int i = 0; i < actions.size(); i++) {

					String[] action = actions.get(i).split(" ");
					String robot = action[0];
					int number = Integer.parseInt(action[1]);

					if (robot.equals("O") && !inActionO) {
						destO = number;
						inActionO = true;
						actionIndexO = i;
						break;
					}
				}
				if (!inActionO) {
					actionIndexO = Integer.MAX_VALUE;
				} else {
					actions.set(actionIndexO, "X 0");
				}
			}

			if (!inActionB) {
				for (int i = 0; i < actions.size(); i++) {

					String[] action = actions.get(i).split(" ");
					String robot = action[0];
					int number = Integer.parseInt(action[1]);

					if (robot.equals("B") && !inActionB) {
						destB = number;
						inActionB = true;
						actionIndexB = i;
						break;
					}
				}
				if (!inActionB) {
					actionIndexB = Integer.MAX_VALUE;
				} else {
					actions.set(actionIndexB, "X 0");
				}
			}

			if (inActionO) {
				if (posO < destO) {
					posO++;
				} else if (posO > destO) {
					posO--;
				} else {
					if (actionIndexO < actionIndexB) {
						inActionO = false;
						// count++;
					}
				}
			}

			if (inActionB) {
				if (posB < destB) {
					posB++;
				} else if (posB > destB) {
					posB--;
				} else {
					if (actionIndexB < actionIndexO) {
						inActionB = false;
						// count++;
					}
				}
			}

			if (actionIndexB == Integer.MAX_VALUE && actionIndexO == Integer.MAX_VALUE) {
				break;
			}

			count++;

		}

		return count;

	}

	private static List<String> readLines(String path) throws IOException {
		StringWriter writer = new StringWriter();
		FileReader reader = new FileReader(path);

		char[] buffer = new char[1024];
		while (reader.read(buffer) != -1) {
			writer.write(buffer);
		}
		reader.close();
		writer.close();
		return Arrays.asList(writer.toString().split("\n"));
	}

}
