package codejam.qualy;

import java.io.*;
import java.util.*;

public class Magicka {

	public static void main(String[] args) throws IOException {
		List<String> input = readLines("B-large.in");
		int N = Integer.valueOf(input.get(0).trim());

		for (int i = 1; i <= N; i += 1) {
			String solution = solve(input.get(i));
			System.out.println("Case #" + i + ": " + solution);
		}

	}

	private static String solve(String test) {
		StringTokenizer tokenizer = new StringTokenizer(test);

		int C = Integer.parseInt(tokenizer.nextToken());
		List<String> combinations = new ArrayList<String>();
		for (int i = 0; i < C; i++) {
			combinations.add(tokenizer.nextToken());
		}

		int D = Integer.parseInt(tokenizer.nextToken());
		List<String> opposed = new ArrayList<String>();
		for (int i = 0; i < D; i++) {
			opposed.add(tokenizer.nextToken());
		}

		int N = Integer.parseInt(tokenizer.nextToken());
		String text = tokenizer.nextToken();

		String elementList = "";

		for (int i = 0; i < N; i++) {
			elementList = invoke(elementList, text.substring(i, i + 1), combinations, opposed);
		}

		String result = "[";
		for (int i = 0; i < elementList.length(); i++) {
			result += elementList.charAt(i);
			if (i < elementList.length() - 1) {
				result += ", ";
			}
		}
		result += "]";
		return result;
	}

	private static String invoke(String elementList, String element, List<String> combinations, List<String> opposed) {
		String newElementList = elementList + element;
		newElementList = combine(newElementList, combinations);
		newElementList = oppose(newElementList, opposed);
		return newElementList;
	}

	private static String combine(String text, List<String> combinations) {
		for (String comb : combinations) {
			String base = comb.substring(0, 2);
			String baseR = new StringBuilder(base).reverse().toString();
			String replacement = comb.substring(2, 3);
			if (text.endsWith(base) || text.endsWith(baseR)) {
				return text.substring(0, text.length() - 2) + replacement;
			}
		}
		return text;
	}

	private static String oppose(String text, List<String> opposed) {
		for (String opp : opposed) {
			String base1 = opp.substring(0, 1);
			String base2 = opp.substring(1, 2);
			if (text.endsWith(base1)) {
				int index = text.lastIndexOf(base2);
				if (index != -1) {
					return "";
				}
			}

			if (text.endsWith(base2)) {
				int index = text.lastIndexOf(base1);
				if (index != -1) {
					return "";
				}
			}

		}
		return text;
	}

	private static List<String> readLines(String path) throws IOException {
		StringWriter writer = new StringWriter();
		FileReader reader = new FileReader(path);

		char[] buffer = new char[1024];
		while (reader.read(buffer) != -1) {
			writer.write(buffer);
		}
		reader.close();
		writer.close();
		return Arrays.asList(writer.toString().split("\n"));
	}

}
