package codejam.qualy;

import java.io.*;
import java.util.*;

public class CandySplitting {

	public static void main(String[] args) throws IOException {
		List<String> input = readLines("C-small-attempt1.in");
		int N = Integer.valueOf(input.get(0).trim());

		for (int i = 1; i <= 2 * N; i += 2) {
			int elem = Integer.valueOf(input.get(i).trim());
			String[] bagStr = input.get(i + 1).trim().split(" ");
			long[] bag = new long[elem];
			for (int j = 0; j < bagStr.length; j++) {
				bag[j] = Long.parseLong(bagStr[j]);
			}
			long sum = solve(bag);
			System.out.println("Case #" + (i / 2 + 1) + ": " + (sum == -1 ? "NO" : sum));
		}

	}

	private static long solve(long[] bag) {
		long sum = -1;
		for (long i = 1; i <= Math.pow(2, bag.length); i++) {
			List<Long> bag1 = new ArrayList<Long>();
			List<Long> bag2 = new ArrayList<Long>();
			for (int j = 0; j < bag.length; j++) {
				long mask = (long) Math.pow(2, j);
				boolean include = (mask & i) == 0;
				if (include) {
					bag1.add(bag[j]);
				} else {
					bag2.add(bag[j]);
				}
			}
			if (bag1.isEmpty() || bag2.isEmpty()) {
				continue;
			}
			long sum1 = badSum(bag1);
			long sum2 = badSum(bag2);
			if (sum1 == sum2) {
				long okSum1 = okSum(bag1);
				long okSum2 = okSum(bag2);
				if (okSum1 > sum) {
					sum = okSum1;
				}
				if (okSum2 > sum) {
					sum = okSum2;
				}
			}
		}
		return sum;
	}

	private static long okSum(List<Long> bag) {
		long sum = 0;
		for (long val : bag) {
			sum = sum + val;
		}
		return sum;
	}

	private static long badSum(List<Long> bag) {
		long sum = bag.get(0);
		for (int i = 1; i < bag.size(); i++) {
			long val = bag.get(i);
			sum = sum ^ val;
		}
		return sum;
	}

	private static List<String> readLines(String path) throws IOException {
		StringWriter writer = new StringWriter();
		FileReader reader = new FileReader(path);

		char[] buffer = new char[1024];
		while (reader.read(buffer) != -1) {
			writer.write(buffer);
		}
		reader.close();
		writer.close();
		return Arrays.asList(writer.toString().split("\n"));
	}

}
