import java.util.Random;

/**
 * Created by david on 12/04/14.
 */
public class MineSweeper {

    private String[][] minesweeper;
    private static int emptyCells;
    private int cont;
    private boolean[][] isViewed;

    public MineSweeper() {}

    public boolean canBeResolved() {
        boolean result = false;
        for (int i = 0; i < minesweeper.length; i++){
            for (int j = 0 ; j < minesweeper[i].length; j++){
                if(minesweeper[i][j].equals("*")){
                    continue;
                }else{
                    cont = 0;
                    isViewed = new boolean[minesweeper.length][minesweeper[i].length];
                    viewCell(i, j);
                    if(cont == emptyCells){
                        minesweeper[i][j] = "c";
                        return true;
                    }
                }
            }
        }
        return result;
    }

    private void viewCell(int x, int y){
        cont++;

        if(isViewed[x][y] != true){
            isViewed[x][y] = true;
            if(x < minesweeper.length - 1)
                if(minesweeper[x + 1][y].equals("."))
                    viewCell(x + 1, y);
            if(x > 0)
                if(minesweeper[x - 1][y].equals("."))
                    viewCell(x -1, y);
            if(y < minesweeper[x].length - 1)
                if(minesweeper[x][y + 1].equals("."))
                    viewCell(x, y +1);
            if(y > 0)
                if(minesweeper[x][ y - 1].equals(""))
                    viewCell(x, y - 1);
        }
    }


    public void generateMinesweeper(int row, int column, int mines) {
        String[][] mw = new String[row][column];
        emptyCells = row * column - mines;

        for(int i = 0; i < row; i++){
            for(int j = 0; j < column; j++){
                mw[i][j] = "*";
            }
        }

        for (int j = 0; j < emptyCells; j++){
            Random rand = new Random();
            for(;;){
                int x = rand.nextInt(row);
                int y = rand.nextInt(column);
                if(mw[x][y].equals("*")){
                    mw[x][y] = ".";
                    break;
                }
            }

        }

        this.minesweeper = mw;
    }

    @Override
    public String toString() {
        String s = "";
        for (int i = 0; i < minesweeper.length; i++){
            for (int j = 0 ; j < minesweeper[i].length; j++){
                s += minesweeper[i][j] +" ";
            }
            s += "\n";
        }
        return s;
    }
}