import java.util.*;
import java.io.*;

public class Goro {
    public static void main(String[] args) throws Exception {
        long startTime = System.currentTimeMillis();
        if(args.length<1) {
            System.out.println("No input filename");
            System.exit(1);
        }

        String outputFilename;
        
        try {
            FileReader fReader = new FileReader(args[0]);
            BufferedReader bReader = new BufferedReader(fReader);
            
            int maxCase = 0;
            
            // get number of case
            String tempLine = bReader.readLine().trim();
            
            maxCase = toInt(tempLine);

            if (!(maxCase>=1 && maxCase<=100)) {
                System.err.println("Invalid number of case.");
                System.exit(6);
            }

            if (args[0].lastIndexOf('.')!=-1) {
                outputFilename = args[0].substring(0,args[0].lastIndexOf('.'))+".out";
            } else {
                outputFilename = args[0] + ".out";
            }
            FileWriter fWriter = new FileWriter(outputFilename);
            BufferedWriter bWriter = new BufferedWriter(fWriter);

            String caseLine;

            int n;

            for (int currentCase=1; currentCase<=maxCase; currentCase++) {
                Double res=0.0;
            
                n=toInt(bReader.readLine().trim());

                caseLine = bReader.readLine().trim();
                String[] rawCaseData = caseLine.split("\\s+");

                Boolean[] frozen = new Boolean[n];
                Integer[] nums = new Integer[n];
                
                for (int i=0;i<n;i++) {
                    nums[i]=toInt(rawCaseData[i]);
                    //System.out.println(i+": "+nums[i]);

                    frozen[i] = new Boolean(true);
                    if (nums[i]==i+1) {
                        frozen[i] = true;
                        //System.out.println(i+": "+nums[i]);
                    } else {
                        frozen[i] = false;
                    }
                }

                int i=0;
                Boolean done=new Boolean(false);
                while (!done) {
                    done=true;
                    

                    if (!frozen[i]) {
                        //System.out.println(i+": "+nums[i]);

                        done=false;

                        if (nums[nums[i]-1]==i+1) {
                            //System.out.println("a: ");
                            nums[nums[i]-1]=nums[i];
                            frozen[nums[i]-1]=true;
                            nums[i]=i+1;
                            frozen[i]=true;
                        } else {
                            //System.out.println("b: ");
                            int temp=nums[nums[i]-1];
                            nums[nums[i]-1]=nums[i];
                            frozen[nums[i]-1]=true;
                            nums[i]=temp;
                        }
                        i=0;
                        res+=2.0;
                        /*
                        for (int o=0;o<n;o++) {
                            System.out.print(nums[o]+ " ");
                        }
                        System.out.println();
                        for (int o=0;o<n;o++) {
                            System.out.print((frozen[o]?"t":"f") + " ");
                        }
                        System.out.println();
                        */
                    }
                    i++;
                    if (i<n) {
                        done=false;
                    }
                }

                StringBuffer caseResult = new StringBuffer("Case #"+currentCase+": "+String.format("%.6f", res));
                System.out.println(caseResult.toString());
                bWriter.write(caseResult.toString(),0,caseResult.length());
                bWriter.newLine();
            }

            bReader.close();
            bWriter.close();
        } catch (IOException e) {
            System.err.println(e.toString());
            System.exit(2);
        }

        long endTime = System.currentTimeMillis();
        System.err.println((endTime-startTime)+"ms");
    }

    public static int toInt(String input) {
        int res = 0;
        try {
            res = Integer.parseInt(input);
        } catch (NumberFormatException e) {
            System.err.println(e.toString());
            System.exit(3);
        }
        return res;
    }

}
