package googlecodejam;

import java.util.Scanner;

public class Watersheds {
	static Scanner in;

	int[] directionsx = {0, -1, 1, 0};
	int[] directionsy = {1, 0, 0, -1};
	
	

	public static void main(String[] args)
	{
		new Watersheds();
	}
	
	int[][] altitudes;
	char[][] labels;
	
	public Watersheds()
	{
		in = new Scanner(System.in);

		int testCount = in.nextInt();

		for( int caseNo = 1; caseNo <= testCount; caseNo++ )
		{
			// input
			int height = in.nextInt();
			int width = in.nextInt();
			
			altitudes = new int[width][height];
			labels = new char[width][height];
			
			for( int y = height-1; y >=0; y-- )
			{
				for( int x = 0; x < width; x++ )
				{
					altitudes[x][y] = in.nextInt();
					labels[x][y] = 0;
				}
			}
			

			// processing
			
			char nextLabel = 'a';
			for( int y = height-1; y >= 0; y-- )
			{
				for( int x = 0; x < width; x++ )
				{
					if( drainsTo(x, y, nextLabel) == nextLabel)
						nextLabel++;
				}
			}
			
			// output
			System.out.println("Case #" + caseNo + ": ");
			
			for( int y = height-1; y>=0; y-- )
			{
				for( int x = 0; x < width; x++ )
				{
					System.out.print(labels[x][y]);
					if ( x + 1 < width )
						System.out.print(" ");
				}
				System.out.println();
			}
			
		}
	}

	
	char drainsTo(int x, int y, char nextLabel)
	{
		char label = labels[x][y];
		
		if( label == 0 )
		{
		
		boolean drains = false;
		int lowestx = x;
		int lowesty = y;
		
		for( int i = 0; i < 4; i++ )
		{
			int x2 = x + directionsx[i];
			int y2 = y + directionsy[i];
			
			if( getAltitude( x2, y2) < getAltitude(lowestx,lowesty))
			{
				lowestx = x2;
				lowesty = y2;
				drains = true;
			}
		}
		
		if( drains )
		{
			label = drainsTo(lowestx, lowesty, nextLabel);
		}
		else
		{
			label = nextLabel;
		}
		
		labels[x][y] = label;
		}
		return label;		
	}
	int getAltitude(int x, int y)
	{
		if( x < 0 ||
			x >= altitudes.length ||
			y < 0 ||
			y >= altitudes[0].length )
			return Integer.MAX_VALUE; 
		
		return altitudes[x][y];
	}
	
}
