package home;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Scanner;

/**
 * CodeJam Qualification Round. 
 * Problem A. Oversized Pancake Flipper
 * @author alexandrpiskun@gmail.com
 * 
 * */
public class TidyNumbers {
	/**
	 * Internal class for solving particular pancake case.
	 * */
	private static class TidyNumbersCase{
		
		int[] number;
		int   numlen;
		/**
		 * @param case_task  String representation of the case. Example "--+--"
		 * */
		public TidyNumbersCase(String text){
			number = new int[text.length()];
			numlen = text.length();
			for(int i=0;i < text.length();i++){
				number[i] = (int)(text.charAt(i)-'0');
			}
		}
		
		/**
		 * @return   number of manipulations for this case.
		 * */
		public String solve(){
			int i=0;
			for(;i<number.length-1;i++){
				if (number[i]>number[i+1]){
					int j=i+1;
					while(j<number.length){
						number[j]=9; j++;
					}
					break;
				}
			}
			
			if(i!=number.length-1){
				while(i>=0){
					// minus
					number[i] = (number[i]==0)?9:number[i]-1;
					if (i>0 && number[i-1]>number[i]){
						number[i] = 9;
						i--;
					} else {
						break;
					} 
					
				}
			}

			
			
			StringBuilder sb=new StringBuilder();
			boolean hz = true;
			for(i = 0; i < number.length;i++){
				if(number[i]==0 && hz ==true){
					continue;
				}else{
					hz = false;
				}
				sb.append(number[i]);
			}
			return  sb.toString();
		}
		
	}
											    	
	private static String CASE_OUTPUT_FORMAT = "Case #%d: %s";
	
	/**
	 * Main method the class.
	 * @param Name of file in resources.
	 * */
	public void process(Scanner input){
		int T = input.nextInt();
		for(int case_number=1;case_number <= T;case_number++){
			String case_string = input.next();
			String result = new TidyNumbersCase(case_string).solve();
			System.out.println(String.format(CASE_OUTPUT_FORMAT, case_number, result));	
		}
		
	}
	
	public static void main(String[] args) {
		
		if (args!=null && args.length > 1 && "-d".equals(args[0]) ){
			try(Scanner input = new Scanner(new File(args[1]))){
				new TidyNumbers().process(input);
			} catch(Exception e){
				System.out.println("Exception during attempt to read file.");
				System.out.println("Exception " + e.getMessage());
			}
		}else{
			Scanner input = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
			new TidyNumbers().process(input);
		}
		
	}

}
