package home;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Scanner;

/**
 * CodeJam Qualification Round. 
 * Problem A. Oversized Pancake Flipper
 * @author alexandrpiskun@gmail.com
 * 
 * */
public class OversizedPancakeFlipper {
	/**
	 * Internal class for solving particular pancake case.
	 * */
	private static class OversizedPancakeFlipperCase{
		/**
		 * Keep number of swaps for case.
		 * */
		private  int number_of_swaps = 0;
		
		/**
		 * Keep information about pancakes as array  
		 */
		boolean  pancakeRange[] = null;
		int K = 0;
		
		/**
		 * @param case_task  String representation of the case. Example "--+--"
		 * */
		public OversizedPancakeFlipperCase(Scanner scan){
			String  range = scan.next();
			K = scan.nextInt();
			this.pancakeRange = new boolean[range.length()];
			int i = 0;
			for(char c :range.toCharArray()){
				if(c=='+'){
					this.pancakeRange[i] = true;
				}
				i++;
			}
		}
		
		
		/**
		 * @return   number of manipulations for this case.
		 * */
		public int solve(){
			int s = 0;
			int h = 0;
			
			for(boolean p :pancakeRange){
				if(p){
					h++;
				} else {
					s++;
				}
			}
			// if (s%K!=0 && h%K !=0){
			//	number_of_swaps = -1;
			//	return number_of_swaps;
			// } 
			
			if (h==pancakeRange.length){
				return 0;
			}
			if (s==pancakeRange.length){
				return s%K==0?s/K:-1;
			}
			int i=0;
			for (i=0; i<pancakeRange.length;){
				if (pancakeRange[i]!=true){
					if( i<=(pancakeRange.length-K) ){
						int j=i;
						while(j<i+K){
							pancakeRange[j] = !pancakeRange[j];
							j++;
						}
						number_of_swaps++;						
					} else {
						number_of_swaps =-1;
					}
				} 
				i++;
			}
			
			return this.number_of_swaps;
		}
		
	}
											    	
	private static String CASE_OUTPUT_FORMAT = "Case #%d: %s";
	
	/**
	 * Main method the class.
	 * @param Name of file in resources.
	 * */
	public void process(Scanner input){
		int T = input.nextInt();
		for(int case_number=1;case_number <= T;case_number++){
			//String case_string = input.next();
			int result = new OversizedPancakeFlipperCase(input).solve();
			System.out.println(String.format(CASE_OUTPUT_FORMAT, case_number,
								 (result==-1)?"IMPOSSIBLE": ""+result  ) );	
		}
		
	}
	
	public static void main(String[] args) {
		
		if (args!=null && args.length > 1 && "-d".equals(args[0]) ){
			try(Scanner input = new Scanner(new File(args[1]))){
				new OversizedPancakeFlipper().process(input);
			} catch(Exception e){
				System.out.println("Exception during attempt to read file.");
				System.out.println("Exception " + e.getMessage());
			}
		}else{
			Scanner input = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
			new OversizedPancakeFlipper().process(input);
		}
		
	}

}
