import java.io.*;
import java.util.*;


public class SavingTheUniverse {
   public static long counter;
   /**
    * @param args Filename of Input File.
    */
   public static void main(String[] args) {
      new SavingTheUniverse(args[0]);
   }
   
   /**
    * Constructor.
    * @param filename   Filename of input file to open.
    */
   public SavingTheUniverse(String filename){
      File f = new File(filename);
      
      if (!f.exists()){
         System.out.println("Cannot Find File. Exiting");
         System.exit(0);
      }
      
      String[] result = parseFile(f);
      
      try{
         PrintWriter output = new PrintWriter(new BufferedWriter(new FileWriter(new File("output.txt"))));
         
         for (String s : result){
            output.println(s);
         }
         
         output.close();
      }catch(IOException e){
      }
      
   }
   
   public String[] parseFile(File f){
      Scanner input = null;
      String output[];
      
      int testCount;
      
      /* Open File */
      try{
         input = new Scanner(f);
      }catch(FileNotFoundException e){
      }
      
      testCount = Integer.parseInt(input.nextLine());
      System.out.println(testCount + " Tests");
      output = new String[testCount];
      
      for (int i = 0; i < testCount; i++){
         System.out.println("Test #" + (i+1));
         
         String engines[],queries[];
         int temp; 
         
         /* Get Engines */
         temp = Integer.parseInt(input.nextLine());
         engines = new String[temp];
         
         for (int o = 0; o < temp; o++){
            engines[o] = input.nextLine();
         }
         
         /* Get Queries*/
         temp = Integer.parseInt(input.nextLine());
         queries = new String[temp];
         
         for (int o = 0; o < temp; o++){
            queries[o] = input.nextLine();
         }
         
         output[i] = "Case #" + (i+1) + ": " + calculateOptimalSolution(engines, queries); 
         System.out.println(output[i]);
         System.out.println("=============");
      }
      
      return output;
   }
   
   public int calculateOptimalSolution(String engines[], String queries[]){
      counter = 0;
      System.out.print("Engines: ");
      for(String s : engines){
         System.out.print(s + " ");
      }
      System.out.println();
      
      System.out.print("Queries: ");
      for(String s : queries){
         System.out.print(s + " ");
      }
      System.out.println();
      
      return calculateResult(engines,queries);
   }
   
   public int calculateResult(String engines[], String queries[]){
      int qIndex, bestEngine, bestCoverage, totalShifts;
      
      if (queries.length == 0){
         return 0;
      }
      
      qIndex = 0;
      totalShifts = 0;
      
      while(true){
         bestEngine = -1;
         bestCoverage = -1;
         
         for (int i = 0; i < engines.length; i++ ){
            if (engines[i].equals(queries[qIndex])){ continue; }
            if(bestEngine == i){continue;}
            
            if (bestEngine == -1){
               bestCoverage = findCoverage(engines[i],queries, qIndex);
               bestEngine = i;
            }else{
               int result = findCoverage(engines[i], queries, qIndex);
               if (result > bestCoverage){
                  bestEngine = i;
                  bestCoverage = result;
               }
            }
         }
         
         System.out.printf("Best Engine: %s (%d)\n", engines[bestEngine], bestCoverage);
         
         qIndex += bestCoverage;
         if (qIndex >= queries.length){
            break;
         }
         
         totalShifts ++;
      }
      
      return totalShifts;
   }
   
   public int findCoverage(String engine, String queries[],int queryIndex){
      int count = 0;
      while(true){
         if(queryIndex >= queries.length){
            break;
         }
         if (queries[queryIndex].equals(engine)){
            break;
         }
         
         count++;
         queryIndex ++;
      }
      
      return count;
   }
}
