

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class SR1_1 {
   /**
    * @param args Filename of Input File.
    */
   public static void main(String[] args) {
      new SR1_1(args[0]);
   }
   
   /**
    * Constructor.
    * @param filename   Filename of input file to open.
    */
   public SR1_1(String filename){
      File f = new File(filename);
      
      if (!f.exists()){
         System.out.println("Cannot Find File. Exiting");
         System.exit(0);
      }
      
      String[] result = parseFile(f);
      
      try{
         PrintWriter output = new PrintWriter(new BufferedWriter(new FileWriter(new File("output.txt"))));
         
         for (String s : result){
            output.println(s);
         }
         
         output.close();
      }catch(IOException e){
      }
      
   }
   
   
   public String[] parseFile(File f){
      Scanner input = null;
      String output[] = null;
      
      int testCount;
      
      /* Open File */
      try{
         input = new Scanner(f);
      }catch(FileNotFoundException e){
      }
      
      testCount = Integer.parseInt(input.nextLine());
      System.out.println(testCount + " Tests");
      output = new String[testCount];

      for (int i = 0; i < testCount; i++){
         /* Put your Shit Here. */
         int vectors = input.nextInt();
         System.out.println("Number of Vectors = " + vectors );
         
         int[] v1 = new int[vectors];
         int[] v2 = new int[vectors];
         
         for (int j = 0; j < vectors; j++){
            v1[j] = input.nextInt();
         }
         for (int j = 0; j < vectors; j++){
            v2[j] = input.nextInt();
         }
         
         int result =scalar(v1,v2,vectors);
         
         output[i] = "Case #" + (i+1) + ": " + result; // Plus Whatever Here 
      }
      
      input.close();
      return output;
   }
   
   private int scalar(int[] v1, int[] v2, int size){
      Arrays.sort(v1);
      Arrays.sort(v2);
      
      System.out.println(Arrays.toString(v1));
      System.out.println(Arrays.toString(v2));
      
      int temp = 0;
      
      for(int i = 0; i < size; i ++){
         temp += v1[i]*v2[size-i-1];
      }
      return temp;
   }
   
}
