import java.io.BufferedReader;
import java.io.File;
import java.io.FileFilter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public class InfiniteHouseOfPancakes {

	public static class Data {

		List<Integer> plates = new ArrayList<Integer>();

		String result = "";

		public Data(Iterator<String> it) throws IOException {
			String line = it.next();
			line = it.next();
			System.out.println(line);
			for (String strNb : line.split(" ")) {
				int nb = Integer.parseInt(strNb);
				plates.add(nb);
			}
		}

		public boolean isEndExploration() {
			for (Integer nb : plates) {
				if (nb > 1) {
					return false;
				}
			}
			return true;
		}

		public void process() {
			int best = Integer.MAX_VALUE;
			int nbIter = 0;
			while (!isEndExploration()) {
				Collections.sort(plates);
				int nbMax = plates.remove(plates.size() - 1);
				if (nbIter + nbMax < best) {
					best = nbIter + nbMax;
				}
				if (nbMax > 1) {
					int nb1 = nbMax / 2;
					int nb2 = nb1;
					if (nb1 * 2 < nbMax) {
						nb2++;
					} else if (nb1 * 2 > nbMax) {
						nb2--;
					}
					plates.add(nb1);
					plates.add(nb2);
				}
				nbIter++;
			}
			if (best == Integer.MAX_VALUE) {
				result = "1";
			} else {
				result = "" + best;
			}
		}
	}

	public static List<Data> DATA_LIST = new ArrayList<InfiniteHouseOfPancakes.Data>();

	public static void main(String[] args) throws IOException {

		// Get the data file not processed
		File dataFile = System.getProperty("dataFile") != null ? new File(
				System.getProperty("dataFile")) : null;
		if (dataFile == null) {
			for (File f : new File(".").listFiles(new FileFilter() {
				@Override
				public boolean accept(File file) {
					return file.isFile() && file.getName().endsWith(".in")
							&& !file.getName().startsWith("res-")
							&& !new File("res-" + file.getName()).exists();
				}
			})) {
				dataFile = f;
				break;
			}
		}

		if (dataFile != null) {

			// Load data
			try (BufferedReader buffer = new BufferedReader(new FileReader(
					dataFile));) {
				Iterator<String> it = buffer.lines().iterator();
				int nbDatas = Integer.parseInt(it.next());
				System.out.println("nbDatas=" + nbDatas);
				while (it.hasNext()) {
					DATA_LIST.add(new Data(it));
				}
				System.out.println("# Data file loaded");

				// Process data
				DATA_LIST.parallelStream().forEach(d -> {
					d.process();
				});
				System.out.println("# Data processed");

				// Print results
				try (FileWriter fw = new FileWriter("res-" + dataFile.getName());) {
					for (int i = 0; i < DATA_LIST.size(); i++) {
						String l = String.format("Case #%d: %s\n", i + 1,
								DATA_LIST.get(i).result);
						System.out.print(l);
						fw.write(l);
					}
				}
			}
		} else {
			System.err.println("Not input data file !");
		}
	}

}
