import java.io.BufferedReader;
import java.io.File;
import java.io.FileFilter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

public class CountingSheep {

	public static class Data {

		int N;
		Set<String> digits = new HashSet<String>();
		String result = "";

		public Data(Iterator<String> it) throws IOException {
			String line = it.next();
			N = Integer.parseInt(line);
		}

		public boolean isFallingAsSleep() {
			return digits.size() == 10;
		}

		public void newValue(Integer val) {
			String tmp = val.toString();
			for (int i = 0; i < tmp.length(); i++) {
				digits.add(tmp.substring(i, i + 1));
			}
		}

		public void process() {
			if (N == 0) {
				result = "INSOMNIA";
			} else {
				newValue(N);
				int i = 1;
				int tmp = N * i;
				while (!isFallingAsSleep()) {
//					System.out.println(tmp);
//					System.out.println(Arrays.asList(digits));
					i++;
					tmp = N * i;
					newValue(tmp);
				}
				result = "" + tmp;
			}

		}
	}

	public static List<Data> DATA_LIST = new ArrayList<CountingSheep.Data>();

	public static void main(String[] args) throws IOException {

		// Get the data file not processed
		File dataFile = System.getProperty("dataFile") != null ? new File(
				System.getProperty("dataFile")) : null;
		if (dataFile == null) {
			for (File f : new File(".").listFiles(new FileFilter() {
				@Override
				public boolean accept(File file) {
					return file.isFile() && file.getName().endsWith(".in")
							&& !file.getName().startsWith("res-")
							&& !new File("res-" + file.getName()).exists();
				}
			})) {
				dataFile = f;
				break;
			}
		}
		if (dataFile != null) {

			// Load data
			try (BufferedReader buffer = new BufferedReader(new FileReader(
					dataFile));) {
				Iterator<String> it = buffer.lines().iterator();
				int nbDatas = Integer.parseInt(it.next());
				System.out.println("nbDatas=" + nbDatas);
				while (it.hasNext()) {
					DATA_LIST.add(new Data(it));
				}
				System.out.println("# Data file loaded");

				// Process data
				DATA_LIST.parallelStream().forEach(d -> {
					d.process();
				});
				System.out.println("# Data processed");

				// Print results
				try (FileWriter fw = new FileWriter("res-" + dataFile.getName());) {
					for (int i = 0; i < DATA_LIST.size(); i++) {
						String l = String.format("Case #%d: %s\n", i + 1,
								DATA_LIST.get(i).result);
						System.out.print(l);
						fw.write(l);
					}
				}
			}
		} else {
			System.err.println("Not input data file !");
		}
	}

}
