import java.io.BufferedReader;
import java.io.File;
import java.io.FileFilter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class OminousOmino {

	public static class Omino {
		int[][] grid;
	}

	public static class Data {

		String result = "";
		int x;
		int r;
		int c;

		public Data(Iterator<String> it) throws IOException {
			String line = it.next();
			System.out.println(line);
			String[] tab = line.split(" ");
			x = Integer.parseInt(tab[0]);
			r = Integer.parseInt(tab[1]);
			c = Integer.parseInt(tab[2]);
		}

		public boolean is(int r, int c) {
			return (this.r == r && this.c == c) || (this.r == c && this.c == r);
		}

		public void process() {
			result = "GABRIEL";
			switch (x) {
			case 1:
				if (is(1, 1)) {
					result = "RICHARD";
				}
				break;
			case 2:
				if (is(1, 1) || is(1, 2) || is(1, 3) || is(3, 3)) {
					result = "RICHARD";
				}
				break;
			case 3:
				if (is(1, 1) || is(1, 2) || is(1, 3) || is(1, 4) || is(2, 2)
						|| is(2, 4) || is(4, 4)) {
					result = "RICHARD";
				}
				break;
			case 4:
				if (is(1, 1) || is(1, 2) || is(1, 3) || is(1, 4) || is(2, 2)
						|| is(2, 3) || is(2, 4) || is(3, 3)) {
					result = "RICHARD";
				}
				break;
			default:
				result = "GABRIEL";
				break;
			}

		}
	}

	public static List<Data> DATA_LIST = new ArrayList<OminousOmino.Data>();

	public static void main(String[] args) throws IOException {

		// Get the data file not processed
		File dataFile = System.getProperty("dataFile") != null ? new File(
				System.getProperty("dataFile")) : null;
		if (dataFile == null) {
			for (File f : new File(".").listFiles(new FileFilter() {
				@Override
				public boolean accept(File file) {
					return file.isFile() && file.getName().endsWith(".in")
							&& !file.getName().startsWith("res-")
							&& !new File("res-" + file.getName()).exists();
				}
			})) {
				dataFile = f;
				break;
			}
		}
		if (dataFile != null) {

			// Load data
			try (BufferedReader buffer = new BufferedReader(new FileReader(
					dataFile));) {
				Iterator<String> it = buffer.lines().iterator();
				int nbDatas = Integer.parseInt(it.next());
				System.out.println("nbDatas=" + nbDatas);
				while (it.hasNext()) {
					DATA_LIST.add(new Data(it));
				}
				System.out.println("# Data file loaded");

				// Process data
				DATA_LIST.parallelStream().forEach(d -> {
					d.process();
				});
				System.out.println("# Data processed");

				// Print results
				try (FileWriter fw = new FileWriter("res-" + dataFile.getName());) {
					for (int i = 0; i < DATA_LIST.size(); i++) {
						String l = String.format("Case #%d: %s\n", i + 1,
								DATA_LIST.get(i).result);
						System.out.print(l);
						fw.write(l);
					}
				}
			}
		} else {
			System.err.println("Not input data file !");
		}
	}

}
