import java.io.BufferedReader;
import java.io.File;
import java.io.FileFilter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class StandingOvation {

	public static class Data {

		int nbInvit;
		int[] s;
		String result = "";

		public Data(Iterator<String> it) throws IOException {
			String line = it.next();
			System.out.println(line);
			String[] tab = line.split(" ");
			nbInvit = Integer.parseInt(tab[0]);
			s = new int[tab[1].length()];
			for (int i = 0; i < s.length; i++) {
				s[i] = Integer.parseInt(tab[1].substring(i, i + 1));
			}
		}

		public boolean isStandingOvation() {
			boolean[] up = new boolean[s.length];
			int nbUp = 0;
			boolean upDetected = true;
			while (upDetected) {
				upDetected = false;
				for (int i = 0; i < s.length; i++) {
					if (nbUp >= i && !up[i]) {
						up[i] = true;
						nbUp = nbUp + s[i];
						upDetected = true;
					}
				}
			}

			for (int i = 0; i < s.length; i++) {
				if (!(up[i] || s[i] == 0)) {
					return false;
				}
			}
			return true;
		}

		public void process() {
			int nb = 0;
			while (!isStandingOvation()) {
				s[0]++;
				nb++;
			}
			result = "" + nb;
		}
	}

	public static List<Data> DATA_LIST = new ArrayList<StandingOvation.Data>();

	public static void main(String[] args) throws IOException {

		// Get the data file not processed
		File dataFile = null;
		for (File f : new File(".").listFiles(new FileFilter() {
			@Override
			public boolean accept(File file) {
				return file.isFile() && file.getName().endsWith(".in")
						&& !file.getName().startsWith("res-")
						&& !new File("res-" + file.getName()).exists();
			}
		})) {
			dataFile = f;
			break;
		}

		if (dataFile != null) {

			// Load data
			try (BufferedReader buffer = new BufferedReader(new FileReader(
					dataFile));) {
				Iterator<String> it = buffer.lines().iterator();
				int nbDatas = Integer.parseInt(it.next());
				System.out.println("nbDatas=" + nbDatas);
				while (it.hasNext()) {
					DATA_LIST.add(new Data(it));
				}
				System.out.println("# Data file loaded");

				// Process data
				DATA_LIST.parallelStream().forEach(d -> {
					d.process();
				});
				System.out.println("# Data processed");

				// Print results
				try (FileWriter fw = new FileWriter("res-" + dataFile.getName());) {
					for (int i = 0; i < DATA_LIST.size(); i++) {
						String l = String.format("Case #%d: %s", i + 1,
								DATA_LIST.get(i).result);
						System.out.println(l);
						fw.write(l);
					}
				}
			}
		} else {
			System.err.println("Not input data file !");
		}
	}

}
