import java.io.BufferedReader;
import java.io.File;
import java.io.FileFilter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

public class CoinJam {

	public static class Data {

		int N;
		int J;
		List<String> potentialJamCoin = new ArrayList<String>();
		List<Long> base2 = new ArrayList<Long>();
		List<Long> base3 = new ArrayList<Long>();
		List<Long> base4 = new ArrayList<Long>();
		List<Long> base5 = new ArrayList<Long>();
		List<Long> base6 = new ArrayList<Long>();
		List<Long> base7 = new ArrayList<Long>();
		List<Long> base8 = new ArrayList<Long>();
		List<Long> base9 = new ArrayList<Long>();
		List<Long> base10 = new ArrayList<Long>();
		
		List<List<Long>> bases = Arrays.asList(base2, base3, base4, base5,
				base6, base7, base8, base9, base10);

		String result = "";

		public Data(Iterator<String> it) throws IOException {
			String line = it.next();
			System.out.println(line);
			String[] vals = line.split(" ");
			N = Integer.parseInt(vals[0]);
			J = Integer.parseInt(vals[1]);
		}

		public void initPotentialJamCoin() {
			int i = 0;
			String tmp = Integer.toBinaryString(i);
			while (tmp.length() < N - 2) {
				while (tmp.length() < N - 2) {
					tmp = "0" + tmp;
				}
				String coin = "1" + tmp + "1";
				for (int r = 2; r <= 10; r++) {
					bases.get(r - 2).add(Long.parseLong(coin, r));
				}
				potentialJamCoin.add(coin);
				System.out.println(showCoin(potentialJamCoin.size() - 1));
				i++;
				tmp = Integer.toBinaryString(i);
			}

			System.out.println("Total to check : " + potentialJamCoin.size());
		}

		public String showCoin(int i) {
			return String.format("%s %s %s %s %s %s %s %s %s %s",
					potentialJamCoin.get(i), base2.get(i), base3.get(i),
					base4.get(i), base5.get(i), base6.get(i), base7.get(i),
					base8.get(i), base9.get(i), base10.get(i));
		}

		public Integer foundFirstDivisor(Long val, List<Integer> divTaboo) {
			for (int d = 2; d < 100000; d++) {
				if (!divTaboo.contains(d) && val % d == 0) {
					return d;
				}
			}
			return null;
		}

		public void process() {
			initPotentialJamCoin();
			List<String> resList = new ArrayList<String>();
			List<Integer> divAlreadyUsed = new ArrayList<Integer>();
			for (int i = 0; i < potentialJamCoin.size(); i++) {
				List<Integer> divList = new ArrayList<Integer>();
				List<Integer> divAlreadyUsedTmp = new ArrayList<Integer>(
						divAlreadyUsed);
				for (List<Long> baseN : bases) {
					Long valBaseN = baseN.get(i);
					Integer div = foundFirstDivisor(valBaseN, divAlreadyUsedTmp);
					if (div != null && div.intValue() != valBaseN.intValue()) {
						divList.add(div);
						divAlreadyUsedTmp.add(div);
					}
				}
				if (divList.size() == bases.size()) {
					String res = String.format("%s %s %s %s %s %s %s %s %s %s",
							potentialJamCoin.get(i), divList.get(0),
							divList.get(1), divList.get(2), divList.get(3),
							divList.get(4), divList.get(5), divList.get(6),
							divList.get(7),divList.get(8));
					System.out.println(res);
					result = result + "\n" + res;
					resList.add(res);
					divAlreadyUsed.addAll(divList);
					if (resList.size() == J) {
						break;
					}
				}
			}
		}
	}

	public static List<Data> DATA_LIST = new ArrayList<CoinJam.Data>();

	public static void main(String[] args) throws IOException {

		// Get the data file not processed
		File dataFile = System.getProperty("dataFile") != null ? new File(
				System.getProperty("dataFile")) : null;
		if (dataFile == null) {
			for (File f : new File(".").listFiles(new FileFilter() {
				@Override
				public boolean accept(File file) {
					return file.isFile() && file.getName().endsWith(".in")
							&& !file.getName().startsWith("res-")
							&& !new File("res-" + file.getName()).exists();
				}
			})) {
				dataFile = f;
				break;
			}
		}
		if (dataFile != null) {

			// Load data
			try (BufferedReader buffer = new BufferedReader(new FileReader(
					dataFile));) {
				Iterator<String> it = buffer.lines().iterator();
				int nbDatas = Integer.parseInt(it.next());
				System.out.println("nbDatas=" + nbDatas);
				while (it.hasNext()) {
					DATA_LIST.add(new Data(it));
				}
				System.out.println("# Data file loaded");

				// Process data
				DATA_LIST.parallelStream().forEach(d -> {
					d.process();
				});
				System.out.println("# Data processed");

				// Print results
				try (FileWriter fw = new FileWriter("res-" + dataFile.getName());) {
					for (int i = 0; i < DATA_LIST.size(); i++) {
						String l = String.format("Case #%d: %s\n", i + 1,
								DATA_LIST.get(i).result);
						System.out.print(l);
						fw.write(l);
					}
				}
			}
		} else {
			System.err.println("Not input data file !");
		}
	}

}
