import java.io.BufferedReader;
import java.io.File;
import java.io.FileFilter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class RevengeOfThePancakes {

	public static class Data {

		String stack;
		String result = "";

		public Data(Iterator<String> it) throws IOException {
			String line = it.next();
			System.out.println(line);
			stack = line;
		}

		public void process() {
			int step = 0;
			while (stack.indexOf("-") != -1 && stack.indexOf("+") != -1) {
				step++;
				char firstFace = stack.charAt(0);
				char nextFace = '+';
				if (firstFace == '+') {
					nextFace = '-';
				}
				int indNextFace = stack.indexOf(nextFace);
				stack = stack.substring(0, indNextFace).replaceAll(
						"\\" + firstFace, "" + nextFace)
						+ stack.substring(indNextFace, stack.length());
//				System.out.println(stack);
			}
			if (stack.indexOf("-") == -1) {
				// Only ++++++++++
				result = "" + step;
			} else if (stack.indexOf("+") == -1) {
				// Only ----------
				step++;
				result = "" + step;
			}
		}
	}

	public static List<Data> DATA_LIST = new ArrayList<RevengeOfThePancakes.Data>();

	public static void main(String[] args) throws IOException {

		// Get the data file not processed
		File dataFile = System.getProperty("dataFile") != null ? new File(
				System.getProperty("dataFile")) : null;
		if (dataFile == null) {
			for (File f : new File(".").listFiles(new FileFilter() {
				@Override
				public boolean accept(File file) {
					return file.isFile() && file.getName().endsWith(".in")
							&& !file.getName().startsWith("res-")
							&& !new File("res-" + file.getName()).exists();
				}
			})) {
				dataFile = f;
				break;
			}
		}
		if (dataFile != null) {

			// Load data
			try (BufferedReader buffer = new BufferedReader(new FileReader(
					dataFile));) {
				Iterator<String> it = buffer.lines().iterator();
				int nbDatas = Integer.parseInt(it.next());
				System.out.println("nbDatas=" + nbDatas);
				while (it.hasNext()) {
					DATA_LIST.add(new Data(it));
				}
				System.out.println("# Data file loaded");

				// Process data
				DATA_LIST.parallelStream().forEach(d -> {
					d.process();
				});
				System.out.println("# Data processed");

				// Print results
				try (FileWriter fw = new FileWriter("res-" + dataFile.getName());) {
					for (int i = 0; i < DATA_LIST.size(); i++) {
						String l = String.format("Case #%d: %s\n", i + 1,
								DATA_LIST.get(i).result);
						System.out.print(l);
						fw.write(l);
					}
				}
			}
		} else {
			System.err.println("Not input data file !");
		}
	}

}
