import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

// ############################################################
// ############################DATA############################
// ############################################################
class Data {

	// The identify of the test
	public int id;
	public String result;

	public List<Integer> order = new ArrayList<Integer>();

	@Override
	public String toString() {
		return "Data [order=" + Arrays.toString(order.toArray()) + "]";
	}

}

// ############################################################
// ############################################################
// ############################################################

public class GoroSort extends Thread {

	// The number of thread in parallelized
	public static int MAX_THREAD = 1;

	// The file to load
	private static String inFileName = "D-small-attempt0.in";

	// ############################################################
	// ########################LOAD################################
	// ############################################################
	public static void main(String[] args) throws IOException {

		// Load the file
		BufferedReader buffer = new BufferedReader(new FileReader(inFileName));

		// Read the number of test
		String line = buffer.readLine();
		NB_TESTS = Integer.parseInt(line);
		System.out.println("NB_TESTS=" + NB_TESTS);

		// Read each test
		int tId = 1;
		line = buffer.readLine();
		while (line != null) {
			line = buffer.readLine();
			String[] values = line.split(" ");
			Data t = new Data();
			t.id = tId;
			for (String val : values) {
				t.order.add(new Integer(val));
			}

			TESTS.add(t);

			// Read the next test
			tId++;
			line = buffer.readLine();
		}
		// ############################################################
		// ############################################################
		// ############################################################

		for (int i = 0; i < MAX_THREAD; i++) {
			new GoroSort().start();
		}

	}

	// ############################################################
	// #########################ALGO###############################
	// ############################################################
	public void algo(Data d) {

		System.out.println(d.toString());

		Map<String, Integer> couple = new HashMap<String, Integer>();
		int nb = d.order.size();
		int nbOK = 0;
		int nbCouple = 0;
		for (int i = 0; i < d.order.size(); i++) {
			int val = d.order.get(i);
			int pos = i + 1;
			String key = val + "-" + pos;
			if (pos > val) {
				key = pos + "-" + val;
			}
			Integer in = couple.get(key);
			if (in == null) {
				couple.put(key, new Integer(1));
			} else {
				couple.put(key, in + 1);
				nbCouple++;
			}

			if (val - pos == 0) {
				nbOK++;
			}
		}
		System.out.println("Nb: " + nb);
		System.out.println("OK: " + nbOK);
		System.out.println("Couple: " + nbCouple);
		int res = nbCouple * 2;

		int libre = nb - nbOK - (nbCouple * 2);
		if (libre > 0) {
			res += libre;
		}

		d.result = "" + res + ".000000";
	}

	// ############################################################
	// ############################################################
	// ############################################################

	@Override
	public void run() {
		getNextDataToProcess(this);
		while (data != null) {
			getNextDataToProcess(this);
		}
		if (NB_RUNNING == 0) {
			try {
				FileWriter fw = new FileWriter("res-" + inFileName);

				for (int j = 0; j < TESTS.size(); j++) {
					Data d = TESTS.get(j);
					algo(d);
					fw.write("Case #" + d.id + ": " + d.result + "\n");
					System.out.print("Case #" + d.id + ": " + d.result + "\n");
				}
				fw.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	// Number of test
	public static int NB_TESTS = 0;

	// The current test
	public static int ID_TEST = 0;

	// The number of running thread
	public static int NB_RUNNING = 0;

	// All the test to do
	private static ArrayList<Data> TESTS = new ArrayList<Data>();

	// The current test
	private Data data = null;

	/**
	 * @param ct
	 *            The calcul thread
	 */
	public static synchronized void getNextDataToProcess(GoroSort ct) {
		if (ID_TEST < NB_TESTS) {
			ID_TEST++;

			if (ct.data == null) {
				NB_RUNNING++;
			}
			ct.data = TESTS.get(ID_TEST - 1);
		}
		NB_RUNNING--;
		ct.data = null;
	}

}
