import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.List;

public class ThemPark1 {

	/**
	 * Fonction permettant de charger un fichier in
	 * 
	 * @param name
	 *            Le nom du fichier
	 * @param separateur
	 *            Le sprateur  utiliser
	 * @return Les valeurs du fichier
	 * 
	 * @throws IOException
	 *             Erreur de lecture
	 */
	public static List<Data> loadFile(String name, String separateur) throws IOException {
		BufferedReader buffer = new BufferedReader(new FileReader(name));
		List<Data> loads = new ArrayList<Data>();

		// Lecture nombre de data
		String line = buffer.readLine();

		// Le R, k, N
		line = buffer.readLine();
		while (line != null) {

			Data d = new Data();

			String[] nb = line.split(separateur);
			d.setR(Integer.parseInt(nb[0]));
			d.setK(Integer.parseInt(nb[1]));
			d.setN(Integer.parseInt(nb[2]));

			// gi
			line = buffer.readLine();
			nb = line.split(separateur);
			for (String n : nb) {
				d.getG().add(Integer.parseInt(n));
			}

			loads.add(d);

			line = buffer.readLine();
		}
		return loads;
	}

	public static void main(String[] args) throws IOException {

		NumberFormat f = NumberFormat.getInstance();
		f.setGroupingUsed(false);

		// Le fichier de test
		String inFileName = "C-small-attempt0.in";

		// Suppression du fichier de rsultat (Si dja existant -> clear)
		File res = new File("res-" + inFileName);
		res.delete();

		int idCase = 1;
		for (Data d : loadFile(inFileName, " ")) {

			System.out.println(d);

			// Groupes placed
			ArrayList<Integer> gPlaced = new ArrayList<Integer>();

			int money = 0;
			for (int i = 0; i < d.getR(); i++) {

				// Number of person placed
				int parked = 0;

				// To know if all it's placed
				boolean placed = false;

				// ALl person leave their place
				gPlaced.clear();

				// Try to place
				while (!placed && gPlaced.size() < d.getK() && d.getG().size() > 0) {

					// Get the next group
					Integer g = d.getG().remove(0);

					if (parked + g <= d.getK()) {

						// The group can be placed
						money = money + g;
						parked = parked + g;
						gPlaced.add(g);
					} else {

						// The group stay in the file
						d.getG().add(0, g);

						placed = true;
					}
				}

				d.getG().addAll(gPlaced);

			}

			// Sauvegarde du resultat
			FileWriter fw = new FileWriter(res, true);
			fw.write("Case #" + idCase + ": " + money + "\n");
			System.out.println("Case #" + idCase + ": " + money + "\n");
			fw.close();

			// Test suivant
			idCase++;
		}

	}
}
