import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

// ############################################################
// ############################DATA############################
// ############################################################
class Data {

	// The identify of the test
	public int id;
	public String result;

	// The identify of the test
	public List<Bouton> boutons = new ArrayList<Bouton>();
	public List<Bouton> boutonsB = new ArrayList<Bouton>();
	public List<Bouton> boutonsO = new ArrayList<Bouton>();

}

class Bouton {
	public char color;

	@Override
	public String toString() {
		return "Button [color=" + color + ", order=" + position + "]";
	}

	public int position;

	public Bouton(String color, String order) {
		this.color = color.charAt(0);
		this.position = Integer.parseInt(order);
	}

}

class ButtonComparator implements Comparator<Bouton> {
	@Override
	public int compare(Bouton o1, Bouton o2) {
		if (o1.position == o2.position) {
			return 0;
		} else if (o1.position > o2.position) {
			return 1;
		} else {
			return -1;
		}
	}
}

// ############################################################
// ############################################################
// ############################################################

public class BotTrust extends Thread {

	// The number of thread in parallelized
	public static int MAX_THREAD = 1;

	// The file to load
	private static String inFileName = "A-large.in";

	// ############################################################
	// ########################LOAD################################
	// ############################################################
	public static void main(String[] args) throws IOException {

		// Load the file
		BufferedReader buffer = new BufferedReader(new FileReader(inFileName));

		// Read the number of test
		String line = buffer.readLine();
		NB_TESTS = Integer.parseInt(line);
		System.out.println("NB_TESTS=" + NB_TESTS);

		// Read each test
		int tId = 1;
		line = buffer.readLine();
		while (line != null) {
			String[] values = line.split(" ");
			Data t = new Data();
			t.id = tId;
			for (int i = 1; i < values.length; i++) {
				Bouton b = new Bouton(values[i], values[i + 1]);
				t.boutons.add(b);
				if (b.color == 'O') {
					t.boutonsO.add(b);
				} else {
					t.boutonsB.add(b);
				}
				i++;
			}

			// Collections.sort(t.boutons, new ButtonComparator());
			// Collections.sort(t.boutonsB, new ButtonComparator());
			// Collections.sort(t.boutonsO, new ButtonComparator());

			TESTS.add(t);

			// Read the next test
			tId++;
			line = buffer.readLine();
		}
		// ############################################################
		// ############################################################
		// ############################################################

		for (int i = 0; i < MAX_THREAD; i++) {
			new BotTrust().start();
		}

	}

	// ############################################################
	// #########################ALGO###############################
	// ############################################################
	public void algo(Data d) {

		System.out.println(d.toString());

		int posO = 1;
		int posB = 1;
		int time = 1;

		String actionO = "";
		String actionB = "";
		Bouton bB = null;
		if (d.boutonsB.size() > 0) {
			bB = d.boutonsB.remove(0);
		}
		Bouton bO = null;
		if (d.boutonsO.size() > 0) {
			bO = d.boutonsO.remove(0);
		}
		Bouton bCur = d.boutons.remove(0);
		while (bO != null || bB != null) {
			boolean updateCur = false;
			actionO = "";
			actionB = "";
			if (bO != null) {
				if (posO == bO.position) {
					if (bCur == bO) {
						actionO = "Push button " + bO.position;
						updateCur = true;
						if (d.boutonsO.size() > 0) {
							bO = d.boutonsO.remove(0);

						} else {
							bO = null;
						}

					} else {
						actionO = "Stay at button " + bO.position;
					}
				} else {
					if (posO > bO.position) {
						posO--;
						actionO = "Move to button " + posO;
					} else {
						posO++;
						actionO = "Move to button " + posO;
					}
				}
			}

			if (bB != null) {
				if (posB == bB.position) {
					if (bB == bCur) {
						actionB = String.format("Push button " + bB.position);
						updateCur = true;
						if (d.boutonsB.size() > 0) {
							bB = d.boutonsB.remove(0);

						} else {
							bB = null;
						}

					} else {
						actionB = "Stay at button " + bB.position;
					}
				} else {
					if (posB > bB.position) {
						posB--;
						actionB = "Move to button " + posB;
					} else {
						posB++;
						actionB = "Move to button " + posB;
					}
				}
			}

			System.out.println(String.format("%10s | %20s | %20s", "" + time, actionO, actionB));
			time++;

			if (d.boutons.size() > 0 && updateCur) {
				bCur = d.boutons.remove(0);
			}
		}

		d.result = "" + (time - 1);
	}

	// ############################################################
	// ############################################################
	// ############################################################

	@Override
	public void run() {
		getNextDataToProcess(this);
		while (data != null) {
			getNextDataToProcess(this);
		}
		if (NB_RUNNING == 0) {
			try {
				FileWriter fw = new FileWriter("res-" + inFileName);

				for (int j = 0; j < TESTS.size(); j++) {
					Data d = TESTS.get(j);
					algo(d);
					fw.write("Case #" + d.id + ": " + d.result + "\n");
					System.out.print("Case #" + d.id + ": " + d.result + "\n");
				}
				fw.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	// Number of test
	public static int NB_TESTS = 0;

	// The current test
	public static int ID_TEST = 0;

	// The number of running thread
	public static int NB_RUNNING = 0;

	// All the test to do
	private static ArrayList<Data> TESTS = new ArrayList<Data>();

	// The current test
	private Data data = null;

	/**
	 * @param ct
	 *            The calcul thread
	 */
	public static synchronized void getNextDataToProcess(BotTrust ct) {
		if (ID_TEST < NB_TESTS) {
			ID_TEST++;

			if (ct.data == null) {
				NB_RUNNING++;
			}
			ct.data = TESTS.get(ID_TEST - 1);
		}
		NB_RUNNING--;
		ct.data = null;
	}

}
