import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;

public class A extends Thread {

	public static NumberFormat FORMATTER = NumberFormat.getInstance();
	static {
		FORMATTER.setGroupingUsed(false);
	}

	public int idThread;

	public A(int idThread) {
		this.idThread = idThread;
	}

	// When the first thread start the process
	public static long START_PROCESS;

	// The number of test processed
	public static int NB_OK = 0;

	// The current test
	public static int ID_TEST = -1;

	// The number of running thread
	public static int NB_RUNNING_THREAD = 0;

	// All the test to do
	private static ArrayList<Data> TESTS = new ArrayList<Data>();

	// The current test
	private Data data = null;

	/**
	 * 
	 * @param n
	 *            The number to get the factorial
	 * @return n!
	 */
	public static long fact(long n) {
		long prod = 1;
		for (int i = 1; i <= n; i++) {
			prod = prod * i;
		}
		return prod;
	}

	/**
	 * 
	 * @param n
	 *            Number of elements in the ensemble
	 * @param k
	 *            Le combinaison
	 * @return n!/k!(n - k)!
	 */
	public static long combinaison(long n, long k) {
		return fact(n) / (fact(k) * (fact(n - k)));
	}

	/**
	 * @param ct
	 *            The calcul thread
	 */
	public static synchronized void getNextDataToProcess(A ct) {

		if (ct.data != null) {

			// A process is OK
			NB_OK++;
			System.out.println(NB_OK + "/" + TESTS.size() + " in " + getProcessTime(START_PROCESS) + " " + ct.data.result);
		} else {

			// A new thread start
			System.out.println("THREAD " + ct.idThread + " [START]");
			NB_RUNNING_THREAD++;
		}

		if (ID_TEST + 1 < TESTS.size()) {

			// New process for the thread
			ID_TEST++;
			ct.data = TESTS.get(ID_TEST);
		} else {

			// Nothing else to process (Stop the process)
			NB_RUNNING_THREAD--;
			ct.data = null;
			System.out.println("THREAD " + ct.idThread + " [STOP]");
		}

	}

	/**
	 * @param sinceTime
	 *            the start date
	 * @return Get the process time
	 */
	public static String getProcessTime(long sinceTime) {
		// Show the time of process
		long duree = System.currentTimeMillis() - sinceTime;
		long nbSec = duree / 1000;
		long nbMin = nbSec / 60;
		if (nbMin > 0) {
			nbSec = nbSec - (nbMin * 60);
		}
		return (nbMin > 0 ? nbMin + " min" : "") + " " + (nbSec > 0 ? nbSec + " sec" : "0 sec");
	}

	public static void main(String[] args) throws IOException {

		START_PROCESS = System.currentTimeMillis();

		// Load the file
		BufferedReader buffer = new BufferedReader(new FileReader(inFileName));

		// Read the number of test
		String line = buffer.readLine();

		// Read each test
		int tId = 1;
		line = buffer.readLine();
		while (line != null) {

			// //////////////////////////////////////////////////
			// /////////////////// START LOAD ///////////////////
			// //////////////////////////////////////////////////
			Data d = new Data();
			d.N = Integer.parseInt(line);
			for (int i = 0; i < d.N; i++) {
				String[] elems = buffer.readLine().split(" ");
				d.A.add(Integer.parseInt(elems[0]));
				d.B.add(Integer.parseInt(elems[1]));
			}

			// //////////////////////////////////////////////////
			// /////////////////// END LOAD ///////////////////
			// //////////////////////////////////////////////////
			d.id = tId;
			TESTS.add(d);
			tId++;
			line = buffer.readLine();
		}

		// for (int i = 0; i < TESTS.size() / 2; i++) {
		// for (int i = 0; i < TESTS.size(); i++) {
		// for (int i = 0; i < 10; i++) {
		// for (int i = 0; i < 1; i++) {
		for (int i = 0; i < 1; i++) {
			new A(i).start();
		}

	}

	// Representation of the test case
	// -------------------------------------------
	public static class Data {

		// The identify of the test
		public int id;
		// The result
		public String result;

		// //////////////////////////////////////////////////
		// /////////////////// START VAL ///////////////////
		// //////////////////////////////////////////////////

		public long N;
		public ArrayList<Integer> A = new ArrayList<Integer>();
		public ArrayList<Integer> B = new ArrayList<Integer>();

		// //////////////////////////////////////////////////////
		// //////////////////// END VAL ////////////////////////
		// //////////////////////////////////////////////////////

	}

	// The file to load
	private static String inFileName = "A-small-attempt1.in";

	@Override
	public void run() {
		getNextDataToProcess(this);
		while (data != null) {

			// //////////////////////////////////////////////////
			// /////////////////// START ALGO ///////////////////
			// //////////////////////////////////////////////////

			System.out.println("-------------------------------------");
			System.out.println("N: " + data.N);
			System.out.println("A: " + Arrays.toString(data.A.toArray()));
			System.out.println("B: " + Arrays.toString(data.B.toArray()));
			System.out.println();

			ArrayList<Integer[]> interval = new ArrayList<Integer[]>();
			for (int i = 0; i < data.N; i++) {
				if (data.A.get(i) < data.B.get(i)) {
					interval.add(new Integer[] { data.A.get(i), data.B.get(i) });
				} else {
					interval.add(new Integer[] { data.B.get(i), data.A.get(i) });
				}
			}
			int nb = 0;
			for (int i = 0; i < interval.size(); i++) {
				Integer[] i1 = interval.get(i);
				for (int j = i + 1; j < interval.size(); j++) {
					Integer[] i2 = interval.get(j);
					if ((i1[0] >= i2[0] && i1[1] <= i2[1]) || (i1[0] > i2[0] && i1[0] < i2[0] && i1[1] > i2[1]) || (i1[0] < i2[0] && i1[1] > i2[1]) || (i1[0] < i2[0] && i1[1] > i2[0] && i1[1] < i2[1])

					) {
						nb++;
					}
				}
			}

			data.result = "" + nb;
			// //////////////////////////////////////////////////////
			// //////////////////// END ALGO ////////////////////////
			// //////////////////////////////////////////////////////

			// Read the next test
			getNextDataToProcess(this);
		}
		if (NB_RUNNING_THREAD == 0) {
			try {

				FileWriter fw = new FileWriter("res-" + inFileName);

				for (int j = 0; j < TESTS.size(); j++) {
					Data d = TESTS.get(j);
					fw.write("Case #" + d.id + ": " + d.result + "\n");
					System.out.print("Case #" + d.id + ": " + d.result + "\n");
				}
				fw.close();
			} catch (IOException e) {
				e.printStackTrace();
			}

		}
	}
}
