import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

// ############################################################
// ############################DATA############################
// ############################################################
class Data {

	// The identify of the test
	public int id;
	public String result;

	public List<Integer> candyBag = new ArrayList<Integer>();

	@Override
	public String toString() {
		return "Data [candyBag=" + Arrays.toString(candyBag.toArray()) + "]";
	}

}

// ############################################################
// ############################################################
// ############################################################

public class CandySplitting extends Thread {

	// The number of thread in parallelized
	public static int MAX_THREAD = 1;

	// The file to load
	private static String inFileName = "C-large.in";

	// ############################################################
	// ########################LOAD################################
	// ############################################################
	public static void main(String[] args) throws IOException {

		// System.out.println("#####################################");
		// System.out.println(addAsPatrick(5, 6));
		// System.out.println(addAsPatrick(5, 4));
		// System.out.println(addAsPatrick(7, 9));
		// System.out.println(addAsPatrick(50, 10));
		// System.out.println("#####################################");
		// Load the file
		BufferedReader buffer = new BufferedReader(new FileReader(inFileName));

		// Read the number of test
		String line = buffer.readLine();
		NB_TESTS = Integer.parseInt(line);
		System.out.println("NB_TESTS=" + NB_TESTS);

		// Read each test
		int tId = 1;
		line = buffer.readLine();
		while (line != null) {
			line = buffer.readLine();
			String[] values = line.split(" ");
			Data t = new Data();
			t.id = tId;
			for (String val : values) {
				t.candyBag.add(new Integer(val));
			}

			Collections.sort(t.candyBag);

			TESTS.add(t);

			// Read the next test
			tId++;
			line = buffer.readLine();
		}
		// ############################################################
		// ############################################################
		// ############################################################

		for (int i = 0; i < MAX_THREAD; i++) {
			new CandySplitting().start();
		}

	}

	// ############################################################
	// #########################ALGO###############################
	// ############################################################
	public static int evalPatrick(List<Integer> bag) {
		int res = 0;
		for (Integer vb : bag) {
			res = addAsPatrick(res, vb);
		}
		return res;
	}

	public static int evalSean(List<Integer> bag) {
		int res = 0;
		for (Integer vb : bag) {
			res += vb;
		}
		return res;
	}

	public static int addAsPatrick(int a, int b) {
		String binA = Integer.toBinaryString(a);
		String binB = Integer.toBinaryString(b);
		if (b > a) {
			binA = Integer.toBinaryString(b);
			binB = Integer.toBinaryString(a);
		}
		while (binA.length() > binB.length()) {
			binB = "0" + binB;
		}
		while (binB.length() > binA.length()) {
			binA = "0" + binA;
		}
		String res = "";
		// System.out.println("\n " + binA);
		// System.out.println("+" + binB);
		// System.out.println("-------------------");
		for (int i = binB.length() - 1; i >= 0; i--) {
			char va = binA.charAt(i);
			char vb = binB.charAt(i);
			if (va == '1' && va == vb) {
				res = "0" + res;
			} else if (va == '0' && vb == '0') {
				res = "0" + res;
			} else {
				res = "1" + res;
			}
		}
		// System.out.println(" " + res);
		// System.out.println("\n" + a + "+" + b + "=" + Integer.parseInt(res,
		// 2));
		return Integer.parseInt(res, 2);
	}

	public void algo(Data d) {

		System.out.println(d.toString());

		List<Integer> bagP = new ArrayList<Integer>();
		List<Integer> bagS = d.candyBag;
		bagP.add(bagS.remove(0));
		int valBagP = evalPatrick(bagP);
		int valBagS = evalPatrick(bagS);
		while (valBagS > valBagP) {
			bagP.add(bagS.remove(0));
			valBagP = evalPatrick(bagP);
			valBagS = evalPatrick(bagS);
		}
		if (bagP.size() > 0 && valBagP == valBagS) {
			d.result = "" + evalSean(bagS);
		} else {
			d.result = "NO";
		}
	}

	// ############################################################
	// ############################################################
	// ############################################################

	@Override
	public void run() {
		getNextDataToProcess(this);
		while (data != null) {
			getNextDataToProcess(this);
		}
		if (NB_RUNNING == 0) {
			try {
				FileWriter fw = new FileWriter("res-" + inFileName);

				for (int j = 0; j < TESTS.size(); j++) {
					Data d = TESTS.get(j);
					algo(d);
					fw.write("Case #" + d.id + ": " + d.result + "\n");
					System.out.print("Case #" + d.id + ": " + d.result + "\n");
				}
				fw.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	// Number of test
	public static int NB_TESTS = 0;

	// The current test
	public static int ID_TEST = 0;

	// The number of running thread
	public static int NB_RUNNING = 0;

	// All the test to do
	private static ArrayList<Data> TESTS = new ArrayList<Data>();

	// The current test
	private Data data = null;

	/**
	 * @param ct
	 *            The calcul thread
	 */
	public static synchronized void getNextDataToProcess(CandySplitting ct) {
		if (ID_TEST < NB_TESTS) {
			ID_TEST++;

			if (ct.data == null) {
				NB_RUNNING++;
			}
			ct.data = TESTS.get(ID_TEST - 1);
		}
		NB_RUNNING--;
		ct.data = null;
	}

}
