import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;

// ############################################################
// ############################DATA############################
// ############################################################
class Data {

	// The identify of the test
	public int id;
	public String result;

	public Regle change;
	public Regle drop;
	public String invoc;

	@Override
	public String toString() {
		return "Data [change=" + change + ", drop=" + drop + ", invoc=" + invoc + "]";
	}

}

class Regle {
	public char elem1;
	public char elem2;
	public String replace;

	public Regle(String str) {
		elem1 = str.charAt(0);
		elem2 = str.charAt(1);
		if (str.length() == 3) {
			replace = "" + str.charAt(2);
		}
	}

	@Override
	public String toString() {
		return elem1 + "" + elem2 + "->" + (replace != null ? replace : "");
	}

	public String appliquerRegle(String str) {

		int ind = -1;
		if (replace != null) {

			// Replace
			ind = str.lastIndexOf("" + elem1 + elem2);
			if (ind == -1) {
				ind = str.lastIndexOf("" + elem2 + elem1);
			}
			if (ind != -1) {
				return str.substring(0, ind) + replace;
			}
		} else {

			// Drop
			if (str.length() > 1) {
				char lastCar = str.charAt(str.length() - 1);
				String sub = str.substring(0, str.length() - 1);
				if (lastCar == elem1) {
					ind = sub.lastIndexOf("" + elem2);
				} else {
					if (lastCar == elem2) {
						ind = sub.lastIndexOf("" + elem1);
					}
				}
				if (ind != -1) {
					return "";
				}
			}
		}
		return str;
	}

}

// ############################################################
// ############################################################
// ############################################################

public class Magicka extends Thread {

	// The number of thread in parallelized
	public static int MAX_THREAD = 1;

	// The file to load
	private static String inFileName = "B-large.in";

	// ############################################################
	// ########################LOAD################################
	// ############################################################
	public static void main(String[] args) throws IOException {

		// Load the file
		BufferedReader buffer = new BufferedReader(new FileReader(inFileName));

		// Read the number of test
		String line = buffer.readLine();
		NB_TESTS = Integer.parseInt(line);
		System.out.println("NB_TESTS=" + NB_TESTS);

		// Read each test
		int tId = 1;
		line = buffer.readLine();
		while (line != null) {
			String[] values = line.split(" ");
			Data t = new Data();
			t.id = tId;
			if (!values[0].equals("0")) {
				t.change = new Regle(values[1]);
				if (!values[2].equals("0")) {
					t.drop = new Regle(values[3]);
				}
			} else {
				if (!values[1].equals("0")) {
					t.drop = new Regle(values[2]);
				}
			}

			t.invoc = values[values.length - 1];

			TESTS.add(t);

			// Read the next test
			tId++;
			line = buffer.readLine();
		}
		// ############################################################
		// ############################################################
		// ############################################################

		for (int i = 0; i < MAX_THREAD; i++) {
			new Magicka().start();
		}

	}

	// ############################################################
	// #########################ALGO###############################
	// ############################################################
	public void algo(Data d) {

		System.out.println("\n" + d.toString());
		d.result = "";
		for (int i = 0; i < d.invoc.length(); i++) {
			char c = d.invoc.charAt(i);
			d.result += c;
			System.out.print(d.result);
			String tmp = "";
			while (!d.result.equals(tmp)) {
				tmp = d.result;
				if (d.change != null) {
					d.result = d.change.appliquerRegle(d.result);
				}
				if (d.drop != null) {
					d.result = d.drop.appliquerRegle(d.result);
				}
			}
			System.out.println(" >>> " + d.result);
		}

		d.result = Arrays.toString(d.result.toCharArray());
	}

	// ############################################################
	// ############################################################
	// ############################################################

	@Override
	public void run() {
		getNextDataToProcess(this);
		while (data != null) {
			getNextDataToProcess(this);
		}
		if (NB_RUNNING == 0) {
			try {
				FileWriter fw = new FileWriter("res-" + inFileName);

				for (int j = 0; j < TESTS.size(); j++) {
					Data d = TESTS.get(j);
					algo(d);
					fw.write("Case #" + d.id + ": " + d.result + "\n");
					System.out.print("Case #" + d.id + ": " + d.result + "\n");
				}
				fw.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	// Number of test
	public static int NB_TESTS = 0;

	// The current test
	public static int ID_TEST = 0;

	// The number of running thread
	public static int NB_RUNNING = 0;

	// All the test to do
	private static ArrayList<Data> TESTS = new ArrayList<Data>();

	// The current test
	private Data data = null;

	/**
	 * @param ct
	 *            The calcul thread
	 */
	public static synchronized void getNextDataToProcess(Magicka ct) {
		if (ID_TEST < NB_TESTS) {
			ID_TEST++;

			if (ct.data == null) {
				NB_RUNNING++;
			}
			ct.data = TESTS.get(ID_TEST - 1);
		}
		NB_RUNNING--;
		ct.data = null;
	}

}
