import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class SnapperChain1 {

	/**
	 * Fonction permettant de charger un fichier in
	 * 
	 * @param name
	 *            Le nom du fichier
	 * @param separateur
	 *            Le sprateur  utiliser
	 * @return Les valeurs du fichier
	 * 
	 * @throws IOException
	 *             Erreur de lecture
	 */
	public static List<Data> loadFile(String name, String separateur) throws IOException {
		BufferedReader buffer = new BufferedReader(new FileReader(name));
		List<Data> loads = new ArrayList<Data>();

		// Lecture nombre de data
		String line = buffer.readLine();

		// Le credit
		line = buffer.readLine();
		while (line != null) {

			Data d = new Data();

			// Les boules
			String[] nb = line.split(separateur);

			d.setN(Integer.parseInt(nb[0]));
			d.setK(Integer.parseInt(nb[1]));

			loads.add(d);

			line = buffer.readLine();
		}
		return loads;
	}

	public static void main(String[] args) throws IOException {

		// Le fichier de test
		String inFileName = "A-small-attempt7.in";

		// Suppression du fichier de rsultat (Si dja existant -> clear)
		File res = new File("res-" + inFileName);
		res.delete();

		int idCase = 1;
		for (Data d : loadFile(inFileName, " ")) {

			String state = "OFF";

			// socket ON
			if ((d.getK() % 2 == 1) && (d.getK() % Math.pow(2, d.getN())) == Math.pow(2, d.getN()) - 1) {
				state = "ON";
			}

			// Sauvegarde du resultat
			FileWriter fw = new FileWriter(res, true);
			fw.write("Case #" + idCase + ": " + state + "\n");
			System.out.println("Case #" + idCase + ": " + state + "\n");
			fw.close();

			// Test suivant
			idCase++;
		}

	}
}
