package com.dbarr.cjar;

import org.apache.commons.io.FileUtils;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * Created by danielbarr on 4/8/17.
 */
public class CodeJame2017 {
    public static void main(String[] args) {
        try {
            List<String> input = FileUtils.readLines(new File("input.txt"));
            File outputFile =  Helper.createFile("output.txt");
            for(int i = 1; i < input.size(); i++) {
                String[] problem = input.get(i).split(" ");
                String caseOutput = problemThree(Helper.getIntAtPosition(problem, 0), Helper.getIntAtPosition(problem, 1));
                String outputText = String.format("Case #%s: %s",(i), caseOutput);
                Helper.writeToFile(outputFile, outputText);
            }


        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static String problemOne(String values, int numFlip) {
        List<Boolean> pancakes = new ArrayList<>();
        for(int i = 0; i < values.length(); i ++) {
            pancakes.add(values.charAt(i) == '+' ? true : false);
        }
        if(!pancakes.contains(false)) {
            return "0";
        }
        int count = 0;
        while(pancakes.contains(false)) {
            flip(pancakes, getFirstFalse(pancakes), numFlip);
            count++;
            if(count > 1000) {
                return "IMPOSSIBLE";
            }
        }
        return String.valueOf(count);
    }

    private static int getFirstFalse(List<Boolean> pancakes) {
        int index = -1;
        for(int i = 0; i < pancakes.size(); i++) {
            if(!pancakes.get(i)) {
                index = i;
                break;
            }
        }
        return index;
    }

    private static void flip(List<Boolean> pancakes, int index, int numFlip) {
        if(index + numFlip >= pancakes.size()) {
            index = index - (index + numFlip - pancakes.size());
        }
        for(int i = index; i < index + numFlip; i++) {
             pancakes.set(i, !pancakes.get(i));
        }
    }

    private static String problemTwo(String value) {
        Long max = Long.parseLong(value);
        Long count = 0L;
        Long tidy = 0L;
        while(tidy == 0L) {
            if(isTidy(max - count)) {
                tidy = max - count;
                break;
            }
            count++;
        }
        return String.valueOf(tidy);
    }

    private static boolean isTidy(Long number) {
        Long lasNum = Long.MAX_VALUE;
        while(number > 10) {
            if(lasNum < number % 10) {
                return false;
            }
            lasNum = number % 10;
            number /= 10;
        }
        return number <= lasNum;
    }

    private static String problemThree(int numStalls, int numPeople) {
        if(numPeople == numStalls) {
            return 0 + " " + 0;
        }
        if(numPeople == 1) {
            return  (numStalls / 2) + " " + (numStalls / 2 - 1);
        }
//        int numOfSqrtNeeded = (int)(Math.sqrt(numPeople) / 2);
//        int numDiv = (int)Math.pow(2, numOfSqrtNeeded) + 1;
//        int length = (numStalls / numDiv);
//        int max = length % 2  == 0 ? length - 1 : length - 2;
//        int minNumOfSqrtNeeded = (int)Math.ceil(Math.sqrt(numPeople) / 2);
//        int minNumDiv = (int)Math.pow(2, minNumOfSqrtNeeded);
//        int minLength = numStalls / minNumDiv;
//        int min = minLength - 2;
//        max = length % 2  == 0 ? (int)Math.ceil(numStalls/numPeople) - 1 : (int)Math.ceil(numStalls/numPeople - 2);
//        min = numStalls/numPeople - 2;
//        if(min < 0) {
//            min = 0;
//        }
//        if(max < 0) {
//           max = numStalls != numPeople ? 1: 0;
//
//        }
        int num = numStalls + 2;
        if(numStalls == numPeople) {
            return 0 + " " + 0;
        }

        if(numPeople == 0) {
            return numStalls /2 + " " + numStalls / 2;
        }

        List<Boolean> stalls = new ArrayList<>();
        for(int i  = 0; i < num; i ++) {
            if( i == 0 || i == num - 1) {
//                stalls.add(true);
            }
            else {
                stalls.add(false);
            }
        }

        for (int i = 0; i < numPeople; i++) {
            int currentIndex = 0;
            int oldCount =0;
            int count = 0;
            for(int j =0; j < stalls.size(); j++) {
                if(stalls.get(j)) {
                    if(count > oldCount) {
                        oldCount = count;
                        currentIndex = j - oldCount;
                    }
                    count = 0;
                }
                else {
                    count++;
                }
            }
            if(count > oldCount) {
                oldCount = count;
                currentIndex = stalls.size() - oldCount;
            }
            int value = currentIndex + (int)Math.ceil(oldCount / 2);
            stalls.set(value, true);
        }
        int min = Integer.MAX_VALUE;
        int max = 0;

        int offset = 0;

        for (int i = 0; i < stalls.size(); i++) {

            if(stalls.get(i)) {
                if(min > offset) {
                    min = offset;
                }

                if(max < offset) {
                    max = offset;
                }
                offset = 0;
            }else {
                offset++;
            }
        }

        return max + " " + min;
    }

    private static boolean updateStall(List<Boolean> stalls, int startIndex, int endIndex) {
        int offset = (endIndex - startIndex) / 2;
        if(startIndex == endIndex) {
            return false;
        }
        if(stalls.get(startIndex +  offset)) {
            return false;
        }
        else {
            stalls.set(startIndex + offset, true);
            return true;

        }
    }

    private static boolean updateStalls(List<Boolean> stalls, int startIndex, int endIndex) {
        int offset = (endIndex - startIndex) / 2;
        if(startIndex == endIndex) {
            return false;
        }
        if(stalls.get(startIndex +  offset)) {
            if(!updateStalls(stalls, startIndex, startIndex +  offset)) {
                return updateStalls(stalls, startIndex +  offset + 1, endIndex);
            }
        }
        else {
            stalls.set(startIndex + offset, true);
        }
        return true;
    }
}
