package com.dbarr.cjar;

import org.apache.commons.io.FileUtils;
import sun.rmi.runtime.Log;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * Created by danielbarr on 4/4/16.
 */
public class CodeJam {
    public static void main(String[] args) {
        try {
            List<String> input = FileUtils.readLines(new File("input.txt"));
            //List<Case> cases = CaseBuilder.buildCases(input);
            File outputFile =  Helper.createFile("output.txt");

            for(int i = 1; i < input.size(); i++) {
                //Case temp = cases.get(i);
                //temp.print();
                String caseOutput = problemThree(16, 50);
                String outputText = String.format("Case #%s: %s",(i), caseOutput);
                Helper.writeToFile(outputFile, outputText);
            }


        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static String problemThree(int jamCoinSize, int numOfJameCoins) {

        String jamCoin = generatePotentialJamCoin(jamCoinSize);
        int count = 0;
        String output = "\n";
        while (count < numOfJameCoins) {
            boolean prime = false;

            String divisors  = "";
            for (int i = 2; i < 11; i++) {
                int solution = 2;
                Long convertedValue = convertToBase(jamCoin, i);
                while (convertedValue % solution != 0 && Math.sqrt(convertedValue) > solution) {
                    solution++;
                }

                if (convertedValue % solution == 0) {
                    divisors += solution + " ";
                    prime = false;
                } else {
                    prime = true;
                    break;
                }
            }

            if (!prime) {
                count++;
                System.out.println(jamCoin + " " + divisors);
                output += jamCoin + " " + divisors + "\n";
            }
            jamCoin = subTractOne(jamCoin);
        }
        return  output;
    }

    public static String subTractOne(String value) {
        String passValue;
       // System.out.println("Initial value:  \t" + value);
        if (value.length() > 3) {
            String subString = value.substring(1, value.length() - 1);
            //System.out.println("Substring value: \t " + subString);
            Long temp = Long.valueOf(subString, 2) - 1;
            String paddedInternal = pad(temp, subString.length());
            String subtractedString = "1" + paddedInternal + "1";
            //System.out.println("Final value: " + subtractedString);

            passValue = subtractedString;
        } else {
            System.out.println("Invalid value:   \t" + value);
            passValue = "value";
        }
        return passValue;
    }

    private static String pad(Long temp, int length) {
        return String.format("%0$" + length + "s", Long.toString(temp, 2)).replace(' ', '0');
    }

    public static String generatePotentialJamCoin(int length) {
        String jamCoin = "";
        for(int i = 0; i < length; i++) {
            jamCoin += "1";
        }
        return jamCoin;
    }

    public static Long convertToBase(String value, int base){
       // System.out.println("Val= " + Integer.parseInt(value, base) + ", base=" + base);
        return Long.parseLong(value, base);
    }

    public static String oldProblemOne(int total, int numItems, String[] items) {
        for(int j = 0; j < numItems; j++) {
            int firstValue = Integer.parseInt(items[j]);
            if(firstValue <= total) {
                for (int k = j + 1; k < numItems; k++) {
                    int secondValue = Integer.parseInt(items[k]);
                    if (j != k && secondValue <= total) {
                        if (firstValue + secondValue == total) {
                            return (j + 1) + " " + (k + 1);
                        }
                    }
                }
            }
        }
        return "";
    }

    public static String problemOne(int value) {
        HashMap<Long, Boolean> digitContainer = new HashMap<>();
        if(value == 0) {
            return "INSOMNIA";
        }else if(value == 1) {
            return "10";
        }
        for(int i = 0; i < 10; i++) {
            digitContainer.put((long)i, false);
        }

        int counter = 1;
        String answer = "";
        while (digitContainer.containsValue(false)) {
            Long valuesToAdd = ((long)value * counter);
            counter++;
            answer = String.valueOf(valuesToAdd);

            while(valuesToAdd != 0) {
                digitContainer.put(valuesToAdd % 10, true);
                valuesToAdd = valuesToAdd / 10;
            }
        }
        return answer;
    }

    public static String problemTwo(String input) {
        List<Integer> list = new ArrayList<>();
        List<Integer> allPositive = new ArrayList<>();

        for(int i = 0; i <input.length(); i++) {
            allPositive.add(1);
            if(input.charAt(i) == '+') {
                list.add(1);
            }
            else {
                list.add(-1);
            }
        }
        int startIndex = 0;
        int endIndex = list.size();

        int counter = 0;
        while (startIndex < endIndex) {
            if(list.get(endIndex - 1) != allPositive.get(endIndex - 1)) {
                counter++;
                for(int i = startIndex; i < endIndex; i++) {
                    allPositive.set(i, allPositive.get(i) * -1);
                }
            }
            endIndex--;
        }


        return counter + "";
    }

    public static String oldProblemTwo(int max, String[] items) {
        int numStanding = 0;
        int numInvite = 0;
        int extra = 0;
        for(int j = 0;j < max + 1; j++) {
            int value =  Helper.getIntAtPosition(items, j);
            numStanding += value;
            if(numStanding > max) {
                break;
            }

            if(value > 1) {
                extra += value -1;
            }
            else if(value == 0){
                if(extra ==0) {
                    numInvite++;
                }
                else {
                    extra--;
                }
            }
        }
        return String.valueOf(numInvite);
    }
}
