package com.dbarr.cjar;

import org.apache.commons.io.FileUtils;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * Created by danielbarr on 4/8/17.
 */
public class CodeJame2017 {
    public static void main(String[] args) {
        try {
            List<String> input = FileUtils.readLines(new File("input.txt"));
            File outputFile =  Helper.createFile("output.txt");
            for(int i = 1; i < input.size(); i++) {
                String[] problem = input.get(i).split(" ");

                String caseOutput = problemOne(problem[0], Helper.getIntAtPosition(problem, 1));
                String outputText = String.format("Case #%s: %s",(i), caseOutput);
                Helper.writeToFile(outputFile, outputText);
            }


        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static String problemOne(String values, int numFlip) {
        List<Boolean> pancakes = new ArrayList<>();
        for(int i = 0; i < values.length(); i ++) {
            pancakes.add(values.charAt(i) == '+' ? true : false);
        }
        if(!pancakes.contains(false)) {
            return "0";
        }
        int count = 0;
        while(pancakes.contains(false)) {
            flip(pancakes, getFirstFalse(pancakes), numFlip);
            count++;
            if(count > 1000) {
                return "IMPOSSIBLE";
            }
        }
        return String.valueOf(count);
    }

    private static int getFirstFalse(List<Boolean> pancakes) {
        int index = -1;
        for(int i = 0; i < pancakes.size(); i++) {
            if(!pancakes.get(i)) {
                index = i;
                break;
            }
        }
        return index;
    }

    private static void flip(List<Boolean> pancakes, int index, int numFlip) {
        if(index + numFlip >= pancakes.size()) {
            index = index - (index + numFlip - pancakes.size());
        }
        for(int i = index; i < index + numFlip; i++) {
             pancakes.set(i, !pancakes.get(i));
        }
    }
}
