package codejam.dbasurco.a;

import java.io.BufferedReader;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.text.MessageFormat;

public class StandingOvation {

	private static final String CHARSET = "US-ASCII";
	private static final String PATH_IN = "A-large.in";
	private static final String PATH_OUT = "StandingOvation.out";
	private static final String SPLITTER = " ";
	private static Path pathIn = Paths.get(PATH_IN);
	private static Path pathOut = Paths.get(PATH_OUT);
	
	public static void main(String[] args) throws IOException {
		
		long startTime = System.currentTimeMillis();
		
		try {
			Files.delete(pathOut);
		} catch (IOException e) {
		}
		
		Charset charset = Charset.forName(CHARSET);
		try (BufferedReader reader = Files.newBufferedReader(pathIn, charset)) {

			solveStandingOvation(reader);
			
		} catch (IOException x) {
		    System.err.format("IOException: %s%n", x);
		    throw x;
		}
		
		long duration = System.currentTimeMillis() - startTime;
		System.out.println(duration + " milliseconds to run");
		
	}
	
	private static void solveStandingOvation(BufferedReader reader) throws NumberFormatException, IOException {
		
		int neededFriends = 0, numOfCurrentS= 0, sMax, caseNum = 0, numberOfTests = Integer.parseInt(reader.readLine());
		String[] caseLine;
		for (int i = 0; i < numberOfTests; i++) {
			caseLine = reader.readLine().split(SPLITTER);
			sMax = Integer.parseInt(caseLine[0]);
			for (int j = 0; j <= sMax; j++) {
				if( numOfCurrentS < j ){
					neededFriends++;
					numOfCurrentS++;
					j--;
					continue;
				}
				numOfCurrentS+= Character.getNumericValue(caseLine[1].charAt(j));
			}
			output(++caseNum,neededFriends);
			neededFriends = 0;
			numOfCurrentS = 0;
		}
		
	}
	
	private static void output(int number, int result) throws IOException
	{
		output(number, ""+result);
	}

	private static void output(int number, String result) throws IOException
	{
		String format = MessageFormat.format("Case #{0}: {1}", number,result);
		System.out.println(format);
		try {
			if(Files.exists(pathOut))
				Files.write(pathOut, "\n".getBytes(),StandardOpenOption.APPEND);
			Files.write(pathOut, format.getBytes(), StandardOpenOption.CREATE, StandardOpenOption.APPEND);
		} catch (IOException e) {
			System.err.format("IOException: %s%n", e);
			throw e;
		}
	}

}
