package aliens;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Aliens2 {

	private static BufferedReader in;
	private static FileWriter out;
	private static String line;
	private static int l;
	private static int d;
	private static int n;
	private static String[] dict;
	private static Boolean[] poss;

	public static void main(String[] args) throws IOException {
		in = new BufferedReader(new FileReader("src/aliens/A-small-attempt1.in"));
		out = new FileWriter("src/aliens/A-small-attempt1.out");
		line = in.readLine();
		String[] chunks = line.split(" ");
		l = Integer.parseInt(chunks[0]);
		d = Integer.parseInt(chunks[1]);
		n = Integer.parseInt(chunks[2]);
		
		log(l + ", " + d + ", " + n);
		
		dict = new String[d];
		for (int i = 0; i < d; i++) {
			dict[i] = in.readLine().trim();
		}
		
		poss = new Boolean[d];

		for (int i = 1; i <= n; i++) {
			doCase(i);
		}
		
		out.close();
	}

	private static void doCase(int i) throws IOException {
		log("\nCase " + i);
		
		String pat = in.readLine().trim();
		String[] toks = tokenize2(pat);
		log("Tokens:");
		for (String tok : toks) {
			log2(tok + " ");
		}
		log("");
		
		// All dict words are possible
		for (int j = 0; j < d; j++) {
			poss[j] = true;
		}
		
		for (int let = 0; let < l; let++) {
			boolean possMatch = false;
			for (int word = 0; word < d; word++) {
				if (poss[word] && allowedByTok(dict[word].charAt(let), toks[let])) {
					// Could be a match
					possMatch = true;
				} else {
					poss[word] = false;
				}
			}
			if (!possMatch) {
				log("Ending search early because there's no word that could match this pattern.");
				break;
			} else {
				// DEBUG
				log("Possible matches after looking at letter " + let + ":");
				for (int j = 0; j < d; j++) {
					if (poss[j]) {
						log(dict[j]);
					}
				}
			}
		}
		
		int count = 0;
		for (int j = 0; j < poss.length; j++) {
			if (poss[j]) {
				count++;
			}
		}
		
		out("Case #" + i + ": " + count);
	}

	private static boolean allowedByTok(char charInRealWord, String tok) {
		for (int i = 0; i < tok.length(); i++) {
			if (charInRealWord == tok.charAt(i)) {
//				log(String.format("'%c' allowed for token '%s'", charInRealWord, tok));
				return true;
			}
		}
//		log(String.format("'%c' not allowed for token '%s'", charInRealWord, tok));
		return false;
	}

	private static String[] tokenize2(String pat) {
		String[] toks = new String[l];
		int j = 0;
		boolean inGroup = false;
		StringBuilder group = new StringBuilder();
		for (int i = 0; i < pat.length(); i++) {
			char c = pat.charAt(i);
			if (c == '(') {
				inGroup = true;
				group.delete(0, 27);
			} else if (c == ')') {
				inGroup = false;
				toks[j++] = group.toString();
			} else {
				if (inGroup) {
					group.append(c);
				} else {
					String s = String.valueOf(c);
					toks[j++] = s;
				}
			}
		}
		return toks;
	}

	private static void out(String string) throws IOException {
		out2(string + "\n");
	}

	private static void out2(String string) throws IOException {
		System.out.print(string);
		out.write(string);
	}

	private static void log(String string) {
		log2(string + "\n");
	}

	private static void log2(String string) {
//		System.out.print(string);
	}

}
