package welcome;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;

public class Welcome {

	private static final String TARGET = "welcome to code jam";
	
	private static BufferedReader in;
	private static FileWriter out;
	private static int n;
	private static String[] chunks;

	private static String line;

	private static HashSet<String> useful;

	private static int[][] mat;

	public static void main(String[] args) throws IOException {
		String dir = "src/welcome/";
		in = new BufferedReader(new FileReader(dir + "C-small-attempt0.in"));
		out = new FileWriter(dir + "C-small-attempt0.out");
		chunks = in.readLine().split(" ");
		n = Integer.parseInt(chunks[0]);
		
		log(n + " cases");
		
		useful = new HashSet<String>();
		for (int i = 0; i < TARGET.length(); i++) {
			useful.add(String.valueOf(TARGET.charAt(i)));
		}
		log("Useful letters:");
		for (String c : useful) {
			log2(c + ", ");
		}

		for (int i = 1; i <= n; i++) {
			doCase(i);
		}
		
		out.close();
	}

	private static void doCase(int i) throws IOException {
		log("\nCase " + i);
		line = in.readLine().trim();
		log("Line: " + line);
		
		stripJunk();
		log("Stripped line: " + line);
		
		int result;
		if (line.length() >= TARGET.length()) {
			mat = new int[TARGET.length()][line.length()];
			for (int row = TARGET.length() - 1; row >= 0; row--) {
				for (int col = line.length() - 1; col >= 0; col--) {
					mat[row][col] = 0;
					if (TARGET.charAt(row) == line.charAt(col)) {
						if (row == TARGET.length() - 1) {
							// Finished match
							mat[row][col] = 1;
						} else if (col == line.length() - 1) {
							// Partial match but out of input to match further
						} else {
							mat[row][col] = mat[row + 1][col + 1];
						}
					}
					if (col < line.length() - 1) {
						mat[row][col] += mat[row][col + 1];
					}
				}
			}
			log("Count matrix:");
			for (int row = 0; row < TARGET.length(); row++) {
				for (int col = 0; col < line.length(); col++) {
					log2(String.format("%02d ", mat[row][col]));
				}
				log("");
			}
			
			result = mat[0][0] % 10000;
		} else {
			result = 0;
		}
		out(String.format("Case #%d: %04d", i, result));
	}

	private static void stripJunk() {
		StringBuilder line2 = new StringBuilder();
		for (int i = 0; i < line.length(); i++) {
			String c = String.valueOf(line.charAt(i));
			if (useful.contains(c)) {
				line2.append(c);
			}
		}
		line = line2.toString();
	}

	private static void out(String string) throws IOException {
		out2(string + "\n");
	}

	private static void out2(String string) throws IOException {
		System.out.print(string);
		out.write(string);
	}

	private static void log(String string) {
		log2(string + "\n");
	}

	private static void log2(String string) {
//		System.out.print(string);
	}
}
