import java.io.*;
import java.util.*;

/**
 * Created by orazberdi on 3/3/2017.
 */
class Solution {
    public static void main(String[] args) throws IOException {
        Scanner input = new Scanner(new File("input"));
        PrintWriter output = new PrintWriter("output");

        solve(input, output);

        output.flush();
        output.close();
    }

    public static void solve(Scanner input, PrintWriter output) {
        int T = input.nextInt();
        input.nextLine();

        for (int t = 1; t <= T; t++) {
            output.print("Case #" + t + ": ");

            int n = input.nextInt(),
                    k = input.nextInt();

            Queue<Pair> queue = new PriorityQueue<>(new Comparator<Pair>() {
                @Override
                public int compare(Pair o1, Pair o2) {
                    if (o1.first() < o2.first()) {
                        return 1;
                    } else if (o1.first() > o2.first()) {
                        return -1;
                    } else {
                        return -1 * Integer.compare(o1.second(), o2.second());
                    }
                }
            });
            queue.offer(pairize(n));

            int count = 0;
            while (true) {
                Pair pair = queue.poll();
                if (++count == k) {
                    output.print(pair);
                    break;
                }
                if (pair.first() > 0) {
                    queue.offer(pairize(pair.first()));
                }
                if (pair.second() > 0) {
                    queue.offer(pairize(pair.second()));
                }
            }

            output.println("");
        }
    }

    private static Pair pairize(int n) {
        if ((n % 2) == 1) {
            return new Pair(n / 2, n / 2);
        } else {
            return new Pair(n / 2, n / 2 - 1);
        }
    }

    static class Pair {
        private int first;
        private int second;

        public Pair(int first, int second) {
            this.first = first;
            this.second = second;
        }

        public int first() {
            return first;
        }

        public int second() {
            return second;
        }

        @Override
        public String toString() {
            return first + " " + second;
        }
    }
}