import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class StandOva {

	public static void main(String[] args) {

		try (BufferedReader reader = new BufferedReader(new FileReader(new File(args[0])));
				BufferedWriter bw = new BufferedWriter(new FileWriter(new File("output.txt")));) {
			String line = null;
			int T = 0;

			// read T, number of test cases
			if ((line = reader.readLine()) != null) {
				T = Integer.parseInt(line);
			}

			// read T cases, for each case extract 2 rows selected, process
			for (int c = 1; c <= T; c++) {

				// read case
				line = reader.readLine();
				String [] split = line.split(" ");
				
				// extract Smax
				int Smax = Integer.parseInt(split[0]);
				
				// extract counts
				String countsStr = split[1];
			    int[] counts = new int[countsStr.length()];
			    for (int i = 0; i < countsStr.length(); i++){
			    	counts[i] = countsStr.charAt(i) - '0';
			    }
			    
			    int toInvite = getMinInvitees(counts);
			    
			    bw.write("Case #" + c + ": " + toInvite + "\n");
			}

		} catch (IOException x) {
			System.err.format("IOException: %s%n", x);
		}

	}

	private static int getMinInvitees(int[] counts) {
		
		int sum = 0, add = 0;
		
		for (int k = 0; k < counts.length; ++k){
			if (counts[k] > 0 && k > sum){
				add += k - sum;
				sum += add;
			}
			sum += counts[k];
		}
		
		return add;
	}

}
