package speakingInTongues;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DeCypher {

	private static Map<Character, Character> googleToEnglish = new HashMap<Character, Character>();

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		fillMap();

		List<String> sents = null;

		try {
			BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(args[0])));
			String line;

			while ((line = br.readLine()) != null) {
				if (Character.isDigit(line.charAt(0))) {
					int numLines = Integer.parseInt(line);
					sents = new ArrayList<String>(numLines);
				} else {
					StringBuilder sb = new StringBuilder();
					for (char c : line.toCharArray()) {
						if (Character.isLetter(c)) {
							sb.append(googleToEnglish.get(c));
						} else {
							sb.append(c);
						}
					}
					sents.add(sb.toString());
				}
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		int l = 1;
		for (String s : sents) {
			System.out.println("Case #" + l++ + ": " + s);
		}

	}

	private static void fillMap() {
		googleToEnglish.put('y', 'a');
		googleToEnglish.put('n', 'b');
		googleToEnglish.put('f', 'c');
		googleToEnglish.put('i', 'd');
		googleToEnglish.put('c', 'e');
		googleToEnglish.put('w', 'f');
		googleToEnglish.put('l', 'g');
		googleToEnglish.put('b', 'h');
		googleToEnglish.put('k', 'i');
		googleToEnglish.put('u', 'j');
		googleToEnglish.put('o', 'k');
		googleToEnglish.put('m', 'l');
		googleToEnglish.put('x', 'm');
		googleToEnglish.put('s', 'n');
		googleToEnglish.put('e', 'o');
		googleToEnglish.put('v', 'p');
		googleToEnglish.put('z', 'q');
		googleToEnglish.put('p', 'r');
		googleToEnglish.put('d', 's');
		googleToEnglish.put('r', 't');
		googleToEnglish.put('j', 'u');
		googleToEnglish.put('g', 'v');
		googleToEnglish.put('t', 'w');
		googleToEnglish.put('h', 'x');
		googleToEnglish.put('a', 'y');
		googleToEnglish.put('q', 'z');

	}

}
