package test;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.Scanner;

public class Test {

	static int t;
	
	final static int R = 0;
	final static int O = 1;
	final static int Y = 2;
	final static int G = 3;
	final static int B = 4;
	final static int V = 5;
	static StringBuilder sb;
	
	public static void main(String[] args) throws FileNotFoundException {
		
		Scanner sc = new Scanner(new BufferedReader(new FileReader("B-small-attempt0.in")));
		int t = sc.nextInt();
		
		for(int loop = 1;loop<=t;loop++)
		{
			int n = sc.nextInt();
			int color[] = new int[6];
			color[R] = sc.nextInt();
			color[O] = sc.nextInt();
			color[Y] = sc.nextInt();
			color[G] = sc.nextInt();
			color[B] = sc.nextInt();
			color[V] = sc.nextInt();
			
			sb = new StringBuilder();
			boolean impossible = false;
			
			int curr_pos = 0;
			
			while(color[R] + color[O] + color[Y] + color[G] + color[B] + color[V] > 0)
			{
				int chosen_color = getNextColor(color, curr_pos);
				if(chosen_color == -1) {
					impossible = true;
					break;
				}
				color[chosen_color]--;
				sb.append(numberToChar(chosen_color));
				curr_pos++;
			}
			
			if(!impossible)
			{
				for(int i=1;i<n;i++)
				{
					if(sb.charAt(i) == sb.charAt(i-1))
						impossible = true;
				}
				if(sb.charAt(0) == sb.charAt(n-1))
					impossible = true;
			}
			
			if(impossible)
				System.out.println("Case #" + loop + ": IMPOSSIBLE");
			else
				System.out.println("Case #" + loop + ": " + sb.toString());
		}
		
		sc.close();
	}
	
	static char numberToChar(int numColor)
	{
		switch(numColor)
		{
			case R:
				return 'R';
			case O:
				return 'O';
			case Y:
				return 'Y';
			case G:
				return 'G';
			case B:
				return 'B';
			case V:
				return 'V';
			default:
				return ' ';
		}
	}
	
	static int charToNumber(char charChar)
	{
		switch(charChar)
		{
			case 'R':
				return R;
			case 'O':
				return O;
			case 'Y':
				return Y;
			case 'G':
				return G;
			case 'B':
				return B;
			case 'V':
				return V;
			default:
				return -1;
		}
	}
	
	static int getNextColor(int color[], int curr_pos)
	{
		int priorityColor = -1;
		
		if(sb.length() > 0)
			priorityColor = charToNumber(sb.charAt(0));
		
		int max = 0;
		int max_color = -1;
		for(int i=0;i<6;i++) {
			if(max < color[i] || (max <= color[i] && priorityColor == i)) {
				if(curr_pos==0 || i != charToNumber(sb.charAt(curr_pos-1))) {
					max = color[i];
					max_color = i;
				}
			}
		}
		
		if(max == 0)
			return -1;
		else
			return max_color;
	}
}
