/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;

public class TestA {
    public static void main(String[] args) {

        MyReaderx reader = new MyReaderx("A-large.in");
        int t = reader.readInt();

        for (int i = 0; i < t; i ++) {
            int n = reader.readInt();

            int [] aarr = new int[1024];
            int [] barr = new int[1024];

            for (int j = 0; j < n; j ++ ) {
                aarr[j] = reader.readInt();
                barr[j] = reader.readInt();
            }

            // try checking intersection for each wire
            int count = 0;
            for (int j = 0; j < n; j ++ ) {
                for (int l = 0; l < j ; l ++) {
                    // checking j and l intersects?
                    int adist = aarr[j] - aarr[l];
                    int bdist = barr[j] - barr[l];
                    if ((adist > 0 && bdist < 0) || adist < 0 && bdist > 0) {
                        count ++;
                    }
                }
            }
            System.out.println("Case #" + (i + 1) + ": " + count);
        }

    }
}


class MyReaderxy {
    InputStream in;

    public MyReaderxy(String fileName) {
        try {
            this.in = new FileInputStream("resources/" + fileName);

        } catch (FileNotFoundException e) {

        }
    }
    public MyReaderxy(InputStream in) {
        this.in = in;
    }

    public String readString() {
        StringBuffer str = new StringBuffer();
        boolean start = true;
        try {
            while (true) {
                int r = in.read();
                if (r == -1) {
                    break;
                }
                char c = (char)r;
                if (c == ' ' || c == '\n' || c== '\r') {
                    if (!start) {
                        break;
                    }
                } else {
                    start = false;
                    str.append(c);
                }
            }
        } catch (Exception e) {
        }
        return str.toString();
    }

    public int readInt() {
        String str = readString();
        return Integer.parseInt(str);
    }
    public long readLong() {
        String str = readString();
        return Long.parseLong(str);
    }
    public float readFloat() {
        String str = readString();
        return Float.parseFloat(str);
    }
}
