/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TestC {
    public static void main(String[] args) {
        
        MyReaderx reader = new MyReaderx("C-small-attempt0.in");
        int t = reader.readInt();

        for (int i = 0; i < t; i ++) {
            int m = reader.readInt();
            int n = reader.readInt();

            int [][] arr = new int[512][512];
            for (int j = 0; j < m; j ++) {
                String str = reader.readString();
                long strInt = Long.parseLong(str, 16);

                for (int k = n - 1; k >= 0; k --) {
                    arr[j][k] = (int)(strInt & 1);
                    strInt >>= 1;
                }
            }
            // creating from 1 to n, m min board
            int limit = Math.min(n, m);

            Map<Integer, List<Entry>> allEntries = new HashMap<Integer, List<Entry>>();
            int j;
            for (j = 1 ; j <= limit; j ++) {
                // for each j size;
                List<Entry> entries = new ArrayList<Entry>();
                allEntries.put(j, entries);
                for (int k = 0; k < m; k ++) {
                    for (int l = 0; l < n; l ++) {
                        if (j == 1) {
                            Entry entry = new Entry(l, k, 1);
                            entries.add(entry);
                            continue;
                        }
                        if (k == 0 || l == 0 ) {
                            continue;
                        }
                        int cp = arr[k][l];
                        int lp = arr[k][l-1];
                        int tp = arr[k-1][l];
                        if (cp == lp || cp == tp) {
                            continue;
                        }
                        List<Entry> pastEntries = allEntries.get(j - 1);
                        for (Entry e: pastEntries) {
                            // checking whether it is extensible
                            if (e.x + e.size == l  && e.y + e.size == k ) {
                                boolean good = true;
                                // now we are inside it
                                // check the bottom most row
                                int row = e.y + e.size;
                                for (int col = e.x; col < e.x + e.size; col ++) {
                                    cp = arr[row][col];
                                    tp = arr[row-1][col];
                                    if (cp == tp) {
                                        good = false;
                                        break;
                                    }
                                }
                                // check the right most ones
                                int col = e.x + e.size;
                                for (row = e.y; row < e.y + e.size && good; row ++) {
                                    cp = arr[row][col];
                                    lp = arr[row][col - 1];
                                    if (cp == lp) {
                                        good = false;
                                        break;
                                    }
                                }
                                if (good) {
                                    Entry entry = new Entry(e.x, e.y, j);
                                    entries.add(entry);
                                }
                            }
                        }
                    }
                }
            }
            int[][] occupied = new int[512][512];
            // now removing dublicate
            int[] count = new int[limit + 1];
            for (j = limit; j >= 1; j --) {
                List<Entry> entries = allEntries.get(j);
                for (Entry entry: entries) {
                    boolean allocated = false;
                    for (int k = entry.x; k < entry.x + entry.size && !allocated; k ++) {
                        for (int l = entry.y; l < entry.y + entry.size && !allocated; l ++) {
                            if (occupied[k][l] == 1) {
                                allocated = true;
                            }
                        }
                    }
                    if (!allocated) {
                        count[j] ++;
                        for (int k = entry.x; k < entry.x + entry.size && !allocated; k ++) {
                            for (int l = entry.y; l < entry.y + entry.size && !allocated; l ++) {
                                occupied[k][l] = 1;
                            }
                        }

                    }
                }
            }
            // now print from 0 count
            int sizes = 0;
            for (j = 0; j < limit + 1; j ++ ) {
                if (count[j] != 0) {
                    sizes ++;
                }
            }
            System.out.println("Case #" + (i + 1) + ": " + sizes);
            for (j = limit; j >= 0; j -- ) {
                if (count[j] != 0) {
                    System.out.println(j + " " + count[j]);
                }
            }
        }
    }
}

class Entry {
    int x;
    int y;
    int size;

    Entry(int x, int y, int size) {
        this.x = x;
        this.y = y;
        this.size = size;
    }
}

class MyReaderx {
    InputStream in;

    public MyReaderx(String fileName) {
        try {
            this.in = new FileInputStream("resources/" + fileName);

        } catch (FileNotFoundException e) {

        }
    }
    public MyReaderx(InputStream in) {
        this.in = in;
    }

    public String readString() {
        StringBuffer str = new StringBuffer();
        boolean start = true;
        try {
            while (true) {
                int r = in.read();
                if (r == -1) {
                    break;
                }
                char c = (char)r;
                if (c == ' ' || c == '\n' || c== '\r') {
                    if (!start) {
                        break;
                    }
                } else {
                    start = false;
                    str.append(c);
                }
            }
        } catch (Exception e) {
        }
        return str.toString();
    }

    public int readInt() {
        String str = readString();
        return Integer.parseInt(str);
    }
    public long readLong() {
        String str = readString();
        return Long.parseLong(str);
    }
    public float readFloat() {
        String str = readString();
        return Float.parseFloat(str);
    }
}

