package online.codejam.codejam2017.qualification;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;

/*
 * https://code.google.com/codejam/contest/3264486/dashboard#s=p2
 */
public class BathroomStalls {

    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new FileInputStream("data/online/codejam/codejam2017/qualification/C-small-1-attempt1.in"));
        File out = new File("data/online/codejam/codejam2017/qualification/C-small-1-attempt1.out");
        Files.deleteIfExists(out.toPath());
        out.createNewFile();

        int T = sc.nextInt();
        for (int test_case = 1; test_case <= T; test_case++) {
            int N = sc.nextInt();
            int K = sc.nextInt();

            Stall[] stalls = new Stall[N + 2];
            stalls[0] = new Stall(0, true, -1, -1);
            stalls[stalls.length - 1] = new Stall(N + 1, true, -1, -1);
            for (int i = 1; i <= N; i++) {
                stalls[i] = new Stall(i, false, i - 1, N - i);
            }

            Stall stallToUse = stalls[0];
            for (int i = 0; i < K; i++) {
                List<Stall> stallsList = Arrays.stream(stalls).filter(s -> !s.isOccupied).collect(Collectors.toList());

                // 1
                Collections.sort(stallsList, (o1, o2) -> o2.minLR - o1.minLR);
                List<Stall> stallsSameMaxMin = new ArrayList<>();
                for (Stall s : stallsList) {
                    if (stallsSameMaxMin.isEmpty()) {
                        stallsSameMaxMin.add(s);
                    } else {
                        if (s.minLR != stallsSameMaxMin.get(0).minLR) {
                            break;
                        } else {
                            stallsSameMaxMin.add(s);
                        }
                    }
                }

                if (stallsSameMaxMin.size() == 1) {
                    stallToUse = stallsSameMaxMin.get(0);
                } else {
                    // 2
                    Collections.sort(stallsSameMaxMin, (o1, o2) -> o2.maxLR - o1.maxLR);
                    List<Stall> stallsSameMaxMax = new ArrayList<>();
                    for (Stall s : stallsSameMaxMin) {
                        if (stallsSameMaxMax.isEmpty()) {
                            stallsSameMaxMax.add(s);
                        } else {
                            if (s.maxLR != stallsSameMaxMax.get(0).maxLR) {
                                break;
                            } else {
                                stallsSameMaxMax.add(s);
                            }
                        }
                    }

                    if (stallsSameMaxMax.size() == 1) {
                        stallToUse = stallsSameMaxMax.get(0);
                    } else {
                        // 3
                        Collections.sort(stallsSameMaxMax, (o1, o2) -> o1.index - o2.index);
                        stallToUse = stallsSameMaxMax.get(0);
                    }
                }

                update(stalls, stallToUse);
            }

            // // write result to file
            String line = "Case #" + test_case + ": " + stallToUse.maxLR + " " + stallToUse.minLR + "\n";
            Files.write(Paths.get(out.getPath()), line.getBytes(), StandardOpenOption.APPEND);
            System.out.print(line);
        }
    }

    private static void update(Stall[] stalls, Stall occupied) {
        int index = occupied.index;
        occupied.isOccupied = true;

        for (int i = index - 1; i >= 0; i--) {
            if (stalls[i].isOccupied) {
                break;
            }
            stalls[i] = new Stall(i, false, stalls[i].L, i - (index - 1));
        }

        for (int i = index + 1; i < stalls.length; i++) {
            if (stalls[i].isOccupied) {
                break;
            }
            stalls[i] = new Stall(i, false, i - (index + 1), stalls[i].R);
        }
    }

    private static class Stall {
        int index;
        boolean isOccupied;
        int L;
        int R;
        int minLR;
        int maxLR;

        Stall(int index, boolean isOccupied, int L, int R) {
            this.index = index;
            this.isOccupied = isOccupied;
            this.L = L;
            this.R = R;

            this.minLR = Math.min(L, R);
            this.maxLR = Math.max(L, R);
        }
    }
}
