package online.codejam2016.round1;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.*;

/**

 */
public class RankAndFile { // B

    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new FileInputStream("data/online/codejam2016/round1/B-small-attempt1.in"));
        File out = new File("data/online/codejam2016/round1/B-small-attempt1.out");
        Files.deleteIfExists(out.toPath());
        out.createNewFile();

        int T = sc.nextInt();
        for (int test_case = 1; test_case <= T; test_case++) {
            int N = sc.nextInt();
            List<List<Integer>> lists = new ArrayList<>();
            List<List<Integer>> listsCopy = new ArrayList<>();

            int shortestHeight = 9999;
            int largestHeight = 0;
            for (int n = 0; n < 2*N-1; n++) {
                List<Integer> list = new ArrayList<>();
                for (int i = 0; i < N; i++) {
                    int height = sc.nextInt();
                    shortestHeight = Math.min(shortestHeight, height);
                    largestHeight = Math.max(largestHeight, height);
                    list.add(height);
                }
                lists.add(list);
                listsCopy.add(list);
            }
//            System.out.println(lists);

            List<Integer> firstRow = new ArrayList<>();
            List<Integer> firstCol = new ArrayList<>();
            for (List<Integer> l : lists) {
                if (l.get(0).equals(shortestHeight)) {
                    if (firstRow.isEmpty()) {
                        firstRow = l;
                    }
                    else {
                        firstCol = l;
                    }
                }
            }
//            lists.remove(firstRow);
//            lists.remove(firstCol);
//            System.out.println(firstRow);
//            System.out.println(firstCol);

            List<Integer> lastRow = new ArrayList<>();
            List<Integer> lastCol = new ArrayList<>();
            for (List<Integer> l : lists) {
                if (l.get(N-1).equals(largestHeight)) {
                    if (lastRow.isEmpty() && l.get(0).equals(firstRow.get(N-1))) {
                        lastRow = l;
                    }
                    else {
                        lastCol = l;
                    }
                }
            }
//            lists.remove(lastRow);
//            lists.remove(lastCol);
//            System.out.println(lastRow);
//            System.out.println(lastCol);

            // fill initial grid
            int[][] grid = new int[N][N];
            if (!firstRow.isEmpty()) {
                for (int i = 0; i < N; i++) {
                    grid[0][i] = firstRow.get(i);
                }
            }
            if (!firstCol.isEmpty()) {
                for (int i = 0; i < N; i++) {
                    grid[i][0] = firstCol.get(i);
                }
            }
            if (!lastRow.isEmpty()) {
                for (int i = 0; i < N; i++) {
                    grid[N - 1][i] = lastRow.get(i);
                }
            }
            if (!lastCol.isEmpty()) {
                for (int i = 0; i < N; i ++) {
                    grid[i][N-1] = lastCol.get(i);
                }
            }
//            System.out.println(Arrays.deepToString(grid));

            // traverse grid by row
            for (int i = 0; i < N; i++) {
                int start = grid[i][0];
                int end = grid[i][N-1];
                if (start == 0 || end == 0) {
                    continue;
                }

                List<Integer> list = new ArrayList<>();
                for (int j = 0; j < N; j++) {
                    int h = grid[i][j];
                    if (h == 0) {
                        break;
                    }
                    list.add(h);
                }

                if (list.size() == N) {
                    // remove from set
                    removeFromList(lists, list);
                }
                else {
                    // find match
                    List<Integer> matchingList = getMatchingList(lists, start, end);
                    for (int k = 0; k < matchingList.size(); k++) {
                        grid[i][k] = matchingList.get(k);
                    }
                }
            }

            // traverse grid by col
            for (int i = 0; i < N; i++) {
                int start = grid[0][i];
                int end = grid[N-1][i];
                if (start == 0 || end == 0) {
                    continue;
                }

                List<Integer> list = new ArrayList<>();
                for (int j = 0; j < N; j++) {
                    int h = grid[j][i];
                    if (h == 0) {
                        break;
                    }
                    list.add(h);
                }

                if (list.size() == N) {
                    // remove from set
                    removeFromList(lists, list);
                }
                else {
                    // find match
                    List<Integer> matchingList = getMatchingList(lists, start, end);
                    for (int k = 0; k < matchingList.size(); k++) {
                        grid[k][i] = matchingList.get(k);
                    }
                }
            }
//            System.out.println(Arrays.deepToString(grid));
//            System.out.println(lists);

            if (lists.size() > 0) {
                // get hole
                int row = -1;
                int col = -1;
                for (int i = 0; i < N; i++) {
                    for (int j = 0; j < N; j++) {
                        if (grid[i][j] == 0) {
                            row = i;
                            col = j;
                        }
                    }
                }
                if (row != -1 && col != -1) {
                    List<Integer> last = lists.remove(0);
                    grid[row][col] = last.get(col);
                }
            }
//            System.out.println(Arrays.deepToString(grid));
//            System.out.println(lists);

            List<List<Integer>> set = new ArrayList<>();
            // create lists from grid by row
            for (int i = 0; i < N; i++) {
                List<Integer> list = new ArrayList<>();
                for (int j = 0; j < N; j++) {
                    list.add(grid[i][j]);
                }
                set.add(list);
            }
            // create lists from grid by col
            for (int i = 0; i < N; i++) {
                List<Integer> list = new ArrayList<>();
                for (int j = 0; j < N; j++) {
                    list.add(grid[j][i]);
                }
                set.add(list);
            }

            // find missing one
            for (List l : listsCopy) {
                for (List ll : set) {
                    if (ll.equals(l)) {
                        set.remove(ll);
                        break;
                    }
                }
            }

            String line = "Case #" + test_case + ": ";
            for (Integer i : set.get(0)) {
                line += i + " ";
            }
            line += "\n";
            Files.write(Paths.get(out.getPath()), line.getBytes(), StandardOpenOption.APPEND);
        }
    }

    public static void removeFromList(List<List<Integer>> lists, List<Integer>list) {
        for (List l : lists) {
            if (l.equals(list)) {
                lists.remove(l);
                break;
            }
        }
    }

    public static List<Integer> getMatchingList(List<List<Integer>> lists, int start, int end) {
        List<Integer> matchingList = new ArrayList<>();
        for (List l : lists) {
            if (l.get(0).equals(start) && l.get(l.size()-1).equals(end)) {
                matchingList = l;
                lists.remove(l);
                break;
            }
        }

        return matchingList;
    }
}
