package online.codejam.codejam2017.qualification;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.Scanner;

/*
 * https://code.google.com/codejam/contest/3264486/dashboard#s=p1
 */
public class TidyNumbers {

    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new FileInputStream("data/online/codejam/codejam2017/qualification/B-small-attempt0.in"));
        File out = new File("data/online/codejam/codejam2017/qualification/B-small-attempt0.out");
        Files.deleteIfExists(out.toPath());
        out.createNewFile();

        int T = sc.nextInt();
        for (int test_case = 1; test_case <= T; test_case++) {
            long original = sc.nextLong();
            long l = original;

            while (!isTidyNumber(l)) {
                String lStr = String.valueOf(l);
                for (int i = lStr.length() - 1; i > 0; i--) {
                    if (lStr.charAt(i) < lStr.charAt(i - 1)) {
                        l = fixNumber(original, lStr, i);
                        break;
                    }
                }
            }

            // write result to file
            String line = "Case #" + test_case + ": " + l + "\n";
            Files.write(Paths.get(out.getPath()), line.getBytes(), StandardOpenOption.APPEND);
            System.out.print(line);
        }
    }

    public static boolean isTidyNumber(long l) {
        String lStr = String.valueOf(l);
        for (int i = 0; i < lStr.length() - 1; i++) {
            if (lStr.charAt(i) > lStr.charAt(i + 1)) {
                return false;
            }
        }

        return true;
    }

    public static long fixNumber(long original, String lStr, int index) {
        long fixed = Long.valueOf(lStr.substring(0, index - 1) + "99" + lStr.substring(index + 1));
        if (fixed > original) {
            String front = lStr.substring(0, index - 1);
            String beforeIndex = String.valueOf(Character.getNumericValue(lStr.charAt(index - 1)) - 1);
            String atIndex = "9";
            String back = lStr.substring(index + 1);
            fixed = Long.valueOf(front + beforeIndex + atIndex + back);
        }

        return fixed;
    }
}
