package online.codejam.codejam2017.qualification;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

/*
 * https://code.google.com/codejam/contest/3264486/dashboard
 */
public class OversizedPancakeFlipper {

    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new FileInputStream("data/online/codejam/codejam2017/qualification/A-large.in"));
        File out = new File("data/online/codejam/codejam2017/qualification/A-large.out");
        Files.deleteIfExists(out.toPath());
        out.createNewFile();

        int T = sc.nextInt();
        for (int test_case = 1; test_case <= T; test_case++) {
            String S = sc.next();
            int K = sc.nextInt();

            Set<String> patternsSeen = new HashSet<>();
            patternsSeen.add(S);
            int numFlips = 0;

            while (S.contains("-")) {
                String nextS = S;
                for (int i = 0; i < S.length() - K; i++) {
                    if (S.charAt(i) == '-') {
                        nextS = S.substring(0, i) + flip(nextS.substring(i, i + K)) + nextS.substring(i + K);
                        break;
                    }
                }

                if (nextS.equals(S) && S.substring(S.length() - K).contains("-")) {
                    nextS = S.substring(0, S.length() - K) + flip(S.substring(S.length() - K));
                }

                if (patternsSeen.contains(nextS)) {
                    numFlips = -1;
                    break;
                }

                patternsSeen.add(nextS);
                numFlips++;
                S = nextS;
            }

            // write result to file
            String line = "Case #" + test_case + ": " + (numFlips == -1 ? "IMPOSSIBLE" : numFlips) + "\n";
            Files.write(Paths.get(out.getPath()), line.getBytes(), StandardOpenOption.APPEND);
            // System.out.print(line);
        }
    }

    public static String flip(String s) {
        StringBuilder stringBuilder = new StringBuilder();
        for (int i = 0; i < s.length(); i++) {
            stringBuilder.append(s.charAt(i) == '-' ? '+' : '-');
        }

        return stringBuilder.toString();
    }
}
