package r2;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.Map;
import java.util.PriorityQueue;

public class Vines {
  final BufferedReader reader;
  final PrintStream writer;

  private static class StartP implements Comparable<StartP> {
    public StartP(int dheld, int l, int iheld) {
      this.dheld = dheld;
      this.l = l;
      this.iheld = iheld;
    }

    public int dheld, l, iheld;

    @Override
    public int compareTo(StartP o) {
      return Integer.compare(dheld + l, o.dheld + o.l);
    }
  }

  int min(int a, int b) {
    return a < b ? a : b;
  }

  /*
   * boolean possible(int[] ls, int[] ds, int[] bestStarts) { }
   */
  boolean possible(int[] ls, int[] ds) {
    Map<Integer, Integer> maxFrom = new HashMap<Integer, Integer>();
    PriorityQueue<StartP> startps = new PriorityQueue<StartP>();
    startps.add(new StartP(ds[0], min(ds[0], ls[0]), 0));
    int k = ls.length;
    while (!startps.isEmpty()) {
      StartP p = startps.poll();
      if (p.dheld + p.l >= ds[k]) {
        return true;
      }
      for (int i = p.iheld + 1; i < k; i++) {
        if (p.dheld + p.l < ds[i]) continue;
        int howFar = ds[i] + min(ds[i] - p.dheld, ls[i]);
        if (maxFrom.containsKey(i) && maxFrom.get(i) >= howFar) continue;
        maxFrom.put(i, howFar);
        startps.add(new StartP(ds[i], min(ds[i] - p.dheld, ls[i]), i));
      }
    }
    return false;
  }

  /**
   * Just IO
   */
  void run() {
    int ncases = readInt();
    for (int ncase = 1; ncase <= ncases; ncase++) {
      int k = readInt();
      int[] ds = new int[k + 1], ls = new int[k];
      for (int j = 0; j < k; j++) {
        int[] arr = readInts();
        ds[j] = arr[0];
        ls[j] = arr[1];
      }
      ds[k] = readInt();
      boolean sol = possible(ls, ds);
      System.out.println("Case #" + ncase + ": " + (sol ? "YES" : "NO"));
    }
  }

  int readInt() {
    try {
      return Integer.parseInt(reader.readLine());
    } catch (Exception e) {
      throw new RuntimeException(e);
    }
  }

  int[] readInts() {
    try {
      String[] parts = reader.readLine().split(" ");
      int[] ret = new int[parts.length];
      for (int i = 0; i < parts.length; i++) {
        ret[i] = Integer.parseInt(parts[i]);
      }
      return ret;
    } catch (IOException e) {
      throw new RuntimeException(e);
    }
  }

  Vines(String input, String output) {
    InputStream inputStream = this.getClass().getResourceAsStream(input);
    reader = new BufferedReader(new InputStreamReader(inputStream));
    if (output == null) {
      writer = null;
    } else {
      try {
        writer = new PrintStream(output);
      } catch (Exception e) {
        throw new RuntimeException(e);
      }
    }
  }

  public static void main(String[] args) {
    try {
      new Vines("A-large.in", "C:/workspace/codejam/src/r2/A-large.out").run();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}
