package r2;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Comparator;

public class Yoga {
  final BufferedReader reader;
  final PrintStream writer;

  int min(int a, int b) {
    return a < b ? a : b;
  }

  private static class Dude {
    public int i, r;
    public int x, y;

    // public double y;

    public Dude(int i, int r) {
      this.i = i;
      this.r = r;
    }
  }

  double[] solve(int n, int w, int l, int[] ris) {
    if (w < l) {
      double[] sol = solve(n, l, w, ris);
      for (int i = 0; i < n; i++) {
        double tmp = sol[2 * i];
        sol[2 * i] = sol[2 * i + 1];
        sol[2 * i + 1] = tmp;
      }
      return sol;
    }
    // w >= l

    Dude[] dudes = new Dude[n];
    for (int i = 0; i < n; i++) {
      dudes[i] = new Dude(i, ris[i]);
    }
    Arrays.sort(dudes, new Comparator<Dude>() {
      @Override
      public int compare(Dude o1, Dude o2) {
        return -Integer.compare(o1.r, o2.r);
      }
    });

    // double[] c = new double[n], r = new double[n];
    int[] maxs = new int[w + 1];
    for (int i = 0; i < w + 1; i++) {
      maxs[i] = Integer.MIN_VALUE;
    }
    // int x = 0, dir = 1;
    for (Dude dude : dudes) {
      int x = 0, start = 0, mmax = Integer.MIN_VALUE; // Math.max(0, x - dude.r);
      boolean succ = false;
      while (!succ) {
        succ = true;
        for (int i = start; i <= Math.min(x + dude.r, w); i++) {
          if (maxs[i] + dude.r > l) {
            start = i + 1;
            x = i + dude.r + 1;
            if (start > w) {
              throw new RuntimeException("fail");
            }
            mmax = Integer.MIN_VALUE;
            succ = false;
            break;
          } else {
            mmax = Math.max(mmax, maxs[i]);
          }
        }
      }
      dude.x = x;
      dude.y = Math.max(0, mmax + dude.r);
      for (int i = Math.max(0, x - dude.r); i <= Math.min(w, x + dude.r); i++) {
        // int dx = Math.max(0, Math.abs(x - i) - 1);
        maxs[i] = dude.y + dude.r; // (int) Math.ceil(Math.sqrt(dude.r * dude.r - dx * dx));
      }
    }

    double[] sol = new double[n * 2];
    for (int i = 0; i < n; i++) {
      sol[2 * dudes[i].i] = dudes[i].x;
      sol[2 * dudes[i].i + 1] = dudes[i].y;
    }
    return sol;
  }

  /**
   * Just IO
   */
  void run() {
    int ncases = readInt();
    for (int ncase = 1; ncase <= ncases; ncase++) {
      int[] arr = readInts();
      int n = arr[0], w = arr[1], l = arr[2];
      int[] ris = readInts();
      double[] sols = solve(n, w, l, ris);
      StringBuilder sb = new StringBuilder("Case #" + ncase + ": ");
      for (double sol : sols) {
        sb.append(sol).append(" ");
      }
      if (writer != null)
        writer.println(sb.toString());
      System.out.println(sb.toString());
    }
  }

  int readInt() {
    try {
      return Integer.parseInt(reader.readLine());
    } catch (Exception e) {
      throw new RuntimeException(e);
    }
  }

  int[] readInts() {
    try {
      String[] parts = reader.readLine().split(" ");
      int[] ret = new int[parts.length];
      for (int i = 0; i < parts.length; i++) {
        ret[i] = Integer.parseInt(parts[i]);
      }
      return ret;
    } catch (IOException e) {
      throw new RuntimeException(e);
    }
  }

  Yoga(String input, String output) {
    InputStream inputStream = this.getClass().getResourceAsStream(input);
    reader = new BufferedReader(new InputStreamReader(inputStream));
    if (output == null) {
      writer = null;
    } else {
      try {
        writer = new PrintStream(output);
      } catch (Exception e) {
        throw new RuntimeException(e);
      }
    }
  }

  public static void main(String[] args) {
    try {
      new Yoga("B-large.in", "C:/workspace/codejam/src/r2/B-large.out").run();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}
