package gcj2014;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.Scanner;

public class ProblemB {

    void solve(int c, Scanner sc, PrintWriter pw) {
        double I = 2; // initial cookie/sec
        double C = sc.nextDouble(); // farm cost
        double F = sc.nextDouble(); // farm bonus
        double X = sc.nextDouble(); // goal
        double T = 0; // time
        double time1 = X / I; // time it would take to get with current rate
        double time2 = (C / I) + (X / (I + F)); // time it would take to get the next farm then make it to goal
        while (time1 > time2) { // buying a farm is more beneficial
            T += C / I; // add time to next farm
            I += F; // inc rate
            time1 = X / I; // time it would take to get with current rate
            time2 = (C / I) + (X / (I + F)); // recalc time to next farm and then to goal
        }
        T += X / I; // add the time where collecting without buying farm until goal
        DecimalFormat df = new DecimalFormat("#.#######");
        pw.printf("Case #%d: %s\r\n", c, df.format(T));
    }

    public static void main(String[] args) {
        try {
            Scanner sc = new Scanner(new FileReader("./B-small-attempt0.in"));
            PrintWriter pw = new PrintWriter(new FileWriter("./output.txt"));

            int cases = Integer.parseInt(sc.nextLine());

            for (int i = 1; i <= cases; i++) {
                System.out.println("Solving Case " + i + "...");
                new ProblemB().solve(i, sc, pw);
            }
            pw.flush();
            pw.close();
            sc.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}
