import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.Scanner;


public class Main {

		public static void main(String[] args) throws FileNotFoundException {
	        File in = new File("src/inputs/A-small-attempt0.in"); 
			Scanner sc = new Scanner(in);
			
			String line = sc.nextLine();
			int numInputs = Integer.parseInt(line);
			
			int[][] board = new int[4][4];
			for (int n = 0; n < numInputs; n++) {
				for (int i = 0; i < 4; i++) {
					line = sc.nextLine();
					for (int j = 0; j < 4; j++) {
						switch(line.charAt(j)) {
						case '.':
							board[i][j]=0;
							break;
						case 'X':
							board[i][j]=2;
							break;
						case 'O':
							board[i][j]=3;
							break;
						case 'T':
							board[i][j]=5;
							break;
						}
					}
				}
				if (sc.hasNext())
					sc.nextLine();
				//pl(Arrays.deepToString(board));
				
				char whoWon = whoWon(board);
				
				printAnswer(n+1,whoWon);

			}
			
			
		}
		
		private static void printAnswer(int num, char stat) {
			switch(stat) {
			case 'x':
				pl("Case #"+num+": X won");
				break;
			case 'o':
				pl("Case #"+num+": O won");
				break;
			case 'd':
				pl("Case #"+num+": Draw");
				break;
			case 'n':
				pl("Case #"+num+": Game has not completed");
				break;
			default:
				pl("?");
			}
			
		}

		private static char whoWon(int[][] board) {
			int hasZero = 1;
			// cols and rows
			for (int i = 0; i < 4; i++) {
				int rowi = board[0][i]*board[1][i]*board[2][i]*board[3][i];
				hasZero *= rowi;
				int coli = board[i][0]*board[i][1]*board[i][2]*board[i][3];
				if (rowi == 16 || rowi == 40 || coli == 16 || coli == 40)
					return 'x';
				else if (rowi == 81 || rowi == 135 || coli == 81 || coli == 135)
					return 'o';
			}
			// diags
			int diag1 =  board[0][0]*board[1][1]*board[2][2]*board[3][3];
			int diag2 =  board[3][0]*board[2][1]*board[1][2]*board[0][3];

			if (diag1 == 16 || diag1 == 40 || diag2 == 16 || diag2 == 40)
				return 'x';
			else if (diag1 == 81 || diag1 == 135 || diag2 == 81 || diag2 == 135)
				return 'o';
			
			// No winner
			if (hasZero == 0)
				return 'n';
			return 'd';
		}

		private static void p(String s) {
			System.out.print(s);
		}
		
		private static void pl(String s) {
			System.out.println(s);
		}
		
}
