import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;
import java.util.Scanner;
import java.util.TreeSet;


public class Main {

	public static void main (String[] args) throws IOException{
		File in = new File("src/testin.txt");
		File out = new File("src/out.txt");
		
		Scanner s = new Scanner(in);
		FileWriter fw = new FileWriter(out.getAbsoluteFile());
		BufferedWriter bw = new BufferedWriter(fw);
		
		int numBoards = Integer.parseInt(s.nextLine());
		for (int n = 0; n < numBoards; n++) {
			int[][] board = parseBoard(s);
			bw.write(formatOutput(n+1,unwindTime(board)));
		}
		
		bw.close();
	}

	private static Boolean unwindTime(int[][] board) {
		TreeSet<Integer> h = new TreeSet<Integer>();
		for (int i = 0; i < board.length; i++) {
			for (int j = 0; j < board[0].length; j++) {
				h.add(board[i][j]);
			}
		}
		Iterator<Integer> itr = h.iterator();
		while(itr.hasNext()) { // in order of numbers in the board
			Integer i = itr.next();
			undoLowestCuts(i,board);
		}
		if (boardClear(board))
			return true;
		return false;
	}
	
	private static boolean boardClear(int[][] board) {
		for (int i = 0; i < board.length; i++) {
			for (int j = 0; j < board[0].length; j++) {
				if (board[i][j] != -1)
					return false;
			}
		}
		return true;
	}
	
	private static void undoLowestCuts(int cut, int[][] board) {
		// rows
		outer1:
		for (int i = 0; i < board.length; i++) {
			for (int j = 0; j < board[0].length; j++) {
				if (board[i][j] != cut && board[i][j] != -1) {
					continue outer1;
				}
			}
			for (int j = 0; j < board[0].length; j++) {
				board[i][j] = -1;
			}
		}
		
		// cols
		outer2:
		for (int j = 0; j < board[0].length; j++) {
			for (int i = 0; i < board.length; i++) {
				if (board[i][j] != cut && board[i][j] != -1) {
					continue outer2;
				}
			}
			for (int i = 0; i < board.length; i++) {
				board[i][j] = -1;
			}
		}
	}
	
	private static int[][] parseBoard(Scanner s) {
		int rows = s.nextInt();
		int cols = s.nextInt();
		int[][] board = new int[rows][cols];
		for (int i = 0; i < rows; i++) {
			for (int j = 0; j < cols; j++) {
				board[i][j] = s.nextInt();
			}
		}
		return board;

	}

	private static String formatOutput(int caseNum, Boolean possible) {
		if (possible) {
			return "Case #"+caseNum+": YES\n";
		} else {
			return "Case #"+caseNum+": NO\n";
		}
	}
	
}
