import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class Main {

	public static void main (String[] args) throws IOException{
		File in = new File("src/in.txt");
		File out = new File("src/out.txt");
		
		Scanner s = new Scanner(in);
		FileWriter fw = new FileWriter(out.getAbsoluteFile());
		BufferedWriter bw = new BufferedWriter(fw);
		
		int numRanges = Integer.parseInt(s.nextLine());
		for (int n = 0; n < numRanges; n++) {
			String start = s.next();
			String end = s.next();
			bw.write(formatOutput(n+1,findInRange(start, end)));
		}
		
		s.close();
		bw.close();
	}

	private static Long findInRange(String start, String end) {
		// squares end in: 0, 1, 4, 9, 6, 5. But can't be 0 b/c no leading 0
		String num = start+"";
		Long total = 0L;
		while (true) {
			boolean possible = true;
			switch (num.charAt(0)) {
			case 2:
			case 3: 
			case 7:
			case 8:
			case 0:
				possible = false;
			}
			if (!possible)
				continue;
			
			if (checkIfPalindrome(num)) {
				String sr = squareRoot(num);
				if (checkIfPalindrome(sr)) {
					//System.out.println(num);
					total++;
				}
			}
			
			if (num.equals(end))
				return total;
			
			num = incrementString(num);
		}
	}
	
	private static String incrementString(String num) {
		char[] c = num.toCharArray();
		for (int i = num.length(); i > 0; i--) {
			if (Integer.parseInt(c[i-1]+"") != 9) {
				c[i-1]=(char)(c[i-1]+1);
				break;
			} else {
				c[i-1] = '0';
			}
			if (i == 1) {
				return "1"+new String(c);
			}
		}
		String s = new String(c);
		return s;
	}

	private static boolean checkIfPalindrome(String s) {
		for (int i = 0; i < s.length()/2; i++) {
			if (s.charAt(i) != s.charAt(s.length()-1-i))
				return false;
		}
		return true;
	}
	
	private static String squareRoot(String n) {

		Double d = Double.parseDouble(n);
		if(Math.abs(Math.round(Math.sqrt(d))-Math.sqrt(d)) > .00005) {
			return "-1"; // square root isn't integral
		}
		return ""+(int)Math.round(Math.sqrt(d));
	}
	
	private static String formatOutput(int caseNum, Long ans) {
		return "Case #"+caseNum+": "+ans+"\n";
	}
	
}
