import java.io.BufferedWriter;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Scanner;

/**
 * @author ddexter
 */
public class TidyNumbers {

    private static long pow10(final int x) {
        long ret = 1;
        for (int i = 0; i < x; ++i) {
            ret *= 10;
        }
        return ret;
    }

    private static long solve(final long x) {
        long y = x;
        int numNines = 0;
        for (int i = 1; y > 9; ++i) {
            long ones = y % 10;
            y /= 10;
            long tens = y % 10;

            if (tens > ones) {
                numNines = i;
                --y;
            }
        }

        if (numNines > 0) {
            long inflectionPoint = pow10(numNines);
            long prefix = x / inflectionPoint;

            return ((prefix - 1) * inflectionPoint) + (inflectionPoint - 1);
        } else {
            return x;
        }
    }

    public static void main(final String args[]) throws Exception {
        final String input = args[0];
        try (InputStream is = Files.newInputStream(Paths.get(input));
             BufferedWriter writer = Files.newBufferedWriter(Paths.get("out.txt"));) {
            final Scanner scanner = new Scanner(is);

            final int n = scanner.nextInt();
            for (int i = 0; i < n; ++i) {
                final long x = scanner.nextLong();
                final long result = solve(x);

                writer.write("Case #" + (i + 1) + ": " + result + "\n");
                writer.flush();
            }
        }
    }
}
