import java.io.BufferedWriter;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Scanner;

/**
 * @author ddexter
 */
public class A {
    private static String shorten(final String pancakes) {
        int i = 0;
        for (; i < pancakes.length(); ++i) {
            if (pancakes.charAt(i) != '+') {
                break;
            }
        }
        return pancakes.substring(i);
    }

    private static boolean isFlippable(final String pancakes, final int flipper) {
        return pancakes.length() >= flipper;
    }

    private static String flip(final String pancakes, final int flipper) {
        final StringBuilder sb = new StringBuilder();
        for (int i = 0; i < flipper; ++i) {
            final char flippedPancake = pancakes.charAt(i) == '-' ? '+' : '-';
            sb.append(flippedPancake);
        }

        if (pancakes.length() > flipper) {
            sb.append(pancakes.substring(flipper));
        }

        return sb.toString();
    }

    private static String solve(String pancakes, final int flipper) {
        pancakes = shorten(pancakes);

        int n = 0;
        while (isFlippable(pancakes, flipper)) {
            ++n;
            pancakes = flip(pancakes, flipper);
            pancakes = shorten(pancakes);
        }

        return pancakes.length() == 0 ? Integer.toString(n) : "IMPOSSIBLE";
    }

    public static void main(final String args[]) throws Exception {
        final String input = args[0];
        try (InputStream is = Files.newInputStream(Paths.get(input));
             BufferedWriter writer = Files.newBufferedWriter(Paths.get("out.txt"));) {
            final Scanner scanner = new Scanner(is);
            final int n = scanner.nextInt();
            for (int i = 0; i < n; ++i) {
                final String pancakes = scanner.next();
                final int flipper = scanner.nextInt();

                final String result = A.solve(pancakes, flipper);

                writer.write("Case #" + (i + 1) + ": " + result + "\n");
                writer.flush();
            }
        }
    }
}
