import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Calendar;

public class B {

	private static final double LOG2 = Math.log(2);
	private static CodeJamIO io = new CodeJamIO();

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		try {
			init();

			int numCases = Integer.parseInt(io.readNextLine()[0]);
			for (int i=1; i <= numCases; i++) {
				io.debug("Solving Case #" + i + "...");
				solveCase(i);
				io.debug("Case #" + i + " solved!");
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	/**
	 * Performs initial computations
	 */
	private static void init() {
		
	}

	/**
	 * Solves a Test Case
	 * 
	 * @param caseNum
	 * @throws IOException
	 */
	private static void solveCase(int caseNum) throws IOException {
		// Read input
		String[] tokens = io.readNextLine();
		int l = Integer.parseInt(tokens[0]);
		int p = Integer.parseInt(tokens[1]);
		int c = Integer.parseInt(tokens[2]);
		
		// Do the work
		int numIntervals = 0;
		while (l < p) {
			numIntervals++;
			l *= c;
		}
		
		int numTests = (int) Math.ceil(Math.log(numIntervals)/LOG2);

		// Print results
		io.print("Case #" + caseNum + ": " + numTests).println();
	}

	/**
	 * Input and Output CodeJam style
	 *
	 */
	private static class CodeJamIO {
		private static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		private static PrintWriter out = new PrintWriter(System.out, true);
		private static PrintWriter err = new PrintWriter(System.err, true);

		/**
		 * 
		 * @return
		 * @throws IOException
		 */
		public String[] readNextLine() throws IOException {
			String line = in.readLine();
			String[] tokens = line.split("\\s+");
			return tokens;
		}

		public CodeJamIO println() {
			out.println();
			return this;
		}

		public CodeJamIO print(String message) {
			out.print(message);
			return this;
		}
		
		/**
		 * 
		 * @param caseNum
		 * @param results
		 */
		public CodeJamIO print(Object[] results) {
			String delim = "";
			for (int i=0; i < results.length; i++) {
				print(delim + results[i]);
			}
			return this;
		}

		/**
		 * 
		 * @param caseNum
		 * @param results
		 */
		public CodeJamIO println(Object[][] results) {
			for (int i=0; i < results.length; i++) {
				print(results[i]).println();
			}
			return this;
		}

		/**
		 * 
		 * @param message
		 */
		public void debug(String message) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
		}

	}

}
