import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Calendar;
import java.util.HashMap;

public class A {

	private static CodeJamIO io = new CodeJamIO();

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		try {
			init();

			int numCases = Integer.parseInt(io.readNextLine()[0]);
			for (int i=1; i <= numCases; i++) {
				io.debug("Solving Case #" + i + "...");
				solveCase(i);
				io.debug("Case #" + i + " solved!");
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	/**
	 * Performs initial computations
	 */
	private static void init() {
		
	}

	/**
	 * Solves a Test Case
	 * 
	 * @param caseNum
	 * @throws IOException
	 */
	private static void solveCase(int caseNum) throws IOException {
		// Read input
		String[] tokens = io.readNextLine();
		int n = Integer.parseInt(tokens[0]);
		int a[] = new int[n];
		int b[] = new int[n];
		HashMap<Integer, Integer> ab = new HashMap<Integer, Integer>();
		for (int i=0; i < n; i++) {
			tokens = io.readNextLine();
			a[i] = Integer.parseInt(tokens[0]);
			b[i] = Integer.parseInt(tokens[1]);
			ab.put(a[i], b[i]);
		}
		
		// Do the work
		Arrays.sort(a);
		Arrays.sort(b);
		
		HashMap<Integer, Integer> bpos = new HashMap<Integer, Integer>();
		
		for (int i=0; i < n; i++) {
			bpos.put(b[i], i);
		}
		
		long intersections = 0;
		int maxb = 0;
		for (int i=0; i < n; i++) {
			if (ab.get(a[i]) < maxb) {
				continue;
			}
			maxb = ab.get(a[i]);
			long inter = Math.abs(i - bpos.get(maxb));
			io.debug("Intersections for " + a[i] + ", " + maxb + ": " + inter);
			intersections += inter;
		}

		// Print results
		io.print("Case #" + caseNum + ": " + intersections).println();
	}

	/**
	 * Input and Output CodeJam style
	 *
	 */
	private static class CodeJamIO {
		private static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		private static PrintWriter out = new PrintWriter(System.out, true);
		private static PrintWriter err = new PrintWriter(System.err, true);

		/**
		 * 
		 * @return
		 * @throws IOException
		 */
		public String[] readNextLine() throws IOException {
			String line = in.readLine();
			String[] tokens = line.split("\\s+");
			return tokens;
		}

		public CodeJamIO println() {
			out.println();
			return this;
		}

		public CodeJamIO print(String message) {
			out.print(message);
			return this;
		}
		
		/**
		 * 
		 * @param caseNum
		 * @param results
		 */
		public CodeJamIO print(Object[] results) {
			String delim = "";
			for (int i=0; i < results.length; i++) {
				print(delim + results[i]);
			}
			return this;
		}

		/**
		 * 
		 * @param caseNum
		 * @param results
		 */
		public CodeJamIO println(Object[][] results) {
			for (int i=0; i < results.length; i++) {
				print(results[i]).println();
			}
			return this;
		}

		/**
		 * 
		 * @param message
		 */
		public void debug(String message) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
		}

	}

}
