import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class B {

	private static CodeJamIO io = new CodeJamIO();

	private static Map<Character, Integer> index = new HashMap<Character, Integer>();
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {

		try {
			init();

			int numCases = Integer.parseInt(io.readNextLine()[0]);
			for (int i=1; i <= numCases; i++) {
				io.debug("Solving Case #" + i + "...");
				solveCase(i);
				io.debug("Case #" + i + " solved!");
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	/**
	 * Performs initial computations
	 */
	private static void init() {
		int i=0;
		index.put('Q', i++);
		index.put('W', i++);
		index.put('E', i++);
		index.put('R', i++);
		index.put('A', i++);
		index.put('S', i++);
		index.put('D', i++);
		index.put('F', i++);
	}

	/**
	 * Solves a Test Case
	 * 
	 * @param caseNum
	 * @throws IOException
	 */
	private static void solveCase(int caseNum) throws IOException {
		Character[][] combination = new Character[index.size()][index.size()];
		HashMap<Character, ArrayList<Character>> opposition =
			initOpposition();
		
		// Read input
		String[] tokens = io.readNextLine();
		int idx = 0;
		int C = Integer.parseInt(tokens[idx]);
		idx++;
		for (int i=idx; i < idx+C; i++) {
			String triple = tokens[i];
			int k = index.get(triple.charAt(0));
			int l = index.get(triple.charAt(1));
			char nonBase = triple.charAt(2);
			combination[k][l] = nonBase;
			combination[l][k] = nonBase;
		}
		idx += C;
		int D = Integer.parseInt(tokens[idx]);
		idx++;
		for (int i=idx; i < idx+D; i++) {
			String pair = tokens[i];
			char oppA = pair.charAt(0);
			char oppB = pair.charAt(1);
			opposition.get(oppA).add(oppB);
			opposition.get(oppB).add(oppA);
		}
		idx += D;
		int N = Integer.parseInt(tokens[idx]);
		idx++;
		String elements = tokens[idx];
		
		// Do the work
		int[] occurences = new int[index.size()];
		List<Character> finalElements = new ArrayList<Character>(N);
		occurences[index.get(elements.charAt(0))]++;
		finalElements.add(elements.charAt(0));
		for (int i=1; i < N; i++) {
			char current = elements.charAt(i);
			io.debug("Adding base element " + current);
			if (finalElements.isEmpty()) {
				finalElements.add(current);
				occurences[index.get(current)]++;
				continue;
			}
			Character previous = finalElements.get(finalElements.size()-1);
			Character comb = null;
			if (index.get(previous) != null) {
				comb = combination[index.get(current)][index.get(previous)];
			}
			if (comb != null) {
				if (occurences[index.get(previous)] > 0) {
					occurences[index.get(previous)]--;
				}
				finalElements.remove(finalElements.size()-1);
				finalElements.add(comb);
			} else {
				boolean found = false;
				for (char c : opposition.get(current)) {
					if (occurences[index.get(c)] > 0) {
						found = true;
						finalElements = new ArrayList<Character>(N);
						occurences = new int[index.size()];
						break;
					}
				}
				if (!found) {
					finalElements.add(current);
					occurences[index.get(current)]++;
				}
			}
		}
		
		// Print results
		StringBuffer buf = new StringBuffer(N);
		buf.append('[');
		String delim = "";
		for (char c : finalElements) {
			buf.append(delim).append(c);
			delim = ", ";
		}
		buf.append(']');
		io.printCase(caseNum).println(buf.toString());

	}

	private static HashMap<Character, ArrayList<Character>> initOpposition() {
		HashMap<Character, ArrayList<Character>> opposition =
			new HashMap<Character, ArrayList<Character>>();
		for (char c : index.keySet()) {
			opposition.put(c, new ArrayList<Character>(index.size()));
		}
		return opposition;
	}

	/**
	 * Input and Output CodeJam style
	 *
	 */
	private static class CodeJamIO {
		private static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		private static PrintWriter out = new PrintWriter(System.out, true);
		private static PrintWriter err = new PrintWriter(System.err, true);

		public String[] readNextLine() throws IOException {
			String line = in.readLine();
			String[] tokens = line.split("\\s+");
			return tokens;
		}

		public CodeJamIO printCase(int caseNum) { return print("Case #" + caseNum + ": " ); }
		
		public CodeJamIO print(Object o) { out.print(o); return this; }

		public CodeJamIO print(Object o[]) { return print(concat(o)); }

		public CodeJamIO print(Object o[][]) { return print(concat(o)); }

		public CodeJamIO println() { out.println(); return this; }

		public CodeJamIO printlnCase(int caseNum) { return printCase(caseNum).println(); }
		
		public CodeJamIO println(Object o) { return print(o).println(); }

		public CodeJamIO println(Object o[]) { return print(o).println(); }

		public CodeJamIO println(Object o[][]) { return print(concat(o)).println(); }

		
		private String concat(Object[] o) {
			StringBuffer buf = new StringBuffer(10*o.length);
			
			String delim = "";
			for (int i=0; i < o.length; i++) {
				buf.append(delim).append(o[i]);
				delim = " ";
			}
			return buf.toString();
		}
		
		private String concat(Object[][] o) {
			StringBuffer buf = new StringBuffer(100*o.length);
			for (int i=0; i < o.length; i++) {
				buf.append(concat(o[i])).append("\n");
			}
			return buf.toString();
		}

		public void debug(String message) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
		}

		public void debug(String message, Object[] o) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			err.println("\t" + concat(o));
		}

		public void debug(String message, Object[][] o) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			String values = concat(o);
			err.println("\t" + values.replaceAll("\n", "\n\t"));
		}

	}

}
