import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Calendar;
import java.util.List;

public class B {

	private static CodeJamIO io = new CodeJamIO();

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		try {
			init();

			int numCases = Integer.parseInt(io.readNextLine()[0]);
			for (int i=1; i <= numCases; i++) {
				io.debug("Solving Case #" + i + "...");
				solveCase(i);
				io.debug("Case #" + i + " solved!");
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	/**
	 * Performs initial computations
	 */
	private static void init() {
		
	}

	/**
	 * Solves a Test Case
	 *
	 * @param caseNum
	 * @throws IOException
	 */
	private static void solveCase(int caseNum) throws IOException {
		// Read input
		String[] tokens = io.readNextLine();
		int n = Integer.parseInt(tokens[0]);
		int r = Integer.parseInt(tokens[1]);
		int o = Integer.parseInt(tokens[2]);
		int y = Integer.parseInt(tokens[3]);
		int g = Integer.parseInt(tokens[4]);
		int b = Integer.parseInt(tokens[5]);
		int v = Integer.parseInt(tokens[6]);

		// Do the work
		StringBuilder result = new StringBuilder();
		Character last = null;
		if (o+1 <= b) {
			result.append(fill(o, "BO")).append("B");
			b = b-o-1;
			last = 'B';
		} else if (o == b && b == n/2.0) {
			result.append(fill(o, "BO"));
			b = 0;
		}
		if (g+1 <= r) {
			result.append(fill(g, "RG")).append("R");
			r = r-g-1;
			last = 'R';
		} else if (g == r && r == n/2.0) {
			result.append(fill(g, "RG"));
			r = 0;
		}
		if (v+1 <= y) {
			result.append(fill(v, "YV")).append("Y");
			y = y-v-1;
			last = 'Y';
		} else if (v == y && y == n/2.0) {
			result.append(fill(v, "YV"));
			y = 0;
		}

		LOOP: while (r > 0 || b > 0 || y > 0) {
			switch (last) {
				case 'B':
					if (b > 0 && r <= 0 && y <= 0) {
						result = new StringBuilder("IMPOSSIBLE");
						break LOOP;
					} else if (r >= y) {
						result.append("R");
						r--;
						last = 'R';
					} else if (r < y) {
						result.append("Y");
						y--;
						last = 'Y';
					}
					break;
				case 'R':
					if (r > 0 && b <= 0 && y <= 0) {
						result = new StringBuilder("IMPOSSIBLE");
						break LOOP;
					} else if (b >= y) {
						result.append("B");
						b--;
						last = 'B';
					} else if (b < y) {
						result.append("Y");
						y--;
						last = 'Y';
					}
					break;
				case 'Y':
					if (y > 0 && r <= 0 && b <= 0) {
						result = new StringBuilder("IMPOSSIBLE");
						break LOOP;
					} else if (r >= b) {
						result.append("R");
						r--;
						last = 'R';
					} else if (r < b) {
						result.append("B");
						b--;
						last = 'B';
					}
					break;
			}
		}

		// Print results
		io.printCase(caseNum).println(result.toString());
	}

	private static String fill(int n, String s) {
		StringBuilder buf = new StringBuilder();
		for (int i = 0; i < n; i++) {
			buf.append(s);
		}
		return buf.toString();
	}

	/**
	 * Input and Output CodeJam style
	 *
	 */
	private static class CodeJamIO {
		private static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		private static PrintWriter out = new PrintWriter(System.out, true);
		private static PrintWriter err = new PrintWriter(System.err, true);

		public String[] readNextLine() throws IOException {
			String line = in.readLine();
			String[] tokens = line.split("\\s+");
			return tokens;
		}

		public CodeJamIO printCase(int caseNum) { return print("Case #" + caseNum + ": " ); }
		
		public CodeJamIO print(Object o) { out.print(o); return this; }

		public CodeJamIO print(Object o[]) { return print(concat(o)); }

		public CodeJamIO print(Object o[][]) { return print(concat(o)); }

		public CodeJamIO println() { out.println(); return this; }

		public CodeJamIO printlnCase(int caseNum) { return printCase(caseNum).println(); }
		
		public CodeJamIO println(Object o) { return print(o).println(); }

		public CodeJamIO println(Object o[]) { return print(o).println(); }

		public CodeJamIO println(Object o[][]) { return print(concat(o)).println(); }

		public CodeJamIO println(List<Integer[]> l) { return print(concat(l)).println(); }

		
		private String concat(Object[] o) {
			StringBuffer buf = new StringBuffer(10*o.length);
			
			String delim = "";
			for (int i=0; i < o.length; i++) {
				buf.append(delim).append(o[i]);
				delim = " ";
			}
			return buf.toString();
		}
		
		private String concat(Object[][] o) {
			StringBuffer buf = new StringBuffer(100*o.length);
			for (int i=0; i < o.length; i++) {
				buf.append(concat(o[i])).append("\n");
			}
			return buf.toString();
		}

		private String concat(List<Integer[]> list) {
			StringBuffer buf = new StringBuffer();
			String delim = "";
			for (Object[] elm : list) {
				buf.append(delim).append(concat(elm)).append("\n");
			}
			return buf.toString();
		}

		public void debug(String message) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
		}

		public void debug(String message, Object[] o) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			err.println("\t" + concat(o));
		}

		public void debug(String message, Object[][] o) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			String values = concat(o);
			err.println("\t" + values.replaceAll("\n", "\n\t"));
		}

		public void debug(String message, List<Integer[]> list) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			String values = concat(list);
			err.println("\t" + values.replaceAll("\n", "\n\t"));
		}

	}

}
