import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

public class B {

	private static CodeJamIO io = new CodeJamIO();

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		try {
			init();

			int numCases = Integer.parseInt(io.readNextLine()[0]);
			for (int i=1; i <= numCases; i++) {
				io.debug("Solving Case #" + i + "...");
				solveCase(i);
				io.debug("Case #" + i + " solved!");
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	/**
	 * Performs initial computations
	 */
	private static void init() {
		
	}

	/**
	 * Solves a Test Case
	 * 
	 * @param caseNum
	 * @throws IOException
	 */
	private static void solveCase(int caseNum) throws IOException {
		// Read input
		String[] tokens = io.readNextLine();
		int n = Integer.parseInt(tokens[0]);
		int m = Integer.parseInt(tokens[1]);
		int[][] lawn = new int[n+1][m+1];
		for (int i=0; i<n; i++) {
			tokens = io.readNextLine();
			for (int j=0; j<m; j++) {
				lawn[i][j] = Integer.parseInt(tokens[j]);
			}
			lawn[i][m] = 100;
		}
		for (int j=0; j<m+1; j++) {
			lawn[n][j] = 100;
		}
		
		// Do the work
		boolean more = true;
		boolean impossible = false;
		while (more && !impossible) {
			more = false;
			if (rowMax(lawn)) {
				more = true;
			}
			if (colMax(lawn)) {
				more = true;
			}
			OUTER: for (int i=0; i<n; i++) {
				for (int j=0; j<m; j++) {
					if (lawn[i][j] < lawn[i][m] && lawn[i][j] < lawn[n][j]) {
						impossible = true;
						break OUTER;
					}
				}
			}
		}
		
		// Print results
		io.printCase(caseNum).println(impossible ? "NO" : "YES");

	}

	private static boolean rowMax(int[][] lawn) {
		boolean more = false;
		for (int i=0; i<lawn.length-1; i++) {
			int prevRowMax = lawn[i][lawn[i].length-1];
			int rowMax = 0;
			for (int j=0; j<lawn[i].length-1; j++) {
				if (lawn[i][j] < prevRowMax && lawn[i][j] > rowMax) {
					rowMax = lawn[i][j];
				}
			}
			io.debug("RowMax for row " + i + ": " + rowMax);
			lawn[i][lawn[i].length-1] = rowMax;
			if (rowMax > 0) {
				more = true;
			}
		}
		return more;
	}

	private static boolean colMax(int[][] lawn) {
		boolean more = false;
		for (int j=0; j<lawn[0].length-1; j++) {
			int prevColMax = lawn[lawn.length-1][j];
			int colMax = 0;
			for (int i=0; i<lawn.length-1; i++) {
				if (lawn[i][j] < prevColMax && lawn[i][j] > colMax) {
					colMax = lawn[i][j];
				}
			}
			io.debug("ColMax for col " + j + ": " + colMax);
			lawn[lawn.length-1][j] = colMax;
			if (colMax > 0) {
				more = true;
			}
		}
		return more;
	}

	/**
	 * Input and Output CodeJam style
	 *
	 */
	private static class CodeJamIO {
		private static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		private static PrintWriter out = new PrintWriter(System.out, true);
		private static PrintWriter err = new PrintWriter(System.err, true);

		public String[] readNextLine() throws IOException {
			String line = in.readLine();
			String[] tokens = line.split("\\s+");
			return tokens;
		}

		public CodeJamIO printCase(int caseNum) { return print("Case #" + caseNum + ": " ); }
		
		public CodeJamIO print(Object o) { out.print(o); return this; }

		public CodeJamIO print(Object o[]) { return print(concat(o)); }

		public CodeJamIO print(Object o[][]) { return print(concat(o)); }

		public CodeJamIO println() { out.println(); return this; }

		public CodeJamIO printlnCase(int caseNum) { return printCase(caseNum).println(); }
		
		public CodeJamIO println(Object o) { return print(o).println(); }

		public CodeJamIO println(Object o[]) { return print(o).println(); }

		public CodeJamIO println(Object o[][]) { return print(concat(o)).println(); }

		public CodeJamIO println(List<Integer[]> l) { return print(concat(l)).println(); }

		
		private String concat(Object[] o) {
			StringBuffer buf = new StringBuffer(10*o.length);
			
			String delim = "";
			for (int i=0; i < o.length; i++) {
				buf.append(delim).append(o[i]);
				delim = " ";
			}
			return buf.toString();
		}
		
		private String concat(Object[][] o) {
			StringBuffer buf = new StringBuffer(100*o.length);
			for (int i=0; i < o.length; i++) {
				buf.append(concat(o[i])).append("\n");
			}
			return buf.toString();
		}

		private String concat(List<Integer[]> list) {
			StringBuffer buf = new StringBuffer();
			String delim = "";
			for (Object[] elm : list) {
				buf.append(delim).append(concat(elm)).append("\n");
			}
			return buf.toString();
		}

		public void debug(String message) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
		}

		public void debug(String message, Object[] o) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			err.println("\t" + concat(o));
		}

		public void debug(String message, Object[][] o) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			String values = concat(o);
			err.println("\t" + values.replaceAll("\n", "\n\t"));
		}

		public void debug(String message, List<Integer[]> list) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			String values = concat(list);
			err.println("\t" + values.replaceAll("\n", "\n\t"));
		}

	}

}
