import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

public class A {

	private static CodeJamIO io = new CodeJamIO();
	public static final int OFFSET = (int) 'A';

	private static class Party implements Comparable<Party> {
		private int num;
		private String name;

		public Party(int num, String name) {
			this.num = num;
			this.name = name;
		}

		public int getNum() {
			return num;
		}

		public void setNum(int num) {
			this.num = num;
		}

		public String getName() {
			return name;
		}

		public void setName(String name) {
			this.name = name;
		}


		@Override
		public int compareTo(Party o) {
			return num < o.num ? -1 : num > o.num ? 1 : 0;
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		try {
			init();

			int numCases = Integer.parseInt(io.readNextLine()[0]);
			for (int i=1; i <= numCases; i++) {
				io.debug("Solving Case #" + i + "...");
				solveCase(i);
				io.debug("Case #" + i + " solved!");
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	/**
	 * Performs initial computations
	 */
	private static void init() {
		
	}

	/**
	 * Solves a Test Case
	 * 
	 * @param caseNum
	 * @throws IOException
	 */
	private static void solveCase(int caseNum) throws IOException {
		// Read input
		io.readNextLine();
		String[] tokens = io.readNextLine();
		Party[] p = new Party[tokens.length];
		for (int i=0; i<tokens.length; i++) {
			p[i] = new Party(Integer.parseInt(tokens[i]), String.valueOf((char) (i + OFFSET)));
		}

		// Do the work
		Arrays.sort(p);
		List<String> result = solveReversed(p);
		Collections.reverse(result);

		// Print results
		io.printCase(caseNum).println(String.join(" ", result));

	}

	private static List<String> solveReversed(Party[] p) {
		List<String> ret = new ArrayList<>();
		int l=p.length-1;
		while (l >= 0 && p[l].getNum() == 0) {
			l--;
		}
		if (l < 0) {
			return ret;
		} else if (l < p.length-1) {
			return solveReversed(Arrays.copyOf(p, l+1));
		} else if (p.length == 1) {
			return solveOne(p[0]);
		}
		int j=p.length-2;
		// combine
		OUTER: while (p[p.length - 1].getNum() > 0) {
			while (p[j].getNum() == 0) {
				j--;
				if (j < 0) {
					break OUTER;
				}
			}
			ret.add(p[p.length-1].getName() + p[j].getName());
			p[j].setNum(p[j].getNum()-1);
			p[p.length-1].setNum(p[p.length-1].getNum()-1);
		}
		if (j >= 0) {
			ret.addAll(solveReversed(Arrays.copyOf(p, j + 1)));
		}
		if (p[p.length-1].getNum() > 0) {
			ret.addAll(solveOne(p[p.length-1]));
		}
		return ret;
	}

	private static List<String> solveOne(Party c) {
		List<String> ret = new ArrayList<>();
		while (c.getNum() > 1) {
			ret.add(c.getName() + c.getName());
			c.setNum(c.getNum()-2);
		}
		while (c.getNum() > 0) {
			ret.add(c.getName());
			c.setNum(c.getNum()-1);
		}
		return ret;
	}

	/**
	 * Input and Output CodeJam style
	 *
	 */
	private static class CodeJamIO {
		private static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		private static PrintWriter out = new PrintWriter(System.out, true);
		private static PrintWriter err = new PrintWriter(System.err, true);

		public String[] readNextLine() throws IOException {
			String line = in.readLine();
			String[] tokens = line.split("\\s+");
			return tokens;
		}

		public CodeJamIO printCase(int caseNum) { return print("Case #" + caseNum + ": " ); }
		
		public CodeJamIO print(Object o) { out.print(o); return this; }

		public CodeJamIO print(Object o[]) { return print(concat(o)); }

		public CodeJamIO print(Object o[][]) { return print(concat(o)); }

		public CodeJamIO println() { out.println(); return this; }

		public CodeJamIO printlnCase(int caseNum) { return printCase(caseNum).println(); }
		
		public CodeJamIO println(Object o) { return print(o).println(); }

		public CodeJamIO println(Object o[]) { return print(o).println(); }

		public CodeJamIO println(Object o[][]) { return print(concat(o)).println(); }

		public CodeJamIO println(List<Integer[]> l) { return print(concat(l)).println(); }

		
		private String concat(Object[] o) {
			StringBuffer buf = new StringBuffer(10*o.length);
			
			String delim = "";
			for (int i=0; i < o.length; i++) {
				buf.append(delim).append(o[i]);
				delim = " ";
			}
			return buf.toString();
		}
		
		private String concat(Object[][] o) {
			StringBuffer buf = new StringBuffer(100*o.length);
			for (int i=0; i < o.length; i++) {
				buf.append(concat(o[i])).append("\n");
			}
			return buf.toString();
		}

		private String concat(List<Integer[]> list) {
			StringBuffer buf = new StringBuffer();
			String delim = "";
			for (Object[] elm : list) {
				buf.append(delim).append(concat(elm)).append("\n");
			}
			return buf.toString();
		}

		public void debug(String message) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
		}

		public void debug(String message, Object[] o) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			err.println("\t" + concat(o));
		}

		public void debug(String message, Object[][] o) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			String values = concat(o);
			err.println("\t" + values.replaceAll("\n", "\n\t"));
		}

		public void debug(String message, List<Integer[]> list) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			String values = concat(list);
			err.println("\t" + values.replaceAll("\n", "\n\t"));
		}

	}

}
