import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

public class A {

	private static CodeJamIO io = new CodeJamIO();

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		try {
			init();

			int numCases = Integer.parseInt(io.readNextLine()[0]);
			for (int i=1; i <= numCases; i++) {
				io.debug("Solving Case #" + i + "...");
				solveCase(i);
				io.debug("Case #" + i + " solved!");
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	/**
	 * Performs initial computations
	 */
	private static void init() {
		
	}

	/**
	 * Solves a Test Case
	 * 
	 * @param caseNum
	 * @throws IOException
	 */
	private static void solveCase(int caseNum) throws IOException {
		// Read input
		char[][] grid = new char[4][4];
		for (int i=0; i<4; i++) {
			String[] tokens = io.readNextLine();
			for (int j=0; j<4; j++) {
				grid[i][j] = tokens[0].charAt(j);
			}
		}
		io.readNextLine();
		
		// Do the work
		boolean[] checkTotal = new boolean[]{false, false, false};
		for (int i=0; i<4; i++) {
			checkTotal = checkTotal(checkLine(grid, i, 0, 0, 1));
			if (!checkTotal[0] && !checkTotal[1]) {
				checkTotal = checkTotal(checkLine(grid, 0, i, 1, 0));
			}
			if (checkTotal[0] || checkTotal[1]) {
				break;
			}
		}
		if (!checkTotal[0] && !checkTotal[1]) {
			checkTotal = checkTotal(checkLine(grid, 0, 0, 1, 1));
		}
		if (!checkTotal[0] && !checkTotal[1]) {
			checkTotal = checkTotal(checkLine(grid, 0, 3, 1, -1));
		}
		
		// Print results
		if (checkTotal[0]) {
			io.printCase(caseNum).println("O won");
		} else if (checkTotal[1]) {
			io.printCase(caseNum).println("X won");
		} else if (checkTotal[2]) {
			io.printCase(caseNum).println("Game has not completed");
		} else {
			io.printCase(caseNum).println("Draw");
		}
	}
	
	private static boolean[] checkTotal(boolean[] checkLine) {
		boolean[] checkTotal = new boolean[3];
		if (checkLine[2]) {
			checkTotal[2] = true;
		} else if (!checkLine[1]) {
			checkTotal[0] = true;
		} else if (!checkLine[0]) {
			checkTotal[1] = true;
		}
		return checkTotal;
	}

	private static boolean[] checkLine(char[][] grid, int startx, int starty, int stepx, int stepy) {
		boolean[] checkLine = new boolean[]{false, false, false};
		int x = startx;
		int y = starty;
		for (int i=0; i<grid.length; i++) {
			if (grid[x][y] == 'O') {
				checkLine[0] = true;
			} else if (grid[x][y] == 'X') {
				checkLine[1] = true;
			} else if (grid[x][y] == '.') {
				checkLine[2] = true;
			}
			x += stepx;
			y += stepy;
		}
		return checkLine;
	}

	/**
	 * Input and Output CodeJam style
	 *
	 */
	private static class CodeJamIO {
		private static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		private static PrintWriter out = new PrintWriter(System.out, true);
		private static PrintWriter err = new PrintWriter(System.err, true);

		public String[] readNextLine() throws IOException {
			String line = in.readLine();
			String[] tokens = line.split("\\s+");
			return tokens;
		}

		public CodeJamIO printCase(int caseNum) { return print("Case #" + caseNum + ": " ); }
		
		public CodeJamIO print(Object o) { out.print(o); return this; }

		public CodeJamIO print(Object o[]) { return print(concat(o)); }

		public CodeJamIO print(Object o[][]) { return print(concat(o)); }

		public CodeJamIO println() { out.println(); return this; }

		public CodeJamIO printlnCase(int caseNum) { return printCase(caseNum).println(); }
		
		public CodeJamIO println(Object o) { return print(o).println(); }

		public CodeJamIO println(Object o[]) { return print(o).println(); }

		public CodeJamIO println(Object o[][]) { return print(concat(o)).println(); }

		public CodeJamIO println(List<Integer[]> l) { return print(concat(l)).println(); }

		
		private String concat(Object[] o) {
			StringBuffer buf = new StringBuffer(10*o.length);
			
			String delim = "";
			for (int i=0; i < o.length; i++) {
				buf.append(delim).append(o[i]);
				delim = " ";
			}
			return buf.toString();
		}
		
		private String concat(Object[][] o) {
			StringBuffer buf = new StringBuffer(100*o.length);
			for (int i=0; i < o.length; i++) {
				buf.append(concat(o[i])).append("\n");
			}
			return buf.toString();
		}

		private String concat(List<Integer[]> list) {
			StringBuffer buf = new StringBuffer();
			String delim = "";
			for (Object[] elm : list) {
				buf.append(delim).append(concat(elm)).append("\n");
			}
			return buf.toString();
		}

		public void debug(String message) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
		}

		public void debug(String message, Object[] o) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			err.println("\t" + concat(o));
		}

		public void debug(String message, Object[][] o) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			String values = concat(o);
			err.println("\t" + values.replaceAll("\n", "\n\t"));
		}

		public void debug(String message, List<Integer[]> list) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			String values = concat(list);
			err.println("\t" + values.replaceAll("\n", "\n\t"));
		}

	}

}
