import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.TreeMap;
import java.util.Arrays;

public class B {

	private static CodeJamIO io = new CodeJamIO();

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		try {
			init();

			int numCases = Integer.parseInt(io.readNextLine()[0]);
			for (int i=1; i <= numCases; i++) {
				io.debug("Solving Case #" + i + "...");
				solveCase(i);
				io.debug("Case #" + i + " solved!");
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	/**
	 * Performs initial computations
	 */
	private static void init() {
		
	}

	/**
	 * Solves a Test Case
	 * 
	 * @param caseNum
	 * @throws IOException
	 */
	private static void solveCase(int caseNum) throws IOException {
		// Read input
		String[] tokens = io.readNextLine();
		int d = Integer.parseInt(tokens[0]);
		String[] pstr = io.readNextLine();
		int[] p = new int[pstr.length];
		for (int i=0; i<p.length; i++) {
			p[i] = Integer.parseInt(pstr[i]);
		}
		
		// Do the work
		Arrays.sort(p);
		int initialmax = p[p.length-1];
		int finalmax = 0;
		for (int special=countSpecial(p); special > 0; special=countSpecial(p)) {
			//io.debug("Found " + special + " special in the array", io.boxInt(p));
			p = doSpecial(p, special);
			finalmax += special;
		}
		//io.debug("Found 0 special in the array", io.boxInt(p));
		finalmax += p[p.length-1];
		if (finalmax > initialmax) {
			io.debug("ERROR! initialmax="+initialmax+", finalmax="+finalmax);
		}
		
		// Print results
		io.printCase(caseNum).println(finalmax);
	}

  private static int countSpecial(int[] p) {
  	int max = p[p.length-1];
  	int maxhalf = max - max/2;
  	for (int i=p.length-1; i>=0; i--) {
  		int previous = i>0 ? p[i-1] : 0;
  		if ((previous>maxhalf ? previous : maxhalf) + p.length - i < max) {
  		  return p.length-i;
  		}
  	}
  	
  	return 0;
  }
  
  private static int[] doSpecial(int[] p, int special) {
  	TreeMap<Integer, Integer> ptree = new TreeMap<Integer, Integer>();
  	for (int i=0; i<p.length-special; i++) {
  		addToTree(ptree, p[i]);
  	}
 		int numAdded = special;
  	for (int i=p.length-special; i<p.length; i++) {
  		int half = p[i]/2;
  		int otherhalf = p[i] - half;
  		if (!ptree.isEmpty() && ptree.firstKey()+half <= otherhalf) {
	 			int min = ptree.firstKey();
  			removeFromTree(ptree, min);
  			addToTree(ptree, min+half);
 				numAdded--;
  		} else {
  			addToTree(ptree, half);
  		}
 			addToTree(ptree, otherhalf);
  	}
  	p = new int[p.length + numAdded];
  	int i=0;
  	for (Integer key : ptree.keySet()) {
  		for (int n=0; n<ptree.get(key); n++) {
  			p[i++] = key;
  		}
  	}
  	return p;
  }
  
  private static void addToTree(TreeMap<Integer, Integer> tree, Integer key) {
  	if (tree.containsKey(key)) {
  		tree.put(key, tree.get(key)+1);
  	} else {
  		tree.put(key, 1);
  	}
  }
  
  private static void removeFromTree(TreeMap<Integer, Integer> tree, Integer key) {
  	if (tree.get(key) > 1) {
  		tree.put(key, tree.get(key)-1);
  	} else {
  		tree.remove(key);
  	}
  }
  
	/**
	 * Input and Output CodeJam style
	 *
	 */
	private static class CodeJamIO {
		private static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		private static PrintWriter out = new PrintWriter(System.out, true);
		private static PrintWriter err = new PrintWriter(System.err, true);

		public String[] readNextLine() throws IOException {
			String line = in.readLine();
			String[] tokens = line.split("\\s+");
			return tokens;
		}

		public CodeJamIO printCase(int caseNum) { return print("Case #" + caseNum + ": " ); }
		
		public CodeJamIO print(Object o) { out.print(o); return this; }

		public CodeJamIO print(Object o[]) { return print(concat(o)); }

		public CodeJamIO print(Object o[][]) { return print(concat(o)); }

		public CodeJamIO println() { out.println(); return this; }

		public CodeJamIO printlnCase(int caseNum) { return printCase(caseNum).println(); }
		
		public CodeJamIO println(Object o) { return print(o).println(); }

		public CodeJamIO println(Object o[]) { return print(o).println(); }

		public CodeJamIO println(Object o[][]) { return print(concat(o)).println(); }

		public CodeJamIO println(List<Integer[]> l) { return print(concat(l)).println(); }

		public Integer[] boxInt(int[] arr) {
			Integer[] ret = new Integer[arr.length];
			for (int i=0; i<arr.length; i++) {
				ret[i] = arr[i];
			}
			return ret;
		}		
		
		private String concat(Object[] o) {
			StringBuffer buf = new StringBuffer(10*o.length);
			
			String delim = "";
			for (int i=0; i < o.length; i++) {
				buf.append(delim).append(o[i]);
				delim = " ";
			}
			return buf.toString();
		}
		
		private String concat(Object[][] o) {
			StringBuffer buf = new StringBuffer(100*o.length);
			for (int i=0; i < o.length; i++) {
				buf.append(concat(o[i])).append("\n");
			}
			return buf.toString();
		}

		private String concat(List<Integer[]> list) {
			StringBuffer buf = new StringBuffer();
			String delim = "";
			for (Object[] elm : list) {
				buf.append(delim).append(concat(elm)).append("\n");
			}
			return buf.toString();
		}

		public void debug(String message) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
		}

		public void debug(String message, Object[] o) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			err.println("\t" + concat(o));
		}

		public void debug(String message, Object[][] o) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			String values = concat(o);
			err.println("\t" + values.replaceAll("\n", "\n\t"));
		}

		public void debug(String message, List<Integer[]> list) {
			err.println(Calendar.getInstance().getTime() + ": " + message);
			String values = concat(list);
			err.println("\t" + values.replaceAll("\n", "\n\t"));
		}

	}

}
