import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.regex.Pattern;

/**
 * Code Jam Qualification Round 2009
 * A. Alien Language
 */
public class AlienLanguage {

	String[] words;

	public AlienLanguage(String[] words) {
		this.words = words;
	}

	public int countMatches(String pattern) {
		String regexPattern = pattern.replace('(', '[').replace(')', ']');
		Pattern p = Pattern.compile(regexPattern);
		int count = 0;
		for (String word : words) {
			if (p.matcher(word).matches()) {
				count++;
			}
		}
		return count;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

		try {
			// Read L, D, N
			String firstLine = in.readLine();
			String[] tokens = firstLine.split("\\s+");
			int l = Integer.parseInt(tokens[0]);
			int d = Integer.parseInt(tokens[1]);
			int n = Integer.parseInt(tokens[2]);
			
			// Read words
			String[] w = new String[d];
			for (int i=0; i < d; i++) {
				w[i] = in.readLine();
			}
			
			AlienLanguage alienLanguage = new AlienLanguage(w);
			
			for (long i=1; i <= n; i++) {
				String pattern = in.readLine();
				System.out.println("Case #" + i + ": " + alienLanguage.countMatches(pattern));
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

}
