import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;

/**
 * Google Code Jam - 2009/1C/A
 */
public class AllYourBase {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

		try {
			int numCases = Integer.parseInt(in.readLine());
			for (int i=1; i <= numCases; i++) {
				String message = in.readLine();
				System.out.println("Case #" + i + ": " + minSeconds(message));
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	private static long minSeconds(String message) {
		ArrayList<Character> symbols = findSymbols(message);
		HashMap<Character, Character> translation = findTranslation(symbols);
		String newMessage = replaceSymbols(message, translation);
		return Long.parseLong(newMessage, symbols.size() > 1 ? symbols.size() : 2);
	}

	private static ArrayList<Character> findSymbols(String message) {
		ArrayList<Character> list = new ArrayList<Character>();
		for (int i=0; i < message.length(); i++) {
			Character c = message.charAt(i); 
			if (!list.contains(c)) {
				list.add(c);
			}
		}
		return list;
	}

	private static HashMap<Character, Character> findTranslation(
			ArrayList<Character> symbols) {
		HashMap<Character, Character> translation = new HashMap<Character, Character>();
		translation.put(symbols.get(0), '1');
		if (symbols.size() > 1) {
			translation.put(symbols.get(1), '0');
			char current = '2';
			for (int i=2; i < symbols.size(); i++) {
				translation.put(symbols.get(i), current++);
			}
		}
		return translation;
	}

	private static String replaceSymbols(String message,
			HashMap<Character, Character> translation) {
		StringBuffer newMessage = new StringBuffer();
		for (int i=0; i < message.length(); i++) {
			newMessage.append(translation.get(message.charAt(i)));
		}
		return newMessage.toString();
	}

}
