package tictactoetomek;

public class TicTacToeStatus {

	private char[][] board;

	public TicTacToeStatus(char[][] board) {
		super();
		this.board = board;
	}
	
	public String getStatus() {
		boolean hasEmpty = false;
		
		for(int i=0; i<4;i++) {
			for(int j=0; j<i+1;j++) {
				char current = board[i][j];
				if(current == '.'){
					hasEmpty = true;
				}
				if(current == 'X' ||  current == 'O' || current == 'T') {
					String checkWin = checkWin(i,j, current);
					if(checkWin != null) {
						return checkWin + " won";
					}
				}
			}
		}
		return hasEmpty ? "Game has not completed" : "Draw";
	}



	private String checkWin(int i, int j, char current) {
		if((i ==0 && j == 0) || (i==3 && j==0)) {
			char checkRow = checkRow(i,j,current);
			char checkColumn = checkColumn(i,j,current);
			char checkDiagonal = checkDiagonal(i,j,current);
			if(checkRow != '/') return checkRow+"";
			if(checkColumn!= '/') return checkColumn+"";
			if(checkDiagonal!= '/') return checkDiagonal+"";
		} else {
			char checkRow = checkRow(i,j,current);
			char checkColumn = checkColumn(i,j,current);
			if(checkRow != '/') return checkRow+"";
			if(checkColumn!= '/') return checkColumn+"";
		}
		return null;
	}

	private char checkRow(int i,int j, char current) {
		if(current == 'T') {
			if(j == 0) {
				current = board[i][1];
			} else {
				current = board[i][0];
			}
		}
		if(current == '.')
			return '/';
		boolean isWin = (board[i][0] == current || board[i][0] == 'T') &&
				(board[i][1] == current || board[i][1] == 'T') &&
				(board[i][2] == current || board[i][2] == 'T') &&
				(board[i][3] == current || board[i][3] == 'T');
		return isWin ? current : '/';
	}

	private char checkColumn(int i, int j, char current) {
		if(current == 'T') {
			if(i == 0) {
				current = board[1][j];
			} else {
				current = board[0][j];
			}
		}
		if(current == '.')
			return '/';
		
		boolean isWin =(board[0][j] == current  || board[0][j] == 'T') &&
				(board[1][j] == current || board[1][j] == 'T') &&
				(board[2][j] == current || board[2][j] == 'T') &&
				(board[3][j] == current || board[3][j] == 'T') ;
		return isWin ? current : '/';
	}

	private char checkDiagonal(int i, int j, char current) {
		if(current == 'T') {
			if(i == 0) {
				current = board[1][1];
			} else {
				current = board[2][1];
			}
		}
		if(current == '.')
			return '/';
		boolean isWin;
		try {
			isWin = (board[i][j] == current || board[i][j] == 'T') &&
					(board[i+1][j+1] == current || board[i+1][j+1] == 'T') &&
					(board[i+2][j+2] == current || board[i+2][j+2] == 'T') &&
					(board[i+3][j+3] == current || board[i+3][j+3] == 'T');
		} catch(ArrayIndexOutOfBoundsException e) {
			isWin =(board[i][j] == current || board[i][j] == 'T') &&
					(board[i-1][j+1] == current || board[i-1][j+1] == 'T') &&
					(board[i-2][j+2] == current || board[i-2][j+2] == 'T') &&
					(board[i-3][j+3] == current || board[i-3][j+3] == 'T');
		}
		return isWin ? current : '/';
	}
}
