package io;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

public abstract class TestCase {

	private String fileName;
	protected int numTestCases;
	protected BufferedReader r;
	
	public String getFileName() {
		return fileName;
	}

	public void setFileName(String fileName) {
		this.fileName = fileName;
	}

	public TestCase(String fileName) {
		super();
		this.fileName = fileName;
	}
	
	
	public void initialize() throws IOException {
		FileReader reader = new FileReader(new File(fileName));
		r = new BufferedReader(reader);
		numTestCases = Integer.valueOf(r.readLine());
	}
	
	public abstract Object readNextTestCase();
	
}
