package minesweeper;

public class MineSweeper {

	private static final String IMPOSSIBLE = "Impossible";
	
	private int row;
	private int column;
	private int mine;
	
	public MineSweeper(String r, String c, String m) {
		this.row = Integer.parseInt(r);
		this.column = Integer.parseInt(c);
		this.mine = Integer.parseInt(m);
	}

	public String solve() {
		int cells = row  * column;
		if(row ==1 || column == 1) {
			if(mine <= cells - 2) {
				//possible
				return getGrid(row, column, mine);
			}
		} else if(mine <= cells -4){
			//possible
			return getGrid(row, column, mine);
		}
		return IMPOSSIBLE;
	}

	private String getGrid(int r, int c, int m) {
		String[][] grid = new String[r][c];
		
		int emptyCells = r * c - m;
		grid[0][0] = "c";
		emptyCells--;
		
		if(r == 1 ) {
			for(int i =1;i<c;i++) {
				if(emptyCells > 0){
					emptyCells--;
					grid[0][i] = ".";
				} else {
					grid[0][i] = "*";
				}
			}
		} else if( c == 1) {
			for(int i =1;i<r;i++) {
				if(emptyCells > 0){
					emptyCells--;
					grid[i][0] = ".";
				} else {
					grid[i][0] = "*";
				}
			}
		} else {
			grid[0][1] = ".";
			grid[1][0] = ".";
			grid[1][1] = ".";
			emptyCells -= 3;
			
			for(int i=0;i<r;i++) {
				for(int j=0;j<c;j++) {
					if(grid[i][j] == null){
						if(emptyCells > 0) {
							emptyCells--;
							grid[i][j] = ".";
						} else {
							grid[i][j] = "*";
						}
					}
				}
			}
		}
		StringBuilder sb = new StringBuilder();
		for (String[] strings : grid) {
			for (String string : strings) {
				sb.append(string);
			}
			sb.append("\n");
		}
		return sb.deleteCharAt(sb.length()-1).toString();
	}

}
