package fairandsquare;

import java.math.BigInteger;
import java.util.Stack;

public class FairAndSquareNumbers {
	private static final BigInteger TWO = BigInteger.valueOf(2);
	
	private BigInteger lowerEnd;
	private BigInteger upperEnd;
	public FairAndSquareNumbers(BigInteger lowerEnd, BigInteger upperEnd) {
		super();
		this.lowerEnd = lowerEnd;
		this.upperEnd = upperEnd;
	}
	
	public int numberOfFairAndSquareNumbers() {
		int counter = 0;
		for(BigInteger var = new BigInteger(lowerEnd.toString());var.compareTo(upperEnd) <= 0 ; var = var.add(BigInteger.ONE)) {
			BigInteger root = sqrt(var);
			if(root.multiply(root).compareTo(var) ==0 ){
				if(isPalindrome(root) && isPalindrome(var)) {
					counter++;
				}
			}
		}
		return counter;
	}

	public boolean isPalindrome(BigInteger root) {
		char[] val = root.toString().toCharArray();
		Stack<Character> st = new Stack<Character>();
		boolean result = true;
		boolean isEven = (val.length %2) == 0;
		int middle = (int) Math.round(val.length / 2.0);
		for(int i =0; i<val.length; i++) {
			if(i<middle-1) {
				st.push(val[i]);
			} else {
				if(i == middle-1) {
					if(isEven) {
						st.push(val[i]);
					}//skip if odd
				} else {
					result = result && (st.pop() == val[i]);
				}
			}
		}
		return result;
	}
	
	public static void main(String[] args) {
		System.out.println(sqrt(new BigInteger("15")));
	}
	
	public static BigInteger sqrt(BigInteger n)
	{
	    if (n.signum() >= 0)
	    {
	        final int bitLength = n.bitLength();
	        BigInteger root = BigInteger.ONE.shiftLeft(bitLength / 2);

	        while (!isSqrt(n, root))
	        {
	            root = root.add(n.divide(root)).divide(TWO);
	        }
	        return root;
	    }
	    else
	    {
	        throw new ArithmeticException("square root of negative number");
	    }
	}


	private static boolean isSqrt(BigInteger n, BigInteger root)
	{
	    final BigInteger lowerBound = root.pow(2);
	    final BigInteger upperBound = root.add(BigInteger.ONE).pow(2);
	    return lowerBound.compareTo(n) <= 0
	        && n.compareTo(upperBound) < 0;
	}
}
