import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;

public class Solver {
	char X = 'X';
	char O = 'O';
	char T = 'T';
	char DOT = '.';

	public enum State {
		X_WON("X won"),
		O_WON("O won"),
		INCOMPLETE("Game has not completed"),
		DRAW("Draw");

		private String string;

		State(String string) {
			this.string=string;
		}

		@Override
		public String toString() {
			return this.string;
		}
	}

	private int xs;
	private int os;
	private char[][] rows;
	private boolean hasT;
	private int empties;
	private State state;

	public Solver(char[][] rows) {
		this.rows=rows;
		countTics(rows);

		this.state = calcState();
	}
	
	public State calcState() {
		if (xs == os) {
//			check if os won
			//rows
			rows:
			for (int i = 0; i<4; i++) {
				for (int j = 0; j<4; j++) {
					if (!(this.rows[i][j] == O || this.rows[i][j] == T)) {
						continue rows;
					}
				}
				return State.O_WON;
			}
			//columns
			columns:
			for (int i = 0; i<4; i++) {
				for (int j = 0; j<4; j++) {
					if (!(this.rows[j][i] == O || this.rows[j][i] == T)) {
						continue columns;
					}
				}
				return State.O_WON;
			}
			//diagonals
			boolean diagonals1 = true; 
			for (int i = 0; i<4; i++) {
				if (!(this.rows[i][i] == O || this.rows[i][i] == T)) {
					diagonals1 = false;
					break;
				}
			}
			if (diagonals1) return State.O_WON;			
			boolean diagonals2 = true; 
			for (int i = 0; i<4; i++) {
				if (!(this.rows[i][3-i] == O || this.rows[i][3-i] == T)) {
					diagonals2 = false;
					break;
				}
			}
			if (diagonals2) return State.O_WON;
		} else {
			assert xs == os +1;
//			check if xs won
			//rows
			rows:
			for (int i = 0; i<4; i++) {
				for (int j = 0; j<4; j++) {
					if (!(this.rows[i][j] == X || this.rows[i][j] == T)) {
						continue rows;
					}
				}
				return State.X_WON;
			}
			//columns
			columns:
			for (int i = 0; i<4; i++) {
				for (int j = 0; j<4; j++) {
					if (!(this.rows[j][i] == X || this.rows[j][i] == T)) {
						continue columns;
					}
				}
				return State.X_WON;
			}
			//diagonals
			boolean diagonals1 = true; 
			for (int i = 0; i<4; i++) {
				if (!(this.rows[i][i] == X || this.rows[i][i] == T)) {
					diagonals1 = false;
					break;
				}
			}
			if (diagonals1) return State.X_WON;			
			boolean diagonals2 = true; 
			for (int i = 0; i<4; i++) {
				if (!(this.rows[i][3-i] == X || this.rows[i][3-i] == T)) {
					diagonals2 = false;
					break;
				}
			}
			if (diagonals2) return State.X_WON;
		}

		if (empties==0) {
			return State.DRAW;
		}
		return State.INCOMPLETE;
	}

	private void countTics(char[][] row12) {
		for (char[] tics : row12) {
			for (char tic : tics) {
				if (tic==X) {
					xs++;
				} else if (tic==O) {
					os++;
				}
				else if (tic==T) {
					hasT=true;
				} else {
					empties++;
				}
			}
		}
	}

	State getState() {
		return state;
	}

	public static void main(String args[]) throws IOException {
		//read T (number of lines)
		final InputStreamReader isr = new FileReader(new File("C:\\Users\\Nick\\Downloads\\" + "A-large.in"));
		final PrintStream bw = new PrintStream(new File("C:\\Users\\Nick\\Downloads\\" + "A-large.out"));
//		final InputStreamReader isr = new InputStreamReader(System.in);
		final BufferedReader reader = new BufferedReader(isr);
		final int t = Integer.parseInt(reader.readLine());
		//for each line, read N (snappers), K (snaps), output state
		for (int i = 0; i < t; i++) {
			String line = reader.readLine();
			char[] row1 = {line.charAt(0), line.charAt(1), line.charAt(2), line.charAt(3)};
			line = reader.readLine();
			char[] row2 = {line.charAt(0), line.charAt(1), line.charAt(2), line.charAt(3)};
			line = reader.readLine();
			char[] row3 = {line.charAt(0), line.charAt(1), line.charAt(2), line.charAt(3)};
			line = reader.readLine();
			char[] row4 = {line.charAt(0), line.charAt(1), line.charAt(2), line.charAt(3)};
			final Solver solver = new Solver(new char[][]{row1, row2, row3, row4});
			bw.printf("Case #%d: %s\n", i+1, solver.getState().toString());

			reader.readLine();
		}
	}
}
