import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.math.BigInteger;

public class PalindromeSolver {

	private static final String ZEROS = "00";
	private static final String ONE = "1";
	private static final String ZERO = "0";
	private BigInteger lower;
	private BigInteger upper;
	private long found;
	private boolean overlap;

	public PalindromeSolver(String lower, String upper) {
		this.lower = new BigInteger(lower);
		this.upper = new BigInteger(upper);
		int sqrtZeros = (lower.length()-1)/2;
		overlap = sqrtZeros%2 == 0;
		int halfDigits = (sqrtZeros+2)/2;
		StringBuilder b = new StringBuilder(ONE);
		for (int i = 0; i < halfDigits-1; i++) {
			b.append(ZERO);
		}
//		b.append(ONE);
//		int minLength = sqrtZeros.

		BigInteger square;
		BigInteger curr;

		curr = palindromed(b);

		square=curr.multiply(curr);

		// TODO increase curr to skip the less than min ones
		while(square.compareTo(this.lower)<0) {
			char lastChar = b.charAt(b.length()-1);
			if (lastChar != '9') {
				b.deleteCharAt(b.length()-1).append((char)(((int)lastChar)+1));
			} else if (overlap) {
				overlap = false;
				if (b.length()==1) {
					b.deleteCharAt(b.length()-1).append(ONE);
				} else {
					b.deleteCharAt(b.length()-1).append(ZERO);
				}
			} else {
				overlap = true;
				b = b.deleteCharAt(b.length()-1).append(ZEROS);
			}
			
			if (overlap) {
				curr = new BigInteger(b.toString() + b.reverse().substring(1));
			}
			else {
				curr = new BigInteger(b.toString() + b.reverse());
			}

			square=curr.multiply(curr);
		}
		
		while(square.compareTo(this.upper)<=0) {
			if (isPalindrome(square)) {
				found++;
			}
		
			char lastChar = b.charAt(b.length()-1);
			if (lastChar != '9') {
				b.deleteCharAt(b.length()-1).append((char)(((int)lastChar)+1));
			} else if (overlap) {
				overlap = false;
				if (b.length()==1) {
					b.deleteCharAt(b.length()-1).append(ONE);
				} else {
					b.deleteCharAt(b.length()-1).append(ZERO);
				}
			} else {
				overlap = true;
				b.deleteCharAt(b.length()-1).append(ZEROS);
			}

			curr = palindromed(b);

			square=curr.multiply(curr);
		}
	}	

	private BigInteger palindromed(StringBuilder b) {
		StringBuilder backwards = new StringBuilder(b).reverse();
		if (overlap) {
			return new BigInteger(b.toString() + backwards.substring(1));
		}
		else {
			return new BigInteger(b.toString() + backwards.toString());
		}
	}

	private boolean isPalindrome(BigInteger curr) {
		char[] longString= curr.toString().toCharArray();
		for (int i = longString.length/2-1; i >= 0; i--) {
			if (longString[i] != longString[longString.length-1-i]) {
				return false;
			}
		}
		return true;
	}

	public static void main(String args[]) throws IOException {
		//read T (number of lines)
		final InputStreamReader isr = new FileReader(new File("C:\\Users\\Nick\\Downloads\\" + "C-large-2.in"));
		final PrintStream bw = new PrintStream(new File("C:\\Users\\Nick\\Downloads\\" + "C-large-2.out"));
//		final InputStreamReader isr = new InputStreamReader(System.in);
		final BufferedReader reader = new BufferedReader(isr);
		final int t = Integer.parseInt(reader.readLine());
		//for each line, read N (snappers), K (snaps), output state
		for (int i = 0; i < t; i++) {
			String line = reader.readLine();
			String[] split = line.split(" ");
			final PalindromeSolver solver = new PalindromeSolver(split[0], split[1]);
			bw.printf("Case #%d: %s\n", i+1, solver.getNumber());
		}
	}

	private long getNumber() {
		return this.found;
	}
}
