package codejam.savingtheuniverse;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

public class Pool {

	private final Set<String> searchEngines;

	public Pool(Set<String> searchEngines) {
		this.searchEngines = searchEngines;
	}

	public int getSwitches(int lineLength, BufferedReader fileReader) throws IOException {
		int numSwitches = 0;
		Set<String> possibles = new HashSet<String>(searchEngines);
		for (int i = 0; i < lineLength; i++) {
			String searchEngine = fileReader.readLine();
			if (possibles.remove(searchEngine)) {
				if (possibles.size() == 0) {
					numSwitches++;
					possibles = new HashSet<String>(searchEngines);
					possibles.remove(searchEngine);
				}
			}
		}
		return numSwitches;
	}

}
