package codejam.triangletrilemma;

import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;



public class Problem {

	boolean solved;
	private long minKeyPresses;

	public Problem(int p, int k, List<Integer> frequencies) {
		Collections.sort(frequencies, new Comparator<Integer>() {
			public int compare(Integer o1, Integer o2) {
				return o2 - o1;
			}
		});

		long total = 0;
		Iterator<Integer> iterator = frequencies.iterator();
		outer:
		for (int currKeyIndex = 1; currKeyIndex <= p; currKeyIndex++) {
			for (int i = 0; i < k; i++) {
				if (iterator.hasNext()) {
					total += iterator.next() * currKeyIndex;
				}
				else break outer;
			}
		}

		solved = !iterator.hasNext();
		minKeyPresses = total;
	}

	public String getMinKeyPresses() {
		if (!solved) {
			return "Impossible";
		}

		assert this.minKeyPresses > 0;
		return Long.toString(minKeyPresses);
	}
}

