import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;

public class PalindromeSolver {

	private long lower;
	private long upper;
	private long found;

	public PalindromeSolver(long lower, long upper) {
		this.lower = lower;
		this.upper = upper;
		long min = (long)Math.ceil(Math.sqrt(lower));
		long square;
		for (long curr = min; (square=curr*curr)<= upper; curr++) {
			if (isPalindrome(curr) && isPalindrome(square)) {
				found++;
			}
		}
	}	

	private boolean isPalindrome(long curr) {
		char[] longString= Long.toString(curr).toCharArray();
		for (int i = longString.length/2-1; i >= 0; i--) {
			if (longString[i] != longString[longString.length-1-i]) {
				return false;
			}
		}
		return true;
	}

	public static void main(String args[]) throws IOException {
		//read T (number of lines)
		final InputStreamReader isr = new FileReader(new File("C:\\Users\\Nick\\Downloads\\" + "C-small-attempt0.in"));
		final PrintStream bw = new PrintStream(new File("C:\\Users\\Nick\\Downloads\\" + "C-small.out"));
//		final InputStreamReader isr = new InputStreamReader(System.in);
		final BufferedReader reader = new BufferedReader(isr);
		final int t = Integer.parseInt(reader.readLine());
		//for each line, read N (snappers), K (snaps), output state
		for (int i = 0; i < t; i++) {
			String line = reader.readLine();
			String[] split = line.split(" ");
			final PalindromeSolver solver = new PalindromeSolver(Long.parseLong(split[0]), Long.parseLong(split[1]));
			bw.printf("Case #%d: %s\n", i+1, solver.getNumber());
		}
	}

	private long getNumber() {
		return this.found;
	}
}
