package codejam.round2;

import java.util.Arrays;


public class Problem {

	private final char[][] matrix;
	private int swaps;

	public Problem(char[][] is) {
		this.matrix = is;
		int size = is[0].length;

		for (int i = 0; i < size; i++) {
			if (!isValid(i, is[i])) {
				int j;
				for (j = i+1; j < size; j++) {
					if (isValid(i, is[j])) {
						for (int x = j; x-1 >= i; x--) {
							swap(x-1, x);
						}
						break;
					}
				}
			}
		}
	}

	private void swap(int i, int j) {
//		System.out.println("swapping " + i + " " + j);
		char[] swapRow = this.matrix[i];
		this.matrix[i] = this.matrix[j];
		this.matrix[j] = swapRow;
		this.swaps++;
	}

	boolean isValid(int row, char[] data) {
//		System.out.println("is " + Arrays.toString(data) + " valid for " + row);
		for (int x = row+1; x < data.length; x++) {
			if (data[x] == '1') {
				return false;
			}
		}
		return true;
	}
	public long getResult() {
		return this.swaps;
	}
}

