package ddmmyyyy;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.Arrays;

public class Solver1 {

	private int operations;
	public Solver1(int currSize, int[] sizes) {
		int operations = 0;
		int deletes = 1;
		Arrays.sort(sizes);
		for (int i = 0; i < sizes.length; i++) {
			if (currSize > sizes[i]) {
				currSize += sizes[i];
				deletes = 1;
			} else {
				operations++;
				int possSize = calcPossSize(currSize, deletes, i, sizes);
				if (sizes[i] < possSize) {
					currSize = possSize;
					currSize += sizes[i];
					deletes=1;
				} else {
					deletes++;
				}
			}
		}
		this.operations = operations;
	}

	private int calcPossSize(int currSize, int deletes, int pos, int[] sizes) {
		int possSize = currSize + (currSize - 1);
		for (int i = 1, j=1; i < deletes; i++) {
			possSize += possSize - 1;
			while (possSize > sizes[pos-deletes+j] && j < deletes) {
				possSize += sizes[pos-deletes+j];
				j++;
			}
		}
		return possSize;
	}

	private int getResult() {
		return this.operations;
	}

	public static final String DIR = "C:\\Users\\Nick\\development\\codejam\\2013\\round1b\\files\\";
	public static final String FILE = "A-small-attempt5";
	public static void main(String args[]) throws IOException {
		//read T (number of lines)
		final InputStreamReader isr = new FileReader(new File(DIR + FILE + ".in"));
//		final InputStreamReader isr = new InputStreamReader(System.in);
		final PrintStream bw = new PrintStream(new File(DIR + FILE + ".out"));
//		final PrintStream bw = new PrintStream(System.out);
		final BufferedReader reader = new BufferedReader(isr);
		final int t = Integer.parseInt(reader.readLine());
		for (int i = 0; i < t; i++) {
			String line = reader.readLine();
			String[] split = line.split(" ");
			int a = Integer.parseInt(split[0]);
			int l = Integer.parseInt(split[1]);
			int[] sizes = new int[l];
			line = reader.readLine();
			split = line.split(" ");
			for (int j = 0; j < l; j++) {
				sizes[j] = Integer.parseInt(split[j]);
			}
			final Solver1 solver = new Solver1(a, sizes);
			bw.printf("Case #%d: %s\n", i+1, solver.getResult());
//			if (i%10==0) System.out.printf("Done #%d, ", i+1);
		}
		reader.close();
	}
}
