/**
 * Author : pankaj
 * Time   : 13-Apr-2013 - 4:40:35 AM
 */
package ttt.a;

import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.Scanner;

public class TicTacToeTomek {
	private long testCasesCount;
	private Scanner scanner;
	BufferedWriter writer;

	private static String X_WON = "X won";
	private static String O_WON = "O won";
	private static String DRAW = "Draw";
	private static String NOT_COMPLETE = "Game has not completed";

	private char[][] boardState = new char[4][4];

	public TicTacToeTomek(FileOutputStream fos, FileInputStream fis) {
		super();
		this.scanner = new Scanner(fis);
		this.writer = new BufferedWriter(new OutputStreamWriter(fos));
	}

	private void forEachTestCase(long testCaseNum) throws IOException {
		// reading corresponding to each test case
		boolean boardCompletelyFilled = true;
		for (int i = 0; i < 4; i++) {
			String nextLine = scanner.nextLine();
			char[] charArray = nextLine.toCharArray();
			for (int k = 0; k < 4; k++) {
				boardState[i][k] = charArray[k];
				if (charArray[k] == '.') {
					boardCompletelyFilled = false;
				}
			}
		}

		// ld & rd
		int ld = 0;
		int rd = 0;
		for (int i = 0; i < 4; i++) {
			ld += boardState[i][i];
			rd += boardState[i][3 - i];
		}
		char c = checkDivsibility(ld);
		if (c != 0) {
			printOutput(testCaseNum, c);
			return;
		}
		c = checkDivsibility(rd);
		if (c != 0) {
			printOutput(testCaseNum, c);
			return;
		}
		// horizontal
		for (int i = 0; i < 4; i++) {
			char character = horizontalRow(i);
			if (character != 0) {
				printOutput(testCaseNum, character);
				return;
			}
		}
		// vertiacal
		for (int i = 0; i < 4; i++) {
			char character = verticalRow(i);
			if (character != 0) {
				printOutput(testCaseNum, character);
				return;
			}
		}

		if(boardCompletelyFilled==true){
			writer.write("Case #" + (testCaseNum + 1) + ": " + DRAW + "\n");
			writer.flush();
			return;
		}
		writer.write("Case #" + (testCaseNum + 1) + ": " + NOT_COMPLETE + "\n");
		writer.flush();
	}

	/**
	 * @param testCaseNum
	 * @throws IOException
	 */
	private void printOutput(long testCaseNum, char c) throws IOException {
		if (c == 'X') {
			writer.write("Case #" + (testCaseNum + 1) + ": " + X_WON + "\n");
		} else {
			writer.write("Case #" + (testCaseNum + 1) + ": " + O_WON + "\n");
		}
		writer.flush();
	}

	/**
	 * @param ld
	 * @return
	 */
	private char checkDivsibility(int s) {
		if (s / 4 == 'X' && s % 4 == 0) {
			return 'X';
		}
		if (s / 4 == 'O' && s % 4 == 0) {
			return 'O';
		}
		if ((s - 'T' + 'X') / 4 == 'X' && (s - 'T' + 'X') % 4 == 0) {
			return 'X';
		}
		if ((s - 'T' + 'O') / 4 == 'O' && (s - 'T' + 'O') % 4 == 0) {
			return 'O';
		}
		return 0;
	}

	/**
	 * @param i
	 * @return
	 */
	private char verticalRow(int i) {
		int s = 0;
		for (int j = 0; j < 4; j++) {
			s += boardState[j][i];
		}

		return checkDivsibility(s);
	}

	/**
	 * @param i
	 * @return
	 */
	private char horizontalRow(int i) {
		int s = 0;
		for (int j = 0; j < 4; j++) {
			s += boardState[i][j];
		}
		return checkDivsibility(s);
	}

	public void _main() throws IOException {
		testCasesCount = scanner.nextLong();
		for (long i = 0; i < testCasesCount; i++) {
			scanner.nextLine();
			forEachTestCase(i);
		}
		writer.close();
	}

	public static void main(String[] args) throws IOException {
		FileOutputStream fos = new FileOutputStream("out");
		FileInputStream fis = new FileInputStream("in");
		TicTacToeTomek countSquare = new TicTacToeTomek(fos, fis);
		countSquare._main();
	}
}
