/**
 * Author : pankaj
 * Time   : 13-Apr-2013 - 4:40:35 AM
 */
package fands;

import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Scanner;
import java.util.Set;

public class FairAndSquareBruteSubB {
	private long testCasesCount;
	private Scanner scanner;
	BufferedWriter writer;
	Set<Long> fairSet = new HashSet<Long>();
	public FairAndSquareBruteSubB(FileOutputStream fos, FileInputStream fis) {
		super();
		this.scanner = new Scanner(fis);
		this.writer = new BufferedWriter(new OutputStreamWriter(fos));
	}

	private void forEachTestCase(long testCaseNum) throws IOException {
		// reading corresponding to each test case
		long lowerLimit = scanner.nextLong();
		long upperLimit = scanner.nextLong();
		long s = 0;
		long lsqrt = (long) Math.sqrt(lowerLimit);
		if (lsqrt * lsqrt != lowerLimit) {
			lsqrt = lsqrt + 1;
		}
		long usqrt = (long) Math.sqrt(upperLimit);
		Iterator<Long> iterator = fairSet.iterator();
		while (iterator.hasNext()) {
			Long type = iterator.next();
			if (type >= lowerLimit && type <= upperLimit) {
				s++;
			}
		}
		writer.write("Case #" + (testCaseNum + 1) + ": " + s + "\n");
		writer.flush();
	}

	public void _main() throws IOException {
		long usqrt = 100000000;
		for (long i = 1; i <= usqrt; i++) {
			if (isNumberPallindrome(i) == true && isNumberPallindrome(i * i) == true) {
				fairSet.add(i * i);
			}
		}
		testCasesCount = scanner.nextLong();
		for (long j = 0; j < testCasesCount; j++) {
			forEachTestCase(j);
		}
		writer.close();
	}

	/**
	 * @param i
	 * @return
	 */
	private boolean isNumberPallindrome(long i) {
		long copyI = i;
		long revI = 0;
		while (i > 0) {
			revI = (revI * 10) + (i % 10);
			i = i / 10;
		}
		return copyI == revI;
	}

	public static void main(String[] args) throws IOException {
		FileOutputStream fos = new FileOutputStream("out");
		FileInputStream fis = new FileInputStream("in");
		FairAndSquareBruteSubB countSquare = new FairAndSquareBruteSubB(fos, fis);
		countSquare._main();
	}
}
