/**
 * Author : pankaj
 * Time   : 13-Apr-2013 - 4:40:35 AM
 */
package energy;

import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.Scanner;

public class Energy {
	private long testCasesCount;
	private Scanner scanner;
	BufferedWriter writer;

	public Energy(FileOutputStream fos, FileInputStream fis) {
		super();
		this.scanner = new Scanner(fis);
		this.writer = new BufferedWriter(new OutputStreamWriter(fos));
	}


	private void forEachTestCase(long testCaseNum) throws IOException {
		// reading corresponding to each test case
		int maxEnergy = scanner.nextInt();
		int energyGain = scanner.nextInt();
		int n = scanner.nextInt();
		int[] activities = new int[n];
		for (int i = 0; i < n; i++) {
			activities[i] = scanner.nextInt();
		}
		int[][] processMatrix = new int[n][maxEnergy+1];
		for(int i=0;i<n;i++){
			for(int j=0;j<maxEnergy+1;j++){
				processMatrix[i][j]=0;
			}
		}

		for (int j = maxEnergy; j >= 0; j--) {
			processMatrix[0][maxEnergy-j] = j * activities[0];
		}

		for (int i = 1; i < n; i++) {
			for (int j = 0; j <= maxEnergy; j++) {
				int m = (j + energyGain) > maxEnergy ? maxEnergy : (j + energyGain);
				for (int k = m; k >= 0; k--) {
					int netGain = processMatrix[i - 1][j] + k * activities[i];
					if (netGain > processMatrix[i][m - k]) {
						processMatrix[i][m - k] = netGain;
					}
				}
			}
		}
		long max = 0;
		for (int j = maxEnergy; j >= 0; j--) {
			if (max < processMatrix[n - 1][j]) {
				max = processMatrix[n - 1][j];
			}
		}

		writer.write("Case #" + (testCaseNum + 1) + ": " + max + "\n");
	}


	public void _main() throws IOException {
		testCasesCount = scanner.nextLong();
		for (long i = 0; i < testCasesCount; i++) {
			// scanner.nextLine();
			forEachTestCase(i);
		}
		writer.close();
	}

	public static void main(String[] args) throws IOException {
		FileOutputStream fos = new FileOutputStream("out");
		FileInputStream fis = new FileInputStream("in");
		Energy countSquare = new Energy(fos, fis);
		countSquare._main();
	}
}
