import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;


public class DeceitfulWar {

	private static final String NEW_LINE = System.getProperty("line.separator");

	public static int simulate(ArrayList<Double> naomiBlocks,
			ArrayList<Double> kenBlocks, int N, boolean deceitful){
		int naomiScore=0;
		Naomi naomi = new Naomi(naomiBlocks);
		Ken ken = new Ken(kenBlocks);
		naomi.getKenBlocks(kenBlocks);
		double kenPlayed = 0;
		for(int i=0; i<N; i++){
			double naomiDeceitful = naomi.deceitfulStrategy();
			double naomiPlayed = naomi.strategy();
			if(deceitful)
				kenPlayed = ken.strategy(naomiDeceitful);
			else 
				kenPlayed = ken.strategy(naomiPlayed);
			if(naomiPlayed > kenPlayed){
				naomiScore++;
			}
		}
		return naomiScore;
	}

	private static void fileParse(File file) {
		ArrayList<Double> arr1 = new ArrayList<Double>();
		ArrayList<Double> arr2 = new ArrayList<Double>();
		BufferedReader in = null;
		FileWriter fw = null;
		int counter = 0;
		String[] singleGame = new String[3];
		try {
			in = new BufferedReader(new FileReader(file));
			int testCase = 1, cases = 0;
			if(in.ready()){
				String s = in.readLine();
				cases = Integer.parseInt(s);
				counter++;
			}
			fw = new FileWriter(file.getParent()+File.separator+"deceitfulWar.out");
			while (in.ready()) {
				String s = in.readLine();
				if (counter%3 != 0){
					singleGame[counter%3-1] = s;
				}else{
					singleGame[singleGame.length-1] = s;
					buildGame(arr1,arr2,singleGame);
					int deceitfulWins = simulate(arr1,arr2,arr1.size(),true);
					int regularWins = simulate(arr1,arr2,arr1.size(),false);
					if(testCase > cases){
						System.out.println("Wrong input file");
						break;
					} else if(testCase == cases){
						printResult(deceitfulWins,regularWins,testCase,fw,true);
					} else{
						printResult(deceitfulWins,regularWins,testCase,fw,false);
					}
					testCase++;
					arr1.clear();
					arr2.clear();
				}
				counter++;
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally{
			try {
				if(fw != null)
					fw.close();
				if(in != null)
					in.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	private static void buildGame(ArrayList<Double> arr1, ArrayList<Double> arr2,
			String[] singleGame) {
		int blocksNum = Integer.parseInt(singleGame[0]);
		String[] a1 = singleGame[1].split("\\s+");
		String[] a2 = singleGame[2].split("\\s+");
		for(int j=0; j<blocksNum; j++){
			arr1.add(Double.parseDouble(a1[j]));
			arr2.add(Double.parseDouble(a2[j]));
		}
	}

	private static void printResult(int deceitfulWins,int regularWins,
			int testCase, FileWriter fw, boolean finalCase) throws IOException{
		String str = "Case #"+testCase+": "+deceitfulWins+" "+regularWins;
		if(!finalCase)
			str += NEW_LINE;
		fw.append(str);
		System.out.print(str);

	}

	public static void main(String[] args){
		File file = new File("C:"+File.separator+"Users"+File.separator+
				"Louai"+File.separator+"Desktop"+File.separator+"codejam"+
				File.separator+"D-small-attempt3.in");

		fileParse(file);		
	}



}
