import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class CookieClickerAlpha {

	private static final double INITIAL_RATE = 2.000000;

	private static final String NEW_LINE = System.getProperty("line.separator"); 


	public static double solver(double C, double F, double X){
		double currentRateGain = 0, nextRateGain = 0,rate = INITIAL_RATE;
		double timer = 0;
		do{
			currentRateGain = (double)X/(double)rate;
			nextRateGain = (double)C/(double)rate+(double)X/(double)(rate+F);
			if(nextRateGain >= currentRateGain){
				timer += (double)currentRateGain;
			} else{
				timer += (double)C/(double)rate;
			}
			rate += (double)F;
		} while(nextRateGain < currentRateGain);
		return timer;
	}

	public static void fileParse(File file) {
		BufferedReader in = null;
		FileWriter fw = null;
		try {
			in = new BufferedReader(new FileReader(file));
			int testCase = 1, cases = 0;
			if(in.ready()){
				String s = in.readLine();
				cases=Integer.parseInt(s);
			}
			fw = new FileWriter(file.getParent()+File.separator+"coockieClicker.out");
			while (in.ready()) {
				String s = in.readLine();
				String[] params = s.split("\\s+");
				printResult(solver(Double.parseDouble(params[0]),
						Double.parseDouble(params[1]),
						Double.parseDouble(params[2])),testCase,fw);
				if(testCase > cases){
					System.out.println("Wrong input file");
					break;
				}
				testCase++;
			}

		} catch (IOException e) {
			e.printStackTrace();
		} finally{
			try {
				if(fw != null)
					fw.close();
				if(in != null)
					in.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	private static void printResult(double res, int testCase, FileWriter fw) throws IOException{
		fw.append(String.format("Case #"+testCase+": %.7f"+NEW_LINE, res));
		System.out.printf("Case #"+testCase+": %.7f"+NEW_LINE, res);
	}


	public static void main(String[] args){
		File file = new File("C:"+File.separator+"Users"+File.separator+
				"Louai"+File.separator+"Desktop"+File.separator+"codejam"+
				File.separator+"B-small-attempt2.in");
		fileParse(file);
	}

}


