import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashSet;


public class MagicTrick {

	private static int cases;
	
	private static int answer1 = 0 , answer2 = 0;

	public static void fileParse(File file) throws IOException{
		@SuppressWarnings("resource")
		BufferedReader in = new BufferedReader(new FileReader(file));
		int counter = 1;
		String[] singleTrick = new String[10];
		int testCase = 1;
		if(in.ready()){
			String s = in.readLine();
			cases=Integer.parseInt(s);
		}
		while (in.ready()) {
			String s = in.readLine();
			if (counter%10 != 0){
				singleTrick[counter%10-1] = s;
			}else{
				singleTrick[singleTrick.length-1] = s;
				int[][] grid1 = new int[4][4],grid2 = new int[4][4];
				buildTrick(grid1,grid2,singleTrick);
				System.out.println(solveTrick(grid1,grid2,answer1,answer2,testCase));
				if(testCase > cases){
					System.out.println("Wrong input file");
					return;
				}
				testCase++;
			}
			counter++;
		}
		in.close();
	}


	private static void buildTrick(int[][] grid1, int[][] grid2, String[] singleTrick) {
		answer1 = Integer.parseInt(singleTrick[0]);
		for(int i=1; i<5; i++){
			String[] numbersInRow = singleTrick[i].split("\\s+");
			for(int j=0; j<numbersInRow.length; j++){
				grid1[i-1][j] = Integer.parseInt(numbersInRow[j]);
			}
		}
		answer2 = Integer.parseInt(singleTrick[5]);
		for(int i=6; i<10; i++){
			String[] numbersInRow = singleTrick[i].split("\\s+");
			for(int j=0; j<numbersInRow.length; j++){
				grid2[i-6][j] = Integer.parseInt(numbersInRow[j]);
			}
		}
	}


	public static String solveTrick(int[][] grid1, int[][] grid2,
			int answer1, int answer2, int caseNumber){
		HashSet<Integer> row1 = new HashSet<Integer>();
		for(int i=0; i<grid1[0].length; i++){
			row1.add(grid1[answer1-1][i]);
		}
		HashSet<Integer> row2 = new HashSet<Integer>();
		for(int i=0; i<grid2[0].length; i++){
			row2.add(grid2[answer2-1][i]);
		}
		row1.retainAll(row2);
		if(row1.size() == 1){
			return "Case #"+caseNumber+": "+row1.iterator().next();
		}
		else if(row1.size() > 1){
			return "Case #"+caseNumber+": Bad magician!";
		}
		else
			return "Case #"+caseNumber+": Volunteer cheated!";
	}

	
	public static void main(String[] args){
		File file = new File("C:"+File.separator+"Users"+File.separator+
				"Louai"+File.separator+"Desktop"+File.separator+"codejam"+
				File.separator+"A-small-attempt0.in");
		try {
			fileParse(file);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}


}
