package com.company;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.*;
import java.util.stream.Collectors;

import static java.lang.Math.sqrt;

public class Main3 {

    public static void main(String[] args) throws IOException {
        //List<String> input = Files.readAllLines(Paths.get(System.getProperty("user.home") + "/Downloads/B-large.in"));
        List<String> input = Files.readAllLines(Paths.get(System.getProperty("user.home") + "/3.txt"));
        List<String> output = new ArrayList<>();

        int length = Integer.parseInt(input.get(1).split(" ")[0]);
        int numberOfJamcoins = Integer.parseInt(input.get(1).split(" ")[1]);
        long[] digits = new long[length];
        digits[0] = 1;
        digits[length - 1] = 1;
        boolean first = true;

        Set<String> jamcoins = new HashSet<>(numberOfJamcoins);
        while (jamcoins.size() < numberOfJamcoins && base(10, digits) < Long.MAX_VALUE) {
            if (!first) {
                digits = next(digits);
            } else {
                first = false;
            }
            long base10 = base(10, digits);
            long base9 = base(9, digits);
            long base8 = base(8, digits);
            long base7 = base(7, digits);
            long base6 = base(6, digits);
            long base5 = base(5, digits);
            long base4 = base(4, digits);
            long base3 = base(3, digits);
            long base2 = base(2, digits);

            long divisor10 = isPrime(base10);
            if (divisor10 == -1) continue;
            long divisor9 = isPrime(base9);
            if (divisor9 == -1) continue;
            long divisor8 = isPrime(base8);
            if (divisor8 == -1) continue;
            long divisor7 = isPrime(base7);
            if (divisor7 == -1) continue;
            long divisor6 = isPrime(base6);
            if (divisor6 == -1) continue;
            long divisor5 = isPrime(base5);
            if (divisor5 == -1) continue;
            long divisor4 = isPrime(base4);
            if (divisor4 == -1) continue;
            long divisor3 = isPrime(base3);
            if (divisor3 == -1) continue;
            long divisor2 = isPrime(base2);
            if (divisor2 == -1) continue;


            String jamcoin = "";
            for (int i = 0; i < digits.length; i++) {
                jamcoin += digits[i];
            }

            jamcoins.add(jamcoin + " " +
                    divisor2 + " " +
                    divisor3 + " " +
                    divisor4 + " " +
                    divisor5 + " " +
                    divisor6 + " " +
                    divisor7 + " " +
                    divisor8 + " " +
                    divisor9 + " " +
                    divisor10 + " ");
        }

        if (jamcoins.size() != numberOfJamcoins) {
            System.out.println("Not enough jamcoins: " + jamcoins.size());
        } else {
            System.out.println("Jamcoins: " + jamcoins.size());
        }
        output.add("Case #1:");
        output.addAll(jamcoins);
        Files.write(Paths.get(System.getProperty("user.home") + "/3ans.txt"), output);
    }

    private static long[] next(long[] digits) {
        long base10 = base(10, digits) + 10;
        String dString = String.valueOf(base10);
        while (!onlyBinary(dString)) {
            base10 += 10;
            dString = String.valueOf(base10);
        }

        List<Integer> x = Arrays.asList(dString.split("")).stream()
                .map(Integer::parseInt)
                .collect(Collectors.toList());

        return x.stream().mapToLong(i -> i).toArray();
    }

    private static boolean onlyBinary(String digits) {
        Set<String> x = new HashSet<>();
        x.addAll(Arrays.asList(digits.split("")));
        if (x.size() == 2 && !x.add("1") && !x.add("0")) {
            return true;
        }
        return false;
    }

    public static long base(long base, long[] digits) {
        long num = 0;
        for (int i = 0; i < digits.length; i++) {
            num += Math.pow(base, i) * digits[digits.length - 1 - i];
        }
        return num;
    }

    public static long isPrime(long n) {
        if (n % 2 == 0) {
            return 2;
        }
        for (long i = 3; i < sqrt(n); i++) {
            if (n % i == 0) {
                return i;
            }
        }
        return -1;
    }

}
