import java.io.BufferedReader;
import java.io.IOException;
import java.util.ArrayList;


public class InputCase {

	long [] digits;
	
	public InputCase() {
	}
	
	public void readCase(BufferedReader reader) throws IOException, NumberFormatException {
		String nLine = reader.readLine().trim();
		digits = new long [nLine.length()];
		for (int i=0; i<digits.length; i++) {
			int dig = nLine.charAt(i) - '0';
			digits[i] = dig;
		}
		
	}
	
	public Object solve() {
		return breakUp(new ArrayList<Long>(), 0, digits.length);
	}
	

	static long countUglies(ArrayList<Long> list) {
		return countUgliesHelper(list.get(0), list, 1);
	}
	
	static long countUgliesHelper(long current, ArrayList<Long> list, int index) {
		if (index == list.size()) {
			if (isUgly(current)) {
				return 1;
			}
			return 0;
		}

		long next = list.get(index++);
		long count = countUgliesHelper(current + next, list, index);
		count += countUgliesHelper(current - next, list, index);
		
		return count;
	}
	
	long buildNumber(int start, int end) {
		long val = 0;
		for (int i = start; i < end; i++) {
			val = val*10 + digits[i];
		}
		return val;
	}
		
	long breakUp(ArrayList<Long> list, int start, int end) {
		if (start == end) {
			return countUglies(list);
		}
		
		long sum = 0;
		int last = list.size();
		for (int i = start + 1; i <= end; i++) {
			list.add(buildNumber(start, i));
			sum += breakUp(list, i, end);
			list.remove(last);
		}
		return sum;
	}


	public ArrayList<Long> breakIt(int lastBreak) {
		if (lastBreak == digits.length-1) {
			ArrayList<Long> one = new ArrayList<Long>();
			one.add(digits[digits.length-1]);
			return one;
		}
		
		ArrayList<Long> allChildren = new ArrayList<Long>();
		
		for (int i=lastBreak+1; i<digits.length; i++) {
			long curVal = 0;
			for (int v=lastBreak; v<i; v++) {
				curVal = curVal * 10 + digits[v];
			}
			ArrayList<Long> children = breakIt(i);
			
			for (int c=0; c<children.size(); c++) {
				allChildren.add(curVal + children.get(c));
				allChildren.add(curVal - children.get(c));
			}
			
		}
		return allChildren;
	}
	
	public static final boolean isUgly(long n) {
		return n%2 == 0 || n%3==0 || n%5==0 || n%7==0;
	}
	
	class BrokenNumber {
		long numbers[];
		
		public BrokenNumber() {
			numbers = new long[0];
		}
		
		public BrokenNumber(BrokenNumber oldBreak, int newBreakSpot) {
			numbers = new long[oldBreak.numbers.length + 1];
			System.arraycopy(oldBreak.numbers, 0, this.numbers, 0, oldBreak.numbers.length);
			numbers[oldBreak.numbers.length] = newBreakSpot;
		}
		
		public void addValues(ArrayList<Long> list) {
			for (int i=0; i<numbers.length; i++) {
				
			}
		}
	}
	
}
