import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

public class InputCase {
	enum Gate {AND, OR}
	
	BNode tree[] = new BNode[10000];
	ArrayList<boolean[]> queue = new ArrayList<boolean[]>();
	int innerNodes;
	int desiredValue;
	int changeable[];
	ArrayList<Integer> canChangeList;
	
	static int left(int node) {
		return (node + 1) * 2 - 1;
	}
	
	static int right(int node) {
		return (node + 1) * 2;
	}
	
	static int parent(int node) {
	    return (node - 1) / 2; 
	}
	

	boolean eval(boolean changedState[]) {
		for (int i = 0; i < changedState.length; i++) {
			tree[changeable[i]].flipped = changedState[i];
		}
		for (int i = innerNodes - 1; i >= 0; i--) {
			tree[i].operate(tree[left(i)], tree[right(i)]);
		}
		return tree[0].value == desiredValue;
	}
	
	
	boolean eval() {
		for (int i = innerNodes - 1; i >= 0; i--) {
			tree[i].operate(tree[left(i)], tree[right(i)]);
		}
		return tree[0].value == desiredValue;
	}

	static int count(boolean changedState[]) {
		int count = 0;
		for (int i = 0; i < changedState.length; i++) {
			if (changedState[i]) {
				count++;
			}
		}
		return count;
	}
	

	int solv(int canChange) {
		queue.clear();
		queue.add(new boolean[canChange]);
		
		while (queue.size() != 0) {
			boolean changedState[] = queue.remove(0);

			for (int i = 0; i < changedState.length; i++) {
				tree[changeable[i]].flipped = changedState[i];
			}

			for (int i = 0; i < changedState.length; i++) {
				if (!changedState[i]) {
					boolean nextState[] = Arrays.copyOf(changedState, changedState.length);
					nextState[i] = true;

					if (eval(nextState)) {
						return count(nextState);
					}

					queue.add(nextState);
				}
			}
		}
		
		return -1;
	}

	
	public InputCase() {
	}
	
	public void readCase(Scanner scanner) throws IOException, NumberFormatException {
		int nodeCount = scanner.nextInt();
		desiredValue = scanner.nextInt();

		canChangeList = new ArrayList<Integer>();
		
		innerNodes = (nodeCount - 1) / 2;
		for (int i = 0; i < innerNodes; i++) {
			tree[i] = new BNode();
			if (scanner.nextInt() == 1) {
				tree[i].type = Gate.AND;
			} else {
				tree[i].type = Gate.OR;
			}
			
			if (scanner.nextInt() == 1) {
				canChangeList.add(i);
				tree[i].changable = true;
			} else {
				tree[i].changable = false;
			}
		}
		
		changeable = new int[canChangeList.size()];
		for (int i = 0; i < changeable.length; i++) {
			changeable[i] = canChangeList.get(i);
		}

		for (int i = innerNodes; i < nodeCount; i++) {
			tree[i] = new BNode();
			tree[i].value = scanner.nextInt();
		}
	}
	
	public Object solve() {
		
		if (eval()) {
			return "0";
		}
		int result = solv(canChangeList.size());

		if (result == -1) {
			return "IMPOSSIBLE";
		}
		
		return Integer.toString(result);
	}
	
	public class BNode {
		public boolean changable;
		public boolean flipped;
		public int value;
		public Gate type;
		
		private Gate getGate() {
			if (flipped) {
				if (type == Gate.AND) {
					return Gate.OR;
				}
				return Gate.AND;
			}
			return type;
		}
		
		public void operate(BNode left, BNode right) {
			if (getGate() == Gate.AND) {
				value = left.value & right.value; 
			} else {
				value = left.value | right.value;
			}
		}
	}
}
