import java.io.BufferedReader;
import java.io.IOException;
import java.util.Scanner;

public class InputCase {

	long maxLettersPerKey;
	long numKeys;
	long alphabetLen;
	long [] alphaFreqs;
	
	public InputCase() {
	}
	
	public void readCase(BufferedReader reader) throws IOException, NumberFormatException {
		
		String nLine = reader.readLine().trim();
		String nLine2 = reader.readLine().trim();
		String [] nVals = nLine.split("(\\s)+");
		String [] fVals = nLine2.split("(\\s)+");
		
		
		
		//Integer.parseInt(nVals[0]);
		
		
		
		maxLettersPerKey = Integer.parseInt(nVals[0]);
		numKeys = Integer.parseInt(nVals[1]);
		alphabetLen = Integer.parseInt(nVals[2]);
		alphaFreqs = new long [(int) alphabetLen];
		for (int i=0; i<alphabetLen; i++) {
			alphaFreqs[i] = Integer.parseInt(fVals[i]);
		}
		
	}
	
	public Object solve() {

		java.util.Arrays.sort(alphaFreqs);
		
		long depth = 1;
		long keyPresses = 0;
		long freqIndex = alphabetLen - 1;
		
		outer:while (depth <= maxLettersPerKey) {
			long numKeysRem = numKeys;
			
			while (numKeysRem > 0) {
				
				keyPresses += depth * alphaFreqs[(int) freqIndex];
				if (freqIndex == 0) {
					break outer;
				}
				freqIndex--;
				numKeysRem--;
			}
			depth++;
		}
		
		if (depth == maxLettersPerKey+1) {
			return "Impossible";
		}
		
		
		return keyPresses;
	}
	
	
}
