package problemSolutions;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import common.ErrorLogger;

/**
 * @author Oliver
 * 
 */
public class CookieClickerAlpha {

	private static BufferedReader br;
	private static BufferedWriter bw;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			// Open input file.
			br = new BufferedReader(new FileReader("B-large.in"));

			// Open output file.
			bw = new BufferedWriter(new FileWriter("output.out"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			return;
		} catch (IOException e) {
			e.printStackTrace();
		}

		try {
			// Initialise input and read number of cases.
			int testCases = Integer.parseInt(br.readLine());

			// For each test case.
			analyseTestCases(testCases);
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				br.close();
				bw.flush();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	private static void analyseTestCases(int testCases) throws IOException {
		for (int i = 1; i <= testCases; i++) {
			String[] input = br.readLine().split(" ");

			ErrorLogger.assertTrue(input.length == 3, "Malformed input.");

			double c = Double.parseDouble(input[0]);
			double f = Double.parseDouble(input[1]);
			double x = Double.parseDouble(input[2]);
			
			// Cookie rate.
			double r = 2;
			
			double duration = 0;
			
			boolean found = false;
			
			while (!found) {
				double timeTillWinWithFarm = (c / r) + (x / (r + f));
				double timeTillWinWithoutFarm = x / r;
				
				if (timeTillWinWithFarm < timeTillWinWithoutFarm) {
					/*
					 * Buy a farm. Cookies reset to zero.
					 */
					
					duration += c / r;
					
					r += f;
				}
				else {
					/*
					 * Don't buy a farm.
					 */
					
					duration += timeTillWinWithoutFarm;
					
					found = true;
				}
			}

			write("Case #" + i + ": " + duration + "\n");
		}
	}

	private static void write(String s) {
		try {
			bw.write(s);
			System.out.print(s);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
