package round1C;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Consonants {

	private static BufferedReader br;
	private static BufferedWriter bw;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			// Open input file.
			br = new BufferedReader(new FileReader("input.in"));
			
			// Open output file.
			bw = new BufferedWriter(new FileWriter("output.out"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			return;
		} catch (IOException e) {
			e.printStackTrace();
		}

		try {
			// Initialise input and read number of cases.
			int testCases = Integer.parseInt(br.readLine());

			// For each test case.
			analyseTestCases(testCases);
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		finally {
			try {
				br.close();
				bw.flush();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	private static void analyseTestCases(int testCases) throws IOException {
		for (int i = 1; i <= testCases; i++) {
			String input = br.readLine();
			
			String[] inputValues = input.split(" ");

			String name = inputValues[0];
			int n = Integer.parseInt(inputValues[1]);

			write("Case #" + i + ": " + countCC(name, 0,name.length() - 1, n, 0) + "\n");
		}
	}
	
	/**
	 * Gets the index of the first instance of the consecutive consonants.
	 * Returns -1 if no more remain.
	 * 
	 * @param s
	 * @param startIndex
	 * @param n
	 * @param fromLeft
	 * @return index of second consonant in consecutive group from respective direction
	 */
	private static int countCC(String s, int startIndex, int endIndex, int n, int count) {
		char[] cArray = s.toCharArray();
		
		int consonants = 0;
		
		int l = startIndex;
		int r = endIndex;
		
		boolean lFound = false;
		
		while (l <= endIndex && !lFound) {
			if (isConsonant(cArray[l])) {
				consonants ++;
			}
			else {
				consonants = 0;
			}
			
			if (consonants == n) {
				lFound = true;
				
				l -= n - 1;
			}
			else {
				l ++;
			}
		}
		
		consonants = 0;
		
		boolean rFound = false;
		
		while (r >= startIndex && !rFound) {
			if (isConsonant(cArray[r])) {
				consonants ++;
			}
			else {
				consonants = 0;
			}
			
			if (consonants == n) {
				rFound = true;
				
				r += n - 1;
			}
			else {
				r --;
			}
		}
		
		if (lFound && rFound) {
			int lChange = l - startIndex;
			int rChange = endIndex - r;
			
			count += (lChange + 1) * (rChange + 1);
			
			if (r - n >= startIndex && l + n <= endIndex) {
				count += (r - (l + n) + 1) * (lChange + 1);
				count += ((r - n) - l + 1) * (rChange + 1);
			}
			
			return countCC(s, l + 1, r - 1, n, count);
		}
		else if (!rFound && !lFound) {
			return count;
		}
		else {
			throw new Error();
		}
		
		/*while (i >= 0 && i < cArray.length) {
			if (isConsonant(cArray[i])) {
				consonants ++;
			}
			else {
				consonants = 0;
			}
			
			if (fromLeft) {
				i ++;
			}
			else {
				i --;
			}
			
			if (consonants == n) {
				return i;
			}
		}
		
		return -1;*/
	}
	
	private static boolean isConsonant(char c) {
		switch (c) {
		case 'a':
			return false;
		case 'e':
			return false;
		case 'i':
			return false;
		case 'o':
			return false;
		case 'u':
			return false;
		default:
			return true;
		}
	}
	
	private static void write(String s) {
		try {
			bw.write(s);
			System.out.print(s);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
