import java.io.*;
import java.util.*;

/**
 * Write a description of class TextFileReader here.
 * 
 * @author Oliver Allbless
 * @version Working
 */
public class TextFileReader
{
    public BufferedReader br;
    public String fileName = "text.txt";

    public String[] TextFileReader()
    {
        openFile();

        String input;

        Stack<String> inputStack = new Stack();

        do
        {
            input = readOneLine();

            if (input != null)
            {
                inputStack.push(input);
            }
        } while(input != null);

        return stackToStringArray(inputStack);
    }

    public void openFile()
    {
        try
        {
            br = new BufferedReader(new FileReader(fileName));
        }
        catch (Exception e)
        {

        }
    }

    public String readOneLine()
    {
        String input = new String();

        try
        {
            input = br.readLine();
        }
        catch (Exception e)
        {
            System.out.println("IO error trying to read from the file");
            System.exit(1);
        }

        return input;
    }

    public String[] splitString(String string, String splitVariable)
    {
        return string.split(splitVariable);
    }
    
    public String[] stackToStringArray(Stack<String> stack)
    {
        String[] stringArray = new String[stack.size()];
        
        for (int i = stack.size() - 1; i >= 0; i --)
        {
            stringArray[i] = stack.pop();
        }
        
        return stringArray;
    }
    
    public String[] getStringArrayPortion(String[] stringArray, int startIndex, int endIndex)
    {
        String[] stringPortion = new String[endIndex - startIndex + 1];
        
        for (int i = startIndex; i <= endIndex; i ++)
        {
            stringPortion[i - startIndex] = stringArray[i];
        }
        
        return stringPortion;
    }
    
    public void traceStringArray(String[] stringArray)
    {
        for (int i = 0; i < stringArray.length; i ++)
        {
            System.out.println(stringArray[i]);
        }
    }
    
    public boolean[] createBooleanArray(int arrayLength, boolean booleanValue)
    {
        boolean[] booleanArray = new boolean[arrayLength];
        
        for (int i = 0; i < arrayLength; i ++)
        {
            booleanArray[i] = booleanValue;
        }
        
        return booleanArray;
    }
    
    public int[] createIntArray(int arrayLength, int intValue)
    {
        int[] intArray = new int[arrayLength];
        
        for (int i = 0; i < arrayLength; i ++)
        {
            intArray[i] = intValue;
        }
        
        return intArray;
    }
    
    public int countBooleanValues(boolean[] booleanArray, boolean booleanValue)
    {
        int count = 0;
        
        for (int i = booleanArray.length - 1; i >= 0; i --)
        {
            if (booleanArray[i] == booleanValue)
            {
                count ++;
            }
        }
        
        return count;
    }
    
    public String[][] splitAlternatingValues(String[] wholeArray, int startIndex)
    {
        String[] arrayA;
        String[] arrayB;
        
        int wholeArrayLength = wholeArray.length;
        
        int splittedArrayLength = (wholeArrayLength - startIndex) / 2;
        
        arrayA = new String[splittedArrayLength];
        
        arrayB = new String[splittedArrayLength];
        
        boolean booleanSwitch = false;
        
        int splittedArrayIndex = 0;
        
        for (int i = startIndex; i < wholeArrayLength; i ++)
        {
            booleanSwitch = !booleanSwitch;
            
            if (booleanSwitch)
            {
                arrayA[splittedArrayIndex] = wholeArray[i];
            }
            else
            {
                arrayB[splittedArrayIndex] = wholeArray[i];
                
                splittedArrayIndex ++;
            }
        }
        
        String[][] splittedArrays = new String[2][splittedArrayLength];
        splittedArrays[0] = arrayA;
        splittedArrays[1] = arrayB;
        
        return splittedArrays;
    }
    
    public char[] stringArrayToCharArray(String[] stringArray)
    {
        int stringArrayLength = stringArray.length;
        
        char[] charArray = new char[stringArrayLength];
        
        for (int i = 0; i < stringArrayLength; i ++)
        {
            charArray[i] = stringArray[i].charAt(0);
        }
        
        return charArray;
    }
    
    public int[] stringArrayToIntArray(String[] stringArray)
    {
        int stringArrayLength = stringArray.length;
        
        int[] intArray = new int[stringArrayLength];
        
        for (int i = 0; i < stringArrayLength; i ++)
        {
            intArray[i] = Integer.parseInt(stringArray[i]);
        }
        
        return intArray;
    }
    
    public int[] intToBinaryArray(int number)
    {
        int[] binaryArray = createIntArray(32, 0);
        
        int binaryIndex = 32;
        
        int bitValue = 0;
        
        while (number > 0)
        {
            bitValue = (int)Math.pow(2, binaryIndex);
            
            if (bitValue <= number)
            {
                binaryArray[binaryIndex] = 1;
                
                number -= bitValue;
            }
            
            binaryIndex --;
        }
        
        return binaryArray;
    }
    
    public int binaryArrayToInt(int[] binaryArray)
    {
        int denaryValue = 0;  
        
        for (int i = binaryArray.length - 1; i >= 0; i --)
        {
            if (binaryArray[i] == 1)
            {
                denaryValue += (int)Math.pow(2, i);
            }
        }
        
        return denaryValue;
    }
    
    public int getLowestValueInIntArray(int[] intArray)
    {
        int lowestValue = 2147483647;
        
        int intArrayLength = intArray.length;
        
        for (int i = 0; i < intArrayLength; i ++)
        {
            if (intArray[i] < lowestValue)
            {
                lowestValue = intArray[i];
            }
        }
        
        return lowestValue;
    }
    
    public int getSumOfIntArray(int[] intArray)
    {
        int sumOfIntArray = 0;
        
        int intArrayLength = intArray.length;
        
        for (int i = 0; i < intArrayLength; i ++)
        {
            sumOfIntArray += intArray[i];
        }
        
        return sumOfIntArray;
    }
}