package _2013.FairAndSquare;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;


public class FairandSquare {


	private OutputFile outputFile;

	public void setOutputFile(String input, String output){
		outputFile = new OutputFile(input, output);
	}
	
	public OutputFile getOutputFile(){
		return this.outputFile;
	}
	
	public void solveAll(){
		List<String> inputList = this.getOutputFile().getInputArray();
		List<String> outputList = new ArrayList<String>();
		for(String input : inputList) outputList.add(solve(input));
		try {
			this.getOutputFile().produceResultFile(outputList);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public String solve(String input){
		long N = 0;
		long A = Long.valueOf(input.split(" ")[0]);
		long B = Long.valueOf(input.split(" ")[1]);
		long dA = (long) Math.sqrt(A);
		long dB = (long) Math.sqrt(B);
		
		//System.out.println("Input: " + input);
		
		long sqA = (dA*dA< A) ? dA+1 : dA;
		long sqB = (dB*dB<= B) ? dB : dB-1;
	
		long i = sqA;
		while(i<=sqB){
			if(isPalindrome(i) && isPalindrome(i*i) ){
				N++;
				//System.out.println(i + "--" + i*i);
			}
			
			i++;
		}
		//System.out.println();
		return String.valueOf(N);
	}
	
	public boolean isPalindrome(long l){
		char[] a = String.valueOf(l).toCharArray();
		for(int i = a.length - 1, j=0; i>j; i-- , j++)
			if(a[j] != a[i]) return false;
		return true;
	}
	

	public static void main(String[] args) {
		FairandSquare fs = new FairandSquare();
		fs.setOutputFile("c:\\TopCoder\\TC\\TopCoderSRM\\GoogleCodeJam\\_2013\\FairAndSquare\\C-small-attempt2.in"
						, "c:\\TopCoder\\TC\\TopCoderSRM\\GoogleCodeJam\\_2013\\FairAndSquare\\C-small-attempt2.out");
		fs.solveAll();
		
	}
	
	private class OutputFile{
		private String inputFileName;
		private String outputFileName;
		private List<String> inputArray;
		private int N;
		
		public OutputFile(String input, String output){
			this.inputFileName = input;
			this.outputFileName = output;
			inputArray = readFileIntoList();
		}
		
		private List<String> readFileIntoList(){
			BufferedReader br;
			List<String> inp = new ArrayList<String>();
			
			try {
		
				br = new BufferedReader(new FileReader(inputFileName));
				N = Integer.parseInt(br.readLine());
				String line;

				while((line = br.readLine())!=null)	inp.add(line.toLowerCase());
			
			} catch (NumberFormatException | IOException e) {
				e.printStackTrace();
			}
			return inp;
		}
		
		private List<List<String>> generateInputs(int inputSize){
			List<List<String>> inputsList = new ArrayList<List<String>>();
			List<String> input = new ArrayList<String>();
			
			int i = 1;
			for(String line : inputArray){
				input.add(line.toLowerCase());
				if(i%inputSize == 0){
					inputsList.add(input);
					input = new ArrayList<String>();
				}
				i++;
			}
			
			return inputsList;
		}
		
		private void produceResultFile(List<String> outputList) throws IOException{
			int i = 1;
			BufferedWriter br = new BufferedWriter(new FileWriter(outputFileName));
			for(String line : outputList){
				System.out.println("Case #"+ i +": "+ line);
				br.write("Case #"+ (i++)+": "+ line);
				br.newLine();
			}
			br.flush();
			br.close();
			
		}
		
		public String getInputFileName() {
			return inputFileName;
		}

		public void setInputFileName(String inputFileName) {
			this.inputFileName = inputFileName;
		}

		public String getOutputFileName() {
			return outputFileName;
		}

		public void setOutputFileName(String outputFileName) {
			this.outputFileName = outputFileName;
		}
		
		public List<String> getInputArray() {
			return inputArray;
		}

		public void setInputArray(List<String> inputArray) {
			this.inputArray = inputArray;
		}

		public int getN() {
			return N;
		}

		public void setN(int n) {
			N = n;
		}
		
	}

	
}
