import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

public class SpeakingInTongues {

	Map<Character,Character> dictionary = new TreeMap<Character,Character>();
	BufferedReader br;
	List<String> output = new ArrayList<String>();
	int T = 0;
	
	public void generateDict(){
		String[] googlereseStr = {
				"ejp mysljylc kd kxveddknmc re jsicpdrysi",
				"rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd",
				"de kr kd eoya kw aej tysr re ujdr lkgc jv",
		};
		String[] english ={
			"our language is impossible to understand",
			"there are twenty six factorial possibilities",
			"so it is okay if you want to just give up",
		};
		for(int i = 0; i<english.length; i++){
			for(int j =0; j<english[i].length();j++){
				if(!dictionary.containsValue((english[i].charAt(j)))){
					dictionary.put(Character.valueOf(googlereseStr[i].charAt(j)),
							Character.valueOf(english[i].charAt(j)));
				}
			}
		}
		//dictionary.remove(Character.valueOf(' '));
		dictionary.put(Character.valueOf('q'),Character.valueOf('z'));
		for(int i=97; i<123;i++){
			if(!dictionary.containsKey(Character.valueOf((char)i))){
				dictionary.put(Character.valueOf((char)i), Character.valueOf('q'));
			}
		}
	}
	
	public void generateOutput(){
		try{
			  FileInputStream fstream = new FileInputStream("C:/temp/A-small-attempt0.in");
			  DataInputStream in = new DataInputStream(fstream);
			  br = new BufferedReader(new InputStreamReader(in));
			  String strLine;
			  T = Integer.parseInt(br.readLine());
			  
			  while ((strLine = br.readLine()) != null)   {
				  System.out.println (strLine);
				  StringBuilder strbld = new StringBuilder();
				  for(int i = 0; i<strLine.length(); i++){
					  strbld.append(dictionary.get(Character.valueOf(strLine.charAt(i))));
					}
				  output.add(strbld.toString());
				}
			  in.close();
		    }catch (Exception e){
			  System.err.println("Error: " + e.getMessage());
			  }
		
		createOutputFile(output);
	}
	
	public void createOutputFile(List<String> output){
		try{
			  FileWriter fstream = new FileWriter("C:/temp/SpeakingInTongues0.out");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(String str : output) {
				  out.write(str);
				  out.newLine();
			  }

			  out.close();
			}catch (Exception e){
			  System.err.println("Error: " + e.getMessage());
			 }
			  
	}
	
	public static void main(String[] args) {
		SpeakingInTongues speakingInTongues = new SpeakingInTongues();
		speakingInTongues.generateDict();
		speakingInTongues.generateOutput();
		
	}

}
