import java.math.BigInteger;
import java.util.BitSet;
import java.util.Scanner;

public class PrimeGC1 {

	private static BigInteger SIX = new BigInteger("6");
	private static BigInteger FIVE = new BigInteger("5");
	private static BigInteger TWO = new BigInteger("2");
	private static BigInteger THREE = new BigInteger("3");

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		Scanner sc = new Scanner(System.in);
		int testCases = sc.nextInt();
		System.out.println("Case #1:");
		for (int in = 0; in < testCases; in++) {

			int input = sc.nextInt();
			int limit = sc.nextInt();
			StringBuilder pad = new StringBuilder();
			for (int i = 0; i < input - 2; i++) {
				pad.append("0");
			}
			String pattern = "1" + pad + "1";
			int base = 2, counter = 0;
			BigInteger check = convertToInt(pattern, base);
			outer: for (;; check = check.add(TWO)) {
				if (!isProbablePrime(check)) {
					StringBuilder result = new StringBuilder();
					result.append(check.toString(2) + " "
							+ fetchMinFactor(check));
					BigInteger res = null;
					for (int bi = 3; bi <= 10; bi++) {
						BigInteger temp = convertToInt(check.toString(2), bi);
						res = fetchMinFactor(temp);
						if (res == null) {
							continue outer;
						}
						result.append(" " + res);
					}
					System.out.println(result);
					counter++;
					if (counter == limit) {
						break;
					}
				}
			}
		}

	}

	public static BigInteger fetchMinFactor(BigInteger check) {
		if (check.mod(TWO).equals(BigInteger.ZERO)) {
			return TWO;
		}
		if (check.mod(THREE).equals(BigInteger.ZERO)) {
			return THREE;
		}
		BigInteger counter = BigInteger.ONE;
		BigInteger temp = null, a = null, b = null;
		BigInteger limit = sqrt(check);
		for (;;) {
			temp = SIX.multiply(counter);
			if (temp.compareTo(limit) == 1) {
				break;
			}
			a = temp.subtract(BigInteger.ONE);
			b = temp.add(BigInteger.ONE);
			if (check.mod(a).equals(BigInteger.ZERO)) {
				return a;
			}
			if (check.mod(b).equals(BigInteger.ZERO)) {
				return b;
			}
			counter = counter.add(BigInteger.ONE);
		}
		return null;
	}

	public static BigInteger sqrt(BigInteger n) {
		BigInteger a = BigInteger.ONE;
		BigInteger b = n.shiftRight(1).add(new BigInteger("2")); // (n >> 1) + 2
																	// (ensure 0
																	// doesn't
																	// show up)
		while (b.compareTo(a) >= 0) {
			BigInteger mid = a.add(b).shiftRight(1); // (a+b) >> 1
			if (mid.multiply(mid).compareTo(n) > 0)
				b = mid.subtract(BigInteger.ONE);
			else
				a = mid.add(BigInteger.ONE);
		}
		return a.subtract(BigInteger.ONE);
	}

	public static boolean isProbablePrime(BigInteger check) {
		BigInteger temp = check.mod(SIX);
		if (temp.equals(BigInteger.ONE) || temp.equals(FIVE)) {
			return true;
		}
		return false;
	}

	private static BigInteger convertToInt(String pattern, int base) {
		int size = pattern.length();
		int sizeIndex = size;
		BigInteger result = BigInteger.ZERO;
		for (int i = 0; i < size; i++) {
			sizeIndex--;
			result = result.add(new BigInteger(pattern.charAt(i) == '0' ? "0"
					: ((Double) (Math.pow(base, sizeIndex))).intValue() + ""));
		}
		return result;
	}

	static void sieve() {
		int limit = Integer.MAX_VALUE;
		BitSet bs = new BitSet(limit);

		for (int i = 2; i < limit; i++) {
			if (bs.get(i - 1)) {
				continue;
			}
			System.out.println(i);
			for (int j = i + 1; j < limit; j++) {
				if (!bs.get(j - 1) && j % i == 0) {
					bs.set(j - 1, true);
				}
			}
		}
		System.out.println(bs);
	}

}
