package jam;

import java.util.Scanner;

public class PanCake {

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		next: for (int i = 0; i < n; i++) {
			String input = sc.next();
			int flipperSize = sc.nextInt();

			int currentHeur = 0;
			int moves = -1;
			if (!input.contains("-")) {
				System.out.println("Case #" + (i + 1) + ": 0");
				continue next;
			}

			int prevBestIndex = Integer.MAX_VALUE;
			while (true) {
				currentHeur = calcHeur(input, flipperSize);
				int bestIndex = -1;
				int checkEndIndex = input.length() - flipperSize;
				for (int j = 0; j <= checkEndIndex; j++) {
					if (!input.substring(j, j + flipperSize).contains("-")) {
						continue;
					}
					int newHeur = calcHeur(makeMove(input, j, flipperSize), flipperSize);
					if (newHeur > currentHeur) {
						bestIndex = j;
						currentHeur = newHeur;
					}
				}
				if (bestIndex != -1) {
					if (prevBestIndex == bestIndex) {
						System.out.println("Case #" + (i + 1) + ": " + "IMPOSSIBLE");
						continue next;
					} else {
						prevBestIndex = bestIndex;
					}
					moves++;
					input = makeMove(input, bestIndex, flipperSize);
					// System.out.println(bestIndex + " ~ " + input);
				} else {
					if (moves == -1 || input.contains("-")) {
						System.out.println("Case #" + (i + 1) + ": " + "IMPOSSIBLE");
					} else {
						System.out.println("Case #" + (i + 1) + ": " + (moves + 1));
					}
					continue next;
				}
			}
		}

	}

	private static String makeMove(String input, int startIndex, int flipperSize) {
		StringBuilder sb = new StringBuilder(input);
		int endIndex = startIndex + flipperSize - 1;
		for (int i = startIndex; i <= endIndex; i++) {
			switch (sb.charAt(i)) {
			case '-':
				sb.setCharAt(i, '+');
				break;
			case '+':
				sb.setCharAt(i, '-');
				break;
			}
		}
		return sb.toString();
	}

	private static int calcHeur(String input, int flipperSize) {
		int startIndex = 0, endIndex = input.length() - 1;
		int heur = 0;
		int continuousBlank = 0;
		for (int i = startIndex; i <= endIndex; i++) {
			switch (input.charAt(i)) {
			case '-':
				heur--;
				continuousBlank++;
				break;
			case '+':
				heur += 1;
				if (continuousBlank >= flipperSize) {
					heur += continuousBlank;
				}
				continuousBlank = 0;
				break;
			}
		}
		if (continuousBlank >= flipperSize) {
			heur += continuousBlank;
		}
		return heur;
	}

}
