/*
Google codejam problem 1.
Needs jdk1.4.2+.
Uses default system encoding to read input file
*/

import java.util.*;
import java.io.*;

public class SearchSwitch
{
	public static void main(String [] args)
	{
		if (args.length != 2)
		{
			System.out.println("USAGE: java SearchSwitch <inputFile> <outputFile>");
			return;
		}
		FileInputStream fis = null;
		FileOutputStream fos = null;
		try
		{
			fis = new FileInputStream(args[0]);
		}
		catch (Exception ex)
		{
			System.out.println("Unable to open file: " + args[0] + ". " + ex.getMessage());
			return;
		}
		try
		{
			fos = new FileOutputStream(args[1]);
		}
		catch (Exception ex)
		{
			System.out.println("Unable to open file: " + args[1] + ". " + ex.getMessage());
			return;
		}

		try
		{
			SearchSwitch sswitch = new SearchSwitch();
			sswitch.countSwitches(new LineNumberReader(new InputStreamReader(fis)), new PrintStream(fos));
			fis.close();
			fos.close();
		}
		catch (Exception ex)
		{
			System.out.println("Error: " + ex.getMessage());
			ex.printStackTrace();
		}
	}

	public SearchSwitch ()
	{
	}

	public void countSwitches(LineNumberReader lnr, PrintStream out) throws Exception
	{
		int testcases = Integer.parseInt(lnr.readLine().trim());
		for (int i = 0; i < testcases; )
		{
			HashSet S = new HashSet();
			ArrayList Q = new ArrayList();
			int s = Integer.parseInt(lnr.readLine().trim());
			for (int j = 0; j < s; j++)
			{
				S.add(lnr.readLine().trim());
			}
			int q = Integer.parseInt(lnr.readLine().trim());
			for (int j = 0; j < q; j++)
			{
				Q.add(lnr.readLine().trim());
			}
			int count = countSwitches(S, Q);
			out.print("Case #" + ++i + ": " + count);
			if (i < testcases)
			{
				out.println("");
			}
			//System.out.println("Case #" + i + ": " + count);
		}
	}

	private int countSwitches(HashSet engines, ArrayList queries)
	{
		int count = 0;
		HashSet temp = new HashSet();
		temp.addAll(engines);
		for (int i = 0; i < queries.size(); i++)
		{
			Object obj = queries.get(i);
			temp.remove(obj);
			if (temp.size() == 0)
			{
				count++;
				temp.addAll(engines);
				temp.remove(obj);
			}
		}
		//System.out.println("unused engines: " + temp + ", returning: " + count);
		return count;
	}
}