/*
Google codejam problem 2.
Needs jdk1.4.2+.
Uses default system encoding to read input file
*/

import java.util.*;
import java.io.*;

public class TimeTable
{
	public static void main(String [] args)
	{
		if (args.length != 2)
		{
			System.out.println("USAGE: java SearchSwitch <inputFile> <outputFile>");
			return;
		}
		FileInputStream fis = null;
		FileOutputStream fos = null;
		try
		{
			fis = new FileInputStream(args[0]);
		}
		catch (Exception ex)
		{
			System.out.println("Unable to open file: " + args[0] + ". " + ex.getMessage());
			return;
		}
		try
		{
			fos = new FileOutputStream(args[1]);
		}
		catch (Exception ex)
		{
			System.out.println("Unable to open file: " + args[1] + ". " + ex.getMessage());
			return;
		}

		try
		{
			TimeTable ttable = new TimeTable();
			ttable.countTrains(new LineNumberReader(new InputStreamReader(fis)), new PrintStream(fos));
			fis.close();
			fos.close();
		}
		catch (Exception ex)
		{
			System.out.println("Error: " + ex.getMessage());
			ex.printStackTrace();
		}
	}

	public TimeTable()
	{
	}

	public void countTrains(LineNumberReader lnr, PrintStream out) throws Exception
	{
		int testcases = Integer.parseInt(lnr.readLine().trim());
		for (int i = 0; i < testcases; )
		{
			int ttime = Integer.parseInt(lnr.readLine().trim());
			String ntrains = lnr.readLine().trim();
			StringTokenizer stn = new StringTokenizer(ntrains, " ");
			int NA = Integer.parseInt(stn.nextToken());
			int NB = Integer.parseInt(stn.nextToken());
			ArrayList A_arrivals = new ArrayList();
			ArrayList A_departures = new ArrayList();
			ArrayList B_arrivals = new ArrayList();
			ArrayList B_departures = new ArrayList();
			for (int j = 0; j < NA; j++)
			{
				String ln = lnr.readLine();
				StringTokenizer st = new StringTokenizer(ln, " ");
				int departtime = getIntTime(st.nextToken());
				int arrivetime = getIntTime(st.nextToken());
				insert(A_departures, departtime);
				insert(B_arrivals, arrivetime);
			}
			for (int j = 0; j < NB; j++)
			{
				String ln = lnr.readLine();
				StringTokenizer st = new StringTokenizer(ln, " ");
				int departtime = getIntTime(st.nextToken());
				int arrivetime = getIntTime(st.nextToken());
				insert(B_departures, departtime);
				insert(A_arrivals, arrivetime);
			}
			int trainsfromA = countTrains(ttime, A_arrivals, A_departures);
			int trainsfromB = countTrains(ttime, B_arrivals, B_departures);
			out.print("Case #" + ++i + ": " + trainsfromA + " " + trainsfromB);
			if (i < testcases)
			{
				out.println("");
			}
			//System.out.println("Case #" + i + ": " + trainsfromA + " " + trainsfromB);
		}
	}

	private int countTrains(int turntime, ArrayList arrivals, ArrayList departures)
	{
		int ret = 0;
		for (int i = 0; i < departures.size(); i++)
		{
			int td = ((Integer) departures.get(i)).intValue();

			if (arrivals.size() > 0)
			{
				int ta = ((Integer) arrivals.get(0)).intValue();
				if (ta + turntime <= td)
				{
					arrivals.remove(0);
				}
				else
				{
					ret++;
				}
			}
			else
			{
				ret++;
			}
		}

		return ret;
	}

	private int getIntTime(String tstring)
	{
		int ret = Integer.parseInt(tstring.substring(0, tstring.indexOf(":"))) * 60;
		ret += Integer.parseInt(tstring.substring(tstring.indexOf(":") + 1, tstring.length()));
		return ret;
	}

	private void insert(ArrayList list, int value)
	{
		for (int i = 0; i < list.size(); i++)
		{
			int k = ((Integer) list.get(i)).intValue();
			if (value <= k)
			{
				list.add(i, new Integer(value));
				return;
			}
		}
		list.add(new Integer(value));
	}
}