/*
Google codejam Round 1A problem 2.
Needs jdk1.5.0+.
Uses default system encoding to read input file
*/

import java.util.*;
import java.io.*;


public class SpeedLimit
{
	public static void main(String [] args)
	{
		if (args.length != 2)
		{
			System.out.println("USAGE: java CropTriangles <inputFile> <outputFile>");
			return;
		}
		FileInputStream fis = null;
		FileOutputStream fos = null;
		try
		{
			fis = new FileInputStream(args[0]);
		}
		catch (Exception ex)
		{
			System.out.println("Unable to open file: " + args[0] + ". " + ex.getMessage());
			return;
		}
		try
		{
			fos = new FileOutputStream(args[1]);
		}
		catch (Exception ex)
		{
			System.out.println("Unable to open file: " + args[1] + ". " + ex.getMessage());
			return;
		}

		try
		{
			SpeedLimit speed = new SpeedLimit();
			speed.count(new LineNumberReader(new InputStreamReader(fis)), new PrintStream(fos));
			fis.close();
			fos.close();
		}
		catch (Exception ex)
		{
			System.out.println("Error: " + ex.getMessage());
			ex.printStackTrace();
		}
	}

	public void count(LineNumberReader lnr, PrintStream out) throws Exception
	{
		int tcs = Integer.parseInt(lnr.readLine().trim());
		for (int tc = 0; tc < tcs; )
		{
			String ln = lnr.readLine();
			StringTokenizer st = new StringTokenizer(ln, " ");
			int n = Integer.parseInt(st.nextToken());
			int m = Integer.parseInt(st.nextToken());
			int X = Integer.parseInt(st.nextToken());
			int Y = Integer.parseInt(st.nextToken());
			int Z = Integer.parseInt(st.nextToken());
			int [] A = new int [m];
			for (int i = 0; i < m; i++)
			{
				A[i] = Integer.parseInt(lnr.readLine());
			}
			int [] spds = gen(n, m, A, X, Y, Z);
			long count [] = new long [n];
			count [0] = 1;
			long tcount = 1;
			for (int i = 1; i < n; i++)
			{
				count[i] = 1;
				for (int j = 0; j < i; j++)
				{
					if (spds[i] > spds[j])
					{
						count[i] = (count[i] + count[j])%1000000007;
					}
				}
				tcount = (tcount + count[i])%1000000007;
				//System.out.println(i + ": " + count[i] + ", " + tcount);
			}
			out.print("Case #" + ++tc + ": " + tcount);
			if (tc < tcs)
			{
				out.println("");
			}
			//System.out.println("Case #" + tc + ": " + tcount);
		}
	}

	public int [] gen(int n, int m, int [] A, int X, int Y, int Z)
	{
		int [] ret = new int [n];
		for (int i = 0; i < n; i++)
		{
			ret [i] = A[i % m];
			long t1 = ((long) X) * A[i % m];
			t1 += ((long) Y) * (i + 1);
			A[i % m] = (int) (t1 % Z);
		}
		return ret;
	}
}