import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.RandomAccessFile;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.util.ArrayList;
import java.util.List;
import java.util.TreeSet;

public class BathroomStall {

	class Sorter implements Comparable {
		public long left;
		public long right;
		public long index;
		public boolean isFilled = false;
		
		
		public Sorter(long left, long right, long index) {
			super();
			this.left = left;
			this.right = right;
			this.index = index;
		}
		
		

		@Override
		public String toString() {
			return "Sorter [left=" + left + ", right=" + right + ", index=" + index + ", isFilled=" + isFilled + "]";
		}



		public void update(long k ) {
			if(k>index) {
				if(k - index <= right) {
					right = k-index -1;
				}
			}else if( k< index) {
				if(index -k <= left) {
					left = index - k  -1;
				}
			} else {
				isFilled = true;
				left = Long.MAX_VALUE;
				right = Long.MAX_VALUE;
			}
		}
		
		@Override
		public int compareTo(Object o) {
			// TODO Auto-generated method stub
			Sorter other = (Sorter)o;
			int result1 = new Long(Math.min(left, right)).compareTo(Math.min(other.left, other.right));
			if(result1 != 0) 
				return result1;
			int result2 = new Long(Math.max(left, right)).compareTo(Math.max(other.left, other.right));
			if(result2 != 0) 
				return result2;
			return new Long(other.index).compareTo(index);
		}
		
	}
	
	

	public Sorter bathroom (long n, long k) {
		TreeSet<Sorter> sorters = new TreeSet<>();
		for(long i=0; i < n; i++) {
			sorters.add(new Sorter(i, n-i -1, i));
		}
		Sorter topS = null;
		for(long i=0 ; i<k;i++) {

			topS = sorters.pollLast();
			//System.out.println(topS);
			TreeSet<Sorter> temp = new TreeSet<>();
			for(Sorter s: sorters) {
				//System.out.println("Before : " + s);
				s.update(topS.index);
				//System.out.println("After : " + s);
				temp.add(s);
			}
			sorters = temp;

		}

		return topS;
	}
	
	public static void main(String[] args) throws Exception {
		List<String> lines = readFile("/Users/debarghy/Downloads/C-small-1-attempt2.in");
		//List<String> lines = readFile("/Users/debarghy/Downloads/test.txt");
		lines.remove(0);
		for(int i=0; i< lines.size() ; i++) {
			long n = Long.parseLong(lines.get(i).split(" ")[0]);
			long k = Long.parseLong(lines.get(i).split(" ")[1]);
			Sorter ans = new BathroomStall().bathroom(n, k);
			System.out.println("Case #" + new Integer(i+1)+ ": "+ Math.max(ans.left, ans.right) + " " + Math.min(ans.left, ans.right));

		}
	}
	
	
	public static List<String> readFile(String path) throws Exception {
        List<String> lines = new ArrayList<>();
        File f = new File(path);

        BufferedReader b = new BufferedReader(new FileReader(f));

        String readLine = "";


        while ((readLine = b.readLine()) != null) {
        	lines.add(readLine);
        }
        return lines;
	}
	
}



//
