import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

public class GCJBase {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		

	}
	
	public static void processingTime(long startTime,long endTime) {
		System.out.println("Processing time :" + (endTime - startTime)  + " ms.");
		System.out.println("Processing time :" + ((endTime - startTime) / 60000) + " min.");
	}

	/**
	 * To process input file parameters.
	 * 
	 * @param fileName
	 * @return
	 */
	public static String[] processInputParameters(String fileName) {
		List<String> parameters = new ArrayList<String>();
		BufferedReader br = null;
		long startTime = System.currentTimeMillis();
		try {
			br = new BufferedReader(new FileReader(fileName));

			String eachLine = br.readLine();
			parameters.add(eachLine);

			while (eachLine != null) {
				eachLine = br.readLine();
				parameters.add(eachLine);
			}
		} catch (IOException ie) {
			ie.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
				br = null;
			}
		}

		System.out.println("File processing time : "
				+ (System.currentTimeMillis() - startTime));
		return parameters.toArray(new String[0]);

	}

	/**
	 * @param value string to be converted in integer.
	 * @return integer value.
	 */
	public static int convertToInt(String value) {
		int convertedValue = Integer.MIN_VALUE;
		try {
			convertedValue = Integer.parseInt(value);
		} catch (NumberFormatException nfe) {

		}
		return convertedValue;
	}
	
	/**
	 * Converts a string array into integer array.
	 * @param array string 
	 * @return integer array
	 */
	public static int[] convertStringToIntArray(String[] array){
		int[] result = new int[array.length];
		for (int i = 0; i < array.length; i++)  {
			result[i] = convertToInt(array[i]);
		}
		return result;
	}
	
	/**
	 * @param result
	 * @param fileName
	 */
	public static void processResult(String[] result,String fileName) {
		PrintWriter pw = null;
		fileName = fileName.replace(".in", ".out");
		try {
			pw = new PrintWriter(new File(fileName));
			for (int i = 0; i < result.length; i++) {
				pw.println("Case #"+(i+1)+": "+result[i]);
			}
		} catch (IOException e) {
			e.printStackTrace();
		}finally {
			if (pw != null) {
				pw.close();
				pw = null;
			}
		}
		
	}
	
	/**
	 * @param result
	 * @param fileName
	 */
	public static void processResult(String[][] result,String fileName) {
		PrintWriter pw = null;
		fileName = fileName.replace(".in", ".out");
		try {
			pw = new PrintWriter(new File(fileName));
			for (int i = 0; i < result.length; i++) {
				pw.println("Case #"+(i+1)+":");
				for (int j = 0; j < result[i].length;j++) {
					pw.println(result[i][j]);
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		}finally {
			if (pw != null) {
				pw.close();
				pw = null;
			}
		}
		
	}
}
