import static org.junit.Assert.*;
import junit.framework.Assert;
import gcj.util.GCJUtil;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;


public class ThemeParkTest {
	
	private static final String LOCATION = "./input";
	private static final String INPUT_FILE = "C-small-attempt1.in";
	private static int noOfTestCases;
	private static int[] runs;
	private static int[] people;
	private static int[][] groups;
	private static ThemePark rollerCoster = new ThemePark();

	@Before
	public void setUp() throws Exception {
		String[] inputs = GCJUtil.getInputParameter(LOCATION , INPUT_FILE);
		noOfTestCases = Integer.parseInt(inputs[0]);
		
		runs = new int[noOfTestCases];
		people = new int[noOfTestCases];
		groups = new int[noOfTestCases][];
		
		int index = 0;
		for (int i = 1; i < inputs.length; i++) {
			inputs[i] = inputs[i].replaceAll(" ", ",");
			String[] eachInput = inputs[i].split(",");
			if (i % 2 == 1) {
//				first line of test case
				int[] firstLine = getIntArr(eachInput);
				runs[index] = firstLine[0];
				people[index] = firstLine[1];
				groups[index] = new int[firstLine[2]];
			} else {
//				second line of test case
				int[] secondLine = getIntArr(eachInput);
				for(int j = 0; j < secondLine.length; j++) {
					groups[index][j] = secondLine[j];
				}
				index++;
			}
		}
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testGetProfit() {
		String[] results = new String[noOfTestCases];
		for (int i = 0; i < noOfTestCases; i++) {
			results[i] = String.valueOf(rollerCoster.getProfit(runs[i], people[i], groups[i]));
		}
		GCJUtil.storeResults(results);
	}

	private int[] getIntArr(String[] input) {
		int[] result = new int[input.length];
		for(int i = 0; i < input.length; i++) {
			result[i] = Integer.parseInt(input[i]);
		}
		return result;
	}
}
