import java.util.LinkedList;
import java.util.Queue;

/**
 * 
 */

/**
 * @author debmalya.jash
 * 
 */
public class ThemePark {
	private Queue<Integer> queue = new LinkedList<Integer>();

	/**
	 * Find out the profit earned by the roller coaster. Some people go alone;
	 * other people go in groups, and don't want to board the roller coaster
	 * unless they can all go together. A ride costs 1 Euro per person.
	 * 
	 * The roller coaster can hold k people at once. People queue for it in
	 * groups. Groups board the roller coaster, one at a time, until there are
	 * no more groups left or there is no room for the next group; then the
	 * roller coaster goes, whether it's full or not. Once the ride is over, all
	 * of its passengers re-queue in the same order. The roller coaster will run
	 * R times in a day.
	 * 
	 * @param noOfRuns
	 *            no of time coaster will run.
	 * @param noOfPeople
	 *            no of people it can hold.
	 * @param groups
	 *            each element is no of members in the group.
	 * @return amount of profit from the run.
	 */
	public int getProfit(int noOfRuns, int noOfPeople, int[] groups) {
		int profit = 0;
		int runCounter = 0;
		queue = new LinkedList<Integer>();
		for(int i = 0; i < groups.length; i++) {
			queue.add(groups[i]);
		}
		
		while (runCounter < noOfRuns) {
			profit += arrangeQueue(noOfPeople);
			runCounter++;
		}
		return profit;
	}

	private int arrangeQueue(int noOfPeople) {
		int total = 0;
		int swap = 0;
		int counter = 0;
		// from the queue get the no of people so that total people will be less
		// than or equal to noOfPeople.
		while (total < noOfPeople) {
			swap = queue.peek();
			if (total + swap <= noOfPeople) {
				queue.poll();
				queue.add(swap);
				total += swap;
			} else {
				break;
			}
			counter++;
			if (counter == queue.size()) {
				break;
			}
		}
		return total;
	}
}
