import java.util.Arrays;

public class MinesweeperMaster extends GCJBase {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if (args != null && args.length > 0) {
			long startTime = System.currentTimeMillis();
			String[] parameters = processInputParameters(args[0]);
			String[][] result = getResult(parameters);
			processResult(result, args[0]);
			processingTime(startTime, System.currentTimeMillis());

		}

	}

	private static String[][] getResult(String[] parameters) {
		String[][] result = new String[Integer.parseInt(parameters[0])][];

		for (int i = 1; i < parameters.length; i++) {
			if (parameters[i] == null) {
				break;
			}
			String[] each = parameters[i].split(" ");

			int r = Integer.parseInt(each[0]);
			int c = Integer.parseInt(each[1]);
			int m = Integer.parseInt(each[2]);

			char[] fullOfMines = new char[c];
			Arrays.fill(fullOfMines, '*');

			if (m > Math.abs(((r * c) - (r + 2))) && r * c - m != 1) {
				result[i - 1] = new String[] { "Impossible" };
			} else {

				int mCount = 0;
				result[i - 1] = new String[r];
				for (int j = 0; j < r; j++) {

					if (mCount < m) {
						int remainingMines = m - mCount;
						if (remainingMines >= c) {
							result[i - 1][j] = String.valueOf(fullOfMines);
							mCount += c;
						} else {
							char[] partialMines = new char[remainingMines];
							Arrays.fill(partialMines, '*');

							char[] remaining = new char[c - remainingMines];
							Arrays.fill(remaining, '.');

							result[i - 1][j] = String.valueOf(partialMines)
									+ String.valueOf(remaining);
							mCount = m;
							
							if (r * c - m == 1) {
								char[] withoutMines = new char[c - 1];
								Arrays.fill(withoutMines, '*');

								result[i - 1][j] = String.valueOf(withoutMines)+"c";
							}
						}
					} else {
						if (j == r - 1) {
							char[] withoutMines = new char[c - 1];
							Arrays.fill(withoutMines, '.');

							result[i - 1][j] = String.valueOf(withoutMines)+"c";
						} else {
							char[] withoutMines = new char[c];
							Arrays.fill(withoutMines, '.');

							result[i - 1][j] = String.valueOf(withoutMines);
						}
					}
				}

			}
		}

		return result;
	}

}
