import static org.junit.Assert.*;
import junit.framework.Assert;
import gcj.util.GCJUtil;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;


public class SnapperChainTest {
	
	private static final String LOCATION = "./input";
	private static final String INPUT_FILE = "A-small-attempt0.in";
	private static int noOfTestCases;
	private static int[] devices;
	private static int[] toggles;
	private static SnapperChain snapper = new SnapperChain();
	
	@Before
	public void setUp() throws Exception {
		String[] inputs = GCJUtil.getInputParameter(LOCATION , INPUT_FILE);
		noOfTestCases = Integer.parseInt(inputs[0]);
		
		devices = new int[noOfTestCases];
		toggles = new int[noOfTestCases];
		
		for(int i = 1;i < inputs.length; i++) {
			devices[i - 1] = Integer.parseInt(inputs[i].substring(0,inputs[i].indexOf(" ")));
			toggles[i - 1] = Integer.parseInt(inputs[i].substring(inputs[i].indexOf(" ") + 1));
		}
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testGetState() {
		String results[] = snapper.getFinalState(devices, toggles);
		Assert.assertNotNull(results);
		Assert.assertTrue(results.length == noOfTestCases);
		GCJUtil.storeResults(results);
	}

//	@Test
	public void testUnit() {
		String results[] = null;
		
		devices = new int[] {2};
		toggles = new int[] {1};
		System.out.println("\nN = 2, K =1");
		results = snapper.getFinalState(devices, toggles);
		Assert.assertTrue("OFF".equals(results[0]));
		
		devices = new int[] {2};
		toggles = new int[] {2};
		System.out.println("\nN = 2, K =2");
		results = snapper.getFinalState(devices, toggles);
		Assert.assertTrue("OFF".equals(results[0]));
		
		devices = new int[] {2};
		toggles = new int[] {3};
		System.out.println("\nN = 2, K =3");
		results = snapper.getFinalState(devices, toggles);
		Assert.assertTrue("ON".equals(results[0]));
		
		devices = new int[] {1};
		toggles = new int[] {0};
		System.out.println("\nN = 1, K =0");
		results = snapper.getFinalState(devices, toggles);
		Assert.assertTrue("OFF".equals(results[0]));
		
		devices = new int[] {1};
		toggles = new int[] {1};
		System.out.println("\nN = 1, K =1");
		results = snapper.getFinalState(devices, toggles);
		Assert.assertTrue("ON".equals(results[0]));
		
		devices = new int[] {4};
		toggles = new int[] {47};
		System.out.println("\nN = 4, K =47");
		results = snapper.getFinalState(devices, toggles);
		Assert.assertTrue("ON".equals(results[0]));
		
//		devices = new int[] {30};
//		toggles = new int[] {108};
//		System.out.println("N = 30, K =108");
//		results = snapper.getFinalState(devices, toggles);
//		System.out.println("Result =" + results[0]);
//		Assert.assertTrue("ON".equals(results[0]));
//		
//		devices = new int[] {30};
//		toggles = new int[] {109};
//		System.out.println("\nN = 30, K =109");
//		results = snapper.getFinalState(devices, toggles);
//		Assert.assertTrue("ON".equals(results[0]));
	}
}
