package qualificationRound2016;

import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import utility.FileIO;

public class Coin_Jam {

	private static final char[] binary = new char[]{'0', '1'};
	private static final long UPPER = 100000000L;
	private static Set<Integer> known = null;
	
	public static void main(String[] args) {
		
		try {
			String filename = "C-small-attempt0.in";
			String content = FileIO.readFile(filename);
			String[] contentLines = content.split("\n");
			int numTests = Integer.parseInt( contentLines[0] );
			StringBuilder result = new StringBuilder();
			int count = 1;
			while(count <= numTests) {
				String[] values = contentLines[count].split(" ");
				int sizeOfBinaryNumber = Integer.parseInt(values[0].trim());
				int numberOfLines = Integer.parseInt(values[1].trim());
				
				List<String> newList = new ArrayList<String>();
				getResults(sizeOfBinaryNumber, newList, numberOfLines);
				
				result.append("Case #" + count + ": \n");
				for(String line: newList) {
					result.append(line);
					result.append("\n");
				}
				count++;
			}
			FileIO.writeFile("out" + filename, result.toString());
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}
	
	private static void getResults(int sizeOfBinaryNumber, List<String> list, int numberOfLines) {
		Set<String> set = new HashSet<String>();
		getAllKLength(sizeOfBinaryNumber-2, set);
		
		Set<String> validSet = new HashSet<String>();
		for(String st: set) 
			validSet.add("1" + st + "1");
		
		set = validSet;
		
		for(String st: set) {
			boolean isPrime = false;
			// prime does not depend on base, since base is just a way
			// of representing the number, and prime is a property of the
			// number, not its base
			for(int i = 2 ; i <= 10 ; i++) {
				BigInteger number = new BigInteger(st, i);
					
				// is the number prime?
				if(known.contains(number.intValue())) 
					isPrime = true;
			}
			
			// binary number can be considered a jamcoin
			// time to get divisors
			if(!isPrime) {
				StringBuilder resString = new StringBuilder(st); resString.append(" ");
				for(int i = 2 ; i <= 10 ; i++) {
					BigInteger number = new BigInteger(st, i);
					BigInteger divisor = getDivisor(number);
					resString.append(divisor); resString.append(" ");
				}
				list.add(resString.toString().trim());
			}
			
			if(list.size() == numberOfLines) return;
			
			
		}
	}
	
	
	private static BigInteger getDivisor(BigInteger number) {
		BigInteger sqrt = sqrt(number);
		
		for(BigInteger i = BigInteger.valueOf(2) ; i.compareTo(sqrt) <= 0 ; i = i.add(BigInteger.ONE)) {
			// perfectly divides => modulo = 0
			if(number.mod(i).equals(BigInteger.ZERO))
				return i;
		}
		
		return BigInteger.ZERO;
	}
	
	private static BigInteger sqrt(BigInteger n) {
	    BigInteger a = BigInteger.ONE;
	    BigInteger b = n.shiftRight(1).add(new BigInteger("2")); // (n >> 1) + 2 (ensure 0 doesn't show up)
	    while (b.compareTo(a) >= 0) {
	        BigInteger mid = a.add(b).shiftRight(1); // (a+b) >> 1
	        if (mid.multiply(mid).compareTo(n) > 0)
	            b = mid.subtract(BigInteger.ONE);
	        else
	            a = mid.add(BigInteger.ONE);
	    }
	    return a.subtract(BigInteger.ONE);
	}

	// The method that prints all possible strings of length k.  It is
    //  mainly a wrapper over recursive function getAllKLengthRec()
    private static void getAllKLength(int k, Set<String> set) {
        int n = binary.length;        
        getAllKLengthRec("", n, k, set);
    }
 
    // The main recursive method to print all possible strings of length k
    private static void getAllKLengthRec(String prefix, int n, int k, Set<String> set) {
         
        // Base case: k is 0, print prefix
        if (k == 0) {
            set.add(prefix);
            return;
        }
 
        // One by one add all characters from set and recursively 
        // call for k equals to k-1
        for (int i = 0; i < n; ++i) {
             
            // Next character of input added
            String newPrefix = prefix + binary[i]; 
             
            // k is decreased, because we have added a new character
            getAllKLengthRec(newPrefix, n, k - 1, set); 
        }
    }
    
    static {
		// REF: http://stackoverflow.com/questions/2068372/fastest-way-to-list-all-primes-below-n-in-python/3035188#3035188
		known = new HashSet<Integer>();
		long n = UPPER;
		boolean correction = (n % 6) > 1;
		
//		// closest number to calculate primes till
//		switch(n%6) {
//			case 0:
//				break;
//			case 1:
//				n = n-1;
//				break;
//			case 2:
//				n = n+4;
//				break;
//			case 3:
//				n = n+3;
//				break;
//			case 4:
//				n = n+2;
//				break;
//			case 5:
//				n = n+1;
//				break;
//		}
		
		long mod6 = n % 6;
		
		if(mod6 == 1) 
			n = n - 1;
		else if (mod6 == 2)
			n = n + 4;
		else if (mod6 == 3)
			n = n + 3;
		else if (mod6 == 4)
			n = n + 2;
		else if (mod6 == 5)
			n = n + 1;
		
		
//		boolean[] sieve = new boolean[n/3];
		List<Boolean> sieve = new ArrayList<Boolean>();
		sieve.add(false);
		for(long i = 1 ; i < n/3 ; i++)
			sieve.add(true);
		
		for(int i = 0 ; i < (int)(Math.abs(Math.sqrt(n)) + 1) ; i++) {
			if(sieve.get(i)) {
				int k = (3*i + 1) | 1;
				
				// sieve[      ((k*k)/3)      ::2*k]=[False]*((n/6-(k*k)/6-1)/k+1)
				int offset = (k*k)/3;
				int stride = 2*k;
				for(int indx = offset ; indx < sieve.size() ; indx+=stride)
					sieve.set(indx, false);
				
				// sieve[(k*k+4*k-2*k*(i&1))/3::2*k]=[False]*((n/6-(k*k+4*k-2*k*(i&1))/6-1)/k+1)
				offset = (k * k + 4 * k - 2 * k * (i & 1) ) / 3;
				for(int indx = offset ; indx < sieve.size() ; indx+=stride)
					sieve.set(indx, false);
			}
		}
		
		known.add( 2 );
		known.add( 3 );
		for(int i = 0 ; i < n/3 - (correction ? 1: 0) ; i++) 
			if(sieve.get(i))
				known.add(  (3*i + 1) | 1  );
		
	}
}
