package roy.debraj.codejam.routingsearchengines;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.SortedMap;
import java.util.TreeMap;

public class SearchEngineRouter {
	private int minSwitchCount = Integer.MAX_VALUE;
	List<String> searchEngines = new ArrayList<String>();
	List<String> inputQueries = new ArrayList<String>();
	
//	Map<String, string>
	Map<String, SortedMap<Integer, Integer>> searchEngineSwitchPoints = new HashMap<String, SortedMap<Integer,Integer>>(); 
	
	public void execute(String inputFileName, String outputFileName) throws IOException{
		BufferedReader input = new BufferedReader(new FileReader(inputFileName));
		BufferedWriter output = new BufferedWriter(new FileWriter(outputFileName));
		
		int N = Integer.parseInt(input.readLine());
		for(int indexInput=0;indexInput<N;indexInput++){
			reset();
			int S = Integer.parseInt(input.readLine());
			for(int indexSEs =0;indexSEs<S;indexSEs++){
				searchEngines.add(input.readLine());
			}
			int Q = Integer.parseInt(input.readLine());
			for(int indexQueries =0;indexQueries < Q;indexQueries++){
				inputQueries.add(input.readLine());
			}
			for(int i=0;i<S;i++){
				
				String searchEngine = searchEngines.get(i);
				searchEngineSwitchPoints.put(searchEngine, new TreeMap<Integer, Integer>());
				for(int j=0;j<Q;j++){
					if(searchEngine.equals(inputQueries.get(j))){
						searchEngineSwitchPoints.get(searchEngine).put(j, j);
					}
				}
				searchEngineSwitchPoints.get(searchEngine).put(Q, Q);
			}
			for(int i=0;i<searchEngines.size();i++){
				if((1==searchEngineSwitchPoints.get(searchEngines.get(i)).size()) && searchEngineSwitchPoints.get(searchEngines.get(i)).lastKey().equals(Q)){
					minSwitchCount=0;
				}
			}
			if(minSwitchCount>0){
				String maxSearchEngine = null;
				int indexInputQueries =0;
				int maxIndex = Integer.MIN_VALUE;
				for(int i=0;i<searchEngines.size();i++){
//					route(searchEngines.get(i),0,0);
					int currentMaxIndex = searchEngineSwitchPoints.get(searchEngines.get(i)).tailMap(0).firstKey();
					if(currentMaxIndex>maxIndex){
						maxSearchEngine = searchEngines.get(i);
						maxIndex=currentMaxIndex;
					}
				}
				route(maxSearchEngine, 1, maxIndex);
			}
			System.out.println(indexInput);
			output.write("Case #" + (indexInput + 1) + ": " + minSwitchCount);
			output.newLine();
			output.flush();
		} //end reading all Input
		output.close();
		input.close();
	}
	
	private void reset(){
		minSwitchCount = Integer.MAX_VALUE;
		searchEngines.clear();
		inputQueries.clear();
		searchEngineSwitchPoints.clear();
	}
	private void route(String searchEngine, int switchCount, int indexInputQueries){
		Set<String> otherSearchEnginesSet = new HashSet<String>(searchEngines);
		otherSearchEnginesSet.remove(searchEngine);
		List<String> otherEngines = new ArrayList<String>(otherSearchEnginesSet);
		
		String maxSearchEngine = null;
		int maxIndex = indexInputQueries;
		for(int i=0;i<otherEngines.size();i++){
//			route(searchEngines.get(i),0,0);
			int currentMaxIndex = searchEngineSwitchPoints.get(otherEngines.get(i)).tailMap(indexInputQueries).firstKey();
			if(currentMaxIndex>maxIndex){
				maxSearchEngine = otherEngines.get(i);
				maxIndex=currentMaxIndex;
			}
		}
//		SortedMap<Integer, Integer> searchEngineSP = searchEngineSwitchPoints.get(searchEngine).tailMap(indexInputQueries);
//		indexInputQueries = searchEngineSP.firstKey();
		indexInputQueries=maxIndex;
		if(indexInputQueries >= inputQueries.size()){
			if(switchCount<minSwitchCount)
				minSwitchCount=switchCount;
		return;	
		}
//		if(indexInputQueries > 0){
//			switchCount++;
//			if(switchCount >= minSwitchCount)
//				return;
//			for(int i=0;i<otherEngines.size();i++){
//				route(otherEngines.get(i), switchCount, indexInputQueries);
//			}
//		}
		switchCount++;
		route(maxSearchEngine,switchCount,indexInputQueries);
//		for()
	}
}
