import java.awt.List;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;


public class Problem2 {
public static void main(String[] args) throws NumberFormatException, IOException {
	BufferedReader br = new BufferedReader(new FileReader("B-large.in"));
	int numOfTestCases = Integer.valueOf(br.readLine()).intValue();
	
	BufferedWriter bw = new BufferedWriter(new FileWriter("B-large.out"));
	
	int M = 0;
	int N = 0;
	for(int i=0;i<numOfTestCases;i++)
	{
		String str = br.readLine();
		String [] strArr = str.split(" ");
		M = Integer.valueOf(strArr[0]).intValue();
		N = Integer.valueOf(strArr[1]).intValue();
		 Tile[][] tileArray = new Tile[M][N];
		 int[][] valueArr = new int[M][N];
		 int value = -1;
		 for(int j=0;j<M;j++)
		 {
			 str = br.readLine();
			 strArr = str.split(" ");
			 for(int k=0;k<N;k++)
			 {
				 value = Integer.valueOf(strArr[k]).intValue();
				 valueArr[j][k] = value;
				 Tile t = new Tile(k, value);
				 tileArray[j][k] = t;
			 }
		 }

		 //sorting tile array
		 for(int j=0;j<M;j++)
		 {
			 Arrays.sort(tileArray[j]);
		 }
		 
		 //logic
		 boolean possible = true;
		 for(int j=0;j<M;j++)
		 {
			 int min = tileArray[j][0].value;
			 int k=1;
			 for(;k<N && tileArray[j][k].value <= min;k++);
			 if(k==N)
			 {
				 continue;
			 }
			 
			for(k=0;k<N;k++)
			{
				int column = tileArray[j][k].column;
				int l=0;
				for(;l<M && valueArr[l][column]<=tileArray[j][k].value;l++);
				if(l<M)
				{
					possible=false;
					break;
				}
			}
			
			if(!possible)
			{
				break;
			}
		 }
		
		 StringBuffer outPutStrBuff = new StringBuffer();
		 outPutStrBuff.append("Case #").append(Integer.toString(i+1)).append(": ").append(possible?"YES":"NO");
		 bw.write(outPutStrBuff.toString());
		 if(i < (numOfTestCases-1))
		 {
			 bw.newLine();
		 }
		 
	}
	
	br.close();
	bw.flush();
	bw.close();
	
}

public static class Tile implements Comparable<Tile>
{
	int column;
	int value;
	public Tile(int column,int value)
	{
		this.column = column;
		this.value = value;
	}
	
	@Override
	public int compareTo(Tile o) {
		return this.value-o.value;
	}

}
}
