package roy.debraj.codejam.traintimetable;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;

public class TrainTimeTableMain {
public static void main(String[] args) throws IOException {
	BufferedReader input = new BufferedReader(new FileReader(args[0]));
	BufferedWriter output = new BufferedWriter(new FileWriter(args[1]));
	int N = Integer.parseInt(input.readLine());
	int T = 0;
	for(int inputIndex=0;inputIndex<N;inputIndex++){
		T = Integer.parseInt(input.readLine());
		
		String NA_NB_str = input.readLine();
		String [] NA_NB_Arr = NA_NB_str.split(" ");
		
		int NA = Integer.parseInt(NA_NB_Arr[0]);
		int NB = Integer.parseInt(NA_NB_Arr[1]);
		
		String [] stationATimeTable = new String[NA];
		String [] departureA = new String[NA];
		String [] arrivalB = new String[NA];
		
		for(int i=0;i<NA;i++){
			stationATimeTable[i]=input.readLine();
			String [] arr = stationATimeTable[i].split(" ");
			departureA[i] = arr[0];
			
			String arrivalTimeArr [] = arr[1].split(":");
			  int mins = Integer.parseInt(arrivalTimeArr[1]) + T;
			  int hr = (mins/60) + Integer.parseInt(arrivalTimeArr[0]);
			  String hrStr = null;
			  if((hr/10)==0){
				  hrStr = "0" + Integer.toString(hr);
			  }else{
				  hrStr = Integer.toString(hr);
			  }
			  int min = mins%60;
			  String minStr = null;
			  if((min/10)==0){
				  minStr = "0" + Integer.toString(min);
			  }else{
				  minStr = Integer.toString(min);
			  }
			  arrivalB[i] = hrStr +":" + minStr;
		}
		
		String [] stationBTimeTable = new String[NB];
		String [] departureB = new String[NB];
		String [] arrivalA = new String[NB];
		
		for(int i=0;i<NB;i++){
			stationBTimeTable[i]=input.readLine();
			String [] arr = stationBTimeTable[i].split(" ");
			departureB[i] = arr[0];
			
			String arrivalTimeArr [] = arr[1].split(":");
			  int mins = Integer.parseInt(arrivalTimeArr[1]) + T;
			  int hr = (mins/60) + Integer.parseInt(arrivalTimeArr[0]);
			  String hrStr = null;
			  if((hr/10)==0){
				  hrStr = "0" + Integer.toString(hr);
			  }else{
				  hrStr = Integer.toString(hr);
			  }
			  int min = mins%60;
			  String minStr = null;
			  if((min/10)==0){
				  minStr = "0" + Integer.toString(min);
			  }else{
				  minStr = Integer.toString(min);
			  }
			  arrivalA[i] = hrStr +":" + minStr;
		}
		
		//sort and merge departure A + arrival A
		int netPositiveA = calNumberofTrains(departureA, arrivalA);
		int netPositiveB = calNumberofTrains(departureB, arrivalB);
//		Arrays.sort(departureA);
//		Arrays.sort(arrivalA);
//		
//		int netPositiveA =0;
//		int negativeA =0;
//		int i=0;
//		for(int j=0;i<departureA.length && j<arrivalA.length;){
//			if(departureA[i].compareTo(departureB[j])<0){
//				if(negativeA>=0)
//					netPositiveA++;
//				else
//					negativeA++;
//				i++;
//			}else{
//				negativeA--;
//				j++;
//			}
//		}
//		for(;i<departureA.length;i++){
//			if(negativeA>=0)
//				netPositiveA++;
//			else
//				negativeA++;
//			i++;
//		}
//		
		output.write("Case #" + (inputIndex+1) +": " + netPositiveA + " " + netPositiveB);
		output.newLine();
		output.flush();
	}
	output.close();
	input.close();
}	
	private static int calNumberofTrains(String[] departure, String [] arrival){
		Arrays.sort(departure);
		Arrays.sort(arrival);
		
		int netPositive =0;
		int negative =0;
		int i=0;
		for(int j=0;i<departure.length && j<arrival.length;){
			if(departure[i].compareTo(arrival[j])<0){
				if(negative>=0)
					netPositive++;
				else
					negative++;
				i++;
			}else{
				negative--;
				j++;
			}
		}
		for(;i<departure.length;i++){
			if(negative>=0)
				netPositive++;
			else
				negative++;
		}
		return netPositive;
	}

}
