import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Problem1 {
public static void main(String[] args) throws NumberFormatException, IOException {
	char[][] chArr = new char[4][4];
	
	//reading input
	BufferedReader br = new BufferedReader(new FileReader("A-small-attempt0.in"));
	int noOfTestCases = Integer.valueOf(br.readLine()).intValue();
	String[] outputArr = new String[noOfTestCases];
	//start reading test cases
	for(int i=0;i<noOfTestCases;i++)
	{
		for(int j=0;j<4;j++)
		{
			String str = br.readLine();
			chArr[j] = str.toCharArray();
		}
		br.readLine();
		//Finished reading input.
		calculateStatus(chArr,outputArr,i);
	}
	
	//writing to output file
	BufferedWriter bw = new BufferedWriter(new FileWriter("A-small-attempt0.out"));
	for(int i=0;i<noOfTestCases;i++)
	{
		bw.write(outputArr[i]);
		if(i<(noOfTestCases-1))
		{
			bw.newLine();
		}
	}
	
	br.close();
	bw.flush();
	bw.close();
	
}

private static void calculateStatus(char[][] chArr,String[] outputArr,int testCaseNo) {
	
	char ch = 'Z';
	boolean success = false;
	boolean emptySpaceExists = false;
	
	//Check row wise.
	for(int i=0;i<4;i++)
	{
		 ch = chArr[i][0];
		int j=1;
		if(ch=='T')
		{
			ch=chArr[i][1];
			j=2;
		}
		for(; j<4 && ch!='.' && (chArr[i][j] == ch || chArr[i][j]=='T') ;j++);
		if(j==4)
		{
			success = true;
			break;
		}
		for(;!emptySpaceExists && j<4;j++)
		{
			if(chArr[i][j]=='.')
			{
				emptySpaceExists=true;
			}
		}
	}
	

	
	//check column wise
	
	for(int j=0;!success && j<4;j++)
	{
		 ch = chArr[0][j];
		int i=1;
		if(ch=='T')
		{
			ch=chArr[1][j];
			i=2;
		}
		for(; i<4 && ch!='.' && (chArr[i][j] == ch || chArr[i][j]=='T') ;i++);
		if(i==4)
		{
			success = true;
			break;
		}
		/*for(;!emptySpaceExists && i<4;i++)
		{
			if(chArr[i][j]=='.')
			{
				emptySpaceExists=true;
			}
		}*/
	}
	
	//check 1st diagonal downwards
	if(!success)
	{
		int i=1;
		int j=1;
		ch = chArr[0][0];
		if(ch=='T')
		{
			ch=chArr[1][1];
			i=2;
			j=2;
		}
		for(;i<4 && j<4 && ch!='.' && (chArr[i][j]==ch || chArr[i][j]=='T');i++,j++);
		if(i==4 && j==4)
		{
			success = true;
		}
	}
	
	//check 2nd diagnol upwards
	if(!success)
	{
		int i=2;
		int j=1;
		ch=chArr[3][0];
		if(ch=='T')
		{
			ch=chArr[2][1];
			i=1;
			j=2;
		}
		for(;i>=0&&j<4 && ch!='.' && (chArr[i][j]==ch || chArr[i][j]=='T');i--,j++ );
		if(j==4)
		{
			success = true;
		}
	}
	
	
	StringBuffer outputStrBuff = new StringBuffer(); 
	outputStrBuff.append("Case #").append(Integer.toString(testCaseNo+1)).append(": ");
	if(success)
	{
		outputStrBuff.append(ch).append(" won");
	}
	else if(emptySpaceExists)
	{
		outputStrBuff.append("Game has not completed");
	}
	else
	{
		outputStrBuff.append("Draw");
	}
	
	outputArr[testCaseNo] = outputStrBuff.toString();
}
}
