/**
 * 
 */
package com.google.code.jam;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.List;

import org.apache.commons.io.IOUtils;

import com.google.common.collect.Lists;

/**
 * @author satselva
 *
 */
public class Minesweeper
{
    private final int rowCount; 
    
    private final int columnCount; 
    
    private final int mineCount;
    
    private char[][] minesPosition;
    
    public Minesweeper(final int rowCount, final int columnCount, final int mineCount)
    {
        this.minesPosition = new char[rowCount][columnCount];
        this.mineCount = mineCount;
        this.rowCount = rowCount;
        this.columnCount = columnCount;
        
        int minesAdded = 0 ;
        for(int row=0; row < rowCount; row++) {
            for(int col=0; col < columnCount; col++) {
                if(minesAdded < mineCount) {
                    minesPosition[row][col] = '*';
                    minesAdded++;
                } else {
                    minesPosition[row][col] = '.';
                }
            }
        }
        minesPosition[rowCount-1][columnCount-1] = 'c';
    }
    
    public String mineSweep() {
        System.out.println("Row" + rowCount + "ColCount" + columnCount);
        if(columnCount-2 >= 0 && rowCount-2 >= 0) {
            if(minesPosition[rowCount-1][columnCount-2] == '*' || minesPosition[rowCount-2][columnCount-1] == '*' || minesPosition[rowCount-2][columnCount-2] == '*') {
                return "Impossible";
            }
        } else if(columnCount-2 >=0 && rowCount-2 < 0 && minesPosition[rowCount-1][columnCount-2] == '*') {
                return "Impossible";
        } else if (columnCount-2 < 0 && rowCount-2>=0 && minesPosition[rowCount-2][columnCount-1] == '*') {
            return "Impossible";
        }
        return toString();
    }
    
    @Override
    public String toString() {
        StringBuilder sbMinesPosition = new StringBuilder(100);
        sbMinesPosition.append("\n");
        for(int i=0; i<minesPosition.length; i++) {
            for(int j=0; j< minesPosition[i].length; j++) {
                sbMinesPosition.append(minesPosition[i][j]);
            }
            sbMinesPosition.append("\n");
        }
        //delete \n, if it is the last character.
        if(sbMinesPosition.substring(sbMinesPosition.length()-1).equals("\n")){
            sbMinesPosition.deleteCharAt(sbMinesPosition.length()-1);
        }
        return sbMinesPosition.toString();
    }
    
    public static void main(String[] args) throws Exception {
        final String inputFileLocation = "/home/satselva/personal/downloads/C-small-attempt0.in";
        final String outputFileLocation = inputFileLocation + "output";
        // final String fileLocation = "/home/satselva/personal/downloads/dummy-small-practice.in";
        int readLineCnt = 0;
        List<String> inputLines = IOUtils.readLines(new FileInputStream(inputFileLocation));
        List<String> outputLines = Lists.newArrayList();
        int testCaseCount = Integer.valueOf(inputLines.get(readLineCnt++));
        
        for (int testCaseNumber = 1; testCaseNumber <= testCaseCount; testCaseNumber++) {
            String[] inputArray = inputLines.get(readLineCnt++).split(" ");
            Minesweeper minesweeper = new Minesweeper(Integer.valueOf(inputArray[0]), Integer.valueOf(inputArray[1]), Integer.valueOf(inputArray[2]));
            // Volunteer first selection
            final String testCaseOutput = String.format("Case #%d: %s", testCaseNumber,
                    minesweeper.mineSweep());
            outputLines.add(testCaseOutput);
            System.out.println(testCaseOutput);
            System.out.println("\n\n");
        }
        IOUtils.writeLines(outputLines, "\n", new FileOutputStream(outputFileLocation));
    }
}
