/**
 * 
 */
package com.google.code.jam;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.List;

import org.apache.commons.io.IOUtils;

import com.google.common.collect.Lists;

/**
 * @author satselva
 *
 */
public class Repeater {
    
    private List<String> columns;
    
    private int[][] characterMatrix;
    
    private boolean isFeglaWon = false;
    
    private int rows;
    
    private int rowIndex = 0;
    
    private int colIndex = -1;
    
    public Repeater(int rows)
    {
        this.rows = rows;
        this.columns = Lists.newArrayList();
        this.characterMatrix = new int[rows][100];
        
        for(int r=0; r<rows; r++) {
            for(int c=0 ; c<100; c++) {
                characterMatrix[r][c] = 0;
            }
        }
        
    }
    
    public boolean addCharacter(String str) {
        
        //System.out.println("Add Character [" + str + "]");
        
        if(rowIndex == 0 && (columns.isEmpty() || !str.equals(columns.get(columns.size() -1)))) {
            columns.add(str);
            colIndex++;
        }
        
        if(rowIndex > 0) {
            if(str.equals(columns.get(colIndex))) {
                
            } else if (colIndex+1 < columns.size() && str.equals(columns.get(colIndex+1))) {
                colIndex = colIndex +1;
            }
            else {
                isFeglaWon = true;
                return false;
            }
        }
        
        characterMatrix[rowIndex][colIndex] = characterMatrix[rowIndex][colIndex] + 1;
        
        return true;
    }
    
    public void nextRow() {
/*        for(int c =0 ; c<columns.size();c++) {
            System.out.print(" " + characterMatrix[rowIndex][c] + " ");
        }
        System.out.println();*/
        
        this.rowIndex++;
        this.colIndex = 0;
        
    }
    
    
    public String computeLeastRepeater() {
        
        if(isFeglaWon) {
            return "Fegla Won";
        }
        
        int moves = 0;
        for(int i=0; i< columns.size();i++) {
            int sum = 0;
            for(int r=0; r < rows; r++) {
                if(characterMatrix[r][i] == 0) {
                    return "Fegla Won";
                }
                sum+=characterMatrix[r][i];
            }
            int median = sum/characterMatrix.length;
            for(int r=0; r<rows; r++) {
                moves += Math.abs(median - characterMatrix[r][i]);
            }
        }
        return String.valueOf(moves);
    }
    
    public static void main(String[] args) throws Exception {
        
        final String inputFileLocation = "/home/satselva/personal/downloads/A-small-attempt0.in";
        final String outputFileLocation = inputFileLocation + "output1B";
        // final String fileLocation = "/home/satselva/personal/downloads/dummy-small-practice.in";
        int readLineCnt = 0;
        List<String> inputLines = IOUtils.readLines(new FileInputStream(inputFileLocation));
        List<String> outputLines = Lists.newArrayList();
        int testCaseCount = Integer.valueOf(inputLines.get(readLineCnt++));
        
        for (int testCaseNumber = 1; testCaseNumber <= testCaseCount; testCaseNumber++) {
            int rows = Integer.valueOf(inputLines.get(readLineCnt++));
            Repeater repeater = new Repeater(rows);
            boolean fegolaWon = false;
            for(int i=1; i<=rows; i++) {
                String inputString = inputLines.get(readLineCnt++);
                //System.out.println("Input String" + inputString);
                for(int c=0; c<inputString.length();c++) {
                    if(!fegolaWon && !repeater.addCharacter(String.valueOf(inputString.charAt(c)))) {
                        break;
                    }
                }
                repeater.nextRow();
            }
            // Volunteer first selection
            String testCaseOutput = String.format("Case #%d: %s", testCaseNumber, repeater.computeLeastRepeater());
            outputLines.add(testCaseOutput);
            //System.out.println(testCaseOutput);
        }
        IOUtils.writeLines(outputLines, "\n", new FileOutputStream(outputFileLocation));
    }
    
}
