/**
 * @author : Sathish
 * @created : 3:40:47 PM
 * @Harmony : Harmony.java
 * @year : 2011
 */
package src.java.codejam;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Sathish
 *
 */
public class Harmony
{
    private long jeffHigh;
    
    private long jeffLow;
    
    private long numPlayers;
    
    private long[] otherPlayerFreq;

    
    
    /**
     * @param args
     */
    public static void main(String[] args)
    {
        FileInputStream fis = null;
        BufferedReader brFile = null;
        List<Harmony> harmonyList = null;
        
        try
        {
            //fis = new FileInputStream("C:/downloads/rpi.in");
            //fis = new FileInputStream("C:/downloads/harmony.in");
            fis = new FileInputStream("C:/downloads/C-small-attempt2.in");
            brFile = new BufferedReader(new InputStreamReader(fis));
            
            String str = brFile.readLine();
            int noOfTestCases = Integer.valueOf(str);
            harmonyList = new ArrayList<Harmony>();
            
            for(int testCase=0; testCase<noOfTestCases; testCase++)
            {
                Harmony samHar = new Harmony();
                
                String jeffStr = brFile.readLine();
                
                String [] jeffValStr = jeffStr.split(" ");
                
                samHar.numPlayers =  Long.valueOf(jeffValStr[0]);
                samHar.jeffLow    =  Long.valueOf(jeffValStr[1]);
                samHar.jeffHigh    =  Long.valueOf(jeffValStr[2]);
                
                String notesStr = brFile.readLine();
                String[] notesVal = notesStr.split(" ");
                
                long[] ipArr = new long[notesVal.length];
                
                for(int i=0; i<notesVal.length;i++)
                {
                    ipArr[i] = Long.valueOf(notesVal[i]);
                }
                
                samHar.otherPlayerFreq = ipArr;
                
                harmonyList.add(samHar);
            }
            
            solveHarmony(harmonyList);
            
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        
    }



    /**
     * @param aHarmonyList
     * @throws IOException 
     */
    private static void solveHarmony(List<Harmony> aHarmonyList) throws IOException
    {
        
        FileOutputStream fos = new FileOutputStream("C:/downloads/harmony_output.txt");
        PrintWriter pw = new PrintWriter(fos);
        
        int cnt = 0;
        for(Harmony har : aHarmonyList)
        {
            cnt++;
            long [] ipArr = har.otherPlayerFreq;
            
            pw.print("Case #" + cnt + ": ");
            
            boolean found = false;
            for(long jeffNote = har.jeffLow ; jeffNote<=har.jeffHigh;jeffNote++ )
            {
                int i= 0;
                for( ; i<har.otherPlayerFreq.length;i++)
                {
                    if(ipArr[i] % jeffNote == 0 || jeffNote % ipArr[i] == 0)
                    {
                        continue;
                    }
                    else
                    {
                        break;
                    }
                }
                
                if(i == har.otherPlayerFreq.length)
                {
                    found = true;
                    pw.print(jeffNote);
                    break;
                }
            }
            
            if(!found)
                pw.print("NO");
            
            pw.println();
        }
        
        
        pw.close();
        fos.close();
        
    }
    
    
}
