/**
 * 
 */
package com.google.code.jam;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Collections;
import java.util.List;

import org.apache.commons.io.IOUtils;

import com.google.common.collect.Lists;

/**
 * Gooogle code jam 2014. Problem 4
 * Cookie clicker. https://code.google.com/codejam/contest/dashboard?c=2974486#s=p3
 * 
 * @author satselva
 */
public class War
{
    
    private List<Integer> firstPerson;
    
    private List<Integer> secondPerson;
    
    
    public War(String[] firstPersonStr, String[]secondPersonStr)
    {
        this.firstPerson = Lists.newArrayList();
        this.secondPerson = Lists.newArrayList();
        
        for(int i=0; i<firstPersonStr.length; i++)  {
            firstPerson.add(Integer.valueOf(firstPersonStr[i]));
            secondPerson.add(Integer.valueOf(secondPersonStr[i]));
        }
        
        Collections.sort(firstPerson);
        Collections.sort(secondPerson);
        
        //System.out.println("First Person" + firstPerson);
        //System.out.println("Second Person" + secondPerson);
    }
    
    /**
     * Method to compute the Naomis deceitful war result
     * @return {@link Integer}
     */
    public int firstPersonOptimal() {
        int result = 0;
        int firstPersonPtr = firstPerson.size()-1;
        int secondPersonPtr = firstPerson.size()-1;
        int loopCnt = 0;
        while(loopCnt < firstPerson.size()) {
            if(firstPerson.get(firstPersonPtr) > secondPerson.get(secondPersonPtr)) {
                firstPersonPtr--;
                result++;
            }
            secondPersonPtr--;
            loopCnt++;
        }
        return result;
    }
    
    /**
     * Method to compute the second person winning max times which gives
     * result of Naomi winning for optimal play
     * 
     * @return {@link Integer}
     */
    public int secondPersonOptimal() {
        int result = 0;
        int firstPersonPtr = firstPerson.size()-1;
        int secondPersonPtr = firstPerson.size()-1;
        int loopCnt = 0;
        while(loopCnt < firstPerson.size()) {
            if(secondPerson.get(firstPersonPtr) > firstPerson.get(secondPersonPtr)) {
                firstPersonPtr--;
                result++;
            }
            secondPersonPtr--;
            loopCnt++;
        }
        return firstPerson.size() - result;
    }
    
    public static void main(String[] args) throws Exception {
        final String inputFileLocation = "/home/satselva/personal/downloads/D-large.in";
        final String outputFileLocation = inputFileLocation + "output";
        // final String fileLocation = "/home/satselva/personal/downloads/dummy-small-practice.in";
        int readLineCnt = 0;
        List<String> inputLines = IOUtils.readLines(new FileInputStream(inputFileLocation));
        List<String> outputLines = Lists.newArrayList();
        int testCaseCount = Integer.valueOf(inputLines.get(readLineCnt++));
        
        for (int testCaseNumber = 1; testCaseNumber <= testCaseCount; testCaseNumber++) {
            inputLines.get(readLineCnt++); //do nothing input
            String[] firstPersonInputArr = inputLines.get(readLineCnt++).replace("0.", "").split(" ");
            String[] secondPersonInputArr = inputLines.get(readLineCnt++).replace("0.", "").split(" ");
            War war = new War(firstPersonInputArr, secondPersonInputArr);
            // Volunteer first selection
            final String testCaseOutput = String.format("Case #%d: %d %d", testCaseNumber,
                    war.firstPersonOptimal(), war.secondPersonOptimal());
            outputLines.add(testCaseOutput);
            System.out.println(testCaseOutput);
            System.out.println("\n\n");
        }
        IOUtils.writeLines(outputLines, "\n", new FileOutputStream(outputFileLocation));
    }
}
