/**
 * 
 */
package com.sathish.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;

/**
 * @author satselva
 *
 */
public class Tongue
{
    private static final Map<String, String> translateMapping = new HashMap<String, String>();
    
    static
    {
        translateMapping.put("y", "a");
        translateMapping.put("n", "b");
        translateMapping.put("f", "c");
        translateMapping.put("i", "d");
        translateMapping.put("c", "e");
        translateMapping.put("w", "f");
        translateMapping.put("l", "g");
        translateMapping.put("b", "h");
        translateMapping.put("k", "i");
        translateMapping.put("u", "j");
        translateMapping.put("o", "k");
        translateMapping.put("m", "l");
        translateMapping.put("x", "m");
        translateMapping.put("s", "n");
        translateMapping.put("e", "o");
        translateMapping.put("v", "p");
        translateMapping.put("z", "q");
        translateMapping.put("p", "r");
        translateMapping.put("d", "s");
        translateMapping.put("r", "t");
        translateMapping.put("j", "u");
        translateMapping.put("g", "v");
        translateMapping.put("t", "w");
        translateMapping.put("h", "x");
        translateMapping.put("a", "y");
        translateMapping.put("q", "z");
        translateMapping.put(" ", " ");
        
    }
    
    
    // q n
    
    
    /**
     * Method which does the translation 
     * 
     * @param input - input string to be translated
     * @return {@link String} - translated String.
     */
    public String translate(final String input)
    {
        StringBuilder sbOutput = new StringBuilder();
        
        for(int i=0; i<input.length(); i++)
        {
            sbOutput.append(translateMapping.get(input.substring(i, i+1)));
        }
        return sbOutput.toString();
    }
    
    public void processInput(String fileName) throws IOException
    {
        
        FileInputStream fis = new FileInputStream(fileName);
        BufferedReader br = new BufferedReader(new InputStreamReader(fis));
        
        PrintWriter pw = new PrintWriter(new File("C:/downloads/output.txt"));
        String input = br.readLine();
        int testCases = Integer.valueOf(input);
        
        
        for(int i=1; i<=testCases; i++)
        {
            input = br.readLine();
            String output = String.format("Case #%d: %s", i, translate(input));
            pw.println(output);
        }
        
        pw.flush();
        pw.close();
    }
    
    public static void main(String[] args) throws IOException
    {
        Tongue tongue = new Tongue();
        
        tongue.processInput("C:/downloads/A-small-attempt0.in");
        String input = "rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd";
        //String op = tongue.translate(input);
        //System.out.println(">>>>>" + op + "<<<<");
        
        
    }
    
    
    
}
