/**
 * @author : Sathish
 * @created : 2:41:57 PM
 * @SquareTiles : SquareTiles.java
 * @year : 2011
 */
package src.java.codejam;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Sathish
 *
 */
public class SquareTiles
{
    
    private static final String IMPOSSIBLE = "Impossible";
    
    private char[][] ipArray;
    
    private int numBlueTiles;
    
    private int rowSize;
    
    private int colSize;
    
    
    /**
     * @return the ipArray
     */
    public char[][] getIpArray()
    {
        return this.ipArray;
    }

    /**
     * @param aIpArray the ipArray to set
     */
    public void setIpArray(char[][] aIpArray)
    {
        this.ipArray = aIpArray;
    }

    /**
     * @return the numBlueTiles
     */
    public int getNumBlueTiles()
    {
        return this.numBlueTiles;
    }

    /**
     * @param aNumBlueTiles the numBlueTiles to set
     */
    public void setNumBlueTiles(int aNumBlueTiles)
    {
        this.numBlueTiles = aNumBlueTiles;
    }
    

    /**
     * @return the rowSize
     */
    public int getRowSize()
    {
        return this.rowSize;
    }

    /**
     * @param aRowSize the rowSize to set
     */
    public void setRowSize(int aRowSize)
    {
        this.rowSize = aRowSize;
    }

    /**
     * @return the colSize
     */
    public int getColSize()
    {
        return this.colSize;
    }

    /**
     * @param aColSize the colSize to set
     */
    public void setColSize(int aColSize)
    {
        this.colSize = aColSize;
    }

    /**
     * @param args
     */
    public static void main(String[] args)
    {
        FileInputStream fis = null;
        BufferedReader brFile = null;
        List<SquareTiles> squareTiles = null;
        
        try
        {
            //fis = new FileInputStream("C:/downloads/rpi.in");
            fis = new FileInputStream("C:/downloads/A-small-attempt123.in");
            brFile = new BufferedReader(new InputStreamReader(fis));
            
            
            String str = brFile.readLine();
            int noOfTestCases = Integer.valueOf(str);
            squareTiles = new ArrayList<SquareTiles>();
            
            for(int testCase=0; testCase<noOfTestCases; testCase++)
            {
                SquareTiles sqTiles = new SquareTiles();
                
                String rowColStr = brFile.readLine();
                
                int row = Integer.valueOf(rowColStr.split(" ")[0]);
                int col = Integer.valueOf(rowColStr.split(" ")[1]);
                char[][] ipArr = new char[row][col];
                int blueTiles = 0;
                
                for(int rowItr=0; rowItr<row; rowItr++)
                {
                    String colStr = brFile.readLine();
                    
                    for(int colItr = 0; colItr < col; colItr++)
                    {
                        ipArr[rowItr][colItr] = colStr.charAt(colItr);
                        
                        if(ipArr[rowItr][colItr] == '#')
                            blueTiles++;
                    }
                }
                
                sqTiles.setIpArray(ipArr);
                sqTiles.setNumBlueTiles(blueTiles);
                sqTiles.setRowSize(row);
                sqTiles.setColSize(col);
                
                squareTiles.add(sqTiles);
            }
            
            solveSquareTiles(squareTiles);
            
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    /**
     * @param aSquareTiles
     * @throws IOException 
     */
    private static void solveSquareTiles(List<SquareTiles> aSquareTiles) throws IOException
    {
        FileOutputStream fos = new FileOutputStream("C:/downloads/sq_tiles_output.txt");
        PrintWriter pw = new PrintWriter(fos);
        
        int cnt = 0;
        for(SquareTiles sqTile : aSquareTiles)
        {
            cnt++;
            pw.println("Case #" + cnt + ":");
            char [][] ipArr = sqTile.getIpArray();
            
            if(sqTile.getNumBlueTiles() % 4 != 0)
            {
                pw.println(IMPOSSIBLE);
                continue;
            }
            
            //No blue tiles... print the given input array
            if(sqTile.getNumBlueTiles() == 0)
            {
                for(int row = 0; row < sqTile.getRowSize(); row++)
                {
                    for(int col = 0; col < sqTile.getColSize(); col++)
                    {
                        pw.print(ipArr[row][col]);
                    }
                    pw.println();
                }
                continue;
            }
            
            //Square Tile has equal number of tiles
            
            int redTileCnt = 0;
            for(int row = 0; row < (sqTile.getRowSize() - 1); row++)
            {
                for(int col = 0; col< (sqTile.getColSize()-1); col++)
                {
                    if(ipArr[row][col] == '#' && ipArr[row+1][col] == '#'
                        && ipArr[row][col+1] == '#' && ipArr[row+1][col+1] == '#')
                    {
                        ipArr[row][col] = '/';
                        ipArr[row+1][col] = '\\';
                        ipArr[row][col+1] = '\\';
                        ipArr[row+1][col+1] = '/';
                        redTileCnt += 4;
                    }
                }
            }
            
            if(redTileCnt == sqTile.getNumBlueTiles())
            {
                for(int row = 0; row < sqTile.getRowSize(); row++)
                {
                    for(int col = 0; col < sqTile.getColSize(); col++)
                    {
                        pw.print(ipArr[row][col]);
                    }
                    pw.println();
                }
            }
            else
            {
                pw.println(IMPOSSIBLE);
            }
            
        }
        
        
        pw.close();
        fos.close();
        
    }

}
