/**
 * @author : Sathish
 * @created : 9:36:19 AM
 * @InvProblem : InvProblem.java
 * @year : 2011
 */
package src.java.codejam;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Candy problem of google code jam
 * 
 * @author Sathish
 *
 */
public class Candy
{
    private static final String CANDY_OP = "Case #%d: %s\n";
    
    private static final String NO = "NO";
    
    private static FileOutputStream fos = null;
    
    private static PrintWriter pw = null;
    
    private int noOfCandyPiles;
    
    private int[] noOfCandies;
    
    private int xorValue;
    
    private boolean isValid;
    
    private String output;
    
    private int minCandy;
    
    private int totalSum;
    
    static
    {
        try
        {
            fos = new FileOutputStream("C:/downloads/candy_op.txt");
            pw = new PrintWriter(fos);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }
    
    /**
     * 
     */
    public Candy()
    {
        this.isValid = true;
    }
    
    /**
     * @return the noOfCandyPiles
     */
    public int getNoOfCandyPiles()
    {
        return this.noOfCandyPiles;
    }


    /**
     * @param aNoOfCandyPiles the noOfCandyPiles to set
     */
    public void setNoOfCandyPiles(int aNoOfCandyPiles)
    {
        this.noOfCandyPiles = aNoOfCandyPiles;
    }


    /**
     * @return the noOfCandies
     */
    public int[] getNoOfCandies()
    {
        return this.noOfCandies;
    }


    /**
     * @param aNoOfCandies the noOfCandies to set
     */
    public void setNoOfCandies(int[] aNoOfCandies)
    {
        this.noOfCandies = aNoOfCandies;
    }


    /**
     * @return the isValid
     */
    public boolean isValid()
    {
        return this.isValid;
    }


    /**
     * @param aIsValid the isValid to set
     */
    public void setValid(boolean aIsValid)
    {
        this.isValid = aIsValid;
    }


    /**
     * @return the output
     */
    public String getOutput()
    {
        return this.output;
    }


    /**
     * @param aOutput the output to set
     */
    public void setOutput(String aOutput)
    {
        this.output = aOutput;
    }


    /**
     * @return the xorValue
     */
    public int getXorValue()
    {
        return this.xorValue;
    }

    /**
     * @param aXorValue the xorValue to set
     */
    public void setXorValue(int aXorValue)
    {
        this.xorValue = aXorValue;
    }

    
    /**
     * @return the minCandy
     */
    public int getMinCandy()
    {
        return this.minCandy;
    }

    /**
     * @param aMinCandy the minCandy to set
     */
    public void setMinCandy(int aMinCandy)
    {
        this.minCandy = aMinCandy;
    }

    /**
     * @return the totalSum
     */
    public int getTotalSum()
    {
        return this.totalSum;
    }

    /**
     * @param aTotalSum the totalSum to set
     */
    public void setTotalSum(int aTotalSum)
    {
        this.totalSum = aTotalSum;
    }

    /**
     * @param args
     * @throws IOException 
     */
    public static void main(String[] args) throws IOException
    {
        FileInputStream fis = null;
        BufferedReader brFile = null;
        List<Candy> candyProbList = null;
        try
        {
            //fis = new FileInputStream("C:/downloads/B-small-practice_inv.in");
            fis = new FileInputStream("C:/downloads/candy_ip_1.in");
            brFile = new BufferedReader(new InputStreamReader(fis));
            
            String str = brFile.readLine();
            
            int noOfTestCases = Integer.valueOf(str);
            
            candyProbList = new ArrayList<Candy>();
            
            for(int i=0; i<noOfTestCases; i++)
            {
                Candy candy = new Candy();
                
                String noOfCandyPiles = brFile.readLine();
                String candyCountStr = brFile.readLine();
                
                String[] candyCountArr =  candyCountStr.split(" ");
                
                candy.setNoOfCandyPiles(Integer.valueOf(noOfCandyPiles));
                
                int[] tmpCandies = new int[candyCountArr.length];
                
                int xorValue = 0;
                int minValue = Integer.MAX_VALUE;
                int totalSum = 0;
                
                for(int j=0; j<candyCountArr.length; j++)
                {
                    if(candyCountArr[j].startsWith("-"))
                        candy.setValid(false);
                    
                    tmpCandies[j] = Integer.valueOf(candyCountArr[j]);
                    xorValue  = xorValue ^ tmpCandies[j];
                    
                    if(tmpCandies[j] < minValue)
                        minValue = tmpCandies[j];
                    
                    totalSum += tmpCandies[j];
                }
                candy.setMinCandy(minValue);
                candy.setTotalSum(totalSum);
                candy.setXorValue(xorValue);
                
                candyProbList.add(candy);
            }
            
        }
        catch (Exception e) 
        {
            e.printStackTrace();
        }
        finally
        {
            try
            {
                brFile.close();
                fis.close();
            }
            catch (IOException e)
            {
                e.printStackTrace();
            }
            
        }
        
        findMaxCandiesPossible(candyProbList);
        
        try
        {
            fos.close();
            pw.close();
        }
        catch (IOException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        
    }

    /**
     * @param aCandyProbList 
     * @throws IOException 
     * 
     */
    private static void findMaxCandiesPossible(List<Candy> aCandyProbList) throws IOException
    {
        int counter = 0;
        for(Candy candy : aCandyProbList)
        {
            counter++;
            
            //If XOR value is not zero, then it is invalid case
            if(candy.getXorValue() != 0 )
            {
                String output = String.format(CANDY_OP, counter, NO);
                System.out.print(output);
                fos.write(output.getBytes());
                continue;
            }
            
            //int [] ipArr = candy.getNoOfCandies();
            //Arrays.sort(ipArr);

            int patrickCandies = candy.getMinCandy();
            int seanCandies = candy.getTotalSum() - patrickCandies;
            
            String output = String.format(CANDY_OP, counter, seanCandies);
            System.out.print(output);
            fos.write(output.getBytes());
        }
    }
}
