/**
 * @author : Sathish
 * @created : 9:55:51 PM
 * @RPI : RPI.java
 * @year : 2011
 */
package src.java.codejam;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Sathish
 *
 */
public class RPI
{
    private int[][] resArr;
    
    private float[] wp;
    
    private float[] owp;
    
    private float[] oowp;
    
    private float[] numOpp;
    
    
    /**
     * @return the numOpp
     */
    public float[] getNumOpp()
    {
        return this.numOpp;
    }



    /**
     * @param aNumOpp the numOpp to set
     */
    public void setNumOpp(float[] aNumOpp)
    {
        this.numOpp = aNumOpp;
    }



    /**
     * @return the resArr
     */
    public int[][] getResArr()
    {
        return this.resArr;
    }



    /**
     * @param aResArr the resArr to set
     */
    public void setResArr(int[][] aResArr)
    {
        this.resArr = aResArr;
    }




    /**
     * @return the wp
     */
    public float[] getWp()
    {
        return this.wp;
    }



    /**
     * @param aWp the wp to set
     */
    public void setWp(float[] aWp)
    {
        this.wp = aWp;
    }



    /**
     * @return the owp
     */
    public float[] getOwp()
    {
        return this.owp;
    }



    /**
     * @param aOwp the owp to set
     */
    public void setOwp(float[] aOwp)
    {
        this.owp = aOwp;
    }



    /**
     * @return the oowp
     */
    public float[] getOowp()
    {
        return this.oowp;
    }



    /**
     * @param aOowp the oowp to set
     */
    public void setOowp(float[] aOowp)
    {
        this.oowp = aOowp;
    }



    public static void main(String[] args)
    {
        FileInputStream fis = null;
        BufferedReader brFile = null;
        List<RPI> rpiList = null;
        
        try
        {
            //fis = new FileInputStream("C:/downloads/rpi.in");
            fis = new FileInputStream("C:/downloads/A-large.in");
            brFile = new BufferedReader(new InputStreamReader(fis));
            
            String str = brFile.readLine();
            int noOfTestCases = Integer.valueOf(str);
            rpiList = new ArrayList<RPI>();
            
            for(int testCase=0; testCase<noOfTestCases; testCase++)
            {
                RPI rpi = new RPI();
                
                String numTeams = brFile.readLine();
                
                int teamSize = Integer.valueOf(numTeams);

                int [][] resArr = new int[teamSize][teamSize];
                float [] numOppArr = new float[teamSize];
                
                for(int row =0 ; row < teamSize; row++)
                {
                    String rowStr = brFile.readLine();
                    int numOpp =0;
                    for(int col=0; col<teamSize; col++)
                    {
                        if(rowStr.charAt(col) == '.')
                            resArr[row][col] = -1;

                        if(rowStr.charAt(col) == '1')
                            resArr[row][col] = 1;
                        
                        if(rowStr.charAt(col) == '0')
                            resArr[row][col] = 0;
                        
                        if(resArr[row][col] >= 0 )
                            numOpp++;
                    }
                    numOppArr[row] = numOpp;
                }
                
                rpi.setResArr(resArr);
                rpi.setNumOpp(numOppArr);
                rpiList.add(rpi);
            }
            solveRPI(rpiList);
            printRPI(rpiList);
            
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        finally
        {
            try
            {
                brFile.close();
                fis.close();
                
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
        }
        
    }



    /**
     * @param aRpiList
     */
    private static void printRPI(List<RPI> aRpiList)
    {
        for(RPI rpi : aRpiList)
        {
            for(int i=0; i<rpi.getWp().length; i++)
            {
                System.out.println(" Val " + rpi.getWp()[i] );
            }
            System.out.println("\n\n");
        }
    }



    /**
     * @param aRpiList
     * @throws FileNotFoundException 
     */
    private static void solveRPI(List<RPI> aRpiList) throws FileNotFoundException
    {
        for(RPI rpi : aRpiList)
        {
            int [][] resArr  = rpi.getResArr();
            float [] wpArr = new float[resArr.length];
            
            //Calculate win percentage
            for(int i=0; i<resArr.length; i++)
            {
                float numMatch = 0;
                float winMatch = 0;
                for(int j = 0; j< resArr.length; j++)
                {
                    if(resArr[i][j] == -1)
                        continue;
                    
                    if(resArr[i][j] == 1)
                        winMatch++;
                    
                    numMatch++;
                }
                wpArr[i] = winMatch/numMatch;
            }
            
            float[] owpArr = new float[resArr.length];
            //Calculate OOWP
            for(int row = 0; row<resArr.length; row++)
            {
                float teamOwp = 0;
                
                System.out.println(" Team " + row);
                
                for(int col=0; col<resArr.length; col++ )
                {
                    if(resArr[row][col] == -1)
                        continue;
                    
                    float oppWin = 0;
                    
                    for(int oppCol = 0; oppCol<resArr.length; oppCol++)
                    {
                        if(oppCol == row)
                            continue;
                        
                        if(resArr[col][oppCol] == 1)
                            oppWin++;
                    }
                    
                    float owp = oppWin / (rpi.getNumOpp()[col] - (float) 1.0);
                    
                    System.out.println("Opp:" + col + "<< oppWin" + oppWin + "<< oppTot" + rpi.getNumOpp()[col]);
                    System.out.println("Team>> " + col + "<< OWP >>" + owp + "<<");
                    
                    teamOwp += owp;
                }
                owpArr[row] = teamOwp/rpi.getNumOpp()[row];
                
            }
            rpi.setOwp(owpArr);
            rpi.setWp(wpArr);
            
            float[] oowpArr = new float[resArr.length];
            for(int row =0; row <resArr.length; row++)
            {
                float oowp = 0;
                for(int col = 0; col<resArr.length; col++)
                {
                    if(resArr[row][col] == -1)
                        continue;
                    
                    oowp += owpArr[col];
                }
                
                oowpArr[row] = oowp/rpi.getNumOpp()[row];
                
            }
            
            rpi.setOowp(oowpArr);
        }
        printResult(aRpiList);
    }
    
    /**
     * @param aRpiList
     * @throws FileNotFoundException 
     */
    private static void printResult(List<RPI> aRpiList) throws FileNotFoundException
    {
        
        FileOutputStream fos = new FileOutputStream("C:/downloads/rpi_output.txt");
        PrintWriter pw = new PrintWriter(fos);
        
        int cnt= 0;
        for(RPI rpi : aRpiList)
        {
            cnt++;
            pw.println("Case #" + cnt + ":");
            for(int i=0; i<rpi.getWp().length; i++)
            {
                float op = (float) (0.25 * rpi.getWp()[i] + 0.50 * rpi.getOwp()[i] + 0.25 * rpi.getOowp()[i]);
                pw.println(op);
            }
            
        }
        
        
        try
        {
            pw.close();
            fos.close();
        }
        catch (IOException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}
