/**
 * 
 */
package com.sathish.codejam;

import java.io.File;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.LineIterator;
import org.apache.commons.lang.StringUtils;

/**
 * @author satselva
 *
 */
public class FairSquare
{
    private int countFairSqures(int start, int end)
    {
        System.out.println("Start" + start + "End" + end);
        int resultVal = 0;
        for(int i=start; i<=end; i++)
        {
            if(checkFairSquare(Integer.valueOf(i))) {
                System.out.println("Fair Square" + i);
                resultVal++;
            }
        }
        return resultVal;
    }
    
    private boolean checkFairSquare(Integer number)
    {
        if(!checkPalindrome(number)) {
            return false;
        }
        Integer sqrtNumber = Integer.valueOf((int) Math.sqrt(number));
        
        if( sqrtNumber * sqrtNumber != number.intValue() ) {
            return false;
        }
        return checkPalindrome(sqrtNumber);
    }
    
    private boolean checkPalindrome(Integer number)
    {
        Integer reverseNumber = Integer.valueOf(StringUtils.reverse(number.toString()));
        return reverseNumber.intValue() == number.intValue();
    }
    
    public static void main(String[] args) throws IOException
    {
        
        File inputFile = new File("C:/downloads/2_small_input.in");
        List<String> outputLines = new ArrayList<String>();
        //File inputFile = new File("C:/downloads/1_small_input.txt");
        LineIterator lineItr = FileUtils.lineIterator(inputFile, "UTF-8");
        String testCasesStr = lineItr.nextLine();
        int noOfTestCases = Integer.valueOf(testCasesStr);
        FairSquare fairSquare = new FairSquare();
        String curIpLine = "";
        for(int i=1; i <= noOfTestCases; i++)
        {
            curIpLine = lineItr.nextLine();
            String[] inpArr = StringUtils.split(curIpLine, " ");
            int fairSquareCnt = fairSquare.countFairSqures(Integer.valueOf(inpArr[0]), Integer.valueOf(inpArr[1]));
            String resultVal = String.format("Case #%d: %d", i, fairSquareCnt);
            outputLines.add(resultVal);
        }
        FileUtils.writeLines(new File(inputFile.getAbsolutePath() + ".out"), "UTF-8", outputLines);
    }
    
    
}
