package com.google.code.jam;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.List;

import org.apache.commons.io.IOUtils;

import com.google.common.collect.Lists;

/**
 * Gooogle code jam 2014. Problem 2
 * Cookie clicker. https://code.google.com/codejam/contest/dashboard?c=2974486#s=p1
 * 
 * @author satselva
 */
public class CookieClicker
{
    private final double farmCost;
    
    private static final double INITIAL_GROWTH_RATE = 2.0;
    
    private final double farmGrowthRate;

    private final double farmTarget;

    protected CookieClicker(final double farmCost, final double farmGrowthRate, final double farmTarget)
    {
        this.farmCost = farmCost;
        this.farmGrowthRate = farmGrowthRate;
        this.farmTarget = farmTarget;
    }

    protected double compute() {
        
        double totalTime = 0.0;
        double currentGrowth = INITIAL_GROWTH_RATE;
        while (true) {
            double timeToTarget = farmTarget / currentGrowth;
            double timeToFarm = farmCost / currentGrowth;
            double nextFarmRate = farmTarget / (currentGrowth + farmGrowthRate);
            
            if ((timeToFarm + nextFarmRate) < timeToTarget) {
                totalTime += timeToFarm;
            } else {
                totalTime += timeToTarget;
                break;
            }
            
            /*
            System.out.println("***********************************************");
            System.out.println("To Target" + timeToTarget);
            System.out.println("To Farm" + timeToFarm);
            System.out.println("Next Farm" + nextFarmRate);
            System.out.println("Current Growth" + currentGrowth);
            System.out.println("Total Time" + totalTime);
            System.out.println("***********************************************\n\n");
            */
            currentGrowth += farmGrowthRate;
        }
        return totalTime;
    }

    public static void main(String[] args) throws Exception {
        final String inputFileLocation = "/home/satselva/personal/downloads/B-small-attempt0.in";
        final String outputFileLocation = inputFileLocation + "output";
        final double factor = 1e7;
        // final String fileLocation = "/home/satselva/personal/downloads/dummy-small-practice.in";
        int readLineCnt = 0;
        List<String> inputLines = IOUtils.readLines(new FileInputStream(inputFileLocation));
        List<String> outputLines = Lists.newArrayList();
        int testCaseCount = Integer.valueOf(inputLines.get(readLineCnt++));
        
        for (int testCaseNumber = 1; testCaseNumber <= testCaseCount; testCaseNumber++) {
            String[] inpArr = inputLines.get(readLineCnt++).split(" ");
            CookieClicker cookieClicker = new CookieClicker(
                    Double.valueOf(inpArr[0]), Double.valueOf(inpArr[1]), Double.valueOf(inpArr[2]));
            // Volunteer first selection
            String testCaseOutput = String.format("Case #%d: %s", testCaseNumber,
                    String.valueOf(Math.round(cookieClicker.compute() * factor)/factor));
            outputLines.add(testCaseOutput);
            //System.out.println(testCaseOutput);
        }
        IOUtils.writeLines(outputLines, "\n", new FileOutputStream(outputFileLocation));
    }

}
