package com.google.code.jam;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.io.IOUtils;

import com.google.common.collect.Lists;

/**
 * Gooogle code jam 2014. Problem 1
 * 
 * @author satselva
 */
public class MagicTrick
{
    private static final String BAD_MAGICIAN = "Bad magician!";

    private static final String VOLUNTEER_CHEATED = "Volunteer cheated!";

    private Map<Integer, List<String>> firstMagicRowMap;

    private Map<Integer, List<String>> secondMagicRowMap;

    public MagicTrick(Map<Integer, List<String>> firstMagicRow,
            Map<Integer, List<String>> secondMagicRow)
    {
        this.firstMagicRowMap = firstMagicRow;
        this.secondMagicRowMap = secondMagicRow;
    }

    protected String getMagicNumber(int volunteerSelectionFirst, int volunterSelectionSecond) {

        List<String> firstSelectedRowElements = firstMagicRowMap.get(volunteerSelectionFirst);
        List<String> secondSelectedRowElements = secondMagicRowMap.get(volunterSelectionSecond);
        firstSelectedRowElements.retainAll(secondSelectedRowElements);

        if (firstSelectedRowElements.isEmpty()) {
            return VOLUNTEER_CHEATED;
        } else if (firstSelectedRowElements.size() == 1) {
            return firstSelectedRowElements.get(0);
        } else {
            return BAD_MAGICIAN;
        }
    }

    public static void main(String[] args) throws Exception {
        final String inputFileLocation = "/home/satselva/personal/downloads/A-small-attempt0.in";
        final String outputFileLocation = inputFileLocation + "output";
        // final String fileLocation = "/home/satselva/personal/downloads/dummy-small-practice.in";
        int readLineCnt = 0;
        List<String> inputLines = IOUtils.readLines(new FileInputStream(inputFileLocation));
        List<String> outputLines = Lists.newArrayList();
        int testCaseCount = Integer.valueOf(inputLines.get(readLineCnt++));
        for (int testCaseNumber = 1; testCaseNumber <= testCaseCount; testCaseNumber++) {
            // Volunteer first selection
            int firstVolunterSelection = Integer.valueOf(inputLines.get(readLineCnt++));
            Map<Integer, List<String>> firstMagicRowMap = new HashMap<Integer, List<String>>();
            for (int row = 1; row <= 4; row++) {
                List<String> rowElements = Lists.newArrayList(inputLines.get(readLineCnt++).split(
                        " "));
                firstMagicRowMap.put(Integer.valueOf(row), rowElements);
            }

            // Volunteer second selection
            int secondVolunterSelection = Integer.valueOf(inputLines.get(readLineCnt++));
            Map<Integer, List<String>> secondMagicRowMap = new HashMap<Integer, List<String>>();
            for (int row = 1; row <= 4; row++) {
                List<String> rowElements = Lists.newArrayList(inputLines.get(readLineCnt++).split(
                        " "));
                secondMagicRowMap.put(Integer.valueOf(row), rowElements);
            }

            MagicTrick magicTrick = new MagicTrick(firstMagicRowMap, secondMagicRowMap);
            String testCaseOutput = String.format("Case #%d: %s", testCaseNumber,
                    magicTrick.getMagicNumber(firstVolunterSelection, secondVolunterSelection));
            System.out.println("test case output" + testCaseOutput);
            outputLines.add(testCaseOutput);
        }
        IOUtils.writeLines(outputLines, "\n", new FileOutputStream(outputFileLocation));
    }

}
