package dfs.codejam;

import java.io.*;

public class StandingOvation {

    private static final String FILE_NAME = "A-small-attempt0";
    private static final String INPUT_FILE_NAME = FILE_NAME + ".in";
    private static final String OUTPUT_FILE_NAME = FILE_NAME + ".out";

    public static void main(String[] args) throws Exception {
        try (BufferedReader reader = new BufferedReader(new FileReader(INPUT_FILE_NAME))) {
            try (BufferedWriter writer = new BufferedWriter(new FileWriter(OUTPUT_FILE_NAME))) {
                int numCases = Integer.parseInt(reader.readLine());
                for (int i = 0; i < numCases; i++) {
                    StandingOvation solver = new StandingOvation(reader);
                    writer.write(String.format("Case #%d: %d\n", i + 1, solver.solve()));
                }
            }
        }
    }

    private final int[] peopleByShyness;

    public StandingOvation(BufferedReader reader) throws IOException {
        String[] split = reader.readLine().split(" ");
        peopleByShyness = split[1].chars().map(Character::getNumericValue).toArray();
    }

    public int solve() {
        int peopleClapping = 0;
        int additionalFriends = 0;
        for (int shyness = 0; shyness < peopleByShyness.length; shyness++) {
            if (shyness > peopleClapping) {
                additionalFriends += shyness - peopleClapping;
                peopleClapping = shyness;
            }
            peopleClapping += peopleByShyness[shyness];
        }
        return additionalFriends;
    }
}
