package dfs.codejam;

import java.io.*;

public class OminousOmino {

    private static final String FILE_NAME = "D-small-attempt1";
    private static final String INPUT_FILE_NAME = FILE_NAME + ".in";
    private static final String OUTPUT_FILE_NAME = FILE_NAME + ".out";

    public static void main(String[] args) throws Exception {
        try (BufferedReader reader = new BufferedReader(new FileReader(INPUT_FILE_NAME))) {
            try (BufferedWriter writer = new BufferedWriter(new FileWriter(OUTPUT_FILE_NAME))) {
                int numCases = Integer.parseInt(reader.readLine());
                for (int i = 0; i < numCases; i++) {
                    OminousOmino solver = new OminousOmino(reader);
                    writer.write(String.format("Case #%d: %s\n", i + 1, solver.solve()));
                }
            }
        }
    }

    private static final String GABRIEL = "GABRIEL";
    private static final String RICHARD = "RICHARD";
    private final int x;
    private final int r;
    private final int c;

    public OminousOmino(BufferedReader reader) throws IOException {
        String[] split = reader.readLine().split(" ");
        x = Integer.parseInt(split[0]);
        r = Integer.parseInt(split[1]);
        c = Integer.parseInt(split[2]);
    }

    public String solve() {
        if ((r * c) % x != 0) return RICHARD;
        switch (x) {
            case 1:
                return GABRIEL;
            case 2:
                return GABRIEL;
            case 3:
                return r * c > 3 ? GABRIEL : RICHARD;
            case 4:
                return r * c >= 12 ? GABRIEL : RICHARD;
            default:
                throw new RuntimeException("x out of range for small input set");
        }
    }
}
