import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class B {
	
	private void solve(File in, File out) throws FileNotFoundException {
		Scanner s = new Scanner(in);
		PrintWriter pw = new PrintWriter(out);
		int T = s.nextInt();
		for (int i = 0; i < T; i++) {
			int N = s.nextInt();
			int[] f = new int[6];
			for (int j = 0; j < f.length; j++) {
				f[j] = s.nextInt();
			}
			pw.println("Case #" + (i+1) + ": " + solve(N, f));
		}
		s.close();
		pw.flush();
		pw.close();
	}
	
	private String solve(int N, int[] f) {
		StringBuilder sb = new StringBuilder();
		Map<Integer, Character> m = new HashMap<>();
		m.put(0, 'R');
		m.put(1, 'O');
		m.put(2, 'Y');
		m.put(3, 'G');
		m.put(4, 'B');
		m.put(5, 'V');
		int[] tmpF = new int[6];
		tmpF[0] = f[0] - f[3];
		tmpF[2] = f[2] - f[5];
		tmpF[4] = f[4] - f[1];
		if (tmpF[0] < 0 || tmpF[2] < 0 || tmpF[4] < 0) {
			return "IMPOSSIBLE";
		}
		if (tmpF[0] == 0 && tmpF[2] == 0 && tmpF[4] == 0) {
			if (f[0] > 0) {
				for (int i = 0; i < f[0]; i++) {
					sb.append(m.get(0));
					sb.append(m.get(3));
				}
				return sb.toString();
			}
			
			if (f[2] > 0) {
				for (int i = 0; i < f[2]; i++) {
					sb.append(m.get(2));
					sb.append(m.get(5));
				}
				return sb.toString();
			}
			
			if (f[4] > 0) {
				for (int i = 0; i < f[4]; i++) {
					sb.append(m.get(4));
					sb.append(m.get(1));
				}
				return sb.toString();
			}
		}
		int lastIndex = -1;
		int firstColour = -1;
		while(N > 0) {
			System.out.println(Arrays.toString(f));
			int colourIndex = getPosibleMaxIndex(tmpF, lastIndex, firstColour);
			if (firstColour == -1) {
				firstColour = colourIndex;
			}
			lastIndex = colourIndex;
			sb.append(m.get(colourIndex));
			tmpF[colourIndex]--;
			f[colourIndex]--;
			N--;
			if (colourIndex == 0 && f[3] > 0) {
				sb.append(m.get(3));
				sb.append(m.get(colourIndex));
				f[colourIndex]--;
				N -= 2;
				f[3]--;
			}
			
			if (colourIndex == 2 && f[5] > 0) {
				sb.append(m.get(5));
				sb.append(m.get(colourIndex));
				f[colourIndex]--;
				N -= 2;
				f[5]--;
			}
			
			if (colourIndex == 4 && f[1] > 0) {
				sb.append(m.get(1));
				sb.append(m.get(colourIndex));
				f[colourIndex]--;
				N -= 2;
				f[1]--;
			}
		}
		if (lastIndex == firstColour) {
			return "IMPOSSIBLE";
		}
		for (int i = 0; i < f.length; i++) {
			if (f[i] != 0) {
				return "IMPOSSIBLE";
			}
		}
		return sb.toString();
	}

	private int getPosibleMaxIndex(int[] f, int lastIndex, int firstColour) {
		int maxIndex = getMax(f);
		if (lastIndex == -1) {
			return maxIndex;
		} else {
			if (lastIndex == maxIndex) {
				if (lastIndex == 0) {
					if (f[2] == f[4] && (firstColour == 2 || firstColour == 4)) {
						return firstColour;
					}
					if (f[2] < f[4]) {
						return 4;
					} else {
						return 2;
					}
				}
				if (lastIndex == 2) {
					if (f[0] == f[4] && (firstColour == 0 || firstColour == 4)) {
						return firstColour;
					}
					if (f[0] < f[4]) {
						return 4;
					} else {
						return 0;
					}
				}
				if (lastIndex == 4) {
					if (f[0] == f[2] && (firstColour == 0 || firstColour == 2)) {
						return firstColour;
					}
					if (f[0] < f[2]) {
						return 2;
					} else {
						return 0;
					}
				}
			}
			if (lastIndex != firstColour) {
				if (lastIndex == 0) {
					if (f[2] == f[4] && (firstColour == 2 || firstColour == 4)) {
						return firstColour;
					}
				}
				if (lastIndex == 2) {
					if (f[0] == f[4] && (firstColour == 0 || firstColour == 4)) {
						return firstColour;
					}
				}
				if (lastIndex == 4) {
					if (f[0] == f[2] && (firstColour == 0 || firstColour == 2)) {
						return firstColour;
					}
				}
			}
		}
		return maxIndex;
	}

	private int getMax(int[] f) {
		int max = Integer.MIN_VALUE;
		int maxIndex = 0;
		for (int i = 0; i < f.length; i++) {
			if (max < f[i]) {
				max = f[i];
				maxIndex = i;
			}
		}
		return maxIndex;
	}

	public static void main(String[] args) throws FileNotFoundException {
		File in = new File("in.txt");
		File out = new File("out.txt");
		B b = new B();
		b.solve(in, out);
	}
}
