import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class C {

	private String solve(int x, String s) {

		StringBuilder sb = new StringBuilder();
		sb.append(s);

		char ch = getIteration(s);
		boolean sign = getSign(s);

		int[] first = getFirst(x, s);
		int[] last = getLast(x, s);

		if (first[1] + last[1] == x || first[0] == -1 || last[0] == -1) {
			return "NO";
		}

		char c = 'a';
		boolean minus = false;
		
		if (first[0] + 1 < s.length()) {
			c = s.charAt(first[0] + 1);
		}

		if (first[1] + last[1] == x - 1) {
			for (int i = first[0] + 2; i < last[0]; i++) {
				minus = sign(c, s.charAt(i), minus);
				c = multiply(c, s.charAt(i));
			}
			if (c == 'j' && minus == false) {
				return "YES";
			} else {
				return "NO";
			}
		}
				
		for (int i = first[0] + 2; i < s.length(); i++) {
			minus = sign(c, s.charAt(i), minus);
			c = multiply(c, s.charAt(i));
		}

		for (int i = 0; i < x - first[1] - last[1] - 2; i++) {
			minus = sign(c, ch, sign);
			c = multiply(c, ch);
		}

		for (int i = 0; i < last[0]; i++) {
			minus = sign(c, s.charAt(i), minus);
			c = multiply(c, s.charAt(i));
		}
		
		if (c == 'j' && minus == false) {
			return "YES";
		}

		return "NO";
	}

	private char getIteration(String s) {
		char c = s.charAt(0);
		boolean minus = false;
		for (int i = 1; i < s.length(); i++) {
			minus = sign(c, s.charAt(i), minus);
			c = multiply(c, s.charAt(i));
		}
		return c;
	}

	private boolean getSign(String s) {
		char c = s.charAt(0);
		boolean minus = false;
		for (int i = 1; i < s.length(); i++) {
			minus = sign(c, s.charAt(i), minus);
			c = multiply(c, s.charAt(i));
		}
		return minus;
	}

	private int[] getFirst(int x, String s) {
		int[] f = new int[2];
		f[0] = -1;
		char c = s.charAt(0);
		boolean minus = false;
		if (c == 'i' && !minus) {
			f[0] = 0;
			return f;
		}
		for (int i = 1; i < s.length(); i++) {
			minus = sign(c, s.charAt(i), minus);
			c = multiply(c, s.charAt(i));
			if (c == 'i' && !minus) {
				f[0] = i;
				return f;
			}
		}
		f[1]++;
		while (f[0] == -1 && x >= f[1]) {
			for (int i = 0; i < s.length(); i++) {
				minus = sign(c, s.charAt(i), minus);
				c = multiply(c, s.charAt(i));
				if (c == 'i' && !minus) {
					f[0] = i;
					return f;
				}
			}
			f[1]++;
		}
		return f;
	}

	private int[] getLast(int x, String s) {
		int[] f = new int[2];
		f[0] = -1;
		char c = s.charAt(s.length() - 1);
		boolean minus = false;
		if (c == 'k' && !minus) {
			f[0] = s.length() - 1;
			return f;
		}
		for (int i = 1; i < s.length(); i++) {
			minus = sign(s.charAt(s.length() - i - 1), c, minus);
			c = multiply(s.charAt(s.length() - i - 1), c);
			if (c == 'k' && !minus) {
				f[0] = s.length() - i - 1;
				return f;
			}
		}
		f[1]++;
		while (f[0] == -1 && x >= f[1]) {
			for (int i = 0; i < s.length(); i++) {
				minus = sign(s.charAt(s.length() - i - 1), c, minus);
				c = multiply(s.charAt(s.length() - i - 1), c);
				if (c == 'k' && !minus) {
					f[0] = s.length() - i - 1;
					return f;
				}
			}
			f[1]++;
		}
		return f;
	}

	private char multiply(char a, char b) {
		char[][] f = new char[][] { { '1', 'i', 'j', 'k' },
				{ 'i', '1', 'k', 'j' }, { 'j', 'k', '1', 'i' },
				{ 'k', 'j', 'i', '1' } };
		int x = 0;
		if (a == '1') {
			x = 0;
		}
		if (a == 'i') {
			x = 1;
		}
		if (a == 'j') {
			x = 2;
		}
		if (a == 'k') {
			x = 3;
		}

		int y = 0;
		if (b == '1') {
			y = 0;
		}
		if (b == 'i') {
			y = 1;
		}
		if (b == 'j') {
			y = 2;
		}
		if (b == 'k') {
			y = 3;
		}
		return f[x][y];
	}

	private boolean sign(char a, char b, boolean minus) {
		int x = 0;
		if (a == '1') {
			x = 0;
		}
		if (a == 'i') {
			x = 1;
		}
		if (a == 'j') {
			x = 2;
		}
		if (a == 'k') {
			x = 3;
		}

		int y = 0;
		if (b == '1') {
			y = 0;
		}
		if (b == 'i') {
			y = 1;
		}
		if (b == 'j') {
			y = 2;
		}
		if (b == 'k') {
			y = 3;
		}

		if (x == y && x != 0) {
			return !minus;
		}
		if (x == 2 && y == 1) {
			return !minus;
		}
		if (x == 3 && y == 2) {
			return !minus;
		}
		if (x == 1 && y == 3) {
			return !minus;
		}

		return minus;
	}

	public static void main(String[] args) throws FileNotFoundException {
		C c = new C();
		//Scanner s = new Scanner(System.in);
		Scanner s = new Scanner(new File("in5.in"));
		PrintWriter pw = new PrintWriter(new File("out5.out"));
		int t = s.nextInt();
		for (int i = 0; i < t; i++) {
			s.nextInt();
			int x = s.nextInt();
			pw.println("Case #" + (i + 1) + ": " + c.solve(x, s.next()));
		}
		pw.close();
		s.close();
	}

}
