import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Mines2 {

	private class Canvas {
		private int[][] f;
		private boolean[] p;
		private boolean t = false;
		private int R;
		private int C;
		private int M;

		public Canvas(int R, int C, int M) {
			this.R = R;
			this.C = C;
			this.M = M;
			p = new boolean[R * C];
						
			f = new int[C][R];
			gen(0);
			if (!t) {
				f[0][0] = -2;
				return;
			}
			int x = 0;
			int y = 0;
			for (int i = 0; i < C; i++) {
				for (int j = 0; j < R; j++) {
					if (f[i][j] == 3) {
						x = i;
						y = j;
						f[i][j] = 0;
					}
					if (f[i][j] == 2 || f[i][j] == 4) {
						f[i][j] = 0;
					}
				}
			}
			f[x][y] = 1;
			
		}

		private void gen(int odIndexu) {
			if (t) {
				return;
			}
			if (odIndexu == p.length) {
				ok();
				return;
			}

			for (int i = 0; i < 2; i++) {
				if (i == 0) {
					p[odIndexu] = true;
					gen(odIndexu + 1);
				} else {
					p[odIndexu] = false;
					gen(odIndexu + 1);
				}
			}
		}
		
		private void ok() {
			int co = 0;
			int c = 0;
			for (int i = 0; i < C; i++) {
				for (int j = 0; j < R; j++) {
					if (p[c]) {
						f[i][j] = -1;
						c++;
						co++;
					} else {
						f[i][j] = 0;
						c++;
					}
				}
			}
			if (co != M) {
				return;
			}
			
			int[] f1 = {-1,-1,-1,0,0,0,1,1,1};
			int[] f2 = {-1,1,0,-1,1,0,-1,1,0};
			int x = 0;
			int y = 0;
			
			for (int i = 0; i < C; i++) {
				for (int j = 0; j < R; j++) {
					for (int k = 0; k < f1.length; k++) {
						x = i + f1[k];
						y = j + f2[k];
						if (0 <= x && x < C && 0 <= y && y < R && f[i][j] == 0) {
							if (f[x][y] == -1) {
								f[i][j] = 2;
								continue;
							}
						}
					}
				}
			}
			
			x = -7;
			
			for (int i = 0; i < C; i++) {
				for (int j = 0; j < R; j++) {
					if (f[i][j] == 0) {
						x = i;
						y = j;
						break;
					}
				}
				if (x != -7) {
					break;
				}
			}
			dfs(x, y);
			/*for (int i = 0; i < C; i++) {
				for (int j = 0; j < R; j++) {
					System.out.print(f[i][j] + " ");
				}
				System.out.println();
			}
			System.out.println();*/
			for (int i = 0; i < C; i++) {
				for (int j = 0; j < R; j++) {
					if (f[i][j] == 0) {
						return;
					}
					if (f[i][j] == 2) {
						return;
					}
				}
			}

			t = true;
		}
		
		private void dfs(int X, int Y) {
			int[] f1 = {-1,-1,-1,0,0,0,1,1,1};
			int[] f2 = {-1,1,0,-1,1,0,-1,1,0};
			
			int x;
			int y;
			
			for (int k = 0; k < f1.length; k++) {
				x = X + f1[k];
				y = Y + f2[k];
				if (0 <= x && x < C && 0 <= y && y < R) {
					if (f[x][y] == 0) {
						f[x][y] = 3;
						dfs(x, y);
					}
					if (f[x][y] == 2) {
						f[x][y] = 4;
					}
				}
			}
		}

		private int[][] getF() {
			return f;
		}
	}

	private Canvas[] c;

	public void d() {
		File f = new File("kod.txt");
		try (Scanner s = new Scanner(f)) {

			int T = s.nextInt();
			c = new Canvas[T];
			for (int i = 0; i < T; i++) {
				System.out.println(i);
				draw(s.nextInt(), s.nextInt(), s.nextInt(), i);	
			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		f = new File("out.txt");
		try (PrintWriter pw = new PrintWriter(f)) {

			for (int i = 1; i < c.length + 1; i++) {
				pw.println("Case #" + i + ": ");
				int[][] fi = c[i - 1].getF();
				if (fi[0][0] == -2) {
					pw.println("Impossible");
					continue;
				}
				for (int j = 0; j < fi[0].length; j++) {
					for (int k = 0; k < fi.length; k++) {
						if (fi[k][j] == 0) {
							pw.print(".");
						}
						if (fi[k][j] == -1) {
							pw.print("*");
						}
						if (fi[k][j] == 1) {
							pw.print("c");
						}
					}
					pw.println();
				}
			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	private void draw(int R, int C, int M, int i) {
		Canvas c = new Canvas(R, C, M);
		this.c[i] = c;
	}

	public static void main(String[] args) {
		Mines2 m = new Mines2();
		m.d();
	}

}
