import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class A {
	
	private void solve(File in, File out) throws FileNotFoundException {
		Scanner s = new Scanner(in);
		PrintWriter pw = new PrintWriter(out);
		int T = s.nextInt();
		for (int i = 0; i < T; i++) {
			int N = s.nextInt();
			int K = s.nextInt();
			P[] f = new P[N];
			for (int j = 0; j < N; j++) {
				P p = new P();
				f[j] = p;
				f[j].R = s.nextInt();
				f[j].H = s.nextInt();
			}
			pw.println("Case #" + (i+1) + ": " + solve(N, K, f));
		}
		s.close();
		pw.flush();
		pw.close();
	}
	
	private class P implements Comparable<P> {
		long R;
		long H;
		long area;
		long sideArea;
		
		@Override
		public int compareTo(P p) {
			return Long.compare(p.area, this.area);
		} 
	}
	
	private String solve(int N, int K, P[] f) {
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < f.length; i++) {
			f[i].area = 2 * f[i].R * f[i].H + f[i].R * f[i].R;
			f[i].sideArea = 2 * f[i].R * f[i].H;
		}
		Arrays.sort(f);
		Set<Integer> s = new HashSet<>();
		s.add(0);
		long area = f[0].area;
		long R = f[0].R; 
		for (int i = 1; i < K; i++) {
			long max = 0;
			int indexMax = 0;
			for (int j = 0; j < f.length; j++) {
				if (!s.contains(j)) {
					long tmpArea = f[j].sideArea;
					if (f[j].R > R) {
						tmpArea += f[j].R * f[j].R - R*R;
					}
					if (max < tmpArea) {
						max = tmpArea;
						indexMax = j;
					}
				}
			}
			area += max;
			if (f[indexMax].R > R) {
				R = f[indexMax].R;
			}
			s.add(indexMax);
		}
		sb.append(Math.PI * ((double)(area)));
		return sb.toString();
	}

	public static void main(String[] args) throws FileNotFoundException {
		File in = new File("in.txt");
		File out = new File("out.txt");
		A a = new A();
		a.solve(in, out);
	}
}
