import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class CoinJam {
	
	int[] field;
	StringBuilder sb = new StringBuilder();
	private int count;
	
	private void solve(File in, File out) throws FileNotFoundException {
		Scanner s = new Scanner(in);
		PrintWriter pw = new PrintWriter(out);
		int T = s.nextInt();
		for (int i = 0; i < T; i++) {
			pw.println("Case #" + (i+1) + ":\n" + solveNumbers(s.nextInt(), s.nextInt()));
		}
		pw.flush();
		pw.close();
	}

	private String solveNumbers(int length, int count) {
		field = new int[length - 2];
		this.count = count;
		generate(field.length - 1);
		return sb.toString();
	}
	
	private void generate(int M) {
		if (count == 0) {
			return;
		}
		if (-1 == M) {
			isNotPrime();
			return;
		}
		for (int i = 0; i < 2; i++) {
			field[M] = i;
			generate(M - 1);
		}
	}

	private void isNotPrime() {
		int[] divisors = new int[9];
		for (int i = 2; i <= 10; i++) {
			long number = transforme(field, i);
			if (isPrime(number, divisors, i - 2)) {
				return;
			}
		}	
		print(divisors);
	}

	private long transforme(int[] field, int base) {
		long number = 0;
		long c = base;
		for (int i = 0; i < field.length; i++) {
			number += field[i] * c;
			c *= base;
		}
		number = number + c + 1;
		return number;
	}
	
	private boolean isPrime(long number, int[] divisors, int j) {
		for (int i = 2; i <= Math.sqrt(number); i++) {
			if (number % i == 0) {
				divisors[j] = i;
				return false;
			}
		}
		return true;
	}
	
	private void print(int[] divisors) {
		count--;
		sb.append("1");
		for (int i = field.length - 1; i >= 0; i--) {
			sb.append(field[i]);
		}
		sb.append("1");
		for (int i = 0; i < divisors.length; i++) {
			sb.append(" " + divisors[i]);
		}
		sb.append("\n");
	}

	public static void main(String[] args) throws FileNotFoundException {
		File in = new File("in.txt");
		File out = new File("out.txt");
		CoinJam cj = new CoinJam();
		cj.solve(in, out);
	}

}
