import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Comparator;
import java.util.LinkedList;
import java.util.Scanner;

public class B {
	private final static String QUESTION_PREFIX = "B";
	
	private static Scanner scanner;
	private static PrintWriter outputFileWriter;
	private static int lineNo;
	
	public static void main(String[] args) throws IOException {
		setupIO (args.length == 0 ? null : args[0]);
		
		int totalTC = scanner.nextInt();
		scanner.nextLine();
		
		for (int tcIdx = 0; tcIdx < totalTC; ++tcIdx) {
			// Read input						
			String s  = scanner.nextLine();
			String[] input = s.split(" ");
			int N = Integer.parseInt(input[0]);
			int K = Integer.parseInt(input[1]);
			long B = Long.parseLong(input[2]);
			int T = Integer.parseInt(input[3]);
			
			long[][] chicks = new long[N][2];
			
			LinkedList chickTime = new LinkedList();
			
			s = scanner.nextLine();
			input = s.split(" ");
			
			for (int i = 0; i < N; ++i) {
				chicks[i][0] = Long.parseLong (input[i]);
			}
		
			s = scanner.nextLine();
			input = s.split(" ");
			
			for (int i = 0; i < N; ++i) {
				chicks[i][1] = Long.parseLong (input[i]);
				
				chickTime.add((Double) ((B - chicks[i][0]) / (double) chicks[i][1])); 
			}
			
			
			int result = swap (chickTime, T,  K); 
			// Calculate
			if (result < 0)
				println ("IMPOSSIBLE");
			else 
				println (result + "");
		}				
	}
	
	private static int swap (LinkedList<Double> chickTime, int T, int K) {
		if (K == 0) {
			return 0;
		} 
		
		for (int i = chickTime.size() - 1; i >= 0; --i) {
			if (chickTime.get(i) <= T) {
				int noOfSwap = chickTime.size() - i - 1;
				chickTime.remove(i);
				return swap(chickTime, T, K - 1) + noOfSwap;
			}
		}
		
		return Integer.MIN_VALUE;		
	}
	
	private static void setupIO (String inputFileName) throws IOException{
		if (inputFileName == null) {
			inputFileName = selectInputFile();
		}
		
		File inputFile = new File (inputFileName);
		scanner = new Scanner(inputFile);
		outputFileWriter = new PrintWriter(new File(inputFile.getName().replaceAll("\\..*", ".out")));
		lineNo = 1;
		
		Runtime.getRuntime().addShutdownHook(new Thread() {
			@Override
			public void run() {
				if (scanner != null) {
					scanner.close();					
				}
				
				if (outputFileWriter != null)
					outputFileWriter.close();
			}
			
		});		
	}
	
	private static String selectInputFile() {
		File[] files = new File (".").listFiles(new FilenameFilter() {
			@Override
			public boolean accept(File dir, String name) {
				if (name.endsWith(".in") && name.startsWith(QUESTION_PREFIX))
					return true;
				else
					return false;
			}			
		});
						
		File latestFile = null;
		
		for (int i = 0; i < files.length; ++i) {
			File file = files[i];
			if (latestFile == null || file.lastModified() > latestFile.lastModified()) {
				latestFile = file;
			}
		}
						
		System.out.println ("Running " + latestFile.getName() + "......");
		return latestFile.getName();		
	}
	
	private static void println (String s) throws IOException {
		
		//System.out.println ("Case #" + (lineNo) + ": " + s);
		outputFileWriter.write("Case #" + (lineNo) + ": " + s + "\n");
		lineNo++;
	}
}

class DummyBComparator implements Comparator<String> {
	public int compare(String o1, String o2) {
		
		
		return 0;
	}	
}

class DummyBComparable implements Comparable<DummyBComparable> {
	public int compareTo(DummyBComparable o) {
		
		

		return 0;
	}	
}