import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class D {
	private final static String QUESTION_PREFIX = "D";
	
	private static Scanner scanner;
	private static PrintWriter outputFileWriter;
	private static int lineNo;
	
	public static void main(String[] args) throws IOException {
		setupIO (args.length == 0 ? null : args[0]);
		
		int totalTC = scanner.nextInt();
		
		for (int tcIdx = 0; tcIdx < totalTC; ++tcIdx) {
			// Read input						
			int k = scanner.nextInt();
			String s = scanner.next();
			
			
			char[] input = s.toCharArray();
			int[] intArr = new int[k];
			
			for (int i = 0; i < k; ++i) {
				intArr[i] = i;
			}
			
			
			// Calculate												
			println (perm2 (intArr, input) + "");
		}				

	}
	
	 // print N! permutation of the elements of array a (not in order)
    public static int perm2(int[] a, char[] input) {
       int N = a.length;       
       return perm2(a, N, input);
    }

    
    private static int perm2(int[] a, int n, char[] input) {
        if (n == 1) {
        	System.out.println (Arrays.toString(a));
        	char[] newStr = new char[input.length];
        	int aLength = a.length;
        	for (int i = 0; i < input.length; ++i) {        		
        		newStr[i] = input[a[i%aLength] + ((i / aLength)) * aLength];
        	}
        	System.out.println (new String(newStr));
        	
        	int length = 0;
        	char lastChar = '\0';
        	for (int i = 0; i < newStr.length; ++i) {
        		if (newStr[i] != lastChar) {
        			length++;
        			lastChar = newStr[i];
        		}
        	}
        	System.out.println (length);
            return length;
        }
        
        int min = Integer.MAX_VALUE;
        for (int i = 0; i < n; i++) {
            swap(a, i, n-1);
            int curValue = perm2(a, n-1, input);
            if (curValue < min)
            	min = curValue;
            swap(a, i, n-1);
        }
        
        return min;
    }  

    // swap the characters at indices i and j
    private static void swap(int[] a, int i, int j) {
        int c;
        c = a[i]; a[i] = a[j]; a[j] = c;
    }


	
	private static void setupIO (String inputFileName) throws IOException{
		if (inputFileName == null) {
			inputFileName = selectInputFile();
		}
		
		File inputFile = new File (inputFileName);
		scanner = new Scanner(inputFile);
		outputFileWriter = new PrintWriter(new File(inputFile.getName().replaceAll("\\..*", ".out")));
		lineNo = 1;
		
		Runtime.getRuntime().addShutdownHook(new Thread() {
			@Override
			public void run() {
				if (scanner != null) {
					scanner.close();					
				}
				
				if (outputFileWriter != null)
					outputFileWriter.close();
			}
			
		});		
	}
	
	private static String selectInputFile() {
		File[] files = new File (".").listFiles(new FilenameFilter() {
			@Override
			public boolean accept(File dir, String name) {
				if (name.endsWith(".in") && name.startsWith(QUESTION_PREFIX))
					return true;
				else
					return false;
			}			
		});
						
		File latestFile = null;
		
		for (int i = 0; i < files.length; ++i) {
			File file = files[i];
			if (latestFile == null || file.lastModified() > latestFile.lastModified()) {
				latestFile = file;
			}
		}
						
		System.out.println ("Running " + latestFile.getName() + "......");
		return latestFile.getName();		
	}
	
	private static void println (String s) throws IOException {
		outputFileWriter.write("Case #" + (lineNo++) + ": " + s + "\n");
	}
}

class DummyDComparator implements Comparator<String> {
	public int compare(String o1, String o2) {
		
		
		return 0;
	}	
}

class DummyDComparable implements Comparable<DummyDComparable> {

	public int compareTo(DummyDComparable o) {
		
		
		return 0;
	}	
}