import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class A {
	private final static String QUESTION_PREFIX = "A";
	
	private static Scanner scanner;
	private static PrintWriter outputFileWriter;
	private static int lineNo;
	
	public static void main(String[] args) throws IOException {
		setupIO (args.length == 0 ? null : args[0]);
		
		int totalTC = scanner.nextInt();
		scanner.nextLine();
		
		
		
		for (int tcIdx = 0; tcIdx < totalTC; ++tcIdx) {
			// Read input						
			String s  = scanner.nextLine();
			String[] input = s.split(" ");
			
			ArrayList<RobotButton> tc = new ArrayList<RobotButton>(totalTC);
			int noOfSteps = Integer.parseInt(input[0]);
			for (int stepNo = 1; stepNo < input.length; ++stepNo) {
				Robot robot = Robot.valueOf(input[stepNo++]);
				int buttonNo = Integer.parseInt(input[stepNo]);
				tc.add(new RobotButton(buttonNo, robot));
			}
			
			
			println ("" + run(tc));			
		}				
	}
	
	private static int run(ArrayList<RobotButton> tc) {
		int[] robotLo = new int[2];
		Arrays.fill(robotLo, 1);
		
		Robot currentRobot = null;
		int lastUsedSteps = 0;
		
		int result = 0;
		
		for (RobotButton rb : tc) {							
			if (currentRobot == null) {
				currentRobot = rb.robot;
			}
			
			if (currentRobot == rb.robot) {
				result += Math.abs(rb.button - robotLo[rb.robot.ordinal()]) + 1;
				lastUsedSteps += Math.abs(rb.button - robotLo[rb.robot.ordinal()]) + 1; 
				
			} else {
				currentRobot = rb.robot;
				int difference =  Math.abs(rb.button - robotLo[rb.robot.ordinal()]);
				int usedSteps = 1;
				if (difference > lastUsedSteps) {
					usedSteps = difference - lastUsedSteps + 1;
				}
				
				lastUsedSteps = usedSteps;
				result += usedSteps;
			}
			
			robotLo[rb.robot.ordinal()] = rb.button;
		}		
		
		return result;
	}
	
	private static void setupIO (String inputFileName) throws IOException{
		if (inputFileName == null) {
			inputFileName = selectInputFile();
		}
		
		File inputFile = new File (inputFileName);
		scanner = new Scanner(inputFile);
		outputFileWriter = new PrintWriter(new File(inputFile.getName().replaceAll("\\..*", ".out")));
		lineNo = 1;
		
		Runtime.getRuntime().addShutdownHook(new Thread() {
			@Override
			public void run() {
				if (scanner != null) {
					scanner.close();					
				}
				
				if (outputFileWriter != null)
					outputFileWriter.close();
			}
			
		});		
	}
	
	private static String selectInputFile() {
		File[] files = new File (".").listFiles(new FilenameFilter() {
			@Override
			public boolean accept(File dir, String name) {
				if (name.endsWith(".in") && name.startsWith(QUESTION_PREFIX))
					return true;
				else
					return false;
			}			
		});
						
		File latestFile = null;
		
		for (int i = 0; i < files.length; ++i) {
			File file = files[i];
			if (latestFile == null || file.lastModified() > latestFile.lastModified()) {
				latestFile = file;
			}
		}
						
		System.out.println ("Running " + latestFile.getName() + "......");
		return latestFile.getName();		
	}
	
	private static void println (String s) throws IOException {		
		//System.out.println ("Case #" + (lineNo) + ": " + s);
		outputFileWriter.write("Case #" + (lineNo) + ": " + s + "\n");
		lineNo++;
	}
}

enum Robot {
	O, B; 
}
class RobotButton {
	public Robot robot;
	public int button;
	public RobotButton(int button, Robot robot) {
		super();
		this.button = button;
		this.robot = robot;
	}	
}

class DummyAComparator implements Comparator<String> {
	public int compare(String o1, String o2) {
		
		
		return 0;
	}	
}

class DummyAComparable implements Comparable<DummyCComparable> {
	public int compareTo(DummyCComparable o) {
		
		

		return 0;
	}	
}