import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class A {
	private final static String QUESTION_PREFIX = "A";
	
	private static Scanner scanner;
	private static PrintWriter outputFileWriter;
	private static int lineNo;
	
	public static void main(String[] args) throws IOException {
		setupIO (args.length == 0 ? null : args[0]);
		
		int L = scanner.nextInt();
		int D = scanner.nextInt();
		int N = scanner.nextInt();
	   scanner.nextLine();
		setup(L);
		
		
		int totalTC = D;
		for (int tcIdx = 0; tcIdx < totalTC; ++tcIdx) {
			// Read input						
		   add(scanner.nextLine().trim(), tcIdx);									
		}
		
		totalTC = N;
		for (int tcIdx = 0; tcIdx < totalTC; ++tcIdx) {
			// Read input						
			String s = scanner.nextLine().trim();
			
			
			Set<Integer> result = new HashSet();
			Set<Integer> current = null;
			
			boolean isOr = false;
			int pos = 0;
			for (char c : s.toCharArray()) {
				if (c == '(') {
					isOr = true;
					current = new HashSet();
				} else if (c == ')'){
					isOr = false;
					
					if (pos == 0) {
						result.addAll(current);
					} else {
						result.retainAll(current);
					}
					pos++;
				} else {
					
					if (isOr) {
						current.addAll(dataSet[pos][getIntFromChar(c)]);
					} else if (pos == 0) {
						result.addAll(dataSet[pos][getIntFromChar(c)]);
						pos++;
					} else {
						result.retainAll(dataSet[pos][getIntFromChar(c)]);
						pos++;
					}
				}
			}
			
			// Calculate												
			println (result.size() + "");			
		}	
		
		
	   
	}
	
	private static Set[][] dataSet;
	private static void setup(int L) {
		dataSet = new Set[L][26];			
		
		for (int i = 0; i < L; ++i) {
			for (int j = 0; j < 26; ++j) {
				dataSet[i][j] = new HashSet<Integer>();
			}
		}
	}
	
	
	private static void add(String s, int index) {
		for (int i = 0; i < s.length(); ++i) {
			char c = s.charAt(i);
			
			dataSet[i][getIntFromChar(c)].add(index);
		}
	}
	
	private static int getIntFromChar (char c) {
		return (int)c - (int)'a';
	}
	
	private static void setupIO (String inputFileName) throws IOException{
		if (inputFileName == null) {
			inputFileName = selectInputFile();
		}
		
		File inputFile = new File (inputFileName);
		scanner = new Scanner(inputFile);
		outputFileWriter = new PrintWriter(new File(inputFile.getName().replaceAll("\\..*", ".out")));
		lineNo = 1;
		
		Runtime.getRuntime().addShutdownHook(new Thread() {
			@Override
			public void run() {
				if (scanner != null) {
					scanner.close();					
				}
				
				if (outputFileWriter != null)
					outputFileWriter.close();
			}
			
		});		
	}
	
	private static String selectInputFile() {
		File[] files = new File (".").listFiles(new FilenameFilter() {
			@Override
			public boolean accept(File dir, String name) {
				if (name.endsWith(".in") && name.startsWith(QUESTION_PREFIX))
					return true;
				else
					return false;
			}			
		});
						
		File latestFile = null;
		
		for (int i = 0; i < files.length; ++i) {
			File file = files[i];
			if (latestFile == null || file.lastModified() > latestFile.lastModified()) {
				latestFile = file;
			}
		}
						
		System.out.println ("Running " + latestFile.getName() + "......");
		return latestFile.getName();		
	}
	
	private static void println (String s) throws IOException {
		outputFileWriter.write("Case #" + (lineNo++) + ": " + s + "\n");
	}
}

class DummyAComparator implements Comparator<String> {
	public int compare(String o1, String o2) {
		
		
		return 0;
	}	
}

class DummyAComparable implements Comparable<DummyBComparable> {

	public int compareTo(DummyBComparable o) {
		
		
		return 0;
	}	
}