import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class A {
	private final static String QUESTION_PREFIX = "A";
	
	private static Scanner scanner;
	private static PrintWriter outputFileWriter;
	private static int lineNo;
	
	public static void main(String[] args) throws IOException {
		setupIO (args.length == 0 ? null : args[0]);
		
		int totalTC = scanner.nextInt();
		scanner.nextLine();
		
		for (int tcIdx = 0; tcIdx < totalTC; ++tcIdx) {
			// Read input						
			String s  = scanner.nextLine();
			
			String[] input = s.split(" ");
			long noOfSnapper = Long.parseLong(input[0]);
			long snapTime = Long.parseLong(input[1]);
			
			long firstOccurance = findFirst(noOfSnapper);
			assert (firstOccurance > 0);
								
         boolean isOn = ((snapTime + 1) % (firstOccurance + 1)) == 0;
         
         if (snapTime == 0)
         	isOn = false;
			// Calculate												
			println (isOn ? "ON" : "OFF");
		}				
	}
	
	private static long findFirst(long noOfsnapper) {
		if (noOfsnapper == 1) {
			return 1;
		} else {			
			return ((long) Math.pow(2, noOfsnapper)) - 1;
		}
	}
	
	private static void setupIO (String inputFileName) throws IOException{
		if (inputFileName == null) {
			inputFileName = selectInputFile();
		}
		
		File inputFile = new File (inputFileName);
		scanner = new Scanner(inputFile);
		outputFileWriter = new PrintWriter(new File(inputFile.getName().replaceAll("\\..*", ".out")));
		lineNo = 1;
		
		Runtime.getRuntime().addShutdownHook(new Thread() {
			@Override
			public void run() {
				if (scanner != null) {
					scanner.close();					
				}
				
				if (outputFileWriter != null)
					outputFileWriter.close();
			}
			
		});		
	}
	
	private static String selectInputFile() {
		File[] files = new File (".").listFiles(new FilenameFilter() {
			@Override
			public boolean accept(File dir, String name) {
				if (name.endsWith(".in") && name.startsWith(QUESTION_PREFIX))
					return true;
				else
					return false;
			}			
		});
						
		File latestFile = null;
		
		for (int i = 0; i < files.length; ++i) {
			File file = files[i];
			if (latestFile == null || file.lastModified() > latestFile.lastModified()) {
				latestFile = file;
			}
		}
						
		System.out.println ("Running " + latestFile.getName() + "......");
		return latestFile.getName();		
	}
	
	private static void println (String s) throws IOException {
		
		//System.out.println ("Case #" + (lineNo) + ": " + s);
		outputFileWriter.write("Case #" + (lineNo) + ": " + s + "\n");
		lineNo++;
	}
}

class DummyAComparator implements Comparator<String> {
	public int compare(String o1, String o2) {
		
		
		return 0;
	}	
}

class DummyAComparable implements Comparable<DummyCComparable> {
	public int compareTo(DummyCComparable o) {
		
		

		return 0;
	}	
}