import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

import javax.swing.event.ListSelectionEvent;

public class B {
	private final static String QUESTION_PREFIX = "B";
	
	private static Scanner scanner;
	private static PrintWriter outputFileWriter;
	private static int lineNo;
	
	public static void main(String[] args) throws IOException {
		
		setupIO (args.length == 0 ? null : args[0]);
		
		int totalTC = scanner.nextInt();
		
		for (int tcIdx = 0; tcIdx < totalTC; ++tcIdx) {
			// Read input						
			int H = scanner.nextInt();
			int W = scanner.nextInt();
			
			int[][] array = createArray(H, W);
			int[][] result = new int[H][W];
			
			int finishedNo = 0;			
			int nextPosX = 0, nextPosY = 0;						
			int currentIdx = 1;
			
			HashMap<Integer, Integer> resultMap = new HashMap<Integer, Integer>();		
			resultMap.put(currentIdx, currentIdx);
			
			List<Integer> distinctSet = new ArrayList<Integer>(26);
			distinctSet.add(currentIdx);
			
			while (finishedNo < H * W) {
				boolean skip = false;
				for (int i = nextPosX; i < H && !skip; ++i) {
					for (int j = nextPosY; j < W && !skip; ++j) {
						if (result[i][j] == 0) {
							result[i][j] = currentIdx;
							
							int[] nextPos = nextCell (array, H, W, i, j);
							
							if (nextPos == null) {
								nextPosX = 0;
								nextPosY = 0;
								currentIdx++;
					
								resultMap.put(currentIdx, currentIdx);
								distinctSet.add(currentIdx);
							} else {
								nextPosX = nextPos[0];
								nextPosY = nextPos[1];
								
								if (result[nextPosX][nextPosY] != 0) {
									Integer toBeMerged = resultMap.get(result[nextPosX][nextPosY]);
									Integer toBeRemoved = resultMap.get(currentIdx);
									
									if (toBeMerged < toBeRemoved) {
										distinctSet.remove(toBeRemoved);
										resultMap.put(currentIdx, toBeMerged);
									} else if (toBeMerged > toBeRemoved) {
										distinctSet.remove(toBeMerged);
										resultMap.put(result[nextPosX][nextPosY], toBeRemoved);
									}
																		
									
									nextPosX = 0;
									nextPosY = 0;
									currentIdx++;
									resultMap.put(currentIdx, currentIdx);
									distinctSet.add(currentIdx);
								}
							}	
							
							finishedNo++;
							skip = true;
						}
					}
				}
			}
			
			Collections.sort(distinctSet);
			
			StringBuilder sb = new StringBuilder();
			sb.append("\n");
			for (int i = 0; i < H; i ++) {
				for (int j = 0; j < W; ++j) {
					sb.append(getChar(distinctSet, resultMap, result[i][j]));
					
					if (j != W - 1)
						sb.append(" ");
				}
				
				if (i != H - 1)
				sb.append("\n");
			}
			
			// Calculate												
			println (sb.toString());
		}				

	}
	
	private static char getChar (List<Integer> distinctSet, HashMap<Integer, Integer> resultMap, int i) {
		Integer j = resultMap.get(i);
		
		int index = distinctSet.indexOf(j);
		
		return (char) ('a' + index);
	}
	
	private static int[] nextCell (int[][] data, int H, int W, int i, int j) {
		int North = Integer.MAX_VALUE;
		int West = Integer.MAX_VALUE;
		int East = Integer.MAX_VALUE;
		int South = Integer.MAX_VALUE;	
		
		int min = Integer.MAX_VALUE;
		int[] pos = new int[2];
		pos[0] = -1;
		pos[1] = -1;
		
		if (i != 0) {
			North = data[i - 1][j];
			
			if (North < min) {
				min = North;
				pos[0] = i - 1;
				pos[1] = j;
			}
		}
		
		if (j != 0) {
			West = data[i][j - 1];
			
			if (West < min) {
				min = West;
				pos[0] = i;
				pos[1] = j - 1;
			}
		}
		
		if (j != W - 1) {
			East = data[i][j + 1];
			
			if (East < min) {
				min = East;
				pos[0] = i;
				pos[1] = j + 1;
			}
		}
		
		
		
		if (i != H - 1) {
			South = data[i + 1][j];
			
			if (South < min) {
				min = South;
				pos[0] = i + 1;
				pos[1] = j;
			}
		}
		
		
		
		if (pos[0] != -1 && data[i][j] > min) {
			return  pos;
		} else {
			return null;
		}
			
		
	}
	
	private static int[][] createArray (int H, int W) {
		int[][] array = new int[H][W];
		for (int i = 0; i < H; ++i) {
			for (int j = 0; j < W; ++j) {
				array[i][j] = scanner.nextInt();
			}
		}
		
		
		return array;
	}
	
	private static void setupIO (String inputFileName) throws IOException{
		if (inputFileName == null) {
			inputFileName = selectInputFile();
		}
		
		File inputFile = new File (inputFileName);
		scanner = new Scanner(inputFile);
		outputFileWriter = new PrintWriter(new File(inputFile.getName().replaceAll("\\..*", ".out")));
		lineNo = 1;
		
		Runtime.getRuntime().addShutdownHook(new Thread() {
			@Override
			public void run() {
				if (scanner != null) {
					scanner.close();					
				}
				
				if (outputFileWriter != null)
					outputFileWriter.close();
			}
			
		});		
	}
	
	private static String selectInputFile() {
		File[] files = new File (".").listFiles(new FilenameFilter() {
			@Override
			public boolean accept(File dir, String name) {
				if (name.endsWith(".in") && name.startsWith(QUESTION_PREFIX))
					return true;
				else
					return false;
			}			
		});
						
		File latestFile = null;
		
		for (int i = 0; i < files.length; ++i) {
			File file = files[i];
			if (latestFile == null || file.lastModified() > latestFile.lastModified()) {
				latestFile = file;
			}
		}
						
		System.out.println ("Running " + latestFile.getName() + "......");
		return latestFile.getName();		
	}
	
	private static void println (String s) throws IOException {
		outputFileWriter.write("Case #" + (lineNo++) + ": " + s + "\n");
	}
}

class DummyBComparator implements Comparator<String> {
	public int compare(String o1, String o2) {
		
		
		return 0;
	}	
}

class DummyBComparable implements Comparable<DummyBComparable> {

	public int compareTo(DummyBComparable o) {
		
		
		return 0;
	}	
}