import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

public class B {
	private final static String QUESTION_PREFIX = "B";
	
	private static Scanner scanner;
	private static PrintWriter outputFileWriter;
	private static int lineNo;
	
	public static void main(String[] args) throws IOException {
		setupIO (args.length == 0 ? null : args[0]);
		
		int totalTC = scanner.nextInt();
		scanner.nextLine();
		
		for (int tcIdx = 0; tcIdx < totalTC; ++tcIdx) {
			// Read input						
			String s  = scanner.nextLine();
			String[] input = s.split(" ");
	
			
			HashMap<Integer, Combine> combineMap = new HashMap<Integer, Combine>();
			HashMap<Character, Set<Destroy>> destroyMap = new HashMap<Character, Set<Destroy>>();
			
			int position = 0;
			int combineCount = Integer.parseInt(input[position++]);
			
			for (int i = 0; i < combineCount; ++i) {
				String combineStr = input[position++];
				
				Combine combine = new Combine(combineStr.charAt(0), combineStr.charAt(1), combineStr.charAt(2));
				
				Combine oldCombine = combineMap.get(combine.code);
				if (oldCombine != null)
					System.out.println ("ERRRORRRR, oldCombine: " + oldCombine.c1 + oldCombine.c2);
				else
					combineMap.put(combine.code, combine);			
			}
			
			int destroyCount = Integer.parseInt(input[position++]);
			
			for (int i = 0; i < destroyCount; ++i) {
				String destroyStr = input[position++];
				
				Destroy destroy = new Destroy(destroyStr.charAt(0), destroyStr.charAt(1));
				
				Set<Destroy> destroyList = destroyMap.get(destroy.c1);
				if (destroyList == null) {
					destroyList = new HashSet<Destroy>();
					destroyMap.put(destroy.c1, destroyList);
				}
				
				destroyList.add(destroy);
				
				destroyList = destroyMap.get(destroy.c2);
				if (destroyList == null) {
					destroyList = new HashSet<Destroy>();
					destroyMap.put(destroy.c2, destroyList);
				}
				
				destroyList.add(destroy);
			}
			
			String inputStr = input[position+1];
			List<Character> result = new ArrayList<Character>(inputStr.length());
			
			for (int i = 0; i < inputStr.length(); ++i) {
				char c = inputStr.charAt(i);
				
				if (result.size() == 0) {
					result.add(c);
				} else {
					char c2 = result.get(result.size() - 1);
					
					int code = getCode(c, c2);
					Combine combine = combineMap.get(code);
					
					if (combine != null) {
						result.set(result.size() - 1, combine.combined);
					} else {
						Set<Destroy> ds = destroyMap.get(c);
						boolean isDestroy = false;
						if (ds != null) {
							for (Destroy d : ds) {
								if (result.contains(d.getNext(c))) {
									result.clear();
									isDestroy = true;
								}
							}
						}
						
						
						if (!isDestroy) 
							result.add(c);
					}
				}
			}
			
			
		   // Calculate												
			println ("" + result.toString());			
		}				
	}
	
	
	
	public static int getCode(char c1, char c2) {
		if (c1 < c2) {
			return ((int) c1) * 1000 + c2;
		} else {
			return ((int) c2) * 1000 + c1;
		}
	}
	
	private static void setupIO (String inputFileName) throws IOException{
		if (inputFileName == null) {
			inputFileName = selectInputFile();
		}
		
		File inputFile = new File (inputFileName);
		scanner = new Scanner(inputFile);
		outputFileWriter = new PrintWriter(new File(inputFile.getName().replaceAll("\\..*", ".out")));
		lineNo = 1;
		
		Runtime.getRuntime().addShutdownHook(new Thread() {
			@Override
			public void run() {
				if (scanner != null) {
					scanner.close();					
				}
				
				if (outputFileWriter != null)
					outputFileWriter.close();
			}
			
		});		
	}
	
	private static String selectInputFile() {
		File[] files = new File (".").listFiles(new FilenameFilter() {
			@Override
			public boolean accept(File dir, String name) {
				if (name.endsWith(".in") && name.startsWith(QUESTION_PREFIX))
					return true;
				else
					return false;
			}			
		});
						
		File latestFile = null;
		
		for (int i = 0; i < files.length; ++i) {
			File file = files[i];
			if (latestFile == null || file.lastModified() > latestFile.lastModified()) {
				latestFile = file;
			}
		}
						
		System.out.println ("Running " + latestFile.getName() + "......");
		return latestFile.getName();		
	}
	
	private static void println (String s) throws IOException {
		
		//System.out.println ("Case #" + (lineNo) + ": " + s);
		outputFileWriter.write("Case #" + (lineNo) + ": " + s + "\n");
		lineNo++;
	}
}

class DummyBComparator implements Comparator<String> {
	public int compare(String o1, String o2) {
		
		
		return 0;
	}	
}

class DummyBComparable implements Comparable<DummyBComparable> {
	public int compareTo(DummyBComparable o) {
		
		

		return 0;
	}	
}

class Combine {
	char c1;
	char c2;
	char combined;
	int code;
	
	public Combine(char c1, char c2, char combined) {
		super();
		this.c1 = c1;
		this.c2 = c2;
		this.combined = combined;
		code = B.getCode(c1, c2);
	}			
	
}

class Destroy {
	char c1;
	char c2;
	
		
	public Destroy(char c1, char c2) {
		super();
		this.c1 = c1;
		this.c2 = c2;
		
	}	
	
	public char getNext( char c) {
		return c == c1 ? c2 : c1;
	}
}