import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class A {
	private final static String QUESTION_PREFIX = "A";
	
	private static Scanner scanner;
	private static PrintWriter outputFileWriter;
	private static int lineNo;
	
	public static void main(String[] args) throws IOException {
		setupIO (args.length == 0 ? null : args[0]);
		
		int totalTC = scanner.nextInt();
		
		for (int tcIdx = 0; tcIdx < totalTC; ++tcIdx) {
			// Read input						
			int M = scanner.nextInt();
			int V = scanner.nextInt();
			
			boolean[] isAndGateTypes = new boolean[(M-1)/2];
			boolean[] isChangable = new boolean[(M-1)/2];
			
			Boolean[] values = new Boolean[M];
			Arrays.fill(values, null);
			
			//values[0] = V == 1 ? true : false;
			
			for (int i = 0; i < M; ++i) {
				if (i < (M - 1) / 2) {
					isAndGateTypes[i] = scanner.nextInt() == 1 ? true: false;
					isChangable[i] = scanner.nextInt() == 1 ? true : false;
				} else {
					values[i] = scanner.nextInt() == 1 ? true : false;
				}								
			}
			
			/*									
			// Calculate
			int no = Integer.MAX_VALUE;
			int true1 = calc (values, isChangable, isAndGateTypes, 1, true);
			int false1 = calc (values, isChangable, isAndGateTypes, 1, false);
			int true2 = calc (values, isChangable, isAndGateTypes, 2, true);
			int false2 = calc (values, isChangable, isAndGateTypes, 2, false);
			
			int true1false2 = (true1 == -1  || false2 == -1) ? -1 : true1 + false2;
			int true1true2 = (true1 == -1  || true2 == -1) ? -1 : true1 + true2;
			int false1false2 = (false1 == -1  || false2 == -1) ? -1 : false1 + false2;
			int false1true2 = (false1 == -1  || true2 == -1) ? -1 : false1 + true2;
			 */
			int no = calc (values, isChangable, isAndGateTypes, 0, V == 1 ? true : false);
				
			if (no == -1)
				println ("IMPOSSIBLE");
			else {
				println (no+"");
			}
		}				

	}
	
	private static int calc (Boolean[] values, boolean[] isChangables, boolean[] isAndGateTypes, int nodeNo, boolean target) {
		if (values[nodeNo] != null ) {
			if (values[nodeNo] != target)
				return -1;
			else
				return 0;
		} else {
			boolean isAnd = isAndGateTypes[nodeNo];
			boolean isChangable = isChangables[nodeNo];
			
			if (!isChangable) {
				if (isAnd) {
					if (target) {
						int true1 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 1, true);
						int true2 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 2, true);
						
						if (true1 == -1 || true2 == -1)
							return -1;
						else
							return true1 + true2;
					} else {
						int true1 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 1, true);
						int false1 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 1, false);
						int true2 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 2, true);
						int false2 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 2, false);
											
						int comb1 = (true1 == -1  || false2 == -1) ? -1 : true1 + false2;
						int comb2 = (false1 == -1 || true2 == -1) ? -1 : false1 + true2;
						int comb3 = (false1 == -1  || false2 == -1) ? -1 : false1 + false2;
						
						int min = Integer.MAX_VALUE;
						
						 if (comb1 != -1)
							 min = comb1;
						 
						 if (comb2 != -1 && comb2 < min)
							 min = comb2;
						 
						 if (comb3 != -1 && comb3 < min)
							 min = comb3;
						 
						 if (min == Integer.MAX_VALUE)
							 min = -1;
						
						return min;
					}					
				} else {
					if (target) {
						int true1 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 1, true);
						int false1 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 1, false);
						int true2 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 2, true);
						int false2 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 2, false);
											
						int comb1 = (true1 == -1  || false2 == -1) ? -1 : true1 + false2;
						int comb2 = (false1 == -1 || true2 == -1) ? -1 : false1 + true2;
						int comb3 = (true1 == -1  || true2 == -1) ? -1 : true1 + true2;
						
						int min = Integer.MAX_VALUE;
						
						 if (comb1 != -1)
							 min = comb1;
						 
						 if (comb2 != -1 && comb2 < min)
							 min = comb2;
						 
						 if (comb3 != -1 && comb3 < min)
							 min = comb3;
						 
						 if (min == Integer.MAX_VALUE)
							 min = -1;
						
						return min;
					} else {
						int false1 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 1, false);
						int false2 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 2, false);
						
						if (false1 == -1 || false2 == -1)
							return -1;
						else
							return false1 + false2;
					}
				}				
			} else {
				int true1 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 1, true);
				int false1 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 1, false);
				int true2 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 2, true);
				int false2 = calc (values, isChangables, isAndGateTypes, nodeNo * 2 + 2, false);
				
				int true1false2 = (true1 == -1  || false2 == -1) ? -1 : true1 + false2;
				int true1true2 = (true1 == -1  || true2 == -1) ? -1 : true1 + true2;
				int false1false2 = (false1 == -1  || false2 == -1) ? -1 : false1 + false2;
				int false1true2 = (false1 == -1  || true2 == -1) ? -1 : false1 + true2;
					
					
				
				if (target) {
					if (isAnd) {
						int min = Integer.MAX_VALUE;
						
						 if (true1false2 != -1)
							 min = true1false2;
						 
						 if (true1true2 != -1 && true1true2 < min)
							 min = true1true2;
						 
						 if (false1true2 != -1 && false1true2 < min)
							 min = false1true2;
						 
						 if (min == Integer.MAX_VALUE)
							 min = -1;
						 
						
						 int unchanged = true1true2;
						 
						 if ((unchanged <= min && unchanged != -1) || (unchanged != -1 && min == -1))
							 return unchanged;
						 else if (min != -1)
							 return min + 1;
						 else
							 return -1;
					} else {
						int min = Integer.MAX_VALUE;
						
						 if (true1false2 != -1)
							 min = true1false2;
						 
						 if (true1true2 != -1 && true1true2 < min)
							 min = true1true2;
						 
						 if (false1true2 != -1 && false1true2 < min)
							 min = false1true2;
						 
						 if (min == Integer.MAX_VALUE)
							 min = -1;
						 
						
						 int changed = true1true2;
						 
						 if ((min <= changed && min != -1) || (min != -1 && changed == -1))
							 return min;
						 else if (changed != -1)
							 return changed + 1;
						 else
							 return -1;
					}
				} else {
					if (isAnd) {
						int min = Integer.MAX_VALUE;
						
						 if (true1false2 != -1)
							 min = true1false2;
						 
						 if (false1false2 != -1 && false1false2 < min)
							 min = false1false2;
						 
						 if (false1true2 != -1 && false1true2 < min)
							 min = false1true2;
						 
						 if (min == Integer.MAX_VALUE)
							 min = -1;
						 
						
						 int changed = false1false2;
						 
						 if ((min <= changed && min != -1) || (min != -1 && changed == -1))
							 return min;
						 else if (changed != -1)
							 return changed + 1;
						 else
							 return -1;
					} else {
						int min = Integer.MAX_VALUE;
						
						 if (true1false2 != -1)
							 min = true1false2;
						 
						 if (false1false2 != -1 && false1false2 < min)
							 min = false1false2;
						 
						 if (false1true2 != -1 && false1true2 < min)
							 min = false1true2;
						 
						 if (min == Integer.MAX_VALUE)
							 min = -1;
						 
						
						 int unchanged = false1false2;
						 
						 if ((unchanged <= min && unchanged != -1) || (unchanged != -1 && min == -1))
							 return unchanged;
						 else if (min != -1)
							 return min + 1;
						 else
							 return -1;
					}
				}
			}
		}			
	}
	
	private static void setupIO (String inputFileName) throws IOException{
		if (inputFileName == null) {
			inputFileName = selectInputFile();
		}
		
		File inputFile = new File (inputFileName);
		scanner = new Scanner(inputFile);
		outputFileWriter = new PrintWriter(new File(inputFile.getName().replaceAll("\\..*", ".out")));
		lineNo = 1;
		
		Runtime.getRuntime().addShutdownHook(new Thread() {
			@Override
			public void run() {
				if (scanner != null) {
					scanner.close();					
				}
				
				if (outputFileWriter != null)
					outputFileWriter.close();
			}
			
		});		
	}
	
	private static String selectInputFile() {
		File[] files = new File (".").listFiles(new FilenameFilter() {
			@Override
			public boolean accept(File dir, String name) {
				if (name.endsWith(".in") && name.startsWith(QUESTION_PREFIX))
					return true;
				else
					return false;
			}			
		});
						
		File latestFile = null;
		
		for (int i = 0; i < files.length; ++i) {
			File file = files[i];
			if (latestFile == null || file.lastModified() > latestFile.lastModified()) {
				latestFile = file;
			}
		}
						
		System.out.println ("Running " + latestFile.getName() + "......");
		return latestFile.getName();		
	}
	
	private static void println (String s) throws IOException {
		outputFileWriter.write("Case #" + (lineNo++) + ": " + s + "\n");
	}
}

class DummyAComparator implements Comparator<String> {
	public int compare(String o1, String o2) {
		
		
		return 0;
	}	
}

class DummyAComparable implements Comparable<DummyAComparable> {

	public int compareTo(DummyAComparable o) {
		
		
		return 0;
	}	
}