package com.gcj;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;

public class Scalar {
	private static Scanner scanner;
	private static PrintWriter outputFileWriter;
	private static int lineNo;
	
	public static void main(String[] args) throws IOException {
		setupIO (args[0]);
		
		int totalTC = scanner.nextInt();
		
		for (int tcIdx = 0; tcIdx < totalTC; ++tcIdx) {
			// Read input
			int noOfElem = scanner.nextInt();
			ArrayList<Integer> sortedX = new ArrayList<Integer> ();
			ArrayList<Integer>  sortedY = new ArrayList<Integer> ();			
			
			for (int i = 0; i < noOfElem; ++i) {
				sortedX.add(scanner.nextInt());
			}
			
			for (int i = 0; i < noOfElem; ++i) {
				sortedY.add(scanner.nextInt());
			}
			
			Collections.sort(sortedX);
			Collections.sort(sortedY);
			
			// Calculate
			int minimumScalar = 0;
			
			while (sortedX.size() > 0) {
				int minX = sortedX.get(0);
				int maxX = sortedX.get(sortedX.size() - 1);
				
				int minY = sortedY.get(0);
				int maxY = sortedY.get(sortedX.size() - 1);
				
				if (minX * maxY < minY * maxX) {
					minimumScalar += minX * maxY;
					sortedX.remove((Integer) minX);
					sortedY.remove((Integer) maxY);
				} else {
					minimumScalar += minY * maxX;
					sortedX.remove((Integer) maxX);
					sortedY.remove((Integer) minY);
				}
			}
			
			
			println(String.valueOf(minimumScalar));			
		}				

	}
	
	private static void setupIO (String inputFileName) throws IOException{
		File inputFile = new File (inputFileName);
		scanner = new Scanner(inputFile);
		outputFileWriter = new PrintWriter(new File(inputFile.getName().replaceAll("\\..*", ".out")));
		lineNo = 1;
		
		Runtime.getRuntime().addShutdownHook(new Thread() {
			@Override
			public void run() {
				if (scanner != null) {
					scanner.close();					
				}
				
				if (outputFileWriter != null)
					outputFileWriter.close();
			}
			
		});		
	}
	
	private static void println (String s) throws IOException {
		outputFileWriter.write("Case #" + (lineNo++) + ": " + s + "\n");
	}

}
