package com.gcj;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Set;
import java.util.StringTokenizer;

public class Switch {
	private static BufferedReader inputFileReader;
	private static PrintWriter outputFileWriter;
	private static int lineNo;
	
	public static void main(String[] args) throws IOException {
		setupIO (args[0]);
		
		int totalTC = Integer.parseInt (readln());
		
		for (int tcIdx = 0; tcIdx < totalTC; ++tcIdx) {
			// Read input
			int totalSE = Integer.parseInt (readln());
			String[] seList = new String[totalSE];
			
			for (int seIdx = 0; seIdx < totalSE; ++seIdx) {
				seList[seIdx] = readln();
			}
			
			int totalQ = Integer.parseInt (readln());
			String[] qList = new String[totalQ];
			
			for (int qIdx = 0; qIdx < totalQ; ++qIdx) {
				qList[qIdx] = readln();
			}
			
			// Calculate
			HashSet occurredSet = new HashSet();
			int numOfSwitch = 0;
			String lastSE = "";
			for (int qIdx = 0; qIdx < totalQ; ++qIdx) {
				if (qList[qIdx].equals(lastSE)) {
					continue;
				}
								
				occurredSet.add(qList[qIdx]);
				
				if (occurredSet.size() == totalSE) {
					numOfSwitch++;
					occurredSet.clear();
					occurredSet.add(qList[qIdx]);
				}
				
				lastSE = qList[qIdx];
			}
				
			println(String.valueOf(numOfSwitch));	
		}				

	}
	
	private static void setupIO (String inputFileName) throws IOException{
		File inputFile = new File (inputFileName);
		inputFileReader = new BufferedReader (new FileReader(inputFile));
		outputFileWriter = new PrintWriter(new File(inputFile.getName().replaceAll("\\..*", ".out")));
		lineNo = 1;
		
		Runtime.getRuntime().addShutdownHook(new Thread() {
			@Override
			public void run() {
				if (inputFileReader != null) {
					try {
						inputFileReader.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				
				if (outputFileWriter != null)
					outputFileWriter.close();
			}
			
		});		
	}
	
	private static String readln() throws IOException {
		return inputFileReader.readLine();
	}
	
	private static void println (String s) throws IOException {
		outputFileWriter.write("Case #" + (lineNo++) + ": " + s + "\n");
	}

}
