import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GettingTheDigits {
	public static Map<Integer, String> numberStringMap = new HashMap<Integer, String>();
	static {
		numberStringMap.put(0, "ZERO");
		numberStringMap.put(1, "ONE");
		numberStringMap.put(2, "TWO");
		numberStringMap.put(3, "THREE");
		numberStringMap.put(4, "FOUR");
		numberStringMap.put(5, "FIVE");
		numberStringMap.put(6, "SIX");
		numberStringMap.put(7, "SEVEN");
		numberStringMap.put(8, "EIGHT");
		numberStringMap.put(9, "NINE");
	}
	
	public static boolean numberFound = false;
	
	public static void main(String[] args){
		// The name of the file to open.
        String fileName = "/media/brandon/My Passport/Linux/development/java/CodeJam2016/src/gettingTheDigitsIn.txt";

        // This will reference one line at a time
        String line = null;
        
        ArrayList<String> answers = new ArrayList<String>();
        try {
            // FileReader reads text files in the default encoding.
            FileReader fileReader = 
                new FileReader(fileName);

            // Always wrap FileReader in BufferedReader.
            BufferedReader bufferedReader = 
                new BufferedReader(fileReader);

            int tests = Integer.parseInt(line = bufferedReader.readLine());
            int t_idx = 1;
            while((line = bufferedReader.readLine()) != null) {
            	numberFound = false;
            	String number = findPhoneNumber(line);
                answers.add("CASE #"+t_idx+": "+number);
                t_idx++;
            }   

            
            FileWriter fw;
            try {
                fw = new FileWriter(new File("/media/brandon/My Passport/Linux/development/java/CodeJam2016/src/gettingTheDigitsOut.txt"));
                for(String answer : answers){
                	fw.write(answer);
                    fw.write(System.lineSeparator()); //new line
                }
                fw.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }

            // Always close files.
            bufferedReader.close();         
        }
        catch(FileNotFoundException ex) {
            System.out.println(
                "Unable to open file '" + 
                fileName + "'");                
        }
        catch(IOException ex) {
            System.out.println(
                "Error reading file '" 
                + fileName + "'");                  
            // Or we could just do this: 
            // ex.printStackTrace();
        }
	}
	
	public static String findPhoneNumber(String s){
		String numbers = "";
		List<Integer> matchingNums = new ArrayList<Integer>();
		System.out.println(s);

		for(int num=9; num>=0; num--){
			String n_str = numberStringMap.get(num);
			boolean matchFound = true;
			for(int i = 0; i < n_str.length(); i++){
				//find character in string;
				boolean isCharInS = false;
				for(int j = 0; j<s.length(); j++){
					if(n_str.charAt(i)==s.charAt(j)){
						isCharInS = true;
						break;
					}
				}
				if(!isCharInS){
					matchFound = false;
					break;
				}
			}
			
			if(matchFound){
				matchingNums.add(num);
				//System.out.println(" ###  FOUND " +num );
				/**/
				System.out.println(s);
				//s = tmp;
				//numbers += num;
				//num++;
			}
		}
		
		//go through list recursively until match is found where when series of numbers is removed from the 
		// string the string is empty
		
		if(s.length() > 0){
			System.err.println("INCORRECT MATCH :: "+matchingNums.size());
		}
		String vals = findCorrectNumbers(matchingNums, s);
		System.err.println("VALS :: "+vals);
		String new_str = "";
		for(int i = 0; i<vals.length(); i++){
			new_str = vals.charAt(i)+new_str;
		}
		
		return new_str;
	}
	
	public static String findCorrectNumbers(List<Integer> matchingNums, String s){
		String n_str = "";

		if(s.length() <= 0){
			System.err.println("MATCH FOUND");
			numberFound = true;
			return n_str;
		}
		
		for(Integer num : matchingNums){
			n_str = Integer.toString(num);
			String lessWord = removeWordFromString(s, numberStringMap.get(num));
			if(!lessWord.equals(s)){
				System.err.println("S : " + s);
				System.err.println("WORD : " + numberStringMap.get(num));
				n_str += findCorrectNumbers(matchingNums, lessWord);
				System.err.println("N STR :: " + n_str);

			}	
			if(numberFound){
				System.err.println("N STR :: " + n_str);

				return n_str;
			}
		}
		
		return n_str;
	}
	
	public static String removeWordFromString(String s, String word){
		String tmp = s;
		for(int idx=0; idx<word.length(); idx++){
			int c_idx = tmp.indexOf(word.charAt(idx));
			if(c_idx == 0){
				tmp= tmp.substring(c_idx+1);
			}
			else if(c_idx > 0){
				tmp = tmp.substring(0, c_idx)+tmp.substring(c_idx+1);
			}
			else{
				return s;
			}
		}
		
		return tmp;
	}
}
