import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;


public class mineSweeper {
	public static void main(String[] args){
		
		File file = new File("/home/nomad/Dev/CodeJam14/src/C-small-attempt3.in");
		List<String> inputLines = ReadWriteTextFile.getContents(file);
		
		int rows = 0;
		int cols = 0;
		int mines = 0;
		int numTests = Integer.parseInt(inputLines.remove(0));
		List<ArrayList<String>> outcomes = new ArrayList<ArrayList<String>>();
		String line = "";
		for(int i=0; i<numTests; i++){
			line =  inputLines.remove(0);
			StringTokenizer token = new StringTokenizer(line, " ");
			rows 	= Integer.parseInt(token.nextToken());
			cols 	=Integer.parseInt(token.nextToken());
			mines	= Integer.parseInt(token.nextToken());
			
			System.out.println("ROWS::"+ rows);
			System.out.println("COLUMNS::"+ cols);
			System.out.println("MINES::"+ mines);
			System.out.println("-------------------------------------");
			
			ArrayList<String> impossible = new ArrayList<String>();
			impossible.add("Case #"+(i+1)+":");
			impossible.add("Impossible");
			
			if((cols>1 && rows > 1) && (rows*cols)-4-mines < 0 && ((rows*cols)-mines)%4!=0 && (rows*cols)-mines !=1){
				System.out.println("Case #"+(i+1)+": Impossible");
				outcomes.add(impossible);
			}
			else if((cols==1 || rows == 1) && mines > (rows*cols)-2 && (rows*cols)-mines !=1){
				System.out.println("Case #"+(i+1)+": Impossible");
				outcomes.add(impossible);
			}
			else{
				
				
				if(cols == 1 || rows == 1){
					String[] board = new String[rows*cols];
					board[0] = "C";
					for(int j=1; j< board.length;j++){
						if(mines == (board.length-(j))){
							board[j]="*";
							--mines;
						}
						else{
							board[j]=".";
						}
					}
					
					ArrayList<String> lst = new ArrayList<String>();
					
					if(cols == 1){
						lst = stringify(board, new ArrayList<String>(), false);
					}
					else if(rows==1){
						lst = stringify(board, new ArrayList<String>(), true);
					}
					lst.add(0,"Case #"+(i+1)+":");
					outcomes.add(lst);
				}
				else{
					String[][] board = new String[rows][cols];
					int open_spaces = (rows*cols)-mines-1;
					List<int[]> frontier = new ArrayList<int[]>();

					if((rows*cols)-mines > 12){
						int row_center = rows/2;
						int col_center = cols/2;
						
						board[row_center][col_center]="C";
						open_spaces = fillBoard(row_center, col_center, open_spaces, board, frontier);

						while(open_spaces > 0){
							int[] coord = frontier.remove(0);
							open_spaces = fillBoard(coord[0], coord[1], open_spaces, board, frontier );
						}
					}
					else{
						board[0][0]="C";
						open_spaces = fillBoard(0, 0, open_spaces, board, frontier);

						while(open_spaces > 0){
							int[] coord = frontier.remove(0);
							open_spaces = fillBoard(coord[0], coord[1], open_spaces, board, frontier );
						}
					}
					addMines(board);
					ArrayList<String> lst = stringify(board, new ArrayList<String>());
					lst.add(0, "Case #"+(i+1)+":");
					outcomes.add(lst);
				}
			}
		}
		PrintWriter writer;
		try {
			writer = new PrintWriter("/home/nomad/Dev/CodeJam14/src/mineSweeper.out", "UTF-8");
			while(!outcomes.isEmpty()){
				ArrayList<String> lst = outcomes.remove(0);
				while(!lst.isEmpty()){
					writer.println(lst.remove(0));
				}
			}
			writer.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public static void addMines(String[][] arr){
		for(int i=0; i<arr.length; i++){
			for(int j=0; j<arr[0].length; j++){
				if(arr[i][j] == null){
					arr[i][j] = "*";
				}
			}
		}		
	}
	
	public static int fillBoard(int x, int y, int freeSpaces, String[][] arr, List<int[]> frontier){
		 
		if(x+1 < arr.length && freeSpaces >0){
			if(arr[x+1][y] == null){
				arr[x+1][y] = ".";
				--freeSpaces;
				int[] loc = {x+1,y};
				frontier.add(loc);
			}
		}
		
		if(y+1 < arr[0].length && freeSpaces >0){
			if(arr[x][y+1] == null){
				arr[x][y+1] = ".";
				--freeSpaces;
				int[] loc = {x,y+1};

				frontier.add(loc);
			}
		}
		
		if(x-1 >= 0 && freeSpaces >0){
			if(arr[x-1][y] == null){
				arr[x-1][y] = ".";
				--freeSpaces;
				int[] loc = {x-1,y};

				frontier.add(loc);
			}
		}
		
		if(y-1>=0 && freeSpaces >0){
			if(arr[x][y-1] == null){
				arr[x][y-1] = ".";
				--freeSpaces;
				int[] loc = {x,y-1};

				frontier.add(loc);
			}
		}
		
		if(x+1 < arr.length && y+1 < arr[0].length && freeSpaces >0){
			if(arr[x+1][y+1] == null){
				arr[x+1][y+1] = ".";
				--freeSpaces;
				int[] loc = {x+1,y+1};

				frontier.add(loc);
			}
		}
		if(x-1>=0 && y+1 < arr[0].length && freeSpaces >0){
			if(arr[x-1][y+1] == null){
				arr[x-1][y+1] = ".";
				--freeSpaces;
				int[] loc = {x-1,y+1};

				frontier.add(loc);
			}
		}
		
		if(x-1 >=0 && y-1 >=0 && freeSpaces >0){
			if(arr[x-1][y-1] == null){
				arr[x-1][y-1] = ".";
				--freeSpaces;
				int[] loc = {x-1,y-1};

				frontier.add(loc);
			}
		}

		if(x+1 < arr.length && y-1 >=0 && freeSpaces >0){
			if(arr[x+1][y-1] == null){
				arr[x+1][y-1] = ".";
				--freeSpaces;
				int[] loc = {x+1,y-1};

				frontier.add(loc);
			}
		}
		/*if(!frontier.isEmpty()){
			for(int[] coord: frontier){
				System.out.println("[ "+coord[0] + ", "+coord[1]+" ]");
			}
		}
		System.out.println("OPEN SPACES LEFT :: "+freeSpaces);
		System.out.println("-------------------------------------");
		*/
		return freeSpaces;
		
	}
	
	public static void fillBoardFromCorner(String[][] arr){
		for(int i=0; i<arr.length; i++){
			for(int j=0; j<arr.length; j++){
				System.out.println(arr[i][j]);
				if(i==0 && j == 0){
					arr[i][j] = "C";
				}
				else{
					arr[i][j+1] = ".";
					arr[i+1][j] = ".";
					arr[i+1][j+1] = ".";
				}

			}
		}
	}
	
	public static void printArray(String[] arr){
		for(int i=0; i<arr.length; i++){
			System.out.println(arr[i]);
		}
	}
	
	public static void printArray(String[][] arr){
		for(int i=0; i<arr.length; i++){
			for(int j=0; j<arr.length; j++){
				System.out.print(arr[i][j]+" ");
			}
			System.out.println("");
		}
	}
	
	public static ArrayList<String> stringify(String[] arr, ArrayList<String> lst, boolean isSingleRow){

		if(isSingleRow){
			String str = "";
			for(int i=0; i<arr.length; i++){
				System.out.println(arr[i]);
				str += arr[i] + " ";
			}
			lst.add(str.trim());
		}
		else{
			for(int i=0; i<arr.length; i++){
				System.out.println(arr[i]);
				lst.add(arr[i]);
			}
		}
		
		return lst;
	}
	
	public static ArrayList<String> stringify(String[][] arr,  ArrayList<String> lst){
		String str = "";
		for(int i=0; i<arr.length; i++){
			for(int j=0; j<arr[0].length; j++){
				System.out.print(arr[i][j]+" ");
				str += arr[i][j]+" ";
			}
			System.out.println("");
			
			lst.add(str.trim());
			str="";
		}
		
		return lst;
	}
}
