package com.code.jam.roller;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.LinkedList;

public class RollerCoasterTest {

	public static void main(String[] args) throws FileNotFoundException {
		RollerCoasterTest tc = new RollerCoasterTest();
		tc.runTestCases();
	}

	public void runTestCases() throws FileNotFoundException {
		try {

			DataInputStream in = new DataInputStream(this.getClass()
					.getResourceAsStream("small.in"));
			BufferedReader br = new BufferedReader(new InputStreamReader(in));

			FileOutputStream fostream = new FileOutputStream("roller_small.out");
			DataOutputStream out = new DataOutputStream(fostream);
			BufferedWriter wr = new BufferedWriter(new OutputStreamWriter(out));

			String strLine;

			int T = 1;
			br.readLine(); // Skip the first line
			long k = 0, R = 0;
			while ((strLine = br.readLine()) != null) {
				String[] rKNLine = strLine.split(" ");

				if (rKNLine.length == 3) {
					R = Long.parseLong(rKNLine[0]);
					k = Long.parseLong(rKNLine[1]);

					String[] gLine = br.readLine().split(" ");
					long i = 0;
					RollerCoaster rc = new RollerCoaster();
					while (i != gLine.length) {
						rc.getQueue().offer(Long.parseLong(gLine[(int) i]));
						i++;
					}

					long money = rc.computeMoneyMade(R, k);
					StringBuffer outLine = new StringBuffer();
					outLine.append("Case #").append(T).append(": ").append(
							money);
					wr.write(outLine.toString());
					wr.newLine();
					T++;
				}
			}

			in.close();
			wr.flush();
			wr.close();
		} catch (Exception e) {// Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
	}
}

class RollerCoaster {

	private LinkedList<Long> queue;

	public LinkedList<Long> getQueue() {
		return queue;
	}

	public RollerCoaster() {
		queue = new LinkedList<Long>();
	}

	public long computeMoneyMade(final long R, final long k) {
		long money = 0;
		for (long i = 0; i < R; i++) {
			money += computeMoneyMadeInEachRound(k, 0);
		}
		return money;
	}

	private long computeMoneyMadeInEachRound(final long numberOfSeats,
			long currentNumOfFolks) {
		long nextGroup = 0;
		long number = 1;
		long money = 0;
		while (currentNumOfFolks <= numberOfSeats && number <= queue.size()) {
			nextGroup = queue.peek();
			currentNumOfFolks = currentNumOfFolks + nextGroup;
			if (currentNumOfFolks <= numberOfSeats) {
				money += nextGroup;
				queue.offer(queue.poll());

			}
			number++;
		}
		return money;
	}
}
