package com.code.jam.snap;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

public class Snapper {

	public static void main(String[] args) throws FileNotFoundException {
		Snapper s = new Snapper();
		s.findLightsStatus();
	}

	public void findLightsStatus() throws FileNotFoundException {
		try {

			DataInputStream in = new DataInputStream(this.getClass()
					.getResourceAsStream("large.in"));
			BufferedReader br = new BufferedReader(new InputStreamReader(in));

			FileOutputStream fostream = new FileOutputStream("snap_large.out");
			DataOutputStream out = new DataOutputStream(fostream);
			BufferedWriter wr = new BufferedWriter(new OutputStreamWriter(out));

			String strLine;

			int T = 1;
			while ((strLine = br.readLine()) != null) {
				String[] input = strLine.split(" ");
				if (input.length == 2) {
					final long N = Long.parseLong(input[0]);
					final long K = Long.parseLong(input[1]);
					boolean isPresent = isLighON(N, K);
					StringBuffer outLine = new StringBuffer();
					outLine.append("Case #").append(T).append(":");
					if (isPresent) {
						outLine.append(" ON");
					} else {
						outLine.append(" OFF");
					}
					wr.write(outLine.toString());
					wr.newLine();
					T++;
				}
			}
			in.close();
			wr.flush();
			wr.close();
		} catch (Exception e) {// Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
	}

	private boolean isLighON(final long N, final long K) {
		boolean isON = false;
		final double difference = Math.pow(2, N);
		final long firstTerm = computeFirstTerm(N);
		isON = isKInSequence(difference, firstTerm, K);
		return isON;
	}

	private long computeFirstTerm(final long N) {
		long firstTerm = 1, newFirstTerm = 1;
		for (long d = 1; d < N; d++) {
			newFirstTerm = (firstTerm * 2) + 1;
			firstTerm = newFirstTerm;
		}
		return newFirstTerm;

	}

	private boolean isKInSequence(final double d, final long a0, final long K) {
		double aN = a0;
		long n = 2;
		while (K >= aN) {
			if (aN == K) {
				return true;
			}
			aN = a0 + (n - 1) * d;
			n++;
		}
		return false;
	}
}
