package game;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class Main {
	public static void main(String[] args){
		
		try {
			BufferedReader input = new BufferedReader(new FileReader("input.in"));
			PrintWriter output = new PrintWriter(new FileWriter("output.out"));
			
			int numOfTestCases = Integer.parseInt(input.readLine());
			int i = 0;
			char[][] table = new char[4][4];
			while(i<numOfTestCases){
				
				// read test case into 4x4 array
				int j = 0;
				while (j < 4){
					String line = input.readLine();
					for (int k=0; k<4; k++){
						table[j][k] = line.charAt(k);
					}
					j++;
				}
				input.readLine();
				i++;
				
				// check game state
				
				// store number of each character in row
				int numX = 0;
				int numO = 0;
				int numT = 0;
				int numDot = 0;
				
				// check horizontal lines
				int m = 0;
				boolean winnerFound = false;
				StringBuffer resultMessage = new StringBuffer("Draw");
				while (m < 4 && !winnerFound){
					int n = 0;
					
					// store number of each character in row
					numX = 0;
					numO = 0;
					numDot = 0;
					numT = 0;
					
					if (!winnerFound){
						// go through row and count each character
						while (n < 4){
							if (table[m][n] == 'X'){
								numX++;
							} else if (table[m][n] == 'O'){
								numO++;
							} else if (table[m][n] == 'T'){
								numT++;
							} else {
								numDot++;
							}
						
							n++;
						}
					
						// process row state
						winnerFound = processRow(resultMessage, numX, numO, numT, numDot);
					}
					
					m++;
					
				}
				
				// check vertical lines
				m = 0;
				while (m < 4 && !winnerFound){
					int n = 0;
					
					// store number of each character in row
					numX = 0;
					numO = 0;
					numDot = 0;
					numT = 0;
					
					if (!winnerFound){
						// go through row and count each character
						while (n < 4){
							if (table[n][m] == 'X'){
								numX++;
							} else if (table[n][m] == 'O'){
								numO++;
							} else if (table[n][m] == 'T'){
								numT++;
							} else {
								numDot++;
							}
						
							n++;
						}
					
						// process row state
						winnerFound = processRow(resultMessage, numX, numO, numT, numDot);
					}
					m++;
					
				}
				
				// check diagonal lines
				if (!winnerFound){
					// process first diagonal
					// store number of each character in row
					numX = 0;
					numO = 0;
					numDot = 0;
					numT = 0;
				
					m = 0;
					while (m < 4 && !winnerFound){
						if (table[m][m] == 'X'){
							numX++;
						} else if (table[m][m] == 'O'){
							numO++;
						} else if (table[m][m] == 'T'){
							numT++;
						} else {
							numDot++;
						}
					
						m++;
					}
				
					// process row state
					winnerFound = processRow(resultMessage, numX, numO, numT, numDot);
				}
				
				if (!winnerFound){
					// process second diagonal
					// store number of each character in row
					numX = 0;
					numO = 0;
					numDot = 0;
					numT = 0;
					
					m = 0;
					while (m < 4){
						if (table[3-m][m] == 'X'){
							numX++;
						} else if (table[3-m][m] == 'O'){
							numO++;
						} else if (table[3-m][m] == 'T'){
							numT++;
						} else {
							numDot++;
						}
					
						m++;
					}
				
					// process row state
					winnerFound = processRow(resultMessage, numX, numO, numT, numDot);
				}
				output.print("Case #" + i + ": ");
				output.println(resultMessage);
			}
			
			input.close();
			output.close();
		} catch (FileNotFoundException e) {
			System.out.println("File not found!");
			e.printStackTrace();
		} catch (IOException e) {
			System.out.println("Error reading file!");
			e.printStackTrace();
		}
	}
	
	/**
	 * 
	 * @param resultMessage result message to be printed in output
	 * @param numX number of 'X' in a row
	 * @param numO number of 'O' in a row
	 * @param numT number of 'T' in a row
	 * @param numDot number of '.' in a row
	 * @return true if winner is found, false otherwise
	 */
	public static boolean processRow(StringBuffer resultMessage, int numX, int numO, int numT, int numDot){
		boolean winnerFound = false;
		if ((numX == 4) || (numX == 3 && numT == 1)){
			winnerFound = true;
			resultMessage.replace(0, resultMessage.length(), "X won");
		} else if ((numO == 4) || (numO == 3 && numT == 1)){
			winnerFound = true;
			resultMessage.replace(0, resultMessage.length(), "O won");
		} else if (numDot > 0){
			resultMessage.replace(0, resultMessage.length(), "Game has not completed");
		}
		
		return winnerFound;
	}
}
