package google.code.jam.flippancakes;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Set;

public class Pancakes {
	public static void main(String[] args) {
		try (BufferedReader br = new BufferedReader(new FileReader(args[0])))
		{
			PrintWriter writer = new PrintWriter(args[1]);
			
			int numOfTestCases = Integer.parseInt(br.readLine());
			for (int i = 1; i <= numOfTestCases; i++) {
				char[] pancakeStack = br.readLine().toCharArray();
				int flips = 0;
				boolean finished = false;
				
				while (!finished) {
					int j = 0;
					boolean changed = false;
					while (j < pancakeStack.length - 1 && !changed) {
						if (pancakeStack[j] != pancakeStack[j + 1]) {
							changed = true;
							flips++;
							
							for (int k = 0; k < j + 1; k++) {
								pancakeStack[k] = pancakeStack[k] == '+' ? '-' : '+';
							}
						} else {
							j++;
						}
					}
					if (!changed) {
						flips += pancakeStack[0] == '+' ? 0 : 1;
						finished = true;
					}
				}
				
				writer.println("Case #" + i + ": " + flips);
			}
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		} 
	}
}
