package google.code.jam.magicshow;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

public class MagicShow {
	public static void main(String[] args) {
		try (BufferedReader br = new BufferedReader(new FileReader(args[0])))
		{
			PrintWriter writer = new PrintWriter(args[1]);
			
			int numOfTestCases = Integer.parseInt(br.readLine());
			for (int i=1; i<=numOfTestCases; i++){
				Set<String> firstRowOfInterest = findRowOfInterest(br);
				Set<String> secondRowOfInterest = findRowOfInterest(br);
				
				firstRowOfInterest.retainAll(secondRowOfInterest);
				if (firstRowOfInterest.size() == 0){
					// Volunteer cheated!
					writer.println("Case #" + i + ": Volunteer cheated!");
					
				} else if (firstRowOfInterest.size() > 1) {
					// Bad magician!
					writer.println("Case #" + i + ": Bad magician!");
				} else {
					// value found
					writer.println("Case #" + i + ": " + firstRowOfInterest.iterator().next());
				}
			}
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		} 
	}
	
	private static Set<String> findRowOfInterest(BufferedReader br) throws NumberFormatException, IOException{
		int answer = Integer.parseInt(br.readLine());
		int j = 1;
		while (j < answer) {
			br.readLine();
			j++;
		}
		String[] rowOfInterest = br.readLine().split(" ");
		while (j < 4) {
			br.readLine();
			j++;
		}
		return new HashSet<String>(Arrays.asList(rowOfInterest));
	}
}
