package palindrome;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class Main {
	public static void main(String[] args){
		
		try {
			BufferedReader input = new BufferedReader(new FileReader("input.in"));
			PrintWriter output = new PrintWriter(new FileWriter("output.out"));
			
			int numOfTestCases = Integer.parseInt(input.readLine());
			int i = 0;
			while (i < numOfTestCases){
				String line = input.readLine();
				String[] boundaries = line.split(" ");
				long lowerBound = Long.parseLong(boundaries[0]);
				long higherBound = Long.parseLong(boundaries[1]);
				
				long startNumber = (long) Math.ceil(Math.sqrt(lowerBound));
				long endNumber = (long) Math.floor(Math.sqrt(higherBound));
				
				int fairAndSquareCount = 0;
				for (long j = startNumber; j <= endNumber; j++){
					if (palindrome(j) && (palindrome(j*j))){
						fairAndSquareCount++;
					}
				}
				i++;
				
				output.println("Case #" + i + ": " + fairAndSquareCount);
			}
			
			input.close();
			output.close();
		} catch (FileNotFoundException e) {
			System.out.println("File not found!");
			e.printStackTrace();
		} catch (IOException e) {
			System.out.println("Error reading file!");
			e.printStackTrace();
		}
	}
	
	/**
	 * Checks whether provided number is palindrome
	 * 
	 * @param number the number to check
	 * @return true if number is palindrome, false otherwise
	 */
	public static boolean palindrome(long number){
		long reversedNumber = 0;
		long n = number;
		while (n > 0){
			long digit = n % 10;
			reversedNumber = reversedNumber * 10 + digit;
			n = n / 10;
		}
		
		if (reversedNumber == number){
			return true;
		} else {
			return false;
		}
	}
}
