package google.code.jam.deceitfulwar;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class DeceitfulWar {
	public static void main(String[] args) {
		try (BufferedReader br = new BufferedReader(new FileReader(args[0])))
		{
			PrintWriter writer = new PrintWriter(args[1]);
			
			int numOfTestCases = Integer.parseInt(br.readLine());
			for (int i=1; i<=numOfTestCases; i++){
				int numOfBlocks = Integer.parseInt(br.readLine());
				String[] naomiBlocksLine = br.readLine().split(" ");
				String[] kenBlocksLine = br.readLine().split(" ");
				
				int deceiveWarScore = deceiveWarScore(naomiBlocksLine, kenBlocksLine);
				int warScore  = warScore(naomiBlocksLine, kenBlocksLine);
				writer.println("Case #" + i + ": " + deceiveWarScore + " " + warScore);
			}
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		} 
	}
	
	private static int deceiveWarScore(String[] naomiBlocksLine, String[] kenBlocksLine) {
		List<Double> naomiBlocks = new ArrayList<>();
		List<Double> kenBlocks = new ArrayList<>();
		for (int j = 0; j < naomiBlocksLine.length; j++){
			naomiBlocks.add(Double.parseDouble(naomiBlocksLine[j]));
		}
		Collections.sort(naomiBlocks);
		Collections.reverse(naomiBlocks);
		for (int j = 0; j < kenBlocksLine.length; j++){
			kenBlocks.add(Double.parseDouble(kenBlocksLine[j]));
		}
		Collections.sort(kenBlocks);
		Collections.reverse(kenBlocks);
		int deceiveWarScore = 0;
		while (naomiBlocks.size() > 0) {
			if (naomiBlocks.get(0) > kenBlocks.get(0)) {
				// Naomi should deceive Ken that she will play block that he can't match
				// he will then play his lowest value block and Naomi will play her lowest value block
				// which beats Ken's and she will score
				deceiveWarScore++;
				Double kenPlayed = kenBlocks.remove(kenBlocks.size() - 1);
				int naomiPlayedIndex = naomiBlocks.size()-1;
				while (naomiBlocks.get(naomiPlayedIndex) < kenPlayed){
					naomiPlayedIndex--;
				}
				naomiBlocks.remove(naomiPlayedIndex);
			} else {
				// Naomi should deceive Ken that she will play block that he must beat with his highest block
				// Then Naomi will play her lowest block, Ken will score but will also lose his most valuable block
				kenBlocks.remove(0);
				naomiBlocks.remove(naomiBlocks.size() - 1);
			}
		}
		return deceiveWarScore;
	}
	
	private static int warScore(String[] naomiBlocksLine, String[] kenBlocksLine) {
		List<Double> naomiBlocks = new ArrayList<>();
		List<Double> kenBlocks = new ArrayList<>();
		for (int j = 0; j < naomiBlocksLine.length; j++){
			naomiBlocks.add(Double.parseDouble(naomiBlocksLine[j]));
		}
		Collections.sort(naomiBlocks);
		Collections.reverse(naomiBlocks);
		for (int j = 0; j < kenBlocksLine.length; j++){
			kenBlocks.add(Double.parseDouble(kenBlocksLine[j]));
		}
		Collections.sort(kenBlocks);
		Collections.reverse(kenBlocks);
		int warScore = 0;
		while (naomiBlocks.size() > 0) {
			if (naomiBlocks.get(0) > kenBlocks.get(0)) {
				warScore++;
				kenBlocks.remove(kenBlocks.size() - 1);
				naomiBlocks.remove(0);
			} else {
				kenBlocks.remove(0);
				naomiBlocks.remove(0);
			}
		}
		return warScore;
	}
}
