package com.deividasg.codejam.a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Arrays;

public class Main {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new FileReader("./res/input.in"));
		BufferedWriter bw = new BufferedWriter(new FileWriter(
				"./res/output.out"));

		int cases = Integer.parseInt(br.readLine());

		for (int i = 0; i < cases; i++) {
			System.out.print("case " + (i + 1) + " ");
			String[] lines = new String[4];
			boolean found = false;
			boolean finished = true;
			for (int j = 0; j < 4; j++) {
				lines[j] = br.readLine();
			}
			// horizontal
			for (int j = 0; j < lines.length; j++) {
				String line = lines[j];
				if (line.equals("XXXX") || line.equals("TXXX")
						|| line.equals("XXXT") || line.equals("XTXX")
						|| line.equals("XXTX")) {
					System.out.println("X Wins! horizontal");
					bw.write("Case #" + (i + 1) + ": X won");
					found = true;
					break;
				}
				if (line.equals("OOOO") || line.equals("TOOO")
						|| line.equals("OOOT") || line.equals("OTOO")
						|| line.equals("OOTO")) {
					System.out.println("O Wins! horizontal");
					bw.write("Case #" + (i + 1) + ": O won");
					found = true;
					break;
				}
				if (line.contains(".")) {
					finished = false;
				}
			}
			br.readLine();
			if (!found) {
				// vertical
				for (int j = 0; j < 4; j++) {
					StringBuilder lineBuilder = new StringBuilder();
					lineBuilder.append(lines[0].charAt(j));
					lineBuilder.append(lines[1].charAt(j));
					lineBuilder.append(lines[2].charAt(j));
					lineBuilder.append(lines[3].charAt(j));

					String line = lineBuilder.toString();
					if (line.equals("XXXX") || line.equals("TXXX")
							|| line.equals("XXXT") || line.equals("XTXX")
							|| line.equals("XXTX")) {
						System.out.println("X Wins! vertical");
						bw.write("Case #" + (i + 1) + ": X won");
						found = true;
						break;
					}
					if (line.equals("OOOO") || line.equals("TOOO")
							|| line.equals("OOOT") || line.equals("OTOO")
							|| line.equals("OOTO")) {
						System.out.println("O Wins! vertical");
						bw.write("Case #" + (i + 1) + ": O won");
						found = true;
						break;
					}
				}
			}

			// left cross
			String crossLine = "";
			StringBuilder lineBuilder = new StringBuilder();
			if (!found) {
				for (int j = 0; j < 4; j++) {
					lineBuilder.append(lines[j].charAt(j));
					crossLine = lineBuilder.toString();
				}

				if (crossLine.equals("XXXX") || crossLine.equals("TXXX")
						|| crossLine.equals("XXXT") || crossLine.equals("XTXX")
						|| crossLine.equals("XXTX")) {
					System.out.println("X Wins! left cross");
					bw.write("Case #" + (i + 1) + ": X won");
					found = true;
				}
				if (crossLine.equals("OOOO") || crossLine.equals("TOOO")
						|| crossLine.equals("OOOT") || crossLine.equals("OTOO")
						|| crossLine.equals("OOTO")) {
					System.out.println("O Wins! left cross");
					bw.write("Case #" + (i + 1) + ": O won");
					found = true;
				}
			}
			// right cross
			lineBuilder = new StringBuilder();
			if(!found){
				for (int j = 0; j < 4; j++) {
					lineBuilder.append(lines[j].charAt(3 - j));
					crossLine = lineBuilder.toString();
				}
	
				if (crossLine.equals("XXXX") || crossLine.equals("TXXX")
						|| crossLine.equals("XXXT") || crossLine.equals("XTXX")
						|| crossLine.equals("XXTX")) {
					System.out.println("X Wins! right cross");
					bw.write("Case #" + (i + 1) + ": X won");
					found = true;
				}
				if (crossLine.equals("OOOO") || crossLine.equals("TOOO")
						|| crossLine.equals("OOOT") || crossLine.equals("OTOO")
						|| crossLine.equals("OOTO")) {
					System.out.println("O Wins! right cross");
					bw.write("Case #" + (i + 1) + ": O won");
					found = true;
				}
			}
			if (!found) {
				if (finished) {
					System.out.println("Draw");
					bw.write("Case #" + (i + 1) + ": Draw");
				} else {
					System.out.println("Not completed");
					bw.write("Case #" + (i + 1) + ": Game has not completed");
				}

			}
			bw.write("\n");
		}

		br.close();
		bw.close();
	}

}
