import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.InputMismatchException;

public class B {
	public static void main(String[] args) throws FileNotFoundException {
		FastScannerB sc = new FastScannerB(new FileInputStream(new File("inputB.txt")));
		PrintWriter pw = new PrintWriter(new File("outputB.txt"));
		
		int T = sc.nextInt();
		for(int t = 1; t <= T; t++){
			StringBuilder sb = new StringBuilder();
			
			int N = sc.nextInt();
			int C = sc.nextInt();
			int M = sc.nextInt();
			
			int[] arr1 = new int[N];
			int[] arr2 = new int[N];
			
			for(int i = 0; i<M; i++){
				int u = sc.nextInt() - 1;
				int v = sc.nextInt();
				if(v == 1){
					arr1[u]++;
				}
				else{
					//v == 2
					arr2[u]++;
				}
			}
			
			//player 1
			ArrayList<Drive> drives = new ArrayList<>();
			for(int i = 0; i<N; i++){
				for(int j = 0; j<arr1[i]; j++){
					Drive d = new Drive();
					d.player1 = i;
					drives.add(d);
				}
			}
			
			//player 2
			int swaps = 0;
			int extra = 0;
			for(int i = 0; i<N; i++){
				for(int j = 0; j<arr2[i]; j++){	//max 1000
					
					boolean found = false;
					for(Drive d : drives){
						if(d.done) continue;
						
						if(d.player1 != i){
							d.done = true;
							found = true;
							break;
						}
						else{
							//same
							if(i == 0) continue;
							else{
								d.done = true;
								found = true;
								swaps++;
								break;
							}
						}
					}
					if(!found){
						extra++;
					}
				}
			}
			
			int ans = extra + drives.size();
			int ann = swaps;
			
			sb.append("Case #");
			sb.append(t);
			sb.append(": ");
			sb.append(ans + " " + ann);
			sb.append('\n');
			System.out.print(sb);
			pw.write(sb.toString());
		}
		
		pw.close();
	}
}

class Drive{
	int player1;
	int player2;
	boolean done;
	Drive(){
		player1 = -1;
		player2 = -1;
		done = false;
	}
}

class FastScannerB{
    private InputStream stream;
    private byte[] buf = new byte[1024];
    private int curChar;
    private int numChars;
    private SpaceCharFilter filter;

    public FastScannerB(InputStream stream)
    {
        this.stream = stream;
    }

    public int read()
    {
        if (numChars == -1)
            throw new InputMismatchException();
        if (curChar >= numChars)
        {
            curChar = 0;
            try
            {
                numChars = stream.read(buf);
            } catch (IOException e)
            {
                throw new InputMismatchException();
            }
            if (numChars <= 0)
                return -1;
        }
        return buf[curChar++];
    }

    public int nextInt()
    {
        int c = read();
        while (isSpaceChar(c))
            c = read();
        int sgn = 1;
        if (c == '-')
        {
            sgn = -1;
            c = read();
        }
        int res = 0;
        do
        {
            if (c < '0' || c > '9')
                throw new InputMismatchException();
            res *= 10;
            res += c - '0';
            c = read();
        } while (!isSpaceChar(c));
        return res * sgn;
    }

    public String next()
    {
        int c = read();
        while (isSpaceChar(c))
            c = read();
        StringBuilder res = new StringBuilder();
        do
        {
            res.appendCodePoint(c);
            c = read();
        } while (!isSpaceChar(c));
        return res.toString();
    }
    
    public String nextLine()
    {
        int c = read();
        StringBuilder res = new StringBuilder();
        do
        {
            res.appendCodePoint(c);
            c = read();
        } while (!isLineEndChar(c));
        return res.toString();
    }    
    
    public double nextDouble() {
        int c = read();
        while (isSpaceChar(c))
            c = read();
        int sgn = 1;
        if (c == '-') {
            sgn = -1;
            c = read();
        }
        double res = 0;
        while (!isSpaceChar(c) && c != '.') {
            if (c == 'e' || c == 'E')
                return res * Math.pow(10, nextInt());
            if (c < '0' || c > '9')
                throw new InputMismatchException();
            res *= 10;
            res += c - '0';
            c = read();
        }
        if (c == '.') {
            c = read();
            double m = 1;
            while (!isSpaceChar(c)) {
                if (c == 'e' || c == 'E')
                    return res * Math.pow(10, nextInt());
                if (c < '0' || c > '9')
                    throw new InputMismatchException();
                m /= 10;
                res += (c - '0') * m;
                c = read();
            }
        }
        return res * sgn;
    }
    
    public long nextLong() {
        int c = read();
        while (isSpaceChar(c))
            c = read();
        int sgn = 1;
        if (c == '-') {
            sgn = -1;
            c = read();
        }
        long res = 0;
        do {
            if (c < '0' || c > '9')
                throw new InputMismatchException();
            res *= 10;
            res += c - '0';
            c = read();
        } while (!isSpaceChar(c));
        return res * sgn;
    }
    
    public boolean isSpaceChar(int c)
    {
        if (filter != null)
            return filter.isSpaceChar(c);
        return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
    }
    
    public boolean isLineEndChar(int c)
    {
        if (filter != null)
            return filter.isSpaceChar(c);
        return c == '\n' || c == '\r' || c == -1;
    }

    public interface SpaceCharFilter
    {
        public boolean isSpaceChar(int ch);
    }
}