import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.InputMismatchException;

public class A {
	public static void main(String[] args) throws FileNotFoundException {
		FastScannerA sc = new FastScannerA(new FileInputStream(new File("inputA.txt")));
		PrintWriter pw = new PrintWriter(new File("outputA.txt"));
		
		int T = sc.nextInt();
		for(int t = 1; t <= T; t++){
			StringBuilder sb = new StringBuilder();
			
			int N = sc.nextInt();
			int K = sc.nextInt();
			double U = sc.nextDouble();
			double[] arr = new double[N];
			for(int i = 0; i<N; i++) arr[i] = sc.nextDouble();
			Arrays.sort(arr);
			
			while(U > 0){
				double lowest = arr[0];
				double second = arr[0];
				int ind = 0;
				while(lowest == second){
					ind++;
					if(ind == N) break;
					second = arr[ind];
				}
				if(ind == N){
					//site isti
					double piece = U / N;
					for(int i = 0; i<N; i++){
						arr[i] = Math.min(arr[i] + piece, 1);
					}
					break;
				}
				else{
					second = arr[ind];
					double piece = Math.min(U / ind, second - lowest);
					for(int i = 0; i<ind; i++){
						arr[i] += piece;
					}
					U -= piece * ind;
				}
			}
//			
//			
//			
//			
//			
//			
//			double remain = U;
//			
//			while(N > 0 && remain > 0){
//				while(N > 0 && arr[N - 1] == 1) N--;
//				
//				double piece = remain / N;
//				remain = 0;
//				for(int i = 0; i<N; i++){
//					if(arr[i] + piece <= 1) arr[i] += piece;
//					else{
//						remain += piece - (1.0 - arr[i]);
//						arr[i] = 1;
//					}
//				}
//			}
			
			double ans = 1;
			for(double d : arr) ans *= d;
			
			sb.append("Case #");
			sb.append(t);
			sb.append(": ");
			sb.append(ans);
			sb.append('\n');
			System.out.print(sb);
			pw.write(sb.toString());
		}
		
		pw.close();
	}
}

class FastScannerA{
    private InputStream stream;
    private byte[] buf = new byte[1024];
    private int curChar;
    private int numChars;
    private SpaceCharFilter filter;

    public FastScannerA(InputStream stream)
    {
        this.stream = stream;
    }

    public int read()
    {
        if (numChars == -1)
            throw new InputMismatchException();
        if (curChar >= numChars)
        {
            curChar = 0;
            try
            {
                numChars = stream.read(buf);
            } catch (IOException e)
            {
                throw new InputMismatchException();
            }
            if (numChars <= 0)
                return -1;
        }
        return buf[curChar++];
    }

    public int nextInt()
    {
        int c = read();
        while (isSpaceChar(c))
            c = read();
        int sgn = 1;
        if (c == '-')
        {
            sgn = -1;
            c = read();
        }
        int res = 0;
        do
        {
            if (c < '0' || c > '9')
                throw new InputMismatchException();
            res *= 10;
            res += c - '0';
            c = read();
        } while (!isSpaceChar(c));
        return res * sgn;
    }

    public String next()
    {
        int c = read();
        while (isSpaceChar(c))
            c = read();
        StringBuilder res = new StringBuilder();
        do
        {
            res.appendCodePoint(c);
            c = read();
        } while (!isSpaceChar(c));
        return res.toString();
    }
    
    public String nextLine()
    {
        int c = read();
        StringBuilder res = new StringBuilder();
        do
        {
            res.appendCodePoint(c);
            c = read();
        } while (!isLineEndChar(c));
        return res.toString();
    }    
    
    public double nextDouble() {
        int c = read();
        while (isSpaceChar(c))
            c = read();
        int sgn = 1;
        if (c == '-') {
            sgn = -1;
            c = read();
        }
        double res = 0;
        while (!isSpaceChar(c) && c != '.') {
            if (c == 'e' || c == 'E')
                return res * Math.pow(10, nextInt());
            if (c < '0' || c > '9')
                throw new InputMismatchException();
            res *= 10;
            res += c - '0';
            c = read();
        }
        if (c == '.') {
            c = read();
            double m = 1;
            while (!isSpaceChar(c)) {
                if (c == 'e' || c == 'E')
                    return res * Math.pow(10, nextInt());
                if (c < '0' || c > '9')
                    throw new InputMismatchException();
                m /= 10;
                res += (c - '0') * m;
                c = read();
            }
        }
        return res * sgn;
    }
    
    public long nextLong() {
        int c = read();
        while (isSpaceChar(c))
            c = read();
        int sgn = 1;
        if (c == '-') {
            sgn = -1;
            c = read();
        }
        long res = 0;
        do {
            if (c < '0' || c > '9')
                throw new InputMismatchException();
            res *= 10;
            res += c - '0';
            c = read();
        } while (!isSpaceChar(c));
        return res * sgn;
    }
    
    public boolean isSpaceChar(int c)
    {
        if (filter != null)
            return filter.isSpaceChar(c);
        return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
    }
    
    public boolean isLineEndChar(int c)
    {
        if (filter != null)
            return filter.isSpaceChar(c);
        return c == '\n' || c == '\r' || c == -1;
    }

    public interface SpaceCharFilter
    {
        public boolean isSpaceChar(int ch);
    }
}