import sun.security.util.BigInt;

import java.math.BigInteger;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;

public class Main {
    private static int calculate(BigInteger num, boolean[] digits){
        int ret = 0; //num of new digits
        while(num.compareTo(BigInteger.ZERO) > 0){
            int digit = Integer.parseInt((num.mod(BigInteger.TEN)).toString());
            if(!digits[digit]){
                ret++;
                digits[digit] = true;
            }
            num = num.divide(BigInteger.TEN);
        }
        return ret;
    }

    public static void main(String[] args){
        Scanner sc = new Scanner(System.in);
        int T = sc.nextInt();
        for(int itt = 1; itt <= T; itt++){
            String input = sc.next();
            BigInteger N = new BigInteger(input);
            BigInteger current = BigInteger.ZERO;

            boolean[] digits = new boolean[10];
            Arrays.fill(digits, false);
            int numDigits = 0;

            HashSet<BigInteger> visited = new HashSet<>();
            while(numDigits < 10){
                current = current.add(N);
                if(visited.contains(current)){
                    current = new BigInteger("-1"); //IMPOSSIBLE
                    break;
                }
                visited.add(current);
                numDigits += calculate(current, digits);
            }

            if(current.equals(BigInteger.valueOf(-1))){
                System.out.println("Case #" + itt + ": INSOMNIA");
            }
            else{
                System.out.println("Case #" + itt + ": " + current);
            }
        }
    }
}
