import java.util.Scanner;

public class Main {
    private static String toBinary(long n){
        StringBuilder r = new StringBuilder();
        while(n > 0){
            r.insert(0, n % 2);
            n /= 2;
        }
        return r.toString();
    }

    private static long converter(String bitString, int base){
        int length = bitString.length();
        long mult = 1;
        long result = 0;
        for(int i = length - 1; i >= 0; i--){
            if(bitString.charAt(i) == '1'){
                result += mult;
            }
            mult *= base;
        }
        return result;
    }

//    private static String converter(long n, int base){
//        StringBuilder r = new StringBuilder();
//        while(n > 0){
//            r.insert(0, n % base);
//            n /= base;
//        }
//        return r.toString();
//    }

//    private static long[] convert(long n){
//        long[] result = new long[9];
//        for(int i = 0; i<9; i++){
//            result[i] = Long.parseLong(converter(n, i + 2));
//        }
//        return result;
//    }

    private static long divisor(long n){
        double root = Math.sqrt(n);
        for(long i = 2; i <= root; i++){
            if(n % i == 0) return i;
        }
        return -1;
    }

    public static void main(String[] args){
        Scanner sc = new Scanner(System.in);
        int T = sc.nextInt();
        for(int itt = 1; itt <= T; itt++){
            System.out.println("Case #" + itt + ":");
            int N = sc.nextInt();
            int J = sc.nextInt();

            long down = (long) Math.pow(2, N-1) + 1;
            long up = (long) Math.pow(2, N) - 1;

            int counter = 0;

            for(long i = down; i <= up; i+=2){
                String bitString = toBinary(i);
                long[] converted = new long[9];
                for(int j = 0; j<9; j++) converted[j] = converter(bitString, j+2);

                long[] divisors = new long[9];
                boolean prime = false;
                for(int j = 0; j<9; j++){
                    long div = divisor(converted[j]);
                    if(div == -1){
                        //found a prime
                        prime = true;
                        break;
                    }
                    divisors[j] = div;
                }
                if(prime) continue;

                StringBuilder out = new StringBuilder();
                out.append(bitString);
                for(int j = 0; j<9; j++){
                    out.append(" " + divisors[j]);
                }

                System.out.println(out);

                counter++;
                if(counter == J) break;
            }
        }
    }
}
