import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;

public class FairWarning {
	private int count;
	private String[] S = null;
	private String inputFileName = "C:/in";
	private String outputFileName = "C:/out";

	public static void main(String[] args) {
		FairWarning fw = new FairWarning();
		fw.readFile();
		fw.output();
	}

	public void readFile() {
		try {
			FileReader fr = new FileReader(inputFileName);
			BufferedReader br = new BufferedReader(fr);
			String strLine;
			strLine = br.readLine();
			count = Integer.parseInt(strLine);
			S = new String[count];
			for (int i = 0; i < count; i++) {
				S[i] = br.readLine();
			}
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void output() {
		try {
			FileWriter fw = new FileWriter(outputFileName);
			BufferedWriter bw = new BufferedWriter(fw);
			for (int i = 0; i < count; i++) {
				bw.write("Case #" + (i + 1) + ": ");
				BigInteger b = calc(S[i]);
				bw.write(b.toString() + "\r\n");
			}
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public BigInteger min(BigInteger b1, BigInteger b2) {
		if (b1.compareTo(b2) < 0)
			return b1;
		else
			return b2;
	}

	public BigInteger max(BigInteger b1, BigInteger b2) {
		if (b1.compareTo(b2) > 0)
			return b1;
		else
			return b2;
	}

	public BigInteger min(BigInteger b1, BigInteger b2, BigInteger b3) {
		if (b1.compareTo(b2) < 0)
			return min(b1, b3);
		else
			return min(b2, b3);
	}

	public BigInteger max(BigInteger b1, BigInteger b2, BigInteger b3) {
		if (b1.compareTo(b2) > 0)
			return max(b1, b3);
		else
			return max(b2, b3);
	}

	public BigInteger mid(BigInteger b1, BigInteger b2, BigInteger b3) {

		if (b1.compareTo(max(b1, b2, b3)) != 0
				&& b1.compareTo(min(b1, b2, b3)) != 0)
			return b1;
		else if (b2.compareTo(max(b1, b2, b3)) != 0
				&& b2.compareTo(min(b1, b2, b3)) != 0)
			return b2;
		else
			return b3;
	}

	public BigInteger calc(String s) {
		String[] temp = s.split("\\s");
		int count = Integer.parseInt(temp[0]);
		if (count == 2) {
			BigInteger b1 = new BigInteger(temp[1]);
			BigInteger b2 = new BigInteger(temp[2]);
			BigInteger max = max(b1, b2);
			BigInteger min = min(b1, b2);
			BigInteger sub = max.subtract(min);
			BigInteger mod = b1.remainder(sub);
			if (mod.compareTo(BigInteger.ZERO) == 0)
				return BigInteger.ZERO;
			else
				return sub.subtract(mod);
		} else {
			BigInteger b1 = new BigInteger(temp[1]);
			BigInteger b2 = new BigInteger(temp[2]);
			BigInteger b3 = new BigInteger(temp[3]);
			BigInteger max = max(b1, b2, b3);
			BigInteger min = min(b1, b2, b3);
			BigInteger mid = mid(b1, b2, b3);
			BigInteger sub1 = max.subtract(mid);
			BigInteger sub2 = mid.subtract(min);
			BigInteger gcd = sub1.gcd(sub2);
			if (gcd.compareTo(BigInteger.ZERO) == 0)
				return BigInteger.ZERO;
			BigInteger mod = b1.remainder(gcd);
			if (mod.compareTo(BigInteger.ZERO) == 0)
				return BigInteger.ZERO;
			else
				return gcd.subtract(mod);
		}
	}
}
