import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class SnapperChain {
	private int count;
	private long[] N = null;
	private long[] K = null;
	private String inputFileName = "C:/small.in";
	private String outputFileName = "C:/small.out";

	public static void main(String[] args) {
		SnapperChain sc = new SnapperChain();
		sc.readFile();
		sc.output();
	}

	public void readFile() {
		try {
			FileReader fr = new FileReader(inputFileName);
			BufferedReader br = new BufferedReader(fr);
			String strLine;
			strLine = br.readLine();
			count = Integer.parseInt(strLine);
			N = new long[count];
			K = new long[count];
			for (int i = 0; i < count; i++) {
				strLine = br.readLine();
				String[] temp = strLine.split("\\s");
				N[i] = Integer.parseInt(temp[0]);
				K[i] = Integer.parseInt(temp[1]);
			}
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void output() {
		try {
			FileWriter fw = new FileWriter(outputFileName);
			BufferedWriter bw = new BufferedWriter(fw);
			for (int i = 0; i < count; i++) {
				bw.write("Case #" + (i + 1) + ": ");
				long k = K[i];
				long n = N[i];
				long p = (long) Math.pow(2, n);
				if (k >= p - 1 && (k + 1) % p == 0)
					bw.write("ON\r\n");
				else
					bw.write("OFF\r\n");
			}
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
}
