import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.LinkedList;

public class ThemePark {
	private int count;
	private String[] S = null;
	private String[] G = null;
	private String inputFileName = "C:/in";
	private String outputFileName = "C:/out";

	public static void main(String[] args) {
		ThemePark tp = new ThemePark();
		tp.readFile();
		tp.output();
	}

	public void readFile() {
		try {
			FileReader fr = new FileReader(inputFileName);
			BufferedReader br = new BufferedReader(fr);
			String strLine;
			strLine = br.readLine();
			count = Integer.parseInt(strLine);
			S = new String[count];
			G = new String[count];
			for (int i = 0; i < count; i++) {
				S[i] = br.readLine();
				G[i] = br.readLine();
			}
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void output() {
		try {
			FileWriter fw = new FileWriter(outputFileName);
			BufferedWriter bw = new BufferedWriter(fw);
			for (int i = 0; i < count; i++) {
				bw.write("Case #" + (i + 1) + ": ");
				long b = calc(S[i], G[i]);
				bw.write(b + "\r\n");
			}
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public long calc(String s, String g) {
		long total = 0;
		String[] temp = s.split("\\s");
		long r = Integer.parseInt(temp[0]);
		long k = Integer.parseInt(temp[1]);
		int n = Integer.parseInt(temp[2]);
		temp = g.split("\\s");
		LinkedList<String> list = new LinkedList<String>(Arrays.asList(temp));
		for (; r > 0; r--) {
			long sum = 0;
			for (int t = 0; t < n && sum<=k; t++) {
				String first = list.getFirst();
				long j = Long.parseLong(first);
				if(sum+j<=k)
					sum += j;
				else
					break;
				//System.out.print(":" + j);
				list.removeFirst();
				list.addLast(first);
			}
			total += sum;
			//System.out.println(":");
		}
		return total;
	}
}
