import java.io.*;
import java.util.*;
import java.util.regex.MatchResult;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author Delia David
 */
public class AlienLanguage2 {

    private static final String INPUT_FILE_NAME = "alienLng.in";

    private static final String OUTPUT_FILE_NAME = "alienLng.out";

    public static void main(String[] args) throws IOException {
        //read input file
        BufferedReader br = new BufferedReader(new FileReader(INPUT_FILE_NAME));
        PrintWriter pw = new PrintWriter(new FileWriter(OUTPUT_FILE_NAME));
        String threeIntsRegex = "(\\d+)\\s+(\\d+)\\s+(\\d+)";
        Pattern pattern = Pattern.compile(threeIntsRegex);
        String line = br.readLine().trim();
        Matcher matcher = pattern.matcher(line);
        int l = 0, d = 0, n = 0;
        if (matcher.matches()) {
            l = Integer.parseInt(matcher.group(1));
            d = Integer.parseInt(matcher.group(2));
            n = Integer.parseInt(matcher.group(3));
        }

        Set<String> words = new HashSet<String>();
        for (int i = 0; i < d; i++) {
            String word = br.readLine().trim();
            words.add(word);
        }

        Map<Integer, Set<Character>> letterPositionsMap = new HashMap<Integer, Set<Character>>();
        for (String word : words) {
            for (int i = 1; i <= word.length(); i++) {
                char letter = word.charAt(i - 1);
                if (letterPositionsMap.containsKey(i)) {
                    if (!letterPositionsMap.get(i).contains(letter)) {
                        letterPositionsMap.get(i).add(letter);
                    }
                } else {
                    Set<Character> letters = new HashSet<Character>();
                    letters.add(letter);
                    letterPositionsMap.put(i, letters);
                }
            }
        }

        for (int i = 1; i <= n; i++) {
            String msgRegex = "\\(\\w*\\)|\\w";
            pattern = Pattern.compile(msgRegex);
            line = br.readLine().trim();
            matcher = pattern.matcher(line);
            List<Set<Character>> parts = new ArrayList<Set<Character>>();
            int j = 0;
            int res = 0;
            boolean ok = true;
            while (matcher.find()) {
                MatchResult matchResult = matcher.toMatchResult();
                String tmp = line.substring(matchResult.start(), matchResult.end());
                if (tmp.startsWith("(")) {
                    tmp = tmp.substring(1, tmp.length() - 1);
                }
                Set<Character> part = new HashSet<Character>();
                for (int k = 0; k < tmp.length(); k++) {
                    if (letterPositionsMap.containsKey(j + 1) && letterPositionsMap.get(j + 1).contains(tmp.charAt(k))) {
                        part.add(tmp.charAt(k));
                    }
                }
                if (part.isEmpty()) {
                    ok = false;
                    break;
                }
                parts.add(part);
                j++;
            }

            if (ok) {
                for (String word : words) {
                    boolean found = true;
                    for (int k = 0; k < l; k++) {
                        char c = word.charAt(k);
                        if (!parts.get(k).contains(c)) {
                            found = false;
                            break;
                        }
                    }
                    if (found) {
                        res++;
                    }
                }
            }
            
            String result = "Case #" + i + ": " + res + "\n";
            pw.write(result);
        }


        br.close();
        pw.close();
    }
}
