package gcj;

import java.io.*;
import java.util.HashSet;
import java.util.Set;

/**
 * User: Delia
 */
public class A {

    static String IN_FILE = "a.in";
    static String OUT_FILE = "a.out";

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader(IN_FILE));
        PrintWriter pw = new PrintWriter(new FileWriter(OUT_FILE));
        int tests = Integer.parseInt(br.readLine());
        for (int test = 1; test <= tests; test++) {
            int L = Integer.parseInt(br.readLine());
            StringBuffer sb = new StringBuffer("");
            for (int i = 0; i < L; i++) {
                sb.append(br.readLine());
            }
            TreeElem root = getTree(sb.toString());

            int A = Integer.parseInt(br.readLine());
            Animal[] animals = new Animal[A];
            for (int i = 0; i < A; i++) {
                String[] values = br.readLine().split("\\s+");
                String name = values[0];
                int featCount = Integer.parseInt(values[1]);
                Animal a = new Animal(name, featCount);
                for (int j = 0; j < featCount; j++) {
                    a.addFeature(values[j + 2]);
                }
                animals[i] = a;
            }

            pw.write("Case #" + test + ":\n");
            for (Animal animal : animals) {
                double prob = 1;
                TreeElem current = root;
                while (current != null) {
                    prob = prob * current.value;
                    if (current.feature != null && animal.hasFeature(current.feature)) {
                        current = current.left;
                    } else {
                        current = current.right;
                    }
                }
                pw.write("" + prob + "\n");
            }
        }
        br.close();
        pw.close();
    }

    public static TreeElem getTree(String st) {
        if (st == null || st.trim().length() == 0) {
            return null;
        } else {
            st = st.trim();
            st = (st.substring(1, st.length() - 1)).trim();
            TreeElem treeElem = new TreeElem();
            int openCount = 0;
            int closeCount = 0;
            int nextOpen = -1;
            int nextClose = -1;

            String s = new String(st);

            nextOpen = s.indexOf('(', 1);
            int firstOpen = nextOpen;
            nextClose = s.indexOf(')', 1);
            if (nextOpen < 0) {
                //no children, no feature; just the value
                double value = Double.parseDouble(s);
                treeElem.value = value;
                treeElem.left = null;
                treeElem.right = null;
                treeElem.feature = null;
                return treeElem;
            } else {
                String[] valueFeat = s.substring(0, nextOpen).split("\\s+");
                treeElem.value = Double.parseDouble(valueFeat[0]);
                treeElem.feature = valueFeat[1];
                openCount = 1;
                nextOpen = s.indexOf('(', nextOpen + 1);
                while (openCount > closeCount) {
                    if (nextOpen < nextClose) {
                        openCount++;
                        nextOpen = s.indexOf('(', nextOpen + 1);
                    } else {
                        closeCount++;
                        nextClose = s.indexOf(')', nextClose + 1);
                    }
                    if (openCount == closeCount) {
                        break;
                    }
                }
                //openCount = closeCount -> left subtree is isolated
                String left = s.substring(firstOpen, nextOpen);
                String right = s.substring(nextOpen);

                treeElem.left = getTree(left);
                treeElem.right = getTree(right);
                return treeElem;
            }
        }
    }

    static class TreeElem {
        double value;
        String feature;
        TreeElem left = null;
        TreeElem right = null;
    }


    static class Animal {
        String name;
        int featCount;
        Set<String> features = new HashSet<String>();

        public Animal(String name, int featCount) {
            this.name = name;
            this.featCount = featCount;
        }

        public void addFeature(String f) {
            features.add(f);
        }

        public boolean hasFeature(String f) {
            return features != null && features.contains(f);

        }
    }
}
