import java.io.*;

/**
 * @author Delia David
 */
public class WelcomeCodeJam {

    private static final String INPUT_FILE_NAME = "welcome.in";

    private static final String OUTPUT_FILE_NAME = "welcome.out";

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader(INPUT_FILE_NAME));
        PrintWriter pw = new PrintWriter(new FileWriter(OUTPUT_FILE_NAME));
        String pattern = "welcome to code jam";

        int n = Integer.parseInt(br.readLine());
        for (int i = 0; i < n; i++) {
            String s = br.readLine();
            int matchesCount = countMatches(s, pattern);
            String res = "Case #" + (i + 1) + ": ";
            if (matchesCount > 999) {
                res += matchesCount;
            } else if (matchesCount > 99) {
                res = res + "0" + matchesCount;
            } else if (matchesCount > 9) {
                res = res + "00" + matchesCount;
            } else {
                res = res + "000" + matchesCount;
            }
            pw.write(res + "\n");
        }
        pw.close();
        br.close();
    }

    //dynamic programming
    private static int countMatches(String s, String p) {
        int n = s.length();
        int k = p.length();
        int x[][] = new int[n][k];

        //last column
        x[n - 1][k - 1] = 0;
        if (s.charAt(n - 1) == p.charAt(k - 1)) {
            x[n - 1][k - 1] = 1;
        }
        for (int i = n - 2; i >= 0; i--) {
            if (s.charAt(i) == p.charAt(k - 1)) {
                x[i][k - 1] = 1 + x[i + 1][k - 1];
            } else {
                x[i][k - 1] = x[i + 1][k - 1];
            }
        }

        //last row
        for (int j = 0; j < k - 1; j++) {
            x[n - 1][j] = 0;
        }

        for (int j = k - 2; j >= 0; j--) {
            for (int i = n - 2; i >= 0; i--) {
                x[i][j] = 0;
                if (s.charAt(i) != p.charAt(j)) {
                    x[i][j] = x[i + 1][j];
                } else {
                    x[i][j] = (x[i + 1][j] + x[i][j + 1]) % 10000;
                }
            }
        }

        return x[0][0];
    }
}
