import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.HashSet;

public class BathroomStalls {
	public static void main(String[] args) throws IOException {
		/*
		BufferedReader bf = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter pw = new PrintWriter(System.out);
		*/
		FileInputStream fstream = new FileInputStream("C-small-1-attempt0.in");
		BufferedReader bf = new BufferedReader(new InputStreamReader(fstream)); 
		PrintWriter pw = new PrintWriter("C-small-1-attempt0.out", "UTF-8");
		
		int t = Integer.parseInt(bf.readLine());
		int cc = 1;
		String[] input = null;
		long n, k;
		long Ls;
		long Rs;
		HashMap<Long, Stall> stalls;
		Stall temp;
		while (t > 0) {
			//init
			input = bf.readLine().split(" ");
			n = Long.parseLong(input[0])+2;
			k = Long.parseLong(input[1]);
			//Ls and Rs of leftmost element from which the calculation starts
			Ls = 0L;
			Rs = n-3;
			stalls = new HashMap<Long, Stall>();
			
			//guards on left and right
			stalls.put(0L, new Stall(true));
			stalls.put(n-1, new Stall(true));
			temp = new Stall(0L, n-3);
			temp.occupied = false;
			stalls.put(1L, temp);
			
			//initial calculations
			for (long i = 2; i < n-1; i++) {
				temp = new Stall(Ls+1, Rs-1);
				Ls = temp.Ls;
				Rs = temp.Rs;
				temp.occupied = false;
				stalls.put(i, temp);
			}
			
			//STEP 1
			long maxMin;
			HashSet<Long> largestMin;
			//STEP 2
			long maxMax;
			HashSet<Long> largestMax;
			//STEP 3
			long leftmost;
			
			//final output
			// x = max(Ls, Rs) and y  = min(Ls, Rs)
			long x = 0;
			long y = 0;
			
			while (k > 0) {
				maxMin = Long.MIN_VALUE;
				maxMax = Long.MIN_VALUE;
				leftmost = n-2;
				largestMax = new HashSet<Long>();
				largestMin = new HashSet<Long>();
				// 1
				for (long i = 1; i < n-1; i++) {
					temp = stalls.get(i);
					if (temp.occupied == false) {
						long val = Math.min(temp.Ls, temp.Rs);
						if (val > maxMin) {
							maxMin = val;
						}
					}
				}
				for (long i = 1; i < n-1; i++) {
					temp = stalls.get(i);
					if (temp.occupied == false) {
						if (Math.min(temp.Ls, temp.Rs) == maxMin/*temp.Ls == maxMin || temp.Rs == maxMin*/) {
							largestMin.add(i);
						}
					}
				}
				if (largestMin.size() == 1) {
					//insert
					for (Long i : largestMin) {
						temp = stalls.get(i);
						temp.occupied = true;
						stalls.put(i, temp);
						//output
						x = Math.min(temp.Ls, temp.Rs);
						y = Math.max(temp.Ls, temp.Rs);
						
						long index = i.longValue()-1;
						Rs = 0;
						//update all left
						while (index > 0) {
							temp = stalls.get(index);
							if (temp.occupied == true) {
								break;
							}
							temp.Rs = Rs;
							Rs++;
							index--;
						}
						//update all right
						index = i.longValue()+1;
						Ls = 0;
						while (index < n-1) {
							temp = stalls.get(index);
							if (temp.occupied == true) {
								break;
							}
							temp.Ls = Ls;
							Ls++;
							index++;
						}
					}
					k--;
					continue;
				}
				
				// 2
				for (Long i : largestMin) {
					temp = stalls.get(i);
					if (temp.occupied == false) {
						long val = Math.max(temp.Ls, temp.Rs);
						if (val > maxMax) {
							maxMax = val;
						}
					}
				}
				for (Long i : largestMin) {
					temp = stalls.get(i);
					if (temp.occupied == false) {
						if (Math.max(temp.Ls, temp.Rs) == maxMax/*temp.Ls == maxMax || temp.Rs == maxMax*/) {
							largestMax.add(i);
						}
					}
				}
				if (largestMax.size() == 1) {
					//insert
					for (Long i : largestMax) {
						temp = stalls.get(i);
						temp.occupied = true;
						stalls.put(i, temp);
						//output
						x = Math.min(temp.Ls, temp.Rs);
						y = Math.max(temp.Ls, temp.Rs);
						
						long index = i.longValue()-1;
						Rs = 0;
						//update all left
						while (index > 0) {
							temp = stalls.get(index);
							if (temp.occupied == true) {
								break;
							}
							temp.Rs = Rs;
							Rs++;
							index--;
						}
						//update all right
						index = i.longValue()+1;
						Ls = 0;
						while (index < n-1) {
							temp = stalls.get(index);
							if (temp.occupied == true) {
								break;
							}
							temp.Ls = Ls;
							Ls++;
							index++;
						}
					}
					k--;
					continue;
				}
				
				// 3
				for (Long i : largestMax) {
					if (i.longValue() < leftmost) {
						leftmost = i.longValue();
					}
				}
				//insert
				temp = stalls.get(leftmost);
				temp.occupied = true;
				stalls.put(leftmost, temp);
				//output
				x = Math.min(temp.Ls, temp.Rs);
				y = Math.max(temp.Ls, temp.Rs);
				
				long index = leftmost-1;
				Rs = 0;
				//update all left
				while (index > 0) {
					temp = stalls.get(index);
					if (temp.occupied == true) {
						break;
					}
					temp.Rs = Rs;
					Rs++;
					index--;
				}
				//update all right
				index = leftmost+1;
				Ls = 0;
				while (index < n-1) {
					temp = stalls.get(index);
					if (temp.occupied == true) {
						break;
					}
					temp.Ls = Ls;
					Ls++;
					index++;
				}
				k--;
			}
			
			pw.println("CASE #" + cc + ": " + y + " " + x);
			pw.flush();
			cc++;
			t--;
		}
		bf.close();
		pw.close();
	}
	static class Stall {
		public long Ls, Rs;
		public boolean occupied;
		public Stall(long Ls, long Rs) {
			this.Ls = Ls;
			this.Rs = Rs;
			this.occupied = false;
		}
		public Stall(boolean occupied) {
			this.occupied = occupied;
		}
		public String toString() {
			return Ls + " " + Rs;
		}
	}
}
