import java.util.*;
import java.io.*;

public class B {
	Node[][] nodes;
	int[][] altitudes;
	char cIdx;
	int H;
	int W;
	
	int sinkH;
	int sinkW;
	
	public static class Node {
		char label = 0;
		boolean labeled = false;
		boolean sink = false;
		boolean N = false;
		boolean S = false;
		boolean E = false;
		boolean W = false;
	}
	
	public void labelNodesFromSink(int h, int w, char label) {
		Node n = nodes[h][w];
		n.labeled = true;
		n.label = label;
		
		if (n.N)
			labelNodesFromSink(h-1,w,label);
		if (n.W)
			labelNodesFromSink(h,w-1,label);
		if (n.E)
			labelNodesFromSink(h,w+1,label);
		if (n.S)
			labelNodesFromSink(h+1,w,label);
	}
	
	public void findSink(int h, int w) {
		sinkH = h;
		sinkW = w;
		
		if (nodes[h][w].sink)
			return;
		
		if (h-1 >= 0) {
			if (nodes[h-1][w].S)
				findSink(h-1,w);
		}
		if (w-1 >= 0) {
			if (nodes[h][w-1].E)
				findSink(h,w-1);
		}
		if (w+1 < W) {
			if (nodes[h][w+1].W)
				findSink(h,w+1);
		}
		if (h+1 < H) {
			if (nodes[h+1][w].N)
				findSink(h+1,w);
		}
	}
	
	public void run() throws Exception {
		File file = new File("B-large.in");
		Scanner scanner = new Scanner(file);
		
		int T = scanner.nextInt();
		for (int t = 1; t <= T; t++) {
			H = scanner.nextInt();
			W = scanner.nextInt();
			
			altitudes = new int[H][W];
			for (int h = 0; h < H; h++) {
				for (int w = 0; w < W; w++) {
					altitudes[h][w] = scanner.nextInt();
				}
			}
			
			nodes = new Node[H][W];
			for (int h = 0; h < H; h++) {
				for (int w = 0; w < W; w++) {
					nodes[h][w] = new Node();
				}
			}
			for (int h = 0; h < H; h++) {
				for (int w = 0; w < W; w++) {
					char dir = 0;
					int min = altitudes[h][w];
					
					if (h-1 >= 0) {
						if (altitudes[h-1][w] < min) {
							min = altitudes[h-1][w];
							dir = 'N'; 
						}
					}
					if (w-1 >= 0) {
						if (altitudes[h][w-1] < min) {
							min = altitudes[h][w-1];
							dir = 'W'; 
						}
					}
					if (w+1 < W) {
						if (altitudes[h][w+1] < min) {
							min = altitudes[h][w+1];
							dir = 'E'; 
						}
					}
					if (h+1 < H) {
						if (altitudes[h+1][w] < min) {
							min = altitudes[h+1][w];
							dir = 'S'; 
						}
					}
					
					if (dir == 0)
						nodes[h][w].sink = true;
					else {
						if (dir == 'N')
							nodes[h-1][w].S = true;
						if (dir == 'W')
							nodes[h][w-1].E = true;
						if (dir == 'E')
							nodes[h][w+1].W = true;
						if (dir == 'S') {
							nodes[h+1][w].N = true;
						}
					}
				}
			}
			
			cIdx = 'a';
			for (int h = 0; h < H; h++) {
				for (int w = 0; w < W; w++) {
					if (!nodes[h][w].labeled) {
						findSink(h,w);
						labelNodesFromSink(sinkH,sinkW,cIdx++);
					}
				}
			}
			
			System.out.println("Case #" + t + ":");
			for (int h = 0; h < H; h++) {
				System.out.print(nodes[h][0].label);
				for (int w = 1; w < W; w++) {
					System.out.print(" " + (char)nodes[h][w].label);
				}
				System.out.println();
			}
		}
	}
	
	public static void main(String[] args) throws Exception {
		B tmp = new B();
		tmp.run();
	}
}
