package c;

import org.junit.Test;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/**
 * @author fly
 */
public class Dijkstra {

    @SuppressWarnings("unchecked")
    static Map<Character, Integer> encode = new HashMap() {{
        put('1', 1);
        put('i', 2);
        put('j', 3);
        put('k', 4);
    }};

    static int[][] forward = {
            {c('1'), c('i'), c('j'), c('k')},
            {c('i'), -c('1'), c('k'), -c('j')},
            {c('j'), -c('k'), -c('1'), c('i')},
            {c('k'), c('j'), -c('i'), -c('1')},
    };

    static int[][] reverse = new int[4][9];

    static {
        for (int i = 0; i < 4; ++i) {
            for (int j = 0; j < 4; ++j) {
                int val = forward[i][j];
                reverse[i][val + 4] = j + 1;
                reverse[i][-val + 4] = -j - 1;
            }
        }
    }

    static int[] src;
    static long L;

    static int c(char c) {
        return encode.get(c);
    }

    static int addToEnd(int a, int b) {
        return ((int) Math.signum(a * b)) * forward[Math.abs(a) - 1][Math.abs(b) - 1];
    }

    static int removeFromStart(int result, int a) {
        return reverse[Math.abs(a) - 1][result + 4];
    }

    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new FileInputStream(args[0]));
        try (PrintWriter out = new PrintWriter(new FileOutputStream(args[0].replaceAll("\\.in", ".out")))) {
            int nTestCases = scanner.nextInt();
            for (int i = 1; i <= nTestCases; ++i) {
                L = scanner.nextLong();
                long X = scanner.nextLong();
                String s = scanner.next();
                src = new int[s.length()];
                for (int j = 0; j < s.length(); ++j) {
                    src[j] = c(s.charAt(j));
                }
                out.println(String.format("Case #%d: %s", i, bool(solve(X))));
            }
        }
    }

    private static String bool(boolean solve) {
        return solve ? "YES" : "NO";
    }

    private static boolean solve(long X) {
        long len = L * X;
        if (len < 3) return false;
        int a = get(0);
        for (long i = 1; i < len - 1; ++i) {
            int b = get(i);
            int c = get(i + 1);
            for (long j = i + 2; j < len; ++j) {
                c = addToEnd(c, get(j));
            }
            for (long j = i + 1; j < len; ++j) {
                if (a == 2 && b == 3 && c == 4) return true;
                b = addToEnd(b, get(j));
                c = removeFromStart(c, get(j));
            }
            a = addToEnd(a, get(i));
        }
        return false;
    }

    private static int get(long i) {
        return src[(int) (i % L)];
    }

}