package b;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.PriorityQueue;
import java.util.Scanner;

/**
 * @author fly
 */
public class Pancakes {
    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new FileInputStream(args[0]));
        try (PrintWriter out = new PrintWriter(new FileOutputStream(args[0].replaceAll("\\.in", ".out")))) {
            int nTestCases = scanner.nextInt();
            for (int i = 1; i <= nTestCases; ++i) {
                int D = scanner.nextInt();
                PriorityQueue<Integer> p = new PriorityQueue<>(new Comparator<Integer>() {
                    @Override
                    public int compare(Integer o1, Integer o2) {
                        return o2.compareTo(o1);
                    }
                });
                for (int j = 0; j < D; ++j) {
                    p.add(scanner.nextInt());
                }
                out.println(String.format("Case #%d: %d", i, solve(p)));
            }
        }
    }

    private static int solve(PriorityQueue<Integer> ps) {
        if (ps.isEmpty() || ps.peek() == 0) return 0;
        int min = ps.peek();
        int move = 0;
        while (move < min) {
            move++;
            int max = ps.poll();
            int half = max/2;
            ps.add(half);
            ps.add(max - half);
            int cand = ps.peek() + move;
            if (cand < min) min = cand;
        }
        return min;
    }

}
