import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class Cookie {
	
	public static double mostEfficient(double farmCost,
									   double farmValue,
									   double rate,
									   double goal,
									   double prevBest,
									   double timeSpent) {
		if (timeSpent + goal/rate < prevBest) {
			return mostEfficient(farmCost, farmValue, rate + farmValue, goal, timeSpent + goal/rate, timeSpent + farmCost/rate);
		} else {
			return prevBest;
		}
	}
	
	public static double mostEfficient2(double farmCost, double farmValue, double rate, double goal, double prevBest, double timeSpent) {
		while (timeSpent + goal/rate < prevBest) {
			prevBest = timeSpent + goal/rate;
			
			timeSpent = timeSpent + farmCost/rate;
			rate = rate + farmValue;
		}
		
		return prevBest;
	}
	
	public static void main(String[] args) throws IOException {
		String fileName = "B-large.in";
		String outFileName = "output.txt";
		Scanner s = null;
		try {
			s = new Scanner(new BufferedReader(new FileReader(fileName)));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		BufferedWriter b = null;
		try {
			b = new BufferedWriter(new FileWriter(outFileName));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	
		int cases = s.nextInt();
		
		for (int i = 1; i <= cases; i++) {
			double farmCost = s.nextDouble();
			double farmValue = s.nextDouble();
			double goal = s.nextDouble();
			
			b.append(String.format("Case #%d: %.7f\n", i, mostEfficient2(farmCost, farmValue, 2.0, goal, goal, 0)));
			System.out.println(i);
		}
		
		b.close();
	}
}
