import java.io.*;
import java.util.*;

public class TicTacToe {
	
	
	public static void main(String[] args) throws IOException {
		
		Scanner s = new Scanner(new File(args[0]));
		//various parentheses and java redundancy (aka, beauty)
		int testCases = Integer.valueOf(s.nextLine()).intValue();
		//screw StringBuffer
		String answer = "";
		
		for (int i = 0; i < testCases; i++) {
			if (i != 0)
				s.nextLine(); //skip empty line
			String[] inputs = {s.nextLine(),s.nextLine(),s.nextLine(),s.nextLine()}; //read 4 lines
			answer += "Case #" + (i+1) + ": " + solvepuzzle(inputs) + "\n";
		}
		System.out.println(answer);
		//write teh dataz
		BufferedWriter bw = new BufferedWriter(new FileWriter(new File("output.txt")));
		bw.write(answer);
		bw.close();
		
	}
	
	public static int evaluate(char[] line) {
		int Xs = 0, Os = 0, Ts = 0;
		
		for (int i = 0; i < line.length; i++) {
			switch (line[i]) {
			case 'X': Xs++; break;
			case 'O': Os++; break;
			case 'T': Ts++; break;
			}
		}
		
		if (Xs + Ts == 4 && Ts <= 1) {
			return 1;
		} else if (Os + Ts == 4 && Ts <= 1) {
			return -1;
		} else {
			return 0;
		}
	}
	
	//Comments: upping lines of code counts since the dawn of IT
	public static String solvepuzzle(String[] lines) {
		char[][] grid = new char[4][4];
		int winner = 0;
		
		for (int i = 0; i < lines.length; i++) {
			grid[i] = lines[i].toCharArray();
		}
		
		for (int i = 0; i < grid.length; i++) {
			winner += evaluate(grid[i]);
		}
		
		for (int i = 0; i < 4; i++) {
			char[] col = {grid[0][i], grid[1][i], grid[2][i], grid[3][i]};
			winner += evaluate(col);
		}
		
		char[] diag = {grid[0][0], grid[1][1], grid[2][2], grid[3][3]};
		winner += evaluate(diag);
		char[] diag2 = {grid[3][0], grid[2][1], grid[1][2], grid[0][3]};
		winner += evaluate(diag2);
		System.out.println(winner);
		if (winner > 0) {
			return "X won";
		} else if (winner < 0) {
			return "O won";
		} else {
			for (int i = 0; i < 4; i++) {
				for (int j = 0; j < 4; j++) {
					if (grid[i][j] == '.') return "Game has not completed";
				}
			}
			return "Draw";
		}
	}
}
