import java.math.*;
import java.io.*;
import java.util.*;

public class zC {

	private static String reverse(String s)
	{
		StringBuilder builder = new StringBuilder();
		for (int i = s.length() - 1; i >= 0; --i)
			builder.append(s.charAt(i));
		return builder.toString();
	}

	private static void genEven()
	{
		for (int i = 1, pow10 = 10; i <= 8; ++i, pow10 *= 10)
		{
			for (Integer x = pow10 / 10; x < pow10; ++x)
			{
				String strY = x.toString() + reverse(x.toString());
				BigInteger y = new BigInteger(strY);
				BigInteger sqrY = y.multiply(y);
				String strSqrY = sqrY.toString();

				if (strSqrY.equals(reverse(strSqrY)))
				{
					System.out.println(x);
	//				System.out.println(y + " " + sqrY);
				}	
			}
		}
	}

	private static void genOdd()
	{
		for (int i = 1, pow10 = 10; i <= 8; ++i, pow10 *= 10)
		{
			for (Integer x = pow10 / 10; x < pow10; x++)
			{
				String strY = x.toString() + reverse(new Integer(x/10).toString());
				BigInteger y = new BigInteger(strY);
				BigInteger sqrY = y.multiply(y);
				String strSqrY = sqrY.toString();

				if (strSqrY.equals(reverse(strSqrY)))
				{
					System.out.println(x);
	//				System.out.println(y + " " + sqrY);
				}	
			}
		}
	}

	BigInteger sqrt(BigInteger n)
	{
		BigInteger l = BigInteger.ZERO;
		BigInteger r = n.add(BigInteger.ONE);
		while(l.add(BigInteger.ONE).compareTo(r) < 0)
		{
			BigInteger m = l.add(r).add(BigInteger.ONE).shiftRight(1);
			if (m.multiply(m).compareTo(n) <= 0)
				l = m;
			else
				r = m;
		}
		return l;
	}

	BigInteger findPalindrom(BigInteger n)
	{
		String s = n.toString();
		if (s.equals(reverse(s)))
			return n;

		BigInteger z = n;
		while (z.mod(BigInteger.valueOf(10)).intValue() == 0)
			z = z.divide(BigInteger.valueOf(10));
		if (z.equals(BigInteger.ONE))
			return n.subtract(BigInteger.ONE);

		char[] chars = new char[s.length()];
		for (int i = 0; i < chars.length; ++i)
			chars[i] = s.charAt(i);

		boolean ok = false;
		int len = chars.length;
		for (int i = (len - 1) / 2, j = len / 2; i >= 0; --i, ++j)
		{
			if (ok)
			{
				chars[j] = chars[i];
				continue;
			}

			if (chars[j] > chars[i])
				ok = true;
			if (chars[j] < chars[i])
			{
				--chars[i];
				ok = true;
			}
			chars[j] = chars[i];
		}

		StringBuilder result = new StringBuilder();
		for (int i = 0; i < chars.length; ++i)
			result.append(chars[i]);
		return new BigInteger(result.toString());
	}

	BigInteger solve(BigInteger n)
	{
		BigInteger sqrtN = findPalindrom(sqrt(n));
		System.err.println(sqrtN + " = palin[sqrt(" + n + ")]");
		String strSqrtN = sqrtN.toString();
		final int minLen = 1;
		if (strSqrtN.length() <= minLen)
			return BigInteger.valueOf(solveForSqrt(sqrtN.intValue()));
		BigInteger result = BigInteger.valueOf(solveForSqrt((int)Math.pow(10, minLen) - 1));
		for (int len = minLen + 1; len < strSqrtN.length(); ++len)
			result = result.add(solveForFixedLength(len));

		int lostSum = 9;
		int lostLen = strSqrtN.length();
		for (int i = 0; lostLen > 0; ++i, lostLen -= 2)
		{
			int curDig = strSqrtN.charAt(i) - '0';
			for (int j = (i == 0 ? 1 : 0); j < curDig; ++j)
			{
				int newLostSum = lostLen > 1 ? lostSum - 2 * j * j : lostSum - j * j;
				result = result.add(getCount(Math.max(0, lostLen - 2), newLostSum));
			}
			lostSum -= (lostLen > 1 ? 2 : 1) * curDig * curDig;
		}
		if (lostSum >= 0)
			result = result.add(BigInteger.ONE);
		return result;
	}

	BigInteger solveForFixedLength(int len)
	{
		System.err.println("solveForFixedLength(" + len + ")"); 
		BigInteger result = BigInteger.ZERO;
		for (int first = 1; first <= 2; ++first)
			result = result.add(getCount(len - 2, 9 - 2 * first * first));
		System.err.println("solveForFixedLength(" + len + ") = " + result); 
		return result;
	}

	BigInteger getCount(int len, int lostSum)
	{
		if (lostSum < 0 || len < 0)
			return BigInteger.ZERO;
		if (len == 0)
			return BigInteger.ONE;
		if (dp[len][lostSum] == null)
		{
			BigInteger result = BigInteger.ZERO;
			if (len == 1)
			{
				for (int i = 0; i <= 2 && i * i <= lostSum; ++i)
					result = result.add(BigInteger.ONE);
			}
			else
			{
				for (int i = 0; i <= 2; ++i)
					result = result = result.add(getCount(len - 2, lostSum - 2 * i * i));
			}
			dp[len][lostSum] = result;
		}
		System.err.println("dp[" + len + "][" + lostSum + "] = " + dp[len][lostSum]); 
		return dp[len][lostSum];
	}

	BigInteger[][] dp;

	int solveForSqrt(int n)
	{
		int result = 0;
		for (int i = 1; i <= n; ++i)
		{
			String strI = "" + i;
			String strSqrI = "" + (i * i);
			if (strI.equals(reverse(strI)) && strSqrI.equals(reverse(strSqrI)))
				++result;
		}
		System.err.println("SolveForSmall(" + n + ") = " + result);
		return result;
	}

	public static void main(String[] args)
	{
		new zC().run();
	}

	public void run()
	{
		dp = new BigInteger[100][];
		for (int i = 0; i < dp.length; ++i)
			dp[i] = new BigInteger[10];

		Scanner in = new Scanner(System.in);
		int tt = in.nextInt();
		for (int ii = 1; ii <= tt; ++ii)
		{
			System.out.print("Case #" + ii + ": ");
			BigInteger a = in.nextBigInteger();
			BigInteger b = in.nextBigInteger();
			System.out.println(solve(b).subtract(solve(a.subtract(BigInteger.ONE))));
		}
	}
}