
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;


public class Main {


	public static void main(String[] args) throws NumberFormatException, IOException {
		new Main().run();
	}

	private int x = 1, t=2, o = 3, p = 0, data[][];

	BufferedReader in;

	PrintWriter out;

	private boolean isP;

	public Main() throws IOException {
		in = new BufferedReader(new InputStreamReader(new FileInputStream("in.txt")));
		out = new PrintWriter(new BufferedWriter(new FileWriter("out.txt")));
		data = new int[4][4];
	}

	public void loadData() throws IOException{
		String line;
		for (int i = 0; i < data.length; i++) {
			line = in.readLine();
			for (int j = 0; j < data[i].length; j++) 
				switch(line.charAt(j)){
				case '.':
					data[i][j] = p;
					isP = true;
					break;
				case 'O':
					data[i][j] = o;
					break;
				case 'X':
					data[i][j] = x;
					break;
				default:
					data[i][j] = t;
				}
		}
	}

	public int testRow(int r){
		if(data[r][0] == p || data[r][1] == p || data[r][2] == p || data[r][3] == p) return p;
		if(data[r][0] <= t && data[r][1] <= t && data[r][2] <= t && data[r][3] <= t) return x;
		if(data[r][0] >= t && data[r][1] >= t && data[r][2] >= t && data[r][3] >= t) return o;
		return t;
	}

	public int testColumn(int c){
		if(data[0][c] == p || data[1][c] == p || data[2][c] == p || data[3][c] == p) return p;
		if(data[0][c] <= t && data[1][c] <= t && data[2][c] <= t && data[3][c] <= t) return x;
		if(data[0][c] >= t && data[1][c] >= t && data[2][c] >= t && data[3][c] >= t) return o;
		return t;
	}

	public int testSlash(){
		if(data[0][3] == p || data[1][2] == p || data[2][1] == p || data[3][0] == p) return p;
		if(data[0][3] <= t && data[1][2] <= t && data[2][1] <= t && data[3][0] <= t) return x;
		if(data[0][3] >= t && data[1][2] >= t && data[2][1] >= t && data[3][0] >= t) return o;
		return t;
	}

	public int testBackSlash(){
		if(data[0][0] == p || data[1][1] == p || data[2][2] == p || data[3][3] == p) return p;
		if(data[0][0] <= t && data[1][1] <= t && data[2][2] <= t && data[3][3] <= t) return x;
		if(data[0][0] >= t && data[1][1] >= t && data[2][2] >= t && data[3][3] >= t) return o;
		return t;
	}


	public void run() throws NumberFormatException, IOException{
		int n= Integer.parseInt(in.readLine());
		int r;
		for (int i = 1; i <= n; i++) {
			isP = false;
			loadData();
			r = testSlash();
			if(r !=x && r!=o){
				r = testBackSlash();
				for (int j = 0; j < data.length && r !=x && r!=o; j++){
					r = testRow(j);
					if(r !=x && r!=o)
						r = testColumn(j);
				}
			}
			if(r==x){
				out.println("Case #"+i+": X won");
			}else if(r==o){
				out.println("Case #"+i+": O won");
			}else if(isP)
				out.println("Case #"+i+": Game has not completed");
			else
				out.println("Case #"+i+": Draw");
			in.readLine();
		}
		close();
	}

	void close() throws IOException{
		in.close();
		out.close();
	}
}
