import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class Main {

	/**
	 * @param args
	 * @throws IOException 
	 * @throws NumberFormatException 
	 */
	public static void main(String[] args) throws NumberFormatException, IOException {
		new Main().run();
	}

	BufferedReader in;

	PrintWriter out;

	long a, b;

	public Main() throws IOException {
		in = new BufferedReader(new InputStreamReader(new FileInputStream("in.txt")));
		out = new PrintWriter(new BufferedWriter(new FileWriter("out.txt")));
	}

	private void close() throws IOException{
		in.close();
		out.close();
	}

	private long solve() throws IOException {
		StringTokenizer t = new StringTokenizer(in.readLine(), " ");
		long count = 0;
		a = Long.parseLong(t.nextToken());
		b = Long.parseLong(t.nextToken());
		long min = (long) Math.ceil(Math.sqrt(a)), max = (long) Math.floor(Math.sqrt(b));
		int minLength = Long.toString(min).length(), maxLength = Long.toString(max).length();
		for (int i = minLength; i <= maxLength; i++) {
			count += calculate((int) Math.ceil(((double)i)/2), min, max, i%2 == 0);
		}
		return count;
	}

	private long calculate(int i, long min, long max, boolean even) {
		long start = (long) Math.pow(10, i-1), end = (long) Math.pow(10, i);
		int count = 0;
		for (long n =  start; n < end; n++) {
			String str = Long.toString(n);
			for (int j = even ? str.length() - 1: str.length() - 2; j >=0; j--)
				str += str.charAt(j);
				long fair = Long.parseLong(str);
				if(fair < min || fair > max) continue;
				if(isFair(fair*fair))count++;
		}
		return count;
	}

	private boolean isFair(long l) {
		String str = Long.toString(l);
		for (int i = 0, j = str.length() - 1; i < j; i++, j--)
			if(str.charAt(i)!= str.charAt(j))return false;
		return true;
	}

	private void run() throws NumberFormatException, IOException {
		int t = Integer.parseInt(in.readLine());
		for (int i = 1; i <= t; i++)
			out.println("Case #" + i + ": " +  solve());

		close();
	}

}
