import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class Main {

	private BufferedReader buffer;
	
	private PrintWriter pw;
	
	private int testCases;

	public Main() {
		open();
		run();
		close();
	}
	
	private void open() {
		try {
			FileInputStream fstream = new FileInputStream("data.in");
			DataInputStream entrada = new DataInputStream(fstream);
			buffer = new BufferedReader(new InputStreamReader(
					entrada));
			FileWriter fichero = new FileWriter("data.out");
			pw = new PrintWriter(fichero);

		} catch (Exception e) {
			e.printStackTrace();

		}
	}

	private void close() {
		try {
			buffer.close();
			pw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private String readLine(){
		try {
			return buffer.readLine();
		} catch (IOException e) {
			return "";
		}
	}
	
	private void writeLine(String line, int i){
		pw.println("Case #"+i+": "+line);
	}

	public static void main(String[] args) {
		new Main();
	}
	
	private void run() {
		testCases = Integer.parseInt(readLine());
		for (int i = 1; i <= testCases; i++) {
			String f = loadLine(Integer.parseInt(readLine()));
			String s = loadLine(Integer.parseInt(readLine()));
			writeLine(result(f, s), i);
		}
	}
	
	private String loadLine(int number){
		String str = "";
		for (int i = 1; i < 5; i++) {
			String tmp = readLine();
			if(number == i)
				str = tmp;
		}
		return str;
	}
	
	private String result(String first, String second){
		String str = "";
		String af[] = first.split(" ");
		String sf[] = second.split(" ");
		for (String s : sf) {
			for (String a : af) {
				if(s.equals(a)){
					if(str.length()>0)
						return "Bad magician!";
					str = s;
				}
			}
		}
		if(str.isEmpty())
			return "Volunteer cheated!";
		return str;
	}

}
