import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.text.DecimalFormat;

public class Main {

	private BufferedReader buffer;

	private PrintWriter pw;

	private long testCases;

	public Main() {
		open();
		run();
		close();
	}

	private void open() {
		try {
			FileInputStream fstream = new FileInputStream("data.in");
			DataInputStream entrada = new DataInputStream(fstream);
			buffer = new BufferedReader(new InputStreamReader(entrada));
			FileWriter fichero = new FileWriter("data.out");
			pw = new PrintWriter(fichero);

		} catch (Exception e) {
			e.printStackTrace();

		}
	}

	private void close() {
		try {
			buffer.close();
			pw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private String readLine() {
		try {
			return buffer.readLine();
		} catch (IOException e) {
			return "";
		}
	}

	private void writeLine(String line, int i) {
		pw.println("Case #" + i + ": " + line);
	}

	public static void main(String[] args) {
		new Main();
	}

	private void run() {
		float c, x, f;
		testCases = Long.parseLong(readLine());
		for (int i = 1; i <= testCases; i++) {
			String[] h = readLine().split(" ");
			c = Float.parseFloat(h[0]);
			f = Float.parseFloat(h[1]);
			x = Float.parseFloat(h[2]);
			writeLine(result(c, x, f), i);
		}
	}

	private String result(float c, float x, float f) {
		DecimalFormat decim = new DecimalFormat("0.0000000");
		float time = 0, farmtime = c / 2, totaltime = 0, tmt = 0, mintime = x / 2;
		int n = 1;
		while (true) {
			totaltime = x / (2 + n * f);
			tmt = time + farmtime + totaltime;
			if (tmt < mintime) {
				mintime = tmt;
				time += farmtime;
				farmtime = c / (2 + n * f);
				n++;
			} else {
				break;
			}
		}
		return decim.format(mintime);
	}

}
