import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class Main {

	/**
	 * @param args
	 * @throws IOException 
	 * @throws NumberFormatException 
	 */
	public static void main(String[] args) throws NumberFormatException, IOException {
		new Main().run();
	}

	int data[][], biggerN[], biggerM[], n, m;
	
	String line;
	
	BufferedReader in;

	PrintWriter out;
	
	public Main() throws IOException {
		in = new BufferedReader(new InputStreamReader(new FileInputStream("in.txt")));
		out = new PrintWriter(new BufferedWriter(new FileWriter("out.txt")));
		data = new int[100][100];
		biggerM = new int[100];
		biggerN = new int[100];
		m = 0;
		n = 0;
	}

	private void free() {
		for (int r = 0; r < n; r++) {
			biggerN[r] = 0;
			for (int c = 0; c < m; c++)
				data[r][c] = 0;
		}
		for (int c = 0; c < m; c++)
			biggerM[c] = 0;
	}
	
	private void loadData() throws IOException {
		free();
		StringTokenizer l = new StringTokenizer(in.readLine(), " ");
		n = Integer.parseInt(l.nextToken());
		m = Integer.parseInt(l.nextToken());
		for (int r = 0; r < n; r++) {
			l = new StringTokenizer(in.readLine()," ");
			for (int c = 0; c < m; c++) 
				data[r][c] = Integer.parseInt(l.nextToken());
		}
		for (int r = 0; r < n; r++) {
			biggerN[r] = data[r][0];
			for (int c = 1; c < m; c++) 
				if(data[r][c] > biggerN[r])
					biggerN[r] = data[r][c];
		}
		for (int c = 0; c < m; c++) {
			biggerM[c] = data[0][c];
			for (int r = 1; r < n; r++) 
				if(data[r][c] > biggerM[c])
					biggerM[c] = data[r][c];
		}
	}
	
	private void close() throws IOException{
		in.close();
		out.close();
	}
	
	private boolean solve() {
		for (int r = 0; r < n; r++) {
			for (int c = 0; c < m; c++) {
				if(biggerM[c] > data[r][c] && biggerN[r] > data[r][c])
					return false;
			}
		}
		return true;
	}
	
	private void run() throws NumberFormatException, IOException {
		int t = Integer.parseInt(in.readLine());
		for (int i = 1; i <= t; i++) {
			loadData();
			out.println("Case #" + i + ": " + (solve() ? "YES" : "NO"));
		}
		close();
	}
	
}
