import java.io.*;
import java.lang.*;
import java.util.*;
import java.math.*;


class Main {
	public static void main(String[] args) throws FileNotFoundException
	{

		PrintWriter fout = new PrintWriter(new File("output.txt"));
		Scanner fin = new Scanner(new File("input.txt"));
		
		int t,ti;
		t=fin.nextInt();
		for(ti=1;ti<=t;++ti){
			
			fout.println( "Case #"+ti+": "+run(fin.nextInt()) );
		}
		
		fout.flush();
	}
	
	public static int run(int n) throws FileNotFoundException
	{
		int i,j,k,l;
		
		BigInteger lcm, x;
		
		int p[]=new int[n];
		
		int r1=1;
		lcm = BigInteger.ONE;
		for(i=2;i<=n;++i){
			x=BigInteger.valueOf(i);
			if(lcm.remainder(x).compareTo(BigInteger.ZERO)!=0){
				lcm = lcm.multiply(x).divide(lcm.gcd(x));
				++r1;
			}
		}
		
		int r2=1;
		lcm = BigInteger.valueOf(n);
		for(i=n-1;i>=1;--i){
			x=BigInteger.valueOf(i);
			if(lcm.remainder(x).compareTo(BigInteger.ZERO)!=0){
				lcm = lcm.multiply(x).divide(lcm.gcd(x));
				++r2;
			}
		}
		
		return r1-r2;
		
	}
	
	static PrintWriter out = new PrintWriter(System.out);
	static Scanner in = new Scanner(System.in);
	static public void cout(Object ... o){
		for( Object w:o ) out.println(w);
		out.println(); out.flush();
	}
	
	
	static class lib{
		public static int gcd(int a, int b){
			if(a<0) a=-a; if(b<0) b=-b;
			while(a!=0 && b!=0)
				if(a>b) a%=b; else b%=a;
			return a+b;
		}
		
		public static int[] gcdExtended(int a, int b){	//return {gcd(a,b), x, y}, where ax+by=gcd(a,b)
			int r, q, x0, y0, x1, y1, x, y;

			x0=1; x1=x=0;
			y0=0; y1=y=1;

			while(b!=0){
				r = a%b;
				q = a/b;
				if(r!=0){
					x = x0-q*x1;
					y = y0-q*y1;
					x0 = x1; y0 = y1;
					x1 = x; y1 = y;
				}
				a = b; b = r;
		    }
			if(a<0){ a=-a; x=-x; y=-y; }
			
		    return new int[]{a, x, y};
		}

		public static long lcm(int a, int b){
			return a/gcd(a,b)*(long)b;
		}
		
		public static int[] divisors(int n){
			int sq = (int)Math.sqrt(n);
			int isfs = (sq*sq==n ? 1 : 0);
			int[] d = new int[sq];
			int m=0, i;
			
			for(i=1; i<=sq; ++i) 
				if(n%i==0) d[m++]=i;
			
			int res[] = new int[m+m-isfs];
			for(i=0; i<m; ++i) res[i]=d[i];
			for(i=m-1-isfs; i>=0; --i) res[m+m-i-1-isfs]=n/d[i];
			
			return res;
		}
		
		public static int[] factorize(int n){
			int d[] = new int[33];
			int m=0, i;
			
			for(i=2; n>1;){
				while(n%i==0){
					d[m++]=i;
					n/=i;
				}
				i+=1+(i>2?1:0);
				if(i*i>n) i=n;
			}
			
			int[] res = new int[m];
			for(i=0;i<m;++i) res[i]=d[i];
			
			return res;
		}
		
		public static int[][] factorizeInPowers(int n){
			int d[][] = new int[11][2];
			int m=0, i;
			
			for(i=2; n>1;){
				d[m][1]=0;
				while(n%i==0){
					d[m][1]++;
					n/=i;
				}
				if(d[m][1]>0) d[m++][0]=i; 
				i+=1+(i>2?1:0);
				if(i*i>n) i=n;
			}
			
			int[][] res = new int[m][2];
			for(i=0;i<m;++i) res[i]=d[i];
			
			return res;
		}
		
		public static int pow(int a, int b){
			int res = 1;
			while(b>0){
				if((b&1)==1) res*=a;
				a*=a;
				b>>=1;
			}
			return res;
		}
		
		public static long pow(long a, long b, long m){
			long res = 1;
			while(b>0){
				if((b&1)==1) res=(res*a)%m;
				a=(a*a)%m;
				b>>=1;
			}
			return res;
		}
		
		public static boolean isPrime(int n){
			if(n<2 || (n>2 && n%2==0)) return false;
			
			for(int i=3; i*i<=n; i+=2)
				if(n%i==0) return false;
				
			return true;
		}
		
		public static int[] primes(int n){
			if(n<2) return new int[0];
			int i, j, m=0;
			boolean[] p = new boolean[n+1];
		    
			for(i=2; i<=n; ++i) if(!p[i]){
				for(j=i*2; j<=n; j+=i) p[j]=true;
				++m;
			}
			
			int[] res = new int[m];
			m=0;
			for(i=2; i<=n; ++i) if(!p[i]) res[m++]=i;
		    
			return res;
		}
		
		public static int phi(int n){
			int d, res = n;

			for(d=2; d*d<=n; ++d)
				if(n%d==0){
					while(n%d==0) n/=d;
					res-=res/d;
				}
			if(n>1) res-=res/n;

			return res;
		}
		
		public static long fibonacci(int n, long m){
			long a[][] = { {0,1},{1,1} };
			long r[][] = { {1,0},{0,1} };
			long t[][] = new long[2][2];
			
			while(n>0)
				if((n&1)==1){
					t[0][0]=r[0][0]*a[0][0]+r[0][1]*a[1][0];
					t[0][1]=r[0][0]*a[0][1]+r[0][1]*a[1][1];
					t[1][0]=r[1][0]*a[0][0]+r[1][1]*a[1][0];
					t[1][1]=r[1][0]*a[0][1]+r[1][1]*a[1][1];
					r[0][0]=t[0][0]%m; r[0][1]=t[0][1]%m; r[1][0]=t[1][0]%m; r[1][1]=t[1][1]%m;
					--n;
				}else{
					t[0][0]=a[0][0]*a[0][0]+a[0][1]*a[1][0];
					t[0][1]=a[0][0]*a[0][1]+a[0][1]*a[1][1];
					t[1][0]=a[1][0]*a[0][0]+a[1][1]*a[1][0];
					t[1][1]=a[1][0]*a[0][1]+a[1][1]*a[1][1];
					a[0][0]=t[0][0]%m; a[0][1]=t[0][1]%m; a[1][0]=t[1][0]%m; a[1][1]=t[1][1]%m;
					n>>=1;
				}
			
			return r[1][0];
		}

		public static int[] prefixFunction(String str){
			char[] s = str.toCharArray();
			int i, k, len=s.length;
			int[] p = new int[len];
			
			k=-1;
			for(i=1; i<len; ++i){
				while(k>=0 && s[k+1]!=s[i]) k=p[k]-1;
				if(s[k+1]==s[i]) ++k;
				p[i]=k+1;
			}
			
			return p;
		}
		
		public static int[] indexesOf(String t, String str){
			int[] p = prefixFunction(t);
			char[] s = str.toCharArray(), c = t.toCharArray();
			int i, k, n=s.length, m=c.length;
			
			int in[] = new int[n], d=0;
			
			k=-1;
			for(i=0; i<n; ++i){
				while(k>=0 && (k+1>=m || c[k+1]!=s[i])) k=p[k]-1;
				if(k+1<m && c[k+1]==s[i]) ++k;
				if(k==m-1){
					in[d++]=i-m+1;
				}
			}
			
			int res[] = new int[d];
			for(i=0;i<d;++i) res[i]=in[i];
			
			return res; 
		}
		
		public static int[] zFunction(String str){
			char s[] = str.toCharArray();
			int i, j, len=s.length;
			int[] z = new int[len];
		    
			j=0;
			for(i=1; i<len; ++i){
				if(i<j+z[j]){
					z[i]=z[i-j];
					if(i+z[i]>=j+z[j]) z[i]=j+z[j]-i;
				}else
					z[i]=0;

				while(i+z[i]<len && s[z[i]]==s[i+z[i]]) ++z[i];

				if(i+z[i]>j+z[j]) j=i;
			}
			z[0]=len;
			
			return z;
		}
		
		public static int[] suffixArray(String str){
			char s[] = str.toCharArray();
			int n = s.length;
			int[] p = new int[n], pt = new int[n], u = new int[n], ut = new int[n], c = new int[n];

			int i, m, k;
			for(i=0; i<n; ++i) ++c[s[i]];

			for(i=1; i<256; ++i) c[i]+=c[i-1];

			for(i=n-1; i>=0; --i) p[--c[s[i]]]=i;

			u[p[0]] = m = 0;
			for(i=1; i<n; ++i){
				if(s[p[i]]!=s[p[i-1]]) ++m;
				u[p[i]] = m;
			}
			++m;

			for(k=1; k<n; k<<=1){
				for(i=0; i<n; ++i){
					pt[i] = p[i]-k;
					if(pt[i]<0) pt[i]+=n;
		        }
				Arrays.fill(c, 0, 0, m);
				
				for(i=0; i<n; ++i) ++c[u[pt[i]]];

				for(i=1; i<m; ++i) c[i]+=c[i-1];

				for(i=n-1; i>=0; --i) p[--c[u[pt[i]]]] = pt[i];

				ut[p[0]] = m = 0;
				for(i=1; i<n; ++i){
					if( !(u[p[i]]==u[p[i-1]] && u[(p[i]+k)%n]==u[(p[i-1]+k)%n]) ) ++m;
					ut[p[i]] = m;
				}
				++m;

				System.arraycopy(ut, 0, u, 0, n);
		    }

		    return p;
		}
	
		public static int maxSubRect(int[][] p, int val){
			int i, j, d, n=p.length, m=p[0].length, res=0;
			int[] a=new int[m];
			int[] s=new int[m+1], t=new int[m+1];
			int[] r=new int[m+1], l=new int[m+1];
			
			for(i=0;i<n;++i){
				d=0;
				for(j=0;j<m;++j){
					a[j] = (p[i][j]==val ? a[j]+1 : 0);
					while(a[j]<s[d]) r[t[d--]]=j-1;
					s[++d]=a[j];
					t[d]=j;
				}
				while(d>0) r[t[d--]]=m;
				
				for(j=m-1;j>0;--j){
					while(a[j]<s[d]) l[t[d--]]=j+1;
					s[++d]=a[j];
					t[d]=j;
				}
				while(d>0) l[t[d--]]=1;
				
				for(j=0;j<m;++j)
					res = Math.max(res, (r[j]-l[j]+1)*a[j]);
			}
			
			return res;
		}
	
	}
	
	
	public static class geom{
		public static class Point{
			double x, y;
			public Point(double X, double Y){
				x=X; y=Y;
			}
			public Point clone(){
				return new Point(x,y);
			}
			public double dist(Point b){
				return Math.sqrt( sqr(x-b.x)+sqr(y-b.y) );
			}
			public boolean in(Segment l){
				if( (l.b.x-l.a.x)*(y-l.a.y)-(l.b.y-l.a.y)*(x-l.a.x)!=0 ) return false;
				
				double u;
				if(l.b.x-l.a.x!=0)
			        u = (x-l.a.x)/(l.b.x-l.a.x);
			    else
			    if(l.b.y-l.a.y!=0)
			        u = (y-l.a.y)/(l.b.y-l.a.y);
			    else
			        return(l.a.x==x && l.a.y==y);

			    return (u>=0.0 && u<=1.0);
			}
		}
		
		public static class Line{
			Point a, b;
			public Line(Point A, Point B){
				a=A.clone(); b=B.clone();
			}
			public Line(double ax, double ay, double bx, double by){
				a=new Point(ax, ay); b=new Point(bx, by);
			}
			public Line(Segment seg){
				a=seg.a.clone(); b=seg.b.clone();
			}
			public Line cross(Line l){
				double z, u1;
				z = (l.b.y-l.a.y)*(b.x-a.x)-(l.b.x-l.a.x)*(b.y-a.y);
				u1 =(l.b.x-l.a.x)*(a.y-l.a.y)-(l.b.y-l.a.y)*(a.x-l.a.x);
			    
			    if( z==0 ){
			    	if( u1!=0 ) return null;
			    	return new Line(a, b);
			    }else{
			    	Point p = new Point( a.x+u1*(b.x-a.x), a.y+u1*(b.y-a.y) );
		    		return new Line(p, p);
			    }
			}
		}
		
		public static class Segment{
			Point a, b;
			public Segment(Point A, Point B){
				a=A.clone(); b=B.clone();
			}
			public Segment(double ax, double ay, double bx, double by){
				a=new Point(ax, ay); b=new Point(bx, by);
			}
			public double length(){
				return Math.sqrt( sqr(a.x-b.x)+sqr(a.y-b.y) );
			}
			
			public Segment cross(Segment l){
				double z, u1, u2;
				z = (l.b.y-l.a.y)*(b.x-a.x)-(l.b.x-l.a.x)*(b.y-a.y);
				u1 =(l.b.x-l.a.x)*(a.y-l.a.y)-(l.b.y-l.a.y)*(a.x-l.a.x);
				u2 =(b.x-a.x)*(a.y-l.a.y)-(b.y-a.y)*(a.x-l.a.x);
			    
			    if( z==0 ){
			    	if( u1!=0 ) return null;
			    	
			    	if( a.in(l) && b.in(l) ) return new Segment(a, b);
			    	if( l.a.in(this) && l.b.in(this) ) return new Segment(l.a, l.b);
			    	if( a.in(l) && l.a.in(this) ) return new Segment(a, l.a);
			    	if( a.in(l) && l.b.in(this) ) return new Segment(a, l.b);
			    	if( b.in(l) && l.a.in(this) ) return new Segment(a, l.a);
			    	if( b.in(l) && l.b.in(this) ) return new Segment(a, l.b);
			    	
			    	return null;
			    }else{
			    	u1/=z;
			    	u2/=z;
			    	if( u1>=0 && u1<=1 && u2>=0 && u2<=1 ){
			    		Point p = new Point( a.x+u1*(b.x-a.x), a.y+u1*(b.y-a.y) );
			    		return new Segment(p, p);
			    	}else
			    		return null;
			    }
			}
		}
		
		public static class Circle{
			Point o; 
			double r;
			public Circle(Point O, double R){
				o=O.clone(); r=R;
			}
			public Circle(double Ox, double Oy, double R){
				o=new Point(Ox, Oy); r=R;
			}
			public double area(){
				return pi*r*r;
			}
		}
		
		public Point[] convexHull(Point[] p){
			return p;
		}
		
		static final double pi = Math.PI;
		static double sqr(double x){
			return x*x;
		}
	}

	
	public static class Q{
		public long p, q;
		
		public Q(){}
		public Q(long a, long b){
			p=a; q=b; 
			fr(this);
		}
		
		public Q add(Q x){
			Q res = new Q(p*x.q + q*x.p, q*x.q);
			fr(res);
			return res;
		}
		
		public Q subtract(Q x){
			Q res = new Q(p*x.q - q*x.p, q*x.q);
			fr(res);
			return res;
		}
		
		public Q multiply(Q x){
			Q res = new Q(p*x.p, q*x.q);
			fr(res);
			return res;
		}
		
		public Q divide(Q x){
			Q res = new Q(p*x.q, q*x.p);
			fr(res);
			return res;
		}
		
		public Q inverse(){
			Q res = new Q(q, p);
			fr(res);
			return res;
		}
		
		public String toString(){
			String res = "";
			if(p==0) res="0";
			else{
				res=p+"";
				if(q!=1) res+="/"+q;
			}
			return res;
		}
		
		public double toDouble(){
			return (double)p/q;
		}
		
		static void fr(Q a){
			if(a.q<0){
				a.p=-a.p; a.q=-a.q;
			}
			long g = gcd(a.p,a.q);
			a.p/=g; a.q/=g;
		}
		static long gcd(long a, long b){
			if(a<0) a=-a;
			while(a!=0 && b!=0)
				if(a>b) a%=b; else b%=a;
			return a+b;
		}
	}
	
	public static class C{
		public Q a, b;
		
		public C(){}
		public C(long A, long B){
			a=new Q(A,1); b=new Q(B,1);
		}
		
		public C(Q A, Q B){
			a=new Q(A.p, A.q); b=new Q(B.p, B.q);
		}
		
		public C add(C x){
			C res = new C(a.add(x.a), b.add(x.b));
			return res;
		}
		
		public C subtract(C x){
			C res = new C(a.subtract(x.a), b.subtract(x.b));
			return res;
		}
		
		public C multiply(C x){
			C res = new C(a.multiply(x.a).subtract(b.multiply(x.b)), a.multiply(x.b).add(b.multiply(x.a)));
			return res;
		}
		
		public C divide(C x){
			return multiply(x.inverse());
		}
		
		public C inverse(){
			Q q = a.multiply(a).add(b.multiply(b));
			C res = conjugate();
			res.a = res.a.divide(q);
			res.b = res.b.divide(q);
			return res;
		}
		
		public C conjugate(){
			return new C(a, new Q(-b.p, b.q));
		}
		
		public String toString(){
			return a+" + i"+b;
		}
	}
	
	
	
}
