import java.io.*;
import java.util.*;
import java.math.*;
import java.text.*;

public class A {
	public static void pl(Object O) {System.out.println(O);}
	public static void pl() {System.out.println();}
	public static void pr(Object O) {System.out.print(O);}
	public static void p(Object O) {System.out.print(O);}
	public static void pf(String f, Object...args) {System.out.printf(f,args);}
	
	public static Scanner sc;
	public static String n() {return sc.next();}
	public static String nl() {return sc.nextLine();}
	public static int ni() {return sc.nextInt();}
	public static double nd() {return sc.nextDouble();}
	
	public static final int DOT = 0;
	public static final int T = 0x111;
	public static final int X = 0x010;
	public static final int O = 0x100;
	public static final int X_MASK = 0x040;
	public static final int O_MASK = 0x400;
	
//	public static final int[] winX = {X*4, X*3+T};
//	public static final int[] winO = {O*4, O*3+T};
	
	public static void main(String[] args) throws FileNotFoundException, IOException, ClassNotFoundException {
		sc = new Scanner(new File(args[0]));

		int kk = ni();
		nl();
		for (int qq = 0; qq < kk; qq++) {
			// create grid for test case

			char[][] grid = new char[4][4];
			int[] across = new int[4];
			int[] down = new int[4];
			int[] diagonal = new int[4]; // backslash, slash
			int empty = 0;
			for (int i = 0; i < 4; i++) {
				String line = nl();
				char[] c = line.toCharArray();
				for (int j = 0; j < 4; j++) {
					grid[i][j] = c[j];
					switch(c[j]) {
					case 'T':
						processCharacter(across, down, diagonal, i, j, T);
						break;
					case 'X':
						processCharacter(across, down, diagonal, i, j, X);
						break;
					case 'O':
						processCharacter(across, down, diagonal, i, j, O);
						break;
					case '.':
						empty++;
						break;
					}
				}
			}
			if (sc.hasNext()) {
				nl(); // read extra line
			}

			// solve test case
			
			boolean xWins = false;
			boolean oWins = false;
			
			for (int i = 0; i < down.length; i++) {
				xWins |= (down[i] & X_MASK) != 0;
				xWins |= (across[i] & X_MASK) != 0;
				oWins |= (down[i] & O_MASK) != 0;
				oWins |= (across[i] & O_MASK) != 0;
			}
			for (int i = 0; i < diagonal.length; i++) {
				xWins |= (diagonal[i] & X_MASK) != 0;
				oWins |= (diagonal[i] & O_MASK) != 0;
			}
			
			// print result
			System.out.printf("Case #%d: ", qq + 1);
			if (!xWins && !oWins) {
				if (empty==0) {
					System.out.println("Draw");
				} else {
					System.out.println("Game has not completed");
				}
			} else if (xWins) {
				System.out.println("X won");
			} else if (oWins) {
				System.out.println("O won");
			} else {
				System.out.println("WTF?!?");
			}
			
			System.err.println(Arrays.deepToString(grid).replaceAll("],","\n"));
			printCounts(across);
			printCounts(down);
			printCounts(diagonal);
		}
	}
	
	private static void printCounts(int[] array) {
		for (int i = 0; i < array.length; i++) {
			System.err.print(Integer.toString(array[i], 16));
			System.err.print(",");
		}
		System.err.println();
	}
	
	private static void processCharacter(int[] across, int[] down,
			int[] diagonal, int i, int j, int value) {
		across[j] += value;
		down[i] += value;
		if (i == j)
			diagonal[0] += value;
		if (i == 3 - j)
			diagonal[1] += value;
	}
}
