import java.io.*;
import java.util.*;
import java.math.*;
import java.text.*;
import java.lang.*;
import static java.lang.Math.*;

public class A {
	public static void pl(Object O) {System.out.println(O);}
	public static void pl() {System.out.println();}
	public static void pr(Object O) {System.out.print(O);}
	public static void p(Object O) {System.out.print(O);}
	public static void pf(String str, Object... args) {System.out.printf(str,args);}
	
	public static Scanner sc;
	public static String n() {return sc.next();}
	public static String nl() {return sc.nextLine();}
	public static int ni() {return sc.nextInt();}
	public static double nd() {return sc.nextDouble();}

	public static void main(String[] args) throws IOException {
		sc = new Scanner(new File(args[0]));
		int qq = sc.nextInt();
		sc.nextLine();
		for (int zz = 0; zz < qq; zz++) {
			int n = ni(); nl();
			char[][] schedule = new char[n][n];
			for (int i = 0; i < schedule.length; i++) {
				schedule[i] = nl().toCharArray();
			}
//			System.out.println(Arrays.deepToString(schedule).replaceAll("],", "\n"));
			
			double[] wp = getWp(schedule);
//			System.out.println(Arrays.toString(wp));
			double[] owp = getOwp(schedule);
//			System.out.println(Arrays.toString(owp));
			double[] oowp = getOowp(schedule,owp);
//			System.out.println(Arrays.toString(oowp));
			
			System.out.printf("Case #%d:\n",zz+1);
			for (int i = 0; i < oowp.length; i++) {
				System.out.println(rpi(wp[i],owp[i],oowp[i]));
			}
		}
	}
	
	private static double[] getOowp(char[][] schedule,double[] owp) {
		double[] oowp = new double[owp.length];
		for (int i = 0; i < oowp.length; i++) { // each entry in oowp
			double sum = 0;
			int opponents =0;
			for (int j = 0; j < owp.length; j++) {
				if(i==j) continue; // don't count games played against own team
				else if(schedule[i][j]=='.') continue; // not an opponent
				else opponents++;
				sum += owp[j];
			}
			oowp[i] = sum/(opponents);
		}
		
		return oowp;
		
	}
	
	private static double[] getOwp(char[][] schedule) {
		double[] owp = new double[schedule.length];
		for (int i = 0; i < schedule.length; i++) { // each team
			double wpsum = 0;
			int opponents = 0;
			for (int j = 0; j < schedule.length; j++) { // schedule rows
				if(i==j) continue; // don't count games played against own team
				else if(schedule[i][j]=='.') continue; // not an opponent
				else opponents++;
				
				int wins = 0;
				int games = 0;
				for (int k = 0; k < schedule.length; k++) { // schedule columns
					if(i==k) continue; // game against self
					switch(schedule[j][k]) {
					case '1' : wins++;
					case '0' : games++; break;
					}
				}
				double wp = 1.0*wins/games;
//				System.out.println(wp);
				wpsum+=wp;
			}
			owp[i]=wpsum/(opponents);
//			System.out.println(owp[i]);
//			System.out.println();
		}
		return owp;
	}
	
	private static double[] getWp(char[][] schedule) {
		double[] wp = new double[schedule.length];
		for (int i = 0; i < wp.length; i++) {
			int wins = 0;
			int games = 0;
			for (int j = 0; j < wp.length; j++) {
				switch(schedule[i][j]) {
				case '1' : wins++;
				case '0' : games++; break;
				}
			}
			wp[i] = 1.0 * wins / games;
		}

		return wp;
	}
	
	public static double rpi(double wp, double owp, double oowp) {
		return 0.25*wp+0.50*owp+0.25*oowp;
	}
}