import java.util.*;

public class ProbB {
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int q = sc.nextInt(); // num cases
		sc.nextLine(); // clear garbage
		for (int i = 0; i < q; i++) {
			int c = sc.nextInt();
			
			Combo[] combos = new Combo[c];
			for (int j = 0; j < c; j++) {
				String s = sc.next();
				combos[j] = new Combo(s);
			}
			
			int d = sc.nextInt();
			Conflict[] conflicts = new Conflict[d];
			for (int j = 0; j < d; j++) {
				String s = sc.next();
				conflicts[j] = new Conflict(s);
			}

			ElementList list = new ElementList(combos, conflicts);
//			System.out.println(list);

			int n = sc.nextInt();
			char[] e = sc.next().toCharArray();
			for (int j = 0; j < n; j++) {
				list.add(e[j]);
			}
			
			System.out.printf("Case #%d: %s",i+1,list);
			if(i!=q) System.out.println();
		}
	}
}

class ElementList {
	String magicks;
	Combo[] combos;
	Conflict[] conflicts;

	public ElementList(Combo[] combos, Conflict[] conflicts) {
		magicks = "";
		this.combos = combos;
		this.conflicts = conflicts;
	}

	public void add(char c) {
		magicks += c;
		applyCombos();
		checkConflicts();
//		System.out.println(this);
	}

	private void applyCombos() {
		if (magicks.length() >= 2) {
			char last = magicks.charAt(magicks.length()-1);
			char penult = magicks.charAt(magicks.length()-2);
			for(Combo c : combos) {
				if((last==c.a && penult==c.b) || (penult==c.a && last==c.b)) {
					magicks = magicks.substring(0,magicks.length()-2)+c.meld;
				}
			}
		}
	}

	private void checkConflicts() {
		if (magicks.length() >= 2) {
			for(Conflict c : conflicts) {
				if(magicks.contains(c.a+"") && magicks.contains(c.b+"")) {
					magicks = "";
				}
			}
		}
	}

	public String toString() {
		// TODO Auto-generated method stub
		return Arrays.toString(magicks.toCharArray());
	}
}

class Combo {
	char a;
	char b;
	char meld;

	public Combo(String s) {
		char[] c = s.toCharArray();
		a = c[0];
		b = c[1];
		meld = c[2];
	}
	
	@Override
	public String toString() {
		// TODO Auto-generated method stub
		return String.format("%s & %s -> %s",""+a,""+b,""+meld);
	}
}

class Conflict {
	char a;
	char b;

	public Conflict(String s) {
		char[] c = s.toCharArray();
		a = c[0];
		b = c[1];
	}
	
	@Override
	public String toString() {
		// TODO Auto-generated method stub
		return String.format("%s & %s",""+a,""+b);
	}
}