import java.util.*;
import java.io.*;

public class ProbA {
	private static final boolean debug = false;

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int q = sc.nextInt(); // num cases
		sc.nextLine(); // clear garbage
		for (int i = 0; i < q; i++) {
			ArrayList<Objective>[] objs = getObjectives(sc);

			// positions
			int locB = 1;
			int locO = 1;

			// buttons 0=Blue 1=Orange
			int[] button = new int[2];
			// set initial dependencies
			button[0] = 0;
			button[1] = 0;

			int time = 0;
			while (!objs[0].isEmpty() || !objs[1].isEmpty()) {
				
				if (debug) {
//					System.out.println(locB + " " + locO);
				}

				int bUpdate = button[0];
				int oUpdate = button[1];

				Objective o = null;

				// FSM blue
				if (!objs[0].isEmpty()) {
					o = objs[0].get(0);
					if (locB != o.button) {
						if (locB < o.button)
							++locB;
						else
							--locB;
					} else if (button[o.dRow]==o.dButton) {
						bUpdate = o.button; // press button
						objs[0].remove(0); // objective finished
						if(debug) {
							System.out.println(objs[0]);
						}
					}
				}

				// FSM orange
				if (!objs[1].isEmpty()) {
					o = objs[1].get(0);
					if (locO != o.button) {
						if (locO < o.button)
							++locO;
						else
							--locO;
					} else if (button[o.dRow]==o.dButton) {
						oUpdate = o.button; // press button
						objs[1].remove(0); // objective finished
						if(debug) {
							System.out.println(objs[1]);
						}
					}
				}

				button[0]=bUpdate;
				button[1]=oUpdate;

				++time;
			}

			System.out.printf("Case #%d: %d", i + 1, time);
			if(i!=q-1) System.out.println();
		}
	}

	private static ArrayList<Objective>[] getObjectives(Scanner sc) {
		ArrayList<Objective>[] objs = new ArrayList[2];
		objs[0] = new ArrayList<Objective>();
		objs[1] = new ArrayList<Objective>();

		Scanner s = new Scanner(sc.nextLine());
		int[] pre = new int[2];
		pre[0] = 0;
		pre[1] = 0;
		int z = s.nextInt();
		for (int j = 0; j < z; j++) {
			// extract info
			int bot = s.next().equals("B") ? 0 : 1;
			int button = s.nextInt();

			// add objective
			Objective objective = new Objective(pre[0], pre[1], bot, button);
			if (debug) {
				System.out.println(objective);
			}
			objs[bot].add(objective);

			// update
			pre[0] = bot;
			pre[1] = button;
		}

		if (debug) {
			System.out.println(Arrays.toString(objs));
		}

		return objs;
	}
}

class Objective {
	int dRow; // dependency button row
	int dButton; // dependency button index
	int bot; // objective button row
	int button; // objective button index

	public Objective(int k, int l, int m, int n) {
		this.dRow = k;
		this.dButton = l;
		this.bot = m;
		this.button = n;
	}

	@Override
	public String toString() {
		return String.format("(%d,%d)->(%d,%d)", dRow, dButton, bot, button);
	}
}