import java.io.*;
import java.util.*;
import java.math.*;
import java.text.*;

public class B {
	public static void main(String[] args) throws Exception {
		String file = args.length > 0 ? args[0] : "b-sample.in";
		Scanner sc = new Scanner(new File(file));

		int kk = sc.nextInt();
		sc.nextLine();
		for (int qq = 0; qq < kk; qq++) {
			int rows = sc.nextInt();
			int cols = sc.nextInt();

			int[][] grid = new int[rows][cols];

			for (int i = 0; i < rows; i++) {
				for (int j = 0; j < cols; j++) {
					grid[i][j] = sc.nextInt();
				}
			}

			/*
			 * The pattern can be achieved if, for every square, there is no
			 * square in the same row, or no square in the same column, whose
			 * height is taller than that square.
			 */

			boolean[][] possibleRow = new boolean[grid.length][grid[0].length];
			boolean[][] possibleCol = new boolean[grid.length][grid[0].length];
			for (int i = 0; i < possibleRow.length; i++) {
				Arrays.fill(possibleRow[i],true);
				Arrays.fill(possibleCol[i],true);
			}

			for (int i = 0; i < grid.length; i++) {
				for (int j = 0; j < grid[0].length; j++) {
					int value = grid[i][j];
					for (int k = 0; k < cols; k++) { // fix i (row)
						possibleRow[i][j] &= (value >= grid[i][k]);
					}
					for (int k = 0; k < rows; k++) { // fix j (column)
						possibleCol[i][j] &= (value >= grid[k][j]);
					}
				}
			}

			boolean[][] possible = new boolean[grid.length][grid[0].length];
			boolean good = true;
			for (int i = 0; i < possible.length; i++) {
				for (int j = 0; j < possible[0].length; j++) {
					possible[i][j] = (possibleRow[i][j] || possibleCol[i][j]);
					good &= possible[i][j];
				}
			}
			
			System.out.printf("Case #%d: ", qq + 1);
			System.out.println(good?"YES":"NO");
			
			System.err.println(Arrays.deepToString(grid).replaceAll("],", "\n"));
			System.err.println(Arrays.deepToString(possibleRow).replaceAll("],", "\n"));
			System.err.println(Arrays.deepToString(possibleCol).replaceAll("],", "\n"));
			System.err.println(Arrays.deepToString(possible).replaceAll("],", "\n"));
		}
	}
}
