import java.io.*;
import java.util.*;
import java.math.*;
import java.text.*;

public class C {
	public static void main(String[] args) throws Exception {
		String file = args.length > 0 ? args[0] : "c-sample.in";
		Scanner sc = new Scanner(new File(file));

		int kk = sc.nextInt();
		sc.nextLine();
		for (int qq = 0; qq < kk; qq++) {
			int a = sc.nextInt();
			int b = sc.nextInt();
			
			TreeMap<Integer, Integer> squaresToRoots = new TreeMap<>();
			
			boolean[] fair = new boolean[b+1];
			boolean[] square = new boolean[b+1];
			Arrays.fill(square, false);
			
			for (int i = a; i < b+1; i++) {
				fair[i] = isFair(i);
				if (fair[i]) {
					square[i] = isSquare(i);
				}
			}
			
			int count = 0;
			for (int i = 0; i < square.length; i++) {
				if (fair[i]) {
					if (square[i]) {
						count++;
					}
				}
			}
			
			System.out.printf("Case #%d: ", qq + 1);
			System.out.println(count);
		}
	}

	/**
	 * Check if the number is a square and that the root is a palindrome.
	 * @param a
	 * @return
	 */
	private static boolean isSquare(int a) {
		int root = (int) Math.floor(Math.sqrt(a));
		boolean rootIsPalindrome = isFair(root); 
		double square = root*root;
		boolean isSquare = (a == square);
		return isSquare && rootIsPalindrome;
	}

	/**
	 * Check if its a palindrome ("fair")
	 * @param a
	 * @return
	 */
	private static boolean isFair(int a) {
		char[] c = Integer.toString(a).toCharArray();
		for (int i = 0; i < c.length; i++) {
			char left = c[i];
			char right = c[c.length-1-i];
			if (left!=right) return false;
		}
		return true;
	}
}
