import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;


public class Qual2 {

	public static BigInteger gcd(BigInteger a, BigInteger b) {
		if (b.compareTo(BigInteger.valueOf(0)) == 0) 
			return a;
		else
			return gcd(b, a.mod(b));
	} 
	
	public static BigInteger findT(BigInteger[] events){
		int size = 0;
		for(int i = 1; i < events.length; i++)
			size += i;
		
		BigInteger[] temp = new BigInteger[size];
		
		for(int i = 0, k = 0; i < events.length - 1; i++)
			for (int j = i + 1; j < events.length; j++, k++)
				temp[k] = events[i].subtract(events[j]).abs();
		
		BigInteger t = temp[0];
		for (int i = 1; i < temp.length; i++)
			t = gcd(t, temp[i]);
		
		return t;
	}
	
	public static void main(String[] args) throws IOException {
        File inFile  = new File("B-large.in");
        File outFile = new File("B-large.out");

		Scanner s = new Scanner(inFile);
        BufferedWriter w = new BufferedWriter(new FileWriter(outFile));
        
		if(s.hasNextInt()){
			int c = s.nextInt();
			for(int i = 1; i <= c; i++){
				BigInteger[] events = new BigInteger[s.nextInt()];
				
				for(int j = 0; j < events.length; j++)
					events[j] = s.nextBigInteger();
				
				BigInteger t = findT(events);
				
				if(events[0].mod(t).compareTo(BigInteger.valueOf(0)) == 0)
					w.write("Case #" + i + ": 0");
				else
					w.write("Case #" + i + ": " + t.subtract(events[0].mod(t)));
				
				w.newLine();
			}
		}	
		
		s.close();
		w.close();
	}
}
