package first.b;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

public class TheRepeater {

	public static void main(String[] args) throws FileNotFoundException {

		//Scanner in = new Scanner(new File("the-repeater.in"));
		Scanner in = new Scanner(new File("roundB-A-small-attempt0.in"));
		
		
		int tests = in.nextInt();
		for ( int test = 1; test <= tests; ++test ) {
			int count = in.nextInt();
			List<String> words = new ArrayList<>();
			for ( int i = 0; i < count; ++i ) {
				words.add(in.next());
			}
			
			//System.out.println ( words );
			
			// Check whether there is a solution
			Set<String> shortened = new HashSet<>();
			for ( String word : words ) {
				shortened.add ( removeDuplicateLetters(word) );
			}
			
			if ( shortened.size() == 1 ) {
				// Solution exists
				// Now, for each letter in the shortened version, determine the ideal number of
				// instances to "move" towards (the rounded average) and the number of moves that
				// requires.
				
				//System.out.println("--solution exists--");
				
				List<List<Integer>> allRepeats = new ArrayList<>();
				for ( String word : words ) {
					List<Integer> repeats = countRepeats(word);
					allRepeats.add(repeats);
					//System.out.println ( countRepeats(word) );
				}
				
				int moves = 0;
				
				String shortVersion = shortened.iterator().next();
				int length = shortVersion.length();
				//System.out.println ( "shortVersion = " + shortVersion + "; length = " + length );
				
				for ( int i = 0; i < length; ++i ) {
					double totalRepeats = 0;
					for ( List<Integer> repeats : allRepeats ) {
						totalRepeats += repeats.get(i);
					}
					
					long targetRepeats = Math.round ( totalRepeats / words.size() );
					for ( List<Integer> repeats : allRepeats ) {
						moves += Math.abs(targetRepeats - repeats.get(i));
					}
				}
				
				/*
				double totalLength = 0;
				for ( String word : words ) {
					totalLength += word.length();
				}
				
				long targetLength = Math.round ( totalLength / words.size() );
				int moves = 0;
				for ( String word : words ) {
					moves += Math.abs(targetLength - word.length());
				}
				*/
				
				System.out.printf ( "Case #%d: %d\n", test, moves);
				
			} else {
				System.out.printf ( "Case #%d: Fegla Won\n", test );
			}
		}
		
		in.close();
	}
	
	private static String removeDuplicateLetters ( String input ) {
		StringBuilder buf = new StringBuilder();
		buf.append(input.charAt(0));
		
		char exclude = input.charAt(0);
		for ( int i = 1; i < input.length(); ++i ) {
			char c = input.charAt(i);
			if ( c != exclude ) {
				buf.append ( c );
				exclude = c;
			}
		}
		
		return buf.toString();
	}
	
	private static List<Integer> countRepeats ( String input ) {
		List<Integer> result = new ArrayList<>();
		
		int repeats = 1;
		char current = input.charAt(0);
		for ( int i = 1; i < input.length(); ++i ) {
			char c = input.charAt(i);
			if ( current != c ) {
				result.add(repeats);
				repeats = 1;
				current = c;
			} else {
				++repeats;
			}
		}
		result.add(repeats);
		
		return result;
	}
}
