package codjamdoce;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.text.MessageFormat;

public class Googlerese {

	private static final String NORMAL =     "abcdefghijklmnopqrstuvwxyz";
	private static final String GOOGLERESE = "ynficwlbkuomxsevzpdrjgthaq";
	private File file;
	private int ncases;
	private String[] cases;
	private String[] result;

	public Googlerese(File file) {
		this.file = file;
	}

	private void translate() {
		int count = 0;
		for (String tcase : cases) {
			result[count] = translate(tcase);
			count++;
		}
	}

	private String translate(String phrase) {
		StringBuilder builder = new StringBuilder();
		for (char c : phrase.trim().toCharArray()) {
			int index = GOOGLERESE.indexOf(c);
			if (c == ' ') {
				builder.append(c);
			} else {
				char charAt = NORMAL.charAt(index);
				builder.append(charAt);
			}
		}
		return builder.toString();
	}

	private void printResult() throws IOException {
		int count = 0;
		File outfile = new File("out");
		if (outfile.exists())
			outfile.delete();
		outfile.createNewFile();
		FileOutputStream out = new FileOutputStream(outfile);
		try {
			for (String r : result) {
				if (count == ncases -1) {
					out.write(MessageFormat.format("Case #{0}: {1}", (count + 1), r).getBytes());
				} else {
					out.write(MessageFormat.format("Case #{0}: {1}\n", (count + 1), r).getBytes());
				}
				count++;
			}
		} finally {
			out.close();
		}
	}

	private void init() throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader(file));
		try {
			String line;
			int lineNumber = 0;
			while ((line = reader.readLine()) != null) {
				if (lineNumber == 0) {
					ncases = Integer.valueOf(line.trim());
					cases = new String[ncases];
					result = new String[ncases];
				} else {
					cases[lineNumber - 1] = line.trim();
				}
				lineNumber++;
			}
		} finally {
			reader.close();
		}
	}

	public static void main(String[] args) throws Exception {
		for (char c : Googlerese.NORMAL.toCharArray()) {
			if (!Googlerese.GOOGLERESE.contains(String.valueOf(c))) {
				System.out.println();
			}
		}
		if (args.length < 1) {
			System.out.println("Provide absolute path of input file");
		}
		File file = new File(args[0]);
		if (file.isFile()) {
			Googlerese googlerese = new Googlerese(file);
			googlerese.init();
			googlerese.translate();
			googlerese.printResult();
		}
	}
}
