import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.text.MessageFormat;
import java.util.Arrays;
import java.util.NavigableSet;
import java.util.Scanner;
import java.util.SortedSet;
import java.util.TreeSet;

@SuppressWarnings({"unchecked", "unused"})
public class Solved {

	private static class StdIn {

		// assume Unicode UTF-8 encoding
		private String charsetName = "UTF-8";

		// the scanner object
		private Scanner scanner = new Scanner(new BufferedInputStream(System.in), charsetName);

		public StdIn() {

		}

		public StdIn(InputStream in) {
			scanner = new Scanner(in, charsetName);
		}

		/**
		 * Is there only whitespace left on standard input?
		 */
		public boolean isEmpty() {
			return !scanner.hasNext();
		}

		/**
		 * Return next string from standard input
		 */
		public String readString() {
			return scanner.next();
		}

		/**
		 * Return next int from standard input
		 */
		public int readInt() {
			return scanner.nextInt();
		}

		/**
		 * Return next double from standard input
		 */
		public double readDouble() {
			return scanner.nextDouble();
		}

		/**
		 * Return next float from standard input
		 */
		public float readFloat() {
			return scanner.nextFloat();
		}

		/**
		 * Return next short from standard input
		 */
		public short readShort() {
			return scanner.nextShort();
		}

		/**
		 * Return next long from standard input
		 */
		public long readLong() {
			return scanner.nextLong();
		}

		/**
		 * Return next byte from standard input
		 */
		public byte readByte() {
			return scanner.nextByte();
		}

		/**
		 * Return next boolean from standard input, allowing "true" or "1" for true,
		 * and "false" or "0" for false
		 */
		public boolean readBoolean() {
			String s = readString();
			if (s.equalsIgnoreCase("true"))
				return true;
			if (s.equalsIgnoreCase("false"))
				return false;
			if (s.equals("1"))
				return true;
			if (s.equals("0"))
				return false;
			throw new java.util.InputMismatchException();
		}

		/**
		 * Does standard input have a next line?
		 */
		public boolean hasNextLine() {
			return scanner.hasNextLine();
		}

		/**
		 * Return rest of line from standard input
		 */
		public String readLine() {
			return scanner.nextLine();
		}

		/**
		 * Return next char from standard input
		 */
		// a complete hack and inefficient - email me if you have a better
		public char readChar() {
			// (?s) for DOTALL mode so . matches a line termination character
			// 1 says look only one character ahead
			// consider precompiling the pattern
			String s = scanner.findWithinHorizon("(?s).", 1);
			return s.charAt(0);
		}

		/**
		 * Return rest of input from standard input
		 */
		public String readAll() {
			if (!scanner.hasNextLine())
				return null;

			// reference: http://weblogs.java.net/blog/pat/archive/2004/10/stupid_scanner_1.html
			return scanner.useDelimiter("\\A").next();
		}

		/**
		  * Read rest of input as array of ints
		  */
		public int[] readInts() {
			String[] fields = readAll().trim().split("\\s+");
			int[] vals = new int[fields.length];
			for (int i = 0; i < fields.length; i++)
				vals[i] = Integer.parseInt(fields[i]);
			return vals;
		}

		/**
		  * Read rest of input as array of doubles
		  */
		public double[] readDoubles() {
			String[] fields = readAll().trim().split("\\s+");
			double[] vals = new double[fields.length];
			for (int i = 0; i < fields.length; i++)
				vals[i] = Double.parseDouble(fields[i]);
			return vals;
		}

		/**
		  * Read rest of input as array of strings
		  */
		public String[] readStrings() {
			String[] fields = readAll().trim().split("\\s+");
			return fields;
		}
	}

	public static void main(String[] args) throws FileNotFoundException {
		StdIn in = new StdIn(new FileInputStream(new File("/Users/nacho/Downloads/A-large.in.txt")));
		int cases = in.readInt();
		NavigableSet<Integer> all = new TreeSet<Integer>(Arrays.asList(0, 1, 2, 3, 4, 5, 6, 7, 8, 9));

		for (int i = 0; i < cases; i++) {
			int choosenNumber = in.readInt();
			SortedSet<Integer> seen = new TreeSet<Integer>();
			boolean sleep = false;
			int lastNumber = choosenNumber;
			if (choosenNumber > 0) {
				for (int j = 1; j < Integer.MAX_VALUE; j++) {
					int next = j * choosenNumber;
					lastNumber = next;
					seen.addAll(getDigits(next));
					if (seen.containsAll(all)) {
						sleep = true;
						break;
					}
				}
			}
			System.out.println(MessageFormat.format("Case #{0}: {1}", String.valueOf(i + 1), sleep ? String.valueOf(lastNumber) : "INSOMNIA"));

		}
	}

	private static SortedSet<Integer> getDigits(int number) {
		SortedSet<Integer> result = new TreeSet<Integer>();
		while (number > 0) {
			result.add(number % 10);
			number = number / 10;
		}
		return result;
	}

}
