import java.io.*;
import java.util.StringTokenizer;

public class A {
    public void run() {
        int t = nextInt();
        for (int i = 1; i <= t; ++i) {
            System.out.println("Case #" + i + ":");
            solve();
        }
    }

    private void solve() {
        int n = nextInt();
        int[][] a = new int[n][n];
        double[] wp = new double[n];
        for (int i = 0; i < n; ++i) {
            String s = nextToken();
            int games = 0;
            int won = 0;
            for (int j = 0; j < n; ++j) {
                a[i][j] = s.charAt(j) == '1' ? 1 : s.charAt(j) == '0' ? -1 : 0;
                games += Math.abs(a[i][j]);
                won += Math.max(0, a[i][j]);
            }
            wp[i] = (double)won / games;
        }
        double[] owp = new double[n];
        for (int i = 0; i < n; ++i) {
            int opponents = 0;
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != 0) {
                    int games = 0;
                    int won = 0;
                    for (int k = 0; k < n; ++k) {
                        if (k != i) {
                            games += Math.abs(a[j][k]);
                            won += Math.max(0, a[j][k]);
                        }
                    }
                    owp[i] += (double)won / games;
                    ++opponents;
                }
            }
            owp[i] /= opponents;
        }
        double[] oowp = new double[n];
        for (int i = 0; i < n; ++i) {
            int opponents = 0;
            for (int j = 0; j < n; ++j) {
                if (a[i][j] != 0) {
                    oowp[i] += owp[j];
                    ++opponents;
                }
            }
            oowp[i] /= opponents;
        }
        for (int i = 0; i < n; ++i) {
            System.out.println(0.25 * wp[i] + 0.50 * owp[i] + 0.25 * oowp[i]);
        }

    }

    static {
        try {
            System.setIn(new FileInputStream("A.in"));
            System.setOut(new PrintStream("A.out"));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }
    public static PrintStream out = new PrintStream(new BufferedOutputStream(System.out));
    public static final BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    public static StringTokenizer tokenizer;

    public static void main(String[] args) throws IOException {
        new A().run();
        out.close();
    }

    public static String nextToken() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new Error(e);
            }
        }
        return tokenizer.nextToken();
    }

    public static int nextInt() {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() {
        return Long.parseLong(nextToken());
    }

    public static double nextDouble() {
        return Double.parseDouble(nextToken());
    }
}
