import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class B {
    private static final int MAXN = 1000000;
    int[] points = new int[MAXN];
    int n;
    private int d;

    public void run() {
        int t = nextInt();
        for (int i = 1; i <= t; ++i) {
            System.out.printf("Case #%d: %.10f\n", i, solve());
        }
    }

    private double solve() {
        int c = nextInt();
        d = nextInt();

        n = 0;
        for (int i = 0; i < c; ++i) {
            int p = nextInt();
            int v = nextInt();
            for (int j = 0; j < v; ++j) {
                points[n++] = p;
            }
        }

        Arrays.sort(points, 0, n);

        double lo = 0;
        double hi = (double)n * d;

        for (int i = 0; i < 100; ++i) {
            double min = (lo + hi) / 2;
            if (check(min)) {
                hi = min;
            }
            else {
                lo = min;
            }
        }

        return hi;
    }

    private boolean check(double t) {
        double left = -Double.MAX_VALUE;
        for (int i = 0; i < n; ++i) {
            if (left + d > points[i] + t) {
                return false;
            }
            left = Math.max(points[i] - t, left + d);
        }
        return true;
    }

    static {
            try {
                System.setIn(new FileInputStream("B.in"));
                System.setOut(new PrintStream("B.out"));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }
        public static PrintStream out = new PrintStream(new BufferedOutputStream(System.out));
    public static final BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    public static StringTokenizer tokenizer;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
        out.close();
    }

    public static String nextToken() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new Error(e);
            }
        }
        return tokenizer.nextToken();
    }

    public static int nextInt() {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() {
        return Long.parseLong(nextToken());
    }

    public static double nextDouble() {
        return Double.parseDouble(nextToken());
    }
}
