import java.io.*;
import java.util.*;

public class B {
    private int[][] m;

    public void run() throws IOException {
        int t = nextInt();
        for (int i = 1; i <= t; ++i) {
            int ans = solve();
            out.println("Case #" + i + ": " + (ans < 0 ? "IMPOSSIBLE" : ans));
        }
    }

    private int solve() throws IOException {
        int r = nextInt();
        int c = nextInt();
        int d = nextInt();

        m = new int[r][c];
        for (int i = 0; i < r; ++i) {
            char[] row = nextToken().toCharArray();
            for (int j = 0; j < c; ++j) {
                m[i][j] = d + row[j] - '0';
            }
        }

        long[][][] am = new long[3][r+1][c+1];

        for (int i = 1; i <= r; ++i) {
            for (int j = 1; j <= c; ++j) {
                for (int k = 0; k < 3; ++k) {
                    am[k][i][j]  = getMass(i-1, j-1, k);
                    am[k][i][j] += am[k][i-1][j];
                    am[k][i][j] += am[k][i]  [j-1];
                    am[k][i][j] -= am[k][i-1][j-1];
                }
            }
        }

        for (int k = Math.min(r, c); k >= 3; --k) {
            for (int i = 0; i + k <= r; ++i) {
                for (int j = 0; j + k <= c; ++j) {
                    int cr2 = 2*i + k-1;
                    int cc2 = 2*j + k-1;

                    long[] mass = new long[3];
                    for (int l = 0; l < 3; ++l) {
                        mass[l]  = am[l][i+k][j+k];
                        mass[l] -= am[l][i]  [j+k];
                        mass[l] -= am[l][i+k][j];
                        mass[l] += am[l][i]  [j];

                        mass[l] -= getMass(i,     j,     l);
                        mass[l] -= getMass(i,     j+k-1, l);
                        mass[l] -= getMass(i+k-1, j,     l);
                        mass[l] -= getMass(i+k-1, j+k-1, l);
                    }

                    if (2*mass[1] == cr2 * mass[0] && 2*mass[2] == cc2 * mass[0]) {
                        return k;
                    }
                }
            }
        }
        return -1;
    }

    private int getMass(int i, int j, int k) {
        int ans = m[i][j];
        if (k == 1) {
            ans *= i;
        }
        else if (k == 2) {
            ans *= j;
        }
        return ans;
    }

    public static BufferedReader in;
    public static PrintStream out;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);

        String className = B.class.getSimpleName();
        System.setIn(new FileInputStream(className + ".in"));
        System.setOut(new PrintStream(className + ".out"));

        in = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintStream(new BufferedOutputStream(System.out));

        new B().run();

        out.close();
    }

    public static StringTokenizer tokenizer;

    public static String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(in.readLine());
        }
        return tokenizer.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}
