import java.io.Reader;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 * @author Denis Nedelyaev
 */
public class Main {
	public static void main(String[] args) throws Exception {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		final String regex = "B-(small|large).*[.]in";
		File directory = new File(".");
		File[] candidates = directory.listFiles(new FilenameFilter() {
			public boolean accept(File dir, String name) {
				return name.matches(regex);
			}
		});
		File toRun = null;
		for (File candidate : candidates) {
			if (toRun == null || candidate.lastModified() > toRun.lastModified())
				toRun = candidate;
		}
		inputStream = new FileInputStream(toRun);
		OutputStream outputStream = new FileOutputStream("b.out");
		FastScanner in = new FastScanner(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskB solver = new TaskB(in, out);
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i);
		out.close();
	}
}

class TaskB {
    private final FastScanner in;
    private final PrintWriter out;

    public TaskB(FastScanner in, PrintWriter out) {
        this.in = in;
        this.out = out;
    }

    public void solve(int testNumber) throws IOException {
        Double ans = solve();
        if (ans != null) {
            out.printf("Case #%d: %.10f\n", testNumber, ans);
        } else {
            out.println("Case #" + testNumber + ": IMPOSSIBLE");
        }
    }

    public Double solve() throws IOException {
        int n = in.nextInt();
        double V = Double.parseDouble(in.next());
        double X = Double.parseDouble(in.next());
        if (n == 1) {
            double R = Double.parseDouble(in.next());
            double C = Double.parseDouble(in.next());
            if (C != X) {
                return null;
            } else {
                return V / R;
            }
        } else {
            double R1 = Double.parseDouble(in.next());
            double C1 = Double.parseDouble(in.next());
            double R2 = Double.parseDouble(in.next());
            double C2 = Double.parseDouble(in.next());
            
            if (C1 == X && C2 == X) {
                return V / (R1 + R2);
            } else if (C1 == X) {
                return V / R1;
            } else if (C2 == X) {
                return V / R2;
            } else if (C1 < X && C2 < X || C1 > X && C2 > X) {
                return null;
            } else {
                double V1 = V * (X - C2) / (C1 - C2);
                double V2 = V - V1;
                
                if (V1 < 0 || V2 < 0) {
                    return null;
                } else {
                    return Math.max(V1 / R1, V2 / R2);
                }
            }
        }
    }
}

class FastScanner {
    private BufferedReader br;
    private String line = "";
    private int pos;

    public FastScanner(InputStream is) {
        this(new BufferedReader(new InputStreamReader(is)));
    }

    public FastScanner(Reader reader) {
        br = new BufferedReader(reader);
    }

    public String next() throws IOException {
        if (!goToNextToken()) {
            return null;
        }
        return readString();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    private boolean goToNextToken() throws IOException {
        if (br == null) {
            return false;
        }

        while (pos == line.length()) {
            line = br.readLine();

            if (line == null) {
                br = null;
                return true;
            }

            pos = 0;

            skipWhitespace();
        }

        return true;
    }

    private String readString() {
        int start = pos;

        while (pos < line.length()) {
            char c = line.charAt(pos);

            if (c == ' ' || c == '\t') {
                break;
            }

            pos++;
        }

        String result = line.substring(start, pos);

        skipWhitespace();

        return result;
    }

    private void skipWhitespace() {
        while (pos < line.length()) {
            char c = line.charAt(pos);

            if (c != ' ' && c != '\t') {
                break;
            }

            pos++;
        }
    }
}

