import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;

public class GCJ2012Round2_C {

    private long[] a;
    private long[] h;

    public void run() throws IOException {
        int T = nextInt();
        for (int i = 1; i <= T; ++i) {
            out.print("Case #" + i + ":");
            solve();
        }
    }

    private void solve() throws IOException {
        int n = nextInt();
        a = new long[n - 1];
        for (int i = 0; i < n - 1; ++i) {
            a[i] = nextInt() - 1;
        }
        h = new long[n];
        h[n-1] = 1000000000;
        calc(0, n - 1, 0, 1000000000);
        for (int i = 0; i < n; ++i) {
            if (h[i] == 0) {
                out.println(" Impossible");
                return;
            }
        }
        for (int i = 0; i < n; ++i) {
            out.print(" " + h[i]);
        }
        out.println();
    }

    private void calc(int from, int to, long prevDist, long prevHeight) {
        if (from >= to) {
            return;
        }
        for (int i = from; i < to; ++i) {
            if (a[i] > to) {
                h[i] = 0;
                return;
            }
            if (a[i] == to) {
                h[i] = prevHeight + (h[to] - prevHeight) * (i - prevDist) / (to - prevDist) - 1;
                prevDist = i;
                prevHeight = h[i];
                calc(from, i, i - (to - i), h[i] - (h[to] - h[i]));
                from = i + 1;
            }
        }
    }

    public static BufferedReader in;
    public static PrintStream out;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);

        String className = GCJ2012Round2_C.class.getSimpleName();
        char lastChar = className.charAt(className.length() - 1);
        System.setIn(new FileInputStream(lastChar + ".in"));
        System.setOut(new PrintStream(lastChar + ".out"));

        in = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintStream(new BufferedOutputStream(System.out));

        new GCJ2012Round2_C().run();

        out.close();
    }

    public static StringTokenizer tokenizer;

    public static String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(in.readLine());
        }
        return tokenizer.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}
