import java.io.*;
import java.util.*;

public class A {
    public void run() throws IOException {
        int t = nextInt();
        for (int i = 1; i <= t; ++i) {
            out.println("Case #" + i + ": " + solve());
        }
    }

    private double solve() throws IOException {
        double x = nextInt();
        double s = nextInt();
        double r = nextInt();
        double t = nextInt();
        int n = nextInt();

        SortedMap<Double, Double> ways = new TreeMap<Double, Double>();

        for (int i = 0; i < n; ++i) {
            double b = nextInt();
            double e = nextInt();
            double w = nextInt();

            Double d = ways.get(w);

            ways.put(w, (d == null ? 0 : d) + e - b);
            x -= e - b;
        }

        ways.put(0.0, x);

        double ans = 0;

        for (Map.Entry<Double, Double> way : ways.entrySet()) {
            double w = way.getKey();
            double d = way.getValue();

            if ((r + w) * t <= d) {
                ans += t + (d - (r + w) * t) / (s + w);
                t = 0;
            }
            else {
                double q = d / (r + w);
                ans += q;
                t -= q;
            }
        }

        return ans;
    }

    public static BufferedReader in;
    public static PrintStream out;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);

        String className = A.class.getSimpleName();
        System.setIn(new FileInputStream(className + ".in"));
        System.setOut(new PrintStream(className + ".out"));

        in = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintStream(new BufferedOutputStream(System.out));

        new A().run();

        out.close();
    }

    public static StringTokenizer tokenizer;

    public static String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(in.readLine());
        }
        return tokenizer.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}
