import java.io.FileInputStream;
import java.io.PrintWriter;
import java.util.Scanner;
import com.google.common.math.DoubleMath;

public class Main {

    static final String EXAMPLE_INPUT = "example.txt";
    static final String SMALL_INPUT = "C-small-attempt0.in";
    static final String LARGE_INPUT = "C-large.in";
    static final String OUTPUT = "output.txt";

    public static void main(String[] args) throws Exception {
        startProcessing();
    }

    static void startProcessing() throws Exception {
        try(FileInputStream stream = new FileInputStream(SMALL_INPUT);
            Scanner scanner = new Scanner(stream);
            PrintWriter writer = new PrintWriter(OUTPUT))
        {
            int T = scanner.nextInt();
            for (int caseNum = 1; caseNum <= T; ++caseNum) {
                long caseRes = solveCase(scanner);
                writer.println("Case #" + caseNum + ": " + caseRes);
            }
        }
    }

    static long solveCase(Scanner scanner) {
        long result = 0;
        long A = scanner.nextLong();
        long B = scanner.nextLong();
        long baseOfA = (long) Math.ceil(Math.sqrt(A));
        long baseOfB = (long) Math.floor(Math.sqrt(B));
        for (long base = baseOfA; base <= baseOfB; ++base) {
            if (isPalindrome(base)) {
                double squared = Math.pow(base, 2);
                if (DoubleMath.isMathematicalInteger(squared)) {
                    long squaredInt = (long) squared;
                    if (isPalindrome(squaredInt)) {
                        result += 1;
                        //System.out.println("Fair square found: " + base + " " + squaredInt);
                    }
                }
            }
        }
        return result;
    }

    static boolean isPalindrome(long number) {
        String chars = String.valueOf(number);
        int len = chars.length();
        for (int index = 0; index < (len / 2); ++index) {
            if (chars.charAt(index) != chars.charAt(len - 1 - index)) {
                return false;
            }
        }
        return true;
    }
}
