import java.io.FileInputStream;
import java.io.PrintWriter;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

public class Main {

    static final String EXAMPLE_INPUT = "example.txt";
    static final String SMALL_INPUT = "A-small-attempt2.in";
    static final String LARGE_INPUT = "C-large-1.in";
    static final String OUTPUT = "output.txt";

    public static void main(String[] args) throws Exception {
        startProcessing();
    }

    static void startProcessing() throws Exception {
        try(FileInputStream stream = new FileInputStream(SMALL_INPUT);
            Scanner scanner = new Scanner(stream);
            PrintWriter writer = new PrintWriter(OUTPUT))
        {
            int T = scanner.nextInt();
            for (int caseNum = 1; caseNum <= T; ++caseNum) {
                long caseRes = solveCase(scanner);
                writer.println("Case #" + caseNum + ": " + caseRes);
            }
        }
    }

    static int solveCase(Scanner scanner) {
        List<Integer> motes = new LinkedList<>();
        int A = scanner.nextInt();
        int N = scanner.nextInt();
        for (int mote = 0; mote < N; ++mote) {
            motes.add(scanner.nextInt());
        }
        Collections.sort(motes);

        if (A == 1) {
            return motes.size();
        }

        int result = recursiveSolve(motes, A, 0, motes.size());
        if (result > motes.size()) {
            return motes.size();
        }
        return result;
    }

    static int recursiveSolve(List<Integer> motes, int arminSize, int index, int motesLeft) {
        if (motesLeft == 0) {
            return 0;
        }
        int operations = 0;
        int nextMote = motes.get(index);
        if (nextMote < arminSize) {
            arminSize += nextMote;
            ++index;
            --motesLeft;
        } else {
            while (arminSize <= nextMote) {
                int maxEatableMote = arminSize - 1;
                arminSize += maxEatableMote;
                operations += 1;
                if (operations >= motesLeft) {
                    return motesLeft;
                }
            }
        }
        int recurseResult = recursiveSolve(motes, arminSize, index, motesLeft);
        return Math.min(operations + motesLeft, operations + recurseResult);
    }
}
