import sun.font.TrueTypeFont;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Scanner;

public class Main {

    static final String EXAMPLE_INPUT = "example.txt";
    static final String SMALL_INPUT = "B-small-attempt0.in";
    static final String OUTPUT = "output.txt";

    public static void main(String[] args) throws Exception {
	    startProcessing();
    }

    static void startProcessing() throws Exception {
        try(FileInputStream stream = new FileInputStream(SMALL_INPUT);
            Scanner scanner = new Scanner(stream);
            PrintWriter writer = new PrintWriter(OUTPUT))
        {
            int T = scanner.nextInt();
            for (int caseNum = 1; caseNum <= T; ++caseNum) {
                boolean caseRes = solveCase(scanner);
                String caseResult = caseRes == true ? "YES" : "NO";
                writer.println("Case #" + caseNum + ": " + caseResult);
            }
        }
    }

    static boolean solveCase(Scanner scanner) {
        int N = scanner.nextInt();
        int M = scanner.nextInt();

        // maxes
        int[] rowMax = new int[N];
        int[] colMax = new int[M];

        for (int row = 0; row < N; ++row) {
            rowMax[row] = 0;
        }
        for (int col = 0; col < M; ++col) {
            colMax[col] = 0;
        }

        // read lawn plan
        int[][] lawnPlan = new int[N][M];
        for (int row = 0; row < N; ++row) {
            for (int col = 0; col < M; ++col) {
                int cellVal = scanner.nextInt();
                if (cellVal > rowMax[row]) {
                    rowMax[row] = cellVal;
                }
                if (cellVal > colMax[col]) {
                    colMax[col] = cellVal;
                }
                lawnPlan[row][col] = cellVal;
            }
        }

        // check feasibility
        for (int row = 0; row < N; ++row) {
            for (int col = 0; col < M; ++col) {
                int cellVal = lawnPlan[row][col];
                if ((rowMax[row] > cellVal) && (colMax[col] > cellVal)) {
                    return false;
                }
            }
        }
        return true;
    }
}
