import java.io.*;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.*;

/**
 * Created by kuzmende on 4/15/17.
 */
public class RoundB2 {



    public static void main(String[] args) throws FileNotFoundException {
        File text = new File("/Users/kuzmende/Downloads/B-small-attempt0(1).in");
        Scanner in = new Scanner(text);

        //Scanner in = new Scanner(System.in);
        int cases_count = in.nextInt();

        try (BufferedWriter bw = new BufferedWriter(new FileWriter("result.out"))) {

            for (int i = 0; i < cases_count; i++) {
                Integer count = in.nextInt();
                Map<String,Integer> unicorns = new HashMap<>();
                unicorns.put("R",in.nextInt());
                unicorns.put("O",in.nextInt());
                unicorns.put("Y",in.nextInt());
                unicorns.put("G",in.nextInt());
                unicorns.put("B",in.nextInt());
                unicorns.put("V",in.nextInt());

                String result = solvePuzzle(unicorns, count);

                String content = "Case #" + (i + 1) + ": " + result + "\n";
                bw.write(content);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    private static String solvePuzzle(Map<String,Integer> unicorns, Integer count) {
        String result = "";
        Integer index = 0;

        while(index<count) {
            String[] allowed = getAllowedColors(result, index, count);

            boolean found = false;
            for (String color : allowed) {
                Integer cc = unicorns.get(color);
                if (cc > 0) {
                    found = true;
                    unicorns.put(color, cc - 1);
                    result+=color;
                    break;
                }
            }
            if(!found){
                return "IMPOSSIBLE";
            }

            index++;
        }

        return result;
    }

    private static String[] getAllowedColors(String result, Integer index, Integer count) {
        if (index == 0) {
            return "R,O,Y,G,B,V".split(",");

        } else if (index < count - 1) {
            switch (result.charAt(index-1)) {
                case 'R':
                    return "Y,G,B".split(",");
                case 'O':
                    return new String[]{"B"};
                case 'Y':
                    return "R,B,V".split(",");
                case 'G':
                    return new String[]{"R"};
                case 'B':
                    return "R,O,Y".split(",");
                case 'V':
                    return new String[]{"G"};
            }
        } else {
            String[] a = new String[0];
            switch (result.charAt(index-1)) {
                case 'R':
                    a = "Y,G,B".split(",");
                    break;
                case 'O':
                    a = new String[]{"B"};
                    break;
                case 'Y':
                    a = "R,B,V".split(",");
                    break;
                case 'G':
                    a = new String[]{"R"};
                    break;
                case 'B':
                    a = "R,O,Y".split(",");
                    break;
                case 'V':
                    a = new String[]{"G"};
            }

            String[] b = new String[0];
            switch (result.charAt(0)) {
                case 'R':
                    b = "Y,G,B".split(",");
                    break;
                case 'O':
                    b = new String[]{"B"};
                    break;
                case 'Y':
                    b = "R,B,V".split(",");
                    break;
                case 'G':
                    b = new String[]{"R"};
                    break;
                case 'B':
                    b = "R,O,Y".split(",");
                    break;
                case 'V':
                    b = new String[]{"G"};
            }

            Set<String> res = new HashSet<>();
            for (String anA : a) {
                for (String aB : b) {
                    if (anA.equals(aB)) {
                        res.add(anA);
                    }
                }
            }
            return res.toArray(new String[res.size()]);
        }
        return new String[0];
    }


}
