import java.util.Scanner;

/**
 * Created by kuzmende on 4/8/17.
 */
public class Pancake {


    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int cases_count = in.nextInt();

        for (int i = 0; i < cases_count; i++) {
            char[] pancake_pattern = in.next().toCharArray();
            int flipper_size = in.nextInt();

            int result = solvePuzzle(pancake_pattern, flipper_size);
            System.out.println("Case #" + (i + 1) + ": "
                    + ((result != -1) ? result : "IMPOSSIBLE"));
        }
    }

    private static int solvePuzzle(char[] pancake_pattern, int flipper_size) {
        int flip_count = 0;
        for (int i = 0; i < pancake_pattern.length; i++) {
            if (pancake_pattern[i] == '-') {
                boolean success = flit(pancake_pattern, i, flipper_size);
                if (!success) {
                    return -1;
                }
                flip_count++;
            }
        }
        return flip_count;
    }

    private static boolean flit(char[] pancake_pattern, int start, int flipper_size) {
        if (start + flipper_size > pancake_pattern.length) {
            return false;
        }

        for (int i = start; i < start + flipper_size; i++) {
            pancake_pattern[i] = inverse(pancake_pattern[i]);
        }
        return true;
    }


    private static char inverse(char symbol) {
        return symbol == '-' ? '+' : '-';
    }
}
