import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

/**
 * Created by kuzmende on 4/8/17.
 */
public class BathroomStalls {


    public static void main(String[] args) throws FileNotFoundException {
        File text = new File("/Users/kuzmende/Downloads/C-small-1-attempt0.in");
        Scanner in = new Scanner(text);

        //Scanner in = new Scanner(System.in);
        int cases_count = in.nextInt();

        try (BufferedWriter bw = new BufferedWriter(new FileWriter("result.out"))) {

            for (int i = 0; i < cases_count; i++) {
                long stall_number = in.nextLong();
                long visitor_number = in.nextLong();

                long[] result = solvePuzzle(stall_number, visitor_number);

                String content = "Case #" + (i + 1) + ": " + result[1] + " " + result[0] + "\n";
                bw.write(content);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static long[] solvePuzzle(long stall_number, long visitor_number) {
        List<Long> occupiedStalls = new ArrayList<>();
        occupiedStalls.add(0L);
        occupiedStalls.add(stall_number + 1);

        long[] min_max_result = new long[2];

        for (int visitor = 0; visitor < visitor_number; visitor++) {
            long suitable_stall = -1L;
            long[] min_max = new long[2];

            for (int i = 0; i < occupiedStalls.size() - 1; i++) {
                long result = pickMiddleLeftOne(occupiedStalls.get(i), occupiedStalls.get(i + 1));

                if (result != -1) {
                    long min = Math.min(result - occupiedStalls.get(i), occupiedStalls.get(i + 1) - result) - 1;
                    long max = Math.max(result - occupiedStalls.get(i), occupiedStalls.get(i + 1) - result) - 1;

                    if (suitable_stall == -1
                            || min_max[0] < min
                            || min_max[0] == min && min_max[1] < max) {

                        min_max[0] = min;
                        min_max[1] = max;

                        suitable_stall = result;
                    }
                }
            }

            if(visitor != visitor_number-1) {
                int insertionPoint = Collections.binarySearch(occupiedStalls, suitable_stall);
                occupiedStalls.add((insertionPoint > -1) ? insertionPoint : (-insertionPoint) - 1, suitable_stall);

            } else {
                min_max_result = min_max;
            }
        }

        return min_max_result;
    }

    private static long pickMiddleLeftOne(long start, long end) {
        long free_range = end - start;
        if (free_range > 1) {
            return start + free_range / 2;
        }
        return -1;
    }

}
