import java.io.*;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.Queue;
import java.util.Scanner;

/**
 * Created by kuzmende on 4/15/17.
 */
public class RoundB {

    private static class Car {
        BigDecimal position;
        BigDecimal speed;

        public Car(BigDecimal position, BigDecimal speed) {
            this.position = position;
            this.speed = speed;
        }
    }

    public static void main(String[] args) throws FileNotFoundException {
        File text = new File("/Users/kuzmende/Downloads/A-large(1).in");
        Scanner in = new Scanner(text);

        //Scanner in = new Scanner(System.in);
        int cases_count = in.nextInt();

        try (BufferedWriter bw = new BufferedWriter(new FileWriter("result.out"))) {



            for (int i = 0; i < cases_count; i++) {
                BigDecimal distance = in.nextBigDecimal();
                int cars_count = in.nextInt();

                Queue<Car> cars = new PriorityQueue<>(cars_count, new Comparator<Car>() {
                    @Override
                    public int compare(Car o1, Car o2) {
                        return o1.position.compareTo(o2.position) * -1;
                    }
                });

                for (int j = 0; j < cars_count; j++) {
                    BigDecimal position = in.nextBigDecimal();
                    BigDecimal speed = in.nextBigDecimal();

                    cars.add(new Car(position,speed));
                }


                BigDecimal result = solvePuzzle(distance, cars);

                String content = "Case #" + (i + 1) + ": " + result + "\n";
                bw.write(content);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    private static BigDecimal solvePuzzle(BigDecimal distance, Queue<Car> cars) {

        Car last = cars.remove();
        BigDecimal time = null;

        if(cars.isEmpty()){
            time = distance.subtract(last.position)
                            .divide(last.speed, 6, RoundingMode.HALF_UP);
        }

        else {
            while(!cars.isEmpty()) {
                Car prev = cars.remove();
                BigDecimal meetTime = prev.speed.subtract(last.speed).divide(last.position.subtract(prev.position), 6, RoundingMode.HALF_UP);

                BigDecimal meetPos = meetTime.compareTo(BigDecimal.ZERO) > 0 ?
                        meetTime.multiply(last.speed).add(last.position) :
                        distance;

                time = meetPos.compareTo(distance) >= 0 ?
                        distance.subtract(prev.position).divide(prev.speed, 6, RoundingMode.HALF_UP) :
                        meetTime.add(distance.subtract(meetPos).divide(last.speed, 6, RoundingMode.HALF_UP));

                if (meetPos.compareTo(distance) >= 0) {
                    last = prev;
                }
            }
        }

        return distance.divide(time, 6, RoundingMode.HALF_UP);
    }
}
