import java.io.*;
import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.Scanner;

/**
 * Created by kuzmende on 4/8/17.
 */
public class BathroomStalls {


    public static void main(String[] args) throws FileNotFoundException {
        File text = new File("/Users/kuzmende/Downloads/C-small-2-attempt1.in");
        Scanner in = new Scanner(text);

        //Scanner in = new Scanner(System.in);
        int cases_count = in.nextInt();

        try (BufferedWriter bw = new BufferedWriter(new FileWriter("result.out"))) {

            for (int i = 0; i < cases_count; i++) {
                long stall_number = in.nextLong();
                long visitor_number = in.nextLong();

                long[] result = solvePuzzle(stall_number, visitor_number);

                String content = "Case #" + (i + 1) + ": " + result[1] + " " + result[0] + "\n";
                bw.write(content);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static long[] solvePuzzle(long stall_number, long visitor_number) {

        //<start, size>
        PriorityQueue<Long[]> freeRange = new PriorityQueue<>(1000, new Comparator<Long[]>() {
            @Override
            public int compare(Long[] o1, Long[] o2) {
                int result = o1[1].compareTo(o2[1]) * -1;
                if (result == 0) {
                    result = o1[0].compareTo(o2[0]);
                }
                return result;
            }
        });

        freeRange.add(new Long[]{1L, stall_number});

        long[] min_max = new long[2];

        for (int visitor = 0; visitor < visitor_number; visitor++) {
            long min = 0, max = 0;
            long left = 0, right = 0;

            if (!freeRange.isEmpty()) {
                Long[] range = freeRange.remove();
                Long rangeSize = range[1];

                long result = pickMiddleLeftOne(range[0], rangeSize);

                if (result != -1) {
                    left = result - range[0];
                    right = range[0] + rangeSize - result - 1;

                    min = Math.min(left, right);
                    max = Math.max(left, right);
                }

                if (visitor != visitor_number - 1) {
                    freeRange.add(new Long[]{range[0], left});
                    freeRange.add(new Long[]{result + 1, right});

                } else {
                    min_max = new long[]{min, max};
                }
            }
        }

        return min_max;
    }

    private static long pickMiddleLeftOne(long start, long size) {
        if (size > 0) {
            return start + (size + 1) / 2 - 1;
        }
        return -1;
    }

}
