import java.io.*;
import java.util.*;

public class CounterCulture {
	static int T;
	static int N;
	static int count = 0;
	
	static class SwappableInteger {
		List<Integer> integer;
		
		public SwappableInteger(int value) {
			integer = new ArrayList<Integer>();
			while ( value != 0 ) {
				int digit = value % 10;
				integer.add(digit);
				value /= 10;
			}
			doNotCountSwap();
		}
		
		public boolean endSmaller(int dist) {
			return integer.get(dist) < integer.get(integer.size()-1-dist);
		}
		
		public int numDigits() {
			return integer.size();
		}
		
		public boolean endsInOne() {
			return integer.get(integer.size()-1) == 1;
		}
		
		public boolean isOne() {
			return integer.size() == 1 && integer.get(0) == 1;
		}
		
		public void reduce(int dist) {
			int num1 = integer.get(integer.size()-1-dist);
			count += num1 * Math.pow(10, dist);
			integer.set(integer.size()-1-dist, 0);
		}
		
		public boolean bothEndsOne() {
			int num1 = integer.get(integer.size()-1);
			int num2 = integer.get(0);
			return num1 == 1 && num2 == 1;
		}
		
		public boolean bothEndsZero(int dist) {
			int num1 = integer.get(integer.size()-1-dist);
			int num2 = integer.get(dist);
			return num1 == 0 && num2 == 0;
		}
		
		public void doNotCountSwap() {
			List<Integer> swapped = new ArrayList<Integer>();
			while ( integer.size() != 0 ) {
				swapped.add(integer.remove(integer.size()-1));
			}
			integer = swapped;
		}
		
		public void swap() {
			List<Integer> swapped = new ArrayList<Integer>();
			while ( integer.size() != 0 ) {
				swapped.add(integer.remove(integer.size()-1));
			}
			integer = swapped;
			count++;
		}
		
		public int getInt() {
			int value = 0;
			int multiplier = 1;
			for ( int i=integer.size()-1; i >= 0; i-- ) {
				value += multiplier * integer.get(i);
				multiplier *= 10;
			}
			return value;
		}
		
		public void sub() {
			int value = getInt();
			value--;
			SwappableInteger s = new SwappableInteger(value);
			this.integer = s.integer;
			count++;
		}
	}
	
	public static void main(String[] args) throws IOException {
		BufferedReader f = new BufferedReader(new FileReader("counter.in"));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("counter.out")));
		
		T = Integer.parseInt(f.readLine());
		for ( int test=1; test <= T; test++ ) {
			count = 1;
			N = Integer.parseInt(f.readLine());
			solve(test,out);
		}
		
		f.close();
		out.close();
	}

	public static void compare() throws IOException {
		BufferedReader f1 = new BufferedReader(new FileReader("counter.out1"));
		BufferedReader f2 = new BufferedReader(new FileReader("counter.out2"));
		for ( int test=1; test<=T; test++ ) {
			System.out.println(f1.readLine().equals(f2.readLine()));
		}
		f1.close(); f2.close();
	}
	
	private static void solve(int test, PrintWriter out) {
		SwappableInteger s = new SwappableInteger(N);
		while ( !s.isOne() ) {
			while ( !s.endsInOne() ) {
				s.sub();
			}
//			if ( !s.bothEndsOne() ) {
//				s.swap();
//				while ( !s.endsInOne() ) {
//					s.sub();
//				}
//			}
			boolean allGood = true;
			if ( !s.bothEndsOne() ) {
				allGood = false;
			}
			for ( int i=1; i <= (s.numDigits()+1) / 2 - 1; i++ ) {
				s.reduce(i);
				if ( !s.bothEndsZero(i) ) {
					allGood = false;
				}
			}
			if ( !allGood ) {
				s.swap();
				while ( !s.endsInOne() ) {
					s.sub();
				}
				for ( int i=1; i <= (s.numDigits()+1) / 2 - 1; i++ ) {
					s.reduce(i);
				}
			}
			
			if ( !s.isOne() ) {
				s.sub(); s.sub();
			} else {
				out.println(String.format("Case #%d: %d",test,count));
				return;
			}
		}
		out.println(String.format("Case #%d: %d",test,count));
		return;
	}
}
