import java.util.*;
import java.io.*;

public class MushroomMonster {
	
	public static int methodOne(int[] mushroomPieces, int N) {
		// use method one
		int numEaten = 0;
		for ( int i=0; i < N-1; i++ ) {
			int numPieces1 = mushroomPieces[i];
			int numPieces2 = mushroomPieces[i+1];
			if ( numPieces2 < numPieces1 ) {
				numEaten += numPieces1 - numPieces2;
			}
		}
		return numEaten;
	}
	
	public static int methodTwo(int[] mushroomPieces, int N) {
		int largestDiff = 0;
		for ( int i=0; i < N-1; i++ ) {
			int numPieces1 = mushroomPieces[i];
			int numPieces2 = mushroomPieces[i+1];
			largestDiff = Math.max(largestDiff, numPieces1 - numPieces2);
		}
		int numEaten = 0;
		for ( int i=0; i < N-1; i++ ) {
			int numPieces = mushroomPieces[i];
			numEaten += Math.min(largestDiff, numPieces);
		}
		return numEaten;
	}
	
	public static void main(String[] args) throws IOException {
		BufferedReader f= new BufferedReader(new FileReader("mushroom.in"));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("mushroom.out")));
		
		int T = Integer.parseInt(f.readLine());
		
		for ( int test=1; test <= T; test++ ) {
			int N = Integer.parseInt(f.readLine());
			StringTokenizer st = new StringTokenizer(f.readLine());
			int[] mushroomPieces = new int[N];
			for ( int i=0; i < N; i++ ) {
				mushroomPieces[i] = Integer.parseInt(st.nextToken());
			}
			int numEaten1 = methodOne(mushroomPieces,N);
			int numEaten2 = methodTwo(mushroomPieces,N);
			out.println(String.format("Case #%d: %d %d",test, numEaten1, numEaten2));
		}
		
		f.close();
		out.close();
	}
}
