import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Set;

public class CountingSheep {

	public static Set<Integer> getDigits(int N) {
		Set<Integer> digits = new HashSet<>();
		while (N != 0) {
			digits.add(N % 10);
			N /= 10;
		}
		return digits;
	}
	
	public static int lastCount(int N) {
		if (N == 0) return -1;
		int count = N;
		Set<Integer> digitsSeen = getDigits(count);
		while (digitsSeen.size() != 10) {
			count += N;
			digitsSeen.addAll(getDigits(count));
		}
		return count;
	}
	
	public static void main(String[] args) throws IOException {
		BufferedReader f  = new BufferedReader(new FileReader("A-large.in"));
		PrintWriter out = new PrintWriter(new FileWriter("A-large.out"));
		
		int T = Integer.parseInt(f.readLine());
		for (int i = 1; i <= T; i++) {
			int N = Integer.parseInt(f.readLine());
			int ans = lastCount(N);
			if (ans == -1) {
				out.write(String.format("Case #%d: INSOMNIA\n", i));
			} else {
				out.write(String.format("Case #%d: %d\n", i, ans));
			}
		}
		
		f.close();
		out.close();
	}
	
}
