import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class RevengeOfThePancakes {

	public static int minFlips(List<Boolean> pancakeStack) {
		int numFlips = 0;
		for (int i = 0; i < pancakeStack.size(); i++) {
			boolean onHappy = pancakeStack.get(i);
			if (i == pancakeStack.size() - 1) {
				if (!onHappy) {
					numFlips++;
				}
			} else {
				boolean nextHappy = pancakeStack.get(i + 1);
				if (onHappy != nextHappy) {
					numFlips++;
				}
			}
		}
		return numFlips;
	}
	
	private static List<Boolean> convertToList(String stack) {
		List<Boolean> list = new ArrayList<>();
		for (int i = 0; i < stack.length(); i++) {
			if (stack.charAt(i) == '+') {
				list.add(true);
			} else {
				list.add(false);
			}
		}
		return list;
	}
	
	public static void main(String[] args) throws IOException {
		BufferedReader f = new BufferedReader(new FileReader("B-large.in"));
		PrintWriter out = new PrintWriter(new FileWriter("B-large.out"));
		
		int T = Integer.parseInt(f.readLine());
		for (int i = 1; i <= T; i++) {
			List<Boolean> stack = convertToList(f.readLine());
			out.write(String.format("Case #%d: %d\n", i, minFlips(stack)));
		}
		
		f.close();
		out.close();
	}
	
}
