/**
 * Created by 成 on 2015/4/11.
 */

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.*;

/**
 * Input
 * <p/>
 * 3
 * 1
 * 3
 * 4
 * 1 2 1 2
 * 1
 * 4
 * <p/>
 * <p/>
 * Output
 * <p/>
 * Case #1: 3
 * Case #2: 2
 * Case #3: 3
 */
public class t2 {
    public static Scanner scanner;

    public static void main(String[] args) throws Exception {
        scanner = new Scanner(new File("t2.in.txt"));
        FileOutputStream propFile = new FileOutputStream("t2.out.txt");
        OutputStream multi = new MultiOutputStream(new PrintStream(propFile), System.out);
        System.setOut(new PrintStream(multi));

        int number = scanner.nextInt();
        for (int i = 0; i < number; i++) {
            int result = getResult();
            System.out.format("Case #%d: %d\n", i + 1, result);
        }
    }

    private static int getResult() {
        int d = scanner.nextInt();
        Integer[] p = new Integer[d];
        Diner[] diners = new Diner[d + 1];
        for (int i = 0; i <= d; i++) {
            diners[i] = new Diner();
        }

        for (int i = 0; i < d; i++) {
            p[i] = scanner.nextInt();
        }

        Arrays.sort(p,Collections.reverseOrder());
        int kmax = 0;
        int last = Integer.MAX_VALUE;
        int kn = 0;
        for (int i = 0; i < d; i++) {
            if (p[i] < last) {
                if (last != Integer.MAX_VALUE) {
                    diners[kmax].value = last;
                    diners[kmax].num = kn;
                    kmax++;
                }
                kn = 1;
                last = p[i];
            } else {
                kn++;
            }
        }
        diners[kmax].value = last;
        diners[kmax].num = kn;
        kmax++;

        diners[kmax].value = 0;
        diners[kmax].num = 0;

        //calc
        int result = 0;
        while (kmax >= 1) {
            int cost1 = diners[0].value - diners[1].value;
            int cost2 = diners[0].num;
            if (cost1 <= cost2) {
                result += cost1;
                kmax = process1(diners, kmax);
            } else {
                result += cost2;
                kmax = process2(diners, kmax);
            }
        }

        return result;
    }

    private static int process1(Diner[] diners, int kmax) {
        diners[1].num = diners[1].num + diners[0].num;
        for (int i = 0; i < kmax; i++) {
            diners[i] = diners[i + 1];
        }
        return kmax - 1;
    }

    private static int process2(Diner[] diners, int kmax) {
        int newValue = (diners[0].value + 1) / 2;
        boolean existValue = false;
        for (int i = 1; i < kmax; i++) {
            if (diners[i].value == newValue) {
                diners[i].num += diners[0].num * 2;
                existValue = true;
            }
        }

        if (existValue) {
            for (int i = 0; i < kmax; i++) {
                diners[i] = diners[i + 1];
            }
            return kmax - 1;
        } else {
            diners[0].value = newValue;
            diners[0].num *= 2;
            Arrays.sort(diners, new Comparator<Diner>() {
                @Override
                public int compare(Diner diner, Diner diner2) {
                    return diner2.value - diner.value;
                }
            });
            return kmax;
        }
    }

    //calc
    static class Diner {
        int value;
        int num;

        @Override
        public String toString() {
            return "value=" + value + ",num=" + num;
        }
    }
}
