package probC;

import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

class FactorCallable implements Callable<BigInteger>{
	BigInteger i;
	FactorCallable(BigInteger i){
		this.i=i;
	}
	BigInteger factor(BigInteger i){
		BigInteger n=new BigInteger("2");
		
		while(!i.remainder(n).equals(BigInteger.ZERO)){
			n=n.add(BigInteger.ONE);
		}
		return n;
	}
	public BigInteger call(){
		return factor(i);
	}
}
public class ProbCL {
	static int produced=0;
	static FileWriter out;
	
	static void print(String s) throws IOException{
		out.write(s);
	}
	public static void main(String[] args) throws IOException, InterruptedException, ExecutionException {
		int J = 500;//number of jamcoin to produce
		BigInteger[]interpretation = new BigInteger[11];
		BigInteger[]factor = new BigInteger[11];
		
		out=new FileWriter("C:\\Users\\Dennis\\Documents\\Eclipse\\Codejam2016\\Cl.out");
		print("Case #1:\n");
		
		BigInteger jamCoin=new BigInteger("10000000000000000000000000000001",2);
		BigInteger TWO=new BigInteger("2"); 
		String jamCoinStr;
		boolean isPrime=false;
		
		ExecutorService executor = Executors.newCachedThreadPool();
		Future<BigInteger> factorFuture;
		FactorCallable factorTask;
		while(produced<J){
			isPrime=false;
			jamCoinStr=jamCoin.toString(2);
			for(int radix=2;radix<11;radix++){
				interpretation[radix]=new BigInteger(jamCoinStr, radix);
				isPrime=interpretation[radix].isProbablePrime(1);
				if(isPrime)break;
			}
			
			if(!isPrime){
				for(int radix=2;radix<11;radix++){
					factorTask=new FactorCallable(interpretation[radix]);
					factorFuture=executor.submit(factorTask);
					try{
						factor[radix]=factorFuture.get(100, TimeUnit.MILLISECONDS);
					}catch(TimeoutException ex){
						isPrime=true;
						factorFuture.cancel(true);
						break;
					}
				}
			}
			
			if(!isPrime){
				//print everything
				print(jamCoinStr+" ");
				for(int radix=2;radix<11;radix++){
					print(factor[radix].toString()+" ");
				}
				produced++;
				print("\n");
			}
			jamCoin=jamCoin.add(TWO);
		}
		
		out.close();
		executor.shutdownNow();
		System.exit(0);
	}
}
