package year2009.qualify.b;

import java.io.PrintWriter;
import java.io.FileReader;
import java.io.IOException;
import java.util.*;

/**
 * @author kouznetsov
 *         Created on 03.09.2009
 */
public class ProblemB {
    private static int[][] water;
    private static Dir[][] links;
    private static int H;
    private static int W;
    private static char[][] charz;

    enum Dir {
        N(-1, 0), W(0, -1), E(0, 1), S(1, 0), SINK(0, 0);
        private int dh;
        private int dw;

        Dir(int dh, int dw) {
            this.dh = dh;
            this.dw = dw;
        }
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        Scanner scanner = new Scanner(new FileReader("water.in"));
        PrintWriter out = new PrintWriter("water.out");
        int T = scanner.nextInt();
        for (int test = 0; test < T; test++) {
            H = scanner.nextInt();
            W = scanner.nextInt();
            water = new int[H][W];
            links = new Dir[H][W];
            charz = new char[H][W];
            for (int i = 0; i < H; i++) {
                for (int j = 0; j < W; j++) {
                    water[i][j] = scanner.nextInt();
                }
            }
            for (int i = 0; i < H; i++) {
                for (int j = 0; j < W; j++) {
                    Dir result = Dir.SINK;
                    int lowest = water[i][j];
                    for (Dir d : Dir.values()) {
                        int h1 = i + d.dh;
                        int w1 = j + d.dw;
                        if (0 <= h1 && h1 < H && 0 <= w1 && w1 < W) {
                            if (water[h1][w1] < lowest) {
                                result = d;
                                lowest = water[h1][w1];
                            }
                        }
                    }
                    links[i][j] = result;
                }
            }
            char symbol = 'a';
            for (int i = 0; i < H; i++) {
                for (int j = 0; j < W; j++) {
                    symbol = goDepth(i, j, symbol);
                }
            }
            out.printf("Case #%d:%n", test+1);
            for (int i = 0; i < H; i++) {
                for (int j = 0; j < W; j++) {
                    out.print(charz[i][j]);
                    out.print(' ');
                }
                out.println();
            }


        }
        out.close();
    }

    private static char goDepth(int i, int j, char symbol) {
        if (charz[i][j] != 0) {
            return symbol;
        }
        charz[i][j] = symbol;
        for (Dir d : Dir.values()) {
            if (d != Dir.SINK) {
                if (connects(i, j, d)) {
                    goDepth(i + d.dh, j + d.dw, symbol);
                }
            }
        }
        return (char) (symbol + 1);
    }

    public static boolean connects(int h, int w, Dir d) {
        if (links[h][w] == d) {
            return true;
        }
        int h1 = h + d.dh;
        int w1 = w + d.dw;
        if (0 <= h1 && h1 < H && 0 <= w1 && w1 < W) {
            Dir other = links[h1][w1];
            return (h == h1 + other.dh) && (w == w1 + other.dw);
        }
        return false;

    }
}