package gcj;

import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class ProblemC {
    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        Scanner scanner = new Scanner(new FileReader("fly.in"));
        PrintWriter out = new PrintWriter("fly.out");

        int N = scanner.nextInt();

        for (int i = 0; i < N; i++) {

            double flyRad = scanner.nextDouble();
            double bigRadius = scanner.nextDouble();
            double thickness = scanner.nextDouble();
            double stringRad = scanner.nextDouble();
            double gap = scanner.nextDouble();

            double total = Math.PI * bigRadius * bigRadius / 2 / 2;

            double smallRad = bigRadius - thickness - flyRad;
            double correctedThickness = stringRad + flyRad;
            double correctedGap = gap - 2 * flyRad;
            double area;
            double size = gap + stringRad * 2;
            double radSquared = smallRad * smallRad;

            double x = 0;
            int countTotal = 0;
            if (correctedGap <= 0) {
                area = 0;
            } else {
                area = 0;
                while (x <= smallRad) {
                    int count = (int) Math.floor(Math.sqrt(radSquared - x * x) / size);
                    double x2 = x + size;
                    if (x2 <= smallRad) {
                        int count2 = (int) Math.floor(Math.sqrt(radSquared - x2 * x2) / size);
                        area += count2 * correctedGap * correctedGap;
                        countTotal += count2;
                        for (int j = count2; j <= count; j++) {
                            double v = calculate(x + correctedThickness, j * size + correctedThickness, correctedGap, smallRad);
                            assert !Double.isNaN(v);
                            area = area + v;
                        }
                    } else {
                        for (int j = 0; j <= count; j++) {
                            double v = calculate(x + correctedThickness, j * size + correctedThickness, correctedGap, smallRad);
                            assert !Double.isNaN(v);
                            area = area + v;
                        }
                    }
                    x = x2;
                }
            }
            out.printf("Case #%d: %1.7f%n", i + 1, 1 - area / total);
        }

        out.close();
    }


    private static double calculate(double x, double y, double size, double rad) {
        double rad2 = rad * rad;
        double ysq = y * y;
        double ysizesq = (y + size) * (y + size);
        double xsizesq = (x + size) * (x + size);
        double xsq = x * x;
        if (xsq + ysq >= rad2) {
            return 0;
        }
        if (xsizesq + ysizesq <= rad2) {
            return size * size;
        }
        boolean crossBottom = (xsizesq + ysq >= rad2);
        boolean  crossLeft = (ysizesq + xsq >= rad2);

        if (crossLeft) {
            double y1 = Math.sqrt(rad2 - xsq) - y;
            if (crossBottom) {
                double x1 = Math.sqrt(rad2 - ysq) - x;
                return (x1 * y1) / 2 + arc(rad, Math.sqrt(x1 * x1 + y1 * y1));
            } else {
                double y2 = Math.sqrt(rad2 - xsizesq) - y;
                return Math.max(y1, y2) * size - Math.abs(y1 - y2) * size / 2 + arc(rad, Math.sqrt((y1-y2)*(y1-y2) + size * size));
            }
        } else { // top
            double x1 = Math.sqrt(rad2 - ysizesq) - x;
            if (crossBottom) {
                double x2 = Math.sqrt(rad2 - ysq) - x;
                return Math.max(x1, x2) * size - Math.abs(x1 - x2) * size / 2 + arc(rad, Math.sqrt((x1-x2)*(x1-x2) + size * size));
            } else { // right
                double y1 = Math.sqrt(rad2 - xsizesq) - y;
                return size * size - (size-x1) * (size-y1) / 2 + arc(rad, Math.sqrt((size-y1) * (size-y1) + (size-x1) * (size-x1)));
            }
        }
    }

    private static double arc(double radius, double len) {
        double angle = Math.asin(len / radius / 2) * 2;
        return radius * radius * (angle - Math.sin(angle)) / 2;
    }
}
