package gcj;

import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.Scanner;

public class ProblemA {
    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        Scanner scanner = new Scanner(new FileReader("save.in"));
        PrintWriter out = new PrintWriter("save.out");

        int N = scanner.nextInt();

        for (int test = 0; test < N; test++) {
            Map<String, Integer> revEngines = new HashMap<String, Integer>();
            int ans = 0;
            int S = scanner.nextInt();
            for (int i = 0; i < S; i++) {
                String s = scanner.nextLine();
                while (s.trim().length() == 0) {
                    s = scanner.nextLine();
                }
                revEngines.put(s, i);
            }
            int Q = scanner.nextInt();
            int[] queries = new int[Q];
            for (int i = 0; i < Q; i++) {
                String s = scanner.nextLine();
                while (s.trim().length() == 0) {
                    s = scanner.nextLine();
                }
                queries[i] = revEngines.get(s);
            }
            if (0 == Q) {
                ans = 0;
            } else {
                int[][] qm = new int[Q][S];
                for (int i = 1; i < Q; i++) {
                    for (int j = 0; j < S; j++) {
                        if (queries[i - 1] == j) {
                            qm[i][j] = i;
                        } else {
                            qm[i][j] = qm[i - 1][j];
                        }
                    }
                }
                if (Q > 0) {
                    qm[queries[0]][0] = -1;
                }
                int[][] best = new int[Q][S];
                for (int i = 1; i < Q; i++) {
                    for (int j = 0; j < S; j++) {
                        best[i][j] = -1;
                    }
                }
                ans = Integer.MAX_VALUE;
                for (int i = 0; i < S; i++) {
                    if (i != queries[Q - 1]) {
                        ans = Math.min(ans, findBest(best, Q - 1, i, qm, S));
                    }
                }
            }
            out.printf("Case #%d: %d%n", test + 1, ans);

        }
        out.close();
    }

    private static int findBest(int[][] best, int q, int s, int[][] qm, int S) {
        if (best[q][s] == -1) {
            int ans = Integer.MAX_VALUE;
            if (qm[q][s] == 0) {
                ans = 0;
            } else if (qm[q][s] == -1) {
                ans = 1;
            } else {
                int qq = qm[q][s];
                for (int i = 0; i < S; i++) {
                    if (i != s) {
                        ans = Math.min(ans, findBest(best, qq, i, qm, S) + 1);
                    }
                }
            }
            best[q][s] = ans;
        }
        return best[q][s];
    }

    private static void dump(int[][] a) {
        for (int i = 0; i < a.length; i++) {
            for (int j = 0; j < a[i].length; j++) {
                System.out.printf("%4d ", a[i][j]);

            }
            System.out.println("");
        }
    }
}