package y2009.round2.D;

import java.io.*;
import java.util.Scanner;
import java.util.HashSet;
import java.util.ArrayList;

public class ProblemD implements Runnable {
    public static final String FILE_PREFIX = "D";
    private int N;
    private double ans;
    private int[] R;
    private int[] Y;
    private int[] X;


    public void run() {

        try {
            Scanner in = new Scanner(new BufferedReader(new FileReader(getInputFile())));
            PrintWriter out = new PrintWriter("output-"  + FILE_PREFIX + ".txt");
            int COUNT = in.nextInt();

            for (int pass = 0; pass < COUNT; pass ++) {
                N = in.nextInt();
                X = new int[N];
                Y = new int[N];
                R = new int[N];
                for (int i = 0; i < N; i++) {
                    X[i] = in.nextInt();
                    Y[i] = in.nextInt();
                    R[i] = in.nextInt();
                }
                ans = Double.MAX_VALUE;
                rec(0, new HashSet<Integer>());

                out.printf("Case #%d: ", pass + 1);
                out.printf("%.6f", ans / 2);
                out.println();
            }

            out.close();
            in.close();
        } catch (Throwable e) {
            e.printStackTrace();
        }
    }

    private void rec(int dp, HashSet<Integer> integers) {
        if (dp == N) {
            double r1 = calcrad(new ArrayList<Integer>(integers));

            ArrayList<Integer> dop = new ArrayList<Integer>();
            for (int i = 0; i < N; i++) {
                if (!integers.contains(i)) {
                    dop.add(i);
                }
            }
            double r2 = calcrad(dop);
            ans = Math.min(ans, Math.max(r1, r2));
        } else {
            rec(dp + 1, integers);
            integers.add(dp);
            rec(dp + 1, integers);
            integers.remove(dp);
        }
    }

    private double calcrad(ArrayList<Integer> integers) {
        if (integers.size() == 0) {
            return 0;
        }
        if (integers.size() == 1) {
            return R[integers.get(0)];
        }
        if (integers.size() == 2) {
            Integer i0 = integers.get(0);
            Integer i1 = integers.get(1);
            return R[i0] +  R[i1] +
                    dist(X[i0], Y[i0],X[i1], Y[i1]);
        }
        //3
        return Double.MAX_VALUE;
    }

    private double dist(int x1, int y1, int x2, int y2) {
        return Math.sqrt((x1-x2) *(x1-x2) +  (y1-y2) *(y1-y2));
    }

    public static void main(String[] args) {
        new Thread(new ProblemD()).start();
    }

    public File getInputFile() {
        File result = null;
        File temp = new File("input" + FILE_PREFIX + ".txt");
        if (temp.exists())  {
            result = temp;
        }
        int index = 0;
        temp = new File(FILE_PREFIX + "-small-attempt" +index +  ".in");
        while (temp.exists())  {
            result = temp;
            index++;
            temp = new File(FILE_PREFIX + "-small-attempt" +index +  ".in");
        }
        temp = new File(FILE_PREFIX + "-large.in");
        if (temp.exists())  {
            result = temp;
        }
        System.out.println("Using " + result);
        return result;
    }
}