package year2009.qualify.c;

import java.io.PrintWriter;
import java.io.FileReader;
import java.io.IOException;
import java.util.*;

/**
 * @author kouznetsov
 *         Created on 03.09.2009
 */
public class ProblemC {
    private static final long MODULO = 10000;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        Scanner scanner = new Scanner(new FileReader("welcome.in"));
        PrintWriter out = new PrintWriter("welcome.out");
        int N = scanner.nextInt();
        String line = scanner.nextLine().trim();
        String pattern = "welcome to code jam";
        for (int test = 0; test < N; test++) {
            while (line.length() == 0) {
                line = scanner.nextLine().trim();
            }
            long[][] variants = new long[line.length()][pattern.length()];
            for (int i = 0; i < line.length(); i++) {
                for (int j = 0; j < pattern.length(); j++) {
                    if (line.charAt(i) == pattern.charAt(j)) {
                        if (j == 0) {
                            variants[i][j] = 1;
                        } else {
                            for (int k = 0; k < i; k++) {
                                variants[i][j] = (variants[i][j] + variants[k][j - 1]) % MODULO;
                            }
                        }
                    }
                }

            }


            long result = 0;
            for (int i = 0; i < line.length(); i++) {
                result = (result +  variants[i][pattern.length() - 1]) % MODULO;
            }
            out.printf("Case #%d: %04d%n", test + 1, result);
            line = "";
        }


        out.close();
    }

    private static boolean matches(String word, ArrayList<Set<Character>> patterns) {
        for (int i = 0; i < word.length(); i++) {
            if (!patterns.get(i).contains(word.charAt(i))) {
                return false;
            }
        }
        return true;
    }
}