package year2009.qualify.a;

import java.io.PrintWriter;
import java.io.FileReader;
import java.io.IOException;
import java.util.*;

/**
 * @author kouznetsov
 *         Created on 03.09.2009
 */
public class ProblemA {
    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        Scanner scanner = new Scanner(new FileReader("alien.in"));
        PrintWriter out = new PrintWriter("alien.out");
        int L = scanner.nextInt();
        int D = scanner.nextInt();
        int N = scanner.nextInt();
        ArrayList<String> dictionary = new ArrayList<String>();
        while (dictionary.size() < D) {
            String s = scanner.nextLine().trim();
            if (s.length() > 0) {
                dictionary.add(s);
            }
        }
        for (int i = 0; i < N; i++) {
            String pattern = scanner.nextLine().trim();
            ArrayList<Set<Character>> patterns = new ArrayList<Set<Character>>();
            int index = 0;
            int pos = 0;
            //Build pattern
            while (index < L) {
                HashSet<Character> set = new HashSet<Character>();
                index++;
                patterns.add(set);
                char symbol = pattern.charAt(pos);
                pos++;
                if (symbol != '(') {
                    set.add(symbol);
                } else {
                    symbol = pattern.charAt(pos);
                    pos++;
                    while (symbol != ')') {
                        set.add(symbol);
                        symbol = pattern.charAt(pos);
                        pos++;
                    }
                }
            }
            int count = 0;
            for (String word : dictionary) {
                if (matches(word, patterns)) {
                    count++;
                }
            }
            out.printf("Case #%d: %d%n", i+1, count);
        }


        out.close();
    }

    private static boolean matches(String word, ArrayList<Set<Character>> patterns) {
        for (int i = 0; i < word.length(); i++) {
            if (!patterns.get(i).contains(word.charAt(i))) {
                return false;
            }
        }
        return true;
    }
}
