package gcj;

import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;

public class ProblemB {
    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        Scanner scanner = new Scanner(new FileReader("train.in"));
        PrintWriter out = new PrintWriter("train.out");
        int N = scanner.nextInt();

        for (int test = 0; test < N; test++) {
            int T = scanner.nextInt();
            int NA = scanner.nextInt();
            int NB = scanner.nextInt();
            ArrayList<Train> trains = new ArrayList<Train>((NA+NB)*2);
            for (int i = 0; i < NA; i++) {
                String s = scanner.nextLine().trim();
                while (s.length() == 0) {
                    s = scanner.nextLine().trim();
                }
                trains.add(createTrain(s.substring(0,5), 0, -1, 0));
                s = s.substring(6).trim();
                trains.add(createTrain(s.substring(0,5), 1, +1, T));
            }
            for (int i = 0; i < NB; i++) {
                String s = scanner.nextLine().trim();
                while (s.length() == 0) {
                    s = scanner.nextLine().trim();
                }
                trains.add(createTrain(s.substring(0,5), 1, -1, 0));
                s = s.substring(6).trim();
                trains.add(createTrain(s.substring(0,5), 0, +1, T));
            }
            Collections.sort(trains, new TrainComparator());
            int[] pool = new int[2];
            int[] start = new int[2];
            for (Train t : trains) {
                pool[t.station] += t.dir;
                if (pool[t.station] < 0) {
                    pool[t.station] = 0;
                    start[t.station]++;
                }
            }
            out.printf("Case #%d: %d %d%n", test+1, start[0], start[1]);
        }
        out.close();
    }

    private static Train createTrain(String s, int station, int dir, int timeShift) {
        int time = 0;
        time += Integer.parseInt(s.substring(0,2)) * 60;
        time += Integer.parseInt(s.substring(3,5));
        return new Train(time + timeShift, dir, station);  //To change body of created methods use File | Settings | File Templates.
    }

    private static class Train {
        int time; //minutes since midnight
        int station; // 0 for A, 1 for B
        int dir; // -1 for departure; +1 for arrival

        private Train(int time, int dir, int station) {
            this.dir = dir;
            this.station = station;
            this.time = time;
        }

        @Override
        public String toString() {
            return String.format("At %02d:%02d on %d dir %d", time / 60, time % 60, station, dir);
        }
    }

    private static class TrainComparator implements Comparator<Train> {
        public int compare(Train o1, Train o2) {
            int r = o1.time - o2.time;
            if (r != 0) {
                return r;
            }
            return o2.dir - o1.dir; //Arrivals first
        }
    }
}