import java.io.*;
import java.util.*;


public class Solution {

	public static BufferedReader cin = new BufferedReader(new InputStreamReader(System.in));
	public static StringTokenizer tok = null;
	
	public static String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		return tok.nextToken();
	}
	
	public static int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(next());
	}
	
	public static boolean[] used1;
	public static boolean[] used2;
	public static int n;
	public static boolean[][] g;
	
	public static void dfs(int src, int idx) {
		used1[src] = true;
		if (used2[src] && !(idx % 2 == 0)) used2[src] = false;
		
		for (int i = 0; i < n; i++) {
			if (g[src][i] && !used1[i]) {
				dfs(i, idx + 1);
			}
		}
		used1[src] = false;
	}
	
	public static void main(String[] args) throws NumberFormatException, IOException {
		int T = nextInt();
		for (int test = 0; test < T; test++) {
			n = nextInt();
			int k = nextInt();
			g = new boolean[n][n];
			int st[][] = new int[n][k];
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < k; j++)
					st[i][j] = nextInt();
			}
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					boolean ok1 = true;
					for (int t = 0; t < k; t++) {
						if (st[j][t] >= st[i][t]) {
							ok1 = false;
							break;
						}
					}
					boolean ok2 = true;
					for (int t = 0; t < k; t++) {
						if (st[j][t] <= st[i][t]) {
							ok2 = false;
							break;
						}
					}
					g[i][j] = !(ok1 || ok2);
				}
			}
			
			int ans = 0;
			
			used1 = new boolean[n];
			used2 = new boolean[n];
			for (int i = 0; i < n; i++) {
				if (!used2[i]) {
					for (int j = 0; j < n; j++) {
						used1[j] = false;
					}
					LinkedList q = new LinkedList();
					q.add(Integer.valueOf(i));
					int lev = 0;
					LinkedList q1 = new LinkedList();
					q1.add(Integer.valueOf(lev));
					while (q.size() > 0) {
						int nxt = ((Integer)(q.get(0))).intValue();
						q.remove(0);
						int nlev = ((Integer)(q1.get(0))).intValue();
						q1.remove(0);
						used1[nxt] = true;
						used2[nxt] = (nlev % 2 == 0);
						for (int j = 0; j < n; j++) {
							if (g[nxt][j] && !used1[j]) {
								q.add(Integer.valueOf(j));
								q1.add(Integer.valueOf(nlev + 1));
							}
						}
					}
					
					ans++;
					dfs(i, 0);
				}
			}
			
			/*used1 = new boolean[n];
			used2 = new boolean[n];
			for (int i = 0; i < n; i++) {
				if (!used2[i]) {
					for (int j = 0; j < n; j++) {
						used1[j] = false;
					}
					ans++;
					dfs(i, 0);
				}
			}*/
			
			System.out.println("Case #" + (test + 1) + ": " + ans);
		}

	}

}
