import java.io.*;
import java.math.BigInteger;
import java.util.*;


public class Solution {

	public static BufferedReader cin = new BufferedReader(new InputStreamReader(System.in));
	public static StringTokenizer tok = null;
	
	public static String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		return tok.nextToken();
	}
	
	public static int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(next());
	}
	
	public static int[] split(int A) {
		int[] ans = new int[9];
		while (A > 0) {
			if (A % 10 > 0)
				ans[A % 10 - 1]++;
			A /= 10;
		}
		return ans;
	}
	
	public static int[] split(BigInteger A) {
		int[] ans = new int[9];
		while (A.compareTo(BigInteger.ZERO) > 0) {
			if (A.mod(BigInteger.TEN).compareTo(BigInteger.ZERO) > 0)
				ans[A.mod(BigInteger.TEN).intValue() - 1]++;
			A = A.divide(BigInteger.TEN);
		}
		return ans;
	}
	
	public static boolean same(int[] A, int[] B) {
		if (A.length != B.length) return false;
		for (int i = 0; i < A.length; i++)
			if (A[i] != B[i])
				return false;
		return true;
	}
	
	public static int stupid(int n) {
		int[] D = split(n);
		do {
			n++;
		} while (!same(D, split(n)));
		return n;
	}
	
	public static String smart(String n) {
		for (int i = n.length() - 2; i >= 0; i--) {
			char[] right = new char[n.length() - i - 1];
			int minj = -1;
			for (int j = i + 1; j < n.length(); j++) {
				if (n.charAt(j) > n.charAt(i) && (minj == -1 || n.charAt(j) < n.charAt(minj))) { // good
					minj = j;
				}
				right[j - i - 1] = n.charAt(j);
			}
			Arrays.sort(right);
			if (minj > -1) {
				String ans = "";
				for (int j = 0; j < i; j++)
					ans += n.charAt(j);
				ans += n.charAt(minj);
				boolean sk = false;
				for (int j = 0; j < right.length; j++) {
					if (sk || (right[j] != n.charAt(minj))) {
						ans += right[j];
					} else {
						ans += n.charAt(i);
					}
					if (right[j] == n.charAt(minj)) sk = true;
				}
				return ans;
			}
		}
		
		char[] digits = n.toCharArray();
		Arrays.sort(digits);
		int zeroes = 0;
		int i = 0;
		while (digits[i] == '0') {
			i++;
			zeroes++;
		}
		String ans = digits[i] + "0";
		for (int j = 0; j < zeroes; j++)
			ans += "0";
		i++;
		for (int j = i; j < digits.length; j++)
			ans += digits[j];
		return ans;
	}
	
	public static void main(String[] args) throws NumberFormatException, IOException {
		int N = nextInt();
		for (int test = 1; test <= N; test++) {
			String ns = next();
			if (ns.length() < 5) {
				if (stupid(Integer.parseInt(ns)) != Integer.parseInt(smart(ns))) {
					System.out.println("#" + test + ": " + ns + " -> " + stupid(Integer.parseInt(ns)) + ", got " + smart(ns));
				} else
					System.out.println("Case #" + test + ": " + stupid(Integer.parseInt(ns)));
			} else {
				System.out.println("Case #" + test + ": " + smart(ns));
			}
		}

	}

}
