import java.io.*;
import java.util.*;


public class Solution {

	public static BufferedReader cin = new BufferedReader(new InputStreamReader(System.in));
	public static StringTokenizer tok = null;
	
	public static String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		return tok.nextToken();
	}
	
	public static int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(next());
	}
	
	public static class Tree {
		public double weight;
		public boolean hasSubtrees = false;
		public String subFeature;
		public Tree left;
		public Tree right;
		
		public Tree(String s) {
			super();
			int i = 0;
			while (s.charAt(i) != '(') i++;
			i++;
			while (s.charAt(i) == ' ' || s.charAt(i) == '\n') i++;
			String w = "";
			do {
				w += s.charAt(i);
				i++;					
			} while (s.charAt(i) != ' ' && s.charAt(i) != '\n' && s.charAt(i) != ')');
			while (s.charAt(i) == ' ' || s.charAt(i) == '\n') i++;
			weight = Double.parseDouble(w);
			if (s.charAt(i) == ')')
				return;
			
			hasSubtrees = true;
			subFeature = "";
			do {
				subFeature += s.charAt(i);
				i++;
			} while (s.charAt(i) != ' ' && s.charAt(i) != '\n');
			while (s.charAt(i) == ' ' || s.charAt(i) == '\n') i++;
			int level = 0;
			String sub1 = "";
			while (s.charAt(i) != ')' || level > 1) {
				if (s.charAt(i) == '(')
					level++;
				if (s.charAt(i) == ')')
					level--;
				sub1 += s.charAt(i);
				i++;
			}
			sub1 += s.charAt(i);
			i++;
			while (s.charAt(i) == ' ' || s.charAt(i) == '\n') i++;
			left = new Tree(sub1);
			level = 0;
			String sub2 = "";
			while (s.charAt(i) != ')' || level > 1) {
				if (s.charAt(i) == '(')
					level++;
				if (s.charAt(i) == ')')
					level--;
				sub2 += s.charAt(i);
				i++;
			}
			sub2 += s.charAt(i);
			i++;
			while (s.charAt(i) == ' ' || s.charAt(i) == '\n') i++;
			right = new Tree(sub2);
		}
	}
	
	public static void main(String[] args) throws NumberFormatException, IOException {
		int N = nextInt();
		for (int test = 0; test < N; test++) {
			int l = nextInt();
			String struct = "";
			for (int i = 0; i < l; i++) {
				struct += " " + cin.readLine();
			}
			Tree root = new Tree(struct);
			System.out.println("Case #" + (test + 1) + ":");
			int a = nextInt();
			for (int i = 0; i < a; i++) {
				String name = next();
				int cnt = nextInt();
				String[] features = new String[cnt];
				for (int j = 0; j < cnt; j++) {
					features[j] = next();
				}
				Arrays.sort(features);
				double ans = 1.0;
				Tree cur = root;
				while (cur.hasSubtrees) {
					ans *= cur.weight;
					if (Arrays.binarySearch(features, cur.subFeature) > -1)
						cur = cur.left;
					else
						cur = cur.right;
				}
				
				Formatter frm = new Formatter(System.out);
				//System.out.println(ans * cur.weight);
				
				Double[] data = new Double[1];
				data[0] = Double.valueOf(ans * cur.weight);
				frm.format(new Locale("EN-en"), "%.7f\n", data);
			}
		}

	}

}
