import java.util.*;

public class Main {

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();

        for (int t = 1; t <= T; ++t) {
            int n = in.nextInt();
            int[] bff = new int[n];
            for (int i = 0; i < n; ++i) {
                bff[i] = in.nextInt() - 1;
            }
            System.out.println("Case #" + t + ": " + solve(bff));
        }
    }

    private static int solve(int[] bff) {
        int n = bff.length;
        int res = 0;
        for (int mask = 0; mask < (1 << n); ++mask) {
            List<Integer> c = new ArrayList<>();
            for (int i = 0; i < n; ++i) {
                if ((mask & (1 << i)) != 0) {
                    c.add(i);
                }
            }

            Collections.sort(c);
            while ((c = nextPermutation(c)) != null) {
                if (check(c, bff)) {
                    res = Math.max(res, Integer.bitCount(mask));
                }
            }
        }
        return res;
    }

    private static boolean check(List<Integer> c, int[] bff) {
        int m = c.size();
        if (m == 1) return false;
        for (int i = 0; i < c.size(); ++i) {
            if (bff[c.get(i)] != c.get((i - 1 + m) % m) &&
                    bff[c.get(i)] != c.get((i + 1) % m)) return false;
        }
        return true;
    }

    private static List<Integer> nextPermutation(final List<Integer> c) {
        // 1. finds the largest k, that c[k] < c[k+1]
        int first = getFirst(c);
        if ( first == -1 ) return null; // no greater permutation
        // 2. find last index toSwap, that c[k] < c[toSwap]
        int toSwap = c.size() - 1;
        while (c.get(first).compareTo(c.get(toSwap)) >= 0)
            --toSwap;
        // 3. swap elements with indexes first and last
        swap( c, first++, toSwap );
        // 4. reverse sequence from k+1 to n (inclusive)
        toSwap = c.size() - 1;
        while ( first < toSwap )
            swap( c, first++, toSwap-- );
        return c;
    }

    // finds the largest k, that c[k] < c[k+1]
    // if no such k exists (there is not greater permutation), return -1
    private static int getFirst(final List<Integer> c) {
        for ( int i = c.size() - 2; i >= 0; --i )
            if ( c.get(i).compareTo(c.get(i + 1)) < 0)
                return i;
        return -1;
    }

    // swaps two elements (with indexes i and j) in array
    private static void swap(final List<Integer> c, final int i, final int j ) {
        Integer tmp = c.get(i);
        c.set(i, c.get(j));
        c.set(j, tmp);
    }
}
