import java.util.*;

public class Main {

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();

        for (int t = 1; t <= T; ++t) {
            int n = in.nextInt();
            int[][] lines = new int[2 * n - 1][n];
            for (int i = 0; i < 2 * n - 1; ++i) {
                for (int j = 0; j < n; ++j) {
                    lines[i][j] = in.nextInt();
                }
            }
            System.out.print("Case #" + t + ":");
            int[] res = solve(lines, n);
            for (int i = 0; i < n; ++i) {
                System.out.print(" " + res[i]);
            }
            System.out.println();
        }
    }

    private static int[] solve(int[][] lines, int n) {
        for (int mask = 0; mask <= 1 << (2 * n - 1); ++mask) {
            if (Integer.bitCount(mask) != n) continue;

            List<int[]> rows = new ArrayList<>();
            for (int i = 0; i < 2 * n - 1; ++i) {
                if ((mask & (1 << i)) != 0) {
                    rows.add(lines[i]);
                }
            }
            Collections.sort(rows, (a1, a2) -> {
                for (int i = 0; i < n; ++i) {
                    if (a1[i] != a2[i]) return Integer.compare(a1[i], a2[i]);
                }
                return 0;
            });

            int[][] f = new int[n][n];
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    f[i][j] = rows.get(i)[j];
                }
            }

            TreeMap<int[], Integer> cols = new TreeMap<>((a1, a2) -> {
                for (int i = 0; i < n; ++i) {
                    if (a1[i] != a2[i]) return Integer.compare(a1[i], a2[i]);
                }
                return 0;
            });
            for (int i = 0; i < 2 * n - 1; ++i) {
                if ((mask & (1 << i)) == 0) {
                    if (!cols.containsKey(lines[i])) {
                        cols.put(lines[i], 0);
                    }
                    cols.put(lines[i], cols.get(lines[i]) + 1);
                }
            }

            boolean fail = false;
            int[] res = null;
            for (int j = 0; j < n & !fail; ++j) {
                int[] curcol = new int[n];
                for (int i = 0; i < n & !fail; ++i) {
                    if (i > 0 && f[i][j] <= f[i - 1][j]) {
                        fail = true;
                        break;
                    }
                    curcol[i] = f[i][j];
                }
                if (!cols.containsKey(curcol)) {
                    if (res != null) {fail = true; break; }
                    res = curcol;
                } else {
                    cols.put(curcol, cols.get(curcol) - 1);
                    if (cols.get(curcol) == 0) {
                        cols.remove(curcol);
                    }
                }
            }

            if (!fail && cols.size() == 0) {
                return res;
            }
        }
        return new int[0];
    }
}
