package org.underdev.labs.codejam;

import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

/**
 * Created by defer on 4/8/16.
 */
public class ProblemA {
    private Scanner input;
    private PrintWriter output;

    public static void main(String[] args) {
        new ProblemA().run();
    }

    private void run() {
        this.input = new Scanner(System.in);
        this.output = new PrintWriter(System.out);

        int n = this.input.nextInt();
        for (int i = 0; i < n; i++) {
            solve(i);
        }
        this.output.flush();
    }

    private void solve(int testcase) {
        int result = 0;

        int start = input.nextInt();

        if (start == 0) {
            output.printf("Case #%d: INSOMNIA\n", testcase+1);
        } else {
            int cycles = 0;
            Set<Integer> sleepSet = new HashSet<Integer>();
            do {
                cycles++;
                int n = start * cycles;
                while (n > 0) {
                    sleepSet.add(n % 10);
                    n /= 10;
                }
            } while (sleepSet.size() != 10);
            output.printf("Case #%d: %d\n", testcase+1, start*cycles);
        }
    }
}
