package org.underdev.labs.codejam;

import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

/**
 * Created by defer on 4/8/16.
 */
public class ProblemC {
    private static final boolean VERBOSE = false;

    private Scanner input;
    private PrintWriter output;

    public static void main(String[] args) {
        new ProblemC().run();
    }

    private void run() {
        this.input = new Scanner(System.in);
        this.output = new PrintWriter(System.out);

        int n = this.input.nextInt();
        for (int i = 0; i < n; i++) {
            solve(i);
        }
        output.flush();
    }

    private BigInteger getAFactorAnyFactor(BigInteger bi) {
        BigInteger factor = BigInteger.ONE;
        BigInteger n = bi.add(BigInteger.ZERO);
        BigInteger maxTb = BigInteger.valueOf(65536*3);

        for (BigInteger i = BigInteger.valueOf(2); i.compareTo(n.divide(i)) <= 0; i = i.add(BigInteger.ONE)) {
            if (n.mod(i).equals(BigInteger.ZERO)) {
                return i;
            }
            if (i.compareTo(maxTb) > 0) return BigInteger.ONE;
        }
        return factor;
    }

    private void solve(int testcase) {
        int n = input.nextInt();
        int j = input.nextInt();

        int found = 0;
        long range_start = (1L << (n-1)) + 1;
        long range_end = (1L << (n)) - 1;
        output.printf("Case #%d:\n", testcase+1);
        do {
            String number = Long.toBinaryString(range_start);
            if (!number.endsWith("0")) {

                boolean isCandidate = true;
                for (int base = 2; base <= 10 && isCandidate; base++) {
                    BigInteger bi = new BigInteger(number, base);
                    isCandidate &= !bi.isProbablePrime(1);
                }

                if (isCandidate) {
                    boolean timebombed = false;
                    BigInteger[] solutions = new BigInteger[11];
                    for (int base = 2; base <= 10; base++) {
                        BigInteger bi = new BigInteger(number, base);
                        BigInteger aFactorAnyFactor = getAFactorAnyFactor(bi);
                        if (aFactorAnyFactor.equals(BigInteger.ONE)) {
                            timebombed = true;
                        }
                        solutions[base] = aFactorAnyFactor;
                    }

                    if (!timebombed) {
                        found++;
                        output.print(number);


                        for (int base = 2; base <= 10; base++) {
                            output.print(' ');
                            BigInteger aFactorAnyFactor = solutions[base];
                            if (VERBOSE) {
                                BigInteger bi = new BigInteger(number, base);
                                output.printf("Base %d, %s %% %s == %s\n", 2, bi, aFactorAnyFactor, bi.mod(aFactorAnyFactor));
                            }

                            output.print(aFactorAnyFactor.toString());
                        }

                        output.print('\n');
                    }
                }
            }
            range_start++;
        } while (found < j && range_start < range_end);
        output.flush();
        if (found != j) throw new IllegalStateException("Failed terribly");
    }
}
