package com.bkhnjkt.google.gcj2017.round1B.B;

import com.bkhnjkt.util.SolverV2;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.Scanner;

class Solution implements SolverV2 {
    static String inputFile = "B-large.in";
    static String outputFile = "B-large.out";
    int n, r, o, y, g, b, v;

    @Override
    public void read(Scanner read) {
        n = read.nextInt();
        r = read.nextInt();
        o = read.nextInt();
        y = read.nextInt();
        g = read.nextInt();
        b = read.nextInt();
        v = read.nextInt();
    }

    @Override
    public String solve() {
        if(o > 0 || g > 0 || v > 0) {
            return "";
        }

        int[] a = new int[] {r, y, b};
        String[] s = new String[] {"R", "Y", "B"};
        for(int i=0; i<3; i++) {
            for(int j=0; j<2; j++) {
                if(a[j] > a[j + 1]) {
                    int temp = a[j];
                    a[j] = a[j + 1];
                    a[j + 1] = temp;

                    String t = s[j];
                    s[j] = s[j + 1];
                    s[j + 1] = t;
                }
            }
        }
        if(a[0] + a[1] < a[2]) {
            return "IMPOSSIBLE";
        }

        String total = "";
        for(int i=0; i<a[2]; i++) {
            total += s[2];
        }
        for(int i=a[1]-1; i >= 0; i--) {
            total = total.substring(0, i) + s[1] + total.substring(i);
        }
        int len = total.length();
        int left = a[0];
        for(int i=len-1; i>0; i--) {
            if(total.charAt(i) == total.charAt(i-1)) {
                total = total.substring(0, i) + s[0] + total.substring(i);
                left --;
            }
        }
        for(int i=left-1; i>=0; i--) {
            total = total.substring(0, i) + s[0] + total.substring(i);
        }
        return total;
    }
}

class BigSolution extends Solution {

    public String create(String st, int num) {
        String total = "";
        for(int i=0; i<num; i++) {
            total += st;
        }
        return total;
    }
    @Override
    public String solve() {
        if(b < o) {
            return "IMPOSSIBLE";
        }
        if(b == o && o > 0) {
            if(n - b - o > 0) {
                return "IMPOSSIBLE";
            } else {
                return create("BO", o);
            }
        }
        b -= o;

        if(r < g)
            return "IMPOSSIBLE";
        if(r == g && g > 0) {
            if(n - r - g > 0) {
                return "IMPOSSIBLE";
            } else {
                return create("RG", g);
            }
        }
        r -= g;

        if(y < v)
            return "IMPOSSIBLE";
        if(y == v && v > 0) {
            if(n - y - v > 0) {
                return "IMPOSSIBLE";
            } else {
                return create("YV", v);
            }
        }
        y -= v;

        Solution solution = new Solution();
        solution.b = b;
        solution.r = r;
        solution.y = y;
        solution.n = b + r + y;
        String result = solution.solve();
        if("IMPOSSIBLE".equals(result))
            return result;

        String total = "";
        for(int i=0; i<result.length(); i++) {
            if(result.charAt(i) == 'B') {
                if(b > 0) {
                    total += "B";
                    b --;
                } else {
                    total += create("BO", o) + "B";
                }
            }
            if(result.charAt(i) == 'R') {
                if(r > 0) {
                    total += "R";
                    r --;
                } else {
                    total += create("RG", g) + "R";
                }
            }
            if(result.charAt(i) == 'Y') {
                if(y > 0) {
                    total += "Y";
                    y --;
                } else {
                    total += create("YV", v) + "Y";
                }
            }
        }
        return total;
    }

}

public class StableNeighbors {

    public static void main(String[] args) throws IOException {
        Scanner read = new Scanner(new File(Solution.inputFile));
        Writer write = new FileWriter(new File(Solution.outputFile));

        int tests = read.nextInt();
        read.nextLine();
        String result = "";
        for(int test=1; test<=tests; test++) {
            // Read input data
            BigSolution solution = new BigSolution();
            solution.read(read);

            // Solve the problem
            try {
                result = solution.solve();
            } catch(Exception ignored) {
            }

            // Write to output
            write.write(String.format("Case #%d: %s\n", test, result));
            System.out.printf(String.format("Case #%d: %s\n", test, result));
        }
        write.close();
    }
}
