package com.bkhnjkt.google.gcj2017.round1C.C;

import com.bkhnjkt.util.SolverV2;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.math.BigDecimal;
import java.util.Arrays;
import java.util.Scanner;

import static java.math.BigDecimal.valueOf;

class Solution implements SolverV2 {
    static String inputFile = "C-small-2-attempt2.in";
    static String outputFile = "C-small-2-attempt2.out";
    int n, k;
    double u;
    double[] p;

    @Override
    public void read(Scanner read) {
        n = read.nextInt();
        k = read.nextInt();
        u = read.nextDouble();
        p = new double[n + 1];
        for (int i = 0; i < n; i++) {
            p[i] = read.nextDouble();
        }
        p[n] = 1;
    }

    @Override
    public String solve() {
        Arrays.sort(p);
        double max = 1;
        for (int i = 0; i < n; i++) {
            max *= p[i];
        }

        double[] total = new double[n + 1];
        total[n] = p[n];
        for (int i = n - 1; i >= 0; i--) {
            total[i] = p[i] + total[i + 1];
        }

        for (int i = 0; i < n; i++) {
            double sum = total[0] - total[i];
            double remain = i * p[i] - sum;
            if (u >= remain) {
                double rate = Math.min(1, p[i] + (u - remain) / (i + 1));
                double cal = 1;
                for (int j = 0; j < n; j++) {
                    cal *= j <= i ? rate : p[j];
                }
                max = Math.max(max, cal);
            } else {
                // do nothing
            }
        }
        return String.format("%.9f", max);
    }
}

class BigSolution extends Solution {

    public String solve() {
        Arrays.sort(p);
        double max = 1;
        for (int i = 0; i < n; i++) {
            max *= p[i];
        }

        double[] total = new double[n + 1];
        total[n] = p[n];
        for (int i = n - 1; i >= 0; i--) {
            total[i] = p[i] + total[i + 1];
        }

        for (int i = 0; i < n; i++) {
            double sum = total[0] - total[i];
            double remain = i * p[i] - sum;
            if (u >= remain) {
                double rate = Math.min(1, p[i] + (u - remain) / (i + 1));
                double[] temp = new double[n];
                for (int j = 0; j < n; j++) {
                    temp[j] = j <= i ? rate : p[j];
                }
                double cal = calculate(temp);
                max = Math.max(max, cal);
            } else {
                // do nothing
            }
        }

        if(k < n) {
            double[] temp = new double[n];
            double remain = u;
            for(int i=n-1; i>=0; i--) {
                double add = Math.min(1 - p[i], remain);
                temp[i] = p[i] + add;
                remain -= add;
            }
            double cal = calculate(temp);
            max = Math.max(max, cal);
        }

        String solution = String.format("%.9f", max);
        if (k == n) {
            String smallSolution = super.solve();
            if (!smallSolution.equals(solution)) {
                System.out.println("Loi roi!!!");
            }

        }
        return solution;
    }

    private double calculate(double[] temp) {
        if (k == n) {
            double val = 1;
            for (int i = 0; i < n; i++) {
                val *= temp[i];
            }
            return val;
        } else {
            BigDecimal[][] q = new BigDecimal[n + 1][n + 1];
            int precision = 1000000;
            q[0][0] = BigDecimal.ONE.setScale(precision, BigDecimal.ROUND_HALF_UP);
            for (int i = 0; i < n; i++) {
                for (int j = 0; j <= i; j++) {
                    q[i + 1][j] = q[i+1][j].add(q[i][j].multiply(valueOf(1 - temp[i]))).setScale(precision, BigDecimal.ROUND_HALF_UP);
                    q[i + 1][j + 1] = q[i+1][j+1].add(q[i][j].multiply(valueOf(temp[i]))).setScale(precision, BigDecimal.ROUND_HALF_UP);
                }
            }

            BigDecimal cal = BigDecimal.ZERO.setScale(precision, BigDecimal.ROUND_HALF_UP);
            for (int j = k; j <= n; j++) {
                cal = cal.add(q[n][j]).setScale(precision, BigDecimal.ROUND_HALF_UP);
            }

            return cal.doubleValue();
        }
    }
}

public class CoreTraining {

    public static void main(String[] args) throws IOException {
        Scanner read = new Scanner(new File(Solution.inputFile));
        Writer write = new FileWriter(new File(Solution.outputFile));

        int tests = read.nextInt();
        read.nextLine();
        String result = "";
        for (int test = 1; test <= tests; test++) {
            // Read input data
            BigSolution solution = new BigSolution();
            solution.read(read);

            // Solve the problem
            try {
                result = solution.solve();
            } catch (Exception ignored) {
            }

            // Write to output
            write.write(String.format("Case #%d: %s\n", test, result));
            System.out.printf(String.format("Case #%d: %s\n", test, result));
        }
        write.close();
    }
}
