package com.bkhnjkt.gcj2017.round1.A;

import com.bkhnjkt.util.Solver;

import java.io.*;
import java.util.Arrays;
import java.util.Scanner;

public class AlphabetCake implements Solver {

    private String[] a;
    private int r;
    private int c;

    private Solver init(String[] a, int r, int c) {
        this.a = a;
        this.r = r;
        this.c = c;

        return this;
    }


    @Override
    public String solve() {
        int begin = findBegin();
        for(int i=begin; i<r; i++) {
            if(emptyLine(i)) {
                a[i] = a[i-1];
            } else {
                char[] chars = a[i].toCharArray();

                char prev = '?';
                int first = c;
                for(int j=0; j<c; j++) {
                    if(chars[j] != '?') {
                        prev = chars[j];
                        first = Math.min(first, j);
                    } else {
                        chars[j] = prev;
                    }
                }
                for(int j=0; j<first; j++) {
                    chars[j] = chars[first];
                }

                a[i] = convert(chars);
            }
        }

        for(int i=0; i<begin; i++) {
            a[i] = a[begin];
        }

        StringBuilder result = new StringBuilder();
        for(int i=0; i<r; i++) {
            result.append("\n").append(a[i]);
        }
        return result.toString();
    }

    private String convert(char[] chars) {
        StringBuilder result = new StringBuilder();
        for(int j=0; j<c; j++) {
            result.append(chars[j]);
        }
        return result.toString();
    }

    private boolean emptyLine(int i) {
        char[] chars = a[i].toCharArray();
        for(int j=0; j<c; j++) {
            if(chars[j] != '?') {
                return false;
            }
        }
        return true;
    }

    private int findBegin() {
        for(int i=0; i<r; i++) {
            if(!emptyLine(i)) {
                return i;
            }
        }
        return 0;
    }

    public static void main(String[] args) throws IOException {
        String inputFile = "A-small-attempt0.in";
        String outputFile = "A-small-attemp0.out";
        Scanner read = new Scanner(new File(inputFile));
        Writer write = new FileWriter(new File(outputFile));

        int tests = Integer.parseInt(read.nextLine());
        String result = "";
        for(int test=1; test<=tests; test++) {
            int r = read.nextInt();
            int c = read.nextInt();
            read.nextLine();
            String[] a = new String[r];
            for(int i=0; i<r; i++) {
                a[i] = read.nextLine();
            }
            try {
                result = new AlphabetCake().init(a, r, c).solve();
            } catch(Exception ignored) {
            }
            write.write(String.format("Case #%d: %s\n", test, result));
            System.out.printf(String.format("Case #%d: %s\n", test, result));
        }
        write.close();
    }
}
