package com.bkhnjkt.gcj2017.qualification.A;

import com.bkhnjkt.util.Solver;

import java.io.*;
import java.util.Scanner;

public class OversidedPancakeFlipper implements Solver {

    private String a;
    private int k;

    private Solver init(int test, String a, int k) {
        this.a = a;
        this.k = k;

        return this;
    }

    @Override
    public String solve() {
        int n = a.length();

        int[] b = new int[n];
        for (int i = 0; i < n; i++) {
            char c = a.charAt(i);
            b[i] = c == '-' ? 0 : 1;
        }

        int total = 0;
        for (int i = 0; i < n; i++) {
            if (b[i] == 0) {
                if (i + k <= n) {
                    total++;
                    for (int j = i; j < i + k; j++) {
                        b[j] = b[j] ^ 1;
                    }
                } else {
                    total = -1;
                }
            }
        }

        return total == -1 ? "IMPOSSIBLE" : ("" + total);
    }

    public static void main(String[] args) throws IOException {
        String inputFile = "A-large.in";
        String outputFile = "A-large.out";
        Scanner read = new Scanner(new File(inputFile));
        Writer write = new FileWriter(new File(outputFile));

        int tests = Integer.parseInt(read.nextLine());
        String result = "";
        for(int test=1; test<=tests; test++) {
            String[] inputs = read.nextLine().split(" ");
            String a = inputs[0];
            int k = Integer.parseInt(inputs[1]);
            try {
                result = new OversidedPancakeFlipper().init(test, a, k).solve();
            } catch(Exception ignored) {
            }
            write.write(String.format("Case #%d: %s\n", test, result));
        }
        write.close();
    }
}
