package com.bkhnjkt.gcj2017.qualification.B;

import com.bkhnjkt.util.Solver;

import java.io.*;
import java.util.Scanner;

public class TidyNumbers implements Solver {

    private long n;

    private Solver init(long n) {
        this.n = n;

        return this;
    }

    private boolean tidy(long n) {
        long prev = 9;
        while(n > 0) {
            long d = n % 10;
            if(d > prev) {
                return false;
            }
            prev = d;
            n /= 10;
        }
        return true;
    }

    @Override
    public String solve() {
        long p10 = 1;
        while(!tidy(n)) {
            long d = (n / p10) % 10;
            n -= (d + 1) * p10;
            p10 *= 10;
        }
        return "" + n;
    }

    public static void main(String[] args) throws IOException {
        String inputFile = "B-small-attempt0.in";
        String outputFile = "B-small-attempt0.out";
        Scanner read = new Scanner(new File(inputFile));
        Writer write = new FileWriter(new File(outputFile));

        int tests = read.nextInt();
        String result = "";
        for(int test=1; test<=tests; test++) {
            long n = read.nextLong();
            try {
                result = new TidyNumbers().init(n).solve();
            } catch(Exception ignored) {
            }
            write.write(String.format("Case #%d: %s\n", test, result));
            System.out.printf(String.format("Case #%d: %s\n", test, result));
        }
        write.close();
    }
}
