package com.bkhnjkt.gcj2017.qualification.C;

import com.bkhnjkt.util.Solver;

import java.io.*;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class BathroomStalls implements Solver {

    private long n;
    private long k;
    private Map<Long, Long> map;

    private Solver init(long n, long k) {
        this.n = n;
        this.k = k;
        map = new HashMap<Long, Long>();

        return this;
    }

    long findMax() {
        long max = 0;
        for(long key: map.keySet()) {
            max = Math.max(max, key);
        }
        return max;
    }

    @Override
    public String solve() {
        map.put(n, 1L);
        while(true) {
            long max = findMax();
            long steps = map.get(max);
            long left = (max-1) / 2;
            long right = (max-1) - left;

            map.remove(max);
            map.put(left, steps + map.getOrDefault(left, 0L));
            map.put(right, steps + map.getOrDefault(right, 0L));
            k -= steps;

            if(k <= 0) {
                return Math.max(left, right) + " " + Math.min(left, right);
            }
        }
    }

    public static void main(String[] args) throws IOException {
        String inputFile = "C-large.in";
        String outputFile = "C-large.out";
        Scanner read = new Scanner(new File(inputFile));
        Writer write = new FileWriter(new File(outputFile));

        int tests = read.nextInt();
        String result = "";
        for(int test=1; test<=tests; test++) {
            // Read input data
            long n = read.nextLong();
            long k = read.nextLong();

            // Solve the problem
            try {
                result = new BathroomStalls()
                        .init(n, k)
                        .solve();
            } catch(Exception ignored) {
            }

            // Write to output
            write.write(String.format("Case #%d: %s\n", test, result));
            System.out.printf(String.format("Case #%d: %s\n", test, result));
        }
        write.close();
    }
}
