package com.bkhnjkt.google.gcj2017.round1C.C;

import com.bkhnjkt.util.SolverV2;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.Arrays;
import java.util.Scanner;

class Solution implements SolverV2 {
    static String inputFile = "C-small-1-attempt0.in";
    static String outputFile = "C-small-1-attempt0.out";
    int n, k;
    double u;
    double[] p;

    @Override
    public void read(Scanner read) {
        n = read.nextInt();
        k = read.nextInt();
        u = read.nextDouble();
        p = new double[n + 1];
        for(int i=0; i<n; i++) {
            p[i] = read.nextDouble();
        }
        p[n] = 1;
    }

    @Override
    public String solve() {
        Arrays.sort(p);
        double max = 1;
        for(int i=0; i<n; i++) {
            max *= p[i];
        }

        double[] total = new double[n+1];
        total[n] = p[n];
        for(int i=n-1; i>=0; i--) {
            total[i] = p[i] + total[i+1];
        }

        for(int i=0; i<n; i++) {
            double sum = total[0] - total[i];
            double remain = i * p[i] - sum;
            if(u >= remain) {
                double rate = Math.min(1, p[i] + (u - remain) / (i+1));
                double cal = 1;
                for(int j=0; j<n; j++) {
                    cal *= j <= i ? rate : p[j];
                }
                max = Math.max(max, cal);
            } else {
                // do nothing
            }
        }
        return String.format("%.9f", max);
    }
}

public class CoreTraining {

    public static void main(String[] args) throws IOException {
        Scanner read = new Scanner(new File(Solution.inputFile));
        Writer write = new FileWriter(new File(Solution.outputFile));

        int tests = read.nextInt();
        read.nextLine();
        String result = "";
        for(int test=1; test<=tests; test++) {
            // Read input data
            Solution solution = new Solution();
            solution.read(read);

            // Solve the problem
            try {
                result = solution.solve();
            } catch(Exception ignored) {
            }

            // Write to output
            write.write(String.format("Case #%d: %s\n", test, result));
            System.out.printf(String.format("Case #%d: %s\n", test, result));
        }
        write.close();
    }
}
