package com.bkhnjkt.google.gcj2017.round1C.A;

import com.bkhnjkt.util.SolverV2;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.Arrays;
import java.util.Scanner;

class Pancake implements Comparable<Pancake> {
    long r, h;

    public Pancake(long r, long h) {
        this.r = r;
        this.h = h;
    }

    @Override
    public int compareTo(Pancake o) {
        // sort biggest first
        long val = o.h * o.r - h * r;
        if(val > 0) {
            return 1;
        } else if(val == 0) {
            return 0;
        } else {
            return -1;
        }
    }
}

class Solution implements SolverV2 {
    static String inputFile = "A-small-attempt2.in";
    static String outputFile = "iA-small-attempt2.out";
    int n, k;
    Pancake[] a;
    double pi = Math.PI;
    @Override

    public void read(Scanner read) {
        n = read.nextInt();
        k = read.nextInt();
        a = new Pancake[n];
        for(int i=0; i<n; i++) {
            a[i] = new Pancake(read.nextLong(), read.nextLong());
        }
    }

    @Override
    public String solve() {
        double max = 0;
        Arrays.sort(a);
        for(int i=0; i<n; i++) {
            // if choose i as a biggest pancake
            int count = k - 1;
            double val = pi * a[i].r * a[i].r + 2 * pi * a[i].h * a[i].r;
            for(int j=0; j<n; j++) {
                if(count > 0 && i != j && a[j].r <= a[i].r) {
                    // pick j
                    count --;
                    val += 2 * pi * a[j].h * a[j].r;
                }
            }
            max = Math.max(max, val);
        }
        return String.format("%.9f", max);
    }
}

public class AmpleSyrup {

    public static void main(String[] args) throws IOException {
        Scanner read = new Scanner(new File(Solution.inputFile));
        Writer write = new FileWriter(new File(Solution.outputFile));

        int tests = read.nextInt();
        read.nextLine();
        String result = "";
        for(int test=1; test<=tests; test++) {
            // Read input data
            Solution solution = new Solution();
            solution.read(read);

            // Solve the problem
            try {
                result = solution.solve();
            } catch(Exception ignored) {
            }

            // Write to output
            write.write(String.format("Case #%d: %s\n", test, result));
            System.out.printf(String.format("Case #%d: %s\n", test, result));
        }
        write.close();
    }
}
