package CUR;

/**
 * Created by Derek on 4/8/16.
 */
import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "A-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("a.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        Scanner in = new Scanner(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskA solver = new TaskA();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskA {
        private int getAnswer(int N) {
            int[] arr = new int[10];

            for (int i = 1; i <= 100; i++) {
                parseDigit(N * i, arr);
                if (seeAll(arr)) {
                    return N * i;
                }

            }

            return -1;
        }

        public void parseDigit(int N, int[] arr) {
            while (N != 0) {
                arr[N % 10]++;
                N /= 10;
            }
        }

        private boolean seeAll(int[] arr) {
            for (int i = 0; i <= 9; i++) {
                if (arr[i] == 0) {
                    return false;
                }
            }
            return true;
        }

        public void solve(int testNumber, Scanner in, PrintWriter out) {


            int N = in.nextInt();
            if (getAnswer(N) == -1) {
                out.println("Case #" + testNumber + ": " + "INSOMNIA");
            } else {
                out.println("Case #" + testNumber + ": " + getAnswer(N));
            }

        }

    }
}

