import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

/**
 * Created by jml90 on 4/8/2017.
 */
public class FashionShow {
    Scanner sc       = new Scanner(getClass().getResourceAsStream(IN));
    static final String FILENAME = "D-small";
    static final String IN       = FILENAME + ".in";
    static final String OUT      = FILENAME + ".out";
    PrintStream out      = System.out;
    private static final char[] SET = {'.', '+', 'x', 'o'};

    private void solve(int [][]boardAdd, int [][]boardX, int[][] input) {
        putX(boardX);
        putAdd(boardAdd);
        int n = boardAdd.length;
        int [][]newBoard = new int[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                newBoard[i][j] = boardAdd[i][j] + boardX[i][j];
            }
        }
        int score = 0;
        int count = 0;
        for (int i = 1; i < n; i++) {
            for (int j = 1; j < n; j++) {
                score+= (newBoard[i][j] >= 2) ? newBoard[i][j] - 1 : newBoard[i][j];
                if (newBoard[i][j] != input[i][j]) {
                   count++;
               }
            }
        }
        out.println(score + " " + count);
        for (int i = 1; i < n; i++) {
            for (int j = 1; j < n; j++) {
                if (newBoard[i][j] != input[i][j]) {
                    out.println(SET[newBoard[i][j]] + " " + i + " " + j);
                }
            }
        }

    }

    private void run() throws Exception {
        out = new PrintStream(new FileOutputStream(OUT));
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            int n = sc.nextInt();
            int m = sc.nextInt();
            int [][] boardAdd = new int[n + 1][n + 1];
            int [][] boardX = new int[n + 1][n + 1];
            int [][] input = new int[n + 1][n + 1];
            for (int j = 0; j <  m; j++) {
                char symbol = sc.next().charAt(0);
                int row = sc.nextInt();
                int col = sc.nextInt();
                if (symbol == '+') {
                    boardAdd[row][col] = 1;

                } else if (symbol == 'x')  {
                    boardX[row][col] = 2;

                } else if (symbol == 'o') {
                    boardAdd[row][col] = 1;
                    boardX[row][col] = 2;

                }
                input[row][col] = boardAdd[row][col] + boardX[row][col];

            }
            out.print("Case #" + i + ": ");
            solve(boardAdd, boardX, input);
        }
        sc.close();
        out.close();
    }
    private void putAdd(int board[][]) {
        Set<Integer> diag = new HashSet<>();
        Set<Integer> cDiag = new HashSet<>();
        int n = board.length;

        for (int i = 1; i < n; i++) {
            for (int j = 1; j < n; j++) {
                if (board[i][j] != 0) {
                    diag.add(i+j);
                    cDiag.add(i-j);
                }
            }
        }
        helpInsert(board, 1, n - 1, diag, cDiag);
    }

    private void insert(int [][]b, int x, int y, Set<Integer> diag, Set<Integer> cDiag) {
        if (!diag.contains(x+y) && !cDiag.contains(x-y)) {
            b[x][y] = 1;
            diag.add(x + y);
            cDiag.add(x - y);
        }
    }
    private void helpInsert(int board[][], int start, int edge, Set<Integer> diag, Set<Integer> cDiag) {
        int end = start + edge - 1;

        for (;edge > 0; edge = edge - 2) {
            for (int i = start; i <= end; i++) {
                int x = start, y = i;
                insert(board, x, y, diag, cDiag);
            }

            for (int i = start; i <= end; i++) {
                int x = end, y = i;
                insert(board, x, y, diag, cDiag);
            }

            for (int i = start; i <= end; i++) {
                int x = i, y = start;
                insert(board, x, y, diag, cDiag);
            }

            for (int i = start; i <= end; i++) {
                int x = i, y = end;
                insert(board, x, y, diag, cDiag);
            }
        }

    }
    private void putX(int board[][]) {
        int n = board.length;
        boolean[] rowVisited = new boolean[n];
        boolean[] columnVisited = new boolean[n];
        for (int i = 1; i < n; i++) {
            for (int j = 1; j < n; j++) {
                if (board[i][j] != 0) {
                    rowVisited[i] = true;
                    columnVisited[j] = true;
                }
            }
        }
        for (int i = 1; i < n; i++) {
            for (int j = 1; j < n; j++)
            {
                if (!rowVisited[i] && !columnVisited[j]) {
                    board[i][j] = 2;
                    rowVisited[i] = true;
                    columnVisited[j] = true;
                }
            }
        }
    }


    public static void main(String args[]) throws Exception {
        new FashionShow().run();
    }

}
