import com.sun.org.apache.xalan.internal.xsltc.compiler.Template;

import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.PriorityQueue;
import java.util.Scanner;

/**
 * Created by jml90 on 4/8/2017.
 */
public class BathRoomStalls {

    Scanner             sc       = new Scanner(getClass().getResourceAsStream(IN));
    static final String FILENAME = "c-small-1";
    static final String IN       = FILENAME + ".in";
    static final String OUT      = FILENAME + ".out";
    PrintStream out      = System.out;

    private void solve(int n, int k) {
        int ans0 = 0;
        int ans1 = 0;
        PriorityQueue<Integer> priorityQueue = new PriorityQueue<>((a,b)->(Integer.compare(b,a)));
        priorityQueue.offer(n);
        int count = 0;
        while (!priorityQueue.isEmpty()) {
            int top = priorityQueue.poll();
            if (count == k - 1) {
                ans0 = getMax(top);
                ans1 = getMin(top);
                break;
            }
            if (top % 2 == 0) {
                priorityQueue.offer(top / 2);
                priorityQueue.offer(top / 2 + 1);
            } else {
                priorityQueue.offer(top / 2 + 1);
                priorityQueue.offer(top / 2 + 1);
            }
            count++;
        }

        out.println(ans0 + " " + ans1);
    }

    private int getMin(int n) {
        return (n + 1) / 2 - 2;
    }

    private int getMax(int n) {
        return n - (n + 1)/ 2 - 1;
    }

    private void run() throws Exception {
        out = new PrintStream(new FileOutputStream(OUT));
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            int n = sc.nextInt() + 2;
            int k = sc.nextInt();
            out.print("Case #" + i + ": ");
            solve(n, k);
        }
        sc.close();
        out.close();
    }

    public static void main(String args[]) throws Exception {
        new  BathRoomStalls().run();
    }
}
