package _2014.QualRound;

import Helper.*;
import java.io.*;
import java.util.*;
import static java.lang.Math.*;

/**
 * @author Rakshak R.Hegde
 */
public class DeceitfulWar {

    private static BufferedReader reader;
    private static StringTokenizer tokenizer;
    private static PrintWriter writer;
    private static long begin = System.currentTimeMillis();

    public static void main(String args[]) throws Exception {
        String root = "IO/2014 Qual Round/";
        String inputPath = root + "D-small-attempt0";
        setup(inputPath);
        int T = nextInt(), N, i, count1, count2, size;
        LinkedList<Float> naomi1 = new LinkedList<>(), ken1 = new LinkedList<>(),
                naomi2 = new LinkedList<>(), ken2 = new LinkedList<>();
        for (int caseNo = 1; caseNo <= T; caseNo++) {
            N = nextInt();
            naomi1.clear();
            for (i = 0; i < N; i++) {
                naomi1.add(nextFloat());
            }
            Collections.sort(naomi1);
            naomi2.clear();
            for (float weight : naomi1) {
                naomi2.add(weight);
            }
            pln("Naomi: " + naomi2);

            ken1.clear();
            for (i = 0; i < N; i++) {
                ken1.add(nextFloat());
            }
            Collections.sort(ken1);
            ken2.clear();
            for (float weight : ken1) {
                ken2.add(weight);
            }
            pln("Ken: " + ken2);

            count1 = 0; // Deceitful ;)
            size = N;
            while (size-- > 0) {
                if(naomi1.getLast()>ken1.getLast()) {
                    count1++;
                    naomi1.removeLast();
                    ken1.removeLast();
                } else if(naomi1.removeFirst()>ken1.removeLast()) {
                    count1++;
                }
            }

            count2 = 0; // Fair :(
            size = N;
            while (size-- > 0) {
                if (naomi2.removeLast() > ken2.getLast()) {
                    count2++;
                    ken2.removeFirst();
                } else {
                    ken2.removeLast();
                }
            }

            println("Case #" + caseNo + ": " + count1 + " " + count2);
            pln("Case #" + caseNo + ": " + count1 + " " + count2);
        }
        displayTime("Time Taken");
        flush();
        java.awt.Toolkit.getDefaultToolkit().beep();
    }

    static int deceitfulWar(List<Integer> naomi, List<Integer> ken) {
        return 0;
    }

    static int war(List<Integer> naomi, List<Integer> ken) {
        return 0;
    }

    /**
     * Call this method to initialize the reader for the input file.
     */
    public static void setup(String file) throws IOException {
        reader = new BufferedReader(new FileReader(file + ".in"));
        tokenizer = new StringTokenizer(reader.readLine());
        writer = new PrintWriter(new BufferedWriter(new FileWriter(file + ".out")));
    }

    /**
     * Get next word.
     */
    public static String next() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }
        return tokenizer.nextToken();
    }

    public static String nextLine() throws IOException {
        tokenizer = null;
        return reader.readLine();
    }

    /**
     * Get next integer.
     */
    public static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    /**
     * Get next long.
     */
    public static long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    /**
     * Get next float.
     */
    public static float nextFloat() throws IOException {
        return Float.parseFloat(next());
    }

    /**
     * Get next double.
     */
    public static double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    /**
     * Print a single line without carryover.
     */
    public static void p(Object msg) {
        System.out.print(msg);
    }

    /**
     * Print a single line with carryover.
     */
    public static void pln(Object msg) {
        System.out.println(msg);
    }

    /**
     * Print a single line without carryover.
     */
    public static void print(Object msg) {
        writer.print(msg);
    }

    /**
     * Print a single line with carryover.
     */
    public static void println(Object msg) {
        writer.println(msg);
    }

    /**
     * Flushes the output.
     */
    public static void flush() throws Exception {
        writer.flush();
        writer.close();
        reader.close();
    }

    /**
     * Resets the timer.
     */
    public static void reset() {
        begin = System.currentTimeMillis();
    }

    /**
     * Displays the time elapsed.
     */
    public static void displayTime(Object msg) {
        System.out.println(msg + ": " + (System.currentTimeMillis() - begin) + " millis");
    }
}
