package _2014.Round1C;

import java.io.*;
import java.util.*;
import static java.lang.Math.*;

/**
 * @author Rakshak R.Hegde
 */
public class PartElf {

    private static BufferedReader reader;
    private static StringTokenizer tokenizer;
    private static PrintWriter writer;
    private static long begin = System.currentTimeMillis();

    public static void main(String args[]) throws Exception {
        String root = "IO/2014 Round 1C/";
        String inputPath = root + "A-small-attempt1";
        setup(inputPath);
        int T = nextInt(), index, generation;
        long P, Q;
        String P_Q;
        double ratio;
        boolean found;
        for (int caseNo = 1; caseNo <= T; caseNo++) {
            P_Q = next();
            index = P_Q.indexOf('/');
            P = Long.parseLong(P_Q.substring(0, index));
            Q = Long.parseLong(P_Q.substring(index + 1));
            if (Q % 2 != 0) {
                println("Case #" + caseNo + ": impossible");
                continue;
            }
            ratio = P / (double) Q;
            found = false;
            for (generation = 1; generation <= 40; generation++) {
                pln(ratio + " : " + generation);
                if (ratio < 0.5) {
                    ratio *= 2.0;
                } else {
                    println("Case #" + caseNo + ": " + generation);
                    found = true;
                    break;
                }
            }
            if (!found) {
                println("Case #" + caseNo + ": impossible");
            }
            pln("*******");
        }
        displayTime("Time Taken");
        flush();
        java.awt.Toolkit.getDefaultToolkit().beep();
    }

    static boolean isValid(String input) {

        return false;
    }

    /**
     * Call this method to initialize the reader for the input file.
     */
    public static void setup(String file) throws IOException {
        reader = new BufferedReader(new FileReader(file + ".in"));
        tokenizer = new StringTokenizer(reader.readLine());
        writer = new PrintWriter(new BufferedWriter(new FileWriter(file + ".out")));
    }

    /**
     * Get next word.
     */
    public static String next() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }
        return tokenizer.nextToken();
    }

    public static String nextLine() throws IOException {
        tokenizer = null;
        return reader.readLine();
    }

    /**
     * Get next integer.
     */
    public static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    /**
     * Get next long.
     */
    public static long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    /**
     * Get next float.
     */
    public static float nextFloat() throws IOException {
        return Float.parseFloat(next());
    }

    /**
     * Get next double.
     */
    public static double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    /**
     * Print a single line without carryover.
     */
    public static void p(Object msg) {
        System.out.print(msg);
    }

    /**
     * Print a single line with carryover.
     */
    public static void pln(Object msg) {
        System.out.println(msg);
    }

    /**
     * Print a single line without carryover.
     */
    public static void print(Object msg) {
        writer.print(msg);
    }

    /**
     * Print a single line with carryover.
     */
    public static void println(Object msg) {
        writer.println(msg);
    }

    /**
     * Flushes the output.
     */
    public static void flush() {
        writer.flush();
    }

    /**
     * Resets the timer.
     */
    public static void reset() {
        begin = System.currentTimeMillis();
    }

    /**
     * Displays the time elapsed.
     */
    public static void displayTime(Object msg) {
        System.out.println(msg + ": " + (System.currentTimeMillis() - begin) + " millis");
    }
}
