package _2014.QualRound;

import java.io.*;
import java.util.*;
import static java.lang.Math.*;

/**
 * @author Rakshak R.Hegde
 */
public class CookieClickerAlpha {

    private static BufferedReader reader;
    private static StringTokenizer tokenizer;
    private static PrintWriter writer;
    private static long begin = System.currentTimeMillis();

    public static void main(String args[]) throws Exception {
        String root = "IO/2014 Qual Round/";
        String inputPath = root + "B-large (2)";
        setup(inputPath);
        int T = nextInt();
        double total, rate, C, F, X;
        boolean goOn;
        for (int caseNo = 1; caseNo <= T; caseNo++) {
            total = 0;
            rate = 2;
            C = nextDouble();
            F = nextDouble();
            X = nextDouble();
            goOn = true;
            while (goOn) {
                // Is it better to win now or
                // make another transaction and then win
                if (X / rate <= C / rate + X / (rate + F)) {
                    goOn = false;
                    total += X / rate;
                } else {
                    total += C / rate; // LOL these two statements were switched
                    rate += F; // when I wrote this first, so I got smaller times ;)
                }
            }
            println("Case #" + caseNo + ": " + total);
            pln("Case #" + caseNo + ": " + total);
        }
        displayTime("Time Taken");
        flush();
        java.awt.Toolkit.getDefaultToolkit().beep();
    }

    /**
     * Call this method to initialize the reader for the input file.
     */
    public static void setup(String file) throws IOException {
        reader = new BufferedReader(new FileReader(file + ".in"));
        tokenizer = new StringTokenizer(reader.readLine());
        writer = new PrintWriter(new BufferedWriter(new FileWriter(file + ".out")));
    }

    /**
     * Get next word.
     */
    public static String next() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }
        return tokenizer.nextToken();
    }

    public static String nextLine() throws IOException {
        tokenizer = null;
        return reader.readLine();
    }

    /**
     * Get next integer.
     */
    public static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    /**
     * Get next long.
     */
    public static long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    /**
     * Get next float.
     */
    public static float nextFloat() throws IOException {
        return Float.parseFloat(next());
    }

    /**
     * Get next double.
     */
    public static double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    /**
     * Print a single line without carryover.
     */
    public static void p(Object msg) {
        System.out.print(msg);
    }

    /**
     * Print a single line with carryover.
     */
    public static void pln(Object msg) {
        System.out.println(msg);
    }

    /**
     * Print a single line without carryover.
     */
    public static void print(Object msg) {
        writer.print(msg);
    }

    /**
     * Print a single line with carryover.
     */
    public static void println(Object msg) {
        writer.println(msg);
    }

    /**
     * Flushes the output.
     */
    public static void flush() {
        writer.flush();
    }

    /**
     * Resets the timer.
     */
    public static void reset() {
        begin = System.currentTimeMillis();
    }

    /**
     * Displays the time elapsed.
     */
    public static void displayTime(Object msg) {
        System.out.println(msg + ": " + (System.currentTimeMillis() - begin) + " millis");
    }
}