package _2014.QualRound;

import java.io.*;
import java.util.*;
import static java.lang.Math.*;

/**
 * @author Rakshak R.Hegde
 */
public class MagicTrick {

    private static BufferedReader reader;
    private static StringTokenizer tokenizer;
    private static PrintWriter writer;
    private static long begin = System.currentTimeMillis();

    public static void main(String args[]) throws Exception {
        String root = "IO/2014 Qual Round/";
        String inputPath = root + "A-small-attempt0";
        setup(inputPath);
        int T = nextInt(), max = 4, count, i, j, row1, row2, ans = 0;
        int[][] arrange1 = new int[4][4], arrange2 = new int[4][4];
        String msg1 = "Bad magician!", msg2 = "Volunteer cheated!";
        for (int caseNo = 1; caseNo <= T; caseNo++) {
            // Chosen 1
            row1 = nextInt() - 1;
            for (i = 0; i < max; i++) {
                for (j = 0; j < max; j++) {
                    arrange1[i][j] = nextInt();
                }
            }
            // Chosen 2
            row2 = nextInt() - 1;
            for (i = 0; i < max; i++) {
                for (j = 0; j < max; j++) {
                    arrange2[i][j] = nextInt();
                }
            }

            /*pln("Case: " + caseNo);
            pln(row1 + ": " + prettify(arrange1[row1]));
            pln(row2 + ": " + prettify(arrange2[row2]));*/
            // Checking
            count = 0;
            for (i = 0; i < max; i++) {
                for (j = 0; j < max; j++) {
                    if (arrange1[row1][i] == arrange2[row2][j]) {
                        count++;
                        ans = arrange1[row1][i];
                    }
                }
            }

            // Printing the appropriate message
            if (count == 1) {
                println("Case #" + caseNo + ": " + ans);
            } else if (count > 1) {
                println("Case #" + caseNo + ": " + msg1);
            } else { // case when zero items found
                println("Case #" + caseNo + ": " + msg2);
            }
        }
        displayTime("Time Taken");
        flush();
        java.awt.Toolkit.getDefaultToolkit().beep();
    }

    static String prettify(int a[]) {
        String elems = "";
        for (int n : a) {
            elems += n + " ";
        }
        return elems;
    }

    /**
     * Call this method to initialize the reader for the input file.
     */
    public static void setup(String file) throws IOException {
        reader = new BufferedReader(new FileReader(file + ".in"));
        tokenizer = new StringTokenizer(reader.readLine());
        writer = new PrintWriter(new BufferedWriter(new FileWriter(file + ".out")));
    }

    /**
     * Get next word.
     */
    public static String next() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }
        return tokenizer.nextToken();
    }

    public static String nextLine() throws IOException {
        tokenizer = null;
        return reader.readLine();
    }

    /**
     * Get next integer.
     */
    public static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    /**
     * Get next long.
     */
    public static long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    /**
     * Get next float.
     */
    public static float nextFloat() throws IOException {
        return Float.parseFloat(next());
    }

    /**
     * Get next double.
     */
    public static double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    /**
     * Print a single line without carryover.
     */
    public static void p(Object msg) {
        System.out.print(msg);
    }

    /**
     * Print a single line with carryover.
     */
    public static void pln(Object msg) {
        System.out.println(msg);
    }

    /**
     * Print a single line without carryover.
     */
    public static void print(Object msg) {
        writer.print(msg);
    }

    /**
     * Print a single line with carryover.
     */
    public static void println(Object msg) {
        writer.println(msg);
    }

    /**
     * Flushes the output.
     */
    public static void flush() {
        writer.flush();
    }

    /**
     * Resets the timer.
     */
    public static void reset() {
        begin = System.currentTimeMillis();
    }

    /**
     * Displays the time elapsed.
     */
    public static void displayTime(Object msg) {
        System.out.println(msg + ": " + (System.currentTimeMillis() - begin) + " millis");
    }
}