import java.util.*;

public class b{
	static int CAM_TIME = 1;
	static int JAM_TIME = 2;
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int T = in.nextInt();
		for(int t = 1; t <= T; t++){
			int AC = in.nextInt();
			int AJ = in.nextInt();
			int[] sched = new int[1440];
			
			for(int ac=0;ac<AC;ac++){
				int start = in.nextInt();
				int end = in.nextInt();
				for(int i = start; i < end; i++){
					sched[i] = CAM_TIME;
				}
			}
			for(int aj=0;aj<AJ;aj++){
				int start = in.nextInt();
				int end = in.nextInt();
				for(int i = start; i < end; i++){
					sched[i] = JAM_TIME;
				}
			}
			
			
			// get the absolute min amount of times the swap can occur
			// so first get the first on-time
			int first = -1;
			for(int i = 0; i < 1440 && first == -1; i++){
				if(sched[i] != 0){
					first = i;
				}
			}
			
			if(first == -1){
				System.out.println("Case #" + t + ": " + 2);
				continue;
			}
			
			// what we want to do:
			// 1) count the number of intermediate intervals
			// 2) count the number of same intervals
			int[] nextTurn = new int[1440];
			int[] prevTurn = new int[1440];
			nextTurn[first] = sched[first];
			prevTurn[first] = sched[first];
			for(int i = 1; i < 1440; i++){
				if(sched[(i + first) % 1440] == CAM_TIME
				|| sched[(i + first) % 1440] == 0 && prevTurn[(i + first - 1) % 1440] == CAM_TIME){
					prevTurn[(i + first) % 1440] = CAM_TIME;
				}
				if(sched[(i + first) % 1440] == JAM_TIME
				|| sched[(i + first) % 1440] == 0 && prevTurn[(i + first - 1) % 1440] == JAM_TIME){
					prevTurn[(i + first) % 1440] = JAM_TIME;
				}
			}
			for(int i = 1439; i > 0; i--){
				if(sched[(i + first) % 1440] == CAM_TIME
				|| sched[(i + first) % 1440] == 0 && nextTurn[(i + first + 1) % 1440] == CAM_TIME){
					nextTurn[(i + first) % 1440] = CAM_TIME;
				}
				if(sched[(i + first) % 1440] == JAM_TIME
				|| sched[(i + first) % 1440] == 0 && nextTurn[(i + first + 1) % 1440] == JAM_TIME){
					nextTurn[(i + first) % 1440] = JAM_TIME;
				}
			}
			
			int numSwaps = 0;
			int camMins = 0;
			int jamMins = 0;
			int canBeEither = 0;
			for(int i = 0; i < 1440; i++){
				if(prevTurn[i] != prevTurn[(i+1) % 1440]){
//					System.out.println("at "+i);
					numSwaps++;
				}
				if(sched[i] == CAM_TIME || prevTurn[i] == CAM_TIME && nextTurn[i] == CAM_TIME) camMins++;
				else if(sched[i] == JAM_TIME || prevTurn[i] == JAM_TIME && nextTurn[i] == JAM_TIME) jamMins++;
				else canBeEither++;
			}
//			System.out.println(Arrays.toString(prevTurn));
//			System.out.println(Arrays.toString(nextTurn));
			
			
			// if camMins <= 720 and jamMins <= 720 then that's all we must do
//			System.out.println("cam time "+camMins+", jam time "+jamMins);
			if(camMins <= 720 && jamMins <= 720){
//				System.out.println("works w/o further");
				System.out.println("Case #" + t + ": " + numSwaps);
				continue;
			}
			
			// otherwise, we must sacrifice some of cam's interspace time or jam's interspace time,
			// which costs swaps.
			if(jamMins > 720){
				// convert all three arrays for the following code. i don't have time to write all that again
				for(int i = 0; i < 1440; i++){
					if(sched[i] == 1) sched[i]++;
					else if(sched[i] == 2) sched[i]--;
					if(nextTurn[i] == 1) nextTurn[i]++;
					else if(nextTurn[i] == 2) nextTurn[i]--;
					if(prevTurn[i] == 1) prevTurn[i]++;
					else if(prevTurn[i] == 2) prevTurn[i]--;
				}
				int swap = camMins; camMins = jamMins; jamMins = swap;
			}
			
			if(camMins > 720){
				jamMins += canBeEither;
				
				// count the number of times cam has intermission time, and for how long
				PriorityQueue<Integer> pq = new PriorityQueue<>(1440, (a, b)->{
					return b.intValue() - a.intValue();
				});
				
				int[] dp = new int[1440];
				for(int i = 1; i <= 1440; i++){
					// look for prevTurn[i] == CAM_TIME && nextTurn[i] == CAM_TIME && sched[i] == 0
					if(sched[(i + first) % 1440] == 0 && prevTurn[(i + first) % 1440] == CAM_TIME &&
							nextTurn[(i + first) % 1440] == CAM_TIME){
						dp[(i+first)%1440] = dp[(i+first-1)%1440] + 1;
					}
					else{
						if(dp[(i+first-1)%1440] > 0){
							pq.add(dp[(i+first-1)%1440]);
						}
					}
				}

//				System.out.println(Arrays.toString(dp));
				
				// the number of these we must take until camMins == jamMins times 2
				// is the number of more swaps required
				while(camMins > 720 && !pq.isEmpty()){
					int more = pq.poll();

//					System.out.println("JUST POLLED "+more);
					numSwaps += 2;
					camMins -= more;
				}
				
				if(camMins > 720){
					System.out.println("Case #" + t + ": Failure");
				}
				else{
					System.out.println("Case #" + t + ": " + numSwaps);
				}
			}
		}
	}
}