import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Dijkstra
{
	static int[][] a = { { 0, 0, 0, 0, 0 },
			{ 0, +1, +2, +3, +4 },
			{ 0, +2, -1, +4, -3 },
			{ 0, +3, -4, -1, +2 },
			{ 0, +4, +3, -2, -1 } };

	public static void main(String[] args) throws IOException
	{
		BufferedReader in = new BufferedReader(new FileReader
				("C-small-attempt2.in"));
		PrintWriter out = new PrintWriter(new BufferedWriter
				(new FileWriter("dijkstra.out")));

		StringTokenizer st;
		int testCases = Integer.parseInt(in.readLine());
		for (int test = 1; test <= testCases; test++)
		{
			st = new StringTokenizer(in.readLine());
			int L = Integer.parseInt(st.nextToken());
			int X = Integer.parseInt(st.nextToken());

			String str = in.readLine();
			String result = "NO";

			int length = L * X;
			if (length > 2)
			{
				if (length == 3)
				{
					if (str.equals("ijk"))
						result = "YES";
				}
				else
				{
					StringBuilder sb = new StringBuilder(length);
					for (int i = 0; i < X; i++)
						sb.append(str);

					String full = sb.toString();

					if (eval(full))
						result = "YES";
				}
			}

			out.printf("Case #%d: %s%n", test, result);
		}

		in.close();
		out.close();

	}

	static int conv(char c)
	{
		return c - 'g';
	}

	static boolean eval(String str)
	{
		int length = str.length();
		int[] s = new int[length];

		int current = conv(str.charAt(0));
		s[0] = current;

		for (int ch = 1; ch < length; ch++)
		{
			current = a[Math.abs(current)][conv(str.charAt(ch))]
					* (current / Math.abs(current));
			s[ch] = current;
		}

		if (current == -1)
		{
			for (int i = 0; i < length; i++)
			{
				if (s[i] == 2)
				{
					int prod = 1;
					for (int j = i + 1; j < length; j++)
					{
						prod = a[Math.abs(prod)][conv(str.charAt(j))]
								* (prod / Math.abs(prod));
						if (s[j] == 4 && prod == 3)
							return true;
					}
				}
			}
		}
		return false;
	}

	static int prod(String str)
	{
		int length = str.length();
		int current = conv(str.charAt(0));
		for (int ch = 1; ch < length; ch++)
			current = a[Math.abs(current)][conv(str.charAt(ch))]
					* (current / Math.abs(current));
		return current;
	}
}
