import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class B
{
	static String FILE_IN = "B-small-attempt5.in";
	static String FILE_OUT = "B.out";

	static String solve(BufferedReader in) throws IOException
	{
		StringTokenizer st = new StringTokenizer(in.readLine());
		int n = Integer.parseInt(st.nextToken());
		double v = Double.parseDouble(st.nextToken());
		double t = Double.parseDouble(st.nextToken());

		double time = 0;
		if (n == 1)
		{
			st = new StringTokenizer(in.readLine());
			double rate = Double.parseDouble(st.nextToken());
			if (Double.parseDouble(st.nextToken()) == t)
				time = v / rate;
			else
				return "IMPOSSIBLE";
		}
		else
		{
			st = new StringTokenizer(in.readLine());
			double r1 = Double.parseDouble(st.nextToken());
			double t1 = Double.parseDouble(st.nextToken());
			Tank one = new Tank(r1, t1);

			st = new StringTokenizer(in.readLine());
			double r2 = Double.parseDouble(st.nextToken());
			double t2 = Double.parseDouble(st.nextToken());
			Tank two = new Tank(r2, t2);

			if (t1 == t)
				time = v / r1;
			else if (t2 == t)
				time = v / r2;
			else
			{
				Tank hot = one, cold = two, fast = one, slow = two;

				if (one.t < two.t)
				{
					hot = two;
					cold = one;
				}
				if (one.r < two.r)
				{
					fast = two;
					slow = one;
				}

				if (hot.t < t || cold.t > t)
					return "IMPOSSIBLE";
				else
				{
					double min = 0;
					double max = v;

					boolean done = false;
					while (!done)
					{
						double mid = (min + max) / 2;
						double v1 = mid;
						double v2 = v - mid;

						double temp = (v1 * hot.t + v2 * cold.t) / (v1 + v2);

						if (Math.abs(temp - t) < 0.0000000000001)
						{
							time = Math.max(v1 / hot.r, v2 / cold.r);
							done = true;
						}
						else if (temp < t)
							min = mid + 0.0000000000001;
						else if (temp > t)
							max = mid - 0.0000000000001;
					}

				}
			}

		}

		return String.format("%.9f", time);
	}

	public static void main(String[] args) throws IOException
	{
		BufferedReader in = new BufferedReader
				(new FileReader("files/" + FILE_IN));
		PrintWriter out = new PrintWriter(new BufferedWriter
				(new FileWriter("files/" + FILE_OUT)));

		int T = Integer.parseInt(in.readLine());
		for (int t = 1; t <= T; t++)
		{
			String result = solve(in);
			System.out.printf("Case #%d: %s%n", t, result);
			out.printf("Case #%d: %s%n", t, result);
		}

		System.out.println("Complete");
		in.close();
		out.close();
	}
}

class Tank
{
	double r, t;

	public Tank(double a, double b)
	{
		r = a;
		t = b;
	}
}
