import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.StringTokenizer;

public class InfiniteHouseofPancakes
{
	public static void main(String[] args) throws IOException
	{
		BufferedReader in = new BufferedReader(new FileReader(
				"B-small-attempt2.in"));
		PrintWriter out = new PrintWriter(new BufferedWriter(
				new FileWriter("pancakes.out")));

		StringTokenizer st;
		int testCases = Integer.parseInt(in.readLine());
		for (int test = 1; test <= testCases; test++)
		{
			int diners = Integer.parseInt(in.readLine());
			ArrayList<Diner> d = new ArrayList<Diner>(diners);

			st = new StringTokenizer(in.readLine());
			for (int i = 0; i < diners; i++)
				d.add(new Diner(Integer.parseInt(st.nextToken())));

			Collections.sort(d);
			int[] order = new int[diners];
			int[] sum = new int[diners];
			for (int i = 0; i < diners; i++)
				order[i] = d.get(i).p;

			sum[0] = order[0];
			for (int i = 1; i < diners; i++)
				order[i] = order[i - 1] + sum[i];

			int min = Integer.MAX_VALUE;
			for (int current = 0; current <= 1; current++)
			{
				Diner.current = current;
				Collections.sort(d, Diner.EAT_ORDER);

				int maxE = d.get(0).e[current];
				int time = maxE;

				for (Diner diner : d)
					if (diner.p > maxE)
						time += diner.s[current];

				if (time < min)
					min = time;
			}

			for (int i = 0; i < diners; i++)
				if (order[i] + i < min)
					if (i == 0 || sum[i - 1] / i <= order[i])
						min = order[i] + i;

			out.printf("Case #%d: %d%n", test, min);
		}

		in.close();
		out.close();
	}
}

class Diner implements Comparable<Diner>
{
	static final Comparator<Diner> EAT_ORDER = new EatOrder();

	static int[][] spe = { { 0, 0, 0, 0, 1, 1, 1, 1, 1, 2 },
			{ 0, 0, 0, 0, 1, 1, 1, 1, 1, 1 } };
	static int[][] eat = { { 0, 1, 2, 3, 2, 3, 3, 4, 4, 3 },
			{ 0, 1, 2, 3, 2, 3, 3, 4, 4, 5 } };

	static int current;

	int p;
	int[] e, s;

	public Diner(int n)
	{
		p = n;

		s = new int[2];
		e = new int[2];

		s[0] = spe[0][p];
		e[0] = eat[0][p];

		s[1] = spe[1][p];
		e[1] = eat[1][p];
	}

	public int compareTo(Diner other)
	{
		return other.p - this.p;
	}

	public String toString()
	{
		return String.format("p: %d s: %d e: %d", p, s[current], e[current]);
	}

	static class EatOrder implements Comparator<Diner>
	{
		public int compare(Diner first, Diner second)
		{
			return second.e[current] - first.e[current];
		}
	}
}