import java.awt.Point;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.StringTokenizer;

public class A
{
	static String FILE_IN = "A-large.in";
	static String FILE_OUT = "A.out";

	static String DIRS = "<^>v";
	static int[] DROW = { 0, -1, 0, 1 };
	static int[] DCOL = { -1, 0, 1, 0 };

	static int rows, cols;
	static char[][] grid;

	static int offRow, offCol;
	static HashSet<Point> points;

	static String solve(BufferedReader in) throws IOException
	{
		StringTokenizer st = new StringTokenizer(in.readLine());
		rows = Integer.parseInt(st.nextToken());
		cols = Integer.parseInt(st.nextToken());

		grid = new char[rows][cols];
		points = new HashSet<Point>();

		for (int i = 0; i < rows; i++)
			grid[i] = in.readLine().toCharArray();

		for (int r = 0; r < rows; r++)
			for (int c = 0; c < cols; c++)
				if (grid[r][c] != '.')
					if (check(r, c, DIRS.indexOf(grid[r][c])) == false)
						points.add(new Point(offRow, offCol));

		boolean impossible = false;
		for (Point p : points)
		{
			if (!hasNeighbour(p.x, p.y))
				impossible = true;
		}

		for (int r = 0; r < rows; r++)
		{
			for (int c = 0; c < cols; c++)
				System.out.print(grid[r][c]);
			System.out.println();
		}

		if (impossible)
			return "IMPOSSIBLE";
		else
			return String.format("%d", points.size());
	}

	private static boolean hasNeighbour(int row, int col)
	{
		int count = -2;
		for (int r = 0; r < rows; r++)
			if (grid[r][col] != '.')
				count++;
		for (int c = 0; c < cols; c++)
			if (grid[row][c] != '.')
				count++;

		return count > 0;
	}

	private static boolean check(int r, int c, int dir)
	{
		if (r < 0 || r >= rows || c < 0 || c >= cols)
		{
			offRow = r - DROW[dir];
			offCol = c - DCOL[dir];
			while (grid[offRow][offCol] == '.')
			{
				offRow -= DROW[dir];
				offCol -= DCOL[dir];
			}
			return false;
		}
		if (grid[r][c] == '.')
			return check(r + DROW[dir], c + DCOL[dir], dir);
		if (grid[r][c] == '*')
			return true;

		char copy = grid[r][c];
		grid[r][c] = '*';
		int d = DIRS.indexOf(copy);
		boolean b = check(r + DROW[d], c + DCOL[d], d);
		grid[r][c] = copy;
		return b;
	}

	public static void main(String[] args) throws IOException
	{
		BufferedReader in = new BufferedReader
				(new FileReader("files/" + FILE_IN));
		PrintWriter out = new PrintWriter(new BufferedWriter
				(new FileWriter("files/" + FILE_OUT)));

		int T = Integer.parseInt(in.readLine());
		for (int t = 1; t <= T; t++)
		{
			String result = solve(in);
			System.out.printf("Case #%d: %s%n", t, result);
			out.printf("Case #%d: %s%n", t, result);
		}

		System.out.println("Complete");
		in.close();
		out.close();
	}
}
