import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class A
{
	static String FILE_IN = "A-large.in";
	static String FILE_OUT = "A.out";

	static String solve(BufferedReader in) throws IOException
	{
		StringTokenizer st = new StringTokenizer(in.readLine());

		String S = st.nextToken();
		int K = Integer.parseInt(st.nextToken());

		StringBuilder sb = new StringBuilder(S);

		int maxFlips = S.length() - K + 1;
		int flips = 0;
		for (int i = 0; i < maxFlips; i++)
			if (sb.charAt(i) == '-')
			{
				int endOfFlip = i + K;
				for(int j = i; j < endOfFlip; j++)
					sb.setCharAt(j, sb.charAt(j) == '+' ? '-' : '+');

				flips++;
			}

		if (sb.indexOf("-") > 0)
			return "IMPOSSIBLE";

		return String.format("%d", flips);
	}

	@SuppressWarnings("Duplicates")
	public static void main(String[] args) throws IOException
	{
		BufferedReader in = new BufferedReader
				(new FileReader("files/" + FILE_IN));
		PrintWriter out = new PrintWriter(new BufferedWriter
				(new FileWriter("files/" + FILE_OUT)));

		int T = Integer.parseInt(in.readLine());
		for (int t = 1; t <= T; t++)
		{
			String result = solve(in);
			System.out.printf("Case #%d: %s%n", t, result);
			out.printf("Case #%d: %s%n", t, result);
		}

		System.out.println("Complete");
		in.close();
		out.close();
	}
}
