import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.StringTokenizer;


public class A
{
	static String FILE_IN = "A-small-attempt1.in";
	static String FILE_OUT = "A.out";

	static String solve(BufferedReader in) throws IOException
	{
		StringTokenizer st = new StringTokenizer(in.readLine());
		Double D = Double.parseDouble(st.nextToken());
		int N = Integer.parseInt(st.nextToken());

		ArrayList<Horse> horses = new ArrayList<>(N);
		int K, S;
		for (int n = 0; n < N; n++)
		{
			st = new StringTokenizer(in.readLine());
			K = Integer.parseInt(st.nextToken());
			S = Integer.parseInt(st.nextToken());

			horses.add(new Horse(K, S, D));
		}
		Collections.sort(horses);

		for (int n = 0; n < N - 1; n++)
		{
			if (horses.get(n).time > horses.get(n + 1).time)
				return String.format("%f", D / horses.get(n).time);
		}
		return String.format("%f", D / horses.get(N - 1).time);
	}

	@SuppressWarnings("Duplicates")
	public static void main(String[] args) throws IOException
	{
		BufferedReader in = new BufferedReader
				(new FileReader("files/" + FILE_IN));
		PrintWriter out = new PrintWriter(new BufferedWriter
				(new FileWriter("files/" + FILE_OUT)));

		int T = Integer.parseInt(in.readLine());
		for (int t = 1; t <= T; t++)
		{
			String result = solve(in);
			System.out.printf("Case #%d: %s%n", t, result);
			out.printf("Case #%d: %s%n", t, result);
		}

		System.out.println("Complete");
		in.close();
		out.close();
	}
}

class Horse implements Comparable<Horse>
{
	int K, S;
	double time;

	public Horse(int k, int s, double D)
	{
		K = k;
		S = s;
		time = (D - K) / S;
	}

	public int compareTo(Horse other)
	{
		return other.K - other.K;
	}
}
