import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class A
{
	static String FILE_IN = "A-small-attempt0.in";
	static String FILE_OUT = "A.out";

	static String solve(BufferedReader in) throws IOException
	{
		StringTokenizer st = new StringTokenizer(in.readLine());
		int R = Integer.parseInt(st.nextToken());
		int C = Integer.parseInt(st.nextToken());

		char[][] grid = new char[R][C];

		for (int r = 0; r < R; r++)
			grid[r] = in.readLine().toCharArray();

		int y;
		for (int r = 0; r < R; r++)
			for (int c = 0; c < C; c++)
			{
				char ch = grid[r][c];
				if (ch != '?')
				{
					y = c + 1;
					while (y < C && grid[r][y] == '?')
						grid[r][y++] = ch;

					y = c - 1;
					while (y >= 0 && grid[r][y] == '?')
						grid[r][y--] = ch;
				}
			}

		int x;
		for (int r = 0; r < R; r++)
			for (int c = 0; c < C; c++)
			{
				char ch = grid[r][c];
				if (ch != '?')
				{
					x = r + 1;
					while (x < R && grid[x][c] == '?')
						grid[x++][c] = ch;

					x = r - 1;
					while (x >= 0 && grid[x][c] == '?')
						grid[x--][c] = ch;
				}
			}

		StringBuilder sb = new StringBuilder();
		for (int r = 0; r < R; r++)
		{
			for (int c = 0; c < C; c++)
				sb.append(grid[r][c]);
			sb.append("\n");
		}

		return String.format("%n%s", sb.deleteCharAt(sb.length() - 1).toString());
	}

	@SuppressWarnings("Duplicates")
	public static void main(String[] args) throws IOException
	{
		BufferedReader in = new BufferedReader
				(new FileReader("files/" + FILE_IN));
		PrintWriter out = new PrintWriter(new BufferedWriter
				(new FileWriter("files/" + FILE_OUT)));

		int T = Integer.parseInt(in.readLine());
		for (int t = 1; t <= T; t++)
		{
			String result = solve(in);
			System.out.printf("Case #%d: %s%n", t, result);
			out.printf("Case #%d: %s%n", t, result);
		}

		System.out.println("Complete");
		in.close();
		out.close();
	}
}
