import java.util.*;
import java.io.*;

public class Main {
	public static void main(String[] args) {

		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int total = in.nextInt();

		StringBuffer result = new StringBuffer();
		for (int t = 1; t <= total; ++t) {
			int n = in.nextInt();
			int k = in.nextInt();

			Pancake[] pancakes = new Pancake[n];

			for (int i = 0; i < n; i++) {
				pancakes[i] = new Pancake(in.nextInt(), in.nextInt());
			}

			result.append("Case #" + t + ": " + solve(n, k, pancakes));
			result.append('\n');
		}
		System.out.print(result);

	}

	private static CompWithUpper upper = new CompWithUpper();
	private static CompWithSide side = new CompWithSide();

	private static double solve(int n, int k, Pancake[] pancakes) {
		// TODO Auto-generated method stub

		Pancake[] alignUpper = Arrays.copyOf(pancakes, n);
		Arrays.sort(alignUpper, upper);
		Pancake[] alignSide = Arrays.copyOf(pancakes, n);
		Arrays.sort(alignSide, side);

		double maxTotal = Double.MIN_VALUE;

		for (int i = 0; i < n; i++) {
			double total = total(n, k, alignUpper[i], alignSide);
			if (total > maxTotal)
				maxTotal = total;
		}

		return maxTotal;
	}

	private static double total(int n, int k, Pancake first, Pancake[] alignSide) {
		double sum = first.sideArea + first.upperArea;
		int count = 1;
		for (int i = 0; i < n; i++) {
			if (count == k)
				break;
			if (first != alignSide[i]) {
				sum += alignSide[i].sideArea;
				count++;
			}
		}
		return sum;
	}

}

class CompWithUpper implements Comparator<Pancake> {

	@Override
	public int compare(Pancake o1, Pancake o2) {
		// TODO Auto-generated method stub
		double upper1 = o1.upperArea;
		double upper2 = o2.upperArea;
		if (upper1 > upper2)
			return -1;
		else if (upper1 < upper2)
			return 1;
		else
			return 0;
	}

}

class CompWithSide implements Comparator<Pancake> {

	@Override
	public int compare(Pancake o1, Pancake o2) {
		// TODO Auto-generated method stub
		double side1 = o1.sideArea;
		double side2 = o2.sideArea;
		if (side1 > side2)
			return -1;
		else if (side1 < side2)
			return 1;
		else
			return 0;
	}

}

class Pancake {
	int r;
	int h;

	double upperArea;
	double sideArea;

	Pancake(int r, int h) {
		this.r = r;
		this.h = h;
		this.upperArea = r * 1.0 * r * Math.PI;
		this.sideArea = 2 * Math.PI * r * 1.0 * h;
	}

}