package gcjam15;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

public class q32017 {
	
	public class Block {
		public int s;
		public int e;
		
		public Block(int s, int e) {
			this.s = s;
			this.e = e;
		}
		
		public int size() {
			return e - s;
		}
		
		public int seat() {
			
			int seat = (e + s) / 2;
			//System.out.println("seat: " + seat + ", " + e + "," + s);
			return seat ;
		}

	}
	
	public static void main(String[] args) throws IOException {
		BufferedReader inputStream = null;
		
		try {
			inputStream = new BufferedReader(new FileReader("C-small-1-attempt0.in"));
			q32017 test = new q32017();
			test.q3m(inputStream);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	public q32017() {
		
	}
	
	public void q3m(BufferedReader input) throws IOException {
		Scanner scanner = new Scanner(input);
		int cases = 0;
		BufferedWriter bw = new BufferedWriter(new FileWriter("c1.out"));
		
		cases = Integer.parseInt(scanner.nextLine());
		
		for (int i = 1; i <= cases; i++) {
					
			int stalls = scanner.nextInt();
			int people = scanner.nextInt();
			
			String output = stalls(stalls, people);
			
			String strout = "Case #" + i + ": " + output;
			
			System.out.println(strout);
			bw.write(strout);
			bw.newLine();
		}	
		scanner.close();
		bw.close();
	}
	
	public String stalls(int stalls, int ppl) {
		ArrayList<Block> blocks = new ArrayList<Block>();
		blocks.add(new Block(1, stalls));
		Block spot = null;
		
		for (int i = 0; i < ppl;) {
			
			//find spot to sit in
			for (Block b : blocks) {
				//System.out.println("Find Spot [B]" + ", L: " + b.s + ", R: " + b.e);
				if (spot == null) {
					spot = b;
				}
				else {
					if (b.size() > spot.size()) {
						spot = b;
					}
				}
			}
			
			//sit in this spot
			blocks.remove(spot);
			int seat = spot.seat();
			
			if (seat != spot.s) {
				blocks.add(new Block(spot.s, (seat - 1)));
			}
			if (seat != spot.e) {
				blocks.add(new Block((seat + 1), spot.e));
			}
			
			if (++i != ppl) {
				spot = null;
			}
		} 
		//System.out.println("L: " + (spot.seat() - spot.s) + ", R: " + (spot.e - spot.seat()));
		
		int left = (spot.seat() - spot.s);
		int right = (spot.e - spot.seat());
		String result = Math.max(left,right) + " " + Math.min(left, right);
		return result;
	}	
}
