package com.desing.codejam.y2014.qualification;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

// Possibly The worst solution

public class MinesweeperMaster {

	public static void main(String[] args) throws FileNotFoundException {

		String inputPathName = "inputs/MinesweeperMaster-small-practice.in";
		String outputPathName = "C:/Users/desingurajan_s/Desktop/out.txt";

		try (Scanner sc = new Scanner(new BufferedReader(new FileReader(
				new File(inputPathName))));
				PrintWriter pw = new PrintWriter(new File(outputPathName))) {
			int T = sc.nextInt();

			for (int i = 1; i <= T; i++) {
				int R = sc.nextInt();
				int C = sc.nextInt();
				int M = sc.nextInt();

				int[] mine = new int[R * C];
				Arrays.fill(mine, 0);

				for (int j = 1; j <= M; j++) {
					mine[R * C - j] = 2;
				}

				boolean impossible = true;
				do {
					Pair pair = checkForOneClickWin(mine, R, C);
					if (pair != null) {
						pw.format("Case #%d:%n", i);
						for (int r = 0; r < R; r++) {
							for (int c = 0; c < C; c++) {
								if (r == pair.r && c == pair.c) {
									pw.format("c");
								} else if (mine[r * C + c] == 2) {
									pw.format("*");
								} else {
									pw.format(".");
								}
							}
							pw.println();
						}
						impossible = false;
						break;
					}
				} while (permuteLexically(mine));

				if (impossible) {
					pw.format("Case #%d:%nImpossible%n", i);
				}
			}
		}
	}

	private static Pair checkForOneClickWin(int[] mine, int R, int C) {
		int[][] copyMine = new int[R][C];
		for (int r = 0; r < R; r++) {
			for (int c = 0; c < C; c++) {
				copyMine[r][c] = mine[r * C + c];
			}
		}

		for (int r = 0; r < R; r++) {
			for (int c = 0; c < C; c++) {
				if (copyMine[r][c] == 0) {
					if (checkNeighboutCellHasMine(copyMine, r, c, R, C)) {
						copyMine[r][c] = 1;
					} else {
						copyMine[r][c] = -1;
					}
				}
			}
		}

//		for (int r = 0; r < R; r++) {
//			for (int c = 0; c < C; c++) {
//				if (copyMine[r][c] == -1) {
//					if (verifyCanReachAllCells(copyMine, r, c, R, C)) {
//						return new Pair(r, c);
//					}
//				}
//			}
//		}

		for (int r = R - 1; r >= 0; r--) {
			for (int c = C - 1; c >= 0; c--) {
				if (copyMine[r][c] == -1) {
					if (verifyCanReachAllCells(copyMine, r, c, R, C)) {
						return new Pair(r, c);
					}
				}
			}
		}
		
		return null;

	}

	private static void setCell(int[][] copyMine, boolean[][] temp,
			List<Pair> pairs, int r, int c, int R, int C) {
		if ((r >= 0 && r < R) && (c >= 0 && c < C)) {
			if (copyMine[r][c] == -1 && !temp[r][c]) {
				temp[r][c] = true;
				pairs.add(new Pair(r, c));
			}
			if (copyMine[r][c] == 1) {
				temp[r][c] = true;
			}
		}
	}

	private static boolean verifyCanReachAllCells(int[][] copyMine, int r,
			int c, int R, int C) {
		boolean[][] cellVisited = new boolean[R][C];
		List<Pair> pairs = new LinkedList<>();
		pairs.add(new Pair(r, c));

		while (pairs.size() > 0) {
			Pair pair = pairs.remove(0);
			r = pair.r;
			c = pair.c;

			setCell(copyMine, cellVisited, pairs, r - 1, c - 1, R, C);
			setCell(copyMine, cellVisited, pairs, r - 1, c, R, C);
			setCell(copyMine, cellVisited, pairs, r - 1, c + 1, R, C);

			setCell(copyMine, cellVisited, pairs, r + 1, c - 1, R, C);
			setCell(copyMine, cellVisited, pairs, r + 1, c, R, C);
			setCell(copyMine, cellVisited, pairs, r + 1, c + 1, R, C);

			setCell(copyMine, cellVisited, pairs, r, c - 1, R, C);
			setCell(copyMine, cellVisited, pairs, r, c, R, C);
			setCell(copyMine, cellVisited, pairs, r, c + 1, R, C);
		}

		for (r = 0; r < R; r++) {
			for (c = 0; c < C; c++) {
				if (!cellVisited[r][c] && copyMine[r][c] != 2) {
					return false;
				}
			}
		}

		return true;
	}

	private static boolean checkNeighboutCellHasMine(int[][] copyMine, int row,
			int column, int R, int C) {
		int r = row - 1, c = column - 1;
		if ((r >= 0 && r < R) && (c >= 0 && c < C) && copyMine[r][c] == 2) {
			return true;
		}
		r = row - 1;
		c = column;
		if ((r >= 0 && r < R) && (c >= 0 && c < C) && copyMine[r][c] == 2) {
			return true;
		}
		r = row - 1;
		c = column + 1;
		if ((r >= 0 && r < R) && (c >= 0 && c < C) && copyMine[r][c] == 2) {
			return true;
		}
		r = row + 1;
		c = column - 1;
		if ((r >= 0 && r < R) && (c >= 0 && c < C) && copyMine[r][c] == 2) {
			return true;
		}
		r = row + 1;
		c = column;
		if ((r >= 0 && r < R) && (c >= 0 && c < C) && copyMine[r][c] == 2) {
			return true;
		}
		r = row + 1;
		c = column + 1;
		if ((r >= 0 && r < R) && (c >= 0 && c < C) && copyMine[r][c] == 2) {
			return true;
		}
		r = row;
		c = column - 1;
		if ((r >= 0 && r < R) && (c >= 0 && c < C) && copyMine[r][c] == 2) {
			return true;
		}
		r = row;
		c = column + 1;
		if ((r >= 0 && r < R) && (c >= 0 && c < C) && copyMine[r][c] == 2) {
			return true;
		}
		return false;
	}

	public static boolean permuteLexically(int[] data) {
		int k = data.length - 2;
		while (data[k] >= data[k + 1]) {
			k--;
			if (k < 0) {
				return false;
			}
		}
		int l = data.length - 1;
		while (data[k] >= data[l]) {
			l--;
		}
		swap(data, k, l);
		int length = data.length - (k + 1);
		for (int i = 0; i < length / 2; i++) {
			swap(data, k + 1 + i, data.length - i - 1);
		}
		return true;
	}

	private static void swap(int[] data, int k, int l) {
		int temp = data[k];
		data[k] = data[l];
		data[l] = temp;
	}
}

class Pair {
	final int r;
	final int c;

	public Pair(int r, int c) {
		this.r = r;
		this.c = c;
	}
}