package codejam.y2016.round2;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

/**
 * @author Max Myslyvtsev
 * @since 5/28/16
 */
public class B {

    public static void main(String[] args) throws Exception {
        //Scanner in = new Scanner(new FileInputStream("/Users/max/Work/Source/foobar/src/main/resources/input.txt"));
        Scanner in = new Scanner(new FileInputStream("/Users/max/Downloads/B-small-attempt1 (1).in"));
        PrintStream out = new PrintStream(new FileOutputStream("/Users/max/Work/Source/foobar/src/main/resources/output.txt"));
        int T = in.nextInt();
        in.nextLine();
        for (int t = 1; t <= T; t++) {
            int N = in.nextInt();
            int K = in.nextInt();
            double[] p = new double[N];
            for (int i = 0; i < N; i++) {
                p[i] = in.nextDouble();
            }
            double r = solve3(N, K, p);
            String a = String.format("%.10f", r);
            String answ = "Case #" + t + ": " + a;
            out.println(answ);
            System.out.println(answ);
        }
    }

    static double solve2(int N, int K, double[] p) {
        TreeMap<Integer, Double>[][] dp = new TreeMap[N][K+1];
        dp[0][0] = new TreeMap<>();
        dp[0][0].put(0, 1.0);
        dp[0][1] = new TreeMap<>();
        dp[0][1].put(1, p[0]);
        dp[0][1].put(-1, 1-p[0]);
        System.out.println(Arrays.toString(dp[0]));
        for (int i = 1; i < N; i++) {
            for (int j = 0; j <= K; j++) {
                double curProb = p[i];
                dp[i][j] = new TreeMap<>();
                for (int vote = -K; vote <= K; vote++) {
                    doStep(dp, i, j, j-1, curProb, vote, vote+1);
                    doStep(dp, i, j, j-1, 1-curProb, vote, vote-1);
                    doStep(dp, i, j, j, 1, vote, vote);
                }
            }
            System.out.println(Arrays.toString(dp[i]));
        }

        return dp[N-1][K].get(0);
    }

    private static void doStep(TreeMap<Integer, Double>[][] dp, int i, int j, int prevJ, double curProb, int prevVote, int nextVote) {
        if (prevJ < 0 || prevJ >= dp[0].length) return;
        if (dp[i-1][prevJ] != null) {
            Double prev = dp[i-1][prevJ].get(prevVote);
            if (prev != null) {
                double cur = prev * curProb;
                Double already = dp[i][j].get(nextVote);
                if (already == null || cur > already) {
                    dp[i][j].put(nextVote, cur);
                }
            }
        }
    }

    static double solve(int N, int K, double[] p) {
        System.out.println();

        Arrays.sort(p);
        double[] taking = new double[K];
        for (int i = 0; i < K/2; i++) {
            taking[i] = p[i];
            taking[K/2+i] = p[N-K/2+i];
        }
        return calcProb(K, taking);
    }

    static double solve3(int N, int K, double[] p) {
        System.out.println();

        Arrays.sort(p);
        double ans = -1;
        if (Math.abs(0.5 - p[0]) < Math.abs(0.5 - p[N-1])) {
            for (int i = K/2; i < N-K/2-K/2; i++) {
                double[] taking = new double[K];
                for (int j = 0; j < K/2; j++) {
                    taking[j] = p[j];
                    taking[K/2+j] = p[i+j];
                }
                double prob = calcProb(K, taking);
                if (ans == -1 || prob > ans) {
                    ans = prob;
                }
            }
        } else {
            for (int i = 0; i < N-K/2-K/2; i++) {
                double[] taking = new double[K];
                for (int j = 0; j < K/2; j++) {
                    taking[j] = p[j+i];
                    taking[K/2+j] = p[N-K/2+j];
                }
                double prob = calcProb(K, taking);
                if (ans == -1 || prob > ans) {
                    ans = prob;
                }
            }
        }
        return ans;
    }

    static double calcProb(int K, double[] taking) {
        System.out.println(Arrays.toString(taking));
        TreeMap<Integer, Double>[] dp = new TreeMap[K];
        dp[0] = new TreeMap<>();
        dp[0].put(1, taking[0]);
        dp[0].put(-1, 1-taking[0]);
        for (int i = 1; i < K; i++) {
            dp[i] = new TreeMap<>();
            double curVote = taking[i];
            for (Map.Entry<Integer, Double> e : dp[i-1].entrySet()) {
                int prevVote = e.getKey();
                double prevProb = e.getValue();
                {
                    int nextVote = prevVote + 1;
                    double nextProb = prevProb * curVote;

                    Double prob = dp[i].get(nextVote);
                    if (prob == null) {
                        prob = 0.0;
                    }
                    prob += nextProb;
                    dp[i].put(nextVote, prob);
                }
                {
                    int nextVote = prevVote - 1;
                    double nextProb = prevProb * (1-curVote);

                    Double prob = dp[i].get(nextVote);
                    if (prob == null) {
                        prob = 0.0;
                    }
                    prob += nextProb;
                    dp[i].put(nextVote, prob);
                }
            }
        }

        System.out.println(Arrays.toString(dp));

        return dp[K-1].get(0);
    }
}
