import java.math.BigInteger;
import java.util.Random;
import java.util.Scanner;

/**
 * Author: Destiner
 * Date: 10.04.2016
 */
public class Qual_C_S {
    private static Random gen = new Random();

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        scanner.nextInt();
        int N = scanner.nextInt();
        int J = scanner.nextInt();
        System.out.println("Case #1:");
        int len = N;
        int count = J;
        int jams = 0;
        while (jams < count) {
            int[] lastResults = new int[9];
            boolean[] number = generate(len);
            boolean ok = true;
            for (int i = 2; i <= 10; i++) {
                int result = checkForSystem(number, i);
                lastResults[i - 2] = result;
                ok = (result != 0);
                if (!ok) {
                    break;
                }
            }
            if (ok) {
                for (boolean aNumber : number) {
                    if (aNumber) {
                        System.out.print(1);
                    } else {
                        System.out.print(0);
                    }
                }
                System.out.print(' ');
                for (int i = 0; i < lastResults.length; i++) {
                    int lastResult = lastResults[i];
                    System.out.print(lastResult);
                    if (i != lastResults.length - 1) {
                        System.out.print(' ');
                    }
                }
                System.out.println();
                jams++;
            }
        }
    }

    private static int checkForSystem(boolean[] number, int i) {
        long num = convert(number, i);
        // Check 2
        if (num % 2 == 0) {
            return 2;
        }
        // Check 3
        if (sumOfDigits(num) % 3 == 0) {
            return 3;
        }
        // Check 5
        if (num % 5 == 0) {
            return 5;
        }
        // Check 7

        String sss = "";
        for (boolean aNumber : number) {
            sss += (aNumber) ? '1' : '0';
        }
        BigInteger bigInteger = new BigInteger(sss, i);
        int[] digits = new int[32];
        int pointer = 31;
        while (bigInteger.signum() == 1) {
            BigInteger[] result = bigInteger.divideAndRemainder(new BigInteger("10"));
            bigInteger = result[0];
            digits[pointer] = Integer.parseInt(result[1].toString());
            pointer--;
        }
        int sum = 0;
        boolean sign = true;
        for (int k = 10; k > 0; k--) {
            int triple = 100 * digits[3 * k - 1] + 10 * digits[3 * k] + digits[3 * k + 1];
            if (sign) {
                sum += triple;
            } else {
                sum -= triple;
            }
            sign = !sign;
        }
        sum += 10 * digits[0] + digits[1];
        if (sum % 7 == 0) {
            return 7;
        }
        return 0;
    }

    private static long convert(boolean[] number, int i) {
        long sum = 0;
        long factor = 1;
        // Convert only last 10 digits
        for (int k = number.length - 1; k >= 0; k--) {
        //for (int k = number.length - 1; k >= number.length - 10; k--) {
            if (number[k]) {
                sum += factor;
            }
            factor *= i;
        }
        return sum;
    }

    private static boolean[] generate(int n) {
        boolean[] number = new boolean[n];
        number[0] = true;
        number[n - 1] = true;
        for (int i = 1; i < n - 1; i++) {
            number[i] = gen.nextBoolean();
        }
        return number;
    }

    static boolean[] primesUnderN(int n) {
        boolean[] isPrime = new boolean[n + 1];
        for (int i = 2; i <= n; i++) {
            isPrime[i] = true;
        }
        for (int i = 2; i * i  <= n; i++) {
            if (isPrime[i]) {
                for (int j = i * i; j <= n; j += i) {
                    isPrime[j] = false;
                }
            }
        }
        return isPrime;
    }

    static int sumOfDigits(long num) {
        int sum = 0;
        while (num > 0) {
            sum += num % 10;
            num /= 10;
        }
        return sum;
    }
}