import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class ProblemC {
    private static final String INPUT_FILENAME = "C-small-attempt0.in";
    private static final String OUTPUT_FILENAME = "C-small-attempt0.out";

	public static void main(String[] args) throws Exception {
		Scanner input = new Scanner(new FileReader(INPUT_FILENAME));
        PrintWriter output = new PrintWriter(new FileWriter(OUTPUT_FILENAME));
            
        int numberOfTestCase = input.nextInt();
        for (int caseNum=1; caseNum<=numberOfTestCase; caseNum++) {
        	int R = input.nextInt();
        	int C = input.nextInt();
        	int M = input.nextInt();
        	
        	int[][] board = new int[R][C];
        	for (int r=0; r<R; r++) {
        		Arrays.fill(board[r], 0);
        	}
        	
        	int m = M;
        	int prev;
        	boolean isPossible = true;
        	while (m > 0) {
        		prev = m;
	        	for (int r=0; r<R && m>0; r++) {
	        		for (int c=0; c<C && m>0; c++) {
	        			if (board[r][c] >= 0) {
	        				placeMine(board, r, c);
	        				if (isPossible(board)) {
	        					m--;
	        				} else {
	        					removeMine(board, r, c);
	        				}
	        			}
	        		}
	        	}
	        	if (prev == m) {
	        		isPossible = false;
	        		break;
	        	}
        	}
        	
        	output.format("Case #%d:\n", caseNum);
        	if (isPossible) {
        		boolean isFirst = true;
	        	for (int r=0; r<R; r++) {
	        		for (int c=0; c<C; c++) {
	        			if (board[r][c] == -1) {
	        				output.print("*");
	        			} else if (board[r][c] == 0 && isFirst) {
	        				output.print("c");
	        				isFirst = false;
	        			} else {
	        				output.print(".");
	        			}
	        		}
	        		output.format("\n");
	        	}
        	} else {
        		output.print("Impossible\n");
        	}
        }
        
        input.close();
        output.close();
	}
	
	public static void placeMine(int[][] board, int r, int c) {
		board[r][c] = -1;
		for (int i=r-1; i<=r+1; i++) {
			for (int j=c-1; j<=c+1; j++) {
				if (i==r && j==c) continue;
				plusOne(board, i, j);
			}
		}
	}
	
	public static void plusOne(int[][] board, int r, int c) {
		try {
			if (board[r][c] >= 0) board[r][c] += 1;
		} catch (IndexOutOfBoundsException e) {
		}
	}
	
	public static void removeMine(int[][] board, int r, int c) {
		int mines = 0;
		for (int i=r-1; i<=r+1; i++) {
			for (int j=c-1; j<=c+1; j++) {
				if (i==r && j==c) continue;
				minusOne(board, i, j);
				try {
					if (board[i][j] == -1) mines++;
				} catch (IndexOutOfBoundsException e) {
				}
			}
		}
		board[r][c] = mines;
	}
	
	public static void minusOne(int[][] board, int r, int c) {
		try {
			if (board[r][c] >= 0) board[r][c] -= 1;
		} catch (IndexOutOfBoundsException e) {
		}
	}
	
	public static boolean isPossible(int[][] board) {
		int[][] b = new int[board.length][board[0].length];
		
		boolean isFirst = true;
		for (int i=0; i<board.length; i++) {
			for (int j=0; j<board[0].length; j++) {
				if (board[i][j] == 0 && isFirst) {
					b[i][j] = -2;
					isFirst = false;
				} else {
					b[i][j] = board[i][j];
				}
			}
		}
		
		if (isFirst) return false;
		
		boolean isExpanded = false;
		while(true) {
			isExpanded = false;
			for (int i=0; i<b.length; i++) {
				for (int j=0; j<b[0].length; j++) {
					if (b[i][j] == -2) {
						isExpanded |= expand(b, i, j);
					}
				}
			}
			
			if (!isExpanded) break;
		}
		
		boolean isPossible = true;
		for (int i=0; i<b.length && isPossible; i++) {
			for (int j=0; j<b[0].length && isPossible; j++) {
				if (b[i][j] >= 0) {
					isPossible = false;
				}
			}
		}
		
		return isPossible;
	}
	
	public static boolean expand(int[][] board, int r, int c) {
		boolean isExpanded = false;

		for (int i=r-1; i<=r+1; i++) {
			for (int j=c-1; j<=c+1; j++) {
				if (i==r && j==c) continue;
				try {
					if (board[i][j] >= 0) {
						board[i][j] = -2;
						isExpanded = true;
					}
				} catch (IndexOutOfBoundsException e) {
				}
			}
		}
		
		return isExpanded;
	}
}
