import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Scanner;

public class ProblemD {
    //private static final String FILENAME = "D-sample";
    private static final String FILENAME = "D-small-attempt0";
    //private static final String FILENAME = "D-large";

	public static void main(String[] args) throws Exception {
		Scanner input = new Scanner(new FileReader(FILENAME + ".in"));
        PrintWriter output = new PrintWriter(new FileWriter(FILENAME + ".out"));

        long start = System.currentTimeMillis();
        int testCase = input.nextInt();
        for (int t=1; t<=testCase; t++) {
        	int N = input.nextInt();
        	int M = input.nextInt();
        	char[][] stage = new char[N][N];
        	boolean[][][] occu = new boolean[N][N][4]; // 0:- 1:| 2:/ 3:\
        	int point = 0;
        	
        	for (int i=0; i<M; i++) {
        		char type = input.next().charAt(0);
        		int R = input.nextInt();
        		int C = input.nextInt();
        		stage[R-1][C-1] = type;
        		
        		if (type == 'o' || type == 'x') {
        			fillPlus(R-1, C-1, occu);
        			point++;
        		}
        		if (type == 'o' || type == '+') {
        			fillX(R-1, C-1, occu);
        			point++;
        		}
        	}

        	String addStr = "";
        	int addCnt = 0;
        	for (int r=0; r<N; r++) {
        		for (int c=0; c<N; c++) {
        			if (stage[r][c] == 0 && !occu[r][c][0] && !occu[r][c][1] && !occu[r][c][2] && !occu[r][c][3]) {
        				stage[r][c] = 'o';
            			fillPlus(r, c, occu);
            			fillX(r, c, occu);
            			point += 2;
        				addStr += "o " + (r+1) + " " + (c+1) + "\n";
        				addCnt++;
        			}
        		}
        	}
        	for (int r=0; r<N; r++) {
        		for (int c=0; c<N; c++) {
        			if (stage[r][c] == 0 && !occu[r][c][0] && !occu[r][c][1]) {
        				stage[r][c] = 'x';
            			fillPlus(r, c, occu);
            			point++;
        				addStr += "x " + (r+1) + " " + (c+1) + "\n";
        				addCnt++;
        			} else if (stage[r][c] == '+' && !occu[r][c][0] && !occu[r][c][1]) {
        				stage[r][c] = 'o';
            			fillPlus(r, c, occu);
            			point++;
        				addStr += "o " + (r+1) + " " + (c+1) + "\n";
        				addCnt++;
        			} else if (stage[r][c] == 0 && !occu[r][c][2] && !occu[r][c][3]) {
        				stage[r][c] = '+';
            			fillX(r, c, occu);
            			point++;
        				addStr += "+ " + (r+1) + " " + (c+1) + "\n";
        				addCnt++;
        			} else if (stage[r][c] == 'x' && !occu[r][c][2] && !occu[r][c][3]) {
        				stage[r][c] = 'o';
            			fillX(r, c, occu);
            			point++;
        				addStr += "o " + (r+1) + " " + (c+1) + "\n";
        				addCnt++;
        			}
        		}
        	}

        	output.print("Case #" + t + ": ");
        	output.print(point + " " + addCnt + "\n");
        	output.print(addStr);
        }
        System.out.printf("Total duration: %dms\n", System.currentTimeMillis() - start);

        input.close();
        output.close();
	}
	
	private static void fillPlus(int R, int C, boolean[][][] occu) {
		for (int c=0; c<occu[R].length; c++) {
			occu[R][c][0] = true;
		}
		for (int r=0; r<occu.length; r++) {
			occu[r][C][1] = true;
		}
	}

	private static void fillX(int R, int C, boolean[][][] occu) {
		int r, c;

		r = R; c = C;
		while(r < occu.length && c >= 0) {
			occu[r][c][2] = true;
			r++; c--;
		}
		r = R; c = C;
		while(r >= 0 && c < occu[0].length) {
			occu[r][c][2] = true;
			r--; c++;
		}
		r = R; c = C;
		while(r >= 0 && c >=0) {
			occu[r][c][3] = true;
			r--; c--;
		}
		r = R; c = C;
		while(r < occu.length && c < occu[0].length) {
			occu[r][c][3] = true;
			r++; c++;
		}
	}
}