import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Scanner;

public class ProblemD {
    private static final String INPUT_FILENAME = "D-small-attempt0.in";
    private static final String OUTPUT_FILENAME = "D-small-attempt0.out";

	public static void main(String[] args) throws Exception {
		Scanner input = new Scanner(new FileReader(INPUT_FILENAME));
        PrintWriter output = new PrintWriter(new FileWriter(OUTPUT_FILENAME));
            
        int numberOfTestCase = input.nextInt();
        for (int caseNum=1; caseNum<=numberOfTestCase; caseNum++) {
        	int M = input.nextInt();
        	int N = input.nextInt();
        	String[] S = new String[M];
        	ArrayList<?>[] nodes = new ArrayList<?>[M];
        	for (int i=0; i<M; i++) {
        		S[i] = input.next();
        		ArrayList<String> subsets = new ArrayList<String>();
        		for (int j=0; j<S[i].length()+1; j++) {
        			subsets.add(S[i].substring(0, j));
        		}
        		nodes[i] = subsets;
        	}
        	
        	HashSet<?>[] servers = new HashSet<?>[N];
        	for (int i=0; i<N; i++) {
        		servers[i] = new HashSet<String>();
        	}

        	int worst = -1;
        	int c = 0;
        	int s, sIdx, sum;
        	HashSet<String> sv;
        	int lim = (int) Math.pow(N, M);
        	for (int i=0; i<lim; i++) {
        		for (int j=0; j<N; j++) {
            		servers[j].clear();
            	}
        		
        		s = i;
        		for (int j=0; j<M; j++) {
        			 sIdx = s % N;
        			 s = s / N;
        			 sv = (HashSet<String>) servers[sIdx];
        			 for(Object node : nodes[j]) {
        				 sv.add((String) node);
        			 }
        		}

        		sum = 0;
        		for (int j=0; j<N; j++) {
            		sum += servers[j].size();
            	}
        		
        		if (sum > worst) {
        			worst = sum;
        			c = 1;
        		} else if (sum == worst) {
        			c++;
        		}
        	}

        	output.format("Case #%d: %d %d\n", caseNum, worst, c);
        }
        
        input.close();
        output.close();
	}
}
