import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class ProblemB {
    //private static final String FILENAME = "B-sample";
    //private static final String FILENAME = "B-small-attempt0";
    private static final String FILENAME = "B-large";

	public static void main(String[] args) throws Exception {
		Scanner input = new Scanner(new FileReader(FILENAME + ".in"));
        PrintWriter output = new PrintWriter(new FileWriter(FILENAME + ".out"));

        long start = System.currentTimeMillis();
        int testCase = input.nextInt();
        for (int t=1; t<=testCase; t++) {
        	int N = input.nextInt();
        	int P = input.nextInt();
        	int[] R = new int[N];
        	for (int i=0; i<N; i++) {
        		R[i] = input.nextInt();
        	}
        	int[][] Q = new int[N][P];
        	for (int i=0; i<N; i++) {
            	for (int j=0; j<P; j++) {
            		Q[i][j] = input.nextInt();
            	}
            	Arrays.sort(Q[i]);
        	}
        	
        	int[] idx = new int[N];
        	int count = 0;
        	for (int p=0; p<P; p++) {
        		if (hasValidSet(R, Q, idx, p)) {
        			count++;
        		}
        	}
        	
        	output.print("Case #" + t + ": " + count + "\n");
        }
        System.out.printf("Total duration: %dms\n", System.currentTimeMillis() - start);

        input.close();
        output.close();
	}
	
	private static boolean hasValidSet(int[] R, int[][] Q, int[] idx, int p) {
		int minServe = (int)Math.ceil(Q[0][p] / (R[0] * 1.1));
		int maxServe = (int)Math.floor(Q[0][p] / (R[0] * 0.9));
		if (minServe > maxServe || Q[0][p] < (minServe * (R[0] * 0.9)) || Q[0][p] > (maxServe * (R[0] * 1.1))) return false;

		int N = R.length;
		int P = Q[0].length;
		for (int s=minServe; s<=maxServe; s++) {
			int[] newIdx = Arrays.copyOf(idx, idx.length);
			boolean findAll = true;
			for (int i=1; i<N; i++) {
				int minValue = (int)Math.ceil((R[i] * 0.9) * s);
				int maxValue = (int)Math.floor((R[i] * 1.1) * s);
				boolean find = false;
				for (int j=newIdx[i]; j<P; j++) {
					if (Q[i][j] >= minValue && Q[i][j] <= maxValue) {
						newIdx[i] = j + 1;
						find = true;
						break;
					}
				}
				if (!find) {
					findAll = false;
					break;
				}
			}
			if (findAll) {
				for (int i=0; i<idx.length; i++) {
					idx[i] = newIdx[i];
				}
				return true;
			}
		}

		return false;
	}
}