import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Scanner;

public class ProblemB {
    private static final String INPUT_FILENAME = "B-small-attempt0.in";
    private static final String OUTPUT_FILENAME = "B-small-attempt0.out";

	public static void main(String[] args) throws Exception {
		Scanner input = new Scanner(new FileReader(INPUT_FILENAME));
        PrintWriter output = new PrintWriter(new FileWriter(OUTPUT_FILENAME));
            
        int numberOfTestCase = input.nextInt();
        for (int caseNum=1; caseNum<=numberOfTestCase; caseNum++) {
        	int N = input.nextInt();
        	int[] A = new int[N];
        	int max = 0;
        	int mIdx = -1;
        	for (int i=0; i<N; i++) {
        		A[i] = input.nextInt();
        		if (A[i] > max) {
        			max = A[i];
        			mIdx = i;
        		}
        	}
        	int smax = 0;
        	int sIdx = -1;
        	for (int i=0; i<N; i++) {
        		if (A[i] == max) continue;
        		if (A[i] > smax) {
        			smax = A[i];
        			sIdx = i;
        		}
        	}
        	
        	int c = 0;
        	while(Math.abs(mIdx-sIdx) > 1) {
        		if (mIdx > sIdx) {
        			swap(A, mIdx, mIdx-1);
        			mIdx--;
        		} else {
        			swap(A, mIdx, mIdx+1);
        			mIdx++;
        		}
        		c++;
        	}
        	
        	c += getCnt(A, mIdx);
        	output.format("Case #%d: %d\n", caseNum, c);
        }
        
        input.close();
        output.close();
	}
	
	public static void swap(int[] A, int a, int b) {
		int tmp = A[a];
		A[a] = A[b];
		A[b] = tmp;
	}
	
	public static int getCnt(int[] A, int mIdx) {
    	int N = A.length;
    	int[] left = new int[mIdx];
    	int[] right = new int[N - 1 - mIdx];
    	for (int i=0; i<left.length; i++) {
    		left[i] = A[i];
    	}
    	for (int i=0; i<right.length; i++) {
    		right[i] = A[N-1-i];
    	}
		return getSwapCnt(left) + getSwapCnt(right);
	}
	
	public static int getSwapCnt(int[] array) {
		int N = array.length;
		int c = 0;
		for (int i=0; i<N-1; i++) {
	    	int max = 0;
	    	int mIdx = -1;
	    	for (int j=0; j<N-i; j++) {
	    		if (array[j] > max) {
	    			max = array[j];
	    			mIdx = j;
	    		}
	    	}
	    	if (mIdx == N-1-i) continue;
	    	for (int j=mIdx+1; j<N-i; j++) {
	    		array[j-1] = array[j];
	    		c++;
	    	}
		}
    	return c;
	}
}
