import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Scanner;

public class ProblemA {
    //private static final String FILENAME = "A-sample";
    private static final String FILENAME = "A-small-attempt0";
    //private static final String FILENAME = "A-large";

	public static void main(String[] args) throws Exception {
		Scanner input = new Scanner(new FileReader(FILENAME + ".in"));
        PrintWriter output = new PrintWriter(new FileWriter(FILENAME + ".out"));

        long start = System.currentTimeMillis();
        int testCase = input.nextInt();
        for (int t=1; t<=testCase; t++) {
        	int R = input.nextInt();
        	int C = input.nextInt();
        	char[][] grid = new char[R][C];
        	for (int r=0; r<R; r++) {
        		String rowStr = input.next();
        		for (int c=0; c<C; c++) {
        			grid[r][c] = rowStr.charAt(c);
        		}
        	}

        	boolean[] expanded = new boolean['Z' - 'A' + 1];
        	for (int r=0; r<R; r++) {
        		for (int c=0; c<C; c++) {
        			if (grid[r][c] != '?' && !expanded[grid[r][c] - 'A']) {
        				expand(grid, r, c);
        				expanded[grid[r][c] - 'A'] = true;
        			}
        		}
        	}

        	output.print("Case #" + t + ":\n");
        	for (int r=0; r<R; r++) {
        		for (int c=0; c<C; c++) {
        			output.print(grid[r][c]);
        		}
    			output.print("\n");
        	}
        }
        System.out.printf("Total duration: %dms\n", System.currentTimeMillis() - start);

        input.close();
        output.close();
	}
	
	private static void expand(char[][] grid, int ir, int ic) {
		char sel = grid[ir][ic];
		int sr = ir, er = ir;
		int sc = ic, ec = ic;
		
		while(sc > 0 && grid[ir][sc-1] == '?') {
			grid[ir][sc-1] = sel;
			sc--;
		}
		while(ec < (grid[0].length - 1) && grid[ir][ec+1] == '?') {
			grid[ir][ec+1] = sel;
			ec++;
		}
		while(sr > 0) {
			boolean isPossible = true;
			for (int c=sc; c<=ec; c++) {
				if (grid[sr-1][c] != '?') {
					isPossible = false;
					break;
				}
			}
			if (isPossible) {
				for (int c=sc; c<=ec; c++) {
					grid[sr-1][c] = sel;
				}
				sr--;
			} else {
				break;
			}
		}
		while(er < (grid.length - 1)) {
			boolean isPossible = true;
			for (int c=sc; c<=ec; c++) {
				if (grid[er+1][c] != '?') {
					isPossible = false;
					break;
				}
			}
			if (isPossible) {
				for (int c=sc; c<=ec; c++) {
					grid[er+1][c] = sel;
				}
				er++;
			} else {
				break;
			}
		}
	}
}