import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

/**
 * @author Mark Devine
 * 
 */
public class B {
	static final boolean DEBUG = false;
	static Scanner in;
	static List<PrintStream> out;

	public static void main(String[] args) throws FileNotFoundException {
		out = new ArrayList<PrintStream>();
		out.add(System.out);
		if (DEBUG) {
			in = new Scanner(new File("t"));
		} else {
			in = new Scanner(new File(B.class.getName() + ".in"));
			out.add(new PrintStream(B.class.getName() + ".out"));
		}
		int T = i();
		for (int i = 0; i < T; i++) {
			pf("Case #%d: %s\n", i + 1, solve());
		}
		d("Done");
		in.close();
		for (PrintStream ps : out) {
			ps.close();
		}
	}

	static String solve() {
		int E = i();
		int R = i();
		int N = i();

//		 d(E + " " + R + " " + N);
		int[] v = new int[N];
		int[] max = new int[N];
		int total = 0;
		int burn = Math.max(0, E - R);

		for (int i = 0; i < N; i++) {
			v[i] = i();
			max[i] = E;
		}

//		d(Arrays.toString(v));

		return get(v, max, 10, 0, burn, R) + "";
	}

	static int get(int[] v, int[] max, int m, int total, int burn, int R) {
		int best = 0;
		if (m <= 0) {
			return total;
		}
		boolean any = false;
		for (int i = 0; i < v.length; i++) {
			if (v[i] == m) {
				int used = max[i];
				if (used > 0) {
					any = true;
					int[] tmpMax = Arrays.copyOf(max, max.length);
					for (int j = 0; j + i < v.length; j++) {
						tmpMax[j + i] = Math.max(0, Math.min(R * j, tmpMax[j + i]));
					}
					for (int j = 0; i - j >= 0; j++) {
						tmpMax[i - j] -= burn;
						tmpMax[i - j] = Math.max(0, tmpMax[i - j]);
					}
//					d(Arrays.toString(tmpMax) + " " + (total + used * m));
					int res = get(v, tmpMax, m, used * m, burn, R);
					best = Math.max(res, best);
				}
			}
		}
		if (!any) {
			return get(v, max, m - 1, total, burn, R);
		}
		return total + best;
	}

	static void p(String x) {
		for (PrintStream ps : out) {
			ps.print(x);
		}
	}

	static void pl(String x) {
		for (PrintStream ps : out) {
			ps.println(x);
		}
	}

	static void pf(String format, Object... args) {
		for (PrintStream ps : out) {
			ps.printf(format, args);
		}
	}

	static String f(String format, Object... args) {
		return String.format(format, args);
	}

	static void d(String x) {
		System.out.println(x);
	}

	static int i() {
		return in.nextInt();
	}

	static long l() {
		return in.nextLong();
	}

	static String s(String pattern) {
		return in.next(pattern);
	}

	static String li() {
		return in.nextLine();
	}
}