import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * @author Mark Devine
 * 
 */
public class B {
	static final boolean DEBUG = false;
	static Scanner in;
	static List<PrintStream> out;
	static final int MAX_PANCAKES = 9;

	public static void main(String[] args) throws FileNotFoundException {
		out = new ArrayList<PrintStream>();
		out.add(System.out);
		if (DEBUG) {
			in = new Scanner(new File("t"));
		} else {
			in = new Scanner(new File(B.class.getName() + ".in"));
			out.add(new PrintStream(B.class.getName() + ".out"));
		}
		int T = i();
		for (int i = 0; i < T; i++) {
			pf("Case #%d: %s\n", i + 1, solve());
		}
		System.out.println("Done");
		in.close();
		for (PrintStream ps : out) {
			ps.close();
		}
	}

	static String solve() {
    int diners = i();
    // indexed by stack height
    int[] pancakes = new int[MAX_PANCAKES + 1];
    for (int i = 0; i < diners; i++) {
      pancakes[i()]++;
    }
    int best = Integer.MAX_VALUE;
    int timeUsed = 0;
    for (int i = MAX_PANCAKES; i > 0; i--) {
      int platesAtSize = pancakes[i];
      if (platesAtSize == 0) {
        continue;
      }
      int stackHeight = i;
      int eatAllNow = stackHeight;
      best = Math.min(timeUsed + eatAllNow, best);
//      if (timeUsed + platesAtSize >= best) {
//        return best + "";
//      }
      timeUsed += platesAtSize;
      if (stackHeight %2 == 1) {
        pancakes[(stackHeight / 2) + 1] += platesAtSize;
        pancakes[stackHeight / 2] += platesAtSize;
      } else {
        pancakes[stackHeight / 2] += platesAtSize * 2;
      }
      // unnecessary
      pancakes[i] = 0;
    }
    best = Math.min(timeUsed, best);
    return best + "";
	}

	static void p(String x) {
		for (PrintStream ps : out) {
			ps.print(x);
		}
	}

	static void pl(String x) {
		for (PrintStream ps : out) {
			ps.println(x);
		}
	}

	static void pf(String format, Object... args) {
		for (PrintStream ps : out) {
			ps.printf(format, args);
		}
	}

	static String f(String format, Object... args) {
		return String.format(format, args);
	}

	static int i() {
		return in.nextInt();
	}

	static long l() {
		return in.nextLong();
	}

	static String s(String pattern) {
		return in.next(pattern);
	}

	static String li() {
		return in.nextLine();
	}
}