import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * @author Mark Devine
 * 
 */
public class D {
  static final boolean DEBUG = false;
  static Scanner in;
  static List<PrintStream> out;

  public static void main(String[] args) throws FileNotFoundException {
    out = new ArrayList<PrintStream>();
    out.add(System.out);
    if (DEBUG) {
      in = new Scanner(new File("t"));
    } else {
      in = new Scanner(new File(D.class.getName() + ".in"));
      out.add(new PrintStream(D.class.getName() + ".out"));
    }
    int T = i();
    for (int i = 0; i < T; i++) {
      pf("Case #%d: %s\n", i + 1, solve());
    }
    System.out.println("Done");
    in.close();
    for (PrintStream ps : out) {
      ps.close();
    }
  }

  static String solve() {
    int X = i();
    int R = i();
    int C = i();

    if (X == 4) {
      return possibleIf(R + C >= 7);
    }
    if (X == 3) {
      return possibleIf(((R*C) % 3 == 0) && (R > 1 && C > 1));
    }
    if (X == 2) {
      return possibleIf((R * C) % 2 == 0);
    }
    return possibleIf(true);
  }
  
  static String possibleIf(boolean possible) {
    return possible ? "GABRIEL" : "RICHARD";
  }

  static int deceitVal(List<Double> naomi, List<Double> ken) {
    int n = 0, k = 0, count = 0;
    while (n < naomi.size()) {
      while (n < naomi.size() && naomi.get(n) < ken.get(k)) {
        n++;
      }
      if (n < naomi.size()) {
        n++;
        k++;
        count++;
      }
    }
    return count;
  }

  static int regVal(List<Double> naomi, List<Double> ken) {
    int n = 0, k = 0, count = 0;
    while (k < ken.size()) {
      while (k < ken.size() && ken.get(k) < naomi.get(n)) {
        k++;
        count++;
      }
      if (k < ken.size()) {
        n++;
        k++;
      }
    }
    return count;
  }

  static void p(String x) {
    for (PrintStream ps : out) {
      ps.print(x);
    }
  }

  static void pl(String x) {
    for (PrintStream ps : out) {
      ps.println(x);
    }
  }

  static void pf(String format, Object... args) {
    for (PrintStream ps : out) {
      ps.printf(format, args);
    }
  }

  static String f(String format, Object... args) {
    return String.format(format, args);
  }

  static int i() {
    return in.nextInt();
  }

  static long l() {
    return in.nextLong();
  }

  static String s(String pattern) {
    return in.next(pattern);
  }

  static String li() {
    return in.nextLine();
  }
}