import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

/**
 * @author Mark Devine
 * 
 */
public class C {
  static final boolean DEBUG = false;
  static Scanner in;
  static List<PrintStream> out;

  public static void main(String[] args) throws FileNotFoundException {
    out = new ArrayList<PrintStream>();
    out.add(System.out);
    if (DEBUG) {
      in = new Scanner(new File("t"));
    } else {
      in = new Scanner(new File(C.class.getName() + ".in"));
      out.add(new PrintStream(C.class.getName() + ".out"));
    }
    int T = i();
    for (int i = 0; i < T; i++) {
      pf("Case #%d: %s\n", i + 1, solve());
    }
    System.out.println("Done");
    in.close();
    for (PrintStream ps : out) {
      ps.close();
    }
  }
  
  static boolean solveJ(char[] chars, int repetitions, int i) {
    // J
    Q gettingJ = null;
    Q first = null;
    boolean found = false;
    for (; i < chars.length * repetitions; i++) {
      Q current = Q.of(chars[i % chars.length]);
      if (gettingJ == null) {
        gettingJ = current;
        first = current;
      } else {
        gettingJ = gettingJ.multiply(current);
        if (!found && gettingJ.eq(first)) {
          return false;
        }
      }
      if (gettingJ.eq(Q.of('j'))) {
        found = true;
        if (solveK(chars, repetitions, i + 1)) {
          return true;
        }
      }
    }
    return false;
  }
  static boolean solveK(char[] chars, int repetitions, int i) {
    // K
    Q gettingK = null;
    for (; i < chars.length * repetitions; i++) {
      Q current = Q.of(chars[i % chars.length]);
      if (gettingK == null) {
        gettingK = current;
      } else {
        gettingK = gettingK.multiply(current);
      }
    }
    return (gettingK != null && gettingK.eq(Q.of('k')));
  }

  static String solve() {
    int length = i();
    int repetitions = i();
    char[] chars = s("[ijk]+").toCharArray();
    
    int i = 0;
    // I
    Q gettingI = null;
    Q first = null;
    boolean found = false;
    for (; i < chars.length * repetitions; i++) {
      Q current = Q.of(chars[i % chars.length]);
      if (gettingI == null) {
        gettingI = current;
        first = current;
      } else {
        gettingI = gettingI.multiply(current);
        if (!found && gettingI.eq(first)) {
          return "NO";
        }
      }
      if (gettingI.eq(Q.of('i'))) {
        found = true;
        if (solveJ(chars, repetitions, i + 1)) {
          return("YES");
        }
      }
    }
    return "NO";
  }

  static class Q {
    // 1, I, J, K
    int q;
    boolean negative;

    Q multiply(Q other) {
      boolean negative = false;
      negative ^= this.negative;
      negative ^= other.negative;
      Q result = table[q][other.q];
      negative ^= result.negative;
      result.negative = negative;
      return result;
    }

    static Q of(int index, boolean negative) {
      Q q = new Q();
      q.q = index;
      q.negative = negative;
      return q;
    }
    static Q of(char c) {
      if (c == 'i') {
        return Q.of(1, false);
      }
      if (c == 'j') {
        return Q.of(2, false);
      }
      return Q.of(3, false);
    }

    boolean eq(Q other) {
      return q == other.q && negative == other.negative;
    }

  }

  static final Q[][] table = new Q[][] {
      { Q.of(0, false), Q.of(1, false), Q.of(2, false), Q.of(3, false) },
      { Q.of(1, false), Q.of(0, true), Q.of(3, false), Q.of(2, true) },
      { Q.of(2, false), Q.of(3, true), Q.of(0, true), Q.of(1, false) },
      { Q.of(3, false), Q.of(2, false), Q.of(1, true), Q.of(0, true) } };

  static void p(String x) {
    for (PrintStream ps : out) {
      ps.print(x);
    }
  }

  static void pl(String x) {
    for (PrintStream ps : out) {
      ps.println(x);
    }
  }

  static void pf(String format, Object... args) {
    for (PrintStream ps : out) {
      ps.printf(format, args);
    }
  }

  static String f(String format, Object... args) {
    return String.format(format, args);
  }

  static int i() {
    return in.nextInt();
  }

  static long l() {
    return in.nextLong();
  }

  static String s(String pattern) {
    return in.next(pattern);
  }

  static String li() {
    return in.nextLine();
  }
}