import java.io.*;
import java.text.MessageFormat;
import java.util.*;

public class UniverseSaver {

    private HashSet<String> engines = new HashSet();
    private List<String> queries = new ArrayList();
    int switches = 0;

    public UniverseSaver(BufferedReader reader) throws IOException {
        int S = Integer.parseInt(reader.readLine());
        for (int i = 0; i < S; i++) {
            engines.add(reader.readLine());
        }
        int Q = Integer.parseInt(reader.readLine());
        for (int i = 0; i < Q; i++) {
            queries.add(reader.readLine());
        }
    }

    private int resolveCase() {
        Set activeEngines = new HashSet(engines);
        for (ListIterator<String> it = queries.listIterator(); it.hasNext();) {
            String query = it.next();
            activeEngines.remove(query);
            if (activeEngines.isEmpty()) {
                switches++;
                activeEngines = new HashSet(engines);
                activeEngines.remove(query);
            }
        }

        return switches;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader("data/A-large.in"));
        PrintWriter writer = new PrintWriter(new FileWriter("data/A-large.out"));

        try {
            int N = Integer.parseInt(reader.readLine());
            for (int i = 0; i < N; i++) {
                writer.println(MessageFormat.format("Case #{0}: {1}", i + 1, new UniverseSaver(reader).resolveCase()));
            }

        } finally {
            try {reader.close();} catch (IOException e) {}
            writer.close();
        }
    }


}
