package devn.gcj.test;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
import com.sun.jndi.url.dns.dnsURLContext;

public class Test
{
	public int tests;
	
	public final static int STAT_X = 0;
	public final static int STAT_O = 1;
	public final static int STAT_D = 2;
	public final static int STAT_NC = 3;
	
	public final static String statStr[] = {
		    "X won",
		    "O won",
		    "Draw",
		    "Game has not completed"
	};
	
	private int[] board;
	public ArrayList<int[]> cases;
	
	public Test(int x, Scanner f)
	{
		tests = x;
		cases = new ArrayList<>(tests);
		
		while (x > 0)
		{
			board = new int[16];
			f.nextLine();
			
			for (int j = 0; j < 4; j++)
			{
				String s = f.nextLine();
				
				for (int i = 0; i < s.length(); i++)
				{
					int a = 2;
					switch (s.charAt(i))
					{
					case 'X':
						a = 1;
						break;
					case 'O':
						a = -1;
						break;
					case 'T':
						a = 0;
						break;
					}
					board[j*4 + i] = a;
					
//					System.out.print(a + " ");
				}
//				System.out.println();
			}
//			System.out.println();
			
			cases.add(board);
			x--;
		}
	}
	
	private static int checkBoard(int[] b)
	{
		int c = 0, r = 0, t;
		boolean aDot = false;
		
		for (int i = 0; i < 4; i++)
		{
			c = 0; 
			r = 0;
			
			for (int j = 0; j < 4; j++)
			{
				if ((t = b[i*4 + j]) > 1)
				{
					r = 15;
				}
				else 
				{
					r += t;
				}
				
				if ((t = b[j*4 + i]) > 1)
				{
					c = 15;
				}
				else 
				{
					c += t;
				}
			}
			
			if (r == 4 || c == 4 || r == 3 || c == 3)
			{
				return STAT_X;
			}
			else if (r <= -3 || c <= -3)
			{
				return STAT_O;
			}
			
			aDot |= c > 10 || r > 10;
		}
		
		c = b[0] + b[5] + b[10] + b[15];
		r = b[12] + b[9] + b[6] + b[3];
		
		if (r == 4 || c == 4 || r == 3 || c == 3)
		{
			return STAT_X;
		}
		else if (r <= -3 || c <= -3)
		{
			return STAT_O;
		}
		
		return aDot ? STAT_NC : STAT_D;
	}
	
	/** 
	 * @param args
	 * @throws Throwable 
	 */
	public static void main(String[] args) throws Throwable
	{
		InputStream in = new FileInputStream("testL.in");
		Scanner f = new Scanner(in);
		
		Test test = new Test(f.nextInt(), f);
		
		for (int i = 0; i < test.tests; i++)
		{
			System.out.println(String.format("Case #%d: %s", i+1, statStr[checkBoard(test.cases.get(i))]));
		}
		
		f.close();
	}

}
