import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;


public class R1A1
{
	public static void main(String[] args) throws FileNotFoundException
	{
		Scanner in = new Scanner(new File(args[0]));
		in.useLocale(Locale.US);
		
		int n = in.nextInt();
		in.nextLine();
		for (int i = 0; i < n; i++)
		{
			int m = in.nextInt();
			in.nextLine();
			
			List<String> strings = new ArrayList<>(m);
			for (int j = 0; j < m; j++)
			{
				strings.add(in.nextLine());
			}
			
			System.out.println("Case #" + (i + 1) + ": " + getMoves(strings));
		}
		
		in.close();
	}

	private static String getMoves(List<String> strings)
	{
		int n = strings.size();
		int[][] r = new int[n][n];
		int minx = Integer.MAX_VALUE;
		int mini = -1;
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < n; j++)
			{
				if (i != j)
				{
					int x = isConvertable(strings.get(i).toCharArray(),
							strings.get(j).toCharArray());
					if (x < 0)
					{
						return "Fegla Won";
					}
					
					r[i][j] = x;
					if (x < minx)
					{
						minx = x;
						mini = i;
					}
				}
			}
		}
		int s = 0;
		for (int i = 0; i < n; i++)
		{
			s += r[mini][i];
		}
				
		return s + "";
	}
	
	private static int isConvertable(char[] a, char[] b)
	{
		int j = 0;
		int i = 0;
		int n = 0;
		
		while (i < a.length && j < b.length)
		{			
			if (a[i] == b[j])
			{
				j++;
				i++;
			}			
			else if (j > 0 && a[i] ==  b[j -1]) 
			{ // del from a
				n++;
				i++;
			}
			else if (j > b.length - 1 && a[i] ==  b[j + 1])
			{// add to a
				n++;
				j++;
			}
			else if (i > a.length - 1 && a[i + 1] == b[j]) 
			{
				n++;
				i++;
			}
			else if (i > 0 && a[i - 1] ==  b[j]) 
			{ // del from a
				n++;
				j++;
			}
			else 
			{
				return -1;
			}
		}
		
		if (j != b.length && i == a.length)
		{
			while (j < b.length)
			{
				if (a[i - 1] == b[j])
				{
					j++;
					n++;
				}
				else 
				{
					return -1;
				}
			}
		}
				
		if (i != a.length && j == b.length)
		{
			while (i < a.length)
			{
				if (a[i] == b[j - 1])
				{
					i++;
					n++;
				}
				else 
				{
					return -1;
				}
			}
		}
		
		if (i != a.length && j != b.length)
		{
			return -1;
		}
		
		return n;
	}
}
