import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.Locale;
import java.util.Queue;
import java.util.Scanner;
import java.util.SortedSet;
import java.util.TreeSet;


public class Test4
{
	private static final double QUANT = .0000001;
		
	private static int deceitful(TreeSet<Double> naomi, TreeSet<Double> ken)
	{
		int wins = 0;

		while (!naomi.isEmpty())
		{
			if (naomi.first() > ken.first())
			{
				naomi.pollFirst();
				ken.pollFirst();
				++wins;
				continue;
			}
			
			double k = ken.last();
			
			Double n = naomi.floor(k - QUANT);
			
			if (n == null)
			{ // naomi's smallest is greater than ken's biggest
				k = ken.pollFirst();
				n = naomi.ceiling(k + QUANT);
				naomi.remove(n);
				
				++wins;
			}
			else 
			{
				ken.pollLast();
				naomi.pollFirst();
			}
		}
		
		return wins;
	}
	
	private static int fair(TreeSet<Double> naomi, TreeSet<Double> ken)
	{
		int wins = 0;

		while (!naomi.isEmpty())
		{
			double n = naomi.pollFirst();
			Double k = ken.ceiling(n + QUANT);
			
			if (k == null)
			{
				ken.pollFirst();
				++wins;
			}
			else 
			{
				ken.remove(k);
			}
		}
		
		return wins;
	}
	
	public static void main(String[] args) throws FileNotFoundException
	{
		Scanner in = new Scanner(new File(args[0]));
		in.useLocale(Locale.US);
		
		TreeSet<Double> naomisBlocks = new TreeSet<>();
		TreeSet<Double> kensBlocks = new TreeSet<>();
		
		int n = in.nextInt();
		in.nextLine();
		for (int i = 0; i < n; i++)
		{
			int m = in.nextInt();
			in.nextLine();
			for (int j = 0; j < m ; j++)
			{
				naomisBlocks.add(in.nextDouble());
			}
			in.nextLine();
			for (int j = 0; j < m ; j++)
			{
				kensBlocks.add(in.nextDouble());
			}
			in.nextLine();

			System.out.println("Case #" + (i + 1) + ": " 
					+ deceitful(new TreeSet<>(naomisBlocks), new TreeSet<>(kensBlocks))
					+ " " + fair(naomisBlocks, kensBlocks));
		}
		
		in.close();
	}
}
