package devn.gcj.test;

import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Scanner;

public class Test4
{
	private final static String IMP = "IMPOSSIBLE";
	private static List<String> sols;
	
	private List<Integer> availKeys;
	private List<Integer> openedChests = new ArrayList<>();
	private List<Chest> availChests;
	
	public Test4(Integer[] availKeys, Chest[] availChests)
	{
		this.availKeys = new ArrayList<>(Arrays.asList(availKeys));
		
		this.availChests = new ArrayList<>(Arrays.asList(availChests));
	}

	public Test4(List<Integer> availKeys, List<Chest> availChests)
	{
		this.availKeys = new ArrayList<>(availKeys);
		
		this.availChests = new ArrayList<>(availChests);
	}
	
	public void openChests(List<Integer> chests)
	{
		openedChests.addAll(new ArrayList<>(chests));
	}
	
	public void openChest(Integer chest)
	{
		openedChests.add(chest);
	}
	

	public static boolean solved;
	
	public void getKeySeries()
	{
		List<Integer> toOpen = getOpenableChestsIds();

		Test4[] paths = new Test4[toOpen.size()];
		
		if (solved)
		{
			return;
		}
		
		Collections.sort(toOpen);
		
		for (int i = 0; i < toOpen.size(); i++)
		{
			int openedId = toOpen.get(i);
			
			paths[i] = new Test4(availKeys, availChests);
			paths[i].openChests(openedChests);
			paths[i].openChest(openedId);
			
			Chest c = availChests.get(openedId);
			
			paths[i].availKeys.remove((Object) c.getKeyToOpen());
			paths[i].availKeys.addAll(c.getContKeys());
			
			
//			System.out.println("use " + openedId +
//					" keys " + availKeys +
//					" deep " + (deep) + 
//					" rem " + (availChests.size() - openedChests.size()));
			
			paths[i].getKeySeries();
		}
		
		if (toOpen.isEmpty())
		{
			if (openedChests.size() < availChests.size()
				&& !sols.contains(IMP))
			{
				sols.add(IMP);
			}
			else 
			{
				StringBuilder sb = new StringBuilder();
				for (Integer sol : openedChests)
				{
					sb.append((sol + 1) + " ");
				}
				sols.add(sb.toString().substring(0, sb.length() - 1));
				solved = true;
			}
		}
	}
	
	private List<Integer> getOpenableChestsIds()
	{
		List<Integer> chests = new ArrayList<>();
				
		for (Integer k : availKeys)
		{
			for (Chest chest : availChests)			
			{
				if (!chests.contains(chest.getId())
				&& !openedChests.contains(chest.getId()) 
				&& chest.opensWith(k))
				{
					chests.add(chest.getId());
				}
			}
		}
		
//		System.out.println("openable " + chests.size());
		
		return chests;
	}
	
	@Override
	public String toString()
	{
		StringBuilder builder = new StringBuilder();
		builder.append("keys=");
		builder.append(availKeys);
		builder.append(" chests=");
		builder.append(availChests);
		builder.append("\n");
		return builder.toString();
	}

	public static void main(String[] args) throws Throwable
	{
		InputStream in = new FileInputStream("test4.in");
		Scanner f = new Scanner(in);
		
		Test4 t;
		Integer[] keys;
		Chest chests[];
		
		int tests = f.nextInt();

		for (int i = 0; i < tests; i++)
		{
			f.nextLine();
			
			int nKeys = f.nextInt();
			int nToOpen = f.nextInt();
			
			f.nextLine();
			
			keys = new Integer[nKeys];
			for (int k = 0; k < nKeys; k++)
			{
				keys[k] = f.nextInt();
			}
			
			f.nextLine();
			
			chests = new Chest[nToOpen];
			for (int k = 0; k < nToOpen; k++)
			{
				int tk = f.nextInt();
				int nCont = f.nextInt();
				
				chests[k] = new Chest(tk, k);
				
				while (nCont > 0)
				{
					chests[k].addKey(f.nextInt());
					nCont--;
				}
			}
			
			t = new Test4(keys, chests);
			Test4.sols = new ArrayList<>();
			solved = false;
			t.getKeySeries();
			
			Collections.sort(Test4.sols);
			
//			System.out.println(sols);
			
			System.out.println(String.format("Case #%d: %s", i+1, sols.get(0)));
		}
		
		f.close();
	}

	private static class Chest
	{
		private int id;
		private int keyToOpen;
		private List<Integer> contKeys;
		
		public Chest(int keyToOpen, int id)
		{
			this.keyToOpen = keyToOpen;
			this.id = id;
			
			this.contKeys = new ArrayList<>();
		}

		public Chest(int keyToOpen, List<Integer> contKeys, int id)
		{
			this.keyToOpen = keyToOpen;
			this.contKeys = contKeys;
			this.id = id;
		}

		public boolean opensWith(int t)
		{
			return keyToOpen == t;
		}

		public int getKeyToOpen()
		{
			return keyToOpen;
		}

		public int getId()
		{
			return id;
		}

		public List<Integer> getContKeys()
		{
			List<Integer> copy = new ArrayList<>(contKeys);

			return copy;
		}
		
		public void addKey(int k)
		{
			contKeys.add(k);
		}

		@Override
		public boolean equals(Object obj)
		{
			if (this == obj)
			{
				return true;
			}
			if (obj == null)
			{
				return false;
			}
			if (!(obj instanceof Chest))
			{
				return false;
			}
			Chest other = (Chest) obj;
			
			return getId() == other.getId();
		}

		@Override
		public String toString()
		{
			StringBuilder builder = new StringBuilder();
			
			builder.append("(");
			builder.append(keyToOpen);
			builder.append("-->>");
			builder.append(contKeys);
			builder.append(")");
			
			return builder.toString();
		}
	}
}
