package codejam_2016;

import java.io.*;
import java.util.HashSet;
import java.util.Set;

public class CountSheep {
	public static void main(String args[]){
		BufferedReader br;
		String fileName = "A-small-attempt0.in";
		String line = "";
		int testCount = 1;
		
		try{
			br = new BufferedReader(new FileReader(fileName));
			line = br.readLine();
			int totalN = Integer.parseInt(line);
			
			while ((line = br.readLine()) != null){
				testCase(line,testCount++);
			}
		}
		
		catch(Exception e){
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	} //end main
	
	public static void testCase(String line, int testCount) throws Exception{
		if (Integer.parseInt(line) == 0){
			printInsomnia(testCount);
			return;
		}
		
		int tempInt = -1;
		
		Set<Integer> set = new HashSet<Integer>();
		for (int i=0; i<line.length(); i++){
			tempInt = line.charAt(i);
			set.add(tempInt);
		}
		int distinctCount = set.size();
		int count = 2;
		int number = Integer.parseInt(line);
		
		try{
			while (true){
				distinctCount = iteration(set, number, testCount, count);
				if(distinctCount != 10)
					count++;
				else
					break;
			}
			printCompleted(testCount,count*number);
		}
		catch(RuntimeException e){
			printInsomnia(testCount);
		}
		catch(Exception e){
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}
	
	public static int iteration(Set set, int number, int testCount, int count) throws RuntimeException, Exception{
		long tempNum = number * count;
		if (tempNum > Integer.MAX_VALUE)
			throw new RuntimeException("exceeded max int value");
		
		String tempNumStr = Long.toString(tempNum);
		int tempInt = -1;
		for (int i=0; i<tempNumStr.length();i++){
			tempInt = tempNumStr.charAt(i);
			set.add(tempInt);
		}
			
		return set.size();
	}
	
	public static void printInsomnia(int testCount){
		System.out.println("Case #"+testCount+": "+ "INSOMNIA");
	}
	
	public static void printCompleted(int testCount, int count){
		System.out.println("Case #"+testCount+": "+ count);
	}
}
