package com.devon;

import java.io.InputStream;
import java.util.Scanner;

public class PartElf {

	private static class Ratio {
		long p,q;
		
		public Ratio(long p, long q) {
			super();
			this.p = p;
			this.q = q;
		}

		int compare(Ratio r1) {
			return Long.compare(p * r1.q, q*r1.p);
		}
		
		void normalize2()
		{
			while(p % 2 ==0 && q %2 ==0) {
				p=p/2;
				q=q/2;
			}
		}
		
		
	}
	
	public void go(InputStream is) {
		Scanner s = new Scanner(is);
		int count = s.nextInt();
		for(int i=0;i<count;i++) {
			String row = s.next();
			String[] pqs= row.split("/");
			
			long p = Long.valueOf(pqs[0]);
			long q = Long.valueOf(pqs[1]);
			
			long a= min(p,q);
			System.out.println("Case #"+(i+1)+": " +  (a==-1 ? "impossible" : String.valueOf(a)));
		}
		
	}

	private long min(long p, long q) {
		Ratio ratio = new Ratio(p, q);
		ratio.normalize2();
//		 if(!isPowerOf2(q)) {
//			 return -1;
//		 }
		 
		 for(int i=0;i<=40;i++) {
			 Ratio upper = new Ratio(1, pow2(i));
			 Ratio lower = new Ratio(1, pow2(i+1));
			 
			 if(upper.compare(ratio) > 0 && lower.compare(ratio) <=0) {
				 return i+1;
			 }
		 }
		 
		 
		 return -1;
	}
	
	private long pow2(int i) {
		long r = 1;
		while(i > 0) {
			i--;
			r=r*2;
		}
		
		return r;
	}

	private int log2(long q) {
		if(q<=0) {
			throw new RuntimeException("Log of 0 or negative not defined");
		}
		
		int power = 0;
		while(q>0) {
			q = q >> 1;
			power++;
		}
		
		return power;
	}
	
	private boolean isPowerOf2(long q)
	{
		int ones = 0;
		while(q>0) {
			q = q >> 1;
			if((q & 1l) == 1l) {
				ones ++;
			}
		}
		
		return ones == 1;
	}

}
