package fairAndSquare;

import java.math.BigInteger;
import java.util.Scanner;

public class FairAndSquare {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
//		System.out.println(getNumberFairAndSquare("100"));
//		System.out.println(getNumberFairAndSquare("1024348434201"));
		
		
		
		Scanner sc = new Scanner(FairAndSquare.class.getResourceAsStream("C-large-1.in"));
		
		int count = sc.nextInt();
		for(int i=0;i<count;i++) {
			String minS = sc.next();
			String maxS = sc.next();
			
			String minsS = new BigInteger(minS).subtract(BigInteger.ONE).toString();
		
			BigInteger result = getNumberFairAndSquare(maxS).subtract(getNumberFairAndSquare(minsS));
			System.out.println("Case #"+(i+1)+": "+ result.toString());
		}
		sc.close();

	}
	
	
	private static String genNumber(int i) {
		StringBuilder b = new StringBuilder("1");
		for(int j=0;j<i;j++) {
			b.append("0");
		}
		System.out.println(b);
		return b.toString();
	}


	private static BigInteger getNumberFairAndSquare(String number)
	{
		if(number.length() <=3) { // hard coded
			int value = Integer.parseInt(number);
			if(value==0) {
				return BigInteger.ZERO;
			}
			if(value<=3) {
				return BigInteger.ONE;
			}
			if(value<=8) {
				return BigInteger.valueOf(2L);
			}
			if(value<=120) {
				return BigInteger.valueOf(3L);
			}
			if(value<=483) {
				return BigInteger.valueOf(4L);
			}
			if(value<=1000) {
				return BigInteger.valueOf(5L);
			}
		}
		BigInteger result = BigInteger.valueOf(5L);
		for(int i=4;i<number.length();i++) {
			result = result.add(getWholeCount(i));
		}
		
		result =result.add(getPartCount(number));
		
		
		return result;
	}

	private static BigInteger getWholeCount(int i) {
		if(((i-1) % 2) !=0) {
			return BigInteger.ZERO;
		}
		int n = ((i-1)/ 2) +1;
		
		boolean even = n % 2 == 0;
		
		BigInteger result = BigInteger.ZERO;
		result = result.add(even ? BigInteger.ONE : BigInteger.valueOf(2L)) ; // 200...0...002 or also 200...100...2 
		BigInteger ones = BigInteger.valueOf(2L).pow(even ? n / 2 -1 : ((n-1) / 2)-1).multiply(even ? BigInteger.ONE : BigInteger.valueOf(3));
		result = result.add(ones);
		
		return result;
	}
	
	private static BigInteger getPartCount(String number) {
		int i= number.length();
		
		if(((i-1) % 2) !=0) {
			return BigInteger.ZERO;
		}
		
		int n = ((i-1)/ 2) + 1;
		
		boolean even = n % 2 == 0;
		
		BigInteger numberInteger = new BigInteger(number);
		
		if(square(build2(n,true)).compareTo(numberInteger) <= 0) {
			return getWholeCount(i);
		}
		
		if(!even && square(build2(n,false)).compareTo(numberInteger) <= 0) {
			return getWholeCount(i).subtract(BigInteger.ONE);
		}
		

		int range = even ? n / 2 -1 : ((n-1) / 2)-1;
		int subpartWidth = even ? n / 2 -1 : ((n-1) / 2)-1;
		return findSmallerOrEqual(numberInteger, BigInteger.ZERO, range , even, subpartWidth);
	}

	private static BigInteger findSmallerOrEqual(BigInteger numberInteger, BigInteger position, int range, boolean even, int subpartWidth)
	{
		if(range ==0) {
			return BigInteger.valueOf(evaluatePosition(numberInteger, position, even,subpartWidth));
		}
		
		BigInteger middlePosition = position.add(BigInteger.valueOf(2).pow(range-1));
		BigInteger lastFromHalfRange = middlePosition.subtract(BigInteger.ONE);
		int middle = evaluatePosition(numberInteger, lastFromHalfRange, even,subpartWidth);
		if(middle == (even ? 1 : 3)) {
			// je v druhej polke
			return BigInteger.valueOf(2).pow(range-1).multiply(even ? BigInteger.ONE : BigInteger.valueOf(3)).add(findSmallerOrEqual(numberInteger, middlePosition, range-1, even,subpartWidth));
		} else {
			return findSmallerOrEqual(numberInteger, position, range-1, even,subpartWidth); 
		}
		
	}
	
	private static int evaluatePosition(BigInteger numberInteger,
			BigInteger position, boolean even, int subpartWidth) {

		
		if(even) {
			if(square(build1(even, position,2,subpartWidth)).compareTo(numberInteger) <= 0) {
				return 1;
			}
		} else {
			for(int i=2;i>=0;i--) {
				if(square(build1(even, position,i,subpartWidth)).compareTo(numberInteger) <= 0) {
					return i+1;
				}
			}
		}
		return 0;
	}


	private static boolean isFair(long sq) {
		String s = String.valueOf(sq);
		StringBuffer buf = new StringBuffer(s);
		return buf.reverse().toString().equals(s);
	}
	
	private static BigInteger build2(int n, boolean second)
	{
		boolean even= n % 2 ==0;
		if(even || !second) {
			return new BigInteger("2" + repeat("0", n-2) + "2");
		} else {
			String middle = repeat("0", (n-3)/2);
			return new BigInteger("2" +  middle + "1" + middle + "2");
		}
	}

	private static BigInteger build1(boolean even, BigInteger order, int suborder, int subpartWidth)
	{
		String orderS = addZeroes(order.toString(2), subpartWidth);
		
		String orderSR = new StringBuilder(orderS).reverse().toString();
		
		return new BigInteger("1" + orderS + (even ? "" : suborder) + orderSR + "1");
	}
	
	private static String addZeroes(String string, int subpartWidth) {
		if(subpartWidth == 0) {
			return "";
		} 
		return repeat("0", subpartWidth-string.length())+string;
	}


	private static String repeat(String s, int count)
	{
		StringBuilder b=  new StringBuilder();
		for(int i=0;i<count;i++) {
			b.append(s);
		}
		return b.toString();
	}
	
	private static BigInteger square(BigInteger integer)
	{
		return integer.multiply(integer);
	}

	private static void generate()
	{
//		int j=0;
//		for(long i=1;i<10000000;i++) {
//			if(isFair(i)) {
//				long sq = i*i;
//				boolean sqAndF = isFair(sq);
//				if(sqAndF) {
//					System.out.println(j+ ".  "+ i+ " fair => " +sq + " - " + (sqAndF));
//					j++;
//				}
//				
//			}
//		}
	}
}
