package lawnmower;


import java.util.Scanner;

public class Lawnmower {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
	Scanner sc = new Scanner(Lawnmower.class.getResourceAsStream("B-small-attempt0.in"));
		
		int count = sc.nextInt();
		for(int i=0;i<count;i++) {
			int[][] lawn = readLawn(sc);
		
			boolean result = canMakePattern(lawn);
		
			System.out.println("Case #"+(i+1)+": "+ (result ? "YES" : "NO"));
		}

	}

	private static boolean canMakePattern(int[][] lawn) {
		boolean result = true;
		Maxs maxs = getMaxs(lawn);
		for(int r=0;r<lawn.length;r++) {
			for(int c=0;c<lawn[r].length;c++) {
				result = result && (maxs.r[r] == lawn[r][c] || maxs.c[c] == lawn[r][c]);
			}
		}
		return result;
	}

	
	private static Maxs getMaxs(int[][] lawn) {
		Maxs result = new Maxs();
		result.r = new int[lawn.length];
		result.c = new int[lawn[0].length];
		
		for(int r=0;r<lawn.length;r++) {
			for(int c=0;c<lawn[r].length;c++) {
				if(result.r[r] < lawn[r][c]) {
					result.r[r] = lawn[r][c];
				}
				if(result.c[c] < lawn[r][c]) {
					result.c[c] = lawn[r][c];
				}
			}
		}
		
		return result;
	}



	private static class Maxs
	{
		int r[];
		int c[];
	}

	private static int[][] readLawn(Scanner sc) {
		int n = sc.nextInt();
		int m = sc.nextInt();
		
		int[][] result = new int[n][m];
		
		for(int ni=0;ni<n;ni++) {
			for(int mi=0;mi<m;mi++) {
				result[ni][mi] = sc.nextInt();
			}
		}
		
		return result;
	}

}
