import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

public class Main {

    private static String FILE_NAME = "./A-large";

    private static int N;
    private static int K;
    private static Cake[] cakes;
    private static double[][] dp;

    public static void main(String[] args) throws IOException {
        BufferedWriter bw = new BufferedWriter(new FileWriter(FILE_NAME + ".out"));
        Scanner sc = new Scanner(new File(FILE_NAME + ".in"));

        int tc = sc.nextInt();
        for (int t = 1; t <= tc; t++) {
            N = sc.nextInt();
            K = sc.nextInt();

            dp = new double[N][K+1];
            cakes = new Cake[N];
            for (int i = 0; i < N; i++) {
                cakes[i] = new Cake(sc.nextDouble(), sc.nextDouble());

                for (int j = 0; j <= K; j++) dp[i][j] = -1;
            }

            Arrays.sort(cakes, (o1, o2) -> {
                int diff = (int) (o2.r - o1.r);
                if (diff != 0) return diff;
                return (int) (o2.h - o1.h);
            });

            double result = -1;
            for (int i = 0; i < N; i++) {
                if (N - i < K) continue;
                result = Math.max(result, solve(i + 1, K - 1) + cakes[i].getPIRR() + cakes[i].get2PIRH());
            }

            bw.write(String.format("Case #%d: %.9f", t, result));
            bw.newLine();
        }

        bw.flush();
    }

    private static double solve(int idx, int rest) {
        if (rest <= 0) return 0;

        if (dp[idx][rest] != -1) return dp[idx][rest];

        double pi2RH = cakes[idx].get2PIRH();
        double max = pi2RH + solve(idx + 1, rest - 1);
        if (N - idx == rest) {
            return dp[idx][rest] = max;
        }
        max = Math.max(max, solve(idx + 1, rest));

        return dp[idx][rest] = max;
    }

    static class Cake {
        public double r;
        public double h;

        public Cake(double r, double h) {
            this.r = r;
            this.h = h;
        }

        public double get2PIRH() {
            return 2 * Math.PI * r * h;
        }

        public double getPIRR() {
            return Math.PI * r * r;
        }
    }
}
