import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

public class Main {

    private static BigInteger[][] cache = new BigInteger[11][32];
    static {
        for (int i = 2; i < cache.length; i++) {
            for (int j = 0; j < cache[i].length; j++) {
                cache[i][j] = BigInteger.valueOf(i).pow(j);
            }
        }
    }

    public static void main(String[] args) throws IOException {
        String filename = "C-small-attempt0";
        BufferedReader br = new BufferedReader(new FileReader("./" + filename + ".in"));
        BufferedWriter bw = new BufferedWriter(new FileWriter("./" + filename + ".out"));

        StringBuilder sb = new StringBuilder();
        int tc = Integer.parseInt(br.readLine());
        for (int i = 1; i <= tc; i++) {
            String[] input = br.readLine().split(" ");
            int n = Integer.valueOf(input[0]);
            int j = Integer.valueOf(input[1]);

            bw.write("Case #" + i + ":");
            bw.newLine();
            boolean[] coin = new boolean[n];
            coin[0] = true;
            coin[coin.length-1] = true;
            List<String> result = new ArrayList<>();
            find(result, n, j, coin, 1);
            for (String r : result) {
                bw.write(r.trim());
                bw.newLine();
            }
            bw.flush();
        }
    }

    private static void find(List<String> result, int n, int j, boolean[] coin, int idx) {
        if (result.size() == j) {
            return;
        }

        if (idx == n - 1) {
            cal(result, coin);
            return;
        }

        find(result, n, j, coin, idx+1);
        coin[idx] = true;
        find(result, n, j, coin, idx+1);
        coin[idx] = false;
    }

    private static void cal(List<String> result, boolean[] coin) {
        StringBuilder sb = new StringBuilder();
        for (int i = 2; i <= 10; i++) {
            BigInteger b = BigInteger.ZERO;
            for (int j = 0; j < coin.length; j++) {
                if (!coin[j]) {
                    continue;
                }
                b = b.add(cache[i][j]);
            }

            if (b.isProbablePrime(100)) {
                return;
            }

            if (b.mod(BigInteger.valueOf(2)).equals(BigInteger.ZERO)) {
                sb.append('2');
                sb.append(' ');
            } else {
                for (BigInteger j = BigInteger.valueOf(3); (j.pow(2)).compareTo(b) <= 0; j = j.add(BigInteger.valueOf(2))) {
                    if (b.mod(j).equals(BigInteger.ZERO)) {
                        sb.append(j.toString());
                        sb.append(' ');
                        break;
                    }
                }
            }
        }

        sb.insert(0, ' ');
        for (int i = 0; i < coin.length; i++) {
            sb.insert(0, coin[i] ? 1 : 0);
        }
        result.add(sb.toString().trim());
    }
}
