package codejam.devrimtuncer.com.codejam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by devrimtuncer on 4/8/17.
 *
 */

public class CodeJam {
    private static final String FILENAME = "inputfiles/in1.in";

    public static void main(String[] args) {

        try {
            List<String> numbers = getNumbers();

            for (int i = 0; i < numbers.size(); i++) {
                String number = numbers.get(i);
                System.out.println("Case #" + (i + 1) + ": " + getTidy(number));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static String getTidy(String number) {
        if (number.length() == 1) {
            return number;
        } else {
            boolean changed = false;
            char[] values = number.toCharArray();
            for (int i = 0; i < values.length - 1; i ++) {
                int right = Integer.parseInt(String.valueOf(values[i + 1]));
                int left= Integer.parseInt(String.valueOf(values[i]));

                if(left > right) {
                    changed = true;
                    // update right values
                    for(int j = i + 1; j < values.length; j ++) {
                        values[j] = Character.forDigit(9, 10);
                    }

                    // update left values
                    for(int j = i; j >= 0; j --) {
                        int val = Integer.parseInt(String.valueOf(values[j]));
                        if(val > 0) {
                            values[j] = Character.forDigit(val - 1, 10);
                            break;
                        } else {
                            values[j] = Character.forDigit(9, 10);
                        }
                    }
                    break;
                }
            }

            if(changed) {
                return getTidy(new String(values));
            } else {
                // remove leading zeros
                return new String(values).replaceFirst("^0+(?!$)", "");
            }
        }
    }

    private static List<String> getNumbers() throws IOException {
        List<String> numbers = null;

        BufferedReader bufferedReader = null;
        FileReader fileReader = null;

        try {
            fileReader = new FileReader(FILENAME);
            bufferedReader = new BufferedReader(fileReader);
            String currentLine;
            bufferedReader = new BufferedReader(new FileReader(FILENAME));

            while ((currentLine = bufferedReader.readLine()) != null) {
                if(numbers == null){
                    numbers = new ArrayList<>(Integer.parseInt(currentLine));
                } else {
                    numbers.add(currentLine);
                }
            }
        } finally {
            try {
                if (bufferedReader != null)
                    bufferedReader.close();
                if (fileReader != null)
                    fileReader.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
        return numbers;
    }
}
