package codejam.devrimtuncer.com.codejam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by devrimtuncer on 4/8/17.
 *
 */

public class BathroomStalls {
    private static final String FILENAME = "inputfiles/BathroomStalls/small.in";

    public static void main(String[] args) {

        try {
            List<TestCase> testCases = getTestCases();

            for (int i = 0; i < testCases.size(); i++) {
                TestCase testCase = testCases.get(i);

                System.out.println("Case #" + (i + 1) + ": " + testCase.solve());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static class TestCase {
        private int n;
        private int k;

        List<Integer> stalls;

        int[] quickSolve() {

            int value = stalls.remove(0);
            if(value == 1) {
                return new int[]{0, 0};
            } else {
                int half = value / 2;
                int extra = value % 2;

                int val0 = half;
                int val1 = half - 1 + extra;

                if (val0 > 0) {
                    boolean add = true;
                    for (int i = 0; i < stalls.size(); i++) {
                        int storedVal = stalls.get(i);
                        if(val0 >= storedVal) {
                            stalls.add(i, val0);
                            add = false;
                            break;
                        }
                    }
                    if(add) {
                        stalls.add(val0);
                    }
                }

                if (val1 > 0) {
                    boolean add = true;
                    for (int i = 0; i < stalls.size(); i++) {
                        int storedVal = stalls.get(i);
                        if(val1 >= storedVal) {
                            stalls.add(i, val1);
                            add = false;
                            break;
                        }
                    }
                    if(add) {
                        stalls.add(val1);
                    }
                }

                return new int[]{val0, val1};
            }
        }


        String solve() {
            if(n == k) {
                return "0 0";
            } else {
                stalls = new ArrayList<>();
                stalls.add(n);
                for (int i = 0; i < k - 1; i++) {
                    quickSolve();
                }

                int[] last = quickSolve();
                return last[0] + " " + last[1];
            }
        }
    }

    private static List<TestCase> getTestCases() throws IOException {
        List<TestCase> numbers = null;

        BufferedReader bufferedReader = null;
        FileReader fileReader = null;

        try {
            fileReader = new FileReader(FILENAME);
            bufferedReader = new BufferedReader(fileReader);
            String currentLine;
            bufferedReader = new BufferedReader(new FileReader(FILENAME));

            while ((currentLine = bufferedReader.readLine()) != null) {
                if(numbers == null){
                    numbers = new ArrayList<>(Integer.parseInt(currentLine));
                } else {
                    TestCase testCase = new TestCase();
                    String[] values = currentLine.split(" ");
                    testCase.n = Integer.parseInt(values[0]);
                    testCase.k = Integer.parseInt(values[1]);
                    numbers.add(testCase);
                }
            }
        } finally {
            try {
                if (bufferedReader != null)
                    bufferedReader.close();
                if (fileReader != null)
                    fileReader.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
        return numbers;
    }
}
