package org.devrimtuncer;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class CodeJam2014_2 {
	
	private static final String SAMPLE_FILE = "sample";
	private static final String SMALL_FILE = "small-practice";
	private static final String LARGE_FILE = "large-practice";

	private static final String PATH = "/Users/devrimtuncer/CodeJam/2014/2/";

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			String caseFileName = SMALL_FILE; // Do not add '.in' type, it'll be auto added

			List<Case> caseList = getCaseList(caseFileName);
			
			for (Case caseItem : caseList) {
				caseItem.solve();
			}
			
			writeToFile(caseFileName, caseList);// Do not add '.out' type, it'll be auto added

		} catch (Throwable t) {
			t.printStackTrace();
		}
	}

	private static class Case {
		
		private DecimalFormat df = new DecimalFormat("#.#######");
		
		private int id;
		private String status;

		// TODO: add other fields for case specific
		private double c;
		private double f;
		private double x;
		
		private double rate = 2;
		private double timeSpent = 0;
		
		public void setValues (String line) {
			String[] splitted = line.split(" ");
			c = Double.parseDouble(splitted[0]);
			f = Double.parseDouble(splitted[1]);
			x = Double.parseDouble(splitted[2]);
			
			
		}
		
		
		public Case(int id) {
			this.id = id;
		}

		public void solve() {
			double time = x / rate;
			double otherTime = (c / rate) + (x / (rate + f));
			
			if(time < otherTime) {
				timeSpent += time;
				this.status = df.format(timeSpent);
			} else {
				timeSpent += (c / rate);
				rate += f;
				solve();
			}
		}

		@Override
		public String toString() {
			return "Case #" + id + ": " + status;
		}
	}

	private static List<Case> getCaseList(String fileName) throws IOException {
		BufferedReader br = null;

		br = new BufferedReader(new FileReader(PATH + fileName + ".in"));

		int caseCount = Integer.parseInt(br.readLine());
		List<Case> caseList = new ArrayList<Case>(caseCount);

		int caseId = 1;

		String sCurrentLine = null;
		while ((sCurrentLine = br.readLine()) != null) {
			Case caseItem = new Case(caseId);

			// TODO: set values for case
			caseItem.setValues(sCurrentLine);
			
			caseId ++;
			caseList.add(caseItem);
		}

		try {
			if (br != null)
				br.close();
		} catch (IOException ex) {
			// Ignore
		}

		return caseList;
	}

	public static void writeToFile(String fileName, List<Case> caseList)
			throws IOException {
		File file = new File(PATH + fileName + ".out");

		// if file doesnt exists, then create it
		if (!file.exists()) {
			file.createNewFile();
		}

		FileWriter fw = new FileWriter(file.getAbsoluteFile());
		BufferedWriter bw = new BufferedWriter(fw);

		for (Case caseItem : caseList) {
			bw.write(caseItem + "\n");
			System.out.println(caseItem);
		}

		try {
			if (bw != null)
				bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
}
