package org.devrimtuncer;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class CodeJam2014_1 {
	
	private static final String SAMPLE_FILE = "sample";
	private static final String SMALL_FILE = "small-practice";
	private static final String LARGE_FILE = "large-practice";

	private static final String PATH = "/Users/devrimtuncer/CodeJam/2014/1/";

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			String caseFileName = SMALL_FILE; // Do not add '.in' type, it'll be auto added

			List<Case> caseList = getCaseList(caseFileName);
			
			for (Case caseItem : caseList) {
				caseItem.solve();
			}
			
			writeToFile(caseFileName, caseList);// Do not add '.out' type, it'll be auto added

		} catch (Throwable t) {
			t.printStackTrace();
		}
	}

	private static class Case {
		private int id;
		private String status;

		// TODO: add other fields for case specific
		
		private String[] firstAnswerSet, secondAnswerSet;
		
		public Case(int id) {
			this.id = id;
			firstAnswerSet = new String[4];
			secondAnswerSet = new String[4];
		}
		
		public void setFirstAnswerSet(String line) {
			firstAnswerSet = line.split(" ");
			
		}
		
		public void setSecondAnswerSet(String line) {
			secondAnswerSet = line.split(" ");
		}

		public void solve() {
			// TODO: write your case solution logic here and set status
			this.status = null;
			
			int selectedCard = -1;
			
			for(int i = 0; i < firstAnswerSet.length; i ++) {
				int firstAnswersItem = Integer.parseInt(firstAnswerSet[i]);
				for(int j = 0; j < secondAnswerSet.length; j ++) {
					int secondAnswersItem = Integer.parseInt(secondAnswerSet[j]);
					if(firstAnswersItem == secondAnswersItem) {
						if(selectedCard == -1) {
							selectedCard = secondAnswersItem;
						} else {
							this.status = "Bad magician!";
							break;
						}
					}
				}
				
				if(status != null){
					break;
				}
			}
			
			if(status == null){
				if(selectedCard != -1) {
					status = String.valueOf(selectedCard);
				} else {
					status = "Volunteer cheated!";
				}
			}
			
		}

		@Override
		public String toString() {
			return "Case #" + id + ": " + status;
		}
	}

	private static List<Case> getCaseList(String fileName) throws IOException {
		BufferedReader br = null;

		br = new BufferedReader(new FileReader(PATH + fileName + ".in"));

		int caseCount = Integer.parseInt(br.readLine());
		List<Case> caseList = new ArrayList<Case>(caseCount);

		int caseId = 1;

		String sCurrentLine = null;
		while ((sCurrentLine = br.readLine()) != null) {
			Case caseItem = new Case(caseId);

			// TODO: set values for case
			int firstAnswer = Integer.parseInt(sCurrentLine);
			String[] cards = new String[4];
			for(int i = 0; i < 4; i ++) {
				cards[i] = br.readLine();
			}
			
			caseItem.setFirstAnswerSet(cards[firstAnswer - 1]);
			
			
			int secondAnswer = Integer.parseInt(br.readLine());
			for(int i = 0; i < 4; i ++) {
				cards[i] = br.readLine();
			}
			
			caseItem.setSecondAnswerSet(cards[secondAnswer - 1]);
			caseId ++;
			caseList.add(caseItem);
		}

		try {
			if (br != null)
				br.close();
		} catch (IOException ex) {
			// Ignore
		}

		return caseList;
	}

	public static void writeToFile(String fileName, List<Case> caseList)
			throws IOException {
		File file = new File(PATH + fileName + ".out");

		// if file doesnt exists, then create it
		if (!file.exists()) {
			file.createNewFile();
		}

		FileWriter fw = new FileWriter(file.getAbsoluteFile());
		BufferedWriter bw = new BufferedWriter(fw);

		for (Case caseItem : caseList) {
			bw.write(caseItem + "\n");
		}

		try {
			if (bw != null)
				bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
}
