package com.devrimtuncer.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Collections;

public abstract class Question1 {
	
	public static void solve() {
		FileReader fileReader = null;
		BufferedReader br = null;
	    try {
			fileReader = new FileReader(getSmallInputFile());
			br = new BufferedReader(fileReader);
			
			Case currentCase = null;
	    	
	    	int numberOfCases = -1;
	    	
	        String line = br.readLine();
	        while (line != null) {
	        	if(numberOfCases == -1) {
	        		numberOfCases = Integer.parseInt(line);
	        	} else {
	        		currentCase = new Case(line);
	        		String nextLine = line = br.readLine();
	        		currentCase.setParties(line);
	        		currentCase.solve();
	        	}
	        	
	            line = br.readLine();
	        }
	    } catch (Exception e) {
			e.printStackTrace();
		} finally {
	    	try {
	    		fileReader.close();
	    	} catch(Exception e) {
	    	}
	    	
	    	try {
	    		br.close();
	    	} catch(Exception e) {
	    	}
	    }
	}
	
	private static class Case {
		private static int caseIndex = 1;
		private String caseId;
		
		private int count= 0;
		private ArrayList<Party> senatorsList;
		int totalSenators = 0;
		
		private String status;
		
		public Case(String line) {
			this.caseId = "Case #" + caseIndex + ": ";
			caseIndex ++;
			
			count = Integer.parseInt(line);
		}
		
		public void setParties(String line) {
			String[] partiesStr = line.split(" ");
			senatorsList = new ArrayList<Party>(partiesStr.length);
			for(int i = 0; i < partiesStr.length; i ++) {
				Party party = new Party();
				party.index = i;
				party.name = getChar(i);
				party.senators = Integer.parseInt(partiesStr[i]);
				senatorsList.add(party);
				
				totalSenators += party.senators;
			}
		}

		private static class Party implements Comparable<Party>{
			String name;
			int index;
			int senators;
			
			public int compareTo(Party compare) {
				int count = ((Party) compare).senators; 
				//descending order
				return count - this.senators;
			}
		}
		
		
		public void solve() {
			try {
				
				status = "";
				
				int loop = totalSenators;
				
				for(int i = 0; i < loop; i ++) {
					Collections.sort(senatorsList);
					
					Party party1, party2, party3;
					party1 = null;
					party2 = null;
					party3 = null;
					if(senatorsList.size() > 0) {
						party1 = senatorsList.get(0);
						if(party1.senators == 0) {
							party1 = null;
						}
					}
					if(senatorsList.size() > 1) {
						party2 = senatorsList.get(1);
						if(party2.senators == 0) {
							party2 = null;
						}
					}
					if(senatorsList.size() > 2) {
						party3 = senatorsList.get(2);
						if(party3.senators == 0) {
							party3 = null;
						}
					}

					
					if(party1 == null) {
						break;
					}
					
					int half = (totalSenators - 2) / 2;
					
					
					if((party1 != null && party2 != null && party1.senators == party2.senators)
							&& (party3 == null || party3.senators <= half)) {
						party1.senators -= 1;
						party2.senators -= 1;
						totalSenators -=2;
						status += party1.name + party2.name + " ";
					} else if((party1.senators - 1 <= half)
							&& (party2 != null && party2.senators - 1 <= half)
							&& (party3 == null || party3.senators <= half)) {
						party1.senators -= 1;
						party2.senators -= 1;
						totalSenators -=2;
						status += party1.name + party2.name + " ";
					} else if ((party2 == null || party2.senators <= half)
							&& (party3 == null || party3.senators <= half)) {
						party1.senators -= 2;
						totalSenators -=2;
						status += party1.name + party1.name + " ";
					} else {
						party1.senators -= 1;
						totalSenators -=1;
						status += party1.name + " ";
					}
				}
				
				System.out.println(toString());
			} catch(StackOverflowError t) {
				t.printStackTrace();
			}
		}
		
		public void setX(String line) {
			
		}
		
		public void setY(String line) {
			
		}
		
		public void setZ(String line) {
			
		}
		
		@Override
		public String toString() {
			return this.caseId + status;
		}
	}
	
	public static String getChar(int index) {
		if(index == 0) {
			return "A";
		} else if(index == 1) {
			return "B";
		}else if(index == 2) {
			return "C";
		}else if(index == 3) {
			return "D";
		}else if(index == 4) {
			return "E";
		}else if(index == 5) {
			return "F";
		}else if(index == 6) {
			return "G";
		}else if(index == 7) {
			return "H";
		}else if(index == 8) {
			return "I";
		}else if(index == 9) {
			return "J";
		}else if(index == 10) {
			return "K";
		}else if(index == 11) {
			return "L";
		}else if(index == 12) {
			return "M";
		}else if(index == 13) {
			return "N";
		}else if(index == 14) {
			return "O";
		}else if(index == 15) {
			return "P";
		}else if(index == 16) {
			return "Q";
		}else if(index == 17) {
			return "R";
		}else if(index == 18) {
			return "S";
		}else if(index == 19) {
			return "T";
		}else if(index == 20) {
			return "U";
		}else if(index == 21) {
			return "V";
		}else if(index == 22) {
			return "W";
		}else if(index == 23) {
			return "X";
		}else if(index == 24) {
			return "Y";
		}else if(index == 25) {
			return "Z";
		} else {
			return "";
		}
	}
	
	private static String getTestInputFile() {
		String file = System.getProperty("user.dir") + File.separator + "src/resources/1/test_input.txt";
		return file;
	}
	
	private static String getSmallInputFile() {
		String file = System.getProperty("user.dir") + File.separator + "src/resources/1/A-small.in";
		return file;
	}
	
	private static String getLargeInputFile() {
		String file = System.getProperty("user.dir") + File.separator + "src/resources/1/A-large.in";
		return file;
	}

}
