package com.devrimtuncer.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

public abstract class Question1 {
	
	public static void solve() {
		FileReader fileReader = null;
		BufferedReader br = null;
	    try {
			fileReader = new FileReader(getSmallInputFile());
			br = new BufferedReader(fileReader);
			
			Case currentCase = null;
	    	
	    	int numberOfCases = -1;
	    	
	        String line = br.readLine();
	        while (line != null) {
	        	if(numberOfCases == -1) {
	        		numberOfCases = Integer.parseInt(line);
	        	} else {
	        		currentCase = new Case(line);
	        		currentCase.solve();
	        	}
	        	
	            line = br.readLine();
	        }
	    } catch (Exception e) {
			e.printStackTrace();
		} finally {
	    	try {
	    		fileReader.close();
	    	} catch(Exception e) {
	    	}
	    	
	    	try {
	    		br.close();
	    	} catch(Exception e) {
	    	}
	    }
	}
	
	private static class Case {
		private static int caseIndex = 1;
		private String caseId;
		
		String line;
		private String status;
		
		public Case(String line) {
			this.caseId = "Case #" + caseIndex + ": ";
			caseIndex ++;
			this.line = line;
			
			status = "";
			HashMap<String, Integer> map = new HashMap<String, Integer>();
			
			for(int i = 0; i < line.length(); i ++) {
				String key = line.substring(i, i +1);
				
				Integer currentCountOfKey = map.get(key);
				if(currentCountOfKey != null && currentCountOfKey > 0) {
					map.put(key, currentCountOfKey.intValue() + 1);
				} else {
					map.put(key, 1);
				}
			}
			
			ArrayList<Integer> values = new ArrayList();
			
			for(int i = 0; i < line.length(); i ++) {
				
				String key = line.substring(i, i +1);
				
		        Integer count = map.get(key);
		        if(count != null && count > 0) {
			        if(key.equals("Z")) {
						Integer eCount =  map.get("E");
						Integer rCount =  map.get("R");
						Integer oCount =  map.get("O");	
						
						if(eCount > 0 && rCount > 0 && oCount > 0) {
							values.add(0);
							
							map.put("Z", count -1);
							map.put("E", eCount -1);
							map.put("R", rCount -1);
							map.put("O", oCount -1);
						}
					} else if(key.equals("X")) {
						Integer sCount =  map.get("S");
						Integer iCount =  map.get("I");
						if(sCount > 0 && iCount > 0) {
							values.add(6);
							
							map.put("S", sCount -1);
							map.put("I", iCount -1);
							map.put("X", count -1);
						}
					} else if(key.equals("W")) {
						Integer tCount =  map.get("T");
						Integer oCount =  map.get("O");
						if(tCount > 0 && oCount > 0) {
							values.add(2);
							
							map.put("T", tCount -1);
							map.put("W", count -1);
							map.put("O", oCount -1);
						}
					} else if(key.equals("U")) {
						Integer fCount =  map.get("F");
						Integer oCount =  map.get("O");
						Integer rCount =  map.get("R");
						if(fCount != null && oCount != null && rCount != null 
								&& fCount > 0 && oCount > 0 && rCount > 0) {
							values.add(4);
							
							map.put("F", fCount -1);
							map.put("O", oCount -1);
							map.put("U", count -1);
							map.put("R", rCount -1);
						}
					} else if(key.equals("G")) {
						Integer eCount =  map.get("E");
						Integer iCount =  map.get("I");
						Integer hCount =  map.get("H");
						Integer tCount =  map.get("T");
						if(eCount != null && iCount != null && hCount != null && tCount != null
								&& eCount > 0 && iCount > 0 && hCount > 0 && tCount > 0) {
							values.add(8);
							
							 map.put("E", eCount -1);
							 map.put("I", iCount -1);
							 map.put("G", count -1);
							 map.put("H", hCount -1);
							 map.put("T", tCount -1);
						}
					} else {
						continue;
					}
		        }
		    }
			
			for(int i = 0; i < line.length(); i ++) {
				String key = line.substring(i, i +1);
				Integer count =  map.get(key);
				
				if(count != null && count > 0) {
					if(key.equals("O")) {
						Integer oCount =  map.get("O");
						Integer nCount =  map.get("N");
						Integer eCount =  map.get("E");
						
						if(oCount != null && nCount != null && eCount != null 
								&& oCount > 0 && nCount > 0 && eCount > 0) {
							values.add(1);
							
							map.put("O", oCount -1);
							map.put("N", nCount -1);
							map.put("E", eCount -1);
						}	
					} else if(key.equals("T") || key.equals("H") || key.equals("R")) { 
		        		Integer tCount =  map.get("T");
						Integer hCount =  map.get("H");
						Integer rCount =  map.get("R");
						Integer eCount =  map.get("E");
						if(tCount != null && hCount != null && rCount != null && eCount != null
								&& tCount > 0 && hCount > 0 && rCount > 0 && eCount > 1) {
							values.add(3);
							
							map.put("T", tCount -1);
							map.put("H", hCount -1);
							map.put("R", rCount -1);
							map.put("E", eCount -2);
						}
					} else if(key.equals("S")) { 
						Integer sCount =  map.get("S");
						Integer eCount =  map.get("E");
						Integer vCount =  map.get("V");
						Integer nCount =  map.get("N");
						if(sCount != null && eCount != null && vCount != null && nCount != null 
								&& sCount > 0 && eCount > 1 && vCount > 0 && nCount > 0) {
							values.add(7);
							
							map.put("S", sCount -1);
							map.put("E", eCount -2);
							map.put("V", vCount -1);
							map.put("N", nCount -1);
						}
					}	
				}
			}
			
			for(int i = 0; i < line.length(); i ++) {
				
				String key = line.substring(i, i +1);
				Integer count =  map.get(key);
				
				if(count != null && count > 0) {
		        	if(key.equals("N") || key.equals("I") || key.equals("E") ) { 
						Integer nCount =  map.get("N");
						Integer iCount =  map.get("I");
						Integer eCount =  map.get("E");
						if(nCount != null && iCount != null && eCount != null 
								&& nCount > 1 && iCount > 0 && eCount > 0) {
							values.add(9);
							
							map.put("N", nCount -2);
							map.put("I", iCount -1);
							map.put("E", eCount -1);
						}
					} else if(key.equals("N") || key.equals("E")) {
						Integer oCount =  map.get("O");
						Integer nCount =  map.get("N");
						Integer eCount =  map.get("E");
						
						if(oCount != null && nCount != null && eCount != null 
								&& oCount > 0 && nCount > 0 && eCount > 0) {
							values.add(1);
							
							map.put("O", oCount -1);
							map.put("N", nCount -1);
							map.put("E", eCount -1);
						}
					}  else if(key.equals("F") || key.equals("I") || key.equals("V") || key.equals("E")) { 
						Integer fCount =  map.get("F");
						Integer iCount =  map.get("I");
						Integer vCount =  map.get("V");
						Integer eCount =  map.get("E");
						if(fCount != null && iCount != null && vCount != null && eCount != null 
								&& fCount > 0 && iCount > 0 && vCount > 0 && eCount > 0) {
							values.add(5);
							
							map.put("F", fCount -1);
							map.put("I", iCount -1);
							map.put("V", vCount -1);
							map.put("E", eCount -1);
						}
					} else if(key.equals("E") || key.equals("V") || key.equals("N")) { 
						Integer sCount =  map.get("S");
						Integer eCount =  map.get("E");
						Integer vCount =  map.get("V");
						Integer nCount =  map.get("N");
						if(sCount != null && eCount != null && vCount != null && nCount != null 
								&& sCount > 0 && eCount > 1 && vCount > 0 && nCount > 0) {
							values.add(7);
							
							map.put("S", sCount -1);
							map.put("E", eCount -2);
							map.put("V", vCount -1);
							map.put("N", nCount -1);
						}
					} else {
						continue;
					}
		        }
		    }
			
			Iterator it = map.entrySet().iterator();
		    while (it.hasNext()) {
		        Map.Entry pair = (Map.Entry)it.next();
		        Integer val = (Integer)pair.getValue();
		        if(val > 0) {
		        	System.out.println("");
		        }
		        it.remove(); // avoids a ConcurrentModificationException
		    }
			Collections.sort(values);
			for(int i = 0; i < values.size(); i ++) {
				status += values.get(i);
			}
		}
		
		public void solve() {
			try {
				System.out.println(toString());
			} catch(StackOverflowError t) {
				t.printStackTrace();
			}
		}
		
		public void setX(String line) {
			
		}
		
		public void setY(String line) {
			
		}
		
		public void setZ(String line) {
			
		}
		
		@Override
		public String toString() {
			return this.caseId + status;
		}
	}
	
	private static String getTestInputFile() {
		String file = System.getProperty("user.dir") + File.separator + "src/resources/1/test_input.txt";
		return file;
	}
	
	private static String getSmallInputFile() {
		String file = System.getProperty("user.dir") + File.separator + "src/resources/1/A-small.in";
		return file;
	}
	
	private static String getLargeInputFile() {
		String file = System.getProperty("user.dir") + File.separator + "src/resources/1/A-large.in";
		return file;
	}

}
