package com.devrimtuncer.utils;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public abstract class FileUtils {
	
	public interface FileReaderCallback {
		public void onReadLine (String line);
	}
	
	public static void readFile(String file, FileReaderCallback fileReaderCallback) throws IOException {
		FileReader fileReader = new FileReader(file);
		BufferedReader br = new BufferedReader(fileReader);
	    try {
	        String line = br.readLine();
	        while (line != null) {
	        	fileReaderCallback.onReadLine(line);
	            line = br.readLine();
	        }
	    } finally {
	    	try {
	    		fileReader.close();
	    	} catch(Exception e) {
	    		// ignore this exception
	    	}
	    	
	    	try {
	    		br.close();
	    	} catch(Exception e) {
	    		// ignore this exception
	    	}
	    }
	}

}
