package com.aegean.codejam.qualification;

import java.io.File;

import com.aegean.codejam.utils.FileUtils;
import com.aegean.codejam.utils.FileUtils.FileReaderCallback;

public abstract class Question1 {
	
	public static void solve() {
		try {
		FileUtils.readFile(getLargeInputFile(), new FileReaderCallback() {
			int caseCount = 0;
			int lineIndex = 0;
			@Override
			public void onReadLine(String line) {
				if(lineIndex > 0) {
					Case theCase = new Case(lineIndex, line);
					theCase.solve();
					System.out.println(theCase);
				} else {
					caseCount = Integer.parseInt(line.trim());
				}
				lineIndex ++;
			}
		});
		} catch (Exception e) {
			e.printStackTrace();
			
		}
	}
	
	private static class Case {
		private String caseId;
		
		private int sMax;
		private String people;
		
		long peopleStoodUp = 0;
		long peopleNeeded = 0;
		
		public Case(int index, String line) {
			this.caseId = "Case #" + index + ": ";
			String[] parts = line.split(" ");
			this.sMax = Integer.parseInt(parts[0]);
			this.people = parts[1];
		}
		
		public void solve() {
			for(int i = 0; i < people.length(); i ++) {
				int currentPeople = Integer.parseInt(people.substring(i, i+1));
				
				if(i > peopleStoodUp && currentPeople > 0){
					long peopleNeededForThis = (i - peopleStoodUp);
					peopleNeeded += peopleNeededForThis;
					peopleStoodUp += peopleNeededForThis;
				}
				
				peopleStoodUp += currentPeople;
			}
		}
		
		@Override
		public String toString() {
			return this.caseId + peopleNeeded;
		}
	}
	
	private static String getTestInputFile() {
		String file = System.getProperty("user.dir") + File.separator + "src/resources/qualification_1_test_input.txt";
		return file;
	}
	
	private static String getSmallInputFile() {
		String file = System.getProperty("user.dir") + File.separator + "src/resources/qualification_1_small_input.txt";
		return file;
	}
	
	private static String getLargeInputFile() {
		String file = System.getProperty("user.dir") + File.separator + "src/resources/A-large.in";
		return file;
	}

}
