package com.devrimtuncer.codejam;

import java.io.File;
import com.devrimtuncer.utils.FileUtils;
import com.devrimtuncer.utils.FileUtils.FileReaderCallback;

public abstract class Question1 {
	
	public static void solve() {

		try {
			FileUtils.readFile(getSmallInputFile(), new FileReaderCallback() {
				int lineIndex = 0;
				int caseIndex = 0;
				Case currentCase;
				@Override
				public void onReadLine(String line) {
					if(lineIndex == 0) {
						int caseCount = Integer.parseInt(line.trim());
					} else {
						caseIndex ++;
						currentCase = new Case(caseIndex, line);
						currentCase.solve();
						System.out.println(currentCase);
					} 
					lineIndex ++;
				}
			});
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private static class Case {
		private String caseId;
		
		private String word;
		
		private String status;
		
		public Case(int index, String line) {
			this.caseId = "Case #" + index + ": ";
			word = line;
		}
		
		public void solve() {
			try {
				
				String producedWord = "";
				
				for(int i = 0;  i < word.length(); i++) {
					String letter = word.substring(i, i + 1);
					if(producedWord.equals("")) {
						producedWord = letter;
					}else {
						if(producedWord.substring(0, 1).compareTo(letter) > 0) {
							producedWord += letter;
						} else {
							producedWord = letter + producedWord;
						}
					}
				}
				
				status = producedWord;
				
			} catch(StackOverflowError t) {
				t.printStackTrace();
			}
		}
		
		
		
		@Override
		public String toString() {
			return this.caseId + status;
		}
	}
	
	private static String getTestInputFile() {
		String file = System.getProperty("user.dir") + File.separator + "src/resources/1/test_input.txt";
		return file;
	}
	
	private static String getSmallInputFile() {
		String file = System.getProperty("user.dir") + File.separator + "src/resources/1/A-small-attempt0.in";
		return file;
	}
	
	private static String getLargeInputFile() {
		String file = System.getProperty("user.dir") + File.separator + "src/resources/1/A-large.in";
		return file;
	}

}
