import java.util.*;

public class ProbC {

	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int numCases = Integer.parseInt(in.nextLine());

		for (int i = 0; i < numCases; i++) {
			int n = in.nextInt();
			int m = in.nextInt();
			in.nextLine();
			int[] values = new int[n*m];
			String line = in.nextLine();
			for (int j = 0; j < n; j++) {
				char c = line.charAt(j);
				if (c == 'i') {
					values[j] = 2;
				} else if (c == 'j') {
					values[j] = 3;
				} else if (c == 'k') {
					values[j] = 4;
				}
			}

			for (int j = 1; j < m; j++) {
				for (int k = 0; k < n; k++) {
					values[j * n + k] = values[(j-1) * n + k];
				}
			}

			boolean result = solve(values);

			System.out.printf("Case #%d: %s\n", i + 1, result ? "YES": "NO");
		}

	}

	public static boolean solve(int[] values) {
		if (values.length < 3) {
			return false;
		}
		return grabI(values);
	}

	public static boolean grabI(int[] values) {
		int val = 1;
		for (int i = 0; i < values.length; i ++) {
			val = eval(val, values[i]);
			if (val == 2 && grabJ(values, i+1)) {
				return true;
			}
		}
		return false;
	}

	public static boolean grabJ(int[] values, int start) {
		int val = 1;
		for (int i = start; i < values.length; i++) {
			val = eval(val, values[i]);
			if (val == 3 && grabK(values, i+1)) {
				return true;
			}
		}
		return false;
	}

	public static boolean grabK(int[] values, int start) {
		int val = 1;
		for (int i = start; i < values.length; i++) {
			val = eval(val, values[i]);
		}
		return val == 4;
	}

	public static int eval(int a, int b) {
		int multiplier = 1;
		if (a * b < 0) {
			multiplier = -1;
		}

		a = Math.abs(a);
		b = Math.abs(b);

		if (a == 1 || b == 1) {
			return multiplier * a * b;
		}

		if (a == b) {
			return -1 * multiplier;
		}

		if (a == 2 && b == 3) {
			return 4 * multiplier;
		}

		if (a == 2 && b == 4) {
			return -3 * multiplier;
		}

		if (a == 3 && b == 2) {
			return -4 * multiplier;
		}

		if (a == 3 && b == 4) {
			return 1 * multiplier;
		}

		if (a == 4 && b == 2) {
			return 3 * multiplier;
		}

		if (a == 4 && b == 3) {
			return -2 * multiplier;
		}

		return 0;
	}
}