import java.util.*;
import java.io.*;

public class BathroomStalls {
	public static boolean[] occupied;
	public static int N = 0;
	public static int K = 0;
	public static void main(String[] args) {
		Scanner scan = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		for(int i = 0, T = scan.nextInt(); i < T; i++) {
			// if(i == 1) System.exit(0);
			N = scan.nextInt();
			K = scan.nextInt();

			occupied = new boolean[N + 2];
			occupied[0] = true;
			occupied[N + 1] = true;
			
			int y = 0;
			int z = 0;

			while(K > 0) {
				int[] next = nextStall();
				y = next[0];
				z = next[1];
				K--;
			}

			System.out.println("Case #" + (i + 1) + ": " + y + " " + z);
		}
	}
	public static int[] nextStall() {
		List<Integer[]> emptyStalls = new ArrayList<Integer[]>();
		for(int i = 1; i < N + 1; i++) {
			if(!occupied[i]) {
				// System.out.println("Found: " + Arrays.toString(occupied) + " at i = " + i);
				// Get # of empty stalls to the left
				int countLeft = 0;
				for(int j = i - 1; j > 0; j--) {
					if(!occupied[j]) {
						countLeft++;
					} else {
						// Otherwise the empty stalls aren't consecutive
						break;
					}
				}
				
				// Get # of empty stalls to the right
				int countRight = 0;
				for(int j = i + 1; j < N + 1; j++) {
					if(!occupied[j]) {
						countRight++;
					} else {
						// Otherwise the empty stalls aren't consecutive
						break;
					}
				}

				// Add this stall to our list of potential stalls to pick
				emptyStalls.add(new Integer[]{i, countLeft, countRight});
			}
		}

		// Now we need to go through each potential stall
		List<Integer[]> minStalls = new ArrayList<Integer[]>();
		int maxMin = Integer.MIN_VALUE;
		int maxMax = Integer.MIN_VALUE;
		for(int i = 0, x = emptyStalls.size(); i < x; i++) {
			Integer[] current = emptyStalls.get(i);
			// Calculate the maximum value for the min of countLeft and countRight
			int min = Math.min(current[1], current[2]);
			
			// If this minimum is greater, reset our list
			if(min > maxMin) {
				minStalls.clear();
				maxMin = min;
			}

			// If this minimum is part of the new maximum, add it to our list
			if(min >= maxMin) minStalls.add(current);
		}

		// If there is only 1 stall to choose from at this point
		if(minStalls.size() == 1) {
			// System.out.println(Arrays.toString(occupied));
			Integer[] current = minStalls.get(0);
			// We choose to take this stall, so make it unavailable
			occupied[current[0]] = true;
			// System.out.println("Took the stall at " + current[0] + " in phase 1 with L: " + current[1] + ", R: " + current[2] + ".");
			// Then, return the max(L, R) and min(L, R)
			int min = Math.min(current[1], current[2]);
			int max = Math.max(current[1], current[2]);
			return new int[]{max, min};
		}

		// Since we had some stalls that tied, we need to go through those stalls
		List<Integer[]> maxStalls = new ArrayList<Integer[]>();
		for(int i = 0, x = minStalls.size(); i < x; i++) {
			Integer[] current = minStalls.get(i);
			// Calculate the maximum value for the max of countLeft and countRight,
			// but this time, only for the stalls that passed the first test
			int max = Math.max(current[1], current[2]);


			// If this maximum is greater, reset our list
			if(max > maxMax) {
				maxStalls.clear();
				maxMax = max;
			}

			// If this maximum is part of the new maximum, add it to our list
			if(max >= maxMax) maxStalls.add(current);
		}

		// We always choose the first stall in this list. Why?
		// 1. If there is only 1 stall to choose from, the index will be 0
		// 2. If there is more than one stall, we go through the array in
		//    ascending order, so the leftmost stall must be index 0.
		Integer[] current = maxStalls.get(0);
		// We choose to take this stall, so make it unavailable
		occupied[current[0]] = true;
		// System.out.println("Took the stall at " + current[0] + " in phase 2 with L: " + current[1] + ", R: " + current[2] + ".");
		// Then, return the max(L, R) and min(L, R)
		int min = Math.min(current[1], current[2]);
		int max = Math.max(current[1], current[2]);
		return new int[]{max, min};

	}
}
