import java.io.*;
import java.util.*;

public class coinjam {
    public static final String NAME = "coinjam";
    
    public static void main(String[] args) throws IOException {
        Scanner scan = new Scanner(new File(NAME + ".in"));
        PrintWriter file = new PrintWriter(new File(NAME + ".out"));
        // scan.nextLine(); while(scan.hasNext()) { ... }
        // String[] a = scan.nextLine().split("\\s+");
        final int T = Integer.parseInt(scan.nextLine());
        String ans = "";
        for(int i = 0; i < T; i++) {
	        String[] a = scan.nextLine().split("\\s+");
	        final int N_length = Integer.parseInt(a[0]);
	        final int J_numToProduce = Integer.parseInt(a[1]);
	        List<Jamcoin> jamcoins = findJamcoins(N_length);
            file.println("Case #" + (i + 1) +":");
            for(int j = 0; j < J_numToProduce; j++) {
            	file.println(jamcoins.get(j));
            }
        }
        file.close();
    }

    public static List<Jamcoin> findJamcoins(int len) {
    	List<Jamcoin> jamcoins = new ArrayList<Jamcoin>();
    	if(len == 2) {

    	} else {
	    	int possibleJamcoins = (int) Math.pow(2, len - 2);
	    	String c = "";
	    	for(int i = 0; i < len - 2; i++) c += "0";
	    	for(int i = 0; i < possibleJamcoins; i++) {
	    		String unpadded = String.valueOf(Integer.toString(i, 2));
	    		String padded = c.substring(unpadded.length()) + unpadded;
	    		Jamcoin thisJamcoin = new Jamcoin("1" + padded + "1");
	    		if(thisJamcoin.isValid()) {
	    			jamcoins.add(thisJamcoin);
	    			//System.out.println("Got " + thisJamcoin + " as a Jamcoin.");
	    		}
	    	}
    	}
    	return jamcoins;
    }

}

class Jamcoin {
	private int[] divisors = new int[9];
	private String coin;
	private boolean isValid;
	
	public Jamcoin(String coin) {
		this.coin = coin;
		this.isValid = !this.foundPrimes();
		if(this.isValid) {
			// If we're actually dealing with a legit jamcoin, find the divisors
			for(int i = 2; i <= 10; i++) {
				divisors[i-2] = this.getLeastDivisor(this.baseN(i));
			}
		}
	}

	// Helper methods
	private boolean foundPrimes() {
		for(int i = 2; i <= 10; i++) {
			long x = Long.valueOf(baseN(i));
			if(this.isPrime(x)) return true;
		}
		return false;
	}

	private int baseN(int n) {
		int sum = 0;
		for(int i = 0; i < this.coin.length(); i++) {
			sum += ((int) (Math.pow(n, i))) * Integer.parseInt(String.valueOf(this.coin.charAt(i)));
		}
		return sum;
	}

	private int getLeastDivisor(int n) {
		for(int i = 2; i <= n / 2; i++) {
			if(n % i == 0) return i;
		}
		return -1;
	}

	private boolean isPrime(long n) {
		if(n > 2 && (n & 1) == 0) return false;
		for(int i = 3; i * i <= n; i += 2)
			if (n % i == 0) return false;
			return true;
	}

	// Accessor methods
	public String getDivisors() {
		String r = "";
		for(int i = 0; i < this.divisors.length; i++) {
			r += " " + this.divisors[i];
		}
		return r;
	}

	public String toString() {
		return this.coin + this.getDivisors();
	}

	public boolean isValid() {
		return this.isValid;
	}
}
