import java.util.*;
import static java.lang.Math.*;
import java.math.BigInteger;

public class CJamCoin {
  private static ArrayList<Integer> primes;
  private static int N = 32;
  private static int J = 500;

  public static void main(String[] args) {
    System.out.println("Case #1:");

    long[] factors = new long[9];
    outer: for(long bitNum = (1L << N - 1) + 1; true; bitNum += 2) {
      if(J == 0)
        return;

      String bitString = Long.toString(bitNum, 2);

      for(int base = 2; base <= 10; ++base) {
        BigInteger val = new BigInteger(bitString, base);

        if(val.isProbablePrime(25))
          continue outer;
        factors[base - 2] = findFactor(val);
        if(factors[base - 2] == -1)
          continue outer;
      }

      System.out.print(bitString);
      for(int i = 0; i < 9; ++i)
        System.out.print(" " + factors[i]);
      System.out.println();
      --J;
    }
  }

  private static long findFactor(BigInteger val) {
    for(BigInteger i = BigInteger.valueOf(3); i.compareTo(BigInteger.valueOf(1_000_000)) <= 0; i = i.add(BigInteger.valueOf(2))) {
      if(val.mod(i).compareTo(BigInteger.ZERO) == 0)
        return i.intValue() ;
    }
    return -1;
  }
}
