import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class B implements Runnable {

	public static void main(String[] args) {
		new Thread(new B()).start();
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	int rows, cols, fall;
	char[][] s;
	int[][][] can;

	private void solve() throws Exception {
		BufferedReader br = new BufferedReader(new FileReader("b.in"));
		PrintWriter pw = new PrintWriter("b.out");
		
		int tests = Integer.parseInt(br.readLine().trim());
		for (int test = 1; test <= tests; test++) {
			StringTokenizer st = new StringTokenizer(br.readLine());
			rows = Integer.parseInt(st.nextToken());
			cols = Integer.parseInt(st.nextToken());
			fall = Integer.parseInt(st.nextToken());
			
			s = new char[rows + 1][];
			for (int i = 0; i < rows; i++) {
				s[i] = br.readLine().toCharArray();
			}
			s[rows] = new char[cols];
			for (int i = 0; i < cols; i++) {
				s[rows][i] = '#';
			}
			
			int inf = Integer.MAX_VALUE / 3;
			
			can = new int[rows][cols][cols];
			for (int i = 0; i < rows; i++) {
				for (int j = 0; j < cols; j++) {
					for (int k = 0; k < cols; k++) {
						can[i][j][k] = inf;
					}
				}
			}
			
			int right = 0;
			while (right + 1 < cols && s[1][right + 1] == '#') {
				right++;
			}
			for (int i = 0; i <= right; i++) {
				can[0][i][i] = 0;
			}
			
			for (int i = 0; i < rows - 1; i++) {
				for (int j = 0; j < cols; j++) {
					for (int k = j; k < cols; k++) {
						if (can[i][j][k] == inf) {
							continue;
						}

						//move to the right
						if (k + 1 < cols && s[i][k + 1] == '.' && s[i + 1][k + 1] == '#') {
							if (can[i][j][k + 1] > can[i][j][k]) {
								can[i][j][k + 1] = can[i][j][k];
							}
						}
						
						//fall to the left
						if (j > 0 && s[i][j - 1] == '.' && s[i + 1][j - 1] == '.') {
							down(i, j - 1, can[i][j][k], fall);
						}
						//fall inside
						for (int t = j; t <= k; t++) {
							if (s[i + 1][t] == '.') {
								down(i, t, can[i][j][k], fall);
							}
						}
						//fall to the right
						if (k + 1 < cols && s[i][k + 1] == '.' && s[i + 1][k + 1] == '.') {
							down(i, k + 1, can[i][j][k], fall);
						}
						
						if (j < k) {
							if (s[i + 1][j] != '.') {
								goright(i, j, k, j, k - 1, can[i][j][k] + (k - j));
							}
							if (s[i + 1][k] != '.') {
								for (int t = j + 1; t <= k; t++) {
									goleft(i, j, k, t, k, can[i][j][k] + (k - t + 1));
								}
							}
						}
					}
				}
			}
			
			int result = inf;
			for (int i = 0; i < cols; i++) {
				for (int j = i; j < cols; j++) {
					result = Math.min(result, can[rows - 1][i][j]);
				}
			}
		
			if (result == inf) {
				pw.println("Case #" + test + ": No");
			} else {
				pw.println("Case #" + test + ": Yes " + result);
			}
		}
		
		br.close();
		pw.close();
	}

	private void goright(int i, int j, int k, int left, int right, int v) {
		for (int t = right; t >= left; t--) {
			if (s[i + 2][t] == '.') {
				down(i + 2, t, v, fall - 2);
				if (t < right && can[i + 1][t][right] > v) {
					can[i + 1][t][right] = v;
				}
				return;
			}
		}
		if (can[i + 1][left][right] > v) {
			can[i + 1][left][right] = v;
		}
	}

	private void goleft(int i, int j, int k, int left, int right, int v) {
		for (int t = left; t <= right; t++) {
			if (s[i + 2][t] == '.') {
				down(i + 2, t, v, fall - 2);
				if (t > left && can[i + 1][left][t] > v) {
					can[i + 1][left][t] = v;
				}
				return;
			}
		}
		if (can[i + 1][left][right] > v) {
			can[i + 1][left][right] = v;
		}
	}

	private void down(int i, int j, int v, int fall) {
		int k = i;
		while (k + 1 < rows && s[k + 1][j] == '.') {
			k++;
		}
		if (k - i <= fall) {
			int left = j;
			while (left > 0 && s[k][left - 1] == '.' && s[k + 1][left - 1] == '#') {
				left--;
			}
			int right = j;
			while (right + 1 < cols && s[k][right + 1] == '.' && s[k + 1][right + 1] == '#') {
				right++;
			}
			
			for (int t = left; t <= right; t++) {
				if (can[k][t][t] > v) {
					can[k][t][t] = v;
				}
			}
		}
	}

}
