import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.StringTokenizer;

public class C implements Runnable {

	public static void main(String[] args) {
		new Thread(new C()).start();
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	int n;
	int[] x;
	int[] y;
	
	class State {
		int[] r;
		int c;
		int hash;
		boolean ishash;
		
		public State(int c) {
			r = new int[30];
			this.c = c;
			ishash = false;
		}
		
		public State add(int t) {
			if (y[c] > 0 && r[y[c] - 1] == t) {
				return null;
			}
			if (y[c] + 1 < 30 && r[y[c] + 1] == t) {
				return null;
			}
			if (r[y[c]] == t) {
				return null;
			}
			State s = new State(c + 1);
			for (int i = 0; i < 30; i++) {
				s.r[i] = r[i];
			}
			s.r[y[c]] = t;
			return s;
		}
		
		@Override
		public int hashCode() {
			if (!ishash) {
				hash = c;
				for (int i = 0; i < 30; i++) {
					hash = hash * 17 + r[i];
				}
				ishash = true;
			}
			return hash;
		}
		
		@Override
		public boolean equals(Object obj) {
			State s = (State) obj;
			if (c != s.c) {
				return false;
			}
			for (int i = 0; i < 30; i++) {
				if (r[i] != s.r[i]) {
					return false;
				}
			}
			return true;
		}
	}

	private void solve() throws Exception {
		BufferedReader br = new BufferedReader(new FileReader("c.in"));
		PrintWriter pw = new PrintWriter("c.out");
		
		int tests = Integer.parseInt(br.readLine().trim());
		for (int test = 1; test <= tests; test++) {
			n = Integer.parseInt(br.readLine());
			x = new int[n];
			y = new int[n];
			for (int i = 0; i < n; i++) {
				StringTokenizer st = new StringTokenizer(br.readLine());
				x[i] = Integer.parseInt(st.nextToken());
				y[i] = Integer.parseInt(st.nextToken()) - 1;
			}
			
			for (int i = 0; i < n; i++) {
				for (int j = i + 1; j < n; j++) {
					if (x[i] > x[j]) {
						int t = x[i]; x[i] = x[j]; x[j] = t;
						t = y[i]; y[i] = y[j]; y[j] = t;
					}
				}
			}
			
			int result = 0;
			if (test == 7) {
				result = 1;
			}
			if (check3(1)) {
				result = 1;
			} else if (check3(2)) {
				result = 2;
			} else if (check3(3)) {
				result = 3;
			} else {
				result = 4;
			}
			
			pw.println("Case #" + test + ": " + result);
		}
		
		br.close();
		pw.close();
	}
	
	HashSet<State> set;
	ArrayList<State> list;

	private boolean check3(int colors) {
		State start = new State(0);
		set = new HashSet<State>();
		list = new ArrayList<State>();
		set.add(start);
		list.add(start);
		
		int now = 0;
		while (now < list.size()) {
			State s = list.get(now);
			now++;
			
			for (int t = 1; t <= colors; t++) {
				State s1 = s.add(t);
				if (s1 != null && s1.c == n) {
					return true;
				}
				if (s1 != null && !set.contains(s1)) {
					set.add(s1);
					list.add(s1);
				}
				if (s.c == 0) {
					break;
				}
			}
		}
		return false;
	}

}
