import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Main implements Runnable {

	public static void main(String[] args) {
		new Thread(new Main()).start();
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	BufferedReader br;
	PrintWriter pw;
	char[][] c, nc;
	int n, m;
	Ver[] v;
	int cv;
	boolean[] u;
	int[] match, lmatch;

	int[] dx = {0, 0, 1, -1};
	int[] dy = {1, -1, 0, 0};
	int[] bdir = {1, 0, 3, 2};

	class Ver {
		int x, y, ind;
		boolean left;
		ArrayList<Ver> e;
	}

	private void solve() throws Exception {
		br = new BufferedReader(new FileReader("e.in"));
		pw = new PrintWriter("e.out");

		int tests = Integer.parseInt(br.readLine().trim());
		for (int test = 1; test <= tests; test++) {
			pw.print("Case #" + test + ": ");
			runtest();
		}

		br.close();
		pw.close();
	}

	private void runtest() throws Exception {
		StringTokenizer st = new StringTokenizer(br.readLine());
		n = Integer.parseInt(st.nextToken());
		m = Integer.parseInt(st.nextToken());

		c = new char[n][];
		for (int i = 0; i < n; i++) {
			c[i] = br.readLine().toCharArray();
		}
		nc = new char[n][m];

		while (true) {
			boolean flag = false;
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					if (c[i][j] == '?' && count(i, j, '#') > 1) {
						c[i][j] = '.';
						flag = true;
					}
				}
			}

			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					if (c[i][j] == '?') {
						for (int dir = 0; dir < 4; dir++) {
							int ni = i + dx[dir];
							int nj = j + dy[dir];
							if (ni > 0 && ni < n && nj > 0 && nj < m && c[ni][nj] == '?') {
								if (count(i, j, '?') == 1 && count(ni, nj, '?') == 1 &&
										count(i, j, '#') == 0 && count(ni, nj, '#') == 0) {
									c[i][j] = '#';
									c[ni][nj] = '#';
									flag = true;
									break;
								}
							}
						}
					}
				}
			}

			if (!flag) {
				break;
			}
		}

		v = new Ver[n * m];
		for (int i = 0; i < n * m; i++) {
			v[i] = new Ver();
			v[i].e = new ArrayList<Ver>();
		}
		u = new boolean[m * n];
		match = new int[m * n];
		lmatch = new int[m * n];


		int result = go();

		for (int x = 0; x < n; x++) {
			for (int y = 0; y < m; y++) {
				if (c[x][y] == '?' && count(x, y, '#') == 1) {
					c[x][y] = '#';
					int res = go();
					if (res > result) {
						result = res;
					}
					c[x][y] = '.';
					res = go();
					if (res > result) {
						result = res;
					}
					c[x][y] = '?';
				}
			}
		}

		pw.println(result);
	}

	int go() {
		cv = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (c[i][j] == '?') {
					v[cv].e.clear();
					v[cv].ind = cv;
					v[cv].x = i;
					v[cv].y = j;
					v[cv].left = ((i + j) % 2 == 0);
					cv++;
				}
			}
		}

		for (int i = 0; i < cv; i++) {
			for (int j = i + 1; j < cv; j++) {
				for (int dir = 0; dir < 4; dir++) {
					if (v[i].x + dx[dir] == v[j].x && v[i].y + dy[dir] == v[j].y) {
						v[i].e.add(v[j]);
						v[j].e.add(v[i]);
					}
				}
			}
		}

		Arrays.fill(match, -1);
		for (int i = 0; i < cv; i++) {
			if (!v[i].left) {
				continue;
			}
			Arrays.fill(u, false);
			dfs(i);
		}

		Arrays.fill(lmatch, -1);
		for (int i = 0; i < cv; i++) {
			if (match[i] != -1) {
				lmatch[match[i]] = i;
			}
		}

		Arrays.fill(u, false);
		for (int i = 0; i < cv; i++) {
			if (v[i].left && lmatch[i] == -1) {
				dfs2(i);
			}
		}

		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				nc[i][j] = c[i][j];
			}
		}

		for (int i = 0; i < cv; i++) {
			boolean use = false;
			if (v[i].left && u[i]) {
				use = true;
			}
			if (!v[i].left && !u[i]) {
				use = true;
			}
			if (use) {
				nc[v[i].x][v[i].y] = '#';
			} else {
				nc[v[i].x][v[i].y] = '.';
			}
		}

		int res = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (nc[i][j] == '#') {
					res += 4 - count2(i, j, '#');
				}
			}
		}
		return res;
	}

	private void dfs2(int i) {
		if (u[i]) {
			return;
		}
		u[i] = true;
		for (Ver ver : v[i].e) {
			int j = ver.ind;
			u[j] = true;
			if (match[j] != -1) {
				dfs(match[j]);
			}
		}
	}

	private boolean dfs(int i) {
		if (u[i]) {
			return false;
		}
		u[i] = true;
		for (Ver ver : v[i].e) {
			int j = ver.ind;
			if (match[j] == -1 || dfs(match[j])) {
				match[j] = i;
				return true;
			}
		}
		return false;
	}

	private int count(int i, int j, char ch) {
		int res = 0;
		if (i > 0 && c[i - 1][j] == ch) {
			res++;
		}
		if (i + 1 < n && c[i + 1][j] == ch) {
			res++;
		}
		if (j > 0 && c[i][j - 1] == ch) {
			res++;
		}
		if (j + 1 < m && c[i][j + 1] == ch) {
			res++;
		}
		return res;
	}

	private int count2(int i, int j, char ch) {
		int res = 0;
		if (i > 0 && nc[i - 1][j] == ch) {
			res++;
		}
		if (i + 1 < n && nc[i + 1][j] == ch) {
			res++;
		}
		if (j > 0 && nc[i][j - 1] == ch) {
			res++;
		}
		if (j + 1 < m && nc[i][j + 1] == ch) {
			res++;
		}
		return res;
	}
}
