import java.util.*;
import java.io.*;

public class BathroomStalls {
    public static void main(String[] args) throws IOException{
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        int t=Integer.parseInt(br.readLine());
        for(int i=1;i<=t;i++) {
            String input = br.readLine();
            long n = Long.parseLong(input.split("\\s")[0]),k=Long.parseLong(input.split("\\s")[1]);
            System.out.println("Case #"+i+": "+ solution(n,k));
        }
    }

    private static class StallState {
        long space;
        long count;
        public StallState(long space,long count) {
            this.space=space;
            this.count=count;
        }
        public String toString() {
            return "space = " + space + ",count = " + count;
        }
    }

    private static int getHighest(List<StallState> stateList,int start) {
        long maxSpace=0;
        int maxInd=start;
        for(int i=start;i<stateList.size();i++){
            if(stateList.get(i).space>maxSpace) {
                maxSpace=stateList.get(i).space;
                maxInd=i;
            }
        }
        return maxInd;
    }
    private static StallState findSpace(List<StallState> stateList,long space,int start){
        for(int i=start;i<stateList.size();i++) {
            if(stateList.get(i).space==space){
                return stateList.get(i);
            }
        }
        StallState stall = new StallState(space,0);
        stateList.add(stall);
        return stall;
    }
    private static void printList(List<StallState> stateList) {
        for(int i=0;i<stateList.size();i++) {
            System.out.println(stateList.get(i).toString());
        }
    }
    private static String solution(long n, long k) {
        List<StallState> stateList = new ArrayList<StallState>();
        stateList.add(new StallState(n,1));
        int index=0,emptyIndex=0;
        while(k>0){
            //printList(stateList);
            index = getHighest(stateList,emptyIndex);
            //System.out.println("index returned = " + index);
            if((k-stateList.get(index).count)<1){ break; }
            else {
                if(stateList.get(index).space%2!=0) {
                    StallState new_ind = findSpace(stateList,((stateList.get(index).space-1)/2),emptyIndex);
                    new_ind.count+=stateList.get(index).count*2;
                }else {
                    StallState ind_one = findSpace(stateList,stateList.get(index).space/2,emptyIndex);
                    ind_one.count+=stateList.get(index).count;
                    StallState ind_two = findSpace(stateList,(stateList.get(index).space/2)-1,emptyIndex);
                    ind_two.count+=stateList.get(index).count;
                }
                //System.out.println("value of k " + k);
                k-=stateList.get(index).count;
                stateList.get(index).count=0;
                stateList.get(index).space=0;
                emptyIndex=index+1;
            }
        }
        if(stateList.get(index).space%2!=0){
            String res = new Long((stateList.get(index).space-1)/2).toString();
            return res+" "+res;
        }else {
            long res_even= stateList.get(index).space/2;
            return new Long(res_even).toString()+" "+ new Long(res_even-1).toString();
        }
    }
}