package com.google.codejam;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Scanner;

public class CoinJam {

	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int numberOfTestCases = in.nextInt();
		int x = 1;
		Map<Long, Long> inputNumberList = new HashMap<Long, Long>();
		for (int i = 0; i < numberOfTestCases; i++) {
			inputNumberList.put(in.nextLong(), in.nextLong());
		}
		for (Map.Entry<Long, Long>  entry : inputNumberList.entrySet()) {
			System.out.println("Case #" + x + ":");
			printPossibleCoinJams(entry);
			x++;
		}
	}
	
	private static void printPossibleCoinJams(Entry<Long, Long> entry) {
		Long givenNumber = entry.getKey();
		Long solutions = entry.getValue();
		StringBuilder middleNumber = new StringBuilder();
		for (int i = 0; i < givenNumber - 2 ; i ++) {
			middleNumber.append("0");
		}
		Long possibleMiddleNumbers = (long)Math.pow(2, givenNumber - 2);
		List<Long> divisors = new ArrayList<Long>();
		while (solutions > 0 && possibleMiddleNumbers > 0) {
			divisors.removeAll(divisors);
			String number = prepareNumber(middleNumber);
//			System.out.println(number);
			if(checkIfCoinJam(number, divisors)){
				printAnswer(number, divisors);
				solutions = solutions - 1;
			}
			middleNumber.replace(0, middleNumber.length(), getNextMiddleNumber(middleNumber.toString()));
			possibleMiddleNumbers = possibleMiddleNumbers - 1;
		}
	}

	private static void printAnswer(String number, List<Long> divisors) {
		System.out.print(number);
		for (Long divisor : divisors) {
			System.out.print(" ");
			System.out.print(divisor);
		}
		System.out.println();
	}

	private static boolean checkIfCoinJam(String number, List<Long> divisors) {
		for (int i = 2; i <= 10; i++) {
			Long temp = convertToBase(number, i);
			if(isPrimeNumber(temp)){
				return false;
			}
			divisors.add(findDivisor(temp));
		}
		return true;
	}

	private static String getNextMiddleNumber(String middleNumber) {
		String base10 = middleNumber.toString();
		Long nextNumber = convertToBase(base10, 2);
		nextNumber = nextNumber + 1;
		String base2 = nextNumber.toString();
		base2 = Long.toBinaryString(nextNumber);
		StringBuilder temp = new StringBuilder();
		if (base2.length() < middleNumber.length()) {
			Integer diffLen = middleNumber.length() - base2.length();
			while (diffLen > 0) {
				temp.append("0");
				diffLen--;
			}
			temp.append(base2);
		} else { 
			temp.append(base2);
		}
		return temp.toString();
	}

	private static String prepareNumber(StringBuilder middleNumber) {
		StringBuilder first = new StringBuilder("1");
		first.append(middleNumber.toString());
		first.append("1");
		return first.toString();
	}

	private static boolean isPrimeNumber(Long number){
//		System.out.println(number);
//        for(Long i=2l; i<=number/2; i++){
//        	System.out.println(i);
//            if(number % i == 0){
//                return false;
//            }
//        }
//        return true;
		Long i;
	    if (number==2)
	        return true;
	    if (number%2==0)
	        return false;
	    for (i=3l;i<=Math.sqrt(number);i+=2)
	        if (number%i==0)
	            return false;
	    return true;
    }
	
	private static Long convertToBase(String string, int base) {
		Long number = Long.parseLong(string);
		Long result = 0l;
		long temp = 0;
		long i = 0;
		while(number > 0){
			temp = number % 10;
			number = number/10;
			result = result + (long)Math.pow(base, i) * temp;
			i++;
		}
		return result;
	}
	
	private static Long findDivisor(Long number){
		Long divisor = 0l;
		for (divisor = 2l; divisor < number; divisor++) {
		    if (number % divisor == 0)
		        break;
		}
		return divisor;
	}

}
