/**
 * 
 */
package round.qaulification;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * @author Dhiraj Khot
 *
 */
public class TidyNumbers {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int numberOfTestCases = in.nextInt();
		List<BigInteger> inputLastNumber = new ArrayList<>();
		for (int i = 0; i < numberOfTestCases; i++) {
			inputLastNumber.add(new BigInteger(in.next()));
		}
		Integer testCase = 1;
		for (BigInteger input : inputLastNumber) {
			System.out.println("Case #" + testCase + ": " + findTidyNumber(input));
			testCase++;
		}

	}

	private static BigInteger findTidyNumber(BigInteger input) {
		BigInteger tidyNumber;
		String stringRepresentation = input.toString();
		
		// Single digit
		if (stringRepresentation.length() == 1)
			return input;
		
		int length = stringRepresentation.length();
		char [] digit = stringRepresentation.toCharArray();
		int i = 1;
		
		// Find the first decreasing point from left to right
		while (i < length) {
			if (digit[i] < digit[i-1]) {
				break;
			}
			i++;
		}
		
		// if whole string is parsed that means whole string is in increasing fashion
		if (i == length) {
			tidyNumber = new BigInteger(stringRepresentation);
		} else {
			
			// Point to the lesser value of the decreasing point
			i--;
			
			// Traverse in the reverse way while the preceding digits are same. 
			while (i > 0 && digit[i] == digit[i-1])
				i--;
			
			// Reduce the lesser digit by 1
			int reduceDigit = (int)digit[i] - 1;
			digit[i] = (char)reduceDigit;
			
			// go to next part 
			i++;
			
			// Further make all digits to 9
			while (i < length) {
				int digit9 = 57;
				digit[i] = (char)digit9;
				i++;
			}
			stringRepresentation = new String(digit);
			tidyNumber = new BigInteger(stringRepresentation);
		}
		
		return tidyNumber;
	}

}
