/**
 * 
 */
package round.qaulification;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * @author Dhiraj
 *
 */
public class BathroomStalls {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int numberOfTestCases = in.nextInt();
		List<List<BigInteger>> inputSet = new ArrayList<>();
		for (int i = 0; i < numberOfTestCases; i++) {
			List<BigInteger> set = new ArrayList<>();
			set.add(new BigInteger(in.next()));
			set.add(new BigInteger(in.next()));
			inputSet.add(set);
		}
		Integer testCase = 1;
		for (List<BigInteger> input : inputSet) {
			List<BigInteger> outputSet = findLastSetValues(input);
			System.out.println("Case #" + testCase + ": " + outputSet.get(0) + " " + outputSet.get(1));
			testCase++;
		}

	}

	private static List<BigInteger> findLastSetValues(List<BigInteger> input) {
		
		// Get the values of N and K from the input
		List<BigInteger> lastSetValue = new ArrayList<>();
		BigInteger currentN = input.get(0);
		BigInteger currentK = input.get(1);
		BigInteger maxValue;
		BigInteger minValue;
		
		// If currentN and currentK both are ONE then return the lastSetValue as 0,0
		if (currentN.equals(BigInteger.ONE) && currentK.equals(BigInteger.ONE)) {
			lastSetValue.add(BigInteger.ZERO);
			lastSetValue.add(BigInteger.ZERO);
			return lastSetValue;
			
		// If the currentK alone is ONE set maxValue and minValue as per the value of currentN mod 2	
		} else if (currentK.equals(BigInteger.ONE)) {
			maxValue = currentN.divide(BigInteger.valueOf(2));
			if (currentN.mod(BigInteger.valueOf(2)).equals(BigInteger.ZERO)) 
				minValue = maxValue.subtract(BigInteger.ONE);
			else 
				minValue = currentN.divide(BigInteger.valueOf(2));
			lastSetValue.add(maxValue);
			lastSetValue.add(minValue);
			return lastSetValue;
		}
		
		// Calculate maxValue and minValue
		maxValue = currentN.divide(BigInteger.valueOf(2));
		if (currentN.mod(BigInteger.valueOf(2)).equals(BigInteger.ZERO)) 
			minValue = maxValue.subtract(BigInteger.ONE);
		else 
			minValue = currentN.divide(BigInteger.valueOf(2));
		
		
		BigInteger newK;
		BigInteger newN;
		
		// Calculate newN and newK
		if (currentK.mod(BigInteger.valueOf(2)).equals(BigInteger.ZERO)) 
			newN = maxValue;
		else 
			newN = minValue;
		newK = currentK.divide(BigInteger.valueOf(2));

		lastSetValue.add(newN);
		lastSetValue.add(newK);
		
		// check for lastSetValues for newN and newK
		lastSetValue = findLastSetValues(lastSetValue);	
		
		return lastSetValue;
	}

}
