import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;


public class MinesweeperMaster {
	
	static public class Tuple { 
		public int x, y;
		public int remove_x, remove_y;
		public Tuple(int x, int y, int remove_x, int remove_y) {
			this.x = x;
			this.y = y;
			this.remove_x = remove_x;
			this.remove_y = remove_y;
		}
	} 
	
	static public Tuple getTuple(int r, int c, int nb_empty) {
		if (nb_empty == 1) {
			return new Tuple(0, 0, 0, 0);
		}
		if (nb_empty <= 3) {
			return null;
		}
		for (int i = 2; i <= r; i++) {
			for (int j = 2; j <= c; j++) {
				if (i * j == nb_empty) {
					return new Tuple(i - 1, j - 1, 0, 0);
				} else if (i * j >= nb_empty && nb_empty >= i * j - (i - 2) - (j - 3)) {
					int a = i * j - nb_empty;
					int b = 0;
					if (a > i - 2) {
						b = a - (i - 2);
						a = i - 2;
					}
					if (j - a >= 2 && i - b >= 2)
						return new Tuple(i - 1, j - 1, a, b);
				}
			}
		}
		return null;
	}
	
	static public void checkIfPossible(int r, int c, int m) {
		int nb_cases = r * c;
		int nb_empty = nb_cases - m;
		if (m >= nb_cases) {
			System.out.println("Impossible");
			return;
		}
		if (c == 1) {
			for (int i = 1; i <= nb_cases; i ++) {
				if (i == 1)
					System.out.println("c");
				else if (i <= nb_empty)
					System.out.println(".");
				else
					System.out.println("*");
			}
			return;
		}
		if (r == 1) {
			String result = "";
			for (int i = 1; i <= nb_cases; i ++) {
				if (i == 1)
					result += "c";
				else if (i <= nb_empty)
					result += ".";
				else
					result += "*";
			}
			System.out.println(result);
			return;
		}
		
		Tuple t = getTuple(r, c, nb_empty);
		if (t == null) {
			System.out.println("Impossible");
			return;
		} else {
			for (int i = 0; i < r; i++) {
				String s = "";
				for (int j = 0; j < c; j++) {
					if (i == 0 && j == 0) {
						s += "c";
					} else {
						boolean is_empty = false;
						is_empty |= (i < t.x && j < t.y);
						if (i == t.x && j == t.y) {
							is_empty = (t.remove_x == 0 && t.remove_y == 0);
						} else {
							is_empty |= (i == t.x && j <= t.y - t.remove_x);
							is_empty |= (j == t.y && i <= t.x - (t.remove_y == 0 ? 0 : t.remove_y + 1));
						}
						s += is_empty ? "." : "*";
					}
				}
				System.out.println(s);
			}
		}
	}
	
	static public void solve() throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String input;
		input = br.readLine();
		int nb_pb = Integer.valueOf(input);
		int r, c, m;
		for (int i = 1; i <= nb_pb; i++) {
			input = br.readLine();
			String[] splitted = input.split(" ");
			r = Integer.valueOf(splitted[0]);
			c = Integer.valueOf(splitted[1]);
			m = Integer.valueOf(splitted[2]);
			System.out.println("Case #" + i + ":");
			checkIfPossible(r, c, m);
		}
	}
	

}


