import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.Collections;


public class Repeater {
	
	
	public static String getSequence(String s) {
		StringBuilder result = new StringBuilder();
		for (int i = 0; i < s.length(); i++) {
			int l = result.length();
			if (l == 0 || result.charAt(l-1) != s.charAt(i)) {
				result.append(s.charAt(i));
			}
		}
		return result.toString();
	}
	
	public static int[] getSequenceInt(String s, int n) {
		int[] result = new int[n];
		char c = '!';
		int j = -1;
		for (int i = 0; i < s.length(); i++) {
			if (i == 0 || c != s.charAt(i)) {
				j++;
			}
			result[j]++;
			c = s.charAt(i);
		}
		
		return result;
	}
	
	
	public static void solve() throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String input;
		input = br.readLine();
		int nb_pb = Integer.valueOf(input);
		int nb_strings;
		
		
		for (int k = 1; k <= nb_pb; k++) {
			
			
			nb_strings = Integer.valueOf(br.readLine());
			
			String[] words = new String[nb_strings];
			
			for (int j = 0; j < nb_strings; j++) {
				words[j] = br.readLine();
			}
			
			String sequence = "";
			boolean possible = true;
			
			int solution = -1;
			
			
			for (int j = 0; j < nb_strings; j++) {
				if (j == 0) {
					sequence = getSequence(words[j]);
				} else if (!getSequence(words[j]).equals(sequence)) {
					possible = false;
				}
			}
			
			if (possible) {
				int seq_length = sequence.length();
				int[][] matrix = new int[nb_strings][];
				for (int i = 0; i < nb_strings; i++) {
					matrix[i] = getSequenceInt(words[i], seq_length);
				}
				solution = 0;
				
				for (int j = 0; j < seq_length; j++) {
					int best1 = 0, best2 = 0;
					int moyenne = 0;
					for (int i = 0; i < nb_strings; i++) {
						moyenne += matrix[i][j];
					}
					moyenne /= nb_strings;
					
					for (int i = 0; i < nb_strings; i++) {
						best1 += Math.abs(matrix[i][j] - moyenne - 1);
						best2 += Math.abs(matrix[i][j] - moyenne);
					}
					
					solution += Math.min(best1, best2);				
				}
				
				
			}
			
		    if (possible) {
		    	System.out.println("Case #" + k + ": " + solution);
		    } else {
		    	System.out.println("Case #" + k + ": Fegla Won");
		    }
			
			
		}
		
	}
		
	
	

}
