package common;

import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.nio.file.StandardOpenOption;
import java.util.List;

/**
 * @author Dzmitry Horbach
 */
public class FileUtil {

    public static List<String> readFile(String fileName) throws IOException {
        return Files.readAllLines(
                FileSystems.getDefault().getPath(fileName), StandardCharsets.UTF_8);
    }

    public static List<String> readMainFile(String fileName) throws IOException {
        return readFile("src/main/resources" + fileName);
    }

    public static void writeFile(String fileName, List<String> lines) throws IOException {
        try {
            BufferedWriter writer =
                    Files.newBufferedWriter(
                            FileSystems.getDefault().getPath(".", fileName),
                            Charset.forName("UTF-8"),
                            StandardOpenOption.CREATE, StandardOpenOption.WRITE);

            for(String line : lines){
                writer.write(line);
                writer.newLine();
            }
            writer.close();
        }
        catch ( IOException ioe ) {
            ioe.printStackTrace();
        }
    }
}
