package codejam.comp2013.qualification.a;

import codejam.comp2013.Folders;
import common.FileUtil;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Dzmitry Horbach
 */
public class ASolver {

    public static void solve(String fileName) throws IOException {
        List<ACase> cases = extractCases(fileName);
        List<String> results = new ArrayList<>();
        for (ACase caze : cases) {
            String result = caze.solve();
            results.add(result);
        }
        FileUtil.writeFile(Folders.F_2013_QUALI_A_R + "test-a-output.txt", results);
    }

    public static List<ACase> extractCases(String fileName) throws IOException {
        List<ACase> cases = new ArrayList<>();
        List<String> lines = FileUtil.readFile(fileName);
        int numCases = Integer.valueOf(lines.get(0));
        for (int c = 0; c < numCases; c++) {
            int caseRow = c * 5 + 1;
            ACase caze = new ACase();
            cases.add(caze);
            for (int i = 0; i < 4; i++) {
                String line = lines.get(caseRow + i);
                for (int j = 0; j < 4; j++) {
                    char ch = line.charAt(j);
                    int charValue = 0;
                    switch (ch) {
                        case 'X':
                            charValue = 1;
                            break;
                        case 'O':
                            charValue = 10;
                            break;
                        case 'T':
                            charValue = 2;
                            break;
                    }
                    caze.set(i, j, charValue);
                }
            }
        }
        return cases;
    }
}
