package codejam.comp2013.qualification.c;

import codejam.comp2013.Folders;
import common.FileUtil;
import common.NumberUtil;

import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Dzmitry Horbach
 */
public class CSolver {
    public static void solve(String fileName) throws IOException {
        List<CCase> cases = extractCases(fileName);
        List<String> results = new ArrayList<>();
        for (CCase caze : cases) {
            String result = caze.solve();
            results.add(result);
        }
        FileUtil.writeFile(Folders.F_2013_QUALI_C_R + "c-output.txt", results);
    }

    public static List<CCase> extractCases(String fileName) throws IOException {
        List<CCase> cases = new ArrayList<>();
        List<String> lines = FileUtil.readFile(fileName);
        int numCases = Integer.valueOf(lines.get(0));
        for (int c = 1; c <= numCases; c++) {
            String[] range = lines.get(c).split(" ");
            CCase caze = new CCase(new BigInteger(range[0]), new BigInteger(range[1]));
            cases.add(caze);
        }
        return cases;
    }
}

class CCase {

    private static int caseGenerator = 0;
    private final int caseNumber;

    private BigInteger A;
    private BigInteger B;

    public CCase(BigInteger from, BigInteger to) {
        caseNumber = ++caseGenerator;
        A = from;
        B = to;
    }

    public String solve() {
        int counter = 0;
        BigInteger from = NumberUtil.sqrt(A);
        while (true) {
            if (NumberUtil.isPalindrome(from.toString())) {
                BigInteger power = from.pow(2);
                if (power.compareTo(B) == 1) {
                    break;
                }
                if (power.compareTo(A) >= 0 && NumberUtil.isPalindrome(power.toString())) {
                    counter += 1;
                }
            }

            from = from.add(new BigInteger("1"));
        }
        return "Case #" + caseNumber + ": " + counter;
    }
}
