package codejam.comp2013.qualification.a;

/**
 * @author Dzmitry Horbach
 */
public class ACase {

    int[][] matrix = new int[4][4];
    boolean hasEmpty = false;

    private static int caseGenerator = 0;
    private final int caseNumber;

    public ACase() {
        caseNumber = ++caseGenerator;
    }

    public void set(int i, int j, int value) {
        matrix[i][j] = value;
        if (value == 0) {
            hasEmpty = true;
        }
    }

    public String solve() {
        for (int i = 0; i < 4; i++) {
            int sumr = 0;
            int sumc = 0;
            for (int j = 0; j < 4; j++) {
                sumr += matrix[i][j];
                sumc += matrix[j][i];
            }
            String winr = whoWin(sumr);
            if (winr != null) {
                return wonResult(winr);
            }
            String winc = whoWin(sumc);
            if (winc != null) {
                return wonResult(winc);
            }
        }

        int sumd1 = 0;
        int sumd2 = 0;
        for (int k = 0; k < 4; k++) {
            sumd1 += matrix[k][k];
            sumd2 += matrix[3 - k][k];
        }
        String wind1 = whoWin(sumd1);
        if (wind1 != null) {
            return wonResult(wind1);
        }
        String wind2 = whoWin(sumd2);
        if (wind2 != null) {
            return wonResult(wind2);
        }

        return hasEmpty ? notCompleted() : draw();
    }

    public String whoWin(int sum) {
        if (sum == 5 || sum == 4) {
            return "X";
        }
        if (sum == 32 || sum == 40) {
            return "O";
        }
        return null;
    }

    private String wonResult(String who) {
        return "Case #" + caseNumber + ": " + who + " won";
    }

    private String draw() {
        return "Case #" + caseNumber + ": Draw";
    }

    private String notCompleted() {
        return "Case #" + caseNumber + ": Game has not completed";
    }
}
