package com.google.codejam.qualification;

import java.io.File;
import java.io.IOException;
import java.math.BigInteger;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Scanner;


public class FairAndSquare {

	private static HashSet<BigInteger> aux = new HashSet<BigInteger>();
	private static BigInteger currentLimit = BigInteger.ONE;
	private static BigInteger currentMarker = BigInteger.ONE;
	
	/**
	 * @param args
	 * @throws IOException 
	 * @throws NumberFormatException 
	 */
	public static void main(String[] args) throws NumberFormatException, IOException {
		Scanner sc = new Scanner(new File("resources/C-small-attempt0.in"));
		int testCases = Integer.parseInt(sc.nextLine().trim());
		int num = 0;
		while(num++ < testCases) {
			String input[] = sc.nextLine().trim().split(" ");
			BigInteger a = new BigInteger(input[0]);
			BigInteger b = new BigInteger(input[1]);
			if(b.compareTo(currentLimit) == 1) {
				searchAndSave(b);
			}
			int count = 0;
			for(Iterator<BigInteger> it = aux.iterator(); it.hasNext();) {
				BigInteger temp = it.next();
				if(((temp.compareTo(a) == 0) || (temp.compareTo(a) == 1)) && ((temp.compareTo(b) == 0) || (temp.compareTo(b) == -1))) {
					count++;
				}
			}
			System.out.println("Case #" + num + ": " + count);
		}
		sc.close();
	}

	private static void searchAndSave(BigInteger newLimit) {
		while (newLimit.compareTo(currentLimit) != -1) {
			if (palindrome(currentMarker)) {
				BigInteger square = currentMarker.pow(2);
				if (palindrome(square)) {
					aux.add(square);
					currentLimit = square;
				}
			}
			currentMarker = currentMarker.add(BigInteger.ONE);
		}
	}

	private static boolean palindrome(BigInteger num) {
		StringBuilder s = new StringBuilder();
		BigInteger remainder = null;
		while(num.compareTo(BigInteger.ZERO) != 0) {
			remainder = num.remainder(new BigInteger("10"));
			num = num.divide(new BigInteger("10"));
			s.append(remainder.toString());
		}
		String rev = (new StringBuffer(s.toString())).reverse().toString();
		String orig = s.toString();
		if(orig.equals(rev))
			return true;
		else
			return false;
	}

}
