
package alphabetcake;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import javax.swing.JFileChooser;


public class AlphabetCake {


	private static final File outputsFolder = new File("output");
	
	public static void main(String[] args) {
		JFileChooser fileChooser = new JFileChooser("inputs/");
		fileChooser.setMultiSelectionEnabled(false);
		
		if (fileChooser.showSaveDialog(null) == JFileChooser.APPROVE_OPTION) {
			File inputFile = fileChooser.getSelectedFile();

			if (!outputsFolder.exists()) {
				outputsFolder.mkdir();
			}

			//Rewrite Old Output
			File outFile = new File(outputsFolder, inputFile.getName().replace("in", "out"));
			if (outFile.exists()) {
				outFile.delete();
			}

			try (BufferedReader reader = new BufferedReader(new FileReader(inputFile));
					BufferedWriter writer = new BufferedWriter(new FileWriter(outFile))) {
				int testcases = Integer.parseInt(reader.readLine());

				for (int i = 1; i <= testcases; i++) {
					System.out.println(String.format("@Case #%d of %d", i, testcases));
					writer.write("Case #" + i + ": " + "\n");
					
					String line = reader.readLine();
					String[] split = line.split(" ");
					int rows = Integer.parseInt(split[0]);
					int cols = Integer.parseInt(split[1]);
					char [][] cake = new char[rows][cols];
					
					for (int j = 0; j < rows; j++) {
						String row = reader.readLine();
						char lastchar = '?';
						for (int k = 0; k < cols; k++) {
							char ch = row.charAt(k);
							if (ch != '?') {
								if (lastchar == '?') {
									lastchar = ch;
									int l = k;
									while (l >= 0) {
										cake[j][l] = ch;
										l--;
									}
								} else {
									lastchar = ch;
									cake[j][k] = ch;
								}
							} else {
								cake[j][k] = lastchar;
							}

						}
					}
					
					process(cake, rows, cols);
					
					for (int row = 0; row < rows; row++) {
						writer.write(new String(cake[row]) + "\n");
					}
				}
			} catch (FileNotFoundException ex) {
				ex.printStackTrace();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		} else {
			System.out.println("NO FILE SELECTED!");
		}
		
		System.out.println("DONE!");
	}

	private static void process(char[][] cake, int rows, int cols) {
		for (int col = 0; col < cols; col++) {
			char lastchar = '?';
			for (int row = 0; row < rows; row++) {
				char ch = cake[row][col];
				if (ch != '?') {
					if (lastchar == '?') {
						lastchar = ch;
						int l = row;
						while (l >= 0) {
							cake[l][col] = ch;
							l--;
						}
					} else {
						lastchar = ch;
					}
				} else {
					cake[row][col] = lastchar;
				}

			}
		}
	}
}
