package sheepsleep;

import java.util.Scanner;

public class SheepSleep {

	private static final int MAX_TRIES = 200;

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int testcases = sc.nextInt();

		for (int i = 1; i <= testcases; i++) {
			int thought = sc.nextInt();
			int value = process(thought);
			System.out.println("Case #" + i + ": " + (value == -1 ? "INSOMNIA" : value));
		}
	}

	private static int process(int thought) {
		if (thought == 0) {
			return -1;
		}

		boolean[] digits = new boolean[10];	
		for (int i = 1; i < Integer.MAX_VALUE; i++) {
			int number = i * thought;
			do {
				int digit = number % 10;
				number /= 10;
				digits[digit] = true;
				
				if (check(digits)) {
					return i * thought;
				}
			} while (number > 0);
		}

		return -1;
	}
	
	private static boolean check(boolean[] digits) {
		for (boolean b : digits) {
			if (!b) {
				return false;
			}
		}
		
		return true;
	}
}
