
package cruisecontrol;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import javax.swing.JFileChooser;


public class CruiseControl {

	
	private static final File outputsFolder = new File("output");
	
	public static void main(String[] args) {
		JFileChooser fileChooser = new JFileChooser("inputs/");
		fileChooser.setMultiSelectionEnabled(false);
		
		if (fileChooser.showSaveDialog(null) == JFileChooser.APPROVE_OPTION) {
			File inputFile = fileChooser.getSelectedFile();

			if (!outputsFolder.exists()) {
				outputsFolder.mkdir();
			}

			//Rewrite Old Output
			File outFile = new File(outputsFolder, inputFile.getName().replace("in", "out"));
			if (outFile.exists()) {
				outFile.delete();
			}

			try (BufferedReader reader = new BufferedReader(new FileReader(inputFile));
					BufferedWriter writer = new BufferedWriter(new FileWriter(outFile))) {
				int testcases = Integer.parseInt(reader.readLine());

				for (int i = 1; i <= testcases; i++) {
					System.out.println(String.format("@Case #%d of %d", i, testcases));
					String[] split = reader.readLine().split(" ");
					int distance = Integer.parseInt(split[0]);
					int horses = Integer.parseInt(split[1]);
					
					double maxTripTime = 0;
					
					for (int horse = 0; horse < horses; horse++) {
						String[] line = reader.readLine().split(" ");
						int distRemaining = distance - Integer.parseInt(line[0]);
						double tripTime = distRemaining / (double) Integer.parseInt(line[1]);
						
						if (tripTime > maxTripTime) {
							maxTripTime = tripTime;
						}
					}
					
					
					writer.write("Case #" + i + ": " + (distance / maxTripTime) + "\n");
				}
			} catch (FileNotFoundException ex) {
				ex.printStackTrace();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		} else {
			System.out.println("NO FILE SELECTED!");
		}
		
		System.out.println("DONE!");
	}
}
