
package bff;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

public class BFF {

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int testcases = sc.nextInt();

		for (int i = 1; i <= testcases; i++) {
			Kid[] kids = new Kid[sc.nextInt()];
			for (int j = 0; j < kids.length; j++) {
				kids[j] = new Kid(j, sc.nextInt() - 1);
			}

			System.out.println("Case #" + i + ": " + process(kids));
		}
	}

	private static int process(Kid[] kids) {
		int max = 0;
		for (int startpoint = 0; startpoint < kids.length; startpoint++) {
			List<Kid> circle = new ArrayList<>();
			Kid[] kidsclone = Arrays.copyOf(kids, kids.length);
			circle.add(kidsclone[startpoint]);
			kidsclone[startpoint].seated = true;

			while (true) {
				int bff = circle.get(circle.size() - 1).bff;

				if (!kidsclone[bff].seated) {
					circle.add(kidsclone[bff]);
					kidsclone[bff].seated = true;
				} else { //Look for extra unseated
					boolean found = false;
					for (Kid k : kidsclone) {
						if (!k.seated) {
							if (k.bff == circle.get(circle.size() - 1).id) {
								circle.add(k);
								k.seated = true;
								found = true;
								break;
							} else if (k.bff == circle.get(0).id) {
								circle.add(0, k);
								k.seated = true;
								found = true;
								break;
							}
						}
					}

					if (!found) {
						Kid last = circle.get(circle.size() - 1);
						if (last.bff == circle.get(0).id || last.bff == circle.get(Math.max(0, circle.size() - 2)).id) {
							if (circle.size() > max) {
								max = circle.size();
							}
						}
						
						break;
					}
				}
			}
		}
		
		return max;
	}
	
	private static class Kid {
		int id;
		int bff;
		boolean seated = false;

		public Kid(int id, int bff) {
			this.id = id;
			this.bff = bff;
		}

		public int getId() {
			return id;
		}

		
		public int getBff() {
			return bff;
		}

		public boolean isSeated() {
			return seated;
		}

	}
}


