package Fractiles;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Fractiles {
	public static void main (String[] args) throws IOException {
		String directory = "/Users/xinghai/Documents/workspace/googleCodeJam";
		String inputFile = "inputs/D-large.in";
		String outputFile = "outputs/D-large.out";
		BufferedReader br = new BufferedReader(new FileReader(directory+"/"+inputFile));

		BufferedWriter bw = new BufferedWriter(new FileWriter(new File(directory+"/"+outputFile).getAbsoluteFile()));
		
		String line = null;
		int caseNum = 0;
		while ( (line = br.readLine()) != null ) {
			String content = "";
			if (caseNum == 0) {
				caseNum ++;
				continue;
			} else {
				content = "Case #" + Integer.toString(caseNum) + ":" + getOutputContent(line) + "\n";
			}
			bw.write(content);
			caseNum ++;
		}
		br.close();
		bw.close();
	}
	
	public static String getOutputContent(String input) {
		String outputContent = "";
		String[] args = input.split(" ");
		int K = Integer.parseInt(args[0]);
		int C = Integer.parseInt(args[1]);
		int S = Integer.parseInt(args[2]);
		if (S <= K-C)
			outputContent = "IMPOSSIBLE";
		else if (C == 1) {
			for (int i = 0; i < K; i++) {
				outputContent += " ";
				outputContent += Integer.toString(i+1);
			}
		}
		else {
			int del = Math.min(C - 1, K-1);
			int minCheck = Math.max(1, K-C+1);
			
			long startingIdx = 0;
			for (int i = 1; i <= del; i++)
				startingIdx += i * Math.pow(K, C-i-1);
			for (int j = 0; j < minCheck; j++) {
				outputContent += " ";
				outputContent += Long.toString(startingIdx + j + 1);
			}
		}
		return outputContent;
	}
	
}
