import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class CruiseControl {

    static double D;
    static int N;
    static int[][] horses;

    static double solve() {
        Arrays.sort(horses, new Comparator<int[]>() {
            @Override
            public int compare(int[] o1, int[] o2) {
                return o2[0] - o1[0];
            }
        });
        double time = 0;
        for (int i = 0; i < N; i++) {
            time = Math.max(time, (D - horses[i][0])/horses[i][1]);
        }
        return D / time;
    }

    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new FileReader("A.in"));
        PrintWriter pw = new PrintWriter(new FileWriter("A.out"));
        int T = sc.nextInt();
        for (int i = 1; i <= T; i++) {
            D = sc.nextDouble();
            N = sc.nextInt();
            horses = new int[N][2];
            for (int j = 0; j < N; j++) {
                horses[j][0] = sc.nextInt();
                horses[j][1] = sc.nextInt();
            }
            double ans = solve();
            pw.println("Case #" + i + ": " + ans);
        }
        pw.close();
    }

}
