import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class OversizedPancakeFlipperSmall {

    static boolean[] pancakes;
    static int K;

    static int minCount;

    static void flip(int s) {
        for (int i = s; i < s + K; i++) {
            pancakes[i] = !pancakes[i];
        }
    }

    static void runFlips(int cur, int count) {
        if (cur + K > pancakes.length) {
            for (int i = 0; i < pancakes.length; i++) {
                if (!pancakes[i]) {
                    return;
                }
            }
            if (count < minCount) {
                minCount = count;
            }
            return;
        }
        runFlips(cur + 1, count);
        flip(cur);
        runFlips(cur + 1, count + 1);
        flip(cur);
    }

    static int minFlips() {
        minCount = Integer.MAX_VALUE;
        runFlips(0, 0);
        return minCount;
    }

    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new FileReader("A-small.in"));
        PrintWriter pw = new PrintWriter(new FileWriter("A-small.out"));
        int T = sc.nextInt();
        for (int i = 1; i <= T; i++) {
            String[] a = sc.next().split("");
            pancakes = new boolean[a.length];
            for (int j = 0; j < a.length; j++) {
                pancakes[j] = a[j].equals("+");
            }
            K = sc.nextInt();
            int ans = minFlips();
            if (ans == Integer.MAX_VALUE) {
                pw.println("Case #" + i + ": IMPOSSIBLE");
            } else {
                pw.println("Case #" + i + ": " + ans);
            }
        }
        pw.close();
    }

}
