import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class BathroomStallsSmall {

    static int N, K;

    static int y, z;
    static int[][] neighbors;

    static void solve() {
        neighbors = new int[N][2];
        for (int i = 0; i < N; i++) {
            neighbors[i][0] = i;
            neighbors[i][1] = N - i - 1;
        }
        for (int i = 0; i < K - 1; i++) {
            int maxMin = -1;
            int maxMax = -1;
            int next = 0;
            for (int j = 0; j < N; j++) {
                int min = Math.min(neighbors[j][0], neighbors[j][1]);
                int max = Math.max(neighbors[j][0], neighbors[j][1]);
                if (min > maxMin) {
                    maxMin = min;
                    next = j;
                } else if (min == maxMin) {
                    if (max > maxMax) {
                        maxMax = max;
                        next = j;
                    }
                }
            }
            neighbors[next][0] = -1;
            neighbors[next][1] = -1;
            for (int j = next + 1; j < N; j++) {
                if (neighbors[j][0] == -1) {
                    break;
                } else {
                    neighbors[j][0] = j - next - 1;
                }
            }
            for (int j = next - 1; j >= 0; j--) {
                if (neighbors[j][1] == -1) {
                    break;
                } else {
                    neighbors[j][1] = next - j - 1;
                }
            }
        }
        int maxMin = -1;
        int maxMax = -1;
        int next = 0;
        for (int j = 0; j < N; j++) {
            int min = Math.min(neighbors[j][0], neighbors[j][1]);
            int max = Math.max(neighbors[j][0], neighbors[j][1]);
            if (min > maxMin) {
                maxMin = min;
                next = j;
            } else if (min == maxMin) {
                if (max > maxMax) {
                    maxMax = max;
                    next = j;
                }
            }
        }
        y = Math.max(neighbors[next][0], neighbors[next][1]);
        z = Math.min(neighbors[next][0], neighbors[next][1]);
    }

    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new FileReader("C-small-1.in"));
        PrintWriter pw = new PrintWriter(new FileWriter("C-small-1.out"));
        int T = sc.nextInt();
        for (int i = 1; i <= T; i++) {
            N = sc.nextInt();
            K = sc.nextInt();
            solve();
            pw.println("Case #" + i + ": " + y + " " + z);
        }
        pw.close();
    }

}
