import java.io.*;
import java.util.*;

public class ThemePark
{
    public static void main(String[] args)
    {
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        for (int test = 1; test <= T; test++)
        {
            int R = in.nextInt(),
                k = in.nextInt(),
                N = in.nextInt();
            int[] groups = new int[N];
            int[] profits = new int[N];
            int[] ends = new int[N];
            for (int i = 0; i < N; i++)
            {
                groups[i] = in.nextInt();
            }


            // Pre-generate data
            for (int i = 0; i < N; i++)
            {
                int riders = 0,
                    nGroups = 0;
                do
                {
                    int end = (i + nGroups) % N;
                    if (riders + groups[end] <= k)
                    {
                        riders += groups[end];
                        nGroups++;
                    }
                    else
                    {
                        break;
                    }
                }
                while (riders < k && nGroups < N);
                profits[i] = riders;
                ends[i] = (i + nGroups) % N;
            }

            // Find cycles in list of ends
            int start = 0,
                t = ends[start],
                h = ends[ends[start]];
            while (t != h)
            {
                t = ends[t];
                h = ends[ends[h]];
            }

            int cycleStart = 0;
            h = t;
            t = start;
            while (t != h)
            {
                t = ends[t];
                h = ends[h];
                cycleStart++;
            }
            int cycleStartGroup = t;
            int cycleLength = 1;
            h = ends[t];
            while (t != h)
            {
                h = ends[h];
                cycleLength++;
            }

            // Calculate profit of cycle
            int group = cycleStartGroup;
            int cycleProfit = 0;
            do
            {
                cycleProfit += profits[group];
                group = ends[group];
            }
            while (group != cycleStartGroup);

            int profit = 0;
            group = 0;
            for (int i = 0; i < R && i < cycleStart; i++)
            {
                profit += profits[group];
                group = ends[group];
            }
            R -= cycleStart;
            int cycleRepetitions = R / cycleLength;
            profit += cycleRepetitions * cycleProfit;
            R %= cycleLength;
            for (int i = 0; i < R; i++)
            {
                profit += profits[group];
                group = ends[group];
            }

            System.out.printf("Case #%d: %d\n", test, profit);
        }
    }
}
