import java.io.*;
import java.util.*;

public class Rotate
{
    public static void main(String[] args)
    {
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        for (int test = 1; test <= T; test++)
        {
            // Read input
            int N = in.nextInt(),
                k = in.nextInt();
            in.nextLine();
            char[][] board = new char[N][N];
            for (int i = 0; i < N; i++)
            {
                String line = in.nextLine();
                for (int j = 0; j < N; j++)
                {
                    board[i][j] = line.charAt(j);
                }
            }

            // Rotate board
            char[][] rotated = new char[N][N];
            for (int i = N - 1; i >= 0; i--)
            {
                for (int j = 0; j < N; j++)
                {
                    for (int L = i; L >= 0; L--)
                    {
                        if (board[j][L] != '.')
                        {
                            rotated[i][j] = board[j][L];
                            board[j][L] = '.';
                            break;
                        }
                    }
                }
            }

            // Find k in a row

            // Check down, right, down-right, up-right
            int[][] deltas = {
                {-1, 0},
                {0, 1},
                {-1, 1},
                {1, 1}
            };
            boolean redWins = false,
                    blueWins = false;
            for (int i = 0; i < N; i++)
            {
                for (int j = 0; j < N; j++)
                {
                    char start = rotated[i][j];
                    if ((start == 'R' && redWins) || (start == 'B' && blueWins))
                    {
                        continue;
                    }

                    for (int[] delta : deltas)
                    {
                        boolean rowFound = true;
                        for (int L = 0; L < k; L++)
                        {
                            int y = i + L * delta[0],
                                x = j + L * delta[1];



                            if (!(y >= 0 && y < N && x >= 0 && x < N && rotated[y][x] == start))
                            {
                                rowFound = false;
                                break;
                            }
                        }
                        if (rowFound)
                        {
                            switch (start)
                            {
                                case 'R':
                                    redWins = true;
                                    break;
                                case 'B':
                                    blueWins = true;
                                    break;
                                default:
                                    break;
                            }
                        }
                    }
                }
            }

            String winner;
            if (!redWins && !blueWins)
            {
                winner = "Neither";
            }
            else if (redWins && blueWins)
            {
                winner = "Both";
            }
            else if (redWins)
            {
                winner = "Red";
            }
            else
            {
                winner = "Blue";
            }
            System.out.printf("Case #%d: %s\n", test, winner);
        }
    }
}
