import java.io.*;
import java.util.*;
import java.awt.Point;

public class Bacteria
{
    public static void main(String[] args)
    {
        Scanner in = new Scanner(System.in);
        int C = in.nextInt();
        for (int test = 1; test <= C; test++)
        {
            Set<Point> state = new HashSet<Point>();
            int R = in.nextInt();
            for (int i = 0; i < R; i++)
            {
                int X1 = in.nextInt(),
                    Y1 = in.nextInt(),
                    X2 = in.nextInt(),
                    Y2 = in.nextInt();
                for (int x = X1; x <= X2; x++)
                {
                    for (int y = Y1; y <= Y2; y++)
                    {
                        state.add(new Point(x, y));
                    }
                }
            }

            int seconds = 0;

            while (!state.isEmpty())
            {
                Set<Point> next = new HashSet<Point>();
                for (Point p : state)
                {
                    // Retain this one?
                    if (state.contains(new Point(p.x - 1, p.y)) || state.contains(new Point(p.x, p.y - 1)))
                    {
                        next.add(p);
                    }

                    // Add new
                    Point matchingWest = new Point(p.x - 1, p.y + 1), // So p is north of target
                          matchingNorth = new Point(p.x + 1, p.y - 1); // So p is west of target
                    if (state.contains(matchingWest))
                    {
                        next.add(new Point(p.x, p.y + 1));
                    }
                    if (state.contains(matchingNorth))
                    {
                        next.add(new Point(p.x + 1, p.y));
                    }
                }
                state = next;
                seconds++;
            }

            System.out.printf("Case #%d: %d\n", test, seconds);
        }
    }
}
