import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

public class CoinJam {

    public static void main(String[] args) throws IOException {

        CoinJam cj = new CoinJam();
        cj.process();

    }

    private void process() throws IOException {
//        List<Configuration> conf = loadInput();
//        for (int i = 0; i < conf.size(); i++) {
//            lastNumber = 0;
//            process(conf.get(i), i + 1);
//        }
        System.out.println(getDivisor("1000000000110011"));
    }

    private void process(Configuration conf, int index) {
        System.out.println("Case #" + index + ":");
        for (int i = 0; i < conf.getJ(); i++) {
            String coin = getNextCoin(conf.getN());
            String divisors = getDivisor(coin);
            System.out.println(coin + " " + divisors);
        }
    }

    private String getDivisor(String coin) {
        String divisors = "";
        for (long i = 2; i <= 10; i++) {
            divisors += getDivisor(convert(coin, i));
            if (i != 10) {
                divisors += " ";
            }
        }
        return divisors;
    }

    private BigInteger convert(String jamCoin, long base) {
        BigInteger result = new BigInteger("0");
        String reverted = new StringBuilder(jamCoin).reverse().toString();
        for (int i = 0; i < reverted.length(); i++) {
            if (reverted.charAt(i) == '1') {
                result = result.add(new BigInteger(String.valueOf(Math.pow(base, i)).substring(0, String.valueOf(Math.pow(base, i)).indexOf("."))));
            }
        }
        return result;
    }

    private boolean isValidCoin(String coin) {
        if (coin == null || coin.trim().isEmpty() || coin.charAt(0) != '1' || coin.charAt(coin.length() - 1) != '1') {
            return false;
        }
        for (long i = 2; i <= 10; i++) {
            if (isPrime(convert(coin, i))) {
                return false;
            }
        }
        return true;
    }

    private boolean isPrime(BigInteger number) {

        if (number.compareTo(new BigInteger("2")) >= 0 && number.compareTo(new BigInteger("3")) <= 0) {
            return true;
        }
        BigInteger i = new BigInteger("2");
        while (i.compareTo(number) < 0) {
            if (number.divideAndRemainder(i)[1].equals(new BigInteger("0"))) {
                return false;
            }
            i = i.add(new BigInteger("1"));
        }
        return true;
    }

    private BigInteger getDivisor(BigInteger number) {
        BigInteger i = new BigInteger("2");
        while (true) {
            if (number.divideAndRemainder(i)[1].equals(new BigInteger("0"))) {
                return i;
            }
            i = i.add(new BigInteger("1"));
        }
    }

    private long lastNumber = 0;

    private String getNextCoin(int n) {
        if (n == 2) {
            return "11";
        }
        String number = Long.toBinaryString(lastNumber);
        lastNumber++;
        while (n - number.length() - 2 > 0) {
            number = "0" + number;
        }
        number = "1" + number + "1";
        if (!isValidCoin(number)) {
            return getNextCoin(n);
        }
        return number;
    }

    private List<Configuration> loadInput() throws IOException {

        List<Configuration> result = new ArrayList<>();
        String line = null;

        try (FileReader fr = new FileReader(new File(getClass().getClassLoader().getResource("input.in").getFile()));
             BufferedReader br = new BufferedReader(fr)) {
            br.readLine();
            while ((line = br.readLine()) != null) {
                String[] split = line.split(" ");
                result.add(new Configuration(Integer.parseInt(split[0]), Integer.parseInt(split[1])));
            }
        }

        return result;
    }

    class Configuration {

        private int n = 0;
        private int j = 0;

        public Configuration(int n, int j) {
            setN(n);
            setJ(j);
        }

        public int getN() {
            return n;
        }

        private void setN(int n) {
            this.n = n;
        }

        public int getJ() {
            return j;
        }

        private void setJ(int j) {
            this.j = j;
        }
    }

}
