import java.util.*;

public class RevengeOfThePancakes {


    public static void main(String[] args) {

        RevengeOfThePancakes cs = new RevengeOfThePancakes();
        cs.process();

    }

    private void process() {
        List<String> input = loadList();
        for (int i = 0; i < input.size(); i++) {
            step = 0;
            if (input.get(i).equals("-")
                    || input.get(i).equals("-+")
                    || allTopEmpty(input.get(i))) {
                System.out.println("Case #" + (i + 1) + ": 1");
            } else if (input.get(i).equals("+") || allTopHappy(input.get(i))) {
                System.out.println("Case #" + (i + 1) + ": 0");
            } else if (input.get(i).equals("+-")) {
                System.out.println("Case #" + (i + 1) + ": 2");
            } else {
                process(input.get(i), i);
            }
        }
    }

    private int step = 0;

    private void process(String input, int index) {
        List<String> list = split(input);
        while (!allTopHappy(convert(list))) {
            int a = convert(list).indexOf("-");
            if (a != 0) {
                negate(list, a);
            }
            list = list.subList(0, convert(list).lastIndexOf("-") + 1);
            list = flip(list);
        }
        System.out.println("Case #" + (index + 1) + ": " + step);
    }

    private void negate(List<String> list, int a) {
        if (list == null || list.isEmpty()) {
            return;
        }
        step++;
        for (int i = 0; i < a; i++) {
            list.remove(i);
            list.add(i, "-");
        }
    }

    private String convert(List<String> list) {
        String s = "";
        if (list == null || list.isEmpty()) {
            return s;
        }
        for (String c : list) {
            s += c;
        }
        return s;
    }

    private List<String> flip(List<String> set) {
        List<String> result = new ArrayList<>();
        if (set == null || set.isEmpty()) {
            return result;
        }
        step++;
        for (int i = set.size() - 1; i >= 0; i--) {
            if (set.get(i).equals("+")) {
                result.add("-");
            } else {
                result.add("+");
            }
        }
        return result;
    }

    private List<String> split(String input) {

        List<String> result = new ArrayList<>();
        if (input == null || input.trim().isEmpty()) {
            return result;
        }
        for (int i = 0; i < input.length(); i++) {
            result.add(input.substring(i, i + 1));
        }
        return result;
    }

    private boolean allTopEmpty(String input) {
        for (int i = 0; i < input.length(); i++) {
            if (input.substring(i, i + 1).equals("+")) {
                return false;
            }
        }
        return true;
    }

    private boolean allTopHappy(String input) {
        for (int i = 0; i < input.length(); i++) {
            if (input.substring(i, i + 1).equals("-")) {
                return false;
            }
        }
        return true;
    }


    private List<String> loadList() {

        Scanner sc = new Scanner(System.in);
        List<String> result = new ArrayList<>();

        int count = sc.nextInt();
        for (int i = 0; i <= count; i++) {
            String s = sc.nextLine();
            if (s != null && !s.trim().isEmpty()) {
                result.add(s);
            }
        }

        return result;
    }
}
