import java.math.BigInteger;
import java.util.*;

public class CountingSheepLarge {

    public static void main(String[] args) {

        CountingSheepLarge cs = new CountingSheepLarge();
        cs.process();

    }

    private void process() {

        List<Integer> nList = loadList();
        for (int i = 0; i < nList.size(); i++) {
            countSheep(nList.get(i), i);
        }

    }

    private void countSheep(long n, long index) {

        Set<Long> digits = new HashSet<Long>();

        if (n <= 0L) {
            System.out.println("Case #" + (index + 1) + ": INSOMNIA");
            return;
        }
        BigInteger i = new BigInteger("1");
        while (digits.size() < 10L) {
            digits.addAll(countSheep(i.multiply(new BigInteger(String.valueOf(n)))));
            i = i.add(new BigInteger("1"));
        }
        System.out.println("Case #" + (index + 1) + ": " + lasNumber);
    }

    private BigInteger lasNumber = null;

    private Collection<? extends Long> countSheep(BigInteger i) {
        String digits = String.valueOf(i);
        lasNumber = new BigInteger(i.toString());
        Set<Long> set = new HashSet<>();
        for (int j = 0; j < digits.length(); j++) {
            set.add(Long.parseLong(digits.substring(j, j + 1)));
        }
        return set;
    }

    private List<Integer> loadList() {

        Scanner sc = new Scanner(System.in);
        List<Integer> result = new ArrayList<>();

        int count = sc.nextInt();
        for (int i = 0; i < count; i++) {
            result.add(sc.nextInt());
        }

        return result;
    }

}
