import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

/**
 * @author Andrew Shulayev
 * @since 2013-04-13
 */
public class TicTacTomek {

    BufferedReader br;
    PrintWriter out;

    public static void main(String[] args) throws IOException {
        new TicTacTomek().run();
    }

    public boolean okay(char c, char s) {
        return (c == s || c == 'T');
    }

    public void O_won(int tt) {
        out.printf("Case #%d: O won\n", tt + 1);
    }
    public void X_won(int tt) {
        out.printf("Case #%d: X won\n", tt + 1);
    }
    public void Not_completed(int tt) {
        out.printf("Case #%d: Game has not completed\n", tt + 1);
    }
    public void Draw(int tt) {
        out.printf("Case #%d: Draw\n", tt + 1);
    }

    public void run() throws IOException {
        br = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter("output.txt");

        int T = Integer.parseInt(br.readLine());

        String[] board = new String[4];
        outer: for (int tt = 0; tt < T; tt++) {
            if (tt > 0)
                br.readLine();
            for (int i = 0; i < board.length; i++) {
                board[i] = br.readLine();
            }

            for (int i = 0; i < board.length; i++) {
                boolean okX = true, okO = true;
                for (char c : board[i].toCharArray()) {
                    okX &= okay(c, 'X');
                    okO &= okay(c, 'O');
                }
                if (okX) {
                    X_won(tt);
                    continue outer;
                }
                if (okO) {
                    O_won(tt);
                    continue outer;
                }
            }

            for (int i = 0; i < board.length; i++) {
                boolean okX = true, okO = true;
                for (int j = 0; j < board.length; j++) {
                    char c = board[j].charAt(i);
                    okX &= okay(c, 'X');
                    okO &= okay(c, 'O');
                }
                if (okX) {
                    X_won(tt);
                    continue outer;
                }
                if (okO) {
                    O_won(tt);
                    continue outer;
                }
            }

            boolean okX = true, okO = true;
            for (int i = 0; i < board.length; i++) {
                char c = board[i].charAt(i);
                okX &= okay(c, 'X');
                okO &= okay(c, 'O');
            }
            if (okX) {
                X_won(tt);
                continue outer;
            }
            if (okO) {
                O_won(tt);
                continue outer;
            }

            okX = true; okO = true;
            for (int i = 0; i < board.length; i++) {
                char c = board[i].charAt(board.length - i - 1);
                okX &= okay(c, 'X');
                okO &= okay(c, 'O');
            }
            if (okX) {
                X_won(tt);
                continue outer;
            }
            if (okO) {
                O_won(tt);
                continue outer;
            }

            boolean hasEmpty = false;
            for (int i = 0; i < board.length; i++) {
                for (int j = 0; j < board.length; j++) {
                    if (board[i].charAt(j) == '.')
                        hasEmpty = true;
                }
            }
            if (hasEmpty)
                Not_completed(tt);
            else
                Draw(tt);
        }

        out.close();
    }

}
