package name.callcc.gcj.utils;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.util.StringTokenizer;

public class FastScanner {
    final BufferedReader reader;
    StringTokenizer tokenizer;

    public FastScanner(final Reader reader) {
        this.reader = new BufferedReader(reader);
    }

    public String next() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreElements()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }
        return tokenizer.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    public static FastScanner fromFile(final String name) throws IOException {
        return new FastScanner(new FileReader(name));
    }

}
