import java.io.*;
import java.util.*;

public class BotTrust {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException {
		new BotTrust().run();
	}

	void run() throws IOException {
		br = new BufferedReader(new FileReader("A-large.in"));
		pw = new PrintWriter("A-large.out");
		
		int tests = nextInt();
		
		for (int t = 0; t < tests; t++) {
			int time = 0;
			int O_pos = 1, B_pos = 1;
			int O_time = 0, B_time = 0;
			
			int steps = nextInt();
			for (int i = 0; i < steps; i++) {
				char next = next().charAt(0);
				int newPos = nextInt();
				if (next == 'O') {
					int delta = Math.max(Math.abs(newPos - O_pos) - O_time, 0) + 1;
					O_pos = newPos;
					time += delta;
					B_time += delta;
					O_time = 0;
				}
				else {
					int delta = Math.max(Math.abs(newPos - B_pos) - B_time, 0) + 1;
					B_pos = newPos;
					time += delta;
					O_time += delta;
					B_time = 0;
				}
			}
			pw.printf("Case #%d: %d\n", t + 1, time);
		}
		
		pw.close();
	}
	
	BufferedReader br;
	StringTokenizer st;
	PrintWriter pw;
	
	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	long nextLong() throws IOException {
		return Long.parseLong(next());
	}
	
	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}
}
