import java.util.*;
import java.io.*;

public class SquareTiles {

	public static void main(String[] args) throws IOException {
		new SquareTiles().run();
	}

	final static String filename = "A";

	void run() throws IOException {
		br = new BufferedReader(new FileReader(filename + ".in"));
		pw = new PrintWriter(filename + ".out");

		int T = nextInt();
		for (int t = 0; t < T; t++) {
			int n = nextInt(), m = nextInt();
			char[][] tile = new char[n][];
			
			boolean fail = false;
			for (int i = 0 ; i < n; i++) {
				tile[i] = next().toCharArray();
			}
			
			loop: for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					if (tile[i][j] == '#') {
						if (i == n - 1 || j == m - 1) {
							fail = true;
							break loop;
						}
						
						if (tile[i + 1][j] == '#' && tile[i][j + 1] == '#' && tile[i + 1][j + 1] == '#') {
							tile[i][j] = '/';
							tile[i][j + 1] = '\\';
							tile[i + 1][j] = '\\';
							tile[i + 1][j + 1] = '/';
						}
						
						else {
							fail = true;
							break loop;
						}
					}
				}
			}
			
			pw.printf("Case #%d:\n", t + 1);
			if (fail) {
				pw.println("Impossible");
			} else for (int i = 0; i < n; i++) {
				pw.println(tile[i]);
			}
		}

		pw.close();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter pw;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
}
