import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

/**
 * @author Andrew Shulayev
 * @since 2013-04-13
 */
public class Lawnmower {

    BufferedReader br;
    PrintWriter out;
    StringTokenizer st;

    public static void main(String[] args) throws IOException {
        new Lawnmower().run();
    }

    public void run() throws IOException {
        br = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter("output.txt");

        int T = nextInt();

        outer: for (int tt = 0; tt < T; tt++) {
            int n = nextInt();
            int m = nextInt();

            boolean[][] field = new boolean[n][m];
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    field[i][j] = nextInt() == 1;
                }
            }

            for (int i = 0; i < n; i++) {
                inner: for (int j = 0; j < m; j++) {
                    if (!field[i][j]) continue;

                    boolean ok = true;
                    for (int k = 0; k < n; k++) {
                        ok &= field[k][j];
                    }
                    if (ok) {
                        continue inner;
                    }

                    ok = true;
                    for (int k = 0; k < m; k++) {
                        ok &= field[i][k];
                    }
                    if (!ok) {
                        out.printf("Case #%d: NO\n", tt + 1);
                        continue outer;
                    }
                }
            }
            out.printf("Case #%d: YES\n", tt + 1);
        }

        out.close();
    }

    public String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }
}
