import java.io.*;
import java.util.*;

public class GoroSort {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException {
		new GoroSort().run();
	}

	void run() throws IOException {
		br = new BufferedReader(new FileReader("D-large.in"));
		pw = new PrintWriter("D-large.out");
		
		int tests = nextInt();
		for (int t = 0; t < tests; t++) {
			int size = nextInt();
			int[] perm = new int[size];
			int[] inv = new int[size];
			
			int steps = 0;
			
			for (int i = 0; i < size; i++) {
				perm[i] = nextInt() - 1;
				inv[perm[i]] = i;
			}
			
			for (int i = 0; i < size; i++) {
				if (perm[perm[i]] != i || perm[i] == i) continue;
				
				steps++;
				
				int x = perm[i];
				
				perm[perm[i]] = x;
				perm[i] = i;
				
				inv[i] = i;
				inv[x] = x;
			}
			
			for (int i = 0; i < size; i++) {
				if (perm[i] == i) continue;
				
				steps++;
				
				int x = perm[i];
				int b = inv[i];
				
				perm[b] = x;
				perm[i] = i;
				
				inv[x] = b;
				inv[i] = i;
			}
			pw.println("Case #" + (t + 1) + ": " + (double) (2 * steps));
		}

		pw.close();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter pw;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}
}
