import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.StringTokenizer;

/**
 * @author Andrew Shulayev
 * @since 2013-04-14
 */
public class FairAndSquare {

    BufferedReader br;
    PrintWriter out;
    StringTokenizer st;

    public static void main(String[] args) throws IOException {
        new FairAndSquare().run();
    }

    public long sqrt(long x) {
        long left = 0, right = x;
        while (left + 1 < right) {
            long mid = left + (right - left) / 2L;
            long sqr = mid * mid;
            if (sqr == x)
                return mid;
            else if (sqr < x) {
                left = mid;
            } else {
                right = mid;
            }
        }
        return left;
    }

    public boolean isPalindrome(long x) {
        String s = Long.toString(x);
        String revs = new StringBuilder(s).reverse().toString();
        return s.equals(revs);
    }

    public void run() throws IOException {
        br = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter("output.txt");

        int T = nextInt();

        for (int tt = 0; tt < T; tt++) {
            long A = nextLong();
            long B = nextLong();

            long a = sqrt(A);
            long b = sqrt(B) + 1;

            int result = 0;

            for (long t = a; t < b; t++) {
                if (!isPalindrome(t))
                    continue;
                long sqr = t * t;
                if (A <= sqr && sqr <= B && isPalindrome(sqr)) {
                    result++;
                }
            }

            out.printf("Case #%d: %d\n", tt + 1, result);
        }

        out.close();
    }

    public String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(next());
    }

}
