import java.io.*;
import java.util.*;

public class RPI {
	
	BufferedReader br;
	StringTokenizer st;
	PrintWriter pw;
	
	public static void main(String[] args) throws IOException {
		new RPI().run();
	}
	
	void run() throws IOException {
		br = new BufferedReader(new FileReader("A.in"));
		pw = new PrintWriter("A.out");
		
		int T = nextInt();
		
		for (int t = 0; t < T; t++) {
			int n = nextInt();
			char[][] table = new char[n][];
			int[] plays = new int[n];
			int[] wins = new int[n];
			double[] WP = new double[n];
			double[] OWP = new double[n];
			
			for (int i = 0; i < n; i++) {
				table[i] = next().toCharArray();
				
				for (int j = 0; j < n; j++) {
					if (table[i][j] != '.') {
						plays[i]++;
					}
					if (table[i][j] == '1') {
						wins[i]++;
					}
				}
				
				WP[i] = (double) wins[i] / plays[i];
			}
			
			// System.out.println(Arrays.toString(WP));
			
			pw.printf("Case #%d:\n", t + 1);
			for (int i = 0; i < n; i++) {
				double sum = 0.0;
				int count = 0;
				for (int j = 0; j < n; j++) {
					if (table[i][j] == '.') continue;
					
					count++;
					if (table[i][j] == '0') {
						sum += (double) (wins[j] - 1) / (plays[j] - 1);
					} else {
						sum += (double) wins[j] / (plays[j] - 1);
					}
				}
				
				OWP[i] = sum / count;
			}
			
			// System.out.println(Arrays.toString(OWP));
			
			for (int i = 0; i < n; i++) {
				double sum = 0.0;
				double count = 0;
				for (int j = 0; j < n; j++) {
					if (table[i][j] == '.') continue;
					
					count++;
					sum += OWP[j];
				}
				
				double OOWP = sum / count;
				pw.println(0.25 * WP[i] + 0.5 * OWP[i] + 0.25 * OOWP);
			}
		}
		
		pw.close();
	}
	
	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
}
