import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Arrays;
import java.util.HashSet;
import java.util.InputMismatchException;
import java.util.Set;


public class GoogleJamSolution{

	String INPUT = "input.txt";
	//String INPUT = "";
	String OUTPUT = "output.txt";
	//String OUTPUT = "";
	
	public void solve() {
		int T = ni();
		for(int tCase=1; tCase<=T; tCase++){
			long hd = nl();
			long ad = nl();
			long hk = nl();
			long ak = nl();
			long b = nl();
			long d = nl();
			Long sol = null;
			for(int deb = 0; deb<=100; deb++){
				Long aux = turnsToWin(hd, ad, hk, ak, b, d, deb);
				if(sol==null || (aux!=null && aux<sol)){
					sol = aux;
				}
			}
			out.append("Case #"+tCase+": ");
			if(sol!=null){
				out.append(sol+"\n");
			}else{
				out.append("IMPOSSIBLE\n");
			}
		}
	}
	
	public Long turnsToWin(long hd, long ad, long hk, long ak, long b, long d, long deb){
		long turnsAlive = (long)Math.ceil((double)hd / ak);
		long attacksToWin = (long)Math.ceil((double)hk / ad);
		long buffs = 0;
		while((long)Math.ceil((double)hk / (ad+b)) < attacksToWin-1){
			buffs++;
			ad+=b;
			attacksToWin = (long)Math.ceil((double)hk / ad);
		}
		long turnsToWin = attacksToWin + buffs;
		long sol = 0;
		long aux_hd = hd;
		while(deb>0){
			if(aux_hd > (ak-d)){
				sol++;
				ak=Math.max(ak-d,0);
				aux_hd-=ak;
				deb--;
			}else{
				aux_hd = hd-ak;
				sol++;
				if(aux_hd <= (ak-d)){
					return null;
				}
			}
			if(aux_hd<=0) return null;
		}
		turnsAlive = Math.max(1,(ak==0?100000:(long)Math.ceil((double)aux_hd / ak)));
		while(turnsToWin>0){
			if(turnsToWin <= turnsAlive){
				sol+=turnsToWin;
				turnsToWin=0;
			}else{
				turnsToWin-=(turnsAlive-1);
				sol += turnsAlive;
				turnsAlive = (ak==0?100000:(long)Math.ceil((double)hd / ak) - 1);
				if(turnsAlive<=1){
					return null;
				}
			}
		}
		return sol;
	}
	
	InputStream is;
	OutputStream os;
	StringBuilder out;
	
	void run() throws Exception
	{
		is = INPUT.isEmpty() ? System.in : new FileInputStream(new File(INPUT));
		os = OUTPUT.isEmpty() ? System.out : new FileOutputStream(new File(OUTPUT));
		out = new StringBuilder();
		solve();
		os.write(out.toString().getBytes());
	}
	
	public static void main(String[] args) throws Exception {
		new GoogleJamSolution().run();
	}
	
	private byte[] inbuf = new byte[1024];
	private int lenbuf = 0, ptrbuf = 0;
	
	private int readByte()
	{
		if(lenbuf == -1)throw new InputMismatchException();
		if(ptrbuf >= lenbuf){
			ptrbuf = 0;
			try { lenbuf = is.read(inbuf); } catch (IOException e) { throw new InputMismatchException(); }
			if(lenbuf <= 0)return -1;
		}
		return inbuf[ptrbuf++];
	}
	
	private boolean isSpaceChar(int c) { return !(c >= 33 && c <= 126); }
	private int skip() { int b; while((b = readByte()) != -1 && isSpaceChar(b)); return b; }
	
	private double nd() { return Double.parseDouble(ns()); }
	private char nc() { return (char)skip(); }
	
	private String ns()
	{
		int b = skip();
		StringBuilder sb = new StringBuilder();
		while(!(isSpaceChar(b))){ // when nextLine, (isSpaceChar(b) && b != ' ')
			sb.appendCodePoint(b);
			b = readByte();
		}
		return sb.toString();
	}
	
	private char[] ns(int n)
	{
		char[] buf = new char[n];
		int b = skip(), p = 0;
		while(p < n && !(isSpaceChar(b))){
			buf[p++] = (char)b;
			b = readByte();
		}
		return n == p ? buf : Arrays.copyOf(buf, p);
	}
	
	private char[][] nm(int n, int m)
	{
		char[][] map = new char[n][];
		for(int i = 0;i < n;i++)map[i] = ns(m);
		return map;
	}
	
	private long[] nla(int n)
	{
		long[] a = new long[n];
		for(int i = 0;i < n;i++)a[i] = nl();
		return a;
	}
	
	private int[] nia(int n)
	{
		int[] a = new int[n];
		for(int i = 0;i < n;i++)a[i] = ni();
		return a;
	}
	
	private int ni()
	{
		int num = 0, b;
		boolean minus = false;
		while((b = readByte()) != -1 && !((b >= '0' && b <= '9') || b == '-'));
		if(b == '-'){
			minus = true;
			b = readByte();
		}
		
		while(true){
			if(b >= '0' && b <= '9'){
				num = num * 10 + (b - '0');
			}else{
				return minus ? -num : num;
			}
			b = readByte();
		}
	}
	
	private long nl()
	{
		long num = 0;
		int b;
		boolean minus = false;
		while((b = readByte()) != -1 && !((b >= '0' && b <= '9') || b == '-'));
		if(b == '-'){
			minus = true;
			b = readByte();
		}
		
		while(true){
			if(b >= '0' && b <= '9'){
				num = num * 10 + (b - '0');
			}else{
				return minus ? -num : num;
			}
			b = readByte();
		}
	}
		
	private static void tr(Object... o) { System.out.println(Arrays.deepToString(o)); }
}
