import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Arrays;
import java.util.Comparator;
import java.util.InputMismatchException;
import java.util.Scanner;

public class GoogleJamSolution {

	String INPUT = "input.in";
	 //String INPUT = "";
	String OUTPUT = "output.txt";
	//String OUTPUT = "";

	public static class Horse{
		int position, speed;

		public Horse(int position, int speed) {
			super();
			this.position = position;
			this.speed = speed;
		}
		
	}
	
	public String solveCase(){
		int D = ni();
		int N = ni();
		Horse[] horses = new Horse[N];
		for(int i=0; i<N; i++){
			horses[i] = new Horse(ni(), ni());
		}
		Arrays.sort(horses, new Comparator<Horse>(){
			@Override
			public int compare(Horse o1, Horse o2) {
				int c = Integer.compare(o1.position, o2.position);
				if(c!=0) return c;
				return Integer.compare(o1.speed, o2.speed);
			}
		});
		double maximunTime = 0;
		for(int i=0; i<N; i++){
			double auxTime = ((double)D - horses[i].position) / horses[i].speed;
			maximunTime = Math.max(auxTime, maximunTime);
		}
		return String.format("%.6f", D/maximunTime).replace(",", ".");
	}
	
	public void solve() {
		int T = ni();
		for(int i=1; i<=T; i++){
			out.append("Case #"+i+": "+solveCase()+"\n");
		}
	}

	InputStream is;
	OutputStream os;
	StringBuilder out;

	void run() throws Exception {
		is = INPUT.isEmpty() ? System.in : new FileInputStream(new File(INPUT));
		os = OUTPUT.isEmpty() ? System.out : new FileOutputStream(new File(
				OUTPUT));
		out = new StringBuilder();
		solve();
		os.write(out.toString().getBytes());
	}

	public static void main(String[] args) throws Exception {
		new GoogleJamSolution().run();
	}

	private byte[] inbuf = new byte[1024];
	private int lenbuf = 0, ptrbuf = 0;

	private int readByte() {
		if (lenbuf == -1)
			throw new InputMismatchException();
		if (ptrbuf >= lenbuf) {
			ptrbuf = 0;
			try {
				lenbuf = is.read(inbuf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (lenbuf <= 0)
				return -1;
		}
		return inbuf[ptrbuf++];
	}

	private boolean isSpaceChar(int c) {
		return !(c >= 33 && c <= 126);
	}

	private int skip() {
		int b;
		while ((b = readByte()) != -1 && isSpaceChar(b))
			;
		return b;
	}

	private double nd() {
		return Double.parseDouble(ns());
	}

	private char nc() {
		return (char) skip();
	}

	private String ns() {
		int b = skip();
		StringBuilder sb = new StringBuilder();
		while (!(isSpaceChar(b))) { // when nextLine, (isSpaceChar(b) && b !=
									// ' ')
			sb.appendCodePoint(b);
			b = readByte();
		}
		return sb.toString();
	}

	private char[] ns(int n) {
		char[] buf = new char[n];
		int b = skip(), p = 0;
		while (p < n && !(isSpaceChar(b))) {
			buf[p++] = (char) b;
			b = readByte();
		}
		return n == p ? buf : Arrays.copyOf(buf, p);
	}

	private char[][] nm(int n, int m) {
		char[][] map = new char[n][];
		for (int i = 0; i < n; i++)
			map[i] = ns(m);
		return map;
	}

	private long[] nla(int n) {
		long[] a = new long[n];
		for (int i = 0; i < n; i++)
			a[i] = nl();
		return a;
	}

	private int[] nia(int n) {
		int[] a = new int[n];
		for (int i = 0; i < n; i++)
			a[i] = ni();
		return a;
	}

	private int ni() {
		int num = 0, b;
		boolean minus = false;
		while ((b = readByte()) != -1 && !((b >= '0' && b <= '9') || b == '-'))
			;
		if (b == '-') {
			minus = true;
			b = readByte();
		}

		while (true) {
			if (b >= '0' && b <= '9') {
				num = num * 10 + (b - '0');
			} else {
				return minus ? -num : num;
			}
			b = readByte();
		}
	}

	private long nl() {
		long num = 0;
		int b;
		boolean minus = false;
		while ((b = readByte()) != -1 && !((b >= '0' && b <= '9') || b == '-'))
			;
		if (b == '-') {
			minus = true;
			b = readByte();
		}

		while (true) {
			if (b >= '0' && b <= '9') {
				num = num * 10 + (b - '0');
			} else {
				return minus ? -num : num;
			}
			b = readByte();
		}
	}

	private static void tr(Object... o) {
		System.out.println(Arrays.deepToString(o));
	}
}
