import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.InputMismatchException;
import java.util.LinkedList;
import java.util.List;


public class GoogleJamSolution{

	String INPUT = "input.txt";
	//String INPUT = "";
	String OUTPUT = "output.txt";
	//String OUTPUT = "";
	
	public void solve() {
		int T = ni();
		for(int tCase=1; tCase<=T; tCase++){
			int N = ni();
			int P = ni();
			int[] gg = nia(N);
			int sol = 0;
			if(N==1){
				for(int i=0; i<P; i++){
					int p = ni();
					double dp = p;
					double min = 10.0 / 11 * dp / gg[0];
					double max = 10.0 / 9 * dp / gg[0];
					if((int)max >= min){
						sol++;
					}
				}
			}
			if(N==2){
				List<Integer>[] lists = new List[1111112];
				for(int i=0; i<1111112; i++){
					lists[i] = new LinkedList<Integer>();
				}
				for(int i=0; i<P; i++){
					int p = ni();
					double dp = p;
					double min = 10.0 / 11.0 * dp / (double)gg[0];
					double max = 10.0 / 9.0 * dp / (double)gg[0];
					int mink = (int)Math.ceil(min);
					int maxk = (int)Math.floor(max);
				//	System.out.println("added1 "+i+" "+mink+" "+maxk);
					for(int j=mink; j<maxk+1; j++){
						lists[j].add(i);
					}
				}
				List<Integer>[] graph = new List[P];
				for(int i=0; i<P; i++){
					graph[i] = new ArrayList<Integer>();
				}
				for(int i=0; i<P; i++){
					int p = ni();
					double dp = p;
					double min = 10.0 / 11.0 * dp / (double)gg[1];
					double max = 10.0 / 9.0 * dp / (double)gg[1];
					int mink = (int)Math.ceil(min);
					int maxk = (int)Math.floor(max);
					//System.out.println("added2 "+i+" "+mink+" "+maxk);
					for(int j=mink; j<maxk+1; j++){
						graph[i].addAll(lists[j]);
					}
				}
				sol = maxMatching(graph, P);
			}
			out.append("Case #"+tCase+": "+sol+"\n");
		}
	}
	
	public static int maxMatching(List<Integer>[] graph, int n2) {
	    int n1 = graph.length;
	    int[] matching = new int[n2];
	    Arrays.fill(matching, -1);
	    int matches = 0;
	    for (int u = 0; u < n1; u++) {
	      if (findPath(graph, u, matching, new boolean[n1]))
	        ++matches;
	    }
	    return matches;
	  }

	  static boolean findPath(List<Integer>[] graph, int u1, int[] matching, boolean[] vis) {
	    vis[u1] = true;
	    for (int v : graph[u1]) {
	      int u2 = matching[v];
	      if (u2 == -1 || !vis[u2] && findPath(graph, u2, matching, vis)) {
	        matching[v] = u1;
	        return true;
	      }
	    }
	    return false;
	  }

	  /*
	  public static void main(String[] args) {
	    Random rnd = new Random(1);
	    for (int step = 0; step < 1000; step++) {
	      int n1 = rnd.nextInt(20) + 1;
	      int n2 = rnd.nextInt(20) + 1;
	      List<Integer>[] g = new List[n1];
	      for (int i = 0; i < n1; i++)
	        g[i] = new ArrayList<>();
	      for (int i = 0; i < n1; i++)
	        for (int j = 0; j < n2; j++)
	          g[i].add(j);
	      int res1 = maxMatching(g, n2);
	      int res2 = slowMinVertexCover(g, n2);
	      if (res1 != res2)
	        throw new RuntimeException();
	    }
	  }*/
	
	InputStream is;
	OutputStream os;
	StringBuilder out;
	
	void run() throws Exception
	{
		is = INPUT.isEmpty() ? System.in : new FileInputStream(new File(INPUT));
		os = OUTPUT.isEmpty() ? System.out : new FileOutputStream(new File(OUTPUT));
		out = new StringBuilder();
		solve();
		os.write(out.toString().getBytes());
	}
	
	public static void main(String[] args) throws Exception {
		new GoogleJamSolution().run();
	}
	
	private byte[] inbuf = new byte[1024];
	private int lenbuf = 0, ptrbuf = 0;
	
	private int readByte()
	{
		if(lenbuf == -1)throw new InputMismatchException();
		if(ptrbuf >= lenbuf){
			ptrbuf = 0;
			try { lenbuf = is.read(inbuf); } catch (IOException e) { throw new InputMismatchException(); }
			if(lenbuf <= 0)return -1;
		}
		return inbuf[ptrbuf++];
	}
	
	private boolean isSpaceChar(int c) { return !(c >= 33 && c <= 126); }
	private int skip() { int b; while((b = readByte()) != -1 && isSpaceChar(b)); return b; }
	
	private double nd() { return Double.parseDouble(ns()); }
	private char nc() { return (char)skip(); }
	
	private String ns()
	{
		int b = skip();
		StringBuilder sb = new StringBuilder();
		while(!(isSpaceChar(b))){ // when nextLine, (isSpaceChar(b) && b != ' ')
			sb.appendCodePoint(b);
			b = readByte();
		}
		return sb.toString();
	}
	
	private char[] ns(int n)
	{
		char[] buf = new char[n];
		int b = skip(), p = 0;
		while(p < n && !(isSpaceChar(b))){
			buf[p++] = (char)b;
			b = readByte();
		}
		return n == p ? buf : Arrays.copyOf(buf, p);
	}
	
	private char[][] nm(int n, int m)
	{
		char[][] map = new char[n][];
		for(int i = 0;i < n;i++)map[i] = ns(m);
		return map;
	}
	
	private long[] nla(int n)
	{
		long[] a = new long[n];
		for(int i = 0;i < n;i++)a[i] = nl();
		return a;
	}
	
	private int[] nia(int n)
	{
		int[] a = new int[n];
		for(int i = 0;i < n;i++)a[i] = ni();
		return a;
	}
	
	private int ni()
	{
		int num = 0, b;
		boolean minus = false;
		while((b = readByte()) != -1 && !((b >= '0' && b <= '9') || b == '-'));
		if(b == '-'){
			minus = true;
			b = readByte();
		}
		
		while(true){
			if(b >= '0' && b <= '9'){
				num = num * 10 + (b - '0');
			}else{
				return minus ? -num : num;
			}
			b = readByte();
		}
	}
	
	private long nl()
	{
		long num = 0;
		int b;
		boolean minus = false;
		while((b = readByte()) != -1 && !((b >= '0' && b <= '9') || b == '-'));
		if(b == '-'){
			minus = true;
			b = readByte();
		}
		
		while(true){
			if(b >= '0' && b <= '9'){
				num = num * 10 + (b - '0');
			}else{
				return minus ? -num : num;
			}
			b = readByte();
		}
	}
		
	private static void tr(Object... o) { System.out.println(Arrays.deepToString(o)); }
}
