import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.util.Arrays;
import java.util.PriorityQueue;
import java.util.Scanner;

public class Main {

	public static void main(String[] args) throws Exception {
		Scanner s = new Scanner(new File("input.txt"));
		FileOutputStream fos = new FileOutputStream(new File("output.txt"));
		int T = s.nextInt();
		s.nextLine();
		for (int t = 1; t <= T; t++) {
			long n = s.nextLong();
			long k = s.nextLong();
			PriorityQueue<Interval> pq = new PriorityQueue<Main.Interval>();
			pq.add(new Interval(0, n+1));
			Interval i = null;
			while(k-->0){
				i = pq.remove();
				long index = i.indexSplit();
				pq.add(new Interval(i.l, index));
				pq.add(new Interval(index, i.r));
			}
			System.out.println("Case #"+t+": "+i.max()+" "+i.min());
		}
	}
	
	public static class Interval implements Comparable<Interval>{
		long l, r;

		public Interval(long l, long r) {
			this.l = l;
			this.r = r;
		}
		
		public long min(){
			return (r-l) / 2 - 1;
		}
		
		public long max(){
			return (r-l+1) / 2 - 1;
		}
		
		public long indexSplit(){
			return (l+r)/2;
		}
		
		@Override
		public int compareTo(Interval arg0) {
			if(min() == arg0.min()){
				if(max() == arg0.max()){
					return Long.compare(l, arg0.l);
				}else{
					return Long.compare(arg0.max(), max());
				}
			}else{
				return Long.compare(arg0.min(), min());
			}
		}
	}
}
