package qualification_2015;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.PriorityQueue;
import java.util.Scanner;
import org.junit.*;


public class InfiniteHouseofPancakes {
	static String folder="/Users/diego/Documents/workspaces/workspaceNormal/CodeJam/src/qualification_2015/";
	static String inputFile="B-small-attempt2.in.txt";
	//static String inputFile="test.txt";
	static String outputFile="answer.out";
	static PrintWriter out;
	static Scanner in;

	public static void main(String[] args) throws FileNotFoundException, IOException {
		in = new Scanner(new File(folder+inputFile));
		out = new PrintWriter(folder+outputFile, "UTF-8");


		int n=in.nextInt();

		for(int i=0;i<n;i++){
			System.out.println(i);
			out.print("Case #"+(i+1)+": ");
			solver();
		}

		out.close();

	}

	private static void solver() throws IOException {
		int d=in.nextInt();
		PriorityQueue<Integer>pq=new PriorityQueue<>(Collections.reverseOrder());
		for(int i=0;i<d;i++)pq.add(in.nextInt());
		//Assert.assertEquals(brutal(new ArrayList<>(pq)),min(pq));
		out.println(min(pq));
		//out.println(brutal(new ArrayList<>(pq)));
	}

	private static int min(PriorityQueue<Integer> pq) {
		if(pq.peek()<=2)return pq.peek();
		else{
			PriorityQueue<Integer> pq2=new PriorityQueue<>(Collections.reverseOrder());

			//special minute
			for(int x:pq) pq2.add(x);	
			int x=pq2.remove();
			pq2.add(x/2);
			if(x%2==0)pq2.add(x/2);
			else pq2.add(x/2+1);


			return Math.min(pq.peek()-1,min(pq2))+1;
		}
	}





	private static int brutal(ArrayList<Integer>al){
		int t=0;
		LinkedList<ArrayList<Integer>>current=new LinkedList<>();
		LinkedList<ArrayList<Integer>>next=new LinkedList<>();
		HashSet<ArrayList<Integer>>hs=new HashSet<>();

		next.add(al);
		hs.add(al);

		while(true){
			current=next;
			next=new LinkedList<>();

			for(ArrayList<Integer> node:current){
				if(isEmpty(node))return t;




				//normal minute
				ArrayList<Integer> nodeCopy=new ArrayList<>(node);
				for(int i=0;i<nodeCopy.size();i++){
					if(nodeCopy.get(i)!=0)nodeCopy.set(i, nodeCopy.get(i)-1);
				}
				if(!hs.contains(nodeCopy)){
					hs.add(nodeCopy);
					next.add(nodeCopy);
				}

				//special minute

				int dinerBefore=findMax(node);

				int count=node.get(dinerBefore);
				ArrayList<Integer> nodeCopy2=new ArrayList<>(node);
				if(count%2==0)nodeCopy2.set(dinerBefore, count/2);
				else nodeCopy2.set(dinerBefore,1+count/2);
				nodeCopy2.add(count/2);
				if(!hs.contains(nodeCopy2)){
					hs.add(nodeCopy2);
					next.add(nodeCopy2);
				}

			}
			t++;
		}
	}

	private static boolean isEmpty(ArrayList<Integer> a){
		for (int i = 0; i < a.size(); i++) {
			if(a.get(i)!=0)return false;
		}
		return true;
	}

	private static int findMax(ArrayList<Integer> a){
		int r=0;
		for(int i=1;i<a.size();i++){
			if(a.get(i)>a.get(r))r=i;
		}
		return r;
	}

}



