import diegolink.utils.Pair;
import diegolink.utils.io.InputReader;
import diegolink.utils.io.OutputWriter;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

/**
 * Created with IntelliJ IDEA.
 * User: Diego Huerfano
 * Date: 4/05/13
 * Time: 11:06 AM
 */
public class Osmos {

    private static long size[];
    private static int n;

    private static Map<Pair<Integer, Long>, Integer> memo;

    private static int f( int i, long acc ) {
        if( i==n ) return 0;
        Pair<Integer, Long> e=new Pair<Integer, Long>( i, acc );
        if( memo.containsKey( e ) ) return memo.get( e );
        int p=cost( acc, size[i] );
        int answer= Math.min(f(i + 1, (1L << p) * (acc - 1L) + 1 + size[i]) + p, f(i + 1, acc) + 1);
        memo.put( e, answer );
        return answer;
    }

    private static int cost( long acc, long size ) {
        if( acc>size ) return 0;
        int aux=(int)Math.ceil((Math.log(size - 1) - Math.log(acc - 1)) / Math.log(2));
        int aux2=(int)((Math.log(size - 1) - Math.log(acc - 1)) / Math.log(2));
        if( aux==aux2 ) aux++;
        return aux;
    }


    public static void main(String[] args) throws IOException{
        InputReader in=new InputReader( new FileInputStream("in.txt") );
        OutputWriter out=new OutputWriter( new FileOutputStream("out.txt") );

        int T=in.readInt();
        long a;
        for (int test = 1; test <= T; test++) {
            a=in.readInt();
            n=in.readInt();
            size=in.readLongs(n);
            Arrays.sort(size);
            if( a==1 ) {
                out.printLine("Case #" + test + ": " + n);
                continue;
            }
            memo=new HashMap<Pair<Integer, Long>, Integer>();
            out.printLine("Case #" + test + ": " + f(0, a));
        }
        out.close();
    }
}
