import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.util.TreeSet;


public class A {
	
	static class Scanner{
		BufferedReader br=null;
		StringTokenizer tk=null;
		public Scanner(){
			br=new BufferedReader(new InputStreamReader(System.in));
		}
		public String next() throws IOException{
			while(tk==null || !tk.hasMoreTokens()) {
				String cad = br.readLine();
				if (cad == null)
					return null;
				tk=new StringTokenizer(cad);
			}
			return tk.nextToken();
		}
		public int nextInt() throws NumberFormatException, IOException{
			return Integer.valueOf(next());
		}
		public long nextLong() throws NumberFormatException, IOException{
			return Long.valueOf(next());
		}
		public double nextDouble() throws NumberFormatException, IOException{
			return Double.valueOf(next());
		}
	}
	
	static int N, R, P, S;
	
	static String[][] dp;
	
	
	static int map(char c) {
		if (c == 'P')
			return 0;
		if (c == 'R')
			return 1;
		// S
		return 2;
	}
	
	static String transition(char c) {
		if (c == 'R')
			return "RS";
		if (c == 'P')
			return "PR";
		return "SP";
	}
	
	
	
	static String dp(int level, char letter) {
		if (level == N)
			return letter + "";
		int c = map(letter);
		if (dp[level][c] != null)
			return dp[level][c];
		char[] array = transition(letter).toCharArray();
		String a = dp(level + 1, array[0]);
		String b = dp(level + 1, array[1]);
		if (a.compareTo(b) <= 0)
			dp[level][c] = a + b;
		else
			dp[level][c] = b + a;
		return dp[level][c];
	}
	
	static boolean test(String ref, int[] count_) {
		int[] count = new int[30];
		for(char c: ref.toCharArray()) 
			count[c - 'A']++;
		for(int i = 0; i < count.length; i++)
			if (count[i] != count_[i])
				return false;
		return true;
	}
	
	public static void main(String args[]) throws NumberFormatException, IOException {
		Scanner sc = new Scanner();
		int T = sc.nextInt();
		for(int c = 1; c <= T; c++) {
			N = sc.nextInt();
			R = sc.nextInt();
			P = sc.nextInt();
			S = sc.nextInt();
			int[] count = new int[30];
			count['R' - 'A'] = R;
			count['S' - 'A'] = S;
			count['P' - 'A'] = P;
			dp = new String[N][3];
			String[] array = new String[3];
			array[0] = dp(0, 'P');
			array[1] = dp(0, 'R');
			array[2] = dp(0, 'S');
			String ans = "IMPOSSIBLE";
			TreeSet<String> set = new TreeSet<String>();
			for(int i = 0; i < 3; i++)
				if (test(array[i], count))
					set.add(array[i]);
			if (set.size() > 0)
				ans = set.first();
			System.out.printf("Case #%d: %s\n", c, ans);
		}
	}

}
