import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.LinkedList;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;

public class C {
	
	static class Scanner{
		BufferedReader br=null;
		StringTokenizer tk=null;
		public Scanner(){
			br=new BufferedReader(new InputStreamReader(System.in));
		}
		public String next() throws IOException{
			while(tk==null || !tk.hasMoreTokens())
				tk=new StringTokenizer(br.readLine());
			return tk.nextToken();
		}
		public int nextInt() throws NumberFormatException, IOException{
			return Integer.valueOf(next());
		}
		public long nextLong() throws NumberFormatException, IOException{
			return Long.valueOf(next());
		}
		public double nextDouble() throws NumberFormatException, IOException{
			return Double.valueOf(next());
		}
	}
	
	//static TreeMap<BigInteger,BigInteger> fns = new  TreeMap<BigInteger,BigInteger>();
	static TreeMap<BigInteger,BigInteger>[] array;
	static LinkedList<BigInteger> fns = new  LinkedList<BigInteger>();
	
	static BigInteger ispalindromesq(BigInteger root){
		BigInteger sq = root.multiply(root);
		if (ispalindrome(sq.toString().toCharArray()))
			return sq;
		return null;
	}
	
	static boolean ispalindrome(char[] s){
		int i = 0;
		int j = s.length - 1;
		while(i < j){
			if (s[i] != s[j])
				return false;
			i++;
			j--;
		}
		return true;
	}
	
	static int limit = 52;
	
	static void init(){
		for(int i = 0; i < limit; i++)
			array[i] = new TreeMap<BigInteger,BigInteger>();
		array[0].put(BigInteger.ZERO,BigInteger.ZERO);
		array[1].put(BigInteger.ZERO,BigInteger.ZERO);
		array[1].put(BigInteger.ONE,BigInteger.ONE);
		array[1].put(new BigInteger("2"),new BigInteger("4"));
		array[1].put(new BigInteger("3"),new BigInteger("9"));
		array[2].put(new BigInteger("11"),new BigInteger("121"));
		array[2].put(new BigInteger("22"),new BigInteger("484"));
		for(int i = 3; i < limit; i++){
			String prefixandsufix = "";
			for(int j = i - 2; j >= 0; j-=2){
				for(BigInteger e: array[j].keySet()){
					String tmp = prefixandsufix + e.toString() + prefixandsufix;
					if (j == 0)
						tmp = prefixandsufix + prefixandsufix;
					for(int k = 1; k < 9; k++){
						String ntmp = k + tmp + k;
						BigInteger root = new BigInteger(ntmp+"");
						BigInteger sq = ispalindromesq(root);
						if (sq == null)
							break;
						array[i].put(root, sq);
					}
				}
				prefixandsufix += "0";
			}
		}
		
		for(int i = 1; i < limit; i++)
			for(BigInteger k : array[i].keySet())
				fns.add(array[i].get(k));
		//System.out.println(fns.size());
	}
	
	public static void main(String args[]) throws NumberFormatException, IOException{
		Scanner sc = new Scanner();
		array = new TreeMap[limit];
		init();
		int T = sc.nextInt();
		for(int c = 1; c <= T; c++){
			BigInteger A =new BigInteger(sc.next());
			BigInteger B =new BigInteger(sc.next());
			int count = 0;
			for(BigInteger e: fns)
				if (A.compareTo(e)<=0 && e.compareTo(B)<=0)
					count++;
			System.out.printf("Case #%d: %d\n",c,count);
		}
	}
}
