import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Stack;
import java.util.StringTokenizer;


public class C {
	
	static class Scanner{
		BufferedReader br=null;
		StringTokenizer tk=null;
		public Scanner(){
			br=new BufferedReader(new InputStreamReader(System.in));
		}
		public String next() throws IOException{
			while(tk==null || !tk.hasMoreTokens())
				tk=new StringTokenizer(br.readLine());
			return tk.nextToken();
		}
		public int nextInt() throws NumberFormatException, IOException{
			return Integer.valueOf(next());
		}
		public long nextLong() throws NumberFormatException, IOException{
			return Long.valueOf(next());
		}
		public double nextDouble() throws NumberFormatException, IOException{
			return Double.valueOf(next());
		}
	}
	
	static class Node {
		int id;
		int siguiente;
		int cycle;
		int color;
		LinkedList<Integer> inverso;
		public Node (int idd, int s){
			id = idd;
			siguiente = s;
			cycle = -1;
			color = 0;
			inverso = new LinkedList<Integer>();
		}
	}
	
	
	static void mark_cycle(int idx, Stack<Integer> so_far) {
		if (array[idx].color == 2)
			return;
		if (array[idx].color == 1) {
			//ciclo
			while(so_far.peek() != idx) {
				int tmp = so_far.pop();
				array[tmp].cycle = cycle;
			}
			array[idx].cycle = cycle;
			cycle++;
			so_far.clear();
			array[idx].color = 2;
			return;
		}
		array[idx].color = 1;
		so_far.push(idx);
		mark_cycle(array[idx].siguiente, so_far);
		array[idx].color = 2;
		return;
	}
	
	
	static int longest(int idx, int cc) {		
		int max = 0;
		for(int e: array[idx].inverso) {
			if (array[e].cycle == cc)
				continue;
			max = Math.max(max, 1 + longest(e, cc));
		}
		return max;
	}
	
	static Node[] array;
	static int cycle;
	static HashSet<Integer> cycles2;
	
	public static void main(String args[]) throws NumberFormatException, IOException {
		Scanner sc = new Scanner();
		int T = sc.nextInt();
		for(int c = 0; c < T; c++) {
			cycle = 0;
			int N = sc.nextInt();
			array = new Node[N];
			for(int i = 0; i < N; i++)
				array[i] = new Node(i, sc.nextInt() - 1);
			for(int i = 0; i < N; i++)
				array[array[i].siguiente].inverso.add(i);
			for(int i = 0; i < N; i++) {
				mark_cycle(i, new Stack<Integer>());
			}
			HashMap<Integer, Integer> count = new HashMap<Integer, Integer>();
			cycles2 =  new HashSet<Integer>();
			for(int i = 0; i < N; i++) {
				int tmp = array[i].cycle;
				if (count.containsKey(tmp))
					count.put(tmp, count.get(tmp) + 1);
				else
					count.put(tmp, 1);
			}
			int max = 0;
			for(int k: count.keySet()) {
				int value = count.get(k);
				max = Math.max(max, value);
				if (value == 2)
					cycles2.add(k);
			}
			for(int i = 0; i < N; i++) {
				if (array[i].cycle != -1 && cycles2.contains(array[i].cycle)) {
					int l1 = longest(i, array[i].cycle);
					int l2 = longest(array[i].siguiente, array[i].cycle);
					max = Math.max(max, l1 + l2 + 2);
				}
			}
//			System.out.println("====");
//			for(int i = 0; i < N; i++)
//				System.out.println(i+" "+array[i].cycle);
			System.out.printf("Case #%d: %d\n", c + 1, max);
		}
	}

}
