import java.io.FileNotFoundException;
import java.util.Scanner;

public class TicTacToeTomek {
	
	private static int os = (int) 'O' * 4;
	private static int ost = (int) 'O' * 3 + (int) 'T';
	private static int xs = (int) 'X' * 4;
	private static int xst = (int) 'X' * 3 + (int) 'T';
	
	public static void main(String args[]) throws FileNotFoundException {
		Scanner input = new Scanner(System.in);
		String line;
			
		int ntests = Integer.valueOf(input.nextLine());
		
		for (int i = 1; i <= ntests; i++) {
			
			int [][] board = new int[4][4];
			boolean boardFull = true;
			StringBuilder out = new StringBuilder();
			
			for (int j = 0; j < 4; j++) {
				line = input.nextLine();

				for (int k = 0; k < 4; k++) {
					if (line.charAt(k) == '.') {
						boardFull = false;
					}
					
					board[j][k] = (int) line.charAt(k);
				}
			}
			
			out.append("Case #").append(i).append(": ");
			
			char winner = '0'; // 0 for not finished, X for X, O for O, D for Draw, N for Not complete
			
			// check columns
			for (int c = 0; c < 4; c++) {
				int sum = board[c][0] + board[c][1] + board[c][2] + board[c][3];
				winner = resolve(sum);
				if (winner != '0') {
					break;
				}
			}
			
			// check rows
			if (winner == '0') {
				for (int r = 0; r < 4; r++) {
					int sum = board[0][r] + board[1][r] + board[2][r] + board[3][r];
					winner = resolve(sum);
					if (winner != '0') {
						break;
					}
				}
			}
			
			// check diagonals
			if (winner == '0') {
				int sum = board[0][0] + board[1][1] + board[2][2] + board[3][3];
				winner = resolve(sum);
			}
			
			if (winner == '0') {
				int sum = board[3][0] + board[2][1] + board[1][2] + board[0][3];
				winner = resolve(sum);
			}
			
			// resolve
			if (winner == '0') {
				if (boardFull) {
					winner = 'D';
				} else {
					winner = 'N';
				}
			}
			
			switch (winner) {
			case 'X':
			case 'O':
				out.append(winner).append(" won");
				break;
			case 'D':
				out.append("Draw");
				break;
			case 'N':
				out.append("Game has not completed");
				break;
			}
			
			System.out.println(out);
			if (input.hasNext()) input.nextLine();
		}
			
	}
	
	private static char resolve(int sum) {
		char result = '0';
		
		if (sum == os || sum == ost) {
			result = 'O';
		} else if (sum == xs || sum == xst) {
			result = 'X';
		}
		
		return result;
	}
}