package lawnmower;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.StringTokenizer;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Main {

    public static BufferedReader br = null;
    public static BufferedWriter bw = null;

    public static void print(int[][] mat, int fila, int col) {
        for (int i = 0; i < fila; i++) {
            for (int j = 0; j < col; j++) {
                System.out.print(mat[i][j] + " ");
            }
            System.out.println();
        }
        System.out.println();
    }

    public static int[][] leeMatriz(int fila, int col) {
        int[][] mat = new int[fila][col];
        try {
            String linea;
            StringTokenizer st = null;

            for (int i = 0; i < fila; i++) {
                linea = br.readLine();
                st = new StringTokenizer(linea);
                for (int j = 0; j < col; j++) {
                    mat[i][j] = Integer.parseInt(st.nextToken());
                }
            }

        } catch (Exception e) {
        } finally {
            return mat;
        }

    }

    public static int izquierda(int mat[][], int i, int j, int fila, int col) {
        return (j - 1 < 0) ? -1 : mat[i][j - 1];
    }

    public static int derecha(int mat[][], int i, int j, int fila, int col) {
        return (j + 1 >= col) ? -1 : mat[i][j + 1];
    }

    public static int abajo(int mat[][], int i, int j, int fila, int col) {
        return (i + 1 >= fila) ? -1 : mat[i + 1][j];
    }

    public static int arriba(int mat[][], int i, int j, int fila, int col) {
        return (i - 1 < 0) ? -1 : mat[i - 1][j];
    }

    public static boolean rodeadoFila(int[][] mat, int i, int j, int fila, int col) {
        int valor = mat[i][j];
        int izq = izquierda(mat, i, j, fila, col);
        int der = derecha(mat, i, j, fila, col);
        if (izq > valor || der > valor) {
            return true;
        }
        return false;
    }

    public static boolean rodeadoCol(int[][] mat, int i, int j, int fila, int col) {
        int valor = mat[i][j];
        int arr = arriba(mat, i, j, fila, col);
        int aba = abajo(mat, i, j, fila, col);
        if (arr > valor || aba > valor) {
            return true;
        }
        return false;
    }

    public static boolean fila(int[][] mat, int i, int j, int fila, int col) {
        int valor = mat[i][j];
        for (j = 0; j < col; j++) {
            if (mat[i][j] > valor) {
                return true;
            }
        }

        return false;
    }

    public static boolean col(int[][] mat, int i, int j, int fila, int col) {
        int valor = mat[i][j];
        for (i = 0; i < fila; i++) {
            if (mat[i][j] > valor) {
                return true;
            }
        }

        return false;
    }

    public static boolean campoImposible(int[][] mat, int i, int j, int fila, int col) {
        //return (rodeadoFila(mat, i, j, fila, col) && rodeadoCol(mat, i, j, fila, col));
        return (fila(mat, i, j, fila, col) && col(mat, i, j, fila, col));
    }

    public static boolean esPosible(int[][] mat, int fila, int col) {
        for (int i = 0; i < fila; i++) {
            for (int j = 0; j < col; j++) {
                if (campoImposible(mat, i, j, fila, col)) {
                    return false;
                }
            }
        }
        return true;
    }

    public static String resultado(int mat[][], int fila, int col) {
        return (esPosible(mat, fila, col) ? "YES" : "NO");
    }

    public static void main(String[] args) {
        try {
            br = new BufferedReader(new FileReader("Input.in"));
            bw = new BufferedWriter(new FileWriter(new File("Output.txt")));
            String linea = Main.br.readLine();
            StringTokenizer st = null;
            int n = Integer.parseInt(linea);
            int[][] mat;
            int index = 1, fila, col;

            while (n-- > 0) {
                linea = br.readLine();
                st = new StringTokenizer(linea);
                fila = Integer.parseInt(st.nextToken());
                col = Integer.parseInt(st.nextToken());
                mat = leeMatriz(fila, col);
                String respuesta = "Case #"+index+": "+resultado(mat, fila, col);
                System.out.println(respuesta);
                bw.write(respuesta+"\n");
//                print(mat,fila,col);
//                System.out.println(arriba(mat,0,0,fila,col));
//                System.out.println(abajo(mat,0,0,fila,col));
//                System.out.println(izquierda(mat,0,0,fila,col));
//                System.out.println(derecha(mat,0,0,fila,col));
                index++;
            }

            bw.close();

        } catch (Exception ex) {
            Logger.getLogger(Main.class
                    .getName()).log(Level.SEVERE, null, ex);
        }
    }

}
