package tic.tac.toe.tomek;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.StringTokenizer;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Main {

    public static BufferedReader br = null;
    public static BufferedWriter bw = null;

    public static void print(char[][] mat, int size) {

        for (int i = 0; i < size; i++) {
            for (int j = 0; j < size; j++) {
                System.out.print(mat[i][j]);
            }
            System.out.println();
        }

        System.out.println();
    }

    public static char[][] leeMatriz(int n) {
        char[][] mat = new char[n][n];
        try {
            String linea = null;
            int cont = 0;

            for (int i = 0; i < n; i++) {
                linea = br.readLine();
                for (int j = 0; j < n; j++) {
                    mat[i][j] = linea.charAt(j);
                }
            }
            br.readLine();
        } catch (Exception e) {
        } finally {
            return mat;
        }

    }

    public static String resultado(char[][] mat) {

        if (winnerPlayer('X', mat)) {
            return "X won";
        }
        if (winnerPlayer('O', mat)) {
            return "O won";
        }

        return (draw(mat)) ? "Draw" : "Game has not completed";
    }

    public static boolean winnerPlayer(char player, char[][] mat) {
        return (rows(player, mat) || cols(player, mat) || diagonals(player, mat));
    }

    public static boolean rows(char player, char[][] mat) {
        boolean ganador;
        for (int i = 0; i < 4; i++) {
            ganador = true;
            for (int j = 0; j < 4; j++) {
                char value = mat[i][j];
                if (value != player && value != 'T') {
                    ganador = false;
                    break;
                }
            }
            if (ganador) {
                return true;
            }
        }
        return false;
    }

    public static boolean cols(char player, char[][] mat) {
        boolean ganador;
        for (int i = 0; i < 4; i++) {
            ganador = true;
            for (int j = 0; j < 4; j++) {
                char value = mat[j][i];
                if (value != player && value != 'T') {
                    ganador = false;
                    break;
                }
            }
            if (ganador) {
                return true;
            }
        }
        return false;
    }

    public static boolean diagonals(char player, char[][] mat) {
        return (normal(player, mat) || inversa(player, mat));
    }

    private static boolean normal(char player, char[][] mat) {
        for (int i = 0; i < 4; i++) {
            char value = mat[i][i];
            if (value != player && value != 'T') {
                return false;
            }
        }
        return true;
    }

    private static boolean inversa(char player, char[][] mat) {
        char v1;
        v1 = mat[3][0];
        if (v1 != player && v1 != 'T') {
            return false;
        }

        v1 = mat[2][1];
        if (v1 != player && v1 != 'T') {
            return false;
        }

        v1 = mat[1][2];
        if (v1 != player && v1 != 'T') {
            return false;
        }

        v1 = mat[0][3];
        if (v1 != player && v1 != 'T') {
            return false;
        }

        return true;
    }

    public static boolean draw(char[][] mat) {
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                if (mat[i][j] == '.') {
                    return false;
                }
            }
        }
        return true;
    }

    public static void main(String[] args) {
        try {
            br = new BufferedReader(new FileReader("Input.in"));
            bw = new BufferedWriter(new FileWriter(new File("Output.txt")));
            String linea = Main.br.readLine();
            int n = Integer.parseInt(linea);
            System.out.println(n);
            int index = 1;

            while (n-- > 0) {
                //System.out.println("n: "+(n+1));
                char[][] mat = leeMatriz(4);
                // print(mat, 4);
                String resultado = resultado(mat);
                String salida = "Case #" + index + ": " + resultado;
                System.out.println(salida);
                bw.write(salida + "\n");
                index++;
            }

            bw.close();

        } catch (Exception ex) {
            Logger.getLogger(Main.class
                    .getName()).log(Level.SEVERE, null, ex);
        }
    }

}
