package fair.and.square;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.StringTokenizer;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Main {

    public static BufferedReader br = null;
    public static BufferedWriter bw = null;
    
    public static String reverse(String cadena){
        StringBuilder sb = new StringBuilder(cadena);
        return sb.reverse().toString();
    }
    
    public static boolean isPalindrome(String cadena){
        return (cadena.equals(reverse(cadena)));
    }
    
    public static boolean isFairAndSquare(String cadena){
        if(!isPalindrome(cadena)){
            return false;
        }
        Double square = Math.sqrt(Integer.parseInt(cadena));
        Integer cuadrado = square.intValue();
        if(cuadrado - square != 0){
            return false;
        }
            
        if(!isPalindrome(cuadrado.toString())){
            return false;
        }
        
        return true;
    }

    public static void main(String[] args) {
        try {
            br = new BufferedReader(new FileReader("Input.in"));
            bw = new BufferedWriter(new FileWriter(new File("Output.txt")));
            String linea = Main.br.readLine();
            StringTokenizer st = null;
            int n = Integer.parseInt(linea);
            int index = 1;

            while (n-- > 0) {
                linea = br.readLine();
                st = new StringTokenizer(linea);
                Integer inicio = Integer.parseInt(st.nextToken());
                Integer fin = Integer.parseInt(st.nextToken());
                
                int cont = 0;
                for(Integer i = inicio ; i <= fin; i++){
                    if(isFairAndSquare(i.toString())){
                        cont++;
                    }
                }
                String resultado = "Case #"+index+": "+cont;
                System.out.println(resultado);
                bw.write(resultado+"\n");
                index++;
            }

            bw.close();

        } catch (Exception ex) {
            Logger.getLogger(Main.class
                    .getName()).log(Level.SEVERE, null, ex);
        }
    }

}
