package com.google.code.jam;

import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

/**
 * Created by russinko on 4/9/16.
 */
public class CoinJam {

    private static final int MAX = 1000000001;
    private static boolean[] array = new boolean[MAX];
    private static final BigInteger[] PRIMES = new BigInteger[100000];

    public static void init() {
        long[] primes = new long[50847534];
        int pos = 0;
        for (int i = 2; i < MAX; i++) {
            if (!array[i]) {
                primes[pos++] = i;
                int j = i + i;
                while (j < MAX) {
                    array[j] = true;
                    j += i;
                }
            }
        }
        System.out.println("Calc done");
        for(pos = 0; pos < 100000; pos++) {
            if(pos % 1000 == 0) System.out.println(pos);
            PRIMES[pos] = new BigInteger(Long.toString(primes[pos]));
        }
        System.out.println("Init done");
    }

    public static void main(String[] args) throws Exception {
        StringBuilder sb = new StringBuilder();
        for(int i = 0; i < 63; i++) {
            sb.append(1);
        }
        BigInteger MAX_LONG = new BigInteger(sb.toString(), 2);
        sb = new StringBuilder();
        for(int i = 0; i < 32; i++) {
            sb.append("1");
        }

        BigInteger MAX_10 = new BigInteger(sb.toString(), 10);

        System.out.println(MAX_10.compareTo(MAX_LONG));



        init();

        int length = 32;

        PrintWriter pw = new PrintWriter("output.txt");
        pw.write("Case #1:\n");

        BigInteger endVal = endValue(length);
        BigInteger[] dividers = new BigInteger[10];

        int count = 0;
        MainLoop: for(BigInteger i = startValue(length); i.compareTo(endVal) <= 0; i = i.add(BigInteger.ONE)) {
            String s = i.toString(2);
            if(!s.endsWith("1")) {
                continue;
            }
            if(!s.startsWith("1")) {
                throw new RuntimeException("Algorithm problem");
            }
            for(int j = 2; j <= 10; j++) {
                BigInteger value = new BigInteger(s, j);
                BigInteger divider = find(value);
                if(divider == null) {
                    continue MainLoop;
                } else {
                    dividers[j - 2] = divider;
                }
            }
            pw.printf("%s", s);
            for(int j = 2; j <= 10; j++) {
                pw.printf(" %s", dividers[j - 2].toString());
            }
            pw.print("\n");
            pw.flush();
            count++;
            if(count >= 500) {
                break;
            }
            System.out.println(count);

        }

        pw.close();



    }

    private static BigInteger find(BigInteger l) {
        for(BigInteger p : PRIMES) {
            if(p.compareTo(l) > -1) {
                return null;
            }
            if((l.mod(p)).equals(BigInteger.ZERO)) {
                return p;
            }
        }
        return null;
    }

    private static BigInteger startValue(int length) {
        StringBuilder sb = new StringBuilder();
        sb.append("1");
        for(int i = 0; i < length - 2; i++) {
            sb.append("0");
        }
        sb.append("1");
        return new BigInteger(sb.toString(), 2);
    }

    private static BigInteger endValue(int length) {
        StringBuilder sb = new StringBuilder();
        for(int i = 0; i < length; i++) {
            sb.append("1");
        }
        return new BigInteger(sb.toString(), 2);
    }

}
