import java.io.*;
import java.util.Scanner;
import java.util.regex.Pattern;

public class A {
    private static boolean debug = false;

    public static void setDebug(boolean d) {
        debug = d;
    }

    public static double WP(int team, int skip, int[][] games) {
        double win = 0.0;
        double loose = 0.0;
        for(int i = 0; i < games.length; i++) {
            if(i == skip) {
                continue;
            }
            if(games[team][i] == 1) {
                win = win + 1.0;
            } else if(games[team][i] == 0) {
                loose = loose + 1.0;
            }
        }
        return win / (win + loose);
    }

    public static boolean isOpponnens(int a, int b, int[][] games) {
        return games[a][b] != -1;
    }

    public static double OWP(int team, int[][] games) {
        double owp = 0.0;
        double n = 0;
        for(int i = 0; i < games.length; i++) {
            if(i == team) continue;
            if(isOpponnens(i, team, games)) {
                owp = owp + WP(i, team, games);
                n = n + 1.0;
            }
        }
        return owp / n;
    }

    public static double OOWP(int team, int[][] games) {
        double oowp = 0.0;
        double n = 0.0;
        for(int i = 0; i < games.length; i++) {
            if(i == team) continue;
            if(isOpponnens(i, team, games)) {
                oowp = oowp + OWP(i, games);
                n = n + 1.0;
            }
        }
        return oowp / n;
    }

    public static void process(InputStream is, OutputStream os) {
        Scanner sc = new Scanner(is);
        PrintWriter pw = new PrintWriter(os);

        Pattern pattern = Pattern.compile("[\\.10]+");

        int nCases = sc.nextInt();
        for(int i = 0; i < nCases; i++) {
            pw.write(String.format("Case #%d:%n", i + 1));
            int tCount = sc.nextInt();
            int[][] games = new int[tCount][tCount];
            for(int j = 0; j < tCount; j++) {
                String lint = sc.next(pattern);
                for(int k = 0; k < tCount; k++) {
                    if(lint.charAt(k) == '.') {
                        games[j][k] = -1;
                    }  else if (lint.charAt(k) == '1') {
                        games[j][k] = 1;
                    }  else if (lint.charAt(k) == '0') {
                        games[j][k] = 0;
                    }   else {
                        throw new RuntimeException("Input was incorrect");
                    }
                }
            }
            for(int j = 0; j < tCount; j++) {
                double wp = WP(j, -1, games);
                double owp = OWP(j, games);
                double oowp = OOWP(j, games);
                double rpi = 0.25 * wp + 0.50 * owp + 0.25 * oowp;
                pw.write(String.format("%10.6f%n", rpi));

            }
        }

        pw.flush();
    }

    private static void log(String s) {
        if (debug) {
            System.out.println(s);
        }
    }

    public static void main(String[] args) throws Exception {
        FileInputStream fis = new FileInputStream(new File("src/main/java/A.in"));
        FileOutputStream fos = new FileOutputStream(new File("src/main/java/A.out"));
        process(fis, fos);
        fos.close();
    }
}
