package google;

import junit.framework.TestCase;

import java.io.*;
import java.util.*;
import java.util.regex.Pattern;

public class B extends TestCase {

    private final static boolean DEBUG = true;

    static List<Character> spell(Map<String, Character> creation,
                                 Map<Character, Set<Character>> deletion,
                                 String sequence) {

        List<Character> list = new ArrayList<Character>();

        for(char c : sequence.toCharArray()) {
            list.add(c);

            while (true) {
                if(list.size() < 2) {
                    break;
                }
                boolean noOps = true;
                char end = list.get(list.size() - 1);
                char prend = list.get(list.size() - 2);
                String comb = "" + prend + end;
                if(creation.containsKey(comb)) {
                    list.remove(list.size() - 1);
                    list.remove(list.size() - 1);
                    list.add(creation.get(comb));
                    noOps = false;
                } else if(deletion.containsKey(end)) {
                    list.remove(list.size() - 1);
                    Set<Character> set = new HashSet<Character>(list);
                    //System.out.println("DEL LIST:" + set);
                    for(char p : deletion.get(end)) {
                        if(set.contains(p)) {
                            list.clear();
                            noOps = false;
                            break;
                        }
                    }
                    if(noOps) list.add(end);
                }
                if(noOps) break;
            }

            //System.out.println("TURN:" + list.toString());
        }

        return list;
    }

    static void process(InputStream is, OutputStream os) {

        Scanner sc = new Scanner(is);
        PrintWriter pw = new PrintWriter(os);

        final Pattern CRSEQ = Pattern.compile("[A-Z]{3}");
        final Pattern DELSEQ = Pattern.compile("[A-Z]{2}");
        final Pattern PRSEQ = Pattern.compile("[A-Z]+");

        int caseCount = sc.nextInt();

        for (int i = 0; i < caseCount; i++) {
            Map<String, Character> creation = new HashMap<String, Character>();
            Map<Character, Set<Character>> deletion = new HashMap<Character, Set<Character>>();

            int createCount = sc.nextInt();
            for(int j = 0; j < createCount; j++) {
                String crSeq = sc.next(CRSEQ);
                char c1 = crSeq.charAt(0);
                char c2 = crSeq.charAt(1);
                creation.put("" + c1 + c2 , crSeq.charAt(2));
                creation.put("" + c2 + c1 , crSeq.charAt(2));
            }

            int deleteCount = sc.nextInt();
            for(int j = 0; j < deleteCount; j++) {
                String delSeq = sc.next(DELSEQ);
                char c1 = delSeq.charAt(0);
                char c2 = delSeq.charAt(1);
                if(!deletion.containsKey(c1)) {
                    deletion.put(c1, new HashSet<Character>());
                }
                if(!deletion.containsKey(c2)) {
                    deletion.put(c2, new HashSet<Character>());
                }
                deletion.get(c1).add(c2);
                deletion.get(c2).add(c1);
            }

            int seqLength = sc.nextInt();

            String sequence  = sc.next(PRSEQ);
            sequence = sequence.substring(0, seqLength);

            //System.out.println(sequence);

            List<Character> sp = spell(creation, deletion, sequence);

            pw.write(String.format("Case #%d: %s%n", i + 1, sp.toString()));

            System.out.println(sp);


        }

        pw.flush();
    }

    public static void main(String[] args) throws Exception {
        InputStream is = new FileInputStream("/home/vitaly/Desktop/googleB.txt");
        OutputStream os = new FileOutputStream("/home/vitaly/Desktop/answerB.txt");
        process(is, os);
        is.close();
        os.close();
    }

    // === HERE TESTS STARTED ===

    public void testInputs() throws Exception {
        runInput("", "");
    }

    private void runInput(String input, String expected) {
        ByteArrayInputStream is = new ByteArrayInputStream(input.getBytes());
        ByteArrayOutputStream os = new ByteArrayOutputStream();
        process(is, os);
        assertEquals(expected, os.toString());
    }
}
