import java.io.*;
import java.util.Scanner;
import java.util.regex.Pattern;

public class A {
    private static boolean debug = false;

    public static void setDebug(boolean d) {
        debug = d;
    }

    public static int[] findCorner(char[][] pict) {
        for (int i = 0; i < pict.length; i++) {
            System.out.println(String.valueOf(pict[i]));
            for (int j = 0; j < pict[i].length; j++) {
                if (pict[i][j] == '#') {
                    if ((i == 0) && (j == 0)) {
                        return new int[]{i, j};
                    }
                    if ((i == 0) && (j > 0) && (pict[i][j - 1] != '#')) {
                        return new int[]{i, j};
                    }
                    if ((i > 0) && (j == 0) && (pict[i - 1][j] != '#')) {
                        return new int[]{i, j};
                    }
                    if ((i > 0) && (j > 0) && (pict[i - 1][j] != '#') && (pict[i][j - 1] != '#')) {
                        return new int[]{i, j};
                    }
                }
            }
        }
        return null;
    }

    public static boolean paint(char[][] pict) {
        while (true) {
            int[] pos = findCorner(pict);
            if (pos == null) return true;
            System.out.println(pos[0] + ":" + pos[1]);
            int r = pos[0];
            int c = pos[1];
            if (r == (pict.length - 1)) return false;
            if (c == (pict[r].length - 1)) return false;
            if (pict[r + 1][c] == '#' && pict[r][c + 1] == '#' && pict[r + 1][c + 1] == '#') {
                pict[r][c] = '/';
                pict[r][c + 1] = '\\';
                pict[r + 1][c] = '\\';
                pict[r + 1][c + 1] = '/';
                System.out.println("PAINT");
            } else {
                return false;
            }
        }
    }


    public static void process(InputStream is, OutputStream os) {
        Scanner sc = new Scanner(is);
        PrintWriter pw = new PrintWriter(os);

        Pattern pat = Pattern.compile("[#\\.]+");

        int nc = sc.nextInt();

        for (int i = 0; i < nc; i++) {
            pw.write(String.format("Case #%d:%n", i + 1));
            System.out.println("-----");
            int rows = sc.nextInt();
            int cols = sc.nextInt();
            char[][] pict = new char[rows][cols];
            for (int j = 0; j < rows; j++) {
                String line = sc.next(pat);
                for (int k = 0; k < cols; k++) {
                    pict[j][k] = line.charAt(k);
                }
            }
            boolean result = paint(pict);
            if (result) {
                for (int j = 0; j < rows; j++) {
                    pw.write(String.format("%s%n", String.valueOf(pict[j])));
                }
            } else {
                pw.write(String.format("Impossible%n"));
            }
        }


        pw.flush();
    }

    private static void log(String s) {
        if (debug) {
            System.out.println(s);
        }
    }

    public static void main(String[] args) throws Exception {
        FileInputStream fis = new FileInputStream(new File("src/main/java/A.in"));
        FileOutputStream fos = new FileOutputStream(new File("src/main/java/A.out"));
        process(fis, fos);
        fos.close();
    }
}
