package google;

import java.io.*;
import java.util.*;
import java.util.regex.Pattern;

public class A {

    static int simulate(int[] side, int[] position, int n) {
        int[][] prevPos = new int[n][];
               int[][] prevTime = new int[n][];

               // Previous positions and time
               int[] pr = new int[]{1, 1};
               int[] tm = new int[]{-1, -1};

               for (int i = 0; i < n; i++) {
                   for(int j = 0; j < 2; j++) {
                      prevPos[i] = new int[]{pr[0], pr[1]};
                      prevTime[i] = new int[]{tm[0], tm[1]};
                   }
                   pr[side[i]] = position[i];
                   tm[side[i]] = i;
               }



//        System.out.println(Arrays.toString(prevPos[0]));
//        System.out.println(Arrays.toString(prevPos[1]));
//        System.out.println(Arrays.toString(prevPos[2]));
//        System.out.println(Arrays.toString(prevPos[3]));

               System.out.println("----- TIMING ------");

//        System.out.println(Arrays.toString(prevTime[0]));
//        System.out.println(Arrays.toString(prevTime[1]));
//        System.out.println(Arrays.toString(prevTime[2]));
//        System.out.println(Arrays.toString(prevTime[3]));

               DirectedGraph<Integer> graph = new DirectedGraph<Integer>();
               for(int i = 0; i < n; i++) {
                   graph.addNode(i);
               }

               int start_node = -1;
               int add_node = n;

               graph.addNode(start_node);
               graph.addNode(add_node);


               System.out.println("----- ADDITIONAL EQUATIONS ------");
               for(int i = 1; i < n; i++) {
                   System.out.println(String.format("t[%d] - t[%d] <= %d", i - 1, i, -1));

                   graph.addEdge(i, i - 1, -1);
               }



               System.out.println("----- EQUATIONS ------");

               // Equations
               for(int i = 0; i < n; i++) {
                   System.out.println(String.format("t[%d] - t[%d] <= %d",
                           prevTime[i][side[i]], i, -1 -Math.abs(position[i] - prevPos[i][side[i]]) ));

                   graph.addEdge(i, prevTime[i][side[i]], -1 -Math.abs(position[i] - prevPos[i][side[i]]) );
               }



               for(int i = 0; i < n; i++) {
                   graph.addEdge(n, i, 0);
               }

               Map<Integer, Double> map =  BellmanFord.shortestPaths(graph, n);

               System.out.println(map.toString());

               int offset = (int) -map.get(-1);

               for(int i = 0; i < n; i++) {
                   System.out.println(String.format("T[%d]=%d", i, offset + (int)(double)map.get(i)));
               }

               return offset + (int)(double)map.get(n - 1);
    }

    static void process(InputStream is, OutputStream os) {
        Scanner sc = new Scanner(is);
        PrintWriter pw = new PrintWriter(os);

        int caseNumber = sc.nextInt();

        Pattern pattern = Pattern.compile("O|B");

        for(int i = 0; i < caseNumber; i++) {
            int length = sc.nextInt();
            int[] side = new int[length];
            int[] position = new int[length];
            for(int j = 0; j < length; j++) {
                String s = sc.next(pattern);
                side[j] = s.equals("O") ? 0 : 1;
                position[j] = sc.nextInt();
            }
            int time = simulate(side, position, length);
            pw.write(String.format("Case #%d: %d%n", i + 1, time));
        }
        pw.flush();
    }

    public static void main(String[] args) throws Exception {

        InputStream is = new FileInputStream("/home/vitaly/Desktop/googleA.txt");
        OutputStream os = new FileOutputStream("/home/vitaly/Desktop/answerA.txt");
        process(is, os);
        is.close();
        os.close();

//        int n = 4;
//        int[] side = new int[]{0, 1, 1, 0};
//        int[] position = new int[]{2, 1, 2, 4};


        // O 5 O 8 B 100
//        int n = 3;
//        int[] side = new int[]{0, 0, 1};
//        int[] position = new int[]{5, 8, 100};

        // B 2 B 1
//        int n = 2;
//        int[] side = new int[]{1, 1};
//        int[] position = new int[]{2, 1};

//        int n = 100;
//
//        int[] side = new int[n];
//        int[] position = new int[n];
//
//        Random random = new Random();
//
//        for(int i = 0; i < n; i++) {
//          side[i] = random.nextInt(2);
//          position[i] = 1 + random.nextInt(100);
//        }



    }

}
