import java.io.File;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

/**
 * Created with IntelliJ IDEA.
 * User: Vitaly Russinkovsky
 * Date: 4/13/13
 */
public class TaskD {

    public static void main(String[] args) throws Exception {

        Scanner sc = new Scanner(new File("D-small-attempt2.in.txt"));
        //Scanner sc = new Scanner(new File("input.txt"));
        PrintWriter pw = new PrintWriter(new File("output.txt"));

        int caseCount = sc.nextInt();
        for (int i = 0; i < caseCount; i++) {

            System.out.println(i);

            int initialKeys = sc.nextInt();
            int chestsCount = sc.nextInt();

            System.out.println(initialKeys + ":" + chestsCount);

            int[] myKeys = new int[200];
            for (int ik = 0; ik < initialKeys; ik++) {
                int kk = sc.nextInt() - 1;
                myKeys[kk] = myKeys[kk] + 1;
            }
            int[] chestKeys = new int[chestsCount];
            int[][] keysInside = new int[chestsCount][];
            int[] self = new int[chestsCount];
            for (int ck = 0; ck < chestsCount; ck++) {
                chestKeys[ck] = sc.nextInt() - 1;
                int insideKeysCount = sc.nextInt();
                int[] chest = new int[insideKeysCount];
                for (int ii = 0; ii < insideKeysCount; ii++) {
                    chest[ii] = sc.nextInt() - 1;
                    if(chestKeys[ck] == chest[ii]) {
                        self[ck] = 1;
                    }
                }
                keysInside[ck] = chest;
            }
            int[] openedChests = new int[chestsCount];

            for(int cc = 0; cc < openedChests.length; cc++)  {
                int count = 0;
                for(int ccc = 0; ccc < openedChests.length; ccc++) {
                    if(chestKeys[ccc] == chestKeys[cc]) {
                        count++;
                    }
                }
                openedChests[cc] = -count;
            }

            int[] result = null;

            if (preGuess(chestKeys, keysInside, myKeys)) {
                result = open(chestKeys, keysInside, openedChests, myKeys, self, 0, 1);
            }

            String rText = " IMPOSSIBLE";

            if (result != null) {
                StringBuilder sb = new StringBuilder();
                for (int iz = 0; iz < result.length; iz++) {
                    for (int jz = 0; jz < result.length; jz++) {
                        if (result[jz] == (iz + 1)) {

                            sb.append(" ");

                            sb.append(Integer.toString(jz + 1));
                        }
                    }
                }
                rText = sb.toString();

            }

            pw.write(String.format("Case #%d:%s\n", i + 1, rText));
            pw.flush();

        }

        sc.close();
        pw.close();


    }

    static boolean preGuess(final int[] chestKeys, final int[][] keysInside, final int[] myKeys) {
        int[] keys = Arrays.copyOf(myKeys, myKeys.length);
        for (int i = 0; i < keysInside.length; i++) {
            int[] insd = keysInside[i];
            for (int j : insd) {
                keys[j] = keys[j] + 1;
            }
        }
        for (int i = 0; i < chestKeys.length; i++) {

            int openingKey = chestKeys[i];
            keys[openingKey] = keys[openingKey] - 1;
            if (keys[openingKey] < 0) {
                return false;
            }

        }
        return true;
    }

    static int[] open(final int[] chestKeys, final int[][] keysInside, final int[] openedChests, final int[] myKeys, final int[] self, final int pos, final int turn) {
        if (turn > chestKeys.length) {
            return openedChests;
        }
        if (pos >= chestKeys.length) {
            return null;
        }
        if (openedChests[pos] < 0) {
            int openingKey = chestKeys[pos];
            boolean flag = false;
            if(myKeys[openingKey] > 1) {
               flag = true;
            }
            if(myKeys[openingKey] == 1 && self[pos] > 0) {
                flag = true;
            }
            if(myKeys[openingKey] == 1 && openedChests[pos] == -1) {
                flag = true;
            }

            if (flag) {
                int[] keys = changeKeys(myKeys, openingKey, keysInside[pos]);
                int[] chests = openChest(chestKeys, openedChests, pos, turn);
                int[] variant = open(chestKeys, keysInside, chests, keys, self, 0, turn + 1);
                if (variant != null) {
                    return variant;
                }
            }
        }
        return open(chestKeys, keysInside, openedChests, myKeys, self, pos + 1, turn);


    }

    static int[] openChest(final int[] chestKeys, int[] chests, int chest, int turn) {
        int[] copy = Arrays.copyOf(chests, chests.length);
        copy[chest] = turn;
        int keyType = chestKeys[chest];
        for(int i = 0; i < copy.length; i++) {
            if(copy[i] < 0 && chestKeys[i] == keyType) {
                copy[i] = copy[i] + 1;
            }
        }

        return copy;
    }

    static int[] changeKeys(int[] keys, int consumeKey, int[] addKeys) {
        int[] copy = Arrays.copyOf(keys, keys.length);
        copy[consumeKey] = copy[consumeKey] - 1;
        for (int k : addKeys) {
            copy[k] = copy[k] + 1;
        }
        return copy;
    }

    static boolean noDeadLock(final int[] chestKeys, final int[] openedChests, int key) {
        for (int i = 0; i < chestKeys.length; i++) {
            if (chestKeys[i] == key && openedChests[i] == 0) {
                System.out.println("Lock");
                return false;
            }
        }
        return true;
    }

}
