package google;

import junit.framework.TestCase;

import java.io.*;
import java.util.*;

public class C extends TestCase {

    private final static boolean DEBUG = true;

    final static int SIZE = 22;

    static int[] keys = null;

    static void generateKeys() {

        keys = new int[SIZE];

        int key = 1;
        for(int i = 0; i < SIZE; i++) {
            keys[i] = key;
            key = key << 1;
        }
    }

    static int analyze(int[] candies) {

        if(keys == null) generateKeys();

        int[] code = new int[SIZE];

        int smallest = candies[0];
        int is = 0;

        for(int i = 0; i < candies.length; i++) {
            for(int j = 0; j < SIZE; j++) {
                if((candies[i] & keys[j]) > 0) code[j]++;
            }
            if(candies[i] < smallest) {
                smallest = candies[i];
                is = i;
            }
        }

        for(int i = 0; i < SIZE; i++) {
            if(code[i] % 2 != 0) {
                return -1;
            }
        }

        int sum = 0;
        for(int i = 0; i < candies.length; i++) {
            if(i != is) {
                sum = sum + candies[i];
            }
        }

        return sum;
    }



    static void process(InputStream is, OutputStream os) {
        Scanner sc = new Scanner(is);
        PrintWriter pw = new PrintWriter(os);

        int caseCount = sc.nextInt();

        for(int i = 0; i < caseCount; i++) {
            int pileCount = sc.nextInt();
            int[] candies = new int[pileCount];
            for(int j = 0; j < pileCount; j++){
                candies[j] = sc.nextInt();
            }
            int solution = analyze(candies);
            if(solution == -1) {
                pw.write(String.format("Case #%d: NO%n", i + 1));
            } else {
                pw.write(String.format("Case #%d: %d%n", i + 1, solution));
            }
        }

        pw.flush();
    }

    public static void main(String[] args) throws Exception {
        InputStream is = new FileInputStream("/home/vitaly/Desktop/googleC.txt");
        OutputStream os = new FileOutputStream("/home/vitaly/Desktop/answerC.txt");
        process(is, os);
        is.close();
        os.close();
    }

    // === HERE TESTS STARTED ===

    public void testInputs() throws Exception {
        runInput("", "");
    }

    private void runInput(String input, String expected) {
        ByteArrayInputStream is = new ByteArrayInputStream(input.getBytes());
        ByteArrayOutputStream os = new ByteArrayOutputStream();
        process(is, os);
        assertEquals(expected, os.toString());
    }
}
