import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

/**
 * Created by russinko on 4/30/16.
 */
public class GettingTheDigits {
    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(new File("A-small-attempt0.in"));
        PrintWriter pw = new PrintWriter(new File("output.txt"));
        int caseCount = Integer.valueOf(sc.nextLine());
        for (int i = 0; i < caseCount; i++) {
            String number = sc.nextLine();
            pw.printf("Case #%d: %s\n", i + 1, recognize(number));
        }
        pw.close();
    }

    static String recognize(String number) {
        Map<Character, Integer> repr = charCount(number);
        List<Integer> recognize = dive(repr);
        StringBuffer sb = new StringBuffer();
        for (int i : recognize) {
            sb.append(Integer.toString(i));
        }
        return sb.toString();
    }


    static List<Integer> dive(Map<Character, Integer> number) {
        for (int i = 0; i < 10; i++) {
            Map<Character, Integer> digit = getMap().get(i);
            Map<Character, Integer> next = subtract(number, digit);
            if (next == null) continue;
            if (isEmpty(next)) {
                List<Integer> list = new ArrayList<>();
                list.add(i);
                return list;
            }
            List<Integer> step = dive(next);
            if (step != null) {
                List<Integer> list = new ArrayList<>();
                list.add(i);
                for (int k : step) {
                    list.add(k);
                }
                return list;
            }
        }
        return null;
    }


    static boolean isEmpty(Map<Character, Integer> number) {
        for (Integer n : number.values()) {
            if (n > 0) return false;
        }
        return true;
    }

    static Map<Integer, Map<Character, Integer>> getMap() {
        Map<Integer, Map<Character, Integer>> map = new HashMap<>();
        map.put(0, charCount("ZERO")); // Z
        map.put(1, charCount("ONE"));
        map.put(2, charCount("TWO"));
        map.put(3, charCount("THREE"));
        map.put(4, charCount("FOUR"));
        map.put(5, charCount("FIVE"));
        map.put(6, charCount("SIX"));   // X
        map.put(7, charCount("SEVEN"));
        map.put(8, charCount("EIGHT"));
        map.put(9, charCount("NINE"));
        return map;
    }

    static Map<Character, Integer> subtract(Map<Character, Integer> from, Map<Character, Integer> digit) {
        Map<Character, Integer> newMap = new HashMap<>();
        for (char c : from.keySet()) {
            newMap.put(c, from.get(c));
        }
        for (char c : digit.keySet()) {
            int subtract = digit.get(c);
            int before = newMap.getOrDefault(c, 0);
            if ((before - subtract) < 0) return null;
            newMap.put(c, before - subtract);
        }
        return newMap;
    }

    static Map<Character, Integer> charCount(String s) {
        Map<Character, Integer> map = new HashMap<>();
        for (char c : s.toCharArray()) {
            Integer count = map.getOrDefault(c, 0);
            map.put(c, count + 1);
        }
        return map;

    }


}
