import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

/**
 * Created by russinko on 5/8/16.
 */
public class SenateEvacuation {
    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(new File("/Users/russinko/Downloads/A-large.in"));
        PrintWriter pw = new PrintWriter(new File("output.txt"));
        int caseCount = sc.nextInt();
        for (int i = 0; i < caseCount; i++) {
            int partyCount = sc.nextInt();

            List<Character> members = new ArrayList<>();

            for(int j = 0; j < partyCount; j++) {
                char party = getParty(j);
                int memberCount = sc.nextInt();
                for(int k = 0; k < memberCount; k++) {
                    members.add(party);
                }

            }

            pw.printf("Case #%d: %s\n", i + 1, render(members));
        }
        pw.close();
    }

    static char getParty(int i) {
        return (char)('A' + (char) i);
    }

    static String render(List<Character> members) {
        List<String> plan = evacuationPlan(members);
        String result = "";
        for(String l : plan) {
            if(result.length() > 0) {
                result = result + " ";
            }
            result = result + l;
        }
        return result;
    }

    static List<String> evacuationPlan(List<Character> members) {
        int count = members.size();
        List<String> evacPlan = new ArrayList<>();
        Map<Character, Integer> st = stats(members);
        while (count > 0) {
            String evac = "";
            Comp comp = new Comp(st);
            List<Character> list = new ArrayList<>(st.keySet());

            Collections.sort(list, comp);

            Character c = list.get(0);
            evac = c.toString();
            st.put(c, st.get(c) - 1);
            count--;
            if(count == 0) {
                evacPlan.add(evac);
                return evacPlan;
            }
            list = new ArrayList<>(st.keySet());
            Collections.sort(list, comp);

            for(Character cc : list) {
                if(safeToRemove(st, cc)) {
                    evac = evac + cc;
                    st.put(cc, st.get(cc) - 1);
                    count--;
                    break;
                }
            }
            evacPlan.add(evac);
        }
        return evacPlan;
    }

    static Map<Character, Integer> stats(List<Character> list) {
        Map<Character, Integer> map = new HashMap<>();
        for(Character l : list) {
            int count = map.getOrDefault(l, 0);
            map.put(l, count + 1);
        }
        return map;
    }

    static boolean safeToRemove(Map<Character, Integer> map, char member) {
        Map<Character, Integer> copy = new HashMap<>(map);
        copy.put(member, copy.get(member) - 1);
        int sum = 0;
        for(Integer v : copy.values()) {
            sum = sum + v;
        }
        Integer max = null;
        for(Integer v : copy.values()) {
            if(max == null) {
                max = v;
            }
            if(max < v) {
                max = v;
            }
        }
        if((max * 2) > sum ) {
            return false;
        }
        return true;
    }

    static class Comp implements Comparator<Character> {
        Map<Character, Integer> map;

        public Comp(Map<Character, Integer> map) {
            this.map = map;
        }

        @Override
        public int compare(Character o1, Character o2) {
            return Integer.compare(map.get(o2), map.get(o1));
        }
    }
}
