import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * Created with IntelliJ IDEA.
 * User: Vitaly Russinkovsky
 * Date: 4/13/13
 */
public class TaskA {

    private static final String XWON = "X won";
    private static final String OWON = "O won";
    private static final String DRAW = "Draw";
    private static final String NOT_COMPLETED =  "Game has not completed";

    public static void main(String[] args) throws Exception{

        Scanner sc = new Scanner(new File("A-large.in.txt"));
        PrintWriter pw = new PrintWriter(new File("output.txt"));

        int caseCount = Integer.parseInt(sc.nextLine());
        for(int i = 0; i < caseCount; i++) {
            String[][] state = new String[4][4];
            for(int lc = 0; lc < 4; lc++) {
                String line = sc.nextLine();
                for(int pos = 0; pos < 4; pos++) {
                    state[lc][pos] = line.substring(pos, pos + 1);
                }
            }
            pw.write(String.format("Case #%d: %s\n", i + 1, analyze(state)));
            if(i < caseCount - 1) {
                sc.nextLine();
            }
        }


        sc.close();
        pw.close();
    }

    private static boolean xWinFailed(String s) {
        return ".".equals(s) || "O".equals(s);
    }

    private static boolean oWinFailed(String s) {
        return ".".equals(s) || "X".equals(s);
    }

    private static String analyze(String[][] state) {
        // Brute force
        // X win horizontal
        for(int i = 0; i < 4; i++) {
            boolean xWin = true;
            boolean oWin = true;
            for(int j = 0; j < 4; j++) {
                if(xWinFailed(state[i][j])) {
                    xWin = false;
                }
                if(oWinFailed(state[i][j])) {
                    oWin = false;
                }
            }
            if(xWin) return XWON;
            if(oWin) return OWON;
        }

        // X win vertical
        for(int j = 0; j < 4; j++) {
            boolean xWin = true;
            boolean oWin = true;
            for(int i = 0; i < 4; i++) {
                if(xWinFailed(state[i][j])) {
                    xWin = false;
                }
                if(oWinFailed(state[i][j])) {
                    oWin = false;
                }
            }
            if(xWin) return XWON;
            if(oWin) return OWON;
        }

        // Diagonal one
        boolean xWin = true;
        boolean oWin = true;
        for(int i = 0; i < 4; i++) {
            if(xWinFailed(state[i][i])) {
                xWin = false;
            }
            if(oWinFailed(state[i][i])) {
                oWin = false;
            }
        }
        if(xWin) return XWON;
        if(oWin) return OWON;

        // Diagonal two
        xWin = true;
        oWin = true;
        for(int i = 0; i < 4; i++) {
            if(xWinFailed(state[i][3-i])) {
                xWin = false;
            }
            if(oWinFailed(state[i][3-i])) {
                oWin = false;
            }
        }
        if(xWin) return XWON;
        if(oWin) return OWON;

        // Game complete
        boolean isGame = true;
        for(int i = 0; i < 4; i++) {
            for(int j = 0; j < 4; j++) {
                if(".".equals(state[i][j])) {
                    isGame = false;
                }
            }
        }


        return isGame ? DRAW : NOT_COMPLETED;


    }


}
