package com.google.code.jam;

import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * Created by russinko on 4/9/16.
 */
public class RevengePancakes {
    enum Mode {
        START,
        PLUS,
        MINUS
    }

    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(new File("B-large.in"));
        PrintWriter pw = new PrintWriter(new File("output.txt"));
        int numberOfInputs = Integer.valueOf(sc.nextLine());
        for(int i = 0; i < numberOfInputs; i++) {
            char[] cakes = sc.nextLine().toCharArray();
            pw.printf("Case #%d: %d\n", i + 1, happy(cakes));
        }
        sc.close();
        pw.close();
    }

    static int happy(char[] cakes) {
        int count = 0;
        MainLoop: while (true) {
            if(ready(cakes)) {
                return count;
            }
            Mode mode = Mode.START;
            for(int i = 0; i < cakes.length; i++) {
                if(cakes[i] == '+') {
                    switch (mode) {
                        case START: mode = Mode.PLUS; continue;
                        case PLUS: continue;
                        case MINUS: flip(cakes, i); count++; continue MainLoop;
                    }
                } else {
                    switch (mode) {
                        case START: mode = Mode.MINUS; continue;
                        case PLUS: flip(cakes, i); count++; continue MainLoop;
                        case MINUS: continue;
                    }

                }
            }
            switch (mode) {
                case MINUS: flip(cakes, cakes.length); count++; break;
                default: throw new RuntimeException("Algorithm mistake");
            }
        }
    }

    static void flip(char[] cakes, int n) {
        for(int i = 0; i < n / 2; i++) {
            char a = cakes[i];
            char b = cakes[n - i - 1];
            cakes[i] = turn(b);
            cakes[n - i - 1] = turn(a);
        }
        if(n % 2 == 1) {
            cakes[n / 2] = turn(cakes[n / 2]);
        }
    }

    static boolean ready(char[] cakes) {
        for(char c : cakes) {
            if(c == '-') return false;
        }
        return true;
    }

    static char turn(char cake) {
        if(cake == '+') {
            return '-';
        } else {
            return '+';
        }
    }
}
