import java.io.*;
import java.util.*;

public class B {
    private static boolean debug = false;

    public static void setDebug(boolean d) {
        debug = d;
    }

    public static double estimate(List<Double> pos, double D) {
        if(pos.size() == 1) {
            return 0.0;
        }
        double minX = pos.get(0);
        double maxX = pos.get(pos.size() - 1);
        for(double crd : pos) {
           if(crd < minX) minX = crd;
           if(crd > maxX) maxX = crd;
        }
        double n = pos.size();
        double required = D * (n - 1.0);
        double diap = maxX - minX;
        double time = (required - diap) / 2.0;
        return time;
    }




    public static void process(InputStream is, OutputStream os) {
        Scanner sc = new Scanner(is);
        PrintWriter pw = new PrintWriter(os);
        int nc = sc.nextInt();
        for (int i = 0; i < nc; i++) {
            //System.out.println("-----");
            int points = sc.nextInt();
            double D = sc.nextDouble();
            List<Double> list = new ArrayList<Double>();
            for (int j = 0; j < points; j++) {
                double crd = sc.nextDouble();
                int vend = sc.nextInt();
                for(int k = 0; k < vend; k++) {
                    list.add(crd);
                }

            }
            int p = 0;

            List<Double> sub = new ArrayList<Double>();
            Collections.sort(list);
            sub.add(list.get(0));
            double time = 0.0;
            while (true) {
                if(p == list.size() - 1) {
                    double st = estimate(sub, D);
                    if(st > time) time = st;
                    break;
                }
                p++;
                if((list.get(p) - list.get(p - 1)) >= D) {
                    double st = estimate(sub, D);
                    if(st > time) time = st;
                    sub = new ArrayList<Double>();

                }
                sub.add(list.get(p));
                //System.out.println(sub);

            }
            //System.out.println(list);
            pw.write(String.format("Case #%d: %15.6f%n", i + 1, time));
        }


        pw.flush();
    }

    private static void log(String s) {
        if (debug) {
            System.out.println(s);
        }
    }

    public static void main(String[] args) throws Exception {
        FileInputStream fis = new FileInputStream(new File("src/main/java/B.in"));
        FileOutputStream fos = new FileOutputStream(new File("src/main/java/B.out"));
        process(fis, fos);
        fos.close();
    }
}
