package com.google.codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Scanner;

/**
 * Created by alayouni on 4/8/17.
 */
public class Main {

    private static final String INPUT_PATH = "A-small-attempt0.in";
    private static final String OUTPUT_PATH = "A-small-attempt0.out";

    public void solve() throws FileNotFoundException {
        Scanner sc = new Scanner(new File(INPUT_PATH));
        PrintStream out = new PrintStream(new FileOutputStream(OUTPUT_PATH));
        int t = sc.nextInt();
        String s, ans;
        int k, minFlips;
        for(int i = 1; i <= t; i++) {
            s = sc.next();
            k = sc.nextInt();
            minFlips = minFlips(s, k);
            ans = minFlips == -1 ? "IMPOSSIBLE" : minFlips + "";
            out.printf("Case #%d: %s\n", i, ans);
        }
        out.close();
        sc.close();
    }

    private int minFlips(String s, int k) {
        boolean[] happy = toArray(s);
        int count = 0;
        for(int i = 0; i <= happy.length - k; i++) {
            if(!happy[i]) {
                for(int j = i; j < i + k; j ++) {
                    happy[j] = !happy[j];
                }
                count++;
            }
        }
        for(int i = Math.max(happy.length - k + 1, 0); i < happy.length; i++) {
            if(!happy[i]) return -1;
        }
        return count;
    }


    private boolean[] toArray(String s) {
        boolean[] happy = new boolean[s.length()];
        for(int i = 0; i < s.length(); i ++) {
            happy[i] = s.charAt(i) == '+' ? true : false;
        }
        return happy;
    }

    public static void main(String[] args) throws FileNotFoundException {
        new Main().solve();
    }
}
