package com.google.codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * Created by alayouni on 4/8/17.
 */
public class Main {

    private static final String INPUT_PATH = "B-large.in";
    private static final String OUTPUT_PATH = "B-large.out";

    public void solve() throws FileNotFoundException {
        Scanner sc = new Scanner(new File(INPUT_PATH));
        PrintStream out = new PrintStream(new FileOutputStream(OUTPUT_PATH));
        int t = sc.nextInt();
        long n, ans;
        for(int i = 1; i <= t; i++) {
            n = sc.nextLong();
            ans = lastCounted(n);
            out.printf("Case #%d: %d\n", i, ans);
        }
        out.close();
        sc.close();
    }

    long lastCounted(long n) {
        if(n < 10) return n;
        int[] digits = digits(n);
        long[] tenPow = tenPows(digits.length - 1);
        long lastCounted = 0;

        for(int i = digits.length - 2, j = i + 1; i >= 0; i--) {
            if(digits[i] < digits[j]) {
                lastCounted += tenPow[j] * (digits[j] - 1);
                for(j-- ;j >= 0; j--) {
                    lastCounted += tenPow[j] * 9;
                }
                return lastCounted;
            } else if(digits[i] > digits[j] || i == 0) {
                for(; j > i; j--) {
                    lastCounted += tenPow[j] * digits[j];
                }
            }
        }
        return lastCounted + digits[0];
    }


    int[] digits(long n) {
        List<Integer> digits = new ArrayList<Integer>();
        do {
            digits.add((int)(n % 10));
            n /= 10;
        } while(n != 0);

        return digits.stream().mapToInt((d) -> d).toArray();
    }

    long[] tenPows(int maxPow) {
        long[] tenPow = new long[maxPow + 1];
        tenPow[0] = 1;
        for(int pow = 1; pow <= maxPow; pow ++) {
            tenPow[pow] = tenPow[pow - 1] * 10;
        }
        return tenPow;
    }

    public static void main(String[] args) throws FileNotFoundException {
        new Main().solve();
    }

}
