package com.google.codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Scanner;

/**
 * Created by alayouni on 4/8/17.
 */
public class Main {
    private static final String INPUT_PATH = "C-large.in";
    private static final String OUTPUT_PATH = "C-large.out";

    public void solve() throws FileNotFoundException {
        Scanner sc = new Scanner(new File(INPUT_PATH));
        PrintStream out = new PrintStream(new FileOutputStream(OUTPUT_PATH));
        int t = sc.nextInt();
        long n, k, ans[];

        for(int i = 1; i <= t; i++) {
            n = sc.nextLong();
            k = sc.nextLong();
            ans = solve(n, k);
            out.printf("Case #%d: %d %d\n", i, ans[0], ans[1]);
        }
        out.close();
        sc.close();
    }


    static class EmptyStallSet {
        long empty, count;
        void copy(EmptyStallSet ess) {
            empty = ess.empty;
            count = ess.count;
        }

        int splitInto(EmptyStallSet max, EmptyStallSet min) {
            if(empty % 2 == 0) {
                max.empty = empty / 2;
                min.empty = (empty - 1) / 2;
                max.count = min.count = count;
                return 2;
            } else {
                max.empty = empty / 2;
                max.count = 2 * count;
                return 1;
            }
        }
    }
    private long[] solve(long n, long k) {
        EmptyStallSet[] ess = {new EmptyStallSet(), new EmptyStallSet(), new EmptyStallSet(), new EmptyStallSet()};
        ess[0].count = 1;
        ess[0].empty = n;
        EmptyStallSet min = new EmptyStallSet(), max = new EmptyStallSet();
        int diffCount = 1, splitRes;
        while (true) {
            if (ess[0].count >= k) return new long[]{ess[0].empty / 2, (ess[0].empty - 1) / 2};
            k -= ess[0].count;
            splitRes = ess[0].splitInto(max, min);
            diffCount --;
            for(int i = 0; i < diffCount; i ++) {
                ess[i].copy(ess[i + 1]);
            }
            diffCount = mergeOrAppendEmptySmallSet(max, ess, diffCount);
            if(splitRes == 2) diffCount = mergeOrAppendEmptySmallSet(min, ess, diffCount);
        }
    }

    private int mergeOrAppendEmptySmallSet(EmptyStallSet ess, EmptyStallSet[] arr, int arrSize) {
        if(arrSize == 0 || ess.empty < arr[arrSize - 1].empty) {
            arr[arrSize ++].copy(ess);
        } else {
            arr[arrSize - 1].count += ess.count;
        }
        return arrSize;
    }



    public static void main(String[] args) throws FileNotFoundException {
        new Main().solve();
    }
}
