import java.io.PrintStream;
import java.util.Scanner;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.Comparator;

public class Solution {

	static final String INPUT_FILE_NAME = "A-large-0-expected";
	static Scanner in;
	static PrintStream out;

	public static void main(String[] args) throws FileNotFoundException {
		in = new Scanner(INPUT_FILE_NAME + ".in");
		out = new PrintStream(INPUT_FILE_NAME + ".out");
		int caseCount = initialize();
		for(int caseNo = 1; caseNo < caseCount + 1; caseNo ++) {
			out.printf("Case #%d: ", caseNo);
			new Solution().solve(caseNo);
		}
		in.close();
		out.close();
	}



	static final BigDecimal PI = BigDecimal.valueOf(Math.PI);
	static final BigDecimal TWO = BigDecimal.valueOf(2);

	Comparator<Cake> cirCmp = (c1, c2) -> -c1.cir.compareTo(c2.cir);
	Comparator<Cake> rCmp = (c1, c2) -> -c1.r.compareTo(c2.r);

	static class Cake {
		int index = 100000;

		BigDecimal r, h;

		BigDecimal cir;

		public Cake(int r, int h) {
			this.r = BigDecimal.valueOf(r);
			this.h = BigDecimal.valueOf(h);
			this.cir = circ();
		}

		BigDecimal circ() {
			return TWO.multiply(PI).multiply(r).multiply(h);
		}

		BigDecimal area() {
			return r.multiply(r).multiply(PI);
		}
	}

	public void solve(int caseNo) {
		int n = in.nextInt(),
				k = in.nextInt();
		Cake[] cakesR = new Cake[n],
				cakesCirc = new Cake[n];
		for(int i = 0; i < n; i++) {
			cakesCirc[i] = cakesR[i] = new Cake(in.nextInt(), in.nextInt());

		}
		Arrays.sort(cakesR, rCmp);
		Arrays.sort(cakesCirc, cirCmp);
		BigDecimal surface = BigDecimal.ZERO;
		for(int i = 0; i < k; i ++) {
			cakesCirc[i].index = i;
			surface = surface.add(cakesCirc[i].cir);
		}
		BigDecimal surface2 = surface.subtract(cakesCirc[k - 1].cir),
				maxSurface = BigDecimal.ZERO,
				tmp;

		for(Cake c : cakesR) {
			if(c.index < k) {
				tmp = surface.add(c.area());
			} else {
				tmp = surface2.add(c.cir.add(c.area()));
			}
			if(tmp.compareTo(maxSurface) > 0)
				maxSurface = tmp;
			if(c.index < k) break;
		}

		out.printf("%.9f\n", maxSurface);
	}




	public static int initialize() {
		return in.nextInt();
	}

}