package com.google.codejam;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Scanner;

public class FairWarming {

	public static void main(String[] args) throws FileNotFoundException {
		InputStream in = System.in;
		if (args.length > 0)
			in = new FileInputStream(args[0]);
		PrintStream out = System.out;
		if (args.length > 1)
			out = new PrintStream(args[1]);
		Scanner scanner = new Scanner(in);

		solve(out, scanner);
	}

	public static void solve(PrintStream out, Scanner scanner) {
		int C = scanner.nextInt();
		for (int caseNum = 1; caseNum <= C; caseNum++) {
			int N = scanner.nextInt();
			BigInteger gcd = null;
			final BigInteger base = scanner.nextBigInteger();
			for (int i = 1; i < N; i++) {
				BigInteger val = scanner.nextBigInteger();
				if (val.compareTo(base) > 0)
					val = val.add(base.negate());
				else
					val = base.add(val.negate());
				if (gcd == null)
					gcd = val;
				else {
					gcd = val.gcd(gcd);

				}
			}
			if (base.mod(gcd).equals(BigInteger.ZERO)) {
				out.println("Case #" + caseNum + ": " + 0);
				
			} else {
				BigInteger result = gcd.add(base.mod(gcd).negate());
				out.println("Case #" + caseNum + ": " + result);

			}


		}
	}
}
