import java.util.*;
import java.io.*;

class PhoneNumber {
    final static String[] numbers =
        new String[] { "ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE" };

    public static void main(String[] args) {
        Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int T = sc.nextInt();

        for (int i = 1; i <= T; i++) {
            String msg = sc.next();
            int[] charCount = generateCharCount(msg);

            String ans = solve(charCount, new StringBuilder(), 0);

            System.out.printf("Case #%d: %s\n", i, ans);
        }
    }

    static String solve(int[] charCount, StringBuilder candidate, int index) {
        if (kosong(charCount)) {
            return candidate.toString();
        }

        if (index > 9) {
            return null;
        }

        int[] newCC1 = new int[26];
        System.arraycopy(charCount, 0, newCC1, 0, 26);
        String justNext = solve(newCC1, new StringBuilder(candidate), index + 1);

        boolean canStay = appendIfPossible(charCount, candidate, index);

        String takeAndStay = canStay ? solve(charCount, new StringBuilder(candidate), index) : null;
        String takeAndNext = solve(charCount, new StringBuilder(candidate), index + 1);

        if (takeAndStay != null) {
            return takeAndStay;
        } else if (takeAndNext != null) {
            return takeAndNext;
        } else {
            return justNext;
        }
    }

    static boolean appendIfPossible(int[] charCount, StringBuilder sb, int index) {
        if (gotLetters(charCount, numbers[index])) {
            deductCount(charCount, numbers[index]);
            sb.append(index);
            return true;
        }
        return false;
    }

    static void deductCount(int[] charCount, String str) {
        for (int i = 0; i < str.length(); i++) {
            int index = (int)str.charAt(i) - 65;
            charCount[index]--;
        }
    }

    static boolean gotLetters(int[] charCount, String str) {
        int[] charCount2 = generateCharCount(str);
        for (int i = 0; i < charCount2.length; i++) {
            if (charCount[i] < charCount2[i]) {
                return false;
            }
        }
        return true;
    }

    static int[] generateCharCount(String str) {
        int[] charCount = new int[26];

        for (int j = 0; j < str.length(); j++) {
            int index = (int)str.charAt(j) - 65;
            charCount[index]++;
        }
        return charCount;
    }

    static boolean kosong(int[] arr) {
        for (int i = 0; i < arr.length; i++) {
            if (arr[i] > 0) {
                return false;
            }
        }
        return true;
    }
}