package round1B;

import java.util.*;
import java.io.*;

public class BoredTSP {
	
	public static void main(String[] args) throws IOException{
		
		Scanner input = new Scanner(new File("C-small-attempt0.in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter("Output.out"));
		int cases = input.nextInt();
		
		for (int i = 1; i <= cases; i++) {
			
			int N = input.nextInt();
			int M = input.nextInt();
			int[] zipcode = new int[N+1];
			int start = 0;
			zipcode[0] = 999999;
			
			// constructing nodes
			for (int j = 1; j <= N; j++) {
				zipcode[j] = input.nextInt();
				if (zipcode[start] > zipcode[j]) {
					start = j;
				}
			}
			
			// constructing the edges
			ArrayList<ArrayList<Integer>> flights = new ArrayList<>();
			for (int j = 0; j <= N; j++) {
				flights.add(new ArrayList<Integer>());
			}
			for (int j = 0; j < M; j++) {
				int from = input.nextInt();
				int to = input.nextInt();
				flights.get(from).add(to);
				flights.get(to).add(from);
			}
			StringBuilder concatzip = new StringBuilder();
			
			// DFS stack
			LinkedList<Integer> stack = new LinkedList<>();
			// list of visited nodes
			boolean[] visited = new boolean[N+1];
			visited[start] = true;

			// push to stack
			stack.push(start);

			// DFS
			while (!stack.isEmpty()) {
				int current = stack.pop();
				concatzip.append(zipcode[current]);
				// get neighbor list
				ArrayList<Integer> nbrList = flights.get(current);

				LinkedList<Integer> tempStack = new LinkedList<>();
				// Add the neighbors that has not been visited yet into the stack
				for (Integer integer : nbrList) {
					if (!visited[integer]) {
						tempStack.push(integer);
					}
				}
				
				while(!tempStack.isEmpty()) {
					// max is index in tempStack
					int max = 0;
					for (int j2 = 1; j2 < tempStack.size(); j2++) {
						if (zipcode[tempStack.get(j2)] > zipcode[tempStack.get(max)]) {
							max = j2;
						}
					}
					stack.push(tempStack.remove(max));
				}
				
				// updates the list of visited nodes
				if (!visited[current]) {
					visited[current] = true;
					
				}
			}
			
			System.out.println("Case #"+i+": "+concatzip);
			writer.write("Case #"+i+": "+concatzip);
			writer.newLine();
			
		}
		input.close();
		writer.close();
	}
	
}
