import java.util.*;
import java.io.*;
import java.math.*;

class CoinJam2 {
    public static void main(String[] args) {
        int N = 32;
        int K = 500;

        System.out.println("Case #1:");

        // number of legit coins
        int count = 0;

        // mid number to try
        int current = 0;

        while (count < K) {
            // Construct number
            String coin = generateCoin(current);

            boolean anyPrime = false;
            long[] factors = new long[9];

            for (int i = 2; i <= 10; i++) {
                BigInteger decimal = new BigInteger(coin, i);
                if (decimal.isProbablePrime(2)) {
                    anyPrime = true;
                    break;
                }
                BigInteger guess = sqrt(decimal);
                long factor = getFactor(decimal, guess);
                if (factor == 1) {
                    anyPrime = true;
                    break;
                }
                factors[i-2] = factor;
            }

            if (anyPrime) {
                current++;
                continue;
            }

            printCoinAndProof(coin, factors);

            count++;
            current++;
        }
    }

    static void printCoinAndProof(String coin, long[] factors) {
        StringBuilder sb = new StringBuilder();
        sb.append(coin);
        for (int i = 0; i < factors.length; i++) {
            sb.append(' ');
            sb.append(factors[i]);
        }
        System.out.println(sb.toString());
    }

    static long getFactor(BigInteger number, BigInteger guess) {
        while (guess.compareTo(BigInteger.ONE) > 0) {
            BigInteger[] res = number.divideAndRemainder(guess);

            // no remainder. It's a factor
            if (res[1].equals(BigInteger.ZERO)) {
                return res[0].longValue();
            }

            guess = guess.subtract(BigInteger.ONE);
        }
        return guess.longValue();
    }

    static String generateCoin(int current) {
        String mid = String.format("%014d", new BigInteger(Integer.toBinaryString(current)));
        StringBuilder sb = new StringBuilder();
        sb.append(1);
        sb.append(mid);
        sb.append(1);
        return sb.toString();
    }

    // Credits to http://stackoverflow.com/questions/4407839/how-can-i-find-the-square-root-of-a-java-biginteger
    static BigInteger sqrt(BigInteger x) {
        BigInteger div = BigInteger.ZERO.setBit(x.bitLength()/2);
        BigInteger div2 = div;
        // Loop until we hit the same value twice in a row, or wind
        // up alternating.
        for(;;) {
            BigInteger y = div.add(x.divide(div)).shiftRight(1);
            if (y.equals(div) || y.equals(div2))
                return y;
            div2 = div;
            div = y;
        }
    }
}
