import java.io.File;
import java.io.FileNotFoundException;
import java.util.*;


public class CountingSheep {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		File testFile = new File("d:\\Users\\Ricardo\\Documents\\CodeJam\\CountingSheep\\A-large.in");
		
		Scanner in=null;
		try {
			in = new Scanner(testFile);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (in==null){
			return;
		}
		Integer testCases = in.nextInt();
		in.nextLine();

		for (Integer currentCase = 0; currentCase < testCases; currentCase++) {
			Integer bleaNumber = in.nextInt();
			System.out.print(String.format("Case #%d: ",currentCase+1));
			if (bleaNumber==0){
				System.out.println("INSOMNIA");
				continue;
			}
			ArrayList<Integer> decomposedNumber = decompose(bleaNumber);
			ArrayList<Integer> currentSum  = decompose(bleaNumber);
			Integer knownNumbers = 0;
			boolean[] foundNumbers = new boolean[10];
		
			
			while (knownNumbers<10){
				for (Integer currentNumber:currentSum){
					if (!foundNumbers[currentNumber]){
						foundNumbers[currentNumber] = true;
						knownNumbers++;
					}					
				}
				if (knownNumbers<10){
					currentSum = addNumbers(currentSum,decomposedNumber);
				}
			}
			
			printLastSum(currentSum);
		
		}

		in.close();

	}

	private static void printLastSum(ArrayList<Integer> currentSum) {
		for (int i=currentSum.size()-1;i>=0;i--){		
			System.out.print(String.format("%d",currentSum.get(i)));
		}
		System.out.println();		
	}

	private static ArrayList<Integer> addNumbers(ArrayList<Integer> currentSum,
			ArrayList<Integer> decomposedNumber) {
		ArrayList<Integer>resultingSum = new ArrayList<Integer>();
		int remainder = 0;
		for (int i=0;i<decomposedNumber.size();i++){
			int newDigit = decomposedNumber.get(i) + currentSum.get(i)+remainder;
			if (newDigit<10){
				resultingSum.add(newDigit);
				remainder=0;
			}else{
				resultingSum.add(newDigit%10);
				remainder = 1;
			}
			
		}
		for (int i=decomposedNumber.size();i<currentSum.size();i++){
			int newDigit = currentSum.get(i)+remainder;
			if (newDigit<10){
				resultingSum.add(newDigit);
				remainder=0;
			}else{
				resultingSum.add(newDigit%10);
				remainder = 1;
			}
		}
		if (remainder==1){
			resultingSum.add(remainder);
		}
		return resultingSum;
	}

	private static ArrayList<Integer> decompose(Integer bleaNumber) {
		ArrayList<Integer>result = new ArrayList<Integer>();
		
		while(bleaNumber>0){
			result.add(bleaNumber%10);
			bleaNumber= bleaNumber/10;
		}
		
		return result;
	}

}
