import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;


public class RevengePancake {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		File testFile = new File("d:\\Users\\Ricardo\\Documents\\CodeJam\\RevengePancake\\B-large.in");
		
		Scanner in=null;
		try {
			in = new Scanner(testFile);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (in==null){
			return;
		}
		Integer testCases = in.nextInt();
		in.nextLine();

		for (Integer currentCase = 0; currentCase < testCases; currentCase++) {
			System.out.print(String.format("Case #%d: ",currentCase+1));
			String pancake=in.nextLine();
			ArrayList<Character> pancakeOrientation = new ArrayList<Character>();
			int moves = 0;
			for (int i=0;i<pancake.length();i++){
				pancakeOrientation.add( (Character)pancake.charAt(i));
			}
			while(!pancakeOrientation.isEmpty()){
				pancakeOrientation = removeTrailingHappy(pancakeOrientation);
				if (pancakeOrientation.isEmpty()){
					break;
				}
				if (justUnhappy(pancakeOrientation)){
					moves++;
					break;
				}else if (pancakeOrientation.get(0)=='+'){
					pancakeOrientation= reverseStartingHappy(pancakeOrientation);
					moves++;
					continue;
				}else{
					pancakeOrientation=reverse(pancakeOrientation);
					moves++;
					continue;
				}
				
			}
			System.out.println(moves);
			
		}

		in.close();

	}

	private static ArrayList<Character> reverse(
			ArrayList<Character> pancakeOrientation) {
		ArrayList<Character>returnPancake = new ArrayList<Character>();
		
		for(int i=pancakeOrientation.size()-1;i>=0;i--){
			returnPancake.add(pancakeOrientation.get(i)=='+'?'-':'+');
		}
		return returnPancake;
	}

	private static ArrayList<Character> reverseStartingHappy(
			ArrayList<Character> pancakeOrientation) {
		ArrayList<Character>returnPancake = new ArrayList<Character>();
		int i=0;
		while(i<pancakeOrientation.size() && pancakeOrientation.get(i)=='+'){
			returnPancake.add('-');
			i++;
			
		}
		while(i<pancakeOrientation.size()){
			returnPancake.add(pancakeOrientation.get(i++));
		}
		return returnPancake;
	}

	private static boolean justUnhappy(ArrayList<Character> pancakeOrientation) {
		int i=0;
		while(i<pancakeOrientation.size()){
			if (pancakeOrientation.get(i)!='-') return false;
			i++;
		}
		return true;
		
	}

	private static ArrayList<Character> removeTrailingHappy(
			ArrayList<Character> pancakeOrientation) {
		ArrayList<Character>returnPancake = new ArrayList<Character>();
		Integer copyUntil=pancakeOrientation.size()-1;
		
		while(copyUntil>=0 && pancakeOrientation.get(copyUntil)=='+'){
			copyUntil--;
		}
		for (int i=0;i<=copyUntil;i++){
			returnPancake.add(pancakeOrientation.get(i));
		}
		return returnPancake;
	}

}
