import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;


public class A {

	private static final String O_WON = "O won";
	private static final String X_WON = "X won";
	static final String FILE = "small-attempt0";

	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader in = new BufferedReader(new FileReader("A-" + FILE + ".in"));
		PrintWriter out = new PrintWriter(new File("A-" + FILE + ".out"));
		int t = Integer.parseInt(in.readLine());
		int i = 0;
		String[] state = new String[4];
		while(i < t) {
			state[0] = in.readLine();
			state[1] = in.readLine();
			state[2] = in.readLine();
			state[3] = in.readLine();
			in.readLine();
			++i;
			out.println("Case #" + i + ": " + getState(state));
		}
		out.close();
		in.close();
	}

	private static String getState(String[] state) {
		boolean containsEmpty = false;
		
		// search lines for victory
		for(String s : state) {
			if(s.indexOf('.') >= 0) {
				containsEmpty = true;
				continue;
			}
			if("XXXX".equals(s)) return X_WON;
			if("OOOO".equals(s)) return O_WON;
			if(s.indexOf('T') >= 0) {
				if(s.indexOf('X') < 0) return O_WON;
				if(s.indexOf('O') < 0) return X_WON;
			}
		}
		
		// search columns for victory
		for(int i = 0; i < 4; ++i) {
			boolean hasEmpty = false;
			boolean hasX = false;
			boolean hasO = false;
			
			for(String s : state) {
				if(s.charAt(i) == '.') {
					hasEmpty = true;
					break;
				}
				if(s.charAt(i) == 'X') {
					hasX = true;
					if(hasO) break;
				}
				if(s.charAt(i) == 'O') {
					hasO = true;
					if(hasX) break;
				}
			}
			if(hasEmpty)
				containsEmpty = true;
			else if(hasX && !hasO)
				return X_WON;
			else if(hasO && !hasX)
				return O_WON;
		}

		// search diagonals for victory
		boolean[] hasEmpty = new boolean[2];
		boolean[] hasX = new boolean[2];
		boolean[] hasO = new boolean[2];
		for(int i = 0; i < 4; ++i) {
			if(state[i].charAt(i) == '.')
				hasEmpty[0] = true;
			if(state[i].charAt(i) == 'X')
				hasX[0] = true;
			if(state[i].charAt(i) == 'O')
				hasO[0] = true;
			
			if(state[i].charAt(3 - i) == '.')
				hasEmpty[1] = true;
			if(state[i].charAt(3 - i) == 'X')
				hasX[1] = true;
			if(state[i].charAt(3 - i) == 'O')
				hasO[1] = true;
		}
		if(hasEmpty[0])
			containsEmpty = true;
		else if(hasX[0] && !hasO[0])
			return X_WON;
		else if(hasO[0] && !hasX[0])
			return O_WON;
		if(hasEmpty[1])
			containsEmpty = true;
		else if(hasX[1] && !hasO[1])
			return X_WON;
		else if(hasO[1] && !hasX[1])
			return O_WON;

		return containsEmpty? "Game has not completed" : "Draw";
	}

}
