import java.io.*;
import java.util.*;
import java.util.regex.*;

class FNode
{
	public float w;
	public String f;
	public FNode left, right;
}

class Animal
{
	public String s;
	public List<String> f = new ArrayList<String>();
}

public class A
{
	public static void main(String[] args) 
	{
		try
		{
			BufferedReader br = new BufferedReader(new FileReader("A-small-attempt0.in"));
			PrintWriter pw = new PrintWriter(new FileWriter("A-small-attempt0.out"));
			int N = Integer.parseInt(br.readLine());

			for(int i=0; i<N; i++)
			{
				pw.printf("Case #%d:\n",i+1);

				int L = Integer.parseInt(br.readLine());
				String s = br.readLine();

				for(int j=1; j<L; j++)
					s = s + " " + br.readLine();

				s = s.replace("("," ( ").replace(")"," ) ").replace("  "," ").replace("  "," ").replace("  "," ");

				FNode rootNode = getTree(s.trim());

				int A = Integer.parseInt(br.readLine());
				Animal[] animals = new Animal[A];

				for(int j=0; j<A; j++)
				{
					String x = br.readLine();
					String[] xa = x.split(" ");

					animals[j] = new Animal();
					animals[j].s = xa[0];
					for(int k=0; k<Integer.parseInt(xa[1]); k++)
						animals[j].f.add(xa[2+k]);

					pw.printf("%.7f\n",getCuteness(rootNode, animals[j].f));
				}
				pw.flush();
			}
		}
		catch(Exception e)
		{ 
			e.printStackTrace();
		}
	}

	static FNode getTree(String s)
	{
		FNode fNode = new FNode();

		s = s.trim();
				
		Pattern p = Pattern.compile("\\( (0.\\d*) (\\w*) (\\(.*\\)) \\)");
		Matcher m = p.matcher(s);
		if(!m.find())
		{
			fNode.w = Float.parseFloat(s.substring(1,s.length()-1));
			return fNode;
		}

		fNode.w = Float.parseFloat(m.group(1));
		fNode.f = m.group(2);

		String x = m.group(3);
		int c = 0, i;

		for(i=0; i<x.length(); i++)
		{
			if(x.charAt(i) == '(')
				c++;
			if(x.charAt(i) == ')')
				c--;
			if(c==0)
				break;
		}

		fNode.left = getTree(x.substring(0,i+1));
		fNode.right = getTree(x.substring(i+1));

		return fNode;
	}

	static float getCuteness(FNode rootNode, List<String> f)
	{
		if(rootNode.f == null)
			return rootNode.w;

		if(f.contains(rootNode.f))
			return rootNode.w * getCuteness(rootNode.left, f);
		
		return rootNode.w * getCuteness(rootNode.right, f);
	}
}
