import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ThemePark {
    public static void main(String[] args) throws IOException {

        FileReader fr = new FileReader(args[0]);
        BufferedReader br = new BufferedReader(fr);

        String line = br.readLine();
        int T = Integer.valueOf(line);

        for (int i=1; i<=T; i++) {
            line = br.readLine();
            String[] integers = line.split(" ");
            int R = Integer.valueOf(integers[0]);
            int k = Integer.valueOf(integers[1]);
            int N = Integer.valueOf(integers[2]);

            line = br.readLine();
            integers = line.split(" ");
            int[] groups = new int[N];

            for (int j=0; j<N; j++) {
                groups[j] = Integer.valueOf(integers[j]);
            }

            List<Integer> records = new ArrayList<Integer>();
            Map<Integer, Integer> map = new HashMap<Integer, Integer>();
            int index = 0;
            int turn = 0;
            int current;
            int groupNum;

            while(index < R) {

                current = 0;
                groupNum = 0;

                if (!map.containsKey(turn)) {

                    map.put(turn, index);

                    while (current < k && groupNum < N) {

                        if (current + groups[turn] <= k) {
                            current += groups[turn];

                        } else {
                            break;
                        }

                        turn = (turn +1) % N;
                        groupNum ++;
                    }

                    records.add(current);
                }
                else {
                    break;
                }

                index ++;
            }

            int result = 0;

            if (index < R) {
                int repeat = map.get(turn);
                int count = index - repeat;

                int repeatTimes = (R-1-repeat)/count - 1;
                int remain = (R-1-repeat)%count;

                int repeatResult = 0;
                int remainResult = 0;
                for (int j=0; j<count; j++) {
                    repeatResult += records.get(repeat + j);
                    if (j <= remain) {
                        remainResult += records.get(repeat + j);
                    }
                }

                result += repeatTimes * repeatResult + remainResult;
            }

            for (Integer record : records) {
                result += record;
            }

            System.out.println(String.format("Case #%d: %d", i, result));
            
        }
    }
}
