import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.PriorityQueue;
import java.util.Scanner;
import java.util.Set;
import java.util.Map.Entry;

public class Second {

	private String filename;
	private String outputName;
	private int numberOfCases;
	private List<String[]> scores;
	private List<String[]> results;


	public Second(String filename,String outputName){
		this.filename = filename;
		this.outputName = outputName;
		scores = new ArrayList();
		results = new ArrayList();
	}

	public void start(){
		readFromFile();

		computeResults();

		writeOutput();

	}




	private void computeResults() {

		for(int i = 0; i<numberOfCases;i++){
			String[] pair = scores.get(i);
			String C = pair[0];
			String J = pair[1];
			char advantage = 'N'; 
			StringBuilder sbC = new StringBuilder();
			StringBuilder sbJ = new StringBuilder();
			for(int j = 0; j<C.length();j++){
				if(advantage == 'N'){
					if(C.charAt(j) == J.charAt(j)){
						if(C.charAt(j) == '?'){
							sbC.append('0');
							sbJ.append('0');
						}else{
							sbC.append(C.charAt(j));
							sbJ.append(J.charAt(j));
						}
					}else if(C.charAt(j) != '?' && J.charAt(j)!='?'){
						sbC.append(C.charAt(j));
						sbJ.append(J.charAt(j));
						if(C.charAt(j)>J.charAt(j)){
							advantage = 'C';
						}else{
							advantage = 'J';
						}
					}else{
						if(C.charAt(j)=='?'){
							sbC.append(J.charAt(j));
							sbJ.append(J.charAt(j));
						}else{
							sbC.append(C.charAt(j));
							sbJ.append(C.charAt(j));
						}
					}

				}else if(advantage == 'C'){
					if(C.charAt(j)=='?'){
						sbC.append('0');
					}else{
						sbC.append(C.charAt(j));
					}
					
					if(J.charAt(j)=='?'){
						sbJ.append('9');
					}else{
						sbJ.append(J.charAt(j));
					}
								
					
				}else{
					
					if(C.charAt(j)=='?'){
						sbC.append('9');
					}else{
						sbC.append(C.charAt(j));
					}
					
					if(J.charAt(j)=='?'){
						sbJ.append('0');
					}else{
						sbJ.append(J.charAt(j));
					}
					
				}
			}
			
			String[] re = new String[2];
			re[0] = sbC.toString();
			re[1] = sbJ.toString();
			
			results.add(re);
		}


	}

	public void readFromFile(){
		numberOfCases=0;
		Scanner scanner;
		try {
			scanner = new Scanner(new File(filename));

			numberOfCases=scanner.nextInt();


			for(int i=0;i<numberOfCases;i++){
				String[] pair = new String[2];
				pair[0] = scanner.next();
				pair[1] =  scanner.next();
				scores.add(pair);

			}

			scanner.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void writeOutput(){
		File file = new File(outputName);

		if (!file.exists()) {
			try {
				file.createNewFile();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		FileWriter fw;
		try {
			fw = new FileWriter(file.getAbsoluteFile());

			BufferedWriter bw = new BufferedWriter(fw);
			for(int i = 0; i<results.size(); i++){
				String[] p = results.get(i);
				bw.write("Case #"+(i+1)+": "+p[0]+" "+p[1]);

				bw.newLine();   

			}

			bw.close();

		}catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
