import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class Second {

	private String filename;
	private String outputName;
	private int numberOfCases;
	private String[] strings;
	private int[] results;
	
	public Second(String filename,String outputName){
		this.filename = filename;
		this.outputName = outputName;
	}
	
	
	public void start(){
		readFromFile();
		
		computeResults();
		
		writeOutput();
		
	}
	
	
	private void computeResults() {
		
		for(int i = 0; i<strings.length; i++){
			String compressed = compress(strings[i]);
			results[i] = flipAmount(compressed);
		}
		
	}


	private int flipAmount(String compressed) {
		int toReturn = 0;
		
		
			
		for (char ch: compressed.toCharArray()) { 
	        if (ch == '-') {
	            toReturn += 2;
	        }
	    }
		
		if(compressed.charAt(0)=='-')
			toReturn--;
		
		
		return toReturn;
	}


	private String compress(String string) {
		StringBuilder sb = new StringBuilder();
		sb.append(string.charAt(0));
		
		for(int i = 1;i<string.length();i++){
			if(string.charAt(i)!=string.charAt(i-1))
				sb.append(string.charAt(i));
			
		}
		
		return sb.toString();
	}


	public void readFromFile(){
		numberOfCases=0;
		Scanner scanner;
		try {
			scanner = new Scanner(new File(filename));

			numberOfCases=scanner.nextInt();
			strings = new String[numberOfCases];
			results = new int[numberOfCases];
					
			for(int i=0;i<numberOfCases;i++){
				strings[i] = scanner.next();
			}

			scanner.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void writeOutput(){
		File file = new File(outputName);
		 
		if (!file.exists()) {
			try {
				file.createNewFile();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		FileWriter fw;
		try {
			fw = new FileWriter(file.getAbsoluteFile());
		 
		BufferedWriter bw = new BufferedWriter(fw);
		for(int i = 0; i<results.length; i++){
			
				bw.write("Case #"+(i+1)+": "+(results[i]));
				bw.newLine();   
			
		}
		
		bw.close();
		
		}catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
