import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class First {

	private String filename;
	private String outputName;
	private int numberOfCases;
	private int[] numbers;
	private long[] results;
	
	
	public First(String filename,String outputName){
		this.filename = filename;
		this.outputName = outputName;
	}

	public void start(){
		readFromFile();
		
		computeResults();
		
		writeOutput();
		
	}
	
	
			
	
	private void computeResults() {
		
		for(int i = 0; i<numbers.length; i++){
			Set<Integer> seen = new HashSet<Integer>();
			int multiply = 1;
			
			while(seen.size()!=10){
				if(numbers[i] == 0){
					results[i] = -1;
					break;
				}
				if(Long.MAX_VALUE - numbers[i] <(multiply-1)*numbers[i]){
					results[i] = -1;
					break;
				}
				
				long numberToCheck = multiply*numbers[i];
				
				while(numberToCheck != 0){
					seen.add((int) (numberToCheck%10));
					numberToCheck /=10;
				}		
				
				
				multiply++;
				
			}
			
			if(seen.size() == 10){
				results[i] = (multiply-1)*numbers[i];
			}
		
			
		}
		
		
		
		
		
	}

	public void readFromFile(){
		numberOfCases=0;
		Scanner scanner;
		try {
			scanner = new Scanner(new File(filename));

			numberOfCases=scanner.nextInt();
			numbers = new int[numberOfCases];
			results = new long[numberOfCases];
					
			for(int i=0;i<numberOfCases;i++){
				String s=scanner.next();
				numbers[i] = Integer.parseInt(s);				
			}

			scanner.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void writeOutput(){
		File file = new File(outputName);
		 
		if (!file.exists()) {
			try {
				file.createNewFile();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		FileWriter fw;
		try {
			fw = new FileWriter(file.getAbsoluteFile());
		 
		BufferedWriter bw = new BufferedWriter(fw);
		for(int i = 0; i<results.length; i++){
			if(results[i]==-1){
				bw.write("Case #"+(i+1)+": "+"INSOMNIA");
				bw.newLine();   
			}else{
				bw.write("Case #"+(i+1)+": "+(results[i]));
				bw.newLine();   
			}
		}
		
		bw.close();
		
		}catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
