import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;


public class Third {

	private String outputName;
	private int digitNumber;
	private int amountOfExamples;
	private List<String> strings;
	private List<int[]> results;
	
	public Third(String datasetName,String outputName){
		this.outputName = outputName;
		if(datasetName.equals("small")){
			digitNumber = 16;
			amountOfExamples = 50;
		}else if(datasetName.equals("big")){
			digitNumber = 32;
			amountOfExamples = 500;
		}else{
			digitNumber = 6;
			amountOfExamples = 3;
		}
	}
	
	
	public void start(){
		readFromFile();
		
		computeResults();
		
		writeOutput();
		
	}
	
	public String binaryNextNumber(String binary){
		
		String nextNumber ="";
		boolean notFound = true;
		while(notFound){
			nextNumber = addOne(binary);
			if(binary.length()!= nextNumber.length())
				break;
			if(nextNumber.charAt(nextNumber.length()-1)=='1')				
				notFound = false;
			
			
			binary = nextNumber;
		}
		
		if(notFound){
			return "exceeded allowed digit amount";
		}else{
			return nextNumber;
		}
		
	}
	
	private String addOne(String binary) {
		
		StringBuilder sb = new StringBuilder();
		int carry = 1;
		for(int i = binary.length()-1; i>-1;i--){
			int number = binary.charAt(i)-'0';
			if(number+carry == 2){
				carry = 1;
				sb.append('0');
			}else{
				sb.append((number+carry));
				carry = 0;
			}
		}
		if(carry == 1)
			sb.append('1');
		
		return sb.reverse().toString();
	}


	private void computeResults() {
		StringBuilder sb = new StringBuilder();
		sb.append('1');
		for(int i = 1; i<digitNumber-1;i++){
			sb.append('0');
		}
		sb.append('1');
		
		String myNumber = sb.toString();
		
		while(strings.size()<amountOfExamples){
			checkForPrimes(myNumber);
			String temp = binaryNextNumber(myNumber);
			if(temp.equals("exceeded allowed digit amount"))
				break;
			myNumber = temp;
		}
		
		
		
	}


	private void checkForPrimes(String myNumber) {
		int[] divisors = new int[9];
		boolean isPrime = false;
		for(int i = 2; i<11; i++){
			
			int divisor = findNonTrivialDivisor(myNumber,i);
			if(divisor == 1 ){
				isPrime = true;
				break;
			}
			divisors[i-2] = divisor;
			
		}
		
		if(!isPrime){
			
			strings.add(myNumber);
			results.add(divisors);
		}
		
		
	}


	private int findNonTrivialDivisor(String myNumber,int base) {
		long convertedNumber = 0;
		for(int i = 0; i<myNumber.length(); i++){
			int digit = myNumber.charAt(myNumber.length()-1-i)-'0';
			convertedNumber += digit*Math.pow(base, i);
		}
		
		
		int squared = (int) Math.sqrt(convertedNumber);
		
		if(convertedNumber%2==0)
			return 2;
		
		for(int i = 3; i<= squared; i+=2){
			if(convertedNumber%i==0)
				return i;
		}
		return 1;
	}


	public void readFromFile(){
		
			strings = new ArrayList<String>();
			results = new ArrayList<int[]>();
			
	}
	
	public void writeOutput(){
		File file = new File(outputName);
		 
		if (!file.exists()) {
			try {
				file.createNewFile();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		FileWriter fw;
		try {
			fw = new FileWriter(file.getAbsoluteFile());
		 
		BufferedWriter bw = new BufferedWriter(fw);
		bw.write("Case #1:");
		for(int i = 0; i<strings.size(); i++){
			
				bw.write(strings.get(i)+" ");
				for(int j = 0 ; j<8; j++ ){
					bw.write(results.get(i)[j]+" ");
				}
				bw.write(results.get(i)[8]+"");
				bw.newLine();   
			
		}
		
		bw.close();
		
		}catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
