import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class First {

	private String filename;
	private String outputName;
	private int numberOfCases;
	private String[] strings;
	private String[] results;


	public First(String filename,String outputName){
		this.filename = filename;
		this.outputName = outputName;
	}

	public void start(){
		readFromFile();

		computeResults();

		writeOutput();

	}



	int[] occurences = new int[10];
	private void computeResults() {

		for(int i = 0; i<numberOfCases;i++){
			String s = strings[i];
			
			System.out.println(s);
			Arrays.fill(occurences, 0);
			for(int j = 0 ; j<s.length();j++){
				char c = s.charAt(j);
				if(c=='Z')
					occurences[0]++;
				if(c=='W')
					occurences[1]++;
				if(c=='G')
					occurences[2]++;
				if(c=='H')
					occurences[3]++;
				if(c=='X')
					occurences[4]++;
				if(c=='U')
					occurences[5]++;
				if(c=='F')
					occurences[6]++;
				if(c=='O')
					occurences[7]++;
				if(c=='V')
					occurences[8]++;
				if(c=='I')
					occurences[9]++;
			}
			
			int[] digits = new int[10];
			digits[0] = extractDigit('Z',occurences);
			digits[2] = extractDigit('W',occurences);
			digits[8] = extractDigit('G',occurences);
			digits[3] = extractDigit('H',occurences);
			digits[6] = extractDigit('X',occurences);
			digits[4] = extractDigit('U',occurences);
			digits[5] = extractDigit('F',occurences);
			digits[1] = extractDigit('O',occurences);
			digits[7] = extractDigit('V',occurences);
			digits[9] = extractDigit('I',occurences);
			
			results[i] = createString(digits);
			System.out.println(results[i]);
		}
		
		


	}

	private String createString(int[] digits) {
		StringBuilder sb = new StringBuilder();
		
		for(int i = 0 ; i<digits.length;i++){
			for(int j = 0; j<digits[i];j++){
				sb.append(i);
			}
			
		}
		
			
		return sb.toString();
	}

	private int extractDigit(char c, int[] occurences) {
		if(c=='Z'){
			int z = occurences[0];
			occurences[7] = occurences[7]-occurences[0];
			return z;
		}else if(c=='W'){
			int w = occurences[1];
			occurences[7] = occurences[7]-occurences[1];
			return w;			
		}else if(c=='G'){
			int g = occurences[2];
			occurences[9] = occurences[9]-occurences[2];
			occurences[3] = occurences[3]-occurences[2];
			return g;		
		}else if(c=='H'){
			int h = occurences[3];			
			return h;		
		}else if(c=='X'){
			int x = occurences[4];	
			occurences[9] = occurences[9]-occurences[4];
			return x;		
		}else if(c=='U'){
			int u = occurences[5];
			occurences[6] = occurences[6]-occurences[5];
			occurences[7] = occurences[7]-occurences[5];
			return u;		
		}else if(c=='F'){
			int u = occurences[6];
			occurences[9] = occurences[9]-occurences[6];
			occurences[8] = occurences[8]-occurences[6];
			return u;		
		}else if(c=='O'){
			int u = occurences[7];			
			return u;		
		}else if(c=='V'){
			int u = occurences[8];	
			
			return u;		
		}else{
			return occurences[9];
		}
		
	}

	public void readFromFile(){
		numberOfCases=0;
		Scanner scanner;
		try {
			scanner = new Scanner(new File(filename));

			numberOfCases=scanner.nextInt();
			strings = new String[numberOfCases];
			results = new String[numberOfCases];

			for(int i=0;i<numberOfCases;i++){
				String s=scanner.next();
				strings[i] = s;				
			}

			scanner.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void writeOutput(){
		File file = new File(outputName);

		if (!file.exists()) {
			try {
				file.createNewFile();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		FileWriter fw;
		try {
			fw = new FileWriter(file.getAbsoluteFile());

			BufferedWriter bw = new BufferedWriter(fw);
			for(int i = 0; i<results.length-1; i++){

				bw.write("Case #"+(i+1)+": "+(results[i]));
				bw.newLine();   

			}
			
			bw.write("Case #"+(results.length)+": "+(results[results.length-1]));

			bw.close();

		}catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
