import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;
import java.util.Stack;

public class First {

	private String filename;
	private String outputName;
	private int numberOfCases;
	private List<int[]> parties;
	private List<String[]> results;


	public First(String filename,String outputName){
		this.filename = filename;
		this.outputName = outputName;
		parties = new ArrayList<int[]>();
		results = new ArrayList<String[]>();
	}

	public void start(){
		readFromFile();

		computeResults();

		writeOutput();

	}



	
	private void computeResults() {

		for(int i = 0 ;i< numberOfCases ; i++){
			List<String> path = new ArrayList<String>();
			int [] members = parties.get(i);
			int[] temp = new int[members.length];
			Arrays.fill(temp, 0);
			poss.clear();
			createSubsets(temp,0,0); 			
			State root = new State(members);			
			findSol(root,path);	
			results.add(lastP.toArray(new String[lastP.size()]));
			for(int j = 0 ; j<lastP.size();j++){
				System.out.print(lastP.get(j));
			}
			System.out.println();
			lastP.clear();
			
			found = false;
		}


	}
	List<String> lastP = new ArrayList<String>();
	boolean found = false;
	private void findSol(State root,List<String> path){
		if(found){
			
		}else if(root.checkLeaf()){
			for(int i = 0 ; i<path.size();i++){
				lastP.add(path.get(i));
				System.out.println(path.get(i));
			}
			found = true;
		}else{
			for(int j = 0 ; j< poss.size();j++){
				State newS = new State(root.members,poss.get(j));
				
				if(newS.checkValidity()){
					List<String> temp = new ArrayList<String>(path);
					temp.add(trans(poss.get(j)));					
					findSol(newS,temp);
				}
					
			}
			
			
		}
	}
	

	private String trans(int[] is) {
		StringBuilder sb = new StringBuilder();
		for(int i = 0 ; i<is.length;i++){
			if(is[i]==2){
				
				char c =  (char) ('A'+i);
				sb.append(c);
				sb.append(c);
			}
			
			if(is[i]==1){
				char c =  (char) ('A'+i);
				sb.append(c);
			}
		}
		return sb.toString();
		
	}


	List<int[]> poss = new ArrayList<int[]>();
	public void createSubsets(int[] root,int index,int sum) {
		
		if(index==root.length){
			if(sum==2 || sum ==1 )
				poss.add(root);
		}else{
			
			createSubsets(root,index+1,sum);
			if(sum<2){
				int[] temp = root.clone();
				temp[index] = 1;
				createSubsets(temp,index+1,sum+1);
			}
			
			if(sum == 0){
				int[] temp = root.clone();
				temp[index] = 2;
				createSubsets(temp,index+1,sum+2);
			}
			
			
		}
		
	}

	public void readFromFile(){
		numberOfCases=0;
		Scanner scanner;
		try {
			scanner = new Scanner(new File(filename));

			numberOfCases=scanner.nextInt();
			
			for(int i=0;i<numberOfCases;i++){
				int partyAmount = scanner.nextInt();
				int[] numbers = new int[partyAmount];
				for(int j = 0 ; j<numbers.length; j++){
					numbers[j] = scanner.nextInt();
					
				}
				parties.add(numbers);
			}

			scanner.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void writeOutput(){
		File file = new File(outputName);

		if (!file.exists()) {
			try {
				file.createNewFile();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		FileWriter fw;
		try {
			fw = new FileWriter(file.getAbsoluteFile());

			BufferedWriter bw = new BufferedWriter(fw);
			for(int i = 0; i<results.size(); i++){

				bw.write("Case #"+(i+1)+":");
				for(int j = 0 ; j<results.get(i).length; j++){
					bw.write(" "+results.get(i)[j]);
				}
				bw.newLine();   

			}
			
			
			bw.close();

		}catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
class State{
	
	int[] members;
	int totalMembers;
	
	public State(int[] members){
		this.members =members;
		
		totalMembers = sum();
	}
	
	public State(int[] members2,int[] diff){
		
		
		this.members = members2.clone();
		for(int i = 0 ; i<members.length;i++){
			members[i]-=diff[i];
		}
		totalMembers = sum();
	}
	

	public int sum(){
		int sum = 0;
		for(int i  =0 ; i<members.length;i++){
			sum += members[i];
		}
		
		return sum;
	}
	
	public boolean checkValidity(){
		for(int i = 0 ; i< members.length; i++){
			if(members[i]>(totalMembers/2))
				return false;
			if(members[i]<0)
				return false;
		}
		
		
		return true;
	}
	
	public boolean checkLeaf(){
		for(int i = 0 ; i<members.length;i++){
			if(members[i]>0)
				return false;
		}
		return true;
	}

	
}
