import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;


public class Dijkstra {

	/**
	 * @param args
	 */
	
	public static String quaternionMultiplication(String x, String y) {
		String[][] multiplicativeStructure = {
				{"1","i","j","k"},
				{"i","-1","k","-j"},
				{"j","-k","-1","i"},
				{"k","j","-i","-1"}				
		};
		
		String product = "";
		int a, b;
		Boolean negativeFlag = false;
		
		if (x != "") {
			a = b = 0;
			if(x.charAt(0) == '-') {
				negativeFlag = true;
				x = x.substring(1);
			} else
				negativeFlag = false;
			
			switch(x) {
			case "1" : {
				a = 0;
				break;
			}
			case "i" : {
				a = 1;
				break;
			}
			case "j" : {
				a = 2;
				break;
			}
			case "k" : {
				a = 3;
				break;
			}
			}
			
			switch(y) {
			case "1" : {
				b = 0;
				break;
			}
			case "i" : {
				b = 1;
				break;
			}
			case "j" : {
				b = 2;
				break;
			}
			case "k" : {
				b = 3;
				break;
			}
			}

			product = multiplicativeStructure[a][b];
			
			if(negativeFlag) {
				if(product.charAt(0) == '-') {
					product = product.substring(1);
				} else {
					product = "-" + product;
				}
			}
		}

		
		return product;
	}
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		int T = 0;

		String currentCase = null;

		String currentOutput = null;
		
		
		
		int L,X, flag;
		String baseString;
		String finalString;
		String quaternionProduct;
		String multiplyBy;
		
		String inputFilename = "C-small-attempt0.in";
		String outputFilename = "C-small-attempt0.out";
		String newline = System.getProperty("line.separator");
		
		BufferedWriter out = null;
		try {
			out = new BufferedWriter(new FileWriter(outputFilename));
		} catch (IOException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}
		
		FileInputStream fStream = null;
		try {
			fStream = new FileInputStream(inputFilename);
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		DataInputStream in = new DataInputStream(fStream);
		BufferedReader br = new BufferedReader(new InputStreamReader(in));
		
		
		try {
			T = Integer.parseInt(br.readLine());
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		for(int i=0;i<T;i++) {
			try {
				currentCase = br.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			L = Integer.parseInt(currentCase.substring(0,currentCase.indexOf(' ')));
			X = Integer.parseInt(currentCase.substring(currentCase.indexOf(' ')+1));
			multiplyBy = baseString = finalString = "";
			
			try {
				baseString = br.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			finalString = baseString;
			
			for(int j=1;j<X;j++)
				finalString = finalString.concat(baseString);

			flag = 0;
			quaternionProduct = "";
			while(finalString.length() > 0) {
							
				if (quaternionProduct == "") {
					quaternionProduct = finalString.charAt(0) + "";
					if(finalString.length() > 1)
						finalString = finalString.substring(1);
					else
						finalString = "";
				}
				
				if((quaternionProduct.equals("i")) && (flag == 0)) {
					flag = 1;
					quaternionProduct = "";
					continue;
				} else if((quaternionProduct.equals("j")) && (flag == 1)) {
					flag = 2;
					quaternionProduct = "";
					continue;
				} else if((quaternionProduct.equals("k")) && (flag == 2)) {
					flag = 3;
					quaternionProduct = "";
					continue;
				}
				
				if((finalString.length() > 1)) {
					multiplyBy = finalString.substring(0, 1);
					finalString = finalString.substring(1);
				} else {
					multiplyBy = finalString.substring(0);
					finalString = "";
				}
				
				quaternionProduct = quaternionMultiplication(quaternionProduct, multiplyBy);
			}
			
			if((quaternionProduct.equals("i")) && (flag == 0)) {
				flag = 1;		
			} else if((quaternionProduct.equals("j")) && (flag == 1)) {
				flag = 2;
			} else if((quaternionProduct.equals("k")) && (flag == 2)) {
				flag = 3;
			}
			
			if(flag == 3)
				currentOutput = "YES";
			else
				currentOutput = "NO";
			
			try {
				out.write("Case #"+(i+1)+": "+currentOutput+ newline);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		try {
			out.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	

	}

}
