import java.util.*;
import java.util.Map.Entry;
import java.util.logging.LoggingMXBean;

import javax.lang.model.type.IntersectionType;
import javax.print.attribute.ResolutionSyntax;
import javax.swing.event.AncestorEvent;
import javax.xml.bind.ValidationEvent;
import javax.xml.parsers.DocumentBuilder;

import java.math.*;
import java.awt.BufferCapabilities.FlipContents;
import java.io.*;

public class Main {
	public static void main(String[] args) throws FileNotFoundException {
		//InputReader in = new InputReader(System.in);
		//PrintWriter out = new PrintWriter(System.out);

		InputReader in = new InputReader(new File("A-large.in"));
		PrintWriter out = new PrintWriter(new File("A-large.out"));
		// Scanner in=new Scanner(System.in);

		int pi = in.nextInt();
		for (int qi = 1; qi <= pi; qi++) {
			int n = in.nextInt();
			int m = in.nextInt();

			List<Node> list = new ArrayList<Node>();
			for (int i = 0; i < n; i++) {
				int r = in.nextInt();
				int h = in.nextInt();
				Node node = new Node(r, h);
				list.add(node);
			}
			Collections.sort(list);

			double[][] d = new double[n][m + 1];
			for (int i = 0; i < n; i++) {
				Node node = list.get(i);
				if (i == 0) {
					d[i][0] = 0;
					d[i][1] = node.getTotalArea();
				} else {
					d[i][0] = 0;
					d[i][1] = Math.max(d[i - 1][1], node.getTotalArea());
					for (int j = 2; j <= m; j++) {
						d[i][j] = Math.max(d[i - 1][j], d[i - 1][j - 1] + node.getHeightArea());
					}
				}
			}
			out.printf("Case #%d: %.9f\n", qi, d[n - 1][m]);
		}

		out.close();
	}

	static class Node implements Comparable<Node> {
		int r;
		int h;

		public Node(int r, int h) {
			this.r = r;
			this.h = h;
		}

		@Override
		public int compareTo(Node o) {
			if (r < o.r) {
				return 1;
			} else if (r > o.r) {
				return -1;
			} else {
				return 0;
			}
		}

		public double getTotalArea() {
			return Math.PI * r * r + 2 * Math.PI * r * h;
		}

		public double getHeightArea() {
			return 2 * Math.PI * r * h;
		}
	}

	static class InputReader {
		BufferedReader br;
		StringTokenizer st;

		public InputReader(File f) {
			try {
				br = new BufferedReader(new FileReader(f));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		public InputReader(InputStream in) {
			br = new BufferedReader(new InputStreamReader(in));
		}

		public String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		public boolean hasNext() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return false;
				st = new StringTokenizer(s);
			}
			return true;
		}

		public int nextInt() {
			return Integer.parseInt(next());
		}

		public long nextLong() {
			return Long.parseLong(next());
		}

		public double nextDouble() {
			return Double.parseDouble(next());
		}
	}
}