import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;


public class MineSweeperGCode {

	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new FileReader("C-small-attempt8.in"));
		PrintWriter out = new PrintWriter("smallOutputC8.out");
		int N = Integer.parseInt(in.readLine());
		int i=0;
		while(i++ < N)
		{
			String [] line = in.readLine().split(" ");
			int R = Integer.parseInt(line[0]);
			int C = Integer.parseInt(line[1]);
			int M = Integer.parseInt(line[2]);
			out.println("Case #"+i+":");
	
			int diff = R*C-M;
			boolean [][] bitMatrix = new boolean[R][C];
			if(M==0) printMat(bitMatrix,out);
			else if(diff == 1){
				oneEmpty(R,C,bitMatrix);
				printMat(bitMatrix,out);
			}	
			else if(R==1 || C==1){
				 printRowCol(R,C,M,bitMatrix);
				 printMat(bitMatrix,out);
			}
			else if(diff < 4) {
				out.println("Impossible");
			}	
			
			else if(MineSweeperGCode.fillRows(0, 0, M, bitMatrix))
				printMat(bitMatrix,out);
			else out.println("Impossible");
			
		}
		in.close();
		out.close();
	}

	public static void printMat(boolean [][] bitMatrix, PrintWriter out){
		for (int j = 0; j < bitMatrix.length; j++) {
			for (int j2 = 0; j2 < bitMatrix[0].length; j2++) {
				if(j==bitMatrix.length-1 && j2==bitMatrix[0].length-1) out.print("c");
				else if(bitMatrix[j][j2]==true) out.print("*");				 
				else out.print(".");
			}
			out.println();
		}
	}
	
	public static boolean fillRows(int R, int C, int M, boolean [][] bitMatrix){
		
		if(bitMatrix[0].length-C==2){
			if(M%2==0){
				//solve --always a solution
				doubleCols(R,M,bitMatrix);
				return true;
			}
			else return false;
		}
		else if(bitMatrix.length-R==2){
			if(M%2==0){
				//solve --always a solution
				doubleRows(C,M,bitMatrix);
				return true;
			}
			else return false;
		}
		
		int rowstofill = M/(bitMatrix[0].length-C);
		int newR = (rowstofill==0)?R:Math.min(R+rowstofill, bitMatrix.length-3);
		int newM = M - (newR-R)*(bitMatrix[0].length-C);
		if(newM!=M) {
			for (int j = R; j < newR; j++) {
				for (int j2 = C; j2 < bitMatrix[0].length; j2++) {
					bitMatrix[j][j2] = true; //true means mines
				}
			}
		}
		if(newM == bitMatrix[0].length-C || newM <= bitMatrix[0].length-C-2)
		{
			for (int i = C; i < C+newM; i++) {
				bitMatrix[newR][i]=true;
			}
			return true;
		}
		else if(newM == bitMatrix[0].length-C-1){
			if(bitMatrix.length-newR > 3){
				for (int i = C; i < C+newM-1; i++) {
					bitMatrix[newR][i]=true;
				}
				bitMatrix[newR+1][C]=true;
				return true;
			}
			return false;
		}
		else if(bitMatrix.length-newR > 3) 
			return MineSweeperGCode.fillCols(newR, C, newM, bitMatrix);
		else if(bitMatrix.length-newR == 3)
		{
			for (int i = C; i < bitMatrix[0].length; i++) bitMatrix[newR][i]=true;
			newM -= (bitMatrix[0].length-C);
			return MineSweeperGCode.fillCols(newR+1, C, newM, bitMatrix);
		}
		return false;
	}
	
	public static boolean fillCols(int R, int C, int M,boolean [][] bitMatrix) {
		
		if(bitMatrix[0].length-C==2){
			if(M%2==0){
				//solve --always a solution
				doubleCols(R,M,bitMatrix);
				return true;
			}
			else return false;
		}
		else if(bitMatrix.length-R==2){
			if(M%2==0){
				//solve --always a solution
				doubleRows(C,M,bitMatrix);
				return true;
			}
			else return false;
		}
		
		int colstofill = M/(bitMatrix.length-R);
		int newC = (colstofill==0)?C:Math.min(C+colstofill, bitMatrix[0].length-3);
		int newM = M - (newC-C)*(bitMatrix.length-R);
		//if(newM==M && newC==C) return false;
		for (int j = R; j < bitMatrix.length; j++) {
			for (int j2 = C; j2 < newC; j2++) {
				bitMatrix[j][j2] = true; //true means mines
			}
		}
		
		if(newM == bitMatrix.length-R || newM <= bitMatrix.length-R-2)
		{
			for (int i = R; i < R+newM; i++) {
				bitMatrix[i][newC]=true;
			}
			return true;
		}
		
		else if(newM == bitMatrix.length-R-1){
			if(bitMatrix[0].length-newC > 3){
				for (int i = R; i < R+newM-1; i++) {
					bitMatrix[i][newC]=true;
				}
				bitMatrix[R][newC+1]=true;
				return true;
			}
			return false;
		}
		else if(bitMatrix[0].length-newC > 3) 
			return MineSweeperGCode.fillRows(R, newC, newM, bitMatrix);
		else if(bitMatrix[0].length-newC == 3)
		{
			for (int i = R; i < bitMatrix.length; i++) bitMatrix[i][newC]=true;
			newM -= (bitMatrix.length-R);
			return MineSweeperGCode.fillRows(R, newC+1, newM, bitMatrix);
		}
		return false;	
	
	}
		
	public static void doubleRows(int C,int M,boolean [][] bitMatrix) {
		//Assume the last element is click c
		int n = M/2;
		int i = C;
		for (; i < n; i++) {
			bitMatrix[bitMatrix.length-2][i] = true;
		}
		i = C;
		for (; i < n; i++) {
			bitMatrix[bitMatrix.length-1][i] = true;
		}
	}
	
	public static void doubleCols(int R,int M,boolean [][] bitMatrix) {
		//Assume the last element is click c
		int n = M/2;
		int i = R;
		for (; i < n; i++) {
			bitMatrix[i][bitMatrix[0].length-2] = true;
		}
		i = R;
		for (; i < n; i++) {
			bitMatrix[i][bitMatrix[0].length-1] = true;
		}
	}

	public static void oneEmpty(int R, int C, boolean [][] bitMatrix) { 
		for (int j = 0; j < bitMatrix.length; j++){
			for (int i = 0; i < bitMatrix[0].length; i++) {
				bitMatrix[j][i] = true;
			}
		}
	}
	
	public static void printRowCol(int R, int C, int M, boolean [][] bitMatrix) { 
		for (int j = 0; j < R; j++){
			for (int i = 0; i < C; i++) {
				if(M==0) return;
				bitMatrix[j][i] = true;
				M--;
				
			}
		}		
	}

}
