import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;


public class DeceitfulWar {

	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new FileReader("D-small-attempt0.in"));
		PrintWriter out = new PrintWriter("smallOutputD.out");
		int T = Integer.parseInt(in.readLine());
		int i=0;
		while(i++ < T)
		{
			int N = Integer.parseInt(in.readLine());
			String [] line1 = in.readLine().split(" ");
			String [] line2 = in.readLine().split(" ");
			double [] naomi = new double[N];
			double [] ken = new double[N];
			for (int j = 0; j < N; j++) {
				naomi[j] = Double.parseDouble(line1[j]);
				ken[j] = Double.parseDouble(line2[j]);
			}
			Arrays.sort(naomi);
			Arrays.sort(ken);
			int dwar = solveDWar(naomi,ken);
			int war = solveWar(naomi,ken);
			out.println("Case #"+i+": "+dwar+" "+war);			
		}
		in.close();
		out.close();
	}
	
	public static int solveWar(double [] n, double [] k){
		//n gives the highest and k, if has, selects next higher or the lowest
		int l = 0;
		int ncount=0;
		for (int i = n.length-1; i >= 0; i--) {
			double chooseN = n[i];
			if(chooseN > k[k.length-1]){//select the lowest
				//System.out.println("--> "+chooseN+" "+l+" "+k[l]);
				ncount++;
			}
			else {
				int ind = search(k,l,k.length-1,chooseN);
				//System.out.println(chooseN+" "+ind+" "+k[ind]);
				while(ind >0) k[ind--] = k[ind];
			}
			l++;
		}
		return ncount;
	}
	
	public static int solveDWar(double [] n, double [] k){
		int ncount=0;
		//int j = k.length-1;
		int l=0;
		for (int i = 0; i < n.length; i++ ) {
			double chooseN = n[i];
			if(chooseN < k[l]){ //deception must be careful.. choose a number below the greatest
				//j--;
			}
			else {ncount++;l++;}
			
		}
		return ncount;
	}
	
	public static int search(double [] A, int l, int h, double target)
	 {
		 if(l<=h)
		 {
			 int mid = (l+h)/2;
			 if(Math.abs(A[mid] - target) <= 0.0000000001) return mid;
			 else if(A[mid]> target) {
				 if(mid==l) return l;
				 else if(mid>l && A[mid-1]<target) return mid;
				 return search(A,l,mid-1,target);
			 }
			 else {
				 if(mid==h) return h+1;
				 else if(mid<h && target<A[mid+1]) return mid+1;
				 return search(A,mid+1,h,target);
			 }
		 }
		 return l;
	 }
}
