/**
 * Created by Dilraj on 4/8/16.
 */
import java.lang.reflect.Array;
import java.util.*;
import java.io.*;

public class Main {

    public static int built = 0;
    public static int[] values = new int[9];

    public static void main(String[] args) throws FileNotFoundException {
        File inputFile = new File("C-small-attempt0.in.txt");
        Scanner input = new Scanner(inputFile);
        int num = Integer.parseInt(input.nextLine());
        PrintStream output = new PrintStream("outputSmall.txt");

        for (int i = 0; i < num; i++){
            output.println("Case #" + (i+1) + ": ");
            String[] segments = input.nextLine().split("\\s+");
            buildBinary(Integer.parseInt(segments[0]), Integer.parseInt(segments[1]), output);
        }
    }

    public static void buildBinary(int N, int J, PrintStream output){
        buildBinary(N, J, "1", output);
    }

    public static void buildBinary(int N, int J, String binary, PrintStream output) {
        if (built != J) {
            if (binary.length() != N-1) {
                buildBinary(N, J, binary + "0", output);
                buildBinary(N, J, binary + "1", output);
            }
            else {
                boolean isJamCoin = buildNumbers(binary + "1");
                if(isJamCoin){
                    built++;
                    int[] divisors = findDivisibles(binary + "1");
                    output.print(binary + "1" + " ");
                    for (int i = 0; i < divisors.length-1; i++){
                        output.print(divisors[i] + " ");
                    }
                    output.println(divisors[8]);
                }
                System.out.println(built + " | " + binary + " | " + Arrays.toString(values));
                if(built == J){
                    System.exit(0);
                }
            }
        }
    }

    public static int[] findDivisibles(String binary){
        int[] divisors = new int[9];
        for (int i = 0; i < 9; i++){
            divisors[i] = getDivisor(values[i]);
        }
        return divisors;
    }

    public static int getDivisor(int value) {
        for (int i = 2; i < value; i++) {
            if (value % i == 0) {
                return i;
            }
        }
        return -1;
    }


    public static boolean buildNumbers(String binary){
        int x = 4;
        for (int i = 2; i < 11; i++){
            int value = buildNum(binary, i);
            boolean isPrime = checkPrime(value);
            if (isPrime){
                return false;
            }
            else {
                values[i - 2] = value;
            }
        }
        return true;
    }

    public static int buildNumber(String binary, int value, int base){
        int digit = Integer.parseInt(binary.substring(0, 1));
        value += digit*Math.pow(base, binary.length());
        if(binary.length() != 1) {
            buildNumber(binary.substring(1), value, base);
        }
        return value;
    }

    public static int buildNum(String s, int radix){
        int result = 0;
        boolean negative = false;
        int i = 0, len = s.length();
        int limit = -Integer.MAX_VALUE;
        int multmin;
        int digit;

        if (len > 0) {
            while (i < len) {
                digit = Character.digit(s.charAt(i++), radix);
                result *= radix;
                result -= digit;
            }
        }
        return negative ? result : -result;
    }

    public static boolean checkPrime(int value){
        if (value%2==0){
            return false;
        }
        for(int i=3;i*i<=value;i+=2) {
            if(value%i==0) {
                return false;
            }
        }
        return true;
    }
}
