import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;


public class tt {
    
    static int parseTime(String s) {
        String[] sp = s.split(":");
        return Integer.parseInt(sp[0]) * 60 + Integer.parseInt(sp[1]); 
    }
    
    static int[] parseTimePair(String s) {
        String[] sp = s.split(" ");
        return new int[] {parseTime(sp[0]), parseTime(sp[1])};
    }
    
    static List<int[]> getTrainList(BufferedReader br, int num) throws Exception {
        List<int[]> trains = new ArrayList<int[]>();
        for (int i = 0; i < num; i++) {
            trains.add(parseTimePair(br.readLine()));
        }
        return trains;
    }
    
    static int countDepartures(List<int[]> trains, int time) {
        int ret = 0;
        for (int[] train : trains) {
            if (train[0] == time) {
                ret++;
            }
        }
        return ret;
    }
    
    static int countArrivals(List<int[]> trains, int time) {
        int ret = 0;
        for (int[] train : trains) {
            if (train[1] == time) {
                ret++;
            }
        }
        return ret;
    }
    
    public static void main(String[] args) throws Exception {
        BufferedReader br = new BufferedReader(new FileReader("input.txt"));
        BufferedWriter bw = new BufferedWriter(new FileWriter("output.txt"));
        System.out.println("answer in " + new File("output.txt").getAbsolutePath());
        
        int nTests = Integer.parseInt(br.readLine());
        
        for (int test = 1; test <= nTests; test++) {
            int turn = Integer.parseInt(br.readLine());
            
            String numStr = br.readLine();
            int na = Integer.parseInt(numStr.split(" ")[0]);
            int nb = Integer.parseInt(numStr.split(" ")[1]);
            
            List<int[]> abTrains = getTrainList(br, na);
            List<int[]> baTrains = getTrainList(br, nb);

            /*
            for (int i = 0; i < abTrains.size(); i++) {
                System.out.println("ab train from " + abTrains.get(i)[0] 
                        + " to " + abTrains.get(i)[1]);
            }
            for (int i = 0; i < baTrains.size(); i++) {
                System.out.println("ba train from " + baTrains.get(i)[0] 
                        + " to " + baTrains.get(i)[1]);
            }
            */
            
            int ansA = 0;
            int ansB = 0;
            int numA = 0;
            int numB = 0;
            for (int t = 0; t < 24*60; t++) {
                // See if something has arrived to A
                int arA = countArrivals(baTrains, t - turn);
                numA += arA;
                // See if something has arrived to B
                int arB = countArrivals(abTrains, t - turn);
                numB += arB;
                if (arA > 0) {
                    //System.out.println(arA + " trains arrived to A at " + t);
                }
                if (arB > 0) {
                    //System.out.println(arB + " trains arrived to B at " + t);
                }
                
                // Send out trains from A
                int depA = countDepartures(abTrains, t);
                numA -= depA;
                if (numA < 0) {
                    //System.out.println("Lacking " + (-numA) + " trains in A at " + t);
                    ansA += -numA;
                    numA = 0;
                }

                // Send out trains from B
                int depB = countDepartures(baTrains, t);
                numB -= depB;
                if (numB < 0) {
                    //System.out.println("Lacking " + (-numB) + " trains in B at " + t);
                    ansB += -numB;
                    numB = 0;
                }
            }
            
            bw.write("Case #" + test + ": " + ansA + " " + ansB + "\n");
        }
        
        bw.close();
        
    }
}
