import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashMap;
import java.util.Map;




public class A {
    public static void main(String[] args) throws Exception {
        
        BufferedReader reader = new BufferedReader(new FileReader("input.txt"));
        BufferedWriter writer = new BufferedWriter(new FileWriter("output.txt"));
        
        
        
        int numcases = Integer.parseInt(reader.readLine());
        for (int testcase = 1; testcase <= numcases; testcase++) {
            int M, V;
            String[] sp = reader.readLine().split(" ");
            M = Integer.parseInt(sp[0]);
            V = Integer.parseInt(sp[1]);
            
            Node[] nodes = new Node[M];
            for (int i = 0; i < M; i++) {
                nodes[i] = new Node();
            }
            for (int i = 1; i <= M; i++) {
                String line = reader.readLine();
                nodes[i - 1].parseNode(line, i, M);
                if (nodes [i - 1].postype == 0) {
                    // internal
                    nodes[i - 1].leftChild = nodes[2*i-1];
                    nodes[i - 1].rightChild = nodes[2*i];
                }
            }
            
            Map<Node, Integer>[] cache = new Map[2];
            cache[0] = new HashMap<Node, Integer>();
            cache[1] = new HashMap<Node, Integer>();
            int ans = nodes[0].getNumSwitches(V, cache);
            String ansStr;
            if (ans == -1) {
                ansStr = "IMPOSSIBLE";
            } else {
                ansStr = ""+ans;
            }
            writer.write("Case #" + testcase + ": " + ansStr + "\n");
        }
        System.out.println("Answer in " + new File("output.txt").getAbsolutePath());
        
/*        
        writer.write("ASDFASDF\n");
        writer.write("1\n");
        writer.write("9999 0\n");
        for (int i = 0; i < ((9999-1)/2); i++) {
            writer.write("1 1\n");
        }
        for (int i = 0; i < ((9999+1)/2); i++) {
            writer.write("1\n");
        }
        */
        
        writer.close();
        
    } // end main
}


class Node {
    int postype; // 0 - internal, 1 - leaf
    
    boolean changeable;
    int optype; // for internal nodes: 1 AND, 0 OR
    
    int value; // for leaf nodes only
    
    Node leftChild;
    Node rightChild;
    
    int getNumSwitches(int value, Map<Node, Integer>[] cache) {
        
        Integer cached = cache[value].get(this);
        if (cached != null) {
            return cached;
        }
        
        int ret;
        if (postype == 1) {
            // leaf
            if (this.value == value) {
                ret = 0; // nothing to change
            } else {
                ret = -1; // impossible
            }
        } else {
            // internal
            ret = -1;
            for (int left = 0; left < 2; left++) {
                int priceleft = leftChild.getNumSwitches(left, cache);
                if (priceleft == -1)
                    continue;
                for (int right = 0; right < 2; right++) {
                    int priceright = rightChild.getNumSwitches(right, cache);
                    if (priceright == -1)
                        continue;
                    if (optype == 1) {
                        // AND
                        int v = left & right;
                        if (v == value) {
                            if (ret == -1 || priceleft + priceright < ret) {
                                ret = priceleft + priceright;
                            }
                        }
                        v = left | right;
                        if (v == value && this.changeable) {
                            if (ret == -1 || priceleft + priceright+1 < ret) {
                                ret = priceleft + priceright+1;
                            }
                        }
                        
                    } else {
                        // OR
                        int v = left | right;
                        if (v == value) {
                            if (ret == -1 || priceleft + priceright < ret) {
                                ret = priceleft + priceright;
                            }
                        }
                        v = left & right;
                        if (v == value && this.changeable) {
                            if (ret == -1 || priceleft + priceright+1 < ret) {
                                ret = priceleft + priceright+1;
                            }
                        }
                        
                    }
                }
            } // for left = 0
        }
        cache[value].put(this, ret);
        return ret;
    }
    
    void parseNode(String line, int linenum, int M) {
        // linenum = 1 .. M
        if (linenum <= (M-1)/2) {
            // internal
            
            if (line.length() != 3) {
                throw new IllegalArgumentException("bad line format " + linenum);
            }
            
            postype = 0;
            if (line.charAt(0) == '1') {
                // AND
                optype = 1;
            } else {
                optype = 0;
            }

            if (line.charAt(2) == '1') {
                // changeable
                changeable = true;
            } else {
                changeable = false;
            }
        } else {
            // leaf
            if (line.length() != 1) {
                throw new IllegalArgumentException("bad format '" + line + "' " + linenum);
            }
            
            postype = 1;
            value = line.charAt(0) - '0';
        }
    }
}