import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;


public class KS {
    public static void main(String[] args) throws Exception {
        BufferedReader reader = new BufferedReader(new FileReader("input.txt"));
        BufferedWriter writer = new BufferedWriter(new FileWriter("output.txt"));
        
        int numtests = Integer.parseInt(reader.readLine());
        for (int testnum = 1; testnum <= numtests; testnum++) {
            int H, W, R;
            String[] sp = reader.readLine().split(" ");
            H = Integer.parseInt(sp[0]);
            W = Integer.parseInt(sp[1]);
            
            int[][] isrock = new int[H][W];
            
            R = Integer.parseInt(sp[2]);
            for (int r = 0; r < R; r++) {
                int row,col;
                sp = reader.readLine().split(" ");
                row = Integer.parseInt(sp[0]);
                col = Integer.parseInt(sp[1]);
                
                row--;
                col--;
                isrock[row][col] = 1;
            }
            
            long[][] ans = new long[H][W];
            ans[H-1][W-1] = 1;
            int x,y;
            for (int rr = H-1; rr >= 0; rr--) {
                for (int cc = W-1; cc >= 0; cc--) {
                    if (isrock[rr][cc]==1)
                        continue;
                    
                    x = rr+1;
                    y = cc+2;
                    if (x < H && y < W && isrock[x][y]==0) {
                        ans[rr][cc] += ans[x][y];
                    }
                    
                    x = rr+2;
                    y = cc+1;
                    if (x < H && y < W && isrock[x][y]==0) {
                        ans[rr][cc] += ans[x][y];
                    }
                    
                    ans[rr][cc] %= 10007;
                }
            }
            
            writer.write("Case #" + testnum + ": " + ans[0][0] + "\n");
        }
        
        System.out.println(new File("output.txt").getAbsolutePath());
        writer.close();
    }
}
