import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;


public class uu {
    private static final String OUTFILE = "output.txt";
    
    public static void main(String[] args) throws Exception {
        BufferedReader reader =new BufferedReader(new FileReader("input.txt"));
        int nTests = Integer.parseInt(reader.readLine());
        
        System.out.println("Writing to file: " + new File(OUTFILE).getAbsolutePath());
        BufferedWriter writer = new BufferedWriter(new FileWriter(OUTFILE));
        
        for (int testNum = 1; testNum <= nTests; testNum++) {
            // Read the engines
            int numEngines = Integer.parseInt(reader.readLine());
            List<String> engines = new ArrayList<String>();
            for (int i = 0; i < numEngines; i++) {
                engines.add(reader.readLine());
            }

            // read the queries
            int numQueries = Integer.parseInt(reader.readLine());
            List<String> queries = new ArrayList<String>();
            for (int i = 0; i < numQueries; i++) {
                queries.add(reader.readLine());
            }
        
            int[][] num = new int[numEngines][numQueries + 1];
            for (int q = numQueries - 1; q >= 0; q--) {
                for (int eng = 0; eng < numEngines; eng++) {
                    if (engines.get(eng).equals(queries.get(q))) {
                        // Can't process here
                        num[eng][q] = 10000;
                        // See where we can switch
                        for (int anEng = 0; anEng < numEngines; anEng++) {
                            if (!engines.get(anEng).equals(queries.get(q))) {
                                num[eng][q] = Math.min(
                                        num[eng][q], 
                                        1 + num[anEng][q + 1]
                                        );
                            }
                        }
                    } else {
                        // Can process here
                        num[eng][q] = num[eng][q+1];
                    }
                }
            }
            
            int ans = 10000;
            for (int eng = 0; eng < numEngines; eng++) {
                ans = Math.min(ans, num[eng][0]);
            }
            
            String ansStr = "Case #" + testNum + ": " + ans;
            System.out.println(ansStr);
            
            writer.write(ansStr + "\n");
            
        }
        
        writer.close();
    }
}
