import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;


public class D {
    public static void main(String[] args) throws Exception {
        BufferedReader reader = new BufferedReader(new FileReader("input.txt"));
        BufferedWriter writer = new BufferedWriter(new FileWriter("output.txt"));
        
        int numtests = Integer.parseInt(reader.readLine());
        for (int curtest = 1; curtest <= numtests; curtest++) {
            int k = Integer.parseInt(reader.readLine());
            String S = reader.readLine();
            int[] p = new int[k];
            for (int i = 0; i < k; i++) {
                p[i] = i;
            }
            
            int ans = 1000000;
            while (true) {
                
                char[] sp = new char[S.length()];
                for (int i = 0; i < sp.length; i++) {
                    int d = (i/k)*k;
                    sp[i] = S.charAt(d + p[i%k]);
                }
                
                int cur = 1;
                for (int i = 1; i < sp.length; i++) {
                    if (sp[i-1]!=sp[i]) {
                        cur++;
                    }
                }
                
                ans = Math.min(ans, cur);
                
                if (!next(p, k))
                    break;
            }
            writer.write("Case #" + curtest + ": " + ans + "\n");
        }
        
        writer.close();
        
        System.out.println(new File("output.txt").getAbsolutePath());
    } // end main
    
    private static boolean next(int[] p, int k) {
        for (int i = k-1; i >= 0; i--) {
            int gr = -1;
            for (int j = i+1; j < k; j++) {
                if (p[j] > p[i]) {
                    if (gr == -1 || p[j] < p[gr]) {
                        gr = j;
                    }
                }
            }
            if (gr >= 0) {
                swap(p, i, gr);
                for (int j = i+1; j < k; j++) {
                    for (int jj = j+1; jj < k; jj++) {
                        if (p[jj] < p[j]) {
                            swap(p, j, jj);
                        }
                    }
                }
                return true;
            }
        }
        return false;
    }
    
    private static void swap(int[] p, int i, int j) {
        int z = p[i];
        p[i] = p[j];
        p[j] = z;
    }
}
