import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.util.StringTokenizer;

/*
 * Helper fns for Google Code Jam problems
 */

public class IO {

	static StringTokenizer t;
	static BufferedReader r;
	static String line;
	
	static BufferedWriter w;
	
	
	static void init(InputStream i, OutputStream o){
		t = new StringTokenizer("");
		r = new BufferedReader(new InputStreamReader(i));
		w = new BufferedWriter(new OutputStreamWriter(o));
	}
	
	//all operate per line
	static int[] readIntArray(int size){
		readLine();
		int[] a = new int[size];
		
		for(int i = 0;i < size;i++){
			a[i] = Integer.parseInt(t.nextToken()); //if size was wrong, would throw
		}
		return a;
	}
	
	static double[] readDoubleArray(int size){
		readLine();
		double[] a = new double[size];
		
		for(int i = 0;i < size;i++){
			a[i] = Double.parseDouble(t.nextToken()); //if size was wrong, would throw
		}
		return a;
	}
	
	static int nextInt(){
		readLine();
		return Integer.parseInt(t.nextToken());
	}
	
	static double nextDouble(){
		readLine();
		return Double.parseDouble(t.nextToken());
	}
	
	private static void readLine(){
		try {
			line = r.readLine();
		} catch (IOException e) {
			e.printStackTrace();
		}
		if(line == null)
			throw new RuntimeException("Shouldn't have called me");
		if(t.hasMoreElements())
			throw new RuntimeException("Shouldn't have called before emptying the tokenizer because you missed some entries");
		t = new StringTokenizer(line);
	}
	static String readString(){
		try {
			return r.readLine();
		} catch (IOException e) {
			e.printStackTrace();
			return "";
		}
	}

	
	private static String arrToStr(double[] a){
		StringBuilder str = new StringBuilder();
		for(int i = 0; i < a.length; i++){
			str.append(a[i] + " "); //need the strbuilder to remove the last " "
		}
		return str.substring(0, str.length() - 1);
	}
	
	private static String arrToStr(int[] a){
		StringBuilder str = new StringBuilder();
		for(int i = 0; i < a.length; i++){
			str.append(a[i] + " "); //need the strbuilder to remove the last " "
		}
		return str.substring(0, str.length() - 1);
	}
	
	static void writeArray(int[] a){
		try {
			w.append(arrToStr(a));
			w.newLine();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	static void writeArray(double[] a){
		try {
			w.append(arrToStr(a));
			w.newLine();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	static void writeString(String s){
		try {
			w.append(s);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	static void writeStringln(String s){
		writeString(s);
		writeString("\n");
	}
	
	static void finish(){
		try {
			w.flush();
			w.close();
			r.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}

