import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.PriorityQueue;
import java.util.Queue;


public class MinesweeperMaster {
	
	static final String filename = "C-small-attempt4";
	
	static final int VARS = 3;
	
	static InputStream in;
	static OutputStream out;
	
	public static void main(String[] args){
		try {
			in = new FileInputStream(filename + ".in");
			out =  new FileOutputStream(filename + ".out");
		} catch (IOException e) {
			e.printStackTrace();
		}
//		in = System.in;
//		out = System.out;
//		
		
		IO.init(in, out);
		int cases = IO.nextInt();
		for(int i = 1; i <= cases; i++){
			//read vars
			int[] vars = IO.readIntArray(VARS);
			
			//read data
			
			//solve
			char[][] ans = solve(vars[0], vars[1], vars[2]);
			IO.writeStringln("Case #" + i + ":");
			if(ans == null){
				IO.writeStringln("Impossible");
			} else {
				for (int j = 0; j < ans.length; j++) {
					StringBuilder sb = new StringBuilder();
					for (int k = 0; k < ans[0].length; k++) {
						sb.append(ans[j][k]);
					}
					IO.writeStringln(sb.toString());
				}
			}
			//
		}
		IO.finish();

	}
	
	private static int weight(char[][] g, int i, int j) {
		int weight = 0;
		weight += w(g, i + 1, j + 1);
		weight += w(g, i + 1, j);
		weight += w(g, i + 1, j - 1);
		
		weight += w(g, i, j - 1);
		weight += w(g, i, j + 1);
		
		weight += w(g, i - 1, j - 1);
		weight += w(g, i - 1, j);
		weight += w(g, i - 1, j + 1);
		
		return weight;
	}
	
	private static int w(char[][] g, int i, int j) {
		if (i < 0 || i >= g.length || j < 0 || j >= g[i].length || g[i][j] == '*' || g[i][j] == '.')
			return 0;
		return 1;
	}

	private static boolean visited(char[][] g, int i, int j) {
		if (i < 0 || i >= g.length || j < 0 || j >= g[i].length || g[i][j] == '*' || g[i][j] == '.')
			return true;
		return false;
	}
	
	private static ArrayList<Cell> setNb(char[][] g, int i, int j) {
		ArrayList<Cell> nb = new ArrayList<Cell>();
		
		set(nb, g, i + 1, j + 1);
		set(nb, g, i + 1, j);
		set(nb, g, i + 1, j - 1);
		
		set(nb, g, i, j - 1);
		set(nb, g, i, j + 1);
		
		set(nb, g, i - 1, j - 1);
		set(nb, g, i - 1, j);
		set(nb, g, i - 1, j + 1);

		return nb;
	}
	
	private static void set(ArrayList<Cell> nb, char[][] g, int i, int j) {
		if(visited(g, i, j))
			return;

		
		nb.add(new Cell(i, j, 0));
		g[i][j] = '.';
	}

	private static char[][] solve(int r, int c, int mines) {
		if(mines >= r * c)
			return null;
		
		char[][] grid = new char[r][c];
		
//		if(mines == 0) {
//			for (int i = 0; i < grid.length; i++) {
//				for (int j = 0; j < grid[0].length; j++) {
//					grid[i][j] = '.';
//				}
//			}
//			return grid;
//		}
		
		if(mines + 1 == r * c) {
			for(int i = 0; i < grid.length; i++) {
				for (int j = 0; j < grid[0].length; j++) {
					grid[i][j] = '*';
				}
			}
			grid[0][0] = 'c';
			return grid;
		}
		
		
		for (int i = 0; i < grid.length; i++) {
			for (int j = 0; j < grid[0].length; j++) {
				grid[i][j] = '0';
			}
		}
		
		Queue<Cell> pq = new PriorityQueue<>();
		Queue<Cell> tpq;
		pq.add(new Cell(0, 0, 0));
		int tot = 0;
		while(!pq.isEmpty() && tot < mines) {
			Cell cell = pq.poll();
			grid[cell.i][cell.j] = '*';
			tot++;
			ArrayList<Cell> nbs = setNb(grid, cell.i, cell.j);
			
			tpq = new PriorityQueue<>();
			for(Cell cc: pq) {
				cc.updateWeight(grid);
				tpq.add(cc);
			}
			for(Cell n: nbs) {
				n.updateWeight(grid);
				tpq.add(n);
			}
			pq = tpq;
			
		}
		
		boolean found = false;
		for (int i = 0; i < grid.length; i++) {
			for (int j = 0; j < grid[0].length; j++) {
				if(grid[i][j] == '0'){
					if(!found){
						grid[i][j] = 'c';
						found = true;
					}
					else {
						grid[i][j] = '.';
					}
					
				}
			}
		}
		
//		for(char[] rr:grid) {
//			IO.writeStringln(Arrays.toString(rr));
//		}
		
		if(found)
			return grid;
		
		return null;
	}
	
	private static class Cell implements Comparable<Cell> {
		int i, j;
		int weight;
		Cell(int ii, int jj, int w) {
			i = ii;
			j = jj;
			weight = w;
		}
		public void updateWeight(char[][] grid) {
			weight = weight(grid, i, j);
		}
		
		@Override
		public int compareTo(Cell o) {
			return Integer.compare(this.weight, o.weight);
		}
	}
}
