import java.util.*;
import java.util.Map.*;

public class Treasure {

	static Map<Integer, Position> keys;
	static Map<Integer, Transition> chests;

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int T = sc.nextInt();
		for(int t=1; t<=T; t++) {
			System.out.printf("Case #%d: ", t);
			int K = sc.nextInt();
			int N = sc.nextInt();
			keys = new Hashtable<Integer, Position>(K);
			for(int k=0; k<K; k++) {
				int ind = sc.nextInt();
				if(!keys.containsKey(ind)) keys.put(ind, new Position(ind, 1));
					else keys.get(ind).cnt++;
			}
			
			chests = new TreeMap<Integer, Transition>();
			for(int n=0; n<N; n++) {
				Transition tr = new Transition(n);
				chests.put(n, tr);
				int Ti = sc.nextInt();
				if(!keys.containsKey(Ti)) keys.put(Ti, new Position(Ti));
				keys.get(Ti).out.add(tr);
				tr.in = keys.get(Ti);
				int Ki = sc.nextInt();
				for(; Ki>0; Ki--) {
					Ti = sc.nextInt();
					if(!keys.containsKey(Ti)) keys.put(Ti, new Position(Ti));
					tr.out.add(keys.get(Ti));
					keys.get(Ti).in.add(tr);
				}
			}
			System.err.println(keys);
			System.err.println(chests);

			// === Modelling ===

			Vector<Integer> decision = new Vector<Integer>();

//int loop = 5;
			mainLoop:
			while(true) {
				// 1. Say that a chest is _safe_ if it contains a key of the same type
				// that one that can open this chest.
				// We can open all the _safe_ chests without risk of loosing keys.
				for(Entry<Integer, Transition> e: chests.entrySet()) {
					Transition chest = e.getValue();
					Position key = chest.in;
					if(key.cnt <= 0) continue;
					boolean canOpen = false;
					if(key.out.size()>key.cnt) {
						Vector<Position> acc = new Vector<Position>(chest.out);
						Vector<Position> newAcc = new Vector<Position>();
						do {
							newAcc.clear();
							if(acc.contains(chest.in)) { canOpen = true; break; }	// The key will return here somewhen - use it without any doubt
							for(Position p: acc) {
								for(Transition tr: p.out) {
									for(Position p2: tr.out) {
										if(!acc.contains(p2)) newAcc.add(p2);
									}
								}
							}
							acc.addAll(newAcc);
						} while (newAcc.size()>0);
					} else canOpen = true;

					if(canOpen) {
						openChest(chest, decision);
						continue mainLoop;
					}
				}
				break;
			}
			if(chests.size()>0) System.out.println("IMPOSSIBLE");
				else {
					for(Integer d: decision) System.out.print(d+" ");
					System.out.println();
			}
		}

		
	}

	private static void openChest(Transition chest, Vector<Integer> decision) {
		Position key = chest.in;
		decision.add(chest.index+1);
		key.cnt--;
		key.out.remove(chest);
		for(Position o: chest.out) {
			o.cnt++;
			o.in.remove(chest);
		}
		chests.remove(chest.index);
		System.err.println("Open chest c"+chest.index);
		System.err.println(decision);
		System.err.println(keys);
		System.err.println(chests);
	}

	static class Position {
		int index;
		Vector<Transition> out = new Vector<Transition>();
		Vector<Transition> in = new Vector<Transition>();
		int cnt;
		public Position(int _index) {
			this(_index, 0);
		}
		public Position(int _index, int _cnt) {
			index = _index;
			cnt = _cnt;
		}
		public String toString() {
			String s = "<key index "+index+", m = "+cnt+", out: [";
			boolean first =  true;
			for(Transition t: out) {
				if(!first) s+= ", "; else first = false;
				s+= "c" + t.index;
			}
			s+= "], in: [";
			first =  true;
			for(Transition t: in) {
				if(!first) s+= ", "; else first = false;
				s+= "c" + t.index;
			}
			return s+"]>";
		}
	}

	static class Transition/* implements Comparable */{
		int index;
		Vector<Position> out = new Vector<Position>();
		Position in = null;
		public Transition(int _index) {
			index = _index;
		}
		public String toString() {
			String s = "<chest index "+index+", out: [";
			boolean first =  true;
			for(Position t: out) {
				if(!first) s+= ", "; else first = false;
				s+= "k" + t.index;
			}
			s+= "], in: k" + in.index;
			return s+"]>";
		}
		/*public int compareTo(Object t) {
			return ((Transition)t).index==index? 0 : (index<((Transition)t).index? -1 : 1);
		}*/
	}

}