import java.io.*;
import java.util.*;
import java.math.*;

public class C
{
  final static int[] DR={-1,0,1,0,-1,-1,+1,+1};    //diagonal moves at the end
  final static int[] DC={0,1,0,-1,-1,+1,+1,-1};

	public static void main(String[] args) throws Exception
	{
    int T;	
		RandomAccessFile in = new RandomAccessFile(args[0],"r");
		T=Integer.parseInt(in.readLine());
		

		for (int i=1; i<=T; i++)
		{
		  String line=in.readLine();
		  String[] temp=line.split("[ ]+");		  
		  int R=Integer.parseInt(temp[0]);
		  int C=Integer.parseInt(temp[1]);
		  int M=Integer.parseInt(temp[2]);

      System.out.println("Case #"+i+":");
      boolean found=solveSmall(R,C,M);
      if (!found) System.out.println("Impossible");
    }

		in.close();
	}
	

	public static boolean solveSmall(int R, int C, int M)
  {
    for (int i=0; i<(int)(Math.pow(C+1,R)); i++)
    {
      int[] a=new int[R];      
      int cur=i;
      int total=0;
      for (int k=0; k<R; k++)
      {
        a[k]=cur%(C+1);
        total+=a[k];
        cur/=(C+1);
      }
      
      if (total==M)
      {
        //print(a);
        char[][] mines=check(R,C,a);
        if (mines!=null)
        {
          print(mines);
          return true;
        }
      }
    }
    
    return false;
  }
  
  public static char[][] check(int R, int C, int[] a)
  {
    char[][] mines=new char[R][C];
    int[][] counts=new int[R][C];
    
    int numMines=0;
    
    for (int r=0; r<R; r++) Arrays.fill(mines[r],'.');
    
    for (int r=0; r<R; r++)
      for (int c=0; c<a[r]; c++)
      {
        mines[r][c]='*';
        counts[r][c]=9;
        numMines++;
      }
      
    //special case!!!
    if (R*C-numMines==1)
    {
loop2:    
      for (int r=0; r<R; r++)
        for (int c=0; c<C; c++)    
          if (mines[r][c]=='.')
          {
            mines[r][c]='c';
            break loop2;
          }
          
      return mines;
    }
      
    for (int r=0; r<R; r++)
      for (int c=0; c<C; c++)
      {
        if (mines[r][c]=='*') continue;
        
        for (int m=0; m<DR.length; m++)
        {
          int r2=r+DR[m];
          int c2=c+DC[m];
          if (r2<0 || r2>=R || c2<0 || c2>=C) continue;
          
          if (mines[r2][c2]=='*') counts[r][c]++;
        }
      }
          
  
    //every number must be adjacent to at least one 0
    for (int r=0; r<R; r++)
      for (int c=0; c<C; c++)
      {
        if (mines[r][c]=='*') continue;
        if (counts[r][c]==0) continue;
        
        boolean ok=false;
        for (int m=0; m<DR.length; m++)
        {
          int r2=r+DR[m];
          int c2=c+DC[m];
          if (r2<0 || r2>=R || c2<0 || c2>=C) continue;
          
          if (counts[r2][c2]==0) ok=true;
        }        
        
        if (!ok) return null;
      }
      
    //all passed, set c
    
loop:    
    for (int r=0; r<R; r++)
      for (int c=0; c<C; c++)    
        if (counts[r][c]==0)
        {
          mines[r][c]='c';
          break loop;
        }
    
    return mines;
    //print(mines);
    //print(counts);
  }
  
  public static void print(char[][] mines)
  {
    for (int r=0; r<mines.length; r++)
    {
      for (int c=0; c<mines[0].length; c++) System.out.print(mines[r][c]);
      System.out.println();
    }
    //System.out.println();    
  }
  
  public static void print(int[][] counts)
  {
    for (int r=0; r<counts.length; r++)
    {
      for (int c=0; c<counts[0].length; c++) System.out.print(counts[r][c]);
      System.out.println();
    }
    System.out.println();    
  }  
  
  public static void print(int[] a)
  {
    for (int i=0; i<a.length; i++) System.out.print(a[i]+" ");
    System.out.println();
  }
}