import java.io.*;
import java.util.*;
import java.math.*;

public class B
{  
	public static void main(String[] args) throws Exception
	{
    int T;	
		RandomAccessFile in = new RandomAccessFile(args[0],"r");
		T=Integer.parseInt(in.readLine());


		for (int i=1; i<=T; i++)
		{
		  String[] temp=in.readLine().split("[ ]+");		  		  		  
		  int N=Integer.parseInt(temp[0]);
		  double V=Double.parseDouble(temp[1]);
		  double X=Double.parseDouble(temp[2]);
		  
      double[] rates=new double[N];
      double[] temps=new double[N];      
      for (int k=0; k<N; k++)
      {
  		  temp=in.readLine().split("[ ]+");		          
        rates[k]=Double.parseDouble(temp[0]);
        temps[k]=Double.parseDouble(temp[1]);        
      }

      String ans=solve(V,X,rates,temps);
      System.out.println("Case #"+i+": "+ans);
    }

		in.close();
	}
	
	
  public static String solve(double V, double X, double[] rates, double[] temps)
  {
    int N=rates.length;   
    
    //System.out.println(V+" "+X);
    //for (int i=0; i<N; i++) System.out.println(i+" "+rates[i]+" "+temps[i]);
    
    if (N==1)
    {
      if (Math.abs(temps[0]-X)<1e-9) return ""+(V/rates[0]);
      else return "IMPOSSIBLE";
    }
    
    boolean anyLarger=false;
    for (int i=0; i<2; i++) if (temps[i]>X || Math.abs(temps[i]-X)<1e-9) anyLarger=true;
    if (!anyLarger) return "IMPOSSIBLE";    //all temps are smaller...
    
    if (Math.abs(temps[0]-X)<1e-9 && Math.abs(temps[1]-X)<1e-9) return ""+(V/(rates[0]+rates[1]));
    
    double attempt=Double.MAX_VALUE;
    if (Math.abs(temps[0]-X)<1e-9) attempt=Math.min(attempt,V/rates[0]);
    if (Math.abs(temps[1]-X)<1e-9) attempt=Math.min(attempt,V/rates[1]);
    if (attempt<Double.MAX_VALUE) return ""+attempt;    //we got exact match!
    
    
    double A=(rates[0]*temps[0]-rates[0]*temps[1]);
    double B=(rates[1]*temps[1]);
    if (Math.abs(A)<1e-9 || Math.abs(B)<1e-9) return "IMPOSSIBLE";    //division by 0
    //System.out.println(A+" "+B);    
    
    double t0=(V*X-V*temps[1])/A;
    double t1=(V*X-t0*rates[0]*temps[0])/B;
    
    if (t0<-1e-9 || t1<-1e-9)
    {
      //System.out.println(t0+" "+t1);
      return "IMPOSSIBLE";
    }
    
    
    return ""+Math.max(t0,t1);
  }
}