import java.io.*;
import java.util.*;
public class RLE
{
	public static void main(String[] args) throws Exception
	{
		RandomAccessFile in = new RandomAccessFile(args[0],"r");
		int N=Integer.parseInt(in.readLine());
		

		for (int i=1; i<=N; i++)
		{
			int k=Integer.parseInt(in.readLine());
			String S=in.readLine();			

			System.out.print("Case #"+i+": ");
			solve(k, S);
			System.out.println();
		}

	}


	public static void solve(int k, String S)
	{
		int[] a=new int[k];
		for (int i=0; i<k; i++) a[i]=i;

		int best=Integer.MAX_VALUE;
		//int div=S.length()/k;

		do
		{
			String b="";
			for (int i=0; i<S.length(); i+=k)
			{
				for (int m=0; m<k; m++)
				{
					b+=S.charAt(i+a[m]);
				}
			}

			int count=1;
			for (int i=1; i<b.length(); i++)
			{
				if (b.charAt(i)!=b.charAt(i-1)) count++;
			}

			if (count<best)
			{
				best=count;
				//System.out.println(b);
			}
		}
		while(nextPermutation(a));

		System.out.print(best);
	}

	//elements in a have to be sorted in ascending order
	//changes the elements to achieve the next permutation
	//returns false if there are no more permutations
	public static boolean nextPermutation(int[] a)
	{
		int N=a.length;
		int i=N-2;
		for (; i>=0; i--)
			if (a[i]<a[i+1])
				break;
		if (i<0) return false;
		
		for (int j=N-1; j>=i; j--)
		{
			if (a[j]>a[i])
			{
				int temp=a[i];
				a[i]=a[j];
				a[j]=temp;
				break;		
			}
		}
		for (int j=i+1; j<(N+i+1)/2; j++)		//reverse from a[i+1] to a[N-1]
		{
			int temp=a[j];
			a[j]=a[N+i-j];
			a[N+i-j]=temp;
		}
		return true;
	}
}
