package CJ2016_QUAL;

import java.math.BigInteger;

public class C {

	public static void main(String[] args) {
		new C().run();
	}
	
	public void run() {
		final int N = 32;
		final int J = 500;
		
		System.out.println("Case #1:");
		
		int[] init = new int[N];
		init[0] = 1; init[N-1] = 1;
		Jamcoin jamcoin = new Jamcoin(init);
		
		int[] divisors = new int[9]; //2 to 10
		int count = 0;
		
		while (count < J){
			if (getDivisors(jamcoin, divisors)) {
				System.out.print(jamcoin.toString());
				for (int i = 2; i <= 10; i++) {
					System.out.print(" " + divisors[i - 2]);
				}
				System.out.println();
				count++;
			}
			
			if (!jamcoin.increment()) { //Out of options of length N
				break;
			}
		}
	}
	
	class Jamcoin {
		private int[] data; //Stored backwards
		
		Jamcoin(int[] data) {
			this.data = data;
		}
		
		public boolean increment() {
			if (!contains(data, 0)) {
				return false;
			}
			
			int i = 1;
			do {
				data[i] = (data[i] + 1) % 2;
			} while (data[i++] == 0);
			
			return true;
		}
		
		public String toString() {
			StringBuilder sb = new StringBuilder();
			for (int i = data.length - 1; i > -1; i--) {
				sb.append(data[i]);
			}
			return sb.toString();
		}
		
		//Jamcoin digits never exceed base & are stored backwards
		public BigInteger toBase10(int base) {
			BigInteger number = BigInteger.ZERO;
			BigInteger weight = BigInteger.ONE;
			for (int i = 0; i < data.length; i++) {
				number = number.add(weight.multiply(BigInteger.valueOf(data[i])));
				weight = weight.multiply(BigInteger.valueOf(base));
			}
			
			return number;
		}
		
	}
	
	public boolean getDivisors(Jamcoin jamcoin, int[] divisors) {
		for (int i = 2; i <= 10; i++) {
			BigInteger num = jamcoin.toBase10(i);
			int divisor = smallestDivisor(num);
			if (divisor == -1) {
				return false;
			}
			divisors[i - 2] = divisor;
		}
		
		return true;
	}
	
	public int smallestDivisor(BigInteger number) {
		for (int i = 2; BigInteger.valueOf(i).compareTo(/*bigIntSqRootFloor(number)*/BigInteger.valueOf(1000)) <= 0; i++) {
			if (number.remainder(BigInteger.valueOf(i)) == BigInteger.valueOf(0)) {
				return i;
			}
		}
		
		return -1;
	}
	
	public boolean contains(int[] array, int value) {
		for (int i = 0; i < array.length; i++) {
			if (array[i] == value) {
				return true;
			}
		}
		
		return false;
	}
	
	public static BigInteger bigIntSqRootFloor(BigInteger x) {
	    if (x .equals(BigInteger.ZERO) || x.equals(BigInteger.ONE)) {
	        return x;
	    }
	    BigInteger two = BigInteger.valueOf(2L);
	    BigInteger y;
	    
	    for (y = x.divide(two);
	            y.compareTo(x.divide(y)) > 0;
	            y = ((x.divide(y)).add(y)).divide(two));
	    return y;
	}
}