package CJ2016_QUAL;

public class C {

	public static void main(String[] args) {
		new C().run();
	}
	
	public void run() {
		final int N = 16;
		final int J = 50;
		
		System.out.println("Case #1:");
		
		int[] init = new int[N];
		init[0] = 1; init[N-1] = 1;
		Jamcoin jamcoin = new Jamcoin(init);
		
		int[] divisors = new int[9]; //2 to 10
		int count = 0;
		
		while (count < J){
			if (getDivisors(jamcoin, divisors)) {
				System.out.print(jamcoin.toString());
				for (int i = 2; i <= 10; i++) {
					System.out.print(" " + divisors[i - 2]);
				}
				System.out.println();
				count++;
			}
			
			if (!jamcoin.increment()) { //Out of options of length N
				break;
			}
		}
	}
	
	class Jamcoin {
		private int[] data; //Stored backwards
		
		Jamcoin(int[] data) {
			this.data = data;
		}
		
		public boolean increment() {
			if (!contains(data, 0)) {
				return false;
			}
			
			int i = 1;
			do {
				data[i] = (data[i] + 1) % 2;
			} while (data[i++] == 0);
			
			return true;
		}
		
		public String toString() {
			StringBuilder sb = new StringBuilder();
			for (int i = data.length - 1; i > -1; i--) {
				sb.append(data[i]);
			}
			return sb.toString();
		}
		
		//Jamcoin digits never exceed base & are stored backwards
		public long toBase10(int base) {
			long number = 0;
			long weight = 1;
			for (int i = 0; i < data.length; i++) {
				number += data[i] * weight;
				weight *= base;
			}
			
			return number;
		}
		
	}
	
	public boolean getDivisors(Jamcoin jamcoin, int[] divisors) {
		for (int i = 2; i <= 10; i++) {
			long num = jamcoin.toBase10(i);
			int divisor = smallestDivisor(num);
			if (divisor == -1) {
				return false;
			}
			divisors[i - 2] = divisor;
		}
		
		return true;
	}
	
	public int smallestDivisor(long number) {
		for (int i = 2; i <= Math.sqrt(number); i++) {
			if (number % i == 0) {
				return i;
			}
		}
		
		return -1;
	}
	
	public boolean contains(int[] array, int value) {
		for (int i = 0; i < array.length; i++) {
			if (array[i] == value) {
				return true;
			}
		}
		
		return false;
	}
}