import java.io.*;
import java.util.*;

public class Main {

	public static void main(String[] args) throws Exception{
		Scanner in = new Scanner(new FileInputStream("input.txt"));
		PrintWriter out = new PrintWriter("output.txt");
		
		in.useDelimiter("(\\p{javaWhitespace}+)|:");
		int n = in.nextInt();
		for(int i = 0; i < n; ++i){
			int timeT = in.nextInt();
            
			int numAB = in.nextInt();
			int numBA = in.nextInt();
            
            TreeMap<Integer, SortedSet<Integer> > depAB = new TreeMap<Integer, SortedSet<Integer> >();
            TreeMap<Integer, SortedSet<Integer> > arrAB = new TreeMap<Integer, SortedSet<Integer> >();
            
            TreeMap<Integer, SortedSet<Integer> > depBA = new TreeMap<Integer, SortedSet<Integer> >();
            TreeMap<Integer, SortedSet<Integer> > arrBA = new TreeMap<Integer, SortedSet<Integer> >();
            
			for(int tIdx = 0; tIdx < numAB + numBA; ++tIdx){
				int dep = in.nextInt() * 60 + in.nextInt();
				int arr = in.nextInt() * 60 + in.nextInt() + timeT;
                pushTrain((tIdx < numAB)? depAB: depBA, (tIdx < numAB)? arrAB: arrBA, dep, arr);
			}
            
            int countA = 0;
            int countB = 0;
            
            while(!arrAB.isEmpty() && !arrBA.isEmpty()){
                int arrB = arrAB.firstKey();
                int arrA = arrBA.firstKey();

                if(arrB < arrA){
                    ++countA;
                    trackTrain(arrAB, depAB, arrB, arrBA, depBA);
                } else {//? ==
                    ++countB;                    
                    trackTrain(arrBA, depBA, arrA, arrAB, depAB);
                }
            }
            
            for(SortedSet<Integer> it: depAB.values())
                countA += it.size();
            for(SortedSet<Integer> it: depBA.values())
                countB += it.size();
            
            out.println(String.format("Case #%d: %d %d", i + 1, countA, countB));
			out.flush();			
		}
		
	}
    
    private static void pushTrain(Map<Integer, SortedSet<Integer> > dep
                                  , Map<Integer, SortedSet<Integer> > arr
                                  , Integer depTime
                                  , Integer arrTime)
    {
        pushCounter(dep, depTime, arrTime);
        pushCounter(arr, arrTime, depTime);
    }
    
    private static int popTrain(Map<Integer, SortedSet<Integer> > dep
                                , Map<Integer, SortedSet<Integer> > arr
                                , Integer depTime)
    {

        int arrTime = popCounter(dep, depTime);
        SortedSet<Integer> altVals = arr.get(arrTime);
        altVals.remove(depTime);
        if(altVals.isEmpty())
            arr.remove(arrTime);
        return arrTime;
    }
    
    
    private static void pushCounter(Map<Integer, SortedSet<Integer> > m, Integer keyVal, Integer altVal){
        SortedSet<Integer> altVals = m.get(keyVal);
        if(altVals == null)
            altVals = new TreeSet<Integer>();
        altVals.add(altVal);
        m.put(keyVal, altVals);                
    }
    
    private static Integer popCounter(Map<Integer, SortedSet<Integer> > m, Integer keyVal){
        SortedSet<Integer> altVals = m.get(keyVal);
        Integer ret = altVals.first();
        altVals.remove(ret);
        if(altVals.isEmpty())
            m.remove(keyVal);
        return ret;
    }

    private static void trackTrain(SortedMap<Integer, SortedSet<Integer>> arr1,
                                   SortedMap<Integer, SortedSet<Integer>> dep1,
                                   int arrTime,
                                   SortedMap<Integer, SortedSet<Integer>> arr2,
                                   SortedMap<Integer, SortedSet<Integer>> dep2) 
    {
        int depTime = arr1.get(arrTime).first();
        while(true){
            arrTime = popTrain(dep1, arr1, depTime);

            SortedMap<Integer, SortedSet<Integer>> upper = dep2.tailMap(arrTime);
            if(upper.isEmpty())
                return;
            depTime = upper.firstKey();
            
            SortedMap<Integer, SortedSet<Integer>> tmp;
            tmp = arr1; arr1 = arr2; arr2 = tmp;
            tmp = dep1; dep1 = dep2; dep2 = tmp;
        }
        
    }
	
}