import java.io.*;
import java.util.*;

public class Main {
	private static class FreqLetter{
		public int freq;
		public int letter;
	}
	
	private static class ByFreq implements Comparator<FreqLetter>{
		public int compare(FreqLetter l, FreqLetter r){
			if(l.freq != r.freq)
				return r.freq - l.freq;
			
			return r.letter - l.letter;
		}
	}
	
	public static void main(String[] args) throws Exception{
		Scanner in = new Scanner(new FileInputStream("input.txt"));
		PrintWriter out = new PrintWriter("output.txt");
		
		int n = in.nextInt();
		for(int caseIdx = 0; caseIdx < n; ++caseIdx){
			
			int maxP = in.nextInt();
			int K = in.nextInt();
			int L = in.nextInt();
			
			FreqLetter f[] = new FreqLetter[L];
			for(int i = 0; i < L; ++i){
				FreqLetter fl = new FreqLetter();
				fl.freq = in.nextInt();
				fl.letter = i;
				f[i] = fl;
			}
			
			Arrays.sort(f, new ByFreq());
			
			long sum = 0;
			int fIdx = 0;
			for(int keyP = 1; keyP <= maxP && fIdx < L && f[fIdx].freq > 0; ++keyP){
				for(int key = 0; key < K && fIdx < L && f[fIdx].freq > 0; ++key, ++fIdx){
					sum += f[fIdx].freq * keyP;
				}
			}
			
			out.print(String.format(Locale.US, "Case #%d: ", caseIdx + 1));
			if(fIdx < L){
				out.println("Impossible");				
			} else {
				out.println(sum);				
			}

			out.flush();			
		}
		
	}
	
}
