package dinbur.codejam.qualification;

import java.io.*;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Random;
import java.util.Set;

public class Problem3 {

    private static HashMap<Long, Long> commonDivisors = new HashMap<>();

    public static void main(String[] args) throws FileNotFoundException {
        try (BufferedReader br = new BufferedReader(new FileReader("src/dinbur/codejam/qualification/input.txt"))) {
            String line = br.readLine();
            int totalExamples = Integer.parseInt(line);
            StringBuilder res = new StringBuilder();
            res.append(String.format("Case #%d:\n", totalExamples));
            for (int i = 0; i < totalExamples; i++) {
                line = br.readLine();
                int length = Integer.parseInt(line.split(" ")[0]);
                int totalJamcoins = Integer.parseInt(line.split(" ")[1]);
                int validJamcoins = 0;
                Set<String> jamcoinsTested = new HashSet<>();
                while(validJamcoins<totalJamcoins) {
                    String randomJamcoin = createRandomJamcoin(length);
                    if (!jamcoinsTested.contains(randomJamcoin)) {
                        jamcoinsTested.add(randomJamcoin);
                        HashMap<Integer, Long> divisors = computeDivisors(randomJamcoin);
                        boolean isValid = true;
                        for (Integer base : divisors.keySet()) {
                            if (divisors.get(base) < 0) {
                                isValid = false;
                                break;
                            }
                        }
                        if (isValid) {
                            validJamcoins++;
                            res.append(String.format("%s %s\n", randomJamcoin, getDivisorValues(divisors)));
                            System.out.println(String.format("Found %d out of %d", validJamcoins, totalJamcoins));
                        }
                    }
                }
            }
            PrintWriter writer = new PrintWriter("output.txt");
            writer.print(res.toString());
            writer.close();
        }catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static String getDivisorValues(HashMap<Integer, Long> divisors){
        StringBuilder sb = new StringBuilder();
        for(int base=2; base<11; base++){
            sb.append(String.format("%d ", divisors.get(base)));
        }
        return sb.toString();
    }

    private static String getRandomBit(){
        return new Random().nextBoolean() ? "1" : "0";
    }

    private static String createRandomJamcoin(int length){
        StringBuilder jamcoin = new StringBuilder("1");
        for(int bit=1; bit< length-1; bit++){
            jamcoin.append(getRandomBit());
        }
        jamcoin.append("1");
        return jamcoin.toString();
    }

    private static long computeJamcoinValue(String jamcoin, int base){
        long res = 0;
        int length = jamcoin.length();
        for(int i=0;i<length;i++){
            res += Long.parseLong(String.valueOf(jamcoin.charAt(i))) * (Math.pow(base,(length-1-i)));
        }
        return res;
    }

    private  static HashMap<Integer, Long> computeDivisors(String jamcoin){
        HashMap<Integer, Long> divisors = new HashMap<>();
        for(int base=2;base<11;base++){
            divisors.put(base, computeDivisor(jamcoin, base));
        }
        return divisors;
    }

    private  static long computeDivisor(String jamcoin, int base) {
        long value = computeJamcoinValue(jamcoin, base);
        if (commonDivisors.containsKey(value)) {
            return commonDivisors.get(value);
        } else {
            long divisor = -1;
            if (value % 2 == 0) {
                divisor = 2;
            } else {
                long squareRoot = (long)Math.sqrt(value);
                for(long i=3; i<squareRoot; i+=2){
                    if(value %i==0){
                        divisor = i;
                    }
                }
            }
            commonDivisors.put(value, divisor);
            return  divisor;
        }
    }
}
