package dinbur.codejam.qualification;

import java.io.*;
import java.util.ArrayList;

public class Problem2 {

    private static final char HAPPY = '+';
    private static final char SAD = '-';

    public static void main(String[] args) throws FileNotFoundException {
        try (BufferedReader br = new BufferedReader(new FileReader("src/dinbur/codejam/qualification/input.txt"))) {
            String line = br.readLine();
            int totalExamples = Integer.parseInt(line);
            StringBuilder res = new StringBuilder();
            for (int i = 0; i < totalExamples; i++) {
                line = br.readLine();
                ArrayList<Character> stack = new ArrayList<>();
                for (char c : line.toCharArray()) {
                    stack.add(c);
                }
                int flips = 0;
                while(!isCustomerHappy(stack)){
                    int flippingPoint = findFlippingPoint(stack);
                    stack = flipPancakes(stack, flippingPoint);
                    flips +=1;
                }
                res.append(String.format("Case #%d:\t%d\n", i+1, flips));
            }
            PrintWriter writer = new PrintWriter("output.txt");
            writer.print(res.toString());
            writer.close();
        }catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static int findFlippingPoint(ArrayList<Character> stack) {
        for (int i = 0; i < stack.size() - 1; i++) {
            if (stack.get(i) != stack.get(i + 1)) {
                return i;
            }
        }
        return stack.size();
    }

    private static boolean isCustomerHappy(ArrayList<Character> stack){
        for(Character c:stack){
            if(SAD == c){
                return false;
            }
        }
        return true;
    }

    private static ArrayList<Character> flipPancakes(ArrayList<Character> stack, int flippingPoint){
        ArrayList<Character> result = new ArrayList<>();
        for(int i=0;i<flippingPoint;i++){
            if(HAPPY == stack.get(i)){
                result.add(SAD);
            }else{
                result.add(HAPPY);
            }
        }
        if(flippingPoint < stack.size()) {
            result.addAll(stack.subList(flippingPoint + 1, stack.size()));
        }
        return result;
    }
}
