package com.codejam.solution;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;

public class LawnMower {
	static int getMin(int[] values){
		int min = values[0];
		for(int i=0;i<values.length;i++){
			min = Math.min(min, values[i]);
		}
		return min;
	}
	
	static int getMax(int[] values){
		int max = values[0];
		for(int i=0;i<values.length;i++){
			max = Math.max(max, values[i]);
		}
		return max;
	}
	
	static boolean canMow(int [][]pattern, int rows, int cols){
		int [][]myPattern = new int[rows][cols];
		for(int i=0;i<rows;i++){
			Arrays.fill(myPattern[i], getMax(pattern[i]));
		}
		for(int j=0; j<cols; j++){
			int [] colValues = new int[rows];
			for(int i=0;i<rows;i++){
				colValues[i]=pattern[i][j];
			}
			int colMax = getMax(colValues);
			for(int i=0;i<rows;i++){
				if(myPattern[i][j] > colMax){
					myPattern[i][j]=colMax;
				}
			}
		}
		
		for(int j=0; j<cols; j++){
			int [] colValues = new int[rows];
			for(int i=0;i<rows;i++){
				colValues[i]=pattern[i][j];
			}
			int colMin = getMin(colValues);
			boolean mowable = true;
			for(int i = 0; i< rows ; i++){
				if(pattern[i][j]>colMin){
					mowable = false;
					break;
				}
			}
			if(mowable){
				for(int i=0;i<rows;i++){
					myPattern[i][j]=colMin;
				}
			}
		}
		
		//compare arrays
		boolean mowable = true;
		for(int i=0; i<rows; i++){
			if(!Arrays.equals(pattern[i], myPattern[i])){
				mowable = false;
			}
		}
		return mowable;
	}
	
	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader fileReader = new BufferedReader(
				new InputStreamReader(new FileInputStream(System.getProperty("user.home")+File.separator+"input.txt")));
		int cases = Integer.parseInt(fileReader.readLine());
		for(int t=0;t<cases;t++){
			String dimSpec = fileReader.readLine();
			String []dims = dimSpec.split("\\s");
			int rows = Integer.parseInt(dims[0]);
			int cols = Integer.parseInt(dims[1]);
			int [][]pattern = new int[rows][cols];
			
			for(int i=0;i<rows; i++){
				String rowSpec = fileReader.readLine();
				String[] colVals = rowSpec.split("\\s");
				for(int j=0;j<cols;j++){
					pattern[i][j] = Integer.parseInt(colVals[j]);
				}
			}
			
			if(canMow(pattern, rows, cols)){
				System.out.println("Case #"+(t+1)+": YES");
			}else{
				System.out.println("Case #"+(t+1)+": NO");
			}
		}
	}
}
