package com.codejam.solution;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.Queue;
import java.util.regex.Pattern;


public class BotTrust {
	public static void solve(String textFile) throws NumberFormatException, IOException{
		FileInputStream fis=new FileInputStream(textFile);
		BufferedReader reader=new BufferedReader(new InputStreamReader(fis));
		int cases=new Integer(reader.readLine()).intValue();
		System.out.println("Cases are "+cases);
		
		
		for(int i=0;i<cases;i++){
			LinkedList blueQueue=new LinkedList();
			LinkedList orangeQueue=new LinkedList();
			String entryLine=reader.readLine();
			String[] entries=entryLine.split("\\s");
			entryLine=null;
			int time=0;
			int n=new Integer(entries[0]).intValue();
			int index=1;
			for(int j=0;j<n;j++){
				if(entries[index].charAt(0)=='O'){
					int []entry={++time,new Integer(entries[++index]).intValue()};
					orangeQueue.add(entry);
				}
				else{
					int []entry={++time,new Integer(entries[++index]).intValue()};
					blueQueue.add(entry);
				}
				++index;
			}
			
			//start progression
			int timeTaken=0;
			int[] orangeAction=(int[]) orangeQueue.pollFirst();
			int[] blueAction=(int[]) blueQueue.pollFirst();
			int currentBlueButton=1;
			int currentOrangeButton=1;
			int blueDistance=blueAction!=null?Math.abs(blueAction[1]-currentBlueButton):0;
			int orangeDistance=orangeAction!=null?Math.abs(orangeAction[1]-currentOrangeButton):0;
			
			while(orangeAction!=null && blueAction!=null){
				if(blueAction[0]<orangeAction[0]){
					if(blueDistance<=0)blueDistance=0;
					timeTaken+=(blueDistance+1);
					orangeDistance-=(blueDistance+1);
					currentBlueButton=blueAction[1];
					blueAction=(int[]) blueQueue.pollFirst();
					if(blueAction!=null){
						blueDistance=Math.abs(blueAction[1]-currentBlueButton);
					}
				}
				else{
					if(orangeDistance<=0)orangeDistance=0;
					timeTaken+=(orangeDistance+1);
					blueDistance-=(orangeDistance+1);
					currentOrangeButton=orangeAction[1];
					orangeAction=(int[]) orangeQueue.pollFirst();
					if(orangeAction!=null){
						orangeDistance=Math.abs(orangeAction[1]-currentOrangeButton);
					}
				}
			}
			
			if(blueAction==null){
				if(orangeDistance<=0)orangeDistance=0;
				while (orangeAction!=null) {
					timeTaken+=(orangeDistance+1);
					currentOrangeButton=orangeAction[1];
					orangeAction=(int[]) orangeQueue.pollFirst();
					if(orangeAction!=null){
						orangeDistance=Math.abs(orangeAction[1]-currentOrangeButton);
					}
				}
			}
			
			if(orangeAction==null){
				if(blueDistance<=0)blueDistance=0;
				while (blueAction!=null) {
					timeTaken+=(blueDistance+1);
					currentBlueButton=blueAction[1];
					blueAction=(int[]) blueQueue.pollFirst();
					if(blueAction!=null){
						blueDistance=Math.abs(blueAction[1]-currentBlueButton);
					}
				}
			}
			
			
			System.out.println("Case #"+(i+1)+": "+timeTaken);
		}
	}
	
	public static void main(String[] args) throws NumberFormatException, IOException {
		BotTrust.solve("/home/solomon/Downloads/A-small.in");
	}
}
