import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;


public class TidyNumbers {
	public static void main(String[] args) throws NumberFormatException, IOException {
		try (BufferedReader reader = new BufferedReader(
				new InputStreamReader(new FileInputStream(args[0])));
				PrintWriter out = new PrintWriter(args[1])) {
			int caseCount = Integer.parseInt(reader.readLine());
			for (int i=0; i< caseCount; i++) {
				String number = reader.readLine();
				List<Integer> numbers = new ArrayList<Integer>(number.length());
				for (int j=0; j< number.length(); j++) {
					numbers.add(Integer.parseInt(""+number.charAt(j)));
				}
				while (!isValid(numbers));
				while (numbers.size() > 1 && numbers.get(0) == 0) {
					numbers.remove(0);
				}
				out.println("Case #"+(i+1)+": "+numbers.toString().replaceAll("\\D", ""));
			}
		}
	}
	
	static boolean isValid(List<Integer> numbers) {
		for (int i = 1; i < numbers.size(); i++) {
			if (numbers.get(i-1) > numbers.get(i)) {
				numbers.set(i, 9);
				numbers.set(i-1, numbers.get(i-1)-1);
				for (int j=i+1; j < numbers.size(); j++) {
					numbers.set(j, 9);
				}
				return false;
			}
		}
		return true;
	}
}
