import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Comparator;
import java.util.SortedMap;
import java.util.TreeMap;


public class BathroomStalls {
	public static void main(String[] args) throws NumberFormatException, IOException {
		try (BufferedReader reader = new BufferedReader(
				new InputStreamReader(new FileInputStream(args[0])));
				PrintWriter out = new PrintWriter(args[1])) {
			int caseCount = Integer.parseInt(reader.readLine());
			for (int i=0; i< caseCount; i++) {
				String[] caseSpec = reader.readLine().split("\\s");
				long N = Long.parseLong(caseSpec[0]);
				long K = Long.parseLong(caseSpec[1]);
				SortedMap<Long, Long> slotsCount = new TreeMap<Long, Long>(new Comparator<Long>() {
					@Override
					public int compare(Long o1, Long o2) {
						return o2.compareTo(o1);
					}
				});
				long peopleAdded = 0;
				
				slotsCount.put(N, 1L);
				while (peopleAdded < K) {
					Long largestSlotsSize = slotsCount.firstKey();
					Long largestSlotsCount = slotsCount.get(largestSlotsSize);
					slotsCount.remove(largestSlotsSize);
					long peopleRemaining = K - peopleAdded;
					if (peopleRemaining <= largestSlotsCount) {
						// the last person will fir into a slot of current largest size
						long leftSlotSizes = largestSlotsSize/2L;
						long rightSlotSizes = leftSlotSizes;
						if (leftSlotSizes > 0 && largestSlotsSize %2 == 0) {
							leftSlotSizes -=1;
						}
						out.println("Case #"+(i+1)+": "+Math.max(leftSlotSizes, rightSlotSizes)+" "+Math.min(leftSlotSizes, rightSlotSizes));
						break;
					} else {
						// we add pple equal to the current largest slots
						peopleAdded += largestSlotsCount;
						// get the size of new slots
						long leftSlotSizes = largestSlotsSize/2L;
						long rightSlotSizes = leftSlotSizes;
						if (largestSlotsSize %2 ==0) {
							leftSlotSizes -=1;
						}
						if (slotsCount.containsKey(leftSlotSizes)) {
							slotsCount.put(leftSlotSizes, slotsCount.get(leftSlotSizes)+largestSlotsCount);
						} else {
							slotsCount.put(leftSlotSizes, largestSlotsCount);
						}
						
						if (slotsCount.containsKey(rightSlotSizes)) {
							slotsCount.put(rightSlotSizes, slotsCount.get(rightSlotSizes)+largestSlotsCount);
						} else {
							slotsCount.put(rightSlotSizes, largestSlotsCount);
						}
					}
				}
			}
		}
	}
}
