package qualification.problemA;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class ProblemASolver {
	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		List<String> answers = solve(args[0]);

		for (String answer : answers) {
			System.out.println(answer);
		}

		writeToDisk(answers);
	}

	private static void writeToDisk(List<String> result) throws IOException {
		File f = new File("F:/home/code/output.txt");
		BufferedWriter w = null;
		try {
			w = new BufferedWriter(new FileWriter(f));
			
			for(String s : result) {
				w.write(s + "\n");
			}
			w.flush();
		} finally {
			if(w != null) {
				w.close();
			}
		}
		
		
	}

	private static List<String> solve(String filename) throws IOException {
		List<String> result = new ArrayList<>();

		File f = new File(filename);
		BufferedReader reader = new BufferedReader(new FileReader(f));

		String sizeString = reader.readLine();
		int size = Integer.parseInt(sizeString);

		for (int i = 0; i < size; i++) {
			List<String> linesFirst = new ArrayList<>();
			List<String> linesSecond = new ArrayList<>();
			int firstGuess = 0;
			int secondGuess = 0;
			
			String line = reader.readLine();
			String line1 = reader.readLine();
			String line2 = reader.readLine();
			String line3 = reader.readLine();
			String line4 = reader.readLine();
				
			firstGuess = Integer.parseInt(line); 
			linesFirst.add(line1);
			linesFirst.add(line2);
			linesFirst.add(line3);
			linesFirst.add(line4);
				
			line = reader.readLine();
			line1 = reader.readLine();
			line2 = reader.readLine();
			line3 = reader.readLine();
			line4 = reader.readLine();

			secondGuess = Integer.parseInt(line); 
			linesSecond.add(line1);
			linesSecond.add(line2);
			linesSecond.add(line3);
			linesSecond.add(line4);
			
			List<String> lineFirstGuess = Arrays.asList(linesFirst.get(firstGuess - 1).split(" ")); 
			List<String> lineSecondGuess = Arrays.asList(linesSecond.get(secondGuess - 1).split(" "));
			boolean contains = false;
			boolean doubleEntry = false;
			String lastNumber = "";
				
			for(String s : lineFirstGuess) {
				if(lineSecondGuess.contains(s)) {
					if(contains) {
						doubleEntry = true;
					}
						
					lastNumber = s;
					contains = true;
				}
			}

			if(doubleEntry) {
				result.add(MessageFormat.format("Case #{0}: Bad magician!", (i + 1)));	
			} else if(!contains) {
				result.add(MessageFormat.format("Case #{0}: Volunteer cheated!", (i + 1)));
			} else {
				result.add(MessageFormat.format("Case #{0}: {1}", (i + 1), lastNumber));
			}
		}

		return result;
	}
}
