package qualification;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;

public class ProblemASolver {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		List<String> answers = solve(args[0]);

		for (String answer : answers) {
			System.out.println(answer);
		}

		writeToDisk(answers);
	}

	private static void writeToDisk(List<String> result) throws IOException {
		File f = new File("F:/home/code/output.txt");
		BufferedWriter w = null;
		try {
			w = new BufferedWriter(new FileWriter(f));
			
			for(String s : result) {
				w.write(s + "\n");
			}
			w.flush();
		} finally {
			if(w != null) {
				w.close();
			}
		}
		
		
	}

	private static List<String> solve(String filename) throws IOException {
		List<String> result = new ArrayList<>();

		File f = new File(filename);
		BufferedReader reader = new BufferedReader(new FileReader(f));

		String sizeString = reader.readLine();
		int size = Integer.parseInt(sizeString);

		for (int i = 0; i < size; i++) {
			String line0 = reader.readLine();
			String line1 = reader.readLine();
			String line2 = reader.readLine();
			String line3 = reader.readLine();
			reader.readLine();

			char[][] gedreht = buildColumnArray(line0, line1, line2, line3);
			char[][] diagonal = buildDiagonal(line0, line1, line2, line3);

			boolean rowX = check(line0.toCharArray(), 'X')
					|| check(line1.toCharArray(), 'X')
					|| check(line2.toCharArray(), 'X')
					|| check(line3.toCharArray(), 'X')
					|| check(gedreht[0], 'X') || check(gedreht[1], 'X')
					|| check(gedreht[2], 'X') || check(gedreht[3], 'X')
					|| check(diagonal[0], 'X') || check(diagonal[1], 'X');

			if (rowX) {
				result.add(MessageFormat.format("Case #{0}: X won", (i + 1)));
				continue;
			}

			boolean rowO = check(line0.toCharArray(), 'O')
					|| check(line1.toCharArray(), 'O')
					|| check(line2.toCharArray(), 'O')
					|| check(line3.toCharArray(), 'O')
					|| check(gedreht[0], 'O') || check(gedreht[1], 'O')
					|| check(gedreht[2], 'O') || check(gedreht[3], 'O')
					|| check(diagonal[0], 'O') || check(diagonal[1], 'O');

			if (rowO) {
				result.add(MessageFormat.format("Case #{0}: O won", (i + 1)));
				continue;
			}

			if (line0.contains(".") || line1.contains(".")
					|| line2.contains(".") || line3.contains(".")) {
				result.add(MessageFormat.format(
						"Case #{0}: Game has not completed", (i + 1)));
				continue;
			}

			result.add(MessageFormat.format("Case #{0}: Draw", (i + 1)));
		}

		return result;
	}

	private static boolean check(char[] row, char player) {
		boolean complete = true;

		for (char s : row) {
			if (s == player || s == 'T') {
				complete = complete && true;
			} else {
				complete = complete && false;
			}
		}

		return complete;
	}

	private static char[][] buildDiagonal(String line0, String line1,
			String line2, String line3) {
		char[][] result = new char[2][4];

		char[] charLine0 = line0.toCharArray();
		char[] charLine1 = line1.toCharArray();
		char[] charLine2 = line2.toCharArray();
		char[] charLine3 = line3.toCharArray();

		result[0][0] = charLine0[0];
		result[0][1] = charLine1[1];
		result[0][2] = charLine2[2];
		result[0][3] = charLine3[3];

		result[1][0] = charLine0[3];
		result[1][1] = charLine1[2];
		result[1][2] = charLine2[1];
		result[1][3] = charLine3[0];

		return result;
	}

	private static char[][] buildColumnArray(String line0, String line1,
			String line2, String line3) {
		char[][] result = new char[4][4];

		char[] charLine0 = line0.toCharArray();
		char[] charLine1 = line1.toCharArray();
		char[] charLine2 = line2.toCharArray();
		char[] charLine3 = line3.toCharArray();

		result[0][0] = charLine0[0];
		result[1][0] = charLine0[1];
		result[2][0] = charLine0[2];
		result[3][0] = charLine0[3];

		result[0][1] = charLine1[0];
		result[1][1] = charLine1[1];
		result[2][1] = charLine1[2];
		result[3][1] = charLine1[3];

		result[0][2] = charLine2[0];
		result[1][2] = charLine2[1];
		result[2][2] = charLine2[2];
		result[3][2] = charLine2[3];

		result[0][3] = charLine3[0];
		result[1][3] = charLine3[1];
		result[2][3] = charLine3[2];
		result[3][3] = charLine3[3];

		return result;
	}

}
