package qualification.problemD;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.MessageFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class ProblemDSolver {
	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		List<String> answers = solve(args[0]);

		for (String answer : answers) {
			System.out.println(answer);
		}

		writeToDisk(answers);
	}

	private static void writeToDisk(List<String> result) throws IOException {
		File f = new File("F:/home/code/output.txt");
		BufferedWriter w = null;
		try {
			w = new BufferedWriter(new FileWriter(f));
			
			for(String s : result) {
				w.write(s + "\n");
			}
			w.flush();
		} finally {
			if(w != null) {
				w.close();
			}
		}
		
		
	}

	private static List<String> solve(String filename) throws IOException {
		List<String> result = new ArrayList<>();

		File file = new File(filename);
		BufferedReader reader = new BufferedReader(new FileReader(file));

		String sizeString = reader.readLine();
		int size = Integer.parseInt(sizeString);

		for (int i = 0; i < size; i++) {
			reader.readLine();
			String naomiRaw = reader.readLine();
			String kenRaw = reader.readLine();
			
			List<Double> naomi = new ArrayList<>();
			List<Double> ken = new ArrayList<>();
			
			for(String s : naomiRaw.split(" ")) {
				naomi.add(Double.parseDouble(s));
			}

			for(String s : kenRaw.split(" ")) {
				ken.add(Double.parseDouble(s));
			}
			
			Collections.sort(naomi);
			Collections.sort(ken);

			int naomiWonWar = 0;
			int naomiWonNewWar = 0;
			
			
			for(int j = 0; j < naomi.size(); j++) {
				double naomiPlay = naomi.get(j);
				double kenPlay = getValueGreater(ken, naomiPlay);
				
				if(naomiPlay > kenPlay) {
					naomiWonWar++;
				}
			}
			
			ken = new ArrayList<>();
			
			for(String s : kenRaw.split(" ")) {
				ken.add(Double.parseDouble(s));
			}
			Collections.sort(ken);

			for(int j = 0; j < ken.size(); j++) {
				double kenPlay = ken.get(j);
				double naomiPlay = getValueGreater(kenPlay, naomi);
				
				if(naomiPlay > kenPlay) {
					naomiWonNewWar++;
				}
			}

			result.add(MessageFormat.format("Case #{0}: {1}", (i + 1), naomiWonNewWar + " " + naomiWonWar));
		}

		return result;
	}
	
	private static double getValueGreater(List<Double> list, double value) {
		double returnValue = -1;
		if(value > list.get(list.size() - 1)) {
			returnValue = list.remove(0);
		} else {
			for(int i = 0; i < list.size(); i++) {
				if(list.get(i) > value) {
					returnValue = list.remove(i);
					return returnValue;
				}
			}
		}
		
		return returnValue;
	}
	
	private static double getValueGreater(double value, List<Double> list) {
		for(int i = 0; i < list.size(); i++) {
			if(list.get(i) > value) {
				return list.remove(i);
			}
		}
		
		return list.remove(0);
	}

}
