package Qualification.ProblemC;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class ProblemC {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		List<List<String>> liste = importFile(new File(args[0]));
		List<String> output = new ArrayList<String>();
		
		int counter = 1;
		for (List<String> list : liste) {
			for(String s : list) {
				System.out.println(s);
			}
			
			System.out.println("---");
			output.add("Case #" + counter++ +": " + solve(list));
			writeToFile(output);
		}

	}
	
	public static void writeToFile(List<String> output) {
		BufferedWriter writer = null;
		try {
			writer = new BufferedWriter(new FileWriter(new File("output.txt")));
			for(int i = 0; i < output.size(); i++) {
				writer.write(output.get(i) + "\n");
			}
		
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally{
			if(writer != null) {
				try {
					writer.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		
	}

	public static boolean isPossible(List<String> input) {
		int countOnes = 0;
		int counter = input.get(0).length();
		for(int j = counter - 1; j >= 0; j--) {
			for(int i = 0; i < input.size(); i++) {
				if(input.get(i).toCharArray()[j] == '1') {
					countOnes++;
				}
			}
			
			if(countOnes%2 != 0) {
				return false;
			}
		}
		
		return true;
	}
	
	public static String solve(List<String> input) {
		long valueOfSean = 0;
		String valuePatrick = "";
		String valueSean = "";
		List<String> listPatrick = new ArrayList<String>();
		List<String> listSean = new ArrayList<String>();
		
		if(!isPossible(input)) {
			return "NO";
		}
		
		for(int i = 0; i < input.size() - 1; i++) {
			valueOfSean += Long.parseLong(input.get(i), 2);
		}
		
		
		return String.valueOf(valueOfSean);
	}

	public static String getNormalizedString(String s, int count) {
		while (s.length() < count) { 
			s = "0" + s; 
			} 
		return s;
	}
	
	public static List<List<String>> importFile(File file) {
		BufferedReader reader = null;
		List<List<String>> imported = new ArrayList<List<String>>();
		try {
			reader = new BufferedReader(new FileReader(file));
			int count = Integer.parseInt(reader.readLine());
			
			for(int i = 0; i < count; i++) {
				List<String> row = new ArrayList<String>();
				reader.readLine();
				String[] splittedNumbers = reader.readLine().split(" ");
				int maxLength = 0;
				List<String> temp = new ArrayList<String>();
				for (String string : splittedNumbers) {
					String numberInBinary = Long.toBinaryString(Long.parseLong(string));
					temp.add(numberInBinary);
					maxLength = Math.max(maxLength, numberInBinary.length());
				}

			
				for(String s : temp) {
					row.add(getNormalizedString(s, maxLength));
				}
				Collections.sort(row);
				Collections.reverse(row);
				imported.add(row);
			}
			
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			if(reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	
		return imported;
	}

}
