package Qualification.ProblemD;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class ProblemD {

	public static void main(String[] args) {
		List<int[]> liste = importFile(new File(args[0]));
		List<String> output = new ArrayList<String>();
		for(int i = 0; i < liste.size(); i++) {
			String result = String.valueOf(solve(liste.get(i)));
			System.out.println(result);
			output.add("Case #" + (i+1) + ": " + result);
		}
		
		writeToFile(output);
	}
	
	public static int solve(int[] input) {
		int returnValue = 0;
		boolean sorted = false;
		
		while(!sorted) {
			List<Integer> liste = new ArrayList<Integer>();
			List<Integer> oldListe = new ArrayList<Integer>();
			
			for(int i = 0; i < input.length; i++) {
				if(input[i] != (i+1)) {
					input = sort(input, input[i], input[input[i]-1]);
					returnValue += 2;
				}
			}
			
			if(liste.size() == 0) {
				sorted = true;
			}
		}
		
		return returnValue;
	}
	
	public static int[] sort(int[] array, int i, int j) {
		int numberI = array[i-1];
		int numberJ = array[j-1];
		array[i-1] = numberJ;
		array[j-1] = numberI;
		return array;
	}
	
	public static void writeToFile(List<String> output) {
		BufferedWriter writer = null;
		try {
			writer = new BufferedWriter(new FileWriter(new File("output.txt")));
			for(int i = 0; i < output.size(); i++) {
				writer.write(output.get(i) + "\n");
			}
		
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally{
			if(writer != null) {
				try {
					writer.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

	public static List<int[]> importFile(File file) {
		BufferedReader reader = null;
		List<int[]> imported = new ArrayList<int[]>();
		try {
			reader = new BufferedReader(new FileReader(file));
			int count = Integer.parseInt(reader.readLine());
			
			for(int i = 0; i < count; i++) {
				reader.readLine();
				String[] splittedNumbers = reader.readLine().split(" ");
				int[] row = new int[splittedNumbers.length];
				for(int j = 0; j < splittedNumbers.length; j++) {
					row [j] = Integer.parseInt(splittedNumbers[j]);
				}
				
				imported.add(row);
			}
			
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			if(reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	
		return imported;
	}

}
