package qualification.problema;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ProblemA {

	private Map<Character, Character> replacement;

	public ProblemA() {
		replacement = new HashMap<Character, Character>();
		initializeMap();
	}

	private void initializeMap() {
		String[] input = new String[] {
				"ejp mysljylc kd kxveddknmc re jsicpdrysi",
				"rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd",
				"de kr kd eoya kw aej tysr re ujdr lkgc jv" };
		String[] output = new String[] {
				"our language is impossible to understand",
				"there are twenty six factorial possibilities",
				"so it is okay if you want to just give up" };

		for (int i = 0; i < input.length; i++) {
			for (int j = 0; j < input[i].toCharArray().length; j++) {
				if (!replacement.containsKey(input[i].toCharArray()[j])) {
					replacement.put(input[i].toCharArray()[j],
							output[i].toCharArray()[j]);
				}
			}

		}

		replacement.put('z', 'q');
		replacement.put('q', 'z');
	}

	public static void main(String[] args) {
		ProblemA a = new ProblemA();
		List<String> input = a.readInput(new File(args[0]));
		List<String> output = a.solve(input);
		a.writeToDisk(output);
	}

	private List<String> readInput(File f) {
		String nextLine = null;
		List<String> result = null;

		try {
			BufferedReader reader = new BufferedReader(new FileReader(f));

			while ((nextLine = reader.readLine()) != null) {
				if (result == null) {
					result = new ArrayList<String>();
				} else {
					result.add(nextLine);
				}
			}
			
			reader.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return result;
	}

	private List<String> solve(List<String> input) {
		List<String> output = new ArrayList<String>();
		
		for(String s : input) {
			StringBuilder builder = new StringBuilder(s.length());
			
			for(Character c : s.toCharArray()) {
				builder.append(replacement.get(c));
			}
			output.add(builder.toString());
		}
		
		return output;
	}

	private void writeToDisk(List<String> output) {
		File f = new File("output.txt");
		
		try {
			BufferedWriter writer = new BufferedWriter(new FileWriter(f));
			int counter = 1;
			for(String s : output) {
				writer.write("Case #" + counter + ": " + s + "\n");
				counter++;
			}
			writer.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		
	}
	
}
