package qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;

import javax.swing.plaf.SliderUI;

public class ProblemCSolver {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		List<String> result = solve(args[0]);
		
		for(String s : result) {
			System.out.println(s);
		}
		
		writeToDisk(result);
	}

	private static void writeToDisk(List<String> result) throws IOException {
		File f = new File("F:/home/code/output.txt");
		BufferedWriter w = null;
		try {
			w = new BufferedWriter(new FileWriter(f));
			
			for(String s : result) {
				w.write(s + "\n");
			}
			w.flush();
		} finally {
			if(w != null) {
				w.close();
			}
		}
	}

	private static List<String> solve(String filename) throws IOException {
		List<String> result = new ArrayList<>();

		File f = new File(filename);
		BufferedReader reader = new BufferedReader(new FileReader(f));

		String sizeString = reader.readLine();
		int size = Integer.parseInt(sizeString);

		for (int i = 0; i < size; i++) {
			int count = 0;
			System.out.println("--------------");
			String line0 = reader.readLine();
			String[] splittedLine = line0.split(" ");

			int min = Integer.parseInt(splittedLine[0]);
			int max = Integer.parseInt(splittedLine[1]);

			for (int j = min; j <= max; j++) {
				if (isPalindrom(String.valueOf(j))) {
					int sqrt = isSqare(j); 
					if(sqrt != -1) {
						if(isPalindrom(String.valueOf(sqrt))) {
							count++;
						}
					}
				}
			}
			
			result.add(MessageFormat.format("Case #{0}: {1}", i+1, count));
		}

		return result;
	}

	private static int isSqare(int i) {
		double sqrt = Math.sqrt(i);
		if(sqrt == Math.rint(sqrt)) {
			return (int) sqrt;
		}
		
		return -1;
	}
	
	private static boolean isPalindrom(String s) {

		if (s.length() == 0 || s.length() == 1) {
			return true;
		}

		char start = s.charAt(0);
		char end = s.charAt(s.length() - 1);

		if (start != end) {
			return false;
		}

		if (s.length() == 2 && start == end) {
			return true;
		}

		return isPalindrom(s.substring(1, s.length() - 2));
	}
}
