package qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;

public class ProblemBSolver {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		List<String> result = solve(args[0]);

		for(String s : result) {
			System.out.println(s);
		}
		
		writeToDisk(result);
	}
	private static void writeToDisk(List<String> result) throws IOException {
		File f = new File("F:/home/code/output.txt");
		BufferedWriter w = null;
		try {
			w = new BufferedWriter(new FileWriter(f));
			
			for(String s : result) {
				w.write(s + "\n");
			}
			w.flush();
		} finally {
			if(w != null) {
				w.close();
			}
		}
	}

	
	private static List<String> solve(String filename) throws IOException {
		List<String> result = new ArrayList<>();

		File f = new File(filename);
		BufferedReader reader = new BufferedReader(new FileReader(f));

		String sizeString = reader.readLine();
		int size = Integer.parseInt(sizeString);

		for (int i = 0; i < size; i++) {
			System.out.println("-------------------------");
			String output = null;
			String line = reader.readLine();
			String[] splitted = line.split(" ");
			int rows = Integer.parseInt(splitted[0]);
			int columns = Integer.parseInt(splitted[1]);
			int[][] matrix = new int[rows][columns];
			
			for(int j = 0; j < rows; j++) {
				line = reader.readLine();
				splitted = line.split(" ");
				for(int k = 0; k < splitted.length; k++) {
					matrix[j][k] = Integer.parseInt(splitted[k]);
				}
			}
	
			for(int j = 1; j < matrix.length - 1; j++) {
				for(int k = 1; k < matrix[j].length - 1; k++) {
					if(checkRow(matrix, j, k) || checkColumn(matrix, j, k)) {
						output = "NO";
						break;
						
					}
				}
				
				if(output != null) {
					break;
				}
			}
		
			if(output == null) {
				result.add(MessageFormat.format("Case #{0}: YES", i+1));
			} else {
				result.add(MessageFormat.format("Case #{0}: NO", i+1));
			}
		}
		
		
		return result;
	}

	
	private static boolean checkRow(int[][] matrix, int row, int column) {
		for(int i = 0; i < matrix[row].length; i++) {
			if(matrix[row][column] < matrix[row][i]) {
				return true;
			}
		}
		
		return false;
	}
	
	private static boolean checkColumn(int[][] matrix, int row, int column) {
		for(int i = 0; i < matrix.length; i++) {
			if(matrix[row][column] < matrix[i][column]) {
				return true;
			}
		}
		
		return false;
	}

}
