package Qualification.ProblemB;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ProblemB {
	
	public static class DataHolder {
		private List<String> opposite = new ArrayList<String>();
		private Map<String, String> combine = new HashMap<String, String>();
		private String input = null;
	}
	
	public static void main(String[] args) {
		List<DataHolder> input = importFile(new File(args[0]));
		List<String> output = new ArrayList<String>();
		for(int i = 0; i < input.size(); i++) {
			char[] result = solve(input.get(i)).toCharArray();
			StringBuilder resultString = new StringBuilder(result.length);
			
			for(int j = 0; j < result.length; j++) {
				resultString.append(result[j] + ", ");
			}
			
			String resultAsString = "";
			if(resultString.length() > 2) {
				resultAsString = resultString.toString().substring(0, resultString.toString().length() - 2);
			}
			
			output.add("Case #" + (i+1) + ": [" + resultAsString + "]");
			resultString = null;
		}
		
		for(int i = 0; i < output.size(); i++) {
			System.out.print(output.get(i));
		}
		
		writeToFile(output);
 	}
	
	
	public static void writeToFile(List<String> output) {
		BufferedWriter writer = null;
		try {
			writer = new BufferedWriter(new FileWriter(new File("output.txt")));
			for(int i = 0; i < output.size(); i++) {
				writer.write(output.get(i) + "\n");
			}
		
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally{
			if(writer != null) {
				try {
					writer.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		
	}

	public static String solve(DataHolder holder) {
		String result = "";
		char[] input = holder.input.toCharArray();
		boolean finished = false;
		
		for(int j = 0; j < input.length; j++) {
			char actualChar = input[j];
			result += actualChar;
			
			if(result.length() < 2) {
				continue;
 			} else {
 				String ending = result.substring(result.length() - 2);
 				if(holder.combine.containsKey(ending)) {
 					result = result.substring(0, result.length() - 2) + holder.combine.get(ending);
 				}

 				for(int i = 0; i < holder.opposite.size(); i++) {
 					if(containsAll(result, holder.opposite.get(i))) {
 						result = "";
 					}
 				}
			}
		}
		
		System.out.println(result);
		return result;
	}
	
	public static boolean containsAll(String input, String value) {
		char[] valueArray = value.toCharArray();
		char[] inputArray = input.toCharArray();
		boolean containsFirst = false;
		boolean containsSecond = false;

		for(int i = 0; i < inputArray.length; i++) {
			if(inputArray[i] == valueArray[0]) {
				containsFirst = true;
			} 
			if(inputArray[i] == valueArray[1]) {
				containsSecond = true;
			} 
		}
		
		return containsFirst && containsSecond;
	}
	
	public static List<DataHolder> importFile(File file) {
		BufferedReader reader = null;
		List<DataHolder> imported = new ArrayList<DataHolder>();
		try {
			reader = new BufferedReader(new FileReader(file));
			int count = Integer.parseInt(reader.readLine());
			
			for(int i = 0; i < count; i++) {
				int counter = 0;
				DataHolder row = new DataHolder();
				String inputLine = reader.readLine();
				String[] inputLineSplitted = inputLine.split(" ");
				int c = Integer.parseInt(inputLineSplitted[counter++]);
				
				for(int j = 0; j < c; j++) {
					String combinesString = inputLineSplitted[counter++];
					String key = combinesString.substring(0, 2);
					String value = combinesString.substring(2);
					row.combine.put(key, value);
					row.combine.put(reverse(key), value);
				}
				
				int d = Integer.parseInt(inputLineSplitted[counter++]);
				
				for(int j = 0; j < d; j++) {
					String opposite = inputLineSplitted[counter++];
					row.opposite.add(opposite);
				}
				
				int n = Integer.parseInt(inputLineSplitted[counter++]);
				row.input = inputLineSplitted[counter];
				imported.add(row);
			}
			
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			if(reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	
		return imported;
	}
	
	public static String reverse(String input) {
		char[] array = input.toCharArray();
		String result = "";
		
		for(int i = array.length-1; i >= 0;i--) {
			result += array[i];
		}
		
		return result;
	}
	
}
