package qualification.problemB;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.MessageFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class ProblemBSolver {
	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		List<String> answers = solve(args[0]);

		for (String answer : answers) {
			System.out.println(answer);
		}

		writeToDisk(answers);
	}

	private static void writeToDisk(List<String> result) throws IOException {
		File f = new File("F:/home/code/output.txt");
		BufferedWriter w = null;
		try {
			w = new BufferedWriter(new FileWriter(f));
			
			for(String s : result) {
				w.write(s + "\n");
			}
			w.flush();
		} finally {
			if(w != null) {
				w.close();
			}
		}
		
		
	}

	private static List<String> solve(String filename) throws IOException {
		List<String> result = new ArrayList<>();

		File file = new File(filename);
		BufferedReader reader = new BufferedReader(new FileReader(file));

		String sizeString = reader.readLine();
		int size = Integer.parseInt(sizeString);

		for (int i = 0; i < size; i++) {
			String line = reader.readLine();
			String[] values = line.split(" ");
			
			double c = Double.parseDouble(values[0]);
			double f = Double.parseDouble(values[1]);
			double x = Double.parseDouble(values[2]);
			double actualSpeed = 2;
			double timeTaken = 0;
			boolean finished = false;
			
			while(!finished) {
				double timeNeededToSuceed = x / actualSpeed;
				double timeNeededToSuceedNextFarm = x / (actualSpeed + f) + c / (actualSpeed);
				
				if(timeNeededToSuceed < timeNeededToSuceedNextFarm) {
					finished = true;
					timeTaken += timeNeededToSuceed;
				} else {
					timeTaken += c / actualSpeed;
					actualSpeed += f;
				}
			}

			timeTaken = Math.round(timeTaken * Math.pow(10, 7)) / Math.pow(10, 7);
			
			String[] timeTakenString = String.valueOf(timeTaken).split("\\.");
			
			String timeTakenFormatted = "";
			if(timeTakenString.length > 1) {
				while(timeTakenString[1].length() < 7) {
					timeTakenString[1] += "0";
				}
				
				timeTakenFormatted = timeTakenString[0] + "." + timeTakenString[1];
			} else {
				timeTakenFormatted = timeTakenString[0] + ".0000000";
			}
			
			result.add(MessageFormat.format("Case #{0}: {1}", (i + 1), timeTakenFormatted));
		}

		return result;
	}
}
