package qualification.problemc;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class ProblemC {

	private class DataStructure {
		private int a;
		private int b;

		public DataStructure(int a, int b) {
			this.a = a;
			this.b = b;
		}
		
		public int getA() {
			return a;
		}

		public void setA(int a) {
			this.a = a;
		}

		public int getB() {
			return b;
		}

		public void setB(int b) {
			this.b = b;
		}

		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + getOuterType().hashCode();
			result = prime * result + (int) (a ^ (a >>> 32));
			result = prime * result + (int) (b ^ (b >>> 32));
			return result;
		}

		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			DataStructure other = (DataStructure) obj;
			if (!getOuterType().equals(other.getOuterType()))
				return false;
			if (a != other.a)
				return false;
			if (b != other.b)
				return false;
			return true;
		}

		private ProblemC getOuterType() {
			return ProblemC.this;
		}
		
		
		
	}

	private List<Integer> solve(List<DataStructure> input) {
		List<Integer> output = new ArrayList<Integer>();

		long start = System.currentTimeMillis();
		
		for (DataStructure structure : input) {
			Set<DataStructure> longs = new HashSet<DataStructure>();
			int a = structure.getA();
			int b = structure.getB();
			int result = 0;

			for (int i = a +1; i <= b; i++) {
				result += findRecycledCount(i, a, b, longs);
			}
			output.add(result);
			// Collections.sort(longs);
		}

		long end = System.currentTimeMillis();
		System.out.println(end - start);
		return output;
	}

//	private long findRecycledCount2(long number, long n, long m,
//			List<Long> longs) {
//		int result = 0;
//		String numberString = String.valueOf(number);
//		
//		for (int i = 1; i < String.valueOf(number).length(); i++) {
//
//			String last = numberString.substring(i + 1);
//			String first = numberString.substring(0, numberString.length() -i);
//			
//			String numberTemp = last + first;
//			long numberTempLong = Long.valueOf(numberTemp);
//			if (numberTempLong > number && numberTempLong >= n
//					&& numberTempLong < m) {
//				//longs.add(numberTempLong);
//				 System.out.println("added for " + number + " " + numberTempLong);
//				result++;
//			}
//		}
//
//		return result;
//	}

	private long findRecycledCount(int number, int n, int m, Set<DataStructure> longs) {
		int result = 0;
		String numberTemp = String.valueOf(number);

		for (int i = 0; i < String.valueOf(number).length(); i++) {

			char temp = numberTemp.charAt(0);
			numberTemp = numberTemp.substring(1) + temp;
			// System.out.println(numberTemp);
			int numberTempLong = Integer.valueOf(numberTemp);

			if (numberTempLong > number && numberTempLong >= n
					&& numberTempLong < m && !longs.contains(new DataStructure(number, numberTempLong))) {
				longs.add(new DataStructure(number, numberTempLong));
				//System.out.println("added for " + number + " " + numberTempLong);
				result++;
			}
		}

		return result;
	}

	private List<DataStructure> readFile(File f) {
		String nextLine = null;
		List<DataStructure> result = null;

		try {
			BufferedReader reader = new BufferedReader(new FileReader(f));

			while ((nextLine = reader.readLine()) != null) {
				if (result == null) {
					result = new ArrayList<DataStructure>();
				} else {
					String[] line = nextLine.split(" ");
					DataStructure structure = new DataStructure(Integer.parseInt(line[0]), Integer.parseInt(line[1]));
					result.add(structure);
				}
			}

			reader.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return result;

	}

	private void writeToDisk(List<Integer> output) {
		File f = new File("outputCsmall.txt");
		
		try {
			BufferedWriter writer = new BufferedWriter(new FileWriter(f));
			int counter = 1;
			for(int s : output) {
				writer.write("Case #" + counter + ": " + s + "\n");
				System.out.println("Case #" + counter + ": " + s + "\n");
				counter++;
			}
			writer.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		
	}

	public static void main(String[] args) {
		ProblemC c = new ProblemC();
		List<DataStructure> structures = c.readFile(new File(args[0]));
		List<Integer> longs = c.solve(structures);
		c.writeToDisk(longs);
	}

}
