import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;


public class Aufgabe3 {
	
	private int numberOfTestcases = 0;
	private List<Node> nodes = new ArrayList<Node>();
	private int cellNumbers = 0;
	private List<Integer> releasedNumbers = new ArrayList<Integer>();
	private List<String> resultSets = new ArrayList<String>();
	private List<Integer> resultList = new ArrayList<Integer>();
	
	private class Node {
		private List<Integer> remaining = new ArrayList<Integer>();
		public List<Integer> getRemaining() {
			return remaining;
		}
		public void setRemaining(List<Integer> remaining) {
			this.remaining = remaining;
		}
		public String getValues() {
			return values;
		}
		public void setValues(String values) {
			this.values = values;
		}
		private String values = "";
	}

	
	
	/**
	 * runs the application
	 * @param args
	 * 			args[0] input file with full path
	 * 			args[1] output file with full path
	 */
	public static void main(String[] args) {
		Aufgabe3 aufgabe = new Aufgabe3();
		String input = args[0];
		String output = args[1];
		StringBuffer buffer = new StringBuffer();
		
		aufgabe.readFile(input);
		int counter = 1;
		
		for(Integer integer : aufgabe.resultList) {
			buffer.append("Case #" + counter++ + ": " + integer + "\n");
		}
		
		aufgabe.writeFile(output, buffer.toString());
	}

	/**
	 * 
	 * writes outputfile to disk
	 * 
	 * @param file
	 *            name and path of the file given as parameter 1 in args-array
	 * @param text
	 *            text which ist written to the file system
	 */
	private void writeFile(String file, String text) {
		File f = new File(file);
		BufferedWriter writer = null;

		try {
			writer = new BufferedWriter(new FileWriter(f));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		if (writer != null) {
			try {
				writer.write(text);
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				try {
					writer.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}

	}
	

	List<Node> workingNodes = new ArrayList<Node>();
	/**
	 * reads an input file
	 * 
	 * @param file
	 *            input file given as first parameter of args (args[0])
	 */
	private void readFile(String file) {
		File f = new File(file);
		BufferedReader reader = null;
		try {
			reader = new BufferedReader(new FileReader(f));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}

		if (reader != null) {
			try {
				String line = null;
				line = reader.readLine();

				try {
					//reads number of test sentences
					numberOfTestcases = Integer.parseInt(line);
				} catch (NumberFormatException e) {
					e.printStackTrace();
				}

				for (int i = 0; i < numberOfTestcases; i++) {
					line = reader.readLine();
					
					String[] splitter = line.split(" ");
					cellNumbers = Integer.parseInt(splitter[0]);

					line = reader.readLine();
					splitter = line.split(" ");
					for(String s : splitter) {
						releasedNumbers.add(Integer.parseInt(s));
					}
					
					for(Integer n : releasedNumbers) {
						Node node = new Node();
						node.setValues(String.valueOf(n) + " ");
						List<Integer> list = new ArrayList<Integer>();
						list.addAll(releasedNumbers);
						list.remove(n);
						node.getRemaining().addAll(list);	
						workingNodes.add(node);
					}
				
					while(workingNodes.size() > 0) {
						Node n = workingNodes.remove(0);

						if(n.getRemaining().size() > 0) {
							for(Integer nextNumber : n.getRemaining()) {
								String string = n.getValues() + nextNumber + " ";
								List<Integer> nextList = new ArrayList<Integer>();
								nextList.addAll(n.getRemaining());
								nextList.remove(nextNumber);
								Node newNode = new Node();
								newNode.setValues(string);
								newNode.setRemaining(nextList);
								workingNodes.add(newNode);
							}
						}
						else {
							resultSets.add(n.getValues());
						}
					}

					int result = Integer.MAX_VALUE;
					int resultTemp = 0;
					
					for(String stringNumber : resultSets) {
						String[] splitterTemp = stringNumber.split(" ");
						boolean[] cells = new boolean[cellNumbers];
						
						for(int j = 0; j < cells.length; j++) {
							cells[j] = true;
						}
						int prisoner = 0;
						
						for(String s: splitterTemp) {
							prisoner = Integer.parseInt(s);
							prisoner--;
							cells[prisoner] = false;
							resultTemp += calcGold(cells, prisoner); 
						}
						
						result = Math.min(result, resultTemp);
						resultTemp = 0;
						
					}
					
					resultList.add(result);
					result = Integer.MAX_VALUE;
					resultSets = new ArrayList<String>();
					releasedNumbers = new ArrayList<Integer>();
					
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	
	private int calcGold(boolean[] cells, int cell) {
		
		int gold = 0;
		
		for(int i = cell-1; i >= 0 && cells[i] != false; i--) {
			gold++;
		}
		
		for(int i = cell + 1; i < cells.length && cells[i] != false; i++) {
			gold++;
		}
		
		return gold;
	}
	
	

	
}
