package Qualification.ProblemA;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class ProblemA {
	private int nextPositionOrange;
	private int nextPositionBlue;
	private int positionOrange = 1;
	private int positionBlue = 1;
	private String nextAction = null;
	private String[] nextActionSplitted = null;
	private boolean orange = true;

	public int solve(List<String> schedule) {
		int usedSeconds = 0;
		boolean pressedOrange = false;
		boolean pressedBlue = false;
		if (nextAction == null) {
			getNextMoves(schedule);
		}

		while (!schedule.isEmpty() || nextAction != null) {
			pressedOrange = false;
			pressedBlue = false;
			usedSeconds++;
			if (orange && nextPositionOrange == positionOrange) {
				System.out.println("Orange pressed Button " + positionOrange);
				pressedOrange = true;
				nextAction = null;
				getNextMoves(schedule);
			} else if (!pressedOrange && !orange
					&& nextPositionBlue == positionBlue) {
				System.out.println("Blue pressed Button " + positionBlue);
				nextAction = null;
				getNextMoves(schedule);
				pressedBlue = true;
			}

			if (!pressedOrange && nextPositionOrange > positionOrange) {
				positionOrange++;
				pressedOrange = true;
				System.out.println("Moving Orange to Position "
						+ positionOrange);
			}
			if (!pressedOrange && nextPositionOrange < positionOrange) {
				pressedOrange = true;
				positionOrange--;
				System.out.println("Moving Orange to Position "
						+ positionOrange);
			}

			if (!pressedBlue && nextPositionBlue > positionBlue) {
				pressedBlue = true;
				positionBlue++;
				System.out.println("Moving Blue to Position " + positionBlue);
			}

			if (!pressedBlue && nextPositionBlue < positionBlue) {
				pressedBlue = true;
				positionBlue--;
				System.out.println("Moving Blue to Position " + positionBlue);
			}
			if (!pressedBlue && nextPositionBlue == positionBlue) {
				pressedBlue = true;
				System.out.println("Staying Blue to Position " + positionBlue);
			}
			if (!pressedOrange && nextPositionOrange == positionOrange) {
				pressedOrange = true;
				System.out.println("Staying Orange to Position " + positionOrange);
			}
			
			System.out.println("---");
		}

		System.out.println("Used Seconds: " + usedSeconds);
		return usedSeconds;
	}

	private void getNextMoves(List<String> schedule) {
		if(schedule.size() == 0) {
			return;
		}
		
		nextAction = schedule.get(0);
		if (nextAction.startsWith("O")) {
			orange = true;
		} else {
			orange = false;
		}

		for (int i = 0; i < schedule.size(); i++) {
			if (schedule.get(i).startsWith("O")) {
				nextPositionOrange = Integer.parseInt(schedule.get(i)
						.split(" ")[1]);
				break;
			}
		}
		for (int i = 0; i < schedule.size(); i++) {
			if (schedule.get(i).startsWith("B")) {
				nextPositionBlue = Integer
						.parseInt(schedule.get(i).split(" ")[1]);
				break;
			}
		}

		schedule.remove(0);
	}

	public static void main(String[] args) {
		List<List<String>> input = importFile(new File(args[0]));
		List<String> output = new ArrayList<String>();
		
		for(int i = 0; i < input.size(); i++) {
			ProblemA a = new ProblemA();
			output.add("Case #" + (i+1) + ": " + a.solve(input.get(i)));
		}
		
		writeToFile(output);
	}

	public static void writeToFile(List<String> output) {
		BufferedWriter writer = null;
		try {
			writer = new BufferedWriter(new FileWriter(new File("output.txt")));
			for(int i = 0; i < output.size(); i++) {
				writer.write(output.get(i) + "\n");
			}
		
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally{
			if(writer != null) {
				try {
					writer.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		
	}
	
	public static List<List<String>> importFile(File file) {
		BufferedReader reader = null;
		List<List<String>> imported = new ArrayList<List<String>>();
		try {
			reader = new BufferedReader(new FileReader(file));
			int count = Integer.parseInt(reader.readLine());
			
			for(int i = 0; i < count; i++) {
				List<String> row = new ArrayList<String>();
				String inputLine = reader.readLine();
				String[] splittedinputLine = inputLine.split(" ");
				
				for(int j = 1; j < splittedinputLine.length; j = j+2) {
					row.add(new String(splittedinputLine[j] + " " + splittedinputLine[j + 1]));
				}
				
				imported.add(row);
			}
			
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			if(reader != null) {
				try {
					reader.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	
		return imported;
	}
	
	public int getNextPositionOrange() {
		return nextPositionOrange;
	}

	public int getNextPositionBlue() {
		return nextPositionBlue;
	}

	public void setNextPositionOrange(int nextPositionOrange) {
		this.nextPositionOrange = nextPositionOrange;
	}

	public void setNextPositionBlue(int nextPositionBlue) {
		this.nextPositionBlue = nextPositionBlue;
	}

	public int getPositionOrange() {
		return positionOrange;
	}

	public int getPositionBlue() {
		return positionBlue;
	}

	public void setPositionOrange(int positionOrange) {
		this.positionOrange = positionOrange;
	}

	public void setPositionBlue(int positionBlue) {
		this.positionBlue = positionBlue;
	}
}
