import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * 
 */

/**
 * @author b117
 * 
 */
public class WelcomeToCodeJam {

	/**
	 * holds number of test sentences
	 */
	private int numberOfSentences;
	/**
	 * holds test sentences
	 */
	private List<String> listSentences = null;
	public int getNumberOfSentences() {
		return numberOfSentences;
	}

	public void setNumberOfSentences(int numberOfSentences) {
		this.numberOfSentences = numberOfSentences;
	}

	public List<String> getListSentences() {
		return listSentences;
	}

	public void setListSentences(List<String> listSentences) {
		this.listSentences = listSentences;
	}

	public List<String> getListUsed() {
		return listUsed;
	}

	public void setListUsed(List<String> listUsed) {
		this.listUsed = listUsed;
	}

	public static Pattern getP() {
		return p;
	}

	public static void setP(Pattern p) {
		WelcomeToCodeJam.p = p;
	}

	public int getResult() {
		return result;
	}

	public void setResult(int result) {
		this.result = result;
	}

	/**
	 * holds visited test sentences
	 */
	private List<String> listUsed = null;
	/**
	 * holds the pattern with the specific regular expression to test a test
	 * sentence
	 */
	private static Pattern p = Pattern
			.compile("[a-z ]*w[a-z ]*e[a-z ]*l[a-z ]*c[a-z ]*o[a-z ]*m[a-z ]*e[a-z ]* [a-z ]*t[a-z ]*o[a-z ]* [a-z ]*c[a-z ]*o[a-z ]*d[a-z ]*e[a-z ]* [a-z ]*j[a-z ]*a[a-z ]*m[a-z ]*");

	/**
	 * counter how often the regular expression matches a test sentence
	 */
	private int result;

	/**
	 * init of the variables
	 */
	public WelcomeToCodeJam() {
		numberOfSentences = 0;
		listSentences = new ArrayList<String>();
		listUsed = new ArrayList<String>();
	}

	/**
	 * reads an input file
	 * 
	 * @param file
	 *            input file given as first parameter of args (args[0])
	 */
	private void readFile(String file) {
		File f = new File(file);
		BufferedReader reader = null;
		try {
			reader = new BufferedReader(new FileReader(f));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}

		if (reader != null) {
			try {
				String line = null;
				line = reader.readLine();

				try {
					//reads number of test sentences
					numberOfSentences = Integer.parseInt(line);
				} catch (NumberFormatException e) {
					e.printStackTrace();
				}

				for (int i = 0; i < numberOfSentences; i++) {
					line = reader.readLine();
					// add sentence
					listSentences.add(line + "\r");
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	/**
	 * 
	 * searches the string in a test sentence
	 * 
	 * for this a tree-like structure is built up for searching
	 * 
	 * @param text
	 *            test sentence
	 */
	private void search(String text) {

		//sentence is already counted
		if (listUsed.contains(text)) {
			return;
		}

		// the matching string has to start with character 'w'
//		while (!text.startsWith("w") && text.length() > 0) {
//			text = text.substring(1);
//		}

		text = text.replaceAll("[^welcomtdja ]", "");

		
		//no matching characters left
		if (text.length() == 0) {
			return;
		}
	
		Matcher m = p.matcher(text);
		//test the sentence
		if (m.matches()) {
			//sentence found 
			//count
			result++;
			//add to visited sentences
			listUsed.add(text);

			//search for next character to leave out -
			//build up tree structure
			int indexOf0 = text.indexOf('w', 0);
			int indexOf1 = text.indexOf('e', indexOf0);
			int indexOf2 = text.indexOf('l', indexOf1);
			int indexOf3 = text.indexOf('c', indexOf2);
			int indexOf4 = text.indexOf('o', indexOf3);
			int indexOf5 = text.indexOf('m', indexOf4);
			int indexOf6 = text.indexOf('e', indexOf5);
			int indexOf7 = text.indexOf(' ', indexOf6);
			int indexOf8 = text.indexOf('t', indexOf7);
			int indexOf9 = text.indexOf('o', indexOf8);
			int indexOf10 = text.indexOf(' ', indexOf9);
			int indexOf11 = text.indexOf('c', indexOf10);
			int indexOf12 = text.indexOf('o', indexOf11);
			int indexOf13 = text.indexOf('d', indexOf12);
			int indexOf14 = text.indexOf('e', indexOf13);
			int indexOf15 = text.indexOf(' ', indexOf14);
			int indexOf16 = text.indexOf('j', indexOf15);
			int indexOf17 = text.indexOf('a', indexOf16);
			int indexOf18 = text.indexOf('m', indexOf17);

			//run search without a matching character to get a new test sentence
			// do this recursivly if more sentence still matches the sentence
			StringBuffer buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf0);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf1);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf2);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf3);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf4);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf5);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf6);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf7);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf8);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf9);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf10);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf11);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf12);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf13);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf14);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf15);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf16);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf17);
			search(buffer.toString());

			buffer = new StringBuffer(text);
			buffer.deleteCharAt(indexOf18);
			search(buffer.toString());//
		}
	}

	/**
	 * 
	 * writes outputfile to disk
	 * 
	 * @param file
	 *            name and path of the file given as parameter 1 in args-array
	 * @param text
	 *            text which ist written to the file system
	 */
	private void writeFile(String file, String text) {
		File f = new File(file);
		BufferedWriter writer = null;

		try {
			writer = new BufferedWriter(new FileWriter(f));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		if (writer != null) {
			try {
				writer.write(text);
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				try {
					writer.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}

	}

	/**
	 * runs the application
	 * @param args
	 * 			args[0] input file with full path
	 * 			args[1] output file with full path
	 */
	public static void main(String[] args) {
		WelcomeToCodeJam jam = new WelcomeToCodeJam();
		//read file
		jam.readFile(args[0]);
		
		StringBuffer buffer = new StringBuffer();
		//test sentences
		for (int i = 0; i < jam.getListSentences().size(); i++) {
			jam.search(jam.getListSentences().get(i));

			//write output into StringBuffer
			buffer.append("Case #" + (i+1) + ": "
					+ new DecimalFormat("0000").format(jam.getResult()) + "\n");
			// get ready for next test
			jam.result = 0;
			jam.listUsed = new ArrayList<String>();
			
		}

		//write output
		jam.writeFile(args[1], buffer.toString());
	}

}

