import java.io.*;
import java.util.*;

public class ProbB {
    public static void main(String[] args) throws FileNotFoundException, IOException {
        ProbB p = new ProbB();
        p.solveAll();
    }
    int tests = 0;
    Scanner in;
    BufferedWriter out;
    public ProbB() throws FileNotFoundException, IOException {
        out = new BufferedWriter(new FileWriter("b.out"));
        in = new Scanner(new File("b.in"));
        tests = in.nextInt();
        //in.nextLine();
        //System.out.println(tests);
    }

    public void solveAll() throws IOException {
        for(int i = 0; i < tests; i++) {
            solve(i+1);
        }
        out.close();
        in.close();
    }
    public void solve(int casenr) throws IOException {
        String line = in.nextLine();
        out.write("Case #"+casenr+": ");
        //solve 
        ArrayList<Circle> cs = new ArrayList<Circle>();
        int n, w, l;
        n = in.nextInt();
        w = in.nextInt();
        l = in.nextInt();
        System.out.println("n:"+n);
        for(int i = 0; i < n; i++) {
            cs.add(new Circle(in.nextInt()));
        }
        //make first row
        for(int ix = 0; ix < cs.size(); ix++) {
            boolean ml, mt;
            cs.get(ix).x = w;
            cs.get(ix).y = l;
            do {
                ml = moveLeft(ix, cs);
                mt = moveTop(ix, cs);
                System.out.println(ix+" moved to "+cs.get(ix).x+","+cs.get(ix).y);
            }while(ml || mt);
        }
        for(int i = 0; i < cs.size(); i++) {
            out.write(cs.get(i).x+" "+cs.get(i).y+" ");
        }
        //endsolve
        out.write('\n');
    }
    
    public boolean moveLeft(int it, ArrayList<Circle> others) {
        Circle c = others.get(it);
        int sy = c.y - c.r;
        int ey = c.y + c.r;
        int minx = 0;
        for(int i = 0; i < it; i++) {
            if(it != i) {
                int osy = others.get(i).y - others.get(i).r;
                int oey = others.get(i).y + others.get(i).r;
                if(osy <= ey && oey >= sy) {
                    minx = Math.max(minx, others.get(i).x+others.get(i).r);
                }
            }
        }
        int oldx = c.x;
        minx++;
        c.x = minx;
        return oldx != minx;
    }
    
    public boolean moveTop(int it, ArrayList<Circle> others) {
        Circle c = others.get(it);
        int sx = c.x - c.r;
        int ex = c.x + c.r;
        int miny = 0;
        for(int i = 0; i < it; i++) {
            if(it != i) {
                int osx = others.get(i).x - others.get(i).r;
                int oex = others.get(i).x + others.get(i).r;
                if(osx <= ex && oex >= sx) {
                    miny = Math.max(miny, others.get(i).y+others.get(i).r);
                }
            }
        }
        int oldy = c.y;
        miny++;
        c.y = miny;
        return oldy != miny;
    }
    
    class Circle implements Comparable<Circle> {
        int x;
        int y;
        int r;
        boolean isset = false;
        
        public Circle(int x, int y, int r) {
            this.x = x;
            this.y = y;
            this.r = r;
        }
        
        public Circle(int r) {
            this.r = r;
        }
        
        public int left(Circle oc) {
            return x+r+oc.r;
        }
        
        public int down(Circle oc) {
            return y+r+oc.r;
        }
        
        public int topleft(int or) {
            return 0;
        }

        @Override
        public int compareTo(Circle o) {
            return new Integer(o.r).compareTo(new Integer(r));
        }
    }
}