import java.io.*;
import java.util.*;

public class ProbC {
    public static void main(String[] args) throws FileNotFoundException, IOException {
        ProbC p = new ProbC();
        p.solveAll();
    }
    int tests = 0;
    Scanner in;
    BufferedWriter out;
    public ProbC() throws FileNotFoundException, IOException {
        out = new BufferedWriter(new FileWriter("c.out"));
        in = new Scanner(new File("c.in"));
        tests = in.nextInt();
    }

    public void solveAll() throws IOException {
        for(int i = 0; i < tests; i++) {
            solve(i+1);
        }
        out.close();
        in.close();
    }
    
    public int rr = 0;
    public int rc = 0;
    
    public int gr = 0;
    public int gc = 0;
    
    public void solve(int casenr) throws IOException {
        out.write("Case #"+casenr+":");
        //System.out.println("Case #"+casenr+":");
        out.write('\n');
        int r = in.nextInt();
        int c = in.nextInt();
        int m = in.nextInt();
        int[][] mat = new int[r][c];
        if(r*c-1 == m) {
            for(int i = 0; i < r; i++) {
                for(int j = 0; j < c; j++) {
                    if(i == 0 && j == 0)
                        out.write('c');
                    else out.write('*');
                }
                out.write('\n');
            }
        } else if(r >= 2 && c >= 2 && r*c-m < 4) {
            out.write("Impossible");
            out.write('\n');
        } else {
            //dafuq
            gr = rr = r;
            gc = rc = c;
            boolean res = solvable(r, c, m, mat);
            if(res && PlaceC(r, c, mat)) {
                for(int i = 0; i < r; i++) {
                    for(int j = 0; j < c; j++) {
                        if(i >= rr || j >= rc)
                            out.write("*");
                        else if(mat[i][j] == -2)
                            out.write("c");
                        else if(mat[i][j] == -1)
                            out.write("*");
                        else 
                            out.write(".");
                    }
                    out.write('\n');
                }
            } else {
                out.write("Impossible");
                out.write('\n');
            }
        }
    }
    
    public boolean solvable(int r, int c, int m, int[][] mat) {
        
        if(m == 0) {
           rr = r;
           rc = c;
           return true; 
        }
        if(m < 0 || r <= 0 || c <= 0 || r*c <= m)
            return false;
        
        if(r < 3 || c < 3) {
            if(trySolve(r, c, m, mat)) {
                rr = r;
                rc = c;
                return true;
            }
            return false;
        }
        if(solvable(r, c-1, m-r, mat))
            return true;
        if(solvable(r-1, c, m-c, mat))
            return true;
        
        if(m < r && m < c && trySolve(r, c, m, mat)) {
            rr = r;
            rc = c;
            return true;
        }
        return false;
    }
    
    public boolean PlaceC(int r, int c, int[][] mat) {
        for(int i = 0; i < rr; i++)
            for(int j = 0; j < rc; j++)
                if(mat[i][j] == 0) {
                    mat[i][j] = -2;
                    return true;
                }
        return false;
    }
    
    public void DebugMat(int r, int c, int m, int[][] mat) {
        System.out.println(m+"---");
        for(int i = 0; i < r; i++) {
            for(int j = 0; j < c; j++) {
                if(mat[i][j] == -1)
                    System.out.print('*');
                else if(mat[i][j] == 0)
                    System.out.print('.');
                else 
                    System.out.print('#');
            }
            System.out.println();
        }
        System.out.println();
        System.out.println();
    }
    
    public boolean trySolve(int r, int c, int m, int[][] mat) {
        //DebugMat(r, c, m, mat);
        if(m == 0) {
            return MatValid(r, c, mat);
        } else {
            for(int i = 0; i < r; i++) {
                for(int j = 0; j < c; j++) {
                    if(mat[i][j] == -1)continue;
                    PlaceBomb(i, j, r, c, mat, true);
                    boolean solved = trySolve(r, c, m-1, mat);
                    if(solved)return true;
                    PlaceBomb(i, j, r, c, mat, false);
                }
            }
            return false;
        }
    }
    
    public boolean MatValid(int r, int c, int[][] mat) {
        for(int i = 0; i < r; i++) {
            for(int j = 0; j < c; j++) {
                boolean valid = mat[i][j] == -1;
                for(int k = -1; k <= 1; k++) {
                    for(int l = -1; l <= 1; l++) {
                        if(IsValid(i+k, j+l, r, c) && mat[i+k][j+l] == 0)
                            valid = true;
                    }
                }
                if(!valid)
                    return false;
            }
        }
        return true;
    }
    
    public void FillRow(int pos, int[][] mat, int r, int c) {
        for(int i = 0; i < c; i++) {
            mat[pos][i] = -1;
        }
    }
    
    public void FillCol(int pos, int[][] mat, int r, int c) {
        for(int i = 0; i < r; i++) {
            mat[i][pos] = -1;
        }
    }
    
    public int CalcNr(int x, int y, int r, int c, int[][] mat) {
        if(mat[x][y] == -1)
            return -1;
        int nr = 0;
        if(IsBomb(x-1, y-1, r, c, mat))nr++;
        if(IsBomb(x-1, y,   r, c, mat))nr++;
        if(IsBomb(x-1, y+1, r, c, mat))nr++;
        if(IsBomb(x,   y-1, r, c, mat))nr++;
        if(IsBomb(x,   y+1, r, c, mat))nr++;
        if(IsBomb(x+1, y-1, r, c, mat))nr++;
        if(IsBomb(x+1, y,   r, c, mat))nr++;
        if(IsBomb(x+1, y+1, r, c, mat))nr++;
        return nr;
    }
    
    public boolean IsBomb(int x, int y, int r, int c, int[][] mat) {
        if(!IsValid(x, y, gr, gc))
            return false;
        else if(!IsValid(x, y, r, c))
            return true;
        return mat[x][y] == -1;
    }
    
    public void PlaceBomb(int x, int y, int r, int c, int[][] mat, boolean place) {
        if(!IsValid(x, y, r, c))
            return;
        mat[x][y] = (place)?-1:0;
        if(IsValid(x-1, y-1, r, c))mat[x-1][y-1] = CalcNr(x-1, y-1, r, c, mat);
        if(IsValid(x-1, y, r, c))mat[x-1][y] = CalcNr(x-1, y, r, c, mat);
        if(IsValid(x-1, y+1, r, c))mat[x-1][y+1] = CalcNr(x-1, y+1, r, c, mat);
        if(IsValid(x, y-1, r, c))mat[x][y-1] = CalcNr(x, y-1, r, c, mat);
        if(IsValid(x, y, r, c))mat[x][y] = CalcNr(x, y, r, c, mat);
        if(IsValid(x, y+1, r, c))mat[x][y+1] = CalcNr(x, y+1, r, c, mat);
        if(IsValid(x+1, y-1, r, c))mat[x+1][y-1] = CalcNr(x+1, y-1, r, c, mat);
        if(IsValid(x+1, y, r, c))mat[x+1][y] = CalcNr(x+1, y, r, c, mat);
        if(IsValid(x+1, y+1, r, c))mat[x+1][y+1] = CalcNr(x+1, y+1, r, c, mat);
    }
            
    public boolean IsValid(int x, int y, int r, int c) {
        return !(x < 0 || y < 0 || x >= r || y >= c);
    }
}