import java.io.*;
import java.util.*;

public class ProbA {
    public static void main(String[] args) throws FileNotFoundException, IOException {
        ProbA p = new ProbA();
        p.solveAll();
    }
    int tests = 0;
    Scanner in;
    PrintWriter out;
    
    public ProbA() throws FileNotFoundException, IOException {
        out = new PrintWriter(new FileWriter("a.out"));
        in = new Scanner(new File("a.in"));
        tests = in.nextInt();
    }

    public void solveAll() throws IOException {
        in.nextLine();
        for(int i = 0; i < tests; i++) {
            solve(i+1);
        }
        out.close();
        in.close();
    }
    public void solve(int casenr) throws IOException {
        out.print("Case #"+casenr+": ");
        int n = in.nextInt();
        String[] words = new String[n];
        int[] count = new int[n];
        int[] pos = new int[n];
        for(int i = 0; i < n; i++) {
            words[i] = in.next();
        }
        boolean done = false;
        boolean possible = true;
        int moves = 0;
        while(!done) {
            char c = words[0].charAt(pos[0]);
            //test validity
            for(int i = 0; i < n; i++) {
                if(words[i].charAt(pos[i]) != c) {
                    done = true;
                    possible = false;
                }
            }
            //move pos
            int sum = 0;
            for(int i = 0; i < n; i++) {
                count[i] = 0;
                while(pos[i] < words[i].length() && words[i].charAt(pos[i]) == c) {
                    sum++;
                    pos[i]++;
                    count[i]++;
                }
            }
            long avg = Math.round(1.0*sum/n);
            for(int i = 0; i < n; i++) {
                moves += Math.abs(count[i] - avg);
            }
            int dones = 0;
            for(int i = 0; i < n; i++) {
                if(pos[i] >= words[i].length()) {
                    dones++;
                }
            }
            if(dones > 0) {
                done = true;
                if(dones < n)
                    possible = false;
            }
        }
        if(possible) {
            out.println(moves);
        } else {
            out.println("Fegla Won");
        }
    }

}