import com.sun.org.apache.xpath.internal.operations.Div;
import java.io.*;
import java.util.*;

public class ProbB {
    
    public static void main(String[] args) throws FileNotFoundException, IOException {
        ProbB p = new ProbB();
        p.solveAll();
    }
    int tests = 0;
    Scanner in;
    PrintWriter out;
    
    public ProbB() throws FileNotFoundException, IOException {
        out = new PrintWriter(new FileWriter("b.out"));
        in = new Scanner(new File("b.in"));
        tests = in.nextInt();
    }

    public void solveAll() throws IOException {
        for(int i = 0; i < tests; i++) {
            solve(i+1);
        }
        out.close();
        in.close();
    }
    public void solve(int casenr) throws IOException {
        out.print("Case #"+casenr+": ");
        int n = in.nextInt();
        ArrayList<Integer> list = new ArrayList<Integer>();
        for(int i = 0;i < n; i++) {
            AddToSortedList(list, in.nextInt());
        }
        out.println(Cost(list, GetSortedListMax(list)));
    }
    
    public int Cost(ArrayList<Integer> list, int max_cost) {
        int max = GetSortedListMax(list);
        int occurances = GetSortedListMaxOccurances(list);
        if(occurances > max_cost)
            return max;
        int proc_cost = Cost(ProcessList(list), max_cost - occurances) + occurances;
        return Math.min(max, proc_cost);
    }
    
    public void AddToSortedList(ArrayList<Integer> list, int nr) {
        int pos = Collections.binarySearch(list, nr);
        if(pos >= 0) {
            list.add(pos, Integer.valueOf(nr));
        } else {
            list.add(-pos-1, Integer.valueOf(nr));
        }
    }
    
    public int GetSortedListMax(ArrayList<Integer> list) {
        return list.get(list.size()-1).intValue();
    }
    
    public int GetSortedListMaxOccurances(ArrayList<Integer> list) {
        int count = 0;
        int max = GetSortedListMax(list);
        for(int i = list.size()-1; i >= 0 && list.get(i).intValue() == max; i--)
            count++;
        return count;
    }
    
    public ArrayList<Integer> ProcessList(ArrayList<Integer> list) {
        ArrayList<Integer> newlist = new ArrayList<Integer>();
        int max = GetSortedListMax(list);
        int occurances = GetSortedListMaxOccurances(list);
        int half1 = max/2;
        int half2 = max - half1;
        for(int i = 0; i < list.size() && list.get(i).intValue() < max; i++) {
            newlist.add(list.get(i));
        }
        for(int i = 0; i < occurances; i++) {
            AddToSortedList(newlist, half1);
            AddToSortedList(newlist, half2);
        }
        return newlist;
    }
}