package SpeakingInTongues;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;

import Practice.Item;

public class MainProcess {

	/**
	 * @param args
	 */
	
	private int numCase;
	// goo -> ori
	private Hashtable<Character , Character> lookup;
	private Hashtable<Character , Boolean> oriCheck;
	private Hashtable<Character , Boolean> gooCheck;
	private String [] gooStr;
	private String [] oriStr;

	public MainProcess(File f){
		initialize();
		
		createLookup();
		findLost();
		
		readFile(f);
		translate();
	}
	
	private void initialize(){
		lookup = new Hashtable<Character , Character>();
		gooStr = new String[3];
		oriStr = new String[3];
		
		gooStr[0] = "ejp mysljylc kd kxveddknmc re jsicpdrysi";
		oriStr[0] = "our language is impossible to understand";
		
		gooStr[1] = "rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd";
		oriStr[1] = "there are twenty six factorial possibilities";
		
		gooStr[2] = "de kr kd eoya kw aej tysr re ujdr lkgc jv";
		oriStr[2] = "so it is okay if you want to just give up";
		
		gooCheck = new Hashtable<Character , Boolean>();
		oriCheck = new Hashtable<Character , Boolean>();
		for(char c='a' ; c<='z' ; c = (char) (c+1)){
			gooCheck.put(c, true);
			oriCheck.put(c, true);
		}
	}
	
	private void createLookup(){
		for(int i=0 ; i<gooStr.length ; i++){
			for(int j=0 ; j<gooStr[i].length() ; j++ ){
			
				char g = gooStr[i].charAt(j);
				char o = oriStr[i].charAt(j);
				
				lookup.put(g, o);
				
				gooCheck.remove(g);
				oriCheck.remove(o);
			}
		}
		
		lookup.put('y','a');
		lookup.put('e','o');
		lookup.put('q','z');
		
		gooCheck.remove('y');
		gooCheck.remove('e');
		gooCheck.remove('q');
		oriCheck.remove('a');
		oriCheck.remove('o');
		oriCheck.remove('z');
		
		Enumeration<Character> keys = lookup.keys();
		int count = 0;
		while(keys.hasMoreElements()){
			char key = keys.nextElement();
			char ori = lookup.get(key);
			//System.out.println(key + " -> " + ori);
			count++;
		}
		
		//System.out.println(count);
	}
	
	private void findLost(){
		char g = ' ';
		char o = ' ';
		
		Enumeration<Character> keys = gooCheck.keys();
		while(keys.hasMoreElements()){
			g = keys.nextElement();
		}
		
		keys = oriCheck.keys();
		while(keys.hasMoreElements()){
			o = keys.nextElement();
		}
		lookup.put(g, o);
	}
	
	private void readFile(File f){
		try {
			FileReader fr = new FileReader(f);
			BufferedReader br = new BufferedReader(fr);
			
			String str = "";
			
			if( (str = br.readLine())!=null){
				numCase = Integer.parseInt(str);
			}
			
			gooStr = new String[numCase];
			
			int count = 0;
			while( count < numCase){
				str = br.readLine();
				gooStr[count] = str;
				
				count++;
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	private void translate(){
		for(int i=0 ; i<gooStr.length ; i++){
			String ans = "Case #" + (i+1) + ": ";
			
			for(int j=0 ; j<gooStr[i].length() ; j++ ){
				char q = gooStr[i].charAt(j);
				
				if(lookup.containsKey(q)){
					ans += lookup.get(q);
				}
				else{
					ans += "-";
				}
				
				
			}
			
			System.out.println(ans);
		}
			
	}
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		File f = new File(".\\src\\SpeakingInTongues\\A-small-attempt0.in");
		MainProcess m = new MainProcess(f);
	}

}
