package round1;

import java.io.*;
import java.util.*;

public class Prob2 {

    private static class Range implements Comparable<Range>
    {
        int min, max;

        public Range(int min, int max) {
            this.min = min;
            this.max = max;
        }

        @Override
        public int compareTo(Range range) {
            return min-range.min;
        }
    }
    private static Range getAproxValue(int totalGrams, int itemGrams)
    {
        if (itemGrams == 0)
            return new Range(0,1000000);
        if (totalGrams == 0)
            return null;
        double minValue = itemGrams*0.9;
        double maxValue = itemGrams*1.1;

        Range result = new Range((int)Math.ceil(totalGrams/maxValue), (int)Math.floor(totalGrams/minValue));
        if (totalGrams < result.min*minValue || totalGrams > result.max*maxValue )
            return null;
        return result;
    }

    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        if(args.length > 0 && args[0].equals("file")) {
            in = new Scanner(new BufferedReader(new FileReader("C:\\Users\\dinus\\codejam\\data\\inputA.txt")));
            System.setOut(new PrintStream("C:\\Users\\dinus\\codejam\\data\\out.txt"));
        }
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        in.nextLine();
        for (int i = 1; i <= t; ++i) {
            int n = in.nextInt();
            int p = in.nextInt();
            int[] grams = new int[n];
            for (int j=0; j<n; j++)
                grams[j] = in.nextInt();
            List<List<Range>> ranges = new ArrayList<List<Range>>();
            for (int j=0; j<n; j++)
            {
                ranges.add(new ArrayList<>());
                for (int k=0; k<p; k++) {
                    Range range = getAproxValue(in.nextInt(), grams[j]);
                    if (range != null)
                        ranges.get(j).add(range);
                }
                Collections.sort(ranges.get(j));
            }
            int[] index = new int[n];
            int packs = 0;
            boolean stop = false;
            while (!stop) {
                boolean canCreatePack = true;
                int min = 0;
                int max = 1000000;
                int highesMin = 0;
                for (int j=0; j<n; j++)
                {
                    //for each ingredient try to put in a pack.
                    if (index[j] >= ranges.get(j).size())
                    {
                        stop = true;
                        break;
                    }
                    Range range = ranges.get(j).get(index[j]);
                    if (canCreatePack)
                    {
                        if(range.min > max || range.max < min)
                        {
                            canCreatePack = false;
                        } else {
                            if (range.min > min)
                                min = range.min;
                            if (range.max < max)
                                max = range.max;
                        }
                    }
                    if (range.min > highesMin)
                        highesMin = range.min;
                }
                if (stop)
                    break;
                if (canCreatePack)
                {
                    for (int j=0; j<n; j++)
                        index[j]++;
                    packs++;
                } else {
                    for (int j=0; j<n; j++)
                    {
                        Range range = ranges.get(j).get(index[j]);
                        while(index[j] < ranges.get(j).size() && range.max < highesMin)
                            index[j]++;

                    }
                }

            }
            System.out.println("Case #" + i + ": " + packs );
        }
//        out.close();

    }
}
