package fr.diodfr.y2011.round1.B;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class Exo1 {

	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;

	public Exo1(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		String nextLine = fileScanner.nextLine();
		//		System.out.println("Exo2.nextLine():" + nextLine);
		lineScanner = new Scanner(nextLine);
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}


	private void computeCase(String outPutFileName) throws IOException {
		BufferedWriter file = new BufferedWriter(new FileWriter(outPutFileName));

		for (int i = 0; i < numberOfCase; i++) {
			nextLine();
			String result = getResult();

			file.append("Case #" + (i + 1) + ":\n" + result);
			System.out.println("Case #" + (i + 1) + " :\n" + result);
			file.newLine();
		}
		file.close();
	}
	
	private String getResult() {
		int teamsCount = lineScanner.nextInt();
		int matches[][] = new int[teamsCount][teamsCount];
		for (int i = 0; i < teamsCount; i++) {
			nextLine();
			String matchesForThisTeam = lineScanner.next();
			
			for (int j = 0; j < teamsCount; j++) {
				char result = matchesForThisTeam.charAt(j);
				
				if (result == '.') {
					matches[i][j] = -1;
				} else {
					matches[i][j] = Integer.valueOf(result) - Integer.valueOf('0');
				}
			}
		}
		
		double owp[] = new double[teamsCount];
		
		for (int i = 0; i < teamsCount; i++) {
			int countMatches = 0;
			owp[i] = 0;
			for (int j = 0; j < teamsCount; j++) {
				if (matches[i][j] >= 0) {
					countMatches ++;
					owp[i] += wp(matches[j], i);
				}
			}
			
			owp[i] /= countMatches;
		}
		
		StringBuilder result = new StringBuilder();
		
		for (int i = 0; i < teamsCount; i++) {
			double rpi = 0.25 * wp(matches[i], -1) + 0.5 * owp[i] + 0.25 * oowp(matches[i], owp);
			result.append(rpi);
			
			if (i+1 != teamsCount) {
				result.append("\n");
			}
		}
		
		return result.toString();
	}

	private double oowp(int[] matches, double[] owp) {
		int countMatches = 0;
		double oowp = 0;
		
		for (int j = 0; j < matches.length; j++) {
			if (matches[j] >= 0) {
				countMatches ++;
				oowp += owp[j];
			}
		}
		
		return oowp/countMatches;
	}

	double wp(int matches[], int excludedIndex) {
		double result = 0;
		int count = 0;
		for (int i = 0; i < matches.length; i++) {
			if (matches[i] >= 0 && (excludedIndex != i)) {
				result += matches[i];
				count++;
			}
		}
		
		return result/count;
	}

	public static void main(String[] args) {

		Exo1 exo = new Exo1("/home/didier/Téléchargements/A-large.in");

		try {
			exo.computeCase("/home/didier/Téléchargements/A-large.out");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
