package gcj2016.p2;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;


public class PB2 {

	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;
	private BufferedWriter outputFile;

	public void init(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}

	private void computeCase(String fileName) throws IOException {
		outputFile = new BufferedWriter(new FileWriter(fileName));

		for (int i = 0; i < numberOfCase; i++) {
			outputFile.append("Case #" + (i+1) + ": " );
			System.out.print("Case #" + (i+1) + " ");
			String result = computeNextCase();
			outputFile.append(result);
			outputFile.newLine();
			System.out.println(result);
		}
		outputFile.close();
	}

	private String computeNextCase() {
		
		nextLine();
		int k = lineScanner.nextInt();
		int c = lineScanner.nextInt();
		int s = lineScanner.nextInt();
		
		System.out.println("PB2.computeNextCase() k" + k + "c" + c + "s" + s);
		int minS = k/c + (k%c == 0? 0: 1);
		if (s < minS) return "IMPOSSIBLE";
		
		StringBuilder result = new StringBuilder();
		BigInteger kBI = BigInteger.valueOf(k);
		BigInteger size = BigInteger.valueOf(minS*c).pow(c).divide(BigInteger.valueOf(minS));
		for (int i = 0; i < minS; i++) {
			if (i != 0) result.append(" ");
			BigInteger r = BigInteger.ONE;
			
			BigInteger maxLocal = size.multiply(BigInteger.valueOf(i));
			BigInteger compare = size.subtract(maxLocal);
			for (int j = 1; j < c; j++) {
				BigInteger rj = r.multiply(kBI.pow(Math.max(0, j - 2))).add(BigInteger.valueOf(j));
			
				if (rj.compareTo(compare) > 0) break;
				r = rj;
			}
			
			r = r.add(maxLocal);
			result.append(r);
		}
		
		return result.toString();
	}

	public static void main(String[] args) throws IOException {
		PB2 pb = null;
		try {
			String file = "./src/gcj2016/p2/D-small-attempt0";
			pb = new PB2();
			pb.init(file  + ".in");
			pb.computeCase(file + ".out");
		} finally {
			if (pb != null) {
				pb.close();
			}
		}
		
		/*
Case #1: 2
Case #2: 1
Case #3: IMPOSSIBLE
Case #4: 1 2
Case #5: 2 6
		 */
	}
}