package gcj2016;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class PB1 {

	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;
	private BufferedWriter outputFile;

	public void init(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}

	private void computeCase(String fileName) throws IOException {
		outputFile = new BufferedWriter(new FileWriter(fileName));

		for (int i = 0; i < numberOfCase; i++) {
			outputFile.append("Case #" + (i+1) + ": " );
			System.out.print("Case #" + (i+1) + " ");
			int result = computeNextCase();
			outputFile.append(Integer.toString(result));
			outputFile.newLine();
			System.out.println(result);
		}
		outputFile.close();
	}

	private int computeNextCase() {
		
		String chaine = fileScanner.nextLine();
		System.out.println("PB1.computeNextCase()" + chaine);
		int result = 0;
		char current = chaine.charAt(0);
		
		for (char element : chaine.toCharArray()) {
			if (element != current) {
				result ++;
				current = element;
			}
		}
		
		if (current == '-') result ++;
		return result;
	}

	public static void main(String[] args) throws IOException {
		PB1 pb = null;
		try {
			String file = "./src/gcj2016/B-large";
			pb = new PB1();
			pb.init(file  + ".in");
			pb.computeCase(file + ".out");
		} finally {
			if (pb != null) {
				pb.close();
			}
		}
	}
}