package fr.sfr.perso.broca.didier.gcj2010;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

public class Round1B_A {

	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;

	public Round1B_A(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}

	

	private void computeCase(String outPutFileName) throws IOException {
		BufferedWriter file = new BufferedWriter(new FileWriter(outPutFileName));

		for (int i = 0; i < numberOfCase; i++) {
			int n = Integer.valueOf(fileScanner.next());
			int m = Integer.valueOf(fileScanner.next());

			Set<String> existingPath = new HashSet<String>();
			existingPath.add("/");

			for (int j = 0; j < n; j++) {
				String path = fileScanner.next();
				for (String splitted : split(path)) {
					existingPath.add(splitted);
					System.out.println(splitted);
				}
			}

			int result = 0;

			for (int j = 0; j < m; j++) {
				String path = fileScanner.next();
				for (String splitted : split(path)) {
					if (!existingPath.contains(splitted)) {
						result ++;
						existingPath.add(splitted);
						System.out.println("A " + splitted);
					} else {
						System.out.println("S " + splitted);
					}
				}
			}

			file.append("Case #" + (i + 1) + ": " + result);
			System.out.println("Case #" + (i + 1) + " " + result);
			file.newLine();
		}
		file.close();
	}


	private List<String> split(String path) {
		List<String> result = new ArrayList<String>();
		StringBuilder builder = new StringBuilder("/");
		for (String splitted : path.split("/")) {
			if (!splitted.equals("")) {
				builder.append(splitted);
				result.add(builder.toString());
				builder.append("/");
			}
		}

		return result;
	}

	public static void main(String[] args) throws IOException {
		Round1B_A s = null;
		try {
			String file = "A-small-attempt1";
			s = new Round1B_A("/home/didier/codejam/" + file  + ".in");
			s.computeCase("/home/didier/codejam/" + file + ".out");
		} finally {
			if (s != null) {
				s.close();
			}
		}
	}
}
