package fr.diodfr.y2011.qual;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class Exo1 {
	
	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;

	public Exo1(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		String nextLine = fileScanner.nextLine();
//		System.out.println("Exo2.nextLine():" + nextLine);
		lineScanner = new Scanner(nextLine);
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}
	
	
	private void computeCase(String outPutFileName) throws IOException {
		BufferedWriter file = new BufferedWriter(new FileWriter(outPutFileName));

		for (int i = 0; i < numberOfCase; i++) {
			nextLine();
			int result = getResult();

			file.append("Case #" + (i + 1) + ": " + result);
			System.out.println("Case #" + (i + 1) + " : " + result);
			file.newLine();
		}
		file.close();
	}
	
	private int getResult() {
		
		int size = lineScanner.nextInt();
		
		int orangePos = 1;
		int orangeTime = 0;
		int bluePos = 1;
		int blueTime = 0;
		
		for (int i = 0; i < size; i++) {
			String element = lineScanner.next();
			int nextPos = lineScanner.nextInt();
			
			if ("O".equalsIgnoreCase(element)) {
				orangeTime = getTime(orangePos, orangeTime, blueTime, nextPos);
				orangePos = nextPos;
			} else {
				blueTime = getTime(bluePos, blueTime, orangeTime, nextPos);
				bluePos = nextPos;
			}
		}
		
		return Math.max(orangeTime, blueTime);
	}

	
	private int getTime(int currentPos, int currentTime, int otherRobotTime, int nextPos) {
		int distance = Math.abs(currentPos-nextPos);
		
		return Math.max(distance+currentTime, otherRobotTime) + 1;
	}

	public static void main(String[] args) {
		
		Exo1 exo = new Exo1("/home/didier/Téléchargements/A-small-attempt0.in");
	
		try {
			exo.computeCase("/home/didier/Téléchargements/A-small-attempt0.out");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
