package fr.diodfr.gcj2015.qualif;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.NavigableMap;
import java.util.Scanner;
import java.util.SortedMap;
import java.util.TreeMap;

/**
 */
public class Pb2 {
	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;
	private BufferedWriter outputFile;

	public void init(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}

	private void computeCase(String fileName) throws IOException {
		outputFile = new BufferedWriter(new FileWriter(fileName));

		
		for (int i = 0; i < numberOfCase; i++) {
			nextLine();
			outputFile.append("Case #" + (i+1) + ": " );
			System.out.print("Case #" + (i+1) + " ");
			int count = lineScanner.nextInt();
			nextLine();
			int result = computeNextCase(toInt(count, lineScanner));
			outputFile.append(result + "");
			outputFile.newLine();
			System.out.println(result);
		}
		outputFile.close();
	}

	private int computeNextCase(int[] numbers) {
		NavigableMap<Integer, Integer> map = createMap(numbers);
		int turn = 0;
		int accuMax = 0;
		int accuCount = 0;
		while (true) {
			int max = map.firstKey();
			if (max == 1) break;
			
			int maxDiv2 = max / 2;
			int maxDiv2PlusRemain = maxDiv2 + (max % 2);
			int countMax = map.get(max);
			NavigableMap<Integer, Integer> tailMap = map.tailMap(max, false);
			int next = 0;
			if (!tailMap.isEmpty()) {
				next = tailMap.firstKey();
			}
			
			if (max - Math.max(maxDiv2PlusRemain, next) < countMax+accuCount) {
				if (accuMax == 0) {
					accuMax = max;
				}
				
				accuCount += countMax;
				if (accuCount > accuMax) break;
			} else {
				if (accuMax != 0) {
					accuMax = 0;
					turn += accuCount;
				}
				turn += countMax;
			}
			
			addValue(tailMap, maxDiv2PlusRemain, countMax);
			addValue(tailMap, maxDiv2, countMax);
			map = tailMap;
		}
		
		return turn + Math.max(accuMax,1);
	}

	private NavigableMap<Integer, Integer> createMap(int[] numbers) {
		NavigableMap<Integer, Integer> result = new TreeMap<Integer, Integer>(Collections.reverseOrder());

		for (int i : numbers) {
			addValue(result, i, 1);
		}
		return result;
	}

	private void addValue(SortedMap<Integer, Integer> result, int i, int value) {
		Integer count = result.get(i);
		if (count == null) {
			count = 0;
		}
		result.put(i, count + value);
	}

	private int[] toInt(int size, Scanner scan) {
		int[] result = new int[size];
		for (int i = 0; i < result.length; i++) {
			result[i] = scan.nextInt();
		}
		return result;
	}

	public static void main(String[] args) throws IOException {
		Pb2 pb = null;
		try {
			String file = "B-small-attempt2";
			pb = new Pb2();
			pb.init("c:\\gcj2015\\" + file  + ".in");
			pb.computeCase("c:\\gcj2015\\" + file + ".out");
		} finally {
			if (pb != null) {
				pb.close();
			}
		}
	}

}
