package fr.diodfr.gcj2015.qualif;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.NavigableMap;
import java.util.Scanner;
import java.util.SortedMap;
import java.util.TreeMap;

/**
 */
public class Pb4 {
	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;
	private BufferedWriter outputFile;

	public void init(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}

	private void computeCase(String fileName) throws IOException {
		outputFile = new BufferedWriter(new FileWriter(fileName));

		
		for (int i = 0; i < numberOfCase; i++) {
			nextLine();
			outputFile.append("Case #" + (i+1) + ": " );
			System.out.print("Case #" + (i+1) + " ");
			boolean result = computeNextCase(lineScanner.nextInt(), lineScanner.nextInt(), lineScanner.nextInt());
			outputFile.append(result ? "GABRIEL" : "RICHARD");
			outputFile.newLine();
			System.out.println(result);
		}
		outputFile.close();
	}

	private boolean computeNextCase(int X, int C, int R) {
		if (X == 1) {
			return true;
		}
		
		if (C < X && R < X) {
			return false;
		}
		
		if (X == 4) {
			return C == 4 && R == 4
					|| C * R == 12;
		}
		
		if (X == 3) {
			if (C * R < 6) {
				return false;
			}
			return (C * R) % 3 == 0;
		}
		
		return (C * R) % 2 == 0;
	}

	public static void main(String[] args) throws IOException {
		Pb4 pb = null;
		try {
			String file = "D-small-attempt2";
			pb = new Pb4();
			pb.init("c:\\gcj2015\\" + file  + ".in");
			pb.computeCase("c:\\gcj2015\\" + file + ".out");
		} finally {
			if (pb != null) {
				pb.close();
			}
		}
	}

}
