package fr.diodfr.gcj2015.qualif;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

/**
 */
public class Pb1 {
	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;
	private BufferedWriter outputFile;

	public void init(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}

	private void computeCase(String fileName) throws IOException {
		outputFile = new BufferedWriter(new FileWriter(fileName));

		
		for (int i = 0; i < numberOfCase; i++) {
			nextLine();
			outputFile.append("Case #" + (i+1) + ": " );
			System.out.print("Case #" + (i+1) + " ");
			int result = computeNextCase(lineScanner.nextInt(), toInt(lineScanner.next().toCharArray()));
			outputFile.append(result + "");
			outputFile.newLine();
			System.out.println(result);
		}
		outputFile.close();
	}

	private int computeNextCase(int numberOfLevel, int[] S) {
		int currentApplause = 0;
		int friends = 0;
		
		for (int i = 0; i < S.length; i++) {
			if (currentApplause < i) {
				friends ++;
				currentApplause ++;
			}
			
			currentApplause += S[i];
		}
		return friends;
	}

	private int[] toInt(char[] charArray) {
		int[] result = new int[charArray.length];
		for (int i = 0; i < result.length; i++) {
			result[i] = charArray[i] - '0';
		}
		return result;
	}

	public static void main(String[] args) throws IOException {
		Pb1 pb = null;
		try {
			String file = "A-large";
			pb = new Pb1();
			pb.init("c:\\gcj2015\\" + file  + ".in");
			pb.computeCase("c:\\gcj2015\\" + file + ".out");
		} finally {
			if (pb != null) {
				pb.close();
			}
		}
	}

}
