

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class PB2 {

	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;
	private BufferedWriter outputFile;

	public void init(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}

	private void computeCase(String fileName) throws IOException {
		outputFile = new BufferedWriter(new FileWriter(fileName));

		for (int i = 0; i < numberOfCase; i++) {
			outputFile.append("Case #" + (i+1) + ": " );
			System.out.print("Case #" + (i+1) + " ");
			String result = computeNextCase();
			outputFile.append(result);
			outputFile.newLine();
			System.out.println(result);
		}
		outputFile.close();
	}

	private String computeNextCase() {
		
		String chaine = fileScanner.nextLine();
		
		System.out.println("PB2.computeNextCase()" + chaine);
		StringBuilder result = new StringBuilder();
		int previous = 0;
		for (int i = 0; i < chaine.length(); i++) {
			int current = chaine.charAt(i) - '0';
			
			if (current >= previous) {
				result.append(current);
				previous = current;
			} else {
				i--;
				
				for(; i >= 0; i--) {
					result.deleteCharAt(i);
					if (i == 0 || chaine.charAt(i-1) != chaine.charAt(i)) break;
				}
				
				int newValue = chaine.charAt(i) - '0' - 1;
				if (newValue > 0) result.append(newValue);
				
				i++;
				for (; i < chaine.length(); i++) {
					result.append(9);
				}
				
				return result.toString();
			}
		}
		
		return result.toString();
	}

	public static void main(String[] args) throws IOException {
		PB2 pb = null;
		try {
			String path = "/home/didier/Téléchargements/";
			String file = path + "B-small-attempt1";
			pb = new PB2();
			pb.init(file  + ".in");
			pb.computeCase(file + ".out");
		} finally {
			if (pb != null) {
				pb.close();
			}
		}
	}
}