package fr.sfr.perso.broca.didier.tools;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Formatter;
import java.util.Scanner;

public class WelcomeCodeJam {
	
	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;
	private String welcomeCodeJam = "welcome to code jam";
	
	public WelcomeCodeJam(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	public int getNumberOfCase() {
		return numberOfCase;
	}
	
	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}
	
	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}
	
	public boolean hasNext() {
		return lineScanner.hasNext();
	}
	
	public String next() {
		return lineScanner.next();
	}
	
	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}
	
	private void computeCase(String fileName) throws IOException {
		BufferedWriter file = new BufferedWriter(new FileWriter(fileName));
		
		for (int i = 0; i < numberOfCase; i++) {
			String result = String.format("%04d", computeNextCase());
			file.append("Case #" + (i+1) + ": " + result.substring(result.length()-4));
			
			file.newLine();
		}
		file.close();
	}
	
	private int computeNextCase() {
		String line = fileScanner.nextLine();
		
		return numberOfWelcome(line, 0);
	}

	private int numberOfWelcome(String line, int i) {
		int result = 0;
		int index = 0;
		while ((index = line.indexOf(welcomeCodeJam.charAt(i), index)) != -1) {
			if (i+1 == welcomeCodeJam.length()) {
				result ++;
			} else {
				result += numberOfWelcome(line.substring(index+1), i+1);
			}
			
			index ++;
		}

		return result;
	}

	public static void main(String[] args) throws IOException {
		WelcomeCodeJam s = null;
        try {
            String file = "test";
			s = new WelcomeCodeJam("D:\\" + file  + ".in");
            s.computeCase("D:\\" + file + ".out");
         } finally {
            if (s != null) {
                s.close();
            }
        }
    }
}
