

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

import com.google.common.collect.SortedMultiset;
import com.google.common.collect.TreeMultiset;


public class PB3 {

	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;
	private BufferedWriter outputFile;

	public void init(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}

	private void computeCase(String fileName) throws IOException {
		outputFile = new BufferedWriter(new FileWriter(fileName));

		for (int i = 0; i < numberOfCase; i++) {
			outputFile.append("Case #" + (i+1) + ": " );
			System.out.print("Case #" + (i+1) + " ");
			String result = computeNextCase();
			outputFile.append(result);
			outputFile.newLine();
			System.out.println(result);
		}
		outputFile.close();
	}

	private String computeNextCase() {
		
		int baths = fileScanner.nextInt();
		int people = fileScanner.nextInt();
		fileScanner.nextLine();
		
		SortedMultiset<Integer> set = TreeMultiset.create();
		set.add(baths);
		int max = baths;
		int min = baths;
		
		for (int i = 0; i < people; i++) {
			int current = set.lastEntry().getElement();
			set.remove(current);
			current--;
			min = current/2;
			set.add(min);
			max = min + current%2;
			set.add(max);
		}
		//FIXME size of space
		
		
		return max + " " + min;
	}

	public static void main(String[] args) throws IOException {
		PB3 pb = null;
		try {
			String path = "/home/didier/Téléchargements/";
			String file = path + "C-small-1-attempt0";
			pb = new PB3();
			pb.init(file  + ".in");
			pb.computeCase(file + ".out");
		} finally {
			if (pb != null) {
				pb.close();
			}
		}
	}
}