package fr.diodfr.gcj2014.qualif;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;


public class PB3 {

	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;
	private BufferedWriter outputFile;

	public void init(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}

	private void computeCase(String fileName) throws IOException {
		outputFile = new BufferedWriter(new FileWriter(fileName));

		for (int i = 0; i < numberOfCase; i++) {
			nextLine();
			outputFile.append("Case #" + (i+1) + ": " );
			System.out.print("Case #" + (i+1) + " ");
			String result = computeNextCase();
			outputFile.append(result);
			outputFile.newLine();
			System.out.println(result);
		}
		outputFile.close();
	}

	private String computeNextCase() {
		int r = lineScanner.nextInt();
		int c = lineScanner.nextInt();
		int m = lineScanner.nextInt();


		String result = miner(r, c, m);

		return result;

	}

	public static void main(String[] args) throws IOException {
		PB3 pb = null;
		try {
			String file = "B-large";
			pb = new PB3();
			pb.init("c:\\gcj2014\\" + file  + ".in");
			pb.computeCase("c:\\gcj2014\\" + file + ".out");
		} finally {
			if (pb != null) {
				pb.close();
			}
		}
	}



	public String miner(int r, int c, int m) {
		int caseVide = r*c - m;

		if (caseVide < 9) {
			if (m%r != 0 && m%c != 0) { 
				return "Impossible";
			}

			if (m%r == 0 && m/r > c-2) {
				return "Impossible";
			}
		}

		char[][] result = new char[r][c];
		int currentMine = 0;

		if (r > c) {
			for (int i = 0; i < r; i++) {
				for (int j = 0; j < c; j++) {
					if (currentMine < m) {
						if (i+2 >= r && m - currentMine < r-i) {
							result[i][j] = '.';
						} else {
							result[i][j] = '*';
							currentMine++;
						}
					} else {
						result[i][j] = '.';
					}
				}
			}
		} else {
			for (int j = 0; j < c; j++) {
				for (int i = 0; i < r; i++) {
					if (currentMine < m) {
						if (j+2 >= c && m - currentMine < c-j) {
							result[i][j] = '.';
						} else {
							result[i][j] = '*';
							currentMine++;
						}
					} else {
						result[i][j] = '.';
					}
				}
			}
		}

		result[r-1][c-1] = 'c';
		
		StringBuilder builder = new StringBuilder();
		for (int i = 0; i < r; i++) {
			if (i!=0) builder.append("\n");
			for (int j = 0; j < c; j++) {
				builder.append(result[i][j]);
			}
		}
		return builder.toString();
	}

}
