package fr.diodfr.gcj2014.qualif;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;


public class PB2 {

	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;
	private BufferedWriter outputFile;

	public void init(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}

	private void computeCase(String fileName) throws IOException {
		outputFile = new BufferedWriter(new FileWriter(fileName));

		for (int i = 0; i < numberOfCase; i++) {
			nextLine();
			outputFile.append("Case #" + (i+1) + ": " );
			System.out.print("Case #" + (i+1) + " ");
			String result = computeNextCase();
			outputFile.append(result);
			outputFile.newLine();
			System.out.println(result);
		}
		outputFile.close();
	}

	private String computeNextCase() {
		double c = Double.parseDouble(lineScanner.next());
		double f = Double.parseDouble(lineScanner.next());
		double x = Double.parseDouble(lineScanner.next());


		double result = winCookiesMinTime(c, f, x);

		return Double.toString(result);

	}

	public static void main(String[] args) throws IOException {
		PB2 pb = null;
		try {
			String file = "test";
			pb = new PB2();
			pb.init("c:\\gcj2014\\" + file  + ".in");
			pb.computeCase("c:\\gcj2014\\" + file + ".out");
		} finally {
			if (pb != null) {
				pb.close();
			}
		}
	}



	public double winCookiesMinTime(double c, double f, double x) {
		double time = 0;
		double currentRate = 2.0;

		do {
			double timeWithoutMoreBuilding = x / currentRate;
			double timeWithANewBuilding = c / currentRate + x / (currentRate + f);
			if (timeWithoutMoreBuilding < timeWithANewBuilding) {
				break;
			}
			
			time += c / currentRate;
			currentRate = currentRate + f;
		} while(true);

		return time + x/currentRate;
	}

}
