package fr.diodfr.y2012.qual;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class Exo1 {
	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;

	public Exo1(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public String nextLine() {
		String nextLine = fileScanner.nextLine();
//		System.out.println("Exo2.nextLine():" + nextLine);
		lineScanner = new Scanner(nextLine);
		return nextLine;
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}
	
	public int nextInt() {
		return lineScanner.nextInt();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}
	
	
	private void computeCase(String outPutFileName) throws IOException {
		BufferedWriter file = new BufferedWriter(new FileWriter(outPutFileName));

		for (int i = 0; i < numberOfCase; i++) {
			String result = getResult();

			file.append("Case #" + (i + 1) + ": " + result);
			System.out.println("Case #" + (i + 1) + " : " + result);
			file.newLine();
		}
		file.close();
	}
	
	private String getResult() {
		StringBuilder result = new StringBuilder(nextLine());
		
		for (int i = 0; i < result.length(); i++) {
			result.setCharAt(i, convert(result.charAt(i)));
		}
		
		return result.toString();
	}

	StringBuilder alphabet = new StringBuilder(
			"yhesocvxduiglbkrztnwjpfmaq"
			);
	private char convert(char charAt) {
		if (charAt ==' ') {
			return ' ';
		}
		return alphabet.charAt(charAt - 'a');
	}

	public static void main(String[] args) {
		
		Exo1 exo = new Exo1("/home/didier/Téléchargements/A-small-attempt0.in");
	
		try {
			exo.computeCase("/home/didier/Téléchargements/A-small-attempt0.out");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
