package gcj2016.p1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;



public class Pb1 {

	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;
	private BufferedWriter outputFile;

	public void init(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}

	private void computeCase(String fileName) throws IOException {
		outputFile = new BufferedWriter(new FileWriter(fileName));

		for (int i = 0; i < numberOfCase; i++) {
			outputFile.append("Case #" + (i+1) + ": " );
			System.out.print("Case #" + (i+1) + " ");
			String result = computeNextCase();
			outputFile.append(result);
			outputFile.newLine();
			System.out.println(result);
		}
		outputFile.close();
	}

	private String computeNextCase() {
		
		Set<Character> charSet = new HashSet<>(); 
		String chiffre = fileScanner.nextLine();
		
		int chiffreInt = Integer.parseInt(chiffre);
		
		if (chiffreInt == 0) return "INSOMNIA";
		
		addChars(charSet, chiffre);
		int i=2;
		while(charSet.size() != 10) {
			chiffre = String.valueOf(chiffreInt*i);
			i++;
			addChars(charSet, chiffre);
		}
		return chiffre;
	}

	private void addChars(Set<Character> charSet, String chiffre) {
		for (Character character : chiffre.toCharArray()) {
			charSet.add(character);
		}
	}

	public static void main(String[] args) throws IOException {
		Pb1 pb = null;
		try {
			String file = "./src/gcj2016/p1/A-small-attempt0";
			pb = new Pb1();
			pb.init(file  + ".in");
			pb.computeCase(file + ".out");
		} finally {
			if (pb != null) {
				pb.close();
			}
		}
	}
}