import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class GCJ1C1 {

	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;

	public GCJ1C1(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}

	private void computeCase(String fileName) throws IOException {
		BufferedWriter file = new BufferedWriter(new FileWriter(fileName));

		for (int i = 0; i < numberOfCase; i++) {
			long result = computeNextCase();
			file.append("Case #" + (i+1) + ": " + result);
			System.out.println("Case #" + (i+1) + " " + result);
			file.newLine();
		}
		file.close();
	}

	private int computeNextCase() {
		nextLine();
		String name = lineScanner.next();
		int n = lineScanner.nextInt();
		
		return compute(name, n);
	}

	private int compute(String name, int n) {
		int result = 0;
		int last=-1;
		
		for (int i = 0; i < name.length(); i++) {
			int current = 0;
			
			while(i+current < name.length() && isConsonant(name.charAt(i+current)) && current < n) {
				current++;
			}
			
			if (current == n) {
				result += (i - last) * -(i+current-name.length()-1);
				last = i;
			} else {
				i += current;
			}
		}
		
		return result;
	}

	private boolean isConsonant(char charAt) {
		switch (charAt) {
		case 'a':
		case 'e':
		case 'i':
		case 'o':
		case 'u':
			return false;
		default:
			return true;
		}
	}

	public static void main(String[] args) throws IOException {
		GCJ1C1 s = null;
		try {
			String file = "A-large";
			s = new GCJ1C1("/home/didier/Téléchargements/" + file  + ".in");
			s.computeCase("/home/didier/Téléchargements/" + file + ".out");
		} finally {
			if (s != null) {
				s.close();
			}
		}
	}
}