package fr.diod.gcj2013.qualif.exo2;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

public class Exo2 {
	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;

	public Exo2(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public String nextLine() {
		String nextLine = fileScanner.nextLine();
		//		System.out.println("Exo2.nextLine():" + nextLine);
		lineScanner = new Scanner(nextLine);
		return nextLine;
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public int nextInt() {
		return lineScanner.nextInt();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}


	private void computeCase(String outPutFileName) throws IOException {
		BufferedWriter file = new BufferedWriter(new FileWriter(outPutFileName));

		for (int i = 0; i < numberOfCase; i++) {
			String test = nextLine();
			int ligne = nextInt();
			int colonne = nextInt();
			int[][] tableau = new int[ligne][colonne];
			
			for (int j = 0; j < tableau.length; j++) {
				nextLine();
				for (int k = 0; k < tableau[0].length; k++) {
					tableau[j][k] = nextInt();
				}
			}

			String result = getResult(tableau);

			file.append("Case #" + (i + 1) + ": " + result);
			System.out.println("Case #" + (i + 1) + " : " + result);
			file.newLine();
		}
		file.close();
	}

	//	3
	//	3 3
	//	2 1 2
	//	1 1 1
	//	2 1 2
	//	5 5
	//	2 2 2 2 2
	//	2 1 1 1 2
	//	2 1 2 1 2
	//	2 1 1 1 2
	//	2 2 2 2 2
	//	1 3
	//	1 2 1
	//	
	//	Case #1: YES
	//	Case #2: NO
	//	Case #3: YES


	private String getResult(int[][] tableau) {
		int[] ligneMax = maxByLigne(tableau);
		int[] colonneMax = maxByColomn(tableau);

		return checkAll(tableau, ligneMax, colonneMax);
	}

	private String checkAll(int[][] tableau, int[] ligneMax, int[] colonneMax) {
		for (int i = 0; i < ligneMax.length; i++) {
			for (int j = 0; j < colonneMax.length; j++) {
				if (tableau[i][j] != Math.min(ligneMax[i], colonneMax[j])) {
					return "NO";
				}
			}
		}
		
		return "YES";
	}

	private int[] maxByColomn(int[][] tableau) {
		int[] max = new int[tableau[0].length];

		for (int j = 0; j < max.length; j++) {
			max[j] = -1;
			for (int i = 0; i < tableau.length; i++) {
				max[j] = Math.max(max[j], tableau[i][j]);
			}
		}

		return max;
	}

	private int[] maxByLigne(int[][] tableau) {
		int[] max = new int[tableau.length];

		for (int i = 0; i < max.length; i++) {
			max[i] = -1;

			for (int j = 0; j < tableau[i].length; j++) {
				max[i] = Math.max(max[i], tableau[i][j]);
			}
		}

		return max;
	}

	public static void main(String[] args) {

//		String inputFileName = "test";
				String inputFileName = "B-small-attempt0";
		//		String inputFileName = "B-large";

		Exo2 exo = new Exo2("/home/didier/Téléchargements/" + inputFileName + ".in");

		try {
			exo.computeCase("/home/didier/Téléchargements/" + inputFileName + ".out");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
