package fr.sfr.perso.broca.didier.tools;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;

public class NextNumber {
	
	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;
	private String welcomeCodeJam = "welcome to code jam";
	
	public NextNumber(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	public int getNumberOfCase() {
		return numberOfCase;
	}
	
	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}
	
	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}
	
	public boolean hasNext() {
		return lineScanner.hasNext();
	}
	
	public String next() {
		return lineScanner.next();
	}
	
	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}
	
	private void computeCase(String fileName) throws IOException {
		BufferedWriter file = new BufferedWriter(new FileWriter(fileName));
		
		for (int i = 0; i < numberOfCase; i++) {
			String result = computeNextCase();
			file.append("Case #" + (i+1) + ": " + result);
			System.out.println("Case #" + (i+1) + " " + result);
			file.newLine();
		}
		file.close();
	}
	
	private String computeNextCase() {
		String stringN = fileScanner.nextLine();
		StringBuffer stringK = new StringBuffer(stringN);
		
		int size = stringN.length();
		int a = stringK.charAt(size-1)-'0';
		for (int i = size-2; i >= 0; i--) {
			int b = stringK.charAt(i)-'0';
			if (a > b) {
//				stringK.setCharAt(i, (char) (a + '0'));
//				stringK.setCharAt(i+1, (char) (b + '0'));
				char[] ordered = stringK.substring(i+1).toCharArray();
				Arrays.sort(ordered);
				
				for (int j = 0; j < ordered.length; j++) {
					if (ordered[j] > b+'0') {
						stringK.setCharAt(i, ordered[j]);
						ordered[j] = (char) (b + '0');
						break;
					}
				}
				
				Arrays.sort(ordered);
				return stringK.substring(0, i+1) + new String(ordered);
			} else {
				stringK.setCharAt(i+1, (char) (a + '0'));
				a = b;
			}
		}

		return orderNAndAddZero(stringN);
	}

	

	private String orderNAndAddZero(String stringN) {
		char[] ordered = stringN.toCharArray();
		
		Arrays.sort(ordered);
		int i = 0;
		for (; i <= ordered.length; i++) {
			if (ordered[i] != '0') {
				break;
			}
		}
		
		char replace = ordered[i];
		ordered[i] = '0';
	
		
		return Character.toString(replace) + new String(ordered);
	}

	public static void main(String[] args) throws IOException {
		NextNumber s = null;
        try {
            String file = "B-small-attempt3";
			s = new NextNumber("D:\\test\\" + file  + ".in");
            s.computeCase("D:\\test\\" + file + ".out");
         } finally {
            if (s != null) {
                s.close();
            }
        }
    }
}
