package fr.diodfr.gcj2014.qualif;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;


public class PB1 {

	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;
	private BufferedWriter outputFile;

	public void init(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}

	private void computeCase(String fileName) throws IOException {
		outputFile = new BufferedWriter(new FileWriter(fileName));

		nextLine();
		for (int i = 0; i < numberOfCase; i++) {
			outputFile.append("Case #" + (i+1) + ": " );
			System.out.print("Case #" + (i+1) + " ");
			String result = computeNextCase();
			outputFile.append(result);
			outputFile.newLine();
			System.out.println(result);
		}
		outputFile.close();
	}

	private String computeNextCase() {
		
		int r1 = lineScanner.nextInt();
		nextLine();
		int[][] card1 = new int[4][4];

		for (int i = 0; i < card1.length; i++) {
			for (int j = 0; j < card1[i].length; j++) {
				card1[i][j] = lineScanner.nextInt();
			}
			nextLine();
		}

		int r2 = lineScanner.nextInt();
		nextLine();

		int[][] card2 = new int[4][4];

		for (int i = 0; i < card2.length; i++) {
			for (int j = 0; j < card2[i].length; j++) {
				card2[i][j] = lineScanner.nextInt();
			}
			if (hasNextLine()) nextLine();
		}

		int result = magic(r1, card1, r2, card2);

		switch (result) {
		case -1:
			return "Bad magician!";
		case -2:
			return "Volunteer cheated!";
		default:
			return Integer.toString(result);
		}

	}

	public static void main(String[] args) throws IOException {
		PB1 pb = null;
		try {
			String file = "A-small";
			pb = new PB1();
			pb.init("c:\\gcj2014\\" + file  + ".in");
			pb.computeCase("c:\\gcj2014\\" + file + ".out");
		} finally {
			if (pb != null) {
				pb.close();
			}
		}
	}

	public int magic(int r1, int[][] cards1, int r2, int[][] cards2) {
		int[] row1 = cards1[r1-1];
		int[] row2 = cards2[r2-1];

		List<Integer> results = new ArrayList<Integer>();

		for (int card : row1) {
			for (int card2 : row2) {
				if (card == card2) {
					results.add(card);
				}
			}
		}


		switch(results.size()) {
		case 1:
			return results.get(0);

		case 0:
			return -2;

		default :
			return -1;
		}
	}

}
