package fr.sfr.perso.broca.didier.tools;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class AlienLanguage {
	
	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;    // N
	private int numberOfWord;    // D
	private int numberOfLetters; // L
	
	String[] dictionnary;
	
	Map<Character, Object> map = new HashMap<Character, Object>();
	
	public AlienLanguage(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	public void retrievedNumberOfCase() {
		nextLine();
		numberOfLetters = nextInt();
		numberOfWord = nextInt();
		numberOfCase = nextInt();
		
		dictionnary = new String[numberOfWord];
	}
	
	public void configureDictionnary() {
		for (int i = 0; i < numberOfWord; i++) {
			dictionnary[i]= nextLineFile();
		}
	}
	
	private void computeCase(String fileName) throws IOException {
		BufferedWriter file = new BufferedWriter(new FileWriter(fileName));
		
		for (int i = 0; i < numberOfCase; i++) {
			file.append("Case #" + (i+1) + ": " + computeNextCase());
			file.newLine();
		}
		file.close();
	}

	private int computeNextCase() {
		String alienPattern = nextLineFile();
		alienPattern = alienPattern.replaceAll("\\(", "[");
		alienPattern = alienPattern.replaceAll("\\)", "]");
		Pattern pattern = Pattern.compile(alienPattern);

		int result=0;
		for (int i = 0; i < numberOfWord; i++) {
			if (pattern.matcher(dictionnary[i]).matches()) {
				result++;
			}
		}
		
		return result;
	}

	
	public int getNumberOfCase() {
		return numberOfCase;
	}
	
	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}
	
	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}
	
	public String nextLineFile() {
		return fileScanner.nextLine();
	}
	
	public boolean hasNext() {
		return lineScanner.hasNext();
	}
	
	public String next() {
		return lineScanner.next();
	}
	
	public int nextInt() {
		return lineScanner.nextInt();
	}
	
	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}
	
	public static void main(String[] args) throws IOException {
		AlienLanguage s = null;
        try {
            s = new AlienLanguage("D:\\input.in");
            
            s.retrievedNumberOfCase();
            s.configureDictionnary();
            s.computeCase("D:\\result.out");
        } finally {
            if (s != null) {
                s.close();
            }
        }
    }
}
