package fr.diod.gcj2013.qualif.exo1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class Exo1 {
	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;

	public Exo1(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public int getNumberOfCase() {
		return numberOfCase;
	}

	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}

	public String nextLine() {
		String nextLine = fileScanner.nextLine();
		//		System.out.println("Exo2.nextLine():" + nextLine);
		lineScanner = new Scanner(nextLine);
		return nextLine;
	}

	public boolean hasNext() {
		return lineScanner.hasNext();
	}

	public String next() {
		return lineScanner.next();
	}

	public int nextInt() {
		return lineScanner.nextInt();
	}

	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}


	private void computeCase(String outPutFileName) throws IOException {
		BufferedWriter file = new BufferedWriter(new FileWriter(outPutFileName));

		for (int i = 0; i < numberOfCase; i++) {
			char[][] tableau = new char[4][4];

			for (int j = 0; j < tableau.length; j++) {
				String ligne = nextLine();

				for (int k = 0; k < tableau.length; k++) {
					tableau[j][k] = ligne.charAt(k);
				}
			}
			if (hasNextLine()) {
				nextLine();
			}

			String result = getResult(tableau);

			file.append("Case #" + (i + 1) + ": " + result);
			System.out.println("Case #" + (i + 1) + " : " + result);
			file.newLine();
		}
		file.close();
	}

	private String getResult(char[][] tableau) {
		String result = boucleLigne(tableau);
		if (result == null) {
			result = boucleColonne(tableau);
			if (result == null) {
				result = boucleDiagonale(tableau);
				if (result == null ) {
					result = checkForEmpty(tableau);
				}
			}
		}

		return result;
	}

	private String checkForEmpty(char[][] tableau) {
		for (int i = 0; i < tableau.length; i++) {
			for (int j = 0; j < tableau[i].length; j++) {
				if (tableau[i][j] == '.') {
					return "Game has not completed";
				}
			}
		}
		
		return "Draw";
	}

	private String boucleDiagonale(char[][] tableau) {
		char car='T';
		int size = tableau.length;
		for (int i = 0; i < size; i++) {
			if (tableau[i][i] == '.') {
				break;
			} else if (car == tableau[i][i] || car == 'T') {
				car = tableau[i][i];
			} else if (tableau[i][i] != 'T') {
				break;
			}
			
			if (i+1 == tableau[i].length) {
				return car + " won";
			}
		}
		
		car='T';
		for (int j = size-1; j >= 0; j--) {
			int i = size - 1 - j; 
			if (tableau[i][j] == '.') {
				break;
			} else if (car == tableau[i][j] || car == 'T') {
				car = tableau[i][j];
			} else if (tableau[i][j] != 'T') {
				break;
			}
			
			if (j == 0) {
				return car + " won";
			}
		}
		
		return null;
	}

	private String boucleColonne(char[][] tableau) {
		for (int j = 0; j < tableau[0].length; j++) {
			char car='T';
			for (int i = 0; i < tableau.length; i++) {
				if (tableau[i][j] == '.') {
					break;
				} else if (car == tableau[i][j] || car == 'T') {
					car = tableau[i][j];
				} else if (tableau[i][j] != 'T') {
					break;
				}
				
				if (i+1 == tableau[j].length) {
					return car + " won";
				}
			}
		}
		
		return null;
	}

	private String boucleLigne(char[][] tableau) {
		for (int i = 0; i < tableau.length; i++) {
			char car='T';
			
			for (int j = 0; j < tableau[i].length; j++) {
				if (tableau[i][j] == '.') {
					break;
				} else if (car == tableau[i][j] || car == 'T') {
					car = tableau[i][j];
				} else if (tableau[i][j] != 'T') {
					break;
				}
				
				if (j+1 == tableau[i].length) {
					return car + " won";
				}
			}
		}
		
		return null;
	}
//	Case #1: X won
//	Case #2: Draw
//	Case #3: Game has not completed
//	Case #4: O won
//	Case #5: O won
//	Case #6: O won

	
	public static void main(String[] args) {

		String inputFileName = "A-small-attempt0";
		
		Exo1 exo = new Exo1("/home/didier/Téléchargements/" + inputFileName + ".in");

		try {
			exo.computeCase("/home/didier/Téléchargements/" + inputFileName + ".out");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
