package fr.sfr.perso.broca.didier.gcj2010;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;

public class CalifA {
	
	private Scanner fileScanner;
	private Scanner lineScanner;
	private int numberOfCase;
	
	public CalifA(String fileName) {
		try {
			fileScanner = new Scanner(new BufferedReader(new FileReader(fileName)));
			numberOfCase = fileScanner.nextInt();
			nextLine();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	public int getNumberOfCase() {
		return numberOfCase;
	}
	
	public boolean hasNextLine() {
		return fileScanner.hasNextLine();
	}
	
	public void nextLine() {
		lineScanner = new Scanner(fileScanner.nextLine());
	}
	
	public boolean hasNext() {
		return lineScanner.hasNext();
	}
	
	public String next() {
		return lineScanner.next();
	}
	
	public void close() {
		if (lineScanner != null) {
			lineScanner.close();
		}
		fileScanner.close();
	}
	
	private void computeCase(String outPutFileName) throws IOException {
		BufferedWriter file = new BufferedWriter(new FileWriter(outPutFileName));

		for (int i = 0; i < numberOfCase; i++) {
			long n = Long.valueOf(fileScanner.next());
			long k = Long.valueOf(fileScanner.next());

			String result = computeNextCase(n, k);
			file.append("Case #" + (i + 1) + ": " + result);
			System.out.println("Case #" + (i + 1) + " " + result);
			file.newLine();
		}
		file.close();
	}

	private String computeNextCase(long n, long k) {
		BigInteger allBytes = BigInteger.valueOf(2).pow((int) n).add(BigInteger.ONE.negate());
		BigInteger kBigInteger = BigInteger.valueOf(k);
		BigInteger puissanceN1 = BigInteger.valueOf(2).pow((int) (n-1));
		BigInteger myAnd = kBigInteger.and(puissanceN1);
		BigInteger myXor = allBytes.xor(kBigInteger).and(allBytes);
		
		
		if (myAnd.longValue() !=0 && myXor.longValue() == 0) {
			return "ON";
		}
		
		return "OFF";
	}

	public static void main(String[] args) throws IOException {
		CalifA s = null;
        try {
            String file = "A-small-attempt0";
			s = new CalifA("/home/didier/codejam/" + file  + ".in");
            s.computeCase("/home/didier/codejam/" + file + ".out");
         } finally {
            if (s != null) {
                s.close();
            }
        }
    }
}
