import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;


public class B_Train_Timetable {

	static final Hour MAX_HOUR = new Hour(23,59);
	
	public static void main(String[] args) {
		Scanner input = new Scanner(System.in);
		StringBuffer out = new StringBuffer();
		
		final String CASE = "Case #";
		final String LS = System.getProperty("line.separator");
		final String DPS = ": ";
		final String DP = ":";
		final String S = " ";

		int n = Integer.parseInt(input.nextLine());
		
		// for test i...
		for(int i = 1; i <= n; i++) {
			int tt = Integer.parseInt(input.nextLine());
			String[] l = input.nextLine().split(S);
			int na = Integer.parseInt(l[0]);
			int nb = Integer.parseInt(l[1]);
			
			List<Hour> aLeave = new ArrayList<Hour>();
			List<Hour> bArrive = new ArrayList<Hour>();
			
			//reading trips a -> b
			for(int j = 0; j < na; j++) {
				String line = input.nextLine();
				String[] hours = line.split(S);
				String[] h1 = hours[0].split(DP);
				String[] h2 = hours[1].split(DP);
				
				aLeave.add(new Hour(Integer.parseInt(h1[0]), Integer.parseInt(h1[1])));
				bArrive.add(new Hour(Integer.parseInt(h2[0]), Integer.parseInt(h2[1])));
			}
			
			Collections.sort(aLeave);
			Collections.sort(bArrive);

			List<Hour> bLeave = new ArrayList<Hour>();
			List<Hour> aArrive = new ArrayList<Hour>();
			
			//reading trips b -> a
			for(int j = 0; j < nb; j++) {
				String line = input.nextLine();
				String[] hours = line.split(S);
				String[] h1 = hours[0].split(DP);
				String[] h2 = hours[1].split(DP);
				
				bLeave.add(new Hour(Integer.parseInt(h1[0]), Integer.parseInt(h1[1])));
				aArrive.add(new Hour(Integer.parseInt(h2[0]), Integer.parseInt(h2[1])));
				
			}
			
			Collections.sort(bLeave);
			Collections.sort(aArrive);
		
			//number of trains starting on A
			int a = 0;
			
			for(Hour al: aLeave) {
				Hour h = al.difference(tt);
				Hour hMinArrive = minHour(aArrive);
				
				if(h.compareTo(hMinArrive) < 0) a++;
				else{
					aArrive.remove(0);
				}
			}
			
			//number of trains starting on A
			int b = 0;
			
			for(Hour al: bLeave) {
				Hour h = al.difference(tt);
				Hour hMinArrive = minHour(bArrive);
				
				if(h.compareTo(hMinArrive) < 0) b++;
				else{
					bArrive.remove(0);
				}				
			}
			
			out.append(CASE).append(i).append(DPS).append(a).append(S).append(b);
			if(i < n ) out.append(LS);
		}
		
		System.out.print(out);
	}
	
	static Hour minHour(List<Hour> l) {
		if(l.size() == 0) return MAX_HOUR;
		return l.get(0);
	}
}

class Hour implements Comparable<Hour> {
	
	int hours;
	int minutes;
	
	Hour(int h, int m) {
		this.hours = h;
		this.minutes = m;
	}
	
	Hour difference(int min) {
		return (min <= this.minutes) ? new Hour(hours,minutes-min): new Hour(hours-1,60+minutes-min);
	}

	@Override
	public int compareTo(Hour o) {
		if(this.hours != o.hours){
			return this.hours - o.hours;
		}
		return this.minutes - o.minutes;
	}
	
	public String toString() {
		return this.hours + ":" + this.minutes;
	}
}