import java.io.*;
import java.util.Arrays;

/**
 * Created by IntelliJ IDEA.
 * User: DIR
 * Date: 12.09.2009
 * Time: 19:50:10
 */
public class Prisoners {
    private static final String INPUT_FILE = "D:\\Jam\\C-small-attempt1.in";
    private static int resNum = 1;

    private final int from;
    private final int[] pris;
    private int index = 0;
    private int to;

    /*new TreeSet<Integer>(new Comparator<Integer>() {

    });*/

    public Prisoners(int p, int q) {
        from = 0;
        to = p;
        pris = new int[q];
    }

    public Prisoners(int from, int to, int[] pris) {
        this.to = to;
        this.from = from;
        this.pris = pris;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader in = new BufferedReader(new FileReader(INPUT_FILE));
        FileWriter out = new FileWriter(INPUT_FILE + ".out");
        final int N = Integer.parseInt(in.readLine());
        for (int i = 0; i < N; i++) {
            String[] tmp = in.readLine().split(" ");
            int P = Integer.parseInt(tmp[0]);
            int Q = Integer.parseInt(tmp[1]);
            tmp = in.readLine().split(" ");
            Prisoners p = new Prisoners(P, Q);
            for (int j = 0; j < Q; j++) {
                p.add(Integer.parseInt(tmp[j]));
            }
            writeRes(out, (p.bride()));
        }
        in.close();
        out.close();
    }

    private void add(int i) {
        pris[index++] = i;
    }

    private static void writeRes(FileWriter out, int res) throws IOException {
        out.write("Case #" + resNum + ": " + res + "\n");
        resNum++;
    }

    private int bride() {
        if (pris.length == 0) {
            return 0;
        }
        int min = Integer.MAX_VALUE;
        for (int i = 0; i < pris.length; i++) {
            Prisoners sub1 = new Prisoners(from, pris[i] - 1, Arrays.copyOf(pris, i));
            Prisoners sub2 = new Prisoners(pris[i], to, Arrays.copyOfRange(pris, i+1, pris.length));
            min = Math.min(min, sub1.bride() + sub2.bride());
        }
        return to - from - 1 + min;


        /*int f = dist(pris[0]);
        int l = dist(pris[pris.length-1]);

        if (f < l) {
            Prisoners sub = new Prisoners(pris[0], to, Arrays.copyOfRange(pris, 1, pris.length));
            return to-from - 1 + sub.bride();
        } else if (l < f) {
            Prisoners sub = new Prisoners(from, pris[pris.length-1]-1, Arrays.copyOf(pris, pris.length-1));
            return to-from - 1 + sub.bride();
        } else {
            Prisoners sub1 = new Prisoners(pris[0], to, Arrays.copyOfRange(pris, 1, pris.length));
            Prisoners sub2 = new Prisoners(from, pris[pris.length-1]-1, Arrays.copyOf(pris, pris.length-1));
            int x1 = sub1.bride();
            int x2 = sub2.bride();
            return to-from - 1 + Math.min(x1, x2);
        }*/
    }

    public int dist(int x) {
        int c = (to + from) / 2;
        if (x < c) {
            c++;
        }
        return Math.abs(c - x);
    }

}