import java.io.*;
import java.util.regex.Pattern;
import java.util.regex.Matcher;

/**
 * Created for Google.
 * User: rozhnev
 * Date: 03.09.2009
 * Time: 12:22:20
 */
public final class AlienLang {
    private static final String IN_FILE = "d:\\Downloads\\G-jam\\sub-2.in";
    private static final String OUT_FILE = "d:\\Downloads\\G-jam\\out3.txt";

    public static void main(String[] args) throws IOException {
        final InputStream f = new FileInputStream(IN_FILE);
        final BufferedReader br = new BufferedReader(new InputStreamReader(f));
        final String[] params = br.readLine().split(" ");
        int L = Integer.parseInt(params[0]);
        int D = Integer.parseInt(params[1]);
        int N = Integer.parseInt(params[2]);

        final AlienLang al = new AlienLang(br, D);

        final Writer out = new FileWriter(OUT_FILE);
        for (int i = 1; i <= N; i++) {
            final int x = al.checkPattern(br.readLine().trim());
            out.write("Case #");
            out.write(String.valueOf(i));
            out.write(": ");
            out.write(String.valueOf(x));
            out.write("\n");
            System.out.println((i * 100 / N) + "%");
        }
        br.close();
        out.close();
        System.out.println("Success!");
    }

    private final String[] words;

    public AlienLang(String[] words) {
        this.words = words;
    }

    public AlienLang(BufferedReader br, int count) throws IOException {
        words = new String[count];
        for (int i = 0; i < count; i++) {
            words[i] = br.readLine().trim();
        }
    }

    public int checkPattern(String pattern) {
        final Pattern p = Pattern.compile(pattern.replace('(', '[').replace(')', ']'));
        int res = 0;
        for (String word : words) {
            final Matcher m = p.matcher(word);
            if (m.matches())
                res++;
        }
        return res;
    }

}
