import java.io.*;

/**
 * Created for Google.
 * User: rozhnev
 * Date: 03.09.2009
 * Time: 21:55:15
 */
public final class Welcome {

    private static final String IN_FILE = "d:\\Downloads\\G-jam\\A-large.in";
    private static final String OUT_FILE = "d:\\Downloads\\G-jam\\out3.txt";
    private static final String TEXT = "welcome to code jam";

    public static void main(String[] args) throws IOException {
        final InputStream f = new FileInputStream(IN_FILE);
        final BufferedReader br = new BufferedReader(new InputStreamReader(f));
        final int N = Integer.parseInt(br.readLine());


        final Writer out = new FileWriter(OUT_FILE);
        for (int i = 1; i <= N; i++) {
            final Welcome welcome = new Welcome(TEXT, br.readLine().trim());
            final int x = welcome.count();
            out.write("Case #");
            out.write(String.valueOf(i));
            out.write(": ");
            out.write(get4digit(x));
            out.write("\n");
            System.out.println((i * 100 / N) + "%");
        }
        br.close();
        out.close();
        System.out.println("Success!");
    }

    private static String get4digit(int x) {
        final String s = "000" + x;
        return s.substring(s.length() - 4);
    }

    private final String pattern;
    private final int[] pointers;
    private final String test;

    public Welcome(String pattern, String testString) {
        this.pattern = pattern;
        pointers = new int[pattern.length()];
        test = testString;
    }

    private int count() {
        int res = 0;
        if (init(0)) {
            do {
                res++;
            } while (stepNext());
        }
        return res;
    }

    private boolean init(int fromIndex) {
        for (int i = fromIndex; i < pointers.length; i++) {
            if (!firstOccur(i)) {
                return false;
            }
        }
        return true;
    }

    private boolean firstOccur(int charIndex) {
        final int fromPosition = (charIndex == 0) ? 0 : pointers[charIndex - 1];
        pointers[charIndex] = test.indexOf(pattern.charAt(charIndex), fromPosition);
        return pointers[charIndex] >= 0;
    }

    private boolean stepNext() {
        for (int i = pointers.length - 1; i >= 0; i--) {
            if (stepOne(i)) {
                if (init(i + 1)) {
                    return true;
                }
            }
        }
        return false;
    }

    private boolean stepOne(int charIndex) {
        final int fromPosition = pointers[charIndex] + 1;
        pointers[charIndex] = test.indexOf(pattern.charAt(charIndex), fromPosition);
        return pointers[charIndex] >= 0;
    }
}
