import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

public class TicTacToeTramek {

	public static void main(String[] args) throws IOException {
		BufferedReader br = null;
		char[][] grid;
		try {
			br = new BufferedReader(new FileReader("A-small-attempt3.in"));
			String line = br.readLine();
			int T = Integer.parseInt(line);

			for (int i = 0; i < T; i++) {
				grid = new char[4][4];
				char wonChar = ' ';
				boolean won = false;
				boolean empty = false;
				boolean completed = false;

				for (int j = 0; j < 4; j++) {
					line = br.readLine();
					grid[j] = line.toCharArray();
				}
				empty = EmptyCells(grid);
				if (checkDiagonal(grid, 'X')) {
					won = true;
					System.out.println("Case #" + (i + 1) + ": "
							+ "X won");
					completed = true;
				}
				if (checkDiagonal(grid, 'O')) {
					won = true;
					System.out.println("Case #" + (i + 1) + ": "
							+ "O won");
					completed = true;
				}
				for (int k = 0; k < 4 && !won; k++) {
					char temp = grid[k][k];
					switch (temp) {
					case 'X':
						if (checkAcross(grid, k, 'X')) {
							won = true;						
						}
						if (checkDown(grid, k, 'X')) {
							won = true;
						}
						wonChar = 'X';
						break;

					case 'O':
						if (checkAcross(grid, k, 'O')) {
							won = true;
						}
						if (checkDown(grid, k, 'O')) {
							won = true;
						}
						wonChar = 'O';
						break;

					case 'T':
						if (checkAcross(grid, k, 'O')) {
							won = true;
							wonChar = 'O';
						}
						if (checkDown(grid, k, 'O')) {
							won = true;
							wonChar = 'O';
						}
						if (checkAcross(grid, k, 'X')) {
							won = true;
							wonChar = 'X';
						}
						if (checkDown(grid, k, 'X')) {
							won = true;
							wonChar = 'X';
						}
						break;

					default:
						break;
					}

					if (won) {
						System.out.println("Case #" + (i + 1) + ": "
								+ wonChar + " won");
						completed = true;
						break;
					}

				}
				line = br.readLine();
				if (empty && !completed) {
					System.out.println("Case #" + (i + 1) + ": "
							+"Game has not completed");
					continue;
				}
				if (!completed) {
					System.out.println("Case #" + (i + 1) + ": "
							+"Draw");
					continue;
				}
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} finally {
			br.close();
		}

	}

	private static boolean checkDiagonal(char[][] grid, char c) {
		int count = 0;
		for (int i = 0; i < 4; i++) {
			if (grid[i][i] == Character.toUpperCase(c) || grid[i][i] == 'T') {
				count++;
			}
		}
		if (count == 4) return true;
		
		count = 0;
		for (int i = 0; i < 4; i++) {
			if (grid[i][3 - i] == Character.toUpperCase(c) || grid[i][3 - i] == 'T') {
				count++;
			}
		}
		if (count == 4) return true;
		
		return false;

	}

	private static boolean EmptyCells(char[][] grid) {
		for (int i = 0; i < 4; i++) {
			for (char c : grid[i]) {
				if (c == '.')
					return true;
			}			
		}
		return false;
	}

	private static boolean checkDown(char[][] grid, int x, char c) {
		for (int i = 0; i < 4; i++) {
			if (grid[i][x] != Character.toUpperCase(c) && grid[i][x] != 'T') {
				return false;
			}
		}
		return true;
	}

	private static boolean checkAcross(char[][] grid, int y, char c) {

		for (int i = 0; i < 4; i++) {
			if (grid[y][i] != Character.toUpperCase(c) && grid[y][i] != 'T') {
				return false;
			}
		}
		return true;
	}
}
