import java.io.*;
import java.io.*;
import java.math.*;
import java.util.Arrays;

public class CoinJam {
	
	static long [][] pows = new long[11][16];
	static boolean[] sieve = new boolean[33_333_334];
	static final int N_PRIMES = 2_050_943;
	static int[] primes = new int[N_PRIMES];

	public static void main(String[] args) throws Exception {
		String filename = "coinjam.in";
		BufferedReader in = new BufferedReader(new FileReader(filename));
		System.setOut(new PrintStream("coinjam.out"));
		long initial = System.currentTimeMillis();
		// powers
		for (int a=2; a<=10; a++) {
			long p = 1;
			for (int n=0; n<16; n++, p*=a) pows[a][n] = p;
		}
		// for (long [] arr :  pows) System.out.println(Arrays.toString(arr));
		// sieve
		sieve[2] = true;
		for (int i=3; i<sieve.length; i+=2) sieve[i] = true;
		for (int i=3,j; (j=i*i)<sieve.length; i++) if(sieve[i]) {
			int tw = i<<1;
			do { sieve[j]=false; } while((j+=tw)<sieve.length);
		}
		// int nPrimes = 1;
		// for (int i=3; i<sieve.length; i+=2) nPrimes += sieve[i]?1:0;
		// System.out.println(nPrimes);
		primes[0]=2;
		for (int i=3, j=1; i<sieve.length; i+=2) if(sieve[i]) primes[j++] = i;
		// for (int i=0; i<100; i++) System.out.println(primes[i]);
		
		
		//System.out.println(primes[0]);
		// for (int i=2; i<=10; i++) System.out.println(calc("1111111111111111", i));
		// System.out.println(((1L<<31)-1)+" "+isPrime(2_147_483_647));
		in.readLine(); // read 1
		String[] sarr = in.readLine().trim().split(" +");
		System.out.println("Case #1:");
		int N = Integer.parseInt(sarr[0]);
		int J = Integer.parseInt(sarr[1]);
		int K = 1<<(N-2);
		for (int k=0, results=0; k<K && results<J; k++) {
			String s = String.format("%"+(N-2)+"s", Integer.toBinaryString(k)).replace(' ', '0');
			boolean anyPrime = false;
			int [] divs = new int[11];
			for (int base = 2; !anyPrime && base <= 10; base++) {
				//System.out.println("\t"+value(s, base));
				int div = isPrime(value(s, base));
				divs[base] = div;
				anyPrime |= (div == 1); 
			}
			if (!anyPrime) {
				System.out.print("1"+s+"1");
				for (int i=2; i<=10; i++) System.out.print(" "+divs[i]);
				System.out.println();
				results++;
			}
			//else           System.out.println("Not JamCoin: 1"+s+"1");
		}
		// System.out.printf("time: %.2f secs%n", (System.currentTimeMillis()-initial)/1000.);
	}
	/* Transforma 1s1 en base a decimal 
	 */
	public static long value(String s, int base) {
		long n = 1 + pows[base][s.length()+1];
		for (int i=s.length()-1, pow=1; i>=0; i--, pow++) n+= s.charAt(i)=='1'?pows[base][pow]:0;
		return n;
		
	}
	
	public static long calc(String s, int base) {
		long n = 0;
		for (int i=s.length()-1, j=0; i>=0; i--,j++) n += s.charAt(i)=='1'?pows[base][j]:0;
		return n;
	}
	
	public static int isPrime(long n) {
		if (n < sieve.length && sieve[(int)n]) return 1;
		else {
			for (int i=0; i<primes.length; i++) if (n%primes[i]==0) return primes[i];
			return 1;
		}
	}
}
