import java.util.*;
import java.io.*;
import static java.lang.Integer.*;
import static java.lang.Math.*;
public class Watersheds {
  public static void main(String args[]) throws Exception {
    BufferedReader in = new BufferedReader(new FileReader(args[0]));
    int  map[][] = new int [128][128]; // las alturas
    char res[][] = new char[128][128]; // las etiquetas
    int dir [][] = {{1, 0}, {0, 1}, {0, -1}, {-1, 0}}; // las direcciones
    int edg [][][] = new int[128][128][2];
    /*ok :*/ for (int t = 1, T = parseInt(in.readLine().trim()); t <= T; t++) {
      StringTokenizer stk = new StringTokenizer(in.readLine());
      int H = parseInt(stk.nextToken()), W = parseInt(stk.nextToken());
      TreeMap<Integer, ArrayList<int[]>> tree = new TreeMap<Integer, ArrayList<int[]>>();
      for (int i = 0; i < H; i++) {
        stk = new StringTokenizer(in.readLine());
        for (int j = 0; j < W; j++) {
          map[i][j] = parseInt(stk.nextToken());
          ArrayList<int[]> l = tree.get(map[i][j]);
          if (l == null) tree.put(map[i][j], l = new ArrayList<int[]>());
          l.add(new int[]{i, j});
        }
      }
      for (int i = 0; i < H; i++) for (int j = 0; j < W; j++) {
        int h = -1, w = -1, l = map[i][j] - 1;
        for (int [] d : dir) {
          int hf = i + d[0], wf = j + d[1];
          if (0 <= hf && hf < H  && 
              0 <= wf && wf < W  && 
              map[hf][wf] <= l)
            { l = map[hf][wf]; h = hf; w = wf; }
          edg[i][j][0] = h;
          edg[i][j][1] = w;
        }
      }
      /*
      for (int i = 0; i < H; i++) {
        for (int j = 0; j < W; j++) System.out.print(Arrays.toString(edg[i][j]));
        System.out.println();
      }
      */
      for (int i = 0; i < H; i++) for (int j = 0; j < W; j++) res[i][j] = ' ';
      for (char c = 'a' ; !tree.isEmpty(); ) {
        Map.Entry<Integer, ArrayList<int[]>> e = tree.pollFirstEntry();
        ArrayList<int[]> l = e.getValue();
        for (int u[] : l) if (res[ u[0] ][ u[1] ] == ' ') {
          res[u[0]][u[1]] = c; // Character.toUpperCase(c);
          Queue<int[]> q = new LinkedList<int[]>();
          q.offer(u);
          while (!q.isEmpty()) {
            int v[] = q.poll();
            int h0 = v[0], w0 = v[1], lu = map[h0][w0];
            for (int [] d : dir) {
              int hf = h0 + d[0], wf = w0 + d[1];
              //System.out.println(hf + " " + wf + " - " +  (0 <= hf && hf < H  && 0 <= wf && wf < W ? edg[hf][wf][0] + " " + edg[hf][wf][1] : " ? "));
              if (0 <= hf && hf < H  && 
                  0 <= wf && wf < W  && 
                  res[hf][wf] == ' ' && // no ha sido etiquetada
                  map[hf][wf] > lu   &&
                  edg[hf][wf][0] == h0 && edg[hf][wf][1] == w0
                  /* se conectan */ ) 
                { res[hf][wf] = c; q.offer(new int[]{hf, wf}); }
            }
            //break ok;
          }
          c = (char)++c;
        }
      }
      
      char mapping[] = new char[26];
      for (int i = 0, c = 'a'; i < H; i++) for (int j = 0; j < W; j++) if (mapping[res[i][j] - 'a'] == 0) { mapping[res[i][j] - 'a'] = (char)c; c++; }
      
      System.out.println("Case #" + t + ":");
      StringBuilder sb = new StringBuilder();
      for (int i = 0; i < H; i++) {
        sb.append(mapping[res[i][0] - 'a']);
        for (int j = 1; j < W; j++) sb.append(" " + mapping[res[i][j] - 'a']);
        sb.append("\n");
      }
      System.out.print(sb.toString());
    }
  }
}
