import java.io.FileReader;
import java.io.BufferedReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.List;
import java.util.Scanner;

public class C {
	static BitSet primes;
	public static void main(String[] args) throws IOException {
		Scanner input = new Scanner(new BufferedReader(new FileReader("C-small-attempt0.in")));
		try {
			// Ignore number of cases. The case is a lie.
			input.nextInt();
			System.out.println("Case #1:");
			int length = input.nextInt();
			int coinsToGenerate = input.nextInt();
			
			int max = (int) Math.pow(2, length);
			int min = (max / 2) + 1;

			primeSieve(((int) Math.sqrt(Long.parseLong(Integer.toString(max, 2)))) + 1);
			
			Integer currentValue = min;
			List<String> foundJamCoins = new ArrayList<>();
			while (currentValue < max && foundJamCoins.size() < coinsToGenerate) {
				String jamCoinCandidate = Integer.toString(currentValue, 2);
				if (isValidJamCoin(jamCoinCandidate)) {
					foundJamCoins.add(jamCoinCandidate);
				}
				currentValue = currentValue + 2;
			}
			for (String coin : foundJamCoins) {
				printCoinWithDivisors(coin);
			}
			
		} finally {
			input.close();
		}
	}
	

	private static void printCoinWithDivisors(String coin) {
		System.out.print(coin);
		for (int base = 2; base <= 10; base++) {
			long number = Long.parseLong(coin, base);
			int divisor = findFirstNonTrivialDivisor(number);
			System.out.print(" " + divisor);
		}
		System.out.println();
	}


	private static int findFirstNonTrivialDivisor(long number) {
		for (int i = 2; i < number; i++) {
			if (primes.get(i) && number % i == 0) {
				return i;
			}
		}
		
		return 0;
	}


	private static boolean isValidJamCoin(String binaryString) {
		//String binaryString = binaryValue.toString();
		for (int base = 2; base <= 10; base++) {
			
			if (isPrime(Long.parseLong(binaryString, base))) {
				return false;
			}
		}
		return true;
	}

	private static boolean isPrime(Long longValue) {
		for (int i = 2; i < (int) Math.sqrt(longValue); i++) {
			if (primes.get(i) && longValue % i == 0) {
				return false;
			}
		}
		
		return true;
	}

	private static void primeSieve(long l) {
		long limit = l;
        // initially assume all integers are prime
        primes = new BitSet((int) limit);
        primes.set(0, (int) limit);

        // mark non-primes <= N using Sieve of Eratosthenes
        for (long i = 2; i*i <= limit; i++) {
            if (primes.get((int) i)) {
                for (long j = i; i*j <= limit; j++) {
                    primes.clear((int)(i*j));
                }
            }
        }
	}
	

}
