import java.io.FileReader;
import java.io.BufferedReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.List;
import java.util.Scanner;

public class C {
	static BitSet primes;
	// Not real need to get very high, the range is very big, so we can find multiples of the first 100000 primes only :)
	static int maxPrime = 100000;
	public static void main(String[] args) throws IOException {
		Scanner input = new Scanner(new BufferedReader(new FileReader("C-large.in")));
		try {
			// Ignore number of cases. The case is a lie.
			input.nextInt();
			System.out.println("Case #1:");
			int length = input.nextInt();
			int coinsToGenerate = input.nextInt();
			
			long max = (long) Math.pow(2, length);
			long min = (max / 2) + 1;

			primeSieve(maxPrime);//((int) Math.sqrt(Long.parseLong(Integer.toString(max, 2)))) + 1);
			
			Long currentValue = min;
			List<String> foundJamCoins = new ArrayList<>();
			while (currentValue < max && foundJamCoins.size() < coinsToGenerate) {
				String jamCoinCandidate = Long.toString(currentValue, 2);
				if (isValidJamCoin(jamCoinCandidate)) {
					foundJamCoins.add(jamCoinCandidate);
				}
				currentValue = currentValue + 2;
			}
			for (String coin : foundJamCoins) {
				printCoinWithDivisors(coin);
			}
			
			//System.out.println("FOUND " + foundJamCoins.size());
			
		} finally {
			input.close();
		}
	}
	

	private static void printCoinWithDivisors(String coin) {
		System.out.print(coin);
		for (int base = 2; base <= 10; base++) {
			int divisor = findFirstNonTrivialDivisor(new BigInteger(coin, base));
			System.out.print(" " + divisor);
		}
		System.out.println();
	}


	private static int findFirstNonTrivialDivisor(BigInteger number) {
		for (int i = 2; i < maxPrime; i++) {
			if (primes.get(i)) {
				if (number.mod(new BigInteger("" + i)).equals(BigInteger.ZERO)) {
					return i;
				}
			}
		}
		
		return 0;
	}


	private static boolean isValidJamCoin(String binaryString) {
		//String binaryString = binaryValue.toString();
		for (int base = 2; base <= 10; base++) {		
			if (isPrime(new BigInteger(binaryString, base))) {
				return false;
			}
		}
		return true;
	}

	private static boolean isPrime(BigInteger bigInteger) {
		for (int i = 2; i < maxPrime; i++) {
			if (primes.get(i) && i != bigInteger.intValue()) {
				if (bigInteger.mod(new BigInteger("" + i)).equals(BigInteger.ZERO)) {
					return false;
				}
			}
		}
		
		return true;
	}

	private static void primeSieve(long l) {
		long limit = l;
        // initially assume all integers are prime
        primes = new BitSet((int) limit);
        primes.set(0, (int) limit);

        // mark non-primes <= N using Sieve of Eratosthenes
        for (long i = 2; i*i <= limit; i++) {
            if (primes.get((int) i)) {
                for (long j = i; i*j <= limit && 0 < (int) (i*j); j++) {
                    primes.clear((int)(i*j));
                }
            }
        }
	}
	

}
