import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

public class PancakesHouse3 {

	public static void main(String[] args) {
		try {
			solve(args);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void solve(String[] args) throws IOException {
		String fileName = "B-small-attempt5.in";
		BufferedReader input = new BufferedReader(new FileReader(fileName));
		
		int numberOfCases = Integer.parseInt(input.readLine());
		for (int i = 0; i < numberOfCases; i++) {
			input.readLine(); // ignore people with food
			String dishAmounts[] = input.readLine().split(" ");
			List<Integer> diners = new ArrayList<>(dishAmounts.length);
			for (String dishAmount : dishAmounts) {
				diners.add(Integer.parseInt(dishAmount));
			}
			
			System.out.println("Case #" + (i + 1) + ": " + solve(diners));
		}
		
		
		input.close();
	}
	
	private static int solve(List<Integer> diners) {
		int maxValue = findMax(diners);
		int maxValueCount = findMaxValueCount(maxValue, diners);
		
		if (maxValue <= 3) {
			return maxValue;
		}
		int candidateSolution = maxValue;
		int newSolution;
		switch (maxValue) {
		case 4:
		case 5:
		case 6:
		case 7:			
			List<Integer> reducedDinersA = reduceMaxValue(maxValue,maxValue / 2, diners);
			newSolution = maxValueCount + solve(reducedDinersA);
			if (newSolution < candidateSolution) {
				candidateSolution = newSolution;
			}
		break; 
		case 8:
			List<Integer> reducedDinersB = reduceMaxValue(maxValue,4, diners);
			newSolution = maxValueCount + solve(reducedDinersB);
			if (newSolution < candidateSolution) {
				candidateSolution = newSolution;
			}
			reducedDinersB = reduceMaxValue(maxValue,5, diners);
			newSolution = maxValueCount + solve(reducedDinersB);
			if (newSolution < candidateSolution) {
				candidateSolution = newSolution;
			}
			break;
		case 9:
			List<Integer> reducedDinersC = reduceMaxValue(maxValue,6, diners);
			newSolution = maxValueCount + solve(reducedDinersC);
			if (newSolution < candidateSolution) {
				candidateSolution = newSolution;
			}
			reducedDinersC = reduceMaxValue(maxValue,5, diners);
			newSolution = maxValueCount + solve(reducedDinersC);
			if (newSolution < candidateSolution) {
				candidateSolution = newSolution;
			}
			break;
		}
		
		return candidateSolution;
	}

	private static List<Integer> reduceMaxValue(int maxValue, int valueToMove,
			List<Integer> diners) {
		List<Integer> reducedDiners = new ArrayList<Integer>(diners);
		int maxValueIndex = reducedDiners.indexOf(maxValue);
		while(maxValueIndex >= 0) {
			reducedDiners.set(maxValueIndex, maxValue - valueToMove);
			reducedDiners.add(valueToMove);
			maxValueIndex = reducedDiners.indexOf(maxValue);
		}
		/*System.out.print("Reduced diners [");
		for (int i = 0; i < reducedDiners.size(); i++) {
			System.out.print(reducedDiners.get(i));
			if (i + 1 < reducedDiners.size()) {
				System.out.print(" ");
			} else {
				System.out.println("]");
			}
		}*/
		return reducedDiners;
	}

	private static int findMax(List<Integer> diners) {
		int max = 0;
		for (int pancakes : diners) {
			if (pancakes > max) {
				max = pancakes;
			}
		}
		return max;
	}

	private static int findMaxValueCount(int maxValue, List<Integer> diners) {
		int count = 0;
		for (int value : diners) {
			if (value == maxValue) {
				count++;
			}
		}
		
		return count;
	}
}