import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.List;
import java.util.Scanner;

public class CodeJamC {

	public static void main(String[] args) throws IOException {
		Scanner input = new Scanner(new BufferedReader(new FileReader("C-small-1-attempt0.in")));
		try {
			int testCases = input.nextInt();
			for (int i = 1; i <= testCases; i++) {
				System.out.println("Case #" + i + ": " + solveTestCase(input));
			}
		} finally {
			input.close();
		}
	}

	private static String solveTestCase(Scanner input) {
		int stalls = input.nextInt();
		int people = input.nextInt();

		BitSet bitset = new BitSet(stalls);
		bitset.set(0);
		bitset.set(stalls + 1);

		for (int i = 1; i < people; i++) {
			findAndSetBestPosition(bitset, stalls + 2, true);
		}
		
		int bestPosition = findAndSetBestPosition(bitset, stalls + 2, false);
		int ls = bitset.previousSetBit(bestPosition - 1) == -1 ? 0 : bestPosition - bitset.previousSetBit(bestPosition - 1) - 1;
		int rs = bitset.nextSetBit(bestPosition + 1) == -1 ? 0 : bitset.nextSetBit(bestPosition + 1) - bestPosition - 1;

		int minComponent = Math.min(ls, rs);
		int maxComponent = Math.max(ls, rs);

		return maxComponent + " " + minComponent;
	}

	private static int findAndSetBestPosition(BitSet bitset, int size, boolean set) {
		int bestPosition = 0;
		int minComponent = -1;
		int maxComponent = -1;

		for (int i = 1; i < size; i++) {
			int ls = bitset.previousSetBit(i) == -1 ? 0 : i - bitset.previousSetBit(i) - 1;
			int rs = bitset.nextSetBit(i) == -1 ? 0 : bitset.nextSetBit(i) - i - 1;

			if (Math.min(ls, rs) > minComponent || (Math.min(ls, rs) == minComponent && Math.max(ls,rs) > maxComponent)) {
				bestPosition = i;
				minComponent = Math.min(ls, rs);
				maxComponent = Math.max(ls, rs);
			} 
		}

		if (set) {
			bitset.set(bestPosition);
		}
		return bestPosition;
	}

}
