import java.io.FileReader;
import java.io.BufferedReader;
import java.io.IOException;
import java.util.Scanner;

public class B {

	public static void main(String[] args) throws IOException {
		Scanner input = new Scanner(new BufferedReader(new FileReader("B-large.in")));
		try {
			int testCases = input.nextInt();
			for (int i = 1; i <= testCases; i++) {
				String pancakeStack = input.next();
				while (pancakeStack.contains("--")) {
					pancakeStack = pancakeStack.replaceAll("--", "-");
				}
				while (pancakeStack.contains("++")) {
					pancakeStack = pancakeStack.replaceAll("\\+\\+", "+");
				}

				int flips = 0;
				// Any happy pancakes on the bottom of the stack won't ever need to be moved, so we can dispose of them
				pancakeStack = trimEnd(pancakeStack);
				
				while (pancakeStack.length() > 0) {
					if (pancakeStack.startsWith("+")) {
						// Having a plus at the top does not work, as it would sink a minus to the bottom, we have to flip it alone first
						pancakeStack = '-' + pancakeStack.substring(1);
						flips++;
					}
					pancakeStack = invert(pancakeStack);
					flips++;
					pancakeStack = trimEnd(pancakeStack);
				}
				
				System.out.println("Case #" + i + ": " + flips);
				
			}
		} finally {
			input.close();
		}
	}

	// We can do it like this, without stringbuilder or anything because the strings are small (100chars in the worst case) 
	// and whenever we call this method there will be at most 2 characters to remove.
	private static String trimEnd(String pancakeStack) {
		String result = pancakeStack;
		while (result.endsWith("+")) {
			result = result.substring(0, result.length() - 1);
		}
		return result;
	}
	
	private static String invert(String pancakeStack) {
		StringBuilder result = new StringBuilder();
		
		for (char character : pancakeStack.toCharArray()) {
			if (character == '+') {
				result.insert(0, '-');
			} else {
				result.insert(0, '+');
			}
		}
		return result.toString();
	}

}
