import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Scanner;

public class CodeJamB {

	public static void main(String[] args) throws IOException {
		Scanner input = new Scanner(new BufferedReader(new FileReader("B-large.in")));
		try {
			int testCases = input.nextInt();
			for (int i = 1; i <= testCases; i++) {
				System.out.println("Case #" + i + ": " + solveTestCase(input));
			}
		} finally {
			input.close();
		}
	}

	private static String solveTestCase(Scanner input) {
		String result = input.next();
		
		while (!isTidyNumber(result)) {
			result = resolveTidiness(result);
		}
		while (result.length() > 1 && result.charAt(0) == '0') {
			result = result.substring(1);
		}
		return result;
	}
	
	private static String resolveTidiness(String finalNumber) {
		boolean convertToNine = false;
		String result = "";
		for (int i = 0; i < finalNumber.length() - 1; i++) {
			
			int firstDigit = Integer.parseInt("" + finalNumber.charAt(i));
			int secondDigit = Integer.parseInt("" + finalNumber.charAt(i + 1));
			
			if (convertToNine) {
				result = result + '9';
			} else if (firstDigit > secondDigit) {
				result = result + (firstDigit == 0 ? 9 : firstDigit - 1);
				convertToNine = true;
			} else {
				result = result + firstDigit;
			}
		}
		result = result + (convertToNine ? '9' : finalNumber.charAt(finalNumber.length() + 1));
		
		return result;
	}

	private static boolean isTidyNumber(String number) {
		for (int i = 0; i < number.length() - 1; i++) {
			int digitA = Integer.parseInt("" + number.charAt(i));
			int digitB = Integer.parseInt("" + number.charAt(i + 1));
			if (digitA > digitB) {
				return false;
			}
		}
		return true;
	}

}
