import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class BAlternative {

	public static void main(String[] args) throws IOException {
		Scanner input = new Scanner(new BufferedReader(new FileReader("B-small-attempt1.in")));
		try {
			int testCases = input.nextInt();
			for (int i = 1; i <= testCases; i++) {
				int squadSize = input.nextInt();
				List<SquadRow> squadRows = new ArrayList<>();
				
				for (int rows = 0; rows < (2 * squadSize - 1); rows++) {
					SquadRow row = new SquadRow();
					for (int soldier = 0; soldier < squadSize; soldier++) {
						row.add(input.nextInt());
					}
					squadRows.add(row);
				}
				
				Collections.sort(squadRows);
				//System.out.println(squadRows);

				// We start assuming it's last row, because we won't ever check that one, so if we check all squadSize - 1 and all are there, that's the missing one
				int missingRow = squadSize - 1;
				for (int currentDiagonal = 0; currentDiagonal < squadSize - 1; currentDiagonal++){
					SquadRow rowA = squadRows.get(currentDiagonal * 2);
					SquadRow rowB = squadRows.get((currentDiagonal * 2) + 1);
					if (rowA.get(currentDiagonal) != rowB.get(currentDiagonal)) {
						missingRow = currentDiagonal;
						break;
					}
				}
				
				SquadRow validEquivalentRow = squadRows.get(missingRow * 2);
				
				//System.out.println(validEquivalentRow);
				
				// Let's check in what subgroup it fits, odds or evens
				SquadRow answer = new SquadRow();
				
				for (int diagonal = 0; diagonal < missingRow; diagonal++) {
					SquadRow rowA = squadRows.get(diagonal * 2);
					SquadRow rowB = squadRows.get((diagonal * 2) + 1);
					if (rowA.get(missingRow) != validEquivalentRow.get(diagonal)) {
						answer.add(rowA.get(missingRow));
					} else {
						answer.add(rowB.get(missingRow));
					}
				}
				
				answer.add(validEquivalentRow.get(missingRow));
				
				for (int diagonal = missingRow + 1; diagonal < squadSize; diagonal++) {
					SquadRow rowA = squadRows.get(diagonal * 2 - 1);
					SquadRow rowB = squadRows.get((diagonal * 2));
					if (rowA.get(missingRow) != validEquivalentRow.get(diagonal)) {
						answer.add(rowA.get(missingRow));
					} else {
						answer.add(rowB.get(missingRow));
					}
				}
				
				System.out.print("Case #" + i + ": ");
				System.out.print(answer.get(0));
				for (int soldier = 1; soldier < squadSize; soldier++) {
					System.out.print(" " + answer.get(soldier));
				}
				System.out.println();
				
			}
		} finally {
			input.close();
		}
	}
	
	public static class SquadRow extends ArrayList<Integer> implements Comparable<SquadRow> {

		@Override
		public int compareTo(SquadRow o) {
			for (int i = 0; i < size(); i++) {
				int comparison = Integer.compare(get(i), o.get(i));
				if (comparison != 0) {
					return comparison;
				}
			}
			
			return 0;
		}
		
	}
}
