package qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

public class FairWarning {

	private File inputFile = new File("D:/Documents/WORK/GoogleCodeJam/2009/Qualification/FairWarning/B-small-attempt1.in");
	private File outputFile = new File("D:/Documents/WORK/GoogleCodeJam/2009/Qualification/FairWarning/B-large.out");
	
	public static void main(String[] args) {
		FairWarning testDrive = new FairWarning();
//		BigInteger a = new BigInteger("7090");
//		BigInteger b = new BigInteger("4111");
//		BigInteger c = new BigInteger("4112");
//		BigInteger[] bigArray = new BigInteger[3];
//		bigArray[0] = a;
//		bigArray[1] = b;
//		bigArray[2] = c;
//		String r = testDrive.calTime(bigArray);
		testDrive.loadCalWrite();
	}
	
	public void loadCalWrite(){
		BufferedReader bReader = null;
		BufferedWriter bWriter = null;
		String thisLine = new String();
		try {
			bReader = new BufferedReader(new FileReader(inputFile));
			bWriter = new BufferedWriter(new FileWriter(outputFile));
			bReader.readLine();
			int index = 1;
			while((thisLine = bReader.readLine())!=null){
				String[] stringArray = thisLine.split(" ");
				Set<String> aSet = new HashSet<String>();
				for(int i=1; i<stringArray.length; ++i){
					aSet.add(stringArray[i]);
				}
				int numberOfEvents = aSet.size();
				BigInteger[] inputBigNumbers = new BigInteger[numberOfEvents];
				int inputBigNumbersIndex = 0;
				for(String aString : aSet){
					inputBigNumbers[inputBigNumbersIndex] = new BigInteger(aString);
					++inputBigNumbersIndex;
				}
				String output = calTime(inputBigNumbers);
				bWriter.write("Case #"+index+": "+output+"\n");
				index++;
			}
			bReader.close();
			bWriter.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private String calTime(BigInteger[] inputBigNumbers){
		Arrays.sort(inputBigNumbers);
		BigInteger[] numbersDifference = new BigInteger[inputBigNumbers.length - 1];
		BigInteger result = null;
		for(int i=1; i<inputBigNumbers.length; ++i){
			numbersDifference[i-1] = inputBigNumbers[i].subtract(inputBigNumbers[i-1]);
		}
		BigInteger aGCD = calGCD(numbersDifference);
		if(aGCD.compareTo(inputBigNumbers[0]) < 0){
			BigInteger aDivision = inputBigNumbers[0].divide(aGCD);
			if(aDivision.multiply(aGCD).equals(inputBigNumbers[0])){
				result = BigInteger.ZERO;
			}else{
				result = aDivision.add(BigInteger.ONE).multiply(aGCD).subtract(inputBigNumbers[0]);
			}
		}else{
			result = aGCD.subtract(inputBigNumbers[0]);
		}
		System.out.println(result);
		return result.toString();
	}
	
	private BigInteger calGCD(BigInteger[] inputBigNumbers){
		if(inputBigNumbers.length == 1){
			return inputBigNumbers[0];
		}else{
			Arrays.sort(inputBigNumbers);
			BigInteger[] smallerInputBigNumbers = new BigInteger[inputBigNumbers.length-1];
			for(int i=1; i<inputBigNumbers.length; ++i){
				smallerInputBigNumbers[i-1] = inputBigNumbers[i].gcd(inputBigNumbers[i-1]);
			}
			return calGCD(smallerInputBigNumbers);
		}
	}
	
}
