package qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class ThemePark {

	private File inputFile = new File("D:/Documents/WORK/GoogleCodeJam/2009/Qualification/ThemePark/C-large.in");
	private File outputFile = new File("D:/Documents/WORK/GoogleCodeJam/2009/Qualification/ThemePark/A-large.out");
	
	public static void main(String[] args) {
		ThemePark testDrive = new ThemePark();
		testDrive.loadCalWrite();
	}

	public void loadCalWrite(){
		BufferedReader bReader = null;
		BufferedWriter bWriter = null;
		String thisLine = new String();
		try {
			bReader = new BufferedReader(new FileReader(inputFile));
			bWriter = new BufferedWriter(new FileWriter(outputFile));
			bReader.readLine();
			int index = 1;
			while((thisLine = bReader.readLine())!=null){
				String[] stringArray = thisLine.split(" ");
				long R = Long.parseLong(stringArray[0]);
				long k = Long.parseLong(stringArray[1]);
				thisLine = bReader.readLine();
				stringArray = thisLine.split(" ");
				long[] longArray = new long[stringArray.length];
				for(int i=0; i<stringArray.length; ++i){
					longArray[i] = Long.parseLong(stringArray[i]);
				}
				long earnings = earningCal(R, k, longArray);
				bWriter.write("Case #"+index+": "+earnings+"\n");
				index++;
			}
			bReader.close();
			bWriter.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private long earningCal(long R, long k, long[] longArray){
		int[] nextIndexArray = new int[longArray.length];
		long[] nextEarningArray = new long[longArray.length];
		List<Integer> newIndexList = new ArrayList<Integer>();
		List<Integer> circleList = null;
		for(int i=0; i<longArray.length; ++i){
			int nextIndex = i;
			long nextEarning = longArray[i];
			int boundaryGuard = 1;
			while(nextEarning + longArray[(nextIndex+1)%longArray.length] <= k && boundaryGuard < longArray.length){
				nextEarning += longArray[(nextIndex+1)%longArray.length];
				nextIndex = (nextIndex+1)%longArray.length;
				++boundaryGuard;
			}
			nextIndexArray[i] = (nextIndex+1)%longArray.length;
			nextEarningArray[i] = nextEarning;
		}
		
		int currentIndex = 0;
		newIndexList.add(currentIndex);
		while(!newIndexList.contains(nextIndexArray[currentIndex]) ){
			currentIndex = nextIndexArray[currentIndex];
			newIndexList.add(currentIndex);
		}
		int startCirle = nextIndexArray[currentIndex];
		for(int i=0; i<newIndexList.size(); ++i){
			if(newIndexList.get(i) == startCirle){
				circleList = newIndexList.subList(i, newIndexList.size());
				newIndexList = newIndexList.subList(0, i);
				break;
			}
		}
		
		int cHead = newIndexList.size();
		long cHeadEarnings = 0;
		int cBody = circleList.size();
		long cBodyEarnings = 0;
		long earnings = 0;
		for(Integer aInt : newIndexList){
			cHeadEarnings += nextEarningArray[aInt];
		}
		for(Integer aInt : circleList){
			cBodyEarnings += nextEarningArray[aInt];
		}
		
		if(R <= cHead){
			for(int i=0; i<R; ++i){
				earnings += nextEarningArray[newIndexList.get(i)];
			}
		}else{
			long rMinusHead = R - cHead;
			long cTail = rMinusHead % cBody;
			long cTailEarnings = 0;
			for(int i=0; i<cTail; ++i){
				cTailEarnings += nextEarningArray[circleList.get(i)];
			}
			long bodyNum = rMinusHead / cBody;
			long bodyNumEarnings = bodyNum * cBodyEarnings;
			earnings = bodyNumEarnings + cHeadEarnings + cTailEarnings;
		}
		System.out.println(earnings);
		return earnings;
	}
}
