import java.io.*;
import java.math.BigInteger;
import java.util.*;

/**
 * User: dizem@126.com
 * Time: 11-5-7 上午8:32
 */
public class Magicka implements Runnable {
	private InputReader in;
	private PrintWriter out;

	public static void main(String[] args) {
		new Thread(new Magicka()).start();
	}

	public Magicka() {
		try {
			System.setIn(new FileInputStream("input.txt"));
			System.setOut(new PrintStream(new FileOutputStream("output.txt")));
		} catch (FileNotFoundException e) {
			throw new RuntimeException();
		}
		in = new InputReader(System.in);
		out = new PrintWriter(System.out);
	}

	Map<String, String> combineMap = new HashMap<String, String>();
	List<String> opposedList = new ArrayList<String>();

	public void run() {
		int numTests = in.readInt();
		for (int testNumber = 0; testNumber < numTests; testNumber++) {
			out.print("Case #" + (testNumber + 1) + ": ");
			int c = in.readInt();
			combineMap.clear();
			for (int i = 0; i < c; ++i) {
				String s = in.readString();
				combineMap.put(s.substring(0, 2), s.substring(2));
			}
			c = in.readInt();
			for (int i = 0; i < c; ++i) {
				opposedList.add(in.readString());
			}
			c = in.readInt();
			str = in.readString();
			solve();
		}
		out.close();
	}

	private String str;

	private void solve() {
		String result = "";
		while (str.length() > 0) {
			if (str.length() == 1) {
				result += str;
				break;
			}

			String s = str.substring(0, 2);
			String s1 = "" + s.charAt(1) + s.charAt(0);


			if (combineMap.containsKey(s)) {
				result += combineMap.get(s);
				str = str.substring(2);

			} else if (combineMap.containsKey(s1)) {
				result += combineMap.get(s1);
				str = str.substring(2);

			} else {
				boolean flag = false;
				for (String opposedStr : opposedList) {
					if (opposedStr.charAt(0) == str.charAt(0)) {
						int index = str.substring(1).indexOf(opposedStr.charAt(1));
						if (index != -1 && !canCombine(index)) {
							flag = true;
							str = str.substring(index + 2);
							break;
						}
					} else if (opposedStr.charAt(1) == str.charAt(0)) {
						int index = str.substring(1).indexOf(opposedStr.charAt(0));

						if (index != -1 && !canCombine(index)) {
							flag = true;
							str = str.substring(index + 2);
							break;
						}
					}
				}
				if (!flag) {
					result += str.charAt(0);
					str = str.substring(1);
				}
			}

		}

		out.print("[");
		for (int i = 0; i < result.length(); ++i) {
			out.print(result.charAt(i));
			if (i != result.length() - 1) {
				out.print(", ");
			}
		}
		out.println("]");
	}


	private boolean canCombine(int index) {
		if (index > 0) {
			if (combineMap.containsKey("" + str.charAt(index) + str.charAt(index - 1))
					|| combineMap.containsKey("" + str.charAt(index - 1) + str.charAt(index)))
				return true;
		}
		if (index < str.length()) {
			if (combineMap.containsKey("" + str.charAt(index) + str.charAt(index + 1))
					|| combineMap.containsKey("" + str.charAt(index + 1) + str.charAt(index)))
				return true;
		}
		return false;
	}

	private static class InputReader {
		private InputStream stream;
		private byte[] buf = new byte[1000];
		private int curChar, numChars;

		public InputReader(InputStream stream) {
			this.stream = stream;
		}

		private int read() {
			if (numChars == -1)
				throw new InputMismatchException();
			if (curChar >= numChars) {
				curChar = 0;
				try {
					numChars = stream.read(buf);
				} catch (IOException e) {
					throw new InputMismatchException();
				}
				if (numChars <= 0)
					return -1;
			}
			return buf[curChar++];
		}

		public int readInt() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			int sgn = 1;
			if (c == '-') {
				sgn = -1;
				c = read();
			}
			int res = 0;
			do {
				if (c < '0' || c > '9')
					throw new InputMismatchException();
				res *= 10;
				res += c - '0';
				c = read();
			} while (!isSpaceChar(c));
			return res * sgn;
		}

		public long readLong() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			int sgn = 1;
			if (c == '-') {
				sgn = -1;
				c = read();
			}
			long res = 0;
			do {
				if (c < '0' || c > '9')
					throw new InputMismatchException();
				res *= 10;
				res += c - '0';
				c = read();
			} while (!isSpaceChar(c));
			return res * sgn;
		}

		public String readString() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			StringBuffer res = new StringBuffer();
			do {
				res.appendCodePoint(c);
				c = read();
			} while (!isSpaceChar(c));
			return res.toString();
		}

		private boolean isSpaceChar(int c) {
			return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
		}

		private String readLine0() {
			StringBuffer buf = new StringBuffer();
			int c = read();
			while (c != '\n' && c != -1) {
				buf.appendCodePoint(c);
				c = read();
			}
			return buf.toString();
		}

		public String readLine() {
			String s = readLine0();
			while (s.trim().length() == 0)
				s = readLine0();
			return s;
		}

		public String readLine(boolean ignoreEmptyLines) {
			if (ignoreEmptyLines)
				return readLine();
			else
				return readLine0();
		}

		public BigInteger readBigInteger() {
			try {
				return new BigInteger(readString());
			} catch (NumberFormatException e) {
				throw new InputMismatchException();
			}
		}

		public char readCharacter() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			return (char) c;
		}

		public double readDouble() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			int sgn = 1;
			if (c == '-') {
				sgn = -1;
				c = read();
			}
			double res = 0;
			while (!isSpaceChar(c) && c != '.') {
				if (c < '0' || c > '9')
					throw new InputMismatchException();
				res *= 10;
				res += c - '0';
				c = read();
			}
			if (c == '.') {
				c = read();
				double m = 1;
				while (!isSpaceChar(c)) {
					if (c < '0' || c > '9')
						throw new InputMismatchException();
					m /= 10;
					res += (c - '0') * m;
					c = read();
				}
			}
			return res * sgn;
		}
	}
}
