import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.InputMismatchException;
import java.util.List;

/**
 * User: dizem@126.com
 * Time: 11-5-7 上午8:32
 */
public class BotTrust implements Runnable {
	private InputReader in;
	private PrintWriter out;

	public static void main(String[] args) {
		new Thread(new BotTrust()).start();
	}

	public BotTrust() {
		try {
			System.setIn(new FileInputStream("input.txt"));
			System.setOut(new PrintStream(new FileOutputStream("output.txt")));
		} catch (FileNotFoundException e) {
			throw new RuntimeException();
		}
		in = new InputReader(System.in);
		out = new PrintWriter(System.out);
	}

	private class Task {
		int pos;
		int index;

		private Task(int pos, int index) {
			this.pos = pos;
			this.index = index;
		}
	}

	private List<Task> taskOrange = new ArrayList<Task>();
	private List<Task> taskBlue = new ArrayList<Task>();


	public void run() {
		int numTests = in.readInt();
		for (int testNumber = 0; testNumber < numTests; testNumber++) {
			out.print("Case #" + (testNumber + 1) + ": ");
			int k = in.readInt();
			char bot;
			int pos;
			taskOrange.clear();
			taskBlue.clear();
			for (int i = 0; i < k; ++i) {
				bot = in.readCharacter();
				pos = in.readInt();
				if (bot == 'O') {
					taskOrange.add(new Task(pos, i));
				} else {
					taskBlue.add(new Task(pos, i));
				}
			}
			solve();
		}
		out.close();
	}


	private void solve() {
		int posOrange = 1, posBlue = 1;
		int taskOrangeIndex = 0, taskBlueIndex = 0;
		int time = 0;

		while (taskOrangeIndex < taskOrange.size() || taskBlueIndex < taskBlue.size()) {
//			out.print("index:" + taskOrangeIndex + " " + taskBlueIndex);
//			out.println("  pos:" + posOrange + " " + posBlue + " time = " + time);
			boolean bPushhed = false;
			if (taskBlueIndex < taskBlue.size() && posBlue == taskBlue.get(taskBlueIndex).pos
					&& (taskOrangeIndex >= taskOrange.size() || taskOrange.get(taskOrangeIndex).index > taskBlue.get(taskBlueIndex).index)) {


				taskBlueIndex++;
				bPushhed = true;
//				out.println("b push");

			} else if (taskBlueIndex < taskBlue.size()) {
				posBlue += Math.signum(taskBlue.get(taskBlueIndex).pos - posBlue);
			}


			if (taskOrangeIndex < taskOrange.size() && posOrange == taskOrange.get(taskOrangeIndex).pos
					&& !bPushhed && (taskBlueIndex >= taskBlue.size() || taskBlue.get(taskBlueIndex).index > taskOrange.get(taskOrangeIndex).index)) {
//				out.println(taskOrange.get(taskOrangeIndex).index);
				taskOrangeIndex++;
//				out.println("o push");
			} else if (taskOrangeIndex < taskOrange.size()) {
				posOrange += Math.signum(taskOrange.get(taskOrangeIndex).pos - posOrange);
			}


			time++;
		}

		out.println(time);
	}

	private static class InputReader {
		private InputStream stream;
		private byte[] buf = new byte[1000];
		private int curChar, numChars;

		public InputReader(InputStream stream) {
			this.stream = stream;
		}

		private int read() {
			if (numChars == -1)
				throw new InputMismatchException();
			if (curChar >= numChars) {
				curChar = 0;
				try {
					numChars = stream.read(buf);
				} catch (IOException e) {
					throw new InputMismatchException();
				}
				if (numChars <= 0)
					return -1;
			}
			return buf[curChar++];
		}

		public int readInt() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			int sgn = 1;
			if (c == '-') {
				sgn = -1;
				c = read();
			}
			int res = 0;
			do {
				if (c < '0' || c > '9')
					throw new InputMismatchException();
				res *= 10;
				res += c - '0';
				c = read();
			} while (!isSpaceChar(c));
			return res * sgn;
		}

		public long readLong() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			int sgn = 1;
			if (c == '-') {
				sgn = -1;
				c = read();
			}
			long res = 0;
			do {
				if (c < '0' || c > '9')
					throw new InputMismatchException();
				res *= 10;
				res += c - '0';
				c = read();
			} while (!isSpaceChar(c));
			return res * sgn;
		}

		public String readString() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			StringBuffer res = new StringBuffer();
			do {
				res.appendCodePoint(c);
				c = read();
			} while (!isSpaceChar(c));
			return res.toString();
		}

		private boolean isSpaceChar(int c) {
			return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
		}

		private String readLine0() {
			StringBuffer buf = new StringBuffer();
			int c = read();
			while (c != '\n' && c != -1) {
				buf.appendCodePoint(c);
				c = read();
			}
			return buf.toString();
		}

		public String readLine() {
			String s = readLine0();
			while (s.trim().length() == 0)
				s = readLine0();
			return s;
		}

		public String readLine(boolean ignoreEmptyLines) {
			if (ignoreEmptyLines)
				return readLine();
			else
				return readLine0();
		}

		public BigInteger readBigInteger() {
			try {
				return new BigInteger(readString());
			} catch (NumberFormatException e) {
				throw new InputMismatchException();
			}
		}

		public char readCharacter() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			return (char) c;
		}

		public double readDouble() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			int sgn = 1;
			if (c == '-') {
				sgn = -1;
				c = read();
			}
			double res = 0;
			while (!isSpaceChar(c) && c != '.') {
				if (c < '0' || c > '9')
					throw new InputMismatchException();
				res *= 10;
				res += c - '0';
				c = read();
			}
			if (c == '.') {
				c = read();
				double m = 1;
				while (!isSpaceChar(c)) {
					if (c < '0' || c > '9')
						throw new InputMismatchException();
					m /= 10;
					res += (c - '0') * m;
					c = read();
				}
			}
			return res * sgn;
		}
	}
}
