package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class CandySplitting {
    static boolean ordered = true;

    // liste construite par la recursion
    static int[] liste;

    static List<int[]> partitionList = new ArrayList<int[]>();
    static List<int[]> invertPartitionList = new ArrayList<int[]>();
    
    /**
     * @param args
     */
    public static void main(String[] args) {
	File file = new File("H:/codejam/C-small-attempt2.in");
	FileInputStream fis;

	try {
	    fis = new FileInputStream(file);
	    BufferedReader reader = new BufferedReader(new InputStreamReader(
		    fis));
	    BufferedWriter out = new BufferedWriter(new FileWriter(
		    "H:/codejam/candysplit.out"));
	    int numberOfTestCases = Integer.parseInt(reader.readLine());
	    for (int i = 0; i < numberOfTestCases; i++) {
		int numberOfCandies = Integer.parseInt(reader.readLine());
		String[] data = reader.readLine().split(" ");
		int[] candyValues = new int[numberOfCandies];
		for (int k = 0; k < numberOfCandies; k++) {
		    candyValues[k] = Integer.parseInt(data[k]);
		}
		int middle=numberOfCandies;
		
		boolean foundResult = false;
		int seanResult = 0;
		for(int k = 1;k<middle;k++){
		    partition(0,numberOfCandies,k);
		    
		    Iterator<int[]> oneIt = partitionList.iterator();
		    Iterator<int[]> twoIt = invertPartitionList.iterator();
		    while(oneIt.hasNext()){
			int[] partOne = oneIt.next();
			int[] partTwo = twoIt.next();
			int resultOne = 0;
			int realResOne = 0;
			for(int l=0;l<partOne.length;l++){
			    resultOne = resultOne^candyValues[partOne[l]];
			    realResOne+=candyValues[partOne[l]];
			}
			int resultTwo = 0;
			int realResTwo = 0;
			for(int m=0;m<partTwo.length;m++){
			    resultTwo = resultTwo^candyValues[partTwo[m]];
			    realResTwo+=candyValues[partTwo[m]];
			}
			if(resultOne==resultTwo){
			    foundResult=true;
			    if(seanResult<realResTwo||seanResult<realResOne){
				seanResult=Math.max(realResTwo, realResOne);
			    }
			    
			}
		    }
		    partitionList.clear();
		    invertPartitionList.clear();
		}
		
		out.write("Case #" + (i + 1) + ": ");
		if(foundResult){
		    out.write(""+seanResult);
		}else{
		    out.write("NO");
		}
		out.write("\n");
		out.flush();
	    }
	    out.close();
	} catch (FileNotFoundException e) {
	    e.printStackTrace();
	} catch (NumberFormatException e) {
	    e.printStackTrace();
	} catch (IOException e) {
	    e.printStackTrace();
	} catch (ArrayIndexOutOfBoundsException e) {
	    e.printStackTrace();
	}
    }

    // construction recursive des listes possibles
    public static void partition(int index,int number,int order) {
    	if (index>=order) {
    	    partitionList.add(liste.clone());
    	    int[] invertList = new int[number-liste.length];
    	    int curIndex = 0;
    	    for(int i=0;i<number;i++){
    		if(!arrayContains(liste,i)){
    		    invertList[curIndex]=i;
    		    curIndex++;
    		}
    	    }
    	    invertPartitionList.add(invertList);
    	    return;
    	}
    	
    	// ajoute un nouvel element candidat dans la liste
    	// - sans ordre -> candidat: tous les elements
    	// - avec ordre -> candidat: seulement les elements suprieurs au prcdant
     
    	int start=0;
    	if(index==0){
    	    liste=new int[order];
    	}
    	if (ordered && index>0) start=liste[index-1]+1;
    	
    	for(int i=start;i<number;i++) {
    		liste[index]=i;
    		partition(index+1,number,order);
    	}
    }
    
    public static boolean arrayContains(int[] array, int number){
	for(int i = 0;i<array.length;i++){
	    if(array[i]==number){
		return true;
	    }
	}
	return false;
    }
}
