package gcj;

import java.io.*;
import java.util.*;

public class A {
	public static void main(String[] args) throws FileNotFoundException {
		writer = new PrintWriter("src\\gcj\\output");
		solveAllTests();
		writer.close();
	}

	private static void solveAllTests() {
		MyScanner sc = new MyScanner();
		int nbTest = sc.nextInt();
		for (int i = 1; i <= nbTest; i++) {
			String s = sc.next();

			String res = solveOneTest(s);
			writer.println("Case #" + i + ": " + res);
		}
	}

	private static String solveOneTest(String s) {
		int[] lettersOccurences = count(s);
		int[] chifOc = new int[10];
		chifOc[0] = handle('Z', lettersOccurences);
		remove(lettersOccurences, chifOc[0], 'Z');
		remove(lettersOccurences, chifOc[0], 'E');
		remove(lettersOccurences, chifOc[0], 'R');
		remove(lettersOccurences, chifOc[0], 'O');

		chifOc[6] = handle('X', lettersOccurences);
		remove(lettersOccurences, chifOc[6], 'S');
		remove(lettersOccurences, chifOc[6], 'I');
		remove(lettersOccurences, chifOc[6], 'X');

		chifOc[2] = handle('W', lettersOccurences);
		remove(lettersOccurences, chifOc[2], 'T');
		remove(lettersOccurences, chifOc[2], 'W');
		remove(lettersOccurences, chifOc[2], 'O');

		chifOc[4] = handle('U', lettersOccurences);
		remove(lettersOccurences, chifOc[4], 'F');
		remove(lettersOccurences, chifOc[4], 'O');
		remove(lettersOccurences, chifOc[4], 'U');
		remove(lettersOccurences, chifOc[4], 'R');

		chifOc[8] = handle('G', lettersOccurences);
		remove(lettersOccurences, chifOc[8], 'E');
		remove(lettersOccurences, chifOc[8], 'I');
		remove(lettersOccurences, chifOc[8], 'G');
		remove(lettersOccurences, chifOc[8], 'H');
		remove(lettersOccurences, chifOc[8], 'T');

		chifOc[1] = handle('O', lettersOccurences);
		remove(lettersOccurences, chifOc[1], 'O');
		remove(lettersOccurences, chifOc[1], 'N');
		remove(lettersOccurences, chifOc[1], 'E');

		chifOc[7] = handle('S', lettersOccurences);
		remove(lettersOccurences, chifOc[7], 'S');
		remove(lettersOccurences, chifOc[7], 'E');
		remove(lettersOccurences, chifOc[7], 'V');
		remove(lettersOccurences, chifOc[7], 'E');
		remove(lettersOccurences, chifOc[7], 'N');

		chifOc[3] = handle('T', lettersOccurences);
		remove(lettersOccurences, chifOc[3], 'T');
		remove(lettersOccurences, chifOc[3], 'H');
		remove(lettersOccurences, chifOc[3], 'R');
		remove(lettersOccurences, chifOc[3], 'E');
		remove(lettersOccurences, chifOc[3], 'E');

		chifOc[5] = handle('F', lettersOccurences);

		chifOc[9] = handle('N', lettersOccurences) / 2;

		return buildRes(chifOc);
	}

	private static String buildRes(int[] chifOc) {
		String res = "";
		for (int i = 0; i < 10; i++) {
			for (int j = 0; j < chifOc[i]; j++) {
				res += i;
			}
		}
		return res;
	}

	private static void remove(int[] lettersOccurences, int n, char c) {
		lettersOccurences[c - 'A'] -= n;

	}

	private static int handle(char c, int[] lettersOccurences) {
		return lettersOccurences[c - 'A'];
	}

	private static void display(int[] letters) {
		for (int i = 0; i < 26; i++) {
			if (letters[i] != 0) {
				System.out.println(i + " " + letters[i]);
			}
		}

	}

	private static int[] count(String s) {
		int[] res = new int[26];
		for (char c : s.toCharArray()) {
			res[c - 'A']++;
		}
		return res;
	}

	static PrintWriter writer;

	// -----------MyScanner class for faster input thx Flatfoot----------
	public static class MyScanner {
		BufferedReader br;
		StringTokenizer st;

		public MyScanner() {
			try {
				this.br = new BufferedReader(new FileReader(new File("input")));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		String next() {
			while (this.st == null || !this.st.hasMoreElements()) {
				try {
					this.st = new StringTokenizer(this.br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return this.st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}

		String nextLine() {
			String str = "";
			try {
				str = this.br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return str;
		}

	}
	// --------------------------------------------------------
}