package gcj17;

import java.io.*;
import java.util.*;
import java.util.Map.Entry;

import gcj17.C.MyScanner;

public class Cmiddle {
	public static void main(String[] args) throws FileNotFoundException {
		writer = new PrintWriter("src\\gcj17\\output");
		solveAllTests();
		writer.close();
	}

	private static void solveAllTests() {
		MyScanner sc = new MyScanner();
		int nbTest = sc.nextInt();
		for (int i = 1; i <= nbTest; i++) {
			int n = sc.nextInt();
			int k = sc.nextInt();
			String res = solveOneTest(n, k);
			writer.println("Case #" + i + ": " + res);
			// writer.println(res);

		}
	}

	static String solveOneTest(int n, int k) {
		TreeMap<Integer, Integer> freeBathroomGroups = new TreeMap<>();
		freeBathroomGroups.put(n, 1);
		for (int i = 1; i < k; i++) {
			Entry<Integer, Integer> biggestEntry = freeBathroomGroups.pollLastEntry();
			if (biggestEntry.getValue() != 1) {
				freeBathroomGroups.put(biggestEntry.getKey(), biggestEntry.getValue() - 1);
			}
			int max = computeMax(biggestEntry.getKey());
			int min = computeMin(biggestEntry.getKey());
			addToMap(freeBathroomGroups, max);
			addToMap(freeBathroomGroups, min);
		}
		int biggestEmptySpot = freeBathroomGroups.lastKey();

		return computeMax(biggestEmptySpot) + " " + computeMin(biggestEmptySpot);
	}

	private static void addToMap(TreeMap<Integer, Integer> freeBathroomGroups, int n) {
		if (!freeBathroomGroups.containsKey(n)) {
			freeBathroomGroups.put(n, 1);
		} else {
			freeBathroomGroups.put(n, freeBathroomGroups.get(n) + 1);
		}

	}

	private static int computeMin(int biggestEmptySpot) {
		return (biggestEmptySpot - 1) / 2;
	}

	private static int computeMax(int biggestEmptySpot) {
		return biggestEmptySpot / 2;
	}

	static PrintWriter writer;

	// -----------MyScanner class for faster input thx Flatfoot----------
	public static class MyScanner {
		BufferedReader br;
		StringTokenizer st;

		public MyScanner() {
			try {
				this.br = new BufferedReader(new FileReader(new File("input")));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		String next() {
			while (this.st == null || !this.st.hasMoreElements()) {
				try {
					this.st = new StringTokenizer(this.br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return this.st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}

		String nextLine() {
			String str = "";
			try {
				str = this.br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return str;
		}

	}
	// --------------------------------------------------------
}