package gcj171B;

import java.io.*;
import java.util.*;

public class B {
	static final String[] col = { "R", "O", "Y", "G", "B", "V" };

	public static void main(String[] args) throws FileNotFoundException {
		writer = new PrintWriter("src\\gcj171B\\output");
		solveAllTests();
		writer.close();
	}

	private static void solveAllTests() {
		MyScanner sc = new MyScanner();
		int nbTest = sc.nextInt();
		for (int i = 1; i <= nbTest; i++) {
			int n = sc.nextInt();
			int[] nb = new int[6];
			int max = 0;
			int maxIndex = 0;
			for (int j = 0; j < 6; j++) {
				nb[j] = sc.nextInt();
				if (nb[j] > max) {
					max = nb[j];
					maxIndex = j;
				}
			}
			String res;
			if (2 * max > n) {
				res = "IMPOSSIBLE";
			} else {
				res = solveOneTest(n, nb, maxIndex);
			}
			writer.println("Case #" + i + ": " + res);
		}
	}

	private static String solveOneTest(int n, int[] nb, int firstMaxIndex) {
		StringBuilder sb = new StringBuilder();
		sb.append(col[firstMaxIndex]);
		nb[firstMaxIndex]--;
		int lastIndex = firstMaxIndex;
		for (int i = 1; i < n; i++) {
			int index = findCurMaxIndex(nb, lastIndex, firstMaxIndex);
			sb.append(col[index]);
			nb[index]--;
			lastIndex = index;
		}
		return sb.toString();
	}

	private static int findCurMaxIndex(int[] nb, int lastIndex, int firstMaxIndex) {
		int curMaxIndex = 0;
		int curMax = -1;
		for (int i = 0; i < 6; i++) {
			if (i == lastIndex) {
				continue;
			}
			if (nb[i] > curMax) {
				curMax = nb[i];
				curMaxIndex = i;
			} else if (nb[i] == curMax && i == firstMaxIndex) {
				curMax = nb[i];
				curMaxIndex = i;
			}
		}
		return curMaxIndex;
	}

	static PrintWriter writer;

	// -----------MyScanner class for faster input thx Flatfoot----------
	public static class MyScanner {
		BufferedReader br;
		StringTokenizer st;

		public MyScanner() {
			try {
				this.br = new BufferedReader(new FileReader(new File("input")));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		String next() {
			while (this.st == null || !this.st.hasMoreElements()) {
				try {
					this.st = new StringTokenizer(this.br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return this.st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}

		String nextLine() {
			String str = "";
			try {
				str = this.br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return str;
		}

	}
	// --------------------------------------------------------
}