package gcj17;

import java.io.*;
import java.util.*;

import gcj17.C.MyScanner;

public class Csmall {
	public static void main(String[] args) throws FileNotFoundException {
		writer = new PrintWriter("src\\gcj17\\output");
		solveAllTests();
		writer.close();
	}

	private static void solveAllTests() {
		MyScanner sc = new MyScanner();
		int nbTest = sc.nextInt();
		for (int i = 1; i <= nbTest; i++) {
			long n = sc.nextLong();
			long k = sc.nextLong();
			String res = solveOneTest(n, k);
			writer.println("Case #" + i + ": " + res);
			// writer.println(res);

		}
	}

	private static String solveOneTest(long n, long k) {
		List<Long> freeBathroomGroups = new LinkedList<>();
		freeBathroomGroups.add(n);
		for (int i = 1; i < k; i++) {
			long biggestEmptySpot = freeBathroomGroups.remove(0);
			long max = computeMax(biggestEmptySpot);
			long min = computeMin(biggestEmptySpot);
			addIfNeeded(freeBathroomGroups, max);
			addIfNeeded(freeBathroomGroups, min);
			Collections.sort(freeBathroomGroups);
			Collections.reverse(freeBathroomGroups);
		}
		long biggestEmptySpot = freeBathroomGroups.remove(0);

		return computeMax(biggestEmptySpot) + " " + computeMin(biggestEmptySpot);
	}

	private static void addIfNeeded(List<Long> freeBathroomGroups, long n) {
		if (n != 0) {
			freeBathroomGroups.add(n);
		}
	}

	private static long computeMin(long biggestEmptySpot) {
		return (biggestEmptySpot - 1) / 2;
	}

	private static long computeMax(long biggestEmptySpot) {
		return biggestEmptySpot / 2;
	}

	static PrintWriter writer;

	// -----------MyScanner class for faster input thx Flatfoot----------
	public static class MyScanner {
		BufferedReader br;
		StringTokenizer st;

		public MyScanner() {
			try {
				this.br = new BufferedReader(new FileReader(new File("input")));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		String next() {
			while (this.st == null || !this.st.hasMoreElements()) {
				try {
					this.st = new StringTokenizer(this.br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return this.st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}

		String nextLine() {
			String str = "";
			try {
				str = this.br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return str;
		}

	}
	// --------------------------------------------------------
}