package gcj17;

import java.io.*;
import java.util.*;

public class A {
	public static void main(String[] args) throws FileNotFoundException {
		writer = new PrintWriter("src\\gcj17\\output");
		solveAllTests();
		writer.close();
	}

	private static void solveAllTests() {
		MyScanner sc = new MyScanner();
		int nbTest = sc.nextInt();
		for (int i = 1; i <= nbTest; i++) {
			String s = sc.next();
			int k = sc.nextInt();
			String res = solveOneTest(s, k);
			writer.println("Case #" + i + ": " + res);
		}
	}

	private static String solveOneTest(String s, int k) {
		boolean[] pancakes = buildPancakesArray(s);
		int count = 0;
		for (int i = 0; i <= s.length() - k; i++) {
			if (!pancakes[i]) {
				count++;
				for (int j = 0; j <= i + k - 1; j++) {
					pancakes[j] = !pancakes[j];
				}
			}
		}
		for (int i = s.length() - k + 1; i < s.length(); i++) {
			if (!pancakes[i]) {
				return "IMPOSSIBLE";
			}
		}
		return count + "";
	}

	private static boolean[] buildPancakesArray(String s) {
		boolean[] res = new boolean[s.length()];
		for (int i = 0; i < s.length(); i++) {
			if (s.charAt(i) == '+') {
				res[i] = true;
			}
		}
		return res;
	}

	static PrintWriter writer;

	// -----------MyScanner class for faster input thx Flatfoot----------
	public static class MyScanner {
		BufferedReader br;
		StringTokenizer st;

		public MyScanner() {
			try {
				this.br = new BufferedReader(new FileReader(new File("input")));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		String next() {
			while (this.st == null || !this.st.hasMoreElements()) {
				try {
					this.st = new StringTokenizer(this.br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return this.st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}

		String nextLine() {
			String str = "";
			try {
				str = this.br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return str;
		}

	}
	// --------------------------------------------------------
}