package gcj2;

import java.io.*;
import java.util.*;

public class A {
	public static void main(String[] args) throws FileNotFoundException {
		writer = new PrintWriter("output");
		solveAllTests();
		writer.close();
	}

	static int R;
	static int C;
	static String[][] tab;

	private static void solveAllTests() {
		MyScanner sc = new MyScanner();
		int nbTest = sc.nextInt();
		for (int i = 1; i <= nbTest; i++) {
			R = sc.nextInt();
			C = sc.nextInt();
			tab = new String[C][R];
			for (int y = R - 1; y >= 0; y--) {
				String row = sc.next();
				for (int x = 0; x < C; x++) {
					tab[x][y] = row.substring(x, x + 1);
				}
			}
			int res = solveOneTest();
			if (res >= 0) {
				writer.println("Case #" + i + ": " + res);
			} else {
				writer.println("Case #" + i + ": " + "IMPOSSIBLE");
			}
		}
	}

	private static int solveOneTest() {
		int res = 0;
		for (int i = 0; i < C; i++) {
			for (int j = 0; j < R; j++) {
				if (".".equals(tab[i][j])) {
					continue;
				}
				boolean leftOk = exploreLeft(i, j);
				boolean rightOk = exploreRight(i, j);
				boolean upOk = exploreUp(i, j);
				boolean downOk = exploreDown(i, j);

				if (!leftOk && !rightOk && !upOk && !downOk) {
					return -1;
				}

				if (">".equals(tab[i][j]) && !rightOk) {
					res++;
				}
				if ("<".equals(tab[i][j]) && !leftOk) {
					res++;
				}
				if ("^".equals(tab[i][j]) && !upOk) {
					res++;
				}
				if ("v".equals(tab[i][j]) && !downOk) {
					res++;
				}
			}
		}
		return res;
	}

	private static boolean exploreLeft(int i, int j) {
		int curX = i - 1;
		int curY = j;
		while (isInGrid(curX, curY)) {
			boolean b = ".".equals(tab[curX][curY]);
			if (!b) {
				return true;
			}
			curX--;
		}
		return false;
	}

	private static boolean exploreRight(int i, int j) {
		int curX = i + 1;
		int curY = j;
		while (isInGrid(curX, curY)) {
			boolean b = ".".equals(tab[curX][curY]);
			if (!b) {
				return true;
			}
			curX++;
		}
		return false;
	}

	private static boolean exploreUp(int i, int j) {
		int curX = i;
		int curY = j + 1;
		while (isInGrid(curX, curY)) {
			boolean b = ".".equals(tab[curX][curY]);
			if (!b) {
				return true;
			}
			curY++;
		}
		return false;
	}

	private static boolean exploreDown(int i, int j) {
		int curX = i;
		int curY = j - 1;
		while (isInGrid(curX, curY)) {
			boolean b = ".".equals(tab[curX][curY]);
			if (!b) {
				return true;
			}
			curY--;
		}
		return false;
	}

	private static boolean isInGrid(int curX, int curY) {
		if (curX < 0 || curX >= C) {
			return false;
		}
		if (curY < 0 || curY >= R) {
			return false;
		}
		return true;
	}

	static PrintWriter writer;

	// -----------MyScanner class for faster input thx Flatfoot----------
	public static class MyScanner {
		BufferedReader br;
		StringTokenizer st;

		public MyScanner() {
			try {
				this.br = new BufferedReader(new FileReader(new File("input")));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		String next() {
			while (this.st == null || !this.st.hasMoreElements()) {
				try {
					this.st = new StringTokenizer(this.br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return this.st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}

		String nextLine() {
			String str = "";
			try {
				str = this.br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return str;
		}

	}
	// --------------------------------------------------------
}