package gcj17;

import java.io.*;
import java.util.*;

public class C {
	public static void main(String[] args) throws FileNotFoundException {
		writer = new PrintWriter("src\\gcj17\\output");
		solveAllTests();
		writer.close();
	}

	private static void solveAllTests() {
		MyScanner sc = new MyScanner();
		int nbTest = sc.nextInt();
		for (int i = 1; i <= nbTest; i++) {
			long n = sc.nextLong();
			long k = sc.nextLong();
			String res = solveOneTest(n, k);
			writer.println("Case #" + i + ": " + res);

		}
	}

	static String solveOneTest(long n, long k) {
		if (k == 1) {
			return childOf(n);
		}
		long ceilingPow2 = 1;
		long sumOccupiedBeforeTurn = 0;
		int log = 0;
		while (2 * ceilingPow2 <= k) {
			sumOccupiedBeforeTurn += ceilingPow2;
			ceilingPow2 *= 2;
			log++;
		}

		long maxBeforeTurn = n;
		for (int i = 0; i < log; i++) {
			maxBeforeTurn = computeMax(maxBeforeTurn);
		}
		long remaining = n - sumOccupiedBeforeTurn;
		long x = remaining + ceilingPow2 - ceilingPow2 * maxBeforeTurn;
		long diff = k - ceilingPow2;
		if (diff >= x) {
			return childOf(maxBeforeTurn - 1);
		} else {
			return childOf(maxBeforeTurn);
		}
	}

	private static String childOf(long n) {
		return computeMax(n) + " " + computeMin(n);
	}

	private static long computeMin(long biggestEmptySpot) {
		return (biggestEmptySpot - 1) / 2;
	}

	private static long computeMax(long biggestEmptySpot) {
		return biggestEmptySpot / 2;
	}

	static PrintWriter writer;

	// -----------MyScanner class for faster input thx Flatfoot----------
	public static class MyScanner {
		BufferedReader br;
		StringTokenizer st;

		public MyScanner() {
			try {
				this.br = new BufferedReader(new FileReader(new File("input")));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		String next() {
			while (this.st == null || !this.st.hasMoreElements()) {
				try {
					this.st = new StringTokenizer(this.br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return this.st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}

		String nextLine() {
			String str = "";
			try {
				str = this.br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return str;
		}

	}
	// --------------------------------------------------------
}