package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class SolverPancake {
	static PrintWriter writer;

	public static void main(String[] args) throws NumberFormatException,
	IOException {
		writer = new PrintWriter("output");
		new SolverPancake().solveAllTests();
		writer.flush();
	}

	private void solveAllTests() throws NumberFormatException, IOException {
		Scanner sc = new Scanner(new File("input"));
		int nbTest = sc.nextInt();
		for (int i = 1; i <= nbTest; i++) {
			int nbCustomer = sc.nextInt();
			List<Integer> nbPancakes = new ArrayList<>();
			for (int j = 0; j < nbCustomer; j++) {
				nbPancakes.add(sc.nextInt());
			}
			int res = getRidOfPancakes(0, nbPancakes);
			writer.println("Case #" + i + ": " + res);
		}

	}

	private int getRidOfPancakes(int alreadySpentTime, List<Integer> nbPancakes) {
		if (alreadySpentTime >= 9) {
			return 9;
		}
		Collections.sort(nbPancakes, Collections.reverseOrder());
		int mostPancakes = nbPancakes.get(0);
		int best = mostPancakes + alreadySpentTime;
		if (mostPancakes <= 3) {
			return best;
		}
		for (int i = 2; i <= mostPancakes / 2; i++) {
			List<Integer> next = new ArrayList<Integer>(nbPancakes);
			next.remove(0);
			next.add(i);
			next.add(mostPancakes - i);
			best = Math.min(best, getRidOfPancakes(alreadySpentTime + 1, next));
		}
		return best;
	}
}
