import java.io.*;
import java.util.*;

public class ProblemA {
	public static void main(String[] args) throws IOException {
		File input = new File("ProblemAInput.txt");
		Scanner s = new Scanner(input);
		int numTestCases = Integer.parseInt(s.nextLine());;

		PrintWriter w = new PrintWriter(new File("ProblemAOutput.txt"), "UTF-8");
		for (int i = 1; i <= numTestCases; i++) {
			int[] res = runTest(s);
			w.println("Case #" + i + ": " + res[0] + " " + res[1]);
		}
		w.close();
	}

	public static int[] runTest(Scanner s) {
		s.nextLine();
		String[] cases = s.nextLine().split(" ");
		int[] curCase = new int[cases.length];
		for (int i = 0; i < cases.length; i++) {
			curCase[i] = Integer.parseInt(cases[i]);
		}
		int[] res = {caseOne(curCase), caseTwo(curCase)};
		return res;	
	}	

	public static int caseOne(int[] curCase) {
		int cur = curCase[0];
		int totalEaten = 0;
		for (int i = 1; i < curCase.length; i++) {
			if (cur > curCase[i]) {
				totalEaten += cur - curCase[i];
			}
			cur = curCase[i];
		}
		return totalEaten;
	}

	public static int caseTwo(int[] curCase) {
		int largest = curCase[0] - curCase[1];
		int totalEaten = 0;
		for (int i = 1; i < curCase.length - 1; i++) {
			if (largest < (curCase[i] - curCase[i+1])) {
				largest = curCase[i] - curCase[i+1];
			}
		}
		for (int i = 0; i < curCase.length - 1; i++) {
			totalEaten += Math.min(largest, curCase[i]);
		}
		return totalEaten;
	}

}