import java.util.HashSet;
import java.util.HashMap;
import java.util.LinkedList;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

public class ProblemB {

  public static void main(String[] a) throws IOException {

    File file = new File(a[0]);
    BufferedReader reader = new BufferedReader(new FileReader(file));
    
    int num = Integer.parseInt(reader.readLine());
    
    ProblemB prob = new ProblemB();
    
    for(int n=0; n<num; n++) {

      String in = reader.readLine();

      System.out.println("Case #"+ (n+1) +": "+ prob.run(in));
    }
  }

  public void debug(String text) {
    //System.out.println(text);
  }

  public String run(String line) {

    debug("=========================== line: '"+ line +"'");

    String[] tokens = line.split(" ");

    int token = 0;
    int numcomb = Integer.parseInt(tokens[token++]);

    //HashMap<Integer, Character> combineMap = new HashMap<Integer, Character>();
    HashMap<String, Character> combineMap = new HashMap<String, Character>();
    HashMap<Character, Character> opposeMap = new HashMap<Character, Character>();

    debug("num combine = "+ numcomb);

    for(int t=0; t<numcomb; t++) {

      debug("combiner for '"+ tokens[token].charAt(2) +" <= ("+ tokens[token].charAt(0) +"|"+ tokens[token].charAt(1) +") = "+ (tokens[token].charAt(0) | tokens[token].charAt(1)));

      char c0 = tokens[token].charAt(0);
      char c1 = tokens[token].charAt(1);
      char c2 = tokens[token].charAt(2);

      //combineMap.put(c0 | c1, c2);

      combineMap.put(""+ c0 + c1, c2);
      combineMap.put(""+ c1 + c0, c2);

      token++;
    }

    int numdestroy = Integer.parseInt(tokens[token++]);

    debug("num destroy = "+ numdestroy);

    for(int t=0; t<numdestroy; t++) {

      debug("opposer ("+ tokens[token].charAt(0) +"|"+ tokens[token].charAt(1) +") = "+ (tokens[token].charAt(0) | tokens[token].charAt(1)));

      //destroySet.add(tokens[token].charAt(0) | tokens[token].charAt(1));
      opposeMap.put(tokens[token].charAt(0), tokens[token].charAt(1));
      opposeMap.put(tokens[token].charAt(1), tokens[token].charAt(0));

      token++;
    }

    int lensequence = Integer.parseInt(tokens[token++]);

    char seq[] = new char[lensequence];
    int pos = 0;

    LinkedList<Character> queue = new LinkedList<Character>();
    LinkedList<Character> result = new LinkedList<Character>();

    for(char c : new StringBuilder(tokens[token]).reverse().toString().toCharArray()) {
      queue.push(c);
    }

    debug("-------------");

    while(queue.size() > 0) {

      char c0 = queue.pop();
      char c1 = 0;
      
      if(queue.size() > 0) {
        c1 = queue.pop();
      }

      debug("c0 = '"+ c0 +"', c1='"+ c1 +"'");
      debug("containsKey("+ c0 +") = "+ opposeMap.containsKey(c0));
      debug("result.indexOf = "+ result.indexOf(opposeMap.get(c0)) +" ("+ opposeMap.get(c0) +")");

      if(opposeMap.containsKey(c0) && result.indexOf(opposeMap.get(c0)) != -1) {
        debug("CLEARING");

        if(c1 != 0) {
          queue.push(c1);
        }

        result.clear();

      } else if(combineMap.containsKey(""+ c0 + c1)) {
        debug("COMBINING "+ c0 +" and "+ c1 +" TO FORM '"+ combineMap.get(""+c0+c1) +"'");
        queue.push(combineMap.get(""+c0+c1));
      } else {
        debug("LEAVING '"+ c0 +"' INTACT");
        result.push(c0);
        if(c1 != 0) {
          queue.push(c1);
        }
      }
    }

    if(queue.size() > 0) {
      debug("Copying remaining element to result");
      result.push(queue.pop());
    }

    if(queue.size() > 0) {
      throw new RuntimeException("ERRRRR");
    }

    if(result.size() == 0) {
      return "[]";
    } else {

      StringBuilder sb = new StringBuilder("[");

      while(result.size() > 0) {
        sb.append(result.removeLast()).append(", ");
      }

      return sb.toString().substring(0, sb.length()-2) +"]";
    }
  }

}
