package com.example;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;

import org.apache.commons.io.FileUtils;

public class ProblemA {

    public static void main(String[] a) throws Exception {
	new ProblemA().run();
    }

    HashMap<Character, Character> mTrMap = new HashMap<Character, Character>();
    
    private ProblemA() throws IOException {
	List<String> input = FileUtil.getLines("/translate_input.txt");
	List<String> output = FileUtil.getLines("/translate_output.txt");
	
	for(int i=0; i<input.size(); i++) {
	    for(int j=0; j<input.get(i).length(); j++) {
		if(mTrMap.containsKey(input.get(i).charAt(j))) {
		    if(mTrMap.get(input.get(i).charAt(j)) != output.get(i).charAt(j)) {
			throw new RuntimeException("inconsistent translation of '"+ input.get(i).charAt(j) +"!");
		    }
		} else {
		    mTrMap.put(input.get(i).charAt(j), output.get(i).charAt(j));
		}
	    }
	}
	
//	ArrayList<Character> chars = new ArrayList<Character>();
//	
//	for(char c='a'; c<='z'; c++) {
//	    System.out.println("'"+ c +"' => '"+ mTrMap.get(c) +"'");
//	    
//	    if(mTrMap.get(c) != null) {
//		chars.add(mTrMap.get(c));
//	    }
//	}
//	
//	Collections.sort(chars);
//	
//	for(Character c : chars) {
//	    System.out.println("'"+ c +"'");
//	}
    }
    
    private String translate(String str) {
	StringBuilder sb = new StringBuilder();

	for(char c : str.toCharArray()) {
	    if(!mTrMap.containsKey(c)) {
		throw new RuntimeException("No such translation character '"+ c +"'");
	    } else if (mTrMap.get(c) == null) {
		throw new RuntimeException("null!? '"+ c +"'");
	    }
	    
	    sb.append(mTrMap.get(c));
	}
	
	return sb.toString();
    }
    
    public void run() throws IOException {
	File file = new File(getClass().getResource("/A-small-attempt1.in").getFile());
//	System.out.println("File '"+ file.getAbsolutePath() +"'");
	
	List<?> lines = FileUtils.readLines(file);

	int numCases = Integer.parseInt((String) lines.get(0));
	
	for(int c=1; c<=numCases; c++) {
	    String translated = translate((String) lines.get(c));
	    
	    System.out.println("Case #"+ c +": "+ translated);
//	    System.out.println("'"+ lines.get(c) +"' => '"+ translated +"'");
	}
    }
    
}
