import java.io.BufferedWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.List;

import javax.management.RuntimeErrorException;

public class BathroomStalls {

	private static final BigInteger ZERO = new BigInteger("0");
	private static final BigInteger ONE = new BigInteger("1");
	private static final BigInteger TWO = new BigInteger("2");

	public static void main(String[] args) throws IOException {
		List<String> lines = Files.readAllLines(Paths.get(args[0]));
		BufferedWriter bw = Files.newBufferedWriter(Paths.get(args[1]));
		int numberOfCases = Integer.parseInt(lines.get(0));
		for (int i = 1; i < numberOfCases+1; i++) {
			String[] tokens = lines.get(i).split(" ");
			int[] maxMin = getMaxMinDetail(Integer.parseInt(tokens[0]), Integer.parseInt(tokens[1]));
			//BigInteger[] maxMin = getMaxMin(new BigInteger(tokens[0]), new BigInteger(tokens[1]));
			bw.write("Case #"+i+": " + maxMin[0] + " " + maxMin[1] +"\n");	
			System.out.println("Case #"+i+": " + maxMin[0] + " " + maxMin[1] +"\n");
		}
		bw.close();
		/*int[] maxMin = testResult(1000, 511);
		System.out.println(maxMin[0] + " " + maxMin[1]);*/
	}
	
	static BigInteger[] getMaxMin(BigInteger stalls, BigInteger people){
		BigInteger half = stalls.divide(TWO);
		if(stalls.compareTo(people) != 1){//handle some coreners
			return new BigInteger[]{ZERO, ZERO};
		}else if(stalls.divideAndRemainder(TWO)[1].compareTo(ONE) == 0){//odd # of stalls
			if(people.compareTo(ONE) == 0){
				return new BigInteger[]{half, half};
			}else if(people.compareTo(half) == 1){
				return new BigInteger[]{ZERO, ZERO};
			}if(people.divideAndRemainder(TWO)[1].compareTo(ZERO) == 0){//even # of people, more tricky
				return getMaxMin(half, (people).divide(TWO));
			}else{//odd # of people
				return getMaxMin(half, people.subtract(ONE).divide(TWO));
			}		
		}else{//even # of stalls
			if(people.compareTo(ONE) == 0){
				return new BigInteger[]{half, half.subtract(ONE)};
			}else if(people.compareTo(half) == 1){//not complete
				return new BigInteger[]{ZERO, ZERO};
			}if(people.divideAndRemainder(TWO)[1].compareTo(ZERO) == 0){//even # of people, more tricky
				return getMaxMin(half, people.divide(TWO));
			}else{//odd # of people
				return getMaxMin(half.subtract(ONE), people.subtract(ONE).divide(TWO));
			}	
		}
	}
	
	static int[] getMaxMin(int stalls, int people){
		int half = stalls/2;
		if(stalls <= people){//handle some coreners
			return new int[]{0, 0};
		}else if(stalls%2 == 1){//odd # of stalls
			if(people == 1){
				return new int[]{half, half};
			}else if(people > half){
				return new int[]{0, 0};
			}if(people%2 == 0){//even # of people, more tricky
				return getMaxMin(half, (people)/2);
			}else{//odd # of people
				return getMaxMin(half, (people-1)/2);
			}		
		}else{//even # of stalls
			if(people == 1){
				return new int[]{half, half-1};
			}else if(people > half){
				return new int[]{0, 0};
			}if(people%2 == 0){//even # of people, more tricky
				return getMaxMin(half, people/2);
			}else{//odd # of people
				return getMaxMin(half-1, (people-1)/2);
			}	
		}
	}
	
	static int[] testResult(int stalls, int people){
		int[] maxMinResult = getMaxMin(stalls, people);		
		int[] maxMinDetailResult = getMaxMinDetail(stalls, people);
		
		if(maxMinResult[0] == maxMinDetailResult[0] && maxMinResult[1]==maxMinDetailResult[1]){
			return maxMinResult;
		}else{
			System.err.println("Incorrect for " + stalls + ", " + people + ". Found " + maxMinResult[0] + ", " + maxMinResult[1] + " expected " + maxMinDetailResult[0] + ", " + maxMinDetailResult[1]);
			/*for (int i = min-5>-1?min-5:0; i < min+5; i++) {
				System.err.print("("+i+","+calcs[i][0]+","+calcs[i][1]+") ");
			}
			System.err.println();
			for (int i = max-5>-1?max-5:0; i < max+5; i++) {
				System.err.print("("+i+","+calcs[i][0]+","+calcs[i][1]+") ");
			}
			System.err.println();*/
			throw new RuntimeErrorException(null);
		}
	}
	
	static int[] getMaxMinDetail(int stalls, int people){
		BitSet stallsSet = new BitSet(stalls+2);
		short[][] calcs = new short[stalls+2][2];
		stallsSet.set(0);
		stallsSet.set(stalls+1);		
		int min = -1;
		int max = -1;
		int minVal = -1;
		int maxVal = -1;
		for (int i = 0; i < people; i++) {
			for (int j = 0; j < stalls+2; j++) {
				if(calcs[j][0] == -1){
					continue;
				}
				if(stallsSet.get(j)){
					calcs[j][0] = -1;
					calcs[j][1] = -1;
				}else{
					calcs[j][0] = (short) (j - stallsSet.previousSetBit(j)-1);
					calcs[j][1] = (short) (stallsSet.nextSetBit(j) - j-1);
				}
			}
			
			//Now take one stall
			int indexToStartFrom = 1;
			while(calcs[indexToStartFrom][0] == -1 && indexToStartFrom < calcs.length) indexToStartFrom++;
			
			ArrayList<Integer> minMaxList = new ArrayList<>();	
			minMaxList.add(indexToStartFrom-1);
			for (int calcIndex = indexToStartFrom; calcIndex < calcs.length; calcIndex++) {
				if(calcs[calcIndex][0] == -1){
					continue;
				}
				if(Math.min(calcs[minMaxList.get(0)][0], calcs[minMaxList.get(0)][1]) < Math.min(calcs[calcIndex][0], calcs[calcIndex][1])){
					minMaxList.clear();
					minMaxList.add(calcIndex);
				}else if(Math.min(calcs[minMaxList.get(0)][0], calcs[minMaxList.get(0)][1]) == Math.min(calcs[calcIndex][0], calcs[calcIndex][1])){
					minMaxList.add(calcIndex);
				}
			}
			
			min = minMaxList.get(0);
			minVal = Math.min(calcs[minMaxList.get(0)][0], calcs[minMaxList.get(0)][1]);
			max = minMaxList.get(0);
			maxVal = Math.max(calcs[minMaxList.get(0)][0], calcs[minMaxList.get(0)][1]);
			if(minMaxList.size() > 1){
				ArrayList<Integer> maxMaxList = new ArrayList<>();
				maxMaxList.add(minMaxList.get(0));
				for (int minMaxListIndex = 1; minMaxListIndex < minMaxList.size(); minMaxListIndex++) {
					if(Math.max(calcs[minMaxList.get(0)][0], calcs[minMaxList.get(0)][1]) < Math.max(calcs[minMaxList.get(minMaxListIndex)][0], calcs[minMaxList.get(minMaxListIndex)][1])){
						maxMaxList.add(0, minMaxList.get(minMaxListIndex));
					}
				}
				max = maxMaxList.get(0);
				maxVal = Math.max(calcs[maxMaxList.get(0)][0], calcs[maxMaxList.get(0)][1]);
				calcs[maxMaxList.get(0)][0] = -1;
				calcs[maxMaxList.get(0)][1] = -1;
				stallsSet.set(maxMaxList.get(0));
			}else{
				calcs[minMaxList.get(0)][0] = -1;
				calcs[minMaxList.get(0)][1] = -1;
				stallsSet.set(minMaxList.get(0));
			}
		}
		
		return new int[]{maxVal, minVal};
	}

}
