import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.List;

public class TidyNumbers {
	
	public static void main(String[] args) throws IOException {
		List<String> lines = Files.readAllLines(Paths.get(args[0]));
		BufferedWriter bw = Files.newBufferedWriter(Paths.get(args[1]));
		int numberOfCases = Integer.parseInt(lines.get(0));
		for (int i = 1; i < numberOfCases+1; i++) {
			bw.write("Case #"+i+": " + getLargesTidyNumber(lines.get(i)) +"\n");	
			System.out.println(lines.get(i) + " --> " + getLargesTidyNumber(lines.get(i)));
		}
		bw.close();
	}
	
	static String getLargesTidyNumber(String num){
		boolean iterationNeeded = false;
		byte[] digits = getDigits(num);
		//byte[] result = new byte[digits.length];
		StringBuffer result = new StringBuffer();
		if(digits.length == 1){
			result.append(""+digits[0]);
		}else{
			boolean allLeftZeros = true;
			byte lastMax = -1;
			for (int i = 0; i < digits.length; i++) {
				if(i < digits.length-1 && digits[i] > digits[i+1]){
					int nxtDigit = digits[i]-1;
					if(nxtDigit < lastMax && !allLeftZeros){
						iterationNeeded = true;
					}else{
						lastMax = (byte) Math.max(lastMax, nxtDigit);
					}
					if(nxtDigit != 0){
						allLeftZeros = false;
					}
					result.append(""+nxtDigit);
					for (int j = i+1; j < digits.length; j++) {
						result.append(""+9);
					}
					break;
				}else{
					allLeftZeros = false;
					lastMax = (byte) Math.max(lastMax, digits[i]);
					result.append(""+digits[i]);
				}
			}
		}
		trimLeadingZeros(result);
		if(iterationNeeded){
			return getLargesTidyNumber(result.toString());
		}else{
			return result.toString();
		}
	}
	
	private static void trimLeadingZeros(StringBuffer result) {
		for (int i = 0; i < result.length(); i++) {
			if(result.charAt(i) == '0'){
				result.deleteCharAt(i);
			}else{
				break;
			}
		}
	}

	static byte[] getDigits(String number){
		char[] digits1 = number.toCharArray();
		byte[] digits = new byte[digits1.length];
		for (int i = 0; i < digits1.length; i++) {
			digits[i] = Byte.parseByte(""+digits1[i]);
		}
		
		return digits;
	}

}
