import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Arrays;
import java.util.BitSet;
import java.util.List;

public class PanCakeFlipper {

	private static final int IMPOSSIBLE = Integer.MAX_VALUE;

	public static void main(String[] args) throws IOException {
		List<String> lines = Files.readAllLines(Paths.get(args[0]));
		BufferedWriter bw = Files.newBufferedWriter(Paths.get(args[1]));
		int numberOfCases = Integer.parseInt(lines.get(0));
		for (int i = 1; i < numberOfCases+1; i++) {
			String[] tokens = lines.get(i).split(" ");
			int canBeFixed = canBeFixed(Integer.parseInt(tokens[1]), tokens[0]);
			String answer = canBeFixed == IMPOSSIBLE ? "IMPOSSIBLE" : ""+canBeFixed;
			bw.write("Case #"+i+": " + answer +"\n");
			//System.out.println("Case #"+i+": " + answer);
		}
		bw.close();
	}
	
	public static int canBeFixed(int k, String row){
		return canBeFixed(0, k, createBitSet(row), row.length());
	}
	
	public static int canBeFixed(int level, int k, BitSet row, int size){
		if(row.cardinality() == size){//if already all good
			return level+0;
		}else if(row.cardinality() == 0){//all bad
			if(size%k == 0){//if the number of elements multiple of k
				return level + size/k;
			}else{
				return IMPOSSIBLE;
			}
		}else{
			BitSet[] splitRows = splitIfPossible(row);//lets try divide and conquer
			if(splitRows.length > 1){
				//dont increase level while going in recursion here as we havent flipped anything yet
				int sum = Arrays.stream(splitRows).map(s -> canBeFixed(0, k, s, size)).mapToInt(Integer::intValue).sum();
				return sum < 0 ? IMPOSSIBLE : level+sum;//if any call return IMPOSSIBLE, the sum will be negative
			}else{
				int cardinality = row.cardinality();
				BitSet forNextLevel = null;
				int nextClearBit = row.nextClearBit(0);
				while(nextClearBit + k <= size){
					BitSet copy = (BitSet) row.clone();
					copy.flip(nextClearBit, nextClearBit + k);
					if(copy.cardinality() == cardinality && copy.nextClearBit(nextClearBit) == nextClearBit && (size - cardinality) < k){//if there is no change(positive or negative), there is no hope
						nextClearBit = row.nextClearBit(nextClearBit+1);
						continue;
					}else{
						forNextLevel = copy;
						break;
					}
				}
				
				if(forNextLevel == null){
					return IMPOSSIBLE;
				}else{
					return canBeFixed(level+1, k, forNextLevel, size);
				}
			}
		}
	}
	
	private static BitSet[] splitIfPossible(BitSet row) {
		//System.out.println("spliting");
		BitSet[] set = new BitSet[]{row};//not really splitting right now. Need to think on this
		return set;
	}

	private static BitSet createBitSet(String row) {
		if(row != null && !row.isEmpty()){
			BitSet bitSet = new BitSet(row.length());
			for (int i = 0; i < row.length(); i++) {
				if(row.charAt(i) == '+'){
					bitSet.set(i);
				}
			}
			return bitSet;
		}else{
			return null;
		}
	}


}
