import java.util.*;
import java.io.FileReader;
import java.io.PrintWriter;
import java.io.FileWriter;
import java.io.File;

public class NextNumber {

    public static void main(String[] args) throws Exception {
        String path = args[0];
        Scanner sc = new Scanner(new FileReader(path));
        PrintWriter pw = new PrintWriter(new FileWriter(path.substring(0, path.lastIndexOf(File.separator)) + File.separator + "output.txt"));
        int numberCases = sc.nextInt();
        //sc.nextLine();
        for (int i = 1; i <= numberCases; i++) {
            int nextInt = sc.nextInt();
            int copyNextInt = nextInt;
            //get all digits
            Map<Integer, Integer> digits = new HashMap<Integer, Integer>() ;
            while (copyNextInt > 0) {
                int nextDigit = copyNextInt % 10;
                if (nextDigit!=0) {
                    if (digits.get(nextDigit)!=null){
                        digits.put(nextDigit, digits.get(nextDigit)+1);
                    } else {
                        digits.put(nextDigit, 1);
                    }
                }
                copyNextInt = copyNextInt/10;
            }

            int min = 0;
            if(digits.size()==1 && digits.get(digits.keySet().iterator().next())==1) {

               min = nextInt * 10;
            } else {
                int count = 1;
                while (true) {
                    copyNextInt = nextInt + count;
                    Map<Integer, Integer> newDigits = new HashMap<Integer, Integer>();
                    while (copyNextInt > 0) {
                        int nextDigit = copyNextInt % 10;
                        if (nextDigit != 0) {
                            if (newDigits.get(nextDigit) != null) {
                                newDigits.put(nextDigit, newDigits.get(nextDigit) + 1);
                            } else {
                                newDigits.put(nextDigit, 1);
                            }
                        }
                        copyNextInt = copyNextInt / 10;
                    }
                    if (compareMaps(digits, newDigits)) {
                        min = nextInt + count;
                        break;
                    }
                    count++;
                }
            }
            pw.write("Case #" + i + ": " + min + "\r\n");
        }
        pw.flush();
        pw.close();
    }

    private static boolean compareMaps(Map<Integer, Integer> digits, Map<Integer, Integer> newDigits){
        if (digits.size() != newDigits.size()) {
            return false;
        }
        for(Integer key: digits.keySet()) {
            if(newDigits.get(key)== null) {
                return false;
            }
            if(!digits.get(key).equals(newDigits.get(key))){
                return false;
            }
        }
        return true;
    }

    public static LinkedList<LinkedList<Integer>> computeSequences(LinkedList<Integer> computedSecuence,
                                                 LinkedList<Integer> notComputedSecuence){
        LinkedList<LinkedList<Integer>> fullSequence = new LinkedList<LinkedList<Integer>>();
        if (notComputedSecuence.size() > 2) {
            int index = 0;
            for(Integer curDigit : notComputedSecuence){
                LinkedList<Integer> newComputedSequence = new LinkedList<Integer>();
                newComputedSequence.addAll(computedSecuence);
                newComputedSequence.add(curDigit);

                LinkedList<Integer> newNonComputedSequence = new LinkedList<Integer>();
                newNonComputedSequence.addAll(notComputedSecuence);
                newNonComputedSequence.remove(index);

                fullSequence.addAll(computeSequences(newComputedSequence, newNonComputedSequence));
                index++;
            }
        } else {
            LinkedList<Integer> newComputedSequence1 = new LinkedList<Integer>();
            newComputedSequence1.addAll(computedSecuence);
            newComputedSequence1.add(notComputedSecuence.get(0));
            newComputedSequence1.add(notComputedSecuence.get(1));

            LinkedList<Integer> newComputedSequence2= new LinkedList<Integer>();
            newComputedSequence2.addAll(computedSecuence);
            newComputedSequence2.add(notComputedSecuence.get(1));
            newComputedSequence2.add(notComputedSecuence.get(0));
            fullSequence.add(newComputedSequence1);
            fullSequence.add(newComputedSequence2);
        }
        return fullSequence;
    }
}
