import java.util.Scanner;
import java.util.ArrayList;
import java.util.List;
import java.io.*;

public class AleinLanguage {
    public static void main(String[] args) throws Exception {
        String path = args[0];
        Scanner sc = new Scanner(new FileReader(path));
        PrintWriter pw = new PrintWriter(new FileWriter(path.substring(0, path.lastIndexOf(File.separator)) +File.separator+ "output.txt"));
        int wordLength = sc.nextInt();
        int numberOfWords = sc.nextInt();
        int numberOfPatterns = sc.nextInt();
        //read words
        sc.nextLine();
        List<String> words = new ArrayList<String>();
        for(int i = 0; i < numberOfWords; i++) {
            String word = sc.nextLine();
            words.add(word);
        }

        List<List<String>> patterns = new ArrayList<List<String>>();
        //read patterns
        for(int i = 0; i < numberOfPatterns; i++) {
            String pattern = sc.nextLine();
            List<String>parsedPattern = new ArrayList<String>();
            //split pattern
            boolean parFlag = false;
            String curString = "";
            for (int j = 0; j < pattern.length(); j++){
                char ch = pattern.charAt(j);
                if (ch=='(') {
                    parFlag = true;
                    continue;
                }
                if(ch == ')') {
                    parFlag = false;
                    parsedPattern.add(curString);
                    curString = "";
                    continue;
                }

                if (parFlag) {
                    curString += ch;
                } else {
                    parsedPattern.add("" + ch);
                }
            }
            patterns.add(parsedPattern);
        }

        /*
        System.out.println("Words:");
        for (String word : words) {
            System.out.println(word);
        }
        System.out.println("Lines:");
        int i = 0;
        for (List<String> parsedPattern : patterns) {
            System.out.println("Pattern" + i);
            for (String patternElem : parsedPattern) {
                System.out.println(patternElem);
            }
            i++;
        } */

        int patternCount = 1;
        for (List<String> parsedPattern : patterns) {
            int count = 0;
            for (String word : words) {
                boolean patternMatch = true;
                for (int letterNum = 0; letterNum < word.length(); letterNum++) {
                    char letter = word.charAt(letterNum);
                    String patternPart = parsedPattern.get(letterNum);
                    if (!patternPart.contains(letter + "")) {
                        patternMatch = false;
                        break;
                    }
                }
                if (patternMatch) {
                    count++;
                }
            }
            //System.out.println(" Pattern " + parsedPattern + " match " + count + "words");
            pw.write("Case #" + patternCount + ": " + count + "\r\n");
            patternCount++;
        }
        pw.flush();
        pw.close();
    }
}
