package com.codejam;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class DeceitfulWar
{
	private static DecimalFormat fmt = new DecimalFormat("0.0000000");

	public static void main(String[] args)
	{
		try
		{
			Scanner inn = new Scanner(System.in);
			//Scanner inn = new Scanner(new File("input/D-small-attempt0.in"));
			PrintWriter pw = new PrintWriter(new FileWriter("output.txt"));

			int totalTestCases = Integer.parseInt(inn.nextLine().replaceAll("\\s", ""));
			for (int i = 1; i <= totalTestCases; i++)
			{
				getOutput(inn, pw, i);
			}
			pw.flush();
			pw.close();
			inn.close();
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}

	private static void getOutput(Scanner inn, PrintWriter pw, int testCase)
	{
		int totalBlocks = Integer.parseInt(inn.nextLine());
		// double[] naomiBlocks = new double[totalBlocks];
		Map<Double, Boolean> naomiBlocks = new HashMap<Double, Boolean>();
		String[] naomis = inn.nextLine().split(" ");
		for (int i = 0; i < totalBlocks; i++)
		{
			naomiBlocks.put(Double.parseDouble(naomis[i]), false);
		}

		// double[] kenBlocks = new double[totalBlocks];
		Map<Double, Boolean> kenBlocks = new HashMap<Double, Boolean>();
		Map<Double, Boolean> kenBlocks2 = new HashMap<Double, Boolean>();
		String[] kens = inn.nextLine().split(" ");
		for (int i = 0; i < totalBlocks; i++)
		{
			kenBlocks.put(Double.parseDouble(kens[i]), false);
			kenBlocks2.put(Double.parseDouble(kens[i]), false);
		}
		// Noraml WAR
		int normalPoint = 0;
		for (double naomisChoose : naomiBlocks.keySet())
		{
			double kensChoose = getKenOptimal(naomisChoose, kenBlocks);
			kenBlocks.remove(kensChoose);

			if (kensChoose < naomisChoose)
				normalPoint++;
		}

		// Deceitful WAR
		int deceitfulPoints = getDeceitfulPoints(naomiBlocks, kenBlocks2);
		pw.println("Case #" + testCase + ": " + deceitfulPoints + " " + normalPoint);
	}

	private static int getDeceitfulPoints(Map<Double, Boolean> naomiBlocks, Map<Double, Boolean> kenBlocks)
	{
		int deceitfulPoints = 0;

		while (true)
		{
			if (naomiBlocks.isEmpty())
				break;
			
			double naomisMax = getMax(naomiBlocks);
			double kensMax = getMax(kenBlocks);
			
			if (naomisMax > kensMax)
			{
				deceitfulPoints++;
				double kenOptimal = getKenOptimal(naomisMax, kenBlocks);
				kenBlocks.remove(kenOptimal);
				double naomiDoubleDeceitfulOptimal = getNaomiDoubleDeceitfulOptimal(kenOptimal, naomiBlocks);
				if (naomiDoubleDeceitfulOptimal > 0.0)
					naomiBlocks.remove(naomiDoubleDeceitfulOptimal);
				else
					naomiBlocks.remove(naomisMax);
			}
			else
			{
				double naomisMin = getMin(naomiBlocks);
				double naomisDeceitful = getNaomisDeceitful(kensMax, naomiBlocks);
				if (naomisDeceitful > 0.0)
				{
					naomiBlocks.remove(naomisMin);
					double kenOptimal = getKenOptimal(naomisDeceitful, kenBlocks);
					kenBlocks.remove(kenOptimal);
				}
			}

			/*double naomisMin = getMin(naomiBlocks);
			double kensTop = getMax(kenBlocks);
			if (naomisMin < kensTop)
			{
				double naomisDeceitful = getNaomisDeceitful(kensTop, naomiBlocks);
				if (naomisDeceitful > 0.0)
				{
					naomiBlocks.remove(naomisMin);
					double kenOptimal = getKenOptimal(naomisDeceitful, kenBlocks);
					// double kenOptimal = getMax(kenBlocks);
					kenBlocks.remove(kenOptimal);
				}
			}
			else
			{
				deceitfulPoints++;
				double kenOptimal = getKenOptimal(naomisMin, kenBlocks);
				kenBlocks.remove(kenOptimal);
				double naomiDoubleDeceitfulOptimal = getNaomiDoubleDeceitfulOptimal(kenOptimal, naomiBlocks);
				System.out.println(naomisMin + " : " + naomiDoubleDeceitfulOptimal);
				if (naomiDoubleDeceitfulOptimal > 0.0)
					naomiBlocks.remove(naomiDoubleDeceitfulOptimal);
				else
					naomiBlocks.remove(naomisMin);
			}*/
		}
		return deceitfulPoints;
	}

	private static double getKenOptimal(double naomis, Map<Double, Boolean> kenBlocks)
	{
		double minDiff = -1.0d;
		double returnBlock = 0.0d;
		for (double kens : kenBlocks.keySet())
		{
			double tmpDiff = getPreciseDouble(kens - naomis);
			if (minDiff < 0 && tmpDiff > 0)
			{
				minDiff = tmpDiff;
				returnBlock = kens;
			}
			else
			{
				if (tmpDiff > 0 && tmpDiff < minDiff)
				{
					minDiff = tmpDiff;
					returnBlock = kens;
				}
			}
		}

		if (returnBlock < naomis)
			returnBlock = getMin(kenBlocks);
		return returnBlock;
	}

	private static double getNaomiDoubleDeceitfulOptimal(double kenOptimal, Map<Double, Boolean> naomiBlocks)
	{
		double minDiff = -1.0d;
		double returnBlock = 0.0d;
		for (double naomis : naomiBlocks.keySet())
		{
			double tmpDiff = getPreciseDouble(naomis - kenOptimal);
			if (minDiff < 0 && tmpDiff > 0)
			{
				minDiff = tmpDiff;
				returnBlock = naomis;
			}
			else
			{
				if (tmpDiff > 0 && tmpDiff < minDiff)
				{
					minDiff = tmpDiff;
					returnBlock = naomis;
				}
			}
		}

		if (returnBlock < kenOptimal)
			returnBlock = -1.0d;
		return returnBlock;
	}

	private static double getNaomisDeceitful(double kensTop, Map<Double, Boolean> naomiBlocks)
	{
		double minimalDeduction = getMinimalDeduction(kensTop);
		double someDeceitfulNumber = kensTop - minimalDeduction;
		while (naomiBlocks.containsKey(someDeceitfulNumber))
		{
			someDeceitfulNumber = someDeceitfulNumber - minimalDeduction;
		}

		return someDeceitfulNumber;
	}

	private static double getMinimalDeduction(double generalNumber)
	{
		String valueOf = String.valueOf(generalNumber);
		String[] tmpArr = valueOf.split("\\.");
		StringBuffer sbf = new StringBuffer();
		int length = tmpArr[1].length();
		sbf.append("0.");
		for (int i = 0; i < length - 1; i++)
		{
			sbf.append("0");
		}
		sbf.append("1");
		return Double.parseDouble(sbf.toString());
	}

	private static double getPreciseDouble(double doubleVal)
	{
		return Double.parseDouble(fmt.format(doubleVal));
	}

	private static double getMin(Map<Double, Boolean> blocks)
	{
		double min = -1.0d;

		for (double block : blocks.keySet())
		{
			if (min < 0)
				min = block;
			else
			{
				if (min > block)
					min = block;
			}
		}
		return min;
	}

	private static double getMax(Map<Double, Boolean> blocks)
	{
		double max = -1.0d;
		for (double block : blocks.keySet())
		{
			if (max < 0)
				max = block;
			else
			{
				if (max < block)
					max = block;
			}
		}
		return max;
	}
}
