package com.round1B;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class TheRepeater
{
	static Scanner inn = null;
	static PrintWriter pw = null;
	static String splitter = "(?!^)";

	public static void main(String[] args)
	{
		try
		{
			inn = new Scanner(new File("input/round1B/repeaterSmall.in"));
			pw = new PrintWriter(new FileWriter("output/round1B/repoutput.txt"));

			int totalCases = Integer.parseInt(inn.nextLine());
			for (int testCase = 1; testCase <= totalCases; testCase++)
			{
				int totalStrings = Integer.parseInt(inn.nextLine());
				String[] rawData = new String[totalStrings];
				for (int index = 0; index < totalStrings; index++)
				{
					rawData[index] = inn.nextLine();
				}

				sortOutTheProblem(testCase, rawData);
			}

			pw.flush();
			pw.close();
			inn.close();
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}

	private static void sortOutTheProblem(int testCase, String[] rawData)
	{
		if (areAllEqual(rawData))
		{
			pw.println("Case #" + testCase + ": 0");
			return;
		}
		if (isValidToProceed(rawData) == false)
		{
			pw.println("Case #" + testCase + ": Fegla Won");
			return;
		}
		// pw.println("Case #" + testCase + " :: ");
		parseAndProvideSolution(testCase, rawData);
	}

	private static boolean areAllEqual(String[] rawData)
	{
		Set<String> hashSet = new HashSet<String>();
		for (String str : rawData)
		{
			hashSet.add(str);
			if (hashSet.size() > 1)
				return false;
		}
		return true;
	}

	private static boolean isValidToProceed(String[] rawData)
	{
		Set<String> hashSet = new HashSet<String>();
		for (String str : rawData)
		{
			StringBuffer sbf = new StringBuffer();
			String[] tmpArr = str.split(splitter);
			for (String si : tmpArr)
			{
				if (si.trim().isEmpty() == false)
					if (sbf.indexOf(si) == -1)
						sbf.append(si);
			}
			hashSet.add(sbf.toString());
			if (hashSet.size() > 1)
				return false;
		}
		return true;
	}

	private static void parseAndProvideSolution(int testCase, String[] rawData)
	{
		Set<String> hashSet = new HashSet<String>();
		String[] tmpArr = rawData[0].split(splitter);
		for (String si : tmpArr)
		{
			hashSet.add(si);
		}
		//pw.println(hashSet);

		Map<String, String> charCountMap = new HashMap<String, String>();
		List<Integer[]> myList = new ArrayList<Integer[]>();
		for (String str : rawData)
		{
			myList.add(splitSpecial(str));
		}
		int hIndex = 0;
		for (String hStr : hashSet)
		{
			String key = hIndex + hStr;
			StringBuffer sbf = new StringBuffer();
			for (Integer[] strArr : myList)
			{
				sbf.append(strArr[hIndex]).append(",");
			}
			charCountMap.put(key, sbf.toString());
			hIndex++;
		}

		//pw.println(charCountMap);
		int minSteps = 0;
		for (String key : charCountMap.keySet())
		{
			String value = charCountMap.get(key);
			// pw.println(key + " : " + value);
			minSteps = minSteps + getMinSteps(value);
		}
		pw.println("Case #" + testCase + ": " + minSteps);
	}

	private static int getMinSteps(String value)
	{
		int minSteps = 0;
		String[] tmpArr = value.split(",");
		Arrays.sort(tmpArr);
		int medianIndex = tmpArr.length / 2;
		int median = Integer.parseInt(tmpArr[medianIndex]);
		// pw.println("Med: " + medianIndex + " : " + median);
		for (String str : tmpArr)
		{
			int tmp = Integer.parseInt(str);
			int diff = (tmp - median) > 0 ? (tmp - median) : (median - tmp);
			// pw.println(tmp + " : " + diff);
			minSteps = minSteps + diff;
		}
		// pw.println("min steps: " + minSteps);
		return minSteps;
	}

	private static Integer[] splitSpecial(String str)
	{
		String[] tmpArr = str.split(splitter);
		Map<String, Integer> tmpMap = new HashMap<String, Integer>();
		for (String si : tmpArr)
		{
			if (tmpMap.containsKey(si))
			{
				int count = tmpMap.get(si);
				tmpMap.put(si, ++count);
			}
			else
			{
				tmpMap.put(si, 1);
			}
		}

		Integer[] myArr = new Integer[tmpMap.size()];
		int index = 0;
		for (String key : tmpMap.keySet())
		{
			myArr[index] = tmpMap.get(key);
			index++;
		}

		return myArr;
	}

	private static void parseAndProvideSolution2(int testCase, String[] rawData)
	{
		Map<String, String> charCountMap = new HashMap<String, String>();

		for (String str : rawData)
		{
			Map<String, Integer> tmpMap = new HashMap<String, Integer>();
			String[] tmpArr = str.split(splitter);
			for (String si : tmpArr)
			{
				if (si.trim().isEmpty() == false)
				{
					if (tmpMap.containsKey(si))
					{
						int count = tmpMap.get(si);
						tmpMap.put(si, ++count);
					}
					else
					{
						tmpMap.put(si, 1);
					}
				}
			}

			for (String key : tmpMap.keySet())
			{
				if (charCountMap.containsKey(key))
				{
					String count = charCountMap.get(key);
					int tmpC = tmpMap.get(key);
					charCountMap.put(key, count + "," + tmpC);
				}
				else
				{
					int tmpC = tmpMap.get(key);
					charCountMap.put(key, String.valueOf(tmpC));
				}
			}
			// pw.println(str);
		}

		// pw.println(charCountMap);
		int minSteps = 0;
		for (String key : charCountMap.keySet())
		{
			String value = charCountMap.get(key);
			// pw.println(key + " : " + value);
			minSteps = minSteps + getMinSteps(value);
		}
		pw.println("Case #" + testCase + ": " + minSteps);
	}
}
