package com.codejam;

import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.Scanner;

public class CookieClicker
{
	private static DecimalFormat fmt = new DecimalFormat("0.0000000");

	public static void main(String[] args)
	{
		try
		{
			Scanner inn = new Scanner(System.in);
			PrintWriter pw = new PrintWriter(new FileWriter("output.txt"));

			int totalCases = Integer.parseInt(inn.nextLine());
			for (int testCase = 1; testCase <= totalCases; testCase++)
			{
				String caseLine = inn.nextLine();
				String[] caseTmp = caseLine.split(" ");

				double farmPrice = Double.parseDouble(caseTmp[0]);
				double addedRate = Double.parseDouble(caseTmp[1]);
				double winPrice = Double.parseDouble(caseTmp[2]);
				pw.println("Case #" + testCase + ": " + getBest(farmPrice, addedRate, winPrice));
			}

			pw.flush();
			pw.close();
			inn.close();
		}
		catch (IOException e)
		{
			//
		}
	}

	private static String getBest(double farmPrice, double addedRate, double winPrice)
	{
		double finalTime = 0.0d;
		double timeToBuyFarm = getPreciseDouble(farmPrice / 2.0d);
		double veryFirstTimeToWin = getPreciseDouble(winPrice / 2.0d);

		if (veryFirstTimeToWin <= timeToBuyFarm)
		{
			finalTime = veryFirstTimeToWin;
		}

		double alreadySpentTime = 0;
		double newRate = 2.0d;
		double minTime = veryFirstTimeToWin;
		double tmp = alreadySpentTime + getPreciseDouble(winPrice / newRate);
		double previousTmp = tmp;
		while (true)
		{
			tmp = getPreciseDouble(alreadySpentTime) + getPreciseDouble(winPrice / newRate);
			if (tmp < minTime)
				minTime = tmp;

			if (tmp > previousTmp)
				break;
			else
				previousTmp = tmp;

			if (tmp > veryFirstTimeToWin)
				break;

			alreadySpentTime = getPreciseDouble(alreadySpentTime) + getPreciseDouble(farmPrice / newRate);
			newRate = getPreciseDouble(newRate) + getPreciseDouble(addedRate);
		}

		finalTime = minTime;
		return fmt.format(finalTime);
	}

	private static double getPreciseDouble(double doubleVal)
	{
		return Double.parseDouble(fmt.format(doubleVal));
	}
}
