package round2;

import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;


public class D {
	
	public static final String INPUT_FILE = "D-small-attempt0.in";
	public static final String OUTPUT_FILE = "d.out";
	
	int caseNo;
	Scanner in;
	
	int maximumThreat;
	int numPlanets;
	
	class Node {
		BitSet bitChildren;
		int distance = 0;
		ArrayList<Node> children = new ArrayList<D.Node>();
		int id = -1;
		boolean visited = false;
		//boolean canHitEnemy = false;
		
	
	}
	
	void clean (Node[] nodes) {
		for (Node n: nodes) {
			n.distance = 0;
			n.visited = false;
			
		}
	}
	
	public void test() {
		maximumThreat = 0;
		System.err.println("case " + caseNo);
		numPlanets = in.nextInt();
		int numWormHoles = in.nextInt();
		
		Node[] nodes = new Node[numPlanets];
		for (int i = 0; i < numPlanets; i++) {
			nodes[i] = new Node();
			nodes[i].id = i;
		}
		
		for (int i = 0; i < numWormHoles; i++) {
			String str = in.next();			
			String[] l = str.split(",");
			int start = Integer.parseInt(l[0]);
			int end = Integer.parseInt(l[1]);
			
			nodes[start].children.add(nodes[end]);
			nodes[end].children.add(nodes[start]);
//			if (start == 1) {
//				nodes[end].canHitEnemy = true;
//			}
//			if (end == 1) {
//				nodes[end].canHitEnemy= true;
//			}
			
			//System.err.println(start + " " + end);
		}
		
		//Do a BFS and find the shortest distance
		
		
		Queue<Node> queue = new LinkedList<D.Node>();
		queue.add(nodes[0]);
		
		int enemyDistance = 0;
		//find node[1]
		while (queue.peek() != null) {
			
			Node n = queue.remove();
			//System.err.println("Visiting node " + n.id);
			
			//check if destination node
			if (n == nodes[1]) {
				//found
				enemyDistance = n.distance - 1;
				break;
				
			}
			
			//go through all the children
			for (Node c: n.children) {
				if (!c.visited) {
					c.visited = true;
					queue.add(c);
					c.distance = n.distance + 1;
				}
			}
			
		}
		
		System.err.println("EnemyDistance " + enemyDistance);
		
		clean(nodes);
		//Do a DFS of distance enemyDistance
		
		//Calculate your bitset, union of planets you threaten
		
		
		//Run dfs of all children
		nodes[0].bitChildren = new BitSet(numPlanets);
		for (Node c: nodes[0].children) {
			nodes[0].bitChildren.set(c.id);
		}
		nodes[0].bitChildren.set(0, false);
		
		dfs(nodes[0], enemyDistance);
		

		
		System.out.println("Case #"  + caseNo + ": " + enemyDistance + " " + maximumThreat);
	}
	
	void dfs(Node n, int depth) {
		n.visited = true;
		boolean canHitEnemy = false;
		//calculate your bitset
		for (Node c: n.children) {
			
			if (c.id == 1) canHitEnemy = true;
			if (!c.visited) {
			n.bitChildren.set(c.id);
			}
		}
		//cant threaten yourself
		n.bitChildren.set(n.id, false);
		
		if (depth == 0) {
			//check if you threaten shit
			if (canHitEnemy) {
				int yourThreat = n.bitChildren.cardinality();
				
				//Threat
//				System.err.print("node " + n.id + " threatens ");
//				for (int i = n.bitChildren.nextSetBit(0); i >= 0; i = n.bitChildren.nextSetBit(i+1)) {
//				   	System.err.print(i + " ");
//				 }
//				System.err.println(" total " + yourThreat);
				
				maximumThreat = Math.max(maximumThreat, yourThreat);
			}			
			n.visited = false;
			return;
		}
		
		//cycle through children
		for (Node c: n.children) {
			
			if (!c.visited) {
				
				c.bitChildren = n.bitChildren.get(0, numPlanets);
				dfs(c, depth -1);	
			}
		}
		n.visited = false;
	}
	
	

	public static void main(String[] args) throws Exception{
	
		System.setOut(new PrintStream(new File(OUTPUT_FILE)));
		(new D()).run();
		
	}

	public void run() throws Exception{

		in = new Scanner(new File(INPUT_FILE));

		int numTests = in.nextInt();

		for (caseNo = 1; caseNo <= numTests; caseNo++) {
			test();
		}

	}
}
