package round2;

import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;


public class A {
	
	public static final String INPUT_FILE = "A-large.in";
	public static final String OUTPUT_FILE = "a.out";
	
	int caseNo;
	Scanner in;
	
	class Walkway implements Comparable<Walkway>{
		int distance;
		int speed;
		@Override
		public int compareTo(Walkway o) {
			// TODO Auto-generated method stub
			if (speed < o.speed)return -1;
			else if (speed > o.speed) return 1;
			else return 0;
		}
		
		@Override
		public String toString() {
			// TODO Auto-generated method stub
			return "D: " + distance + " S: " + speed;
		}
		
		
	}
	
	public void test() {
		//dist
		int d = in.nextInt();
		//walk
		int walkSpeed = in.nextInt();
		//run
		int runSpeed = in.nextInt();
		//run time
		int runTime = in.nextInt();
		//walkways
		int numWalkways = in.nextInt();
		
		ArrayList<Walkway> walkways = new ArrayList<Walkway>();
		
		int curPos = 0;
		//beg, end, walkway speed
		for (int i = 0; i < numWalkways; i++) {
			int beg = in.nextInt();
			int end = in.nextInt();
			int speed = in.nextInt();
			
			Walkway w = new Walkway();
			w.distance = end - beg;
			w.speed = speed;
			walkways.add(w);
			
			//create a walkway with 0 speed, if the beg is past the curPos
			if (beg > curPos) {
				Walkway p = new Walkway();
				p.distance = beg - curPos;
				p.speed = 0;
				walkways.add(p);
			}
			
			curPos = end;
			

			//create a walkway for the lastpath?
			if (i == numWalkways - 1 && curPos < d) {
				Walkway p = new Walkway();
				p.distance = d - curPos;
				p.speed = 0;
				walkways.add(p);
			}
		}
		

		
	
		
		//group all "walkways" based on length and speed
		
		
		//sort by length
		Collections.sort(walkways);
		
		for (Walkway w: walkways) {
			//System.out.println(w);
		}
		
		double totalTime = 0;
		//simulate, running on slowest speed walkways
		double curRunTime = runTime;
		
		for (Walkway w: walkways) {
			
			double segDist = w.distance;
			
			double canRunDist = (w.speed + runSpeed) * curRunTime;
			
			double actualRunDist = Math.min(segDist, canRunDist);
			double actualRunTime = actualRunDist/(w.speed + runSpeed);
			
			double remainingDist = segDist - actualRunDist;
			double remainingWalkTime = remainingDist/(w.speed + walkSpeed);
			//use up running
			
			totalTime += actualRunTime + remainingWalkTime;
			curRunTime -= actualRunTime;
			
			
			
			
			
			
			
		}

		System.out.println("Case #"  + caseNo + ": " + totalTime);
	}
	
	

	public static void main(String[] args) throws Exception{
	
		System.setOut(new PrintStream(new File(OUTPUT_FILE)));
		(new A()).run();
		
	}

	public void run() throws Exception{

		in = new Scanner(new File(INPUT_FILE));

		int numTests = in.nextInt();

		for (caseNo = 1; caseNo <= numTests; caseNo++) {
			test();
		}

	}
}
