package name.dlazerka.codejam.y20171b.b;

import java.io.IOException;
import java.math.BigInteger;
import java.nio.file.*;
import java.util.*;
import java.util.stream.IntStream;

import static java.nio.charset.StandardCharsets.US_ASCII;

public class B1B {

	static class Test {
		final int N;
		final int[] c;
		final char[] col = new char[] {'R', 'O', 'Y', 'G', 'B', 'V'};

		Map<Character, Integer> counts;

		Test(Iterator<String> lines) {
			{
				int[] ints = IO.readInts(lines.next());
				N = ints[0];
				c = new int[6];
				System.arraycopy(ints, 1, c, 0, 6);
			}
		}

		String solve(int testNum) {
			char[] res = new char[N];

			int cur = 0;

			for (int i = 0; i < N; i++) {
				for (int tr = 0; c[cur] == 0 || (i > 0 && !compatible(res[i-1], col[cur])); tr++) {
					if (tr > 6) {
						return "IMPOSSIBLE";
					}
					cur = (cur + 1) % 6;
				}

				res[i] = col[cur];
				c[cur]--;
				cur = (cur + 2) % 6;
			}

			if (!compatible(res[N-1], res[0])) {
				return "IMPOSSIBLE";
			}

			return new String(res);
		}

		private boolean compatible(char prev, char col) {
			if (prev == col) return false;
			switch (prev) {
				case 'R': return col != 'V' && col != 'O';
				case 'O': return col != 'R' && col != 'Y';
				case 'Y': return col != 'O' && col != 'G';
				case 'G': return col != 'Y' && col != 'B';
				case 'B': return col != 'G' && col != 'V';
				case 'V': return col != 'B' && col != 'R';
				default: throw new IllegalStateException(prev + "");
			}
		}
	}

	public static void main(String[] args) throws Exception {
		FileSystem fs = FileSystems.getDefault();
		// Not class.getResource() because we keep those in 'src', not 'resources'.
		Path srcDir = fs.getPath(
				"src/main/java",
				B1B.class.getPackage().getName().replace('.', '/'));

		Path inPath = Files.list(srcDir)
				.filter(path -> path.toString().endsWith(".in"))
				// not having any .out files
				.filter(path -> !Files.exists(fs.getPath(path.toString().replace(".in", ".out"))))
				.findFirst()
				.orElse(null);
		if (inPath == null) {
			throw new IOException("No *.in files without corresponding .out found");
		}


		Iterator<String> lines = Files.lines(inPath, US_ASCII).iterator();
		int T = Integer.parseInt(lines.next());

		List<String> solutions = new ArrayList<>(T);
		//System.out.println(caseOut);
		IntStream.rangeClosed(1, T)
				.mapToObj(t -> "Case #" + t + ": " + new Test(lines).solve(t))
				.forEachOrdered(solutions::add);
		solutions.forEach(System.out::println);
		Path outPath = fs.getPath(inPath.toString().replace(".in", ".out"));
		Files.write(outPath, solutions, US_ASCII, StandardOpenOption.CREATE, StandardOpenOption.TRUNCATE_EXISTING);
	}

	@SuppressWarnings("unused")
	static class IO {
		/**
		 * Use Arrays.asList() if you want a List.
		 */
		static int[] readInts(String line) {
			String[] split = line.trim().split(" ");
			int[] result = new int[split.length];
			for (int i = 0; i < result.length; i++) {
				result[i] = Integer.parseInt(split[i]);
			}
			return result;
		}

		/**
		 * Use Arrays.asList() if you want a List.
		 */
		static long[] readLongs(String line) {
			String[] split = line.trim().split(" ");
			long[] result = new long[split.length];
			for (int i = 0; i < result.length; i++) {
				result[i] = Long.parseLong(split[i]);
			}

			return result;
		}

		static BigInteger[] readBigIntegers(String line) {
			String[] split = line.split(" ");
			BigInteger[] result = new BigInteger[split.length];
			for (int i = 0; i < split.length; i++) {
				result[i] = new BigInteger(split[i]);
			}
			return result;
		}

		static void printMap(char[][] map) {
			for (char[] charMap : map) {
				for (char c : charMap) {
					System.out.print(c == '\0' ? '.' : c);
				}
				System.out.println();
			}
			System.out.println();
		}
	}
}
