package name.dlazerka.codejam.y2016.b;

import com.google.common.base.Stopwatch;
import com.google.common.base.Throwables;

import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.*;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import static java.nio.file.StandardOpenOption.CREATE;
import static java.nio.file.StandardOpenOption.TRUNCATE_EXISTING;
import static java.util.concurrent.TimeUnit.MILLISECONDS;

public class Main {
	static FileSystem fs = FileSystems.getDefault();

	//static String TEST = "test";
	static String TEST = "small";
	//static String TEST = "large";

	public static void main(String[] args) throws Exception {
		Stopwatch startedAt = Stopwatch.createStarted();
		List<Main> cases = read();

		List<String> res = cases
				.stream()
				.map(c -> "Case #" + c.num + ": " + c.solve() + "\n")
				.collect(Collectors.toList());

		res.forEach(System.out::print);

		Path out = fs.getPath("out." + TEST);
		try (BufferedWriter writer = Files.newBufferedWriter(out, CREATE, TRUNCATE_EXISTING)) {
			res.forEach(r -> {
				try {
					writer.write(r);
				} catch (IOException e) {
					Throwables.propagate(e);
				}
			});
		}


		System.out.println(startedAt.elapsed(MILLISECONDS) + "ms");
	}

	static List<Main> read() throws IOException {
		String packageName = Main.class.getPackage().getName();
		Path path = fs.getPath("src/main/java", packageName.replace('.', '/'), "in." + TEST);
		if (!Files.exists(path)) {
			throw new NoSuchFileException(path.toAbsolutePath().toString());
		}

		List<String> lines = Files.readAllLines(path, StandardCharsets.US_ASCII);

		//List<String> lines = Files.readAllLines(path);
		int T = Integer.parseInt(lines.get(0));
		List<Main> cases = new ArrayList<>(T);

		for(int ci = 1; ci <= T; ci++) {
			Main main = new Main(ci);


			char[] chars = lines.get(ci).trim().toCharArray();


			main.S = new ArrayList<>(chars.length);;
			for(char aChar : chars) {
				main.S.add(aChar);
			}

			cases.add(main);
		}
		return cases;
	}


	final int num;
	public Main(int num) {
        this.num = num;
    }

	////////////////////////////

	List<Character> S;

	List<Character> reduce(List<Character> s) {
		if (s.size() == 0) {
			return s;
		}

		ArrayList<Character> result = new ArrayList<>(s.size());
		char cur = ' ';
		for (Character c : s) {
			if (cur != c) {
				cur = c;
				result.add(c);
			}
		}

		if (result.get(result.size() - 1) == '+') {
			result.remove(result.size() - 1);
		}

		return result;
	};

   	int solve() {
	    List<Character> reduced = reduce(S);

	    return reduced.size();
   	}
}
