package name.dlazerka.codejam.y20171b.a;

import java.io.IOException;
import java.math.BigInteger;
import java.nio.file.*;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.stream.IntStream;

import static java.nio.charset.StandardCharsets.US_ASCII;

public class A1B {

	static class Test {
		final int D;
		final int N;
		final int[] K;
		final int[] S;

		Test(Iterator<String> lines) {
			{
				int[] ints = IO.readInts(lines.next());
				D = ints[0];
				N = ints[1];

				K = new int[N];
				S = new int[N];
			}

			for (int i = 0; i < N; i++) {
				int[] ints = IO.readInts(lines.next());
				K[i] = ints[0];
				S[i] = ints[1];
			}
		}

		String solve(int testNum) {

			float maxTimeAtD = 0f;

			for (int i = 0; i < N; i++) {
				int toTravel = D - K[i];
				float timeAtD = toTravel / (float) S[i];

				if (timeAtD > maxTimeAtD) maxTimeAtD = timeAtD;
			}

			float result = D / maxTimeAtD;

			return result + "";
		}
	}

	public static void main(String[] args) throws Exception {
		FileSystem fs = FileSystems.getDefault();
		// Not class.getResource() because we keep those in 'src', not 'resources'.
		Path srcDir = fs.getPath(
				"src/main/java",
				A1B.class.getPackage().getName().replace('.', '/'));

		Path inPath = Files.list(srcDir)
				.filter(path -> path.toString().endsWith(".in"))
				// not having any .out files
				.filter(path -> !Files.exists(fs.getPath(path.toString().replace(".in", ".out"))))
				.findFirst()
				.orElse(null);
		if (inPath == null) {
			throw new IOException("No *.in files without corresponding .out found");
		}


		Iterator<String> lines = Files.lines(inPath, US_ASCII).iterator();
		int T = Integer.parseInt(lines.next());

		List<String> solutions = new ArrayList<>(T);
		//System.out.println(caseOut);
		IntStream.rangeClosed(1, T)
				.mapToObj(t -> "Case #" + t + ": " + new Test(lines).solve(t))
				.forEachOrdered(solutions::add);
		solutions.forEach(System.out::println);
		Path outPath = fs.getPath(inPath.toString().replace(".in", ".out"));
		Files.write(outPath, solutions, US_ASCII, StandardOpenOption.CREATE, StandardOpenOption.TRUNCATE_EXISTING);
	}

	@SuppressWarnings("unused")
	static class IO {
		/**
		 * Use Arrays.asList() if you want a List.
		 */
		static int[] readInts(String line) {
			String[] split = line.trim().split(" ");
			int[] result = new int[split.length];
			for (int i = 0; i < result.length; i++) {
				result[i] = Integer.parseInt(split[i]);
			}
			return result;
		}

		/**
		 * Use Arrays.asList() if you want a List.
		 */
		static long[] readLongs(String line) {
			String[] split = line.trim().split(" ");
			long[] result = new long[split.length];
			for (int i = 0; i < result.length; i++) {
				result[i] = Long.parseLong(split[i]);
			}

			return result;
		}

		static BigInteger[] readBigIntegers(String line) {
			String[] split = line.split(" ");
			BigInteger[] result = new BigInteger[split.length];
			for (int i = 0; i < split.length; i++) {
				result[i] = new BigInteger(split[i]);
			}
			return result;
		}

		static void printMap(char[][] map) {
			for (char[] charMap : map) {
				for (char c : charMap) {
					System.out.print(c == '\0' ? '.' : c);
				}
				System.out.println();
			}
			System.out.println();
		}
	}
}
