package c2270488.c;

import java.io.*;
import java.util.ArrayList;

import util.Util;

public class Main {

	public static void main(String[] args) throws Exception {
	    long startedAt = System.currentTimeMillis();
		Input input = new Input(new File(Main.class.getResource("in").toURI()));
		input.parse();
		Writer output = new BufferedWriter(new FileWriter(new File(Main.class.getResource("out").toURI())));
		try {
			Solver solver = new Solver();
			for (Case c : input.cases) {
				String line = "Case #" + c.num + ": " + solver.solve(c) + "\n";
				output.write(line);
				System.out.print(line);
			}
		} finally {
			output.close();
		}
		long endedAt = System.currentTimeMillis();
		System.out.println((endedAt - startedAt) + "ms");
	}
}

class Input {
    private BufferedReader reader;

    ArrayList<Case> cases;

    public Input(File file) throws FileNotFoundException {
        reader = new BufferedReader(new FileReader(file));
    }

    public Input(InputStream is) {
        this.reader = new BufferedReader(new InputStreamReader(is));
    }

    public void parse() throws IOException {
        try {
            int N = Util.readInt(reader);
            cases = new ArrayList<Case>(N);

            for (int ci = 1; ci <= N; ci++) {
                Case c = new Case(ci);
                long[] ii = Util.readLongs(reader);
                c.A = ii[0];
                c.B = ii[1];
                cases.add(c);
            }
        } finally {
            reader.close();
        }
    }
}