package c2270488.b;

import java.io.*;
import java.util.ArrayList;

import util.Util;

public class Main {

	public static void main(String[] args) throws Exception {
		Input input = new Input(new File(Main.class.getResource("in").toURI()));
		input.parse();
		Writer output = new BufferedWriter(new FileWriter(new File(Main.class.getResource("out").toURI())));
		try {
			Solver solver = new Solver();
			for (Case c : input.cases) {
				String sol = solver.solve(c);
				String line = "Case #" + c.num + ": " + sol + "\n";
				output.write(line);
				System.out.print(line);
			}
		} finally {
			output.close();
		}
	}
}

class Input {
    private BufferedReader reader;

    ArrayList<Case> cases;

    public Input(File file) throws FileNotFoundException {
        reader = new BufferedReader(new FileReader(file));
    }

    public Input(InputStream is) {
        this.reader = new BufferedReader(new InputStreamReader(is));
    }

    public void parse() throws IOException {
        try {
            int N = Util.readInt(reader);
            cases = new ArrayList<Case>(N);

            for (int ci = 1; ci <= N; ci++) {
                Case c = new Case(ci);
                int[] ii = Util.readInts(reader);
                c.N = ii[0];
                c.M = ii[1];
                c.t = new int[c.N][c.M];
                for (int row = 0; row < c.N; row++) {
                    c.t[row] = Util.readInts(reader);
                }
                cases.add(c);
//                if (ci != N) Util.readLine(reader);
            }
        } finally {
            reader.close();
        }
    }
}