package magicka;

import java.io.BufferedReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;

public class Case {
	private String name = null;
	
	private int cRuleNo = 0;
	private List<String> cRule = new ArrayList();
	private int dRuleNo = 0;
	private List<String> dRule = new ArrayList();
	private int length = 0;
	private String text = null;
	private String result = null;
	
	public void parse(String name, BufferedReader br) throws Exception {
		this.name = name;
		String line = br.readLine();
		String[] t = line.split(" ");
		int index = 0;
		int temp = Integer.parseInt(t[index++]);
		if (temp > 0) {
			// CRule
			String x = t[index++];
			for (int i = 0; i < temp; i++) {
				String xx = x.substring(i * 3, i * 3 + 3);
				cRule.add(xx);
			}
		}
		temp = Integer.parseInt(t[index++]);
		if (temp > 0) {
			// DRule
			String x = t[index++];
			for (int i = 0; i < temp; i++) {
				String xx = x.substring(i * 2, i * 2 + 2);
				dRule.add(xx);
			}
		}
		// 
		this.length = Integer.parseInt(t[index++]);
		this.text = t[index++];
		if (this.length != this.text.length()) {
			throw new Exception();
		}
	}

	public void doProcess() {
		StringBuilder sb = new StringBuilder(this.text);
		StringBuilder cal = new StringBuilder();
		for (int i = 0; i < sb.length(); i++) {
			cal.append(sb.charAt(i));
			char lastChr = sb.charAt(i);
			// C Rule
			for (String rule : cRule){
				char op1 = rule.charAt(0);
				char op2 = rule.charAt(1);
				char op3 = rule.charAt(2);
				if (lastChr != op1 && lastChr != op2) {
					continue;
				}
				int s1 = cal.indexOf(String.valueOf(op1) + String.valueOf(op2), cal.length() - 2);
				int s2 = cal.indexOf(String.valueOf(op2) + String.valueOf(op1), cal.length() - 2);
				if (s1 >= 0) {
					cal = cal.replace(s1, s1+2, String.valueOf(op3));
				} else if (s2 >= 0) {
					cal = cal.replace(s2, s2+2, String.valueOf(op3));
				}
			}
			//System.out.println("C:"+ cal);
			lastChr = cal.charAt(cal.length()-1);
			// D Rule
			for (String rule : dRule){
				char op1 = rule.charAt(0);
				char op2 = rule.charAt(1);
				if (op1 != lastChr && op2 != lastChr) {
					continue;
				} 
				int end_index = cal.length() - 1;
				int start_index = -1;
				if (op1 == lastChr) {
					start_index = cal.lastIndexOf(String.valueOf(op2));
				} else {
					start_index = cal.lastIndexOf(String.valueOf(op1));
				}
				if (start_index < 0) {
					continue;
				}
				//cal = cal.replace(start_index, end_index+1, "");
				cal = new StringBuilder();
			}
			//System.out.println("D:"+cal);
		}
		StringBuilder sb2 = new StringBuilder();
		sb2.append("[");
		for (int i = 0; i < cal.length(); i++) {
			sb2.append(cal.charAt(i));
			sb2.append(", ");
		}
		if (cal.length() > 0) {
			sb2.delete(sb2.length() - 2, sb2.length());
		}
		sb2.append("]");
		this.result = sb2.toString();
		
	}
	public void dump() {
	}

	public void dumpResult() {
		System.out.println("Case #" + this.name + ": " + this.result);
	}
}
