package magicka;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.List;

public class MagiTest {

	private CaseContainer container = new CaseContainer();
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		if (args.length > 1) {
			System.err.println("Error: java magicka.MagiTest inputfile");
			System.exit(9);
		}
		MagiTest main = new MagiTest();
		InputStream is = null;
		try {
			if (args.length == 1) {
				is = new FileInputStream(args[0]);
			} else {
				is = System.in;
			}
			main.init(is);
		} finally {
			is.close();
		}
		main.dump();
		main.doProcess();
		main.dumpResult();
	}

	private void dump() {
		this.container.dump();
	}
	private void doProcess() {
		this.container.doProcess();
	}
	private void dumpResult() {
		this.container.dumpResult();
	}

	public void init(InputStream is) throws Exception {
		InputStreamReader ir = null;
		BufferedReader br = null;
		String line = null;
		int totalCaseNum = 0;
		List<Case> list = null;
		try {
			ir = new InputStreamReader(is);
			br = new BufferedReader(ir);
			// 1s 
			line = br.readLine();
			totalCaseNum = Integer.parseInt(line);
			this.container.setTotalCaseNum(totalCaseNum);
			list = this.container.getList();
			// 2sڈȍ~̓P[X
			for (int i = 0; i < totalCaseNum; i++) {
				Case cs = new Case();
				cs.parse(String.valueOf(i+1), br);
				list.add(cs);
			}
		} finally {
			br.close();
			br = null;
			ir.close();
			ir = null;
		}
	}

}
