import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Scanner;


public class DeceitfulWar 
{
	public static final String FNAME = "D-large.in";
	
	public static void main(String[] args) throws Exception
	{
		ArrayList<String> inputs = Util.getInputs(FNAME);
		BufferedWriter bw = new BufferedWriter(new FileWriter(new File("output.txt")));
		int testCases = Integer.parseInt(inputs.get(0));
		for (int test = 1; test <= testCases; test++)
		{
			int numBlocks = Integer.parseInt(inputs.get( 1 + (test - 1) * 3 ));
			ArrayList<Float> ONaomiBlocks = new ArrayList<Float>();
			Scanner sc = new Scanner(inputs.get( 2 + (test - 1) * 3 ));
			for (int i = 0; i < numBlocks; i++)
				ONaomiBlocks.add(sc.nextFloat());
			sc.close();
			ArrayList<Float> OKenBlocks = new ArrayList<Float>();
			sc = new Scanner(inputs.get( 3 + (test - 1) * 3 ));
			for (int i = 0; i < numBlocks; i++)
				OKenBlocks.add(sc.nextFloat());
			sc.close();
			
			/* Play deceitful war */
			int nScore = 0;
			int kScore = 0;
			
			ArrayList<Float> NaomiBlocks = (ArrayList<Float>) ONaomiBlocks.clone();
			ArrayList<Float> KenBlocks = (ArrayList<Float>) OKenBlocks.clone();
			
			while (NaomiBlocks.size() > 0)
			{
				int nMin = minimumIndex(NaomiBlocks);
				int nMax = maximumIndex(NaomiBlocks);
				int kMin = minimumIndex(KenBlocks);
				int kMax = maximumIndex(KenBlocks);
				float nMinVal = NaomiBlocks.get(nMin);
				float nMaxVal = NaomiBlocks.get(nMax);
				float kMinVal = KenBlocks.get(kMin);
				float kMaxVal = KenBlocks.get(kMax);
				
				//Pick Naomi's smallest block
				int nSelIndex = nMin;
				float nSelValue = nMinVal;
				//If Ken can beat your score, lie so he wastes his largest block. If he can't beat you, tell the truth so he doesn't get suspicious.
				float nDisclosedValue = 0;
				if (nMinVal > kMinVal)
					nDisclosedValue = .9999f;
				else
					nDisclosedValue = (kMaxVal > nSelValue ? kMaxVal - .00001f : nSelValue);
				
				//Now Ken's turn. He chooses the smallest block greater than the disclosed value. If he's going to lose for sure, he chooses his smallest block
				int greaterInd = getGreaterIndex(KenBlocks, nDisclosedValue);
				int kSelIndex = (greaterInd != -1 ? greaterInd : kMin);
				float kSelValue = KenBlocks.get(kSelIndex);
				
				//Score and destroy blocks
				if (kSelValue > nSelValue)
					kScore++;
				else
					nScore++;
				NaomiBlocks.remove(nSelIndex);
				KenBlocks.remove(kSelIndex);
			}
			
			NaomiBlocks = (ArrayList<Float>) ONaomiBlocks.clone();
			KenBlocks = (ArrayList<Float>) OKenBlocks.clone();
			
			/* Play war */
			int nScore2 = 0;
			int kScore2 = 0;
			while (NaomiBlocks.size() > 0)
			{
				int nMin = minimumIndex(NaomiBlocks);
				int nMax = maximumIndex(NaomiBlocks);
				int kMin = minimumIndex(KenBlocks);
				int kMax = maximumIndex(KenBlocks);
				float nMinVal = NaomiBlocks.get(nMin);
				float nMaxVal = NaomiBlocks.get(nMax);
				float kMinVal = KenBlocks.get(kMin);
				float kMaxVal = KenBlocks.get(kMax);
				
				//Pick Naomi's smallest block
				int nSelIndex = nMin;
				float nSelValue = nMinVal;
				
				//Now Ken's turn. He chooses the smallest block greater than the disclosed value. If he's going to lose for sure, he chooses his smallest block
				int greaterInd = getGreaterIndex(KenBlocks, nSelValue);
				int kSelIndex = (greaterInd != -1 ? greaterInd : kMin);
				float kSelValue = KenBlocks.get(kSelIndex);
				
				//Score and destroy blocks
				if (kSelValue > nSelValue)
					kScore2++;
				else
					nScore2++;
				NaomiBlocks.remove(nSelIndex);
				KenBlocks.remove(kSelIndex);
			}
			bw.write("Case #" + test + ": " + nScore + " " + nScore2 + "\n");
		}
		bw.close();
	}
	
	/* returns the index of the smallest value in an arraylist */
	public static int minimumIndex(ArrayList<Float> list)
	{
		float min = 2;
		int minIndex = -1;
		for (int i = 0; i < list.size(); i++)
		{
			if (list.get(i) < min)
			{
				min = list.get(i);
				minIndex = i;
			}
		}
		return minIndex;
	}
	
	/* returns the index of the smallest value in an arraylist */
	public static int maximumIndex(ArrayList<Float> list)
	{
		float max = -1;
		int maxIndex = -1;
		for (int i = 0; i < list.size(); i++)
		{
			if (list.get(i) > max)
			{
				max = list.get(i);
				maxIndex = i;
			}
		}
		return maxIndex;
	}
	
	/* returns the index of the smallest value in an arraylist greater than a given value. Returns -1 if none are greater than the value */
	public static int getGreaterIndex(ArrayList<Float> list, float compare)
	{
		float min = 2;
		int minIndex = -1;
		for (int i = 0; i < list.size(); i++)
		{
			if (list.get(i) > compare && list.get(i) < min)
			{
				min = list.get(i);
				minIndex = i;
			}
		}
		return minIndex;
	}
}
