package projects;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

public class FairAndSquare {
	
	final static String FNAME = "C-small-attempt0";
	
	static void print(Object s){
		System.out.println(s);
	}
	
	static String reverseIt(String a) {
		
		int length = a.length();
		StringBuilder reverse = new StringBuilder();
		for(int i = length; i > 0; --i) {
			char result = a.charAt(i-1);
			reverse.append(result);
		}
		return reverse.toString();
	}
	
	static boolean isFAndS(int a){
		String s = Integer.toString(a);
		if (s.equals(reverseIt(s))){
			
			double root = Math.sqrt((double) a);
			int iPart = (int) root;
			double fPart = root - iPart;
			
			String iStr = Integer.toString(iPart);
			if (fPart == 0.0){
				if (reverseIt(iStr).equals(iStr)){
					return true;
				}
			}
			
		}
		
		return false;
	}
	
	public static void main(String[] args){
		
		BufferedReader br = null;
		BufferedWriter bw = null;
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			bw = new BufferedWriter(new FileWriter(FNAME + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		String line = "";
		ArrayList<String> input = new ArrayList<String>();
		
		while (line != null){
			try {
				line = br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			if (line != null){
				input.add(line);
			}
		}
		
		int testCases = Integer.parseInt(input.get(0));
		print(testCases);
		
		input.remove(0);
		ArrayList<int[]> cases = new ArrayList<int[]>();
		
		for (String s : input){
			Scanner sc = new Scanner(s);
			int[] params = new int[2];
			params[0] = Integer.parseInt(sc.next());
			params[1] = Integer.parseInt(sc.next());
			cases.add(params);
			sc.close();
		}
		
		for (int i = 0; i < cases.size(); i++){
			
			int[] params = cases.get(i);
			int start = params[0];
			int end = params[1];
			int ans = 0;
			
			for(int a = start; a <= end; a++){
				if (isFAndS(a)){
					ans++;
				}
			}
			
				try {
					bw.write("Case #" + (i+1) + ": " + ans + "\n");
				} catch (IOException e) {
					e.printStackTrace();
				}
			
		}
		try {
			bw.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		
	}
}
