package projects;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class TicTacToe {
	
	final static String IN_FNAME = "A-large.in";
	final static String OUT_FNAME = "out.out";
	
	static void print(Object s){
		System.out.println(s);
	}
	
	public static void main(String[] args){
		
		BufferedReader br = null;
		BufferedWriter bw = null;
		try {
			br = new BufferedReader(new FileReader(IN_FNAME));
			bw = new BufferedWriter(new FileWriter(OUT_FNAME));
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		String line = "";
		ArrayList<String> input = new ArrayList<String>();
		
		//Read the file
		while (line != null){
			try {
				line = br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			if (line != null){
				input.add(line);
			}
		}
		
		int testCases = Integer.parseInt(input.get(0));
		input.remove(0);
		input.add(0, "");
		print(testCases);
		
		ArrayList<String[][]> boards = new ArrayList<String[][]>();
		int count = 0;
		while (count < input.size()){
			if (input.get(count).equals("") && count < input.size() - 1){
				count++;
				String[][] board = new String[4][4];
				for (int y = 0; y < 4; y++){
					String str = input.get(count);
					count++;
					for (int x = 0; x < 4; x++){
						board[x][y] = String.valueOf(str.charAt(x));
					}
				}
				boards.add(board);
			}
			
		}
		
		int Case = 1;
		String status = "";
		for (String[][] board : boards){
			
			
			int[][] searches = {
					{0, 3, 1, 0},
					{0, 2, 1, 0},
					{0, 1, 1, 0},
					{0, 0, 1, 0},
					{0, 0, 1, 1},
					{0, 0, 0, 1},
					{1, 0, 0, 1},
					{2, 0, 0, 1},
					{3, 0, 0, 1},
					{3, 0, -1, 1},
					
			};
			String winner = "nobody";
			boolean isDraw = true;
			
			for (int[] sa : searches){
				winner = "nobody";
				int startX = sa[0];
				int startY = sa[1];
				int xInc = sa[2];
				int yInc = sa[3];
				int xPos = startX;
				int yPos = startY;
				String testStr = board[xPos][yPos];
				xPos += xInc;
				yPos += yInc;
				Boolean searchResult = true;
				
				if (!testStr.equals(".")){
					
					while(xPos >= 0 && xPos < 4 && yPos >= 0 && yPos < 4){
						String atPos = board[xPos][yPos];
						
						if (testStr.equals("T") && !atPos.equals(".")){
							testStr = atPos;
						}
						
						if (atPos.equals(".")){
							isDraw = false;
						}
						
						if (!(atPos.equals(testStr) || atPos.equals("T"))){
							searchResult = false;
						}
						xPos += xInc;
						yPos += yInc;
					}
				
					if (searchResult == true){
						winner = testStr;
						break;
					}
					
				}else{
					isDraw = false;
				}
					
			}
			if (isDraw && winner == "nobody"){
				winner = "draw";
			}
			switch (winner){
				case("X"):{
					status = "X won";
					break;
				}
				case("O"):{
					status = "O won";
					break;
				}
				case("draw"):{
					status = "Draw";
					break;
				}
				case("nobody"):{
					status = "Game has not completed";
					break;
				}
			}
			
			try {
				print("Case #" + Case + ": " + status);
				bw.write("Case #" + Case + ": " + status + "\n");
			} catch (Exception e) {
				e.printStackTrace();
			}
			Case++;
		}
		try {
			bw.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
