package project2;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Random;
import java.util.Scanner;

public class Project2 {
	
	final static String IN_FNAME = "C-small-1-attempt2.in";
	final static String OUT_FNAME = "out.out";
	
	static void print(Object s){
		System.out.println(s);
	}
	
	public static void main(String[] args) throws IOException{
		
		BufferedReader br = null;
		BufferedWriter bw = null;
		try {
			br = new BufferedReader(new FileReader(IN_FNAME));
			bw = new BufferedWriter(new FileWriter(OUT_FNAME));
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		String line = "";
		ArrayList<String> input = new ArrayList<String>();
		
		//Read the file
		while (line != null){
			try {
				line = br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			if (line != null){
				input.add(line);
			}
		}
		
		int testCases = Integer.parseInt(input.get(0));
		input.remove(0);
		input.add(0, "");
		print(testCases);
		
		ArrayList<ArrayList<Integer>> params = new ArrayList<ArrayList<Integer>>();
		for (String s : input)
		{
			Scanner sc = new Scanner(s);
			if (sc.hasNext())
			{
				ArrayList<Integer> i = new ArrayList<Integer>();
				do
				{
					i.add(sc.nextInt());
				}while(sc.hasNext());
				params.add(i);
				sc.close();
			}
		}
		
		for(int caseNo = 1; caseNo <= testCases; caseNo++)
		{
			bw.write("Case #1: \n");
			ArrayList<Integer> i = params.get(0);
			int R = i.get(0);
			int N = i.get(1);
			int M = i.get(2);
			int K = i.get(3);
			for (int cR = 1; cR <= R; cR++)
			{
				ArrayList<Integer> set = params.get(cR);
				ArrayList<String> posStrings = new ArrayList<String>();
				ArrayList<Integer> times = new ArrayList<Integer>();
				for(int cK = 1; cK <= K; cK++)
				{
					long start = System.currentTimeMillis();
					int product = -1;
					String nums = "";
					while(product != set.get(cK-1))
					{
						product = 1;
						nums = "";
						for(int cN = 1; cN <= N; cN++)
						{
							Random r = new Random();
							int num = r.nextInt(M-2+1) + 2;
							nums += num;
							if (Math.random() > 0.5)
								product*=num;
							
						}
					}
					posStrings.add(nums);
					print("R=" + cR + ": possible: " + nums);
					long end = System.currentTimeMillis();
					times.add((int) (end - start));
				}
				int longestTime = -1;
				int lTIndex = 0;
				for (Integer time : times)
				{
					if (time >= longestTime)
					{
						longestTime = time;
						lTIndex = times.indexOf(time);
					}
				}
				try {
					bw.write(posStrings.get(lTIndex) + "\n");
				} catch (IOException e) {
					e.printStackTrace();
				}
				print(posStrings.get(lTIndex));
			}
		}
		try {
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
