package projects;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

public class Treasure {
	
	final static String IN_FNAME = "D-small-attempt3.in";
	final static String OUT_FNAME = "out.out";
	
	static void print(Object s){
		System.out.println(s);
	}
	
	public static ArrayList<Integer> parseLine(String s){
		Scanner sc = new Scanner(s);
		ArrayList<Integer> params = new ArrayList<Integer>();
		while(sc.hasNext()){
			int i = sc.nextInt();
			params.add(i);
			print(i);
		}
		sc.close();
		return params;
	}
	
	public static void main(String[] args){
		
		BufferedReader br = null;
		BufferedWriter bw = null;
		try {
			br = new BufferedReader(new FileReader(IN_FNAME));
			bw = new BufferedWriter(new FileWriter(OUT_FNAME));
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		String line = "";
		ArrayList<String> input = new ArrayList<String>();
		
		//Read the file
		while (line != null){
			try {
				line = br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			if (line != null){
				input.add(line);
			}
		}
		
		int testCases = Integer.parseInt(input.get(0));
		input.remove(0);
		print(testCases);
		
		//Parse the file
		ArrayList<TCase> cases = new ArrayList<TCase>();
		int count = 0;
		while (count < input.size()){
				String str = input.get(count);
				ArrayList<Integer> params = parseLine(str);
				int numKeys = params.get(0);
				int numChests = params.get(1);
				count++;
				
				str = input.get(count);
				params = parseLine(str);
				ArrayList<Integer> keys = params;
				count++;
				
				ArrayList<TChest> chests = new ArrayList<TChest>();
				
				for(int i = 0; i < numChests; i++){
					str = input.get(count);
					params = parseLine(str);
					int r = params.get(0);
					params.remove(0);
					int n = params.get(0);
					params.remove(0);
					TChest chest = new TChest(r, n, params, i);
					chests.add(chest);
					count++;
				}
				
				TCase newCase = new TCase(numKeys, numChests, chests, keys, "", 0);
				cases.add(newCase);
		}
		
		count = 1;
		for (TCase thisCase : cases){
			String output = "";
			
			ArrayList<Integer> posMoves = thisCase.getPossibleMoves();
			if (posMoves.size() == 0){
				output = "IMPOSSIBLE";
			}else{
				thisCase.startTime = System.currentTimeMillis();
				doMoves(thisCase, thisCase);
				String result = thisCase.path;
				if (thisCase.finished == true){
					output = (result.substring(0, result.length()-1));
				}else{
					output = "IMPOSSIBLE";
				}
				
			}
			try {
				bw.write("Case #" + count + ": " + output + "\n");
				print("Case #" + count + ": " + output);
			} catch (IOException e) {
				e.printStackTrace();
			}
			count++;
		}
		try {
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	static String doMoves(TCase myCase, TCase origCase){
		String path = "";
		for (int i : myCase.getPossibleMoves()){
			TCase copyCase = myCase.clone();
			copyCase.path += (copyCase.chests.get(i).index + 1) + " ";
			copyCase.depth ++;
			ArrayList<Integer> pso = myCase.getPossibleMoves();
			copyCase.openChest(i);
			if (copyCase.chests.size() == 0 && origCase.finished == false){
				path = copyCase.path;
				origCase.finished = true;
				origCase.path = path;
				break;
			}else{
				long endTime = System.currentTimeMillis();
				if (copyCase.getPossibleMoves().size() > 0 && origCase.finished == false && endTime-origCase.startTime < 2500){
					path = doMoves(copyCase, origCase);
				}
			}
		}
		return path;
	}
	
}
