import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Scanner;


public class CookieClicker 
{
	public static final String FNAME = "B-large.in";
	
	public static void main(String[] args) throws Exception
	{
		ArrayList<String> inputs = getInputs();
		BufferedWriter bw = new BufferedWriter(new FileWriter(new File("output.txt")));
		int testCases = Integer.parseInt(inputs.get(0));
		for (int test = 0; test < testCases; test++)
		{
			double cookieRate = 2;
			String data = inputs.get(test + 1);
			Scanner sc = new Scanner(data);
			sc.useDelimiter(" ");
			double farmPrice = sc.nextFloat();
			double cookiesPerFarm = sc.nextFloat();
			double cookieGoal = sc.nextFloat();
			sc.close();
			double elapsedTime = 0f;
			boolean running = true;
			while (running)
			{
				//The time it will take to finish at the current rate
				double timeWithoutFarm = elapsedTime + (cookieGoal / cookieRate);
				//The time it will take to finish if we buy a farm
				double timeWithFarm = (elapsedTime + (farmPrice / cookieRate)) + ((cookieGoal)/(cookieRate + cookiesPerFarm));
				
				if (timeWithoutFarm < timeWithFarm)
				{
					elapsedTime += (cookieGoal / cookieRate);
					running = false;
				}
				else
				{
					elapsedTime += (farmPrice / cookieRate);
					cookieRate += cookiesPerFarm;
				}
			}
			bw.write("Case #" + (test + 1) + ": " + elapsedTime + "\n");
		}
		bw.close();
	}
	
	static ArrayList<String> getInputs() throws IOException
	{
		ArrayList<String> inputs = new ArrayList<String>();
		BufferedReader br = new BufferedReader(new FileReader(new File(FNAME)));
		String line = br.readLine();
		while (line != null)
		{
			inputs.add(line);
			line = br.readLine();
		}
		br.close();
		return inputs;
	}
	
	/* tests to see if the two numbers are within a certain margin of error*/
	static boolean IsApproximatelyEqual(double x, double y, double epsilon)
	{
		  // Check absolute precision.
		  if (-epsilon <= x - y && x - y <= epsilon)
		    return true;

		  // Is x or y too close to zero?
		  if ((-epsilon <= x && x <= epsilon) || (-epsilon <= y && y <= epsilon))
		    return false;

		  // Check relative precision.
		  return (-epsilon <= (x - y) / x && (x - y) / x <= epsilon || -epsilon <= (x - y) / y && (x - y) / y <= epsilon);
	}
}
