package projects.project1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Scanner;

public class Project1 {
	
	final static String IN_FNAME = "A-small-attempt0.in";
	final static String OUT_FNAME = "out.out";
	
	static void print(Object s){
		System.out.println(s);
	}
	
	public static void main(String[] args){
		
		BufferedReader br = null;
		BufferedWriter bw = null;
		try {
			br = new BufferedReader(new FileReader(IN_FNAME));
			bw = new BufferedWriter(new FileWriter(OUT_FNAME));
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		String line = "";
		ArrayList<String> input = new ArrayList<String>();
		
		//Read the file
		while (line != null){
			try {
				line = br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			if (line != null){
				input.add(line);
			}
		}
		
		int testCases = Integer.parseInt(input.get(0));
		input.remove(0);
		input.add(0, "");
		print(testCases);
		
		ArrayList<BigInteger[]> params = new ArrayList<BigInteger[]>();
		for (String s : input)
		{
			Scanner sc = new Scanner(s);
			if (sc.hasNext())
			{
				BigInteger[] i = {sc.nextBigInteger(), sc.nextBigInteger()};
				params.add(i);
				sc.close();
			}
		}
		
		for(int caseNo = 1; caseNo <= testCases; caseNo++)
		{
			BigInteger innerRad = params.get(caseNo-1)[0];
			BigInteger totalML = params.get(caseNo-1)[1];
			BigInteger rings = BigInteger.valueOf(-1);
			BigInteger curRad = innerRad.add(BigInteger.valueOf(1));
			print("r= " + innerRad);
			print("t= " + totalML);
			do
			{
				rings = rings.add(BigInteger.valueOf(1));
				totalML = totalML.subtract(getRequiredML(curRad));
				curRad = curRad.add(BigInteger.valueOf(2));
				//print(totalML);
			}while(totalML.compareTo(BigInteger.valueOf(0)) >= 0);
			try {
				bw.write("Case #" + caseNo + ": " + rings.toString() + "\n");
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		try {
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		
	}
	public static BigInteger getRequiredML(BigInteger r)
	{
		BigInteger exclude = r.subtract(BigInteger.valueOf(1));
		BigInteger area = r.pow(2).subtract(exclude.pow(2));
		return area;
	}
}
