package googlecodejam;


import java.io.*;
import java.text.*;
import java.util.*;

public class Template {
    public static void main(String[] args) throws Exception {
        String name = "A-small-attempt0";
        String path = "F:/codejam/";
        Scanner sc = new Scanner(new File(path + name + ".in"));
        DecimalFormat df = new DecimalFormat("0.00", DecimalFormatSymbols.getInstance(Locale.ENGLISH));
        sc.useLocale(Locale.ENGLISH);
        PrintWriter pw = new PrintWriter(path + name + ".out");
        int testCases = sc.nextInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {

            String res ="";
            boolean drawFlag = true;
            boolean solved = false;
            
            //set up board
            int[][] board = new int[4][4];
            for (int i = 0; i < board.length; i++) {
                char[] rowi = sc.next().toCharArray();
                for (int j = 0; j < board[0].length; j++) {
                    switch (rowi[j]) {
                    case 'X':
                        board[i][j]=3;
                        break;
                    case 'O':
                        board[i][j]=2;
                        break;
                    case 'T':
                        board[i][j]=6;
                        break;
                    case '.':
                        drawFlag = false;
                        board[i][j]=1;
                        break;
                    default:                        
                        break;
                    }
                }
            }
            
            
            //Test horizontal
            if (!solved) {              
                for (int row = 0; row < board.length; row++) {
                    int testprod=1;
                    for (int col = 0; col < board[0].length; col++) {
                        testprod*=board[row][col];
                    }
                    if (testprod % 16 == 0) {res = "O won"; solved = true; break;}
                    else if (testprod % 81 == 0) {res = "X won"; solved = true; break;}
                }
            }
            
            //Test vertical
            if (!solved) {              
                for (int col = 0; col < board.length; col++) {
                    int testprod=1;
                    for (int row = 0; row < board[0].length; row++) {
                        testprod*=board[row][col];
                    }
                    if (testprod % 16 == 0) {res = "O won"; solved = true; break;}
                    else if (testprod % 81 == 0) {res = "X won"; solved = true; break;}
                }
            }

            //Test diagonal
            if (!solved) {              
                int testprodEW=1;
                int testprodNS=1;
                for (int i = 0; i < board.length; i++) {
                        testprodNS*=board[i][i];
                        testprodEW*=board[i][3-i];
                }
                if (testprodNS % 16 == 0 || testprodEW % 16 ==0) res = "O won";
                else if (testprodNS % 81 == 0 || testprodEW % 81 ==0) res = "X won";
                else if (drawFlag) res = "Draw";
                else res = "Game has not completed";
            }

            pw.println("Case #" + testCase + ": " + res);
            pw.flush();
        }
        pw.close();
    }
}