package googlecodejam;

import java.io.*;
import java.text.*;
import java.util.*;

public class ProblemB {
    public static void main(String[] args) throws Exception {
        String name = "B-large";
        String path = "F:/codejam/";
        Scanner sc = new Scanner(new File(path + name + ".in"));
        sc.useLocale(Locale.ENGLISH);
        PrintWriter pw = new PrintWriter(path + name + ".out");
        int testCases = sc.nextInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {

            String res = "";

            // set up board
            int irow = sc.nextInt();
            int icol = sc.nextInt();
            int[][] board = new int[irow][icol];
            for (int row = 0; row < irow; row++) {
                for (int col = 0; col < icol; col++) {
                    board[row][col] = sc.nextInt();
                }
            }

            // reiterate board
            int status = 1;
            while (status > 0) {
                status = solveBoard(board);
            }

            if (status == 0) {
                res = "YES";
            } else if (status == -1) {
                res = "NO";
            } else {
                res = "Problem";
            }

            pw.println("Case #" + testCase + ": " + res);
            pw.flush();
        }
        pw.close();
    }

    public static int solveBoard(int[][] board) {
        int minR = 0;
        int minC = 0;
        int cMin = 999;
        boolean failFlagR = false;
        boolean failFlagC = false;

        // get global min
        for (int row = 0; row < board.length; row++) {
            for (int col = 0; col < board[0].length; col++) {
                if (board[row][col] < cMin) {
                    minR = row;
                    minC = col;
                    cMin = board[row][col];
                }
            }
        }

        for (int row = 0; row < board.length; row++) {
            if (board[row][minC] != cMin && board[row][minC] != 999) {
                failFlagR = true;
                break;
            }
        }
        if (!failFlagR) {
            for (int row = 0; row < board.length; row++) {
                board[row][minC] = 999;
            }
        }

        for (int col = 0; col < board[0].length; col++) {
            if (board[minR][col] != cMin && board[minR][col] != 999) {
                failFlagC = true;
                break;
            }
        }
        if (!failFlagC) {
            for (int col = 0; col < board[0].length; col++) {
                board[minR][col] = 999;
            }
        }

        if (cMin == 999) {
            return 0;
        } else if (failFlagC && failFlagR) {
            return -1;
        } else {
            return 1;
        }
    }
}
