package cj2010.qualification;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

public class ThemePark {
	private static String DEFAULT_INPUT_FILENAME = "input.txt";
	
	public static void main(String[] args) {
		ThemePark themePark = new ThemePark();
		if(args.length > 0){
			themePark.run(args[0]);
		} else {
			themePark.run(DEFAULT_INPUT_FILENAME);
		}
	}

	
	public void run(String inputFilename){
		File inputFile = new File(inputFilename);
		
		try {
			BufferedReader input = new BufferedReader(new FileReader(inputFile));
			
			try {
				String line = input.readLine(); // first line - test case count
				
				int numberOfTests = Integer.valueOf(line);
				
				for(int i = 0; i < numberOfTests; i++){
					int testNumber = i + 1;

					line = input.readLine();
					
					String[] tokens = line.split(" ");
					int ridesPerDay = Integer.parseInt(tokens[0]);
					int numberOfSeats = Integer.parseInt(tokens[1]);
					
					line = input.readLine();
					String[] groups = line.split(" ");
					
					String result = runTest(ridesPerDay, numberOfSeats, groups, testNumber);
					System.out.println(result);
				}
				
				
			} catch (IOException e) {
				input.close();
			}
		} catch (IOException e1) {
			// do nothing
		}
	}

	private String runTest(int ridesPerDay, int seatsPerRide, String[] groups, int testCaseNumber){
		int groupIndex = 0;
		int euros = 0;
		int groupCount = groups.length;
		
		for(int rideNumber = 0; rideNumber < ridesPerDay; rideNumber++){
			
			int seatsRemaining = seatsPerRide;
			
			// loop through groups in line 
			// until a group cannot be seated anymore		
			for(int i = 0; i < groupCount; i++){
				
				if(groupIndex >= groupCount){
					groupIndex = 0;
				}
				
				int requiredSeats = Integer.parseInt(groups[groupIndex]);
				
				seatsRemaining -= requiredSeats;
				if(seatsRemaining >= 0){
					euros += requiredSeats;
					groupIndex++;
				} else {
					break;
				}
			}
			
		}
		
		return "Case #" + testCaseNumber + ": " + euros;
	}

}
