package cj2010.qualification;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

public class Snapper {
	private static String DEFAULT_INPUT_FILENAME = "input.txt";
	
	public static void main(String[] args) {
		Snapper snapper = new Snapper();
		if(args.length > 0){
			snapper.run(args[0]);
		} else {
			snapper.run(DEFAULT_INPUT_FILENAME);
		}
	}

	
	public void run(String inputFilename){
		File inputFile = new File(inputFilename);
		
		try {
			BufferedReader input = new BufferedReader(new FileReader(inputFile));
			
			try {
				String line = input.readLine(); // first line - test case count
				
				int numberOfTests = Integer.valueOf(line);
				
				for(int i = 0; i < numberOfTests; i++){
					line = input.readLine();
					
					String[] tokens = line.split(" ");
					int snapperDeviceCount = Integer.parseInt(tokens[0]);
					int numberOfSnaps = Integer.parseInt(tokens[1]);
					int testNumber = i + 1;
					
					String result = runTest(snapperDeviceCount, numberOfSnaps, testNumber);
					System.out.println(result);
				}
				
				
			} catch (IOException e) {
				input.close();
			}
		} catch (IOException e1) {
			// do nothing
		}
	}
	
	private String runTest(int snapperDeviceCount, int numberOfSnaps, int testCaseNumber){
	
		boolean[] snapperStates = new boolean[snapperDeviceCount];
		
		// Apply snaps
		for(int i = 0; i < numberOfSnaps; i++){
			
			int index = 0;
			while(index < snapperDeviceCount && snapperStates[index]) {
				snapperStates[index] = false;
				index++;
			}
			if(index < snapperDeviceCount) {
				snapperStates[index] = true;
			}
		}
		
		// Determine result
		boolean isOn = true;
		
		for(int i = 0; i < snapperStates.length && isOn; i++){
			isOn = snapperStates[i];
		}

		if(isOn){
			return "Case #" + testCaseNumber + ": ON";
		} else {
			return "Case #" + testCaseNumber + ": Off";
		}
	}
}
