import java.io.*;
import java.util.Scanner;

public class TidyNumbers {

    public static void main(String[] args) throws FileNotFoundException {
        String inputFile = "B-large.in";
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(new File(inputFile)))));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        in.nextLine();
        for (int i = 1; i <= t; ++i) {
            String number = in.nextLine();

            boolean tidy = false;
            char last;

            while(!tidy) {
                last = number.charAt(0);
                tidy = true;
                for (int k = 1; k < number.length(); k++) {
                    if (number.charAt(k) < last) {
                        number = decrement(number, k - 1);
                        tidy = false;
                        break;
                    }
                    last = number.charAt(k);
                }
            }

            while(number.charAt(0) == '0') {
                number = number.substring(1);
            }

            System.out.println("Case #" + i + ": " + number);
        }
    }

    private static String decrement(String number, int pos) {
        char change = number.charAt(pos);
        return number.substring(0, pos) + (--change) + repeat("9", number.length() - pos - 1);
    }

    private static String repeat(String str, int times) {
        StringBuilder result = new StringBuilder("");
        while(times-->0) {
            result.append(str);
        }
        return result.toString();
    }
}
