import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class BathroomStalls {

    public static void main(String[] args) throws FileNotFoundException {
        String inputFile = "C-small-1-attempt1.in";
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(new File(inputFile)))));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        for (int i = 1; i <= t; ++i) {
            Long N = in.nextLong();
            Long K = in.nextLong();

            List<Boolean> directions = getBinary(K);

            long lastMin, lastMax;
            long leftMin = N;
            long rightMin = N;
            long leftMax = N;
            long rightMax = N;
            long depth = 0;
            long step = 0;
            long lastPositions = 0;

            for(Boolean dir: directions) {

                lastPositions = (long)Math.pow(2, step++);
                if(step < directions.size()) {
                    depth += lastPositions;
                }

                lastMin = Math.min(leftMin, rightMin);
                lastMax = Math.max(leftMax, rightMax);

                rightMin = (lastMin - 1) / 2;
                leftMin = lastMin - rightMin - 1;

                rightMax = (lastMax - 1) / 2;
                leftMax = lastMax - rightMax - 1;

                // check for negative
                if(leftMin < 0) leftMin = 0;
                if(leftMax < 0) leftMax = 0;
            }

            long position = K - depth;

            if(((leftMax + rightMax + 1) * position) + depth + ((leftMin + rightMin + 1) * (lastPositions - position)) <= N) {
                System.out.println("Case #" + i + ": " + leftMax + " " + rightMax);
            }
            else {
                System.out.println("Case #" + i + ": " + leftMin + " " + rightMin);
            }
        }
    }

    private static List<Boolean> getBinary(Long number) {
        List<Boolean> binary = new ArrayList<>();

        while(number > 0) {
            binary.add(number % 2 > 0);
            number = number / 2;
        }

        Collections.reverse(binary);

        return binary;
    }
}
