import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Locale;
import java.util.Scanner;

/**
 * @author Dmitri Gabbasov
 */
public abstract class MultipleTestCaseSolver {

  public void solveAll(String inputName) {
    Scanner scanner;
    PrintStream out;
    try {
      scanner = new Scanner(new FileInputStream("inputs/" + inputName + ".in"));
      out = new PrintStream("inputs/" + inputName + ".out");
    }
    catch (FileNotFoundException e) {
      System.out.println("Enter input:");
      scanner = new Scanner(System.in);
      out = System.out;
    }
    
    scanner.useLocale(Locale.ENGLISH);

    int T = scanner.nextInt();
    
    for (int t = 0; t < T; ++t) {
      out.print("Case #" + (t + 1) + ": ");
      solveOne(scanner, out);
    }
  }
  
  public abstract void solveOne(Scanner input, PrintStream out);
}
