import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;

public class BFFs {

	public static StringBuilder builder = new StringBuilder();

	public static void findBFFs(String str, int caseNumber) {
		if (caseNumber != 1)
			builder.append(System.getProperty("line.separator"));
		builder.append("Case #" + caseNumber + ": ");

		String[] arr = str.split(" ");
		ArrayList<Integer> intList = new ArrayList<Integer>();
		
		for (String a: arr){
			intList.add(Integer.parseInt(a));
		}
		
		Collections.sort(intList);
		
		int secondLast = -10;
		int last = -5;
		int maxCount = 1;
		int count = 1;
		int flag = -1000;
		for (int z: intList){
			if (z - last ==1) {
				count ++;
			} else if (z - last ==0) {
				if (!(z == last && z == secondLast) && z - flag > 1){
					count ++;
					flag = z;
				}
			} else {
				count = 1;
			}
			if (count > maxCount){
				maxCount = count;
			}
			secondLast = last;
			last = z;
		}
		
		builder.append(maxCount+"");
	}

	public static void writeOutput(String output) {
		try {
			File file = new File("./output.txt");
			FileWriter fileWriter = new FileWriter(file);
			fileWriter.write(output);
			fileWriter.flush();
			fileWriter.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		try (BufferedReader br = new BufferedReader(new FileReader("./input.txt"))) {
			String line;
			int cases = Integer.parseInt(br.readLine());

			int i = 0;
			while ((line = br.readLine()) != null && i < cases) {
				String str = br.readLine();
				findBFFs(str, i+1);
				i++;
			}

			writeOutput(builder.toString());
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
