import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;

public class RankFile {

	public static StringBuilder builder = new StringBuilder();

	public static void rankFile(int n, ArrayList<String> list, int caseNumber) {
		if (caseNumber != 1)
			builder.append(System.getProperty("line.separator"));
		builder.append("Case #" + caseNumber + ": ");

		HashMap<Integer, Integer> counts = new HashMap<Integer, Integer>();

		for (int i = 0; i < list.size(); i++) {
			String[] characters = list.get(i).split(" ");
			for (String str : characters) {
				Integer val = Integer.parseInt(str);
				if (counts.containsKey(val)) {
					counts.put(val, counts.get(val) + 1);
				} else {
					counts.put(val, 1);
				}
			}
		}

		ArrayList<Integer> odds = new ArrayList<Integer>();
		for (Map.Entry<Integer, Integer> set : counts.entrySet()) {
			if (set.getValue() % 2 != 0) {
				odds.add(set.getKey());
			}
		}
		Collections.sort(odds);

		StringBuilder aa = new StringBuilder();
		for (Integer str : odds) {
			aa.append(str+" ");
		}
		builder.append(aa.toString().trim());

	}

	public static void writeOutput(String output) {
		try {
			File file = new File("./output.txt");
			FileWriter fileWriter = new FileWriter(file);
			fileWriter.write(output);
			fileWriter.flush();
			fileWriter.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		try (BufferedReader br = new BufferedReader(new FileReader("./input.txt"))) {
			String line;
			int cases = Integer.parseInt(br.readLine());

			int i = 0;
			while ((line = br.readLine()) != null && i < cases) {
				int N = Integer.parseInt(line);
				int count = 2 * N - 1;
				ArrayList<String> list = new ArrayList<String>();
				for (int j = 0; j < count; j++) {
					list.add(br.readLine());
				}

				rankFile(N, list, i + 1);
				i++;
			}

			writeOutput(builder.toString());
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
