package dmitrib.gcj.welcome;

import java.io.FileInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.FileWriter;
import java.util.List;
import java.util.ArrayList;

/**
 * WelcomeGcj
 * <p/>
 *
 * @author Dmitri Bogdel
 */
public class WelcomeGcj {

  private static final Object[][] TC = {
      {"aaa",   "a",    0},
      {"a",     "aaa",  3},
      {"ab",    "abb",  2},
      {"ab",    "a b",  1},
      {"ab",    "aab",  2},
      {"ab",    "aaa",  0},
      {"ab",    "bbb",  0},
      {"ab",    "ba",   0},
      {"",      "",     0},
      {"a",     "b",    0},
      {"",      "b",    0},
      {"a",     "",     0},

      {"welcome to code jam",     "elcomew elcome to code jam",         1},
      {"welcome to code jam",     "wweellccoommee to code qps jam",     256},
      {"welcome to code jam",     "welcome to codejam",                 0},
  };


  public static void main(String[] args) throws IOException {

    int c[] = new int[1];
    c[0] = 0;

    int failed = 0;

    for (Object[] t : TC) {
      c[0] = 0;
      branch((String)t[0], (String)t[1], c);

      if (c[0] != (Integer)t[2]) {
        System.out.println("FAIL: " + t[0] +" " + t[1] + " must be " + t[2] + " but=" + c[0]);
        failed++;
      }
      else {
        System.out.println("PASS");
      }

    }

    if (failed > 0) {
      throw new RuntimeException("TESTS FAILED");
    }

    main2(args);

  }


  public static void main2(String[] args) throws IOException {

    FileInputStream stream = new FileInputStream("input-welcome.txt");
    BufferedReader input = new BufferedReader(new InputStreamReader(stream));

    List<String> lines = new ArrayList<String>();

    String line;

    int count = Integer.valueOf(input.readLine());

    while((line = input.readLine()) != null) {
      lines.add(line);
    }

    int i=1;

    FileWriter wr = new FileWriter("out-welcome.txt");

    for (String s : lines) {

      int c[] = new int[1];
      c[0] = 0;

      branch("welcome to code jam", s, c);

      wr.write("Case #" + (i++) + ": " + align(String.valueOf(c[0])));
      wr.write("\n");
      wr.flush();

    }
    
    wr.close();

  }

  private static String align(String s) {
    while (s.length() < 4) {
      s = "0" + s;
    }
    return s;
  }


  private static void branch(String patternRemain, String srcRemain, int[] count) {

    //System.out.print("patternRemain = " + patternRemain);
    //System.out.println(" srcRemain = " + srcRemain);

    if (patternRemain.length() == 0) {
      return;
    }

    if (patternRemain.length() > srcRemain.length()) {
      //return;
    }


    char nextChar = patternRemain.charAt(0);

    for (int i=0; i<srcRemain.length(); i++) {

      if (srcRemain.charAt(i) == nextChar) {

        //System.out.println("match i = " + i);

        if (patternRemain.length() == 1) {
          count[0]++;
          count[0] = (count[0] % 10000);  // TODO: check for 1 digit
          //System.out.println("last i = " + i);
        }
                
        branch(patternRemain.substring(1), srcRemain.substring(i+1), count);
      }
    }



  }

}
