import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Solution implements Runnable {
    private final BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    private final PrintWriter writer = new PrintWriter(System.out);
    private StringTokenizer tokenizer;

    private String next() throws Exception {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }
        return tokenizer.nextToken();
    }

    private int nextInt() throws Exception {
        return Integer.parseInt(next());
    }

    private long nextLong() throws Exception {
        return Long.parseLong(next());
    }

    public static void main(String[] args) {
        new Solution().run();
    }

    @Override
    public void run() {
        try {
            solve();
            reader.close();
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(9875);
        }
    }

    private int n, m;
    private int[] r;
    private int[][] a;
    private boolean[] used;

    private void solve() throws Exception {
        int tests = nextInt();
        for (int test = 1; test <= tests; test++) {
            n = nextInt();
            m = nextInt();

            r = new int[n];
            a = new int[n][m];
            for (int i = 0; i < n; i++) {
                r[i] = nextInt();
            }
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    a[i][j] = nextInt();
                }
            }

            used = new boolean[m];

            writer.printf("Case #%d: ", test);
            switch (n) {
                case 1:
                    writer.println(get1());
                    break;
                case 2:
                    writer.println(get2(0));
                    break;
                default:
                    writer.println("Not implemented yet");
                    break;
            }
        }
    }

    private int get1() {
        int result = 0;
        for (int i = 0; i < m; i++) {
            if (isMatch1(a[0][i])) {
                result++;
            }
        }
        return result;
    }

    private int get2(int pos) {
        if (pos == m) {
            return 0;
        }

        int result = get2(pos + 1);

        for (int i = 0; i < m; i++) {
            if (!used[i] && isMatch2(a[0][pos], a[1][i])) {
                used[i] = true;
                result = Math.max(result, 1 + get2(pos + 1));
                used[i] = false;
            }
        }

        return result;
    }

    private boolean isMatch1(int cnt0) {
        int ll0 = (10 * cnt0) / (11 * r[0]);
        if ((10 * cnt0) % (11 * r[0]) > 0) {
            ll0++;
        }
        int rr0 = (10 * cnt0) / (9 * r[0]);

        return ll0 > 0 && ll0 <= rr0;
    }

    private boolean isMatch2(int cnt0, int cnt1) {
        int ll0 = (10 * cnt0) / (11 * r[0]);
        if ((10 * cnt0) % (11 * r[0]) > 0) {
            ll0++;
        }
        int rr0 = (10 * cnt0) / (9 * r[0]);

        int ll1 = (10 * cnt1) / (11 * r[1]);
        if ((10 * cnt1) % (11 * r[1]) > 0) {
            ll1++;
        }
        int rr1 = (10 * cnt1) / (9 * r[1]);

        return ll0 <= rr0 && ll1 <= rr1 && ll0 <= rr1 && ll1 <= rr0;
    }
}

