import java.util.Locale;
import java.util.Scanner;

public class Solution {
    private static final double EPS = 1e-8;

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);

        Scanner scanner = new Scanner(System.in);

        int tests = scanner.nextInt();
        for (int test = 1; test <= tests; test++) {
            double c = scanner.nextDouble();
            double f = scanner.nextDouble();
            double x = scanner.nextDouble();

            System.out.printf("Case #%d: %.7f\n", test, solve(c, f, x));
        }

        scanner.close();
    }

    private static double solve(double c, double f, double x) {
        int ln = 0;
        int rn = 10000000;

        while (rn - ln > 10) {
            int n1 = (2 * ln + rn) / 3;
            int n2 = (ln + 2 * rn) / 3;
            double v1 = f(c, f, x, n1);
            double v2 = f(c, f, x, n2);

            if (v1 > v2) {
                ln = n1;
            } else {
                rn = n2;
            }
        }

        double result = Double.MAX_VALUE;
        for (int i = ln; i <= rn; i++) {
            result = Math.min(result, f(c, f, x, i));
        }

        return result;
    }

    private static double f(double c, double f, double x, int n) {
        double result = 0.0;
        for (int i = 0; i < n; i++) {
            result += c / (2.0 + i * f);
        }
        result += x / (2.0 + n * f);

        return result;
    }
}
