import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * @author Dmitry Levshunov (levshunov.d@gmail.com)
 */
public class FairAndSquare {
    private static final List<Long> palindromes = new ArrayList<Long>();

    public static void main(String[] args) {
        precalc();

        Scanner scanner = new Scanner(System.in);

        int tests = scanner.nextInt();
        for (int test = 0; test < tests; test++) {
            long a = scanner.nextLong();
            long b = scanner.nextLong();
            System.out.printf("Case #%d: %d", test + 1, calc(a, b));
            System.out.println();
        }

        scanner.close();
    }

    private static int calc(long a, long b) {
        int result = 0;
        for (Long palindrome : palindromes) {
            if (a <= palindrome && palindrome <= b) {
                result++;
            }
        }
        return result;
    }

    private static void precalc() {
        for (long x = 1; x <= 10000000; x++) {
            if (isPalindrome(x) && isPalindrome(x * x)) {
                palindromes.add(x * x);
            }
        }
    }

    private static boolean isPalindrome(long x) {
        String s = Long.toString(x);
        for (int i = 0; i < s.length(); i++) {
            if (s.charAt(i) != s.charAt(s.length() - i - 1)) {
                return false;
            }
        }
        return true;
    }
}
