import java.util.Set;
import java.util.Scanner;
import java.util.TreeSet;

public class Solution {
    private static final String[] NAMES = {"Sheldon", "Leonard", "Penny", "Rajesh", "Howard"};

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int tests = scanner.nextInt();
        for (int test = 1; test <= tests; test++) {
            Set<Integer> answer = readCards(scanner, allCards());
            answer = readCards(scanner, answer);

            System.out.printf("Case #%d: ", test);
            if (answer.isEmpty()) {
                System.out.println("Volunteer cheated!");
            } else if (answer.size() > 1) {
                System.out.println("Bad magician!");
            } else {
                System.out.println(answer.iterator().next());
            }
        }

        scanner.close();
    }

    private static Set<Integer> allCards() {
        Set<Integer> result = new TreeSet<>();
        for (int i = 1; i <= 16; i++) {
            result.add(i);
        }
        return result;
    }

    private static Set<Integer> readCards(Scanner scanner, Set<Integer> interestCards) {
        int interestLine = scanner.nextInt() - 1;
        Set<Integer> interestLineCards = new TreeSet<>();

        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                int t = scanner.nextInt();
                if (i == interestLine) {
                    interestLineCards.add(t);
                }
            }
        }

        interestCards.retainAll(interestLineCards);

        return interestCards;
    }
}
