import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/**
 * @author Dmitry Levshunov (levshunov.d@gmail.com)
 */
public class TaskA {
    private static final Map<Character, Character> ALPHABET_MAPPING = new HashMap<Character, Character>() {{
        put('a', 'y');
        put('b', 'h');
        put('c', 'e');
        put('d', 's');
        put('e', 'o');
        put('f', 'c');
        put('g', 'v');
        put('h', 'x');
        put('i', 'd');
        put('j', 'u');
        put('k', 'i');
        put('l', 'g');
        put('m', 'l');
        put('n', 'b');
        put('o', 'k');
        put('p', 'r');
        put('q', 'z');
        put('r', 't');
        put('s', 'n');
        put('t', 'w');
        put('u', 'j');
        put('v', 'p');
        put('w', 'f');
        put('x', 'm');
        put('y', 'a');
        put('z', 'q');
    }};

    public static void main(String[] args) throws Exception {
        Scanner scanner = new Scanner(System.in);

        int tests = Integer.parseInt(scanner.nextLine().trim());

        for (int test = 1; test <= tests; test++) {
            String line = scanner.nextLine();
            System.out.printf("Case #%d: %s", test, processLine(line));
            System.out.println();
        }

        scanner.close();
    }

    private static String processLine(String line) {
        StringBuilder result = new StringBuilder();

        for (char c : line.toCharArray()) {
            if (ALPHABET_MAPPING.containsKey(c)) {
                result.append(ALPHABET_MAPPING.get(c));
            } else {
                result.append(c);
            }
        }

        return result.toString();
    }
}
