import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.Locale;
import java.util.StringTokenizer;

public class Solution implements Runnable {
    private final BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    private final PrintWriter writer = new PrintWriter(System.out);
    private StringTokenizer tokenizer;

    private String next() throws Exception {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }
        return tokenizer.nextToken();
    }

    private int nextInt() throws Exception {
        return Integer.parseInt(next());
    }

    private long nextLong() throws Exception {
        return Long.parseLong(next());
    }

    public static void main(String[] args) {
        new Solution().run();
    }

    @Override
    public void run() {
        try {
            Locale.setDefault(Locale.US);
            solve();
            reader.close();
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(9875);
        }
    }

    private void solve() throws Exception {
        int tests = nextInt();

        DecimalFormat format = new DecimalFormat("0.000000");

        for (int test = 1; test <= tests; test++) {
            double d = nextInt();
            int n = nextInt();

            double maxTime = 0.0;
            for (int i = 0; i < n; i++) {
                double k = nextInt();
                double s = nextInt();
                maxTime = Math.max(maxTime, (d - k) / s);
            }

            writer.println("Case #" + test + ": " + format.format(d / maxTime));
        }
    }
}

