import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Solution implements Runnable {
    private final BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    private final PrintWriter writer = new PrintWriter(System.out);
    private StringTokenizer tokenizer;

    private String next() throws Exception {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }
        return tokenizer.nextToken();
    }

    private int nextInt() throws Exception {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) {
        new Solution().run();
    }

    @Override
    public void run() {
        try {
            solve();
            reader.close();
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(9875);
        }
    }

    private void solve() throws Exception {
        int tests = nextInt();
        for (int test = 1; test <= tests; test++) {
            int result = calculate(next().toCharArray(), nextInt());

            writer.printf("Case #%d: ", test);
            writer.println(result != -1 ? result : "IMPOSSIBLE");
        }
    }

    private int calculate(char[] a, int k) {
        int n = a.length;
        int result = 0;

        for (int i = 0; i < n; i++) {
            if (a[i] == '+') {
                continue;
            }

            result++;

            for (int j = 0; j < k; j++) {
                if (i + j >= n) {
                    return -1;
                } else {
                    a[i + j] = a[i + j] == '-' ? '+' : '-';
                }
            }
        }

        return result;
    }
}

