import java.util.Scanner;

/**
 * @author Dmitry Levshunov (levshunov.d@gmail.com)
 */
public class TicTacToeTomek {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int tests = scanner.nextInt();
        for (int test = 0; test < tests; test++) {
            String[] board = new String[4];
            for (int i = 0; i < 4; i++) {
                board[i] = scanner.next();
            }
            System.out.printf("Case #%d: %s", test + 1, processBoard(board));
            System.out.println();
        }

        scanner.close();
    }

    private static String processBoard(String[] board) {
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[i].length(); j++) {
                char c = board[i].charAt(j);
                if (c == 'X' || c == 'O' || c == 'T') {
                    if (checkWin(board, i, j, 'X', 0, 1)
                            || checkWin(board, i, j, 'X', 1, 0)
                            || checkWin(board, i, j, 'X', 1, 1)
                            || checkWin(board, i, j, 'X', 1, -1)) {
                        return "X won";
                    }
                    if (checkWin(board, i, j, 'O', 0, 1)
                            || checkWin(board, i, j, 'O', 1, 0)
                            || checkWin(board, i, j, 'O', 1, 1)
                            || checkWin(board, i, j, 'O', 1, -1)) {
                        return "O won";
                    }
                }
            }
        }

        if (!isGameCompleted(board)) {
            return "Game has not completed";
        } else {
            return "Draw";
        }
    }

    private static boolean checkWin(String[] board, int x, int y, char c, int dx, int dy) {
        int cnt = 0;
        while (true) {
            if (x < 0 || y < 0 || x >= board.length || y >= board[x].length()) {
                return cnt >= 4;
            }

            if (board[x].charAt(y) != c && board[x].charAt(y) != 'T') {
                return cnt >= 4;
            } else {
                cnt++;
            }

            x += dx;
            y += dy;
        }
    }

    private static boolean isGameCompleted(String[] board) {
        for (String boardLine : board) {
            for (char c : boardLine.toCharArray()) {
                if (c == '.') {
                    return false;
                }
            }
        }

        return true;
    }
}
