import java.util.*;

/**
 * @author Dmitry Levshunov (levshunov.d@gmail.com)
 */
public class QualificationA {
    private static final int ROBOTS_COUNT = 2;

    private static int solve(int n, int[] robotNumber, int[] buttonNumber) {
        int[] currentRobotsPosition = new int[ROBOTS_COUNT];

        Queue<Integer> targetRobotNumber = new LinkedList<Integer>();
        Queue<Integer> targetButtonNumbers = new LinkedList<Integer>();

        List<Queue<Integer>> targetButtonNumbersForRobot =
                new ArrayList<Queue<Integer>>(ROBOTS_COUNT);

        for (int i = 0; i < ROBOTS_COUNT; i++) {
            targetButtonNumbersForRobot.add(new LinkedList<Integer>());
        }

        for (int i = 0; i < n; i++) {
            targetRobotNumber.add(robotNumber[i]);
            targetButtonNumbers.add(buttonNumber[i]);

            targetButtonNumbersForRobot.get(robotNumber[i]).add(buttonNumber[i]);
        }

        int result = 0;

        while (!targetRobotNumber.isEmpty()) {
            int turningRobot = targetRobotNumber.poll();
            int turningButton = targetButtonNumbers.poll();

            while (currentRobotsPosition[turningRobot] != turningButton) {
                doMove(currentRobotsPosition, targetButtonNumbersForRobot);
                result++;
            }

            doMove(currentRobotsPosition, targetButtonNumbersForRobot);
            result++;

            targetButtonNumbersForRobot.get(turningRobot).poll();
        }

        return result;
    }

    private static void doMove(int[] currentRobotsPosition, List<Queue<Integer>> targetButtonNumbersForRobot) {
        for (int robot = 0; robot < ROBOTS_COUNT; robot++) {
            if (!targetButtonNumbersForRobot.get(robot).isEmpty()) {
                int targetButton = targetButtonNumbersForRobot.get(robot).peek();

                if (currentRobotsPosition[robot] < targetButton) {
                    currentRobotsPosition[robot]++;
                } else if (currentRobotsPosition[robot] > targetButton) {
                    currentRobotsPosition[robot]--;
                }
            }
        }
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int testCases = scanner.nextInt();

        for (int testCase = 1; testCase <= testCases; testCase++) {
            int n = scanner.nextInt();

            int[] robotNumber = new int[n];
            int[] buttonNumber = new int[n];

            for (int i = 0; i < n; i++) {
                robotNumber[i] = scanner.next().equals("B") ? 0 : 1;
                buttonNumber[i] = scanner.nextInt() - 1;
            }

            System.out.printf("Case #%d: %d", testCase, solve(n, robotNumber, buttonNumber));
            System.out.println();
        }

        scanner.close();
    }
}
