import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * @author Dmitry Levshunov (levshunov.d@gmail.com)
 */
public class QualificationB {
    private static String solve(String invocations, String[] combinations, String[] oppositions) {
        List<Character> result = new ArrayList<Character>();

        for (char currentElement : invocations.toCharArray()) {
            if (result.isEmpty()) {
                result.add(currentElement);
                continue;
            }

            char previousElement = result.get(result.size() - 1);

            Character combination = getCombination(previousElement, currentElement, combinations);
            if (combination != null) {
                result.set(result.size() - 1, combination);
                continue;
            }

            boolean hasOpposition = false;
            for (Character character : result) {
                if (isOpposition(character, currentElement, oppositions)) {
                    hasOpposition = true;
                    break;
                }
            }

            if (hasOpposition) {
                result.clear();
            } else {
                result.add(currentElement);
            }
        }

        return result.toString();
    }

    private static boolean isOpposition(char previousElement, char currentElement, String[] oppositions) {
        for (String opposition : oppositions) {
            char e1 = opposition.charAt(0);
            char e2 = opposition.charAt(1);

            if ((previousElement == e1 && currentElement == e2) || (previousElement == e2 && currentElement == e1)) {
                return true;
            }
        }

        return false;
    }

    private static Character getCombination(char previousElement, char currentElement, String[] combinations) {
        for (String combination : combinations) {
            char e1 = combination.charAt(0);
            char e2 = combination.charAt(1);

            if ((previousElement == e1 && currentElement == e2) || (previousElement == e2 && currentElement == e1)) {
                return combination.charAt(2);
            }
        }

        return null;
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int testCases = scanner.nextInt();

        for (int testCase = 1; testCase <= testCases; testCase++) {
            String[] combinations = new String[scanner.nextInt()];
            for (int i = 0; i < combinations.length; i++) {
                combinations[i] = scanner.next();
            }

            String[] oppositions = new String[scanner.nextInt()];
            for (int i = 0; i < oppositions.length; i++) {
                oppositions[i] = scanner.next();
            }

            scanner.nextInt();
            String invocations = scanner.next();

            System.out.printf("Case #%d: %s", testCase, solve(invocations, combinations, oppositions));
            System.out.println();
        }

        scanner.close();
    }
}
