import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Solution implements Runnable {
    private final BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    private final PrintWriter writer = new PrintWriter(System.out);
    private StringTokenizer tokenizer;

    private String next() throws Exception {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }
        return tokenizer.nextToken();
    }

    private int nextInt() throws Exception {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) {
        new Solution().run();
    }

    @Override
    public void run() {
        try {
            solve();
            reader.close();
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(9875);
        }
    }

    private char[] a;
    private int[][][] dp;
    private int[][][] next;

    private void solve() throws Exception {
        int tests = nextInt();
        for (int test = 1; test <= tests; test++) {
            a = next().toCharArray();
            dp = new int[a.length][2][10];
            next = new int[a.length][2][10];
            for (int i = 0; i < a.length; i++) {
                Arrays.fill(dp[i][0], -1);
                Arrays.fill(dp[i][1], -1);
                Arrays.fill(next[i][0], -1);
                Arrays.fill(next[i][1], -1);
            }

            get(0, 1, 0);

            writer.printf("Case #%d: ", test);
            boolean hasLeadingNonZero = false;
            int x = 0;
            int isMax = 1;
            for (int i = 0; i < a.length; i++) {
                x = next[i][isMax][x];
                isMax = (isMax == 1) && (x == (a[i] - '0')) ? 1 : 0;
                if (hasLeadingNonZero || x > 0) {
                    writer.print(x);
                    hasLeadingNonZero = true;
                }
            }
            writer.println();
        }
    }

    private boolean get(int pos, int isMax, int prev) {
        if (pos >= a.length) {
            return true;
        }

        int result = dp[pos][isMax][prev];
        if (result != -1) {
            return result == 1;
        }

        boolean bResult = false;

        int bound = (isMax == 1) ? (a[pos] - '0') : 9;
        for (int i = prev; i <= bound; i++) {
            int nextIsMax = (isMax == 1) && (i == bound) ? 1 : 0;
            if (get(pos + 1, nextIsMax, i)) {
                bResult = true;
                next[pos][isMax][prev] = i;
            }
        }

        dp[pos][isMax][prev] = bResult ? 1 : 0;

        return bResult;
    }
}

