import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class Solution implements Runnable {
    private final BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    private final PrintWriter writer = new PrintWriter(System.out);
    private StringTokenizer tokenizer;

    private String next() throws Exception {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }
        return tokenizer.nextToken();
    }

    private int nextInt() throws Exception {
        return Integer.parseInt(next());
    }

    private long nextLong() throws Exception {
        return Long.parseLong(next());
    }

    public static void main(String[] args) {
        new Solution().run();
    }

    @Override
    public void run() {
        try {
            solve();
            reader.close();
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(9875);
        }
    }

    private void solve() throws Exception {
        int tests = nextInt();
        for (int test = 1; test <= tests; test++) {
            int n = nextInt();
            int m = nextInt();
            StringBuilder[] grid = new StringBuilder[n];
            for (int i = 0; i < n; i++) {
                grid[i] = new StringBuilder(next());
            }

            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (grid[i].charAt(j) != '?') {
                        for (int k = j + 1; k < m && grid[i].charAt(k) == '?'; k++) {
                            grid[i].setCharAt(k, grid[i].charAt(j));
                        }
                    }
                }
                for (int j = m - 1; j >= 0; j--) {
                    if (grid[i].charAt(j) != '?') {
                        for (int k = j - 1; k >= 0 && grid[i].charAt(k) == '?'; k--) {
                            grid[i].setCharAt(k, grid[i].charAt(j));
                        }
                    }
                }
            }

            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    if (grid[i].charAt(j) != '?') {
                        for (int k = i + 1; k < n && grid[k].charAt(j) == '?'; k++) {
                            grid[k].setCharAt(j, grid[i].charAt(j));
                        }
                        for (int k = i - 1; k >= 0 && grid[k].charAt(j) == '?'; k--) {
                            grid[k].setCharAt(j, grid[i].charAt(j));
                        }
                    }
                }
            }

            writer.printf("Case #%d:", test);
            writer.println();
            for (StringBuilder line : grid) {
                writer.println(line);
            }
        }
    }
}

