package Round1C;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Scanner;

public class Task3 {
	
	private static void fillArray(int[][] array, int value)
	{
		for (int i = 0; i < array.length; ++i)
			for (int j = 0; j < array[i].length; ++j)
				array[i][j] = value;
	}

	/**
	 * @param args
	 * @throws FileNotFoundException 
	 */
	public static void main(String[] args) throws FileNotFoundException {
		File file = new File("D:/Development/Competitions/GoogleCodeJam/GoogleCodeJam2016/data/Round1C/C-small-attempt1.in");
		PrintStream out = new PrintStream(new FileOutputStream("D:/Development/Competitions/GoogleCodeJam/GoogleCodeJam2016/data/Round1C/C-small-attempt1.out"));
		System.setOut(out);
		
		//Scanner sc = new Scanner(System.in);
		Scanner sc = new Scanner(file);
		int T = sc.nextInt();
		for (int i = 0; i < T; ++i)
		{
			int J = sc.nextInt();
			int P = sc.nextInt();
			int S = sc.nextInt();
			int K = sc.nextInt();
			
			int[][] JP = new int[J][P]; fillArray(JP, K);
			int[][] PS = new int[P][S]; fillArray(PS, K);
			int[][] JS = new int[J][S]; fillArray(JS, K);
			
			HashSet<Integer> combinations = new HashSet<Integer>(J * P * S); 
			
			for (int j = 0; j < J; ++j)
				for (int p = 0; p < P; ++p)
					for (int s = 0; s < S; ++s)
						combinations.add(100 * j + 10 * p + s);
						
			ArrayList<String> result = new ArrayList<String>();

			while (!combinations.isEmpty())
			{
				//Choose combinations whose min of three maximums is biggest
				int maxMin = 0;
				int value = combinations.iterator().next();
				for (Integer combination : combinations)
				{
					int j = combination / 100;
					int p = (combination / 10) % 10;
					int s = combination % 10;
					
					int jp = JP[j][p];
					int ps = PS[p][s];
					int js = JS[j][s];
					
					int localMin = Math.min(Math.min(jp, ps), js);
					if (localMin > maxMin)
					{
						value = combination;
						maxMin = localMin;
					}
				}
				
				// Found the value which could be removed most safely.
				int j = value / 100;
				int p = (value / 10) % 10;
				int s = value % 10;
				result.add(String.format("%c %c %c ", '1'+j, '1'+p, '1'+s));
				//result.add(String.format("%c %c %c jp is %d ps is %d js is %d", '1'+j, '1'+p, '1'+s, JP[j][p]-1, PS[p][s]-1, JS[j][s]-1));
				
				JP[j][p] -= 1;
				if (JP[j][p] == 0)
				{
					for (int sTemp = 0; sTemp < 10; sTemp++)
						combinations.remove(j*100+p*10+sTemp);
				}
				
				PS[p][s] -= 1;
				if (PS[p][s] == 0)
				{
					for (int jTemp = 0; jTemp < 10; jTemp++)
						combinations.remove(jTemp*100+p*10+s);
				}
				
				JS[j][s] -= 1;
				if (JS[j][s] == 0)
				{
					for (int pTemp = 0; pTemp < 10; pTemp++)
						combinations.remove(j*100+pTemp*10+s);
				}
				
				combinations.remove(value);
			}
			
			System.out.println(String.format("Case #%d: %d", i + 1, result.size()));
			/*
			System.out.println(String.format("Case #%d: %d\nJ is %d P is %d S is %d K is %d", i + 1, result.size(), J, P, S, K));
			if ((J > K) || (P > K) || (S > K))
				System.out.println("Case is interesting");
			if (result.size() != J * P * S)
				System.out.println("Case is complicated");
			*/
				 
			for (int j = 0; j < result.size(); ++j)
				System.out.println(result.get(j));
		}
		sc.close();
	}

}