package Round1B;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Scanner;
import java.util.TreeSet;

public class Task2 {
	
	public static int colorToInt(char color)
	{
		switch (color)
		{
		case 'R':
			return 1;
		case 'O':
			return 2;
		case 'Y':
			return 3;
		case 'G':
			return 4;
		case 'B':
			return 5;
		case 'V':
			return 6;
		default:
			return 0;
		}
	}
	
	public static boolean colorsCanNeighbor(char color, char otherColor)
	{
		if (color == otherColor)
			return false;
			
		if (color == 'R')
			return !((otherColor == 'O') || (otherColor == 'V'));
			
		if (color == 'Y')
			return !((otherColor == 'O') || (otherColor == 'G'));
		
		if (color == 'B')
			return !((otherColor == 'G') || (otherColor == 'V'));
			
		if (color == 'O')
			return !((otherColor == 'R') || (otherColor == 'Y'));
			
		if (color == 'G')
			return !((otherColor == 'Y') || (otherColor == 'B'));
		
		if (color == 'V')
			return !((otherColor == 'R') || (otherColor == 'B'));
			
		return false;				
	}

	
	private static class Unicorn implements Comparable<Unicorn>
	{
		public char color;
		public int  quantity;
		
		public Unicorn(char iColor, int iQuantity)
		{
			color = iColor;
			quantity = iQuantity;
		}
		
		@Override
		public int compareTo(Unicorn otherUnicorn) {
			// TODO Auto-generated method stub
			if (quantity != otherUnicorn.quantity)
				return otherUnicorn.quantity - quantity;
			else
				return colorToInt(color) - colorToInt(otherUnicorn.color);
		}
	} 

	/**
	 * @param args
	 * @throws FileNotFoundException 
	 */
	public static void main(String[] args) throws FileNotFoundException {

		File file = new File("D:/Development/Competitions/GoogleCodeJam/GoogleCodeJam2017/data/Round1B/B-small-attempt2.in");
		PrintStream out = new PrintStream(new FileOutputStream("D:/Development/Competitions/GoogleCodeJam/GoogleCodeJam2017/data/Round1B/B-small-attempt2.out"));
		System.setOut(out);
		
		Scanner sc = new Scanner(file);
		int T = sc.nextInt();
		String[] result = new String[T];
		 
		//Solution is the following - 
		for (int i = 0; i < T; ++i)
		{
			
			int N = sc.nextInt();
			TreeSet<Unicorn> unicorns = new TreeSet<Unicorn>();
			
			unicorns.add(new Unicorn('R', sc.nextInt()));
			unicorns.add(new Unicorn('O', sc.nextInt()));
			unicorns.add(new Unicorn('Y', sc.nextInt()));
			unicorns.add(new Unicorn('G', sc.nextInt()));
			unicorns.add(new Unicorn('B', sc.nextInt()));
			unicorns.add(new Unicorn('V', sc.nextInt()));
			
			String res = "";
			char   lastCol = 'N';
			for (int n = 0; n < N; ++n)
			{
				Iterator<Unicorn> iter = unicorns.iterator();
				while (iter.hasNext())
				{
					Unicorn unicorn = iter.next();
					if (colorsCanNeighbor(unicorn.color, lastCol) && (unicorn.quantity > 0))
					{
						lastCol = unicorn.color;
						res = res + lastCol;
						unicorns.remove(unicorn);
						unicorn.quantity--;
						unicorns.add(unicorn);
						break;
					}
				}
				
				if (!iter.hasNext())
				{
					res = "IMPOSSIBLE";
					break;
				}
			}
			
			if (colorsCanNeighbor(res.charAt(0), res.charAt(res.length()-1)))
				result[i] = res;
			else
				result[i] = "IMPOSSIBLE";
		}
		sc.close();

		
		for (int i = 0; i < T; ++i)
		{
			System.out.println(String.format("Case #%d: %s", i + 1, result[i]));
		}

	}

}