package Qualification;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Scanner;

public class Task2 {
	private static int Splits[][] = null;
	
	private static void GenerateSplits()
	{
		Splits = new int[1000][];
		for (int i = 0; i < 1000; ++i)
		{
			Splits[i] = new int[i + 1];
			for (int j = 0; j < i + 1; ++j)
			{
				Splits[i][j] = (i + 1) / (j + 1);
				if ((i + 1) % (j + 1) != 0) ++Splits[i][j];
			}
		}
	}
	
	private static int calculateOptimalTime(ArrayList<Integer> P, int unprocessedIndex, int timeSpentRedistributing, int maxAmountToEat)
	{
		int currentResult = timeSpentRedistributing + maxAmountToEat; 
		if (unprocessedIndex == -1)
			return currentResult;
		int currentValue = P.get(unprocessedIndex);
		if (maxAmountToEat > currentValue)
			return currentResult;
		int[] currentSplit = Splits[currentValue - 1];
		int localMinimumTime = 1000;
		
		for (int i = 0; i < currentSplit.length; ++i)
		{
			int optimalTimeForPreviousIndices = calculateOptimalTime(P, unprocessedIndex - 1, timeSpentRedistributing + i, 
																	 Math.max(currentSplit[i], maxAmountToEat));
			if (optimalTimeForPreviousIndices < localMinimumTime)
				localMinimumTime = optimalTimeForPreviousIndices;
		}
		return localMinimumTime;
	}
	
	public static void main(String[] args) throws FileNotFoundException {
		GenerateSplits();
		File file = new File("./data/B-small-attempt3.in");
		PrintStream out = new PrintStream(new FileOutputStream("./data/B-small-attempt3.out"));
		System.setOut(out);
		
		Scanner sc = new Scanner(file);
		int T = sc.nextInt();
		int[] result = new int[T];
		for (int i = 0; i < T; ++i)
		{
			int D = sc.nextInt();
			ArrayList<Integer> P = new ArrayList<Integer>();
			for (int j = 0; j < D; ++j)
				P.add(sc.nextInt());
			P.sort(null);

			result[i] = calculateOptimalTime(P, P.size() - 1, 0, 0);
		}	
		
		sc.close();
		for (int i = 0; i < T; ++i)
			System.out.println(String.format("Case #%d: %d", i + 1, result[i]));
	}
}

/*

1
1
3
Problem Infinite House of Pancakes

At the Infinite House of Pancakes, there are only finitely many pancakes, but there are infinitely many diners who would be willing to eat them! When the restaurant opens for breakfast, among the infinitely many diners, exactly D have non-empty plates; the ith of these has Pi pancakes on his or her plate. Everyone else has an empty plate.

Normally, every minute, every diner with a non-empty plate will eat one pancake from his or her plate. However, some minutes may be special. In a special minute, the head server asks for the diners' attention, chooses a diner with a non-empty plate, and carefully lifts some number of pancakes off of that diner's plate and moves those pancakes onto one other diner's (empty or non-empty) plate. No diners eat during a special minute, because it would be rude.

You are the head server on duty this morning, and it is your job to decide which minutes, if any, will be special, and which pancakes will move where. That is, every minute, you can decide to either do nothing and let the diners eat, or declare a special minute and interrupt the diners to make a single movement of one or more pancakes, as described above.

Breakfast ends when there are no more pancakes left to eat. How quickly can you make that happen?

Input

The first line of the input gives the number of test cases, T. T test cases follow. Each consists of one line with D, the number of diners with non-empty plates, followed by another line with D space-separated integers representing the numbers of pancakes on those diners' plates.

Output

For each test case, output one line containing "Case #x: y", where x is the test case number (starting from 1) and y is the smallest number of minutes needed to finish the breakfast.

Limits

1 <= T <= 100.
Small dataset

1 <= D <= 6.
1 <= Pi <= 9.
Large dataset

1 <= D <= 1000.
1 <= Pi <= 1000.
Sample


Input 
 	
Output 
 
3
1
3
4
1 2 1 2
1
4

Case #1: 3
Case #2: 2
Case #3: 3

In Case #1, one diner starts with 3 pancakes and everyone else's plate is empty. One optimal strategy is:

Minute 1: Do nothing. The diner will eat one pancake.

Minute 2 (special): Interrupt and move one pancake from that diner's stack onto another diner's empty plate. (Remember that there are always infinitely many diners with empty plates available, no matter how many diners start off with pancakes.) No pancakes are eaten during an interruption.

Minute 3: Do nothing. Each of those two diners will eat one of the last two remaining pancakes.

In Case #2, it is optimal to let the diners eat for 2 minutes, with no interruptions, during which time they will finish all the pancakes.

In Case #3, one diner starts with 4 pancakes and everyone else's plate is empty. It is optimal to use the first minute as a special minute to move two pancakes from the diner's plate to another diner's empty plate, and then do nothing and let the diners eat for the second and third minutes.
*/
