package Qualification;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.math.BigInteger;
import java.nio.charset.StandardCharsets;
import java.util.Scanner;

public class Task3 {
	
	private static void increaseByOne(byte[] bytes)
	{
		int cur = bytes.length-2;
		while (bytes[cur] == 1)
		{
			bytes[cur] = 0;
			--cur;
		}
		bytes[cur] = 1;
	}
	
	private static boolean isDivisibileBy11(byte[] bytes)
	{
		int numberOfEvenOnes = 0;
		int numberOfOddOnes = 0;
		for (int i = 0; i < bytes.length; ++i)
		{
			if (bytes[i] == 1)
			{
				if ((i % 2) == 0)
					numberOfEvenOnes++;
				else
					numberOfOddOnes++;
			}
		}
		
		return (numberOfOddOnes % 11) == (numberOfEvenOnes % 11); 
	}
	
	private static String digitsToString(byte[] bytes)
	{
		String result = new String();
		for (int i = 0; i < bytes.length; ++i)
		{
			if (bytes[i] == 1)
				result = result+"1";
			else
				result = result+"0";
		}
		
		return result;
	}
	
	public static void main(String[] args) throws FileNotFoundException {
		PrintStream out = new PrintStream(new FileOutputStream("D:/Development/Competitions/GoogleCodeJam/GoogleCodeJam2016/data/Qualification/C-small.out"));
		System.setOut(out);
		
		final int N = 16;
		final int J = 50;
		byte[] digits = new byte[N];
		digits[0] = 1;
		digits[15] = 1;
		
		System.out.println("Case #1:");
		for (int i = 0; i < J; ++i)
		{
			while (!isDivisibileBy11(digits))
				increaseByOne(digits);
			String result = digitsToString(digits);
			
			System.out.println(String.format("%s 3 4 5 6 7 8 9 10 11", result));
			increaseByOne(digits);
		}
	}
}