import javafx.util.Pair;

import java.io.*;
import java.util.*;

public class Solution {
    // TODO: do not forget
    private static final int READ_FROM_FILE = 1;
    private static final int WRITE_TO_FILE = 1;
    private static final String INPUT_FILE = "B-small-attempt1.in";
    private static final String OUTPUT_FILE = "B-small-attempt1.out";

    private void run(InputReader in, PrintWriter out) {
        int n = in.nextInt();
        int mas[] = new int[n];
        for(int i = 0; i < n; ++i)
            mas[i] = in.nextInt();
        int ans = Integer.MAX_VALUE;
        for(int i = 0; i <= n; ++i) {
            ArrayList< Pair<Integer, Integer> > m1 = new ArrayList<>();
            ArrayList< Pair<Integer, Integer> > m2 = new ArrayList<>();
            for(int j = 0; j < i; ++j)
                m1.add(new Pair<>(mas[j], j));
            for(int j = i; j < n; ++j)
                m2.add(new Pair<>(mas[j], j - i));
            m1.sort(new Comparator<Pair<Integer, Integer>>() {
                @Override
                public int compare(Pair<Integer, Integer> o1, Pair<Integer, Integer> o2) {
                    return o1.getKey() - o2.getKey();
                }
            });
            m2.sort(new Comparator<Pair<Integer, Integer>>() {
                @Override
                public int compare(Pair<Integer, Integer> o1, Pair<Integer, Integer> o2) {
                    return o2.getKey() - o1.getKey();
                }
            });

            int t = 0;
            if(m1.size() > 1) {
                int last = m1.get(0).getValue();
                for (int j = 1; j < m1.size(); ++j) {
                    if (last < m1.get(j).getValue()) {
                        last = m1.get(j).getValue();
                    } else {
                        t += j - m1.get(j).getValue();
                    }
                }
            }
            if(m2.size() > 1) {
                int last = m2.get(0).getValue();
                for (int j = 1; j < m2.size(); ++j) {
                    if (last < m2.get(j).getValue()) {
                        last = m2.get(j).getValue();
                    } else {
                        t += j - m2.get(j).getValue();
                    }
                }
            }
            ans = Math.min(ans, t);
        }
        out.println(ans);
    }

    public static void main(String[] args) {
        InputReader in;
        PrintWriter out;
        try {
            if (READ_FROM_FILE == 1) {
                in = new InputReader(new FileInputStream(INPUT_FILE));
            } else {
                in = new InputReader(System.in);
            }
            if (WRITE_TO_FILE == 1) {
                out = new PrintWriter(OUTPUT_FILE);
            } else {
                out = new PrintWriter(System.out);
            }
        } catch (IOException e) {
            throw new RuntimeException(e);
        }

        Solution solution = new Solution();
        int cases = in.nextInt();
        for(int i = 1; i <= cases; ++i) {
            out.print("Case #" + i + ": ");
            solution.run(in, out);
        }

        out.println();
        out.flush();
        out.close();
    }

    private static class InputReader {
        private BufferedReader reader;
        private StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream));
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }

        public char nextCharacter() {
            return next().charAt(0);
        }
    }
}