import java.io.*;
import java.util.*;

public class Solution {
    // TODO: do not forget
    private static final int READ_FROM_FILE = 1;
    private static final int WRITE_TO_FILE = 1;
    private static final double EPS = 1e-8;
    private static final String INPUT_FILE = "B-small-attempt1.in";
    private static final String OUTPUT_FILE = "B-small-attempt1.out";

    private void run(InputReader in, PrintWriter out) {
        int n = in.nextInt();
        double v = in.nextDouble(), x = in.nextDouble();
        double s[][] = new double[n][2];
        for(int i = 0; i < n; ++i) {
            s[i][0] = in.nextDouble(); // r
            s[i][1] = in.nextDouble(); // c
        }

        double result = -1;
        if(n == 1) {
            if(Math.abs(x - s[0][1]) < EPS) {
                result = v / s[0][0];
            }
        } else {
            double lessT = Math.min(s[0][1], s[1][1]);
            double grT = Math.max(s[0][1], s[1][1]);
            if(lessT <= x && x <= grT || Math.abs(x - lessT) < EPS || Math.abs(x - grT) < EPS) {
                if(Math.abs(x - s[0][1]) < EPS) {
                    if(Math.abs(x - s[1][1]) < EPS) {
                        result = v / (s[0][0] + s[1][0]);
                    } else {
                        result = v / s[0][0];
                    }
                } else if(Math.abs(x - s[1][1]) < EPS) {
                    result = v / s[1][0];
                } else {
                    double v0 = v * (x - s[1][1]) / (s[0][1] - s[1][1]);
                    double v1 = v - v0;
                    result = Math.max(v0 / s[0][0], v1 / s[1][0]);
                }
            }
        }

        if(result < 0) {
            out.print("IMPOSSIBLE");
        } else {
            out.print(String.format("%.9f", result).replace(",", "."));
        }
    }

    public static void main(String[] args) {
        InputReader in;
        PrintWriter out;
        try {
            if (READ_FROM_FILE == 1) {
                in = new InputReader(new FileInputStream(INPUT_FILE));
            } else {
                in = new InputReader(System.in);
            }
            if (WRITE_TO_FILE == 1) {
                out = new PrintWriter(OUTPUT_FILE);
            } else {
                out = new PrintWriter(System.out);
            }
        } catch (IOException e) {
            throw new RuntimeException(e);
        }

        Solution solution = new Solution();
        int cases = in.nextInt();
        for(int i = 1; i <= cases; ++i) {
            out.print("Case #" + i + ": ");
            solution.run(in, out);
            out.println();
        }

        out.println();
        out.flush();
        out.close();
    }

    private static class InputReader {
        private BufferedReader reader;
        private StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream));
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }

        public char nextCharacter() {
            return next().charAt(0);
        }
    }
}