import java.io.*;
import java.util.*;

public class Solution {
    // TODO: do not forget
    private static final int READ_FROM_FILE = 1;
    private static final int WRITE_TO_FILE = 1;
    private static final String INPUT_FILE = "C-small-attempt2.in"; // "input.txt";
    private static final String OUTPUT_FILE = "C-small-attempt2.out";

    private void run(InputReader in, PrintWriter out) {
        int n = in.nextInt(), q = in.nextInt();
        long e[] = new long[n], s[] = new long[n];
        for(int i = 0; i < n; ++i) {
            e[i] = in.nextLong();
            s[i] = in.nextLong();
        }
        long d[][] = new long[n][n];
        for(int i = 0; i < n; ++i) {
            for(int j = 0; j < n; ++j) {
                d[i][j] = in.nextLong();
            }
        }
        for(int i = 0; i < q; ++i) {
            int u = in.nextInt(), v = in.nextInt();

            double dp[][] = new double[n][n];
            for(int j = 0; j < n - 1; ++j) {
                double start = Long.MAX_VALUE;
                for(int k = 0; k < j; ++k) {
                    if(dp[j][k] > 0) {
                        start = Math.min(start, dp[j][k]);
                    }
                }
                if (j == 0) {
                    start = 0;
                }

                int ind = j + 1;
                long rem = e[j], path = d[ind - 1][ind];
                while(rem >= path) {
                    double time = (double) path / s[j];
                    if(dp[ind][j] == 0 || dp[ind][j] > start + time) {
                        dp[ind][j] = start + time;
                    }
                    rem -= path;
                    start += time;
                    ind++;
                    if (ind == n) {
                        break;
                    }
                    path = d[ind - 1][ind];
                }

            }
            double ans = Long.MAX_VALUE;
            for(int j = 0; j < n; ++j) {
                if (dp[n - 1][j] > 0) {
                    ans = Math.min(ans, dp[n - 1][j]);
                }
            }
            out.print(String.format("%.9f", ans).replace(",", "."));
        }
    }

    public static void main(String[] args) {
        InputReader in;
        PrintWriter out;
        try {
            if (READ_FROM_FILE == 1) {
                in = new InputReader(new FileInputStream(INPUT_FILE));
            } else {
                in = new InputReader(System.in);
            }
            if (WRITE_TO_FILE == 1) {
                out = new PrintWriter(OUTPUT_FILE);
            } else {
                out = new PrintWriter(System.out);
            }
        } catch (IOException e) {
            throw new RuntimeException(e);
        }

        Solution solution = new Solution();
        int cases = in.nextInt();
        for(int i = 1; i <= cases; ++i) {
            out.print("Case #" + i + ": ");
            solution.run(in, out);
            out.println();
        }

        out.println();
        out.flush();
        out.close();
    }

    private static class InputReader {
        private BufferedReader reader;
        private StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream));
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }

        public char nextCharacter() {
            return next().charAt(0);
        }
    }
}