import java.util.*;
import java.util.regex.Pattern;
import java.io.*;

public class Solution implements Runnable {
    static {
        Locale.setDefault(Locale.US);
    }

    public static void main(String[] args) {
        new Thread(new Solution()).start();
    }

    public void run() {
        try {
            solve();
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException(e.getMessage());
        }
    }

    String next() throws Exception {
    	while (tok == null || !tok.hasMoreTokens())
    		tok = new StringTokenizer(cin.readLine());
    	return tok.nextToken();
    }

    int nextInt() throws Exception {
        return Integer.parseInt(next());
    }

    BufferedReader cin;
    PrintWriter cout;
    StringTokenizer tok;
    
    String[] a;

    private void solve() throws Exception {
        cin = new BufferedReader(new FileReader("input.txt"));
        cout = new PrintWriter(new File("output.txt"));
        
        nextInt();
        int n = nextInt(), m = nextInt();
        a = new String[n];
        for(int i = 0; i < n; ++i)
        	a[i] = next();
        
        for(int tc = 1; tc <= m; ++tc) {
        	String pat = next().replace('(', '[').replace(')', ']');
        	Pattern pattern = Pattern.compile(pat);
        	int ans = 0;
        	for(String s: a)
        		if (pattern.matcher(s).matches()) ++ans;
        	cout.println("Case #" + tc + ": " + ans);
        } 

        cin.close();
        cout.close();
    }

}
