import java.util.*;
import java.io.*;


public class Solution implements Runnable {
	final int ITER = 1000000;
	
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			throw new RuntimeException(e.toString());
		}
	}
	
	BufferedReader cin;
	PrintWriter cout;
	StringTokenizer tok;
	
	String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		return tok.nextToken();
	}
	
	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}
	
	boolean[] used;

	private void solve() throws Exception {
		cin = new BufferedReader(new FileReader("input.txt"));
		cout = new PrintWriter(new File("output.txt"));
		
		used = new boolean[10];
		
		int tk = nextInt();
		for (int tc = 1; tc <= tk; ++tc) {
			long x = nextInt();
			Arrays.fill(used, false);
			cout.print("Case #" + tc + ": ");
			
			int digits = 0;
			for (int i = 1; i <= ITER && digits < 10; ++i) {
				long s = x * i;
				do {
					int dig = (int) (s % 10);
					if (!used[dig]) ++digits;
					used[dig] = true;
					s /= 10;
				} while (s > 0);
				if (digits == 10) cout.println(x * i);
			}
			
			if (digits != 10) cout.println("INSOMNIA");
		}
		
		cin.close();
		cout.close();
	}

}
