import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Solution {
	public static void main(String[] args) throws Exception {
		try {
			new Solution().solve();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	BufferedReader cin;
	PrintWriter cout;
	StringTokenizer tok;
	
	String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens())
			tok = new StringTokenizer(cin.readLine());
		return tok.nextToken();
	}
	
	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}
	
	BigInteger[] a;
	BigInteger[] c;
	int n;

	void solve() throws Exception {
		cin = new BufferedReader(new FileReader("input.txt"));
		cout = new PrintWriter(new File("output.txt"));
		
		int tk = nextInt();
		
		for(int tc = 1; tc <= tk; ++tc) {
			n = nextInt();
			a = new BigInteger[n];
			c = new BigInteger[n];
			
			for(int i = 0; i < n; ++i)
				a[i] = new BigInteger(next());
			
			Arrays.sort(a);
			
			BigInteger g = a[1].subtract(a[0]);
			for(int i = 2; i < n; ++i)
				g = g.gcd(a[i].subtract(a[0]));
			
			for(int i = 0; i < n; ++i) {
				BigInteger[] dar = a[i].divideAndRemainder(g);
				c[i] = dar[0];
				if (!dar[1].equals(BigInteger.ZERO)) 
					c[i] = c[i].add(BigInteger.ONE);
			}
			
			BigInteger ans = c[0];
			for(int i = 1; i < n; ++i) {
				BigInteger t = a[i].subtract(a[0]).divide(g);
				BigInteger cans = c[i].subtract(t);
				if (ans.compareTo(cans) < 0) ans = cans;
			}
			
			ans = ans.multiply(g).subtract(a[0]);
			
			cout.println("Case #" + tc + ": " + ans);
			
			System.err.println("Case #" + tc + " is solved.");
			System.err.flush();
		}
		
		cin.close();
		cout.close();
	}
}
