import java.util.*;
import java.io.*;

import static java.lang.Math.*;


public class Solution implements Runnable {

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException(e.toString());
		}
	}
	
	BufferedReader cin;
	PrintWriter cout;
	StringTokenizer tok;
	
	String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		return tok.nextToken();
	}
	
	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}
	
	long pow(long a, int b) {
		long res = 1;
		for (int i = 0; i < b; ++i)
			res = res * a;
		return res;
	}
	
	long get(int l, int r, int k, int pow) {
		long ans = 0;
		while (pow > 1) {
			ans += (r - 1) * pow(k, pow - 1);
			r = max(l, r - 1);
			pow--;
		}
		if (l != r) throw new RuntimeException("L and R do not match");
		return ans + l;
	}

	private void solve() throws Exception {
		cin = new BufferedReader(new FileReader("input.txt"));
		cout = new PrintWriter(new File("output.txt"));
		
		int tk = nextInt();
		for (int tc = 1; tc <= tk; ++tc) {
			int k = nextInt();
			int c = nextInt();
			int s = nextInt();
			
			if (c * s < k) {
				cout.println("Case #" + tc + ": IMPOSSIBLE");
				continue;
			}
			
			int group = min(k, c);
			cout.print("Case #" + tc + ":");
			for (int i = 1; i <= (k + group - 1) / group; ++i) {
				cout.print(" " + get((i - 1) * group + 1, min(i * group, k), k, group));
			}
			cout.println();
		}
		
		cin.close();
		cout.close();
	}

}
