import java.text.DecimalFormat;
import java.util.*;
import java.io.*;
import static java.lang.Math.*;

public class Solution implements Runnable {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new Solution()).start();
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens())
			tok = new StringTokenizer(cin.readLine());
		return tok.nextToken();
	}
	
	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}
	
	BufferedReader cin;
	PrintWriter cout;
	StringTokenizer tok;

	class Circle {
		double x, y, r;
		
		Circle() throws Exception {
			x = nextInt();
			y = nextInt();
			r = nextInt();
		}
	}
	int n;
	Circle[] a;

	private void solve() throws Exception {
		cin = new BufferedReader(new FileReader("input.txt"));
		cout = new PrintWriter(new File("output.txt"));
		
		int tk = nextInt();
		for(int tc = 1; tc <= tk; ++tc) {
			n = nextInt();
			
			a = new Circle[n];
			for(int i = 0; i < n; ++i) {
				a[i] = new Circle();
			}
			
			cout.println("Case #" + tc + ": " + new DecimalFormat("0.000000000").format(getAns()));
			System.out.println("Solved case " + tc + "/" + tk);
			System.out.flush();
		}
		
		cin.close();
		cout.close();
	}

	private double getAns() {
		if (n == 1) return a[0].r;
		if (n == 2) return Math.max(a[0].r, a[1].r);
		
		double res = 1E40;
		
		res = Math.min(res, getAns(a[0], a[1], a[2]));
		res = Math.min(res, getAns(a[0], a[2], a[1]));
		res = Math.min(res, getAns(a[2], a[1], a[0]));
		
		return res;
	}

	private double getAns(Circle c1, Circle c2, Circle c3) {
		double rc = (hypot(c1.x - c2.x, c1.y - c2.y) + c1.r + c2.r) / 2.0;
		return Math.max(rc, c3.r);
	}
}
