import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {

	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	StringTokenizer tok;
	BufferedReader cin;
	PrintWriter cout;
	
	private String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}
	
	class Chicken implements Comparable<Chicken>{
		int x, v;

		public Chicken(int x, int v) {
			this.x = x;
			this.v = v;
		}

		public int compareTo(Chicken o) {
			if (x > o.x) return -1;
			if (x < o.x) return 1;
			
			return 0;
		}
	}

	int cases;
	int n, k, b, t;
	Chicken[] a;
	int[] Xes;
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		cin = new BufferedReader(new FileReader("B-small-attempt0.in"));
		//cout = new PrintWriter(System.out);
		cout = new PrintWriter("output.txt");
		
		cases = nextInt();

		for (int testcase = 0; testcase < cases; ++testcase) {
			n = nextInt();
			k = nextInt();
			b = nextInt();
			t = nextInt();
			
			a = new Chicken[n];
			Xes = new int[n];
			
			for (int i = 0; i < n; ++i) {
				Xes[i] = nextInt();
			}
			
			for (int i = 0; i < n; ++i) {
				a[i] = new Chicken(Xes[i], nextInt());
			}
			
			Arrays.sort(a);
			
			int ans = 0;
			int passed = 0;
			
			for (int i = 0; i < n && passed < k; ++i) {
				if (a[i].x + a[i].v * t >= b) {
					ans += i - passed;
					++passed;
				}
			}
			
			cout.print("Case #" + (testcase + 1) + ": ");
			if (passed < k) {
				cout.println("IMPOSSIBLE");
			} else {
				cout.println(ans);
			}
		}
		
		cout.close();
	}
}
