import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {

	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	StringTokenizer tok;
	BufferedReader cin;
	PrintWriter cout;
	
	private String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	int n, m, cases;
	char[][] a;
	
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		cin = new BufferedReader(new FileReader("A-small-attempt0.in"));
		cout = new PrintWriter("output.txt");
		
		m = nextInt();
		n = nextInt();
		cases = nextInt();
		
		a = new char[n][];
		for (int i = 0; i < n; ++i) {
			a[i] = cin.readLine().toCharArray();
		}
		
		for (int testcase = 0; testcase < cases; ++testcase) {
			cout.println("Case #" + (testcase + 1) + ": " + count(cin.readLine().toCharArray()));
			cout.flush();
		}
		
		cout.close();
	}

	private int count(char[] str) {
		int ans = 0;
		
		ArrayList<HashSet<Character>> theWord = new ArrayList<HashSet<Character>>();
		
		int i = 0;
		while (i < str.length) {
			HashSet<Character> theLetter = new HashSet<Character>();
			
			if (str[i] != '(') {
				theLetter.add(str[i]);
				++i;
			} else {
				++i;
				while (str[i] != ')') {
					theLetter.add(str[i]);
					++i;
				}
				++i;
			}
			
			theWord.add(theLetter);
		}
		
		HashSet<Character>[] word = theWord.toArray(new HashSet[theWord.size()]);
		
		for (i = 0; i < n; ++i) {
			boolean ok = true;
			
			for (int j = 0; j < m; ++j) {
				if (! word[j].contains(a[i][j])) {
					ok = false;
					break;
				}
			}
			
			if (ok) {
				++ans;
			}
		}
		
		return ans;
	}
}
