import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.StringTokenizer;


public class Solution implements Runnable {
	
	private static final double SUP = Integer.MAX_VALUE >> 1;

	public static void main(String[] args) {
		new Thread(new Solution()).run();
	}
	
	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException("Laja in solution");
		}
	}
	
	private String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}
	
	private double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}
	
	private long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	BufferedReader cin;
	StringTokenizer tok;
	PrintWriter cout;
	
	class Circle {
		double x, y, r;

		public Circle(double x, double y, double r) {
			this.x = x;
			this.y = y;
			this.r = r;
		}
	}
	
	int testcases, n;
	Circle[] a;
	double ans;
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		cin = new BufferedReader(new FileReader("D-small-attempt0.in"));
		cout = new PrintWriter("output.txt");
		//cout = new PrintWriter(System.out);
		
		testcases = nextInt();
		
		for (int testcase = 0; testcase < testcases; ++testcase) {
			n = nextInt();
			
			a = new Circle[n];
			
			for (int i = 0; i < n; ++i) {
				a[i] = new Circle(nextInt(), nextInt(),	nextInt());
			}
			
			ans = SUP;
			
			if (n == 1) {
				ans = a[0].r;
			} 
			
			if (n == 2) {
				ans = Math.max(a[0].r, a[1].r);
			}
			
			if (n == 3) {
				tryAns(a[0], a[1], a[2]);
				tryAns(a[1], a[2], a[0]);
				tryAns(a[2], a[0], a[1]);
			}
			
			cout.println("Case #" + (testcase + 1) + ": " + new DecimalFormat("#0.0000000").format(ans));
		}
		
		cout.close();
	}

	private void tryAns(Circle a, Circle b, Circle c) {
		double r = (a.r + b.r + dist(a, b)) / 2;
		
		r = Math.max(r, c.r);
		
		ans = Math.min(ans, r);
	}

	private double dist(Circle a, Circle b) {
		return Math.hypot(a.x - b.x, a.y - b.y);
	}
}
