import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class Solution implements Runnable {

	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}
	
	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException("Laja in solution");
		}
	}
	
	private String next() throws IOException {
		while (tok == null || tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	private long nextLong() throws IOException {
		return Long.parseLong(next());
	}
	
	BufferedReader cin;
	StringTokenizer tok;
	PrintWriter cout;
	char[] a;
	
	public void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		cin = new BufferedReader(new FileReader("A-small-attempt2.in"));
		cout = new PrintWriter("output.txt");
		//cout = new PrintWriter("");
		
		makeMapping();
		
		cin.readLine();
		String s = cin.readLine();
		
		int testcase = 1;
		
		while (s != null) {
			cout.println("Case #" + testcase + ": " + map(s));
			++testcase;
			s = cin.readLine();
		}
		
		cout.close();
	}
	
	private String map(String s) {
		StringBuffer buf = new StringBuffer();
		
		for (int i = 0; i < s.length(); ++i) {
			buf.append(a[s.charAt(i)]);
		}
		
		return buf.toString();
	}

	String english    = "our language is impossible to understand there are twenty six factorial possibilities so it is okay if you want to just give up";
	String googlerese = "ejp mysljylc kd kxveddknmc re jsicpdrysi rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd de kr kd eoya kw aej tysr re ujdr lkgc jv";
	
	private void makeMapping() {
		a = new char[256];
		
		int cnt = 0;
		
		for (int i = 0; i < english.length(); ++i) {
			if (a[googlerese.charAt(i)] == 0) {
				++cnt;
				a[googlerese.charAt(i)] = english.charAt(i);
			}
		}
		
		a['q'] = 'z';
		a['z'] = 'q';
		cnt += 2;
		
		if (cnt != 27) {
			for (char ch = 'a'; ch <= 'z'; ++ch) {
				if (a[ch] == 0) {
					System.out.println("'" + ch + "' is missing!");
					System.out.flush();
				}
			}
			
			throw new RuntimeException("Cnt is " + cnt);
		}
	}
}
