import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class Solution implements Runnable {
	
	public static void main(String[] args) {
		new Thread(new Solution()).run();
	}
	
	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException("Laja in solution");
		}
	}
	
	private String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}
	
	private double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}
	
	private long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	BufferedReader cin;
	StringTokenizer tok;
	PrintWriter cout;
	
	private int testcases;
	private int n, k;
	private int[][] prices;
	private int[] a;
	private int[] group;
	private int numberOfGroups;
	int[] bit;
	private int ans;
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		cin = new BufferedReader(new FileReader("C-small-attempt0.in"));
		cout = new PrintWriter("output.txt");
		//cout = new PrintWriter(System.out);
		
		bit = new int[30];
		for (int i = 0; i < 30; ++i) {
			bit[i] = 1 << i;
		}
		
		testcases = nextInt();
		
		for (int testcase = 0; testcase < testcases; ++testcase) {
			n = nextInt();
			k = nextInt();
			
			prices = new int[n][k];
			a = new int[n];
			
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < k; ++j) {
					prices[i][j] = nextInt();
				}
			}
			
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < n; ++j) {
					if ((i != j) && intersect(i, j)) {
						a[i] = set(a[i], j);
					}
				}
			}
			
			group = new int[n];
			numberOfGroups = 0;
			ans = n;
			
			rec(0);
			
			cout.println("Case #" + (testcase + 1) + ": " + ans);
		}
		
		cout.close();
	}

	private void rec(int v) {
		if (ans <= numberOfGroups) {
			return;
		}
		
		if (v == n) {
			ans = numberOfGroups;
			return;
		}
		
		for (int i = 0; i < numberOfGroups; ++i) {
			if ((a[v] & group[i]) == 0) {
				group[i] = set(group[i], v);
				rec(v + 1);
				group[i] = unset(group[i], v);
			}
		}
		
		group[numberOfGroups] = set(0, v);
		++numberOfGroups;
		rec(v + 1);
		--numberOfGroups;
		group[numberOfGroups] = 0;
	}

	private boolean intersect(int u, int v) {
		for (int i = 0; i < k - 1; ++i) {
			if (! ((prices[u][i] < prices[v][i] && prices[u][i + 1] < prices[v][i + 1]) || 
				   (prices[u][i] > prices[v][i] && prices[u][i + 1] > prices[v][i + 1]))
			   ) 
			{
				return true;
			}
		}
		
		return false;
	}

	private int set(int val, int j) {
		return val | bit[j];
	}
	
	private int unset(int val, int j) {
		return val & (~ bit[j]);
	}
}
