import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {

	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	StringTokenizer tok;
	BufferedReader cin;
	PrintWriter cout;
	
	private String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	int cases;
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		//cin = new BufferedReader(new FileReader("B-small-attempt0.in"));
		//cin = new BufferedReader(new FileReader("B-small-attempt1.in"));
		cin = new BufferedReader(new FileReader("B-large.in"));
		cout = new PrintWriter("output.txt");
		
		cases = nextInt();

		for (int testcase = 0; testcase < cases; ++testcase) {
			char[] number = next().toCharArray();
			char[] answer = null;
			
			for (int i = number.length - 1; i >= 0; --i) {
				int pos = -1;
				char minVal = '9' + 1;
				
				for (int j = i + 1; j < number.length; ++j) {
					if (number[j] < minVal && number[j] > number[i]) {
						minVal = number[j];
						pos = j;
					}
				}
				
				if (pos == -1 || number[i] >= minVal) {
					continue;
				}
				
				char temp = number[i];
				number[i] = number[pos];
				number[pos] = temp;
				
				Arrays.sort(number, i + 1, number.length);
				
				answer = number;
				break;
			}
			
			if (answer == null) {
				answer = new char[number.length + 1];
				
				for (int i = 0; i < number.length; ++i) {
					answer[i] = number[i];
				}
				
				answer[number.length] = '0';
				
				Arrays.sort(answer);
				
				int pos = -1;
				char minVal = '9' + 1;
				
				for (int j = 0; j < answer.length; ++j) {
					if (answer[j] < minVal && answer[j] != '0') {
						minVal = answer[j];
						pos = j;
					}
				}
				
				char temp = answer[0];
				answer[0] = answer[pos];
				answer[pos] = temp;
			}
			
			cout.println("Case #" + (testcase + 1) + ": " + new String(answer));
		}
		
		cout.close();
	}
}
