import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new Solution()).start();
	}
	
	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException("Laja in solution");
		}
	}

	private String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	BufferedReader cin;
	StringTokenizer tok;
	PrintWriter cout;
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		cin = new BufferedReader(new FileReader("B-small-attempt0.in"));
		cout = new PrintWriter(new File("output.txt"));
		
		int testcases = nextInt();
		
		for (int testcase = 0; testcase < testcases; ++testcase) {
			int n = nextInt();
			int m = nextInt();
			int d = nextInt();
			
			int[][] a = new int[n][m];
			for (int i = 0; i < n; ++i) {
				char[] str = next().toCharArray();
				
				for (int j = 0; j < m; ++j) {
					a[i][j] = str[j] - '0' + d;
				}
			}
			
			int ans = 0;
			
			//first
			for (int x = 1; x < n - 1; ++x) {
				for (int y = 1; y < m - 1; ++y) {
					int maxdist = min(x, n - 1 - x, y, m - 1 - y);
					
					for (int len = 1; len <= maxdist; ++len) {
						Point curSum = new Point(0, 0, 0);
						
						for (int i = x - len; i <= x + len; ++i) {
							for (int j = y - len; j <= y + len; ++j) {
								curSum.add(new Point(i - x, j - y, a[i][j]));
							}
						}
						
						curSum.substract(new Point(-len, -len, a[x - len][y - len]));
						curSum.substract(new Point(-len, +len, a[x - len][y + len]));
						curSum.substract(new Point(+len, -len, a[x + len][y - len]));
						curSum.substract(new Point(+len, +len, a[x + len][y + len]));
						
						if (curSum.x == 0 && curSum.y == 0) {
							ans = max(ans, len * 2 + 1);
						}
					}
				}
			}
			
			// other
			for (int x = 1; x < n - 1; ++x) {
				for (int y = 1; y < m - 1; ++y) {
					int maxdist = min(x + 1, n - 1 - x, y + 1, m - 1 - y);
					
					for (int len = 2; len <= maxdist; ++len) {
						Point curSum = new Point(0, 0, 0);
						
						int centreX = x * 2 + 1;
						int centreY = y * 2 + 1;
						
						for (int i = x - len + 1; i <= x + len; ++i) {
							for (int j = y - len + 1; j <= y + len; ++j) {
								curSum.add(new Point(i * 2 - centreX, j * 2 - centreY, a[i][j]));
							}
						}
						
						curSum.substract(new Point(- 2 * len + 1, - 2 * len + 1, a[x - len + 1][y - len + 1]));
						curSum.substract(new Point(- 2 * len + 1, + 2 * len - 1, a[x - len + 1][y + len]));
						curSum.substract(new Point(+ 2 * len - 1, - 2 * len + 1, a[x + len][y - len + 1]));
						curSum.substract(new Point(+ 2 * len - 1, + 2 * len - 1, a[x + len][y + len]));
						
						if (curSum.x == 0 && curSum.y == 0) {
							ans = max(ans, len * 2);
						}
					}
				}
			}
			
			if (ans == 0) {
				cout.printf("Case #%d: IMPOSSIBLE\n", (testcase + 1));
			} else {
				cout.printf("Case #%d: %d\n", (testcase + 1), ans);
			}
		}
		
		cout.close();
	}

	private int min(int x, int y, int i, int j) {
		return min(x, min(y, min(i, j)));
	}

	private int min(int i, int j) {
		if (i < j) {
			return i;
		} else {
			return j;
		}
	}
	
	private class Point {
		int x;
		int y;
		
		public Point(int x, int y, int mult) {
			this.x = x * mult;
			this.y = y * mult;
		}
		
		public void add(Point other) {
			this.x += other.x;
			this.y += other.y;
		}
		
		public void substract(Point other) {
			this.x -= other.x;
			this.y -= other.y;
		}
	}
}