import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new Solution()).start();
	}
	
	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException("Laja in solution");
		}
	}

	private String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	BufferedReader cin;
	StringTokenizer tok;
	PrintWriter cout;
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		cin = new BufferedReader(new FileReader("C-small-attempt0.in"));
		cout = new PrintWriter(new File("output.txt"));
		
		int testcases = nextInt();
		
		for (int testcase = 0; testcase < testcases; ++testcase) {
			int n = nextInt();
			
			int[] a = new int[n + 1];
			int[] b = new int[n + 1];
			
			int max = 1;
			for (int i = 2; i <= n; ++i) {
				factorize(i, b);
				
				max += check(a, b);
			}
			
			Arrays.fill(a, 0);
			int min = 0;
			if (n == 1) {
				min = 1;
			}
			
			for (int i = n; i > 1; --i) {
				factorize(i, b);
				
				min += check(a, b);
			}
			
			cout.printf("Case #%d: %d\n", (testcase + 1), max - min);
		}
		
		cout.close();
	}

	private void factorize(int v, int[] b) {
		Arrays.fill(b, 0);
		
		int rest = v;
		for (int i = 2; i <= rest; ++i) {
			while (rest % i == 0) {
				rest /= i;
				++b[i];
			}
		}
		
		if (rest > 1) {
			throw new RuntimeException("fuck");
		}
	}
	
	private int check(int[] a, int[] b) {
		int result = 0;
		
		for (int i = 0; i < a.length; ++i) {
			if (a[i] < b[i]) {
				a[i] = b[i];
				result = 1;
			}
		}
		
		return result;
	}
}