import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {

	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	StringTokenizer tok;
	BufferedReader cin;
	PrintWriter cout;
	
	private String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	int cases;
	long r, k;
	int n;
	long[] a, used;
	int[] len;
	
	long sum;
	int v;
	int curLen;
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		cin = new BufferedReader(new FileReader("C-small-attempt0.in"));
		//cout = new PrintWriter(System.out);
		cout = new PrintWriter("output.txt");
		
		cases = nextInt();

		for (int testcase = 0; testcase < cases; ++testcase) {
			r = nextInt();
			k = nextInt();
			n = nextInt();
			
			a = new long[n];
			
			for (int i = 0; i < n; ++i) {
				a[i] = nextInt();
			}
			
			len = new int[n];
			used = new long[n];
			
			sum = 0;
			v = 0;
			curLen = 0;
			
			go();
			
			if (r > 0) {
				int cycleLength = curLen - len[v];
				long cycleValue = sum - used[v];
				sum += (r / cycleLength) * cycleValue;
				r = r % cycleLength;
			}
			
			go();
			
			cout.println("Case #" + (testcase + 1) + ": " + sum);
		}
		
		cout.close();
	}

	private void go() {
		Arrays.fill(used, -1);
		
		while (r > 0 && used[v] == -1) {
			--r;
			used[v] = sum;
			len[v] = curLen++;
			
			int loaded = 0;
			int t = v;
			while (true) {
				if (loaded + a[t] > k) {
					break;
				}
				
				loaded += a[t];
				t = (t + 1) % n;
				if (t == v) {
					break;
				}
			}
			
			if (loaded == 0) {
				r = 0;
				break;
			}
			
			sum += loaded;
			v = t;
		}		
	}
}
