import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {

	private static final int SUP = Integer.MAX_VALUE;

	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	StringTokenizer tok;
	BufferedReader cin;
	PrintWriter cout;
	
	private String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}
	
	private final int[] dx = {-1, 0, 0, 1};
	private final int[] dy = {0, -1, 1, 0};

	int[][] a;
	int[][] basin;
	int n, m, cases, current;
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		//cin = new BufferedReader(new FileReader("B-small-attempt0.in"));
		cin = new BufferedReader(new FileReader("B-large.in"));
		cout = new PrintWriter("output.txt");

		cases = nextInt();
		
		for (int testcase = 0; testcase < cases; ++testcase) {
			n = nextInt();
			m = nextInt();
			a = new int[n][m];
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					a[i][j] = nextInt();
				}
			}

			basin = new int[n][m];
			current = 1;
			
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					dfs(i, j);
				}
			}
			
			cout.println("Case #" + (testcase + 1) + ":");
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m - 1; ++j) {
					cout.print((char)('a' + basin[i][j] - 1) + " ");
				}
				
				cout.println((char)('a' + basin[i][m - 1] - 1));
			}
		}
		
		cout.close();
	}

	private int dfs(int i, int j) {
		if (basin[i][j] != 0) {
			return basin[i][j];
		}
		
		int minLev = SUP;
		int minPoint = -1;
		
		for (int k = 0; k < 4; ++k) {
			int x = i + dx[k];
			int y = j + dy[k];
			if (inField(x, y)) {
				if (a[x][y] < minLev) {
					minLev = a[x][y];
					minPoint = k;
				}
			}
		}
		
		if (minLev < a[i][j]) {
			basin[i][j] = dfs(i + dx[minPoint], j + dy[minPoint]);
		} else {
			basin[i][j] = current;
			++current;
		}
		
		return basin[i][j];
	}

	private boolean inField(int i, int j) {
		return (0 <= i) && (i < n) && (0 <= j) && (j < m);
	}
}
