import java.text.DecimalFormat;
import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	StringTokenizer tok;
	BufferedReader cin;
	PrintWriter cout;
	
	private String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}
	
	private double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}
	
	class Node {
		String name;
		double prob;
		Node yes, no;
		
		public Node(double prob) {
			this.prob = prob;
		}

		public Node(String name, double prob, Node a, Node b) {
			this.name = name;
			this.prob = prob;
			this.yes = a;
			this.no = b;
		}
	}

	int cases;
	String[] lines;
	int n, num;
	
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		//cin = new BufferedReader(new FileReader("A-small-attempt0.in"));
		cin = new BufferedReader(new FileReader("A-large.in"));
		cout = new PrintWriter("output.txt");
		
		cases = nextInt();

		for (int testcase = 0; testcase < cases; ++testcase) {
			n = nextInt();
			lines = new String[n];
			for (int i = 0; i < n; ++i) {
				lines[i] = cin.readLine();
			}
			
			num = 0;
			Node root = readNode();
			
			tok = null;
			
			cout.println("Case #" + (testcase + 1) + ":");
			
			int m = nextInt();
			for (int i = 0; i < m; ++i) {
				next();
				int l = nextInt();
				HashSet<String> properties = new HashSet<String>();
				for (int j = 0; j < l; ++j) {
					properties.add(next());
				}
				
				cout.println(new DecimalFormat("#0.00000000").format(go(1, root, properties)));
			}
		}
		
		cout.close();
	}

	private Object go(double prob, Node node, HashSet<String> properties) {
		if (node.name == null) {
			return prob * node.prob;
		}
		
		if (properties.contains(node.name)) {
			return go(prob * node.prob, node.yes, properties);
		} else {
			return go(prob * node.prob, node.no,  properties);
		}
	}

	private Node readNode() throws Exception {
		if (lines[num].indexOf(')') >= 0) {
			tok = new StringTokenizer(lines[num], " ()");
			++num;
			return new Node(nextDouble());
		}

		tok = new StringTokenizer(lines[num], " ()");
		double prob = nextDouble();
		String name = next();
		++num;
		
		Node yes = readNode();
		Node no = readNode();
		
		++num;
		
		return new Node(name, prob, yes, no);
	}
}
