import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {
	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException("Laja in solution");
		}
	}
	
	private String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	private long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	BufferedReader cin;
	StringTokenizer tok;
	PrintWriter cout;
	
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		//cin = new BufferedReader(new FileReader("B-small-attempt0.in "));
		cin = new BufferedReader(new FileReader("B-large.in"));
		cout = new PrintWriter(new FileWriter("output.txt"));
		
		int numberOfCases = nextInt();
		for (int testcase = 0; testcase < numberOfCases; ++testcase) {
			long boosters = nextLong();
			long t = nextLong();
			int n = nextInt();
			int c = nextInt();
			Flight[] a = new Flight[c];
			long cycleTime = 0;
			
			for (int i = 0; i < c; ++i) {
				a[i] = new Flight(nextLong());
				cycleTime += a[i].distance * 2;
			}

			PriorityQueue<Flight> queue = new PriorityQueue<Solution.Flight>();
			
			long localCycleTime = 0;
			long resultTime = 0;
			for (int i = 0; i < c; ++i) {
				long cycles = n / c;
				long lastFlight = cycles * c + i;
				while (lastFlight >= n) {
					--cycles;
					lastFlight = cycles * c + i;
				}
				
				if (lastFlight == n - 1) {
					resultTime = cycles * cycleTime + localCycleTime + a[i].distance * 2;
				}
				
				a[i].timeToThat = cycles * cycleTime + localCycleTime;
				
				queue.add(a[i]);
				
				localCycleTime += a[i].distance * 2;
			}
			
			while (!queue.isEmpty() && boosters > 0) {
				Flight flight = queue.poll();
				
				while (flight.timeToThat >= t && boosters > 0) {
					resultTime -= flight.distance;
					--boosters;
					flight.timeToThat -= cycleTime;
				}
				
				if (flight.timeToThat + flight.distance * 2 > t) {
					long slowDist = (t - flight.timeToThat) / 2 + (t - flight.timeToThat) % 2;
					Flight halfFlight = new Flight(flight.distance - slowDist);
					halfFlight.timeToThat = t;
					queue.add(halfFlight);
				}
			}
			
			cout.printf("Case #%d: %d\n", testcase + 1, resultTime);
		}
		
		cout.close();
	}

	private class Flight implements Comparable<Flight> {
		long distance;
		long timeToThat;
		
		public Flight(long distance) {
			this.distance = distance;
			timeToThat = 0;
		}

		@Override
		public int compareTo(Flight other) {
			return (int)(other.distance - distance);
		}
	}
}
