import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {
	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException("Laja in solution");
		}
	}
	
	private String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	BufferedReader cin;
	StringTokenizer tok;
	PrintWriter cout;
	
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		//cin = new BufferedReader(new FileReader("A-small-attempt0.in "));
		cin = new BufferedReader(new FileReader("A-large.in "));
		cout = new PrintWriter(new FileWriter("output.txt"));
		
		int numberOfCases = nextInt();
		for (int testcase = 0; testcase < numberOfCases; ++testcase) {
			int n = nextInt();
			char[][] a = new char[n][];
			
			for (int i = 0; i < n; ++i) {
				a[i] = cin.readLine().toCharArray();
			}
			
			double[] won = new double[n];
			double[] total = new double[n];
			double[] first = new double[n];
			double[] second = new double[n];
			double[] third = new double[n];
			
			for (int i = 0; i < n; ++i) {
				won[i] = 0;
				total[i] = 0;
				
				for (int j = 0; j < n; ++j) {
					if (a[i][j] == '1') {
						++won[i];
					}
					
					if (a[i][j] == '1' || a[i][j] == '0') {
						++total[i];
					}
				}
				
				first[i] = won[i] / total[i];
			}
			
			for (int i = 0; i < n; ++i) {
				double sum = 0;
				
				for (int j = 0; j < n; ++j) {
					if (a[i][j] != '.') {
						if (a[i][j] == '1') {
							sum += won[j] / (total[j] - 1);
						} else {
							sum += (won[j] - 1) / (total[j] - 1);
						}
					}
				}
				
				second[i] = sum / total[i];
			}
			
			for (int i = 0; i < n; ++i) {
				double sum = 0;
				
				for (int j = 0; j < n; ++j) {
					if (a[i][j] != '.') {
						sum += second[j];
					}
				}
				
				third[i] = sum / total[i];
			}
			
			cout.printf("Case #%d:\n", testcase + 1);
			for (int i = 0; i < n; ++i) {
				cout.println(first[i] / 4 + second[i] / 2 + third[i] / 4);
			}
		}
		
		cout.close();
	}

}
