import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {

	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	StringTokenizer tok;
	BufferedReader cin;
	PrintWriter cout;
	
	private String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	HashSet<String> existing;
	int cases;
	int n, m;
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		cin = new BufferedReader(new FileReader("A-large.in"));
		//cout = new PrintWriter(System.out);
		cout = new PrintWriter("output.txt");
		
		cases = nextInt();

		for (int testcase = 0; testcase < cases; ++testcase) {
			existing = new HashSet<String>();
			n = nextInt();
			m = nextInt();
			
			for (int i = 0; i < n; ++i) {
				String dir = next();
				
				while (!dir.isEmpty()) {
					existing.add(dir);
					dir = dir.substring(0, dir.lastIndexOf('/'));
				}
			}
			
			int ans = 0;
			for (int i = 0; i < m; ++i) {
				String dir = next();
				
				while ((!dir.isEmpty()) && (!existing.contains(dir))) {
					existing.add(dir);
					++ans;
					
					dir = dir.substring(0, dir.lastIndexOf('/'));
				}
			}
			
			cout.println("Case #" + (testcase + 1) + ": " + ans);
		}
		
		cout.close();
	}
}
