import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {

	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}
	
	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException("Laja in solution");
		}
	}

	private String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	BufferedReader cin;
	StringTokenizer tok;
	PrintWriter cout;
	
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		cin = new BufferedReader(new FileReader("A-small-attempt0.in"));
		cout = new PrintWriter(new File("output.txt"));
		
		int testcases = nextInt();
		
		for (int testcase = 0; testcase < testcases; ++testcase) {
			int n = nextInt();
			int[] lastMoved = {0, 0};
			int[] position = {1, 1};
			int curTime = 0;
			
			for (int i = 0; i < n; ++i) {
				int robot = -1;
				char robotChar = next().charAt(0);
				if (robotChar == 'O') {
					robot = 0;
				} else if (robotChar == 'B') {
					robot = 1;
				}
				
				int nextCell = nextInt();
				int dist = abs(position[robot] - nextCell);
				
				int turnTime = max(0, dist - (curTime - lastMoved[robot])) + 1;
				
				curTime += turnTime;
				position[robot] = nextCell;
				lastMoved[robot] = curTime;
			}
			
			cout.printf("Case #%d: %d\n", testcase + 1, curTime);
		}
		
		cout.close();
	}
	
}
