import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {

	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}
	
	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException("Laja in solution");
		}
	}

	private String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	BufferedReader cin;
	StringTokenizer tok;
	PrintWriter cout;
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		//cin = new BufferedReader(new FileReader("C-small-attempt0.in "));
		cin = new BufferedReader(new FileReader("C-large.in "));
		cout = new PrintWriter(new File("output.txt"));
		
		int testcases = nextInt();
		
		for (int testcase = 0; testcase < testcases; ++testcase) {
			int n = nextInt();
			long[] a = new long[n];
			long xor = 0;
			for (int i = 0; i < n; ++i) {
				a[i] = nextInt();
				xor = xor ^ a[i];
			}
			
			if (xor != 0) {
				cout.printf("Case #%d: NO\n", testcase + 1);
				continue;
			}
			
			Arrays.sort(a);
			long sum = 0;
			for (int i = 1; i < n; ++i) {
				sum += a[i];
			}
			
			cout.printf("Case #%d: %d\n", testcase + 1, sum);
		}
		
		cout.close();
	}
}
