import java.util.*;
import java.io.*;
import java.math.*;

import static java.lang.Math.*;

public class Solution implements Runnable {

	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	StringTokenizer tok;
	BufferedReader cin;
	PrintWriter cout;
	
	private String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	int cases;
	BigInteger[] a;
	int n;
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		cin = new BufferedReader(new FileReader("B-large.in"));
		//cout = new PrintWriter(System.out);
		cout = new PrintWriter("output.txt");
		
		cases = nextInt();

		for (int testcase = 0; testcase < cases; ++testcase) {
			n = nextInt();
			a = new BigInteger[n];
			for (int i = 0; i < n; ++i) {
				a[i] = new BigInteger(next());
			}
			
			Arrays.sort(a);
			
			BigInteger T = a[1].subtract(a[0]);
			for (int i = 2; i < n; ++i) {
				T = gcd(T, a[i].subtract(a[0]));
			}
			
			BigInteger x = a[0].mod(T);
			
			cout.print("Case #" + (testcase + 1) + ": ");
			if (x.equals(BigInteger.ZERO)) {
				cout.println(0);
			} else {
				cout.println(T.subtract(x));
			}
		}
		
		cout.close();
	}
	
	private BigInteger gcd(BigInteger a, BigInteger b) {
		if (a.compareTo(b) < 0) {
			BigInteger temp = a;
			a = b;
			b = temp;
		}

		if (b.equals(BigInteger.ZERO)) {
			return a;
		} else {
			return gcd(b, a.mod(b));
		}
	}
}
