import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {
	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException("Bug in solution");
		}
	}
	
	private String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}
	

	BufferedReader cin;
	StringTokenizer tok;
	PrintWriter cout;
	
	String[] names;
	Map<String, Integer> namesMap;
	boolean[] used;
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		cin = new BufferedReader(new FileReader("a-small.in"));
		cout = new PrintWriter(new File("output.txt"));
		//cout = new PrintWriter(System.out);
		
		int cases = nextInt();
		for (int testCase = 1; testCase <= cases; ++testCase) {
			int n = nextInt();
			
			names = new String[n];
			namesMap = new HashMap<String, Integer>();
			used = new boolean[n];
			
			for (int i = 0; i < n; ++i) {
				names[i] = cin.readLine();
				namesMap.put(names[i], i);
			}

			int k = nextInt();
			int rest = n;
			int ans = 0;
			
			for (int i = 0; i < k; ++i) {
				int v = namesMap.get(cin.readLine());
				
				if (used[v]) continue;
				
				if (rest == 1) {
					Arrays.fill(used, false);
					used[v] = true;
					rest = n - 1;
					++ans;
				} else {
					used[v] = true;
					--rest;
				}
			}
			
			cout.println("Case #" + testCase + ": " + ans);
		}
		
		cout.close();
	}
}