import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {
	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException("Laja in solution");
		}
	}
	
	private String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	BufferedReader cin;
	StringTokenizer tok;
	PrintWriter cout;
	
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		//cin = new BufferedReader(new FileReader("A-small-attempt0.in"));
		cin = new BufferedReader(new FileReader("a-large.in"));
		cout = new PrintWriter(new FileWriter("output.txt"));
		
		int numberOfCases = nextInt();
		for (int testcase = 0; testcase < numberOfCases; ++testcase) {
			int n = nextInt();
			int m = nextInt();
			char[][] a = new char[n][];
			
			for (int i = 0; i < n; ++i) {
				a[i] = cin.readLine().toCharArray();
			}
			
			boolean fail = false;
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					if (a[i][j] == '#') {
						if (i == n - 1 || j == m - 1 ||	a[i + 1][j] != '#' || 
								a[i][j + 1] != '#' || a[i + 1][j + 1] != '#') {
							fail = true;
							break;
						}
						
						a[i][j] = '/';
						a[i][j + 1] = '\\';
						a[i + 1][j] = '\\';
						a[i + 1][j + 1] = '/';
					}
				}
				
				if (fail) {
					break;
				}
			}
			
			cout.printf("Case #%d: \n", testcase + 1);
			if (fail) {
				cout.println("Impossible");
			} else {
				for (int i = 0; i < n; ++i) {
					cout.println(new String(a[i]));
				}
			}
		}
		
		cout.close();
	}

}
