import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {
	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException("Laja in solution");
		}
	}
	
	private String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	BufferedReader cin;
	StringTokenizer tok;
	PrintWriter cout;
	
	
	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		cin = new BufferedReader(new FileReader("C-small-attempt0.in"));
		cout = new PrintWriter(new FileWriter("output.txt"));
		
		int numberOfCases = nextInt();
		for (int testcase = 0; testcase < numberOfCases; ++testcase) {
			int n = nextInt();
			int l = nextInt();
			int h = nextInt();
			
			int[] a = new int[n];
			for (int i = 0; i < n; ++i) {
				a[i] = nextInt();
			}
			
			int result = -1;
			for(int freq = l; freq <= h; ++freq) {
				boolean good = true;
				
				for (int i = 0; i < n; ++i) {
					if ((a[i] % freq) != 0 && (freq % a[i]) != 0) {
						good = false;
						break;
					}
				}
				
				if (good) {
					result = freq;
					break;
				}
			}
			
			cout.printf("Case #%d: ", testcase + 1);
			
			if (result == -1) {
				cout.println("NO");
			} else {
				cout.println(result);
			}
		}
		
		cout.close();
	}
}
