import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {

	private static final int MOD = 100003;

	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	StringTokenizer tok;
	BufferedReader cin;
	PrintWriter cout;
	
	private String next() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}
		
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}
	
	long c(int n, int k) {
		if (c[n][k] != 0) {
			return c[n][k];
		}
		
		if (n <= 1 || k <= 1 || k == n) {
			c[n][k] = 1;
		} else {
			c[n][k] = (c(n - 1, k) + c(n - 1, k - 1)) % MOD;
		}
		
		return c[n][k];
	}

	int cases;
	long[][] d;
	long[][] c;
	int n;
	
	private void solve() throws Exception {
		cin = new BufferedReader(new FileReader("input.txt"));
		//cin = new BufferedReader(new FileReader("C-small-attempt4.in"));
		cin = new BufferedReader(new FileReader("C-large.in"));
		//cout = new PrintWriter(System.out);
		cout = new PrintWriter("output.txt");
		
		n = 500;
		c = new long[n + 1][n + 1];
		d = new long[n + 1][n + 1];
		
		d[0][1] = 1;
		
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				for (int k = max(j + 1, j + j - i); k <= n; ++k) {
					d[j][k] = (d[j][k] + d[i][j] * c(k - j, j - i)) % MOD;
				}
			}
		}
		
		cases = nextInt();
		
		for (int testcase = 0; testcase < cases; ++testcase) {
			n = nextInt();
			
			long ans = 0;
			
			for (int i = 0; i <= n; ++i) {
				ans = (ans + d[i][n]) % MOD;
			}
			
			cout.println("Case #" + (testcase + 1) + ": " + ans);
		}
		
		cout.close();
	}
}
