import java.util.*;
import java.io.*;
import java.math.*;
import static java.lang.Math.*;

public class Solution implements Runnable {

	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}

	@Override
	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException("Laja in solution");
		}
	}

	private String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(cin.readLine());
		}

		return tok.nextToken();
	}

	private int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	BufferedReader cin;
	StringTokenizer tok;
	PrintWriter cout;

	private void solve() throws Exception {
		//cin = new BufferedReader(new FileReader("input.txt"));
		cin = new BufferedReader(new FileReader("B-small-attempt0.in"));
		cout = new PrintWriter(new File("output.txt"));

		int testcases = nextInt();

		for (int testcase = 0; testcase < testcases; ++testcase) {
			HashMap<String, Character> mapping = new HashMap<String, Character>();
			HashSet<String> negatives = new HashSet<String>();

			int t = nextInt();
			for (int i = 0; i < t; ++i) {
				String str = next();
				mapping.put(str.charAt(0) + "" + str.charAt(1), str.charAt(2));
				mapping.put(str.charAt(1) + "" + str.charAt(0), str.charAt(2));
			}

			t = nextInt();
			for (int i = 0; i < t; ++i) {
				String str = next();
				negatives.add(str.charAt(0) + "" + str.charAt(1));
				negatives.add(str.charAt(1) + "" + str.charAt(0));
			}

			int n = nextInt();
			String str = next();
			List<Character> result = new ArrayList<Character>();

			for (int i = 0; i < n; ++i) {
				result.add(str.charAt(i));

				while (result.size() > 1) {
					char a = result.get(result.size() - 1);
					char b = result.get(result.size() - 2);

					if (mapping.containsKey(a + "" + b)) {
						result = result.subList(0, result.size() - 2);
						result.add(mapping.get(a + "" + b));
					} else {
						for (int j = 0; j < result.size() - 1; ++j) {
							if (negatives.contains(a + "" + result.get(j))) {
								result.clear();
							}
						}
						
						break;
					}
				}
			}
			
			cout.printf("Case #%d: %s\n", testcase + 1, result.toString());
		}

		cout.close();
	}

}
