import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * by dt on 4/10/15, 8:00 PM
 */
public class B {
    private static final String FILENAME = "B-small-attempt0.in";
//    private static final String FILENAME = "B-large.in";
//        private static final String FILENAME = "test.in";
    private static final String OUT_FILENAME = "B-small-attempt0.out";
//    private static final String OUT_FILENAME = "B-large.out";
//    private static final String OUT_FILENAME = "test.out";

    private static int[] minSplits;

    public static void main(String... args) throws FileNotFoundException {
        Scanner sc = new Scanner(new File(FILENAME));
        PrintWriter pw = new PrintWriter(OUT_FILENAME);
        int t = sc.nextInt();
        TestCase[] tests = new TestCase[t];
        int maxPancakes = 0;
        for (int i = 0; i < t; i++) {
            TestCase tc = new TestCase();
            tests[i] = tc;
            tc.nEaters = sc.nextInt();
            tc.pancakes = new int[tc.nEaters];
            for (int j = 0; j < tc.nEaters; j ++) {
                tc.pancakes[j] = sc.nextInt();
                maxPancakes = Math.max(maxPancakes, tc.pancakes[j]);
            }
        }

        buildSplits(maxPancakes);

        for (int i = 0; i < t; i ++) {
            pw.println("Case #" + (i + 1) + ": " + new B().solve(tests[i]));
        }
        pw.flush();
        pw.close();
    }

    private static void buildSplits(int maxPancakes) {
        minSplits = new int[maxPancakes + 1];
        // no splits -- just eat whole stack
        for (int i = 0; i <= maxPancakes; i ++) {
            minSplits[i] = i;
        }
        for (int i = 2; i <= maxPancakes; i ++) {
            for (int j = 0; j <= i / 2; j ++) {
                minSplits[i] = Math.min(minSplits[i], Math.max(minSplits[j], minSplits[i - j]) + 1);
            }
        }
    }

    int solve(TestCase t) {
        int maxTime = 0;
        for (int stack : t.pancakes) {
            maxTime = Math.max(maxTime, minSplits[stack]);
        }
        return maxTime;
    }

    static class TestCase {
        int nEaters;
        int[] pancakes;
    }
}
