/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codejam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.SortedSet;
import java.util.TreeSet;

/**
 *
 * @author dms
 */
public class Watersheds {

  private static String INPUT = "/tmp/input";

  public static void rebase(byte[][] map, int j, int k, byte value) {
    if (map[j][k] == value) {
      return;
    }
    byte prevValue = map[j][k];
    map[j][k] = value;
    if (j > 0) {
      if (map[j - 1][k] == prevValue) {
        rebase(map, j - 1, k, value);
      }
    }
    if (k > 0) {
      if (map[j][k - 1] == prevValue) {
        rebase(map, j, k - 1, value);
      }
    }
    if (k < map[j].length - 1) {
      if (map[j][k + 1] == prevValue) {
        rebase(map, j, k + 1, value);
      }
    }
    if (j < map.length - 1) {
      if (map[j + 1][k] == prevValue) {
        rebase(map, j + 1, k, value);
      }
    }
  }

  /**
   * @param args the command line arguments
   */
  public static void main(String[] args) throws IOException {
    BufferedReader reader = new BufferedReader(new FileReader(INPUT));
    int maps = Integer.valueOf(reader.readLine());

    for (int i = 0; i < maps; i++) {
      System.out.println("Case #" + (i + 1) + ": ");
      String[] dim = reader.readLine().split(" ");
      int height = Integer.valueOf(dim[0]);
      int width = Integer.valueOf(dim[1]);

      int[][] map = new int[height][width];
      byte[][] drains = new byte[height][width];

      for (int j = 0; j < height; j++) {
        String row = reader.readLine();
        String[] cells = row.split(" ");
        for (int k = 0; k < width; k++) {
          map[j][k] = Byte.valueOf(cells[k]);
          drains[j][k] = -1;
        }
      }

      byte currentDrain = 0;
      for (int j = 0; j < height; j++) {
        for (int k = 0; k < width; k++) {
          int north = 10001;
          int west = 10001;
          int east = 10001;
          int south = 10001;
          if (j > 0) {
            north = map[j - 1][k];
          }
          if (k > 0) {
            west = map[j][k - 1];
          }
          if (k < width - 1) {
            east = map[j][k + 1];
          }
          if (j < height - 1) {
            south = map[j + 1][k];
          }
          int min = Math.min(north, west);
          min = Math.min(min, east);
          min = Math.min(min, south);
          if (min >= map[j][k]) {
            if (drains[j][k] == -1) {
              drains[j][k] = currentDrain++;
            }
            continue;
          }
          if (north == min) {
            if (drains[j][k] != -1 && drains[j][k] != drains[j - 1][k]) {
              rebase(drains, j, k, drains[j - 1][k]);
            } else {
              drains[j][k] = drains[j - 1][k];
            }
            continue;
          } else if (west == min) {
            if (drains[j][k] != -1 &&
                    drains[j][k] != drains[j][k - 1]) {
              rebase(drains, j, k, drains[j][k - 1]);
            } else {
              drains[j][k] = drains[j][k - 1];
            }
          } else if (east == min) {
            if (drains[j][k + 1] == -1) {
              if (drains[j][k] == -1) {
                drains[j][k] = drains[j][k + 1] = currentDrain++;
              } else {
                drains[j][k + 1] = drains[j][k];
              }
            } else if (drains[j][k] == -1) {
              drains[j][k] = drains[j][k + 1];
            } else {
              rebase(drains, j, k, drains[j][k + 1]);
            }
          } else if (south == min) {
            if (drains[j][k] == -1) {
              drains[j + 1][k] = drains[j][k] = currentDrain++;
            } else {
              drains[j + 1][k] = drains[j][k];
            }
          }
        }
      }
      SortedSet<Byte> values = new TreeSet<Byte>();
      for (int j = 0; j < height; j++) {
        for (int k = 0; k < width; k++) {
          values.add(drains[j][k]);
        }
      }

      Map<Byte, Character> mapping = new HashMap<Byte, Character>();
      char curr = 'a';
      for (Byte value : values) {
        mapping.put(value, curr);
        curr++;
      }

      char[][] result = new char[height][width];
      for (int j = 0; j < height; j++) {
        for (int k = 0; k < width; k++) {
          System.out.print(mapping.get(drains[j][k]));
          if (k < width - 1) {
            System.out.print(" ");
          }
        }
        System.out.println();
      }
    }
  }
}
