/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codejam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.HashSet;
import java.util.Set;

/**
 *
 * @author dms
 */
public class Happy {

  public static String input = "/tmp/input";
  public static String output = "/tmp/output";

  public void run() throws IOException {
    BufferedReader reader = new BufferedReader(new FileReader(input));
    FileWriter writer = new FileWriter(output);

    int tests = Integer.valueOf(reader.readLine());
    for (int test = 0; test < tests; test++) {
      System.out.println("Case #" + (test + 1) + ": ");
      writer.write("Case #" + (test + 1) + ": ");
      solve(reader, writer);
      writer.write("\n");
    }

    reader.close();
    writer.close();
  }

  public void solve(BufferedReader reader, Writer writer)
          throws IOException {
    String[] bases = reader.readLine().split(" ");
    int[] basesInt = new int[bases.length];
    for (int i = 0; i < bases.length; i++) {
      basesInt[i] = Integer.valueOf(bases[i]);
    }
    boolean happy = false;
    int number = 1;
    while (!happy) {
      number++;
      happy = true;
      for (int i = 0; i < basesInt.length; i++) {
        happy = happy && isHappyForBase(number, basesInt[i]);
        if (!happy) {
          break;
        }
      }
    }
    writer.write(String.valueOf(number));
  }

  public boolean isHappyForBase(int number, int base) {
    Set<Integer> memory = new HashSet<Integer>();
    while (number != 1) {
      memory.add(number);
      int newNumber = 0;
      while (number > 0) {
        int digit = number % base;
        newNumber += digit*digit;
        number = number / base;
      }
      number = newNumber;
      if (memory.contains(number))
        return false;
      
    }
    return true;
  }

  /**
   * @param args the command line arguments
   */
  public static void main(String[] args) throws IOException {
    Happy happy = new Happy();
    happy.run();
    
  }
}
