import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.StringTokenizer;


public class FairAndSquare3 {
	public static void main(String[] args) throws IOException {
		
		ArrayList<BigInteger> list = new ArrayList<BigInteger>();
		
		File file = new File("C:\\Users\\dbu\\Downloads\\dataSF.txt");
		
		if (file.exists()) {
				
			BufferedReader br = new BufferedReader(new FileReader(file));
			
			try {
				String line = br.readLine();
		        while (line != null) {
		        	BigInteger big = new BigInteger(line.trim());
		        	list.add(big);
		        	line = br.readLine();
		        }
			} finally {
				br.close();	
			}
			
		} else {
		
			int n = power2(25);
			int dn = n / 100;
	
			list.add(BigInteger.valueOf(1));
			list.add(BigInteger.valueOf(4));
			list.add(BigInteger.valueOf(9));
			
			for (int x = 1; x < n; x+=1) {
				
				if (x % dn == 0) System.out.println(new Date().toString() + (x/dn) + "%");
				
				String binaryL = Integer.toBinaryString(x); 
				String binaryR = new StringBuffer(binaryL).reverse().toString(); 
				
				String binaryL2 = "2" + binaryL.substring(1); 
				String binaryR2 = new StringBuffer(binaryL2).reverse().toString(); 
				
				addIfSquareAndFair(binaryL + binaryR, list);
				addIfSquareAndFair(binaryL2 + binaryR2, list);
				addIfSquareAndFair(binaryL + "0" + binaryR, list);
				addIfSquareAndFair(binaryL + "1" + binaryR, list);
				addIfSquareAndFair(binaryL + "2" + binaryR, list);
				addIfSquareAndFair(binaryL2 + "0" + binaryR2, list);
				addIfSquareAndFair(binaryL2 + "1" + binaryR2, list);
			}
			
			Collections.sort(list);
			
			{
				PrintStream data = new PrintStream(new File("C:\\Users\\dbu\\Downloads\\dataSF.txt"));
				for (BigInteger big : list) {
					data.println(big);
				}
				data.close();
			}
		
		}
		
		String name = "C-large-2";
		String path = "C:\\Users\\dbu\\Downloads\\";
		
		String text = TextReader.read(path + name + ".in");
		
		PrintStream out = new PrintStream(new File(path + name + ".out"));
		
		StringTokenizer tokenizer = new StringTokenizer(text);
		
		int T = Integer.parseInt(tokenizer.nextToken());
		System.out.println(T);
		System.out.println("======");
		for (int t = 0; t < T; t += 1) {
		
			String A = tokenizer.nextToken();
			String B = tokenizer.nextToken();
			System.out.println(A + " " + B);
			
			BigInteger bigA = new BigInteger(A);
			BigInteger bigB = new BigInteger(B);
			
			int cnt = 0;
			for (BigInteger big : list) {
				int compA = big.compareTo(bigA);
				int compB = big.compareTo(bigB);
				if (compA == 0 || compB == 0 || compA == 1 && compB == -1) {
					cnt += 1;
				}
			}
			
			String result = "Case #"+(t+1)+": "+cnt;
			System.out.println(result);
			out.println(result);	
		}
		
		out.close();
	}
	
	private static int power2(int n) {
		int x = 1;
		for (int i = 1; i < n; i+=1) {
			x *= 2;
		}
		return x;
	}
	
	private static void addIfSquareAndFair(String x, ArrayList<BigInteger> list) {
		BigInteger big = new BigInteger(x);
		BigInteger sqr = big.multiply(big);
		if (palindrome(sqr)) {
			list.add(sqr);
		}
	}

	static boolean palindrome(BigInteger big) {
		String str = big.toString();		
		int length = str.length();
		boolean ok = true;
		for (int i = 0; i < length/2; i++)
			ok = ok && (str.charAt(i) == str.charAt(length - i -1));
		return ok;
	}
	
	
}
