package edu.syr.codejam.dhrumin.questions;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

import edu.syr.codejam.dhrumin.util.ReadWrite;

public class QuestionA {

	
	
	public List<String> readInput(String inputFile)
	{
		try {
			Scanner scan = new Scanner(new File(inputFile));
			List<String> result = new ArrayList<String>();
			while(scan.hasNext())
			{
				Integer testcases = scan.nextInt();
				
				for(int i = 0; i < testcases; i++)
				{
					char[][] rows = new char[4][4];
					boolean hasDots = false;
					for(int j = 0; j < 4; j++)
					{
						String str = scan.next();					
						
						for(int k = 0; k < str.length(); k++)
						{
							rows[j][k] = str.charAt(k);
							if(str.charAt(k) == '.')
								hasDots = true;
							
						}
					}
					result.add(getResult(rows, hasDots));
				}
				return result;
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	
	public String getResult(char[][] rows, boolean hasDots)
	{			
		char c = checkValues(rows);
		StringBuilder build = new StringBuilder();
		if(c != 'N')
		{
			build.append(c);
			build.append(" won");
			return build.toString();
		}
		else if(hasDots)
			return "Game has not completed";
		
		else
			return "Draw";
	}
	
	public char checkValues(char[][] rows)
	{		
		boolean check = true;
		for(int i = 0; i < 4; i++)
		{
			check = true;
			int count = 0;
			char prev = 'N';
			
			for(int j = 0; j < 4; j++)
			{
				if(rows[i][j] == 'T')
				{
					++count;
					if(count > 1)
					{
						check = false;
						break;
					}
				}
				
				if(rows[i][j] == '.')
				{
					check = false;
					break;
				}
				
				else if(j > 0 && rows[i][j - 1] != rows[i][j] && prev != 'N')
				{
					//prev = rows[i][j];
					check = false;
					break;
				}
				else
					prev = rows[i][j];
			}
			
			if(check)
				return prev;			
		}
		
		for(int j = 0; j < 4; j++)
		{
			check = true;
			int count = 0;
			char prev = 'N';
			for(int i = 0; i < 4; i++)
			{		
				if(rows[i][j] == 'T')
				{
					++count;
					if(count > 1)
					{
						check = false;
						break;
					}
				}
				
				if(rows[i][j] == '.')
				{
					check = false;
					break;
				}
				
				else if(i > 0 && rows[i][j] != prev && prev != 'N')
				{
					check = false;
					break;
				}
				else
					prev = rows[i][j];
			}
			
			if(check)
				return prev;			
		}
		
		//Diag 1
		char prev = 'N';
		check = true;
		int count1 = 0;
		for(int i =0; i < 4; i++)
		{
			if(rows[i][i] == '.')
			{
				check = false;
				break;
			}
			
			if(rows[i][i] == 'T')
			{
				++count1;
				if(count1 > 1)
				{
					check = false;
					break;
				}
				continue;
			}
			
			if(prev == 'N')
				prev = rows[i][i];
			 
			if(rows[i][i] != prev)
			{
				check = false;
				break;
			}
		}
		
		if(check)
			return prev;
		
		//Diag 2
		int count = 0;
		count1 = 0;
		prev = 'N';
		check  = true;
		for(int i = 3; i >= 0; i--)
		{
			if(rows[count][i] == '.')
			{
				check = false;
				break;
			}
			
			if(rows[count][i] == 'T')
			{
				++count1;
				if(count1 > 1)
				{
					check = false;
					break;
				}
				continue;
			}
			if(prev == 'N')
				prev = rows[count][i];
			
			if(rows[count++][i] != prev)
			{
				check = false;
				break;
			}
		}
		
		if(check)
			return prev;
		
		return 'N';		
	}
	
	public static void main(String args[])
	{
		QuestionA a = new QuestionA();
		List<String> result = a.readInput("src/inputs/A-large.in");
		ReadWrite rw = new ReadWrite();
		rw.writeOutput("src/outputs/outputB.txt", result);
	}
	
}
