import java.io.*;
import java.util.*;

final public class B {
	final static String INPUT = "B-large.in";
	
	public static void main(String[] args) throws Throwable {
		long start = System.currentTimeMillis();
		
		FileReader fr;
		BufferedReader br = new BufferedReader(fr = new FileReader(INPUT));
		int testCases = Integer.parseInt(br.readLine());
		
		FileWriter fw;
		BufferedWriter bw = new BufferedWriter(fw = new FileWriter(INPUT.replaceFirst("\\.in$", ".out")));
		
		for(int i=0; i<testCases; i++) {
			int T = Integer.parseInt(br.readLine());
			
			String[] tmp = br.readLine().split(" "), tmp2;
			int nA = Integer.parseInt(tmp[0]);
			int nB = Integer.parseInt(tmp[1]);
			
			ArrayList<BEvent> events = new ArrayList<BEvent>();
			for(int j=0; j<nA; j++) {
				tmp = br.readLine().split(" ");
				
				tmp2 = tmp[0].split(":");
				new BEvent(1, 2);
				events.add(new BEvent(Integer.parseInt(tmp2[0])*60 + Integer.parseInt(tmp2[1]), 1));
				
				
				tmp2 = tmp[1].split(":");
				events.add(new BEvent(Integer.parseInt(tmp2[0])*60 + Integer.parseInt(tmp2[1]) + T, 4));
			}
			
			for(int j=0; j<nB; j++) {
				tmp = br.readLine().split(" ");
				
				tmp2 = tmp[0].split(":");
				events.add(new BEvent(Integer.parseInt(tmp2[0])*60 + Integer.parseInt(tmp2[1]), 2));
				
				tmp2 = tmp[1].split(":");
				events.add(new BEvent(Integer.parseInt(tmp2[0])*60 + Integer.parseInt(tmp2[1]) + T, 3));
			}
			
			Collections.sort(events);
			
			int needA = 0;
			int needB = 0;
			
			int actA = 0;
			int actB = 0;
			
			for(BEvent e : events) {
				switch(e.type) {
					case 1:
						if(actA == 0) {
							needA++;
						}
						else {
							actA--;
						}
						break;
					case 2:
						if(actB == 0) {
							needB++;
						}
						else {
							actB--;
						}
						break;
					case 3:
						actA++;
						break;
					case 4:
						actB++;
						break;
				}
			}
			
			bw.write("Case #"+(i+1)+": "+needA+" "+needB);
			bw.newLine();
		}
		
		br.close();
		fr.close();
		bw.close();
		fw.close();
		
		System.out.println((double)(System.currentTimeMillis() - start)/1000+" s");
	}
}

final class BEvent implements Comparable {
	short time; // in minutes
	
	byte type;
	/* 1 - departs from A
	 * 2 - departs from B
	 * 3 - arrives to A (and ready)
	 * 4 - arrives to B (and ready)
	 */
		
	public BEvent(int time, int type) {
		this.time = (short)time;
		this.type = (byte)type;
	}
	
	public int compareTo(Object o) {
		BEvent o2 = (BEvent)o;
		if(time == o2.time) {
			return o2.type - type;
		}
		else {
			return time - o2.time;
		}
	}
}