import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;

class a {

	private static final double LOG2 = Math.log(2.0);

	/**
	 * Computes the natural logarithm of a BigInteger. Works for really big
	 * integers (practically unlimited)
	 * 
	 * @param val
	 *            Argument, positive integer
	 * @return Natural logarithm, like as Math.log()
	 */
	public static double logBigInteger(BigInteger val) {
	    int blex = val.bitLength() - 1022; // any value in 60..1023 works
	    if (blex > 0)
	        val = val.shiftRight(blex);
	    double res = Math.log(val.doubleValue());
	    return (blex > 0 ? res + blex * LOG2 : res) / LOG2;
	}
	
    public static void main(String args[]) {
	BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
	int T;
	String line;
	try {
		line = br.readLine();
		T = Integer.parseInt(line);
	
		for(int t=1; t<=T; t++) {
			BigInteger p, q;

			line = br.readLine();
			String pq[] = line.split("\\/");
	    
			p = new BigInteger(pq[0]);
			q = new BigInteger(pq[1]);
			
			BigInteger pgcd = p.gcd(q);
			p = p.divide(pgcd);
			q = q.divide(pgcd);
			if(logBigInteger(q) != q.getLowestSetBit())
				System.out.println("Case #" + Integer.toString(t) + ": impossible");
			else {
				System.out.println("Case #" + Integer.toString(t) + ": " + 
						   Integer.toString((int)(Math.floor(logBigInteger(q))-Math.floor(logBigInteger(p)))));
			}
				
		}
		
	} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();

	    
	}

 }

};
