import java.io.*;


public class A {
    static class DiagonalCounter {
        boolean leftDiagonal = false;
        int n,k;
        int [] prevRow;
        int [] currRow;
        
        public DiagonalCounter(int n, int k, boolean whichWay) {
            prevRow = new int [n];
            currRow = new int [n];
            leftDiagonal = whichWay;
            this.n =n;
            this.k = k;
        }
        
        void nextRow() {
            int [] t = prevRow;
            prevRow = currRow;
            currRow = t;
        }
        
        boolean increment (int col) {
            int diagonalIndex = leftDiagonal ? col +1 : col -1;
            if (diagonalIndex >= 0 && diagonalIndex < n) {
                currRow[col] = prevRow[diagonalIndex] + 1;                
                return currRow[col] >= k;
            } else {
                currRow[col] = 1;
            }
            return false;
            
        }
        void reset (int col) {
            currRow[col] = 0;
        }
    }
    
    static int [] vert;
    
    static DiagonalCounter redLeft;
    static DiagonalCounter redRight;
    static DiagonalCounter blueLeft;
    static DiagonalCounter blueRight;
    
    static char [] vertColor;
    
    public static void print (char [][] a) {
        System.out.println();
        for (int row = 0; row< a.length; row++) {
            for (int col = 0; col < a[row].length; col++) {
                System.out.print(a[row][col]);
            }
            System.out.println();
        }
        System.out.println();
    }

    public static void main (String [] args) throws NumberFormatException, IOException {
        
        
        BufferedReader reader;
        
        if (args.length > 0) {
            reader = new BufferedReader( new InputStreamReader(new FileInputStream(args[0])));            
        } else {
            reader = new BufferedReader( new InputStreamReader(System.in));
        }
        
        int testCases = Integer.valueOf(reader.readLine());
        try {
            int testCase;
            for ( testCase = 0; testCase < testCases; testCase++) {
                String [] parts = reader.readLine().split("\\s+");                
                int n = Integer.valueOf(parts[0]);
                int k = Integer.valueOf(parts[1]);
                
                redLeft = new DiagonalCounter(n,k, true);
                redRight = new DiagonalCounter(n,k, false);
                blueLeft = new DiagonalCounter(n,k, true);                
                blueRight = new DiagonalCounter(n,k, false);                
           
                vert = new int[n];
                vertColor = new char[n];
                
                for (int i=0; i < n; i++) {              
                    vert[i] = 0;
                }
                int redLinked = 0;
                int blueLinked = 0;
                
                char [][] grid = new char [n][];
                
                for (int row = 0; row < n; row++) {
                    grid[row] = reader.readLine().toCharArray();   
                }
                //print(grid);
                grid = rotate(grid);
                //print(grid);
                for (int row = 0; row < n; row++) {
                    char [] b = grid[row];
                    int hcount = 0;
                    char hlast = '.';
                    for (int col = 0; col < n ; col++) {   
                        if (b[col] =='R') {
                            if (redLeft.increment(col)) redLinked++;
                            if (redRight.increment(col)) redLinked++;
                        } else {
                            redLeft.reset(col);
                            redRight.reset(col);
                        }
                        if (b[col] =='B') {
                            if (blueLeft.increment(col)) blueLinked++;
                            if (blueRight.increment(col)) blueLinked++;
                        } else {
                            blueLeft.reset(col);
                            blueRight.reset(col);
                        }
                        
                        // Vertical
                        if (vertColor[col] == b[col]) {
                            vert[col]++;
                            if (vert[col] >=k) {
                                if (vertColor[col] =='R') redLinked++; 
                                else if (vertColor[col] == 'B') blueLinked++;
                            }
                        } else {
                            vertColor[col] = b[col];
                            vert[col] = 1;                            
                        }  

                        // Horizontal
                        if (b[col] == hlast) {
                            hcount++;
                            if (hcount >=k) {
                                if (hlast =='R') redLinked++; 
                                else if (hlast == 'B') blueLinked++;
                            }
                        } else {
                            hlast = b[col];
                            hcount = 1;
                        }
                    } 
                    redLeft.nextRow();
                    redRight.nextRow();
                    blueLeft.nextRow();
                    blueRight.nextRow();
                }
                String result = blueLinked>0 ? redLinked>0 ?  "Both" : "Blue" : redLinked>0 ? "Red" : "Neither";
                String csq = "Case #"+(testCase+1)+": " + result;
                System.out.println(csq);
            } 
        } finally {

            reader.close();
        }
    }

    private static char[][] rotate(char[][] grid) {
        int rows = grid.length;
        int cols = grid[0].length;
        
        char [][] result = new char [rows][];
        for (int row = 0; row < rows; row++) {
            result[row] = new char [cols];
        }
        
        for (int row = 0; row < rows; row++) {
            int index = 0;
            int tcol = rows - 1 - row;
            for (int col = cols-1; col >=0; col--) {                
                int trow = rows-1-index;  
                char c = grid[row][col];
                if (c =='R' || c =='B') {
                    result[trow][tcol] = c;
                    index++;
                }
            }
            while (index < rows) {                
                int trow = rows-1-index;  
                result[trow][tcol] = '.';
                index++;
            }            
        }
        return result;
    }
}
