package codeJam;

import java.io.IOException;

public class Lawnmower
{
    public static void main(String[] args) throws IOException
    {
        String in = "/home/sam/google/2013/qual/2/sample";
        String out = "/home/sam/google/2013/qual/2/sampleOut";
        FileUtils fUtils = new FileUtils(in, out);
        int caseNums = fUtils.readNumOfCases();
        for (int i = 0; i < caseNums; i++)
        {
            int[] dim = fUtils.explodeNextLineAsInt();
            int rows = dim[0];
            int cols = dim[1];
            int[][] lawn = new int[rows][cols];
            for (int b = 0; b < rows; b++)
            {
                int[] iRow = fUtils.explodeNextLineAsInt();
                lawn[b] = iRow;
            }
            boolean validPattern = true;
            int maxRows[] = new int[rows];
            int maxCols[] = new int[cols];
            for (int x = 0; x < rows; x++)
            {
                maxRows[x] = Integer.MIN_VALUE;
                for (int y = 0; y < cols; y++)
                {
                    maxRows[x] = Math.max(maxRows[x], lawn[x][y]);
                }
            }
            for (int y = 0; y < cols; y++)
            {
                maxCols[y] = Integer.MIN_VALUE;
                for (int x = 0; x < rows; x++)
                {
                    maxCols[y] = Math.max(maxCols[y], lawn[x][y]);
                }
            }
            for (int x = 0; validPattern && x < rows; x++)
            {
                for (int y = 0; validPattern && y < cols; y++)
                {
                    if (lawn[x][y] < maxRows[x] && lawn[x][y] < maxCols[y])
                        validPattern = false;
                }
            }
            if (validPattern)
                fUtils.writeCase("YES");
            else
                fUtils.writeCase("NO");
        }
        fUtils.closeFile();
        fUtils.closeWriteFile();
    }
}
