package codeJam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class FileUtils
{
    private int caseNum = 1;
    private BufferedReader fileBr;
    private FileReader fileR;
    private final String inFile;
    private final String outFile;
    private FileWriter writer;

    public FileUtils(String inFile, String outFile)
    {
        this.inFile = inFile;
        this.outFile = outFile;
    }
    public void closeFile() throws IOException
    {
        fileBr.close();
        fileR.close();
    }
    public void closeWriteFile() throws IOException
    {
        writer.close();
    }
    public String[] explodeNextLine() throws IOException
    {
        String s[] = readNextLine().split(" ");
        return s;
    }
    public int[] explodeNextLineAsInt() throws IOException
    {
        String s[] = explodeNextLine();
        int ret[] = new int[s.length];
        for (int i = 0; i < s.length; i++)
        {
            ret[i] = Integer.parseInt(s[i]);
        }
        return ret;
    }
    public String readNextLine() throws IOException
    {
        String nextLine;
        nextLine = fileBr.readLine();
        if (nextLine == null)
            closeFile();
        return nextLine;
    }
    public int readNumOfCases() throws IOException
    {
        int numOfCases;
        fileR = new FileReader(inFile);
        fileBr = new BufferedReader(fileR);
        String s;
        s = fileBr.readLine();
        numOfCases = Integer.parseInt(s);
        return numOfCases;
    }
    public void writeCase(String text) throws IOException
    {
        if (writer == null)
            writer = new FileWriter(outFile);
        String out = "";
        out += "Case #" + caseNum;
        out += ": " + text + "\n";
        writer.write(out);
        caseNum++;
    }
}