package com.meme2;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

/**
 * @author Prabakar Kalivaradan (Prabakar_Kalivaradan@Trimble.com)
 */
public class C {
  public static void main(String[] args) throws FileNotFoundException {
    if (args.length != 1) {
      System.out.println("Please input file name");
      return;
    }
    String filePath = args[0];
    Scanner scan = new Scanner(new File(filePath));

    int testCaseCount = Integer.valueOf(scan.nextLine());
    int i = 1;
    while (scan.hasNextLine()) {
      System.out.printf("");
      int entriesCount = Integer.valueOf(scan.nextLine());
      List<String> list = new ArrayList<String>();
      for (int k = 0; k < entriesCount; k++) {
        list.add(scan.nextLine());
      }
//      System.out.println(list);
      runLogic(i, list);
      i++;
    }
    System.out.println();
  }

  public static void runLogic(int testCase, List<String> list) {
    System.out.println();
    String outputFormat = "Case #%d: %s";
    int fake = 0;
    List<String> unique = new ArrayList<String>();
    Set<String> words = new HashSet<String>();
    for (String itemx : list) {
      String[] d = itemx.split(" ");
      if (!words.contains(d[0]) || !words.contains(d[1])) {
        unique.add(itemx);
        words.add(d[0]);
        words.add(d[1]);
      }
    }
//    System.out.println("Uniqes:" + unique);
    Iterator<String> iter = list.iterator();
    while (iter.hasNext()) {
      String entry = iter.next();
      List<String> rest = new ArrayList<String>();
      rest.addAll(list);
      rest.remove(entry);
      if (isFake(entry, rest)) {
//        iter.remove();
//        System.out.println("found fake: " + entry);
        if (!allUniqueWords(rest).contains(entry))
          fake++;
      }
    }

    System.out.printf(outputFormat, testCase, fake);

  }

  private static Set<String> allUniqueWords(List<String> list) {
    Set<String> words = new HashSet<String>();
    for (String itemx : list) {
      String[] d = itemx.split(" ");
      words.add(d[0]);
      words.add(d[1]);
    }
    return words;
  }

  private static boolean isFake(String target, List<String> rest) {
//    System.out.println("search list:" + rest);
    String[] terms = target.split(" ");
    boolean first = false;
    boolean second = false;
    for (String e : rest) {
//      System.out.println("term1 occur index: " + e.indexOf(terms[0]));
//      System.out.println("term2 occur index: " + e.indexOf(terms[1]));
      if (e.indexOf(terms[0] + " ") == 0) {
//        System.out.println(terms[0] + " 1 matching " + e);
        first = true;
      }
      if (e.indexOf(" " + terms[1]) > 0) {
//        System.out.println(terms[1] + " 2 matching " + e);
        second = true;
      }
    }
    return first && second;
  }
}

