import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

/**
 * 
 */

/**
 * @author pkalivaradan
 *
 */
public class DobbyPancake {

    private static int[][] extraMoves = new int[][] {{0,0,0, 0,0,0, 0,0,0},{}};
    /**
     * @param args
     * @throws IOException
     */
    public static void main(String[] args) throws IOException {
        // for (int i = 2; i < 1000; i++) {
        // printMinutesToEat(i);
        // }
        List<String> lines = Files.readAllLines(new File(args[0]).toPath());
        if (lines == null || lines.size() == 0) {
            System.out.println("Not a valid input file... or error reading input");
            return;
        }
        int testCount = Integer.parseInt(lines.get(0));
        int index = 1;
        for (int i = 1; i < lines.size(); i += 2) {
            int dinerCount = Integer.parseInt(lines.get(i));
            String[] chunks = lines.get(i + 1).split(" ");
            int[] pancakeCount = stringToInt(chunks);
            eatPancakes(index++, dinerCount, pancakeCount);
        }
    }

    private static void eatPancakes(int testNum, int dinerCount, int[] panC) {
//        System.out.println(testNum + " , " + dinerCount + " , " + Arrays.toString(panC));

        Integer[] pans = Arrays.stream(panC).boxed().toArray(Integer[]::new);
        Arrays.sort(pans, new Comparator<Integer>() {
            @Override
            public int compare(Integer o1, Integer o2) {
                return o2.compareTo(o1);
            }
        });
        int minutesNeeded = getMinutesToEat(panC[0]);
        panC = Arrays.stream(pans).mapToInt(i -> i).toArray();
        // System.out.println("Sorted: " + Arrays.toString(pancakeCount));
        if (panC[0] == 9) {
            if(dinerCount > 2 && ((panC[1] <= 9 && panC[1] >= 7) 
                    && (panC[2] <= 9 && panC[2] >= 7)))
                minutesNeeded = 9;
            else if(dinerCount > 2 && ((panC[1] <= 9 && panC[1] >= 7) 
                    && (panC[2] <= 6 && panC[2] >= 4)))
                minutesNeeded = 8;
            else if(dinerCount > 1 && (panC[1] <= 9 && panC[1] >= 7))
                minutesNeeded = 7;
            else if(dinerCount > 1 && (panC[1] <= 6 && panC[1] >= 4))
                minutesNeeded = 6;
            else
                minutesNeeded = 5;
        } else if(panC[0] == 8){
            if(dinerCount > 3 && ((panC[1] <= 8 && panC[1] >= 5) 
                    && (panC[2] <= 8 && panC[2] >= 5)
                    && (panC[3] <= 8 && panC[3] >= 5)))
                minutesNeeded = 8;
            else if(dinerCount > 2 && ((panC[1] <= 8 && panC[1] >= 5) 
                    && (panC[2] <= 8 && panC[2] >= 5)))
                minutesNeeded = 7;
            else if(dinerCount > 1 && (panC[1] <= 8 && panC[1] >= 5))
                minutesNeeded = 6;
            else
                minutesNeeded = 5;
        } else if(panC[0] == 7){
            if(dinerCount > 2 && ((panC[1] == 6 || panC[1] == 5|| panC[1] == 7) 
                    && (panC[2] == 6 || panC[2] == 5|| panC[2] == 7)))
                minutesNeeded = 7;
            else if(dinerCount > 1 && (panC[1] == 6 || panC[1] == 5|| panC[1] == 7))
                minutesNeeded = 6;
            else
                minutesNeeded = 5;
        } else if(panC[0] == 6){
            if(dinerCount > 2 && ((panC[1] == 6 || panC[1] == 5|| panC[1] == 4) 
                    && (panC[2] == 6 || panC[2] == 5|| panC[2] == 4)))
                minutesNeeded = 6;
            else if(dinerCount > 1 && (panC[1] == 6 || panC[1] == 5|| panC[1] == 4))
                minutesNeeded = 5;
            else
                minutesNeeded = 4;
        } else if(panC[0] == 5){
            if(dinerCount > 1 && (panC[1] == 5 || panC[1] == 4))
                minutesNeeded = 5;
            else
                minutesNeeded = 4;
        } else if(panC[0] == 4){
            if(dinerCount > 1 && (panC[1] == 4 || panC[1] == 3))
                minutesNeeded = 4;
            else
                minutesNeeded = 3;
        } else if(panC[0] == 3){
            minutesNeeded = 3;
        } else if(panC[0] == 2){
            minutesNeeded = 2;
        } else {
            minutesNeeded = 1;
        }
//            for (int i = 1; i < dinerCount; i++) {
//                int minimumTime = getMinutesToEat(panC[i]);
//                // System.out.println("Time to eat for " + pancakeCount[i] + " cakes: " + minimumTime);
//                if (minutesNeeded <= panC[i]) {
//                    minutesNeeded += 1;// one extra pancake move is needed for every other big Pi
//                }
//            }
        System.out.println("Case #" + testNum + ": " + minutesNeeded);
    }

    static int getMinutesToEat(int cakesInOnePlate) {
        if (cakesInOnePlate == 1) {
            return 1;
        }
        if (cakesInOnePlate == 0) {
            return 0;
        }
        int minutes = ((int) cakesInOnePlate / 2 + cakesInOnePlate % 2 + 1);
        if (cakesInOnePlate % 3 == 0) {// those which can be divided into 3 equal parts, take 1 min lesser e.g. 9 pks
            minutes--;
        }
        return minutes;
    }

    private static int[] stringToInt(String[] array) {
        if (array == null) {
            return new int[] {};
        }
        int[] result = new int[array.length];
        for (int i = 0; i < result.length; i++) {
            result[i] = Integer.parseInt(array[i]);
        }
        return result;
    }
}
