package com.meme;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

/**
 * @author Prabakar Kalivaradan (Prabakar_Kalivaradan@Trimble.com)
 */
public class Sheep {
  public static void main(String[] args) throws FileNotFoundException {
    if(args.length != 1) {
      System.out.println("Please input file name");
      return;
    }
    String filePath = args[0];
    Scanner scan = new Scanner(new File(filePath));

    int testCaseCount = Integer.valueOf(scan.nextLine());
    int i = 1;
    while(scan.hasNextLine()) {
      System.out.printf("");
      runSheep(i, Long.valueOf(scan.nextLine()));
      i++;
    }
    System.out.println();
  }

  public static void runSheep(int testCase, long dozeNumber) {
    System.out.println();
    String outputFormat = "Case #%d: %s";
    if(dozeNumber == 0) {
      System.out.printf(outputFormat, testCase, "INSOMNIA");
      return;
    }
    Set<Character> digits = new HashSet<Character>();
    int i = 1;

    while (digits.size() < 10) {
      long zNumber = i * dozeNumber;
      String stringNum = String.format("%d", zNumber);
      for (int k=0; k<stringNum.length(); k++) {
        digits.add(stringNum.charAt(k));
      }
      if(digits.size() == 10) {
        System.out.printf(outputFormat, testCase, zNumber);
        break;
      }
      i++;
    }
  }
}
