package com.meme;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

/**
 * @author Prabakar Kalivaradan (Prabakar_Kalivaradan@Trimble.com)
 */
public class Pancake {
  public static void main(String[] args) throws FileNotFoundException {
    if (args.length != 1) {
      System.out.println("Please input file name");
      return;
    }
    String filePath = args[0];
    Scanner scan = new Scanner(new File(filePath));

    int testCaseCount = Integer.valueOf(scan.nextLine());
    int i = 1;
    while (scan.hasNextLine()) {
      System.out.printf("");
      runPancake(i, scan.nextLine());
      i++;
    }
    System.out.println();
  }

  public static void runPancake(int testCase, String panCakesOrStreamOfBits) {
    System.out.println();
    String outputFormat = "Case #%d: %d";
    int flips = 0;
    int length = panCakesOrStreamOfBits.length();
    if (length == 1) {
      if (panCakesOrStreamOfBits.charAt(0) == '-') {
        flips++;
      }
      System.out.printf(outputFormat, testCase, flips);
      return;
    }
    for (int i = 1; i < length; i++) {
      char current = panCakesOrStreamOfBits.charAt(i);
      char previous = panCakesOrStreamOfBits.charAt(i-1);
      if(current != previous) {
        flips++;
      }
    }
    if (panCakesOrStreamOfBits.charAt(length - 1) == '-') {
      flips++;
    }
    System.out.printf(outputFormat, testCase, flips);
  }
}
