import java.io.File;
import java.nio.file.Files;
import java.util.Arrays;
import java.util.List;
import java.util.stream.IntStream;

/**
 * 
 */

/**
 * @author pkalivaradan
 *
 */
public class Dobby {

    /**
     * @param args
     * @throws Throwable
     */
    public static void main(String[] args) throws Throwable {
        List<String> lines = Files.readAllLines(new File(args[0]).toPath());
        if (lines == null || lines.size() == 0) {
            System.out.println("Not a valid input file... or error reading input");
            return;
        }
        int testCount = Integer.parseInt(lines.get(0));
        for (int i = 1; i <= testCount; i++) {
            String[] chunks = lines.get(i).split(" ");
            int max = Integer.parseInt(chunks[0]);
            int[] digits = stringToInt(chunks[1].split(""));
            standingOvation(i, max, digits);
        }
    }

    private static void standingOvation(int testNum, int max, int[] digits) {
        // System.out.println(max + " , " + Arrays.toString(digits));
        int friendsNeeded = 0;
        if (max > 0) {
            int standing = digits[0];
            for (int i = 1; i < digits.length; i++) {
                if (standing < i) {
                    int diff = i - standing;
                    friendsNeeded += diff;
                    standing += diff;
                }
                standing += digits[i];
            }
        }
        System.out.println("Case #" + testNum + ": " + friendsNeeded);
    }

    private static int[] stringToInt(String[] array) {
        if (array == null) {
            return new int[] {};
        }
        int[] result = new int[array.length];
        for (int i = 0; i < result.length; i++) {
            result[i] = Integer.parseInt(array[i]);
        }
        return result;
    }
}
