package com.meme;

import java.io.File;
import java.io.FileNotFoundException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * @author Prabakar Kalivaradan (Prabakar_Kalivaradan@Trimble.com)
 */
public class JamCoin {
  private static String middleBinaryPattern = "";

  public static void main(String[] args) throws FileNotFoundException {
    if (args.length != 1) {
      System.out.println("Please input file name");
      return;
    }
    String filePath = args[0];
    Scanner scan = new Scanner(new File(filePath));

    int testCaseCount = Integer.valueOf(scan.nextLine());
    int i = 1;
    while (scan.hasNextLine()) {
      System.out.printf("");
      String[] nums = scan.nextLine().split(" ");
      runCoin(i, Integer.valueOf(nums[0]), Integer.valueOf(nums[1]));
      i++;
    }
    System.out.println();
  }

  public static void runCoin(int testCase, int N, int J) {
    String outputFormat = "Case #%d:";
    System.out.printf(outputFormat, testCase);
    int middleDigitsWidth = N - 2;
    String format = "%" + middleDigitsWidth + "s";
    String middlePattern = String.format(format, Integer.toBinaryString(0)).replace(' ', '0');
    int i = 0;
    String currentPattern = middlePattern;
    int neededCoins = J;
    COIN_SEARCH: while (i < Math.pow(2, middleDigitsWidth) - 1) {
//      System.out.println("---> testing coin " + currentPattern);
      String nextPattern = getNextBitPattern(middleDigitsWidth, currentPattern);
      String possibleJamCoin = "1" + nextPattern + "1";
      List<BigInteger> divisors = new ArrayList<BigInteger>();
      for(int radix=2; radix<=10; radix++) {
        BigInteger divisor = getDivisor(new BigInteger(possibleJamCoin,radix));
        if(divisor.compareTo(BigInteger.ZERO) == 0) {
          currentPattern = nextPattern; i++;
          continue COIN_SEARCH;
        }
        divisors.add(divisor);
      }
      //print coin
      System.out.println();
      System.out.print(possibleJamCoin);
      for(BigInteger dv : divisors) {
        System.out.print(" " + dv.toString());
      }

      neededCoins--;
      if (neededCoins==0) {
        break COIN_SEARCH;
      }
      currentPattern = nextPattern;
      i++;
    }
  }

  private static String getNextBitPattern(int width, String currentPattern) {
    int current = Integer.valueOf(currentPattern, 2);
    return String.format("%" + width + "s", Integer.toBinaryString(current + 1)).replace(' ', '0');
  }

  private static BigInteger getDivisor(BigInteger number) {
    BigInteger limit = number.divide(number.divide(BigInteger.TEN));
    for (BigInteger i = BigInteger.valueOf(2); i.compareTo(limit) < 0; i = i.add(BigInteger
        .ONE)) {
      if (number.mod(i).compareTo(BigInteger.ZERO) == 0) {
        return i;
      }
    }
    return BigInteger.ZERO;
  }
}
