package round1B;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Scanner;

public class TheRepeater {
	public static void main(String[] args) throws IOException {
//		System.setIn(new FileInputStream("/tmp/small.in"));
//		System.setOut(new PrintStream("/tmp/small.out"));
		System.setIn(new FileInputStream("/tmp/large.in"));
		System.setOut(new PrintStream("/tmp/large.out"));

		Scanner sc = new Scanner(System.in);
		final int TEST_CASES = sc.nextInt();

		for (int i = 1; i <= TEST_CASES; i++) {
			int count = sc.nextInt();

			String[] data = new String[count];
			for (int j = 0; j < data.length; j++) {
				data[j] = sc.next();
			}

			int result = solve(data);

			if (result != -1) {
				System.out.format("Case #%d: %d\n", i, result);

			} else {
				System.out.format("Case #%d: Fegla Won\n", i);
			}
		}

		sc.close();
	}

	private static int solve(String[] data) {
		int[] indices = new int[data.length];

		int result = 0;
		boolean process = true;
		
		L:while (process) {
			
			char currentChar = 0;
			
			int[] count = new int[data.length];
			
			int out = 0;
			
			for (int i = 0; i < data.length; i++) {
				
				if(indices[i] < data[i].length() && (currentChar == 0 || currentChar == data[i].charAt(indices[i]))){
					if(currentChar == 0) currentChar = data[i].charAt(indices[i]);
					
					while(indices[i] < data[i].length() && currentChar == data[i].charAt(indices[i])){
						indices[i]++;
						count[i]++;
					}
					
				} else {
					out++;					
				}
			}
			
			if(out > 0){
				if(out != data.length){
					result = -1;
				}
				
				process = false;
			
			} else {
				int optimal = findOptimal(count);
				result += optimal;
			}
			
		}

		return result;
	}

	private static int findOptimal(int[] count) {
		int total = 0;
		
		for(int _ : count){
			total += _;
		}
		
		int floor = total / count.length;
		int ceil = (total + 1) / count.length;
		
		int roundUp = -1;
		int value = Integer.MAX_VALUE;
		for(int _ : count){
			int diff = _ - floor;
			if(_ >= floor && (roundUp == -1 || diff < value)){
				roundUp = _;
				value = diff;
			}
		}
		
		int roundDown = -1;
		value = Integer.MAX_VALUE;
		
		for(int _ : count){
			int diff = floor - _;
			if(_ <= floor && (roundDown == -1 || diff < value)){
				roundDown = _;
				value = diff;
			}
		}
		
		int change1 = 0;
		int change2 = 0;
		int change3 = 0;
		int change4 = 0;
		
		for(int _ : count){
			change1 += Math.abs(floor - _);
			change2 += Math.abs(ceil - _);
			change3 += Math.abs(roundUp - _);
			change4 += Math.abs(roundDown - _);
		}
			
		return Math.min(change1, Math.min(change2, Math.min(change3, change4)));
	}
}
