import java.util.Arrays;
import java.util.Scanner;


public class InfiniteHousePancakes {
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int testCases = sc.nextInt();
		
		for (int i = 1; i <= testCases; i++) {
			int platesNumber = sc.nextInt();
			int[] plates = new int[platesNumber];
			
			for(int j = 0; j < plates.length; j++) {
				plates[j] = sc.nextInt();
			}
			
			int result = solve(plates);
			
			System.out.format("Case #%d: %d\n", i, result);
		}
	}

	private static int solve(int[] plates) {
		
		int max = 0;
		for (int n : plates) max = Math.max(max, n);

		max = Math.max(3, max);
		
		int[][] memo = new int[max + 1][2];
		 
		memo[1] = new int[]{1, 0};
		memo[2] = new int[]{2, 0};
		
		for (int i = 3; i < memo.length; i++){
			int[] min = new int[]{ memo[i - 1][0] + 1, memo[i - 1][1] };
			
			for (int k = 2; k <= i / 2; k++){
				int[] current = new int[]{ 
							Math.max(memo[k][0], memo[i - k][0]), 
							1 + memo[k][1] + memo[i - k][1]				
						};
				
				if (current[0] < min[0] || (current[0] == min[0] && current[1] < min[1])) {
					min = current;
				}
			}
			
			memo[i] = min;
		}

		int result = 0;
		for (int plate : plates){
			int cost = memo[plate][0] + memo[plate][1];
			result = Math.max(cost, result);
		}
		
		return result;
	}
}
