import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class Archeo {

	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader("data/D-small-attempt4.in"));
			int nbCases = new Integer(br.readLine());
			
			for (int pb=0 ; pb<nbCases ; pb++) {
				// Parsing
				String[] vals = br.readLine().split(" ");
				int K = new Integer(vals[0]);
				int C = new Integer(vals[1]);
				int S = new Integer(vals[2]);
				
				// Solution
				System.out.print("Case #" + (pb+1) + ": ");
				//System.out.println(K + " " + C + " " + S);
				
				List<Long> solution = Archeo.solve (K, C, S);
				if (solution == null)
					System.out.println("IMPOSSIBLE");
				else {
					for (long val : solution)
						System.out.print((val+1) + " ");
					System.out.println();
				}
				
				/*if (C == 1 || K == 1) {
					if (K > S)
						System.out.println("IMPOSSIBLE");
					else {
						for (int i=1 ; i<=K ; i++)
							System.out.print(i + " ");
						System.out.println();
					}
				} else if (K <= 2*S) {
					List<Long> solution = Archeo.solve (K, C, S);
					for (long val : solution)
						System.out.print(val + " ");
					System.out.println();
				} else
					System.out.println("IMPOSSIBLE");/**/
			}
			br.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static List<Long> solve(int k, int c, int s) {
		List<Long> values = new ArrayList<>();
		
		if (s == 0)
			return null;
		else if (c == 1) {
			if (s<k)
				return null;
			
			for (long idx=0 ; idx<k ; idx++)
				values.add(idx);
			return values;
			
		} else if (k == c) {
			long sum = 0;
			
			for (long i=0 ; i<c ; i++)
				sum += i * new Double(Math.pow(k, c-1-i)).longValue();
			values.add(sum);
			return values;
		} else if (k < c)
			return solve(k, k, s);
		else if (k > c){
			for (int n=0 ; n<k/c ; n++) {
				long sum = 0;
				
				for (long i=0 ; i<c ; i++)
					sum += (c * n + i) * new Double(Math.pow(k, c-1-i)).longValue();
				
				values.add(sum);
			}
			
			if (k%c != 0) {
				long idx = solve(k-c, k-c, 1).get(0);
				values.add(
						((idx+1)/(k-c))*k
						+ c + (k % (k-c))
				);
			}
			
			if (values.size() <=s)
				return values;
		}
		
		return null;
	}

	private static List<Long> solve(int k, int c) {
		if (c > k)
			return solve(k, k);
		
		List<Long> solution = new ArrayList<>();
		
		for (int n=0 ; n<k/c ; n++) {
			long sum = 0;
			
			for (long i=0 ; i<c ; i++)
				sum += (c * n + i) * new Double(Math.pow(k, c-1-i)).longValue();
			
			solution.add(sum + 1);
		}
		
		if (k%c != 0) {
			long idx = solve (2, 2).get(0);
			solution.add(
					new Double(Math.pow(c, c)).longValue() +
					c * ((idx / (k-c)) + 1) + (idx % (k-c))
			);
		}
		
		return solution;
	}/**/
	
}
