package main;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

public class Coin {

	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader("data/A-small-attempt0.in"));
			int nbCases = new Integer(br.readLine());
			
			for (int pb=0 ; pb<nbCases ; pb++) {
				String line = br.readLine();
				Map<Character, Integer> letters = new HashMap<>();
				for (int i=0 ; i<line.length() ; i++) {
					char c = line.charAt(i);
					int val = letters.containsKey(c) ? letters.get(new Character(c)) : 0;
					letters.put(c, val+1);
				}
				
				String number = getNumber (letters);
				System.out.print("Case #" + (pb+1) + ": ");
				System.out.println(number);
			}
			br.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static String getNumber(Map<Character, Integer> letters) {
		int[] numbers = firstStep (letters);
		
		String phone = "";
		
		for (int i=0 ; i<numbers.length ; i++)
			for (int j=0 ; j<numbers[i] ; j++)
				phone += "" + i;
		
		return phone;
	}

	private static int[] firstStep(Map<Character, Integer> letters) {
		int[] numbers = new int[10];
		
		while (letters.containsKey(new Character('Z'))
				|| letters.containsKey(new Character('W'))
				|| letters.containsKey(new Character('U'))
				|| letters.containsKey(new Character('X'))
				|| letters.containsKey(new Character('G'))) {
		
			if (letters.containsKey(new Character('Z'))) {
				numbers[0]++;
				delete ('Z', letters);
				delete ('E', letters);
				delete ('R', letters);
				delete ('O', letters);
			} else if (letters.containsKey(new Character('W'))) {
				numbers[2]++;
				delete ('T', letters);
				delete ('W', letters);
				delete ('O', letters);
			} else if (letters.containsKey(new Character('U'))) {
				numbers[4]++;
				delete ('F', letters);
				delete ('O', letters);
				delete ('U', letters);
				delete ('R', letters);
			}else if (letters.containsKey(new Character('X'))) {
				numbers[6]++;
				delete ('S', letters);
				delete ('I', letters);
				delete ('X', letters);
			}else if (letters.containsKey(new Character('G'))) {
				numbers[8]++;
				delete ('E', letters);
				delete ('I', letters);
				delete ('G', letters);
				delete ('H', letters);
				delete ('T', letters);
			}
		}
		
		while (letters.containsKey(new Character('O'))
				|| letters.containsKey(new Character('H'))
				|| letters.containsKey(new Character('F'))
				|| letters.containsKey(new Character('S'))) {
		
			if (letters.containsKey(new Character('O'))) {
				numbers[1]++;
				delete ('O', letters);
				delete ('N', letters);
				delete ('E', letters);
			} else if (letters.containsKey(new Character('H'))) {
				numbers[3]++;
				delete ('T', letters);
				delete ('H', letters);
				delete ('R', letters);
				delete ('E', letters);
				delete ('E', letters);
			} else if (letters.containsKey(new Character('F'))) {
				numbers[5]++;
				delete ('F', letters);
				delete ('I', letters);
				delete ('V', letters);
				delete ('E', letters);
			}else if (letters.containsKey(new Character('S'))) {
				numbers[7]++;
				delete ('S', letters);
				delete ('E', letters);
				delete ('V', letters);
				delete ('E', letters);
				delete ('N', letters);
			}
		}
		
		numbers[9] = letters.containsKey(new Character('I')) ? letters.get(new Character('I')) : 0;
		
		return numbers;
	}

	private static void delete(char c, Map<Character, Integer> letters) {
		Character ch = new Character(c);
		int val = letters.get(ch);
		
		if (val <= 1)
			letters.remove(ch);
		else
			letters.put(ch, val-1);
	}
	
}
