import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class Sheep {

	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader("data/A-large.in"));
			int nbCases = new Integer(br.readLine());
			
			for (int pb=0 ; pb<nbCases ; pb++) {
				int val = new Integer(br.readLine());
				System.out.print("Case #" + (pb+1) + ": ");
				
				if (val == 0)
					System.out.println("INSOMNIA");
				else {
					boolean[] digits = new boolean[10];
					System.out.println(Sheep.count(val, 0, digits));
				}
			}
			br.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static int count(int N, int sum, boolean[] digits) {
		if (Sheep.ended(digits))
			return sum;
		
		sum += N;
		Sheep.insertDigits (digits, sum);
		
		return Sheep.count(N, sum, digits);
	}

	private static void insertDigits(boolean[] digits, int val) {
		while (val > 0) {
		    int digit = val % 10;
		    digits[digit] = true;
		    val /= 10;
		}
	}

	private static boolean ended(boolean[] digits) {
		for (boolean val : digits)
			if (!val)
				return false;
		return true;
	}
	
}
