package codejam2017.qualif;

import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Stream;

public class CodeJam02Tidy {
	
	private static String solve(TestCase testCase) {
		return tidy(testCase.numbers);
	}
	
	static String tidy(String numbers) {
		int indexOfUntidyness = indexOfUntidyness(numbers);
		
		if (indexOfUntidyness == -1) {
			return numbers;
		} else {
			String newNubers = tidyOnce(numbers, indexOfUntidyness);
			return tidy(newNubers);
		}
	}
	
	static String tidyOnce(String numbers, int indexOfUntidyness) {
		String pre = numbers.substring(0, indexOfUntidyness);
		String mid = "" + (Integer.parseInt(numbers.substring(indexOfUntidyness, indexOfUntidyness + 1)) - 1);
		String post = "";
		for (int i = 0; i < numbers.substring(indexOfUntidyness + 1).length(); i++) {
			post += "9";
		}
		
		return cleanLeadingZero(pre + mid + post);
	}
	
	static String cleanLeadingZero(String numbers) {
		if (fromPos(numbers, 0) == 0) {
			return numbers.substring(1);
		} else {
			return numbers;
		}
	}
	
	static int indexOfUntidyness(String numbers) {
		if (numbers.length() < 2) {
			return -1;
		}
		
		int prevNum = fromPos(numbers, 0);
		for (int i = 1; i < numbers.length(); i++) {
			int currNum = fromPos(numbers, i);
			if (prevNum > currNum) {
				return i - 1;
			}
			prevNum = currNum;
		}
		
		return -1;
	}
	
	static int fromPos(String numbers, int index) {
		return Integer.parseInt(numbers.charAt(index) + "");
	}
	
	static class TestCase {
		String numbers;
		
		@Override
		public String toString() {
			return "TestCase [numbers=" + numbers + "]";
		}
	}
	
	
	/*
	 *  ------------------------------------------
	 *   Boilerplate to run test and handle files
	 *  ------------------------------------------
	 */

	public static void main(String[] args) {
		TestInput testInput = getInput();
		TestOutput testOutput = solve(testInput);
		writeOutput(testOutput);
	}
	
	private static TestOutput solve(TestInput testInput) {
		TestOutput testOutput = new TestOutput();
		
		for (TestCase testCase : testInput.cases) {
			String result = solve(testCase);
			testOutput.result.add(result);
		}
		
		return testOutput;
	}

	private static void writeOutput(TestOutput testOutput) {
		Path path = Paths.get("/home/dodi/temp/output.txt");
		try (BufferedWriter writer = Files.newBufferedWriter(path)) {
			int caseNumber = 1;
			for (String line : testOutput.result) {
				writer.write("Case #" + caseNumber + ": " + line + "\n");
				caseNumber++;
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}


	private static TestInput getInput() {
		String fileName = "/home/dodi/temp/input.txt";
		
		TestInput testInput = new TestInput();
		try (Stream<String> stream = Files.lines(Paths.get(fileName))) {
			stream.forEach((line) -> {
				if (testInput.numberOfCases == -1) {
					testInput.numberOfCases = Integer.parseInt(line);
				} else {
					TestCase testCase = new TestCase();
					testCase.numbers = line;
					testInput.cases.add(testCase);
				}
			});

		} catch (IOException e) {
			e.printStackTrace();
		}
		return testInput;
	}
	
	static class TestInput {
		int numberOfCases = -1;
		List<TestCase> cases = new ArrayList<>();
		
		@Override
		public String toString() {
			return "TestInput [numberOfCases=" + numberOfCases + ", cases=" + cases + "]";
		}
	}
	
	static class TestOutput {
		List<String> result = new ArrayList<>();
	}
}
