package codejam2017.qualif;

import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Stream;

public class CodeJam01Pancake {
	
	private static int maxVal(int[] arr) {
		int maxVal = -1;
		for (int i = 0; i < arr.length; i++) {
			if (arr[i] > maxVal) {
				maxVal = arr[i];
			}
		}
		return maxVal;
	}
	
	private static String solve(TestCase testCase) {
		int[] flips = new int[testCase.pancaces.length()];
		int totalNumberOfFlips = 0;
		System.out.println(testCase.pancaces);
		int firstBlank = testCase.pancaces.indexOf("-");
		while (firstBlank != -1 && maxVal(flips) < 100) {
			int endPos = firstBlank + testCase.flipperSize;
			int lastPos = testCase.pancaces.length();
			
			if (endPos > lastPos) {
				firstBlank = firstBlank - (endPos - lastPos);
				endPos = lastPos;
			}
			
			String pre = testCase.pancaces.substring(0, firstBlank);
			String post = testCase.pancaces.substring(endPos);
			String mid = testCase.pancaces.substring(firstBlank, endPos);

			String newMid = "";
			for (int i = 0; i < mid.length(); i++) {
				if (mid.charAt(i) == '+') {
					newMid += "-";
				} else {
					newMid += "+";
				}
			}
			
			testCase.pancaces = pre + newMid + post;
			System.out.println(testCase.pancaces);
			for (int i = firstBlank; i < lastPos; i++) {
				flips[i] = flips[i] + 1;
			}
			
			totalNumberOfFlips ++;
			firstBlank = testCase.pancaces.indexOf("-");
		}
		System.out.println("---******");
		if (firstBlank == -1) {
			return totalNumberOfFlips + "";
		} else {
			return "IMPOSSIBLE"; 
		}
	}
	
	static class TestCase {
		int flipperSize;
		String pancaces;
		
		@Override
		public String toString() {
			return "TestCase [flipperSize=" + flipperSize + ", pancaces=" + pancaces + "]";
		}
	}
	
	
	/*
	 *  ------------------------------------------
	 *   Boilerplate to run test and handle files
	 *  ------------------------------------------
	 */

	public static void main(String[] args) {
		TestInput testInput = getInput();
		TestOutput testOutput = solve(testInput);
		writeOutput(testOutput);
	}
	
	private static TestOutput solve(TestInput testInput) {
		TestOutput testOutput = new TestOutput();
		
		for (TestCase testCase : testInput.cases) {
			String result = solve(testCase);
			testOutput.result.add(result);
		}
		
		return testOutput;
	}

	private static void writeOutput(TestOutput testOutput) {
		Path path = Paths.get("/home/dodi/temp/output.txt");
		try (BufferedWriter writer = Files.newBufferedWriter(path)) {
			int caseNumber = 1;
			for (String line : testOutput.result) {
				writer.write("Case #" + caseNumber + ": " + line + "\n");
				caseNumber++;
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}


	private static TestInput getInput() {
		String fileName = "/home/dodi/temp/input.txt";
		
		TestInput testInput = new TestInput();
		try (Stream<String> stream = Files.lines(Paths.get(fileName))) {
			stream.forEach((line) -> {
				if (testInput.numberOfCases == -1) {
					testInput.numberOfCases = Integer.parseInt(line);
				} else {
					TestCase testCase = new TestCase();
					testCase.pancaces = line.split(" ")[0];
					testCase.flipperSize = Integer.parseInt(line.split(" ")[1]);
					testInput.cases.add(testCase);
				}
			});

		} catch (IOException e) {
			e.printStackTrace();
		}
		return testInput;
	}
	
	static class TestInput {
		int numberOfCases = -1;
		List<TestCase> cases = new ArrayList<>();
		
		@Override
		public String toString() {
			return "TestInput [numberOfCases=" + numberOfCases + ", cases=" + cases + "]";
		}
	}
	
	static class TestOutput {
		List<String> result = new ArrayList<>();
	}
}
