package commons.read;

import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.nio.file.Path;

import commons.read.model.Lines;

public class ProblemReader {

	private String filePath;
	private String fileName;
	
	public ProblemReader(String filePath, String fileName) {
		this.filePath = filePath;
		this.fileName = fileName;
	}
	
	public Lines read() {
		Path path = FileSystems.getDefault().getPath(filePath, fileName);
		try {
			return new Lines(Files.readAllLines(path, Charset.defaultCharset()));
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}
}
