package commons.read.model;

import java.util.List;

public class Case {
	private final int caseNumber;
	private final List<List<String>> lines;
	
	public Case(int caseNumber, List<List<String>> lines) {
		this.caseNumber = caseNumber;
		this.lines = lines;
	}
	
	public List<List<String>> getLines() {
		return lines;
	}
	
	public int getCaseNumber() {
		return caseNumber;
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("Case " + caseNumber);
		sb.append("\n");
		for (List<String> line : lines) {
			sb.append(line);
			sb.append("\n");
		}
		
		return sb.toString();
	}
}
