package commons.read.model;

import java.util.ArrayList;
import java.util.List;

public class SplittedLines {
	
	private final List<List<String>> lines;
	
	public SplittedLines(List<List<String>> lines) {
		this.lines = lines;
	}
	
	public List<List<String>> getLines() {
		return lines;
	}
	
	public Cases toProblem() {
		int numberOfCases = Integer.parseInt(lines.get(0).get(0));
		int caseSize = lines.size() / numberOfCases;
		
		List<Case> cases = new ArrayList<Case>();
		for (int i = 0; i < numberOfCases; i++) {
			List<List<String>> caseLines = new ArrayList<List<String>>();
			for (int j = 0; j < caseSize; j++) {
				caseLines.add(lines.get(i * caseSize + j + 1));
			}
			cases.add(new Case(i+1, caseLines));
		}
		
		return new Cases(cases);
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		
		for (List<String> line : lines) {
			sb.append(line);
			sb.append("\n");
		}
		
		return sb.toString();
	}
}
