import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import commons.read.ProblemReader;
import commons.read.model.Case;
import commons.read.model.Cases;
import commons.write.SolutionWriter;



public class MagicTrick {
	
	private static final String PATH = "/home/dodie/workspace_codejam/codejam201404/magic-trick2/src/main/resources";
	private static final String INPUT_FILE = "A-small-attempt0.in";
	private static final String OUT_FILE = "A-small-attempt0.out";
	
	
	
	
	public static void main(String[] args) {
		Cases cases = new ProblemReader(PATH, INPUT_FILE).read().split().toProblem();
		List<String> solution = new ArrayList<String>();
		
		for (Case problem : cases) {
			int selectedRowNumFirst = Integer.parseInt(problem.getLines().get(0).get(0));
			int selectedRowNumSecond = Integer.parseInt(problem.getLines().get(5).get(0));
			
			Set<String> firstLine = new HashSet<String>(problem.getLines().get(selectedRowNumFirst));
			Set<String> secondLine = new HashSet<String>(problem.getLines().get(5 + selectedRowNumSecond));
			
			firstLine.retainAll(secondLine);
			if (firstLine.isEmpty()) {
				solution.add("Case #" + problem.getCaseNumber() + ": Volunteer cheated!");
			} else if (firstLine.size() > 1) {
				solution.add("Case #" + problem.getCaseNumber() + ": Bad magician!");
			} else {
				solution.add("Case #" + problem.getCaseNumber() + ": " + firstLine.iterator().next());
			}
		}
		
		new SolutionWriter(PATH, OUT_FILE).write(solution);
	}
}
