package commons.write;

import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.OpenOption;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.List;

public class SolutionWriter {

	private String filePath;
	private String fileName;

	public SolutionWriter(String filePath, String fileName) {
		this.filePath = filePath;
		this.fileName = fileName;
	}

	public void write(List<String> solution) {
		Path myDir = Paths.get(filePath);

		Path writeFile = myDir.resolve(fileName);
		
		try {
			try {
				Files.delete(writeFile);
			} catch (Exception e) {
				// Do nothing.
			}
			
			Files.createFile(writeFile);
			BufferedWriter br = Files.newBufferedWriter(writeFile,
					Charset.forName("UTF-8"),
					new OpenOption[] { StandardOpenOption.WRITE });
			
			for (String line : solution) {
				br.write(line);
				br.write("\n");
			}

			br.flush();
			br.close();
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}
}
