package hu.awm.test;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.StringJoiner;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class StandingOvation {
	static int caseNumber = 0;
	
	public static void main(String[] args) throws Exception {
		resetFile();
		try (Stream<String> lines = Files.lines(Paths.get("/home/dodi/temp", "in"))) {
			lines.skip(1).forEach(line -> addResult(solve(line)));
		}
	}
	
	static String solve(String line) {
		String audienceRawData = line.split(" ")[1];
		int[] audience = new int[audienceRawData.length()];
		for (int i = 0; i < audience.length; i++) {
			audience[i] = Integer.parseInt(audienceRawData.charAt(i) + "");
		}
		
		int standNum = 0;
		int extra = 0;
		for (int i = 0; i < audience.length; i++) {
			if (audience[i] != 0) {
				if (standNum >= i) {
					standNum += audience[i];
				} else {
					int addExtra = i - standNum;
					extra += addExtra;
					standNum += addExtra + audience[i];
				}
			}
		}
		
		return extra + "";
	}
	
	static void resetFile() {
		try {
			Files.write(Paths.get("/home/dodi/temp/out"), "".getBytes());
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}
	
	static void addResult(String caseResult) {
		String formattedResult = "Case #" + ++caseNumber + ": " + caseResult + "\n";
		try {
			Files.write(Paths.get("/home/dodi/temp/out"), formattedResult.getBytes(), StandardOpenOption.APPEND);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}
}
