package util;

import java.math.BigDecimal;
import java.util.ArrayList;

public class Prime {
	public static boolean []isPrimeArray = new boolean[1000000];
	public static ArrayList<Integer> prime;
	
	public Prime() {
		prime = new ArrayList<Integer>();
		for(int i = 0; i < 1000000; i++) {
			isPrimeArray[i] = true;
		}
		setPrime();
	}
	
	public void setPrime() {
		isPrimeArray[0] = false;
		isPrimeArray[1] = false;
		
		for(int i = 2; i < 1000000; i++) {
			if(isPrimeArray[i] == true) {
				prime.add(i);
				
				for(int j = i * 2; j < 1000000; j+=i) {
					isPrimeArray[j] = false;
				}
			}
		}
	}
	
	public int getNThPrime(int n) {
		return prime.get(n);
	}
	
	public boolean isNPrime(int n) {
		return isPrimeArray[n];
	}
	
	public ArrayList<Integer> findPrimeFactor(int n) {
		ArrayList<Integer> pf = new ArrayList<Integer>();
		for(int i = 0 ; i < Math.sqrt(n); i++) {
			if(isNPrime(i) && ((n % i) == 0)) {
				pf.add(i);
			}
		}
		return pf;
	}
	
	public ArrayList<Integer> findPrimeFactor(BigDecimal n) {
		ArrayList<Integer> pf = new ArrayList<Integer>();
		for(int i = 0; i < prime.size(); i++) {
			BigDecimal bdPrime = BigDecimal.valueOf(prime.get(i));
			if((bdPrime).compareTo(n) >= 0) {
				break;
			}
			BigDecimal []result = n.divideAndRemainder(bdPrime); 
			if(result[1].equals(BigDecimal.ZERO)) {
				pf.add(prime.get(i));
			}
		}
		return pf;
	}
	
	public static void main(String []args) {
		Prime p = new Prime();
		System.out.println(p.getNThPrime(100));
		System.out.println(p.isNPrime(32767));
		ArrayList<Integer> pf = p.findPrimeFactor(32767);
		for(Integer i:pf) {
			System.out.println(i);
		}
	}

}
