package codejam;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;
import java.util.Set;

public class Main implements Runnable {
	Scanner sc;
	private boolean debug = false;

	/***************************************************************************/

	void solve() {
		int y = sc.nextInt();
		int x = sc.nextInt();
		char[][] g = new char[x][y];
		sc.nextLine();
		for (int i = 0; i < y; i++) {
			String line = sc.nextLine();
			for (int j = 0; j < x; j++)
				g[j][i] = line.charAt(j);
		}
		long c = 0;
		for (int i = 0; i < x; i++)
			for (int j = 0; j < y; j++) {
				if (!checkdir(g, g[i][j], i, j)) {
					if (checkdir(g, 'v', i, j) || checkdir(g, '^', i, j) || checkdir(g, '<', i, j) || checkdir(g, '>', i, j))
						c++;
					else {
						System.out.print("IMPOSSIBLE");
						return;
					}
				}
			}
		System.out.print(c);
	}

	boolean checkdir(char[][] g, char g2, int i, int j) {
		try {
			switch (g2) {
			case '^':
				j--;
				while (g[i][j] == '.')
					j--;
				return true;
			case '<':
				i--;
				while (g[i][j] == '.')
					i--;
				return true;
			case '>':
				i++;
				while (g[i][j] == '.')
					i++;
				return true;
			case 'v':
				j++;
				while (g[i][j] == '.')
					j++;
				return true;
			default:
				return true;
			}
		} catch (Exception e) {
			return false;
		}
	}

	/***************************************************************************/

	@Override
	public void run() {
		Locale.setDefault(Locale.US);
		sc = new Scanner(System.in);
		if (!debug) {
			try {
				sc = new Scanner(new FileInputStream("C:\\Users\\Aesma\\Desktop\\in.in"));
				System.setOut(new PrintStream(new FileOutputStream("C:\\Users\\Aesma\\Desktop\\out.txt")));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
				System.exit(0);
			}
		}

		int cn = sc.nextInt();
		for (int ca = 1; ca <= cn; ca++) {
			System.out.print("Case #" + ca + ": ");
			solve();
			System.out.println();
			System.err.println("Solved case #" + ca);
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}
}