import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

public class Lawnmower
{
	public static void main(String[] args)
	{
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		for (int tn=1;tn<=n;tn++)
		{
			int N = sc.nextInt();
			int M = sc.nextInt();
			int[][] lawn = new int[N][M];
			
			for (int i=0;i<N;i++) // lines
			{
				for (int j=0;j<M;j++) // integers on line
				{
					lawn[i][j] = sc.nextInt();
				}
			}
			
			System.out.println("Case #"+tn+": "+testLawn(lawn));
		}
		sc.close();
	}
	
	static String testLawn(int[][] lawn)
	{
		int[] hh = getHeights(lawn);
		
		// consider each height a layer. highest grass is always fine. start at second highest grass
		for (int l=hh.length-2;l>=0;l--)
		{
			int h = hh[l];
			boolean[][] layer = new boolean[lawn.length][lawn[0].length];
			for (int i=0;i<lawn.length;i++)
			{
				for (int j=0;j<lawn[i].length;j++)
				{
					if (lawn[i][j] == h)
					{
						layer[i][j] = true;
					}
				}
			}
			if (!testLayer(layer))
			{
				return "NO";
			}
		}
		
		return "YES";
	}
	
	static int[] getHeights(int[][] lawn)
	{
		ArrayList<Integer> heights = new ArrayList<Integer>();
		
		for (int i=0;i<lawn.length;i++)
		{
			for (int j=0;j<lawn[i].length;j++)
			{
				int h = lawn[i][j];
				if (!heights.contains(h))
				{
					heights.add(h);
				}
			}
		}
		
		int[] hh = new int[heights.size()];
		for (int i=0;i<heights.size();i++)
		{
			hh[i] = heights.get(i);
		}
		Arrays.sort(hh);
		
		return hh;
	}
	
	static boolean testLayer(boolean[][] layer)
	{
		boolean[][] checked = new boolean[layer.length][layer[0].length];
		
		for (int i=0;i<layer.length;i++) // rows
		{
			for (int j=0;j<layer[i].length;j++) // columns
			{
				if (!checked[i][j]) // prevent extra computations
				{
					if (!layer[i][j]) // not part of layer, mark checked
					{
						checked[i][j] = true;
					}
					else // block i,j is part of layer; check!!
					{
						// each block that is part of this layer must be part of a row OR column also included in the layer
						
						// check row
						boolean row = true;
						for (int k=0;k<layer[i].length;k++) // columns in row i
						{
							if (!layer[i][k])
							{
								row = false;
							}
						}
						
						// check column
						boolean column = true;
						for (int k=0;k<layer.length;k++) // rows containing column j
						{
							if (!layer[k][j])
							{
								column = false;
							}
						}
						
						if (!row && !column)
						{
							return false;
						}
					}
				}
			}
		}
		
		return true;
	}
}
