import java.util.ArrayList;
import java.util.Scanner;

public class Treasure2
{
	static ArrayList<Integer> path;
	
	static ArrayList<Integer> keys;
	static ArrayList<Integer> usedKeys;
	
	static ArrayList<Chest> chests;
	
	static boolean pathFound;
	
	public static void main(String[] args)
	{
		Scanner sc = new Scanner(System.in);
		int T = sc.nextInt(); // num test cases
		for (int tn=1;tn<=T;tn++)
		{
			int K = sc.nextInt(); // num keys
			int N = sc.nextInt(); // num chests
			
			path = new ArrayList<Integer>();
			keys = new ArrayList<Integer>();
			usedKeys = new ArrayList<Integer>();
			chests = new ArrayList<Chest>();
			pathFound = false;
			
			for (int i=0;i<K;i++) // for each key
			{
				keys.add(sc.nextInt());
			}
			
			for (int i=0;i<N;i++) // for each chest
			{
				int keyType = sc.nextInt();
				int keyNum = sc.nextInt();
				int[] keysInChest = new int[keyNum];
				
				for (int j=0;j<keyNum;j++)
				{
					keysInChest[j] = sc.nextInt();
				}
				
				chests.add(new Chest(keyType, keysInChest, i+1));
			}
			
			if (treasureHunt())
			{
				String pathStr = "";
				for (int p : path)
				{
					pathStr += p + " ";
				}
				System.out.println("Case #"+tn+": "+pathStr);
			}
			else
			{
				System.out.println("Case #"+tn+": IMPOSSIBLE");
			}
		}
		sc.close();
	}
	
	static boolean treasureHunt()
	{
		if (pathFound) // possibly unnecessary?
		{
			return true;
		}
		
		if (allOpen()) // done!
		{
			pathFound = true;
			return true;
		}
		
		boolean stuck = true;
		
		for (int c=0;c<chests.size();c++) // for each unopened chest
		{
			Chest curChest = chests.get(c);
			if (!curChest.open)
			{
				if (keys.contains(new Integer(curChest.keyType))) // can open?
				{
					stuck = false;
					
					//open:
					curChest.open = true;
					
					//used key:
					keys.remove(new Integer(curChest.keyType));
					usedKeys.add(curChest.keyType);
					
					//get new keys:
					for (int k=0;k<curChest.keys.length;k++)
					{
						keys.add(curChest.keys[k]);
					}
					
					// write to trail
					path.add(curChest.name);
					
					if (treasureHunt()) // continue
					{
						
					}
					else // backtrack
					{
						// go back on trail
						path.remove(path.size()-1);
						
						// put back new keys:
						for (int k=0;k<curChest.keys.length;k++)
						{
							keys.remove(new Integer(curChest.keys[k]));
						}
						
						// take back key:
						keys.add(curChest.keyType);
						usedKeys.remove(new Integer(curChest.keyType));
						
						// close chest:
						curChest.open = false;
					}
				}
			}
		}
		
		return !stuck;
	}
	
	static class Chest
	{
		int keyType;
		int keys[];
		int name;
		boolean open;
		public Chest(int keyType, int[] keys, int name)
		{
			super();
			this.keyType = keyType;
			this.keys = keys;
			this.name = name;
			this.open = false;
		}
		
		public String toString()
		{
			return "C"+name;
		}
	}
	
	static boolean allOpen()
	{
		for (Chest c : chests)
		{
			if (!c.open)
			{
				return false;
			}
		}
		return true;
	}
}
