import java.util.ArrayList;
import java.util.Scanner;

public class FairAndSquare
{
	public static void main(String[] args)
	{
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		int[][] cases = new int[n][2];
		
		// save time, combine cases!
		int min = 0;
		int max = 0;
		
		// first case:
		cases[0][0] = sc.nextInt();
		cases[0][1] = sc.nextInt();
		min = cases[0][0];
		max = cases[0][1];
		
		// second to nth case:
		for (int tn=1;tn<n;tn++)
		{
			cases[tn][0] = sc.nextInt();
			cases[tn][1] = sc.nextInt();			

			if (cases[tn][0] < min)
			{
				min = cases[tn][0];
			}
			
			if (cases[tn][1] > max)
			{
				max = cases[tn][1];
			} 
		}
		sc.close();
		
		int[] fas = getFAS(min, max); // get all fas numbers
		
		// count them for each case
		int caseCount[] = new int[n];
		for (int f : fas) // each number
		{
			for (int tn=0;tn<n;tn++) // each case
			{
				if (f >= cases[tn][0] && f <= cases[tn][1])
				{
					caseCount[tn]++;
				}
			}
		}
		
		for (int tn=0;tn<n;tn++) // each case
		{
			System.out.println("Case #"+(tn+1)+": "+caseCount[tn]);
		}
	}
	
	static int[] getFAS(int a, int b)
	{
		int x = (int) Math.sqrt(a);
		int y = (int) Math.sqrt(b);
		ArrayList<Integer> fas = new ArrayList<Integer>();
		
		for (int i=x;i<=y;i++)
		{
			if (palindrome(i) && palindrome(i*i))
			{
				fas.add(i*i);
			}
		}
		
		int[] ii = new int[fas.size()];
		int i=0;
		for (int f : fas)
		{
			ii[i++] = f;
		}
		return ii;
	}
	
	static boolean palindrome(int n)
	{
		char[] num = (n+"").toCharArray();
		for (int i=0, j=num.length-1;i<num.length;i++,j--)
		{
			if (num[i] != num[j])
			{
				return false;
			}
		}
		
		return true;
	}
}
