import java.util.ArrayList;
import java.util.Scanner;

public class FairAndSquare
{
	public static void main(String[] args)
	{
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		long[][] cases = new long[n][2];
		
		// save time, combine cases!
		long min = 0;
		long max = 0;
		
		// first case:
		cases[0][0] = sc.nextLong();
		cases[0][1] = sc.nextLong();
		min = cases[0][0];
		max = cases[0][1];
		
		// second to nth case:
		for (int tn=1;tn<n;tn++)
		{
			cases[tn][0] = sc.nextLong();
			cases[tn][1] = sc.nextLong();			

			if (cases[tn][0] < min)
			{
				min = cases[tn][0];
			}
			
			if (cases[tn][1] > max)
			{
				max = cases[tn][1];
			} 
		}
		sc.close();
		
		long[] fas = getFAS(min, max); // get all fas numbers
		
		// count them for each case
		int caseCount[] = new int[n];
		for (long f : fas) // each number
		{
			for (int tn=0;tn<n;tn++) // each case
			{
				if (f >= cases[tn][0] && f <= cases[tn][1])
				{
					caseCount[tn]++;
				}
			}
		}
		
		for (int tn=0;tn<n;tn++) // each case
		{
			System.out.println("Case #"+(tn+1)+": "+caseCount[tn]);
		}
	}
	
	static long[] getFAS(long a, long b)
	{
		long x = (long) Math.sqrt(a);
		long y = (long) Math.sqrt(b);
		ArrayList<Long> fas = new ArrayList<Long>();
		
		for (long i=x;i<=y;i++)
		{
			if (palindrome(i) && palindrome(i*i))
			{
				fas.add(i*i);
			}
		}
		
		long[] ii = new long[fas.size()];
		int i=0;
		for (long f : fas)
		{
			ii[i++] = f;
		}
		return ii;
	}
	
	static boolean palindrome(long n)
	{
		char[] num = (n+"").toCharArray();
		for (int i=0, j=num.length-1;i<num.length;i++,j--)
		{
			if (num[i] != num[j])
			{
				return false;
			}
		}
		
		return true;
	}
}
