import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by Corey on 4/9/2016.
 */
public class ProblemD {

    public ProblemD() {

    }

    class Instance {
        int instanceNum;
        int baseWidth;
        int complexity;
        int maxTests;
        boolean possible;
        List<Integer> tilesToCheck;
        public Instance(int instanceNum, int baseWidth, int complexity, int maxTests) {
            this.instanceNum = instanceNum;
            this.baseWidth = baseWidth;
            this.complexity = complexity;
            this.maxTests = maxTests;
            this.possible = true;
            this.tilesToCheck = new ArrayList<Integer>();
        }
        public String makePattern(long p) {
            StringBuilder b = new StringBuilder();
            for (int i = 0; i < baseWidth; ++i) {
                b.append((p & (1 << i)) == 0 ? 'L' : 'G');
            }
            return b.toString();
        }
        public String makeArtwork(String pattern, int complexity) {
            String p = pattern;
            String g = pattern.replace('L', 'G');
            for (int i = 0; i < (complexity - 1); ++i) {
                StringBuilder b = new StringBuilder();
                for (int c = 0; c < p.length(); ++c) {
                    if (p.charAt(c) == 'L') {
                        b.append(pattern);
                    } else {
                        b.append(g);
                    }
                }
                p = b.toString();
            }
            return p;
        }
        public void showArt() {
            for (int i = 0; i < Math.pow(2, baseWidth); ++i) {
                String pattern = makePattern(i);
                System.out.printf("%s %s\n", pattern, makeArtwork(pattern, complexity));
            }
        }
        public void solve() {
            if (maxTests < baseWidth) {
                possible = false;
            } else if (baseWidth == 1) {
                tilesToCheck.add(1);
            } else if (complexity == 1) {
                for (int i = 1; i <= baseWidth; ++i) {
                    tilesToCheck.add(i);
                }
            } else {
                for (int i = 2; i <= baseWidth; ++i) {
                    tilesToCheck.add(i);
                }
            }
        }
        public String formatTilesToCheck() {
            StringBuilder b = new StringBuilder();
            for (int i = 0; i < tilesToCheck.size(); ++i) {
                if (i > 0) {
                    b.append(' ');
                }
                b.append(tilesToCheck.get(i));
            }
            return b.toString();
        }
        public void printSolution() {
            if (possible) {
                System.out.printf("Case #%d: %s\n", instanceNum, formatTilesToCheck());
            } else {
                System.out.printf("Case #%d: IMPOSSIBLE\n", instanceNum);
            }
        }
    }

    public void solveAll(String filename) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(filename)));
        int numInstances = Integer.parseInt(reader.readLine());
        for (int instanceNum = 1; instanceNum <= numInstances; ++instanceNum) {
            String[] fields = reader.readLine().split(" ");
            int baseWidth = Integer.parseInt(fields[0]);
            int complexity = Integer.parseInt(fields[1]);
            int maxTests = Integer.parseInt(fields[2]);
            Instance instance = new Instance(instanceNum, baseWidth, complexity, maxTests);
            instance.solve();
            instance.printSolution();
        }
    }

    public static void main(String args[]) throws IOException {
        String filename = args[0];
        ProblemD problem = new ProblemD();
        problem.solveAll(filename);
    }
}
