import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * Created by Corey on 4/9/2016.
 */
public class ProblemB {

    class Instance {
        int instanceNum;
        String initialState;
        boolean[] state;
        int flips;
        public Instance(int instanceNum, String initialState) {
            this.instanceNum = instanceNum;
            this.initialState = initialState;
            this.state = new boolean[initialState.length()];
            for (int i = 0; i < initialState.length(); ++i) {
                this.state[i] = initialState.charAt(i) == '+';
            }
            this.flips = 0;
        }
        public void solve() {
            while (!isSolved()) {
                //System.out.printf("%d: %d %s\n", instanceNum, flips, getState());
                flip(chooseNumToFlip());
            }
            //System.out.printf("%d: %d %s\n", instanceNum, flips, getState());
        }
        public int chooseNumToFlip() {
            boolean firstState = state[0];
            for (int i = 1; i < state.length; ++i) {
                if (state[i] != firstState) {
                    return i;
                }
            }
            return state.length;
        }
        public void flip(int numToFlip) {
            for (int i = 0; i < numToFlip; ++i) {
                state[i] = !state[i];
            }
            ++flips;
        }
        public boolean isSolved() {
            for (int i = 0; i < state.length; ++i) {
                if (!state[i]) {
                    return false;
                }
            }
            return true;
        }
        public String getState() {
            StringBuilder b = new StringBuilder();
            for (int i = 0; i < state.length; ++i) {
                b.append(state[i] ? '+' : '-');
            }
            return b.toString();
        }
        public String getSolutionLine() {
            return String.format("Case #%d: %d", instanceNum, flips);
        }
    }

    public void solveAll(String filename) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(filename)));
        int numInstances = Integer.parseInt(reader.readLine());
        for (int instanceNum = 1; instanceNum <= numInstances; ++instanceNum) {
            String initialState = reader.readLine();
            Instance instance = new Instance(instanceNum, initialState);
            instance.solve();
            System.out.println(instance.getSolutionLine());
        }
    }

    public static void main(String[] args) throws IOException {
        String filename = args[0];
        ProblemB problem = new ProblemB();
        problem.solveAll(filename);
    }

}
