import java.io.*;
import java.util.Arrays;

/**
 * Created by Corey on 4/9/2016.
 */
public class ProblemA {

    static String FOREVER_CODE = "INSOMNIA";
    static int NUM_DIGITS = 10;
    static int MAX_ITERATIONS = 1000000;
    static char FIRST_DIGIT = '0';

    class Instance {
        int startAt = 0;
        int instanceNum = 0;
        boolean[] seenDigits = new boolean[NUM_DIGITS];
        boolean goesForever = false;
        String lastNumber = "";
        public Instance(int instanceNum, int startAt) {
            this.startAt = startAt;
            this.instanceNum = instanceNum;
            this.goesForever = false;
            this.lastNumber = "";
            for (int i = 0; i < NUM_DIGITS; ++i) {
                seenDigits[i] = false;
            }
        }
        public boolean allDigitsSeen() {
            for (int i = 0; i < NUM_DIGITS; ++i) {
                if (!seenDigits[i]) {
                    return false;
                }
            }
            return true;
        }
        public void solve() {
            if (startAt == 0) {
                goesForever = true;
            } else {
                for (int i = 1; i <= MAX_ITERATIONS; ++i) {
                    lastNumber = Integer.toString(startAt * i);
                    int numberLength = lastNumber.length();
                    for (int c = 0; c < numberLength; ++c) {
                        char digit = lastNumber.charAt(c);
                        int digitIndex = digit - FIRST_DIGIT;
                        seenDigits[digitIndex] = true;
                    }
                    //System.out.printf("%d: %s %s\n", instanceNum, lastNumber, getReadableSeenDigits());
                    if (allDigitsSeen()) {
                        return;
                    }
                }
            }
        }
        public String getReadableSeenDigits() {
            StringBuilder b = new StringBuilder();
            for (int i = 0; i < NUM_DIGITS; ++i) {
                b.append(seenDigits[i] ? '1' : '0');
            }
            return b.toString();
        }
        public String getSolutionLine() {
            String solution = goesForever ? FOREVER_CODE : lastNumber;
            return String.format("Case #%d: %s", instanceNum, solution);
        }
    }

    public ProblemA() {
    }

    public void solveAll(String filename) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(filename)));
        int numInstances = Integer.parseInt(reader.readLine());
        for (int instanceNum = 1; instanceNum <= numInstances; ++instanceNum) {
            String line = reader.readLine();
            int startAt = Integer.parseInt(line);
            Instance instance = new Instance(instanceNum, startAt);
            instance.solve();
            System.out.println(instance.getSolutionLine());
        }
        reader.close();
    }

    public static void main(String args[]) throws IOException {
        ProblemA problem = new ProblemA();
        String filename = args[0];
        problem.solveAll(filename);
    }

}
