import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Arrays;


public class TicTacToe {

	final static boolean debug = false;
	
	static final int symbols[] = new int[1024];
	static {
		symbols['.'] = 0;
		symbols['X'] = 1;
		symbols['O'] = 2;
		symbols['T'] = 3;
	}
	
	public static int check(int[] table, int[] values) {
		
		int check = table[values[0]];
		check &= table[values[1]];
		check &= table[values[2]];
		check &= table[values[3]];		
		if (check == 0)
			return -1;
		
		for (int i : values) {
			if (table[i] == 1)
				return 'X';
			else if (table[i] == 2)
				return 'O';
		}
		System.out.println(Arrays.toString(table));
		System.out.println(Arrays.toString(values));
		throw new RuntimeException("should not ever happen");
	}
	
	public static void main(String[] args) throws Exception {
		String outputFile = args[0] + ".out";
		PrintWriter out = new PrintWriter(new FileWriter(outputFile));
		BufferedReader in = new BufferedReader(new FileReader(new File(args[0])));
		int inputNum = Integer.parseInt(in.readLine());
		for (int i = 1; i <= inputNum; i++) {
			int[] table = new int[16];
			String line = in.readLine() + in.readLine() + in.readLine() + in.readLine();
			in.readLine();
			if (debug)
				System.out.println(line);
			
			for (int j = 0; j < 16; j++) {
				int sym = line.charAt(j);
				table[j] = symbols[sym];
				if (debug)
					System.out.print(table[j]);
			}
			if (debug)
				System.out.println();
			
			out.print("Case #" + i + ": ");
			
			//test diagonal left
			// n+5
			int val = check(table, new int[] {0, 5, 10, 15});
			if(val != -1) {
				out.println((char) val + " won");
				continue;
			}
			//test diagonal right
			// 4+(n + 3)
			val = check(table, new int[] {3, 6, 9, 12});
			if(val != -1) {
				out.println((char) val + " won");
				continue;
			}
			
			//test horizon
			// (n + 1)
			val = check(table, new int[] {0, 1, 2, 3});
			if(val != -1) {
				out.println((char) val + " won");
				continue;
			}
			val = check(table, new int[] {4, 5, 6, 7});
			if(val != -1) {
				out.println((char) val + " won");
				continue;
			}
			val = check(table, new int[] {8, 9, 10, 11});
			if(val != -1) {
				out.println((char) val + " won");
				continue;
			}
			val = check(table, new int[] {12, 13, 14, 15});
			if(val != -1) {
				out.println((char) val + " won");
				continue;
			}			
			
			//test vertical
			// (n + 4)
			val = check(table, new int[] {0, 4, 8, 12});
			if(val != -1) {
				out.println((char) val + " won");
				continue;
			}	
			val = check(table, new int[] {1, 5, 9, 13});
			if(val != -1) {
				out.println((char) val + " won");
				continue;
			}	
			val = check(table, new int[] {2, 6, 10, 14});
			if(val != -1) {
				out.println((char) val + " won");
				continue;
			}	
			val = check(table, new int[] {3, 7, 11, 15});
			if(val != -1) {
				out.println((char) val + " won");
				continue;
			}
			if (line.contains(".")) {
				out.println("Game has not completed");
			}
			else {
				out.println("Draw");
			}
			if (debug)
				System.out.println();
		}
		out.close();
	}
}
