package codejam.bottrust;

import java.io.File;
import java.util.Scanner;
import java.util.StringTokenizer;

public class BotTrust {

	static final int BLUE = 0;
	static final int ORANGE = 1;
	
	int[] nextPosition = new int[2];
	
	int maxButton;

	int[] botPositions = new int[2];
	
	BotPosition[] orders;
	int currentOrder;
	
	public BotTrust(int n, BotPosition[] post) {
		maxButton = n;
		orders = post;
		
		for (int i = 0; i < botPositions.length; i++) {
			botPositions[i] = 1;
		}
	}

	static String getBot(int botNo) {
		return botNo == BotTrust.BLUE ? "B" : "O";
	}
	
	public int go() {
		int time = 0;
		
		while (true) {
			time++;
			int botPresssed = -1;
			BotPosition o = orders[currentOrder];
			// is button pressable?
			for (int botNo = 0; botNo < 2; botNo++) {
				//log("check botton can be pressed by %d?\n", botNo);
				if (isMyTurn(o, botNo)) {
					botPresssed = botNo; // yes.. I pressed it then i do nothing in the below action
					log("%s Pressed at %d.\n", BotTrust.getBot(botNo) , o.position);
					currentOrder++;
					log("%s is the current order\n", o);
					break;
				}
			}
			if (currentOrder == orders.length) return time;
			
			for (int botNo = 0; botNo < 2; botNo++) {
				if (botPresssed == botNo) continue;
				o = orders[currentOrder];
				boolean myturn = isMyTurn(o, botNo);
				int botPosition = botPositions[botNo];
				
				// determine action if pressed and myturn i will do nothing
				if (botPresssed != -1 && myturn) {
					// stay
					log("%s Stay at %d.\n", BotTrust.getBot(botNo) , botPosition);
					continue;
				}
				
				// if find nextbutton of each bot.
				for (int i = currentOrder; i < orders.length; i++) {
//					log("%s(%d) looking forward at %s\n", BotTrust.getBot(botNo) ,botPosition, o);
					BotPosition bp = orders[i];
					if (bp.bot == botNo) {
						if (bp.position > botPosition) {
							botPosition++;
							log("%s Move to %d.\n", BotTrust.getBot(botNo) , botPosition);
						}
						else if (bp.position < botPosition) {
							botPosition--;
							log("%s Move to %d.\n", BotTrust.getBot(botNo) , botPosition);
						}
						else {
							log("%s Stay at %d.\n", BotTrust.getBot(botNo) , botPosition);
						}
						botPositions[botNo] = botPosition;
						break;
					}
				}
			}
		}
	}
	
	static void log(String s, Object... args) {
//		System.out.printf(s, args);
	}
	
	public static void main(String[] args) throws Exception {
		Scanner s = new Scanner(new File(args[0]));
		int maxNumberOfButton = Integer.parseInt(args[1]); 
		int n = Integer.parseInt(s.nextLine());
		for (int i = 1; i <= n; i++) {
			String line = s.nextLine();
			BotPosition[] inputLine = createInputLine(line);
			
			BotTrust bt = new BotTrust(maxNumberOfButton, inputLine);
			System.out.printf("Case #%d: %d\n", i, bt.go());
		}
	}
	
	static BotPosition[] createInputLine(String input) {
		StringTokenizer tokenizer = new StringTokenizer(input);
		int n = Integer.parseInt(tokenizer.nextToken());
		BotPosition[] posts = new BotPosition[n];
		for (int i = 0; i < n; i++) {
			posts[i] = new BotPosition();
			posts[i].bot = tokenizer.nextToken().equals("O") ? 1 : 0;
			posts[i].position = Integer.parseInt(tokenizer.nextToken());
		}
		return posts;
	}
	boolean isMyTurn(BotPosition o, int botNo) {
		return o.bot == botNo && o.position == botPositions[botNo];
	}
}

class BotPosition {
	int bot;
	int position;
	
	public String toString() {
		return BotTrust.getBot(bot) + " " + position; 
	}
}