import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;



public class FairAndSquare {

	private static HashMap<Long, Long> reverzCache = new HashMap<Long, Long>(); 
	
	private static boolean debug = true;
	
	public static long reverz(long n) {
		Long cached = reverzCache.get(n);
		if (cached != null) 
			return cached;
		
		int k= (int) Math.floor(Math.log(n) / Math.log(10)) + 1;

		long[] dign= new long[k];
		dign[0]= (long) Math.floor(n/Math.pow(10,k-1));
		int i=1;
		for(i=1;i<k;i++) {
			dign[i]=(long) (Math.floor(n/Math.pow(10,k-i-1)))%10;
		}

		long sum=0;
		for (i=0;i<k;i++) {
			sum = sum + dign[i] * (long) Math.pow(10,i);
		}
		reverzCache.put(n, sum);
		return sum;
	}	

	public static boolean isplndrms(long n) {
		long ceil = (long) Math.ceil(Math.sqrt(n));
		long floor = (long) Math.floor(Math.sqrt(n));
		return (n - reverz(n) == 0) && (ceil - floor == 0) && (ceil - reverz(ceil) == 0);
	}
	
	
	public static long findplndrms(long a, long b) {
		
		long i=a;
		ArrayList<Long> list = new ArrayList<Long>();
		long ct=0;
		for(i=a;i<=b;i++) {
			if (isplndrms(i)) {
//				System.out.println("i=" + i);
//				System.out.println("sqr=" + (long) Math.ceil(Math.sqrt(i)));
				list.add(i);
				ct++;
			}
		}
		if (debug) {
			System.out.println("Count: " + ct);
			System.out.println(list);
		}
		return ct;
	}

	public static void main(String[] args) throws Exception {

		String outputFile = args[0] + ".out";
		PrintWriter out = new PrintWriter(new FileWriter(outputFile));
		BufferedReader in = new BufferedReader(new FileReader(new File(args[0])));
		int inputNum = Integer.parseInt(in.readLine());
		for (int i = 1; i <= inputNum; i++) {
			String[] tokens = in.readLine().split(" ");
			long lowerBound = Integer.parseInt(tokens[0]);
			long upperBound = Integer.parseInt(tokens[1]);
			
			out.printf("Case #%d: %d\n", i, findplndrms(lowerBound, upperBound));
		}
		out.close();
		in.close();
	}
}
