package codejam.candysplitting;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

class NotableToCheatException extends Exception {
	
}

public class CandySplitting {

	CandySplitting() {
		
	}
	
	int split(List<Integer> candies) throws NotableToCheatException {
		int max = 0;
		for (int pStartIndex = 0; pStartIndex < candies.size() ; pStartIndex++) {
//			System.out.println("pStartIndex = " + pStartIndex);
			for (int pSize = 1; pSize <= candies.size() - 1; pSize++) {
				ArrayList<Integer> pPile = new ArrayList<Integer>();
				ArrayList<Integer> sPile = new ArrayList<Integer>(candies);
//				System.out.println("pSize = " + pSize);
				int removeIndex = pStartIndex;
				while (pPile.size() < pSize) {
					if (removeIndex >= sPile.size()) {
						removeIndex = removeIndex % sPile.size();
//						System.out.println("removeIndex % pSize = " + removeIndex);
					}
					pPile.add(sPile.remove(removeIndex));
				}
				int sc = sCal(sPile);
				int pc = pCal(pPile);
				
				if (sc == sCal(pPile) && pc >= pCal(sPile) && pc > max) {
//					System.out.println("P " + pPile + " = " + pCal(pPile));
//					System.out.println("S " + sPile + " = " + sCal(sPile));
//					System.out.printf("*** %d(%d) >= %d(%d)\n", sc, pCal(sPile), pc, sCal(pPile));
					max = Math.max(pc, max);
				}
			}
		}
//		System.out.println("_______________");
		if (max == 0)
			throw new NotableToCheatException();
		return max;
	}
	
	private int pCal(List<Integer> p) {
		int sum = 0;
		for (int v : p) {
			sum += v;
		}
		return sum;
	}
	
	private int sCal(List<Integer> s) {
		int sum = 0;
		for (int v : s) {
			sum ^= v;
		}
		return sum;
	}
	
	public static void main(String[] args) throws Exception {
		
		Scanner s = new Scanner(new File(args[0]));
		int noCase = Integer.parseInt(s.nextLine());
		for (int i = 1; i <= noCase; i++) {
			int size = Integer.parseInt(s.nextLine());
			ArrayList<Integer> candies = new ArrayList<Integer>(size);
			for (int j = 0; j < size; j++) {
				candies.add(Integer.parseInt(s.next()));
			}
			if (s.hasNextLine()) s.nextLine();
			CandySplitting cs = new CandySplitting();
			try {
				int value = cs.split(candies);
				System.out.printf("Case #%d: %d\n", i, value);
			}
			catch (NotableToCheatException e) {
				System.out.printf("Case #%d: NO\n", i);
			}
			
		}
		s.close();
	}
}
