import java.util.*;

public class A {
    
    public static void main(String[] args) {
        A a = new A();
        Scanner in = new Scanner(System.in);
        int cases = in.nextInt();
        for (int i = 0; i < cases; i++) {
            double[] solved = a.solve(in);
            System.out.printf("Case #%d:\n", i+1);
            for (double d: solved) System.out.println(d);
        }
    }
    
    private double[] solve(Scanner in) {
        int teams = in.nextInt();
        double[] RPIs = new double[teams];
        int[][] results = new int[teams][teams];
        for (int i = 0; i < results.length; i++)
        Arrays.fill(results[i], -1);
        for (int i = 0; i < teams; i++) {
            String currentTeam = in.next();
            for (int j = 0; j < teams; j++) {
                if (i == j) continue;
                if (currentTeam.charAt(j) == '1') results[i][j] = 1;
                else if (currentTeam.charAt(j) == '0')
                    results[i][j] = 0;
            }
        }
        double[] WPs = new double[teams];
        double[] OWPs = new double[teams];
        double[] OOWPs = new double[teams];
        Arrays.fill(OWPs, -1.0);
        Arrays.fill(OOWPs, -1.0);

        for (int i = 0; i < teams; i++) {
            int winCount = 0;
            int totalCount = 0;
            for (int j = 0; j < teams; j++) {
                if (results[i][j] == 0 || results[i][j] == 1) totalCount++;
                if (results[i][j] == 1) winCount++;
            }
            WPs[i] = (double) winCount / (double) totalCount;
        }
        
        
        
        for (int i = 0; i < teams; i++) {
            int opponentcount = 0;
            for (int j = 0; j < teams; j++) {
                if (results[i][j] != -1) opponentcount++;
            }
            double[] AWPs = new double[teams];
            Arrays.fill(AWPs, -1);
            for (int j = 0; j < teams; j++) {
                if (results[i][j] == -1) continue;
                if (i == j) continue;
                int winCount = 0;
                int totalCount = 0;
                for (int k = 0; k < teams; k++) {
                    if (k == j || i == k) continue;
                    if (results[j][k] == 0 || results[j][k] == 1) totalCount++;
                    if (results[j][k] == 1) winCount++;
                }
                AWPs[j] = (double) winCount / (double) totalCount;
            }
            double sum = 0;
            for (int j = 0; j < AWPs.length; j++) if (AWPs[j] != -1) sum += AWPs[j];
            OWPs[i] = (double) sum / (double) opponentcount;
        }
        
        for (int i = 0; i < teams; i++) {
            int opponentcount = 0;
            for (int j = 0; j < teams; j++) {
                if (results[i][j] != -1) opponentcount++;
            }
            double sum = 0;
            for (int j = 0; j < OWPs.length; j++) if (OWPs[j] != -1 && results[i][j] != -1) sum += OWPs[j];
            OOWPs[i] = (double) sum / (double) opponentcount;
        }
       // for (int i = 0; i < teams; i++)
        //    System.out.print(OOWPs[i] + " ");
       // System.out.println();
        for (int i = 0; i < teams; i++) {
            RPIs[i] = 0.25 * WPs[i] + 0.50 * OWPs[i] + 0.25 * OOWPs[i];
        }
        return RPIs;
    }
}