package codejam.CJ2016.R1A;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

public class R1AB {

	private static class Pair<T> {
		public T first;
		public T second;
		public int index;
		
		public Pair(T a, T b, int i) {
			first = a;
			second = b;
			index = i;
		}
	}
	
	private static int compare(int[] o1, int[] o2, int start) {
		for (int k = start; k < o1.length; k++) {
			if (o1[k]!=o2[k]) return o1[k]-o2[k];
		}
		return 0;
	}
	
	private static void addToGrid(int[][] grid, int[] toAdd, int i, int N, boolean isRow) {
		for (int k = 0; k < N; k++) {
			if (isRow) {
				grid[i][k] = toAdd[k];
			} else {
				grid[k][i] = toAdd[k];
			}
		}
	}
	
	private static boolean checkCompatibility(int[][] grid, int[] toCheck, int i, int N, boolean isRow, boolean complete) {
		boolean compatible = true;
		for (int k = 0; k < i && compatible; k++) {
			if (isRow) {
				compatible = grid[i][k]==0 || grid[i][k] == toCheck[k];
			} else {
				compatible = grid[k][i]==0 || grid[k][i] == toCheck[k];
			}
		}
		if (complete) {
			for (int k = i+1; k < N && compatible; k++) {
				if (isRow) {
					compatible = grid[i][k]==0 || grid[i][k] == toCheck[k];
				} else {
					compatible = grid[k][i]==0 || grid[k][i] == toCheck[k];
				}
			}
		}
		return compatible;
	}
	
	public static void main(String[] args){
		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		for(int i=1; i<=t; i++){
			int N = in.nextInt();
			LinkedList<int[]> lists = new LinkedList<>();
			for (int k = 0; k< 2*N-1; k++) {
				int[] list = new int[N];
				for (int l = 0; l < N; l++) {
					list[l] = in.nextInt();
				}
				lists.add(list);
			}
			lists.sort((a,b) -> compare(a,b,0));
			int missing = -1;
			//System.err.println("Size of lists: " + lists.size());
			List<Pair<int[]>> levelPairs = new ArrayList<>(N);
			for (int k = 0; k < N; k++) {
				//System.err.println("k=" + k);
				int[] small = lists.poll();
				int[] large = null;
				if (k < N-1 || missing!=-1) {
					large = lists.peek();
					if (large[k] == small[k]) {
						lists.poll();
					} else {
						large = null;
						missing = k;
					}
				} else {
					missing = N-1;
				}
				levelPairs.add(new Pair<>(small, large, k));
				final int start = k+1;
				lists.sort((a,b) -> compare(a,b,start));
			}
			System.err.println("missing=" + missing);			
			System.out.print("Case #" + i + ":");
			for (int k = 0; k < N; k++) {
				int toOut;
				if (missing == k) {
					toOut = levelPairs.get(k).first[k];
				} else {
					if (levelPairs.get(k).first[missing] == levelPairs.get(missing).first[k]) {
						toOut = levelPairs.get(k).second[missing];
					} else {
						toOut = levelPairs.get(k).first[missing];
					}
				}
				System.out.print(" " + toOut);
			}
			
			System.out.println();
		}
		
		in.close();
	}
	
//	public static void main(String[] args){
//		Scanner in = new Scanner(System.in);
//		int t = in.nextInt();
//		for(int i=1; i<=t; i++){
//			int N = in.nextInt();
//			LinkedList<int[]> lists = new LinkedList<>();
//			for (int k = 0; k< 2*N-1; k++) {
//				int[] list = new int[N];
//				for (int l = 0; l < N; l++) {
//					list[l] = in.nextInt();
//				}
//				lists.add(list);
//			}
//			lists.sort((a,b) -> compare(a,b,0));
//			int missing = -1;
//			int[][] finalGrid = new int[N][N];
//			//System.err.println("Size of lists: " + lists.size());
//			List<Pair<int[]>> levelPairs = new LinkedList<>();
//			for (int k = 0; k < N; k++) {
//				//System.err.println("k=" + k);
//				int[] small = lists.poll();
//				int[] large = null;
//				if (k < N-1 || missing!=-1) {
//					large = lists.peek();
//					if (large[k] == small[k]) {
//						lists.poll();
//					} else {
//						large = null;
//						missing = 2*N + k; // k-th element, still dunno if row or collumn
//					}
//				} else {
//					missing = 3*N-1;
//				}
//				if (k == 0) {
//					addToGrid(finalGrid, small, 0, N, true);
//					if (large!= null) {
//						addToGrid(finalGrid, large, 0, N, false);
//					} else {
//						missing = N; // missing collumn with index 0
//					}
//				} else {
//					// Now we should try to match with potential collumn or row
//					if (large != null && compare(small,large, 0)==0) {
//						// both are equal, no brainer
//						addToGrid(finalGrid, small, k, N, true);
//						addToGrid(finalGrid, large, k, N, false);
//					} else {
//						// check small compatibility with known elements
//						boolean rowCompat = checkCompatibility(finalGrid, small, k, N, true, false);
//						boolean collumnCompat = checkCompatibility(finalGrid, small, k, N, true, false);
//						if (rowCompat && !collumnCompat) {
//							addToGrid(finalGrid, small, k, N, true);
//							if (large != null) {
//								addToGrid(finalGrid, large, k, N, false);
//							} else {
//								missing = N + k; // missing collumn with index k
//							}
//						} else if (collumnCompat && !rowCompat) {
//							addToGrid(finalGrid, small, k, N, false);
//							if (large != null) {
//								addToGrid(finalGrid, large, k, N, true);
//							} else {
//								missing = k; // missing row with index k
//							}
//						} else {
//							// now we must have both rowCompat and collumnCompat true
//							if (large != null) {
//								rowCompat = checkCompatibility(finalGrid, large, k, N, true, false);
//								collumnCompat = checkCompatibility(finalGrid, large, k, N, true, false);
//								if (rowCompat && !collumnCompat) {
//									addToGrid(finalGrid, large, k, N, true);
//									addToGrid(finalGrid, small, k, N, false);
//								} else if (collumnCompat && !rowCompat) {
//									addToGrid(finalGrid, large, k, N, false);
//									addToGrid(finalGrid, small, k, N, true);
//								} else {
//									levelPairs.add(new Pair<>(small, large, k));
//								}
//							} else {
//								levelPairs.add(new Pair<>(small, large, k));
//							}
//						}
//					}
//				}
//				final int start = k+1;
//				lists.sort((a,b) -> compare(a,b,start));
//			}
//			System.err.println("missing=" + missing);
////			while (!levelPairs.isEmpty()) {
////				System.err.println("" + levelPairs.size() + " pairs left");
////				for (Pair<int[]> pair : levelPairs) {
////					boolean rowCompat = checkCompatibility(finalGrid, pair.first, pair.index, N, true, true);
////					boolean collumnCompat = checkCompatibility(finalGrid, pair.first, pair.index, N, false, true);
////					if (rowCompat && !collumnCompat) {
////						addToGrid(finalGrid, pair.first, pair.index, N, true);
////						if (pair.second != null) {
////							addToGrid(finalGrid, pair.second, pair.index, N, false);
////						} else {
////							missing = N + pair.index;
////						}
////						levelPairs.remove(pair);
////					} else if (collumnCompat && !rowCompat) {
////						addToGrid(finalGrid, pair.first, pair.index, N, false);
////						if (pair.second != null) {
////							addToGrid(finalGrid, pair.second, pair.index, N, true);
////						} else {
////							missing = pair.index;
////						}
////						levelPairs.remove(pair);
////					} else {
////						// now we must have both rowCompat and collumnCompat true
////						if (pair.second != null) {
////							rowCompat = checkCompatibility(finalGrid, pair.second, pair.index, N, true, true);
////							collumnCompat = checkCompatibility(finalGrid, pair.second, pair.index, N, true, true);
////							if (rowCompat && !collumnCompat) {
////								addToGrid(finalGrid, pair.second, pair.index, N, true);
////								addToGrid(finalGrid, pair.first, pair.index, N, false);
////								levelPairs.remove(pair);
////							} else if (collumnCompat && !rowCompat) {
////								addToGrid(finalGrid, pair.second, pair.index, N, false);
////								addToGrid(finalGrid, pair.first, pair.index, N, true);
////								levelPairs.remove(pair);
////							}
////						}
////					}
////				}
////			}
//			
//			System.out.print("Case #" + i + ":");
//			if (missing < N) {
//				for (int k = 0; k < N; k++) {
//					System.out.print(" " + finalGrid[missing][k]);
//				}
//			} else if (missing < 2*N) {
//				for (int k = 0; k < N; k++) {
//					System.out.print(" " + finalGrid[k][missing - N]);
//				}
//			}
//			
//			System.out.println();
//		}
//		
//		in.close();
//	}
}
