package google.jam.qualificationround2009;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

public class Watersheds {

	public static void main(String[] args) throws Exception {
		new Watersheds().run();
	}
	
	static int[] dx = new int[]{-1,0,0,1};
	static int[] dy = new int[]{0,-1,1,0};
	public void run() throws Exception{
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream("c:\\B-large.in")));
		PrintWriter pw = new PrintWriter("c:\\B-large.out");
		int tests = Integer.parseInt(br.readLine());
		int ca = 1;
		String str = "";
		while(tests-- > 0){
			str = br.readLine();
			String[] strs = str.split("\\s+");
			int H = Integer.parseInt(strs[0]);
			int W = Integer.parseInt(strs[1]);
			Cell[][] cells = new Cell[H][W];
			for(int i = 0; i < H; i++){
				String[] temp = br.readLine().split("\\s+");
				for(int j = 0; j < W; j++){
					if(i == 0 && j == 0){
						cells[i][j] = new Cell(Integer.parseInt(temp[j]), 'a');
					}else cells[i][j] = new Cell(Integer.parseInt(temp[j]));
				}
			}
			
			List<Cell> sins = new ArrayList<Cell>();
			for(int i = 0; i < H; i++){
				for(int j = 0; j < W; j++){
					Cell cell = cells[i][j];
					Cell low = null;
					for(int k = 0; k < 4; k++){
						int yx = i + dx[k];
						int yy = j + dy[k];
						if(yx < 0 || yx >= H || yy < 0 || yy >= W) continue;
						Cell tempCell = cells[yx][yy];
						if(tempCell.sco < cell.sco){						
							if(low == null) low = tempCell;
							else{
								if(low.sco > tempCell.sco) low = tempCell;
							}
						}
					}
					if(low == null) sins.add(cell);
					else{
						cell.next = low;
						low.per.add(cell);
					}
				}
			}
			
			markA(cells[0][0]);
			char tc = 'b';
			for(int i = 0; i < sins.size(); i++){
				Cell cell = sins.get(i);
				if (cell.lab == null) {
					cell.lab = tc++;
					mark(cell);
				}else mark(cell);		
			}
			pw.println("Case #" + (ca++) + ":");
			for(int i = 0; i < cells.length; i++){
				for(int j  = 0; j < cells[i].length; j++){
					Cell cell = cells[i][j];
					if(j < cells[i].length  - 1){
						pw.print(cell.lab + " ");
					}else{
						pw.println(cell.lab);
					}
				}
			}
			
		}
		pw.close();
		
	}
	
	void markA(Cell cell){
		Cell nextCell = cell.next;
		if(nextCell != null && nextCell.lab == null){
			nextCell.lab = cell.lab;
			markA(nextCell);
		}
		List<Cell> perCells = cell.per;
		if(perCells != null){
			for(int i = 0 ; i< perCells.size(); i++){
				Cell perCell = perCells.get(i);
				if(perCell.lab != null) continue;
				perCell.lab = cell.lab;
				markA(perCell);
			}
		}
	}
	
	void mark(Cell cell){
		List<Cell> perCells = cell.per;
		if(perCells != null){
			for(int i = 0 ; i< perCells.size(); i++){
				Cell perCell = perCells.get(i);
				if(perCell.lab != null) continue;
				perCell.lab = cell.lab;
				mark(perCell);
			}
		}
	}
	
	class Cell{
		Cell next;
		List<Cell> per;
		int sco;
		Character lab;
		Cell(int sco){
			this.sco = sco;
			per = new ArrayList<Cell>();
		}
		Cell(int sco, Character lab){
			this(sco);
			this.lab = lab;
		}
	}

}
