package dijkstra;

public class Quaternion {
	/**Represents value of quaternion in following way:
	 * 1 or -1 : exact values
	 * 2 : i (-2 : -i)
	 * 3 : j (-3 : -j)
	 * 4 : k (-4 : -k)
	 */
	private int value;
	
	public Quaternion(char val) {
		switch (val) {
		case 'i': value = 2; break;
		case 'j': value = 3; break;
		case 'k': value = 4; break;
		}
	}
	
	private Quaternion(int value) {
		this.value = value;
	}
	
//	private Quaternion() {
//		this(1);
//	}
	
	public Quaternion multiply(Quaternion b) {
		boolean isNegative = (this.value > 0) != (b.value > 0);
		int absThis = Math.abs(this.value);
		int absB = Math.abs(b.value);
		if (absThis == 1) {
			if (isNegative) absB *= -1;
			return new Quaternion(absB);
		}
		if (absB == 1) {
			if (isNegative) absThis *= -1;
			return new Quaternion(absThis);
		}
		if (absThis == 2) {
			int res = 0;
			switch (absB) {
			case 2: res = -1; break;
 			case 3: res = 4; break;
 			case 4: res = -3; break;
			}
			if (isNegative) res *= -1;
			return new Quaternion(res);
		}
		if (absThis == 3) {
			int res = 0;
			switch (absB) {
			case 2: res = -4; break;
 			case 3: res = -1; break;
 			case 4: res = 2; break;
			}
			if (isNegative) res *= -1;
			return new Quaternion(res);
		}
		//if (absThis == 4) {
			int res = 0;
			switch (absB) {
			case 2: res = 3; break;
 			case 3: res = -2; break;
 			case 4: res = -1; break;
			}
			if (isNegative) res *= -1;
			return new Quaternion(res);
		//}
	}
	
	public boolean isI() {
		return (this.value == 2);
	}
	
	public boolean isJ() {
		return (this.value == 3);
	}
	
	public boolean isK() {
		return (this.value == 4);
	}
}
