import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Main {
	private static String inputO = "src/input";
	private static String inputS = "src/A-small-attempt0.in";
	private static String inputL = "";
	
	public static void main (String[] args) {
		
		BufferedReader br;
		try {
			File outputFile = new File("src/output.txt");
			// if file doesnt exists, then create it
			if (!outputFile.exists()) {
				outputFile.createNewFile();
			}
			FileWriter fw = new FileWriter(outputFile.getAbsoluteFile());
			BufferedWriter bw = new BufferedWriter(fw);
			
			br = new BufferedReader(new FileReader(inputS));
			String line = br.readLine();
			
			int numberOfTestCase = Integer.parseInt(line);
			for (int i = 0; i < numberOfTestCase; i++) {
				int[][] arrangement1 = new int[4][4];
				int[][] arrangement2 = new int[4][4];
				
				int row1 = Integer.parseInt(br.readLine());
				
				for (int j = 0; j < 4; j++) {
					String arrangementLine = br.readLine();
					String[] arrangementStr = arrangementLine.split(" ");
					for (int k = 0; k < 4; k++) {
						arrangement1[j][k] = Integer.parseInt(arrangementStr[k]);
					}
				}
				
				int row2 = Integer.parseInt(br.readLine());

				for (int j = 0; j < 4; j++) {
					String arrangementLine = br.readLine();
					String[] arrangementStr = arrangementLine.split(" ");
					for (int k = 0; k < 4; k++) {
						arrangement2[j][k] = Integer.parseInt(arrangementStr[k]);
					}
				}
				
				
				int[] row1Array = new int[4];
				for (int i1 = 0; i1 < 4; i1++) {
					row1Array[i1] = arrangement1[row1-1][i1];
				}
				
				int[] row2Array = new int[4];
				for (int i2 = 0; i2 < 4; i2++) {
					row2Array[i2] = arrangement2[row2-1][i2];
				}
				
				int result = arrayComparison(row1Array, row2Array);
				System.out.println(result);

				int caseNumber = i + 1;
				switch (result) {
					case -1: 
						bw.write("Case #" + caseNumber + ": Bad magician!");
						break;
					case 0:
						bw.write("Case #" + caseNumber + ": Volunteer cheated!");
						break;
					default:
						bw.write("Case #" + caseNumber + ": " + result);
						break;
				}
				
//				for (int ii = 0; ii<4;ii++) {
//					System.out.print(row1Array[ii] + " ");
//				}
//				System.out.println();
//				for (int ii = 0; ii<4;ii++) {
//					System.out.print(row2Array[ii] + " ");
//				}
//				System.out.println();
//				System.out.println("=====");
//				System.out.println(row1 + " " + row2);
				
//				for (int ii = 0; ii<4;ii++) {
//					for (int jj=0;jj<4;jj++) {
//						System.out.print(arrangement1[ii][jj] + " ");
//					}
//					System.out.println();
//				}
//				
//				for (int ii = 0; ii<4;ii++) {
//					for (int jj=0;jj<4;jj++) {
//						System.out.print(arrangement2[ii][jj] + " ");
//					}
//					System.out.println();
//				}
//				System.out.println("=======");
				
				
				
				bw.newLine();
			}
			bw.close();
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	
	public static int arrayComparison (int[] array1, int[] array2) {
		int count = 0;
		int picked = 0;
		for (int i = 0; i < array1.length; i++) {
			for (int j = 0; j < array2.length; j++) {
				if (array1[i] == array2[j]) {
					picked = array1[i];
					count++;
					break;
				}
			}
			
		}
		
		if (count>1) {
			count = -1;
		} else if (count == 1) {
			count = picked;
		}
		return count;
	}
}
