import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;


public class Main {
	
	public static void main (String[] args) {
		BufferedReader br;
		try {
			File outputFile = new File("src/output.txt");
			// if file doesnt exists, then create it
			if (!outputFile.exists()) {
				outputFile.createNewFile();
			}
			FileWriter fw = new FileWriter(outputFile.getAbsoluteFile());
			BufferedWriter bw = new BufferedWriter(fw);
			
			br = new BufferedReader(new FileReader("src/A-small-attempt1.in"));
			StringBuilder sb = new StringBuilder();
			String line = br.readLine();
			
			int numberOfTestCase = Integer.parseInt(line);
			
			for (int i = 0; i < numberOfTestCase; i++) {
				ArrayList<String> inputs = new ArrayList<String>();
				int gameState = 0; // 0 - draw, 1 - Game not completed, 2 - X won, 3 - O won
				
				String input1 = br.readLine();
				inputs.add(input1);
				String input2 = br.readLine();
				inputs.add(input2);
				String input3 = br.readLine();
				inputs.add(input3);
				String input4 = br.readLine();
				inputs.add(input4);
				
				br.readLine(); // Read the empty line.
				
				String inputV1 = input1.substring(0, 1) + input2.substring(0, 1) + input3.substring(0, 1) + input4.substring(0, 1);
				inputs.add(inputV1);
				
				String inputV2 = input1.substring(1, 2) + input2.substring(1, 2) + input3.substring(1, 2) + input4.substring(1, 2);
				inputs.add(inputV2);
				
				String inputV3 = input1.substring(2, 3) + input2.substring(2, 3) + input3.substring(2, 3) + input4.substring(2, 3);
				inputs.add(inputV3);
				
				String inputV4 = input1.substring(3, 4) + input2.substring(3, 4) + input3.substring(3, 4) + input4.substring(3, 4);
				inputs.add(inputV4);
				
				String inputC1 = input1.substring(0, 1) + input2.substring(1, 2) + input3.substring(2, 3) + input4.substring(3, 4);
				inputs.add(inputC1);
				
				String inputC2 = input1.substring(3, 4) + input2.substring(2, 3) + input3.substring(1, 2) + input4.substring(0, 1);
				inputs.add(inputC2);
				
				for (int j = 0; j < inputs.size(); j++) {
					String inputCurr = inputs.get(j);
					if (inputCurr.contains(".")) {
						gameState = 1;
						continue;
					}
					
					if (inputCurr.contains("T")) {
						inputCurr = inputCurr.replace("T", "");
						if (inputCurr.contains("X") && !inputCurr.contains("O")) {
							gameState = 2;
							break;
						} else if (!inputCurr.contains("X") && inputCurr.contains("O")) {
							gameState = 3;
							break;
						} else {
							continue;
						}
					} else {
						if (inputCurr.contains("X") && !inputCurr.contains("O")) {
							gameState = 2;
							break;
						} else if (!inputCurr.contains("X") && inputCurr.contains("O")) {
							gameState = 3;
							break;
						} else {
							continue;
						}
					}
				}

				int index = i + 1;
				switch (gameState) {
				case 0:
					bw.write("Case #" + index + ": Draw");
					bw.newLine();
					break;
				case 1:
					bw.write("Case #" + index + ": Game has not completed");
					bw.newLine();
					break;
				case 2:
					bw.write("Case #" + index + ": X won");
					bw.newLine();
					break;
				case 3:
					bw.write("Case #" + index + ": O won");
					bw.newLine();
					break;
					
				}
			}
			
			bw.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
