import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Main {
	public static void main (String[] args) {
		
		BufferedReader br;
		try {
			File outputFile = new File("src/output.txt");
			// if file doesnt exists, then create it
			if (!outputFile.exists()) {
				outputFile.createNewFile();
			}
			FileWriter fw = new FileWriter(outputFile.getAbsoluteFile());
			BufferedWriter bw = new BufferedWriter(fw);
			
			br = new BufferedReader(new FileReader("src/B-large.in"));
			String line = br.readLine();
			
			int numberOfTestCase = Integer.parseInt(line);
			for (int i = 0; i < numberOfTestCase; i++) {
				boolean casePass = true;
				String dimension = br.readLine();
				String[] NM = dimension.split(" ");
				int N = Integer.parseInt(NM[0]);
				int M = Integer.parseInt(NM[1]);

				int[][] NArrayList = new int[N][M];
				for (int j = 0; j < N; j++ ) {
					String currLine = br.readLine();
					String[] currLineNumbers = currLine.split(" ");
					for (int k = 0; k < M; k++) {
						NArrayList[j][k] = Integer.parseInt(currLineNumbers[k]);
					}
				}
				
				
				for (int n = 0; n < N; n++) {
					for (int m = 0; m < M; m++) {
						boolean leftBlocked = false, rightBlocked = false, topBlocked = false, botBlocked = false;
						int currInt = NArrayList[n][m];
						for (int mm = 0; mm < m; mm++) {
							if (currInt < NArrayList[n][mm]) {
								leftBlocked = true;
								break;
							}
						}
						for (int mm = m; mm < M; mm++) {
							if (currInt < NArrayList[n][mm]) {
								rightBlocked = true;
								break;
							}
						}
						
						for (int nn = 0; nn < n; nn++) {
							if (currInt < NArrayList[nn][m]) {
								topBlocked = true;
								break;
							}
						}
						for (int nn = n; nn < N; nn++) {
							if (currInt < NArrayList[nn][m]) {
								botBlocked = true;
								break;
							}
						}
						
						if (
								(leftBlocked && topBlocked)
								||
								(leftBlocked && botBlocked)
								||
								(rightBlocked && topBlocked)
								||
								(rightBlocked && botBlocked)
								) {
							casePass = false;
							break;
						}
					}
					if (!casePass) {
						break;
					}
				}
				
				int caseNumber = i + 1;
				if (casePass) {
					bw.write("Case #" + caseNumber + ": YES");
				} else {
					bw.write("Case #" + caseNumber + ": NO");
				}
				bw.newLine();
			}
			bw.close();
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
