import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Main {
	private static String inputO = "src/input";
	private static String inputS = "src/B-small-attempt0.in";
	private static String inputL = "";
	
	public static void main (String[] args) {
		
		BufferedReader br;
		try {
			File outputFile = new File("src/output.txt");
			// if file doesnt exists, then create it
			if (!outputFile.exists()) {
				outputFile.createNewFile();
			}
			FileWriter fw = new FileWriter(outputFile.getAbsoluteFile());
			BufferedWriter bw = new BufferedWriter(fw);
			
			br = new BufferedReader(new FileReader(inputS));
			String line = br.readLine();
			
			int numberOfTestCase = Integer.parseInt(line);
			for (int i = 0; i < numberOfTestCase; i++) {
				String config = br.readLine();
				String[] configs = config.split(" ");
				
				double CbuyFarm = Double.parseDouble(configs[0]);
				double Fextra = Double.parseDouble(configs[1]);
				double Xwin = Double.parseDouble(configs[2]);
				
				double result = computation(CbuyFarm, Fextra, Xwin);
				
				System.out.println(result);
				
				int caseNumber = i + 1;
				bw.write("Case #" + caseNumber + ": " + result);
				
				bw.newLine();
			}
			bw.close();
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	
	public static double computation (double C, double F, double X) {
		double currRate = 2.0;
		
		double t00 = X/currRate; // time to win with 0 farm
		double t1 = C/currRate; // time to buy 1st farm
		
		currRate = F + currRate; // rate after 1st farm
		
		double t01 = X/currRate; // time to win with 1 farm
		
		if (t01 + t1 < t00) {
			return t1 + getFarm(C, F, X, currRate);
		} else {
			return t00;
		}
	}
	
	private static double getFarm (double C, double F, double X, double currRate) {
		double tC = X/currRate; // time to win with current farm
		double tB = C/currRate; // time to buy next farm
		
		currRate = F + currRate; // rate after this farm
		
		double tN = X/currRate; // time to win with next farm
		
		if (tN + tB < tC) {
			return tB + getFarm(C, F, X, currRate);
		} else {
			return tC;
		}
	}
}
