import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Main {
	public static void main (String[] args) {
		
		BufferedReader br;
		try {
			File outputFile = new File("src/output.txt");
			// if file doesnt exists, then create it
			if (!outputFile.exists()) {
				outputFile.createNewFile();
			}
			FileWriter fw = new FileWriter(outputFile.getAbsoluteFile());
			BufferedWriter bw = new BufferedWriter(fw);
			br = new BufferedReader(new FileReader("src/C-small-attempt0.in"));

			String line = br.readLine();
			
			int numberOfTestCase = Integer.parseInt(line);
			for (int i = 0; i < numberOfTestCase; i++) {
				int oututNumber = 0;
				String boundsString = br.readLine();
				String[] boundsInt = boundsString.split(" ");
				int lowerBound = Integer.parseInt(boundsInt[0]);
				int upperBound = Integer.parseInt(boundsInt[1]);

				double sqrtOfLowerBound = Math.sqrt(lowerBound);
				int lowerBoundCeil = (int) Math.ceil(sqrtOfLowerBound);
				
				double sqrtOfUpperBound = Math.sqrt(upperBound);
				int upperBoundFloor = (int) Math.floor(sqrtOfUpperBound);
				
				// All the squares between lowerBoundCeil and upperBoundFloor are in the range. 
				// Check these numbers are palindromes, then check their square. 
				for (int j = lowerBoundCeil; j <= upperBoundFloor; j++) {
					String intString = j + "";
					if (isPalindrome(intString)) {
						int jj = j * j;
						String sqString = jj + "";
						if (isPalindrome(sqString)) {
							oututNumber++;
						}
					}
				}
				
				int caseNumber = i + 1;
				bw.write("Case #" + caseNumber + ": " + oututNumber);
				bw.newLine();
			}
			bw.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public static boolean isPalindrome (String str) {
		boolean isPalindrome = false;
		if (str.length() == 1) {
			return true;
		} else if (str.length() == 2) {
			if ( str.substring(0, 1).equals(str.substring(1, 2)) ) {
				return true;
			} else {
				return false;
			}
		}
		
        if(str.length()%2 == 0){
            for(int i = 0; i <= str.length()/2-1; i++){
                if(!str.substring(i, i + 1).equals(str.substring(str.length()-i-1, str.length()-i))){
                    return false;
                } else {
                	isPalindrome = true;
                }
            }
        } else {
            for(int i = 0; i <= (str.length() - 1)/2 - 1; i++){
                if (!str.substring(i, i + 1).equals(str.substring(str.length()-i-1, str.length()-i))){
                    return false;
                } else {
                	isPalindrome = true;
                }
            }
        }
		return isPalindrome;
	}
}
