package com.dongmyo.codejam;

import java.io.BufferedReader;
import java.io.FileReader;

import java.util.StringTokenizer;

public class Magicka {
	//public static String INPUT_FILE = "input.txt";
	public static String INPUT_FILE = "B-small-attempt2.in";
	
	public static final String DELIM = " ";
	
	private int caseNo;
	
	private int C;
	private String[] arrC;
	
	private int D;
	private String[] arrD;
	
	private int N;
	private String invokes;
	
	private StringBuffer elements = new StringBuffer();
	
	private int combinedIndex = -1;
	
	public Magicka(int caseNo, int C, String[] arrC, int D, String[] arrD, int N, String invokes) {
		this.caseNo = caseNo;
		
		this.C = C;
		this.arrC = arrC;
		
		this.D = D;
		this.arrD = arrD;
		
		this.N = N;
		this.invokes = invokes;
	}
	
	public void solve() {
		for(int i = 0; i < N; i++) {
			elements = elements.append(invokes.charAt(i));

			if(elements.length() >= 2) {
				applyCombine();
			}
			
			if(elements.length() >= 2) {
				applyOpposed();
			}
		}
		
		System.out.print("Case #" + caseNo + ": [");
		
		for(int i = 0; i < elements.length(); i++) {
			System.out.print(elements.charAt(i));
			
			if(i + 1 < elements.length()) {
				System.out.print(", ");
			}
		}
		
		System.out.print("]");
		System.out.println();
		
		return;
	}
	
	protected void applyCombine() {
		if(C < 1) {
			return;
		}
		
		String s = elements.substring(elements.length() - 2, elements.length());
		if(s.charAt(0) > s.charAt(1)) {
			s = new StringBuffer(s.substring(1, 2)).append(s.substring(0, 1)).toString();
		}
		
		for(int i = 0; i < C; i++) {
			if(arrC[i].substring(0, 2).compareTo(s) == 0) {
				elements = elements.delete(elements.length() - 2, elements.length());
				elements.append(arrC[i].substring(2));
				
				combinedIndex = elements.length() - 1;
				
				break;
			}
		}
		
		return;
	}
	
	protected void applyOpposed() {
		if(D < 1) {
			return;
		}
		
		String s = elements.substring(elements.length() - 1);
		
		for(int i = 0; i < D; i++) {
			if(arrD[i].contains(s)) {
				int idx = ((arrD[i].indexOf(s) + 1) % 2);
				String t = arrD[i].substring(idx, idx + 1);
				
				int idx2;
				
				if(combinedIndex < 0) {
					idx2 = elements.indexOf(t);
				}
				else {
					idx2 = elements.indexOf(t, combinedIndex);
				}
				
				if(idx2 >= 0) {
					elements = elements.replace(idx2, elements.length(), "");
				}
				
				break;
			}
		}
		
		return;
	}
	
	public static void main(String[] args) {
		try {
			BufferedReader in = new BufferedReader(new FileReader(INPUT_FILE));
			
			int T = Integer.parseInt(in.readLine());
			
			StringTokenizer st;
			
			String[] arrC = null;
			String[] arrD = null;
			
			for(int i = 0; i < T; i++) {
				String sLine = in.readLine();
				
				st = new StringTokenizer(sLine, Magicka.DELIM);
				
				// C.
				int C = Integer.parseInt(st.nextToken());
				
				if(C > 0) {
					arrC = new String[C];
					
					for(int j = 0; j < C; j++) {
						String s = st.nextToken();
						
						if(s.charAt(0) > s.charAt(1)) {
							arrC[j] = new StringBuffer(s.substring(1, 2)).append(s.substring(0, 1)).append(s.substring(2, 3)).toString();
						}
						else {
							arrC[j] = s;
						}
					}
				}
				
				// D.
				int D = Integer.parseInt(st.nextToken());

				if(D > 0) {
					arrD = new String[D];
					
					for(int j = 0; j < D; j++) {
						arrD[j] = st.nextToken();
					}
				}
				
				// N.
				int N = Integer.parseInt(st.nextToken());
				
				String invokes = st.nextToken();
				
				// solve it.
				new Magicka(i + 1, C, arrC, D, arrD, N, invokes).solve();
			}
			
			in.close();
		}
		catch(Exception e) {}
	}
}
