import java.io.*;
import java.util.*;

public class AlienLang {
//	private static String INPUT_FILE = "input.txt";
//	private static String INPUT_FILE = "A-small-attempt1.in";
	private static String INPUT_FILE = "A-large.in";
	
	private static final String DELIM = " ";
	
	private static final char LPAREN = '(';
	private static final char RPAREN = ')';
	
	private int L;
	
	private String[] dict = null;
	private String[] cases = null;
	
	AlienLang(int L, int D, int N) {
		this.L = L;
		
		dict = new String[D];
		cases = new String[N];
	}
	
	public void setDict(int nIdx, String sWord) {
		dict[nIdx] = sWord;
	}
	
	public void setCase(int nIdx, String sCase) {
		cases[nIdx] = sCase;
	}
	
	public void findPatterns() {
		for(int i = 0; i < cases.length; i++) {
			findPatternOf(i);
		}
		
		return;
	}
	
	protected void findPatternOf(int nIdx) {
		String[] caseList = new String[L];
		
		makeCaseList(cases[nIdx], caseList);
		
		calcPatterns(nIdx, caseList);

		return;
	}
	
	protected void makeCaseList(String sCase, String[] caseList) {
		boolean bOpt = false;
		int nIdx = 0;
		String sOpt = "";

		for(int i = 0; i < sCase.length(); i++) {
			char ch = sCase.charAt(i);
			
			if(bOpt) {
				if(ch == AlienLang.RPAREN) {
					caseList[nIdx] = sOpt;
					nIdx++;
					bOpt = false;
				}
				else {
					sOpt += ch;
				}
			}
			else {
				if(ch == AlienLang.LPAREN) {
					bOpt = true;
					sOpt = "";
				}
				else {
					caseList[nIdx] = Character.toString(ch);
					nIdx++;
				}
			}
		}
			
		return;
	}
	
	protected void calcPatterns(int nIdx, String[] caseList) {
		int nCnt = 0;
		
		for(int i = 0; i < dict.length; i++) {
			boolean bMatch = true;
			
			for(int j = 0; j < dict[i].length(); j++) {
				if(caseList[j].indexOf(dict[i].charAt(j)) < 0) {
					bMatch = false;
					break;
				}
			}
			
			if(bMatch) {
				nCnt++;
			}
		}
		
		System.out.println("Case #" + (nIdx + 1) + ": " + nCnt);
		
		return;
	}
	
	public static void main(String[] args) {
		try {
			BufferedReader in = new BufferedReader(new FileReader(AlienLang.INPUT_FILE));
			
			// L D N.
			String sLine = in.readLine();
			
			StringTokenizer st = new StringTokenizer(sLine, AlienLang.DELIM);
			
			int L = new Integer(st.nextToken()).intValue();
			int D = new Integer(st.nextToken()).intValue();
			int N = new Integer(st.nextToken()).intValue();
			
			AlienLang lang = new AlienLang(L, D, N);
			
			// words.
			for(int i = 0; i < D; i++) {
				lang.setDict(i, in.readLine());
			}
			
			// test cases.
			for(int i = 0; i < N; i++) {
				lang.setCase(i, in.readLine());
			}
			
			in.close();
			
			lang.findPatterns();
		}
		catch(Exception e) {}
	}
}
