package com.dongmyo.gcj;

import java.io.BufferedReader;
import java.io.FileReader;

public class RPI {
	//public static String INPUT_FILE = "input.txt";
	public static String INPUT_FILE = "A-small-attempt0.in";
	
	public static final String DELIM = " ";
	
	private int caseNo;
	private int N;
	private char[][] arr;
	
	private int[] arrWin;
	private int[] arrMatch;

	private char[][] arrOCheck;
	
	private double[] arrOwp;
	
	public RPI(int caseNo, int N, char[][] arr) {
		this.caseNo = caseNo;
		this.N = N;
		this.arr = arr;
		
		this.arrWin = new int[N];
		this.arrMatch = new int[N];

		this.arrOCheck = new char[N][N];
		
		this.arrOwp = new double[N];
	}
	
	public void solve() {
		for(int i = 0; i < N; i++) {
			for(int j = i + 1; j < N; j++) {
				if(arr[i][j] != '.') {
					arrMatch[i]++;
					arrMatch[j]++;
					
					if(arr[i][j] == '1') {
						arrWin[i]++;
						
						arrOCheck[i][j] = '1';
						arrOCheck[j][i] = '2';
					}
					else {
						arrWin[j]++;
						arrOCheck[i][j] = '2';
						arrOCheck[j][i] = '1';
					}
				}
			}
		}

		int count;
		
		for(int i = 0; i < N; i++) {
			arrOwp[i] = 0.0;
			count = 0;
			
			for(int j = 0; j < N; j++) {
				if(arrMatch[j] > 0) {
					
					if(arrOCheck[i][j] == '2') {
						count++;
						arrOwp[i] += ((arrWin[j] - 1.0) / (arrMatch[j] - 1.0));
					}
					else if(arrOCheck[i][j] == '1') {
						count++;
						arrOwp[i] += ((arrWin[j] * 1.0) / (arrMatch[j] - 1.0));
					}
				}
			}
			
			if(count > 0) {
				arrOwp[i] = arrOwp[i] / (count * 1.0);
			}
		}
		
		System.out.println("Case #" + caseNo + ":");
		
		double rpi, oowp;
		
		for(int i = 0; i < N; i++) {
			if(arrMatch[i] == 0) {
				rpi = 0.0;
			}
			else {
				rpi = ((arrWin[i] * 1.0) / arrMatch[i]) * 0.25;
			}
			
			rpi += (arrOwp[i] * 0.5);
			
			oowp = 0.0;
			count = 0;
			
			for(int j = 0; j < N; j++) {
				if(arr[i][j] != '.') {
					oowp += arrOwp[j];
					count++;
				}
			}
			
			if(count > 0) {
				rpi += ((oowp / (count * 1.0)) * 0.25);
			}
			
			System.out.println(rpi);
		}
	}
	
	public static void main(String[] args) {
		try {
			BufferedReader in = new BufferedReader(new FileReader(INPUT_FILE));
			
			int T = Integer.parseInt(in.readLine());
			
			int N;
			char[][] arr;
			
			for(int i = 0; i < T; i++) {
				N = Integer.parseInt(in.readLine());

				arr = new char[N][N];
				
				for(int j = 0; j < N; j++) {
					System.arraycopy(in.readLine().toCharArray(), 0, arr[j], 0, N);
				}
				
				new RPI(i + 1, N, arr).solve();
			}
			
			in.close();
		}
		catch(Exception e) {}
	}
}
