package com.dongmyo.codejam;

import java.io.BufferedReader;
import java.io.FileReader;

import java.util.StringTokenizer;

public class BotTrust {
	//public static String INPUT_FILE = "input.txt";
	//public static String INPUT_FILE = "A-small-attempt0.in";
	public static String INPUT_FILE = "A-large.in";
	
	public static final String DELIM = " ";
	
	private int caseNo;
	private int N;
	private String[] arr;
	
	private int time = 0;
	
	private int[] pos = new int[] { 1, 1 };
	
	public BotTrust(int caseNo, int N, String[] arr) {
		this.caseNo = caseNo;
		this.N = N;
		this.arr = arr;
	}
	
	public void solve() {
		for(int i = 0; i < N; i++) {
			char robot = arr[i].charAt(0);
			int button = Integer.parseInt(arr[i].substring(1));
			
			int idx = ((robot == 'O') ? 0 : 1);
			
			int otherGoButton = otherGoTo(i, robot);  
			
			// move.
			if(pos[idx] < button) {
				while(pos[idx] < button) {
					time++;

					pos[idx]++;
					
					if(otherGoButton > 0) {
						if(pos[(idx + 1) % 2] < otherGoButton) {
							pos[(idx + 1) % 2]++;
						}
						else if(pos[(idx + 1) % 2] > otherGoButton) {
							pos[(idx + 1) % 2]--;
						}
					}
//System.out.println("time: " + time + ", O: " + pos[0] + ", B: " + pos[1]);				
				}
			}
			else if(pos[idx] > button) {
				while(pos[idx] > button) {
					time++;

					pos[idx]--;
					
					if(otherGoButton > 0) {
						if(pos[(idx + 1) % 2] < otherGoButton) {
							pos[(idx + 1) % 2]++;
						}
						else if(pos[(idx + 1) % 2] > otherGoButton) {
							pos[(idx + 1) % 2]--;
						}
					}
//System.out.println("time: " + time + ", O: " + pos[0] + ", B: " + pos[1]);				
				}
			}
			
			// check.
			time++;

			if(otherGoButton > 0) {
				if(pos[(idx + 1) % 2] < otherGoButton) {
					pos[(idx + 1) % 2]++;
				}
				else if(pos[(idx + 1) % 2] > otherGoButton) {
					pos[(idx + 1) % 2]--;
				}
			}
//System.out.println("time: " + time + ", O: " + pos[0] + ", B: " + pos[1]);			
		}
		
		System.out.println("Case #" + caseNo + ": " + time);
		
		return;
	}
	
	protected int otherGoTo(int idx, char robot) {
		int button = 0;
		
		for(int i = idx + 1; i < N; i++) {
			if(arr[i].charAt(0) != robot) {
				button = Integer.parseInt(arr[i].substring(1));
				break;
			}
		}
		
		return button;
	}
	
	public static void main(String[] args) {
		try {
			BufferedReader in = new BufferedReader(new FileReader(INPUT_FILE));
			
			int T = Integer.parseInt(in.readLine());
			
			String sLine;
			StringTokenizer st;
			
			String robot;
			int button;
			
			String[] arr;
			
			for(int i = 0; i < T; i++) {
				sLine = in.readLine();
				
				st = new StringTokenizer(sLine, BotTrust.DELIM);
				
				int N = Integer.parseInt(st.nextToken());
				
				arr = new String[N];
				
				for(int j = 0; j < N; j++) {
					robot = st.nextToken();
					button = Integer.parseInt(st.nextToken());
					
					arr[j] = robot + button;
				}
				
				new BotTrust(i + 1, N, arr).solve();
			}

			in.close();
		}
		catch(Exception e) {}
	}
}
