import java.util.*;
import java.io.*;

public class C {
	private double min = Double.MAX_VALUE;
	public double[] solver(int N, int Q, int[][] adj, int[] E, int[] S, int[][] q) {
		double[] rst = new double[Q];
		
		for(int i = 0; i < Q; i++) {
			//System.out.println(N);
			rst[i] = 1.0 * (double)adj[0][1] / (double)S[i] + dfs(N, 1, 0, E[0] - adj[0][1], E, S, adj, 0);
		}
		return rst;
	}
	
	private double dfs(int N, int curCity, int curHorse, int restDist, int[] E, int[] S, int[][] adj, double time) {
		if (curCity == N-1) return time;
		if (restDist < adj[curCity][curCity+1]) {
			return dfs(N, curCity+1, curCity, E[curCity]-adj[curCity][curCity+1], E, S, adj, time+1.0*(double)adj[curCity][curCity+1] / (double)S[curCity]);
		}
		return Math.min(
		dfs(N, curCity+1, curCity, E[curCity]-adj[curCity][curCity+1], E, S, adj, time+1.0*(double)adj[curCity][curCity+1] / (double)S[curCity]),
		dfs(N, curCity+1, curHorse, restDist-adj[curCity][curCity+1], E, S, adj, time+1.0*(double)adj[curCity][curCity+1] / (double)S[curHorse])
				);
	}

	public static void main(String[] args) {
		C classc = new C();
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
		for (int l = 1; l <= t; ++l) {
			int N = in.nextInt();
			int Q = in.nextInt();
			
			int[] E = new int[N];
			int[] S = new int[N];
			for(int i = 0; i < N; i++) {
				E[i] = in.nextInt();
				S[i] = in.nextInt();
			}
			int[][] adj = new int[N][N];
			for(int i = 0; i < N; i++) {
				for(int j = 0; j < N; j++) {
					adj[i][j] = in.nextInt();
				}
			}
			int[][] query = new int[Q][2];
			for(int i = 0; i< Q; i++) {
				query[i][0] = in.nextInt();
				query[i][1] = in.nextInt();
			}
			double[] rst = classc.solver(N,Q,adj,E,S,query);
			String str = "";
			for(int i = 0;  i< Q; i++) {
				str = str + String.valueOf(rst[i]) + " ";
			}
			System.out.println("Case #" + l + ": "+str.trim());
		}
	}
}

