package com.test;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;


public class CandySplitting
{
	public static void main( String[] args ) throws Exception
	{
		final List<String> testCaseList = loadFile();

		int caseNumber = 1;

		final BufferedWriter writer = new BufferedWriter(new FileWriter(new File("C:\\Users\\brandon.salzberg\\Workspace_Eclipse\\CodeJam\\res\\testOutput.txt")));
		for (String testCaseStr : testCaseList)
		{
			final List<Integer> candyList = loadTestCase(testCaseStr);
			final String result = divideCandy(candyList);

			writer.write("Case #" + caseNumber++ + ": " + result + "\n");
		}

		writer.flush();
		writer.close();
	}

	private static String divideCandy( final List<Integer> candyList ) throws Exception
	{
		Collections.sort(candyList);

		final int totalDumbValue = determineDumbValue(candyList);
		final int totalRealValue = determineRealValue(candyList);

		System.out.println("DumbValue: " + totalDumbValue);
		System.out.println("RealValue: " + totalRealValue);

		String retVal = "NO";
		if (totalDumbValue == 0)
		{
			retVal = Integer.toString(totalRealValue - candyList.get(0));
		}

		return retVal;
	}

	private static int determineDumbValue( final List<Integer> candyList )
	{
		int retVal = 0;

		for (Integer candyVal : candyList)
		{
			final String binaryVal = Integer.toBinaryString(candyVal);
			final String totalBinaryVal = Integer.toBinaryString(retVal);

			System.out.println("CurrVal: " + binaryVal);
			System.out.println("TotalVal: " + totalBinaryVal);

			/*
			 * Add the numbers
			 */
			retVal += candyVal;
			System.out.println("RetVal: " + retVal);

			/*
			 * And deduct the values of any columns that have 1's because
			 * Patrick will make addition errors here
			 */
			final int length = Math.min(binaryVal.length(), totalBinaryVal.length());
			for (int i = 0; i < length; i++)
			{
				if (binaryVal.charAt(binaryVal.length() - 1 - i) == '1' && totalBinaryVal.charAt(totalBinaryVal.length() - 1 - i) == '1')
				{
					System.out.println("Match at: " + i);
					final double deduction = Math.pow(2, i + 1);
					System.out.println("Deduction: " + deduction);
					retVal -= deduction;
				}
			}
		}

		return retVal;
	}

	private static int determineRealValue( final List<Integer> candyList )
	{
		int retVal = 0;

		for (Integer candyVal : candyList)
		{
			retVal += candyVal;
		}

		return retVal;
	}

	private static List<Integer> loadTestCase( final String testCaseStr ) throws Exception
	{
		final String[] candyStrArray = testCaseStr.split(" ");

		final List<Integer> retVal = new ArrayList<Integer>();
		for (String candyStr : candyStrArray)
		{
			retVal.add(Integer.parseInt(candyStr));
		}

		return retVal;
	}

	private static List<String> loadFile() throws Exception
	{
		BufferedReader reader = new BufferedReader(new FileReader(new File("C:\\Users\\brandon.salzberg\\Workspace_Eclipse\\CodeJam\\res\\testInput.txt")));
		final int numCases = Integer.parseInt(reader.readLine());

		final List<String> retVal = new ArrayList<String>(numCases);
		for (int i = 0; i < numCases; i++)
		{
			final int numCandy = Integer.parseInt(reader.readLine());
			retVal.add(reader.readLine());
		}

		return retVal;
	}
}
