package com.test;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;


public class RPI
{
	private static char[][]	results;
	private static WL[]		wlArray;
	private static double[]	owpArray;
	private static double[]	aowpArray;

	public static void main( String[] args ) throws Exception
	{
		loadFile();
	}

	private static void processResults()
	{
		for (int i = 0; i < results.length; i++)
		{
			int numWins = 0;
			int numLosses = 0;
			for (int j = 0; j < results[i].length; j++)
			{
				if (results[i][j] == '1')
				{
					numWins++;
				}
				else if (results[i][j] == '0')
				{
					numLosses++;
				}
			}

			wlArray[i] = new WL(numWins, numLosses);
		}

		for (int i = 0; i < results.length; i++)
		{
			double totalOWP = 0;
			int numOpponents = 0;
			for (int j = 0; j < results[i].length; j++)
			{
				/*
				 * This means these two teams played
				 */
				if (results[i][j] != '.')
				{
					WL opponentWL = wlArray[j];
					/*
					 * Now subtract our game from that percentage
					 */
					double opponentWins = opponentWL.wins;
					double opponentLosses = opponentWL.losses;

					if (results[i][j] == '1')
					{
						opponentLosses--;
					}
					else
					{
						opponentWins--;
					}
					totalOWP += opponentWins / (opponentWins + opponentLosses);
					numOpponents++;
				}
			}

			owpArray[i] = totalOWP / numOpponents;
		}

		for (int i = 0; i < results.length; i++)
		{
			double totalAOWP = 0;
			int numOpponents = 0;
			for (int j = 0; j < results[i].length; j++)
			{
				/*
				 * This means these two teams played
				 */
				if (results[i][j] != '.')
				{
					totalAOWP += owpArray[j];
					numOpponents++;
				}
			}

			aowpArray[i] = totalAOWP / numOpponents;
		}
	}

	private static void printResults( final BufferedWriter writer ) throws Exception
	{
		for (int i = 0; i < results.length; i++)
		{
			final double wp = (double)wlArray[i].wins / ((double)wlArray[i].wins + (double)wlArray[i].losses);
			final double rpi = (0.25 * wp) + (0.5 * owpArray[i]) + (0.25 * aowpArray[i]);

			writer.write(rpi + "\n");
		}
	}

	private static void loadFile() throws Exception
	{
		BufferedReader reader = new BufferedReader(new FileReader(new File("C:\\Users\\brandon.salzberg\\Workspace_Eclipse\\CodeJam\\res\\testInput.txt")));
		final int numCases = Integer.parseInt(reader.readLine());

		final BufferedWriter writer = new BufferedWriter(new FileWriter(new File("C:\\Users\\brandon.salzberg\\Workspace_Eclipse\\CodeJam\\res\\testOutput.txt")));

		for (int i = 0; i < numCases; i++)
		{
			final int numTeams = Integer.parseInt(reader.readLine());
			results = new char[numTeams][numTeams];
			wlArray = new WL[numTeams];
			owpArray = new double[numTeams];
			aowpArray = new double[numTeams];

			for (int teamNumber = 0; teamNumber < numTeams; teamNumber++)
			{
				final String teamSchedule = reader.readLine();

				for (int j = 0; j < teamSchedule.length(); j++)
				{
					char gameResult = teamSchedule.charAt(j);
					results[teamNumber][j] = gameResult;
				}
			}

			processResults();
			writer.write("Case #" + (i+1) + ":\n");
			printResults(writer);
		}

		writer.flush();
		writer.close();
	}

	private static class WL
	{
		public WL( int wins, int losses )
		{
			this.wins = wins;
			this.losses = losses;
		}

		public int	wins;
		public int	losses;
	}
}
