package com.test;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;


public class Magicka
{
	private static final List<Combinator>	combinatorList	= new ArrayList<Combinator>();
	private static final List<Opposed>		opposedList		= new ArrayList<Opposed>();

	public static void main( String[] args ) throws Exception
	{
		final List<String> testCaseList = loadFile();

		int caseNumber = 1;

		final BufferedWriter writer = new BufferedWriter(new FileWriter(new File("C:\\Users\\brandon.salzberg\\Workspace_Eclipse\\CodeJam\\res\\testOutput.txt")));
		for (String testCaseStr : testCaseList)
		{
			final String invocationStr = loadTestCase(testCaseStr);
			final String resultStr = processInvocationString(invocationStr);

			writer.write("Case #" + caseNumber++ + ": [");
			for (int i = 0; i < resultStr.length(); i++)
			{
				writer.write(resultStr.charAt(i));

				if (i < resultStr.length() - 1)
				{
					writer.write(", ");
				}
			}
			writer.write("]\n");
		}

		writer.flush();
		writer.close();
	}

	private static String processInvocationString( final String invocationStr )
	{
		String currentInvocations = "";

		for (int i = 0; i < invocationStr.length(); i++)
		{
			currentInvocations += invocationStr.charAt(i);

			System.out.println("CurrentInvocation: " + currentInvocations);

			/*
			 * Check for combinations
			 */
			for (Combinator combinator : combinatorList)
			{
				if (currentInvocations.length() > 1)
				{
					System.out.println("Search[" + combinator.search1 + "], Replace[" + combinator.replace + "]");
					
					currentInvocations = currentInvocations.replace(combinator.search1, combinator.replace);
					currentInvocations = currentInvocations.replace(combinator.search2, combinator.replace);
					System.out.println("[REPLACE] CurrentInvocation: " + currentInvocations);
				}
			}

			/*
			 * Check for opposing elements
			 */
			for (Opposed opposed : opposedList)
			{
				if (currentInvocations.contains(opposed.element1) && currentInvocations.contains(opposed.element2))
				{
					currentInvocations = "";
				}
			}
		}

		return currentInvocations;
	}

	private static String loadTestCase( final String testCaseStr )
	{
		combinatorList.clear();
		opposedList.clear();

		final String[] testCaseArray = testCaseStr.split(" ");

		int index = 0;

		final int numCombinators = Integer.parseInt(testCaseArray[index++]);
		for (int i = 0; i < numCombinators; i++)
		{
			final String fullCombinator = testCaseArray[index++];

			final Combinator combinator = new Combinator();
			combinator.search1 = fullCombinator.substring(0, 2);
			combinator.search2 = new StringBuffer(combinator.search1).reverse().toString();
			combinator.replace = fullCombinator.substring(2, 3);

			combinatorList.add(combinator);
		}

		final int numOpposed = Integer.parseInt(testCaseArray[index++]);
		for (int i = 0; i < numOpposed; i++)
		{
			final String fullOpposed = testCaseArray[index++];

			final Opposed opposed = new Opposed();
			opposed.element1 = fullOpposed.substring(0, 1);
			opposed.element2 = fullOpposed.substring(1, 2);

			opposedList.add(opposed);
		}

		final int numInvocations = Integer.parseInt(testCaseArray[index++]);
		final String invocationStr = testCaseArray[index++];

		return invocationStr;
	}

	private static List<String> loadFile() throws Exception
	{
		BufferedReader reader = new BufferedReader(new FileReader(new File("C:\\Users\\brandon.salzberg\\Workspace_Eclipse\\CodeJam\\res\\testInput.txt")));
		final int numCases = Integer.parseInt(reader.readLine());

		final List<String> retVal = new ArrayList<String>(numCases);
		for (int i = 0; i < numCases; i++)
		{
			retVal.add(reader.readLine());
		}

		return retVal;
	}

	private static class Combinator
	{
		public String	search1;
		public String	search2;
		public String	replace;
	}

	private static class Opposed
	{
		public String	element1;
		public String	element2;
	}
}
