package com.test;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;


public class GoroSort
{
	public static void main( String[] args ) throws Exception
	{
		final List<String> testCaseList = loadFile();

		int caseNumber = 1;

		final BufferedWriter writer = new BufferedWriter(new FileWriter(new File("C:\\Users\\brandon.salzberg\\Workspace_Eclipse\\CodeJam\\res\\testOutput.txt")));
		for (String testCaseStr : testCaseList)
		{
			final List<String> elementList = loadTestCase(testCaseStr);
			final long numHits = goroSort(elementList);
			writer.write("Case #" + caseNumber++ + ": " + numHits + "\n");
		}

		writer.flush();
		writer.close();
	}

	private static long goroSort( final List<String> elementList ) throws Exception
	{
		/*
		 * For numbers that are in the wrong index, randomize the numbers that
		 * are in their spot (recursively)
		 */
		long numHits = 0;
		for (int index = 0; index < elementList.size(); index++)
		{
			final int elementVal = Integer.parseInt(elementList.get(index));

			/*
			 * The value is in the wrong location
			 */
			if (elementVal != (index + 1))
			{
				final List<Integer> chain = new ArrayList<Integer>();

				chain.add(index + 1);
				calculateChainLengh(elementVal, index + 1, chain, elementList);

				/*
				 * Number of hits required = chain.size()!
				 */
				numHits += chain.size();
				/*
				 * Put chained items into their correct position.
				 */
				for (Integer chainItem : chain)
				{
					elementList.set(chainItem - 1, Integer.toString(chainItem));
				}
				
				System.out.println("Chain: " + chain);
			}
		}

		return numHits;
	}

	private static void calculateChainLengh( final int elementVal, final int elementIndex, final List<Integer> chain, final List<String> elementList )
	{
		int destinationIndex = elementVal;
		int destinationVal = Integer.parseInt(elementList.get(elementVal - 1));

		chain.add(destinationIndex);

		if (chain.contains(destinationVal))
		{
			return;
		}

		calculateChainLengh(destinationVal, destinationIndex, chain, elementList);
	}

	private static List<String> loadTestCase( final String testCaseStr )
	{
		return Arrays.asList(testCaseStr.split(" "));
	}

	private static List<String> loadFile() throws Exception
	{
		BufferedReader reader = new BufferedReader(new FileReader(new File("C:\\Users\\brandon.salzberg\\Workspace_Eclipse\\CodeJam\\res\\testInput.txt")));
		final int numCases = Integer.parseInt(reader.readLine());

		final List<String> retVal = new ArrayList<String>(numCases);
		for (int i = 0; i < numCases; i++)
		{
			final int numElements = Integer.parseInt(reader.readLine());
			retVal.add(reader.readLine());
		}

		return retVal;
	}
}
