package codeJam.rounb1b.firstProblem;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class FirstProblem {

	private static final String FILE_PATH = "C:\\Users\\Dora\\codejam\\rounb1bFirstProblem\\resources\\";

	static List<String> numbers = Arrays.asList("ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT",
			"NINE");

	List<Integer> finalNumer;

	PrintWriter writer;

	public static void main(String args[]) {
		FirstProblem cs = new FirstProblem();
		File file = new File(FILE_PATH + "input\\A-large.in");
		cs.createFile();
		try {
			cs.readFile(file);
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			cs.writer.close();
		}
	}

	private void readFile(File file) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(file)));

		int nrOfTestcases = getNumberOutOfString(br.readLine());

		for (int i = 0; i < nrOfTestcases; i++) {
			String line = br.readLine();
			int start = 0;
			int end = 0;
			while ((!getResult(line, start, end).isEmpty())) {
				start++;
				end = increment(end);
			}
			writeResultToFile(finalNumer, i);
		}
		br.close();

	}

	private int increment(int i) {
		if (i == 9) {
			return 0;
		} else {
			return ++i;
		}
	}

	private String getResult(String line, int start, int end) {
		finalNumer = new ArrayList<>();
//		for (int i = start; i != end; i = increment(i)) {
		int i = 0;
		while (i<10) {
			while (containsNumber(line, numbers.get(start))) {
				line = deleteNumber(line, numbers.get(start));
				finalNumer.add(start);
			}
			i++;
			start = increment(start);
		}
		
		return line;
	}

	private boolean containsNumber(String line, String s) {
		for (int i = 0; i < s.length(); i++) {
			if (!line.contains(s.charAt(i) + "")) {
				return false;
			}
		}
		return true;
	}

	private String deleteNumber(String line, String s) {
		for (int i = 0; i < s.length(); i++) {
			line = line.replaceFirst(s.charAt(i) + "", "");
		}
		return line;
	}

	private int getNumberOutOfString(String str) {
		try {
			return Integer.parseInt(str);
		} catch (NumberFormatException e) {
			System.out.println(e);
		}
		return 0;
	}

	private void writeResultToFile(List<Integer> result, int caseNumber) {
		String lineToWrite = "Case #" + (caseNumber + 1)+ ": ";
		Collections.sort(result);
		for (int i = 0; i < result.size(); i++) {
			lineToWrite += result.get(i);
		}
		writer.println(lineToWrite);
	}

	private void createFile() {
		try {
			writer = new PrintWriter(FILE_PATH + "output\\output.txt");
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

}
