package codeJam.secondProblem;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class RevengeOfThePancakes {
	
	private static final String FILE_PATH = "C:\\Users\\Dora\\codejam\\pancakes\\resources\\";
	private static final String FILE_NAME =  "B-large.in";
	private List<Boolean> initialStack;
	private PrintWriter writer;
	private int solution;
	
	
	public static void main(String args[]) {
		RevengeOfThePancakes revenge = new RevengeOfThePancakes();
		File file = new File(FILE_PATH + "input\\" + FILE_NAME);
		revenge.createFile();
		try {
			revenge.readFile(file);
		} catch (IOException e) {
			e.printStackTrace();
		}
		finally {
			revenge.writer.close();
		}
	}
	
	private void readFile(File file) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(file)));
	 
		int nrOfLines = Integer.parseInt(br.readLine());
		for (int i = 0; i< nrOfLines; i++) {
			createArrayList(br.readLine());
			solution = Integer.MAX_VALUE;
			findSolution(initialStack, 0);
			writeResultToFile(i+1);
		}
		br.close();
	}
	
	private int findSolution(List<Boolean> list, int numberOfFlips){
		if (isThisASolution(list) && (numberOfFlips < solution)) {
			solution = numberOfFlips;
		} else {
					int sametype = findNumberOfPancakesOfSameType(list); 
					for (int pancackesToFlip=sametype; pancackesToFlip < list.size(); pancackesToFlip++) {
						if ((list.get(0)==list.get(pancackesToFlip) && (sametype==pancackesToFlip)) || (pancackesToFlip==0) || (sametype==list.size()-1)){
							numberOfFlips = findSolution(reverseStack(list, pancackesToFlip), ++numberOfFlips);
						}
					}
		}
		return numberOfFlips;
	}
	
	private int findNumberOfPancakesOfSameType(List<Boolean> list) {
		int i =0;
		while ((i+1 < list.size()) && (list.get(i) == list.get(i+1))) {
			i++;
		}
		return i;
	}
	
	private List<Boolean> reverseStack(List<Boolean> list, int index) {
		int i = 0;
		while (i<=index) {
			boolean aux = list.get(i);
			list.set(i, !list.get(index));
			list.set(index, !aux);
			i++; index--;
		}
		return list;
	}

	private void createArrayList(String line) {
		initialStack = new ArrayList<Boolean>(Arrays.asList(new Boolean[line.length()]));
		Collections.fill(initialStack, Boolean.FALSE);
		for (int i=0; i<line.length(); i++) {
			if (line.charAt(i) == '+') {
				initialStack.set(i, true);
			}
		}
	}
	
	private void writeResultToFile(int caseNumber) {
		String lineToWrite = "Case #" + caseNumber + ": "+ solution;
		writer.println(lineToWrite);
	}
	
	private void createFile() {
		try {
			writer = new PrintWriter(FILE_PATH + "output\\output"+FILE_NAME+".txt");
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	private boolean isThisASolution(List<Boolean> list) {
		for (boolean b: list) {
			if (!b) {
				return false;
			}
		}
		return true;
	}

}
