package codeJam.firstProblem;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class CountingSheep {
	
	private static final String FILE_PATH = "C:\\Users\\Dora\\codejam\\countingSheep\\resources\\";
	
	List<Boolean> digitPresence;
	PrintWriter writer;
	
	
	public static void main(String args[]) {
		CountingSheep cs = new CountingSheep();
		File file = new File(FILE_PATH + "input\\A-large.in");
		cs.createFile();
		try {
			cs.readFile(file);
		} catch (IOException e) {
			e.printStackTrace();
		}
		finally {
			cs.writer.close();
		}
	}
	
	private void readFile(File file) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(file)));
	 
		long nrOfLines = getNumberOutOfString(br.readLine());
		for (int i = 0; i< nrOfLines; i++) {
			long number = getNumberOutOfString(br.readLine());
			if (number == 0) {
				writeResultToFile("INSOMNIA", i+1);
				continue;
			}
			createArrayList();
			int numerToMultiplyWith = 0;
			do {
				numerToMultiplyWith++;
				fillDigitPresenceList(number*numerToMultiplyWith);
			} while (!allDigitPresent());
			writeResultToFile(Long.toString(number*numerToMultiplyWith), i+1);
		}
		br.close();
	}
	
	private long getNumberOutOfString(String str) {
		try {
			return Long.parseLong(str);
		} catch (NumberFormatException e) {
			System.out.println(e);
		}
		return 0;
	}
	
	private void fillDigitPresenceList(long nr) {
		while (nr > 0) {
			int digit = (int)nr%10;
			digitPresence.set(digit, true);
			nr = nr/10;
		}
	}
	
	private boolean allDigitPresent() {
		for (boolean b: digitPresence) {
			if (!b) {
				return b;
			}
		}
		return true;
	}
	
	private void createArrayList() {
		digitPresence = new ArrayList<Boolean> (Arrays.asList(new Boolean[10]));
		Collections.fill(digitPresence, Boolean.FALSE);
	}
	
	private void writeResultToFile(String result, int caseNumber) {
		String lineToWrite = "Case #" + caseNumber + ": "+ result;
		writer.println(lineToWrite);
	}
	
	private void createFile() {
		try {
			writer = new PrintWriter(FILE_PATH + "output\\output.txt");
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

}
