import java.util.LinkedList;


public class Map {

	private class MapEntry{
		public int height;
		public MapEntry flow;
		public char label;
		
		public MapEntry(int height){
			this.height = height;
			label = 0;
		}
	}
	
	private MapEntry[][] map;
	private char actlab;
	
	public Map(int w, int h){
		actlab = 'a';
		map = new MapEntry[w][h];
	}
	
	public void setEntry(int w, int h, int height){
		map[w][h] = new MapEntry(height);
	}
	
	public void labelEntrys(){
		calcField();
		label();
	}
	
	public void writeEntry(CaseWriter cw){
		for(int i = 0; i < map[0].length; i++){
			for(int j = 0; j < map.length; j++){
				cw.write(map[j][i].label);
			}
			cw.newLine();
		}
	}
	
	private void calcField(){
		for(int i = 0; i < map.length; i++){
			for(int j = 0; j < map[i].length; j++){
				int ownHeight = map[i][j].height;
				int smallHeight = ownHeight;
				MapEntry me = null;
				if(j - 1 >= 0 && map[i][j - 1].height < smallHeight){
					smallHeight = map[i][j-1].height;
					me = map[i][j-1];
				}
				
				if(i - 1 >= 0 && map[i-1][j].height < smallHeight){
					smallHeight = map[i-1][j].height;
					me = map[i-1][j];
				}
				

				if(i + 1 < map.length && map[i + 1][j].height < smallHeight){
					smallHeight = map[i+1][j].height;
					me = map[i+1][j];
				}
				
				if(j + 1 < map[i].length && map[i][j+1].height < smallHeight){
					smallHeight = map[i][j+1].height;
					me = map[i][j+1];
				}
				
				map[i][j].flow = me;
			}
		}
	}
	
	private void label(){
		for(int j = 0; j < map[0].length; j++){
			for(int i = 0; i < map.length; i++){
			
				if(map[i][j].label == 0){
					LinkedList<MapEntry> mlist = new LinkedList<MapEntry>();
					mlist.add(map[i][j]);
					while(!mlist.isEmpty()){
						MapEntry curr = mlist.peekFirst();
						if(curr.flow != null){
							mlist.addFirst(curr.flow);
						}else{
							break;
						}
					}
					MapEntry sink = mlist.pollFirst();
					char nl;
					if(sink.label == 0){
						nl = actlab;
						actlab++;
						sink.label = nl;
					}else{
						nl = sink.label;
					}
					while(!mlist.isEmpty()){
						MapEntry curr = mlist.pollFirst();
						curr.label = nl;
					}
				}
			}
		}
	}
}
