package wordProc;

import java.util.ArrayList;
import java.util.LinkedList;

public class Diction {

	private class DictionNode{
		public DictionNode[] children;
		
		public DictionNode(){
			children = new DictionNode[26];
		}
	}
	
	private DictionNode[] diction;
	private int depth;
	
	public Diction(int depth){
		diction = new DictionNode[26];
		this.depth = depth;
	}
	
	public boolean insertString(String s){
		if(s.length() != depth){
			System.out.println("Dict not correct");
			System.exit(-1);
		}
		
		DictionNode[] tDict = diction;
		
		for(int i = 0; i < depth; i++){
			int dictIndex = s.charAt(i) - 97;
			if(tDict[dictIndex] == null) tDict[dictIndex] = new DictionNode();
			tDict = tDict[dictIndex].children;
		}
		
		return true;
	}
	
	public int checkString(String s){
		if(s.length() < depth){
			System.out.println("Test Case not correct");
			System.exit(-1);
		}
		
		ArrayList<DictionNode[]> tDictArr = new ArrayList<DictionNode[]>();
		tDictArr.add(diction);
		
		for(int i = 0; i < s.length(); i++){
			if(s.charAt(i) == '('){
				i++;
				LinkedList<Character> chars = new LinkedList<Character>();
				while(s.charAt(i) != ')'){
					chars.add(s.charAt(i));
					i++;
				}
				ArrayList<DictionNode[]> temp = new ArrayList<DictionNode[]>();
				for(int j = 0; j < tDictArr.size(); j++){
					for(char c: chars){
						int dictIndex = c - 97;
						if(tDictArr.get(j)[dictIndex]!=null)
							temp.add(tDictArr.get(j)[dictIndex].children);
					}
				}
				tDictArr = temp;
			}else{
				int dictIndex = s.charAt(i) - 97;
				for(int j = 0; j < tDictArr.size(); j++){
					if(tDictArr.get(j)[dictIndex] == null){
						tDictArr.remove(j);
					}else{
						tDictArr.set(j, tDictArr.get(j)[dictIndex].children);
					}
				}
			}
		}
		
		return tDictArr.size();

	}
}
