/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package deceitfulwar;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

/**
 *
 * @author bohmd
 */
public class Deceitfulwar {

    Scanner scanner;
    Writer writer;

    /**
     * @param args the command line arguments
     * @throws java.io.IOException
     */
    public static void main(String[] args) throws IOException {
        String filename = args[0];
        File in = new File(filename + ".in");
        File out = new File(filename + ".out");
        new Deceitfulwar(in, out).process();
    }

    public Deceitfulwar(File in, File out) throws IOException {
        scanner = new Scanner(in);
        writer = new BufferedWriter(new FileWriter(out));
    }
    
        public void process() throws IOException {
        int T = scanner.nextInt();
        System.out.println("Inputfile contains " + T + " cases");
        for (int i = 0; i < T; i++) {
            System.out.println("Case #" + (i+1) +"\n");
            int numberOfBlocks = scanner.nextInt();
            Double[] naomi= new Double[numberOfBlocks];
            Double[] ken = new Double[numberOfBlocks];
            for(int j=0; j<numberOfBlocks; j++)
            {
                naomi[j]= scanner.nextDouble();
            }
            for(int j=0; j<numberOfBlocks; j++)
            {
                ken[j]= scanner.nextDouble();
            }
            writer.write("Case #" + (i+1) +": ");
            writer.write(solveCase(naomi, ken)+"\n");
        }
        writer.close();
    }
        
        
        private String solveCase(Double[] naomi, Double[] ken){
           Arrays.sort(naomi);
           Arrays.sort(ken);
            return deceitfulwar(new Blocks(naomi), new Blocks(ken))+" " + war(new Blocks(naomi), new Blocks(ken));
        }
        
        private int war(Blocks naomi, Blocks ken)
        {
            int wins=0;
            while( naomi.hasMore()){
                Double naomiesBlock = naomi.removeMax();
                if(ken.getMax()>naomiesBlock)
                    ken.removeMax();
                else{
                    ken.removeMin();
                    wins++;
                }
            }
            return wins;
        }
        
        private int deceitfulwar(Blocks naomi, Blocks ken)
        {
            int wins=0;
            while( ken.hasMore()){
                Double kensBlock = ken.removeMax();
                if(naomi.getMax()>kensBlock){
                    naomi.removeMax();
                    wins++;
                }
                else{
                    naomi.removeMin();
                }
            }
            return wins;
        }
        
        
    private class Blocks
    {
        List<Double> blocks;
       public Blocks(Double[] blocks)
       {
           Arrays.sort(blocks);
           this.blocks = new ArrayList<>(Arrays.asList(blocks));                   
       }
       
       public Double getMax()
       {
           return blocks.get(blocks.size()-1);
       }
       
       public Double getMin()
       {
           return blocks.get(0);
       }
       
       public Double removeMax()
       {
           return blocks.remove(blocks.size()-1);
       }
       
       public boolean hasMore()
       {
           return !blocks.isEmpty();
       }
       
              public Double removeMin()
       {
           return blocks.remove(0);
       }
    }
}
