
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.Scanner;

public class CruiseControl {

	private static String inFile;
	private static String outFile;
	private static FileWriter out;

	public static void main(String[] args) throws IOException {
		inFile = args[0] + ".in";
		outFile = args[0] + ".out";
		out = new FileWriter(outFile);
		new CruiseControl().solve();

		out.close();
	}

	private void writeCase(int caseNum, String result) throws IOException {
		//System.out.println("Case #" + caseNum + ": " + result);
		out.write("Case #" + caseNum + ": " + result + "\n");
	}

	public void solve() throws IOException {
		Scanner scanner = new Scanner(new File(inFile));
		scanner.nextInt();
		int caseNum = 1;
		while (scanner.hasNext()) {
			double destination = scanner.nextInt();
			int n = scanner.nextInt();
			double resultMin = Double.MAX_VALUE;
			for (int i = 0; i < n; i++) {
				double start = scanner.nextInt();
				double speed = scanner.nextInt();
				if (start < destination) {
					double result= destination  / (destination-start)* speed ;
					if(result <resultMin){
						resultMin = result;
					}
				}
			}
			DecimalFormat df = new DecimalFormat("#.000000");
			writeCase(caseNum++, df.format(resultMin) + "");
		}
		scanner.close();
	}
}
