import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class Pankake {
	public static void main(String[] args) throws IOException {
		new Pankake(args[0], args[1]);
	}

	public Pankake(String inFile, String outFile) throws IOException {
		Scanner scanner = new Scanner(new File(inFile));
		FileWriter fileWriter = new FileWriter(new File(outFile));
		scanner.next();
		int caseNum = 1;
		while (scanner.hasNext()) {
			String pancakeString = scanner.next();
			int wrongSide = 0;
			int firstWrong = pancakeString.length();
			boolean[] pancakeLine = new boolean[pancakeString.length()];

			for (int i = 0; i < pancakeString.length(); i++) {
				pancakeLine[i] = pancakeString.charAt(i) == '+';
				if (!pancakeLine[i]) {
					if (wrongSide == 0) {
						firstWrong = i;
					}
					wrongSide++;
				}
			}

			// logPancakes(pancakeLine);

			int flipper = scanner.nextInt();

			int flipCount = 0;
			for (int i = firstWrong; i < pancakeString.length() - flipper + 1; i++) {
				if (!pancakeLine[i]) {
					for (int j = 0; j < flipper; j++) {
						pancakeLine[i + j] = !pancakeLine[i + j];
					}
					flipCount++;
					// logPancakes(pancakeLine);
				}
			}
			boolean success = true;
			for (int i = pancakeString.length() - flipper; i < pancakeString.length(); i++) {
				success &= pancakeLine[i];
			}

			fileWriter.write("Case #" + caseNum + ": " + (success ? flipCount : "IMPOSSIBLE") + "\n");
			caseNum++;
		}
		fileWriter.close();
		scanner.close();
	}

	// private void logPancakes(boolean[] pancakes){
	// for (int i=0; i<pancakes.length;i++)
	// {
	// System.out.print(pancakes[i]?'+':'-');
	// }
	// System.out.println();
	//
	// }
}
