package roundb;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;

public class CloseMatch {
	public static void main(String[] args) throws IOException {
		new CloseMatch(args[0]);
	}

	public CloseMatch(String fileName) throws IOException {
		List<String> lines = Files.readAllLines(Paths.get(fileName + ".in"), Charset.defaultCharset());
		FileOutputStream output = new FileOutputStream(new File(fileName + ".out"));
		for (int i = 1; i < lines.size(); i++) {
			String line = lines.get(i);
			String[] pieces = line.split(" ");
			String oceaniaCoders = pieces[0];
			String eurasiaJammers = pieces[1];
			String result = "Case #" + i + ": " + solve(oceaniaCoders.toCharArray(), eurasiaJammers.toCharArray())
					+ "\n";
			System.out.print(result);
			output.write(result.getBytes());
		}
		output.close();
	}

	private String solve(char[] oceaniaCoders, char[] eurasiaJammers) {
		Boolean oceaniaCodersAreBetter = null;
		for (int i = 0; i < oceaniaCoders.length; i++) {
			if (oceaniaCoders[i] == '?') {
				if (eurasiaJammers[i] == '?') {
					if (oceaniaCodersAreBetter == null) {
						oceaniaCoders[i] = '0';
						eurasiaJammers[i] = '0';
					} else if (oceaniaCodersAreBetter) {
						oceaniaCoders[i] = '0';
						eurasiaJammers[i] = '9';
					} else {
						oceaniaCoders[i] = '9';
						eurasiaJammers[i] = '0';
					}
				} else {
					oceaniaCoders[i] = eurasiaJammers[i];
				}
			} else if (eurasiaJammers[i] == '?') {
				eurasiaJammers[i] = oceaniaCoders[i];
			} else if (oceaniaCodersAreBetter == null && oceaniaCoders[i] != eurasiaJammers[i]) {
				oceaniaCodersAreBetter = oceaniaCoders[i] > eurasiaJammers[i];
			}
		}

		return new String(oceaniaCoders) + " " + new String(eurasiaJammers);

	}

}
