import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class BathroomStalls {
	public static void main(String[] args) throws IOException {
		new BathroomStalls(args[0]);
	}

	public BathroomStalls(String file) throws IOException {
		Scanner scanner = new Scanner(new File(file + ".in"));
		FileWriter fileWriter = new FileWriter(new File(file + ".out"));
		scanner.next();
		int caseNum = 1;
		while (scanner.hasNext()) {
			long stalls = scanner.nextLong();
			long people = scanner.nextLong();

			Map<Long, Integer> freeBlocks = new HashMap<Long, Integer>();
			freeBlocks.put(stalls, 1);
			for (int i = 0; i < people - 1; i++) {
				// find longest free block
				Long max = Collections.max(freeBlocks.keySet());
				removeFromFreeBlocks(freeBlocks, max);
				if (max % 2 == 0) {
					addToFreeBlocks(freeBlocks, max / 2);
					addToFreeBlocks(freeBlocks, max / 2 - 1);
				} else {
					addToFreeBlocks(freeBlocks, (max - 1) / 2);
					addToFreeBlocks(freeBlocks, (max - 1) / 2);
				}
			}
			Long max = Collections.max(freeBlocks.keySet());
			String result = null;
			if (max % 2 == 0) {
				result = (max / 2) + " " + (max / 2 - 1);
			} else {
				result = ((max - 1) / 2) + " " + ((max - 1) / 2);
			}
			String caseResult = "Case #" + caseNum + ": " + result + "\n";
			//System.out.print(caseResult);
			fileWriter.write(caseResult);
			caseNum++;
		}
		fileWriter.close();
		scanner.close();

	}

	private void addToFreeBlocks(Map<Long, Integer> freeBlocks, Long block) {
		if (freeBlocks.get(block) == null) {
			freeBlocks.put(block, 1);
		} else {
			freeBlocks.put(block, freeBlocks.get(block) + 1);
		}

	}

	private void removeFromFreeBlocks(Map<Long, Integer> freeBlocks, Long block) {
		if (freeBlocks.get(block).equals(1)) {
			freeBlocks.remove(block);
		} else {
			freeBlocks.put(block, freeBlocks.get(block) - 1);
		}
	}

}
