package roundb;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Phone {

	private static final String[] numbers = new String[] { "ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX",
			"SEVEN", "EIGHT", "NINE" };

	public static void main(String[] args) throws IOException {
		new Phone(args[0]);
	}

	public Phone(String fileName) throws IOException {
		List<String> lines = Files.readAllLines(Paths.get(fileName + ".in"), Charset.defaultCharset());
		FileOutputStream output = new FileOutputStream(new File(fileName + ".out"));
		for (int i = 1; i < lines.size(); i++) {
			String line = lines.get(i);
			String result = "Case #" + i + ": " + solve(line) + "\n";
			//System.out.print(result);
			output.write(result.getBytes());
		}
		output.close();
	}

	private String solve(String number) {
		Map<Character, Integer> letters = new HashMap<Character, Integer>();
		for (int i = 0; i < number.length(); i++) {
			char c = number.charAt(i);
			if (letters.get(c) != null) {
				letters.put(c, letters.get(c) + 1);
			} else {
				letters.put(c, 1);
			}
		}

		Map<Integer, Integer> result = new HashMap<Integer, Integer>();
		result.put(0, letters.get('Z'));
		removeLetters(letters, "ZERO", letters.get('Z'));
		result.put(6, letters.get('X'));
		removeLetters(letters, "SIX", letters.get('X'));
		result.put(8, letters.get('G'));
		removeLetters(letters, "EIGHT", letters.get('G'));
		result.put(2, letters.get('W'));
		removeLetters(letters, "TWO", letters.get('W'));
		result.put(3, letters.get('H'));
		removeLetters(letters, "THREE", letters.get('H'));
		result.put(4, letters.get('U'));
		removeLetters(letters, "FOUR", letters.get('U'));
		result.put(5, letters.get('F'));
		removeLetters(letters, "FIVE", letters.get('F'));
		result.put(7, letters.get('V'));
		removeLetters(letters, "SEVEN", letters.get('V'));
		result.put(9, letters.get('I'));
		removeLetters(letters, "NINE", letters.get('I'));
		result.put(1, letters.get('O'));
		removeLetters(letters, "ONE", letters.get('O'));
		return resultToString(result);
	}

	private String resultToString(Map<Integer, Integer> resultNums) {

		String result = "";
		for (int i = 0; i < 10; i++) {
			if (resultNums.get(i) != null) {
				for (int j = 0; j < resultNums.get(i); j++) {
					result += i + "";
				}
			}
		}
		return result;
	}

	private void removeLetters(Map<Character, Integer> letters, String toRemove, Integer count) {
		if (count != null && count > 0) {
			for (int i = 0; i < toRemove.length(); i++) {
				char c = toRemove.charAt(i);
				letters.put(c, letters.get(c) - count);
			}
		}
	}

}
