package roundb;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.text.StyledEditorKit.ForegroundAction;

public class Technobabble {
	public static void main(String[] args) throws IOException {
		new Technobabble(args[0]);
	}

	public Technobabble(String fileName) throws IOException {
		List<String> lines = Files.readAllLines(Paths.get(fileName + ".in"), Charset.defaultCharset());
		FileOutputStream output = new FileOutputStream(new File(fileName + ".out"));
		int cases = 1;
		int i = 1;
		while (i < lines.size()) {
			String line = lines.get(i);
			int topics = Integer.parseInt(line);
			List<String> first = new ArrayList<String>();
			List<String> second = new ArrayList<String>();
			for (int j = 0; j < topics; j++) {
				line = lines.get(i + j + 1);
				String[] pieces = line.split(" ");
				first.add(pieces[0]);
				second.add(pieces[1]);
			}
			String result = "Case #" + cases + ": " + solve(first, second) + "\n";
			// System.out.print(result);
			output.write(result.getBytes());
			cases++;
			i += topics + 1;

		}
		output.close();
	}

	private int solve(List<String> a, List<String> b) {
		int result = 0;
		Map<String, Integer> firstWords = new HashMap<String, Integer>();
		Map<String, Integer> secondWords = new HashMap<String, Integer>();
		for (int i = 0; i < a.size(); i++) {
			addOneWord(firstWords, a.get(i));
			addOneWord(secondWords, b.get(i));
		}
		List<String> orderedA = new ArrayList<String>();
		List<String> orderedB = new ArrayList<String>();

		for (int i = 0; i < a.size(); i++) {
			if ((firstWords.get(a.get(i)) == 1 && secondWords.get(b.get(i)) > 1)
					|| (firstWords.get(a.get(i)) > 1 && secondWords.get(b.get(i)) == 1)) {
				orderedA.add(0, a.get(i));
				orderedB.add(0, b.get(i));
			} else if (firstWords.get(a.get(i)) > 1 && secondWords.get(b.get(i)) > 1) {
				orderedA.add(a.get(i));
				orderedB.add(b.get(i));
			}
		}

		for (int i = 0; i < orderedA.size(); i++) {
			boolean foundA = false;
			boolean foundB = false;
			for (int j = 0; j < i && !(foundA && foundB); j++) {
				if (orderedA.get(j).equals(orderedA.get(i))) {
					foundA = true;
				}
				if (orderedB.get(j).equals(orderedB.get(i))) {
					foundB = true;
				}
			}
			if (foundA && foundB) {
				result++;
			}
		}

		return result;
	}

	private void addOneWord(Map<String, Integer> words, String word) {
		if (words.get(word) == null) {
			words.put(word, 1);
		} else {
			words.put(word, words.get(word) + 1);
		}
	}

	private void removeOneWord(Map<String, Integer> words, String word) {
		words.put(word, words.get(word) - 1);
	}

}
