import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;
import java.nio.charset.Charset;
import java.io.PrintWriter;

public class Pancakes{

	private static final char HAPPY = '+';
	private static final char SAD = '-';
	
	public static void main(String[] args){
		solve("B-large.in", "test.out");
	}
	
	private static int count(String stack){
		int length = stack.length();
		int result = 0;
		for (int i = length-1; i >=1; i--){
			if(stack.charAt(i) != stack.charAt(i-1))
				result ++;
		}
		char bottom = stack.charAt(length-1);
		return bottom == HAPPY?result:result+1;
	}
	
	private static void solve(String fileIn, String fileOut){
	
		Charset charset = Charset.forName("ISO-8859-1");
		Path path = Paths.get("", fileIn);
		try {
			List<String> lines = Files.readAllLines(path, charset);
			String words = "";
			int tests = Integer.parseInt(lines.get(0));
			for (int i = 0; i < tests; i++){
				String line = lines.get(i+1);
				int result = count(line);
				words += "Case #" + (i + 1) + ": " + (int)result + "\n";
			}
			//System.out.println(words);
			PrintWriter out = new PrintWriter(fileOut);
		    	out.print(words);	
;		    	out.close();	
		}
		catch (IOException e){
			e.printStackTrace();
		}
	}
	
}
