import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.HashSet;
import java.util.List;
import java.nio.charset.Charset;
import java.io.PrintWriter;

public class CSheep{
	public static void main(String[] args){
		solve("A-large.in", "test.out");
	}
	
	private static HashSet initHash(){
		// create a hash set with digits
	      	HashSet<Integer> hs = new HashSet<Integer>();
	      	for (int d = 0; d <= 9; d++)
	      		hs.add(d);
	      	return hs;
	}
	
	private static int[] getDigits(int N){
		int length = String.valueOf(N).length();
		int[] result = new int[length];
		
		while(N>0){
			result[--length] = N%10;
			N = N/10;
		}
		return result;
	}
	
	private static int solveTest(int N){
		if (N == 0) return -1;
		int iN = N;
		HashSet hs = initHash();
		while (true){
			//go through digits 
			int[] digits = getDigits(N);	
			for (int d : digits)
				if (hs.contains(d))
					hs.remove(d);
			if(hs.isEmpty()) 
				return N;
			N += iN;
		}
	}
	
	private static void solve(String fileIn, String fileOut){
	
		Charset charset = Charset.forName("ISO-8859-1");
		Path path = Paths.get("", fileIn);
		try {
			List<String> lines = Files.readAllLines(path, charset);
			String words = "";
			int tests = Integer.parseInt(lines.get(0));
			for (int i = 0; i < tests; i++){
				String line = lines.get(i+1);
				int N = Integer.parseInt(line);
				int result = solveTest(N);
				if (result == -1)
					words += "Case #" + (i + 1) + ": " + "INSOMNIA\n";
					else words += "Case #" + (i + 1) + ": " + (int)result + "\n";
			}
			//System.out.println(words);
			PrintWriter out = new PrintWriter(fileOut);
		    	out.print(words);	
;		    	out.close();	
		}
		catch (IOException e){
			e.printStackTrace();
		}
	}
}
