import java.io.*;

public class RevengeofthePancakes {
	
	private static final String OUTPUT_CASE = "Case #%s: ";
	
	public static void main(String[] args) throws NumberFormatException, IOException {
		
		//Output writing
		FileWriter output = new FileWriter(args[1]);
		BufferedWriter bufferedWriter = new BufferedWriter(output);
		
		//Input reading
		String infil = args[0];
		FileReader input = new FileReader(infil);
		BufferedReader bufferedReader = 
                new BufferedReader(input);
		String s = bufferedReader.readLine();
		int testCases = Integer.parseInt(s);
		int counter = 1;
		
		while(counter <= testCases){
			if(counter > 1)
				bufferedWriter.write("\n");
			String pancakeSeq = bufferedReader.readLine();
				int result = minNumOfMoves(pancakeSeq);
				bufferedWriter.write((String.format(OUTPUT_CASE, counter)) + result);
			counter++;
			
		}
		
		bufferedReader.close();
		input.close();
		
		bufferedWriter.close();
		output.close();
	}
	
	protected static int newHappyPancakeIndexBefore(char[] happyBlankPancake, int happyPancakeIndexBefore){
		while(happyPancakeIndexBefore > 0 && happyBlankPancake[happyPancakeIndexBefore] == '+'){
			happyPancakeIndexBefore--;
		}
		return happyPancakeIndexBefore;
	}	
	
	protected static int minNumOfMoves(String pancakeSeq){
		int minMoves = 0;
		char[] happyBlankPancake = pancakeSeq.toCharArray();
		
		int happyPancakeIndexBefore = happyBlankPancake.length - 1;
		happyPancakeIndexBefore = newHappyPancakeIndexBefore(happyBlankPancake, happyPancakeIndexBefore);
		
		while(happyPancakeIndexBefore > 0 || happyBlankPancake[happyPancakeIndexBefore] != '+'){
			
			char topPancake = happyBlankPancake[0];
			
			if(happyPancakeIndexBefore !=0 && topPancake == happyBlankPancake[happyPancakeIndexBefore]){ 
				//Complete flip 
				flipPancakes(0, happyPancakeIndexBefore, happyBlankPancake);
				minMoves++;
			} else {
				
				//determining how pancakes to flip to match
				int pointer = 0;
				while(pointer+1 < happyBlankPancake.length && happyBlankPancake[pointer+1] == topPancake){
					pointer++;
				}
				flipPancakes(0, pointer, happyBlankPancake);
				minMoves++;
			}
			//if(happyPancakeIndexBefore == 0) break;
			happyPancakeIndexBefore = newHappyPancakeIndexBefore(happyBlankPancake, happyPancakeIndexBefore);
			
		}
		return minMoves;
	}
	
	
	protected static void flipPancakes(int start, int end, char[] happyBlankPancake){
		int i = start, j = end;
		
		while(i < j){
			char temp = happyBlankPancake[i];
			happyBlankPancake[i] = flipPancake(happyBlankPancake[j]);
			happyBlankPancake[j] = flipPancake(temp);
			i++; j--;
		}
		 
		if(i == j){ //flip remaining pancake
			happyBlankPancake[i] = flipPancake(happyBlankPancake[i]);
		}
	}
	
	protected static char flipPancake(char pancakeState){
		return pancakeState == '+'? '-':'+';
	}

}
