import java.util.*;

public class b {
	static int s;
	static boolean[][] seen;
	static boolean[][] tmp;
			
	static int[] dx = {-1,-1,0,0,1,1};
	static int[] dy = {-1,0,-1,1,0,1};
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int T = in.nextInt();
		for(int t=1; t<=T; t++) {
			System.out.printf("Case #%d: ", t);

			s = in.nextInt();
			int m = in.nextInt();
			seen = new boolean[2*s+10][2*s+10];
			tmp = new boolean[2*s+10][2*s+10];
			boolean done = false;

			DisjointSet ds = new DisjointSet((2*s+10)*(2*s+10));

			int[] cornerX = new int[]{1,1,s,2*s-1,2*s-1,s};
			int[] cornerY = new int[]{1,s,2*s-1,2*s-1,s,1};

			int[] edgeX = new int[]{0,2,2,s+2,2*s,s+2};
			int[] edgeY = new int[]{2,0,s+2,2,s+2,2*s};

			int[] edgeX3 = new int[]{1,2,2,4,4,5};
			int[] edgeY3 = new int[]{2,1,4,2,5,4};

			for(int i=0; i<s-3; i++) {
				//bottom 
				seen[0][i+2] = true;
				seen[i+2][0] = true;

				//sides
				seen[i+2][s+i+2] = true;
				seen[s+i+2][i+2] = true;

				//top
				seen[2*s][s+i+2] = true;
				seen[s+i+2][2*s] = true;
			}
			
			for(int i=0; i<2*s+10; i++)
				for(int j=0; j<2*s+10; j++)
					for(int k=0; k<dx.length; k++) {
						int nx = i+dx[k];
						int ny = j+dy[k];
						if(nx < 0 || ny < 0) continue;
						if(seen[i][j] && seen[nx][ny])
							ds.union(hash(i,j),hash(nx,ny));
					}

			for(int z=0; z<m; z++) {
				boolean hasBridge = false;
				boolean hasFork = false;
				boolean hasRing = false;

				int x = in.nextInt();
				int y = in.nextInt();
				if(done) continue;
				seen[x][y] = true;
				int adj = 0;
				for(int i=0; i<dx.length; i++) {
					int nx = x+dx[i];
					int ny = y+dy[i];
					if(seen[nx][ny]) {
						adj++;
						ds.union(hash(x,y),hash(nx,ny));
					}
				}
				for(int i=0; i<6; i++)
					for(int j=i+1; j<6; j++)
						if(ds.find(hash(cornerX[i],cornerY[i])) == ds.find(hash(cornerX[j],cornerY[j])))
							hasBridge = true;

				if(s > 3) for(int i=0; i<6; i++)
					for(int j=i+1; j<6; j++)
						for(int k=j+1; k<6; k++)
							if(ds.find(hash(edgeX[i],edgeY[i])) == ds.find(hash(edgeX[j],edgeY[j])) &&
								ds.find(hash(edgeX[i],edgeY[i])) == ds.find(hash(edgeX[k],edgeY[k])))
								hasFork = true;
				
				if(s == 3) for(int i=0; i<6; i++)
					for(int j=i+1; j<6; j++)
						for(int k=j+1; k<6; k++)
							if(ds.find(hash(edgeX3[i],edgeY3[i])) == ds.find(hash(edgeX3[j],edgeY3[j])) &&
								ds.find(hash(edgeX3[i],edgeY3[i])) == ds.find(hash(edgeX3[k],edgeY3[k])))
								hasFork = true;

				for(int i=0; i<dx.length; i++)
					if(!seen[x+dx[i]][y+dy[i]] && !canReachEdge(x+dx[i],y+dy[i]))
						hasRing = true;
				
				if(hasBridge)  {
					System.out.print("bridge");
				}
				if(hasFork) {
					if(hasBridge) System.out.print("-");
					System.out.print("fork");
				}
				if(hasRing) {
					if(hasBridge||hasFork) System.out.print("-");
					System.out.print("ring");
				}
				done |= hasBridge || hasFork || hasRing;
				if(done) System.out.println(" in move " + (z+1));
			}
			if(!done) System.out.println("none");
		}
	}
	static boolean canReachEdge(int x, int y) {
		ArrayDeque<Integer> q = new ArrayDeque<Integer>();
		ArrayDeque<Integer> unMark = new ArrayDeque<Integer>();
		q.add(x);
		q.add(y);
		tmp[x][y] = true;
		boolean ret = false;
		while(!q.isEmpty() && !ret) {
			int a = q.poll();
			int b = q.poll();
			unMark.add(a);
			unMark.add(b);
			for(int i=0; i<dx.length; i++) {
				int nx = a + dx[i];
				int ny = b + dy[i];
				if(!ok(nx,ny)) {
					ret = true;
					break;
				}
				if(seen[nx][ny] || tmp[nx][ny]) continue;
				tmp[nx][ny] = true;
				q.add(nx);
				q.add(ny);
			}
		}
		while(!q.isEmpty())
			unMark.add(q.poll());
		while(!unMark.isEmpty())
			tmp[unMark.poll()][unMark.poll()] = false;
		return ret;
	}
	static boolean ok(int x, int y) {
		if(x <= 0 || y <= 0 || x >= 2*s || y >= 2*s) return false;
		if(Math.abs(x-y) >= s) return false;
		return true;
	}
	static int hash(int x, int y) {
		return (2*s+10)*x + y;
	}
	static class DisjointSet {
		int[] p, r;
		DisjointSet(int s) {
			p = new int[s];	
			r = new int[s];
			for(int i=0; i<s; i++)
				p[i] = i;
		}
		void union(int x, int y) {
			int a = find(x);
			int b = find(y);
			if(a==b) return;
			if(r[a] == r[b])
				r[p[b]=a]++;
			else 
				p[a]=p[b]=r[a]<r[b]?b:a;
		}
		int find(int x) {
			return p[x]=p[x]==x?x:find(p[x]);
		}
	}

}
