package Qualify2013;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.RoundingMode;
import java.util.Scanner;

public class ProblemC {
    
    public static void main(String[] args) throws FileNotFoundException, IOException {
        ProblemC c = new ProblemC();

        Scanner sc = new Scanner(new FileReader("C-small-attempt0.in.txt"));
        PrintWriter pw = new PrintWriter(new FileWriter("outputC.txt"));
        
        int T = sc.nextInt();
        
        for (int i = 0; i < T; i++) {
            System.out.println("Case " + (i + 1));
            pw.print("Case #" + (i + 1) + ": ");
            c.run(sc, pw);
        }
        
        pw.flush();
        pw.close();
        sc.close();
    }

    public void run(Scanner sc, PrintWriter pw) {
        BigInteger A, B;
        int count = 0;
        
        A = sc.nextBigInteger();
        B = sc.nextBigInteger();

        
        for(BigInteger i = A; i.compareTo(B) <= 0 ; i = i.add(BigInteger.ONE)){
            if(isPalindrome(i)){
                BigInteger sqrtI = sqrt(i);
                if(isSquare(i, sqrtI)){
                    if(isPalindrome(sqrtI))
                        count++;
                }
            }
        }
        
        pw.println(count);
    }
    
    public boolean isPalindrome(BigInteger num) {
        String digits = num.toString();
        int numDigits = digits.length();

        if (numDigits == 1) {
            return true;
        }
        
        for (int i = 0; i < numDigits / 2; i++) {
            if (digits.charAt(i) != digits.charAt(numDigits - i - 1)) {
                return false;
            }
        }
        
        return true;
    }
    
    private static BigInteger squareRootEstimate(BigInteger a) {
        int log2aAprox = a.bitLength();
        int rootExp = log2aAprox / 2;
        return BigInteger.valueOf(2).pow(rootExp);
    }
    
    public static BigInteger sqrt(BigInteger a) {
        if (a.compareTo(BigInteger.ZERO) < 0) {
            throw new IllegalArgumentException();
        }

        BigDecimal square = new BigDecimal(a);
        BigDecimal solution = new BigDecimal(squareRootEstimate(a));
        BigDecimal adjustment;
        do {
            adjustment = square.subtract(solution.pow(2));
            adjustment = adjustment.divide(solution, 10, RoundingMode.HALF_EVEN);
            adjustment = adjustment.divide(BigDecimal.valueOf(2), 10, RoundingMode.HALF_EVEN);
            solution = solution.add(adjustment);
        } while (Math.abs(adjustment.doubleValue()) > 1);
        return solution.toBigInteger();
    }
    
    public static boolean isSquare(BigInteger a, BigInteger sqrtA) {
        if (a.compareTo(BigInteger.ZERO) < 0) {
            return false;
        }

        return sqrtA.multiply(sqrtA).equals(a);
    }
}
