package codejam2014.qualify;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 *
 * @author Henrique S. Nobrega
 */
public class ProblemC {

    public static void main(String[] args) throws FileNotFoundException, IOException {
        ProblemC c = new ProblemC();

        Scanner sc = new Scanner(new FileReader("C-large.in.txt"));
        PrintWriter pw = new PrintWriter(new FileWriter("outputC-large.txt"));

        int T = sc.nextInt();

        for (int i = 0; i < T; i++) {
            System.out.println("Case " + (i + 1));
            pw.print("Case #" + (i + 1) + ": ");
            c.run(sc, pw);
        }

        pw.flush();
        pw.close();
        sc.close();
    }

    public void run(Scanner sc, PrintWriter pw) {
        int row = sc.nextInt();
        int column = sc.nextInt();
        int M = sc.nextInt();
        pw.println();
        if (hasSolution(row, column, (row*column - M))) {
            String[][] grid = createGrid(row, column, (row*column - M));
            
            for (String[] grid1 : grid) {
                for (String grid11 : grid1) {
                    pw.print(grid11);
                }
                pw.println();
            }
        } else {
            pw.println("Impossible");
        }
    }

    public boolean hasSolution(int row, int column, int blankFields) {
        if (row == 1 || column == 1) {
            return true;
        } else if (row == 2 || column == 2) {
            if (blankFields == 1) {
                return true;
            } else if (blankFields == 2) {
                return false;
            } else {
                return blankFields % 2 == 0;
            }
        } else {
            return blankFields != 2 && blankFields != 3 && blankFields != 5 && blankFields != 7;
        }
    }

    public String[][] createGrid(int row, int column, int blankFields) {
        String[][] grid = new String[row][column];

        for (String[] grid1 : grid) {
            for (int j = 0; j < grid1.length; j++) {
                grid1[j] = "*";
            }
        }

        if (row == 1) {
            for (int i = 0; i < blankFields; i++) {
                grid[0][i] = ".";
            }
        } else if (column == 1) {
            for (int i = 0; i < blankFields; i++) {
                grid[i][0] = ".";
            }
        } else if (row == 2) {
            int field = 1;
            for (int i = 0; field < blankFields; i++) {
                grid[0][i] = ".";
                grid[1][i] = ".";
                field += 2;
            }
        } else if (column == 2) {
            int field = 1;
            for (int i = 0; field < blankFields; i++) {
                grid[i][0] = ".";
                grid[i][1] = ".";
                field += 2;
            }
        } else {
            int field = 0;
            int curRow = 0;
            int curCol;

            if (blankFields == 1) {

            } else if (blankFields == 4) {
                grid[0][1] = ".";
                grid[1][0] = ".";
                grid[1][1] = ".";
            } else if (blankFields == 6) {
                grid[0][1] = ".";
                grid[0][2] = ".";
                grid[1][0] = ".";
                grid[1][1] = ".";
                grid[1][2] = ".";
            } else if (blankFields == 8) {
                grid[0][1] = ".";
                grid[0][2] = ".";
                grid[1][0] = ".";
                grid[1][1] = ".";
                grid[1][2] = ".";
                grid[2][0] = ".";
                grid[2][1] = ".";
            } else {
                boolean full = false;
                while (field < blankFields) {
                    for (curCol = 0; curCol < column; curCol++) {
                        grid[curRow][curCol] = ".";
                        grid[curRow + 1][curCol] = ".";
                        field += 2;
                        if (blankFields - field <= 3) {
                            curCol++;
                            break;
                        }
                    }

                    if (curCol == column) {
                        curRow += 2;
                        curCol = 0;
                        full = true;
                    }

                    if (curCol == column - 1) {
                        if (blankFields - field == 3) {
                            if (full) {
                                grid[curRow][curCol] = ".";
                                curRow += 2;
                                curCol = 0;
                                grid[curRow][curCol++] = ".";
                                grid[curRow][curCol++] = ".";
                            } else {
                                curRow += 2;
                                curCol = 0;
                                grid[curRow][curCol++] = ".";
                                grid[curRow][curCol++] = ".";
                                grid[curRow][curCol++] = ".";
                                curRow -= 2;
                            }
                            field += 3;
                        } else if (blankFields - field == 2) {
                            grid[curRow][curCol] = ".";
                            grid[curRow + 1][curCol++] = ".";
                            field += 2;
                        }
                    } else if (curCol == column - 2) {
                        if (blankFields - field == 3) {
                            if (full) {
                                grid[curRow][curCol] = ".";
                                grid[curRow + 1][curCol++] = ".";
                                grid[curRow][curCol++] = ".";
                            } else {
                                curRow += 2;
                                curCol = 0;
                                grid[curRow][curCol++] = ".";
                                grid[curRow][curCol++] = ".";
                                grid[curRow][curCol++] = ".";
                                curRow -= 2;
                            }
                            field += 3;
                        } else if (blankFields - field == 2) {
                            grid[curRow][curCol] = ".";
                            grid[curRow + 1][curCol++] = ".";
                            field += 2;
                        }
                    } else {
                        if (blankFields - field == 3) {
                            if (full) {
                                if (curCol != 0) {
                                    grid[curRow][curCol] = ".";
                                    grid[curRow + 1][curCol++] = ".";
                                    grid[curRow][curCol++] = ".";
                                } else {
                                    grid[curRow][curCol++] = ".";
                                    grid[curRow][curCol++] = ".";
                                    grid[curRow][curCol++] = ".";
                                }
                            } else {
                                curRow += 2;
                                curCol = 0;
                                grid[curRow][curCol++] = ".";
                                grid[curRow][curCol++] = ".";
                                grid[curRow][curCol++] = ".";
                                curRow -= 2;
                            }
                            field += 3;
                        } else if (blankFields - field == 2) {
                            if (full) {
                                if (curCol != 0) {
                                    grid[curRow][curCol] = ".";
                                    grid[curRow + 1][curCol++] = ".";
                                } else {
                                    grid[curRow][curCol++] = ".";
                                    grid[curRow][curCol++] = ".";
                                }
                                field += 2;
                            } else {
                                grid[curRow][curCol] = ".";
                                grid[curRow + 1][curCol++] = ".";
                                field += 2;
                            }
                        } else {
                            if (curRow == row - 1) {
                                while (field < blankFields) {
                                    grid[curRow][curCol++] = ".";
                                    field++;
                                }
                            }
                        }
                    }
                }
            }
        }

        grid[0][0] = "c";

        return grid;
    }

    public void printGrid(String[][] grid) {
        for (String[] grid1 : grid) {
            for (String grid11 : grid1) {
                System.out.print(grid11);
            }
            System.out.println();
        }
    }
}
