package codejam2014.qualify;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class ProblemA {
    private static final int BAD_MAGICIAN = -1;
    private static final int VOLUNTEER_CHEATED = 0;
    
    public static void main(String[] args) throws FileNotFoundException, IOException {
        ProblemA a = new ProblemA();

        Scanner sc = new Scanner(new FileReader("A-small-attempt1.in.txt"));
        PrintWriter pw = new PrintWriter(new FileWriter("outputA.txt"));
        
        int T = sc.nextInt();
        
        for (int i = 0; i < T; i++) {
            System.out.println("Case " + (i + 1));
            pw.print("Case #" + (i + 1) + ": ");
            sc.nextLine();
            a.run(sc, pw);
        }
        
        pw.flush();
        pw.close();
        sc.close();
    }

    public void run(Scanner sc, PrintWriter pw) {
        int[][] cardGrid = new int[4][4];
        int firstCardRow;
        int secondCardRow;
        
        firstCardRow = sc.nextInt();        
        for (int row = 0; row < cardGrid.length; row++) {
            for (int column = 0; column < cardGrid.length; column++) {
                cardGrid[row][column] = sc.nextInt();
            }
        }
        int[] firstRowSet = new int[cardGrid.length];
        for (int i = 0; i < firstRowSet.length; i++)
            firstRowSet[i] = cardGrid[firstCardRow - 1][i];
        
        secondCardRow = sc.nextInt();
        for (int row = 0; row < cardGrid.length; row++) {
            for (int column = 0; column < cardGrid.length; column++) {
                cardGrid[row][column] = sc.nextInt();
            }
        }
        int[] secondRowSet = new int[cardGrid.length];
        for (int i = 0; i < firstRowSet.length; i++)
            secondRowSet[i] = cardGrid[secondCardRow - 1][i];
        
        int answer = compareRowSets(firstRowSet, secondRowSet);
        
        if (answer == BAD_MAGICIAN) {
            pw.println("Bad magician!");
        } else if (answer == VOLUNTEER_CHEATED) {
            pw.println("Volunteer cheated!");
        } else {
            pw.println(answer);
        }
    }
    
    public int compareRowSets(int[] set1, int[] set2) {
        boolean matchFlag = false;
        int result = 0;
        
        for (int i = 0; i < set1.length; i++) {
            for (int j = 0; j < set2.length; j++) {
                if (set1[i] == set2[j]) {
                    if (!matchFlag) {
                        matchFlag = true;
                        result = set1[i];
                    } else {
                        return BAD_MAGICIAN;
                    }
                }
            }
        }
        
        return matchFlag ? result : VOLUNTEER_CHEATED;
    }
    
}