import java.io.*;

class ThemePark {

    private static BufferedReader InputFile;
    private static BufferedWriter OutputFile;    
    private static int Cases;

    private static void leftRotateQueue (int[] Queue, int distance){
    	int[] QueueEnd = new int[distance];
    	System.arraycopy(Queue, 0, QueueEnd, 0, distance);
    	System.arraycopy(Queue, distance, Queue, 0, Queue.length - distance);
    	System.arraycopy(QueueEnd, 0, Queue, Queue.length - distance, QueueEnd.length);
    }
    
    private static int solveProblem(int R, int k, int[] Queue) throws Exception {
        int result = 0;

        for (int i = 0; i < R; i++) {
        	int g = 0;
        	int j = 0;
        	
        	while (j < Queue.length && g + Queue[j] <= k) {
        	   g = g + Queue[j];
        	   j++;
        	}
        	
            leftRotateQueue(Queue, j);        	
        	result = result + g;            
        }

        return result;
    }

    private static String processTestCase () throws Exception {    	
        String[] Tokens = InputFile.readLine().split(" ");
        int R = Integer.parseInt(Tokens[0]);
        int k = Integer.parseInt(Tokens[1]);
        int N = Integer.parseInt(Tokens[2]);
     
        Tokens = InputFile.readLine().split(" ");
        
        int[] Queue = new int[N];
        
        for (int i = 0; i < N; i++) {
            Queue[i] = Integer.parseInt(Tokens[i]);
        }

        return Integer.toString(solveProblem(R, k, Queue));
    }

    public static void main(String[] args) {
        try
        {
        	if (args.length == 0)
        	    throw new Exception("Input file missing.");
        	else if (args.length == 1)
        		throw new Exception("Output file missing.");
        	
            InputFile = new BufferedReader(new FileReader(args[0]));
            OutputFile = new BufferedWriter(new FileWriter(args[1]));            		
            Cases = Integer.parseInt(InputFile.readLine());
            
            for (int i = 1; i <= Cases; i++) {
            	OutputFile.write("Case #" + Integer.toString(i) + ": " + processTestCase());
            	OutputFile.newLine();
            }
            
            OutputFile.flush();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}