import java.io.*;

class SnapperChain {

    private static BufferedReader InputFile;
    private static BufferedWriter OutputFile;    
    private static int Cases;

    private static boolean solveProblem(boolean[][] SnapperChain, int K) throws Exception {
        boolean result = false;
        boolean[][] SnapperChainOld = new boolean[SnapperChain.length][SnapperChain[0].length];
        boolean[][] SnapperChainNew = new boolean[SnapperChain.length][SnapperChain[0].length];
        
        for (int r = 0; r < SnapperChain.length; r++) {
        	for (int c = 0; c < SnapperChain[0].length; c++) {
        		SnapperChainOld[r][c] = SnapperChain[r][c];
        		SnapperChainNew[r][c] = SnapperChain[r][c];
        	}
        }

        for (int i = 0; i < K; i++) {
        	for (int j = 0; j < SnapperChainOld.length; j++) {
        		if (SnapperChainOld[j][0]) 
        			SnapperChainNew[j][1] = !SnapperChainOld[j][1];
        		else 
        			SnapperChainNew[j][1] = SnapperChainOld[j][1];
        		
        		if (j != SnapperChainOld.length - 1)
        		   SnapperChainNew[j + 1][0] = SnapperChainNew[j][0] & SnapperChainNew[j][1];
        		else
        		   result = SnapperChainNew[j][0] & SnapperChainNew[j][1];
        	}
        	
            for (int r = 0; r < SnapperChainNew.length; r++) {
            	for (int c = 0; c < SnapperChainNew[0].length; c++) {
            		SnapperChainOld[r][c] = SnapperChainNew[r][c];
            	}
            }
        }

        return result;
    }

    private static String processTestCase () throws Exception {
        String[] Tokens = InputFile.readLine().split(" ");        
        int N = Integer.parseInt(Tokens[0]);
        int K = Integer.parseInt(Tokens[1]);
        boolean[][] SnapperChain = new boolean[N][2];

        SnapperChain[0][0] = true;
        SnapperChain[0][1] = false;
        
        for (int i = 1; i < N; i++) {
        	SnapperChain[i][0] = false;
        	SnapperChain[i][1] = false;
        }
        	
        if (solveProblem(SnapperChain, K)) 
            return "ON";
        else
        	return "OFF";
    }

    public static void main(String[] args) {
        try
        {
        	if (args.length == 0)
        	    throw new Exception("Input file missing.");
        	else if (args.length == 1)
        		throw new Exception("Output file missing.");
        	
            InputFile = new BufferedReader(new FileReader(args[0]));
            OutputFile = new BufferedWriter(new FileWriter(args[1]));            		
            Cases = Integer.parseInt(InputFile.readLine());
            
            for (int i = 1; i <= Cases; i++) {
            	OutputFile.write("Case #" + Integer.toString(i) + ": " + processTestCase());
            	OutputFile.newLine();
            }
            
            OutputFile.flush();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}