
import java.io.File;
import java.io.PrintWriter;

import java.util.LinkedList;
import java.util.Scanner;

public class Translator {

	private File inputFile;
	private LinkedList<String> cases;
	private char[] googlerese_mappings;
	
	public Translator(String filename) {
		
		cases = new LinkedList<String>();
		
		inputFile = new File(filename);
		if (!inputFile.exists()) {
			System.out.println("File not found");
			System.exit(1);
		}
		else {
			googlerese_mappings = new char[26];
			translate();
			writeOutput();
		}
	}
	
	
	private void writeOutput() {

		PrintWriter pw = null;
	
		try {
			pw = new PrintWriter("output.txt");
		}
		catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
		
		int count = 1;
		for (String s : cases) {
		
			pw.println("Case #" + count++ + ": " + s);
		}
		pw.flush();
		pw.close();
	}
	
	
	private void translate() {
		
		Scanner scan = null;
		String tmp;
		char[] chars;
		char c;
		
		try {
			scan = new Scanner(inputFile);
		}
		catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
		
		// Drop number of cases
		scan.nextLine();
		while (scan.hasNextLine()) {
			
			tmp = scan.nextLine();
			chars = new char[tmp.length()];
			tmp.getChars(0, tmp.length(), chars, 0);
			for (int i=0; i<chars.length; i++) {
				
				switch (chars[i]) {
					case 'a': chars[i] = 'y'; break;
					case 'b': chars[i] = 'h'; break;
					case 'c': chars[i] = 'e'; break;
					case 'd': chars[i] = 's'; break;
					case 'e': chars[i] = 'o'; break;
					case 'f': chars[i] = 'c'; break;
					case 'g': chars[i] = 'v'; break;
					case 'h': chars[i] = 'x'; break;
					case 'i': chars[i] = 'd'; break;
					case 'j': chars[i] = 'u'; break;
					case 'k': chars[i] = 'i'; break;
					case 'l': chars[i] = 'g'; break;
					case 'm': chars[i] = 'l'; break;
					case 'n': chars[i] = 'b'; break;
					case 'o': chars[i] = 'k'; break;
					case 'p': chars[i] = 'r'; break;
					case 'q': chars[i] = 'z'; break;
					case 'r': chars[i] = 't'; break;
					case 's': chars[i] = 'n'; break;
					case 't': chars[i] = 'w'; break;
					case 'u': chars[i] = 'j'; break;
					case 'v': chars[i] = 'p'; break;
					case 'w': chars[i] = 'f'; break;
					case 'x': chars[i] = 'm'; break;
					case 'y': chars[i] = 'a'; break;
					case 'z': chars[i] = 'q'; break;
				}
			}
			cases.add(new String(chars));
		}
	}

	
	public static void main(String[] args) {
		
		if (args.length != 1) {
			System.out.println("Invalid parameter length");
			System.exit(1);
		}
		else {
			new Translator(args[0]);
		}
	}
}