import java.io.*;
import java.math.BigInteger;
import java.util.*;

import org.jfree.data.function.PowerFunction2D;

public class r2a
{
    int classtree[][] = new int[4][4];
    boolean emptyCells = false;
    int ret = 0;
    String output = "No";

    /**
     * @param args
     */
    public static void main(String[] args)
    {
        r2a mk = new r2a();
        try {
            FileInputStream fstream = new FileInputStream("d:/cjinput.txt");
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String str;
            int i = 0;
            while ((str = br.readLine()) != null) {
                i++;
                mk.emptyCells = false;
                if (i == 1)
                    continue;
                for (int x = 0; x < 4; x++) {
                    for (int y = 0; y < 4; y++) {
                        if (str.charAt(y) == 'X')
                            mk.classtree[x][y] = 1;
                        else if (str.charAt(y) == 'O')
                            mk.classtree[x][y] = -1;
                        else if (str.charAt(y) == 'T')
                            mk.classtree[x][y] = 10;
                        else {
                            mk.classtree[x][y] = 1000;
                            mk.emptyCells = true;
                        }                        
                    }
                    str = br.readLine();
                }
                mk.ret=0;
                mk.evaluate(i);
                if (mk.ret == 1)
                    System.out.println("Case #" + (i-1) + ": " + "X won");
                else if (mk.ret == 2)
                    System.out.println("Case #" + (i-1) + ": " + "O won");
                else if (mk.ret == 0 && mk.emptyCells)
                    System.out.println("Case #" + (i-1) + ": " + "Game has not completed");
                else
                    System.out.println("Case #" + (i-1) + ": " + "Draw");

            }
            in.close();
        }
        catch (Exception e) {
            System.err.println(e);
        }

    }

    private boolean evaluate(int rowNum)
    {
        checkDiag();
        if (ret == 0)
            checkRows();
        if (ret == 0)
            checkCols();

        return true;
    }

    /**
     * 
     */
    private void checkDiag()
    {
        int sum = classtree[0][0];
        for (int i = 1; i < 4; i++) {
            sum += classtree[i][i];
        }

        if (checkVal(sum))
            return;

        sum = classtree[0][3];
        for (int i = 1; i < 4; i++)
            sum += classtree[i][3 - i];

        if (checkVal(sum))
            return;

    }

    /**
     * 
     */
    private void checkRows()
    {

        for (int i = 0; i < 4; i++) {
            int sum = 0;
            for (int j = 0; j < 4; j++) {
                sum += classtree[i][j];
            }

            if (checkVal(sum))
                return;
        }

    }

    /**
     * @param sum
     */
    protected boolean checkVal(int sum)
    {
        if (sum == 13 || sum == 4) {
            ret = 1;
            return true;
        }
        else if (sum == 7 || sum == -4) {
            ret = 2;
            return true;
        }
        return false;
    }

    /**
     * 
     */
    private void checkCols()
    {
        for (int i = 0; i < 4; i++) {
            int sum = 0;
            for (int j = 0; j < 4; j++) {
                sum += classtree[j][i];
            }

            if (checkVal(sum))
                return;
        }

    }

}
