import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author dpark3542
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "B-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("b.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskB solver = new TaskB();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskB {
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            out.print("Case #" + testNumber + ": ");
            int n = in.nextInt(), p = in.nextInt();
            int[] r = in.nextIntArray(n);
            int[][] q = new int[n][p], l = new int[n][p], u = new int[n][p];
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < p; j++) {
                    q[i][j] = in.nextInt();
                    l[i][j] = (int) Math.ceil(q[i][j] / (1.1 * r[i]));
                    u[i][j] = (int) Math.floor(q[i][j] / (0.9 * r[i]));
                }
            }
            // small
            int ans = 0;
            if (n == 1) {
                for (int j = 0; j < p; j++) {
                    if (l[0][j] <= u[0][j]) {
                        ans++;
                    }
                }
            }
            if (n == 2) {
                int a = 0;
                DisjointSetUnion dsu = new DisjointSetUnion(p + 1);
                for (int i = 0; i < p; i++) {
                    if (l[0][i] > u[0][i]) {
                        continue;
                    }
                    a++;
                    for (int j = 0; j < p; j++) {
                        if (l[1][j] > u[1][j]) {
                            continue;
                        }
                        if (Math.max(l[0][i], l[1][j]) <= Math.min(u[0][i], u[1][j])) {
                            dsu.update(p, j);
                        }
                    }
                }
                ans = Math.min(a, p + 1 - dsu.setCount);
            }
            out.println(ans);
        }

    }

    static class DisjointSetUnion {
        public int size;
        public int setCount;
        private int[] root;
        private int[] height;

        public DisjointSetUnion(int n) {
            size = n;
            root = new int[n];
            height = new int[n];
            Arrays.fill(root, -1);
            Arrays.fill(height, 1);
            setCount = n;
        }

        private int superRoot(int v) {
            if (v < 0 || v >= size) {
                throw new IndexOutOfBoundsException(Integer.toString(v));
            }
            while (root[v] != -1) {
                v = root[v];
            }
            return v;
        }

        public void update(int u, int v) {
            int su = superRoot(u), sv = superRoot(v);
            if (su == sv) {
                return;
            }
            setCount--;
            if (height[su] > height[sv]) {
                root[sv] = su;
            } else if (height[sv] == height[su]) {
                root[sv] = su;
                height[su]++;
            } else {
                root[su] = sv;
            }
        }

    }

    static class InputReader {
        private BufferedReader br;
        private StringTokenizer st;

        public InputReader(InputStream stream) {
            br = new BufferedReader(new InputStreamReader(stream), 32768);
            st = null;
        }

        public String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return st.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public int[] nextIntArray(int n) {
            int[] a = new int[n];
            for (int i = 0; i < n; i++) {
                a[i] = nextInt();
            }
            return a;
        }

    }
}

