import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author dpark3542
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "C-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("c.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskC solver = new TaskC();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskC {
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            out.print("Case #" + testNumber + ": ");
            long n = in.nextLong(), k = in.nextLong();
            long f = (long) (Math.log(k) / Math.log(2));
            Pair<Long, Long> p;
            if (k - Math.pow(2, f) < modOffset(n + 1, (long) Math.pow(2, f))) {
                p = mlr((long) (n / Math.pow(2, f)));
            } else {
                p = mlr((long) (n / Math.pow(2, f)) - 1);
            }
            out.println(Math.max(p.k, p.v) + " " + Math.min(p.k, p.v));
        }

        private Pair<Long, Long> mlr(long x) {
            if (x % 2 == 0) {
                return new Pair<Long, Long>(x / 2 - 1, x / 2);
            } else {
                return new Pair<Long, Long>((x - 1) / 2, (x - 1) / 2);
            }
        }

        private long modOffset(long x, long m) {
            long ans = x % m;
            if (ans == 0) {
                return m;
            } else {
                return ans;
            }
        }

    }

    static class InputReader {
        private BufferedReader br;
        private StringTokenizer st;

        public InputReader(InputStream stream) {
            br = new BufferedReader(new InputStreamReader(stream), 32768);
            st = null;
        }

        public String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return st.nextToken();
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

    }

    static class Pair<K, V extends Comparable> implements Comparable<Pair<K, V>> {
        public K k;
        public V v;

        public Pair(K key, V value) {
            k = key;
            v = value;
        }

        public boolean equals(Pair<K, V> p) {
            return k.equals(p.k) && v.equals(p.v);
        }

        public boolean equals(Object o) {
            if (this == o) {
                return true;
            }
            if (!(o instanceof Pair)) {
                return false;
            }
            return equals((Pair) o);
        }

        public int compareTo(Pair<K, V> p) {
            return v.compareTo(p.v);
        }

        public String toString() {
            return "<" + k.toString() + ", " + v.toString() + ">";
        }

        public int hashCode() {
            return 31 * k.hashCode() + v.hashCode();
        }

    }
}

