import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author dpark3542
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "A-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("a.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskA solver = new TaskA();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskA {
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            out.println("Case #" + testNumber + ":");
            int r = in.nextInt(), c = in.nextInt();
            char[][] a = new char[r][c];
            for (int i = 0; i < r; i++) {
                String s = in.next();
                a[i] = s.toCharArray();
            }
            int v = 0;
            out:
            while (v < r) {
                for (int j = 0; j < c; j++) {
                    if (a[v][j] != '?') {
                        break out;
                    }
                }
                v++;
            }
            for (int i = v; i < r; i++) {
                int t = 0;
                while (t < c && a[i][t] == '?') {
                    t++;
                }
                if (t == c) {
                    if (i > 0) {
                        a[i] = a[i - 1];
                    }
                } else {
                    for (int j = 0; j < t; j++) {
                        a[i][j] = a[i][t];
                    }
                    for (int j = t; j < c; j++) {
                        if (a[i][j] == '?') {
                            a[i][j] = a[i][j - 1];
                        }
                    }
                }
            }
            for (int i = 0; i < v; i++) {
                a[i] = a[v];
            }
            for (int i = 0; i < r; i++) {
                for (int j = 0; j < c; j++) {
                    out.print(a[i][j]);
                }
                out.println();
            }
        }

    }

    static class InputReader {
        private BufferedReader br;
        private StringTokenizer st;

        public InputReader(InputStream stream) {
            br = new BufferedReader(new InputStreamReader(stream), 32768);
            st = null;
        }

        public String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return st.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

    }
}

