import java.util.*;
import java.io.*;
import java.math.*;

public class FairSquare
{
	public static BigInteger biSqrt(BigInteger x)
	{
		if(x.equals(BigInteger.ZERO) || x.equals(BigInteger.ONE))
			return x;
		
		BigInteger two = new BigInteger("2");
		BigInteger y;
		for (y = x.divide(two); y.compareTo(x.divide(y)) > 0; y = ((x.divide(y)).add(y)).divide(two));
		return y;
	}
	
	public static void main(String[] args) throws Exception 
	{
		File infile = new File("C:\\dev\\codejam\\C-small-attempt0.in");
		File outfile = new File("C:\\dev\\codejam\\output.txt");
		BufferedReader br = new BufferedReader(new FileReader(infile));
		BufferedWriter bw = new BufferedWriter(new FileWriter(outfile));
		
		boolean[] isFS = new boolean[10000001];
		String s;
		for(int i = 1; i < 10000001; i++)
		{
			s = Integer.toString(i);
			boolean pal = true;
			for(int j = 0; j < s.length()/2; j++)
			{
				if(s.charAt(j) != s.charAt(s.length() - 1 - j))
					pal = false;
			}
			if(!pal)
				continue;
			BigInteger square = new BigInteger(Integer.toString(i));
			square = square.pow(2);
			s = square.toString();
			boolean FS = true;
			for(int j = 0; j < s.length()/2; j++)
			{
				if(s.charAt(j) != s.charAt(s.length() - 1 - j))
					FS = false;
			}
			isFS[i] = FS;
		}
		
		int cases = Integer.parseInt(br.readLine());
		for(int i = 0; i < cases; i++)
		{
			s = br.readLine();
			String[] splits = s.split(" ");
			BigInteger n = new BigInteger(splits[0]);
			n = n.subtract(BigInteger.ONE);
			BigInteger m = new BigInteger(splits[1]);
			
			int count = 0;
			for(int j = biSqrt(n).intValue() + 1; j < biSqrt(m).intValue() + 1; j++)
			{
				if(isFS[j])
				{
					count++;
				}
			}
			
			bw.write("Case #" + (i + 1) + ": " +count);
			
			if((i + 1) < cases)
			{
				bw.write("\n");
			}
			bw.flush();
		}
		
		/*for(int i = 0; i < 10000001; i++)
		{
			if(isFS[i])
				System.out.println(i + ": " + isFS[i]);
		}*/
	}

}
