package codejam3;

/**
 *
 * @author Gusano
 */
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.LinkedList;

public class Main {

    String nombreEntrada;
    LinkedList<String> contenidoEntrada, contenidoSalida;
    double contador = 0;

    void lectura() throws Exception {
        File fichero = new File(this.nombreEntrada); // se instancia un objeto de clase File
        if (fichero.exists()) { // si el fichero existe

            FileReader fr = new FileReader(fichero);
            BufferedReader br = new BufferedReader(fr); //se crea una buffer de lectura
            String linea = br.readLine(); // se lee la primera linea
            int i = 0; // contador para ver cantidad de lineas no nulas
            while (linea != null) { // mientras la linea no sea nula
                this.contenidoEntrada.addLast(linea); // guardar la linea en la lista contenidoEntrada
                linea = br.readLine(); // se lee la linea siguiente
                i++; // se aumenta en 1 el contador de lineas no nulas
            }
            br.close(); // se cierra el buffer y el archivo de entrada.


        } else { // si el archivo no existe, se muestra el mensaje de error correspondiente
            System.out.println("Archivo no existe");
        }
    }

    void escritura(LinkedList<String> contenido, String nombre_salida) {
        try {
            File fichero = new File(nombre_salida);
            PrintWriter pw = new PrintWriter(fichero);
            for (int i = 0; i < contenido.size(); i++) {
                if (i < (contenido.size() - 1)) {
                    pw.println("Case #" + (i + 1) + ": " + contenido.get(i));
                } else {
                    pw.print("Case #" + (i + 1) + ": " + contenido.get(i));
                }
            }
            pw.close();
        } catch (Exception e) {
            System.out.println("No se pudo escribir el archivo");
        }
    }
    public int[] ordenarQuicksort(int[] vector, int primero, int ultimo){
        int i=primero, j=ultimo;
        int pivote=vector[(primero + ultimo) / 2];
        int auxiliar;

        do{
                while(vector[i]<pivote) i++;
                while(vector[j]>pivote) j--;

                if (i<=j){
                    if(i<j){
                        contador +=2;
                        }
                    auxiliar=vector[j];
                        vector[j]=vector[i];
                        vector[i]=auxiliar;
                        i++;
                        j--;
                      
                }

        } while (i<=j);

        if(primero<j) ordenarQuicksort(vector,primero, j);
        if(ultimo>i) ordenarQuicksort(vector,i, ultimo);
        return vector;
    }

    public String solve() {

        String tamArray = this.contenidoEntrada.pop();

        int n = Integer.parseInt(tamArray);

      
        String arreglo[] = this.contenidoEntrada.pop().split(" ");
        int vector[] = new int[n];
        for(int i = 0;i<n;i++){
            vector[i] = Integer.parseInt(arreglo[i]);
        }
        vector = this.ordenarQuicksort(vector, 0, n-1);

        String solucion = new String();
        DecimalFormatSymbols simbolos = new DecimalFormatSymbols();
        simbolos.setDecimalSeparator('.');
        DecimalFormat formato = new DecimalFormat("0.000000", simbolos);
        solucion = formato.format(contador);
        System.out.println(solucion);
        contador = 0;
        return solucion;
    }

    public static void main(String[] args) throws Exception {

        Main main = new Main();
        main.nombreEntrada = args[0];
        main.contenidoEntrada = new LinkedList<String>();
        main.contenidoSalida = new LinkedList<String>();
        main.lectura();
        int casos = Integer.parseInt(main.contenidoEntrada.pop());
        for (int i = 0; i < casos; i++) {

            main.contenidoSalida.add(main.solve());

        }

        String salida[] = main.nombreEntrada.split("\\.");
        main.escritura(main.contenidoSalida, salida[0] + ".out");

    }
}
