package mylib;

import java.io.*;
import java.util.*;
import java.math.*;

public class mylib {
    
    public static boolean DEBUG = true;
    private static final BigDecimal SQRT_DIG = new BigDecimal(150);
    private static final BigDecimal SQRT_PRE = new BigDecimal(10).pow(SQRT_DIG.intValue());

    public static void println(Object string){
        if(DEBUG)
            System.out.println(string);
    }
    
    public static BigInteger sqrt(BigInteger n) {
        BigInteger a = BigInteger.ONE;
        BigInteger b = new BigInteger(n.shiftRight(5).add(new BigInteger("8")).toString());
        while(b.compareTo(a) >= 0) {
            BigInteger mid = new BigInteger(a.add(b).shiftRight(1).toString());
            if(mid.multiply(mid).compareTo(n) > 0) b = mid.subtract(BigInteger.ONE);
            else a = mid.add(BigInteger.ONE);
        }
        return a.subtract(BigInteger.ONE);
    }
    private static BigDecimal sqrtNewtonRaphson  (BigDecimal c, BigDecimal xn, BigDecimal precision){
        BigDecimal fx = xn.pow(2).add(c.negate());
        BigDecimal fpx = xn.multiply(new BigDecimal(2));
        BigDecimal xn1 = fx.divide(fpx,2*SQRT_DIG.intValue(),RoundingMode.HALF_DOWN);
        xn1 = xn.add(xn1.negate());
        BigDecimal currentSquare = xn1.pow(2);
        BigDecimal currentPrecision = currentSquare.subtract(c);
        currentPrecision = currentPrecision.abs();
        if (currentPrecision.compareTo(precision) <= -1){
            return xn1;
        }
        return sqrtNewtonRaphson(c, xn1, precision);
    }

    public static BigDecimal bigSqrt(BigDecimal c){
        return sqrtNewtonRaphson(c,new BigDecimal(1),new BigDecimal(1).divide(SQRT_PRE));
    }
    
    public static BigInteger gcd(BigInteger a, BigInteger b){
         if(b.equals(BigInteger.valueOf(0)))
             return a;
         else
             return gcd(b, a.mod(b));
    }
    
    public static ArrayList<Integer> StringToArray(String strin){
        String[] strArray = strin.split(" ");
        ArrayList<Integer> intArray = new ArrayList<Integer>(strArray.length);
        for(int i = 0; i < strArray.length; i++) {
            intArray.add(Integer.parseInt(strArray[i]));
        }
        
        return intArray;
    }
    public static int[] StringToIntArray(String strin){
       String[] strArray = strin.split("\\s");
        int[] intArray = new int[strArray.length];
        for(int i = 0; i < strArray.length; i++) {
            intArray[i] = Integer.parseInt(strArray[i], 10);
        }
        
        return intArray;
    }
    public static long[] StringToLongArray(String strin){
       String[] strArray = strin.split(" ");
        long[] intArray = new long[strArray.length];
        for(int i = 0; i < strArray.length; i++) {
            intArray[i] = Long.parseLong(strArray[i], 10);
        }
        
        return intArray;
    }
    public static double[] StringToDoubleArray(String strin){
       String[] strArray = strin.split(" ");
        double[] intArray = new double[strArray.length];
        for(int i = 0; i < strArray.length; i++) {
            intArray[i] = Double.parseDouble(strArray[i]);
        }
        
        return intArray;
    }    
     public static BigInteger[] StringToBigArray(String strin){
        String[] strArray = strin.split(" ");
        BigInteger[] intArray = new BigInteger[strArray.length];
        for(int i = 0; i < strArray.length; i++) {
            intArray[i] = new BigInteger(strArray[i]);
        }
        
        return intArray;
    }
     
   public static int[] IntConcat(int[] a, int[] b) {
       int aLen = a.length;
       int bLen = b.length;
       int[] c= new int[aLen+bLen];
       System.arraycopy(a, 0, c, 0, aLen);
       System.arraycopy(b, 0, c, aLen, bLen);
       return c;
}
}