import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class TicTacToeTomek {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Scanner in;
		BufferedWriter out;
		try {
			in = new Scanner(new File("A-small-attempt0.in"));
			out = new BufferedWriter(new FileWriter(new File("A-small.out")));
		} catch (Exception e) {
			e.printStackTrace();
			return;
		}
		
		int cases = in.nextInt();
		in.nextLine();
		for (int T = 1; T <= cases; T++){
			String[] board = new String[4];
			for (int i = 0; i < 4; i++){
				board[i] = in.nextLine();
			}
			in.nextLine();
			
			boolean x = horizontalWin(board, 'X') || verticalWin(board, 'X') || diagWin(board, 'X');
			boolean y = horizontalWin(board, 'O') || verticalWin(board, 'O') || diagWin(board, 'O');
			
			try{
			if (x) out.write("Case #" + T + ": X won\n");
			else if (y) out.write("Case #" + T + ": O won\n");
			else if (board[0].contains(".") || board[1].contains(".") || board[2].contains(".") || board[3].contains(".")) out.write("Case #" + T + ": Game has not completed\n");
			else out.write("Case #" + T + ": Draw\n");
			}catch(IOException e){e.printStackTrace();}
		}
		
		try {
			out.flush();out.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		in.close();
		
	}
	
	private static boolean horizontalWin(String[] board, char player){
		for (int i = 0; i < 4; i++){
			boolean win = true;
			for (int j = 0; j < 4; j++){
				if (board[i].charAt(j) != player && board[i].charAt(j) != 'T') win = false;
			}
			if (win) return win;
		}
		return false;
	}
	
	private static boolean verticalWin(String[] board, char player){
		for (int i = 0; i < 4; i++){
			boolean win = true;
			for (int j = 0; j < 4; j++){
				if (board[j].charAt(i) != player && board[j].charAt(i) != 'T') win = false;
			}
			if (win) return win;
		}
		return false;
	}
	
	private static boolean diagWin(String[] board, char player){
		boolean win = true;
		boolean win2 = true;
		for (int i = 0; i < 4; i++){
			if (board[i].charAt(i) != player && board[i].charAt(i) != 'T') win = false;
			if (board[3-i].charAt(i) != player && board[3-i].charAt(i) != 'T') win2 = false;
			
		}
		return win || win2;
	}

}
