import java.io.*;
import java.util.*;

public class B {

	private static PrintWriter out;
	  
	public static final String Path = "c:\\CodeJam\\"; 
	public static final String SNAME = "B-small-attempt1";
	public static final String LNAME = "B-large";
	public static final String TNAME = "test";
	public static final String SPNAME = "B-small-practice";
	public static final String LPNAME = "B-large-practice";
	
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileReader(Path + SNAME + ".in"));
		out = new PrintWriter(new BufferedWriter(new FileWriter(Path + SNAME + ".out")));
		
		int cases = in.nextInt();
		for(int i = 1; i <= cases; i++) {
			out.print("Case #" + i + ": ");
			int N = in.nextInt();
			int R = in.nextInt();
			int O = in.nextInt();
			int Y = in.nextInt();
			int G = in.nextInt();
			int B = in.nextInt();
			int V = in.nextInt();
			
			Map<String, Integer> count = new HashMap<String, Integer>();
		    count.put("R", R);
		    count.put("O", O);
		    count.put("Y", Y);
		    count.put("G", G);
		    count.put("B", B);
		    count.put("V", V);
		    
			calculate(N, count);
		}
		
		out.close();
	}
	
	public static void calculate(int N, Map<String, Integer> count) {
		
		Map<String, List<String>> possible = getPossible();
		
		String current = "";
		
		int counter = 0;
        String first = "";
        
		StringBuilder s = new StringBuilder();
		while (counter < N) {
			
			String next = getNext(current, count, possible, first);
			if (next.isEmpty()) {
				out.println("IMPOSSIBLE");
				return;
			}
			count.put(next, count.get(next) - 1);
			
			if (counter == 0)
				first = next;
			
			s.append(next);
			counter++;
			current = next;
		}
		
		if (!possible.get(first).contains(current)){
			out.println("IMPOSSIBLE");
			return;
		}
		
		out.println(s.toString());
	}
	
	public static String getNext(String current, Map<String, Integer> count, Map<String, List<String>> possible, String first){
		
		ArrayList<String> complex = new ArrayList<String>();
		complex.add("O");
		complex.add("G");
		complex.add("V");
		
		ArrayList<String> simple = new ArrayList<String>();
		simple.add("R");
		simple.add("Y");
		simple.add("B");
	
	
		String color = "";
		if (current.isEmpty()){
			color = getMax(simple, count, first);
			
			if (color.isEmpty())
				color = getMax(complex, count, first);
		} else {
			
			List<String> p = possible.get(current);
			color = getMax(p, count, first);
		}
		
		return color;
	}
	
	public static String getMax(List<String> color, Map<String, Integer> count, String first) {
		String colorS = "";
		int max = 0;
		
		for(int i = 0; i < color.size(); i++) {
			if (count.get(color.get(i)) > max) {
				max = count.get(color.get(i));
				colorS = color.get(i);
				
				if (colorS.equals("O") || colorS.equals("G") || colorS.equals("V")) {
					break;
				}
			}
		}
		
		if (!first.isEmpty() && max == 1 && color.contains(first) && count.get(first) == 1) {
			return first;
		}
		
		return colorS;
	}
	
	public static Map<String, List<String>> getPossible() {

		Map<String, List<String>> possibles = new HashMap<String, List<String>>();
	
		ArrayList<String> p = new ArrayList<String>();
		p.add("G");
		p.add("Y");
		p.add("B");
		possibles.put("R", p);
		
		
		p = new ArrayList<String>();
		p.add("V");
		p.add("R");
		p.add("B");
		possibles.put("Y", p);
		
		
		p = new ArrayList<String>();
		p.add("O");
		p.add("R");
		p.add("Y");
		possibles.put("B", p);
		
		
		p = new ArrayList<String>();
		p.add("B");
		possibles.put("O", p);
		
		p = new ArrayList<String>();
		p.add("R");
		possibles.put("G", p);
		
		p = new ArrayList<String>();
		p.add("Y");
		possibles.put("V", p);
		
		return  possibles;
	}
}

