import java.io.*;
import java.util.*;

public class Bathroom {
	private static PrintWriter out;
	  
	public static final String Path = "c:\\CodeJam\\"; 
	public static final String SNAME = "C-small-1-attempt1";
	public static final String LNAME = "C-large";
	
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileReader(Path + SNAME + ".in"));
		out = new PrintWriter(new BufferedWriter(new FileWriter(Path + SNAME + ".out")));
		
		int cases = in.nextInt();
		for(int i = 1; i <= cases; i++) {
			out.print("Case #" + i + ": ");
			calculate(in.nextInt(), in.nextInt());
		}
		
		out.close();
	}
	
	
	public static void calculate(int n, int k){
		
		boolean[] occupied = new boolean[n + 1];
		
		List<Segment> segs = new ArrayList<Segment>();
		segs.add(new Segment(1, n));
		
		int counter = 0;
		int currentStall = 0;
		
		while (counter < k) {
			int index = 0;
			Segment maxRange = segs.get(index);
			for(int i = 0; i < segs.size(); i++) {
				if (segs.get(i).range() > maxRange.range()){
					index = i;
					maxRange = segs.get(i);
				}
			}
			
			currentStall = maxRange.median();
			occupied[currentStall] = true;
			
			counter++;
			
			if (counter < k) {
				if (maxRange.range() == 0) {
					segs.remove(maxRange);
				} else {
					if (maxRange.range() > 1) {
						segs.add(index,  new Segment(maxRange.left, currentStall - 1));
					}
					maxRange.left = currentStall + 1;
					 
				}
			}
		}
		
		int Ls = 0;
		int Rs = 0;
		int copy = currentStall;
				
		while (copy > 1 && !occupied[copy - 1]){
			Ls++;
			copy--;
		}
		
		copy = currentStall;
		while (copy < n && !occupied[copy + 1]){
			Rs++;
			copy++;
		}
			
		
		out.println(Math.max(Ls, Rs) + " " + Math.min(Ls, Rs));
	}
}

class Segment {
	public int left;
	public int right;
	
    public Segment(int l, int r) {
		left = l;
		right = r;
	}
    
    public int range() {
    	return right - left;
    }
    
    public int median() {
    	return (right + left) / 2; 
    }
}

