import java.io.*;
import java.util.*;

public class Bathroom {
	private static PrintWriter out;
	  
	public static final String Path = "c:\\CodeJam\\"; 
	public static final String SNAME = "C-small-2-attempt1";
	public static final String LNAME = "C-large";
	public static final String TNAME = "Test";
	
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileReader(Path + LNAME + ".in"));
		out = new PrintWriter(new BufferedWriter(new FileWriter(Path + LNAME + ".out")));
		
		int cases = in.nextInt();
		for(int i = 1; i <= cases; i++) {
			out.print("Case #" + i + ": ");
			calculate(in.nextLong(), in.nextLong());
		}
		
		out.close();
	}
	
	
	public static void calculate(long n, long k){
		
		long Ls = 0;
		long Rs = 0;
		
		HashMap<Long, Long> hmap = new HashMap<Long, Long>();
		Comparator<Long> comparator = new LongComparator();
		 
		PriorityQueue<Long> queue = 
		            new PriorityQueue<Long>(comparator);
		  
		queue.add(n);
		hmap.put(n, 1l);
		
		long count = 0;
		while(!queue.isEmpty()) {
			
			long current_n = queue.remove();
			long n_count = hmap.get(current_n);
			count = count + n_count;
			
			long median = current_n / 2;
			if (current_n % 2 == 1)
			   median++;
			
			Ls = median - 1;
			Rs = current_n - median;
			
			if (count >= k) {
				break;
			} else {
			  if (Ls > 0) {
				if (hmap.containsKey(Ls)) {
					hmap.put(Ls, hmap.get(Ls) + n_count);
				} else {
					hmap.put(Ls, n_count);
					queue.add(Ls);
				}
			  }
				
			  if (Rs > 0 ) {
				if (hmap.containsKey(Rs)) {
					hmap.put(Rs, hmap.get(Rs) + n_count);
				} else {
					hmap.put(Rs, n_count);
					queue.add(Rs);
				}
			  }
			}
		}
		
		out.println(Math.max(Ls, Rs) + " " + Math.min(Ls, Rs));
	}
}

class LongComparator implements Comparator<Long>
{
    @Override
    public int compare(Long x, Long y)
    {
        if (x > y)
        {
            return -1;
        }
        if (x < y)
        {
            return 1;
        }
        return 0;
    }
}

