package com.google.codejam.coinjam;

import java.io.*;
import java.util.*;

public class CoinJam {

	private static String filename = "small";
	private static ArrayList<Long> primes = new ArrayList<Long>();
	
	public static void main(String[] args) throws Exception {
		RandomAccessFile input = new RandomAccessFile(filename + "_in.txt", "r");
		RandomAccessFile output = new RandomAccessFile(filename + "_out.txt", "rw");
		
		primes.add((long)2);
						
			for(int p = 3; p < Math.pow(2, 16); p++)addPrime(p);
			
		int cases = Integer.valueOf(input.readLine());
				
		for(int i = 0; i < cases; i++){
			String out = "Case #" + (i + 1) + ":\n";
			
			String[] arguments = input.readLine().split(" ");
			
			int N = Integer.valueOf(arguments[0]) - 2,
				J = Integer.valueOf(arguments[1]);
			
			for(int n = 0; J > 0 && n < Math.pow(2, N); n++){
				int temp = n;
				
				String binary = "";
				for(int a = 0; a < N; a++){
					binary = temp % 2 + binary;
					temp /= 2;
				}
				
				ArrayList<Long> candidates = new ArrayList<Long>();
				
				boolean prime = false;
				
				for(int b = 2; !prime && b <= 10; b++){
					long candidate = Long.valueOf("1" + binary + "1", b);
					
					if(primes.contains(candidate) || addPrime(candidate)){
						prime = true;
						break;
					}
					
					if(!prime){
						candidates.add(candidate);
					}else{
						break;
					}
				}
				
				if(candidates.size() == 9){
					J--;
					
					out += "1" + binary + "1";
					
					for(long candidate : candidates){
						for(long c = 2; c <= Math.sqrt(candidate) && !candidates.contains(c); c++){
							if(candidate % c == 0){
								out += " " + c;
								break;
							}
						}
					}
					
					out += "\n";
				}
				
			}
			
			System.out.print(out);
			output.writeBytes(out);
		}
		
		output.close();
		input.close();
	}
	
	private static boolean addPrime(long candidate){
		boolean pp = true;
		for(long prime : primes){
			if(candidate % prime == 0){
				// not prime
				pp = false;
				break;
			}
		}
		if(pp){
			for(long ppp = primes.get(primes.size() - 1) + 1; ppp <= Math.sqrt(candidate); ppp++){
				if(candidate % ppp == 0){
					pp = false;
					break;
				}
			}
		}
		if(pp){
			primes.add((long)candidate);
		}
		return pp;
	}

}
