package com.google.codejam.deceitfulwar;

import java.io.RandomAccessFile;
import java.util.ArrayList;

public class DeceitfulWar {

	private static String filename = "small";
	
	public static void main(String[] args) throws Exception {
		RandomAccessFile in = new RandomAccessFile(filename + ".in", "r");
		RandomAccessFile out = new RandomAccessFile(filename + ".out", "rw");
		
		int cases = Integer.parseInt(in.readLine());
		
		for(int i = 0; i < cases; i++){
			
			in.readLine();
			
			String[] N = in.readLine().split(" ");
			String[] K = in.readLine().split(" ");
			
			out.writeBytes("Case #" + (i + 1) + ": " + dwar(N, K) + " " + war(N, K) + "\n");	

		}
		
		out.close();
		in.close();
	}

	private static int war(String[] N, String[] K){
		
		ArrayList<Double> naomi = toArray(N);
		ArrayList<Double> ken = toArray(K);
		
		int score = naomi.size();
		
		for(int n = 0; n < naomi.size(); n++){
			for(int k = 0; k < ken.size(); k++){
				if(ken.get(k) > naomi.get(n)){
					ken.remove(k);
					score--;
					k--;
					
					break;
				}
			}
		}
		return score;
	}
	
	private static int dwar(String[] N, String[] K){
		
		ArrayList<Double> naomi = toArray(N);
		ArrayList<Double> ken = toArray(K);
		
		int score = 0;
		
		int end = naomi.size() - 1;
		
		for(;end >= 0; end--){
			if(naomi.get(end) > ken.get(end)){
				score++;
			}else{
				break;
			}
		}
				
		for(int n = 0; n < end; n++){
			if(naomi.get(n) > ken.get(n)){
				score++;
			}else{
				if(n != end){
					score++;
					end--;
				}
			}
			
			for(;end >= 0; end--){
				if(naomi.get(end) > ken.get(end)){
					score++;
					end--;
				}else{
					break;
				}
			}
		}
		
		return score;
	}
	
	private static ArrayList<Double> toArray(String[] doubles){
		
		@SuppressWarnings("serial")
		ArrayList<Double> array = new ArrayList<Double>(){
			
			@Override
			public boolean add(Double e) {
				for(int d = 0; d < super.size(); d++){
					if(super.get(d) > e){
						super.add(d, e);
						return true;
					}
				}
				return super.add(e);
			}
			
		};
		for(String d : doubles)array.add(Double.parseDouble(d));
		
		return array;
	}
}
