package com.google.codejam.problema;

import java.io.*;
import java.util.*;

public class ProblemA {

	private static String filename = "small";
	
	public static void main(String[] args) throws Exception {
		RandomAccessFile input = new RandomAccessFile(filename + "_in.txt", "r");
		RandomAccessFile output = new RandomAccessFile(filename + "_out.txt", "rw");
		
		int cases = Integer.valueOf(input.readLine());
		
		for(int i = 0; i < cases; i++){
			
			int size = Integer.valueOf(input.readLine());
			String[][] matrix = new String[size][size];
			
			for(int j = 0; j < size; j++){
				String line = input.readLine();
				
				for(int k = 0; k < line.length(); k++){
					matrix[j][k] = String.valueOf(line.charAt(k));
				}
			}
			
			String solved = solve(matrix);
			
			output.writeBytes("Case #" + (i + 1) + ":\n" + solved + "\n");
			System.out.println("Case #" + (i + 1) + ":\n" + solved);
		}
		
		output.close();
		input.close();
	}

	private static String solve(String[][] matrix){
		double[] wps = new double[matrix.length];
		double[] owps = new double[matrix.length];
		double[] oowps = new double[matrix.length];
		
		for(int i = 0; i < matrix.length; i++)wps[i] = wp(matrix[i], -1);
		for(int i = 0; i < matrix.length; i++)owps[i] = owp(matrix, i);
		for(int i = 0; i < matrix.length; i++)oowps[i] = oowp(matrix, owps, i);
		
		String solved = "";
		
		for(int i = 0; i < matrix.length; i++){
			solved += ((wps[i] * 0.25) + (owps[i] * 0.5) + (oowps[i] * 0.25)) + "\n";
		}
		return solved.substring(0, solved.lastIndexOf("\n"));
	}
	
	private static double wp(String[] stats, int out){
		double games = 0.0;
		double wins = 0.0;
		
		int counter = 0;
		for(String s : stats){
			if(counter != out){
				if(!s.equals(".")){
					if(s.equals("1")){
						wins++;
					}
					games++;
				}
			}
			counter++;
		}
		if(games == 0.0)return 0.0;
		return wins / games;
	}
	
	private static double owp(String[][] matrix, int out){
		double games = 0.0;
		double owp = 0.0;
		
		for(int i = 0; i < matrix.length; i++){
			if(i != out){
				if(!matrix[i][out].equals(".")){				
					owp += wp(matrix[i], out);
					games++;
				}
			}
		}
		return owp / games;
	}
	
	private static double oowp(String[][] matrix, double[] owps, int out){
		double oowp = 0.0;
		double total = 0.0;
		
		for(int i = 0; i < owps.length; i++){
			if(i == out)continue;
			if(matrix[i][out].equals("."))continue;
			oowp += owps[i];
			total++;
		}
		return oowp / total;
	}
}
