package com.google.codejam.tictactoetomek;

import java.io.RandomAccessFile;

public class TicTacToeTomek {

	private static String filename = "large";
	
	public static void main(String[] args) throws Exception {
		RandomAccessFile input = new RandomAccessFile(filename + ".in", "r");
		RandomAccessFile output = new RandomAccessFile(filename + ".out", "rw");
				
		int cases = Integer.valueOf(input.readLine());
		for(int i = 0; i < cases; i++){
			
			String line;
			String[][] board = new String[4][4];
			
			for(int r = 0; r < 4; r++){
				line = input.readLine();
				for(int c = 0; c < 4; c++){
					board[r][c] = String.valueOf(line.charAt(c));					
				}
			}
			input.readLine();
			
			String solved = solve(board);
			
			if(solved == null){
				if(hasMoves(board)){
					solved = "Game has not completed";
				}else{
					solved = "Draw";
				}
			}else{
				solved += " won";
			}
			output.writeBytes("Case #" + (i + 1) + ": " + solved + "\n");
		}
		
		output.close();
		input.close();
	}

	private static String solve(String[][] board){
		String winner = null;
		
		if(!board[0][0].equals(".")){
			for(int p = 0; p < 4; p++){
				if((winner == null) || board[p][p].equals(winner) || board[p][p].equals("T")){
					if(!board[p][p].equals("T"))winner = board[p][p];
					continue;
				}
				winner = null;
				break;
			}
		}
		if(winner != null)return winner;
		
		if(!board[3][0].equals(".")){
			for(int p = 0; p < 4; p++){
				if((winner == null) || board[3 - p][p].equals(winner) || board[3 - p][p].equals("T")){
					if(!board[3- p][p].equals("T"))winner = board[3 - p][p];
					continue;
				}
				winner = null;
				break;
			}
			if(winner != null)return winner;
		}
		
		for(int x = 0; x < 4; x++){
			if(!board[x][0].equals(".")){
				for(int y = 0; y < 4; y++){
					if((winner == null) || board[x][y].equals(winner) || board[x][y].equals("T")){
						if(!board[x][y].equals("T"))winner = board[x][y];
						continue;
					}
					winner = null;
					break;
				}
				if(winner != null)return winner;
			}
		}
		
		for(int x = 0; x < 4; x++){
			if(!board[0][x].equals(".")){
				for(int y = 0; y < 4; y++){
					if((winner == null) || board[y][x].equals(winner) || board[y][x].equals("T")){
						if(!board[y][x].equals("T"))winner = board[y][x];
						continue;
					}
					winner = null;
					break;
				}
				if(winner != null)return winner;
			}
		}
		
		return null;
	}
	
	private static boolean hasMoves(String[][] board){
		for(int x = 0; x < 4; x++){
			for(int y = 0; y < 3; y++){
				if(board[x][y].equals("."))return true;
			}
		}
		return false;
	}
}
