package com.google.codejam.problemc;

import java.io.*;

public class ProblemC {

	private static String filename = "small";
	
	public static void main(String[] args) throws Exception {
		RandomAccessFile input = new RandomAccessFile(filename + "_in.txt", "r");
		RandomAccessFile output = new RandomAccessFile(filename + "_out.txt", "rw");
		
		int cases = Integer.valueOf(input.readLine());
		
		for(int i = 0; i < cases; i++){
			
			String[] parameters = input.readLine().split(" ");
			
			int N = Integer.valueOf(parameters[0]);
			long L = Long.valueOf(parameters[1]);
			long H = Long.valueOf(parameters[2]);
			
			long[] frequencies = new long[N];
			
			String[] f = input.readLine().split(" ");
			for(int j = 0; j < f.length; j++)frequencies[j] = Long.valueOf(f[j]);
			
			long solved = solve(frequencies, L, H);
			
			output.writeBytes("Case #" + (i + 1) + ": " + ((solved < 0) ? "NO" : solved) + "\n");
			System.out.println("Case #" + (i + 1) + ": " + ((solved < 0) ? "NO" : solved));
		}
		
		output.close();
		input.close();
	}

	private static long solve(long[] frequencies, long L, long H){
		long play = -1;
		for(long freq = L; freq <= H; freq++){
			long gcd = 0;
			for(int j = 0; j < frequencies.length; j++){
				if(frequencies[j] == 1)continue;
				gcd = gcd(freq, frequencies[j]);
				if(gcd <= 1)break;
			}
			if(gcd > 1){
				play = freq;
				break;
			}
		}
		return play;
	}
	
	private static long gcd(long a, long b){
		if(b > a)return gcd(b, a);
		if((a % b) == 0)return b;
		return gcd(b, a % b);
	}
}
