package com.google.codejam.lawnmower;

import java.io.RandomAccessFile;

public class Lawnmower {

	private static String filename = "large";
	
	public static void main(String[] args) throws Exception {
		RandomAccessFile input = new RandomAccessFile(filename + ".in", "r");
		RandomAccessFile output = new RandomAccessFile(filename + ".out", "rw");
		
		String[] attributes;
		
		int cases = Integer.valueOf(input.readLine());
		for(int i = 0; i < cases; i++){
			attributes = input.readLine().split(" ");
			
			int M = Integer.valueOf(attributes[0]);
			int N = Integer.valueOf(attributes[1]);
			
			int[][] field = new int[M][N];
			for(int j = 0; j < M; j++){
				attributes = input.readLine().split(" ");
				
				for(int a = 0; a < attributes.length; a++){
					field[j][a] = Integer.valueOf(attributes[a]);
				}
			}
			
			String solved = solve(field) ? "YES" : "NO";
			
			output.writeBytes("Case #" + (i + 1) + ": " + solved + "\n");
		}
		
		output.close();
		input.close();
	}

	private static boolean solve(int[][] field){
		for(int y = 0; y < field.length; y++){
			for(int x = 0; x < field[0].length; x++){
				if(isSunk(y, x, field))return false;
			}
		}
		return true;
	}
	
	private static boolean isSunk(int x, int y, int[][] field){
		for(int a = 0; a < field.length; a++){
			if(field[a][y] > field[x][y]){
				for(int b = 0; b < field[0].length; b++){
					if(field[x][b] > field[x][y])return true;
				}
			}
		}
		return false;
	}
}
