package com.google.codejam.fairwarning;

import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

public class FairWarningSmall {

	public static void main(String[] args) throws Exception{
		
		String filename = "small";
		RandomAccessFile ulaz = new RandomAccessFile(filename + "_in.txt", "r");
		RandomAccessFile izlaz = new RandomAccessFile(filename + "_out.txt", "rw");
		
		int cases = Integer.valueOf(ulaz.readLine());
		
		for(int i = 0; i < cases; i++){
			
			Set<Long> treeslarboseconds = new TreeSet<Long>();
			
			String parameters = ulaz.readLine();
			for(String parameter : parameters.substring(parameters.indexOf(" ") + 1).split(" ")){
				treeslarboseconds.add(Long.valueOf(parameter));
			}
						
			List<Long> slarboseconds = new ArrayList<Long>(treeslarboseconds);
			
			long T = slarboseconds.get(slarboseconds.size() - 1) - slarboseconds.get(slarboseconds.size() - 2);
			for(int j = (slarboseconds.size() - 1); j > 0; j--){
				long tmpT = slarboseconds.get(j) - slarboseconds.get(j - 1);
				if(tmpT < T)T = tmpT;
			}
			
			long delta = ((slarboseconds.get(0) % T) == 0) ? 0 : ((long)(slarboseconds.get(0) / T) + 1) * T - slarboseconds.get(0);
			
			boolean divisible;
			do{
				divisible = true;
				for(Long second : slarboseconds){
					while(((second + delta) % T) != 0){
						delta += T;
						break;
					}
				}
			}while(!divisible);
			
			System.out.println("Case #" + (i + 1) + ": " + delta);
			izlaz.writeBytes("Case #" + (i + 1) + ": " + delta + "\n");
		}
	}	
}
