package com.google.codejam.fairandsquare;

import java.io.RandomAccessFile;

public class FairAndSquare {

	private static String filename = "small";
	
	public static void main(String[] args) throws Exception {
		RandomAccessFile input = new RandomAccessFile(filename + ".in", "r");
		RandomAccessFile output = new RandomAccessFile(filename + ".out", "rw");
		
		String[] attributes;
		
		int cases = Integer.valueOf(input.readLine());
		for(int i = 0; i < cases; i++){
			attributes = input.readLine().split(" ");
			
			long A = Long.valueOf(attributes[0]);
			long B = Long.valueOf(attributes[1]);
			
			long solved = solve(A, B);
			
			output.writeBytes("Case #" + (i + 1) + ": " + solved + "\n");
		}
		
		output.close();
		input.close();
	}

	private static long solve(long A, long B){
		long N = (long) Math.ceil(Math.sqrt(A));
		long M = (long) Math.sqrt(B);
		
		long perfects = 0;
		for(; N <= M; N++){
			if(isPalindrome(N)){				
				if(isPalindrome(N * N)){
					perfects++;
				}
			}
		}
		return perfects;
	}
	
	private static boolean isPalindrome(long candidate){
		if(candidate < 10)return true;
		
		String s = String.valueOf(candidate);
		
		for(int a = 0; a < (s.length() / 2); a++){
			if(s.charAt(a) != s.charAt(s.length() - a - 1)){
				return false;
			}
		}
		return true;
	}
}
