package com.google.codejam.countingsheep;

import java.io.*;
import java.util.*;

public class CountingSheep {

	private static String filename = "small";
	
	public static void main(String[] args) throws Exception {
		RandomAccessFile input = new RandomAccessFile(filename + "_in.txt", "r");
		RandomAccessFile output = new RandomAccessFile(filename + "_out.txt", "rw");
		
		int cases = Integer.valueOf(input.readLine());
		
		for(int i = 0; i < cases; i++){
			
			int N = Integer.valueOf(input.readLine()),
				n = N;
			
			long solved = 0;
			
			ArrayList<Integer> digits = new ArrayList<Integer>();
			
			if(n != 0){
				if(n % 10 == 0){
					while(n % 10 == 0)n /= 10;
					digits.add(0);
				}
				
				for(int k = 0; true; k++){
					for(Integer ntgr : solve(n * k)){
						if(!digits.contains(ntgr)){
							digits.add(ntgr);
						}
					}
					
					if(digits.size() == 10){
						solved = N * k;
						break;
					}
				}
			}
			
			String out = "Case #" + (i + 1) + ": " + (solved == 0 ? "INSOMNIA" : solved) + "\n";
			
			System.out.print(out);
			output.writeBytes(out);
		}
		
		output.close();
		input.close();
	}
	
	private static ArrayList<Integer> solve(long number){
		ArrayList<Integer> digits = new ArrayList<Integer>();
		
		while(number > 0){
			if(!digits.contains(number % 10)){
				digits.add((int)number % 10);
			}
			number /= 10;
		}
		
		return digits;
	}

}
