package com.google.codejam.infinitehouseofpancakes;

import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.Collections;

public class InfiniteHouseOfPancakes {

	private static String filename = "small";
	
	public static void main(String[] args) throws Exception {
		RandomAccessFile input = new RandomAccessFile(filename + ".in", "r");
		RandomAccessFile output = new RandomAccessFile(filename + ".out", "rw");
		
		int cases = Integer.parseInt(input.readLine());
		
		String[] plates;
		for(int i = 0; i < cases; i++){
			input.readLine();
			plates = input.readLine().split(" ");
			
			ArrayList<Integer>
				pancakes = new ArrayList<Integer>();
			
				for(String p : plates){
					pancakes.add(Integer.parseInt(p));
				}
				
			String solved = "Case #" + (i + 1) + ": " + solve(pancakes) + "\n";
			
			System.out.print(solved);
			
			output.writeBytes(solved);
		}
		
		output.close();
		input.close();
	}
	
	private static int solve(ArrayList<Integer> pancakes){
		
		Collections.sort(pancakes);
		Collections.reverse(pancakes);

		int time = pancakes.get(0);
		int cost = 0;
		
		while(true){
						
			int	plate = pancakes.remove(0);
			
			if(plate == 1)return time;
			
			int a = (plate / 2);
			int b = (plate / 2) + (plate % 2);
			
			pancakes.add(a);
			pancakes.add(b);
			
			Collections.sort(pancakes);
			Collections.reverse(pancakes);
			
			cost++;
			
			if((pancakes.get(0) + cost) < time)time = pancakes.get(0) + cost;
			
		}
	}

}
