package com.google.codejam.problema;

import java.io.*;
import java.util.*;

public class ProblemA {

	private static String filename = "large";
	
	public static void main(String[] args) throws Exception {
		RandomAccessFile input = new RandomAccessFile(filename + "_in.txt", "r");
		RandomAccessFile output = new RandomAccessFile(filename + "_out.txt", "rw");
		
		int cases = Integer.valueOf(input.readLine());
		
		for(int i = 0; i < cases; i++){
			
			String[] parameters = input.readLine().split(" ");
			
			int R = Integer.valueOf(parameters[0]);
			int C = Integer.valueOf(parameters[1]);
			
			char[][] picture = new char[R][C];
			
			for(int j = 0; j < R; j++){
				
				String line = input.readLine();
				
				for(int c = 0; c < C; c++){
					picture[j][c] = line.charAt(c);
				}
			}
			
			char[][] solved = solve(picture, 0, 0);
			
			String out = "";
			if(!possible(solved)){
				out = "Impossible\n";
			}else{
				for(int n = 0; n < solved.length; n++){
					for(int m = 0; m < solved[n].length; m++){
						out += String.valueOf(solved[n][m]);
					}
					out += "\n";
				}
			}
			
			output.writeBytes("Case #" + (i + 1) + ":\n" + out);
			System.out.print("Case #" + (i + 1) + ":\n" + out);
		}
		
		output.close();
		input.close();
	}

	private static char[][] solve(char[][] picture, int x, int y){
		if(y >= picture.length)return picture;
		if(x >= picture[y].length)return solve(picture, 0, y + 1);
		if(picture[y][x] != '#')return solve(picture, x + 1, y);
		if(y == picture.length - 1)return picture;
		if(x == picture[y].length - 1)return picture;
		
		if(picture[y][x + 1] == '#'){
			if(picture[y + 1][x] == '#'){
				if(picture[y + 1][x + 1] == '#'){
					picture[y][x] = '/';
					picture[y][x + 1] = '\\';
					picture[y + 1][x] = '\\';
					picture[y + 1][x + 1] = '/';
				}
			}
		}
		return solve(picture, x + 2, y);
	}
	
	private static boolean possible(char[][] picture){
		for(int i = 0; i < picture.length; i++){
			for(int j = 0; j < picture[i].length; j++){
				if(picture[i][j] == '#')return false;
			}
		}
		return true;
	}
}
