package com.google.codejam.dijkstra;

import java.io.RandomAccessFile;

public class Dijkstra {

	private static String filename = "small";
	
	public static void main(String[] args) throws Exception {
		RandomAccessFile input = new RandomAccessFile(filename + ".in", "r");
		RandomAccessFile output = new RandomAccessFile(filename + ".out", "rw");

		int cases = Integer.parseInt(input.readLine());
		
		for(int i = 0; i < cases; i++){
			int loop = Integer.parseInt(input.readLine().split(" ")[1]);
			
			String solved = "Case #" + (i + 1) + ": " + (solve(translate(input.readLine().toCharArray()), loop) ? "YES" : "NO") + "\n";
			
			System.out.print(solved);
			output.writeBytes(solved);
			
		}
		
		output.close();
		input.close();
	}
	
	private static boolean solve(int[] chars, int loop){
		
		int a = 0, b = 0;
		
		for(int l = 0; l < loop; l++){
			for(int c = 0; c < chars.length; c++){
				
				b = chars[c];
				
				if(a != 0){
					b = multiply(a, b);
				}
								
				a = b;
			}
			
		}
		
		return a == -1;
		
	}
		
	private static int[] translate(char[] chars){
		int[] translated = new int[chars.length];
		
		for(int c = 0; c < chars.length; c++){
			if(chars[c] == 'i')translated[c] = 2;
			if(chars[c] == 'j')translated[c] = 3;
			if(chars[c] == 'k')translated[c] = 4;
		}
		
		return translated;
	}
	
	private static int multiply(int a, int b){
		int prefix = ((a * b) < 0) ? -1 : 1;
			
			a = Math.abs(a);
			b = Math.abs(b);
		
		if((a == 1) && (b == 1))return prefix * 1;
		if((a == 1) && (b == 2))return prefix * 2;
		if((a == 1) && (b == 3))return prefix * 3;
		if((a == 1) && (b == 4))return prefix * 4;
		
		if((a == 2) && (b == 1))return prefix * 2;
		if((a == 2) && (b == 2))return prefix * -1;
		if((a == 2) && (b == 3))return prefix * 4;
		if((a == 2) && (b == 4))return prefix * -3;
		
		if((a == 3) && (b == 1))return prefix * 3;
		if((a == 3) && (b == 2))return prefix * -4;
		if((a == 3) && (b == 3))return prefix * -1;
		if((a == 3) && (b == 4))return prefix * 2;
		
		if((a == 4) && (b == 1))return prefix * 4;
		if((a == 4) && (b == 2))return prefix * 3;
		if((a == 4) && (b == 3))return prefix * -2;
		if((a == 4) && (b == 4))return prefix * -1;
		
		return 0;
	}

}
