package com.dragonsblaze.codejam;

import java.io.BufferedReader;
import java.io.FileReader;

public class ThemePark
{
	private static void processInputFile(String inputFile) throws Exception
	{
		FileReader fileReader = new FileReader(inputFile);
		BufferedReader reader = new BufferedReader(fileReader);
		
		int T = Integer.parseInt(reader.readLine());

		for(int i = 1; i <= T; i++)
		{
			String[] params = reader.readLine().split(" ");
			String[] valuesStr = reader.readLine().split(" ");
			
			int[] values = new int[valuesStr.length];
			
			for(int j = 0; j < valuesStr.length; j++)
				values[j] = Integer.parseInt(valuesStr[j]);
			
			System.out.println("Case #" + i + ": " + solve(Integer.parseInt(params[0]), Integer.parseInt(params[1]), values));
		}
	}
	
	private static long solve(int rounds, int capacity, int[] groups)
	{
		int pointer = 0, capacityLeft;
		long money = 0;
		
		int totalPeople = 0;
		for (int group : groups)
			totalPeople += group;
		
		if(totalPeople <= capacity)
			return totalPeople * rounds;
			
		for(int round = 0; round < rounds; round++)
		{
			capacityLeft = capacity;
			
			while(capacityLeft > 0 && capacityLeft >= groups[pointer])
			{
				capacityLeft -= groups[pointer];
				money += groups[pointer];
			
				if(++pointer == groups.length)
					pointer = 0;
			}
		}
		
		return money;
	}
	
	public static void main(String[] args)
	{
		try
		{
			processInputFile(args[0]);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
}