package com.dragonsblaze.codejam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;

public class ThemePark
{
	private void processInputFile(String inputFile, String outputFile) throws Exception
	{
		FileReader fileReader = new FileReader(inputFile);
		BufferedReader reader = new BufferedReader(fileReader);
		FileWriter fileWriter = new FileWriter(outputFile);
		
		int T = Integer.parseInt(reader.readLine());

		for(int i = 1; i <= T; i++)
		{
			String[] params = reader.readLine().split(" ");
			String[] valuesStr = reader.readLine().split(" ");
			
			int[] values = new int[valuesStr.length];
			
			for(int j = 0; j < valuesStr.length; j++)
				values[j] = Integer.parseInt(valuesStr[j]);
			
			int result = solve(Integer.parseInt(params[0]), Integer.parseInt(params[1]), values);
			
			fileWriter.write("Case #" + i + ": " + result + "\n");
			fileWriter.flush();
			
			System.out.print("Case #" + i + ": " + result + "\n");
		}
	}
	
	private int solve(int rounds, int capacity, int[] groups)
	{
		int pointer = 0, money = 0;
		
		int capacityLeft;
		
		int totalPeople = 0;
		for (int group : groups)
			totalPeople += group;
		
		if(totalPeople <= capacity)
			return totalPeople * rounds;
			
		for(int round = 0; round < rounds; round++)
		{
			capacityLeft = capacity;
			
			while(capacityLeft > 0 && capacityLeft >= groups[pointer])
			{
				capacityLeft -= groups[pointer];
				money += groups[pointer];
			
				if(++pointer == groups.length)
					pointer = 0;
			}
		}
		
		return money;
	}
	
	public static void main(String[] args)
	{
		ThemePark themePark = new ThemePark();
		try
		{
//			themePark.processInputFile("data/ThemePark/sample.in", "data/ThemePark/sample.out");
			themePark.processInputFile("/home/aaditya/downloads/C-small-attempt0.in", "/home/aaditya/C-small.out");
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
}