package com.dragonsblaze.codejam;

import java.io.BufferedReader;
import java.io.FileReader;

public class FairWarning
{
	private double solve(double[] values)
	{
		double minimumDifference = Double.MAX_VALUE, smallest = Double.MAX_VALUE;
		int i, j;
		
		for (i = 0; i < values.length; i++)
		{
			if(smallest > values[i])
				smallest = values[i];
			
			for(j = 0; j < values.length; j++)
				if(values[i] > values[j] && minimumDifference > values[i] - values[j])
					minimumDifference = values[i] - values[j];
		}
		
		for(i = 0; i < Integer.MAX_VALUE; i++)
			if(minimumDifference * i >= smallest)
				return (minimumDifference * i - smallest);
		
		return -1;
	}

	int gcd(int a, int b)
	{
		if (a == 0 && b == 0) return -1;
		if (b == 0) return a;
		return gcd(b, a % b);
	}

	int lcm(int a, int b)
	{
		return (int) (a * b) / gcd(a, b);
	}

	private void processInputFile(String inputFile) throws Exception
	{
		FileReader fileReader = new FileReader(inputFile);
		BufferedReader reader = new BufferedReader(fileReader);

		int T = Integer.parseInt(reader.readLine());

		for (int i = 1; i <= T; i++)
		{
			String[] data = reader.readLine().split(" ");

			int numberOfValues = Integer.parseInt(data[0]);
			double[] values = new double[numberOfValues];
			
			for (int j = 0; j < numberOfValues; j++)
				values[j] = Double.parseDouble(data[j + 1]);
				
			System.out.println("Case #" + i + ": " + solve(values));
		}
	}

	public static void main(String[] args)
	{
		FairWarning snapperChain = new FairWarning();
		try
		{
			snapperChain.processInputFile(args[0]);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
}