import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class TicTacToeTomek
{
	static char[][] board;

	public static char checkRow(int row)
	{
		char ch = board[row][0];
		if (ch == 'T')
			ch = board[row][1];
		for (int col = 1; col < 4; col++)
			if (board[row][col] != 'T' && board[row][col] != ch)
				return '.';
		return ch;

	}

	public static char checkCol(int col)
	{
		char ch = board[0][col];
		if (ch == 'T')
			ch = board[1][col];
		for (int row = 1; row < 4; row++)
			if (board[row][col] != 'T' && board[row][col] != ch)
				return '.';
		return ch;

	}

	public static char checkDiagLeft()
	{
		char ch = board[0][0];
		if (ch == 'T')
			ch = board[1][1];
		for (int row = 1; row < 4; row++)
			if (board[row][row] != 'T' && board[row][row] != ch)
				return '.';
		return ch;

	}

	public static char checkDiagRight()
	{
		char ch = board[0][3];
		if (ch == 'T')
			ch = board[1][2];
		for (int row = 1; row < 4; row++)
			if (board[row][3 - row] != 'T' && board[row][3 - row] != ch)
			{
				return '.';
			}

		return ch;
	}

	/** @param args
	 * @throws IOException */
	public static void main(String[] args) throws IOException
	{
		Scanner in = new Scanner(new File("input.txt"));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(
				"output.txt")));

		int numCases = in.nextInt();

		for (int test = 1; test <= numCases; test++)
		{
			board = new char[4][4];

			for (int row = 0; row < 4; row++)
				board[row] = in.next().toCharArray();

			char winner = '.';
			
			// Rows			
			for (int row = 0; row < 4; row++)
			{
				winner = checkRow(row);
				if (winner != '.')
					break;
			}
			
			
			if (winner == '.')
			{
				for (int col = 0; col < 4; col++)
				{
					winner = checkCol(col);
					if (winner != '.')
						break;
				}
			}
			
			if (winner == '.')
			{
				winner = checkDiagLeft();
				if (winner == '.')
					winner = checkDiagRight();
			}
			
			System.out.print("Case #" + test + ": ");
			if (winner == 'X')
				System.out.println ("X won");
			else if (winner == 'O')
				System.out.println("O won");
			else
			{
				boolean complete = true;
				for (int row = 0; row < 4; row++)
					for (int col = 0; col < 4; col++)
						if (board[row][col] == '.')
							complete = false;
				if (complete)
					System.out.println("Draw");
				else
					System.out.println("Game has not completed");
			}
			

		}

	}
}
