/*
ID: your_id_here
LANG: JAVA
TASK: test
*/
import java.awt.Point;
import java.io.*;
import java.util.*;



class PointComparator implements Comparator<Point>
{
	int[][] arr;
	PointComparator(int[][] arr) {
		this.arr = arr;
	}
	public int compare(Point x, Point y) {
		return arr[x.x][x.y] - arr[y.x][y.y];
	}
}



class Main {


		public static int[] nums = new int[1000000 + 1];

	public static String reverse(String str) {

		String reversed = new StringBuilder(str).reverse().toString();

		return reversed;

	}

	public static void counter (BufferedReader f, PrintWriter out, int test) throws IOException {
		String numstr = f.readLine();
		int num = Integer.parseInt(numstr);
		System.out.println("---" + num);


		for (int i = 1; i <= num; i++) {
			if ((nums[i] == 0)) {
				int lowest = nums[i - 1] + 1;
				numstr = Integer.toString(i);
				int reversedInt = Integer.parseInt(reverse(numstr));
				String reversed = Integer.toString(reversedInt);
				if (numstr.length() == reversed.length() && reversedInt < i)
					lowest = Math.min(lowest, (nums[reversedInt] + 1));
				System.out.println(i + ", " + lowest);
				nums[i] = lowest;
			}
		}




		out.println("Case #" + test + ": " + nums[num]);
	}



	public static int getVal(int[][] arr, int x, int y) {
		if (x < 0 || y < 0 || x > arr.length - 1 || y > arr[0].length - 1) {
			return 0;
		} else {
			return arr[x][y] != -1 ? 1 : 0;
		}
	}

	public static void neighbours(BufferedReader f, PrintWriter out, int test) throws IOException {
		String numstr = f.readLine();
		StringTokenizer st = new StringTokenizer(numstr);
		int r = Integer.parseInt(st.nextToken());
		int c = Integer.parseInt(st.nextToken());
		int n = Integer.parseInt(st.nextToken());
		int oldR = r;
		r = Math.min(r, c);
		c = Math.max(oldR, c);
		int returnVal = Integer.MAX_VALUE;


		int[][] board = new int[r][c];
		if (n <= ((r * c) / 2 + (r * c) % 2)) {
			returnVal = 0;
		} else {
			for (int x = 0; x < r; x++) {
				for (int y = 0; y < c; y++) {
					if ((x + y) % 2 == 0) {
						board[x][y] = 0;
					} else {
						board[x][y] = -1;
					}
				}
			}

			PointComparator comp = new PointComparator(board);

			PriorityQueue<Point> spaces = new PriorityQueue<Point>(comp);

			for (int x = 0; x < r; x++) {
				for (int y = 0; y < c; y++) {
					if (board[x][y] == -1) {
						int sum = 0;
						sum += getVal(board, x + 1, y);
						sum += getVal(board, x - 1, y);
						sum += getVal(board, x, y + 1);
						sum += getVal(board, x, y - 1);
						board[x][y] = sum;
					}
					spaces.add(new Point(x, y));
				}
			}

		}


		out.println("Case #" + test + ": " + returnVal);
	}


	public static int hikers(BufferedReader f) throws IOException {
		int n = Integer.parseInt(f.readLine());
		ArrayList<Point> hikers = new ArrayList<Point>();
		for (int i = 0; i < n; i++) {
			StringTokenizer st = new StringTokenizer(f.readLine());
			int d = Integer.parseInt(st.nextToken());
			int h = Integer.parseInt(st.nextToken());
			int m  = Integer.parseInt(st.nextToken());
			for (int j = 0; j < h; j++) {
				hikers.add(new Point(d, m + j));
			}
		}

		Point hikerA = hikers.get(0);
		Point hikerB = hikers.get(1);

		System.out.println(hikerA.toString());
		System.out.println(hikerB.toString());

		if (hikerA.x > hikerB.x || (hikerA.x == hikerB.x && hikerB.y > hikerB.y)) {
			Point temp = hikerA;
			hikerA = new Point(hikerB);
			hikerB = temp;
		}

		double timeToFinishA = hikerA.y * (360.0 - hikerA.x) / (360);
		double timeToFinishB = hikerB.y * (360.0 - hikerB.x) / (360);

		System.out.println(timeToFinishA);
		System.out.println(timeToFinishB);

		if (timeToFinishA >= timeToFinishB + hikerB.y) {
			return 1;
		} else {
			return 0;
		}
//
//		System.out.println(timeToFinishA);
//		System.out.println(timeToFinishB);
//
//		if (timeToFinishA < timeToFinishB) {
//			double timeLeft = timeToFinishB - timeToFinishA;
//			int timesExtra = (int)(Math.floor(timeLeft / hikerA.y));
//			System.out.println(timesExtra);
//			passesB += timesExtra;
//		} else if (timeToFinishB < timeToFinishA) {
//			double timeLeft = timeToFinishA - timeToFinishB;
//			int timesExtra = (int)(Math.floor(timeLeft / (360.0 / hikerB.y)));
//			passesA += timesExtra;
//		}
//
//
//		return Math.min(passesA, passesB);
	}

	public static void main (String [] args) throws IOException {
		BufferedReader f = new BufferedReader(new FileReader("test.in"));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("test.out")));
		int t = Integer.parseInt(f.readLine());
//		for (int i = 0; i < nums.length; i++) {
//			nums[i] = 0;
//		}

		for (int i = 0; i < t; i++) {
			out.println("Case #" + (i + 1) + ": " + hikers(f));
		}

		out.close();
		System.exit(0);
	}
}
