/*
ID: your_id_here
LANG: JAVA
TASK: test
*/
import java.io.*;
import java.util.*;
import java.awt.Point;


/*

things to track:

for each iteration of splitting one level{
  skipCount = 0;
  for each level{
    whether you plus current skip count is > amount you save (math.max...)
    if worth to split, split -> move to next level, clear next list
    else, don't split, check next level
  }
}
*/
class PointComparator implements Comparator<Point>
{
  public int compare(Point a, Point b) {
    if (a.x == b.x) {
      return a.y - b.y;
    } else {
      return a.x - b.x;
    }
  }
}



class test {

  static Comparator comp = new PointComparator();

  private static int gcd(int a, int b)
  {
      while (b > 0)
      {
          int temp = b;
          b = a % b;
          a = temp;
      }
      return a;
  }

  private static int lcm(int a, int b)
  {
      return a * (b / gcd(a, b));
  }

  private static int lcm(int[] input)
  {
      int result = input[0];
      for(int i = 1; i < input.length; i++) {
        result = lcm(result, input[i]);
      }
      return result;
  }


  public static void mushrooms (BufferedReader f, PrintWriter out, int test) throws IOException {
    int n = Integer.parseInt(f.readLine());
    String str = f.readLine();
    StringTokenizer st = new StringTokenizer(str);
    int[] arr = new int[n];
    for (int i = 0; i < n; i++) {
      arr[i] = Integer.parseInt(st.nextToken());
    }
    int method1 = 0;
    int method2 = 0;
    int maxdif = 0;

    for (int i = 1; i < n; i++) {
      if (arr[i-1] > arr[i])
        method1 += arr[i-1] - arr[i];
      if (arr[i-1] - arr[i] > maxdif) {
        maxdif = arr[i-1] - arr[i];
      }
    }

    for (int i = 0; i < n - 1; i++) {
      if (arr[i] < maxdif) {
        method2 += arr[i];
      } else {
        method2 += maxdif;
      }
    }


    out.println("Case #" + test + ": " + method1 + " " + method2);
  }



  public static void printResult(PrintWriter out, int test, String content) {
    out.println("Case #" + test + ": " + content);
  }

  public static void haircut (BufferedReader f, PrintWriter out, int test) throws IOException {
    String str = f.readLine();
    System.out.println(str);
    StringTokenizer st = new StringTokenizer(str);

    int b = Integer.parseInt(st.nextToken());
    int n = Integer.parseInt(st.nextToken());

    if (n <= b) {
      printResult(out, test, "" + n);
      return;
    }

    st = new StringTokenizer(f.readLine());

    PriorityQueue<Point> serving = new PriorityQueue<Point>(comp);


    int[] arr = new int [b];
    for (int i = 0; i < b; i++) {
      arr[i] = Integer.parseInt(st.nextToken());
      serving.add(new Point(arr[i], i));
      System.out.print(arr[i] + " ");
    }
    System.out.println();

    int place = 0;
    n -= b;
    System.out.println("N:     " + n);
    System.out.println("Place: " + place);

    int lcm = lcm(arr);
    System.out.println("LCM:   " + lcm);
    int reduceBy = 0;
    for (int i = 0; i < b; i++) {
      reduceBy += lcm / arr[i];
    }

    System.out.println("Reduce: " + reduceBy);
    reduceBy = (((n - place) / reduceBy) - 1) * reduceBy;


    System.out.println("Reduce: " + reduceBy);
System.out.println("-----------");
if (reduceBy > 0)
      place += reduceBy;
        System.out.println(n);


    while (place <= n) {
      place++;
      Point p = serving.remove();
      // System.out.println("Person: " + place + ",     Point: " + p.x + " " + p.y);
      serving.add(new Point(p.x + arr[p.y], p.y));
      if (place == n) {
        printResult(out, test, "" + (p.y + 1));
        return;
      }
    }
  }


  public static void main (String [] args) throws IOException {


    BufferedReader f = new BufferedReader(new FileReader("test.in"));
    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("test.out")));
    int t = Integer.parseInt(f.readLine());
    for (int i = 0; i < t; i++) {
      haircut(f, out, i+1);
      System.out.println("--------NEXT---------------");
    }

    out.close();
    System.exit(0);
  }
}
