import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class BathroomStalls {
	public class Stall {
		boolean isOccupied;
		long ls, rs;

		public boolean isOccupied() {
			return isOccupied;
		}

		public void setOccupied(boolean isOccupied) {
			this.isOccupied = isOccupied;
		}

		public long getLs() {
			return ls;
		}

		public void setLs(long ls) {
			this.ls = ls;
		}

		public long getRs() {
			return rs;
		}

		public void setRs(long rs) {
			this.rs = rs;
		}

		public long max() {
			return ls > rs ? ls : rs;
		}

		public long min() {
			return ls < rs ? ls : rs;
		}

		Stall() {
			isOccupied = false;
			ls = Long.MIN_VALUE;
			rs = Long.MIN_VALUE;
		}

		@Override
		public String toString() {
			return "Occupied : " + isOccupied() + " Ls : " + ls + " Rs : " + rs;
		}

	}

	List<Stall> stalls;

	public BathroomStalls(long n) {
		stalls = new ArrayList<>();
		;
		for (int i = 0; i < n + 2; i++) {
			Stall stall = new Stall();

			if (i == 0 || i == n + 1) {
				stall.isOccupied = true;
			}
			stalls.add(stall);
		}

	}

	private int rightMost(int n) {
		int r = 0;
		for (int i = n + 1; i < stalls.size(); i++) {
			if (stalls.get(i).isOccupied)
				break;
			r++;
		}
		return r;
	}

	private int leftMost(int n) {
		int l = 0;
		for (int i = n - 1; i < stalls.size(); i--) {
			if (stalls.get(i).isOccupied)
				break;
			l++;
		}
		return l;
	}

	private void compute() {
		for (int i = 0; i < stalls.size(); i++) {
			if (!stalls.get(i).isOccupied()) {
				stalls.get(i).setLs(leftMost(i));
				stalls.get(i).setRs(rightMost(i));
			}
		}
	}

	public static void main(String args[]) {
		File f = new File("src/BathroomStalls.txt");
		File outputFile = new File("src/BathRoomStallsOutput.txt");
		try {
			BufferedReader bufferedReader = new BufferedReader(new FileReader(f));
			BufferedWriter bufferedWriter = new BufferedWriter(new FileWriter(outputFile));
			String str;
			bufferedReader.readLine();
			int caseNumber = 1;
			while ((str = bufferedReader.readLine()) != null) {
				String[] parts = str.split(" ");
				long n = Long.parseLong(parts[0]), k = Long.parseLong(parts[1]);

				BathroomStalls bathroomStalls = new BathroomStalls(n);
				Stall furthestStall = null;
				bathroomStalls.compute();
				for (int person = 0; person < k; person++) {
					List<Stall> selectedList = new ArrayList<>();
					for (int isOccupiedStall = 0; isOccupiedStall < bathroomStalls.stalls.size(); isOccupiedStall++)
						if (!bathroomStalls.stalls.get(isOccupiedStall).isOccupied) {
							furthestStall = bathroomStalls.stalls.get(isOccupiedStall);
							break;
						}
					selectedList.add(furthestStall);

					for (int j = 0; j < n + 1; j++) {
						if (!bathroomStalls.stalls.get(j).isOccupied) {
							if (furthestStall.min() < bathroomStalls.stalls.get(j).min()) {
								furthestStall = bathroomStalls.stalls.get(j);
								selectedList.clear();
								selectedList.add(bathroomStalls.stalls.get(j));
							} else if (furthestStall.min() == bathroomStalls.stalls.get(j).min()) {
								selectedList.add(bathroomStalls.stalls.get(j));
							}
						}
					}
					// I dont need a second list because anyway the next
					// criteria is only leftmost which will come by default.
					furthestStall = selectedList.get(0);
					for (Stall stall : selectedList) {
						if (stall.max() > furthestStall.max()) {
							furthestStall = stall;
						}

					}

					furthestStall.setOccupied(true);
					bathroomStalls.compute();
				}
				bufferedWriter.write("Case #" + caseNumber + ": " + furthestStall.max() + " " + furthestStall.min());
				bufferedWriter.flush();
				bufferedWriter.newLine();
				caseNumber++;
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
