import org.junit.Test;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import org.junit.Assert;;

public class TidyNumbers {
	public static boolean isTidyNumber(long num) {
		boolean isTidy = true;

		while (num > 9) {
			long lastDigit = num % 10;
			num /= 10;
			long secondLastDigit = num % 10;
			if (lastDigit < secondLastDigit) {
				isTidy = false;
				break;
			}
		}
		return isTidy;
	}

	public static void main(String args[]){
		File f = new File("src/tidyNumbers.txt");
		File output = new File("src/tidyNumbersOutput.txt");

		BufferedReader b;
		try {
			String readLine = "";
			b = new BufferedReader(new FileReader(f));
			BufferedWriter writer = new BufferedWriter(new FileWriter(output));
			int i = 1;
			b.readLine();
			while ((readLine = b.readLine()) != null) {
				long number = Long.parseLong(readLine);
				for(long num = number; num > 0; num--){
					if(TidyNumbers.isTidyNumber(num)){
						writer.write("Case #" + i++ + ": " + num);
						writer.newLine();
						break;
					}
				}
			}
			writer.flush();
			b.close();
			writer.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}




	}

	@Test
	public void testIsTidy() {
		Assert.assertTrue(isTidyNumber(8));
		Assert.assertEquals(true, isTidyNumber(123));
		Assert.assertEquals(true, isTidyNumber(555));
		Assert.assertEquals(true, isTidyNumber(224488));

		Assert.assertFalse(isTidyNumber(81));
		Assert.assertFalse(isTidyNumber(20));
		Assert.assertFalse(isTidyNumber(321));

	}
}
