package com.dragos.myapplication;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Scanner;

/**
 * Created by Dragos Raducanu on 11/04/15.
 * raducanu.dragos@gmail.com
 */
public class Pancake {

    private static PrintWriter writer;
    private static long start_time = 0;

    public static void main(String[] args) {
        start_time = System.currentTimeMillis();
        try {
            writer = new PrintWriter("./app/src/main/java/output.out", "UTF-8");
            File f = new File("./app/src/main/java/input.in");

            Scanner sc = new Scanner(f);

            int cases = sc.nextInt();
            for (int i = 0; i < cases; i++) {
                int nonEmpty = sc.nextInt();
                ArrayList<Integer> plates = new ArrayList<>();

                for(int j = 0; j < nonEmpty; j++) {
                    plates.add(sc.nextInt());
                }
                solve(i, plates);
            }
            writer.close();
            println("Exec time: " + (System.currentTimeMillis() - start_time));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }


    }

    private static void solve(int index, ArrayList<Integer> plates) {
        String str = "";
        for(int i = 0; i < plates.size(); i++) {
            str += plates.get(i) + " ";
        }
//        println("#" + (index + 1) + ": " + (plates.size()) + " : " + str);


        //make the tree
        Node root = new Node(plates, 0);
        insert(root, plates);



        //find the shortest path to leaf;
        LinkedList<Node> queue = new LinkedList<>();
        queue.add(root);
        int level = 0;
        while(!queue.isEmpty()) {
            Node n = queue.pop();
            if(n.left == null && n.right == null) {
                writer.println("Case #" + (index + 1) + ": " + n.level);
                break;
            } else {
                if(n.left != null) {
                    queue.add(n.left);
                }
                if(n.right != null) {
                    queue.add(n.right);
                }
            }

        }

    }

    private static void insert(Node node, ArrayList<Integer> plates){
        ArrayList<Integer> special = getConfigAfterSpecialMinute(plates);
        if(special != null) insertLeft(node, special);

        ArrayList<Integer> regular  = getRegularConfig(plates);
        if(regular != null) insertRight(node, regular);

        if(node.left != null && node.left.value != null) {
            insert(node.left, node.left.value);
        }
        if(node.right != null && node.right.value != null) {
            insert(node.right, node.right.value);
        }
    }

    private static ArrayList<Integer> getConfigAfterSpecialMinute(ArrayList<Integer> plates) {
        ArrayList<Integer> newConfig = new ArrayList<>(plates);
        //get max and split it;
        int max = 0;
        int p = 0;
        for(int i = 0; i < newConfig.size(); i++) {
            if(max <= newConfig.get(i)) {
                max = newConfig.get(i);
                p = i;
            }
        }
       if(newConfig.get(p) != 0) {
            if(newConfig.get(p) != 1) {
                newConfig.set(p, newConfig.get(p) - max / 2);
                newConfig.add(max / 2);
            } else {
//                return null;
                newConfig = getRegularConfig(plates);
//                println("Finished with +1 minute from special (only plates with 1)");
//                return null;
            }
        } else {
            return null;
        }
        return newConfig;
    }

    private static ArrayList<Integer> getRegularConfig(ArrayList<Integer> plates) {
        ArrayList<Integer> newConfig = new ArrayList<>(plates);
        boolean empty = true;
        for(int i = 0; i < newConfig.size(); i++) {
            if(plates.get(i) != 0) {
                newConfig.set(i, newConfig.get(i) - 1);
                empty = false;
            }
        }
        if(empty) {
            return null;
        }
        return newConfig;
    }

    private static void println(String s) {
        System.out.println(s);
    }


    public static void insertLeft(Node node, ArrayList<Integer> value) {
//        println("insertLeft: " + value);

        if(node.left == null) {
            node.left = new Node(value, node.level + 1);
        } else {
            throw new RuntimeException("Node already has left child: " + node.left);
        }
    }

    public static void insertRight(Node node, ArrayList<Integer> value) {
        if(node.right == null) {
            node.right = new Node(value, node.level + 1);
        } else {
            throw new RuntimeException("Node already has right child.");
        }
    }



   public static  class Node {
       public Node left;
       public Node right;
       public int level;
       public ArrayList<Integer> value;

       public Node(ArrayList<Integer> value, int level) {
        this.value = value;
        this.level = level;
       }

   }
}
