import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;


public class CoinJam {
	
	public static long convertBase(char[] number, int base){
		long res=0;
		for(int i= number.length -1; i>=0;i--){
			res += Long.parseLong(""+number[i])* Math.pow(base, number.length -1 - i);
		}
		
		return res;
	}
	
	public static long isPrime(long number){
		long res= -1;
		if(number% 2 == 0) return 2;
		for(long i=3; i <= Math.sqrt(number) ; i+=2){
			if(number % i == 0) return i;
		}
		
		return res;
	}
	
	public static String completeNumber(String number, int size){
		StringBuffer sb = new StringBuffer("");
		for(int i=0; i<  size - number.length();i++)
			sb.append('0');
		sb.append(number);
		return sb.toString();
	}
	
	public static String isCodeJam(long number, int size){
		String binaryNum = completeNumber(Long.toBinaryString(number), size);
		
		StringBuffer sb = new StringBuffer(binaryNum + " ");
		for(int i=2;i<=10;i++){
			long newBaseNum = convertBase(binaryNum.toCharArray(), i);
			long divisor = isPrime(newBaseNum);			
			if(divisor == -1) return "";
			else sb.append(divisor + " ");
		}
		
		return sb.toString().substring(0, sb.length()-1);		
	}
	
	public static String[] createCodeJams(int numCJ, int numChar){
		String[] res = new String[numCJ];
		int count=0;
		for(long  i=(long)Math.pow(2, numChar) - 1; i >= 4  && count < numCJ; i--){
			String tmp = isCodeJam(i, numChar);
			if(!tmp.equals("")){ 
				res[count] =tmp;
				count++;
			}
		}
		
		return res;
	}

	public static void main(String[] args) {
		int numTestCases = 0;
		try(BufferedReader br = new BufferedReader(new InputStreamReader(System.in));){	
			numTestCases = Integer.parseInt(br.readLine());
			for(int i=0; i< numTestCases; i++){			
				String numbers = br.readLine();
				int numChar = Integer.parseInt(numbers.split(" ")[0]);
				int numCJ = Integer.parseInt(numbers.split(" ")[1]);
				System.out.println("Case #" +(i+1)+": " );
				String[] res = createCodeJams(numCJ, numChar);
				for(int j=0;j< res.length;j++)
					System.out.println(res[j]);
			}

		}catch(IOException e){
			System.out.println("Trono");
		}
		
	}

}