/**
 * InfinitiHousePancakes.java
 *
 * Copyright (c) 2015 Turrisystem Ltda.
 * Todos los derechos reservados.
 */
package com.google.codejam.ejercicios;

import java.util.ArrayList;
import java.util.List;

import com.google.codejam.principal.EjecutorBase;

/**
 * La descripcin de la clase viene aqu.
 *
 * @author John William Sanabria Delgado
 * @since 1.0
 */
public class InfinitiHousePancakes extends EjecutorBase {

	/**
	 * @param casosPrueba
	 * @param contenido
	 */
	public InfinitiHousePancakes(int casosPrueba, List<String> contenido) {
		super(casosPrueba, contenido);
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see com.google.codejam.principal.EjecutorBase#ejecutarEjercicio()
	 */
	@Override
	public List<String> ejecutarEjercicio() {
		List<String> resultado = new ArrayList<String>();
		
		for(int r=0; r<contenido.size(); r+=2){
			String lineaComensales = contenido.get(r);
			String[] lineaPancakes = contenido.get(r+1).split(" ");
			
			Integer comensales = Integer.parseInt(lineaComensales);
			List<Integer> platos = new ArrayList<Integer>();
			
			for(int i=0; i<lineaPancakes.length; i++){
				platos.add(Integer.parseInt(lineaPancakes[i]));
			}
			
			int minutos = 0;
			while(true){
				if(determinarFin(platos)){
					break;
				}
				
				List<Integer> platosRegular = ejecutarMinutoRegular(platos);
				List<Integer> platosEspecial= ejecutarMinutoEspecial(platos);
				
				int maximoRegular = 0;
				int maximoEspecial = 0;
				
				maximoRegular = hallarMaximo(platosRegular);
				if(platosEspecial != null){
					maximoEspecial = hallarMaximo(platosEspecial);
				}
				
				if(maximoEspecial <= maximoRegular && platosEspecial != null){
					platos = platosEspecial;
				}else{
					platos = platosRegular;
				}
				
				minutos++;
			}
				
			resultado.add(String.valueOf(minutos));
		}
		
		return resultado;
	}
	
	private List<Integer> ejecutarMinutoRegular(List<Integer> platos){
		List<Integer> nuevosPlatos = new ArrayList<Integer>();
		for(Integer plato : platos){
			if(plato > 0 ){
				nuevosPlatos.add(plato-1);
			}else{
				nuevosPlatos.add(0);
			}
		}
		
		return nuevosPlatos;
	}
	
	
	private List<Integer> ejecutarMinutoEspecial(List<Integer> platos){
		Integer maximo = hallarMaximo(platos);
		List<Integer> nuevosPlatos = new ArrayList<Integer>();
		
		if(maximo > 1){
		
			boolean dividir = false;
			for(Integer plato : platos){
				if(plato == maximo && !dividir){
					int nuevo = plato / 2;
					nuevosPlatos.add(nuevo);
					nuevosPlatos.add(plato - nuevo);
					dividir = true;
				}else{
					nuevosPlatos.add(plato);
				}
				
			}
		}else{
			nuevosPlatos = null;
		}
			
		return nuevosPlatos;
	}
	
	
	private boolean determinarFin(List<Integer> platos){
		boolean fin = false;
		for(Integer plato : platos){
			fin |= plato>0;
		}
		
		return !fin;
	}
	
	
	private Integer hallarMaximo(List<Integer> platos){
		Integer maximo = 0;
		for(Integer plato: platos){
			if(plato>maximo){
				maximo = plato;
			}
		}
		
		return maximo;
	}
	
	
	public static void main(String[] args){
		int a = 3;
		int b = a/2;
		System.out.println(b);
	}

}
