/**
 * DeceitfulWar.java
 *
 * Copyright (c) 2014 Turrisystem Ltda.
 * Todos los derechos reservados.
 */
package com.google.codejam.ejercicios;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

import com.google.codejam.principal.EjecutorBase;

/**
 * La descripcin de la clase viene aqu.
 *
 * @author John William Sanabria Delgado
 * @since 1.0
 */
public class DeceitfulWar extends EjecutorBase {
	/**
	 * @param casosPrueba
	 * @param contenido
	 */
	public DeceitfulWar(int casosPrueba, List<String> contenido) {
		super(casosPrueba, contenido);
		// TODO Auto-generated constructor stub
	}


	public List<String> ejecutarEjercicio(){
		List<String> resultado = new ArrayList<String>();
		
		for(int r=0; r<contenido.size(); r++){
			int bloques = Integer.parseInt(contenido.get(r++));
			String[] masasNaomi = contenido.get(r++).split(" ");
			String[] masasKen = contenido.get(r).split(" ");
			
			Double[] aMasasN = new Double[masasNaomi.length];
			Double[] aMasasK = new Double[masasKen.length];
			
			for(int i=0; i<masasNaomi.length; i++){
				aMasasN[i] = Double.parseDouble(masasNaomi[i]);
			}
			
			for(int i=0; i<masasKen.length; i++){
				aMasasK[i] = Double.parseDouble(masasKen[i]);
			}
			
			Arrays.sort(aMasasN);
			Arrays.sort(aMasasK);
			
			List<Double> masasN = new ArrayList<Double>();
			List<Double> masasK = new ArrayList<Double>();
			
			for(int i=aMasasN.length-1; i>=0; i--){
				masasN.add(aMasasN[i]);
			}
			
			for(int i=aMasasK.length-1; i>=0; i--){
				masasK.add(aMasasK[i]);
			}
		
			int ganadosTrampa = deceitfulWar(masasN, masasK);
			int ganadosBien = originWar(masasN, masasK);
			
			resultado.add(ganadosTrampa + " " + ganadosBien);
		}
		
		return resultado;
	}

	
	private List<Double> clonarValores(List<Double> masas){
		List<Double> clon = new ArrayList<Double>();
		clon.addAll(masas);
		
		return clon;
	}
	
	
	private int deceitfulWar(List<Double> masasN, List<Double> masasK){
		int resultado = 0;
		
		List<Double> cMasasN = clonarValores(masasN);
		List<Double> cMasasK = clonarValores(masasK);
		
		Iterator<Double> itN = cMasasN.iterator();
		while(itN.hasNext()){
			Double bloqueN = itN.next();
			
			boolean removioK = false;
			
			Iterator<Double> itK = cMasasK.iterator();
			while(itK.hasNext()){
				Double bloqueK = itK.next();
				
				if(bloqueN>bloqueK){
					itK.remove();
					removioK = true;
					break;
				}
			}
			
			if(removioK){
				itN.remove();
				resultado +=1;
			}else{
				break;
			}
		}
		
		
		List<Double> cMasasNTemp = new ArrayList<Double>();
		for(int i = cMasasN.size()-1; i>=0; i--){
			cMasasNTemp.add(cMasasN.get(i));
		}
		
		
		itN = cMasasNTemp.iterator();
		while(itN.hasNext()){
			Double bloqueN = itN.next();
			
			boolean removioK = false;
			
			Iterator<Double> itK = cMasasK.iterator();
			while(itK.hasNext()){
				Double bloqueK = itK.next();
				
				if(bloqueN>bloqueK){
					itK.remove();
					removioK = true;
					break;
				}
			}
			
			if(removioK){
				itN.remove();
				resultado +=1;
			}else{
				break;
			}
		}
		
		return resultado;
	}
	
	
	
	private int originWar(List<Double> masasN, List<Double> masasK){
		int resultado = 0;
		
		List<Double> cMasasN = clonarValores(masasN);
		List<Double> cMasasK = clonarValores(masasK);
		
		List<Double> cMasasKTemp = new ArrayList<Double>();
		for(int i = cMasasK.size()-1; i>=0; i--){
			cMasasKTemp.add(cMasasK.get(i));
		}
		
		
		Iterator<Double> itN = cMasasN.iterator();
		while(itN.hasNext()){
			Double bloqueN = itN.next();
			
			boolean removioK = false;
			
			Iterator<Double> itK = cMasasKTemp.iterator();
			while(itK.hasNext()){
				Double bloqueK = itK.next();
				
				if(bloqueN<bloqueK){
					itK.remove();
					removioK = true;
					break;
				}
			}
			
			if(removioK){
				itN.remove();
			}
		}
		
		cMasasKTemp = new ArrayList<Double>();
		for(int i = cMasasK.size()-1; i>=0; i--){
			cMasasKTemp.add(cMasasK.get(i));
		}
		
		itN = cMasasN.iterator();
		while(itN.hasNext()){
			Double bloqueN = itN.next();
			
			boolean removioK = false;
			
			Iterator<Double> itK = cMasasKTemp.iterator();
			while(itK.hasNext()){
				Double bloqueK = itK.next();
				
				if(bloqueN>bloqueK){
					itK.remove();
					removioK = true;
					break;
				}
			}
			
			if(removioK){
				itN.remove();
				resultado += 1;
			}
		}
		
		return resultado;
	}

}
