/**
 * ManejadorArchivos.java
 *
 * Copyright (c) 2014 Turrisystem Ltda.
 * Todos los derechos reservados.
 */
package com.google.codejam.principal;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.List;

/**
 * La descripcin de la clase viene aqu.
 *
 * @author John William Sanabria Delgado
 * @since 1.0
 */
public class ManejadorArchivos implements IManejadorArchivos {

	/* (non-Javadoc)
	 * @see com.google.codejam.archivos.IManejadorArchivos#leerArchivo(java.io.File, java.util.List)
	 */
	@Override
	public int leerArchivo(File archivoEntrada, List<String> contenido) {
		int casosPrueba = 0;
		
		BufferedReader bf = null;
		try{
			bf = new BufferedReader(new FileReader(archivoEntrada));
			
			String linea = null;
			
			while((linea=bf.readLine())!=null){
				if(casosPrueba==0){
					casosPrueba = Integer.parseInt(linea.trim());
				}else{
					contenido.add(linea);
				}
			}
		}catch(Exception e){
			e.printStackTrace();
		}finally{
			if(bf!=null){
				try{
					bf.close();
				}catch(Exception e1){
					e1.printStackTrace();
				}
			}
		}
		
		return casosPrueba;
	}

	/* (non-Javadoc)
	 * @see com.google.codejam.archivos.IManejadorArchivos#generarArchivo(java.io.File, java.util.List)
	 */
	@Override
	public void generarArchivo(File archivoSalida, List<String> contenido) {
		PrintWriter pr = null;
		try{
			pr = new PrintWriter(archivoSalida);
			int i = 1;
			for(String linea : contenido){
				pr.println("Case #" + (i++) + ": " + linea);
			}
		}catch(Exception e){
			e.printStackTrace();
		}finally{
			if(pr!=null){
				try{
					pr.close();
				}catch(Exception e1){
					e1.printStackTrace();
				}
			}
		}
		
		

	}

}
