/**
 * @(#)B.java, 2009-9-3. 
 * 
 * Copyright 2009 Yodao, Inc. All rights reserved.
 * YODAO PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package Qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

/**
 *
 * @author wangjun
 *
 */
public class B {
    
    public void combine(int[] fa, int x, int y) {
        int tx = x;
        while (fa[x] >= 0)
            x = fa[x];
        int ty = y;       
        while (fa[y] >= 0)
            y = fa[y];
        if (x == y) 
            return;
        
        int root;
        fa[y] += fa[x];
        fa[x] = y;
        root = y;
        x = tx;
        while (x != root) {
            tx = fa[x];
            fa[x] = root;
            x = tx;
        }
        y = ty;
        while (y != root) {
            ty = fa[y];
            fa[y] = root;
            y = ty;
        }
    }
    
    public int findRoot(int[] fa, int x) {
        int tx = x;
        while (fa[x] >= 0)
            x = fa[x];
        int root = x;
        x = tx;
        while (x != root) {
            tx = fa[x];
            fa[x] = root;
            x = tx;
        }
        return root;
    }
    
    public void work() throws Exception {
        
        final String fileName = "B-large";
        final String inputFileName = fileName + ".in";
        final String outputFileName = fileName + ".out";
        final int direction[][] = new int[][] {{-1, 0}, {0, -1}, {0, 1}, {1, 0}};
    
        BufferedReader inf = new BufferedReader(new InputStreamReader(
                new FileInputStream(inputFileName)));
        BufferedWriter ouf = new BufferedWriter(new OutputStreamWriter(
                new FileOutputStream(outputFileName)));        
        
        String line = inf.readLine();
        String[] lines;
        int t = Integer.parseInt(line.trim());
        
        for (int test = 0; test < t; test++) {
            
            line = inf.readLine();
            lines = line.split(" ");
            int h = Integer.parseInt(lines[0].trim());
            int w = Integer.parseInt(lines[1].trim());            
            
            int fa[] = new int[h * w];
            int map[][] = new int[h][];
            
            for (int i = 0; i < h; i++) {
                map[i] = new int[w];
                line = inf.readLine();
                lines = line.split(" ");
                for (int j = 0; j < w; j++)
                    map[i][j] = Integer.parseInt(lines[j].trim());
            }
            
            for (int i = 0; i < h; i++) 
                for (int j = 0; j < w; j++) 
                    fa[i * w + j] = -1;
            
            int ti, tj;
            for (int i = 0; i < h; i++)
                for (int j = 0; j < w; j++) {
                    int min = 10001;
                    int mink = -1;
                    for (int k = 0; k < 4; k++) {
                        ti = i + direction[k][0];
                        tj = j + direction[k][1];
                        if (ti >= 0 && ti < h && tj >= 0 && tj < w
                                && map[ti][tj] < map[i][j]
                                && map[ti][tj] < min) {
                            min = map[ti][tj];
                            mink = k;
                        }
                    }
                    if (mink != -1) {
                        ti = i + direction[mink][0];
                        tj = j + direction[mink][1];
                        combine(fa, i * w + j, ti * w + tj);
                    }
                }

            ouf.write("Case #" + (test + 1) + ": \n");
            char ans = 'a';
            char out[] = new char[h * w];
            
            for (int i = 0; i < h; i++) {
                for (int j = 0; j < w; j++) {
                    int x = i * w + j;
                    int tx = findRoot(fa, x);
                    if (out[tx] < 'a') {
                        out[tx] = ans;
                        ans = (char)(ans + 1);
                    }
                    ouf.write(out[tx] + " ");
                }
                ouf.write("\n");
            }
        }
        
        inf.close();
        ouf.close();
        
    }
    
    public static void main(String[] args) throws Exception {
        new B().work();
    }    

}
