/**
 * @(#)A.java, 2009-9-12. 
 */
package Round1A;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.HashSet;

/**
 *
 * @author wangjun
 *
 */
public class A {

    
    final int Square[] = new int[]{0,1,4,9,16,25,36,49,64,81};
    
    public String decToBase(int x, int base) {
        
        String result = "";
        while (x != 0) {
            int y = x / base;
            result = "" + (x - y * base) + result; 
            x = y;
        }        
        return result;           
        
    }
    
    public boolean isOK(String str) {
        if (!str.startsWith("1"))
            return false;
        for (int i = 1; i < str.length(); i++)
            if (str.charAt(i) != '0')
                return false;
        return true;        
    }
    
    public boolean isHappy(int x, int base) {
        String str;
        int sum = x;
        HashSet<Integer> set = new HashSet<Integer>();
        set.add(x);
        while (true) {
            str = decToBase(sum, base);
            if (isOK(str))
                return true;
            sum = 0;
            for (int i = 0; i < str.length(); i++) 
                sum += Square[(int)str.charAt(i) - 48];
            if (set.contains(sum))
                return false;
            set.add(sum);
           
        }
            
    }
     
    public void work() throws Exception {
        
        final String fileName = "A-small-attempt0";
        final String inputFileName = fileName + ".in";
        final String outputFileName = fileName + ".out";
    
        BufferedReader inf = new BufferedReader(new InputStreamReader(
                new FileInputStream(inputFileName)));
        BufferedWriter ouf = new BufferedWriter(new OutputStreamWriter(
                new FileOutputStream(outputFileName)));        
        
        String line = inf.readLine();
        String[] lines;
        int tests = Integer.parseInt(line.trim());
        int bases[];
        
        for (int test = 0; test < tests; test++) {
            
            ouf.write("Case #" + (test + 1) + ": ");
            
            line = inf.readLine();
            lines = line.split(" ");
            bases = new int[lines.length];
            for (int i = 0; i < bases.length; i++) {
                bases[i] = Integer.parseInt(lines[i]);
            }
            int ans = 2;
            while (true) {
                boolean mark = true;
                for (int i = 0; i < bases.length; i++) {
                    if (!isHappy(ans, bases[i])) {
                        mark = false;
                        break;
                    }
                }
                if (mark)
                    break;
                ans++;
            }
            ouf.write(ans + "\n");
//            for (int i = 27; i < 3000000; i++) {
//                if (i % 100000 == 0)
//                    System.out.println(i);
//                boolean mark = true;
//                for (int j = 3; j <= 9; j++) {
//                    if (!isHappy(i, j)) {
//                        mark = false;
//                        break;
//                    }                       
//                }
//                if (mark) {
//                    System.out.println(i);
//                    break;
//                }
//            }
        }
        
        inf.close();
        ouf.close();
        
    }
    
    public static void main(String[] args) throws Exception {
        new A().work();
    }    

}
