package qualification2014;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;
import java.util.TreeSet;

public class D_DeceitfulWar {
	public D_DeceitfulWar() throws IOException
	{
		TreeSet<Double> naomiBlocksDeceit = new TreeSet<Double>();
		TreeSet<Double> kenBlocksDeceit = new TreeSet<Double>();
		TreeSet<Double> naomiBlocksNormal = new TreeSet<Double>();
		TreeSet<Double> kenBlocksNormal = new TreeSet<Double>();
		
		File txt = new File("src\\qualification2014\\D_InputLarge");
		File out = new File("src\\qualification2014\\D_OutputLarge");
		
		FileWriter fw = new FileWriter(out);
		Scanner s = new Scanner(txt);
		StringBuilder sb = new StringBuilder();
		
		//read in number of cases
		int caseMax = Integer.parseInt(s.nextLine());
		
		for (int caseNum = 1; caseNum <= caseMax; caseNum++)
		{
			//read in number of blocks
			int numBlocks = Integer.parseInt(s.nextLine());
			
			double storage; //to keep from advancing scanner
			
			//read in naomi's blocks
			Scanner row = new Scanner(s.nextLine());
			for (int slot = 0; slot < numBlocks; slot++)
			{
				storage = row.nextDouble();
				naomiBlocksDeceit.add(storage);
				naomiBlocksNormal.add(storage);
			}
			row.close();
			
			//read in ken's blocks
			row = new Scanner(s.nextLine());
			for (int slot = 0; slot < numBlocks; slot++)
			{
				storage = row.nextDouble();
				kenBlocksDeceit.add(storage);
				kenBlocksNormal.add(storage);
			}
			row.close();
			
			//Optimal DeceitWar
			int deceitWarWins = 0;
			for (int round = 0; round < numBlocks; round++)
			{
				if (kenBlocksDeceit.first() > naomiBlocksDeceit.first())
				{
					/*
					 * Naomi claims largest block that Ken can beat
					 * then gets rid of her smallest block and Ken's
					 * largest block
					 */
					naomiBlocksDeceit.remove(naomiBlocksDeceit.first());
					kenBlocksDeceit.remove(kenBlocksDeceit.last());
				}
				else if (kenBlocksDeceit.first() < naomiBlocksDeceit.first())
				{
					/*
					 * Naomi claims a block size Ken cannot beat, then
					 * beat's Ken's smallest block with her smallest block
					 */
					naomiBlocksDeceit.remove(naomiBlocksDeceit.first());
					kenBlocksDeceit.remove(kenBlocksDeceit.first());
					deceitWarWins++;
				}
			}
			
			//Optimal NormalWar
			int normalWarWins = 0;
			for (int round = 0; round < numBlocks; round++)
			{
				//what Naomi chooses doesn't really matter
				double naomiChoice = naomiBlocksNormal.first();
				naomiBlocksNormal.remove(naomiChoice);
				
				if (kenBlocksNormal.higher(naomiChoice) != null)
				{
					//Ken beats Naomi's choice in most efficient way 
					kenBlocksNormal.remove(kenBlocksNormal.higher(naomiChoice));
				}
				else
				{
					//Ken ditches smallest block
					kenBlocksNormal.remove(kenBlocksNormal.first());
					normalWarWins++;
				}
			}
			sb.setLength(0);
			sb.append("Case #");
			sb.append(caseNum);
			sb.append(": ");
			sb.append(deceitWarWins);
			sb.append(' ');
			sb.append(normalWarWins);
			if (caseNum != caseMax)
			{
				sb.append('\n');
			}
			fw.write(sb.toString());
		}
		s.close();
		fw.close();
	}
}
