package codejam;

import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

public class war {
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = new StringTokenizer("");
	
	public static void main(String[] args) {
		war test = new war();
		test.start();
	}
	
	public void solve() throws IOException {
		int num_test = readInt();
		for (int i = 0; i < num_test; ++i) {
			int n = readInt();
			double[] naomi = new double[n];
			double[] ken = new double[n];
			
			for (int j = 0; j < n; ++j) {
				naomi[j] = readDouble();
			}
			for (int j = 0; j < n; ++j) {
				ken[j] = readDouble();
			}
			
			solveEach(naomi, ken, i+1);
			System.out.println("Case " + i + " finished");
		}
	}
	
	public void solveEach(double[] naomi, double[] ken, int num_test) {
		out.print("Case #" + num_test + ": ");
		Arrays.sort(naomi);
		Arrays.sort(ken);
		
		deceitfulWar(naomi, ken);
		war(naomi, ken);
	}
	
	public void deceitfulWar(double[] naomi, double[] ken) {
		int naomi_pointer = 0, ken_pointer = 0;
		int num_naomi_win = 0;
		while (naomi_pointer < naomi.length && ken_pointer < ken.length) {
			if (naomi[naomi_pointer] > ken[ken_pointer]) {
				++num_naomi_win;
				++naomi_pointer;
				++ken_pointer;
			} else {
				++naomi_pointer;
			}
		}
		out.print(num_naomi_win + " ");
	}
	
	public void war(double[] naomi, double[] ken) {
		boolean[] ken_used = new boolean[ken.length];
		int num_naomi_win = 0;
		for (int i = 0; i < naomi.length; ++i) {
			int j = 0;
			while (j < ken.length) {
				if (!ken_used[j] && ken[j] > naomi[i]) {
					ken_used[j] = true;
					break;
				}
				++j;
			}
			if (j == ken.length) {
				for (int k = 0; k < ken.length; ++k) {
					if (!ken_used[k]) {
						ken_used[k] = true;
						++num_naomi_win;
						break;
					}
				}
			}
		}
		out.println(num_naomi_win);
	}


	
	public void start()
	{
		try {
			/*in = new BufferedReader(new FileReader("/Users/congli/Documents/javaworkspace/usaco/src/com/congli/usaco/input.txt"));
			out = new PrintWriter(System.out);*/
			in = new BufferedReader(new FileReader("/Users/congli/Downloads/D-large.in"));
			out = new PrintWriter(new BufferedWriter(new FileWriter("/Users/congli/Documents/javaworkspace/codejam/src/codejam/output.txt")));
			solve();
			in.close();
			out.close();
		} catch (Throwable t) {
			// TODO Auto-generated catch block
			t.printStackTrace();
		}
	}
	
	public String readString() throws IOException {
		while (!tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	public int readInt() throws IOException {
		return Integer.parseInt(readString());
	}

	public long readLong() throws IOException {
		return Long.parseLong(readString());
	}

	public double readDouble() throws IOException {
		return Double.parseDouble(readString());
	}
}
