//package com.congli.gcj;

import java.io.*;
import java.util.*;

public class Q3 {

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = new StringTokenizer("");

	public static void main(String[] args) {
		Q3 test = new Q3();
		test.start();
	}

	public void solve() throws IOException 
	{
		int num_test = readInt();
		long a = 0;
		long b = 0;
		long sqrta = 0;
		long sqrtb = 0;
		for(int i = 0; i < num_test; ++i)
		{
			a = readLong();
			b = readLong();
			
			sqrta = sqrt(a);
			sqrta = (sqrta * sqrta < a ? (sqrta+1) : sqrta);
			sqrtb = sqrt(b);
			calculate(i+1, sqrta, sqrtb);
		}
	}
	
	public void calculate(int case_num, long a, long b) throws IOException
	{
		long result = 0;
		for(long i = a; i <= b; ++i)
		{
			if(isPalindrome(i) && isPalindrome(i*i))
				++result;
		}
		System.out.println("Case #" + case_num + ": " + result);
	}
	
	public long sqrt(long x) 
	{
        if(x <= 0) return 0;
        long start = 1;
        long end = x;  
           
        while(start <= end)
        {           
            long mid = start + (end-start)/2;
            if(Long.MAX_VALUE / mid < mid) // This imples mid*mid must be larger than MAX_VALUE!
                end = mid-1;
            else
            {
                if(mid*mid == x) return mid;
                if(mid*mid < x)
                    start = mid+1;
                else
                    end = mid-1;
            }
        }
        return start-1;
    }
	
	public boolean isPalindrome(long x) 
	{
		if(x < 0) return false;
		long temp = x;
		long numDigits = 0;
        while(temp > 0)
        {
            temp /= 10;
            ++numDigits;
        }
        
        long highNum = x;
        long lowNum = x;
        for(int i = 0; i < numDigits/2; ++i)
        {
            int highDigit = (int) (highNum / (Math.pow(10, numDigits-i-1)));
            highNum = (int) (highNum % (Math.pow(10, numDigits-i-1)));
            long lowDigit = (lowNum % 10);
            lowNum /= 10;
            if(Math.abs(highDigit) != lowDigit) return false;
        }
        return true;
    }
	
	public void start()
	{
		try {
			long t1 = System.currentTimeMillis();
			if (System.getProperty("ONLINE_JUDGE") != null) {
				in = new BufferedReader(new InputStreamReader(System.in));
				out = new PrintWriter(System.out);
			} else {
				in = new BufferedReader(new FileReader("..\\GCJ\\src\\com\\congli\\gcj\\input.txt"));
				out = new PrintWriter(System.out);
			}
			Locale.setDefault(Locale.US);
			solve();
			in.close();
			out.close();
			long t2 = System.currentTimeMillis();
			System.err.println("Time = " + (t2 - t1));
		} catch (Throwable t) {
			t.printStackTrace(System.err);
			System.exit(-1);
		}
	}
	
	public String readString() throws IOException {
		while (!tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	public int readInt() throws IOException {
		return Integer.parseInt(readString());
	}

	public long readLong() throws IOException {
		return Long.parseLong(readString());
	}

	public double readDouble() throws IOException {
		return Double.parseDouble(readString());
	}
}
