//package com.congli.gcj;

import java.io.*;
import java.util.*;

public class Q1 {

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = new StringTokenizer("");

	public static void main(String[] args) {
		Q1 test = new Q1();
		test.start();
	}

	public void solve() throws IOException 
	{
		int num_test = readInt();
		
		for(int i = 0; i < num_test; ++i)
		{
			calculate(i+1);
		}
		
	}
	
	public void calculate(int case_num) throws IOException
	{
		int[] row = new int[4];
		int[] col = new int[4];
		boolean[] row_T = new boolean[4];
		boolean[] col_T = new boolean[4];
		
		int diag = 0, off_diag = 0;
		boolean diag_T = false, off_diag_T = false;
		
		boolean contains_dot = false;
		String temp;
		char curr;
		
		for(int i = 0; i < 4; ++i)
		{
			temp = readString();
			for(int j = 0; j < 4; ++j)
			{
				curr = temp.charAt(j);
				if(curr == 'X')
				{
					row[i]++;
					col[j]++;
					if(i == j) diag++;
					if(i == 3-j) off_diag++;
				}
				else if(curr == 'O')
				{
					row[i]--;
					col[j]--;
					if(i == j) diag--;
					if(i == 3-j) off_diag--;
				}
				else if(curr == 'T')
				{
					row_T[i] = true;
					col_T[j] = true;
					if(i == j) diag_T = true;
					if(i == 3-j) off_diag_T = true;
				}
				else
					contains_dot = true;
			}
		}
		
		if((diag == 4 || (diag == 3 && diag_T)) || (off_diag == 4 || (off_diag == 3 && off_diag_T)))
		{
			System.out.println("Case #" + case_num + ": X won");
			return;
		}
		if((diag == -4 || (diag == -3 && diag_T)) || (off_diag == -4 || (off_diag == -3 && off_diag_T)))
		{
			System.out.println("Case #" + case_num + ": O won");
			return;
		}
		
		for(int i = 0; i < 4; ++i)
		{
			if((row[i] == 4 || (row[i] == 3 && row_T[i])) || (col[i] == 4 || (col[i] == 3 && col_T[i]))) 
			{
				System.out.println("Case #" + case_num + ": X won");
				return;
			}
			if((row[i] == -4 || (row[i] == -3 && row_T[i])) || (col[i] == -4 || (col[i] == -3 && col_T[i]))) 
			{
				System.out.println("Case #" + case_num + ": O won");
				return;
			}
		}
		
		if(contains_dot)
			System.out.println("Case #" + case_num + ": Game has not completed");
		else
			System.out.println("Case #" + case_num + ": Draw");
	}
	
	public void start()
	{
		try {
			long t1 = System.currentTimeMillis();
			if (System.getProperty("ONLINE_JUDGE") != null) {
				in = new BufferedReader(new InputStreamReader(System.in));
				out = new PrintWriter(System.out);
			} else {
				in = new BufferedReader(new FileReader("..\\GCJ\\src\\com\\congli\\gcj\\input.txt"));
				out = new PrintWriter(System.out);
			}
			Locale.setDefault(Locale.US);
			solve();
			in.close();
			out.close();
			long t2 = System.currentTimeMillis();
			System.err.println("Time = " + (t2 - t1));
		} catch (Throwable t) {
			t.printStackTrace(System.err);
			System.exit(-1);
		}
	}
	
	public String readString() throws IOException {
		while (!tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	public int readInt() throws IOException {
		return Integer.parseInt(readString());
	}

	public long readLong() throws IOException {
		return Long.parseLong(readString());
	}

	public double readDouble() throws IOException {
		return Double.parseDouble(readString());
	}
}
