//package com.congli.gcj;

import java.io.*;
import java.util.*;

public class Q2_2 {

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = new StringTokenizer("");

	public static void main(String[] args) {
		Q2_2 test = new Q2_2();
		test.start();
	}

	public void solve() throws IOException 
	{		
		int num_test = readInt();
		
		int row = 0;
		int col = 0;
		for(int i = 0; i < num_test; ++i)
		{
			row = readInt();
			col = readInt();
			int[][] array = new int[row][col];
			
			for(int r = 0; r < row; ++r)
				for(int c = 0; c < col; ++c)
					array[r][c] = readInt();
			
			calculate(i+1, row, col, array);
		}
	}
	
	public void calculate(int case_num, int row, int col, int[][] array) throws IOException
	{
		int[] max_row = new int[row];
		int[] max_col = new int[col];
		
		for(int i = 0; i < row; ++i)
		{
			int temp = 0;
			for(int j = 0; j < col; ++j)
				temp = Math.max(temp, array[i][j]);
			max_row[i] = temp;
		}
		
		for(int j = 0; j < col; ++j)
		{
			int temp = 0;
			for(int i = 0; i < row; ++i)
				temp = Math.max(temp, array[i][j]);
			max_col[j] = temp;
		}
		
		for(int i = 0; i < row; ++i)
		{
			for(int j = 0; j < col; ++j)
			{
				if(array[i][j] < max_row[i] && array[i][j] < max_col[j])
				{
					out.println("Case #" + case_num + ": NO");
					return;
				}
			}
		}
		out.println("Case #" + case_num + ": YES");
	}
	
	public void start()
	{
		try {
			long t1 = System.currentTimeMillis();
			in = new BufferedReader(new FileReader("..\\GCJ\\src\\com\\congli\\gcj\\input.txt"));
			out = new PrintWriter(new File("..\\GCJ\\src\\com\\congli\\gcj\\output.txt"));
			Locale.setDefault(Locale.US);
			solve();
			in.close();
			out.close();
			long t2 = System.currentTimeMillis();
			System.err.println("Time = " + (t2 - t1));
		} catch (Throwable t) {
			t.printStackTrace(System.err);
			System.exit(-1);
		}
	}
	
	public String readString() throws IOException {
		while (!tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	public int readInt() throws IOException {
		return Integer.parseInt(readString());
	}

	public long readLong() throws IOException {
		return Long.parseLong(readString());
	}

	public double readDouble() throws IOException {
		return Double.parseDouble(readString());
	}
}
