package codejam;

import java.io.*;
import java.util.StringTokenizer;

public class minesweeper {
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = new StringTokenizer("");
	
	public static void main(String[] args) {
		minesweeper test = new minesweeper();
		test.start();
	}
	
	public void solve() throws IOException {
		int num_test = readInt();
		for (int i = 0; i < num_test; ++i) {
			int r = readInt();
			int c = readInt();
			int num_mine = readInt();
			solveEach(r, c, num_mine, i+1);
		}
	}
	
	public void solveEach(int m, int n, int num_mine, int num_test) {
		int[][] matrix = new int[m][n];
		
		for (int layer = 0; layer < Math.min(m, n)/2; ++layer)
        {
            for (int i = layer; i < n-layer-1; ++i) {
            	if (num_mine > 0) {
            		matrix[layer][i] = -1;
                	--num_mine;
                	continue;
            	} else {
            		fillMatrix(layer, i, m, n, matrix);
            	}
            }
           
            for (int i = layer; i < m-layer-1; ++i) {
            	if (num_mine > 0) {
            		matrix[i][n-layer-1] = -1;
            		--num_mine;
            		continue;
            	} else {
            		fillMatrix(i, n-layer-1, m, n, matrix);
            	}
            }
               
            for (int i = n-layer-1; i > layer; --i) {
            	if (num_mine > 0) {
            		matrix[m-layer-1][i] = -1;
            		--num_mine;
            		continue;
            	} else {
            		fillMatrix(m-layer-1, i, m, n, matrix);
            	}
            }
               
            for (int i = m-layer-1; i > layer; --i) {
            	if (num_mine > 0) {
            		matrix[i][layer] = -1;
            		--num_mine;
            		continue;
            	} else {
            		fillMatrix(i, layer, m, n, matrix);
            	}
            }
        }
       
        if(m < n && m%2 == 1) {
        	for (int i = m/2; i < n-m/2; ++i) {
             	if (num_mine > 0) {
             		matrix[m/2][i] = -1;
             		--num_mine;
             		continue;
             	} else {
             		fillMatrix(m/2, i, m, n, matrix);
             	}
             }
        } else if (m > n && n%2 == 1) {
        	for(int i = n/2; i < m-n/2; ++i) {
        		if (num_mine > 0) {
             		matrix[i][n/2] = -1;
             		--num_mine;
             		continue;
             	} else {
             		fillMatrix(i, n/2, m, n, matrix);
             	}
        	}
        } else if (m == n && m%2 == 1) {
        	if (num_mine > 0) {
        		matrix[m/2][m/2] = -1;
        		--num_mine;
         	} else {
         		fillMatrix(m/2, m/2, m, n, matrix);
         	}
        }
        //outputMatrix(m, n, matrix);
        out.println("Case #" + num_test + ":");
        
        if (!hasZero(m, n, matrix) || !isPossible(m, n, matrix)) {
        	out.println("Impossible");
        	return;
        }
        
        boolean has_out_c = false;
        for (int i = 0; i < m; ++i) {
        	for (int j = 0; j < n; ++j) {
        		if (matrix[i][j] == -1) {
        			out.print("*");
        		} else if (matrix[i][j] == 1) {
        			out.print(".");
        		} else {
        			if (has_out_c) {
        				out.print(".");
        			} else {
        				out.print("c");
        				has_out_c = true;
        			}
        		}
        	}
        	out.println();
        }
		
	}
	
	public void outputMatrix(int m, int n, int[][] matrix) {
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j < n; ++j) {
				out.print(matrix[i][j] + " ");
			}
			out.println();
		}
	}
	
	public boolean isPossible(int m, int n, int[][] matrix) {
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j < n; ++j) {
				if (matrix[i][j] == 1 && hasNoZeroNeighbor(i, j, m, n, matrix)) {
					return false;
				}
			}
		}
		return true;
	}
	
	public boolean hasNoZeroNeighbor(int i, int j, int m, int n, int[][] matrix) {
		if (i-1 >= 0) {
			if (j-1 >= 0 && matrix[i-1][j-1] == 0) {
				return false;
			}
			if (j >= 0 && matrix[i-1][j] == 0) {
				return false;
			}
			if (j+1 < n && matrix[i-1][j+1] == 0) {
				return false;
			}
		}
		if (j-1 >= 0 && matrix[i][j-1] == 0) {
			return false;
		}
		if (j+1 < n && matrix[i][j+1] == 0) {
			return false;
		}
		if (i+1 < m) {
			if (j-1 >= 0 && matrix[i+1][j-1] == 0) {
				return false;
			}
			if (j >= 0 && matrix[i+1][j] == 0) {
				return false;
			}
			if (j+1 < n && matrix[i+1][j+1] == 0) {
				return false;
			}
		}
		return true;
	}
	
	public boolean hasZero(int m, int n, int[][] matrix) {
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j < n; ++j) {
				if (matrix[i][j] == 0) {
					return true;
				}
			}
		}
		return false;
	}
	
	public void fillMatrix(int i, int j, int m, int n, int[][] matrix) {
		if (i-1 >= 0) {
			if (j-1 >= 0 && matrix[i-1][j-1] == -1) {
				matrix[i][j] = 1; return;
			}
			if (j >= 0 && matrix[i-1][j] == -1) {
				matrix[i][j] = 1; return;
			}
			if (j+1 < n && matrix[i-1][j+1] == -1) {
				matrix[i][j] = 1; return;
			}
		}
		if (j-1 >= 0 && matrix[i][j-1] == -1) {
			matrix[i][j] = 1;return;
		}
		if (j+1 < n && matrix[i][j+1] == -1) {
			matrix[i][j] = 1; return;
		}
		if (i+1 < m) {
			if (j-1 >= 0 && matrix[i+1][j-1] == -1) {
				matrix[i][j] = 1; return;
			}
			if (j >= 0 && matrix[i+1][j] == -1) {
				matrix[i][j] = 1; return;
			}
			if (j+1 < n && matrix[i+1][j+1] == -1) {
				matrix[i][j] = 1; return;
			}
		}
		matrix[i][j] = 0;
	}
	
	public void start()
	{
		try {
			/*in = new BufferedReader(new FileReader("/Users/congli/Documents/javaworkspace/usaco/src/com/congli/usaco/input.txt"));
			out = new PrintWriter(System.out);*/
			in = new BufferedReader(new FileReader("/Users/congli/Downloads/C-small-attempt2.in"));
			out = new PrintWriter(new BufferedWriter(new FileWriter("/Users/congli/Documents/javaworkspace/codejam/src/codejam/output.txt")));
			solve();
			in.close();
			out.close();
		} catch (Throwable t) {
			// TODO Auto-generated catch block
			t.printStackTrace();
		}
	}
	
	public String readString() throws IOException {
		while (!tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	public int readInt() throws IOException {
		return Integer.parseInt(readString());
	}

	public long readLong() throws IOException {
		return Long.parseLong(readString());
	}

	public double readDouble() throws IOException {
		return Double.parseDouble(readString());
	}
}

