import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;


public class Q2 {
	public static Problem[] probs;

	static class Problem {
		public int P;
		public int[] M;
		public int numTeams;
		public ArrayList<int[]> prices = new ArrayList<int[]>();
	}
		
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				String output = solveProblem(probs[i]);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
		
	private static boolean isDone(int[] attendList) {
		for (int i=0; i<attendList.length; i++) {
			if (attendList[i]!=0) {
				return false;
			}
		}
		return true;
	}
	
	private static String solveProblem(Problem p) {
		int[] attendList = new int[p.numTeams];
		for (int i=0; i<p.numTeams; i++) {
			attendList[i] = p.P - p.M[i];
		}
		
		int round = p.P;
		int price = 0;
		
		while (!isDone(attendList)) {
			for (int i=0; i<(int)Math.pow(2, p.P-round); i++) {
				for (int j=i*(int)Math.pow(2, round); j<(i+1)*(int)Math.pow(2, round); j++) {
					if (attendList[j]!=0) {
						//buy this game
						price++;
						for (int k=i*(int)Math.pow(2, round); k<(i+1)*(int)Math.pow(2, round); k++) {
							attendList[k] = Math.max(0, attendList[k]-1);
						}
						break;
					}
				}
				
			}
			
			round--;
		}
		
		return "" + price;
	}

	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			for (int i=0; i<probs.length; i++) {
				line = br.readLine();
				probs[i] = new Problem();
				String[] pieces = line.split(" ");
				probs[i].P = Integer.parseInt(pieces[0]);
				int pm = (int)Math.pow(2, probs[i].P);
				if (pm%2!=0) {
					System.out.println("power error");
					System.exit(1);
				}
				probs[i].numTeams = pm;
				probs[i].M = new int[pm];
				line = br.readLine();
				pieces = line.split(" ");
				for (int j=0; j<pm; j++) {
					probs[i].M[j] = Integer.parseInt(pieces[j]);
				}
				for (int j=0; j<probs[i].P; j++) {
					line = br.readLine();
					pieces = line.split(" ");
					int power = (int)Math.pow(2, probs[i].P-j-1);
					int[] prices = new int[power];
					for (int k=0; k<power; k++) {
						prices[k] = Integer.parseInt(pieces[k]);
					}
					probs[i].prices.add(prices);
				}
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
