import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;


public class R1Q2 {
	private static Problem[] probs;
	
	private static class Problem {
		public long N;
		public int[] digits;
		public int[] newDigits;
	}
	
	public static void main(String[] args) {
		readData(args[0]);
		process();
	}

	private static void process() {
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter("R1Q2/R1Q2.out"));
			for (int i=0; i<probs.length; i++) {
				Problem currProb = probs[i];
				ArrayList<Integer> digitsList = new ArrayList<Integer>();
				int lastDigit = -1;
				boolean done = false;
				for (int j=currProb.digits.length-1; j>=0; j--) {
					//count until a shrink
					int currDigit = currProb.digits[j];
					digitsList.add(currDigit);
					if (currDigit<lastDigit) {
						currProb.newDigits = new int[currProb.digits.length];
						for (int k=0; k<j; k++) {
							currProb.newDigits[k] = currProb.digits[k];
						}
						int nextLargest = 10;
						int nextLargestIndex = -1;
						for (int k=0; k<digitsList.size(); k++) {
							if (digitsList.get(k)>currDigit && digitsList.get(k)<nextLargest) {
								nextLargest = digitsList.get(k);
								nextLargestIndex = k;
							}
						}
						currProb.newDigits[j] = digitsList.remove(nextLargestIndex);
						//now fill lowest to highest
						for (int k=j+1; k<currProb.digits.length; k++) {
							int smallest = 10;
							int smallestIndex = -1;
							for (int n=0; n<digitsList.size(); n++) {
								if (digitsList.get(n)<smallest) {
									smallest = digitsList.get(n);
									smallestIndex = n;
								}
							}
							currProb.newDigits[k] = digitsList.remove(smallestIndex);
						}
						done = true;
						break;
					} else {
						lastDigit = currDigit;
					}
				}
				if (!done) {
		
				//otherwise need to add a zero: <smallest> <0> ...
					currProb.newDigits = new int[currProb.digits.length+1];
					int smallest = 10;
					int smallestIndex = -1;
					for (int j=0; j<digitsList.size(); j++) {
						if (digitsList.get(j)<smallest && digitsList.get(j)!=0) {
							smallest = digitsList.get(j);
							smallestIndex = j;
						}
					}
					currProb.newDigits[0] = digitsList.remove(smallestIndex);
					currProb.newDigits[1] = 0;
					for (int k=2; k<currProb.newDigits.length; k++) {
						smallest = 10;
						smallestIndex = -1;
						for (int n=0; n<digitsList.size(); n++) {
							if (digitsList.get(n)<smallest) {
								smallest = digitsList.get(n);
								smallestIndex = n;
							}
						}
						currProb.newDigits[k] = digitsList.remove(smallestIndex);
					}
				}
				bw.write("Case #" + (i+1) + ": ");
				for (int j=0; j<currProb.newDigits.length; j++) {
					bw.write(currProb.newDigits[j] + "");
				}
				bw.write("\n");
				
			}
			bw.flush();
			bw.close();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	
	
	private static void readData(String inFile) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(inFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				line = br.readLine();
				probs[i].digits = new int[line.length()];
				for (int j=0; j<line.length(); j++) {
					probs[i].digits[j] = Integer.parseInt(line.substring(j, j+1));
				}
				
			}
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
