import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;


public class Q2 {
	private static Problem[] probs;
	
	private static class Train {
		public int timeToReady = 0;
		public boolean goingToA = false;
		public boolean goingToB = false;
		public boolean atA = false;
		public boolean atB = false;
		public int departTime;
		public int arriveTime;
	}
	
	private static class Problem {
		public int turnaroundTime;
		public int AtoB;
		public int BtoA;
		public int[][] AtoBtimes;
		public int[][] BtoAtimes;
		public ArrayList<Train> trains = new ArrayList<Train>();
		

	}
	
	public static void main(String[] args) {
		readData(args[0]);
		simulate(args[0]);
	}

	private static void simulate(String file) {
		int startingA = 0;
		int startingB = 0;
		BufferedWriter bw = null;
		try {
			bw = new BufferedWriter(new FileWriter(file + ".out"));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		for (int i=0; i<probs.length; i++) {
			Problem currProb = probs[i];
			for (int j=0; j<23*60+59; j++) {
				//process trains in transit
				for (Train t: currProb.trains) {
					if (t.arriveTime==j) {
						if (t.goingToA) {
							t.goingToA = false;
							t.atA = true;
							t.timeToReady = currProb.turnaroundTime;
						} else if (t.goingToB) {
							t.goingToB = false;
							t.atB = true;
							t.timeToReady = currProb.turnaroundTime;
						} else {
							System.out.println("missed a case");
						}
					//Age waiting trains
					} else if (t.atA || t.atB) {
						if (t.timeToReady>0) {
							t.timeToReady--;
						}
					}
				}
				//process trains leaving, AtoB
				for (int k=0; k<currProb.AtoB; k++) {
					if (currProb.AtoBtimes[k][0]==j) {
						//find a train
						boolean foundTrain = false;
						for (Train t: currProb.trains) {
							if (t.atA && t.timeToReady==0) {
								t.atA = false;
								t.goingToB = true;
								t.departTime = currProb.AtoBtimes[k][0];
								t.arriveTime = currProb.AtoBtimes[k][1];
								foundTrain = true;
								break;
							}
						}
						if (!foundTrain) {
							Train t = new Train();
							t.atA = false;
							t.goingToB = true;
							t.departTime = currProb.AtoBtimes[k][0];
							t.arriveTime = currProb.AtoBtimes[k][1];
							currProb.trains.add(t);
							startingA++;
						}
					}
				}
				//process trains leaving, BtoA
				for (int k=0; k<currProb.BtoA; k++) {
					if (currProb.BtoAtimes[k][0]==j) {
						//find a train
						boolean foundTrain = false;
						for (Train t: currProb.trains) {
							if (t.atB && t.timeToReady==0) {
								t.atB = false;
								t.goingToA = true;
								t.departTime = currProb.BtoAtimes[k][0];
								t.arriveTime = currProb.BtoAtimes[k][1];
								foundTrain = true;
								break;
							}
						}
						if (!foundTrain) {
							Train t = new Train();
							t.atB = false;
							t.goingToA = true;
							t.departTime = currProb.BtoAtimes[k][0];
							t.arriveTime = currProb.BtoAtimes[k][1];
							currProb.trains.add(t);
							startingB++;
						}
					}
				}
			}
			try {
				bw.write("Case #" + (i+1) + ": " + startingA + " " + startingB + "\n");
			} catch (IOException e) {
				e.printStackTrace();
			}
			startingA = 0;
			startingB = 0;
		}
		try {
			bw.flush();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
	
	
	private static void readData(String inFile) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(inFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				probs[i].turnaroundTime = Integer.parseInt(br.readLine());
				line = br.readLine();
				String pieces[] = line.split(" ");
				probs[i].AtoB = Integer.parseInt(pieces[0]);
				probs[i].BtoA = Integer.parseInt(pieces[1]);
				probs[i].AtoBtimes = new int[probs[i].AtoB][2];
				int hrLeave, minLeave, hrArrive, minArrive;
				for (int j=0; j<probs[i].AtoB; j++) {
					pieces = br.readLine().split(" ");
					hrLeave = Integer.parseInt(pieces[0].split(":")[0]);
					minLeave = Integer.parseInt(pieces[0].split(":")[1]);
					hrArrive = Integer.parseInt(pieces[1].split(":")[0]);
					minArrive = Integer.parseInt(pieces[1].split(":")[1]);
					probs[i].AtoBtimes[j][0] = hrLeave*60+minLeave;
					probs[i].AtoBtimes[j][1] = hrArrive*60+minArrive;
				}
				probs[i].BtoAtimes = new int[probs[i].BtoA][2];
				for (int j=0; j<probs[i].BtoA; j++) {
					pieces = br.readLine().split(" ");
					hrLeave = Integer.parseInt(pieces[0].split(":")[0]);
					minLeave = Integer.parseInt(pieces[0].split(":")[1]);
					hrArrive = Integer.parseInt(pieces[1].split(":")[0]);
					minArrive = Integer.parseInt(pieces[1].split(":")[1]);
					probs[i].BtoAtimes[j][0] = hrLeave*60+minLeave;
					probs[i].BtoAtimes[j][1] = hrArrive*60+minArrive;
				}
			}
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}

