import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Q2 {
	public static Problem[] probs;

	static class Problem {
		public int N;
		public int P;
		public int[] R;
		public int[][] Q;
	}
				
	
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				String output = solveProblem(probs[i]);
				System.out.println("Case #" + (i+1) + ": " + output);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
			
	private static String solveProblem(Problem p) {
		int[][][] ingredientLimits = new int[p.N][p.P][2];
		//First determine upper and lower limits for each
		int lowestLimit = 1111112;
		int highestLimit = 0;
		for (int i=0; i<p.N; i++) {
			for (int j=0; j<p.P; j++) {
				int upperLimit = (p.Q[i][j]*10)/(p.R[i]*9);
				int testLowerLimit = (p.Q[i][j]*10)/(p.R[i]*11);
				if (testLowerLimit*(p.R[i]*11)<(p.Q[i][j]*10)) {
					testLowerLimit++;
				}
				ingredientLimits[i][j][0] = testLowerLimit;
				ingredientLimits[i][j][1] = upperLimit;
				if (testLowerLimit<lowestLimit) {
					lowestLimit = testLowerLimit;
				}
				if (upperLimit>highestLimit) {
					highestLimit = upperLimit;
				}
			}
		}
		//Match
		int[][] hits = new int[1111112][p.N];
		for (int i=0; i<1111112; i++) {
			for (int j=0; j<p.N; j++) {
				hits[i][j] = 0;
			}
		}
		//populate
		for (int i=0; i<p.N; i++) {
			for (int j=0; j<p.P; j++) {
//				System.out.println("Ing " + i + ", pack " + j + ", " + ingredientLimits[i][j][0] + "-" + ingredientLimits[i][j][1]);
				for (int k=ingredientLimits[i][j][0]; k<=ingredientLimits[i][j][1]; k++) {
					hits[k][i]++;
				}
			}
		}
		
		int kits = 0;
		
		while (true) {
		
		//find smallest match
		int limitNum = -1;
		int smallestMatchSize = p.P+1;
		int smallestSum = p.N*(p.P+1);
		for (int i=lowestLimit; i<=highestLimit; i++) {
			boolean allMatch = true;
			int matchSize = p.P+1;
			int sum = 0;
			for (int j=0; j<p.N; j++) {
				if (hits[i][j]==0) {
					allMatch = false;
					break;
				} else {
					matchSize = Math.min(matchSize, hits[i][j]);
					sum += hits[i][j];
				}
			}
			if (allMatch) {
				if (matchSize<smallestMatchSize) {
					limitNum = i;
					smallestMatchSize = matchSize;
					smallestSum = sum;
				} else if (matchSize==smallestMatchSize && sum<smallestSum) {
					limitNum = i;
					smallestSum = sum;
				}
			}
		}
		if (limitNum!=-1) {
			//Remove from list
			//Pick the package which includes this and has the least range
			for (int i=0; i<p.N; i++) {
				int packageCandidate = -1;
				int smallestRange = 1111112;
				for (int j=0; j<p.P; j++) {
					int range = ingredientLimits[i][j][1] - ingredientLimits[i][j][0];
					if (limitNum>=ingredientLimits[i][j][0] && limitNum<=ingredientLimits[i][j][1]) {
						if (range<smallestRange && range>=0) {
							packageCandidate = j;
							smallestRange = range;
						}
					}
				}
				for (int j=ingredientLimits[i][packageCandidate][0]; j<=ingredientLimits[i][packageCandidate][1]; j++) {
					hits[j][i]--;
				}
				//Remove this package from consideration
				ingredientLimits[i][packageCandidate][0] = -1;
				ingredientLimits[i][packageCandidate][1] = -1;
			}
			kits++;
		} else {
			//no more matches
			break;
		}
		
		}
		
		return "" + kits;
	}

	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			line = br.readLine();
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				String[] pieces = line.split("\\s+");
				probs[i].N = Integer.parseInt(pieces[0]);
				probs[i].P = Integer.parseInt(pieces[1]);
				line = br.readLine();
				pieces = line.split("\\s+");
				probs[i].R = new int[probs[i].N];
				for (int j=0; j<probs[i].N; j++) {
					probs[i].R[j] = Integer.parseInt(pieces[j]);
				}
				line = br.readLine();
				probs[i].Q = new int[probs[i].N][probs[i].P];
				for (int j=0; j<probs[i].N; j++) {
					pieces = line.split("\\s+");
					for (int k=0; k<probs[i].P; k++) {
						probs[i].Q[j][k] = Integer.parseInt(pieces[k]);
					}
					line = br.readLine();
				}
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
