import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;


public class Q3 {
	private static Problem[] probs;
	
	private static class Problem {
		public double f;
		public double R;
		public double t;
		public double r;
		public double g;
	}
	
	public static void main(String[] args) {
		readData(args[0]);
		process(args[0]);
	}

	public static void process(String file) {
		DecimalFormat df = new DecimalFormat("0.000000");
		BufferedWriter bw = null;
		try {
			bw = new BufferedWriter(new FileWriter(file + ".out"));
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		double x0, y0, innerRad, f, R, r, t, g;
		for (int i=0; i<probs.length; i++) {
			System.out.println("Prob " + (i+1));
			Problem currProb = probs[i];
			r = currProb.r;
			R = currProb.R;
			f = currProb.f;
			t = currProb.t;
			g = currProb.g;
			x0 = r;
			innerRad = R-t;
			if (f>innerRad && 2*f>g) {
				try {
					bw.write("Case #" + (i+1) + ": 1.000000\n");
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			double cumulativeArea = 0.0;
			while (x0<innerRad) {
				y0 = r;
				while (x0*x0+y0*y0<innerRad*innerRad) {
					System.out.println("x0: " + x0 + " y0:" + y0);
					/*5 cases:
						1) square
						2) curvy top
						3) straight, curvy corner, straight
						4) curvy side
						5) curvy corner, no straight
					*/
					
					//square
					double ulX = x0;
					double ulY = y0+g;
					boolean ulIn = (ulX*ulX+ulY*ulY<=innerRad*innerRad);
					double lrX = x0+g;
					double lrY = y0;
					boolean lrIn = (lrX*lrX+lrY*lrY<=innerRad*innerRad);
					double urX = x0+g;
					double urY = y0+g;
					boolean urIn = (urX*urX+urY*urY<=innerRad*innerRad);
					if (urIn) {
						System.out.println("square");
						cumulativeArea += (g-2*f)*(g-2*f);
					} else if (!ulIn && lrIn) { //curvy top
						System.out.println("curvy top");
						double c = R-t-f;
						double x1 = x0+f;
						double x2 = x0+g-f;
						double int2 = .5*(Math.atan(x2/Math.sqrt(c*c-x2*x2))*c*c + x2*Math.sqrt(c*c-x2*x2))-(y0+f)*x2;
						double int1 = .5*(Math.atan(x1/Math.sqrt(c*c-x1*x1))*c*c + x1*Math.sqrt(c*c-x1*x1))-(y0+f)*x1;
						if (int2-int1>0.0) {
							cumulativeArea += (int2-int1);
						}
					} else if (ulIn && lrIn) { //straight, curvy corner, straight
						//rectangle + integrated section
						System.out.println("curvy corner");
						double intersectPt = Math.sqrt((innerRad-f)*(innerRad-f) - (y0+g-f)*(y0+g-f));
						if (intersectPt-(x0+f)>0 && g-2*f>0) {
							cumulativeArea += (intersectPt-(x0+f)) * (g-2*f);
						}
							
						double c = R-t-f;
						double x1 = intersectPt;
						double x2 = x0+g-f;
						double int2 = .5*(Math.atan(x2/Math.sqrt(c*c-x2*x2))*c*c + x2*Math.sqrt(c*c-x2*x2))-(y0+f)*x2;
						double int1 = .5*(Math.atan(x1/Math.sqrt(c*c-x1*x1))*c*c + x1*Math.sqrt(c*c-x1*x1))-(y0+f)*x1;
						if (int2-int1>0.0) {
							cumulativeArea += (int2-int1);
						}
					} else if (ulIn && !lrIn) { //curvy side
						//rectangle + integrated section
						System.out.println("curvy side");
						double intersectPt = Math.sqrt((innerRad-f)*(innerRad-f) - (y0+g-f)*(y0+g-f));
						double rectangle = (intersectPt - (x0+f)) * (g-2*f);
						if ((intersectPt-(x0+f)>0 && g-2*f>0)) {
							cumulativeArea += (intersectPt-(x0+f)) * (g-2*f);
						}
						
						double yIntersectPt = Math.sqrt((innerRad-f)*(innerRad-f) - (y0+f)*(y0+f));
						double c = R-t-f;
						double x1 = intersectPt;
						double x2 = yIntersectPt;
						double int2 = .5*(Math.atan(x2/Math.sqrt(c*c-x2*x2))*c*c + x2*Math.sqrt(c*c-x2*x2))-(y0+f)*x2;
						double int1 = .5*(Math.atan(x1/Math.sqrt(c*c-x1*x1))*c*c + x1*Math.sqrt(c*c-x1*x1))-(y0+f)*x1;
						if (int2-int1>0.0) {
							cumulativeArea += (int2-int1);
						}
					} else if (!ulIn && !lrIn){ //curvy corner, no straight
 						System.out.println("all curvy");
						double x1 = x0+f;
						double x2 = Math.sqrt((innerRad-f)*(innerRad-f) - (y0+f)*(y0+f));
						double c = R-t-f;
						double int2 = .5*(Math.atan(x2/Math.sqrt(c*c-x2*x2))*c*c + x2*Math.sqrt(c*c-x2*x2))-(y0+f)*x2;
						double int1 = .5*(Math.atan(x1/Math.sqrt(c*c-x1*x1))*c*c + x1*Math.sqrt(c*c-x1*x1))-(y0+f)*x1;
						if (x2>x1 && int2-int1>0.0) {
							cumulativeArea += (int2-int1);
						}
					} else {
						System.err.println("missed a case!");
					}
					System.out.println("cumulativeArea: " + cumulativeArea);
					y0 += g + 2*r;
				}
				x0 += g + 2*r;
			}
			double prob = 1 - (cumulativeArea / (Math.PI*R*R*.25));
			String formattedProb = df.format(prob);
			try {
				bw.write("Case #" + (i+1) + ": " + formattedProb + "\n");
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		try {
			bw.flush();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static void readData(String inFile) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(inFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				line = br.readLine();
				String pieces[] = line.split(" ");
				probs[i].f = Double.parseDouble(pieces[0]);
				probs[i].R = Double.parseDouble(pieces[1]);
				probs[i].t = Double.parseDouble(pieces[2]);
				probs[i].r = Double.parseDouble(pieces[3]);
				probs[i].g = Double.parseDouble(pieces[4]);
			}
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}

