import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;


public class Q3 {
	public static Problem[] probs;

	static class Problem {
		public int R;
		public int[][] bacteria;
		public int alive = 0;
	}
		
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				String output = solveProblem(probs[i]);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
		
	
	private static String solveProblem(Problem p) {
//		for (int i=0; i<p.bacteria.length; i++) {
//			for (int j=0; j<p.bacteria.length; j++) {
//				System.out.print(p.bacteria[i][j]);
//			}
//			System.out.println();
//		}
		int secs = 0;
		while (p.alive!=0) {
//			for (int i=0; i<p.bacteria.length; i++) {
//				for (int j=0; j<p.bacteria[0].length; j++) {
//					System.out.print(p.bacteria[i][j]);
//				}
//				System.out.println();
//			}
//			System.out.println();
			p.alive = 0;
			int[][] nextIter = new int[p.bacteria.length][p.bacteria[0].length];
			nextIter[0][0] = 0;
			//across the top
			for (int i=1; i<p.bacteria[0].length; i++) {
				if (p.bacteria[0][i-1]==1) {
					nextIter[0][i] = p.bacteria[0][i];
					if (nextIter[0][i]==1) {
						p.alive++;
					}
				} else {
					nextIter[0][i] = 0;
				}
			}
			//down the left
			for (int i=1; i<p.bacteria.length; i++) {
				if (p.bacteria[i-1][0]==1) {
					nextIter[i][0] = p.bacteria[i][0];
					if (nextIter[i][0]==1) {
						p.alive++;
					}
				} else {
					nextIter[i][0] = 0;
				}
			}
			
			for (int i=1; i<p.bacteria.length; i++) {
				for (int j=1; j<p.bacteria[0].length; j++) {
					if (p.bacteria[i-1][j]==1 && p.bacteria[i][j-1]==1) {
						nextIter[i][j] = 1;
						p.alive++;
					} else if (p.bacteria[i-1][j]==0 && p.bacteria[i][j-1]==0) {
						nextIter[i][j] = 0;
					} else {
						nextIter[i][j] = p.bacteria[i][j];
						if (nextIter[i][j]==1) {
							p.alive++;
						}
					}
				}
			}
			p.bacteria = nextIter;
			secs ++;

			
		}
		
		
		return "" + secs;
	}

	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			for (int i=0; i<probs.length; i++) {
				System.out.println(i);
				line = br.readLine();
				probs[i] = new Problem();
				String[] pieces = line.split(" ");
				probs[i].R = Integer.parseInt(pieces[0]);
				ArrayList<int[]> rectangles = new ArrayList<int[]>();
				int maxX = 1;
				int minX = 1000000;
				int maxY = 1;
				int minY = 1000000;
				for (int j=0; j<probs[i].R; j++) {
					line = br.readLine();
					pieces = line.split(" ");
					int[] params = new int[4];
					for (int k=0; k<4; k++) {
						params[k] = Integer.parseInt(pieces[k]);
					}
					if (params[0]<minX) {
						minX = params[0];
					}
					if (params[2]>maxX) {
						maxX = params[2];
					}
					if (params[1]<minY) {
						minY = params[1];
					}
					if (params[3]>maxY) {
						maxY = params[3];
					}
					rectangles.add(params);
				}
				probs[i].bacteria = new int[maxY-minY+1][maxX-minX+1];
								
				for (int j=0; j<rectangles.size(); j++) {
					int[] rect = rectangles.get(j);
					for (int k=rect[0]-minX; k<=rect[2]-minX; k++) {
						for (int m=rect[1]-minY; m<=rect[3]-minY; m++) {
							probs[i].bacteria[m][k] = 1;
							probs[i].alive++;
						}
					}
				}
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
