import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashMap;


public class Qual_Q2 {
	public static Problem[] probs;
	
	static class Problem {
		public int C;
		public HashMap<String, String> mappings = new HashMap<String, String>();
		public int D;
		public String opposed[][];
		public int N;
		public String elements;
	}
	
	
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				String res = solveProblem(probs[i]);
				System.out.println(i);
				bw.write("Case #" + (i+1) + ": " + res.toString() + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
	
	private static void reduce(Problem p, ArrayList<String> elements) {
		//first combine
		if (elements.size()<2) {
			return;
		}
		String search = elements.get(elements.size()-2) + elements.get(elements.size()-1);
		if (p.mappings.containsKey(search)) {
			//remove the last 2
			elements.remove(elements.size()-1);
			elements.remove(elements.size()-1);
			//put the new one
			elements.add(p.mappings.get(search));
		} else {
			String search2 = elements.get(elements.size()-1) + elements.get(elements.size()-2);
			if (p.mappings.containsKey(search2)) {
				//remove the last 2
				elements.remove(elements.size()-1);
				elements.remove(elements.size()-1);
				//put the new one
				elements.add(p.mappings.get(search2));
			}
		}
		//then opposed
		for (int i=0; i<p.opposed.length; i++) {
			if (elements.contains(p.opposed[i][0]) && elements.contains(p.opposed[i][1])) {
				elements.clear();
				break;
			}
		}
	}
	
	private static String solveProblem(Problem p) {
		ArrayList<String> elements = new ArrayList<String>();
 		for (int i=0; i<p.elements.length(); i++) {
			elements.add(p.elements.substring(i,i+1));
			reduce(p, elements);
		}
 		String result = "[";
 		for (int i=0; i<elements.size()-1; i++) {
 			result = result + elements.get(i) + ", ";
 		}
 		if (elements.size()>0) {
 			return result + elements.get(elements.size()-1) + "]";
 		}
 		return "[]";
	}

	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			line = br.readLine();
			int i = 0;
			while (line!=null) {
				probs[i] = new Problem();
				String[] pieces = line.split(" ");
				probs[i].C = Integer.parseInt(pieces[0]);
				int j;
				for (j=0; j<probs[i].C; j++) {
					probs[i].mappings.put(pieces[1+j].substring(0, 2), pieces[1+j].substring(2));
				}
				probs[i].D = Integer.parseInt(pieces[1+probs[i].C]);
				probs[i].opposed = new String[probs[i].D][2];
				for (j=0; j<probs[i].D; j++) {
					probs[i].opposed[j][0] = pieces[1+j+probs[i].C+1].substring(0, 1); 
					probs[i].opposed[j][1] = pieces[1+j+probs[i].C+1].substring(1, 2); 
				}
				probs[i].N = Integer.parseInt(pieces[1+probs[i].C+1+probs[i].D]);
				probs[i].elements = pieces[1+probs[i].C+1+probs[i].D+1];
				line = br.readLine();
				i++;
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}


	
}

