import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Q1 {
	public static Problem[] probs;

	static class Problem {
		public int N;
		public int K;
		public char[][] board;
	}
		
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				String output = solveProblem(probs[i]);
//				System.out.println(output);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
		
	private static String solveProblem(Problem p) {
		rotate(p);
		return checkForSolutions(p);
//		for (int i=0; i<p.N; i++) {
//			for (int j=0; j<p.N; j++) {
//				System.out.print(p.board[i][j]);
//			}
//			System.out.println();
//		}
//		System.out.println();
//		return "";
	}
	
	private static String checkForSolutions(Problem p) {
		boolean blueWins = false;
		boolean redWins = false;
		int K = p.K;
		char currVal;
		boolean wins;
		for (int i=0; i<p.N; i++) {
			for (int j=0; j<p.N; j++) {
				if (redWins && blueWins) {
					return "Both";
				}
				if (p.board[i][j]=='.') {
					continue;
				}
				if (blueWins && p.board[i][j]=='B') {
					continue;
				}
				if (redWins && p.board[i][j]=='R') {
					continue;
				}
				currVal = p.board[i][j];
				wins = false;
				//lower left
				if (j>=K-1 && i<=p.N-K) {
					wins = true;
					for (int k=1; k<K; k++) {
						if (p.board[i+k][j-k]!=currVal) {
							wins = false;
							break;
						}
					}
				}
				//down
				if (!wins) {
					
				if (i<=p.N-K) {
					wins = true;
					for (int k=1; k<K; k++) {
						if (p.board[i+k][j]!=currVal) {
							wins = false;
							break;
						}
					}
				}
				
				}
				
				if (!wins) {
				
				if (j<=p.N-K && i<=p.N-K) {
					//lower right
					wins = true;
					for (int k=1; k<K; k++) {
						if (p.board[i+k][j+k]!=currVal) {
							wins = false;
							break;
						}
					}
				}
				
				}
				
				if (!wins) {
				
				if (j<=p.N-K) {
					//right
					wins = true;
					for (int k=1; k<K; k++) {
						if (p.board[i][j+k]!=currVal) {
							wins = false;
							break;
						}

					}
					
				}
				
				}
				
				if (wins) {
					if (currVal=='R') {
						redWins=true;
					} else if (currVal=='B') {
						blueWins = true;
					} else {
						System.err.println("huh?");
						System.exit(1);
					}
				}
			}
		}
		if (redWins && blueWins) {
			return "Both";
		} else if (redWins) {
			return "Red";
		} else if (blueWins) {
			return "Blue";
		}
		return "Neither";
	}

	private static void rotate(Problem p) {
		char[][] newBoard = new char[p.N][p.N];
		for (int i=p.N-1; i>=0; i--) {
			int rowCount = 0;
			for (int j=p.N-1; j>=0; j--) {
				if (p.board[i][j]=='R' || p.board[i][j]=='B') {
					newBoard[p.N-1-rowCount][p.N-1-i] = p.board[i][j];
					rowCount++;
				}
			}
			for (int j=p.N-1-rowCount; j>=0; j--) {
				newBoard[j][p.N-1-i] = '.';
			}
		}
		p.board = newBoard;
	}
	
	
	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			for (int i=0; i<probs.length; i++) {
				line = br.readLine();
				probs[i] = new Problem();
				String[] pieces = line.split(" ");
				probs[i].N = Integer.parseInt(pieces[0]);
				probs[i].K = Integer.parseInt(pieces[1]);
				probs[i].board = new char[probs[i].N][probs[i].N];
				for (int j=0; j<probs[i].N; j++) {
					line = br.readLine();
					for (int k=0; k<probs[i].N; k++) {
						probs[i].board[j][k] = line.charAt(k);
					}
				}
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
}
