import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;


public class Qual_Q1 {
	public static Problem[] probs;

	static class Problem {
		public int numButtons;
		public ArrayList<Button> button_seq = new ArrayList<Button>();
	}
	
	static class Button {
		public String robot;
		public int button;
	}
	
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
//				System.out.println("Solving " + i);
					String output = solveProblem(probs[i]);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
	
	private static int nextButton(Problem p, int i, String r) {
		for (int j=i; j<p.numButtons; j++) {
			if (p.button_seq.get(j).robot.equals(r)) {
				return p.button_seq.get(j).button;
			}
		}
		return -1;
	}
	
	private static String solveProblem(Problem p) {
		int currTime = 0;
		int index = 0;
		int curr_o = 1;
		int curr_b = 1;
		int next_o = nextButton(p, index, "O");
		int next_b = nextButton(p, index, "B");
		Button cur_button;
		while (index<p.numButtons) {
			cur_button = p.button_seq.get(index);
			if (cur_button.robot.equals("O")) {
				int diff = Math.abs(next_o-curr_o);
				curr_o = next_o;
				//diff+1 timesteps elapse b/c of pushing
				if (Math.abs(next_b-curr_b)<diff+1) {
					curr_b = next_b;
				} else {
					if (next_b>curr_b) {
						curr_b += diff+1;
					} else {
						curr_b -= diff+1;
					}
				}
				index++;
				currTime+= diff+1;
				next_o = nextButton(p, index, "O");				
			} else {
				int diff = Math.abs(next_b-curr_b);
				curr_b = next_b;
				//diff+1 timesteps elapse b/c of pushing
				if (Math.abs(next_o-curr_o)<diff+1) {
					curr_o = next_o;
				} else {
					if (next_o>curr_o) {
						curr_o += diff+1;
					} else {
						curr_o -= diff+1;
					}
				}
				index++;
				currTime+= diff+1;
				next_b = nextButton(p, index, "B");				
			}
		}
		return "" + currTime;
	}

	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			line = br.readLine();
			int i = 0;
			while (line!=null) {
				String[] pieces = line.split(" ");
				probs[i] = new Problem();
				probs[i].numButtons = Integer.parseInt(pieces[0]);
				int j;
				for (j=0; j<probs[i].numButtons; j++) {
					Button b = new Button();
					b.robot = pieces[2*j+1];
					b.button = Integer.parseInt(pieces[2*j+2]);
					probs[i].button_seq.add(b);
				}
				line = br.readLine();
				i++;
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
}
