import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;


public class Q1 {
	private static Problem prob;
	
	private static class Problem {
		public int L;
		public int D;
		public int N;
		public char[][] words;
	}
	
	public static void main(String[] args) {
		long time = System.currentTimeMillis();
		readData(args[0]);
		System.out.println(System.currentTimeMillis() - time);
	}

	private static int process(String testCase) {
		char[] test = testCase.toCharArray();
		int index = 0;
		int wordIndex = 0;
		int[] wordStatus = new int[prob.D];
		for (int i=0; i<prob.D; i++) {
			wordStatus[i] = 1;
		}
		while (index<test.length) {
			char c = test[index];
			if (c=='(') { //starting an option
				ArrayList<Character> options = new ArrayList<Character>();
				c = test[++index];
				while (c!=')') {
					options.add(c);
					c = test[++index];
				}
				char[] arr = new char[options.size()];
				for (int i=0; i<options.size(); i++) {
					arr[i] = options.get(i);
				}
				for (int i=0; i<prob.D; i++) {
					char t = prob.words[i][wordIndex];
					boolean flag = false;
					for (int j=0; j<arr.length; j++) {
						if (t==arr[j]) {
							flag = true;
							break;
						}
					}
					if (flag==false) {
						wordStatus[i] = 0;
					}
				}
				wordIndex++;
			} else {
				for (int i=0; i<prob.D; i++) {
					if (prob.words[i][wordIndex]!=c) {
						wordStatus[i] = 0;
					}
				}
				wordIndex++;
			}
			index++;
		}
		int tot = 0;
		for (int i=0; i<prob.D; i++) {
			tot += wordStatus[i];
		}
		return tot;
	}
	
	private static void readData(String inFile) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(inFile));
			BufferedWriter bw = new BufferedWriter(new FileWriter("Q1/Q1.out"));
			prob = new Problem();
			String line = br.readLine();
			String[] pieces = line.split(" ");
			prob.L = Integer.parseInt(pieces[0]);
			prob.D = Integer.parseInt(pieces[1]);
			prob.N = Integer.parseInt(pieces[2]);
			prob.words = new char[prob.D][prob.L];
			for (int i=0; i<prob.D; i++) {
				line = br.readLine();
				char[] array = line.toCharArray();
				for (int j=0; j<array.length; j++) {
					prob.words[i][j] = array[j];
				}
			}
			for (int i=0; i<prob.N; i++) {
				line = br.readLine();
				int numOptions = process(line);
				bw.write("Case #" + (i+1) + ": " + numOptions + "\n");
			}
			br.close();
			bw.flush();
			bw.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
