import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Q3 {
	public static Problem[] probs;

	static class Problem {
		public int N;
		public int J;
	}
				
	
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				String output = solveProblem(probs[i]);
				System.out.println(output);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
			
	private static long getValue(char[] arr, int base) {
		long exp = 1;
		long tot = 0;
		for (int i=0; i<arr.length; i++) {
			tot += arr[i]*exp;
			exp *= base;
		}
		return tot;
	}
	
	private static boolean increment(char[] arr) {
		int index = 1;
		arr[index] += 1;
		while (index<arr.length && arr[index]==2) {
			arr[index] = 0;
			index++;
			arr[index] += 1;
		}
		if (index<arr.length) {
			return true;
		}
		return false;
	}

	private static void printJamcoin(char[] arr) {
		for (int i=arr.length-1; i>=0; i--) {
			System.out.print((int)(arr[i]));
		}
		System.out.println();
	}
	
	private static long getDivisor(long test) {
		long i = 3;
		while(i<Math.sqrt(test)) {
			if (test%i==0) {
				return i;
			}
			i+=2;
		}
		return -1;
	}
	
	private static String solveProblem(Problem p) {
		//Length N, need J
		//Just iterate?
		ArrayList<char[]> jamcoins = new ArrayList<char[]>();
		ArrayList<long[]> divisors = new ArrayList<long[]>();
		char[] jamcoinTest = new char[p.N];
		jamcoinTest[0] = 1;
		for (int i=1; i<p.N-1; i++) {
				jamcoinTest[i] = 0;
		}
		jamcoinTest[p.N-1] = 1;
		while (jamcoins.size()<p.J) {
//			printJamcoin(jamcoinTest);
			boolean flag = true;
			long[] div = new long[11];
			//Check each base
			for (int i=2; i<=10; i++) {
				long value = getValue(jamcoinTest, i);
				long divisor = getDivisor(value);
				if (divisor==-1) {
					flag = false;
					break;
				} else {
					div[i] = divisor;
				}
			}
			if (flag) {
				jamcoins.add(jamcoinTest.clone());
				divisors.add(div);
			}
			if (!increment(jamcoinTest)) {
				return "BAD";
			}
		}
		StringBuffer response = new StringBuffer("\n");
		for (int i=0; i<jamcoins.size(); i++) {
			char[] jc = jamcoins.get(i);
			for (int j=jc.length-1; j>=0; j--) {
				if (jc[j]==0) {
					response.append("0");
				} else if (jc[j]==1) {
					response.append("1");
				} else {
					System.err.println("Error, value " + jc[j] + " in jamcoin.");
				}
			}
			long[] divs = divisors.get(i);
			for (int j=2; j<=10; j++) {
				response.append(" " + divs[j]);
			}
			response.append("\n");
		}
		return response.toString();
	}

	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			line = br.readLine();
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				String[] pieces = line.split("\\s+");
				probs[i].N = Integer.parseInt(pieces[0]);
				probs[i].J = Integer.parseInt(pieces[1]);
				line = br.readLine();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
