import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Q2 {
	public static Problem[] probs;

	static class Problem {
		public boolean[] S;
	}
				
	
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				String output = solveProblem(probs[i]);
				System.out.println(output);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
			
	private static boolean[] flip(int n, boolean[] stack) {
		//n is last pancake to flip
		boolean[] tmpStack = new boolean[stack.length];
		for (int i=0; i<=n; i++) {
			tmpStack[i] = !stack[n-i];
		}
		for (int i=n+1; i<stack.length; i++) {
			tmpStack[i] = stack[i];
		}
		return tmpStack;
	}
	
	private static String solveProblem(Problem p) {
		/*Find the closest-to-the-bottom false
		 * If the top element is false, flip from the false at the bottom
		 * If the top element is true, flip the consecutive # of trues at the top
		 */
		int i;
		int flips = 0;
		boolean[] stack = p.S;
		while (true) {
			int bottomFalse = -1;
			for (i=stack.length-1; i>=0; i--) {
				if (stack[i]==false) {
					bottomFalse = i;
					break;
				}
			}
			if (bottomFalse==-1) {
				break;
			}
			if (stack[0]==false) {
				stack = flip(bottomFalse, stack);
				flips++;
			} else {
				int conTrues = 0;
				while (conTrues<stack.length && stack[conTrues]==true) {
					conTrues++;
				}
				stack = flip(conTrues-1, stack);
				flips++;
			}
		}
		return "" + flips;
	}

	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			line = br.readLine();
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				probs[i].S = new boolean[line.trim().length()];
				for (int j=0; j<line.trim().length(); j++) {
					if (line.charAt(j)=='+') {
						probs[i].S[j] = true;
					} else {
						probs[i].S[j] = false;
					}
				}
				line = br.readLine();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
