import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Q1 {
	public static Problem[] probs;

	static class Problem {
		public long N;
		public int Pd;
		public int Pg;
	}
		
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				System.out.println("Case " + i);
				String output = solveProblem(probs[i]);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
		
	private static String solveProblem(Problem p) {
		int i, j;
		//test stupid cases
		if (p.Pg==0 && p.Pd!=0) {
			return "Broken";
		}
		if (p.Pg==100 && p.Pd!=100) {
			return "Broken";
		}
		
		//test possible values of W
		int W = 0;
		boolean found = false;
		if (p.Pd==0) {
			W = 0;
			found = true;
		} else {
		
		for (i=1; (i*100)/p.Pd<=p.N; i++) {
			int tmp = (i*100)/p.Pd;
			if (tmp*p.Pd==i*100) {
				W = i;
				found = true;
				break;
			}
		}
		
		}
		if (!found) {
			return "Broken";
		}
		
		
		return "Possible";
		//can we match Pg?
//		int D = 1;
//		if (p.Pd!=0) {
//			D = (W*100)/p.Pd;
//		}
//		int lost = D-W;
//		
//		long w = p.Pg-W;
//		long mult = 1;
//		while (w<0 || w<W) {
//			mult++;
//			w = p.Pg*mult - W;
//		}
//		
//		System.out.println("W: " + W + " w: " + w);		
		

	}
	
	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			line = br.readLine();
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				String[] pieces = line.split(" ");
				probs[i].N = Long.parseLong(pieces[0]);
				probs[i].Pd = Integer.parseInt(pieces[1]);
				probs[i].Pg = Integer.parseInt(pieces[2]);
				line = br.readLine();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}

