import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Q3 {
	public static Problem[] probs;

	static class Problem {
		public int N;
		public int K;
	}
	
	static class Stall {
			public char occupied;
			public int Ls;
			public int Rs;
			static final char EMPTY = '0';
			static final char FULL = '1';
			
			public Stall() {
				occupied = EMPTY;
			}
	}
				
	
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				String output = solveProblem(probs[i]);
				System.out.println(output);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
			
	private static String solveProblem(Problem p) {
		Stall[] stalls = new Stall[p.N+2];
		int i;
		for (i=0; i<stalls.length; i++) {
			stalls[i] = new Stall();
		}
		stalls[0].occupied = Stall.FULL;
		stalls[stalls.length-1].occupied = Stall.FULL;
		for (i=1; i<stalls.length-1; i++) {
			stalls[i].Ls = i-1;
			stalls[i].Rs = stalls.length-2-i;
		}
		int returnMax = -1;
		int returnMin = -1;
		for (i=0; i<p.K; i++) {
			int bestMin = -1;
			int bestMax = -1;
			int bestIndex = -1;
			int j;
			for (j=1; j<stalls.length-1; j++) {
				if (stalls[j].occupied==Stall.EMPTY) {
					int localMin = Math.min(stalls[j].Ls, stalls[j].Rs);
					if (localMin>bestMin) {
						bestMin = localMin;
						bestMax = Math.max(stalls[j].Ls, stalls[j].Rs);
						bestIndex = j;
					} else if (localMin==bestMin) {
						int localMax = Math.max(stalls[j].Ls, stalls[j].Rs);
						if (localMax>bestMax) {
							bestMax = localMax;
							bestIndex = j;
						}
					}
				}
			}
			stalls[bestIndex].occupied = Stall.FULL;
			//Adjust the neighbors
			int index = bestIndex-1;
			while (stalls[index].occupied==Stall.EMPTY) {
				stalls[index].Rs = bestIndex - index - 1;
				index--;
			}
			stalls[bestIndex].Ls = bestIndex - index - 1;
			index = bestIndex+1;
			while (stalls[index].occupied==Stall.EMPTY) {
				stalls[index].Ls = index - bestIndex - 1;
				index++;
			}
			stalls[bestIndex].Rs = index - bestIndex - 1;
			if (i==p.K-1) {
				//Determine returnMax, returnMin
				returnMax = Math.max(stalls[bestIndex].Ls, stalls[bestIndex].Rs);
				returnMin = Math.min(stalls[bestIndex].Ls, stalls[bestIndex].Rs);
			}
//			printStalls(stalls);
		}	
		return "" + returnMax + " " + returnMin;
	}

	public static void printStalls(Stall[] stalls) {
		for (int i=0; i<stalls.length; i++) {
			System.out.print(stalls[i].occupied);
		}
		System.out.println();
	}
	
	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			line = br.readLine();
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				String[] pieces = line.split("\\s+");
				probs[i].N = Integer.parseInt(pieces[0]);
				probs[i].K = Integer.parseInt(pieces[1]);
				line = br.readLine();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
