import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Qual_Q1 {
	public static Problem[] probs;

	static class Problem {
		public int N;
		public long K;
	}
	
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				String output = solveProblem(probs[i]);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
	
	private static String solveProblem(Problem p) {
		long pBits = 1;
		for (int i=0; i<p.N; i++) {
			pBits *= 2;
		}
		pBits -= 1;
//		System.out.println(pBits);
		if ( (p.K & pBits)==pBits ) {
			return "ON";
		}
		return "OFF";
	}

	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			line = br.readLine();
			int i = 0;
			while (line!=null) {
				String[] pieces = line.split(" ");
				probs[i] = new Problem();
				probs[i].N = Integer.parseInt(pieces[0]);
				probs[i].K = Long.parseLong(pieces[1]);
				line = br.readLine();
				i++;
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
}
