import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Q2 {
	public static Problem[] probs;

	static class Problem {
		public double C;
		public double F;
		public double X;
	}
				
	
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				String output = solveProblem(probs[i]);
				System.out.println(output);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
			
	private static String solveProblem(Problem p) {
		double totTime = 0.0;
		double rate = 2.0;
		double secondsToWin = p.X/rate;
		double secondsToBuyFarm = p.C/rate;
		double secondsToWinWithFarm = secondsToBuyFarm + p.X/(rate + p.F);
		while (secondsToWin>secondsToWinWithFarm) {
			totTime += secondsToBuyFarm;
			rate += p.F;
			secondsToWin = p.X/rate;
			secondsToBuyFarm = p.C/rate;
			secondsToWinWithFarm = secondsToBuyFarm + p.X/(rate + p.F);
		}
		return "" + (totTime + secondsToWin);
	}

	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			line = br.readLine();
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				String[] pieces = line.split(" ");
				probs[i].C = Double.parseDouble(pieces[0]);
				probs[i].F = Double.parseDouble(pieces[1]);
				probs[i].X = Double.parseDouble(pieces[2]);
				line = br.readLine();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
