import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Q2 {
	public static Problem[] probs;

	static class Problem {
		public long N;
	}
				
	
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				String output = solveProblem(probs[i]);
				System.out.println(output);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
			
	private static String solveProblem(Problem p) {
		long test = p.N;
		int index = isTidy(test);
		while (index!=-1) {
			StringBuffer testSB = new StringBuffer("" + test);
			for (int i=index; i<testSB.length(); i++) {
				testSB.setCharAt(i, '9');
			}
			String indexStr = testSB.substring(index-1, index);
			testSB.setCharAt(index-1, ("" + (Integer.parseInt(indexStr)-1)).charAt(0));
			test = Long.parseLong(testSB.toString());
			index = isTidy(test);
		}
		return "" + test;
	}

	private static int isTidy(long n) {
		String s = "" + n;
		for(int i=1; i<s.length(); i++) {
			if (Integer.parseInt(s.substring(i, i+1))<Integer.parseInt(s.substring(i-1, i))) {
				return i;
			}
		}
		return -1;
	}
	
	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			line = br.readLine();
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				probs[i].N = Long.parseLong(line.trim());
				line = br.readLine();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
