import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.NumberFormat;


public class Q3 {
	private static Problem[] probs;
	
	public static char[] phrase = "welcome to code jam".toCharArray();
	
	private static class Problem {
		public char[] text;
		public char[] transitions;
		public int[] counts;
	}
	
	public static void main(String[] args) {
		long time = System.currentTimeMillis();
		readData(args[0]);
		process();
		System.out.println(System.currentTimeMillis() - time);
	}

	private static void process() {
		try {
			DecimalFormat df = new DecimalFormat();
			df.setMaximumIntegerDigits(4);
			df.setMinimumIntegerDigits(4);
			df.setGroupingUsed(false);
			BufferedWriter bw = new BufferedWriter(new FileWriter("Q3/Q3.out"));
			for (int i=0; i<probs.length; i++) {
				Problem currProb = probs[i];
				for (char c: currProb.text) {
					for (int j=phrase.length-1; j>0; j--) {
						if (c==phrase[j]) {
							currProb.counts[j] = (currProb.counts[j] + currProb.counts[j-1]) % 10000;
						}
					}
					if (c==phrase[0]) {
						currProb.counts[0] = (currProb.counts[0] + 1) % 10000;
					}
				}
				bw.write("Case #" + (i+1) + ": ");
				bw.write(df.format(currProb.counts[phrase.length-1]) + "\n");
			}
			bw.flush();
			bw.close();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	
	private static void readData(String inFile) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(inFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				line = br.readLine();
				probs[i].text = line.toCharArray();
				probs[i].counts = new int[phrase.length];
				for (int j=0; j<phrase.length; j++) {
					probs[i].counts[j] = 0;
				}
			}
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
