import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Q1 {
	public static Problem[] probs;

	static class Problem {
		public int N;
	}
				
	
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				String output = solveProblem(probs[i]);
				System.out.println(output);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
			
	private static String solveProblem(Problem p) {
		int[] digits = new int[10];
		int i;
		boolean success = false;
		for (i=0; i<10; i++) {
			digits[i] = 0;
		}
		int testN = p.N;
		while (testN<Integer.MAX_VALUE && testN!=0) {
			int tmpN = testN;
			int log10 = (int)(Math.log10(testN)+1);
			for (i=0; i<log10; i++) {
				int digit = tmpN % 10;
				digits[digit] = 1;
				tmpN /= 10;
			}
			int prod = 1;
			for (i=0; i<10; i++) {
				prod *= digits[i];
			}
			if (prod==1) {
				success=true;
				break;
			}
			testN += p.N;
		}
		if (success) {
			return "" + testN;
		} else {
			return "INSOMNIA";
		}
	}

	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			line = br.readLine();
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				probs[i].N = Integer.parseInt(line.trim());
				line = br.readLine();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
