import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.MathContext;
import java.text.DecimalFormat;

public class R1Q3 {
	private static Problem[] probs;
	
	private static class Problem {
		public long exponent; 
	}
	
	public static void main(String[] args) {
		readData(args[0]);
		process(args[0]);
	}
	
	private static void process(String outFile) {
		BufferedWriter bw = null;
		try {
			bw = new BufferedWriter(new FileWriter(outFile+".out"));
		} catch (IOException e) {
			e.printStackTrace();
		}
		MathContext mc = new MathContext(100);
		BigDecimal rt5 = new BigDecimal(Math.sqrt(5.0));
		BigDecimal two = new BigDecimal(2);
		BigDecimal three = new BigDecimal(3);	
		BigDecimal five = new BigDecimal(5);
		for (int i=0; i<10; i++) {
			rt5 = rt5.subtract((rt5.pow(2).subtract(five)).divide(rt5.multiply(two), mc));
		}
		BigDecimal base = rt5.add(three);
		BigDecimal tot;
		DecimalFormat df = new DecimalFormat("000");

		for (int i=0; i<probs.length; i++) {
			Problem currProb = probs[i];
			tot = new BigDecimal(1.0);
			for (long j=0; j<currProb.exponent; j++) {
				tot = tot.multiply(base);
			}
			System.out.println(tot);
			BigInteger bi = tot.toBigInteger();
			int digits = bi.mod(new BigInteger("1000")).intValue();
			try {
				bw.write("Case #" + (i+1) + ": " + df.format(digits) + "\n");
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		try {
			bw.flush();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	private static void readData(String inFile) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(inFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				probs[i].exponent = Integer.parseInt(br.readLine());
			}
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
