import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;

public class R1Q1 {
	private static Problem[] probs;
	
	private static class Problem {
		public int numVectorComps;
		public int[] vect1;
		public int[] vect2;
	}
	
	public static void main(String[] args) {
		readData(args[0]);
		process(args[0]);
	}
	
	private static void process(String outFile) {
		BufferedWriter bw = null;
		try {
			bw = new BufferedWriter(new FileWriter(outFile+".out"));
		} catch (IOException e) {
			e.printStackTrace();
		}
		for(int i=0; i<probs.length; i++) {
			Problem currProb = probs[i];
			Arrays.sort(currProb.vect1);
			Arrays.sort(currProb.vect2);
			long tot = 0;
			for (int j=0; j<currProb.numVectorComps; j++) {
				tot += currProb.vect1[j]*currProb.vect2[currProb.numVectorComps-1-j];
			}
			try {
				bw.write("Case #" + (i+1) + ": " + tot + "\n");
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		try {
			bw.flush();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static void readData(String inFile) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(inFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				probs[i].numVectorComps = Integer.parseInt(br.readLine());
				probs[i].vect1 = new int[probs[i].numVectorComps];
				probs[i].vect2 = new int[probs[i].numVectorComps];
				line = br.readLine();
				String[] pieces = line.split(" ");
			 	for (int j=0; j<probs[i].numVectorComps; j++) {
			 		probs[i].vect1[j] = Integer.parseInt(pieces[j]);
			 	}
				line = br.readLine();
				pieces = line.split(" ");
			 	for (int j=0; j<probs[i].numVectorComps; j++) {
			 		probs[i].vect2[j] = Integer.parseInt(pieces[j]);
			 	}
			}
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
