import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;


public class Qual_Q2 {
	public static Problem[] probs;
	
	static class Problem {
		public int N;
		public BigInteger[] greatEvents;
	}
	
	
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				BigInteger res = solveProblem(probs[i]);
				bw.write("Case #" + (i+1) + ": " + res.toString() + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
	
	private static BigInteger solveProblem(Problem problem) {
		BigInteger[] diff = new BigInteger[problem.N-1];
		for (int i=1; i<problem.N; i++) {
			diff[i-1] = (problem.greatEvents[i].subtract(problem.greatEvents[i-1])).abs();
//			System.out.println(diff[i-1]);
		}
		BigInteger gcdInt = diff[0];
		if (diff.length>1) {
			gcdInt = diff[0].gcd(diff[1]);
			for (int i=2; i<diff.length; i++) {
				gcdInt.gcd(diff[i]);
			}
		}
//		System.out.println(gcdInt);
		BigInteger[] div = problem.greatEvents[0].divideAndRemainder(gcdInt);
//			System.out.println(div[0]);
//			System.out.println(div[1]);
			if (!div[1].equals(BigInteger.ZERO)) {
			div[0] = div[0].add(BigInteger.ONE);
		}
		BigInteger result = (div[0].multiply(gcdInt)).subtract(problem.greatEvents[0]);
		return result;
	}

	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			line = br.readLine();
			int i = 0;
			while (line!=null) {
				probs[i] = new Problem();
				String[] pieces = line.split(" ");
				probs[i].N = Integer.parseInt(pieces[0]);
				probs[i].greatEvents = new BigInteger[probs[i].N];
				for (int j=0; j<probs[i].N; j++) {
					probs[i].greatEvents[j] = new BigInteger(pieces[j+1]);
				}
				line = br.readLine();
				i++;
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}


	
}

