import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;


public class Q1 {
	private static Problem[] probs;
	
	private static class Problem {
		public String[] searchEngines;
		public String[] queries;
		
		public int lastEngine(int startingIndex) {
			int last = -2;
			ArrayList<String> engines = new ArrayList<String>();
			for (String engine: searchEngines) {
				engines.add(engine);
			}
			int i = startingIndex;
			while(i<queries.length && engines.size()>1) {
				engines.remove(queries[i]);
				i++;
			}
			if (i==queries.length) return -1;
			while(i<queries.length && !queries[i].equals(engines.get(0))) {
				i++;
			}
			if (i==queries.length) return -1;
			return i;
		}
	}
		
	public static void main(String[] args) {
		readData(args[0]);
		process(args[0]);
	}

	private static void process(String outFile) {
		BufferedWriter bw = null;
		try {
			bw = new BufferedWriter(new FileWriter(outFile+".out"));
		} catch (IOException e) {
			e.printStackTrace();
		}
		for (int i=0; i<probs.length; i++) {
			Problem currProb = probs[i];
			int counter = 0;
			int index = 0;
			index = currProb.lastEngine(0);
			while(index!=-1) {
				counter++;
				index = currProb.lastEngine(index);
			}
			try {
				bw.write("Case #" + (i+1) + ": " + counter + "\n");
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		try {
			bw.flush();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	
	private static void readData(String inFile) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(inFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				int numEngines = Integer.parseInt(br.readLine());
				probs[i].searchEngines = new String[numEngines];
			 	for (int j=0; j<numEngines; j++) {
			 		probs[i].searchEngines[j] = br.readLine();
			 	}
			 	int numQueries = Integer.parseInt(br.readLine());
			 	probs[i].queries = new String[numQueries];
			 	for (int j=0; j<numQueries; j++) {
			 		probs[i].queries[j] = br.readLine();
			 	}
			}
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}

