import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Q1 {
	public static Problem[] probs;

	static class Problem {
		public int row;
		public int[][] firstArr = new int[4][4];
		public int row2;
		public int[][] secondArr = new int[4][4];
	}
				
	
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				String output = solveProblem(probs[i]);
				System.out.println(output);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
			
	private static String solveProblem(Problem p) {
		int[] candidates = new int[4];
		for (int i=0; i<4; i++) {
			candidates[i] = p.firstArr[p.row-1][i];
//			System.out.print(candidates[i] + " ");
		}
		int[] candidates2 = new int[4];
		for (int i=0; i<4; i++) {
			candidates2[i] = p.secondArr[p.row2-1][i];
//			System.out.print(candidates2[i] + " ");
		}
		ArrayList<Integer> answers = new ArrayList<Integer>();
		for (int i=0; i<4; i++) {
			for (int j=0; j<4; j++) {
				if (candidates[i]==candidates2[j]) {
					answers.add(candidates[i]);
				}
			}
		}
	
		if (answers.size()==1) {
			return "" + answers.get(0);
		} else if (answers.size()==0) {
			return "Volunteer cheated!";
		} else {
			return "Bad magician!";
		}
	}

	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			line = br.readLine();
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				probs[i].row = Integer.parseInt(line);
				for (int j=0; j<4; j++) {
					line = br.readLine();
					String[] pieces = line.split(" ");
					for (int k=0; k<4; k++) {
						probs[i].firstArr[j][k] = Integer.parseInt(pieces[k]);
					}
				}
				line = br.readLine();
				probs[i].row2 = Integer.parseInt(line);
				for (int j=0; j<4; j++) {
					line = br.readLine();
					String[] pieces = line.split(" ");
					for (int k=0; k<4; k++) {
						probs[i].secondArr[j][k] = Integer.parseInt(pieces[k]);
					}
				}
				line = br.readLine();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
