import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Q1 {
	public static Problem[] probs;

	static class Problem {
		public int K;
		public StringBuffer S;
	}
				
	
	public static void main(String[] args) {
		String inputFile = args[0];
		parseFile(inputFile);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(inputFile + ".out"));
			for (int i=0; i<probs.length; i++) {
				String output = solveProblem(probs[i]);
				System.out.println(output);
				bw.write("Case #" + (i+1) + ": " + output + "\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
			
	private static String solveProblem(Problem p) {
		StringBuffer testSB = p.S;
		int index = isDone(testSB.toString());
		int iter = 0;
		while (index!=-1) {
			int i;
			int firstNeg = testSB.indexOf("-");
			if (testSB.length()-firstNeg<p.K) {
				return "IMPOSSIBLE";
			}
			flip(testSB, firstNeg, p.K);
			index = isDone(testSB.toString());
			iter++;
		}
		
		return "" + iter;
	}

	private static void flip(StringBuffer sb, int index, int flipSize) {
		int i;
		for (i=index; i<index+flipSize; i++) {
			if (sb.charAt(i)=='-') {
				sb.setCharAt(i, '+');
			} else {
				sb.setCharAt(i, '-');
			}
		}
	}
	
	private static int isDone(String s) {
		for (int i=0; i<s.length(); i++) {
			if (s.charAt(i)=='-') {
				return i;
			}
		}
		return -1;
	}
	
	public static void parseFile(String inputFile) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(inputFile));
			String line = br.readLine();
			probs = new Problem[Integer.parseInt(line)];
			line = br.readLine();
			for (int i=0; i<probs.length; i++) {
				probs[i] = new Problem();
				String[] pieces = line.split("\\s+");
				probs[i].S = new StringBuffer(pieces[0]);
				probs[i].K = Integer.parseInt(pieces[1]);
				line = br.readLine();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
