package round1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class DecisionTree {
	double val;
	String feature;
	DecisionTree t1;
	DecisionTree t2;

	public DecisionTree() {
		feature = null;
	}

	public static DecisionTree getTree (String a) {
		DecisionTree res = new DecisionTree();
		a = a.trim();
		int i = a.indexOf(" ");
		if (i == -1) {
			res.val = Double.parseDouble(a);
			return res;
		}
		res.val = Double.parseDouble(a.substring(0, i));
		a = a.substring(i+1).trim();
		i = a.indexOf(" ");
		res.feature = a.substring(0, i).trim();
		a = a.substring(i+1).trim();
		i = getClose(1, a);
		res.t1 = getTree(a.substring(1, i));
		a = a.substring(i+1).trim();
		res.t2 = getTree(a.substring(1, a.length()-1));
		return res;
	}

	public static int getClose (int p, String b) {
		int count = 0;
		for (int i = p; i < b.length(); i++) {
			if (b.charAt(i) == '(')
				count++;
			else if (b.charAt(i) == ')') {
				if (count == 0)
					return i;
				count--;
			}
		}
		return 0;
	}

	public static void main(String[] args) {
		try {
			BufferedReader in = new BufferedReader(new FileReader(
					"DecisionTree.in"));
			BufferedWriter out = new BufferedWriter(new FileWriter(
					"DecisionTree.out"));

			int n = Integer.parseInt(in.readLine());
			for (int i = 1; i <= n; i++) {
				int temp = Integer.parseInt(in.readLine());
				String buf = "";
				while (temp > 0) {
					temp--;
					buf = buf + " " + in.readLine();
				}
				temp = buf.indexOf("(");
				int temp2 = getClose(temp+1, buf);
				DecisionTree tree = getTree(buf.substring(temp+1, temp2));
				out.write("Case #" + i + ":\n");
				temp = Integer.parseInt(in.readLine());
				while (temp > 0) {
					temp--;
					String[] spl = in.readLine().split(" ");
					ArrayList<String> features = new ArrayList<String>(spl.length-2);
					for (int j = 2; j < spl.length; j++)
						features.add(spl[j]);
					DecisionTree tt = tree;
					double p = 1;
					while (true) {
						p *= tt.val;
						if (tt.feature == null)
							break;
						if (features.contains(tt.feature))
							tt = tt.t1;
						else
							tt = tt.t2;
					}
					out.write(p + "\n");
				}
			}

			out.close();
			in.close();
		} catch (IOException ioe) {
			System.out.println("File handling error: " + ioe);
		}
	}
}
