package qualification;

import java.awt.Point;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Watersheds {
	public static Point zero = new Point(0, 0);
	public static Point south = new Point(1, 0);
	public static Point north = new Point(-1, 0);
	public static Point east = new Point(0, 1);
	public static Point west = new Point(0, -1);

	int alt;
	int belongs;
	Point direc;

	public Watersheds (int alt) {
		this.alt = alt;
		this.belongs = -1;
		this.direc = Watersheds.zero;
	}

	public static boolean isValid (int x, int y, int h, int w) {
		if (x < 0)
			return false;
		if (x >= h)
			return false;
		if (y < 0)
			return false;
		if (y >= w)
			return false;
		return true;
	}

	public static void main(String[] args) {
		try {
			BufferedReader in = new BufferedReader(new FileReader(
					"Watersheds.in"));
			BufferedWriter out = new BufferedWriter(new FileWriter(
					"Watersheds.out"));

			String buf = in.readLine();
			int n = Integer.parseInt(buf);
			for (int i = 1; i <= n; i++) {
				buf = in.readLine();
				String[] spl = buf.split(" ");
				int h = Integer.parseInt(spl[0]);
				int w = Integer.parseInt(spl[1]);
				Watersheds[][] sheds = new Watersheds[h][w];
				for (int j = 0; j < h; j++) {
					buf = in.readLine();
					spl = buf.split(" ");
					for (int k = 0; k < w; k++)
						sheds[j][k] = new Watersheds(Integer.parseInt(spl[k]));
				}
				for (int j = 0; j < h; j++)
					for (int k = 0; k < w; k++) {
						Point t = zero;
						Point tryy = south;
						if (Watersheds.isValid(j+tryy.x, k+tryy.y, h, w))
							if (sheds[j+tryy.x][k+tryy.y].alt <= sheds[j+t.x][k+t.y].alt
									&& sheds[j+tryy.x][k+tryy.y].alt < sheds[j][k].alt)
								t = tryy;
						tryy = east;
						if (Watersheds.isValid(j+tryy.x, k+tryy.y, h, w))
							if (sheds[j+tryy.x][k+tryy.y].alt <= sheds[j+t.x][k+t.y].alt
									&& sheds[j+tryy.x][k+tryy.y].alt < sheds[j][k].alt)
								t = tryy;
						tryy = west;
						if (Watersheds.isValid(j+tryy.x, k+tryy.y, h, w))
							if (sheds[j+tryy.x][k+tryy.y].alt <= sheds[j+t.x][k+t.y].alt
									&& sheds[j+tryy.x][k+tryy.y].alt < sheds[j][k].alt)
								t = tryy;
						tryy = north;
						if (Watersheds.isValid(j+tryy.x, k+tryy.y, h, w))
							if (sheds[j+tryy.x][k+tryy.y].alt <= sheds[j+t.x][k+t.y].alt
									&& sheds[j+tryy.x][k+tryy.y].alt < sheds[j][k].alt)
								t = tryy;
						sheds[j][k].direc = t;
					}
				int mark = 0;
				for (int j = 0; j < h; j++)
					for (int k = 0; k < w; k++)
						if (sheds[j][k].direc == zero) {
							sheds[j][k].belongs = mark;
							mark++;
						}
				for (int j = 0; j < h; j++)
					for (int k = 0; k < w; k++)
						if (sheds[j][k].belongs == -1) {
							int x = j;
							int y = k;
							while (sheds[x][y].belongs == -1) {
								int x1 = sheds[x][y].direc.x;
								int y1 = sheds[x][y].direc.y;
								x += x1;
								y += y1;
							}
							int b = sheds[x][y].belongs;
							x = j;
							y = k;
							while (sheds[x][y].belongs == -1) {
								sheds[x][y].belongs = b;
								int x1 = sheds[x][y].direc.x;
								int y1 = sheds[x][y].direc.y;
								x += x1;
								y += y1;
							}
						}
				char[] marks = new char[30];
				for (int p = 0; p < 30; p++)
					marks[p] = '0';
				char toMark = 'a';
				out.write("Case #" + i + ":\n");
				for (int j = 0; j < h; j++) {
					for (int k = 0; k < w; k++) {
						if (k > 0)
							out.write(" ");
						if (marks[sheds[j][k].belongs] == '0') {
							marks[sheds[j][k].belongs] = toMark;
							out.write(toMark);
							toMark++;
						} else {
							out.write(marks[sheds[j][k].belongs]);
						}
					}
					out.write("\n");
				}
			}

			out.close();
			in.close();
		} catch (IOException ioe) {
			System.out.println("File handling error: " + ioe);
		}
	}
}
