package tictactoetomek;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;

public class TFour {

  public static void main(String[] args) throws IOException {
    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

    int numcases = Integer.parseInt(br.readLine());
    int currcase = 1;
    StringBuilder sb = new StringBuilder();
    while(numcases-- > 0) {
      char[][] gameboard = new char[4][4];
      boolean hasWinner = false;
      char winner = '.';

      gameboard[0] = br.readLine().toCharArray();
      gameboard[1] = br.readLine().toCharArray();
      gameboard[2] = br.readLine().toCharArray();
      gameboard[3] = br.readLine().toCharArray();

      // Rows
      for(int i = 0; i < 4; i++) {
        if(isXPiece(gameboard[i][0]) && isXPiece(gameboard[i][1]) && isXPiece(gameboard[i][2]) && isXPiece(gameboard[i][3])) {
          hasWinner = true;
          winner = 'X';
        } else if (isOPiece(gameboard[i][0]) && isOPiece(gameboard[i][1]) && isOPiece(gameboard[i][2]) && isOPiece(gameboard[i][3])) {
          hasWinner = true;
          winner = 'O';
        }
      }

      // Columns
      for(int i = 0; i < 4; i++) {
        if(isXPiece(gameboard[0][i]) && isXPiece(gameboard[1][i]) && isXPiece(gameboard[2][i]) && isXPiece(gameboard[3][i])) {
          hasWinner = true;
          winner = 'X';
        } else if (isOPiece(gameboard[0][i]) && isOPiece(gameboard[1][i]) && isOPiece(gameboard[2][i]) && isOPiece(gameboard[3][i])) {
          hasWinner = true;
          winner = 'O';
        }
      }

      // Diagonal
      if(isXPiece(gameboard[0][0]) && isXPiece(gameboard[1][1]) && isXPiece(gameboard[2][2]) && isXPiece(gameboard[3][3])) {
      hasWinner = true;
      winner = 'X';
      }
      if(isXPiece(gameboard[0][3]) && isXPiece(gameboard[1][2]) && isXPiece(gameboard[2][1]) && isXPiece(gameboard[3][0])) {
      hasWinner = true;
      winner = 'X';
      }

      if(isOPiece(gameboard[0][0]) && isOPiece(gameboard[1][1]) && isOPiece(gameboard[2][2]) && isOPiece(gameboard[3][3])) {
      hasWinner = true;
      winner = 'O';
      }
      if(isOPiece(gameboard[0][3]) && isOPiece(gameboard[1][2]) && isOPiece(gameboard[2][1]) && isOPiece(gameboard[3][0])) {
      hasWinner = true;
      winner = 'O';
      }

      if(hasWinner) {
        sb.append("Case #" + currcase + ": " + winner + " won\n");
      } else {
        if(boardfull(gameboard)) {
          sb.append("Case #" + currcase + ": " + "Draw\n");
        } else {
          sb.append("Case #" + currcase + ": " + "Game has not completed\n");
        }
      }

      br.readLine();
      currcase++;
    }

    System.out.println(sb);
  }

  private static boolean boardfull(char[][] board) {
    for(int i = 0; i < 4; i++) {
      for(int j = 0; j < 4; j++) {
        if(board[i][j] == '.') {
          return false;
        }
      }
    }
    return true;
  }

  private static boolean isXPiece(char c) {
    return c == 'X' || c == 'T';
  }

  private static boolean isOPiece(char c) {
    return c == 'O' || c == 'T';
  }

}
