package codejam;

import java.math.BigInteger;
import java.util.HashSet;
import java.util.Objects;
import java.util.Set;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledExecutorService;

public class Jamcoin {
    static Set<Long> foundCoins = new HashSet<>();
    public static void main(String[] args) throws Exception {
        int N = 32;
        int J = 500;
        int found = 0;

        ExecutorService executorService = Executors.newCachedThreadPool();
        System.out.println("Case #1:");
        f: for (long i = 1L<<(N-1); foundCoins.size() < J; ++i) {
            if (i % 2 == 0) {
                continue;
            }
            Future<?> f = executorService.submit(new CoinTask(i));
            Thread.sleep(200);
            f.cancel(true);
        }
    }

    static class CoinTask implements Runnable {

        long i;

        public CoinTask(long i) {
            this.i = i;
        }

        @Override
        public void run() {
                String binaryRep = Long.toBinaryString(i);
                BigInteger[] possible_divisors = new BigInteger[11];
                for (int base = 2; base <= 10; ++base) {
                    BigInteger j = new BigInteger(binaryRep, base);
                    if (j.isProbablePrime(25)) {
                        return;
                    }
                    possible_divisors[base] = null;
                    BigInteger bound = BigInteger.valueOf(((long) Math.sqrt(j.doubleValue())) + 1L);
                    for (BigInteger k = BigInteger.valueOf(2L); k.compareTo(bound) < 0; k = k.add(BigInteger.ONE)) {
                        if (j.mod(k).equals(BigInteger.ZERO)) {
                            possible_divisors[base] = k;
                            break;
                        }
                    }
                    if (possible_divisors[base] == null) {
                        return;
                    }
                }
                // so this is a jamcoin
                StringBuilder sb = new StringBuilder();
                sb.append(binaryRep);
                for (int base = 2; base <= 10; ++base) {
                    sb.append(" ");
                    sb.append(possible_divisors[base]);
                }
                if (!foundCoins.contains(i)) {
                    foundCoins.add(i);
                    System.out.println(sb.toString());
                }
            }

    }
}
