import java.io.*;

import java.util.*;

public class Q2014P3 {
	static int r;
	static int c;
	static int m;
	static int[] di = {-1,-1,-1,0,0,1,1,1};
	static int[] dj = {-1,0,1,-1,1,-1,0,1};
	static char[][] map;
	static int[][] res;
	static ArrayList<Integer> candidate;
	
	public static int posToNum(int u, int v){
		return u*c + v + 1;
	}
	
	public static int numToRow(int x){
		if (x%c==0){
			return x/c-1;
		}else {
			return x/c;
		}
	}
	
	public static int numToCol(int x){
		if (x%c-1 >= 0) 
			return x%c - 1;
		else 
			return c-1;
	}
	
	public static void mark(int uu, int vv){
		for (int k=0; k<8; k++){
			int u = uu + di[k];
			int v = vv + dj[k];
			if (u>=0 && u<r && v>=0 && v<c && map[u][v]=='.'){
				Integer tmp = Integer.valueOf(posToNum(u,v));
				if (!candidate.contains(tmp)){
					candidate.add(tmp);
				}
			}
		}
	}
	
	public static int check(int uu, int vv){
		int cnt = 0;
		for (int k=0; k<8; k++){
			int u = uu + di[k];
			int v = vv + dj[k];
			if (u>=0 && u<r && v>=0 && v<c && map[u][v]=='.'){
				Integer tmp = Integer.valueOf(posToNum(u,v));
				if (!candidate.contains(tmp)){
					cnt++;
				}
			}
		}
		return cnt;
	}
	
	public static void main(String[] args)throws FileNotFoundException, UnsupportedEncodingException {
		// TODO Auto-generated method stub
		String INPUT = "C-small-attempt3.in";
		String OUTPUT = "C-small-attempt3.out";
		File file = new File(INPUT);
		PrintWriter writer = new PrintWriter(OUTPUT, "UTF-8");
	
		Scanner sc = new Scanner(file);
		int test = sc.nextInt();
		for (int testCase=1; testCase <= test; testCase++){
			r = sc.nextInt();
			c = sc.nextInt();
			m = sc.nextInt();
			int mm = m;
			map = new char[r][c];
			res = new int[r][c];
			for (int i=0; i<r; i++)
				for (int j=0; j<c; j++)
					map[i][j] = '.';
			candidate = new ArrayList<Integer>();
			if (m>0){
				map[0][0] = '*';
				res[0][0] = -1;
				mark(0,0);
				m--;
			}
			int resi = -1;
			int resj = -1;
			int u;
			int v;
			while (m>0){
				int min = 9;
				for (Integer num:candidate){
					int n = num.intValue();
					u = numToRow(n);
					v = numToCol(n);
					int tmp = check(u,v);
					if (tmp < min){
						min = tmp;
						resi = u;
						resj = v;
					}
				}
				m--;
				map[resi][resj] = '*';
				res[resi][resj] = -1;
				mark(resi,resj);
				candidate.remove(Integer.valueOf(posToNum(resi,resj)));
			}
			
			for (int i=0; i<r; i++){
				for (int j=0; j<c; j++){
					if (map[i][j]=='.'){
						int tmp = 0;
						for (int k=0; k<8; k++){
							u = i + di[k];
							v = j + dj[k];
							if (u>=0 && u<r && v>=0 && v<c && map[u][v]=='*'){
								tmp++;
							}
						}
						res[i][j]=tmp;
					}
				}
			}
			/*
			writer.println("Case #" + testCase + ": ");
			for (int i=0; i<r; i++){
				for (int j=0; j<c; j++){
					writer.print(res[i][j]);
				}
				writer.println();
			}
			*/
			boolean impossible = false;
			for (int i=0; i<r; i++){
				for (int j=0; j<c; j++){
					if (map[i][j]=='.' && res[i][j]!=0){
						boolean pass = false;
						for (int k=0; k<8; k++){
							u = i + di[k];
							v = j + dj[k];
							if (u>=0 && u<r && v>=0 && v<c && res[u][v]==0){
								pass=true;
							}
						}
						if (!pass){impossible = true;}
					}
				}
			}
			resi = -1;
			resj = -1;
			if (impossible){
				if (mm == r*c-1){
					impossible = false;
					for (int i=0; i<r; i++)
						for (int j=0; j<c; j++)
							if (map[i][j]=='.'){
								resi = i;
								resj = j;
							}
				}
			} else {
				for (int i=0; i<r; i++)
					for (int j=0; j<c; j++)
						if (res[i][j]==0){
							resi = i;
							resj = j;
							break;
						}
			}
			
			writer.println("Case #" + testCase + ": ");
			if (impossible){
				writer.println("Impossible");
			} else{
				map[resi][resj] = 'c';
				for (int i=0; i<r; i++){
					for (int j=0; j<c; j++){
						writer.print(map[i][j]);
					}
					writer.println();
				}
			}
		}	
		
		writer.close();
	}
}
