package codejam.war;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class WarCase {
	private int n;
	private List<Double> kenBlocks;
	private List<Double> naomiBlocks;
	private double actualNaomiPick;

	public String solve(int caseNo) {
		int naomiPointsWar = playWar();
		int naomiPointsDeceitfulWar = playDeceitfulWar();

		return String.format("Case #%s: %s %s", caseNo, naomiPointsDeceitfulWar, naomiPointsWar);
	}

	private int playDeceitfulWar() {
		int naomiPointsDeceitfulWar = 0;
		Double kenChoice, naomiChoice;
		List<Double> kenSingleGameBlocks = new ArrayList<>(n);
		List<Double> naomiSingleGameBlocks = new ArrayList<>(n);
		kenSingleGameBlocks.addAll(kenBlocks);
		naomiSingleGameBlocks.addAll(naomiBlocks);

		while (!kenSingleGameBlocks.isEmpty()) {
			naomiChoice = naomiPicks(naomiSingleGameBlocks, kenSingleGameBlocks);
			kenChoice = kenPicksBest(kenSingleGameBlocks, naomiChoice);
			if (actualNaomiPick > kenChoice) {
				naomiPointsDeceitfulWar++;
			}
			kenSingleGameBlocks.remove(kenChoice);
		}
		return naomiPointsDeceitfulWar;
	}

	private Double naomiPicks(List<Double> naomiSingleGameBlocks, List<Double> kenSingleGameBlocks) {
		Double kenLow = kenSingleGameBlocks.get(0);
		Double kenHigh = kenSingleGameBlocks.get(kenSingleGameBlocks.size() - 1);
		Double naomiLow = naomiSingleGameBlocks.get(0);
		Double actualPick, whatToTell;
		if(kenLow > naomiLow) {
			actualPick = naomiLow;
			whatToTell = kenHigh - 0.0000001;
		} else {
			actualPick = naomiLow;
			whatToTell = 1.0;
		}
		actualNaomiPick = actualPick;
		naomiSingleGameBlocks.remove(actualPick);
		return whatToTell;
	}

	private int playWar() {
		int naomiPointsWar = 0;
		Double kenChoice, naomiChoice;
		List<Double> kenSingleGameBlocks = new ArrayList<>(n);
		List<Double> naomiSingleGameBlocks = new ArrayList<>(n);
		kenSingleGameBlocks.addAll(kenBlocks);
		naomiSingleGameBlocks.addAll(naomiBlocks);

		while (!kenSingleGameBlocks.isEmpty()) {
			naomiChoice = naomiSingleGameBlocks.get(0);
			kenChoice = kenPicksBest(kenSingleGameBlocks, naomiChoice);
			if (naomiChoice > kenChoice) {
				naomiPointsWar++;
			}
			kenSingleGameBlocks.remove(kenChoice);
			naomiSingleGameBlocks.remove(naomiChoice);
		}
		return naomiPointsWar;
	}

	private Double kenPicksBest(List<Double> blocks, Double naomiChoice) {
		for (Double block : blocks) {
			if (block > naomiChoice) {
				return block;
			}
		}
		return blocks.get(0);
	}

	public WarCase(int n, List<Double> naomiBlocks, List<Double> kenBlocks) {
		this.n = n;
		this.kenBlocks = kenBlocks;
		this.naomiBlocks = naomiBlocks;
		Collections.sort(this.kenBlocks);
		Collections.sort(this.naomiBlocks);

	}

	public int getN() {
		return n;
	}

	public void setN(int n) {
		this.n = n;
	}

	public List<Double> getKenBlocks() {
		return kenBlocks;
	}

	public void setKenBlocks(List<Double> kenBlocks) {
		this.kenBlocks = kenBlocks;
	}

	public List<Double> getNaomiBlocks() {
		return naomiBlocks;
	}

	public void setNaomiBlocks(List<Double> naomiBlocks) {
		this.naomiBlocks = naomiBlocks;
	}
}
