package codejam.asg2;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

public class CookieClicker {

	public static void main(String[] args) throws IOException {
		List<ClickerCase> cases = loadInput("d:\\codejam\\cookie\\B-small-attempt0.in");
		List<String> output = solve(cases);
		writeOutput(output, "d:\\codejam\\cookie\\output.txt");

	}

	private static void writeOutput(List<String> output, String path) throws IOException {
		PrintWriter file = null;
		try {
			file = new PrintWriter(new FileWriter(path, false));
			for (String solution : output) {
				file.println(solution);
			}
		} finally {
			if (file != null) {
				file.close();
			}
		}
	}

	private static List<String> solve(List<ClickerCase> cases) {
		List<String> solved = new ArrayList<>();
		int caseNo = 1;
		for (ClickerCase testCase : cases) {
			solved.add(testCase.solve(caseNo++));
		}
		return solved;
	}

	private static List<ClickerCase> loadInput(String path) throws IOException {
		BufferedReader file = null;
		List<ClickerCase> clickerCases;
		try {
			file = new BufferedReader(new FileReader(path));
			String l = file.readLine();
			int nOfCases = Integer.valueOf(l);
			clickerCases = new ArrayList<>(nOfCases);
			for (int i = 0; i < nOfCases; i++) {
				clickerCases.add(generateTestCase(file));
			}
		} finally {
			if (file != null) {
				file.close();
			}
		}
		return clickerCases;
	}

	private static ClickerCase generateTestCase(BufferedReader file) throws IOException {
		String line = file.readLine();
		String[] data = line.split(" ");

		return new ClickerCase(Double.valueOf(data[0]), Double.valueOf(data[1]), Double.valueOf(data[2]));
	}

}
