package codejam.asg2;

import java.text.DecimalFormat;

public class ClickerCase {
	private double farmCost;
	private double cpsPerFarm;
	private double goal;
	private double cps = 2;

	public String solve(int caseNo) {
		double timeElapsed = 0;
		while (!shouldEnd()) {
			timeElapsed += saveForFarm();
			buyFarm();
		}
		timeElapsed += saveForGoal();
		DecimalFormat df = new DecimalFormat("#.0000000"); 
		return String.format("Case #%s: %s", caseNo, df.format(timeElapsed).replaceAll(",", "."));
	}

	private double saveForGoal() {
		return goal / cps;
	}

	public ClickerCase(double farmCost, double cpsPerFarm, double goal) {
		super();
		this.farmCost = farmCost;
		this.cpsPerFarm = cpsPerFarm;
		this.goal = goal;
	}

	private double saveForFarm() {
		return farmCost / cps;
	}

	private boolean shouldEnd() {
		double timeToGoal = saveForGoal();
		double timeToFarm = farmCost / cps;
		double nextIterationGoal = goal / (cps + cpsPerFarm);
		if ((timeToFarm + nextIterationGoal) > timeToGoal) {
			return true;
		} else {
			return false;
		}
	}

	public void buyFarm() {
		cps += cpsPerFarm;
	}

	public double getFarmCost() {
		return farmCost;
	}

	public void setFarmCost(double farmCost) {
		this.farmCost = farmCost;
	}

	public double getCpsPerFarm() {
		return cpsPerFarm;
	}

	public void setCpsPerFarm(double cpsPerFarm) {
		this.cpsPerFarm = cpsPerFarm;
	}

	public double getGoal() {
		return goal;
	}

	public void setGoal(double goal) {
		this.goal = goal;
	}
}
