package codejam.war;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

public class War {
	public static void main(String[] args) throws IOException {
		List<WarCase> cases = loadInput("d:\\codejam\\war\\D-small-attempt0.in");
		List<String> output = solve(cases);
		writeOutput(output, "d:\\codejam\\war\\output.txt");
	}

	private static void writeOutput(List<String> output, String path) throws IOException {
		PrintWriter file = null;
		try {
			file = new PrintWriter(new FileWriter(path, false));
			for (String solution : output) {
				file.println(solution);
			}
		} finally {
			if (file != null) {
				file.close();
			}
		}
	}

	private static List<String> solve(List<WarCase> cases) {
		List<String> solved = new ArrayList<>();
		int caseNo = 1;
		for (WarCase testCase : cases) {
			solved.add(testCase.solve(caseNo++));
		}
		return solved;
	}

	private static List<WarCase> loadInput(String path) throws IOException {
		BufferedReader file = null;
		List<WarCase> warCases;
		try {
			file = new BufferedReader(new FileReader(path));
			String l = file.readLine();
			int nOfCases = Integer.valueOf(l);
			warCases = new ArrayList<>(nOfCases);
			for (int i = 0; i < nOfCases; i++) {
				warCases.add(generateTestCase(file));
			}
		} finally {
			if (file != null) {
				file.close();
			}
		}
		return warCases;
	}

	private static WarCase generateTestCase(BufferedReader file) throws IOException {
		String nLine = file.readLine();
		String naomiLine = file.readLine();
		String kenLine = file.readLine();

		List<Double> naomiBlocks = lineToBlocks(naomiLine);
		List<Double> kenBlocks = lineToBlocks(kenLine);
		return new WarCase(Integer.valueOf(nLine), naomiBlocks, kenBlocks);
	}

	private static List<Double> lineToBlocks(String line) {
		String[] strBlocks = line.split(" ");
		List<Double> result = new ArrayList<>();
		for (String block : strBlocks) {
			result.add(Double.valueOf(block));
		}
		return result;
	}
}
