package codejam.asg1;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

public class Magican {

	public static void main(String[] args) throws IOException {
		List<TestCase> cases = loadInput("d:\\codejam\\magican\\A-small-attempt0.in");
		List<String> output = solve(cases);
		writeOutput(output, "d:\\codejam\\magican\\output.txt");
	}

	private static List<String> solve(List<TestCase> cases) {
		List<String> solved = new ArrayList<>();
		int caseNo = 1;
		for (TestCase testCase : cases) {
			solved.add(testCase.solve(caseNo++));
		}
		return solved;
	}

	private static void writeOutput(List<String> output, String path) throws IOException {
		PrintWriter file = null;
		try {
			file = new PrintWriter(new FileWriter(path, false));
			for (String solution : output) {
				file.println(solution);
			}
		} finally {
			if (file != null) {
				file.close();
			}
		}
	}

	private static List<TestCase> loadInput(String path) throws IOException {
		BufferedReader file = null;
		List<TestCase> testCases;
		try {
			file = new BufferedReader(new FileReader(path));
			String l = file.readLine();
			int nOfCases = Integer.valueOf(l);
			testCases = new ArrayList<>(nOfCases);
			for (int i = 0; i < nOfCases; i++) {
				testCases.add(generateTestCase(file));
			}
		} finally {
			if (file != null) {
				file.close();
			}
		}
		return testCases;
	}

	private static TestCase generateTestCase(BufferedReader file) throws NumberFormatException, IOException {
		TestCase testCase = new TestCase();
		testCase.setFirstRow(Integer.valueOf(file.readLine()) - 1);
		int[][] cards = createCards(file);
		testCase.setCards1(cards);

		testCase.setSecondRow(Integer.valueOf(file.readLine()) - 1);
		cards = createCards(file);
		testCase.setCards2(cards);

		return testCase;
	}

	private static int[][] createCards(BufferedReader file) throws IOException {
		int[][] cards = new int[4][4];

		for (int i = 0; i <= 3; i++) {
			lineToCards(file.readLine(), cards, i);
		}
		return cards;
	}

	private static void lineToCards(String line, int[][] cards, int row) {
		String[] cardsStr = line.split(" ");
		int i = 0;
		for (String card : cardsStr) {
			cards[row][i] = Integer.valueOf(card);
			i++;
		}
	}

}
