import java.util.*;
import java.io.*;

public class B {
    public static final int ITERATIONS = 75;
    public static final double EPS = 1e-6;
    FastScanner in;
    PrintWriter out;

    private double C, F, X;
    public void solve() throws IOException {
        int TEST = in.nextInt();
        for (int test = 1; test <= TEST; test++) {
            C = in.nextDouble();
            F = in.nextDouble();
            X = in.nextDouble();

            int l = 0, r = 10000000;

            while (r - l > 5) {
                int m1 = l + (r - l) / 3;
                int m2 = r - (r - l) / 3;
                double q1 = f(m2);
                double q2 = f(m1);
                if (q1 - q2 < -EPS) {
                    l = m1;
                } else {
                    r = m2;
                }
            }
            double ans = 0.0;
            ans = Double.MAX_VALUE;
            for (int i = l; i <= r; i++) {
                ans = Math.min(ans, f(i));
            }

            out.println("Case #" + test + ": " + ans);
        }
    }

    private double f(int cnt) {
        double result = 0;
        int ferms = 0;
        double current = 2.0;
        while (ferms < cnt) {
            double q = current + ferms * F;
            double time = C / q;
            ferms++;
            result += time;
        }
        return result + X / (current + ferms * F);
    }

    public void run() {
        try {
            in = new FastScanner(new File("input.txt"));
            out = new PrintWriter(new File("output.txt"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }
    }

    public static void main(String[] arg) {
        new B().run();
    }
}