import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;


public class D {

	public static void main(String[] args) {
		Scanner in;
		PrintWriter out;
		try {
			in = new Scanner(new File("D-small-attempt1.in"));
			out = new PrintWriter("d1.out");
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(1);
			return;
		}
		
		int numCases = in.nextInt();
		
		for (int t = 1; t <= numCases; t++){
			int numBlocks = in.nextInt();
			double[] naomi = new double[numBlocks];
			for (int i = 0; i < naomi.length; i++){
				naomi[i] = in.nextDouble();
			}
			
			double[] ken = new double[numBlocks];
			for (int i = 0; i < ken.length; i++){
				ken[i] = in.nextDouble();
			}
			
			Arrays.sort(naomi);
			Arrays.sort(ken);
			
			ArrayList<Double> p1List = new ArrayList<>();
			for (int i = 0; i < naomi.length; i++){
				p1List.add(naomi[i]);
			}
			
			ArrayList<Double> p2List = new ArrayList<>();
			for (int i = 0; i < ken.length; i++){
				p2List.add(ken[i]);
			}
			
			System.out.println(t + ":");
			System.out.println(Arrays.toString(naomi));
			System.out.println(Arrays.toString(ken));
			
			int deciet = solveDeciet(new ArrayList<Double>(p1List), new ArrayList<Double>(p2List));
			int war = solveWar(new ArrayList<Double>(p1List), new ArrayList<Double>(p2List));
			
			out.println("Case #" + t + ": " + deciet + " " + war);
			
		}
		
		out.flush();
		
		in.close();
		out.close();
		
	}

	private static int solveWar(ArrayList<Double> p1, ArrayList<Double> p2) {
		int max = 0;
		for (int i = 0; i < p1.size(); i++){
			int j = 0;
			while (j < p2.size() && p2.get(j) < p1.get(i)){
				j++;
			}
			int score;
			
			if (j >= p2.size()){
				double temp = p2.remove(0);
				double temp2 = p1.remove(i);
				score = 1+solveWar(p1, p2);
				p2.add(0, temp);
				p1.add(i,temp2);
			}
			else{
				double temp = p2.remove(j);
				double temp2 = p1.remove(i);
				score = solveWar(p1,p2);
				p2.add(j, temp);
				p1.add(i, temp2);
			}
			
			if (score > max){
				max = score;
			}
		}
		return max;
	}

	private static int solveDeciet(ArrayList<Double> p1, ArrayList<Double> p2) {
		int i = 0;
		while (i < p1.size() && p1.get(i) < p2.get(0)){
			i++;
		}
		return p1.size()-i;
	}


	
}
