package io.savinkov;

import javax.crypto.NoSuchPaddingException;
import java.io.*;
import java.security.NoSuchAlgorithmException;
import java.util.LinkedList;
import java.util.Queue;

public class Main {

    public static int findNonTrivialDivisor(long n) {
        for (int i = 2; i < n; i++) {
            if(n % i == 0) return i;
        }
        return 0;
    }

    public static boolean hasDivisorsForAllBases(int[] divs) {
        for (int d: divs) if(d == 0 || d == -1) return false;
        return true;
    }

    public static String getAllDivisors(int[] divs) {
        StringBuffer sb = new StringBuffer();
        for (int i=0; i < divs.length; i++) {
            if (i != divs.length -1) {
                sb.append(divs[i] + " ");
            } else {
                sb.append(divs[i]);
            }
        }
        return sb.toString();
    }

    public static void main(String[] args) throws NoSuchPaddingException, NoSuchAlgorithmException {
        BufferedReader br = null;
        FileOutputStream fos = null;
        BufferedWriter bw = null;
        try {
            br = new BufferedReader(new FileReader("input"));
            fos = new FileOutputStream(new File("output1.txt"));
            bw = new BufferedWriter(new OutputStreamWriter(fos));
            String line;
            int[] divisors = null;
            final int CASES = Integer.valueOf(br.readLine());
            String[] params = br.readLine().split("\\s+");
            final int LENGTH = Integer.valueOf(params[0]);
            final int NUMBER_OF_RESULTS = Integer.valueOf(params[1]);
            Queue<String> lastResults = null;
            String max_str = "";
            for(int d=0; d < LENGTH; d++) max_str += "1";
            final int MAX_JAMCOIN = Integer.parseInt(max_str,2);
            final int MIN_JAMCOIN = (1 << LENGTH - 1) + 1;
            for (int i = 1; i <= CASES; i++) {
                lastResults = new LinkedList<>();
                bw.write(String.format("Case #%s:",i));
                bw.newLine();
                for (int jamc = MAX_JAMCOIN; jamc >= MIN_JAMCOIN; jamc-=2){
                    long num = 0;
                    int divisor = 0;
                    divisors = new int[9];
                    for (int j = 2; j <=10; j++) {
                        num = Long.parseLong(Integer.toBinaryString(jamc),j);
                        divisor  = findNonTrivialDivisor(num);
                        if (divisor == 0) {
                            break;
                        } else {
                            divisors[j-2]=divisor;
                        }
                    }
                    if (hasDivisorsForAllBases(divisors)) {
                        String divStr = getAllDivisors(divisors);
                        if (lastResults.size() == NUMBER_OF_RESULTS) {
                            break;
                        }
                        lastResults.add(String.format("%s %s",Integer.toBinaryString(jamc),divStr));
                    }
                }
                for (String output: lastResults) {
                    bw.write(output);
                    bw.newLine();
                }
            }
            br.close();
            bw.close();
            fos.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
