import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Scanner;

/**
 *
 * @author Daniel Sheng
 */
public class Tongues
{
    private static class CharFreq implements Comparable<CharFreq>
    {
        private char letter;
        private int seen;
        
        public CharFreq(char c)
        {
            letter = c;
            seen = 0;
        }

        public int compareTo(CharFreq o)
        {
            return o.seen - seen;
        }
    }
    
    private static final LinkedList<Character> engFrequent = new LinkedList<Character>();
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws FileNotFoundException
    {
        char[] mapping = initMappings();
        
        Scanner in = new Scanner(new java.io.FileInputStream(new File("A-small-attempt1.in")));
        int lns = Integer.parseInt(in.nextLine());
        
        PrintStream out = new PrintStream("tongues.out");
        
        LinkedList<String> encoded = new LinkedList<String>();
        CharFreq[] freqs = new CharFreq[26];
        for(char c = 'a'; c <= 'z'; c = (char) (c + 1))
            freqs[c - 'a'] = new CharFreq(c);
        
        for(int ln = 0; ln < lns; ln++)
        {
            String garbled = in.nextLine();
            encoded.add(garbled);
            
            for(int i = 0; i < garbled.length(); i++)
            {
                char c = garbled.charAt(i);
                if(c != ' ')
                    freqs[c - 'a'].seen++;
            }
        }
        
        genMappings(freqs, mapping);
        
        int num = 1;
        for(String garbled : encoded)
        {
            String engStr = "Case #" + (num++) + ": ";
            for(int i = 0; i < garbled.length(); i++)
            {
                char c = garbled.charAt(i);
                if(c != ' ')
                    engStr += mapping[c - 'a'];
                else
                    engStr += ' ';
            }
            out.println(engStr);
        }
        //*/
    }
    
    private static char[] initMappings()
    {
        engFrequent.add('e');
        engFrequent.add('t');
        engFrequent.add('a');
        engFrequent.add('o');
        engFrequent.add('i');
        engFrequent.add('n');
        engFrequent.add('s');
        engFrequent.add('h');
        engFrequent.add('r');
        engFrequent.add('d');
        engFrequent.add('l');
        engFrequent.add('c');
        engFrequent.add('u');
        engFrequent.add('m');
        engFrequent.add('w');
        engFrequent.add('f');
        engFrequent.add('g');
        engFrequent.add('y');
        engFrequent.add('p');
        engFrequent.add('b');
        engFrequent.add('v');
        engFrequent.add('k');
        engFrequent.add('j');
        engFrequent.add('x');
        engFrequent.add('q');
        engFrequent.add('z');
        
        String from = "y qee ejp mysljylc kd kxveddknmc re jsicpdrysi rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd de kr kd eoya kw aej tysr re ujdr lkgc jv".replaceAll("\\s+", "");
        String to = "a zoo our language is impossible to understand there are twenty six factorial possibilities so it is okay if you want to just give up".replaceAll("\\s+", "");
        char[] mapping = new char[26];
        for(int i = 0; i < from.length(); i++)
        {
            char map = to.charAt(i);
            mapping[from.charAt(i) - 'a'] = map;
            engFrequent.remove((Character) map);
        }
        
        return mapping;
    }
    
    private static void genMappings(CharFreq[] freqs, char[] mapping)
    {
        Iterator<Character> freqLetterIter = engFrequent.iterator();
        
        Arrays.sort(freqs);
        
        for(CharFreq c : freqs)
            if(mapping[c.letter - 'a'] == '\0')
                mapping[c.letter - 'a'] = freqLetterIter.next();
    }
}
