package codejam.round1B;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/*
 * Problem A. Getting the Digits
 */
public class ProblemA {

	private static BufferedReader br;

	private static void init(String filePath) {
		try {
			br = new BufferedReader(new FileReader(filePath));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	private static String readNextline() {
		String line = null;
		if (br != null) {
			try {
				line = br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return line;
	}

	public static void main(String args[]) {
		init("A-small-attempt0.in");
		execute();
	}

	private static void execute() {
		int testCases = 0;

		testCases = Integer.parseInt(readNextline());

		for (int currentTestCase = 1; currentTestCase <= testCases; currentTestCase++) {

			String S = readNextline();
			char[] i = S.toCharArray();
			List<Character> input = new ArrayList<Character>();
			for (char c : i) {
				input.add(c);
			}
			List<String> output = new ArrayList<String>();
			
			while (input.size() > 0) {
				output.add(getNextNumber(input));
			}
			
			Collections.sort(output);
			System.out.print("Case #" + currentTestCase + ": ");
			for (int j = 0; j < output.size(); j++) {
				System.out.print(output.get(j));
			}
			System.out.print("\n");

		}

	}
		
	static String getNextNumber(List<Character> input) {
		if (input.contains('Z')) {
			input.remove(input.indexOf('Z'));
			input.remove(input.indexOf('E'));
			input.remove(input.indexOf('R'));
			input.remove(input.indexOf('O'));
			return "0";

		} else if (input.contains('W')) {
			input.remove(input.indexOf('T'));
			input.remove(input.indexOf('W'));
			input.remove(input.indexOf('O'));
			return "2";

		} else if (input.contains('U')) {
			input.remove(input.indexOf('F'));
			input.remove(input.indexOf('O'));
			input.remove(input.indexOf('U'));
			input.remove(input.indexOf('R'));
			return "4";

		} else if (input.contains('X')) {

			input.remove(input.indexOf('S'));
			input.remove(input.indexOf('I'));
			input.remove(input.indexOf('X'));
			return "6";
		} else if (input.contains('G')) {
			input.remove(input.indexOf('E'));
			input.remove(input.indexOf('I'));
			input.remove(input.indexOf('G'));
			input.remove(input.indexOf('H'));
			input.remove(input.indexOf('T'));
			return "8";
		}else if(input.contains('R')){
			input.remove(input.indexOf('T'));
			input.remove(input.indexOf('H'));
			input.remove(input.indexOf('R'));
			input.remove(input.indexOf('E'));
			input.remove(input.indexOf('E'));
			return "3";
		}
		else if(input.contains('O')){
			input.remove(input.indexOf('O'));
			input.remove(input.indexOf('N'));
			input.remove(input.indexOf('E'));
			return "1";
		}
		else if(input.contains('F')){
			input.remove(input.indexOf('F'));
			input.remove(input.indexOf('I'));
			input.remove(input.indexOf('V'));
			input.remove(input.indexOf('E'));
			return "5";
		}
		else if(input.contains('S')){
			input.remove(input.indexOf('S'));
			input.remove(input.indexOf('E'));
			input.remove(input.indexOf('V'));
			input.remove(input.indexOf('E'));
			input.remove(input.indexOf('N'));
			return "7";
		}
		else if(input.contains('N')){
			input.remove(input.indexOf('N'));
			input.remove(input.indexOf('I'));
			input.remove(input.indexOf('N'));
			input.remove(input.indexOf('E'));
			
			return "9";
		}
		
		return null;
	}
}
