package codejam.qualification;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

/*
 * Problem B. Revenge of the Pancakes
 */
public class QualificationB {

	private static BufferedReader br;

	private static void init(String filePath) {
		try {
			br = new BufferedReader(new FileReader(filePath));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	private static String readNextline() {
		String line = null;
		if (br != null) {
			try {
				line = br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return line;
	}

	public static void main(String args[]) {
		init("B-small-attempt0.in");
		execute();
	}

	private static void execute() {
		int testCases = 0;

		testCases = Integer.parseInt(readNextline());

		for (int currentTestCase = 1; currentTestCase <= testCases; currentTestCase++) {
			String S = readNextline();
			char[] stack = S.toCharArray();

			System.out.println("Case #" + currentTestCase + ": "
					+ getFlipCount(stack));
		}

	}

	private static int getFlipCount(char[] stack) {
		if (stack == null || stack.length == 0) {
			return 0;
		}
		int flipCount = 0;
		int bottom = stack.length - 1;
		bottom = determineBottomIndex(stack);
		while (bottom > 0) {
			if (stack[0] == '-') {
				flipStack(stack, bottom);
			} else {
				int idx = determineLastPlusIndex(stack, bottom);
				flipStack(stack, idx);
			}
			flipCount++;
			bottom = determineBottomIndex(stack);
		}
		if (stack[0] == '-') {
			flipCount++;
		}

		return flipCount;
	}

	private static int determineBottomIndex(char[] stack) {
		if (stack == null || stack.length == 0) {
			return -1;
		}

		int len = stack.length;
		int bottom = len - 1;
		for (int i = len - 1; i > 0; i--) {
			if (stack[i] == '-') {
				break;
			}
			bottom = i - 1;
		}

		return bottom;
	}

	private static void flipStack(char[] stack, int bottom) {
		if (stack == null || stack.length == 0) {
			return;
		}
		for (int i = 0, j = bottom; i <= j; i++, j--) {
			char c = stack[i];
			stack[i] = flipSymbol(stack[j]);
			stack[j] = flipSymbol(c);
		}
	}

	private static char flipSymbol(char symbol) {
		if (symbol == '+') {
			return '-';
		}
		return '+';
	}

	private static int determineLastPlusIndex(char[] stack, int bottom) {
		if (stack == null || stack.length == 0) {
			return -1;
		}
		int idx = 0;
		for (int i = 0; i < bottom; i++) {
			if (stack[i] == '+') {
				idx = i;
			}
		}
		return idx;
	}

}
