package codejam.qualification;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

/*
 * Problem A. Counting Sheep
 */
public class Qualification1 {

	private static BufferedReader br;

	private static void init(String filePath) {
		try {
			br = new BufferedReader(new FileReader(filePath));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	private static String readNextline() {
		String line = null;
		if (br != null) {
			try {
				line = br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return line;
	}

	public static void main(String args[]) {
		init("A-small-attempt0.in");
		execute();
	}

	private static void execute() {
		int testCases = 0;

		testCases = Integer.parseInt(readNextline());

		for (int currentTestCase = 1; currentTestCase <= testCases; currentTestCase++) {
			int N = Integer.parseInt(readNextline());
			System.out.println("Case #" + currentTestCase + ": "
					+ getLastNumber(N));
		}

	}

	private static String getLastNumber(int N) {
		if (N == 0) {
			return "INSOMNIA";
		}

		Set<Integer> seenDigits = new HashSet<Integer>();

		int lastNum = 0;
		int iteration = 1;

		while (seenDigits.size() < 10) {
			lastNum = iteration * N;
			recordVisitedDigits(lastNum, seenDigits);
			iteration++;
		}

		return Integer.toString(lastNum);
	}

	private static void recordVisitedDigits(int last, Set<Integer> seenDigits) {
		int x = last;
		while (x != 0) {
			int y = x % 10;
			seenDigits.add(y);
			x = x / 10;
		}
	}

}
