import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.util.Arrays;

public class Candy {
   private void solve() {
      int numCases = nextInt();
      for (int cases = 0; cases < numCases; cases++) {
         int numCandies = nextInt();
         int[] candies = new int[numCandies];
         for (int i = 0; i < numCandies; i++) {
            candies[i] = nextInt();
         }
         // sort array
         Arrays.sort(candies);

         int target = -1;
         // sum of all candies except for target
         int sum = -1;
         // index of target
         int skip = -1;
         // index which starts sean's pile
         for (int i = 0; i < numCandies; i++) {
            target = candies[i];
            sum = patrickSum(candies, i);
            if (target == sum) {
               skip = i;
               break;
            }
         }
         if (target != sum) {
            writer.println("Case #" + (cases + 1) + ": " + "NO");
         } else {
            writer.println("Case #" + (cases + 1) + ": " + seanSum(candies, skip));
         }
      }
   }

   // private static int pSum(int a, int b) {
   //    int big, small;
   //    if (a > b) {
   //       big = a;
   //       small = b;
   //    } else {
   //       big = b;
   //       small = a;
   //    }
   //    int sum = 0;
   //    while (big > 0) {
   //       int exp = (int) (Math.log(big)/Math.log(2));
   //       int pow = (int) Math.pow(2, exp);
   //       if (small >= pow) {
   //          small -= pow;
   //          big -= pow;
   //       } else {
   //          big -= pow;
   //          sum += pow;
   //       }
   //    }
   //    sum += big;
   //    sum += small;
   //    return sum;
   // }
   
   private int patrickSum(int[] nums, int skip) {
      int sum = 0;
      for (int i = 0; i < nums.length; i++) {
         if (i == skip) continue;
         sum = sum ^ nums[i];
      }
      return sum;
   }

   private int seanSum(int[] nums, int skip) {
      int sum = 0;
      for (int i = 0; i < nums.length; i++) {
         if (i == skip) continue;
         sum += nums[i];
      }
      return sum;
   }

   private static String TASK_ID;

   public static void main(String[] args) {
//      System.out.println(pSum(Integer.parseInt(args[0]), Integer.parseInt(args[1])));
      TASK_ID = args[0];
      new Candy().run();
   }

   BufferedReader reader;
   StringTokenizer tokenizer = null;
   PrintWriter writer;

   public void run() {
      try {
         long now = System.currentTimeMillis();
         reader = new BufferedReader(new FileReader(TASK_ID + ".in"));
         writer = new PrintWriter(TASK_ID + ".out");
         solve();
         reader.close();
         writer.close();
         System.out.println(System.currentTimeMillis() - now + "ms");
      } catch (Exception e) {
         throw new RuntimeException(e);
      }
   }

   int nextInt() {
      return Integer.parseInt(nextToken());
   }

   double nextDouble() {
      return Double.parseDouble(nextToken());
   }

   long nextLong() {
      return Long.parseLong(nextToken());
   }

   String nextToken() {
      while (tokenizer == null || !tokenizer.hasMoreTokens()) {
         try {
            tokenizer = new StringTokenizer(reader.readLine());
         } catch (IOException e) {
            throw new RuntimeException(e);
         }
      }
      return tokenizer.nextToken();
   }
}
