import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.io.IOException;

public class A {
   
   public void solve() {
      int numCases = nextInt();
      for (int caseNum = 0; caseNum < numCases; caseNum++) {
         int numRows = nextInt();
         int numCols = nextInt();
         char[][] grid = new char[numRows][numCols];
         for (int row = 0; row < numRows; row++) {
            grid[row] = nextToken().toCharArray();
         }
         boolean poss = true;
        check:
         for (int row = 0; row < numRows; row++) {
            for (int col = 0; col < numCols; col++) {
               if (grid[row][col] == '#') {
                  if (row == numRows-1 || col == numCols-1) {
                     poss = false;
                     break check;
                  }
                  boolean squareExists = (grid[row][col] == '#' &&
                                          grid[row+1][col] == '#' &&
                                          grid[row][col+1] == '#' &&
                                          grid[row+1][col+1] == '#');

                  if (!squareExists) {
                     poss = false;
                     break check;
                  }
                  grid[row][col] = '/';
                  grid[row+1][col] = '\\';
                  grid[row][col+1] = '\\';
                  grid[row+1][col+1] = '/';
               }
            }
         }
         writer.println("Case #" + (caseNum+1) + ":");
         if (poss) {
            for (int row = 0; row < numRows; row++) {
               for (int col = 0; col < numCols; col++) {
                  writer.print(grid[row][col]);
               }
               writer.println();
            }
         } else {
            writer.println("Impossible");
         }
      }
   }
   
   private static String TASK_ID = "A";

   public static void main(String[] args) {
      new A().run();
      System.exit(0);
   }
   
   BufferedReader reader;
   StringTokenizer tokenizer = null;
   PrintWriter writer;

   public void run() {
      try {
         reader = new BufferedReader(new FileReader(TASK_ID + ".in"));
         writer = new PrintWriter(TASK_ID + ".out");
         solve();
         reader.close();
         writer.close();
      } catch (Exception e) {
         throw new RuntimeException(e);
      }
   }
   
   int nextInt() {
      return Integer.parseInt(nextToken());
   }

   double nextDouble() {
      return Double.parseDouble(nextToken());
   }

   long nextLong() {
      return Long.parseLong(nextToken());
   }

   String nextToken() {
      while (tokenizer == null || !tokenizer.hasMoreTokens()) {
         try {
            tokenizer = new StringTokenizer(reader.readLine());
         } catch (IOException e) {
            throw new RuntimeException(e);
         }
      }
      return tokenizer.nextToken();
   }
}
