import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class BotTrust {
   private void solve() {
      int numTests = nextInt();
      for (int i = 0; i < numTests; i++) {
         int numButtons = nextInt();
         // location of O
         int oLoc = 1;
         // location of B
         int bLoc = 1;
         // total number of steps
         int totalSteps = 0;
         // previous bot to move
         String prevBot = null;
         // number of steps taken in previous button
         int prevSteps = 0;
         for (int j = 0; j < numButtons; j++) {
            String nowBot = nextToken();
            int target = nextInt();
            // number of steps needed to press button
            int steps;

            // calculate number of steps
            if (nowBot.equals("O")) {
               steps = Math.abs(oLoc - target) + 1;
               oLoc = target;
            } else { // B bot
               steps = Math.abs(bLoc - target) + 1;
               bLoc = target;
            }
            
            if (j == 0 || prevBot.equals(nowBot)) {
               totalSteps += steps;
               prevSteps += steps;
            } else { // !prevBot.equals(nowBot)
               if (prevSteps >= steps) {
                  totalSteps += 1;
                  prevSteps = 1;
               } else { // if (prevSteps < steps)
                  totalSteps += (steps - prevSteps);
                  prevSteps = (steps - prevSteps);
               }
            }
            prevBot = nowBot;
         }
         writer.println("Case #" + (i+1) + ": " + totalSteps);
      }
   }

   private static String TASK_ID;

   public static void main(String[] args) {
      TASK_ID = args[0];
      new BotTrust().run();
   }

   BufferedReader reader;
   StringTokenizer tokenizer = null;
   PrintWriter writer;

   public void run() {
      try {
         long now = System.currentTimeMillis();
         reader = new BufferedReader(new FileReader(TASK_ID + ".in"));
         writer = new PrintWriter(TASK_ID + ".out");
         solve();
         reader.close();
         writer.close();
         System.out.println(System.currentTimeMillis() - now + "ms");
      } catch (Exception e) {
         throw new RuntimeException(e);
      }
   }

   int nextInt() {
      return Integer.parseInt(nextToken());
   }

   double nextDouble() {
      return Double.parseDouble(nextToken());
   }

   long nextLong() {
      return Long.parseLong(nextToken());
   }

   String nextToken() {
      while (tokenizer == null || !tokenizer.hasMoreTokens()) {
         try {
            tokenizer = new StringTokenizer(reader.readLine());
         } catch (IOException e) {
            throw new RuntimeException(e);
         }
      }
      return tokenizer.nextToken();
   }
}
