package trygoogle.triangle;

import java.util.HashSet;
import java.util.Set;
import java.util.Vector;

public class Triangles {

	public static class Point {
		public Point(long x, long y) {
			this.x=x;
			this.y=y;
		}

		@Override
		public boolean equals(Object o) {
			if (o instanceof Point) {
				Point ot = (Point) o;
				return ot.x == x && ot.y == y;
			}
			return false;
		}
		
		@Override
		public int hashCode() {
			return (int) ((x*y) - x - y); 
		}
		
		long x;
		long y;
	}
	
	public static class Triangle {
		private Point x,y,z;

		public Triangle(Point x, Point y, Point z) {
			this.x = x;
			this.y = y;
			this.z = z;
		}
		
		@Override
		public boolean equals(Object o) {
			if (o instanceof Triangle) {
				Triangle ot = (Triangle) o;
				return (ot.x.equals(x) || ot.x.equals(y) || ot.x.equals(z)) &&
					   (ot.y.equals(x) || ot.y.equals(y) || ot.y.equals(z)) &&
				       (ot.z.equals(x) || ot.z.equals(y) || ot.z.equals(z));
			}
			else 
				return false;
		}
		
		@Override
		public int hashCode() {
			return x.hashCode() * y.hashCode() * z.hashCode(); 
		}
		
		public String toString() {
			return "(" + x + "," + y + ")";
		}
	}
	
	private HashSet<Triangle> triangles = new HashSet<Triangle>();
	
	private Vector<Point> trees;
	
	public Triangles(int n, long a, long b, long c, long d, long x0, long y0, long m) {
		trees = new Vector<Point>(n);
		long X = x0, Y = y0;
		trees.add(new Point(X, Y));
		for (int i = 1; i <= n-1; i++) {
		  X = (a * X + b) % m;
		  Y = (c * Y + d) % m; 
		  trees.add(new Point(X,Y));
		}
	}

	public int getNum() {
		Point x,y,z;
		for(int i = 0; i < trees.size(); i++) {
			x = trees.get(i);
			for(int j= i + 1; j < trees.size(); j++) {
				if (i == j)
					continue;
				y = trees.get(j);
				for (int k=j+1;k<trees.size(); k++) {
					if ( k == i || j == k)
						continue;
					z = trees.get(k);
					double cx = (x.x + y.x + z.x) / 3.0;
					double cy = (x.y + y.y + z.y) / 3.0;
					if ( (int) cx == cx && (int) cy == cy) {
						Triangle t = new Triangle(x, y, z);
						//if (!triangles.contains(t))
							triangles.add(t);
						
					}
				}
			}
		}
//		Vector<Triangle> t =new Vector<Triangle>(triangles.size());
//		for (Triangle tr:triangles)
//			if (!t.contains(tr))
//				t.add(tr);
//		return t.size();
		return triangles.size();
	}
}
