/**
 * 
 */
package trygoogle.trains;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Vector;

/**
 * @author Bognár Gábor
 *
 */
public class TimeTable {

	private static SimpleDateFormat df = new SimpleDateFormat("HH:mm");
	
	private Vector<Calendar> dfroma, dfromb, aata, aatb;
	
	private TimeTable() {
		dfroma = new Vector<Calendar>();
		dfromb = new Vector<Calendar>();
		aata = new Vector<Calendar>();
		aatb = new Vector<Calendar>();
	}
	
	public static TimeTable parseTimes(Vector<String> atob, Vector<String>btoa, int ttime) {
		try {
			TimeTable res = new TimeTable();
			
			for (String s : atob) {
				String t[] = s.split(" ");
				Calendar c = Calendar.getInstance();
				c.setTime(df.parse(t[0]));
				res.dfroma.add(c);
				Calendar cc = Calendar.getInstance();
				cc.setTime(df.parse(t[1]));
				cc.add(Calendar.MINUTE, ttime);
				res.aatb.add(cc);
			}
			
			for (String s : btoa) {
				String t[] = s.split(" ");
				Calendar c = Calendar.getInstance();
				c.setTime(df.parse(t[0]));
				res.dfromb.add(c);
				Calendar cc = Calendar.getInstance();
				cc.setTime(df.parse(t[1]));
				cc.add(Calendar.MINUTE, ttime);
				res.aata.add(cc);
			}
			
			Collections.sort(res.dfroma);
			Collections.sort(res.dfromb);
			Collections.sort(res.aata);
			Collections.sort(res.aatb);
			
			return res;
		} catch (ParseException e) {
			e.printStackTrace();
			return null;
		}
		
	}
	
	public String getNums() {
		int a = 0, b = 0;
		for (Calendar c : dfroma)
			if (aata.isEmpty() || c.before(aata.get(0)))
				a++;
			else
				aata.remove(0);
		for (Calendar c : dfromb)
			if (aatb.isEmpty() || c.before(aatb.get(0)))
				b++;
			else
				aatb.remove(0);
		return a + " " + b;
	}
	
}
