package com.codejam.dsoen.FairAndSquare;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;

public class SmallInput {

	private static BufferedReader reader;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if(args.length > 0) {
			String filename = args[0];
			FileInputStream fis;
			try {
				fis = new FileInputStream(filename);
				reader = new BufferedReader(new InputStreamReader(fis));
			} catch (FileNotFoundException e) {
				reader = new BufferedReader(new InputStreamReader(System.in));
				e.printStackTrace();
			}
		}
		else {
			reader = new BufferedReader(new InputStreamReader(System.in));
		}
		
		int numCases;
		TestCase[] testCases;
		
		numCases = getNumberOfTestCases();
		
		testCases = new TestCase[numCases];
		for(int i = 0; i < numCases; i++) {
			String testCase = getTestCase();
			testCases[i] = new TestCase(testCase);
			System.out.println("Case #" + (i + 1) + ": " + testCases[i].getFairAndSquare());
		}
				
		try {
			reader.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private static class TestCase
	{
		public long[] testItem;
		
		public TestCase(String testCase) {
			String[] splittedTestCase = testCase.split(" ");
			testItem = new long[splittedTestCase.length];
			
			for(int i = 0; i < testItem.length; i++) {
				testItem[i] = Long.parseLong(splittedTestCase[i]);
			}
		}
		
		public int getFairAndSquare() {
			int nFairAndSquare = 0;
			
			long lowerBorder = testItem[0];
			long upperBorder = testItem[1];
			
			for(long item = lowerBorder; item <= upperBorder; item++) {
				if(!isPalindrome(item))
					continue;
				
				if(squareOf(item) < 0)
					continue;
				
				if(isPalindrome(squareOf(item)))
					nFairAndSquare++;
			}
			
			return nFairAndSquare;
		}
	}
	
	private static int getNumberOfTestCases() {
		int retval = -1;
        try {
			String input = reader.readLine();
	        retval = Integer.parseInt(input);

		} catch (IOException e) {
			e.printStackTrace();
		}
        
        return retval;
	}
	
	private static String getTestCase() {
		String retval = "";
        try {
			String input = reader.readLine();
	        retval = input;

		} catch (IOException e) {
			e.printStackTrace();
		}
        
        return retval;
	}
	
	private static long squareOf(long n) {
		if (n < 0)
			return -1;

		switch((int)(n & 0x3F)) {
			case 0x00: case 0x01: case 0x04: case 0x09: case 0x10: case 0x11:
			case 0x19: case 0x21: case 0x24: case 0x29: case 0x31: case 0x39:
				long sqrt;
		    
				if(n < 410881L)
				{
					int i;
					float x2, y;

					x2 = n * 0.5F;
					y  = n;
					i  = Float.floatToRawIntBits(y);
					i  = 0x5f3759df - ( i >> 1 );
					y  = Float.intBitsToFloat(i);
					y  = y * ( 1.5F - ( x2 * y * y ) );

					sqrt = (long)(1.0F/y);
				}
				else
				{
					sqrt = (long)Math.sqrt(n);
				}
				
				if(sqrt*sqrt == n)
					return sqrt;
				else
					return -1;
		  default:
			  return -1;
		}
	}
	
	private static boolean isPalindrome(long n) {
		long num = n;
		long rev = 0;
		long dig;
		while (num > 0)
		{
		      dig = num % 10;
		      rev = rev * 10 + dig;
		      num = num / 10;
		}
		return rev == n;
	}
}
