package com.codejam.dsoen.TicTacToeTomek;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;

public class SmallInput {

	private static BufferedReader reader;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if(args.length > 0) {
			String filename = args[0];
			FileInputStream fis;
			try {
				fis = new FileInputStream(filename);
				reader = new BufferedReader(new InputStreamReader(fis));
			} catch (FileNotFoundException e) {
				reader = new BufferedReader(new InputStreamReader(System.in));
				e.printStackTrace();
			}
		}
		else {
			reader = new BufferedReader(new InputStreamReader(System.in));
		}
		
		int numCases;
		TestCase[] testCases;
		
		numCases = getNumberOfTestCases();
		
		testCases = new TestCase[numCases];
		for(int i = 0; i < numCases; i++) {
			String testCase = getTestCase();
			testCases[i] = new TestCase(testCase);
			System.out.println("Case #" + (i + 1) + ": " + testCases[i].getResultString());
		}
				
		try {
			reader.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private static class TestCase
	{
		public char[] testItem;
		
		private String[] result = {
			"X won",
			"O won",
			"Draw",
			"Game has not completed"
		};
		
		public TestCase(String testCase) {
			testItem = new char[16];
			
			testItem = testCase.toCharArray();
		}
		
		public int getResult() {
			int result = 2;
			
			for(int x = 0; x < 4; x++) {
				result = getResultCol(x);
				if(result < 2) {
					break;
				}
			}
			
			if(result >= 2) {
				for(int y = 0; y < 4; y++) {
					result = getResultRow(y);
					if(result < 2) {
						break;
					}
				}
			}
			
			if(result >= 2) {
				result = getResultLeftDiagonal();
			}
			
			if(result >= 2) {
				result = getResultRightDiagonal();
			}
			
			if(result >= 2) {
				for(char item : testItem) {
					if(item == '.') {
						result = 3;
						break;
					}
					else {
						result = 2;
					}
				}
			}
			
			return result;
		}
		
		private int getResultCol(int x) {
			int result = 2;
			boolean isResulting = true;
			
			// Try X
			for(int i = 0; i < 4 && isResulting; i++) {
				isResulting = testItem[x+i*4] == 'X' || testItem[x+i*4] == 'T'
						|| testItem[x+i*4] == '.';
				if(testItem[x+i*4] == '.')
					result = 3;
			}
			if(isResulting && result != 3) {
				return 0;
			}
			else if(isResulting)
				return 3;
			else
				result = 2;

			isResulting = true;
			// Try O
			for(int i = 0; i < 4 && isResulting; i++) {
				isResulting = testItem[x+i*4] == 'O' || testItem[x+i*4] == 'T'
						|| testItem[x+i*4] == '.';
				if(testItem[x+i*4] == '.')
					result = 3;
			}
			if(isResulting && result != 3) {
				return 1;
			}
			else if(isResulting)
				return 3;
			else
				result = 2;
			
			return 2;
		}
		
		private int getResultRow(int y) {
			int result = 2;
			boolean isResulting = true;
			
			// Try X
			for(int i = 0; i < 4 && isResulting; i++) {
				isResulting = testItem[y*4+i] == 'X' || testItem[y*4+i] == 'T'
						|| testItem[y*4+i] == '.';
				if(testItem[y*4+i] == '.')
					result = 3;
			}
			if(isResulting && result != 3) {
				return 0;
			}
			else if(isResulting)
				return 3;
			else
				result = 2;

			isResulting = true;
			// Try O
			for(int i = 0; i < 4 && isResulting; i++) {
				isResulting = testItem[y*4+i] == 'O' || testItem[y*4+i] == 'T'
						|| testItem[y*4+i] == '.';
				if(testItem[y*4+i] == '.')
					result = 3;
			}
			if(isResulting && result != 3) {
				return 1;
			}
			else if(isResulting)
				return 3;
			else
				result = 2;
			
			return 2;
		}
		
		private int getResultLeftDiagonal() {
			int result = 2;
			boolean isResulting = true;
			
			// Try X
			for(int i = 0; i < 4 && isResulting; i++) {
				isResulting = testItem[i*4+i] == 'X' || testItem[i*4+i] == 'T' 
						|| testItem[i*4+i] == '.';
				if(testItem[i*4+i] == '.')
					result = 3;
			}
			if(isResulting && result != 3) {
				return 0;
			}
			else if(isResulting)
				return 3;
			else
				result = 2;

			isResulting = true;
			// Try O
			for(int i = 0; i < 4 && isResulting; i++) {
				isResulting = testItem[i*4+i] == 'O' || testItem[i*4+i] == 'T' 
						|| testItem[i*4+i] == '.';
				if(testItem[i*4+i] == '.')
					result = 3;
			}
			if(isResulting && result != 3) {
				return 1;
			}
			else if(isResulting)
				return 3;
			else
				result = 2;
			
			return 2;
		}

		private int getResultRightDiagonal() {
			int result = 2;
			boolean isResulting = true;
			
			// Try X
			for(int i = 0; i < 4 && isResulting; i++) {
				isResulting = testItem[i*4+3-i] == 'X' || testItem[i*4+3-i] == 'T'
						|| testItem[i*4+3-i] == '.';
				if(testItem[i*4+3-i] == '.')
					result = 3;
			}
			if(isResulting && result != 3) {
				return 0;
			}
			else if(isResulting)
				return 3;
			else
				result = 2;

			isResulting = true;
			// Try O
			for(int i = 0; i < 4 && isResulting; i++) {
				isResulting = testItem[i*4+3-i] == 'O' || testItem[i*4+3-i] == 'T'
						|| testItem[i*4+3-i] == '.';
				if(testItem[i*4+3-i] == '.')
					result = 3;
			}
			if(isResulting && result != 3) {
				return 1;
			}
			else if(isResulting)
				return 3;
			else
				result = 2;
			
			return 2;
		}
		
		public String getResultString() {
			return result[getResult()];
		}
	}
	
	private static int getNumberOfTestCases() {
		int retval = -1;
        try {
			String input = reader.readLine();
	        retval = Integer.parseInt(input);

		} catch (IOException e) {
			e.printStackTrace();
		}
        
        return retval;
	}
	
	private static String getTestCase() {
		String retval = "";
        try {
			String input = reader.readLine();
	        retval += input;
			input = reader.readLine();
	        retval += input;
			input = reader.readLine();
	        retval += input;
			input = reader.readLine();
	        retval += input;
			input = reader.readLine();
		} catch (IOException e) {
			e.printStackTrace();
		}
        
        return retval;
	}
}
