package ru.orangesoftware.tidy;

import java.io.*;
import java.util.BitSet;
import java.util.Scanner;

public class Tidy {

    private static final StringBuilder sb = new StringBuilder();

    public static void main(String[] args) throws IOException {
        String inFileName = args[0];
        solve(inFileName);
        writeResult(inFileName);
    }

    private static void solve(String inFileName) throws FileNotFoundException {
        try (Scanner in = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(inFileName))))) {
            int t = in.nextInt();
            for (int i = 1; i <= t; ++i) {
                long n = in.nextLong();
                long r = lastTidy(n);
                System.out.println("Case #" + i + ": " + n + " -> " + r);
                sb.append("Case #").append(i).append(": ").append(r).append("\n");
            }
        }
    }

    private static long lastTidy(long n) {
        if (n < 10) return n;
        for (long i = n; i >= 0; i--) {
            if (isTidy(i)) return i;
        }
        return 0;
    }

    private static boolean isTidy(long num) {
        long lastDigit = -1;
        while (num > 0) {
            long digit = num % 10;
            if (lastDigit != -1) {
                if (lastDigit < digit) return false;
            }
            lastDigit = digit;
            num = num / 10;
        }
        return true;
    }

    private static void writeResult(String inFileName) throws IOException {
        try (BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(new File(inFileName + ".out")))) {
            out.write(sb.toString().getBytes());
            out.flush();
        }
    }

}
