package ru.orangesoftware.pancakes;

import java.io.*;
import java.util.*;

public class PancakesLarge {

    private static final StringBuilder sb = new StringBuilder();

    public static void main(String[] args) throws IOException {
        String inFileName = args[0];
        solve(inFileName);
        writeResult(inFileName);
    }

    private static void solve(String inFileName) throws FileNotFoundException {
        try (Scanner in = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(inFileName))))) {
            int t = in.nextInt();
            in.nextLine();
            for (int i = 1; i <= t; ++i) {
                String[] split = in.nextLine().split(" ");
                String s = split[0].trim();
                int k = Integer.valueOf(split[1]);
                int r = flipPancakes(s, k);
                System.out.println("Case #" + i + ": " + s + ", " + k + " -> " + r);
                if (r == -1) {
                    sb.append("Case #").append(i).append(": IMPOSSIBLE\n");
                } else {
                    sb.append("Case #").append(i).append(": ").append(r).append("\n");
                }
            }
        }
    }


    private static int flipPancakes(String s, int k) {
        char[] a = s.toCharArray();
        int flips = 0;
        for (int i = 0; i < s.length() - k + 1; i++) {
            if (a[i] == '-') {
                flipAt(a, i, k);
                ++flips;
            }
        }
        return allHappy(a) ? flips : -1;
    }

    private static void flipAt(char[] a, int pos, int k) {
        for (int i = pos; i < pos + k; i++) {
            if (a[i] == '+') a[i] = '-';
            else a[i] = '+';
        }
    }

    private static boolean allHappy(char[] a) {
        for (char c : a) {
            if (c != '+') return false;
        }
        return true;
    }

    private static void writeResult(String inFileName) throws IOException {
        try (BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(new File(inFileName + ".out")))) {
            out.write(sb.toString().getBytes());
            out.flush();
        }
    }

}
