package ru.orangesoftware.cruise;

import java.io.*;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class Control {

    private static final StringBuilder sb = new StringBuilder();

    public static void main(String[] args) throws IOException {
        String inFileName = args[0];
        solve(inFileName);
        writeResult(inFileName);
    }

    private static void solve(String inFileName) throws FileNotFoundException {
        try (Scanner in = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(inFileName))))) {
            int t = in.nextInt();
            for (int i = 1; i <= t; ++i) {
                long d = in.nextInt();
                int n = in.nextInt();
                Horse[] horses = new Horse[n];
                for (int j = 0; j < n; j++) {
                    horses[j] = new Horse(in.nextLong(), in.nextLong());
                }
                double r = race(d, horses);
                System.out.println("Case #" + i + ": " + n + " -> " + r);
                sb.append("Case #").append(i).append(": ").append(r).append("\n");
            }
        }
    }

    private static double race(long d, Horse[] horses) {
        Arrays.sort(horses, Comparator.comparingLong(o -> o.pos));
        System.out.println(Arrays.toString(horses));
        double minSpeed = Double.MAX_VALUE;
        for (Horse h : horses) {
            long dd = d - h.pos;
            double t = 1.0 * dd / h.speed;
            minSpeed = Math.min(minSpeed, d / t);
        }
        return minSpeed;
    }

    private static void writeResult(String inFileName) throws IOException {
        try (BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(new File(inFileName + ".out")))) {
            out.write(sb.toString().getBytes());
            out.flush();
        }
    }

    private static class Horse {
        long pos;
        long speed;

        Horse(long pos, long speed) {
            this.pos = pos;
            this.speed = speed;
        }

        @Override
        public String toString() {
            return "Horse{" +
                    "pos=" + pos +
                    ", speed=" + speed +
                    '}';
        }
    }

}
