import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class QualifierRound
{
    public static void main(String[] args) throws NumberFormatException, IOException
    {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        int testCases = Integer.parseInt(br.readLine());
        List<TestCase> testCasesList = new ArrayList<>(testCases);
        for (int i = 0; i < testCases; i++)
        {
            String firstAns = br.readLine();
            List<String> firstMatrix = new ArrayList<>();
            for (int j = 0; j < 4; j++)
            {
                firstMatrix.add(br.readLine());
            }
            String secondAns = br.readLine();
            List<String> secondMatrix = new ArrayList<>();
            for (int j = 0; j < 4; j++)
            {
                secondMatrix.add(br.readLine());
            }
            TestCase testCase = new TestCase();
            testCase.setFirstAns(firstAns);
            testCase.setFirstMatrix(firstMatrix);
            testCase.setSecondAns(secondAns);
            testCase.setSecondMatrix(secondMatrix);
            testCasesList.add(testCase);
        }
        int testCaseCount = 1;
        for (TestCase testCase : testCasesList)
        {
            String firstAnsRow = testCase.getFirstMatrix().get(Integer.valueOf(testCase.getFirstAns()) - 1);
            String secondAnsRow = testCase.getSecondMatrix().get(Integer.valueOf(testCase.getSecondAns()) - 1);
            List<String> firstAsList = Arrays.asList(firstAnsRow.split(" "));
            List<String> secondAsList = Arrays.asList(secondAnsRow.split(" "));
            int foundCount = 0;
            String possibleAns = null;
            for (String first : firstAsList)
            {
                if (secondAsList.contains(first))
                {
                    possibleAns = first;
                    foundCount++;
                }
            }
            if (foundCount > 1)
            {
                System.out.println("Case #" + testCaseCount + ": Bad magician!");
            }
            else if (foundCount == 1)
            {
                System.out.println("Case #" + testCaseCount + ": " + possibleAns);
            }
            else if (foundCount == 0)
            {
                System.out.println("Case #" + testCaseCount + ": Volunteer cheated!");
            }
            testCaseCount++;
        }
    }

    public static class TestCase
    {
        private String firstAns = null;
        private String secondAns = null;
        private List<String> firstMatrix = null;
        private List<String> secondMatrix = null;

        public String getFirstAns()
        {
            return firstAns;
        }

        public void setFirstAns(String firstAns)
        {
            this.firstAns = firstAns;
        }

        public String getSecondAns()
        {
            return secondAns;
        }

        public void setSecondAns(String secondAns)
        {
            this.secondAns = secondAns;
        }

        public List<String> getFirstMatrix()
        {
            return firstMatrix;
        }

        public void setFirstMatrix(List<String> firstMatrix)
        {
            this.firstMatrix = firstMatrix;
        }

        public List<String> getSecondMatrix()
        {
            return secondMatrix;
        }

        public void setSecondMatrix(List<String> secondMatrix)
        {
            this.secondMatrix = secondMatrix;
        }
    }
}
