import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class DeceitfulWar
{
    public static void main(String[] args) throws NumberFormatException, IOException
    {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        int testCases = Integer.parseInt(br.readLine());
        List<TestCase> testCasesList = new ArrayList<>(testCases);
        for (int i = 0; i < testCases; i++)
        {
            br.readLine();
            String naomi = br.readLine();
            String ken = br.readLine();
            String[] naomiSplit = naomi.split(" ");
            String[] kenSplit = ken.split(" ");
            TestCase case1 = new TestCase();
            List<Double> naomiList = new ArrayList<>();
            List<Double> kenList = new ArrayList<>();
            for (int j = 0; j < naomiSplit.length; j++)
            {
                naomiList.add(Double.valueOf(naomiSplit[j]));
                kenList.add(Double.valueOf(kenSplit[j]));
            }
            case1.setKen(kenList);
            case1.setNaomi(naomiList);
            testCasesList.add(case1);
        }
        int testCaseCounter = 1;
        for (TestCase case1 : testCasesList)
        {
            solve(case1.getNaomi(), case1.getKen(), testCaseCounter);
            testCaseCounter++;
        }
    }

    public static void solve(List<Double> naomi, List<Double> ken, int testCaseCounter)
    {
        Collections.sort(naomi);
        Collections.sort(ken);
        List<Double> naomiCopy = new ArrayList<>(naomi);
        List<Double> kenCopy = new ArrayList<>(ken);
        int score = 0;
        int highestNum = 1;
        while (!isGreater(naomiCopy, kenCopy))
        {
            WarTactic naomiTactic = getTactic(naomiCopy, highestNum);
            WarTactic kenTactic = getTactic(kenCopy, 1);
            if (naomiTactic.getMyHighest() < kenTactic.getMyHighest())
            {
                naomiCopy.remove(naomiTactic.getMyLowest());
                Double kensClosestMax = getClosetMax(kenCopy, naomiTactic.getMyHighest());
                kenCopy.remove(kensClosestMax);
                score++;
                highestNum = 1;
            }
            else
            {
                highestNum++;
            }
        }
        System.out.print("Case #" + testCaseCounter + ": " + (naomi.size() - score)+" ");
        score = 0;
        naomiCopy = new ArrayList<>(naomi);
        kenCopy = new ArrayList<>(ken);
        while (!isGreater(kenCopy, naomiCopy))
        {
            WarTactic kenTactic = getTactic(kenCopy, highestNum);
            WarTactic naomiTactic = getTactic(naomiCopy, 1);
            if (kenTactic.getMyHighest() < naomiTactic.getMyHighest())
            {
                kenCopy.remove(kenTactic.getMyLowest());
                Double naomiClosestMax = getClosetMax(naomiCopy, kenTactic.getMyHighest());
                naomiCopy.remove(naomiClosestMax);
                score++;
                highestNum = 1;
            }
            else
            {
                highestNum++;
            }
        }
        System.out.print(score + "\n");
    }

    public static boolean isGreater(List<Double> naomi, List<Double> ken)
    {
        boolean flag = true;
        for (int i = 0; i < naomi.size(); i++)
        {
            if (!(naomi.get(i) > ken.get(i)))
            {
                flag = false;
                break;
            }
        }
        return flag;
    }

    public static WarTactic getTactic(List<Double> list, int highestNum)
    {
        WarTactic tactic = new WarTactic();
        tactic.setMyHighest(list.get(list.size() - highestNum));
        tactic.setMyLowest(list.get(0));
        return tactic;
    }

    public static Double getClosetMax(List<Double> list, Double num)
    {
        for (Double d : list)
        {
            if (d > num)
            {
                return d;
            }
        }
        return 0d;
    }

    static class WarTactic
    {
        private Double myLowest = 0d;
        private Double myHighest = 0d;

        public Double getMyHighest()
        {
            return myHighest;
        }

        public Double getMyLowest()
        {
            return myLowest;
        }

        public void setMyHighest(Double myHighest)
        {
            this.myHighest = myHighest;
        }

        public void setMyLowest(Double myLowest)
        {
            this.myLowest = myLowest;
        }
    }

    static class TestCase
    {
        private List<Double> naomi = null;
        private List<Double> ken = null;

        public List<Double> getKen()
        {
            return ken;
        }

        public List<Double> getNaomi()
        {
            return naomi;
        }

        public void setKen(List<Double> ken)
        {
            this.ken = ken;
        }

        public void setNaomi(List<Double> naomi)
        {
            this.naomi = naomi;
        }
    }
}
