import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Dijkstra1
{
	private static Map<String, String>	map	= new HashMap<String, String>();
	static
	{
		map.put("1,1", "1");
		map.put("1,i", "i");
		map.put("1,j", "j");
		map.put("1,k", "k");
		
		map.put("i,1", "i");
		map.put("i,i", "-1");
		map.put("i,j", "k");
		map.put("i,k", "-j");
		
		map.put("j,1", "j");
		map.put("j,i", "-k");
		map.put("j,j", "-1");
		map.put("j,k", "i");
		
		map.put("k,1", "k");
		map.put("k,i", "j");
		map.put("k,j", "-i");
		map.put("k,k", "-1");
	}
	
	public static void main(String[] args) throws NumberFormatException, IOException
	{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int cases = Integer.parseInt(br.readLine());
		List<String> testCases = new ArrayList<>();
		for (int i = 0; i < cases; i++)
		{
			testCases.add(br.readLine() + "," + br.readLine());
		}
		int i = 1;
		for (String solveCase : testCases)
		{
			String solve = solve(solveCase);
			System.out.println("Case #" + (i++) + ": " + solve);
		}
	}
	
	private static int find(String solveCase, String findWhat, int startFrom)
	{
		String[] split = solveCase.split(",");
		int repeat = Integer.parseInt(split[0].split(" ")[1]);
		String wholeString = "";
		for (int i = 0; i < repeat; i++)
		{
			wholeString += split[1];
		}
		char[] charArray = wholeString.toCharArray();
		String left = null;
		String right = null;
		String result = null;
		for (int i = startFrom; i < charArray.length - 1; i++)
		{
			if (result == null)
			{
				left = charArray[i] + "";
			}
			else
				left = result;
			if (left.equals(findWhat))
			{
				return i;
			}
			right = charArray[i + 1] + "";
			result = getMul(left, right);
			if (result.equals(findWhat))
			{
				return i;
			}
		}
		return -1;
	}
	
	private static String solve(String solveCase)
	{
		String[] split = solveCase.split(",");
		int repeat = Integer.parseInt(split[0].split(" ")[1]);
		String wholeString = "";
		for (int i = 0; i < repeat; i++)
		{
			wholeString += split[1];
		}
		if ("ijk".equals(wholeString))
		{
			return "YES";
		}
		int find = find(solveCase, "i", 0);
		if (find != -1)
		{
			int find2 = find(solveCase, "j", find + 1);
			if (find2 != -1)
			{
				int find3 = find(solveCase, "k", find2 + 1);
				// if (find3 != -1 && find3 == wholeString.length() - 1)
				if (find3 != -1)
				{
					return "YES";
				}
			}
		}
		return "NO";
	}
	
	private static String getMul(String left, String right)
	{
		int negCount = 0;
		if (left.startsWith("-"))
		{
			negCount++;
			left = left.substring(1, 2);
		}
		if (right.startsWith("-"))
		{
			negCount++;
			right = right.substring(1, 2);
		}
		
		String key = left + "," + right;
		String string = map.get(key);
		if (string.startsWith("-"))
		{
			negCount++;
			string = string.substring(1, 2);
		}
		if (negCount % 2 == 1)
		{
			string = "-" + string;
		}
		return string;
	}
}
