import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class MineSweeper
{
    private static String[][] sol = null;
    private static Set<String> exploredSet = new HashSet<>();

    public static void main(String[] args) throws NumberFormatException, IOException
    {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        int testCases = Integer.parseInt(br.readLine());
        List<TestCase> testCasesList = new ArrayList<>(testCases);
        for (int i = 0; i < testCases; i++)
        {
            String caseAsString = br.readLine();
            String[] split = caseAsString.split(" ");
            TestCase case1 = new TestCase();
            case1.setR(Integer.valueOf(split[0]));
            case1.setC(Integer.valueOf(split[1]));
            case1.setMines(Integer.valueOf(split[2]));
            testCasesList.add(case1);
        }
        int caseCounter = 1;
        for (TestCase case1 : testCasesList)
        {
            solve(case1.getR(), case1.getC(), case1.getMines(), caseCounter);
            caseCounter++;
        }
//        solve(4, 7, 3, 1);
//        solve(10, 10, 82, 2);
    }

    public static void solve(int r, int c, int mines, int caseNumber)
    {
        String[][] arr = new String[r][c];
        sol = new String[r][c];
        exploredSet.clear();
        for (int i = 0; i < r; i++)
        {
            for (int j = 0; j < c; j++)
            {
                arr[i][j] = "*";
            }
        }
        for (int i = 0; i < r; i++)
        {
            for (int j = 0; j < c; j++)
            {
                arr[i][j] = "c";
                String[][] clone = clone(arr, "", "");
                String[][] revealZeros = revealZeros(clone, i, j);
                // print(revealZeros);
                if (revealMore(mines, revealZeros, false))
                {
                    System.out.println("Case #" + caseNumber + ":");
                    // replace all . by 'A'
                    String[][] solClone = clone(sol, ".", "A");
                    String[][] solCloneB = clone(sol, ".", ".");
                    exploredSet.clear();
                    revealZeros = revealZeros(solClone, i, j);
                    if (revealMore(mines, revealZeros, true))
                    {
                        // check if solCloneB & sol are equal
                        if (equal(solCloneB, sol))
                        {
                            print(sol);
                            return;
                        }
                    }
                }
                arr[i][j] = "*";
            }
        }
        System.out.println("Case #" + caseNumber + ":");
        System.out.println("Impossible");
    }

    public static boolean equal(String[][] arr1, String[][] arr2)
    {
        boolean flag = true;
        for (int i = 0; i < arr1.length; i++)
        {
            for (int j = 0; j < arr2[0].length; j++)
            {
                if (!arr1[i][j].equals(arr2[i][j]))
                {
                    flag = false;
                    break;
                }
            }
        }
        return flag;
    }

    public static String[][] clone(String[][] revealZeros, String replacee, String replacer)
    {
        String[][] s = new String[revealZeros.length][revealZeros[0].length];
        for (int i = 0; i < revealZeros.length; i++)
        {
            for (int j = 0; j < revealZeros[0].length; j++)
            {
                s[i][j] = revealZeros[i][j];
                if (s[i][j].equals(replacee))
                {
                    s[i][j] = replacer;
                }
            }
        }
        return s;
    }

    public static boolean revealMore(int reqMinesCount, String[][] revealZeros, boolean inAction)
    {
        int currentCount = getMinesCount(revealZeros);
        if (reqMinesCount == currentCount && !containsA(revealZeros))
        {
            sol = revealZeros;
            return true;
        }
        else if (reqMinesCount > currentCount)
        {
            return false;
        }
        else
        {
            for (int i = 0; i < revealZeros.length; i++)
            {
                for (int j = 0; j < revealZeros[0].length; j++)
                {
                    if (revealZeros[i][j].equals("c") || !isClickable(revealZeros, i, j, inAction))
                    {
                        continue;
                    }
                    else if (!exploredSet.contains(i + "#" + j))
                    {
                        exploredSet.add(i + "#" + j);
                        revealZeros = revealZeros(revealZeros, i, j);
                        // print(revealZeros);
                        return revealMore(reqMinesCount, revealZeros, inAction);
                    }
                }
            }
        }
        return false;
    }

    private static boolean containsA(String[][] arr)
    {
        boolean flag = false;
        for (int i = 0; i < arr.length; i++)
        {
            for (int j = 0; j < arr[0].length; j++)
            {
                if (arr[i][j].equals("A"))
                {
                    flag = true;
                    break;
                }
            }
        }
        return flag;
    }

    public static int getMinesCount(String[][] arr)
    {
        int count = 0;
        for (int i = 0; i < arr.length; i++)
        {
            for (int j = 0; j < arr[0].length; j++)
            {
                if (arr[i][j].equals("*"))
                {
                    count++;
                }
            }
        }
        return count;
    }

    public static String[][] revealZeros(String[][] arr, int clickedRow, int clickedCol)
    {
        if (!arr[clickedRow][clickedCol].equals("c"))
        {
            arr[clickedRow][clickedCol] = ".";
        }
        if (clickedRow - 1 >= 0)
        {
            if (!arr[clickedRow - 1][clickedCol].equals("c"))
            {
                // #1
                arr[clickedRow - 1][clickedCol] = ".";
            }
            if (clickedCol - 1 >= 0)
            {
                if (!arr[clickedRow - 1][clickedCol - 1].equals("c"))
                {
                    // #2
                    arr[clickedRow - 1][clickedCol - 1] = ".";
                }
            }
            if (clickedCol + 1 < arr[0].length)
            {
                if (!arr[clickedRow - 1][clickedCol + 1].equals("c"))
                {
                    // #3
                    arr[clickedRow - 1][clickedCol + 1] = ".";
                }
            }
        }
        if (clickedRow + 1 < arr.length)
        {
            if (!arr[clickedRow + 1][clickedCol].equals("c"))
            {
                // #4
                arr[clickedRow + 1][clickedCol] = ".";
            }
            if (clickedCol - 1 >= 0)
            {
                if (!arr[clickedRow + 1][clickedCol - 1].equals("c"))
                {
                    // #5
                    arr[clickedRow + 1][clickedCol - 1] = ".";
                }
            }
            if (clickedCol + 1 < arr[0].length)
            {
                if (!arr[clickedRow + 1][clickedCol + 1].equals("c"))
                {
                    // #6
                    arr[clickedRow + 1][clickedCol + 1] = ".";
                }
            }
        }
        if (clickedCol - 1 >= 0)
        {
            // #7
            if (!arr[clickedRow][clickedCol - 1].equals("c"))
            {
                arr[clickedRow][clickedCol - 1] = ".";
            }
        }
        if (clickedCol + 1 < arr[0].length)
        {
            if (!arr[clickedRow][clickedCol + 1].equals("c"))
            {
                // #8
                arr[clickedRow][clickedCol + 1] = ".";
            }
        }
        return arr;
    }

    private static boolean isClickable(String[][] arr, int clickedRow, int clickedCol, boolean inAction)
    {
        if (!inAction)
        {
            return true;
        }
        if (clickedRow - 1 >= 0)
        {
            if (arr[clickedRow - 1][clickedCol].equals("*"))
            {
                // #1
                return false;
            }
            if (clickedCol - 1 >= 0)
            {
                if (arr[clickedRow - 1][clickedCol - 1].equals("*"))
                {
                    // #2
                    return false;
                }
            }
            if (clickedCol + 1 < arr[0].length)
            {
                if (arr[clickedRow - 1][clickedCol + 1].equals("*"))
                {
                    // #3
                    return false;
                }
            }
        }
        if (clickedRow + 1 < arr.length)
        {
            if (arr[clickedRow + 1][clickedCol].equals("*"))
            {
                // #4
                return false;
            }
            if (clickedCol - 1 >= 0)
            {
                if (arr[clickedRow + 1][clickedCol - 1].equals("*"))
                {
                    // #5
                    return false;
                }
            }
            if (clickedCol + 1 < arr[0].length)
            {
                if (arr[clickedRow + 1][clickedCol + 1].equals("*"))
                {
                    // #6
                    return false;
                }
            }
        }
        if (clickedCol - 1 >= 0)
        {
            // #7
            if (arr[clickedRow][clickedCol - 1].equals("*"))
            {
                return false;
            }
        }
        if (clickedCol + 1 < arr[0].length)
        {
            if (arr[clickedRow][clickedCol + 1].equals("*"))
            {
                // #8
                return false;
            }
        }
        return true;
    }

    public static void print(String[][] sol2)
    {
        // print solution and exit..
        for (int k = 0; k < sol2.length; k++)
        {
            for (int l = 0; l < sol2[0].length; l++)
            {
                System.out.print(sol2[k][l]);
            }
            System.out.println();
        }
    }

    public static class TestCase
    {
        private int r, c, mines = 0;

        public int getR()
        {
            return r;
        }

        public void setR(int r)
        {
            this.r = r;
        }

        public int getC()
        {
            return c;
        }

        public void setC(int c)
        {
            this.c = c;
        }

        public int getMines()
        {
            return mines;
        }

        public void setMines(int mines)
        {
            this.mines = mines;
        }

    }
}
