import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class CookieGame
{
    public static void main(String[] args) throws NumberFormatException, IOException
    {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        int testCases = Integer.parseInt(br.readLine());
        List<TestCase> testCasesList = new ArrayList<>(testCases);
        for (int i = 0; i < testCases; i++)
        {
            String testCase = br.readLine();
            String[] split = testCase.split(" ");
            TestCase case1 = new TestCase();
            case1.setC(Double.valueOf(split[0]));
            case1.setF(Double.valueOf(split[1]));
            case1.setX(Double.valueOf(split[2]));
            testCasesList.add(case1);
        }
        int caseNumber = 1;
        for (TestCase t : testCasesList)
        {
            solve(t, caseNumber);
            caseNumber++;
        }
    }

    public static void solve(TestCase t, int caseNumber)
    {
        double C = t.getC(), F = t.getF(), X = t.getX();
        double productionRate = 2;
        double currentSolTime = X / productionRate;
        double timeSpentToGetFarm = 0;
        while (true)
        {
            // Add 1 more farm and check time
            timeSpentToGetFarm += C / productionRate;
            // increased prod after farm purchased
            productionRate += F;
            double newReqTime = (X / productionRate) + timeSpentToGetFarm;
            if (currentSolTime > newReqTime)
            {
                currentSolTime = newReqTime;
            }
            else
            {
                String s = "Case #" + caseNumber + ": ";
                System.out.println(s + currentSolTime);
                // DecimalFormat f = new DecimalFormat("#####.0000000");
                // System.out.println(s+f.format(currentSolTime));
                break;
            }
        }
    }

    public static class TestCase
    {
        double C, F, X = 0;

        public double getC()
        {
            return C;
        }

        public double getF()
        {
            return F;
        }

        public double getX()
        {
            return X;
        }

        public void setC(double c)
        {
            C = c;
        }

        public void setF(double f)
        {
            F = f;
        }

        public void setX(double x)
        {
            X = x;
        }

    }
}
