import java.util.Scanner;

public class FairAndSquare {
	public static void main(String[] args) {
		Scanner scan = new Scanner(System.in);
		int numTrials = scan.nextInt();
		for (int trial = 0; trial < numTrials; trial++) {
			long a = scan.nextLong();
			long b = scan.nextLong();
			double sqrta = Math.sqrt(a);
			long aceil = (long) Math.ceil(sqrta);
			assert aceil * aceil >= a && (aceil - 1) * (aceil - 1) < a;
			double sqrtb = Math.sqrt(b);
			long bfloor = (long) Math.floor(sqrtb);
			assert bfloor * bfloor <= b && (bfloor + 1) * (bfloor + 1) > b;
			int count = 0;
			for (long i = aceil; i <= bfloor; i++) {
				if (isPalindrome(i) && isPalindrome(i * i)) {
					count++;
				}
			}
			System.out.println("Case #" + (trial + 1) + ": " + count);
		}
	}

	static int[] digits = new int[16];

	private static boolean isPalindrome(long l) {
		int digCount = 0;
		while (l > 0) {
			digits[digCount++] = (int) (l % 10);
			l /= 10;
		}
		for (int i = 0; i < digCount / 2; i++) {
			if (digits[i] != digits[digCount - 1 - i])
				return false;
		}
		return true;
	}
}
