import java.util.HashMap;
import java.util.Scanner;

public class D {
	private static final HashMap<Integer, Double> probs = new HashMap<Integer, Double>();
	private static int numGondolas;

	public static void main(String[] args) {
		Scanner scan = new Scanner(System.in);
		int numCases = scan.nextInt();
		for (int caseNum = 1; caseNum <= numCases; caseNum++) {
			System.out.println("Case #" + caseNum + ": " + solveProblem(scan));
		}
	}

	private static double solveProblem(Scanner scan) {
		int startArrange = 0;
		char[] cs = scan.next().toCharArray();
		numGondolas = cs.length;
		probs.clear();
		for (int i = numGondolas - 1; i >= 0; i--) {
			char c = cs[i];
			startArrange <<= 1;
			if (c == 'X')
				startArrange |= 1;
		}
		return earnings(startArrange);
	}

	private static double earnings(int arrangement) {
		if (arrangement == (1 << numGondolas) - 1)
			return 0;
		Double res = probs.get(arrangement);
		if (res == null) {
			res = 0D;
			for (int i = 0; i < numGondolas; i++) {
				int j = i;
				int cost = numGondolas;
				while ((arrangement & (1 << j)) != 0) {
					j = (j + 1) % numGondolas;
					cost--;
				}
				res += earnings(arrangement | (1 << j)) + cost;
			}
			res /= numGondolas;
			probs.put(arrangement, res);
		}
		return res;
	}
}
