import java.util.Scanner;

public class B {
	public static void main(String[] args) {
		Scanner scan = new Scanner(System.in);
		int numCases = scan.nextInt();
		for (int caseNum = 1; caseNum <= numCases; caseNum++) {
			System.out.println("Case #" + caseNum + ": " + solveProblem(scan));
		}
	}

	private static String solveProblem(Scanner scan) {
		long n = 1L << scan.nextLong();
		long p = scan.nextLong();
		long must = getMust(n, p);
		long could = getCould(n, p);
		return must + " " + could;
	}

	private static long getMust(long n, long p) {
		long bot = 0;
		long top = n;
		while (top - bot > 1) {
			long guess = (top + bot) / 2;
			if (worstStanding(n, guess) < p) {
				bot = guess;
			} else
				top = guess;
		}
		return bot;
	}

	private static long getCould(long n, long p) {
		long bot = 0;
		long top = n;
		while (top - bot > 1) {
			long guess = (top + bot) / 2;
			if (bestStanding(n, guess) < p) {
				bot = guess;
			} else
				top = guess;
		}
		return bot;
	}

	private static long worstStanding(long n, long t) {
		return n - 1 - bestStanding(n, n - 1 - t);
	}

	private static long bestStanding(long n, long t) {
		long numAbove = t;
		long numBelow = n - t - 1;
		long res = 0;
		while (numBelow > 0) {
			if (numAbove % 2 == 1) {
				numAbove++;
				numBelow--;
			}
			numAbove /= 2;
			numBelow /= 2;
		}
		while (numAbove > 0) {
			res <<= 1;
			res += 1;
			numAbove >>= 1;
		}
		return res;
	}
}
