package codejam2;

import java.util.Arrays;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;

public class B {
	public static void main(String[] args) {
		Scanner scan = new Scanner(System.in);
		int numCases = scan.nextInt();
		for (int i = 1; i <= numCases; i++) {
			System.out.printf("Case #" + i + ": ");
			System.out.println(run(scan));
		}
	}

	public static long run(Scanner scan) {
		int[] nums = new int[scan.nextInt()];
		for (int i = 0; i < nums.length; i++) {
			nums[i] = scan.nextInt();
		}
		long best = Long.MAX_VALUE;
		for (int split = 0; split <= nums.length; split++) {
			int[] upseq = Arrays.copyOfRange(nums, 0, split);
			int[] downseq = Arrays.copyOfRange(nums, split, nums.length);
			reverse(downseq);
			best = Math.min(best, countswaps(upseq) + countswaps(downseq));
		}
		return best;
	}

	private static void reverse(int[] s) {
		for (int i = 0; i < s.length / 2; i++) {
			int tmp = s[i];
			s[i] = s[s.length - 1 - i];
			s[s.length - 1 - i] = tmp;
		}
	}

	private static long swapcount;

	public static long countswaps(int[] array) {
		swapcount = 0;
		mcsort(array, 0, array.length);
		return swapcount;
	}

	public static Queue<Integer> mcsort(int[] array, int from, int to) {
		if (to - from == 0) {
			return new LinkedList<Integer>();
		} else if (to - from == 1) {
			LinkedList<Integer> res = new LinkedList<Integer>();
			res.add(array[from]);
			return res;
		} else {
			int mid = (from + to) / 2;
			Queue<Integer> lsorted = mcsort(array, from, mid);
			Queue<Integer> rsorted = mcsort(array, mid, to);
			LinkedList<Integer> res = new LinkedList<Integer>();
			while (!lsorted.isEmpty() && !rsorted.isEmpty()) {
				if (rsorted.peek() < lsorted.peek()) {
					res.add(rsorted.poll());
					swapcount += lsorted.size();
				} else {
					res.add(lsorted.poll());
				}
			}
			res.addAll(lsorted);
			res.addAll(rsorted);
			return res;
		}
	}
}
