import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

public class ProbB extends CodeJamProblem {

	class Student implements Comparable<Student> {
		final int rad;
		int x, y;

		public Student(int r) {
			rad = r;
		}

		@Override
		public int compareTo(Student o) {
			return rad - o.rad;
		}

		public void set(int x, int y) {
			this.x = x;
			this.y = y;
		}

		public void flip() {
			int temp = x;
			x = y;
			y = temp;
		}
	}

	@Override
	protected String run(Scanner scan) {
		int n = scan.nextInt();
		int w = scan.nextInt(), l = scan.nextInt();
		boolean flipped = w < l;
		if (flipped) {
			int temp = w;
			w = l;
			l = temp;
		}
		Student[] arr = new Student[n];
		Student[] arr2 = new Student[n];
		for (int i = 0; i < n; i++) {
			arr[i] = new Student(scan.nextInt());
		}
		arr2 = Arrays.copyOf(arr, n);
		Arrays.sort(arr2);
		Student firstStudent = arr2[n - 1];
		arr2[n - 1].set(0, 0);
		int lastX = arr2[n - 1].rad, lastY = 0;
		for (int i = n - 2; i >= 0; i--) {
			if (lastX + arr2[i].rad > w) {
				lastY += firstStudent.rad + arr2[i].rad;
				firstStudent = arr2[i];
				if (lastY > l)
					throw new Error("Not enough space");
				lastX = 0;
			}
			arr2[i].set(lastX + arr2[i].rad, lastY);
			lastX = arr2[i].x + arr2[i].rad;
		}
		if (flipped) {
			for (Student s : arr) {
				s.flip();
			}
		}
		StringBuilder sb = new StringBuilder();
		boolean isFirst = true;
		for (Student s : arr) {
			sb.append((!isFirst ? " " : "") + s.x + " " + s.y);
			isFirst = false;
		}
		return sb.toString();
	}

}
