package codejam2;

import java.util.PriorityQueue;
import java.util.Scanner;
import java.util.TreeMap;
import java.util.TreeSet;

public class A {
	private static final class IntPair implements Comparable<IntPair> {
		public IntPair(int first, int second) {
			this.first = first;
			this.second = second;
		}

		public final int first;
		public final int second;

		@Override
		public int compareTo(IntPair o2) {
			return o2.sum() - sum();
		}

		public final int sum() {
			return first + second;
		}

		public String toString() {
			return "(" + first + "," + second + ")";
		}
	}

	public static void main(String[] args) {
		Scanner scan = new Scanner(System.in);
		int numCases = scan.nextInt();
		for (int i = 1; i <= numCases; i++) {
			System.out.print("Case #" + i + ": ");
			System.out.println(run(scan));
		}
	}

	public static int run(Scanner scan) {
		int n = scan.nextInt();
		int x = scan.nextInt();
		int res = n;
		TreeMap<Integer, Integer> sizes = new TreeMap<Integer, Integer>();
		int[] listSizes = new int[n];
		for (int i = 0; i < n; i++) {
			listSizes[i] = scan.nextInt();
			addCounter(sizes, listSizes[i]);
		}
		PriorityQueue<IntPair> bestPairs = new PriorityQueue<IntPair>();
		for (Integer s : listSizes) {
			addBest(x, sizes, bestPairs, s);
		}
		while (!sizes.isEmpty() && !bestPairs.isEmpty()) {
			IntPair p = bestPairs.poll();
			if (subCounter(sizes, p.first)) {
				if (sizes.containsKey(p.second)) {
					subCounter(sizes, p.second);
					res--;
				} else {
					addCounter(sizes, p.first);
					addBest(x, sizes, bestPairs, p.first);
				}
			} else if (sizes.containsKey(p.second)) {
				addBest(x, sizes, bestPairs, p.second);
			}
		}
		return res;
	}

	private static void addCounter(TreeMap<Integer, Integer> sizes, int nextInt) {
		Integer curVal = sizes.get(nextInt);
		if (curVal == null) {
			curVal = 0;
		}
		sizes.put(nextInt, curVal + 1);
	}

	private static void addBest(int x, TreeMap<Integer, Integer> sizes,
			PriorityQueue<IntPair> bestPairs, Integer s) {
		subCounter(sizes, s);
		Integer other = sizes.floorKey(x - s);
		if (other != null)
			bestPairs.add(new IntPair(s, other));
		addCounter(sizes, s);
	}

	private static boolean subCounter(TreeMap<Integer, Integer> sizes,
			Integer nextInt) {
		Integer curVal = sizes.remove(nextInt);
		if (curVal == null)
			return false;
		curVal--;
		if (curVal > 0)
			sizes.put(nextInt, curVal);
		return true;
	}
}
