package main;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/*
 * Solving problems from www.projecteuler.net
 */
public class EntryPoint {

   public static void main(String[] args) {
      EntryPoint ep = new EntryPoint();
      ep.run();
   }


   private void run() {
      List<String> input = getFileAsListOfStrings("input.txt");
      int cases = Integer.parseInt(input.remove(0));
      int caseNum = 1;

      while (input.size() > 0) {
         String[] row = input.remove(0).split(" ");
         System.out.println("Case #" + caseNum + ": " + process(row[1]));
         caseNum++;
      }
   }

   private int process(String row) {
      char[] charArray = row.toCharArray();
      int[] shyness = new int[charArray.length];
      for (int i = 0; i < charArray.length; ++i) {
         shyness[i] = Integer.parseInt(Character.toString(charArray[i]));
      }
      int totalStanding = shyness[0];
      int friendsNeeded = 0;
      for (int i = 1; i < shyness.length; ++i) {
         int needed = i - totalStanding;
         if (shyness[i] > 0 && needed > 0) {
            friendsNeeded += needed;
            totalStanding += needed;
         }
         totalStanding += shyness[i];
      }
      return friendsNeeded;
   }

   private List<String> getFileAsListOfStrings(String fileName) {
      final String fileBase = "C:\\Users\\drandall\\workspace\\Practice\\src\\files\\";
      List<String> result = new ArrayList<String>();
      BufferedReader in = null;
      try {
         in = new BufferedReader(new FileReader(fileBase + fileName));
         while (in.ready()) {
            result.add(in.readLine());
         }
      } catch (Exception e) {
         System.out.println("Error reading file: " + e);
      } finally {
         if (in != null) {
            try {
               in.close();
            } catch (IOException e) {
            }
         }
      }
      return result;
   }
}
