package main;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/*
 * Solving problems from www.projecteuler.net
 */
public class EntryPoint {

   public static void main(String[] args) {
      EntryPoint ep = new EntryPoint();
      ep.run();
   }


   private void run() {
      List<String> input = getFileAsListOfStrings("input.txt");
      int cases = Integer.parseInt(input.remove(0));
      int caseNum = 1;

      while (input.size() > 0) {
         String[] split = input.remove(0).split(" ");
         System.out.println("Case #" + caseNum + ": " + canFillGrid(split));
         caseNum++;
      }
   }


   private static final String GABE = "GABRIEL"; // places pieces
   private static final String RICK = "RICHARD"; // chooses first piece

   private String canFillGrid(String[] input) {
      int omino = Integer.parseInt(input[0]);
      int row = Integer.parseInt(input[1]);
      int col = Integer.parseInt(input[2]);

      if (row > col) {
         int temp = row;
         row = col;
         col = temp;
      }
      // there's only 1 1-Omino choice, Gabe wins
      if (omino == 1) {
         return GABE;
      }
      // 7 or higher omino, richard wins because of circled blank
      if (omino > 6) {
         return RICK;
      }
      // a grid of RxC can only be filled with X-ominos if R*C % X == 0
      if ((row * col) % omino > 0) {
         return RICK;
      }

      if (omino > col) {
         return RICK;
      }
      if (omino > 2 && row == 1) {
         return RICK;
      }

      if (omino > 3 && row == 2) {
         return RICK;
      }

      if (omino > 5 && row == 3) {
         return RICK;
      }
      return GABE;
   }


   private List<String> getFileAsListOfStrings(String fileName) {
      final String fileBase = "C:\\Users\\drandall\\workspace\\Practice\\src\\files\\";
      List<String> result = new ArrayList<String>();
      BufferedReader in = null;
      try {
         in = new BufferedReader(new FileReader(fileBase + fileName));
         while (in.ready()) {
            result.add(in.readLine());
         }
      } catch (Exception e) {
         System.out.println("Error reading file: " + e);
      } finally {
         if (in != null) {
            try {
               in.close();
            } catch (IOException e) {
            }
         }
      }
      return result;
   }
}
