import java.util.*;

public class Main{
  static final String XWON = "Case #%d: X won\n";
  static final String OWON = "Case #%d: O won\n";
  static final String DRAW = "Case #%d: Draw\n";
  static final String NOTC = "Case #%d: Game has not completed\n";
  static final int PLAYER1 = 0;
  static final int PLAYER2 = 1;
  
  public static void main(String args[]) throws Exception {
    
    Scanner in = new Scanner(System.in);
    String line = in.nextLine();
    int n = Integer.parseInt(line);
    for (int i = 1; i <= n; i++) {
      if (i > 1) in.nextLine();
      int[] board = new int[4];
      boolean isEmpty = false;
      for (int j = 0; j < 4; j++) {
        line = in.nextLine();
        for (int k = 3; k >= 0; k--) {
          char ch = line.charAt(k);
          if (ch == 'X') {
            board[j] += (1 << k*2);
          } else if (ch == 'O') {
            board[j] += (2 << k*2);
          } else if (ch == 'T') {
            board[j] += (3 << k*2);
          } else {
            isEmpty = true;
          }
        }
      }
      
      if (judge(board, PLAYER1)) {
        System.out.printf(XWON, i);
      } else if (judge(board, PLAYER2)) {
        System.out.printf(OWON, i);
      } else if (!isEmpty) {
        System.out.printf(DRAW, i);
      } else {
        System.out.printf(NOTC, i);
      }
    }
  }
  static boolean judge(int[] board, int player) {
    int[][] val = {
      {64, 16, 4, 1},
      {128, 32, 8, 2}
    };
    int[] row = {
      val[0][0] | val[0][1] | val[0][2] | val[0][3],
      val[1][0] | val[1][1] | val[1][2] | val[1][3],
    };
    for (int r = 0; r < 4; r++) {
      if ((board[r] & row[player]) == row[player]) return true;
    }
    for (int c = 0; c < 4; c++) {
      if ((board[0] & val[player][c]) == val[player][c] &&
          (board[1] & val[player][c]) == val[player][c] &&
          (board[2] & val[player][c]) == val[player][c] &&
          (board[3] & val[player][c]) == val[player][c] ) {
        return true;
      }
    }
    if ((board[0] & val[player][0]) == val[player][0] &&
        (board[1] & val[player][1]) == val[player][1] &&
        (board[2] & val[player][2]) == val[player][2] &&
        (board[3] & val[player][3]) == val[player][3] ) {
      return true;
    }
    if ((board[0] & val[player][3]) == val[player][3] &&
        (board[1] & val[player][2]) == val[player][2] &&
        (board[2] & val[player][1]) == val[player][1] &&
        (board[3] & val[player][0]) == val[player][0] ) {
      return true;
    }
    return false;
  }
}
