package dto.google.codejam.y2010.qual;

import java.io.*;
import java.util.*;
import java.math.*;

/**
 * @author dto
 */
public class FairWarning {
   public static void main(String[] args) throws IOException {
      final BufferedReader in = new BufferedReader(new FileReader("B-" + args[0] + ".in"));
      final PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("B-" + args[0] + ".out")));
      final int C = Integer.parseInt(in.readLine());
      for(int X = 1; X <= C; X++) {
         out.println("Case #" + X + ": " + fairWarningCalc(in.readLine()));
      }
      in.close();
      out.close();
   }

   private static String fairWarningCalc(String line) {
      String[] l = line.split(" ");
      final int N = Integer.parseInt(l[0]);
      assert(l.length == N + 1);

      TreeSet<BigInteger> timeSet = new TreeSet<BigInteger>();
      for(int i = 1; i <= N; i++)
         timeSet.add(new BigInteger(l[i]));
      assert(timeSet.size() >= 2);

      BigInteger minTime = timeSet.pollFirst();
      BigInteger gcd = BigInteger.ZERO; // gcd of the (time_i - minTime)'s
      for(BigInteger time : timeSet)
         gcd = gcd.gcd(time.subtract(minTime));

      BigInteger y = gcd.subtract(minTime);
      y = y.mod(gcd); // make sure it's the minimal non-negative one

      return y.toString();
   }
}
