package dto.google.codejam.y2010.round1b;

import java.io.*;
import java.util.*;

/**
 * @author dto
 */
public class FileFixIt {
   public static void main(String[] args) throws IOException {
      final BufferedReader in = new BufferedReader(new FileReader("A-" + args[0] + ".in"));
      final PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("A-" + args[0] + ".out")));
      final int T = Integer.parseInt(in.readLine());
      for(int X = 1; X <= T; X++) {
         String[] line = in.readLine().split(" ");
         assert(line.length == 2);
         int N = Integer.parseInt(line[0]);
         int M = Integer.parseInt(line[1]);

         PathTracker track = new PathTracker();
         PathTracker track2 = new PathTracker();
         for(int j = 1; j <= N; j++) {
            String l = in.readLine();
            track.addPathNoParents(l);
            track2.addPathWithParents(l);
         }
         assert(track.knownPaths.equals(track2.knownPaths));

         int y = 0;
         for(int j = 1; j <= M; j++) {
            y += track.addPathWithParents(in.readLine());
         }
         
         out.println("Case #" + X + ": " + y);
      }
      in.close();
      out.close();
   }

   private static class PathTracker {
      private TreeSet<String> knownPaths = new TreeSet<String>();

      // returns the number of paths added
      public int addPathNoParents(String path) {
         return knownPaths.add(path) ? 1 : 0;
      }

      public int addPathWithParents(String path) {
         final String[] components = path.split("/");
         int pathsAdded = 0;
         String pathSoFar = "";
         // skip components[0], which is empty
         for(int i = 1; i < components.length; i++) {
            pathSoFar += "/" + components[i];
            pathsAdded += addPathNoParents(pathSoFar);
         }
         return pathsAdded;
      }
   }
}
