package dto.google.codejam.y2010.round1b;

import java.io.*;
import java.util.*;

/**
 * @author dto
 */
public class Chicks {
   public static void main(String[] args) throws IOException {
      BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
      System.out.print("Enter input file name: ");
      final String testFile = stdin.readLine();
      final BufferedReader in = new BufferedReader(new FileReader("B-" + testFile + ".in"));
      final PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("B-" + testFile + ".out")));
      final int C = Integer.parseInt(in.readLine());
      for(int cc = 1; cc <= C; cc++) {
         String[] line = in.readLine().split(" ");
         assert(line.length == 4);
         int N = Integer.parseInt(line[0]);
         int K = Integer.parseInt(line[1]);
         int B = Integer.parseInt(line[2]);
         int T = Integer.parseInt(line[3]);

         int[] X = splitParse(in.readLine());
         int[] V = splitParse(in.readLine());

         assert(X.length == N);
         assert(V.length == N);
         
         int calc = chickCalc(N, K, B, T, X, V);
         out.println("Case #" + cc + ": " + ((calc == -1) ? "IMPOSSIBLE" : calc));
      }
      in.close();
      out.close();
   }

   private static int[] splitParse(String s) {
      String[] a = s.split(" ");
      int[] n = new int[a.length];
      for(int i = 0; i < a.length; i++)
         n[i] = Integer.parseInt(a[i]);
      return n;
   }

   private static int chickCalc(int N, int K, int B, int T, int[] X, int[] V) {
      if(K == 0)
         return 0;

      int[] swapCount = new int[N];
      boolean[] makesIt = new boolean[N];
      int numMadeIt = 0;
      int numSwaps = 0;
      for(int i = N - 1; i >= 0; i--) {
         if(B - X[i] > V[i] * T) // too slow
            continue;
         int swaps = 0;
         for(int j = i + 1; j < N; j++) {
            if(makesIt[j]) {
               swaps += swapCount[j];
               break;
            } else {
               swaps++;
            }
         }
         swapCount[i] = swaps;
         makesIt[i] = true;
         numSwaps += swaps;
         numMadeIt++;
         if(numMadeIt == K)
            break;
      }
      return (numMadeIt < K) ? -1 : numSwaps;
   }
}
