package dto.google.codejam.y2010.round2;

import java.io.*;
import java.util.*;

/**
 * @author dto
 */
public class Bacteria {
   private static boolean[][] oldGrid = new boolean[100][100];
   private static boolean[][] newGrid = new boolean[100][100];

   public static void main(String[] args) throws IOException {
      BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
      System.out.print("Enter input file name: ");
      final String testFile = stdin.readLine();
      final BufferedReader in = new BufferedReader(new FileReader("C-" + testFile + ".in"));
      final PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("C-" + testFile + ".out")));
      final int T = parse(in.readLine());

      for(int X = 1; X <= T; X++) {
         int R = parse(in.readLine());

         for(int a = 1; a <= R; a++) {
            String[] line = in.readLine().split(" ");
            assert(line.length == 4);
            int x1 = parse(line[0]);
            int y1 = parse(line[1]);
            int x2 = parse(line[2]);
            int y2 = parse(line[3]);
            for(int i = x1; i <= x2; i++)
               for(int j = y1; j <= y2; j++)
                  oldGrid[i - 1][j - 1] = true;
         }

         int t = 1;
         timeloop:
            for( ; ; t++) {
               for(int i = 0; i < 100; i++)
                  for(int j = 0; j < 100; j++)
                     if(oldGrid[i][j])
                        newGrid[i][j] = north(oldGrid, i, j) || west(oldGrid, i, j);
                     else
                        newGrid[i][j] = north(oldGrid, i, j) && west(oldGrid, i, j);

               boolean[][] tmp = oldGrid;
               oldGrid = newGrid;
               newGrid = tmp;

               for(int i = 0; i < 100; i++)
                  for(int j = 0; j < 100; j++)
                     if(oldGrid[i][j])
                        continue timeloop;
               break;
            }
         

         out.println("Case #" + X + ": " + t);
         
         if(X != T)
            for(int i = 0; i < 100; i++)
               Arrays.fill(oldGrid[i], false);
      }
      in.close();
      out.close();
   }

   private static boolean north(boolean[][] grid, int i, int j) {
      if(i == 0)
         return false;
      else
         return grid[i - 1][j];
   }

   private static boolean west(boolean[][] grid, int i, int j) {
      if(j == 0)
         return false;
      else
         return grid[i][j - 1];
   }

   private static int parse(String s) {
      return Integer.parseInt(s);
   }
}
