package duarte.codejam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.lang.reflect.Constructor;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.List;

public abstract class CodeJamProblem implements Runnable {
	private static final boolean paralelo = true;
	static List<String> result = new ArrayList<String>();
	String[] entrada;
	int indice = 0;

	public CodeJamProblem() {
		super();
	}

	public int getIndice() {
		return indice;
	}

	public CodeJamProblem(String[] entrada, Integer i) {
		super();
		this.entrada = entrada;
		this.indice = i;
	}

	public String processaArquivo(String filename) throws Exception {
		result.clear();
		BufferedReader reader = new BufferedReader(new FileReader(filename));
		reader.readLine();
		Date d = new Date();

		while (reader.ready()) {
			indice++;
			String[] entrada = leEntrada(reader);
			processa(entrada);
		}

		System.err.println("Executou em "
				+ ((new Date().getTime() - d.getTime()) / 1000f) + " segs");
		StringBuilder builder = new StringBuilder();

		while (Thread.activeCount() > 2);
//			System.out.println(Thread.activeCount());

		Collections.sort(result, new Comparador());

		for (String s : result) {
			builder.append(s + "\n");
		}
		return builder.toString();
	}

	private void processa(String[] entrada) throws Exception {
		if (paralelo) {
			Constructor<? extends CodeJamProblem> constr = getClass()
					.getConstructor(String[].class, Integer.class);
			CodeJamProblem inst = constr.newInstance((Object) entrada,
					getIndice());
			new Thread(inst).start();
		} else
			addResult("Case #" + indice + ": " + resolve(entrada));
	}

	public static synchronized void addResult(String res) {
		result.add(res);
	}

	public abstract String resolve(String[] entrada);

	protected String[] leEntrada(BufferedReader reader) throws Exception {
		return reader.readLine().split(" ");
	}

	@Override
	public void run() {
		addResult("Case #" + indice + ": " + resolve(entrada));
	}

	public class Comparador implements Comparator<String> {

		@Override
		public int compare(String arg0, String arg1) {
			Integer a = Integer.valueOf(arg0.substring(6,
					arg0.indexOf(" ", 7) - 1));
			Integer b = Integer.valueOf(arg1.substring(6,
					arg1.indexOf(" ", 7) - 1));
			return a.compareTo(b);
		}

	}

	public String[] concat(String[] first, String[] second) {
		String[] result = Arrays.copyOf(first, first.length + second.length);
		System.arraycopy(second, 0, result, first.length, second.length);
		return result;
	}

}
