package duarte.codejam;

import java.io.BufferedReader;
import java.util.ArrayList;

public class Round1A extends CodeJamProblem {
	
	public Round1A() {
		super();
	}

	public Round1A(String[] entrada, Integer i) {
		super(entrada, i);
	}

	@Override
	public String resolve(String[] entradaP) {
		
		String[] entradaLoc = entradaP.length == 1 ? entradaP[0].split(" ") : entradaP;
		int charsDigitados = Integer.valueOf(entradaLoc[0]);
		int charsFaltando = Integer.valueOf(entradaLoc[1]) - charsDigitados;
		Float[] pcts = new Float[entradaLoc.length - 2];
		for(int i = 2; i < entradaLoc.length ; i++)
			pcts[i-2] = Float.valueOf(entradaLoc[i]);
		
		int qtdCasos = (int) Math.pow(2, charsDigitados);
		Float[] casosPct = new Float[qtdCasos];
		String[] casosString = new String[qtdCasos];
		for(int i = 0; i < qtdCasos; i++){
			String binaryString = Integer.toBinaryString(i);
			while(binaryString.length() < charsDigitados)
				binaryString = "0" + binaryString;
			casosPct[i] = multiplicaArray(pcts, String.format(binaryString));
			casosString[i] = binaryString;
		}
		Float menorKeystroke = Float.MAX_VALUE;
		
		
		for(int qtdBksp = -1; qtdBksp <= charsDigitados ; qtdBksp++){
			int[] keystrokes = new int[qtdCasos];
			for(int i = 0; i < qtdCasos; i++){
				int ke = keystrokes(casosString[i], charsDigitados, charsFaltando, qtdBksp);
				keystrokes[i] = ke;
			}
			Float mediaArray = Float.valueOf(somaArray(keystrokes, casosPct));
			if(menorKeystroke > mediaArray) menorKeystroke = mediaArray;
		}
		
		
		return String.format("%.6f", vtnc(menorKeystroke)).replace(",", ".");
	}

	
	private Float somaArray(int[] ar, Float[] pcts){
		Float ret = 0f;
		for(int i = 0; i < ar.length; i++)
			ret += pcts[i]*ar[i];
		return ret;
	}
	
	private int keystrokes(String caso, int charsDigitados,
			int charsFaltando, int qtdBksp) {
		if(qtdBksp < 0) return 1 + charsDigitados + charsFaltando + 1;
		int ret = charsFaltando + 1 + (qtdBksp*2); 
		if(caso.contains("1") && caso.indexOf("1") < charsDigitados - qtdBksp) 
			ret += charsDigitados + charsFaltando + 1;
		return ret ;
	}

	public Float multiplicaArray(Float[] pcts, String binaryString) {
		Float result = 1f;
		for(int i = 0; i < binaryString.length(); i++){
			result *= binaryString.charAt(i) == '1' ? 1 - pcts[i] : pcts[i];
		}
		return result;
	}

	@Override
	protected String[] leEntrada(BufferedReader reader) throws Exception {
		String[] entrada = reader.readLine().split(" ");
		String[] pcts = reader.readLine().split(" ");
		return concat(entrada, pcts);
	}
	
	public class Caso{
		ArrayList<Integer> keystrokes = new ArrayList<Integer>();
		
	}
	
	public Float vtnc(Float in){
		Float out = (float) (Math.rint(2000000.0 * in)/ 2000000.0);
		
		return out;
	}

	public String resolve() {
		
		return resolve(entrada);
	}
	

}
