package TicTakToeTomek;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class TicTakToeTomek {

	public static void main(String[] args) {
		File input = new File(args[0]);
		try {
			Scanner sc = new Scanner(new FileReader(input));
			PrintWriter output = new PrintWriter(new FileWriter("solution.out"));
			int numOfTestCases = sc.nextInt();
			sc.nextLine();
			for(int i = 1; i <= numOfTestCases; i++) {
				int[][] gameBoard = new int[4][4];
				for(int j = 0; j < 4; j++) {
					String line = sc.nextLine();
					for(int k = 0; k < 4; k++) {
						if(line.charAt(k) == 'X')		// X == 1
							gameBoard[j][k] = 1;
						else if(line.charAt(k) == 'O')	// O == 2
							gameBoard[j][k] = 2;
						else if(line.charAt(k) == 'T')	// T == 3
							gameBoard[j][k] = 3;
						else if(line.charAt(k) == '.')	// . == 4
							gameBoard[j][k] = 4;
					}
				}
				sc.nextLine();
				
				int solution = findSolution(gameBoard);
				output.print("Case #" + i + ": ");
				if(solution == 1)
					output.println("X won");
				else if(solution == 2)
					output.println("O won");
				else if(solution == 3)
					output.println("Draw");
				else if(solution == 4)
					output.println("Game has not completed");
			}
			sc.close();
			output.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	/* Returns an integer to describe the status of the board.
	 * 1 == X won
	 * 2 == O won
	 * 3 == Draw
	 * 4 == Game has not completed
	 */
	private static int findSolution(int[][] gameBoard) {
		boolean isBoardFull = true;
		boolean didSomeoneWin = false;
		int solution = 0;
		
		// Checking rows
		int index = 0;		
		while(index < 4 && !didSomeoneWin) {
			solution = checkForWinner(gameBoard[index][0], gameBoard[index][1], gameBoard[index][2], gameBoard[index][3]);
			if(solution == 1 || solution == 2)
				didSomeoneWin = true;
			if(solution == 4)
				isBoardFull = false;
			index++;
		}
		
		// Checking columns
		index = 0;
		while(index < 4 && !didSomeoneWin) {
			solution = checkForWinner(gameBoard[0][index], gameBoard[1][index], gameBoard[2][index], gameBoard[3][index]);
			if(solution == 1 || solution == 2)
				didSomeoneWin = true;
			if(solution == 4)
				isBoardFull = false;
			index++;
		}
		
		// Checking diagonal
		if(!didSomeoneWin) {
			solution = checkForWinner(gameBoard[0][0], gameBoard[1][1], gameBoard[2][2], gameBoard[3][3]);
			if(solution == 1 || solution == 2)
				didSomeoneWin = true;
			if(solution == 4)
				isBoardFull = false;
		}
		
		// Checking second diagonal
		if(!didSomeoneWin) {
			solution = checkForWinner(gameBoard[0][3], gameBoard[1][2], gameBoard[2][1], gameBoard[3][0]);
			if(solution == 1 || solution == 2)
				didSomeoneWin = true;
			if(solution == 4)
				isBoardFull = false;
		}
		
		if(!isBoardFull && !didSomeoneWin)
			return 4;
		if(isBoardFull && !didSomeoneWin)
			return 3;
		return solution;
	}
	
	private static int checkForWinner(int num1, int num2, int num3, int num4) {
		if(num1 == 4 || num2 == 4 || num3 == 4 || num4 == 4)
			return 4;
		if(num1 == num2 && num2 == num3 && num3 == num4) {
			return num1;
		}
		else if((num1 == num2 && num2 == num3 && num4 == 3) ||
				(num1 == num2 && num2 == num4 && num3 == 3) ||
				(num1 == num3 && num3 == num4 && num2 == 3))
			return num1;
		else if(num2 == num3 && num3 == num4 && num1 == 3)
			return num2;
		else
			return 3;
	}

}
