package Lawnmower;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.util.Scanner;


public class Lawnmower {

	public static void main(String[] args) {
		File inputFile = new File(args[0]);
		try {
			Scanner input = new Scanner(new FileReader(inputFile));
			PrintWriter output = new PrintWriter(new FileWriter("solution.out"));
			int numOfTestCases = input.nextInt();
			for(int i = 1; i <= numOfTestCases; i++) {
				int n = input.nextInt();
				int m = input.nextInt();
				int[][] desiredPattern = new int[n][m];
				int[][] currentPattern = new int[n][m];
				boolean[][] isPatternCorrect = new boolean[n][m];
				List<Integer> patternHeights = new ArrayList<Integer>();
				boolean[] heightsInList = new boolean[101];
				for(int j = 0; j < 100; j++) {
					heightsInList[j] = false;
				}
				for(int j = 0; j < n; j++) {
					for(int k = 0; k < m; k++) {
						desiredPattern[j][k] = input.nextInt();
						currentPattern[j][k] = 100;
						isPatternCorrect[j][k] = (desiredPattern[j][k] == currentPattern[j][k]);
						if(!heightsInList[desiredPattern[j][k]]) {
							patternHeights.add(new Integer(desiredPattern[j][k]));
							heightsInList[desiredPattern[j][k]] = true;
						}
					}
				}
				Collections.sort(patternHeights);
				Collections.reverse(patternHeights);
				boolean hasSolution = findSolution(desiredPattern, currentPattern, isPatternCorrect, patternHeights);
				output.print("Case #" + i + ": ");
				if(hasSolution)
					output.println("YES");
				else
					output.println("NO");
			}
			input.close();
			output.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	private static boolean findSolution(int[][] desiredPattern, int[][] currentPattern, 
										boolean[][] isPatternCorrect, List<Integer> patternHeights) {
		Iterator<Integer> iter = patternHeights.iterator();
		while(iter.hasNext()) {
			int height = iter.next().intValue();
			for(int i = 0; i < currentPattern.length; i++) {
				mowRow(desiredPattern, currentPattern, isPatternCorrect, i, height);
			}
			for(int j = 0; j < currentPattern[0].length; j++) {
				mowColumn(desiredPattern, currentPattern, isPatternCorrect, j, height);
			}
		}
		return checkPattern(isPatternCorrect);
	}
	
	private static void mowRow(int[][] desiredPattern, int[][] currentPattern, boolean[][] isPatternCorrect, int row, int height) {
		boolean canMow = true;
		for(int j = 0; j < currentPattern[row].length & canMow; j++) {
			if(isPatternCorrect[row][j] && currentPattern[row][j] != height)
				canMow = false;
		}
		if(canMow) {
			for(int j = 0; j < currentPattern[row].length; j++) {
				currentPattern[row][j] = height;
				isPatternCorrect[row][j] = (desiredPattern[row][j] == currentPattern[row][j]);
			}
		}
	}
	
	private static void mowColumn(int[][] desiredPattern, int[][] currentPattern, boolean[][] isPatternCorrect, int col, int height) {
		boolean canMow = true;
		for(int i = 0; i < currentPattern.length & canMow; i++) {
			if(isPatternCorrect[i][col] && currentPattern[i][col] != height)
				canMow = false;
		}
		if(canMow) {
			for(int i = 0; i < currentPattern.length; i++) {
				currentPattern[i][col] = height;
				isPatternCorrect[i][col] = (desiredPattern[i][col] == currentPattern[i][col]);
			}
		}
	}
	
	private static boolean checkPattern(boolean[][] isPatternCorrect) {
		for(int i = 0; i < isPatternCorrect.length; i++) {
			for(int j = 0; j < isPatternCorrect[i].length; j++) {
				if(!isPatternCorrect[i][j])
					return false;
			}
		}
		return true;
	}

}
