package Bullseye;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Bullseye {

	public static void main(String[] args) {
		File inputFile = new File(args[0]);
		try {
			Scanner input = new Scanner(new FileReader(inputFile));
			PrintWriter output = new PrintWriter(new FileWriter("solution.out"));
			int numOfTestCases = input.nextInt();
			input.nextLine();
			for(int i = 1; i <= numOfTestCases; i++) {
				long whiteRadius = input.nextLong();
				long blackRadius = whiteRadius + 1;
				long paintLeft = input.nextLong();
				
				//Paint first ring
				paintLeft = paintLeft - paintRing(blackRadius, whiteRadius);
				int numOfRings = 1;
				
				blackRadius = blackRadius + 2;
				whiteRadius = whiteRadius + 2;
				while(enoughPaintForRing(paintLeft, blackRadius, whiteRadius)) {
					paintLeft = paintLeft - paintRing(blackRadius, whiteRadius);
					numOfRings++;
					blackRadius = blackRadius + 2;
					whiteRadius = whiteRadius + 2;
				}
				output.print("Case #" + i + ": ");
				output.println(numOfRings);

			}
			input.close();
			output.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	private static long paintRing(long blackRadius, long whiteRadius) {
		return (blackRadius*blackRadius) - (whiteRadius*whiteRadius);
	}
	
	private static boolean enoughPaintForRing(double paintLeft, long blackRadius, long whiteRadius) {
		return (paintLeft - ((blackRadius*blackRadius) - (whiteRadius*whiteRadius)) >= 0);
	}

}
