package FairAndSquare;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class FairAndSquare {

	public static void main(String[] args) {
		File inputFile = new File(args[0]);
		try {
			Scanner input = new Scanner(new FileReader(inputFile));
			PrintWriter output = new PrintWriter(new FileWriter("solution.out"));
			int numOfTestCases = input.nextInt();
			for(int i = 1; i <= numOfTestCases; i++) {
				int begin = input.nextInt();
				int end = input.nextInt();
				int solution = findSolution(begin, end);
				output.println("Case #" + i + ": " + solution);
			}
			input.close();
			output.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static int findSolution(int begin, int end) {
		int solution = 0;
		for(int number = begin; number <= end; number++) {
			boolean isFairAndSquare = true;
			isFairAndSquare = isFairAndSquare && isPalindrome(String.valueOf(number));
			double rootOfNumber = Math.sqrt(number);
			int wholePartOfRoot = (int) rootOfNumber;
			double diff = rootOfNumber - wholePartOfRoot;
			if(diff == 0.0)
				isFairAndSquare = isFairAndSquare && isPalindrome(String.valueOf(wholePartOfRoot));
			else
				isFairAndSquare = false;
			if(isFairAndSquare)
				solution++;
		}
		return solution;
	}
	
	private static boolean isPalindrome(String number) {
		if(number.length() == 1)
			return true;
		else if(number.length() == 2)
			return (number.charAt(0) == number.charAt(1));
		else {
			return ((number.charAt(0) == number.charAt(number.length()-1)) && (isPalindrome(number.substring(1, number.length()-1))));
		}
	}

}
