import java.util.*;
import java.io.*;
import java.math.*;

public class a {

  public static void main(String[] args) throws Exception {
    BufferedReader br = new BufferedReader(new FileReader(args[0]));
    String str;

    int numCases = Integer.parseInt(br.readLine());
    for (int nCase = 1; nCase <= numCases; nCase++) {
      String[] sa = br.readLine().split(" ");
      int N = Integer.parseInt(sa[0]);
      int K = Integer.parseInt(sa[1]);
      int[][] board = new int[N][N];
      int[][] rotatedBoard = new int[N][N];
      for (int i = 0; i < N; i++) {
        str = br.readLine();
        for (int j = 0; j < str.length(); j++) {
          // red = 1, blue = 2
          if (str.charAt(j) == 'R')
            board[i][j] = 1;
          else if (str.charAt(j) == 'B')
            board[i][j] = 2;
          else
            board[i][j] = 0;    
        }
      }
      for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
          rotatedBoard[i][j] = board[N-1-j][i];
        }
      }
      gravity(rotatedBoard);
      board = rotatedBoard;


      // check red
      // each row
      int redCount = 0;
      int blueCount = 0;
      boolean redWins = false;
      boolean blueWins = false;
      loop:
        for (int i = board.length-1; i >= 0; i--) {
          redCount = 0;
          blueCount = 0;
          for (int j = 0; j < board.length; j++) {
            if (redWins && blueWins) break loop;
            if (rotatedBoard[i][j] == 1) {
              blueCount = 0;
              redCount++;
              if (redCount == K) {
                redWins = true;
              }
            }
            else if (rotatedBoard[i][j] == 2) {
              redCount = 0;
              blueCount++;
              if (blueCount == K) {
                blueWins = true;
              }
            }
            else {
              redCount = 0;
              blueCount = 0;
            }
          }
        }
      redCount = 0;
      blueCount = 0;
      loop2:
        for (int j = board.length-1; j >= 0; j--) {
          redCount = 0;
          blueCount = 0;
          for (int i = 0; i < board.length; i++) {
            if (redWins && blueWins) break loop2;
            if (rotatedBoard[i][j] == 1) {
              blueCount = 0;
              redCount++;
              if (redCount == K) {
                redWins = true;
              }
            }
            else if (rotatedBoard[i][j] == 2) {
              redCount = 0;
              blueCount++;
              if (blueCount == K) {
                blueWins = true;
              }
            }
            else {
              redCount = 0;
              blueCount = 0;
            }
          }
        }
      redCount = 0;
      blueCount = 0;
      loop3:
        for (int i = board.length-1; i >= 0; i--) {
          redCount = 0;
          blueCount = 0;
          for (int j = 0; j < board.length; j++) {
            if (redWins && blueWins) break loop3;
            if (rotatedBoard[i][j] != 0) {
              int val = board[i][j];
              int k;
              for (k = 0; k < K; k++) {
                int ii = i - k;
                int jj = j + k;
                if (ii >= 0 && ii < board.length && jj >= 0 && jj < board.length && board[ii][jj] == val)
                  continue;
                else break;
              }
              if (k == K) {
                if (val == 1)
                  redWins = true;
                else
                  blueWins = true;
              }
            }
          }
        }
      redCount = 0;
      blueCount = 0;
      loop4:
        for (int i = board.length-1; i >= 0; i--) {
          redCount = 0;
          blueCount = 0;
          for (int j = 0; j < board.length; j++) {
            if (redWins && blueWins) break loop4;
            if (board[i][j] != 0) {
              int val = board[i][j];
              int k;
              for (k = 0; k < K; k++) {
                int ii = i - k;
                int jj = j - k;
                if (ii >= 0 && ii < board.length && jj >= 0 && jj < board.length && board[ii][jj] == val) {
                  //System.out.println(i + ", " + j + ": dia " + k);
                  continue;
                }
                else break;
              }
              if (k == K) {
                if (val == 1) {
                  //System.out.println("red diag");
                  redWins = true;
                }
                else
                  blueWins = true;
              }
            }
          }
        }
      String answer;
      if (redWins && blueWins)
        answer = "Both";
      else if (redWins && !blueWins)
        answer = "Red";
      else if (!redWins && blueWins)
        answer = "Blue";
      else
        answer = "Neither";
      System.out.println("Case #" + nCase + ": " + answer);
    }
    br.close();

  }

  public static void gravity(int[][] board) {
    for (int j = 0; j < board.length; j++) {
      int toFit = board.length-1;
      for (int i = board.length-1; i >= 0; i--) {
        if (board[i][j] == 0)
          continue;
        else {
          board[toFit][j] = board[i][j];
          toFit--;
        }
      }
      while (toFit >= 0) {
        board[toFit][j] = 0;
        toFit--;
      }
    }
  }
}
