import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.io.StreamTokenizer;
import java.util.logging.ConsoleHandler;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Problem A. Tic-Tac-Toe-Tomek
 * 
 * @author sombrabr@gmail.com
 *
 */
public class A {

	static Logger log = Logger.getLogger("A");
	
	static class TicTacToeTomek {
		char board[][] = new char[4][4];
		
		int currentLine = 0;
		
		boolean hasEmptySquare = false;
		
		void addLine(String line) {
			for(int i=0; i<4; ++i) {
				board[currentLine][i] = line.charAt(i);
				hasEmptySquare |= board[currentLine][i] == '.';
			}
			currentLine++;
		}
		
		String Status() {
			char won;
			
			won = checkRows();
			if('\0' != won) {
				return won + " won";
			}
			
			won = checkColumns();
			if('\0' != won) {
				return won + " won";
			}
			
			won = checkDiagonals();
			if('\0' != won) {
				return won + " won";
			}
			
			if(hasEmptySquare) {
				return "Game has not completed";
			}
			
			return "Draw";
		}
		
		char checkRows() {
			nextLine:
			for(int i=0; i<4; ++i) {
				char chr = 'T';
				for(int j=0; j<4; ++j) {
					char cur = board[i][j];
					if(cur == '.') continue nextLine;
					if(chr == 'T') chr = cur;
					if(cur != chr && cur != 'T') {
						continue nextLine;
					}
				}
				return chr;
			}
			
			return '\0';
		}
		
		char checkColumns() {
			nextColumn:
			for(int i=0; i<4; ++i) {
				char chr = 'T';
				for(int j=0; j<4; ++j) {
					char cur = board[j][i];
					if(cur == '.') continue nextColumn;
					if(chr == 'T') chr = cur;
					if(cur != chr && cur != 'T') {
						continue nextColumn;
					}
				}
				return chr;
			}
			
			return '\0';
		}		
		
		char checkDiagonals() {
			boolean next = false;
			
			char chr = 'T';
			for(int i=0; i<4; ++i) {
				char cur = board[i][i];
				if(cur == '.') {
					next = true;
					break;
				}
				if(chr == 'T') chr = cur;
				if(cur != chr && cur != 'T') {
					next = true;
					break;
				}
			}
			
			if(!next) {
				return chr;
			}

			next = false;
			chr = 'T';
			for(int i=0; i<4; ++i) {
				char cur = board[3-i][i];
				if(cur == '.') {
					next = true;
					break;
				}
				if(chr == 'T') chr = cur;
				if(cur != chr && cur != 'T') {
					next = true;
					break;
				}
			}
			
			if(!next)
				return chr;
			
			return '\0';
		}
		
	}
	
	public static void main(String[] args) throws IOException {
		log.setLevel(Level.OFF);
		ConsoleHandler handler = new ConsoleHandler();
		handler.setLevel(Level.ALL);
		log.addHandler(handler);
		
		String fileName = args[0];
		
		Reader reader = new FileReader(fileName);
		
		StreamTokenizer st = new StreamTokenizer(reader);
		st.resetSyntax();
		st.wordChars(0x21, 0x7E);
		st.whitespaceChars(0x00, 0x20);
		st.eolIsSignificant(true);
		
		st.nextToken();
		
		int cases = Integer.parseInt(st.sval);
		log.fine("T: " + cases);
		
		st.nextToken();
		
		for(int c=0; c<cases; c++) {
			log.fine("Case " +(c+1));
			TicTacToeTomek tttt = new TicTacToeTomek();
			
			for(int i=0; i<4; ++i) {
				st.nextToken();
				log.fine("line " + (i+1) + ": " + st.sval);
				tttt.addLine(st.sval);
				st.nextToken();
			}
			st.nextToken();
			
			System.out.println("Case #" + (c+1) + ": " + tttt.Status());
		}
	}

}
