import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.io.StreamTokenizer;
import java.util.logging.ConsoleHandler;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Problem B. Lawnmower
 * 
 * @author sombrabr@gmail.com
 *
 */
public class B {

	static Logger log = Logger.getLogger("B");
	
	static class Lawnmower {
		
		int desiredLawn[][];
		
		int lawn[][];
		
		int N, M;

		public Lawnmower(int n, int m) {
			N = n;
			M = m;
			desiredLawn = new int[N][M];
			lawn = new int[N][M];
			fill(lawn, 100);
		}

		private static void fill(int[][] arr, int val) {
			for(int i=0; i<arr.length; ++i) {
				for(int j=0; j<arr[i].length; ++j) {
					arr[i][j] = val;
				}
			}
			
		}

		public void setHeight(int n, int m, int height) {
			desiredLawn[n][m] = height;
		}

		public String isPossible() {
			cutHorizontal();
			
			cutVertical();
			
			if(same()) {
				return "YES";
			}
			
			return "NO";
		}

		private boolean same() {
			for(int i=0; i<N; ++i) {
				for(int j=0; j<M; ++j) {
					if(desiredLawn[i][j] != lawn[i][j])
						return false;
				}
			}
			
			return true;
		}

		private void cutVertical() {
			for(int i=0; i<M; ++i) {
				int height = 0;
				for(int j=0; j<N; ++j) {
					if(desiredLawn[j][i]>height) {
						height = desiredLawn[j][i];
					}
				}
				for(int j=0; j<N; j++) {
					if(lawn[j][i]>height) lawn[j][i] = height;
				}
			}
		}

		private void cutHorizontal() {
			for(int i=0; i<N; ++i) {
				int height = 0;
				for(int j=0; j<M; ++j) {
					if(desiredLawn[i][j]>height) {
						height = desiredLawn[i][j];
					}
				}
				for(int j=0; j<M; ++j) {
					if(lawn[i][j] > height) lawn[i][j] = height;
				}
			}
		}

	}
	
	public static void main(String[] args) throws IOException {
		log.setLevel(Level.OFF);
		ConsoleHandler handler = new ConsoleHandler();
		handler.setLevel(Level.ALL);
		log.addHandler(handler);
		
		String fileName = args[0];
		
		Reader reader = new FileReader(fileName);
		
		StreamTokenizer st = new StreamTokenizer(reader);
		st.resetSyntax();
		st.wordChars(0x21, 0x7E);
		st.whitespaceChars(0x00, 0x20);
		st.eolIsSignificant(true);
		st.parseNumbers();
		
		st.nextToken();
		
		int cases = (int) st.nval;
		log.fine("T (cases): " + cases);
		
		st.nextToken();
		
		for(int c=0; c<cases; c++) {
			log.fine("Case: " + (c+1));
			
			st.nextToken();
			int N = (int) st.nval;
			st.nextToken();
			int M = (int) st.nval;
			
			log.fine("N (lines): " + N + "; M (squares): " + M);
			
			st.nextToken();
			
			Lawnmower l = new Lawnmower(N, M);
			
			for(int n=0; n<N; ++n) {
				for (int m=0; m<M; ++m) {
					st.nextToken();
					l.setHeight(n,m,(int) st.nval);
				}
								
				st.nextToken();
			}
			
			String result = l.isPossible();
			log.fine("Result: " + result);
			System.out.println("Case #" + (c+1) + ": " + result);			
		}
	}

}
