import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * Google code jam.
 * Qualification Round 2012.
 * A. Speaking in Tongues
 * 
 * Usage: &lt;app&gt; &lt;input &gt;output
 * 
 * @author sombrabr@gmail.com
 *
 */
public class QualA {
	
	//static char[] map = new char['z'-'a'+1];
	static char[] map = new char[]{'y','h','e','s','o','c','v','x','d','u','i','g','l','b','k','r','z','t','n','w','j','p','f','m','a','q'};
	
	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		
		int cases = new Integer(in.readLine());
		
		translate(in, cases);
		
		//createArray(in, cases);
	}
	
	// Do the translation
	static void translate(BufferedReader in, int cases) throws IOException {
		for(int i=0; i<cases; ++i) {
			String line = in.readLine();
			char[] chLine = line.toCharArray();
			
			System.out.print("Case #" + (i+1) + ": ");
			for(int j=0; j<chLine.length; ++j) {
				if(chLine[j]==' ')
					System.out.print(' ');
				else if(map[chLine[j]-'a']==0x00) {
					System.out.print('_');
					System.err.println("Verify character " + chLine[j]);
				} else
					System.out.print(map[chLine[j]-'a']);
			}
			System.out.println();
		}
	}
	
	// Used to create the array based on Sample
	static void createArray(BufferedReader in, int cases) throws IOException {
		String[] googlerese = new String[cases];
		for(int i=0; i<cases; ++i) {
			googlerese[i] = in.readLine();
		}
		
		String[] english = new String[cases];
		for(int i=0; i<cases; ++i) {
			english[i] = in.readLine();
			english[i] = english[i].replaceFirst("Case #\\d+: ", "");
		}
	
		for(int i=0; i<cases; ++i) {
			char[] chGooglerese = googlerese[i].toCharArray();
			char[] chEnglish = english[i].toCharArray();
			for(int j=0; j<chGooglerese.length; ++j) {
				if(chGooglerese[j]!=' ')
					map[chGooglerese[j]-'a'] = chEnglish[j];
			}
		}
		
		System.out.print("static char[] map = new char[]{");
		for(int i=0; i<map.length; ++i) {
			if(i>0)
				System.out.print(',');
			System.out.print('\'');
			System.out.print(map[i]);
			System.out.print('\'');
		}
		System.out.println("};");
	}
}
