import java.io.File;
import java.io.FileNotFoundException;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Scanner;


class Time {
	public String start;
	public String ende;
	
	public int start_minutes;
	public int ende_minutes;
	
	boolean use_new;
	
	public Time(String start, String ende) throws ParseException
	{
		this.start = start;
		this.ende = ende;
		use_new = true;
		
		DateFormat dfm = new SimpleDateFormat("HH:mm");
		start_minutes = (int)(dfm.parse(start).getTime()/60000);
		ende_minutes = (int)(dfm.parse(ende).getTime()/60000);
	}
}

public class SolB {

	private static int count = 1;
	private static int turnaround_time;
	private static int NA,NB;
	
	private static Time[] timetableA = new Time[120]; 
	private static Time[] timetableB = new Time[120];
	
	public static void main(String[] args) throws FileNotFoundException,ParseException {
		if(args.length != 1)
		{
			System.out.println("Expecting file");
			return;
		}
		
		Scanner sc = new Scanner(new File(args[0]));
		sc.nextLine();
		
		while(sc.hasNextLine())
		{
			turnaround_time = Integer.parseInt(sc.nextLine());
			
			NA = Integer.parseInt(sc.next());
			NB = Integer.parseInt(sc.next());
			
			for(int i=0; i<NA; i++)
				timetableA[i] = new Time(sc.next(), sc.next());
			
			for(int i=0; i<NB; i++)
				timetableB[i] = new Time(sc.next(), sc.next());

			sc.nextLine();
			
			calc();
		}

		sc.close();
	}
	
	public static void calc()
	{
		int res_na = NA;
		int res_nb = NB;
		
		for(int ib=0; ib<NB; ib++)
		{
			//System.out.println("zug B "+ib);
			int ankunft_A = timetableB[ib].ende_minutes + turnaround_time;
			int dist = Integer.MAX_VALUE;
			int min_dist = -1;
			int ia;
			//System.out.println("ankunft "+ankunft_A);
			
			for(ia=0; ia<NA; ia++)
			{
				if(timetableA[ia].use_new)
				{
					int diff = timetableA[ia].start_minutes-ankunft_A;
					//System.out.println("diff "+diff);
					if(diff >= 0 && diff < dist)
					{
						min_dist = ia;
						dist = diff;
					}
				}
			}
			
			if(min_dist != -1)
			{
				//System.out.println("anschluss gefunden "+min_dist+"/"+dist);
				res_na--;
				timetableA[min_dist].use_new = false;
			}
		}
		
		for(int ia=0; ia<NA; ia++)
		{
			//System.out.println("zug A "+ia);
			int ankunft_B = timetableA[ia].ende_minutes + turnaround_time;
			int dist = Integer.MAX_VALUE;
			int min_dist = -1;
			int ib;
			//System.out.println("ankunft "+ankunft_B);
			//System.out.println("NB "+NB);
			for(ib=0; ib<NB; ib++)
			{
				if(timetableB[ib].use_new)
				{
					int diff = timetableB[ib].start_minutes-ankunft_B;
					//System.out.println("diff "+diff);
					if(diff >= 0 && diff < dist)
					{
						min_dist = ib;
						dist = diff;
					}
				}
			}
			
			if(min_dist != -1)
			{
				//System.out.println("anschluss gefunden "+min_dist+"/"+dist+"/"+ib);
				res_nb--;
				timetableB[min_dist].use_new = false;
			}
		}
		
		System.out.println("Case #"+count+++": "+res_na+" "+res_nb);
	}
}