import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

/**
 *
 */
public class Problem3 {
	
	/**
	 * Auto generated method comment
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		
		long startTime = System.currentTimeMillis();
		String filename = args[0];
		
		try {
			FileReader reader = new FileReader(filename);
			BufferedReader bufferedReader = new BufferedReader(reader);
			
			String line = bufferedReader.readLine().trim();
			
			Integer numTests = Integer.parseInt(line);
			for (int i = 0; i < numTests; i++) {
				line = bufferedReader.readLine().trim();
				StringTokenizer tokenizer = new StringTokenizer(line);
				String stringLengthString = tokenizer.nextToken().trim();
				String repeatString = tokenizer.nextToken().trim();
				Integer repeats = Integer.parseInt(repeatString);
				
				String reductionString = bufferedReader.readLine().trim();
				
				String fullString = "";
				
				boolean singleLetter = true;
				String firstLetter = reductionString.substring(0, 1);
				
				if (firstLetter.equals("i")) {
					
					if (reductionString.contains("j") || reductionString.contains("k")) {
						singleLetter = false;
					}
				}
				if (firstLetter.equals("j")) {
					if (reductionString.contains("k") || reductionString.contains("i")) {
						singleLetter = false;
					}
					
				}
				if (firstLetter.equals("k")) {
					if (reductionString.contains("i") || reductionString.contains("j")) {
						singleLetter = false;
					}
					
				}
				for (int j = 0; j < repeats; j++) {
					fullString += reductionString;
				}
				
				String outputString = "NO";

				if (!singleLetter) {
					boolean possibleReduction = testString(fullString, null);
					if (possibleReduction) {
						outputString = getAnswer(fullString);
					}
				}
				
				System.out.println("Case #" + (i + 1) + ": " + outputString);
				
			}
			
			bufferedReader.close();
			
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		
		long endTime = System.currentTimeMillis();
		
	}
	
	private static String getAnswer(String fullString) {
		if (fullString.length() > 3) {
			//substring reduce to i
			for (int j = 0; j < fullString.length() - 2; j++) {
				boolean isI = testString(fullString.substring(0, j + 1), "i");
				
				if (isI) {
					//substring reduce to j
					for (int k = j + 1; k < fullString.length() - 1; k++) {
						
						String middleString = fullString.substring(j + 1, k + 1);
						boolean isJ = testString(middleString, "j");
						if (isJ) {
							
							boolean isK = testString(fullString.substring(k + 1), "k");
							
							if (isK) {
								return "YES";
							}
						}
					}
				}
			}
			
		} else {
			if (fullString.length() == 3 && fullString.equals("ijk")) {
				return "YES";
			}
		}
		return "NO";
	}
	
	private static boolean testString(String testString, String characterToTest) {
		boolean negative = false;
		
		if (testString.startsWith("-")) {
			negative = true;
			testString = testString.substring(1);
		}
		
		while (testString.length() >= 2) {
			
			String firstChar = testString.substring(0, 1);
			
			String secondChar = testString.substring(1, 2);
			
			String reduction = algebraRules(firstChar, secondChar);
			
			if (negative && reduction.startsWith("-")) {
				reduction = reduction.substring(1);
				negative = false;
			}
			
			testString = reduction + testString.substring(2);
			if (testString.startsWith("-")) {
				negative = true;
				testString = testString.substring(1);
			}
			
		}
		
		if (characterToTest == null && negative && testString.equals("1")) {
			return true;
		} else {
			if (testString.equals(characterToTest) && !negative) {
				return true;
			}
		}
		return false;
	}
	
	private static String algebraRules(String str1, String str2) {
		if (str1.equals(str2)) {
			if (str1.equals("1")) {
				return "1";
			} else {
				return "-1";
			}
		}
		
		if (str1.equals("1") && !str2.equals("1")) {
			return str2;
		}
		
		if (str2.equals("1") && !str1.equals("1")) {
			return str1;
		}
		
		if (str1.equals("i") && str2.equals("j")) {
			return "k";
		}
		
		if (str1.equals("j") && str2.equals("i")) {
			return "-k";
		}
		
		if (str1.equals("j") && str2.equals("k")) {
			return "i";
		}
		
		if (str1.equals("k") && str2.equals("j")) {
			return "-i";
		}
		
		if (str1.equals("k") && str2.equals("i")) {
			return "j";
		}
		
		if (str1.equals("i") && str2.equals("k")) {
			return "-j";
		}
		
		return "";
	}
	
}
