import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.math.BigInteger;
import java.util.Map.Entry;
import java.util.Scanner;
import java.util.TreeMap;
import java.util.logging.Logger;

public class C_Big extends SecurityManager
{
   static Scanner in;
   static BufferedWriter out;
   static TreeMap<BigInteger, Integer> fairAndSquare;

   static String name()
   { return "C"; }
   //{ return new Object() { }.getClass().getEnclosingClass().getName(); };
   //{ return Thread.currentThread().getStackTrace()[1].getClassName(); };
   
   static boolean isPalin(BigInteger number)
   {
      String s = number.toString();
      for (int j = 0; j < s.length()/2; j++)
         if (s.charAt(j) != s.charAt(s.length()-1-j))
            return false;
      return true;
   }
   
   static boolean isFairAndSquare(BigInteger number)
   {
      return isPalin(number) && isPalin(number.multiply(number));
   }
   
   static String createPalin(String s)
   {
      char[] outArr = new char[s.length()*2];
      char[] inArr = s.toCharArray();
      System.arraycopy(inArr, 0, outArr, 0, inArr.length);
      for (int i = 0; i < inArr.length; i++)
      {
         outArr[inArr.length+i] = inArr[inArr.length-1-i];
      }
      return new String(outArr);
   }

   static String createPalinUneven(String s)
   {
      char[] outArr = new char[s.length()*2-1];
      char[] inArr = s.toCharArray();
      System.arraycopy(inArr, 0, outArr, 0, inArr.length);
      for (int i = 0; i < inArr.length-1; i++)
      {
         outArr[inArr.length+i] = inArr[inArr.length-2-i];
      }
      return new String(outArr);
   }

   static long toNextBinary(String binString)
   {
      char[] arr = binString.toCharArray();
      int state = 0;
      for (int j = binString.length()-1; j >= 0; j--)
      {
         if (arr[j] == '1')
         {
            arr[j] = '0';
            if (state == 0 || state == 1)
            {
               state++;
            }
         }
         else if (state == 2)
         {
            state++;
            arr[j] = '1';
            break;
         }
      }
      if (state != 3)
         return Long.parseLong("1" + binString.replaceAll(".", "0"), 2);
      else
         return Long.parseLong(new String(arr), 2);
   }
   
   private static void makePalinsGetMatches(String s)
   {
      int m = 0;
      String newS = createPalinUneven(s);
      while (m < 3)
      {
         BigInteger bi = new BigInteger(newS);
         BigInteger prod = bi.multiply(bi);
         if (isPalin(bi) && isPalin(prod))
         {
            fairAndSquare.put(prod, -1);
         }
         if (m == 1)
            newS = createPalin(s);
         else
            newS = createPalinUneven(s + "2");
         m++;
      }
   }
   
   private static void getMatches(String s)
   {
      BigInteger bi = new BigInteger(s);
      BigInteger prod = bi.multiply(bi);
      if (isPalin(prod))
      {
         fairAndSquare.put(prod, -1);
      }
   }
   
   public static void main(String[] args) throws Exception
   {
      long max = 10000000000000000l;
      //long max = 1000000000000000000l;
      fairAndSquare = new TreeMap<BigInteger, Integer>();
      OldC.populate(fairAndSquare);
      for (long i = 0; i < 40000000; i++)
      {
         String s = Long.toString(i, 2);
         if (s.matches("(?:.*?1){5}.*0"))
         {
            i = toNextBinary(s);
            continue;
         }
         makePalinsGetMatches(s);
      }
      String zeros = "";
      for (int i = 0; i < 30; i++)
      {
         getMatches(createPalin("2"+zeros));
         getMatches(createPalinUneven("2"+zeros+"1"));
         getMatches(createPalinUneven("2"+zeros));
         zeros += "0";
      }
      fixPositions();

      //String inStr = name() + "-test.txt";
      //String inStr = name() + "-small-attempt0.in";
      String inStr = name() + "-large-2.in";
      String outStr = name() + ".out";
      in = new Scanner(new File(inStr));
      out = new BufferedWriter(new FileWriter(outStr));
      int count = in.nextInt();
      for (int i = 1; i <= count; i++)
      {
         BigInteger start = in.nextBigInteger();
         BigInteger end = in.nextBigInteger().add(BigInteger.ONE);
         /*System.out.println(start);
         System.out.println(end);
         System.out.println(fairAndSquare.ceilingEntry(start));
         System.out.println(fairAndSquare.ceilingEntry(end));*/
         long l = fairAndSquare.ceilingEntry(end).getValue() - fairAndSquare.ceilingEntry(start).getValue();
         out.write("Case #" + i + ": ");
         out.write(""+l);
         out.write("\n");
      }
      out.flush();
   }

   static void fixPositions()
   {
      int c = 0;
      for (Entry<BigInteger, Integer> entry : fairAndSquare.entrySet())
      {
         entry.setValue(c++);
      }
   }
}

class OldC
{
   static Scanner in;
   static BufferedWriter out;

   static String name()
   { return Logger.getLogger(new Throwable().getStackTrace()[0].getClassName()).getName(); }
   //{ return new Object() { }.getClass().getEnclosingClass().getName(); };
   //{ return Thread.currentThread().getStackTrace()[1].getClassName(); };
   
   static boolean isPalin(long number)
   {
      return number == reverse(number);
   }

   static long reverse(long number)
   {
      long result = 0;
      while (number != 0)
      {
         long remainder = number % 10;
         result = result * 10 + remainder;
         number /= 10;
      }
      return result;
   }

   public static void populate(TreeMap<BigInteger, Integer> fairAndSquare)
   {
      int c = 0;
      long max = 1000;
      for (long i = 0; ; i++)
      {
         long prod = i*i;
         if (isPalin(i) && isPalin(prod))
         {
            fairAndSquare.put(BigInteger.valueOf(prod), c++);
         }
         if (prod > max)
            break;
      }
   }
}
