import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Collections;
import java.util.LongSummaryStatistics;
import java.util.PriorityQueue;
import java.util.StringTokenizer;

public class ProblemC {

    public static void main(String[] args) throws IOException {
        InputScanner is = new InputScanner();
        int t = is.nextInt();
        for (int i = 1; i <= t; i++) {
            long n = is.nextLong();
            long k = is.nextLong();
            PriorityQueue<Long> queue = new PriorityQueue<>(Collections.reverseOrder());
            queue.add(n);
            long max = 0;
            long min = 0;
            while (k > 0) {
                k--;
                long val = queue.poll();
                max = val / 2;
                min = val - max - 1;
                queue.add(max);
                queue.add(min);
            }
            System.out.println("Case #" + i + ": " + max + " " + min);
        }
    }


    static class InputScanner {
        BufferedReader br;
        StringTokenizer st;

        public InputScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        public String next() throws IOException {
            if (st == null || !st.hasMoreTokens()) {
                String line = br.readLine();
                st = new StringTokenizer(line);
            }
            return st.nextToken();
        }

        public int nextInt() throws IOException {
            String next = next();
            return Integer.parseInt(next);
        }

        public long nextLong() throws IOException {
            String next = next();
            return Long.parseLong(next);
        }
    }
}
