
import java.io.*;
import java.util.*;

public class SquareTiles implements Runnable {
	private StringTokenizer st;

	private BufferedReader in;

	private PrintWriter out;

	final String file = "A-small-attempt0";

	public void solve(int test) throws IOException {
		out.println("Case #" + (test + 1) + ":");
		int R = nextInt();
		int C = nextInt();
		
		String[] tiles = new String[R];
		for(int i = 0; i < R; i++){
			tiles[i] = next();
		}

		int hashCount = 0;
		
		for(int i = 0; i < R; i++){
			for(int j = 0; j < C; j++){
				if(tiles[i].charAt(j) == '#'){
					hashCount++;
				}
			}
		}
		if(hashCount % 4 != 0){
			out.println("Impossible");
		}else{
			char[][] tilesarray = new char[R][C];
			for(int i = 0; i < R; i++){
				tilesarray[i] = tiles[i].toCharArray();
			}
			
			for(int i = 0; i < R - 1; i++){
				for(int j = 0; j < C - 1; j++){
					if(tilesarray[i][j] == '#' && tilesarray[i][j + 1] == '#' && tilesarray[i + 1][j] == '#' && tilesarray[i + 1][j + 1] == '#'){
						tilesarray[i][j] = '/';
						tilesarray[i][j + 1] = '\\';
						tilesarray[i + 1][j] = '\\';
						tilesarray[i + 1][j + 1] = '/';
						j++;
					}
				}
			}
			
			hashCount = 0;
			for(int i = 0; i < R; i++){
				for(int j = 0; j < C; j++){
					if(tilesarray[i][j] == '#'){
						hashCount++;
					}
				}
			}
			if(hashCount != 0){
				out.println("Impossible");
			}else{
				for(int i = 0; i < R; i++){
					for(int j = 0; j < C; j++){
						out.print(tilesarray[i][j]);
					}
					out.println();
				}
			}
		}
		
	}

	public void run() {
		try {
			//in = new BufferedReader(new InputStreamReader(System.in));
			in = new BufferedReader(new FileReader(file + ".in"));
			//out = new PrintWriter(new OutputStreamWriter(System.out));
			out = new PrintWriter(file + ".out");
			eat("");

			int tests = nextInt();
			for (int test = 0; test < tests; ++test) {
				solve(test);
			}

			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			failed = true;
		}
	}

	void eat(String s) {
		st = new StringTokenizer(s);
	}

	String next() throws IOException {
		while (!st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null) {
				return null;
			}
			eat(line);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	static boolean failed = false;

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		Thread th = new Thread(new SquareTiles());
		th.start();
		try {
			th.join();
		} catch (InterruptedException iex) {
		}
		if (failed) {
			throw new RuntimeException();
		}
	}
}

