
import java.io.*;
import java.util.*;

public class PerfectHarmony implements Runnable {
	private StringTokenizer st;

	private BufferedReader in;

	private PrintWriter out;

	final String file = "C-large";

	public static long lcm(long a, long b) {
		return (a * b) / gcd(a, b);
	}

	/*public static long lcm(int a[]) {
		int size = a.length;
		if (size > 2) {
			return lcm(lcm(Arrays.copyOf(a, size - 1)), a[size - 1]);
		} else {
			return lcm(a[0], a[1]);
		}
	}*/

	public static long gcd(long a, long b) {
		if (b == 0)
			return a;
		else
			return gcd(b, a % b);
	}
	
	public void solve(int test) throws IOException {
		out.print("Case #" + (test + 1) + ": ");
		int N = nextInt();
		long L = nextLong();
		long H = nextLong();

		long[] freqs = new long[N];
		for(int i = 0; i < N; i++){
			freqs[i] = nextLong();
		}
		
		if(L == 1){
			out.println(1);
			return;
		}
		
		long lcm = 1;
		Arrays.sort(freqs);
		for(int i = 0; i < N; i++){
			lcm = lcm(lcm, freqs[i]);
			if(L <= lcm && lcm <= H){
				boolean ok = true;
				for(int j = i + 1; j < N; j++){
					if(freqs[j] > lcm){
						if(freqs[j] % lcm == 0){
							continue;
						}else{
							ok = false;
							break;							
						}
					}else{
						if(lcm % freqs[j] == 0){
							continue;
						}else{
							ok = false;
							break;							
						}
					}					
				}
				if(ok == true){
					out.println(lcm);
					return;
				}
			}
			if(lcm > H){
				out.println("NO");
				return;
			}
		}
		out.println("NO");
		return;
		
		/*
		for(long f = L; f <= H; f++){
			boolean ok = true;
			for(int i = 0; i < N; i++){
				if(freqs[i] % f == 0 || f % freqs[i] == 0){
					continue;
				}else{
					ok = false;
					break;
				}
			}
			if(ok == true){
				out.println(f);
				return;
			}
		}*/
		/*out.println("NO");*/
	}

	public void run() {
		try {
			//in = new BufferedReader(new InputStreamReader(System.in));
			in = new BufferedReader(new FileReader(file + ".in"));
			//out = new PrintWriter(new OutputStreamWriter(System.out));
			out = new PrintWriter(file + ".out");
			eat("");

			int tests = nextInt();
			for (int test = 0; test < tests; ++test) {
				solve(test);
			}

			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			failed = true;
		}
	}

	void eat(String s) {
		st = new StringTokenizer(s);
	}

	String next() throws IOException {
		while (!st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null) {
				return null;
			}
			eat(line);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	static boolean failed = false;

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		Thread th = new Thread(new PerfectHarmony());
		th.start();
		try {
			th.join();
		} catch (InterruptedException iex) {
		}
		if (failed) {
			throw new RuntimeException();
		}
	}
}

