import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.StringTokenizer;

public class Magicka {
	private static class ConflictingPair {
		private char first, second;

		private ConflictingPair(char first, char second) {
			this.first = first;
			this.second = second;
		}

		public String toString() {
			return first + ", " + second;
		}
	}

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

		// get the number of test cases
		int T = Integer.parseInt(br.readLine());

		for (int t = 1; t <= T; t++) {
			StringTokenizer st = new StringTokenizer(br.readLine());

			int C = Integer.parseInt(st.nextToken());
			HashMap<String, String> combpairs = new HashMap<String, String>(C);
			for (int c = 1; c <= C; c++) {
				String combpair = st.nextToken();
				combpairs.put(combpair.substring(0, 2), combpair.substring(2));
			}

			int D = Integer.parseInt(st.nextToken());
			HashSet<ConflictingPair> conflictpairs = new HashSet<ConflictingPair>(D);
			for (int d = 1; d <= D; d++) {
				String conflictpair = st.nextToken();
				conflictpairs.add(new ConflictingPair(conflictpair.charAt(0), conflictpair.charAt(1)));
			}
			int N = Integer.parseInt(st.nextToken());

			String invoke = st.nextToken();
			StringBuilder elementlist = new StringBuilder();
			elementlist.append(invoke.charAt(0));

			for (int i = 1, len = invoke.length(); i < len; i++) {
				char incoming = invoke.charAt(i);
				boolean ok = true;

				if (elementlist.length() > 0) {
					// checking combination pairs
					StringBuilder checkcombpair = new StringBuilder("" + elementlist.charAt(elementlist.length() - 1) + incoming);
					if (ok == true && combpairs.containsKey(checkcombpair.toString())) {
						elementlist.replace(elementlist.length() - 1, elementlist.length(), combpairs.get(checkcombpair.toString()));
						ok = false;
					}
					checkcombpair.reverse();
					if (ok == true && combpairs.containsKey(checkcombpair.toString())) {
						elementlist.replace(elementlist.length() - 1, elementlist.length(), combpairs.get(checkcombpair.toString()));
						ok = false;
					}
					// checking conflicting pairs
					if (ok == true) {
						for (ConflictingPair p : conflictpairs) {
							if ((p.first == incoming && elementlist.indexOf(p.second + "") != -1)
									|| (p.second == incoming && elementlist.indexOf(p.first + "") != -1)) {
								elementlist.delete(0, elementlist.length());
								ok = false;
								break;
							}
						}
					}
				}

				// all fine, so append the character
				if (ok == true) {
					elementlist.append(incoming);
				}
			}

			System.out.printf("Case #%d: %s\n", t, Arrays.toString(elementlist.toString().toCharArray()));
		}
	}
}
