import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;


public class RPI {
	
	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

		// get the number of test cases
		int T = Integer.parseInt(br.readLine());
		
		for (int t = 1; t <= T; t++) {
			StringTokenizer st = new StringTokenizer(br.readLine());
			int N = Integer.parseInt(st.nextToken());
			
			String[] in = new String[N];
			for(int i = 0; i < N; i++){
				in[i] = br.readLine();
			}
			
			double[] wp = new double[N];
			double[] owp = new double[N];
			double[] oowp = new double[N];
			double[] rpi = new double[N];
			
			for(int i = 0; i < N; i++){
				int wincount = 0, playcount = 0;
				for(int j = 0; j < N; j++){
					if(in[i].charAt(j) == '1'){
						playcount++;
						wincount++;
					}
					if(in[i].charAt(j) == '0'){
						playcount++;
					}
				}
				wp[i] = (double)wincount/playcount;
			}
			
			for(int i = 0; i < N; i++){
				int otherplayercount = 0;
				double owptot = 0;
				for(int j = 0; j < N; j++){
					if(in[i].charAt(j) == '1' || in[i].charAt(j) == '0'){
						otherplayercount++;
						int wincount = 0, playcount = 0;
						for(int k = 0; k < N; k++){
							if(k != i){
								if(in[j].charAt(k) == '1'){
									playcount++;
									wincount++;
								}
								if(in[j].charAt(k) == '0'){
									playcount++;
								}
							}
						}
						owptot += (double)wincount/playcount;
					}
				}
				owp[i] = (double)owptot/otherplayercount;
			}
			
			for(int i = 0; i < N; i++){
				int otherplayercount = 0;
				double oowptot = 0;
				for(int j = 0; j < N; j++){
					if(in[i].charAt(j) == '1' || in[i].charAt(j) == '0'){
						otherplayercount++;
						oowptot += owp[j];
					}
				}
				oowp[i] = (double)oowptot/otherplayercount;
			}
			for(int i = 0; i < N; i++){
				rpi[i] = 0.25 * wp[i] + 0.50 * owp[i] + 0.25 * oowp[i];
			}
			System.out.println("Case #" + t + ":");
			for(int i = 0; i < N; i++){
				System.out.println(rpi[i]);
			}
		}
	}
}
