package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

/**
 * Solution to Google Code Jam Problem #1.
 * 
 * @author dan
 */
public class TestCase {

	private List<String> _searchEngines;
	private List<String> _searchQueries;
	
	/**
	 * Constructor
	 * 
	 * @param searchEngines the search engines.
	 * @param searchQueries the search queries.
	 */
	public TestCase ( List<String> searchEngines, List<String> searchQueries ) {
		_searchEngines = searchEngines;
		_searchQueries = searchQueries;
		
		// System.out.println( "TestCase added: " + _searchEngines + " engines, " + _searchQueries + " queries" );
	}

	/**
	 * Entry point
	 * 
	 * @param args unused.
	 */
	public static void main ( String[] args ) throws Exception {
		String fileName = "A-large.in";
		File f = new File(fileName);
		BufferedReader br = new BufferedReader( new FileReader( f ) );
		String readLine;
		readLine = br.readLine( );
		int numCases = Integer.parseInt( readLine );
		
		List<TestCase> cases = new ArrayList<TestCase>( );
		
		for( int i = 0; i < numCases; i++ )
		{
			List<String> engines = new ArrayList<String>( );
			List<String> queries = new ArrayList<String>( );
			
			readLine = br.readLine( );
			int numEngines = Integer.parseInt( readLine );
			for( int j = 0; j < numEngines; j++ )
			{
				engines.add( br.readLine( ) );
			}
			
			readLine = br.readLine( );
			int numQueries = Integer.parseInt( readLine );
			for( int j = 0; j < numQueries; j++ )
			{
				queries.add( br.readLine( ) );
			}
			
			cases.add( new TestCase( engines, queries ) );
		}
		br.close( );
		
		String newLine = "";
		BufferedWriter bw = new BufferedWriter( new FileWriter( new File( "out.txt" ) ) );
		for( int i = 0; i < cases.size( ); i++ )
		{
			bw.write( newLine );
			TestCase tc = cases.get( i );
			bw.write( "Case #" + (i+1) + ": " + tc.MinimizeSwitches( ) );
			newLine = "\r\n";
		}
		bw.close( );
	}

	/**
	 * Determine the lowest number of search engine switches required to process the query list.
	 */
	public int MinimizeSwitches() {
		int switches = 0;
		// only need to increment switches when every seach engine has been used once
		List<String> tmpEngines = new ArrayList<String>( );
		
		for( String query : _searchQueries )
		{
			if( _searchEngines.contains( query ) && 
				!tmpEngines.contains( query ) )
				tmpEngines.add( query );
			if( tmpEngines.size( ) >= _searchEngines.size( ) )
			{
				switches++;
				tmpEngines.clear( );
				tmpEngines.add( query );
			}
		}
		_searchEngines.removeAll( tmpEngines );
		return switches;
	}
}
