/**
 * 
 */
package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

/**
 * @author dan
 *
 */
public class FlyCase {

	private double f, R, t, r, g;

	/**
	 * 
	 */
	public FlyCase ( double f1,
			double R1,
			double t1,
			double r1,
			double g1 ) {
		f = f1;
		R = R1;
		t = t1;
		r = r1;
		g = g1;
		
		//System.out.println( "Created: " + turnaround + " " + _timesAB + " " + timesBA );
	}
	
	public double CalculateProbability( ) {
		// first take a quarter of the whole area.
		double quarterArea = Math.PI / 4.0 * (R) * (R);
		// divide by this in the end.
		double divArea = quarterArea;
		
		// make sure it's actually possible to miss
		if( f * 2 >= g ) return 1.0;
		
		/*for( double posX = r; posX < R; posX += g + 2*r )
		{
			for( double posY = r; posY < R; posY += g + 2*r )
			{
				double innerX = posX + f;
				double nextX = posX + g - f;
				double innerY = posY + f;
				double nextY = posY + g - f;
				double sqArea = 0;
				// see if this is a square or whether it's intersected by the border
				if( Math.sqrt( nextX * nextX + nextY * nextY ) < R-t-f)
				{
					//System.out.println( "Found square at " + posX + "," + posY );
					// an entire square!  area is easy
					sqArea = (g - 2*f) * (g - 2*f);
				}
				else if( Math.sqrt( innerX * innerX + innerY * innerY ) < R-t-f &&
						posY > posX )
				{
					// a partial square
					// start with the whole area and subtract - makes substitutions easier
					double initArea = Math.PI / 4.0 * (R-t-f) * (R-t-f);;
					// take out 0 to innerX
					double rad = R-t-f;
					initArea -= helper( rad, innerX );
					// take out under the square
					// first find the end of the square
					double intercept = Math.sqrt( rad * rad - innerY * innerY );
					double startNext;
					if( intercept < nextX )
						startNext = intercept;
					else
						startNext = nextX;
					initArea -= (startNext - innerX) * innerY;
					// now take out the remaining circle part
					initArea -= helper( rad, rad ) - helper( rad, startNext );
					// done!
					//System.out.println( "Area of partial square found to be " + initArea );
					sqArea = initArea * 2;
					//System.out.println( "Areas: " + divArea + " vs " + helper( R, R ) );
				}
				else if( Math.sqrt( innerX * innerX + innerY * innerY ) < R-t-f &&
						posY == posX )
				{
					// a partial square
					// start with the whole area and subtract - makes substitutions easier
					double initArea = Math.PI / 4.0 * (R-t-f) * (R-t-f);;
					// take out 0 to innerX
					double rad = R-t-f;
					initArea -= helper( rad, innerX );
					// take out under the square
					// first find the end of the square
					double intercept = Math.sqrt( rad * rad - innerY * innerY );
					double startNext;
					if( intercept < nextX )
						startNext = intercept;
					else
						startNext = nextX;
					initArea -= (startNext - innerX) * innerY;
					// now take out the remaining circle part
					initArea -= helper( rad, rad ) - helper( rad, startNext );
					// done!
					//System.out.println( "Area of partial square found to be " + initArea );
					sqArea = initArea;
					//System.out.println( "Areas: " + divArea + " vs " + helper( R, R ) );
				}
				quarterArea -= sqArea;
			}
		}
		
		// start with the racket
		double totalArea = Math.PI / 4.0 * ( (R+f)*(R+f) - (R-t-f)*(R-t-f) );
		for( double lineX = 0; lineX < R-t-f; lineX += g + 2*r)
		{
			double addArea = 0;
			// get the area of each line
			// see if the right bound is cut off
			double end = lineX+r+f;
			if( R-t-f < end )
				end = R-t-f;
			addArea = helper( R-t-f, end ) - helper( R-t-f, lineX-r-f );
			for( double lineY = 0; lineY < Math.sqrt( (R-t-f)*(R-t-f) - (lineX*lineX)); lineY += g + 2*r)
			{
				// is this cut off?
				if( Math.sqrt( (R-t-f)*(R-t-f) - (lineY+r+f)*(lineY+r+f) ) < lineY+g )
				{
					// ok, not a trivial case - is the upper bound also clipped?
					double upperBound = lineX+r+f;
					if( upperBound > R-t-f )
						upperBound = R-t-f;
					addArea += ( helper( R-t-f, upperBound ) - helper( R-t-f, lineX-r-f ) ) - ( (lineY+r+f) * (2*(r+f)) );
				}
				else
				{
					// is the upper bound clipped?
					double clip;
					if( (clip = Math.sqrt( (R-t-f)*(R-t-f) - (lineY+r+g-f)*(lineY+r+g-f) )) < lineX+r+f )
					{
						addArea += helper( R-t-f, lineX+r+f ) - helper( R-t-f, clip ) + (g-2*f)*(2*(r+f)-(lineX+r+f-clip));
					}
					else
						addArea += (g - 2*f) * (2*(r+f));
				}
			}
			// first line is half
			if(lineX == 0)
				addArea /= 2;
			//System.out.println( "Adding " + addArea );
			totalArea += addArea;
		}
		
		quarterArea = divArea;
		double innerRad = R-t-f;
		for( double posX = r; posX + f < innerRad * Math.sqrt( 2.0 ) / 2.0; posX += g + 2*r)
		{
			double innerX = posX + f;
			double nextX = posX + g - f;
			double diffArea = 0;
			double undoubleArea = 0;
			diffArea = helper( innerRad, nextX ) - helper( innerRad, innerX );
			System.out.println( "diffArea is " + diffArea );
			for( double posY = 0; posY < Math.sqrt( innerRad*innerRad - innerX*innerX); posY += g + 2*r)
			{
				double innerY = posY - r - f;
				if( posY == 0 )
					innerY = posY;
				double nextY = posY + r + f;
				
				if( posY > posX - r )
				{
					// is the upper bound clipped?
					double clip;
					if( (clip = Math.sqrt( innerRad*innerRad - nextY*nextY )) < nextX )
					{
						diffArea -= helper( innerRad, nextX ) - helper( innerRad, clip ) + (clip-innerX)*(nextY-innerY);
					}
					else
						diffArea -= (nextX-innerX)*(nextY-innerY);
				}
				else if( posY == posX - r )
				{
					if( posX + g + 2*r >= innerRad * Math.sqrt( 2 ) / 2.0)
						undoubleArea = diffArea;
					else
						undoubleArea = (nextX-innerX)*(nextX-innerX);
				}
				else
				{
					diffArea -= (nextX-innerX)*(nextX-innerX+f+f+r);
				}
			}
			//System.out.println( "Adding " + addArea );
			quarterArea -= diffArea * 2;
			quarterArea += undoubleArea;
		}*/
		
		quarterArea = divArea;
		List<Square> allSquares = new ArrayList<Square>( );
		for(double posX = 0; posX < R; posX += g+2*r)
			for(double posY = 0; posY < R; posY += g+2*r)
				allSquares.add( new Square( posX, posY, posX + g+2*r, posY + g+2*r, R-t-f, r+f ) );
		
		double sqArea = 0.0;
		for( Square s : allSquares )
		{
			sqArea += s.CalcArea( );
		}
		
		quarterArea -= sqArea;
		
		return quarterArea / divArea;
	}

	/**
	 * @param rad
	 * @param innerX
	 * @return
	 */
	private double helper ( double rad, double innerX ) {
		double r = (Math.sqrt(rad*rad-innerX*innerX)*innerX + rad*rad * Math.atan( innerX / Math.sqrt( rad*rad - innerX * innerX ) ) ) / 2;
		System.out.println( "Found rad " + rad + " and innerX " + innerX + " to be " + r );
		//System.out.println( innerX / Math.sqrt( rad * rad - innerX * innerX ) );
		return r;
	}

	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main ( String[] args ) throws Exception {
		String fileName = "C-large.in";
		File f = new File(fileName);
		BufferedReader br = new BufferedReader( new FileReader( f ) );
		String readLine;
		readLine = br.readLine( );
		int numCases = Integer.parseInt( readLine );
		
		List<FlyCase> cases = new ArrayList<FlyCase>( );
		
		for( int i = 0; i < numCases; i++ )
		{
			String[] readArray = br.readLine( ).split( " " );
			cases.add( new FlyCase( Double.parseDouble( readArray[0] ),
					Double.parseDouble( readArray[1] ),
					Double.parseDouble( readArray[2] ),
					Double.parseDouble( readArray[3] ),
					Double.parseDouble( readArray[4] ) ) );
		}
		br.close( );
		
		String newLine = "";
		BufferedWriter bw = new BufferedWriter( new FileWriter( new File( "out.txt" ) ) );
		for( int i = 0; i < cases.size( ); i++ )
		{
			bw.write( newLine );
			FlyCase tc = cases.get( i );
			double result = tc.CalculateProbability( );
			String output = new DecimalFormat("0.000000").format( result );
			bw.write( "Case #" + (i+1) + ": " + output );
			newLine = "\r\n";
		}
		bw.close( );
	}

}
