package gcj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * Solution to Google Code Jam Problem.
 * 
 * @author dan
 */
public class VectorCase {

	List<Integer> _vec1, _vec2;
	
	/**
	 * Constructor
	 */
	public VectorCase ( List<Integer> vec1, List<Integer> vec2 ) {
		_vec1 = vec1;
		_vec2 = vec2;
		
		System.out.println( "TestCase added: " + _vec1 + " vec1, " + _vec2 + " vec2" );
	}

	/**
	 * Entry point
	 * 
	 * @param args unused.
	 */
	public static void main ( String[] args ) throws Exception {
		String fileName = "A-small-attempt0.in";
		File f = new File(fileName);
		BufferedReader br = new BufferedReader( new FileReader( f ) );
		String readLine;
		readLine = br.readLine( );
		int numCases = Integer.parseInt( readLine );
		
		List<VectorCase> cases = new ArrayList<VectorCase>( );
		
		for( int i = 0; i < numCases; i++ )
		{
			readLine = br.readLine( );
			List<Integer> v1 = new ArrayList<Integer>();
			String vec1 = br.readLine( );
			String[] nums = vec1.split( " " );
			for( String s : nums )
				v1.add( Integer.parseInt( s ) );
			
			List<Integer> v2 = new ArrayList<Integer>();
			String vec2 = br.readLine( );
			nums = vec2.split( " " );
			for( String s : nums )
				v2.add( Integer.parseInt( s ) );
			
			cases.add( new VectorCase( v1, v2 ) );
		}
		br.close( );
		
		String newLine = "";
		BufferedWriter bw = new BufferedWriter( new FileWriter( new File( "out.txt" ) ) );
		for( int i = 0; i < cases.size( ); i++ )
		{
			bw.write( newLine );
			VectorCase tc = cases.get( i );
			bw.write( "Case #" + (i+1) + ": " + tc.ProcessTest( ) );
			newLine = "\r\n";
		}
		bw.close( );
	}

	/**
	 * @return
	 */
	public String ProcessTest() {
		String ret = "";
		Collections.sort(_vec1);
		Collections.sort(_vec2);
		int sum = 0;
		for(int i = 0; i < _vec1.size( ); i++ )
		{
			sum += _vec1.get( i ) * _vec2.get( _vec1.size( ) - i - 1 );
		}
		ret = "" + sum;
		return ret;
	}
}
