import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;


public class Translator {
	HashMap<Character,Character> dictionary;
	int numTestCases =-1;
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		Translator tr = new Translator();
		tr.parse();
	}

	private void parse() throws IOException {
		FileReader inputStream = null;
		FileWriter outputStream = null;
		BufferedReader br = null;
		PrintWriter pw = null;
		try{
			inputStream = new FileReader("A-small-attempt0.in");
			outputStream = new FileWriter("trans.txt");
			br = new BufferedReader(inputStream);
			pw = new PrintWriter(outputStream);
			numTestCases = Integer.parseInt(br.readLine());			
			
			for(int i=1;i<=numTestCases;i++){
				String inputLine = br.readLine();
				pw.println("Case #"+i+": "+solve(inputLine,pw));
			}
		}
		finally{
			if(inputStream != null){
				inputStream.close();
			}
			if(outputStream != null){
				outputStream.close();
			}
		}		
	}

	private String solve(String inputLine, PrintWriter pw) {
		StringBuilder sb = new StringBuilder(inputLine);
		for(int i=0;i<inputLine.length();i++){
			Character oldkey =sb.charAt(i);
			Character newkey = dictionary.get(oldkey);
			sb.replace(i, i+1, newkey.toString());
	    }
		
	    
	    return sb.toString();
	}

	public Translator(){
		dictionary = new HashMap<Character,Character>(26);
		dictionary.put('a', 'y');
		dictionary.put('b', 'h');
		dictionary.put('c', 'e');
		dictionary.put('d', 's');
		dictionary.put('e', 'o');
		dictionary.put('f', 'c');
		dictionary.put('g', 'v');
		dictionary.put('h', 'x');
		dictionary.put('i', 'd');
		dictionary.put('j', 'u');
		dictionary.put('k', 'i');
		dictionary.put('l', 'g');
		dictionary.put('m', 'l');
		dictionary.put('n', 'b');
		dictionary.put('o', 'k');
		dictionary.put('p', 'r');
		dictionary.put('q', 'z');
		dictionary.put('r', 't');
		dictionary.put('s', 'n');
		dictionary.put('t', 'w');
		dictionary.put('u', 'j');
		dictionary.put('v', 'p');
		dictionary.put('w', 'f');
		dictionary.put('x', 'm');
		dictionary.put('y', 'a');
		dictionary.put('z', 'q');
		dictionary.put(' ', ' ');
		
	}
}
/*
 *a->y
 * b
 * c
 * d
 * e
 * f
 * g
 * h
 * i
 * j
 * k
 * l
 * m
 * n
 * o
 * p
 * q
 * r
 * s
 * t
 * u
 * v
 * w
 * x
 * y
 * z
 */
