import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.StringTokenizer;

public class watershed {
	
	public static void main(String[] args) {			
		File file = new File("large.in");
		FileInputStream in = null;
		
		try {
			in = new FileInputStream(file);
			BufferedReader reader = new BufferedReader(new InputStreamReader(in));
			String line = null;

			int T = 0, H = 0, W = 0;
			Boolean firstLine = true;
			int h = 0;
			int t = 1;
			Boolean readMap = false;
						
			while ((line = reader.readLine()) != null) {
				//System.out.println(line);
			
				if (firstLine == true) {
					T = new Integer(line);
					firstLine = false;
					
				} else if (readMap == false) {
					StringTokenizer st = new StringTokenizer(line);
					H = new Integer(st.nextToken());
					W = new Integer(st.nextToken());
					//System.out.println("T:" + T + " H:" + H + " W:" + W + "\n");
					readMap = true;
					continue;
					
				} else if (readMap == true) {
					int[][] map = new int[H+2][W+2];
					for (int i = 0; i < H+2; i++) {
						for (int j = 0; j < W+2; j++) {
							map[i][j] = 10001;
						}
					}
					
					StringTokenizer st = new StringTokenizer(line);
					for (int i = 0; i < W; i++) {
						map[1][i+1] = new Integer(st.nextToken());
					}								
					for (int i = 1; i < H; i++) {
						line = reader.readLine();
						st = new StringTokenizer(line);
						for (int j = 0; j < W; j++) {
							map[i+1][j+1] = new Integer(st.nextToken());
						}			     
						//System.out.println(line);
					}
					
					//System.out.println("--------------------------------------------");
					//printMap(map);
					//System.out.println("--------------------------------------------");
					Character[][] outmap = evalMap(map);
					System.out.println("Case #" + (t++) + ":");
					printMap(outmap);
					//System.out.println("--------------------------------------------");
					
					//System.out.println("");
					readMap = false;
				}
			}
			
			in.close();
		} catch (IOException x) {
			System.err.println(x);
		} 	
	}
	
	static Character[][] evalMap(int[][] map) {
		int h = map.length - 2;
		int w = map[0].length - 2;
		Character[][] outMap = new Character[h][w]; 	
		
		int basin = 96;
		
		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				int oi = i;
				int oj = j;
				int mi = i+1;
				int mj = j+1;
				
				Boolean foundSink = false;
				while (!foundSink) {
					//System.out.println(mi + ", " + mj);
									
					// Sink
					if (map[mi-1][mj] >= map[mi][mj] &&
							map[mi+1][mj] >= map[mi][mj] &&
							map[mi][mj-1] >= map[mi][mj] &&
							map[mi][mj+1] >= map[mi][mj]
							) {
						if (outMap[mi-1][mj-1] == null) {
							basin++;
							outMap[mi-1][mj-1] = (char) basin;
						}
						outMap[i][j] = outMap[mi-1][mj-1];
						foundSink = true;
						break;
					}
	
					// North, West, East, South.
					ArrayList<Integer> localAltitudes = new ArrayList<Integer>();
					localAltitudes.add(map[mi-1][mj]);
					localAltitudes.add(map[mi][mj-1]);
					localAltitudes.add(map[mi][mj+1]);
					localAltitudes.add(map[mi+1][mj]);
					int min = (int) Collections.min(localAltitudes);
					//System.out.println("Min: " + min);
					
					int alt = map[mi][mj];
					/*
					System.out.println(
							(map[mi-1][mj]) + " " +
							(map[mi][mj-1]) + " " +
							(map[mi][mj+1]) + " " +
							(map[mi+1][mj]) + " ");
							*/
					
					// Go North
					if (map[mi-1][mj] == min) {
						mi--;
						//System.out.println("N");
						continue;
					}

					// Go West
					if (map[mi][mj-1] == min) {
						mj--;
						//System.out.println("W");
						continue;
					}
					          
					// Go East
					if (map[mi][mj+1] == min) {
						mj++;
						//System.out.println("E");
						continue;
					}
					
					// Go South
					if (map[mi+1][mj] == min) {
						mi++;
						//System.out.println("S");
						continue;
					}
				}	
			}
		}
		
		return outMap;
	}
	
	static void printMap(Character[][] map) {
		int h = map.length;
		int w = map[0].length;
		
		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				if (map[i][j] == null) {
					System.out.print("_" + " ");
				} else {
					System.out.print(map[i][j] + " ");
				}
			}
			System.out.print("\n");
		}
		
		return;
	}
	
	static void printMap(int[][] map) {
		int h = map.length;
		int w = map[0].length;
		
		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				System.out.print(map[i][j] + " ");
			}
			System.out.print("\n");
		}
		
		return;
	}
}
