import java.io.File;
import java.io.FileNotFoundException;
import java.util.*;

/**
 * Created by dusti on 4/8/2017.
 */
public class A {
    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(System.in);
       // Scanner in = new Scanner(new File("a.txt"));
        int numberOfInputs = in.nextInt();
        for (int i = 0; i < numberOfInputs; i++) {
            String pancakes = in.next().trim();
            int flipperSize = in.nextInt();
            int numberOfFlips = getNumFlips(pancakes, flipperSize);
            System.out.println(
                    "Case #" + (i + 1) + ": " + (numberOfFlips != -1? numberOfFlips : "IMPOSSIBLE")
            );
        }
    }

    private static int getNumFlips(String pancakes, int flipperSize) {
        HashMap<String, String> visited = new HashMap<>();
        Deque<String> Q = new ArrayDeque<>();
        visited.put(pancakes, null);
        Q.addFirst(pancakes);

        while (!Q.isEmpty()) {
            String currentState = Q.removeFirst();
            if (isAllHappy(currentState)) {
                return (distanceToRoot(currentState, visited));
            }
            for (int i = 0; i + flipperSize <= currentState.length(); i++) {
                String n = flip(currentState, i, flipperSize);
                if (!visited.containsKey(n)) {
                    visited.put(n, currentState);
                    Q.addLast(n);
                }
            }
        }
        return -1;
    }

    private static String flip(String pancakes, int index, int flipperSize) {
        char[] chars = pancakes.toCharArray();
        for (int i = 0; i < flipperSize; i++) {
            chars[index + i] = (chars[index + i] == '+') ? '-' : '+';
        }
        return String.valueOf(chars);
    }

    private static int distanceToRoot(String currentState, HashMap<String, String> visited) {
        int count = 0;
        while (currentState != null) {
            currentState = visited.get(currentState);
            count++;
        }
        return count - 1;
    }

    private static boolean isAllHappy(String currentState) {
        for (char c : currentState.toCharArray()) {
            if (c != '+') {
                return false;
            }
        }
        return true;
    }
}