import javafx.util.Pair;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

/**
 * Created by dusti on 4/8/2017.
 */
public class C {
    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(System.in);
//        Scanner in = new Scanner(new File("c.txt"));
        int numberOfTests = in.nextInt();
        for (int i = 0; i < numberOfTests; i++) {
            int n = in.nextInt();
            int k = in.nextInt();
            printCase(n, k, i + 1);
        }
    }

    private static void printCase(int n, int k, int caseNumber) {
        boolean[] stalls = new boolean[2 + n];
        Arrays.fill(stalls, false);
        stalls[0] = true;
        stalls[stalls.length - 1] = true;
        for (int i = 0; i < k - 1; i++) {
            makeSelection(stalls, false, caseNumber);
        }
        makeSelection(stalls, true, caseNumber);
    }

    private static void makeSelection(boolean[] stalls, boolean shouldPrint, int caseNumber) {
        int[] ls = getLs(stalls);
        int[] rs = getRs(stalls);
        List<AbstractMap.SimpleEntry<Integer, Integer>> pairsOfMin = IntStream.range(0, stalls.length)
                .filter(i -> !stalls[i])
                .mapToObj((i) -> new AbstractMap.SimpleEntry<>(i, Math.min(ls[i], rs[i])))
                .collect(Collectors.toList());
        int max = pairsOfMin.stream().mapToInt(AbstractMap.SimpleEntry::getValue).max().orElse(0);

        int maxIndex = IntStream.range(0, stalls.length)
                .filter(i -> ! stalls[i])
                .filter(i -> Math.min(ls[i],rs[i]) == max)
                .mapToObj((i) -> new AbstractMap.SimpleEntry<>(i, Math.max(ls[i], rs[i])))
                .max(Comparator.comparingInt(AbstractMap.SimpleEntry::getValue))
                .map(AbstractMap.SimpleEntry::getKey)
                .orElse(0);


        stalls[maxIndex] = true;
        if (shouldPrint) {
            System.out.println("Case #" + caseNumber + ": " + (Math.max(rs[maxIndex], ls[maxIndex]) - 1) + " " + (Math.min(rs[maxIndex], ls[maxIndex]) - 1));
        }
    }

    private static int[] getRs(boolean[] stalls) {
        int count = 0;
        int rs[] = new int[stalls.length];
        for (int i = stalls.length - 1; i >= 0; i--) {
            if (stalls[i]) {
                count = 0;
            }
            rs[i] = count;
            count++;
        }
        return rs;
    }

    private static int[] getLs(boolean[] stalls) {
        int[] ls = new int[stalls.length];
        int count = 0;
        for (int i = 0; i < stalls.length; i++) {
            if (stalls[i]) {
                count = 0;
            }
            ls[i] = count;
            count++;
        }
        return ls;
    }

}
