package google_code_jam.year_2017;

import java.io.*;
import java.util.HashMap;
import java.util.Map;

public class Round_1B_B {

    private static final String FILE_ROOT = "src/google_code_jam/year_2017/";
    private static final String FILE_INPUT = FILE_ROOT + "b.in";
    private static final String FILE_OUTPUT = FILE_ROOT + "b.out";

    private static BufferedReader mReader;
    private static PrintWriter mWriter;
    private static Map<Integer, int[]> mMatches;
    private static int[] mBaseOrder = new int[] {0, 2, 4, 1, 3, 5};

    static {
        mMatches = new HashMap<>(6);
        mMatches.put(0, new int[] {3, 2, 4});
        mMatches.put(1, new int[] {4});
        mMatches.put(2, new int[] {5, 0, 4});
        mMatches.put(3, new int[] {0});
        mMatches.put(4, new int[] {1, 0, 2});
        mMatches.put(5, new int[] {2});
    }

    public static void main(String[] args) throws IOException {
        mReader = new BufferedReader(new InputStreamReader(new FileInputStream(FILE_INPUT)));
        mWriter = new PrintWriter(FILE_OUTPUT);
        int testCasesCount = Integer.parseInt(mReader.readLine());

        for (int testCase = 1; testCase <= testCasesCount; testCase++) {
            int[] temp = parseIntArray(mReader.readLine());
            int n = temp[0];
            int r = temp[1];
            int o = temp[2];
            int y = temp[3];
            int g = temp[4];
            int b = temp[5];
            int v = temp[6];

            String answer = calcSolution(n, new int[] {r, o, y, g, b, v});
            printAnswer(testCase, answer);
        }

        mWriter.close();
        mReader.close();
    }

    private static String calcSolution(int n, int[] chars) {
        char[] ans = new char[n];

        int mostFirst = -1;
        int lastCharIndex = -1;
        if (chars[0] > 0 || chars[2] > 0 || chars[4] > 0) {
            int c1 = chars[0];
            int c2 = chars[2];
            int c3 = chars[4];
            int max = Math.max(c1, Math.max(c2, c3));
            lastCharIndex = c1 == max ? 0 : c2 == max ? 2 : 4;
            ans[0] = getChar(lastCharIndex);
            chars[lastCharIndex]--;
            mostFirst = lastCharIndex;
        } else {
            return "IMPOSSIBLE";
        }

        for (int i = 1; i < n; i++) {
            int nextChar = -1;
            int[] opt = mMatches.get(lastCharIndex);
            if (chars[opt[0]] > 0) {
                nextChar = opt[0];
            } else if (opt.length > 1) {
                int c1 = chars[opt[1]];
                int c2 = chars[opt[2]];
                nextChar = c1 > c2 && c1 > 0 ? opt[1]
                        : c2 > c1 && c2 > 0 ? opt[2]
                        : opt[1] == mostFirst && c1 > 0 ? opt[1]
                        : c2 > 0 ? opt[2]
                        : -1;
            }

            if (nextChar == -1) {
                return "IMPOSSIBLE";
            }

            ans[i] = getChar(nextChar);
            chars[nextChar]--;
            lastCharIndex = nextChar;
        }

        int[] firstCases = mMatches.get(lastCharIndex);
        for (int i : firstCases) {
            if (getChar(i) == ans[0]) {
                return new String(ans);
            }
        }

        return "IMPOSSIBLE";
    }

    private static char getChar(int i) {
        switch (i) {
            case 0:
                return 'R';
            case 1:
                return 'O';
            case 2:
                return 'Y';
            case 3:
                return 'G';
            case 4:
                return 'B';
            case 5:
                return 'V';
            default:
                throw new IllegalStateException();
        }
    }

    private static int[] parseIntArray(String text) {
        String[] tokens = text.split(" ");
        int[] result = new int[tokens.length];

        for (int i = 0; i < tokens.length; i++) {
            result[i] = Integer.parseInt(tokens[i]);
        }

        return result;
    }

    private static void printAnswer(int testCase, String answer) {
//        System.out.format("Case #%d: %s\n", testCase, answer);
        mWriter.format("Case #%d: %s\n", testCase, answer);
    }
}
