package google_code_jam.year_2017;

import java.io.*;
import java.util.HashMap;
import java.util.Map;

public class Round_1B_C {

    private static final String FILE_ROOT = "src/google_code_jam/year_2017/";
    private static final String FILE_INPUT = FILE_ROOT + "c.in";
    private static final String FILE_OUTPUT = FILE_ROOT + "c.out";

    private static BufferedReader mReader;
    private static PrintWriter mWriter;

    private static int n;
    private static long[] mHorseDist;
    private static long[] mHorseSpeed;
    private static long[][] mDist;

    private static double[] mMinTime;

    public static void main(String[] args) throws IOException {
        mReader = new BufferedReader(new InputStreamReader(new FileInputStream(FILE_INPUT)));
        mWriter = new PrintWriter(FILE_OUTPUT);
        int testCasesCount = Integer.parseInt(mReader.readLine());

        for (int testCase = 1; testCase <= testCasesCount; testCase++) {
            int[] temp = parseIntArray(mReader.readLine());
            n = temp[0];

            mHorseDist = new long[n];
            mHorseSpeed = new long[n];
            for (int i = 0; i < n; i++) {
                long[] tempLong = parseLongArray(mReader.readLine());
                mHorseDist[i] = tempLong[0];
                mHorseSpeed[i] = tempLong[1];
            }

            mDist = new long[n][n];
            for (int i = 0; i < n; i++) {
                mDist[i] = parseLongArray(mReader.readLine());
            }
            mReader.readLine(); // ignored

            mMinTime = new double[n];

            double answer = calcSolution();
            printAnswer(testCase, answer);
        }

        mWriter.close();
        mReader.close();
    }

    private static double calcSolution() {
        for (int i = n - 2; i >= 0; i--) {
            calcMinTime(i);
        }

//        System.out.println(n);
//        for (double t : mMinTime) {
//            System.out.println(t);
//        }

        return mMinTime[0];
    }

    private static void calcMinTime(int start) {
        long horseDist = mHorseDist[start];
        long horseSpeed = mHorseSpeed[start];

        double bestTime = Double.MAX_VALUE;
        long commonDist = 0;

        for (int i = start + 1; i < n; i++) {
            commonDist += mDist[i - 1][i];
            if (commonDist > horseDist) {
                break;
            }

            double curTime = (double) commonDist / horseSpeed + mMinTime[i];
            if (curTime < bestTime) {
                 bestTime = curTime;
            }
        }

        mMinTime[start] = bestTime;
    }

    private static int[] parseIntArray(String text) {
        String[] tokens = text.split(" ");
        int[] result = new int[tokens.length];

        for (int i = 0; i < tokens.length; i++) {
            result[i] = Integer.parseInt(tokens[i]);
        }

        return result;
    }

    private static long[] parseLongArray(String text) {
        String[] tokens = text.split(" ");
        long[] result = new long[tokens.length];

        for (int i = 0; i < tokens.length; i++) {
            result[i] = Long.parseLong(tokens[i]);
        }

        return result;
    }

    private static void printAnswer(int testCase, double answer) {
//        System.out.format("Case #%d: %.6f\n", testCase, answer);
        mWriter.format("Case #%d: %.6f\n", testCase, answer);
    }
}
