package google_code_jam.year_2017;

import java.io.*;

public class Round_1B_A {

    private static final String FILE_ROOT = "src/google_code_jam/year_2017/";
    private static final String FILE_INPUT = FILE_ROOT + "a.in";
    private static final String FILE_OUTPUT = FILE_ROOT + "a.out";

    private static BufferedReader mReader;
    private static PrintWriter mWriter;

    public static void main(String[] args) throws IOException {
        mReader = new BufferedReader(new InputStreamReader(new FileInputStream(FILE_INPUT)));
        mWriter = new PrintWriter(FILE_OUTPUT);
        int testCasesCount = Integer.parseInt(mReader.readLine());

        for (int testCase = 1; testCase <= testCasesCount; testCase++) {
            int[] temp = parseIntArray(mReader.readLine());
            int D = temp[0];
            int n = temp[1];
            int[][] horses = new int[n][2];
            for (int i = 0; i < n; i++) {
                temp = parseIntArray(mReader.readLine());
                horses[i][0] = temp[0];
                horses[i][1] = temp[1];
            }

            double answer = calcSolution(D, horses);
            printAnswer(testCase, answer);
        }

        mWriter.close();
        mReader.close();
    }

    private static double calcSolution(int d, int[][] horses) {
        double maxTime = 0;
        for (int i = 0; i < horses.length; i++) {
            double time = (double) (d - horses[i][0]) / (double) horses[i][1];
//            System.out.println("dist: " + (d - horses[i][0]) + " [speed]: " + (double) horses[i][1] + " [time]: " + time);
            maxTime = Math.max(maxTime, time);
        }
//        System.out.println("maxTime: " + maxTime);

        return (double) d / maxTime;
    }


    private static int[] parseIntArray(String text) {
        String[] tokens = text.split(" ");
        int[] result = new int[tokens.length];

        for (int i = 0; i < tokens.length; i++) {
            result[i] = Integer.parseInt(tokens[i]);
        }

        return result;
    }

    private static void printAnswer(int testCase, double answer) {
//        System.out.format("Case #%d: %.6f\n", testCase, answer);
        mWriter.format("Case #%d: %.6f\n", testCase, answer);
    }
}
