package solver;

import java.util.Arrays;

public class HappyPancakes {
	
	public static String run(String[] input) {
		String s = "";
		for (int i = 1; i<=input.length;i++){
			boolean[] side = new boolean[input[i-1].length()];
			for (int j =0;j<side.length;j++){
				side[j] = input[i-1].charAt(j) == '+';
			}
			s += "Case #" + i + ": ";
			s += computeFlips(side);
			s += "\n";
		}
		return s;
	}

	private static int computeFlips(boolean[] sides) {
		int counter = 0;
		int pointer = sides.length - 1;
		while (pointer >= 0){
			if (sides[pointer]){
				pointer--;
				continue;
			}
			if (!sides[0]){
				sides = flip(sides,pointer);
				counter++;
				pointer--;
				continue;
			}
			for (int i = pointer - 1;i >= 0;i--){
				if (sides[i]){
					sides = flip(sides,i);
					counter++;
					break;
				}
			}
			sides = flip(sides,pointer);
			counter++;
			pointer--;
		}
		return counter;
	}
	
	private static boolean[] flip(boolean[] sides,int index){
		boolean[] stack = new boolean[index+1];
		for (int i = index;i>=0;i--){
			stack[index-i] = !sides[i];
		}
		for (int i = 0;i<=index;i++){
			sides[i] = stack[i];
		}
		return sides;
	}
}
