package solver;

public class Fractile {

	public static String run(int[][] testCases) {
		String s = "";
		for (int i = 0;i<testCases.length;i++){
			s += "Case #" + (i+1) + ": ";
			s += getSequence(testCases[i][0],testCases[i][1],testCases[i][2]);
			s += "\n";
		}
		return s;
	}

	/**
	 * 
	 * @param K original sequence length
	 * @param C complexity (K^C length tiles)
	 * @param S clean tiles
	 * @return
	 */
	private static String getSequence(int K, int C, int S) {
		int[] result = recurseSequence(K,C);
		if (result.length > S){
			return "IMPOSSIBLE";
		} else {
			String s = "" + result[0];
			for (int i = 1;i<result.length;i++){
				s+= " " + result[i];
			}
			return s;
		}
	}

	private static int[] recurseSequence(int k, int c) {
		if (c == 1){
			int[] returnSeq = new int[k];
			for (int i=1;i<=k;i++){
				returnSeq[i-1] = i;
			}
			return returnSeq;
		}
		int[] prevSeq = recurseSequence(k, c - 1);
		if (prevSeq.length == 1){
			return prevSeq;
		}
		int[] returnSeq = new int[prevSeq.length - 1];
		for (int i=0;i<returnSeq.length;i++){
			returnSeq[i] = prevSeq[i]*k;
		}
		return returnSeq;
	}
}
