import java.util.*;
import java.io.*;

// javac Main.java&& java Main < input.md > output.md
// javac Main.java&& java Main < input.md
public class Main {


	public static void main(String[] args) {
		Main a = new Main();

		try {
			a.MainStart(args);
		} catch (Exception e) {
			a.printdv("[EXCEPTION] " + e.toString());
		}
	}

	String BREAK_EARLY = "!!asdfasdf";
	boolean DEBUG = true;

	void MainStart(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));

		int t = Integer.parseInt(in.nextLine()); // number of test case

		for (int testCase = 1; testCase <= t; ++testCase) {
			String line = in.nextLine();

			TreeMap<Character, Integer> map = new TreeMap<>();

			for (int i = 0; i < line.length(); i++) {
				if (map.containsKey(line.charAt(i))) {
					map.put(line.charAt(i), map.get(line.charAt(i)) + 1);
				} else {
					map.put(line.charAt(i), 1);
				}
			}

			int[] charCount = new int[10];

			char curChar = 'Z';
			if (map.containsKey(curChar) && (map.get(curChar) > 0)) {
				int count = map.get(curChar);
				String curNumStr = "ZERO";
				for(int i=0; i<curNumStr.length(); i++) {
					map.put(curNumStr.charAt(i), map.get(curNumStr.charAt(i)) - count);
				}
				// System.out.println(curNumStr + ": " + count);
				charCount[0] = count;
			}

			curChar = 'W';
			if (map.containsKey(curChar) && (map.get(curChar) > 0)) {
				int count = map.get(curChar);
				String curNumStr = "TWO";
				for(int i=0; i<curNumStr.length(); i++) {
					map.put(curNumStr.charAt(i), map.get(curNumStr.charAt(i)) - count);
				}
				// System.out.println(curNumStr + ": " + count);
				charCount[2] = count;
			}

			curChar = 'U';
			if (map.containsKey(curChar) && (map.get(curChar) > 0)) {
				int count = map.get(curChar);
				String curNumStr = "FOUR";
				for(int i=0; i<curNumStr.length(); i++) {
					map.put(curNumStr.charAt(i), map.get(curNumStr.charAt(i)) - count);
				}
				// System.out.println(curNumStr + ": " + count);
				charCount[4] = count;
			}

			curChar = 'X';
			if (map.containsKey(curChar) && (map.get(curChar) > 0)) {
				int count = map.get(curChar);
				String curNumStr = "SIX";
				for(int i=0; i<curNumStr.length(); i++) {
					map.put(curNumStr.charAt(i), map.get(curNumStr.charAt(i)) - count);
				}
				// System.out.println(curNumStr + ": " + count);
				charCount[6] = count;
			}


			curChar = 'G';
			if (map.containsKey(curChar) && (map.get(curChar) > 0)) {
				int count = map.get(curChar);
				String curNumStr = "EIGHT";
				for(int i=0; i<curNumStr.length(); i++) {
					map.put(curNumStr.charAt(i), map.get(curNumStr.charAt(i)) - count);
				}
				// System.out.println(curNumStr + ": " + count);
				charCount[8] = count;
			}

			// Unique after process

			curChar = 'O';
			if (map.containsKey(curChar) && (map.get(curChar) > 0)) {
				int count = map.get(curChar);
				String curNumStr = "ONE";
				for(int i=0; i<curNumStr.length(); i++) {
					map.put(curNumStr.charAt(i), map.get(curNumStr.charAt(i)) - count);
				}
				// System.out.println(curNumStr + ": " + count);
				charCount[1] = count;
			}


			curChar = 'H';
			if (map.containsKey(curChar) && (map.get(curChar) > 0)) {
				int count = map.get(curChar);
				String curNumStr = "THREE";
				for(int i=0; i<curNumStr.length(); i++) {
					map.put(curNumStr.charAt(i), map.get(curNumStr.charAt(i)) - count);
				}
				// System.out.println(curNumStr + ": " + count);
				charCount[3] = count;
			}


			curChar = 'F';
			if (map.containsKey(curChar) && (map.get(curChar) > 0)) {
				int count = map.get(curChar);
				String curNumStr = "FIVE";
				for(int i=0; i<curNumStr.length(); i++) {
					map.put(curNumStr.charAt(i), map.get(curNumStr.charAt(i)) - count);
				}
				// System.out.println(curNumStr + ": " + count);
				charCount[5] = count;
			}


			curChar = 'S';
			if (map.containsKey(curChar) && (map.get(curChar) > 0)) {
				int count = map.get(curChar);
				String curNumStr = "SEVEN";
				for(int i=0; i<curNumStr.length(); i++) {
					map.put(curNumStr.charAt(i), map.get(curNumStr.charAt(i)) - count);
				}
				// System.out.println(curNumStr + ": " + count);
				charCount[7] = count;
			}


			// UNIQUE AFTER
			curChar = 'I';
			if (map.containsKey(curChar) && (map.get(curChar) > 0)) {
				int count = map.get(curChar);
				String curNumStr = "NINE";
				for(int i=0; i<curNumStr.length(); i++) {
					map.put(curNumStr.charAt(i), map.get(curNumStr.charAt(i)) - count);
				}
				// System.out.println(curNumStr + ": " + count);
				charCount[9] = count;
			}


			StringBuilder sb = new StringBuilder();

			for (int i=0; i < 10; i++) {
				for (int j=0; j < charCount[i]; ++j) {
					sb.append(i);
				}
			}

			// System.out.print(sb.toString());

			System.out.printf("Case #%d: %s\n", testCase, sb.toString());
		}
	}





/* HELPER STUFF */

	void printdv(String line) {
		if (DEBUG) {
			System.err.print("\t[DEBUG] ");
			System.err.println(line);
		}
	}

}

