package codejam.qr2013;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.Scanner;

public class Lawnmower {


	 
	
	 public static BigInteger bigIntSqRootFloor(BigInteger x)
		        throws IllegalArgumentException {
		    if (x.compareTo(BigInteger.ZERO) < 0) {
		        throw new IllegalArgumentException("Negative argument.");
		    }
		    // square roots of 0 and 1 are trivial and
		    // y == 0 will cause a divide-by-zero exception
		    if (x.compareTo(BigInteger.ZERO) == 0  || x.compareTo(BigInteger.ONE) == 0 ){
		        return x;
		    } // end if
		    BigInteger two = BigInteger.valueOf(2L);
		    BigInteger y;
		    // starting with y = x / 2 avoids magnitude issues with x squared
		    for (y = x.divide(two);
		            y.compareTo(x.divide(y)) > 0;
		            y = ((x.divide(y)).add(y)).divide(two));
		    return y;
		}
	 public static BigInteger bigIntSqRootCeil(BigInteger x)
		        throws IllegalArgumentException {
		 

		    if (x.compareTo(BigInteger.ZERO) < 0) {
		        throw new IllegalArgumentException("Negative argument.");
		    }
		    // square roots of 0 and 1 are trivial and
		    // y == 0 will cause a divide-by-zero exception
		    if (x.compareTo(BigInteger.ZERO) == 0  || x.compareTo(BigInteger.ONE) == 0 ) {
		        return x;
		    } // end if
		    BigInteger two = BigInteger.valueOf(2L);
		    BigInteger y;
		    // starting with y = x / 2 avoids magnitude issues with x squared
		    for (y = x.divide(two);
		            y.compareTo(x.divide(y)) > 0;
		            y = ((x.divide(y)).add(y)).divide(two));
		    if (x.compareTo(y.multiply(y)) == 0) {
		        return y;
		    } else {
		        return y.add(BigInteger.ONE);
		    }
		} // end bigIntSqRootCeil
	
	 
	 public static char[] nextPal(char[] arr, int h, int l){
		 for(int i=h;i<l;i++){
			 arr[i] = arr[l-1-i];
		 }
		 return arr;
	 }
	 
	 
	public static BigInteger nextHigherPalin(BigInteger x) {
		String num = x.toString();
		int l = num.length();
		int h = (l + 1) / 2;
		if (num.replaceAll("9", "").length() == 0) { // handle 999 and 9999 case
			StringBuilder builder = new StringBuilder("1");
			for (int i = 0; i < num.length() - 1; i++)
				builder.append("0");
			builder.append("1");
			return new BigInteger(builder.toString());
		}
		char[] ch = num.toCharArray();
		char[] rev = nextPal(ch, h, l);
		String midplus = num.substring(0, h);
		StringBuffer mid = new StringBuffer(midplus.substring(0, l / 2))
				.reverse();
		String rever = midplus + mid;
		//System.out.println(rever);
		if (rever.compareTo(num) <= 0) {
			String midplus1 = new BigInteger(num.substring(0, h)).add(
					BigInteger.ONE).toString();
			StringBuffer midrev = new StringBuffer(midplus1.substring(0, l / 2))
					.reverse();
			return new BigInteger(midplus1 + midrev);
		} else
			return new BigInteger(new String(rev));

	}
	 static boolean isPalindrome(String str) {    
		    int n = str.length();
		    for( int i = 0; i < n/2; i++ )
		        if (str.charAt(i) != str.charAt(n-i-1)) 
		            return false;
		    return true;    
		}
	
	public static void main(String[] args) throws Exception {

        PrintWriter out = new PrintWriter(new File("lawn-out.txt"));
        

        try {

            Scanner scanner = new Scanner(new File("lawn-in.txt"));
            scanner.hasNextLine();
            int T = Integer.parseInt(scanner.nextLine());
           for(int i=0;i<T;i++){
        	 
    
        		   String num[] = scanner.nextLine().split(" ");

        		   //System.out.println(num[0]+"  "+num[1]);
        		   BigInteger from = bigIntSqRootCeil(new BigInteger(num[0]));
        		   BigInteger to = bigIntSqRootFloor(new BigInteger(num[1]));
        		   
        		   //System.out.println("from:"+bigIntSqRootCeil(new BigInteger(num[0])));
        		   //System.out.println("to  :"+bigIntSqRootFloor(new BigInteger(num[1])));
        		   
        		   int count =0;
        		   if(!isPalindrome(from.toString()))
        			  from = nextHigherPalin(from); 
        		   
        		   while(from.compareTo(to) <= 0){
        			   //System.out.println("from: "+from);
        			   BigInteger square  = from.pow(2);
        			  
	    			   if(isPalindrome(square.toString())){
	    				   count++;
	    			   }
        			  BigInteger next = nextHigherPalin(from);
        			  
        			  if(next.compareTo(to)==0){
        				  
        				  if(isPalindrome(next.pow(2).toString())){
	        				   count++;
	        			   }
        				  break;
        			  }
        			  else{
        				from = next;  
        			  }
        			   
        		   }
        		   
        		   

        	   out.println("Case #"+(i+1)+": "+count);

            }
           out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
	}

}
