package src;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashMap;
import java.util.Map;

public class Main {
	
	static int[][] map;
	static int[][] basin;
	static int H;
	static int W;

	public static void main(String[] args) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader(new File("resource/B-large.in")));
		BufferedWriter writer = new BufferedWriter(new FileWriter(new File("resource/A-small.out")));
		String firstLine = reader.readLine();
		int T = Integer.parseInt(firstLine);
		
		for (int i = 0; i < T; i++){
			String line = reader.readLine();
			String[] linesplit = line.split(" ");
			H = Integer.parseInt(linesplit[0]);
			W = Integer.parseInt(linesplit[1]);
			map = new int[W][H];
			basin = new int[W][H];
			for (int j = 0; j < H; j++){
				line = reader.readLine();
				linesplit = line.split(" ");
				for (int k = 0; k < W; k++){
					map[k][j] = Integer.parseInt(linesplit[k]);
				}
			}
			
			int count = 0;
			for (int a = 0; a < H; a++){
				for (int b = 0; b < W; b++){
					basin[b][a] = count;
					count++;
				}
			}
			
			boolean changed = true;
			while (changed) {
				changed = false;
				
				for (int y = 0; y < H; y++){
					for (int x = 0; x < W; x++){
						int basinType = getValueOfLowest(x, y);
						if (basinType != -1){
							if (basin[x][y] != basinType){
								changed = true;
								basin[x][y] = basinType;
							}
						}
					}
				}
			}
			
			
			writer.write("Case #" + (i+1) + ":\n");
			Map<Integer, Character> code = new HashMap<Integer, Character>();
			char cur = 'a';
			for (int a = 0; a < H; a++){
				for (int b = 0; b < W; b++){
					if (code.get(basin[b][a]) != null){
						writer.write(code.get(basin[b][a]) + " ");
					} else {
						code.put(basin[b][a], cur);
						cur++;
						writer.write(code.get(basin[b][a]) + " ");
					}
				}
				writer.write('\n');
			}
			
			
		}
		writer.flush();
		writer.close();
	}
	
	public static int getValueOfLowest(int x, int y){
		int cur = map[x][y];
		int lowest = cur;
		int basinType = -1;
		int xleft = x-1;
		int xright = x+1;
		int yup = y-1;
		int ydown = y+1;
		
		if (yup >= 0) {
			if (map[x][yup] < lowest){
				lowest = map[x][yup];
				basinType = basin[x][yup];
			}
		}
		
		if (xleft >= 0) {
			if (map[xleft][y] < lowest){
				lowest = map[xleft][y];
				basinType = basin[xleft][y];
			}
		}
		
		if (xright < W){
			if (map[xright][y] < lowest){
				lowest = map[xright][y];
				basinType = basin[xright][y];
			}
		}
		
		if (ydown < H){
			if (map[x][ydown] < lowest){
				lowest = map[x][ydown];
				basinType = basin[x][ydown];
			}
		}
		
		return basinType;
	}

}
