package src;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;

public class Main {

	public static void main(String[] args) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader(new File("resource/1C.in")));
		BufferedWriter writer = new BufferedWriter(new FileWriter(new File("resource/1C.out")));
		String firstLine = reader.readLine();
		int numCases = Integer.parseInt(firstLine);
		
		for (int i = 0; i < numCases; i++){
			String line = reader.readLine();
			String[] lineSplit = line.split(" ");
			int P = Integer.parseInt(lineSplit[0]);
			int Q = Integer.parseInt(lineSplit[1]);
			System.out.println(P + " " + Q);
			line = reader.readLine();
			lineSplit = line.split(" ");
			int length = lineSplit.length;
			int[] releases = new int[lineSplit.length];
			for (int j = 0; j < lineSplit.length; j++){
				releases[j] = Integer.parseInt(lineSplit[j]);
			}
			int answer = 0;
			
			if (length == 1){
				answer = singleRelease(releases[0], P);
			} else if (length == 2){
				answer = doubleRelease(releases[0], releases[1], P);
			} else if (length == 3){
				answer = tripleRelease(releases[0], releases[1], releases[2], P);
			} else if (length == 4){
				answer = quadrupleRelease(releases[0], releases[1], releases[2], releases[3], P);
			} else if (length == 5){
				answer = quintupleRelease(releases[0], releases[1], releases[2], releases[3], releases[4], P);
			}
			
			writer.write("Case #" + (i+1) + ": " + answer + "\n");
		}
		writer.flush();
		writer.close();
	}
	
	public static int singleRelease(int cellA, int totalCells){
		return totalCells - 1;
	}
	
	public static int doubleRelease(int cellA, int cellB, int totalCells){
		/*if (totalCells - cellA - 1 > cellB - 2){
			return (totalCells + cellB - 3);
		} else {
			return (2*totalCells) - cellA - 2;
		}*/
		int minimumA = totalCells - 1 + singleRelease(cellB - cellA, totalCells - cellA);
		int minimumB = totalCells - 1 + singleRelease(cellA, cellB - 1);
		return Math.min(minimumA, minimumB);
	}
	
	public static int tripleRelease(int cellA, int cellB, int cellC, int totalCells){
		/*if (2*totalCells - 4 < cellB + cellC + totalCells - 5){
			if (2*totalCells - 4 < 3*totalCells - cellA - cellB - 3){
				return 2*totalCells - 4;
			} else {
				return 3*totalCells - cellA - cellB - 3;
			}
		} else {
			if (cellB + cellC + totalCells - 5 < 3*totalCells - cellA - cellB - 3){
				return cellB + cellC + totalCells - 5;
			} else {
				return 3*totalCells - cellA - cellB - 3;
			}
		}*/
		int minimumA = totalCells - 1 + doubleRelease(cellB - cellA, cellC - cellA, totalCells - cellA);
		int minimumB = totalCells - 1 + singleRelease(cellA, cellB - 1) + singleRelease(cellC - cellB, totalCells - cellB);
		int minimumC = totalCells - 1 + doubleRelease(cellA, cellB, cellC - 1);
		return Math.min(minimumA, Math.min(minimumB, minimumC));
	}
	
	public static int quadrupleRelease(int cellA, int cellB, int cellC, int cellD, int totalCells){
		int minimumA = totalCells - 1 + tripleRelease(cellB - cellA, cellC - cellA, cellD - cellA, totalCells - cellA);
		int minimumB = totalCells - 1 + singleRelease(cellA, cellB - 1) + doubleRelease(cellC - cellB, cellD - cellB, totalCells - cellB);
		int minimumC = totalCells - 1 + doubleRelease(cellA, cellB, cellC - 1) + singleRelease(cellD - cellC, totalCells - cellC);
		int minimumD = totalCells - 1 + tripleRelease(cellA, cellB, cellC, cellD - 1);
		return Math.min(minimumA, Math.min(minimumB, Math.min(minimumC, minimumD)));
	}
	
	public static int quintupleRelease(int cellA, int cellB, int cellC, int cellD, int cellE, int totalCells){
		int minimumA = totalCells - 1 + quadrupleRelease(cellB - cellA, cellC - cellA, cellD - cellA, cellE - cellA, totalCells - cellA);
		int minimumB = totalCells - 1 + singleRelease(cellA, cellB - 1) + tripleRelease(cellC - cellB, cellD - cellB, cellE - cellB, totalCells - cellB);
		int minimumC = totalCells - 1 + doubleRelease(cellA, cellB, cellC - 1) + doubleRelease(cellD - cellC, cellE - cellC, totalCells - cellC);
		int minimumD = totalCells - 1 + tripleRelease(cellA, cellB, cellC, cellD - 1) + singleRelease(cellE - cellD, totalCells - cellD);
		int minimumE = totalCells - 1 + quadrupleRelease(cellA, cellB, cellC, cellD, cellE - 1);
		return Math.min(minimumA, Math.min(minimumB, Math.min(minimumC, Math.min(minimumD, minimumE))));
	}
}
