package main;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Random;
import java.util.Scanner;

public class ProblemD {

	public static void main(String[] args) throws IOException {
		ProblemD m = new ProblemD();
		String file = "D-small";
		Scanner scanner = new Scanner(new FileReader(file + ".in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter(file + "-output.out"));
		String[] numbers = {"0", "1", "12", "123", "1234", "12345"};
		ArrayList<ArrayList<String>> perms = new ArrayList<ArrayList<String>>();
		for (int i = 0; i < numbers.length; i++){
			perms.add(Permutations.perm1(numbers[i]));
		}

		int numCases = Integer.parseInt(scanner.nextLine());
		System.out.println(numCases);
		for (int i = 0; i < numCases; i++){
			int K = Integer.parseInt(scanner.nextLine());
			String S = scanner.nextLine();
			ArrayList<String> permutations = perms.get(K);
			int solution = Integer.MAX_VALUE;
			for (int j = 0; j < permutations.size(); j++){
				int answer = m.applyPermutation(S, permutations.get(j));
				if (answer < solution){
					solution = answer;
				}
			}
			String sol = "Case #" + String.valueOf(i + 1) + ": " + solution + '\n';
			writer.write(sol);
			System.out.println("**** NEXT CASE ****");
		}
		scanner.close();
		writer.close();
	}
	
	public int applyPermutation(String S, String p){
		int length = p.length();
		int pointer = 0;
		//String newS = "";
		char[] oldS = S.toCharArray();
		char[] newS = new char[S.length()];
		char[] perm = p.toCharArray();
		while (pointer < S.length()){
			//char[] segment = S.substring(pointer, pointer + length).toCharArray();
			for (int i = 0; i < length; i++){
				int index = Integer.parseInt(String.valueOf(perm[i]));
				newS[pointer + i] = oldS[pointer + index - 1]; 
			}
			pointer += length;
		}
		System.out.println(newS);
		return compress(String.valueOf(newS));
	}
	
	public int compress(String S){
		int count = 0;
		char[] chars = S.toCharArray();
		char oldChar = ' ';
		for (int i = 0; i < chars.length; i++){
			if (chars[i] != oldChar){
				count++;
				oldChar = chars[i];
			}
		}
		return count;
	}
	
	public long getFactorial(int K){
		if (K == 1){
			return 1;
		} else {
			return K * getFactorial(K - 1);
		}
	}
	
	public static class Permutations {

	    // print N! permutation of the characters of the string s (in order)
	    public static ArrayList<String> perm1(String s) { return perm1("", s, new ArrayList()); }
	    private static ArrayList<String> perm1(String prefix, String s, ArrayList list) {
	        int N = s.length();
	        if (N == 0) {
	        	//System.out.println(prefix);
	        	list.add(prefix);
	        }
	        else {
	            for (int i = 0; i < N; i++)
	               perm1(prefix + s.charAt(i), s.substring(0, i) + s.substring(i+1, N), list);
	        }
	        return list;
	    }

	    // print N! permutation of the elements of array a (not in order)
	    public void perm2(String s) {
	       int N = s.length();
	       char[] a = new char[N];
	       for (int i = 0; i < N; i++)
	           a[i] = s.charAt(i);
	       perm2(a, N);
	    }

	    private void perm2(char[] a, int n) {
	        if (n == 1) {
	            System.out.println(a);
	            return;
	        }
	        for (int i = 0; i < n; i++) {
	            swap(a, i, n-1);
	            perm2(a, n-1);
	            swap(a, i, n-1);
	        }
	    }  

	    // swap the characters at indices i and j
	    private void swap(char[] a, int i, int j) {
	        char c;
	        c = a[i]; a[i] = a[j]; a[j] = c;
	    }



	    /*public static void main(String[] args) {
	       int N = Integer.parseInt(args[0]);
	       String alphabet = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
	       String elements = alphabet.substring(0, N);
	       perm1(elements);
	       System.out.println();
	       perm2(elements);
	    }*/
	}
}
