package main;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class Main {

	private static String fileName = "A-small";
	
	public static void main(String[] args) throws IOException{
		File file = new File(fileName + ".in");
		Main m = new Main();
		
		BufferedReader reader = new BufferedReader(new FileReader(file));
		BufferedWriter writer = new BufferedWriter(new FileWriter(fileName + "-output.out"));
		
		String numCasesString = reader.readLine();
		int numCases = Integer.parseInt(numCasesString);
		for (int i = 0; i < numCases; i++){
			int caseNumber = i + 1;
			String line = reader.readLine();
			StringTokenizer tok = new StringTokenizer(line, " ");
			int n = Integer.parseInt(tok.nextToken());
			long A = Long.parseLong(tok.nextToken());
			long B = Long.parseLong(tok.nextToken());
			long C = Long.parseLong(tok.nextToken());
			long D = Long.parseLong(tok.nextToken());
			long X0 = Long.parseLong(tok.nextToken());
			long Y0 = Long.parseLong(tok.nextToken());
			long M = Long.parseLong(tok.nextToken());
			ArrayList<GridPoint> list = m.generateTrees(n, A, B, C, D, X0, Y0, M);
			int answer = m.solve(list);
			writer.write("Case #" + caseNumber + ": " + answer + '\n');
		}
		reader.close();
		writer.close();
	}
	
	private int solve(ArrayList<GridPoint> list) {
		int total = 0;
		GridPoint point1, point2, point3;
		for (int i = 0; i < list.size(); i++){
			point1 = list.get(i);
			for (int j = i + 1; j < list.size(); j++){
				point2 = list.get(j);
				for (int k = j + 1; k < list.size(); k++){
					point3 = list.get(k);
					long newX = (point1.getX() + point2.getX() + point3.getX());
					long newY = (point1.getY() + point2.getY() + point3.getY());
					
					if (newX % 3 == 0 && newY % 3 == 0){
						System.out.println(newX + " " + newY);
						/*if ((double)(point2.getY() - point1.getY())/(double)(point2.getX() - point1.getX())
								== (double)(point3.getY() - point1.getY())/(double)(point3.getX() - point1.getX())){
							System.out.println("SAME LINE");
						} else {
							total++;
						}*/
						total++;
					}
				}
			}
			
		}
		return total;
	}

	private ArrayList<GridPoint> generateTrees(int n, long a, long b, long c, long d, long x0, long y0, long m){
		ArrayList<GridPoint> list = new ArrayList<GridPoint>();
		long x = x0;
		long y = y0;
		list.add(new GridPoint(x, y));
		System.out.println ("Added tree: " + x + " " + y);
		for (int i = 1; i < n; i++){
			x = (a * x + b) % m;
			y = (c * y + d) % m;
			list.add(new GridPoint(x, y));
			System.out.println ("Added tree: " + x + " " + y);
		}
		return list;
	}
	
	public class GridPoint{
		private long x
		;
		public long getX() {
			return x;
		}

		public void setX(long x) {
			this.x = x;
		}

		public long getY() {
			return y;
		}

		public void setY(long y) {
			this.y = y;
		}

		private long y;
		
		public GridPoint(long x, long y){
			this.x = x;
			this.y = y;
		}
		
		
	}
}