package main;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class Main {

	public static void main(String[] args) throws IOException{
		File file = new File("B-large.in");
		Main m = new Main();
		
		BufferedReader reader = new BufferedReader(new FileReader(file));
		BufferedWriter writer = new BufferedWriter(new FileWriter("B-large-output.out"));
		
		String numCasesString = reader.readLine();
		int numCases = Integer.parseInt(numCasesString);
		for (int i = 0; i < numCases; i++){
			int caseNumber = i + 1;
			String line = reader.readLine();
			int turnaroundTime = Integer.parseInt(line);
			AllTrips allTrips = m.new AllTrips(turnaroundTime);
			line = reader.readLine();
			StringTokenizer tok = new StringTokenizer(line, " ");
			String numAString = tok.nextToken();
			String numBString = tok.nextToken();
			int numA = Integer.parseInt(numAString);
			int numB = Integer.parseInt(numBString);
			for (int j = 0; j < numA; j++){
				line = reader.readLine();
				StringTokenizer tok2 = new StringTokenizer(line, " ");
				String departTimeString = tok2.nextToken();
				String arriveTimeString = tok2.nextToken();
				allTrips.addTrip(m.new Trip('A', departTimeString, arriveTimeString));
			}
			for (int j = 0; j < numB; j++){
				line = reader.readLine();
				StringTokenizer tok2 = new StringTokenizer(line, " ");
				String departTimeString = tok2.nextToken();
				String arriveTimeString = tok2.nextToken();
				allTrips.addTrip(m.new Trip('B', departTimeString, arriveTimeString));
			}
			int[] solution = allTrips.solve();
			writer.write("Case #" + caseNumber + ": " + solution[0] + " " + solution[1] + '\n');
		}
		reader.close();
		writer.close();
	}
	
	public class AllTrips{
		private ArrayList fromATrips;
		private ArrayList fromBTrips;
		private int turnaroundTime;
		
		public AllTrips(int turnAroundTime){
			this.fromATrips = new ArrayList();
			this.fromBTrips = new ArrayList();
			this.turnaroundTime = turnAroundTime;
		}
		
		public void addTrip(Trip trip){
			if(trip.getDepartFrom() == 'A'){
				if (fromATrips.size() == 0){
					fromATrips.add(trip);
				} else {
					for (int i = 0; i < fromATrips.size(); i++){
						if (trip.getDepartureTime() < ((Trip)fromATrips.get(i)).getDepartureTime()){
							fromATrips.add(i, trip);
							break;
						} else if (i == fromATrips.size() - 1){
							fromATrips.add(trip);
							break;
						}
					}
				}
			} else if (trip.getDepartFrom() == 'B'){
				if (fromBTrips.size() == 0){
					fromBTrips.add(trip);
				} else {
					for (int i = 0; i < fromBTrips.size(); i++){
						if (trip.getDepartureTime() < ((Trip)fromBTrips.get(i)).getDepartureTime()){
							fromBTrips.add(i, trip);
							break;
						} else if (i == fromBTrips.size() - 1){
							fromBTrips.add(trip);
							break;
						}
					}
				}
			} else {
				System.out.println("ERROR: NOT A OR B");
			}
			System.out.println("Added " + trip);
			System.out.println("From A Trips: " + fromATrips);
			System.out.println("From B Trips: " + fromBTrips);
		}
		
		private Trip getMinTrip(){
			if(fromATrips.size() == 0){
				return (Trip) fromBTrips.get(0);
			} else if (fromBTrips.size() == 0){
				return (Trip) fromATrips.get(0);
			} else if (((Trip)fromATrips.get(0)).getDepartureTime() <= ((Trip)fromBTrips.get(0)).getDepartureTime()){
				return (Trip) fromATrips.get(0);
			} else if (((Trip)fromBTrips.get(0)).getDepartureTime() < ((Trip)fromATrips.get(0)).getDepartureTime()){
				return (Trip) fromBTrips.get(0);
			} else {
				System.out.println("ERROR");
				return null;
			}
		}
		
		private Trip getNextTrip(Trip trip){
			ArrayList nextTripList;
			Trip nextTrip = null;
			if (trip.getDepartFrom() == 'A'){
				nextTripList = fromBTrips;
			} else {
				nextTripList = fromATrips;
			}
			for (int i = 0; i < nextTripList.size(); i++){
				if(((Trip)nextTripList.get(i)).getDepartureTime() >= trip.getArrivalTime() + turnaroundTime){
					nextTrip = (Trip)nextTripList.get(i);
					break;
				}
			}
			return nextTrip;
		}
		
		public int[] solve(){
			int numATrain = 0;
			int numBTrain = 0;
			int totalTrips = fromATrips.size() + fromBTrips.size();
			
			while(totalTrips > 0){
				System.out.println("From A Trips: " + fromATrips);
				System.out.println("From B Trips: " + fromBTrips);
				Trip trip = getMinTrip();
				System.out.println("  Min Trip: " + trip);
				if (trip.getDepartFrom() == 'A'){
					numATrain++;
				} else {
					numBTrain++;
				}
				while (trip != null){
					Trip nextTrip = getNextTrip(trip);
					System.out.println("    Removed trip: " + trip);
					remove(trip);
					trip = nextTrip;
				}
				totalTrips = fromATrips.size() + fromBTrips.size();
			}
			
			int[] solution = new int[2];
			solution[0] = numATrain;
			solution[1] = numBTrain;
			return solution;
		}
		
		private void remove(Trip trip){
			if (trip.getDepartFrom() == 'A'){
				fromATrips.remove(trip);
			} else if (trip.getDepartFrom() == 'B'){
				fromBTrips.remove(trip);
			}
		}
	}
	
	public class Trip{
		
		private char departFrom;
		private int departureTime;
		private int arrivalTime;
		
		public Trip(char departFrom, String departTimeString, String arriveTimeString){
			StringTokenizer departTok = new StringTokenizer(departTimeString, ":");
			StringTokenizer arriveTok = new StringTokenizer(arriveTimeString, ":");
			String departHourString = departTok.nextToken();
			String departMinuteString = departTok.nextToken();
			String arriveHourString = arriveTok.nextToken();
			String arriveMinuteString = arriveTok.nextToken();
			int departHour = Integer.parseInt(departHourString);
			int departMinute = Integer.parseInt(departMinuteString);
			int arriveHour = Integer.parseInt(arriveHourString);
			int arriveMinute = Integer.parseInt(arriveMinuteString);
			this.departFrom = departFrom;
			this.departureTime = departHour * 60 + departMinute;
			this.arrivalTime = arriveHour * 60 + arriveMinute;
		}

		public char getDepartFrom() {
			return departFrom;
		}

		public int getDepartureTime() {
			return departureTime;
		}

		public int getArrivalTime() {
			return arrivalTime;
		}
		
		@Override
		public String toString() {
			return "Trip[" + String.valueOf(departFrom) + ", " + String.valueOf(departureTime) + ", " + String.valueOf(arrivalTime) + "]";
		}
	}
}
