package main;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Main {

	public static void main(String[] args) throws IOException {
		Main m = new Main();
		BufferedReader reader = new BufferedReader(new FileReader("input.in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.out"));
		
		int numCases = Integer.parseInt(reader.readLine());
		for (int i = 0; i < numCases; i++){
			ArrayList searchEngineList = new ArrayList();
			ArrayList queryList = new ArrayList();
			int numSearchEngines = Integer.parseInt(reader.readLine());
			for (int j = 0; j < numSearchEngines; j++){
				String searchEngineName = reader.readLine();
				searchEngineList.add(searchEngineName);
			}
			int numQueries = Integer.parseInt(reader.readLine());
			for (int k = 0; k < numQueries; k++){
				String queryName = reader.readLine();
				queryList.add(queryName);
			}
			System.out.println("CASE: " + searchEngineList + " " + queryList);
			int numSwitches = m.solve(searchEngineList, queryList);
			String solution = "Case #" + String.valueOf(i + 1) + ": " + String.valueOf(numSwitches) + '\n';
			writer.write(solution);
			System.out.println("**** NEXT CASE ****");
		}
		reader.close();
		writer.close();
	}
	
	private int solve(ArrayList searchEngineList, ArrayList queryList){
		int numSwitches = 0;
		ArrayList availableSearchEngineList = (ArrayList) searchEngineList.clone();
		for (int i = 0; i < queryList.size(); i++){
			String query = (String) queryList.get(i);
			if (availableSearchEngineList.contains(query)){
				if (availableSearchEngineList.size() == 1){
					numSwitches++;
					availableSearchEngineList = (ArrayList) searchEngineList.clone();
					availableSearchEngineList.remove(query);
					System.out.println("REMOVED " + query + ", REPOPULATING LIST: " + availableSearchEngineList);
				} else {
					availableSearchEngineList.remove(query);
					System.out.println("REMOVED " + query + ", AVAILABLE LIST: " + availableSearchEngineList);
				}
			} else {
				System.out.println("DIDN'T REMOVE " + query + ", AVAILABLE LIST: " + availableSearchEngineList);
			}
		}
		return numSwitches;
	}

}
