import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class PasswordProblem {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		// read input file
		File file = new File("A-small-attempt0.in");
		BufferedReader br = new BufferedReader(new FileReader(file));
		//String ln = "";
		int count = Integer.parseInt(br.readLine());

		// write output file
		File out = new File("out.txt");
		BufferedWriter bw = new BufferedWriter(new FileWriter(out));

		String[] lnArr1;
		String[] lnArr2;
		int typed = 0;	// # chars already typed
		//int total = 0;	// # chars in password
		int left = 0;	// # chars left to type in password
		float[] probs;	// prob. I correctly typed i-th char
		float[] typedProbs; //int[] keepOn; int[] oneBack; int[] twoBack; int enter;
		int keepOnR; int keepOnW; int oneBackR; int oneBackW; int twoBackR; int twoBackW; int enter;
		float lowestExp = 0;
		for(int i = 0; i < count; i++){
			lnArr1 = br.readLine().split(" ");
			lnArr2 = br.readLine().split(" ");
			typed = Integer.parseInt(lnArr1[0]);
			//total = Integer.parseInt(lnArr1[1]);
			left = Integer.parseInt(lnArr1[1]) - typed;
			probs = fillFloatArr(lnArr2, typed);
			
			typedProbs = computeTypedProbs(probs, typed);
			enter = left + typed + 2;
			keepOnR = left + 1;
			keepOnW = 2*left + typed + 2;
			oneBackR = left + 3;
			oneBackW = 2*left + typed + 4;
			twoBackR = left + 5;
			twoBackW = 2*left + typed + 6;
			
			lowestExp = computeLowestExp(typedProbs, keepOnR, keepOnW, oneBackR, oneBackW, twoBackR, twoBackW, enter, typed);
			
			bw.write("Case #" + (i+1) + ": " + String.format("%.6f", (float)lowestExp));
			bw.newLine();
			
//			keepOn = computeKeepOn(typed, left);
//			oneBack = computeOneBack(typed, left);
//			twoBack = computeTwoBack(typed, left);				
		}
		bw.close();
	}
	
	private static float computeLowestExp(float[] probs, int koR, int koW, int obR, int obW, int tbR, int tbW, int e, int t){
		float temp = 0;
		float exp = 0;
		int c = 0;
		while(c < 4){
			for(int i = 0; i < probs.length; i++){
				if(c == 0){
					temp += (i < 1) ? probs[i]*koR : probs[i]*koW;
				} else if(c == 1 && t > 1){
					temp += (i < 2) ? probs[i]*obR : probs[i]*obW;
				} else if(c == 1 && t == 1){
					temp += probs[i]*obR;
				} else if(c == 2 && t > 2){
					temp += (i < 4) ? probs[i]*tbR : probs[i]*tbW;
				} else if(c == 2 && t == 2){
					temp += probs[i]*tbR;
				} else if(c == 3){
					temp += probs[i]*e;
				}
			}
			exp = (c == 0) ? temp : ((temp < exp && temp > 0) ? temp : exp);
			temp = 0;
			c++;
		}
		return exp;
	}
	
//	private static int[] computeOneBack(int t, int left){
//		int[] temp = new int[(int) Math.pow(2, t)];
//		for(int i = 0; i < temp.length; i++){
//			if(i < 2)
//				temp[i] = left + 3;
//			else
//				temp[i] = 2*left + t + 4;
//		}
//		
//		return temp;
//	}
//	
//	private static int[] computeTwoBack(int t, int left){
//		int[] temp = new int[(int) Math.pow(2, t)];
//		if(t > 2){
//			for(int i = 0; i < temp.length; i++){
//				if(i < 4)
//					temp[i] = left + 5;
//				else
//					temp[i] = 2*left + t + 6;
//			}
//		}
//		return temp;
//	}
//
//	private static int[] computeKeepOn(int t, int left){
//		int[] temp = new int[(int) Math.pow(2, t)];
//		for(int i=0; i < temp.length; i++){
//			if(i == 0)
//				temp[i] = (left + 1);
//			else
//				temp[i] = (2*left + t + 2);
//		}
//		return temp;
//	}
	
	private static float[] computeTypedProbs(float[] probs, int t){
		float[] temp = new float[(int) Math.pow(2, t)];
		float[] helper = new float[t];
		float p;
		for(int i=0; i < temp.length; i++){
			p = 1.0f;
			for(int j=0; j < probs.length; j++){
				int check = (int) Math.pow(2, t-j);
				if(i % check < check/2)
					p *= probs[j];
				else
					p *= (1 - probs[j]);
			}
			temp[i] = p;
		}
		return temp;
	}
	
	private static float[] fillFloatArr(String[] arr, int t){
		if(arr.length != t){
			System.out.println("Problem!\n");
			return null;
		}
		float[] returnArr = new float[t];
		for(int j=0; j < returnArr.length; j++){
			returnArr[j] = Float.parseFloat(arr[j]);
		}
		
		return returnArr;
	}

}
