package tw.dy93;


import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Scanner;

public class C {
    private final String problemName = "C";
    private final String inTheMiddle = "-small";
    private final String inTheEnd = "-attempt0";

    private void run() throws IOException {
        Scanner scan = new Scanner(new File(problemName + inTheMiddle + inTheEnd + ".in"));
        PrintWriter w = new PrintWriter(new FileWriter(problemName + inTheMiddle + inTheEnd + ".out"));
        PrimeManager primeMgr = new PrimeManager();


        int tests = Integer.parseInt(scan.nextLine());
        for (int test = 1; test <= tests; test++) {
            w.printf("Case #%d:\n", test);
            String line = scan.nextLine();
            int len = Integer.parseInt(line.split(" ")[0]);
            int n = Integer.parseInt(line.split(" ")[1]);


            for (int i = 0; i < (1 << (len - 2)); i++) {
                int candidate = i << 1 | 1 | (1 << (len - 1));
                ArrayList<String> divisors = new ArrayList<>();
                long divisor = primeMgr.isPrime(candidate);

                if (divisor==1) {
                    continue;
                } else {
                    divisors.add(String.valueOf(divisor));
                }

                String candidateStr = Integer.toBinaryString(candidate);

                for (int base = 3; base <= 10; base++) {
                    divisor = primeMgr.isPrime(convertToIntegerByBase(candidateStr, base));
                    if(divisor == 1) {
                        break;
                    } else {
                        divisors.add(String.valueOf(divisor));
                    }
                }
                if (divisors.size()==9 && n-->0) {
                    w.printf("%s %s\n", candidateStr, String.join(" ", divisors));
                }
            }

        }
        w.close();
    }

    private long convertToIntegerByBase(String s, int base) {
        long sum = 0;
        for (int i = 0; i < s.length(); i++) {
            sum = sum * base;
            if (s.charAt(i) == '1') {
                sum = sum + 1;
            }
        }
        return sum;
    }


    public static void main(String[] args) throws IOException {
        C b = new C();
        b.run();
//        int cnt = 0;
//        PrimeManager p = b.new PrimeManager();
//        for (int i = 100; i >= 0; i--) {
//            if (p.isPrime(i)==1) {
//                cnt += 1;
//                System.out.println(i);
//            }
//        }
//        System.out.println(cnt);
    }


    public class PrimeManager {
        private ArrayList<Long> primes;
        private HashSet<Long> primesSet;
        private long knowledge;

        public PrimeManager() {
            primes = new ArrayList<>();
            primes.add(2l);
            primesSet = new HashSet<>();
            primesSet.add(2l);
            knowledge = 2l;
        }

        public long isPrime(long n) {
            if (n <= 1l) {
                return -1;
            }

            if (primesSet.contains(n)) {
                return 1l;
            }

            int i;
            for (i = 0; i < primes.size() && primes.get(i) <= Math.sqrt(n); i++) {
                if (n % primes.get(i) == 0) {
                    return primes.get(i);
                }
            }

            long divisor = 1;
            // extend knowledge base
            for (long j = knowledge + 1; j <= Math.sqrt(n); j++) {
                if (isPrime(j)==1) {
                    primes.add(j);
                    primesSet.add(j);
                }
                knowledge = j;
                if (n % j == 0) {
                    divisor = j;
                }
            }

            return divisor;
        }
    }
}

