package tw.dy93;


import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Main {
    private final String problemName = "A";
    private final String inTheMiddle = "-large";
    private final String inTheEnd = "";
    private final String[] numbers = new String[]{"1", "2", "3", "4", "5", "6", "7", "8", "9", "0"};

    private void run() throws IOException {
        Scanner scan = new Scanner(new File(problemName + inTheMiddle + inTheEnd + ".in"));
        PrintWriter w = new PrintWriter(new FileWriter(problemName + inTheMiddle + inTheEnd + ".out"));

        int tests = Integer.parseInt(scan.nextLine());

        for (int test = 1; test <= tests; test++) {
            int N = Integer.parseInt(scan.nextLine());
            if (N == 0) {
                w.printf("Case #%d: INSOMNIA\n", test);
            } else {
                int ans;
                SeeRecord seeRecord = new SeeRecord();
                for (ans = N; !seeRecord.haveSeenAll(); ans += N) {
                    int tmp = ans;
                    while (tmp != 0) {
                        seeRecord.seen(tmp % 10);
                        tmp = tmp / 10;
                    }
                }
                w.printf("Case #%d: %d\n", test, ans - N);
            }
        }
        w.close();
    }

    private class SeeRecord {
        private int record;

        public SeeRecord() {
            this.record = 0;
        }

        public void seen(int n) {
            this.record = this.record | (1 << n);
        }

        public boolean haveSeenAll() {
            return this.record == 0b1111111111;
        }
    }

    public static void main(String[] args) throws IOException {
        Main main = new Main();
        main.run();
    }
}
