import java.awt.*;
import java.io.File;
import java.util.ArrayList;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: user
 * Date: 4/12/13
 * Time: 6:13 PM
 * To change this template use File | Settings | File Templates.
 */
public class TicTacToeProblem implements Problem {

    private File file;
    private static int boardHeight = 4, boardWidth = 4;

    public TicTacToeProblem(File file){
        this.file = file;
    }

    @Override
    public String getName() {
        return "Tic Tac Toe Problem";
    }

    @Override
    public void setFile(File file) {
        this.file = file;
    }

    @Override
    public File getFile() {
       return file;
    }

    @Override
    public List<String> solve(List<String> stringList) {
        final List<String> solutionList = new ArrayList<String>();
        int numTestCases = Integer.parseInt(stringList.get(0));
        int caseNumber = 1;
        int lineIndex = 1;
        for(int i = 0; i < numTestCases; i++){
            char[][] board = new char[4][4];
            board[0] = stringList.get(lineIndex).toCharArray();
            lineIndex++;
            board[1] = stringList.get(lineIndex).toCharArray();
            lineIndex++;
            board[2] = stringList.get(lineIndex).toCharArray();
            lineIndex++;
            board[3] = stringList.get(lineIndex).toCharArray();
            solutionList.add(solveTestCase(board, caseNumber));
            caseNumber++;
            lineIndex+=2;
        }
        return solutionList;
    }

    private String solveTestCase(char[][] board, int testCase){

        if(win(board, 'X')){
            return "Case #"+testCase+": X won";
        }
        if(win(board, 'O'))
            return "Case #"+testCase+": O won";

        if(checkFor(board, '.'))
            return "Case #"+testCase+": Game has not completed";

        return "Case #"+testCase+": Draw";
    }

    private boolean checkFor(char[][] board, char ch){
        for(int r = 0; r <boardHeight; r++){
            for(int c = 0; c < boardWidth; c++){
                if(board[r][c] == ch)
                    return true;
            }
        }
        return false;
    }


    private boolean works(char position, char player){
        if(position == 'T')
            return true;
        if(position == player)
            return true;
        return false;
    }

    private boolean win(char[][] board, char player){
        boolean win = false;
        //check diagnol top left bottom right
        if(works(board[0][0], player) ){
            if(works(board[boardHeight-1][boardWidth-1], player)){
                if(works(board[1][1], player) && works(board[2][2], player))
                    return true;
            }
        }

        //check diagnal top right bottom left
        if(works(board[0][ 3], player) && works(board[1][2], player) && works(board[2][1], player) && works(board[3][0], player))
            return true;
        //check column 4
        if(works(board[0][ 3], player) && works(board[1][3], player) && works(board[2][3], player) && works(board[3][3], player))
            return true;
        //check column 3
        if(works(board[0][ 2], player) && works(board[1][2], player) && works(board[2][2], player) && works(board[3][2], player))
            return true;
        //check column 2
        if(works(board[0][ 1], player) && works(board[1][1], player) && works(board[2][1], player) && works(board[3][1], player))
            return true;
        //check column 1
        if(works(board[0][ 0], player) && works(board[1][0], player) && works(board[2][0], player) && works(board[3][0], player))
            return true;
        //check row 1
        if(works(board[0][ 0], player) && works(board[0][1], player) && works(board[0][2], player) && works(board[0][3], player))
            return true;
        //check row 2
        if(works(board[1][ 0], player) && works(board[1][1], player) && works(board[1][2], player) && works(board[1][3], player))
            return true;
        //check row 3
        if(works(board[2][ 0], player) && works(board[2][1], player) && works(board[2][2], player) && works(board[2][3], player))
            return true;
        //check row 4
        if(works(board[3][ 0], player) && works(board[3][1], player) && works(board[3][2], player) && works(board[3][3], player))
            return true;

        return win;
    }

    /*

    private boolean win(char[][] board, char player){
        for(int row = 0; row < boardHeight; row++){
            for(int col = 0; col < boardWidth; col++){
                if(board[row][col] == player){
                    List<Point> pointsCounted = new ArrayList<Point>();
                    Point newPoint = new Point(col, row);
                    pointsCounted.add(newPoint);
                    while((newPoint = checkAdjacentSpots(board, newPoint , pointsCounted, player)) != null){
                        pointsCounted.add(newPoint);
                    }
                    if(pointsCounted.size() == 4)
                        return true;
                }
            }
        }
        return false;
    }

    private Point checkAdjacentSpots(char[][]board, Point point, List<Point> pointsCounted, char player){
        //check left
        List<Point> paths = new ArrayList<Point>();
        int x = (int) point.getX();
        int leftX = (int)point.getX() - 1;
        int rightX = (int)point.getX() + 1;

        int y = (int)point.getY();
        int topY = (int)point.getY() - 1;
        int bottomY = (int)point.getY() + 1;
        if(leftX >= 0){

            if(board[y][leftX] == player || board[y][leftX] == 'T'){
                paths.add(new Point(leftX, y));
            }

            if(topY >= 0){
                if(board[topY][leftX] == player || board[topY][leftX] == 'T')
                    paths.add(new Point(leftX, topY));
            }

            if(bottomY < boardHeight){
                if(board[bottomY][leftX] == player || board[bottomY][leftX] == 'T')
                    paths.add(new Point(leftX, bottomY));
            }
        }

        if(rightX < boardWidth){

            if(board[y][rightX] == player || board[y][rightX] == 'T'){
                paths.add(new Point(rightX, y));
            }

            if(topY >= 0){
                if(board[topY][rightX] == player || board[topY][rightX] == 'T')
                    paths.add(new Point(rightX, topY));

                if(board[topY][x] == player || board[topY][x] == 'T')
                    paths.add(new Point(x,topY));
            }

            if(bottomY < boardHeight){
                if(board[bottomY][rightX] == player || board[bottomY][rightX] == 'T')
                    paths.add(new Point(rightX, bottomY));

                if(board[bottomY][x] == player || board[bottomY][x] == 'T')
                    paths.add(new Point(x,bottomY));
            }
        }

        Point returnPoint = null;
        for(Point p : paths){
            boolean counted = false;
            for(Point cp : pointsCounted){
                if(cp.getX() == p.getX() || cp.getY() == p.getY()){
                    counted = true;
                    break;
                }
            }
            if(!counted){
                returnPoint = p;
                break;
            }
        }

        return returnPoint;
    }
                      */
}
