import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: user
 * Date: 4/12/13
 * Time: 2:10 PM
 * To change this template use File | Settings | File Templates.
 */
public class Solver {

    private List<Problem> problems;

    public Solver(){
        problems = new ArrayList<Problem>();

        //problems.add(new SnapperProblem(new File("src/A-small-practice.in")));
        problems.add(new FairAndSquareProblem(new File("src/C-small-attempt1.in")));
        //add problems initializations here

        for(Problem problem : problems){
            System.out.println("Solving problem: " + problem.getName() + "...");

            //System.out.println(problem.solve());

            try{
                List<String> stringList = IOHelper.buildStringList(problem.getFile());
                final List<String> solution = problem.solve(stringList);
                String fileName = problem.getFile().getName();
                fileName = fileName.substring(0,fileName.indexOf(".")) + ".out";
                IOHelper.writeOutputFile(solution, new File(fileName));
            }
            catch(FileNotFoundException ex){
                System.out.println("Could not find file: " + ex.getCause());
            }
            catch(IOException ex){
                System.out.println("Something bad happened!");
            }
        }
    }

}
