import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

/**
 * Created by UMCGUDY on 4/10/2015.
 */
public class PancakesSolution implements Solution {
	@Override
	public String solve(List<String> input) {
		final Iterator<String> inputIterator = input.iterator();
		final int numTestCases = Integer.parseInt(inputIterator.next());
		final StringBuilder solutionBuilder = new StringBuilder();
		for (int tc = 1; tc <= numTestCases; tc ++) {
			System.out.println(tc);
			final int solution = solveTc(inputIterator);
			solutionBuilder.append("Case #" + tc + ": " + solution + System.lineSeparator());
		}
		return solutionBuilder.toString();
	}

	private int solveTc(Iterator<String> inputIterator) {
		inputIterator.next();
		final String[] desc = inputIterator.next().split(" ");

		final BST<Integer,Integer> tree = new BST<Integer, Integer>();

		for (String d : desc) {
			final Integer val = Integer.parseInt(d);
			tree.put(val, val);
		}


		boolean balanced = false;
		int specialMinutes = 0;

		while (!balanced) {
			final int max = tree.max();
			int split = max/2;
			int remainder = max%2;
			if (max - (split + remainder) > 1 && secondMost(tree) < max) {
				tree.deleteMax();
				tree.put(split, split);
				tree.put(split + remainder, split + remainder);
				specialMinutes++;
			} else {
				balanced = true;
			}
		}

		return tree.max() + specialMinutes;
	}



	private int secondMost(BST<Integer,Integer> tree) {
		int oldMax = tree.max();
		tree.deleteMax();
		if (tree.isEmpty()) {
			tree.put(oldMax, oldMax);
			return 0;
		}
		int newMax = tree.max();
		tree.put(oldMax, oldMax);
		return newMax;
	}


}
