import java.io.File;
import java.util.ArrayList;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: user
 * Date: 4/13/13
 * Time: 2:43 PM
 * To change this template use File | Settings | File Templates.
 */
public class FairAndSquareProblem implements Problem {

    private File file;

    public FairAndSquareProblem(File file){
        this.file = file;
    }

    @Override
    public String getName() {
        return "Fair and Square Problem";
    }

    @Override
    public void setFile(File file) {
       this.file = file;
    }

    @Override
    public File getFile() {
        return file;
    }

    @Override
    public List<String> solve(List<String> stringList) {
        int numTestCases = Integer.parseInt(stringList.get(0));
        final List<String> solutionList = new ArrayList<String>();

        for(int i = 1; i<= numTestCases; i++){
            String[] testCaseParams =  stringList.get(i).split(" ");
            int bottomBound = Integer.parseInt(testCaseParams[0]);
            int topBound = Integer.parseInt(testCaseParams[1]);
            String solutionText = solveTestCase(bottomBound, topBound, i);
            solutionList.add(solutionText);
        }
        return solutionList;
    }


    private String solveTestCase(int bottomBound, int topBound, int caseNumber){
        int numFairAndSquare = 0;
        for(int n = bottomBound; n <= topBound; n++){
            double square = Math.sqrt(n);
            if(square == (long) square)
                if(isPalindrome((int)square)){
                    if(isPalindrome(n))
                        numFairAndSquare++;
                }
        }
        return "Case #"+caseNumber+": "+numFairAndSquare;
    }


    private boolean isPalindrome(int n){
        String nString = ""+n;
        //nString = nString.replace(".", "");
        for(int i = 0; i < nString.length()/2; i++){
            if(nString.charAt(i) != nString.charAt(nString.length()-1-i))
                return false;
        }

        return true;
    }

}
