import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Scanner;

public class Solution {

	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File("in.txt"));
		PrintWriter out = new PrintWriter("out.txt");
		Solve s = new Solve();
		int t = in.nextInt();
		for (int i = 1; i <= t; i++) {
			s.solve(in, out, i);
		}
		in.close();
		out.close();
	}

}

class Solve {
	void solve(Scanner in, PrintWriter out, int TEST) {
		int n = in.nextInt();
		int k = in.nextInt();
		List<Long> l = new ArrayList<>();
		long[] r = new long[n];
		long[] h = new long[n];
		for (int i = 0; i < n; i++) {
			r[i] = in.nextLong();
			h[i] = in.nextLong();
			l.add(r[i] * h[i]);
		}
		l.sort(Comparator.reverseOrder());

		long result = 0l;
		for (int i = 0; i < k - 1; i++) {
			result += 2 * l.get(i);
		}
		long min = l.get(k - 1);
		long maxRadius = 0l;
		for (int i = 0; i < n; i++) {
			if (r[i] * h[i] >= min) {
				maxRadius = Math.max(maxRadius, r[i]);
			}
		}
		min = l.get(k - 1);
		long bestResult = 0l;
		long tmp;
		for (int i = 0; i < n; i++) {
			if (r[i] * h[i] <= min) {
				if (r[i] > maxRadius) {
					tmp = 2 * r[i] * h[i] + r[i] * r[i] - maxRadius * maxRadius;
				} else {
					tmp = 2 * r[i] * h[i];
				}
				bestResult = Math.max(bestResult, tmp);
			}
		}
		result += bestResult + maxRadius * maxRadius;
		double resultD = Math.PI * result;
		out.println("Case #" + TEST + ": " + String.format("%.9f", resultD));
	}
}