import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Scanner;

public class Solution {

	public static void main(String[] args) throws IOException {
		Path path = new File("input.txt").toPath();
		Scanner in = new Scanner(Files.newBufferedReader(path, Charset.defaultCharset()));
		int t = in.nextInt(); // Scanner has functions to read ints, longs,
								// strings, chars, etc.

		PrintWriter out = new PrintWriter("output.txt", "UTF-8");
		Solve s = new Solve(in, out);
		for (int i = 1; i <= t; ++i) {
			s.solve(i);
		}
		in.close();
		out.close();
	}

}

class Solve {
	private Scanner in;
	private PrintWriter out;

	public Solve(Scanner in, PrintWriter out) {
		this.in = in;
		this.out = out;
	}

	public void solve(int t) {
		
		String s = in.next();
		boolean[] b = new boolean[s.length()];
		boolean[] bb = new boolean[s.length()+1];
		for (int i = 0; i < s.length(); i++) {
			if (s.charAt(i) == '+') {
				b[i] = true;
			}
		}
		int k = in.nextInt();
		boolean good = true;
		boolean canChange = true;
		boolean changed = false;
		int count = 0;
		for (int i = 0; i < s.length(); i++) {
			if (s.length() - i < k) {
				canChange = false;
			}
			if (bb[i]) {
				changed = !changed;
			}
			if (!(b[i] ^ changed)){
				if (!canChange) {
					good = false;
					break;
				}else {
					changed = !changed;
					bb[i+k] = true;
					count++;
				}
			}
		}
		if (good) {
		out.println("Case #" + t + ": " + count );
		} else {
			out.println("Case #" + t + ": " + "IMPOSSIBLE" );
			
		}
	}

}
