import java.io.*;
import java.util.StringTokenizer;

/**
 * Created by daria on 11.04.15.
 */
public class A {
    public static class FastScanner {
        private BufferedReader reader;
        private StringTokenizer tokenizer;
        public boolean hasMoreTokens() throws IOException{
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                String s = nextLine();
                if (s == null) return false;
                tokenizer = new StringTokenizer(s);
            }
            return true;
        }
        FastScanner(InputStream inputStream) {
            reader = new BufferedReader(new InputStreamReader(inputStream));
        }

        public String nextLine() throws IOException {
            StringBuilder sb = new StringBuilder();
            while (tokenizer != null && tokenizer.hasMoreTokens()) {
                sb.append(" ");
                sb.append(tokenizer.nextToken());
            }
            if (sb.length() == 0) {
                return reader.readLine();
            }
            return sb.toString();
        }


        public String next() throws IOException {
            while (tokenizer == null || !tokenizer.hasMoreTokens())
                tokenizer = new StringTokenizer(nextLine());
            return tokenizer.nextToken();
        }

        public int nextInt() throws NumberFormatException, IOException {
            return Integer.parseInt(next());
        }
        public long nextLong() throws NumberFormatException, IOException {
            return Long.parseLong(next());
        }


        public double nextDouble() throws NumberFormatException, IOException {
            return Double.parseDouble(next());
        }

    }

    FastScanner in;
    PrintWriter out;

    public void solve() throws IOException {
        int n = in.nextInt();
        for (int i = 0; i < n; i++) {
            int max = in.nextInt();
            String str = in.next();
            int ans = 0;
            int guarantee = 0;

            guarantee += str.charAt(0) - '0';

            for (int j = 1; j <= max; j++) {
                if (j > guarantee) {
                    ans += j - guarantee;
                    guarantee += j - guarantee;
                }
                guarantee += (str.charAt(j) - '0');
            }

            out.println("Case #" + (i+1) + ": " + ans);
        }
    }

    public void run() {
        try {
            in = new FastScanner(new FileInputStream(new File("A-small-attempt0" + ".in")));
            out = new PrintWriter("a" + ".out");

            solve();

            out.flush();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new A().run();
    }
}