/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package round22015;

/**
 *
 * @author Andrii
 */
import qr2015.*;
import java.util.NavigableSet;
import java.io.BufferedWriter;
import java.util.InputMismatchException;
import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.math.BigInteger;
import java.io.OutputStream;
import java.util.Collections;
import java.io.PrintWriter;
import java.io.Writer;
import java.io.IOException;
import java.io.FileInputStream;
import java.util.TreeSet;
import java.io.InputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.OutputStreamWriter;
import java.util.Comparator;
import java.io.FileOutputStream;
import java.util.SortedSet;
import java.io.File;
import java.util.Set;

public class ProblemA {

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "A-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified()) {
                    toRun = candidate;
                }
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("a.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        OutputWriter out = new OutputWriter(outputStream);
        TaskA solver = new TaskA();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++) {
            solver.solve(i, in, out);
        }
        out.close();
    }
}

class TaskA {
    
    int R, C;
    int[][] table;
    int[] dx = new int[]{0, 0, 1, 0, -1};
    int[] dy = new int[]{0, -1, 0, 1, 0};
    int lastX, lastY;
    int bX, bY;
    
    private int convert(char ch) {
        switch(ch) {
            case '.': return 0;
            case '^': return 1;
            case '>': return 2;
            case 'v': return 3;
            case '<': return 4;
            default: return -1;
        }
    }
    
    private boolean isSafe(int y, int x) {
        boolean visited[][] = new boolean[R][C];
        bX = -1;
        bY = -1;
        lastX = x;
        lastY = y;
        visited[y][x] = true;
        int newY = y + dy[table[lastY][lastX]];
        int newX = x + dx[table[lastY][lastX]];
        while(newY >= 0 && newY < R && newX >=0 && newX < C && !visited[newY][newX]) {
            if (table[newY][newX] != 0) {
                bX = lastX;
                bY = lastY;
                lastX = newX;
                lastY = newY;
                visited[newY][newX] = true;
            }
            newY += dy[table[lastY][lastX]];
            newX +=dx[table[lastY][lastX]];
        }
        if (newY >= 0 && newY < R && newX >=0 && newX < C)
            return true;
        return false;
    }

    public void solve(int testNumber, InputReader in, OutputWriter out) {
        R = in.readInt();
        C = in.readInt();
        table = new int[R][C];
        for(int y = 0; y < R; y++) {
            String s = in.readString();
            for(int x = 0; x < C; x++) {
                table[y][x] = convert(s.charAt(x));
            }
        }
        
        int res = 0;
        for(int y = 0; y < R; y++) {
            label: for (int x = 0; x < C; x++) {
                if (table[y][x] == 0 || isSafe(y, x)) continue;
                if (bX == -1) {
                    for(int i = 1; i <= 4; i++) {
                        lastX = x + dx[i];
                        lastY = y + dy[i];
                        while(lastY >= 0 && lastY < R && lastX >=0 && lastX < C && table[lastY][lastX] == 0) {
                            lastX+=dx[i];
                            lastY+=dy[i];
                        }
                        if (lastY >= 0 && lastY < R && lastX >=0 && lastX < C)
                        {
                            table[y][x] = i;
                            res++;
                            continue label;
                        }
                    }
                    out.printLine("Case #" + testNumber + ":", "IMPOSSIBLE");
                    return;
                } else {
                    if (bX == lastX) {
                        table[lastY][lastX] = bY > lastY ? 3 : 1;
                        res++;
                    } else {
                        table[lastY][lastX] = bX > lastX ? 2 : 4;
                        res++;
                    }
                }
            }
        }
        out.printLine("Case #" + testNumber + ":", res == -1 ? "IMPOSSIBLE" : res);
    }
}
