import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;

public class ProblemA {

	public static void main(String[] args) throws IOException {
		OversizedPancakeFlipper opf = new OversizedPancakeFlipper();
		opf.solve();
	}

}

class OversizedPancakeFlipper {
	
	OversizedPancakeFlipper() throws IOException {
		in = new FScanner("input.txt");
		t = in.nextInt();
		out = new FPrinter("output.txt");
	}
	
	void analyzeTest(int tc) throws IOException {
		s = in.next();
		k = in.nextInt();
		
		char[] pm = s.toCharArray();
		int len = pm.length;
		
		boolean all = true;
		int ans = 0;
		for (int i = 0; i < len; i++) {
			if (pm[i] == '-') {
				if (len - i < k){
					all = false;
					break;
				}
				ans++;
				for (int j = 0; j < k; j++){
					if (pm[i+j] == '-'){
						pm[i+j] = '+';
					}
					else { // pm[i+j] == '+' 
						pm[i+j] = '-';
					}
				}					
			}
		}
		
		if (!all) {
			out.printlnCase(tc, "IMPOSSIBLE");
		}
		else {
			out.printlnCase(tc, ans);
		}
		
	}
	
	void solve() throws IOException {
		for (int tc = 1; tc <= t; tc++){
			analyzeTest(tc);
		}
		out.fclose();
	}
	
	int t;
	int k;
	String s;
	
	FScanner in;
	FPrinter out;
}

class FScanner {
	
	FScanner(String inputfile) throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader(inputfile)));
		in.ordinaryChar('-');
		in.ordinaryChar('+');
		in.wordChars('-', '-');
		in.wordChars('+', '+');
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	double nextDouble() throws IOException {
		in.nextToken();
		return in.nval;
	}
	
	String next() throws IOException {
		in.nextToken();
		return in.sval;
	}

	StreamTokenizer in;
}

class FPrinter {
	
	FPrinter(String outputfile) throws IOException {
		out = new PrintWriter(outputfile);
	}
	
	void printCase(int tc) throws IOException {
		out.print("Case #");
		out.print(tc);
		out.print(": ");
	}
	
	void printlnCase(int tc, String ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}
	
	void printlnCase(int tc, long ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}	
	
	void fclose() {
		out.flush();
		out.close();
	}
	
	PrintWriter out;
}
