import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.ArrayList;
import java.util.Collections;


public class B_qual {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException {
		Lawnmower lawnmower = new Lawnmower();
		lawnmower.solve();
	}

}


class Lawnmower {
	
	Lawnmower() throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader("input.txt")));
		out = new PrintWriter("output.txt");
		t = nextInt();		
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	
	class Cell implements Comparable<Cell>{
		
		Cell (int r, int c, int h) {
			this.r = r;
			this.c = c;
			this.h = h;
		}
		
		public int compareTo(Cell cell){
			if (h < cell.h) return -1;
			if (h > cell.h) return 1;
			if (r < cell.r) return -1;
			if (r > cell.r) return 1;
			if (r < cell.c) return -1;
			if (r > cell.c) return 1;
			return 0;
		}
		
		int r;
		int c;
		int h;
	}
	
	void readTest() throws IOException {
		n = nextInt();
		m = nextInt();
		
		lawn = new int[n][m];
		alawn = new ArrayList<Cell>();
		
		int h;
		for (int i = 0; i < n; i++){
			for (int j = 0; j < m; j++){
				h = nextInt();
				lawn[i][j] = h;
				alawn.add(new Cell(i, j, h));
			}
		}
		
		Collections.shuffle(alawn);
		Collections.sort(alawn);		
	}
	
	
	String analizeTest() {
		boolean [] rused = new boolean[n];
		boolean [] cused = new boolean[m];
		
		int checksum;
		int amount;
		boolean rr;
		boolean cc;
		
		boolean ans = true;
		
		for (Cell cell: alawn) {
			if (!rused[cell.r] && !cused[cell.c]){
				checksum = 0;
				amount = 0;
				rr = cc = false;
				
				for (int j = 0; j < m; j++){
					if (!cused[j]){
						checksum += lawn[cell.r][j];
						amount++;
					}
				}
				
				if (checksum == cell.h * amount) {
					rused[cell.r] = true;
					rr = true;
				}

				checksum = 0;
				amount = 0;

				for (int i = 0; i < n; i++){
					if (!rused[i]) {
						checksum += lawn[i][cell.c];
						amount++;
					}
				}
				
				if (checksum == cell.h * amount) {
					cused[cell.c] = true;
					cc = true;
				}
				
				ans = rr || cc;
				if (!ans) 
					break;
			}
		}
		
		return (ans? "YES" : "NO");
		
	}
	
	void solve() throws IOException {
		String res;
		for (int k = 1; k <= t; k++){
			readTest();
			res = analizeTest();
			out.print("Case #");
			out.print(k);
			out.print(": ");
			out.println(res);
		}
		
		out.flush();
		out.close();
	}
	
	
	int n;
	int m;
	int[][] lawn;
	ArrayList<Cell> alawn;
	
	StreamTokenizer in;
	PrintWriter out;
	int t;
}