import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.ArrayList;


public class A {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException {
		CNames cn = new CNames(); 
		cn.solve();
	}

}


class CNames {
	
	class Pair {
		
		Pair(int l, int r){
			left = l;
			right = r;
		}
		
		public String toString() {
			return "[" + left + ":" + right +"]";
		}
		
		int left;
		int right;
	}
	
	CNames () throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader("input.txt")));
		out = new PrintWriter("output.txt");
		in.nextToken();
		T = (int)in.nval;
		consonant = new boolean[26];
		for (int i = 0; i < 26; i++){
			consonant[i] = true;
		}
				
		consonant[(int)'a' - a] = consonant[(int)'e' - a] = consonant[(int)'i' - a] = consonant[(int)'o' - a] = consonant[(int)'u' - a] = false;
	}
	
	long analyzeTest() throws IOException {
		in.nextToken();
		String s = in.sval;
		char[] name = s.toCharArray();
		int len = name.length;
		in.nextToken();
		int n = (int)in.nval;
		ArrayList<Pair> alp = new ArrayList<>();
		
		if (n == 0){
			long res = 0L; 
			for (int i = 1; i <= len; i++){
				res = res + i;
			}
			return res;
		}
		
		// n == 0 - 
		
		// search n consonants
		
		int sp = 0;

		while ((sp + n - 1) < len) {
			for (; ((sp < len) && (!consonant[name[sp] - a])); sp++); 
		
			int k = 1;
			int idx = sp+1;
			while ((idx < len) && (consonant[name[idx] - a]) && (k < n)) {
				k++;
				idx++;
			}
		
			if (k == n) {
				alp.add(new Pair(sp, idx-1));
			}
		
			//idx++;
			sp++;
			while ((idx < len) && (consonant[name[idx] - a])) {
				alp.add(new Pair(sp, idx));
				sp++;
				idx++;
			}
		}
		
		long subs = 0L;
		int lb;
		long lv;
		long rv;
		
		int last = 0; 
		
		for (Pair p: alp){
			lb = p.left;
			lv = lb - last;
			if (lv < 0) {
				lv = 0;
			}
			rv = len - 1 - p.right;
			last = p.left + 1;
			subs = subs + lv + 1 + rv + lv*rv;
		}
		
		return subs;
		
	}
		
	void solve() throws IOException  {
		long res;
		for (int k = 0; k < T; k++){
			res = analyzeTest();
			out.print("Case #");
			out.print(k+1);
			out.print(": ");
			out.println(res);
		}
		
		out.flush();
		out.close();
	}
	

	
	boolean[] consonant;
	static final int a = (int)'a';
	
	int T; 
	StreamTokenizer in;
	PrintWriter out;
}