import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.ArrayDeque;


public class Qual2016_B_er {

	public static void main(String[] args) throws IOException {
		RevengePancakes rp = new RevengePancakes();
		rp.solve();
	}

}

class RevengePancakes {
	
	RevengePancakes() throws IOException {
		in = new FScanner("input.txt");
		out = new FPrinter("output.txt");
		t = in.nextInt();
		
	}
	
	void testCase(int tc) throws IOException {
		pc = in.next().toCharArray();
		int len = pc.length;
		
		ArrayDeque<Character> sq = new ArrayDeque<Character>();
		int idx = 0;
		sq.add(pc[idx]);
		idx++;
		while (idx < len){
			if (pc[idx] != sq.getLast()){
				sq.addLast(pc[idx]);
			}
			idx++;
		}
		
		int flip = 0;
		if (sq.pollFirst() == '-'){
			flip = 1;
		}
		
		while (!sq.isEmpty()){
			if (sq.pollFirst() == '-'){
				flip += 2; // + before to -, - - to +
			}
		}
		
		out.printlnCase(tc, flip);
		
	}
	
	void solve() throws IOException {
		for (int i = 1; i <= t; i++){
			testCase(i);
		}
		out.fclose();
	}
	
	char[] pc;
	
	int t;
	
	FScanner in;
	FPrinter out;
}



class FScanner {
	
	FScanner(String inputfile) throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader(inputfile)));
		in.ordinaryChar('-');
		in.ordinaryChar('+');
		in.wordChars('-', '-');
		in.wordChars('+', '+');
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	double nextDouble() throws IOException {
		in.nextToken();
		return in.nval;
	}
	
	String next() throws IOException {
		in.nextToken();
		return in.sval;
	}

	StreamTokenizer in;
}

class FPrinter {
	
	FPrinter(String outputfile) throws IOException {
		out = new PrintWriter(outputfile);
	}
	
	void printCase(int tc) throws IOException {
		out.print("Case #");
		out.print(tc);
		out.print(": ");
	}
	
	void printlnCase(int tc, String ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}
	
	void printlnCase(int tc, long ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}	
	
	void fclose() {
		out.flush();
		out.close();
	}
	
	PrintWriter out;
}
