import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.ArrayList;
import java.util.Collections;


public class D_small {

	public static void main(String[] args) throws IOException {
		DeceitfulWarS dws = new DeceitfulWarS();
		dws.solve();
	}

}

class DeceitfulWarS {
	
	DeceitfulWarS() throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader("input.txt")));
		
		t = nextInt();
		out = new PrintWriter("output.txt");
		
		naomi = new ArrayList<>();
		ken = new ArrayList<>();
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	double nextDouble() throws IOException {
		in.nextToken();
		return in.nval;
	}
	
	void prepareTest() throws IOException {
		n = nextInt();
		
		ken.clear();
		naomi.clear();

		for (int i = 0; i < n; i++){
			naomi.add((int)(nextDouble() * MIL));
		}
		
		Collections.sort(naomi);
				
		for (int i = 0; i < n; i++){
			ken.add((int)(nextDouble() * MIL));
		}
		
		Collections.sort(ken);		
	}
	
	void analyzeTest(int tc) throws IOException {
		
		prepareTest();
		
		// war game
		
		wscore = 0;
		
		int i = 0;
		int j = 0;
		
		int ksc = 0;
		
		while ((i < n) && (j < n)){
			if (naomi.get(i) < ken.get(j)){
				ksc++;
				i++;
				j++;
			}
			else { // >, nothing ==
				j++;
			}
		}
		
		wscore = n - ksc;
		
		// deceitful war game
		
		dwscore = 0;
		
		i = 0;
		j = 0;
		int hb = n;
		
		ksc = 0;
		
		while ((i < n) && (j < hb)){
			if (naomi.get(i) < ken.get(j)){
				ksc++;
				i++;
				hb--;
			}
			else {
				dwscore++;
				i++;
				j++;
			}
		}
		
		//dwscore = n - ksc;
		
		print(tc);
		
	}
	
	void print(int tc) {
		out.print("Case #");
		out.print(tc);
		out.print(": ");
		out.print(dwscore);
		out.print(" ");
		out.println(wscore);
	}
	
	void solve() throws IOException {
		for (int i = 1; i <= t; i++){
			analyzeTest(i);
		}
		
		out.flush();
		out.close();
	}
	
	int wscore;
	int dwscore;
	
	int n;
	ArrayList<Integer> ken;
	ArrayList<Integer> naomi;
	
	int t;
	StreamTokenizer in;
	PrintWriter out;
	
	static final int MIL = 1000000;
}
