import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;


public class ProblemA {

	public static void main(String[] args) throws IOException {
		Brattleship bs = new Brattleship();
		bs.solve();
	}

}

class Brattleship {
	
	Brattleship() throws IOException {
		in = new FScanner("input.txt");
		out = new FPrinter("output.txt");
		t = in.nextInt();
	}
	
	void testCase(int tc) throws IOException {
		r = in.nextInt();
		c = in.nextInt();
		w = in.nextInt();
		
		score = 0;
		score = (r-1) * (c/w);
		
		// last row
		int add = c/w; // and last step into sheep
		// w-1 cell on left, c % w cell on right 
		int d = c % w;
		
		score = score + add; 
		if (d != 0) {
			score = score + w;
		}
		else {
			score = score + (w-1);
		}
		
		out.printlnCase(tc, score);
	}
	
	void solve() throws IOException {
		for (int i = 1; i <= t; i++){
			testCase(i);
		}
		out.fclose();
	}
	
	FScanner in;
	FPrinter out;
	
	int t;
	int r;
	int c;
	int w;
	
	int score;
}

class FScanner {
	
	FScanner(String inputfile) throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader(inputfile)));
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	double nextDouble() throws IOException {
		in.nextToken();
		return in.nval;
	}
	
	String next() throws IOException {
		in.nextToken();
		return in.sval;
	}

	StreamTokenizer in;
}

class FPrinter {
	
	FPrinter(String outputfile) throws IOException {
		out = new PrintWriter(outputfile);
	}
	
	void printCase(int tc) throws IOException {
		out.print("Case #");
		out.print(tc);
		out.print(": ");
	}
	
	void printlnCase(int tc, String ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}
	
	void printlnCase(int tc, long ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}	
	
	void fclose() {
		out.flush();
		out.close();
	}
	
	PrintWriter out;
}
