import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;


public class Qual2016_D_s_er {

	public static void main(String[] args) throws IOException {
		Fractiles fs = new Fractiles(); 
		fs.solve();
	}

}

class Fractiles {
	
	Fractiles() throws IOException {
		in = new FScanner("input.txt");
		out = new FPrinter("output.txt");
		t = in.nextInt();
	}
	
	void testCase (int tc) throws IOException {
		int k = in.nextInt();
		int c = in.nextInt();
		int s = in.nextInt();
		
		if (((c == 1) && (s < k)) || ((c > 1) && (s < k-1))) {
			out.printlnCase(tc, " IMPOSSIBLE");
		}
		else {
			out.printCase(tc);
			for (int j = 1; j <= k; j++){
				out.printWS(j);
			}
			out.println();
		}
	}
	
	void solve() throws IOException {
		for (int i = 1; i <= t; i++){
			testCase(i);
		}
		out.fclose();
	}
	
	int t;
	
	FScanner in;
	FPrinter out;
}


class FScanner {
	
	FScanner(String inputfile) throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader(inputfile)));
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	double nextDouble() throws IOException {
		in.nextToken();
		return in.nval;
	}
	
	String next() throws IOException {
		in.nextToken();
		return in.sval;
	}

	StreamTokenizer in;
}

class FPrinter {
	
	FPrinter(String outputfile) throws IOException {
		out = new PrintWriter(outputfile);
	}
	
	void printWS(int aj) throws IOException {
		out.print(" ");
		out.print(aj);
	}
	
	void println() throws IOException {
		out.println();
	}
	
	void printCase(int tc) throws IOException {
		out.print("Case #");
		out.print(tc);
		out.print(":");
	}
	
	void printlnCase(int tc, String ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}
	
	void printlnCase(int tc, long ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}	
	
	void fclose() {
		out.flush();
		out.close();
	}
	
	PrintWriter out;
}
