import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.TreeSet;


public class Qual2016_A_er {

	public static void main(String[] args) throws IOException {
		CountingSheeps cs = new CountingSheeps();
		cs.solve();
	}

}

class CountingSheeps {
	
	CountingSheeps() throws IOException {
		in = new FScanner("input.txt");
		out = new FPrinter("output.txt");
		checkDigits = new TreeSet<Character>();
		t = in.nextInt();
	}
	
	void testCase(int tc) throws IOException {
		checkDigits.clear();
		int num = in.nextInt();
		if (num == 0) {
			out.printlnCase(tc, "INSOMNIA");
		}
		else {
			long z = 0;
			while (checkDigits.size() != 10){
				z = z + num; 
				dgs = Long.toString(z).toCharArray();
				for (char d: dgs){
					checkDigits.add(d);
				}
			}
			
			out.printlnCase(tc, z);
		}
	}
	
	void solve() throws IOException {
		for (int i = 1; i <= t; i++){
			testCase(i);
		}
		out.fclose();
	}
	
	TreeSet<Character> checkDigits;
	char[] dgs;
	
	int t;
	
	FScanner in;
	FPrinter out;
}

class FScanner {
	
	FScanner(String inputfile) throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader(inputfile)));
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	double nextDouble() throws IOException {
		in.nextToken();
		return in.nval;
	}
	
	String next() throws IOException {
		in.nextToken();
		return in.sval;
	}

	StreamTokenizer in;
}

class FPrinter {
	
	FPrinter(String outputfile) throws IOException {
		out = new PrintWriter(outputfile);
	}
	
	void printCase(int tc) throws IOException {
		out.print("Case #");
		out.print(tc);
		out.print(": ");
	}
	
	void printlnCase(int tc, String ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}
	
	void printlnCase(int tc, long ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}	
	
	void fclose() {
		out.flush();
		out.close();
	}
	
	PrintWriter out;
}

/*
class CountingSheepsCheck {
	
	void check2() {
		a = new boolean[1000001];
		TreeSet<Character> digs = new TreeSet<Character>();
		
		for (int i = 1; i <= 1000000; i++){
			digs.clear();
			for (int j = 1; j < maxSteps; j++){
				int num = (i * j);
				char[] dg = Integer.toString(num).toCharArray();
				for (char d: dg){
					digs.add(d);
				}
				if (digs.size() == 10) 
					break;
			}
			if (digs.size() != 10){
				a[i] = true;
			}
		}
		
		System.out.println("2 digits problem");
		for (int i = 0; i < 1000001; i++){
			if (a[i]) {
				System.out.println(i);
			}
		}
		System.out.println("All problems");
	}
	
	int checkD = 100;
	int maxSteps = 100;
	
	boolean[] a;
}
*/