import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.Scanner;

public class ProblemB {

	public static void main(String[] args) throws IOException {
		TidyNumbers tn = new TidyNumbers();
		tn.solve();
	}

}

class TidyNumbers {
	
	TidyNumbers() throws IOException {
		in = new Scanner(new BufferedReader(new FileReader("input.txt")));
		out = new FPrinter("output.txt");
		t = in.nextInt();
	}
	
	void analyzeTest(int tc) throws IOException {
		long n = in.nextLong();
		String sn = "0" + Long.toString(n);
		char[] num = sn.toCharArray();
		int len = num.length;
		
		int bnd = 0;
		for (int i = 1; i < len; i++){
			if (num[i] >= num[i-1]){
				bnd++;
			}
			else {
				break;
			}
		}
		
		if (bnd < (len-1)){
			int bnd2 = bnd;
			while (num[bnd2]==num[bnd]){
				bnd2--;
			}
			bnd2 = bnd2+1;
			num[bnd2]--;
			for (int j = bnd2 + 1; j < len; j++){
				num[j] = '9';
			}
		}
		
		long ans = Long.parseLong(String.copyValueOf(num));
		
		out.printlnCase(tc, ans);
	}
	
	void solve() throws IOException {
		for (int tc = 1; tc <= t; tc++){
			analyzeTest(tc);
		}
		in.close();
		out.fclose();
	}
	
	int t;
	
	Scanner in;
	FPrinter out;
}

class FScanner {
	
	FScanner(String inputfile) throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader(inputfile)));
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	double nextDouble() throws IOException {
		in.nextToken();
		return in.nval;
	}
	
	String next() throws IOException {
		in.nextToken();
		return in.sval;
	}

	StreamTokenizer in;
}

class FPrinter {
	
	FPrinter(String outputfile) throws IOException {
		out = new PrintWriter(outputfile);
	}
	
	void printCase(int tc) throws IOException {
		out.print("Case #");
		out.print(tc);
		out.print(": ");
	}
	
	void printlnCase(int tc, String ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}
	
	void printlnCase(int tc, long ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}	
	
	void fclose() {
		out.flush();
		out.close();
	}
	
	PrintWriter out;
}
