import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.ArrayList;
import java.util.Collections;

public class ProblemA {

	public static void main(String[] args) throws IOException {
		Horse h = new Horse();
		h.solve();
	}

}

class Horse {
	
	static class Pair implements Comparable<Pair>{
		Pair(int k, int s){
			this.dk = k;
			this.s = s;
		}
		
		public int compareTo(Pair p){
			if (dk < p.dk) return -1;
			if (dk > p.dk) return 1;
			if (s < p.s) return -1;
			if (s > p.s) return 1;
			return 0;
		}
		
		public String toString(){
			return dk +" " + s;
		}
		
		int dk;
		int s;
	}
	
	Horse() throws IOException {
		in = new FScanner("input.txt");
		t = in.nextInt();
		out = new FPrinter("output.txt");
	}
	
	void test(int tc) throws IOException {
		d = in.nextInt();
		n = in.nextInt();
		ap.clear();
		for (int i = 0; i < n; i++){
			int k = in.nextInt();
			int s = in.nextInt();
			ap.add(new Pair(d-k, s));
		}
		
		Collections.sort(ap);
		double time = 0;
		for (Pair p: ap){
			double ct = (1.0 * p.dk)/p.s;
			if (ct > time){
				time = ct;
			}
		}
		
		double v = (d*1.0)/time;
		out.printlnCase(tc, v);
	}

	void solve() throws IOException {
		ap = new ArrayList<>();
		for (int tc = 1; tc <= t; tc++){
			test(tc);
		}
		
		out.fclose();
	}
	
	int t;
	int n;
	
	int d;
	ArrayList<Pair> ap;
	
	FScanner in;
	FPrinter out;
	
	static double EPS = 1E-9;
}

class FScanner {
	
	FScanner(String inputfile) throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader(inputfile)));
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	double nextDouble() throws IOException {
		in.nextToken();
		return in.nval;
	}
	
	String next() throws IOException {
		in.nextToken();
		return in.sval;
	}

	StreamTokenizer in;
}

class FPrinter {
	
	FPrinter(String outputfile) throws IOException {
		out = new PrintWriter(outputfile);
	}
	
	void printCase(int tc) throws IOException {
		out.print("Case #");
		out.print(tc);
		out.print(": ");
	}
	
	void printlnCase(int tc, String ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}
	
	void printlnCase(int tc, long ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}	
	
	void printlnCase(int tc, double ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}	
	
	void fclose() {
		out.flush();
		out.close();
	}
	
	PrintWriter out;
}
