import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.Scanner;


public class QA_2015_er {

	public static void main(String[] args) throws IOException {
		Ovation ovation = new Ovation();
		ovation.solve();
	}

}

class Ovation {
	
	Ovation() throws IOException {
		in = new Scanner(new BufferedReader(new FileReader("input.txt")));
		out = new FPrinter("output.txt");
		t = in.nextInt();
	}
	
	void testCase(int tc) throws IOException {
		smax = in.nextInt();
		up = 0;
		ans = 0; 
		friends = 0;
		
		char[] shyness = in.next().toCharArray();
		int len = shyness.length;
		for (int level = 0; level < len; level++){
			if ((up < level) && (shyness[level] != ZERO)) {
				friends = level - up;
				up = up + friends;
				ans = ans + friends;
			}
			up = up + (shyness[level] - ZERO);
		}
		
		out.printlnCase(tc, ans);
	}
	
	void solve() throws IOException {
		for (int i = 1; i <= t; i++){
			testCase(i);
		}
		
		out.fclose();
	}
	
	Scanner in;
	FPrinter out;
	
	int ans;
	int friends;
	int smax;
	int up; 
	
	int t;
	
	static final char ZERO = '0';
}


class FScanner {
	
	FScanner(String inputfile) throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader(inputfile)));
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	double nextDouble() throws IOException {
		in.nextToken();
		return in.nval;
	}
	
	String next() throws IOException {
		in.nextToken();
		return in.sval;
	}

	StreamTokenizer in;
}

class FPrinter {
	
	FPrinter(String outputfile) throws IOException {
		out = new PrintWriter(outputfile);
	}
	
	void printCase(int tc) throws IOException {
		out.print("Case #");
		out.print(tc);
		out.print(": ");
	}
	
	void printlnCase(int tc, String ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}
	
	void printlnCase(int tc, long ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}	
	
	void fclose() {
		out.flush();
		out.close();
	}
	
	PrintWriter out;
}
