import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;

public class QB_2015_er {

	public static void main(String[] args) throws IOException {
		Pancakes pancakes = new Pancakes();
		pancakes.precalc();
		pancakes.solve();
	}

}

class Pancakes {

	Pancakes() throws IOException {
		in = new FScanner("input.txt");
		out = new FPrinter("output.txt");
		t = in.nextInt();
		p = new int[PMAX+1];
	}

	void precalc() {
		onePile = new int[PMAX+1][PMAX+1];
		for (int pc = 1; pc <= PMAX; pc++){
			for (int k = 1; k <= PMAX; k++){
				onePile[pc][k] = (((pc/k) + ((pc % k == 0)? 0: 1)) - 1); 
			}
		}
	}
	
	void testCase(int tc) throws IOException {
		int d = in.nextInt();		
		int[] diner = new int[d];
		for (int i = 0; i < d; i++){
			diner[i] = in.nextInt();
		}
		
		int[] time = new int[PMAX+1];
		
		for (int tm = 1; tm <= PMAX; tm++){
			for (int i = 0; i < d; i++){
				time[tm] = time[tm] + onePile[diner[i]][tm]; 
			}
			time[tm] += tm;
		}
		
		int bestTime = 2*PMAX;
		for (int tm = 1; tm <= PMAX; tm++){
			if (time[tm] < bestTime) {
				bestTime = time[tm];
			}
		}
		
		out.printlnCase(tc, bestTime);
	}
	
	void solve() throws IOException {
		for (int i = 1; i <= t; i++) {
			testCase(i);
		}
		
		out.fclose();
	}
	
	int[][] onePile;

	int[] p;
	int t;	
	
	FScanner in;
	FPrinter out;
	
	static final int PMAX = 1000; 
}

class FScanner {
	
	FScanner(String inputfile) throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader(inputfile)));
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	double nextDouble() throws IOException {
		in.nextToken();
		return in.nval;
	}
	
	String next() throws IOException {
		in.nextToken();
		return in.sval;
	}

	StreamTokenizer in;
}

class FPrinter {
	
	FPrinter(String outputfile) throws IOException {
		out = new PrintWriter(outputfile);
	}
	
	void printCase(int tc) throws IOException {
		out.print("Case #");
		out.print(tc);
		out.print(": ");
	}
	
	void printlnCase(int tc, String ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}
	
	void printlnCase(int tc, long ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}	
	
	void fclose() {
		out.flush();
		out.close();
	}
	
	PrintWriter out;
}
