import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;

public class Asmall {

	public static void main(String[] args) throws IOException {
		VidaElf ve = new VidaElf();
		ve.solve();
	}

}

class VidaElf {
	
	VidaElf() throws IOException {
		in = new FScanner("input.txt");
		T = in.nextInt();
		in.in.whitespaceChars('/', '/');
		in.in.ordinaryChars('0', '9');
		in.in.wordChars('0', '9');
	}
	
	long gcd(long a, long b){
		long res;
		while ((a != 0) && (b != 0)) {
			if (a > b){
				a = a % b;
			}
			else {
				b = b % a;
			}
		}
		
		if (a != 0){
			res = a;
		}
		else {
			res = b;
		}
		
		return res;
	}
	
	boolean checkDenom(long d){
		boolean res = true;
		while ((d > 1) && (d % 2 == 0)){
			d = d/2;
		}
		res = !(d > 1);
		return res;
	}
	
	void analyzeTestcase(int tc) throws IOException  {
		String nnom = in.next();
		long nom = Long.parseLong(nnom);
		String dnom = in.next();
		long denom = Long.parseLong(dnom);
		
		long g = gcd(nom, denom);
		nom = nom/g;
		denom = denom/g;
		
		if (!checkDenom(denom)){
			ans = "impossible";
			return;
		}
		
		int depth = 0;
		while (nom < denom){
			denom = denom/2;
			depth++;
		}
		
		ans = "" + depth;
		
	}
	
	void solve() throws IOException  {
		FPrinter out = new FPrinter("output.txt");
		
		for (int tc = 1; tc <= T; tc++){
			analyzeTestcase(tc);
			out.printlnCase(tc, ans);
		}
		
		out.fclose();
	}
	
	String ans;
	FScanner in;
	int T;
}

class FScanner {
	
	FScanner(String inputfile) throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader(inputfile)));
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	double nextDouble() throws IOException {
		in.nextToken();
		return in.nval;
	}
	
	String next() throws IOException {
		in.nextToken();
		return in.sval;
	}
	
	StreamTokenizer in;
}

class FPrinter {
	
	FPrinter(String outputfile) throws IOException {
		out = new PrintWriter(outputfile);
	}
	
	void printCase(int tc) throws IOException {
		out.print("Case #");
		out.print(tc);
		out.print(": ");
	}
	
	void printlnCase(int tc, String ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}
	
	void fclose() {
		out.flush();
		out.close();
	}
	
	PrintWriter out;
}
