import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;


public class ProblemC {

	public static void main(String[] args) throws IOException {
		Queen queen = new Queen();
		queen.solve();
	}

}

class Queen {
	
	Queen() throws IOException {
		in = new FScanner("input.txt");
		t = in.nextInt();
		denom = new int[MAXD];
		out = new FPrinter("output.txt");
	}
	
	void testCase(int tc) throws IOException {
		c = in.nextInt();
		d = in.nextInt();
		v = in.nextInt();
		
		for (int i = 0; i < d; i++){
			denom[i] = in.nextInt();
		}
		
		cnt = 0;
		
		int maxVal = 0;
		int newNom;		
		int i = 0;
		
		while ((i < d) && (maxVal < v)) {
			
			if (maxVal < (denom[i] - 1)) {
				newNom = maxVal+1;
				cnt++;
				maxVal = c * newNom + maxVal;
			}
			else {
				maxVal = c * denom[i] + maxVal;
				i++;
			}			
		}
		
		while (maxVal < v) {
			newNom = maxVal+1;
			cnt++;
			maxVal = c * newNom + maxVal;
		}
		
		out.printlnCase(tc, cnt);
	}
	
	void solve() throws IOException {
		for (int i = 1; i <= t; i++){
			testCase(i);
		}
		out.fclose();
	}
	
	FScanner in;
	FPrinter out;
	
	int cnt;
	
	int t;
	int c;
	int d;
	int v;
	int[] denom;
	
	static final int MAXD = 100;
}

class FScanner {
	
	FScanner(String inputfile) throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader(inputfile)));
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	double nextDouble() throws IOException {
		in.nextToken();
		return in.nval;
	}
	
	String next() throws IOException {
		in.nextToken();
		return in.sval;
	}

	StreamTokenizer in;
}

class FPrinter {
	
	FPrinter(String outputfile) throws IOException {
		out = new PrintWriter(outputfile);
	}
	
	void printCase(int tc) throws IOException {
		out.print("Case #");
		out.print(tc);
		out.print(": ");
	}
	
	void printlnCase(int tc, String ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}
	
	void printlnCase(int tc, long ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}	
	
	void fclose() {
		out.flush();
		out.close();
	}
	
	PrintWriter out;
}
