import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.Scanner;

public class ProblemC {

	public static void main(String[] args) throws IOException {
		BathroomStalls bs = new BathroomStalls();
		bs.solve();
	}

}

class BathroomStalls {
	
	BathroomStalls() throws IOException {
		in = new Scanner(new BufferedReader(new FileReader("input.txt")));
		out = new FPrinter("output.txt");
		t = in.nextInt();
	}
	
	void analyzeTest(int tc) throws IOException {
		n = in.nextLong();
		k = in.nextLong();
		
		long even = 0;
		long odd = 0;

		long esize = 0;
		long osize = 0;

		
		if (n % 2 == 0) {
			even = 1;
			esize = n;
		}
		else {
			odd = 1;
			osize = n;
		}
						
		long remk = k;
		
		long nextPart = even + odd;
		
		long neven;
		long nodd;
		
		long tosize = 0;
		long nosize = 0;
		
		while (remk > nextPart) {
			remk = remk - nextPart;
			
			neven = 0;
			nodd = 0;
			
			nosize = 0;
					
			if (even > 0) {
				
				esize = esize - 1;
				tosize = esize / 2;
				
				if (tosize % 2 == 0) {
					nosize = esize - tosize;
					esize = tosize;
				}
				else {
					nosize = tosize;
					esize = esize - nosize;
				}
				
				if (esize > 0) {
					neven = even;
				}
				if (nosize > 0) {
					nodd = even;
				}
			}
			
			if (odd > 0) {
				
				osize = osize - 1;
				tosize = osize / 2;
				if (tosize % 2 == 0){
					
//					if ((esize != 0) && (tosize != esize)) {
//						System.err.println("Fail Logic");
//					}
					
					esize = tosize;
					if (esize > 0) {
						neven = neven + 2 * odd;
					}
					if (nosize > 0){
						osize = nosize;						
					}
					
				}
				else { // if tosize % 2 != 0

//					if ((nosize != 0) && (nosize != tosize)) {
//						System.err.println("Fail Logic");
//					}
					
					osize = tosize;
					if (osize > 0) {
						nodd = nodd + 2 * odd;
					}
				}
								
			}
			
			else {
				osize = nosize;
			}
						
			even = neven;
			odd = nodd;
			nextPart = even + odd;

		}
		
		// now remk <= nextPart
			
		long small = osize;
		long cntsmall = odd;
			
		long big = esize;
		long cntbig = even;
		
		if (cntsmall == 0) {
			small = big;
		}
		if (cntbig == 0){
			big = small;
		}
			
		if (small > big) {
			big = osize;
			cntbig = odd;
			small = esize;
			cntsmall = even;
		}
			
		if (remk <= cntbig){
			big = big - 1;
			long a = big / 2;
			long b = big - a;
			maxLR = Math.max(a, b);
			minLR = Math.min(a, b);
		}
		else {
			small = small - 1;
			long a = small / 2;
			long b = small - a;
			maxLR = Math.max(a, b);
			minLR = Math.min(a, b);
		}
			
		String ans = maxLR + " " + minLR;
		out.printlnCase(tc, ans);
		
	}
	
	void solve() throws IOException {
		for (int tc = 1; tc <= t; tc++){
			analyzeTest(tc);
		}
		
		in.close();
		out.fclose();
	}
	
	
	long maxLR;
	long minLR;
	
	int t;
	long n;
	long k;
	Scanner in;
	FPrinter out;
}


class FScanner {
	
	FScanner(String inputfile) throws IOException {
		in = new StreamTokenizer(new BufferedReader(new FileReader(inputfile)));
	}
	
	int nextInt() throws IOException {
		in.nextToken();
		return (int)in.nval;
	}
	
	double nextDouble() throws IOException {
		in.nextToken();
		return in.nval;
	}
	
	String next() throws IOException {
		in.nextToken();
		return in.sval;
	}

	StreamTokenizer in;
}

class FPrinter {
	
	FPrinter(String outputfile) throws IOException {
		out = new PrintWriter(outputfile);
	}
	
	void printCase(int tc) throws IOException {
		out.print("Case #");
		out.print(tc);
		out.print(": ");
	}
	
	void printlnCase(int tc, String ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}
	
	void printlnCase(int tc, long ans) throws IOException {
		printCase(tc);
		out.println(ans);
	}	
	
	void fclose() {
		out.flush();
		out.close();
	}
	
	PrintWriter out;
}
