import java.io.*;
import java.util.*;

class Entry implements Comparable
{
  String str;
  int n;
  Entry(String s, int m)
  {
   str=s;
   n=m;
  }

  public int compareTo(Object k)
  {
    int m = ((Entry)k).n;
    return(n-m);
  }
}

class SaveUniverse
{
    String s[], q[];

  SaveUniverse(String s[], String q[])
  {
    this.s = s;
    this.q = q;
  }
 
  Map<String, Integer> findFrequency(int pos)
  {
      Map<String, Integer> query = new HashMap<String, Integer>();
      Integer freq;
      for(int j=pos; j<q.length; j++)
      {
        freq = query.get(q[j]);
        if(freq==null)
           query.put(q[j], 1);
        else
           query.put(q[j], freq+1);
      }
      return query;
  }

  public static ArrayList<Entry> getSortedEntries(Map<String, Integer> mp)
  {
   Set<String> key_set = mp.keySet();
   List<Entry> alist = new ArrayList<Entry>();
   for(String s1: key_set)
   {
     Entry e1 = new Entry(s1, mp.get(s1));
     alist.add(e1);
   }
   Collections.sort(alist);
   return ((ArrayList<Entry>)alist); 
  }

  String findFarthest(int pos)
  {
   int farthest = 0;
   for(int i=0; i<s.length; i++)
   {
      boolean notFound = true;
      for(int j=pos; j<q.length; ++j)
      {
        if(s[i].equals(q[j]))
        {
          notFound = false;
          if(farthest < j) 
            farthest = j;
          break;
        }
      }
      if(notFound)
        return null;
   }
   return q[farthest];
  }

  public static void main(String args[])
  {
    if(args.length != 1)
    {
      System.out.println("Give input data file name as argument!");
      System.exit(0);
    }

    File f1 = null; 
    Scanner sc = null;
    try
    {
      f1 = new File(args[0]);
      sc = new Scanner(f1);
    }
    catch(Exception e)
    { 
      System.out.println("Problem with input file: " + e);
    }

    String s[], q[];
    int n_s, n_q;
    int i, j, n = sc.nextInt();
    for(i=0; i<n; i++)
    {
      n_s = sc.nextInt();
      sc.nextLine();
      s = new String[n_s];
      for(j=0; j<n_s; j++)
      {
        s[j]=sc.nextLine();
      }  
      n_q=sc.nextInt();
      q = new String[n_q];
      sc.nextLine();
      for(j=0; j<n_q; j++)
      {
        q[j]=sc.nextLine();
      }
      
      SaveUniverse ob = new SaveUniverse(s, q);
      int y;
      y=0; 
      j=0;
      String cur_engine = ob.findFarthest(0);
      //System.out.println(cur_engine);
      while(cur_engine != null)
      {
        if(q[j].equals(cur_engine))
        {
          y++;
          cur_engine = ob.findFarthest(j);
      //System.out.println(cur_engine);
        }
        j++;
      }
  
      System.out.println("Case #" + (i+1) + ": " + y);
    }
    sc.close();
  }
} 
