import java.io.*;
import java.util.*;

class Mytime implements Comparable<Mytime>
{
  int hh, mm;
  
  Mytime(int h, int m)
  {
   hh=h;
   mm=m;
  }

  Mytime(String v)
  {
    String t[];
    t = v.split(":");
    hh = Integer.parseInt(t[0]);
    mm = Integer.parseInt(t[1]);
  }

  public int compareTo(Mytime t2)
  {
    //Mytime t2 = (Mytime)k;
    if(hh == t2.hh && mm == t2.mm)
      return 0;
    if(hh != t2.hh)
      return(hh - t2.hh);
    else
      return(mm - t2.mm);
  }

  Mytime add(int minutes)
  {
    int m = mm + minutes;
    int h = hh;
    if(m > 59)
    {
      h = h + m/60;
      m = m%60;
    }
    return(new Mytime(h, m));
  }

  public String toString()
  {
    return("" + hh + ":" + mm);
  }  
}

class Train implements Comparable<Train>
{
  Mytime d, a;

  Train(Mytime aa, Mytime bb)
  {
    d=aa;
    a=bb;
  }

  public String toString()
  {
    return("" + a + " - " + d);
  }  

  public int compareTo(Train t2)
  {
    return(d.compareTo(t2.d));
  }
}

class TrainTT 
{
  public static void main(String args[])
  {
    if(args.length != 1)
    {
      System.out.println("Give input data file name as argument!");
      System.exit(0);
    }

    File f1 = null; 
    Scanner sc = null;
    try
    {
      f1 = new File(args[0]);
      sc = new Scanner(f1);
    }
    catch(Exception e)
    { 
      System.out.println("Problem with input file: " + e);
    }

    String s[], q[];
    int i, j, n = sc.nextInt();
    for(i=0; i<n; i++)
    {
      int T, NA, NB;
      T = sc.nextInt();
      NA = sc.nextInt();
      NB = sc.nextInt();
      Train trainA[] = new Train[NA];
      Train trainB[] = new Train[NB];
      Train trainA1[] = new Train[NA];
      Train trainB1[] = new Train[NB];
      ArrayList<Train> sortedA = new ArrayList<Train>();
      ArrayList<Train> sortedB = new ArrayList<Train>();
      ArrayList<Train> sortedA1 = new ArrayList<Train>();
      ArrayList<Train> sortedB1 = new ArrayList<Train>();

      for(j=0; j<NA; j++)
      {
        String temp1 = sc.next();
        Mytime a1 = new Mytime(temp1); 
        String temp2 = sc.next();
        Mytime d1 = new Mytime(temp2); 
        trainA[j] = new Train(a1, d1);
        trainA1[j] = new Train(d1, a1);
        sortedA.add(trainA[j]);
        sortedA1.add(trainA1[j]);
      }

      Collections.sort(sortedA);
      Collections.sort(sortedA1);
/*
      for(j=0; j<NA; j++)
      {
        System.out.println("Train at A #" + (j+1) + ": " + trainA[j]);
      }  
*/      
      for(j=0; j<NB; j++)
      {
        String temp1 = sc.next();
        Mytime a1 = new Mytime(temp1); 
        String temp2 = sc.next();
        Mytime d1 = new Mytime(temp2); 
        trainB[j] = new Train(a1, d1);
        trainB1[j] = new Train(d1, a1);
        sortedB.add(trainB[j]);
        sortedB1.add(trainB1[j]);
      }

      Collections.sort(sortedB);
      Collections.sort(sortedB1);
/*
      for(j=0; j<NB; j++)
      {
        System.out.println("Train at B #" + (j+1) + ": " + trainB[j]);
      }  
*/      
      int reqdA=NA, reqdB=NB;

      for(j=0; j<NA; j++)
      {
       if(sortedB1.size() == 0)
         break;
       if(reqdA == 0)
         break;
       Mytime t1 = (sortedB1.get(0)).d.add(T);
       Mytime t2 = (sortedA.get(j)).d;
       if(t1.compareTo(t2) <=  0)
       {
         sortedB1.remove(0);
         reqdA--;
       }
      }
  
      for(j=0; j<NB; j++)
      {
       if(sortedA1.size() == 0)
         break;
       if(reqdB == 0)
         break;
       Mytime t1 = (sortedA1.get(0)).d.add(T);
       Mytime t2 = (sortedB.get(j)).d;
       if(t1.compareTo(t2) <=  0)
       {
         sortedA1.remove(0);
         reqdB--;
       }
      }
  
      System.out.println("Case #" + (i+1) + ": " + reqdA + " " + reqdB);
    }
    sc.close();
  }
} 
