import java.util.*;
import java.io.File;

class Mycell
{
  static int totalcells;
  String name;
  int r, c;
  boolean sink;
  int alt;
  int nbasin;
  Mycell neighbors[] = new Mycell[4];
  Mycell toNeighbor;
  Mycell()
  {
   r=-1; c=-1;
  }
  Mycell(int row, int col, int alti)
  {
    r = row;
    c = col;
    alt = alti;
  }
  void setMycell(int row, int col, int alti)
  {
    r = row;
    c = col;
    alt = alti;
  }
  void setName(String s)
  { name = s; }
  void setNeighbors(Mycell n, Mycell w, Mycell e, Mycell s)
  {
    neighbors[0] = n;
    neighbors[1] = w;
    neighbors[2] = e;
    neighbors[3] = s;
    toNeighbor = null;
    int min=0, minalt;
    if(neighbors[0] == null)
      minalt = 20000;
    else
      minalt = neighbors[0].alt;
    for(int i=1; i<4; i++)
    { int tempalt;
      if(neighbors[i] == null)
        tempalt = 20000;
      else
        tempalt = neighbors[i].alt;

      if(tempalt < minalt)
      {
        min = i;
	minalt = neighbors[i].alt;
      }
    }
    if(minalt < alt)
      toNeighbor = neighbors[min];
    if(toNeighbor == null)
      sink = true;
    else
      sink = false;
  }

  int getR()
  { return r; }
  int getC()
  { return c; }
  int getAlt()
  { return alt; }
  boolean isSink()
  { return sink; }
}
class Watersheds 
{
  static void pr(String s)
  {
    System.out.println(s);
  }
  static void pr1(String s)
  {
    System.out.print(s + " ");
  }
  public static void main(String args[])
  {
    Scanner sc = null;
    File f1 = null;
    if(args.length == 0)
    {
      pr("Input file name not given.");
      System.exit(0);
    }
    try
    {
      f1 = new File(args[0]);
      sc = new Scanner(f1);
    }
    catch(Exception e)
    { 
      pr("Problem with input file opening.");
      System.exit(0);
    }
    int T = sc.nextInt();
    for(int i=0; i<T; i++)
    {
      int H = sc.nextInt();
      int W = sc.nextInt();
      Mycell x[][] = new Mycell[H][W];
      for(int j=0; j<H; j++)
        for(int k=0; k<W; k++)
	{
          int temp = sc.nextInt();
	  x[j][k] = new Mycell(j, k, temp);
	}
      for(int j=0; j<H; j++)
        for(int k=0; k<W; k++)
	{
	  Mycell n, w, e, s;
	  if(j == 0)
	   n = null;
	  else
	   n = x[j-1][k];
	  if(j == H-1)
	   s = null;
	  else
	   s = x[j+1][k];
	  if(k == 0)
	   w = null;
	  else
	   w = x[j][k-1];
	  if(k == W-1)
	   e = null;
	  else
	   e = x[j][k+1];
          //try
	  //{
	  x[j][k].setNeighbors(n, w, e, s);
	  //}
	  //catch(Exception e)
	  //{
          //  pr("k = " + k + " j = " + j) 
	  //}
	}
      int nb = 1;
      for(int j=0; j<H; j++)
      {
        for(int k=0; k<W; k++)
	{
          if(x[j][k].isSink())
	  {
            x[j][k].nbasin = nb;	
	    nb++;
	  }
	}
      }
      for(int j=0; j<H; j++)
      {
        for(int k=0; k<W; k++)
	{
	  Mycell temp = x[j][k];
	  while(temp.toNeighbor != null)
	  {
	    temp = temp.toNeighbor;
	  }
          x[j][k].nbasin = temp.nbasin;	
	}
      }
      char label = 'a';
      Map<Integer, Character> basin = new HashMap<Integer, Character>();
      for(int j=0; j<H; j++)
      {
        for(int k=0; k<W; k++)
	{
	  Character tempc = basin.get(x[j][k].nbasin);
	  if(tempc == null)
	  {
	    basin.put(x[j][k].nbasin, label);
	    x[j][k].name = "" + label;
	    label++;
	  }
	  else
	  {
	    x[j][k].name = "" + tempc;
	  }
	}
      }
      pr("Case #" + (i+1) + ": ");
      for(int j=0; j<H; j++)
      {
        for(int k=0; k<W; k++)
	{
	  pr1(x[j][k].name);
	}
	pr("");
      }
    }
/*
    pr1(" " + L);
    pr1(" " + D);
    pr(" " + N);
    char words[][] = new char[D][];
    for(int i=0; i<D; i++)
    {
      String temp = sc.next();
  //    pr(temp);
      words[i] = temp.toCharArray();
    }
    sc.nextLine();
    for(int i=0; i<N; i++)
    {
      String temp = sc.nextLine();
    //  pr(temp);
      StringBuffer temp1 = new StringBuffer();
      for(int j=0; j<temp.length(); j++)
      {
        if(temp.charAt(j) == '(')
	{
          //temp1.append(' ');
	  j++;
	  while(temp.charAt(j) != ')')
	  {
            temp1.append(temp.charAt(j));
            j++;
	  }
          temp1.append(' ');
	}
	else
          temp1.append("" + temp.charAt(j) + ' ');
      }
      String temp2 = (temp1.toString()).trim();
      String tokens[] = temp2.split(" ");
      //for(int j=0; j<tokens.length; j++)
      //  pr1(tokens[j]);
      //pr("  " + tokens.length);

      int ctr = 0;
      for(int j=0; j<D; j++)
      { boolean wordformed = true;
        for(int k=0; k<L; k++)
	{
	  if(!tokens[k].contains("" + words[j][k]))
	  {
	    wordformed = false;
	    break;
	  }
	}
	if(wordformed)
	  ctr++;
      }
      pr("Case #" + (i+1) + ": " + ctr);
    }
*/    
  }
}

