import java.util.Scanner;

public class Chess {

	static int board[][], maxBoard[];
	static int M, N;

	public static String fromBase10(int num, int base) {
		String s = "";
		do {
			int res = num % base;
			s = (char) (res < 10 ? ('0' + res) : ('A' + res - 10)) + s;
		} while ((num /= base) != 0);
		return s;
	}

	public static int toBase10(String s, int base) {
		int total = 0;
		for (int p = 0; p < s.length(); p++) {
			char digit = s.charAt(s.length() - p - 1);
			total += Character.getNumericValue(digit) * Math.pow(base, p);
		}
		return total;
	}

	public static int isChess(int X, int Y) {
		int SIZE = Math.min(maxBoard.length, Math.min(M - X, N - Y));

		for (int x = X; x < X + SIZE; x++)
			for (int y = Y; y < Y + SIZE; y++)
				if (board[x][y] < 0)
					SIZE = Math.max(x - X, y - Y);

		for (int size = 1; size <= SIZE; size++) {
			String s = "";
			for (int x = X; x < X + size; x++) {
				for (int y = Y; y < Y + size; y++)
					s += board[x][y] == 1 ? "1" : "0";
				if (size % 2 == 0)
					s += s.charAt(s.length()-1) == '0' ? '1' : '0';			}
			if (size % 2 == 0)
				s = s.substring(0, s.length()-1);
			if (s.charAt(0) == '0') {
				for (int i = 0; i < s.length(); i+=2)
					if (s.charAt(i) != '0'
							|| (i + 1 < s.length() && s.charAt(i + 1) != '1'))
						return size-1;
			} else {
				for (int i = 0; i < s.length(); i+=2)
					if (s.charAt(i) != '1'
							|| (i + 1 < s.length() && s.charAt(i + 1) != '0'))
						return size-1;
			}
		}
		return SIZE;
	}

	public static void findLarge() {
		while (true) {
			int Lx = 0, Ly = 0, Lsize = -1;
			for (int x = 0; x < M; x++)
				for (int y = 0; y < N; y++) {
					int size = isChess(x, y);
					if (Lsize == -1 || size > Lsize) {
						Lx = x;
						Ly = y;
						Lsize = size;
					}
				}
			if (Lsize < 2)
				return;
			for (int x = Lx; x < Lx + Lsize; x++)
				for (int y = Ly; y < Ly + Lsize; y++)
					board[x][y] = -1;
			maxBoard[Lsize-1]++;
		}
	}

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		for (int c = 1; c <= n; c++) {
			M = sc.nextInt();
			N = sc.nextInt();
			board = new int[M][N];
			maxBoard = new int[Math.max(M, N)];
			for (int m = 0; m < M; m++) {
				String num = sc.next();
				for (int j = 0; j < num.length(); j++) {
					String S = fromBase10(toBase10("" + num.charAt(j), 16), 2);
					while (S.length() != 4)
						S = "0" + S;
					for (int i = 0; i < 4; i++)
						if (S.charAt(i) == '1')
							board[m][j*4+i] = 1;
				}
			}
			findLarge();
			int s = 0, s_ = 0;
			for (int i = 0; i < maxBoard.length; i++)
				if (maxBoard[i] > 0)
					s++;
			System.out.printf("Case #%d: %d\n", c, s+1);
			for (int i = maxBoard.length - 1; i >= 0; i--)
				if (maxBoard[i] > 0) {
					System.out.printf("%d %d\n", i + 1, maxBoard[i]);
					s_ += maxBoard[i] * (i+1) * (i+1);
				}
			if (s_ != M*N)
				System.out.printf("%d %d\n", 1, M * N - s_);
		}
	}

}
