import java.util.Collections;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;
import java.util.Vector;

public class Water {

	static int H, W;
	static int[][] water;
	static int[][] bas;
	static char[][] fin;
	static Vector<Integer> alt;
	
	public static int expand(int i, int j, int b) {
		if (bas[i][j] > 0)
			return bas[i][j];
		
		int low = water[i][j];
		char dir = '.';
		if (i != 0 && water[i - 1][j] < low) {
			low = water[i - 1][j];
			dir = 'N';
		}
		if (j != 0 && water[i][j - 1] < low) {
			low = water[i][j - 1];
			dir = 'W';
		}
		if (j != W - 1 && water[i][j + 1] < low) {
			low = water[i][j + 1];
			dir = 'E';
		}
		if (i != H - 1 && water[i + 1][j] < low) {
			low = water[i + 1][j];
			dir = 'S';
		}

		if (low != water[i][j]) {
			if (dir == 'S') {
				bas[i][j] = expand(i+1, j, b);
				bas[i+1][j] = bas[i][j];
			} else if (dir == 'E') {
				bas[i][j] = expand(i, j+1, b);
				bas[i][j+1] = bas[i][j];
			} else if (dir == 'N') {
				bas[i][j] = expand(i-1, j, b);
				bas[i-1][j] = bas[i][j];
			} else if (dir == 'W') {
				bas[i][j] = expand(i, j-1, b);
				bas[i][j-1] = bas[i][j];
			}
		}
		
		if (bas[i][j] > 0)
			return bas[i][j];
		else
			return b;
	}
	
	public static void basins() {
		int b = 1;
		for (int k = alt.size() - 1; k >= 0; k--) {
			for (int i = 0; i < H; i++)
				for (int j = 0; j < W; j++)
					if (alt.get(k) == water[i][j]) {
						if ((bas[i][j] = expand(i, j, b)) == b)
							b++;
					}
		}
		
		char[] array = new char[b+1];
		char in = 'a';
		for (int i = 0; i < H; i++) {
			for (int j = 0; j < W; j++) {
				if (array[bas[i][j]] < 'a') {
					array[bas[i][j]] = in;
					in++;
				}
				fin[i][j] = array[bas[i][j]];
				System.out.print(fin[i][j]);
				if (j != W-1)
					System.out.print(" ");
			}
			System.out.println();
		}
	}

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int T = sc.nextInt();
		for (int k = 1; k <= T; k++) {
			H = sc.nextInt();
			W = sc.nextInt();
			water = new int[H][W];
			bas = new int[H][W];
			fin = new char[H][W];
			alt = new Vector<Integer>();
			for (int i = 0; i < H; i++)
				for (int j = 0; j < W; j++) {
					water[i][j] = sc.nextInt();
					alt.add(water[i][j]);
				}
			Collections.sort(alt);
			Set<Integer> set = new HashSet(alt);
			alt.clear();
			alt.addAll(set);
			System.out.println("Case #" + k + ":");
			basins();
		}
	}

}
