package com.google.jam.eaque.stub;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;

public class Main {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		if (args.length != 2) {
			System.out.println("args length : " + args.length);
			System.exit(0);
		}

		try {
			InputFileManager ifm = new InputFileManager(args[0]);
			BufferedWriter bw = new BufferedWriter(new FileWriter(args[1]));

			long nbTestCases = ifm.readLong();

			String[][] cases = new String[(int) nbTestCases][4];

			for (int i = 0; i < nbTestCases; i++) {
				for (int j = 0; j < 4; j++) {
					cases[i][j] = ifm.readLine();
				}
				ifm.readLine();
			}

			if (nbTestCases == 1) {
				SubTest st = new SubTest(cases);
				st.run();
				st.join();

				int i = 1;
				for (String string : st.getResults()) {
					bw.write("Case #" + i + ": " + string);
					bw.newLine();
					i++;
				}
			} else if (nbTestCases == 2 || nbTestCases == 3) {
				SubTest st1 = new SubTest(Arrays.copyOfRange(cases, 0,
						cases.length / 2));
				SubTest st2 = new SubTest(Arrays.copyOfRange(cases,
						cases.length / 2, cases.length));
				st1.run();
				st2.run();
				st1.join();
				st2.join();

				int i = 1;
				for (String string : st1.getResults()) {
					bw.write("Case #" + i + ": " + string);
					bw.newLine();
					i++;
				}
				for (String string : st2.getResults()) {
					bw.write("Case #" + i + ": " + string);
					bw.newLine();
					i++;
				}
			} else {
				SubTest st1 = new SubTest(Arrays.copyOfRange(cases, 0,
						cases.length / 4));
				SubTest st2 = new SubTest(Arrays.copyOfRange(cases,
						cases.length / 4, cases.length / 2));
				SubTest st3 = new SubTest(Arrays.copyOfRange(cases,
						cases.length / 2, 3 * (cases.length / 4)));
				SubTest st4 = new SubTest(Arrays.copyOfRange(cases,
						3 * (cases.length / 4), cases.length));
				st1.run();
				st2.run();
				st3.run();
				st4.run();
				st1.join();
				st2.join();
				st3.join();
				st4.join();

				int i = 1;
				for (String string : st1.getResults()) {
					bw.write("Case #" + i + ": " + string);
					bw.newLine();
					i++;
				}
				for (String string : st2.getResults()) {
					bw.write("Case #" + i + ": " + string);
					bw.newLine();
					i++;
				}
				for (String string : st3.getResults()) {
					bw.write("Case #" + i + ": " + string);
					bw.newLine();
					i++;
				}
				for (String string : st4.getResults()) {
					bw.write("Case #" + i + ": " + string);
					bw.newLine();
					i++;
				}
			}

			ifm.close();
			bw.close();
		} catch (IOException | InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
