package com.google.jam.round1c;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class InputFileManager {

    private BufferedReader br;

    public InputFileManager(String filePath) throws NumberFormatException,
            IOException {
        br = new BufferedReader(new FileReader(filePath));
    }

    public void close() throws IOException {
        br.close();
    }

    public String readLine() throws IOException {
        return br.readLine();
    }

    public long readLong() throws NumberFormatException, IOException {
        return Long.parseLong(br.readLine());
    }

    public String[] readAndSplit() throws IOException {
        return br.readLine().split(" ");
    }

    public long[] readLongs() throws IOException {
        String[] strings = this.readAndSplit();
        long[] res = new long[strings.length];
        for (int i = 0; i < strings.length; i++) {
            res[i] = Long.parseLong(strings[i]);
        }
        return res;
    }
    
    public int[] readInts() throws IOException {
        String[] strings = this.readAndSplit();
        int[] res = new int[strings.length];
        for (int i = 0; i < strings.length; i++) {
            res[i] = Integer.parseInt(strings[i]);
        }
        return res;
    }
}
