package com.google.jam.eaque.qualif.a;

import java.io.IOException;

import com.google.jam.eaque.stub.Stub;

public class StubImpl extends Stub {

	@Override
	public String runTestCase(String[] caze) throws NumberFormatException,
			IOException {
		byte[][] board = new byte[4][4];
		int o1 = 'O' + 'O' + 'O' + 'O';
		int x1 = 'X' + 'X' + 'X' + 'X';
		int o2 = 'O' + 'O' + 'O' + 'T';
		int x2 = 'X' + 'X' + 'X' + 'T';
		boolean notCompleted = false;

		for (int i = 0; i < 4; i++) {
			board[i] = caze[i].getBytes();
		}

		for (int i = 0; i < 4; i++) {
			int total = board[i][0];

			for (int j = 1; j < 4; j++) {
				total += board[i][j];
			}
			if (total == o1 || total == o2) {
				return "O won";
			} else if (total == x1 || total == x2) {
				return "X won";
			}
		}

		for (int i = 0; i < 4; i++) {
			int total = board[0][i];

			for (int j = 1; j < 4; j++) {
				total += board[j][i];
			}
			if (total == o1 || total == o2) {
				return "O won";
			} else if (total == x1 || total == x2) {
				return "X won";
			}
		}

		int diag1 = board[0][0] + board[1][1] + board[2][2] + board[3][3];
		int diag2 = board[3][0] + board[2][1] + board[1][2] + board[0][3];
		if (diag1 == o1 || diag1 == o2 || diag2 == o1 || diag2 == o2) {
			return "O won";
		} else if (diag1 == x1 || diag1 == x2 || diag2 == x1 || diag2 == x2) {
			return "X won";
		}
		
		for (int i = 0; i < board.length; i++) {
			for (int j = 0; j < board[i].length; j++) {
				if (board[i][j] == '.') {
					notCompleted = true;
					break;
				}
			}
			if (notCompleted) {
				return "Game has not completed";
			}
		}

		return "Draw";
	}

}
