/**
 * 
 */
package com.google.jam.eaque.qualif.c;

import java.io.IOException;

import com.google.jam.eaque.stub.Stub;

/**
 * @author Charles
 * 
 */
public class StubImpl extends Stub {

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.google.jam.eaque.stub.Stub#runTestCase(java.lang.String[][])
	 */
	@Override
	public String runTestCase(String[] caze) throws NumberFormatException,
			IOException {
		int[] numbers = new int[caze.length];
		int res = 0;

		for (int i = 0; i < caze.length; i++) {
			numbers[i] = Integer.parseInt(caze[i]);
		}

		for (int i = numbers[0]; i <= numbers[1]; i++) {
			int power = getPow(i);
			if (isPalindrome(i, power)) {
				int square = perfectSquareBabylonianMethod(i, power);
				if (square != -1 && isPalindrome(square, getPow(square))) {
					res++;
				}
			}
		}
		return Integer.toString(res);
	}

	private int getPow(int number) {
		int power = 1;
		while (number >= 10) {
			number /= 10;
			power *= 10;
		}
		return power;
	}

	private boolean isPalindrome(int number, int power) {
		int tmp = number;
		int reste;
		int res = 0;
		while (power >= 1) {
			reste = tmp % 10;
			res += reste * power;
			power /= 10;
			tmp /= 10;
		}
		return number == res;
	}

	private int perfectSquareBabylonianMethod(int number, int power) {
		double x = power;
		int xBefore = (int) x;
		x = (x + (((double) number) / x)) / (double) 2.0;
		int xAfter = (int) x;

		while (xBefore != xAfter) {
			xBefore = (int) x;
			x = (x + (((double) number) / x)) / (double) 2.0;
			xAfter = (int) x;
		}

		if (xAfter * xAfter == number) {
			return xAfter;
		} else {
			return -1;
		}
	}

}
