package tictactoe;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**
 * Created with IntelliJ IDEA.
 * User: Phaith
 * Date: 13/4/2556
 * Time: 12:47 น.
 * To change this template use File | Settings | File Templates.
 */
public class TICTACTOE {
    private static final int M=4, N=4;
    private static final int O_WINNER=0, X_WINNER=1, DRAW=2, GAME_NOT_END=3;
    Scanner scanner;
    public static void main(String[]argv){
        TICTACTOE tictactoe = new TICTACTOE();
        tictactoe.run();
    }
    public void run(){
        int caseNum=0;
        // read input file
        try {
            scanner = new Scanner(new File("tic_tac_toe.in"));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        // get case num
        caseNum = Integer.parseInt(scanner.nextLine());
        runCase(caseNum);
    }
    private void runCase(int caseNum){
        char [][]board = new char[M][N];
        // loop all cases
        for(int i=0;i<caseNum;i++){
            //get input for each case
            for(int m=0;m<M;m++){
                String row = scanner.nextLine();
                // check empty line
                if(row.equals("")){
                    row = scanner.nextLine();
                }
                for(int n=0;n<N;n++){
                    board[m][n] = row.charAt(n);
                }
            }
            checkWinner(i,board);
        }
    }
    private void checkWinner(int caseIndex, char [][]board){
        boolean mightNotEnd=false;
        // check row winner
        for(int m=0;m<M;m++){
            int OCount=0;
            int XCount=0;
            for(int n=0;n<N;n++){
                if(board[m][n]=='O'){
                    OCount++;
                }else if(board[m][n]=='X'){
                    XCount++;
                }else if(board[m][n]=='T'){
                    OCount++;
                    XCount++;
                }else{
                    mightNotEnd=true;
                }
            }
            if(XCount == 4){
                printWinner(caseIndex,X_WINNER);
                return;
            }else if(OCount == 4){
                printWinner(caseIndex,O_WINNER);
                return;
            }
        }

        // check col winner
        for(int m=0;m<M;m++){
            int OCount=0;
            int XCount=0;
            for(int n=0;n<N;n++){
                if(board[n][m]=='O'){
                    OCount++;
                }else if(board[n][m]=='X'){
                    XCount++;
                }else if(board[n][m]=='T'){
                    OCount++;
                    XCount++;
                }else{
                    mightNotEnd=true;
                }
            }
            if(XCount == 4){
                printWinner(caseIndex,X_WINNER);
                return;
            }else if(OCount == 4){
                printWinner(caseIndex,O_WINNER);
                return;
            }
        }
        // check diagonal win
        // top left to bottom right
        int OCount=0;
        int XCount=0;
        for(int m=0;m<M;m++){
            if(board[m][m]=='O'){
                OCount++;
            }else if(board[m][m]=='X'){
                XCount++;
            }else if(board[m][m]=='T'){
                OCount++;
                XCount++;
            }else{
                mightNotEnd=true;
            }
            if(XCount == 4){
                printWinner(caseIndex,X_WINNER);
                return;
            }else if(OCount == 4){
                printWinner(caseIndex,O_WINNER);
                return;
            }
        }

        //top right to bottom left
        OCount=0;
        XCount=0;
        for(int m=0;m<M;m++){
            if(board[m][M-1-m]=='O'){
                OCount++;
            }else if(board[m][M-1-m]=='X'){
                XCount++;
            }else if(board[m][M-1-m]=='T'){
                OCount++;
                XCount++;
            }else{
                mightNotEnd=true;
            }
            if(XCount == 4){
                printWinner(caseIndex,X_WINNER);
                return;
            }else if(OCount == 4){
                printWinner(caseIndex,O_WINNER);
                return;
            }
        }
        // check draw or game not end
        if(mightNotEnd){
            printWinner(caseIndex,GAME_NOT_END);
            return;
        }else{
            printWinner(caseIndex,DRAW);
        }
    }
    private void printWinner(int caseIndex, int winner){
        if(winner==O_WINNER){
            System.out.printf("Case #%d: O won\n",caseIndex+1);
        }else if(winner==X_WINNER){
            System.out.printf("Case #%d: X won\n",caseIndex+1);
        }else if(winner==DRAW){
            System.out.printf("Case #%d: Draw\n",caseIndex+1);
        }else if(winner==GAME_NOT_END){
            System.out.printf("Case #%d: Game has not completed\n",caseIndex+1);

        }
    }
}
