package qualification.a;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.StringReader;
import java.io.UnsupportedEncodingException;
import java.math.BigDecimal;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import util.StringUtil;

public class ASmallPractice {

	public static void main(String[] args) {
		ASmallPractice prac = new ASmallPractice();
		
		String contents = prac.loadFile("./qualification/a/A-small-attempt0.in");
		
		String[] lines = prac.cutLine(contents);
		
		StringBuffer sb = new StringBuffer(2000);
//			System.out.println("Case #: " + prac.getCalendarLines("100 10 1"));
		for (int i = 0 ; i < lines.length ; i++) {
			sb.append("Case #" + (i+1) + ": " + prac.getResult(lines[i]));
			sb.append("\n");
		}
//		
		prac.write("./qualification/a/A-small-practice.out", sb.toString());
	}
	
	private String loadFile(String filePath) {
		if (StringUtil.isEmpty(filePath)) {
			return null;
		}
		
		StringBuffer sb = new StringBuffer(2000);
		try {
			URL resource = ASmallPractice.class.getClassLoader().getResource(filePath);
			
			File file = new File(resource.getFile());
			FileReader reader = new FileReader(file);
			
			BufferedReader br = new BufferedReader(reader);
			
			char[] c = new char[(int) file.length()];
			br = new BufferedReader(new FileReader(file));
			br.read(c);
			sb.append(c);
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return sb.toString();
	}
	
	private String[] cutLine(String contents) {
		
		String[] split = StringUtil.split(contents, "\n");
		
		List<String> list = new ArrayList<String>();
		
		String line;
		for (int i = 1; i < split.length ; i++) {
			line = split[i];
			if (!StringUtil.isEmpty(line)) {
				list.add(line);
			}
		}
		
		return list.toArray(new String[list.size()]);
	}
	
	
	private  void write(String fileLocation, String content) {
		URL resource = ASmallPractice.class.getClassLoader().getResource("");
		
        StringReader stringReader = new StringReader(content);
        BufferedReader bufferedReader = new BufferedReader(stringReader);
        String s = "";
        BufferedWriter bufferedWriter = null;
        try {
            
            bufferedWriter = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(resource.getFile() + fileLocation), "UTF-8"));
            
            while ((s = bufferedReader.readLine()) != null) {
                bufferedWriter.write(s);
                bufferedWriter.newLine();
            }
            stringReader.close();
            bufferedReader.close();
            bufferedWriter.close();
        } catch (UnsupportedEncodingException e) {
        } catch (FileNotFoundException e)  {
        }catch (IOException e) {
        } finally {
            if (stringReader != null) {
                stringReader.close();
            }
            if (bufferedReader != null) {
                
                    try {
                        bufferedReader.close();
                    } catch (IOException e) {
                        
                    }
                
            }
            if (bufferedWriter != null) {
               
                    try {
                        bufferedWriter.close();
                    } catch (IOException e) {
                    }
                
            }
        }
    }
	
	private String getResult(String name) {
		long t1 = System.nanoTime();
		int intName = StringUtil.parseInt(name);
		
		if (intName == 0) {
			return "INSOMNIA";
		}
		
		boolean[] result = new boolean[10];
		
		int currentValue = intName;
		int index = 1;
		
		String returnVal = "INSOMNIA";
		while (index < 1000) {
			currentValue = intName * index;
			if(check(currentValue, index, result)) {
				returnVal =  String.valueOf(currentValue);
				break;
			}
			
			index++;
		}
		
		long t2 = System.nanoTime();
		
		System.out.println(index + " " + (t2 - t1) + "ns");
		return returnVal;
	}
	
	private boolean check(int value, int index, boolean[] result) {
		int skip = (int) Math.log10((double) index);
		int denominator = (int) (Math.pow(10, skip));
		
		if (denominator == index) {
			denominator = (int) (Math.pow(10, skip - 1));
			if (denominator < 1) {
				denominator = 1;
			}
		}
		
		int restValues = value / denominator;
		int lastNum = -1;
		while (restValues > 0) {
			lastNum = restValues % 10;
			result[lastNum] = true;
			
			restValues = restValues / 10;
		}
		
		for (boolean r : result) {
			if (!r) {
				return false;
			}
		}
		
		return true;
	}
}

