package round1b.b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.URL;
import java.util.StringTokenizer;

import qualification.c.ProblemC;

public class ProblemB {
	public static void main(String[] args) {

		BufferedReader br = null;
		BufferedWriter wr = null;
		
		try {
			URL inputResource = ProblemC.class.getClassLoader().getResource("round1b/b/B-large.in");
			URL outputResource = ProblemC.class.getClassLoader().getResource("");
			
			File inputFile = new File(inputResource.getFile());
			File outputFile = new File(outputResource.getFile(), "round1b/b/B-large.out");
			FileReader reader = new FileReader(inputFile);
			FileWriter writer = new FileWriter(outputFile);
			
			br = new BufferedReader(reader);
			wr = new BufferedWriter(writer);
			
			String input = br.readLine();
			String output = null;
			int last = Integer.parseInt(input);

			for (int i = 0 ; i < last ; i++) {
				input = br.readLine();
				System.out.println("#" + (i+1));
				System.out.println(input);
				
				output = getResult(input);
				System.out.println(output);
				wr.write("Case #" + (i + 1) + ": " + output);
				wr.newLine();
			}
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
				}
			}
			
			if (wr != null) {
				try {
					wr.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

	private static String getResult(String input) {
		StringTokenizer token = new StringTokenizer(input, " ");
		int n = Integer.parseInt(token.nextToken());
		char[] result = new char[n];

		int[] colors = new int[6];
		for (int i = 0 ; i < 6 ; i++) {
			colors[i] = Integer.parseInt(token.nextToken());
			if (result[0] == 0 && colors[i] > 0) {
				result[0] = getColorChar(i);
				colors[i]--;
			}
		}
		
		for (int i = 1 ; i < n ; i++) {
			int[] possibleColors = possibleColor(result[i - 1]);
			
			if (possibleColors.length > 1) {
				if (colors[possibleColors[0]] > 0) {
					result[i] = getColorChar(possibleColors[0]);
					colors[possibleColors[0]]--;
				} else {
					if (colors[possibleColors[1]] > colors[possibleColors[2]]) {
						result[i] = getColorChar(possibleColors[1]);
						colors[possibleColors[1]]--;
					} else if (colors[possibleColors[2]] > 0) {
						result[i] = getColorChar(possibleColors[2]);
						colors[possibleColors[2]]--;
					}
				}
			} else {
				if (colors[possibleColors[0]] > 0) {
					result[i] = getColorChar(possibleColors[0]);
					colors[possibleColors[0]]--;
				}
			}
			
			
			if (result[i] == 0) {
				System.out.println(i + " : " + new String(result));
				return "IMPOSSIBLE";
			}
		}
		
		if (!checkUnique(result[0], result[n - 1])) {
			if (checkUnique(result[0], result[n - 2]) 
					&& checkUnique(result[n - 3], result[n - 1])) {
				char temp = result[n - 2];
				result[n - 2] = result[n - 1];
				result[n - 1] = temp;
			} else {
				System.out.println(new String(result));
				return "IMPOSSIBLE";
			}
		}
		
		return new String(result);
	}
	
	private static boolean checkUnique(char a, char b) {
		int[] possibleColor = possibleColor(a);
		
		for (int color : possibleColor) {
			if (b == getColorChar(color)) {
				return true;
			}
		}
		return false;
	}
	
	private static int[] possibleColor(char c) {
		switch (c) {
		case 'R':
			return new int[]{3, 2, 4};
		case 'O':
			return new int[]{4};
		case 'Y': 
			return new int[]{5, 4, 0};
		case 'G':
			return new int[]{0};
		case 'B':
			return new int[]{1, 0, 2};
		case 'V':
			return new int[]{2};
		}
		return null;
	}
	
	private static char getColorChar(int i) {
		switch (i) {
		case 0:
			return 'R';
		case 1:
			return 'O';
		case 2: 
			return 'Y';
		case 3:
			return 'G';
		case 4:
			return 'B';
		case 5:
			return 'V';
		}
		return 0;
	}
}
