package qualification.b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.StringReader;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import qualification.a.ASmallPractice;
import util.StringUtil;

public class BSmallPractice {
	public static void main(String[] args) {
		BSmallPractice prac = new BSmallPractice();
		
		String contents = prac.loadFile("./qualification/b/B-small-attempt0.in");
		
		String[] lines = prac.cutLine(contents);
		
		StringBuffer sb = new StringBuffer(2000);
//			System.out.println("Case #: " + prac.getCalendarLines("100 10 1"));
		for (int i = 0 ; i < lines.length ; i++) {
			sb.append("Case #" + (i+1) + ": " + prac.getResult(lines[i]));
			sb.append("\n");
		}
//		
		prac.write("./qualification/b/B-small.out", sb.toString());
	}
	
	private String loadFile(String filePath) {
		if (StringUtil.isEmpty(filePath)) {
			return null;
		}
		
		StringBuffer sb = new StringBuffer(2000);
		try {
			URL resource = getClass().getClassLoader().getResource(filePath);
			
			File file = new File(resource.getFile());
			FileReader reader = new FileReader(file);
			
			BufferedReader br = new BufferedReader(reader);
			
			char[] c = new char[(int) file.length()];
			br = new BufferedReader(new FileReader(file));
			br.read(c);
			sb.append(c);
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return sb.toString();
	}
	
	private String[] cutLine(String contents) {
		
		String[] split = StringUtil.split(contents, "\n");
		
		List<String> list = new ArrayList<String>();
		
		String line;
		for (int i = 1; i < split.length ; i++) {
			line = split[i];
			if (!StringUtil.isEmpty(line)) {
				list.add(line.trim());
			}
		}
		
		return list.toArray(new String[list.size()]);
	}
	
	
	private  void write(String fileLocation, String content) {
		URL resource = getClass().getClassLoader().getResource("");
		
        StringReader stringReader = new StringReader(content);
        BufferedReader bufferedReader = new BufferedReader(stringReader);
        String s = "";
        BufferedWriter bufferedWriter = null;
        try {
            
            bufferedWriter = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(resource.getFile() + fileLocation), "UTF-8"));
            
            while ((s = bufferedReader.readLine()) != null) {
                bufferedWriter.write(s);
                bufferedWriter.newLine();
            }
            stringReader.close();
            bufferedReader.close();
            bufferedWriter.close();
        } catch (UnsupportedEncodingException e) {
        } catch (FileNotFoundException e)  {
        }catch (IOException e) {
        } finally {
            if (stringReader != null) {
                stringReader.close();
            }
            if (bufferedReader != null) {
                
                    try {
                        bufferedReader.close();
                    } catch (IOException e) {
                        
                    }
                
            }
            if (bufferedWriter != null) {
               
                    try {
                        bufferedWriter.close();
                    } catch (IOException e) {
                    }
                
            }
        }
    }
	
	private String getResult(String name) {
		System.out.println("----------------------");
		long t1 = System.nanoTime();
		char[] charArray = name.toCharArray();
		int times = 0;
		
		while (!checkAllSmile(charArray)) {
			move(charArray);
			times++;
			
			System.out.println(new String(charArray));
		}
		
		long t2 = System.nanoTime();
		
		return String.valueOf(times);
	}
	
	private void move(char[] charArray) {
		int last = charArray.length - 1;
		
		if (charArray[0] == '+') {
			last = 0;
			while (last < charArray.length - 1 && charArray[last + 1] == '+') {
				last++;
			}
		} else {
			while (last > 0 && charArray[last] == '+') {
				last--;
			}
		}
		
		int first = 0;
		
		while (first <= last) {
			if (first == last) {
				charArray[first] = flip(charArray[first]);
			} else {
				char temp = charArray[first];
				charArray[first] = flip(charArray[last]);
				charArray[last] = flip(temp);
			}
			
			first++;
			last--;
		}
		
	}
	
	private char flip(char original) {
		if (original == '-') {
			return '+';
		}
		
		return '-';
	}
	
	private boolean checkAllSmile(char[] charArray) {
		for(char c : charArray) {
			if (c == '-') {
				return false;
			}
		}
		
		return true;
	}
}
