package qualification.c;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.StringReader;
import java.io.UnsupportedEncodingException;
import java.math.BigInteger;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class CSmallPractice {
	public static void main(String[] args) {
		CSmallPractice prac = new CSmallPractice();
		
		String contents = prac.loadFile("./qualification/c/C-small-attempt1.in");
		
		String[] lines = prac.cutLine(contents);
		
		StringBuffer sb = new StringBuffer(2000);
		for (int i = 0 ; i < lines.length ; i++) {
			sb.append("Case #" + (i+1) + ":\n");
			sb.append(prac.getResult(lines[i]));
		}
		prac.write("./qualification/c/C-small.out", sb.toString());
	}
	
	private String loadFile(String filePath) {
		
		StringBuffer sb = new StringBuffer(2000);
		BufferedReader br = null;
		try {
			URL resource = getClass().getClassLoader().getResource(filePath);
			
			File file = new File(resource.getFile());
			FileReader reader = new FileReader(file);
			
			br = new BufferedReader(reader);
			
			char[] c = new char[(int) file.length()];
			br = new BufferedReader(new FileReader(file));
			br.read(c);
			sb.append(c);
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				br.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		
		return sb.toString();
	}
	
	private String[] cutLine(String contents) {
		
		String[] split = split(contents, "\n");
		
		List<String> list = new ArrayList<String>();
		
		String line;
		for (int i = 1; i < split.length ; i++) {
			line = split[i];
			if (line != null && !"".equals(line)) {
				list.add(line.trim());
			}
		}
		
		return list.toArray(new String[list.size()]);
	}
	
	public String[] split(String data, String delemeter) {
        if (delemeter == null) {
            return new String[] { data };
        }

        String[] tokens = null;

        StringTokenizer tokenizer = new StringTokenizer(data, delemeter);
        tokens = new String[tokenizer.countTokens()];
        for (int i = 0; tokenizer.hasMoreTokens(); i++) {
            tokens[i] = tokenizer.nextToken();
        }
        return tokens;
    }
	
	
	private  void write(String fileLocation, String content) {
		URL resource = getClass().getClassLoader().getResource("");
		
        StringReader stringReader = new StringReader(content);
        BufferedReader bufferedReader = new BufferedReader(stringReader);
        String s = "";
        BufferedWriter bufferedWriter = null;
        try {
            
            bufferedWriter = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(resource.getFile() + fileLocation), "UTF-8"));
            
            while ((s = bufferedReader.readLine()) != null) {
                bufferedWriter.write(s);
                bufferedWriter.newLine();
            }
            stringReader.close();
            bufferedReader.close();
            bufferedWriter.close();
        } catch (UnsupportedEncodingException e) {
        } catch (FileNotFoundException e)  {
        }catch (IOException e) {
        } finally {
            if (stringReader != null) {
                stringReader.close();
            }
            if (bufferedReader != null) {
                
                    try {
                        bufferedReader.close();
                    } catch (IOException e) {
                        
                    }
                
            }
            if (bufferedWriter != null) {
               
                    try {
                        bufferedWriter.close();
                    } catch (IOException e) {
                    }
                
            }
        }
    }
	
	private String getResult(String name) {
		System.out.println("----------------------");
		long t1 = System.currentTimeMillis();
		String[] split = split(name, " ");
		String length = split[0];
		String count = split[1];
		System.out.println(length + " " + count);
		
//		int[][] allCases = getAllCases(length);
		
		int intLength = Integer.parseInt(length);
		int intCount = Integer.parseInt(count);
		
		
		StringBuffer sb = new StringBuffer();
		int outputStringCounter = 0;
		
		for (int i = 0 ; i < Math.pow(2, intLength - 2) ; i++ ) {
			int[] intArray = getIntArray(i, intLength);
			String outputString = getOutputString(intArray);
			
			if (outputString == null) {
				continue;
			} 
			
			sb.append(outputString);
			sb.append("\n");
			outputStringCounter++;
			if (outputStringCounter >= intCount) {
				break;
			}
		}
		
		
		
		long t2 = System.currentTimeMillis();
		
		System.out.println(t2 - t1 + " ms");
		return sb.toString();
	}
	
	private String getOutputString(int[] intArray) {
		List<String> divisors = new ArrayList<String>();
		 
//		BigInteger value = null;
		
		for (int base = 2 ; base <= 10 ; base++) {
//			value = BigInteger.ZERO;

			String divisor = null;
			BigInteger value = getInteger(intArray, base);
			BigInteger last = value.divide(new BigInteger("2")).add(BigInteger.ONE);
			
			if (value.isProbablePrime(1)) {
				return null; 
			}
			for (BigInteger j = new BigInteger("2") ; j.compareTo(last) < 0; j = j.add(BigInteger.ONE)) {
				if (value.remainder(j).equals(BigInteger.ZERO)) {
					divisor = String.valueOf(j);
					break;
				}
			}
			if (divisor == null) {
				return null;
			}
			divisors.add(divisor);
			
		}
		StringBuffer sb = new StringBuffer();
		for (int i : intArray) {
			sb.append(i);
		}
		
		for (String divisor : divisors) {
			sb.append(" ");
			sb.append(divisor);
		}
		
		return sb.toString();
	}
	
	
	private BigInteger getInteger(int[] src, int radix) {
		StringBuffer sb = new StringBuffer();
		for (int i : src) {
			sb.append(String.valueOf(i));
		}
		
		BigInteger value = new BigInteger(sb.toString(), radix);
		
		return value;
	}
	
	private int[] getIntArray(int val, int length) {
		String binaryString = Integer.toBinaryString(val);
		int[] intArray = toIntArray(binaryString);
		
		int[] result = new int[length];
		
		result[0] = 1;
		result[result.length - 1] = 1;
		int destPos = length - intArray.length - 1;
		for (int i = 1 ; i < destPos ; i++) {
			result[i] = 0;
		}
		
		System.arraycopy(intArray, 0, result, destPos, intArray.length);
		return result;
	}
	
	private int[][] getAllCases(String length) {
		int intLength = Integer.parseInt(length) - 2;
		
		List<String> list = new ArrayList<String>();
		list.add("0");
		list.add("1");
		
		for (int i = 1 ; i < intLength ; i++) {
			list = append(list);
		}
		
		int[][] allCases = new int[list.size()][];
		for (int i = 0 ; i < list.size() ; i++) {
			allCases[i] = toIntArray(list.get(i));
		}
		
		return allCases;
	}
	
	private int[] toIntArray(String string) {
		char[] charArray = string.toCharArray();
		
		int[] intArray = new int[charArray.length];
				
		for (int i = 0 ; i < charArray.length ; i++) {
			intArray[i] = Character.getNumericValue(charArray[i]);
		}
		
		return intArray;
	}
	
	private List<String> append(List<String> before) {
		List<String> newList = new ArrayList<String>();
		
		for (String b : before) {
			newList.add(b + "0");
			newList.add(b + "1");
		}
		
		return newList;
	}
}
