package qualification.b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.URL;
import java.util.StringTokenizer;

public class ProblemB {

	public static void main(String[] args) {

		BufferedReader br = null;
		BufferedWriter wr = null;
		
		try {
			URL inputResource = ProblemB.class.getClassLoader().getResource("qualification/b/B-small-attempt0.in");
			URL outputResource = ProblemB.class.getClassLoader().getResource("");
			
			File inputFile = new File(inputResource.getFile());
			File outputFile = new File(outputResource.getFile(), "qualification/b/B-small-attempt0.out");
			FileReader reader = new FileReader(inputFile);
			FileWriter writer = new FileWriter(outputFile);
			
			br = new BufferedReader(reader);
			wr = new BufferedWriter(writer);
			
			String input = br.readLine();
			String output = null;
			int last = Integer.parseInt(input);

			for (int i = 0 ; i < last ; i++) {
				input = br.readLine();
				System.out.println(input);
				output = getResult(input);
				System.out.println(output);
				wr.write("Case #" + (i + 1) + ": " + output);
				wr.newLine();
			}
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
				}
			}
			
			if (wr != null) {
				try {
					wr.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	private static String getResult(String input) {
		char[] numbers = input.toCharArray();
		int index = -1;
		while ((index = getNotTidyIndex(numbers)) >= 0) {
			numbers[index] = (char) (numbers[index] - 1);
			for (int i = index + 1 ; i < numbers.length ; i++) {
				numbers[i] = '9';
			}
		}
		
		String result = new String(numbers);
		if (result.startsWith("0")) {
			result = result.substring(1);
		}
		return result;
	}
	
	private static int getNotTidyIndex(char[] numbers) {
		for (int i = 0 ; i < numbers.length - 1; i++) {
			if (numbers[i] > numbers[i+1]) {
				return i;
			}
		}
		return -1;
	}
	
}
