package qualification.c;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.URL;
import java.util.StringTokenizer;

public class ProblemC {

	public static void main(String[] args) {

		BufferedReader br = null;
		BufferedWriter wr = null;
		
		try {
			URL inputResource = ProblemC.class.getClassLoader().getResource("qualification/c/C-small-1-attempt1.in");
			URL outputResource = ProblemC.class.getClassLoader().getResource("");
			
			File inputFile = new File(inputResource.getFile());
			File outputFile = new File(outputResource.getFile(), "qualification/c/C-small-1-attempt1.out");
			FileReader reader = new FileReader(inputFile);
			FileWriter writer = new FileWriter(outputFile);
			
			br = new BufferedReader(reader);
			wr = new BufferedWriter(writer);
			
			String input = br.readLine();
			String output = null;
			int last = Integer.parseInt(input);

			for (int i = 0 ; i < last ; i++) {
				input = br.readLine();
				System.out.println(input);
				output = getResult(input);
				System.out.println(output);
				wr.write("Case #" + (i + 1) + ": " + output);
				wr.newLine();
			}
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
				}
			}
			
			if (wr != null) {
				try {
					wr.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	private static String getResult(String input) {
		StringTokenizer token = new StringTokenizer(input, " ");
		double stalls = Double.parseDouble(token.nextToken());
		double person = Double.parseDouble(token.nextToken());
		
		double dividend = stalls - person;
		
		int log = (int) (Math.log(person) / Math.log(2)) + 1;
		double divisor = Math.pow(2, log);
		
		String result = null;
		
		double quotient = Math.floor(dividend / divisor);
		if (dividend % divisor == 0) {
			result = String.format("%.0f %.0f", quotient, quotient);
		} else {
			if (stalls < person * 2) {
				result = String.format("%.0f %.0f", quotient, quotient);
			} else {
				result = String.format("%.0f %.0f", quotient + 1, quotient);
			}
		}
		
		return result;
	}
	
	
}
