package qualification.a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.URL;
import java.util.StringTokenizer;

public class ProblemA {

	public static void main(String[] args) {

		BufferedReader br = null;
		BufferedWriter wr = null;
		
		try {
			URL inputResource = ProblemA.class.getClassLoader().getResource("qualification/a/A-large.in");
			URL outputResource = ProblemA.class.getClassLoader().getResource("");
			
			File inputFile = new File(inputResource.getFile());
			File outputFile = new File(outputResource.getFile(), "qualification/a/A-large.out");
			FileReader reader = new FileReader(inputFile);
			FileWriter writer = new FileWriter(outputFile);
			
			br = new BufferedReader(reader);
			wr = new BufferedWriter(writer);
			
			String input = br.readLine();
			String output = null;
			int last = Integer.parseInt(input);

			for (int i = 0 ; i < last ; i++) {
				input = br.readLine();
				System.out.println(input);
				output = getResult(input);
				System.out.println(output);
				wr.write("Case #" + (i + 1) + ": " + output);
				wr.newLine();
			}
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
				}
			}
			
			if (wr != null) {
				try {
					wr.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	private static String getResult(String input) {
		StringTokenizer token = new StringTokenizer(input, " ");
		char[] pancakes = token.nextToken().toCharArray();
		int length = pancakes.length;
		int flipSize = Integer.parseInt(token.nextToken());
		
		int counter = 0;
		for (int i = 0 ; i < length ; i++) {
			if (pancakes[i] == '-') {
				if (i + flipSize <= length) {
					reverse(pancakes, i, flipSize);
					counter++;
				} else {
					return "IMPOSSIBLE";
				}
			}
		}
		
		return String.valueOf(counter);
	}
	
	private static void reverse(char[] pancakes, int startIndex, int numof) {
		for (int i = 0 ; i < numof ; i++) {
			pancakes[i + startIndex] = pancakes[i + startIndex] == '+' ? '-' : '+';
		}
	}
	
}
