package round1b.a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.URL;
import java.util.StringTokenizer;

import qualification.c.ProblemC;

public class ProblemA {
	public static void main(String[] args) {

		BufferedReader br = null;
		BufferedWriter wr = null;
		
		try {
			URL inputResource = ProblemC.class.getClassLoader().getResource("round1b/a/A-small-attempt1.in");
			URL outputResource = ProblemC.class.getClassLoader().getResource("");
			
			File inputFile = new File(inputResource.getFile());
			File outputFile = new File(outputResource.getFile(), "round1b/a/A-small-attempt1.out");
			FileReader reader = new FileReader(inputFile);
			FileWriter writer = new FileWriter(outputFile);
			
			br = new BufferedReader(reader);
			wr = new BufferedWriter(writer);
			
			String input = br.readLine();
			String output = null;
			int last = Integer.parseInt(input);

			for (int i = 0 ; i < last ; i++) {
				input = br.readLine();
				System.out.println("#" + (i+1));
				System.out.println(input);
				
				StringTokenizer token = new StringTokenizer(input, " ");
				int dist = Integer.parseInt(token.nextToken());
				int horses = Integer.parseInt(token.nextToken());
				
				double latestTime = 0;
				for (int j = 0 ; j < horses ; j++) {
					input = br.readLine();
					System.out.println(input);
					double time = getTime(dist, input);
					System.out.println(time);
					if (time > latestTime) {
						latestTime = time;
					}
				}
				double speed = dist / latestTime;
				System.out.println(String.format("%.6f", speed));
				wr.write("Case #" + (i + 1) + ": " + String.format("%.6f", speed));
				wr.newLine();
			}
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
				}
			}
			
			if (wr != null) {
				try {
					wr.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	private static double getTime(int dist, String input) {
		StringTokenizer token = new StringTokenizer(input, " ");
		int startPoint = Integer.parseInt(token.nextToken());
		int speed = Integer.parseInt(token.nextToken());
		
		return (dist - startPoint) / (double) speed;
	}
}
