import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;

class B {	
	public static void main(String args[]) {
		TestCase[] testCases = TestCase.loadTestCases(System.in);
		for (int i=0; i<testCases.length; i++) {
			testCases[i].start(1);
		}
	}
}

class TestCase {
	int mCaseNum;
	int mK;
	int mB;
	int mT;
	int[] mX;
	int[] mV;
	
	public TestCase(int caseNum, int k, int b, int t, int[] x, int[] v) {
		mCaseNum = caseNum;
		mK = k;
		mB = b;
		mT = t;
		mX = x;
		mV = v;
	}
	
	public static TestCase[] loadTestCases(InputStream is) {
		Scanner sc = new Scanner(is);
		int caseNum = Integer.parseInt(sc.nextLine());
		TestCase[] testCases = new TestCase[caseNum];
		for (int t=0; t<testCases.length; t++) {
			int N = sc.nextInt();
			int K = sc.nextInt();
			int B = sc.nextInt();
			int T = sc.nextInt();
			sc.nextLine();
			int[] X = new int[N];
			for (int i=0; i<N; i++)
				X[i] = sc.nextInt();
			sc.nextLine();
			int[] V = new int[N];
			for (int i=0; i<N; i++)
				V[i] = sc.nextInt();
			sc.nextLine();
			testCases[t] = new TestCase(t+1, K, B, T, X, V);
		}
		sc.close();
		return testCases;
	}
	
	public void start(int mode) {
		if (mode == 0)
			dump();
		else {
			long startTime = System.currentTimeMillis();
			solve();
			long endTime = System.currentTimeMillis();
			//System.out.println("Time="+((endTime - startTime) / 1000));
		}
	}
	
	public void dump() {
		System.out.println("case "+mCaseNum);
		System.out.println("K="+mK+"B="+mB+", T="+mT);
		for (int i=0; i<mX.length; i++)
			System.out.print(mX[i]+" ");
		System.out.println();
		for (int i=0; i<mV.length; i++)
			System.out.print(mV[i]+" ");
		System.out.println();
	}
	
	public void solve0() {
		int possible = 0;
		int[] possibility = new int[mX.length];
		for (int i=mX.length-1; i>=0; i++) {
			if (mX[i] + mV[i] * mT >= mB) {
				possible++;
				possibility[i] = 1;
			}
		}
		if (possible >= mK) {
			int cnt = 0;
			int[] prevX = mX;
			int[] nextX = new int[mX.length];
			for (int t=0; t<mT; t++) {
				for (int i=0; i<mX.length; i++) {
					nextX[i] = prevX[i] + mV[i];
				}
			}
			System.out.println("Case #" + mCaseNum + ": " + cnt);
		} else {
			System.out.println("Case #" + mCaseNum + ": IMPOSSIBLE");
		}
	}
	
	public void solve() {
		int possible = 0;
		ArrayList<Chick> chicks = new ArrayList<Chick>(mX.length);
		for (int i=mX.length-1; i>=0; i--) {
			Chick c = new Chick(i, mX[i], mV[i]);
			if (mX[i] + mV[i] * mT >= mB) {
				possible++;
				c.isPossible = true;
			}
			chicks.add(0, c);
		}
		if (possible >= mK) {
			int cnt = 0;
			for (int t=0; t<mT; t++) {
				for (int i=0; i<mX.length; i++)
					chicks.get(i).X = chicks.get(i).X + chicks.get(i).V;
				for (int i=0; i<mX.length-2; i++)
					for (int j=i; j<mX.length-1; j++) {
						if (chicks.get(j).X > chicks.get(j+1).X) {
							if (chicks.get(j).isPossible)
								cnt++;
							Collections.swap(chicks, j, j+1);
						}
					}
			}
			System.out.println("Case #" + mCaseNum + ": " + cnt);
		} else {
			System.out.println("Case #" + mCaseNum + ": IMPOSSIBLE");
		}
	}
	
	private static class Chick implements Comparable<Chick>{
		public int N;
		public int X;
		public int V;
		public boolean isPossible;
		public Chick(int n, int x, int v) {
			N = n;
			X = x;
			V = v;
		}
		@Override
		public int compareTo(Chick arg0) {
			return (X - arg0.X);
		}
		@Override
		public String toString() {
			return ("X"+X);
		}
	}
}