import java.io.InputStream;
import java.util.Scanner;

class SquareTiles {
	public static void main(String args[]) {
		TestCase[] testCases = TestCase.loadTestCases(System.in);
		for (int i=0; i<testCases.length; i++) {
//			testCases[i].dump();
			testCases[i].solve();
		}
	}
}

class TestCase {
	int mCaseNum;
	char[][] mPicture;
	
	public TestCase(int caseNum, char[][] picture) {
		mCaseNum = caseNum;
		mPicture = picture;
	}
	
	public static TestCase[] loadTestCases(InputStream is) {
		Scanner sc = new Scanner(is);
		int caseNum = Integer.parseInt(sc.nextLine());
		TestCase[] testCases = new TestCase[caseNum];
		for (int i=0; i<testCases.length; i++) {
			int R = sc.nextInt();
			int C = sc.nextInt();
			sc.nextLine();
			char[][] picture = makeCharArray(R, C);
			for (int r=0; r<R; r++) {
				String l = sc.nextLine();
				for (int c=0; c<C; c++) {
					picture[r][c] = l.charAt(c);
				}
			}
			testCases[i] = new TestCase(i+1, picture);
		}
		sc.close();
		return testCases;
	}
	
	public void dump() {
		System.out.println("case "+mCaseNum);
		for (int r=0; r<mPicture.length; r++) {
			for (int c=0; c<mPicture[r].length; c++) {
				System.out.print(mPicture[r][c]);
			}
			System.out.println();
		}
		System.out.println();
	}
	
	private static final char BLUE = '#';
	
	public void solve() {
		int r, c;
		int R = mPicture.length;
		int C = mPicture[0].length;
		boolean possible = true;
		for (r=0; r<R; r++) {
			for (c=0; c<C; c++) {
				if ((r == R-1 || c == C-1) && mPicture[r][c] == BLUE) { // last row or last column
					possible = false;
					break;
				}
				else if (mPicture[r][c] != BLUE) continue;
				else if (mPicture[r][c+1] == BLUE && mPicture[r+1][c] == BLUE && mPicture[r+1][c+1] == BLUE) {
					mPicture[r][c] = '/';
					mPicture[r+1][c+1] = '/';
					mPicture[r+1][c] = '\\';
					mPicture[r][c+1] = '\\';
					c++;
				} else {
					possible = false;
					break;
				}
			}
			if (!possible)
				break;
		}
		System.out.println("Case #" + mCaseNum + ":");
		if (possible) {
			for (r=0; r<R; r++) {
				for (c=0; c<C; c++) {
					System.out.print(mPicture[r][c]);
				}
				System.out.println();
			}
		} else {
			System.out.println("Impossible");
		}
	}
	
	private static char[][] makeCharArray(int h, int w) {
		char[][] array = new char[h][];
		for (int i=0; i<h; i++)
			array[i] = new char[w];
		return array;
	}
}