import java.io.InputStream;
import java.util.Collections;
import java.util.LinkedList;
import java.util.Scanner;

class Magicka {
	public static void main(String args[]) {
		TestCase[] testCases = TestCase.loadTestCases(System.in);
		for (int i=0; i<testCases.length; i++) {
//			testCases[i].dump();
			testCases[i].solve();
		}
	}
}

class TestCase {
	int mCaseNum;
	char mComA;
	char mComB;
	char mComC;
	char mOppA;
	char mOppB;
	String mSeries;
	
	int mNumOppA;
	int mNumOppB;
	StringBuilder mResult = new StringBuilder();
	
	public TestCase(int caseNum, char comA, char comB, char comC, char oppA, char oppB, String series) {
		mCaseNum = caseNum;
		mComA = comA;
		mComB = comB;
		mComC = comC;
		mOppA = oppA;
		mOppB = oppB;
		mSeries = series;
	}
	
	public static TestCase[] loadTestCases(InputStream is) {
		Scanner sc = new Scanner(is);
		int caseNum = Integer.parseInt(sc.nextLine());
		TestCase[] testCases = new TestCase[caseNum];
		for (int i=0; i<testCases.length; i++) {
			char comA = '.', comB = '.', comC = '.';
			if (sc.nextInt() > 0) {
				String combineStr = sc.next();
				comA = combineStr.charAt(0);
				comB = combineStr.charAt(1);
				comC = combineStr.charAt(2);
			}
			char oppA = '.', oppB = '.';
			if (sc.nextInt() > 0) {
				String opposeStr = sc.next();
				oppA = opposeStr.charAt(0);
				oppB = opposeStr.charAt(1);
			}
			String series = null;
			if (sc.nextInt() > 0) {
				series = sc.next();
			}
			testCases[i] = new TestCase(i+1, comA, comB, comC, oppA, oppB, series);
			sc.nextLine();
		}
		sc.close();
		return testCases;
	}
	
	public void dump() {
		System.out.println("case "+mCaseNum);
		System.out.println("Com="+mComA+mComB+mComC+", Opp="+mOppA+mOppB+", "+mSeries);
	}
	
	public void solve() {		
		resetResult();
		for (int i=0; i<mSeries.length(); i++) {
			char newC = mSeries.charAt(i);
			if (mResult.length() == 0) {
				addToResult(newC);
			} else {
				char lastC = mResult.charAt(mResult.length()-1);
				if ((lastC == mComA && newC == mComB) || (lastC == mComB && newC == mComA)) { // combine
					if (lastC == mOppA) mNumOppA--;
					else if (lastC == mOppB) mNumOppB--;
					mResult.setCharAt(mResult.length()-1, mComC);
				} else if ((newC == mOppA && mNumOppB > 0) || (newC == mOppB && mNumOppA > 0)) { // oppose
					resetResult();
				} else
					addToResult(newC);
			}
		}
		System.out.println("Case #" + mCaseNum + ": " + getResultString());
	}
	
	private void resetResult() {
		mResult.setLength(0);
		mNumOppA = 0;
		mNumOppB = 0;
	}
	
	private void addToResult(char c) {
		mResult.append(c);
		if (c == mOppA) mNumOppA++;
		else if (c == mOppB) mNumOppB++;
	}
	
	private String getResultString() {
		if (mResult.length() == 0) return "[]";
		String ret = "";
		for (int i=0; i<mResult.length(); i++) {
			if (i == 0)
				ret += "["+mResult.charAt(i);
			else
				ret += ", "+mResult.charAt(i);
		}
		ret += "]";
		return ret;
	}
}