import java.io.InputStream;
import java.util.Scanner;

class TicTacToeTomek {	
	public static void main(String args[]) {
		TestCase[] testCases = TestCase.loadTestCases(System.in);
		long startTime = System.currentTimeMillis();
		for (int i=0; i<testCases.length; i++) {
            // testCases[i].dump();
            testCases[i].solve();
		}
		long endTime = System.currentTimeMillis();
		System.out.println("Time="+((endTime - startTime) / 1000));
	}
}

class TestCase {
	int mCaseNum;
    char[][] mBoard;
	
    public TestCase(int caseNum, char[][] board) {
		mCaseNum = caseNum;
        mBoard = board;
	}

    private static final int N = 4;
	
	public static TestCase[] loadTestCases(InputStream is) {
		Scanner sc = new Scanner(is);
		int caseNum = Integer.parseInt(sc.nextLine());
		TestCase[] testCases = new TestCase[caseNum];

		for (int i=0; i<testCases.length; i++) {
            char[][] board = makeArray(N, N);
            for (int r = 0; r < N; r++) {
                String line = sc.nextLine();
                board[r] = line.toCharArray();
            }
            testCases[i] = new TestCase(i + 1, board);
            sc.nextLine();
		}
		sc.close();
		return testCases;
	}
	
	public void dump() {
		System.out.println("------------- case "+mCaseNum);		
        for (int r = 0; r < N; r++) {
            for (int c = 0; c < N; c++) {
                System.out.print(" " + mBoard[r][c]);
            }
            System.out.println();
        }
	}
	
	public void solve() {
        for (int i = 0; i < N; i++) {
            if (check(i, 0, 0, 1))
                return;
            if (check(0, i, 1, 0))
                return;
        }
        if (check(0, 0, 1, 1))
            return;
        if (check(0, N - 1, 1, -1))
            return;
        for (int r = 0; r < N; r++) {
            for (int c = 0; c < N; c++) {
                if (mBoard[r][c] == '.') {
                    System.out.println("Case #" + mCaseNum + ": Game has not completed");
                    return;
                }
            }
        }
        System.out.println("Case #" + mCaseNum + ": Draw");
	}

    private boolean check(int sx, int sy, int dx, int dy) {
        int x = sx;
        int y = sy;
        int countX = 0;
        int countO = 0;
        int countT = 0;
        for (int i = 0; i < N; i++) {
            char c = mBoard[y][x];
            if (c == 'X')
                countX++;
            else if (c == 'O')
                countO++;
            else if (c == 'T')
                countT++;
            x += dx;
            y += dy;
        }
        if ((countX == N) || (countX == N - 1 && countT == 1)) {
            System.out.println("Case #" + mCaseNum + ": X won");
            return true;
        } else if ((countO == N) || (countO == N - 1 && countT == 1)) {
            System.out.println("Case #" + mCaseNum + ": O won");
            return true;
        } else
            return false;
	}

    private static char[][] makeArray(int h, int w) {
        char[][] array = new char[h][];
        for (int i = 0; i < h; i++)
            array[i] = new char[w];
        return array;
    }
}