import java.io.InputStream;
import java.util.ArrayList;
import java.util.Scanner;

class Pseudominion {
	public static void main(String args[]) {
		TestCase[] testCases = TestCase.loadTestCases(System.in);
		for (int i=0; i<testCases.length; i++) {
//			testCases[i].dump();
			testCases[i].solve();
		}
	}
}

class TestCase {
	int mCaseNum;
	ArrayList<Card> mCards;
	ArrayList<Card> mDeck;
	
	public TestCase(int caseNum, ArrayList<Card> cards, ArrayList<Card> deck) {
		mCaseNum = caseNum;
		mCards = cards;
		mDeck = deck;
	}
	
	public static TestCase[] loadTestCases(InputStream is) {
		Scanner sc = new Scanner(is);
		int caseNum = Integer.parseInt(sc.nextLine());
		TestCase[] testCases = new TestCase[caseNum];
		for (int i=0; i<testCases.length; i++) {
			int n = sc.nextInt();
			sc.nextLine();
			ArrayList<Card> cards = new ArrayList<Card>();
			for (int j=0; j<n; j++) {
				cards.add(new Card(sc.nextInt(), sc.nextInt(), sc.nextInt()));
				sc.nextLine();
			}
			int m = sc.nextInt();
			sc.nextLine();
			ArrayList<Card> deck = new ArrayList<Card>();
			for (int j=0; j<m; j++) {
				deck.add(new Card(sc.nextInt(), sc.nextInt(), sc.nextInt()));
				sc.nextLine();
			}
			testCases[i] = new TestCase(i+1, cards, deck);
		}
		sc.close();
		return testCases;
	}
	
	public void dump() {
		System.out.println("case "+mCaseNum);
		System.out.println("mCards : "+mCards);
		System.out.println("mDeck  : "+mDeck);
	}
	
	public void solve() {
		int s = 0;
		int t = 1;
		Card pick;
		while(mCards.size() >= 1 && t >= 1) {
			if (t == 1) {
				pick = Card.chooseCard(mCards, Card.OT, Card.OS, Card.OC);
			} else {
				if (mCards.size() == 1 && mDeck.size() > 0) {
					pick = Card.chooseCard(mCards, Card.OC, Card.OS, Card.OT);
				} else {
					pick = Card.chooseCard(mCards, Card.OS, Card.OC, Card.OT);
				}
			}
			mCards.remove(pick);			
			t--;
			
			for (int i=0; i<pick.c(); i++) {
				if (mDeck.size() == 0) break;
				mCards.add(mDeck.remove(0));
			}
			s += pick.s();
			t += pick.t();			
		}

		System.out.println("Case #" + mCaseNum + ": " + s);
	}
}

class Card {
	public static final int OC = 0;
	public static final int OS = 1;
	public static final int OT = 2;
	private int[] cst = new int[3];
	
	Card(int c, int s, int t) {
		cst[OC] = c;
		cst[OS] = s;
		cst[OT] = t;
	}
	
	public int c() {
		return cst[OC];
	}
	public int s() {
		return cst[OS];
	}
	public int t() {
		return cst[OT];
	}
	public String toString() {
		return cst[0]+","+cst[1]+","+cst[2];
	}
	public static Card chooseCard(ArrayList<Card> cards, int order1, int order2, int order3) {
		Card max = null;
		for (int i=0; i<cards.size(); i++) {
			Card cur = cards.get(i);
			if (i == 0) max = cur;
			else {
				if (max.cst[order1] < cur.cst[order1]) {
					max = cur;
				} else if (max.cst[order1] == cur.cst[order1]) {
					if (max.cst[order2] < cur.cst[order2]) {
						max = cur;
					} else if (max.cst[order2] == cur.cst[order2]) {
						if (max.cst[order3] < cur.cst[order3]) {
							max = cur;
						}
					}
				}
			}
		}
		return max;
	}
}