import java.io.InputStream;
import java.util.Scanner;

class RPI {
	public static void main(String args[]) {
		TestCase[] testCases = TestCase.loadTestCases(System.in);
		for (int i=0; i<testCases.length; i++) {
//			testCases[i].dump();
			testCases[i].solve();
		}
	}
}

class TestCase {
	int mCaseNum;
	int[][] mRecord;
	private static final int WIN = 1;
	private static final int LOSE = 0;
	private static final int NO = -1;	
	
	public TestCase(int caseNum, int[][] record) {
		mCaseNum = caseNum;
		mRecord = record;
	}
	
	public static TestCase[] loadTestCases(InputStream is) {
		Scanner sc = new Scanner(is);
		int caseNum = Integer.parseInt(sc.nextLine());
		TestCase[] testCases = new TestCase[caseNum];
		for (int i=0; i<testCases.length; i++) {
			int n = sc.nextInt();
			sc.nextLine();
			int[][] record = makeArray(n, n);
			for (int r=0; r<n; r++) {
				String l = sc.nextLine();
				for (int c=0; c<n; c++) {
					if (l.charAt(c) == '0')
						record[r][c] = LOSE;
					else if (l.charAt(c) == '1')
						record[r][c] = WIN;
					else
						record[r][c] = NO;
				}
			}
			testCases[i] = new TestCase(i+1, record);
		}
		sc.close();
		return testCases;
	}
	
	public void dump() {
		System.out.println("case "+mCaseNum);
		for (int r=0; r<mRecord.length; r++) {
			for (int c=0; c<mRecord.length; c++) {
				System.out.print(mRecord[r][c]+" ");
			}
			System.out.println();
		}
		System.out.println();
	}
	
	public void solve() {
		int n = mRecord.length;
		double[] wp = new double[n];
		int[] wpd = new int[n];
		
		double[] owp = new double[n];
		double[] oowp = new double[n];
		int r, c, l;
		for (r=0; r<n; r++) {
			wpd[r] = 0;
			for (c=0; c<n; c++) {
				if (mRecord[r][c] != NO) {
					wp[r] += mRecord[r][c];
					wpd[r]++;
				}
			}
//			System.out.println("wp "+r+" : "+(wp[r] / wpd[r]));
		}
		
		for (r=0; r<n; r++) {
			l = 0;
			for (c=0; c<n; c++) {
				if (mRecord[r][c] != NO) {
					owp[r] += ((double)(wp[c] - mRecord[c][r]) / (wpd[c] - 1));
					l++;
				}
			}
			owp[r] /= l;
//			System.out.println("owp "+r+" : "+owp[r]);
		}
		
		for (r=0; r<n; r++) {
			wp[r] /= wpd[r];
		}
		
		for (r=0; r<n; r++) {
			l = 0;
			for (c=0; c<n; c++) {
				if (mRecord[r][c] != NO) {
					oowp[r] += owp[c];
					l++;
				}
			}
			oowp[r] /= l;
//			System.out.println("oowp "+r+" : "+oowp[r]);
		}
		
		System.out.println("Case #" + mCaseNum + ":");
		for (r=0; r<n; r++) {
			System.out.println(0.25 * wp[r] + 0.5 * owp[r] + 0.25 * oowp[r]);
		}
	}
	
	private static int[][] makeArray(int h, int w) {
		int[][] array = new int[h][];
		for (int i=0; i<h; i++)
			array[i] = new int[w];
		return array;
	}
}