import java.io.InputStream;
import java.util.Arrays;
import java.util.Collections;
import java.util.LinkedList;
import java.util.Scanner;

class CandySplitting {
	public static void main(String args[]) {
		TestCase[] testCases = TestCase.loadTestCases(System.in);
		for (int i=0; i<testCases.length; i++) {
//			testCases[i].dump();
			testCases[i].solve();
		}
	}
}

class TestCase {
	int mCaseNum;
	int[] mCandies;
	
	public TestCase(int caseNum, int[] candies) {
		mCaseNum = caseNum;
		mCandies = candies;
	}
	
	public static TestCase[] loadTestCases(InputStream is) {
		Scanner sc = new Scanner(is);
		int caseNum = Integer.parseInt(sc.nextLine());
		TestCase[] testCases = new TestCase[caseNum];
		for (int i=0; i<testCases.length; i++) {
			int numCandy = sc.nextInt();
			sc.nextLine();
			int[] candies = new int[numCandy];
			for (int j=0; j<numCandy; j++) {
				candies[j] = sc.nextInt();
			}
			testCases[i] = new TestCase(i+1, candies);
			sc.nextLine();
		}
		sc.close();
		return testCases;
	}
	
	public void dump() {
		System.out.println("case "+mCaseNum);
		for (int i=0; i<mCandies.length; i++)
			System.out.print(" "+mCandies[i]);
		System.out.println();
	}
	
	public void solve() {
		Arrays.sort(mCandies);
		long xorSum = 0;
		long sum = 0;
		for (int i=0; i<mCandies.length; i++) {
			xorSum ^= mCandies[i];
			sum += mCandies[i];
		}
		
		if (xorSum > 0)
			System.out.println("Case #" + mCaseNum + ": " + "NO");
		else
			System.out.println("Case #" + mCaseNum + ": " + (sum - mCandies[0]));
	}
}