import java.io.InputStream;
import java.util.Collections;
import java.util.LinkedList;
import java.util.Scanner;

class FreecellStatistics {
	public static void main(String args[]) {
		TestCase[] testCases = TestCase.loadTestCases(System.in);
		for (int i=0; i<testCases.length; i++) {
//			testCases[i].dump();
			testCases[i].solve();
		}
	}
}

class TestCase {
	int mCaseNum;
	int mN;
	int mPd;
	int mPg;
	
	public TestCase(int caseNum, int n, int pd, int pg) {
		mCaseNum = caseNum;
		mN = n;
		mPd = pd;
		mPg = pg;
	}
	
	public static TestCase[] loadTestCases(InputStream is) {
		Scanner sc = new Scanner(is);
		int caseNum = Integer.parseInt(sc.nextLine());
		TestCase[] testCases = new TestCase[caseNum];
		for (int i=0; i<testCases.length; i++) {
			int n = sc.nextInt();
			int pd = sc.nextInt();
			int pg = sc.nextInt();
			testCases[i] = new TestCase(i+1, n, pd, pg);
			sc.nextLine();
		}
		sc.close();
		return testCases;
	}
	
	public void dump() {
		System.out.println("case "+mCaseNum);
		System.out.println("n="+mN+","+mPd+","+mPg);
	}
	
	public void solve() {
		boolean possible = true;
		if ((mPg == 100 && mPd < 100) || (mPd > 0 && mPg == 0)) possible = false;
		else {
			int need2 = 2;
			int need5 = 2;
			if (mPd % 4 == 0) need2 = 0;
			else if (mPd % 2 == 0) need2 = 1;
			if (mPd % 25 == 0) need5 = 0;
			else if (mPd % 5 == 0) need5 = 1;
			int need = 1;
			int i;
			for (i=0; i<need2; i++)
				need *= 2;
			for (i=0; i<need5; i++)
				need *= 5;
			possible = mN >= need;
		}
		System.out.println("Case #" + mCaseNum + ": " + (possible ? "Possible" : "Broken"));
	}
}