import java.io.InputStream;
import java.util.Scanner;

class PerfectHarmony {
	public static void main(String args[]) {
		TestCase[] testCases = TestCase.loadTestCases(System.in);
		for (int i=0; i<testCases.length; i++) {
//			testCases[i].dump();
			testCases[i].solve();
		}
	}
}

class TestCase {
	int mCaseNum;
	long[] mNotes;
	long mLow;
	long mHigh;
	
	public TestCase(int caseNum, long[] notes, long low, long high) {
		mCaseNum = caseNum;
		mNotes = notes;
		mLow = low;
		mHigh = high;
	}
	
	public static TestCase[] loadTestCases(InputStream is) {
		Scanner sc = new Scanner(is);
		int caseNum = Integer.parseInt(sc.nextLine());
		TestCase[] testCases = new TestCase[caseNum];
		for (int i=0; i<testCases.length; i++) {
			int n = sc.nextInt();
			long l = sc.nextLong();
			long h = sc.nextLong();
			sc.nextLine();
			long[] notes = new long[n];
			for (int j=0; j<n; j++) {
				notes[j] = sc.nextLong();
			}
			testCases[i] = new TestCase(i+1, notes, l, h);
		}
		sc.close();
		return testCases;
	}
	
	public void dump() {
		System.out.println("case "+mCaseNum);
		System.out.println("L="+mLow+", H="+mHigh);
		for (int i=0; i<mNotes.length; i++) {
			System.out.print(mNotes[i]+" ");
		}
		System.out.println();
	}
	
	public void solve() {
		long answer = -1;
		for (long f=mLow; f<=mHigh; f++) {
			boolean possible = true;
			for (int i=0; i<mNotes.length; i++) {
				if ((mNotes[i] < f && (f % mNotes[i] > 0)) || (mNotes[i] >= f && (mNotes[i] % f > 0))) {
					possible = false;
					break;
				}
			}
			if (possible) {
				answer = f;
				break;
			}
		}
		if (answer >= 0)
			System.out.println("Case #" + mCaseNum + ": " + answer);
		else
			System.out.println("Case #" + mCaseNum + ": " + "NO");
	}
}