import java.io.InputStream;
import java.util.Scanner;

class A {	
	public static void main(String args[]) {
		TestCase[] testCases = TestCase.loadTestCases(System.in);
		for (int i=0; i<testCases.length; i++) {
			testCases[i].start(1);
		}
	}
}

class TestCase {
	int mCaseNum;
	int[][] mWires;
	
	public TestCase(int caseNum, int[][] wires) {
		mCaseNum = caseNum;
		mWires = wires;
	}
	
	public static TestCase[] loadTestCases(InputStream is) {
		Scanner sc = new Scanner(is);
		int caseNum = Integer.parseInt(sc.nextLine());
		TestCase[] testCases = new TestCase[caseNum];
		for (int t=0; t<testCases.length; t++) {
			int n = Integer.parseInt(sc.nextLine());
			int[][] wires = makeArray(n, 2);
			for (int i=0; i<n; i++) {
				wires[i][0] = sc.nextInt();
				wires[i][1] = sc.nextInt();
				sc.nextLine();
			}
			testCases[t] = new TestCase(t+1, wires);
		}
		sc.close();
		return testCases;
	}
	
	public void start(int mode) {
		if (mode == 0)
			dump();
		else {
			long startTime = System.currentTimeMillis();
			solve();
			long endTime = System.currentTimeMillis();
			//System.out.println("Time="+((endTime - startTime) / 1000));
		}
	}
	
	public void dump() {
		System.out.println("case "+mCaseNum);
		for (int i=0; i<mWires.length; i++)
			System.out.println(mWires[i][0]+"-"+mWires[i][1]);
	}
	
	public void solve() {
		int cnt = 0;
		for (int i=0; i<mWires.length-1; i++) 
			for (int j=i+1; j<mWires.length; j++) {
				if ((mWires[i][0] < mWires[j][0] && mWires[i][1] > mWires[j][1]) ||
					(mWires[i][0] > mWires[j][0] && mWires[i][1] < mWires[j][1])) {
					cnt++;
				}	
			}
		System.out.println("Case #" + mCaseNum + ": " + cnt);
	}

	private static int[][] makeArray(int h, int w) {
		int[][] array = new int[h][];
		for (int i=0; i<h; i++)
			array[i] = new int[w];
		return array;
	}
}