import java.io.InputStream;
import java.util.Scanner;

class Snapper {	
	public static void main(String args[]) {
		TestCase[] testCases = TestCase.loadTestCases(System.in);
		long startTime = System.currentTimeMillis();
		for (int i=0; i<testCases.length; i++) {
			//testCases[i].dump();
			testCases[i].solve();
			//testCases[i].solve2();
		}
		long endTime = System.currentTimeMillis();
		//System.out.println("Time="+((endTime - startTime) / 1000));
	}
}

class TestCase {
	int mCaseNum;
	int mSnapperNum;
	int mFingerNum;
	boolean[] mPower;
	boolean[] mState;
	
	public TestCase(int caseNum, int snapperNum, int fingerNum) {
		mCaseNum = caseNum;
		mSnapperNum = snapperNum;
		mFingerNum = fingerNum;
		mPower = new boolean[mSnapperNum];
		mState = new boolean[mSnapperNum];
		mPower[0] = true;
	}
	
	public static TestCase[] loadTestCases(InputStream is) {
		Scanner sc = new Scanner(is);
		int caseNum = Integer.parseInt(sc.nextLine());
		TestCase[] testCases = new TestCase[caseNum];
		for (int i=0; i<testCases.length; i++) {
			int snapperNum = sc.nextInt();
			int fingerNum = sc.nextInt();
			sc.nextLine();
			testCases[i] = new TestCase(i+1, snapperNum, fingerNum);
		}
		sc.close();
		return testCases;
	}
	
	public void dump() {
		System.out.println("case "+mCaseNum);		
		System.out.println("Case " + mCaseNum + ", Snapper "+mSnapperNum + ", Finger "+mFingerNum);
	}
	
	public void solve() {
		/*
		for (int i=1; i<=mFingerNum; i++) {
			for (int j=0; j<mSnapperNum; j++) {
				if (mPower[j])
					mState[j] = !mState[j];
			}
			for (int j=1; j<mSnapperNum; j++)
				mPower[j] = mPower[j-1] && mState[j-1];
			
			for (int j=0; j<mSnapperNum; j++) {
				if (mPower[j] != P(j, i))
					System.out.println("Finger "+i+", Snap "+j+" : Power = " + mPower[j] + " / " + P(j, i));
				if (mState[j] != S(j, i))
					System.out.println("Finger "+i+", Snap "+j+" : State = " + mState[j] + " / " + S(j, i));
			}
		}
		*/
		boolean light = P(mSnapperNum-1, mFingerNum) && S(mSnapperNum-1, mFingerNum);
		System.out.println("Case #" + mCaseNum + ": " + (light ? "ON" : "OFF"));
		//System.out.println("Case #" + mCaseNum + ": Power " + mPower[mSnapperNum - 1] + ", State " + mState[mSnapperNum - 1]);
	}

	private boolean P(int snapperNum, int fingerNum) {
		int interval = (int) Math.pow(2, snapperNum);
		return ((fingerNum + 1) % interval == 0);
	}
	
	private boolean S(int snapperNum, int fingerNum) {
		int interval = (int) Math.pow(2, snapperNum + 1);
		return ((fingerNum % interval) / (interval / 2) == 1);
	}
}