import java.io.InputStream;
import java.util.HashSet;
import java.util.Scanner;

class A {	
	public static void main(String args[]) {
		TestCase[] testCases = TestCase.loadTestCases(System.in);
		for (int i=0; i<testCases.length; i++) {
			testCases[i].start(1);
		}
	}
}

class TestCase {
	int mCaseNum;
	String[] mExist;
	String[] mCreate;
	
	public TestCase(int caseNum, String[] exist, String[] create) {
		mCaseNum = caseNum;
		mExist = exist;
		mCreate = create;
	}
	
	public static TestCase[] loadTestCases(InputStream is) {
		Scanner sc = new Scanner(is);
		int caseNum = Integer.parseInt(sc.nextLine());
		TestCase[] testCases = new TestCase[caseNum];
		for (int t=0; t<testCases.length; t++) {
			int n = sc.nextInt();
			int m = sc.nextInt();
			sc.nextLine();
			String[] exist = new String[n];
			for (int i=0; i<n; i++)
				exist[i] = sc.nextLine();
			String[] create = new String[m];
			for (int i=0; i<m; i++)
				create[i] = sc.nextLine();
			testCases[t] = new TestCase(t+1, exist, create);
		}
		sc.close();
		return testCases;
	}
	
	public void start(int mode) {
		if (mode == 0)
			dump();
		else {
			long startTime = System.currentTimeMillis();
			solve();
			long endTime = System.currentTimeMillis();
			//System.out.println("Time="+((endTime - startTime) / 1000));
		}
	}
	
	public void dump() {
		System.out.println("case "+mCaseNum);
		System.out.println("Exist");
		for (int i=0; i<mExist.length; i++)
			System.out.println(mExist[i]);
		System.out.println("Create");
		for (int i=0; i<mCreate.length; i++)
			System.out.println(mCreate[i]);
	}
	
	public void solve() {
		int cnt = 0;
		HashSet<String> s = new HashSet<String>();
		for (int i=0; i<mExist.length; i++)
			createDir(s, mExist[i]);
		for (int i=0; i<mCreate.length; i++)
			cnt += createDir(s, mCreate[i]);
		System.out.println("Case #" + mCaseNum + ": " + cnt);
	}
	
	private int createDir(HashSet<String> s, String dir) {
		int cnt = 0;
		int prev = 0;
		while(true) {
			int idx = dir.indexOf('/', prev+1);
			prev = idx;
			String sub = (idx < 0 ? dir : dir.substring(0, idx));
			if (!s.contains(sub)) {
				s.add(sub);
				cnt++;
			}
			if (prev < 0)
				break;
		}
		return cnt;
	}
}