import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;

/**
 * Created by eason on 9/4/16.
 */
public class Program {

    public static void main(String[] args) {
        try (Scanner cin = new Scanner(System.in)) {
            int count = cin.nextInt();
            for (int i = 1; i <= count; i++) {
                int origSize = cin.nextInt();
                int generationCount = cin.nextInt();
                int allowance = cin.nextInt();
                System.out.println(String.format(
                        "Case #%d: %s", i, describe(origSize, generationCount, allowance)));
            }
        }
    }

    private static String describe(int origSize, int generationCount, int allowance) {
        List<BigInteger> guesses = solve(origSize, generationCount, allowance);
        return String.join(" ", guesses
                        .stream()
                        .map(BigInteger::toString)
                        .collect(Collectors.toList()));
    }

    private static List<BigInteger> solve(int origSize, int generationCount, int allowance) {
        List<BigInteger> answer = new ArrayList<>(origSize);
        BigInteger branchSize = myExp(origSize, generationCount);
        BigInteger guess = new BigInteger("1");
        for (int i = 0; i < origSize; i++) {
            answer.add(guess);
            guess = guess.add(branchSize);
        }
        return answer;
    }

    private static BigInteger myExp(int origSize, int generationCount) {
        BigInteger base = new BigInteger(Integer.toString(origSize));
        return base.pow(generationCount - 1);
    }

}
