import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.security.SecureRandom;
import java.util.StringTokenizer;
          
public class Main {
	private static final BigInteger TWO = new BigInteger("2");     
	public static SecureRandom random = new SecureRandom();
    public static StringBuffer sb = new StringBuffer();
    
    public static void main(String[] arg) throws IOException {
         
         BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
         
         int T = Integer.parseInt(br.readLine());
         
         
         for(int t = 1 ; t <= T ; t++){
        	 sb.append("Case #"+t+":\n");
        	 StringTokenizer st = new StringTokenizer(br.readLine());
        	 
        	 int num = Integer.parseInt(st.nextToken());
        	 
        	 long startNum = (1l<<(num-1))+1l;
        	 long endNum = (1l<<num)-1l;
        	 
        	 createNumber(startNum, endNum, Integer.parseInt(st.nextToken()));
         }
         
         System.out.println(sb.toString());
         
         
    }

    private static void createNumber(long startNum, long endNum, int cnt) {
    	long dest = startNum;
    	
    	BigInteger[] numbers = new BigInteger[11];
    	
    	
    	while(cnt > 0){
    		
    		boolean isInPrime = false;
    		
    		for(int i = 2 ; i <= 10 ; i++){
    			numbers[i] = new BigInteger(Long.toBinaryString(dest), i);
        		if(numbers[i].isProbablePrime(17)){
        			dest += 2;
            		if(dest > endNum){
            			return;
            		}
            		isInPrime = true;
        			break;
        		}
    		}
    		
    		if(isInPrime){
    			continue;
    		}
    		
    		sb.append(Long.toBinaryString(dest));
    			
    		for(int i = 2 ; i <= 10 ; i++){
    			sb.append(" ");
    			BigInteger result = null;
				do{
					result = pollardRho(numbers[i]);
				}while(result.compareTo(numbers[i])==0);
				
				sb.append(result);
			}
			sb.append("\n");
			
			dest += 2;
			
			cnt -= 1;

    	}
		
	}

	private static BigInteger pollardRho(BigInteger n) {
        
        if(n.mod(TWO).compareTo(BigInteger.ZERO) == 0){
            return TWO;
        }
         
        BigInteger factor = BigInteger.ONE; 
        BigInteger a = new BigInteger(n.bitLength(), random);
        BigInteger b = a;
        BigInteger c = new BigInteger(n.bitLength(), random);
         
        while(factor.compareTo(BigInteger.ONE) == 0){
             
            a = a.multiply(a).add(c).mod(n);
            b = b.multiply(b).add(c).mod(n);
            b = b.multiply(b).add(c).mod(n);
             
            factor = a.subtract(b).abs().gcd(n);
        }
         
        return factor;
    }      
     
}