import static java.lang.Math.sqrt;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Set;
import java.util.StringTokenizer;

public class D {
	
	private static BufferedReader in;
	private static PrintWriter out;
	private static StringTokenizer tok;
	
	private static final double MEPS = 0x1P-32;
	private static final double EPS = 0x1P-28;
	
	private static double sqr(double x) {
		return x * x;
	}
	
	private static double distsqr(double x1, double y1, double x2, double y2) {
		return sqr(x1 - x2) + sqr(y1 - y2);
	}
	
	private static void solve(int test) throws Exception {
		int n = nextInt();
		int x[] = new int[n];
		int y[] = new int[n];
		int r[] = new int[n];
		for (int i = 0; i < n; i++) {
			x[i] = nextInt();
			y[i] = nextInt();
			r[i] = nextInt();
		}
		double al = 0;
		for (int i = 0; i < n; i++) {
			if (al < r[i]) {
				al = r[i];
			}
		}
		double ar = 0x1P16;
		while (ar - al > 0x1P-32) {
			double am = (al + ar) / 2;
			Set<Long> sets = new HashSet<Long>();
			for (int i = 0; i < n; i++) {
				sets.add(1L << i);
			}
			for (int i = 1; i < n; i++) {
				for (int j = 0; j < i; j++) {
					double x1 = x[i];
					double y1 = y[i];
					double r1 = am - r[i];
					double x2 = x[j];
					double y2 = y[j];
					double r2 = am - r[j];
					double dist = sqrt(distsqr(x1, y1, x2, y2));
					if (dist > r1 + r2 + MEPS) {
						continue;
					}
					if (dist > r1 + r2 - MEPS) {
						dist = r1 + r2;
					}
					double cos = (sqr(r1) + sqr(dist) - sqr(r2)) / (2 * r1 * dist);
					if (cos > 1 + MEPS || cos < -1 - MEPS) {
						throw new AssertionError();
					}
					if (cos > 1 - MEPS) {
						cos = 1;
					}
					if (cos < -1 + MEPS) {
						cos = -1;
					}
					double p = (r1 + r2 + dist) / 2;
					double sin = sqrt(p * (p - r1) * (p - r2) * (p - dist)) * 2 / dist / r1;
					double dx = (x2 - x1) / dist * r1;
					double dy = (y2 - y1) / dist * r1;
					{
						double tx = dx * cos - dy * sin + x1;
						double ty = dx * sin + dy * cos + y1;
						long set = 0;
						for (int k = 0; k < n; k++) {
							if (1 + EPS >= distsqr(x[k], y[k], tx, ty) / sqr(am - r[k])) {
								set |= 1L << k;
							}
						}
						if ((set & (1L << i)) == 0 || (set & (1L << j)) == 0) {
							throw new AssertionError();
						}
						sets.add(set);
					}
					{
						double tx = dx * cos - dy * sin + x1;
						double ty = dx * sin + dy * cos + y1;
						long set = 0;
						for (int k = 0; k < n; k++) {
							if (1 + EPS >= distsqr(x[k], y[k], tx, ty) / sqr(am - r[k])) {
								set |= 1L << k;
							}
						}
						if ((set & (1L << i)) == 0 || (set & (1L << j)) == 0) {
							throw new AssertionError();
						}
						sets.add(set);
					}
				}
			}
			long lsets[] = new long[sets.size()];
			int pos = 0;
			for (long set: sets) {
				lsets[pos++] = set;
			}
			boolean res = false;
			long check = (1L << n) - 1L;
			for (int i = 0; i < lsets.length; i++) {
				for (int j = 0; j < i; j++) {
					if ((lsets[i] | lsets[j]) == check) {
						res = true;
						break;
					}
				}
				if (lsets[i] == check) {
					res = true;
				}
				if (res) {
					break;
				}
			}
			if (res) {
				ar = am;
			} else {
				al = am;
			}
		}
		out.println("Case #" + test + ": " + al);
	}
	
	private static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	private static long nextLong() throws IOException {
		return Long.parseLong(next());
	}
	
	private static String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	public static void main(String[] args) throws Exception {
		in = new BufferedReader(new InputStreamReader(new FileInputStream("d.in")));
		out = new PrintWriter(new OutputStreamWriter(new FileOutputStream("d.out")));
		int t = nextInt();
		for (int i = 0; i < t; ++i) {
			solve(i + 1);
		}
		in.close();
		out.close();
	}
}
