import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;
import java.util.StringTokenizer;

public class B {
	
	static BufferedReader in;
	static PrintWriter out;
	static StringTokenizer tok;
	
	static int set[];
	
	static int getSet(int i) {
		if (set[i] != i) {
			set[i] = getSet(set[i]);
		}
		return set[i];
	}
	
	static final Random rng = new Random();
	
	static void join(int i, int j) {
		i = getSet(i);
		j = getSet(j);
		if (i != j) {
			if (rng.nextBoolean()) {
				set[i] = j;
			} else {
				set[j] = i;
			}
		}
	}

	public static void main(String args[]) throws Exception {
		in = new BufferedReader(new InputStreamReader(new FileInputStream("b.in")));
		out = new PrintWriter(new OutputStreamWriter(new FileOutputStream("b.out")));
		int T = nextInt();
		for (int t = 0; t < T; t++) {
//			System.out.println("Beginning test " + (t + 1));
			int h = nextInt();
			int w = nextInt();
			int map[][] = new int[h][w];
			for (int y = 0; y < h; y++) {
				for (int x = 0; x < w; x++) {
					map[y][x] = nextInt();
				}
			}
			set = new int[h * w];
			for (int i = 0; i < set.length; i++) {
				set[i] = i;
			}
			for (int y = 0; y < h; y++) {
				for (int x = 0; x < w; x++) {
					int mh = map[y][x];
					int mc = -1;
					if (y > 0 && map[y - 1][x] < mh) {
						mh = map[y - 1][x];
						mc = w * (y - 1) + x;
					}
					if (x > 0 && map[y][x - 1] < mh) {
						mh = map[y][x - 1];
						mc = w * y + x - 1;
					}
					if (x < w - 1 && map[y][x + 1] < mh) {
						mh = map[y][x + 1];
						mc = w * y + x + 1;
					}
					if (y < h - 1 && map[y + 1][x] < mh) {
						mh = map[y + 1][x];
						mc = w * (y + 1) + x;
					}
					if (mc >= 0) {
//						System.out.println("Flow from (" + x + ", " + y + ") to (" + mc % w + ", " + mc / w + ")");
						join(w * y + x, mc);
					}
				}
			}
			out.println("Case #" + (t + 1) + ":");
			Map<Integer, Character> chars = new HashMap<Integer, Character>();
			for (int y = 0; y < h; y++) {
				for (int x = 0; x < w; x++) {
					int set = getSet(w * y + x);
					if (!chars.containsKey(set)) {
						chars.put(set, (char) ('a' + chars.size()));
					}
					out.print(chars.get(set));
					out.print(' ');
				}
				out.println();
			}
		}
		in.close();
		out.close();
	}
	
	static String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}
	
	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
}