import static java.lang.Integer.parseInt;
import static java.lang.Long.parseLong;

import java.io.*;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;

public class B {
	
	static BufferedReader in;
	static PrintWriter out;
	static StringTokenizer tok;
	
	static class Pair {
		final char a, b;

		Pair(char a, char b) {
			if (a > b) {
				char t = a;
				a = b;
				b = t;
			}
			this.a = a;
			this.b = b;
		}
		
		public boolean equals(Object obj) {
			if (!(obj instanceof Pair)) {
				return false;
			}
			Pair pair = (Pair) obj;
			return a == pair.a && b == pair.b;
		}
		
		public int hashCode() {
			return (a << 16) | b;
		}
	}
	
	static void solveTest() throws Exception {
		Map<Pair, Character> pairs = new HashMap<Pair, Character>();
		int n = nextInt();
		for (int i = 0; i < n; i++) {
			String s = next();
			if (s.length() != 3) {
				throw new AssertionError();
			}
			pairs.put(new Pair(s.charAt(0), s.charAt(1)), s.charAt(2));
		}
		n = nextInt();
		Pair bad[] = new Pair[n];
		for (int i = 0; i < n; i++) {
			String s = next();
			if (s.length() != 2) {
				throw new AssertionError();
			}
			bad[i] = new Pair(s.charAt(0), s.charAt(1));
		}
		n = nextInt();
		String s = next();
		if (s.length() != n) {
			throw new AssertionError();
		}
		StringBuilder cur = new StringBuilder();
		Map<Character, Integer> counts = new HashMap<Character, Integer>();
		for (int i = 0; i < n; i++) {
			char c = s.charAt(i);
			while (cur.length() > 0) {
				char pc = cur.charAt(cur.length() - 1);
				Pair p = new Pair(pc, c);
				Character res = pairs.get(p);
				if (res != null) {
					cur.setLength(cur.length() - 1);
					int cnt = counts.get(pc) - 1;
					if (cnt == 0) {
						counts.remove(pc);
					} else {
						counts.put(pc, cnt);
					}
					c = res;
				} else {
					break;
				}
			}
			cur.append(c);
			{
				Integer cnt = counts.get(c);
				counts.put(c, cnt == null ? 1 : cnt + 1);
			}
			for (Pair p: bad) {
				if (counts.containsKey(p.a) && counts.containsKey(p.b)) {
					cur.setLength(0);
					counts.clear();
					break;
				}
			}
		}
		out.print('[');
		for (int i = 0; i < cur.length(); i++) {
			if (i > 0) {
				out.print(", ");
			}
			out.print(cur.charAt(i));
		}
		out.println(']');
	}
	
	static void solve() throws Exception {
		int tests = nextInt();
		for (int test = 1; test <= tests; test++) {
			out.print("Case #" + test + ": ");
			solveTest();
		}
	}

	public static void main(String[] args) throws Exception {
		System.out.print("Enter filename: ");
		System.out.flush();
		String filename = new BufferedReader(new InputStreamReader(System.in)).readLine();
		in = new BufferedReader(new InputStreamReader(
			new FileInputStream(new File(filename + ".in"))));
		out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(
			new FileOutputStream(new File(filename + ".out")))));
		solve();
		in.close();
		out.close();
	}
	
	static String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}
	
	static char nextChar() throws IOException {
		String token = next();
		if (token.length() != 1) {
			throw new IllegalArgumentException("String \"" + token + "\" is not a single character");
		}
		return token.charAt(0);
	}
	
	static int nextInt() throws IOException {
		return parseInt(next());
	}
	
	static long nextLong() throws IOException {
		return parseLong(next());
	}
	
	static BigInteger nextBigInt() throws IOException {
		return new BigInteger(next());
	}
}