import static java.lang.Integer.parseInt;
import static java.math.BigInteger.ZERO;

import java.io.*;
import java.math.BigInteger;
import java.util.StringTokenizer;

public class C {
	
	static BufferedReader in;
	static PrintWriter out;
	static StringTokenizer tok;
	
	static void solveTest() throws Exception {
		BigInteger r = nextBigInt();
		BigInteger k = nextBigInt();
		int n = nextInt();
		BigInteger g[] = new BigInteger[n];
		for (int i = 0; i < n; i++) {
			g[i] = nextBigInt();
		}
		int next[] = new int[n];
		BigInteger profit[] = new BigInteger[n];
		{
			int j = 0;
			BigInteger curProfit = ZERO;
			for (int i = 0; i < n; i++) {
				if (i == j) {
					curProfit = curProfit.add(g[j]);
					j = (j + 1) % n;
				}
				while (j != i && curProfit.add(g[j]).compareTo(k) <= 0) {
					curProfit = curProfit.add(g[j]);
					j = (j + 1) % n;
				}
				next[i] = j;
				profit[i] = curProfit;
				curProfit = curProfit.subtract(g[i]);
			}
		}
		int map[] = new int[n];
		BigInteger money[] = new BigInteger[n];
		for (int i = 0; i < n; i++) {
			map[i] = i;
			money[i] = ZERO;
		}
		for (int bit = r.bitLength() - 1; bit >= 0; --bit) {
			{
				int newMap[] = new int[n];
				BigInteger newMoney[] = new BigInteger[n];
				for (int i = 0; i < n; i++) {
					newMap[i] = map[map[i]];
					newMoney[i] = money[i].add(money[map[i]]);
				}
				map = newMap;
				money = newMoney;
			}
			if (r.testBit(bit)) {
				int newMap[] = new int[n];
				BigInteger newMoney[] = new BigInteger[n];
				for (int i = 0; i < n; i++) {
					newMap[i] = next[map[i]];
					newMoney[i] = money[i].add(profit[map[i]]);
				}
				map = newMap;
				money = newMoney;
			}
		}
		out.println(money[0]);
	}
	
	static void solve() throws Exception {
		int tests = nextInt();
		for (int test = 1; test <= tests; test++) {
			out.print("Case #" + test + ": ");
			solveTest();
		}
	}

	public static void main(String[] args) throws Exception {
		System.out.print("Enter filename: ");
		System.out.flush();
		String filename = new BufferedReader(new InputStreamReader(System.in)).readLine();
		in = new BufferedReader(new InputStreamReader(
			new FileInputStream(new File(filename + ".in"))));
		out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(
			new FileOutputStream(new File(filename + ".out")))));
		solve();
		in.close();
		out.close();
	}
	
	static String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}
	
	static int nextInt() throws IOException {
		return parseInt(next());
	}
	
	static BigInteger nextBigInt() throws IOException {
		return new BigInteger(next());
	}
}