import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.StringTokenizer;


public class BotTrust {

	/**
	 * @param args
	 */
	private static ArrayList<String> colors = new ArrayList<String>();
	private static ArrayList<Integer> buttons = new ArrayList<Integer>();
	
	private static int getNextTarget(int bot){
		if (bot == 0){//blue bot
			for (int i = 0; i < colors.size(); i++){
				if (colors.get(i).equals("B"))
					return buttons.get(i);
			}
		} else { //orange bot
			for (int i = 0; i < colors.size(); i++){
				if (colors.get(i).equals("O"))
					return buttons.get(i);
			}
		}		
		return -1;		
	}
	public static void main(String[] args) {
		try{
		    // Open the file that is the first 
		    // command line parameter
		    FileInputStream fstream = new FileInputStream("A-small-attempt0.in");
		    // Get the object of DataInputStream
		    DataInputStream in = new DataInputStream(fstream);
		        BufferedReader br = new BufferedReader(new InputStreamReader(in));
		    //Read File Line By Line
		    int numTests = Integer.parseInt(br.readLine());
		    for (int i = 0; i < numTests; i++)   {
		      StringTokenizer st = new StringTokenizer(br.readLine());
		      int numButtons = Integer.parseInt(st.nextToken());
		      //System.out.println("num buttons = " + numButtons);
		      
		      
		      for (int j = 0; j < numButtons; j++){
		    	  colors.add(st.nextToken());
		    	  buttons.add(Integer.parseInt(st.nextToken()));		    	  
		      }
		      //System.out.println("TEST READ");
		      //System.out.println(colors);
		      //System.out.println(buttons);
		      //MAIN LOOP FOR EACH CASE
		      String turn = colors.get(0);
		      int step = 1;
		      int orangePos = 1;
		      int bluePos = 1;
		      int blueTarget = getNextTarget(0);
		      int orangeTarget = getNextTarget(1);
		      //System.out.println(blueTarget);
		      //System.out.println(orangeTarget);

		      while (true){
		    	  //Blue moves
		    	  boolean buttonFoundThisTurn = false;
		    	  if (blueTarget != -1) {
			    	  if (bluePos < blueTarget) {
			    		  bluePos++;
			    	  } else if (bluePos > blueTarget){
			    		  bluePos--;
			    	  } else if (turn.equals("B")) {
			    		  //push button
			    		  colors.remove(0);
			    		  buttons.remove(0);
			    		  blueTarget = getNextTarget(0);
			    		  buttonFoundThisTurn = true;
			    	  }
		    	  }
		    	  
		    	  //Orange moves
		    	  if (orangeTarget != -1) {
			    	  if (orangePos < orangeTarget) {
			    		  orangePos++;
			    	  } else if (orangePos > orangeTarget){
			    		  orangePos--;
			    	  } else if (turn.equals("O")) {
			    		  //push button
			    		  colors.remove(0);
			    		  buttons.remove(0);
			    		  orangeTarget = getNextTarget(1);
			    		  buttonFoundThisTurn = true;
			    	  }
		      	 }
		    	  
		    	  if (buttonFoundThisTurn) {
		    		  if (colors.size() == 0)
		    			  break;
		    		  turn = colors.get(0);
		    	  }
		    	  step++;
		      }
		      System.out.println("Case #" + (i+1) + ": "+step);

		    }
		    //Close the input stream
		    in.close();
		}catch (Exception e){//Catch exception if any
		      System.err.println("Error: " + e.getMessage());
		}

	}

}
