import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.StringTokenizer;

public class Magicka {


	/**
	 * @param args
	 */
	private static HashMap<String, String> combos = new HashMap<String, String>();
	private static HashSet<String> opposed = new HashSet<String>();
	private static ArrayList<Character> invokeArray = new ArrayList<Character>();
	
	public static void main(String[] args) {
		try{
		    // Open the file that is the first 
		    // command line parameter
		    FileInputStream fstream = new FileInputStream("MagickaFiles/B-large.in");
		    // Get the object of DataInputStream
		    DataInputStream in = new DataInputStream(fstream);
		        BufferedReader br = new BufferedReader(new InputStreamReader(in));
		    //Read File Line By Line
		    int numTests = Integer.parseInt(br.readLine());
		    for (int i = 0; i < numTests; i++)   {
		      StringTokenizer st = new StringTokenizer(br.readLine());
		      int numCombos = Integer.parseInt(st.nextToken());
		      //System.out.println("num combos = " + numCombos);
		      
		      //Build combo lookup
		      for (int j = 0; j < numCombos; j++){
		    	  String combo = st.nextToken();
		    	  char charA = Character.toUpperCase(combo.charAt(0));
		    	  char charB = Character.toUpperCase(combo.charAt(1));
		    	  String elems = "";
		    	  if (charA < charB) {
		    		  elems += charA;
		    		  elems += charB;
		    	  } else {
		    		  elems += charB;
		    		  elems += charA;
		    	  }
		    	  String result = combo.substring(2);
		    	  combos.put(elems, result);
		      }
		  
		      int numOpposed = Integer.parseInt(st.nextToken());
		      //System.out.println("num opposed = " + numOpposed);
		      for (int j = 0; j < numOpposed; j++){
		    	  String opposedPair = st.nextToken().toUpperCase();
		    	  String opposedPairAlt = "";
		    	  opposedPairAlt += opposedPair.charAt(1);
		    	  opposedPairAlt += opposedPair.charAt(0);
		    	  //System.out.println("Adding " + opposedPair + " and " + opposedPairAlt + " to opposition set");
		    	  opposed.add(opposedPairAlt);
		    	  opposed.add(opposedPair);
		      }
		      
		      int numElems = Integer.parseInt(st.nextToken());
		      String elementString = st.nextToken();
		      invokeArray.add(elementString.charAt(0));
		      for (int j = 1; j < numElems; j++){
		    	  

		    	  //First add and apply combos
		    	  Character next = elementString.charAt(j);

		    	  if (invokeArray.size() > 0){
			    	  Character prev = invokeArray.get(invokeArray.size() -1);
			    	  String comboCheck = "";
			    	  if (prev < next){
			    		  comboCheck += prev;
			    		  comboCheck += next;
			    	  } else {
			    		  comboCheck += next;
			    		  comboCheck += prev;
			    	  }
			    	  if (combos.containsKey(comboCheck)){
			    		  invokeArray.remove(invokeArray.size() - 1);	
			    		  invokeArray.add(combos.get(comboCheck).charAt(0));
			    		  continue;
			    	  } else {
			    		  invokeArray.add(next);
			    	  }
			    	  
			    	  //Second, clear array if any oppose pairs exist
	
			    	  for (int k = 0; k < invokeArray.size() - 1; k++){
			    		  char candidate = invokeArray.get(k);
			    		  String opposeCheck = "";
			    		  opposeCheck += candidate;
			    		  opposeCheck += next;

			    		  if (opposed.contains(opposeCheck)){
			    			  invokeArray.clear();
			    		  }
			    	  }
		    	  } else {
		    		  invokeArray.add(next);
		    	  }
		    	  

		      }
		       System.out.println("OPPOSITION SET: " + opposed);
		       System.out.println("LEXICOGRAPHICALLY ORDERED COMBOS: " + combos);
		      System.out.println("Case #" + (i+1) + ": " + invokeArray);
		      opposed.clear();
		      combos.clear();
		      invokeArray.clear();

		    }
		    //Close the input stream
		    in.close();
		}catch (Exception e){//Catch exception if any
		      System.err.println("Error: " + e.getMessage());
		}

	}

}
