/*
PROBLEM: Multi-base happiness
LANGUAGE: Java
CONTESTANT: Aram Ebtekar
*/

import java.io.*;
import java.util.*;

public class NextNumber
{
	public static void main(String[] args) throws IOException
	{
		BufferedReader in = new BufferedReader(new FileReader("B.in"));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("B.out")));
		
		int T = Integer.parseInt(in.readLine());
		
		for (int caseNum = 1; caseNum <= T; caseNum++)
		{
			char[] N = in.readLine().toCharArray();
			int[] digits = new int[N.length+1];
			
			digits[N.length] = 0; 
			for (int i = 0; i < N.length; i++)
			{
				digits[N.length - i - 1] = Integer.parseInt(Character.toString(N[i]));
			}
			
			int switchIndex = -1;
			
			for (int i = 1; switchIndex == -1 && i < digits.length; i++)
			{
				for (int j = 0; j < i; j++)
				{
					if (digits[j] > digits[i] && (switchIndex == -1 || digits[j] < digits[switchIndex]))
						switchIndex = j;
				}
				
				if (switchIndex != -1)
				{
					int temp = digits[switchIndex];
					digits[switchIndex] = digits[i];
					digits[i] = temp;
					for (int j = 1; j < i; j++)
					{
						for (int k = j; k > 0 && digits[k] > digits[k-1]; k--) 
						{
							int temp2 = digits[k];
							digits[k] = digits[k-1];
							digits[k-1] = temp2;
						}
					}
				}
			}
			
			out.print("Case #" + caseNum + ": ");
			if (digits[N.length] != 0)
				out.print(digits[N.length]);
			for (int i = N.length - 1; i >= 0; i--)
				out.print(digits[i]);
			out.println();
			
		}
		
		in.close();
		out.close();
		System.exit(0);
	}
}
