package q1;

import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class Magician {
	private final static int DIMENSION = 4;

	private final Scanner scanner = new Scanner(System.in);
	
	private void skipRow() {
		for(int i=0;i<DIMENSION;i++)
			scanner.nextInt();
	}
	
	private Set<Integer> readCandidates() {
		Set<Integer> candidates = new HashSet<>();
		
		int row = scanner.nextInt();
		//System.err.println("Row number: " + row);
		int curr_row=1;
		while(curr_row < row) {
			skipRow();
			curr_row++;
		}
		//System.err.println("Curr row: " + curr_row);
		for(int i=0 ; i< DIMENSION; i++) {
			candidates.add(scanner.nextInt());
		}
		curr_row++;
		
		while(curr_row <= DIMENSION) {
			skipRow();
			curr_row++;
		}
		
		return candidates;
	}
	
	public void findCard(int caseNo) {
		Set<Integer> cand1 = readCandidates();
		Set<Integer> cand2 = readCandidates();
		cand1.retainAll(cand2);
		
		String result;
		switch(cand1.size()) {
		case 1:
			result = String.valueOf(cand1.iterator().next());
			break;
		case 0:
			result = "Volunteer cheated!";
			break;
		default:
			result = "Bad magician!";
			break;
		}
		
		System.out.println("Case #" + caseNo + ": " + result);
	}
	
	public void runCases() {
		int caseCount = scanner.nextInt();
		for (int i = 0; i < caseCount; i ++) {
			findCard(i+1);
		}
	}
	
	public static void main(String[] args) {
		Magician me = new Magician();
		me.runCases();
	}
}
