package q3;

import java.util.LinkedList;
import java.util.Scanner;

public class MineSweeper {
	public MineSweeper(int r, int c, int m) {
		super();
		R = r;
		C = c;
		M = m;
	}


	private int R, C, M;
	private int lastClickR, lastClickC;
	
	public void solve() {
		boolean hasSolution = false;
		LinkedList<BoardState> queue = new LinkedList<BoardState>();
		queue.add(new BoardState(R,C));
		while(!queue.isEmpty()) {
			BoardState bs = queue.removeLast();
			if(hasSolution(bs)) {
				if(bs.mineCount()==M) {
					printSolution(bs);
					hasSolution=true;
					break;
				}
				else if(bs.mineCount()<M){
					for(int i=0;i<R;i++) {
						for(int j=0;j<C;j++) {
							if (!bs.hasMine(i, j)) {
								BoardState newBS = new BoardState(bs);
								newBS.addMine(i, j);
								queue.add(newBS);
							}
						}
					}
				}
			}
		}
		if(!hasSolution)
			System.out.println("Impossible");
	}
	
	private void printSolution(BoardState bs) {
		for(int i=0;i<R;i++) {
			for(int j=0;j<C;j++) {
				if(i==lastClickR && j==lastClickC) {
					System.out.print("c");
				}
				else if(bs.hasMine(i, j)) {
					System.out.print("*");
				}
				else {
					System.out.print(".");
				}
			}
			System.out.println();
		}
	}
	
	private boolean hasSolution(BoardState bs) {
		for(int i=0;i<R;i++)
			for(int j=0;j<C;j++)
				if(bs.click(i, j)) {
					lastClickR = i;
					lastClickC = j;
					return true;
				}
		return false;
	}
	
	public static void main(String[] args) {
		Scanner s = new Scanner(System.in) ;
		
		int count = s.nextInt();
		
		for (int i=0;i<count;i++) {
			MineSweeper ms = new MineSweeper(s.nextInt(), s.nextInt(), s.nextInt());
			System.out.println("Case #"+(i+1) + ":");
			ms.solve();
		}
	}
}
