package codejamfilefixit;

import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedList;
import java.util.Scanner;

public class Main {

    long mkdirs = 0;

    public static void main(String[] args) {
        new Main().run();
    }

    void run() {
        Scanner a = new Scanner(System.in);
        int numtests = a.nextInt();
        for (int test = 1; test <= numtests; test++) {
            Dir root = new Dir();
            int N = a.nextInt();
            int M = a.nextInt();
            for (int n = 0; n < N; n++) {
                String path = a.next();
                root.traverseAndCreate(stringToPath(path));
            }
            mkdirs = 0;
            ArrayList<String> newPaths = new ArrayList<String>(M);
            for (int m = 0; m < M; m++) {
                newPaths.add(a.next());
            }
            Collections.sort(newPaths);
            for (String path : newPaths) {
                root.traverseAndCreate(stringToPath(path));
            }
            System.out.println("Case #" + test + ": " + mkdirs);
        }
    }

    LinkedList<String> stringToPath(String path) {
        LinkedList<String> result = new LinkedList<String>();

        String[] tokens = path.split("/");
        for (int i = tokens.length - 1; i > 0; i--) {
            result.addFirst(tokens[i]);
        }
        return result;
    }

    class Dir {

        String name;
        // sorted list of child directories
        LinkedList<Dir> children = new LinkedList<Dir>();

        void traverseAndCreate(LinkedList<String> dir) {
            if (dir.size() == 0) {
                // nothing further to insert
                return;
            }
            // is there a child with the proper name?
            int ix = 0;
            for (Dir child : children) {
                // if we are past the child
                if (child.name.compareTo(dir.getFirst()) > 0) {
                    Dir newdir = new Dir();
                    newdir.name = dir.poll();
                    mkdirs++;
                    children.add(ix, newdir);
                    // recurse
                    newdir.traverseAndCreate(dir);
                    return;
                } else if (child.name.compareTo(dir.getFirst()) == 0) {
                    // this is the child dir, traverse here
                    dir.poll();
                    child.traverseAndCreate(dir);
                    return;
                }

                ix++;
            }

            // passed entire list of child directories, 
            // and none is larger or equal to this
            // create new child directory at end of list.
            Dir newdir = new Dir();
            newdir.name = dir.poll();
            mkdirs++;
            children.addLast(newdir);
            // recurse
            newdir.traverseAndCreate(dir);
        }
    }
}
