package treasure;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.TreeMap;
import javax.swing.JFileChooser;

public class Treasure {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        JFileChooser fc = new JFileChooser("C:\\Users\\fgoss_000\\Desktop");
        int res = fc.showOpenDialog(null);
        if(res == JFileChooser.APPROVE_OPTION){
            File file = fc.getSelectedFile();
            try{
                long start = System.currentTimeMillis();
                computeFile(file);
                System.out.println(System.currentTimeMillis() - start);
                System.out.println("done. ");
            }catch(FileNotFoundException ex){
                System.err.println("file not found: " + ex);
            } catch (IOException ex) {
                System.err.println("io exception: " + ex);
            }
        }
    }
    
    public static void computeFile(File file) throws FileNotFoundException, IOException{
        BufferedReader in = new BufferedReader(new FileReader(file));
        BufferedWriter out = new BufferedWriter(new FileWriter(new File(file.getParent(), "treasureSolution.txt")));
        int nCases = Integer.parseInt(in.readLine());
        for(int i=0; i<nCases; i++){
            String[] words = in.readLine().split(" ");
            int K = Integer.parseInt(words[0]);
            int N = Integer.parseInt(words[1]);
            ArrayList<Integer> keys = new ArrayList<Integer>();
            words = in.readLine().split(" ");
            for(int j=0; j<words.length; j++)
                keys.add(Integer.parseInt(words[j]));
            ArrayList<ArrayList<Integer>> chestsContent = new ArrayList<ArrayList<Integer>>();
            ArrayList<Boolean> chestsState = new ArrayList<Boolean>();
            ArrayList<Integer> chestsLock = new ArrayList<Integer>();
            for(int j=0; j<N; j++){
                ArrayList<Integer> chestContent = new ArrayList<Integer>();
                words = in.readLine().split(" ");
                chestsLock.add(Integer.parseInt(words[0]));
                for(int k=2; k<words.length; k++)
                    chestContent.add(Integer.parseInt(words[k]));
                chestsContent.add(chestContent);
                chestsState.add(Boolean.FALSE);
            }
            ArrayList<Integer> way = new ArrayList<Integer>();
            
            /*
            System.out.println(keys);
            System.out.println(chestsContent);
            System.out.println(chestsLock);
            System.out.println(chestsState);
            System.out.println(way);
            System.out.println(computeCase(keys, chestsContent, chestsLock, chestsState, way));
            */
            
            System.out.println("i=" + i);
            
            String solution = formatSolution(computeCase(new TreeMap<String, ArrayList<Integer>>(), keys, chestsContent, chestsLock, chestsState, way));
            out.write("Case #" + (i+1) + ": " + solution + "\n");
        }
        in.close();
        out.close();
    }

    public static ArrayList<Integer> computeCase(TreeMap<String, ArrayList<Integer>> mem, ArrayList<Integer> keys, ArrayList<ArrayList<Integer>> chestsContent, ArrayList<Integer> chestsLock, ArrayList<Boolean> chestsState, ArrayList<Integer> way){
        /*
        System.out.println("method begining");
        System.out.println(keys);
        System.out.println(chestsContent);
        System.out.println(chestsLock);
        System.out.println(chestsState);
        System.out.println(way);
        System.out.println("");
        */
        
        ArrayList<Integer> memResult = mem.get(formatChestsState(chestsState));
        if(memResult != null)
            return memResult;
        
        if(way.size() == chestsState.size()){
            mem.put(formatChestsState(chestsState), way);
            return way;
        }

        for(int c=0; c<chestsLock.size(); c++){
            for(int k=0; k<keys.size(); k++){
                Integer key = keys.get(k);
                if(!chestsState.get(c) && chestsLock.get(c).equals(key)){
                    ArrayList<Integer> keysNew = new ArrayList<Integer>(keys);
                    keysNew.remove(key);
                    keysNew.addAll(chestsContent.get(c));

                    ArrayList<Integer> wayNew = new ArrayList<Integer>(way);
                    wayNew.add(c);
                    
                    ArrayList<Boolean> chestsStateNew = new ArrayList<Boolean>(chestsState);
                    chestsStateNew.remove(c);
                    chestsStateNew.add(c, Boolean.TRUE);
                    
                    ArrayList<Integer> recResult = computeCase(mem, keysNew, chestsContent, chestsLock, chestsStateNew, wayNew);
                    
                    if(!recResult.isEmpty()){
                        mem.put(formatChestsState(chestsState), recResult);
                        return recResult;
                    }
                }
            }
        }
        mem.put(formatChestsState(chestsState), new ArrayList<Integer>());
        return new ArrayList<Integer>();
    }
    
    public static String formatChestsState(ArrayList<Boolean> chestsState){
        StringBuilder sb = new StringBuilder();
        for(Boolean b : chestsState)
            sb.append(b ? "1" : "0");
        return sb.toString();
    }
    
    public static String formatSolution(ArrayList<Integer> solution){
        StringBuilder sb = new StringBuilder();
        Iterator<Integer> it = solution.iterator();
        if(it.hasNext()){
            sb.append((1 + it.next().intValue()));
            while(it.hasNext())
                sb.append(" " + (1 + it.next().intValue()));
        }
        else
            sb.append("IMPOSSIBLE");
        return sb.toString();
    }
    
    /*
    public static boolean allOpened(boolean[] chestsState){
        for(int i=0; i<chestsState.length; i++)
            if(!chestsState[i])
                return false;
        return true;
    }
    */
}
