import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import javax.swing.JFileChooser;


public class ProblemB {
	
    public static void main(String[] args) {
        JFileChooser fc = new JFileChooser("C:\\Users\\ede\\Desktop\\codeJam");
        int res = fc.showOpenDialog(null);
        if(res == JFileChooser.APPROVE_OPTION){
            File file = fc.getSelectedFile();
            try{
                computeFile(file);
                System.out.println("done. ");
            }catch(FileNotFoundException ex){
                System.err.println("file not found: " + ex);
            } catch (IOException ex) {
                System.err.println("io exception: " + ex);
            }
        }
    }
    
    public static void computeFile(File file) throws FileNotFoundException, IOException{
        BufferedReader in = new BufferedReader(new FileReader(file));
        BufferedWriter out = new BufferedWriter(new FileWriter(new File(file.getParent(), "b_small.txt")));
        int nCases = Integer.parseInt(in.readLine());
        for(int i=0; i<nCases; i++){
        	double[] nums = parseDoubleLine(in.readLine());
            String solution = "" + computeCase(nums[0], nums[1], nums[2]);
            String line = "Case #" + (i+1) + ": " + solution + "\n";
            System.out.print(line);
            out.write(line);
        }
        in.close();
        out.close();
    }
    
    public static int[] parseIntLine(String str){
    	String[] strs = str.split(" ");
    	int[] nums = new int[strs.length];
    	for(int i=0; i < nums.length; i++)
    		nums[i] = Integer.parseInt(strs[i]);
    	return nums;
    }
    
    public static double[] parseDoubleLine(String str){
    	String[] strs = str.split(" ");
    	double[] nums = new double[strs.length];
    	for(int i=0; i < nums.length; i++)
    		nums[i] = Double.parseDouble(strs[i]);
    	return nums;
    }
    
    public static double computeCase(double c, double f, double x){
    	double bestTime = totalTime(0, c, f, x);
    	for(int n=1; true; n++) {
    		double nextTime = totalTime(n, c, f, x);
    		if(nextTime < bestTime){
    			bestTime = nextTime;
    		}
    		else{
    			break;
    		}
    	}
    	return bestTime;
    	/*
    	int min = 0;
    	int max = 1;
    	double bestTime = totalTime(max, c, f, x);
    	while(true){
    		double nextTime = totalTime(2*max, c, f, x);
    		if(nextTime < bestTime){
    			bestTime = nextTime;
    			max *= 2;
    		}
    		else {
    			break;
    		}
    	}
    	while(true) {
    		
    	}
    	*/
    }
    
    public static double totalTime(int n, double c, double f, double x){
    	double timeToBuild = 0;
    	for(int i=0; i<n; i++)
    		timeToBuild += c / (2 + f*i);
    	double timeToWait = x / (2 + f*n);
    	return timeToBuild + timeToWait;
    }
}
