package fairandsquare;

import com.sun.org.apache.xerces.internal.xs.datatypes.XSQName;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import javax.swing.JFileChooser;

public class FairAndSquare {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        JFileChooser fc = new JFileChooser("C:\\Users\\fgoss_000\\Desktop");
        int res = fc.showOpenDialog(null);
        if(res == JFileChooser.APPROVE_OPTION){
            File file = fc.getSelectedFile();
            try{
                computeFile(file);
                System.out.println("done. ");
            }catch(FileNotFoundException ex){
                System.err.println("file not found: " + ex);
            } catch (IOException ex) {
                System.err.println("io exception: " + ex);
            }
        }
    }
    
    public static void computeFile(File file) throws FileNotFoundException, IOException{
        BufferedReader in = new BufferedReader(new FileReader(file));
        BufferedWriter out = new BufferedWriter(new FileWriter(new File(file.getParent(), "fairAndSquareSolution.txt")));
        int nCases = Integer.parseInt(in.readLine());
        for(int i=0; i<nCases; i++){
            String[] words = in.readLine().split(" ");
            BigInteger aa = new BigInteger(words[0]);
            BigInteger bb = new BigInteger(words[1]);
            BigInteger solution = computeCase(aa, bb);
            out.write("Case #" + (i+1) + ": " + solution + "\n");
        }
        in.close();
        out.close();
    }
    
    public static BigInteger computeCase(BigInteger aa, BigInteger bb){
        BigInteger c = BigInteger.ZERO;
        BigInteger x = bigSqrt(aa, true);
        BigInteger b = bigSqrt(bb, false);
        while(x.compareTo(b) <= 0){
            BigInteger xx = x.multiply(x);
            if(isPalindrom(x) && isPalindrom(xx) && aa.compareTo(xx) <= 0 && bb.compareTo(xx) >= 0)
                c = c.add(BigInteger.ONE);
            x = x.add(BigInteger.ONE);
        }
        return c;
    }
    
    /*
    public static int computeCase(int a, int b){
        int c = 0;
        int aa = (int)Math.floor(Math.sqrt(a));
        int bb = (int)Math.ceil(Math.sqrt(b));
        System.out.println("Suche zwischen " + aa + " und " + bb);
        for(int x=aa; x<=bb; x++){
            int xSquare = (int)Math.pow(x, 2);
            if(isPalindrom(x) && isPalindrom(xSquare) && xSquare >= a && xSquare <= b)
                c++;
        }
        return c;
    }
    */
    
    public static boolean isPalindrom(BigInteger n){
        return isPalindrom(n.toString());
    }
    public static boolean isPalindrom(String str){
        int len = str.length();
        for(int i=0; i<len/2; i++)
            if(str.charAt(i) != str.charAt(len - 1 - i))
                return false;
        return true;
    }
    
    /*
    public static boolean isPalindrom(int n){
        int len = (int)Math.log10(n) + 1;
        for(int i=0; i<len/2; i++){
            int digitL = getDigit(n, len - 1 - i);
            int digitR = getDigit(n, i);
            if(digitL != digitR) 
                return false;
        }
        return true;
    }
    
    public static int getDigit(int n, int i){
        return (n/(int)Math.pow(10, i))%10;
    }
    */
    
    public static BigInteger bigSqrt(BigInteger n, boolean floor){
        BigInteger smaller = new BigInteger("0");
        BigInteger greater = new BigInteger(n.toString());
        BigInteger two = new BigInteger("2");
        BigInteger one = new BigInteger("1");
        while(greater.subtract(smaller).compareTo(one) > 0){
            BigInteger middle = greater.add(smaller).divide(two);
            BigInteger middleSquare = middle.multiply(middle);
            if(middleSquare.compareTo(n) < 0)
                smaller = middle;
            else 
                greater = middle;
        }
        if(floor)
            return smaller;
        else
            return greater;
    }
}
