package tictactoetomek;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import javax.swing.JFileChooser;

public class TicTacToeTomek {

    public static int O = 0;
    public static int T = 1;
    public static int X = 2;
    public static int E = 3;
    
    public static void main(String[] args) {
        JFileChooser fc = new JFileChooser("C:\\Users\\fgoss_000\\Desktop");
        int res = fc.showOpenDialog(null);
        if(res == JFileChooser.APPROVE_OPTION){
            File file = fc.getSelectedFile();
            try{
                computeFile(file);
                System.out.println("done. ");
            }catch(FileNotFoundException ex){
                System.err.println("file not found: " + ex);
            } catch (IOException ex) {
                System.err.println("io exception: " + ex);
            }
        }
        /*  test case
        System.out.println(computeCase(new int[][]{new int[]{E, O, T, O}, 
                                                   new int[]{E, E, O, E}, 
                                                   new int[]{E, T, X, E}, 
                                                   new int[]{O, O, E, T}}));
        */
    }
    
    public static void computeFile(File file) throws FileNotFoundException, IOException{
        BufferedReader in = new BufferedReader(new FileReader(file));
        BufferedWriter out = new BufferedWriter(new FileWriter(new File(file.getParent(), "ticTacToeTomekSolution.txt")));
        int nCases = Integer.parseInt(in.readLine());
        for(int i=0; i<nCases; i++){
            int[][] field = new int[4][];
            for(int j=0; j<4; j++)
                field[j] = parseLine(in.readLine());
            //ignore empty line
            in.readLine();
            String solution = computeCase(field);
            out.write("Case #" + (i+1) + ": " + solution + "\n");
        }
        in.close();
        out.close();
    }
    
    public static int[] parseLine(String str){
        int[] line = new int[str.length()];
        for(int i=0; i<line.length; i++){
            switch(str.charAt(i)){
                case 'X': line[i] = X; break;
                case 'O': line[i] = O; break;
                case 'T': line[i] = T; break;
                case '.': line[i] = E; break;
            }
        }
        return line;
    }
    
    public static String computeCase(int[][] field){
        boolean oHasLine = playerWon(O, field);
        boolean xHasLine = playerWon(X, field);
        if(oHasLine && xHasLine)
            return "Draw";
        else if(oHasLine)
            return "O won";
        else if(xHasLine)
            return "X won";
        else if(isFieldFull(field))
            return "Draw";
        else 
            return "Game has not completed";
    }
    
    public static boolean playerWon(int player, int[][] field){
        //horizontal and vertical 
        for(int i=0; i<4; i++){
            if(countsForPlayer(field[i][0], player) && 
               countsForPlayer(field[i][1], player) && 
               countsForPlayer(field[i][2], player) && 
               countsForPlayer(field[i][3], player))
                return true;
            if(countsForPlayer(field[0][i], player) && 
               countsForPlayer(field[1][i], player) && 
               countsForPlayer(field[2][i], player) && 
               countsForPlayer(field[3][i], player))
                return true;
        }
        //diagonal
        if(countsForPlayer(field[0][0], player) && 
           countsForPlayer(field[1][1], player) && 
           countsForPlayer(field[2][2], player) && 
           countsForPlayer(field[3][3], player))
            return true;
        if(countsForPlayer(field[0][3], player) && 
           countsForPlayer(field[1][2], player) && 
           countsForPlayer(field[2][1], player) && 
           countsForPlayer(field[3][0], player))
            return true;
        return false;
    }
    
    public static boolean countsForPlayer(int position, int player){
        if(player == O)
            return position == O || position == T;
        if(player == X)
            return position == X || position == T;
        return false;
    }
    
    public static boolean isFieldFull(int[][] field){
        for(int i=0; i<field.length; i++)
            for(int j=0; j<field[i].length; j++)
                if(field[i][j] == E)
                    return false;
        return true;
    }
}
