package lawnmower;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import javax.swing.JFileChooser;

public class Lawnmower {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        JFileChooser fc = new JFileChooser("C:\\Users\\fgoss_000\\Desktop");
        int res = fc.showOpenDialog(null);
        if(res == JFileChooser.APPROVE_OPTION){
            File file = fc.getSelectedFile();
            try{
                computeFile(file);
                System.out.println("done. ");
            }catch(FileNotFoundException ex){
                System.err.println("file not found: " + ex);
            } catch (IOException ex) {
                System.err.println("io exception: " + ex);
            }
        }
        /*
        System.out.println(computeCase(5, 5, new int[][]{new int[]{1, 1, 2, 1, 1}, 
                                                         new int[]{1, 1, 1, 1, 1}, 
                                                         new int[]{1, 1, 2, 1, 1}, 
                                                         new int[]{1, 1, 1, 1, 1}, 
                                                         new int[]{1, 1, 2, 1, 1}}));
        */
    }
    
    public static void computeFile(File file) throws FileNotFoundException, IOException{
        BufferedReader in = new BufferedReader(new FileReader(file));
        BufferedWriter out = new BufferedWriter(new FileWriter(new File(file.getParent(), "lawnmowerSolution.txt")));
        int nCases = Integer.parseInt(in.readLine());
        for(int i=0; i<nCases; i++){
            String[] words = in.readLine().split(" ");
            int height = Integer.parseInt(words[0]);
            int width = Integer.parseInt(words[1]);
            int[][] field = new int[width][height];
            
            for(int j=0; j<height; j++){
                words = in.readLine().split(" ");
                for(int k=0; k<width; k++){
                    field[k][j] = Integer.parseInt(words[k]);
                }
            }
            boolean solution = computeCase(width, height, field);
            out.write("Case #" + (i+1) + ": " + (solution ? "YES" : "NO") + "\n");
        }
        in.close();
        out.close();
    }
    
    public static boolean computeCase(int width, int height, int[][] pattern){
        int[] columnMax = new int[width];
        int[] rowMax = new int[height];
        for(int i=0; i<width; i++){
            for(int j=0; j<height; j++){
                columnMax[i] = Math.max(columnMax[i], pattern[i][j]); 
                rowMax[j] = Math.max(rowMax[j], pattern[i][j]);
            }
        }
        for(int i=0; i<width; i++){
            for(int j=0; j<height; j++){
                int patternHeight = pattern[i][j];
                if(patternHeight < 1 || patternHeight > 100)
                    return false;
                if(patternHeight < rowMax[j] && patternHeight < columnMax[i])
                    return false;
            }
        }
        return true;
    }
}
