import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import javax.swing.JFileChooser;

public class ProblemA {

    public static void main(String[] args) {
        JFileChooser fc = new JFileChooser("C:\\Users\\ede\\Desktop\\codeJam");
        int res = fc.showOpenDialog(null);
        if(res == JFileChooser.APPROVE_OPTION){
            File file = fc.getSelectedFile();
            try{
                computeFile(file);
                System.out.println("done. ");
            }catch(FileNotFoundException ex){
                System.err.println("file not found: " + ex);
            } catch (IOException ex) {
                System.err.println("io exception: " + ex);
            }
        }
    }
    
    public static void computeFile(File file) throws FileNotFoundException, IOException{
        BufferedReader in = new BufferedReader(new FileReader(file));
        BufferedWriter out = new BufferedWriter(new FileWriter(new File(file.getParent(), "a_small.txt")));
        int nCases = Integer.parseInt(in.readLine());
        for(int i=0; i<nCases; i++){
        	int ans1 = Integer.parseInt(in.readLine());
        	int[][] field1 = new int[4][];
            for(int j=0; j<4; j++)
                field1[j] = parseLine(in.readLine());
        	int ans2 = Integer.parseInt(in.readLine());
        	int[][] field2 = new int[4][];
            for(int j=0; j<4; j++)
                field2[j] = parseLine(in.readLine());
            String solution = computeCase(ans1, field1, ans2, field2);
            String line = "Case #" + (i+1) + ": " + solution + "\n";
            System.out.print(line);
            out.write(line);
        }
        in.close();
        out.close();
    }
    
    public static int[] parseLine(String str){
    	String[] sCards = str.split(" ");
    	int[] iCards = new int[sCards.length];
    	for(int i=0; i < iCards.length; i++)
    		iCards[i] = Integer.parseInt(sCards[i]);
    	return iCards;
    }
    
    public static String computeCase(int ans1, int[][] field1, int ans2, int[][] field2){
    	Set<Integer> set1 = new HashSet<>();
    	Set<Integer> set2 = new HashSet<>();
    	for(int i=0; i<4; i++){
    		set1.add(field1[ans1-1][i]);
    		set2.add(field2[ans2-1][i]);
    	}
    	System.out.println(set1);
    	System.out.println(set2);
    	set1.retainAll(set2);
    	System.out.println(set1);
    	switch (set1.size()) {
		case 0:
			return "Volunteer cheated!";
		case 1:
			return "" + set1.iterator().next();
		default:
			return "Bad magician!";
		}
    }
    
    private static void p(int ans, int[][] field){
    	System.out.println(ans);
    	for(int[]row : field)
    		System.out.println(Arrays.toString(row));
    }
}
