/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package rpi;

import java.util.Scanner;

/**
 *
 * @author edemairy
 */
public class RPI {

    int nbTestCases;
    static int win[];
    static int nbMatch[];
    static double wp[];
    static double owp[];
    static double oowp[];
    static double result[];

    private void solve() {
        int numCase=0;
        for (TestCase testCase : testCases) {
            numCase++;
            win = new int[testCase.N];
            nbMatch = new int[testCase.N];
            wp = new double[testCase.N];
            owp = new double[testCase.N];
            oowp = new double[testCase.N];
            result = new double[testCase.N];
            for (int i = 0; i < testCase.N; ++i) {
                int nb = 0;
                int r = 0;
                for (int j = 0; j < testCase.N; ++j) {
                    switch (testCase.values[i].charAt(j)) {
                        case '.':
                            break;
                        case '1':
                            r++;
                        case '0':
                            nb++;
                    }
                }
                win[i] = r;
                nbMatch[i] = nb;
                wp[i] = (nb != 0) ? 1.0 * r / nb : 0;
            }
            for (int i = 0; i < testCase.N; ++i) {
                int nb = 0;
                double r = 0;
                for (int j = 0; j < testCase.N; ++j) {
                    if (testCase.values[i].charAt(j) != '.') {
                        nb++;
                        r += 1.0 * (win[j] - ((testCase.values[j].charAt(i) == '1') ? 1 : 0))
                                / (nbMatch[j]- ((testCase.values[j].charAt(i) != '.') ? 1 : 0));
                    }
                }
                owp[i] = r / nb;
            }
            for (int i = 0; i < testCase.N; ++i) {
                int nb = 0;
                double r = 0;
                for (int j = 0; j < testCase.N; ++j) {
                    if (testCase.values[i].charAt(j) != '.') {
                        nb++;
                        r += owp[j];
                    }
                }
                oowp[i] = r / nb;
            }
            System.out.println("Case #"+numCase+":");
            for (int i = 0; i < testCase.N; ++i) {
              result[i] = 0.25*wp[i]+0.5*owp[i]+0.25*oowp[i];
              System.out.println(result[i]);
            }
        }
    }

    private class TestCase {

        public int N;
        public String[] values;

        public TestCase(String[] values) {
            this.values = values;
            this.N = values.length;
        }

        public String toString() {
            String result = new String();
            for (String value : values) {
                result += value + " ";
            }
            return result;
        }
    }
    private TestCase testCases[];

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        RPI main = new RPI();
        main.run();
    }

    private void run() {
        readTestCaseList();
        solve();
//        showTestCaseList();
    }

    private void readTestCaseList() {
        Scanner scanner = new Scanner(System.in);
        nbTestCases = scanner.nextInt();
        System.out.println("nbTestCase="+nbTestCases);
        testCases = new TestCase[nbTestCases];
        for (int i = 0; i < nbTestCases; ++i) {
            testCases[i] = readTestCase(scanner);
        }
    }

    private void showTestCaseList() {
      //  System.out.println("#testcases = " + testCases.length);
        for (int i = 0; i < testCases.length; ++i) {
            System.out.println(testCases[i]);
        }
    }

    private TestCase readTestCase(Scanner scanner) {
        int N = scanner.nextInt();
        scanner.nextLine();
     //   System.out.println("N="+N);
        String values[] = new String[N];
        for (int i = 0; i < N; ++i) {
            values[i] = scanner.nextLine();
   //         System.out.println("values["+i+"]="+values[i]);
        
        }
        TestCase newTestCase = new TestCase(values);
        return newTestCase;
    }
}
