
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.Formatter;
import java.util.Locale;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author edemairy
 */
public class Main {

    private final static Logger logger = Logger.getLogger(Main.class.getName());
    private static int nbTC;
    private static StringBuilder result = new StringBuilder();

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        logger.setLevel(Level.OFF);
        Scanner scanner = new Scanner(System.in);
//        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        nbTC = scanner.nextInt();
//        scanner.nextLine();
        for (int tc = 1; tc <= nbTC; ++tc) {
            result.append("Case #"+tc+": ");
            result.append(oneTestCase(scanner));
            result.append('\n');
        }
        System.out.print(result);
    }

    private static double[] p = new double[100010];
    private static StringBuilder oneTestCase(Scanner scanner)  throws IOException {
        Formatter formatter = new Formatter(Locale.ENGLISH);
        StringBuilder result = new StringBuilder();
        int A = scanner.nextInt();
        int B = scanner.nextInt();
        double sumpi = 0;
        double prod1mpi = 1;
        double prod1bp = 1;
        double prod2bp = 1;
        for (int i=1; i<=A; ++i) {
            p[i] = Double.parseDouble(scanner.next());
            sumpi += p[i];
            
            prod1mpi *= p[i];
            if (i<A) {
                prod1bp *= p[i];
            } else {
                prod1bp *= (1-p[i]);
            }
            if (i<(A-1)) {
                prod2bp *= p[i];
            } else {
                prod2bp *= (1-p[i]);
            }
        }
        double es1 = prod1mpi*(B-A+1) + (1-prod1mpi)*(2*B-A+2);
        double es2 = prod1mpi*(B-A+3) + prod1bp*(B-A+3) + (1-prod1mpi-prod1bp)*(2*B-A+4);
        double es3;
        if (A>1) {
            es3 = prod1mpi*(B-A+5) + (prod2bp)*(B-A+5) + (1-prod1mpi-prod2bp)*(2*B-A+6);
        } else {
            es3 = prod1mpi*(B-A+4) + prod2bp*(B-A+4) + (1-prod1mpi-prod2bp)*(2*B-A+5);;
        }
        
        double es4 = (B+2);
        
        double r = Math.min(es1, Math.min(es2, Math.min(es3, es4)));
        formatter.format("%.6f",r);
//        for (int i = 0; i < 5; ++i) {
//            formatter.format("%3d", n[i]);
//        }
        result.append(formatter.out());
        return result;
    }

    private static int readInt(BufferedReader reader) throws IOException {
        int result = 0;
        boolean positive = true;
        char currentChar = (char) reader.read();

        while ((currentChar == ' ') || (currentChar == '\n')) {
            currentChar = (char) reader.read();
        }
        if (currentChar == (char) -1) {
            throw new IOException("end of stream");
        }
        if (currentChar == '-') {
            positive = false;
            currentChar = (char) reader.read();
        }
        while ((currentChar >= '0') && (currentChar <= '9')) {
            result = result * 10 + currentChar - '0';
            currentChar = (char) reader.read();
        }
        if (positive) {
            return result;
        } else {
            return -result;
        }
    }

    private static char readChar(BufferedReader reader) throws IOException {
        return (char) reader.read();
    }
}
