
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author edemairy
 */
public class Main {

    private final static Logger logger = Logger.getLogger(Main.class.getName());
    private static int nbTC;
    private static StringBuilder result = new StringBuilder();

    private static void learning() {
        String[] inputs = {
            "z", // guessed from what was lacking
            "y qee", 
            "ejp mysljylc kd kxveddknmc re jsicpdrysi",
            "rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd",
            "de kr kd eoya kw aej tysr re ujdr lkgc jv"
        };
        String[] outputs = {
          "q",
          "a zoo",
          "our language is impossible to understand",
          "there are twenty six factorial possibilities",
          "so it is okay if you want to just give up"
        };
        for (int i=0; i<inputs.length; ++i) {
            assert(inputs[i].length() == outputs[i].length());
            forc: for (int c=0; c<inputs[i].length();++c) {
                Character ichar = inputs[i].charAt(c);
                Character ochar = outputs[i].charAt(c);
                Character dicoChar = dictionnary.get(ichar);
                if ( dicoChar != null) {
                    assert(dicoChar == ochar);
                }
                dictionnary.put(ichar,ochar);
            }
        }
        Set<Character> keys = dictionnary.keySet();
        Collection<Character> values = dictionnary.values();
        assert(keys.size()==values.size());
        assert(keys.size()==27);
        
        for (char c='a'; c<='z'; ++c) {
            if (!keys.contains(c)) {
                System.err.println(c+" is not a known key.");
            }
            if (!values.contains(c)) {
                System.err.println(c+" is not a known value.");
            }
        }
    }

    private static Map<Character, Character> dictionnary = new HashMap<Character, Character>();
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        logger.setLevel(Level.OFF);
//        Scanner scanner = new Scanner(System.in);
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        learning();
        nbTC = readInt(reader);
//        scanner.nextLine();
        for (int tc = 1; tc <= nbTC; ++tc) {
            result.append("Case #"+tc+": ");
            result.append(oneTestCase(reader));
            result.append('\n');
        }
        System.out.print(result);
    }

    private static StringBuilder oneTestCase(BufferedReader reader)  throws IOException {
        Formatter formatter = new Formatter();
        StringBuilder result = new StringBuilder();
        String input = reader.readLine();
        for (Character c:input.toCharArray()) {
            result.append(dictionnary.get(c));
        }
//        for (int i = 0; i < 5; ++i) {
//            formatter.format("%3d", n[i]);
//        }
//        result.append(formatter.out());
        return result;
    }

    private static int readInt(BufferedReader reader) throws IOException {
        int result = 0;
        boolean positive = true;
        char currentChar = (char) reader.read();

        while ((currentChar == ' ') || (currentChar == '\n')) {
            currentChar = (char) reader.read();
        }
        if (currentChar == (char) -1) {
            throw new IOException("end of stream");
        }
        if (currentChar == '-') {
            positive = false;
            currentChar = (char) reader.read();
        }
        while ((currentChar >= '0') && (currentChar <= '9')) {
            result = result * 10 + currentChar - '0';
            currentChar = (char) reader.read();
        }
        if (positive) {
            return result;
        } else {
            return -result;
        }
    }

    private static char readChar(BufferedReader reader) throws IOException {
        return (char) reader.read();
    }
}
