
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.Formatter;
import java.util.Locale;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author edemairy
 */
public class Main {

    private final static Logger logger = Logger.getLogger(Main.class.getName());
    private static int nbTC;
    private static int tc;
    private static StringBuilder result = new StringBuilder();

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        logger.setLevel(Level.OFF);
//        Scanner scanner = new Scanner(System.in);
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        nbTC = readInt(reader);
//        scanner.nextLine();
        for (tc = 1; tc <= nbTC; ++tc) {
            result.append(oneTestCase(reader));
            result.append('\n');
        }
        System.out.print(result);
    }

    private static StringBuilder oneTestCase(BufferedReader reader) throws IOException {
        Formatter formatter = new Formatter(Locale.ENGLISH);
        StringBuilder output = new StringBuilder();
        StringBuffer[] board = new StringBuffer[4];
        for (int i = 0; i < 4; ++i) {
            board[i] = new StringBuffer(reader.readLine());
        }
        reader.readLine();

        boolean oWon = false;
        boolean xWon = false;

        int[] posT = searchT(board);
        boolean ended = isFinished(board);
        oWon = hasWon(posT, board, 'O');
        xWon = hasWon(posT, board, 'X');

        formatter.format("Case #%d: ", tc);
        if (oWon) {
            formatter.format("O won");            
        } else if (xWon) {
            formatter.format("X won");
        } else if (ended) {
            formatter.format("Draw");
        } else {
            formatter.format("Game has not completed");
        }
        output.append(formatter.out());
        return output;
    }

    private static int readInt(BufferedReader reader) throws IOException {
        int result = 0;
        boolean positive = true;
        char currentChar = (char) reader.read();

        while ((currentChar == ' ') || (currentChar == '\n')) {
            currentChar = (char) reader.read();
        }
        if (currentChar == (char) -1) {
            throw new IOException("end of stream");
        }
        if (currentChar == '-') {
            positive = false;
            currentChar = (char) reader.read();
        }
        while ((currentChar >= '0') && (currentChar <= '9')) {
            result = result * 10 + currentChar - '0';
            currentChar = (char) reader.read();
        }
        if (positive) {
            return result;
        } else {
            return -result;
        }
    }

    private static char readChar(BufferedReader reader) throws IOException {
        return (char) reader.read();
    }

    private static int[] searchT(StringBuffer[] board) {
        int[] result = new int[2];
        fori:
        for (int i = 0; i < 4; ++i) {
            for (int j = 0; j < 4; ++j) {
                if (board[i].charAt(j) == 'T') {
                    result[0] = i;
                    result[1] = j;
                    break fori;
                }
            }
        }
        return result;
    }

    private static boolean hasWon(int[] posT, StringBuffer[] board, char c) {
        boolean result = false;
        board[posT[0]].setCharAt(posT[1], c);
        fori:
        for (int i = 0; i < 4; i++) {
            forj1:
            for (int j = 0; j < 4; j++) {
                if (board[i].charAt(j) == c) {
                    continue forj1;
                } else {
                    continue fori;
                }

            }
            return true; 
        }

        fori:
        for (int i = 0; i < 4; i++) {
            forj:
            for (int j = 0; j < 4; j++) {
                if (board[j].charAt(i) == c) {
                    continue forj;
                } else {
                    continue fori;
                }
            }
            return true;
        }
        diago1:{
            fori:
            for (int i = 0; i < 4; i++) {
                if (board[i].charAt(i) == c) {
                    continue fori;
                } else {
                    break diago1;
                }
            }
            return true;
        }
        diago2:{
            fori:
            for (int i = 0; i < 4; i++) {
                if (board[i].charAt(3-i) == c) {
                    continue fori;
                } else {
                    break diago2;
                }
            }
            return true;
        }
        return false;
    }

    private static boolean isFinished(StringBuffer[] board) {
        boolean result = true;
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                if (board[i].charAt(j) == '.')
                    return false;
            }
        }
        
        return true;
    }
}
