
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.ObjectInputStream;
import java.math.BigInteger;
import java.util.AbstractMap.SimpleEntry;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.Formatter;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Set;
import java.util.TreeSet;

/**
 *
 * @author edemairy
 */
public class Main {

	private static boolean isPrime(BigInteger v, List<Long> divisors) {
		if (v.isProbablePrime(100)) {
			return true;
		} else {
			for (int i = 2; i != -1; i = bs.nextSetBit(i + 1)) {
				divisors.add((long) i);
				return false;
			}
			return true;
		}
	}

	private int nbTC;
	private StringBuilder result = new StringBuilder();

	private static class EndException extends RuntimeException {
	}

	public void run() throws IOException {
		//        Scanner scanner = new Scanner(System.in);
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		nbTC = readInt(reader);
//         nbTC = Integer.MAX_VALUE;
//        scanner.nextLine();
		try {
			for (int tc = 1; tc <= nbTC; ++tc) {
				result.append("Case #");
				result.append(tc);
				result.append(":\n");
				result.append(oneTestCase(reader));
			}
		} catch (EndException e) {
		}
		System.out.print(result);
	}

	private static BitSet bs;

	/**
	 * @param args the command line arguments
	 */
	public static void main(String[] args) throws IOException, ClassNotFoundException {
		ObjectInputStream ois = new ObjectInputStream(new FileInputStream(new File("prime")));
		bs = (BitSet) ois.readObject();
		for (int i = 2; i != -1 && i < MAX_DIV; i = bs.nextSetBit(i + 1)) {
			if (bs.get(i)) {
				for (int j = 2; (long) i * (long) j < (MAX_DIV); j++) {
					NT[i * j] = i;
				}
			}
		}
		Main main = new Main();
		main.run();
	}
	private static int MAX_DIV = 1;//Integer.MAX_VALUE / 2;
	private static int[] NT = new int[MAX_DIV];

	public static boolean isPrime(long i, List<Long> divisors) {
		if (i <= Integer.MAX_VALUE) {
			if (bs.get((int) i)) {
				return true;
			} else {
				if (i < MAX_DIV) {
					divisors.add((long) NT[Math.toIntExact(i)]);
				} else {
					for (int div = 2; div != -1; div = bs.nextSetBit(div + 1)) {
						if (i % div == 0) {
							divisors.add((long) div);
							break;
						}
					}
				}
				return false;
			}
		} else {
			for (int n = 2; n != -1; n = bs.nextSetBit(n + 1)) {
				if (i % n == 0) {
					divisors.add((long) n);
					return false;
				}
			}
		}
		return true;
	}

	public static boolean isPrimeBases(long i, List<Long> divisors) {
		String binary = Long.toBinaryString(i);
		if (isPrime(i, divisors)) {
			return true;
		}
		for (int n = 3; n < 11; n++) {
			BigInteger v = new BigInteger(binary, n);
			if (isPrime(v, divisors)) {
				return true;
			}
		}
		return false;
	}

	private StringBuilder oneTestCase(BufferedReader reader) throws IOException {
		Formatter formatter = new Formatter(Locale.ENGLISH);
		StringBuilder output = new StringBuilder();
//        for (int i = 0; i < 5; ++i) {
//            formatter.format("%3d", n[i]);
//        }
		String[] parts = reader.readLine().split(" ");
		int N = Integer.parseInt(parts[0]);
		int J = Integer.parseInt(parts[1]);
		List<SimpleEntry<Long, List<Long>>> candidates = new ArrayList<>();

		// base 2
		long min = (BigInteger.valueOf(2).pow(N - 1).add(BigInteger.ONE)).longValueExact();
		long max = (BigInteger.valueOf(2).pow(N)).longValueExact();
		for (long i = min; i < max; i += 2) {
			List<Long> divisors = new ArrayList<>();
			if (!isPrimeBases(i, divisors)) {
				candidates.add(new SimpleEntry<>(i, divisors));
				if (candidates.size() >= J) {
					break;
				}
			}
		}
		int cptJ = 0;
		Iterator it = candidates.iterator();
		while (cptJ < J) {
			SimpleEntry<Long, List<Long>> currentCandidate = (SimpleEntry<Long, List<Long>>) it.next();
			long current = currentCandidate.getKey();
			List<Long> divisors = currentCandidate.getValue();
			formatter.format("%s ", Long.toBinaryString(current));
			for (int b = 2; b < 10; b++) {
				formatter.format("%d ", divisors.get(b - 2));
			}
			formatter.format("%d\n", divisors.get(8));
			cptJ++;
		}

		output.append(formatter.out());
		return output;
	}

	private int readInt(BufferedReader reader) throws IOException {
		int r = 0;
		boolean positive = true;
		char currentChar = (char) reader.read();

		while ((currentChar == ' ') || (currentChar == '\n')) {
			currentChar = (char) reader.read();
		}
		if (currentChar == (char) -1) {
			throw new IOException("end of stream");
		}
		if (currentChar == '-') {
			positive = false;
			currentChar = (char) reader.read();
		}
		while ((currentChar >= '0') && (currentChar <= '9')) {
			r = r * 10 + currentChar - '0';
			currentChar = (char) reader.read();
		}
		if (positive) {
			return r;
		} else {
			return -r;
		}
	}

	private char readChar(BufferedReader reader) throws IOException {
		return (char) reader.read();
	}
}
