/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package bottrust;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.regex.Pattern;

/**
 *
 * @author edemairy
 */
public class Main {

    int nbTestCases;
    private List<Integer> O_orders;
    private List<Integer> B_orders;
    private int O_pos;
    private int B_pos;
    private int O_currentOrder;
    private int B_currentOrder;
    private int time;
    private List<Bot> button;

    private void solve() {
        int testCaseNumber = 1;
        String result = "";
        for (TestCase testCase : testCases) {
            O_orders = new ArrayList<Integer>();
            B_orders = new ArrayList<Integer>();
            button = new ArrayList<Bot>();
            O_pos = 1;
            B_pos = 1;
            int lastOpos = 1;
            int lastBpos = 1;
            for (Order o : testCase.orders) {
                if (o.bot == Bot.O) {
                    lastOpos = o.pos;
                }
                if (o.bot == Bot.B) {
                    lastBpos = o.pos;
                }
            }
            for (int i = testCase.orders.length - 1; i >= 0; --i) {
                Order order = testCase.orders[i];
                button.add(0, order.bot);
                if (order.bot == Bot.O) {
                    O_orders.add(0, order.pos);
                    lastOpos = order.pos;
                    B_orders.add(0, lastBpos);
                } else {
                    B_orders.add(0, order.pos);
                    lastBpos = order.pos;
                    O_orders.add(0, lastOpos);
                }
            }
            assert (O_orders.size() == B_orders.size());
/*            for (int i = 0; i < O_orders.size(); ++i) {
                System.out.println("O:" + O_orders.get(i) + " , B:" + B_orders.get(i) + " " + button.get(i));
            }
            System.out.println("##############");*/
            O_currentOrder = 0;
            B_currentOrder = 0;
            time = 0;
            for (int i = 0; i < O_orders.size(); ++i) {
                int tt = 0;
                if (button.get(i) == Bot.B) {
                    tt = Math.abs(B_orders.get(i) - B_pos) + 1;
                    B_pos = B_orders.get(i);
                    O_pos = O_pos + Math.min(tt, Math.abs(O_pos - O_orders.get(i))) * (int) (-Math.signum(O_pos - O_orders.get(i)));
                } else {
                    tt = Math.abs(O_orders.get(i) - O_pos) + 1;
                    O_pos = O_orders.get(i);
                    B_pos = B_pos + Math.min(tt, Math.abs(B_pos - B_orders.get(i))) * (int) (-Math.signum(B_pos - B_orders.get(i)));
                }
                time += tt;

            }
            result += "Case #" + testCaseNumber + ": " + time + "\n";
            testCaseNumber++;
        }
        System.out.println(result);

    }

    private enum Bot {

        O, B
    };

    private class Order {

        public Order(String bot, int pos) {
            this.bot = (bot.equals("O")) ? Bot.O : Bot.B;
            this.pos = pos;
        }
        public Bot bot;
        public int pos;

        public String toString() {
            String result = "(" + ((bot == Bot.O) ? "O" : "B") + "," + pos + ")";
            return result;
        }
    }

    private class TestCase {

        public TestCase(int size) {
            orders = new Order[size];
        }
        public Order orders[];

        public String toString() {
            String result = new String();
            for (Order order : orders) {
                result += order.toString();
                result += "; ";
            }
            return result;
        }
    }
    private TestCase testCases[];

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        Main main = new Main();
        main.run();
    }

    private void run() {
        readTestCaseList();
        solve();
        //showTestCaseList();
    }

    private void readTestCaseList() {
        Scanner scanner = new Scanner(System.in);
        nbTestCases = scanner.nextInt();
        testCases = new TestCase[nbTestCases];
        for (int i = 0; i < nbTestCases; ++i) {
            testCases[i] = readTestCase(scanner);
        }
    }

    private void showTestCaseList() {
        System.out.println("#testcases = " + testCases.length);
        for (int i = 0; i < testCases.length; ++i) {
            System.out.println(testCases[i]);
        }
    }

    private TestCase readTestCase(Scanner scanner) {
        int testCaseLength = scanner.nextInt();
        TestCase newTestCase = new TestCase(testCaseLength);
        for (int i = 0; i < testCaseLength; ++i) {
            String bot = scanner.next(Pattern.compile("O|B"));
          //  System.out.println("\"" + bot + "\"");
            int pos = scanner.nextInt();
            newTestCase.orders[i] = new Order(bot, pos);
        }
        return newTestCase;
    }
}
