
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Formatter;
import java.util.Locale;

/**
 *
 * @author edemairy
 */
public class Main {

    private int nbTC;
    private StringBuilder result = new StringBuilder();

    private static class EndException extends RuntimeException {
    }

    public void run() throws IOException {
        //        Scanner scanner = new Scanner(System.in);
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        nbTC = readInt(reader);
//         nbTC = Integer.MAX_VALUE;
//        scanner.nextLine();
        try {
            for (int tc = 1; tc <= nbTC; ++tc) {
                result.append("Case #"+tc+":\n");
                result.append(oneTestCase(reader));
//                result.append('\n');
            }
        } catch (EndException e) {
        }
        System.out.print(result);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        Main main = new Main();
        main.run();
    }

    private static final char CLICKED = 'c';
    private static final char MINE = '*';
    private static final char EMPTY = '.';

    private StringBuilder oneTestCase(BufferedReader reader) throws IOException {
        Formatter formatter = new Formatter(Locale.ENGLISH);
        StringBuilder output = new StringBuilder();
        int R = readInt(reader);
        int C = readInt(reader);
        boolean hasSolution = true;
        StringBuffer[] solution = new StringBuffer[R];
        for (int r = 0; r < R; r++) {
            solution[r] = new StringBuffer(C);
            for (int c = 0; c < C; c++) {
                solution[r].append(EMPTY);
            }
        }
        solution[0].setCharAt(0, CLICKED);
        int M = readInt(reader);
//        int size = R * C;
//        if (R >= 2 && C >= 2) {
//            if (M <= (R - 2) * (C - 2)) {
//                solution[0].setCharAt(0, CLICKED);
//                // M= divisor*(R-2)+remain
//                int remain = M % (C - 2);
//                int div = M / (C - 2);
//                for (int r = R - 1; r > (R - div); r--) {
//                    for (int c = C - 1; c > 1; c--) {
//                        solution[r].setCharAt(c, MINE);
//                    }
//                }
//                for (int c = C - 1; c > C - remain; c--) {
//                    solution[R - div].setCharAt(c, MINE);
//                }
//                hasSolution = true;
//            } else {
//                if (size - M >= 4) {
//                    if ((size - M % 2) != 0) {
//                        hasSolution = false;
//                    } else {
//                        int remainingMines = M;
//                        for (int r = R - 1; r > 1; r--) {
//                            for (int c = C - 1; c > 1; c--) {
//                                solution[r].setCharAt(c, MINE);
//                            }
//                        }
//
//                    }
//                } else {
//                    hasSolution = false;
//                }
//            }
//        }

        if (C==1) {
            if (R>M) {
                for (int m=0; m<M; m++) {
                    solution[R-m-1].setCharAt(0, MINE);
                }
            } else {
                hasSolution = false;
            }
        } else if (R==1) {
            if (C>M) {
                for (int m=0; m<M; m++) {
                    solution[0].setCharAt(C-m-1, MINE);
                }
            } else {
                hasSolution = false;
            }
        } else {
            int remainingMines = fillGrid(solution, R, C, M);
            hasSolution = (remainingMines ==0);
        }
        if (hasSolution) {
            for (int r=0; r<R; r++) {
                formatter.format("%s\n", solution[r]);
            }
        } else {
            formatter.format("Impossible\n");
        }
//        for (int i = 0; i < 5; ++i) {
//            formatter.format("%3d", n[i]);
//        }
        output.append(formatter.out());
        return output;
    }

    private static int fillGrid(StringBuffer[] grid, int R, int C, int M) {
        int remainingMines = M;      
        for (int r = R - 1; r > 1; r--) {
            for (int c = C - 1; c > 1; c--) {
                if (remainingMines > 0) {
                  grid[r].setCharAt(c, MINE);
                  remainingMines--;
                }
            }
        }
        for (int r = R-1; r>1; r--) {
            if (remainingMines >= 2) {
                  grid[r].setCharAt(1, MINE);
                  remainingMines--;
                  grid[r].setCharAt(0, MINE);
                  remainingMines--;                  
            }
        }
        for (int c = C-1; c>1; c--) {
            if (remainingMines >= 2) {
                  grid[0].setCharAt(c, MINE);
                  remainingMines--;
                  grid[1].setCharAt(c, MINE);
                  remainingMines--;                  
            }
        }
        if (remainingMines ==3) {
            grid[0].setCharAt(1, MINE);
            grid[1].setCharAt(0, MINE);
            grid[1].setCharAt(1, MINE);
            remainingMines-=3;
        }
        return remainingMines;
    }

    private int readInt(BufferedReader reader) throws IOException {
        int r = 0;
        boolean positive = true;
        char currentChar = (char) reader.read();

        while ((currentChar == ' ') || (currentChar == '\n')) {
            currentChar = (char) reader.read();
        }
        if (currentChar == (char) -1) {
            throw new IOException("end of stream");
        }
        if (currentChar == '-') {
            positive = false;
            currentChar = (char) reader.read();
        }
        while ((currentChar >= '0') && (currentChar <= '9')) {
            r = r * 10 + currentChar - '0';
            currentChar = (char) reader.read();
        }
        if (positive) {
            return r;
        } else {
            return -r;
        }
    }

    private long readLong(BufferedReader reader) throws IOException {
        long r = 0;
        boolean positive = true;
        char currentChar = (char) reader.read();

        while ((currentChar == ' ') || (currentChar == '\n')) {
            currentChar = (char) reader.read();
        }
        if (currentChar == (char) -1) {
            throw new IOException("end of stream");
        }
        if (currentChar == '-') {
            positive = false;
            currentChar = (char) reader.read();
        }
        while ((currentChar >= '0') && (currentChar <= '9')) {
            r = r * 10 + currentChar - '0';
            currentChar = (char) reader.read();
        }
        if (positive) {
            return r;
        } else {
            return -r;
        }
    }

    private char readChar(BufferedReader reader) throws IOException {
        return (char) reader.read();
    }
}
