package com.codejam2016.edgar.Q2;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Set;

public class Pancakes {

    public static final String path = "/Users/edgaarrr/CodeJam/2016/qualification/src/com/codejam2016/edgar/Q2/";

    public static String outputLine(long testCaseNo, Object...anss) {
        String str = "Case #"+testCaseNo+":";
        for (Object ans : anss) {
             str = str + " " + ans;
       }
        return str;
    }

    public static String flip(String S) {
        String str = new StringBuilder(S).reverse().toString();

        str = str.replace('+', '*');
        str = str.replace('-', '+');
        str = str.replace('*', '-');
        return str;
    }

    public static boolean isAllHappy(String S) {
        String test = S;
        return 0 == test.replace("+", "").length();
    }
    public static boolean isAllBlank(String S) {
        String test = S;
        return 0 == test.replace("-", "").length();
    }

    public static int positionAllSameTop(String S, boolean isHapi) {
        int pos = -1;
        for (String c : S.split("(?!^)")) {
            if (c.equals(isHapi? "-" : "+")) {
                break;
            }
            pos ++;
        }
        return pos;
    }

    public static int positionAllSameBottom(String S, boolean isHapi) {
        int pos = -1;
        for (String c : new StringBuilder(S).reverse().toString().split("(?!^)")) {
            if (c.equals(isHapi? "-" : "+")) {
                break;
            }
            pos ++;
        }
        if (pos == -1) {
            return pos;
        }
        return S.length() - pos;
    }

    public static long maneuver(String S) {
        String before;
        String after = S;
        long flipCount = 0;

        while(!isAllHappy(after)) {

            boolean startWithHapi = "+".equals(after.substring(0, 1));
            int pos = 1;

            while ( ( startWithHapi && (pos+1)<=after.length() && isAllHappy(after.substring(0, pos+1)) ) ||
                    ( !startWithHapi && (pos+1)<=after.length() && isAllBlank(after.substring(0, pos+1)) )) {
                pos++;
            }


            String flipped = flip(after.substring(0, pos));
            if  ((pos)<=S.length())
                after = flipped + after.substring(pos);
            else
                after = flipped;

            System.out.println("After "+ (++flipCount) +": "+after);

        }
        return flipCount;
    }


    public static void main(String[] args) {
	    String inputFile = "B-large";

        BufferedReader input = null;

        PrintWriter output = null;

        try {

            String sCurrentLine;

            input = new BufferedReader(new FileReader(path + inputFile + ".in"));
            output = new PrintWriter(path + inputFile + ".out", "UTF-8");

            sCurrentLine = input.readLine();
            System.out.println("Test Case Number: " + sCurrentLine);

            long lineIndex =0;
            long minmumFlip = Long.MAX_VALUE;
            while ((sCurrentLine = input.readLine()) != null) {
                System.out.println(sCurrentLine);

                minmumFlip = maneuver(sCurrentLine);


                String answer = minmumFlip+"";



                output.println(outputLine(lineIndex+1, answer));
                System.out.println("Answer: "+answer+"\n");

                lineIndex++;
            }

        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (input != null)input.close();
                output.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }
}
