package com.codejam2016.edgar.Q3;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class CoinJam {

    public static final String path = "/Users/edgaarrr/CodeJam/2016/qualification/src/com/codejam2016/edgar/Q3/";

    public static String outputLine(long testCaseNo, Object...anss) {
        String str = "Case #"+testCaseNo+":";
        for (Object ans : anss) {
             str = str + " " + ans;
       }
        return str;
    }

    public static boolean isPrime(long n) {
        //check if n is a multiple of 2
        if (n%2==0) return false;
        //if not, then just check the odds
        for(long i=3;i*i<=n;i+=2) {
            if(n%i==0)
                return false;
        }
        return true;
    }

    public static List<String> generateCoins(int N) {
        List<String> list = new ArrayList<>();

        if (N>2) {
            long max = (long) Math.pow( (double)2 ,(double) (N-2));

            for (int i=0; i< max; i++) {

                String iStr = toBase2(i);

                for (int j=iStr.length(); j<N-2; j++) {
                    iStr = "0"+iStr;
                }
                list.add("1"+iStr+"1");
            }
        } else {
            list.add("11");
        }
        System.out.println("generatedCoins: "+ list);
        return list;

    }
    public static String toBase2(int n) {
        if (n==0) {
            return "0";
        }
        StringBuilder binary = new StringBuilder();
        while (n>0) {
            if((n&1)==1){
                binary.append(1);
            }else
                binary.append(0);
            n>>=1;
        }

        return binary.reverse().toString();
    }

    public static boolean isJamCoins(String coin) {
        long value;
        long divisor;
        for (int base = 2 ; base <= 10; base++) {
            value = Long.parseLong(coin, base);
            if (isPrime(value)) {
                System.out.println(coin+"("+value+"): Is Prime");
                return false;
            }
        }

        return true;
    }

    public static long findNonTrivialDivisor(long coin) {
        for (long divisor = 2; divisor<coin; divisor++) {
            if (coin%divisor==0) {
                return divisor;
            }
        }
        return 1;
    }

    public static void main(String[] args) {
	    String inputFile = "C-small-attempt0";

        BufferedReader input = null;

        PrintWriter output = null;

        Set<String> digitUsed = null;

        try {

            String sCurrentLine;

            input = new BufferedReader(new FileReader(path + inputFile + ".in"));
            output = new PrintWriter(path + inputFile + ".out", "UTF-8");

            sCurrentLine = input.readLine();
            System.out.println("Test Case Number: " + sCurrentLine);

            int testCaseNo =0;
            while ((sCurrentLine = input.readLine()) != null) {
                testCaseNo++;
                output.println("Case #"+testCaseNo+":");

                String[] strs = sCurrentLine.split("\\s+");
                int digitNum = Integer.parseInt(strs[0]);
                int jamCoinsNum = Integer.parseInt(strs[1]);

                List<String> jamCoins = new ArrayList<>();
                for (String testCoin : generateCoins(digitNum)) {

                    if (isJamCoins(testCoin)) {
                        jamCoins.add(testCoin);
                        if (jamCoins.size()>=jamCoinsNum) {
                            break;
                        }
                    }
                }

                System.out.println(jamCoins);
                for (String jamCoin : jamCoins) {
                    String line = jamCoin+" ";
                    for (int base = 2 ; base <= 10; base++) {
                        line = line+" "+findNonTrivialDivisor(Long.parseLong(jamCoin, base));
                    }

                    output.println(line);
                }
            }

        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (input != null)input.close();
                output.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }
}
