import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class CookieClicker {

	public static void main(String[] args) throws IOException {
		File inputFile = null;
		if (args[0] != null) {
			inputFile = new File(args[0]);
		} else {
			inputFile = new File("c:/codeJam/input");
		}
		String line;
		int testNum = 0;
		BufferedReader br = null;
		List<Test> tests = new ArrayList<Test>();
		try {
			br = new BufferedReader(new FileReader(inputFile));
			if ((line = br.readLine()) != null) {
				testNum = Integer.parseInt(line);
			}
			if (testNum != 0) {
				int num = 0;
				while ((line = br.readLine()) != null) {
					num++;
					String[] input = line.split(" ");
					tests.add(new Test(num, Double.parseDouble(input[0]), Double.parseDouble(input[1]), Double.parseDouble(input[2])));
				}
			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			br.close();
		}

		PrintWriter writer = null;
		if (args.length > 1) {
			File output = new File(args[1]);
			writer = new PrintWriter(output);
		}
		
		for (Test test: tests) {
			String ans = test.getMinTime();
			System.out.println(ans);
			if (writer != null) {
				writer.println(ans);
			}
		}
		
		if (writer != null) {
			writer.close();
		}


	}
	
	private static class Test{
		private int testNum;
		private double C;
		private double F;
		private double X;
		
		public Test(int testNum, double c, double f, double x){
			this.testNum = testNum;
			this.C = c;
			this.F = f;
			this.X = x;
		}
		
		public String getMinTime() {
			boolean min = false;
			int N = 0;
			double R = 2;
			Double time = Double.valueOf(0);
			while (!min) {
				time = X / R - C / R - X / (R+F);
				if (time <= 0) {
					min = true;
				} else {
					N++;
					R += F;
				}
			}
			if (N == 0) {
				time = X / 2;
			} else {
				time = X / (2+ F*N);
				for (int i = 0; i < N; i++){
					time += C / (2 + i*F);
				}
			}
			DecimalFormat dec = new DecimalFormat("#.#######");

			return "Case #" + testNum + ": " + Double.valueOf(dec.format(time)).toString();
		}
		
	}

}
