import java.io.*;
import java.util.*;
import java.util.stream.Collectors;

public class Pancakes {
    public static void main(String[] args) throws IOException {
        BinaryIn binaryIn = new BinaryIn(args[0]);
        String[] input = binaryIn.readString().split("\n");
        int testNum = Integer.parseInt(input[0]);

        try (Writer writer = new BufferedWriter(new OutputStreamWriter(
                new FileOutputStream("./Pancakes/answer-" + args[0]), "utf-8"))) {
            int test = 1;
            for (int i = 1; i <= testNum * 2; i += 2) {
                //int D = Integer.parseInt(input[i]);
                long seconds = 0;
                List<Integer> plates = Arrays.asList(input[i + 1].split(" ")).stream()
                        .map(Integer::parseInt)
                        .collect(Collectors.toList());

                /*plates.forEach(System.out::print);
                System.out.println();*/
                String output = "Case #" + test + ": " + calcSeconds(plates) + "\n";
                test++;
                writer.write(output);
                System.out.print(output);

            }
            try {
                writer.close();
            } catch (Exception ignored) {

            }
        }
    }

    private static int calcSeconds(List<Integer> plates) {
        Map<Integer, Integer> n = new HashMap<>();
        for (int i: plates) {
            int m = 1;
            if (n.containsKey(i)) {
                m += n.get(i);
            }
            n.put(i, m);
        }
        boolean stop = false;
        int result = 0;
        List<Integer> variants = n.keySet().stream().sorted((a,b) -> Integer.compare(b,a)).collect(Collectors.toList());
        while (!stop) {
            if (variants.size() == 0) {
                break;
            }
            int max = variants.get(0);
            if (max == 1) {
                stop = true;
                result += 1;
            }
            if (variants.size() > 1) {
                int profit = max - variants.get(1) - n.get(max);
                if (profit < 0 ) {
                    result += max;
                    break;
                }
            } else {
                if (max <= 3) {
                    result += max;
                    break;
                } else if (max - (int)Math.ceil(max / 2.0) - n.get(max) < 0) {
                    result += max;
                    break;
                }
            }
            result += n.get(max);
            int maxDiv2;
            if (max % 2 == 0) {
                maxDiv2 = max / 2;
                int k = n.get(max) * 2;
                if (n.containsKey(maxDiv2)) {
                    k += n.get(maxDiv2);
                }
                n.put(maxDiv2, k);
            } else {
                maxDiv2 = (int) Math.ceil(max / 2.0);
                int maxDiv2Min = max / 2 - 1;
                int kMax = n.get(max);
                int kMin = n.get(max);
                if (n.containsKey(maxDiv2)) {
                    kMax += n.get(maxDiv2);
                }
                if (n.containsKey(maxDiv2Min)) {
                    kMin += n.get(maxDiv2Min);
                }
                n.put(maxDiv2, kMax);
                n.put(maxDiv2Min, kMin);
                if (!variants.contains(maxDiv2Min)) {
                    variants.add(maxDiv2Min);
                    variants = variants.stream().sorted((a,b) -> Integer.compare(b,a)).collect(Collectors.toList());
                }
            }
            variants.remove(0);
            if (!variants.contains(maxDiv2)) {
                variants.add(maxDiv2);
                variants = variants.stream().sorted((a,b) -> Integer.compare(b,a)).collect(Collectors.toList());
            }
        }
        return result;
    }
}
