import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class DeceitfulWar {

	public static void main(String[] args) throws IOException {
		File inputFile = null;
		if (args[0] != null) {
			inputFile = new File(args[0]);
		} else {
			inputFile = new File("c:/codeJam/input");
		}
		String line;
		int testNum = 0;
		BufferedReader br = null;
		List<Test> tests = new ArrayList<Test>();
		try {
			br = new BufferedReader(new FileReader(inputFile));
			if ((line = br.readLine()) != null) {
				testNum = Integer.parseInt(line);
			}
			if (testNum != 0) {
				int blocksNum;
				int num = 0;
				while ((line = br.readLine()) != null) {
					num++;
					blocksNum = Integer.parseInt(line);
					String[] naomiSt = br.readLine().split(" ");
					List<Double> naomi = new ArrayList<Double>();
					for (String n : naomiSt) {
						naomi.add(Double.parseDouble(n));
					}

					String[] kenSt = br.readLine().split(" ");
					List<Double> ken = new ArrayList<Double>();
					for (String n : kenSt) {
						ken.add(Double.parseDouble(n));
					}
					tests.add(new Test(num, blocksNum, naomi, ken));
				}
			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			br.close();
		}

		PrintWriter writer = null;
		if (args.length > 1) {
			File output = new File(args[1]);
			writer = new PrintWriter(output);
		}
		String ans = null;
		for (Test test : tests) {
			ans = test.getAnswer();
			System.out.println(ans);
			if (writer != null) {
				writer.println(ans);
			}
		}
		if (writer != null) {
			writer.close();
		}

	}

	private static class Test {
		private int testNum;
		private int blocksNum;
		private List<Double> naomi;
		private List<Double> ken;

		public Test(int num, int blocksNum, List<Double> naomi, List<Double> ken) {
			this.testNum = num;
			this.blocksNum = blocksNum;
			this.naomi = naomi;
			this.ken = ken;
		}

		public String getAnswer() {
			Comparator<Double> comparator = new Comparator<Double>() {
				@Override
				public int compare(Double double1, Double double2) {

					return Double.compare(double1, double2);
				}
			};
			Collections.sort(naomi, comparator);
			Collections.sort(ken, comparator);
			int W = 0;
			int DW = 0;
			if (naomi.get(blocksNum - 1) < ken.get(0)) {
				return "Case #" + testNum + ": 0 0";
			} else if (naomi.get(0) > ken.get(blocksNum - 1)) {
				W = blocksNum;
				DW = blocksNum;
			} else {
				List<Double> n = naomi;
				List<Double> k = ken;

				int i = 0;
				int j = blocksNum - 1;
				int p = 0;
				while (i < blocksNum) {
					if (n.get(i) < k.get(p)) {
						i++;
						j--;
					} else {
						DW++;
						i++;
						p++;
					}
					
				}

				while (n.size() > 0) {
					i = 0;
					while (i < n.size() && n.get(0) > k.get(i)) {
						i++;
					}
					if (i == n.size() || n.get(0) > k.get(i)) {
						W = n.size();
						n.clear();
					} else {
						n.remove(0);
						k.remove(i);
					}
				}
			}

			return "Case #" + testNum + ": " + DW + " " + W;
		}

	}

}
