package com.company;

import java.io.*;
import java.util.BitSet;

public class Pancakes {
    public static void main(String[] args) {
        Writer writer = null;
        try {
            writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("pancakes_large.txt"), "utf-8"));
            try {
                BufferedReader br = new BufferedReader(new FileReader(new File("B-large.in")));
                int inputNum = Integer.parseInt(br.readLine());
                for (int i = 0; i < inputNum; i++) {
                    writer.write("Case #" + (i + 1) + ": " + exec(br.readLine()) + "\n");
                }
            } catch (IOException e) {
                e.printStackTrace();
            }


        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                writer.close();
            } catch (Exception ex) {/*ignore*/}
        }
    }

    private static String exec(String input) {
        boolean[] cakes = readInput(input);
        int flips = 0;
        for (int i = cakes.length - 1; i >= 0; i--) {
            if (!cakes[i]) {
                if (cakes[0]) {
                    for (int j = 1; j <= i; j++) {
                        if (!cakes[j]) {
                            flip(cakes, j - 1);
                            flips++;
                            break;
                        }
                    }
                }
                flip(cakes, i);
                flips++;
            }
        }
        for (boolean b: cakes) {
            System.out.print((b ? 1 : 0));
        }
        System.out.println();
        return String.valueOf(flips);
    }

    private static boolean[] readInput(String input) {
        boolean[] cakes = new boolean[input.length()];
        int i = 0;
        for (char c: input.toCharArray()) {
            cakes[i] = c == '+';
            i++;
        }
        return cakes;
    }

    private static void flip(boolean[] cakes, int length) {
        int i = 0, j = length;
        while (i <= j) {
            if (i == j) {
                cakes[i] = !cakes[i];
            } else {
                boolean temp = cakes[j];
                cakes[j] = !cakes[i];
                cakes[i] = !temp;
            }
            i++;
            j--;
        }
    }
}
