import java.util.*;
import java.io.*;
public class C
{
	public static final int INFINITY = 1000000000;
	
	public static ArrayList<Edge>[] adj;
	public static int source;
	public static int sink;
	public static int[] dist;
	public static boolean[] blocked;
	
	public static void main(String[] args) throws Exception
	{
//		Scanner in = new Scanner(System.in);
//		PrintWriter out = new PrintWriter(System.out);
		
		Scanner in = new Scanner(new File("C-small-attempt0.in"));
		PrintWriter out = new PrintWriter(new FileWriter(new File("C-small.out")));
		
		int t = in.nextInt();
		for(int x = 0; x < t; x++)
		{
			int n = in.nextInt();
			in.nextLine();
			
			HashMap<String, Integer> map = new HashMap<String, Integer>();
			
			ArrayList<Integer>[] sentences = new ArrayList[n];
			for(int y = 0; y < n; y++)
			{
				String[] temp = in.nextLine().split(" ");
				sentences[y] = new ArrayList<Integer>();
				for(int z = 0; z < temp.length; z++)
				{
					if(!map.containsKey(temp[z]))
					{
						map.put(temp[z], map.size());
					}
					
					sentences[y].add(map.get(temp[z]));
				}
			}
			
			adj = new ArrayList[n + 2 * map.size()];
			for(int a = 0; a < adj.length; a++)
			{
				adj[a] = new ArrayList<Edge>();
			}
			
			source = 0;
			sink = 1;
			
			for(int b = 0; b < sentences.length; b++)
			{
				for(int c : sentences[b])
				{
					add(b, n + c, INFINITY);
					add(n + map.size() + c, b, INFINITY);
				}
			}
			
			for(int d = 0; d < map.size(); d++)
			{
				add(n + d, n + map.size() + d, 1);
			}
			
			out.println("Case #" + (x + 1) + ": " + dinic());
		}
		
		out.close();
	}
	
	public static void add(int a, int b, int cap)
	{
		Edge e1 = new Edge(b, cap);
		Edge e2 = new Edge(a, 0);
		e1.rev = e2;
		e2.rev = e1;
		adj[a].add(e1);
		adj[b].add(e2);
	}
	
	public static int dinic()
	{
		int result = 0;
		
		dist = new int[adj.length];
		
		while(getLevels())
		{
			blocked = new boolean[adj.length];
			result += blockingFlow(source, Integer.MAX_VALUE);
		}
		
		return result;
	}
	
	public static boolean getLevels()
	{
		Arrays.fill(dist, -1);
		ArrayDeque<Integer> queue = new ArrayDeque<Integer>();
		
		dist[source] = 0;
		queue.add(source);
		
		while(queue.size() > 0)
		{
			int node = queue.remove();
			
			for(Edge e : adj[node])
			{
				if(dist[e.end] == -1 && e.capacity > 0)
				{
					dist[e.end] = dist[node] + 1;
					queue.add(e.end);
				}
			}
		}
		
		return dist[sink] != -1;
	}
	
	public static int blockingFlow(int node, int flow)
	{
		if(flow == 0)
		{
			return 0;
		}
		else if(node == sink)
		{
			return flow;
		}
		else
		{
			int ret = 0;
			for(Edge e : adj[node])
			{
				if(!blocked[e.end] && dist[e.end] == dist[node] + 1 && e.capacity > 0)
				{
					int current = blockingFlow(e.end, Math.min(flow, e.capacity));
					e.capacity -= current;
					e.rev.capacity += current;
					flow -= current;
					ret += current;
				}
			}
			
			blocked[node] |= (flow > 0);
			
			return ret;
		}
	}
	
	static class Edge
	{
		int end;
		int capacity;
		Edge rev;
		
		public Edge(int e, int c)
		{
			end = e;
			capacity = c;
		}
	}
}
