import java.util.*;
import java.io.*;
public class B
{
	public static void main(String[] args) throws Exception
	{
//		Scanner in = new Scanner(System.in);
//		PrintWriter out = new PrintWriter(System.out);
		
		Scanner in = new Scanner(new File("B-small-attempt2.in"));
		PrintWriter out = new PrintWriter(new FileWriter(new File("B-small.out")));
		
		int t = in.nextInt();
		for(int y = 0; y < t; y++)
		{
			int n = in.nextInt();
			double v = in.nextDouble();
			double x = in.nextDouble();
			
			Water[] water = new Water[n];
			for(int z = 0; z < n; z++)
			{
				water[z] = new Water(in.nextDouble(), in.nextDouble());
			}
			
			Arrays.sort(water);
			
			double low = 0;
			double high = 1E18;
			while((high - low) / low >= 1E-9 || high - low >= 1E-9)
			{
				double mid = (low + high) / 2.0;
				
				double[] amounts = new double[water.length];
				for(int a = 0; a < water.length; a++)
				{
					amounts[a] = mid * water[a].rate;
				}
				
				double max = 0;
				double sum = 0;
				for(int b = 0; b < water.length; b++)
				{
					if(sum + water[b].temp * amounts[b] < x * v)
					{
						max += amounts[b];
						sum += water[b].temp * amounts[b];
					}
					else
					{
						double current = (x * v - sum) / water[b].temp;
						max += current;
						sum += current * water[b].temp;
					}
				}
				
				double min = 0;
				sum = 0;
				for(int c = water.length - 1; c >= 0; c--)
				{
					if(sum + water[c].temp * amounts[c] < x * v)
					{
						min += amounts[c];
						sum += water[c].temp * amounts[c];
					}
					else
					{
						double current = (x * v - sum) / water[c].temp;
						min += current;
						sum += current * water[c].temp;
					}
				}
				
				if(min <= v + 1E-18 && max >= v - 1E-18)
				{
					high = mid;
				}
				else
				{
					low = mid;
				}
			}
			
			out.print("Case #" + (y + 1) + ": ");
			if(low > 1E17)
			{
				out.println("IMPOSSIBLE");
			}
			else
			{
				out.printf("%.20f%n", low);
			}
		}
		
		out.close();
	}
	
	static class Water implements Comparable<Water>
	{
		double rate;
		double temp;
		
		public Water(double r, double c)
		{
			rate = r;
			temp = c;
		}
		
		public int compareTo(Water o)
		{
			return Double.compare(temp, o.temp);
		}
	}
}
