import java.util.*;
import java.io.*;
public class A
{
	public static void main(String[] args) throws Exception
	{
//		FastScanner in = new FastScanner(System.in);
//		PrintWriter out = new PrintWriter(System.out);
		
		FastScanner in = new FastScanner(new File("A-large.in"));
		PrintWriter out = new PrintWriter(new FileWriter(new File("A-large.out")));
		
		int[] dr = {1, 0, -1, 0};
		int[] dc = {0, 1, 0, -1};
		String types = "v>^<";
		
		int t = in.nextInt();
		for(int x = 0; x < t; x++)
		{
			int r = in.nextInt();
			int c = in.nextInt();
			
			char[][] grid = new char[r][c];
			for(int y = 0; y < r; y++)
			{
				grid[y] = in.next().toCharArray();
			}
			
			int result = 0;
			outer:
			for(int z = 0; z < grid.length; z++)
			{
				for(int a = 0; a < grid[0].length; a++)
				{
					if(grid[z][a] != '.')
					{
						boolean current = false;
						for(int b = 0; b < dr.length; b++)
						{
							current |= safe(z, a, dr[b], dc[b], grid);
						}
						
						if(!current)
						{
							result = -1;
							break outer;
						}
						
						if(!safe(z, a, dr[types.indexOf(grid[z][a])], dc[types.indexOf(grid[z][a])], grid))
						{
							result++;
						}
					}
				}
			}
			
			out.print("Case #" + (x + 1) + ": ");
			if(result == -1)
			{
				out.println("IMPOSSIBLE");
			}
			else
			{
				out.println(result);
			}
		}
		
		out.close();
	}
	
	public static boolean safe(int row, int col, int dr, int dc, char[][] grid)
	{
		row += dr;
		col += dc;
		
		while(row >= 0 && row < grid.length && col >= 0 && col < grid[0].length)
		{
			if(grid[row][col] != '.')
			{
				return true;
			}
			
			row += dr;
			col += dc;
		}
		
		return false;
	}
	
	static class FastScanner
	{
		BufferedReader br;
		StringTokenizer st;
		
		public FastScanner(InputStream input)
		{
			br = new BufferedReader(new InputStreamReader(input));
			st = new StringTokenizer("");
		}
		
		public FastScanner(File f) throws IOException
		{
			br = new BufferedReader(new FileReader(f));
			st = new StringTokenizer("");
		}
		
		public String next() throws IOException
		{
			if(st.hasMoreTokens())
			{
				return st.nextToken();
			}
			else
			{
				st = new StringTokenizer(br.readLine());
				return next();
			}
		}
		
		public int nextInt() throws IOException
		{
			return Integer.parseInt(next());
		}
	}
}
