package google.qualification;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;

public class FairSquare {

    public int count(int min, int max) {
        int total = 0;
        int currentsqrt = (int) Math.sqrt(min);
        int current = currentsqrt * currentsqrt;
        while (current <= max) {
            if (current >= min && current <= max) {
                if (isPalyndrome(currentsqrt) && isPalyndrome(current)) {
                    total++;
                }
            }
            currentsqrt++;
            current = currentsqrt * currentsqrt;
        }

        return total;
    }

    private boolean isPalyndrome(int num) {
        String value = String.valueOf(num);
        int i = 0, j = value.length() - 1;
        while (j > i) {
            if (value.charAt(i) != value.charAt(j)) {
                return false;
            }
            i++;
            j--;
        }
        return true;
    }

    public static void main(String[] args) throws Exception {
        String file = "fairsquare/C-small-attempt0.in";
        BufferedReader reader = null;
        try {
            InputStream stream = FairSquare.class.getClassLoader().getResourceAsStream(file);
            reader = new BufferedReader(new InputStreamReader(stream));

            int T = Integer.parseInt(reader.readLine().trim());

            for (int i = 0; i < T; i++) {
                String[] values = reader.readLine().trim().split("\\s+");
                int count = new FairSquare().count(Integer.parseInt(values[0]), Integer.parseInt(values[1]));
                System.out.println(String.format("Case #%s: %s", (i + 1), count));
            }
        } finally {
            if (reader != null) {
                reader.close();
            }
        }
    }
}
