import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;

public class CountingSheep {

	public void go(String[] args) throws Exception {
		BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(args[0])));
		int T = Integer.parseInt(reader.readLine());
		for (int idx = 0; idx < T; idx++) {
			int N = Integer.parseInt(reader.readLine());

			String msg = "Case #" + (idx + 1) + ": ";
			if (N == 0) {
				System.out.println(msg + "INSOMNIA");
				continue;
			}
			int value = count(N);
			System.out.println(msg + value);
		}
	}

	private int count(int num) {
		boolean[] digits = new boolean[10];

		int i = 0;
		while (!isComplete(digits) && i < 10000) {
			int parts = num * ++i;
			while (parts > 0) {
				int digit = parts % 10;
				parts = parts / 10;
				digits[digit] = true;
			}
		}

		return num * i;
	}

	private boolean isComplete(boolean[] digits) {
		for (boolean val : digits) {
			if (!val)
				return false;
		}
		return true;
	}

	public static void main(String[] args) throws Exception {
		new CountingSheep().go(args);
	}

}
