import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.Arrays;

public class CoinJam {

	public void go(String[] args) throws Exception {
		BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(args[0])));
		int T = Integer.parseInt(reader.readLine());
		for (int idx = 0; idx < T; idx++) {
			String line = reader.readLine();
			String[] parts = line.split(" ");

			String msg = "Case #" + (idx + 1) + ":";
			System.out.println(msg);
			Output[] outputs = count(Integer.parseInt(parts[0]), Integer.parseInt(parts[1]));
			for (Output output : outputs) {
				StringBuilder str = new StringBuilder(output.value);
				for (long d : output.divisors) {
					str.append(" ").append(d);
				}
				System.out.println(str);
			}
		}
	}

	private Output[] count(int N, int J) {
		Output[] outputs = new Output[J];
		int found = 0;
		outloop: for (long i = 0; i < Math.pow(2, N - 2); i++) {
			String inner = Long.toBinaryString(i);
			String value = "1" + pad(inner, N - 2) + "1";

			Output output = new Output();
			output.value = value;
			for (int base = 2; base <= 10; base++) {
				long inBase = Long.parseLong(value, base);
				long divisor = isPrime(inBase);
				if (divisor == 0) {
					continue outloop;
				}
				output.divisors[base - 2] = divisor;
			}

			outputs[found] = output;
			if (++found == J) {
				break outloop;
			}
		}

		return outputs;
	}

	private String pad(String num, int length) {
		StringBuilder builder = new StringBuilder();
		for (int i = 0; i < length - num.length(); i++) {
			builder.append("0");
		}
		return builder.append(num).toString();
	}

	public long isPrime(long n) {
		for (long i = 2; i < Math.sqrt(n); i++) {
			if (n % i == 0) {
				return i;
			}
		}
		return 0;
	}

	private class Output {
		public String value;
		public long[] divisors = new long[9];
	}

	public static void main(String[] args) throws Exception {
		new CoinJam().go(args);
	}

}
