import java.lang.*;
import java.io.*;
import java.util.*;

public class MinesweeperMaster {

  public void solve(String file) throws Exception {
    BufferedReader reader = new BufferedReader(new FileReader(file));
    int T = Integer.parseInt(reader.readLine());
    next: for (int i = 1; i <= T; i++) {
      String[] parts = reader.readLine().split(" ");
      int R = Integer.parseInt(parts[0]);
      int C = Integer.parseInt(parts[1]);
      int M = Integer.parseInt(parts[2]);

      int[][] grid = solve(R, C, M);

      System.out.println("Case #" + i + ":");
      if (grid != null) {
        for (int a = 0; a < R; a++) {
          for (int b = 0; b < C; b++) {
            if (isClickable(R, C, grid, a, b)) {
              print(grid, a, b);
              continue next;
            }
          }
        }
      }
      System.out.println("Impossible");
    }
  }

  private int[][] solve(int R, int C, int M) throws Exception {
    int[][] grid = new int[R][C];
    int m = M;

    for (int i = 0; m > 0 && i < Math.max(R, C) - 1; i++) {
      m = mineGrid(R, C, grid, i, m);
      if (m == 0) break;
    }

    return (m == 0) ? grid : null;
  }

  private int mineGrid(int R, int C, int[][] grid, int pos, int m) {
    for (int j = 0; j < C; j++) {
      if (grid[pos][j] != Integer.MAX_VALUE) {
        grid[pos][j] = Integer.MAX_VALUE;
        m--;
        if (m == 0) return 0;
      }
    }
    for (int i = 0; i < R; i++) {
      if (grid[i][pos] != Integer.MAX_VALUE) {
        grid[i][pos] = Integer.MAX_VALUE;
        m--;
        if (m == 0) return 0;
      }
    }

    return m;
  }

  private boolean isClickable(int R, int C, int[][] grid, int i, int j) {
    if (grid[i][j] != 0) return false;
    if (i > 0 && j > 0 && grid[i - 1][j - 1] == Integer.MAX_VALUE) return false;
    if (i > 0 && grid[i - 1][j] == Integer.MAX_VALUE) return false;
    if (i > 0 && j < C - 1 && grid[i - 1][j + 1] == Integer.MAX_VALUE) return false;
    if (j > 0 && grid[i][j - 1] == Integer.MAX_VALUE) return false;
    if (j < C - 1 && grid[i][j + 1] == Integer.MAX_VALUE) return false;
    if (i < R - 1 && j > 0 && grid[i + 1][j - 1] == Integer.MAX_VALUE) return false;
    if (i < R - 1 && grid[i + 1][j] == Integer.MAX_VALUE) return false;
    if (i < R - 1 && j < C - 1 && grid[i + 1][j + 1] == Integer.MAX_VALUE) return false;

    return true;
  }

  private void print(int[][] grid, int i1, int j1) {
    for (int i = 0; i < grid.length; i++) {
      String line = "";
      for (int j = 0; j < grid[i].length; j++) {
        if (i == i1 && j == j1) {
          line += "c ";
        }
        else if (grid[i][j] == Integer.MAX_VALUE) {
          line += "* ";
        }
        else {
          line += ". ";
        }
      }
      System.out.println(line.trim());
    }
  }

  public static void main(String[] args) throws Exception {
    new MinesweeperMaster().solve(args[0]);
  }
}
