import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.PriorityQueue;
import java.util.Queue;
import java.util.StringTokenizer;

public class Code
{
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	int getLowBound(int y, int z) {
		int q = (11 * z) / 10;
		return (y + q - 1) / q;
	}
	
	int getHighBound(int y, int z) {
		return y / ((9 * z) / 10);
	}

	void solve() throws IOException {
		int T = nextInt();
		for (int iT = 0; iT < T; iT++) {
			int N = nextInt();
			int P = nextInt();
			int[] R = new int[N];
			for (int i = 0; i < N; i++) {
				R[i] = nextInt();
				R[i] *= 10;
			}
			int[][] Q = new int[N][P];
			for (int i = 0; i < N; i++) {
				for (int j = 0; j < P; j++) {
					Q[i][j] = nextInt();
					Q[i][j] *= 10;
				}
			}
			
			List<List<Segment>> a = new ArrayList<List<Segment>>(N);
			List<Queue<Integer>> q = new ArrayList<Queue<Integer>>(N);
			int[] p = new int[N];
			for (int i = 0; i < N; i++) {
				List<Segment> cur = new ArrayList<Segment>(P);
				for (int j = 0; j < P; j++) {
					cur.add(new Segment(getLowBound(Q[i][j], R[i]), getHighBound(Q[i][j], R[i])));
				}
				Collections.sort(cur);
				a.add(cur);
				p[i] = 0;
				q.add(new PriorityQueue<Integer>());
			}

			int res = 0;
			int cur = 0;
			
			
			while (true) {
				
				cur++;
				for (int i = 0; i < N; i++) {
					while ((p[i] < P) && (a.get(i).get(p[i]).l <= cur)) {
						q.get(i).add(a.get(i).get(p[i]).r);
						p[i]++;
					}
				}
				
				boolean flag;
				flag = true;
				boolean kill;
				kill = false;
				for (int i = 0; i < N; i++) {
					if (q.get(i).isEmpty()) {
						flag = false;
						if (p[i] == P) {
							kill = true;
						} else {
							cur = a.get(i).get(p[i]).l - 1;
						}
						flag = false;
						break;
					}
				}
				if (!flag) {
					if (kill) {
						break;
					} else {
						continue;
					}
				}
				
				flag = true;
				for (int i = 0; i < N; i++) {
					while ((!q.get(i).isEmpty()) && (q.get(i).peek() < cur)) {
						q.get(i).poll();
					}
					if (q.get(i).isEmpty()) {
						flag = false;
					}
				}
				
				if (flag) {
					res++;
					for (int i = 0; i < N; i++) {
						q.get(i).poll();
					}
					cur--;
				}
			}
			
			out.println("Case #" + String.valueOf(iT + 1) + ": " + res);
		}
	}
  
	Code() throws IOException {
		try {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));
			st = new StringTokenizer("");
			solve();
			in.close();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
  
	public static void main(String[] args) throws IOException {
		new Code();
	}
  
	String next() throws IOException {
		while (!st.hasMoreTokens()) {
			String line = in.readLine();
			if (line != null) st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	long nextLong() throws IOException {
		return Long.parseLong(next());
	}
	
	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}
	
	private static class Segment implements Comparable<Segment> {
		
		public int l, r;
		
		public Segment(int l, int r) {
			this.l = l;
			this.r = r;
		}

		@Override
		public int compareTo(Segment o) {
			return this.l - o.l;
		}
		
	}
}
