package magicka;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class MagickaTest {
	
	public static void main(String[] args) throws Exception {
		String fileName = "C:/Users/Eddie/Downloads/B-small-attempt0.in";
		TestData[] data = parseFile(fileName);
		
		for(int i = 0; i < data.length; i++) {
			StringBuilder builder = new StringBuilder();
			TestData td = data[i];
			
			char[] elements = td.elements.toCharArray();
			
			for(char c : elements) {
				if(builder.length() > 0) {
					String prev = builder.substring(builder.length() - 1, builder.length());
					prev += c;
					
					String prevRev = new StringBuilder(prev).reverse().toString();
					
//					System.out.println("Combinations to search: " + prev + "(" + td.combinations.containsKey(prev) + ") " + prevRev + "(" + td.combinations.containsKey(prevRev) + ")");
					
					//do combinations
					if(td.combinations.containsKey(prev)) {
						builder.replace(builder.length() - 1, builder.length(), td.combinations.get(prev).toString());
						continue;
					}
					
					if(td.combinations.containsKey(prevRev)) {
						builder.replace(builder.length() - 1, builder.length(), td.combinations.get(prevRev).toString());
						continue;
					}
					
					if(td.oppositions.containsKey(c)) {
						//System.out.print("Searching oppositions for " + c + ": ");
						Set<Character> opposes = td.oppositions.get(c);
						
						for(char cc : opposes) {
							if(builder.indexOf(String.valueOf(cc)) >= 0) {
								builder.setLength(0);
							}
						}
						
						if(builder.length() == 0) {
							continue;
						}
					}
				}
				
				builder.append(c);
				
//				System.out.println(builder);
				
				
			}
			
			System.out.println("Case #" + (i + 1) + ": " + Arrays.toString(builder.toString().toCharArray()));
//			System.out.println("------------------");
			
		}
	}
	
	public static TestData[] parseFile(String fileName) throws FileNotFoundException {
		Scanner scanner = new Scanner(new File(fileName));
		
		String numTests = scanner.nextLine();
		int t = Integer.parseInt(numTests);
		TestData[] data = new TestData[t];
		
		for(int i = 0; i < t; i++) {
			TestData test = new TestData();
			
			String line = scanner.nextLine();
			
			String[] split = line.split("\\s");
			int arrPos = 0;
			
			int numCombine = Integer.parseInt(split[arrPos]);
			arrPos++;
			
//			System.out.println("Found " + numCombine + " to combine!");
			
			int j;
			for(j = 0; j < numCombine; j++) {
				String toCombine = split[arrPos];
				String match = toCombine.substring(0, 2);
				char result = toCombine.charAt(2);
				
				test.combinations.put(match, result);
			
				arrPos++;
				
//				System.out.println("Matching " + match + " to create " + result);
			}
			
			int numConflict = Integer.parseInt(split[arrPos]);
		
//			System.out.println("Found " + numConflict + " conflicts!");
			
			arrPos++;
			
			for(j = 0; j < numConflict; j++) {
				String conflicting = split[arrPos];
				char first = conflicting.charAt(0);
				char last = conflicting.charAt(1);
				
				test.guaranteeOppositionSet(first);
				test.guaranteeOppositionSet(last);
				
				test.oppositions.get(first).add(last);
				test.oppositions.get(last).add(first);
				
//				System.out.println("Conflicting elements: " + first + " and " + last);
				arrPos++;
			}
			
			int numElements = Integer.parseInt(split[arrPos]);
			arrPos++;
			
//			System.out.println("Found " + numElements + " elements: " + split[arrPos]);
			
			test.elements = split[arrPos];
			
			data[i] = test;
			
			//System.out.println();
		}
		
		return data;
	}
	
	private static class TestData {
		Map<Character, Set<Character>> oppositions = new HashMap<Character, Set<Character>>();
		Map<String, Character> combinations = new HashMap<String, Character>();
		
		String elements;
		
		public void guaranteeOppositionSet(Character key) {
			if(!oppositions.containsKey(key)) {
				oppositions.put(key, new HashSet<Character>());
			}
		}
	}
}
