package robots;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Queue;
import java.util.Scanner;
import java.util.concurrent.ArrayBlockingQueue;

public class RobotTest {

	public static void main(String[] args) throws Exception {
		String filename = "C:\\Users\\Eddie\\AppData\\Local\\Temp\\A-small-attempt0.in.txt";
		Target[][] targets = readFile(filename);
		
		for(int i = 0; i < targets.length; i++) {
			int seconds = compute(targets[i]);
			System.out.println("Case #" + (i + 1) + ": " + seconds);
		}
		
	}
	
	static int compute(Target[] targets ) {
		Queue<Target> read = new ArrayBlockingQueue<Target>(100);
		
		for(Target tt : targets) {
			read.add(tt);
		}

		int seconds = 0;
	
		while(!read.isEmpty()) {
			Target t = read.poll();
			
			Robot next = t.robot;
			Robot other;
			
			if(next == Robot.BLUE) {
				other = Robot.ORANGE;
			} else {
				other = Robot.BLUE;
			}
			
			//doesn't have a target
			if(next.target == -1) {
				next.target = t.position;
			}
			
			if(other.target == -1) {
				for(Target target : read) {
					if(target.robot == other) {
						other.target = target.position;
						break;
					} 
				}
			}
			
			while(next.step()) {
				other.step();
				seconds++;
			}
			
			//press that mo-fucking button
			other.step();
			seconds++;
			
			next.target = -1;
			
			//System.out.println("ORANGE: " + Robot.ORANGE.pos + "\tBLUE: " + Robot.BLUE.pos);
		}
		
		Robot.BLUE.pos = 1;
		Robot.ORANGE.pos = 1;
		Robot.BLUE.target = -1;
		Robot.ORANGE.target = -1;
		
		return seconds;
	}
	
	static Target[][] readFile(String fileName) throws FileNotFoundException {
		Target[][] targets = null;
		
		Scanner scanner = new Scanner(new File(fileName));
		
		int total = Integer.parseInt(scanner.nextLine());
		targets = new Target[total][];
		
		int n = 0;
		
		for(n = 0; n < total; n++) {
			String line = scanner.nextLine();
			String[] split = line.split("\\s");
			
			Target[] round = new Target[Integer.parseInt(split[0])]; 
			
			for(int i = 1; i < split.length; i += 2) {
				String robS = split[i];
				String pos = split[i + 1];
				
				Robot robot;
				
				if(robS.equals("O")) {
					robot = Robot.ORANGE;
				} else {
					robot = Robot.BLUE;
				}
				
				int position = Integer.parseInt(pos);
				
				round[i/2] = new Target(robot, position);
			}
			
			targets[n] = round;
		}
		
		return targets;
	}
	
	static private enum Robot {
		BLUE,
		ORANGE;
		
		int pos = 1;
		int target = -1;
		
		public boolean step() {
			if(target == -1) {
				return false;
			}
			
			if(pos > target) {
				pos--;
				return true;
			} else if (pos < target) {
				pos++;
				return true;
			} else {
				
				return false;
			}
		}
		
	}
	
	static private class Target {
		Robot robot;
		int position;
		
		public Target(Robot robot, int position) {
			this.robot = robot;
			this.position = position;
		}
	}
}
