package problems;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

public class MagicTrick {

	public static final int LINES_PER_CASE = 10;
	public static final String TEMPLATE = "Case #%d: %s";
	public static final String VOL_CHEATED = "Volunteer cheated!";
	public static final String BAD_MAGICIAN = "Bad Magician!";

	public static void main(String[] args) throws FileNotFoundException {
		File in = new File("A-small-attempt0.in");
		Scanner sc = new Scanner(in);
		int numCases = Integer.parseInt(sc.nextLine());
		for (int i = 0; i < numCases; i++) {
			String[] lines = new String[LINES_PER_CASE];
			for (int j = 0; j < LINES_PER_CASE; j++)
				lines[j] = sc.nextLine();
			analyzeCase(lines, i + 1);
		}
		sc.close();
	}

	public static void analyzeCase(String[] lines, int case_num) {
		int response1 = Integer.parseInt(lines[0]);
		int response2 = Integer.parseInt(lines[5]);
		String[] first_row = lines[response1].split(" ");
		String[] second_row = lines[5 + response2].split(" ");
		
		Set<String> overlapChecker = new HashSet<String>();
		for (String num : first_row)
			overlapChecker.add(num);
		for (String num : second_row)
			overlapChecker.add(num);
//		System.out.println(overlapChecker);
		
		if (overlapChecker.size() == 7) {
			List<String> a = new ArrayList<String>(Arrays.asList(first_row));
			List<String> b = new ArrayList<String>(Arrays.asList(second_row));
			a.retainAll(b);
			String magicNum = a.get(0);
			System.out.println(String.format(TEMPLATE, case_num, magicNum));
		}
		else if (overlapChecker.size() == 8)
			System.out.println(String.format(TEMPLATE, case_num, VOL_CHEATED));
		else
			System.out.println(String.format(TEMPLATE, case_num, BAD_MAGICIAN));
	}
}
