import java.io.*;
import java.util.*;

//maxflow/max matching/Minimum Vertex Cover=MCBM=V-Max Independent Set(Dominating Set)
//find MVC == find the MCBM == find the max flow of bipartite graph
public class pony {
    static int T, N, Q;
    static long[] e,s;
    static boolean visited[];
    static long[][] adj,dist;
    static int [][] q;
    static double total=0.0;
    static double INF=0.000001;
    static double dp[];

    public static void main(String[] args) throws IOException {
        Scanner f = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        T = Integer.parseInt(f.nextLine());
        StringTokenizer st;
        for (int k = 0; k < T; k++) {
            st = new StringTokenizer(f.nextLine());
            N = Integer.parseInt(st.nextToken());
            Q = Integer.parseInt(st.nextToken());
            e = new long[N]; s=new long[N];
            adj = new long[N][N]; dist=new long[N][N];
            q = new int[Q][2];
            dp = new double[N];

            visited = new boolean[N];

            for (int i = 0; i < N; i++) {
                st = new StringTokenizer(f.nextLine());
                e[i] = Integer.parseInt(st.nextToken());
                s[i] = Integer.parseInt(st.nextToken());
            }
            for (int i = 0; i < N; i++) {
                st = new StringTokenizer(f.nextLine());
                for (int j = 0; j < N; j++) {
                    adj[i][j] = Long.parseLong(st.nextToken());
                }
            }
            for (int i = 0; i <Q ; i++) {
                st = new StringTokenizer(f.nextLine());
                q[i][0] = Integer.parseInt(st.nextToken());
                q[i][1] = Integer.parseInt(st.nextToken());
            }
            Arrays.fill(dp, Double.MAX_VALUE/100);
            dp[N-1]=0.0;
            for (int i = 0; i <N-1 ; i++) {
                for (int j = i+1; j < N; j++) {
                    dist[i][j]=dist[i][j-1]+adj[j-1][j];
                }
            }
            for (int i = 0; i < N-1; i++) {
                if (i+e[i]>=N-1){
                    dp[i]=((double)dist[i][N-1]) / s[i];
                }
            }
            for (int i = N-2; i >=0 ; i--) {
                for (int j = i+1; j <= Math.min(i+e[i],N-1); j++) {
                    dp[i] = Math.min(dp[i], dp[j]+((double)dist[i][j]) / s[i]);
                }
            }

            total = dp[0];
            //total=bfs(0);

            System.out.println("Case #" + (k + 1) + ": " +total);
        }
    }


     public static double bfs(int v) {
             pair2 st = new pair2(v, e[v], s[v],0.0);
             PriorityQueue<pair2> q = new PriorityQueue<>();
             q.offer(st);
             while (!q.isEmpty()) {
                 pair2 p = q.poll();
                 int d = p.index;
                 if (d==N-1) return p.t;
                 long dist = adj[d][d+1];
                 double t= p.t+((double)dist)/p.s;
                 //if (visited[d]) continue;
                 //visited[d] = true;
                 long e1 = p.e-dist;
                 if (d<N-2 && e1>=adj[d+1][d+2]) {
                     pair2 p1 = new pair2(d + 1, e1, p.s, t);
                     q.offer(p1);
                 }
                 pair2 p2 = new pair2(d+1, e[d+1],s[d+1],t);
                 q.offer(p2);
             }
             return 0.0;
         }

}
class pair2 implements Comparable<pair2>{
    int index;
    long e,s;
    double t;
    public pair2(int i, long e, long s, double t) {
        this.index=i;
        this.e=e;
        this.s=s;
        this.t = t;
    }
    public int compareTo(pair2 b){
        if (Math.abs(this.t-b.t)<0.000001) {
            if  (b.s<this.s) return -1;
            return 1;
        }
        if (this.t<b.t)return -1;
        if (this.t>b.t) return 1;
        return 0;
    }
}