package round1b;

import com.google.common.base.Preconditions;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.*;

/**
 * @author jhedwardyang
 */
public class P1 {
    private static double getTime(int dest, List<Map.Entry<Integer, Integer>> lst) {
        double slowestCompletionTime = 0;
        for (Map.Entry<Integer, Integer> entry : lst) {
            int intialPos = entry.getKey();
            int maxSpeed = entry.getValue();
            int distanceToTravel = dest - intialPos;
            double time = ((double) distanceToTravel) / ((double) maxSpeed);
            slowestCompletionTime = Math.max(slowestCompletionTime, time);
        }
        return slowestCompletionTime;
    }

    public static void main(String[] args) throws FileNotFoundException {
        Preconditions.checkArgument(1 == args.length);

        Scanner in = new Scanner(new File(args[0]));
        int cases = in.nextInt();

        for (int i = 1; i <= cases; ++i) {
            int dest = in.nextInt();
            int numHorses = in.nextInt();
            List<Map.Entry<Integer, Integer>> lst = new ArrayList<>(numHorses);
            for (int j = 1; j <= numHorses; ++j) {
                int initialPos = in.nextInt();
                int maxSpeed = in.nextInt();
                lst.add(new AbstractMap.SimpleEntry<>(initialPos, maxSpeed));
            }

            double res = getTime(dest, lst);
            double speed = ((double) dest) / res;

            // read it.
            // run it.
            System.out.print("Case #" + i + ": ");
            System.out.println(speed);
        }
    }
}
