package A;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Map;
import java.util.Scanner;

public class P1 {
    private static final char HAPPY = '+';
    private static final char SAD = '-';

    private static void print(boolean[] arr) {
        for (int i = 0; i < arr.length; ++i) {
            System.out.print(arr[i] ? HAPPY : SAD);
        }
        System.out.println();
    }

    // Flip k at n.
    private static void flip(boolean[] arr, int n, int k) {
        for(int i = n; i < n + k; ++i) {
            arr[i] = !arr[i];
        }
    }

    private static int pancake(boolean[] arr, int k) {
        int count = 0;
        for (int i = 0; i < (arr.length / 2); ++i) {
            if (i + k >  arr.length) {
                break;
            }
            if (!arr[i]) {
                flip(arr, i, k);
                ++count;
            }
            if (!arr[arr.length - 1 - i]) {
                flip(arr, arr.length - i - k, k);
                ++count;
            }
        }
        for (int i = 0; i < arr.length; ++i) {
            if (!arr[i]) {
                throw new IllegalArgumentException("");
            }
        }
        return count;
    }

    public static void main(String[] args) throws FileNotFoundException {
        if (1 != args.length) {
            return;
        }

        Scanner in = new Scanner(new File(args[0]));
        int t = in.nextInt();

        for (int i = 0; i < t; ++i) {
            String str = in.next();
            boolean[] arr = new boolean[str.length()];
            for (int j = 0; j < arr.length; ++j) {
                if ('+' == str.charAt(j)) {
                    arr[j] = true;
                } else if ('-' == str.charAt(j)) {
                    arr[j] = false;
                }
            }
            int k = in.nextInt();

            System.out.print("Case #" + (i + 1) + ": ");
            try {
                int result = P1.pancake(arr, k);
                System.out.println(result);
            } catch (IllegalArgumentException e) {
                System.out.println("IMPOSSIBLE");
            }
        }
    }
}