import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.*;


public class Y2016_RQ_C {

    private static final String Q_NUM = "C";
    private static final int INPUT_TYPE = 1;

    private static final int N = 32;
    private static final int J = 500;

    // For small input only, N=16(digits), J=50(jamcoins). Max jamcoin is 1111111111111111.
    private String solve(Scanner sc, int caseNum) {
        StringBuilder ans = new StringBuilder("\n");
        int count = 0;
        int nlesstwo = N - 2;
        String middleMaxS = "11111111111111111111111111111111111111111111111111111111".substring(0, nlesstwo);
        int middleMax = Integer.parseInt(middleMaxS, 2);
        LOOP1:
        for (int middle = 0; middle <= middleMax; middle++) {
            String middleS = String.format("%"+nlesstwo+"s", Integer.toBinaryString(middle)).replace(' ', '0');
            String jamcoinMaybe = "1"+middleS+"1";
            System.out.println(jamcoinMaybe+" trying .. ");
            StringBuilder line = new StringBuilder(jamcoinMaybe);
            for (int radix = 2; radix <= 10; radix++) {
                BigInteger value = new BigInteger(jamcoinMaybe, radix);
                if (value.isProbablePrime(1)) { // probable prime
                    continue LOOP1;
                }
                BigInteger divisor = getDivisor(value);
                if (divisor == null) {
                    continue LOOP1;
                }
                line.append(" ").append(divisor);
//                long value = Long.parseLong(jamcoinMaybe, radix);
//                long divisor = getDivisor(value);
//                if (divisor == 1) { // prime
//                    continue LOOP1;
//                }
//                line.append(" ").append(divisor);
            }
            line.append("\n");
            ans.append(line);
            System.out.print(line);
            if (++count == J) {
                break;
            }
        }
        return ans.toString();
    }

    private long getDivisor(long n) {
        if (n % 2 == 0) return 2;
        for (long i = 3; i * i <= n; i += 2) {
            if (n % i == 0)
                return i;
        }
        return 1; // is a prime
    }

    private BigInteger getDivisor(BigInteger n) {
        for (BigInteger prime : PRIMES) {
            if (prime.pow(2).compareTo(n) > 0) {
                break;
            }
            if (n.mod(prime).equals(BigInteger.ZERO)) {
                return prime;
            }
        }
        return null;
//        BigInteger TWO = new BigInteger("2");
//        if (n.mod(TWO).equals(BigInteger.ZERO)) {
//            return TWO;
//        }
//        long count = 0;
//        for (BigInteger divisor = new BigInteger("3");
//             divisor.pow(2).compareTo(n) <= 0;
//             divisor = divisor.add(TWO)) {
//            if (++count == 1234567) {
//                break;
//            }
//            if (n.mod(divisor).equals(BigInteger.ZERO)) {
//                return divisor;
//            }
//        }
//        return null;
    }

    private static int N_PRIMES = 9999;
    private static List<BigInteger> PRIMES = new ArrayList<>(N_PRIMES);
    static {
        BigInteger prime = BigInteger.ONE;
        for (int i = 0; i < N_PRIMES; i++) {
            prime = prime.nextProbablePrime();
            PRIMES.add(prime);
        }
    }

    public Y2016_RQ_C() throws IOException {
        String prefix = Q_NUM + '/' + Q_NUM;
        String file_in, file_out;
        if (INPUT_TYPE == 2) {
            file_in = prefix + "-small.in";
            file_out = prefix + "-small.out";
        } else if (INPUT_TYPE == 3) {
            file_in = prefix + "-large.in";
            file_out = prefix + "-large.out";
        } else {
            file_in = prefix + "ii";
            file_out = prefix + "oo0";
        }

        Scanner sc = new Scanner(new File(file_in));
        int T = sc.nextInt();
        sc.nextLine();

        StringBuilder solAll = new StringBuilder();

        for (int i = 0; i < T; i++) {
            int caseNum = i + 1;
            String caseAnswer = "Case #" + caseNum + ": " + solve(sc, caseNum);
            System.out.println(caseAnswer);
            solAll.append(caseAnswer);
            solAll.append("\n");
        }

        String output = solAll.toString();
        System.out.println(output);
        BufferedWriter writer = new BufferedWriter(new FileWriter(file_out));
        writer.write(output);

        sc.close();
        writer.close();
    }

    public static void main(String[] args) throws IOException {
        new Y2016_RQ_C();
    }

}
