import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class Y2015_RQ_A {

    private static final String Q_NUM = "A";
    private static final InputType IN_TYPE = InputType.SMALL;
    private static final boolean DEBUG = false;

    private enum InputType {SAMPLE, SMALL, LARGE}

    private String solve(Scanner sc, int nCase) {
        String[] sp = sc.nextLine().trim().split("\\s+");
        int smax = Integer.parseInt(sp[0]);
        char[] cs = sp[1].toCharArray();
        // assert smax == cs.length
        int inviteMax = 0;
        int sum = 0;
        for (int i = 0; i < cs.length; i++) {
            int n = cs[i] - '0';
            if (n > 0) {
                int inviteForThis = i - sum;
                if (inviteForThis > inviteMax)
                    inviteMax = inviteForThis;
                sum += n;
            }
        }
        return "Case #" + (nCase + 1) + ": "+inviteMax;
    }

    public Y2015_RQ_A() throws IOException {
        String prefix = Q_NUM + '/' + Q_NUM;
        String file_in, file_out;
        if (IN_TYPE == InputType.SMALL) {
            file_in = prefix + "-small.in";
            file_out = prefix + "-small.out";
        } else if (IN_TYPE == InputType.LARGE) {
            file_in = prefix + "-large.in";
            file_out = prefix + "-large.out";
        } else {
            file_in = prefix + "ii";
            file_out = prefix + "oo0";
        }

        Scanner sc = new Scanner(new File(file_in));
        int T = sc.nextInt();
        sc.nextLine();

        StringBuilder solAll = new StringBuilder();

        for (int nCase = 0; nCase < T; nCase++) {
            solAll.append(solve(sc, nCase));
            solAll.append("\n");
        }

        String output = solAll.toString();
        System.out.println(output);
        BufferedWriter writer = new BufferedWriter(new FileWriter(file_out));
        writer.write(output);

        sc.close();
        writer.close();
    }

    public static void main(String[] args) throws IOException {
        new Y2015_RQ_A();
    }

}
