import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;


public class Y2016_RQ_A {

    private static final String Q_NUM = "A";
    private static final int INPUT_TYPE = 2;

    private String solve(Scanner sc, int nCase) {
        String answer = null;
        int n = sc.nextInt();
        if (n == 0) {
            answer = "INSOMNIA";
        } else {
            Set<String> saw = new HashSet<>();
            String xs = null;
            for (long i = 1; saw.size() < 10; i++) {
                long x = i * n;
                xs = String.valueOf(x);
                for (String s : xs.split("")) {
                    if (s == null || s.isEmpty()) {
                        continue;
                    }
                    saw.add(s);
                }
            }
            answer = xs;
        }
        return "Case #" + (nCase + 1) + ": " + answer;
    }

    public Y2016_RQ_A() throws IOException {
        String prefix = Q_NUM + '/' + Q_NUM;
        String file_in, file_out;
        if (INPUT_TYPE == 2) {
            file_in = prefix + "-small.in";
            file_out = prefix + "-small.out";
        } else if (INPUT_TYPE == 3) {
            file_in = prefix + "-large.in";
            file_out = prefix + "-large.out";
        } else {
            file_in = prefix + "ii";
            file_out = prefix + "oo0";
        }

        Scanner sc = new Scanner(new File(file_in));
        int T = sc.nextInt();
        sc.nextLine();

        StringBuilder solAll = new StringBuilder();

        for (int nCase = 0; nCase < T; nCase++) {
            solAll.append(solve(sc, nCase));
            solAll.append("\n");
        }

        String output = solAll.toString();
        System.out.println(output);
        BufferedWriter writer = new BufferedWriter(new FileWriter(file_out));
        writer.write(output);

        sc.close();
        writer.close();
    }

    public static void main(String[] args) throws IOException {
        new Y2016_RQ_A();
    }

}
