import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;


public class Y2015_RQ_D {

    private static final String Q_NUM = "D";
    private static final InputType IN_TYPE = InputType.LARGE;
    private static final boolean DEBUG = false;
    private static final String RICHARD = "RICHARD";
    private static final String GABRIEL = "GABRIEL";
    private static final Set<String> GABRIEL_WIN  = new HashSet<String>() {{
        addAll(Arrays.asList(
                "2 1 2", "2 1 4", "2 2 2", "2 2 3", "2 2 4", "2 3 4", "2 4 4",
                "3 2 3", "3 3 3", "3 3 4", "4 3 4", "4 4 4"
        ));
    }};

    private enum InputType {SAMPLE, SMALL, LARGE}

    private String solve(Scanner sc, int nCase) {
        int X = sc.nextInt();
        int R = sc.nextInt();
        int C = sc.nextInt();
        if (R > C) { // make R < C
            int tmp = R;
            R = C;
            C = tmp;
        }
        String line = X+" "+R+" "+C;
        String winner = RICHARD;
        if (X <= 4) {
            if (X == 1 || GABRIEL_WIN.contains(line))
                winner = GABRIEL;
        } else if (X == 5 || X == 6) {
            int halfX = 3;
            if (C >= X && R >= halfX && (R * C) % X == 0)
                winner = GABRIEL;
        } // X >= 7 always RICHARD win
        return "Case #" + (nCase + 1) + ": "+winner;
    }

    public Y2015_RQ_D() throws IOException {
        String prefix = Q_NUM + '/' + Q_NUM;
        String file_in, file_out;
        if (IN_TYPE == InputType.SMALL) {
            file_in = prefix + "-small.in";
            file_out = prefix + "-small.out";
        } else if (IN_TYPE == InputType.LARGE) {
            file_in = prefix + "-large.in";
            file_out = prefix + "-large.out";
        } else {
            file_in = prefix + "ii";
            file_out = prefix + "oo0";
        }

        Scanner sc = new Scanner(new File(file_in));
        int T = sc.nextInt();
        sc.nextLine();

        StringBuilder solAll = new StringBuilder();

        for (int nCase = 0; nCase < T; nCase++) {
            solAll.append(solve(sc, nCase));
            solAll.append("\n");
        }

        String output = solAll.toString();
        System.out.println(output);
        BufferedWriter writer = new BufferedWriter(new FileWriter(file_out));
        writer.write(output);

        sc.close();
        writer.close();
    }

    public static void main(String[] args) throws IOException {
        new Y2015_RQ_D();
    }

}
