package com.eevoskos.codejam;

import java.io.BufferedReader;
import java.io.InputStreamReader;

public class FairAndSquare {

	int a, b;

	FairAndSquare(int a, int b) {
		this.a = a;
		this.b = b;
	}

	private int count() {
		int count = 0;
		for (int i = a; i <= b; i++) {
			if (isFairAndSquare(i)) {
				count++;
			}
		}
		return count;
	}

	boolean isFair(int num) {
		String normal = String.valueOf(num);
		String reverse = new StringBuffer(normal).reverse().toString();
		return normal.matches(reverse);
	}

	boolean isSquare(int num) {
		double sqrt = Math.sqrt(num);
		int intPart = (int) sqrt;

		if ((double) intPart != sqrt) {
			return false;
		}

		return isFair((int) sqrt);
	}

	boolean isFairAndSquare(int num) {
		if (!isFair(num)) {
			return false;
		}
		return isSquare(num);
	}

	public static void main(String... args) {
		try {
			// Console reader
			BufferedReader c = new BufferedReader(new InputStreamReader(
					System.in));

			// Number of test cases
			int T = Integer.valueOf(c.readLine());

			// Do, for each test case
			for (int i = 0; i < T; i++) {
				// Read input values
				String line = c.readLine();
				String[] values = line.split(" ");
				int a = Integer.valueOf(values[0]);
				int b = Integer.valueOf(values[1]);

				// Create case
				FairAndSquare fas = new FairAndSquare(a, b);

				// Print result
				System.out.println("Case #" + (i + 1) + ": " + fas.count());
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}