package com.eevoskos.codejam;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;

public class SpeakingInTongues {

	static Map<String, String> dictionary = new HashMap<String, String>();
	
	static {
		dictionary.put("q", "z");
		dictionary.put("z", "q");
	}

	void train() {
		String[] in = new String[] { 
				"ejp mysljylc kd kxveddknmc re jsicpdrysi",
				"rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd",
				"de kr kd eoya kw aej tysr re ujdr lkgc jv" };

		String[] out = new String[] { 
				"our language is impossible to understand",
				"there are twenty six factorial possibilities",
				"so it is okay if you want to just give up" };

		for (int i = 0; i < in.length; i++) {
			for (int j = 0; j < in[i].length(); j++) {
				String g = in[i].substring(j, j + 1);
				String t = out[i].substring(j, j + 1);
				if (!dictionary.containsKey(g)) {
					dictionary.put(g, t);
				}
			}

		}

		//System.out.println("Training complete!");

		// Test training
		for (int i = 0; i < in.length; i++) {
			String trans = translate(in[i]);
			System.out.println("Train #" + (i+1) + ": " + trans + " ..." + (trans.matches(out[i]) ? "Correct" : "Incorrect"));
		}

	}

	String translate(String googlerese) {
		String translation = "";
		for (int i = 0; i < googlerese.length(); i++) {
			String c = googlerese.substring(i, i + 1);
			String t = dictionary.get(c);
			if (t == null || t.matches("null")) {
				translation += "0";
			} else {
				translation += t;
			}
		}
		return translation;
	}

	public static void main(String... args) {
		SpeakingInTongues s = new SpeakingInTongues();
		s.train();

		//System.out.println("Now the real thing starts!\n");
		
		try {

			BufferedReader c = new BufferedReader(new InputStreamReader(System.in));

			// Number of test cases
			int T = Integer.valueOf(c.readLine());

			// Do, for each test case
			for (int i = 0; i < T; i++) {

				// Googlerese string
				String G = c.readLine();

				// Print the translated text
				System.out.println("Case #" + (i + 1) + ": " + s.translate(G));

			}

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
