package FairAndSquare;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

/**
 * @author Efe Karakus
 * @date: 4/13/13
 * @time: 1:41 PM
 */
public class FileOutput {

    private String path;
    private BufferedWriter writer;


    public FileOutput(String path) throws IOException {
        this.path = path;
        File file = new File(path);

        // if file doesnt exists, then create it
        if (!file.exists()) {
            file.createNewFile();
        }

        FileWriter fw = new FileWriter(file.getAbsoluteFile());
        writer = new BufferedWriter(fw);
    }

    public void write(String content) throws IOException {
        writer.write(content);
    }

    public void close() throws IOException {
        if (writer != null) writer.close();
    }
}
