package FairAndSquare;

import java.io.IOException;

/**
 * @author Efe Karakus
 * @date: 4/13/13
 * @time: 1:42 PM
 */
public class FairAndSquare {

    private int _start;
    private int _end;

    public FairAndSquare(int start, int end) {
        _start = start;
        _end = end;
    }

    public int count() {
        int count = 0;
        for(int i = _start; i <= _end; i++) {
            if (isFairAndSquare(i)) count++;
        }
        return count;
    }


    private boolean isFairAndSquare(int i) {
        String s = (new Integer(i)).toString();
        if (!isPalindrome(s)) return false;

        double sqrt = Math.sqrt(i);
        double wholeSqrt = Math.floor(sqrt);
        if (sqrt != wholeSqrt) return false;

        s = (new Integer((int) wholeSqrt)).toString();
        if (!isPalindrome(s)) return false;

        return true;
    }

    private boolean isPalindrome(String s) {
        int N = s.length();
        for (int i = 0; i < N/2; i++) {
            if (s.charAt(i) != s.charAt(N-i-1)) return false;
        }
        return true;
    }

    public static void main(String[] args) throws IOException {
        String path = "/Users/efekarakus/Code-Jam/src/FairAndSquare/";
        String inputName = "C-small-attempt0.in";
        FileReader reader = new FileReader(path + inputName);
        FileOutput output = new FileOutput(path + "fairandsquare-output.txt");

        int casesCount = Integer.parseInt(reader.readLine());
        for (int i = 0; i < casesCount; i++) {
            String[] intervals = reader.readLine().split(" ");
            int start = Integer.parseInt(intervals[0]);
            int end = Integer.parseInt(intervals[1]);
            FairAndSquare fs = new FairAndSquare(start, end);
            int count = fs.count();

            output.write("Case #" + (i+1) + ": " + count + "\n");
        }

        reader.close();
        output.close();
    }
}
