import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;

public class C {

    int MOD = 100003;

    int[][] c;
    int[][] d;

    void countC(int n) {
        c = new int[n + 1][];
        c[0] = new int[1];
        c[0][0] = 1; 
        for (int i = 1; i <= n; i++) {
            c[i] = new int[i + 1];
            c[i][0] = 1;
            c[i][i] = 1;
            for (int j = 1; j < i; j++) {
                c[i][j] = (c[i - 1][j - 1] + c[i - 1][j]) % MOD;
            }
        }
    }

    int getC(int n, int k) {
        if (n < 0) return 0;
        if (n < k) return 0;
        if (k < 0) return 0;
        return c[n][k];
    }

    void countD(int n) {
        d = new int[n + 1][n];
        for (int in = 2; in <= n; in++) {
            d[in][1] = 1;
            for (int ip = 1; ip < in; ip++) {
                for (int i = 1; i < ip; i++) {
                    long curLong = (long) getC(in - ip - 1, ip - i - 1) * d[ip][i]; 
                    int cur = (int) (curLong % MOD);
                    d[in][ip] = (d[in][ip] + cur) % MOD;
                }
            }
        }
    }

    public void run() throws IOException {
        Scanner in = new Scanner(new FileReader("C.in"));
        PrintWriter out = new PrintWriter(new FileWriter("C.out"));
        int NT = in.nextInt();
        countC(500);
        countD(500);
        for (int TN = 1; TN <= NT; TN++) {
            int n = in.nextInt();
            int res = 0;
            for (int p = 1; p < n; p++) {
                res = (res + d[n][p]) % MOD;
            }
            out.println("Case #" + TN + ": " + res);
        }
        out.close();
    }

    public static void main(String[] args) throws IOException {
        new C().run();
    }

}