import java.io.*;
import java.util.*;

public class A {

    private static class Node {
        String name;
        boolean isExist = false;
        HashMap<String, Node> subdirs;

        private Node(String name, boolean exist) {
            this.name = name;
            isExist = exist;
            subdirs = new HashMap<String, Node>();
        }

        Node createEmptyNode(String name, boolean isExist) {
            return new Node(name, isExist);
        }

        void addNode(List<String> path, boolean isExist) {
            if (path.isEmpty()) return;
            Node next = subdirs.get(path.get(0)); 
            if (next == null) {
                next = createEmptyNode(path.get(0), isExist);
                subdirs.put(path.get(0), next);
            }
            next.addNode(path.subList(1, path.size()), isExist);
        }

        int getNotExist() {
            int res = 0;
            if (!this.isExist) res = 1;
            for (Node ch : subdirs.values()) {
                res += ch.getNotExist();
            }
            return res;
        }

    }

    List<String> getParts(String s) {
        ArrayList<String> res = new ArrayList<String>();
        StringTokenizer st = new StringTokenizer(s, "/");
        while (st.hasMoreElements()) {
            String token = st.nextToken();
            res.add(token);
        }
        return res;
    }

    public void run() throws IOException {
        Scanner in = new Scanner(new FileReader("A-large.in"));
        PrintWriter out = new PrintWriter(new FileWriter("A.out"));
        int NT = in.nextInt();
        for (int TN = 1; TN <= NT; TN++) {
            int n = in.nextInt();
            int m = in.nextInt();

            Node node = new Node("", true);
            in.nextLine();
            for (int i = 0; i < n; i++) {
                String s = in.nextLine();
//                System.out.println("s = " + s);
                List<String> list = getParts(s);
//                System.out.println("parts = " + list.toString());
//                node.addNode(list.subList(1, list.size()), true);
                node.addNode(list, true);
            }
            for (int i = 0; i < m; i++) {
                String s = in.next();
                List<String> list = getParts(s);
//                System.out.println("add " + list);
//                System.out.println("add " + (list.subList(1, list.size()).toString()));
                node.addNode(list, false);
            }

            int res = node.getNotExist();
            out.println("Case #" + TN + ": " + res);
        }
        out.close();

    }

    public static void main(String[] args) throws IOException {
        new A().run();
    }

}
