import java.io.*;
import java.util.*;
import java.math.*;

public class Main implements Runnable {
	class Point {
		int x, t;
		public Point(int xx, int tt) {
			x = xx; t = tt;
		}
	}
	void solve() throws IOException {
		int tests = nextInt();
		for (int test=1; test<=tests; test++) {
			int n = nextInt();
			int res = 0;
			LinkedList<Point> a = new LinkedList<Point>();
			LinkedList<Point> b = new LinkedList<Point>();
			for (int i=0; i<n; i++) {
				boolean f = next().charAt(0)=='O';
				int k = nextInt();
				if (f) a.add(new Point(k, i)); else b.add(new Point(k, i));
			}
			int x = 1, y = 1;
			while (a.size()>0 && b.size()>0) {
				Point p1 = a.getFirst();
				Point p2 = b.getFirst();
				if (p1.t<p2.t) {
					int go = Math.abs(x-p1.x)+1;
					res += go;
					x = p1.x;
					a.removeFirst();
					int need = p2.x-y;
					if (need>0) {
						y = Math.min(y+go, p2.x);
					} else {
						y = Math.max(y-go, p2.x);
					}
				} else {
					int go = Math.abs(y-p2.x)+1;
					res += go;
					y = p2.x;
					b.removeFirst();
					int need = p1.x-x;
					if (need>0) {
						x = Math.min(x+go, p1.x);
					} else {
						x = Math.max(x-go, p1.x);
					}
				}
			}
			while (!a.isEmpty()) {
				Point p = a.removeFirst();
				res += Math.abs(x-p.x)+1;
				x = p.x;
			}
			while (!b.isEmpty()) {
				Point p = b.removeFirst();
				res += Math.abs(y-p.x)+1;
				y = p.x;
			}
			out.println("Case #"+test+": "+res);
		}
		
		
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			//br = new BufferedReader(new InputStreamReader(System.in));
			//out = new PrintWriter(System.out);
			br = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			solve();
			br.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(0);
		}
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null)
				return null;
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	public static void main(String[] args) {
		new Thread(new Main()).start();
	}
}
