import java.io.*;
import java.util.*;
import java.math.*;

public class Main implements Runnable {
	boolean[][] a, b;
	long[] msk;
	int maxC = -1, Len = -1;
	int n;
	void dfs(int len, int v, long m) {
		if (len>Len) return;
		if (v==1) {
			if (Long.bitCount(m)>maxC) {
				maxC = Long.bitCount(m);
			}
			return;
		}
		m |= msk[v];		
		for (int i=0; i<n; i++)
			if (b[v][i]) {				
				dfs(len+1, i, m);
			}
	}
	void solve() throws IOException {
		int tests = nextInt();
		for (int test=1; test<=tests; test++) {
			out.print("Case #"+test+": ");
			n = nextInt();
			int m = nextInt();
			a = new boolean[n][n];
			b = new boolean[n][n];
			msk = new long[n];
			while (m-->0) {
				int x = nextInt();
				int y = nextInt();
				a[x][y] = a[y][x] =  true;
				msk[x] |= (1l << y);
				msk[x] |= (1l << x);
				msk[y] |= (1l << y);
				msk[y] |= (1l << x);
			}
			int[] d = new int[n];
			Arrays.fill(d, -1);
			Queue<Integer> Q = new LinkedList<Integer>();
			d[0] = 0; Q.add(0);
			while (!Q.isEmpty()) {
				int v = Q.poll();
				for (int i=0; i<n; i++)
					if (a[v][i] && d[i]==-1) {
						d[i] = d[v]+1;
						Q.add(i);
					}				
			}
			for (int i=0; i<n; i++)
				for (int j=0; j<n; j++)
					b[i][j] = a[i][j] && d[j]==d[i]+1;
			
			Len = d[1];
			dfs(0, 0, 0);
			out.println((d[1]-1)+" "+(maxC-d[1]));		
			
		}
	
		
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			//br = new BufferedReader(new InputStreamReader(System.in));
			//out = new PrintWriter(System.out);
			br = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			solve();
			br.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(0);
		}
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null)
				return null;
			st = new StringTokenizer(s,", \t");
		}
		return st.nextToken();
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	public static void main(String[] args) {
		new Thread(new Main()).start();
	}
}
