import java.io.*;
import java.util.*;
import java.math.*;

public class Main implements Runnable {
	double eps = 1e-8;
	class Rec implements Comparable<Rec>{
		int l, w;
		public Rec(int l, int w) {
			this.l = l;
			this.w = w;
		}
		public int compareTo(Rec o) {			
			return (w-o.w);
		}
	}
	void solve() throws IOException {
		int tests = nextInt();
		for (int test=1; test<=tests; test++) {
			out.print("Case #"+test+": ");
			double res = 0;
			int X = nextInt();
			int v0 = nextInt();
			int v1 = nextInt();
			double T = nextInt();
			int n = nextInt();
			Vector<Rec> a = new Vector<Rec>();
			int pr = 0;
			for (int i=0; i<n; i++) {
				int x1 = nextInt();
				int x2 = nextInt();
				int v = nextInt();
				if (pr<x1) a.add(new Rec(x1-pr, 0));
				a.add(new Rec(x2-x1, v));
				pr = x2;
			}
			if (pr<X) a.add(new Rec(X-pr, 0));
			Collections.sort(a);
			for (Rec r:a) {
				double w1 = r.w+v1;
				double w2 = r.w+v0;
				double t1 = r.l/w1;			
				if (T<0) T = 0;
				if (t1<=T+eps) {
					res += t1;
					T -= t1;					
				} else {
					double l = T*w1;
					res += T;
					res += (r.l-l)/w2;
					T = 0;					
				}
			}
			out.printf(Locale.US,"%1.9f\n", res);
			
		}
	
		
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			//br = new BufferedReader(new InputStreamReader(System.in));
			//out = new PrintWriter(System.out);
			br = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			solve();
			br.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(0);
		}
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null)
				return null;
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	public static void main(String[] args) {
		new Thread(new Main()).start();
	}
}
