import java.io.*;
import java.util.*;
import java.math.*;

public class Main implements Runnable {
	
	void solve() throws IOException {
		int tests = nextInt();
		for (int test=1; test<=tests; test++) {
			out.println("Case #"+test+":");
			int n = nextInt();
			int m = nextInt();
			char[][] res = new char[n][m];
			boolean[][] a = new boolean[n+2][m+2];
			for (int i=0; i<n; i++) {
				char[] s = next().toCharArray();
				for (int j=0; j<m; j++)
					a[i][j] = s[j]=='#';
			}
			for (char[] rr: res) 
				Arrays.fill(rr, '.');
			
			boolean ok = true;
			for (int i=0; i<n; i++)
				for (int j=0; j<m; j++)
					if (a[i][j]) {
						ok &= a[i][j]&a[i+1][j]&a[i+1][j]&a[i+1][j+1];
						a[i][j] = a[i+1][j] = a[i][j+1] = a[i+1][j+1] = false;
						if (!ok) break;
						res[i][j] = res[i+1][j+1] = '/';
						res[i+1][j] = res[i][j+1] = '\\';
					}
			if (ok) {
				for (int i=0; i<n; i++) {
					for (int j=0; j<m; j++) 
						out.print(res[i][j]);
					out.println();
				}
			} else out.println("Impossible");
			
		}
	
		
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			//br = new BufferedReader(new InputStreamReader(System.in));
			//out = new PrintWriter(System.out);
			br = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			solve();
			br.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(0);
		}
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null)
				return null;
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	public static void main(String[] args) {
		new Thread(new Main()).start();
	}
}
