import java.io.*;
import java.util.*;
import java.math.*;

public class Main implements Runnable {

	class Point {
		int x, r, id;
		public Point(int xx, int rr, int i) {
			x = xx; r = rr; id = i;
		}
	}
    void solve() throws IOException {
    	int tests = nextInt();
    	for (int test=1; test<=tests; test++) {
    		int n = nextInt();
    		int[] L = new int[n+2];
    		int[] d = new int[n+2];
    		for (int i=0; i<n; i++) {
    			d[i] = nextInt();
    			L[i] = nextInt();
    		}
    		d[n] = nextInt();
    		Queue<Point> q = new LinkedList<Point>();
    		q.add(new Point(d[0], Math.min(d[0], L[0]), 0));
    		boolean ok = false;
    		while (!q.isEmpty() && !ok) {
    			Point cur = q.poll();
    			for (int j=cur.id+1; j<=n; j++) {
    				if (d[j]-d[cur.id]>cur.r) break;
    				if (j==n) {
    					ok = true; break;
    				}
    				q.add(new Point(d[j], Math.min(L[j], d[j]-d[cur.id]), j));
    			}
    		}
    		out.print("Case #"+test+": ");
    		if (ok) out.println("YES"); else out.println("NO");
    	}
    }
   
    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    public void run() {
        try {            
            br = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
            solve();
            br.close();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(123);
        }
    }

    String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            String s = br.readLine();
            if (s == null)
                return null;
            st = new StringTokenizer(s);
        }
        return st.nextToken();
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
