import java.io.*;
import java.util.*;
import java.math.*;

public class Main implements Runnable {
	void solve() throws IOException {
		int tests = nextInt();
		int N = 1000;
		double[] p = new double[N+1];
		for (int n=2; n<=N; n++) {
			double cur = n;
			double res = n;
			for (int k=1; k<n; k++) {
				cur /= k;
				res += p[n-k]*cur/(n-k);
			}
			p[n] = res;
		}
		for (int test=1; test<=tests; test++) {
			int n = nextInt();
			int[] a = new int[n];
			for (int i=0; i<n; i++) a[i] = nextInt()-1;
			boolean[] f = new boolean[n];
			double res = 0;
			for (int i=0; i<n; i++) {
				int x = i;
				int l = 0;
				while (!f[x]) {
					f[x] = true; 
					l++;
					x = a[x];
				}
				res += p[l];
			}
		
			out.printf(Locale.US, "Case #%d: %1.6f\n", test, res);
		}	
		
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			//br = new BufferedReader(new InputStreamReader(System.in));
			//out = new PrintWriter(System.out);
			br = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			solve();
			br.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(0);
		}
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null)
				return null;
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	public static void main(String[] args) {
		new Thread(new Main()).start();
	}
}
