import java.io.*;
import java.util.*;
import java.math.*;

public class Main implements Runnable {

	class Point {
		int r, id;
		public Point(int rr, int i) {
			r = rr; id = i;
		}
	}
    void solve() throws IOException {
    	int tests = nextInt();
    	for (int test=1; test<=tests; test++) {
    		int n = nextInt();
    		int[] L = new int[n+2];
    		int[] d = new int[n+2];
    		for (int i=0; i<n; i++) {
    			d[i] = nextInt();
    			L[i] = nextInt();
    		}
    		d[n] = nextInt();
    		int[] dm = new int[n+1];
    		dm[0] = d[0];
    		boolean ok = false;
    		for (int i=0; !ok && i<n; i++) {    			
    			for (int j=i+1; j<=n; j++) {
    				if (d[j]-d[i]>dm[i]) break;
    				if (j==n) {
    					ok = true; break;
    				}
    				dm[j] = Math.max(dm[j], Math.min(L[j], d[j]-d[i]));    				
    			}
    		}
    		out.print("Case #"+test+": ");
    		if (ok) out.println("YES"); else out.println("NO");
    		out.flush();
    	}
    }
   
    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    public void run() {
        try {            
            br = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
            solve();
            br.close();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(123);
        }
    }

    String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            String s = br.readLine();
            if (s == null)
                return null;
            st = new StringTokenizer(s);
        }
        return st.nextToken();
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
