import java.io.*;
import java.util.*;
import java.math.*;

public class Main implements Runnable {
	double eps = 1e-9;
	void solve() throws IOException {
		int tests = nextInt();
		for (int test=1; test<=tests; test++) {
			out.print("Case #"+test+": ");
			int n = nextInt();
			int m = nextInt();
			int d = nextInt();
			int[][] a = new int[n][m];
			for (int i=0; i<n; i++) {
				char[] s = br.readLine().toCharArray();
				for (int j=0; j<m; j++)
					a[i][j] = s[j]-'0';
			}
			
			int res = -1;
			for (int sz = Math.min(n, m); sz>2; sz--) {
				for (int i=0; i<=n-sz && res<0; i++) 
					for (int j=0; j<=m-sz; j++) {
						double sx = 0, sy = 0;
						double cx = (i + (i + sz))/2.0;
						double cy = (j + (j + sz))/2.0;
						for (int i1 = i; i1 < i+sz; i1++)
							for (int j1 = j; j1 < j+sz; j1++) 
							if (!(i1==i && j1 ==j || i1==i+sz-1 && j1 ==j || i1==i+sz-1 && j1 ==j+sz-1 ||  i1==i && j1 ==j+sz-1))
							{
								sx += a[i1][j1] * (i1 + 0.5 - cx);
								sy += a[i1][j1] * (j1 + 0.5 - cy);
							}
						if (Math.abs(sx)<eps && Math.abs(sy)<eps) {
							res =  sz; break;
						}						
					}
			}
			
			if (res<0) out.println("IMPOSSIBLE"); else	
			out.println(res);
		
			
		}
	
		
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			//br = new BufferedReader(new InputStreamReader(System.in));
			//out = new PrintWriter(System.out);
			br = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			solve();
			br.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(0);
		}
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null)
				return null;
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	public static void main(String[] args) {
		new Thread(new Main()).start();
	}
}
