import java.io.*;
import java.util.*;
import java.math.*;

public class Main implements Runnable {
	
	void solve() throws IOException {
		int tests = nextInt();
		for (int test=1; test<=tests; test++) {
			out.print("Case #"+test+": ");
			int L = nextInt();
			long T = nextLong();
			int n = nextInt();
			int C = nextInt();
			long[] a = new long[n];
			long[] cc = new long[C];
			for (int i=0; i<C; i++) 
				cc[i] = nextInt()*2;
			for (int i=0; i<n; i++)
				a[i] = cc[i%C];
			long[] sum = new long[n+1];
			for (int i=0; i<n; i++)
				sum[i+1] = sum[i]+a[i];
			long res = sum[n];
			PriorityQueue<Long> Q = new PriorityQueue<Long>();
				
			long all = 0, good = 0;
			if (L>0) {
				for (int i=n-1; i>=0; i--) {
					long t = Math.max(0, T-sum[i]);
					long time = sum[i];
					t = Math.min(t, a[i]);
					time += t;
					time += (a[i]-t)/2;
					time += (all-good)+good/2;
					Q.add(a[i]);
					good += a[i];
					all += a[i];
					if (!Q.isEmpty() && Q.size()>=L) {
						long dd = Q.poll();
						good -= dd;
					}
					if (sum[i]+a[i]>=T)
						res = Math.min(res, time);
				}
			}
			out.println(res);
			
		}
	
		
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	public void run() {
		try {
			//br = new BufferedReader(new InputStreamReader(System.in));
			//out = new PrintWriter(System.out);
			br = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			solve();
			br.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(0);
		}
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null)
				return null;
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	public static void main(String[] args) {
		new Thread(new Main()).start();
	}
}
