package gcj2014.round1b;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;

public class A_TheRepeater {
	public static void main(String args[]) throws FileNotFoundException {
		Scanner sc= new Scanner(new File(args[0]));
		
		int T = sc.nextInt();
		for(int t=1; t<=T; t++) {
			System.out.println("Case #" + t + ": " + solve(sc));
		}
	}

	static String str[];
	static int index[];
	
	private static String solve(Scanner sc) {
		int N = sc.nextInt();
		str = new String[N];
		index = new int[N];
		for(int i=0; i<N; i++) {
			str[i] = sc.next();
			index[i] = 0;
		}
		
		int n = solve();
		
		if(n == -1) {
			return "Fegla Won";
		}
		return String.valueOf(n);
	}
	
	/**
	 * @return Minimum number of moves for all strings to be identical, -1 if impossible
	 */
	static int solve() {
		if(str.length == 0) return 0; // sait-on jamais...
		
		int moves = 0;
		
		while(!stringFinished(0)) {
			int num[] = new int[str.length];
			
			char c = getChar(0); 
			for(int i=0; i<str.length; i++) {
				num[i] = getNumOf(i, c);
				// All strings must have the same letter
				if(num[i] == 0) return -1;
			}
			
			moves += numOfMoves(num);
		}
		
		// All strings finished
		for(int i=1; i<str.length; i++) {
			if(!stringFinished(i)) return -1;
		}
		
		return moves;
	}

	
	/**
	 * 
	 * @param num
	 *        Number of repetition of the current letter in each string
	 * @return The minimum number of moves to make the current letter repeated the same number of time in all strings
	 */
	private static int numOfMoves(int[] num) {
		Arrays.sort(num);
		int moves = 0;
		
		while(!identical(num)) {
			int min = 1;
			while(num[min] == num[0]) {
				min++;
			}
			
			int max = 1;
			while(num[num.length-1-max] == num[num.length-1]) {
				max++;
			}
			
			// change string
			if(min <= max) {
				// Repeat letters in "smallest" strings
				moves += min*(num[min]-num[0]);
				for(int i=0; i<min; i++) {
					num[i] = num[min];
				}
			}
			else { // min > max
				// Delete strings in the "largest" strings
				moves += max*(num[num.length-1]-num[max]);
				for(int i=max+1; i<num.length; i++) {
					num[i] = num[max];
				}
			}
		}
		
		return moves;
	}

	private static boolean identical(int[] num) {
		for(int n : num) {
			if(n != num[0]) return false;
		}
		return true;
	}

	static int getNumOf(int i, char c) {
		int n = 0;
		while(!stringFinished(i) && getChar(i) == c) {
			index[i]++;
			n++;
		}
		return n;
	}
	
	static char getChar(int i) {
		return str[i].charAt(index[i]);
	}
	
	static boolean stringFinished(int i) {
		return index[i] >= str[i].length();
	}
}
