package gcj2014.round1c;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

public class B_TrainCars {
	public static void main(String args[]) throws FileNotFoundException {
		Scanner sc= new Scanner(new File(args[0]));
		
		int T = sc.nextInt();
		for(int t=1; t<=T; t++) {
			System.out.println("Case #" + t + ": " + new B_TrainCars().solve(sc));
		}
	}
	
	int solve(Scanner sc) {
		int N = sc.nextInt();
		
		String cars[] = new String[N];
		for(int i=0; i<N; i++) {
			cars[i] = removeDuplicateChars(sc.next());
		}
		
		return (int)(combine("", cars) % 1000000007);
	}
	
	
	private String removeDuplicateChars(String s) {
		StringBuilder b = new StringBuilder(s.length());
		for(int i=0; i<s.length();) {
			char c = s.charAt(i);
			do i++;	while(i<s.length() && s.charAt(i) == c);
			b.append(c);
		}
		return b.toString();
	}

	long combine(String head, String cars[]) {
		boolean finished = true;
		
		long result = 0;
		for(int i=0; i<cars.length; i++) {
			if(cars[i] != null) {
				finished = false;
				result += solve(head + cars[i], dup(cars, i));
			}
		}
		return finished ? 1 : result;
	}

	private String[] dup(String[] s, int i) {
		String clone[] = s.clone();
		clone[i] = null;
		return clone;
	}

	long solve(String head, String cars[]) {
		// Check feasibility
		for(int i=0; i<head.length();) {
			char c = head.charAt(i);
			do i++; while(i<head.length() && head.charAt(i) == c);
			
			if(i<head.length()) {
				// Check letter is not present in the rest of the string and cars
				for(int j=i+1; j<head.length(); j++) {
					if(head.charAt(j) == c) return 0;
				}
				for(String car : cars) {
					if(car != null) {
						if(car.indexOf(c) >= 0) return 0;
					}
				}
			}
		}
		
		// Find cars with only the 'c' letter. They must be inserted now in any order (2^(cCars-1) combinations)
		int cCars = 0;
		char c = head.charAt(head.length() - 1);
		for(int i=0; i<cars.length; i++) {
			if(cars[i] != null && containsOnly(cars[i], c)) {
				cCars++;
				// unnecessary: head += cars[i];
				cars[i] = null;
			}
		}
		
		if(cCars > 0) cCars--;
		return (1 << cCars) * combine(head, cars);
	}

	private boolean containsOnly(String s, char c) {
		for(int i=0; i<s.length(); i++) {
			if(s.charAt(i) != c) return false;
		}
		return true;
	}
}
