package gcj;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class D2 {
	public static void main(String args[]) throws FileNotFoundException {
		String filename = "D-small-attempt4";
		new D2().run(
				new Scanner(new File(filename + ".in")),
				new PrintStream(new File(filename + ".out"))
				);
	}

	void run(Scanner scanner, PrintStream out) {
		int T = scanner.nextInt();
		for(int i=0; i<T; i++) {
			int N = scanner.nextInt();
			int M = scanner.nextInt();
			char stage[][] = new char[N][N];
			for(int m=0; m<M; m++) {
				String c = scanner.next();
				int row = scanner.nextInt();
				int col = scanner.nextInt();
				stage[row-1][col-1] = c.charAt(0);
			}
			String result = solve(stage);
			out.println("Case #" + (i+1) + ": " + result);
		}
		scanner.close();
	}

	private String solve(char[][] stage) {
		Solution solution = smallSolve(stage);
		List<String> delta = calculateDelta(stage, solution.stage);
		
		
		/*
		Solution sol2 = new D().bruteSolve(stage, 0, 0, solution);
		if(sol2 != solution) {
			System.err.println("BEST FOUND");
		}
		*/
		
		return solution.points + " " + delta.size() + (delta.size()>0 ? ("\n" + String.join("\n", delta)) : "")
				/*
				+ "\n" + toString(stage) + " => " 
				+ "\n" + toString(solution.stage)
				+ (isValid(solution.stage) ? "" : "INVALID\n")
				+ "========"
				*/
				;
	}

	private List<String> calculateDelta(char[][] stage, char[][] stage2) {
		List<String> delta = new ArrayList<String>();
		
		for(int r=0; r<stage.length; r++) {
			for(int c=0; c<stage.length; c++) {
				if(stage[r][c] != stage2[r][c]) {
					delta.add(stage2[r][c] + " " + (r+1) + " " + (c+1));
				}
			}
		}
		
		return delta;
	}
	
	private int calculatePoints(char[][] stage) {
		int points  = 0;
		for(int r=0; r<stage.length; r++) {
			for(int c=0; c<stage.length; c++) {
				if(stage[r][c] != 0) {
					points++;
				}
				if(stage[r][c] == 'o') {
					points++;
				}
			}
		}
		return points;
	}
	
	private String toString(char stage[][]) {
		String result = "";
		for(int r=0; r<stage.length; r++) {
			for(int c=0; c<stage.length; c++) {
				result += stage[r][c] == 0 ? '.' : stage[r][c];
			}
			result += '\n';
		}
		return result;
	}
	
	private Solution smallSolve(char[][] stage) {
		stage = new Solution(0, stage).stage;
		
		int c0 = -1;
		for(int c=0; c<stage.length; c++) {
			if(stage[0][c] == 'x' || stage[0][c] == 'o') {
				stage[0][c] = 'o';
				c0 = c;
			}
			else {
				stage[0][c] = '+';
			}
		}
		
		if(c0 == -1) {
			stage[0][0] = 'o';
			c0 = 0;
		}
		
		int r;
		for(r=1; r<stage.length && c0+r < stage.length; r++) {
			stage[r][c0+r] = 'x';
		}
		for(; r<stage.length; r++) {
			stage[r][stage.length-r-1] = 'x';
		}

		
		for(int c=1; c<stage.length-1; c++) {
			if(stage[stage.length-1][c] != 'x') {
				stage[stage.length-1][c] = '+';
			}
		}
		
		return new Solution(calculatePoints(stage), stage);
	}
	
	private boolean isValid(char[][] stage) {
		// Check rows
		for(int r=0; r<stage.length; r++) {
			int count = 0;
			for(int c=0; c<stage.length; c++) {
				if(stage[r][c] != 0 && stage[r][c] != '+') {
					if(count++ > 0) {
						return false;
					}
				}
			}
		}
		
		// Check columns
		for(int r=0; r<stage.length; r++) {
			int count = 0;
			for(int c=0; c<stage.length; c++) {
				if(stage[r][c] != 0 && stage[r][c] != '+') {
					if(count++ > 0) {
						return false;
					}
				}
			}
		}
		
		// Check / diagonal
		for(int s=1; s<stage.length*2-2; s++) {
			int count = 0;
			for(int r=0; r<stage.length; r++) {
				if(s-r >= 0 && s-r < stage.length) {
					if(stage[r][s-r] != 0 && stage[r][s-r] != 'x') {
						if(count++ > 0) {
							return false;
						}
					}
				}
			}
		}
		
		// Check \ diagonal
		for(int s=-stage.length+1; s<stage.length; s++) {
			int count = 0;
			for(int r=0; r<stage.length; r++) {
				if(s+r >= 0 && s+r < stage.length) {
					if(stage[r][s+r] != 0 && stage[r][s+r] != 'x') {
						if(count++ > 0) {
							return false;
						}
					}
				}
			}
		}
		
		return true;
	}
}
