package gcj;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class BaseClass {
	
	public static void main(String args[]) throws FileNotFoundException {
		new BaseClass().run(new Scanner(new File("A-large.in")));
	}

	private void run(Scanner scanner) {
		int T = scanner.nextInt();
		for(int i=0; i<T; i++) {
			String S = scanner.next();
			int K = scanner.nextInt();
			int result = solve(S, K);
			String strResult = result == -1 ? "IMPOSSIBLE" : String.valueOf(result);
			System.out.println("Case #" + (i+1) + ": " + strResult);
		}
		scanner.close();
	}

	private int solve(String S, int K) {
		boolean[] pancakes = new boolean[S.length()];
		for(int i=0; i<S.length(); i++) {
			pancakes[i] = S.charAt(i) == '+';
		}
		
		int flipsCounter = 0;
		for(int i=0; i<=S.length()-K; i++) {
			if(!pancakes[i]) {
				// Apply flipper on pancakes [i, i+K[ to flip pancakes[i]
				flipsCounter++;
				for(int k=0; k<K; k++) {
					pancakes[i+k] = !pancakes[i+k];
				}
			}
		}
		
		if(done(pancakes)) {
			return flipsCounter;
		}
		// Impossible
		return -1;
	}

	private boolean done(boolean[] pancakes) {
		for(int i=0; i<pancakes.length; i++) {
			if(!pancakes[i]) return false;
		}
		return true;
	}
}
