package gcj2015.qualification;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class D_OminousOmino {
	public static void main(String args[]) throws FileNotFoundException {
		Scanner scanner = new Scanner(new File(args[0]));
		
		int T = scanner.nextInt();
		for(int t=1; t<=T; t++) {
			int X = scanner.nextInt();
			int R = scanner.nextInt();
			int C = scanner.nextInt();
			
			System.out.println("Case #" + t + ": " + solve(X, R, C));
		}
		
		scanner.close();
	}
	
	private static String solve(int X, int R, int C) {
		boolean result = solve2(X, R, C);
		return result?"RICHARD":"GABRIEL";
	}

	private static boolean solve2(int X, int R, int C) {
		if(X > 6) {
			// Can create an omino with a hole
			return true;
		}
		
		if(X > R && X > C) {
			// 1*X omino does not fit
			return true;
		}
		if(X+1 > R+C) {
			// L-shaped omino R*C does not fit
			return true;
		}
		
		if(X%2 == 0) {
			// X pair => can create L-shaped X/2*X/2+1 omino
			if(X/2 > R || X/2 > C) {
				return true;
			}
		}
		else {
			// X impair => can create L-shaped (X+1)/2*(X+1)/2 omino
			if((X+1)/2 > R || (X+1)/2 > C) {
				return true;
			}
		}
		
		if((R*C) % X != 0) {
			return true;
		}
		
		if((R==4 && C==3) || (R==3 && C==4)) {
			if(X==6) {
				//  *
				// ****
				//  *
				return true;
			}
		}
		if(R==2 && C==4 || R==4 && C==2) {
			if(X==4) {
				// **
				//  **
				return true;
			}
		}
		
		return false;
	}
}
