package gcj2015.qualification;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class B_Pancakes {
	public static void main(String args[]) throws FileNotFoundException {
		Scanner scanner = new Scanner(new File(args[0]));
		
		int T = scanner.nextInt();
		for(int t=1; t<=T; t++) {
			int D = scanner.nextInt();
			List<Integer> P = new ArrayList<Integer>();
			for(int k=0; k<D; k++) {
				P.add(scanner.nextInt());
			}
			
			System.out.println("Case #" + t + ": " + solve(P, -1));
		}
		
		scanner.close();
	}
	
	public static int solve(List<Integer> P, int remain) {
		int imax = max(P);
		int max = P.get(imax);
		if(max < 4) {
			// Best strategy: do nothing
			return max;
		}
		
		if(max == 9) {
			// Special case
			P.set(imax, 3);
			int max3 = max(P);
			if(max3 <= 3) {
				// Can solve in 5 minutes:
				// 9 -> 6 3 -> 3 3 3 -> 2 2 2 -> 1 1 1 -> 0 0 0			
				return 5;
			}
		}
		
		// Interrupt and move
		P.set(imax, max/2);
		P.add(max - max/2);
		
		// Is it too late to do any better?
		if(remain < 0) {
			remain = max;
		}
		if(remain <= 0) {
			return 0;
		}
		remain = Math.min(remain,  max);
		
		int minutes = 1+solve(P, remain-1);
		
		if(minutes > max) {
			// Actually better to do nothing
			return max;
		}
		
		return minutes;
	}

	private static int max(List<Integer> P) {
		int imax = 0;
		for(int i=1; i<P.size(); i++) {
			if(P.get(i) > P.get(imax)) {
				imax = i;
			}
		}
		return imax;
	}
}
