// http://code.google.com/codejam/contest/2974486/dashboard#s=p3

package gcj2014.qualification;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;

public class D_DeceitfulWar {
	public static void main(String args[]) throws FileNotFoundException {
		Scanner sc= new Scanner(new File(args[0]));
		sc.useLocale(new Locale("us"));
		
		int T = sc.nextInt();
		for(int t=1; t<=T; t++) {
			int N = sc.nextInt();
			
			double naomieBlocks[] = new double[N];
			for(int i=0; i<N; i++) {
				naomieBlocks[i]  = sc.nextDouble();
			}
			Arrays.sort(naomieBlocks);
			
			double kenBlocks[] = new double[N];
			for(int i=0; i<N; i++) {
				kenBlocks[i]  = sc.nextDouble();
			}
			Arrays.sort(kenBlocks);
			
			System.out.println("Case #" + t + ": " + 
					solveDeceiptWar(naomieBlocks, kenBlocks) + " " + solveWar(naomieBlocks, kenBlocks));
		}
	}

	private static int solveDeceiptWar(double[] naomieBlocks, double[] kenBlocks) {
		int score = 0;
		
		int nMin = 0;
		int kMin = 0;
		
		while(nMin < naomieBlocks.length) {
			if(naomieBlocks[nMin] < kenBlocks[kMin]) {
				nMin++;
				// kMax--;
			}
			else {
				// Naomie scores
				score++;
				nMin++;
				kMin++;
			}
		}
	
		return score;
	}

	private static int solveWar(double[] naomieBlocks, double[] kenBlocks) {
		int score = 0;
		int n=naomieBlocks.length-1, k=kenBlocks.length-1;
		while(n>0 && k > 0) {
			if(naomieBlocks[n] > kenBlocks[k]) {
				// Naomie scores
				score++;
				n--;
			}
			else {
				/// Ken scores
				k--;
				n--;
			}
		}
		return score;
	}
}
