package gcj;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

public class C {
	public static void main(String args[]) throws FileNotFoundException {
		String filename = "C-small-1-attempt0";
		new C().run(
				new Scanner(new File(filename + ".in")),
				System.out);
	}

	private void run(Scanner scanner, PrintStream out) {
		int T = scanner.nextInt();
		for(int i=0; i<T; i++) {
			int N = scanner.nextInt();
			int K = scanner.nextInt();
			int[] result = solve(N, K);
			out.println("Case #" + (i+1) + ": " + result[1] + " " + result[0]);
		}
		scanner.close();
	}

	/**
	 * @param N N+2 bathroom
	 * @param K K people
	 */
	private int[] solve(int N, int K) {
		boolean[] stalls = new boolean[N+2];
		stalls[0] = stalls[N+1] = true;
		
		int[] minMax = null;
		for(int k=0; k<K; k++) {
			int S = -1;
			minMax = null;
			// Search the better stall for user
			for(int s=0; s<stalls.length; s++) {
				if(!stalls[s]) {
					// Empty stall
					int[] minMaxs = calculateMinMax(stalls, s);
					if(isBetter(minMax, minMaxs)) {
						S = s;
						minMax = minMaxs;
					}
				}
			}
			
			stalls[S] = true;
		}
		return minMax;
	}

	private boolean isBetter(int[] minMax, int[] minMaxs) {
		return minMax == null ||
				minMaxs[0] > minMax[0] ||
				(minMaxs[0] == minMax[0] && minMaxs[1] > minMax[1]);
	}

	/**
	 * @return An array of 2 integers: min(Ls, Rs) and max(Ls, Rs)
	 */
	private int[] calculateMinMax(boolean[] stalls, int s) {
		int left = 0;
		while(!stalls[s-left-1]) left++;
		
		int right = 0;
		while(!stalls[s+right+1]) right++;
		
		if(left > right) {
			return new int[] {right, left};
		}
		else {
			return new int[] {left, right};
		}
	}
	
	
}
