import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Task implements Runnable {
	private static String id = "digger";
	private static int INF = 1000000000;

	private Scanner in;
	private PrintWriter out;

	private int ans;
	private int r, c, f;
	char[][] t;
	int[][][] a;
	boolean[][][] w;

	private int go(int cr, int ll, int rr) {
		if (ll >= rr)
			return INF;
		if (cr == r - 1)
			return 0;
		if (w[cr][ll][rr])
			return a[cr][ll][rr];
		w[cr][ll][rr] = true;
		for (int i = ll; i < rr; i++) {
			if (t[cr + 1][i] == '.')
				return a[cr][ll][rr] = Math.min(go(cr, ll, i - 1), go(cr, i + 1, rr));
		}
		boolean upd = false;
		int ol = ll;
		int or = rr;
		while (rr < c && t[cr][rr] == '.' && t[cr + 1][rr] != '.') {
			rr++;
			upd = true;
		}
		while (ll > 0 && t[cr][ll - 1] == '.' && t[cr + 1][ll - 1] != '.') {
			ll--;
			upd = true;
		}
		if (upd)
			return a[cr][ol][or] = go(cr, ll, rr);
		int res = INF;
		if (ll > 0 && t[cr][ll - 1] == '.' && t[cr + 1][ll - 1] == '.') {
			for (int k = cr + 1; k < r && k - cr <= f; k++) {
				if (k == r - 1 || t[k + 1][ll - 1] != '.') {
					res = Math.min(res, go(k, ll - 1, ll));
					break;
				}
			}
		}
		if (rr < c && t[cr][rr] == '.' && t[cr + 1][rr] == '.') {
			for (int k = cr + 1; k < r && k - cr <= f; k++) {
				if (k == r - 1 || t[k + 1][rr] != '.') {
					res = Math.min(res, go(k, rr, rr + 1));
					break;
				}
			}
		}
		if (rr - ll == 1)
			return a[cr][ll][rr] = res;
		for (int i = ll; i < rr; i++) {
			for (int k = cr + 1; k < r && k - cr <= f; k++) {
				if (k == r - 1 || t[k + 1][i] != '.') {
					res = Math.min(res, go(k, i, i + 1) + 1);
					break;
				}
			}
		}
		for (int i = ll; i < rr; i++) {
			for (int j = i + 1; j <= rr; j++) {
				if (i == ll && j == rr)
					continue;
				res = Math.min(res, go(cr + 1, i, j) + j - i);
			}
		}
		if (cr < r - 2 && rr - ll > 2) {
			for (int i = ll; i < rr; i++) {
				if (t[cr + 2][i] == '.' && (i > ll + 1 && t[cr + 2][i - 1] != '.' || i < rr - 2 &&
						t[cr + 2][i + 1] != '.')) {
					for (int k = cr + 2; k < r && k - cr <= f + 1; k++) {
						if (k == r - 1 || t[k + 1][i] != '.') {
							res = Math.min(res, go(k, i, i + 1) + 2);
						}
					}
				}
			}
		}
		return a[cr][ll][rr] = res;
	}

	private void init() {
		try {
			in = new Scanner(new File(id + ".in"));
			out = new PrintWriter(id + ".out");
		} catch (FileNotFoundException ignored) {
		}
	}

	private void read() {
		r = in.nextInt();
		c = in.nextInt();
		f = in.nextInt();
		t = new char[r][];
		for (int i = 0; i < r; i++) {
			String tt = in.next();
			t[i] = tt.toCharArray();
		}
	}

	private void solve() {
		a = new int[r][c][c + 1];
		w = new boolean[r][c][c + 1];
		ans = go(0, 0, 1);
	}

	private void write(int test) {
		System.out.println(test + " " + r + " " + c);
		out.print("Case #" + test + ": ");
		if (ans == INF)
			out.println("No");
		else
			out.println("Yes " + ans);
	}

	public void run() {
		init();
		int t = in.nextInt();
		for (int i = 1; i <= t; i++) {
			read();
			solve();
			write(i);
		}
		out.close();
	}

	public static void main(String[] args) {
		new Thread(new Task()).start();
	}
}
