import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.Arrays;

public class Task implements Runnable {
	private static String id = "chart";

	private Scanner in;
	private PrintWriter out;

	private int ans;
	private int n, k;
	private Chart[] c;
	boolean[][] g;
	int[] d;
	boolean[] w;

	private class Chart implements Comparable<Chart> {
		private int[] p;

		public int compareTo(Chart o) {
			return p[0] - o.p[0];
		}
	}

	private boolean go(int v) {
		if (w[v])
			return false;
		w[v] = true;
		for (int i = 0; i < n; i++) {
			if (g[v][i] && d[i] == -1) {
				d[i] = v;
				return true;
			}
		}
		for (int i = 0; i < n; i++) {
			if (g[v][i] && go(d[i])) {
				d[i] = v;
				return true;
			}
		}
		return false;
	}

	private void init() {
		try {
			in = new Scanner(new File(id + ".in"));
			out = new PrintWriter(id + ".out");
		} catch (FileNotFoundException ignored) {
		}
	}

	private void read() {
		n = in.nextInt();
		k = in.nextInt();
		c = new Chart[n];
		for (int i = 0; i < n; i++) {
			c[i] = new Chart();
			c[i].p = new int[k];
			for (int j = 0; j < k; j++)
				c[i].p[j] = in.nextInt();
		}
	}

	private void solve() {
		Arrays.sort(c);
		g = new boolean[n][n];
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				boolean good = true;
				for (int l = 0; l < k; l++) {
					if (c[i].p[l] >= c[j].p[l]) {
						good = false;
						break;
					}
				}
				g[i][j] = good;
			}
		}
		d = new int[n];
		Arrays.fill(d, -1);
		ans = n;
		for (int i = 0; i < n; i++) {
			w = new boolean[n];
			if (go(i))
				ans--;
		}
	}

	private void write(int test) {
		out.println("Case #" + test + ": " + ans);
	}

	public void run() {
		init();
		int t = in.nextInt();
		for (int i = 1; i <= t; i++) {
			read();
			solve();
			write(i);
		}
		out.close();
	}

	public static void main(String[] args) {
		new Thread(new Task()).start();
	}
}
