import java.util.InputMismatchException;
import java.math.BigInteger;
import java.io.*;

/**
 * Generated by Contest helper plug-in
 * Actual solution is at the bottom
 */
public class Main {
	public static void main(String[] args) {
		try {
			System.setIn(new FileInputStream("b.in"));
			System.setOut(new PrintStream(new FileOutputStream("b.out")));
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
		InputReader in = new StreamInputReader(System.in);
		PrintWriter out = new PrintWriter(System.out);
		run(in, out);
	}

	public static void run(InputReader in, PrintWriter out) {
		Solver solver = new TaskB();
		int testCount = in.readInt();
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		Exit.exit(in, out);
	}
}

abstract class InputReader {
	private boolean finished = false;

	public abstract int read();

	public int readInt() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		int sgn = 1;
		if (c == '-') {
			sgn = -1;
			c = read();
		}
		int res = 0;
		do {
			if (c < '0' || c > '9')
				throw new InputMismatchException();
			res *= 10;
			res += c - '0';
			c = read();
		} while (!isSpaceChar(c));
		return res * sgn;
	}

	public String readString() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		StringBuffer res = new StringBuffer();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}

	private boolean isSpaceChar(int c) {
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public char readCharacter() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		return (char) c;
	}

	public void setFinished(boolean finished) {
		this.finished = finished;
	}

	public abstract void close();
}

class StreamInputReader extends InputReader {
	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar, numChars;

	public StreamInputReader(InputStream stream) {
		this.stream = stream;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	@Override
	public void close() {
		try {
			stream.close();
		} catch (IOException ignored) {
		}
	}
}

class Exit {
	private Exit() {
	}

	public static void exit(InputReader in, PrintWriter out) {
		in.setFinished(true);
		in.close();
		out.close();
	}
}

interface Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out);
}

class TaskB implements Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out) {
		char[][] combinations = new char[256][256];
		int transmutationCount = in.readInt();
		for (int i = 0; i < transmutationCount; i++) {
			char base1 = in.readCharacter();
			char base2 = in.readCharacter();
			combinations[base1][base2] = combinations[base2][base1] = in.readCharacter();
		}
		boolean[][] opposite = new boolean[256][256];
		int oppositeCount = in.readInt();
		for (int i = 0; i < oppositeCount; i++) {
			char base1 = in.readCharacter();
			char base2 = in.readCharacter();
			opposite[base1][base2] = opposite[base2][base1] = true;
		}
		int elementCount = in.readInt();
		char[] stack = new char[elementCount];
		int size = 0;
		for (int i = 0; i < elementCount; i++) {
			stack[size++] = in.readCharacter();
			while (size >= 2) {
				if (combinations[stack[size - 1]][stack[size - 2]] != 0) {
					stack[size - 2] = combinations[stack[size - 1]][stack[size - 2]];
					size--;
					continue;
				}
				for (int j = 0; j < size - 1; j++) {
					if (opposite[stack[j]][stack[size - 1]])
						size = 0;
				}
				break;
			}
		}
		out.print("Case #" + testNumber + ": [");
		for (int i = 0; i < size; i++) {
			if (i != 0)
				out.print(", ");
			out.print(stack[i]);
		}
		out.println("]");
	}
}

