import java.util.ArrayList;
import java.util.List;
import java.util.InputMismatchException;
import java.math.BigInteger;
import java.util.Iterator;
import java.io.*;
import java.util.Comparator;
import java.util.*;
import java.util.Arrays;
import java.util.Collection;

/**
 * Generated by Contest helper plug-in
 * Actual solution is at the bottom
 */
public class Main {
	public static void main(String[] args) {
		try {
			System.setIn(new FileInputStream("c.in"));
			System.setOut(new PrintStream(new FileOutputStream("c.out")));
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
		InputReader in = new StreamInputReader(System.in);
		PrintWriter out = new PrintWriter(System.out);
		run(in, out);
	}

	public static void run(InputReader in, PrintWriter out) {
		Solver solver = new TaskC();
		int testCount = in.readInt();
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		Exit.exit(in, out);
	}
}

abstract class InputReader {
	private boolean finished = false;

	public abstract int read();

	public int readInt() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		int sgn = 1;
		if (c == '-') {
			sgn = -1;
			c = read();
		}
		int res = 0;
		do {
			if (c < '0' || c > '9')
				throw new InputMismatchException();
			res *= 10;
			res += c - '0';
			c = read();
		} while (!isSpaceChar(c));
		return res * sgn;
	}

	public String readString() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		StringBuffer res = new StringBuffer();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}

	private boolean isSpaceChar(int c) {
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public char readCharacter() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		return (char) c;
	}

	public void setFinished(boolean finished) {
		this.finished = finished;
	}

	public abstract void close();
}

class StreamInputReader extends InputReader {
	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar, numChars;

	public StreamInputReader(InputStream stream) {
		this.stream = stream;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	public void close() {
		try {
			stream.close();
		} catch (IOException ignored) {
		}
	}
}

class Exit {
	private Exit() {
	}

	public static void exit(InputReader in, PrintWriter out) {
		in.setFinished(true);
		in.close();
		out.close();
	}
}

interface Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out);
}

class IOUtils {

	public static char[] readCharArray(InputReader in, int size) {
		char[] array = new char[size];
		for (int i = 0; i < size; i++)
			array[i] = in.readCharacter();
		return array;
	}

	public static char[][] readTable(InputReader in, int rowCount, int columnCount) {
		char[][] table = new char[rowCount][];
		for (int i = 0; i < rowCount; i++)
			table[i] = readCharArray(in, columnCount);
		return table;
	}

	}

class TaskC implements Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out) {
		int rowCount = in.readInt();
		int columnCount = in.readInt();
		char[][] map = IOUtils.readTable(in, rowCount, columnCount);
		int result;
		@SuppressWarnings({"unchecked"}) final
		Set<Integer>[] incoming = new Set[rowCount * columnCount];
		for (int i = 0; i < rowCount * columnCount; i++)
			incoming[i] = new HashSet<Integer>();
		int[] firstDelta = new int[rowCount * columnCount];
		int[] secondDelta = new int[rowCount * columnCount];
		for (int j = 0; j < rowCount; j++) {
			for (int k = 0; k < columnCount; k++) {
				int index = j * columnCount + k;
				int firstHorizontalDelta = rowCount * columnCount - 1;
				int secondHorizontalDelta = 1;
				int firstVerticalDelta = rowCount * columnCount - columnCount;
				int secondVerticalDelta = columnCount;
				if (k == 0)
					firstHorizontalDelta = columnCount - 1;
				else if (k == columnCount - 1)
					secondHorizontalDelta = rowCount * columnCount - columnCount + 1;
				switch (map[j][k]) {
					case '-':
						firstDelta[index] = firstHorizontalDelta;
						secondDelta[index] = secondHorizontalDelta;
						break;
					case '/':
						firstDelta[index] = secondHorizontalDelta + firstVerticalDelta;
						secondDelta[index] = firstHorizontalDelta + secondVerticalDelta;
						break;
					case '|':
						firstDelta[index] = firstVerticalDelta;
						secondDelta[index] = secondVerticalDelta;
						break;
					default:
						firstDelta[index] = firstHorizontalDelta + firstVerticalDelta;
						secondDelta[index] = secondHorizontalDelta + secondVerticalDelta;
						break;
				}
				int first = (index + firstDelta[index]) % (rowCount * columnCount);
				incoming[first].add(index);
				int second = (index + secondDelta[index]) % (rowCount * columnCount);
				incoming[second].add(index);
			}
		}
		NavigableSet<Integer> queue = new TreeSet<Integer>(new Comparator<Integer>() {
			public int compare(Integer o1, Integer o2) {
				int value = incoming[o1].size() - incoming[o2].size();
				if (value != 0)
					return value;
				return o1 - o2;
			}
		});
		for (int i = 0; i < rowCount * columnCount; i++)
			queue.add(i);
		out.print("Case #" + testNumber + ": ");
		while (!queue.isEmpty() && incoming[queue.first()].size() <= 1) {
			if (incoming[queue.first()].isEmpty()) {
				out.println(0);
				return;
			}
			int index = queue.pollFirst();
			int source = incoming[index].iterator().next();
			int other;
			if ((source + firstDelta[source]) % (rowCount * columnCount) == index)
				other = (source + secondDelta[source]) % (rowCount * columnCount);
			else
				other = (source + firstDelta[source]) % (rowCount * columnCount);
			incoming[index].remove(source);
			queue.remove(other);
			incoming[other].remove(source);
			queue.add(other);
		}
		int[][] edges = new int[rowCount * columnCount][2];
		boolean[] visited = new boolean[rowCount * columnCount];
		Arrays.fill(visited, true);
		for (int index : queue) {
			visited[index] = false;
			int curIndex = 0;
			for (int source : incoming[index]) {
				int other;
				if ((source + firstDelta[source]) % (rowCount * columnCount) == index)
					other = (source + secondDelta[source]) % (rowCount * columnCount);
				else
					other = (source + firstDelta[source]) % (rowCount * columnCount);
				edges[index][curIndex++] = other;
			}
		}
		result = 1;
		for (int i = 0; i < rowCount * columnCount; i++) {
			if (visited[i])
				continue;
			result *= 2;
			result %= 1000003;
			int current = edges[i][0];
			int last = i;
			while (current != i) {
				visited[current] = true;
				int next = edges[current][0] + edges[current][1] - last;
				last = current;
				current = next;
			}
		}
		out.println(result);
//		out.println("Case #" + testNumber + ": " + (result % 1000003));
	}
}

