import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.*;

/**
 * @author Egor Kulikov (kulikov@devexperts.com)
 */
public class Task implements Runnable {
    private static final String TASK_ID = "welcome";
    private static final String IN_FILE = TASK_ID + ".in";
    private static final String OUT_FILE = TASK_ID + ".out";
	private static final String a = "welcome to code jam";
	private static final int MOD = 10000;

    private Scanner in;
    private PrintWriter out;
    private int t, ans;
    private String s;

    private void init() {
        try {
            in = new Scanner(new File(IN_FILE));
        } catch (FileNotFoundException ignored) {}
        try {
            out = new PrintWriter(OUT_FILE);
        } catch (FileNotFoundException ignored) {}
    }

    private void read() {
		s = in.next();
    }

    private void solve() {
		System.out.println(s);
		int n = s.length();
		int m = a.length();
		int[][] d = new int[n + 1][m + 1];
		d[0][0] = 1;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				d[i][j] %= MOD;
				d[i + 1][j] += d[i][j];
				if (s.charAt(i) == a.charAt(j))
					d[i + 1][j + 1] += d[i][j];
			}
			d[i + 1][m] += d[i][m] % MOD;
		}
		ans = d[n][m] % MOD;
    }

    private void write() {
		String res = "" + ans;
		while (res.length() < 4)
			res = "0" + res;
        out.printf("Case #%d: %s\n", t, res);
    }

    public void run() {
        init();
        int n;
        n = in.nextInt();
		in.useDelimiter("\n");
//		in.next();
        for (t = 1; t <= n; t++) {
            System.out.println("Test " + t);
            read();
            solve();
            write();
        }
        out.close();
    }
    public static void main(String[] args) {
        new Thread(new Task()).start();
    }
}
