import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Task implements Runnable {
	private static String id = "plant";

	private Scanner in;
	private PrintWriter out;

	private double ans;
	private int n;
	int[] x, y, r;

	private void init() {
		try {
			in = new Scanner(new File(id + ".in"));
			out = new PrintWriter(id + ".out");
		} catch (FileNotFoundException ignored) {
		}
	}

	private void read() {
		n = in.nextInt();
		x = new int[n];
		y = new int[n];
		r = new int[n];
		for (int i = 0; i < n; i++) {
			x[i] = in.nextInt();
			y[i] = in.nextInt();
			r[i] = in.nextInt();
		}
	}

	private void solve() {
		if (n == 1) {
			ans = r[0];
			return;
		}
		if (n == 2) {
			ans = Math.max(r[0], r[1]);
			return;
		}
		ans = 1e100;
		for (int i = 0; i < 3; i++) {
			int a = (i + 1) % 3;
			int b = (i + 2) % 3;
			ans = Math.min(ans, Math.max(r[i], (Math.hypot(x[a] - x[b], y[a] - y[b]) + r[a] + r[b]) / 2));
		}
	}

	private void write(int test) {
		out.println("Case #" + test + ": " + ans);
	}

	public void run() {
		init();
		int t = in.nextInt();
		for (int i = 1; i <= t; i++) {
			read();
			solve();
			write(i);
		}
		out.close();
	}

	public static void main(String[] args) {
		new Thread(new Task()).start();
	}
}
