package eric;

import java.io.*;
import java.util.*;
import java.text.*;

public class StU {

    static int switches( List<String> engines, List<String> queries ) {
        Set<String> got = new HashSet<String>( engines );
        String chosen = null;
        for (int i = 0; i < queries.size(); ++i) {
            String query = queries.get(i);
            if ((chosen != null) && query.equals( chosen )) {
                // switch
                return 1 + switches( engines, queries.subList( i, queries.size() )); 
            }
            if (got.contains( query )) {
                got.remove( query );
            }
            if (got.size() == 1) {
                chosen = got.iterator().next();
            }
        }
        return 0;
    }

    public static void main( String[] args ) throws IOException {
        File inputFile = new File( args[0] );
        BufferedReader reader = new BufferedReader( new InputStreamReader( new FileInputStream( inputFile ) ) ); 
        String line = reader.readLine();
        int cases = Integer.parseInt( line.trim() );
        File outputFile = new File( inputFile.getPath() + ".out" ); 
        PrintWriter writer = new PrintWriter( new FileWriter( outputFile ) ); 
        for (int i = 0; i < cases; ++i) {
            int numEngines = Integer.parseInt( reader.readLine() );
            List<String> engines = new ArrayList<String>(numEngines); 
            for (int j = 0; j < numEngines; ++j) {
                engines.add( reader.readLine().trim().intern() );
            }
            int numQueries = Integer.parseInt( reader.readLine() );
            List<String> queries = new ArrayList<String>(numQueries); 
            for (int j = 0; j < numQueries; ++j) {
                queries.add( reader.readLine().trim().intern() );
            }
            int numSwitches = switches( engines, queries );
            String resultLine = "Case #" + (i + 1) + ": " + numSwitches;
            System.out.println( resultLine );
            writer.println( resultLine ); 
        }
        reader.close();
        writer.close();
    }
}
