package eric;

import java.io.*;
import java.util.*;
import java.text.*;

public class Train {

    private static int parseMinutes( String hhmm ) {
        StringTokenizer st = new StringTokenizer( hhmm.trim(), ":" );
        int hour = Integer.parseInt( st.nextToken() );
        int mins = Integer.parseInt( st.nextToken() );
        return (60 * hour) + mins;
    }

    static int trainsNeeded( LinkedList<Integer> minus, LinkedList<Integer> plus ) {
        Collections.sort( minus );
        Collections.sort( plus );
        int initial = 0;
        int trains = 0;
        while (minus.size() > 0) {
            if ((plus.size() == 0) || (minus.peek() < plus.peek())) {
                if (trains > 0) {
                    --trains;
                } else {
                    // needed another train
                    ++initial;
                }
                minus.remove();
            } else if (plus.size() > 0) {
                ++trains;
                plus.remove();
            }
        }
        return initial;
    }

    public static void main( String[] args ) throws IOException {
        File inputFile = new File( args[0] );
        BufferedReader reader = new BufferedReader( new InputStreamReader( new FileInputStream( inputFile ) ) ); 
        String line = reader.readLine();
        int cases = Integer.parseInt( line.trim() );
        File outputFile = new File( inputFile.getPath() + ".out" ); 
        PrintWriter writer = new PrintWriter( new FileWriter( outputFile ) ); 
        for (int i = 0; i < cases; ++i) {
            LinkedList<Integer> minusA = new LinkedList<Integer>();
            LinkedList<Integer> plusA = new LinkedList<Integer>();
            LinkedList<Integer> minusB = new LinkedList<Integer>();
            LinkedList<Integer> plusB = new LinkedList<Integer>();
            int turnaroundTime = Integer.parseInt( reader.readLine().trim() );
            StringTokenizer st = new StringTokenizer( reader.readLine() );
            int numA = Integer.parseInt( st.nextToken() );
            int numB = Integer.parseInt( st.nextToken() );
            for (int j = 0; j < numA; ++j) {
                st = new StringTokenizer( reader.readLine() );
                int departure = parseMinutes( st.nextToken() );
                minusA.add( departure );
                int arrival = parseMinutes( st.nextToken() );
                plusB.add( arrival + turnaroundTime );
            }
            for (int j = 0; j < numB; ++j) {
                st = new StringTokenizer( reader.readLine() );
                int departure = parseMinutes( st.nextToken() );
                minusB.add( departure );
                int arrival = parseMinutes( st.nextToken() );
                plusA.add( arrival + turnaroundTime );
            }
            int minA = trainsNeeded( minusA, plusA );
            int minB = trainsNeeded( minusB, plusB );
            String resultLine = "Case #" + (i + 1) + ": " + minA + " " + minB;
            System.out.println( resultLine );
            writer.println( resultLine ); 
        }
        reader.close();
        writer.close();
    }
}
