package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

/**
 * @author Marius Oehler
 *
 */
public class OversizedPancakeFlipper {

	public static void main(String[] args) throws Exception {
		try (BufferedWriter writer = new BufferedWriter(new FileWriter("results.txt"))) {
			try (BufferedReader reader = new BufferedReader(new FileReader("A-large.in"))) {
				int numberTestCases = Integer.parseInt(reader.readLine());

				for (int i = 1; i <= numberTestCases; i++) {
					String line = String.format("Case #%d: %s", i, solve(reader.readLine()));
					System.out.println(line);
					writer.write(line);
					writer.newLine();
				}
			}
		}
	}

	private static String solve(String input) {
		String[] split = input.split(" ");

		char[] pancakes = split[0].toCharArray();
		int flipperSize = Integer.parseInt(split[1]);
		int flipCount = 0;

		int i;
		for (i = 0; i <= (pancakes.length - flipperSize); i++) {
			if (pancakes[i] == '-') {
				flipCount++;
				flip(pancakes, i, flipperSize);
			}
		}

		for (; i < pancakes.length; i++) {
			if (pancakes[i] != '+') {
				return "IMPOSSIBLE";
			}
		}

		return String.valueOf(flipCount);
	}

	private static void flip(char[] input, int index, int flipperSize) {
		for (int i = index; i < (index + flipperSize); i++) {
			char pancake = input[i];
			input[i] = pancake == '+' ? '-' : '+';
		}
	}
}
