package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Collections;
import java.util.LinkedList;

/**
 * @author Marius Oehler
 *
 */
public class BathroomStalls {

	public static void main(String[] args) throws Exception {
		try (BufferedWriter writer = new BufferedWriter(new FileWriter("results.txt"))) {
			try (BufferedReader reader = new BufferedReader(new FileReader("C-small-1-attempt0.in"))) {
				int numberTestCases = Integer.parseInt(reader.readLine());

				for (int i = 1; i <= numberTestCases; i++) {
					String line = String.format("Case #%d: %s", i, solve(reader.readLine()));

					System.out.println(line);
					writer.write(line);
					writer.newLine();
				}
			}
		}
	}

	private static String solve(String input) {
		String[] split = input.split(" ");

		long stalls = Long.parseLong(split[0]);
		long people = Long.parseLong(split[1]);

		LinkedList<Long> list = new LinkedList<>();

		list.add(stalls);

		long max = 0, min = 0;

		for (long i = 0; i < people; i++) {
			long num = list.removeLast();

			max = num / 2L;
			min = max;

			if ((num % 2) == 0) {
				min--;
			}

			boolean sort = !list.isEmpty() && (list.getLast() > min);

			list.add(min);
			list.add(max);

			if (sort) {
				Collections.sort(list);
			}
		}

		return max + " " + min;
	}

}
