package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

/**
 * @author Marius Oehler
 *
 */
public class TidyNumbers {

	public static void main(String[] args) throws Exception {
		try (BufferedWriter writer = new BufferedWriter(new FileWriter("results.txt"))) {
			try (BufferedReader reader = new BufferedReader(new FileReader("B-large.in"))) {
				int numberTestCases = Integer.parseInt(reader.readLine());

				for (int i = 1; i <= numberTestCases; i++) {
					String line = String.format("Case #%d: %s", i, solve(reader.readLine()));

					System.out.println(line);
					writer.write(line);
					writer.newLine();
				}
			}
		}
	}

	private static String solve(String input) {
		if (input.length() <= 1) {
			return input;
		}

		char[] chars = input.toCharArray();

		for (int i = chars.length - 1; i > 0; i--) {
			if (isTidy(new String(chars))) {
				break;
			}

			set(chars, i);
		}

		return String.valueOf(Long.parseLong(new String(chars)));
	}

	private static void set(char[] chars, int index) {
		chars[index] = '9';
		if (chars[index - 1] == '0') {
			set(chars, index - 1);
		} else {
			chars[index - 1] = (char) (chars[index - 1] - 1);
		}
	}

	private static boolean isTidy(String number) {
		char[] chars = number.toCharArray();

		for (int i = 0; i < (chars.length - 1); i++) {
			if (chars[i] > chars[i + 1]) {
				return false;
			}
		}

		return true;
	}
}
