package meuh.com.google.codejam.r1b;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Scanner;

public class StableNeighbors {
    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        PrintWriter out = new PrintWriter(new File("StableNeighbors.out"));
        new StableNeighbors().run(in, out);
        out.close();
    }
    private enum Color { R, O, Y, G, B, V }

    private void run(Scanner in, PrintWriter out) {
        int T = in.nextInt();
        for (int t=0; t<T; t++) {
            int N = in.nextInt();
            int ponnies[] = new int[6];
            ponnies[0] = in.nextInt();
            ponnies[1] = in.nextInt();
            ponnies[2] = in.nextInt();
            ponnies[3] = in.nextInt();
            ponnies[4] = in.nextInt();
            ponnies[5] = in.nextInt();
            Color current;
            if (ponnies[0] >= ponnies[2] && ponnies[0] >= ponnies[4]) current = Color.R;
            else if (ponnies[2] >= ponnies[0] && ponnies[2] >= ponnies[4]) current = Color.Y;
            else if (ponnies[4] > 0) current = Color.B;
            else if (ponnies[1] > 0) current = Color.O;
            else if (ponnies[3] > 0) current = Color.G;
            else current = Color.V;
            Color start = current;
            ponnies[start.ordinal()]--;
            Color[] result = new Color[N];
            result[0] = start;
            boolean isPossible = true;
            for (int n=1; n<N; n++) {
                Color[] neighbors = neighbors(current, ponnies, start);
                boolean toContinue = false;
                for (Color c: neighbors) {
                    if (ponnies[c.ordinal()] > 0) {
                        current = c;
                        result[n] = c;
                        ponnies[c.ordinal()]--;
                        toContinue = true;
                        break;
                    }
                }
                if (!toContinue) {
                    isPossible = false;
                    break;
                }
            }
            if (isPossible) {
                boolean isSuccess = false;
                for (Color c: neighbors(current, ponnies, start)) {
                    if (c == start) {
                        isSuccess = true;
                    }
                }
                if (isSuccess) {
                    StringBuilder sb = new StringBuilder();
                    for (Color c : result) {
                        sb.append(c.name());
                    }
                    out.println(String.format("Case #%d: %s", t + 1, sb.toString()));
                } else {
                    out.println(String.format("Case #%d: IMPOSSIBLE", t+ 1));
                }
            } else {
                out.println(String.format("Case #%d: IMPOSSIBLE", t+ 1));
            }
        }
    }
    private Color[] neighbors(Color color, int[] ponnies, Color start) {
        if (color == Color.O) return new Color[]{Color.B};
        if (color == Color.G) return new Color[]{Color.R};
        if (color == Color.V) return new Color[]{Color.Y};
        if (color == Color.R) {
            if (ponnies[Color.Y.ordinal()] > ponnies[Color.B.ordinal()]) {return new Color[]{Color.G, Color.Y, Color.B};}
            else if (ponnies[Color.Y.ordinal()] < ponnies[Color.B.ordinal()]) {return new Color[]{Color.G, Color.B, Color.Y};}
            else if (start == Color.B) {return new Color[]{Color.G, Color.B, Color.Y};}
            else {return new Color[]{Color.G, Color.Y, Color.B};}
        }
        if (color == Color.Y) {
            if (ponnies[Color.R.ordinal()] > ponnies[Color.B.ordinal()]) {return new Color[]{Color.V, Color.R, Color.B};}
            else if (ponnies[Color.R.ordinal()] < ponnies[Color.B.ordinal()]) {return new Color[]{Color.V, Color.B, Color.R};}
            else if (start == Color.B) {return new Color[]{Color.V, Color.B, Color.R};}
            else {return new Color[]{Color.V, Color.R, Color.B};}
        }
        if (ponnies[Color.R.ordinal()] > ponnies[Color.Y.ordinal()]) {return new Color[]{Color.O, Color.R, Color.Y};}
        else if (ponnies[Color.R.ordinal()] < ponnies[Color.Y.ordinal()]) {return new Color[]{Color.O, Color.Y, Color.R};}
        else if (start == Color.Y) {return new Color[]{Color.O, Color.Y, Color.R};}
        else {return new Color[]{Color.O, Color.R, Color.Y};}
    }
}
