package com.meuh.codejam;

import java.io.*;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Scanner;

public class CoinJam {
    private static final BigInteger longMaxBigInt = BigInteger.valueOf(Long.MAX_VALUE);
    private static final BigInteger bigInt2 = BigInteger.valueOf(2);
    private static final BigInteger bigInt3 = BigInteger.valueOf(3);
    private static int N_PRIMES;
//    private BigInteger[] bigIntegers1 = new BigInteger[PRE_ALLOCATED_SIZE];
//    private BigInteger[] bigIntegers2 = new BigInteger[PRE_ALLOCATED_SIZE];
    private static BigInteger[] bigIntegerPrimes;

    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new File("primes.txt"));
        N_PRIMES = in.nextInt();
        bigIntegerPrimes = new BigInteger[N_PRIMES];
        for (int i=0; i<N_PRIMES; i++) {
            bigIntegerPrimes[i] = BigInteger.valueOf(in.nextInt());
        }
        in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        PrintWriter out = new PrintWriter(new File("CoinJam.out"));
        new CoinJam().run(in, out);
        out.close();
    }

    private void run(Scanner in, PrintWriter out) {
//        int  s=0;
//        int p = 5;
//        while (s < 1000) {
//            if(isPrime(p) == 0) {
//                System.out.println(p);
//                s++;
//            }
//            p++;
//        }
//        for (int i=0, j=5; i<PRE_ALLOCATED_SIZE; i++, j+=6) {
//            bigIntegers1[i] = BigInteger.valueOf(j);
//            bigIntegers2[i] = BigInteger.valueOf(j+2);
//        }
        int t=in.nextInt();
        for (int i=0; i<t; i++) {
            int N = in.nextInt();
            int J = in.nextInt();
            byte coinJam[] = new byte[N];
            Arrays.fill(coinJam, (byte)'0');
            coinJam[0] = (byte) '1';
            coinJam[N-1] = (byte) '1';
            long divisors[] = new long[9];
            out.println(String.format("Case #%d:", i + 1));
            while (J > 0) {
                boolean isCoinJam = true;
                String jamCoinStr = new String(coinJam);
                for (int j=2; j<=10; j++) {
                    long divisor;
                    if (jamCoinStr.length() > 19) {
                        BigInteger number = new BigInteger(jamCoinStr, j);
                        if(number.compareTo(longMaxBigInt) < 0) {
                            divisor = isPrime(number.longValue());
                        } else {
                            divisor = isPrime(number);
                        }
                    } else {
                        long number = Long.parseLong(jamCoinStr, j);
                        divisor = isPrime(number);
                    }
                    if (divisor == 0) {
                        isCoinJam = false;
                        break;
                    }
                    divisors[j-2] = divisor;
                }
                if (isCoinJam) {
                    out.println(String.format("%s %d %d %d %d %d %d %d %d %d", jamCoinStr,
                            divisors[0], divisors[1], divisors[2], divisors[3], divisors[4], divisors[5], divisors[6],
                            divisors[7], divisors[8]));
                    J--;
                }
                nextCoinJam(coinJam);
            }
        }
    }

    private void nextCoinJam(byte[] coinJam) {
        for (int i=coinJam.length-2; i>=1; i--) {
            if (coinJam[i] == '0') {
                coinJam[i] = '1';
                for (int j=i+1; j<=coinJam.length-2; j++) {
                    coinJam[j] = '0';
                }
                break;
            }
        }
    }

    private long isPrime(BigInteger n) {
        if (n.remainder(bigInt2).bitCount() == 0) {
            return 2;
        } else if (n.remainder(bigInt3).bitCount() == 0) {
            return 3;
        }
        for(int i = 0; i < N_PRIMES; i++) {
            if (n.remainder(bigIntegerPrimes[i]).bitCount() == 0)
                return bigIntegerPrimes[i].longValue();
        }
        return 0;
    }

    private long isPrime(long n) {
        if(n > 2 && (n & 1) == 0)
            return 2;
        for(long i = 3; i * i <= n; i += 2)
            if (n % i == 0)
                return i;
        return 0;
    }
}
