package com.meuh.codejam;

import java.io.*;
import java.math.BigInteger;
import java.util.Scanner;

public class Fractiles {
    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        PrintWriter out = new PrintWriter(new File("Fractiles.out"));
        new Fractiles().run(in, out);
        out.close();
    }

    private void run(Scanner in, PrintWriter out) {
        int t=in.nextInt();
        for (int i=0; i<t; i++) {
            int K = in.nextInt();
            int C = in.nextInt();
            int S = in.nextInt();
            int minTileToClean = K + 1 - C;
            if (minTileToClean <= 0) minTileToClean = 1;
            if (S < minTileToClean) {
                out.println(String.format("Case #%d: IMPOSSIBLE", i + 1));
            } else {
                BigInteger startingIndex = BigInteger.ONE;
                for (int j = 1; j < C && j < K; j++) {
                    startingIndex = startingIndex.multiply(startingIndex.add(BigInteger.ONE));
                }
                StringBuilder sb = new StringBuilder();
                BigInteger k = startingIndex;
                for (int j = 0; j < minTileToClean; j++) {
                    sb.append(" ");
                    sb.append(k.toString());
                    k = k.add(BigInteger.ONE);
                }
                out.println(String.format("Case #%d:%s", i + 1, sb.toString()));
            }
        }
    }
}
