package com.meuh.codejam;

import java.io.*;
import java.util.Arrays;
import java.util.Scanner;

public class BFFs {
    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        PrintWriter out = new PrintWriter(new File("BFF.out"));
        new BFFs().run(in, out);
        out.close();
    }

    private void run(Scanner in, PrintWriter out) {
        int T = in.nextInt();
        for (int i=0; i<T; i++) {
            int N = in.nextInt();
            Student students[] = new Student[N];
            for (int j=0; j<N; j++) {
                students[j] = new Student(j+1);
            }
            for (int j=0; j<N; j++) {
                int bf = in.nextInt();
                students[j].friend = students[bf-1];
            }
            int maxKids = 0;
            for (int j=0; j<N; j++) {
                Student student = students[j];
                int maxKidsForIteration = 0;
                while (!student.isVisited) {
                    student.visit();
                    maxKidsForIteration++;
                    student = student.friend;
                }
                if (student.id == students[j].id) {
                    maxKids = (maxKids < maxKidsForIteration) ? maxKidsForIteration : maxKids;
                }
                student = students[j];
                while (student.isVisited) {
                    student.unVisit();
                    student = student.friend;
                }
            }
            out.println(String.format("Case #%d: %d", i+1, maxKids));
        }
    }

    private class Student {
        private final int id;
        boolean isVisited = false;
        Student friend = null;

        private Student(int id) {
            this.id = id;
        }

        public void visit() {
            isVisited = true;
        }

        public void unVisit() {
            isVisited = false;
        }
    }
}
