package com.meuh.codejam.round1;

import java.io.*;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class SenateEvacuation {
    Comparator<Party> reverseComparator = new Comparator<Party>() {
        @Override
        public int compare(Party o1, Party o2) {
            return Integer.compare(o2.members, o1.members);
        }
    };
    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        PrintWriter out = new PrintWriter(new File("SenateEvacuation.out"));
        new SenateEvacuation().run(in, out);
        out.close();
    }

    private void run(Scanner in, PrintWriter out) {
        int T = in.nextInt();
        for (int i=0; i<T; i++) {
            int N = in.nextInt();
            Party parties[] = new Party[N];
            int totoalMembers = 0;
            for (int j=0; j<N; j++) {
                int p = in.nextInt();
                totoalMembers += p;
                parties[j] = new Party((char) ('A' + j), p);
            }
            Arrays.sort(parties, reverseComparator);
            StringBuilder stringBuilder = new StringBuilder();
            while (totoalMembers > 0) {
                stringBuilder.append(parties[0].symbol);
                parties[0].members--;
                totoalMembers--;
                int majority = (totoalMembers+1) / 2;
                if (parties[1].members < majority) {
                    stringBuilder.append(parties[0].symbol);
                    parties[0].members--;
                    totoalMembers--;
                } else if (parties[0].members < majority) {
                    if (parties.length>2 && parties[2].members >= majority) {
                        ;
                    } else {
                        stringBuilder.append(parties[1].symbol);
                        parties[1].members--;
                        totoalMembers--;
                    }
                }
                stringBuilder.append(' ');
                Arrays.sort(parties, reverseComparator);
            }
            out.println(String.format("Case #%d: %s", i+1, stringBuilder.toString()));
        }
    }

    private class Party {
        public final char symbol;
        public int members;

        private Party(char symbol, int members) {
            this.symbol = symbol;
            this.members = members;
        }
    }
}
