package com.meuh.codejam;

import java.io.*;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Scanner;

public class CoinJam {
    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        PrintWriter out = new PrintWriter(new File("CoinJam.out"));
        new CoinJam().run(in, out);
        out.close();
    }

    private void run(Scanner in, PrintWriter out) {
        int t=in.nextInt();
        for (int i=0; i<t; i++) {
            int N = in.nextInt();
            int J = in.nextInt();
            byte coinJam[] = new byte[N];
            Arrays.fill(coinJam, (byte)'0');
            coinJam[0] = (byte) '1';
            coinJam[N-1] = (byte) '1';
            long divisors[] = new long[9];
            out.println(String.format("Case #%d:", i + 1));
            while (J > 0) {
                boolean isCoinJam = true;
                String jamCoinStr = new String(coinJam);
                for (int j=2; j<=10; j++) {
                    long number = Long.parseLong(jamCoinStr, j);
                    long divisor = isPrime(number);
                    if (divisor == 0) {
                        isCoinJam = false;
                        break;
                    }
                    divisors[j-2] = divisor;
                }
                if (isCoinJam) {
                    out.println(String.format("%s %d %d %d %d %d %d %d %d %d", jamCoinStr,
                            divisors[0], divisors[1], divisors[2], divisors[3], divisors[4], divisors[5], divisors[6],
                            divisors[7], divisors[8]));
                    J--;
                }
                nextCoinJam(coinJam);
            }
        }
    }

    private void nextCoinJam(byte[] coinJam) {
        for (int i=coinJam.length-2; i>=1; i--) {
            if (coinJam[i] == '0') {
                coinJam[i] = '1';
                for (int j=i+1; j<coinJam.length-2; j++) {
                    coinJam[j] = '0';
                }
                break;
            }
        }
    }

    private long isPrime(long n) {
        if(n > 2 && (n & 1) == 0)
            return 2;
        for(long i = 3; i * i <= n; i += 2)
            if (n % i == 0)
                return i;
        return 0;
    }
}
