package com.meuh.codejam;

import java.io.*;
import java.util.Scanner;
import java.util.Stack;

public class GettingTheDigits {
    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        PrintWriter out = new PrintWriter(new File("GettingTheDigits.out"));
        new GettingTheDigits().run(in, out);
        out.close();
    }

    private void run(Scanner in, PrintWriter out) {
        int T = in.nextInt();
        String[] digitStr = {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
        in.nextLine();
        for (int i=0; i<T; i++) {
            int digitCounts[] = new int[26];
            String s=in.nextLine();
            addDigitCounts(digitCounts, s);
            Stack<Integer> digits = new Stack<>();
            int j=0;
            boolean isFinished = false;
            while (!isFinished) {
                for (; j < 10; j++) {
                    while (digitExists(digitCounts, digitStr[j])) {
                        digits.push(j);
                    }
                }
                isFinished = true;
                for (int k = 0; k < digitCounts.length; k++) {
                    if (digitCounts[k] > 0) {
                        isFinished = false;
                        break;
                    }
                }
                if (!isFinished) {
                    int putBack = digits.pop();
                    addDigitCounts(digitCounts, digitStr[putBack]);
                    j = putBack + 1;
                }
            }
            StringBuilder stringBuilder = new StringBuilder();
            for (int k: digits) {
                stringBuilder.append(k);
            }
            out.println(String.format("Case #%d: %s", i+1, stringBuilder.toString()));
        }
    }

    private void addDigitCounts(int[] alphaCounts, String s) {
        for (char c: s.toCharArray()) {
            alphaCounts[c-'A']++;
        }
    }

    private boolean digitExists(int counts[], String digit) {
        int alphaCounts[] = new int[26];
        addDigitCounts(alphaCounts, digit);
        for (int i=0; i<alphaCounts.length; i++) {
            if (counts[i] < alphaCounts[i]) {
                return false;
            }
        }
        for (int i=0; i<alphaCounts.length; i++) {
            counts[i] -= alphaCounts[i];
        }
        return true;
    }
}
