import gnu.trove.set.hash.TCharHashSet;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Scanner;
import java.util.Set;

public class R1A_KillerWord {
	public static void main(String[] args) throws FileNotFoundException {
		Scanner scan = new Scanner(new File("B-small-attempt2.in"));
		PrintWriter out = new PrintWriter("out.txt");
		int cases = scan.nextInt();
		for (int testCase = 0; testCase < cases; testCase++) {
			int numWords = scan.nextInt();
			int numLists = scan.nextInt();
			String[] words = new String[numWords];
			for (int i = 0; i < numWords; i++)
				words[i] = scan.next();
			String[] lists = new String[numLists];
			for (int i = 0; i < numLists; i++)
				lists[i] = scan.next();

			out.printf("Case #%d:", testCase + 1);
			for (int i = 0; i < numLists; i++)
				out.printf(" %s", bestStr(words, lists[i]));
			out.println();
		}
		out.close();
	}

	private static String bestStr(String[] words, String list) {
		int maxPenalty = -1;
		String bestWord = null;
		for (int i = 0; i < words.length; i++) {
			int p = simulate(words, words[i], list);
			if (p > maxPenalty) {
				maxPenalty = p;
				bestWord = words[i];
			}
		}
		return bestWord;
	}

	private static int simulate(String[] words, String word, String list) {
		Set<String> consistentWords = new HashSet<String>();
		for (String s : words)
			consistentWords.add(s);

		char[] known = new char[word.length()];
		TCharHashSet notin = new TCharHashSet();
		TCharHashSet guessed = new TCharHashSet();
		filterInconsistent(consistentWords, known, notin, guessed);

		int p = 0;
		int i = 0;
		while (consistentWords.size() > 1) {
			if (i >= list.length())
				throw new RuntimeException();

			char guess = list.charAt(i);
			if (isHelpful(consistentWords, guess)) {
				boolean fail = fillGuess(known, word, guess);
				if (fail) {
					notin.add(guess);
					p++;
				}
				guessed.add(guess);
				filterInconsistent(consistentWords, known, notin, guessed);
			}
			i++;
		}
		if (consistentWords.size() == 0)
			throw new RuntimeException();
		return p;
	}

	private static boolean fillGuess(char[] known, String word, char guess) {
		boolean fail = true;
		for (int i = 0; i < word.length(); i++) {
			if (word.charAt(i) == guess) {
				known[i] = guess;
				fail = false;
			}
		}
		return fail;
	}

	private static void filterInconsistent(Set<String> c, char[] known, TCharHashSet notin, TCharHashSet guessed) {
		Iterator<String> iter = c.iterator();
		while (iter.hasNext()) {
			String s = iter.next();
			if (!isConsistent(known, s, notin, guessed))
				iter.remove();
		}
	}

	private static boolean isHelpful(Set<String> consistentWords, char c) {
		for (String s : consistentWords)
			if (s.indexOf(c) != -1)
				return true;
		return false;
	}

	private static boolean isConsistent(char[] known, String word, TCharHashSet notin, TCharHashSet guessed) {
		if (known.length != word.length())
			return false;
		for (int i = 0; i < known.length; i++) {
			char c = word.charAt(i);
			if (notin.contains(c))
				return false;
			if (known[i] != 0 && known[i] != c)
				return false;
			if (known[i] == 0 && guessed.contains(c))
				return false;
		}
		return true;
	}
}