import gnu.trove.list.array.TCharArrayList;
import gnu.trove.stack.TCharStack;
import gnu.trove.stack.array.TCharArrayStack;

import java.io.File;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class QB_Magicka {
	public static void main(String[] args) throws Exception {
		Scanner scan = new Scanner(new File("B-large.in"));
		PrintWriter out = new PrintWriter("out.txt");
		int cases = scan.nextInt();
		scan.nextLine();
		for (int testCase = 0; testCase < cases; testCase++) {
			int numCombinations = scan.nextInt();
			char[][] combinations = new char[26][26];
			for (int i = 0; i < numCombinations; i++) {
				String comb = scan.next();
				char base1 = comb.charAt(0), base2 = comb.charAt(1), nonbase = comb.charAt(2);
				combinations[base1 - 'A'][base2 - 'A'] = nonbase;
				combinations[base2 - 'A'][base1 - 'A'] = nonbase;
			}

			int numOpposed = scan.nextInt();
			TCharArrayList[] opposed = new TCharArrayList[26];
			for (int i = 0; i < opposed.length; i++)
				opposed[i] = new TCharArrayList();
			for (int i = 0; i < numOpposed; i++) {
				String pair = scan.next();
				char ch1 = pair.charAt(0);
				char ch2 = pair.charAt(1);
				opposed[ch1 - 'A'].add(ch2);
				opposed[ch2 - 'A'].add(ch1);
			}

			TCharStack stack = new TCharArrayStack();
			int[] invokedCounts = new int[26];
			scan.nextInt();
			String invokeList = scan.next();
			for (int i = 0; i < invokeList.length(); i++) {
				char next = invokeList.charAt(i);
				if (stack.size() >= 1) {
					char top = stack.peek();
					char comb = combinations[top - 'A'][next - 'A'];
					if (comb != 0) {
						stack.pop();
						stack.push(comb);
						invokedCounts[top - 'A']--;
					} else {
						stack.push(next);
					}
				} else {
					stack.push(next);
				}

				char top = stack.peek();
				invokedCounts[top - 'A']++;
				TCharArrayList oppList = opposed[top - 'A'];
				for (int j = 0; j < oppList.size(); j++) {
					char opp = oppList.get(j);
					if (invokedCounts[opp - 'A'] > 0) {
						stack.clear();
						Arrays.fill(invokedCounts, 0);
						break;
					}
				}
			}

			out.printf("Case #%d: ", testCase + 1);
			char[] stackArr = stack.toArray();
			out.print("[");
			if (stackArr.length > 0) {
				out.print(stackArr[stackArr.length - 1]);
				for (int i = stackArr.length - 2; i >= 0; i--) {
					out.print(", ");
					out.print(stackArr[i]);
				}
			}
			out.println("]");
		}
		out.close();
	}
}