import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * @author Jing Wang
 */
public class QualificationThemePark {
	public static void main(String[] args) throws FileNotFoundException {
		Scanner scan = new Scanner(new File("C-large.in"));
		PrintWriter out = new PrintWriter("out.txt");
		int cases = scan.nextInt();
		for (int i = 0; i < cases; i++) {
			// roller coaster runs
			int r = scan.nextInt();
			// max capacity
			int k = scan.nextInt();
			// num groups
			int n = scan.nextInt();

			// group sizes
			int[] g = new int[n];
			for (int j = 0; j < n; j++)
				g[j] = scan.nextInt();

			out.printf("Case #%d: %d%n", i + 1, getProfit(r, k, n, g));
		}
		scan.close();
		out.close();
	}

	private static long getProfit(int r, int k, int n, int[] g) {
		// figure out the periodicity
		// at most n

		// which rotations of the queue were reached
		boolean[] reached = new boolean[n];

		// order of rotations
		List<Integer> rotations = new ArrayList<Integer>();

		// profit for rotation i
		long[] profits = new long[n];

		int rot = 0;
		while (!reached[rot]) {
			int i = 0;
			long ppl = 0;
			while (ppl + g[(i + rot) % n] <= k && i < n) {
				ppl += g[(i + rot) % n];
				i++;
			}

			profits[rot] = ppl;
			rotations.add(rot);
			reached[rot] = true;

			rot = (rot + i) % n;
		}

		// put it all together
		// if r is small, we calculated more than needed
		int periodStart = rotations.indexOf(rot);
		int periodSize = rotations.size() - periodStart;

		int numPeriods = Math.max((r - periodStart) / periodSize, 0);
		int leftoverRuns = Math.max(r - periodStart - numPeriods * periodSize, 0);

		long periodProfit = 0;
		for (int i = 0; i < periodSize; i++)
			periodProfit += profits[rotations.get(i + periodStart)];

		long startProfit = 0;
		for (int i = 0; i < r && i < periodStart; i++)
			startProfit += profits[rotations.get(i)];

		long endProfit = 0;
		for (int i = 0; i < leftoverRuns; i++)
			endProfit += profits[rotations.get(i + periodStart)];

		return startProfit + endProfit + periodProfit * numPeriods;
	}
}