import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class A_1A {
	public static void main(String[] args) throws FileNotFoundException {
		Scanner scan = new Scanner(new File("A-small-attempt0.in"));
		PrintWriter out = new PrintWriter("out.txt");
		int cases = scan.nextInt();
		for (int i = 0; i < cases; i++) {
			int dim = scan.nextInt();
			int k = scan.nextInt();
			char[][] board = new char[dim][dim];
			for (int r = 0; r < dim; r++)
					board[r] = scan.next().toCharArray();
			out.printf("Case #%d: %s%n", i + 1, solve(board, k));
		}
		out.close();
	}

	private static String solve(char[][] board, int k) {
		char[][] rotated = doGravity(rotateCW(board));
		boolean red = findVictory(rotated, 'R', k);
		boolean blue = findVictory(rotated, 'B', k);
		if (blue && red)
			return "Both";
		if (blue)
			return "Blue";
		if (red)
			return "Red";
		return "Neither";
	}

	private static char[][] rotateCW(char[][] arr) {
		int M = arr.length;
		int N = arr[0].length;
		char[][] rotated = new char[N][M];
		for (int r = 0; r < M; r++)
			for (int c = 0; c < N; c++)
				rotated[c][M - 1 - r] = arr[r][c];
		return rotated;
	}

	// the top is row 0
	private static char[][] doGravity(char[][] arr) {
		for (int r = arr.length - 2; r >= 0; r--) {
			for (int c = 0; c < arr.length; c++) {
				int currentR = r;
				while (currentR + 1 < arr.length && arr[currentR][c] != '.' && arr[currentR + 1][c] == '.') {
					arr[currentR + 1][c] = arr[currentR][c];
					arr[currentR][c] = '.';
					currentR++;
				}
			}
		}
		return arr;
	}

	private static boolean findVictory(char[][] arr, char winner, int k) {
		for (int r = 0; r < arr.length - k + 1; r++) {
			col: for (int c = 0; c < arr.length; c++) {
				for (int i = 0; i < k; i++)
					if (arr[r + i][c] != winner)
						continue col;
				return true;
			}
		}
		for (int r = 0; r < arr.length; r++) {
			col: for (int c = 0; c < arr.length - k + 1; c++) {
				for (int i = 0; i < k; i++)
					if (arr[r][c + i] != winner)
						continue col;
				return true;
			}
		}
		for (int r = 0; r < arr.length - k + 1; r++) {
			col: for (int c = 0; c < arr.length - k + 1; c++) {
				for (int i = 0; i < k; i++)
					if (arr[r + i][c + i] != winner)
						continue col;
				return true;
			}
		}

		for (int r = 0; r < arr.length - k + 1; r++) {
			col: for (int c = 0; c < arr.length - k + 1; c++) {
				for (int i = 0; i < k; i++)
					if (arr[r + k - i - 1][c + i] != winner)
						continue col;
				return true;
			}
		}

		return false;
	}
}