import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class Solution3 {
	static BufferedReader br;
    static StringTokenizer sc;
    static PrintWriter out;

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new FileReader("input.in"));
        out = new PrintWriter("output.out");
        sc = new StringTokenizer("");
        int t = nxtInt();
        for (int i = 1; i <= t; i++) {
        	int n = nxtInt();
        	int k = nxtInt();
        	
        	ArrayList<Integer> emptyStalls = new ArrayList<Integer>();
        	emptyStalls.add(n);
        	
        	int stallsR = 0, stallsL = 0;
        	
        	for (int j = 0; j < k; j++) {
        		int max = getMax(emptyStalls);
        		if (max == 1) {
        			stallsR = stallsL = 0;
        			break;
        		}
        		        		
        		for (int l = 0; l < emptyStalls.size(); l++) {
        			if (emptyStalls.get(l) == max) {
        				emptyStalls.remove(l);
        				
        				stallsR = max / 2;
        				if (max % 2 == 1) {
        					stallsL = stallsR;
        				}
        				else {
        					stallsL = stallsR - 1; 
        				}
        				
        				emptyStalls.add(stallsR);
        				emptyStalls.add(stallsL);
        				
        				break;
        			}
        		}        		        		
        	}
        	
        	out.println("Case #" + i + ": " + stallsR + " " + stallsL);
        }
        br.close();
        out.close();
    }    

    static String nxtTok() throws IOException {
        while (!sc.hasMoreTokens()) {
            String s = br.readLine();
            if (s == null) {
                return null;
            }
            sc = new StringTokenizer(s.trim());
        }
        return sc.nextToken();
    }

    static int nxtInt() throws IOException {
        return Integer.parseInt(nxtTok());
    }

    static long nxtLng() throws IOException {
        return Long.parseLong(nxtTok());
    }

    static double nxtDbl() throws IOException {
        return Double.parseDouble(nxtTok());
    }

    static int[] nxtIntArr(int n) throws IOException {
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nxtInt();
        }
        return a;
    }

    static long[] nxtLngArr(int n) throws IOException {
        long[] a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nxtLng();
        }
        return a;
    }

    static char[] nxtCharArr() throws IOException {
        return nxtTok().toCharArray();
    }
    
    static int getMin(int arr[], int count)
    {
    	int min = arr[0];
    	for (int i = 1; i < count; i++)
    		if (arr[i] < min)
    			min = arr[i];

    	return min;
    }

    static int getMax(ArrayList<Integer> arr)
    {
    	int max = arr.get(0);
    	for (int i = 1; i < arr.size(); i++)
    		if (arr.get(i) > max)
    			max = arr.get(i);

    	return max;
    }

    static void sortAsc(int arr[], int count)
    {
        int temp;

        for (int i = 0; i < count - 1; i++)
        {
            for (int j = i + 1; j < count; j++)
            {
                if (arr[i] > arr[j])
                {
                    temp = arr[i];
                    arr[i] = arr[j];
                    arr[j] = temp;
                }
            }
        }
    }

    static void sortDesc(int arr[], int count)
    {
        int temp;

        for (int i = 0; i < count - 1; i++)
        {
            for (int j = i + 1; j < count; j++)
            {
                if (arr[i] < arr[j])
                {
                    temp = arr[i];
                    arr[i] = arr[j];
                    arr[j] = temp;
                }
            }
        }
    }
}