import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Solution3 {
	static BufferedReader br;
    static StringTokenizer sc;
    static PrintWriter out;

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new FileReader("input.in"));
        out = new PrintWriter("output.out");
        sc = new StringTokenizer("");
        int t = nxtInt();
        for (int i = 1; i <= t; i++) {
        	out.println("Case #" + i + ":");
        	int n = nxtInt();
        	int j = nxtInt();
        	int[] digits = new int[n];
        	digits[0] = 1;
        	digits[n - 1] = 1;
        	int solutions = 0;
        	
        	int numTrials = (int) Math.pow(2, n - 2);
        	
        	for (int k = 0; k < numTrials; k++) {
        		// fill in the digits
        		int index = 1;
        		int num = k;
        		while (num > 0) {
        			digits[index] = num % 2;
        			num = (int) (num / 2);
        			index++;
        		}
        		for (int l = index; l < n - 1; l++)
        			digits[l] = 0;
        		
        		int[] divisor = new int[9];
        		boolean nonPrime = true;
        		for (int base = 2; base <= 10; base++) {
        			boolean ok = false;
        			long number = 0;
        			for (int l = 0; l < n; l++) {
        				number += digits[l] * Math.pow(base, l);
        			}
        			
        			for (int l = 2; l <= Math.sqrt(number); l++) {
        				if (number % l == 0) {
        					ok = true;
        					divisor[base - 2] = l;
        					break;
        				}
        			}
        			if (ok == false) {
        				nonPrime = false;
        				break;
        			}
        		}
        		
        		if (nonPrime) {
        			for (int l = n - 1; l >= 0; l--)
        				out.print(digits[l]);
        			for (int l = 0; l < 9; l++)
        				out.print(" " + divisor[l]);
        			out.println();
        			
        			solutions++;
        			if (solutions == j)
        				break;
        		}
        	}        	
        }
        br.close();
        out.close();
        System.out.println("finish");
    }

    

    static String nxtTok() throws IOException {
        while (!sc.hasMoreTokens()) {
            String s = br.readLine();
            if (s == null) {
                return null;
            }
            sc = new StringTokenizer(s.trim());
        }
        return sc.nextToken();
    }

    static int nxtInt() throws IOException {
        return Integer.parseInt(nxtTok());
    }

    static long nxtLng() throws IOException {
        return Long.parseLong(nxtTok());
    }

    static double nxtDbl() throws IOException {
        return Double.parseDouble(nxtTok());
    }

    static int[] nxtIntArr(int n) throws IOException {
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nxtInt();
        }
        return a;
    }

    static long[] nxtLngArr(int n) throws IOException {
        long[] a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nxtLng();
        }
        return a;
    }

    static char[] nxtCharArr() throws IOException {
        return nxtTok().toCharArray();
    }
    
    static int getMin(int arr[], int count)
    {
    	int min = arr[0];
    	for (int i = 1; i < count; i++)
    		if (arr[i] < min)
    			min = arr[i];

    	return min;
    }

    static int getMax(int arr[], int count)
    {
    	int max = arr[0];
    	for (int i = 1; i < count; i++)
    		if (arr[i] > max)
    			max = arr[i];

    	return max;
    }

    static void sortAsc(int arr[], int count)
    {
        int temp;

        for (int i = 0; i < count - 1; i++)
        {
            for (int j = i + 1; j < count; j++)
            {
                if (arr[i] > arr[j])
                {
                    temp = arr[i];
                    arr[i] = arr[j];
                    arr[j] = temp;
                }
            }
        }
    }

    static void sortDesc(int arr[], int count)
    {
        int temp;

        for (int i = 0; i < count - 1; i++)
        {
            for (int j = i + 1; j < count; j++)
            {
                if (arr[i] < arr[j])
                {
                    temp = arr[i];
                    arr[i] = arr[j];
                    arr[j] = temp;
                }
            }
        }
    }
}