import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Solution1 {
	static BufferedReader br;
    static StringTokenizer sc;
    static PrintWriter out;

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new FileReader("input.in"));
        out = new PrintWriter("output.out");
        sc = new StringTokenizer("");
        int t = nxtInt();
        for (int i = 1; i <= t; i++) {
        	int d = nxtInt();
        	int n = nxtInt();
        	
        	int[] k = new int[n];
        	double[] s = new double[n];
        	
        	for (int j = 0; j < n; j++) {
        		k[j] = nxtInt();
        		s[j] = nxtDbl();
        	}
        	
        	double[] time = new double[n];
        	
        	for (int j = 0; j < n; j++) {
        		time[j] = (d - k[j]) / s[j];
        	}
        	
        	double maxT = getMax(time, time.length);
        	double maxS = d / maxT;
        	
        	for (int j = 0; j < n; j++) {
        		if (k[j] < (maxS - s[j]) * maxT)
        			maxS = d / time[j];
        	}
        	
        	out.println("Case #" + i + ": " + maxS);
        }
        br.close();
        out.close();
        System.out.println("Finished");
    }    

    static String nxtTok() throws IOException {
        while (!sc.hasMoreTokens()) {
            String s = br.readLine();
            if (s == null) {
                return null;
            }
            sc = new StringTokenizer(s.trim());
        }
        return sc.nextToken();
    }

    static int nxtInt() throws IOException {
        return Integer.parseInt(nxtTok());
    }

    static long nxtLng() throws IOException {
        return Long.parseLong(nxtTok());
    }

    static double nxtDbl() throws IOException {
        return Double.parseDouble(nxtTok());
    }

    static int[] nxtIntArr(int n) throws IOException {
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nxtInt();
        }
        return a;
    }

    static long[] nxtLngArr(int n) throws IOException {
        long[] a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nxtLng();
        }
        return a;
    }

    static char[] nxtCharArr() throws IOException {
        return nxtTok().toCharArray();
    }
    
    static float getMin(float arr[], int count)
    {
    	float min = arr[0];
    	for (int i = 1; i < count; i++)
    		if (arr[i] < min)
    			min = arr[i];

    	return min;
    }

    static double getMax(double arr[], int count)
    {
    	double max = arr[0];
    	for (int i = 1; i < count; i++)
    		if (arr[i] > max)
    			max = arr[i];

    	return max;
    }

    static void sortAsc(int arr[], int count)
    {
        int temp;

        for (int i = 0; i < count - 1; i++)
        {
            for (int j = i + 1; j < count; j++)
            {
                if (arr[i] > arr[j])
                {
                    temp = arr[i];
                    arr[i] = arr[j];
                    arr[j] = temp;
                }
            }
        }
    }

    static void sortDesc(int arr[], int count)
    {
        int temp;

        for (int i = 0; i < count - 1; i++)
        {
            for (int j = i + 1; j < count; j++)
            {
                if (arr[i] < arr[j])
                {
                    temp = arr[i];
                    arr[i] = arr[j];
                    arr[j] = temp;
                }
            }
        }
    }
}