import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Solution1 {
	static BufferedReader br;
    static StringTokenizer sc;
    static PrintWriter out;

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new FileReader("input.in"));
        out = new PrintWriter("output.out");
        sc = new StringTokenizer("");
        int t = nxtInt();
        for (int i = 1; i <= t; i++) {
        	int r = nxtInt();
        	int c = nxtInt();
        	char[][] grid = new char[r][];
        	
        	for (int j = 0; j < r; j++) {
        		grid[j] = nxtCharArr();
        	}
        	
        	int empty = 0;
        	for (int j = 0; j < r; j++) {
        		for (int k = 0; k < c; k++) {
        			if (grid[j][k] == '?') {
        				empty++;
        			}
        		}
        	}
        	
        	int j = 0, k = 0;
        	
        	char[] done = new char[28];
        	int doneIndex = 0;
        	
        	while (empty > 0) {
        		boolean found = false;
        		if (grid[j][k] != '?') {
        			for (int n = 0; n < 28; n++) {
        				if (grid[j][k] == done[n]) {
        					found = true;
        					break;
        				}
        			} 
        			if (!found) {
        				char curCh = grid[j][k];
        				done[doneIndex] = curCh;
        				doneIndex++;
        				int[] bounds = new int[4];
        				bounds[0] = bounds[2] = j;
        				bounds[1] = bounds[3] = k;

        				for (int l = k - 1; l >= 0; l--) {
        					if (grid[j][l] == '?') {
        						grid[j][l] = curCh;
        						bounds[1] = l;
        						empty--;
        					}
        					else {
        						break;
        					}
        				}

        				for (int l = k + 1; l < c; l++) {
        					if (grid[j][l] == '?') {
        						grid[j][l] = curCh;
        						bounds[3] = l;
        						empty--;
        					}
        					else {
        						break;
        					}
        				}

        				boolean rowOK = true;
        				for (int l = j - 1; l >= 0; l--) {
        					boolean ok = true;
        					for (int m = bounds[1]; m <= bounds[3]; m++) {
        						if (grid[l][m] != '?') {
        							ok = false;
        							rowOK = false;
        							break;
        						}
        					}
        					if (ok == true) {
        						for (int m = bounds[1]; m <= bounds[3]; m++) {
        							grid[l][m] = curCh;
        							empty--;
        						}
        						bounds[0] = l;
        					}
        					if (!rowOK)
        						break;
        				}

        				rowOK = true;
        				for (int l = j + 1; l < r; l++) {
        					boolean ok = true;
        					for (int m = bounds[1]; m <= bounds[3]; m++) {
        						if (grid[l][m] != '?') {
        							ok = false;
        							rowOK = false;
        							break;
        						}
        					}
        					if (ok == true) {
        						for (int m = bounds[1]; m <= bounds[3]; m++) {
        							grid[l][m] = curCh;
        							empty--;
        						}
        						bounds[2] = l;
        					}
        					if (!rowOK)
        						break;
        				}
        			}
        		}
        		
        		k++;
        		if (k >= c) {
        			k = 0;
        			j++;
        			if (j >= r)
        				j++;
        		}
        	}
        	
        	out.println("Case #" + i + ":");
        	for (int l = 0; l < r; l++)
        		out.println(grid[l]);
        }
        br.close();
        out.close();
        System.out.println("Finished");
    }    

    static String nxtTok() throws IOException {
        while (!sc.hasMoreTokens()) {
            String s = br.readLine();
            if (s == null) {
                return null;
            }
            sc = new StringTokenizer(s.trim());
        }
        return sc.nextToken();
    }

    static int nxtInt() throws IOException {
        return Integer.parseInt(nxtTok());
    }

    static long nxtLng() throws IOException {
        return Long.parseLong(nxtTok());
    }

    static double nxtDbl() throws IOException {
        return Double.parseDouble(nxtTok());
    }

    static int[] nxtIntArr(int n) throws IOException {
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nxtInt();
        }
        return a;
    }

    static long[] nxtLngArr(int n) throws IOException {
        long[] a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nxtLng();
        }
        return a;
    }

    static char[] nxtCharArr() throws IOException {
        return nxtTok().toCharArray();
    }
    
    static int getMin(int arr[], int count)
    {
    	int min = arr[0];
    	for (int i = 1; i < count; i++)
    		if (arr[i] < min)
    			min = arr[i];

    	return min;
    }

    static int getMax(int arr[], int count)
    {
    	int max = arr[0];
    	for (int i = 1; i < count; i++)
    		if (arr[i] > max)
    			max = arr[i];

    	return max;
    }

    static void sortAsc(int arr[], int count)
    {
        int temp;

        for (int i = 0; i < count - 1; i++)
        {
            for (int j = i + 1; j < count; j++)
            {
                if (arr[i] > arr[j])
                {
                    temp = arr[i];
                    arr[i] = arr[j];
                    arr[j] = temp;
                }
            }
        }
    }

    static void sortDesc(int arr[], int count)
    {
        int temp;

        for (int i = 0; i < count - 1; i++)
        {
            for (int j = i + 1; j < count; j++)
            {
                if (arr[i] < arr[j])
                {
                    temp = arr[i];
                    arr[i] = arr[j];
                    arr[j] = temp;
                }
            }
        }
    }
}