import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Solution4 {
	static BufferedReader br;
    static StringTokenizer sc;
    static PrintWriter out;

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new FileReader("input.in"));
        out = new PrintWriter("output.out");
        sc = new StringTokenizer("");
        int t = nxtInt();
        for (int i = 1; i <= t; i++) {
        	int n = nxtInt();
        	int m = nxtInt();
        	
        	char[][] models = new char[n][];
        	for (int j = 0; j < n; j++)
        		models[j] = new char[n];
        	for (int j = 0; j < n; j++)
        		for (int k = 0; k < n; k++)
        			models[j][k] = '.';
        	
        	for (int j = 0; j < m; j++) {
        		char ch = nxtTok().toCharArray()[0];
        		models[nxtInt() - 1][nxtInt() - 1] = ch;
        	}
        	
        	char[][] addedModels = new char[n][];
        	for (int j = 0; j < n; j++)
        		addedModels[j] = new char[n];
        	for (int j = 0; j < n; j++)
        		for (int k = 0; k < n; k++)
        			addedModels[j][k] = '.';
        	
        	int[] osInRows = new int[n];
        	for (int j = 0; j < n; j++)
        		osInRows[j] = 0;
        	
        	int[] osInCols = new int[n];
        	for (int j = 0; j < n; j++)
        		osInCols[j] = 0;
        	
        	int[] xsInRows = new int[n];
        	for (int j = 0; j < n; j++)
        		xsInRows[j] = 0;
        	
        	int[] xsInCols = new int[n];
        	for (int j = 0; j < n; j++)
        		xsInCols[j] = 0;
        	
        	for (int j = 0; j < n; j++) {
        		for (int k = 0; k < n; k++) {
        			if (models[j][k] == 'o') {
        				osInRows[j]++;
        				osInCols[k]++;
        			}
        			else if (models[j][k] == 'x') {
        				xsInRows[j]++;
        				xsInCols[k]++;
        			}
        		}
        	}
        	
        	for (int j = 0; j < n; j++) {
        		for (int k = 0; k < n; k++) {
        			if (models[j][k] == '+') {
        				boolean canBeO = true;
        				if (osInRows[j] + osInCols[k] + xsInRows[j] + xsInCols[k] != 0) {
        					canBeO = false;
        				}
        				
        				int row = j - 1;
        				int col = k - 1;
        				while (row >= 0 && col >= 0) {
        					if (models[row][col] == 'o' || models[row][col] == '+') {
        						canBeO = false;
        					}
        					row--;
        					col--;
        				}
        				row = j + 1;
        				col = k + 1;
        				while (row < n && col < n) {
        					if (models[row][col] == 'o' || models[row][col] == '+') {
        						canBeO = false;
        					}
        					row++;
        					col++;
        				}
        				row = j - 1;
        				col = k + 1;
        				while (row >= 0 && col < n) {
        					if (models[row][col] == 'o' || models[row][col] == '+') {
        						canBeO = false;
        					}
        					row--;
        					col++;
        				}
        				row = j + 1;
        				col = k - 1;
        				while (row < n && col >= 0) {
        					if (models[row][col] == 'o' || models[row][col] == '+') {
        						canBeO = false;
        					}
        					row++;
        					col--;
        				}
        				
        				if (canBeO) {
        					models[j][k] = 'o';
        					addedModels[j][k] = 'o';
        					osInRows[j]++;
        					osInCols[k]++;
        				}
        			}

        			else if (models[j][k] == 'x') {
        				boolean canBeO = true;
        				if (osInRows[j] + osInCols[k] + xsInRows[j] + xsInCols[k] != 0) {
        					canBeO = false;
        				}
        				
        				int row = j - 1;
        				int col = k - 1;
        				while (row >= 0 && col >= 0) {
        					if (models[row][col] == 'o' || models[row][col] == '+') {
        						canBeO = false;
        					}
        					row--;
        					col--;
        				}
        				row = j + 1;
        				col = k + 1;
        				while (row < n && col < n) {
        					if (models[row][col] == 'o' || models[row][col] == '+') {
        						canBeO = false;
        					}
        					row++;
        					col++;
        				}
        				row = j - 1;
        				col = k + 1;
        				while (row >= 0 && col < n) {
        					if (models[row][col] == 'o' || models[row][col] == '+') {
        						canBeO = false;
        					}
        					row--;
        					col++;
        				}
        				row = j + 1;
        				col = k - 1;
        				while (row < n && col >= 0) {
        					if (models[row][col] == 'o' || models[row][col] == '+') {
        						canBeO = false;
        					}
        					row++;
        					col--;
        				}
        				
        				if (canBeO) {
        					models[j][k] = 'o';
        					addedModels[j][k] = 'o';
        					osInRows[j]++;
        					osInCols[k]++;
        				}
        			}
        			else if (models[j][k] == '.') {
        				boolean canBeO = true;
        				boolean canBePlus = true;
        				boolean canBeX = true;
        				if (osInRows[j] + osInCols[k] + xsInRows[j] + xsInCols[k] != 0) {
        					canBeO = false;
        					canBeX = false;
        				}
        				
        				int row = j - 1;
        				int col = k - 1;
        				while (row >= 0 && col >= 0) {
        					if (models[row][col] == 'o' || models[row][col] == '+') {
        						canBeO = false;
        						canBePlus = false;
        					}
        					row--;
        					col--;
        				}
        				row = j + 1;
        				col = k + 1;
        				while (row < n && col < n) {
        					if (models[row][col] == 'o' || models[row][col] == '+') {
        						canBeO = false;
        						canBePlus = false;
        					}
        					row++;
        					col++;
        				}
        				row = j - 1;
        				col = k + 1;
        				while (row >= 0 && col < n) {
        					if (models[row][col] == 'o' || models[row][col] == '+') {
        						canBeO = false;
        						canBePlus = false;
        					}
        					row--;
        					col++;
        				}
        				row = j + 1;
        				col = k - 1;
        				while (row < n && col >= 0) {
        					if (models[row][col] == 'o' || models[row][col] == '+') {
        						canBeO = false;
        						canBePlus = false;
        					}
        					row++;
        					col--;
        				}
        				
        				if (canBeO) {
        					models[j][k] = 'o';
        					addedModels[j][k] = 'o';
        					osInRows[j]++;
        					osInCols[k]++;
        				}
        				else if (canBePlus) {
        					models[j][k] = '+';
        					addedModels[j][k] = '+';
        				}
        				else if (canBeX) {
        					models[j][k] = 'x';
        					addedModels[j][k] = 'x';
        					xsInRows[j]++;
        					xsInCols[k]++;
        				}
        			}
        			
        			
        		}
        	}
        	
        	int stylePoints = 0;
        	int added = 0;
        	
        	for (int j = 0; j < n; j++) {
        		for (int k = 0; k < n; k++) {
        			if (models[j][k] == 'o')
        				stylePoints += 2;
        			else if (models[j][k] == '+' || models[j][k] == 'x')
        				stylePoints++;
        			if(addedModels[j][k] != '.')
        				added++;
        		}
        	}
        	
        	out.println("Case #" + i + ": " + stylePoints + " " + added);
        	for (int j = 0; j < n; j++) {
        		for (int k = 0; k < n; k++) {
        			if (addedModels[j][k] != '.') {
        				out.println(addedModels[j][k] + " " + (j + 1) + " " + (k + 1));
        			}
        		}
        	}
        }
        br.close();
        out.close();
        System.out.println("Finished");
    }    

    static String nxtTok() throws IOException {
        while (!sc.hasMoreTokens()) {
            String s = br.readLine();
            if (s == null) {
                return null;
            }
            sc = new StringTokenizer(s.trim());
        }
        return sc.nextToken();
    }

    static int nxtInt() throws IOException {
        return Integer.parseInt(nxtTok());
    }

    static long nxtLng() throws IOException {
        return Long.parseLong(nxtTok());
    }

    static double nxtDbl() throws IOException {
        return Double.parseDouble(nxtTok());
    }

    static int[] nxtIntArr(int n) throws IOException {
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nxtInt();
        }
        return a;
    }

    static long[] nxtLngArr(int n) throws IOException {
        long[] a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nxtLng();
        }
        return a;
    }

    static char[] nxtCharArr() throws IOException {
        return nxtTok().toCharArray();
    }
    
    static int getMin(int arr[], int count)
    {
    	int min = arr[0];
    	for (int i = 1; i < count; i++)
    		if (arr[i] < min)
    			min = arr[i];

    	return min;
    }

    static int getMax(int arr[], int count)
    {
    	int max = arr[0];
    	for (int i = 1; i < count; i++)
    		if (arr[i] > max)
    			max = arr[i];

    	return max;
    }

    static void sortAsc(int arr[], int count)
    {
        int temp;

        for (int i = 0; i < count - 1; i++)
        {
            for (int j = i + 1; j < count; j++)
            {
                if (arr[i] > arr[j])
                {
                    temp = arr[i];
                    arr[i] = arr[j];
                    arr[j] = temp;
                }
            }
        }
    }

    static void sortDesc(int arr[], int count)
    {
        int temp;

        for (int i = 0; i < count - 1; i++)
        {
            for (int j = i + 1; j < count; j++)
            {
                if (arr[i] < arr[j])
                {
                    temp = arr[i];
                    arr[i] = arr[j];
                    arr[j] = temp;
                }
            }
        }
    }
}