package codejam2014.qualification.d;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Arrays;

public class DecilfulWar {
	public static final String FOLDER = DecilfulWar.class.getSimpleName();

	public static void main(String[] args) throws Exception {
		BufferedReader input = new BufferedReader(new FileReader(FOLDER+"/in.txt"));
		//	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

		BufferedWriter output = new BufferedWriter(new FileWriter(FOLDER+"/out.txt"));
		//	BufferedWriter output = new BufferedWriter(new OutputStreamWriter(System.out));

		final int T = Integer.parseInt(input.readLine());

		for (int i = 0; i < T; i++) {
			StringBuilder sb = new StringBuilder();
			sb.append("Case #").append(i + 1).append(": ").append(solve(input)).append("\n");
			output.write(sb.toString());
		}
		output.flush();
		input.close();
		output.close();
	}

	private static String solve(BufferedReader in) throws IOException {
		int N = s2i (in.readLine());
		double[] naomi = as2ad(in.readLine().trim().split(" "));
		Arrays.sort(naomi);
		double[] ken = as2ad(in.readLine().trim().split(" "));
		Arrays.sort(ken);
	
		int w = countWar(naomi, ken);
		int dw = countdDWar(naomi, ken);
		
		
		return dw + " " + w;
		
	}


	private static int countdDWar(double[] naomi, double[] ken) {
		int N = naomi.length;
		int na = 0;
		int ke = 0;
		
		int result = 0;
		while (na < N && ke < N) {
			if (naomi[na] > ken[ke]) {
				result++;
				na++;
				ke++;
				continue;
			} 
			
			na++;	
		}
		
		return result;
	}

	private static int countWar(double[] naomi, double[] ken) {
		int N = naomi.length;
		int na = 0;
		int ke = 0;
		
		
		while (na < N && ke < N) {
			if (ken[ke] < naomi[na]) {
				ke++;
				continue;
			}
			ke++;
			na++;
		}
		
		return N - na;
	}

	private static double[] as2ad(String[] as) {
		double[] ad = new double[as.length];
		for (int i = 0; i < as.length; i++) 
			ad[i] = Double.parseDouble(as[i]);
		
		return ad;
	}

	private static int[] as2ai(String[] as) {
		int[] ai = new int[as.length];
		for (int i = 0; i < as.length; i++) {
			ai[i] = s2i(as[i]);
		}
		return ai;
	}
	private static int s2i(String s) {
		return Integer.parseInt(s.trim());
	}

}

