package gcj2011.round1b;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Primeiro {

	private static final String ARQ_IN = "src/gcj2011/round1b/primeiroIn.txt";
	private static final String ARQ_OUT = "src/gcj2011/round1b/primeiroOut.txt";
	
	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File(ARQ_IN));
		PrintWriter printer = new PrintWriter(new File(ARQ_OUT));
		
		long numTestCases = Long.parseLong(sc.nextLine().trim());
		
		for (long i = 0; i < numTestCases; i++) {
			System.out.printf("Case #%d: \n", i + 1);
			printer.printf("Case #%d: \n", i + 1);
			resolve(sc, printer);
		}
		printer.close();
		sc.close();
	}
	
	private static void resolve(Scanner sc, PrintWriter printer) {
		int n = Integer.parseInt(sc.nextLine().trim());
		double[] pontos = new double[n];
		int[] jogados = new int[n];
		int[] ganhos = new int[n];
		
		
		Integer[][] tabela = new Integer[n][n];
		for (int i =0; i < n; i++) {
			String linha = sc.nextLine().trim();
			for (int j = 0; j < n; j++) {
				char carac = linha.charAt(j);
				if (carac != '.') {
					if (carac == '1') {
						tabela[i][j] = 1;
						ganhos[i]++;
					}
					if (carac == '0') {
						tabela[i][j] = 0;
					}
					jogados[i]++;
				}
			}
		}
		
		for (int i=0; i < n; i++) {
			double media = 1.0 * ganhos[i] / jogados[i];
			pontos[i] = 0.25 * media;
		}
		
		
		Double[][] tabelaOwp = new Double[n][n];
		double[] owp = new double[n];
		int[] owpJogados = new int[n];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i != j) {
					if (tabela[i][j]!= null) {
						double somadeJexcetoI = 1.0 * (ganhos[j] - tabela[j][i]) / (jogados[j] - 1);
						tabelaOwp[i][j] = somadeJexcetoI;
						owp[i] += somadeJexcetoI;
						owpJogados[i]++;
					}
				}
			}
		}
		for (int i=0; i < n; i++) {
			owp[i] = owp[i] / owpJogados[i];
			pontos[i] += (0.5 * owp[i]);
		}
		
		int[] oowpJogados = new int[n];
		double [] oowp = new double[n];
		
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i != j) {
					if (tabela[i][j]!= null) {
						oowp[i] += owp[j];
						oowpJogados[i]++;
					}
				}
			}
		}

		for (int i=0; i < n; i++) {
			pontos[i] += (0.25 * oowp[i] / oowpJogados[i]);
			System.out.printf("%.12g\n", pontos[i]);
			printer.printf("%.12g\n", pontos[i]);
		}
		
		
		
		
	}
}
