package gcj2009.qualification.b;



import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class Watersheds {
	static int linhas, colunas;
	static Posicao[][] mapa;
	static char simboloAtual;
	
	public static void main(String[] args) throws FileNotFoundException {
//		Scanner in = new Scanner(new File("src/gcj2009/qualification/a/A-small-attempt0.in.txt"));
		Scanner in = new Scanner(new File("src/gcj2009/qualification/b/entrada.in"));
		//src/gcj2009/qualification/a/A-small-attempt0.in.txt
		
		int testes = in.nextInt();
		
		for (int i = 0; i < testes; i++) {
			System.out.println("Case #" + (i + 1) + ": ");
			
			
			linhas = in.nextInt();
			colunas = in.nextInt();
			
			mapa = new Posicao[linhas][colunas];
			for (int l = 0; l < linhas; l++) {
				for (int c = 0; c < colunas; c++) {
					mapa[l][c] = new Posicao(in.nextInt(), l, c);
				}
			}
			
			resolve(mapa, linhas, colunas);
			
			imprimeMapa();
		}
	}

	private static void imprimeMapa() {
		for (int i = 0; i < linhas; i++) { 
			for (int j = 0; j < colunas; j++) { 
				System.out.print(mapa[i][j].getLetra());
				System.out.print(' ');
			}
			System.out.println();
		}
		
	}

	private static void resolve(Posicao[][] mapa, int linhas, int colunas) {
		simboloAtual = 'a';
		for (int i = 0; i < linhas; i++) {
			for (int j = 0; j < colunas; j++) {
				marcaPosicao(mapa[i][j]);
			}
		}
	}

	
	
	private static char marcaPosicao(Posicao posicaoAtual) {
		if (posicaoAtual.getLetra() != 0) {
			return posicaoAtual.getLetra();
		}
		
		Posicao proxPosicao = achaDirecaoAgua(posicaoAtual);
		if (proxPosicao == null){
			posicaoAtual.setLetra(simboloAtual++);
		} else {
			posicaoAtual.setLetra(marcaPosicao(proxPosicao));
		}
		return posicaoAtual.getLetra();
	}

	private static Posicao achaDirecaoAgua(Posicao posicaoAtual) {
		List<Posicao> posicoes = pegaCoordenadasAdjacentes(posicaoAtual.linha, posicaoAtual.coluna);
		
		Posicao proxPosicao = null;
		for (Posicao p : posicoes) {
			if (p.getValor() < posicaoAtual.getValor()) {
				if (proxPosicao == null || proxPosicao.getValor() > p.getValor()) {
					proxPosicao = p;
				}
			}
		}
		
		return proxPosicao;
	}

	private static List<Posicao> pegaCoordenadasAdjacentes(int linha, int coluna) {
		List<Posicao> posicoes = new ArrayList<Posicao>();		
		// Norte
		Posicao nova = posicaoValida(linha -1, coluna);
		if (nova != null) 
			posicoes.add(nova);
		
		// Oeste
		nova = posicaoValida(linha, coluna - 1);
		if (nova != null) 
			posicoes.add(nova);

		// Leste
		nova = posicaoValida(linha, coluna + 1);
		if (nova != null) 
			posicoes.add(nova);
		
		// Sul
		nova = posicaoValida(linha + 1, coluna);
		if (nova != null) 
			posicoes.add(nova);

		Collections.sort(posicoes);
		return posicoes;
	}

	private static Posicao posicaoValida(int linha, int coluna) {
		if (linha < 0 || linha >= linhas)
			return null;
		if (coluna < 0 || coluna >= colunas) 
			return null;
		return mapa[linha][coluna];
	}
	
}

class Posicao implements Comparable<Posicao>{
	private final int valor;
	private char letra;
	private Posicao proxPosicao;
	public final int linha, coluna; 

	public Posicao getProxPosicao() {
		return proxPosicao;
	}



	public void setProxPosicao(Posicao proxPosicao) {
		this.proxPosicao = proxPosicao;
	}



	public Posicao(int valor, int x, int y) {
		this.valor = valor;
		this.linha = x;
		this.coluna = y;
	}

	

	public char getLetra() {
		if (proxPosicao != null) {
			return proxPosicao.getLetra();
		}
		
		return letra;
	}


	public void setLetra(char letra) {
		this.letra = letra;
	}


	public int getValor() {
		return valor;
	}



	@Override
	public int compareTo(Posicao o) {
		return getValor() - o.getValor();
	}
}