package CodeJam2;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;


public class CodeJam2 {
	private List<Integer> l1, l2;
	private int tamanho;
	
	public CodeJam2(String[] lista1, String[] lista2, int tamanho) {
		this.tamanho = tamanho;
		l1 = new ArrayList<Integer>(tamanho);
		l2 = new ArrayList<Integer>(tamanho);
		
		for (int i = 0; i < tamanho; i++) {
			l1.add(new Integer(lista1[i]));
			l2.add(new Integer(lista2[i]));
		}
	}
	
	public Long resolve() {
		long resultado = 0;
		Collections.sort(l1);
		Collections.sort(l2);
		for (int i = 0; i < tamanho; i++) {
			resultado += l1.get(i) * l2.get(tamanho - 1 - i);
		}
		return resultado;
		
	}
	
	public static void main(String[] args) {
		try {
			Scanner sc = new Scanner(new File("input.txt"));
			int nTestes = Integer.parseInt(sc.nextLine());
			EscreveEmArquivo arquivo = new EscreveEmArquivo("out.txt");

			for (int i = 0; i < nTestes; i++) {
				
				int tamVetor = Integer.parseInt(sc.nextLine());
				String[] vetor1, vetor2;
				vetor1 = sc.nextLine().split(" ");
				vetor2 = sc.nextLine().split(" ");
				CodeJam2 problema = new CodeJam2(vetor1, vetor2, tamVetor);
				
				arquivo.imprimeTeste(problema.resolve().toString());
				System.out.println();

			}
			arquivo.fecha();

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	
	
}

class EscreveEmArquivo{
	FileWriter writer;
	int nTeste;

	public EscreveEmArquivo(String nomeDoArquivo)  {
		try {
			writer = new FileWriter(new File(nomeDoArquivo));
		} catch (IOException e) {
			e.printStackTrace();
		} 

		nTeste = 1;

	}

	public void imprime(String frase) {
		try {
			writer.write(frase);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void imprimeTeste(String frase) {
		try {
			writer.write("Case #" + nTeste++ + ": " + frase + "\n");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void fecha() {
		try {
			writer.flush();
			writer.close();

		} catch (IOException e) {
			e.printStackTrace();
		}		
	}


}