package problema1;

import java.util.HashMap;
import java.util.List;

public class CentralSystem {
	private List<String> queries, engines;
	private int nQuerie, nEngine;
	private int posicao;
	
	public CentralSystem(List<String> queries, int nQuerie, List<String> engines, int nEngine) {
		this.engines = engines;
		this.nEngine = nEngine;
		this.nQuerie = nQuerie;
		this.queries = queries;
		posicao = -1;
	}
	
	public int calcSwitches() {
		String ultEngine = "";
		int count = 0;
		while (posicao < nQuerie) {
			ultEngine = caminhaAteUltimaEngine(posicao++, ultEngine);
			if (ultEngine.equals("") && (posicao == nQuerie)) {
				return count;
			}
			count++;
		}
		return count;
	}
	
	private String caminhaAteUltimaEngine(int posInicial, String ultEngine) {
		int conta = 0;
		HashMap<String, Integer> mapa = createMap();
		if (ultEngine != null && !ultEngine.equals("")) {
			mapa.put(ultEngine, new Integer("1"));
			conta++;
		}
		
		while ((conta < nEngine) && (posicao < nQuerie)) {
			if (mapa.get(queries.get(posicao)) == 0) {
				conta++;
				if (conta == nEngine) {
					return queries.get(posicao);
				}
				mapa.put(queries.get(posicao), new Integer(1));
			}
			posicao++;
		}
		return "";
	}

	private HashMap<String, Integer> createMap() {
		HashMap<String, Integer> mapa = new HashMap<String, Integer>();
		for(String engine : engines)
			mapa.put(engine, new Integer(0));
		return mapa;
	}

}
