package codejam2014.qualification.b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.text.DecimalFormat;
import java.text.Format;
import java.text.NumberFormat;

public class CookieClickerAlpha {
	public static final String FOLDER = CookieClickerAlpha.class.getSimpleName();

	public static void main(String[] args) throws Exception {
		BufferedReader input = new BufferedReader(new FileReader(FOLDER+"/in.txt"));
		//	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

		BufferedWriter output = new BufferedWriter(new FileWriter(FOLDER+"/out.txt"));
		//	BufferedWriter output = new BufferedWriter(new OutputStreamWriter(System.out));

		final int T = Integer.parseInt(input.readLine());

		for (int i = 0; i < T; i++) {
			StringBuilder sb = new StringBuilder();
			sb.append("Case #").append(i + 1).append(": ").append(solve(input)).append("\n");
			output.write(sb.toString());
		}
		output.flush();
		input.close();
		output.close();
	}

	private static String solve(BufferedReader in) throws IOException {
		
		DecimalFormat format = new DecimalFormat("0.0000000");
		String[] l = in.readLine().trim().split(" ");
		double C = Double.parseDouble(l[0]);
		double F = Double.parseDouble(l[1]);
		double X = Double.parseDouble(l[2]);
		
		double taxa = 2.0;
		double tempoEvolucao = 0.0;
		double tempoGasto = X / taxa;
		while (true) {
			double novotmpEvolucao = C / taxa;
			double novaTaxa = taxa + F;
			double novoTmpGasto = X / novaTaxa;
			double novoTempo = tempoEvolucao + novotmpEvolucao + novoTmpGasto; 
			if (tempoGasto < novoTempo) {
				return format.format(tempoGasto);
			}
			taxa = novaTaxa;
			tempoGasto = novoTempo;
			tempoEvolucao += novotmpEvolucao;
			
		}
		
		
	}
}

