package gcj.gcj2009.round1c.a;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.Scanner;

public class ProblemaA {

	private static final String ARQ_IN = "src/gcj/gcj2009/round1c/a/entradaA.txt";
	private static final String ARQ_OUT = "src/gcj/gcj2009/round1c/a/saidaA.txt";
	
	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File(ARQ_IN));
		PrintWriter printer = new PrintWriter(new File(ARQ_OUT));
		
		long numTestCases = Long.parseLong(sc.nextLine().trim());
		
		for (long i = 0; i < numTestCases; i++) {
			String tempo = sc.nextLine().trim();
			String result = resolve(tempo);
			System.out.printf("Case #%d: %s\n", i + 1, result);
			printer.printf("Case #%d: %s\n", i + 1, result);

		}
		printer.close();
		sc.close();
	}
	
	private static String resolve(String tempo) {
		HashMap<Character, Long> mapAlf = new HashMap<Character, Long>();
		
		
		char primeiro = tempo.charAt(0);
		
		for (int i = 0; i < tempo.length(); i++) {
			if (primeiro != tempo.charAt(i)) {
				mapAlf.put(tempo.charAt(i), 0L);
				break;
			}
		}
		
		if (mapAlf.size() == 0) {
			mapAlf.put(tempo.charAt(0), 1L);
			return getNumeroNaBase(tempo, mapAlf, 2);
		}
		
		long numero = 1;
		for (int i =0; i < tempo.length(); i++) {
			char carac = tempo.charAt(i);
			if (!mapAlf.containsKey(carac)) {
				mapAlf.put(carac, numero);
				numero++;
			}			
		}

		long base = numero;
		
		return getNumeroNaBase(tempo, mapAlf, base);
	}

	private static String getNumeroNaBase(String tempo,	HashMap<Character, Long> mapAlf, long base) {
		
		BigInteger result = new BigInteger("0");
		
		for (int i = 0; i < tempo.length(); i++) {
			long num = mapAlf.get(tempo.charAt(i));
			result = result.multiply(new BigInteger(Long.toString(base)));
			
			result = result.add(new BigInteger(Long.toString(num)));
		}
		
		return result.toString();
	}
}
