package qualification2015.b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class HouseOfPancakes {
	
	private static final int MAX_PANCAKES = 10;
	public static final String FOLDER = "qualification2015/b";
	
	public static void main(String[] args) throws Exception {
		BufferedReader input = new BufferedReader(new FileReader(FOLDER+"/input.txt"));
		BufferedWriter output = new BufferedWriter(new FileWriter(FOLDER+"/output.txt"));

		int n = Integer.parseInt(input.readLine());
		
		for (int i = 0; i < n; i++) {
			
			StringBuilder resposta = new StringBuilder();
			
			String solucao = solve(input);
			resposta.append("Case #").append(i +1).append(": ").append(solucao).append("\n");
			String texto = resposta.toString();
			output.write(texto);
			System.out.print(texto);
		}
		input.close();
		output.close();

	}

	private static String solve(BufferedReader input) throws IOException {
		int D = Integer.parseInt(input.readLine());
		int[] pancakes = getPancakes(input.readLine().split(" "));
		
		long breakfastTime = getMinorTime(pancakes, MAX_PANCAKES);
		
		return Long.toString(breakfastTime);
	}

	private static long getMinorTime(int[] pancakes, int position) {
		while (pancakes[position] == 0) {
			position--;
		}
		
		if (position <= 3) {
			return position;
		}
		
		int quantity = pancakes[position];
		pancakes[position] = 0;
		int middle = position / 2;
		if (position % 2 == 0) {
			pancakes[middle] += quantity ;
			pancakes[middle] += quantity ;
		} else {
			pancakes[middle] += quantity;
			pancakes[middle + 1] += quantity;
		}
		
		long doingSpecialMinute = getMinorTime(pancakes, position - 1) + quantity;
		if (doingSpecialMinute < position) {
			return doingSpecialMinute; 
		}
		
		return position;
	}

	private static int[] getPancakes(String[] array) {
		int [] pancakes = new int[MAX_PANCAKES + 1];
		for (String s : array) {
			int val = Integer.parseInt(s);
			pancakes[val]++;
		}
		return pancakes;
	}	
	
}
