package gcj2011.qualification.aBotTrust;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class BotTrust {

	private static final String ARQ_IN = "src/gcj2011/qualification/aBotTrust/entradaA.txt";
	private static final String ARQ_OUT = "src/gcj2011/qualification/aBotTrust/saidaA.txt";
	
	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File(ARQ_IN));
		PrintWriter printer = new PrintWriter(new File(ARQ_OUT));
		
		long numTestCases = Long.parseLong(sc.nextLine().trim());
		
		for (long i = 0; i < numTestCases; i++) {
			long result = resolve(sc.nextLine().trim().split(" "));
			System.out.printf("Case #%d: %s\n", i + 1, result);
			printer.printf("Case #%d: %s\n", i + 1, result);
		}
		printer.close();
		sc.close();
	}
	
	private static long resolve(String[] entradas) {
		final int OROBO = 0;
		final int BROBO = 1;
		
		// 0  o O
		// 1  o B

		int posicaoAtual = entradas.length / 2;
		int [][] posicao = new int[2][(entradas.length - 1) / 2 + 2];
		
		
		
		for (int i = entradas.length-2 ; i >0; i = i - 2) {
			int robo = OROBO;
			int roboOutro = BROBO;
			if (entradas[i].equals("B")) {
				robo = BROBO;
				roboOutro = OROBO;
			}
			posicao[robo][posicaoAtual] = Integer.parseInt(entradas[i + 1]);
			posicao[roboOutro][posicaoAtual] = posicao[roboOutro][posicaoAtual + 1] ;
			posicaoAtual--;
		}
		if (posicaoAtual != 0) {
			throw new RuntimeException("erro de indice da posicao do robo");
		}
		posicao[OROBO][posicaoAtual] = 1;
		posicao[BROBO][posicaoAtual] = 1;
		
		
		long tempo = 0;
		for (int i = 0 ; i < entradas.length - 1; i = i + 2) {
			int roboComando = OROBO;
			int roboOutro = BROBO;
			if (entradas[i  + 1].equals("B")) {
				roboComando = BROBO;
				roboOutro = OROBO;
			}
			int proxPosicao = posicaoAtual + 1;
			int tempoComando = Math.abs(posicao[roboComando][proxPosicao] - posicao[roboComando][posicaoAtual]) + 1;
			
			int outroRoboQuerAndar = posicao[roboOutro][proxPosicao] - posicao[roboOutro][posicaoAtual];
			if (Math.abs(outroRoboQuerAndar) >= tempoComando) {
				posicao[roboOutro][proxPosicao] = posicao[roboOutro][posicaoAtual] + tempoComando * (outroRoboQuerAndar > 0 ? 1 : (-1));  
			}
			tempo += tempoComando;
//			System.out.printf("[%d,%d]", posicao[OROBO][proxPosicao], posicao[BROBO][proxPosicao]);
			posicaoAtual++;
		}
		
		
		
		return tempo;
	}
}
