package gcj.gcj2009.round1c.c;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class ProblemaC {

	private static final String ARQ_IN = "src/gcj/gcj2009/round1c/c/entradaC.txt";
	private static final String ARQ_OUT = "src/gcj/gcj2009/round1c/c/saidaC.txt";
	
	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File(ARQ_IN));
		PrintWriter printer = new PrintWriter(new File(ARQ_OUT));
		
		long numTestCases = Long.parseLong(sc.nextLine().trim());
		
		for (long i = 0; i < numTestCases; i++) {
			String[] linha1 = sc.nextLine().trim().split(" ");
			String[] prisoes = sc.nextLine().trim().split(" ");
			
			long result = resolve(Integer.parseInt(linha1[0]), Integer.parseInt(linha1[1]), prisoes);
			System.out.printf("Case #%d: %s\n", i + 1, result);
			printer.printf("Case #%d: %s\n", i + 1, result);

		}
		printer.close();
		sc.close();
	}
	
	private static long resolve(int numCelas, int numPrisSoltos, String[] prisoes) {
		List<Integer> listPrisoes = new ArrayList<Integer>();
		for (String s : prisoes) {
			listPrisoes.add(Integer.parseInt(s) - 1);
		}
		
		List<Integer> celasVazias = new ArrayList<Integer>();
		celasVazias.add(-1);
		celasVazias.add(numCelas);
		
		return resolveRecursivo(numCelas, listPrisoes, celasVazias);
	}
	
	private static long resolveRecursivo(int numCelas, List<Integer> prisoes, List<Integer> celasVazias) {
		
		if (prisoes.size() == 0) {
			return 0;
		}
		
		long resp = Long.MAX_VALUE;
		
		for (Integer i : prisoes) {
			List<Integer> novaPrisao = new ArrayList<Integer>(prisoes);
			List<Integer> novasCelasVazias = new ArrayList<Integer>(celasVazias);
			novaPrisao.remove(i);
			long libera = libera(i, novasCelasVazias);
			long novoResultado = libera + resolveRecursivo(numCelas, novaPrisao, novasCelasVazias);
			if (novoResultado < resp) {
				resp = novoResultado;
			}
		}
		return resp;
	}
	
	private static long libera(int cela, List<Integer> celasVazias) {
		int celaAnt =  -1;
		int celaPos = Integer.MAX_VALUE;
		
		for (Integer i : celasVazias) {
			if (i > celaAnt && i < cela) {
				celaAnt = i;
			}
			
			if (i < celaPos && i > cela) {
				celaPos = i;
			}
		}
		
		celasVazias.add(cela);
		return celaPos - celaAnt - 2; // um cela liberada, mais um pois inclui
	}
	
	
}
