package gcj2011.round1c;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Segundo {

	private static final String ARQ_IN = "src/gcj2011/round1c/segundoIn.txt";
	private static final String ARQ_OUT = "src/gcj2011/round1c/segundoOut.txt";
	
	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File(ARQ_IN));
		PrintWriter printer = new PrintWriter(new File(ARQ_OUT));
		
		long numTestCases = Long.parseLong(sc.nextLine().trim());
		
		for (long i = 0; i < numTestCases; i++) {
			String result = resolve(sc);
			System.out.printf("Case #%d: %s\n", i + 1, result);
			printer.printf("Case #%d: %s\n", i + 1, result);
		}
		printer.close();
		sc.close();
	}
	
	private static String resolve(Scanner sc) {
		String[] primeira = sc.nextLine().split(" ");
		String[] segunda = sc.nextLine().split(" ");
		
		int n = Integer.parseInt(primeira[0]);
		BigInteger L = new BigInteger(primeira[1]);
		BigInteger H = new BigInteger(primeira[2]);
		
		List<BigInteger> frequencies  = new ArrayList<BigInteger>();
		
		
		for (int i = 0; i < n; i++) {
			if (segunda[i].equals("1"))
				continue;
			frequencies.add(new BigInteger(segunda[i]));
		}
		
		List<BigInteger> lista = new ArrayList<BigInteger>();
		
		for (int i = 0; i < frequencies.size() - 1; i++) {
			BigInteger resultMDC = mdc(frequencies.get(i), frequencies.get(i + 1));
			if (resultMDC.equals(new BigInteger("1"))) {
				lista.add(frequencies.get(i));
				lista.add(frequencies.get(i+1));
			} else {
				lista.add(resultMDC);
			}
		}
		
		BigInteger result = new BigInteger("1");
		for (BigInteger b : lista) {
			result = mmc(b, result);
		}
		
		if (result.compareTo(L) < 0) {
			Long prox = L.divide(result).longValue() + 1;
			result = result.multiply(new BigInteger(prox.toString()));
		}

		if (result.compareTo(H) > 0) {
			return "NO";
		}
		 
		return result.toString();
	}

	static BigInteger mdc(BigInteger a, BigInteger b) {
		BigInteger maior = a, menor = b;
		if (b.compareTo(a) > 0) {
			maior = b; menor = a;
		}
		BigInteger resto = maior;
		while (!resto.equals(new BigInteger("0"))) {
			maior = menor;
			menor = resto;
			resto = maior.mod(menor);
		}
		return menor;
	}
	
	static BigInteger mmc (BigInteger a, BigInteger b) {
		return a.multiply(b).divide(mdc(a,b));
	}
	
	
	
}
