package net.anzix.learn.codejam.r2_12;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.PrintStream;
import java.util.Scanner;

import net.anzix.learn.codejam.r1b12.SafetyInNumbers;

public class SwingingWild {

	private InputStream input;
	private PrintStream output;

	public SwingingWild() {

	}

	public SwingingWild(InputStream input, PrintStream output) {
		super();
		this.input = input;
		this.output = output;
	}

	public SwingingWild(File inputFile, File outputFile) throws Exception {
		this.input = new FileInputStream(inputFile);
		output = new PrintStream(outputFile);

	}

	public void run() throws Exception {
		Scanner scanner = new Scanner(input);
		int cases = scanner.nextInt();
		for (int i = 0; i < cases; i++) {
			int no = scanner.nextInt();
			int[] l = new int[no];
			int[] d = new int[no];
			for (int j = 0; j < no; j++) {
				d[j] = scanner.nextInt();
				l[j] = scanner.nextInt();
			}
			int D = scanner.nextInt();

			boolean res = check(d, l, D);
			output.printf("Case #" + (i + 1) + ": " + (res ? "YES" : "NO")
					+ "\n");
		}
		output.close();

	}

	public static void main(String[] args) {
		try {
			new SwingingWild(new File(args[0]), new File(args[1])).run();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public boolean check(int[] d, int[] l, int distance) {
		int[] solution = new int[l.length];
		
		for (int j = l.length - 1; j >= 0; j--) {
			if (distance - d[j] <= l[j]) {
				solution[j] = distance - d[j];
			}
			for (int k = j + 1; k < l.length && d[k] - d[j] <= l[j]; k++) {
				if (solution[k] > 0 && solution[k] <= d[k] - d[j]) {
					int sol = (d[k] - d[j]);
					if (solution[j] == 0 || sol < solution[j]) {
						solution[j] = sol;
					}
				}
			}
		}
		if (solution[0] == 0)
			return false;
		return solution[0] <= d[0];

	}
}
