package net.anzix.learn.codejam.qr12;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class SpeakingInTongues {
	private Map<Character, Character> codeBack = new HashMap();

	private File input;
	private PrintStream output;

	public SpeakingInTongues(File inputFile, File outputFile) throws Exception {
		this();
		this.input = inputFile;
		output = new PrintStream(outputFile);

	}

	public void run() throws Exception {
		Scanner s = new Scanner(new FileInputStream(input));
		s.useDelimiter("\n");
		int lines = s.nextInt();
		for (int i = 0; i < lines; i++) {
			output.println("Case #" + (i + 1) + ": " + translate(s.next()));
		}
		output.close();
	}

	public SpeakingInTongues() {
		codeBack.put('y', 'a');
		codeBack.put(' ', ' ');
		codeBack.put('e', 'o');
		codeBack.put('q', 'z');
		codeBack.put('z', 'q');
		addCodePage("our language is impossible to understand",
				"ejp mysljylc kd kxveddknmc re jsicpdrysi");
		addCodePage("there are twenty six factorial possibilities",
				"rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd");
		addCodePage("so it is okay if you want to just give up",
				"de kr kd eoya kw aej tysr re ujdr lkgc jv");
	}

	public static void main(String[] args) throws Exception {
		SpeakingInTongues t = new SpeakingInTongues(new File(args[0]), new File(
				"/tmp/" + SpeakingInTongues.class.getSimpleName() + ".out"));
		t.run();

	}

	private void addCodePage(String string, String string2) {
		for (int i = 0; i < string.length(); i++) {
			codeBack.put(string2.charAt(i), string.charAt(i));
		}

	}

	public String translate(String translate) {
		StringBuilder b = new StringBuilder();
		for (int i = 0; i < translate.length(); i++) {
			Character c = codeBack.get(translate.charAt(i));
			if (c == null) {
				System.out.println("No mapping for " + translate.charAt(i));
				throw new IllegalArgumentException("No mapping for "
						+ translate.charAt(i));
			}
			b.append(c);
		}
		return b.toString();

	}

	public Character getOriginalChar(char c) {
		return codeBack.get(c);
	}

}
