package watershed;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Scanner;

public class Watershed {
	
	public static final char[] alphabet = {'a','b','c','d',
			'e','f','g','h','i','j','k','l','m','n','o',
			'p','q','r','s','t','u','v','w','x','y','z'};
	
	public static void main(String args[]){
		try{
			Scanner scannerator = new Scanner(new File("B-small-attempt0.in"));
			
			int t = scannerator.nextInt();
			
			for(int i = 1; i <= t; i++){
				int h = scannerator.nextInt();
				int w = scannerator.nextInt();
				
				int[][] elevations = new int[h][w];
				char[][] basins = new char[h][w];
				boolean[] letterUsed = new boolean[26];
				
				for(int q = 0; q < h; q++){
					for(int p = 0; p < w; p++){
						elevations[q][p] = scannerator.nextInt();
						basins[q][p] = ' ';
					}
				}
				
				for(int m = 0; m < 26; m++){
					letterUsed[m] = false;
				}
				
				for(int q = 0; q < h; q++){
					for(int p = 0; p < w; p++){
						assignBasin(new LinkedList<Point>(),
								letterUsed, basins, elevations, p, q);
					}
				}
				
				System.out.println("Case #" + i + ":");
				for(int q = 0; q < h; ++q){
					for(int p = 0; p < w; p++){
						System.out.print(basins[q][p]);
						if(p < w-1){
							System.out.print(" ");
						}
					}
					System.out.println();
				}
			}
		}
		catch (FileNotFoundException e){

		}
	}
	
	public static void assignBasin(LinkedList<Point> pointsVisited, boolean[] charUsed,
			char[][] basins, int[][] elevations, int rootX, int rootY){

		if(basins[rootY][rootX] != ' '){
			Iterator<Point> it = pointsVisited.iterator();
			while(it.hasNext()){
				Point current = it.next();
				basins[current.y][current.x] = basins[rootY][rootX];
			}
			return;
		}
		
		pointsVisited.add(new Point(rootX, rootY));

		int targetX = rootX;
		int targetY = rootY;

		//North
		if(rootY > 0 && elevations[rootY -1][rootX] < elevations[targetY][targetX]){
			targetY = rootY - 1;
			targetX = rootX;
		}
		//West
		if(rootX > 0 && elevations[rootY][rootX-1] < elevations[targetY][targetX]){
			targetY = rootY;
			targetX = rootX-1;
		}
		//East
		if(rootX < elevations[0].length-1 && elevations[rootY][rootX+1] < elevations[targetY][targetX]){
			targetY = rootY;
			targetX = rootX+1;
		}
		//South
		if(rootY < elevations.length-1 && elevations[rootY +1][rootX] < elevations[targetY][targetX]){
			targetY = rootY + 1;
			targetX = rootX;
		}	
		
		if(targetX == rootX && targetY == rootY){
			char toBeUsed = ' ';
			
			for(int i = 0; toBeUsed == ' ' && i<26; i++){
				if(charUsed[i] == false){
					toBeUsed = alphabet[i];
					charUsed[i] = true;
				}
			}
			
			Iterator<Point> it = pointsVisited.iterator();
			
			while(it.hasNext()){
				Point current = it.next();
				basins[current.y][current.x] = toBeUsed;
			}
			return;
		}
		else{
			assignBasin(pointsVisited, charUsed, basins, elevations, targetX, targetY);
		}
	}
	
	static class Point{
		int x;
		int y;
		public Point(int x, int y){
			this.x = x;
			this.y = y;
		}
	}
}