package alienLanguage;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class Driver {

	public static void main(String args[]){
		try{
			Scanner s = new Scanner(new File("A-small-attempt0.in"));
			int l = s.nextInt();
			int d = s.nextInt();
			int n = s.nextInt();
			
			String[] examples = new String[d];
			
			for(int i = 0; i < d; i++){
				examples[i] = s.next();
			}
				
			for(int i = 1; i <= n; i++){
				System.out.println("Case #" + i + ": " + 
						Driver.countPossible(s.next(), examples));
			}
			
		}
		catch (FileNotFoundException e){
			System.out.println("File was not found!");
		}
	}
	
	public static int countPossible(String current, String[] knownWords){
		int count = 0;
		
		for (int i = 0; i<knownWords.length; i++){
			if(wordsAreMatched(current, knownWords[i])){
				++count;
			}
		}
		
		return count;
	}
	
	public static boolean wordsAreMatched(String current, String known){
		boolean stillValid = true;
		int j = 0;
		for(int i = 0; stillValid && i < known.length(); ++i){
			String temp = "";
			if(current.charAt(j) == '('){
				++j;
				while(current.charAt(j) != ')'){
					temp += current.substring(j, j+1);
					++j;
				}
			}
			else {temp += current.charAt(j);}
			
			stillValid = charMatch(temp, known.charAt(i));
			
			++j;
		}
		return stillValid;
	}
	
	public static boolean charMatch(String temp, char knownChar){
		for(int i = 0; i < temp.length(); i++){
			if(temp.charAt(i) == knownChar){
				return true;
			}
		}
		return false;
	}
	
	
}
