package codejam;

import java.io.*;
import java.text.*;
import java.util.*;
import java.util.regex.*;
import java.math.*;
import java.awt.*;
import java.awt.geom.*;

public class UglyNumbers {

	public static BufferedReader stdin = new BufferedReader(
			new InputStreamReader(System.in));

	public static StringTokenizer st;

	public static String TOKEN() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(stdin.readLine());
		return st.nextToken();
	}

	public static int INT() throws IOException {
		return Integer.parseInt(TOKEN());
	}

	public static double DOUBLE() throws IOException {
		return Double.parseDouble(TOKEN());
	}

	public static DecimalFormat DF = new DecimalFormat("0.000",
			new DecimalFormatSymbols(Locale.ENGLISH));

	public static BufferedWriter writer;
	public static StringBuffer sb;
	
	public static void write(String text) {
		if(sb==null)sb = new StringBuffer();
		sb.append(text);
	}
	
	public static void writeLn(String text) {
		if(sb==null)sb = new StringBuffer();
		sb.append(text);
		sb.append("\n");
	}
	
	public static void flushBuffer() throws IOException {
		writer.write(sb.toString());
		writer.flush();
	}
	
	
	public static void main(String[] args) throws Exception {
		
		stdin = new BufferedReader(new FileReader(new File("B-small-attempt0.in"))); 
		writer = new BufferedWriter(new FileWriter(new File("B-small.out")));
		
		
		// ***************************************************************
		
		int cases = INT();
		
		for(int c = 1;c<=cases;c++) {
			
			String input = TOKEN();
			
			memo = new long[input.length()][210];
			for(int i = 0;i<input.length();i++)Arrays.fill(memo[i], -1);
			
			long solution = solve(input, 0, 0);
			
			
			writeLn("Case #"+c+": "+solution);
			System.out.println("Case #"+c+": "+solution);
			
		}
		
		// ***************************************************************
		
		
		flushBuffer();
		
		
	}
	
	public static long[][] memo;
	
	public static long solve(String input, int index, int untilnow) {
		
		if(index>=input.length())return isUgly(untilnow)?1:0;
		if(memo[index][untilnow]!=-1)return memo[index][untilnow];
		
		int answer = 0;
		
		for(int end = index+1;end<=input.length();end++) {
			
			long value = Long.parseLong(input.substring(index,end));
			
			// +
			int nextnum = (int)modulo(untilnow+value,210);
			answer += solve(input,end,nextnum);
			
			// -
			if(index>0) {
				nextnum = (int)modulo(untilnow-value,210);
				answer += solve(input,end,nextnum);
			}
			
		}
		
		memo[index][untilnow] = answer;
		return answer;
		
	}
	
	public static boolean isUgly(long number) {
		if(number%2==0)return true;
		if(number%3==0)return true;
		if(number%5==0)return true;
		if(number%7==0)return true;
		return false;
	}
	
	public static long modulo(long number, long mod) {
		return ((number%mod)+mod)%mod;
	}

	// *******************************************************************
	
	// *******************************************************************
	
	
	
}
