package codejam;

import java.io.*;
import java.text.*;
import java.util.*;
import java.util.regex.*;
import java.math.*;
import java.awt.*;
import java.awt.geom.*;

public class TrainTimetable {

	public static BufferedReader stdin = new BufferedReader(
			new InputStreamReader(System.in));

	public static StringTokenizer st;

	public static String TOKEN() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(stdin.readLine());
		return st.nextToken();
	}

	public static int INT() throws IOException {
		return Integer.parseInt(TOKEN());
	}

	public static double DOUBLE() throws IOException {
		return Double.parseDouble(TOKEN());
	}

	public static DecimalFormat DF = new DecimalFormat("0.000",
			new DecimalFormatSymbols(Locale.ENGLISH));

	public static BufferedWriter writer;
	public static StringBuffer sb;
	
	public static void write(String text) {
		if(sb==null)sb = new StringBuffer();
		sb.append(text);
	}
	
	public static void writeLn(String text) {
		if(sb==null)sb = new StringBuffer();
		sb.append(text);
		sb.append("\n");
	}
	
	public static void flushBuffer() throws IOException {
		writer.write(sb.toString());
		writer.flush();
	}
	
	
	public static void main(String[] args) throws Exception {

		stdin = new BufferedReader(new FileReader(new File("B-large.in"))); 
		writer = new BufferedWriter(new FileWriter(new File("B-large.out")));
		
		
		// ***************************************************************
		int cases = INT();
		
		for(int c = 1;c<=cases;c++) {
			
			int turnaround = INT();
			
			int fA = INT();
			int fB = INT();
			
			int[][] times = new int[4][];
			times[0] = new int[fA]; // from a
			times[1] = new int[fB]; // to a
			times[2] = new int[fB]; // from b
			times[3] = new int[fA]; // to b
			
			for(int i = 0;i<fA;i++) {
				times[0][i] = timeToMinutes(TOKEN());
				times[3][i] = timeToMinutes(TOKEN())+turnaround;
			}
			
			for(int i = 0;i<fB;i++) {
				times[2][i] = timeToMinutes(TOKEN());
				times[1][i] = timeToMinutes(TOKEN())+turnaround;
			}
			
			Arrays.sort(times[0]);
			Arrays.sort(times[1]);
			Arrays.sort(times[2]);
			Arrays.sort(times[3]);
			
			
			int atA = 0;
			int atB = 0;
			int minA = 0;
			int minB = 0;
			
			int[] indices = new int[4];
			
			while(true) {
				int first = -1;
				int firstTime = Integer.MAX_VALUE;
				for(int i = 0;i<4;i++) {
					if(indices[i]>=times[i].length)continue;
					int tt = times[i][indices[i]];
					
					if(tt<firstTime) {
						firstTime = tt;
						first = i;
					}
					
					if(tt<=firstTime && i%2==1) {
						firstTime = tt;
						first = i;
					}
				}
				if(first==-1)break;
				
				if(first==0) {
					atA--;
				}
				if(first==1) {
					atA++;
				}
				if(first==2) {
					atB--;
				}
				if(first==3) {
					atB++;
				}
				
				indices[first]++;
				
				minA = Math.min(minA, atA);
				minB = Math.min(minB, atB);
				
			}
			
			int aSol = -minA;
			int bSol = -minB;
			
			System.out.println("Case #"+c+": "+aSol+" "+bSol);
			writeLn("Case #"+c+": "+aSol+" "+bSol);
			
		}
		
		// ***************************************************************
		
		
		flushBuffer();
		
		
	}
	
	public static int timeToMinutes(String time) {
		String[] clock = time.split(":");
		return Integer.parseInt(clock[0])*60 + Integer.parseInt(clock[1]);
	}

	// *******************************************************************
	
	// *******************************************************************
	
	
	
}
