import java.io.*;
import java.text.*;
import java.util.*;

public class TicTacToeTomek {

    public static final String in = "A-small-attempt1.in";
    public static final String ou = "A-small.out";

    public static final DecimalFormat DF = new DecimalFormat("0.000",new DecimalFormatSymbols(Locale.ENGLISH));
    public static final double EPSILON = 1E-9;

    public TicTacToeTomek(BufferedReader input) {
        this.input = input;
        this.outputBuilder = new StringBuilder();
    }

    public String go() throws Exception {
        // Solve problem here!
        int cases = INT();
        for(int cc = 1; cc <= cases; cc++) {

            write("Case #" + cc + ": ");

            char[][] board = new char[4][];
            for(int i = 0; i < 4 ; i++) {
                board[i] = LINE().toCharArray();
            }

            if(hasWon(board, 'X')) {
                writeln("X won");
            } else if(hasWon(board, 'O')) {
                writeln("O won");
            } else if(isGameFinished(board)) {
                writeln("Draw");
            } else {
                writeln("Game has not completed");
            }


            LINE();

        }
        return outputBuilder.toString();
    }

    private boolean isGameFinished(char[][] board) {
        for(char[] row : board) {
            for(char cell : row) {
                if(cell == '.') {
                    return false;
                }
            }
        }
        return true;
    }


    public boolean hasWon(char[][] brd, char player) {

        // Horizontal
        for(int i = 0; i < 4; i++) {
            boolean ok = true;
            for(int j = 0; j < 4; j++) {
                if(brd[i][j] != player && brd[i][j] != 'T') {
                    ok = false;
                }
            }
            if(ok)return true;
        }

        // Vertical
        for(int j = 0; j < 4; j++) {
            boolean ok = true;
            for(int i = 0; i < 4; i++) {
                if(brd[i][j] != player && brd[i][j] != 'T') {
                    ok = false;
                }
            }
            if(ok)return true;
        }

        // Diagonal 1
        boolean ok = true;
        for(int j = 0; j < 4; j++) {
            if(brd[j][j] != player && brd[j][j] != 'T') {
                ok = false;
            }
        }
        if(ok)return true;

        // Diagonal 1
        ok = true;
        for(int j = 0; j < 4; j++) {
            if(brd[j][3 - j] != player && brd[j][3 - j] != 'T') {
                ok = false;
            }
        }
        return ok;


    }


    // Scaffolding
    public static void main(String[] args) throws Exception {
        BufferedWriter output = new BufferedWriter(new FileWriter(new File(ou)));
        output.write(new TicTacToeTomek(new BufferedReader(new FileReader(new File(in)))).go());

//        BufferedWriter output = new BufferedWriter(new OutputStreamWriter(System.out));
//        output.write(new TicTacToeTomek(new BufferedReader(new InputStreamReader(System.in))).go());

        output.flush();
        output.close();
    }

    // Output methods
    StringBuilder outputBuilder = new StringBuilder();
    void write(String str) { outputBuilder.append(str); }
    void write(int num) {    outputBuilder.append(num); }
    void write(long num) {   outputBuilder.append(num); }
    void write(char ch) {    outputBuilder.append(ch); }
    void writeln(String str) { outputBuilder.append(str); outputBuilder.append("\n");}
    void writeln(int num) {    outputBuilder.append(num); outputBuilder.append("\n"); }
    void writeln(long num) {   outputBuilder.append(num); outputBuilder.append("\n"); }
    void writeln(char ch) {    outputBuilder.append(ch); outputBuilder.append("\n"); }

    // Input methods
    BufferedReader input;
    StringTokenizer st;
    String LINE() throws Exception { return input.readLine(); }
    String TOKEN() throws Exception {
        while (st == null || !st.hasMoreTokens())st = new StringTokenizer(LINE());
        return st.nextToken();
    }
    int INT() throws Exception {return Integer.parseInt(TOKEN());}
    long LONG() throws Exception {return Long.parseLong(TOKEN());}
    double DOUBLE() throws Exception {return Double.parseDouble(TOKEN());}


}
