import java.io.*;
import java.text.*;
import java.util.*;

public class BotTrust {
	
	static BufferedReader stdin;
	static StringTokenizer st;

	static String LINE() throws Exception { return stdin.readLine(); }
	static String TOKEN() throws Exception {
		while (st == null || !st.hasMoreTokens())st = new StringTokenizer(LINE());
		return st.nextToken();
	}
	static int INT() throws Exception {return Integer.parseInt(TOKEN());}
	static long LONG() throws Exception {return Long.parseLong(TOKEN());}
	static double DOUBLE() throws Exception {return Double.parseDouble(TOKEN());}

	
	static DecimalFormat DF = new DecimalFormat("0.000",new DecimalFormatSymbols(Locale.ENGLISH));
	
	
	public static void main(String[] args) throws Exception {
		String input = "A-large.in";
		String output = "A-large.out";
		stdin = new BufferedReader(new FileReader(new File(input)));
		FileWriter frw = new FileWriter(output);
		
		int cases = INT();
		int cc = 1;
		while(cases-->0) {
			System.out.println(cc);
			int N = INT();
			
			char[] side = new char[N];
			int[] btn = new int[N];
			for(int i = 0;i<N;i++) {
				side[i] = TOKEN().charAt(0);
				btn[i] = INT()-1;
			}
			
			int solution = -1;
			boolean[][][] vis = new boolean[N][100][100];
			PriorityQueue<State> queue = new PriorityQueue<State>();
			
			queue.add(new State(0,0,0,0));
			vis[0][0][0] = true;
out:		while(!queue.isEmpty()) {
				State next = queue.poll();
				
				for(int amv = -1;amv<=1;amv++) {
					if(next.a+amv<0 || next.a+amv>=100)continue;
					for(int bmv = -1;bmv<=1;bmv++) {
						if(next.b+bmv<0 || next.b+bmv>=100)continue;
						
						int na = next.a+amv;
						int nb = next.b+bmv;
						int nseq = next.seq;
						int ntime = next.time+1;
						
						if(amv==0 && side[next.seq]=='O' && btn[next.seq]==next.a) {
							// Push button
							nseq++;
						} else if(bmv==0 && side[next.seq]=='B' && btn[next.seq]==next.b) {
							// Push button
							nseq++;
						}
						if(nseq==N) {
							solution = ntime;
							break out;
						}
						
						if(vis[nseq][na][nb])continue;
						vis[nseq][na][nb] = true;
						queue.add(new State(na,nb,nseq,ntime));
					}
				}
				
			}
			frw.write("Case #"+(cc++)+": ");
			frw.write(""+solution);
			frw.write("\n");
			
		}
		frw.flush();
		frw.close();
		
		
		
	}
	
	public static class State implements Comparable<State> {
		int a, b, seq, time;
		
		State(int a, int b, int seq, int time) {
			this.a = a; 
			this.b = b;
			this.seq = seq;
			this.time = time;
		}
		
		public int compareTo(State s) {
			return this.time-s.time;
		}
	}

}
