package codejam;

import java.io.*;
import java.text.*;
import java.util.*;
import java.util.regex.*;
import java.math.*;
import java.awt.*;
import java.awt.geom.*;

public class SavingUniverse {

	public static BufferedReader stdin = new BufferedReader(
			new InputStreamReader(System.in));

	public static StringTokenizer st;

	public static String TOKEN() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(stdin.readLine());
		return st.nextToken();
	}

	public static int INT() throws IOException {
		return Integer.parseInt(TOKEN());
	}

	public static double DOUBLE() throws IOException {
		return Double.parseDouble(TOKEN());
	}

	public static DecimalFormat DF = new DecimalFormat("0.000",
			new DecimalFormatSymbols(Locale.ENGLISH));

	public static BufferedWriter writer;
	public static StringBuffer sb;
	
	public static void write(String text) {
		if(sb==null)sb = new StringBuffer();
		sb.append(text);
	}
	
	public static void writeLn(String text) {
		if(sb==null)sb = new StringBuffer();
		sb.append(text);
		sb.append("\n");
	}
	
	public static void flushBuffer() throws IOException {
		writer.write(sb.toString());
		writer.flush();
	}
	
	
	public static void main(String[] args) throws Exception {

		stdin = new BufferedReader(new FileReader(new File("A-large(2).in"))); 
		writer = new BufferedWriter(new FileWriter(new File("A-large.out")));
		
		
		// ***************************************************************
		int cases = INT();
		
		for(int c = 1;c<=cases;c++) {
			int engines = INT();
			
			HashMap<String, Integer> engInd = new HashMap<String, Integer>();
			ArrayList<Integer>[] hits = new ArrayList[engines];
			
			for(int i = 0; i<engines;i++) {
				String eng = stdin.readLine();
				engInd.put(eng, i);
				hits[i] = new ArrayList<Integer>();
			}
			
			int queries = INT();
			
			for(int i = 0;i<queries;i++) {
				String que = stdin.readLine();
				
				if(engInd.containsKey(que)) {
					
					int ind = engInd.get(que);
					hits[ind].add(i);
				}
			}
			
			for(int i = 0; i<engines;i++) {
				hits[i].add(queries);
			}
			
			// Simulate
			
			int last = 0;
			int qNum = hits[0].get(0);
			for(int i = 1; i<engines;i++) {
				int here = hits[i].get(0);
				if(here>qNum) {
					last = i;
					qNum = here;
				}
			}
			
			int switches = 0;
			
			while(true) {
				if(qNum==queries)break;
				
				int best = 0;
				int qBest= -1;
				
				for(int i = 0; i<engines;i++) {
					if(i==last)continue;
					int xx = 0;
					while(hits[i].get(xx)<=qNum)xx++;
					int here = hits[i].get(xx);
					if(here>qBest) {
						best = i;
						qBest = here;
					}
				}
				switches++;
				qNum = qBest;
				last = best;
				
				
			}
			
			writeLn("Case #"+c+": "+switches);
			System.out.println("Case #"+c+": "+switches);
			
		}
		
		// ***************************************************************
		
		
		flushBuffer();
		
		
	}

	// *******************************************************************
	
	// *******************************************************************
	
	
	
}
