package round1a;
import java.io.*;
import java.util.*;
import java.math.*;
import java.text.*;

public class Rotate {

	static DecimalFormat DF = new DecimalFormat("0.000",new DecimalFormatSymbols(Locale.ENGLISH));
	
	public static void run() throws Exception {
		
		init("A-small-attempt0");
		
		int cases = INT();
		for(int cc = 1;cc<=cases;cc++) {
			int N = INT(), K = INT();
			char[][] board = new char[N][];
			for(int i = 0;i<N;i++)board[i] = TOKEN().toCharArray();
			
			char[][] rotated = new char[N][N];
			for(char[] r : rotated)Arrays.fill(r, '.');
			for(int col = 0;col<N;col++) {
				int fromrow = N-1-col;
				int row = N-1;
				for(int fromcol = N-1;fromcol>=0;fromcol--) {
					if(board[fromrow][fromcol]=='.')continue;
					rotated[row--][col] = board[fromrow][fromcol];
				}
			}
//			for(char[] rot : rotated)System.err.println(Arrays.toString(rot));
			
			boolean red = false;
			boolean blue = false;
			
			// Horizontal
			for(int i = 0;i<N;i++) {
				int r = 0, b = 0;
				for(int j = 0;j<N;j++) {
					if(rotated[i][j]=='R')r++;
					else r = 0;
					if(rotated[i][j]=='B')b++;
					else b = 0;
					if(r>=K)red = true;
					if(b>=K)blue = true;
					
				}
			}
			
			// Vertical
			for(int i = 0;i<N;i++) {
				int r = 0, b = 0;
				for(int j = 0;j<N;j++) {
					if(rotated[j][i]=='R')r++;
					else r = 0;
					if(rotated[j][i]=='B')b++;
					else b = 0;
					if(r>=K)red = true;
					if(b>=K)blue = true;
					
				}
			}
			// Diagonal 1
			for(int i = 0;i+K<=N;i++) {
				for(int j = 0;j+K<=N;j++) {
					if(rotated[i][j]=='R') {
						int cnt = 0;
						for(int kk = 0;kk<K;kk++) {
							if(rotated[i+kk][j+kk]=='R')cnt++;
						}
						if(cnt>=K)red = true;
					} else if(rotated[i][j]=='B') {
						int cnt = 0;
						for(int kk = 0;kk<K;kk++) {
							if(rotated[i+kk][j+kk]=='B')cnt++;
						}
						if(cnt>=K)blue = true;
					}
				}
			}
			// Diagonal 1
			for(int i = K-1;i<N;i++) {
				for(int j = K-1;j<N;j++) {
					if(rotated[i][j]=='R') {
						int cnt = 0;
						for(int kk = 0;kk<K;kk++) {
							if(rotated[i-kk][j-kk]=='R')cnt++;
						}
						if(cnt>=K)red = true;
					} else if(rotated[i][j]=='B') {
						int cnt = 0;
						for(int kk = 0;kk<K;kk++) {
							if(rotated[i-kk][j-kk]=='B')cnt++;
						}
						if(cnt>=K)blue = true;
					}
				}
			}
			print("Case #"+cc+": ");
			// TODO Print output
			if(blue && red)println("Both");
			else if(blue)println("Blue");
			else if(red)println("Red");
			else println("Neither");
		}
		
	}
	
	// *************************************************************************************
	// *********************************** FRAMEWORK ***************************************
	// *************************************************************************************
	
	public static BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
	public static boolean isStandardInput = false;
	
	public static File input;
	public static FileReader inputreader;
	public static BufferedReader in;
	
	public static File output;
	public static FileWriter outputwriter;
	public static BufferedWriter out;
	
	public static StringTokenizer st;
	
	public static void main(String[] args) throws Exception {
		doSTDIN(true);
		setOutput("test.out");
		run();
		close();
	}
	
	public static void init(String problemName) throws Exception {
		doSTDIN(false);
		setInput(problemName+".in");
		setOutput(problemName+".out");
	}
	
	// **************** PRINT METHODS **********************
	
	public static void println() throws IOException {
		out.write("\n");
		System.out.println();
	}
	
	public static void println(Object obj) throws IOException {
		out.write(obj.toString());
		out.write("\n");
		System.out.println(obj.toString());
	}
	
	public static void print(Object obj) throws IOException {
		out.write(obj.toString());
		System.out.print(obj.toString());
	}
	
	public static void println(long number) throws IOException {
		out.write(Long.toString(number));
		out.write("\n");
		System.out.println(number);
	}
	
	public static void print(long number) throws IOException {
		out.write(Long.toString(number));
		System.out.print(number);
	}
	
	public static void println(char c) throws IOException {
		out.write(Character.toString(c));
		out.write("\n");
		System.out.println(c);
	}
	
	public static void print(char c) throws IOException {
		out.write(Character.toString(c));
		System.out.print(c);
	}
	
	public static void println(String line) throws IOException {
		out.write(line);
		out.write("\n");
		System.out.println(line);
	}
	
	public static void print(String line) throws IOException {
		out.write(line);
		System.out.print(line);
	}
	
	// ******************** INPUT DECLARATION ******************
	
	public static void doSTDIN(boolean standard) {
		isStandardInput = standard;
	}
	
	public static void setInput(String filename) throws IOException {
		input = new File(filename);
		inputreader = new FileReader(input);
		in = new BufferedReader(inputreader);
	}
	
	public static void setOutput(String filename) throws IOException {
		output = new File(filename);
		outputwriter = new FileWriter(output);
		out = new BufferedWriter(outputwriter);
	}
	
	public static void close() throws IOException {
		if(in!=null)in.close();
		if(inputreader!=null)inputreader.close();
		
		if(out!=null)out.flush();
		if(out!=null)out.close();
		if(outputwriter!=null)outputwriter.close();
	}
	
	// ************************** INPUT READING *****************
	
	static String LINE() throws IOException { return isStandardInput?stdin.readLine():in.readLine(); }
	static String TOKEN() throws IOException {
		while (st == null || !st.hasMoreTokens())st = new StringTokenizer(LINE());
		return st.nextToken();
	}
	static int INT() throws IOException {return Integer.parseInt(TOKEN());}
	static long LONG() throws IOException {return Long.parseLong(TOKEN());}
	static double DOUBLE() throws IOException {return Double.parseDouble(TOKEN());}
	static BigInteger BIGINT() throws IOException {return new BigInteger(TOKEN());}
	
}
