package codejam;

import java.io.*;
import java.text.*;
import java.util.*;
import java.util.regex.*;
import java.math.*;
import java.awt.*;
import java.awt.geom.*;

public class BooleanTree {

	public static BufferedReader stdin = new BufferedReader(
			new InputStreamReader(System.in));

	public static StringTokenizer st;

	public static String TOKEN() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(stdin.readLine());
		return st.nextToken();
	}

	public static int INT() throws IOException {
		return Integer.parseInt(TOKEN());
	}

	public static double DOUBLE() throws IOException {
		return Double.parseDouble(TOKEN());
	}

	public static DecimalFormat DF = new DecimalFormat("0.000",
			new DecimalFormatSymbols(Locale.ENGLISH));

	public static BufferedWriter writer;
	public static StringBuffer sb;
	
	public static void write(String text) {
		if(sb==null)sb = new StringBuffer();
		sb.append(text);
	}
	
	public static void writeLn(String text) {
		if(sb==null)sb = new StringBuffer();
		sb.append(text);
		sb.append("\n");
	}
	
	public static void flushBuffer() throws IOException {
		writer.write(sb.toString());
		writer.flush();
	}
	
	
	public static void main(String[] args) throws Exception {

		stdin = new BufferedReader(new FileReader(new File("A-small-attempt0.in")));
		writer = new BufferedWriter(new FileWriter(new File("A-small-attempt0.out")));
		
		
		// ***************************************************************
		int cases = INT();
		
		for(int c = 1;c<=cases;c++) {
			
			int nodes = INT();
			boolean desired = (INT()==1);
			
			Node[] list = new Node[nodes];
			
			for(int i = 0;i<(nodes-1)/2;i++) {
				int G = INT();
				int C = INT();
				InternalNode nn = new InternalNode(G,C);
				
				list[i] = nn;
				
				if(i>0) {
					int parent = (i-1)/2;
					boolean cB = (i/2)!=parent;
					if(cB) {
						((InternalNode)list[parent]).childB = nn;
					} else {
						((InternalNode)list[parent]).childA = nn;
					}
					
				}
				
			}
			
			for(int i = ((nodes-1)/2);i<nodes;i++) {
				int I = INT();
				Leaf nn = new Leaf(I);
				
				if(i>0) {
					int parent = (i-1)/2;
					boolean cB = (i/2)!=parent;
					
					if(cB) {
						((InternalNode)list[parent]).childB = nn;
					} else {
						((InternalNode)list[parent]).childA = nn;
					}
					
				}
				
			}
			
			Node.memo = new int[nodes][2];
			for(int i = 0;i<nodes;i++)Arrays.fill(Node.memo[i], -1);
			
			int solution = list[0].solve(desired, 0);
			
			System.out.println(solution);
			writeLn("Case #"+c+": "+((solution>=Integer.MAX_VALUE/2)?"IMPOSSIBLE":solution));
			
		}
		
		// ***************************************************************
		
		
		flushBuffer();
		
		
	}

	// *******************************************************************
	
	// *******************************************************************
	
	public static int solve(int node, boolean T) {
		return 0;
	}
	
	private static abstract class Node {
		
		public abstract int solve(boolean value, int index);
		
		public static int[][] memo;
		
	}
	
	private static class InternalNode extends Node {
		
		Node childA;
		Node childB;
		
		boolean AND;
		boolean changeable;
		
		public InternalNode(int G, int C) {
			
			this.AND = (G==1);
			this.changeable = (C==1);
			
		}
		
		public int solve(boolean value, int index) {
			
			if(memo[index][value?1:0]!=-1)return memo[index][value?1:0];
			
			int aTrue = childA.solve(true, index*2+1);
			int aFalse = childA.solve(false, index*2+1);
			int bTrue = childB.solve(true, index*2+2);
			int bFalse = childB.solve(false, index*2+2);
			
			//System.out.println(index+": ("+this.AND+"."+this.changeable+") -"+aTrue+" - "+aFalse+" - "+bTrue+" - "+bFalse);
			
			int best = Integer.MAX_VALUE / 2;
			
			if(value) {
				if(AND) {
					if(!(aTrue>=Integer.MAX_VALUE/2 || bTrue>=Integer.MAX_VALUE/2)) {
						best = Math.min(aTrue + bTrue,best);
					}
				} else {
					
					int val = Integer.MAX_VALUE / 2;
					
					val = Math.min(val, aTrue + bTrue);
	
					val = Math.min(val, aFalse + bTrue);
	
					val = Math.min(val, aTrue + bFalse);
	
					best = Math.min(best,val);
				}
				
				if(changeable) {
					if(AND) {
						int val = Integer.MAX_VALUE / 2;
						val = Math.min(val, aTrue + bTrue);
						val = Math.min(val, aFalse + bTrue);
						val = Math.min(val, aTrue + bFalse);
						
						best = Math.min(best,val+1);
					} else {
						if(!(aTrue>=Integer.MAX_VALUE/2 || bTrue>=Integer.MAX_VALUE/2)) {
							best = Math.min(best, aTrue + bTrue + 1);
						}
					}
					
				}
			} else {
				if(!AND) {
					if(!(aFalse>=Integer.MAX_VALUE/2 || bFalse>=Integer.MAX_VALUE/2)) {
						best = Math.min(aFalse + bFalse,best);
					}
				} else {
					int val = Integer.MAX_VALUE / 2;
					val = Math.min(val, aFalse + bFalse);
	
					val = Math.min(val, aTrue + bFalse);
	
					val = Math.min(val, aFalse + bTrue);
	
					best = Math.min(best,val);
				}
				
				if(changeable) {
					if(!AND) {
						int val = Integer.MAX_VALUE / 2;
						val = Math.min(val, aFalse + bFalse);
						
						val = Math.min(val, aTrue + bFalse);
		
						val = Math.min(val, aFalse + bTrue);
						
						best = Math.min(best,val+1);
					} else {
						if(!(aFalse>=Integer.MAX_VALUE/2 || bFalse>=Integer.MAX_VALUE/2)) {
							best = Math.min(aFalse + bFalse + 1,best);
						}
					}
				}
			}
			
			memo[index][value?1:0] = best;
			//System.out.println(index+", "+value+", "+best);
			
			return memo[index][value?1:0];
		}
		
	}
	
	private static class Leaf extends Node {
		
		boolean value;
		
		public Leaf(int I) {
			value = (I==1);
		}
		
		public int solve(boolean value, int index) {
			//if(index == 4)System.out.println("XXX: "+(this.value)+" "+value+" "+((this.value==value)?Integer.MAX_VALUE/2:0));
			return (this.value==value)?0:Integer.MAX_VALUE/2;
			
		}
		
	}
	
}
