package com.vairoj.codejam.y2016;

import java.io.File;
import java.util.Scanner;

public class Pancake {

    private boolean[] stack;

    public String solve(String input) {
        stack = new boolean[input.length()];
        for (int i = 0; i < input.length(); i++) {
            stack[i] = input.charAt(i) == '+';
        }

        int flipCount = 0;

        while ((stack[0] != true) || (indexOfFlip() < stack.length)) {
            // flip
            int idx = indexOfFlip();
            for (int i = 0; i < idx; i++) {
                stack[i] = !stack[i];
            }
            flipCount++;
        }

        return String.valueOf(flipCount);
    }

    private int indexOfFlip() {
        int flipIndex;
        for (flipIndex = 1; flipIndex < stack.length; flipIndex++) {
            if (stack[flipIndex] != stack[0]) { break; }
        }
        return flipIndex;
    }

    public static void main(String[] args) throws Exception {
        String fileName = args[0];
        Scanner scanner = new Scanner(new File(fileName));
        int numLines = scanner.nextInt();
        for (int i = 0; i < numLines; i++) {
            Pancake problem = new Pancake();
            String solution = problem.solve(scanner.next());
            System.out.println(String.format("Case #%d: %s", i + 1, solution));
        }
    }
}
