import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

public class SpaceEmergency {
	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		int cases = Integer.parseInt(scanner.nextLine());

		for (int cc = 1; cc <= cases; cc++) {
			System.out.print("Case #" + cc + ": ");
			String line = scanner.nextLine();
			String[] ss = line.split(" ");
			int L = Integer.parseInt(ss[0]);
			long T = Long.parseLong(ss[1]);
			int N = Integer.parseInt(ss[2]);
			int C = Integer.parseInt(ss[3]);
			int[] cs = new int[C];
			for (int i = 0; i < cs.length; i++) {
				cs[i] = Integer.parseInt(ss[4 + i]);
			}

			int[] counts = new int[C];
			Arrays.fill(counts, N / C);
			for (int i = 0; i < N % C; i++) {
				counts[i]++;
			}
			Map<Integer, Integer> countMap = new HashMap<Integer, Integer>();
			for (int i = 0; i < counts.length; i++) {
				countMap.put(cs[i], counts[i]);
			}

			long totalLength = 0;
			for (int i = 0; i < cs.length; i++) {
				totalLength += cs[i] * counts[i];
			}

			if (totalLength * 2 < T || L == 0) {
				System.out.println(totalLength * 2);
				continue;
			}

			int oneCycleLength = 0;
			for (int i = 0; i < cs.length; i++) {
				oneCycleLength += cs[i];
			}

			long cyclesBeforeFirst = T / (oneCycleLength * 2);
			long cycleRemain = T % (oneCycleLength * 2);

			long starsBeforeFirst = cyclesBeforeFirst * C;

			for (int i = 0; i < cs.length; i++) {
				if (cycleRemain >= (cs[i]*2)) {
					starsBeforeFirst++;
					cycleRemain -= (cs[i]*2);
				} else {
					break;
				}
			}

			int tFromStart = (int) cycleRemain;
			int firstPossibleC = (int) (starsBeforeFirst % cs.length);

			long firstPossibleGain = cs[firstPossibleC] - (tFromStart / 2);

			long gone = starsBeforeFirst + 1;

			long[] used = new long[cs.length];
			Arrays.fill(used, gone / cs.length);
			for (int i = 0; i < gone % cs.length; i++) {
				used[i]++;
			}
			long[] gains = new long[cs.length + 1];
			long[] possibleGainCounts = new long[cs.length + 1];
			for (int i = 0; i < cs.length; i++) {
				possibleGainCounts[i] = counts[i] - used[i];
			}
			possibleGainCounts[cs.length] = 1;

			for (int i = 0; i < cs.length; i++) {
				gains[i] = cs[i];
			}
			gains[cs.length] = firstPossibleGain;

			TreeMap<Long, Long> ggg = new TreeMap<Long, Long>();
			for (int i = 0; i < cs.length; i++) {
				ggg.put(gains[i], possibleGainCounts[i]);
			}
			if (ggg.containsKey(firstPossibleGain)) {
				ggg.put(firstPossibleGain, ggg.get(firstPossibleGain) + 1);
			} else {
				ggg.put(firstPossibleGain, 1L);
			}

			Iterator<Long> iter = ggg.descendingKeySet().iterator();

			long[] ggs = new long[ggg.size()];
			long[] ggcs = new long[ggg.size()];
			for (int i = 0; i < ggcs.length; i++) {
				long key = iter.next();
				ggs[i] = key;
				ggcs[i] = ggg.get(key);
			}

			int remainingBooster = L;
			long totalGain = 0;
			for (int i = 0; i < ggcs.length; i++) {
				if(remainingBooster <= ggcs[i]) {
					totalGain += remainingBooster * ggs[i];
					break;
				} else{
					totalGain += ggcs[i] * ggs[i];
					remainingBooster -= ggcs[i];
				}
			}
			
			System.out.println(totalLength * 2 - totalGain);

		}

	}
}
