import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.NoSuchElementException;
import java.util.Scanner;

public class C {

	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File("A.txt"));
		PrintWriter out = new PrintWriter(new File("c.txt"));

		int T = in.nextInt();
		for (int t = 1; t <= T; t++) {

			int N = in.nextInt();
			Long[] r = new Long[N];
			for (int i = 0; i < N; i++) {
				r[i] = in.nextLong();
			}

			String sol = solveCase(r);
			out.printf("Case #%d: ", t);
			out.print(sol + "\n");
		}

		out.close();
	}

	private static String solveCase(Long[] r) {

		if (!solvable(r))
			return "NO";

		PowerSet power = new PowerSet(r);

		long max = Long.MIN_VALUE;
		
		while (power.hasNext()) {
			Long o = (Long) power.next();
			if(o!=null)
			max = Math.max(o,max);
		}
				return max+"";
	}

	private static boolean solvable(Long[] r) {

		Long ans = r[0];
		for (int i = 1; i < r.length; i++) {
			ans = ans ^ r[i];
		}
		return ans == 0;
	}
}

class PowerSet {
	private boolean[] membership;
	private Long[] array;

	public PowerSet(Long[] array) {
		this.array = array;
		this.membership = new boolean[this.array.length];
	}

	public Long next() {
		boolean ok = false;
		for (int i = 0; i < this.membership.length; i++)
			if (!this.membership[i]) {
				ok = true;
				break;
			}
		if (!ok)
			throw (new NoSuchElementException("teeeeeeeeeeeeet"));
		else {
			int n = 0;
			this.membership[0] = !this.membership[0];
			boolean carry = !this.membership[0];
			while (n + 1 < this.membership.length) {
				n++;
				if (carry) {
					this.membership[n] = !this.membership[n];
					carry = !this.membership[n];
				} else
					break;
			}

			Long suma = 0l;
			Long sumb = 0l;
			Long xora = -1l;
			Long xorb = -1l;
			for (int i = 0; i < this.membership.length; i++) {
				if (this.membership[i]) {
		
					suma +=  this.array[i];
					xora =  (xora == -1 ? array[i] : xora ^ ( array[i]));
				} else {
					sumb +=  this.array[i];
					xorb =  (xorb == -1 ? array[i] : xorb ^  array[i]);
				}
			}

			if((xora^xorb)==0){
			
				return Math.max(suma, sumb);
			
			}
			return null;
		}
	}

	public boolean hasNext() {
		for (int i = 0; i < this.membership.length; i++)
			if (!this.membership[i])
				return true;
		return false;
	}
}
