import java.util.Arrays;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;
import java.util.Stack;


public class D {

	public static Chest[] chests;
	public static int[] from = new int[1 << 21];
	public static int[] open = new int[1 << 21];
	public static int[] initialKeys = new int[200];
	
	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		int T = scanner.nextInt();
		for (int t = 1; t <= T; t++) {
			Arrays.fill(initialKeys, 0);
			int K = scanner.nextInt();
			int N = scanner.nextInt();
			for (int i = 0; i < K; i++) {
				int k = scanner.nextInt();
				initialKeys[k-1]++;
			}
			chests = new Chest[N];
			for (int i = 0; i < N; i++) {
				chests[i] = new Chest();
				Chest chest = chests[i];
				chest.type = scanner.nextInt() - 1;
				int n = scanner.nextInt();
				for (int j = 0; j < n; j++) {
					int k = scanner.nextInt();
					chest.keys[k-1]++;
				}
			}
				
			int finalState = -1;
			Arrays.fill(from, -1);
			Arrays.fill(open, -1);
			Queue<Integer> q = new LinkedList<Integer>();
			for (int c = 0; c < N; c++) {
				if (initialKeys[chests[c].type] > 0) {
					int state = 1 << c;
					q.offer(state);
					from[state] = 0;
					open[state] = c;
				}
			}
			
			int[] keys = new int[200];
			BFS:
			while (!q.isEmpty()) {
				int state = q.poll();
				for (int k = 0; k < keys.length; k++)
					keys[k] = initialKeys[k];
				for (int c = 0; c < N; c++) {
					if ((state & (1 << c)) > 0) {
						Chest chest = chests[c];
						keys[chest.type]--;
						for (int k = 0; k < keys.length; k++) {
							keys[k] += chest.keys[k];
						}
					}
				}
				for (int c = 0; c < N; c++) {
					Chest chest = chests[c];
					if ((state & (1 << c)) == 0 && keys[chest.type] > 0) {
						int newState = state | 1 << c;
						if (from[newState] < 0) {
							from[newState] = state;
							open[newState] = c;
							q.offer(newState);
							if (newState == (1 << N) - 1) {
								finalState = newState;
								break BFS;
							}
						}
					}
				}
			}

			if (finalState > -1) {
				Stack<Integer> stack = new Stack<Integer>();
				int state = finalState;
				while (state != 0) {
					stack.push(open[state] + 1);
					state = from[state];
				}
				String ans = "";
				while (!stack.isEmpty()) {
					ans += " " + stack.pop();
				}
				System.out.println("Case #" + t + ":"  + ans);
			} else {
				System.out.println("Case #" + t + ": IMPOSSIBLE");
			}
		}
	}
}

class Chest {
	public int type;
	public int[] keys = new int[200];
}
