import java.util.Scanner;


public class A {
	
	public static char[][] board;
	
	public static void main(String[] args) {
		Scanner scan = new Scanner(System.in);
		int T = Integer.parseInt(scan.nextLine());
		for (int t = 1; t <= T; t++) {
			boolean incomplete = false;
			int winner = 0;
		
			board = new char[4][4];
			for (int i = 0; i < 4; i++) {
				String s = scan.nextLine();
				incomplete |= s.indexOf('.') >= 0;
				board[i] = s.toCharArray();
			}
			if (t < T)
				scan.nextLine();
			
			for (int i = 0; i < 4; i++) {
				int result = checkRow(i);
				if (result > 0) {
					winner = result;
					break;
				}
				result = checkColumn(i);
				if (result > 0) {
					winner = result;
					break;
				}
			}
			
			if (winner == 0) {
				int result = checkDiagonals();
				if (result > 0) {
					winner = result;
				}
			}
			
			String result = "";
			if (winner == 1) {
				result = "X won";
			} else if (winner == 2) {
				result = "O won";
			} else if (incomplete) {
				result = "Game has not completed";
			} else {
				result = "Draw";
			}
			
			System.out.println("Case #" + t + ": " + result);
		}
	}
	
	public static int checkRow(int row) {
		char x = board[row][0];
		if (x == 'T')
			x = board[row][1];
		if (x == '.')
			return 0;
		boolean winner = true;
		for (int i = 0; i < 4; i++) {
			winner &= board[row][i] == x || board[row][i] == 'T';
		}
		if (winner) {
			if (x == 'X')
				return 1;
			else if (x == 'O')
				return 2;
		}
		return 0;
	}
	
	public static int checkColumn(int col) {
		char x = board[0][col];
		if (x == 'T')
			x = board[1][col];
		if (x == '.')
			return 0;
		boolean winner = true;
		for (int i = 0; i < 4; i++) {
			winner &= board[i][col] == x || board[i][col] == 'T';
		}
		if (winner) {
			if (x == 'X')
				return 1;
			else if (x == 'O')
				return 2;
		}
		return 0;
	}
	
	public static int checkDiagonals() {
		int result = checkFirstDiag();
		if (result == 0)
			result = checkSecondDiag();
		return result;
	}
	
	public static int checkFirstDiag() {
		char x = board[0][0];
		if (x == 'T')
			x = board[1][1];
		if (x == '.')
			return 0;
		boolean winner = true;
		for (int i = 0; i < 4; i++) {
			winner &= board[i][i] == x || board[i][i] == 'T';
		}
		if (winner) {
			if (x == 'X')
				return 1;
			else if (x == 'O')
				return 2;
		}
		return 0;
	}
	
	public static int checkSecondDiag() {
		char x = board[3][0];
		if (x == 'T')
			x = board[2][1];
		if (x == '.')
			return 0;
		boolean winner = true;
		for (int i = 0; i < 4; i++) {
			winner &= board[3-i][i] == x || board[3-i][i] == 'T';
		}
		if (winner) {
			if (x == 'X')
				return 1;
			else if (x == 'O')
				return 2;
		}
		return 0;
	}

}
