import java.io.*;
import java.util.*;
import java.math.*;
import java.text.*;

public class GCJ_B {
	static void solve() {
		int N = Integer.parseInt(read());
		int NA, NB, t, i, ca, cb, h, m;
		ArrayList<Trip> trips = new ArrayList<Trip>();
		ArrayList<Train> ta = new ArrayList<Train>(), tb = new ArrayList<Train>(); 
		Train leaving;
		StringTokenizer tok;
		for(int T = 1; T <= N; ++T) {
			t = Integer.parseInt(read());
			tok = new StringTokenizer(read());
			NA = Integer.parseInt(tok.nextToken());
			NB = Integer.parseInt(tok.nextToken());
			trips.clear();
			ta.clear();
			tb.clear();
			for(i = 0; i < NA; ++i) {
				tok = new StringTokenizer(read(), " :");
				trips.add(new Trip(Integer.parseInt(tok.nextToken()), 
						Integer.parseInt(tok.nextToken()),
						Integer.parseInt(tok.nextToken()),
						Integer.parseInt(tok.nextToken()), "A"));
			}
			for(i = 0; i < NB; ++i) {
				tok = new StringTokenizer(read(), " :");
				trips.add(new Trip(Integer.parseInt(tok.nextToken()), 
						Integer.parseInt(tok.nextToken()),
						Integer.parseInt(tok.nextToken()),
						Integer.parseInt(tok.nextToken()), "B"));
			}
			ca = cb = 0;
			Collections.sort(trips);
			for(Trip trip : trips) {
				if(trip.from.equals("A")) {
					leaving = null;
					for(Train train : ta)
						if(train.ah < trip.dh || (train.ah == trip.dh && train.am <= trip.dm) &&
							(leaving == null || train.ah < leaving.ah || 
							(train.ah == leaving.ah && train.am < leaving.am)))
								leaving = train;
					if(leaving != null)
						ta.remove(leaving);
					else
						ca++;
					m = trip.am + t;
					h = trip.ah + (m / 60);
					m %= 60;
					tb.add(new Train(h, m));
				} else {
					leaving = null;
					for(Train train : tb)
						if(train.ah < trip.dh || (train.ah == trip.dh && train.am <= trip.dm) &&
							(leaving == null || train.ah < leaving.ah || 
							(train.ah == leaving.ah && train.am < leaving.am)))
								leaving = train;
					if(leaving != null)
						tb.remove(leaving);
					else
						cb++;
					m = trip.am + t;
					h = trip.ah + (m / 60);
					m %= 60;
					ta.add(new Train(h, m));
				}
			}
			out.println("Case #" + T + ": " + ca + " " + cb);
		}
	}
	public static void main(String[] args) throws IOException {
		in = new BufferedReader(new InputStreamReader(new FileInputStream("B-large.in")));
		out = new PrintWriter(new OutputStreamWriter(new FileOutputStream("B.out")));
		solve();
		out.flush();
	}
	static BufferedReader in;
	static PrintWriter out;
	static String read() {
		try {
			return in.readLine();
		} catch (IOException e) { return null; }
	}
}
class Trip implements Comparable<Trip> {
	int dh, dm, ah, am;
	String from;
	
	Trip(int DH, int DM, int AH, int AM, String from) {
		dh = DH;
		dm = DM;
		ah = AH;
		am = AM;
		this.from = from;
	}

	public int compareTo(Trip t) {
		if(dh != t.dh)
			return dh - t.dh;
		if(dm != t.dm)
			return dm - t.dm;
		if(ah != t.ah)
			return ah - t.ah;
		return am - t.am;
	}
	
	public String toString() {
		return from + " -> " + dh + ":" + dm + " " + ah + ":" + am;
	}
}

class Train {
	int ah, am;
	
	Train(int AH, int AM) {
		ah = AH;
		am = AM;
	}
	
	public String toString() {
		return ah + ":" + am;
	}
}