import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;


public class ProblemB {
	static int R, C;
	static int[][] m = new int[110][110];
	static int[][] filled = new int[110][110];
	static char[][] ans = new char[110][110];
	static int[] DX = {-1, 0, 0, 1};
	static int[] DY = {0, -1, 1, 0};
	static int[] DS = {3, 2, 1, 0};
	
	public static void main(String[] args) {
		Scanner scan = null;
		PrintWriter out = null;
		try {
			scan = new Scanner(new File("B-large.in"));
			out = new PrintWriter(new FileOutputStream("B-large.out"));
		} catch (Exception e) { }
		int T = scan.nextInt();
		for (int t = 1; t <= T; t++) {
			System.out.println(t);
			R = scan.nextInt();
			C = scan.nextInt();
			for (int i = 0; i < R; i++) {
				Arrays.fill(filled[i], -1);
				for (int j = 0; j < C; j++)
					m[i][j] = scan.nextInt();
			}
			int k = 0;
			for (int i = 0; i < R; i++)
				for (int j = 0; j < C; j++) {
					if (filled[i][j] > -1)
						continue;
					int w = sendsTo(i, j);
					if (w == -1)
						fill(i, j, k++);
				}
			char f = 'a';
			for (int i = 0; i < R; i++)
				for (int j = 0; j < C; j++)
					if (filled[i][j] != -1)
						fill2(i, j, f++, filled[i][j]);
			
			out.println("Case #" + t + ":");
			System.out.println("Case #" + t + ":");
			for (int i = 0; i < R; i++) {
				for (int j = 0; j < C; j++) {
					if (j > 0) {
						out.print(" ");
						System.out.print(" ");
					}
					out.print(ans[i][j]);
					System.out.print(ans[i][j]);
				}
				out.println();
				System.out.println();
			}
		}
		out.flush();
	}
	
	static void fill(int x, int y, int f) {
		filled[x][y] = f;
		for (int i = 0; i < DX.length; i++) {
			int xx = x + DX[i];
			int yy = y + DY[i];
			if (xx >= 0 && xx < R && yy >= 0 && yy < C && filled[xx][yy] == -1) {
				int w = sendsTo(xx, yy);
				if (w > -1 && DS[w] == i)
					fill(xx, yy, f);
			}
		}
	}
	
	static int sendsTo(int x, int y) {
		int min = m[x][y];
		int mini = -1;
		for (int w = 0; w < DX.length; w++) {
			int xx = x + DX[w];
			int yy = y + DY[w];
			if (xx >= 0 && xx < R && yy >= 0 && yy < C && m[xx][yy] < min) {
				min = m[xx][yy];
				mini = w;
			}
		}
		return mini;
	}
	
	static void fill2(int x, int y, char f, int v) {
		ans[x][y] = f;
		filled[x][y] = -1;
		for (int i = 0; i < DX.length; i++) {
			int xx = x + DX[i];
			int yy = y + DY[i];
			if (xx >= 0 && xx < R && yy >= 0 && yy < C && filled[xx][yy] == v)
				fill2(xx, yy, f, v);
		}
	}
}
