import java.io.*;
import java.util.*;
import java.math.*;
import java.text.*;

public class GCJR1_B {
	static final int MAX_N = 1005;
	
	static void solve() {
		int T = Integer.parseInt(read());
		int[] belongsTo = new int[MAX_N];
		boolean factors[][] = new boolean[MAX_N][MAX_N];
		TreeSet<Integer> uniqueSets = new TreeSet<Integer>();
		int A, B, P;
		int i, j, k;
		int[] f;
		boolean ok;
		StringTokenizer tok;
		for(int tt = 1; tt <= T; ++tt) {
			tok = new StringTokenizer(read());
			A = Integer.parseInt(tok.nextToken());
			B = Integer.parseInt(tok.nextToken());
			P = Integer.parseInt(tok.nextToken());
			for(i = A; i <= B; ++i) {
				Arrays.fill(factors[i], false);
				f = uniqueFactors(i);
				for(j = 0; j < f.length; ++j)
					factors[i][f[j]] = true;
				belongsTo[i] = i;
			}
			uniqueSets.clear();
			for(i = A; i <= B; ++i)
				for(j = i + 1; j <= B; ++j) {
					ok = false;
					for(k = P; k < MAX_N && !ok; ++k)
						ok = factors[i][k] && factors[j][k];
					if(ok) {
						for(k = A; k <= B; ++k)
							if(belongsTo[k] == belongsTo[j])
								belongsTo[k] = belongsTo[i];
						belongsTo[j] = belongsTo[i];
					}
				}
			for(i = A; i <= B; ++i)
				uniqueSets.add(belongsTo[i]);
			out.println("Case #" + tt + ": " + uniqueSets.size());
		}

	}
	static int[] uniqueFactors(int N) {
		ArrayList<Integer> facts = new ArrayList<Integer>();
		int d, top;
		int i;
		if ((N & 1) == 0) {
			facts.add(2);
			while ((N & 1) == 0)
				N >>= 1;
		}
		d = 3;
		top = (int)Math.sqrt(N) + 1;
		while (d <= top) {
			if (N % d == 0) {
				facts.add(d);
				while (N % d == 0)
					N /= d;
				top = (int)Math.sqrt(N) + 1;
			}
			d += 2;
		}
		if (N > 1)
			facts.add(N);
		int[] ans = new int[facts.size()];
		for (i = 0; i < ans.length; i++)
			ans[i] = facts.get(i);
		return ans;
	}

	public static void main(String[] args) throws IOException {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(new FileWriter("B-small.out"));
		solve();
		out.flush();
	}
	static BufferedReader in;
	static PrintWriter out;
	static String read() {
		try {
			return in.readLine();
		} catch (IOException e) { return null; }
	}
}
