package google.code.jam;

import java.io.File;
import java.io.FileNotFoundException;
import java.text.DecimalFormat;
import java.util.Scanner;

public class RPI {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		if (args.length != 1)
			throw new RuntimeException("Invalid argument!");
		File file = new File(args[0]);
		try {
			Scanner scanner = new Scanner(file);

			// Read number of numbers
			if (!scanner.hasNext()) {
				throw new RuntimeException("Incorrect input!");
			}
			int numberOfIterations = scanner.nextInt();

			DecimalFormat df = new DecimalFormat("#.############");

			for (int it = 0; it < numberOfIterations; it++) {
				int t = scanner.nextInt();
				char table[][] = new char[t][t];
				for (int r = 0; r < t; r++) {
					String line = scanner.next();
					char[] carr = line.toCharArray();
					for (int i = 0; i < carr.length; i++) {
						table[r][i] = carr[i];
					}
					// System.out.println(line);
				}
				TeamPoints[] teams = new TeamPoints[t];
				// WPs
				for (int i = 0; i < t; i++) {
					int sum = 0;
					int games = 0;
					for (int j = 0; j < table[i].length; j++) {
						if (table[i][j] != '.') {
							sum += table[i][j] == '1' ? 1 : 0;
							games++;
						}
					}
					teams[i] = new TeamPoints();
					teams[i].p = sum;
					teams[i].g = games;
					teams[i].wp = (double) sum / games;
				}
				// OWPs
				for (int i = 0; i < t; i++) {
					double sum = 0;
					int games = 0;
					for (int j = 0; j < table[i].length; j++) {
						if (table[i][j] != '.' && j != i) {
							sum += table[i][j] == '1' ? ((double) teams[j].p / (teams[j].g - 1))
									: ((double) (teams[j].p - 1) / (teams[j].g - 1));
							games++;
						}
					}
					teams[i].owp = (double) sum / games;
				}
				// OOWPs
				for (int i = 0; i < t; i++) {
					double sum = 0;
					int games = 0;
					for (int j = 0; j < table[i].length; j++) {
						if (table[i][j] != '.' && j != i) {
							sum += teams[j].owp;
							games++;
						}
					}
					teams[i].oowp = (double) sum / games;
				}
				System.out.println("Case #" + (it + 1) + ":");
				// RPI
				for (int i = 0; i < t; i++) {
					teams[i].rpi = 0.25d * teams[i].wp + 0.50d * teams[i].owp
							+ 0.25d * teams[i].oowp;
					System.out.println(df.format(teams[i].rpi));
				}

			}

			scanner.close();

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}

	}

	static class TeamPoints {
		double wp;
		double owp;
		double oowp;
		int p;
		int g;
		double rpi;
	}

}
