package google.code.jam;

import java.io.File;
import java.io.FileNotFoundException;
import java.text.DecimalFormat;
import java.util.Scanner;

public class SquareTiles {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		if (args.length != 1)
			throw new RuntimeException("Invalid argument!");
		File file = new File(args[0]);
		try {
			Scanner scanner = new Scanner(file);

			// Read number of numbers
			if (!scanner.hasNext()) {
				throw new RuntimeException("Incorrect input!");
			}
			int numberOfIterations = scanner.nextInt();

			DecimalFormat df = new DecimalFormat("#.############");

			for (int it = 0; it < numberOfIterations; it++) {
				int R = scanner.nextInt();
				int C = scanner.nextInt();
				char table[][] = new char[R][C];
				for (int r = 0; r < R; r++) {
					String line = scanner.next();
					char[] carr = line.toCharArray();
					for (int i = 0; i < carr.length; i++) {
						table[r][i] = carr[i];
					}
					// System.out.println(line);
				}
				boolean fail = false;
				for (int r = 0; r < R; r++) {
					for (int c = 0; c < C; c++)
						if (table[r][c] == '#') {
							// Put red:
							table[r][c] = '/';
							if ((r + 1) < R && (c + 1) < C) {
								if (table[r][c + 1] == '#') {
									table[r][c + 1] = '\\';
									if (table[r + 1][c] == '#') {
										table[r + 1][c] = '\\';
										if (table[r + 1][c + 1] == '#') {
											table[r + 1][c + 1] = '/';
										} else {
											fail = true;
										}
									} else {
										fail = true;
									}
								} else {
									fail = true;
								}
							} else {
								fail = true;
							}
							if (fail)
								break;
						}
					if (fail)
						break;
				}

				System.out.println("Case #" + (it + 1) + ":");
				if (fail) {
					System.out.println("Impossible");
				} else {
					for (int r = 0; r < R; r++) {
						for (int c = 0; c < C; c++) {
							System.out.print(table[r][c]);
						}
						System.out.println("");
					}
				}

			}

			scanner.close();

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}

	}
}
