import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;
public class CodeJam2015C {

	public static void main(String[] args) throws Exception
	{
		// TODO Auto-generated method stub
		Scanner read = new Scanner(new File("input.txt"));
		PrintWriter write = new PrintWriter("output.txt");
		int itterations = Integer.parseInt(read.nextLine());
		
		for (int i = 0; i < itterations; i++) 
		{
			int numChars = read.nextInt();
			int repetitions = read.nextInt();
			String chars = read.next();
			
			chars = compileChars(chars, repetitions);
			
			if(instantNoChecks(chars))
			{
				write.println("Case #" + (i+1) + ": NO");
				continue;
			}
			
			if(instantYes(chars))
			{
				write.println("Case #" + (i+1) + ": YES");
				continue;
			}
			
			boolean[] sign = {true};
			String reduction = "";
			int iCount = 1;
			for(; iCount < numChars * repetitions - 1; iCount++)
			{
				reduction += chars.substring(iCount - 1, iCount);
				reduction = reduce(reduction, sign);
				
				if(reduction.equals("i"))
					break;
			}
			
			if(!reduction.equals("i"))	
			{
				write.println("Case #" + (i+1) + ": NO");
				continue;
			}
			
			reduction = "";
			int jCount = iCount + 1;
			for(; jCount < numChars * repetitions; jCount++)
			{
				reduction += chars.substring(jCount - 1, jCount);
				reduction = reduce(reduction, sign);
				
				if(reduction.equals("j"))
					break;
			}

			if(!reduction.equals("j"))	
			{
				write.println("Case #" + (i+1) + ": NO");
				continue;
			}
			
			reduction = chars.substring(jCount, chars.length());
			reduction = reduce(reduction, sign);
			
			if(!reduction.equals("k"))	
			{
				write.println("Case #" + (i+1) + ": NO");
				continue;
			}
			
			if(sign[0])
				write.println("Case #" + (i+1) + ": YES");
			else
				write.println("Case #" + (i+1) + ": NO");
		}
		write.close();
		read.close();
	}
	
	private static String reduce(String s, boolean[] positive)
	{
		if(s.length() == 1) return s;
		
		String reduction = multiply(s.charAt(0), s.charAt(1), positive);
		
		if(s.length() == 2) return reduction;
		
		return reduce(reduction + s.substring(2, s.length()), positive);
	}
	
	private static String multiply(char first, char second, boolean[] sign)
	{
		if(first == second)
		{
			sign[0] = !sign[0];
			return "";
		}
		
		if(first == 'i')
		{
			if(second == 'j')
			{
				return "k";
			}
			
			if(second == 'k')
			{
				sign[0] = !sign[0];
				return "j";
			}
		}
		
		if(first == 'j')
		{
			if(second == 'i')
			{
				sign[0] = !sign[0];
				return "k";
			}
			
			if(second == 'k')
			{
				return "i";
			}
		}
		
		if(first == 'k')
		{
			if(second == 'j')
			{
				sign[0] = !sign[0];
				return "i";
			}
			
			if(second == 'i')
			{
				return "j";
			}
		}
		return ""; //shouldnt need this case....................
	}
	
	private static boolean instantYes(String chars)
	{
		return chars.equals("ijk");
	}
	
	private static String compileChars(String initChars, int reps)
	{
		String result = "";
		
		for (int i = 0; i < reps; i++) 
		{
			result += initChars;
		}
		
		return result;
	}
	
	private static boolean instantNoChecks(String chars)
	{
		if(chars.length() < 3 || charsCheckOneType(chars) || (chars.length() == 3 && charsCheckOneMiss(chars)))
			return true;
		return false;
	}
	
	private static boolean charsCheckOneType(String chars)
	{
		char initialChar = chars.charAt(0);
		for (int i = 1; i < chars.length(); i++) 
		{
			if(chars.charAt(i) != initialChar)
				return false;
		}
		return true;
	}
	
	private static boolean charsCheckOneMiss(String chars)
	{
		int iCount = 0, jCount = 0, kCount = 0;
		
		for (int i = 0; i < chars.length(); i++) 
		{
			if(chars.charAt(i) == 'i')
				iCount++;
			else if(chars.charAt(i) == 'j')
				jCount++;
			else if(chars.charAt(i) == 'k')
				kCount++;
		}
		
		if(iCount > 0 && jCount > 0 && kCount > 0)
			return false;
		
		return true;
	}
}
//I am using a few of the Java standard libraries - including java.io and java.util