package qualification;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;
import java.util.concurrent.TimeUnit;

public class JamCoins {
	
	static BigInteger BIGTWO = BigInteger.ONE.add(BigInteger.ONE);

	public static void main(String[] args) throws IOException {
		long start = System.currentTimeMillis();
		String filePartName = "C-large";
		String fileInPath = filePartName + ".in";
		String fileOutPath = filePartName + ".out";

		Scanner sc = new Scanner(new FileReader(fileInPath));
		FileWriter fOut = new FileWriter(fileOutPath);
		
		List<BigInteger> primes = new LinkedList<BigInteger>();

		int numCases = sc.nextInt();
		for (int caseNo = 1; caseNo <= numCases; caseNo++) {
			int n = sc.nextInt();
			int j = sc.nextInt();
			
			fOut.write("Case #" + caseNo + ":");
			
			String numString = "1";
			for (int k = 1; k < n - 1; k++) {
				numString += "0";
			}
			numString += "1";
			
			int coinsMade = 0;
			
			//use longs if 17 or less, otherwise use BigInteger to avoid errors
			//hackjob
			if (n <= 17) {
				while (coinsMade < j) {
					//System.out.println(numString);
					List<Long> factors = new ArrayList<Long>(9);
					boolean newCoin = true;
					for (int i = 2; i <= 10; i++) {
						Long num = Long.parseLong(numString, i);
						//System.out.println(num);
						boolean foundOne = false;
						if (num % 2 == 0) {
							factors.add(2L);
							foundOne = true;
							//System.out.println("For " + num + " there's 2");
						} else { // if it's not 2, can skip every even number
							for (long x = 3; x * x <= num; x += 2) {
								if (num % x == 0) {
									factors.add(x);
									foundOne = true;
									//System.out.println("For " + num + " there's " + x);
									break;
								}
							}
						}
						if (!foundOne) {
							//System.out.println("Lies, scandalous lies! (at base " + i + " with " + num + ")");
							newCoin = false;
							break; // this isn't a jamcoin at all!
						}
					}
					if (newCoin) {
						fOut.write("\r\n");
						fOut.write(numString);
						for (Long factor: factors) {
							fOut.write(" " + factor);
						}
						coinsMade++;
					}
					numString = Long.toBinaryString(Long.parseLong(numString, 2) + 2);
				}
			} else {
				primes.add(BIGTWO);
				primes.add(BIGTWO.add(BigInteger.ONE));
				while (coinsMade < j) {		
					//System.out.println(numString);
					List<BigInteger> factors = new ArrayList<BigInteger>(9);
					boolean newCoin = true;
					long startTime = System.currentTimeMillis();
					for (int i = 2; i <= 10; i++) {
						BigInteger num = new BigInteger(numString, i);
						//System.out.println(num);
						boolean foundOne = false;
						for (BigInteger prime: primes) {
							if (num.mod(prime) == BigInteger.ZERO) {
								factors.add(prime);
								foundOne = true;
								//System.out.println("For " + num + " there's " + prime);
								break;
							}
						} 
						if (!foundOne) {
							for (BigInteger x = primes.get(primes.size() - 1).add(BIGTWO); 
									(x.multiply(x)).compareTo(num) <= 0; x = x.add(BIGTWO)) {
								if (System.currentTimeMillis() - startTime > 5000) {
									break;
								}		
								if (num.mod(x) == BigInteger.ZERO) {
									factors.add(x);
									primes.add(x);
									foundOne = true;
									System.out.println("For " + num + " there's " + x);
									break;
								}
							}
						}
						if (!foundOne) {
							//System.out.println("Lies, scandalous lies! (at base " + i + " with " + num + ")");
							newCoin = false;
							break; // this isn't a jamcoin at all!
						}
					}
					if (newCoin) {
						fOut.write("\r\n");
						fOut.write(numString);
						for (BigInteger factor: factors) {
							fOut.write(" " + factor);
						}
						coinsMade++;
						System.out.println("Total coins: " + coinsMade + " and new one is " + numString);
						System.out.println("Time taken: " + (System.currentTimeMillis() - start) + " ms");
						//System.out.println(primes);						
					}
					BigInteger tempBigInt = new BigInteger(numString, 2);
					tempBigInt = tempBigInt.add(BIGTWO);
					numString = tempBigInt.toString(2);
				}
			}
			
			
		}

		sc.close();
		fOut.close();
		System.out.println(primes);
		System.out.println("Done!");
		System.out.println("Time taken: " + (System.currentTimeMillis() - start) + " ms");
	}
	
}
