package qualification;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class BathroomStalls {

	public static void main(String[] args) throws IOException {
		long start = System.currentTimeMillis();
		String folder = "qualification/";
		String filePartName = "C-small-2-attempt0";
		String fileInPath = folder + filePartName + ".in";
		String fileOutPath = folder + filePartName + ".out";

		Scanner sc = new Scanner(new FileReader(fileInPath));
		FileWriter fOut = new FileWriter(fileOutPath);

		int numCases = sc.nextInt();
		sc.nextLine();
		for (int caseNo = 1; caseNo <= numCases; caseNo++) {
			int n = sc.nextInt();
			int k = sc.nextInt();
			// position 0 contains the number of gaps of size 0 etc
			// this will take up way too much memory in large but is fine in smaller cases
			// and more performance efficient because no sorting is needed
			
			int biggestGap = (int) Math.floor(n / 2.0);
			int[] gapsOfSizePos = new int[biggestGap + 1]; 
			
			//do first person outside loop
			gapsOfSizePos[biggestGap]++;
			gapsOfSizePos[(int) Math.floor((n - 1) / 2.0)]++;
			
			for (int i = 1; i < k - 1; i++) { // last person used for max and min, so one less at end here
				gapsOfSizePos[(int) Math.floor(biggestGap / 2.0)]++;
				gapsOfSizePos[(int) Math.floor((biggestGap - 1) / 2.0)]++;
				
				//cleanup: get rid of gap that was used
				// if no more of that size, reduce biggest gap to next available size
				if (--gapsOfSizePos[biggestGap] == 0) {
					while (gapsOfSizePos[biggestGap] == 0) {
						biggestGap--;
					}
				}
			}
			
			// do one imaginary person at end to get max and min, unless there was only one person
			int max;
			int min;
			if (k != 1) {
				max = (int) Math.floor(biggestGap / 2.0);
				min = (int) Math.floor((biggestGap - 1) / 2.0);
			} else {
				max = biggestGap;
				min = (int) Math.floor((n - 1) / 2.0);
			}
			
			
			fOut.write("Case #" + caseNo + ": " + max + " " + min + '\r' + '\n');		
			if (caseNo % 10 == 0) {
				System.out.println("Time taken: " + (System.currentTimeMillis() - start) + " ms");
				System.out.println("Case " + caseNo + " done");
			}
		}

		sc.close();
		fOut.close();
		System.out.println("Done!");
	}
	
}
