package round1a;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class AlphabetCake {

	public static void main(String[] args) throws IOException {
		long start = System.currentTimeMillis();
		String folder = "round1a/";
		String filePartName = "A-large";
		String fileInPath = folder + filePartName + ".in";
		String fileOutPath = folder + filePartName + ".out";

		Scanner sc = new Scanner(new FileReader(fileInPath));
		FileWriter fOut = new FileWriter(fileOutPath);

		int numCases = sc.nextInt();
		sc.nextLine();
		for (int caseNo = 1; caseNo <= numCases; caseNo++) {
			int r = sc.nextInt();
			int c = sc.nextInt();			
			sc.nextLine();
			
			char[][] cake = new char[r][c];
			for (int i = 0; i < r; i++) {
				cake[i] = sc.nextLine().toCharArray();
			}
			
			int blankRow = -1;
			for (int i = 0; i < r; i++) {
				char prev = '!';
				int waitingForNextInRow = -1;
				for (int j = 0; j < c; j++) {
					if (cake[i][j] != '?') {
						prev = cake[i][j];
						if (waitingForNextInRow != -1) {
							while (waitingForNextInRow < j) {
								cake[i][waitingForNextInRow++] = cake[i][j];								
							}
							waitingForNextInRow = -1;
						}
					} else {
						if (prev != '!') {
							cake[i][j] = prev;
						} else if (waitingForNextInRow == -1) {
							waitingForNextInRow = j; 
						}
					}
				}
				if (prev == '!') { //whole row is ?
					boolean solved = false;
					//check previous rows til a non ? row
					int checkRow = i - 1;
					while (checkRow >= 0 && !solved) {
						if (cake[checkRow][0] != '?') { //the row is filled in already
							solved = true;
							while (checkRow < i) {
								cake[checkRow + 1] = cake[checkRow];
								checkRow++;
							}
						}
						checkRow--;
					}
					if (!solved && blankRow == -1) { //all previous rows blank- need to fix this from future rows
						blankRow = i;
					}
				} else if (blankRow != -1) { // there are all letters in this row and we have previous blank row(s)
					while (blankRow < i) {
						cake[blankRow] = cake[i];
						blankRow++;
					}
					blankRow = -1; //reset
				}
			}
			
			
			fOut.write("Case #" + caseNo + ":" + '\r' + '\n');
			for (int i = 0; i < r; i++) {
				for (int j = 0; j < c; j++) {
					fOut.write(cake[i][j]);
				}
				fOut.write("" + '\r' + '\n');
			}
			
			if (caseNo % 10 == 0) {
				System.out.println("Time taken: " + (System.currentTimeMillis() - start) + " ms");
				System.out.println("Case " + caseNo + " done");
			}
		}

		sc.close();
		fOut.close();
		System.out.println("Done!");
	}
	
}
