import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.TreeMap;

public class CodeJam15Main {

    final static String WORK_DIR = "/Users/amit/Downloads/";
    final static String OP_DIR = "/Users/amit/Documents/workspace/CodeJam15/src/";
    final static String INPUT_FILE_NAME = "D-large.in";
    //final static String INPUT_FILE_NAME = "A-large.in";
    final static String OUTPUT_FILE_NAME = "output.txt";
    
	public static void main(String arg[]) throws IOException
	{
		Scanner sc = new Scanner(new FileReader(WORK_DIR + INPUT_FILE_NAME));
        PrintWriter pw = new PrintWriter(new FileWriter(OP_DIR  + OUTPUT_FILE_NAME));
        
        int cases = sc.nextInt();
        
        for (int caseNum = 0; caseNum < cases; caseNum++) {
        	
            pw.print("Case #" + (caseNum + 1) + ": ");
            
            // Problem A
            //int maxShy = sc.nextInt();
            //String people = sc.nextLine();
            //int invite = solveStandingOvation(maxShy, people);
            
            //Problem B
            //int filledPlates = sc.nextInt();
            //TreeMap<Integer,Integer> tm = new TreeMap<Integer,Integer>(Collections.reverseOrder());
            
            //while(filledPlates!=0)
            //{
            //	int panCakesInPlate = sc.nextInt();
            //	tm.put(panCakesInPlate,tm.getOrDefault(panCakesInPlate, 0) + 1);
            //	filledPlates--;
            //}
            
            //int howFast = solvePancakes(tm);
            //pw.println(howFast);
            
            // D
            int X = sc.nextInt();
            int R = sc.nextInt();
            int C = sc.nextInt();
            
            String winner = solveOmino(X,R,C);
            pw.println(winner);
        }
        
        pw.flush();
        pw.close();
        sc.close();
	}
	
	public static String solveOmino(int X,int xR, int xC)
	{
		int R = Math.max(xR, xC);
		int C = Math.min(xR, xC);
		int total = R*C;
		
		if( X >= 7 || X > R || total % X != 0 || (X >= 2*C && X>2))
		{
			return "RICHARD";
		}
		
		return "GABRIEL";
	}
	
	public static int solvePancakes(TreeMap<Integer,Integer> tm)
	{
		int specialMinutes = 0;
		boolean useSpecialMinute = true;
		while(useSpecialMinute)
		{
			int largestPlateSize = tm.firstKey();
			int noOfLargestPlates = tm.get(largestPlateSize);
			
			int biggerPart =  (int)Math.ceil(largestPlateSize/2.0);
			int smallerPart = largestPlateSize - biggerPart;
			
			Integer nextBiggestPlate = tm.higherKey(largestPlateSize);
			if(nextBiggestPlate == null)
			{
				nextBiggestPlate = Integer.MIN_VALUE;
			}
			
			nextBiggestPlate = Math.max(nextBiggestPlate, biggerPart);
			
			if(nextBiggestPlate + noOfLargestPlates <= largestPlateSize)
			{
				tm.remove(largestPlateSize);
				int totalBiggerPartPlates = noOfLargestPlates + tm.getOrDefault(biggerPart, 0);
				tm.put(biggerPart, totalBiggerPartPlates);
				
				int totalSmallerPartPlates = noOfLargestPlates + tm.getOrDefault(smallerPart, 0);
				tm.put(smallerPart, totalSmallerPartPlates);
				
				specialMinutes += noOfLargestPlates	;
			}
			else
			{
				useSpecialMinute = false;
			}
		}
		
		int mins = tm.firstKey() + specialMinutes;
		return mins;
	}
	
	public static int solveStandingOvation(int maxShy, String people)
	{
		int offset = (int)'0';
		int standing = people.charAt(1) - offset;
		int invite = 0;
		
		for(int i=2;i<people.length();i++)
		{
			int shyLevel = i-1;
			int diff = shyLevel - standing;
			if(diff > 0)
			{
				invite += diff;
				standing += diff;
			}

			standing += (people.charAt(i) - offset);
		}
		
		return invite;
	}
}

