package com.elbr.codejam.fair;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.net.URL;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

public class Fair {
	private static String getTime(String[] params) {
		int n = Integer.parseInt(params[0]);

		List<BigInteger> ints = new LinkedList<BigInteger>();

		BigInteger gcd = null;
		BigInteger min = null;

		for (int i = 1; i <= n; i++) {
			BigInteger bigI = new BigInteger(params[i]);

			if (gcd == null) {
				gcd = bigI;
				min = bigI;
			} else {
				gcd = gcd.gcd(bigI);
				min = min.min(bigI);
			}

			ints.add(bigI);
		}

		Collections.sort(ints);

		// System.out.println(ints);

		BigInteger smallest = new BigInteger("0");
		BigInteger biggest = new BigInteger(gcd.toString());

		BigInteger step = new BigInteger(gcd.toString());
		BigInteger b = new BigInteger(gcd.toString());

		// System.out.println(gcd);

		if (gcd.intValue() == 1) {
			return (ints.get(ints.size() - 1).subtract(ints
					.get(ints.size() - 2))).subtract(gcd).toString();
		}

		do {
			BigInteger g = null;

			List<BigInteger> ints2 = new LinkedList<BigInteger>();
			for (BigInteger bigI : ints) {
				bigI = bigI.add(step);
				ints2.add(bigI);
			}

			ints.clear();
			ints.addAll(ints2);

			for (BigInteger bigI : ints) {
				if (g == null) {
					g = bigI;
				} else {
					g = g.gcd(bigI);
				}
			}

			if (biggest.compareTo(g) < 0) {
				biggest = new BigInteger(g.toString());
				smallest = new BigInteger(b.toString());
			}

			b = b.add(step);

			// System.out.println(ints);
		} while (b.compareTo(min) <= 0);

		return smallest.toString();
	}

	public static void main(String[] in) throws IOException {
		// test();

		URL file = Fair.class.getResource("B-small-attempt0.in");
		String path = file.getFile();

		BufferedReader reader = new BufferedReader(new FileReader(path));

		int numOfCases = Integer.parseInt(reader.readLine());

		for (int t = 0; t < numOfCases; t++) {
			String line = reader.readLine();
			String[] params = line.split("\\s");

			System.out.println("Case #" + (t + 1) + ": " + getTime(params));
		}
	}
}
