package com.elbr.codejam2011.round2A.a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.URL;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Arrays;
import java.util.Locale;

public class A {

	public static void main(String[] in) throws IOException {
		URL fileIn = A.class.getResource("A-large.in");
		String path = fileIn.getFile();
		BufferedReader reader = new BufferedReader(new FileReader(path));

		File fileOut = new File(A.class.getSimpleName() + ".out");
		fileOut.createNewFile();
		BufferedWriter writer = new BufferedWriter(new FileWriter(fileOut));

		int numOfCases = Integer.parseInt(reader.readLine());

		for (int t = 0; t < numOfCases; t++) {
			String line1 = reader.readLine();
			String[] params = line1.split("\\s");

			int n = Integer.parseInt(params[0]);

			Boolean[][] table = new Boolean[n][n];
			for (int i = 0; i < table.length; i++) {
				String row = reader.readLine();

				for (int j = 0; j < row.length(); j++) {
					if (row.charAt(j) == '0') {
						table[j][i] = true;
					} else if (row.charAt(j) == '1') {
						table[j][i] = false;
					}
				}
			}

			String outputLine = "Case #" + (t + 1) + ": " + answer(table);
			System.out.println(outputLine);
			writer.write(outputLine + System.getProperty("line.separator"));
		}

		reader.close();
		writer.close();
	}

	private static double getRPI(String row) {

		// double RPI = 0.25 * WP + 0.50 * OWP + 0.25 * OOWP;

		return 0;
	}

	private static String answer(Boolean[][] table) {
		String answer = "";

		NumberFormat format = DecimalFormat.getInstance(Locale.US);
		format.setMinimumFractionDigits(0);
		format.setMaximumFractionDigits(12);

		for (Boolean[] booleans : table) {
			System.out.println(Arrays.toString(booleans));
		}

		double[] wp = new double[table.length];

		int i = 0;
		for (Boolean[] booleans : table) {
			wp[i] = getWP(booleans, null);
			i++;
		}

		System.out.println(Arrays.toString(wp));

		double[] owp = new double[table.length];
		for (int j = 0; j < table.length; j++) {
			double competitors = 0;

			for (int k = 0; k < table.length; k++) {
				if (j == k)
					continue;
				if (table[j][k] == null)
					continue;
				competitors++;
				owp[j] += getWP(table[k], j);
			}

			owp[j] = owp[j] / competitors;
		}

		System.out.println(Arrays.toString(owp));

		double[] oowp = new double[table.length];
		for (int j = 0; j < table.length; j++) {
			double competitors = 0;

			for (int k = 0; k < table.length; k++) {
				if (j == k)
					continue;
				if (table[j][k] == null)
					continue;
				competitors++;
				oowp[j] += owp[k];
			}

			oowp[j] = oowp[j] / competitors;
		}

		for (int j = 0; j < wp.length; j++) {
			double RPI = 0.25 * wp[j] + 0.50 * owp[j] + 0.25 * oowp[j];
			answer += "\n" + RPI;
		}

		return answer;
	}

	private static double getWP(Boolean[] booleans, Integer ignore) {
		double games = 0, wins = 0;

		for (int i = 0; i < booleans.length; i++) {
			Boolean b = booleans[i];
			if (ignore != null && i == ignore)
				continue;
			if (b != null) {
				games++;
				if (b) {
					wins++;
				}
			}
		}

		return wins / games;
	}
}
