package ar.com.jgrande.gcj2011;

import java.io.IOException;
import java.util.ArrayDeque;
import java.util.Deque;
import java.util.HashMap;
import java.util.HashSet;

public class Magicka extends GCJUtil {
	
	private static class Pair {
		public Character c1, c2;
		
		@Override
		public boolean equals(Object obj) {
			if(obj==null || !(obj instanceof Pair)) {
				return false;
			}
			
			Pair other = (Pair)obj;
			
			return (other.c1==c1 && other.c2==c2) || (other.c1==c2 && other.c2==c1);
		}
		
		@Override
		public int hashCode() {
			return c1.hashCode() ^ c2.hashCode();
		}
	}
	
	public void run() throws IOException {
		int T = readInt();
		
		for(int t=0;t<T;t++) {
			Deque<Character> deque = new ArrayDeque<Character>();
			HashMap<Pair, Character> combs = new HashMap<Magicka.Pair, Character>();
			HashSet<Pair> ops = new HashSet<Pair>();
			String s;
			
			int C = readInt();
			for(int c=0;c<C;c++) {
				s = readString();
				Pair p = new Pair();
				p.c1 = s.charAt(0);
				p.c2 = s.charAt(1);
				combs.put(p, s.charAt(2));
			}
			
			int D = readInt();
			for(int d=0;d<D;d++) {
				s = readString();
				Pair p = new Pair();
				p.c1 = s.charAt(0);
				p.c2 = s.charAt(1);
				ops.add(p);
			}
			
			int N = readInt();
			Pair p = new Pair();
			s = readString();
			for(int i=0;i<N;i++) {
				char newElem = s.charAt(i);
				
				if(!deque.isEmpty()) {
					char topElem = deque.peekFirst();

					p.c1 = newElem;
					p.c2 = topElem;
					
					if(combs.containsKey(p)) {
						deque.pop();
						newElem = combs.get(p);
					}
					
					deque.push(newElem);
					
					for(Character elem: deque) {
						p.c1 = newElem;
						p.c2 = elem;
						if(ops.contains(p)) {
							deque.clear();
							break;
						}
					}
				} else {
					deque.push(newElem);
				}
			}
			
			System.out.print("Case #" + (t+1) + ": [");
			if(!deque.isEmpty()) {
				System.out.print(deque.removeLast());
				while(!deque.isEmpty()) {
					System.out.print(", " + deque.removeLast());
				}
			}
			System.out.println("]");
		}
	}
	
	public static void main(String[] args) throws IOException {
		new Magicka().run();
	}

}
