package org.eldavo.google;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.lang.reflect.Array;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;

/**
 * @author eldavojohn This is my pathetic attempt to get into the Google code
 *         jam! It seems that people are a bit inept in a particular alternate
 *         universe so we're going to help them out and build a scheduler type
 *         thingy that routes their search engine queries ^1 to protect them
 *         from a nasty implosion bug that the creator, wise as he is, forgot to
 *         build a try/catch block around.
 * 
 *         ^1 Unless the search engine is MSN, then we let it go through :D
 */
public class SaveTheUniverse {

	/**
	 * @param args
	 *            The only arg we're concerned with is the first one which
	 *            should contain the name of the file we want to parse inputs
	 *            from.
	 */
	public static void main(String[] args) {

		// these are some place holders we'll use later but I only want to
		// instantiate once so these variables go at the front
		int caseSize = 0;

		try {

			// an ugly one liner that reads in the file (don't ask me, Sun did
			// it!)
			BufferedReader searchFile = new BufferedReader(new FileReader(
					new File(args[0])));
			BufferedWriter outputFile = new BufferedWriter(new FileWriter(
					new File(args[0] + ".out")));

			// we can now read searchFile line by line
			// so lets find our first two valies:

			// this tells us how many cases we're going to have
			int numberOfCases = Integer.parseInt(searchFile.readLine());

			// now we get into the cases and we need to make a loop that runs
			// through each of the cases and pushes them through our logic
			// method
			for (int caseCount = 0; caseCount < numberOfCases; caseCount++) {
				
				// this integer informs us of how many search engines there are
				int numberOfEngines = Integer.parseInt(searchFile.readLine());

				// now for each of those search engines, we want to find out
				// their
				// names and log them in a hash of strings, keyed by integers
				HashMap<String, Integer> engines = new HashMap<String, Integer>();
				for (int engineCount = 0; engineCount < numberOfEngines; engineCount++) {
					engines.put(searchFile.readLine(), engineCount);
				}

				// lets get the size of this case as the next line
				caseSize = Integer.parseInt(searchFile.readLine());

				// and finally we prepare the list of searches into an array of
				// integers, notice that I find the key of the search engine
				// that matches it and replace it with a number (or -1 if it
				// matches none of them) because string compares are more
				// expensive
				int[] caseSearches = new int[caseSize];
				for (int searchCount = 0; searchCount < caseSize; searchCount++) {
					try {
						caseSearches[searchCount] = engines.get(searchFile
								.readLine());
					} catch (Exception e) {
						// something went wrong on this line so we giver it a -1
						caseSearches[searchCount] = -1;
					}
				}

				// it wasn't clear if we zero reference our cases so that should
				// explain the +1
				outputFile.write("Case #"
						+ (caseCount + 1)
						+ ": "
						+ computeMinSwitches(numberOfEngines, caseSearches, 0,
								caseSize) + "\n");
				outputFile.flush();
			}
			outputFile.close();

		} catch (Exception e) {
			// can't read the file for some reason, assume perfect input or
			// would try harder at this
			System.out.println("Could not read file!");
			e.printStackTrace();
		}

	}

	// the real recursive logic of Saving the Universe!
	private static int computeMinSwitches(int numberOfEngines, int[] searches,
			int index, int caseSize) {

		// Naively I would think this needs tabular programming but the same
		// effect can be achieved if we count how long we can go from the front
		// of the array of values and then start from the new index recursively
		// until we reach the end of the string. Basically we are trying to see
		// the optimum distance we can squeeze out of each single switch.

		// create a map to hold the engine numbers and remove them as we find
		// them but when it's the last one we stop and recursively call this
		// method
		HashSet<Integer> markers = new HashSet<Integer>();
		for (int engineCount = 0; engineCount < numberOfEngines; engineCount++) {
			markers.add(engineCount);
		}

		while (!markers.isEmpty() && index < caseSize) {
			markers.remove(searches[index]);
			index++;
		}

		// our two special termintating cases are that we don't have an empty
		// marker holder and we are at the end of the input which means we
		// return 0
		if (index >= caseSize && !markers.isEmpty()) {
			return 0;
		} else if (index >= caseSize && markers.isEmpty()) {
			// otherwise, we might be in this special case where the last
			// element actually requires a switch (this is due to my dirty -1
			// trick you see below
			return 1;
		}

		// now we got to step back so the algorithm remembers that we can
		// 'switch' from one search engine to another, we need to make the
		// switch so the routed search of the switch must be counted in the next
		// recursion ... clear as mud? good
		return computeMinSwitches(numberOfEngines, searches, index - 1,
				caseSize) + 1;
	}

}
