package org.eldavo.google;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Arrays;

/**
 * @author eldavojohn This is my pathetic attempt to get into the Google code
 *         jam! Train Timetable test.
 */
public class TrainTimetable {

	/**
	 * @param args
	 *            The only arg we're concerned with is the first one which
	 *            should contain the name of the file we want to parse inputs
	 *            from.
	 */
	public static void main(String[] args) {

		// these are some place holders we'll use later but I only want to
		// instantiate once so these variables go at the front
		int caseSize = 0;

		try {

			// an ugly one liner that reads in the file (don't ask me, Sun did
			// it!)
			BufferedReader searchFile = new BufferedReader(new FileReader(
					new File(args[0])));
			BufferedWriter outputFile = new BufferedWriter(new FileWriter(
					new File(args[0] + ".out")));

			// we can now read searchFile line by line
			// so lets find our first two values:

			// this tells us how many cases we're going to have
			int numberOfCases = Integer.parseInt(searchFile.readLine());

			// now we get into the cases and we need to make a loop that runs
			// through each of the cases and pushes them through our logic
			// method
			for (int caseCount = 0; caseCount < numberOfCases; caseCount++) {

				// this integer informs us of turnaround time for this case
				int turnaroundTime = Integer.parseInt(searchFile.readLine());

				// these next two integers inform us of trips from a to b and
				// then trips to b to a so lets parse them
				String temp = searchFile.readLine();
				int split = temp.indexOf(" ");
				String tempa = new String(temp.substring(0, split - 1));
				int a2b = Integer
						.parseInt(new String(temp.substring(0, split)));
				int b2a = Integer.parseInt(new String(temp.substring(split + 1,
						temp.length())));

				// now we need to parse the lines for each of the trips from a2b
				int[] aDepartures = new int[a2b];
				int[] bArrivals = new int[a2b];
				int[] bPrepared = new int[a2b];
				for (int a2bCount = 0; a2bCount < a2b; a2bCount++) {
					temp = searchFile.readLine();
					split = temp.indexOf(" ");
					aDepartures[a2bCount] = readTime(new String(temp.substring(
							0, split)));
					bArrivals[a2bCount] = readTime(new String(temp.substring(
							split + 1, temp.length())));
					bPrepared[a2bCount] = bArrivals[a2bCount] + turnaroundTime;
				}

				// now we need to parse the lines for each of the trips from b2a
				int[] bDepartures = new int[b2a];
				int[] aArrivals = new int[b2a];
				int[] aPrepared = new int[b2a];
				for (int b2aCount = 0; b2aCount < b2a; b2aCount++) {
					temp = searchFile.readLine();
					split = temp.indexOf(" ");
					bDepartures[b2aCount] = readTime(new String(temp.substring(
							0, split)));
					aArrivals[b2aCount] = readTime(new String(temp.substring(
							split + 1, temp.length())));
					aPrepared[b2aCount] = aArrivals[b2aCount] + turnaroundTime;
				}

				// now lets sort our lists by earliest time (order doesn't
				// really matter)
				Arrays.sort(aDepartures);
				Arrays.sort(aPrepared);
				Arrays.sort(bDepartures);
				Arrays.sort(bPrepared);

				// now let's count how many trains that need to leave as +1
				// and each train that is prepared as -1
				// for each side
				int aTotal = 0;
				int aPreparedIndex = 0;
				for (int aCount = 0; aCount < aDepartures.length;) {
					if (aPreparedIndex < aPrepared.length
							&& aPrepared[aPreparedIndex] <= aDepartures[aCount]) {
						aCount++;
						aPreparedIndex++;
					} else if (aCount < aDepartures.length){
						aTotal++;
						aCount++;
					}
				}

				int bTotal = 0;
				int bPreparedIndex = 0;
				for (int bCount = 0; bCount < bDepartures.length;) {
					if (bPreparedIndex < bPrepared.length
							&& bPrepared[bPreparedIndex] <= bDepartures[bCount]) {
						bCount++;
						bPreparedIndex++;
					} else if (bCount < bDepartures.length) {
						bTotal++;
						bCount++;
					}
				}

//				bTotal = 0;
//				aTotal = 0;
//				int aDepartureIndex = 0;
//				int bDepartureIndex = 0;
//				aPreparedIndex = 0;
//				bPreparedIndex = 0;
//				for (; aDepartureIndex < aDepartures.length
//						|| bDepartureIndex < bDepartures.length;) {
//					if (aDepartureIndex >= aDepartures.length) {
//						
//					}
//					
//					if (aDepartureIndex < aDepartures.length
//							&& bDepartureIndex < bDepartures.length
//							&& aDepartures[aDepartureIndex] <= bDepartures[bDepartureIndex]) {
//						aTotal++;
//						
//						aDepartureIndex++;
//					} else if (aDepartureIndex < aDepartures.length
//							&& bDepartureIndex < bDepartures.length
//							&& aDepartures[aDepartureIndex] > bDepartures[bDepartureIndex]) {
//					}
//				}

				if (bTotal < 0)
					bTotal = 0;
				if (aTotal < 0)
					aTotal = 0;

				// it wasn't clear if we zero reference our cases so that should
				// explain the +1
				System.out.println("Case #" + (caseCount + 1) + ": " + aTotal
						+ " " + bTotal);
				outputFile.write("Case #" + (caseCount + 1) + ": " + aTotal
						+ " " + bTotal + "\n");
				outputFile.flush();
			}
			outputFile.close();

		} catch (Exception e) {
			// can't read the file for some reason, assume perfect input or
			// would try harder at this
			System.out.println("Could not read file!");
			e.printStackTrace();
		}

	}

	private static int readTime(String text) {

		int split = text.indexOf(":");
		int hours = Integer.parseInt(new String(text.substring(0, split)));
		int minutes = Integer.parseInt(new String(text.substring(split + 1,
				text.length())));

		return (hours * 60) + minutes;

	}

}
