/**
 * 
 */
package org.eldavo.google;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;

/**
 * @author eldavojohn@gmail.com
 * 
 */
public class CropTriangles {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		try {

			BufferedReader inputFile = new BufferedReader(new FileReader(
					new File(args[0])));
			BufferedWriter outputFile = new BufferedWriter(new FileWriter(
					new File(args[0] + ".out")));

			// we can now read searchFile line by line
			// so lets find our first two values:

			long numberOfCases = Integer.parseInt(inputFile.readLine());
			// now we get into the cases and we need to make a loop that runs
			// through each of the cases and pushes them through our logic
			// method
			for (int caseCount = 0; caseCount < numberOfCases; caseCount++) {

				// n, A, B, C, D, x0, y0 and M
				String temp = inputFile.readLine();

				String[] split = temp.split(" ");

				// for(long k = 0; k < split.length; k++)
				// System.out.println(split[k]);

				int n = Integer.parseInt(split[0]);
				long A = Long.parseLong(split[1]);
				long B = Long.parseLong(split[2]);
				long C = Long.parseLong(split[3]);
				long D = Long.parseLong(split[4]);
				long x0 = Long.parseLong(split[5]);
				long y0 = Long.parseLong(split[6]);
				long M = Long.parseLong(split[7]);

				Coords[] trees = locateTrees(n, A, B, C, D, x0, y0, M);

				long validTriangles = 0;

				for (int i1 = 0; i1 < n - 2; i1++) {
					for (int i2 = i1 + 1; i2 < n - 1; i2++) {
						for (int i3 = i2 + 1; i3 < n; i3++) {
							if (!treeCompare(trees[i1], trees[i2]) &&
									!treeCompare(trees[i2], trees[i3]) &&
									!treeCompare(trees[i1], trees[i3]) &&
									isCenterGridCoord(trees[i1], trees[i2],
											trees[i3])) {

								validTriangles++;
							}
						}
					}
				}

				outputFile.write("Case #" + (caseCount + 1) + ": "
						+ validTriangles + "\n");
				outputFile.flush();
			}
			outputFile.close();

		} catch (Exception e) {
			// can't read the file for some reason, assume perfect input or
			// would try harder at this
			e.printStackTrace();
		}

	}

	private static boolean isCenterGridCoord(Coords coords, Coords coords2,
			Coords coords3) {

		double x = (coords.getX() + coords2.getX() + coords3.getX());
		x = x/3;
		double y = (coords.getY() + coords2.getY() + coords3.getY());
		y = y/3;

		if (Math.ceil(x) == x && Math.floor(x) == x && Math.ceil(y) == y
				&& Math.floor(y) == y)
			return true;
		else
			return false;
	}

	private static Coords[] locateTrees(int n, long A, long B, long C, long D,
			long x0, long y0, long M) {
		Coords[] retArray = new Coords[n];
		long X = x0, Y = y0;
		retArray[0] = new Coords(X, Y);
//		 System.out.println(" X : " + X + "  Y : " + Y);
		for (int i = 1; i < n; i++) {
			X = (A * X + B) % M;
			Y = (C * Y + D) % M;
			retArray[i] = new Coords(X, Y);
//			 System.out.println(" X : " + X + "  Y : " + Y);
		}

		return retArray;
	}
	
	private static boolean treeCompare(Coords i, Coords k) {
		if(i.getX() == k.getX() && i.getY() == k.getY())
			return true;
		else 
			return false;
	}

}
