/**
 * 
 */
package org.eldavo.google;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigInteger;

/**
 * @author David
 * 
 */
public class SpeedLimits {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {

			BufferedReader inputFile = new BufferedReader(new FileReader(
					new File(args[0])));
			BufferedWriter outputFile = new BufferedWriter(new FileWriter(
					new File(args[0] + ".out")));

			// we can now read searchFile line by line
			// so lets find our first two values:

			int numberOfCases = Integer.parseInt(inputFile.readLine());
			// now we get into the cases and we need to make a loop that runs
			// through each of the cases and pushes them through our logic
			// method
			for (int caseCount = 0; caseCount < numberOfCases; caseCount++) {
				String temp = inputFile.readLine();

				String[] split = temp.split(" ");

				// for(int k = 0; k < split.length; k++)
				// System.out.println(split[k]);

				// n, m, X, Y and Z
				// 9223372036854775807
				// 1000000000
				int n = Integer.parseInt(split[0]);
				int m = Integer.parseInt(split[1]);
				long X = Long.parseLong(split[2]);
				long Y = Long.parseLong(split[3]);
				long Z = Long.parseLong(split[4]);

				long[] A = new long[m];

				for (int mcount = 0; mcount < m; mcount++) {
					A[mcount] = Integer.parseInt(inputFile.readLine());
				}

				long[] speedLimits = new long[n];

				for (int i = 0; i <= n - 1; i++) {
					speedLimits[i] = A[i % m];
					// System.out.print(speedLimits[i]+ ", ");
					A[i % m] =  ((X * A[i % m] + Y * (i + 1)) % Z);
				}

				BigInteger total = BigInteger.valueOf(0);

				BigInteger[] subSet = new BigInteger[n];
				
				for (int i = n-1; i >= 0; i--) {
					subSet[i] = BigInteger.valueOf(1);
					for(int j = i + 1; j < n; j++) {
						if(speedLimits[i] < speedLimits[j]) {
							subSet[i] = subSet[i].add(subSet[j]);
						}						
					}
					total = total.add(subSet[i]);
				}

				// System.out.println();

				outputFile.write("Case #" + (caseCount + 1) + ": " + (total.mod(BigInteger.valueOf(1000000007)))
						+ "\n");
				outputFile.flush();
			}
			outputFile.close();

		} catch (Exception e) {
			// can't read the file for some reason, assume perfect input or
			// would try harder at this
			e.printStackTrace();
		}

	}

}
