import java.io.*;
import java.util.*;

class Problem3Take2 {
    
    public static int R, C, M;
    public static int click_x, click_y;
    public static int[][] board;
    
    /*public static void main (String [] args) {
        R = 10;
        C = 10;
        M = 82;
        board = new int[][]{new int[]{-1,-1,-1,-1,-1,-1,-1,-1,2,0},new int[]{2,5,-1,-1,-1,-1,-1,-1,3,0},new int[]{0,3,-1,-1,-1,-1,-1,-1,3,0},new int[]{0,3,-1,-1,-1,-1,-1,-1,3,0},new int[]{0,3,-1,-1,-1,-1,-1,-1,3,0},new int[]{0,3,-1,-1,-1,-1,-1,-1,3,0},new int[]{0,3,-1,-1,-1,-1,-1,-1,3,0},new int[]{0,2,-1,-1,-1,-1,-1,-1,2,0},new int[]{0,1,2,3,3,3,3,2,1,0},new int[]{0,0,0,0,0,0,0,0,0,0}};
        System.out.println(works(M));
    }*/
    
    //solves the "Minesweeper Master" problem
    public static void main (String [] args) throws IOException {
        
        BufferedReader f = new BufferedReader(new FileReader("in3.txt"));
        PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("out3.txt")));
        StringTokenizer st = new StringTokenizer(f.readLine());
        
        int cases = Integer.parseInt(st.nextToken());
        for (int i=0; i<cases; i++) {
            System.out.println(i);
//----------------------start input----------------------------------------
            st = new StringTokenizer(f.readLine());
            R = Integer.parseInt(st.nextToken()); //rows in board
            C = Integer.parseInt(st.nextToken()); //columns in board
            M = Integer.parseInt(st.nextToken()); //mines on board
            System.out.println(R+" "+C+" "+M);
//------------------------end input----------------------------------------
            
            board = new int[R][C];
            for (int rows = 0; rows < R; rows++) {
                for (int columns = 0; columns < C; columns++) {
                    board[rows][columns] = 0;
                }
            }
            click_x = click_y = 0;
            
            if (addMines()) {
                System.out.println("Case #"+(i+1)+":\nPossible");
                out.println("Case #"+(i+1)+":");
                for (int j = 0; j < R; j++) {
                    for (int k = 0; k < C; k++) {
                        if(board[j][k] == -1) out.print("*");
                        else if(j==click_x && k==click_y) out.print("c");
                        else out.print(".");
                    }
                    out.println();
                }
            } else {
                out.println("Case #"+(i+1)+":\nImpossible");
                System.out.println("Case #"+(i+1)+":\nImpossible");
            }
            
        }
        
        out.close();                                  // close the output file
        System.exit(0);                               // don't omit this!
    }
    
    public static boolean addMines() {
        ArrayList<Integer> stuffBag = new ArrayList<>();
        stuffBag.add(new Integer(0));
        return recursiveAddMines(stuffBag, 0);
    }
    
    public static boolean recursiveAddMines(ArrayList<Integer> stuffBag, int mines) {
        if (mines >= M) return works(M);
        /*for (int j = 0; j < R; j++) {
            for (int k = 0; k < C; k++) {
                if(board[j][k] == -1) System.out.print("^");
                else System.out.print(board[j][k]);
            }
            System.out.println();
        }*/
        int[][] oldBoard = board.clone();
        for (int i = 0 ; i < board.length ; i ++) {
            oldBoard[i] = board[i].clone();
        }
        
        if (stuffBag == null) return false;
        
        while (stuffBag.size()>0) {
            System.out.println(mines);
            int ij = stuffBag.remove(0).intValue();
            int j = ij % (R+C);
            ij-=j;
            int i = ij/(R+C);
            if (board[i][j]!=-1) {
                board[i][j]=-1;
            } else {
                continue;
            }
            addNumbers(i,j);
            
            ArrayList<Integer> bagToSend = new ArrayList<>();
            addNeighbors(i, j, bagToSend);
            boolean a = recursiveAddMines(bagToSend, mines+1);
            if (a) {
                return true;
            } else {
                board = oldBoard.clone();
                for (int z = 0 ; z < board.length ; z ++) {
                    board[z] = oldBoard[z].clone();
                }
            }
        }
        
        return false;
    }
    
    public static void addNeighbors(int i, int j, ArrayList<Integer> bag) {
        if (j < C-1) {
            if (board[i][j+1]!=-1) bag.add(new Integer(((i)*(R+C))+(j+1)));
        }
        if (i < R-1) {
            if (board[i+1][j]!=-1) bag.add(new Integer(((i+1)*(R+C))+(j)));
        }
        if (j > 0) {
            if (board[i][j-1]!=-1) bag.add(new Integer(((i)*(R+C))+(j-1)));
        }
        if (i > 0) {
            if (board[i-1][j]!=-1) bag.add(new Integer(((i-1)*(R+C))+j));
        }
    }
    
    public static void addNumbers(int i, int j) {
        if (i > 0) {
            if (board[i-1][j]!=-1) board[i-1][j]++;
            if (j > 0) {
                if (board[i-1][j-1]!=-1) board[i-1][j-1]++;
            }
            if (j < C-1) {
                if (board[i-1][j+1]!=-1) board[i-1][j+1]++;
            }
        }
        if (i < R-1) {
            if (board[i+1][j]!=-1) board[i+1][j]++;
            if (j > 0) {
                if (board[i+1][j-1]!=-1) board[i+1][j-1]++;
            }
            if (j < C-1) {
                if (board[i+1][j+1]!=-1) board[i+1][j+1]++;
            }
        }
        if (j > 0) {
            if (board[i][j-1]!=-1) board[i][j-1]++;
        }
        if (j < C-1) {
            if (board[i][j+1]!=-1) board[i][j+1]++;
        }
    }
    
    public static void removeNumbers(int i, int j) {
        if (i > 0) {
            if (board[i-1][j]!=-1) board[i-1][j]--;
            if (j > 0) {
                if (board[i-1][j-1]!=-1) board[i-1][j-1]--;
            }
            if (j < C-1) {
                if (board[i-1][j+1]!=-1) board[i-1][j+1]--;
            }
        }
        if (i < R-1) {
            if (board[i+1][j]!=-1) board[i+1][j]--;
            if (j > 0) {
                if (board[i+1][j-1]!=-1) board[i+1][j-1]--;
            }
            if (j < C-1) {
                if (board[i+1][j+1]!=-1) board[i+1][j+1]--;
            }
        }
        if (j > 0) {
            if (board[i][j-1]!=-1) board[i][j-1]--;
        }
        if (j < C-1) {
            if (board[i][j+1]!=-1) board[i][j+1]--;
        }
    }
    
    public static void rankSpace(int i, int j) {
        int count = 0;
        if (i > 0) {
            if (board[i-1][j]==-1) count++;
            if (j > 0) {
                if (board[i-1][j-1]==-1) count++;
            }
            if (j < C-1) {
                if (board[i-1][j+1]==-1) count++;
            }
        }
        if (i < R-1) {
            if (board[i+1][j]==-1) count++;
            if (j > 0) {
                if (board[i+1][j-1]==-1) count++;
            }
            if (j < C-1) {
                if (board[i+1][j+1]==-1) count++;
            }
        }
        if (j > 0) {
            if (board[i][j-1]==-1) count++;
        }
        if (j < C-1) {
            if (board[i][j+1]==-1) count++;
        }
        board[i][j] = count;
    }
    
    public static boolean works (int mines) { //checks if a board configuration works
        HashSet<Integer> reachables = new HashSet<>();
        int click_i = 0, click_j = 0; //in case there is no 0 but instead a 1 (or 2, 3, 4, etc)
        boolean done = false;
        search:
            for (int i=0;i<R;i++) {
                for (int j=0;j<C;j++) {
                    if (board[i][j] == 0) {
                        click_i = i;
                        click_j = j;
                        done = true;
                        break search;
                    } else if (board[i][j] > 0) {
                        click_i = i;
                        click_j = j;
                        //don't break in case there is a 0
                    }
                }
            }
        
        recursiveCheckZeroes(click_i, click_j, reachables);
        click_x = click_i;
        click_y = click_j;
        return (reachables.size() == (R*C)-mines);
    }
    
    public static void recursiveCheckZeroes (int i, int j, HashSet<Integer> reachables) {
        if (i>=R || i<0 || j>=C || j<0) return;
        int x = board[i][j];
        if (x>=0) {
            int oldSize = reachables.size();
            if(!reachables.add(new Integer((i*(R+C))+j))) return; //adds and checks if we've already been here
            if (x==0) {
                recursiveCheckZeroes(i+1,j, reachables);
                recursiveCheckZeroes(i,j+1, reachables);
                recursiveCheckZeroes(i+1,j+1, reachables);
                recursiveCheckZeroes(i-1,j+1, reachables);
                recursiveCheckZeroes(i+1,j-1, reachables);
                recursiveCheckZeroes(i-1,j, reachables);
                recursiveCheckZeroes(i,j-1, reachables);
                recursiveCheckZeroes(i-1,j-1, reachables);
            }
        }
    }
}