import edu.princeton.cs.algs4.In;
import edu.princeton.cs.algs4.Out;

import java.math.BigInteger;


public class Fractiles {

    public static int[] toInt(String[] nums) {
        int[] result = new int[nums.length];
        for (int i = 0; i < nums.length; i++) result[i] = Integer.parseInt(nums[i]);
        return result;
    }

    public static void ln(String s) {
        System.out.println(s);
    }

    private static int gcd(int a, int b) {
        BigInteger b1 = BigInteger.valueOf(a);
        BigInteger b2 = BigInteger.valueOf(b);
        BigInteger gcd = b1.gcd(b2);
        return gcd.intValue();
    }

    public static BigInteger convertToDecimal(String str, int base) {
        int v = 0;
        BigInteger total = BigInteger.ZERO;
        BigInteger factor = BigInteger.ONE;
        str = str.toUpperCase();
        for (int i = str.length() - 1; i >= 0; i--) {
            char c = str.charAt(i);
            if (c >= '0' && c <= '9')
                v = c - '0';
            else if (c >= 'A' && c <= 'Z')
                v = 10 + (c - 'A');

            total = total.add(factor.multiply(BigInteger.valueOf(v)));
            factor = factor.multiply(BigInteger.valueOf(base));
        }
        return total;
    }

    public static String[] toStringArray(Object[] arr) {
        String[] result = new String[arr.length];
        for(int i=0; i<result.length; i++) {
            result[i] = arr[i].toString();
        }
        return result;
    }

    public static void main(String[] args) {
        In in = new In(args[0] + ".in");
        Out out = new Out(args[0] + ".out");
        int T = in.readInt();

        for (int t = 1; t <= T; t++) { //each case
            int K = in.readInt();
            int C = in.readInt();
            int S = in.readInt();

            int minS = C>1? K -1: K;

            out.print("Case #" + t + ":");
            if(S < minS) {
                out.println(" IMPOSSIBLE");
            }else if(C == 1){
                for(int i=1; i<=K; i++)
                    out.print(" " + i);
                out.println();
            }else{
                for(int i=2; i<=K; i++)
                    out.print(" " + i);
                out.println();
            }

        }

    }

    //return null if it's prime, or return the divisor
    public static BigInteger isPrime(BigInteger n) {

//        if (!n.isProbablePrime(10)) {
//            return false;
//        }

        if (n.compareTo(BigInteger.ONE) == 0 || n.compareTo(BigInteger.valueOf(2)) == 0) {
            return null;
        }
        BigInteger root = appxRoot(n);
        //System.out.println("Using approximate root " + root);

//        int cnt = 0;
        for (BigInteger i = BigInteger.valueOf(3);
             i.compareTo(root) <= 0;
             i = i.nextProbablePrime()) {
//            cnt++;
//            if (cnt % 1000 == 0) {
//                System.out.println(cnt + " Using next prime " + i);
//            }
            if (n.mod(i).equals(BigInteger.ZERO)) {
                return i;
            }

        }
        return null;

    }

    private static BigInteger appxRoot(final BigInteger n) {
        BigInteger half = n.shiftRight(1);
        while (half.multiply(half).compareTo(n) > 0) {
            half = half.shiftRight(1);
        }
        return half.shiftLeft(1);
    }


    private static void next(char[] num) {
        for (int i = num.length - 1; i >= 0; i--) {
            if (num[i] == '0') {
                num[i] = '1';
                return;
            } else {
                num[i] = '0';
            }

        }
    }
}

