import edu.princeton.cs.algs4.In;
import edu.princeton.cs.algs4.Out;

import java.math.BigInteger;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Random;


public class JamCoin {

    public static int[] toInt(String[] nums) {
        int[] result = new int[nums.length];
        for (int i = 0; i < nums.length; i++) result[i] = Integer.parseInt(nums[i]);
        return result;
    }

    public static void ln(String s) {
        System.out.println(s);
    }

    private static int gcd(int a, int b) {
        BigInteger b1 = BigInteger.valueOf(a);
        BigInteger b2 = BigInteger.valueOf(b);
        BigInteger gcd = b1.gcd(b2);
        return gcd.intValue();
    }

    public static BigInteger convertToDecimal(String str, int base) {
        int v = 0;
        BigInteger total = BigInteger.ZERO;
        BigInteger factor = BigInteger.ONE;
        str = str.toUpperCase();
        for (int i = str.length() - 1; i >= 0; i--) {
            char c = str.charAt(i);
            if (c >= '0' && c <= '9')
                v = c - '0';
            else if (c >= 'A' && c <= 'Z')
                v = 10 + (c - 'A');

            total = total.add(factor.multiply(BigInteger.valueOf(v)));
            factor = factor.multiply(BigInteger.valueOf(base));
        }
        return total;
    }

    public static String[] toStringArray(Object[] arr) {
        String[] result = new String[arr.length];
        for (int i = 0; i < result.length; i++) {
            result[i] = arr[i].toString();
        }
        return result;
    }

    public static void main(String[] args) {
        In in = new In(args[0] + ".in");
        Out out = new Out(args[0] + ".out");
        int C = in.readInt();

        int N = in.readInt();
        int J = in.readInt();
        Random rand = new Random();


        int[] tests = new int[]{2, 3, 5, 7, 11, 13, 17, 23, 29, 31, 37};

        for (int c = 1; c <= C; c++) { //each case
            char[] num = new char[N - 2];
            for (int i = 0; i < num.length; i++) num[i] = '0';

            HashSet<String> tested = new HashSet<>();
//            String[] results = new String[J];

            BigInteger[] baseNums = new BigInteger[9];
//            String test = "1" + new String(num) + "1";
//            for (int base = 2; base <= 10; base++) {
//                baseNums[base - 2] = convertToDecimal(test, base);
//            }

            out.println("Case #1:");

            String coin = "1" + new String(num) + "1";
            int count = 0;
            for (int i = 0; i < J; i++) { //generate a coin

                boolean found = false;
                while (!found) {

                    //update base Numbers
                    for (int b = 0; b < baseNums.length; b++) {
                        baseNums[b] = convertToDecimal(coin, b + 2);
                        //baseNums[b] = baseNums[b].add(BigInteger.valueOf(b + 2));
                    }

                    //verify base numbers
                    BigInteger[] divisor = new BigInteger[9];
                    found = true;
                    for (int b = 0; b < baseNums.length; b++) {

                        //check if prime
                        BigInteger div = isPrime(baseNums[b]);
                        if (div == null) {
                            found = false;
                            break;
                        }

                        divisor[b] = div;
//                        for (int d = 0; d < tests.length; d++) {
//                            if (baseNums[b].mod(BigInteger.valueOf(tests[d])).equals(0)) {
//                                divisor[b] = tests[d];
//                                break;
//                            }
//                        }
//                        if (divisor[b] == 0) {
//                            found = false;
//                            break;
//                        }
                    }

                    if (found) {
                        out.println(coin + " " + String.join(" ", toStringArray(divisor)));
                        count++;
                        ln("count: " + count + " " + tested.size());
                    }

                    //update number
                    do {
                        next(num, rand);
                        coin = "1" + new String(num) + "1";
                    } while (tested.contains(coin));
                    tested.add(coin);
                    //ln("bn " + Arrays.toString(baseNums));
                    //ln("di " + Arrays.toString(divisor));
                }


            }


        }

    }

    //return null if it's prime, or return the divisor
    public static BigInteger isPrime(BigInteger n) {

//        if (!n.isProbablePrime(10)) {
//            return false;
//        }

        if (n.compareTo(BigInteger.ONE) == 0 || n.compareTo(BigInteger.valueOf(2)) == 0) {
            return null;
        }
        BigInteger root = appxRoot(n);
        //System.out.println("Using approximate root " + root);

//        int cnt = 0;
        for (BigInteger i = BigInteger.valueOf(3);
             i.compareTo(root) <= 0;
             i = i.nextProbablePrime()) {
//            cnt++;
//            if (cnt % 1000 == 0) {
//                System.out.println(cnt + " Using next prime " + i);
//            }
            if (n.mod(i).equals(BigInteger.ZERO)) {
                return i;
            }

        }
        return null;

    }

    private static BigInteger appxRoot(final BigInteger n) {
        BigInteger half = n.shiftRight(1);
        while (half.multiply(half).compareTo(n) > 0) {
            half = half.shiftRight(1);
        }
        return half.shiftLeft(1);
    }


    private static void next(char[] num, Random rand) {
        //random
        for (int i = 0; i < num.length; i++) {
            num[i] = rand.nextBoolean() ? '1' : '0';
        }
//
//        for (int i = num.length - 1; i >= 0; i--) {
//            if (num[i] == '0') {
//                num[i] = '1';
//                return;
//            } else {
//                num[i] = '0';
//            }
//
//        }
    }
}

