import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.PriorityQueue;
import java.util.Scanner;

public class Main {

	public static void main(String[] args) throws IOException {
		new Main();
	}
	
	private int W;
	private int H;
	private int B;
	private Building END;

	public Main() throws IOException {
		//Scanner in = new Scanner(new File("C-test.txt"));
		Scanner in = new Scanner(new File("C-large.in"));
		BufferedWriter out = new BufferedWriter(new FileWriter("C-large.txt"));

		int amountOfTasks = in.nextInt();
		for (int task = 0; task < amountOfTasks; task++) {
			W = in.nextInt();
			H = in.nextInt();
			B = in.nextInt();
			Building[] buildings = new Building[B+1];
			PriorityQueue<Building> pq = new PriorityQueue<Building>();
			for (int i = 0; i < B; i++) {
				int a = in.nextInt();
				int b = in.nextInt();
				int c = in.nextInt();
				int d = in.nextInt();
				buildings[i] = new Building(i, a, b, c, d);
				pq.add(buildings[i]);
				END = new Building(B, 42, 42, 42, 42);
				END.bestDist = 1000000000;
				buildings[B] = END;
				pq.add(END);
			}
			
			int[][] distances = new int[B][B+1];
			for (int i = 0; i < B; i++) {
				for (int j = 0; j <= i; j++) {
					int dis = distance(buildings[i], buildings[j]);
					distances[i][j] = dis;
					distances[j][i] = dis;
				}
				distances[i][B] = W-buildings[i].x1-1;
			}
			boolean[] used = new boolean[B+1];
			
			int solution = W;
			while(!pq.isEmpty()) {
				Building b = pq.poll();
				if (b == END) {
					solution = b.bestDist;
					break;
				}
				used[b.index] = true;
				for (int i = 0; i <= B; i++) {
					if (!used[i]) {
						if (distances[b.index][i] + b.bestDist < buildings[i].bestDist) {
							pq.remove(buildings[i]);
							buildings[i].bestDist = distances[b.index][i] + b.bestDist;
							pq.add(buildings[i]);
						}	
					}
				}
				pq.remove(b);
			}
			
			out.write("Case #" + (task + 1) + ": " + solution);
			out.newLine();
			System.out.println(solution);
		}

		out.close();
		in.close();
	}
	
	public class Building implements Comparable<Building> {
		public int x0, y0 ,x1, y1;
		public int bestDist;
		public int index;
		public Building(int index, int x0, int y0, int x1, int y1) {
			this.index = index;
			this.x0 = x0;
			this.y0 = y0;
			this.x1 = x1;
			this.y1 = y1;
			this.bestDist = x0;
		}
		public int compareTo(Building bOther) {
			return this.bestDist-bOther.bestDist;
		}
	}
	
	public int distance(Building b1, Building b2) {
		if (b1.x0 == b2.x0) {
			int a = b1.y0 - b2.y1;
			if (a < 0) a = 0;
			int b = b2.y0 - b1.y1;
			if (b < 0) b = 0;
			if (a == 0 && b == 0)
				return 0;
			if (a==0)
				return b-1;
			else return a-1;
		} else if (b1.x0 < b2.x0) {
			if (b1.x1 >= b2.x0) {
				int a = b1.y0 - b2.y1;
				if (a < 0) a = 0;
				int b = b2.y0 - b1.y1;
				if (b < 0) b = 0;
				if (a == 0 && b == 0)
					return 0;
				if (a==0)
					return b-1;
				else return a-1;
			} else {
				int a = b1.y0 - b2.y1;
				if (a < 0) a = 0;
				int b = b2.y0 - b1.y1;
				if (b < 0) b = 0;
				int e;
				if (a == 0 && b == 0)
					e = 0;
				if (a==0)
					e = b-1;
				else e = a-1;
				
				int c = b1.x0 - b2.x1;
				if (c < 0) c = 0;
				int d = b2.x0 - b1.x1;
				if (d < 0) d = 0;
				int f;
				if (c == 0 && d == 0)
					f = 0;
				if (c==0)
					f = d-1;
				else f = c-1;
				return Math.max(e, f);
			}
		} else {
			Building temp = b1;
			b1 =b2;
			b2 = temp;
			if (b1.x1 >= b2.x0) {
				int a = b1.y0 - b2.y1;
				if (a < 0) a = 0;
				int b = b2.y0 - b1.y1;
				if (b < 0) b = 0;
				if (a == 0 && b == 0)
					return 0;
				if (a==0)
					return b-1;
				else return a-1;
			} else {
				int a = b1.y0 - b2.y1;
				if (a < 0) a = 0;
				int b = b2.y0 - b1.y1;
				if (b < 0) b = 0;
				int e;
				if (a == 0 && b == 0)
					e = 0;
				if (a==0)
					e = b-1;
				else e = a-1;
				
				int c = b1.x0 - b2.x1;
				if (c < 0) c = 0;
				int d = b2.x0 - b1.x1;
				if (d < 0) d = 0;
				int f;
				if (c == 0 && d == 0)
					f = 0;
				if (c==0)
					f = d-1;
				else f = c-1;
				return Math.max(e, f);
			}
		}
	}
}