import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class Main {

	public static void main(String[] args) throws IOException {
		new Main();
	}

	private int nbKeys;
	private int nbChests;

	public Main() throws IOException {
		Scanner sc = new Scanner(new File("D-small-attempt2.in"));
		BufferedWriter out = new BufferedWriter(
				new FileWriter("outputSmall.txt"));
		int aantalOpgaven = sc.nextInt();
		//System.out.println("aantal:= " + aantalOpgaven);
		for (int n = 0; n < aantalOpgaven; n++) {
			//System.out.println("Case nr: " + (n + 1));

			nbKeys = sc.nextInt();
			nbChests = sc.nextInt();

			ArrayList<Integer> keys = new ArrayList<Integer>();
			for (int i = 0; i < nbKeys; i++) {
				keys.add(sc.nextInt());
			}

			Map<Integer, int[]> chests = new HashMap<Integer, int[]>();
			for (int i = 0; i < nbChests; i++) {
				int chestKey = sc.nextInt();
				int nbInside = sc.nextInt();
				int[] array = new int[nbInside + 1];
				array[0] = chestKey;
				for (int j = 0; j < nbInside; j++) {
					array[j+1] = sc.nextInt();
				}
				chests.put(i+1, array);
			}

			if (surelyImpossible(keys, chests)){
				out.write("Case #" + (n + 1) + ": IMPOSSIBLE");
				out.newLine();
			} else {
				out.write("Case #" + (n + 1) + ": "
						+ solve(keys, chests, new ArrayList<Integer>(), 0));
				out.newLine();
			}		
		}
		sc.close();
		out.close();
	}
	
	private boolean surelyImpossible(ArrayList<Integer>keys,Map<Integer, int[]> chests) {
		ArrayList<Integer> allKeys = new ArrayList<Integer>();
		ArrayList<Integer> allKeysNodig = new ArrayList<Integer>();
		for (int i = 0; i < keys.size(); i++) {
			allKeys.add(keys.get(i));
		}
		for (int i = 0; i < chests.size(); i++) {
			int[] array = chests.get(i+1);
			allKeysNodig.add(array[0]);
			for(int j = 1; j < array.length; j++) {
				allKeys.add(array[j]);
			}
		}
		for (int i = 0; i < allKeysNodig.size(); i++) {
			if (!allKeys.contains(allKeysNodig.get(i)))
				return true;
			else
				allKeys.remove(firstOccurence(allKeysNodig.get(i), allKeys));
		}
		return false;
	}

	private String solve(ArrayList<Integer> keys, Map<Integer, int[]> chests,
			ArrayList<Integer> done, int toDelete) {
		if (keys.size() == 0 && chests.size() != nbChests) {
			int index = done.size() - 1;
			int value = done.get(index);
			done.remove(index);
			//System.out.println("removed the last chest from done chests");

			for (int k = 0; k < toDelete; k++) {
				keys.remove(keys.size() - 1);
				System.out.println("removed the last key from keys");
			}
			keys.add(chests.get(value)[0]);
			//System.out.println("added the last used key to keys");

			return "IMPOSSIBLE";
		}

		if (done.size() == nbChests)
			return "";

		for (int i = 1; i <= nbChests; i++) {
			//System.out.println("Chest nr: " + i);
			if (keys.contains(chests.get(i)[0]) && !done.contains(i)) {
				int[] array = chests.get(i);
					
				for (int k = 1; k < array.length; k++) {
					keys.add(array[k]);
				//	System.out.println("added " + array[k] + " to keys");
				}
				
				done.add(i);
				//System.out.println("added " + i + " to done chests");

				keys.remove(firstOccurence(chests.get(i)[0], keys));
				//System.out.println("removed " + chests.get(i)[0] + " from keys");

				String opl = solve(keys, chests, done, array.length-1);
				if (opl == "")
					return i + "";
				if (opl != "IMPOSSIBLE")
					return i + " " + opl;
			} //else
				//System.out.println("Not possible to open chest  nr: " + i);
		}
		if (done.size() != 0) {
			int index = done.size() - 1;
			int value = done.get(index);
			done.remove(index);
			//System.out.println("removed the last chest from done chests");

			for (int k = 0; k < toDelete; k++) {
				keys.remove(keys.size() - 1);
			//	System.out.println("removed the last key from keys");
			}
			keys.add(chests.get(value)[0]);
			//System.out.println("added the last used key to keys");
		}
		return "IMPOSSIBLE";
	}

	private int firstOccurence(int value, ArrayList<Integer> keys) {
		for (int i = 0; i < keys.size(); i++) {
			if (keys.get(i) == value)
				return i;
		}
		return -1;
	}
}
