import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

// C
// Mede mogelijk gemaakt door Lore haar poepje
public class Main {
	public static void main(String[] args) throws FileNotFoundException {
		new Main();
	}

	boolean change;
	
	public Main() throws FileNotFoundException {
		//Scanner sc = new Scanner(System.in);
		Scanner sc = new Scanner(new File("C-large.in"));
		PrintWriter out = new PrintWriter(new File("C_large.out"));

		int amountOfTasks = sc.nextInt();
		for (int task = 1; task <= amountOfTasks; task++) {
			int r = sc.nextInt();
			int c = sc.nextInt();
			char[][] field = new char[r][c];
			for (int i = 0; i < r; i++) {
				String row = sc.next();
				for (int j = 0; j < c; j++) {
					field[i][j] = row.charAt(j);
					if (field[i][j] == '|' || field[i][j] == '-') {
						field[i][j] = 'x';
					}
				}
			}
			char[][] result = null;
			change = true;
			while(change) {
				change = false;
				allHittable(field, r, c);
			}
			if (allHittable(field, r, c)) {
				result = recurse(r, c, field, 0, 0);
			} 
			String sol = "POSSIBLE";
			if (result == null) {
				sol = "IMPOSSIBLE";
				System.out.println("Case #" + task + ": " + sol);
				out.println("Case #" + task + ": " + sol);
			} else {
				System.out.println("Case #" + task + ": " + sol);
				out.println("Case #" + task + ": " + sol);
				printField(result, r, c, out);
			}
		}

		out.close();
		sc.close();
	}

	private void printField(char[][] field, int r, int c, PrintWriter out) {
		for (int i = 0; i < r; i++) {
			String s = "";
			for (int j = 0; j < c; j++) {
				s += field[i][j];
			}
			System.out.println(s);
			out.println(s);
		}
	}
	
	private char[][] recurse(int r, int c, char[][] field, int i, int j) {
		if (i == r) {
			boolean found = true;
			outerloop: for (int a = 0; a < r; a++) {
				for (int b = 0; b < c; b++) {
					if (field[a][b] == '.' && !hitted(field, a, b, r, c)) {
						found = false;
						break outerloop;
					}
				}
			}
			if (found) {
				return field;
			} else {
				return null;
			}
		} else if (j == c) {
			if (!allHittable(field, r, c)) {
				return null;
			}
			return recurse(r, c, field, i + 1, 0);
		}
		if (field[i][j] == 'x') {
			if (!hittingRight(field, i, j, r, c) && !hittingLeft(field, i, j, r, c)) {
				field[i][j] = '-';
				char[][] result = recurse(r, c, field, i, j + 1);
				if (result == null) {
					field[i][j] = 'x';
				} else {
					return result;
				}
			}
			if (!hittingUp(field, i, j, r, c) && !hittingDown(field, i, j, r, c)) {
				field[i][j] = '|';
				char[][] result = recurse(r, c, field, i, j + 1);
				if (result == null) {
					field[i][j] = 'x';
				} else {
					return result;
				}
			}
			return null;
		} else {
			return recurse(r, c, field, i, j + 1);
		}
	}

	private boolean allHittable(char[][] field, int r, int c) {
		for (int i = 0; i < r; i++) {
			for (int j = 0; j < c; j++) {
				if (field[i][j] == '.') {
					if (!hittable(field, i, j, r, c)) {
						return false;
					}
				}
			}
		}
		return true;
	}
	
	private boolean hittable1(char[][] field, int i, int j, int r, int c) {
		return (hittingRight(field, i, j, r, c) || hittingLeft(field, i, j, r, c) || hittingUp(field, i, j, r, c) || hittingDown(field, i, j, r, c));
	}

	private boolean hittable(char[][] field, int i, int j, int r, int c) {
		boolean poss = (hittingRight(field, i, j, r, c) || hittingLeft(field, i, j, r, c) || hittingUp(field, i, j, r, c) || hittingDown(field, i, j, r, c));
		if (!poss) return false;
		int amount = 0;
		if (hittingRight3(field, i, j, r, c)) {
			amount++;
		}
		if (hittingLeft3(field, i, j, r, c)) {
			amount++;
		}
		if (hittingUp3(field, i, j, r, c)) {
			amount++;
		}
		if (hittingDown3(field, i, j, r, c)) {
			amount++;
		}
		if (amount == 0) {
			return false;
		} else if (amount == 1) {
			if (hittingRight3(field, i, j, r, c)) {
				validateRight(field, i, j, r, c);
			} else if (hittingLeft3(field, i, j, r, c)) {
				validateLeft(field, i, j, r, c);
			} else if (hittingUp3(field, i, j, r, c)) {
				validateUp(field, i, j, r, c);;
			} else if (hittingDown3(field, i, j, r, c)) {
				validateDown(field, i, j, r, c);
			}
		}
		return true;
	}

	private boolean hitted(char[][] field, int i, int j, int r, int c) {
		return (hittingRight2(field, i, j, r, c) || hittingLeft2(field, i, j, r, c) || hittingUp2(field, i, j, r, c) || hittingDown2(field, i, j, r, c));
	}
		
	private boolean hittingRight(char[][] field, int i, int j, int r, int c) {
		int pos = j + 1;
		while (pos < c) {
			if (field[i][pos] == 'x' || field[i][pos] == '-' || field[i][pos] == '|') {
				return true;
			} else if (field[i][pos] == '#') {
				return false;
			} else if (field[i][pos] == '/') {
				return hittingUp(field, i, pos, r, c);
			} else if (field[i][pos] == '\\') {
				return hittingDown(field, i, pos, r, c);
			}
			pos++;
		}
		return false;
	}
	
	private boolean hittingLeft(char[][] field, int i, int j, int r, int c) {
		int pos = j - 1;
		while (pos >= 0) {
			if (field[i][pos] == 'x' || field[i][pos] == '-' || field[i][pos] == '|') {
				return true;
			} else if (field[i][pos] == '#') {
				return false;
			} else if (field[i][pos] == '/') {
				return hittingDown(field, i, pos, r, c);
			} else if (field[i][pos] == '\\') {
				return hittingUp(field, i, pos, r, c);
			}
			pos--;
		}
		return false;
	}
	
	private boolean hittingUp(char[][] field, int i, int j, int r, int c) {
		int pos = i - 1;
		while (pos >= 0) {
			if (field[pos][j] == 'x' || field[pos][j] == '-' || field[pos][j] == '|') {
				return true;
			} else if (field[pos][j] == '#') {
				return false;
			} else if (field[pos][j] == '/') {
				return hittingRight(field, pos, j, r, c);
			} else if (field[pos][j] == '\\') {
				return hittingLeft(field, pos, j, r, c);
			}
			pos--;
		}
		return false;
	}
	
	private boolean hittingDown(char[][] field, int i, int j, int r, int c) {
		int pos = i + 1;
		while (pos < r) {
			if (field[pos][j] == 'x' || field[pos][j] == '-' || field[pos][j] == '|') {
				return true;
			} else if (field[pos][j] == '#') {
				return false;
			} else if (field[pos][j] == '/') {
				return hittingLeft(field, pos, j, r, c);
			} else if (field[pos][j] == '\\') {
				return hittingRight(field, pos, j, r, c);
			}
			pos++;
		}
		return false;
	}
	
	private boolean hittingRight2(char[][] field, int i, int j, int r, int c) {
		int pos = j + 1;
		while (pos < c) {
			if (field[i][pos] == '-') {
				return true;
			} else if (field[i][pos] == '#' || field[i][pos] == '|') {
				return false;
			} else if (field[i][pos] == '/') {
				return hittingUp(field, i, pos, r, c);
			} else if (field[i][pos] == '\\') {
				return hittingDown(field, i, pos, r, c);
			}
			pos++;
		}
		return false;
	}
	
	private boolean hittingLeft2(char[][] field, int i, int j, int r, int c) {
		int pos = j - 1;
		while (pos >= 0) {
			if (field[i][pos] == '-') {
				return true;
			} else if (field[i][pos] == '#' || field[i][pos] == '|') {
				return false;
			} else if (field[i][pos] == '/') {
				return hittingDown(field, i, pos, r, c);
			} else if (field[i][pos] == '\\') {
				return hittingUp(field, i, pos, r, c);
			}
			pos--;
		}
		return false;
	}
	
	private boolean hittingUp2(char[][] field, int i, int j, int r, int c) {
		int pos = i - 1;
		while (pos >= 0) {
			if (field[pos][j] == '|') {
				return true;
			} else if (field[pos][j] == '#' || field[pos][j] == '-') {
				return false;
			} else if (field[pos][j] == '/') {
				return hittingRight(field, pos, j, r, c);
			} else if (field[pos][j] == '\\') {
				return hittingLeft(field, pos, j, r, c);
			}
			pos--;
		}
		return false;
	}
	
	private boolean hittingDown2(char[][] field, int i, int j, int r, int c) {
		int pos = i + 1;
		while (pos < r) {
			if (field[pos][j] == '|') {
				return true;
			} else if (field[pos][j] == '#' || field[pos][j] == '-') {
				return false;
			} else if (field[pos][j] == '/') {
				return hittingLeft(field, pos, j, r, c);
			} else if (field[pos][j] == '\\') {
				return hittingRight(field, pos, j, r, c);
			}
			pos++;
		}
		return false;
	}
	
	private boolean hittingRight3(char[][] field, int i, int j, int r, int c) {
		int pos = j + 1;
		while (pos < c) {
			if (field[i][pos] == '-' || field[i][pos] == 'x') {
				return true;
			} else if (field[i][pos] == '#' || field[i][pos] == '|') {
				return false;
			} else if (field[i][pos] == '/') {
				return hittingUp(field, i, pos, r, c);
			} else if (field[i][pos] == '\\') {
				return hittingDown(field, i, pos, r, c);
			}
			pos++;
		}
		return false;
	}
	
	private boolean hittingLeft3(char[][] field, int i, int j, int r, int c) {
		int pos = j - 1;
		while (pos >= 0) {
			if (field[i][pos] == '-' || field[i][pos] == 'x') {
				return true;
			} else if (field[i][pos] == '#' || field[i][pos] == '|') {
				return false;
			} else if (field[i][pos] == '/') {
				return hittingDown(field, i, pos, r, c);
			} else if (field[i][pos] == '\\') {
				return hittingUp(field, i, pos, r, c);
			}
			pos--;
		}
		return false;
	}
	
	private boolean hittingUp3(char[][] field, int i, int j, int r, int c) {
		int pos = i - 1;
		while (pos >= 0) {
			if (field[pos][j] == '|' || field[pos][j] == 'x') {
				return true;
			} else if (field[pos][j] == '#' || field[pos][j] == '-') {
				return false;
			} else if (field[pos][j] == '/') {
				return hittingRight(field, pos, j, r, c);
			} else if (field[pos][j] == '\\') {
				return hittingLeft(field, pos, j, r, c);
			}
			pos--;
		}
		return false;
	}
	
	private boolean hittingDown3(char[][] field, int i, int j, int r, int c) {
		int pos = i + 1;
		while (pos < r) {
			if (field[pos][j] == '|' || field[pos][j] == 'x') {
				return true;
			} else if (field[pos][j] == '#' || field[pos][j] == '-') {
				return false;
			} else if (field[pos][j] == '/') {
				return hittingLeft(field, pos, j, r, c);
			} else if (field[pos][j] == '\\') {
				return hittingRight(field, pos, j, r, c);
			}
			pos++;
		}
		return false;
	}
	
	private boolean validateRight(char[][] field, int i, int j, int r, int c) {
		int pos = j + 1;
		while (pos < c) {
			if (field[i][pos] == 'x' || field[i][pos] == '-' || field[i][pos] == '|') {
				if (field[i][pos] != '-') change = true;
				field[i][pos] = '-';
				return true;
			} else if (field[i][pos] == '#') {
				return false;
			} else if (field[i][pos] == '/') {
				return hittingUp(field, i, pos, r, c);
			} else if (field[i][pos] == '\\') {
				return hittingDown(field, i, pos, r, c);
			}
			pos++;
		}
		return false;
	}
	
	private boolean validateLeft(char[][] field, int i, int j, int r, int c) {
		int pos = j - 1;
		while (pos >= 0) {
			if (field[i][pos] == 'x' || field[i][pos] == '-' || field[i][pos] == '|') {
				if (field[i][pos] != '-') change = true;
				field[i][pos] = '-';
				return true;
			} else if (field[i][pos] == '#') {
				return false;
			} else if (field[i][pos] == '/') {
				return hittingDown(field, i, pos, r, c);
			} else if (field[i][pos] == '\\') {
				return hittingUp(field, i, pos, r, c);
			}
			pos--;
		}
		return false;
	}
	
	private boolean validateUp(char[][] field, int i, int j, int r, int c) {
		int pos = i - 1;
		while (pos >= 0) {
			if (field[pos][j] == 'x' || field[pos][j] == '-' || field[pos][j] == '|') {
				if (field[pos][j] != '|') change = true;
				field[pos][j] = '|';
				return true;
			} else if (field[pos][j] == '#') {
				return false;
			} else if (field[pos][j] == '/') {
				return hittingRight(field, pos, j, r, c);
			} else if (field[pos][j] == '\\') {
				return hittingLeft(field, pos, j, r, c);
			}
			pos--;
		}
		return false;
	}
	
	private boolean validateDown(char[][] field, int i, int j, int r, int c) {
		int pos = i + 1;
		while (pos < r) {
			if (field[pos][j] == 'x' || field[pos][j] == '-' || field[pos][j] == '|') {
				if (field[pos][j] != '|') change = true;
				field[pos][j] = '|';
				return true;
			} else if (field[pos][j] == '#') {
				return false;
			} else if (field[pos][j] == '/') {
				return hittingLeft(field, pos, j, r, c);
			} else if (field[pos][j] == '\\') {
				return hittingRight(field, pos, j, r, c);
			}
			pos++;
		}
		return false;
	}
	
}
