package gcj.gcj;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;

import org.apache.commons.lang3.tuple.Pair;

import com.google.common.math.IntMath;

public class Pancakes {

    private static final String INPUT_FILE = "/home/elinow/Downloads/B-small-attempt0.in";
    // private static final String INPUT_FILE = "/home/elinow/Downloads/A-large.in";
    private static final String OUTPUT_FOLDER = "/home/elinow/workspaces/algo/gcj/src/main/java/gcj/gcj/";
    private static final String OUTPUT_FILE = "B-small.out";

    public static void main(String[] args) throws Exception {
        InputReader in = new InputReader(new FileInputStream(INPUT_FILE));
        // InputReader in = new InputReader(System.in);
        PrintWriter pw = new PrintWriter(new File(OUTPUT_FOLDER, OUTPUT_FILE));
        int T = in.nextInt();
        for (int t = 1; t <= T; t++) {
            int D = in.nextInt();
            List<Integer> P = new ArrayList<Integer>();
            for (int i = 0; i < D; i++) {
                P.add(in.nextInt());
            }
            Collections.sort(P);
            Collections.reverse(P);
            int res = Integer.MAX_VALUE;
            for (int k = 1; k <= P.get(0); k++) {
                int tempRes = calc(P, k);
                res = Math.min(tempRes, res);
            }
            String resStr = String.format("Case #%d: %d", t, res);
            pw.println(resStr);
            System.out.println(resStr);
        }
        pw.close();
    }

    private static int calc(List<Integer> p, int k) {
        int res = 0;
        Map<Integer, Pair<Integer, Integer>> memo = new HashMap<>();
        int maxPile = Integer.MIN_VALUE;
        for (int num : p) {
            Pair<Integer, Integer> t = f(num, k, memo);
            res += t.getLeft();
            maxPile = Math.max(maxPile, t.getRight());
        }
        res += maxPile;
        return res;
    }

    private static Pair<Integer, Integer> f(int num, int k, Map<Integer, Pair<Integer, Integer>> memo) {
        if (num <= k) {
            return Pair.of(0, num);
        }
        Pair<Integer, Integer> memoedVal = memo.get(num);
        if (memoedVal != null) {
            return memoedVal;
        }
        Pair<Integer, Integer> left = f(num / 2, k, memo);
        Pair<Integer, Integer> right = f(IntMath.divide(num, 2, RoundingMode.UP), k, memo);
        int splits = left.getLeft() + right.getLeft() + 1;
        int max = Math.max(left.getRight(), right.getRight());
        Pair<Integer, Integer> res = Pair.of(splits, max);
        memo.put(num, res);
        return res;
    }

    public static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 65535);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }
    }
}
