import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class TicTacToeTomek {
	private static final String OUT = "C:/workspaces/tc/CodeJam/src/tic.out";
	private static final String IN = "D:/downloads/A-large.in";

	private static enum Status {
		X_WON, O_WON, DRAW, NOT_COMPLETE;
	}

	public static Status solve(char[][] board) {
		if (won(board, 'X')) {
			return Status.X_WON;
		}
		if (won(board, 'O')) {
			return Status.O_WON;
		}
		if (finished(board)) {
			return Status.DRAW;
		} else {
			return Status.NOT_COMPLETE;
		}
	}

	private static boolean finished(char[][] board) {
		boolean finished = true;
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				if (board[i][j] == '.') {
					finished = false;
				}
			}
		}
		return finished;
	}

	private static boolean won(char[][] board, char ch) {
		for (int i = 0; i < 4; i++) {
			boolean res = true;
			for (int j = 0; j < 4 && res; j++) {
				char ch2 = board[i][j];
				if (ch2 != ch && ch2 != 'T') {
					res = false;
				}
			}
			if (res) {
				return true;
			}
		}
		for (int i = 0; i < 4; i++) {
			boolean res = true;
			for (int j = 0; j < 4 && res; j++) {
				char ch2 = board[j][i];
				if (ch2 != ch && ch2 != 'T') {
					res = false;
				}
			}
			if (res) {
				return true;
			}
		}
		boolean found = true;
		for (int i = 0; i < 4; i++) {
			if (board[i][i] != ch && board[i][i] != 'T') {
				found = false;
			}
		}
		if (found) {
			return true;
		}
		found = true;
		for (int i = 0; i < 4; i++) {
			if (board[3 - i][i] != ch && board[3 - i][i] != 'T') {
				found = false;
			}
		}
		if (found) {
			return true;
		}
		return false;
	}

	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(IN));
		BufferedWriter bw = new BufferedWriter(new FileWriter(OUT));
		int T = Integer.parseInt(br.readLine());
		for (int i = 0; i < T; i++) {
			char[][] board = new char[4][4];
			for (int j = 0; j < 4; j++) {
				String st = br.readLine();
				for (int k = 0; k < 4; k++) {
					board[j][k] = st.charAt(k);
				}
			}
			br.readLine();
			Status status = solve(board);
			String res = "";
			switch (status) {
			case X_WON:
				res = "X won";
				break;
			case O_WON:
				res = "O won";
				break;
			case DRAW:
				res = "Draw";
				break;
			case NOT_COMPLETE:
				res = "Game has not completed";
				break;
			}
			bw.write("Case #" + (i + 1) + ": " + res + "\n");
		}
		bw.close();
		br.close();
	}

}