import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.StringTokenizer;

import org.apache.commons.lang3.StringUtils;


public class CoinJam {
    private static final String INPUT_FILE = "e:/downloads/A-small-attempt0.in";
    private static final String OUTPUT_FOLDER = "C:/workspaces/algo/GCJ/src/";
    private static final String OUTPUT_FILE = "prolem-D.out";

    public static void main(String[] args) throws Exception {
        InputReader in = new InputReader(new FileInputStream(INPUT_FILE));
        PrintWriter pw = new PrintWriter(new File(OUTPUT_FOLDER, OUTPUT_FILE));
        int T = in.nextInt();
        for (int t = 1; t <= T; t++) {
            int N = in.nextInt();
            int J = in.nextInt();
            long minNum = Long.parseLong(1 + StringUtils.repeat('0', N - 2) + "1", 2);
            Map<String, List<Long>> nums = new LinkedHashMap<>();
            long num = minNum;
            while (nums.size() < J) {
                String binaryStr = Long.toBinaryString(num);
                if (binaryStr.endsWith("1")) {
                    System.out.println("Checking : " + binaryStr);
                    List<Long> divs = isCoin(binaryStr);
                    if (divs != null) {
                        nums.put(binaryStr, divs);
                    } else {
                        System.out.println(binaryStr + " is coin");
                    }
                }
                num++;
            }
            String res = String.format("Case #%d:\n", t);
            for (Entry<String, List<Long>> entry : nums.entrySet()) {
                res += entry.getKey();
                for (Long divisor : entry.getValue()) {
                    res += " " + divisor;
                }
                res += "\n";
            }
            pw.println(res);
            System.out.println(res);
        }
        pw.close();
    }

    private static List<Long> isCoin(String num) {
        List<Long> res = new ArrayList<>(9);
        for (int radix = 2; radix <= 10; radix++) {
            long convertedNum = Long.valueOf(num, radix);
            if (isPrime(convertedNum)) {
                res = null;
                break;
            }
            long divisor = getDivisor(convertedNum);
            res.add(divisor);
        }
        return res;
    }

    private static boolean isPrime(long num) {
        if (num % 2 == 0) {
            return false;
        }
        BigInteger t = BigInteger.valueOf(num);
        return t.isProbablePrime(40);
    }

    private static long getDivisor(long num) {
        if (num % 2 == 0) {
            return 2;
        }
        for (int i = 3; i <= Math.sqrt(num) + 1 && i < num; i += 2) {
            if (num % i == 0) {
                return i;
            }
        }
        throw new IllegalArgumentException(num + " does not have divisors");
    }

    public static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

    }

}
