import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

import org.apache.commons.lang3.ArrayUtils;

public class UpDown {
    private static final String inputName = "e:/downloads/B-small-attempt2.in";
    private static final String outputName = "C:/workspaces/algo/GCJ/src/prolemB.out";

    public static void main(String[] args) throws IOException, InterruptedException, ExecutionException {
        Scanner sc = new Scanner(new FileReader(inputName));
        // Scanner sc = new Scanner(System.in);
        int T = sc.nextInt();
        ExecutorService executor = Executors.newFixedThreadPool(4);
        List<Future<Long>> results = new ArrayList<>();
        for (int t = 0; t < T; t++) {
            int N = sc.nextInt();
            List<Integer> S = new ArrayList<>();
            for (int i = 0; i < N; i++) {
                S.add(sc.nextInt());
            }
            Future<Long> res = executor.submit(new Solver(S));
            results.add(res);
        }
        executor.shutdown();
        BufferedWriter bw = new BufferedWriter(new FileWriter(outputName));
        for (int t = 0; t < T; t++) {
            Long res = results.get(t).get();
            String str = String.format("Case #%s: %s\n", t + 1, res);
            bw.write(str);
            System.out.print(str);
        }
        bw.close();
    }

    private static class Solver implements Callable<Long> {
        private List<Integer> S;

        public Solver(List<Integer> s) {
            this.S = s;
        }

        public static int calc(int[] nums) {
            int[] sorted = Arrays.copyOf(nums, nums.length);
            Arrays.sort(sorted);
            int res = 0;
            for (int i = 0; i < nums.length; i++) {
                int ind = ArrayUtils.indexOf(nums, sorted[i]);
                for (int j = ind; j > i; j--) {
                    int t = nums[j];
                    nums[j] = nums[j - 1];
                    nums[j - 1] = t;
                    res++;
                }
            }
            return res;
        }

        @Override
        public Long call() throws Exception {
            Integer max = Collections.max(S);
            int maxPos = S.indexOf(max);
            long res = Integer.MAX_VALUE;
            for (int i = 0; i < S.size(); i++) {
                int tempRes = Math.abs(maxPos - i);
                List<Integer> nums = new ArrayList<>(S);
                nums.remove(max);
                if (i > 0) {
                    List<Integer> l = nums.subList(0, i);
                    int[] left = new int[l.size()];
                    for (int j = 0; j < l.size(); j++) {
                        left[j] = l.get(j);
                    }
                    tempRes += calc(left);
                }
                if (i < S.size() - 1) {
                    List<Integer> t = new ArrayList<>(nums);
                    List<Integer> l = t.subList(i, nums.size());
                    Collections.reverse(l);
                    int[] right = new int[l.size()];
                    for (int j = 0; j < l.size(); j++) {
                        right[j] = l.get(j);
                    }
                    tempRes += calc(right);
                }
                res = Math.min(res, tempRes);
            }
            return res;
        }

    }

}
