import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

import com.google.common.primitives.Ints;


public class PancakeRevenge {
    private static final String INPUT_FILE = "e:/downloads/B-large.in";
    private static final String OUTPUT_FOLDER = "C:/workspaces/algo/GCJ/src/";
    private static final String OUTPUT_FILE = "prolem-B.out";

    public static void main(String[] args) throws Exception {
        InputReader in = new InputReader(new FileInputStream(INPUT_FILE));
        PrintWriter pw = new PrintWriter(new File(OUTPUT_FOLDER, OUTPUT_FILE));
        int T = in.nextInt();
        for (int t = 1; t <= T; t++) {
            String st = in.next();
            boolean[] chars = new boolean[st.length()];
            for (int i = 0; i < chars.length; i++) {
                chars[i] = st.charAt(i) == '+';
            }
            int count = 0;
            for (int i = chars.length - 1; i >= 0; i--) {
                if (!chars[i]) {
                    count++;
                    for (int j = 0; j <= i; j++) {
                        chars[j] = !chars[j];
                    }
                }
            }
            String res = String.format("Case #%d: %d", t, count);
            pw.println(res);
            System.out.println(res);
        }
        pw.close();
    }

    private static List<Long> isCoin(String num, long[] divisors) {
        List<Long> res = new ArrayList<>(9);
        for (int radix = 2; radix <= 10; radix++) {
            Long convertedNum = Long.valueOf(num, radix);
            if (isPrime(convertedNum, divisors)) {
                res = null;
                break;
            }
            long divisor = getDivisor(convertedNum, divisors);
            res.add(divisor);
        }
        return res;
    }

    private static boolean isPrime(long num, long[] divisors) {
        if (num % 2 == 0) {
            return false;
        }
        int ind = getIndex(num);
        return divisors[ind] == 0;
    }

    private static long getDivisor(long num, long[] divisors) {
        if (num % 2 == 0) {
            return 2;
        }
        int ind = getIndex(num);
        return divisors[ind];
    }

    private static long getNumber(long index) {
        return 2 * index + 1;
    }

    private static int getIndex(long number) {
        return Ints.checkedCast((number - 1) / 2);
    }

    public static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

    }

}
