import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class FairAndSquare {

	private static final String OUT = "C:/workspaces/tc/CodeJam/src/fair.out";
	private static final String IN = "D:/downloads/C-small-attempt0.in";

	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(IN));
		BufferedWriter bw = new BufferedWriter(new FileWriter(OUT));
		int T = Integer.parseInt(br.readLine());
		for (int i = 0; i < T; i++) {
			StringTokenizer st = new StringTokenizer(br.readLine());
			int A = Integer.parseInt(st.nextToken());
			int B = Integer.parseInt(st.nextToken());
			int res = solve(A, B);
			bw.write("Case #" + (i + 1) + ": " + res + "\n");
		}
		bw.close();
		br.close();
	}

	private static int solve(int a, int b) {
		int res = 0;
		for (int i = a; i <= b; i++) {
			if (isSqr(i)) {
				if (isPalindrome(i)) {
					int sqrt = (int) Math.round(Math.sqrt(i));
					if (isPalindrome(sqrt)) {
						res++;
					}
				}
			}
		}
		return res;
	}

	private static boolean isSqr(int x) {
		double t = Math.sqrt(x);
		long rounded = Math.round(t);
		return x == rounded * rounded;
	}

	private static boolean isPalindrome(int x) {
		String st = Integer.toString(x);
		StringBuilder sb = new StringBuilder(st);
		st = sb.reverse().toString();
		return x == Integer.parseInt(st);
	}
}