import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

import com.google.common.collect.Iterables;

public class MagicTrick {

    private static final String inputName = "e:/downloads/A-small-attempt0.in";
    private static final String outputName = "C:/workspaces/algo/GCJ/src/prolemA.out";

    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new FileReader(inputName));
        BufferedWriter bw = new BufferedWriter(new FileWriter(outputName));
        int T = sc.nextInt();
        for (int t = 0; t < T; t++) {
            Set<Integer> cards1 = getSelectedCards(sc);
            Set<Integer> cards2 = getSelectedCards(sc);
            cards1.retainAll(cards2);
            int intersectionSize = cards1.size();
            String answer;
            switch (intersectionSize) {
            case 0:
                answer = "Volunteer cheated!";
                break;
            case 1:
                answer = Iterables.getOnlyElement(cards1).toString();
                break;
            default:
                answer = "Bad magician!";
                break;
            }
            String res = String.format("Case #%s: %s\n", t + 1, answer);
            bw.write(res);
        }
        bw.close();
    }

    private static Set<Integer> getSelectedCards(Scanner sc) {
        int r1 = sc.nextInt();
        int[][] cards1 = readCards(sc);
        Set<Integer> nums1 = new HashSet<>(6);
        for (int i = 0; i < 4; i++) {
            nums1.add(cards1[r1 - 1][i]);
        }
        return nums1;
    }

    private static int[][] readCards(Scanner sc) {
        int[][] cards1 = new int[4][4];
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                cards1[i][j] = sc.nextInt();
            }
        }
        return cards1;
    }

}
