import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class ProblemB {

	static String INPUT_FILE = "d:/downloads/B-small-attempt0.in";
	static String OUTPUT_FILE = "d:/downloads/b.out";

	public static boolean hasCenter(int[][] mass, int K, int r, int c) {
		long sumX = 0, sumY = 0;
		for (int i = 0; i < K; i++) {
			for (int j = 0; j < K; j++) {
				if (i == 0 && j == 0)
					continue;
				if (i == 0 && j == K - 1)
					continue;
				if (i == K - 1 && j == 0)
					continue;
				if (i == K - 1 && j == K - 1)
					continue;
				int cellValue = mass[r + i][c + j];
				if (K % 2 == 1) {
					if (i == K / 2 && j == K / 2)
						continue;
					int dy = K / 2 - i;
					int dx = K / 2 - j;
					sumX += cellValue * dx;
					sumY += cellValue * dy;
				} else {
					sumX += cellValue * (K - 1 - 2 * i);
					sumY += cellValue * (K - 1 - 2 * j);
				}
			}
		}
		return sumX == 0 && sumY == 0;
	}

	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new File(INPUT_FILE));
		PrintWriter pw = new PrintWriter(new File(OUTPUT_FILE));
		int T = sc.nextInt();
		for (int t = 1; t <= T; t++) {
			int R = sc.nextInt();
			int C = sc.nextInt();
			int D = sc.nextInt();
			int[][] mass = new int[R][C];
			for (int i = 0; i < R; i++) {
				String st = sc.next();
				for (int j = 0; j < C; j++) {
					mass[i][j] = st.charAt(j) - '0';
				}
			}
			System.out.println(Arrays.deepToString(mass));
			boolean found = false;
			int res = -1;
			for (int K = Math.min(R, C); K >= 3 && !found; K--) {
				for (int r = 0; r <= R - K && !found; r++) {
					for (int c = 0; c <= C - K; c++) {
						if (hasCenter(mass, K, r, c)) {
							found = true;
							res = K;
							break;
						}
					}
				}
			}
			if (res != -1)
				pw.println("Case #" + t + ": " + res);
			else {
				pw.println("Case #" + t + ": IMPOSSIBLE");
			}
		}
		pw.close();
	}

}
