import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class DataPacking {
    private static final String inputName = "e:/downloads/A-large.in";
    private static final String outputName = "C:/workspaces/algo/GCJ/src/prolemA.out";

    public static void main(String[] args) throws IOException, InterruptedException, ExecutionException {
        Scanner sc = new Scanner(new FileReader(inputName));
        // Scanner sc = new Scanner(System.in);
        int T = sc.nextInt();
        ExecutorService executor = Executors.newFixedThreadPool(4);
        List<Future<Long>> results = new ArrayList<>();
        for (int t = 0; t < T; t++) {
            int N = sc.nextInt();
            int X = sc.nextInt();
            int[] S = new int[N];
            for (int i = 0; i < N; i++) {
                S[i] = sc.nextInt();
            }
            Future<Long> res = executor.submit(new Solver(X, S));
            results.add(res);
        }
        BufferedWriter bw = new BufferedWriter(new FileWriter(outputName));
        for (int t = 0; t < T; t++) {
            Long res = results.get(t).get();
            String str = String.format("Case #%s: %s\n", t + 1, res);
            bw.write(str);
            System.out.print(str);
        }
        bw.close();
    }

    private static class Solver implements Callable<Long> {
        private int X;
        private int[] s;

        public Solver(int x, int[] s) {
            X = x;
            this.s = s;
        }


        @Override
        public Long call() throws Exception {
            Arrays.sort(s);
            int N = s.length;
            int left = 0;
            long res = 0;
            for (int i = N - 1; i >= left; i--) {
                if (left < i && s[i] + s[left] <= X) {
                    left++;
                }
                res++;
            }
            return res;
        }

    }
}
