import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Lawnmower {

	private static final String OUT = "C:/workspaces/tc/CodeJam/src/lawn.out";
	private static final String IN = "D:/downloads/B-small-attempt0.in";

	public static String solve(int[][] lawn) {
		int total = lawn.length + lawn[0].length;
		for (int i = 0; i < 1 << total; i++) {
			boolean[] lines = new boolean[lawn.length];
			int M = lines.length;
			for (int j = 0; j < M; j++) {
				int t = i & 1 << j;
				if (t > 0) {
					lines[j] = true;
				}
			}
			boolean[] columns = new boolean[lawn[0].length];
			int N = columns.length;
			for (int j = 0; j < N; j++) {
				int t = i & 1 << (j + M);
				if (t > 0) {
					columns[j] = true;
				}
			}
			int[][] temp = new int[M][N];
			for (int j = 0; j < M; j++) {
				Arrays.fill(temp[j], 2);
			}
			for (int j = 0; j < M; j++) {
				if (lines[j]) {
					for (int k = 0; k < N; k++) {
						temp[j][k] = 1;
					}
				}
			}
			for (int j = 0; j < N; j++) {
				if (columns[j]) {
					for (int k = 0; k < M; k++) {
						temp[k][j] = 1;
					}
				}
			}
			if (Arrays.deepEquals(lawn, temp)) {
				return "YES";
			}
		}
		return "NO";
	}

	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader br = new BufferedReader(new FileReader(IN));
		BufferedWriter bw = new BufferedWriter(new FileWriter(OUT));
		int T = Integer.parseInt(br.readLine());
		for (int i = 0; i < T; i++) {
			StringTokenizer st = new StringTokenizer(br.readLine());
			int M = Integer.parseInt(st.nextToken());
			int N = Integer.parseInt(st.nextToken());
			int[][] lawn = new int[M][N];
			for (int j = 0; j < M; j++) {
				st = new StringTokenizer(br.readLine());
				for (int k = 0; k < N; k++) {
					lawn[j][k] = Integer.parseInt(st.nextToken());
				}
			}
			String res = solve(lawn);
			bw.write("Case #" + (i + 1) + ": " + res + "\n");
		}
		bw.close();
		br.close();
	}

}