import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

import org.apache.commons.math.fraction.BigFraction;

public class ProblemA {

	static String INPUT_FILE = "d:/downloads/A-small-attempt1 (2).in";
	static String OUTPUT_FILE = "d:/downloads/a1.out";

	public static class Walkway implements Comparable<Walkway> {
		@Override
		public String toString() {
			return "Walkway [length=" + length + ", w=" + w + "]";
		}

		int length, w;

		public Walkway(int length, int w) {
			this.length = length;
			this.w = w;
		}

		public int getLength() {
			return length;
		}

		@Override
		public int compareTo(Walkway arg0) {
			return w - arg0.w;
		}
	}

	public static double solveTask(int X, int S, int R, int t,
			List<Walkway> walkways) throws Exception {
		int sum = 0;
		System.out.println("new case t : " + t);
		for (Walkway w : walkways) {
			sum += w.getLength();
		}
		walkways.add(new Walkway(X - sum, 0));
		Collections.sort(walkways);
		BigFraction res = BigFraction.ZERO;
		BigFraction time = new BigFraction(t);
		for (Walkway w : walkways) {
			BigFraction rtfr = new BigFraction(w.getLength(), w.w + R);
			System.out.println(rtfr + " : " + time);
			if (time.equals(BigFraction.ZERO)) {
				res = res.add(new BigFraction(w.getLength(), S + w.w));
			} else if (rtfr.compareTo(time) <= 0) {
				time = time.subtract(rtfr);
				res = res.add(rtfr);
			} else {
				res = res.add(time);
				BigFraction len = time.multiply(new BigFraction(w.w + R))
						.negate().add(new BigFraction(w.getLength()));
				res = res.add(len.divide(S + w.w));
				time = BigFraction.ZERO;
			}
		}
		return res.doubleValue();
	}

	public static void main(String[] args) throws Exception {
		Scanner sc = new Scanner(new File(INPUT_FILE));
		PrintWriter pw = new PrintWriter(new File(OUTPUT_FILE));
		int T = sc.nextInt();
		for (int test = 1; test <= T; test++) {
			int X = sc.nextInt();
			int S = sc.nextInt();
			int R = sc.nextInt();
			int t = sc.nextInt();
			int N = sc.nextInt();
			List<Walkway> walkways = new ArrayList<ProblemA.Walkway>();
			for (int i = 0; i < N; i++) {
				Walkway w = new Walkway(-sc.nextInt() + sc.nextInt(),
						sc.nextInt());
				walkways.add(w);
			}
			double res = solveTask(X, S, R, t, walkways);
			System.out.println("Res : " + res);
			pw.println("Case #" + test + ": " + res);
		}
		pw.close();
	}

}
