package by.khamenka.gcj.qual2017;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.StringTokenizer;
import java.util.concurrent.Callable;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

import com.google.common.math.BigIntegerMath;

public class ProblemA {

    private static final String INPUT_FILE = "d:/downloads/A-small-attempt0.in";
    private static final String OUTPUT_FOLDER = "d:/downloads/";
    private static final String OUTPUT_FILE = "A-small.out";

    public static void main(String[] args) throws Exception {
//        InputReader in = new InputReader(System.in);
//        PrintWriter pw = new PrintWriter(System.out);
        InputReader in = new InputReader(new FileInputStream(INPUT_FILE));
        PrintWriter pw = new PrintWriter(new File(OUTPUT_FOLDER, OUTPUT_FILE));
        int T = in.nextInt();
        for (int t = 1; t <= T; t++) {
            String res = solve(in.next(), in.nextInt());
            pw.write(String.format("Case #%d: %s\n", t, res));
        }
        pw.close();
    }

    private static String solve(String input, int K) {
        boolean[] p = new boolean[input.length()];
        for (int i = 0; i < input.length(); i++) {
            p[i] = input.charAt(i) == '+';
        }
        int res = 0;
        for (int i = 0; i <= input.length() - K; i++) {
            if (!p[i]) {
                res++;
                for (int j = 0; j < K; j++) {
                    p[i + j] = !p[i + j];
                }
            }
        }
        for (int i = 0; i < input.length(); i++) {
            if (!p[i]) {
                return "IMPOSSIBLE";
            }
        }
        return "" + res;
    }

    public static class InputReader {

        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

    }

}
