import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.LinkedList;
import java.util.Queue;
import java.util.StringTokenizer;

public class BotTrust {

	public static final String fileName = "d:/downloads/A-large.in";

	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(fileName));
		int T = Integer.parseInt(br.readLine());
		for (int t = 0; t < T; t++) {
			StringTokenizer st = new StringTokenizer(br.readLine());
			int N = Integer.parseInt(st.nextToken());
			int prevO = 1, prevB = 1;
			Queue<Integer> oLen = new LinkedList<Integer>();
			Queue<Integer> bLen = new LinkedList<Integer>();
			Queue<Character> nextCommands = new LinkedList<Character>();
			for (int j = 0; j < N; j++) {
				char roboId = st.nextToken().charAt(0);
				int dest = Integer.parseInt(st.nextToken());
				if (roboId == 'O') {
					oLen.add(Math.abs(dest - prevO));
					prevO = dest;
				}
				if (roboId == 'B') {
					bLen.add(Math.abs(dest - prevB));
					prevB = dest;
				}
				nextCommands.add(roboId);
			}
			Queue<Character> oq = new LinkedList<Character>();
			Queue<Character> bq = new LinkedList<Character>();
			if (oLen.size() > 0) {
				int len = oLen.poll();
				for (int i = 0; i < len; i++) {
					oq.add('g');
				}
			}
			if (bLen.size() > 0) {
				int len = bLen.poll();
				for (int i = 0; i < len; i++) {
					bq.add('g');
				}
			}
			if (nextCommands.poll() == 'O') {
				oq.add('p');
			} else {
				bq.add('p');
			}
			int time = 0;
			while (true) {
				time++;
				if (bq.isEmpty() && oq.isEmpty()) {
					break;
				}
				Character oc = oq.poll();
				Character bc = bq.poll();
				if (oc == null)
					oc = '#';
				if (bc == null)
					bc = '#';
				if ('p' == oc || 'p' == bc) {
					Character nc = nextCommands.poll();
					if (nc == null)
						nc = '#';
					if ('p' == oc) {
						if (oLen.size() > 0) {
							int len = oLen.poll();
							for (int i = 0; i < len; i++) {
								oq.add('g');
							}
						}
					} else {
						if (bLen.size() > 0) {
							int len = bLen.poll();
							for (int i = 0; i < len; i++) {
								bq.add('g');
							}
						}
					}
					if (nc == 'O') {
						oq.add('p');
					}
					if (nc == 'B') {
						bq.add('p');
					}
				}
			}
			System.out.println("Case #" + (t + 1) + ": " + (time - 1));
		}
		br.close();
	}
}
