package codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Random;

public class ProblemC {
	
	public static void main(String[] args) throws IOException {
		FileReader fileReader = new FileReader(new File(args[0]));
		
		BufferedReader bufferedReader = new BufferedReader(fileReader);
		
		File outFile = new File(args[0].replaceAll("\\.\\w+$", ".out"));
		outFile.delete();
		
		FileWriter fileWriter = new FileWriter(outFile,	true);
		
		String readLine = bufferedReader.readLine();
		
		int c = Integer.parseInt(readLine);
		
		
		for (int i = 1; i <= c; i++) {
			readLine = bufferedReader.readLine();
			String[] input = readLine.split(" ");
			//prison cells
			int p = Integer.parseInt(input[0]);
			int q = Integer.parseInt(input[1]);
			
			String[] split = bufferedReader.readLine().split(" ");
			
			int pc[] = new int[split.length];
			
			for (int j = 0; j < pc.length; j++) {
				pc[j] = Integer.parseInt(split[j]);
			}
			
			
			List<int[]> makeCombs = makeCombs(pc);
			
			long min = Long.MAX_VALUE; 
			
			for (int v = 0; v < makeCombs.size(); v++) {
				
				pc = makeCombs.get(v);
				long totalCoins = 0;
				for (int j = 0; j < pc.length; j++) {
					
					for (int j2 = pc[j]+1; j2 <= p; j2++) {
						//if already release
						boolean released = false;
						for (int k = 0; k <= j; k++) {
							if (j2 == pc[k]) {
								released = true;
								break;
							}
						}
						
						if (released)
							break;
						else
							totalCoins++;
					}
					for (int j2 = pc[j]-1; j2 >= 1; --j2) {
						
						//if already release
						boolean released = false;
						for (int k = 0; k <= j; k++) {
							if (j2 == pc[k]) {
								released = true;
								break;
							}
						}
						
						if (released)
							break;
						else
							totalCoins++;
						
					}
					
					
				}
				
				if (min > totalCoins) {
					min = totalCoins;
				}
				
				if (min == 0)
					break;
			
			}
			String out = "Case #"+i+": "+min;
			System.out.println(out);
			fileWriter.append(out);
			fileWriter.append("\n");
		}
		
		
		//end logic
		fileWriter.flush();
		
		System.exit(0);
	}
	
	public static List<int[]> makeCombs(int[] a) {
		List<int[]> combs = new ArrayList<int[]>(a.length * a.length);
		Arrays.sort(a);
		combs.add(a);
		
		for (int j = 0; j < a.length; j++) {
			for (int i = 0; i < a.length-1; i++) {
				swap(a, i, i+1);
				
				int[] dest = new int[a.length];
				System.arraycopy(a, 0, dest , 0, a.length);
				combs.add(dest);
			}
		}
		Random random = new Random();
		for (int i = 0; i < 100; i++) {
			swap(a, Math.abs(random.nextInt())%a.length, Math.abs(random.nextInt())%a.length);
			int[] dest = new int[a.length];
			System.arraycopy(a, 0, dest , 0, a.length);
			combs.add(dest);
		}
		
		return combs;
	}

	private static void swap(int[] a, int i, int j) {
		int temp = a[i];
		a[i] = a[j];
		a[j] = temp;
	}
	
}
