package qualification;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import codejam.CodeJam;

public class Magicka extends CodeJam {
	
	public Magicka(String file) throws Exception {
		super(file, -1);
	}
	
	class Comb {
		
		public Comb(char a, char b, char result) {
			this.a = a;
			this.b = b;
			this.result = result;
		}
		char a;
		char b;
		char result;
		
	}
	
	class Op {
		
		public Op(char a, char b) {
			this.a = a;
			this.b = b;
		}
		char a;
		char b;
		
	}
	
	@Override
	public Object processCase(int caseNumber) throws Exception {
		String[] codesStr = readLine().split(" ");
		
		int comb = Integer.parseInt(codesStr[0]);
		
		HashMap<String, Comb> combs = new HashMap<String, Magicka.Comb>(comb);
		
		for (int i = 1; i < comb+1; i++) {
			String string = codesStr[i];
			combs.put(string.charAt(0)+""+string.charAt(1), new Comb(string.charAt(0),string.charAt(1), string.charAt(2)));
		}
		
		int oposite = Integer.parseInt(codesStr[1+comb]);
		List<Op> oposites = new ArrayList<Op>(oposite);
		
		for (int i = 2+comb; i < oposite+2+comb; i++) {
			String string = codesStr[i];
			oposites.add(new Op(string.charAt(0),string.charAt(1)));
		}
		
		String seq = codesStr[3+comb+oposite];
		
		char[] result = new char[seq.length()]; 
		
		int c = 0;
		for (int i = 0; i < seq.length(); i++) {
			char currentChar = seq.charAt(i); 
			if (c == 0) {
				result[c++] = currentChar;
				continue;
			}
			Comb combination = combs.get(result[c-1]+""+currentChar);
			if (combination == null) combination = combs.get(currentChar+""+result[c-1]);
			
			if (combination != null) {
				result[c-1] = combination.result;
				continue;
			} 
			result[c] = currentChar;
			if (containsOp(oposites, result, c)) {
				c = 0;
				continue;
			}
			c++;
		}
		StringBuilder r = new StringBuilder("[");
		for (int i = 0; i < c; i++) {
			if (i > 0) {
				r.append(", ");
			}
			r.append(result[i]);
		}
		r.append(']');
		return r;
	}

	private boolean containsOp(List<Op> oposites, char newC[], int len) {
		for (Op op : oposites) {
			boolean containsA = false;
			boolean containsB = false;
			for (int j = 0; j <= len; j++) {
				char c = newC[j];
				if (c == op.a) {
					if (containsB)return true;
					containsA = true;
				} else if (c == op.b){
					if (containsA)return true;
					containsB = true;
				}
			}
		}
		return false;
	}
	
	
	
	public static void main(String[] args) throws Exception {
		new Magicka(args[0]).start();
	}

}
