package codejam;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashSet;
import java.util.Set;

public class QualificationC extends CodeJam {

	public QualificationC(String file) throws Exception {
		super(file,1);
	}
	
	@Override
	public Object processCase(int caseNumber) throws Exception {
		long[] limits = readLongArray(caseNumber, 0);
		
		long start = limits[0];
		long end = limits[1];
		
		return countPerfectPalindromes(start, end) +""; 
		
	}

	static long CACHE[] = {0,1,4,9,121,484,10201,12321,14641,40804,44944,1002001,1234321,4008004,100020001,102030201,104060401,121242121,123454321,125686521,400080004,404090404,10000200001l,10221412201l,12102420121l,12345654321l,40000800004l,1000002000001l,1002003002001l,1004006004001l,1020304030201l,1022325232201l,1024348434201l,1210024200121l,1212225222121l,1214428244121l,1232346432321l,1234567654321l,4000008000004l,4004009004004l};
	
	private static long maxKnowedValue() {
		return CACHE[CACHE.length-1];
	}
	
	private static long countPerfectPalindromes(long start, long end) {
		long found = 0;
		
		for (long n: CACHE) {
			if (n < start) continue;
			if (n > end) return found;
			
			found++;
		}
		
		//lets give up to search more, it would take to much time. 
//		for (long n = maxKnowedValue(); n <= end; n++) {
//			
//			int lastHex = (int)(n & 0xF);
//			
//			if (lastHex != 0 && lastHex != 1 && lastHex != 4 && lastHex != 9) continue;
//			
//			if (!isPalindromeNumber(n)) continue;
//			
//			long tst;
//	        tst = (long)Math.sqrt(n);
//	        if (tst*tst == n) {
//	        	if (isPalindromeNumber(tst)) {
//	        		found++;
//	        	}
//	        }	
//			
//		}
		return found;
	}
	
	//used by generator
	public static String reverseNumber(long n) {
		char[] charArray = (n+"").toCharArray();
		reverse(charArray);
		return new String(charArray);
	}
	
	//used by generator
	public static boolean isPerfectPalindrome(long n) {
		int lastHex = (int)(n & 0xF);
		
		if (lastHex != 0 && lastHex != 1 && lastHex != 4 && lastHex != 9) return false;
		
		long tst;
        tst = (long)Math.sqrt(n);
        if (tst*tst == n && isPalindromeNumber(tst)) {
        	return true;
        }	
        return false;
	}
	
	public static void main(String[] args) throws IOException,
			InterruptedException, Exception {
		//generator
//		Set<Long> found = new HashSet<Long>();
//		
//		long max = (long) Math.pow(10, 7);
//		
//		long biggerNumberSearched = 0;
//		
//		for (long i = 1; i < max; i++) {
//			for (long j = 0; j <= 9; j++) {
//				if (isPerfectPalindrome(j)) {
//					found.add(j);
//				}
//			}
//			
//			long n = Long.parseLong(i+""+reverseNumber(i));
//			if (isPerfectPalindrome(n)) {
//				found.add(n);
//			}
//			for (int j = 0; j <= 9; j++) {
//				n = Long.parseLong(i+""+j+""+reverseNumber(i));
//				if (isPerfectPalindrome(n)) {
//					System.out.println(n);
//					found.add(n);
//				}
//				biggerNumberSearched = n;
//			}
//			
//			
//			
//		}
//		ArrayList<Long> arrayList = new ArrayList<Long>(found);
//		Collections.sort(arrayList);
//		
//		for (Long long1 : arrayList) {
//			System.out.print(long1+",");
//		}
//		
//		System.out.println("BiggerNumberSearched: "+biggerNumberSearched);
		
		
		new QualificationC("C-large-1.in").start();
//		System.out.println(countPerfectPalindromes(0, (long)Math.pow(10, 12)));

	}
	
	
}
