package codejam;
import java.io.IOException;

public class QualificationA extends CodeJam {

	public QualificationA(String file) throws Exception {
		super(file);
	}

	@Override
	public Object processCase(int caseNumber) throws Exception {
		//skip empty line
		if (caseNumber > 1) readLine();
		
		boolean hasEmptyFields = false;
		
		char board[] = new char[16];
		
		//read four lines searching for line win 
		for (int i = 0; i < 4; i++) {
			String readLine = readLine();
			char[] charArray = readLine.toCharArray();
			
			//lines
			String hasWin = hasWin(charArray, 1, 0);
			if (hasWin == null) {
				hasEmptyFields = true;
			} else if (!hasWin.isEmpty()) {
				for (int j = 0; j < 3-i; j++) {
					readLine();
				}
				return hasWin;
			}
			System.arraycopy(charArray, 0, board, i*4, 4);
		}
		
		//diagonal right to left
		String hasWin = hasWin(board, 5, 0);
		
		if (hasWin != null && !hasWin.isEmpty()) {
			return hasWin;
		}
		
		//diagonal left to right
		hasWin = hasWin(board, 3, 3);
		
		if (hasWin != null && !hasWin.isEmpty()) {
			return hasWin;
		}
		
		//columns
		for (int i = 0; i < 4; i++) {
			hasWin = hasWin(board, 4, i);
			
			if (hasWin != null && !hasWin.isEmpty()) {
				return hasWin;
			}
		}
		
		return hasEmptyFields?"Game has not completed":"Draw";
	}

	private String hasWin(char[] charArray, int disivible, int startFrom) {
		byte o = 0;
		byte x = 0;
		byte t = 0;
		
		byte counted = 0;
		
		for (int pos = startFrom; pos < charArray.length; pos+=disivible) {
			
			if (counted++ == 4) break;
			
			char c = charArray[pos];
			
			if (c == '.') return null;
			
			if (c == 'O') {
				o++;
			} else if (c == 'X') {
				x++;
			} else {
				t++;
			}
		}
		
		if (o == 4 || (o == 3 && t == 1)) {
			return "O won";
		} else if (x == 4 || (x == 3 && t == 1)) {
			return "X won";
		}
		
		return "";
		
	}

	public static void main(String[] args) throws IOException,
			InterruptedException, Exception {
		new QualificationA("A-large.in").start();

	}
	
	
}
