import java.io.IOException;

public class SnapperChain extends CodeJam {

	public SnapperChain(String file) throws Exception {
		super(file);
	}

	@Override
	public Object processCase(int caseNumber) throws Exception {
		String[] data = readLine().split(" ");
		int numberOfDevices = Integer.parseInt(data[0]);
		int snappes = Integer.parseInt(data[1]);

		if (snappes == 0)
			return "OFF";

		if (caseNumber == 5) {
			System.out.println("opa");
		}
		
		int minToggles = minToggles(numberOfDevices);
		
		if (minToggles == snappes) return "ON";
		
		snappes -= minToggles;
		
		return snappes%(minToggles+1)==0?"ON":"OFF";
//		boolean[] state = new boolean[numberOfDevices];// POWER, ON
//
//		int lastDeviceWithPower = 0;
//		
//		for (int y = 0; y < snappes; y++) {
//			lastDeviceWithPower = toggle(state, 0, lastDeviceWithPower);
//			//toggle(state, 0, true);
////			for (int i = 0; i < numberOfDevices; i++) {
////				if (i <= lastDeviceWithPower) {// has power
////					boolean ON = state[i];// toggle
////					state[i] = !ON; // toggle
////					if (i + 1 < numberOfDevices) {
////						//state[i + 1][0] = state[i][0];// power for the next
////					}
////				} else {
////					break;
////				}
////			}
//		}
		//return lastDeviceWithPower == numberOfDevices -1 && state[numberOfDevices - 1] ? "ON": "OFF";
	}

	/**
	 * Initially, all the Snappers are in the OFF state, so only the first one
	 * is receiving power from the socket, and the light is off. I snap my
	 * fingers once, which toggles the first Snapper into the ON state and gives
	 * power to the second one. I snap my fingers again, which toggles both
	 * Snappers and then promptly cuts power off from the second one, leaving it
	 * in the ON state, but with no power. I snap my fingers the third time,
	 * which toggles the first Snapper again and gives power to the second one.
	 * Now both Snappers are in the ON state, and if my light is plugged into
	 * the second Snapper it will be on.
	 * 
	 */
	
	private int minToggles(int numberOfDevices) {
		boolean[] state = new boolean[numberOfDevices];// POWER, ON
		int lastDeviceWithPower = 0;
		int count=0;
		
		do {
			lastDeviceWithPower = toggle(state, 0, lastDeviceWithPower);
			count++;
			//System.out.print(count+" count "+Arrays.toString(state) + " > " + lastDeviceWithPower+" dev "+numberOfDevices);
			//System.out.println(" "+(lastDeviceWithPower >= numberOfDevices-1 && state[numberOfDevices-1]));
		} while(!(lastDeviceWithPower >= numberOfDevices-1 && state[numberOfDevices-1]));
		//System.out.println("min"+count);
		return count;
	}
	
	private int toggle(boolean state[], int i, int lastDeviceWithPower) {
		if (i < lastDeviceWithPower) {
			state[i] = !state[i];
			toggle(state, i+1, lastDeviceWithPower);
			
			if (!state[i]) {
				lastDeviceWithPower = i;
			}
			
		} else if (i == lastDeviceWithPower) {
			state[i] = !state[i];
			if (state[i] && i < state.length -1) {
				for (int j = i; j < state.length; j++) {
					if (state[j] && j < state.length-1)continue;
					
					lastDeviceWithPower = j;
					break;
				}
				
			}
		}
		return lastDeviceWithPower;
	}

	private void toggle(boolean[][] state, int i, boolean putPower) {
		boolean ON = state[i][1];// toggle
		state[i][1] = !ON; // toggle
		if (!putPower) {
			state[i][0] = false;
			powerOn(state, i+1, false);
			return;
		}
		if (i + 1 < state.length && state[i + 1][0]) {// if the next is power on
			toggle(state, ++i, state[i][1]);//toggle
		} else if (i + 1 < state.length && state[i][0]) {// if the next is power
			powerOn(state, i+1, true);
		}
	}
	
	private void powerOn(boolean[][] state, int i, boolean on) {
		if (i < state.length) {
			if (state[i][0]) {
				state[i][0] = on;
				powerOn(state, i+1, on);
			}
		}
	}

	public static void main(String[] args) throws IOException,
			InterruptedException, Exception {
		new SnapperChain(args[0]).start();
	}
}
