package codejam;

import java.io.IOException;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.regex.Pattern;

public class B extends CodeJam {

	public B(String file) throws Exception {
		super(file,1);
	}

	@Override
	public Object processCase(int caseNumber) throws Exception {
		BigInteger number = new BigInteger(readLine(caseNumber, 0));
		
		while (!isTidyNumber3(number)) {
			String[] numbers = number.toString().split("0", 2);
			if (numbers.length == 2 && numbers[1].replace("0", "").length() > 0) {
				number = number.subtract(new BigInteger(numbers[1]));
			} else {
				number = number.subtract(new BigInteger("1",10));
			}
		}
		return number;
	}
	
	private BigInteger TEN = new BigInteger("10");
	private BigInteger ZERO = new BigInteger("0");
	
	Pattern patter = Pattern.compile("0*1*2*3*4*5*6*7*8*9*");
	
	private boolean isTidyNumber4(BigInteger number) {
		String string = number.toString();
		return patter.matcher(string).matches();
	}
	
	private boolean isTidyNumber3(BigInteger number) {
		int current = -1;
		while (number.compareTo(ZERO) > 0) {
			BigInteger mod = number.mod(TEN);
			int intValue = mod.intValue();
			
			number = number.divide(TEN);
			if (current == -1) {
				current = intValue;
				continue;
			}
			
			if (intValue > current) return false;
			
			current = intValue;
		}
		
		return true;

	}
	
	private boolean isTidyNumber2(BigInteger number) {
		char[] charArray = number.toString().toCharArray();
		
		int current = -1;
		for (int i = 0; i < charArray.length; i++) {
			if (i == 0) {
				current = charArray[0]-48;
				continue;
			}

			int c = charArray[i]-48;

			if (c < current)
				return false;
			
			current = c;
		}

		return true;

	}

	private boolean isTidyNumber(BigInteger number) {
		String string = number.toString();
		char[] a = string.toCharArray();
		char[] b = string.toCharArray();
		
		Arrays.sort(b);
		
		int length = a.length;
		
		for (int i=length-1; i>=0; i--)
            if (a[i] != b[i])
                return false;

        return true;
		
	}

	public static void main(String[] args) throws IOException, InterruptedException, Exception {
		new B("B-small-attempt0.in").start();

	}

}
