package codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;

public class ProblemA {
	
	public static final char DIGITS[] = {'1','0','2','3','4','5','6','7','8','9','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'};
	
	public static void main(String[] args) throws IOException {
		FileReader fileReader = new FileReader(new File(args[0]));
		
		BufferedReader bufferedReader = new BufferedReader(fileReader);
		
		File outFile = new File(args[0].replaceAll("\\.\\w+$", ".out"));
		outFile.delete();
		
		FileWriter fileWriter = new FileWriter(outFile,	true);
		
		//logic goes here
		
		String readLine = bufferedReader.readLine();

		int t = Integer.parseInt(readLine);

		// logic goes here
		for (int i = 1; i <= t; i++) {
			
			String numberStr = bufferedReader.readLine();
			
			int countDigits = countDigits(numberStr);
			
			numberStr = formatToMinimalMnumber(numberStr, countDigits);
			
			if (countDigits == 1) {
				countDigits = 2;
			}
			BigInteger bigInteger = new BigInteger(numberStr, countDigits);
			
			long parseLong = Long.parseLong(bigInteger.toString());
			
			String out = "Case #"+i+": "+parseLong;
			
			System.out.println(out);
			fileWriter.write(out);
			fileWriter.write("\n");			
		}	
		
		//end logic
		fileWriter.flush();
		
		System.exit(0);
	}

	private static int countDigits(String numberStr) {
		
		char[] counted = new char[numberStr.length()];
		int countedLen = 0;
		
		for (int i = 0; i < numberStr.length(); i++) {
			char c = numberStr.charAt(i);
			
			boolean contains = false;
			for (int j = 0; j < i; j++) {
				if (c == counted[j]) {
					contains = true;
					break;
				}
			}
			
			if (!contains) {
				counted[countedLen++] = c;
			}
		}
		
		return countedLen;
	}
	
	private static String formatToMinimalMnumber(String number, int digits) {
		Map<Character, Character> map = new HashMap<Character, Character>();
		
		int used = 0;
		
		StringBuilder formatedNumber = new StringBuilder();
		
		for (int i = 0; i < number.length(); i++) {
			char c = number.charAt(i);
			
			Character maped = map.get(c);
			
			Character outC = null;
			if (maped == null) {
				
				outC = DIGITS[used++];
				
				map.put(c, outC);
			} else {
				outC = maped;
			}
			
			formatedNumber.append(outC);
			
		}
		
		return formatedNumber.toString();
	}
	
	private static int maxBase(String numberStr) {
		
		char max = (char)Integer.MIN_VALUE;
		
		for (int i = 0; i < numberStr.length(); i++) {
			char c = numberStr.charAt(0);
			
			if (c > max) {
				max = c;
			}
		}
		
		if (max >= 65) {
			return 10+max-96;
		}
		
		return max - 46;
	}
	

}
