package codejam;
import java.awt.Point;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class QualificationD extends CodeJam {

	public QualificationD(String file) throws Exception {
		super(file);
		verbose = false;
	}
	
	@Override
	public Object processCase(int caseNumber) throws Exception {
//		if (caseNumber == 3) {
//			System.out.println("QualificationD.processCase()");
//		}
		int[] readIntArray = readIntArray();
		
		int x = readIntArray[0];
		int lines = readIntArray[1];
		int columns = readIntArray[2];
		
		if ((lines * columns)%x != 0) {
			return "RICHARD";
		} else {
			List<Omino> resultList = getOminos(x);
			for (Omino omino : resultList) {
				Point maxPoint = omino.getMaxPoint();
				if (Math.min(maxPoint.x+1, maxPoint.y+1) > Math.min(lines, columns)) {
					return "RICHARD";
				}
			}
		}
		
		List<Omino> resultList = getOminos(x);
		
		if (verbose) {
			for (Omino omino : resultList) {
				omino.print();
			}
		}
		
		boolean board[][] = new boolean[columns][lines];
		
		boolean canSolve = false;
		
GO_TO_N:for (Omino ominoT : resultList) {
			
			List<Omino> rotations = ominoT.getRotations();
			
			ArrayList<Omino> incompatibles = new ArrayList<QualificationD.Omino>();
			for (Omino omino : rotations) {
				Point maxPoint = omino.getMaxPoint();
				if (maxPoint.x >= columns || maxPoint.y >= lines) {
					incompatibles.add(omino);
					continue;
				}
			}
			
			rotations.removeAll(incompatibles);
			
			if (rotations.isEmpty()) {
				canSolve = false;
			}
			
			for (Omino omino : rotations) {
			
				for (int i = 0; i < board.length; i++) {
					for (int j = 0; j < board[0].length; j++) {
						
						Point p[] = omino.points;
						
						boolean[][] boardClone = cloneGrid(board);
						
						boolean fit = true;
						for (int k = 0; k < p.length; k++) {
							if (p[k].x + i < boardClone.length && p[k].y + j < boardClone[0].length && boardClone[p[k].x + i][p[k].y + j] == false) {
								boardClone[p[k].x + i][p[k].y + j] = true;
							} else {
								fit = false;
								break;
							}
						} 
						boolean reflectUsed = false;
						if (!fit && omino.reflect()) {
							reflectUsed = true;
							boardClone = Arrays.copyOf(board, board.length);
							fit = true;
							for (int k = 0; k < p.length; k++) {
								if (p[k].x + i < boardClone.length && p[k].y + j < boardClone[0].length && boardClone[p[k].x + i][p[k].y + j] == false) {
									boardClone[p[k].x + i][p[k].y + j] = true;
								} else {
									fit = false;
									break;
								}
							}
						}
						
						printBoard(boardClone);
						
						if (fit) {
							boolean solved = isSolved(boardClone);
							if (solved) {
								canSolve = true;
							} else {
//								if (caseNumber == 62) {
//									System.out
//											.println("QualificationD.processCase()");
//								}
								canSolve = canSolve(boardClone, resultList);
							}
							if (canSolve) continue GO_TO_N;
						}
						
						//try reflect
						if (!reflectUsed && omino.reflect()) {
							reflectUsed = true;
							boardClone = Arrays.copyOf(board, board.length);
							fit = true;
							for (int k = 0; k < p.length; k++) {
								if (p[k].x + i < boardClone.length && p[k].y + j < boardClone[0].length && boardClone[p[k].x + i][p[k].y + j] == false) {
									boardClone[p[k].x + i][p[k].y + j] = true;
								} else {
									fit = false;
									break;
								}
							}
						}
						
						printBoard(boardClone);
						
						if (fit) {
							boolean solved = isSolved(board);
							if (solved) {
								canSolve = true;
							} else {
//								if (caseNumber == 62) {
//									System.out
//											.println("QualificationD.processCase()");
//								}
								canSolve = canSolve(boardClone, resultList);
							}
							if (canSolve) continue GO_TO_N;
						}
					}
				}
			
			}
			
			if (!canSolve) {
				return "RICHARD";
			}
		}
		
		return canSolve?"GABRIEL":"RICHARD";
		
	}
	
	private boolean canSolve(boolean [][]board, List<Omino> ominos) {
		for (Omino ominoT : ominos) {
			
			List<Omino> rotations = ominoT.getRotations();
			for (Omino omino : rotations) {
				boolean fit = true;
				do {
					for (int i = 0; i < board.length; i++) {
						for (int j = 0; j < board[0].length; j++) {
							
							Point p[] = omino.points;
							
							boolean[][] boardClone = cloneGrid(board);
							
							fit = true;
							for (int k = 0; k < p.length; k++) {
								if (p[k].x + i < boardClone.length && p[k].y + j < boardClone[0].length && boardClone[p[k].x + i][p[k].y + j] == false) {
									boardClone[p[k].x + i][p[k].y + j] = true;
									printBoard(boardClone);
								} else {
									fit = false;
									break;
								}
							}
							boolean reflectUsed = false;
							if (!fit && omino.reflect()) {
								reflectUsed = true;
								boardClone = cloneGrid(board);
								fit = true;
								for (int k = 0; k < p.length; k++) {
									if (p[k].x + i < boardClone.length && p[k].y + j < boardClone[0].length && boardClone[p[k].x + i][p[k].y + j] == false) {
										boardClone[p[k].x + i][p[k].y + j] = true;
									} else {
										fit = false;
										break;
									}
								}
							}
							
							if (fit) {
								board = boardClone;
								
								boolean solved = isSolved(board);
								if (solved) return true;
							}
							
							//try reflect
							if (!reflectUsed && omino.reflect()) {
								reflectUsed = true;
								boardClone = cloneGrid(board);
								fit = true;
								for (int k = 0; k < p.length; k++) {
									if (p[k].x + i < boardClone.length && p[k].y + j < boardClone[0].length && boardClone[p[k].x + i][p[k].y + j] == false) {
										boardClone[p[k].x + i][p[k].y + j] = true;
									} else {
										fit = false;
										break;
									}
								}
							}
							
							if (fit) {
								board = boardClone;
								
								boolean solved = isSolved(board);
								if (solved) return true;
							}
						}
					}
				} while (fit);
			
			}
			
		}
		return false;
	}

	private boolean[][] cloneGrid(boolean[][] board) {
		boolean boardClone[][] = new boolean[board.length][board[0].length];
		for (int k = 0; k < boardClone.length; k++) {
			for (int k2 = 0; k2 < boardClone[0].length; k2++) {
				boardClone[k][k2] = board[k][k2];
			}
		}
		return boardClone;
	}

	private boolean isSolved(boolean[][] board) {
		boolean solved = true;
		for (int k = 0; k < board.length; k++) {
			for (int k2 = 0; k2 < board[0].length; k2++) {
				if (board[k][k2] == false) {
					solved = false;
					break;
				}
			}
		}
		return solved;
	}
	
	static class Omino {
		
		Point points[];
		//number of squares
		public Omino(Point points[]) {
			this.points = Arrays.copyOf(points, points.length);
		}
		
		public Omino(List<Point> points, int max) {
			if (points.size() > max) {
				points = points.subList(points.size()-max, points.size());
			}
			this.points = new Point[points.size()];
			this.points = points.toArray(this.points);
		}
		
		public void trim() {
			int minY = Integer.MAX_VALUE;
			int minX = Integer.MAX_VALUE;
			
			for (Point point : points) {
				if (point.x < minX) minX = point.x;
				if (point.y < minY) minY = point.y;
			}
			
			for (int i = 0; i < points.length; i++) {
				points[i] = new Point(points[i].x - minX, points[i].y - minY);
			}
			
		}
		
		public Point getMaxPoint() {
			int maxY = 0;
			int maxX = 0;
			
			for (Point point : points) {
				if (point.x > maxX) maxX = point.x;
				if (point.y > maxY) maxY = point.y;
			}
			
			return new Point(maxX, maxY);
		}
		
		public List<Omino> getRotations() {
			Omino other = new Omino(points);
			
			List<Omino> rotations = new ArrayList<Omino>();
			rotations.add(this);
			while (other.rotate() && !rotations.contains(other)) {
				rotations.add(other);
				other = new Omino(other.points);
			}
			
			return rotations;
		}
		
		public boolean reflect() {
			Point maxPoint = getMaxPoint();
			
			Omino old = new Omino(points);
			for (int i = 0; i < points.length; i++) {
				points[i] = new Point(maxPoint.x-points[i].x, points[i].y);
			}
			int minY = 0;
			int minX = 0;
			
			for (Point point : points) {
				if (point.x < minX) minX = point.x;
				if (point.y < minY) minY = point.y;
			}
			
			for (int i = 0; i < points.length; i++) {
				points[i] = new Point(points[i].x - minX, points[i].y - minY);
			}
			return !this.equals(old);
		}
		
		public boolean rotate() {
			Omino old = new Omino(points);
			for (int i = 0; i < points.length; i++) {
				points[i] = new Point(-points[i].y, points[i].x);
			}
			int minY = 0;
			int minX = 0;
			
			for (Point point : points) {
				if (point.x < minX) minX = point.x;
				if (point.y < minY) minY = point.y;
			}
			
			for (int i = 0; i < points.length; i++) {
				points[i] = new Point(points[i].x - minX, points[i].y - minY);
			}
			return !this.equals(old);
		}
		
		public void print() {
			Point maxPoint = getMaxPoint();
			char[][] board = new char[maxPoint.x+1][maxPoint.y+1];
			
			for (int i = 0; i < board[0].length; i++) {
				System.out.print("_ ");
			}
			System.out.println();
			for (int i = 0; i < points.length; i++) {
				board[points[i].x][points[i].y] = 'X';
			};
			for (int i = 0; i < board.length; i++) {
				for (int j = 0; j < board[0].length; j++) {
					System.out.print(board[i][j]+"|");
				}
				System.out.println();
			}
		}
		
		@Override
		public boolean equals(Object obj) {
			Omino other = (Omino)obj;
			
			if (points.length != other.points.length) return false;
			
			for (int i = 0; i < points.length; i++) {
				boolean found = false;
				for (int j = 0; j < other.points.length; j++) {
					if (points[i].equals(other.points[j])) {
						found = true;
						break;
					}
				}
				if (!found) return false;
			}
			return true;
		}
		
		@Override
		public String toString() {
			return Arrays.toString(points);
		}
	}
	
	private void printBoard(boolean [][]board) {
		if (!verbose) return;
		System.out.println("QualificationB.printBoard()");
		for (int i = 0; i < board[0].length; i++) {
			for (int j = 0; j < board.length; j++) {
				boolean b = board[j][i];
				if (b) {
					System.out.print("X|");
				} else {
					System.out.print("_|");
				}
				
			}
			System.out.println();
		}
	}
	
	private static List<Omino> getOminos(int x) {
		ArrayList<Omino> ominos = new ArrayList<Omino>();
		switch (x) {
		case 1:
			ominos.add(new Omino(new Point[]{new Point(0, 0)}));
			break;
			
		case 2:
			ominos.add(new Omino(new Point[]{new Point(0, 0),new Point(1, 0)}));//--
			break;
			
		case 3:
			/**
			 *  ###
			 */
			ominos.add(new Omino(new Point[]{new Point(0, 0),new Point(1, 0), new Point(2, 0)}));//---
			/**
			 *  ##
			 *   #
			 */
			ominos.add(new Omino(new Point[]{new Point(0, 0),new Point(1, 0), new Point(1, 1)}));
			
			break;
			
		case 4:
			/**
			 *  ####
			 */
			ominos.add(new Omino(new Point[]{new Point(0, 0),new Point(1, 0), new Point(2, 0), new Point(3, 0)}));
			/**
			 *  ###
			 *    #
			 */
			ominos.add(new Omino(new Point[]{new Point(0, 0),new Point(1, 0), new Point(2, 0), new Point(2, 1)}));
			
			/**
			 *  ###
			 *   #
			 */
			ominos.add(new Omino(new Point[]{new Point(0, 0),new Point(1, 0), new Point(2, 0), new Point(1, 1)}));
			
			/**
			 *  ##
			 *   ##
			 */
			ominos.add(new Omino(new Point[]{new Point(0, 0),new Point(1, 0), new Point(1, 1), new Point(2, 1)}));
			
			/**
			 *  ##
			 *  ##
			 */
			ominos.add(new Omino(new Point[]{new Point(0, 0),new Point(1, 0), new Point(0, 1), new Point(1, 1)}));
			break;

		default:
			break;
		}
		
		return ominos;
	}
	
	public static void main(String[] args) throws IOException,
			InterruptedException, Exception {
		
//		List<Omino> ominos = getOminos(4);
//		
//		for (Omino omino : ominos) {
//			
//			List<Omino> otherRotations = omino.getRotations();
//			
//			for (Omino omino2 : otherRotations) {
//				omino2.print();
//				omino2.reflect();
//				omino2.print();
//			}
//		}
		
		new QualificationD("D-small-attempt11.in").start();

	}
	
	
}

