import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;


public class ThemePark extends CodeJam {

	public ThemePark(String file) throws Exception {
		super(file, 2);
	}

	@Override
	public Object processCase(int caseNumber) throws Exception {
		String readLine = readLine(caseNumber, 0);
		String[] split = readLine.split(" ");
		int runTimes = Integer.parseInt(split[0]);
		int canHold = Integer.parseInt(split[1]);
		int totalNumbers = Integer.parseInt(split[2]);
		
		readLine = readLine(caseNumber, 1);
		String[] split2 = readLine.split(" ");
		
		LinkedList<Integer> line = new LinkedList<Integer>();
		
		for (int i = 0; i < split2.length; i++) {
			line.add(Integer.parseInt(split2[i]));
		}
		
		List<Integer> currentRunning = new ArrayList<Integer>();
		
		long totalCount = 0;
		long count = 0;
		for (int i = 0; i < runTimes; ) {
			Integer first = line.peek();
			
			if (first == null || count + first > canHold) {
				for (Integer integer : currentRunning) {
					line.addLast(integer);
				}
				totalCount += count;
				count = 0;
				currentRunning.clear();
				i++;
				continue;
			} else {
				count += first;
				currentRunning.add(line.pop());
			}
		}
		
		return totalCount;
	}
	
	public static void main(String[] args) throws IOException, InterruptedException, Exception {
		new ThemePark(args[0]).start();
	}

}
