package qualification;
import java.util.ArrayList;
import java.util.Arrays;

import codejam.CodeJam;

public class CandySplitting extends CodeJam {
	
	public CandySplitting(String file) throws Exception {
		super(file, 2);
	}
	
	@Override
	public Object processCase(int caseNumber) throws Exception {
		if (caseNumber == 2) {
			System.out.println();
		}
		//int number = Integer.parseInt(readLine(caseNumber, 0));
		Integer[] numbers = readIntegerArray(caseNumber, 1);

		Arrays.sort(numbers);
		numbers = reverse(numbers);
		
		long totalFake = 0;
		long total = 0;
		
		long bestTotal = -1;
		
		for (int i = 0; i < numbers.length; i++) {
			total += numbers[i];
			
			totalFake ^= numbers[i];
			
			if (totalFake == 0 || total == 0) continue;
			
			long[] otherPart = remainingValueFake(numbers, i+1);
			
			if (otherPart[1] == totalFake && total > otherPart[0]) {
//				System.out.println("TotalFake: "+totalFake);
//				System.out.println("Total: "+total+" > "+otherPart[0]);
				bestTotal = total;
			}
		}
		return bestTotal == -1?"NO":bestTotal;
		
	}
	
	private long[] remainingValueFake(Integer numbers[], int offset) {
		long totalFake = 0;
		long total = 0;
		for (int i = offset; i < numbers.length; i++) {
			total += numbers[i];
			totalFake ^= numbers[i];
		}
		return new long[]{total, totalFake};
	}
	
	public static void main(String[] args) throws Exception {
		new CandySplitting(args[0]).start();
	}

}
