package qualification;
import java.util.ArrayList;
import java.util.List;

import codejam.CodeJam;

public class BotTrust extends CodeJam {
	
	public BotTrust(String file) throws Exception {
		super(file, -1);
	}
	
	static class Button {
		
		public Button(boolean orange, int number) {
			this.orange = orange;
			this.number = number;
		}
		boolean orange;
		int number;
	}
	
	@Override
	public Object processCase(int caseNumber) throws Exception {
		String[] codesStr = readLine().split(" ");
		
		int numberOfButtons = Integer.parseInt(codesStr[0]);
		
		List<Button> btns = new ArrayList<Button>(numberOfButtons);
		
		int currentO = 1;
		int currentB = 1;
		
		for (int i = 1; i < codesStr.length; i+=2) {
			boolean orange = codesStr[i].equals("O");
			int number = Integer.parseInt(codesStr[i+1]);
			btns.add(new Button(orange, number));
		}
		int cN = 0;
		for (int s = 1;true; s++) {
			
			Button buttonO = getNext(btns, true);
			Button buttonB = getNext(btns, false);
			
			boolean pressed = false;
			if (buttonO != null) {
				if (currentO < buttonO.number) {
					currentO++;
//					System.out.println("Orange Move to button "+currentO);
				} else if (currentO > buttonO.number) {
					currentO--;
				} else {
					if (!pressed && currentO == btns.get(0).number) {
						pressed = true;
//						System.out.println("Orange Push button "+currentO);
						btns.remove(0);
						if (btns.size() == 0)return s;
					} else {
//						System.out.println("Orange Stay at button "+currentO);
					}
				}
			}
			
			if (buttonB != null) {
				if (currentB < buttonB.number) {
					currentB++;
//					System.out.println("Blue Move to button "+currentB);
				} else if (currentB > buttonB.number) {
					currentB--;
				} else {
					if (!pressed && currentB == btns.get(0).number) {
						pressed = true;
//						System.out.println("Blue Push button "+currentB);
						btns.remove(0);
						if (btns.size() == 0)return s;
					} else {
//						System.out.println("Blue Stay at button "+currentB+" "+btns.get(0).number);
					}
				}
			}
		}
	}
	
	public Button getNext(List<Button> btns, boolean orange) {
		for (Button btn : btns) {
			if (btn.orange == orange) {
				return btn;
			}
		}
		return null;
	}
	
	public static void main(String[] args) throws Exception {
		new BotTrust(args[0]).start();
	}

}
