package cadejam;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Pattern;


public class AlienLanguage {
	
	public static void main(String[] args) throws IOException {
		FileReader fileReader = new FileReader(new File(args[0]));
		
		BufferedReader bufferedReader = new BufferedReader(fileReader);
		
		String readLine = bufferedReader.readLine();
		
		String[] input = readLine.split(" ");
		
		//letters
		int l = Integer.parseInt(input[0]);
		//words
		int d = Integer.parseInt(input[1]);
		//tests
		int n = Integer.parseInt(input[2]);
		
		List<String> dic = new ArrayList<String>(d);
		List<Pattern> tests = new ArrayList<Pattern>(n);
		
		for (int i = 0; i < d; i++) {
			dic.add(bufferedReader.readLine());
		}
		
		for (int i = 0; i < n; i++) {
			tests.add(createPattern(bufferedReader.readLine()));
		}
		
		FileWriter fileWriter = new FileWriter(new File(args[0].replaceAll("\\.\\w+$", ".out")), true);
		
		for (int i = 0; i < tests.size(); i++) {
			
			Pattern pattern = tests.get(i);
			int count =0;
			
			for (String word : dic) {

				if (pattern.matcher(word).find()) {
					count++;
				}
					
			}
			
			String outLine = "Case #"+(i+1)+": "+count;
			System.out.println(outLine);
			fileWriter.write(outLine+"\n");
		}
		
		fileWriter.flush();
		
		System.exit(0);
		
	}
	
	private static Pattern createPattern(String test) {
		StringBuilder re = new StringBuilder();
		
		boolean started = false;
		for (int i = 0; i < test.length(); i++) {
			char c = test.charAt(i);
			
			re.append(c);
			if (started && isLowerChar(c)) {
				if (i < test.length()-1 && isLowerChar(test.charAt(i+1)))
					re.append('|');
			}
			
			if (c == '(') {
				started = true;
			} else if (c == ')') {
				started = false;
			}
		}
		return Pattern.compile(re.toString());
	}
	
	public static boolean isLowerChar(char c) {
		return c >= 'a' && c <= 'z';
	}

}
