import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.Scanner;


public class DeceitfulWar {

	public static void main(String[] args) {
		long start = System.currentTimeMillis();
		String inputFilename = "D-small-attempt0.in";
		StringBuilder answer = new StringBuilder();
		try {
			FileInputStream fis = new FileInputStream(inputFilename);
			Scanner sc = new Scanner(fis);
			int testCases = sc.nextInt();
			for (int i=1; i<=testCases; i++) {
				int blocks = sc.nextInt();
				double[] naomi = new double[blocks];
				for (int j=0; j<blocks; j++) {
					naomi[j] = sc.nextDouble();
				}
				double[] ken = new double[blocks];
				for (int j=0; j<blocks; j++) {
					ken[j] = sc.nextDouble();
				}
				String ans = solve(blocks, naomi, ken);
				answer.append("Case #" + i + ": " + ans + System.lineSeparator());
			}
			sc.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		writeOutput(answer.toString());
		System.out.println("in " + (System.currentTimeMillis() - start));
	}

	private static String solve(int blocks, double[] naomi, double[] ken) {
		//deceitful war
		double[] naomiSorted = sort(naomi, blocks, true);
		double[] kenSorted = sort(ken, blocks, true);
		int naomiDeceitfulScore = 0;
//		for (int i=0; i<blocks; i++) {
//			if (naomiSorted[i] > kenSorted[i]) {
//				naomiDeceitfulScore++;
//			}
//		}
		
		int naomiIndex=0;
		for (int kenIndex=0; kenIndex<blocks; kenIndex++) {
			if (naomiSorted[naomiIndex] > kenSorted[kenIndex]) {
				naomiDeceitfulScore++;
				naomiIndex++;
			}
		}
		
		
		//regular war
		int naomiRegular = 0;
		int kenIndex=0;
		for (naomiIndex=0; naomiIndex<blocks; naomiIndex++) {
			if (naomiSorted[naomiIndex] > kenSorted[kenIndex]) {
				naomiRegular++;
			} else {
				kenIndex++;
			}
		}
		return naomiDeceitfulScore + " " + naomiRegular;
	}

	private static void writeOutput(String string) {
		try {
			String outputFilename = "output.txt";
			BufferedWriter bw = new BufferedWriter(new FileWriter(outputFilename));
			bw.write(string);
			bw.close();
			System.out.println("success!");
		} catch (Exception e) {
			System.out.println("error!");
		}
	}
	
	private static double[] sort(double[] y, int n, boolean isBigToSmall) {
		if (n <= 1) return y;
		int middle = n/2;
		double[] left = new double[middle];
		for (int i=0; i<middle; i++)
			left[i] = y[i];
		left = sort(left, middle, isBigToSmall);
		double[] right;
		if (middle*2 == n) {
			right = new double[middle];
			for (int i=0; i<middle; i++)
				right[i] = y[middle+i];
			right = sort(right, middle, isBigToSmall);
		} else {
			right = new double[middle+1];
			for (int i=0; i<=middle; i++)
				right[i] = y[middle+i];
			right = sort(right, middle+1, isBigToSmall);
		}
		return merge(left, right, isBigToSmall);
	}

	private static double[] merge(double[] left, double[] right, boolean isBigToSmall) {
		int leftLen = left.length;
		int rightLen = right.length;
		int resultLen = leftLen + rightLen;
		int i=0;
		int j=0;
		double[] result = new double[resultLen];
		for (int m=0; m<resultLen; m++) {
			if (isBigToSmall) {
				if (i < leftLen && j<rightLen) {
					if (left[i] > right[j]) {
						result[m] = left[i];
						i++;
					}
					else {
						result[m] = right[j];
						j++;
					}
				}
				else if (i < leftLen) {
					result[m] = left[i];
					i++;
				}
				else if (j < rightLen) {
					result[m] = right[j];
					j++;
				}
			}
			else {
				if (i < leftLen && j<rightLen) {
					if (left[i] < right[j]) {
						result[m] = left[i];
						i++;
					}
					else {
						result[m] = right[j];
						j++;
					}
				}
				else if (i < leftLen) {
					result[m] = left[i];
					i++;
				}
				else if (j < rightLen) {
					result[m] = right[j];
					j++;
				}
			}
		}
		return result;
	}

}
