import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.Arrays;
import java.util.Scanner;


public class TheRepeater {

	public static void main(String[] args) {
		long start = System.currentTimeMillis();
		String inputFilename = "A-large.in";
		StringBuilder answer = new StringBuilder();
		try {
			FileInputStream fis = new FileInputStream(inputFilename);
			Scanner sc = new Scanner(fis);
			int testCases = sc.nextInt();
			for (int i=1; i<=testCases; i++) {
				int N = sc.nextInt();
				String[] strings = new String[N];
				for (int j=0; j<N; j++) {
					strings[j] = sc.next();
				}
				String ans = solve(N, strings);
				answer.append("Case #" + i + ": " + ans + System.lineSeparator());
			}
			sc.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		writeOutput(answer.toString());
		System.out.println("in " + (System.currentTimeMillis() - start));
	}

	private static String solve(int n, String[] strings) {
		int counter = 0;
		char currChar = strings[0].charAt(0);
		int[] indexes = new int[n];
		for (int i=0; i<n; i++) {
			if (strings[i].charAt(0) != currChar) {
				return "Fegla Won";
			}
			indexes[i] = 0;
		}
		while (indexes[0]<strings[0].length()) {
			currChar = strings[0].charAt(indexes[0]);
			int[] apps = getAppearences(n, strings, indexes, currChar);
			if (apps == null) {
				return "Fegla Won";
			}
			Arrays.sort(apps);
			if (n%2 != 0) {
				int median = apps[n/2];
				for (int i=0; i<n; i++) {
					counter += Math.abs(median-apps[i]);
				}
			} else {
				int median1 = apps[n/2];
				int median2 = apps[(n-1)/2];
				int counter1 = 0;
				int counter2 = 0;
				for (int i=0; i<n; i++) {
					counter1 += Math.abs(median1-apps[i]);
					counter2 += Math.abs(median2-apps[i]);
				}
				counter += counter1<counter2 ? counter1 : counter2;
			}
		}
		return ""+counter;
	}

	private static int[] getAppearences(int n, String[] strings, int[] indexes,
			char currChar) {
		int[] apps = new int[n];
		for (int i=0; i<n; i++) {
			apps[i] = 0;
			for (int j=0; j<strings[i].length()-indexes[i]; j++) {
				if (strings[i].charAt(indexes[i]+j) != currChar)
					break;
				apps[i]++;
			}
			if (apps[i] == 0) {
				return null;
			} else {
				indexes[i]+=apps[i];
			}
		}
		return apps;
	}

	private static void writeOutput(String string) {
		try {
			String outputFilename = "output.txt";
			BufferedWriter bw = new BufferedWriter(new FileWriter(outputFilename));
			bw.write(string);
			bw.close();
			System.out.println("success!");
		} catch (Exception e) {
			System.out.println("error!");
		}
	}

}
