import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.Scanner;


public class NewLotteryGame {

	public static void main(String[] args) {
		long start = System.currentTimeMillis();
		String inputFilename = "B-small-attempt0.in";
		StringBuilder answer = new StringBuilder();
		try {
			FileInputStream fis = new FileInputStream(inputFilename);
			Scanner sc = new Scanner(fis);
			int testCases = sc.nextInt();
			for (int i=1; i<=testCases; i++) {
				int A = sc.nextInt();
				int B = sc.nextInt();
				int K = sc.nextInt();
				String ans = solve(A, B, K);
				answer.append("Case #" + i + ": " + ans + System.lineSeparator());
			}
			sc.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		writeOutput(answer.toString());
		System.out.println("in " + (System.currentTimeMillis() - start));
	}

	private static String solve(long a, long b, long k) {
		if (a==1)
			return ""+b;
		if (b==1)
			return ""+a;
		long totalPairs = a*b;
		long min = a<b? a:b;
		if (k>=min)
			return ""+totalPairs;
		int count = 0;
		for (int i=0; i<a; i++) {
			for (int j=0; j<b; j++) {
				if ((i&j) < k) {
					count++;
				}
			}
		}
		return ""+count;
	}

	private static void writeOutput(String string) {
		try {
			String outputFilename = "output.txt";
			BufferedWriter bw = new BufferedWriter(new FileWriter(outputFilename));
			bw.write(string);
			bw.close();
			System.out.println("success!");
		} catch (Exception e) {
			System.out.println("error!");
		}
	}

}
