import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.Scanner;


public class TheRepeater {

	public static void main(String[] args) {
		long start = System.currentTimeMillis();
		String inputFilename = "A-small-attempt0.in";
		StringBuilder answer = new StringBuilder();
		try {
			FileInputStream fis = new FileInputStream(inputFilename);
			Scanner sc = new Scanner(fis);
			int testCases = sc.nextInt();
			for (int i=1; i<=testCases; i++) {
				int N = sc.nextInt();
				String[] strings = new String[N];
				for (int j=0; j<N; j++) {
					strings[j] = sc.next();
				}
				String ans = solve(N, strings);
				answer.append("Case #" + i + ": " + ans + System.lineSeparator());
			}
			sc.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		writeOutput(answer.toString());
		System.out.println("in " + (System.currentTimeMillis() - start));
	}

	private static String solve(int n, String[] strings) {
		int counter = 0;
		if (n==2) { //easy
			String str1 = strings[0];
			String str2 = strings[1];
			if (str1.charAt(0) != str2.charAt(0)) {
				return "Fegla Won";
			}
			int i=0;
			int j=0;
			while (i<str1.length() || j<str2.length()) {
				if (i<str1.length() && j<str2.length() &&
						str1.charAt(i) == str2.charAt(j)) {
					i++;
					j++;
				} else if (i<str1.length() && str1.charAt(i) == str2.charAt(j-1)) {
					counter++;
					i++;
				} else if (j<str2.length() && str1.charAt(i-1) == str2.charAt(j)) {
					counter++;
					j++;
				} else {
					return "Fegla Won";
				}
			}
		}
		return ""+counter;
	}

	private static void writeOutput(String string) {
		try {
			String outputFilename = "output.txt";
			BufferedWriter bw = new BufferedWriter(new FileWriter(outputFilename));
			bw.write(string);
			bw.close();
			System.out.println("success!");
		} catch (Exception e) {
			System.out.println("error!");
		}
	}

}
