import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.Scanner;


public class CookieClickerAlpha {
	
	public static void main(String[] args) {
		long start = System.currentTimeMillis();
		String inputFilename = "B-large.in";
		StringBuilder answer = new StringBuilder();
		try {
			FileInputStream fis = new FileInputStream(inputFilename);
			Scanner sc = new Scanner(fis);
			int testCases = sc.nextInt();
			for (int i=1; i<=testCases; i++) {
				double farmCost = sc.nextDouble();
				double extraCookies = sc.nextDouble();
				double goal = sc.nextDouble();
				
				String ans = solve(farmCost, extraCookies, goal);
				answer.append("Case #" + i + ": " + ans + System.lineSeparator());
			}
			sc.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		writeOutput(answer.toString());
		System.out.println("in " + (System.currentTimeMillis() - start));
	}

	private static String solve(double farmCost, double extraCookies, double goal) {
		double cookiesPerSecond = 2;
		double cookiesOwned = 0;
		double totalTime = 0;
		while (cookiesOwned < goal) {
			double diffToGoal = goal-cookiesOwned;
			double diffToFarm = farmCost-cookiesOwned;
			if (diffToGoal <= diffToFarm) {
				totalTime += diffToGoal/cookiesPerSecond;
				break;
			} else if (diffToFarm > 0) {
				//cant buy a farm
				totalTime += diffToFarm/cookiesPerSecond;
				cookiesOwned += diffToFarm;
			} else {
				//can buy a farm
				double timeIfNotBuying = diffToGoal/cookiesPerSecond;
				double timeIfBuying = (goal-(cookiesOwned-farmCost))/(cookiesPerSecond+extraCookies);
				if (timeIfNotBuying <= timeIfBuying) {
					//dont buy
					totalTime += timeIfNotBuying;
					break;
				} else {
					//buy
					cookiesOwned -= farmCost;
					cookiesPerSecond += extraCookies;
				}
			}
		}
		return String.format("%.7f", totalTime);
	}

	private static void writeOutput(String string) {
		try {
			String outputFilename = "output.txt";
			BufferedWriter bw = new BufferedWriter(new FileWriter(outputFilename));
			bw.write(string);
			bw.close();
			System.out.println("success!");
		} catch (Exception e) {
			System.out.println("error!");
		}
	}

}
