import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.Scanner;


public class MagicTrick {
	
	public static void main(String[] args) {
		long start = System.currentTimeMillis();
		String inputFilename = "A-small-attempt0.in";
		StringBuilder answer = new StringBuilder();
		try {
			FileInputStream fis = new FileInputStream(inputFilename);
			Scanner sc = new Scanner(fis);
			int testCases = sc.nextInt();
			for (int i=1; i<=testCases; i++) {
				int firstRow = sc.nextInt();
				int[][] firstOrder = new int[4][4];
				for (int j=0; j<4; j++) {
					for (int k=0; k<4; k++) {
						firstOrder[j][k] = sc.nextInt();
					}
				}
				int secondRow = sc.nextInt();
				int[][] secondOrder = new int[4][4];
				for (int j=0; j<4; j++) {
					for (int k=0; k<4; k++) {
						secondOrder[j][k] = sc.nextInt();
					}
				}
				
				String ans = solve(firstOrder[firstRow-1], secondOrder[secondRow-1]);
				answer.append("Case #" + i + ": " + ans + System.lineSeparator());
			}
			sc.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		writeOutput(answer.toString());
		System.out.println("in " + (System.currentTimeMillis() - start));
	}

	private static String solve(int[] firstRow, int[] secondRow) {
		int chosen = -1;
		int numberOfAns = 0;
		for (int i=0; i<firstRow.length; i++) {
			for (int j=0; j<secondRow.length; j++) {
				if (firstRow[i] == secondRow[j]) {
					chosen = firstRow[i];
					numberOfAns++;
					break;
				}
			}
		}
		if (numberOfAns == 0) {
			return "Volunteer cheated!";
		} else if (numberOfAns == 1) {
			return "" + chosen;
		} else {
			return "Bad magician!";
		}
	}

	private static void writeOutput(String string) {
		try {
			String outputFilename = "output.txt";
			BufferedWriter bw = new BufferedWriter(new FileWriter(outputFilename));
			bw.write(string);
			bw.close();
			System.out.println("success!");
		} catch (Exception e) {
			System.out.println("error!");
		}
	}

}
