package com.elsa.squirrel;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by elisabet on 2015-04-18.
 */
public class Squirrel {

    public static void main(String[] args) {
        try {
            String path = args[0];
            Squirrel m = new Squirrel();
            List<String> result = m.readFile(path);
            String outPath = "/home/elisabet/temp.out";

            PrintWriter pw = new PrintWriter(outPath);
            for (String s : result) {
                pw.println(s);
            }
            pw.close();
        } catch (IOException e) {
            System.out.println("IOException: "+e.getMessage());
        }
    }
    private List<String> readFile(String path) throws IOException {
        FileReader fr = new FileReader(path);
        BufferedReader br = new BufferedReader(fr);
        List<String> result = new ArrayList<String>();

        int m = Integer.parseInt(br.readLine());

        for (int i = 1; i<=m; i++){
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Case #"+i+":\n");

            String str = readExample(br);

            stringBuilder.append(str);
            result.add(stringBuilder.toString());
            System.out.println(stringBuilder);
        }
        return result;
    }

    private String readExample(BufferedReader br) throws IOException{
        String result ="";
        int trees_n = Integer.parseInt(br.readLine());
        Coord[] trees = new Coord[trees_n];
        for(int i=0; i<trees_n; i++){
            String s = br.readLine();
            //System.out.println(s);
            trees[i] = fillTree(s.split(" "));
        }

        int minX=0, minY=0, maxX=0, maxY=0;
        for (Coord tree : trees){
            minX = tree.x < minX ? tree.x : minX;
            minY = tree.y < minY ? tree.y : minY;
            maxX = tree.x > maxX ? tree.x : maxX;
            maxY = tree.y > maxY ? tree.y : maxY;
        }
        //System.out.println("maxX: "+maxX+", minX: "+minX+", maxY:"+maxY+", minY:"+minY);
        for (Coord tree : trees){
            result += cutDown(tree,minX,maxX,minY,maxY,trees)+"\n";
        }
        return result;
    }

    private int cutDown(Coord tree, int minX, int maxX, int minY, int maxY, Coord[] other){
        if (tree.x <= minX || tree.x >= maxX || tree.y <= minY || tree.y >= maxY)
            return 0;
        int leftTop=0, rightTop=0, leftBottom=0, rightBottom=0;

        for (Coord otherTree : other){
            if (otherTree == tree) continue;
            if (otherTree.x <= tree.x) {
                if (otherTree.y <= tree.y)
                    leftTop++;
                if (otherTree.y >= tree.y)
                    rightTop++;
            }
            if (otherTree.x >= tree.x) {
                if (otherTree.y <= tree.y)
                    leftBottom++;
                if (otherTree.y >= tree.y)
                    rightBottom++;
            }
        }

        //System.out.println(leftTop+" "+rightTop+" "+leftBottom+" "+rightBottom);
        int minTop = Math.min(leftTop, rightTop);
        int minBottom = Math.min(leftBottom, rightBottom);

        return Math.min(minBottom,minTop);
    }

    private Coord fillTree(String[] spec){
        Coord tree = new Coord();
        tree.x = Integer.parseInt(spec[0]);
        tree.y = Integer.parseInt(spec[1]);
        return tree;
    }

    private class Coord{
        public int x=0;
        public int y=0;
    }
}
