package april2016;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.*;

/**
 * Created by elisabet on 2016-04-09.
 */
public class B {
    private static boolean verbose = true;

    private static String filename = "B-large";
    private static String infilename = "/home/elisabet/google_code_jam/april2016/in/"+filename+".in";
    private static String outfilename = "/home/elisabet/google_code_jam/april2016/out/"+filename+".out";

    public static void main(String[] args) throws FileNotFoundException {
        Scanner s = new Scanner(new File(infilename));
        int D = Integer.parseInt(s.nextLine());

        ArrayList<String> result = new ArrayList<>();

        for (int i = 1; i<= D; i++) {
            int j = doStuff(s);
            result.add("Case #"+i+": "+j);
        }
        print(result);
    }

    private static int doStuff(Scanner s) {
        // true = happy face, false = blank
        char[] line = s.nextLine().toCharArray();
        int n = line.length;

        Boolean[] bstack = new Boolean[n];
        Arrays.fill(bstack, false);


        for (int j = 0; j < bstack.length; j++) {
            System.out.print(line[j]);
            if (line[j] == '+') bstack[j] = true;
        }
        log("");

        List<Boolean> stack = Arrays.asList(bstack);

        log(stack.toString());
        int j = 0;
        boolean done = true;
        for (boolean b : stack) {
            done &= b;
        }

        while (!done) {
            log("not done; "+stack.toString());

            int front = 0;
            boolean firstFace = stack.get(0);
            for (boolean b : stack) {
                if (b == firstFace) {
                    front++;
                } else {
                    break;
                }
            }

            int back = 0;
            boolean lastFace = stack.get(n -1);
            for (int k = n -1; k >= 0; k--) {
                if (stack.get(k) == lastFace) {
                    back++;
                } else {
                    break;
                }
            }

            log("front: "+front+", back: "+back+", size: "+ n);
            if (front == n) {
                flip(n, stack);
            } else if (back > front && lastFace != firstFace) {
                int index = n - back;
                flip(index, stack);
            } else {
                flip(front, stack);
            }

            j++;
            done = true;
            for (boolean b : stack) {
                done &= b;
            }
        }
        return j;
    }

    private static void flip(int index, List<Boolean> stack) {
        log("flipping first "+index+" elements of " + stack.toString());

        List<Boolean> head = stack.subList(0, index);
        Collections.reverse(head);

        for (int i = 0; i < index; i++) {
            head.set(i, !head.get(i));
        }
        log("flipped to: "+stack.toString());
    }

    static private void log(String s) {
        if (verbose) {
            System.out.println(s);
        }
    }

    static private void print(List<String> output) throws FileNotFoundException {
        PrintWriter pw = new PrintWriter(outfilename);
        for (String s : output) {
            log(s);
            pw.println(s);
        }
        pw.close();

    }
}
