package com.elsa.opera;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by elisabet on 2015-04-11.
 */
public class Opera {
    public static void main(String[] args) {
        try {
            long millis = System.currentTimeMillis();
            String path = args[0];
            Opera o = new Opera();
            List<String> result = o.readFile(path);
            String outPath = "/home/elisabet/temp.out";

            PrintWriter pw = new PrintWriter(outPath);
            for (String s : result) {
                pw.println(s);
            }
            pw.close();

            long millis2 = System.currentTimeMillis();
            System.out.println("time: "+(millis2-millis));
        } catch (IOException e) {
            System.out.println("IOException: "+e.getMessage());
        }
    }

    private List<String> readFile(String path) throws IOException {
        FileReader fr = new FileReader(path);
        BufferedReader br = new BufferedReader(fr);
        List<String> result = new ArrayList<String>();

        int m = Integer.parseInt(br.readLine());

        for (int i = 1; i<=m; i++){
            StringBuilder stringBuilder = new StringBuilder();
            int friends = extraFriends(br.readLine());
            stringBuilder.append("Case #"+i+": "+friends);
            System.out.println( "Case #"+i+": " + friends);
            result.add(stringBuilder.toString());
        }
        return result;
    }

    private int extraFriends(String s) {
        String[] audience = s.split(" ");
        int s_max = Integer.parseInt(audience[0]);
        int friends = 0;
        if (s_max == 0)
            return friends;
        int[] levels = new int[audience[1].length()];

        for (int i = 0; i<levels.length; i++) {
            levels[i] = Integer.parseInt(audience[1].substring(i,i+1));
        }

        int standing = 0;
        for (int i = 0; i<levels.length; i++) {
            if (standing < i){
                int r = i-standing;
                friends += r;
                standing += r;
            }
            standing += levels[i];
        }

        return friends;
    }
}
