package com.elsa.omino;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by elisabet on 2015-04-11.
 */
public class Omino {
    public static void main(String[] args) {
        try {
            long millis = System.currentTimeMillis();
            String path = args[0];
            Omino o = new Omino();
            List<String> result = o.readFile(path);
            String outPath = "/home/elisabet/temp.out";

            PrintWriter pw = new PrintWriter(outPath);
            for (String s : result) {
                pw.println(s);
            }
            pw.close();

            long millis2 = System.currentTimeMillis();
            System.out.println("time: "+(millis2-millis));
        } catch (IOException e) {
            System.out.println("IOException: "+e.getMessage());
        }
    }

    private List<String> readFile(String path) throws IOException {
        FileReader fr = new FileReader(path);
        BufferedReader br = new BufferedReader(fr);
        List<String> result = new ArrayList<String>();

        int m = Integer.parseInt(br.readLine());

        for (int i = 1; i<=m; i++){
            boolean richWins = play(br.readLine().split(" "));
            String next = "Case #"+i+": "+(richWins ? "RICHARD" : "GABRIEL");
            System.out.println(next);
            result.add(next);
        }
        return result;
    }

    private boolean play(String[] s){
        int X = Integer.parseInt(s[0]);
        int R = Integer.parseInt(s[1]);
        int C = Integer.parseInt(s[2]);

        // positive size
        if (R <1 || C <1)
            return true;

        if (X == 1)
            return false;
        // size not dividable by omino
        if (((R*C) % X) != 0)
            return true;

        // X can not be fit if straight
        if ((X>R) && (X>C))
            return true;

        int Xmax =(X+1)/2;

        if (Xmax > C || Xmax > R)
            return true;

        // ugly ass shit
        if ( X == 4 && (C==2||R==2))
            return true;

        // possible to make hole
        if (X >= 7)
            return true;

        return false;
    }

}
