package com.elsa.mushroom;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Created by elisabet on 2015-04-18.
 */
public class MushroomLady {

    public static void main(String[] args) {
        try {
            String path = args[0];
            MushroomLady m = new MushroomLady();
            List<String> result = m.readFile(path);
            String outPath = "/home/elisabet/temp.out";

            PrintWriter pw = new PrintWriter(outPath);
            for (String s : result) {
                pw.println(s);
            }
            pw.close();
        } catch (IOException e) {
            System.out.println("IOException: "+e.getMessage());
        }
    }
    private List<String> readFile(String path) throws IOException {
        FileReader fr = new FileReader(path);
        BufferedReader br = new BufferedReader(fr);
        List<String> result = new ArrayList<String>();

        int m = Integer.parseInt(br.readLine());

        for (int i = 1; i<=m; i++){
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Case #"+i+": ");

            int[] t = readExample(br);
            int a = method1(t);
            int b = method2(t);
            String str = ""+a+" "+b;

            stringBuilder.append(str);
            result.add(stringBuilder.toString());
            System.out.println(stringBuilder);
        }
        return result;
    }

    private int[] readExample(BufferedReader br) throws IOException{
        int nTimes = Integer.parseInt(br.readLine());
        int[] t = new int[nTimes];
        String s = br.readLine();
        System.out.println(s);
        String[] times = s.split(" ");
        for (int i=0; i<times.length; i++) {
            t[i] = Integer.parseInt(times[i]);
            //System.out.println(""+t[i]);
        }
        return t;
    }

    private int method1(int[] mushrooms) {
        int prev = mushrooms[0];
        int i = 1;
        while(i<mushrooms.length && mushrooms[i] >= prev) {
            prev = mushrooms[i];
            i++;
        }
        //System.out.println("skip: "+(i-1));
        int total=0;
        for (int j=i; j<mushrooms.length; j++){
            int diff = (mushrooms[j]-mushrooms[j-1]);
            total += diff <0 ? diff:0;
        }
        return -total;
    }

    private int method2(int[] mushrooms) {
        int total = 0;
        int topSpeed = 0;
        for (int i = 1; i<mushrooms.length; i++){
            int diff = -(mushrooms[i]-mushrooms[i-1]);
            topSpeed = diff > topSpeed ? diff : topSpeed;
        }
        if (topSpeed == 0) return total;

        for (int i = 0; i<mushrooms.length-1; i++){
            total += Math.min(topSpeed, mushrooms[i]);
        }
        //System.out.println("top speed:"+topSpeed);
        return total;
    }
}
