import java.io.*;
import java.util.*;
import java.text.*;

/**
 * @author Roman Elizarov
 */
public class D extends Thread {
	public static void main(String[] args) throws FileNotFoundException, InterruptedException {
		Locale.setDefault(Locale.US);
		if (args.length == 0)
			args = new String[] { "D.in" };
		for (String infile : args)
			new D().go(infile);
	}

	private Scanner in;
	private PrintWriter out;

	private void go(String infile) throws FileNotFoundException, InterruptedException {
		open(infile);
		start();
		join();
		close();
	}

	private void open(String infile) throws FileNotFoundException {
		String outfile = infile.replaceFirst("(\\.in)?$", ".out");
		System.out.printf("Processing %s, writing %s...%n", infile, outfile);
		in = new Scanner(new File(infile));
		out = new PrintWriter(new File(outfile));
	}

	private void close() {
		if (in != null)
			in.close();
		if (out != null)
			out.close();
	}

	public void run() {
		int n = in.nextInt();
		int lastp = 0;
		boolean nl = true;
		long start = System.currentTimeMillis();
		for (int i = 1; i <= n; i++) {
			if (nl) {
				System.out.print(new SimpleDateFormat("HH:mm:ss.SSS").format(new Date()) + " : ");
				nl = false;
			}
			doCase(i);
			System.out.print(".");
			int p = i * 20 / n;
			if (lastp != p) {
				System.out.printf("%d%%, ~%d sec more to go%n", (i * 100 / n), (System.currentTimeMillis() - start) * (n - i) / i / 1000);
				lastp = p;
				nl = true;
			}
		}
	}

	int k;
	char[] s;

	int n;
	char[] t;

	int[] p;
	int best;

	private void doCase(int caseNumber) {
		// read case
		k = in.nextInt();
		s = in.next().toCharArray();

		// solve case
		n = s.length;
		t = new char[n];
		p = new int[k];
		best = Integer.MAX_VALUE;
		solve(0, 0);

		// write case result
		out.printf("Case #%d: %d%n", caseNumber, best);
	}

	private void solve(int i, int u) {
		if (i < k) {
			for (int j = 0; j < k; j++) {
				if (((1 << j) & u) == 0) {
					p[i] = j;
					solve(i + 1, u | (1 << j));
				}
			}
			return;
		}
		best = Math.min(best, size());
	}

	private int size() {
		for (int i = 0; i < n; i += k) {
			for (int j = 0; j < k; j++) {
				t[i + j] = s[i + p[j]];				
			}
		}
		int result = 0;
		char prev = 0;
		for (int i = 0; i < n; i++) {
			if (t[i] != prev) {
				result++;
				prev = t[i];
			}
		}
		return result;
	}
}