import java.io.*;
import java.util.*;
import java.text.*;

/**
 * @author Roman Elizarov
 */
public class B extends Thread {
	public static void main(String[] args) throws FileNotFoundException, InterruptedException {
		Locale.setDefault(Locale.US);
		if (args.length == 0)
			args = new String[] { "B.in" };
		for (String infile : args)
			new B().go(infile);
	}

	private Scanner in;
	private PrintWriter out;

	private void go(String infile) throws FileNotFoundException, InterruptedException {
		open(infile);
		start();
		join();
		close();
	}

	private void open(String infile) throws FileNotFoundException {
		String outfile = infile.replaceFirst("(\\.in)?$", ".out");
		System.out.printf("Processing %s, writing %s...%n", infile, outfile);
		in = new Scanner(new File(infile));
		out = new PrintWriter(new File(outfile));
	}

	private void close() {
		if (in != null)
			in.close();
		if (out != null)
			out.close();
	}

	public void run() {
		int n = in.nextInt();
		int lastp = 0;
		boolean nl = true;
		long start = System.currentTimeMillis();
		for (int i = 1; i <= n; i++) {
			if (nl) {
				System.out.print(new SimpleDateFormat("HH:mm:ss.SSS").format(new Date()) + " : ");
				nl = false;
			}
			doCase(i);
			System.out.print(".");
			int p = i * 20 / n;
			if (lastp != p) {
				System.out.printf("%d%%, ~%d sec more to go%n", (i * 100 / n), (System.currentTimeMillis() - start) * (n - i) / i / 1000);
				lastp = p;
				nl = true;
			}
		}
	}

	private void doCase(int caseNumber) {
		// read case
		int n = in.nextInt();
		int m = in.nextInt();
		int a = in.nextInt();

		// solve case
		for (int y1 = 0; y1 <= m; y1++) {
			for (int x2 = 0; x2 <= n; x2++) {
//				if (y1 == 0 && x2 == 0)
//					continue;
//				int rhs = a + x2 * y1;
//				if (y1 == 0) {
//					if (rhs % x2 == 0) {
//						int y3 = rhs / x2;
//						if (y3 <= m) {
//							solved(caseNumber, 0, y1, x2, 0, 0, y3);
//							return;
//						}
//					}
//				}
//				if (x2 == 0) {
//
//				}
//				int g = gcd(x2, y1);
				for (int x3 = 0; x3 <= n; x3++)
					for (int y3 = 0; y3 <= m; y3++) {
						if (Math.abs(-x2 * y3 + x2 * y1 - x3 * y1) == a) {
							solved(caseNumber, 0, y1, x2, 0, x3, y3);
							return;
						}
					}
			}
		}

		// write case result
		out.printf("Case #%d: IMPOSSIBLE%n", caseNumber);
	}

	private void solved(int caseNumber, int x1, int y1, int x2, int y2, int x3, int y3) {
		out.printf("Case #%d: %d %d %d %d %d %d%n", caseNumber, x1, y1, x2, y2, x3, y3);
	}

	private int gcd(int x, int y) {
		while (y != 0) {
			int t = x % y;
			x = y;
			y = t;
		}
		return x;
	}
}