package round2;

import java.io.*;
import java.util.*;

/**
 * @author Roman Elizarov
 */
public class B {
	public static void main(String[] args) throws IOException {
		new B().go();
	}

	Scanner in;
	PrintWriter out;

	private void go() throws IOException  {
		in = new Scanner(new File("src\\round2\\b.in"));
		out = new PrintWriter(new File("src\\round2\\b.out"));
		int t = in.nextInt();
		for (int tn = 1; tn <= t; tn++) {
			System.out.println("Case #" + tn);
			out.println("Case #" + tn + ": " + solveCase());
		}
		in.close();
		out.close();
	}

	int n;
	int w;
	int l;
	S[] orig;
	S[] s;
	P rootP;
	boolean[] u;

	private String solveCase() {
		n = in.nextInt();
		w = in.nextInt();
		l = in.nextInt();
		orig = new S[n];
		for (int i = 0; i < n; i++)
			orig[i] = new S(in.nextInt());
		s = orig.clone();
		Arrays.sort(s);
		rootP = new P(Integer.MAX_VALUE, 0);
		u = new boolean[n];
		int last = 0;
		P curP = rootP;
		for (int i = 0; i < n;) {
			if (u[i]) {
				i++;
				continue;
			}
			int rem = last == 0 ? Integer.MAX_VALUE : w - last;
			int j = i;
			for (; j < n; j++)
				if (s[j].r <= rem)
					break;
			if (j >= n) {
				last = 0;
				curP = rootP;
				j = i;
			}
			int x = last == 0 ? 0 : last + s[j].r;
			int h = curP.h;
			int y = h == 0 ? 0 : h + s[j].r;
			System.out.println(x + " " + y);
			assert y <= l;

			// place
			u[j] = true;
			s[j].x = x;
			s[j].y = y;

			// update
			last = x + s[j].r;
			curP.dup();
			curP.h = y + s[j].r;
			curP.d = last;
			while (curP.next.d <= last)
				curP.next = curP.next.nextOrNew();
			curP = curP.next;
		}

		// result
		StringBuilder sb = new StringBuilder();
		for (S s : orig) {
			if (sb.length() > 0)
				sb.append(' ');
			sb.append(s.x).append(' ').append(s.y);
		}
		return sb.toString();
	}

	static class S implements Comparable<S> {
		int r;
		int x = -1;
		int y = -1;

		S(int r) {
			this.r = r;
		}

		public int compareTo(S o) {
			return o.r - r;
		}
	}

	static class P {
		int d;
		int h;
		P next;

		P(int d, int h) {
			this.d = d;
			this.h = h;
		}

		P(int d, int h, P next) {
			this.d = d;
			this.h = h;
			this.next = next;
		}

		public P nextOrNew() {
			if (next == null)
				next = new P(Integer.MAX_VALUE, h);
			return next;
		}

		public void dup() {
			next = new P(d, h, next);
		}
	}
}
