package round2;

import java.io.*;
import java.util.Arrays;
import java.util.Scanner;

/**
 * @author Roman Elizarov
 */
public class C {
	private static final int MAX = 1000000000;
	private static final String IMPOSSIBLE = "Impossible";

	public static void main(String[] args) throws IOException {
		new C().go();
	}

	Scanner in;
	PrintWriter out;

	private void go() throws IOException  {
		in = new Scanner(new File("src\\round2\\c.in"));
		out = new PrintWriter(new File("src\\round2\\c.out"));
		int t = in.nextInt();
		for (int tn = 1; tn <= t; tn++) {
			out.println("Case #" + tn + ": " + solveCase());
		}
		in.close();
		out.close();
	}

	int n;
	int[] x;
	int[] span;
	int[] y;

	private String solveCase() {
		n = in.nextInt();
		x = new int[n];
		for (int i = 1; i < n; i++)
			x[i] = in.nextInt();
		y = new int[n + 1];
		span = new int[n + 1];
		Arrays.fill(span, n);
		Arrays.fill(y, MAX);
		for (int i = 1; i < n; i++) {
			int k = x[i];
			span[k] = Math.min(span[k], i);
			boolean adjust = true;
		adjust:
			while (adjust) {
				adjust = false;
				for (int j = i + 1; j <= n; j++)
					if (j != k) {
						int cm = cmax(i, k, j);
						//System.out.println(i + "," + j + "," + k + " = " + cm);
						if (j > k && span[j] < k && cm < y[j]) {
							y[i] = Math.min(y[i], cmax(k, j, i));
							if (y[i] < 0)
								return IMPOSSIBLE;
							adjust = true;
							continue adjust;
						} else {
							y[j] = Math.min(y[j], cm);
							if (y[j] < 0)
								return IMPOSSIBLE;
						}
					}
			}
		}
		boolean ok = true;
	check:
		for (int i = 1; i < n; i++) {
			int k = x[i];
			for (int j = i + 1; j <= n; j++)
				if (j != k)
					if (y[j] > cmax(i, k, j)) {
						ok = false;
						break check;
					}
		}
		if (!ok)
			return IMPOSSIBLE;
		StringBuilder sb = new StringBuilder();
		for (int i = 1; i <= n; i++) {
			if (sb.length() > 0)
				sb.append(' ');
			sb.append(y[i]);
		}
		return sb.toString();
	}

	private int cmax(int i, int k, int j) {
		return (int)Math.min(MAX, ((long)y[i] * (k - j) + (long)y[k] * (j - i) - 1) / (k - i));
	}
}
