import java.util.ArrayList;
import java.util.Arrays;

public class MagicCards {
	private int [][] cards;
	private int row;
	
	public MagicCards (int n, int selectedRow, ArrayList <Integer> allCards) {
		cards = new int [n][n];
		
		if (allCards.size() != (n*n)) {
			System.err.println("The number of given cards does not fit the size of the magic game");
			System.exit(-1);
		}
		
		for (int i=0; i<allCards.size(); i++) {
			cards[i/n][i%n] = allCards.get(i);
		}
		
		row = selectedRow;
	}
	
	public int checkMagicTrick (MagicCards other) {
		int count = 0;
		int card = 0;
		boolean found = false;
		
		if (cards.length != other.cards.length) {
			System.err.println("The magic games do not have the same size");
			System.exit(-1);			
		}
		
		for (int i=0; i<cards.length; i++) {
			found = false;
			
			for (int j=0; j<other.cards.length && !found; j++) {
				if (cards[row][i] == other.cards[other.row][j]) {
					found = true;
					card = cards[row][i];
					count ++;
				}
			}
		}
		
		if (count > 1) {
			return -1;
		}
		else {
			return card; 
		}
	}
	
	public String toString() {
		String current = "";
		
		current += ("Selected row in the game is " + row + "\n");
		
		current += "Set of cards in the game is\n";
		
		for (int i=0; i<cards.length; i++) {
			current += (Arrays.toString(cards[i]) + "\n");
		}
		
		current += "\n";
		
		return current;
	}
}
