import java.util.ArrayList;
import java.util.Arrays;

public class CookieClickerGame {
	private double C;
	private double F;
	private double X;
	private double S; // Initial cookies per second
	
	public CookieClickerGame (double cookieS, double cookieC, double cookieF, double cookieX) {
		S = cookieS;
		C = cookieC;
		F = cookieF;
		X = cookieX;
	}
	
	public double obtainBestCookieTime () {
		// We start from the beginning of the game, seeing how fast is to obtain the cookie final points without buying new farms
		// Then, we try to buy a farm, and see if the time to obtain the final cookie points buying the next farm is lower than waiting for the cookie
		// If buying a new farm improves our time, then we will search for another farm; if not, we have already found the best time for farming cookies!
		
		double newCookieTime;
		double currentCookieProduction;
		double cookieTime;
		double cookieTimeSpent;
		double farmTime;
		boolean improves;
		
		newCookieTime = X/S;
		currentCookieProduction = S;
		cookieTimeSpent = 0.0;
		farmTime = 0.0;
		
		do {
			improves = false;
			
			// How much time achieving the cookie objective will cost (it was previously computed within the newCookieTime)
			cookieTime = newCookieTime;
			
			// How much time will cost to buy a new farm and the cookie objective with the new farm
			farmTime = C/currentCookieProduction;
			newCookieTime = X/(currentCookieProduction+F);
			
			if (cookieTime > (farmTime+newCookieTime)) {
				// Add the previous time of farm and improve production
				cookieTimeSpent += farmTime;
				currentCookieProduction += F;
				improves = true;
			}
		} while (improves);
		
		return (cookieTimeSpent+cookieTime);
	}
	
	public String toString() {
		String current = "";
		
		current += ("Farm cost is " + C + "\n");
		current += ("Farm production is " + F + "\n");
		current += ("Cookies final goal is " + X + "\n");
		
		current += "\n";
		
		return current;
	}
}
