import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;

public class DeceitfulWar {
	static int numberGames;
	static ArrayList <WarGame> allGames;
	static int [] outputWarGame;
	static int [] outputDeceitfulWarGame;
	
	public static void readFile(String filename) {
		WarGame currentGame;
		int blocksSize;
		ArrayList <Double> currentFirstBlocks;
		ArrayList <Double> currentSecondBlocks;
		
		try {
			File file = new File(filename);
			Scanner warScan = new Scanner(file);
			
			numberGames = warScan.nextInt();
			
			// Allocate memory for all cases
			allGames = new ArrayList <WarGame> (numberGames);
			outputWarGame = new int [numberGames];
			outputDeceitfulWarGame = new int [numberGames];
			
			// Read cases in the file
			for (int i=0; i<numberGames; i++) {
				blocksSize = warScan.nextInt();
				
				currentFirstBlocks = new ArrayList <Double> (blocksSize);
				currentSecondBlocks = new ArrayList <Double> (blocksSize);
				
				for (int j=0; j<blocksSize; j++) {
					currentFirstBlocks.add(warScan.nextDouble());
				}
				for (int j=0; j<blocksSize; j++) {
					currentSecondBlocks.add(warScan.nextDouble());
				}
				
				currentGame = new WarGame (blocksSize, currentFirstBlocks, currentSecondBlocks);
				allGames.add(currentGame);
			}
			
      warScan.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	public static void writeSolution (String filename) {
		String currentOutput;
		
		try {
			PrintWriter pw_file = new PrintWriter (filename);
			PrintWriter pw_stdoutput = new PrintWriter (System.out, true);
		
			for (int i=0; i<numberGames; i++) {
				pw_file.print("Case #" + (i+1) + ": " + outputDeceitfulWarGame[i] + " " + outputWarGame[i] + "\n");
				pw_stdoutput.print("Case #" + (i+1) + ": " + outputDeceitfulWarGame[i] + " " + outputWarGame[i] + "\n");
			}
			
			pw_file.close();
			pw_stdoutput.close();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main (String[] args) {
		if (args.length != 2) {
			System.err.println("The input and output files are not specified");
			System.exit(0);
		}
		
		// Creating the locale for english language
		Locale.setDefault(new Locale("en", "US"));
		
		// Read the input file
		readFile(args[0]);
		
		// For each cookie game case, compute the minimum time to be solved
		for (int i=0; i<numberGames; i++) {
			outputDeceitfulWarGame[i] = allGames.get(i).obtainPointsDeceitfulWar();
			outputWarGame[i] = allGames.get(i).obtainPointsWar();
		}
		
		//Write the output solution
		writeSolution (args[1]); 
				
	}
} 
