import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.ArrayList;
import java.util.Arrays;

public class MagicTrick {
	static int numberTricks;
	static ArrayList <MagicCards> allMagic;
	static int sizeMagic = 4;
	static int [] outputTrick;
	
	public static void readFile(String filename) {
		ArrayList <Integer> numbersMagic;
		MagicCards currentMagic;
		int currentRow;
		
		try {
			File file = new File(filename);
			Scanner magicScan = new Scanner(file);
			
			numberTricks = magicScan.nextInt();
			
			// Allocate memory for all cases
			allMagic = new ArrayList <MagicCards> (numberTricks);
			outputTrick = new int [numberTricks];
			
			// Read cases in the file
			for (int i=0; i<numberTricks*2; i++) {
				numbersMagic = new ArrayList <Integer> (sizeMagic*sizeMagic);
				
				currentRow = magicScan.nextInt()-1;
				for (int j=0; j<sizeMagic*sizeMagic; j++) {
					numbersMagic.add(magicScan.nextInt());
				}
				
				currentMagic = new MagicCards (sizeMagic, currentRow, numbersMagic);
				allMagic.add(currentMagic);
			}
			
      magicScan.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	public static void writeSolution (String filename) {
		try {
			PrintWriter pw_file = new PrintWriter (filename);
			PrintWriter pw_stdoutput = new PrintWriter (System.out, true);
		
			for (int i=0; i<numberTricks; i++) {
				pw_file.print("Case #" + (i+1) + ": ");
				pw_stdoutput.print("Case #" + (i+1) + ": ");
				
				if (outputTrick[i] > 0) {
					pw_file.print(outputTrick[i]);
					pw_stdoutput.print(outputTrick[i]);
				} 
				else if (outputTrick[i] == 0) {
					pw_file.print("Volunteer cheated!");
					pw_stdoutput.print("Volunteer cheated!");
				}
				else {
					pw_file.print("Bad magician!");
					pw_stdoutput.print("Bad magician!");
				}
				
				pw_file.print("\n");
				pw_stdoutput.print("\n");
			}
			
			pw_file.close();
			pw_stdoutput.close();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main (String[] args) {
		if (args.length != 2) {
			System.err.println("The input and output files are not specified");
			System.exit(0);
		}
		
		// Read the input file
		readFile(args[0]);
		
		// For each magic cases, check the magician trick
		for (int i=0; i<numberTricks; i++) {
			outputTrick[i] = allMagic.get(2*i).checkMagicTrick(allMagic.get(2*i+1));
		}
		
		//Write the output solution
		writeSolution (args[1]); 
				
	}
} 
