import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;

public class CookieClicker {
	static int numberGames;
	static ArrayList <CookieClickerGame> allGames;
	static double [] outputGame;
	static double initialCookiesPerSecond = 2;
	
	public static void readFile(String filename) {
		CookieClickerGame currentGame;
		double currentC;
		double currentF;
		double currentX;
		
		try {
			File file = new File(filename);
			Scanner cookieScan = new Scanner(file);
			
			numberGames = cookieScan.nextInt();
			
			// Allocate memory for all cases
			allGames = new ArrayList <CookieClickerGame> (numberGames);
			outputGame = new double [numberGames];
			
			// Read cases in the file
			for (int i=0; i<numberGames; i++) {
				currentC = cookieScan.nextDouble();
				currentF = cookieScan.nextDouble();
				currentX = cookieScan.nextDouble();
				
				currentGame = new CookieClickerGame (initialCookiesPerSecond, currentC, currentF, currentX);
				allGames.add(currentGame);
			}
			
      cookieScan.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	public static void writeSolution (String filename) {
		String currentOutput;
		
		try {
			PrintWriter pw_file = new PrintWriter (filename);
			PrintWriter pw_stdoutput = new PrintWriter (System.out, true);
		
			for (int i=0; i<numberGames; i++) {
				pw_file.print("Case #" + (i+1) + ": ");
				pw_stdoutput.print("Case #" + (i+1) + ": ");
				
				currentOutput = String.format("%.7f%n",outputGame[i]);
                   
				pw_file.print(currentOutput);
				pw_stdoutput.print(currentOutput);
			}
			
			pw_file.close();
			pw_stdoutput.close();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main (String[] args) {
		if (args.length != 2) {
			System.err.println("The input and output files are not specified");
			System.exit(0);
		}
		
		// Creating the locale for english language
		Locale.setDefault(new Locale("en", "US"));
		
		// Read the input file
		readFile(args[0]);
		
		// For each cookie game case, compute the minimum time to be solved
		for (int i=0; i<numberGames; i++) {
			outputGame[i] = allGames.get(i).obtainBestCookieTime();
		}
		
		//Write the output solution
		writeSolution (args[1]); 
				
	}
} 
