package qualification;



import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class B {
    class Solver implements Runnable {
        int testId;
        boolean failed = false;
        String result = "YES";
        
        Solver(int testId) {
            this.testId = testId;
        }

        int n,m;
        int[][] a;

        private void readInput() {
        	n = nextInt();
        	m = nextInt();
            a = new int[n][m];
            
            for (int i = 0; i < n; i++){
            	for (int j = 0; j < m; j++) {
            		a[i][j] = nextInt();
            	}
            }
        }

        int res;
        
        public void run() {
        	int maxi[] = new int[n];
        	int maxj[] = new int[m];
        	
            for (int i = 0; i < n; i++){
            	maxi[i] = a[i][0];
            	for (int j = 1; j < m; j++) {
            		if (a[i][j] > maxi[i]) maxi[i] = a[i][j]; 
            	}            	
            }

            for (int j = 0; j < m; j++){
            	maxj[j] = a[0][j];
            	for (int i = 1; i < n; i++) {
            		if (a[i][j] > maxj[j]) maxj[j] = a[i][j]; 
            	}            	
            }
            
            for (int i = 0; i < n; i++){
            	for (int j = 0; j < m; j++) {
            		if (a[i][j] < maxi[i] && a[i][j] < maxj[j]) {
            			result = "NO";
            			return;
            		}
            	}
            }
            result = "YES";
        
        }


        private void printOutput() {
            if (failed) {
                writer.println("0");
                System.out.println("FAILURE!!!");
            } else {
                writer.println(String.format("Case #%d: %s", testId, result));
            }
        }
    }

	// solve the problem here
	private void solve(){
		int numTests = nextInt();
		for (int testId = 1; testId <= numTests; testId++) {
			Solver solver = new Solver(testId);
			solver.readInput();
			solver.run();
			solver.printOutput();
		}

	}


	BufferedReader reader;
	StringTokenizer tokenizer = null;
	PrintWriter writer;

	String encrypted = "ejp mysljylc kd kxveddknmc re jsicpdrysi"+
	         "rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd"+
	         "de kr kd eoya kw aej tysr re ujdr lkgc jvq";
    String output    = "our language is impossible to understand"+
	         "there are twenty six factorial possibilities"+ 
	         "so it is okay if you want to just give upz";

    char[] code = new char[256];
    	
    private void preparehalfcode() {
    	for (int i = 0; i<encrypted.length(); i++) {
    		code[encrypted.charAt(i)] = output.charAt(i);
    	}    	
    }
    
    private void prepare() {
    	preparehalfcode();
    	encrypted = encrypted.toUpperCase();
    	output = output.toUpperCase();
    	preparehalfcode();
    }
    
    public void run() {
        try {
            long now = System.currentTimeMillis();
            String problemfilename = this.getClass().getSimpleName();
            reader = new BufferedReader(new FileReader(problemfilename + ".in"));
            writer = new PrintWriter(problemfilename + ".out");
            prepare();
            solve();
            reader.close();
            writer.close();
            System.out.println(System.currentTimeMillis() - now + "ms");
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

	int nextInt() {
        return Integer.parseInt(nextToken());
    }

    double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    long nextLong() {
        return Long.parseLong(nextToken());
    }

    String nextToken() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }
    /**
	 * @param args
	 */
	public static void main(String[] args) {
		new B().run();
	}

}
