package round2;


import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class A {
    class Solver implements Runnable {
        int testId;
        boolean failed = false;
        boolean result = false;
        
        Solver(int testId) {
            this.testId = testId;
        }

        int n;
        int[] vines;
        int[] d;
        int D;

        private void readInput() {
        	n = nextInt();
        	
        	vines = new int[n];
        	d = new int[n];
        	
        	for (int i=0; i<n; i++){
        		d[i] = nextInt();
        		vines[i] = nextInt();
        	}
        	
        	D = nextInt();
        }

        int res;

        private boolean swing(int l, int v) {
        	//holding vine v, can swing l metres
        	int maxswing = d[v]+l;
        	//I might catch any vine that's not farther then [ vines[v] + l ]
        	if (maxswing >= D) return true;
        	
        	int i = v + 1;
        	if (i>=n) return false;
        	
        	while (d[i] <= maxswing) {
        		if (swing(Math.min(vines[i], d[i]-d[v]), i ) ) return true;
                i++;
        		if (i>=n) return false;
        	}
        	
        	return false;
        }
        public void run() {
        	
        	result = swing(d[0], 0);
        }


        private void printOutput() {
            if (failed) {
                writer.println("No");
                System.out.println("FAILURE!!!");
            } else {
            	
                writer.println(String.format("Case #%d: %s", testId, (result ? "YES" : "NO")));
            }
        }
    }

	// solve the problem here
	private void solve(){
		int numTests = nextInt();
		for (int testId = 1; testId <= numTests; testId++) {
			Solver solver = new Solver(testId);
			solver.readInput();
			solver.run();
			solver.printOutput();
		}

	}


	BufferedReader reader;
	StringTokenizer tokenizer = null;
	PrintWriter writer;

    private void prepare() {
    }
    
    public void run() {
        try {
            long now = System.currentTimeMillis();
            String problemfilename = this.getClass().getSimpleName();
            reader = new BufferedReader(new FileReader(problemfilename + ".in"));
            writer = new PrintWriter(problemfilename + ".out");
            prepare();
            solve();
            reader.close();
            writer.close();
            System.out.println(System.currentTimeMillis() - now + "ms");
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

	int nextInt() {
        return Integer.parseInt(nextToken());
    }

    double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    long nextLong() {
        return Long.parseLong(nextToken());
    }

    String nextToken() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }
    /**
	 * @param args
	 */
	public static void main(String[] args) {
		new A().run();
	}

}
