package qualification;



import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class A {
    class Solver implements Runnable {
        int testId;
        boolean failed = false;
        int result = 0;
        
        Solver(int testId) {
            this.testId = testId;
        }

        static final int N = 4;
        String in, out = "";
        
        ArrayList<String> text = new ArrayList<String>();
        char[][] f = new char[N][N];
        int[][] c = new int[N][N];
        private void readInput() {
            try {
            	out = "Draw"; //assume draw
            	for (int i = 0; i<N; i++) {
				  in = reader.readLine();
				  for (int j = 0; j < N; j++) {
					  f[i][j] = in.charAt(j);
					  // Assume not completed if square is empty
					  if (f[i][j] == '.') out = "Game has not completed";
				  }
            	}
            	in = reader.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
        }

        private void prep(){
        	for (int i = 0; i<N; i++) {
			  for (int j = 0; j < N; j++) {
				  switch (f[i][j]) {
				  case 'X': c[i][j] = 100;
				  break;
				  case 'O': c[i][j] = 9;
				  break;
				  case 'T': c[i][j] = 9000;
				  break;
				  case '.': c[i][j] = 1;
				  break;
				  }
			  }
        	}
        }
        
        private int sumLine(int stx, int sty, int dx, int dy) {
        	int r = 0;
        	int i = stx; 
        	int j = sty;
        	for (int u = 0; u < N; u++) {
        		r += c[i][j];
        		i += dx;
        		j += dy;
        	}
        	return r;
        }
        
        private void checkLines() {
        	//if any line is filled plus T
        	for (int i = 0; i < N; i++){
        		int x = sumLine(i, 0, 0, 1);
        		if (x % 100 == 0) {
        			out = "X won";
        			return;
        		}
        		if (x % 9 == 0) {
        			out = "O won";
        			return;
        		}
        	}
        	
        	//if any vertical is filled plus T
        	for (int j = 0; j < N; j++){
        		int x = sumLine(0, j, 1, 0);
        		if (x % 100 == 0) {
        			out = "X won";
        			return;
        		}
        		if (x % 9 == 0) {
        			out = "O won";
        			return;
        		}
        	}
        	
        	//if any vertical is filled plus T
        	for (int j = 0; j < N; j++){
        		int x = sumLine(0, j, 1, 0);
        		if (x % 100 == 0) {
        			out = "X won";
        			return;
        		}
        		if (x % 9 == 0) {
        			out = "O won";
        			return;
        		}
        	}

        	//any diagonal is filled plus T
        	{
    		int y = sumLine(0, 0, 1, 1);
    		if (y % 100 == 0) {
    			out = "X won";
    			return;
    		}
    		if (y % 9 == 0) {
    			out = "O won";
    			return;
    		}
        	}

        	{
    		int z = sumLine(0, 3, 1, -1);
    		if (z % 100 == 0) {
    			out = "X won";
    			return;
    		}
    		if (z % 9 == 0) {
    			out = "O won";
    			return;
    		}
        	}
        }
        
        public void run() {
        	prep();
        	checkLines();
        	//otherwise, the status was already set correctly 
        }


        private void printOutput() {
            if (failed) {
                writer.println("0");
                System.out.println("FAILURE!!!");
            } else {
                writer.println(String.format("Case #%d: %s", testId, out));
            }
        }
    }

	// solve the problem here
	private void solve(){
		int numTests = nextInt();
		for (int testId = 1; testId <= numTests; testId++) {
			Solver solver = new Solver(testId);
			solver.readInput();
			solver.run();
			solver.printOutput();
		}

	}


	BufferedReader reader;
	StringTokenizer tokenizer = null;
	PrintWriter writer;

    private void prepare() {
    }
    
    public void run() {
        try {
            long now = System.currentTimeMillis();
            String problemfilename = this.getClass().getSimpleName();
            reader = new BufferedReader(new FileReader(problemfilename + ".in"));
            writer = new PrintWriter(problemfilename + ".out");
            prepare();
            solve();
            reader.close();
            writer.close();
            System.out.println(System.currentTimeMillis() - now + "ms");
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

	int nextInt() {
        return Integer.parseInt(nextToken());
    }

    double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    long nextLong() {
        return Long.parseLong(nextToken());
    }

    String nextToken() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }
    /**
	 * @param args
	 */
	public static void main(String[] args) {
		new A().run();
	}

}
