package com.company;

//import java.util.*;

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class Main {

    public static void main(String[] args) throws FileNotFoundException {

        String inFile = "c-small-2.in";
        String outFile = "c-small-2.out";

//        String inFile = "C-large.in";
//        String outFile = "C-large.out";

        Scanner in = new Scanner(new File(inFile));
        PrintWriter writer = new PrintWriter(outFile);
        int t = in.nextInt();
        for (int i = 1; i <= t; ++i) {
            String n = in.next();
            String k = in.next();
            String result = solve(n, k);
            System.out.println("Case #" + i + ": " + result);
            writer.println("Case #" + i + ": " + result);
            writer.flush();
        }
        writer.close();
    }

    private static String solve(String n, String k) {
        if (n.equals(k)) {
            return "0 0";
        }

        PriorityQueue<BigInteger> queue = new PriorityQueue<>(100, new Comparator<BigInteger>() {
            @Override
            public int compare(BigInteger o1, BigInteger o2) {
                return o2.compareTo(o1);
            }
        });
        queue.add(new BigInteger(n));
        BigInteger maxSpace = BigInteger.ZERO;
        BigInteger minSpace = BigInteger.ZERO;

        for (BigInteger bi = BigInteger.ZERO;
             bi.compareTo(new BigInteger(k)) < 0;
             bi = bi.add(BigInteger.ONE)) {

            BigInteger i = queue.remove();
            if (i != null) {
                maxSpace = i.subtract(i.subtract(BigInteger.ONE).divide(new BigInteger("2"))).subtract(BigInteger.ONE);
                minSpace = i.subtract(BigInteger.ONE).divide(new BigInteger("2"));

                if (maxSpace.compareTo(BigInteger.ZERO) > 0) {
                    queue.add(maxSpace);
                }

                if (minSpace.compareTo(BigInteger.ZERO) > 0) {
                    queue.add(minSpace);
                }
            }
        }

        return maxSpace + " " + minSpace;
    }

}