import java.awt.*;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.Scanner;

/**
 * Created by Elaine on 4/22/2017.
 */
public class Unicorns {
    public static final byte RED = 4;
    public static final byte ORANGE = 6;
    public static final byte YELLOW = 2;
    public static final byte GREEN = 3;
    public static final byte BLUE = 1;
    public static final byte VIOLET = 5;
    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
        byte colors[] = {RED,ORANGE,YELLOW,GREEN,BLUE,VIOLET};

        Scanner scanner = new Scanner(new FileInputStream("src/small_input.txt"));
        int T = scanner.nextInt();
        PrintWriter writer = new PrintWriter("Unicorns", "UTF-8");

        for(int i=0;i<T;i++) {
            int N = scanner.nextInt();
            int R = scanner.nextInt();
            int O = scanner.nextInt();
            int Y = scanner.nextInt();
            int G = scanner.nextInt();
            int B = scanner.nextInt();
            int V = scanner.nextInt();
            int sumWithRed = R + O + V;
            int sumWithYellow = O + Y + G;
            int sumWithBlue = G + B + V;
            String toReturn;
            if(sumWithBlue > N/2 || sumWithRed > N/2 || sumWithYellow > N/2) {
                toReturn = "IMPOSSIBLE";
            } else {
                StringBuffer sb = new StringBuffer();
                PriorityQueue<ColorFrequency> heap = new PriorityQueue<ColorFrequency>(6);
                heap.add(new ColorFrequency(RED, R));
                heap.add(new ColorFrequency(ORANGE, O));
                heap.add(new ColorFrequency(YELLOW, Y));
                heap.add(new ColorFrequency(GREEN, G));
                heap.add(new ColorFrequency(BLUE, B));
                heap.add(new ColorFrequency(VIOLET, V));
                for(int j=0;j<N/2;j++) {
                    ColorFrequency firstFreq = heap.poll();
                    sb.append(toLetter(firstFreq.color));
                    firstFreq.frequency--;
                    ColorFrequency secondFreq = heap.poll();
                    sb.append(toLetter(secondFreq.color));
                    secondFreq.frequency--;
                    heap.add(firstFreq);
                    heap.add(secondFreq);
                }
                if(N%2==1) {
                    ColorFrequency firstFreq = heap.poll();
                    sb.append(toLetter(firstFreq.color));
                }
                toReturn = sb.toString();
                char[] chars = toReturn.toCharArray();
                if(chars[chars.length-1] == chars[0]) {
                    char temp = chars[chars.length-1];
                    char secondToLast = chars[chars.length-2];
                    char thirdToLast = chars[chars.length-3];
                    if (temp != thirdToLast) {
                        chars[chars.length-2] = temp;
                        chars[chars.length-1] = secondToLast;
                    }
                    toReturn = new String(chars);
                }
            }
            writer.println("Case #" + (i+1) + ": " + toReturn);
        }
        writer.close();

    }

    static char toLetter(byte color) {
        char letter;
        switch(color) {
            case RED:
                letter = 'R';
                break;
            case ORANGE:
                letter = 'O';
                break;
            case YELLOW:
                letter = 'Y';
                break;
            case GREEN:
                letter = 'G';
                break;
            case BLUE:
                letter = 'B';
                break;
            case VIOLET:
                letter = 'V';
                break;
            default:
                letter = ' ';
        }
        return letter;
    }

    static class ColorFrequency implements Comparable{
        ColorFrequency(byte c, int f) {
            color = c;
            frequency = f;
        }
        byte color;
        int frequency;

        @Override
        public int compareTo(Object o) {
            int comp = Integer.compare(((ColorFrequency)o).frequency,frequency);
            if(comp == 0) {
                comp = Byte.compare(((ColorFrequency) o).color,color);
            }
            return comp;
        }
    }

    static boolean hasRed(byte unicorn) {
        return (unicorn & 1<<2) > 0;
    }
    static boolean hasYellow(byte unicorn) {
        return (unicorn & 1<<1) > 0;
    }
    static boolean hasBlue(byte unicorn) {
        return (unicorn & 1) > 0;
    }
}
