import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Scanner;

/**
 * Created by Elaine on 4/8/2017.
 */
public class BathroomStalls {
    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
        Scanner scanner = new Scanner(new FileInputStream("src/small_input.txt"));
        int T = scanner.nextInt();
        PrintWriter writer = new PrintWriter("bathroomStalls", "UTF-8");

        for(int i=0;i<T;i++) {
            int N = scanner.nextInt();
            int K = scanner.nextInt();

            if (N == K) {
                writer.println("Case #" + (i+1) + ": 0 0");
            } else {
                Node listHead = new Node(N);
                int L=0;
                int R=0;

                for (int j = 0; j < K; j++) {
                    Node maxNode = null;
                    int maxValue = 0;

                    Node currentNode = listHead;
                    while (currentNode != null) {
                        if (currentNode.value > maxValue) {
                            maxValue = currentNode.value;
                            maxNode = currentNode;
                        }
                        currentNode = currentNode.next;
                    }

                    if (maxNode.value % 2 == 0) {
                        L = maxNode.value / 2 - 1;
                        R = maxNode.value / 2;
                    } else {
                        L = (maxNode.value - 1) / 2;
                        R = (maxNode.value - 1) / 2;
                    }

                    Node lNode = new Node(L);
                    Node rNode = new Node(R);
                    lNode.insertAfter(rNode);
                    maxNode.replace(lNode);
                }
                writer.println("Case #" + (i + 1) + ": " + Math.max(L, R) + " " + Math.min(L, R));
            }
        }
        writer.close();

    }

    private static class Node {
        Node(int val) {
            this.value = val;
            this.next = null;
            this.prev = null;
        }

        public int value;
        public Node next;
        public Node prev;

        public void insertAfter(Node newNode) {
            if(this.next != null) {
                this.next.prev = newNode;
            }
            newNode.next = this.next;
            newNode.prev = this;
            this.next = newNode;
        }

        public void replace (Node pair) {
            Node lastNode = pair;
            if(this.prev != null) {
                while (lastNode.next != null) {
                    lastNode = lastNode.next;
                }

                if (this.next != null) {
                    this.next.prev = lastNode;
                }
                lastNode.next = this.next;
                pair.prev = this.prev;
                if (this.prev != null) {
                    this.prev.next = pair;
                }
            } else {
                this.value = pair.value;
                this.insertAfter(pair.next);
            }
        }
    }
}
