import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.math.BigInteger;
import java.util.Scanner;

/**
 * Created by Elaine on 4/8/2017.
 */
public class TidyNumbers {
    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
        Scanner scanner = new Scanner(new FileInputStream("src/small_input.txt"));
        int T = scanner.nextInt();
        PrintWriter writer = new PrintWriter("tidyNumbers", "UTF-8");

        for(int i=0;i<T;i++) {
            BigInteger N = new BigInteger(scanner.next());
            BigInteger closest = closestTidy(N);

            writer.println("Case #" + (i+1) + ": " + closest);
        }
        writer.close();

    }

    private static BigInteger closestTidy(BigInteger N) {
        // turn int into char array
        char[] chars = N.toString().toCharArray();
        // find where numbers are not increasing
        int i;
        for(i=0;i<chars.length-1;i++){
            if (chars[i] > chars[i+1]) {
                break;
            }
        }
        if (i == chars.length-1) {
            return N;
        }
        char numToLower = chars[i];
        // find first instance of that number
        while(i >= 0 && chars[i] == numToLower) {
            i--;
        }
        i++;
        // drop it by one, then fill the rest with 9s
        chars[i]--;
        for(int j=i+1;j<chars.length;j++) {
            chars[j] = '9';
        }
        // turn char array into integer
        return new BigInteger(new String(chars));
    }

}
