import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.*;

/**
 * Created by Elaine on 4/8/2017.
 */
public class OversizedPancakeFlipper {

    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
        Scanner scanner = new Scanner(new FileInputStream("src/small_input.txt"));
        int numOrders = scanner.nextInt();
        PrintWriter writer = new PrintWriter("oversizedPancakeFlipper", "UTF-8");

        for(int i=0;i<numOrders;i++) {
            String pancakes = scanner.next();
            int K = scanner.nextInt();
            int numFlips = flips(pancakes, K);

            writer.println("Case #" + (i+1) + ": " + (numFlips == -1 ? "IMPOSSIBLE" : numFlips));
        }
        writer.close();

    }

    private static int flips(String pancakes, int K) {
        System.out.println();
        int numPancakes = pancakes.length();
        int numPositions = numPancakes - K + 1;

        char[] chars = new char[numPancakes];
        Arrays.fill(chars, '+');
        String goal = new String(chars);

        LinkedList<PancakeState> queue = new LinkedList<PancakeState>();
        HashSet<String> set = new HashSet<String>();
        queue.add(new PancakeState(pancakes,0));
        set.add(queue.getFirst().pancakes);

        while(!queue.isEmpty()) {
            PancakeState currentState = queue.pop();
            if (currentState.pancakes.equals(goal)) {
                return currentState.flipsSoFar;
            }
            for(int i=0;i<numPositions;i++) {
                PancakeState nextState = new PancakeState(currentState,K,i);
                if(!set.contains(nextState.pancakes)) {
                    System.out.println(nextState.pancakes);
                    set.add(nextState.pancakes);
                    queue.add(nextState);
                }
            }
        }

        return -1;
    }

    private static class PancakeState {
        PancakeState(String pancakes, int flips) {
            this.pancakes = pancakes;
            this.flipsSoFar = flips;
        }
        PancakeState(PancakeState oldState, int K, int spatulaPosition) {
            this.flipsSoFar = oldState.flipsSoFar + 1;
            char[] pancakeChars = oldState.pancakes.toCharArray();
            for(int i=0;i<K;i++) {
                int position = i+spatulaPosition;
                pancakeChars[position] = pancakeChars[position] == '+' ? '-' : '+';
            }
            this.pancakes = new String(pancakeChars);
        }
        public String pancakes = null;
        public int flipsSoFar = 0;
    }
}
