import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

/** @author Jorge Zaccaro */

public class CodeJam_JorgeZaccaro {
	/*--- General Attributes ---*/
	private static String inputData;
	private static String outputData;
	
	/*--- Problem Specific Attributes ---*/
	private static int T;
	private static Map<String,Integer> alreadyDone;
	private static Map<Integer,Integer> results;
	
	/*--- Functions ---*/
	public static String[] readDataSet() {
		inputData = CodeJamIO.readFile();
		String[] testCasesString = inputData.split("\n");
		T = Integer.parseInt(testCasesString[0]);
		
		return testCasesString;
	}
	
	
	
	/* SOLUTION */
	public static void main (String args[]) {
		
		/*READ FILE*/
		String[] processData = readDataSet();
		
		/*TEST CASES LOOP*/
		alreadyDone = new Hashtable<String,Integer>();
		results = new Hashtable<Integer,Integer>();
		String[] thisTest;
		int N, P, numberOfSeconds;
		boolean buttonPressed = false;
		String R, newKey;
		List<Integer> blueButtons = new ArrayList<Integer>();
			Robot blueRobot = new Robot();
		List<Integer> orangeButtons = new ArrayList<Integer>();	
			Robot orangeRobot = new Robot();
			
			for (int t=1; t<=T; t++) {
				numberOfSeconds = 0;
				blueRobot.resetRobot();	orangeRobot.resetRobot();
				
				newKey = processData[t];
				thisTest = processData[t].split(" ");
				N = Integer.parseInt(thisTest[0]);
				//System.out.println(N);
				if(alreadyDone.containsKey(newKey)) {
					results.put(t, alreadyDone.get(newKey));	
					break;
				}
				
				blueButtons.removeAll(blueButtons);
				orangeButtons.removeAll(orangeButtons);
				for (int j=1, k=1; j<=N; j++, k+=2) {
					R = String.valueOf(thisTest[k]);
					P = Integer.parseInt(String.valueOf(thisTest[k+1]));
					//System.out.println(R+" "+P);
					if (R.equals("B")) {
						blueButtons.add(P);
					}
					else {
						orangeButtons.add(P);
					}
				}
								
				/*Read Sequence*/
				for (int j=1, k=1; j<=N; j++, k+=2) {
					R = String.valueOf(thisTest[k]);
					blueRobot.state=Robot.States.NOTPRESSED;
					orangeRobot.state=Robot.States.NOTPRESSED;
					buttonPressed = false;
					while(!buttonPressed) {
						if (blueRobot.totalPressed < blueButtons.size())
							{blueRobot.positionTarget = blueButtons.get(blueRobot.totalPressed);}					
						if(orangeRobot.totalPressed < orangeButtons.size())
							{orangeRobot.positionTarget = orangeButtons.get(orangeRobot.totalPressed);}
					if (R.equals("B")) {
						if (blueRobot.positionTarget < blueRobot.position) {
							blueRobot.position -= 1;
							if (orangeRobot.positionTarget < orangeRobot.position) {
								orangeRobot.position -= 1;
							}
							else if (orangeRobot.positionTarget > orangeRobot.position) {
								orangeRobot.position += 1;
							}
						}
						else if (blueRobot.positionTarget > blueRobot.position) {
							blueRobot.position += 1;
							if (orangeRobot.positionTarget < orangeRobot.position) {
								orangeRobot.position -= 1;
							}
							else if (orangeRobot.positionTarget > orangeRobot.position) {
								orangeRobot.position += 1;
							}
						}
						else {
							if (blueRobot.state==Robot.States.NOTPRESSED) {
								buttonPressed = true;
								blueRobot.state=Robot.States.PRESSED;
								blueRobot.totalPressed += 1;
							}
							if (orangeRobot.positionTarget < orangeRobot.position) {
								orangeRobot.position -= 1;
							}
							else if (orangeRobot.positionTarget > orangeRobot.position) {
								orangeRobot.position += 1;
							}
						}
						numberOfSeconds += 1;
					}
					else if (R.equals("O")){	
						if (orangeRobot.positionTarget < orangeRobot.position) {
							orangeRobot.position -= 1;
							if (blueRobot.positionTarget < blueRobot.position) {
								blueRobot.position -= 1;
							}
							else if (blueRobot.positionTarget > blueRobot.position) {
								blueRobot.position += 1;
							}
						}
						else if (orangeRobot.positionTarget > orangeRobot.position) {
							orangeRobot.position += 1;
							if (blueRobot.positionTarget < blueRobot.position) {
								blueRobot.position -= 1;
							}
							else if (blueRobot.positionTarget > blueRobot.position) {
								blueRobot.position += 1;
							}
						}
						else {
							if (orangeRobot.state==Robot.States.NOTPRESSED) {
								buttonPressed = true;
								orangeRobot.state=Robot.States.PRESSED;
								orangeRobot.totalPressed += 1;
							}
							if (blueRobot.positionTarget < blueRobot.position) {
								blueRobot.position -= 1;
							}
							else if (blueRobot.positionTarget > blueRobot.position) {
								blueRobot.position += 1;
							}
						}

						numberOfSeconds += 1;
					}//if "B" or "O"
					}//while buttonPressed					
				}//for N
				//System.out.println("Posiciones: "+blueRobot.position+" "+orangeRobot.position);
				alreadyDone.put(newKey, numberOfSeconds);
				results.put(t, numberOfSeconds);
			}//for T
		
		/*OUTPUT FILE*/
		outputData = "";
		for (int z=1; z<=T; z++) {
			outputData += "Case #"+z+": "+results.get(z)+"\n";
		}
		
		CodeJamIO.writeFile(outputData);
		System.out.println(outputData);
	}
		
		//Test
		
		
}
	

