import java.util.ArrayList;
import java.util.Collections;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

/** @author Jorge Zaccaro */

public class CodeJam_JorgeZaccaro {
	/*--- General Attributes ---*/
	private static String inputData;
	private static String outputData;
	
	/*--- Problem Specific Attributes ---*/
	private static int T;
	private static Map<String,String> alreadyDone;
	private static Map<Integer,String> results;
	private static Map<String,String> patrickBitAddition;
	private static List<Integer> seanCandyPile;
	private static List<Integer> patrickCandyPile;
	
	/*--- Functions ---*/
	public static String[] readDataSet() {
		inputData = CodeJamIO.readFile();
		String[] testCasesString = inputData.split("\n");
		T = Integer.parseInt(testCasesString[0]);
		
		return testCasesString;
	}
	
	public static int patrickAddition(int num1, int num2) {
		String number1 = Integer.toBinaryString(num1);
		String number2 = Integer.toBinaryString(num2);
		
		String patrickAddition = "", newNumber1="", newNumber2="";
		int maxSize = Math.max(number1.length(), number2.length()), difSize;
		
		/*Equal string lengths by inserting zeros*/
		if (number1.length()>number2.length()) {
			difSize = (number1.length()-number2.length());
			for (int j=1; j<=difSize; j++) {
				newNumber2 += "0";
			}
		}
		else if (number1.length()<number2.length()) {
			difSize = (number2.length()-number1.length());
			for (int j=1; j<=difSize; j++) {
				newNumber1 += "0";
			}
		}
			newNumber1 += number1;
			newNumber2 += number2;
		
		/*Patrick's addition*/
		String bit1x, bit2x, bitAdd;
		for (int i=0; i<maxSize; i++) {
			bit1x = String.valueOf(newNumber1.charAt(i));
			bit2x = String.valueOf(newNumber2.charAt(i));
			bitAdd = patrickBitAddition.get(bit1x+bit2x);
			patrickAddition += bitAdd;
		}
		
		return Integer.parseInt(patrickAddition,2);
	}
	
	/* SOLUTION */
	public static void main (String args[]) {
		
		/*READ FILE*/
		String[] processData = readDataSet();
		
		/*TEST CASES LOOP*/
		patrickBitAddition = new Hashtable<String,String>();
			patrickBitAddition.put("00", "0"); patrickBitAddition.put("01", "1");
			patrickBitAddition.put("10", "1"); patrickBitAddition.put("11", "0");			
		alreadyDone = new Hashtable<String,String>();
		results = new Hashtable<Integer,String>();
		
		String[] C;
		int N, num1, num2, fake, real,
			sumSeanFake, sumPatrickFake, sumSeanReal, sumPatrickReal;
		for (int t=1, k=2; t<=T; t++, k+=2) {	
			seanCandyPile = new ArrayList<Integer>();
			patrickCandyPile = new ArrayList<Integer>();
			
			N = Integer.parseInt(processData[k-1]);
			C = processData[k].split(" ");
			
			if(alreadyDone.containsKey(processData[k])) {
				results.put(t, alreadyDone.get(processData[k]));	
				break;
			}
			
			/*Create candy integer list*/
			List<Integer> candies = new ArrayList<Integer>();
			for (int m=0; m<N; m++) {
				candies.add(Integer.parseInt(C[m]));
			}
			Collections.sort(candies, Collections.reverseOrder());
			
			
			/*Divide candies - 1st part*/
			
			
			while (candies.size()>0) {
				
				if (candies.size()>1) {
					num1 = candies.get(0);
					num2 = candies.get(1);
					fake = patrickAddition(num1,num2);
					real = (num1+num2);
					if (fake < real) {
						seanCandyPile.add(num1);
						//seanCandyPile.add(num2);
						candies.remove(0);
						//candies.remove(1);
					}
					else {
						patrickCandyPile.add(num1);
						//patrickCandyPile.add(num2);
						candies.remove(0);
						//candies.remove(1);
					}
				}
				else {
					num1 = candies.get(0);
					seanCandyPile.add(num1);
					candies.remove(0);					
				}
			} 
			
			/*Divide candies - 2nd part - Balance*/
			sumSeanFake=0; sumPatrickFake=0; sumSeanReal=0; sumPatrickReal=0;
			for (int thisValue:seanCandyPile) {
				sumSeanFake = patrickAddition(sumSeanFake,thisValue);
				sumSeanReal += thisValue;
			}
			for (int thisValue:patrickCandyPile) {
				sumPatrickFake = patrickAddition(sumPatrickFake,thisValue);
				sumPatrickReal += thisValue;
			}
			//Collections.sort(seanCandyPile); Collections.sort(patrickCandyPile);
			
			boolean equal=false;
			int transfers = 0;
			
			while(!equal && transfers<seanCandyPile.size()-1) {
				int maxSeanSumIndex = 0, maxSeanSum=0; 
				for (int w=0; w<seanCandyPile.size(); w++) {
					List<Integer> seanCandyPileTemp = new ArrayList<Integer>();
						for(int c=0;c<seanCandyPile.size();c++) {seanCandyPileTemp.add(c, 0);}
					List<Integer> patrickCandyPileTemp = new ArrayList<Integer>();
						for(int c=0;c<patrickCandyPile.size();c++) {patrickCandyPileTemp.add(c, 0);}
					Collections.copy(seanCandyPileTemp, seanCandyPile);
					Collections.copy(patrickCandyPileTemp, patrickCandyPile);
					
					patrickCandyPileTemp.add(seanCandyPileTemp.get(w));
					seanCandyPileTemp.remove(w);
					transfers += 1;
					
					sumSeanFake=0; sumPatrickFake=0; sumSeanReal=0; sumPatrickReal=0;
					for (int thisValue:seanCandyPileTemp) {
						sumSeanFake = patrickAddition(sumSeanFake,thisValue);
						sumSeanReal += thisValue;
					}
					for (int thisValue:patrickCandyPileTemp) {
						sumPatrickFake = patrickAddition(sumPatrickFake,thisValue);
						sumPatrickReal += thisValue;
					}
					
					if (sumSeanReal>maxSeanSum && sumSeanReal>sumPatrickReal && sumSeanFake==sumPatrickFake) {
						maxSeanSum=sumSeanReal;
						maxSeanSumIndex=w;
					}
				}
				
				patrickCandyPile.add(seanCandyPile.get(maxSeanSumIndex));
				seanCandyPile.remove(maxSeanSumIndex);
				transfers += 1;
				
				sumSeanFake=0; sumPatrickFake=0; sumSeanReal=0; sumPatrickReal=0;
				for (int thisValue:seanCandyPile) {
					sumSeanFake = patrickAddition(sumSeanFake,thisValue);
					sumSeanReal += thisValue;
				}
				for (int thisValue:patrickCandyPile) {
					sumPatrickFake = patrickAddition(sumPatrickFake,thisValue);
					sumPatrickReal += thisValue;
				}				
				
				if (sumSeanFake==sumPatrickFake && sumSeanReal>sumPatrickFake) {
					equal=true;			
				}
				
			}
			
			//System.out.println(sumSeanFake+" "+sumSeanReal+"\n"+sumPatrickFake+" "+sumPatrickReal+"\n");
			
			/*Results Hash*/
			if (equal && patrickCandyPile.size()>0) {
				alreadyDone.put(processData[k], ""+sumSeanReal);
				results.put(t, ""+sumSeanReal);
			}
			else {
				alreadyDone.put(processData[k], "NO");
				results.put(t, "NO");
			}
		}
		
		/*OUTPUT FILE*/
		outputData = "";
		for (int z=1; z<=T; z++) {
			outputData += "Case #"+z+": "+results.get(z)+"\n";
		}
		
		CodeJamIO.writeFile(outputData);
		System.out.println(outputData);
	}
		
		//Test
		
		
}
	

