import java.io.*;
import java.util.*;

public class Magicka {
    int C;
    String[] c;
    int D;
    String[] d;
    int N;
    String data;

    private Object solve() throws Exception {
        Map<String,Character> combine = new HashMap<String,Character>();
        for (String s: c) {
            combine.put(s.charAt(0) + "" + s.charAt(1), s.charAt(2));
            combine.put(s.charAt(1) + "" + s.charAt(0), s.charAt(2));
        }

        Map<Character,Set<Character>> delete = new HashMap<Character,Set<Character>>();
        for (String s: d) {
            for (int i = 0; i <= 1; i++) {
                Set<Character> d = delete.get(s.charAt(i));
                if (d == null) {
                    d = new HashSet<Character>();
                }
                d.add(s.charAt(1-i));
                delete.put(s.charAt(i), d);
            }
        }

        StringBuilder s = new StringBuilder();

        for (int i = 0; i < data.length(); i++) {
            s.append(data.charAt(i));


            while (s.length() >= 2) {
                Character ch = combine.get(s.substring(s.length()-2, s.length()));
                if (ch == null) {
                    break;
                }
                s.delete(s.length() - 2, s.length()).append(ch);
            }

            for (int j = 0; j < s.length(); j++) {
                Set<Character> d = delete.get(s.charAt(j));
                if (d == null) {
                    continue;
                }
                for (int k = 0; k < s.length(); k++) {
                    if (k != j && d.contains(s.charAt(k))) {
                        s.delete(0, s.length());
                        break;
                    }
                }
            }
        }

        StringBuilder result = new StringBuilder();
        result.append('[');
        for (int i = 0; i < s.length(); i++) {
            if (i > 0) {
                result.append(", ");
            }
            result.append(s.charAt(i));
        }
        result.append(']');

        return result.toString();
    }

    private void load() throws Exception {
        C = nextInt();
        c = nextTokenArray(C);
        D = nextInt();
        d = nextTokenArray(D);
        N = nextInt();
        data = next();
        assert data.length() == N;

        log.print("C: " + C + ", c: " + Arrays.toString(c) + ", D: " + D + ", d: " + Arrays.toString(d) + ", N: " + N + ", s: " + data);
    }


    private static final String PREFIX = "B-large";
    private static final String PATH = "d:/gcjam11/qr/";
    private static final String POSTFIX_IN = ".in";
    private static final String POSTFIX_OUT = ".out";
    private static final PrintStream log = System.out;

    public static void main(String args[]) throws Exception {
        InputStreamReader reader = new InputStreamReader(new BufferedInputStream(new FileInputStream(PATH + PREFIX + POSTFIX_IN)));
        PrintStream out = new PrintStream(new FileOutputStream(PATH + PREFIX + POSTFIX_OUT));
        Scanner in = new Scanner(reader);

        long t0 = System.nanoTime();
        int testCount = in.nextInt(); in.nextLine();
        for (int testIndex = 1; testIndex <= testCount; testIndex++) {
            log.printf("Data #%d: ", testIndex);

            Magicka s = new Magicka();
            s.in = in;
            s.load();
            s.in = null;
            log.println();

            long t1 = System.nanoTime();
            String result = "Case #" + testIndex + ": " + s.solve();

            out.println(result);
            log.println(result);
            log.printf("Time #%d: %.6f sec\n\n", testIndex, (System.nanoTime() - t1) / 1e9);
        }
        log.printf("Total time: %.6f sec", (System.nanoTime() - t0)/1e9);

        reader.close();
        out.close();
    }

    private Scanner in;
    private int nextInt() { return in.nextInt(); }
    private long nextLong() { return in.nextLong(); }
    private double nextDouble() { return Double.parseDouble(in.next()); }
    private String nextLine() { return in.nextLine().trim(); }
    private void skipLine() { in.nextLine(); }
    private String next() { return in.next().trim(); }
    private int[] nextIntArray(int size) { int[] a = new int[size]; for (int i = 0; i < size; i++) a[i] = in.nextInt(); return a; }
    private long[] nextLongArray(int size) { long[] a = new long[size]; for (int i = 0; i < size; i++) a[i] = in.nextLong(); return a; }
    private double[] nextDoubleArray(int size) { double[] a = new double[size]; for (int i = 0; i < size; i++) a[i] = Double.parseDouble(in.next());  return a; }
    private String[] nextLineArray(int size) { String[] a = new String[size]; for (int i = 0; i < size; i++) a[i] = in.nextLine().trim(); return a; }
    private String[] nextTokenArray(int size) { String[] a = new String[size]; for (int i = 0; i < size; i++) a[i] = in.next().trim(); return a; }
}
