import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;

public class AirportWalkways {

    int X, S, R, t, N;
    int[] B, E, w;

    final static double EPS = 1e-10;
    private Object solve() throws Exception {
        int x = 0;
        double t = 0;
        double rt = this.t;

        for (int i = 0; x < X; i++) {
            int dx = 0;
            if (i == N || x < B[i]) {
                dx = (i == N? X: B[i]) - x;
                if (rt * R >= dx) {
                    t += dx / (double)R;
                    rt -= dx / (double)R;
                } else if (rt > EPS) {
                    t += rt + (dx - R*rt)/ (double)S;
                    rt = 0;
                } else {
                    t += dx / (double)S;
                }
            }
            x += dx;
            if (x >= X) break;

            dx = E[i] - x;
            if (rt * (R + w[i]) >= dx) {
                t += dx / (double)(R + w[i]);
                rt -= dx / (double)(R + w[i]);
            } else if (rt > EPS) {
                t += rt + (dx - (R+w[i])*rt)/ (double)(S + w[i]);
                rt = 0;
            } else {
                t += dx / (double)(S + w[i]);
            }
            x += dx;
        }
        return String.format("%.8f", t);
    }

    private void load() throws Exception {
        X = nextInt();
        S = nextInt();
        R = nextInt();
        t = nextInt();
        N = nextInt();

        log.print("X: " + X + ", S: " + S + ", R: " + R + ", t: " + t + ", N: " + N + ", DATA:");
        B = new int[N];
        E = new int[N];
        w = new int[N];
        for (int i = 0; i < N; i++) {
            B[i] = nextInt();
            E[i] = nextInt();
            w[i] = nextInt();
            log.print("(" + B[i] + ", " + E[i] + ", " + w[i] + "), ");
        }
    }


    private static final String PREFIX = "A-small-attempt1";
    private static final String PATH = "d:/gcjam11/r2/";
    private static final String POSTFIX_IN = ".in";
    private static final String POSTFIX_OUT = ".out";
    private static final PrintStream log = System.out;

    public static void main(String args[]) throws Exception {
        Locale.setDefault(Locale.US);
        InputStreamReader reader = new InputStreamReader(new BufferedInputStream(new FileInputStream(PATH + PREFIX + POSTFIX_IN)));
        PrintStream out = new PrintStream(new FileOutputStream(PATH + PREFIX + POSTFIX_OUT));
        Scanner in = new Scanner(reader);

        long t0 = System.nanoTime();
        int testCount = in.nextInt(); in.nextLine();
        for (int testIndex = 1; testIndex <= testCount; testIndex++) {
            log.printf("Data #%d: ", testIndex);

            AirportWalkways s = new AirportWalkways();
            s.in = in;
            s.load();
            s.in = null;
            log.println();

            long t1 = System.nanoTime();
            String result = "Case #" + testIndex + ": " + s.solve();

            out.println(result);
            log.println(result);
            log.printf("Time #%d: %.6f sec\n\n", testIndex, (System.nanoTime() - t1) / 1e9);
        }
        log.printf("Total time: %.6f sec", (System.nanoTime() - t0)/1e9);

        reader.close();
        out.close();
    }

    private Scanner in;
    private int nextInt() { return in.nextInt(); }
    private long nextLong() { return in.nextLong(); }
    private double nextDouble() { return Double.parseDouble(in.next()); }
    private String nextLine() { return in.nextLine().trim(); }
    private void skipLine() { in.nextLine(); }
    private String next() { return in.next().trim(); }
    private int[] nextIntArray(int size) { int[] a = new int[size]; for (int i = 0; i < size; i++) a[i] = in.nextInt(); return a; }
    private long[] nextLongArray(int size) { long[] a = new long[size]; for (int i = 0; i < size; i++) a[i] = in.nextLong(); return a; }
    private double[] nextDoubleArray(int size) { double[] a = new double[size]; for (int i = 0; i < size; i++) a[i] = Double.parseDouble(in.next());  return a; }
    private String[] nextLineArray(int size) { String[] a = new String[size]; for (int i = 0; i < size; i++) a[i] = in.nextLine().trim(); return a; }
    private String[] nextTokenArray(int size) { String[] a = new String[size]; for (int i = 0; i < size; i++) a[i] = in.next().trim(); return a; }
}
