import java.io.*;
import java.util.*;

public class TheKillerWord {
    int N, M;
    String[] D, L;

    private Object[] cost(String d, String L) {
        ArrayList<String> D = new ArrayList<String>();
        for (int i = 0; i < this.D.length; i++) {
            if (this.D[i].length() == d.length()) {
                D.add(this.D[i]);
            }
        }

        int cost = 0;
        for (int i = 0; i < L.length() && D.size() > 1; i++) {
            char ch = L.charAt(i);

            boolean contains = false;
            for (String s: D) {
                if (s.indexOf(ch) >= 0) {
                    contains = true;
                    break;
                }
            }
            if (!contains) continue;

            for (int k = 0; k < D.size(); k++) {
                String s = D.get(k);
                for (int j = 0; j < d.length(); j++) {
                    char ch0 = d.charAt(j);
                    if (ch0 == '_') continue;
                    if ((ch0 == ch && s.charAt(j) != ch) || (ch0 != ch && s.charAt(j) == ch)) {
                        D.remove(k);
                        k--;
                        break;
                    }
                }
            }

            if (d.indexOf(ch) >= 0) {
                d = d.replace(ch, '_');
            } else {
                cost++;
            }

        }

        return new Object[] {cost, D.get(0)};
    }

    private Object solve() throws Exception {
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < L.length; i++) {
            int bestCost = -1;
            String bestWord = "";
            for (String s: D) {
                Object[] c = cost(s, L[i]);
                int cost = (Integer)c[0];
                if (cost > bestCost) {
                    bestCost = cost;
                    bestWord = (String)c[1];
                }
            }
            sb.append(bestWord + " ");
        }
        return sb.toString().trim();
    }

    private void load() throws Exception {
        N = nextInt();
        M = nextInt();
        D = nextTokenArray(N);
        L = nextTokenArray(M);
        log.print("N: " + N + ", M: " + M + ", D: " + Arrays.toString(D) + ", L: " + Arrays.toString(L));
    }


    private static final String PREFIX = "B-small-attempt1";
    private static final String PATH = "d:/gcjam11/r1a/";
    private static final String POSTFIX_IN = ".in";
    private static final String POSTFIX_OUT = ".out";
    private static final PrintStream log = System.out;

    public static void main(String args[]) throws Exception {
        Locale.setDefault(Locale.US);
        InputStreamReader reader = new InputStreamReader(new BufferedInputStream(new FileInputStream(PATH + PREFIX + POSTFIX_IN)));
        PrintStream out = new PrintStream(new FileOutputStream(PATH + PREFIX + POSTFIX_OUT));
        Scanner in = new Scanner(reader);

        long t0 = System.nanoTime();
        int testCount = in.nextInt(); in.nextLine();
        for (int testIndex = 1; testIndex <= testCount; testIndex++) {
            log.printf("Data #%d: ", testIndex);

            TheKillerWord s = new TheKillerWord();
            s.in = in;
            s.load();
            s.in = null;
            log.println();

            long t1 = System.nanoTime();
            String result = "Case #" + testIndex + ": " + s.solve();

            out.println(result);
            log.println(result);
            log.printf("Time #%d: %.6f sec\n\n", testIndex, (System.nanoTime() - t1) / 1e9);
        }
        log.printf("Total time: %.6f sec", (System.nanoTime() - t0)/1e9);

        reader.close();
        out.close();
    }

    private Scanner in;
    private int nextInt() { return in.nextInt(); }
    private long nextLong() { return in.nextLong(); }
    private double nextDouble() { return Double.parseDouble(in.next()); }
    private String nextLine() { return in.nextLine().trim(); }
    private void skipLine() { in.nextLine(); }
    private String next() { return in.next().trim(); }
    private int[] nextIntArray(int size) { int[] a = new int[size]; for (int i = 0; i < size; i++) a[i] = in.nextInt(); return a; }
    private long[] nextLongArray(int size) { long[] a = new long[size]; for (int i = 0; i < size; i++) a[i] = in.nextLong(); return a; }
    private double[] nextDoubleArray(int size) { double[] a = new double[size]; for (int i = 0; i < size; i++) a[i] = Double.parseDouble(in.next());  return a; }
    private String[] nextLineArray(int size) { String[] a = new String[size]; for (int i = 0; i < size; i++) a[i] = in.nextLine().trim(); return a; }
    private String[] nextTokenArray(int size) { String[] a = new String[size]; for (int i = 0; i < size; i++) a[i] = in.next().trim(); return a; }
}
