import java.util.Scanner;

public class Minesweeper {
	Scanner sc = new Scanner(System.in);
	private int R = 0;
	private int C = 0;
	private int M = 0;
	private int next = 0;

	public void init() {
		R = sc.nextInt();
		C = sc.nextInt();
		M = sc.nextInt();
	}

	public void printTable(char table[][]) {
		for (int i = 0; i < table.length; i++) {
			for (int j = 0; j < table[i].length; j++) {
				System.out.print(table[i][j] + " ");
			}
			System.out.println();
		}
	}

	public void process() {
		char[][] table = new char[R][C];
		for (int i = 0; i < R; i++) {
			for (int j = 0; j < C; j++) {
				table[i][j] = '.';
			}
		}
		boolean impossible = false;
		table[0][0] = 'C';
		while (R <= M || C <= M) {
			if (R <= C && R <= M) {
				for (int i = 0; i < R; i++) {
					table[i][C - 1] = '*';
				}
				C--;
				M -= R;
			}
			if (C <= M) {
				for (int i = 0; i < C; i++) {
					table[R - 1][i] = '*';
				}
				R--;
				M -= C;
			}
			if (R == 1 || C == 1) {
				impossible = true;
			}
		}
		next++;
		System.out.println("Case #" + next + ":");
		if (impossible == true) {
			System.out.println("Impossible");
		} else if (M == 0) {
			printTable(table);
		} else if (R == 1 || C == 1) {
			if (R == 1) {
				for (int i = 0; i < M; i++) {
					table[0][C - 1 - i] = '*';
				}
			} else if (C == 1) {
				for (int i = 0; i < M; i++) {
					table[R - 1 - i][0] = '*';
				}
			}
			printTable(table);
		} else if ((C == 2 || R == 2) && M == 1) {
			System.out.println("Impossible");
		} else if (C == 2 && R == 2 && M == 3) {
			table[0][1] = '*';
			table[1][0] = '*';
			table[1][1] = '*';
			printTable(table);
		} else if (C + R - 5 >= M) {
			for (int j = R - 1; j >= 2; j--) {
				if (M == 0)
					break;
				table[j][C - 1] = '*';
				M--;
			}
			if (M != 0) {
				M++;
				for (int j = C - 1; j >= 2; j--) {
					if (M == 0)
						break;
					table[R - 1][j] = '*';
					M--;
				}
			}
			printTable(table);
		} else {
			System.out.println("Impossible");
		}
	}

	public void run() {
		int size = sc.nextInt();
		for (int i = 0; i < size; i++) {
			init();
			process();
		}
		sc.close();
	}

	public static void main(String[] args) {
		new Minesweeper().run();
	}
}
