package qualif2015;

import java.util.Scanner;
import java.util.TreeMap;
import java.util.TreeSet;

public class Restaurant {

	
	public static int highest = 0;
	public static int moveCost = 0;


	public static int bestScoreEver = Integer.MAX_VALUE;
	
	public static TreeMap<Integer, Integer> people = null;

	public static void reset() {
		highest = 0;
		moveCost = 0;
		people = new TreeMap<Integer, Integer>();
		bestScoreEver = Integer.MAX_VALUE;
	}
	
	public static boolean reduceHighest() {
		
		int initHeight = people.lastKey();
		int initialStep = people.get(initHeight);	
		Integer secondHighest = people.lowerKey(initHeight);
		if(secondHighest == null) {
			secondHighest = 0;
		}
		
		//update the globals
		highest = initHeight;
		
		if(score(highest, moveCost) < bestScoreEver) {
			bestScoreEver = score(highest, moveCost);
		}
		
		//not worth it, eg: 16 16 ... 16
		if(initialStep > initHeight) {
			return false;
		}
		
		
		int curHeight = initHeight;
		int curCost = 0;
		int step = initialStep;
		
		int lastHeight = curHeight;
		int lastCost = curCost;
		
		
		int iteration = 0;
		while( (lastHeight + lastCost) > secondHighest 
				&& (curCost + curHeight) <= lastHeight
				&& ( score((curHeight > secondHighest) ? curHeight : secondHighest,(curCost + moveCost)) <= score(highest, moveCost))
				&& iteration < 2) {
			
			lastHeight = curHeight;
			lastCost = curCost;
			
			
			curHeight = (int) Math.ceil( 1d * curHeight / 2);
			curCost = (int) (curCost + step);
			
			step++;
			iteration++;
		}
		
		
		if(initHeight > lastHeight) {
			
			//Updating the people map
			people.remove(initHeight);
			
			Integer existingQuantity = people.get(lastHeight);
			if(existingQuantity == null) {
				existingQuantity = 0;
			}
			
			if(lastHeight * 2 != initHeight) {
				
				people.put(lastHeight, existingQuantity + initialStep);
				people.put(lastHeight - 1, existingQuantity + initialStep);
			}
			else {
				people.put(lastHeight, existingQuantity + (initialStep * 2));
			}
			
			moveCost = moveCost + lastCost;
			
			return true;
		}
		else {
			return false;
		}
	}
	
	
	public static int score(int highest, int moveCost) {
		return highest + moveCost;
	}
	
	public static void main(String...args) {
		
		
		Scanner reader = new Scanner(System.in);
		int caseCount = Integer.parseInt(reader.nextLine());
		
	
		//for each use case
		for(int caseId = 0; caseId < caseCount; caseId++) {

			int peopleNumber = Integer.parseInt(reader.nextLine());

			reset();
			for(int i = 0; i < peopleNumber; i++) {
				int person = reader.nextInt();
				
				Integer quantity = people.get(person);
				if(quantity == null) {
					quantity = 0;
				}
				people.put(person, quantity + 1);
			}
			
			while(reduceHighest());
			
			System.out.println("Case #"+ (caseId + 1) + ": "+ bestScoreEver);
			reader.nextLine();
		}
		
	}
}
