package qualif2015;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.TreeSet;

public class Q {

	public final static char i = 'i';
	public final static char j = 'j';
	public final static char k = 'k';
	public final static char un = '1';
	
	public final static Q I = new Q(i);
	public final static Q J = new Q(j);
	public final static Q K = new Q(k);
	public final static Q UN = new Q(un);
	
	
	
	public char v;
	public boolean isPositive;
	
	
	public Q(char value) {
		this.v = value;
		isPositive = true;
	}
	
	public Q(char value, boolean isPositive) {
		this(value);
		this.isPositive = isPositive;
	}
	
	
	public static Q multiply(Q q1, Q q2) {
		
		char symbol = 0;
		boolean sign = q1.isPositive == q2.isPositive;
		boolean signOperation = true;
		
		if(q1.v == un) {
			symbol = q2.v;
		}
		else if(q2.v == un) {
			symbol = q1.v;
		}
		
		else if(q1.v == q2.v) {
			symbol = un;
			signOperation = false;
		}
		
		
		else if(q1.v == i && q2.v == j) {
			symbol = k;
			signOperation = true;
		}
		else if(q1.v == j && q2.v == i) {
			symbol = k;
			signOperation = false;
		}
		
		else if(q1.v == k && q2.v == i) {
			symbol = j;
			signOperation = true;
		}
		else if(q1.v == i && q2.v == k) {
			symbol = j;
			signOperation = false;
		}
		
		else if(q1.v == j && q2.v == k) {
			symbol = i;
			signOperation = true;
		}
		else if(q1.v == k && q2.v == j) {
			symbol = i;
			signOperation = false;
		}
		
			
		return new Q(symbol, (sign == signOperation));
	}
	
	public String toString() {
		String sign = (isPositive) ? "" : "-";
		return sign + v;
	}
	
	@Override
	public boolean equals(Object obj) {
		Q q2 = (Q) obj;
		
		return (v == q2.v) && (isPositive == q2.isPositive);
	}
	
	
	public static List<Q> stringToQ(String input) {
		
		List<Q> symboles = new ArrayList<Q>();
		for(char symbole : input.toCharArray()) {
			Q cur = new Q(symbole);
			symboles.add(cur);
		}
		
		return symboles;
	}
	
	
	public static List<Q> QMul(List<Q> symboles, int count) {
		List<Q> copy = new ArrayList<Q>(symboles);
		
		for(int i = 0 ; i < (count - 1); i++) {
			symboles.addAll(copy);
		}
		
		return symboles;
	}
	
	
	
	public static boolean isElligible(List<Q> symboles) {
		
		Q product = new Q(un, true);
		HashSet<Integer> alphabet = new HashSet<Integer>();
		for(Q symbole : symboles) {
			product = multiply(product, symbole);
			
			alphabet.add((int) symbole.v);
		}
		
		
		
		return (product.equals(new Q(un, false)) && alphabet.size() > 1);
	}
	
	public static boolean validateIJK(List<Q> symboles) {
		
		Q product1 = new Q(un,true);
		for(int p1 = 0; p1 < symboles.size(); p1++) {
			product1 = multiply(product1, symboles.get(p1));
			
			if(product1.equals(I)) {
				
				Q product2 = new Q(un,true);
				for(int p2 = p1 + 1; p2 < symboles.size(); p2++) {
					product2 = multiply(product2, symboles.get(p2));
					
					if(product2.equals(J)) {
						
						Q product3 = new Q(un,true);
						for(int p3 = p2 + 1; p3 < symboles.size(); p3++) {
							product3 = multiply(product3, symboles.get(p3));
							
							if(product3.equals(K)) {
								return true;
							}
						}
					}
				}	
			}
		}
		
	
		return false;
	}
	
	
	public static void main(String...args) {
		
		
		//System.out.println(validateIJK(stringToQ("jijijijijiji")));
		
	
		
		
		Scanner reader = new Scanner(System.in);
		int caseCount = Integer.parseInt(reader.nextLine());
		
	
		//for each use case
		for(int caseId = 0; caseId < caseCount; caseId++) {

			
			int charLength = reader.nextInt();
			int repetition = reader.nextInt();
			
			reader.nextLine();
			String input = reader.nextLine();
			List<Q> symboles = stringToQ(input);
			
			symboles = QMul(symboles, repetition);
			
			boolean isIJK = false;
			
			if(isElligible(symboles)) {
				isIJK = validateIJK(symboles);
			}
			
			
			System.out.println("Case #"+ (caseId + 1) + ": "+ ((isIJK) ? "YES" : "NO"));
		}
		
	}
}
