/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package codejam;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author eltayeb
 */
public class TicTacToeTomek {

    private enum STATE{
        DRAW , NC , WON
    }
    private static final String inputFileName = "input.txt";
    private static final int row = 4;
    private static final int col = 4;
    private static final String  draw = "Draw";
    private static final String  nc = "Game has not completed";
    private static final String  won = "won";
    private static STATE state = STATE.DRAW;
    private static String winner = ".";//should be set to O or X in case of winning
    private static char[][] cell = new char[row][col];
    private static int casesNumber = -1;
    private static int lineNumber = 0;
    private static int caseNumber = 0;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            // TODO code application logic here
            //1- read input
            //2- run the algorithm
            readInputFile();
        } catch (FileNotFoundException ex) {
            System.out.println("ERROR:: " + ex.toString());
        } catch (IOException ex) {
            System.out.println("ERROR:: " + ex.toString());
        }
    }


    static private void processString(String strLine) {
        //ignor empty lines
        if (strLine.isEmpty() || strLine.matches("\n") || strLine.matches("\r") || strLine.matches("\n\r")|| strLine.matches("\r\n"))
            return;
        if (casesNumber == -1){
            casesNumber = Integer.parseInt(strLine);
            return;
        }
        filloutBoard(lineNumber, strLine.toCharArray());
        lineNumber++;
        if (lineNumber==4){
            caseNumber++;
            lineNumber=0;
            checkForWinner();
            printResult(caseNumber);
            cleanBoard();
        }
    }

    public static boolean checkForWinner(){
        char prob = '.';
        //horizontal winning
        for (int i = 0 ; i< row ; i++){
            prob = '.';
            if (cell[i][0] == 'T')
                prob = cell[i][1];
            else
                prob = cell[i][0];
            if (prob == '.')
                continue;
            for (int j = 1 ; j < col ; j++){
                if (cell[i][j] != prob && cell[i][j] != 'T'){
                    break;
                } else if (j==3){
                    //we have a winner
                    winner= "" + prob;
                    state = STATE.WON;
                    return true;
                }
            }
        }

        //vertical winning
        for (int j = 0 ; j< col ; j++){
            prob = '.';
            if (cell[0][j] == 'T')
                prob = cell[1][j];
            else
                prob = cell[0][j];
            if (prob == '.')
                continue;
            for (int i = 1 ; i < row ; i++){
                if (cell[i][j] != prob && cell[i][j] != 'T'){
                    break;
                } else if (i==3){
                    //we have a winner
                    winner= "" + prob;
                    state = STATE.WON;
                    return true;
                }
            }
        }

        //diagonal winning
        prob = '.';
        if (cell[0][0] == 'T')
            prob = cell[1][1];
        else
            prob = cell[0][0];

        for (int i = 1 ; i < row ; i++){
            if (prob == '.')
                break;
            if (cell[i][i] != prob && cell[i][i] != 'T'){
                break;
            } else if (i==3){
                    //we have a winner
                    winner= "" + prob;
                    state = STATE.WON;
                    return true;
                }
        }
        prob = '.';
        if (cell[row-1][0] == 'T')
            prob = cell[row-2][1];
        else
            prob = cell[row-1][0];
        for (int i = 1 ; i < row ; i++){
            if (prob == '.')
                break;
            if (cell[row-i-1][i] != prob && cell[row-i-1][i] != 'T'){
                break;
            } else if (i==3){
                    //we have a winner
                    winner= "" + prob;
                    state = STATE.WON;
                    return true;
                }
        }
        return false;
    }
    
    public static void readInputFile() throws FileNotFoundException, IOException{
        FileInputStream f = null;
        try {
            f = new FileInputStream(inputFileName);
            Reader reader = new InputStreamReader(f);
            BufferedReader buffer = new BufferedReader(reader);
            String strLine;
            while ((strLine = buffer.readLine()) != null) {
                processString(strLine);
            }
        } 
        finally {
            try {
                f.close();
            } catch (IOException ex) {
                System.out.println("ERROR:" + ex.toString());
            }

        }
    }

    public static boolean filloutBoard(int r , char[] data){
        //System.arraycopy(data, 0, cell[r], 0, col);
        //Scan each line to find empty cells
        for (int i=0 ; i < col ; i++){
            cell [r][i] = data [i];
            if (data[i] == '.'){
                state = STATE.NC;
            }
        }
        return true;
    }

    /**
     * cleanBoard initialize the cells ,set each cell to '.'
     */
    public static void cleanBoard(){
        for (int i = 0 ; i < row ; i++ ){
            for (int j = 0; j < col ; j++){
                cell[i][j]='.';
            }
        }
        state = STATE.DRAW;
        winner = ".";
    }

    /**
     * printResult prints the result for specific test case determined by caseNumber
     * @param caseNumber test case number
     */
    public static void printResult(int caseNumber){
        switch(state){
            case DRAW:
                System.out.println("Case #" + caseNumber + ": " + draw);
                break;
            case NC:
                System.out.println("Case #" + caseNumber + ": " + nc);
                break;
            case WON:
                System.out.println("Case #" + caseNumber + ": " + winner + " " + won);
                break;
            default:
                System.out.println("Case #" + caseNumber + ": " + "ERROR");
                break;
        }
    }

}
