import java.io.*;
import java.util.*;

public class CoinJam {
	public static void main(String[] args) throws Exception {
		Scanner sc = new Scanner(new FileReader("input" + (args.length == 0 ? "" : args[0]) + ".txt"));
		PrintWriter pw = new PrintWriter(new FileWriter("output" + (args.length == 0 ? "" : args[0]) + ".txt"));
		int numOfCase = sc.nextInt();
		long[] nontrivial = new long[9];

		for (int i = 1; i <= numOfCase; i++) {
			int length = sc.nextInt();
			int[] coin = new int[length];
			coin[0] = 1;
			coin[length - 1] = 1;

			pw.println("Case #" + i + ":");

			int numOfCoinNeeded = sc.nextInt();
			int coinCount = 0;

			while (coinCount < numOfCoinNeeded) {
				if (isJamCoin(coin, nontrivial)) {
					outputJamCoin(coin, nontrivial, pw);
					coinCount++;
				}

				int m = length - 2;
				while (m > 0 && coin[m] == 1) {
					coin[m] = 0;
					m--;
				}
				coin[m] = 1;
			}
		}
		
		pw.flush();
		pw.close();
		sc.close();
	}

	public static boolean isJamCoin(int[] coin, long[] nontrivial) {
		Arrays.fill(nontrivial, 0);

		for (int base = 2; base <= 10; base++) {
			long number = 0;
			for (int digit : coin) {
				number *= base;
				number += digit;
			}

			long sqrt = (long) Math.sqrt(number);
			for (long divisor = 2; divisor <= sqrt; divisor++) {
				if (number % divisor == 0) {
					nontrivial[base - 2] = divisor;
					break;
				}
			}

			if (nontrivial[base - 2] == 0) return false;
		}

		return true;
	}

	public static void outputJamCoin(int[] coin, long[] nontrivial, PrintWriter pw) {
		//long test = 0;
		for (int digit : coin) {
			pw.print(digit);
			//test = test * 10 + digit;
		}

		//pw.print(" = " + test);

		for (long divisor : nontrivial) {
			pw.print(" " + divisor);
		}
		pw.println();

	}
}