package emm.cj08.round1b;

import java.io.*;
import java.util.*;

public class ProbB {
	private static String me = "B";
	private static int run = 0;
	
	private static BufferedReader br;
	private static PrintStream ps;
	
	private static List<Integer> lprimes;
	private static Set<Integer> sprimes;
	
	public static void main2(String[] args) throws IOException {
		int max = 1000200;
		lprimes = new ArrayList<Integer>(max);
		lprimes.add(2);
		
		for(int i = 3; i <= max; i += 2) {
			boolean found = false;
			for(int cur: lprimes)
				if(i%cur == 0) {
					found = true;
					break;
				}
			
			if(!found)
				lprimes.add(i);
		}
		
		PrintStream ps = new PrintStream("primes.txt");
		for(int i: lprimes)
			ps.println(i);
		ps.close();
	}
	
	public static void main(String[] args) throws IOException {
		lprimes = new ArrayList<Integer>(80000);
		
		BufferedReader bprimes = new BufferedReader(new FileReader("primes.txt"));
		String line;
		while((line = bprimes.readLine()) != null) {
			if(line.length() == 0)
				continue;
			
			lprimes.add(Integer.parseInt(line));
		}
		bprimes.close();
		sprimes = new HashSet<Integer>();
		sprimes.addAll(lprimes);
		
		
		br = new BufferedReader(new FileReader(getInFile()));

		List<String> o = new ArrayList<String>();
		
		int trials = ri();
		for(int trial = 0; trial < trials; trial++) {
			String[] arr = rss();
			
			long a = Long.parseLong(arr[0]);
			long b = Long.parseLong(arr[1]);
			long p = Long.parseLong(arr[2]);
			
			HashMap<Long,List<Pointer>> map = new HashMap<Long,List<Pointer>>(); 
			List<Long> goodkeys = new ArrayList<Long>();
			
			for(long cur = a; cur <= b; cur++) {
				Pointer me = new Pointer(cur);
				
				for(long factor: vfactor(cur, p)) {
					if(map.containsKey(factor)) {
						List<Pointer> clist = map.get(factor);
						
						if(clist.size() == 1)
							goodkeys.add(factor);
						
						clist.add(me);
					} else {
						List<Pointer> list = new ArrayList<Pointer>();
						list.add(me);
						map.put(factor, list);
					}
				}
			}
			
			long size = b - a + 1;
			for(long key: goodkeys) {
				List<Pointer> list = map.get(key);
				Pointer curpointer = list.get(0);
				
				for(Pointer po: list)
					if(po.myset != curpointer.myset) {
						for(Pointer other: po.pset) {
							curpointer.myset.add(other.me);
							curpointer.pset.add(other);
							
							other.pset = curpointer.pset;
							other.myset = curpointer.myset;
						}

						size--;
					}
			}
			
			o.add("" + size);
		}
		
		br.close();
		
		
		System.out.println("\nResults:\n");
		ps = new PrintStream("/home/eric/workspace/CodeJam08/src/emm/cj08/round1b/" + me + "-out.txt");
		
		int pos = 1;
		for(String str: o) {
			String out = "Case #" + (pos++) + ": " + str;
			
			System.out.println(out);
			ps.println(out);
		}
		
		ps.close();
	}

	private static void merge(Pointer a, Pointer b) {
		if(a.myset == b.myset) {
			return;
		}
		
		
	}
	
	private static class Pointer {
		public long me;
		public Set<Long> myset;
		public Set<Pointer> pset;
		
		public Pointer(long me) {
			this.me = me;
			myset = new HashSet<Long>();
			myset.add(me);
			
			pset = new HashSet<Pointer>();
			pset.add(this);
		}
		
		@Override
		public int hashCode() {
			return new Long(me).hashCode(); 
		}
		
		@Override
		public boolean equals(Object o) {
			return ((Pointer)o).me == me;
		}
	}
	
	private static boolean isPrime(long l) {
		for(int i: lprimes)
			if(l % i == 0)
				return false;
		
		return true;
	}
	
	private static List<Long> vfactor(long l, long p) {
		List<Long> result = new ArrayList<Long>();
		
		for(long cur: factor(l))
			if(cur >= p)
				result.add(cur);
		
		return result;
	}
	
	private static Set<Long> factor(long l) {
		long orig = l;
		Set<Long> result = new HashSet<Long>();
		Iterator<Integer> i = lprimes.iterator();
		long curprime = i.next();
		
		while(l >= curprime && i.hasNext()) {
			while(l % curprime == 0) {
				l /= curprime;
				result.add(curprime);
			}
			
			curprime = i.next();
		}
		
		if(result.size() == 0)
			result.add(orig);
		
		return result;
	}
	
	private static void calcPrimes(int max) {
		
		
		sprimes = new HashSet<Integer>(lprimes.size());
		sprimes.addAll(lprimes);
	}
	
	private static String rs() throws IOException {
		String line = br.readLine();
		
		System.out.println(line);
		return line;
	}
	
	private static String[] rss() throws IOException {
		return rs().split(" ");
	}
	
	private static int ri() throws IOException {
		return Integer.parseInt(rs());
	}
	
	private static int[] ris() throws IOException {
		String[] arr = rss();
		int[] result = new int[arr.length];
		
		for(int i = 0; i < result.length; i++)
			result[i] = Integer.parseInt(arr[i]);
		
		return result;
	}
	
	private static double rd() throws IOException {
		return Double.parseDouble(rs());
	}
	
	private static double[] rds() throws IOException {
		String[] arr = rss();
		double[] result = new double[arr.length];
		
		for(int i = 0; i < result.length; i++)
			result[i] = Double.parseDouble(arr[i]);
		
		return result;
	}
	
	private static String getInFile() {
		String base = "/home/eric/workspace/CodeJam08/src/emm/cj08/round1b/" + me + "-";
		
		if(run == -2) {
			return base + "short.txt";
		} else if(run == -1) {
			return base + "large.in";
		} else {
			return base + "small-attempt" + run + ".in";
		}
	}
}
