package emm.cj08.round1;

import java.io.*;
import java.math.*;
import java.util.*;
import java.text.*;

public class Scalar {
	private static final File IN = new File("/home/eric/cj/scalar-in.txt"), OUT = new File("/home/eric/cj/scalar-out.txt");
	
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(IN));
		PrintStream ps = new PrintStream(OUT);
		
		int trials = Integer.parseInt(br.readLine());
		for(int trial = 0; trial < trials; trial++) {
			int dim = Integer.parseInt(br.readLine());
			
			int[] va = read(br);
			int[] vb = read(br);
			
			Arrays.sort(va);
			Arrays.sort(vb);
			
			BigInteger result = BigInteger.ZERO;
			for(int i = 0; i < dim; i++)
				result = result.add(new BigInteger("" + (long)va[i] * vb[vb.length - 1 - i]));
			
			ps.println("Case #" + (trial + 1) + ": " + result);
		}
		
		br.close();
		ps.close();
	}
	
	private static int[] read(BufferedReader br) throws IOException {
		String[] arr = br.readLine().split(" ");
		int[] result = new int[arr.length];
		
		for(int i = 0; i < result.length; i++)
			result[i] = Integer.parseInt(arr[i]);
		
		return result;
	}
}
