import java.io.*;
import java.lang.*;
import java.util.*;
import java.math.*;


public class Solution
{

	static class Frac {
		BigInteger a, b;
		Frac (BigInteger c, BigInteger d) {
			a = c;
			b = d;
			norm();
		}

		void norm() {
			BigInteger g = a.gcd(b);
			a = a.divide(g);
			b = b.divide(g);
		}

		Frac add (Frac f) {
			return new Frac (a.multiply(f.b).add( f.a.multiply(b) ), b.multiply(f.b));
		}
	}

	public static void main (String [] args) throws IOException {
		Scanner sc = new Scanner (System.in);
		PrintWriter pw = new PrintWriter (System.out);

		int ts = sc.nextInt();
		for (int tt=1; tt<=ts; ++tt) {
			
			int n = sc.nextInt(),
				m = sc.nextInt();
			int d[][] = new int [m][];
			int sz[] = new int [m];
			for (int i=0; i<m; ++i) {
				int k = sc.nextInt();
				sz[i] = k;
				d[i] = new int[k];
				d[i][0] = 1;
				for (int j=1; j<k; ++j)
					d[i][j] = sc.nextInt();
				while (sz[i] > 0 && d[i][sz[i]-1] > n)
					--sz[i];
			}

			Frac res = new Frac (BigInteger.ZERO, BigInteger.ONE);

			if (m > 1) {

			for (int d1=0; d1<10000 && 1+d1<=n; ++d1) {

				int sum = 0,
					cnt = sz[0] + sz[1];
				for (int i=0; i<sz[0]; ++i)
					for (int j=0; j<sz[1]; ++j)
						if (d[0][i] == d[1][j] + d1) {
							sum += 4;
							cnt -= 2;
						}
				int ptr1 = sz[0] - 1,
					ptr2 = sz[1] - 1;
				for (int i=0; i<sz[0]; ++i)
					if (d[0][i] > n) {
						--cnt;
						--ptr1;
					}
				for (int i=0; i<sz[1]; ++i)
					if (d1 + d[1][i] > n) {
						--cnt;
						--ptr2;
					}
				sum += cnt;

				int prev = n + 1;
				//pw.println( "d1=" + d1 );
				while (ptr1>=0 && ptr2>=0) {
					int right = Math.max( d[0][ptr1], d[1][ptr2] + d1 );
					int cc = prev - right;
					//pw.println ("ptr: " + ptr1 + " " + ptr2 + " right=" + right + " sum=" + sum + " cc=" + cc);
	
					res = res.add( new Frac (BigInteger.valueOf(sum) .multiply( BigInteger.valueOf(cc) ), BigInteger.ONE) );

					if (d[0][ptr1] == d[1][ptr2] + d1)
						sum -= 4;
					else
						sum -= 1;
					if (d[0][ptr1] == right)  --ptr1;
					if (d[1][ptr2] + d1 == right)  --ptr2;
					prev = right;
				}
				
				//pw.println( "d1=" + d1 + " res=" + res.a);
				//pw.flush();
				
			}
			for (int d1=1; d1<10000 && 1+d1<=n; ++d1) {

				int sum = 0,
					cnt = sz[0] + sz[1];
				int ptr1 = sz[0] - 1,
					ptr2 = sz[1] - 1;
				for (int i=0; i<sz[0]; ++i)
					for (int j=0; j<sz[1]; ++j)
						if (d1 + d[0][i] == d[1][j]) {
							sum += 4;
							cnt -= 2;
						}
				for (int i=0; i<sz[0]; ++i)
					if (d1 + d[0][i] > n) {
						--cnt;
						--ptr1;
					}
				for (int i=0; i<sz[1]; ++i)
					if (d[1][i] > n) {
						--cnt;
						--ptr2;
					}
				sum += cnt;

				int prev = n + 1;
				//pw.println( "d1=" + d1 );
				while (ptr1>=0 && ptr2>=0) {
					int right = Math.max( d[0][ptr1] + d1, d[1][ptr2] );
					int cc = prev - right;
					//pw.println ("ptr: " + ptr1 + " " + ptr2 + " right=" + right + " sum=" + sum + " cc=" + cc);
	
					res = res.add( new Frac (BigInteger.valueOf(sum) .multiply( BigInteger.valueOf(cc) ), BigInteger.ONE) );

					if (d[0][ptr1] + d1 == d[1][ptr2])
						sum -= 4;
					else
						sum -= 1;
					if (d[0][ptr1] + d1 == right)  --ptr1;
					if (d[1][ptr2] == right)  --ptr2;
					prev = right;
				}
				
				//pw.println( "d1=" + d1 + " res=" + res.a);
				//pw.flush();
				
			}

			//pw.println( " res=" + res.a);
			//pw.flush();
			for (int i=0; i<sz[1]; ++i) {
				if (10000 + d[1][i] > n)
					continue;
				int cnt;
				if (i == sz[1]-1)
					cnt = n - 10000 - d[1][i];
				else
					cnt = d[1][i+1] - d[1][i];
				cnt = Math.min( cnt, n - (10000 + d[1][i] - 1) );
				if (cnt > 0) {
					res = res.add( new Frac (BigInteger.valueOf(cnt).multiply(BigInteger.valueOf(cnt+1)).divide(BigInteger.valueOf(2)).multiply( BigInteger.valueOf(sz[0]+i+1) ), BigInteger.ONE) );
					//pw.println( "cnt=" + cnt + " mult=" + (sz[0]+i+1));
				}
			}

			for (int i=0; i<sz[0]; ++i) {
				int cnt;
				if (i == sz[0]-1)
					cnt = n - (m>1 ? 10000 : 0) - d[0][i];
				else
					cnt = d[0][i+1] - d[0][i];
				cnt = Math.min( cnt, n - (10000 + d[0][i] - 1) );
				if (cnt > 0) {
					res = res.add( new Frac (BigInteger.valueOf(cnt).multiply(BigInteger.valueOf(cnt+1)).divide(BigInteger.valueOf(2)).multiply( BigInteger.valueOf((m>1 ? sz[1] : 0) +i+1) ), BigInteger.ONE) );
					//pw.println( "cnt=" + cnt + " mult=" + (sz[0]+i+1));
				}
			}

			}

			else {
				for (int i=0; i<sz[0]; ++i) {
					int cnt;
					if (i == sz[0]-1)
						cnt = n - (m>1 ? 10000 : 0) - d[0][i] + 1;
					else
						cnt = d[0][i+1] - d[0][i];
					//pw.println("cnt=" + cnt);
					res = res.add( new Frac (BigInteger.valueOf(cnt).multiply( BigInteger.valueOf(i+1) ), BigInteger.ONE) );
				}
			}

			res.b = res.b.multiply( BigInteger.valueOf(n).pow(m) );
			res.norm();

			BigInteger k = res.a.divide( res.b );
			res.a = res.a.subtract( res.b.multiply( k ) );

			pw.println ("Case #" + tt + ": " + k + "+" + res.a + "/" + res.b);
			pw.flush();

		}

	}
}

