import java.util.Arrays;
import java.util.Scanner;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import static java.lang.System.out;

public class Treasure {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws FileNotFoundException {
		Scanner fileReader = new Scanner(new File("D-small.in"));
		PrintStream fileWriter = new PrintStream(new File("D-small.out"));
		int numberOfTestCases = fileReader.nextInt();
		
		for(int testCase = 1; testCase <= numberOfTestCases; testCase++) {
			Graph map = new Graph();
			map.numOfStartKeys = fileReader.nextInt();
			map.chest = new Node[fileReader.nextInt()];
			map.startKeys = new int[map.numOfStartKeys];
			for(int index = 0; index < map.numOfStartKeys; index++)
				map.startKeys[index] = fileReader.nextInt();
			
			for(int index = 0; index < map.chest.length; index++) {
				map.chest[index] = new Node();
				map.chest[index].keyToOpen = fileReader.nextInt();
				map.chest[index].numOfKeys = fileReader.nextInt();
				map.chest[index].keys = new int[map.chest[index].numOfKeys];
				for(int count = 0; count < map.chest[index].numOfKeys; count++)
					map.chest[index].keys[count] = fileReader.nextInt();
				map.chest[index].isOpen = false;
				
				map.chest[index].isStartingNode = false;
				for(int count = 0; count < map.numOfStartKeys; count++)
					if(map.chest[index].keyToOpen == map.startKeys[count]) {
						map.chest[index].isStartingNode = true;
						break;
					}
			}
			
			for(int index = 0; index < map.chest.length; index++) {
				map.chest[index].numberOfAdjNodes = 0;
				map.chest[index].adjacentNodes = new int[map.chest.length];
				for(int count = 0; count < map.chest[index].numOfKeys; count++) {
					int j;
					for(j = count - 1; j >= 0; j--)
						if(map.chest[index].keys[j] == map.chest[index].keys[count])
							break;
					if(j >= 0)
						continue;
					
					for(int i = 0; i < map.chest.length; i++)
						if(i == index)
							continue;
						else if(map.chest[i].keyToOpen == map.chest[index].keys[count]) {
							map.chest[index].adjacentNodes[map.chest[index].numberOfAdjNodes] = i;
							map.chest[index].numberOfAdjNodes++;
						}
				}
				Arrays.sort(map.chest[index].adjacentNodes, 0, map.chest[index].numberOfAdjNodes);
				//fileWriter.println("Chest #" + (index + 1) + ": " + map.chest[index].toString());
			}
			
			map.sequence = new int[map.chest.length];
			map.process();
			
			fileWriter.print("Case #" + testCase + ": ");
			if(map.isPossible) {
				int index;
				for(index = 0; index < map.chest.length - 1; index++)
					fileWriter.print((map.sequence[index] + 1) + " ");
				fileWriter.println((map.sequence[index] + 1));
			}
			else
				fileWriter.println("IMPOSSIBLE");
		}
		fileReader.close();
		fileWriter.close();

		out.println("output file generated");
		return;
	}
}
class Node {
	public int keyToOpen;
	public boolean isOpen;
	public boolean isStartingNode;
	
	public int numOfKeys;
	public int[] keys;
	
	public int numberOfAdjNodes;
	public int[] adjacentNodes;
	
	public String toString() {
		String str = keyToOpen + ":" + isOpen + ":" + isStartingNode + ":" + numOfKeys + ":";
		for(int index = 0; index < numOfKeys; index++)
			str += (keys[index] + ";");
		str += ":";
		for(int index = 0; index < numberOfAdjNodes; index++)
			str += (adjacentNodes[index] + ",");
		
		return str;
	}
}
class Graph {
	public Node[] chest;
	public int[] sequence;
	public int numOfStartKeys;
	public int[] startKeys;
	public boolean isPossible = false;
	
	public void process() {
		int numOfChestClosed;
		int seqCount = 0;
		int prevSeqCount = 0;
		int keys = numOfStartKeys;

		for(int index = 0; index < chest.length; index++) {
				if(chest[index].isStartingNode) {
					prevSeqCount = seqCount;
					sequence[seqCount++] = index;
					chest[index].isOpen = true;
					keys--;
					
					int temp = seqCount - 1;
					do {
						numOfChestClosed = 0;
						for(int i = 0; i < chest.length; i++)
							if(chest[i].isOpen == false)
								numOfChestClosed++;
						
						for(int count = 0; count < chest[sequence[temp]].numberOfAdjNodes; count++) {
							if(notInSequence(chest[sequence[temp]].adjacentNodes[count], seqCount)) {
								sequence[seqCount++] = chest[sequence[temp]].adjacentNodes[count];
								chest[chest[sequence[temp]].adjacentNodes[count]].isOpen = true;
							}
						}
						temp++;
						
						for(int i = 0; i < chest.length; i++)
							if(chest[i].isOpen == false)
								numOfChestClosed--;
						
						if(numOfChestClosed == 0 && temp >= seqCount)
							break;
					}while(seqCount < chest.length);
					
					if(seqCount == chest.length) {
						isPossible = true;
						return;
					}
					if(keys == 0 && sameKeyToOpen(index)) {
						for(int i = seqCount - 1; i >= prevSeqCount; i--)
							chest[sequence[i]].isOpen = false;
						
						keys++;
						seqCount = prevSeqCount;

						continue;
					}
					else if(keys > 0)
						continue;
					
					for(int i = 0; i < chest.length; i++)
						chest[i].isOpen = false;
					seqCount = 0;
				}
		}
		
		return;
	}
	private boolean sameKeyToOpen(int number) {
		for(int index = number + 1; index < chest.length; index++)
			if(chest[number].keyToOpen == chest[index].keyToOpen)
				return true;
		
		return false;
	}
	
	private boolean notInSequence(int number, int limit) {
		for(int index = 0; index < limit; index++)
			if(sequence[index] == number)
				return false;
		
		return true;
	}
}