import java.util.Scanner;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import static java.lang.System.out;

public class TicTacToe  {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws FileNotFoundException {
		Scanner fileReader = new Scanner(new File("A-large.in"));
		PrintStream fileWriter = new PrintStream(new File("A-large.out"));
		int numberOfTestCases = Integer.parseInt(fileReader.nextLine());
		int matrix[][] = new int[4][4];
		
		for(int testCase = 1; testCase <= numberOfTestCases; testCase++) {
			for(int count = 0; count < 4; count++) {
				String row = fileReader.nextLine();
				for(int index = 0; index < 4; index++)
					switch(row.charAt(index)) {
					case 'X' : matrix[count][index] = 1;
					break;
					case 'O' : matrix[count][index] = 2;
					break;
					case 'T' : matrix[count][index] = 0;
					break;
					default: matrix[count][index] = 3;
					}
			}
			fileWriter.print("Case #" + testCase + ": ");
			switch(gameStatus(matrix)) {
			case 1:
				fileWriter.println("X won");
				break;
			case 2:
				fileWriter.println("O won");
				break;
			case 0:
				fileWriter.println("Draw");
				break;
			default: fileWriter.println("Game has not completed");
			}
			fileReader.nextLine();
		}
		fileReader.close();
		fileWriter.close();

		out.println("output file generated");
		return;
	}
	private static int gameStatus(int[][] matrix) {
		int i, j;
		
		for(i = 0; i < 4; i++){
			for(j = 0; j < 4; j++)
				if(matrix[i][j] >= 2 )
					break;
			if(j == 4)
				return 1;
		}
		for(i = 0; i < 4; i++) {
			for(j = 0; j < 4; j++)
				if(matrix[j][i] >= 2)
					break;
			if(j == 4)
				return 1;
		}
		if((matrix[0][0] < 2 && matrix[1][1] < 2 && matrix[2][2] < 2 && matrix[3][3] < 2) ||
				(matrix[0][3] < 2 && matrix[1][2] < 2 && matrix[2][1] < 2 && matrix[3][0] < 2))
			return 1;
		
		for(i = 0; i < 4; i++){
			for(j = 0; j < 4; j++)
				if(matrix[i][j] == 1 || matrix[i][j] == 3)
					break;
			if(j == 4)
				return 2;
		}
		for(i = 0; i < 4; i++) {
			for(j = 0; j < 4; j++)
				if(matrix[j][i] == 1 || matrix[j][i] == 3)
					break;
			if(j == 4)
				return 2;
		}
		if(((matrix[0][0] == 2 || matrix[0][0] == 0) && (matrix[1][1] == 2 || matrix[1][1] == 0) && 
				(matrix[2][2] == 2 || matrix[2][2] == 0) && (matrix[3][3] == 2 || matrix[3][3] == 0)) 
				||
				((matrix[0][3] == 2 || matrix[0][3] == 0) && (matrix[1][2] == 2 || matrix[1][2] == 0) && 
						(matrix[2][1] == 2 || matrix[2][1] == 0) && (matrix[3][0] == 2 || matrix[3][0] == 0))
						)
			return 2;
		
		for(i = 0; i < 4; i++)
			for(j = 0; j < 4; j++)
				if(matrix[j][i] == 3)
					return 3;
		
		return 0;
	}
}