import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;

public class C {

	static double[][] v;
	static double[] d;
	static double[] s;
	static double[] dp;
	static int n;

	static void floyd() {
		for(int k = 0; k < n; k++) {
			for(int i = 0; i < n; i++) {
				for(int j = 0; j < n; j++) {
					v[i][j] = Math.min(v[i][j], v[i][k] + v[k][j]);
				}
			}
		}
	}
	static double solve(int i) {
		if (i == n - 1)
			return 0;
		if (dp[i] != -1)
			return dp[i];
		double res = Double.MAX_VALUE;
		for (int j = i + 1; j < n; j++) {
			if (v[i][j] > d[i])
				continue;
			res = Math.min(res, (v[i][j] / s[i]) + solve(j));
		}
		return dp[i] = res;
	}

	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new FileReader("C-small-attempt1.in"));
		out = new PrintWriter("c_small_1.out");
		sc = new StringTokenizer("");
		int tc = nxtInt();
		for (int t = 1; t <= tc; t++) {
			n = nxtInt();
			int q = nxtInt();
			d = new double[n];
			s = new double[n];
			v = new double[n][n];
			for (int i = 0; i < n; i++) {
				d[i] = nxtDbl();
				s[i] = nxtDbl();
			}
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					v[i][j] = nxtDbl();
					if (v[i][j] == -1)
						v[i][j] = 100000000000000000L;
				}
			}
			floyd();
			dp = new double[n];
			Arrays.fill(dp, -1);
			while(q-- > 0) {
				int u = nxtInt() - 1;
				int v = nxtInt() - 1;
			}
			out.println("Case #" + t + ": " + solve(0));
		}
		br.close();
		out.close();
	}

	static BufferedReader br;
	static StringTokenizer sc;
	static PrintWriter out;

	static String nxtTok() throws IOException {
		while (!sc.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null)
				return null;
			sc = new StringTokenizer(s.trim());
		}
		return sc.nextToken();
	}

	static int nxtInt() throws IOException {
		return Integer.parseInt(nxtTok());
	}

	static long nxtLng() throws IOException {
		return Long.parseLong(nxtTok());
	}

	static double nxtDbl() throws IOException {
		return Double.parseDouble(nxtTok());
	}

	static int[] nxtIntArr(int n) throws IOException {
		int[] a = new int[n];
		for (int i = 0; i < n; i++)
			a[i] = nxtInt();
		return a;
	}

	static long[] nxtLngArr(int n) throws IOException {
		long[] a = new long[n];
		for (int i = 0; i < n; i++)
			a[i] = nxtLng();
		return a;
	}

	static char[] nxtCharArr() throws IOException {
		return nxtTok().toCharArray();
	}
}
