import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;

public class A {

	public static class PanCake implements Comparable<PanCake> {
		long r, h;

		PanCake(long r, long h) {
			this.r = r;
			this.h = h;
		}

		@Override
		public int compareTo(PanCake o) {
			if (this.r > o.r)
				return -1;
			if (this.r < o.r)
				return 1;
			return 0;
		}
	}

	static long[][] dp;
	static int n, k;
	static PanCake[] arr;

	static long solve(int i, int j) {
		if (i == n || j == k)
			return 0;
		if (dp[i][j] != -1)
			return dp[i][j];
		long res = Math.max(solve(i + 1, j),
			(j == 0? (arr[i].r * arr[i].r) : (0)) + (2L * arr[i].r * arr[i].h) + solve(i + 1, j + 1));
		return dp[i][j] = res;
	}

	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new FileReader("A-large.in"));
		out = new PrintWriter("A-large.out");
		sc = new StringTokenizer("");
		int tc = nxtInt();
		for (int t = 1; t <= tc; t++) {
			n = nxtInt();
			k = nxtInt();
			dp = new long[n][k];
			for(long[] a : dp)
				Arrays.fill(a, -1);
			arr = new PanCake[n];
			for (int i = 0; i < n; i++)
				arr[i] = new PanCake(nxtLng(), nxtLng());
			Arrays.sort(arr);
			double res = solve(0, 0);
			out.println("Case #" + t + ": " + res * Math.PI);
		}
		br.close();
		out.close();
	}

	static BufferedReader br;
	static StringTokenizer sc;
	static PrintWriter out;

	static String nxtTok() throws IOException {
		while (!sc.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null)
				return null;
			sc = new StringTokenizer(s.trim());
		}
		return sc.nextToken();
	}

	static int nxtInt() throws IOException {
		return Integer.parseInt(nxtTok());
	}

	static long nxtLng() throws IOException {
		return Long.parseLong(nxtTok());
	}

	static double nxtDbl() throws IOException {
		return Double.parseDouble(nxtTok());
	}

	static int[] nxtIntArr(int n) throws IOException {
		int[] a = new int[n];
		for (int i = 0; i < n; i++)
			a[i] = nxtInt();
		return a;
	}

	static long[] nxtLngArr(int n) throws IOException {
		long[] a = new long[n];
		for (int i = 0; i < n; i++)
			a[i] = nxtLng();
		return a;
	}

	static char[] nxtCharArr() throws IOException {
		return nxtTok().toCharArray();
	}
}
