import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.Queue;
import java.util.StringTokenizer;

public class B {

    static BufferedReader br;
    static PrintWriter out;
    static StringTokenizer sc;

    static int lastIndexOfPlus(char[] c) {
        for (int i = c.length - 1; i > -1; i--)
            if (c[i] == '-')
                return i + 1;
        return -1;
    }

    static char[] flip(char[] c, int lp) {
        char[] nc = Arrays.copyOf(c, c.length);
        if (nc[0] == '+') {
            int i = 0;
            while (nc[i] == '+')
                nc[i++] = '-';
            return nc;
        }
        for (int j = 0; j < lp; j++)
            nc[j] = c[lp - j - 1] == '+' ? '-' : '+';
        return nc;
    }

    static int getMask(char[] c) {
        int mask = 0;
        for (int i = 0; i < c.length; i++)
            mask |= c[i] == '+' ? (1 << i) : 0;
        return mask;
    }

    static char[] dontGetMask(int mask, int len) {
        char[] c = new char[len];
        for (int i = 0; i < c.length; i++)
            c[i] = (mask & (1 << i)) == 0 ? '-' : '+';
        return c;
    }

    static int move(char[] c, int i) {
        char[] nc = Arrays.copyOf(c, c.length);
        for (int j = 0; j < i; j++)
            nc[j] = c[i - j - 1] == '+' ? '-' : '+';
        return getMask(nc);
    }

    static int naive(char[] c) {
        Queue<Integer> q = new LinkedList<>();
        int[] dist = new int[1 << c.length];
        int mask = getMask(c);
        Arrays.fill(dist, -1);
        q.add(mask);
        dist[mask] = 0;
        while (!q.isEmpty()) {
            mask = q.poll();
            c = dontGetMask(mask, c.length);
            for (int i = 1; i <= c.length; i++) {
                int newMask = move(c, i);
                if (dist[newMask] == -1) {
                    dist[newMask] = dist[mask] + 1;
                    q.add(newMask);
                }
            }
        }
        return dist[(1 << c.length) - 1];
    }

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new FileReader(new File("B.in")));
        out = new PrintWriter("B.out");
        sc = new StringTokenizer("");
        int tc = nxtInt();
        for (int i = 1; i <= tc; i++) {
            out.print("Case #" + i + ": ");
            char[] c = nxtTok().toCharArray();
            int steps = 0, lp;
            while ((lp = lastIndexOfPlus(c)) != -1) {
                c = flip(c, lp);
                steps++;
            }
            out.println(steps);
        }
        br.close();
        out.close();
    }

    static String nxtTok() throws IOException {
        while (!sc.hasMoreTokens()) {
            String s = br.readLine();
            if (s == null)
                return null;
            sc = new StringTokenizer(s.trim());
        }
        return sc.nextToken();
    }

    static int nxtInt() throws NumberFormatException, IOException {
        return Integer.parseInt(nxtTok());
    }

}