import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.Queue;
import java.util.StringTokenizer;

public class C {

	static ArrayList<Integer>[] adj;
	static int[] dx = { 0, 0, 1, -1 };
	static int[] dy = { 1, -1, 0, 0 };
	static boolean[] vis;
	static int n, m;

	static int bfs(int st) {
		Queue<Integer> q = new LinkedList<>();
		q.add(st);
		int[] par = new int[adj.length];
		Arrays.fill(par, -1);
		par[st] = -2;
		while (!q.isEmpty()) {
			int t = q.poll();
			int y = t % m;
			if (y == m - 1) {
				int curr = t;
				while (par[curr] != -2) {
					vis[curr] = true;
					curr = par[curr];
				}
				return 1;
			}
			for (int i = 0; i < adj[t].size(); i++) {
				int u = adj[t].get(i);
				if (par[u] == -1 && !vis[u]) {
					q.add(u);
					par[u] = t;
				}
			}
		}
		return 0;
	}

	@SuppressWarnings("unchecked")
	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new FileReader("C.in"));
		out = new PrintWriter("C.out");
		sc = new StringTokenizer("");
		int tc = nxtInt();
		for (int t = 1; t <= tc; t++) {
			m = nxtInt();
			n = nxtInt();
			int b = nxtInt();
			boolean[][] v = new boolean[n][m];
			for (int i = 0; i < b; i++) {
				int y1 = nxtInt();
				int x1 = n - nxtInt() - 1;
				int y2 = nxtInt();
				int x2 = n - nxtInt() - 1;
				for (int j = x2; j <= x1; j++)
					for (int j2 = y1; j2 <= y2; j2++)
						v[j][j2] = true;
			}
			adj = new ArrayList[n * m + 10];
			vis = new boolean[n * m + 10];
			for (int i = 0; i < adj.length; i++)
				adj[i] = new ArrayList<>();
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					if (v[i][j])
						continue;
					int from = i * m + j;
					for (int k = 0; k < 4; k++) {
						int ni = i + dx[k];
						int nj = j + dy[k];
						if (ni > -1 && ni < n && nj > -1 && nj < m) {
							if (v[ni][nj])
								continue;
							int to = ni * m + nj;
							adj[from].add(to);
						}
					}
				}
			}
			int cnt = 0;
			for (int i = 0; i < n; i++)
				if (!v[i][0])
					cnt += bfs(i * m);
			System.out.println("Case #" + t + ": " + cnt);
			out.println("Case #" + t + ": " + cnt);
		}
		br.close();
		out.close();
	}

	static BufferedReader br;
	static StringTokenizer sc;
	static PrintWriter out;

	static String nxtTok() throws IOException {
		while (!sc.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null)
				return null;
			sc = new StringTokenizer(s.trim());
		}
		return sc.nextToken();
	}

	static int nxtInt() throws IOException {
		return Integer.parseInt(nxtTok());
	}

	static long nxtLng() throws IOException {
		return Long.parseLong(nxtTok());
	}

	static double nxtDbl() throws IOException {
		return Double.parseDouble(nxtTok());
	}

	static int[] nxtIntArr(int n) throws IOException {
		int[] a = new int[n];
		for (int i = 0; i < n; i++)
			a[i] = nxtInt();
		return a;
	}

	static long[] nxtLngArr(int n) throws IOException {
		long[] a = new long[n];
		for (int i = 0; i < n; i++)
			a[i] = nxtLng();
		return a;
	}

	static char[] nxtCharArr() throws IOException {
		return nxtTok().toCharArray();
	}
}