import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class B {

	static double solve(double c, double f, double x, int n) {
		if (n == -1)
			return Double.MAX_VALUE;
		double tot = 2.0;
		double ans = 0;
		for (int i = 0; i < n; i++) {
			ans += c / tot;
			tot += f;
		}
		ans += x / tot;
		return ans;
	}

	static int cmp(double a, double b) {
		double eps = 1e-8;
		if (Math.abs(a - b) <= eps)
			return 0;
		if (a - b > eps)
			return 1;
		return -1;
	}

	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new FileReader("B-large.in"));
		out = new PrintWriter("B.out");
		sc = new StringTokenizer("");
		int tc = nxtInt();
		for (int t = 1; t <= tc; t++) {
			double c = nxtDbl();
			double f = nxtDbl();
			double x = nxtDbl();
			int lo = 0;
			int hi = 1000000;
			while (lo < hi) {
				int mid = (lo + hi) / 2;
				double i = solve(c, f, x, mid);
				double im1 = solve(c, f, x, mid - 1);
				double ip1 = solve(c, f, x, mid + 1);
				if (cmp(i, im1) <= 0 && cmp(i, ip1) <= 0) {
					lo = hi = mid;
				} else if (cmp(i, im1) <= 0 && cmp(i, ip1) >= 0) {
					lo = mid + 1;
				} else
					hi = mid;
			}
			out.printf("Case #%d: %.7f\n", t, solve(c, f, x, lo));
			System.out.printf("Case #%d: %.7f\n", t, solve(c, f, x, lo));
		}
		br.close();
		out.close();
	}

	static BufferedReader br;
	static StringTokenizer sc;
	static PrintWriter out;

	static String nxtTok() throws IOException {
		while (!sc.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null)
				return null;
			sc = new StringTokenizer(s.trim());
		}
		return sc.nextToken();
	}

	static int nxtInt() throws IOException {
		return Integer.parseInt(nxtTok());
	}

	static long nxtLng() throws IOException {
		return Long.parseLong(nxtTok());
	}

	static double nxtDbl() throws IOException {
		return Double.parseDouble(nxtTok());
	}

	static int[] nxtIntArr(int n) throws IOException {
		int[] a = new int[n];
		for (int i = 0; i < n; i++)
			a[i] = nxtInt();
		return a;
	}

	static long[] nxtLngArr(int n) throws IOException {
		long[] a = new long[n];
		for (int i = 0; i < n; i++)
			a[i] = nxtLng();
		return a;
	}

	static char[] nxtCharArr() throws IOException {
		return nxtTok().toCharArray();
	}
}