import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class C {

	static int[][] table = { { 0, 0, 0, 0, 0 }, { 0, 1, 2, 3, 4 },
			{ 0, 2, -1, 4, -3 }, { 0, 3, -4, -1, 2 }, { 0, 4, 3, -2, -1 } };

	static int mul(int x, int y) {
		int cnt = 0;
		if (x < 0) {
			cnt++;
			x *= -1;
		}
		if (y < 0) {
			cnt++;
			y *= -1;
		}
		return table[x][y] * (cnt % 2 == 0 ? 1 : -1);
	}

	static int div(int x, int res) {
		if (x > 0) {
			for (int i = 0; i < 5; i++) {
				if (table[x][i] == res)
					return i;
				else if (-table[x][i] == res)
					return -i;
			}
		}
		x *= -1;
		for (int i = 0; i < 5; i++) {
			if (table[x][i] == res)
				return -i;
			else if (-table[x][i] == res)
				return i;
		}
		return 0;
	}

	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new FileReader("C.in"));
		out = new PrintWriter("C.out");
		sc = new StringTokenizer("");
		int tc = nxtInt();
		for (int t = 1; t <= tc; t++) {
			int l = nxtInt();
			long x = nxtLng();
			char[] ch = nxtCharArr();
			int[] arr = new int[(int) (x <= 8 ? x * l : 4 * l)];
			arr[0] = ch[0] - 'i' + 2;
			for (int i = 1; i < arr.length; i++)
				arr[i] = mul(arr[i - 1], ch[i % l] - 'i' + 2);
			ArrayList<Integer> eyes = new ArrayList<>();
			for (int i = 0; i < arr.length; i++) {
				if (arr[i] == 2)
					eyes.add(i);
			}
			ArrayList<Integer> kaiz = new ArrayList<>();
			for (int i = arr.length - 1; i > 0; i--) {
				if (div(arr[i - 1], arr[arr.length - 1]) == 4)
					kaiz.add(i);
			}
			if (arr[arr.length - 1] == 4)
				kaiz.add(0);
			boolean done = false;
			if (x <= 8) {
				for (Integer i : eyes) {
					for (Integer k : kaiz) {
						if (i >= k)
							continue;
						done |= div(arr[i], arr[k - 1]) == 3;
					}
				}
			} else {
				for (Integer i : eyes) {
					for (Integer k : kaiz) {
						long remx = x - 8;
						int rem = remx % 2 == 0 ? 1 : arr[l - 1];
						if (remx % 4 > 1)
							rem *= -1;
						if (Math.abs(arr[l - 1]) == 1)
							rem = remx % 2 == 0 ? 1 : -1;
						done |= mul(mul(div(arr[i], arr[arr.length - 1]), rem),
								k == 0 ? 1 : arr[k - 1]) == 3;
						if (done)
							break;
					}
					if (done)
						break;
				}
			}
			System.out.println("Case #" + t + ": " + (done ? "YES" : "NO"));
			out.println("Case #" + t + ": " + (done ? "YES" : "NO"));
			// int[] naive = new int[(int) (x * l)];
			// naive[0] = ch[0] - 'i' + 2;
			// for (int i = 1; i < naive.length; i++)
			// naive[i] = mul(naive[i - 1], ch[i % l] - 'i' + 2);
			// eyes = new ArrayList<>();
			// for (int i = 0; i < naive.length; i++) {
			// if (naive[i] == 2)
			// eyes.add(i);
			// }
			// kaiz = new ArrayList<>();
			// for (int i = naive.length - 1; i > 0; i--) {
			// if (div(naive[i - 1], naive[naive.length - 1]) == 4)
			// kaiz.add(i);
			// }
			// if (naive[naive.length - 1] == 4)
			// kaiz.add(0);
			// boolean done2 = false;
			// for (Integer i : eyes) {
			// for (Integer k : kaiz) {
			// if (i >= k)
			// continue;
			// done2 |= div(naive[i], naive[k - 1]) == 3;
			// if (done2)
			// break;
			// }
			// if (done2)
			// break;
			// }
			// if (done2 != done)
			// System.out.println(t / 0);
		}
		br.close();
		out.close();
	}

	static BufferedReader br;
	static StringTokenizer sc;
	static PrintWriter out;

	static String nxtTok() throws IOException {
		while (!sc.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null)
				return null;
			sc = new StringTokenizer(s.trim());
		}
		return sc.nextToken();
	}

	static int nxtInt() throws IOException {
		return Integer.parseInt(nxtTok());
	}

	static long nxtLng() throws IOException {
		return Long.parseLong(nxtTok());
	}

	static double nxtDbl() throws IOException {
		return Double.parseDouble(nxtTok());
	}

	static int[] nxtIntArr(int n) throws IOException {
		int[] a = new int[n];
		for (int i = 0; i < n; i++)
			a[i] = nxtInt();
		return a;
	}

	static long[] nxtLngArr(int n) throws IOException {
		long[] a = new long[n];
		for (int i = 0; i < n; i++)
			a[i] = nxtLng();
		return a;
	}

	static char[] nxtCharArr() throws IOException {
		return nxtTok().toCharArray();
	}
}