import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

public class Main {

	private void printToFile(String s) {
		try {
			FileWriter fw = new FileWriter("Output.txt");
			fw.write(s);
			fw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private void flipPancakes(int nbr, int startPos, ArrayList<Integer> pancakes) {
		for (int i = startPos; i < startPos + nbr; i++) {
			pancakes.set(i, pancakes.get(i) * -1);
		}
	}

	private int execute(String s) {
		int nbrFlips = 0;
		String temp = s.substring(s.indexOf(" ") + 1);
		int nbr = Integer.parseInt(temp);
		temp = s.substring(0, s.indexOf(" "));
		ArrayList<Integer> tempList = new ArrayList<Integer>();
		for (char c : temp.toCharArray()) {
			if (c == '+')
				tempList.add(1);
			else
				tempList.add(-1);
		}
		for (int i = 0; i < tempList.size(); i++) {
			if (tempList.get(i) == -1) {
				if (i + nbr > tempList.size()) {
					return -1;
				}
				flipPancakes(nbr, i, tempList);
				nbrFlips++;
			}
		}
		return nbrFlips;
	}

	public static void main(String[] args) {

		Main m = new Main();
		StringBuilder sb = new StringBuilder();

		try {
			Scanner sc = new Scanner(new File("A-large.in"));
			int nbrOfTests = Integer.parseInt(sc.nextLine());
			for(int i = 0; i < nbrOfTests; i++) {
				sb.append("Case #" + (i + 1) + ": ");
				String tempString = sc.nextLine();
				int temp = m.execute(tempString);
				if(temp == -1) {
					sb.append("IMPOSSIBLE");
				} else {
					sb.append(temp);
				}
				if(i != nbrOfTests - 1)
					sb.append("\n");
			}
			sc.close();
			m.printToFile(sb.toString());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}