
import java.util.*;
import java.math.*;
import java.io.*;

public class P4 {

	public static ArrayList <BigDecimal> cloneList (ArrayList <BigDecimal> list) {
	    ArrayList <BigDecimal> clone = new ArrayList<BigDecimal>(list.size());
	    
	    for (BigDecimal item: list) clone.add(item);
	    
	    return clone;
	}

	public P4 () throws IOException {
		BufferedReader in = new BufferedReader (new FileReader("D-small-attempt0.in"));
		PrintWriter out = new PrintWriter (new FileWriter("output.out"));
		
		int numCases = Integer.parseInt(in.readLine().trim());

		for (int cases = 1; cases <= numCases; cases++) {
			int blocks = Integer.parseInt(in.readLine().trim());
			StringTokenizer stNaomi = new StringTokenizer(in.readLine().trim());
			StringTokenizer stKen = new StringTokenizer(in.readLine().trim());
			ArrayList <BigDecimal> nArr = new <BigDecimal> ArrayList ();
			ArrayList <BigDecimal> kenArr = new <BigDecimal> ArrayList ();
			for (int i = 0; i < blocks; i++) {
				nArr.add(new BigDecimal(stNaomi.nextToken()));
				kenArr.add(new BigDecimal(stKen.nextToken()));
			}

			out.print("Case #" + cases +": ");
			out.print(new War(new Ken (P4.cloneList(kenArr)), new Naomi(P4.cloneList(nArr), P4.cloneList(kenArr), true), blocks).play());
			out.print(" ");
			out.println(new War(new Ken (kenArr), new Naomi(nArr, kenArr, false), blocks).play());
		}

		out.close();
		in.close();
	}


	public static void main (String [] args) throws IOException {
		new P4 ();
	}

	interface Player {
		public BigDecimal choose ();
		public BigDecimal choose (BigDecimal val);
	}

	class Naomi implements Player {
		ArrayList <BigDecimal> arr, kenArr;
		boolean optimal;

		public Naomi (ArrayList <BigDecimal> arr, ArrayList <BigDecimal> kenArr, boolean optimal) {
			Collections.sort(arr);
			this.arr = arr;

			Collections.sort(kenArr);
			this.kenArr = kenArr;

			this.optimal = optimal;
		}

		public BigDecimal choose (BigDecimal val) {
			return arr.remove(arr.size() - 1);
		}

		public BigDecimal choose () {
			if (optimal) {
				if (kenArr.get(kenArr.size() - 1).compareTo(arr.get(arr.size() - 1)) == 1) {
					arr.remove(0);
					return kenArr.remove(kenArr.size() - 1).subtract(new BigDecimal("0.00000001"));
				}
				else {
					kenArr.remove(kenArr.size() - 1);
					return arr.remove(arr.size() - 1);
				}
			}
			else {
				return arr.remove(0);		
			}
		}
	}

	class Ken implements Player {
		ArrayList <BigDecimal> arr;

		public Ken (ArrayList <BigDecimal> arr) {
			Collections.sort(arr);
			this.arr = arr;
		}

		public BigDecimal choose (BigDecimal val) {
			for (int i = 0, len = arr.size(); i < len; i++) {
				if (arr.get(i).compareTo(val) == 1) 
					return arr.remove(i);
			}
			return arr.remove(arr.size() - 1);
		}

		public BigDecimal choose () {
			return arr.remove(0);
		}
	}

	class War {
		int rounds;
		Player ken, naomi;

		public War (Player ken, Player naomi, int rounds) {
			this.ken = ken;
			this.naomi = naomi;
			this.rounds = rounds;
		}

		public int play () {
			int naomiWins = 0;
			while (rounds != 0) {
				BigDecimal naomiChoice, kenChoice;
				naomiChoice = naomi.choose();
				kenChoice = ken.choose(naomiChoice);
				if (naomiChoice.compareTo(kenChoice) == 1)
					naomiWins++;
				rounds--;
			}
			return naomiWins;
		}
	}
}