
import java.util.*;
import java.math.*;
import java.io.*;

public class P3 {

	public boolean noAdjacentMine (char [][] field, int r, int c) {
		if (c + 1 < field[0].length && field[r][c + 1] == '*')
			return false;
		if (c - 1 >= 0 && field[r][c - 1] == '*')
			return false;
		if (r + 1 < field.length && field[r + 1][c] == '*')
			return false;
		if (r - 1 >= 0 && field[r - 1][c] == '*')
			return false;
		if (c + 1 < field[0].length && r + 1 < field.length && field[r + 1][c + 1] == '*')
			return false;
		if (c + 1 < field[0].length && r - 1 >= 0 && field[r - 1][c + 1] == '*')
			return false;
		if (r + 1 < field.length && c - 1 >= 0 && field[r + 1][c - 1] == '*')
			return false;
		if (r - 1 >= 0 && c - 1 >= 0 && field[r - 1][c - 1] == '*')
			return false;

		return true;
	}

	public char [][] copyArr (char [][] arr) {
		char [][] newArr = new char[arr.length][arr[0].length];
		for (int a = 0, len1 = arr.length; a < len1; a++) {
			for (int b = 0, len2 = arr[0].length; b < len2; b++) {
				newArr[a][b] = arr[a][b];
			}
		}
		return newArr;

	}

	public void propogate (char [][] field, int r, int c) {
		if (r < 0 || r >= field.length || c < 0 || c >= field[0].length || field[r][c] == '*') return;
		
		if (field[r][c] == 'A')
			return;
		else
			field[r][c] = 'A';
		
		if (noAdjacentMine(field, r, c)) {
			propogate(field, r, c + 1);
			propogate(field, r, c - 1);
			propogate(field, r + 1, c + 1);
			propogate(field, r + 1, c - 1);
			propogate(field, r - 1, c + 1);
			propogate(field, r - 1, c - 1);
			propogate(field, r + 1, c);
			propogate(field, r - 1, c);
		}
	}

	public void print (char [][] field) {
		System.out.println("=== Printing Field ===");
		for (int r = 0; r < field.length; r++) {
			for (int c = 0; c < field[0].length; c++) {
				System.out.print(field[r][c] == '*' ? '*' : '.');
			}
			System.out.println();
		}
	}

	public boolean click (char [][] field, int r, int c) {
		propogate(field, r, c);


		for (; r >= 0; r--) {
			for (; c >= 0; c--) {
				if (field[r][c] == '.')
					return false;
			}
		}
		return true;
	}

	public boolean canClick (char [][] field, int r, int c) {
		return field[r][c] != '*';
	}

	public String build (char [][] field, int r, int c) {
		StringBuilder st = new StringBuilder();
		for (int y = 0; y < field.length; y++) {
			for (int x = 0; x < field[0].length; x++) {
				if (y == r && x == c)
					st.append("c");
				else
					st.append((field[y][x] == 'A' || field[y][x] == '.') ? '.' : '*');
			}
			st.append("\n");
		}

		return st.toString();
	}

	public P3 () throws IOException {
		// BufferedReader in = new BufferedReader (new FileReader("practice.in"));
		BufferedReader in = new BufferedReader (new FileReader("C-small-attempt2.in"));
		PrintWriter out = new PrintWriter (new FileWriter("output.out"));

		int numCases = Integer.parseInt(in.readLine().trim());

		for (int cases = 1; cases <= numCases; cases++) {
			StringTokenizer st = new StringTokenizer(in.readLine().trim());
			int row = Integer.parseInt(st.nextToken()), column = Integer.parseInt(st.nextToken()), mines = Integer.parseInt(st.nextToken()), originalMines = mines;
			char [][] field = new char [row][column];
			String temp;
			
			int r = 0, c = 0, total = row * column;
			int direction = 1;
			boolean nowRow = false;
			do {
				if (mines != 0) {
					field[r][c] = '*';
					mines--;
				}
				else {
					field[r][c] = '.';
					// System.out.println(", dot");
				}

				if (nowRow) {
					if (direction == 1) {
						if (r + 1 < field.length && field[r + 1][c] != '*')
							r++;
						else {
							nowRow = false;
							direction = -1;	
							c--;
						}
					}
					else {
						if (r - 1 >= 0 && field[r - 1][c] != '*') {
							r--;
						}
						else {
							nowRow = false;	
							direction = 1;	
							c++;

						}
					}						
				}
				else {
					if (direction == 1) {
						if (c + 1 < field[0].length && field[r][c + 1] != '*') {
							c++;
						}
						else {
							nowRow = true;
							r++;
						}
					}
					else {
						if (c - 1 >= 0 && field[r][c - 1] != '*') {
							c--;
						}
						else {

							nowRow = true;
							r--;
						}
					}
				}
				total--;
			} while (total != 0);

			for (int rr = 0; rr < row; rr++) {
				for (int cc = 0; cc < column; cc++) {
					field[rr][cc] = field[rr][cc] != '*' ? '.':'*';
				}
			}



			System.out.println("Solved Case #" + cases);
			out.println("Case #" + cases +":");
			// print(field);
			if (originalMines == 0 || row == 1 || column == 1) {
				for (int rr = 0; rr < row; rr++) {
					for (int cc = 0; cc < column; cc++) {
						if (originalMines != 0) {
							originalMines--;
							out.print('*');
						}
						else if (rr == row - 1 && cc == column - 1)
							out.print('c');
						else
							out.print('.');
					}
					out.println();
				}
			}
			else {
				ArrayList <Integer> rArr = new ArrayList <Integer> ();
				ArrayList <Integer> cArr = new ArrayList <Integer> ();
				
				for (int rr = 0; rr < row; rr++) {
					for (int cc = 0; cc < column; cc++) {
						if (canClick(field, rr, cc) && noAdjacentMine(field, rr, cc)) {
							rArr.add(rr);
							cArr.add(cc);
						}
					}
				}
				boolean finished = false;
				for (int i = 0, len = rArr.size(); i < len; i++) {
					if (click(copyArr(field), rArr.get(i), cArr.get(i))) {
						out.print(build(field, rArr.get(i), cArr.get(i)));
						finished = true;
						break;
					}
				}
				if (!finished) {
					out.println("Impossible");
				}
			}

		}

		out.close();
		in.close();
	}


	public static void main (String [] args) throws IOException {
		new P3 ();
	}
}