package day1problemC;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;

public class main {
	
	public static String jamCoin;
	public static int[] divisors = new int[9];
	public static boolean foundJamCoin = false;
	
	public static boolean lessThanOrEqualTo(BigInteger a, BigInteger b) {
		if(a.compareTo(b) == -1) return true;
		else if(a.compareTo(b) == 0) return true;
		return false;
	}
	
	public static int getFactor(BigInteger n) {
	    if (n.mod(new BigInteger("2")).equals(BigInteger.ZERO)) return 2;
	    //for(int i=3; lessThanOrEqualTo(new BigInteger(String.valueOf(i*i)), n); i+=2) {
	    for(int i=3; i*i <= 1000000; i+=2) {
	    	if (n.mod(new BigInteger(String.valueOf(i))).equals(BigInteger.ZERO))
	            return i;
	    }
	    return -1;
	}
	
	public static void findJamCoin() {
		while(!foundJamCoin) {
			jamCoin = Long.toBinaryString(Long.valueOf(jamCoin, 2) + 1);
			if((jamCoin.charAt(jamCoin.length()-1)) == '0') jamCoin = jamCoin.substring(0, jamCoin.length()-1) + "1";
			//System.out.println("...........testing jamcoin " + jamCoin);
			boolean possibleJamCoin = true;
			for(int i = 2; i < 11; i++) {
				int divisor = -1;
				if(!(new BigInteger(jamCoin, i)).isProbablePrime(1)) {
					//System.out.println("Base " + i + ": " + new BigInteger(jamCoin, i));
					divisor = getFactor(new BigInteger(jamCoin, i));
					//System.out.println("Divisor: " + divisor);
				}
				if(divisor == -1) {
					possibleJamCoin = false;
					break;
				}
				else divisors[i-2] = divisor;
			}
			if(possibleJamCoin) {
				foundJamCoin = true;
			}
		}
		foundJamCoin = false;
	}

	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader("in.txt"));
			BufferedWriter bw = new BufferedWriter(new FileWriter("out.txt", true));
			PrintWriter out = new PrintWriter(bw);
		    String line = br.readLine();
		    int cases = Integer.parseInt(line);
		    int caseNo = 1;
		    while ((line = br.readLine()) != null) {
		    	int spaceIndex = line.indexOf(" ");
		    	int N = Integer.parseInt(line.substring(0, spaceIndex)); // size of coin
		    	int J = Integer.parseInt(line.substring(spaceIndex+1)); // number of coins
		    	long startBase10 = (long) (Math.pow(2, N-1));
		    	jamCoin = Long.toString(startBase10, 2);
		    	out.println("Case #" + caseNo + ":");
		    	for(int i = 0; i < J; i++) {
		    		findJamCoin();
		    		out.println(jamCoin + " " + 
		    				divisors[0] + " " + 
		    				divisors[1] + " " + 
		    				divisors[2] + " " + 
		    				divisors[3] + " " + 
		    				divisors[4] + " " + 
		    				divisors[5] + " " + 
		    				divisors[6] + " " + 
		    				divisors[7] + " " + 
		    				divisors[8]);
		    		//System.out.println("Found jamcoin: " + jamCoin);
		    	}
		    	caseNo++;
		    }
		    out.close();
		    System.out.println("done");
		} catch(IOException e) {
			System.out.println("nooo");
		}
	}

}
