package judges;

import java.io.File;
import java.io.IOException;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.PriorityQueue;
import java.util.Queue;
import java.util.Scanner;

import commons.FileUtilities;

public class Judges {
    public static void main(String[] args) throws IOException {
        
        List<String> cases = FileUtilities.readFile(new File("A-small-attempt2.in"));
        
        int nrCases = new Scanner(cases.get(0)).nextInt();
        List<String> result = new LinkedList<String>();
        
        for (int i = 1; i <= nrCases; i++) {
            
            Scanner s = new Scanner(cases.get(i));
            
            int N = s.nextInt();
            int amount = 0;
            int maxPoints = 0;
            
            Queue<Pair> q = new PriorityQueue<Pair>();
            for (int j = 0; j < N; j++) {
                int points = s.nextInt();
                amount += points; 
                if (maxPoints < points) {
                    maxPoints = points;
                }
                q.offer(new Pair(points, j));
            }
                        
            double percAmount = 0;
            List<Pair> list = new LinkedList<Pair>();
            while(!q.isEmpty()) {
                Pair p = q.poll();
                if (maxPoints != p.points) {

                    p.minPerc = new Double(maxPoints - p.points) / new Double(amount);
                } else {
                    p.minPerc = 0;
                }
                percAmount += p.minPerc;
                list.add(p);
            }
            double remaining = 1 - percAmount;
            if (remaining > 0) {
                for (Pair p : list) {
                    p.minPerc += remaining / N;
                }
            } else {
                while (remaining + 0.0000001 < 0) {
                    int subAmount = N + 1;
                    int possibAmount = 0;
                    double subtractAmount = Integer.MAX_VALUE;
                    while(subAmount > possibAmount) {
                        possibAmount = 0;
                        subAmount--;
                        
                        for (Pair p : list) {
                            if(p.minPerc > 0) {
                                possibAmount++;
                                double sub = Math.min(p.minPerc, new Double(-remaining) / new Double(subAmount));
                                subtractAmount = Math.min(sub, subtractAmount);
                            } 
                        }
                    }
                    for (Pair p : list) {
                        if (p.minPerc >= subtractAmount) {
                            p.minPerc -= subtractAmount;
                            remaining += subtractAmount;
                        }
                    }
                    if (subAmount == 0) {
                        System.out.println("WTF");
                    }
                }
            }
            
            double[] resPerc = new double[N];
            for (Pair p : list) {
                resPerc[p.position] = p.minPerc;
            }
            StringBuilder r = new StringBuilder();
            for (double d : resPerc) {
                r.append(d);
                r.append(" ");
            }
            r.deleteCharAt(r.length() - 1);
            result.add(r.toString());
        }
        
        FileUtilities.writeFile(result, new File("A-small-attempt2.out"));
    }
    public static class Pair implements Comparable<Pair> {
        public Integer points;
        public int position;
        public double minPerc;
        public Pair(int points, int position) {
            this.points = points; this.position = position;
        }
        @Override
        public int compareTo(Pair o) {
            // TODO Auto-generated method stub
            return -points.compareTo(o.points);
        }
    }
}
