import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;
import java.util.Scanner;
import java.util.Set;

public class pancakes {

	static class State {
		boolean[] p;

		public State(String s) {
			p = new boolean[s.length()];
			char[] sarr = s.toCharArray();
			for (int i = 0; i < s.length(); i++) {
				if (sarr[i] == '+') {
					p[i] = true;
				}
			}
		}

		public State(boolean[] s) {
			p = new boolean[s.length];
			for (int i = 0; i < s.length; i++) {
				if (s[i]) {
					p[i] = true;
				}
			}
		}

		int toInt() {
			int n = 0;
			for (boolean b : p)
				n = (n << 1) | (b ? 1 : 0);
			return n;
		}

		public List<State> out(int k) {
			List<State> ret = new LinkedList<State>();
			for (int i = 0; i <= p.length - k; i++) {
				State s = new State(p);
				for (int j = 0; j < k; j++) {
					s.p[i + j] = !s.p[i + j];
				}
				ret.add(s);
			}

			return ret;
		}

		@Override
		public String toString() {
			StringBuilder ret = new StringBuilder();
			for (int i = 0; i < p.length; i++) {
				ret.append(p[i] ? "+" : "-");
			}
			return ret.toString();
		}
	}

	public static void main(String[] args) throws FileNotFoundException {

		String filename = "A-small-attempt0";
		System.setIn(new FileInputStream(new File(filename + ".in")));
		System.setOut(new PrintStream(new File(filename + ".out")));
		Scanner sc = new Scanner(System.in);

		int t = sc.nextInt();

		for (int c = 1; c <= t; c++) {
			String s = sc.next();
			int k = sc.nextInt();

			State start = new State(s);

			StringBuilder targets = new StringBuilder();
			for (int i = 0; i < s.length(); i++) {
				targets.append("+");
			}
			int target = new State(targets.toString()).toInt();

			Queue<State> reach = new LinkedList<>();
			Set<Integer> visited = new HashSet<>();

			int num = 0;
			reach.add(start);

			int result = -1;

			outer: while (true) {
				Queue<State> news = new LinkedList<>();
				while (!reach.isEmpty()) {
					State st = reach.poll();
					if (st.toInt() == target) {
						result = num;
						break outer;
					}
					for (State out : st.out(k)) {
						if (!visited.contains(out.toInt())) {
							visited.add(out.toInt());
							news.add(out);
						}
					}
				}
				if (!news.isEmpty()) {
					reach = news;
					num++;
				} else {
					break;
				}
			}
			System.out.print("Case #" + c + ": ");
			if (result != -1) {
				System.out.println(result);
			} else {
				System.out.println("IMPOSSIBLE");
			}
		}

	}
}
