package rpi;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

public class Team {
    public HashMap<Integer, Character> wins = new HashMap<Integer, Character>();

    public int id;

    public double getWinPercentageWithout(Integer id) {

        int winsum = 0;
        int gamecount = 0;
        for (Integer k : wins.keySet()) {
            if (!k.equals(id)) {
                if (wins.get(k).equals('1')) {
                    winsum++;
                    gamecount++;
                } else if (wins.get(k).equals('0')) {
                    gamecount++;
                }
            }
        }
        return ((double) winsum) / gamecount;
    }

    public List<Integer> getOpponents() {
        List<Integer> results = new LinkedList<Integer>();

        for (Integer k : wins.keySet()) {
            if (!wins.get(k).equals('.')) {
                results.add(k);
            }
        }
        return results;
    }

    public double getOWP(Map<Integer, Team> teams) {
        double sum = 0;
        List<Integer> li = this.getOpponents();
        for (Integer u : li) {
            sum += teams.get(u).getWinPercentageWithout(this.id);
        }
        return sum / li.size();

    }
}
