package rpi;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

import commons.FileUtilities;

public class RPI {

    public static void main(String[] args) throws IOException {

        Scanner lineScanner = new Scanner(new File("A-large.in"));
        
        List<String> results = new LinkedList<String>();
        
        Integer cases = Integer.parseInt(lineScanner.nextLine());
        
        for (int i = 0; i < cases; i++) {
            
            Integer teamcount = Integer.parseInt(lineScanner.nextLine());
            Map<Integer, Team> teams = new HashMap<Integer, Team>();
            
            for (int team = 0; team < teamcount; team++) {
                Team curTeam = new Team();
                teams.put(team, curTeam);
                curTeam.id = team;
                String matchups = lineScanner.nextLine();
                
                for (int j = 0; j < matchups.toCharArray().length; j++) {
                    curTeam.wins.put(j, matchups.toCharArray()[j]);
                }
            }
            

            String team = "";
            
            for (Integer t : teams.keySet()) {
                
                double winpercent = teams.get(t).getWinPercentageWithout(teams.get(t).id);
                System.out.println(t + "'s wp " + winpercent);
                
                double owp = teams.get(t).getOWP(teams);
                System.out.println(t + "'s owp " + owp);
                
                List<Integer> oppo = teams.get(t).getOpponents();
                
                double oowpsum = 0;
                for(Integer u : oppo) {
                    oowpsum += teams.get(u).getOWP(teams);
                }
                double oowp = oowpsum / oppo.size();
                System.out.println(t + "'s oowp " + oowp);
                
                double rpi = 0.25 * winpercent + 0.5 * owp + 0.25 * oowp;
                
                team += rpi + "\n";
            }
            
            results.add(team);
            
        }
        
        

        FileUtilities.writeFile(results, new File("rpi.out"));
    }

}
