import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;

public class amplebig {
	  static class Pancake implements Comparable<Pancake> {
		  int radius;
		  int height;
		  Pancake(int radius, int height) {
			  this.radius = radius;
			  this.height = height;
		  }
		@Override
		public int compareTo(Pancake arg0) {
			if (arg0.radius != radius) {
				return arg0.radius - radius;
			}
			return arg0.height - height;
		}
		@Override
		public String toString() {
			return "(" + radius + "," + height + ")";
		}
		public BigDecimal top() {
			return new BigDecimal(radius).pow(2).multiply(new BigDecimal(Math.PI));
		}
		public BigDecimal side() {
			return new BigDecimal(2).multiply(new BigDecimal(Math.PI)).multiply(new BigDecimal(radius)).multiply(new BigDecimal(height));
		}
	  }
	public static void main(String[] args) throws FileNotFoundException {
		String filename = "A-large";
		System.setIn(new FileInputStream(new File(filename + ".in")));
		System.setOut(new PrintStream(new File(filename + ".out")));
		Scanner sc = new Scanner(System.in);

		int t = sc.nextInt();
		
		for (int c = 1; c <= t; c++) {
			
			int n = sc.nextInt();
			int k = sc.nextInt();
			ArrayList<Pancake> cakes = new ArrayList<>();
			
			for (int i = 0; i < n; i++) {
				 cakes.add(new Pancake(sc.nextInt(), sc.nextInt()));
			}
			Collections.sort(cakes);
			
			BigDecimal[][] dp = new BigDecimal[n + 1][k + 1];
			for (int i = 0; i <= n; i++) {
				for (int j = 0; j <= k;j++) {
					 dp[i][j] = BigDecimal.ZERO;
				}
			}
			
			// 
			for (int i = 1; i <= n; i++) {
				// start new stack with this one
				dp[i][1] = dp[i - 1][1].max(cakes.get(i - 1).top().add(cakes.get(i - 1).side()));
			}
			
			for (int i = 1; i <= n; i++) {
				for (int j = 2; j <= k; j++) {
					// choose this one
					if (dp[i - 1][j - 1] != BigDecimal.ZERO) {
						dp[i][j] = dp[i][j].max(dp[i - 1][j - 1].add(cakes.get(i  - 1).side()));
					}
					// ignore this one
					dp[i][j] = dp[i][j].max(dp[i - 1][j]);
				}
			}
			
			System.out.println("Case #" + c + ": " + dp[n][k]);
		}
		
	}
}
