package icevend;

import java.io.File;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;
import java.util.PriorityQueue;
import java.util.Scanner;

import commons.FileUtilities;

public class icevend {
    public static void main(String[] args) throws IOException {
        
        Scanner linescanner = new Scanner(new File("B-small-attempt0.in"));
        int cases = Integer.parseInt(linescanner.nextLine());
        List<String> results = new LinkedList<String>();
        
        for (int curCase = 0; curCase < cases; curCase++) {
            
            String pointsAndD = linescanner.nextLine();
            String[] pd = pointsAndD.split("\\s+");
            
            int vendorpoints = Integer.parseInt(pd[0]);
            int d = Integer.parseInt(pd[1]);
            
            PriorityQueue<Vendor> heap = new PriorityQueue<Vendor>();
            
            for (int point = 0; point < vendorpoints; point++) {
                
                String coordAndVCount = linescanner.nextLine();
                String[] cv = coordAndVCount.split("\\s+");
                int coord = Integer.parseInt(cv[0]);
                int vcount = Integer.parseInt(cv[1]);
                
                for (int count = 0; count < vcount; count++) {
                    Vendor v = new Vendor();
                    v.startposition = coord;
                    v.endposition = coord;
                    System.out.println("Vendor at " + v.startposition);
                    heap.add(v);
                }
            }
            
            Vendor first = heap.poll();
            Vendor prevVendor = null;
            Vendor thisVendor = null;
            Vendor nextVendor = first;
            do {
                prevVendor = thisVendor;
                thisVendor = nextVendor;
                nextVendor = heap.poll();
                
                thisVendor.prevVendor = prevVendor;
                thisVendor.nextVendor = nextVendor;
                
            } while(!heap.isEmpty());
            
            
            first.pushRight(d);
            System.out.println("Pushed all");
            
            boolean better = true;
            double mintime = Integer.MAX_VALUE;
            while (better) {
                double time = 0;
                Vendor v = first;
                while(v != null) {
                    if (v.getWayTime() > time) {
                        time = v.getWayTime();
                    }
                    v = v.nextVendor;
                }
                
                if (time < mintime) {
                    mintime = time;
                    System.out.println("Found new mintime " + time);
                    Vendor v1 = first;
                    while(v1 != null) {
                        System.out.println("should move from " + v1.startposition + " to " + v1.endposition);
                        v1.endposition -= 0.5;
                        v1 = v1.nextVendor;
                    }
                } else {
                    better = false;
                }
            }
            
            results.add("" + mintime);
        }

        FileUtilities.writeFile(results, new File("vendor.out"));
    }
}
