
import java.util.Scanner;

public class CoinJam {

    static int[] primes = {3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439, 443, 449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541, 547, 557, 563, 569, 571, 577, 587, 593, 599, 601, 607, 613, 617, 619, 631, 641, 643, 647, 653, 659, 661, 673, 677, 683, 691, 701, 709, 719, 727, 733, 739, 743, 751, 757, 761, 769, 773, 787, 797, 809, 811, 821, 823, 827, 829, 839, 853, 857, 859, 863, 877, 881, 883, 887, 907, 911, 919, 929, 937, 941, 947, 953, 967, 971, 977, 983, 991, 997};

    static long convert(long x, int base) {
        long result = 0;
        int i = 0;
        while (x > 0) {
            if (x % 2 == 1) {
                result += Math.pow(base, i);
            }
            x /= 2;
            i++;
        }
        return result;
    }
    
    static int primeFactor(long x) {
        for (int p : primes) {
            if (p >= x) {
                return -1;
            }
            if (x % p == 0) {
                return p;
            }
        }
        return -1;
    }
    
    static String binary(long x) {
        String result = "";
        while (x > 0) {
            result = (x % 2) + result;
            x /= 2;
        }
        return result;        
    }

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);
        s.nextInt();
        int n = s.nextInt();
        int j = s.nextInt();
        System.out.println("Case #1:");
        int i = 0;
        long x = (long) Math.pow(2, n - 1) + 1;
        long max = (long) Math.pow(2, n);
        while (i < j) {            
            if (x >= max) {   
                System.out.println("FAIL!");
            }
            int[] pf = new int[9];
            boolean valid = true;
            for (int k = 2; k <= 10; k++) {
                long y = x;
                if (k != 2) {
                    y = convert(x, k);
                }
                pf[k - 2] = primeFactor(y);
                if (pf[k - 2] == -1) {
                    valid = false;
                    break;
                }
            }
            if (valid) {
                System.out.print(binary(x));
                for (int k = 0; k < 9; k++) {
                    System.out.print(" " + pf[k]);
                }
                System.out.println();
                i++;
            }
            x += 2;
        }

    }

}
