package com.google.codejam;

import java.awt.Point;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class Enc {
	
	private BufferedReader in;
	private BufferedWriter out;
	private int n;
	private int x, y, k;
	private boolean [][] field;
	private boolean [][] swpField;
	
	public static void main(String [] args){
		new Enc(new File(args[0]), new File(args[1])).doIt();
	}
	
	public Enc(File in, File out){
		try {
			this.in = new BufferedReader(new FileReader(in));
			this.out = new BufferedWriter(new FileWriter(out));
			n = Integer.parseInt(this.in.readLine());
		} catch (Exception e){
			e.printStackTrace();
		}
	}
	
	public void doIt(){
		try {
			StringBuilder sb = new StringBuilder();
			String res;
			
			for (int i = 0; i < n; i++){
				System.out.println(i);
				sb.append("Case #")
				.append((i + 1))
				.append(": ")
				.append(compute())
				.append(((i + 1 == n) ? "" : "\n"));
			}
			
			res = sb.toString();
			System.out.println(res);
			out.write(res);
		} catch (Exception e){
			e.printStackTrace();
		} finally {
			try { in.close(); } catch (Exception e) {}
			try { out.close(); } catch (Exception e) {}
		}
	}
	
	private void readLine() throws IOException{
		String [] swp = in.readLine().split(" ");
		x = Integer.parseInt(swp[0]);
		y = Integer.parseInt(swp[1]);
		k = Integer.parseInt(swp[2]);
	}
	
	private void createField(){
		field = new boolean[x][y];
		swpField = new boolean[x][y];
	}
	
	private void set(Point a){
		field[a.x][a.y] = true;
		swpField[a.x][a.y] = true;
	}
	
	private void unset(Point a){
		field[a.x][a.y] = false;
	}
	
	private boolean isCorner(Point a){
		return a.x == 0 || a.y == 0 || a.x + 1 == x || a.y + 1 == y;
	}
	
	private boolean isSettable(Point a){
		return a.x >= 0 && a.x < x && a.y >= 0 && a.y < y && !field[a.x][a.y];
	}
	
	private boolean isSurrounded(Point a){
		return 
			!isCorner(a) &&
			swpField[a.x - 1][a.y] && 
			swpField[a.x + 1][a.y] &&
			swpField[a.x][a.y - 1] &&
			swpField[a.x][a.y + 1];
	}
	
	private void markStones(){
		int alreadyPut = 0;
		List<Point> list = new ArrayList<Point>();
		list.add(new Point(1, 1));
		Point swp;
		
		while (alreadyPut != k){
			if (list.size() == 0){
				markCorner(k - alreadyPut);
				alreadyPut = k;
			} else {
				swp = list.remove(0);
				if (!isCorner(swp) && !field[swp.x][swp.y]) {
					list.add(new Point(swp.x - 1, swp.y));
					list.add(new Point(swp.x, swp.y - 1));
					list.add(new Point(swp.x + 1, swp.y));
					list.add(new Point(swp.x, swp.y + 1));
				}
				if (isSettable(swp)){
					set(swp);
					alreadyPut++;
				}
			}
		}
	}
	
	private void markCorner(int n){
		switch (n){
		case 0: break;
		case 1: set(new Point(0, 0)); break;
		case 2: set(new Point(0, 0)); set(new Point(0, y - 1)); break;
		case 3: set(new Point(0, 0)); set(new Point(0, y - 1)); set(new Point(x - 1, 0)); break;
		case 4: set(new Point(0, 0)); set(new Point(0, y - 1)); set(new Point(x - 1, 0)); set(new Point(x - 1, y - 1)); break;
		}
	}
	
	private void removeStones(){
		for (int i = 0; i < x; i++){
			for (int j = 0; j < y; j++){
				Point pos = new Point(i, j);
				if (field[pos.x][pos.y] && isSurrounded(pos)){
					unset(pos);
				}
			}
		}
	}
	
	private int countStones(){
		int ret = 0;
		for (int i = 0; i < x; i++)
			for (int j = 0; j < y; j++)
				if (field[i][j])
					ret++;
		return ret;
	}
	
	private void printField(){
		for (int i = 0; i < x; i++) {
			for (int j = 0; j < y; j++) {
				System.out.print(((field[i][j])?"o":"."));
			}
			System.out.println();
		}
	}
	
	private String compute() throws IOException{
		readLine();
		
		if (x <= 2 || y <= 2 || k <= 4) return k + "";
		
		createField();
		markStones();
		removeStones();
		printField();
		System.out.println("---");
		
		return countStones() + "";
	}

}
