package com.google.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Lottery {
	
	private BufferedReader in;
	private BufferedWriter out;
	private int a,b,k;
	
	public static void main(String [] args){
		new Lottery(new File(args[0]), new File(args[1])).doIt();
	}
	
	private Lottery(File inFile, File outFile){
		try {
			in = new BufferedReader(new FileReader(inFile));
			out = new BufferedWriter(new FileWriter(outFile));
		} catch (Exception e){
			e.printStackTrace();
		}
	}
	
	private void doIt(){
		try {
			int n = Integer.parseInt(in.readLine());
			StringBuilder sb = new StringBuilder();
			for (int i = 0; i < n; i++){
				sb.append("Case #")
				.append(i + 1)
				.append(": ")
				.append(compute())
				.append((i + 1 == n)?"":"\n");
			}
			String ret = sb.toString();
			System.out.println(ret);
			out.write(ret);
			in.close();
			out.close();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	private void read(){
		try {
			String l = in.readLine();
			if (l.trim().length() == 0){
				a = 0; b = 0; k = 0;
			}
			String [] line = l.split(" ");
			a = Integer.parseInt(line[0]);
			b = Integer.parseInt(line[1]);
			k = Integer.parseInt(line[2]);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private String compute(){
		read();
		int res = 0;
		for (int i = 0; i < a; i++){
			for (int j = 0; j < b; j++){
				if ((i & j) < k){
					res++;
				}
			}
		}
		return "" + res;
	}

}
