package com.google.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class Magician {
	
	private static final int SIZE = 4;
	
	private String [][] firstArrangement = new String[SIZE][SIZE];
	private String [][] secondArrangement = new String[SIZE][SIZE];
	private BufferedReader in;
	private BufferedWriter out;
	private int firstAnswer = -1;
	private int secondAnswer = -1;
	
	public static void main(String [] args){
		new Magician().doIt(new File(args[0]), new File(args[1]));
	}
	
	public void doIt(File inFile, File outFile){
		try {
			in = new BufferedReader(new FileReader(inFile));
			out = new BufferedWriter(new FileWriter(outFile));
			StringBuilder sb = new StringBuilder();
			
			int n = Integer.parseInt(in.readLine());
			
			for (int i = 0; i < n; i++){
				firstAnswer = Integer.parseInt(in.readLine()) - 1;
				for (int j = 0; j < SIZE; j++){
					firstArrangement[j] = in.readLine().split(" ");
				}
				secondAnswer = Integer.parseInt(in.readLine()) - 1;
				for (int j = 0; j < SIZE; j++){
					secondArrangement[j] = in.readLine().split(" ");
				}
				
				sb.append("Case #")
					.append(i + 1)
					.append(": ")
					.append(doIt());
				if (i + 1 != n){
					sb.append("\n");
				}
			}
			
			String result = sb.toString();
			System.out.println(result);
			out.write(result);
		} catch (Exception e){
		} finally {
			if (in != null){ try { in.close(); } catch (Exception ex) {} }
			if (out != null){ try { out.close(); } catch (Exception ex) {} }
		}
	}
	
	private String doIt(){
		Set<String> swp = new HashSet<String>();
		List<String> answer = new ArrayList<String>();
		
		for (int i = 0; i < SIZE; i++){
			swp.add(firstArrangement[firstAnswer][i]);
		}
		
		for (int i = 0; i < SIZE; i++){
			if (swp.contains(secondArrangement[secondAnswer][i])){
				answer.add(secondArrangement[secondAnswer][i]);
			}
		}
		
		switch (answer.size()){
		case 0 : return "Volunteer cheated!";
		case 1 : return answer.get(0);
		default: return "Bad magician!";
		}
	}
}
