package com.szabogabriel.cj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

public class AbstractSolution {

	private BufferedReader IN;
	private BufferedWriter OUT;

	private int count;
	
	private long N;
	private boolean [] found;
	private int [] numbers = new int [256];

	public AbstractSolution(File input, File output) {
		numbers['0'] = 0;
		numbers['1'] = 1;
		numbers['2'] = 2;
		numbers['3'] = 3;
		numbers['4'] = 4;
		numbers['5'] = 5;
		numbers['6'] = 6;
		numbers['7'] = 7;
		numbers['8'] = 8;
		numbers['9'] = 9; 
		try {
			IN = new BufferedReader(new InputStreamReader(new FileInputStream(input)));
			OUT = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(output)));
			count = Integer.parseInt(IN.readLine()); //FIXME
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void execute() {
		try {
			for (int i = 0; i < count; i++) {
				readInput();
				handle(i);
			}
			OUT.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void readInput() throws IOException {
		N = Long.parseLong(IN.readLine());
		found = new boolean [] {false, false, false, false, false, false, false, false, false, false};
	}
	
	private void setCyphers(long finalNumber) {
		char [] swp = Long.toString(finalNumber).toCharArray();
		for (char it : swp)
			found[numbers[it]] = true;
	}
	
	private boolean isAsleep() {
		for (boolean it : found)
			if (!it)
				return false;
		return true;
	}
	
	private boolean isSleepPossible() {
		return N != 0;
	}
	
	private void handle(int caseId) {
		long finalNumber = 0;
		if (isSleepPossible()) {
			while (!isAsleep()) {
				finalNumber += N;
				setCyphers(finalNumber);
			}
			print(caseId, finalNumber + "");
		} else {
			print(caseId, "INSOMNIA");
		}
	}

	private void print(int count, String output) {
		try {
			System.out.println("Case #" + (count + 1) + ": " + output);
			OUT.write("Case #" + (count + 1) + ": " + output + "\n");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
