package com.google.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;

public class CookieClicker {

	private double cookiePerSecond = 2.0d;
	private double costOfFarm = 0.0d;
	private double addCookiePerSecond = 0.0d;
	private double goal = 0.0d;
	private double seconds;
	
	public static void main(String [] args){
		new CookieClicker().doIt(new File(args[0]), new File(args[1]));
	}
	
	public void doIt(File inFile, File outFile){
		BufferedReader in = null;
		BufferedWriter out = null;
		try {
			StringBuilder sb = new StringBuilder();
			String [] swp;
			
			in = new BufferedReader(new FileReader(inFile));
			out = new BufferedWriter(new FileWriter(outFile));
			
			int n = Integer.parseInt(in.readLine());
			
			for (int i = 0; i < n; i++){
				swp = in.readLine().split(" ");
				costOfFarm = Float.parseFloat(swp[0]);
				addCookiePerSecond = Float.parseFloat(swp[1]);
				goal = Float.parseFloat(swp[2]);
				
				sb.append("Case #")
					.append(i + 1)
					.append(": ")
					.append(doIt());
				if (i + 1 != n){
					sb.append("\n");
				}
			}
			
			String buffer = sb.toString();
			System.out.println(buffer);
			out.write(buffer);
		} catch (Exception e){
			e.printStackTrace();
		} finally {
			if (in != null) try { in.close(); } catch (Exception e) {}
			if (out != null) try { out.close(); } catch (Exception e) {}
		}
	}
	
	private void reset(){
		seconds = 0.0f;
		cookiePerSecond = 2.0f;
	}
	
	private String doIt(){
		reset();
		while (shouldBuildFarm()){
			buildFarm();
		}
		seconds += timeToGoal();
		return Double.valueOf(seconds).toString();
	}
	
	private boolean shouldBuildFarm(){
		return timeToGoal() > (timeToGoalWithAdditionalFarm() + timeToFarm());
	}
	
	private void buildFarm(){
		seconds += timeToFarm();
		cookiePerSecond += addCookiePerSecond;
	}
	
	private double timeToGoal(){
		return goal / cookiePerSecond;
	}
	
	private double timeToFarm(){
		return costOfFarm / cookiePerSecond;
	}
	
	private double timeToGoalWithAdditionalFarm(){
		return goal / (cookiePerSecond + addCookiePerSecond);
	}

}
