package com.szabogabriel.cj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

public class AbstractSolution {

	private BufferedReader IN;
	private BufferedWriter OUT;

	private int count;
	
	private boolean [] values;

	public AbstractSolution(File input, File output) {
		try {
			IN = new BufferedReader(new InputStreamReader(new FileInputStream(input)));
			OUT = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(output)));
			count = Integer.parseInt(IN.readLine()); //FIXME
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void execute() {
		try {
			for (int i = 0; i < count; i++) {
				readInput();
				handle(i);
			}
			OUT.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void readInput() throws IOException {
		char [] swp = IN.readLine().toCharArray();
		values = new boolean [swp.length];
		for (int i = 0; i < swp.length; i++) {
			values[i] = swp[i] == '+';
		}
	}
	
	private boolean isStackOk() {
		for (boolean i : values) 
			if (!i)
				return false;
		return true;
	}
	
	private int findAmountToFlip() {
		int ret = 0;
		boolean first = values[0];
		for (boolean i : values)
			if (i == first)
				ret++;
			else 
				return ret;
		return ret;
	}
	
	private void flip(int amount) {
		for (int i = 0; i < amount; i++)
			values[i] = !values[i];
	}

	private void handle(int caseId) {
		int count = 0;
		while (!isStackOk()) {
			count++;
			flip(findAmountToFlip());
		}
		print(caseId, count + "");
	}

	private void print(int count, String output) {
		try {
			System.out.println("Case #" + (count + 1) + ": " + output);
			OUT.write("Case #" + (count + 1) + ": " + output + "\n");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
