import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.NumberFormat;


public class ProblemB {
	
	public static void main(String[] args) {
		//C, F, X
		/*
		4
		30.0 1.0 2.0
		30.0 2.0 100.0
		30.50000 3.14159 1999.19990
		500.0 4.0 2000.0
		*/
		
		
		/*
		Case #1: 1.0000000
		Case #2: 39.1666667
		Case #3: 63.9680013
		Case #4: 526.1904762 
		*/
		
		BufferedReader br = null;
		try {
			br = new BufferedReader(new FileReader(new File(args[0])));
			String line;
			int i = 0;
			int numCases = 0;
			while ((line = br.readLine()) != null) {
				
				if(i == 0) {
					numCases = Integer.parseInt(line);
					////System.out.println("numCases==" + numCases);
				} else {
					//start reading input lines
					double result = processLine(line);
					String s = String.valueOf(result);
					
					try {
						NumberFormat f = new DecimalFormat("#0.0000000");
						s = f.format(result);
					} catch (Exception e) {
						//Catch and ignore exception
					}
			        
					System.out.println("Case #" + i + ": " + s);
					////System.out.println("\n\n=================================");
				}
				
				i = i + 1;
			}
		} catch (Exception e) {
			//Catch and ignore exception
		} finally {
			try {
				if(br != null) {
					br.close();
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	public static double processLine(String line) {
		String[] tokens = line.split(" ");
		double cVal = Double.parseDouble(tokens[0]);
		double fVal = Double.parseDouble(tokens[1]);
		double xVal = Double.parseDouble(tokens[2]);
		
		double result = 0.0;
		double curr = 2.0;
		////System.out.println("C=" + cVal + "; F=" + fVal + "; X=" + xVal);
		
		double lhs = xVal * ( ( 1 / curr ) - ( 1 / (curr + fVal) ) );
		double rhs = cVal / curr;
		//double inc = xVal / curr;
		////System.out.println("lhs=" + lhs + "; rhs=" + rhs + "; curr=" + curr); // + "; inc=" + inc);
		
		while(lhs > rhs) {
			////System.out.println("lhs > rhs: " + lhs + " > " + rhs);
			result += rhs;
			curr += fVal;
			
			lhs = xVal * ( ( 1 / curr ) - ( 1 / (curr + fVal) ) );
			rhs = cVal / curr;
			//inc = xVal / curr;
			////System.out.println("lhs=" + lhs + "; rhs=" + rhs + "; curr=" + curr); // + "; inc=" + inc);
		}
		
		result += (xVal  / curr);
		
		return result;
	}
}
