import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/*
3							numCases = 3;
2							answers = [2, 3]
1 2 3 4						inputSet = 
5 6 7 8
9 10 11 12
13 14 15 16
3
1 2 5 4
3 11 6 15
9 10 7 12
13 14 8 16
2
1 2 3 4
5 6 7 8
9 10 11 12
13 14 15 16
2
1 2 3 4
5 6 7 8
9 10 11 12
13 14 15 16
2
1 2 3 4
5 6 7 8
9 10 11 12
13 14 15 16
3
1 2 3 4
5 6 7 8
9 10 11 12
13 14 15 16
 */

public class ProblemA {
	
	public static final String RESULT_STR = "Case #";
	
	public static final String NO_MATCH = "Volunteer cheated!";
	
	public static final String DUP_MATCH = "Bad magician!";
	
	
	public static void main(String[] args) {
		List<Integer> listOne = new ArrayList<Integer>();
		List<Integer> listTwo = new ArrayList<Integer>();
		int currentCase = 0;
		
		BufferedReader br = null;
		try {
			br = new BufferedReader(new FileReader(new File(args[0])));
			String line;
			int i = 0;
			int numCases = 0;
			int[] answers = new int[2];
			int[][] inputSet = new int[8][4];
			int inputRowNum = 0; // 4 rows per input set - so 8 rows per case - so this will be 0, 1, 2, 3, 4, 5, 6, 7
			int caseAnswerNum = 0; // 2 answers per case - so this can be 0,1
			int nextAnswerRow = 1;
			
			while ((line = br.readLine()) != null) {
			   if(i == 0) {
				   ////System.out.println("First line:" + line);
				   //number of test cases to follow
				   numCases = Integer.parseInt(line);
				   //System.out.println("numCases==" + numCases);
				   
				   i = i + 1;
				   continue;
			   }
			   
			   if(i == nextAnswerRow) {
				   ////System.out.println("Answer line:" + line);
				   if(caseAnswerNum == 2) { 
					   //New test case begin
					   currentCase = currentCase + 1;
					   answers = new int[2];
					   caseAnswerNum = 0;
					   inputRowNum = 0; //make it 0 every time we are on first answer row of new case 
					   // - this is to indicate start of new input set for the new case
				   }
				   
				   answers[caseAnswerNum] = Integer.parseInt(line);
				   
				   caseAnswerNum = caseAnswerNum + 1;
				   
				   nextAnswerRow = nextAnswerRow + 5;
				   
				   i = i + 1;
				   continue;
			   }
			   
			   if(i < nextAnswerRow) {
				   ////System.out.println("Input line:" + line);
				   String[] tokens = line.split(" ");
				   int rowPos = 0;
				   for(String s : tokens) {
					   inputSet[inputRowNum][rowPos++] = Integer.parseInt(s);
				   }
				   
				   inputRowNum = inputRowNum +1;
				   
				   if(inputRowNum == 8) {
					   /*
					    2							answers = [2, 3]
						1 2 3 4						inputSet = 
						5 6 7 8
						9 10 11 12
						13 14 15 16
						3
						1 2 5 4
						3 11 6 15
						9 10 7 12
						13 14 8 16
					   */
					   
					   /*
					    Case #1: 7
						Case #2: Bad magician!
						Case #3: Volunteer cheated! 
					    */
					   listOne = new ArrayList<Integer>();
					   listTwo = new ArrayList<Integer>();
					   
					   for(int num : inputSet[answers[0] - 1]) {
						   listOne.add(num);
					   }
					   
					   for(int num : inputSet[answers[1] + 3]) {
						   listTwo.add(num);
					   }
					   
					   listOne.retainAll(listTwo);
					   
					   printOutput(listOne, currentCase);
				   }
				   
				   i = i + 1;
				   continue;
			   }
			}
			
			////System.out.println("Done reading input>>>>>>>>>>>>>>>>>>>");
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if(br != null) {
					br.close();
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	public static void printOutput(List<Integer> listOne, int currentCase) {
		String result = RESULT_STR + (currentCase + 1) + ": ";
		if(listOne.size() == 0) {
			result += NO_MATCH;
		} else if(listOne.size() == 1) {
			result += listOne.get(0);
		} else if(listOne.size() > 1) {
			result += DUP_MATCH;
		}
		System.out.println(result);
		////System.out.println("\n##############################################################");
	}
}
