import java.io.*;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class B {

	public static void main( String[] args ) throws IOException
	{
		BufferedReader in = new BufferedReader( new FileReader("input") );

		String s = in.readLine();
		int T = Integer.parseInt(s);

		for( int i = 0 ; i < T ; i ++ )
		{
			s = in.readLine();
			StringTokenizer st = new StringTokenizer(s);
			int H = Integer.parseInt(st.nextToken());
			int W = Integer.parseInt(st.nextToken());

			/** CReATe MAp **/
			Cell[][] map = new Cell[H][W];
			for( int j = 0 ; j < H ; j++ )
			{
				s = in.readLine();
				st = new StringTokenizer(s);
				for( int k = 0 ; k < W ; k++ )
				{
					map[j][k] = new Cell( Integer.parseInt(st.nextToken()), j, k );
				}
			}

			/** FinD SinKS **/
			ArrayList<Cell> sinks = findSinks(H, W, map);

			/** buIlD AdJACEncieS **/
			setCellAdjacency(map, H, W);

			/** buIlD BasiNs **/
			for( Cell c : sinks )
			{
				c.basin = new ArrayList<Cell>();
				c.basin.add(c);
				ArrayList<Cell> queue = new ArrayList<Cell>();
				ArrayList<Cell> queue2 = new ArrayList<Cell>();
				queue.add(c);
				while( !queue.isEmpty() )
				{
					Cell current = queue.remove(0);
					queue2.add(current);
					if( current.north != null && isBelow(map, current, current.north))
					{
						current.north.basin = current.basin;
						current.basin.add(current.north);
						if( !queue2.contains(current.north))
							queue.add(current.north);
					}
					if( current.east != null && isBelow(map, current, current.east))
					{
						current.east.basin = current.basin;
						current.basin.add(current.east);
						if( !queue2.contains(current.east))
							queue.add(current.east);
					}
					if( current.west != null && isBelow(map, current, current.west))
					{
						current.west.basin = current.basin;
						current.basin.add(current.west);
						if( !queue2.contains(current.west))
							queue.add(current.west);
					}
					if( current.south != null && isBelow(map, current, current.south))
					{
						current.south.basin = current.basin;
						current.basin.add(current.south);
						if( !queue2.contains(current.south))
							queue.add(current.south);
					}
				}
			}

			/** DEBUG ????**/
//			for( Cell c : sinks )
//			{
//				System.out.println( "SINK: " + c.h + " , " + c.w );
//				for( Cell c2 : c.basin )
//					System.out.println(c2.h + " " + c2.w);
//				System.out.println("----");
//			}

			/** laBEl basiNS **/
			char[] alphabet = {'a','b','c','d','e','f','g','h','i','j',
					'k','l','m','n','o','p','q','r','s','t','u','v'
					,'w','x','y','z'};
			int currLetter = 0;
			for( int j = 0 ; j < H ; j++ )
			{
				for( int k = 0 ; k < W ; k++ )
				{
					if( map[j][k].label == null )
					{
						for( Cell c : map[j][k].basin )
							c.label = alphabet[currLetter] + "";
						currLetter++;
					}
				}
			}


			/** PRinT iT **/
			System.out.println( "Case #" + (i +1)+ ":" );
			for( int j = 0 ; j < H ; j++ )
			{
				for( int k = 0 ; k < W ; k++ )
				{
					System.out.printf( map[j][k].label );
					if( k != W-1 )
						System.out.printf( " " );
					else
						System.out.println();
				}
			}

		}

	}

	public static ArrayList<Cell> findSinks( int H, int W, Cell[][] map )
	{
		ArrayList<Cell> sinks = new ArrayList<Cell>();
		for( int i = 0; i < H ; i++ )
		{
			for( int j = 0; j < W ; j++ )
			{
				int currC = map[i][j].alt;
				int north,south,east,west;
				north = south = west = east = Integer.MAX_VALUE;
				if( i != 0 )
					north = map[i-1][j].alt;
				if( i != H-1 )
					south = map[i+1][j].alt;
				if( j != 0 )
					west = map[i][j-1].alt;
				if( j != W-1 )
					east = map[i][j+1].alt;

				int minH = Math.min(north, south);
				int minW = Math.min(west, east);
				int min = Math.min(minH, minW);
				if( map[i][j].alt <= min )
				{
					sinks.add(map[i][j]);
					map[i][j].isSink = true;
				}		
			}
		}
		return sinks;
	}

	static boolean isBelow( Cell[][] map, Cell below, Cell above )
	{
		boolean isBelow = true;
		//North,West,East,South
		
		if( below.alt >= above.alt )
			isBelow = false;
		else if( ( above.north != null && below.alt > above.north.alt && below != above.north ) || 
				( above.south != null && below.alt > above.south.alt && below != above.south ) ||
				( above.east != null && below.alt > above.east.alt && below != above.east ) ||
				( above.west != null && below.alt > above.west.alt && below != above.west ) )
			isBelow = false;
		else if( ( above.north != null && below.alt == above.north.alt && below != above.north ) )
			isBelow = false;
		else if( ( above.west != null && below.alt == above.west.alt && below != above.north && below != above.west ) )
			isBelow = false;
		else if( (above.east != null &&  below.alt == above.east.alt && below != above.north && below != above.west && below != above.east ) )
			isBelow = false;


//				System.out.println( "Is (" + below.h +","+ below.w+ ") below (" +
//						above.h + ","+above.w + ")?  --> " + isBelow + " (" +(below.alt) +"," +above.alt + ")" ); 
		return isBelow;
	}

	static void setCellAdjacency( Cell[][] map, int H, int W )
	{
		for( int i = 0; i < H ; i++ )
		{
			for( int j = 0; j < W ; j++ )
			{
				Cell currC = map[i][j];
				if( i != 0 )
					currC.north = map[i-1][j];
				if( i != H-1 )
					currC.south = map[i+1][j];
				if( j != 0 )
					currC.west = map[i][j-1];
				if( j != W-1)
					currC.east = map[i][j+1];
			}
		}
	}

	static class Cell
	{
		int alt, h, w;
		Cell drainsInto;
		boolean isSink = false;
		String label;
		Cell north,south,east,west;
		ArrayList<Cell> basin;

		Cell( int alt, int h, int w )
		{
			this.alt = alt;
			this.h = h;
			this.w = w;
		}

	}
}
