import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class ProblemC {

	private static final String PROBLEM_PREFIX = "C";
	
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-test";

	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt0";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt1";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt2";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt3";
	private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-large";

	private static long findFirstFactor(long n) {
		for (long factor = 2; factor * factor <= n; factor++) {
			if (n % factor == 0) {
				return factor;
			}
		}
		return -1L;
	}
	
	public static String naive(int n, int j) {
		StringBuilder sb = new StringBuilder();
		for (long number = (1 << (n - 1)) + 1; number < 1 << n; number += 2) {
			String input = Long.toString(number, 2);
			System.err.println(input);
			boolean containsPrime = false;
			StringBuilder ssb = new StringBuilder();
			ssb.append(input).append(" ");
			for (int base = 2; base <= 10; base++) {
				long value = Long.valueOf(input, base);
				long firstFactor = findFirstFactor(value);
				if (firstFactor == -1) {
					containsPrime = true;
					break;
				} else {
					ssb.append(firstFactor);
					if (base < 10) {
						ssb.append(" ");
					}
				}
			}
			if (!containsPrime) {
				sb.append(ssb).append("\n");
				System.out.println(ssb);
				if (--j == 0) {
					break;
				}
			}
		}
		return sb.toString();
	}
	
	private static BigInteger findFirstFactor(BigInteger n) {
		for (BigInteger factor = BigInteger.valueOf(2); factor.multiply(factor).compareTo(n) <= 0; factor = factor.add(BigInteger.ONE)) {
			if (n.mod(factor).compareTo(BigInteger.ZERO) == 0) {
				return factor;
			}
			if (factor.compareTo(BigInteger.valueOf(100)) > 0) {
				break;
			}
		}
		return null;
	}

	public static String solve(int n, int j) {
		StringBuilder sb = new StringBuilder();
		for (BigInteger number = BigInteger.ONE.shiftLeft(n - 1).add(BigInteger.ONE); number.compareTo(BigInteger.ONE.shiftLeft(n)) < 0; number = number.add(BigInteger.valueOf(2))) {
			String input = number.toString(2);
			System.err.println(j + ": " + input);
			boolean containsPrime = false;
			StringBuilder ssb = new StringBuilder();
			ssb.append(input).append(" ");
			for (int base = 2; base <= 10; base++) {
				BigInteger value = new BigInteger(input, base);
				/*if (value.isProbablePrime(3)) {
					break;
				}*/
				BigInteger firstFactor = findFirstFactor(value);
				if (firstFactor == null) {
					containsPrime = true;
					break;
				} else {
					ssb.append(firstFactor);
					if (base < 10) {
						ssb.append(" ");
					}
				}
			}
			if (!containsPrime) {
				sb.append(ssb).append("\n");
				System.out.println(ssb);
				if (--j == 0) {
					break;
				}
			}
		}
		return sb.toString();
	}
	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File(PROBLEM_NAME + ".in"));
		PrintStream out = new PrintStream(new File(PROBLEM_NAME + ".out"));

		int t = in.nextInt();
		int caseNumber = 1;
		while (caseNumber <= t) {
			int n = in.nextInt();
			int j = in.nextInt();
			out.println("Case #" + caseNumber++ + ":");
			out.println(solve(n, j));
		}
	}

}
