import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

public class ProblemB {

	private static final String PROBLEM_PREFIX = "B";
	
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-test";

	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt0";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt1";
	private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt2";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt3";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-large";

	private static String format(String pattern, int n) {
		String s = "" + n;
		if (pattern.length() - s.length() == 1) {
			s = "0" + s;
		} else if (pattern.length() - s.length() == 2) {
			s = "00" + s;
		}
		return s;
	}
	
	private static boolean fits(String pattern, int n) {
		String s = format(pattern, n);
		for (int i = 0; i < pattern.length(); i++) {
			if (pattern.charAt(i) == '?' || pattern.charAt(i) == s.charAt(i)) {
				continue;
			}
			return false;
		}
		return true;
	}
	
	public static String naive(String a, String b) {
		int min = Integer.MAX_VALUE;
		int minA = Integer.MAX_VALUE;
		int minB = Integer.MAX_VALUE;
		int max = a.length() == 1 ? 10 : a.length() == 2 ? 100 : 1000;
		for (int i = 0; i < max; i++) {
			if (fits(a, i)) {
				for (int j = 0; j < max; j++) {
					if (fits(b, j)) {
						if (
								Math.abs(i - j) < min || 
								Math.abs(i - j) == min && i < minA || 
								Math.abs(i - j) == min && i == minA && j < minB
						) {
							min = Math.abs(i - j);
							minA = i;
							minB = j;
						}
					}
				}
			}
		}
		return format(a, minA) + " " + format(b, minB);
	}
	
	public static String solve(String a, String b) {
		String ar = "";
		String br = "";
		int diff = 0;
		for (int i = 0; i < a.length(); i++) {
			char ca = a.charAt(i);
			char cb = b.charAt(i);
			if (ca == '?' && cb == '?') {
				if (diff == 0) {
					ar += "0";
					br += "0";
				} else if (diff > 0) {
					ar += "0";
					br += "9";
				} else {
					ar += "9";
					br += "0";
				}
			} else if (ca == '?') {
				br += cb;
				if (diff == 0) {
					ar += cb;
				} else if (diff > 0) {
					ar += "0";
				} else {
					ar += "9";
				}
			} else if (cb == '?') {
				ar += ca;
				if (diff == 0) {
					br += ca;
				} else if (diff > 0) {
					br += "9";
				} else {
					br += "0";
				}
			} else {
				ar += ca;
				br += cb;
			}
			diff = Integer.valueOf(ar) - Integer.valueOf(br);
		}
		
		return ar + " " + br;
	}

	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File(PROBLEM_NAME + ".in"));
		PrintStream out = new PrintStream(new File(PROBLEM_NAME + ".out"));
		try {
			int t = in.nextInt();
			int caseNumber = 1;
			while (caseNumber <= t) {
				String a = in.next();
				String b = in.next();
				out.println("Case #" + caseNumber++ + ": " + naive(a, b));
			}
		} finally {
			in.close();
			out.close();
		}
	}

}
