import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.PriorityQueue;
import java.util.Scanner;

public class ProblemA {

	private static final String PROBLEM_PREFIX = "A";
	
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-test";

	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt0";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt1";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt2";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt3";
	private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-large";

	private static double check(int[] p) {
		double max = Integer.MIN_VALUE;
		double sum = 0;
		for (int i = 0; i < p.length; i++) {
			max = Math.max(max, p[i]);
			sum += p[i];
		}
		return sum > 0 ? max / sum : 0;
	}
	
	public static String naive(int n, int[] p) {
		StringBuilder sb = new StringBuilder();
		while (true) {
			int max = Integer.MIN_VALUE;
			int maxIndex = -1;
			for (int i = 0; i < n; i++) {
				if (p[i] > max) {
					max = p[i];
					maxIndex = i;
				}
			}
			if (max == 0) {
				break;
			}
			p[maxIndex]--;
			sb.append((char) ('A' + maxIndex));
			
			max = Integer.MIN_VALUE;
			maxIndex = -1;
			for (int i = 0; i < n; i++) {
				if (p[i] > max) {
					max = p[i];
					maxIndex = i;
				}
			}
			if (max == 0) {
				break;
			}
			p[maxIndex]--;
			if (check(p) <= 0.5) {
				sb.append((char) ('A' + maxIndex));
			} else {
				p[maxIndex]++;
			}
			
			sb.append(" ");
			
			if (check(p) > 0.6) {
				System.err.println("ERROR");
			}

		}
		return sb.toString();
	}

	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File(PROBLEM_NAME + ".in"));
		PrintStream out = new PrintStream(new File(PROBLEM_NAME + ".out"));
		try {
			int t = in.nextInt();
			int caseNumber = 1;
			while (caseNumber <= t) {
				int n = in.nextInt();
				int[] p = new int[n];
				for (int i = 0; i < n; i++) {
					p[i] = in.nextInt();
				}
				out.println("Case #" + caseNumber++ + ": " + naive(n, p));
			}
		} finally {
			in.close();
			out.close();
		}
	}

}
