import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class ProblemA {

	private static final String PROBLEM_PREFIX = "A";
	
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-test";

	private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt0";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt1";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt2";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt3";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-large";

	private static String[] words = new String[] {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
	
	private static String subtract(String s, String w) {
		for (char c : w.toCharArray()) {
			if (s.indexOf("" + c) == -1) {
				return null;
			}
			s = s.replaceFirst("" + c, "x");
		}
		return s.replaceAll("x", "");
	}
	
	private static String find(String s, String result) {
		if (s.isEmpty()) {
			return result;
		}
		for (int i = 0; i < words.length; i++) {
			String w = words[i];
			String subtract = subtract(s, w);
			if (subtract == null) {
				continue;
			}
			String r = find(subtract, result + i);
			if (r != null) {
				return r;
			}
		}
		return null;
	}
	
	public static String solve(String s) {
		return find(s, "");
	}

	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File(PROBLEM_NAME + ".in"));
		PrintStream out = new PrintStream(new File(PROBLEM_NAME + ".out"));
		try {
			int t = in.nextInt();
			int caseNumber = 1;
			while (caseNumber <= t) {
				String s = in.next();
				out.println("Case #" + caseNumber++ + ": " + solve(s));
			}
		} finally {
			in.close();
			out.close();
		}
	}

}
