import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

public class ProblemC {

	private static final String PROBLEM_PREFIX = "C";
	
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-test";

	private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt0";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt1";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt2";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt3";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-large";

	private static List<Long> factor(long n) {
		List<Long> factors = new ArrayList<Long>();
		for (long factor = 2; factor * factor <= n; factor++) {
            while (n % factor == 0) {
                factors.add(factor); 
                n /= factor;
            }
        }
		return factors;
	}
	
	public static String naive(int n, int j) {
		StringBuilder sb = new StringBuilder();
		for (long number = (1 << (n - 1)) + 1; number < 1 << n; number += 2) {
			String input = Long.toString(number, 2);
			boolean containsPrime = false;
			StringBuilder ssb = new StringBuilder();
			ssb.append(input).append(" ");
			for (int base = 2; base <= 10; base++) {
				long value = Long.valueOf(input, base);
				List<Long> factors = factor(value);
				if (factors.isEmpty()) {
					containsPrime = true;
					break;
				} else {
					ssb.append(factors.get(0));
					if (base < 10) {
						ssb.append(" ");
					}
				}
			}
			if (!containsPrime) {
				sb.append(ssb).append("\n");
				System.out.println(ssb);
				if (--j == 0) {
					break;
				}
			}
		}
		return sb.toString();
	}

	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File(PROBLEM_NAME + ".in"));
		PrintStream out = new PrintStream(new File(PROBLEM_NAME + ".out"));

		int t = in.nextInt();
		int caseNumber = 1;
		while (caseNumber <= t) {
			int n = in.nextInt();
			int j = in.nextInt();
			out.println("Case #" + caseNumber++ + ":");
			out.println(naive(n, j));
		}
	}

}
