import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class ProblemB {

	public static void main(String[] args) throws FileNotFoundException {
		Scanner scanner = new Scanner(new File("B-large.in"));
		//Scanner scanner = new Scanner(new File("B-small-attempt3.in"));
		// Scanner scanner = new Scanner(new File("B-test.in"));
		try {
			int t = scanner.nextInt();
			int caseNumber = 1;
			while (caseNumber <= t) {
				int count = scanner.nextInt();
				int[] pancakeIndex = new int[1000 + 1];
				int max = 0;
				for (int i = 0; i < count; i++) {
					int p = scanner.nextInt();
					pancakeIndex[p]++;
					max = Math.max(max, p);
				}

				int result = solve(pancakeIndex, max);

				System.out.println("Case #" + caseNumber++ + ": " + result);
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			scanner.close();
		}
	}

	public static int solve(int[] pancakeIndex, int max) {
		int min = max;
		
		for (int i = 1; i < max; i++) {
			int specialMinutesCount = 0;
			for (int j = i + 1; j <= max; j++) {
				if (pancakeIndex[j] == 0) {
					continue;
				}
				specialMinutesCount += (j / i + (j % i == 0 ? 0 : 1) - 1) * pancakeIndex[j];
			}
			int minCandidate = i + specialMinutesCount;
			min = Math.min(min, minCandidate);
		}
		
		return min;
	}
	
	/*public static int solve(int[] pancakeIndex, int max) {
		int result = max;
		int specialMinutes = 0;
		for (int pancakesCount = max; pancakesCount > 0; pancakesCount--) {
			int dinersCount = pancakeIndex[pancakesCount];

			if (dinersCount == 0) {
				continue;
			}

			result = Math.min(result, pancakesCount + specialMinutes);

			int splitSize = (int) Math.sqrt(pancakesCount);

			int splitsCount = pancakesCount / splitSize;
			pancakeIndex[splitSize] += dinersCount * splitsCount;
			int leftover = pancakesCount - splitSize * splitsCount;
			if (leftover > 0) {
				pancakeIndex[leftover] += dinersCount;
			}
			pancakeIndex[pancakesCount] = 0;

			specialMinutes += dinersCount * (splitsCount - (leftover == 0 ? 1 : 0));

		}
		return result;
	}*/
}