import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

public class ProblemD {

	private static final String PROBLEM_PREFIX = "D";
	
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-test";

	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt0";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt1";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt2";
	//private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-small-attempt3";
	private static final String PROBLEM_NAME = PROBLEM_PREFIX + "-large";

	private static String toString(long[] result) {
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < result.length; i++) {
			sb.append(result[i]);
			if (i + 1 < result.length) {
				sb.append(" ");
			}
		}
		return sb.toString();
	}

	private static long pow(long n, long pow) {
		long result = 1;
		for (int i = 1; i <= pow; i++) {
			result *= n;
		}
		return result;
	}
	
	public static String naive(int k, int c, int s) {
		long[] result = new long[k];
		long groupLength = pow(k, c - 1);
		for (int i = 0; i < k; i++) {
			long groupNumber = i + 1;
			result[i] = groupNumber * groupLength;
		}
		return toString(result);
	}

	public static String solve(int k, int c, int s) {
		int min = (int) Math.ceil(((double) k) / Math.pow(2, c - 1));
		if (s < min) {
			return "IMPOSSIBLE";
		}
		long[] result = new long[min];
		for (int i = 0; i < min; i++) {
			result[i] = pow(k, c - 1) + (i + 1) * pow(2, c - 1) - 1;
		}
		return toString(result);
	}
	
	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File(PROBLEM_NAME + ".in"));
		PrintStream out = new PrintStream(new File(PROBLEM_NAME + ".out"));

		int t = in.nextInt();
		int caseNumber = 1;
		while (caseNumber <= t) {
			int k = in.nextInt();
			int c = in.nextInt();
			int s = in.nextInt();
			out.println("Case #" + caseNumber++ + ": " + solve(k, c, s));
		}
	}

}
