import java.util.*;
import java.io.*;
public class Main {

  static class Pair implements Comparable<Pair> {
      public char party;
      public int num;

      public Pair(int p, int num) {
          this.party = (char)('A' + p);
          this.num = num;
      }

      public int compareTo(Pair comparePair) {
          return comparePair.num - this.num;
      }
  }

  public static void main(String[] args) {
    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
    int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
    for (int k = 1; k <= t; k++) {
        int n = in.nextInt();
        PriorityQueue<Pair> queue = new PriorityQueue<Pair>(n);
        for (int i = 0; i < n; i++) { queue.add(new Pair(i, in.nextInt())); }

        StringBuilder sb = new StringBuilder();
        sb.append("Case #");
        sb.append(k);
        sb.append(":");
        while (!queue.isEmpty()) {
          sb.append(" ");
          Pair p = queue.poll();
          if (p.num > queue.peek().num) {
              sb.append(p.party);
              if (--p.num > 0) queue.add(p);
          } else {
              if (queue.size() > 1) {
                  sb.append(p.party);
                  if (--p.num > 0) queue.add(p);
              } else {
                  Pair q = queue.poll();
                  sb.append(p.party);
                  sb.append(q.party);
                  if (--p.num > 0) queue.add(p);
                  if (--q.num > 0) queue.add(q);
              }
          }
        }
        System.out.println(sb.toString());
    }
    
  }

}