package com.codejam;

import java.util.Arrays;

public class Pancakes extends Solver<Integer> {
    private char[] trimRight(char character, char[] data) {
        int finalLen = data.length;
        int trimCount = 0;
        while (finalLen > 0 && data[finalLen - 1] == character) {
            finalLen--;
        }
        return Arrays.copyOf(data, finalLen);
    }

    private char flipChar(char source) {
        return source == '+' ? '-' : '+';
    }

    private int getFlippingCost(char target, char[] data) {
        if (data.length == 0) {
            return 0;
        }
        int addValue = 0;
        if (data[data.length - 1] != target) {
            addValue = 1;
            target = flipChar(target);

        }
        /*
         * If last few characters are same as target skip them
         * otherwise one more flip and reversed target
        * */
        return addValue + getFlippingCost(target, trimRight(target, data));

    }

    @Override
    public Integer solveCase() {
        char[] data = input.next().trim().toCharArray();
        return getFlippingCost('+', data);
    }
}
