package com.codejam;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * Created by Mario on 4/9/2016.
 */
public class CountingSheep extends Solver<String> {
    private static final int MAX_ITERATIONS = 100_000;

    public CountingSheep(String problemName) {
        super(problemName);
    }

    @Override
    public String solveCase() {
        int result = generateSolution();
        return result == -1 ? "INSOMNIA" : String.valueOf(result);
    }

    private Set<Integer> getDigits(int number) {
        Set<Integer> digits = new HashSet<>();
        while (number > 0) {
            digits.add(number % 10);
            number /= 10;
        }
        return digits;
    }

    private int generateSolution() {
        Set<Integer> digits = new HashSet<>();
        int startingNumber = input.nextInt();
        if (startingNumber == 0) {
            return -1;
        }
        int current = startingNumber;
        while (true) {
            digits.addAll(getDigits(current));
            if (digits.size() == 10) {
                return current;
            }
            current += startingNumber;
        }
    }
}
