import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.Queue;


public class War {

	public static void main(String[] args) throws Exception {

		new War().solve();
		
	}
	
	public void solve()  throws Exception{
		
		
		
		String inFile = "inFiles/D-small-attempt0.in";
		String outFile= "inFiles/out.out";
		
				
		BufferedReader fin = new BufferedReader(new InputStreamReader(new FileInputStream(inFile)));
		PrintWriter fout = new PrintWriter(outFile);
		
		int totalTests = Integer.parseInt(fin.readLine());
		
		int N;
		String[] splt;
		String na3Data;
		Double double1;
		
		RBT<Double, Double> ken, abl;
		
		
		for(int test = 1; test <=totalTests; test++){
			ken = new RBT<Double, Double>();
			abl = new RBT<Double, Double>();
			N = Integer.parseInt(fin.readLine());
			
			na3Data = fin.readLine();
			
			splt = fin.readLine().split(" ");
			for (int i = 0; i < N; i++) {
				double1 = new Double(splt[i]);
				ken.put(double1, double1);
				abl.put(double1, double1);
			}
			double[] na3 = new double[N];
			splt = na3Data.split(" ");
			for (int i = 0; i < N; i++) {
				na3[i] = Double.parseDouble(splt[i]);
			}
			Arrays.sort(na3);
			
			int  totalNa3 = 0, totalDeceved = 0;

			totalNa3 = playFair(abl, na3, N);
			
			totalDeceved= playUnFair(ken, na3, N);
			
			fout.println("Case #"+test+": "+totalDeceved+" "+totalNa3);
//			System.out.println("Case #"+test+": "+totalNa3+" "+totalDeceved);
			
			
		}
		
		
		
		
		
		fout.close();
		fin.close();
		
		
	}
	
	
	private int playUnFair(RBT<Double, Double> ken, double[] na3, int N) {
		Double dNa3, dMax;
		
		int head = 0, totalDeceved = 0, sz;
		
		for(; head < N; head++){
			dMax = ken.max();
			if(na3[N-head-1]> dMax){
				totalDeceved++;
				ken.deleteMax();
			}else{
				break;
			}
		}
		
		
		for (int idx = 0; idx < N - head; idx++) {
			
			dMax = ken.max();
			
			if(na3[idx] > dMax){//Play fair
				
				totalDeceved++;
				ken.deleteMax();
			}else{
				sz = ken.size();
				dNa3 = ken.select(sz-1);
				if(dNa3 != null){
					ken.deleteMax();
				
				}else{
					if(na3[idx] > dMax){
						totalDeceved++;
					}
					ken.deleteMax();
				}					
			}			
		}
		
		return totalDeceved;
	}

	private int playFair(RBT<Double, Double> abl, double[] na3, int N) {
		
		int totalNa3 = 0;
		Double double1;
		for (int idx = 0; idx < N ; idx++) {
			
			double1 = abl.ceil(na3[idx]);				
			if(double1!= null){
				abl.delete(double1);
			}else{
				totalNa3 ++;
				abl.deleteMin();
			}					
		}
		
		return totalNa3;
	}


	class RBT<K extends Comparable<K>, V>  {

		private static final boolean RED = true;
		private static final boolean BLACK = false;

		class Node {
			V val;
			K key;
			Node left, right;
			boolean color;
			int sz = 0;

			public Node(K key, V val, int sz, boolean clr) {
				this.key = key;
				this.val = val;
				this.color = clr;
				this.sz = sz;
			}
		}

		Node root = null;

		public RBT() {

		}

		public void put(K key, V val) {
			root = put(root, key, val);
			if(root!=null)root.color = BLACK;
		}

		private Node put(Node x, K key, V val) {
			if (x == null)
				return new Node(key, val, 1, RED);

			int cmp = key.compareTo(x.key);
			if (cmp < 0)
				x.left = put(x.left, key, val);
			else if (cmp > 0)
				x.right = put(x.right, key, val);
			else
				x.val = val;

			// coloring steps
			if (isRed(x.right) && !isRed(x.left))
				x = rotateLeft(x);
			if (isRed(x.left) && isRed(x.left.left))
				x = rotateRight(x);
			if (isRed(x.left) && isRed(x.right))
				flipColor(x);

			x.sz = 1 + size(x.left) + size(x.right);
			return x;
		}

			
		private Node colorFlip(Node x) {
			if(x == null) return x;
			x.color = !x.color;
			if(x.left != null)x.left.color = !x.left.color;
			if(x.right != null)x.right.color = !x.right.color;
			return x;
		}

		private Node fixUp(Node h) {
			
			if (isRed(h.right)) 					h = rotateLeft(h);		
			if (isRed(h.left) && isRed(h.left.left))h = rotateRight(h);
			if (isRed(h.left) && isRed(h.right))	colorFlip(h);
			return h;
		}

		private Node moveRedRight(Node h) {
			colorFlip(h);
			if (isRed(h.left.left)) {
				h = rotateRight(h);
				colorFlip(h);
			}
			return h;
		}

		public void deleteMax() {
			root = deleteMax(root);
			if(root!=null)root.color = BLACK;
		}

		private Node deleteMax(Node h) {
			if (isRed(h.left)) h = rotateRight(h);
			
			if (h.right == null)return null;
			
			if (!isRed(h.right) && !isRed(h.right.left))
				h = moveRedRight(h);
			
			h.right = deleteMax(h.right);
			
			h.sz = 1 + size(h.left) + size(h.right);//
			return fixUp(h);
		}

		private Node moveRedLeft(Node h) {
			colorFlip(h);
			if (h.right!=null &&isRed(h.right.left)) {
				h.right = rotateRight(h.right);
				h = rotateLeft(h);
				colorFlip(h);
			}
			return h;
		}

		 
		public void deleteMin() {
			root = deleteMin(root);
			if(root!=null)root.color = BLACK;
		}

		private Node deleteMin(Node h) {
			if (h.left == null)
				return null;
			if (!isRed(h.left) && !isRed(h.left.left))
				h = moveRedLeft(h);
			h.left = deleteMin(h.left);
			h.sz = 1 + size(h.left) + size(h.right);//
			return fixUp(h);
		}

		 
		public void delete(K k) {
			root = delete(root, k);
			if(root!= null)root.color = BLACK;
		}

		private Node delete(Node h, K key) {
			if(h == null) return null;
			if (key.compareTo(h.key) < 0) {
				if (!isRed(h.left) && !isRed(h.left.left))
					h = moveRedLeft(h);
				h.left = delete(h.left, key);
			} else {
				if (isRed(h.left))
					h = rotateRight(h);
				if (key.compareTo(h.key) == 0 && (h.right == null))
					return null;
				if (h.right!=null && !isRed(h.right) && !isRed(h.right.left))
					h = moveRedRight(h);
				if (key.compareTo(h.key) == 0) {
					h.key = min(h.right).key;
					h.val = get(h.right, h.key);
					h.right = deleteMin(h.right);
				} else
					h.right = delete(h.right, key);
			}
			h.sz = 1 + size(h.left) + size(h.right);//
			return fixUp(h);
		}


		
		private boolean isRed(Node h) {
			if (h == null)
				return BLACK;
			return h.color;
		}

		private Node rotateLeft(Node h) {
			Node x = h.right;
			h.right = x.left;
			x.left = h;
			x.color = h.color;
			h.color = RED;
			x.sz = h.sz;
			h.sz = 1 + size(h.left) + size(h.right);
			return x;
		}

		private Node rotateRight(Node h) {
			Node x = h.left;
			h.left = x.right;
			x.right = h;
			x.color = h.color;
			h.color = RED;
			x.sz = h.sz;
			h.sz = 1 + size(h.left) + size(h.right);
			return x;
		}

		private void flipColor(Node h) {
//			h.color = RED;
//			h.left.color = BLACK;
//			h.right.color = BLACK;
			if(h == null) return;
			h.color = !h.color;
			if(h.left!= null)h.left.color = !h.left.color ;
			if(h.right!=null)h.right.color = !h.right.color ;
		}

		 
		public V get(K key) {
			Node x = root;
			while (x != null) {
				int cmp = key.compareTo(x.key);
				if (cmp < 0)
					x = x.left;
				else if (cmp > 0)
					x = x.right;
				else
					return x.val;
			}
			return null;
		}

		private V get(Node h, K k) {
			if (h == null)
				return null;
			int cmp = k.compareTo(h.key);
			if (cmp < 0)
				return get(h.left, k);
			else if (cmp > 0)
				return get(h.right, k);
			else
				return h.val;
		}

		 
		public boolean contains(K key) {
			return get(key) != null;
		}

		 
		public int size() {
			return size(root);
		}

		private int size(Node h) {
			if (h == null)
				return 0;
			return h.sz;
		}

		 
		public boolean isEmpty() {
			return size() == 0;
		}

		 
		public K min() {
			return min(root).key;
		}

		private Node min(Node x) {
			if (x == null)
				return null;
			while (x.left != null)
				x = x.left;
			return x;
		}

		 
		public K max() {
			Node x = root;
			if (x == null)
				return null;
			while (x.right != null)
				x = x.right;
			return x.key;
		}

		 
		public K floor(K x) {
			Node t = floor(root, x);
			if (t == null)
				return null;
			return t.key;
		}

		private Node floor(Node h, K k) {
			if (h == null)
				return null;

			int cmp = k.compareTo(h.key);
			if (cmp == 0)
				return h;
			if (cmp < 0)
				return floor(h.left, k);
			Node t = floor(h.right, k);
			if (t != null)
				return t;
			else
				return h;
		}

		 
		public K ceil(K k) {
			Node x = ceil(root, k);
			if (x == null)
				return null;
			return x.key;
		}

		private Node ceil(Node h, K k) {
			if (h == null)
				return null;
			int cmp = k.compareTo(h.key);
			if (cmp == 0)
				return h;
			else if (cmp > 0)
				return ceil(h.right, k);
			Node x = ceil(h.left, k);
			if (x != null)
				return x;
			else
				return h;
		}

		 
		public int rank(K k) {
			int r =  rank(root, k);
			return (r>0)?r:-1;
		}

		private int rank(Node h, K k) {
			// one based
			if (h == null || k == null)
				return 0;// -1 * size(root);
			int cmp = k.compareTo(h.key);
			if (cmp == 0)
				return 1 + size(h.left);
			else if (cmp < 0)
				return rank(h.left, k);
			else
				return 1 + size(h.left) + rank(h.right, k);
		}

		 
		public K select(int r) {
			return select(root, r);
		}

		private K select(Node h, int r) {
			if (h == null)
				return null;

			int sz = 1 + size(h.left);
			if (r == sz)
				return h.key;
			else if (r < sz)
				return select(h.left, r);
			else
				return select(h.right, r - sz);

		}

		
		 
		public void print(){
			StringBuffer sb = new StringBuffer();
			print(root, sb, " ");
			System.out.println(sb);
		}

		private void print(Node x, StringBuffer sb, String out) {
			if(x == null )return;
			
			print(x.right, sb, out+" -");
			sb.append(out+x.val+((x.color)?")":"")+"\n\n");
			print(x.left, sb, out+" -");
		}

		 
		public int size(K lo, K hi) {
			int r1 = rank(ceil(lo));
			int r2 = rank(floor(hi));
			return r2 - r1 +1;
//			if(contains(hi)) return r2 - r1 + 1;
//			else return r2 - r1;
		}

		public Iterable<K> keys() {
			Queue<K> q = new LinkedList<K>();
			inOrder(root, q);
			return q;
		}

		 
		public Iterable<K> keys(K lo, K hi) {
			Queue<K> q = new LinkedList<K>();
			inOrder(root, q, lo, hi);		
			return q;
		}

		private void inOrder(Node x, Queue<K> q, K lo, K hi) {
			if ( x == null) return;

			int c1 = lo.compareTo(x.key);
			int c2 = hi.compareTo(x.key);
			
			if( c1 <= 0 && c2 >=0){//in range
				inOrder(x.left, q, lo, hi);
				q.add(x.key);
				inOrder(x.right, q, lo, hi);
			}
			else if (c1 > 0) inOrder(x.right, q, lo, hi);
			else if (c2 < 0) inOrder(x.left, q, lo, hi);
					
		}

		private void inOrder(Node h, Queue<K> q) {
			if (h == null)
				return;
			inOrder(h.left, q);
			q.add(h.key);
			inOrder(h.right, q);
		}

	}

}
