/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package tictactoc;

import com.sun.org.apache.xalan.internal.xsltc.compiler.Template;
import java.io.BufferedInputStream;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;

/**
 *
 * @author Peter
 */
public class TicTacToc {

    enum State {

        Blank, X, O, T
    };
    static int n = 4;
    static char[][] board = new char[n][n];
    static int moveCount;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        File file = new File("A-large.in");
        FileInputStream fis = null;
        BufferedInputStream bis = null;
        DataInputStream dis = null;

        try {
            fis = new FileInputStream(file);
            // Here BufferedInputStream is added for fast reading.
            bis = new BufferedInputStream(fis);
            dis = new DataInputStream(bis);

            FileWriter fstream = new FileWriter("output.txt");
            BufferedWriter out = new BufferedWriter(fstream);

            String line, output;
            line = dis.readLine();
            int testCases = Integer.parseInt(line);
            int i, j, count = 1, c = 0;
            char movevalue = 0;
            int state = 0;
            boolean win = false;
            char[][] tempBoard = new char[n][n];
            // dis.available() returns 0 if the file does not have more lines.
            while (dis.available() != 0) {
                output = "Case #" + count + ": ";
                initBoard();
                System.out.println("*********temp board***********");
                for (i = 0; i < 4; i++) {
                    line = dis.readLine();
                    for (j = 0; j < 4; j++) {
                        tempBoard[i][j] = line.charAt(j);
                        if (tempBoard[i][j] == 'T') {
                            board[i][j] = tempBoard[i][j];
                            moveCount++;
                        }
                        System.out.print(tempBoard[i][j] + " ");
                    }
                    System.out.println("");
                }

                for (i = 0; i < 4; i++) {
                    for (j = 0; j < 4; j++) {
                        movevalue = tempBoard[i][j];
                        if (movevalue == 'X' || movevalue == 'O') {
                            state = Move(i, j, movevalue);
                            if (state == 1) {
                                win = true;
                                break;
                            }
                        }
                    }
                    if(win)
                        break;
                }

                if (state == 1) {
                    if (movevalue == 'X') {
                        output += "X won";
                    } else if (movevalue == 'O') {
                        output += "O won";
                    }
                } else if (state == 2) {
                    output += "Draw";
                } else if (state == 3) {
                    output += "Game has not completed";
                }
                line = dis.readLine();
                out.append(output + "\n");
                win = false;
                state = 3;
                count++;
            }
            // dispose all the resources after using them.
            fis.close();
            bis.close();
            dis.close();
            out.close();

        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void initBoard() {
        moveCount = 0;
        
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                board[i][j] = '.';
            }
        }
    }

    public static int Move(int x, int y, char move) {
        if (board[x][y] == '.') {
            board[x][y] = move;
        }
        moveCount++;

        //check end conditions

        //check col
        for (int i = 0; i < n; i++) {
            if (board[x][i] != move && board[x][i] != 'T') {
                break;
            }
            if (i == n - 1) {
                //report win for s
                return 1;
            }
        }

        //check row
        for (int i = 0; i < n; i++) {
            if (board[i][y] != move && board[x][i] != 'T') {
                break;
            }
            if (i == n - 1) {
                //report win for s
                return 1;
            }
        }

        //check diag
        if (x == y) {
            //we're on a diagonal
            for (int i = 0; i < n; i++) {
                if (board[i][i] != move && board[x][i] != 'T') {
                    break;
                }
                if (i == n - 1) {
                    //report win for s
                    return 1;
                }
            }
        }

        //check anti diag (thanks rampion)
        for (int i = 0; i < n; i++) {
            if (board[i][(n - 1) - i] != move && board[i][(n - 1) - i] != 'T') {
                break;
            }
            if (i == n - 1) {
                //report win for s
                return 1;
            }
        }

        //check draw
        if (moveCount == (n * n)) {
            //report draw
            return 2;
        }
        return 3;
    }
}
