package themepark;

import java.io.BufferedInputStream;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;
import java.util.Queue;

/**
 * 8-5-2010 google code jam
 * @author peter
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        File file = new File("C:\\Users\\peter\\Documents\\code jam\\Problem2\\C-small-attempt0.in");
        FileInputStream fis = null;
        BufferedInputStream bis = null;
        DataInputStream dis = null;

        try {
            fis = new FileInputStream(file);
            // Here BufferedInputStream is added for fast reading.
            bis = new BufferedInputStream(fis);
            dis = new DataInputStream(bis);

            FileWriter fstream = new FileWriter("C:\\Users\\peter\\Documents\\code jam\\Problem2\\output1.txt");
            BufferedWriter out = new BufferedWriter(fstream);

            String line, output;
            line = dis.readLine();
            int testCases = Integer.parseInt(line);
            int R, K, N, x, temp, index;
            // dis.available() returns 0 if the file does not have more lines.
            for (int i = 1; i <= testCases; i++) {
                output = "Case #" + i + ": ";

                line = dis.readLine();
                R = Integer.parseInt(line.substring(0, line.indexOf(" ")));
                line = line.substring(line.indexOf(" ") + 1, line.length());
                K = Integer.parseInt(line.substring(0, line.indexOf(" ")));
                N = Integer.parseInt(line.substring(line.lastIndexOf(" ") + 1, line.length()));
                int[] groups = new int[N];
                line = dis.readLine();
                Queue<Integer> queue = new LinkedList();
                for (int j = 0; j < N; j++) {
                    index = line.indexOf(" ");
                    if (index == -1) {
                        index = line.length();
                    }
                    queue.add(Integer.parseInt(line.substring(0, index)));
                    if (j < N - 1) {
                        line = line.substring(line.indexOf(" ") + 1, line.length());
                    }
                }
                int profit = calcProfit(R, K, queue);
                output += profit;
                out.append(output + "\n");
                output = "";
            }
            // dispose all the resources after using them.
            fis.close();
            bis.close();
            dis.close();
            out.close();

        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static int calcProfit(int R, int K, Queue<Integer> queue) {
        Integer x, count = 0;
        int price = 1;
        int profit = 0;
        int groupNo = 0;
        for (int i = 0; i < R; i++) {
            while (count < K && groupNo < queue.size()) {
                x = queue.peek();
                if (count + x <= K) {
                    x = queue.poll();
                    groupNo++;
                    count += x;
                    queue.add(x);
                }else{
                    break;
                }
            }
            profit += count * price;
            count = 0;
            groupNo = 0;
        }
        return profit;
    }
}
