import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.PriorityQueue;

public class Main {

    private static final boolean     DEBUG = false;
    private static LightReader       reader;
    private static final PrintStream out   = System.out;

    private static final int         I     = 2;
    private static final int         J     = 3;
    private static final int         K     = 4;
    private static final int[][]     TABLE = {//
                                              //
            { 0, 0, 0, 0, 0 }, //
            { 0, 1, I, J, K },//
            { 0, I, 1, K, J },//
            { 0, J, K, 1, I },//
            { 0, K, J, I, 1 }             };
    private static final int[][]     SIGNS = {//
                                              //
            { 1, 1, 1, 1, 1 }, //
            { 1, 1, 1, 1, 1 },//
            { 1, 1, -1, 1, -1 },//
            { 1, 1, -1, -1, 1 },//
            { 1, 1, 1, -1, -1 },//

                                           };

    public static boolean calculate(int L, int X, char[] chars) {
        int LX = L * X;
        if (LX < 3) { return false; }
        if (X > 1) {
            char[] newChars = new char[LX];
            for (int i = 0; i < LX; i++) {
                newChars[i] = chars[i % L];
            }
            chars = newChars;
            X = 1;
            L = LX;
        }
        int[] reverseVals = new int[L];
        int[] reverseSigns = new int[L];

        int pValue = chars[L - 1] - 'g';
        int sign = 1;
        reverseVals[L - 1] = pValue;
        reverseSigns[L - 1] = sign;
        for (int i = L - 2; i >= 0; i--) {
            int value = chars[i] - 'g';
            sign *= SIGNS[value][pValue];
            pValue = TABLE[value][pValue];

            reverseVals[i] = pValue;
            reverseSigns[i] = sign;

        }

        int[] forwardVals = new int[L];
        int[] forwardSigns = new int[L];
        sign = 1;
        pValue = chars[0] - 'g';
        forwardVals[0] = pValue;
        forwardSigns[0] = sign;
        for (int i = 1; i < L; i++) {
            int value = chars[i] - 'g';
            sign *= SIGNS[pValue][value];
            pValue = TABLE[pValue][value];
            forwardVals[i] = pValue;
            forwardSigns[i] = sign;

        }
        for (int i = 0; i < L - 2; i++) {
            if (forwardSigns[i] > 0 && forwardVals[i] == I) {
                /* FOUND i */
                int prod = chars[i + 1] - 'g';
                int sig = 1;
                if (prod == J) {
                    /* FOUND J */
                    if (reverseSigns[i + 2] > 0 && reverseVals[i + 2] == K) {
                        /* FOUND K */
                        return true;
                    }
                }
                for (int j = i + 2; j < L - 1; j++) {
                    int value = chars[j] - 'g';
                    sig *= SIGNS[prod][value];
                    prod = TABLE[prod][value];
                    if (prod == J && sig > 0) {
                        /* FOUND J */
                        if (reverseSigns[j + 1] > 0 && reverseVals[j + 1] == K) {
                            /* FOUND K */
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }

    public static void processCase() {
        int L = reader.nextInt();
        int X = reader.nextInt();
        String input = reader.nextString();
        char[] chars = input.toCharArray();
        boolean result = calculate(L, X, chars);
        if (result) {
            System.out.println("YES");
        } else {
            System.out.println("NO");
        }

    }

    public static void process() {
        int T = reader.nextInt();
        for (int i = 1; i <= T; i++) {
            out.print("Case #" + i + ": ");
            processCase();
        }
    }

    public static void main(String[] argv) {
        reader = new LightReader(System.in);
        process();
        // System.out.println(calculate(2, 6, new char[] { 'j', 'i',}));
    }

    /**
     * Opens a fileInputStream to the given file
     *
     * @param path
     * @throws RuntimeException
     */
    public static FileInputStream openFileStream(String path) {
        File f = new File(path);
        try {
            return new FileInputStream(f);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

}
