import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.PriorityQueue;

public class Main {
    private static LightReader         reader;
    private static final PrintStream   out    = System.out;
    private static final boolean[][][] MATRIX = new boolean[5][5][5];

    static {
        MATRIX[1][1][1] = false;
        MATRIX[1][1][2] = true;
        MATRIX[1][1][3] = true;
        MATRIX[1][1][4] = true;

        MATRIX[1][2][1] = false;
        MATRIX[1][2][2] = false;
        MATRIX[1][2][3] = true;
        MATRIX[1][2][4] = true;

        MATRIX[1][3][1] = false;
        MATRIX[1][3][2] = true;
        MATRIX[1][3][3] = true;
        MATRIX[1][3][4] = true;

        MATRIX[1][4][1] = false;
        MATRIX[1][4][2] = false;
        MATRIX[1][4][3] = true;
        MATRIX[1][4][4] = true;

        MATRIX[2][2][1] = false;
        MATRIX[2][2][2] = false;
        MATRIX[2][2][3] = true;
        MATRIX[2][2][4] = true;

        MATRIX[2][3][1] = false;
        MATRIX[2][3][2] = false;
        MATRIX[2][3][3] = false;
        MATRIX[2][3][4] = true;

        MATRIX[2][4][1] = false;
        MATRIX[2][4][2] = false;
        MATRIX[2][4][3] = true;
        MATRIX[2][4][4] = true;

        MATRIX[3][3][1] = false;
        MATRIX[3][3][2] = true;
        MATRIX[3][3][3] = false;
        MATRIX[3][3][4] = true;

        MATRIX[3][4][1] = false;
        MATRIX[3][4][2] = false;
        MATRIX[3][4][3] = false;
        MATRIX[3][4][4] = false;

        MATRIX[4][4][1] = false;
        MATRIX[4][4][2] = false;
        MATRIX[4][4][3] = true;
        MATRIX[4][4][4] = false;

    }

    public static boolean calculate(int R, int C, int X) {
        int min = R < C ? R : C;
        int max = R + C - min;
        return MATRIX[min][max][X];
    }

    public static void processCase() {
        int X = reader.nextInt();
        int R = reader.nextInt();
        int C = reader.nextInt();
        if (calculate(R, C, X)) {
            System.out.println("RICHARD");
        } else {
            System.out.println("GABRIEL");

        }

    }

    public static void process() {
        int T = reader.nextInt();
        for (int i = 1; i <= T; i++) {
            out.print("Case #" + i + ": ");
            processCase();
        }
    }

    public static void main(String[] argv) {
        reader = new LightReader(System.in);
        process();
    }

    /**
     * Opens a fileInputStream to the given file
     *
     * @param path
     * @throws RuntimeException
     */
    public static FileInputStream openFileStream(String path) {
        File f = new File(path);
        try {
            return new FileInputStream(f);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

}
