
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class LightReader {
    private static final boolean DEBUG     = false;
    private static final String  DELIMS    = " \t\n\r\f";
    private BufferedReader       reader;
    private StringTokenizer      tokenizer = new StringTokenizer("", DELIMS);
    private boolean              hasError  = false;

    public LightReader(InputStream in) {
        reader = new BufferedReader(new InputStreamReader(in));
    }

    public boolean hasError() {
        return hasError;
    }

    public boolean hasNext() {
        checkTokenizer();
        return tokenizer.hasMoreTokens();
    }

    public int nextInt() {
        checkTokenizer();
        return Integer.parseInt(tokenizer.nextToken());
    }

    public String nextString() {
        checkTokenizer();
        return tokenizer.nextToken();
    }

    public int[] readInts(int count) {
        int[] array = new int[count];
        for (int i = 0; i < count; i++) {
            array[i] = nextInt();
        }
        return array;
    }

    private void checkTokenizer() {
        if (!tokenizer.hasMoreTokens()) {
            String line = null;
            try {
                line = reader.readLine();
            } catch (IOException e) {
                if (DEBUG) {
                    System.out.println("IO Error" + e);
                }
                hasError = true;
            }
            if (line != null) {
                tokenizer = new StringTokenizer(line, DELIMS);
            }
        }
    }
}