import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.PriorityQueue;

public class Main {

    private static final boolean     DEBUG = false;
    private static LightReader       reader;
    private static final PrintStream out   = System.out;

    public static int calculate(int diners[], int idx) {
        int splits = 0;
        int currentTime = 0;
        int minTime = Integer.MAX_VALUE;
        while (idx >= 1) {
            int count = diners[idx];
            while (count == 0 && idx > 1) {
                count = diners[idx - 1];
                idx--;
            }
            currentTime = idx + splits;
            if (currentTime < minTime) {
                minTime = currentTime;
            } else if (idx == 1 && count > 0) {
                minTime = (splits + 1) < minTime ? splits + 1 : minTime;
                break;
            } else if (idx == 1) {
                break;
            }

            int a = idx / 2;
            int b = idx - a;

            diners[idx] = 0;
            diners[a] += count;
            diners[b] += count;

            splits += count;
            idx--;
        }
        return minTime;
    }

    public static void processCase() {
        int D = reader.nextInt();
        int maxDinerTypes = 1000 + 1;
        int idx = 0;
        int[] diners = new int[maxDinerTypes];
        for (int i = 0; i < D; i++) {
            int in = reader.nextInt();
            idx = in > idx ? in : idx;
            diners[in]++;
        }
        int value = calculate(diners, idx);
        System.out.println(value);

    }

    public static void process() {
        int T = reader.nextInt();
        for (int i = 1; i <= T; i++) {
            out.print("Case #" + i + ": ");
            processCase();
        }
    }

    public static void main(String[] argv) {
        reader = new LightReader(System.in);
        process();
    }

    /**
     * Opens a fileInputStream to the given file
     *
     * @param path
     * @throws RuntimeException
     */
    public static FileInputStream openFileStream(String path) {
        File f = new File(path);
        try {
            return new FileInputStream(f);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

}
