import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;


public class RPI {
	static ArrayList<String> teamRecords = new ArrayList<String>();
	static int numTeams;
	
	public static void main(String[] args) {
		try {
			BufferedReader in = new BufferedReader(new FileReader("A-small-attempt0.in"));
			FileWriter out = new FileWriter("A-small-attempt0.out");
			int numCases = Integer.parseInt(in.readLine());
			for(int i = 1; i <= numCases; i++)
			{
				out.write("Case #" + i + ":\n");
				numTeams = Integer.parseInt(in.readLine());
				for(int q = 0; q < numTeams; q++)
				{
					teamRecords.add(in.readLine());
				}
				ArrayList<Double> wPS = new ArrayList<Double>();
				for(String s : teamRecords)
				{
					wPS.add(calcWinPercent(s));
				}
				ArrayList<Double> oPS = new ArrayList<Double>();
				for(int q = 0; q < numTeams; q++)
				{
					oPS.add(calcOpWinPercent(teamRecords.get(q), q));
				}
				for(int q = 0; q < numTeams; q++)
				{
					double rPI = 0;
					rPI = (.25 * wPS.get(q)) + (.5 * oPS.get(q));
					
					String curTeamRecord = teamRecords.get(q);
					char[] chars = curTeamRecord.toCharArray();
					double sum = 0;
					int numTeam = 0;
					for(int z = 0; z < numTeams; z++)
					{
						if(chars[z] == '.')
							continue;
						else
						{
							sum = sum + oPS.get(z);
							numTeam++;
						}
					}
					rPI += (.25 * (sum/numTeam));
					out.write("" + rPI + "\n");
				}
				teamRecords.clear();
			}	
			out.close();
		} catch (Exception e)
		{
			e.printStackTrace();
		}

}

	private static Double calcOpWinPercent(String string, int teamNum) {
		String curTeamRecord = string;
		char[] chars = curTeamRecord.toCharArray();
		double wins = 0;
		int numTeam = 0;
		for(int i=0; i < numTeams; i++)
		{
			if(chars[i] == '.')
				continue;
			else
			{
				String curTeamRecord2 = teamRecords.get(i);
				char[] chars2 = curTeamRecord2.toCharArray();
				int wins2 = 0;
				int numTeam2 = 0;
				for(int j = 0; j < numTeams; j++)
				{
					if(j == teamNum)
						continue;
					if(chars2[j] == '.')
						continue;
					if(chars2[j] == '0')
					{
						numTeam2++;
					}
					if(chars2[j] == '1')
					{
						wins2++;
						numTeam2++;
					}
				}
				wins = wins + (((double)wins2)/numTeam2);
				numTeam++;
			}
		}
		return (wins/numTeam);
	}

	private static Double calcWinPercent(String s) {
			String curTeamRecord = s;
			char[] chars = curTeamRecord.toCharArray();
			int wins = 0;
			int numTeam = 0;
			for(char c : chars)
			{
				if(c == '.')
					continue;
				if(c == '0')
				{
					numTeam++;
				}
				if(c == '1')
				{
					wins++;
					numTeam++;
				}
			}
			return (((double)(wins))/numTeam);
		}
	}
