import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class StableCircular {

	private static final char[] inx = {'R', 'O', 'Y', 'G', 'B', 'V'};
	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int t = in.nextInt();
		for (int i = 1; i <= t; ++i) {
			// N, R, O, Y, G, B, and V
			int N = in.nextInt();
			int[] us = new int[6];
			for (int j = 0; j < inx.length; j++) {
				int count = in.nextInt();
				us[j] = count;
				makeMap(inx[j]);
			}
			String ret = null;
			if(maxValid(N, us)) {
				ret = getStable(N, us);
			} else {
				ret = "IMPOSSIBLE";
			}
			System.out.println("Case #" + i + ": " + ret);
		}
		in.close();
	}

	private static boolean maxValid(int N, int[] u) {
		int max = N/2;
		/*
		 	A mane with red and yellow hairs appears orange.
			A mane with yellow and blue hairs appears green.
			A mane with red and blue hairs appears violet
		 */
		// {0, 1, 2, 3, 4, 5}
		// {R, O, Y, G, B, V}
		// r+v
		if(u[0]+u[5] > max) return false;
		// r+o
		if(u[0]+u[1] > max) return false;
		// y+o
		if(u[1]+u[2] > max) return false;
		// y+g
		if(u[2]+u[3] > max) return false;
		// b+g
		if(u[3]+u[4] > max) return false;
		// b+v
		if(u[4]+u[5] > max) return false;
		return true;
	}
	
	private static int getIdx(char c) {
		// {0, 1, 2, 3, 4, 5}
		// {R, O, Y, G, B, V}
		switch (c) {
		case 'R':
			return 0;
		case 'O':
			return 1;
		case 'Y':
			return 2;
		case 'G':
			return 3;
		case 'B':
			return 4;
		case 'V':
			return 5;
		default:
			return -1;
		}
	}
	
	private static Map<Character, int[]> friendMap = new HashMap<>();
	private static void makeMap(char c) {
		friendMap.put(c, getFriends(c));
	}
	private static int[] getFriends(char c) {
		// {0, 1, 2, 3, 4, 5}
		// {R, O, Y, G, B, V}
		switch (c) {
		case 'R':
			return new int[]{getIdx('Y'),getIdx('B'),getIdx('G')};
		case 'O':
			return new int[]{getIdx('B')};
		case 'Y':
			return new int[]{getIdx('R'),getIdx('B'),getIdx('V')};
		case 'G':
			return new int[]{getIdx('R')};
		case 'B':
			return new int[]{getIdx('R'),getIdx('Y'),getIdx('O')};
		case 'V':
			return new int[]{getIdx('Y')};
		}
		return null;
	}
	
	
	private static String getStable(int N, int[] u) {
		char start = inx[0];
		for (int i = 0; i < inx.length; i++) {
			if(u[i] > 0) {
				start = inx[i];
				break;
			}
		}
		char[] horses = new char[N];
		boolean stablize = stablize(horses, 0, start, u);
		if(!stablize) return "IMPOSSIBLE";
		
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < horses.length; i++) {
			sb.append(horses[i]);
		}
		return sb.toString();
	}
/*	
4
6 2 0 2 0 2 0
3 1 0 2 0 0 0
6 2 0 1 1 2 0
4 0 0 2 0 0 2
*/
	private static boolean stablize(char[] horses, int idx, char c, int[] u) {
		horses[idx] = c;
		u[getIdx(c)] = u[getIdx(c)] - 1;
		if(idx == horses.length -1) {
			int[] is = friendMap.get(c);
			for (int i = 0; i < is.length; i++) {
				if(inx[is[i]] == horses[0])
					return true;
			}
			return false;
		}
		boolean ret = false;
		int[] is = friendMap.get(c);
		for (int i = 0; i < is.length; i++) {
			if(u[is[i]] > 0) {
				int i1 = getIdx(c);
				int i2 = is[i];
				int idx1 = idx+1;
				while(u[i1] > 1 && u[i2] > 1) {
					horses[idx1] = inx[i2];
					u[i2] = u[i2] - 1;
					idx1++;
					horses[idx1] = inx[i1];
					u[i1] = u[i1] - 1;
					idx1++;
				}
				
				ret = stablize(horses, idx1, inx[i2], u);
				if(ret) {
					return true;
				}
			}
		}
		u[getIdx(c)] = u[getIdx(c)] + 1;
		return ret;
	}
}
