

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.Scanner;

public class BathroomStalls {
	public static void main(String[] args) {
		
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	    int t = in.nextInt(); 
	    for (int i = 1; i <= t; ++i) {
	      long n = in.nextLong();
	      long k = in.nextLong();
	      long[] tn = stalls(n, k);
		System.out.println("Case #" + i + ": " + tn[0] + " " + tn[1]);
	    }
	    in.close();
	}

	public static long[] stalls(long n, long k) {
		// 
		long[] ret = new long[]{n ,k};
		
		PriorityQueue<ABlock> q = new PriorityQueue<>(new Comparator<ABlock>() {
			@Override
			public int compare(ABlock o1, ABlock o2) {
				
				if(o2.getSize() == o1.getSize()) {
					return Long.compare(o1.beg, o2.beg);
				}
				return Long.compare(o2.getSize(), o1.getSize());
			}
		});
		
		q.add(new ABlock(0, n-1));
		ABlock x = null;
		for (long i = 0; i < k; i++) {
			x = q.remove();
			if(x.getSize() > 1) {
				if(x.getSize() == 2) {
					q.add(new ABlock(x.end, x.end));
				} else {
					long mid = x.beg + ((x.end - x.beg)/2);
					
					q.add(new ABlock(x.beg, mid - 1));
					q.add(new ABlock(mid + 1, x.end));
				}
			}
		}
		long l = 0;
		long r = 0;
		if(x.getSize() > 1) {
			if(x.getSize() == 2) {
				q.add(new ABlock(x.end, x.end));
				r = 1;
			} else {
				long mid = x.beg + ((x.end - x.beg)/2);
				l = new ABlock(x.beg, mid - 1).getSize();
				r = new ABlock(mid + 1, x.end).getSize();
			}
		}
		ret[0] = Math.max(l, r);
		ret[1] = Math.min(l, r);
		return ret;
	}
	public static class ABlock{
		long beg;
		long end;
		long size;
		public ABlock(long beg, long end) {
			this.beg = beg;
			this.end = end;
			size = end - beg + 1;
		}
		public long getSize() {
			return size;
		}
		@Override
		public String toString() {
			return getSize() + " " + beg + " " + end;
		}
	}
}
