

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.List;
import java.util.Scanner;

public class AmpleSyrup {

	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int t = in.nextInt();
		for (int i = 1; i <= t; ++i) {
			int N = in.nextInt();
			int K = in.nextInt();
			Pancake[] arr = new Pancake[N];
			for (int j = 0; j < N; j++) {
				double R = in.nextDouble();
				double H = in.nextDouble();
				arr[j] = new Pancake(R, H);
			}
			double maxA = getMaxA(arr, K);
			NumberFormat formatter = new DecimalFormat("#0.000000");   
			System.out.println("Case #" + i + ": " + formatter.format(Math.PI*maxA));
		}
		in.close();
	}
	
	private static double getMaxA(Pancake[] arr, int K) {
		Arrays.sort(arr, new Comparator<Pancake>() {
			@Override
			public int compare(Pancake o1, Pancake o2) {
				return Double.compare(o2.cya, o1.cya);
			}
		});
		
		Pancake[] rSort = Arrays.copyOf(arr, arr.length);
		Arrays.sort(rSort, new Comparator<Pancake>() {
			@Override
			public int compare(Pancake o1, Pancake o2) {
				return Double.compare(o2.topa, o1.topa);
			}
		});
		
		double maxTopA = 0;
		double maxA = 0;
		List<Pancake> sel = new ArrayList<>();
		for (int i = 0; i < K; i++) {
			sel.add(arr[i]);
			maxA += arr[i].cya;
			maxTopA = Math.max(maxTopA, arr[i].topa);
		}
		
		for (int i = 0; i < rSort.length; i++) {
			if(maxTopA >= rSort[i].topa || sel.contains(rSort[i])) {
				return maxA + maxTopA;
			}
			Pancake p = sel.get(sel.size() - 1);
			double repA = maxA - p.cya + rSort[i].cya;
			if((maxA+maxTopA) < (repA + rSort[i].topa)) {
				maxA = repA;
				maxTopA = rSort[i].topa;
				sel.remove(p);
				sel.add(rSort[i]);
			}
		}
		
		return maxA + maxTopA;
	}

	public static class Pancake {
		double r;
		double h;
		double cya;
		double topa;
		public Pancake(double r, double h) {
			this.r = r;
			this.h = h;
			cya = 2 * r * h;
			topa = r * r;
		}
	}
}
