import java.io.*;
import java.util.*;
import java.math.*;
 
public class Main
{
    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static Scanner sc = new Scanner(System.in);
    
    public static BigInteger val(BigInteger num, int b, int n)
    {
        BigInteger ret=BigInteger.ZERO;
        BigInteger base=BigInteger.valueOf(b);
        for(int i=n-1; i>=0; i--)
        {
            ret=ret.multiply(base);
            if(num.testBit(i)==true)
                ret=ret.add(BigInteger.ONE);
        } 
        return ret;
    }
    
    public static BigInteger exp(int b, int e)
    {
        if(e==0)
            return BigInteger.ONE;
        if(e%2==1)
            return BigInteger.valueOf(b).multiply(exp(b, e-1));
        BigInteger x=exp(b, e/2);
        return x.multiply(x);
    }
    
    public static int valid(BigInteger x)
    {
        for(int i=2; i<=100; i++)
        {
            if(x.compareTo(BigInteger.valueOf(i))==0)
                break;
            if(x.mod(BigInteger.valueOf(i)).compareTo(BigInteger.ZERO)==0)
                return i;
        }
        return 0;
    }
    
    public static void bin(BigInteger x, int n)
    {
        for(int i=n-1; i>=0; i--)
        {
            int y;
            if(x.testBit(i)==true)
                y=1;
            else
                y=0;
            System.out.printf("%d", y);
        }
        System.out.printf(" ");
    }
    
    public static void solve(int n, int m)
    {
        int ans[] = new int[15];
        for(BigInteger num=exp(2, n).subtract(BigInteger.ONE); m>0; num=num.subtract(BigInteger.ONE))
        {
            if(num.testBit(0)==false || num.testBit(n-1)==false)
                continue;
            
            boolean flag=true;
            for(int j=2; j<=10 && flag==true; j++)
            {
                BigInteger x=val(num, j, n);
                int y=valid(x);
                if(y>0)
                {
                    ans[j]=y;
                }
                else
                {
                    flag=false;
                }
            }
            if(flag)
            {
                bin(num, n);
                for(int i=2; i<=10; i++)
                {
                    if(i>2)
                        System.out.printf(" ");
                    System.out.printf("%d", ans[i]);
                }
                System.out.println();
                m--;
            }
        }
    }
    
    public static void main(String[] args) throws Exception
    {      
        int tt=sc.nextInt();
        for(int t=1; t<=tt; t++)
        {
            int n=sc.nextInt();
            int m=sc.nextInt();
            
            System.out.println("Case #"+t+":");
            solve(n, m);
        }
    }
}