package com.goose.qualification;

import java.io.*;
import java.util.StringTokenizer;

import static java.lang.Double.parseDouble;
import static java.lang.Integer.parseInt;
import static java.lang.Long.parseLong;
import static java.lang.System.exit;

/**
 * Created by michal on 08.04.2017.
 */
public class TidyNumbers {

    static BufferedReader in;
    static PrintWriter out;
    static StringTokenizer tok;

    static int numOfTests;
    static int caseNum;

    //brute force
    public static boolean isTidy(long N) {
        if(N < 10) { return true; }
        String number = String.valueOf(N);
        char[] digits = number.toCharArray();

        for(int index = 0; index < digits.length - 1; index++) {
            if(digits[index] > digits[index+1]) { return false; }
        }
        return true;

    }

    public static long lastTidyNumber(long N) {
        long candidateTidyNumber = N;

        while (!isTidy(candidateTidyNumber)) {
            candidateTidyNumber--;
        }
        return candidateTidyNumber;
    }

    public static boolean isTidyLocally(char[] digits, int start) {
        if(digits.length < 2) { return true; }

        return digits[start] <= digits[start+1];
    }

    public static void makeItTidy(char[] digits, int atIndex) {
        digits[atIndex]--;
        for(int i = atIndex + 1; i < digits.length;i++) {
            digits[i] = '9';
        }
    }


    public static char[] lastTidyNumber(char[] digits) {
        char[] candidateTidyNumber = digits.clone();

        for(int index = candidateTidyNumber.length - 2; index >=0; index--) {
            if(!isTidyLocally(candidateTidyNumber, index)) {
                makeItTidy(candidateTidyNumber, index);
            }
        }

        return candidateTidyNumber;
    }

    public static void solve() throws IOException {
        printCase();
        long N = nextLong();
        String number = String.valueOf(N);
        char[] digits = number.toCharArray();
        char[] candChars = lastTidyNumber(digits);
        long outN = Long.valueOf(new String(candChars));


        out.print(outN);
    }

    static void printCase() {
        out.print("Case #" + caseNum + ": ");
    }

    static void printlnCase() {
        out.println("Case #" + caseNum + ": ");
    }

    static int nextInt() throws IOException {
        return parseInt(next());
    }

    static long nextLong() throws IOException {
        return parseLong(next());
    }

    static double nextDouble() throws IOException {
        return parseDouble(next());
    }

    static String next() throws IOException {
        while(tok == null || !tok.hasMoreTokens() ) {
            tok = new StringTokenizer(in.readLine());
        }
        return tok.nextToken();
    }

    public static void main(String[] args)  {

        try {
            in = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(new OutputStreamWriter(System.out));
            numOfTests = nextInt();

            for(caseNum = 1; caseNum <= numOfTests; caseNum++) {
                if(caseNum != 1) { out.print("\n"); }
                solve();
            }
            in.close();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            exit(1);
        }


    }
}
