package com.goose.qualification;

import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

import static java.lang.Double.parseDouble;
import static java.lang.Integer.parseInt;
import static java.lang.Long.parseLong;
import static java.lang.System.exit;

/**
 * Created by michal on 08.04.2017.
 */
public class OversizedPancakeFlipper {


    static BufferedReader in;
    static PrintWriter out;
    static StringTokenizer tok;

    static int numOfTests;
    static int caseNum;

    static char[] pancakeLine;


    public static boolean isHappySide(char c) {
        return c == '+';
    }

    public static boolean isBlankSide(char c) {
        return c == '-';
    }


    public static boolean isAllHappySide(char[] pancakes) {
        return isAllHappySide(pancakes, 0);
    }

    public static boolean isAllHappySide(char[] pancakes, int offset) {
        for (int i = offset; i < pancakes.length; i++) {
            if(isBlankSide(pancakes[i])) { return false; }
        }
        return true;
    }

    public static void flipPancake(char[] pancakes, int at) {
        char old = pancakes[at];
        pancakes[at] = old == '+' ? '-' : '+';
    }

    public static void flipPancakes(char[] pancakes, int at, int pancakeFlipperSize) {
        for(int i = at; i < at + pancakeFlipperSize;i++ ) {
            flipPancake(pancakes, i);
        }
    }


    public static void solve() throws IOException {
        printCase();
        String s = in.readLine();

        String[] args = s.split(" ");
        pancakeLine = args[0].toCharArray();
        int K = parseInt(args[1]);

        int pancakeSize = pancakeLine.length;

        int flips = 0;

        for(int indexOffset = 0; indexOffset<pancakeSize - K + 1;indexOffset++) {
            if(isHappySide(pancakeLine[indexOffset])) { continue; }

            flipPancakes(pancakeLine, indexOffset, K);
            flips++;
        }

        if(isAllHappySide(pancakeLine)) {
            out.print(flips);
        } else {
            out.print("IMPOSSIBLE");
        }

    }

    static void printCase() {
        out.print("Case #" + caseNum + ": ");
    }

    static void printlnCase() {
        out.println("Case #" + caseNum + ": ");
    }

    static int nextInt() throws IOException {
        return parseInt(next());
    }

    static long nextLong() throws IOException {
        return parseLong(next());
    }

    static double nextDouble() throws IOException {
        return parseDouble(next());
    }

    static String next() throws IOException {
        while(tok == null || !tok.hasMoreTokens() ) {
            tok = new StringTokenizer(in.readLine());
        }
        return tok.nextToken();
    }

    public static void main(String[] args)  {

        try {
            in = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(new OutputStreamWriter(System.out));
            numOfTests = nextInt();

            for(caseNum = 1; caseNum <= numOfTests; caseNum++) {
                //System.out.println(caseNum);
                if(caseNum != 1) { out.print("\n"); }
                solve();
            }
            in.close();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            exit(1);
        }


    }

}
