package com.goose;

import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.IntStream;

public class StandingOvation {

    public void writeSolutionToFile(String fileName) throws IOException {
        BufferedWriter bf = null;

        try {
            FileWriter fw = new FileWriter(fileName, false);
            bf = new BufferedWriter(fw);
            for(int i=1;i<solutions.size();i++) {
                bf.write("Case #" + i + ": " + solutions.get(i-1).toString());
                bf.newLine();
            }
            bf.write("Case #" + solutions.size() + ": " + solutions.get(solutions.size() - 1).toString());
        }finally {
            if(bf != null) {
                bf.close();
            }
        }
    }

    private Integer testCaseNum;

    private List<Integer[]> testCasesList;
    private List<Integer[]> cummulativeList;
    private List<Integer> solutions;

    public StandingOvation(String fileName) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader(fileName));

        try {
            StringBuilder sb = new StringBuilder();
            String line = br.readLine();
            this.testCaseNum = Integer.parseInt(line);
            testCasesList = new ArrayList<>(testCaseNum);
            cummulativeList = new ArrayList<>(testCaseNum);
            solutions = new ArrayList<>(testCaseNum);
            Integer n;
            String[] numList;
            Integer maxShyness;
            Integer item;
            String shynessLine;
            for(int caseNum=0;caseNum <testCaseNum;caseNum++) {
                line = br.readLine();
                numList = line.split(" ");
                shynessLine = numList[1];
                maxShyness = Integer.parseInt(numList[0]);
                testCasesList.add(new Integer[maxShyness + 1]);
                cummulativeList.add(new Integer[maxShyness + 1]);
                item = testCasesList.get(caseNum)[0] = Character.getNumericValue(shynessLine.charAt(0));
                cummulativeList.get(caseNum)[0] = item;
                for(int i =1;i <= maxShyness;i++) {
                    item = testCasesList.get(caseNum)[i] = Character.getNumericValue(shynessLine.charAt(i));
                    cummulativeList.get(caseNum)[i] = cummulativeList.get(caseNum)[i-1] + item;
                }
            }

        }finally {

        }

    }

    public void solve() {
        StringBuilder sb = new StringBuilder();
        //int[] personIndex;
        Integer maxShyness;
        Integer maxNeededPeople = 0;
        for (int i = 0; i < testCaseNum ; i++) {
            maxNeededPeople = 0;
            maxShyness = testCasesList.get(i).length - 1;
            //personIndex = IntStream.range(1, testCasesList.get(i).length + 1).toArray();
            for(int personIndex = 0; personIndex <= maxShyness;personIndex++) {
                maxNeededPeople = Math.max(maxNeededPeople, personIndex +  1 - cummulativeList.get(i)[personIndex] );
            }
            solutions.add(maxNeededPeople);
        }
    }


    public static void main(String[] args) throws IOException {
	    StandingOvation standingOvation = new StandingOvation("resources/A-large.in");
        standingOvation.solve();
        standingOvation.writeSolutionToFile("resources/A-large.out");
    }
}
