package qualify;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class SavingTheUniverse {
	
	public static void main(String[] args) {
		String path = args[0];
		int cont = 1;
		// Se procesa el archivo
		List<CentralSystem> testCases = fileToList(path);
		// Se ejecuta el algortimo por cada caso de prueba
		for (Iterator<CentralSystem> iterator = testCases.iterator(); iterator.hasNext(); ) {
			CentralSystem centralSystem = iterator.next();
			//int switchsNumber = processTestCase(centralSystem);
			int switchsNumber = process(centralSystem.getSearchEngines(), centralSystem.getIncomingQueries());
			System.out.println("Case #" + cont++ + ": " + switchsNumber);
		}
	}
	
	private static List<CentralSystem> fileToList(String path) {
		List<CentralSystem> testCases = new ArrayList<CentralSystem>();
		try {
			BufferedReader in = new BufferedReader(new FileReader(path));
			// Se lee el numero de casos
			String line = in.readLine();
			Integer cases = new Integer(line);
			// Por cada caso se procesa el archivo
			for (int i = 0; i < cases.intValue(); i++) {
				CentralSystem centralSystem = new CentralSystem();
				// Se lee el numero de motores de busqueda
				line = in.readLine();
				Integer searchEngines = new Integer(line);
				// Se procesan los motores de busqueda
				for (int j = 0; j < searchEngines.intValue(); j++) {
					line = in.readLine();
					centralSystem.getSearchEngines().add(line);
				}
				// Se lee el numero de consultas
				line = in.readLine();
				Integer incomingQueries = new Integer(line);
				// Se procesan las consultas
				for (int k = 0; k < incomingQueries.intValue(); k++) {
					line = in.readLine();
					centralSystem.getIncomingQueries().add(line);
				}
				testCases.add(centralSystem);
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return testCases;
	}
	
	private static int process(List<String> searchEngines, List<String> incomingQueries) {
		int result = incomingQueries.size() == 0 ? 0 : -1;
		
		while (incomingQueries.size() != 0) {
			int nextPosition = 0;
			int maxPosition = -1;
			for (Iterator<String> iterator = searchEngines.iterator(); iterator.hasNext(); ) {
				String searchEngine = iterator.next();
				nextPosition = calculate(searchEngine, incomingQueries);
				if (nextPosition > maxPosition) {
					maxPosition = nextPosition;
				}
			}
			result++;
			for (int i = 0; i < maxPosition; i++) {
				incomingQueries.remove(0);
			}
		}
		
		return result;
	}
	
	private static int calculate(String searchEngine, List<String> incomingQueries) {
		int nextPosition = 0;
		for (Iterator<String> iterator = incomingQueries.iterator(); iterator.hasNext(); nextPosition++) {
			String query = iterator.next();
			if (query.equals(searchEngine)) {
				break;
			}
		}
		return nextPosition;
	}

}
