/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cointjam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;

/**
 *
 * @author martin
 */
public class CointJam {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        String fileName;
        if (args.length < 1) {
            fileName = "/home/martin/GCJ/2016_Qualif/C/C-small-attempt3.in";
        } else {
            fileName = args[0];
        }
        BufferedReader br = new BufferedReader(new FileReader(fileName));
        String line = br.readLine(); // Number of test cases
        int n = Integer.parseInt(line);
        for (int i = 0; i < n; i++) {
            //String y = getPlay(br);
            System.out.println("Case #" + (i + 1) + ": ");
            play(br);
            //System.out.printf("Case #%d: %.8f %.8f\n", i+1, y.d, y.t);
        }
    }
    
    private static void play(BufferedReader br) throws IOException {
        String line = br.readLine();
        Scanner s = new Scanner(line);
        int N = s.nextInt();
        int J = s.nextInt();
        long T = (1l << (N-1)) + 1;
        //System.err.println("Initial T = "+T);
        for (int j = 0; j < J; j++) {
            while(!test(T)) T += 2;
            T += 2; // Addonce more for the next attempt
        }
    }
    
    private static boolean test(long T) {
        int[] divs = new int[9];
        int d = testDiv(T);
        if (d > 0) {
            divs[0] = d;
        } else {
            return false;
        }
        for (int radix = 3; radix <= 10; radix++) {
            long Tr = print(T, radix);
            d = testDiv(Tr);
            if (d > 0) {
                divs[radix - 2] = d;
            } else {
                return false;
            }
        }
        System.out.print(Long.toBinaryString(T));
        for (int i = 0; i < divs.length; i++) {
            System.out.print(" "+divs[i]);
        }
        System.out.println("");
        return true;
    }
    
    private static int testDiv(long T) {
        int T2 = (int) (Math.sqrt(T) + 1);
        for (int div = 2; div < T2; div += 1) {
            if ((T % div) == 0) {
                // Not a prime
                return div;
            }
        }
        // is prime
        return 0;
        
    }

    /** Print 'l' which when printed in binary is read as in 'radix' */
    private static long print(long l, int radix) {
        long n = 0;
        long exp = 1;
        while (l > 0) {
            long b = (l & 0x1);
            if (b > 0) {
                n += exp;
            }
            l = l >> 1;
            exp *= radix;
        }
        return n;
    }
}
