/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package dijkstra;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Scanner;

/**
 *
 * @author martin
 */
public class Dijkstra {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        String fileName;
        if (args.length < 1) {
            fileName = "/home/martin/GCJ/2015_Qualif/C/MyTest2.txt";
        } else {
            fileName = args[0];
        }
        BufferedReader br = new BufferedReader(new FileReader(fileName));
        String line = br.readLine(); // Number of test cases
        int n = Integer.parseInt(line);
        for (int i = 0; i < n; i++) {
            String y = getPlay(br);
            System.out.println("Case #" + (i + 1) + ": "+y);
            //System.out.printf("Case #%d: %.8f %.8f\n", i+1, y.d, y.t);
        }
    }
    
    private static String getPlay(BufferedReader br) throws IOException {
        String line = br.readLine();
        Scanner s = new Scanner(line);
        int L = s.nextInt();
        int X = s.nextInt();
        line = br.readLine();
        s = new Scanner(line);
        String letters = s.next();
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < X; i++) {
            sb.append(letters);
        }
        letters = sb.toString();
        
        boolean success = reduceToIJK(letters);
        if (success) {
            return "YES";
        } else {
            return "NO";
        }
    }

    private static boolean reduceToIJK(String letters) {
        int indexi = 0, indexj = -1, indexk = -1;
        int ii = 0;
        Q Qi, Qj, Qk;
        Qi = new Q('1');
        do {
            indexj = -1;
            for ( ; ii < letters.length(); ii++) {
                Qi.multiply(letters.charAt(ii));
                if (Qi.is('i')) {
                    indexj = ++ii;
                    break;
                }
            }
            if (indexj < 0) return false;
            Qj = new Q('1');
            int ij = indexj;
            do {
                indexk = -1;
                for (; ij < letters.length(); ij++) {
                    Qj.multiply(letters.charAt(ij));
                    if (Qj.is('j')) {
                        indexk = ++ij;
                        break;
                    }
                }
                if (indexk < 0) return false;
                Qk = new Q('1');
                for (int ik = indexk; ik < letters.length(); ik++) {
                    Qk.multiply(letters.charAt(ik));
                }
                if (Qk.is('k')) {
                    return true;
                }
            } while (true);
        } while (true);
    }
    
    
    
    private static final class Q {
        char ijk1;
        boolean positive;
        
        public Q(char c) {
            this.ijk1 = c;
            this.positive = true;
        }
        
        public void multiply(char c) {
            if (ijk1 == '1') {
                ijk1 = c;
            } else if (ijk1 == 'i') {
                if (c == 'i') {
                    ijk1 = '1';
                    positive = !positive;
                } else if (c == 'j') {
                    ijk1 = 'k';
                } else {
                    ijk1 = 'j';
                    positive = !positive;
                }
            } else if (ijk1 == 'j') {
                if (c == 'i') {
                    ijk1 = 'k';
                    positive = !positive;
                } else if (c == 'j') {
                    ijk1 = '1';
                    positive = !positive;
                } else {
                    ijk1 = 'i';
                }
            } else if (ijk1 == 'k') {
                if (c == 'i') {
                    ijk1 = 'j';
                } else if (c == 'j') {
                    ijk1 = 'i';
                    positive = !positive;
                } else {
                    ijk1 = '1';
                    positive = !positive;
                }
            }
        }
        
        public boolean is(char c) {
            return positive && ijk1 == c;
        }

        @Override
        public String toString() {
            return ((positive) ? "" : "-") + ijk1;
        }
        
    }
}
