/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package elf;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

/**
 *
 * @author martin
 */
public class Elf {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        String fileName;
        if (args.length < 1) {
            fileName = "/mnt/SSD180/GCJ/2014_1C/A/MyTest.txt";
        } else {
            fileName = args[0];
        }
        BufferedReader br = new BufferedReader(new FileReader(fileName));
        String line = br.readLine(); // Number of test cases
        int n = Integer.parseInt(line);
        for (int i = 0; i < n; i++) {
            TestCase tc = readTc(br);
            long y = getPlay(tc);
            if (y < 0) {
                System.out.println("Case #"+(i+1)+": impossible");
            } else {
                System.out.println("Case #"+(i+1)+": "+y);
            }
        }
    }

    private static TestCase readTc(BufferedReader br) throws IOException {
        String line = br.readLine();
        int i = line.indexOf('/');
        TestCase tc = new TestCase();
        tc.P = Long.parseLong(line.substring(0, i));
        tc.Q = Long.parseLong(line.substring(i+1));
        return tc;
    }
    
    private static long pow2(int n) {
        long p = 1;
        for (int i = 1; i <= n; i++) {
            p *= 2;
        }
        return p;
    }

    private static long getPlay(TestCase tc) {
        long p40 = pow2(40);
        tc = reduce(tc);
        if ((p40 % tc.Q) != 0) {
            return -1;
        }
        long mult = p40/tc.Q;
        int numgen = 0;
        long P = tc.P;
        long Q = tc.Q;
        while (P/Q < 1 && numgen < 40) {
            P *= 2;
            numgen++;
        }
        if (P/Q < 1) {
            return -1;
        } else {
            return numgen;
        }
    }

    private static TestCase reduce(TestCase tc) {
        
        long P = tc.P;
        long Q = tc.Q;
        long M = Math.min(P, Q);
        for (long l = 2; l <= M; l++) {
            if ((P % l) == 0 && (Q % l) == 0) {
                P = P/l;
                Q = Q/l;
            }
        }
        TestCase tc2 = new TestCase();
        tc2.P = P;
        tc2.Q = Q;
        return tc2;
    }
    
    private static class TestCase {
        long P, Q;
    }
    
}
