/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package revengeofpancakes;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Scanner;

/**
 *
 * @author martin
 */
public class RevengeOfPancakes {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        String fileName;
        if (args.length < 1) {
            fileName = "/home/martin/GCJ/2016_Qualif/B/MyTest.txt";
        } else {
            fileName = args[0];
        }
        BufferedReader br = new BufferedReader(new FileReader(fileName));
        String line = br.readLine(); // Number of test cases
        int n = Integer.parseInt(line);
        for (int i = 0; i < n; i++) {
            String y = getPlay(br);
            System.out.println("Case #" + (i + 1) + ": "+y);
            //System.out.printf("Case #%d: %.8f %.8f\n", i+1, y.d, y.t);
        }
    }
    
    private static final boolean UP = true;
    private static final boolean DOWN = false;
    
    private static String getPlay(BufferedReader br) throws IOException {
        String line = br.readLine();
        if (line.isEmpty()) {
            return "0";
        }
        boolean[] pancakes = new boolean[line.length()];
        for (int i = 0; i < pancakes.length; i++) {
            pancakes[i] = (line.charAt(i) == '+');
        }
        int bottom = pancakes.length;
        long rounds = 0l;
        do {
            //int lastBottom = bottom;
            while (bottom > 0 && pancakes[bottom-1] == UP) bottom--;
            if (bottom == 0) break;
            // The last is DOWN. Need to flip all from bottom. But need to have DOWN on the top:
            if (pancakes[0] == UP) {
                int numUps = 1;
                while (pancakes[numUps] == UP) numUps++;
                flip(pancakes, numUps);
            } else {
                flip(pancakes, bottom);
            }
            rounds++;
            //print(pancakes);
        } while (bottom > 0);
        return Long.toString(rounds);
    }

    /** Flip 'n' top pancakes. */
    private static void flip(boolean[] pancakes, int n) {
        boolean c;
        int n2 = (n+1)/2;
        for (int i = 0; i < n2; i++) {
            int i2 = n - 1 - i;
            if (i == i2) {
                pancakes[i] = !pancakes[i];
            } else {
                c = pancakes[i];
                pancakes[i] = !pancakes[i2];
                pancakes[i2] = !c;
            }
        }
    }

    private static void print(boolean[] pancakes) {
        for (int i = 0; i < pancakes.length; i++) {
            if (pancakes[i]) {
                System.err.print("+");
            } else {
                System.err.print("-");
            }
        }
        System.err.println("");
    }
}
