package gcj2016.r2;

import java.util.Arrays;
import java.util.Iterator;
import java.util.Scanner;

public class A {
    final int N, R, P, S;
    private static final String impossible = "IMPOSSIBLE";
    private static final char[] moves = "RPS".toCharArray();

    // parse
    public A(final Scanner sc) {
        N = sc.nextInt();
        R = sc.nextInt();
        P = sc.nextInt();
        S = sc.nextInt();
    }

    // solve
    @Override
    public String toString() {
        if (1 << N != R + P + S) {
            debug(1 << N, R, P, S, R + P + S);
            throw null;
        }
        try {
            final int[] res = new int[1 << N];
            solve(N, R, P, S, res);
            for (int i = 0, j = 1; j < N - 1; j++) {
                for (int k = N >> 1; k > (i ^= k); k >>= 1) ;
                if (j < i) {
                    int tmp = res[j];
                    res[j] = res[i];
                    res[i] = tmp;
                }
            }
            final StringBuilder sb = new StringBuilder();
            for (int i = 0; i < res.length; i++)
                sb.append(moves[res[i]]);
            return reorder(sb.toString());
        } catch (NullPointerException e) {
            return impossible;
        }
    }

    void solve(int n, int r, int p, int s, int[] arr) {
        debug(n, r, p, s);
        if (n == 0) {
            arr[0] = r > 0 ? 0 : p > 0 ? 1 : 2;
            return;
        }
        final int m = Math.min(Math.min(r, p), s) / 2;
        r -= 2 * m;
        p -= 2 * m;
        s -= 2 * m;
        if (r == p + s) {
            p = p + m;
            r = s + m;
            s = m;
        } else if (p == s + r) {
            s = s + m;
            p = r + m;
            r = m;
        } else if (s == r + p) {
            r = r + m;
            s = p + m;
            p = m;
        } else {
            debug("impossible", n, r, p, s);
            throw null;
        }

        final int n2 = 1 << (n - 1);
        solve(n - 1, r, p, s, arr);
        for (int i = 0; i < n2; i++)
            arr[i + n2] = (arr[i] + 2) % 3;
    }

    String reorder(final String s) {
        if (s.length() == 1)
            return s;
        final String s1 = reorder(s.substring(0, s.length() / 2));
        final String s2 = reorder(s.substring(s.length() / 2));
        if (s1.compareTo(s2) < 0)
            return s1 + s2;
        else
            return s2 + s1;
    }

    // Template
    public static void main(String... args) throws Exception {
        try (final Scanner sc = new Scanner(System.in)) {
            final int T = sc.nextInt();
            final Object[] solvers = new Object[T];
            for (int i = 0; i < T; i++)
                solvers[i] = new A(sc);
            final Iterator<String> results = Arrays.stream(solvers)
                    .map(Object::toString)
                    .iterator();
            for (int i = 1; i <= T; i++)
                System.out.printf("Case #%s: %s\n", i, results.next());
        }
    }

    private static void debug(Object... os) {
        System.err.println(Arrays.deepToString(os));
    }
}
