package r2;

import java.io.*;
import java.util.*;
import java.math.*;

import static java.lang.Math.*;
import static java.lang.Character.*;
import static java.util.Arrays.*;
import static java.util.Collections.*;
import static java.math.BigInteger.*;

public class B {
	static final char PROB = B.class.getSimpleName().charAt(0);
	static final boolean PRAC = false;

	static final double EPS = 1e-9;
	static final int INF = 1 << 20;
	static final int[] di = { -1, 0, 0, 1 };
	static final int[] dj = { 0, -1, 1, 0 };
	static Scanner sc = new Scanner(System.in);

	final int R, C, D;
	final int[][] w;

	public B() {
		R = sc.nextInt();
		C = sc.nextInt();
		D = sc.nextInt();
		w = new int[R][C];
		for (int i = 0; i < R; i++) {
			char[] cs = sc.next().toCharArray();
			for (int j = 0; j < C; j++)
				w[i][j] = cs[j] - '0' + D;
		}
	}

	public String solve() {
		int ret = 0;
		int MAX = min(R, C);
		for (int K = 3; K <= MAX; K++) {
			long[][] sum = new long[R - K + 1][C - K + 1];
			long[][] x = new long[R - K + 1][C - K + 1];
			long[][] y = new long[R - K + 1][C - K + 1];
			for (int p = 0; p <= R - K; p++) {
				if (p == 0) {
					for (int i = 0; i < K; i++)
						for (int j = 0; j < K; j++)
							if ((i != 0 || j != 0) && (i != 0 || j != K - 1) && (i != K - 1 || j != 0)
									&& (i != K - 1 || j != K - 1)) {
								sum[0][0] += w[i][j];
								x[0][0] += w[i][j] * i;
								y[0][0] += w[i][j] * j;
							}
				} else {
					sum[p][0] = sum[p - 1][0];
					x[p][0] = x[p - 1][0];
					y[p][0] = y[p - 1][0];

					sum[p][0] -= w[p][0];
					x[p][0] -= w[p][0] * p;
					y[p][0] -= w[p][0] * 0;
					for (int j = 1; j < K - 1; j++) {
						sum[p][0] -= w[p - 1][j];
						x[p][0] -= w[p - 1][j] * (p - 1);
						y[p][0] -= w[p - 1][j] * j;
					}
					sum[p][0] -= w[p][K - 1];
					x[p][0] -= w[p][K - 1] * p;
					y[p][0] -= w[p][K - 1] * (K - 1);

					sum[p][0] += w[p][0];
					x[p][0] += w[p][0] * (p + K - 2);
					y[p][0] += w[p][0] * 0;
					for (int j = 1; j < K - 1; j++) {
						sum[p][0] += w[p + K - 1][j];
						x[p][0] += w[p + K - 1][j] * (p + K - 1);
						y[p][0] += w[p + K - 1][j] * j;
					}
					sum[p][0] += w[p + K - 2][K - 1];
					x[p][0] += w[p + K - 2][K - 1] * (p + K - 2);
					y[p][0] += w[p + K - 2][K - 1] * (K - 1);
				}
				for (int q = 1; q <= C - K; q++) {
					sum[p][q] = sum[p][q - 1];
					x[p][q] = x[p][q - 1];
					y[p][q] = y[p][q - 1];

					sum[p][q] -= w[p][q];
					x[p][q] -= w[p][q] * p;
					y[p][q] -= w[p][q] * q;
					for (int i = 1; i < K - 1; i++) {
						sum[p][q] -= w[p + i][q - 1];
						x[p][q] -= w[p + i][q - 1] * (p + i);
						y[p][q] -= w[p + i][q - 1] * (q - 1);
					}
					sum[p][q] -= w[p + K - 1][q];
					x[p][q] -= w[p + K - 1][q] * (p + K - 1);
					y[p][q] -= w[p + K - 1][q] * q;

					sum[p][q] += w[p][q + K - 2];
					x[p][q] += w[p][q + K - 2] * p;
					y[p][q] += w[p][q + K - 2] * (q + K - 2);
					for (int i = 1; i < K - 1; i++) {
						sum[p][q] += w[p + i][q + K - 1];
						x[p][q] += w[p + i][q + K - 1] * (p + i);
						y[p][q] += w[p + i][q + K - 1] * (q + K - 1);
					}
					sum[p][q] += w[p + K - 1][q + K - 2];
					x[p][q] += w[p + K - 1][q + K - 2] * (p + K - 1);
					y[p][q] += w[p + K - 1][q + K - 2] * (q + K - 2);
				}
			}
			for (int i = 0; i <= R - K; i++) {
				for (int j = 0; j <= C - K; j++) {
					if ((2 * i + K - 1) * sum[i][j] == x[i][j] * 2 && (2 * j + K - 1) * sum[i][j] == y[i][j] * 2)
						ret = K;
				}
			}

		}
		return ret < 3 ? "IMPOSSIBLE" : "" + ret;
	}

	public static void main(String... args) {
		small();
		int T = Integer.parseInt(sc.nextLine());
		for (int t = 1; t <= T; t++) {
			System.err.printf("Case #%s%n", t);
			System.out.printf("Case #%s: %s%n", t, new B().solve());
		}
		System.err.println("done.");
	}

	public static void small() {
		String in = PROB + "-small" + (PRAC ? "-practice" : "-attempt" + 0) + ".in";
		String out = PROB + "-small.out";
		if (!PRAC)
			for (int i = 1; new File(PROB + "-small" + "-attempt" + i + ".in").exists(); i++)
				in = PROB + "-small" + "-attempt" + i + ".in";
		try {
			System.setIn(new BufferedInputStream(new FileInputStream(in)));
			System.setOut(new PrintStream(out));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(0);
		}
		sc = new Scanner(System.in);
	}

	public static void large() {
		String in = PROB + "-large" + (PRAC ? "-practice" : "") + ".in";
		String out = PROB + "-large.out";
		try {
			System.setIn(new BufferedInputStream(new FileInputStream(in)));
			System.setOut(new PrintStream(out));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(0);
		}
		sc = new Scanner(System.in);
	}

	private static void debug(Object... os) {
		System.err.println(deepToString(os));
	}
}
