package r2;

import java.io.*;
import java.util.*;
import java.math.*;

import static java.lang.Math.*;
import static java.lang.Character.*;
import static java.util.Arrays.*;
import static java.util.Collections.*;
import static java.math.BigInteger.*;

public class A {
	static final char PROB = A.class.getSimpleName().charAt(0);
	static final boolean PRAC = false;

	static final double EPS = 1e-12;
	static final int INF = 1 << 20;
	static final int[] di = { -1, 0, 0, 1 };
	static final int[] dj = { 0, -1, 1, 0 };
	static Scanner sc = new Scanner(System.in);

	final int X, S, R, t, N;
	final int[] B, E, w;

	public A() {
		X = sc.nextInt();
		S = sc.nextInt();
		R = sc.nextInt();
		t = sc.nextInt();
		N = sc.nextInt();
		B = new int[N];
		E = new int[N];
		w = new int[N];
		for (int i = 0; i < N; i++) {
			B[i] = sc.nextInt();
			E[i] = sc.nextInt();
			w[i] = sc.nextInt();
		}
	}

	public String solve() {
		Pair[] ps = new Pair[N + 1];
		int sum = 0;
		for (int i = 0; i < N; i++) {
			ps[i] = new Pair(E[i] - B[i], S + w[i]);
			sum += E[i] - B[i];
		}
		ps[N] = new Pair(X - sum, S);
		sort(ps);
		double ret = 0;
		double rem = t;
		for (Pair p : ps)
			if (rem > 0 && (p.val + R - S) * rem >= p.key) {
				double time = 1. * p.key / (p.val + R - S);
				ret += time;
				rem -= time;
			} else {
				ret += rem + (p.key - (p.val + R - S) * rem) / p.val;
				rem = 0.;
			}
		return "" + ret;
	}

	private static class Pair implements Comparable<Pair> {
		final int key, val;

		public Pair(int key, int val) {
			this.key = key;
			this.val = val;
		}

		@Override
		public int compareTo(Pair o) {
			return val - o.val;
		}
	}

	public static void main(String... args) {
		 large();
		int T = Integer.parseInt(sc.nextLine());
		for (int t = 1; t <= T; t++) {
			System.err.printf("Case #%s%n", t);
			System.out.printf("Case #%s: %s%n", t, new A().solve());
		}
		System.err.println("done.");
	}

	public static void small() {
		String in = PROB + "-small" + (PRAC ? "-practice" : "-attempt" + 0) + ".in";
		String out = PROB + "-small.out";
		if (!PRAC)
			for (int i = 1; new File(PROB + "-small" + "-attempt" + i + ".in").exists(); i++)
				in = PROB + "-small" + "-attempt" + i + ".in";
		try {
			System.setIn(new BufferedInputStream(new FileInputStream(in)));
			System.setOut(new PrintStream(out));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(0);
		}
		sc = new Scanner(System.in);
	}

	public static void large() {
		String in = PROB + "-large" + (PRAC ? "-practice" : "") + ".in";
		String out = PROB + "-large.out";
		try {
			System.setIn(new BufferedInputStream(new FileInputStream(in)));
			System.setOut(new PrintStream(out));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(0);
		}
		sc = new Scanner(System.in);
	}

	private static void debug(Object... os) {
		System.err.println(deepToString(os));
	}
}
