package r1a;

import java.io.*;
import java.util.*;
import java.math.*;

import static java.lang.Math.*;
import static java.lang.Character.*;
import static java.util.Arrays.*;
import static java.util.Collections.*;
import static java.math.BigInteger.*;

public class B {
	static final char PROB = B.class.getSimpleName().charAt(0);
	static final boolean PRAC = false;

	static final int INF = 1 << 20;
	static final int[] di = { -1, 0, 0, 1 };
	static final int[] dj = { 0, -1, 1, 0 };
	static Scanner sc = new Scanner(System.in);

	final int N, M;
	final char[][] D;
	final char[][] L;

	public B() {
		N = sc.nextInt();
		M = sc.nextInt();
		D = new char[N][];
		for (int i = 0; i < N; i++)
			D[i] = sc.next().toCharArray();
		L = new char[M][];
		for (int i = 0; i < M; i++)
			L[i] = sc.next().toCharArray();
	}

	public String solve() {
		StringBuilder sb = new StringBuilder();
		Map<Integer, LC> ll = new HashMap<Integer, LC>();
		for (int i = 0; i < N; i++) {
			if (!ll.containsKey(D[i].length))
				ll.put(D[i].length, new LC());
			ll.get(D[i].length).add(new Dic(i));
		}
		for (int m = 0; m < M; m++) {
			if (m > 0)
				sb.append(' ');
			int max = -1;
			int maxDic = Integer.MAX_VALUE;
			for (LC lc : ll.values()) {
				BinTree bt = new BinTree(L[m]);
				for (Dic dic : lc)
					bt.add(dic);
				int mm = bt.getMax();
				if (mm > max || (mm == max && bt.maxDic < maxDic)) {
					max = mm;
					maxDic = bt.maxDic;
				}
			}
			sb.append(D[maxDic]);
		}
		return sb.toString();
	}

	private static class BinTree {
		private final char[] L;
		private final int idx;
		private BinTree match = null, miss = null;
		public int maxDic;
		private final Dic dic;

		public BinTree(char[] L) {
			this.L = L;
			this.idx = 0;
			this.dic = null;
			maxDic = Integer.MAX_VALUE;
		}

		public BinTree(char[] L, int idx, Dic d) {
			this.L = L;
			this.idx = idx;
			this.dic = d;
			if (idx < L.length)
				if (dic.contains(L[idx]))
					match = new BinTree(L, idx + 1, dic);
				else
					miss = new BinTree(L, idx + 1, dic);
			maxDic = dic.num;
		}

		public void add(Dic dic) {
			if (idx == L.length) {
				maxDic = min(maxDic, dic.num);
				return;
			}
			if (dic.contains(L[idx]))
				if (match == null)
					match = new BinTree(L, idx + 1, dic);
				else
					match.add(dic);
			else if (miss == null)
				miss = new BinTree(L, idx + 1, dic);
			else
				miss.add(dic);
		}

		public int getMax() {
			if (L.length == idx)
				return 0;
			int ret = 0;
			if (match != null) {
				int m = match.getMax();
				if (m > ret || (m == ret && match.maxDic < maxDic)) {
					ret = m;
					maxDic = match.maxDic;
				}
			}
			if (miss != null) {
				int m = miss.getMax() + (match == null ? 0 : 1);
				if (m > ret || (m == ret && miss.maxDic < maxDic)) {
					ret = m;
					maxDic = miss.maxDic;
				}
			}
			return ret;
		}
	}

	private class LC extends ArrayList<Dic> {
	};

	private class Dic extends HashSet<Character> {
		final int num;

		public Dic(int i) {
			this.num = i;
			for (char c : D[i])
				add(c);
		}
	}

	public static void main(String... args) {
		small();
		int T = Integer.parseInt(sc.nextLine());
		for (int t = 1; t <= T; t++) {
			System.err.printf("Case #%s%n", t);
			System.out.printf("Case #%s: %s%n", t, new B().solve());
		}
		System.err.println("done.");
	}

	public static void small() {
		String in = PROB + "-small" + (PRAC ? "-practice" : "-attempt" + 0) + ".in";
		String out = PROB + "-small.out";
		try {
			if (!PRAC)
				for (int i = 1; new File(PROB + "-small" + "-attempt" + i + ".in").exists(); i++)
					in = PROB + "-small" + "-attempt" + i + ".in";
			System.setIn(new BufferedInputStream(new FileInputStream(in)));
			System.setOut(new PrintStream(out));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(0);
		}
		sc = new Scanner(System.in);
	}

	public static void large() {
		String in = PROB + "-large" + (PRAC ? "-practice" : "") + ".in";
		String out = PROB + "-large.out";
		try {
			System.setIn(new BufferedInputStream(new FileInputStream(in)));
			System.setOut(new PrintStream(out));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(0);
		}
		sc = new Scanner(System.in);
	}

	private static void debug(Object... os) {
		System.err.println(deepToString(os));
	}
}
