package gcj2010.rnd2;

import java.io.*;
import java.util.*;
import java.math.*;

import static java.lang.Math.*;
import static java.lang.Character.*;
import static java.util.Arrays.*;
import static java.util.Collections.*;
import static java.math.BigInteger.*;

public class C {
	static final int INF = 1 << 20;
	static final int[] di = { -1, 0, 0, 1 };
	static final int[] dj = { 0, -1, 1, 0 };
	static final char PROB = C.class.getSimpleName().charAt(0);
	static final boolean PRAC = false;
	static final Mode mode = Mode.TestSmall;

	static enum Mode {
		SampleTestSmall, SampleTestLarge, TestSmall, TestLarge, Diff
	}

	private static class Small extends Solver {
		static final int S = 105;
		protected String solve(Scanner sc) {
			int R = sc.nextInt();
			int[] X1 = new int[R];
			int[] Y1 = new int[R];
			int[] X2 = new int[R];
			int[] Y2 = new int[R];
			for (int i = 0; i < R; i++) {
				X1[i] = sc.nextInt();
				Y1[i] = sc.nextInt();
				X2[i] = sc.nextInt() + 1;
				Y2[i] = sc.nextInt() + 1;
			}
			boolean[][] map = new boolean[S][S];
			for(int k = 0; k < R; k++)
				for(int i = X1[k]; i < X2[k]; i++)
					for(int j = Y1[k]; j < Y2[k]; j++)
						map[i][j] = true;
			int ret = 0;
			int num = 0;
			do {
				num = 0;
				boolean[][] nm = new boolean[S][S];
				for(int i = 1; i < S; i++)
					for(int j = 1; j < S; j++)
						if(map[i][j]) {
							if(map[i-1][j] || map[i][j-1]) {
								nm[i][j] = true;
								num++;
							}
						}
						else {
							if(map[i-1][j] && map[i][j-1]) {
								nm[i][j] = true;
								num++;
							}
						}
				map = nm;
				ret++;
			} while(num > 0);
//			int[] in = new int[R];
//			fill(in, -1);
//			for (int i = 0; i < R; i++)
//				for (int j = 0; j < R; j++)
//					if (!(X1[i] == X1[j] && Y1[i] == Y1[j]))
//						if (X1[i] <= X1[j] && X1[j] <= X2[i] && Y1[i] <= Y1[j] && Y1[j] <= Y2[i])
//							in[j] = i;
//			int[] Ye = new int[R];
//			for (int i = 0; i < R; i++)
//				Ye[i] = Y2[i];
//			for (int i = 0; i < R; i++)
//				for (int j = 0; j < R; j++)
//					if (X1[i] <= X2[j] && X2[j] < X2[i] && Y1[j] <= Y2[i])
//						Ye[i] = max(Ye[i], Y2[j]);
//			int[] s = new int[R];
//			fill(s, -1);
//			for (int k = 0; k < R; k++)
//				for (int i = 0; i < R; i++)
//					if (s[i] < 0)
//						if (in[i] == -1)
//							s[i] = 0;
//						else if (s[in[i]] >= 0)
//							s[i] = s[in[i]] + X1[i] - X1[in[i]] + Y1[i] - Y1[in[i]];
//			int ret = 0;
//			for (int i = 0; i < R; i++)
//				ret = max(ret, s[i] + X2[i] - X1[i] + Ye[i] - Y1[i]);
			return "" + ret;
		}
	}

	private static class Large extends Solver {
		protected String solve(Scanner sc) {
			return new Small().solve(sc);
		}
	}

	private static abstract class Solver {
		protected abstract String solve(Scanner sc);

		public void run() {
			Scanner sc = new Scanner(System.in);
			int T = sc.nextInt();
			sc.nextLine();
			for (int t = 1; t <= T; t++) {
				System.err.printf("Case #%s%n", t);
				System.out.printf("Case #%s: %s%n", t, solve(sc));
			}
			System.err.println("done.");
		}
	}

	public static void main(String... args) {
		switch (mode) {
		case TestSmall: {
			String name = smallName(getMaxFileNum());
			setStream(name + ".in", name + ".out");
		}
		case SampleTestSmall:
			new Small().run();
			break;
		case TestLarge:
			setStream(largeName() + ".in", largeName() + ".out");
		case SampleTestLarge:
			new Large().run();
			break;
		case Diff: {
			int max = getMaxFileNum();
			for (int i = 0; i <= max; i++) {
				setStream(smallName(i) + ".in", "small_tmp");
				new Small().run();
				setStream(smallName(i) + ".in", "large_tmp");
				new Large().run();
				setStream("small_tmp", diffName(i));
				new Diff().diff(i, "small_tmp", "large_tmp");
			}
			break;
		}
		}
	}

	private static class Diff {
		public void diff(int id, String small, String large) {
			try {
				Scanner sm = new Scanner(new File(small));
				Scanner lg = new Scanner(new File(large));
				int line = 0;
				while (sm.hasNextLine() && lg.hasNextLine()) {
					String s = sm.nextLine();
					String l = lg.nextLine();
					if (!s.equals(l)) {
						System.out.println(line + ">" + s);
						System.out.println(line + "<" + l);
					}
					line++;
				}

			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	private static int getMaxFileNum() {
		if (PRAC)
			return 0;
		int ret = -1;
		for (int i = 0; new File(smallName(i) + ".in").exists(); i++)
			ret = i;
		return ret;
	}

	private static String largeName() {
		return PROB + "-large" + (PRAC ? "-practice" : "");
	}

	private static String smallName(int a) {
		return PROB + "-small" + (PRAC ? "-practice" : "-attempt" + a);
	}

	private static String diffName(int a) {
		return PROB + "-small" + (PRAC ? "" : a) + ".dif";
	}

	private static void setStream(String in, String out) {
		try {
			System.setIn(new BufferedInputStream(new FileInputStream(in)));
			System.setOut(new PrintStream(out));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private static void debug(Object... os) {
		System.err.println(deepToString(os));
	}
}
