package gcj2010.qual;
import java.io.*;
import java.util.*;
import java.math.*;

import static java.lang.Math.*;
import static java.util.Arrays.*;
import static java.math.BigInteger.*;

public class B {
	static final int INF = 1 << 20;
	static final int[] di = { -1, 0, 0, 1 };
	static final int[] dj = { 0, -1, 1, 0 };
	static final char PROB = 'B';
	static final boolean SAMP = false;
	static final boolean PRAC = false;

	private BigInteger gcd(BigInteger x, BigInteger y) {
		return y.equals(ZERO) ? x : gcd(y, x.mod(y));
	}

	private BigInteger solve(Scanner sc) {
		int N = sc.nextInt();
		BigInteger[] t = new BigInteger[N];
		for(int i = 0; i < N; i++)
			t[i] = sc.nextBigInteger();
		sort(t);
		BigInteger gcd = t[1].subtract(t[0]);
		for(int i = 1; i < N - 1; i++)
			gcd = gcd(gcd, t[i+1].subtract(t[i]));
		return gcd.subtract(t[0].mod(gcd)).mod(gcd);
	}

	public void run() {
		Scanner sc = new Scanner(System.in);
		int T = sc.nextInt(); sc.nextLine();
		for(int t = 1; t <= T; t++)
			System.out.printf("Case #%s: %s%n", t, solve(sc));
	}

	public static void main(String...args) throws IOException {
		if(!SAMP) {
			for(int i = 0; new File(smallName(i) + ".in").exists(); i++)
				if(!new File(smallName(i) + ".out").exists()){
					System.setIn(new FileInputStream(smallName(i) + ".in"));
					System.setOut(new PrintStream(smallName(i) + ".out"));
					new B().run();
				}
			if(new File(largeName() + ".in").exists()) {
				System.setIn(new FileInputStream(largeName() + ".in"));
				System.setOut(new PrintStream(largeName() + ".out"));
				new B().run();
			}
		}
		else
			new B().run();
	}

	private static String largeName() {
		return PROB + "-large" + (PRAC ? "-practice" : "");
	}

	private static String smallName(int a) {
		return PROB + "-small" + (PRAC ? a == 0 ? "-practice" : "" : "-attempt" + a);
	}
}
