package gcj2016.r1a;

import java.util.ArrayDeque;
import java.util.Arrays;
import java.util.Iterator;
import java.util.Scanner;

public class AL {

    final char[] S;

    // parse
    public AL(final Scanner sc) {
        S = sc.next().toCharArray();
    }

    // solve
    @Override
    public String toString() {
        final ArrayDeque<Character> deq = new ArrayDeque<>();
        char next = ' ';
        for (final char c : S) {
            if (deq.isEmpty()) {
                next = c;
                deq.offerLast(c);
            } else if (c > deq.peekFirst()) {
                next = deq.peekFirst();
                deq.offerFirst(c);
            } else if (c < deq.peekFirst()) {
                if (next == deq.peekFirst())
                    next = c;
                deq.offerLast(c);
            } else if (c > next)
                deq.offerFirst(c);
            else
                deq.offerLast(c);
        }

        final StringBuilder sb = new StringBuilder();
        for (final char c : deq)
            sb.append(c);
        return sb.toString();
    }

    // Template
    public static void main(String... args) throws Exception {
        try (final Scanner sc = new Scanner(System.in)) {
            final int T = sc.nextInt();
            final Object[] solvers = new Object[T];
            for (int i = 0; i < T; i++)
                solvers[i] = new AL(sc);
            final Iterator<String> results = Arrays.stream(solvers)
                    .map(Object::toString)
                    .iterator();
            for (int i = 1; i <= T; i++)
                System.out.printf("Case #%s: %s\n", i, results.next());
        }
    }

    private static void debug(Object... os) {
        System.err.println(Arrays.deepToString(os));
    }
}
