package gcj2016.qual;

import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Scanner;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

public class CLarge {
    private static final String name = "gcj/src/main/java/gcj2016/qual/C-large.out";

    public static void main(String... args) throws Exception {
        System.setOut(new PrintStream(name));

        try (final Scanner sc = new Scanner(System.in)) {
            final int T = sc.nextInt();
            final int N = sc.nextInt();
            int J = sc.nextInt();
            System.out.println("Case #1:");
            final String format = String.format("1%%%ds1", N - 2);
            loop:
            for (int i = 0; J > 0 && i < 1 << (N - 2); i++) {
                final String jam = String.format(format, Integer.toBinaryString(i)).replace(" ", "0");
                final BigInteger[] nt = new BigInteger[11];
                for (int base = 2; base <= 10; base++) {
                    final BigInteger k = new BigInteger(jam, base);

                    if (k.isProbablePrime(100))
                        continue loop;
                    final BigInteger f = factor(k);

                    if(f == null)
                        continue loop;

                    if(!k.mod(f).equals(BigInteger.ZERO))
                        throw null;
                    nt[base] = k.divide(f);
                }
                final String result = jam + " " +
                        Arrays.stream(nt, 2, 11).map(BigInteger::toString).collect(Collectors.joining(" "));
                System.out.println(result);
                debug(result);
                J--;
            }
        }
    }

    private static BigInteger factor(BigInteger num) {
        BigInteger x_fixed = BigInteger.valueOf(2);
        int cycle_size = 2;
        BigInteger x = x_fixed;
        BigInteger factor = BigInteger.ONE;

        while (factor.equals(BigInteger.ONE)) {
            if(cycle_size > 1 << 16)
                return null;

            for (int count = 1; count <= cycle_size && factor.compareTo(BigInteger.ONE) <= 0; count++) {
                x = (x.multiply(x).add(BigInteger.ONE)).mod(num);
                factor = x.subtract(x_fixed).gcd(num);
            }

            cycle_size *= 2;
            x_fixed = x;
        }

        return factor;
    }

    private static void debug(Object... os) {
        System.err.println(Arrays.deepToString(os));
    }
}
