package gcj2010.qual;
import java.io.*;
import java.util.*;
import java.math.*;

import static java.lang.Math.*;
import static java.util.Arrays.*;
import static java.math.BigInteger.*;

public class C {
	static final int INF = 1 << 20;
	static final int[] di = { -1, 0, 0, 1 };
	static final int[] dj = { 0, -1, 1, 0 };
	static final char PROB = 'C';
	static final boolean SAMP = false;
	static final boolean PRAC = false;

	private long solve(Scanner sc) {
		int R = sc.nextInt();
		int k = sc.nextInt();
		int N = sc.nextInt();
		int[] g = new int[N];
		for(int i = 0; i < N; i++)
			g[i] = sc.nextInt();
		int[] cur = new int[N+2];
		int[] eur = new int[N+2];
		Set<Integer> set = new HashSet<Integer>();
		int n = 0;
		for(int c = 0, e = 0; !set.contains(c);) {
			set.add(c);
			n++;
			int sum = 0;
			int p = c;
			while((sum == 0 || c != p) && sum + g[c] <= k) {
				sum += g[c];
				e += g[c];
				c = (c + 1) % N;
			}
			cur[n] = c;
			eur[n] = e;
		}
		long ret = 0;
		if(R <= n)
			ret = eur[R];
		else {
			int p = binarySearch(cur, 0, n, cur[n]);
			ret = eur[p];
			R -= p;
			ret += 1L * (R / (n - p)) * (eur[n] - eur[p]);
			R %= n - p;
			ret += eur[R+p] - eur[p];
		}
		return ret;
	}

	public void run() {
		Scanner sc = new Scanner(System.in);
		int T = sc.nextInt(); sc.nextLine();
		for(int t = 1; t <= T; t++)
			System.out.printf("Case #%s: %s%n", t, solve(sc));
	}

	public static void main(String...args) throws IOException {
		if(!SAMP) {
			for(int i = 0; new File(smallName(i) + ".in").exists(); i++)
				if(!new File(smallName(i) + ".out").exists()){
					System.setIn(new FileInputStream(smallName(i) + ".in"));
					System.setOut(new PrintStream(smallName(i) + ".out"));
					new C().run();
				}
			if(new File(largeName() + ".in").exists()) {
				System.setIn(new FileInputStream(largeName() + ".in"));
				System.setOut(new PrintStream(largeName() + ".out"));
				new C().run();
			}
		}
		else
			new C().run();
	}

	private static String largeName() {
		return PROB + "-large" + (PRAC ? "-practice" : "");
	}

	private static String smallName(int a) {
		return PROB + "-small" + (PRAC ? a == 0 ? "-practice" : "" : "-attempt" + a);
	}
}
