package gcj2009.rnd1a;
import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class B {
	static final int INF = 1 << 20;
	static final int[] di = { -1, 0, 0, 1 };
	static final int[] dj = { 0, -1, 1, 0 };
	static final char PROB = 'B';
	static final boolean SAMP = false;
	static final boolean PRAC = false;
	
	int rem(int N, int D) {
		return (N % D + D) % D;
	}

	private int solve(Scanner sc) {
		int N = sc.nextInt();
		int M = sc.nextInt();
		int[][] S = new int[N][M];
		int[][] W = new int[N][M];
		int[][] T = new int[N][M];
		for(int i = 0; i < N; i++)
			for(int j = 0; j < M; j++) {
				S[i][j] = sc.nextInt();
				W[i][j] = sc.nextInt();
				T[i][j] = rem(sc.nextInt(), S[i][j] + W[i][j]);
			}
		int[][] dp = new int[2*N][2*M];
		for(int i = 0; i < 2 * N; i++)
			for(int j = 0; j < 2 * M; j++)
				dp[i][j] = INF;
		dp[0][0] = 0;
		for(int i = 0; i < 2 * N; i++)
			for(int j = 0; j < 2 * M; j++) {
				int r = rem(-dp[i][j] + T[i/2][j/2], S[i/2][j/2] + W[i/2][j/2]);
				int q = rem(-dp[i][j] + T[i/2][j/2] + S[i/2][j/2], S[i/2][j/2] + W[i/2][j/2]);
				if(i % 2 == 0)
					dp[i+1][j] = min(dp[i+1][j], dp[i][j] + (q < r && q > 0 ? 0 : r) + 1);
				else if(i < 2 * N - 1 && j % 2 == 1)
					dp[i+1][j] = min(dp[i+1][j], dp[i][j] + 2);
				if(j % 2 == 0) 
					dp[i][j+1] = min(dp[i][j+1], dp[i][j] + (r < q && r > 0 ? 0 : q) + 1);
				else if(j < 2 * M - 1 && i % 2 == 1)
					dp[i][j+1] = min(dp[i][j+1], dp[i][j] + 2);
			}
//		for(int[] is : dp)
//			System.err.println(Arrays.toString(is));
		return dp[2*N-1][2*M-1];
	}
	
	public void run() {
		Scanner sc = new Scanner(System.in);
		int T = sc.nextInt(); sc.nextLine();
		for(int t = 1; t <= T; t++)
			System.out.printf("Case #%d: %d%n", t, solve(sc));
	}

	public static void main(String...args) throws IOException {
		if(!SAMP) {
			for(int i = 0; new File(smallName(i) + ".in").exists(); i++) 
				if(!new File(smallName(i) + ".out").exists()){
					System.setIn(new FileInputStream(smallName(i) + ".in"));
					System.setOut(new PrintStream(smallName(i) + ".out"));
					new B().run();
				}
			if(new File(largeName() + ".in").exists()) {
				System.setIn(new FileInputStream(largeName() + ".in"));
				System.setOut(new PrintStream(largeName() + ".out"));
				new B().run();
			}
		}
		else
			new B().run();
	}

	private static String largeName() {
		return PROB + "-large" + (PRAC ? "-practice" : "");
	}

	private static String smallName(int a) {
		return PROB + "-small" + (PRAC ? a == 0 ? "-practice" : "" : "-attempt" + a);
	}
}
