package gcj2009.rnd2;
import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class C {
	static final int INF = 1 << 20;
	static final int[] di = { -1, 0, 0, 1 };
	static final int[] dj = { 0, -1, 1, 0 };
	static final char PROB = 'C';
	static final boolean SAMP = false;
	static final boolean PRAC = false;

	int n, k;
	boolean[][] map;

	private int solve(Scanner sc) {
		n = sc.nextInt();
		k = sc.nextInt();
		int[][] price = new int[n][k];
		for(int i = 0; i < n; i++)
			for(int j = 0; j < k; j++)
				price[i][j] = sc.nextInt();
		map = new boolean[n][n];
		for(int i = 0; i < n; i++)
			loop : 
				for(int j = i + 1; j < n; j++) {
					for(int p = 1; p < k; p++)
						if((price[i][p-1] - price[j][p-1]) * (price[i][p] - price[j][p]) <= 0)
							continue loop;
					map[i][j] = map[j][i] = true;
				}
		int ret = 1;
		while(dfs(ret, 0, new int[n], 1))
			ret++;
		return ret;
	}

	boolean dfs(int limit, int c, int[] gr, int l) {
		if(c == n)
			return false;

		boolean[] imp = new boolean[limit];
		for(int i = 0; i < c; i++)
			imp[gr[i]] |= !map[i][c];

		for(int i = 0; i < l; i++)
			if(!imp[i]) {
				gr[c] = i;
				if(!dfs(limit, c + 1, gr, min(max(i + 2, l), limit)))
					return false;
			}
		return true;
	}

	public void run() {
		Scanner sc = new Scanner(System.in);
		int T = sc.nextInt(); sc.nextLine();
		for(int t = 1; t <= T; t++)
			System.out.printf("Case #%d: %d%n", t, solve(sc));
	}

	public static void main(String...args) throws IOException {
		if(!SAMP) {
			for(int i = 0; new File(smallName(i) + ".in").exists(); i++) 
				if(!new File(smallName(i) + ".out").exists()){
					System.setIn(new FileInputStream(smallName(i) + ".in"));
					System.setOut(new PrintStream(smallName(i) + ".out"));
					new C().run();
				}
			if(new File(largeName() + ".in").exists()) {
				System.setIn(new FileInputStream(largeName() + ".in"));
				System.setOut(new PrintStream(largeName() + ".out"));
				new C().run();
			}
		}
		else
			new C().run();
	}

	private static String largeName() {
		return PROB + "-large" + (PRAC ? "-practice" : "");
	}

	private static String smallName(int a) {
		return PROB + "-small" + (PRAC ? a == 0 ? "-practice" : "" : "-attempt" + a);
	}
}
