package gcj2009.rnd1a;
import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class A {
	static final int INF = 1 << 20;
	static final int[] di = { -1, 0, 0, 1 };
	static final int[] dj = { 0, -1, 1, 0 };
	static final char PROB = 'A';
	static final boolean SAMP = false;
	static final boolean PRAC = false;

	static final int MAX = 1000000;
	static final boolean[][] memo = new boolean[11][MAX+1];
	
	private String solve(Scanner sc) {
		String[] ss = sc.nextLine().split(" ");
		int[] bases = new int[ss.length];
		for(int i = 0; i < ss.length; i++)
			bases[i] = Integer.parseInt(ss[i]);
		loop : for(int i = 2; i <= MAX; i++) {
			for(int j : bases)
				if(!memo[j][i])
					continue loop;
			return "" + i;
		}
		return "";
	}
	
	boolean[] memo(int base) {
		boolean[] visited = new boolean[MAX+1];
		boolean[] memo = new boolean[MAX+1];
		for(int i = 1; i <= MAX; i++)
			dfs(i, base, visited, memo);
		return memo;
	}
	
	boolean dfs(int i, int base, boolean[] visited, boolean[] memo) {
		if(i == 1)
			memo[i] = true;
		else if(!visited[i]) {
			visited[i] = true;
			memo[i] = dfs(getNext(i, base), base, visited, memo);
		}
		return memo[i];
	}
	
	int getNext(int i, int base) {
//		if(i < base)
//			return i;
		int ret = 0;
		for(; i > 0; i /= base)
			ret += (i % base) * (i % base);
		return ret;
	}

	public void run() {
		Scanner sc = new Scanner(System.in);
		for(int i = 2; i <= 10; i++)
			memo[i] = memo(i);
		int T = sc.nextInt(); sc.nextLine();
		for(int t = 1; t <= T; t++)
			System.out.printf("Case #%d: %s%n", t, solve(sc));
	}

	public static void main(String...args) throws IOException {
		if(!SAMP) {
			for(int i = 0; new File(smallName(i) + ".in").exists(); i++) 
				if(!new File(smallName(i) + ".out").exists()){
					System.setIn(new FileInputStream(smallName(i) + ".in"));
					System.setOut(new PrintStream(smallName(i) + ".out"));
					new A().run();
				}
			if(new File(largeName() + ".in").exists()) {
				System.setIn(new FileInputStream(largeName() + ".in"));
				System.setOut(new PrintStream(largeName() + ".out"));
				new A().run();
			}
		}
		else
			new A().run();
	}

	private static String largeName() {
		return PROB + "-large" + (PRAC ? "-practice" : "");
	}

	private static String smallName(int a) {
		return PROB + "-small" + (PRAC ? a == 0 ? "-practice" : "" : "-attempt" + a);
	}
}
