import java.lang.System;
import java.util.List;
import java.util.ArrayList;
import java.io.*;

public class IOUtils {

    public static List<InputCase> fromFile(File f, int caseLength) {
        BufferedReader in = null;
        List<InputCase> cases = new ArrayList<InputCase>();
        try {
            in = new BufferedReader(new FileReader(f));
            int counter = 0;
            int caseN = 1;
            String line = in.readLine(); // first line is the number of test cases
            List<String> tmpList = new ArrayList<String>();
            while((line = in.readLine()) != null) {
                tmpList.add(line);
                if(counter++ % caseLength == caseLength - 1) {
                    cases.add(new InputCase(tmpList, caseN++));
                    tmpList = new ArrayList<String>();
                }
            }
        } catch (IOException e) {
            System.out.println("Some error occured while reading!");
            e.printStackTrace(System.out);
        } finally {
            if(in != null) {
                try{
                    in.close();
                } catch (IOException e) {
                    System.out.println("Some error occured while reading!");
                    e.printStackTrace(System.out);
                }
            }
        }
        return cases;
    }

    public static void toFile(Solvable s, List<InputCase> ic, File in) {
        String outName =
                in.getName().replaceFirst("[.][^.]+$", "") + ".out";
        PrintWriter out = null;
        try {
            out = new PrintWriter(
                new BufferedWriter(new FileWriter(outName)));
            for(InputCase i : ic) {
                out.println(s.solveCase(i));
            }
        } catch(IOException e) {
            System.out.println("Some error occured while reading!");
            e.printStackTrace(System.out);
        } finally {
            if(out != null) {
                out.close();
            }
        }
    }
}
