import java.lang.Integer;
import java.lang.Double;

import java.util.*;
import java.io.File;
import java.text.DecimalFormat;

public class CookieClicker implements Solvable {

    private static final int CASE_LENGTH = 1;

    public static void main(String[] args) {
        File f;
        if(args.length > 0 && (f = new File(args[0])).canRead()){
            List<InputCase> cases = IOUtils.fromFile(f, CASE_LENGTH);
            IOUtils.toFile(new CookieClicker(), cases, f);
        }
    }

    public String solveCase(InputCase i) {
        String[] inputElements = i.getTextAtLine(0).split("\\s+");
        final double farmCost =
            Double.valueOf(inputElements[0]); // C: Change every problem
        final double bonusRate =
            Double.valueOf(inputElements[1]); // F: Change every problem
        final double cookiesToWin =
            Double.valueOf(inputElements[2]); //X: Change every problem
        int farms = 0;
        double bestTime = calculateTime(farms, bonusRate,
            farmCost, cookiesToWin);
        while(true) {
            double newTime;
            if((newTime = calculateTime(++farms, bonusRate,
            farmCost, cookiesToWin)) >= bestTime) {
                break;
            }
            bestTime = newTime;
        }
        DecimalFormat df = new DecimalFormat(".0000000");
        return "Case #" + i.getCaseNumber() + ": "
                + df.format(bestTime);
    }

    private double calculateTime(
        int farmBought, double bonusRate, double farmCost, double cookieGoal) {
        final double startingRate = 2.0;
        if(farmBought ==  -1) {
            return 0.0;
        }
        return calculateTime(farmBought - 1, bonusRate, farmCost, farmCost) +
            cookieGoal / (startingRate + bonusRate * farmBought);
    }
}
