import java.util.*;
import java.io.File;

public class DeceitfulWar implements Solvable {

    private static final int CASE_LENGTH = 3;

    public static void main(String[] args) {
        File f;
        if(args.length > 0 && (f = new File(args[0])).canRead()){
            List<InputCase> cases = IOUtils.fromFile(f, CASE_LENGTH);
            IOUtils.toFile(new DeceitfulWar(), cases, f);
        }
    }

    public String solveCase(InputCase i) {
      String[] naomiArray = i.getTextAtLine(1).split("\\s+");
      List<Float> naomiList = new ArrayList<Float>();
      for(String s : naomiArray) {
        naomiList.add(Float.parseFloat(s));
      }
      String[] kenArray = i.getTextAtLine(2).split("\\s+");
      List<Float> kenList = new ArrayList<Float>();
      for(String s : kenArray) {
        kenList.add(Float.parseFloat(s));
      }
    return "Case #"+ i.getCaseNumber() +": " + playDecWar(naomiList, kenList)
           + " " + playWar(naomiList, kenList);
    }

    private int playDecWar(List<Float> n, List<Float> k) {
      List<Float> nList = new ArrayList<Float>(n);
      List<Float> kList = new ArrayList<Float>(k);
      Collections.sort(nList);
      Collections.sort(kList);
      int naomiScore = 0;
      while(!nList.isEmpty()) {
        float kenHeaviest = kList.get(kList.size()-1);
        float naomiHeaviest = nList.get(nList.size()-1);
        // if naomi can tell a fake weight without being discovered  it will do it
        if (naomiHeaviest < kenHeaviest) {
          kList.remove(kList.size()-1); // remove the heaviest
          //rimuovo il piu basso tra quelli doppi
          for(int i = 0; i < kList.size() - 2; i++ ) {
            float l = kList.get(i);
            float h = kList.get(i+1);
            float removalCandidate = 0;
            int numbersBetween = 0;
            for(float fl : nList) {
              if(fl > l && fl < h) {
                if (numbersBetween++ == 0) {
                  removalCandidate = fl;
                }
              }
            }
            if (numbersBetween > 1) {
              nList.remove(removalCandidate);
              break;
            }
          }
          nList.remove(0); // remove the lightest
        } else {
          nList.remove(nList.size()-1); // remove the heaviest
          kList.remove(kList.size()-1); // remove the lightest
          naomiScore++;
        }

      }
      return naomiScore;
    }


    private int playWar(List<Float> n, List<Float> k) {
      List<Float> nList = new ArrayList<Float>(n);
      List<Float> kList = new ArrayList<Float>(k);
      Collections.sort(nList);
      Collections.sort(kList);
      int naomiScore = 0;

      while(!nList.isEmpty()) {
        float naomiChoice = nList.remove(0);
        for(float f : kList) {
          if(f > naomiChoice) {
            System.out.println("naomi: " + naomiChoice + " ken:" + f);
            kList.remove(kList.indexOf(f));
            naomiScore--;
            break;
          }
        }
        naomiScore++;
      }
      return naomiScore;
  }

}
