/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package rpi;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Locale;

/**
 *
 * @author erben
 */
class Games{
    int N;      // csapatok száma
    int g[][];  // eredmények -1
    int[] won,lost;
    double wp[];
    double owp[];
    double oowp[];
    double rpi[];

    public Games(BufferedReader be) throws IOException{
        N = Integer.parseInt(be.readLine());
        g = new int[N][N];
        won = new int[N];
        lost = new int[N];
        wp = new double[N];
        owp = new double[N];
        oowp = new double[N];
        rpi = new double[N];

        for(int i=0; i<N; i++){
            String sor = be.readLine();
            won[i] = 0;
            lost[i] = 0;
            for(int j=0; j <N; j++){
                char c = sor.charAt(j);
                switch(c){
                    case '.': g[i][j] = 0; break;
                    case '1': g[i][j] = 1; won[i]++; break;
                    case '0': g[i][j] = -1; lost[i]++; break;
                }
            }
        }
        
    }
    
    public void solve(){
        //wp
        for(int i = 0; i<N; i++){
            wp[i] = (double)won[i] / (won[i]+lost[i]);
        }
        //owp
        for(int i = 0; i<N; i++){
            double owps=0.0;
            int db = 0;
            for(int j =0; j <N; j++){
                if(j != i){
                    if(g[i][j] != 0){ //csak ellenfelekre
                        db++;
                        if(g[i][j]==1){
                            owps += (double)(won[j]) / (won[j]-1+lost[j]);
                        } else {
                            owps += (double)(won[j]-1) / (won[j]-1+lost[j]);
                        }
                    }
                }
            }
            owp[i] = owps / db;
        }

        //oowp
        for(int i = 0; i<N; i++){
            double oowps=0.0;
            int db=0;
            for(int j =0; j <N; j++){
                if(j != i){
                    if(g[i][j] != 0){ //csak ellenfelekre
                        db++;
                        oowps += owp[j];
                    }
                }
            }
            oowp[i] = oowps / db;
        }

        
    }
    
    public void print(){
        for(int i=0; i<N; i++){
            rpi[i] = 0.25*wp[i]+0.5*owp[i]+0.25*oowp[i];
            System.out.format(Locale.US,"%.10f\n", rpi[i]);
        }
    
    }



}

public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        // TODO code application logic here
        BufferedReader be = new BufferedReader(new FileReader("As.in"));
        int T = Integer.parseInt(be.readLine());
        for(int i=1; i<= T; i++){
            Games G = new Games(be);
            System.out.println("Case #"+i+":");
            G.solve();
            G.print();
        }

    }

}
