import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;


public class Main {
	
	static boolean isfair(BigInteger num)
	{
		BigInteger refl = BigInteger.ZERO;
		BigInteger copy = new BigInteger(num.toByteArray());
		
		while (!copy.equals(BigInteger.ZERO))
		{
			refl = refl.multiply(BigInteger.TEN);
			refl = refl.add(copy.mod(BigInteger.TEN));
			copy = copy.divide(BigInteger.TEN);
		}
		
		if (num.equals(refl))
			return true;
		
		return false;
	}
	
	static boolean issquare(BigInteger num)
	{
		if (num.equals(BigInteger.ZERO) || num.equals(BigInteger.ONE))
			return true;
		
		BigInteger two = new BigInteger("2");
		BigInteger min = BigInteger.ONE;
		BigInteger max = num;
		
		while(min.add(BigInteger.ONE).compareTo(max) == -1)
		{
			BigInteger mid = min.add(max).divide(two);
			//System.out.println(min + " " + max);
			int comp = mid.multiply(mid).compareTo(num);
			if (comp == 0)
			{
				return isfair(mid);
			}
			if (comp == -1)
				min = mid;
			else
				max = mid;
		}
		
		return false;
	}

	public static void main(String[] args) {
		
		if (args.length != 2)
		{
			System.out.println("Input infile and outfile");
			return;
		}
		Scanner fin;
		PrintWriter fout;
		try {
			fin = new Scanner(new File(args[0]));
			fout = new PrintWriter(new File(args[1]));
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			return;
		}
		
		int T = fin.nextInt();
		for (int t = 1; t <= T; t++)
		{
			BigInteger A = fin.nextBigInteger();
			BigInteger B = fin.nextBigInteger();
			B = B.add(BigInteger.ONE);
			BigInteger C = BigInteger.ZERO;
			
			while (!A.equals(B))
			{
				//System.out.println(A + ": " + (isfair(A) && issquare(A)));
				if (isfair(A) && issquare(A))
				C = C.add(BigInteger.ONE);
				A = A.add(BigInteger.ONE);
			}
			
			fout.format("Case #%d: %s\n", t, C.toString());
			
		}
		fout.close();
		fin.close();
		
	}

}
