import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Main {

	public static void main(String[] args) {
		try {
			File inputFile = new File("//home/elliot/Downloads/B-small-attempt2.in");
			File outputFile = new File("/home/elliot/B-small.out");
			if(outputFile.exists())
				outputFile.delete();
			outputFile.createNewFile();
			FileReader fr = new FileReader(inputFile);
			BufferedReader br = new BufferedReader(fr);
			FileWriter fw = new FileWriter(outputFile,true);
			BufferedWriter bw = new BufferedWriter(fw);
			
			int numCases = Integer.parseInt(br.readLine());
			for(int i = 0; i < numCases; i++ ){
				String dimensions = br.readLine();
				Integer rows = Integer.parseInt(dimensions.split("\\s")[0]);
				Integer cols = Integer.parseInt(dimensions.split("\\s")[1]);
				Integer[][] lawn = new Integer[rows][cols];
				for(int j = 0; j < rows; j++){
					String row = br.readLine();
					for(int k = 0; k < cols; k++)
						lawn[j][k] = Integer.parseInt(row.split("\\s")[k]);
				}
				String result = solve(lawn, rows, cols);
				bw.write("Case #" + (i+1) + ": " + result);
				bw.newLine();
			}
			bw.flush();
			bw.close();
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public static String solve(Integer[][] lawn, Integer rows, Integer cols) {
		Integer maxRows[] = new Integer[rows];
		Integer maxCols[] = new Integer[cols];
		for(int i = 0; i < rows; i++)
			maxRows[i] = max(lawn[i]);
		for(int i = 0; i < cols; i++)
			maxCols[i] = max(getColumn(lawn, i, rows));
		
		for(int i = 0; i < rows; i++)
			for(int j = 0; j < cols; j++) {
				if(lawn[i][j] < maxRows[i] && lawn[i][j] < maxCols[j])
					return "NO";
			}
		return "YES";
	}
	
	public static Integer max(Integer[] array) {
		Integer maximum = 0;
		for(Integer integer : array )
			if(integer>maximum)
				maximum=integer;
		return maximum;
	}
	
	public static Integer[] getColumn( Integer[][] array, int column, Integer numRows){
		Integer vector[] =  new Integer[numRows];
		for(int i = 0; i < numRows; i++)
			vector[i]=array[i][column];
		return vector;
	}
}
