import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Main {


	public static void main(String[] args) {
		try {
			File inputFile = new File("/home/elliot/Downloads/A-small-attempt0.in");
			File outputFile = new File("/home/elliot/A-small.out");
			if(outputFile.exists())
				outputFile.delete();
			outputFile.createNewFile();
			FileReader fr = new FileReader(inputFile);
			BufferedReader br = new BufferedReader(fr);
			FileWriter fw = new FileWriter(outputFile,true);
			BufferedWriter bw = new BufferedWriter(fw);
			
			int numCases = Integer.parseInt(br.readLine());
			for(int i = 0; i < numCases; i++ ){
				char board[][] = new char[4][4];
				for(int j = 0; j < 4; j++) {
					String row = br.readLine();
					board[j] = row.toCharArray();
				}
				String outcome = checkBoard(board);
				bw.write("Case #" + (i+1) + ": " + outcome);
				bw.newLine();
				if(i != numCases-1)
					br.readLine();
			}
			bw.flush();
			bw.close();
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static String checkBoard(char[][] board) {
		String fullBoard = new String();
		for(int i = 0; i < 4; i++) {
			//if Four in a row - win
			String row = new String(board[i]);
			fullBoard += row;
			String rowX = row.replace("T", "X");
			if(rowX.equals("XXXX"))
				return "X won";
			String rowO = row.replace("T", "O");
			if(rowO.equals("OOOO"))
				return  "O won";

			//else if Four in a column - win
			String col = new String();
			for(int j = 0; j < 4; j++)
				col += board[j][i];
			String colX = col.replace("T", "X");
			if(colX.equals("XXXX"))
				return "X won";
			String colO = col.replace("T", "O");
			if(colO.equals("OOOO"))
				return  "O won";			
		}
		//else if Four diagonal - win
		String diag1 = new String();
		String diag2 = new String();
		for(int i = 0; i < 4; i++) 
			diag1 += board[i][i];
		for(int i = 3; i > -1; i--)
			diag2 += board[3-i][i];
		String diagX = diag1.replace("T", "X");
		if(diagX.equals("XXXX"))
			return "X won";
		diagX = diag2.replace("T", "X");
		if(diagX.equals("XXXX"))
			return "X won";
		String diagO = diag1.replace("T", "O");
		if(diagO.equals("OOOO"))
			return "O won";
		diagO = diag2.replace("T", "O");
		if(diagO.equals("OOOO"))
			return "O won";	
		
		//else if Full Board - Draw
		if(!fullBoard.contains("."))
			return "Draw";
		//else - Not Complete
		return "Game has not completed";
	}
}
