

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.PriorityQueue;
import java.util.Scanner;

// Using the Google Guava library.
public class A {

	public static void main(String [] args) throws IOException {
		String inputFile = "src/A-small-attempt0.in";
		Scanner in = new Scanner(new File(inputFile));
		PrintStream out = new PrintStream(inputFile.substring(0, inputFile.length()-2)+"out");
		int cases = in.nextInt();
		for (int cs = 1; cs <= cases; cs++) {
			int r = in.nextInt();
			int c = in.nextInt();
			Board init = new Board(r, c);
			List<Character> letters = new ArrayList<>();
			for (int i = 0; i < r; i++) {
			    String row = in.next();
			    for (int j = 0; j < c; j++) {
			        char cur = row.charAt(j);
                    init.set(i, j, cur);
                    if (cur != '?') {
                        letters.add(cur);
                    }
			    }
			}
			init.letters = letters;

			PriorityQueue<Board> q = new PriorityQueue<>();
			q.add(init);
			while(true) {
			    Board cur = q.remove();
			    if (cur.isComplete()) {
			        init = cur;
			        break;
			    }
			    q.addAll(cur.successors());
			}
			String ans = "Case #"+cs+":\n"+init;
			out.println(ans);
			System.out.println(ans);
		}
		out.close();
		in.close();
	}

	private static class Board implements Comparable<Board> {
	    char cake [][];
	    int r, c;
	    final int size;
	    int filled = 0;
	    List<Character> letters;

	    private Board(int r, int c) {
	        this.r = r;
	        this.c = c;
	        cake = new char[r][c];
            for (int i = 0; i < r; i++) {
                for (int j = 0; j < c; j++) {
                    cake[i][j] = '?';
                }
            }
	        size = r * c;
	    }

	    private Board copy() {
	        Board b = new Board(r, c);
            for (int i = 0; i < r; i++) {
                for (int j = 0; j < c; j++) {
                    b.set(i, j, cake[i][j]);
                }
            }
	        b.letters = new ArrayList<>(letters);
	        b.letters.remove(letters.size() - 1);
	        return b;
	    }

	    private List<Board> successors() {
	        List<Board> ret = new ArrayList<>();
	        if (letters.isEmpty()) {
	            return ret;
	        }
	        char cur = letters.get(letters.size() - 1);
	        for (int rs = 0; rs < r; rs++) {
	            for (int re =rs; re < r; re++) {
	                for (int cs = 0; cs < c; cs++) {
	                    for (int ce = cs; ce < c; ce++) {
	                        if (onlyHas(cur, rs, re, cs, ce)) {
	                            Board cpy = copy();
	                            cpy.fill(cur, rs, re, cs, ce);
	                            ret.add(cpy);
	                        }
	                    }
	                }
	            }
	        }
	        return ret;
	    }

	    private boolean onlyHas(char cur, int rs, int re, int cs, int ce) {
	        boolean found = false;
	        for (int i = rs; i <= re; i++) {
	            for (int j = cs; j <= ce; j++) {
	                char ij = cake[i][j];
	                found |= ij == cur;
	                if (ij != '?' && ij != cur) {
	                    return false;
	                }
	            }
	        }
	        return found;
	    }

	    private void fill(char cur, int rs, int re, int cs, int ce) {
            for (int i = rs; i <= re; i++) {
                for (int j = cs; j <= ce; j++) {
                    set(i, j, cur);
                }
            }
        }

	    private void set(int r, int c, char i) {
	        char prev = cake[r][c];
	        cake[r][c] = i;
	        if (i != '?' && prev == '?') {
	            filled++;
	        }
	    }

        @Override
        public int compareTo(Board o) {
            return o.filled - filled;
        }

        boolean isComplete() {
            return filled == size;
        }

        @Override
        public String toString() {
            String s = "";
            for (char[] row : cake) {
                for (char c : row) {
                    s = s + c;
                }
                s += "\n";
            }
            s = s.substring(0, s.length() - 1);
            return s;
        }

	}
}
