

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import com.google.common.collect.Lists;

//Using the Google Collections library.
public class B {

	public static void main(String [] args) throws IOException {
		String inputFile = "src/B-small-0.in";
		Scanner in = new Scanner(new File(inputFile));
		PrintStream out = new PrintStream(inputFile.substring(0, inputFile.length()-2)+"out");
		int cases = in.nextInt();
		for (int c = 1; c <= cases; c++) {
			int numWords = in.nextInt();
			int numSequences = in.nextInt();
			List<List<String>> words = Lists.newArrayList();
			List<String> allWords = Lists.newArrayList();
			for (int i = 0; i <= 10; i++)
				words.add(new ArrayList<String>());
			List<String> sequences = Lists.newArrayList();
			for (int i = 0; i < numWords; i++) {
				String w = in.next();
				words.get(w.length()).add(w);
				allWords.add(w);
			}
			for (int i = 0; i < numSequences; i++)
				sequences.add(in.next());
			out.print("Case #"+c+":");
			for (String seq : sequences) {
				String worst = null;
				int mostPoints = -1;
				for (String word : allWords) {
					List<String> cur = words.get(word.length());
					int points = 0;
					int index = 0;
					char [] letters = new char [word.length()];
					int correct = 0;
					List<String> valid = cur; 
					while (correct < word.length()) {
						while (isInvalid(valid, seq.charAt(index)))
							index++;
						char curLetter = seq.charAt(index);
						if (word.indexOf(curLetter) >= 0) {
							for (int i = 0; i < word.length(); i++) {
								if (word.charAt(i) == curLetter) {
									letters[i] = curLetter;
									correct++;
								}
							}
							valid = filter(valid, letters, curLetter);
						} else {
							points++;
							valid = filter(valid, curLetter);
						}
						index++;
					}
					if (points > mostPoints) {
						mostPoints = points;
						worst = word;
					}
				}
				out.print(" " + worst);
			}
			out.println();
		}
		out.close();
	}
	
	private static boolean isInvalid(List<String> words, char letter) {
		for (String word : words)
			if (word.indexOf(letter) >= 0)
				return false;
		return true;
	}
	
	private static List<String> filter(List<String> words, char [] letters, char curLetter) {
		List<String> ret = Lists.newArrayList();
		for (String word : words) {
			boolean add = true;
			for (int i = 0; i < letters.length; i++)
				if ((letters[i] > 0 && word.charAt(i) != letters[i]) || 
						(letters[i] == 0 && word.charAt(i) == curLetter)) {
					add = false;
					break;
				}
			if (add)
				ret.add(word);
		}
		return ret;
	}
	
	private static List<String> filter(List<String> words, char letter) {
		List<String> ret = Lists.newArrayList();
		for (String word : words) {
			if (word.indexOf(letter) < 0)
				ret.add(word);
		}
		return ret;
	}
}
