

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.List;
import java.util.Scanner;

import com.google.common.collect.Lists;

// Using the Google Collections library.
public class A {

	public static void main(String [] args) throws IOException {
		String inputFile = "src/A-small-0.in";
		Scanner in = new Scanner(new File(inputFile));
		PrintStream out = new PrintStream(inputFile.substring(0, inputFile.length()-2)+"out");
		int cases = in.nextInt();
		for (int c = 1; c <= cases; c++) {
			int steps = in.nextInt();
			List<Action> oActions = Lists.newArrayList();
			List<Action> bActions = Lists.newArrayList();
			for (int s = 1; s <= steps; s++) {
				String robot = in.next();
				int loc = in.nextInt();
				Action act = new Action(loc, s);
				if ("O".equals(robot))
					oActions.add(act);
				else
					bActions.add(act);
			}
			int bPos = 1;
			int oPos = 1;
			int curStep = 1;
			int oAct = 0;
			int bAct = 0;
			int t = 0;
			while(curStep <= steps) {
				Action oAction = null;
				Action bAction = null;
				if (oAct < oActions.size())
					oAction = oActions.get(oAct);
				if (bAct < bActions.size())
					bAction = bActions.get(bAct);
				boolean oMoved = false, bMoved = false;
				if (oAction != null && oPos != oAction.loc) {
					oPos += (oPos > oAction.loc) ? -1 : 1;
					oMoved = true;
				}
				if (bAction != null && bPos != bAction.loc) {
					bPos += (bPos > bAction.loc) ? -1 : 1;
					bMoved = true;
				}
				if (oAction != null && !oMoved && oPos == oAction.loc && oAction.step == curStep) {
					oAct++;
					curStep++;
				} else if (bAction != null && !bMoved && bPos == bAction.loc && bAction.step == curStep) {
					bAct++;
					curStep++;
				}
				t++;
			}
			
			out.print("Case #"+c+": "+t);
			out.println();
		}
		out.close();
	}
	
	private static class Action {
		int loc;
		int step;
		public Action(int loc, int step) {
			this.loc = loc;
			this.step = step;
		}
	}
}
