

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

import com.google.common.collect.Lists;

// Using the Google Guava library.
public class A {

	public static void main(String [] args) throws IOException {
		String inputFile = "src/A-small-0.in";
		Scanner in = new Scanner(new File(inputFile));
		PrintStream out = new PrintStream(inputFile.substring(0, inputFile.length()-2)+"out");
		int cases = in.nextInt();
		for (int cs = 1; cs <= cases; cs++) {
			int n = in.nextInt();
			int m = in.nextInt();
			long baseCost = 0, finalCost = 0;
			List<Journey> journies = Lists.newArrayList();
			for (int i = 0; i < m; i++) {
				Journey j = new Journey(in.nextInt(), in.nextInt(), in.nextInt());
				journies.add(j);
				baseCost += j.cost(n);
			}
			Collections.sort(journies);
			for (int i = 0; i < journies.size(); i++) {
				Journey cur = journies.get(i);
				if (cur.travellers == 0) {
					continue;
				}
				List<Journey> toAdd = Lists.newArrayList();
				for (Journey j : journies) {
					if (j.travellers > 0 && j.start < cur.start && j.stop < cur.stop &&
							cur.start <= j.stop) {
						int toMove = Math.min(cur.travellers, j.travellers);
						toAdd.add(new Journey(j.start, cur.stop, toMove));
						toAdd.add(new Journey(cur.start, j.stop, toMove));
						cur.travellers -= toMove;
						j.travellers -= toMove;
						if (cur.travellers == 0)
							break;
					}
				}
				journies.addAll(toAdd);
			}
			for (Journey j : journies) {
				finalCost += j.cost(n);
			}
			long diff = baseCost - finalCost;
			
			String ans = "Case #"+cs+": "+diff;
			out.print(ans);
			out.println();
			System.out.println(ans);
		}
		out.close();
	}
	
	private static class Journey implements Comparable<Journey> {
		int start;
		int stop;
		int travellers;
		
		public Journey(int start, int stop, int travellers) {
			this.start = start;
			this.stop = stop;
			this.travellers = travellers;
		}
		
		public long cost(int n) {
			if (start == stop)
				return 0;
			int dist = stop - start;
			return (long) travellers*((dist)*n - dist * (dist-1L) / 2); 
		}

		@Override
		public int compareTo(Journey o) {
			return start - o.start;
		}
	}
}
