

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.List;
import java.util.Scanner;

// Using the Google Guava library.
public class C {

	public static void main(String [] args) throws IOException {
		String inputFile = "src/C-small-attempt0.in";
		Scanner in = new Scanner(new File(inputFile));
		PrintStream out = new PrintStream(inputFile.substring(0, inputFile.length()-2)+"out");
		int cases = in.nextInt();
		for (int cs = 1; cs <= cases; cs++) {
		    int n = in.nextInt();
		    int j = in.nextInt();
		    BitSet bs = new BitSet(n);
		    bs.set(0);
		    bs.set(n-1);
		    
		    StringBuilder buf = new StringBuilder();
		    List<BigInteger> primes = getPrimesBelow(10000);
		    while (j > 0) {
		        BigInteger [] solutions = new BigInteger[9];
		        boolean solutionFound = true;
		        for (int i = 2; i <= 10 && solutionFound; i++) {
                    BigInteger bigI = BigInteger.valueOf(i);
		            BigInteger val = BigInteger.ONE;
		            for (int k = 1; k < n; k++) {
		                if (bs.get(k)) {
                            val = val.add(bigI.pow(k));
		                }
		            }
		            BigInteger divisor = null;
		            for (BigInteger p : primes) {
		                if (val.mod(p).equals(BigInteger.ZERO)) {
		                    divisor = p;
		                    break;
		                }
		            }
		            if (divisor == null) {
		                solutionFound = false;
		            } else {
		                solutions[i-2] = divisor;
		            }
		        }
		        if (solutionFound) {
		            buf.append("\n");
		            for (int i = n-1; i >= 0; i--) {
		                buf.append(bs.get(i) ? "1" : "0");
		            }
		            for (BigInteger s : solutions) {
		                buf.append(" ").append(s);
		            }
		            j--;
		        }
		        boolean ki = true;
		        for (int i = 1; i < n && ki; i++) {
		            ki = bs.get(i);
		            bs.set(i, !ki);
		        }
		    }
			String ans = "Case #"+cs+": "+buf.toString();
			out.println(ans);
			System.out.println(ans);
		}
		out.close();
		in.close();
	}

    public static List<BigInteger> getPrimesBelow(int number) {
        List<BigInteger> result = new ArrayList<>();
        // Run the sieve of Eratosthenes
        boolean [] isComposite = new boolean[number];
        for (int i = 2; i<isComposite.length; i++) {
            if (!isComposite[i]) {
                result.add(BigInteger.valueOf(i));
                for (int j=2*i; j<isComposite.length; j += i) {
                    isComposite[j] = true;
                }
            }
        }
        return result;
    }
}
