

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

import com.google.common.collect.Lists;

// Using the Google Collections library.
public class A {

	public static void main(String [] args) throws IOException {
		String inputFile = "src/A-large-0.in";
		Scanner in = new Scanner(new File(inputFile));
		PrintStream out = new PrintStream(inputFile.substring(0, inputFile.length()-2)+"out");
		int cases = in.nextInt();
		for (int c = 1; c <= cases; c++) {
			double x = in.nextInt();
			double s = in.nextInt();
			double r = in.nextInt();
			double t = in.nextInt();
			int n = in.nextInt();
			List<Walkway> walkways = Lists.newArrayList();
			for (int i = 0; i < n; i++) {
				Walkway w = new Walkway(in.nextInt(), in.nextInt(), s + in.nextInt());
				walkways.add(w);
			}
//			Collections.sort(walkways);
			List<Walkway> path = Lists.newArrayList();
			double pos = 0;
			for (Walkway w : walkways) {
				if (w.e <= x) {
					if (w.b > pos) {
						path.add(new Walkway(pos, w.b, s));
						pos = w.b;
					}
					path.add(w);
					pos = w.e;
				}
			}
			if (pos < x)
				path.add(new Walkway(pos, x, s));
			Collections.sort(path);
			double rtl = t;
			double time = 0;
			for (Walkway w : path) {
				if (rtl > 0) {
					Walkway rw = new Walkway(w.b, w.e, w.w + r - s);
					if (rw.time() < rtl) {
						rtl -= rw.time();
						time += rw.time();
					} else {
						time += rtl;
						double runDist = (w.e - w.b) * rtl / rw.time();
						time += (w.e - w.b - runDist) / w.w;
						rtl = 0;
					}
				} else {
					time += w.time();
				}
			}
			out.print("Case #"+c+": "+time);
			out.println();
		}
		out.close();
	}
	
	private static class Walkway implements Comparable<Walkway> {
		double b;
		double e;
		double w;
		public Walkway(double b, double e, double w) {
			this.b = b;
			this.e = e;
			this.w = w;
		}
		
		public int compareTo(Walkway o) {
			return (int) w - (int) o.w;
		}
		
		public double time() {
			return (e - b) / w;
		}

		@Override
		public String toString() {
			return "Walkway [b=" + b + ", e=" + e + ", w=" + w + "]";
		}
		
	}
}
