import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class Round1B2 {
	public static void main( String[] args ) throws IOException {
		BufferedReader f = new BufferedReader(new FileReader("B-small-attempt2.in"));
	    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("B-small-attempt2.out")));
	    int tests = Integer.decode(f.readLine());
	    for(int i = 1; i <= tests; i++) {
	    	StringTokenizer st = new StringTokenizer(f.readLine());
		    int num = Integer.valueOf(st.nextToken());
		    int least = Integer.valueOf(st.nextToken());
		    int barn = Integer.valueOf(st.nextToken());
		    int time = Integer.valueOf(st.nextToken());
		    ArrayList<Chick> chicks = new ArrayList<Chick>();
		    st = new StringTokenizer(f.readLine());
		    StringTokenizer st2 = new StringTokenizer(f.readLine());
		    for(int j = 0; j < num; j++) {
		    	chicks.add(new Chick(Integer.valueOf(st.nextToken()), Integer.valueOf(st2.nextToken()), barn));
		    }
		    Comparator comp = new ChickCompare();
		    ArrayList<Chick> chickpos = (ArrayList<Chick>) chicks.clone();
		    Collections.sort(chickpos, comp);
		    Collections.sort(chicks);
		    int swaps = 0;
		    for(int j = 0; j < least; j++) {
		    	Chick c = chicks.get(j);
		    	if(c.val > time) {
		    		swaps = -1;
		    		break;
		    	}
		    	int q = chickpos.indexOf(c);
		    	swaps += q - 1;
		    }
		    
		    String x = "Case #" + i + ": " + (swaps < 0 ? "IMPOSSIBLE": "" + swaps);
		    out.println(x);
		    System.out.println(x);
	    	
	    }	    
	    
	    out.close();
	}
	
	
	public static TreeSet<String> getDir(String s) {
	    TreeSet<String> dirs = new TreeSet<String>();
	    int d = s.indexOf('/', 2);
		while( d > 0 ) {
			dirs.add(s.substring(0, d));
			d = s.indexOf('/', d + 1);
		}
		dirs.add(s);
		return dirs;
	}
}

class Chick implements Comparable {
	int pos;
	double speed;
	double barn;
	double val;
	Chick(int pos, double speed, double barn) {
		this.pos = pos;
		this.speed = speed;
		this.barn = barn;
		val = (barn - pos) / speed;
	}

	public int compareTo(Object other) {
		double x = this.val - ((Chick) other).val;
		if(x > 0) return 1;
		if(x < 0) return -1;
		return this.pos - ((Chick) other).pos;
	}
	
	public String toString() {
		return val + " " + pos;
	}
}

class ChickCompare implements Comparator<Chick>{

    public int compare(Chick a, Chick b) {
        return b.pos - a.pos;
    }
}