import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Jam3 {
    private static final String CASE_NUMBER = "Case #";
    private static final String COLON = ": ";
    private static final String SPACE = " ";
	private static int caseCounter = 1;

	public static void main(String[] args) throws IOException {
    	String inputFileName = "C-small-attempt0.in";
    	List<String> outputFile = new ArrayList<>();
    
    	try (Scanner scanner = new Scanner(new File(inputFileName))) {
    		int cases = scanner.nextInt();
    		for(int i=0; i<cases ; i++) {
        		writeSolutionLineToFile(outputFile, solution(scanner.nextInt(), scanner.nextInt()));
        		caseCounter++;
        	}

		} catch (IOException e) {
			e.printStackTrace();
		}
    	Files.write(Paths.get("out.txt"), outputFile);
    }

	private static List<List<Long>> solution(int N, int J) {
		List<List<Long>> solutions = new ArrayList<>();

		long b = (long) Math.pow(2, N-2);
		
		for (long k = 0 ; k < b; k++) {
			List<Long> divs = new ArrayList<>();
			String bin = Long.toBinaryString(k);
			String binary = String.format("%0"+(N-2)+"d", Long.valueOf(bin));
			binary = "1" + binary + "1";
			divs.add(Long.valueOf(binary));
			for (int i=2 ; i<11 ; i++) {
				long candidate = convertToDecimalInRadix(binary,i);
				long div = isPrime(candidate);
				if (div < 0) {
					break;
				} else {
					divs.add(div);
				}
			}
			if (divs.size() == 10) {
				solutions.add(divs);
			} else {
				divs.clear();
			}
			if (solutions.size() == J) {
				break;
			}
		}
		
		return solutions;
	}
	
	private static Long convertToDecimalInRadix(String input, int radix) {
		return Long.parseLong(input, radix);
	}
	
	private static void writeSolutionLineToFile(List<String> outputFile, List<List<Long>> solutions) {
		outputFile.add(CASE_NUMBER + caseCounter + COLON);
		for (List<Long> l : solutions) {
			StringBuilder b = new StringBuilder();
			for (Long m : l) {
				b.append(m).append(SPACE);
			}
			outputFile.add(b.toString());
		}
		
	}
	
	private static long isPrime (long n) {
		if (n < 2) {
			return 1;
		}
		if (n == 2 || n == 3) {
			return -1;
		}
		if (n % 2 == 0) {
			return 2;
		}
		if (n % 3 == 0) {
			return 3;
		}
		long sqrtN = (long) Math.sqrt(n) + 1;
		for (long i = 6L; i <= sqrtN; i += 6) {
			if (n % (i - 1) == 0) {
				return (i - 1);
			}
			if (n % (i + 1) == 0) {
				return (i + 1);
			}
		}
		return -1;
	}
}

