import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class Jam2 {
    private static final String CASE_NUMBER = "Case #";
    private static final String COLON = ": ";
	private static int caseCounter = 1;
	static int counter1 = 0;
	static int counter2 = 0;
	static int counter3 = 0;
	static int K = 0;

	public static void main(String[] args) throws IOException {
    	String inputFileName = "C-small-attempt3.in";
    	List<String> outputFile = new ArrayList<>();
    
    	try (Scanner scanner = new Scanner(new File(inputFileName))) {
    		int cases = scanner.nextInt();
    		for(int i=0; i<cases ; i++) {
        		writeSolutionLineToFile(outputFile, solution(scanner));
        		caseCounter++;
        	}

		} catch (IOException e) {
			e.printStackTrace();
		}
    	Files.write(Paths.get("out.txt"), outputFile);
    }

	private static String solution(Scanner scanner) {
		int J = scanner.nextInt();
		int P = scanner.nextInt();
		int S = scanner.nextInt();
		K = scanner.nextInt();
		counter1 = 0;
		counter2 = 0;
		counter3 = 0;
		
		Map<String,String> outfits = new HashMap<>();
		Map<String,Integer> pairs1 = new HashMap<>();
		Map<String,Integer> pairs2 = new HashMap<>();
		Map<String,Integer> pairs3 = new HashMap<>();
		
		for(int j=0;j<J;j++) {
			for(int p = 0;p<P;p++) {
				for(int s = 0;s<S;s++) {
					addOutfit(outfits, j+1,p+1,s+1, pairs1, pairs2, pairs3);
				}
			}
		}
		return mapToSoultionString(outfits);
	}
	
	private static String mapToSoultionString(Map<String,String> outfits) {
		
		StringBuilder sb = new StringBuilder();
		sb.append(outfits.size());
		for(Map.Entry<String , String> s : outfits.entrySet()) {
			sb.append("\n").append(s.getValue());
		}
		return sb.toString();
	}
	
	
	private static void remove(Map<String,Integer> map, int j, int p) {
		StringBuilder sb = new StringBuilder();
		String key = sb.append(j).append(p).toString();
		
		if (map.get(key) == 1) {
			map.remove(key);
		} else {
			map.put(key, map.get(key)-1);
		}
	}
	
	private static boolean add(Map<String,Integer> map, int j, int p) {
		StringBuilder sb = new StringBuilder();
		String key = sb.append(j).append(p).toString();
		if(map.containsKey(key)) {
			if(map.get(key) >= K) {
				map.put(key, map.get(key)+1);
				return false;
			}
			map.put(key, map.get(key)+1);
		} else {
			map.put(key,1);
		}
		return true;
	}
	
	private static void addOutfit(Map<String,String> map, int j, int p, int s, 
			Map<String,Integer> pairs1, Map<String,Integer> pairs2,Map<String,Integer> pairs3) {
		StringBuilder sb = new StringBuilder();
		sb.append(j).append(" ").append(p).append(" ").append(s);
		if(map.put(sb.toString(),sb.toString()) == null) {
			boolean o = add(pairs1, j, p);
			boolean t = add(pairs2, j, s);
			boolean h = add(pairs3, p, s);
			if(!o || !t || !h) {
				map.remove(sb.toString(),sb.toString());
				remove(pairs1, j, p);
				remove(pairs2, j, s);
				remove(pairs3, p, s);
			}
		}
	}

	private static void writeSolutionLineToFile(List<String> outputFile, String solution) {
		outputFile.add(CASE_NUMBER + caseCounter + COLON + solution);
	}
}

