import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class Jam1 {
    private static final String CASE_NUMBER = "Case #";
    private static final String COLON = ": ";
	private static int caseCounter = 1;

	public static void main(String[] args) throws IOException {
    	String inputFileName = "A-large.in";
    	List<String> outputFile = new ArrayList<>();
    
    	try (Scanner scanner = new Scanner(new File(inputFileName))) {
    		int cases = scanner.nextInt();
    		for(int i=0; i<cases ; i++) {
        		writeSolutionLineToFile(outputFile, solution(scanner));
        		caseCounter++;
        	}

		} catch (IOException e) {
			e.printStackTrace();
		}
    	Files.write(Paths.get("out.txt"), outputFile);
    }

	private static String solution(Scanner scanner) {
		int parties = scanner.nextInt();
		scanner.nextLine();
		String input = scanner.nextLine();
		String [] a = input.split(" ");
		List<Integer> distribution = new ArrayList<>();
		int sum = 0;
		StringBuilder sb = new StringBuilder();
		for (String p : a) {
			Integer val = Integer.valueOf(p);
			sum += val;
			distribution.add(Integer.valueOf(p));
		}
		
		while (getSum(distribution) > 0) {
			for(int i=0; i<distribution.size(); i++) {
				for(int j=0; j<distribution.size(); j++) {
					removeAtIndexes(distribution,i,j,sb);
					if(getSum(distribution) == 0) {
						break;
					}
				}
			}
			for(int i=0; i<distribution.size(); i++) {
				removeAtIndexes(distribution,i,-1,sb);
				if(getSum(distribution) == 0) {
					break;
				}
			}
		}
		
		return sb.toString();
	}
	
	private static boolean checkIfPossible(List<Integer> in, int i, int j) {
		if(j == -1) {
			if(in.get(i) > 0) {
				return true;
			} else {
				return false;
			}
		} else {
			if(i == j) {
				if(in.get(i) > 1) {
					return true;
				}
			} else {
				if(in.get(i) > 0 && in.get(j) > 0) {
					return true;
				} else {
					return false;
				}
			}
		}
		return false;
	}
	
	private static boolean removeAtIndexes(List<Integer> in, int i, int j, StringBuilder sb) {
		if(checkIfPossible(in, i, j)) {
			in.set(i, in.get(i)-1);
			if(j >= 0) {
				in.set(j, in.get(j)-1);
			}
			if(isMaxLessThenHalf(in)) {
				addToSolution(i,j,sb);
				return true;
			} else {
				in.set(i, in.get(i)+1);
				if(j >= 0) {
					in.set(j, in.get(j)+1);
				}
				return false;
			}
		} else {
			return false;
		}
		
	}
	
	private static boolean isMaxLessThenHalf(List<Integer> in) {
		return getMax(in) <= getSum(in)/2;
	}
	
	private static int getMax(List<Integer> in) {
		return Collections.max(in);
	}
	
	private static int getSum(List<Integer> in) {
		int sum = 0;
		for (Integer p : in) {
			sum += p;
		}
		return sum;
	}
	
	private static StringBuilder addToSolution(int i, int j, StringBuilder sb) {
		sb.append((char)(i+65));
		if(j != -1) {
			sb.append((char)(j+65));
		}
		sb.append(" ");
		return sb;
	}

	private static void writeSolutionLineToFile(List<String> outputFile, String solution) {
		outputFile.add(CASE_NUMBER + caseCounter + COLON + solution);
	}
}

