import java.io.File;
import java.io.IOException;
import java.math.BigDecimal;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

public class Jam1 {
    private static final String CASE_NUMBER = "Case #";
    private static final String COLON = ": ";
	private static int caseCounter = 1;

	public static void main(String[] args) throws IOException {
    	String inputFileName = "A-small-attempt0.in";
    	List<String> outputFile = new ArrayList<>();
    
    	try (Scanner scanner = new Scanner(new File(inputFileName))) {
    		int cases = scanner.nextInt();
    		for(int i=0; i<cases ; i++) {
    			long startingNumber = scanner.nextLong();
        		writeSolutionLineToFile(outputFile, solution(startingNumber));
        		caseCounter++;
        	}

		} catch (IOException e) {
			e.printStackTrace();
		}
    	Files.write(Paths.get("out.txt"), outputFile);
    }

	private static String solution(long N) {
		Set<Character> solutionTable = new HashSet<>();
		BigDecimal intial = new BigDecimal(0);
		BigDecimal bigN = new BigDecimal(N);
		if (N == 0) {
			return "INSOMNIA";
		}
		while (solutionTable.size() != 10) {
			intial = intial.add(bigN);
			for(Character c : String.valueOf(intial).toCharArray()) {
				solutionTable.add(c);
			}
		}
		return intial.toString();
	}

	private static void writeSolutionLineToFile(List<String> outputFile, String solution) {
		outputFile.add(CASE_NUMBER + caseCounter + COLON + solution);
	}
}

