import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Jam1 {
    private static final String CASE_NUMBER = "Case #";
    private static final String COLON = ": ";
	private static int caseCounter = 1;

	public static void main(String[] args) throws IOException {
    	String inputFileName = "A-large.in";
    	List<String> outputFile = new ArrayList<>();
    
    	try (Scanner scanner = new Scanner(new File(inputFileName))) {
    		int cases = scanner.nextInt();
    		for(int i=0; i<cases ; i++) {
    			StringBuilder pancakeLine = new StringBuilder(scanner.next());
    			int flips = scanner.nextInt();
        		writeSolutionLineToFile(outputFile, solution(pancakeLine, flips));
        		caseCounter++;
        	}

		} catch (IOException e) {
			e.printStackTrace();
		}
    	Files.write(Paths.get("out.txt"), outputFile);
    }

	private static String solution(StringBuilder line, int flips) {
		int r = 0;
		for (int i = 0; i < line.length() - flips + 1; i++) {
			if (line.charAt(i) == '-') {
				for (int j = 0; j < flips; j++) {
					line.setCharAt(i + j, line.charAt(i + j) == '-' ? '+' : '-');
				}
				r++;
			}
		}

		for (int i = line.length() - flips; i < line.length(); ++i) {
			if (line.charAt(i) == '-') {
				return "IMPOSSIBLE";
			}
		}
		return String.valueOf(r);
	}

	private static void writeSolutionLineToFile(List<String> outputFile, String solution) {
		outputFile.add(CASE_NUMBER + caseCounter + COLON + solution);
	}
}

