import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Jam2 {
	private static final String CASE_NUMBER = "Case #";
	private static final String COLON = ": ";
	private static int caseCounter = 1;

	public static void main(String[] args) throws IOException {
		String inputFileName = "B-small-attempt0.in";
		List<String> outputFile = new ArrayList<>();

		try (Scanner scanner = new Scanner(new File(inputFileName))) {
			int cases = scanner.nextInt();
			for (int i = 0; i < cases; i++) {
				StringBuilder input = new StringBuilder(scanner.next());
				writeSolutionLineToFile(outputFile, solution(input));
				caseCounter++;
			}

		} catch (IOException e) {
			e.printStackTrace();
		}
		Files.write(Paths.get("out.txt"), outputFile);
	}

	private static String solution(StringBuilder input) {
		int i = 1;
		while (i < input.length()) {
			if (i > 0 && input.charAt(i) < input.charAt(i - 1)) {
				if (input.charAt(i) == '0') {
					input = new StringBuilder(input.substring(0, i) + fillString(input.length() - i, '9'));
					input.setCharAt(i - 1, (char) (input.charAt(i - 1) - 1));
					i--;
				} else {
					input.setCharAt(i, (char) (input.charAt(i) - 1));
				}
			} else {
				i++;
			}
		}
		for (int j = 0; j < input.length(); j++) {
			if (input.charAt(j) != '0') {
				i = j;
				break;
			}
		}
		return input.substring(i);
	}

	public static String fillString(int count, char c) {
		StringBuilder sb = new StringBuilder(count);
		for (int i = 0; i < count; i++) {
			sb.append(c);
		}
		return sb.toString();
	}

	private static void writeSolutionLineToFile(List<String> outputFile, String solution) {
		outputFile.add(CASE_NUMBER + caseCounter + COLON + solution);
	}
}
