import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class Jam2 {
    private static final String CASE_NUMBER = "Case #";
    private static final String COLON = ": ";
	private static int caseCounter = 1;

	public static void main(String[] args) throws IOException {
    	String inputFileName = "B-small-attempt1.in";
    	List<String> outputFile = new ArrayList<>();
    
    	try (Scanner scanner = new Scanner(new File(inputFileName))) {
    		int cases = scanner.nextInt();
    		for(int i=0; i<cases ; i++) {
        		writeSolutionLineToFile(outputFile, solution(scanner.next()));
        		caseCounter++;
        	}

		} catch (IOException e) {
			e.printStackTrace();
		}
    	Files.write(Paths.get("out.txt"), outputFile);
    }

	private static int solution(String p) {
		List<Boolean> pancakes = new ArrayList<>();
		for (char c : p.toCharArray()) {
			pancakes.add(c == '+' ? Boolean.TRUE : Boolean.FALSE);
		}
		
		if (check(pancakes)) {
			return 0;
		}
		
		boolean target = calculateTarget(pancakes);
		
		int counter = 0;
		if (target == false) {
			counter++;
		}
		
		for (int i = pancakes.size()-1 ; i >=0 ; i--) {
			if (pancakes.get(i) == target) {
				continue;
			} else if (pancakes.get(i) != pancakes.get(0)) {
				if (pancakes.get(i) != pancakes.get(0)) {
					target = !target;
					counter ++;
				}
				continue;
			} else {
				pancakes = flipMe(pancakes, i+1);
				counter++;
			}
		}
		return counter;
	}
	
	private static boolean check(List<Boolean> in) {
		return !in.contains(Boolean.FALSE);
	}
	
	private static boolean calculateTarget(List<Boolean> in) {
		return in.get(0) == in.get(in.size()-1) ? true : in.get(in.size()-1);
	}
	
	private static List<Boolean> flipMe(List<Boolean> list, int n) {
		List<Boolean> sublist = list.subList(0, n);
		for (int i = 0 ; i<sublist.size() ; i++) {
			sublist.set(i, !sublist.get(i));
		}
		Collections.reverse(sublist);
		
		List<Boolean> result = new ArrayList<>(sublist);
		for (int i = n ; i<list.size() ; i++) {
			result.add(list.get(i));
		}
		return result;
	}

	private static void writeSolutionLineToFile(List<String> outputFile, int solution) {
		outputFile.add(CASE_NUMBER + caseCounter + COLON + solution);
	}
}

