package olds;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

public class JamCoin {

    static int[] range = new int[17];
    static {
        range[0] = 1;
        range[1] = 3;
        range[2] = 5;
        range[3] = 9;
        range[4] = 17;
        range[5] = 33;
        range[6] = 65;
        range[7] = 129;
        range[8] = 257;
        range[9] = 513;
        range[10] = 1025;
        range[11] = 2049;
        range[12] = 4097;
        range[13] = 8193;
        range[14] = 16385;
        range[15] = 32769;
        range[16] = 65535;
    }

    private static class Calls implements Callable<long[]> {

        int start;
        CountDownLatch countDownLatch;

        public Calls(int start, CountDownLatch countDownLatch) {
            this.start = start;
            this.countDownLatch = countDownLatch;
        }

        @Override
        public long[] call() throws Exception {
            String binary = Integer.toString(start, 2);
            boolean isAcceptable = true;
            long divisors[] = new long[11];
            divisors[1] = start;
            divisors[2] = getDivisor(start);
            if (divisors[2] != 0) {
                for (int k = 3; k <= 10; k++) {
                    divisors[k] = getDivisor(Long.valueOf(binary, k).longValue());
                    if (divisors[k] == 0) {
                        isAcceptable = false;
                        break;
                    }
                }
                if (isAcceptable) {
                    list.add(divisors);
                    countDownLatch.countDown();
                }
            }
            return divisors;
        }
    }

    static List<long[]> list = new ArrayList<long[]>();

    public static void solve(final Input input, final PrintWriter output) throws Exception {
        final int numberOfTestCases = input.nextInt();
        for (int i = 0; i < numberOfTestCases; i++) {
            final int N = input.nextInt();
            final int J = input.nextInt();
            int start = range[N - 1];
            int end = range[N] - 2;
            CountDownLatch countDownLatch = new CountDownLatch(J);
            ExecutorService executorService = Executors.newFixedThreadPool(20);
            for (int j = start; j <= end; j += 2) {
                Calls calls = new Calls(j, countDownLatch);
                executorService.submit(calls);
            }
            countDownLatch.await(4, TimeUnit.MINUTES);
            executorService.shutdownNow();
            printOutput(i, output, J);
        }
    }

    private static void printOutput(int i, PrintWriter output, int J) {
        output.println("Case #" + (i + 1) + ":");
        StringBuilder sb = new StringBuilder();
        for (int j = 0; j < J && j < list.size(); j++) {
            sb.append(Long.toBinaryString(list.get(j)[1]));
            sb.append(" ");
            for (int k = 2; k < list.get(j).length; k++) {
                sb.append(list.get(j)[k]);
                sb.append(" ");
            }
            sb.append("\n");
        }
        output.println(sb);
    }

    private static int getDivisor(long number) {
        if (number % 2 == 0) {
            return 2;
        }
        for (int i = 3; i * i <= number; i += 2) {
            if (number % i == 0) {
                return i;
            }
        }
        return 0;
    }

    public static void main(final String[] args) throws Exception {
        // final PrintWriter output = new PrintWriter(new File("src/olds/output.txt"));
        final PrintWriter output = new PrintWriter(System.out);
        final Input input = new Input(new BufferedReader(new InputStreamReader(System.in)));
        solve(input, output);
        input.close();
        output.close();
    }

    private static class Input {

        private final BufferedReader in;
        private final StringBuilder sb = new StringBuilder();
        private final static String SEPERATOR = " \n\r\t";

        public Input(final BufferedReader in) {
            this.in = in;
        }

        public String next() throws IOException {
            sb.setLength(0);
            while (true) {
                int c = in.read();
                if (c == -1) {
                    return null;
                }
                if (SEPERATOR.indexOf(c) == -1) {
                    sb.append((char) c);
                    break;
                }
            }
            while (true) {
                int c = in.read();
                if (c == -1 || SEPERATOR.indexOf(c) != -1) {
                    break;
                }
                sb.append((char) c);
            }
            return sb.toString();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(next(), 10);
        }

        public void close() throws IOException {
            in.close();
        }
    }
}
