import java.io.BufferedReader;
import java.io.Closeable;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class A {

    private static final String CASES = "Case #";
    private static final String COLON = ": ";
    private static final char NEWLINE = '\n';

    public static String getResult(int totalToTravel, NoIdea[] noIdea) {
        double maxHours = Double.MIN_VALUE;
        for (int i = 0; i < noIdea.length; i++) {
            maxHours = Double.max((totalToTravel - noIdea[i].kilos) / noIdea[i].speed, maxHours);
        }
        return String.format("%.6f", totalToTravel / maxHours);
    }

    private static class NoIdea {

        double kilos, speed;

        public NoIdea(int kilos, int speed) {
            this.kilos = kilos;
            this.speed = speed;
        }
    }

    public static void solve(final Input input, final PrintWriter output) throws IOException {
        final int numberOfTestCases = input.nextInt();
        final StringBuilder stringBuilder = new StringBuilder(25000 * numberOfTestCases);
        for (int z = 1; z <= numberOfTestCases; z++) {
            int total = input.nextInt();
            int count = input.nextInt();
            NoIdea[] noIdea = new NoIdea[count];
            for (int i = 0; i < count; i++) {
                noIdea[i] = new NoIdea(input.nextInt(), input.nextInt());
            }
            stringBuilder.append(CASES);
            stringBuilder.append(z);
            stringBuilder.append(COLON);
            stringBuilder.append(getResult(total, noIdea));
            stringBuilder.append(NEWLINE);
        }
        output.println(stringBuilder.toString());
    }

    public static void main(final String[] args) throws IOException {
        try (final PrintWriter output = new PrintWriter(System.out); final Input input = new Input(new BufferedReader(new InputStreamReader(System.in)))) {
            solve(input, output);
        }
    }

    private static class Input implements Closeable {

        private final BufferedReader bufferedReader;
        private final StringBuilder stringBuilder = new StringBuilder();
        private final static char[] SEPERATOR = {'\t', '\n', '\r', ' '};

        public Input(final BufferedReader in) {
            this.bufferedReader = in;
        }

        private boolean isAnySeperator(final char ch) {
            return ch == SEPERATOR[3] || ch == SEPERATOR[1] || ch == SEPERATOR[0] || ch == SEPERATOR[2];
        }

        private boolean isLineSeperator(final char ch) {
            return ch == SEPERATOR[1] || ch == SEPERATOR[2];
        }

        public String next() throws IOException {
            stringBuilder.setLength(0);
            while (true) {
                int c = bufferedReader.read();
                if (c == -1) {
                    return null;
                }
                char ch = (char) c;
                if (!isAnySeperator(ch)) {
                    stringBuilder.append(ch);
                    break;
                }
            }
            while (true) {
                int c = bufferedReader.read();
                char ch = (char) c;
                if (c == -1 || isAnySeperator(ch)) {
                    break;
                }
                stringBuilder.append(ch);
            }
            return stringBuilder.toString();
        }

        public String nextLine() throws IOException {
            stringBuilder.setLength(0);
            while (true) {
                final int c = bufferedReader.read();
                if (c == -1) {
                    return null;
                }
                final char ch = (char) c;
                if (!isLineSeperator(ch)) {
                    stringBuilder.append(ch);
                    break;
                }
            }
            while (true) {
                int c = bufferedReader.read();
                char ch = (char) c;
                if (c == -1 || isLineSeperator(ch)) {
                    break;
                }
                stringBuilder.append(ch);
            }
            return stringBuilder.toString();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(next(), 10);
        }

        public long nextLong() throws IOException {
            return Long.parseLong(next(), 10);
        }

        public void close() throws IOException {
            bufferedReader.close();
        }
    }
}
