import java.io.BufferedReader;
import java.io.Closeable;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class B {

    private static final String CASES = "Case #";
    private static final String COLON = ": ";
    private static final String NEWLINE = "\n";

    private static void flip(final char[] pattern, final int index, final int count) {
        for (int i = index; i < index + count; i++) {
            if (pattern[i] == '+') {
                pattern[i] = '-';
            } else {
                pattern[i] = '+';
            }
        }
    }

    private static int countNumber(final char[] pattern, final int count) {
        int fcount = 0;
        for (int i = 0; i <= pattern.length - count; i++) {
            if (pattern[i] == '-') {
                flip(pattern, i, count);
                fcount++;
            }
        }
        for (int i = pattern.length - count + 1; i < pattern.length; i++) {
            if (pattern[i] == '-')
                return -1;
        }
        return fcount;
    }

    public static void solve(final Input input, final PrintWriter output) throws IOException {
        final int numberOfTestCases = input.nextInt();
        final StringBuilder stringBuilder = new StringBuilder(25000 * numberOfTestCases);
        for (int z = 1; z <= numberOfTestCases; z++) {
            char[] pattern = input.next().toCharArray();
            int count = input.nextInt();
            stringBuilder.append(CASES);
            stringBuilder.append(z);
            stringBuilder.append(COLON);
            int c = countNumber(pattern, count);
            stringBuilder.append(c == -1 ? "IMPOSSIBLE" : c);
            stringBuilder.append(NEWLINE);
        }
        output.println(stringBuilder.toString());
    }

    public static void main(final String[] args) throws IOException {
        try (final PrintWriter output = new PrintWriter(System.out); final Input input = new Input(new BufferedReader(new InputStreamReader(System.in)))) {
            solve(input, output);
        }
    }

    private static class Input implements Closeable {

        private final BufferedReader in;
        private final StringBuilder sb = new StringBuilder();
        private final static String SEPERATOR = " \n\r\t";
        private final static String LINE_SEPERATOR = "\n\r";

        public Input(final BufferedReader in) {
            this.in = in;
        }

        public String next() throws IOException {
            sb.setLength(0);
            while (true) {
                int c = in.read();
                if (c == -1) {
                    return null;
                }
                if (SEPERATOR.indexOf(c) == -1) {
                    sb.append((char) c);
                    break;
                }
            }
            while (true) {
                int c = in.read();
                if (c == -1 || SEPERATOR.indexOf(c) != -1) {
                    break;
                }
                sb.append((char) c);
            }
            return sb.toString();
        }

        public String nextLine() throws IOException {
            sb.setLength(0);
            while (true) {
                int c = in.read();
                if (c == -1) {
                    return null;
                }
                if (LINE_SEPERATOR.indexOf(c) == -1) {
                    sb.append((char) c);
                    break;
                }
            }
            while (true) {
                int c = in.read();
                if (c == -1 || LINE_SEPERATOR.indexOf(c) != -1) {
                    break;
                }
                sb.append((char) c);
            }
            return sb.toString();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(next(), 10);
        }

        public long nextLong() throws IOException {
            return Long.parseLong(next(), 10);
        }

        public void close() throws IOException {
            in.close();
        }
    }
}
