package olds;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class PancakeB {

    public static void solve(final Input input, final PrintWriter output) throws IOException {
        final int numberOfTestCases = input.nextInt();
        for (int i = 0; i < numberOfTestCases; i++) {
            final String string = input.next();
            output.println("Case #" + (i + 1) + ": " + solve(string));
        }
    }

    private static int getCount(String value) {
        int count = 0;
        for (int i = 0; i < value.length(); i++) {
            if (value.charAt(i) == '-') {
                count++;
            }
        }
        return count;
    }

    private static int solve(String value) {
        int oneSide = getCount(value);
        if (oneSide == value.length()) {
            return 1;
        } else if (oneSide == 0) {
            return 0;
        }
        int count = 0;
        char previous = value.charAt(0);
        for (int i = 1; i < value.length(); i++) {
            char next = value.charAt(i);
            if (previous == '+' && next == '-') {
                count += 2;
                for (; i < value.length(); i++) {
                    if (value.charAt(i) == '+') {
                        break;
                    }
                }
                previous = '+';
            } else if (previous == '-' && next == '+') {
                count++;
                previous = '+';
            } else {
                continue;
            }
        }
        return count;
    }

    public static void main(final String[] args) throws IOException {
        final PrintWriter output = new PrintWriter(new File("output.txt"));
        final Input input = new Input(new BufferedReader(new InputStreamReader(System.in)));
        solve(input, output);
        input.close();
        output.close();
    }

    private static class Input {

        private final BufferedReader in;
        private final StringBuilder sb = new StringBuilder();
        private final static String SEPERATOR = " \n\r\t";

        public Input(final BufferedReader in) {
            this.in = in;
        }

        public String next() throws IOException {
            sb.setLength(0);
            while (true) {
                int c = in.read();
                if (c == -1) {
                    return null;
                }
                if (SEPERATOR.indexOf(c) == -1) {
                    sb.append((char) c);
                    break;
                }
            }
            while (true) {
                int c = in.read();
                if (c == -1 || SEPERATOR.indexOf(c) != -1) {
                    break;
                }
                sb.append((char) c);
            }
            return sb.toString();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(next(), 10);
        }

        public void close() throws IOException {
            in.close();
        }
    }
}
