import java.io.BufferedReader;
import java.io.Closeable;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class A {

    private static final String CASES = "Case #";
    private static final String COLON = ": ";
    private static final char NEWLINE = '\n';

    public static void formResult(final char[][] matrix, int row, int col) {
        for (int i = 0; i < row - 1; i++) {
            for (int j = 0; j < col; j++) {
                if (matrix[i][j] == '?') {
                    if (matrix[i + 1][j] != '?') {
                        matrix[i][j] = matrix[i + 1][j];
                    }
                }
            }
        }
        for (int i = 1; i < row; i++) {
            for (int j = 0; j < col; j++) {
                if (matrix[i][j] == '?') {
                    if (matrix[i - 1][j] != '?') {
                        matrix[i][j] = matrix[i - 1][j];
                    }
                }
            }
        }
        for (int i = row - 1; i > 0; i--) {
            for (int j = 0; j < col; j++) {
                if (matrix[i - 1][j] == '?') {
                    if (matrix[i][j] != '?') {
                        matrix[i - 1][j] = matrix[i][j];
                    }
                }
            }
        }
        for (int i = 0; i < row; i++) {
            for (int j = 1; j < col; j++) {
                if (matrix[i][j] == '?') {
                    if (matrix[i][j - 1] != '?') {
                        matrix[i][j] = matrix[i][j - 1];
                    }
                }
            }
        }
        for (int i = 0; i < row; i++) {
            for (int j = 0; j < col - 1; j++) {
                if (matrix[i][j] == '?') {
                    if (matrix[i][j + 1] != '?') {
                        matrix[i][j] = matrix[i][j + 1];
                    }
                }
            }
        }
        for (int i = 0; i < row; i++) {
            for (int j = col - 1; j > 0; j--) {
                if (matrix[i][j - 1] == '?') {
                    if (matrix[i][j] != '?') {
                        matrix[i][j - 1] = matrix[i][j];
                    }
                }
            }
        }
    }

    public static void solve(final Input input, final PrintWriter output) throws IOException {
        final int numberOfTestCases = input.nextInt();
        final StringBuilder stringBuilder = new StringBuilder(2000 * numberOfTestCases);
        for (int z = 1; z <= numberOfTestCases; z++) {
            int row = input.nextInt();
            int col = input.nextInt();
            char[][] matrix = new char[row][col];
            for (int i = 0; i < row; i++) {
                matrix[i] = input.next().toCharArray();
            }
            stringBuilder.append(CASES);
            stringBuilder.append(z);
            stringBuilder.append(COLON);
            stringBuilder.append(NEWLINE);
            formResult(matrix, row, col);
            for (int i = 0; i < row; i++) {
                for (int j = 0; j < col; j++) {
                    stringBuilder.append(matrix[i][j]);
                }
                if (i != row - 1)
                    stringBuilder.append(NEWLINE);
            }
            stringBuilder.append(NEWLINE);
        }
        output.println(stringBuilder.toString());
    }

    public static void main(final String[] args) throws IOException {
        try (final PrintWriter output = new PrintWriter(System.out); final Input input = new Input(new BufferedReader(new InputStreamReader(System.in)))) {
            solve(input, output);
        }
    }

    private static class Input implements Closeable {

        private final BufferedReader bufferedReader;
        private final StringBuilder stringBuilder = new StringBuilder();
        private final static char[] SEPERATOR = {'\t', '\n', '\r', ' '};

        public Input(final BufferedReader in) {
            this.bufferedReader = in;
        }

        private boolean isAnySeperator(final char ch) {
            return ch == SEPERATOR[3] || ch == SEPERATOR[1] || ch == SEPERATOR[0] || ch == SEPERATOR[2];
        }

        private boolean isLineSeperator(final char ch) {
            return ch == SEPERATOR[1] || ch == SEPERATOR[2];
        }

        public String next() throws IOException {
            stringBuilder.setLength(0);
            while (true) {
                int c = bufferedReader.read();
                if (c == -1) {
                    return null;
                }
                char ch = (char) c;
                if (!isAnySeperator(ch)) {
                    stringBuilder.append(ch);
                    break;
                }
            }
            while (true) {
                int c = bufferedReader.read();
                char ch = (char) c;
                if (c == -1 || isAnySeperator(ch)) {
                    break;
                }
                stringBuilder.append(ch);
            }
            return stringBuilder.toString();
        }

        public String nextLine() throws IOException {
            stringBuilder.setLength(0);
            while (true) {
                final int c = bufferedReader.read();
                if (c == -1) {
                    return null;
                }
                final char ch = (char) c;
                if (!isLineSeperator(ch)) {
                    stringBuilder.append(ch);
                    break;
                }
            }
            while (true) {
                int c = bufferedReader.read();
                char ch = (char) c;
                if (c == -1 || isLineSeperator(ch)) {
                    break;
                }
                stringBuilder.append(ch);
            }
            return stringBuilder.toString();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(next(), 10);
        }

        public long nextLong() throws IOException {
            return Long.parseLong(next(), 10);
        }

        public void close() throws IOException {
            bufferedReader.close();
        }
    }
}
