import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class A {

    public static void solve(final Input input, final PrintWriter output) throws IOException {
        final int numberOfTestCases = input.nextInt();
        for (int i = 0; i < numberOfTestCases; i++) {
            final String string = input.next();
            output.println("Case #" + (i + 1) + ": " + solve(string));
        }
    }

    private static String solve(String string) {
        List<String> list = new ArrayList<String>();
        list.add(string.substring(0, 1));
        for (int i = 1; i < string.length(); i++) {
            List<String> newlist = new ArrayList<String>();
            for (String str : list) {
                if (string.charAt(i) > str.charAt(0)) {
                    newlist.add(string.charAt(i) + str);
                } else {
                    newlist.add(str + string.charAt(i));
                }
            }
            list = newlist;
        }
        Collections.sort(list);
        return list.get(list.size() - 1);
    }

    public static void main(final String[] args) throws IOException {
        // final PrintWriter output = new PrintWriter(new File("src/olds/output.txt"));
        final PrintWriter output = new PrintWriter(System.out);
        final Input input = new Input(new BufferedReader(new InputStreamReader(System.in)));
        solve(input, output);
        input.close();
        output.close();
    }

    private static class Input {

        private final BufferedReader in;
        private final StringBuilder sb = new StringBuilder();
        private final static String SEPERATOR = " \n\r\t";

        public Input(final BufferedReader in) {
            this.in = in;
        }

        public String next() throws IOException {
            sb.setLength(0);
            while (true) {
                int c = in.read();
                if (c == -1) {
                    return null;
                }
                if (SEPERATOR.indexOf(c) == -1) {
                    sb.append((char) c);
                    break;
                }
            }
            while (true) {
                int c = in.read();
                if (c == -1 || SEPERATOR.indexOf(c) != -1) {
                    break;
                }
                sb.append((char) c);
            }
            return sb.toString();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(next(), 10);
        }

        public void close() throws IOException {
            in.close();
        }
    }
}
