package olds;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class B {

    public static void solve(Input input, PrintWriter output) throws IOException {
        int numberOfTestCases = input.nextInt();
        for (int i = 0; i < numberOfTestCases; i++) {
            int number = input.nextInt();
            if (number * 2 == number) {
                System.out.println("Case #" + (i + 1) + ": INSOMNIA");
            } else {
                boolean[] isDone = new boolean[10];
                System.out.println("Case #" + (i + 1) + ": " + getNumber(1, number, isDone));
            }
        }
    }

    private static boolean isAllDone(boolean[] isDone) {
        boolean result = true;
        for (int i = 0; i < 10; i++) {
            result &= isDone[i];
        }
        return result;
    }

    private static void cover(long number, boolean[] isDone) {
        if (number == 0) {
            return;
        }
        isDone[(int) number % 10] = true;
        cover(number / 10, isDone);
    }

    private static long getNumber(int count, long number, boolean[] isDone) {
        if (isAllDone(isDone)) {
            return number * (count - 1);
        }
        cover(number * count, isDone);
        return getNumber(count + 1, number, isDone);
    }

    public static void main(String[] args) throws IOException {
        final PrintWriter output = new PrintWriter(System.out);
        final Input input = new Input(new BufferedReader(new InputStreamReader(System.in)));
        solve(input, output);
        input.close();
        output.close();
    }

    private static class Input {

        private final BufferedReader in;
        private final StringBuilder sb = new StringBuilder();
        private final static String SEPERATOR = " \n\r\t";

        public Input(final BufferedReader in) {
            this.in = in;
        }

        public String next() throws IOException {
            sb.setLength(0);
            while (true) {
                int c = in.read();
                if (c == -1) {
                    return null;
                }
                if (SEPERATOR.indexOf(c) == -1) {
                    sb.append((char) c);
                    break;
                }
            }
            while (true) {
                int c = in.read();
                if (c == -1 || SEPERATOR.indexOf(c) != -1) {
                    break;
                }
                sb.append((char) c);
            }
            return sb.toString();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(next(), 10);
        }

        public void close() throws IOException {
            in.close();
        }
    }
}
