import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

//Jesse Fish

public class Question3 {

	ArrayList <Combine> [] combiners;
	ArrayList <Destruct> [] destroyers;
	String [] inputs;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		File file = new File(args[0]);

		Question3 a=new Question3();
		try {
			a.loadExample(file);
			a.runAll();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void runAll(){
		FileWriter out;
		try {
			out=new FileWriter("output.txt");

			for(int i=0;i<inputs.length;i++){
				out.write("Case #"+(i+1)+": "+runTest(i)+"\n");
				System.out.print("Case #"+(i+1)+": "+runTest(i)+"\n");
			}
			out.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public String runTest(int iteration){
		String ending=inputs[iteration];
		String starting="";
		
		for(int i=0;i<ending.length();i++){
			starting+=ending.charAt(i);
			//check combiners
			starting=checkCombiners(starting,combiners[iteration]);
			//check destructors
			starting=checkDestructors(starting,destroyers[iteration]);
		}
		
		return buildOutput(starting);
	}
	public String buildOutput(String in){
		String out="[";
		for(int i=0;i<in.length();i++){
			out+=in.charAt(i)+", ";
		}
		if(out.length()>1){
			out=out.substring(0, out.length()-2);
		}
		out+="]";
		return out;
	}
	public String checkCombiners(String in, ArrayList <Combine> combs){
		int length=in.length();
		boolean changed=false;
		if(length>1){
			for(Combine c:combs){
				if(c.isCombine(in.charAt(length-1), in.charAt(length-2))){
					in=in.substring(0, length-2)+c.getResult();
					//changed=true;
					break;
				}
			}
			/*if(changed){
				in=checkCombiners(in,combs);
			}*/
			return in;
		}else{
			return in;
		}
	}
	public String checkDestructors(String in, ArrayList <Destruct> dest){
		int length=in.length();
		if(length>1){
			for(int i=0;i<length;i++){
				for(int j=0;j<length;j++){
					if(i!=j){
						for(Destruct d:dest){
							if(d.isDestroy(in.charAt(i), in.charAt(j))){
								return "";
							}
						}
					}
				}
			}
			
			return in;
		}else{
			return in;
		}
	}
	public void loadExample(File example) throws FileNotFoundException{
		Scanner reader = new Scanner(example);
		int testCount=reader.nextInt();
		reader.nextLine();

		//System.out.println(testCount);
		combiners = new ArrayList[testCount];
		destroyers = new ArrayList[testCount];
		inputs= new String[testCount];

		int value_count=0;
		for(int i=0;i<testCount;i++){

			combiners[i]=new ArrayList<Combine>();
			value_count=reader.nextInt();
			for(int j=0;j<value_count;j++){
				combiners[i].add(new Combine(reader.next()));
			}

			destroyers[i]=new ArrayList<Destruct>();
			value_count=reader.nextInt();
			for(int j=0;j<value_count;j++){
				destroyers[i].add(new Destruct(reader.next()));
			}
			value_count=reader.nextInt();
			inputs[i]=reader.next();
			//System.out.println(inputs[i]);
		}
		
	}
}

class Destruct{
	char a,b;
	public Destruct(String destruct){
		this.a=destruct.charAt(0);
		this.b=destruct.charAt(1);
	}
	public boolean isDestroy(char a, char b){
		if(this.a == a && this.b == b || this.b == a && this.a == b){
			return true;
		}
		else{
			return false;
		}
	}
}

class Combine{
	char a,b,c;
	public Combine(String combine){
		System.out.println(combine);
		this.a=combine.charAt(0);
		this.b=combine.charAt(1);
		this.c=combine.charAt(2);
	}
	public boolean isCombine(char a, char b){
		if(this.a == a && this.b == b || this.b == a && this.a == b){
			return true;
		}
		else{
			return false;
		}
	}
	public char getResult(){
		return c;
	}
}
