//Jesse Fish
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;


public class Problem1 {

	Team teams [];
	String tests [][];
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		File file = new File(args[0]);

		Problem1 a=new Problem1();
		try {
			a.loadExample(file);
			a.runAll();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void runAll(){
		FileWriter out;
		try {
			out=new FileWriter("output.txt");
			for(int i=0;i<tests.length;i++){
				String temp=runTest(i);
				out.write("Case #"+(i+1)+":\n"+temp);
				System.out.print("Case #"+(i+1)+":\n"+temp);
			}
			out.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public void loadExample(File example) throws FileNotFoundException{
		Scanner reader = new Scanner(example);
		int testCount=reader.nextInt();
		reader.nextLine();
		tests = new String[testCount][];
		for(int i=0;i<testCount;i++){
			int teamCount=reader.nextInt();
			reader.nextLine();
			tests[i]=new String[teamCount];
			for(int j=0;j<teamCount;j++){
				tests[i][j]=reader.nextLine();
			}
		}
	}

	public String runTest(int iteration){
		String output="";
		String [] test=tests[iteration];
		teams=new Team[test.length];
		for(int i=0;i<test.length;i++){
			//System.out.println(test[i]);
			teams[i]=new Team(test[i],i);
		}
		for(int i=0;i<teams.length;i++){
			teams[i].buildTeam();
		}
		for(int i=0;i<teams.length;i++){
			teams[i].calcWinP();
		}
		for(int i=0;i<teams.length;i++){
			teams[i].calcOwP();
		}
		for(int i=0;i<teams.length;i++){
			teams[i].calcOowP();
			teams[i].calcScore();
			output+=""+teams[i].score+"\n";
		}


		return output;
	}

	class Team{
		double wp,owp,oowp=0;
		ArrayList<Team> opponents=new ArrayList<Team>();
		String input;
		int index=0;
		double score=0;

		public Team(String in, int index){
			input=in;
			this.index=index;
		}
		public void buildTeam(){
			for(int i=0;i<input.length();i++){
				char temp=input.charAt(i);
				if(temp != '.'){
					opponents.add(teams[i]);
				}
			}
		}
		public void calcWinP(){
			int wins=0;
			int losses=0;
			for(int i=0;i<input.length();i++){
				char temp=input.charAt(i);
				if(temp == '1'){
					wins++;
				}else if (temp == '0'){
					losses++;
				}
			}
			wp=((double)wins)/(wins+losses);
		}
		public double giveWP(int skip){
			double ret;
			int wins=0;
			int losses=0;
			for(int i=0;i<input.length();i++){
				if(i==skip){
					continue;
				}
				char temp=input.charAt(i);
				if(temp == '1'){
					wins++;
				}else if (temp == '0'){
					losses++;
				}
			}
			ret=((double)wins)/(wins+losses);
			return ret;
		}
		public void calcOwP(){
			double sum=0;
			for(Team t:this.opponents){
				sum+=t.giveWP(this.index);
			}
			this.owp=sum/this.opponents.size();
		}
		public void calcOowP(){
			double sum=0;
			for(Team t:this.opponents){
				sum+=t.owp;
			}
			this.oowp=sum/this.opponents.size();
		}

		public void calcScore(){
			score=.25*wp+.5*owp+.25*oowp;
		}
	}
}
