import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;


public class Problem2 {

	Test tests [];
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		File file = new File(args[0]);

		Problem2 a=new Problem2();
		try {
			a.loadExample(file);
			a.runAll();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void runAll(){
		FileWriter out;
		try {
			out=new FileWriter("output.txt");
			for(int i=0;i<tests.length;i++){
				String temp=runTest(i);
				out.write("Case #"+(i+1)+": "+temp+"\n");
				System.out.print("Case #"+(i+1)+": "+temp+"\n");
			}
			out.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public void loadExample(File example) throws FileNotFoundException{
		Scanner reader = new Scanner(example);
		int testCount=reader.nextInt();
		reader.nextLine();
		tests = new Test[testCount];
		for(int i=0;i<testCount;i++){
			tests[i]=new Test(reader.nextInt(),reader.nextInt());
			for(int j=0;j<tests[i].point.length;j++){
				tests[i].point[j]=new Vpoint(reader.nextInt(),reader.nextInt());
			}
		}
	}
	
	public String runTest(int iteration){
		double solve=tests[iteration].solveTest();
		return ""+solve;
	}
}
class Test{
	int d;
	Vpoint point[];
	public Test(int points,int dist){
		d=dist;
		point=new Vpoint[points];
	}
	public void print(){
		System.out.println("t "+point.length+" "+d);
		for(int i=0;i<point.length;i++){
			System.out.println("point " +point[i].startx +" "+point[i].vendors);
		}
	}
	public double solveTest(){
		for(int i=0;i<point.length;i++){
			point[i].calcSpread(d);
		}
		Arrays.sort(point, point[0]);
		print();
		int moves=0;
		int position=point[0].startx;
		
		moves+=point[0].spread;
		System.out.println("moves " +point[0].spread+" "+moves);
		
		for(int i=1;i<point.length;i++){
			if(d-(point[i].startx-position)>0){
				moves+=d-(point[i].startx-position);
				System.out.println("moves "+moves);
			}
			position=point[i].startx;
			moves+=point[i].spread;
			//System.out.println(point[i].spread+" "+moves);
		}
		return moves/2.0;
	}
}

class Vpoint implements Comparator<Vpoint>{
	int vendors;
	int startx;
	int spread;
	public Vpoint(int startx,int vendors){
		this.startx=startx;
		this.vendors=vendors;
	}
	public void calcSpread(int d){
		spread=d*(vendors-1);
	}
	@Override
	public int compare(Vpoint arg0, Vpoint arg1) {
		if(arg0.startx<arg1.startx){
			return -1;
		}
		if(arg0.startx>arg1.startx){
			return 1;
		}
		return 0;
	}
}