import java.io.File;
import java.io.FileNotFoundException;
import java.util.LinkedList;
import java.util.Scanner;

//Jesse Fish

public class Question1 {
	LinkedList <Move> oMoves =new LinkedList <Move>();
	LinkedList <Move> bMoves =new LinkedList <Move>();
	
	Robot O;
	Robot B;
	
	int total_time=0;
	String tests[];
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		File file = new File(args[0]);
		
		Question1 a=new Question1();
		try {
			a.loadExample(file);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		a.runAll();
	}
	
	public void runAll(){
		for(int i=0;i<tests.length;i++){
			parseTest(i);
			runTest();
			System.out.printf("Case #%d: %d\n",i+1,this.total_time);
		}
	}

	public void loadExample(File example) throws FileNotFoundException{
		Scanner reader = new Scanner(example);
		int testCount=reader.nextInt();
		reader.nextLine();
		tests = new String[testCount];
		for(int i=0;i<testCount;i++){
			tests[i]=reader.nextLine();
		}
	}
	
	public void parseTest(int number){
		Scanner reader = new Scanner(tests[number]);
		int buttonPresses =reader.nextInt();
		String hallway="";
		int button;
		Move lastMove=null;
		Move currentMove=null;
		for(int i=0;i<buttonPresses;i++){
			hallway=reader.next();
			button=reader.nextInt();
			currentMove=new Move(hallway,button,lastMove);
			if(currentMove.isB()){
				bMoves.add(currentMove);
			} else{
				oMoves.add(currentMove);
			}
			lastMove=currentMove;
		}
		if(bMoves.peek().dependent!=null && oMoves.peek().dependent!=null){
			System.out.println("big error here");
		}
	}
	
	public void runTest(){
		total_time=0;
		O=new Robot(oMoves);
		B=new Robot(bMoves);
		Robot currentRob=O;
		Robot otherRob=B;
		
		while(!O.isdone() || !B.isdone()){
			if(O.stepsLeft()<B.stepsLeft()){
				currentRob=O;
				otherRob=B;
			}else{
				currentRob=B;
				otherRob=O;
			}
			if(currentRob.isdone()){
				Robot temp=currentRob;
				currentRob=otherRob;
				otherRob=temp;
			}
			int steps=currentRob.stepsLeft();
			O.step(steps);
			B.step(steps);
			total_time+=steps;
			
			if(currentRob.press()){
				otherRob.step(1);
				total_time+=1;
			}else{
				steps=otherRob.stepsLeft();
				otherRob.step(otherRob.stepsLeft());
				total_time+=steps;
				if(otherRob.press()){
					total_time+=1;
				}else{
					System.out.println("major error has occurred");
				}
			}
		}
	}
}

class Move{
	public Hallway hall;
	public int button;
	private boolean pressed=false;
	public Move dependent=null;
	public Move(String h, int b, Move m){
		this.dependent=m;
		if(h.charAt(0)=='O'){
			this.hall= Hallway.O;
		}
		else if(h.charAt(0)=='B'){
			this.hall=Hallway.B;
		}else{
			System.out.println("ERROR! INVALID HALLWAY");
		}
		this.button=b;
	}
	public boolean isB(){
		if (this.hall==Hallway.B){
			return true;
		}
		return false;
	}
	boolean isPressed(){
		return pressed;
	}
	void press(){
		pressed=true;
	}
}

class Robot{
	LinkedList <Move> moves;
	int position=1;
	Move currentMove;
	boolean done=false;
	
	public Robot(LinkedList <Move> moves){
		this.moves=moves;
		if(!moves.isEmpty()){
			currentMove=moves.pop();
		}else{
			//if this robot has no moves to make
			//give it an emtpy dummy move
			currentMove=new Move("O",0,null);
			currentMove.press();
			done=true;
		}
	}
	
	int getDirection(){
		if(currentMove.button-position == 0){
			return 0;
		}
		return (currentMove.button-position)/Math.abs(currentMove.button-position);
	}
	int stepsLeft(){
		return Math.abs(currentMove.button-position);
	}
	boolean step(int n){
		if(n <= Math.abs(currentMove.button-position)){
			position+= n*getDirection();
			return true;
		}
		return false;
	}
	boolean press(){
		if(currentMove.button==position){
			if(currentMove.dependent == null || currentMove.dependent.isPressed()){
				currentMove.press();
				advanceMove();
				return true;
			}
		}
		return false;
	}
	void advanceMove(){
		if(!moves.isEmpty()){
			currentMove = moves.pop();
		}else{
			done=true;
		}
	}
	boolean isdone(){
		return done;
	}
}
enum Hallway{O,B}

