import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class Problem2 {

	Test tests [];

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		File file = new File(args[0]);

		Problem2 a=new Problem2();
		try {
			a.loadExample(file);
			a.runAll();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void runAll(){
		FileWriter out;
		try {
			out=new FileWriter("output.txt");
			for(int i=0;i<tests.length;i++){
				String temp=runTest(i);
				out.write("Case #"+(i+1)+": "+temp+"\n");
				System.out.print("Case #"+(i+1)+": "+temp+"\n");
			}
			out.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public void loadExample(File example) throws FileNotFoundException{
		Scanner reader = new Scanner(example);
		int testCount=reader.nextInt();
		reader.nextLine();
		tests = new Test[testCount];
		for(int i=0;i<testCount;i++){
			tests[i]=new Test(reader.nextInt(),reader.nextInt());
			if(reader.hasNext())
				reader.nextLine();
			for(int j=0;j<tests[i].grid.length;j++){
				tests[i].setrow(j, reader.nextLine());
			}
		//	tests[i].print();
		}
	}

	public String runTest(int i){
		return tests[i].solve();
	}
}
class Test{
	char [][] grid;
	char [][] scratch;
	int [][] squares;
	int [][] considering;
	public Test(int a, int b){
		grid=new char[a][b];
		//scratch=new char[a][b];
		squares=new int [a-1][b-1];
	}
	public void setrow(int row, String s){
		char [] temp=s.toCharArray();
		for(int i=0;i<temp.length;i++){
			grid[row][i]=temp[i];
		}
	}
	public void print(){
		for(int i=0;i<grid.length;i++){
			for(int j=0;j<grid[i].length;j++){
				System.out.print(grid[i][j]);
			}
			System.out.println();
		}
	}
	public int countBlue(){
		int blue=0;
		for(int i=0;i<grid.length;i++){
			for(int j=0;j<grid[i].length;j++){
				if(grid[i][j]=='#')
					blue++;
			}
		}
		return blue;
	}

	public String solve(){
		int blueCount=countBlue();
		if(blueCount==0){
			//return is as is
			String output=this.buildoutput();

			return output;
		}
		if(blueCount%4!=0){
			return "\nImpossible";
		}
		//start considering placements

		//find all possible squares
		//if there are blue outside those return impossible
		considerSquares();
		if(checkScractch()){
			return "\nImpossible";
		}

		//we have a situation that has possible
		//squares on every blue

		if(buildSquares()){
			return "\nImpossible";
		}
		String output=this.buildoutput();

		return output;

	}
	void considerSquares(){
		this.scratch=this.grid.clone();
		for(int i=0;i<grid.length-1;i++){
			for(int j=0;j<grid[i].length-1;j++){
				if(grid[i][j]=='#' && grid[i+1][j]=='#'  && grid[i+1][j+1]=='#'  && grid[i][j+1]=='#'){
					scratch[i][j]='X';
					scratch[i+1][j]='X';
					scratch[i+1][j+1]='X';
					scratch[i][j+1]='X';
					squares[i][j]=1;
				}
			}
		}
	}
	boolean checkScractch(){
		for(int i=0;i<scratch.length;i++){
			for(int j=0;j<scratch[i].length;j++){
				if(scratch[i][j]=='#'){
					return true;
				}
			}
		}
		return false;
	}
	boolean buildSquares(){
		considering=this.squares.clone();

		for(int i=0;i<squares.length;i++){
			for(int j=0;j<squares[i].length;j++){
				if(considering[i][j]==1){
						if(i+1<squares.length)
							considering[i+1][j]=0;

						if(i+1<squares.length && j+1<squares[i].length)
							considering[i+1][j+1]=0;
						if(j+1<squares[i].length)
							considering[i][j+1]=0;
				}
			}
		}
		//check if the squares in considering cover everything
		this.scratch=this.grid.clone();

		for(int i=0;i<squares.length;i++){
			for(int j=0;j<squares[i].length;j++){
				if(considering[i][j]==1){
					scratch[i][j]='X';
					scratch[i+1][j]='X';
					scratch[i+1][j+1]='X';
					scratch[i][j+1]='X';
				}
			}
		}

		return checkScractch();
	}
	String buildoutput(){
		this.scratch=this.grid.clone();
		String out="\n";
		for(int i=0;i<squares.length;i++){
			for(int j=0;j<squares[i].length;j++){
				if(considering[i][j]==1){
					scratch[i][j]='/';
					scratch[i+1][j]='\\';
					scratch[i+1][j+1]='/';
					scratch[i][j+1]='\\';
				}
			}
		}
		
		for(int i=0;i<grid.length;i++){
			for(int j=0;j<grid[i].length;j++){
				out+=scratch[i][j];
			}
			if(i+1<grid.length)
				out+="\n";
		}
		return out;
	}
}