package codejam.qualification.question;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;

import org.apache.commons.collections.BidiMap;
import org.apache.commons.collections.bidimap.DualHashBidiMap;

public class QuestionB {
	
	private List<List<Integer>> inputList = new ArrayList<List<Integer>>();
	private List<Integer> lineList; 
	private List<Integer> bestScoresList = new ArrayList<Integer>();
	private List<Integer> numOfSurprisesList = new ArrayList<Integer>();
	
	private String inFile = "/home/erenay/Downloads/B-small-attempt0.in";
	private String outFile = "/home/erenay/Downloads/out/out-B.txt";
	
	public static void main(String[] args) throws IOException {
		
		QuestionB main = new QuestionB();
		main.solve();
		
	}

	protected void solve() throws IOException{
	
		readInput();
		PrintWriter pw = new PrintWriter(new BufferedWriter(new	FileWriter(outFile)));
		
		for (int i = 0; i < inputList.size(); i++){
			
			int totalCandidates = 0;
			int currentBestScore = bestScoresList.get(i);
			int lowerLimit = currentBestScore * 3 -2;
			int lowerLimitSurp = lowerLimit -2; //Lower limit with surprise
			
			int numSurprises = numOfSurprisesList.get(i);

			List currentLineList = inputList.get(i);
			for (int j=0; j<currentLineList.size(); j++){
				int currentScore = (Integer)currentLineList.get(j);
				if (currentScore >= currentBestScore){
					if ( (currentScore < 30) && (currentScore >= lowerLimit) ){
						totalCandidates++;
					}
					else if (numSurprises > 0){
						if ( (currentScore < 30) && (currentScore >= lowerLimitSurp) ){
							totalCandidates++;
							numSurprises--;
						}
					}
				}
			}
			pw.println("Case #"+(i+1)+": "+totalCandidates);
			
		}
		
		pw.close();
		System.out.println("Completed.");
	

	}
		
	protected void readInput() throws IOException{
		BufferedReader br = new BufferedReader(new FileReader(inFile));
		String line = null;
		
		Integer nEntry = Integer.valueOf(br.readLine());
		if (!(nEntry > 0)){
			throw new RuntimeException("Unexpected input value.");
		}
		for (int i = 0; i<nEntry; i++){
			line = br.readLine();
			lineList = new ArrayList<Integer>();
			StringTokenizer st = new StringTokenizer(line, " ");
			if (st.hasMoreTokens()){
				st.nextToken(); //number of scores
				numOfSurprisesList.add(Integer.valueOf(st.nextToken()));
				bestScoresList.add(Integer.valueOf(st.nextToken()));
				while(st.hasMoreTokens()) {
					Integer score = Integer.valueOf(st.nextToken());
					lineList.add(score);
				}
				inputList.add(lineList);
			}
		}
		
		br.close();
		
	}
		
		
	
		
}
		


