package com.google.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.HashSet;

public class Q3 {

	BufferedReader bReader;
	BufferedWriter bWriter;
	
	ArrayList<Integer> elementsList;
	ArrayList<Integer> possibleTotalList;
	HashSet<Bar> elementSet ;
	
	
	
	public static void main (String[] args) throws IOException{
		Q3 q3 = new Q3();
		q3.solveSmall();
	}

	private void solveSmall() throws IOException {
		try{
			File infile = new File("/home/erenay/Downloads/C-small-attempt0.in");
			bReader = new BufferedReader(new FileReader(infile));
		
			File outfile = new File("/home/erenay/Downloads/C-small-attempt0.out");
			bWriter = new BufferedWriter(new FileWriter(outfile));
		
			int n = Integer.parseInt(bReader.readLine());

			for (int i = 0; i < n; i++){
				
				elementsList = new ArrayList<Integer>();
				possibleTotalList = new ArrayList<Integer>();
				elementSet = new HashSet<Bar>();
				
				int nElements = Integer.parseInt(bReader.readLine());
				StringTokenizer st = new StringTokenizer(bReader.readLine(), " ");
				for (int j = 0; j <nElements; j++){
					elementSet.add(new Bar(j, Integer.parseInt(st.nextToken())));
					    
				}
				Set<Set<Bar>> powerSet = powerSet(elementSet);
			
				int sean_sTotal = 0;
				int pTotal = 0;
				int sean_pTotal = 0;
				boolean found = false;
				
				for (Set<Bar> seanSet : powerSet){
					
					sean_sTotal = 0;
					pTotal = 0;
					sean_pTotal = 0;
					//found = false;
					
					Iterator<Bar> itSean = seanSet.iterator();
					
					
					while (itSean.hasNext()) {
						int sNext = itSean.next().getNumber();
						sean_sTotal = sum_sean(sean_sTotal, sNext);
					}
					Set<Bar> restElementSet = (HashSet<Bar>) elementSet.clone();
					restElementSet.removeAll(seanSet);
					Iterator<Bar> itPatrick = restElementSet.iterator();
					while (itPatrick.hasNext()) {
						int pNext = itPatrick.next().getNumber();
						sean_pTotal = sum_sean(sean_pTotal, pNext);
						pTotal += pNext;
					}
					
					
					if ( (sean_sTotal == sean_pTotal) && (sean_sTotal != 0)) {
						//System.out.println("sTotal: "+sTotal);
						//Iterator<Bar> itp = seanSet.iterator();
						//while (itp.hasNext()) System.out.print(itp.next().getNumber()+", ");
				
						possibleTotalList.add(pTotal);
						
					}
					
					
				}
				System.out.print("Case #"+(i+1)+": ");
				if (!possibleTotalList.isEmpty()){
					System.out.print(Collections.max(possibleTotalList)+"\n");
				}
				else System.out.print("NO\n");
				
			}
		
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		finally{
			bReader.close();
			bWriter.close();
		}
	}
	
	private int sum_sean(int a, int b){
		
		if (a == 0) return b;
		else {
			//System.out.println(""+a+" + "+b+" = "+ (a ^ b));
			return a ^ b;
		}
		
	} 
	
	public Set<Set<Bar>> powerSet(Set<Bar> originalSet) {
        Set<Set<Bar>> sets = new HashSet<Set<Bar>>();
        if (originalSet.isEmpty()) {
            sets.add(new HashSet<Bar>());
            return sets;
        }
        List<Bar> list = new ArrayList<Bar>(originalSet);
        Bar head = list.get(0);
        Set<Bar> rest = new HashSet<Bar>(list.subList(1, list.size()));
        for (Set<Bar> set : powerSet(rest)) {
            Set<Bar> newSet = new HashSet<Bar>();
            newSet.add(head);
            newSet.addAll(set);
            sets.add(newSet);
            sets.add(set);
        }
        return sets;
    }

	private class Bar{

		int id;
		int number;
		
		public int getNumber() {
			return number;
		}

		private Bar(int id, int number) {
			this.id = id;
			this.number = number;
		}
	}

}
