/**
 * 
 */
package com.googlecodejam2014;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;

/**
 * @author Himanshu Jain	erhimanshujain
 *
 */
public class FourthQualifying {

	public static void main(String[] args) {
		BufferedReader buffReader=null;
		BufferedWriter buffWriter=null;
		Integer testCases=null;
		int totalBlockPer;
		Double[] arrKenBlocks;
		Double[] arrNaomiBlocks;
		
		ArrayList<Double> naomiBlocks;
		ArrayList<Double> kenBlocks;
		Double chosenNaomi;
		Double toldNaomi;
		Double minKen;
		int naomiVictories;
		int naomiDeceitVictories;
		
		int chosenNaomiIndex;
		int chosenKenIndex;
		
		
		
		try {
			buffReader=new BufferedReader(new FileReader(new File("C:\\Users\\Himanshu Jain\\Desktop\\CodeJam\\Qualifying2014\\Submission4\\D-large.in")));
			buffWriter=new BufferedWriter(new FileWriter(new File("C:\\Users\\Himanshu Jain\\Desktop\\CodeJam\\Qualifying2014\\Submission4\\D-large.out")));
			
			// Read the input file
			testCases=Integer.valueOf(buffReader.readLine());	// No. of test cases
			
			for(int tcCount=1;tcCount<=testCases;tcCount++) {
				totalBlockPer=Integer.valueOf(buffReader.readLine());	// Total no. of blocks per player
				arrNaomiBlocks=parseDouble(buffReader.readLine().split(" ",totalBlockPer));
				arrKenBlocks=parseDouble(buffReader.readLine().split(" ",totalBlockPer));
				naomiBlocks = new ArrayList<Double>(Arrays.asList(arrNaomiBlocks));
				kenBlocks = new ArrayList<Double>(Arrays.asList(arrKenBlocks));
				
				Collections.sort(naomiBlocks);
				Collections.sort(kenBlocks);
				
				// Normal War
				chosenNaomi=0.00;
				toldNaomi=0.00;
				naomiVictories=0;
				chosenNaomiIndex=0;
				chosenKenIndex=0;
				for(int iTmp=0;iTmp<totalBlockPer;iTmp++) {
					chosenNaomiIndex=naomiBlocks.size()-1;
					chosenNaomi=naomiBlocks.get(chosenNaomiIndex);
					chosenKenIndex=-1;
					for(int jTmp=0;jTmp<kenBlocks.size();jTmp++) {
						if(chosenNaomi<kenBlocks.get(jTmp)) {
							chosenKenIndex=jTmp;							
							break;
						}						
					}
					
					if(chosenKenIndex==-1) {
						naomiVictories++;
						chosenKenIndex=0;
					}
					
					naomiBlocks.remove(chosenNaomiIndex);
					kenBlocks.remove(chosenKenIndex);
				}
				
				// Deceitful War
				naomiBlocks = new ArrayList<Double>(Arrays.asList(arrNaomiBlocks));
				kenBlocks = new ArrayList<Double>(Arrays.asList(arrKenBlocks));
				Collections.sort(naomiBlocks);
				Collections.sort(kenBlocks);
				
				chosenNaomi=0.00;
				toldNaomi=0.00;
				chosenNaomiIndex=0;
				chosenKenIndex=0;
				naomiDeceitVictories=0;
				
				for(int iTmp=0;iTmp<totalBlockPer;iTmp++) {
					chosenNaomiIndex=0;
					chosenNaomi=naomiBlocks.get(chosenNaomiIndex);
					chosenKenIndex=kenBlocks.size()-1;
					if(chosenNaomi>kenBlocks.get(chosenKenIndex)) {
						toldNaomi=chosenNaomi;
						naomiDeceitVictories+=kenBlocks.size();
						break;
					} else {
						if(kenBlocks.size()>1) {
							minKen=kenBlocks.get(0);
							chosenNaomiIndex=-1;
							for(int jTmp=0;jTmp<naomiBlocks.size();jTmp++) {
								if(minKen<naomiBlocks.get(jTmp)) {
									chosenNaomiIndex=jTmp;
									break;
								}						
							}
							if(chosenNaomiIndex==-1) {
								chosenNaomiIndex=0;
								toldNaomi=kenBlocks.get(chosenKenIndex)-((kenBlocks.get(chosenKenIndex)-kenBlocks.get(chosenKenIndex-1))/2);
							} else {
								chosenNaomi=naomiBlocks.get(chosenNaomiIndex);
								toldNaomi=kenBlocks.get(chosenKenIndex)+0.000001;
								chosenKenIndex=0;
								naomiDeceitVictories++;
							}
						}
						else {
							toldNaomi=chosenNaomi;
							
							if(toldNaomi>kenBlocks.get(0))
								naomiDeceitVictories++;
						}
					}
					naomiBlocks.remove(chosenNaomiIndex);
					kenBlocks.remove(chosenKenIndex);
				}
				buffWriter.write("Case #"+tcCount+": "+naomiDeceitVictories+" "+naomiVictories);
				buffWriter.newLine();
				buffWriter.flush();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if(buffReader!=null)	buffReader.close();
				if(buffWriter!=null)	buffWriter.close();
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				buffReader=null;
				buffWriter=null;
			}
		}
	}
	
	private static Double[] parseDouble(String[] strArray) {
		Double[] doubleArray;
		
		doubleArray=new Double[strArray.length];
		for(int iTmp=0;iTmp<doubleArray.length;iTmp++) {
			doubleArray[iTmp]=Double.parseDouble(strArray[iTmp]);
		}
		return doubleArray;
	}
}