import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.Set;


public class Main {

	private static BufferedWriter outputFile;

	public static void main(String[] args) throws IOException {
		//Scanner scanner = new Scanner(Main.class.getResourceAsStream("sample.in"));
		Scanner scanner = new Scanner(Main.class.getResourceAsStream("B-small-attempt2.in"));
		//Scanner scanner = new Scanner(Main.class.getResourceAsStream("B-large.in"));

		outputFile = new BufferedWriter(new FileWriter("result.txt"));
		int caseNbTotal = scanner.nextInt();

		for (int caseNb = 0 ; caseNb < caseNbTotal ; caseNb++){
			int[] tableHavingIPancake = new int[1001];
			// read case data
			int nbDinner  = scanner.nextInt();
			int[] pancakes = new int[nbDinner];
			for (int i = 0 ; i < nbDinner ; i++){
				pancakes[i] = scanner.nextInt();
			}

			String result = "" + getBestNbMinutes(pancakes);

			// write case solution
			writeCase(caseNb, result);
		}
		scanner.close();
		outputFile.close();
	}

	private static int getBestNbMinutes(int[] pancakes) {
		Arrays.sort(pancakes);
		
		if (pancakes[pancakes.length -1] < 4) {
			return pancakes[pancakes.length -1];
		}
		
		int[] noSpecialNext = new int[pancakes.length];
		for(int i = 0 ; i < pancakes.length ; i++){
			noSpecialNext[i] =  pancakes[i]  - 1;
			if (pancakes[i]  - 1 == 0){
				break;
			}
		}
		int noSpecial = 1 + getBestNbMinutes(noSpecialNext);

		int pancakeMoved = pancakes[pancakes.length -1] / 2;
		int[] specialNext = new int[pancakes.length + 1];
		for(int i = 0 ; i < pancakes.length ; i++){
			noSpecialNext[i] =  pancakes[i];
			if (pancakes[i] == 0){
				break;
			}
		}
		specialNext[specialNext.length -2] -= pancakeMoved;
		specialNext[specialNext.length -1] = pancakeMoved;
		int special = 1 + getBestNbMinutes(specialNext);
		
		if (special < noSpecial){
			return special;
		} else {
			return noSpecial;
		}
	}

	private static void writeCase(int caseNb, String result) {
		StringBuilder sb = new StringBuilder("Case #");
		sb.append(caseNb+1);
		sb.append(": ");
		sb.append(result);
		String line = sb.toString();
		System.out.println(line);
		try {
			outputFile.write(line);
			outputFile.write("\n");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
