package problem.b;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Scanner;

public class Magicka {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException,
			InterruptedException {
		final String fileName = "problem/b/small";

		FileInputStream inFile = new FileInputStream(fileName + ".in");
		Scanner in = new Scanner(inFile);

		FileOutputStream outFile = new FileOutputStream(fileName + ".out");
		PrintWriter out = new PrintWriter(outFile);

		int testCases = in.nextInt();

		for (int i = 1; i <= testCases; i++) {
			String[] combinations = new String[in.nextInt()];
			for (int j = 0; j < combinations.length; j++) {
				combinations[j] = in.next();
			}
			String[] opposites = new String[in.nextInt()];
			for (int j = 0; j < opposites.length; j++) {
				opposites[j] = in.next();
			}
			in.next();
			String invocation = in.next();
			String res = "Case #" + i + ": "
					+ solveTestCase(combinations, opposites, invocation);

			out.println(res);
			System.out.println(res);
		}
		System.out.println("Done");
		out.flush();
		out.close();
	}

	public static class CharacterPair {
		char first;
		char second;

		public CharacterPair(char first, char second) {
			super();
			this.first = first;
			this.second = second;
		}

		@Override
		public boolean equals(Object obj) {
			if (obj == null || !(obj instanceof CharacterPair))
				return false;

			CharacterPair that = (CharacterPair) obj;

			return (this.first == that.first && this.second == that.second)
					|| (this.first == that.second && this.second == that.first);
		}

		public Character getOtherIfContained(char test) {
			if(first == test)
				return second;
			else if(second == test)
				return first;
			else return null;
		}

		@Override
		public int hashCode() {
			// TODO Auto-generated method stub
			return this.first ^ this.second;
		}
	}

	private static String solveTestCase(String[] sCombinations,
			String[] sOpposites, String invocation) {

		Map<CharacterPair, Character> combinations = new HashMap<CharacterPair, Character>();

		for (String combination : sCombinations) {
			combinations.put(
				new CharacterPair(combination.charAt(0), combination.charAt(1)),
				combination.charAt(2)
			);
		}

		List<CharacterPair> opposites = new ArrayList<CharacterPair>(
				sOpposites.length);

		for (String opposite : sOpposites) {
			opposites.add(new CharacterPair(
				opposite.charAt(0),
				opposite.charAt(1)
			));
		}

		LinkedList<Character> invoked = new LinkedList<Character>();
		
		invocationLoop: for (int i = 0; i < invocation.length(); i++) {
			char nextChar = invocation.charAt(i);
			if (invoked.isEmpty()) {
				invoked.add(nextChar);
				continue invocationLoop;
			}
			char lastChar = invoked.getLast();

			Character combined = combinations.get(new CharacterPair(nextChar,
					lastChar));
			if (combined != null) {
				invoked.removeLast();
				invoked.add(combined);
			} else {
				invoked.add(nextChar);
				for (CharacterPair oppositePair : opposites) {
					Character opposite = oppositePair
							.getOtherIfContained(nextChar);
					if (opposite != null && invoked.contains(opposite)) {
						invoked.clear();
						continue invocationLoop;
					}
				}
			}
		}
		String sep = "";
		StringBuilder sb = new StringBuilder("[");
		for (char c : invoked) {
			sb.append(sep);
			sb.append(c);
			sep = ", ";
		}
		return sb.append(']').toString();
	}
}
