package problem.c;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;


public class CandySplitting {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException,
			InterruptedException {
		final String fileName = "problem/c/large";
		
		FileInputStream inFile = new FileInputStream(fileName+".in");
		Scanner in = new Scanner(inFile);
		
		FileOutputStream outFile = new FileOutputStream(fileName+".out");
		PrintWriter out = new PrintWriter(outFile);

		int testCases = in.nextInt();

		for (int i = 1; i <= testCases; i++) {
			int[] candyValues = new int[in.nextInt()];
			for (int j = 0; j < candyValues.length; j++) {
				candyValues[j] = in.nextInt();
			}
			Arrays.sort(candyValues);
			out.println("Case #" + i + ": "
					+ solveTestCase(candyValues));
		}
		System.out.println("Done");
		out.flush();
		out.close();
	}

	private static String solveTestCase(int[] candyValues) {
		int xorTotal = 0;
		int total = 0;
		for(int value : candyValues) {
			xorTotal ^= value;
			total += value;
		}
		if(xorTotal != 0)
			return "NO";
		else
			return ""+(total - candyValues[0]);
	}
}
