package round2.b;

import java.io.*;
import java.util.*;

public class SpinningBlade {
	public static void main(String[] args) throws IOException,
			InterruptedException {
		final String fileName = "round2/b/small";

		FileInputStream inFile = new FileInputStream(fileName + ".in");
		Scanner in = new Scanner(inFile);

		FileOutputStream outFile = new FileOutputStream(fileName + ".out");
		PrintWriter out = new PrintWriter(outFile);

		int testCases = in.nextInt();

		for (int i = 1; i <= testCases; i++) {
			int height = in.nextInt();
			int width = in.nextInt();
			int mass = in.nextInt(); //Not needed
			int[][] masses = new int[height][width];
			for(int y = 0; y < height; y++) {
				String row = in.next();
				for(int x = 0; x < width; x++)
					masses[y][x] = row.charAt(x) - '0';
			}
			String s = "Case #" + i + ": " + solveTestCase(masses, width, height);
			out.println(s);
			System.out.println(s);
		}
		System.out.println("Done");
		out.flush();
		out.close();
	}
	
	private static boolean isStable(int[][] masses, int xOffset, int yOffset, int size) {
		double center = (size - 1) / 2.0;
		double xComp = 0;
		double yComp = 0;
		for(int x = 0; x < size; x++) {
			for(int y = 0; y < size; y++) {
				if((y==0 || y == size-1) && (x==0 || x == size-1)) continue;
				
				int mass = masses[y+yOffset][x+xOffset];
				xComp += mass * (x - center);
				yComp += mass * (y - center);
			}
		}
		return xComp == 0 && yComp == 0;
	}

	private static String solveTestCase(int[][] masses, int width, int height) {
		
		for(int size = Math.min(width, height); size >=3; size--)
			for(int x = 0; x <= width - size; x++)
				for(int y = 0; y <= height - size; y++)
					if(isStable(masses, x, y, size))
						return ""+size;
		
		return "IMPOSSIBLE";
	}
}
