package round2.a;

import java.io.*;
import java.util.*;

public class Walkways {
	
	public static class Walkway implements Comparable<Walkway>{
		public final int length;
		public int speed;
		
		public Walkway(int start, int end, int speed) {
			super();
			this.length = end - start;
			this.speed = speed;
		}

		@Override
		public int compareTo(Walkway that) {
			
			return that == null ? -1 : that.speed - this.speed;
		}
		
	}
	
	public static void main(String[] args) throws IOException,
			InterruptedException {
		final String fileName = "round2/a/large";

		FileInputStream inFile = new FileInputStream(fileName + ".in");
		Scanner in = new Scanner(inFile);

		FileOutputStream outFile = new FileOutputStream(fileName + ".out");
		PrintWriter out = new PrintWriter(outFile);

		int testCases = in.nextInt();

		for (int i = 1; i <= testCases; i++) {
			int distance = in.nextInt();
			int normalSpeed = in.nextInt();
			int runningSpeed = in.nextInt();
			int runningTime = in.nextInt();
			Walkway[] walkways = new Walkway[in.nextInt() + 1];
			int length = 0;
			for(int j = 1; j < walkways.length; j++) {
				walkways[j] = new Walkway(in.nextInt(), in.nextInt(), in.nextInt());
				length += walkways[j].length;
			}
			walkways[0] = new Walkway(length, distance, 0);
			
			String s = "Case #" + i + ": " + solveTestCase(distance, normalSpeed, runningSpeed, runningTime, walkways);
			out.println(s);
			System.out.println(s);
		}
		System.out.println("Done");
		out.flush();
		out.close();
	}

	private static String solveTestCase(int distance, int normalSpeed, int runningSpeed, double runningTime , Walkway[] walkways) {
		
		Arrays.sort(walkways, Collections.reverseOrder());
		double time = 0;
		for (Walkway walkway : walkways) {
			walkway.speed += normalSpeed;
		}
		
		runningSpeed -= normalSpeed;
		for (Walkway walkway : walkways) {
			if(runningTime > 0) {
				double fastTime = walkway.length / (double) (walkway.speed + runningSpeed);
				if(fastTime < runningTime) {
					time += fastTime;
					runningTime -= fastTime;
				}
				else {
					double distanceRan = runningTime * (walkway.speed + runningSpeed);
					double distanceLeft = walkway.length - distanceRan;
					double walkTime = distanceLeft / walkway.speed;
					time += walkTime + runningTime;
					runningTime = 0;
				}
			}
			else
				time += walkway.length / (double) walkway.speed;
		}
		return ""+time;
	}
}
