package round1c.a;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream.GetField;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Iterator;
import java.util.Scanner;

import round1b.a.RPI.CellType;

public class SquareTiles {
	public static enum CellType {
		WIN, LOSE, NONE;
		static CellType fromString(char c) {
			return c == '1' ? WIN : c == '0' ? LOSE : NONE;
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException,
			InterruptedException {
		final String fileName = "round1c/a/large";

		FileInputStream inFile = new FileInputStream(fileName + ".in");
		Scanner in = new Scanner(inFile);

		FileOutputStream outFile = new FileOutputStream(fileName + ".out");
		PrintWriter out = new PrintWriter(outFile);

		int testCases = in.nextInt();

		for (int t = 1; t <= testCases; t++) {
			int rows = in.nextInt();
			int cols = in.nextInt();
			char[][] cells = new char[rows][cols];

			for (int i = 0; i < rows; i++) {
				String line = in.next();
				for (int j = 0; j < cols; j++) {
					cells[i][j] = line.charAt(j);
				}
			}

			String s = "Case #" + t + ":\n" + solveTestCase(cells, rows, cols);
			out.println(s);
			System.out.println(s);
		}
		System.out.println("Done");
		out.flush();
		out.close();
	}

	private static String solveTestCase(char[][] cells, int rows, int cols) {
		for (int i = 0; i < rows; i++) {
			for (int j = 0; j < cols; j++) {
				if (cells[i][j] == '#') {
					if(j + 1 >= cols || i + 1 >= rows)
						return "Impossible";
					
					if (cells[i][j + 1] == '#' &&
						cells[i + 1][j + 1] == '#' &&
						cells[i + 1][j] == '#') {
						cells[i][j] = '/';
						cells[i][j+1] = '\\';
						cells[i+1][j+1] = '/';
						cells[i+1][j] = '\\';
					}
					else
						return "Impossible";
				}
			}
		}
		StringBuffer result = new StringBuffer();
		String sep = "";
		for (int i = 0; i < rows; i++) {
			result.append(sep);
			sep = "\n";
			result.append(cells[i]);
			
		}
		return result.toString();
	}
}
