package round2.c;

import java.io.*;
import java.util.*;

public class Restaurant 
{
	public static long GCD(long a, long b)
	{
		   if (b==0) return a;
		   return GCD(b, a%b);
		}
		public static long LCM(long a, long b)
		{
			return a/GCD(a,b)*b;
		}

	public static long calcPrimeNumbers(long n) {
		boolean[] isPrimeNumber = new boolean[(int) (n + 1)]; // boolean defaults to
		long count = 0;
		// false
		for (int i = 2; i <= n; i++) {
			isPrimeNumber[i] = true;
		}
		for (int i = 2; i <= n; i++) {
			if (isPrimeNumber[i]) {
				count++;
				// Now mark the multiple of i as non-prime number
				for (int j = i; j * i <= n; j++) {
					isPrimeNumber[i * j] = false;
				}
			}

		}

		return count;
	}
	public static void main(String[] args) throws IOException,
			InterruptedException {
		final String fileName = "round2/c/small";

		FileInputStream inFile = new FileInputStream(fileName + ".in");
		Scanner in = new Scanner(inFile);

		FileOutputStream outFile = new FileOutputStream(fileName + ".out");
		PrintWriter out = new PrintWriter(outFile);

		int testCases = in.nextInt();

		for (int i = 1; i <= testCases; i++) {
			
			String s = "Case #" + i + ": " + solveTestCase(in.nextInt());
			out.println(s);
			System.out.println(s);
		}
		System.out.println("Done");
		out.flush();
		out.close();
	}

	private static String solveTestCaseBroken(long n) {
		//if(n==1) return "0";
		long test = calcPrimeNumbers(n);
		System.out.println(test);
		return ""+ test;//(n - test);
	}
	
	private static String solveTestCase(int n) {
		long cost = 0;
		long max = 0, min = 0;
		for(int i = 1; i <= n; i++) {
			if(cost == 0)
				cost = i;
			else if(cost % i != 0) {
				cost = LCM(cost, i);
				max++;
			}
		}
		cost = 0;
		for(int i = n; i > 0; i--) {
			if(cost == 0)
				cost = i;
			else if(cost % i != 0) {
				cost = LCM(cost, i);
				min++;
			}
		}
		return Math.abs(max - min) +"";
	}
}
