package round1c.b;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream.GetField;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

public class SpaceEmergency {
	public static final long NORMAL_SPEED = 1;
	public static final long FAST_SPEED = 2;
	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException,
			InterruptedException {
		final String fileName = "round1c/b/large";

		FileInputStream inFile = new FileInputStream(fileName + ".in");
		Scanner in = new Scanner(inFile);

		FileOutputStream outFile = new FileOutputStream(fileName + ".out");
		PrintWriter out = new PrintWriter(outFile);

		int testCases = in.nextInt();

		for (int i = 1; i <= testCases; i++) {
			long boosterCount = in.nextLong();
			long boosterTime = in.nextLong();
			int starCount = in.nextInt();
			int c = in.nextInt();
			long[] distances = new long[c];
			LinkedList<Long> starList = new LinkedList();
			for(int j = 0; j < c; j++) {
				distances[j] = in.nextLong();
			}
			for(int j = 0; j < starCount; j++) {
				starList.add(distances[j%c]*2);
			}
			
			String s = "Case #" + i + ": " + solveTestCase(starList, boosterCount, boosterTime) / 2;
			out.println(s);
			System.out.println(s);
		}
		System.out.println("Done");
		out.flush();
		out.close();
	}

	private static long solveTestCase(LinkedList<Long> starList, long boosterCount, long boosterTime) {
		long slowDistance = 0, fastDistance = 0;
		long boosterDistance = boosterTime;
		
		while(!starList.isEmpty() && starList.getFirst() <= boosterDistance) {
			long distance = starList.removeFirst();
			boosterDistance -= distance;
			slowDistance += distance;
		}
		if(!starList.isEmpty()) {
			slowDistance += boosterDistance;
			long distanceLeft = starList.getFirst() - boosterDistance;
			starList.set(0, distanceLeft);
		}
		else {
			return slowDistance * 2;
		}
		
		Collections.sort(starList);
		Collections.reverse(starList);
		for(long distance : starList) {
			if(boosterCount > 0) {
				boosterCount--;
				fastDistance += distance;
			}
			else {
				slowDistance += distance;
			}
		}

		return 2*slowDistance + fastDistance;
	}
}
