/*
 *  Google Code Jam
 *  Author: Eric Lee <e@ericdlee.com>
 */

import java.io.*;
import java.util.*;

public class D {
  
  private static String runCase(Scanner s) throws IOException {
    int m = s.nextInt();
    int numServers = s.nextInt();
    s.nextLine();
    String[] strings = new String[m];
    for(int i = 0; i < m; i++) {
      strings[i] = s.nextLine();
    }
    
    String[][] servers = new String[numServers][m];
    int[] counters = new int[numServers];
    int[] t = tryAll(strings, servers, counters, 0);
    return t[0] + " " + t[1];
  }
  
  private static int[] tryAll(String[] strings,
                            String[][] servers,
                            int[] counters,
                            int i) {
    if(i < strings.length) {
      int[] ret = new int[2];
      for(int j = 0; j < servers.length; j++) {
        servers[j][counters[j]] = strings[i];
        counters[j]++;
        int[] t = tryAll(strings, servers, counters, i + 1);
        if(t[0] > ret[0]) {
          ret[0] = t[0];
          ret[1] = t[1];
        }
        else if(t[0] == ret[0]) {
          ret[1] += t[1];
        }
        counters[j]--;
        servers[j][counters[j]] = null;
      }
      return ret;
    }
    else {
      int[] ret = new int[2];
      for(int j = 0; j < servers.length; j++) {
        ret[0] += nodesInTrie(Arrays.copyOfRange(servers[j], 0, counters[j]));
      }
      ret[1] = 1;
      return ret;
    }
  }
  
  private static int nodesInTrie(String[] strings) {
    Set<String> stringSet = new HashSet<String>();
    for(int i = 0; i < strings.length; i++) {
      for(int j = 0; j <= strings[i].length(); j++) {
        stringSet.add(strings[i].substring(0, j));
      }
    }
    return stringSet.size();
  }
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  public static void main(String[] args) {
    
    String filename;
    File file;
    Scanner scanner;
    PrintWriter writer;
    int numCases;
    boolean hadProblems = false;
    
    try {
      if(args.length > 0) {
        filename = args[0];
      }
      else {
        System.out.print("Enter the file name, minus extensions: ");
        Scanner kbd = new Scanner(System.in);
        filename = kbd.nextLine();
      }
      file = new File(filename + ".in");
      scanner = new Scanner(file);
      writer = new PrintWriter(filename + ".out", "UTF-8");
      numCases = Integer.parseInt(scanner.nextLine());
    }
    catch(Exception e) {
      System.err.println(e.getMessage());
      return;
    }
    
    System.out.println();
    
    for(int i = 1; i <= numCases; i++) {
      try {
        String output = "Case #" + i + ": " + runCase(scanner);
        writer.println(output);
        System.out.println(output);
      }
      catch(Exception e) {
        e.printStackTrace();
        hadProblems = true;
      }
    }
    
    writer.close();
    
    if(hadProblems) {
      System.out.println();
      System.err.println("ERROR(S) IN TEST CASES. PLEASE CHECK THE OUTPUT.");
    }
    
    System.out.println();
    
  }
  
  
}