/*
 *  Google Code Jam
 *  Author: Eric Lee <e@ericdlee.com>
 */

import java.io.*;
import java.util.*;

public class B {
  
  private static String runCase(Scanner s) throws IOException {
    int n = s.nextInt();
    int[] nums = new int[n];
    for(int i = 0; i < n; i++) {
      nums[i] = s.nextInt();
    }
    
    int last = 0, numSwaps = 0, leftBound = 0, rightBound = n - 1;
    while(true) {
      
      // Find the smallest item not used yet
      int min = Integer.MAX_VALUE, minIndex = -1;
      for(int i = 0; i < n; i++) {
        if(nums[i] < min && nums[i] > last) {
          min = nums[i];
          minIndex = i;
        }
      }
      last = min;
      if(minIndex == -1) {
        break;
      }
      
      // Decide whether to move it left or right
      if(minIndex - leftBound < rightBound - minIndex) {
        for(int i = minIndex; i > 0; i--) {
          if(nums[i - 1] < min) {
            break;
          }
          nums[i] = nums[i - 1];
          nums[i - 1] = min;
          numSwaps++;
        }
        leftBound++;
      }
      else {
        for(int i = minIndex; i < n - 1; i++) {
          if(nums[i + 1] < min) {
            break;
          }
          nums[i] = nums[i + 1];
          nums[i + 1] = min;
          numSwaps++;
        }
        rightBound--;
      }
      
    }
    
    return numSwaps + "";
  }
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  public static void main(String[] args) {
    
    String filename;
    File file;
    Scanner scanner;
    PrintWriter writer;
    int numCases;
    boolean hadProblems = false;
    
    try {
      if(args.length > 0) {
        filename = args[0];
      }
      else {
        System.out.print("Enter the file name, minus extensions: ");
        Scanner kbd = new Scanner(System.in);
        filename = kbd.nextLine();
      }
      file = new File(filename + ".in");
      scanner = new Scanner(file);
      writer = new PrintWriter(filename + ".out", "UTF-8");
      numCases = Integer.parseInt(scanner.nextLine());
    }
    catch(Exception e) {
      System.err.println(e.getMessage());
      return;
    }
    
    System.out.println();
    
    for(int i = 1; i <= numCases; i++) {
      try {
        String output = "Case #" + i + ": " + runCase(scanner);
        writer.println(output);
        System.out.println(output);
      }
      catch(Exception e) {
        System.err.println(e.getMessage());
        hadProblems = true;
      }
    }
    
    writer.close();
    
    if(hadProblems) {
      System.out.println();
      System.err.println("ERROR(S) IN TEST CASES. PLEASE CHECK THE OUTPUT.");
    }
    
    System.out.println();
    
  }
  
  
}