/*
 *  Google Code Jam
 *  Author: Eric Lee <e@ericdlee.com>
 */

import java.io.*;
import java.util.*;

public class A {
  
  private static String runCase(Scanner s) throws IOException {
    int n = s.nextInt();
    int diskSize = s.nextInt();
    int[] files = new int[n];
    for(int i = 0; i < n; i++) {
      files[i] = s.nextInt();
    }
    Arrays.sort(files);
    
    int count = 0;
    for(int i = 0; i < n; i++) {
      if(files[i] < 0) {
        continue;
      }
      boolean matched = false;
      for(int j = n - 1; j > i; j--) {
        if(files[j] < 0) {
          continue;
        }
        if(files[i] + files[j] <= diskSize) {
          files[j] = -1;
          break;
        }
      }
      count++;
    }
    
    return count + "";
  }
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  public static void main(String[] args) {
    
    String filename;
    File file;
    Scanner scanner;
    PrintWriter writer;
    int numCases;
    boolean hadProblems = false;
    
    try {
      if(args.length > 0) {
        filename = args[0];
      }
      else {
        System.out.print("Enter the file name, minus extensions: ");
        Scanner kbd = new Scanner(System.in);
        filename = kbd.nextLine();
      }
      file = new File(filename + ".in");
      scanner = new Scanner(file);
      writer = new PrintWriter(filename + ".out", "UTF-8");
      numCases = Integer.parseInt(scanner.nextLine());
    }
    catch(Exception e) {
      System.err.println(e.getMessage());
      return;
    }
    
    System.out.println();
    
    for(int i = 1; i <= numCases; i++) {
      try {
        String output = "Case #" + i + ": " + runCase(scanner);
        writer.println(output);
        System.out.println(output);
      }
      catch(Exception e) {
        System.err.println(e.getMessage());
        hadProblems = true;
      }
    }
    
    writer.close();
    
    if(hadProblems) {
      System.out.println();
      System.err.println("ERROR(S) IN TEST CASES. PLEASE CHECK THE OUTPUT.");
    }
    
    System.out.println();
    
  }
  
  
}