import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.Deque;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.PriorityQueue;
import java.util.Queue;
import java.util.Scanner;
import java.util.Set;
import java.util.Stack;
import java.util.TreeMap;
import java.util.TreeSet;

import myUtil.MathUtil;
import myUtil.StringUtil;

public class Solution {

	static String inputfile = "D-small-attempt0.in";
	static String outputfile = "C://generate.txt";

	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File(inputfile));

		int n = Integer.parseInt(in.nextLine());

		PrintStream out = new PrintStream(new File(outputfile));
		for (int i = 1; i <= n; i++) {
			out.print("Case #" + i + ":");
			fractiles(in.nextInt(), in.nextInt(), out);
			in.nextInt();
		}
	}

	public static void generate(int k, int c, PrintStream out) {
		String s = "";

		for (int i = 0; i < k; i++) {
			s += "G";
		}

		helper(false, k, "", out);

	}

	private static void helper(boolean b, int k, String cur, PrintStream out) {
		if (cur.length() == k) {
			out.println(cur);
			return;
		}

		if (!b) {
			helper(true, k, cur + 'G', out);
		}
		helper(b, k, cur + 'L', out);

	}

	public static void fractiles(int ks, int c, PrintStream out) {
		while (ks >= 1) {
			out.print(" " + ks--);
		}
		out.println();
	}

	public static void fractiles(int k, int c, int s, PrintStream out) {

		if (c == 1) {
			if (s < k) {
				out.println(" IMPOSSIBLE");
				return;
			} else {
				for (int i = 1; i <= s; i++) {
					out.print(" " + i);
				}
				out.println();
				return;
			}
		} else {
			if (s < k - 1) {
				out.println(" IMPOSSIBLE");
				return;
			} else {
				if (s == 1) {
					out.println(" " + 1);
					return;
				}
				for (int i = 2; i <= s; i++) {
					out.print(" " + i);
				}
				out.println();
				return;
			}

		}
	}

	private static void coinjam(int n, int j, PrintStream out) {

		long min = 1 + (1l << (n - 1)), max = (1l << n) - 1;

		long cur = min;
		outer: while (cur <= max && j > 0) {
			String binaryStr = Long.toBinaryString(cur);
			cur += 2;
			System.out.println("cur: " + cur);
			BigInteger[] bases = new BigInteger[9];
			for (int i = 0; i < 9; i++) {
				bases[i] = MathUtil.bigIntegerParse(binaryStr, i + 2);
				System.out.println("Radix: " + (i + 2));
				if (bases[i].isProbablePrime(4)) {
					continue outer;
				}
			}

			List<String> res = new ArrayList<>();

			res.add(binaryStr);
			for (int i = 0; i < 9; i++) {
				System.out.println("factor: " + i);
				BigInteger sub = getFactor(bases[i]);
				if (sub.equals(BigInteger.ZERO)) {
					continue outer;
				}
				res.add(sub.toString());
			}

			out.print(res.get(0));
			for (int i = 1; i <= 9; i++) {
				out.print(" " + res.get(i));
			}
			out.println();
			j--;
		}
	}

	private static long getFactor(long l) {

		long i = 2l;
		while (i < l) {
			if (l % i == 0) {
				return i;
			}
			i++;
		}

		return -1;
	}

	private static BigInteger getFactor(BigInteger l) {

		BigInteger res = BigInteger.valueOf(2);
		int count = 0;
		while (res.compareTo(l) < 0 && count < 100000) {
			if (l.remainder(res).equals(BigInteger.ZERO)) {
				return res;
			}
			res = res.add(BigInteger.ONE);
			count++;
		}

		return BigInteger.ZERO;
	}

	private static int filp(String str) {
		if (str.length() < 1) {
			return 0;
		}

		int count = 0;
		char cur = str.charAt(0);

		for (int i = 1; i < str.length(); ++i) {
			if (str.charAt(i) == cur) {
				continue;
			} else {
				count++;
				cur = str.charAt(i);
			}
		}

		return cur == '+' ? count : count + 1;

	}

	private static String countSheep(String str) {
		Set<String> counted = new HashSet<>();
		Set<Character> set = new HashSet<>();
		String cur = str;
		while (counted.add(cur)) {
			for (char c : cur.toCharArray()) {
				set.add(c);
			}
			if (set.size() == 10) {
				return cur;
			} else {
				cur = StringUtil.add(cur, str);

			}
		}

		return "INSOMNIA";
	}

	static int anagram(String s) {

		Map<String, Integer> map = new HashMap<String, Integer>();

		char[] c = s.toCharArray();

		for (int i = 1; i < c.length; i++) {
			for (int j = 0; j <= c.length - i; j++) {
				String key = makeKey(c, j, j + i);
				map.put(key, 1 + map.getOrDefault(key, 0));
			}
		}

		int count = 0;

		for (Map.Entry<String, Integer> entry : map.entrySet()) {
			int num = entry.getValue();
			if (num > 1) {
				count += num * (num - 1) / 2;
			}
		}

		return count;

	}

	private static String makeKey(char[] c, int i, int j) {

		char[] key = new char[j - i];
		System.arraycopy(c, i, key, 0, j - i);
		Arrays.sort(key);
		return new String(key);
	}

	static int stableDNA(Scanner in) {
		char[] c = in.next().toCharArray();
		int[][] info = new int[c.length][4];
		int[] diff = new int[4];
		for (int i = 0; i < c.length; i++) {
			if (i > 0) {
				info[i][0] = info[i - 1][0];
				info[i][1] = info[i - 1][1];
				info[i][2] = info[i - 1][2];
				info[i][3] = info[i - 1][3];
			}
			if (c[i] == 'A') {
				info[i][0]++;
			} else if (c[i] == 'C') {
				info[i][1]++;
			} else if (c[i] == 'G') {
				info[i][2]++;
			} else {
				info[i][3]++;
			}
		}

		int lo = 0, hi = 0;
		for (int i = 0; i < 4; i++) {
			diff[i] = info[c.length - 1][i] - c.length / 4;

		}

		int min = c.length;

		while (lo < c.length && hi < c.length) {
			while (lo < c.length && isSteady(lo, hi, info, diff)) {
				lo++;
				min = Math.min(min, hi - lo + 1);
			}
			hi++;
		}
		return min;
	}

	private static boolean isSteady(int lo, int hi, int[][] info, int[] diff) {

		int A = info[hi][0] - ((lo > 0) ? info[lo - 1][0] : 0);
		int C = info[hi][1] - ((lo > 0) ? info[lo - 1][1] : 0);
		int G = info[hi][2] - ((lo > 0) ? info[lo - 1][2] : 0);
		int T = info[hi][3] - ((lo > 0) ? info[lo - 1][3] : 0);
		if (A >= diff[0] && C >= diff[1] && G >= diff[2] && T >= diff[3]) {
			return true;
		} else
			return false;
	}

	static String threesomRotateArray(Scanner in) {
		int n = in.nextInt();
		int[] A = new int[n];
		int k = 0;
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				if (A[j] < A[i]) {
					k++;
				}
			}
		}

		return (k & 1) == 0 ? "YES" : "NO";
	}

	static int minCostBS(String s) {
		int n = s.length();
		int[] cost = new int[n];
		int[] cum_cost = new int[n];
		for (int i = 0; i < n; i++) {
			cost[i] = s.charAt(i) - '0';
			cum_cost[i] = ((i > 0) ? cum_cost[i - 1] : 0) + cost[i];
		}

		int lo = 0, hi = n - 1, totalcost = 0;
		while (lo <= hi) {
			int key = cum_cost[hi] - ((lo > 0) ? cum_cost[lo - 1] : 0);
			int pos = Arrays.binarySearch(cum_cost, lo, hi + 1, key / 2);
			if (pos < 0) {
				pos = -(pos + 1);
			} else {
				if (2 * cum_cost[pos] != key)
					pos++;

			}
			totalcost += cost[pos];

			int left = cum_cost[pos] - cost[pos]
					- ((lo > 0) ? cum_cost[lo - 1] : 0), right = cum_cost[hi]
					- cum_cost[pos];
			if (left > right) {
				hi = pos - 1;
			} else {
				lo = pos + 1;
			}
		}

		return totalcost;

	}

	static int insertionSort(Scanner in) {

		Deque<String> stack = new LinkedList<>();
		int cards = Integer.parseInt(in.nextLine());
		int count = 0;
		while (cards-- > 0) {
			String cur = in.nextLine();
			if (!stack.isEmpty() && cur.compareTo(stack.peek()) < 0) {
				count++;
			} else {
				stack.push(cur);
			}
		}

		return count;
	}

	static double degree(Scanner in) {

		double v = in.nextDouble(), d = in.nextDouble();
		final double g = 9.8;
		double sin = g * d / v / v;
		if (sin > 1) {
			sin = 1.0;
		}
		return Math.toDegrees(Math.asin(sin) / 2);

	}

	static String isBipath(Scanner in) {
		int pairs = in.nextInt();

		Map<String, List<String>> g = new HashMap<String, List<String>>();
		Map<String, Boolean> color = new HashMap<>();
		Set<String> unv = new HashSet<>();
		while (pairs-- > 0) {
			String p1 = in.next();
			String p2 = in.next();

			if (!g.containsKey(p1)) {
				g.put(p1, new ArrayList<>());
			}
			if (!g.containsKey(p2)) {
				g.put(p2, new ArrayList<>());
			}
			g.get(p1).add(p2);
			g.get(p2).add(p1);
			unv.add(p1);
			unv.add(p2);
		}

		Deque<String> q = new LinkedList<>();
		while (!unv.isEmpty()) {
			{
				Iterator<String> it = unv.iterator();
				q.offer(it.next());
			}
			boolean flag = false;
			while (!q.isEmpty()) {
				int size = q.size();
				while (size-- > 0) {
					String cur = q.poll();
					if (unv.contains(cur)) {
						unv.remove(cur);
						color.put(cur, flag);
						q.addAll(g.get(cur));
					} else {
						if (color.get(cur) ^ flag) {
							return "NO";
						}
					}
				}
				flag = !flag;
			}
		}

		return "YES";

	}

	static int googleString(int N, long k) {
		if (N == 1)
			return 0;
		long len = (1l << N) - 1;
		if (k == ((len + 1) >>> 1)) {
			return 0;
		} else if (k < ((len + 1) >>> 1)) {
			return googleString(N - 1, k);
		} else
			return 1 - googleString(N - 1, (len + 1) - k);
	}

	static String rank(Scanner in) {

		Map<String, Queue<Integer>> map = new HashMap<>();

		int[] score = new int[in.nextInt()];
		for (int i = 0; i < score.length; i++) {
			score[i] = in.nextInt();
		}
		int numComp = in.nextInt();

		while (numComp-- > 0) {
			int weight = in.nextInt();
			for (int i = 0; i < score.length; i++) {
				String name = in.next();
				if (!map.containsKey(name)) {
					map.put(name, new PriorityQueue<>(
							new Comparator<Integer>() {
								@Override
								public int compare(Integer o1, Integer o2) {
									// TODO Auto-generated method stub
									return o2 - o1;
								}

							}));
				}
				map.get(name).add(weight * score[i]);
			}
		}

		int first = in.nextInt();

		Map<String, Integer> board = new TreeMap<String, Integer>();

		for (String name : map.keySet()) {
			int total = 0;
			for (int i = 0; i < first && !map.get(name).isEmpty(); i++) {
				total += map.get(name).poll();
			}
			board.put(name, total);
		}

		List<Entry<String, Integer>> result = new ArrayList<>();

		result.addAll(board.entrySet());
		Collections.sort(result, new Comparator<Entry<String, Integer>>() {

			@Override
			public int compare(Entry<String, Integer> e0,
					Entry<String, Integer> e1) {
				if (e0.getValue() == e1.getValue()) {
					return e0.getKey().compareTo(e1.getKey());
				} else
					return -e0.getValue() + e1.getValue();
			}

		});

		StringBuilder sb = new StringBuilder();
		int previous = 0, count = 1, rank = 1;
		for (Entry<String, Integer> e : result) {
			if (count == 1 || e.getValue() != previous) {
				rank = count;
			} else {
			}
			sb.append(rank + ": " + e.getKey()/**
			 * + "(" + e.getValue() + ")"
			 **/
			+ System.lineSeparator());
			count++;
			previous = e.getValue();
		}

		return sb.toString();

	}

	static int lazySpell(String s) {

		if (s.length() < 2)
			return 1;

		int[] num = new int[s.length()];

		Arrays.fill(num, 3);

		num[0] = num[num.length - 1] = 2;

		for (int i = 0; i < s.length() - 1; i++) {
			if (i < s.length() - 1 && s.charAt(i) == s.charAt(i + 1)) {
				num[i]--;
				num[i + 1]--;
			}
			if (i < s.length() - 2 && s.charAt(i) == s.charAt(i + 2)) {
				num[i + 1]--;
			}
		}

		long res = 1;

		for (int n : num) {
			if (n != 0) {
				res *= n;
				if (res > 1000000007) {
					res %= 1000000007;
				}
			}
		}

		return (int) res;
	}

	static String ReverseShuffleMerge(String s) {

		int[] info = new int[26];

		for (char c : s.toCharArray()) {
			info[c - 'a']++;
		}

		int[] need = new int[26];
		for (int i = 0; i < info.length; i++) {
			need[i] = info[i] >>> 1;
		}

		Stack<Character> stack = new Stack<>();

		for (int i = s.length() - 1; i >= 0; i--) {

			char c = s.charAt(i);

			while (!stack.isEmpty() && stack.peek() > c
					&& info[stack.peek() - 'a'] > need[stack.peek() - 'a']
					&& need[c - 'a'] > 0) {
				need[stack.pop() - 'a']++;
			}

			if (need[c - 'a'] > 0) {
				stack.push(c);
				need[c - 'a']--;
			}
			info[c - 'a']--;
		}

		StringBuffer sb = new StringBuffer();
		while (!stack.isEmpty()) {
			sb.append(stack.pop());

		}

		return sb.reverse().toString();
	}

	public static String[] getWords(String sen) {

		Set<Character> allowed = new HashSet<>(Arrays.asList(new Character[] {
				'a', 'e', 'i', 'o', 'u', 'h', 'k', 'l', 'm', 'n', 'p', 'w' }));

		List<String> foo = new LinkedList<>(Arrays.asList(sen.split(" ")));

		for (Iterator<String> iterator = foo.iterator(); iterator.hasNext();) {
			String string = iterator.next();
			for (char c : string.toCharArray()) {
				if (!allowed.contains(c)) {
					iterator.remove();
					break;
				}
			}
		}

		String[] ans = new String[foo.size()];

		System.arraycopy(foo.toArray(), 0, ans, 0, ans.length);

		return ans;

	}

	public static int numWins(int[] A, int m, int n) {

		boolean[] dp = new boolean[n + 1];
		int count = 0;
		for (int i = 1; i < dp.length; i++) {

			for (int j = 0; j < A.length; j++) {
				if (i - A[j] >= 0 && !dp[i - A[j]]) {
					dp[i] = true;
					break;
				}
			}

			if (i >= m && i <= n) {
				count += (dp[i]) ? 1 : 0;
			}
			System.out.printf("%6d", (i - 1));
		}
		System.out.println();
		System.out.println(Arrays.toString(dp));
		TreeSet t;
		return count;
	}

	public static int whichOne(int n) {

		int size = 2 * n / (int) Math.sqrt(n);
		List<Integer> list = new ArrayList<>(size);

		for (int i = n - size; i <= n; i++)
			list.add(i);

		while (n != 1) {
			int root = (int) Math.sqrt(n);
			list.remove(list.size() - 1 - n + root * root);
			n -= root;
		}

		return list.get(list.size() - 1);
	}

}
