import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.BigInteger;

public class Coins {

	public static String create(long i, int n) {
		StringBuilder s = new StringBuilder(n);
		while(i != 0) {
			s.append(i % 2);
			i = i / 2;
		}
		int length = s.length();
		for(int j = 0; j < n - length - 2; ++j)
			s.append(0);
		s.append(1);
		s.reverse();
		s.append(1);
		return s.toString();
	}

	public static BigInteger fromBase(String s, int base) {
		int length = s.length();
		BigInteger num = BigInteger.valueOf(0);
		for(int i = 0; i < length; ++i) {
			if(s.charAt(i) - '0' == 1) {
				int power = length - 1 - i;
				num = num.add(BigInteger.valueOf(base).pow(power));
			}			
		}
		return num;
	}

	public static int findFirstFactor(BigInteger n) {
		for(int i = 2; i < 201; ++i) {
			BigInteger bigI = BigInteger.valueOf(i);
			if(bigI.compareTo(n) == 0)
				break;
			if(n.mod(bigI).intValue() == 0)
				return i;
		}
		return 0;
	}

	public static void main(String[] args)  throws FileNotFoundException, IOException {
		Scanner s = new Scanner(new File("C-large.in"));
		//Scanner s = new Scanner(System.in);
		PrintWriter out = new PrintWriter(new FileWriter("Coins.out"));
		int t = s.nextInt();
		for(int tests = 0; tests < t; ++tests) {
			int n = s.nextInt();
			int j = s.nextInt();
			int counter = 0;
			out.println("Case #" + (tests + 1) + ":");
			long expt = (long)Math.pow(2, n-2);
			for(long i = 0; i < expt; ++i) {
				String coin = create(i, n);
				int[] proofs = new int[9];
				for(int x = 10; x >= 2; --x) {
					int factor = findFirstFactor(fromBase(coin, x));
					if(factor == 0)
						break;
					proofs[x - 2] = factor;
				}
				if(proofs[0] != 0) {
					++counter;
					out.print(coin);
					for(int x = 0; x < 9; ++x) {
						out.print(" " + proofs[x]);
					}
					out.println();
				}
				if(counter == j)
					break;
			}
		}
		out.close();
	}
}