package codejam2016.qulificaton;

import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class CountingSheep {

    public static void main(String[] args) {
        final int[] solutions = testCase("/codejam2016/qualification/counting_sheep_small.in");
        final Set<Character> set = new HashSet<>();
        initSet(set);

        for (int i = 0; i < solutions.length; i++) {
            long current = solutions[i];
            long last = solutions[i];
            initSet(set);

            if (current == 0) {
                System.out.println("Case #" + (i + 1) + ": INSOMNIA");
                continue;
            }

            int factor = 1;
            updateSet(set, current);

            while (!set.isEmpty()) {
                last = current * factor;
                factor++;
                updateSet(set, last);
            }
            System.out.println("Case #" + (i + 1) + ": " + last);
        }
    }

    private static void updateSet(Set<Character> set, long current) {
        for (Character c : String.valueOf(current).toCharArray()) {
            set.remove(c);
        }
    }

    private static int[] testCase(String inputFilePath) {
        final Scanner scanner = new Scanner(CountingSheep.class.getResourceAsStream(inputFilePath));
        final int solutionSize = scanner.nextInt();
        final int[] solutions = new int[solutionSize];
        for (int i = 0; i < solutions.length; i++) {
            solutions[i] = scanner.nextInt();
        }
        return solutions;
    }

    private static void initSet(Set<Character> set) {
        set.add('0');
        set.add('1');
        set.add('2');
        set.add('3');
        set.add('4');
        set.add('5');
        set.add('6');
        set.add('7');
        set.add('8');
        set.add('9');
    }


}
