package codejam2016.qulificaton;

import java.util.Scanner;

public class CoinLam {


    public static void main(String[] args) {
        final Scanner scanner = new Scanner(CoinLam.class.getResourceAsStream("/codejam2016/qualification/coin_jam_small.txt"));
        scanner.nextInt();
        final int N = scanner.nextInt();
        final int J = scanner.nextInt();

        System.out.println("Case #" + 1 + ": ");
        int currentJ = J;
        int currentNum = getInitialNum(N);
//        System.out.println(currentNum);
        while (currentJ > 0) {
            long[] bases = toBases(currentNum);
            final long[] devisors = getDevisorsPrimes(bases);
            if (!hasPrime(devisors)) {
                System.out.print(Integer.toBinaryString(currentNum));
                for (int i = 0; i < devisors.length; i++) {
//                    System.out.print(" " + bases[i] + "/" + devisors[i]);
                    System.out.print(" " + devisors[i]);
                }
                System.out.println();
                currentJ--;
            }
            currentNum += 2;
        }
    }

    private static boolean hasPrime(long[] devisors) {
        for (int i = 0; i < devisors.length; i++) {
            if (devisors[i] < 0) return true;
        }
        return false;
    }

    private static long[] getDevisorsPrimes(long[] bases) {
        final long[] divesors = new long[9];
        for (int i = 0; i < bases.length; i++) {
            divesors[i] = isPrime(bases[i]);
        }
        return divesors;
    }

    private static long[] toBases(int currentNum) {
        final String binary = Integer.toBinaryString(currentNum);
        final long[] bases = new long[9];
        bases[0] = Long.parseLong(binary, 2);
        bases[1] = Long.parseLong(binary, 3);
        bases[2] = Long.parseLong(binary, 4);
        bases[3] = Long.parseLong(binary, 5);
        bases[4] = Long.parseLong(binary, 6);
        bases[5] = Long.parseLong(binary, 7);
        bases[6] = Long.parseLong(binary, 8);
        bases[7] = Long.parseLong(binary, 9);
        bases[8] = Long.parseLong(binary, 10);
        return bases;
    }

    private static int getInitialNum(int n) {
        final char[] arr = new char[n];
        arr[0] = '1';
        arr[arr.length - 1] = '1';
        for (int i = 1; i < arr.length - 1; i++) {
            arr[i] = '0';
        }

        return Integer.parseInt(String.valueOf(arr), 2);
    }

    private static long isPrime(long n) {
        if (n % 2 == 0) {
            return 2;
        }
        if (n % 3 == 0) {
            return 3;
        }
        long sqrtN = (long) Math.sqrt(n) + 1;
        for (long i = 6L; i <= sqrtN; i += 6) {
            if (n % (i - 1) == 0) {
                return i - 1;
            }
            if (n % (i + 1) == 0) {
                return i + 1;
            }
        }
        return -1;
    }

}
