package contests.java;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.LinkedList;
import java.util.List;

/**
 * @author Ernesto Velazquez Caballero
 * @since 12/04/2015
 */
public class ContestC {
    private static final int[][] VALUES = new int[][]
            {
                    {0, 1, 2, 3},
                    {1, 0, 3, 2},
                    {2, 3, 0, 1},
                    {3, 2, 1, 0}
            };

    private static final int[][] SIGNS = new int[][]
            {
                    {1,  1,  1,  1},
                    {1, -1,  1, -1},
                    {1, -1, -1,  1},
                    {1,  1, -1, -1}
            };

    /**
     * @param args
     * @throws java.io.IOException
     */
    public static void main(String[] args) throws Exception {
        final FileReader fileReader = new FileReader("res\\contest_1\\C-small-attempt2.in");
        final BufferedReader bufferedReader = new BufferedReader(fileReader);

        final int numberOfTests = Integer.parseInt(bufferedReader.readLine());

        for (int i = 0; i < numberOfTests; i ++) {
            final String[] stringElements = bufferedReader.readLine().split(" ");
            final int l = Integer.parseInt(stringElements[0]);
            final int x = Integer.parseInt(stringElements[1]);
            String partialQuaternionsString = bufferedReader.readLine();

//            System.out.println("");
//            System.out.println(String.format("l=%s, x=%s, partial=%s", l, x, partialQuaternionsString));
//            System.out.println("");

            int totalSize = l * x;
            boolean isEquivalent = false;
            boolean isValid = (totalSize >= 3);

            if (isValid) {
                final char firstChar = partialQuaternionsString.charAt(0);
                isValid = false;

                for (int j = 1; j < l; j ++) {
                    if (partialQuaternionsString.charAt(j) != firstChar) {
                        isValid = true;
                        break;
                    }
                }
            }

            if (isValid) {
                partialQuaternionsString = partialQuaternionsString
                        .replace('i', '1').replace('j', '2').replace('k', '3');

                final StringBuilder sb = new StringBuilder(totalSize);
                for (int j = 0; j < x; j++) {
                    sb.append(partialQuaternionsString);
                }
                final char[] quaternionsCharArray = sb.toString().toCharArray();
                final int[] quaternionsArray = new int[totalSize];

                for (int j = 0; j < totalSize; j++) {
                    quaternionsArray[j] = Character.getNumericValue(quaternionsCharArray[j]);
                }

                int currentSign = 1;
                int currentChar = 0;
                final List<Integer> firstGroupIndices = new LinkedList<Integer>();

                for (int index = 0; index <= quaternionsArray.length - 3; index ++) {
                    final int nextChar = quaternionsArray[index];
                    currentSign *= SIGNS[currentChar][nextChar];
                    currentChar = VALUES[currentChar][nextChar];

                    if ((currentChar == 1) && (currentSign > 0)) {
                        firstGroupIndices.add(index + 1);
                    }
                }

                currentSign = 1;
                currentChar = 0;
                final List<Integer> thirdGroupIndices = new LinkedList<Integer>();

                for (int index = quaternionsArray.length - 1; index >= 2; index --) {
                    final int nextChar = quaternionsArray[index];
                    currentSign *= SIGNS[currentChar][nextChar];
                    currentChar = VALUES[currentChar][nextChar];

                    if ((currentChar == 3) && (currentSign > 0)) {
                        thirdGroupIndices.add(index - 1);
                    }
                }

out:
                if (!isEquivalent) {
                    for (int index1 : firstGroupIndices) {
                        for (int index2 : thirdGroupIndices) {
                            if (index1 <= index2) {
                                isEquivalent = isProductValueEqualsTo(index1, index2, quaternionsArray, 2);
                                if (isEquivalent) {
//                                        System.out.println("startIndex: " + index1);
//                                        System.out.println("endIndex: " + index2);
                                    break out;
                                }
                            }
                        }
                    }
                }
            }

            if (isValid && isEquivalent) {
                System.out.println("Case #" + (i + 1) + ": YES");
            } else {
                System.out.println("Case #" + (i + 1) + ": NO");
            }
        }
    }

    private static boolean isProductValueEqualsTo(final int startIndex, final int endIndex, final int[] quaternionsArray, final int expectedChar) throws Exception {
        int currentChar = 0;

        for (int i = startIndex; i <= endIndex; i ++) {
            currentChar = VALUES[currentChar][quaternionsArray[i]];
        }

        if (currentChar == expectedChar) {
            int currentSign = 1;
            currentChar = 0;

            for (int i = startIndex; i <= endIndex; i ++) {
                currentSign *= SIGNS[currentChar][quaternionsArray[i]];
            }

            return (currentSign > 0);
        }

        return false;
    }
}
