package round1c.c;

import round1c.c.Key;

import java.io.*;
import java.util.*;

public class Solution {
    private static final String EXERCISE = "c";
    private static final String INPUT_FOLDER = "input/round1c/" + EXERCISE;
    private static final String OUTPUT_FOLDER = "output/round1c/" + EXERCISE;

//    private static final String FILENAME = "test";
    private static final String FILENAME = EXERCISE.toUpperCase() + "-small-attempt0";
//    private static final String FILENAME = EXERCISE.toUpperCase() + "-large";

    public static void main(String[] args) throws IOException {
        final long start = System.nanoTime();

        // READ INPUT FILE
        final FileReader fileReader = new FileReader(INPUT_FOLDER + "/" + FILENAME + ".in");
        final BufferedReader bufferedReader = new BufferedReader(fileReader);

        String line = bufferedReader.readLine();
        final Integer numberOfCases = Integer.parseInt(line);
        final String[] cases = new String[numberOfCases];

        for (int i = 0; i < numberOfCases; i++) {
            line = bufferedReader.readLine();
            cases[i] = line;
        }

        bufferedReader.close();


        // WRITE OUTPUT FILE
        final FileWriter fileWriter = new FileWriter(OUTPUT_FOLDER + "/" + FILENAME + ".out");
        final BufferedWriter bufferedWriter = new BufferedWriter(fileWriter);

        for (int i = 0; i < cases.length; i++) {
            final String[] temp = cases[i].split(" ");
            final int j = Integer.parseInt(temp[0]);
            final int p = Integer.parseInt(temp[1]);
            final int s = Integer.parseInt(temp[2]);
            final int k = Integer.parseInt(temp[3]);

            final String[] solution = solveCase(j, p, s, k);
            bufferedWriter.write("Case #" + (i + 1) + ": " + solution.length + System.lineSeparator());
            for (int i2 = 1; i2 < solution.length; i2 ++) {
                bufferedWriter.write(solution[i2] + System.lineSeparator());
            }
        }

        bufferedWriter.close();

        final long end = System.nanoTime();

        System.out.println("Total time: " + (end - start) / 1000000.0);
    }

    private static boolean isValid(final int ji, final int pi, final int si, final int k, final Map<Key, Integer> map) {
        final Key jpKey = new Key("J" + ji, "P" + pi);
        Integer jpValue = map.get(jpKey);
        if (jpValue != null) {
            if (jpValue == k) {
                return false;
            }
        } else {
            jpValue = 0;
        }

        final Key jsKey = new Key("J" + ji, "S" + si);
        Integer jsValue = map.get(jsKey);
        if (jsValue != null) {
            if (jsValue == k) {
                return false;
            }
        } else {
            jsValue = 0;
        }

        final Key psKey = new Key("P" + pi, "S" + si);
        Integer psValue = map.get(psKey);
        if (psValue != null) {
            if (psValue == k) {
                return false;
            }
        } else {
            psValue = 0;
        }

        map.put(jpKey, jpValue + 1);
        map.put(jsKey, jsValue + 1);
        map.put(psKey, psValue + 1);

        return true;
    }

    private static String[] solveCase(final int j, final int p, final int s, final int k) {
        final Map<Key, Integer> map = new HashMap<>();
        final List<String> result = new ArrayList<>();

        for (int ji = 1; ji <= j; ji ++) {
            for (int pi = 1; pi <= p; pi ++) {
                for (int si = 1; si <= s; si ++) {
                    if (isValid(ji, pi, si, k, map)) {
                        result.add(ji + "" + pi + "" + si);
                    }
                }
            }
        }

        return result.toArray(new String[0]);
    }
}
