package round1b.a;

import java.io.*;
import java.util.HashMap;
import java.util.Map;

public class Solution {
    private static final String EXERCISE = "a";
    private static final String INPUT_FOLDER = "input/round1b/" + EXERCISE;
    private static final String OUTPUT_FOLDER = "output/round1b/" + EXERCISE;

//    private static final String FILENAME = "test";
    private static final String FILENAME = EXERCISE.toUpperCase() + "-small-attempt1";
//    private static final String FILENAME = EXERCISE.toUpperCase() + "-large";

    public static void main(String[] args) throws IOException {
        final long start = System.nanoTime();

        // READ INPUT FILE
        final FileReader fileReader = new FileReader(INPUT_FOLDER + "/" + FILENAME + ".in");
        final BufferedReader bufferedReader = new BufferedReader(fileReader);

        String line = bufferedReader.readLine();
        final Integer numberOfCases = Integer.parseInt(line);
        final String[] cases = new String[numberOfCases];

        for (int i = 0; i < numberOfCases; i++) {
            line = bufferedReader.readLine();
            cases[i] = line;
        }

        bufferedReader.close();


        // WRITE OUTPUT FILE
        final FileWriter fileWriter = new FileWriter(OUTPUT_FOLDER + "/" + FILENAME + ".out");
        final BufferedWriter bufferedWriter = new BufferedWriter(fileWriter);

        for (int i = 0; i < cases.length; i++) {
            final String numbers = cases[i];
            bufferedWriter.write("Case #" + (i + 1) + ": " + solveCase(numbers) + System.lineSeparator());
        }

        bufferedWriter.close();

        final long end = System.nanoTime();

        System.out.println("Total time: " + (end - start) / 1000000.0);
    }

    private static String solveCase(final String numbers) {
        final Map<Integer, Integer> map = new HashMap<>();
        for (int i = 0; i < 10; i++) {
            map.put(i, 0);
        }

        char[] characters = numbers.toCharArray();
        characters = removeNumber(characters, map, 'Z', new char[]{'Z', 'E', 'R', 'O'}, 0);
        characters = removeNumber(characters, map, 'W', new char[]{'T', 'W', 'O'}, 2);
        characters = removeNumber(characters, map, 'U', new char[]{'F', 'O', 'U', 'R'}, 4);
        characters = removeNumber(characters, map, 'X', new char[]{'S', 'I', 'X'}, 6);
        characters = removeNumber(characters, map, 'G', new char[]{'E', 'I', 'G', 'H', 'T'}, 8);
        characters = removeNumber(characters, map, 'O', new char[]{'O', 'N', 'E'}, 1);
        characters = removeNumber(characters, map, 'H', new char[]{'T', 'H', 'R', 'E', 'E'}, 3);
        characters = removeNumber(characters, map, 'F', new char[]{'F', 'I', 'V', 'E'}, 5);
        characters = removeNumber(characters, map, 'S', new char[]{'S', 'E', 'V', 'E', 'N'}, 7);

        int count = 0;
        for (int i = 0; i < characters.length; i++) {
            if (characters[i] == '-') {
                count++;
            }
        }

        map.put(9, (characters.length - count) / 4);

        String result = "";

        for (int i = 0; i <= 9; i++) {
            count = map.get(i);
            String number = Integer.toString(i);
            for (int j = 0; j < count; j++) {
                result += number;
            }
        }

        return result;
    }

    private static char[] removeNumber(char[] characters, final Map<Integer, Integer> map, final char character, final char[] chars, final int number) {
        int length = characters.length;
        int counter = 0;

        for (int i = 0; i < length; i++) {
            if (characters[i] == character) {
                counter++;
            }
        }

        map.put(number, counter);

        for (int i = 0; i < chars.length; i++) {
            characters = removeCharacter(characters, chars[i], counter);
        }

        return characters;
    }

    private static char[] removeCharacter(final char[] characters, final char character, final int count) {
        int index = 0;
        for (int i = 0; i < count; i++) {
            while (characters[index] != character) {
                index++;
            }
            characters[index] = '-';
        }
        return characters;
    }
}
