package round1b.b;

import java.io.*;

public class Solution {
    private static final String EXERCISE = "b";
    private static final String INPUT_FOLDER = "input/round1b/" + EXERCISE;
    private static final String OUTPUT_FOLDER = "output/round1b/" + EXERCISE;

//    private static final String FILENAME = "test";
    private static final String FILENAME = EXERCISE.toUpperCase() + "-small-attempt0";
//    private static final String FILENAME = EXERCISE.toUpperCase() + "-large";

    public static void main(String[] args) throws IOException {
        final long start = System.nanoTime();

        // READ INPUT FILE
        final FileReader fileReader = new FileReader(INPUT_FOLDER + "/" + FILENAME + ".in");
        final BufferedReader bufferedReader = new BufferedReader(fileReader);

        String line = bufferedReader.readLine();
        final Integer numberOfCases = Integer.parseInt(line);
        final String[][] cases = new String[numberOfCases][2];

        for (int i = 0; i < numberOfCases; i++) {
            line = bufferedReader.readLine();
            final String[] numbers = line.split(" ");
            cases[i][0] = numbers[0];
            cases[i][1] = numbers[1];
        }

        bufferedReader.close();


        // WRITE OUTPUT FILE
        final FileWriter fileWriter = new FileWriter(OUTPUT_FOLDER + "/" + FILENAME + ".out");
        final BufferedWriter bufferedWriter = new BufferedWriter(fileWriter);

        for (int i = 0; i < cases.length; i++) {
            final String c = cases[i][0];
            final String j = cases[i][1];
            bufferedWriter.write("Case #" + (i + 1) + ": " + solveCase(c, j) + System.lineSeparator());
        }

        bufferedWriter.close();

        final long end = System.nanoTime();

        System.out.println("Total time: " + (end - start) / 1000000.0);
    }

    private static String solveCase(final String c, final String j) {
        char[] cc = c.toCharArray();
        char[] jj = j.toCharArray();
        int length = cc.length;
        int index = 0;

        while (index < length) {
            if (cc[index] == jj[index]) {
                if (cc[index] == '?') {
                    cc[index] = '0';
                    jj[index] = '0';
                }
            } else {
                if (cc[index] == '?') {
                    int jjj = Integer.parseInt(String.valueOf(jj[index]));

                    if (jjj == 0) {
                        long jjjj = value(jj);

                        cc[index] = '0';
                        long cccc0 = value(cc);

                        cc[index] = '9';
                        long cccc9 = value(cc);

                        cc[index] = '?';

                        if (Math.abs(cccc0 - jjjj) <= Math.abs(cccc9 - jjjj)) {
                            cc[index] = '0';
                        } else {
                            cc[index] = '9';
                        }
                    } else {
                        int jjjm1 = jjj - 1;
                        int jjjp1 = jjj + 1;

                        long jjjj = value(jj);

                        cc[index] = ("" + jjjm1).charAt(0);
                        long ccccm1 = value(cc);

                        cc[index] = ("" + jjj).charAt(0);
                        long cccc = value(cc);

                        cc[index] = ("" + jjjp1).charAt(0);
                        long ccccp1 = value(cc);

                        cc[index] = '?';

                        long[] abs = new long[]{
                                Math.abs(ccccm1 - jjjj),
                                Math.abs(cccc - jjjj),
                                Math.abs(ccccp1 - jjjj)
                        };

                        if ((abs[0] <= abs[1]) && (abs[0] <= abs[2])) {
                            cc[index] = ("" + jjjm1).charAt(0);
                        } else if ((abs[1] <= abs[0]) && (abs[1] <= abs[2])) {
                            cc[index] = ("" + jjj).charAt(0);
                        } else {
                            cc[index] = ("" + jjjp1).charAt(0);
                        }
                    }
                } else if (jj[index] == '?') {
                    int ccc = Integer.parseInt(String.valueOf(cc[index]));

                    if (ccc == 0) {
                        long cccc = value(cc);

                        jj[index] = '0';
                        long jjjj0 = value(jj);

                        jj[index] = '9';
                        long jjjj9 = value(jj);

                        jj[index] = '?';

                        if (Math.abs(jjjj0 - cccc) <= Math.abs(jjjj9 - cccc)) {
                            jj[index] = '0';
                        } else {
                            jj[index] = '9';
                        }
                    } else {
                        int cccm1 = ccc - 1;
                        int cccp1 = ccc + 1;

                        long cccc = value(cc);

                        jj[index] = ("" + cccm1).charAt(0);
                        long jjjjm1 = value(jj);

                        jj[index] = ("" + ccc).charAt(0);
                        long jjjj = value(jj);

                        jj[index] = ("" + cccp1).charAt(0);
                        long jjjjp1 = value(jj);

                        jj[index] = '?';

                        long[] abs = new long[]{
                                Math.abs(jjjjm1 - cccc),
                                Math.abs(jjjj - cccc),
                                Math.abs(jjjjp1 - cccc)
                        };

                        if ((abs[0] <= abs[1]) && (abs[0] <= abs[2])) {
                            jj[index] = ("" + cccm1).charAt(0);
                        } else if ((abs[1] <= abs[0]) && (abs[1] <= abs[2])) {
                            jj[index] = ("" + ccc).charAt(0);
                        } else {
                            jj[index] = ("" + cccp1).charAt(0);
                        }
                    }
                } else {
                    int ccc = Integer.parseInt(String.valueOf(cc[index]));
                    int jjj = Integer.parseInt(String.valueOf(jj[index]));

                    if (ccc > jjj) {
                        fill(cc, '0');
                        fill(jj, '9');
                        break;
                    } else if (ccc < jjj) {
                        fill(cc, '9');
                        fill(jj, '0');
                        break;
                    }
                }
            }

            index++;
        }

        return string(cc) + " " + string(jj);
    }

    private static long value(final char[] chars) {
        long value = 0;
        int length = chars.length;

        for (int i = 0; i < length; i++) {
            if (chars[i] != '?') {
                value += Integer.parseInt(String.valueOf(chars[i])) * Math.pow(10, length - i - 1);
            }
        }

        return value;
    }

    private static void fill(final char[] chars, final char character) {
        int length = chars.length;

        for (int i = 0; i < length; i++) {
            if (chars[i] == '?') {
                chars[i] = character;
            }
        }
    }

    private static String string(final char[] chars) {
        String value = "";
        int length = chars.length;

        for (int i = 0; i < length; i++) {
            value += String.valueOf(chars[i]);
        }

        return value;
    }
}
