package b;

import java.io.*;

public class Solution {
//    private static final String FILENAME = "test";
//    private static final String FILENAME = "B-small-attempt0";
    private static final String FILENAME = "B-large";

    public static void main(String[] args) throws IOException {
        final long start = System.nanoTime();

        // READ INPUT FILE
        final FileReader fileReader = new FileReader("input/b/" + FILENAME + ".in");
        final BufferedReader bufferedReader = new BufferedReader(fileReader);

        String line = bufferedReader.readLine();
        final Integer numberOfCases = Integer.parseInt(line);
        final String[] cases = new String[numberOfCases];

        for (int i = 0; i < numberOfCases; i ++) {
            line = bufferedReader.readLine();
            cases[i] = line;
        }

        bufferedReader.close();


        // WRITE OUTPUT FILE
        final FileWriter fileWriter = new FileWriter("output/b/" + FILENAME + ".out");
        final BufferedWriter bufferedWriter = new BufferedWriter(fileWriter);

        for (int i = 0; i < cases.length; i ++) {
            final String stack = cases[i];
            bufferedWriter.write("Case #" + (i + 1) + ": " + solveCase(stack) + System.lineSeparator());
        }

        bufferedWriter.close();

        final long end = System.nanoTime();

        System.out.println("Total time: " + (end - start) / 1000000.0);
    }

    private static int solveCase(final String stack) {
        final char[] characters = stack.toCharArray();
        char lastCharacter = characters[characters.length - 1];
        int totalGroups = (lastCharacter == '-' ? 1 : 0);

        for (int i = characters.length - 2; i >= 0 ; i --) {
            if (lastCharacter != characters[i]) {
                totalGroups ++;
                lastCharacter = characters[i];
            }
        }

        return totalGroups;
    }
}
