package a;

import java.io.*;
import java.util.ArrayList;
import java.util.List;

public class Solution {
//    private static final String FILENAME = "test";
    private static final String FILENAME = "A-small-attempt0";
//    private static final String FILENAME = "large";


    public static void main(String[] args) throws IOException {
        final long start = System.nanoTime();

        // READ INPUT FILE
        final FileReader fileReader = new FileReader("input/a/" + FILENAME + ".in");
        final BufferedReader bufferedReader = new BufferedReader(fileReader);

        String line = bufferedReader.readLine();
        final Integer numberOfCases = Integer.parseInt(line);
        final int[] cases = new int[numberOfCases];

        for (int i = 0; i < numberOfCases; i ++) {
            line = bufferedReader.readLine();
            final int number = Integer.parseInt(line);
            cases[i] = number;
        }

        bufferedReader.close();


        // WRITE OUTPUT FILE
        final FileWriter fileWriter = new FileWriter("output/a/" + FILENAME + ".out");
        final BufferedWriter bufferedWriter = new BufferedWriter(fileWriter);

        for (int i = 0; i < cases.length; i ++) {
            final Integer number = cases[i];
            bufferedWriter.write("Case #" + (i + 1) + ": " + (isInsomnia(number) ? "INSOMNIA" : solveCase(number)) + System.lineSeparator());
        }

        bufferedWriter.close();

        final long end = System.nanoTime();

        System.out.println("Total time: " + (end - start) / 1000000.0);
    }

    private static boolean isInsomnia(final int number) {
        return (number == 0);
    }

    private static Integer solveCase(final int number) {
        final List<String> pendingDigits = new ArrayList<>(10);
        for (int i = 0; i <= 9; i ++) {
            pendingDigits.add(Integer.toString(i));
        }

        int currentNumber = 0;

        do {
            currentNumber += number;
            updatePendingDigits(pendingDigits, currentNumber);
        } while (!pendingDigits.isEmpty());

        return currentNumber;
    }

    private static void updatePendingDigits(final List<String> pendingDigits, final int number) {
        final String string = Integer.toString(number);
        final List<String> foundDigits = new ArrayList<>(pendingDigits.size());

        for (final String digit : pendingDigits) {
            if (string.indexOf(digit) >= 0) {
                foundDigits.add(digit);
            }
        }

        pendingDigits.removeAll(foundDigits);
    }
}
