package task1;

import java.io.*;

/**
 * Created by Сергій Шнуренко on 08.04.2016.
 */
public class Main {
    private static String inFileName = "A-large.in";
    private static String outFileName = "out.txt";
    private static int N;//number of cases
    private static int cases[];//numbers for every case


    private static void readInput(String fileName){
        BufferedReader reader=null;
        try {
            reader = new BufferedReader(new FileReader(fileName));
            String temp;

            temp = reader.readLine();

            N = Integer.valueOf(temp);
            cases = new int[N];

            for(int i=0;i<N;i++){
                if((temp = reader.readLine())==null){
                    System.out.println("Input is incorrect");
                    return;
                }
                cases[i]=Integer.valueOf(temp);
            }

        } catch(IOException e) {
            e.printStackTrace();
        } finally {
            if(reader != null)
                try {
                    reader.close();
                }catch (IOException e){
                    e.printStackTrace();
                }
        }
    }
    private static void writeOutput(String outString) {
        BufferedWriter writer=null;
        try {
            writer = new BufferedWriter(new FileWriter("out.txt"));
            writer.write(outString);
        } catch (IOException e){e.printStackTrace();}
        finally {
            if(writer != null)
                try {
                    writer.close();
                }catch (IOException e){
                    e.printStackTrace();
                }
        }
    }

    public static void main(String[] args){
        readInput(inFileName);
        String outBuff = "";

        for(int i=0;i<N;i++){
            int result = lastNumberBeforeDreaming(cases[i]);
            outBuff+="Case #"+(i+1)+": ";
            if(result==0){
                outBuff+="INSOMNIA";
            }else{
                outBuff+=result;
            }
            outBuff+="\n";
        }
        writeOutput(outBuff);
    }

    private static int lastNumberBeforeDreaming(int factorN){
        if(factorN==0) return 0;
        boolean flags[] = { false, false, false, false, false,
                            false, false, false, false, false};
        boolean flag;
        int curr = 0;
        int number;
        do{
            curr++;
            number = curr*factorN;
            int temp = number;
            while(temp>0){
                flags[temp%10] = true;
                temp/=10;
            }
            flag=true;
            for(int i=0;i<10;i++){
                flag = flag&flags[i];
            }
        }while(!flag);
        return number;
    }


}


