package task2;

import java.io.*;

/**
 * Created by Сергій Шнуренко on 09.04.2016.
 */
public class Main {


    private static String inFileName = "B-large.in";
    private static String outFileName = "out.txt";
    private static int N;
    private static String cases[];


    private static void readInput(String fileName){
        BufferedReader reader=null;
        try {
            reader = new BufferedReader(new FileReader(fileName));
            String temp;
            temp = reader.readLine();

            N = Integer.valueOf(temp);
            cases = new String[N];

            for(int i=0;i<N;i++){
                if((temp = reader.readLine())==null){
                    System.out.println("Input is incorrect");
                    return;
                }
                cases[i]=temp;
            }

        } catch(IOException e) {
            e.printStackTrace();
        } finally {
            if(reader != null)
                try {
                    reader.close();
                }catch (IOException e){
                    e.printStackTrace();
                }
        }
    }
    private static void writeOutput(String outString) {
        BufferedWriter writer=null;
        try {
            writer = new BufferedWriter(new FileWriter("out.txt"));
            writer.write(outString);
        } catch (IOException e){e.printStackTrace();}
        finally {
            if(writer != null)
                try {
                    writer.close();
                }catch (IOException e){
                    e.printStackTrace();
                }
        }
    }

    public static void main(String[] args){
        readInput(inFileName);
        String outBuff = "";
        for(int i=0;i<N;i++) {
            int turns = getTurns(cases[i]);
            outBuff+="Case #"+(i+1)+": "+turns+"\n";
        }
        writeOutput(outBuff);
    }


    /**
     *
     * @param pancakesString identifies state of cakes in the stack(+-+++.. String)
     * @return
     */
    private static int getTurns(String pancakesString){
        //calculating n-number of junctions of different states cakes
        //if stack is ending with "-" state cakes then number of turns
        //we need to do t = n+1 otherwise if "+" t=n

        char pancakes[] = pancakesString.toCharArray();
        int n=0;//number of junctions
        char prev = pancakes[0];

        //loop calculating number of junctions
        for (int i=1; i<pancakes.length; i++) {
            n += pancakes[i]!=prev ? 1 : 0;
            prev = pancakes[i];
        }

        if (prev == '-') {
            return n+1;
        } else {
            return n;
        }
    }


}
