package task1;

import java.io.*;
import java.util.Arrays;

/**
 * Created by Сергій Шнуренко on 08.04.2016.
 */
public class Main {
    private static String inFileName = "A-small-attempt0.in";
    private static String outFileName = "A-small.out";
    private static int N;//number of cases
    private static String cases[];// every case


    private static void readInput(String fileName){
        BufferedReader reader=null;
        try {
            reader = new BufferedReader(new FileReader(fileName));
            String temp;

            temp = reader.readLine();

            N = Integer.valueOf(temp);
            cases = new String[N];

            for(int i=0;i<N;i++){
                if((temp = reader.readLine())==null){
                    System.out.println("Input is incorrect");
                    return;
                }
                cases[i]=temp;
            }

        } catch(IOException e) {
            e.printStackTrace();
        } finally {
            if(reader != null)
                try {
                    reader.close();
                }catch (IOException e){
                    e.printStackTrace();
                }
        }
    }
    private static void writeOutput(String outString) {
        BufferedWriter writer=null;
        try {
            writer = new BufferedWriter(new FileWriter(outFileName));
            writer.write(outString);
        } catch (IOException e){e.printStackTrace();}
        finally {
            if(writer != null)
                try {
                    writer.close();
                }catch (IOException e){
                    e.printStackTrace();
                }
        }
    }

    public static void main(String[] args){
        readInput(inFileName);
        String outBuff = "";

        for(int i=0;i<N;i++) {
            outBuff+="Case #"+(i+1)+": "+getDigits(cases[i])+"\n";
        }
        writeOutput(outBuff);
    }

    public static String getDigits(String input){
        String result ="";
        while(input.contains("Z")){
            input= input.replaceFirst("Z","");
            input= input.replaceFirst("E","");
            input= input.replaceFirst("R","");
            input= input.replaceFirst("O","");
            result+="0";
        }
        while(input.contains("W")){
            input= input.replaceFirst("T","");
            input= input.replaceFirst("W","");
            input= input.replaceFirst("O","");
            result+="2";
        }
        while(input.contains("U")){
            input= input.replaceFirst("F","");
            input= input.replaceFirst("O","");
            input= input.replaceFirst("U","");
            input= input.replaceFirst("R","");
            result+="4";
        }
        while(input.contains("X")){
            input= input.replaceFirst("S","");
            input= input.replaceFirst("I","");
            input= input.replaceFirst("X","");
            result+="6";
        }
        while(input.contains("G")){
            input= input.replaceFirst("E","");
            input= input.replaceFirst("I","");
            input= input.replaceFirst("G","");
            input= input.replaceFirst("H","");
            input= input.replaceFirst("T","");
            result+="8";
        }
        while(input.contains("O")){
            input= input.replaceFirst("O","");
            input= input.replaceFirst("N","");
            input= input.replaceFirst("E","");
            result+="1";
        }
        while(input.contains("T")){
            input= input.replaceFirst("T","");
            input= input.replaceFirst("H","");
            input= input.replaceFirst("R","");
            input= input.replaceFirst("E","");
            input= input.replaceFirst("E","");
            result+="3";
        }
        while(input.contains("F")){
            input= input.replaceFirst("F","");
            input= input.replaceFirst("I","");
            input= input.replaceFirst("V","");
            input= input.replaceFirst("E","");
            result+="5";
        }
        while(input.contains("S")){
            input= input.replaceFirst("S","");
            input= input.replaceFirst("E","");
            input= input.replaceFirst("V","");
            input= input.replaceFirst("E","");
            input= input.replaceFirst("N","");
            result+="7";
        }
        while(input.contains("N")){
            input= input.replaceFirst("N","");
            input= input.replaceFirst("I","");
            input= input.replaceFirst("N","");
            input= input.replaceFirst("E","");
            result+="9";
        }


        return sortString(result);
    }

    public static String sortString(String input){
        char charArray[] = input.toCharArray();
        Arrays.sort(charArray);
        return new String(charArray);
    }


}


