package codejam.classificationround;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.TreeMap;

public class Magicka {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		BufferedReader input = new BufferedReader(new InputStreamReader(new FileInputStream("B-large.in")));
		BufferedWriter output = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("output")));
		long num_cases = Long.parseLong(input.readLine());
		int current_case = 0;
		ArrayList<Character> result = new ArrayList<Character>();
		TreeMap<Character,TreeMap<Character,Character>> combinations = new TreeMap<Character,TreeMap<Character,Character>>();
		TreeMap<Character,ArrayList<Character>> oposed = new TreeMap<Character, ArrayList<Character>>();
		
		while (current_case < num_cases){
			current_case++;
			result.clear();
			combinations.clear();
			oposed.clear();
			String[] elements = input.readLine().split(" ");
			// parsing
			int pos = 0;
			int c = Integer.parseInt(elements[pos++]);
			while (c-- > 0){
				String cc = elements[pos++];
				addCombinationCharacter(combinations,cc.charAt(0),cc.charAt(1),cc.charAt(2));
				addCombinationCharacter(combinations,cc.charAt(1),cc.charAt(0),cc.charAt(2));
			}
			int d = Integer.parseInt(elements[pos++]);
			while (d-- > 0){
				String dd = elements[pos++];
				addOposedCharacter(oposed,dd.charAt(0),dd.charAt(1));
				addOposedCharacter(oposed,dd.charAt(1),dd.charAt(0));
			}
			int n = Integer.parseInt(elements[pos++]);
			String invocation = elements[pos++];
			
			for (int i = 0; i < invocation.length(); i++){
				char ch = invocation.charAt(i);
				add(result,ch,combinations,oposed);
			}
			
			output.write("Case #" + current_case + ": [");
			for (int i = 0; i < result.size(); i++){
				output.write(result.get(i));
				if (i < (result.size()-1))
					output.write(", ");
			}
			output.write("]\n");
		}
		output.close();
	}

	private static void add(ArrayList<Character> result, char ch,
			TreeMap<Character, TreeMap<Character, Character>> combinations,
			TreeMap<Character, ArrayList<Character>> oposed) {
		if (result.isEmpty()){
			result.add(ch);
			return;
		}
		// combinations
		char lastChar = result.get(result.size()-1);
		if (combinations.containsKey(ch) && 
			combinations.get(ch).containsKey(lastChar)){
			result.remove(result.size()-1);
			add(result,combinations.get(ch).get(lastChar),combinations,oposed);
			return;
		};
		// oposed
		if (oposed.containsKey(ch)){
			ArrayList<Character> listOposed = oposed.get(ch);
			if (!Collections.disjoint(listOposed, result)){
				result.clear();
				return;
			}
		}
		result.add(ch);
	}

	private static void addOposedCharacter(
			TreeMap<Character, ArrayList<Character>> characters,
			char a, char b) {
		ArrayList<Character> cc = characters.get(a);
		if (cc == null){
			cc = new ArrayList<Character>();
			characters.put(a, cc);
		}
		cc.add(b);
	}
	
	private static void addCombinationCharacter(
			TreeMap<Character, TreeMap<Character, Character>> characters,
			char a, char b, char c) {
		TreeMap<Character, Character> cc = characters.get(a);
		if (cc == null){
			cc = new TreeMap<Character, Character>();
			characters.put(a, cc);
		}
		cc.put(b, c);
	}

}
