package codejam.classificationround;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Vector;

public class BotTrust {

	public static class Bot {
		
		public Bot(String s){
			color = s;
		}
		
		public String toString(){
			return "Bot "+ color+"["+pos+"]";
		}
		
		String color;
		int pos = 1;

		public boolean execute(Vector<Step> steps) {
			Step s = steps.firstElement();
			if (s.color.equals(color)){
				if (s.num == pos){
					return true;
				} else if (s.num > pos){
					pos++;
				} else {
					pos--;
				}
			}else{
				Step next = getNextColor(steps);
				if (next == null) return false;
				if (next.num > pos){
					pos++;
				} else if (next.num < pos){
					pos --;
				}
			}
			return false;
		}

		private Step getNextColor(Vector<Step> steps) {
			for (Step s : steps)
				if (s.color.equals(color))
					return s;
			return null;
		}

	}

	public static class Step {
		public Step(String c, String n) {
			color = c;
			num = Integer.parseInt(n);
		}
		
		public String color;
		public int num;
		
		public String toString(){
			return color+"["+num+"]";
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		BufferedReader input = new BufferedReader(new InputStreamReader(new FileInputStream("A-large.in")));
		BufferedWriter output = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("output")));
		Bot orange = new Bot("O");
		Bot blue = new Bot("B");
		long num_cases = Long.parseLong(input.readLine());
		int current_case = 0;
		while (current_case < num_cases){
			current_case++;
			Vector<Step> steps= new Vector<Step>();
			
			String[] elements = input.readLine().split(" ");
			int numSteps = Integer.parseInt(elements[0]);
			for (int i = 0; i < numSteps; i++){
				steps.add(new Step(elements[i*2+1],elements[i*2+2]));
			}
			
			int seconds = 0;
			while(!steps.isEmpty()){
				seconds++;
				boolean o = orange.execute(steps);
				boolean b = blue.execute(steps);
				if (o || b)
					steps.remove(0);
			}
			
			output.write("Case #" + current_case + ": " + seconds + "\n");
			blue.pos = 1;
			orange.pos = 1;
		}
		output.close();
	}

}
