package codejam.classificationround;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.TreeMap;

public class CandySplitting {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		BufferedReader input = new BufferedReader(new InputStreamReader(new FileInputStream("C-small-attempt3.in")));
		BufferedWriter output = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("output")));
		long num_cases = Long.parseLong(input.readLine());
		
		int current_case = 0;
		
		while (current_case < num_cases){
			current_case++;
			System.out.print(current_case + "/" + num_cases);
			
			int numCandies = Integer.parseInt(input.readLine());
			int[] candies = new int[numCandies];
			int currentCandie = 0;
			for (String s : input.readLine().split(" "))
				candies[currentCandie++] = Integer.parseInt(s);
				
			System.out.println(" - " + numCandies);
			
			boolean[] p = new boolean[numCandies];
			
			
			boolean [] best = null;
			long numBest = 0;
			
			for(initialize(p); !end(p); increment(p)){
				long stotal = 0, ptotal = 0, sxor = 0, pxor = 0;
				for (int i = 0; i < p.length; i++){
					if (p[i]){
						ptotal += candies[i];
						pxor ^= candies[i];
					} else {
						stotal += candies[i];
						sxor ^= candies[i];
					}
				}
				if (ptotal > stotal) continue;
				if (ptotal == 0) continue;
				if (sxor == pxor){
					if (numBest < stotal){
						numBest = stotal;
						best = Arrays.copyOf(p, p.length);
					}
				}
			}

			output.write("Case #" + current_case + ": ");
			if (best == null)
				output.write("NO\n");
			else
				output.write(numBest+"\n");
		}
		output.close();
	}

	private static void increment(boolean[] p) {
		for (int i = 0; i < p.length; i++){
			p[i] = !p[i];
			if (p[i]) break;
		}
	}

	private static void initialize(boolean[] p) {
		Arrays.fill(p, false);
	}

	private static boolean end(boolean[] p) {
		for (boolean b : p)
			if (!b)
				return false;
		return true;
	}

	private static ArrayList<Integer> permute(ArrayList<Integer> p,
			ArrayList<Integer> s) {
		if (getValue(p) > getValue(s)) return null;
		if (!p.isEmpty() && (getXor(p) == getXor(s))) return s;

		ArrayList<Integer> b = null;
		long bestValue = 0;
		for (Integer i : s){
			ArrayList<Integer> p2 = new ArrayList<Integer>(p);
			p2.add(i);
			ArrayList<Integer> s2 =  new ArrayList<Integer>(s);
			s2.remove(i);
			
			ArrayList<Integer> n = permute(p2,s2);
			if (n == null) continue;
			long nValue = getValue(n);
			if (b == null || bestValue < nValue){
				bestValue = nValue;
				b = n;
			}
		}
		
		return b;
	}

	private static long getXor(ArrayList<Integer> p) {
		long total = 0;
		for (int i : p)
			total ^= i;
		return total;
	}

	private static long getValue(ArrayList<Integer> sean) {
		long total = 0;
		for (int i : sean)
			total += i;
		return total;
	}

	private static void add(ArrayList<Character> result, char ch,
			TreeMap<Character, TreeMap<Character, Character>> combinations,
			TreeMap<Character, ArrayList<Character>> oposed) {
		if (result.isEmpty()){
			result.add(ch);
			return;
		}
		// combinations
		char lastChar = result.get(result.size()-1);
		if (combinations.containsKey(ch) && 
			combinations.get(ch).containsKey(lastChar)){
			result.remove(result.size()-1);
			add(result,combinations.get(ch).get(lastChar),combinations,oposed);
			return;
		};
		// oposed
		if (oposed.containsKey(ch)){
			ArrayList<Character> listOposed = oposed.get(ch);
			if (!Collections.disjoint(listOposed, result)){
				result.clear();
				return;
			}
		}
		result.add(ch);
	}

	private static void addOposedCharacter(
			TreeMap<Character, ArrayList<Character>> characters,
			char a, char b) {
		ArrayList<Character> cc = characters.get(a);
		if (cc == null){
			cc = new ArrayList<Character>();
			characters.put(a, cc);
		}
		cc.add(b);
	}
	
	private static void addCombinationCharacter(
			TreeMap<Character, TreeMap<Character, Character>> characters,
			char a, char b, char c) {
		TreeMap<Character, Character> cc = characters.get(a);
		if (cc == null){
			cc = new TreeMap<Character, Character>();
			characters.put(a, cc);
		}
		cc.put(b, c);
	}

}
