package jam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.HashMap;

public class Tongues {
	public static void main(String[] args) throws Exception{
		String inputFile = "A-small-attempt1.in";
		
		HashMap<Character,Character> dict = loadSamples();
	
		BufferedReader input = new BufferedReader(new InputStreamReader(new FileInputStream(inputFile)));
		BufferedWriter output = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("output")));
		long num_cases = Long.parseLong(input.readLine());
		int current_case = 0;
		
		while (current_case < num_cases){
			current_case++;
			
			String line = input.readLine();
			System.out.println("***");
			System.out.println(line);
			String changed = "";
			for (int i = 0; i < line.length(); i++){
				if (!dict.containsKey(line.charAt(i))){
					System.out.println("char not found: "+ line.charAt(i));
				}
				changed += dict.get(line.charAt(i));
			}
			System.out.println(changed);
			output.write("Case #" + current_case + ": " + changed + "\n");
		}
		output.close();
	}

	private static HashMap<Character, Character> loadSamples() {
		HashMap<Character, Character> dict = new HashMap<Character, Character>();
		dict.put('y', 'a');
		dict.put('e', 'o');
		dict.put('q', 'z');
		
		String[][] samples = {
			new String[] {"ejp mysljylc kd kxveddknmc re jsicpdrysi","our language is impossible to understand"},
			new String[] {"rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd","there are twenty six factorial possibilities"},
			new String[] {"de kr kd eoya kw aej tysr re ujdr lkgc jv","so it is okay if you want to just give up"}
		};
		
		for (String[] s : samples){
			for (int i = 0; i < s[0].length(); i++){
				char c1 = s[0].charAt(i);
				char c2 = s[1].charAt(i);
				if (!dict.containsKey(c1))
					dict.put(c1, c2);
			}
		}
		
		char missingkey=' ';
		char missingObj=' ';
		
		for (char i = 'a'; i <= 'z'; i++){
			if (!dict.containsKey(i)){
				missingkey = i;
				break;
			}
		}
		for (char i = 'a'; i <= 'z'; i++){
			if (!dict.containsValue(i)){
				missingObj = i;
				break;
			}
		}
		dict.put(missingkey, missingObj);
		
		return dict;
	}
}
