package codejam.round1C;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Arrays;

public class E2 {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		String inputFile = "1c/B-small-attempt0.in";
		BufferedReader input = new BufferedReader(new InputStreamReader(new FileInputStream(inputFile)));
		BufferedWriter output = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("output")));

		long num_cases = Long.parseLong(input.readLine());
		int current_case = 0;
		while (current_case < num_cases){
			current_case++;
			
			String[] data = input.readLine().split(" ");
			int L = Integer.parseInt(data[0]);
			long t = Long.parseLong(data[1]);
			int N = Integer.parseInt(data[2]);
			int C = Integer.parseInt(data[3]);
			
			long[] distances = new long[N];
			boolean[] booster = new boolean[N];
			Arrays.fill(booster, false);
			for (int i = 0 ; i < N; i++){
				distances[i] = Long.parseLong(data[(i%C) + 4]);
			}
			while (numBoosters(booster) < L){
				int pos = getBooster(distances,booster,t);
				if (pos == -1)
					break;
				booster[pos] = true;
			}
			long besttime = getTimeFor(distances,booster,N,t);
			
			output.write("Case #" + current_case + ": " + besttime + "\n");
		}
		output.close();
	}

	private static int numBoosters(boolean[] booster) {
		int t = 0;
		for (boolean b : booster)
			if (b) t++;
		return t;
	}

	private static long getTimeFor(long[] distances, boolean[] booster, int N, long t) {
		long time = 0;
		for (int i = 0; i < N; i++){
			if (booster[i]){
				long d = Math.min(distances[i], t/2);
				long not = Math.max(d-time, 0);
				time += not*2;
				time += (distances[i] - not);
			} else
				time += distances[i]*2;
		}
		return time;
	}

	private static int getBooster(long[] distances, boolean[] booster, long t) {
		int pos = -1;
		long increment = -t;
		for (int i = 0; i < distances.length; i++){
			if (booster[i]) continue;
			long t1 = getTimeFor(distances,booster,distances.length,t);
			booster[i] = true;
			long t2 = getTimeFor(distances,booster,distances.length,t);
			booster[i] = false;
			if ((t1 - t2) > increment){
				pos = i;
				increment = t1 - t2;
			}
		}
		return pos;
	}

}