import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.InputMismatchException;

public class RatherPerplexingShowdown {
	private static final String DEFAULT_STR = "hehe xd";
	
	public static void main(String[] args) {
		FileScanner sc = new FileScanner("io/input.txt");
		StringBuilder sb = new StringBuilder();
		
		String[] RA = new String[13];
		String[] PA = new String[13];
		String[] SA = new String[13];
		RA[0] = "R";
		PA[0] = "P";
		SA[0] = "S";
		for (int i = 1; i < RA.length; i++) {
			RA[i] = combine(RA[i - 1], SA[i - 1]);
			PA[i] = combine(PA[i - 1], RA[i - 1]);
			SA[i] = combine(SA[i - 1], PA[i - 1]);
		}
		
		int T = sc.nextInt();
		for (int t = 1; t <= T; t++) {
			int N = sc.nextInt();
			int R = sc.nextInt();
			int P = sc.nextInt();
			int S = sc.nextInt();
			String ans = DEFAULT_STR;
			if (matchRPS(RA[N], R, P, S)) {
				ans = minStr(ans, RA[N]);
			}
			if (matchRPS(PA[N], R, P, S)) {
				ans = minStr(ans, PA[N]);
			}
			if (matchRPS(SA[N], R, P, S)) {
				ans = minStr(ans, SA[N]);
			}
			sb.append(String.format("Case #%d: %s\n", t, ans.equals(DEFAULT_STR) ? "IMPOSSIBLE" : ans));
		}
		
		try (PrintWriter pw = new PrintWriter("io/output.txt")) {
			pw.append(sb.toString());
		} catch (FileNotFoundException e) {
			System.out.println("Error with output file!");
		}
	}
	
	private static String combine(String s1, String s2) {
		if (s1.compareTo(s2) < 0) {
			return s1 + s2;
		} else {
			return s2 + s1;
		}
	}
	
	private static String minStr(String s1, String s2) {
		if (s1.compareTo(s2) < 0) {
			return s1;
		} else {
			return s2;
		}
	}
	
	private static boolean matchRPS(String str, int R, int P, int S) {
		for (int i = 0; i < str.length(); i++) {
			switch (str.charAt(i)) {
			case 'R':
				R--;
				break;
			case 'P':
				P--;
				break;
			case 'S':
				S--;
				break;
			}
		}
		return R == 0 && P == 0 && S == 0;
	}

	public static class FileScanner {
		private byte[] buf = new byte[1024];
		private int curChar;
		private int numChars;
		private InputStream stream;
		
		public FileScanner(String file) {
			try {
				stream = new FileInputStream(file);
			} catch (FileNotFoundException e) {
				System.out.println("Error with input file!");
			}
		}
		
		public int read() {
			if (numChars == -1)
				throw new InputMismatchException();
			if (curChar >= numChars) {
				curChar = 0;
				try {
					numChars = stream.read(buf);
				} catch (IOException e) {
					throw new InputMismatchException();
				}
				if (numChars <= 0)
					return -1;
			}
			return buf[curChar++];
		}

		public String nextLine() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			StringBuilder res = new StringBuilder();
			do {
				res.appendCodePoint(c);
				c = read();
			} while (!isEndOfLine(c));
			return res.toString();
		}

		public String nextString() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			StringBuilder res = new StringBuilder();
			do {
				res.appendCodePoint(c);
				c = read();
			} while (!isSpaceChar(c));
			return res.toString();
		}

		public long nextLong() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			int sgn = 1;
			if (c == '-') {
				sgn = -1;
				c = read();
			}
			long res = 0;
			do {
				if (c < '0' || c > '9')
					throw new InputMismatchException();
				res *= 10;
				res += c - '0';
				c = read();
			} while (!isSpaceChar(c));
			return res * sgn;
		}

		public int nextInt() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			int sgn = 1;
			if (c == '-') {
				sgn = -1;
				c = read();
			}
			int res = 0;
			do {
				if (c < '0' || c > '9')
					throw new InputMismatchException();
				res *= 10;
				res += c - '0';
				c = read();
			} while (!isSpaceChar(c));
			return res * sgn;
		}

		public int[] nextIntArray(int n) {
			return nextIntArray(n, 0);
		}

		public int[] nextIntArray(int n, int off) {
			int[] arr = new int[n + off];
			for (int i = 0; i < n; i++) {
				arr[i + off] = nextInt();
			}
			return arr;
		}

		public long[] nextLongArray(int n) {
			return nextLongArray(n, 0);
		}

		public long[] nextLongArray(int n, int off) {
			long[] arr = new long[n + off];
			for (int i = 0; i < n; i++) {
				arr[i + off] = nextLong();
			}
			return arr;
		}

		private boolean isSpaceChar(int c) {
			return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
		}

		private boolean isEndOfLine(int c) {
			return c == '\n' || c == '\r' || c == -1;
		}
	}
}