import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.InputMismatchException;

public class RankAndFile {
	public static void main(String[] args) {
		FileScanner sc = new FileScanner("io/input.txt");
		StringBuilder sb = new StringBuilder();

		int T = sc.nextInt();
		for (int t = 1; t <= T; t++) {
			int N = sc.nextInt();
			int[][] lsts = new int[2 * N - 1][];
			for (int i = 0; i < 2 * N - 1; i++) {
				lsts[i] = sc.nextIntArray(N);
			}
			int[][] M = new int[N][N];
			boolean[] used = new boolean[2 * N - 1];
			for (int p = 0; p < N; p++) {
				int min = Integer.MAX_VALUE;
				for (int i = 0; i < 2 * N - 1; i++) {
					if (!used[i]) {
						min = Math.min(min, lsts[i][p]);
					}
				}
				int[] idxs = new int[2];
				int pos = 0;
				for (int i = 0; i < 2 * N - 1; i++) {
					if (!used[i] && lsts[i][p] == min) {
						idxs[pos++] = i;
					}
				}
				if (pos == 2) {
					if (rowFit(M, lsts[idxs[0]], p)) {
						copyRow(M, lsts[idxs[0]], p);
						copyCol(M, lsts[idxs[1]], p);
					} else {
						copyRow(M, lsts[idxs[1]], p);
						copyCol(M, lsts[idxs[0]], p);
					}
				}
				for (int i = 0; i < pos; i++) {
					used[idxs[i]] = true;
				}
			}
			int[] ans = new int[N];
			for (int i = 0; i < N; i++) {
				for (int j = 0; j < N; j++) {
					ans[i] ^= M[i][j];
					ans[j] ^= M[i][j];
				}
			}
			for (int[] arr : lsts) {
				for (int i = 0; i < N; i++) {
					ans[i] ^= arr[i];
				}
			}
			StringBuilder ord = new StringBuilder();
			for (int v : ans) {
				ord.append(v + " ");
			}
			sb.append(String.format("Case #%d: %s\n", t, ord.toString()));
		}
		
		try (PrintWriter pw = new PrintWriter("io/output.txt")) {
			pw.append(sb.toString());
		} catch (FileNotFoundException e) {
			System.out.println("Error with output file!");
		}
	}
	
	public static boolean rowFit(int[][] M, int[] A, int r) {
		for (int c = 0; c < A.length; c++) {
			if (M[r][c] > 0 && M[r][c] != A[c]) {
				return false;
			}
		}
		return true;
	}
	
	public static void copyRow(int[][] M, int[] A, int r) {
		System.arraycopy(A, 0, M[r], 0, A.length);
	}
	
	public static void copyCol(int[][] M, int[] A, int c) {
		for (int r = 0; r < A.length; r++) {
			M[r][c] = A[r];
		}
	}
	
	public static class FileScanner {
		private byte[] buf = new byte[1024];
		private int curChar;
		private int numChars;
		private InputStream stream;
		
		public FileScanner(String file) {
			try {
				stream = new FileInputStream(file);
			} catch (FileNotFoundException e) {
				System.out.println("Error with input file!");
			}
		}
		
		public int read() {
			if (numChars == -1)
				throw new InputMismatchException();
			if (curChar >= numChars) {
				curChar = 0;
				try {
					numChars = stream.read(buf);
				} catch (IOException e) {
					throw new InputMismatchException();
				}
				if (numChars <= 0)
					return -1;
			}
			return buf[curChar++];
		}

		public String nextLine() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			StringBuilder res = new StringBuilder();
			do {
				res.appendCodePoint(c);
				c = read();
			} while (!isEndOfLine(c));
			return res.toString();
		}

		public String nextString() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			StringBuilder res = new StringBuilder();
			do {
				res.appendCodePoint(c);
				c = read();
			} while (!isSpaceChar(c));
			return res.toString();
		}

		public long nextLong() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			int sgn = 1;
			if (c == '-') {
				sgn = -1;
				c = read();
			}
			long res = 0;
			do {
				if (c < '0' || c > '9')
					throw new InputMismatchException();
				res *= 10;
				res += c - '0';
				c = read();
			} while (!isSpaceChar(c));
			return res * sgn;
		}

		public int nextInt() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			int sgn = 1;
			if (c == '-') {
				sgn = -1;
				c = read();
			}
			int res = 0;
			do {
				if (c < '0' || c > '9')
					throw new InputMismatchException();
				res *= 10;
				res += c - '0';
				c = read();
			} while (!isSpaceChar(c));
			return res * sgn;
		}

		public int[] nextIntArray(int n) {
			return nextIntArray(n, 0);
		}

		public int[] nextIntArray(int n, int off) {
			int[] arr = new int[n + off];
			for (int i = 0; i < n; i++) {
				arr[i + off] = nextInt();
			}
			return arr;
		}

		public long[] nextLongArray(int n) {
			return nextLongArray(n, 0);
		}

		public long[] nextLongArray(int n, int off) {
			long[] arr = new long[n + off];
			for (int i = 0; i < n; i++) {
				arr[i + off] = nextLong();
			}
			return arr;
		}

		private boolean isSpaceChar(int c) {
			return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
		}

		private boolean isEndOfLine(int c) {
			return c == '\n' || c == '\r' || c == -1;
		}
	}
}