import java.util.Scanner;
import java.util.ArrayList;

public class Main { 
	public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int tests = sc.nextInt();
        for (int t = 1; t <= tests; t++) {
            int min, max;
            int n = sc.nextInt();
            int k = sc.nextInt();
            Stall[] s = new Stall[n+2];
            int[] occupied = new int[n+2];
            for(int i = 0; i<n+2; i++) s[i] = new Stall();
            place(s, 0);
            place(s, n+1);
            
            for(int i = 0; i < k-1 ; i++) {
                place(s, findBest(s));
            }
            int i = findBest(s);
            min = Math.min(s[i].leftDist, s[i].rightDist);
            max = Math.max(s[i].leftDist, s[i].rightDist);
            System.out.printf("Case #%d: %d %d\n", t, max, min);
        } 
	}
    
    public static void place(Stall[] s, int pos) {
        s[pos].occupied = true;
        for(int i = 0; i < pos; i++) {
            if(s[i].rightDist > pos - i - 1) s[i].rightDist = pos - i - 1;
        }
        for(int i = pos + 1; i < s.length; i++) {
            if(s[i].leftDist > i - pos - 1) s[i].leftDist = i - pos - 1;
        }
        //System.out.println("Placed in pos "+pos);
    }
    
    public static int findBest(Stall[] s) {
        int l = -1, r = -1, pos = -1;
        for(int i = 0; i < s.length; i++) {
            if(s[i].occupied) continue;
            if(Math.min(s[i].leftDist, s[i].rightDist) > Math.min(l, r)) {
                pos = i;
                l = s[i].leftDist;
                r = s[i].rightDist;
            } else if(Math.min(s[i].leftDist, s[i].rightDist) == Math.min(l, r)) {
                if(Math.max(s[i].leftDist, s[i].rightDist) > Math.max(l, r)) {
                    pos = i;
                    l = s[i].leftDist;
                    r = s[i].rightDist;
                }
            }
        }
        return pos;
    }
} 

class Stall {
    public int leftDist, rightDist;
    public boolean occupied;
    
    public Stall() {
        leftDist = Integer.MAX_VALUE;
        rightDist = Integer.MAX_VALUE;
        occupied = false;
    }
}