import java.util.ArrayList;
import java.math.BigInteger;
public class Main{	
	public static void main(String[] args){
		int N = 32, J = 500;
		long bound = 1;
		for(int i=1; i<8; i++) bound*=10;
		System.out.println(bound);
		ArrayList<Long> p = generatePrimes(bound);
		int max = 1<<(N-2);
		System.out.print("Case #1:");
		int count = 0;
		for(int i=0; i<max; i++){
			if(count>=J) break;
			String s = "1"+padLeft(Integer.toBinaryString(i), N-2)+"1";
			long[] divs = isNotPrime(s,p);
			
			if(divs[0]!=0){ 
				System.out.print("\n"+s); 
				for(long d:divs) System.out.print(" "+d); 
				count++;
			}	
		}
		
	}
	
	public static String padLeft(String s, int len){
		StringBuilder sb = new StringBuilder();
		while(len-s.length()>sb.length()) sb.append(0);
		sb.append(s);
		return sb.toString();
	}
	
	public static long[] isNotPrime(String s, ArrayList<Long> p){
		long[] divs = new long[9];
		char[] c  = s.toCharArray();
		long[] iA = new long[c.length];
		for(int i=0;i<c.length;i++) iA[i] = c[i]-48;
		for(int i=2; i<11; i++){
			BigInteger val = new BigInteger("0");
			BigInteger exp = new BigInteger("1");
			for(int j=iA.length-1;j>=0;j--){
				val = val.add(exp.multiply(new BigInteger(iA[j]+"")));
				exp = exp.multiply(new BigInteger(i+""));
			}
			//if(val<0) System.out.println("I bRoke ues BIGINts");
			//System.out.println(s+" = "+val+" base "+i);
			if(val.isProbablePrime(5)){
				divs[0] = 0; 
				return divs;
			}else{
				boolean changed = false;
				for(Long k:p){
					long j = k.longValue();
					if(val.remainder(new BigInteger(""+j)).intValue()==0){divs[i-2] = j; changed = true; break;}
				}	
				if(!changed){
					divs[0] = 0; 
					return divs;
				}
			}
		}
		return divs;
	}
	
	public static ArrayList<Long> generatePrimes(long n){
		ArrayList<Long> primes = new ArrayList<Long>();
		primes.add(2L);
		primes.add(3L);
		for(long i=1; 6*i+1<n;i++){
			if(isPrime(6*i-1, primes)==0) primes.add(6*i-1);
			if(isPrime(6*i+1, primes)==0) primes.add(6*i+1);
			//if((6*i)%60000==0) System.out.println(6*i+1);
		}
		return primes;
	}
	
	public static long isPrime(long n, ArrayList<Long> p){
		
		for(Long i:p){
			long j = i.longValue();
			if(j*j>n) break;
			if(n%j==0)return j;
		}
		return 0;
	}
}
