import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;


public class gc_2017_1b_a {
    final String f = "A-small-attempt0";

    private BufferedReader in;
    private PrintWriter out;
    private StringTokenizer st;

    void solve() throws IOException {
        int D = nextInt();
        int N = nextInt();

        ArrayList<pair> list = new ArrayList<pair>();

        for (int i=0; i<N; i++){
            int loc = nextInt();
            int speed = nextInt();
            pair cur = new pair(loc, speed);
            list.add(cur);
        }

        Collections.sort(list, new Comparator<pair>(){
            public int compare (pair a, pair b){
                return a.loc - b.loc;
            }
        });

        double maxTime = 0.0;

        for (int i=0; i<N; i++){
            pair cur = list.get(i);
            double curTime = (double)(D-cur.loc) / (double)(cur.speed);
            maxTime = Math.max(curTime, maxTime);
        }

        double res = (double)(D)/maxTime;
        out.println(res);
    }

    public void run() throws IOException {
        in = new BufferedReader(new FileReader(f + ".in"));
        out = new PrintWriter(f + ".out");

        eat("");

        int tests = nextInt();
        for (int test = 0; test < tests; ++test) {
            System.out.println("Test #" + (test + 1));
            out.print("Case #" + (test + 1) + ": ");
            solve();
        }

        in.close();
        out.close();
    }

    private void eat(String str) {
        st = new StringTokenizer(str);
    }

    String next() throws IOException {
        while (!st.hasMoreTokens()) {
            String line = in.readLine();
            if (line == null) {
                return null;
            }
            eat(line);
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    public static void main(String[] args) throws IOException {
        new gc_2017_1b_a().run();
    }
}

class pair {
    int loc;
    int speed;
    public pair(int loc, int speed){
        this.loc = loc;
        this.speed = speed;
    }
}
