import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.StringTokenizer;

/**
 * Created by yujiahao on 4/8/17.
 */
public class gc_2017_qualification_c {
    final String f = "C-small-1-attempt0";

    private BufferedReader in;
    private PrintWriter out;
    private StringTokenizer st;

    void solve() throws IOException {
        long n = nextLong();
        long k = nextLong();

        PriorityQueue<pair> queue = new PriorityQueue<pair>(new Comparator<pair>(){
            public int compare (pair a, pair b){
                if (a.len != b.len) return b.len - a.len > 0 ? 1: -1;
                if (a.left != b.left)   return a.left < b.left ? -1: 1;
                return 0;
            }
        });

        pair first = new pair(1L, n+2);
        queue.offer(first);
        long min = 0L;
        long max = 0L;

        for (long i = 0; i<k; i++){
            pair cur = queue.poll();
            long left = cur.left;
            long right = cur.right;
            long len = cur.len;

            long next = 0L;

            if (len%2==0){
                next = left + len/2;
            }else{
                next = left + len/2 + 1;
            }

            if (i==k-1){
                min = Math.min(right-next-1, next-left-1);
                max = Math.max(right-next-1, next-left-1);
            }

            if (i!=k-1){
                pair add1 = new pair(left, next);
                pair add2 = new pair(next, right);
                queue.offer(add1);
                queue.offer(add2);
            }
        }

        StringBuilder sb = new StringBuilder();
        sb.append(max).append(" ").append(min).append("\n");
        out.print(sb.toString());
    }

    public void run() throws IOException {
        in = new BufferedReader(new FileReader(f + ".in"));
        out = new PrintWriter(f + ".out");

        eat("");

        int tests = nextInt();
        for (int test = 0; test < tests; ++test) {
            System.out.println("Test #" + (test + 1));
            out.print("Case #" + (test + 1) + ": ");
            solve();
        }

        in.close();
        out.close();
    }

    private void eat(String str) {
        st = new StringTokenizer(str);
    }

    String next() throws IOException {
        while (!st.hasMoreTokens()) {
            String line = in.readLine();
            if (line == null) {
                return null;
            }
            eat(line);
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    public static void main(String[] args) throws IOException {
        new gc_2017_qualification_c().run();
    }
}

class pair {
    long left;
    long right;
    long len;
    public pair (long left, long right){
        this.left = left;
        this.right = right;
        len = right-left-1;
    }
}
