import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**
 * Created by Ran on 09/04/2016.
 */
public class CoinJam {

    private static long[][] baseMult = new long[11][];
    private static int[] lastDivisors = new int[11];

    private static void initBaseMult() {

        for (int i = 2; i <= 10; i++) {
            baseMult[i] = new long[16];
            baseMult[i][0] = 1;
            for (int j = 1; j < 16; j++)
                baseMult[i][j] = baseMult[i][j-1] * i;
        }
    }

    private static long transToBase(int n, int base) {

        long res = 0;

        for (int i = 0; i < 16; i++) {
            int digit = n % 2;
            n /= 2;
            res += digit * baseMult[base][i];
        }

        return res;
    }

    private static int isPrime(long n) {

        if (n % 2 == 0)
            return 2;

        if (n % 3 == 0)
            return 3;

        long i = 5;
        long w = 2;

        while (i * i <= n) {

            if (n % i == 0)
                return (int)i;

            i += w;
            w = 6 - w;
        }

        return 0;
    }

    private static boolean isJamCoin(int n) {

        boolean prime = false;

        for (int i = 2; i <= 10; i++) {
            long b = transToBase(n, i);
            lastDivisors[i] = isPrime(b);
            if (lastDivisors[i] == 0) {
                prime = true;
                break;
            }
        }

        return !prime;
    }

    public static void main (String[] args) {

        initBaseMult();

        isPrime(1029);
        Scanner s = null;
        try {
            s = new Scanner (new File("C-small-attempt0.in"));
        } catch (FileNotFoundException e) {
            e.printStackTrace ();
        }

        int t = s.nextInt();
        if (t != 1) {
            System.out.println("Error: t must be 1.");
            return;
        }

        System.out.println ("Case #1:");

        int n = s.nextInt();
        int j = s.nextInt();

        if (n == 16) {
            if (j != 50) {
                System.out.println("Error: j must be 50.");
                return;
            }

            int count = 0;

            for (int i = 32769; i < 65535; i += 2) {
                if (isJamCoin(i)) {
                    System.out.print(Integer.toBinaryString(i));
                    for (int b = 2; b <= 10; b++)
                        System.out.print(" " + lastDivisors[b]);
                    System.out.println();
                    count++;
                    if (count >= j)
                        break;
                }
            }
        }
    }
}
