import java.util.Scanner;
import java.util.ArrayList;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.io.FileOutputStream;

/**
 * Created by IntelliJ IDEA.
 * User: Ran
 * Date: May 21, 2011
 */
public class RPI {
   
   public static void main (String[] args) {

      Scanner s = null;
      PrintStream out = null;
//      String fileName = "A-small-test";
//      String fileName = "A-small-attempt0";
      String fileName = "A-large";
      try {
         s = new Scanner (new File (fileName + ".in"));
         out = new PrintStream (new FileOutputStream (fileName + ".out"));
      } catch (FileNotFoundException e) {
         e.printStackTrace ();
      }

      int t = s.nextInt();

      // Traverse all test cases.
      for (int test = 1; test <= t; test++) {

         int n = s.nextInt();

         char games[][] = new char[n][n];

         for (int i = 0; i < n; i++) {
            String line = s.next();
            for (int j = 0; j < n; j++) {
               games[i][j] = line.charAt (j);
            }
         }

         double wp[] = new double[n];
         double owp[] = new double[n];
         double oowp[] = new double[n];

         int won[] = new int[n];
         int lost[] = new int[n];

         for (int i = 0; i < n; i++) {
            won[i] = 0;
            lost[i] = 0;
            for (int j = 0; j < n; j++) {
               if (games[i][j] == '1')
                  won[i]++;
               else if (games[i][j] == '0')
                  lost[i]++;
            }
            wp[i] = (double)won[i] / (won[i] + lost[i]);
         }

         for (int i = 0; i < n; i++) {
            int numOps = 0;
            double sumOps = 0;
            for (int j = 0; j < n; j++) {
               if (games[i][j] != '.') {
                  numOps++;
                  int opWon = won[j];
                  int opLost = lost[j];
                  if (games[i][j] == '1')
                     opLost--;
                  else
                     opWon--;
                  sumOps += (double)opWon / (opWon + opLost);
               }
            }
            owp[i] = sumOps / numOps;
         }
         
         for (int i = 0; i < n; i++) {
            int numOps = 0;
            double sumOps = 0;
            for (int j = 0; j < n; j++) {
               if (games[i][j] != '.') {
                  numOps++;
                  sumOps += owp[j];
               }
            }
            oowp[i] = sumOps / numOps;
         }

         String outStr = "Case #" + test + ":";
         System.out.println (outStr);
         out.println (outStr);

         for (int i = 0; i < n; i++) {
            double res = 0.25 * wp[i] + 0.50 * owp[i] + 0.25 * oowp[i];
            System.out.printf ("%.12f\n", res);
            out.printf ("%.12f\n", res);
         }
      }
   }
}
