import java.util.Scanner;
import java.util.Arrays;
import java.util.ArrayList;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;

/**
 * Created by IntelliJ IDEA.
 * User: Ran
 * Date: Jun 4, 2011
 */
public class Airport {

   public static void main (String[] args) {

      Scanner s = null;
      PrintStream out = null;
//      String fileName = "A-small-test";
//      String fileName = "A-small-attempt2";
      String fileName = "A-large";
      try {
         s = new Scanner (new File (fileName + ".in"));
         out = new PrintStream (new FileOutputStream (fileName + ".out"));
      } catch (FileNotFoundException e) {
         e.printStackTrace ();
      }

      int t = s.nextInt();

      // Traverse all test cases.
      for (int test = 1; test <= t; test++) {

         int len = s.nextInt();
         int walk = s.nextInt();
         int run = s.nextInt();
         int runT = s.nextInt();
         int n = s.nextInt();

         double runTime = runT;

         ArrayList<Walkway> w = new ArrayList<Walkway>();

         int b, e = 0, sp;
         int prev = 0;
         for (int i = 0; i < n; i++) {
            b = s.nextInt();
            e = s.nextInt();
            sp = s.nextInt();
            if (prev < b)
               w.add (new Walkway (prev, b, 0));
            w.add (new Walkway (b, e, sp));
            prev = e;
         }

         if (e < len)
            w.add (new Walkway (e, len, 0));

         Object ww[] = w.toArray();
         Arrays.sort (ww);

         double total = 0;
         for (int i = 0; i < ww.length; i++) {
            Walkway cur = (Walkway)ww[i];
            double segLen = cur.end - cur.begin;
            double walkSpeed = walk + cur.speed;
            double runSpeed = run + cur.speed;
            if (runTime <= 0) {
               total += (segLen / walkSpeed);
            }
            else {
               double segTime = (segLen / runSpeed);
               if (segTime <= runTime) {
                  total += segTime;
                  runTime -= segTime;
               }
               else { // Can run only part of the segment.
                  double runLen = runTime * runSpeed;
                  double walkLen = segLen - runLen;
                  total += (runLen / runSpeed) + (walkLen / walkSpeed);
                  runTime = 0;
               }
            }
         }

//         String outStr = "Case #" + test + ": " + total;
//         System.out.println (outStr);
//         out.println (outStr);
         System.out.printf ("Case #%d: %.9f\n", test, total);
         out.printf ("Case #%d: %.9f\n", test, total);
      }
   }
}
