import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class QualCBrute {
	
	static Room[] rooms;
	
	static class Room {
		int left;
		int right;
		int min;
		int max;
		int index;
		boolean free;
		
		public Room(int index) {
			left = 0;
			right = 0;
			free = true;
			min = 0;
			max = 0;
			this.index = index;
		}
		
		public void calc() {
			int count = 0;
			int curr = index+1;
			while (curr < rooms.length && rooms[curr].free) {
				count++;
				curr++;
			}
			right = count;
			count = 0;
			curr = index-1;
			while (curr >= 0 && rooms[curr].free) {
				count++;
				curr--;
			}
			left = count;
			min = Math.min(left, right);
			max = Math.max(left, right);
		}
	}

	public static void main(String[] args) throws IOException {
		BufferedReader r = new BufferedReader(new InputStreamReader(System.in));
		String s = r.readLine();
		int T = Integer.parseInt(s);
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < T; i++) {
			s = r.readLine();
			String[] parts = s.split(" ");
			int N = Integer.parseInt(parts[0]);
			int K = Integer.parseInt(parts[1]);
			rooms = new Room[N];
			for (int j = 0; j < N; j++) {
				rooms[j] = new Room(j);
			}
			for (int j = 0; j < K; j++) {
				int index = 0;
				int min = 0;
				int max = 0;
				for (int k = 0; k < N; k++) {
					if (!rooms[k].free) { continue; }
					rooms[k].calc();
					if (rooms[k].min > min) {
						min = rooms[k].min;
						max = rooms[k].max;
						index = k;
					} else if (rooms[k].min == min && rooms[k].max > max) {
						min = rooms[k].min;
						max = rooms[k].max;
						index = k;
					}
				}
				rooms[index].free = false;
				if (j == K-1) {
					sb.append("Case #" + (i+1) + ": " + max + " " + min + "\n");
				}
			}			
		}
		PrintWriter writer = new PrintWriter("QualCBrute.txt", "UTF-8");
		writer.print(sb.toString());
		writer.close();
		System.out.print(sb.toString());


	}

}
