package CodeJam;

import java.util.*;
import java.io.*;

public class A {

	public static void main(String[] args) {
		String[] cases = readTestCases("z:/gcj/A-large.in");
		int[] results = new int[cases.length];

		for (int i = 0; i < cases.length; i++) {
			String[] data = cases[i].split(" ");
			int N = Integer.parseInt(data[0]);

			int[] idle = {0, 0};
			int[] currP = {1, 1};
			for (int j = 1; j <= N; j++) {
				int r = data[j*2-1].equals("O") ? 0 : 1;
				int p = Integer.parseInt(data[j*2]);

				int cost = Math.abs(p - currP[r]) + 1 - idle[r];
				if (cost <= 0) {
					cost = 1;
				}

				results[i] += cost;
				idle[~r+2] += cost;
				idle[r] = 0;
				currP[r] = p;
			}
		}

		writeOutput(results);
	}

	private static String[] readTestCases(String filename) {
		try {
			BufferedReader is = new BufferedReader(new FileReader(filename));

			int T = Integer.parseInt(is.readLine());
			String[] cases = new String[T];

			for (int i = 0; i < T; i++) {
				cases[i] = is.readLine();
			}

			is.close();
			return cases;

		} catch (IOException e) {
			System.err.println("IOException: " + e.getMessage());
			return null;
		}
	}

	private static void writeOutput(int[] results) {
		try {
			PrintWriter os = new PrintWriter(new FileWriter("z:/output.txt"));
			for (int i = 0; i < results.length; i++) {
				os.println("Case #" + (i+1) + ": " + results[i]);
			}
			os.close();
		} catch (IOException e) {
			System.err.println("IOException: " + e.getMessage());
		}
	}

}
