import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class RunOneA {
  int typedChars, totalChars;
  double[] pTypeChars;
  
  public RunOneA(int[] charNum, double[]p) {
    this.typedChars = charNum[0];
    this.totalChars = charNum[1];
    pTypeChars = p;
  }
  
  public String solve() {
    int[] inputs = new int[typedChars];
    double[] results = calc(inputs, 0);
    double exp = results[0];
    for (int i = 1; i < results.length; ++i) {
      if (results[i] < exp)
        exp = results[i];
    }
    return String.format("%6f", exp);
  }
  
  private double[] calc(int[] inputs, int level) {
    if (level == typedChars) {
      boolean hasErr = inputs[0] == 1;
      // calc p
      double p = inputs[0] == 0 ? pTypeChars[0] : 1 - pTypeChars[0];
      for (int i = 1; i < inputs.length; ++i) {
        double pi = pTypeChars[i];
        if (inputs[i] == 1) {
          pi = 1 - pi;
          hasErr = true;
        }
        p *= pi;
      }
      double[] r = new double[typedChars + 2];
      // 0 keep typing
      r[0] = totalChars - typedChars + 1;
      if (hasErr) {
        r[0] += totalChars + 1;
      }
      // last, enter right away
      r[r.length - 1] = totalChars + 2;

      // back space i time
      for (int i = 1; i < r.length - 1; ++i) {
        hasErr = false;
        for (int j = 0; j < typedChars - i; ++j) {
          if (inputs[j] == 1) {
            hasErr = true;
          }
        }
        r[i] = (totalChars - typedChars) + 1 + 2 * i;
        if (hasErr) {
          r[i] += totalChars + 1;
        }
      }
      for (int i = 0; i < r.length; ++i) {
        r[i] *= p;
      }
      return r;
    }
    inputs[level] = 0;
    double[] a = calc(inputs, level + 1);
    inputs[level] = 1;
    double[] b = calc(inputs, level + 1);
    for (int i = 0; i < a.length; ++i) {
      a[i] += b[i];
    }
    return a;
  }

  public static void main(String[] args) throws IOException {
//    RunOneA solver = new RunOneA(3, 4, new double[]{1,0.9,0.1});
//    System.out.println(solver.solve());
    RunOneA solver;
    File folder = new File(".");
    for (File f : folder.listFiles()) {
      if (!f.getName().endsWith("in") || !f.isFile()) {
        continue;
      }
      System.out.println(f.getName());
      String outFileName = f.getName().replace("in", "out");

      BufferedReader reader = new BufferedReader(new FileReader(f));
      String str;
      int lineNum = 0, caseNum = 1;
      BufferedWriter writer = new BufferedWriter(new FileWriter(outFileName));
      lineNum = Integer.valueOf(reader.readLine());
      int ind = 0;
      int[] charNum = new int[2];
      double[] p;
      while ((str = reader.readLine()) != null) {
        str = str.trim();
        String[] tokens = str.split(" ");
        if (ind == 0) {
          for (int i = 0; i < tokens.length; ++i) {
            charNum[i] = Integer.valueOf(tokens[i]);
          }
          ind = 1;
        } else {
          p = new double[tokens.length];
          for (int i = 0; i < tokens.length; ++i) {
            p[i] = Double.valueOf(tokens[i]);
          }
          solver = new RunOneA(charNum, p);
          ind = 0;
          writer.write(String.format("Case #%d: %s\n", caseNum++, solver.solve()));
        }
        
      }
      if (lineNum != caseNum - 1) {
        System.err.println("Case Number is not matched to input file.");
      }
      writer.flush();
      writer.close();
    }
  }
}
