
public final class CountingSheepTestCase extends TestCase<Long,String,LongInputProcessor> {
	public static final int NUM_DIGITS = 10;
	
	private boolean[] beenSeen = new boolean[NUM_DIGITS];
	private int remainingDigits = NUM_DIGITS;
	
	public CountingSheepTestCase(LongInputProcessor inputProcessor) {
		super(inputProcessor);
	}
	
	@Override
	public String solveCase(Long input) {
		if( input == 0 ) {
			return "INSOMNIA";
		}
		Long currentNumber = input;
		while( !processNumber(currentNumber) ) {
			currentNumber += input;
		}
		return currentNumber.toString();
	}
	
	/**
	 * Process the digits of a number and return true
	 * if all digits (0 - 9) have been observed after observing the
	 * digits of this number.
	 * 
	 * @param number
	 * @return True if all digits have been observed
	 */
	private boolean processNumber(Long number) {
		String stringFormat = number.toString();
		for(char character: stringFormat.toCharArray()) {
			int radix = character - '0';
			if( !beenSeen[radix] ) {
				beenSeen[radix] = true;
				remainingDigits--;
			}
		}
		return remainingDigits <= 0;
	}
}
