package round1.a;



import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.Arrays;

public class Minimum_Scalar_Product {

	/**
	 * solve the problem
	 * @param caseBeans
	 * @return
	 */
	public static void solve(CaseBean[] caseBeans) {
		//int[] min_switch_times = new int[caseBeans.length];
		
		for (int i = 0; i < caseBeans.length; i++) {
			long[] x = caseBeans[i].getX();

			long[] y = caseBeans[i].getY();
			
			Arrays.sort(x);
			Arrays.sort(y);
			
			int LENGTH = x.length;
			
			for (int j = 0; j < LENGTH; j++) {
				caseBeans[i].minimum += x[j] * y[LENGTH - j - 1];
			}
		}
	}
	
	public static void main(String[] args) {
		File inFile = new File("e:\\google\\round1\\a\\A-small-attempt0.in");
		File outFile = new File("e:\\google\\round1\\a\\A-small-attempt0.out");
		
		CaseBean[] caseBeans = Helper.parse(inFile);		
		
		solve(caseBeans);
		
		Helper.writeResult(outFile, caseBeans);
		
		
		System.out.println(Arrays.toString(caseBeans));
		
		System.out.println(ReadWriteTextFile.getContents(outFile));
	}
}

class Helper {
	
	public static CaseBean[] parse(File file) {
		String inContents = ReadWriteTextFile.getContents(file);
		String[] lines = inContents.split("\r?\n");
		int line_index = 0;
		
		final int CASE_SIZE = Integer.parseInt(lines[line_index++]);
		
		CaseBean[] caseBeans = new CaseBean[CASE_SIZE];
		
		
		for (int i = 0; i < caseBeans.length; i++) {
			caseBeans[i] = new CaseBean();
			
			int N = Integer.parseInt(lines[line_index++]);
			
			String[] xString = lines[line_index++].split("\\s");
			
			long[] x = new long[xString.length];	
			for (int j = 0; j < x.length; j++) {
				x[j] = Long.parseLong(xString[j]);
			}
			String[] yString = lines[line_index++].split("\\s");
			
			long[] y = new long[yString.length];	
			for (int j = 0; j < y.length; j++) {
				y[j] = Long.parseLong(yString[j]);
			}
			
			caseBeans[i].setX(x);
			caseBeans[i].setY(y);
		}
		return caseBeans;
	}
	
	
	public static void writeResult(File file, CaseBean[] caseBeans) {
		StringBuffer buf = new StringBuffer();
		
		
		for (int i = 0; i < caseBeans.length; i++) {
			buf.append("Case #").append((i+1)).append(": ").append(caseBeans[i].minimum).append("\r\n");
		}
		
		
		try {
			if (!file.exists()) {
				file.createNewFile();
			}
			ReadWriteTextFile.setContents(file, buf.toString());
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}

class CaseBean {
	
	long[] x;

	long[] y;

	long minimum;
	
	public String toString() {
		String NEW_LINE = "\r\n";
		String SEPARTOR = ", ";
		StringBuffer buf = new StringBuffer();
		
		buf.append(minimum);
		buf.append(NEW_LINE);
		if (x != null) {
			buf.append(x.length);
			buf.append(" : ");
			for (int i = 0; i < x.length; i++) {
				buf.append(x[i]);
				buf.append(SEPARTOR);
			}
		}
		buf.append(NEW_LINE);
		if (y != null) {
			buf.append(y.length);
			buf.append(" : ");
			for (int i = 0; i < y.length; i++) {
				buf.append(y[i]);
				buf.append(SEPARTOR);
			}
		}
		buf.append(NEW_LINE);
		return buf.toString();
	}


	public long[] getX() {
		return x;
	}


	public void setX(long[] x) {
		this.x = x;
	}


	public long[] getY() {
		return y;
	}


	public void setY(long[] y) {
		this.y = y;
	}

}

class ReadWriteTextFile {

	/**
	 * Fetch the entire contents of a text file, and return it in a String.
	 * This style of implementation does not throw Exceptions to the caller.
	 *
	 * @param aFile is a file which already exists and can be read.
	 */
	static public String getContents(File aFile) {
		//...checks on aFile are elided
		StringBuilder contents = new StringBuilder();

		try {
			//use buffering, reading one line at a time
			//FileReader always assumes default encoding is OK!
			BufferedReader input = new BufferedReader(new FileReader(aFile));
			try {
				String line = null; //not declared within while loop
				/*
				 * readLine is a bit quirky :
				 * it returns the content of a line MINUS the newline.
				 * it returns null only for the END of the stream.
				 * it returns an empty String if two newlines appear in a row.
				 */
				while ((line = input.readLine()) != null) {
					contents.append(line);
					contents.append(System.getProperty("line.separator"));
				}
			} finally {
				input.close();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}

		return contents.toString();
	}

	static public String getContents(String fileName) {
		return getContents(new File(fileName));
	}

	/**
	 * Change the contents of text file in its entirety, overwriting any
	 * existing text.
	 *
	 * This style of implementation throws all exceptions to the caller.
	 *
	 * @param aFile is an existing file which can be written to.
	 * @throws IllegalArgumentException if param does not comply.
	 * @throws FileNotFoundException if the file does not exist.
	 * @throws IOException if problem encountered during write.
	 */
	static public void setContents(File aFile, String aContents)
			throws FileNotFoundException, IOException {
		if (aFile == null) {
			throw new IllegalArgumentException("File should not be null.");
		}
		if (!aFile.exists()) {
			throw new FileNotFoundException("File does not exist: " + aFile);
		}
		if (!aFile.isFile()) {
			throw new IllegalArgumentException("Should not be a directory: "
					+ aFile);
		}
		if (!aFile.canWrite()) {
			throw new IllegalArgumentException("File cannot be written: "
					+ aFile);
		}

		//use buffering
		Writer output = new BufferedWriter(new FileWriter(aFile));
		try {
			//FileWriter always assumes default encoding is OK!
			output.write(aContents);
		} finally {
			output.close();
		}
	}

	/** Simple test harness.   */
	public static void main(String[] aArguments) throws IOException {
		File testFile = new File("C:\\Temp\\blah.txt");
		System.out.println("Original file contents: " + getContents(testFile));
		setContents(testFile,
				"The content of this file has been overwritten...");
		System.out.println("New file contents: " + getContents(testFile));
	}
} 