package google.study;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Saving_the_Universe {

	/**
	 * solve the problem
	 * @param caseBeans
	 * @return
	 */
	public static int[] solve(CaseBean[] caseBeans) {
		int[] min_switch_times = new int[caseBeans.length];
		
		for (int i = 0; i < caseBeans.length; i++) {
			String[] search_engines = caseBeans[i].getSearch_engines();

			String[] incoming_querieds = caseBeans[i].getIncoming_querieds();
			
			int switch_times = 0;
			List list = new ArrayList();
			for (int j = 0; j < incoming_querieds.length; j++) {
				if (!list.contains(incoming_querieds[j])) {
					list.add(incoming_querieds[j]);
					if (search_engines.length == list.size()) {
						list.clear();
						list.add(incoming_querieds[j]);
						switch_times ++;
					}
				}
			}

			min_switch_times[i] = switch_times;
			
		}
		
		return min_switch_times;
	}
	
	public static void main(String[] args) {
		File inFile = new File("d:\\googleTest\\Saving_the_Universe\\A-small-attempt2.in");
		File outFile = new File("d:\\googleTest\\Saving_the_Universe\\A-small.out");
		
		CaseBean[] caseBeans = Helper.parse(inFile);		
		
		int[] min_switch_times = solve(caseBeans);
		
		Helper.writeResult(outFile, min_switch_times);
		
		
		System.out.println(Arrays.toString(caseBeans));
		
		System.out.println(ReadWriteTextFile.getContents(outFile));
	}
}

class Helper {
	
	public static CaseBean[] parse(File file) {
		String inContents = ReadWriteTextFile.getContents(file);
		String[] lines = inContents.split("\r?\n");
		int line_index = 0;
		
		final int CASE_SIZE = Integer.parseInt(lines[line_index++]);
		
		CaseBean[] caseBeans = new CaseBean[CASE_SIZE];
		
		for (int i = 0; i < caseBeans.length; i++) {
			caseBeans[i] = new CaseBean();
			
			int search_engines_length = Integer.parseInt(lines[line_index++]);
			
			String[] search_engines = new String[search_engines_length];	
			for (int j = 0; j < search_engines.length; j++) {
				search_engines[j] = lines[line_index++];
			}
			
			int incoming_querieds_length = Integer.parseInt(lines[line_index++]);
			
			String[] incoming_querieds = new String[incoming_querieds_length];	
			for (int j = 0; j < incoming_querieds.length; j++) {
				incoming_querieds[j] = lines[line_index++];
			}
			
			caseBeans[i].setSearch_engines(search_engines);
			caseBeans[i].setIncoming_querieds(incoming_querieds);
		}
		return caseBeans;
	}
	
	
	public static void writeResult(File file, int[] number) {
		StringBuffer buf = new StringBuffer();
		
		
		for (int i = 0; i < number.length; i++) {
			buf.append("Case #").append((i+1)).append(": ").append(number[i]).append("\r\n");
		}
		
		
		try {
			if (!file.exists()) {
				file.createNewFile();
			}
			ReadWriteTextFile.setContents(file, buf.toString());
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}

class CaseBean {
	
	String[] search_engines;

	String[] incoming_querieds;

	public String[] getIncoming_querieds() {
		return incoming_querieds;
	}

	public void setIncoming_querieds(String[] incoming_querieds) {
		this.incoming_querieds = incoming_querieds;
	}

	public String[] getSearch_engines() {
		return search_engines;
	}

	public void setSearch_engines(String[] search_engines) {
		this.search_engines = search_engines;
	}
	
	public String toString() {
		String NEW_LINE = "\r\n";
		String SEPARTOR = ", ";
		StringBuffer buf = new StringBuffer();
		if (search_engines != null) {
			buf.append(search_engines.length);
			buf.append(" : ");
			for (int i = 0; i < search_engines.length; i++) {
				buf.append(search_engines[i]);
				buf.append(SEPARTOR);
			}
		}
		if (incoming_querieds != null) {
			buf.append(incoming_querieds.length);
			buf.append(" : ");
			for (int i = 0; i < incoming_querieds.length; i++) {
				buf.append(incoming_querieds[i]);
				buf.append(SEPARTOR);
			}
		}
		buf.append(NEW_LINE);
		return buf.toString();
	}

}

class ReadWriteTextFile {

	  /**
	  * Fetch the entire contents of a text file, and return it in a String.
	  * This style of implementation does not throw Exceptions to the caller.
	  *
	  * @param aFile is a file which already exists and can be read.
	  */
	  static public String getContents(File aFile) {
	    //...checks on aFile are elided
	    StringBuilder contents = new StringBuilder();
	    
	    try {
	      //use buffering, reading one line at a time
	      //FileReader always assumes default encoding is OK!
	      BufferedReader input =  new BufferedReader(new FileReader(aFile));
	      try {
	        String line = null; //not declared within while loop
	        /*
	        * readLine is a bit quirky :
	        * it returns the content of a line MINUS the newline.
	        * it returns null only for the END of the stream.
	        * it returns an empty String if two newlines appear in a row.
	        */
	        while (( line = input.readLine()) != null){
	          contents.append(line);
	          contents.append(System.getProperty("line.separator"));
	        }
	      }
	      finally {
	        input.close();
	      }
	    }
	    catch (IOException ex){
	      ex.printStackTrace();
	    }
	    
	    return contents.toString();
	  }
	  
	  static public String getContents(String fileName) {
		  return getContents(new File(fileName));
	  }

	  /**
	  * Change the contents of text file in its entirety, overwriting any
	  * existing text.
	  *
	  * This style of implementation throws all exceptions to the caller.
	  *
	  * @param aFile is an existing file which can be written to.
	  * @throws IllegalArgumentException if param does not comply.
	  * @throws FileNotFoundException if the file does not exist.
	  * @throws IOException if problem encountered during write.
	  */
	  static public void setContents(File aFile, String aContents)
	                                 throws FileNotFoundException, IOException {
	    if (aFile == null) {
	      throw new IllegalArgumentException("File should not be null.");
	    }
	    if (!aFile.exists()) {
	      throw new FileNotFoundException ("File does not exist: " + aFile);
	    }
	    if (!aFile.isFile()) {
	      throw new IllegalArgumentException("Should not be a directory: " + aFile);
	    }
	    if (!aFile.canWrite()) {
	      throw new IllegalArgumentException("File cannot be written: " + aFile);
	    }

	    //use buffering
	    Writer output = new BufferedWriter(new FileWriter(aFile));
	    try {
	      //FileWriter always assumes default encoding is OK!
	      output.write( aContents );
	    }
	    finally {
	      output.close();
	    }
	  }

	  /** Simple test harness.   */
	  public static void main (String[] aArguments) throws IOException {
	    File testFile = new File("C:\\Temp\\blah.txt");
	    System.out.println("Original file contents: " + getContents(testFile));
	    setContents(testFile, "The content of this file has been overwritten...");
	    System.out.println("New file contents: " + getContents(testFile));
	  }
	} 

