package google.study.b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;

public class Train_Timetable {

	/**
	 * solve the problem
	 * 
	 * @param caseBeans
	 * @return
	 */
	public static String[] solve(CaseBean[] caseBeans) {
		String[] start_A_B = new String[caseBeans.length];

		for (int i = 0; i < caseBeans.length; i++) {
			Trip[] trips = caseBeans[i].getTrips();
			
			Arrays.sort(trips);
			

			for (int j = 0; j < trips.length; j++) {
				if (trips[j].pre == null) {
					trimFollowTrip(trips, j, caseBeans[i].getTurnaround_time());
				}
			}		
			
			int count_A_B = 0;
			int count_B_A = 0;
			
			for (int j = 0; j < trips.length; j++) {
				if (trips[j].pre == null) {
					if (trips[j].direction == Trip.A_B) {
						count_A_B ++;
					} else {
						count_B_A ++;
					}
				}
			}
			caseBeans[i].setCount_A_B(count_A_B);
			caseBeans[i].setCount_B_A(count_B_A);
			
			start_A_B[i] = count_A_B + " " + count_B_A;
		}

		return start_A_B;
	}
	
	
	static long MINUTE_LONG = 60 * 1000;
	
	public static void trimFollowTrip(Trip[] trips, int index, int turnaround_time) {
		
		if(trips[index] == null) {
			return;
		}
		
		for (int i = index+1; i < trips.length; i++) {
			
			if (trips[i].getPre() == null &&  trips[index].getDirection() != trips[i].getDirection() && trips[index].getArrival().getTime() + turnaround_time * MINUTE_LONG <= trips[i].getDeparture().getTime()) {
				trips[index].setNext(trips[i]);
				trips[i].setPre(trips[index]);
				trimFollowTrip(trips, i, turnaround_time);
				break;
			}
		}		
	}

	public static void main(String[] args) {
		File inFile = new File(
				"d:\\googleTest\\Train_Timetable\\B-large.in");
		File outFile = new File(
				"d:\\googleTest\\Train_Timetable\\B-large.out");

		CaseBean[] caseBeans = null;
		try {
			caseBeans = Helper.parse(inFile);
		} catch (ParseException e) {
			e.printStackTrace();
		}

		String[] start_A_B = solve(caseBeans);

		Helper.writeResult(outFile, start_A_B);

		System.out.println(Arrays.toString(caseBeans));
		System.out.println(Arrays.toString(start_A_B));
		
		System.out.println(ReadWriteTextFile.getContents(outFile));
	}
}

class Helper {

	public static CaseBean[] parse(File file) throws ParseException {
		String inContents = ReadWriteTextFile.getContents(file);
		String[] lines = inContents.split("\r?\n");
		int line_index = 0;

		final int CASE_SIZE = Integer.parseInt(lines[line_index++]);

		CaseBean[] caseBeans = new CaseBean[CASE_SIZE];

		for (int i = 0; i < caseBeans.length; i++) {
			caseBeans[i] = new CaseBean();
			
			int turnaround_time = Integer.parseInt(lines[line_index++]);
			String[] number_AB = lines[line_index++].split(" ");
			
			int NA = Integer.parseInt(number_AB[0]);
			int NB = Integer.parseInt(number_AB[1]);
			
			Trip[] trips = new Trip[NA + NB];
			for (int j = 0; j < trips.length; j++) {
				trips[j] = new Trip();
				String[] time = lines[line_index++].split(" ");
				trips[j].setDeparture(Trip.format.parse(time[0]));
				trips[j].setArrival(Trip.format.parse(time[1]));
				if (j < NA) {
					trips[j].setDirection(Trip.A_B);
				} else {
					trips[j].setDirection(Trip.B_A);
				}
			}
			caseBeans[i].setTurnaround_time(turnaround_time);
			caseBeans[i].setTrips(trips);
		}
		return caseBeans;
	}

	public static void writeResult(File file, String[] start_A_B) {
		StringBuffer buf = new StringBuffer();

		for (int i = 0; i < start_A_B.length; i++) {
			buf.append("Case #").append((i + 1)).append(": ").append(start_A_B[i])
					.append("\r\n");
		}

		try {
			if (!file.exists()) {
				file.createNewFile();
			}
			ReadWriteTextFile.setContents(file, buf.toString());
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}

class CaseBean {
	
	
	int count_A_B;
	int count_B_A;
	
	int turnaround_time;
	
	Trip[] trips;

	public String toString() {
		String NEW_LINE = "\r\n";
		StringBuffer buf = new StringBuffer();
		buf.append("A->B : " + count_A_B);
		buf.append("    ");
		buf.append("B->A : " + count_B_A);
		buf.append(NEW_LINE);
		buf.append("turnaround_time : ");
		buf.append(turnaround_time);
		buf.append(NEW_LINE);
		if (trips != null) {
			buf.append(trips.length);
			buf.append(NEW_LINE);
			for (int i = 0; i < trips.length; i++) {
				buf.append(trips[i]);
				buf.append(NEW_LINE);
			}
		}
		buf.append(NEW_LINE);
		return buf.toString();
	}

	public int getTurnaround_time() {
		return turnaround_time;
	}

	public void setTurnaround_time(int turnaround_time) {
		this.turnaround_time = turnaround_time;
	}

	public Trip[] getTrips() {
		return trips;
	}

	public void setTrips(Trip[] trips) {
		this.trips = trips;
	}

	public int getCount_A_B() {
		return count_A_B;
	}

	public void setCount_A_B(int count_A_B) {
		this.count_A_B = count_A_B;
	}

	public int getCount_B_A() {
		return count_B_A;
	}

	public void setCount_B_A(int count_B_A) {
		this.count_B_A = count_B_A;
	}

}

class Trip implements Comparable {

	
	Trip pre;
	Trip next;
	
	public final static SimpleDateFormat format = new SimpleDateFormat("HH:mm");

	public static final int A_B = 1;
	public static final int B_A = 2;
	
	int direction;
	
	Date departure;

	Date arrival;

	public String toString() {
		return format.format(departure) + " " + format.format(arrival) + "(" + (direction == A_B ? "A->B" : "B->A") + ")";
	}

	public Date getArrival() {
		return arrival;
	}

	public void setArrival(Date arrival) {
		this.arrival = arrival;
	}

	public Date getDeparture() {
		return departure;
	}

	public void setDeparture(Date departure) {
		this.departure = departure;
	}

	public int compareTo(Object anotherTrip) {
		Trip _anotherTrip = (Trip) anotherTrip;
		return this.getDeparture().compareTo(_anotherTrip.getDeparture());
	}

	public int getDirection() {
		return direction;
	}

	public void setDirection(int direction) {
		this.direction = direction;
	}

	public Trip getNext() {
		return next;
	}

	public void setNext(Trip next) {
		this.next = next;
	}

	public Trip getPre() {
		return pre;
	}

	public void setPre(Trip pre) {
		this.pre = pre;
	}
}

class ReadWriteTextFile {

	/**
	 * Fetch the entire contents of a text file, and return it in a String. This
	 * style of implementation does not throw Exceptions to the caller.
	 * 
	 * @param aFile
	 *            is a file which already exists and can be read.
	 */
	static public String getContents(File aFile) {
		// ...checks on aFile are elided
		StringBuilder contents = new StringBuilder();

		try {
			// use buffering, reading one line at a time
			// FileReader always assumes default encoding is OK!
			BufferedReader input = new BufferedReader(new FileReader(aFile));
			try {
				String line = null; // not declared within while loop
				/*
				 * readLine is a bit quirky : it returns the content of a line
				 * MINUS the newline. it returns null only for the END of the
				 * stream. it returns an empty String if two newlines appear in
				 * a row.
				 */
				while ((line = input.readLine()) != null) {
					contents.append(line);
					contents.append(System.getProperty("line.separator"));
				}
			} finally {
				input.close();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}

		return contents.toString();
	}

	static public String getContents(String fileName) {
		return getContents(new File(fileName));
	}

	/**
	 * Change the contents of text file in its entirety, overwriting any
	 * existing text.
	 * 
	 * This style of implementation throws all exceptions to the caller.
	 * 
	 * @param aFile
	 *            is an existing file which can be written to.
	 * @throws IllegalArgumentException
	 *             if param does not comply.
	 * @throws FileNotFoundException
	 *             if the file does not exist.
	 * @throws IOException
	 *             if problem encountered during write.
	 */
	static public void setContents(File aFile, String aContents)
			throws FileNotFoundException, IOException {
		if (aFile == null) {
			throw new IllegalArgumentException("File should not be null.");
		}
		if (!aFile.exists()) {
			throw new FileNotFoundException("File does not exist: " + aFile);
		}
		if (!aFile.isFile()) {
			throw new IllegalArgumentException("Should not be a directory: "
					+ aFile);
		}
		if (!aFile.canWrite()) {
			throw new IllegalArgumentException("File cannot be written: "
					+ aFile);
		}

		// use buffering
		Writer output = new BufferedWriter(new FileWriter(aFile));
		try {
			// FileWriter always assumes default encoding is OK!
			output.write(aContents);
		} finally {
			output.close();
		}
	}

	/** Simple test harness. */
	public static void main(String[] aArguments) throws IOException {
		File testFile = new File("C:\\Temp\\blah.txt");
		System.out.println("Original file contents: " + getContents(testFile));
		setContents(testFile,
				"The content of this file has been overwritten...");
		System.out.println("New file contents: " + getContents(testFile));
	}
}
