import java.util.*;

public class BBrute {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        
        final int noTests = in.nextInt();
        in.nextLine();
        
        for(int test=1; test<=noTests; test++) {
            int K = in.nextInt();
            int L = in.nextInt();
            int S = in.nextInt();
            in.nextLine();
            
            if(L > S) {
                System.out.printf("Case #%d: %f\n", test, 0);
                continue;
            }
            
            char[] keyboard = in.nextLine().toCharArray();
            char[] target = in.nextLine().toCharArray();
            
            int tChars = keyboard.length;
            int counts[] = new int[256];
            for(char c : keyboard) {
                counts[(int) c]++;
            }
            
            //generate all permutations, calculate their probability, and number of bananas
            boolean used[] = new boolean[256];
            List<Character> temp = new ArrayList<>();
            for(char c : keyboard) {
                if(!used[(int) c]) {
                    used[(int) c] = true;
                    temp.add(c);
                }
            }
            
            char[] keyNoRep = new char[temp.size()];
            for(int i=0; i<keyNoRep.length; i++)
                keyNoRep[i] = temp.get(i);
            
            //System.err.println("cur keyboard = " + Arrays.toString(keyNoRep));
            
            char[][] allPerms = allPerms(keyNoRep, S);
            
            double exp = 0;
            int worstTimes = 0;
            for(char[] curPerm : allPerms) {
                
                //calculate the probability of this one
                double prob = 1.0;
                for(char c : curPerm)
                    prob *= (double) counts[(int) c] / tChars;
                
                //calculate how many times we got the target word
                int times = 0;
                for(int i=0; i<curPerm.length - target.length + 1; i++) {
                    boolean matched = true;
                    for(int j=0; j<target.length && matched; j++)
                        if(curPerm[i + j] != target[j])
                            matched = false;
                    
                    if(matched)
                        times++;
                }
                
                //multiply the two and add to the total
                double prod = prob * times;
                exp += prod;
                
                //add to worst case times
                worstTimes = Math.max(worstTimes, times);
            }
            
            
            
            System.out.printf("Case #%d: %f%n", test, worstTimes - exp);
        }
    }
    
    public static char[][] allPerms(char[] keyboard, int s) {
        int total = (int) Math.pow(keyboard.length, s);
        //System.err.println(keyboard);
        //System.err.println("total Perms = " + total);
        
        char[][] toReturn = new char[total][s];
        
        int curChar[] = new int[s];
        
        for(int perm=0; perm<total; perm++) {
            char[] curPerm = toReturn[perm];
            
            for(int i=0; i<s; i++) {
                curPerm[i] = keyboard[curChar[i]];
            }
                
            incMod(curChar, keyboard.length);
        }
        
        return toReturn;
    }
    
    public static void incMod(int[] arr, int mod) {
        for(int element=0; element<arr.length; element++) {
            arr[element]++;
            if(arr[element] < mod)
                break;
            else
                arr[element] = 0;
        }
    }
}
