import java.util.*;

public class ProblemBS {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        
        final int noTests = in.nextInt();
        in.nextLine();
        
        for(int test=1; test<=noTests; test++) {
            int r = in.nextInt();
            int c = in.nextInt();
            int n = in.nextInt();
            
            boolean[][] occ = new boolean[r][c];
            
            System.out.printf("Case #%d: %d%n", test, solve(occ, n, 0, -1, -1));
        }
    }
    
    public static int solve(boolean[][] occupants, int toPlace, int curScore, int lastX, int lastY) {
        if(toPlace == 0)
            return curScore;
        
        //try all remaining holes
        int x = lastX + 1;
        if(x >= occupants.length)
            x = 0;
        
        int y = lastY;
        if(x == 0)
            y++; 
        
        if(x >= occupants.length || y >= occupants[x].length || x < 0 || y < 0)
            return Integer.MAX_VALUE;
        
        int bestScore = Integer.MAX_VALUE;
        
        while(x < occupants.length && y < occupants[x].length) {
            //place the thing
            occupants[x][y] = true;
            
            //calculate change in score
            int[][] offsets = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}};
            
            int scorePen = 0;
            
            for(int[] offset : offsets) {
                int tX = x + offset[0];
                int tY = y + offset[1];
                
                if(tX < occupants.length && tX >= 0 && tY < occupants[tX].length && tY >= 0 && occupants[tX][tY])
                    scorePen++;
            }
            
            int newSol = solve(occupants, toPlace-1, curScore + scorePen, x, y);
            bestScore = Math.min(bestScore, newSol);
            
            if(bestScore == 0)
                return 0;
            
            //unplace
            occupants[x][y] = false;
            
            //increment x and y
            x++;
            if(x >= occupants.length)
                x = 0;
            
            if(x == 0)
                y++;
        }
        
        return bestScore;
        
    }
}
