import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.BitSet;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Queue;
import java.util.Scanner;
import java.util.Set;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

public class A {

	private static int flipLength; 

    public static void main(String[] args) throws FileNotFoundException {
//    	Node start = new Node(8);
//    	Node target = new Node("---+-++-");
//    	flipLength = 3;
//        System.out.println(breadthFirstSearch(start, target));
//        
//        start = new Node(5);
//    	target = new Node("+++++");
//    	flipLength = 4;
//        System.out.println(breadthFirstSearch(start, target));
//        
//        start = new Node(5);
//    	target = new Node("-+-+-");
//    	flipLength = 4;
//        System.out.println(breadthFirstSearch(start, target));
        Scanner in = new Scanner(new File("A-small-attempt2.in"));
        PrintWriter pw = new PrintWriter(new File("A.out"));
        int tests = in.nextInt();
        for (int i = 0 ; i < tests; i++) {
        	String pattern = in.next();
        	int n = in.nextInt();
        	
        	Node start = new Node(pattern.length());
        	Node target = new Node(pattern);
        	flipLength = n;
            pw.write("Case #" + (i+1) + ": " + breadthFirstSearch(start, target) + "\n");
        }
        pw.flush();
    }

    private static String breadthFirstSearch(Node start, Node target) {
    	
    	Set<Node> visited = new HashSet<>();
    	Queue<Node> toVisit = new LinkedList<>();
    	visited.add(start);
    	toVisit.add(start);
    	while (!toVisit.isEmpty()) {
    		Node n = toVisit.poll();
    		if (n.equals(target)) {
    			return String.valueOf(n.distance);
    		}
    		List<Node> children = n.children();
    		List<Node> newKids = children.stream().filter(item -> visited.add(item)).collect(Collectors.toList());
    		toVisit.addAll(newKids);
    	}
    	return "IMPOSSIBLE";
    }

    private static class Node {
    	final BitSet value;
    	final int distance;
    	Node(int bits) {
    		value = new BitSet(bits);
    		value.set(0, bits, true);
    		distance = 0;
    	}

    	Node(Node father, int index) {
    		value = (BitSet) father.value.clone();
    		value.flip(index, index+flipLength);
    		distance = father.distance + 1;
    	}

    	public Node(String string) {
    		value = new BitSet(string.length());
			IntStream.range(0, string.length())
			.forEach(idx -> value.set(idx, string.charAt(idx) == '+' ? true : false));
			distance = Integer.MAX_VALUE;
		}

		List<Node> children() {
    		List<Node> nodes = IntStream.range(0, value.length()-flipLength + 1).boxed()
    				.map(i -> new Node(Node.this, i))
    				.collect(Collectors.toList());
    		return nodes;
    	}

		
		@Override
		public String toString() {
			return "Node [value=" + value + ", distance=" + distance + "]";
		}

		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + ((value == null) ? 0 : value.hashCode());
			return result;
		}

		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			Node other = (Node) obj;
			if (value == null) {
				if (other.value != null)
					return false;
			} else if (!value.equals(other.value))
				return false;
			return true;
		}
    	
    }

    
}
