import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.LinkedHashSet;
import java.util.Scanner;
import java.util.Set;

public class A {

	enum alphabet {
		A(1),
		B(2),
		C(3),
		D(4),
		E(5),
		F(6),
		G(7),
		H(8),
		I(9),
		J(10),
		K(11),
		L(12),
		M(13),
		N(14),
		O(15),
		P(16),
		Q(17),
		R(18),
		S(19),
		T(20),
		U(21),
		V(22),
		W(23),
		X(24),
		Y(25),
		Z(26);
			
		int index;
		alphabet(int index) {
			this.index = index;
		}
	}
	
    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new File("A-small-attempt0.in"));
        PrintWriter pw = new PrintWriter(new File("A-small.out"));
        int tests = in.nextInt();
        for (int i = 0 ; i < tests; i++) {
        	int r = in.nextInt();
        	int c = in.nextInt();
        	int[][] grid = new int[r][c];
        	for (int j = 0; j < r; j++) {
        		
        		String row = in.next();
        		for (int k = 0; k < c; k++) {
        			try {
        				alphabet a = alphabet.valueOf(String.valueOf(row.charAt(k)).toUpperCase());
        				grid[j][k] = a.index;
        			}
        			catch (Exception e) {
        				grid[j][k] = -1;
        			}
        				
        		}
        	}
            pw.write("Case #" + (i+1) + ": " + solution(grid));
            pw.flush();
        }
        pw.close();
        in.close();
    }

    private static String solution(int[][] grid) {
    	int r = grid.length;
    	int c = grid[0].length;
    	Set<Integer> toCopyAtTheEnd = new LinkedHashSet<>();
    	Set<Integer> full = new LinkedHashSet<>();
    	for (int i = 0; i < r; i++) {
    		int[] row = grid[i];
    		boolean found = false;
    		int carryCopying = 0;
    		for (int j = 0; j < c; j++) {
    			if (row[j] == -1 && found) {
    				row[j] = row[j-1];
    			}
    			else if (row[j] == -1 && !found) {
    				carryCopying++;
    			}
    			else if (row[j] != -1 && carryCopying != 0) {
    				found = true;
    				while (carryCopying > 0) {
    					row[j-carryCopying] = row[j];
    					carryCopying--;
    				}
    			}
    			else {
    				found = true;
    			}
    		}
    		if (!found) {
    			toCopyAtTheEnd.add(i);
    		}
    		else {
    			full.add(i);
    			if (found && carryCopying > 0) {
    			
    				int copyFrom = c-carryCopying - 1;
    				while (carryCopying > 0) {
    					row[c-carryCopying] = row[copyFrom];
    					carryCopying--;
    				}
    			}
    		}
    	}
    	if (full.isEmpty()) {
    		for (int i = 0; i < r; i++) {
    			int[] row = grid[i];
    			Arrays.fill(row, 1);
    		}
    	}
    	else {
    		for (Integer idx : toCopyAtTheEnd) {
    			if (idx == 0) {
    				int firstGood = full.iterator().next();
    				copyArray(grid[firstGood], grid[0]);
    			}
    			else {
    				copyArray(grid[idx-1], grid[idx]);
    			}
    		}
    	}
    	StringBuilder sb = new StringBuilder();
    	alphabet[] letters = alphabet.values();
    	sb.append("\n");
    	for (int i = 0; i < r; i ++) {
    		for (int j = 0; j < c; j++) {
    			sb.append(letters[grid[i][j] - 1]);
    		}
    		sb.append("\n");
    	}
    	
    	return sb.toString();
    }

	private static void copyArray(int[] src, int[] dst) {
		for (int i = 0; i < src.length; i++) {
			dst[i] = src[i];
		}
	}
    
}
