import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Collections;
import java.util.List;
import java.util.PriorityQueue;
import java.util.Scanner;
import java.util.stream.Collectors;

public class C {


    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new File("C-small-1-attempt0.in"));
        PrintWriter pw = new PrintWriter(new File("C-small.out"));
        int tests = in.nextInt();
        for (int i = 0 ; i < tests; i++) {
        	int n = in.nextInt();
        	int k = in.nextInt();
            pw.write("Case #" + (i+1) + ": " + solution(n, k) + "\n");
            pw.flush();
        }
        pw.close();
        in.close();
    }

    private static String solution(int n, int k) {
    	PriorityQueue<Space> pq = new PriorityQueue<>(Collections.reverseOrder());
    	pq.add(new Space(1, n));
    	Space space = null;
    	for (int i = 0; i < k-1; i++) {
    		space = pq.poll();
    		int mid = space.length% 2 == 0 ? (space.length/2 + space.start - 1) :  (space.length/2 + space.start);
    		Space[] split = space.split(mid);
    		if (split[0].length > 0) {
    			pq.add(split[0]);
    		}
    		if (split[1].length > 0) {
    			pq.add(split[1]);
    		}
    	}
    	space = pq.poll();
    	int newLength = space.length - 1;
    	return "" + (newLength - newLength/2) + " " + (newLength/2);  
    }

    private static class Space implements Comparable<Space> {
    	private int start;
    	private int length;

    	Space(int position, int length) {
    		this.start = position;
    		this.length = length;
    	}
    	Space[] split(int pos) {
    		return new Space[]{
    				new Space(start, pos - start),
    				new Space(pos + 1, (start + length) - (pos + 1))};
    	}
		@Override
		public int compareTo(Space o) {
			if (length > o.length) {
				return 1;
			}
			else if (o.length > length) {
				return -1;
			}
			else {
				return -1*Integer.compare(start, o.start);
			}
		}
		@Override
		public String toString() {
			return "Space [start=" + start + ", length=" + length + "]";
		}
    }
    
}
