import java.io.File;
import java.io.FileWriter;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;


public class Milkshakes {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		File f1 = new File(args[0]);
		File f2 = new File(args[1]);
		if(f2.exists())
		{
			f2.delete();
		}
		f2.createNewFile();
		RandomAccessFile fin = new RandomAccessFile(f1, "r");
		FileWriter fout = new FileWriter(f2);
		String numberTestLine = fin.readLine();
		for(int i = 0; i < Integer.valueOf(numberTestLine.trim()); i++)
		{
			//System.out.println("Case #"  + i);
			String flavors = fin.readLine();
			int []flavorBatchs = new int[Integer.parseInt(flavors)];
			String customers = fin.readLine();
			ArrayList<Customer> lstCustomers = new ArrayList<Customer>();
			for(int j = 0; j < Integer.parseInt(customers); j++)
			{
				String custMilk = fin.readLine();
				String []custMiklParts = custMilk.split(" ");
				String numCustMikl = custMiklParts[0];
				lstCustomers.add(new Customer(custMiklParts));
			}
			
			int custAtt = 0;
			boolean error = false;
			while(custAtt < lstCustomers.size() && !error)
			{
				//System.out.println("Case #"  + i + " CustAtt: " + custAtt);

				Customer cust = lstCustomers.get(custAtt);
				if(!cust.likeOne(flavorBatchs))
				{
					int flavorMalted = cust.getMaltedFlavor();
					if(flavorMalted != -1)
					{
						if(flavorBatchs[flavorMalted-1] != 1)
						{
							flavorBatchs[flavorMalted-1] = 1;
							custAtt = 0;
						}
						else
						{
							error = true;
						}
					}
					else
					{
						error = true;
					}
				}
				else
				{
					custAtt++;
				}
			}
			
			fout.write("Case #" + (i+1) + ":");
			if(!error)
			{
				for (int j = 0; j < flavorBatchs.length; j++) {
					fout.write(" " + flavorBatchs[j]);
				}
			}
			else
			{
				fout.write(" IMPOSSIBLE");
			}
			fout.write("\n");
		}
		fout.flush();
		fout.close();
	}
	
}
class MilkType
{
	int milkFlavor; //1 to N
	int milkType; // O unmalted 1 malted
	
	@Override
	public boolean equals(Object obj) {
		// TODO Auto-generated method stub
		return this.equals((MilkType)obj);
	}

	public boolean equals(MilkType o)
	{
		return o.milkFlavor == this.milkFlavor && o.milkType == this.milkType;
	}
}

class Customer
{
	Collection<MilkType> milks = new ArrayList<MilkType>();
	
	public Customer(String[] milksArr)
	{
		int num = Integer.parseInt(milksArr[0]);
		for(int i = 0; i < num; i++)
		{
			MilkType mType = new MilkType();
			mType.milkFlavor = Integer.parseInt(milksArr[i*2 + 1]);
			mType.milkType = Integer.parseInt(milksArr[i*2 + 2]);
			milks.add(mType);
		}
	}
	
	public boolean likeOne(int []flavorBatchs )
	{
		for (int i = 0; i < flavorBatchs.length; i++) {
			int type = flavorBatchs[i];
			MilkType mType = new MilkType();
			mType.milkFlavor = i+1;
			mType.milkType = type;
			if(milks.contains(mType))
			{
				return true;
			}
		}
		return false;
	}
	
	public int getMaltedFlavor()
	{
		for (Iterator<MilkType> iterator = this.milks.iterator(); iterator.hasNext();) {
			MilkType milk =  iterator.next();
			if(milk.milkType == 1)
			{
				return milk.milkFlavor;
			}
		}
		return -1;
	}
}
