import java.io.File;
import java.io.FileWriter;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;


public class MinimunScalarProduct {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		File f1 = new File(args[0]);
		File f2 = new File(args[1]);
		if(f2.exists())
		{
			f2.delete();
		}
		f2.createNewFile();
		RandomAccessFile fin = new RandomAccessFile(f1, "r");
		FileWriter fout = new FileWriter(f2);
		String numberTestLine = fin.readLine();
		for(int i = 0; i < Integer.valueOf(numberTestLine.trim()); i++)
		{
			String numCoord = fin.readLine();
			String vector1 = fin.readLine();
			String vector2 = fin.readLine();
			ArrayList<Integer> coord1 = createCollection(vector1, numCoord); 
			ArrayList<Integer> coord2 = createCollection(vector2, numCoord);
			int product = 0;
			for(int j = 0; j< Integer.parseInt(numCoord); j++)
			{
				if(coord1.get(0) < coord2.get(0))
				{
					product += coord1.get(0) * coord2.get(coord2.size()-1);
					coord1.remove(0);
					coord2.remove(coord2.size()-1);
				}
				else
				{
					product += coord2.get(0) * coord1.get(coord1.size()-1);
					coord2.remove(0);
					coord1.remove(coord1.size()-1);
				}
			} 
			fout.write("Case #" + (i+1) + ": " + product + "\n");
		}
		fout.flush();
		fout.close();

	}

	private static ArrayList<Integer> createCollection(String vector, String numCoord) {
		String[] vectorParts = vector.split(" ");
		ArrayList<Integer> ret = new ArrayList<Integer>();
		for (int i = 0; i < vectorParts.length; i++) {
			String string = vectorParts[i];
			ret.add(Integer.decode(string));
		}
		Collections.sort(ret);
		return ret;
	}

}
