import java.io.File;
import java.io.FileWriter;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.Iterator;


public class SavingUniverse
{
	public static void main(String[] args) throws Exception
	{
		File f1 = new File(args[0]);
		File f2 = new File(args[1]);
		if(f2.exists())
		{
			f2.delete();
		}
		f2.createNewFile();
		RandomAccessFile fin = new RandomAccessFile(f1, "r");
		FileWriter fout = new FileWriter(f2);
		String numberTestLine = fin.readLine();
		for(int i = 0; i < Integer.valueOf(numberTestLine.trim()); i++)
		{
			ArrayList<String> enginesNames = new ArrayList<String>();
			String numEngines = fin.readLine();
			for(int j = 0; j < Integer.valueOf(numEngines); j++)
			{
				String engineName = fin.readLine();
				enginesNames.add(engineName);
			}
			String numQueries = fin.readLine();
			ArrayList<String> queries = new ArrayList<String>();
			for(int j = 0; j < Integer.valueOf(numQueries); j++)
			{
				String query = fin.readLine();
				queries.add(query);
			}
			int out = process(enginesNames,queries);
			fout.write("Case #" + (i+1) + ": " + out + "\n");
		}
		fout.flush();
		fout.close();
	}

	private static int process(ArrayList<String> enginesNames, ArrayList<String> queries)
	{
		String lessEngine = getLessEngine(enginesNames, queries);
		
		for(Iterator<String> itQueries = queries.iterator(); itQueries.hasNext();)
		{
			String query = itQueries.next();
			if(!query.equals(lessEngine))
			{
				itQueries.remove();
			}
			else
			{
				break;
			}
		}
		
		if(queries.size() == 0)
		{
			return 0;
		}
		else
		{
			return 1 + process(enginesNames, queries);
		}
	}

	private static String getLessEngine(ArrayList<String> enginesNames, ArrayList<String> queries)
	{
		String ret = enginesNames.get(0); 
		int maxEngine = getEngineNumbers(ret, queries);
		for(Iterator<String> itEngines = enginesNames.iterator(); itEngines.hasNext();)
		{
			String engineName = itEngines.next();
			int currentEngine = getEngineNumbers(engineName, queries);
			if(currentEngine > maxEngine)
			{
				maxEngine = currentEngine;
				ret = engineName;
			}
		}
		return ret;
	}

	private static int getEngineNumbers(String ret, ArrayList<String> queries)
	{
		return queries.indexOf(ret)>=0?queries.indexOf(ret):queries.size();
	}
}
