import java.io.*;
import java.util.*;

/*
 * Qualification Round Problem A: Tic-Tac-Toe-Tomek
 */
public class TicTacToeTomek {
	public static String solve(char[][] board) {
		// Check horizontal / vertical wins
		for (int i=0; i<4; i++) {
			for (int p=0; p<2; p++) { //switch horizontal/vertical
				char player;
				if (p == 0) {
					player = board[i][0];
				} else {
					player = board[0][i];
				}
				boolean win = true;
				if (player == '.') {
					win = false;
					continue;
				}
				for (int j=1; j<4; j++) {
					char current;
					if (p == 0) {
						current = board[i][j];
					} else {
						current = board[j][i];
					}
					if (current != player && current != 'T') {
						win = false;
						break;
					}
				}
				if (win) {
					return player + " won";
				}
			}
		}
		// Check diagonals wins
		for (int p=0; p<2; p++) { //switch between 2 diagonals
			boolean win = true;
			char player;
			if (p == 0) {
				player = board[0][0];
			} else {
				player = board[0][3];
			}
			if (player == '.') {
				win = false;
				continue;
			}
			for (int i=1; i<4; i++) {
				char current;
				if (p == 0) {
					current = board[i][i];
				} else {
					current = board[i][3-i];
				}
				if (current != player && current != 'T') {
					win = false;
					break;
				}
			}
			if (win) {
				return player + " won";
			}
		}
		// check for draw/uncomplete
		for (int i=0; i<4; i++) {
			for (int j=0; j<4; j++) {
				if (board[i][j] == '.') {
					return "Game has not completed";
				}
			}
		}
		return "Draw";
	}
	
	public static void main(String[] args) {
		try {
			// Init Scanner / Writer
			String filename = "A-small-attempt0";
			Scanner sc = new Scanner(new File(filename + ".in"));
			BufferedWriter out = new BufferedWriter(new FileWriter(filename + ".out"));
			
			// Start reading file
			int T = sc.nextInt();
			for (int i=1; i<=T; i++) {
				sc.nextLine();
				char[][] board = new char[4][];
				for (int j=0; j<4; j++) {
					String line = sc.nextLine();
					board[j] = line.toCharArray();
				}
				out.write("Case #");
				out.write(Integer.toString(i));
				out.write(": ");
				out.write(solve(board));
				out.write("\n");
			}
			out.close();
			sc.close();
		} catch (Exception e) {
			System.out.println(e);
		}

	}

}
