import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Scanner;

/*
 * Qualification Round Problem C: Fair and Square
 */
public class FairAndSquare {
	public static ArrayList<BigInteger> fas_numbers = new ArrayList<BigInteger>();
	
	public static boolean isPalindrome(BigInteger n) {
		String sn = n.toString();
		for (int i=0; i<sn.length()/2; i++) {
			if (sn.charAt(i) != sn.charAt(sn.length()-1-i)) {
				return false;
			}
		}
		return true;
	}
	
	public static void gen_fas() {
		BigInteger limit = BigInteger.TEN.pow(100);
		for (int i=1; i<10 && BigInteger.valueOf(i).compareTo(limit)==-1; i++) {
			BigInteger sq = BigInteger.valueOf(i * i);
			if (isPalindrome(sq)) {
				fas_numbers.add(sq);
			}
		}
		int len = 2;
		int p_size = 1;
		BigInteger p_number = new BigInteger("1");
		while (true) {
			StringBuffer cur = new StringBuffer(p_number.toString());
			StringBuffer rev = new StringBuffer(p_number.toString()).reverse();
			if (len % 2 == 0) {
				cur.append(rev);
				BigInteger x = new BigInteger(cur.toString());
				BigInteger sq = x.multiply(x);
				if (sq.compareTo(limit) == 1) {
					return;
				}
				if (isPalindrome(sq)) {
					fas_numbers.add(sq);
				}
			} else {
				for (int i=0; i<=9; i++) {
					cur.append(i);
					cur.append(rev);
					BigInteger x = new BigInteger(cur.toString());
					BigInteger sq = x.multiply(x);
					if (sq.compareTo(limit) == 1) {
						return;
					}
					if (isPalindrome(sq)) {
						fas_numbers.add(sq);
					}
				}
			}
			p_number = p_number.add(BigInteger.ONE);
			if (p_number.toString().length() > p_size) {
				if (len % 2 == 0) {
					p_number = BigInteger.TEN.pow(p_size - 1);
				} else {
					p_size++;
				}
				len++;
			}
		}
	}
	public static int solve(BigInteger A, BigInteger B) {
		int count = 0;
		for (int i=0; i<fas_numbers.size(); i++) {
			BigInteger current = fas_numbers.get(i);
			if (current.compareTo(A) >= 0) {
				if (current.compareTo(B) <= 0) {
					count++;
				} else {
					break;
				}
			}
		}
		return count;
	}
	
	public static void main(String[] args) {
		try {
			gen_fas();
			// Init Scanner / Writer
			String filename = "C-large-1";
			Scanner sc = new Scanner(new File(filename + ".in"));
			BufferedWriter out = new BufferedWriter(new FileWriter(filename + ".out"));
			
			// Start reading file
			int T = sc.nextInt();
			for (int i=1; i<=T; i++) {
				sc.nextLine();
				BigInteger A = sc.nextBigInteger();
				BigInteger B = sc.nextBigInteger();
				
				out.write("Case #");
				out.write(Integer.toString(i));
				out.write(": ");
				out.write("" + solve(A, B));
				out.write("\n");
			}
			out.close();
			sc.close();
		} catch (Exception e) {
			System.out.println(e);
		}
	}

}
