import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.Arrays;
import java.util.Scanner;

/*
 * Qualification Round Problem B: Lawnmower
 */
public class Lawnmower {

	public static String solve(int[][] board, int N, int M, boolean isLarge) {
		if (N == 1 || M == 1) {
			return "YES";
		}
		int limit = 2;
		if (isLarge) {
			limit = 100;
		}
		int[][] newboard = new int[N][M];
		for (int i=0; i<N; i++) {
			for (int j=0; j<M; j++) {
				newboard[i][j] = limit;
			}
		}
		for (int l=limit-1; l>0; l--) {
			for (int i=0; i<M; i++) {
				boolean cut = true;
				if (board[0][i] <= l) {
					for (int j=0; j<N; j++) {
						if (board[j][i] > l) {
							cut = false;
							break;
						}
					}
				} else {
					cut = false;
				}
				if (cut) {
					for (int j=0; j<N; j++) {
						if (newboard[j][i] > l) {
							newboard[j][i] = l;
						}
					}
				}
			}
			for (int i=0; i<N; i++) {
				boolean cut = true;
				if (board[i][0] <= l) {
					for (int j=0; j<M; j++) {
						if (board[i][j] > l) {
							cut = false;
							break;
						}
					}
				} else {
					cut = false;
				}
				if (cut) {
					for (int j=0; j<M; j++) {
						if (newboard[i][j] > l) {
							newboard[i][j] = l;
						}
					}
				}
			}
		}
		for (int i=0; i<N; i++) {
			for (int j=0; j<M; j++) {
				if (newboard[i][j] != board[i][j]) {
					return "NO";
				}
			}
		}
		return "YES";
	}
	
	public static void main(String[] args) {
		try {
			// Init Scanner / Writer
			String filename = "B-small-attempt1";
			boolean isLarge = false;
			Scanner sc = new Scanner(new File(filename + ".in"));
			BufferedWriter out = new BufferedWriter(new FileWriter(filename + ".out"));
			
			// Start reading file
			int T = sc.nextInt();
			for (int i=1; i<=T; i++) {
				sc.nextLine();
				int N = sc.nextInt();
				int M = sc.nextInt();
				int[][] board = new int[N][M];
				for (int a=0; a<N; a++) {
					for (int b=0; b<M; b++) {
						board[a][b] = sc.nextInt();
					}
				}
				out.write("Case #");
				out.write(Integer.toString(i));
				out.write(": ");
				out.write(solve(board, N, M, isLarge));
				out.write("\n");
			}
			out.close();
			sc.close();
		} catch (Exception e) {
			System.out.println(e);
		}
	}

}
