package codejam.task3;

import java.util.ArrayList;
import java.util.List;

import codejam.Task;
import codejam.Util;

public class Task3 extends Task {

	@Override
	public List<String> split(String input) {
		List<String> result = new ArrayList<String>();
		String[] lines = Util.getLines(input);
		for (int i = 1; i < lines.length; i++) {
			result.add(lines[i]);
		}
		return result;
	}

	@Override
	public String solveCase(String input) {
		String nums[] = input.split(" ");
		int start = Integer.parseInt(nums[0]);
		int end = Integer.parseInt(nums[1]);
		int count = 0;
		for (int i = start; i <= end; i++) {
			if (isFair(i) && isSquare(i) && 
					isFair((int)Math.sqrt(i))) {
				count++;
			}
		}
		return "" + count;
	}

	private boolean isSquare(int n) {
		double root = Math.round(Math.sqrt(n));
		return Math.abs(root * root - n) < 0.00000001;
	}

	private boolean isFair(int n) {
		String str = "" + n;
		int len = str.length();
		for (int i = 0; i < (len + 1) / 2; i++) {
			if (str.charAt(i) != str.charAt(len - i - 1)) {
				return false;
			}
		}
		return true;
	}
}
