import java.awt.Point;
import java.awt.geom.Point2D;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;


public class Problem2 {

	public static void main(String[] args) {
		File file = new File(args[0]);
		File out;
		if (args[1] != null)
			out = new File(args[1]);
	    else
			out = new File("A-small.out");
		FileReader fr = null;
		FileWriter fw = null;
		try {
			fw = new FileWriter(out);
			fr = new FileReader(file);
		} catch (FileNotFoundException e) {
			file = new File(System.getProperty("user.dir"));
			try {
				fr = new FileReader(file);
			} catch (FileNotFoundException e1) {
				e1.printStackTrace();
				return;
			}
		} catch (IOException e) {
			e.printStackTrace();
			return;
		}
		BufferedReader br = new BufferedReader(fr);
		
		try {
			String line = br.readLine();
			int n = Integer.parseInt(line);
			for (int i = 0; i < n; i++) {
				String result = "Case #" + (i+1) + ": ";
				line = br.readLine();
				int turnaround = Integer.parseInt(line);
				line = br.readLine();
				String[] values = line.split(" ");
				int NA = Integer.parseInt(values[0]);
				int NB = Integer.parseInt(values[1]);
				
				int[] depA = new int[NA];
				int[] depB = new int[NB];
				int[] readyA = new int[NB];
				int[] readyB = new int[NA];
				
				for (int j = 0; j < NA; j++) {
					line = br.readLine();
					String[] times = line.split(" ");
					depA[j] = getValue(times[0]);
					readyB[j] = getValue(times[1]) + turnaround;
				}
				Arrays.sort(depA);
				Arrays.sort(readyB);
				
				for (int j = 0; j < NB; j++) {
					line = br.readLine();
					String[] times = line.split(" ");
					depB[j] = getValue(times[0]);
					readyA[j] = getValue(times[1]) + turnaround;
				}
				Arrays.sort(depB);
				Arrays.sort(readyA);
				
				int A = 0;
				int B = 0;
				
				for (int j = 0; j < NA && A < NB; j++) {
					if (depA[j] >= readyA[A])
						A++;
				}
				for (int j = 0; j < NB && B < NA; j++) {
					if (depB[j] >= readyB[B])
						B++;
				}				
				
				result += (NA - A) + " " + (NB - B);
				
				result += System.getProperty("line.separator");
				fw.write(result);
			}
			fw.close();
			fr.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}

	public static int getValue(String time) {
		String[] temp = time.split("\\:");
		int ret = Integer.parseInt(temp[0]) * 60 + Integer.parseInt(temp[1]);
		return ret;
	}
}
