import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


public class Problem2 {

	public static void main(String[] args) {
		File file = new File(args[0]);
		File out;
		if (args[1] != null)
			out = new File(args[1]);
	    else
			out = new File("A-small.out");
		FileReader fr = null;
		FileWriter fw = null;
		try {
			fw = new FileWriter(out);
			fr = new FileReader(file);
		} catch (FileNotFoundException e) {
			file = new File(System.getProperty("user.dir"));
			try {
				fr = new FileReader(file);
			} catch (FileNotFoundException e1) {
				e1.printStackTrace();
				return;
			}
		} catch (IOException e) {
			e.printStackTrace();
			return;
		}
		BufferedReader br = new BufferedReader(fr);
		
		try {
			String line = br.readLine();
			int n = Integer.parseInt(line);
			for (int i = 0; i < n; i++) {
				String result = "Case #" + (i+1) + ": ";
				line = br.readLine();
				String[] values = line.split(" ");
				
				int A = Integer.parseInt(values[0]);
				int B = Integer.parseInt(values[1]);
				int P = Integer.parseInt(values[2]);
				
				ArrayList<Integer> primes = getPrimes(P, B);
				
				int[] group = new int[B - A + 1];
				for (int j = 0; j < B-A+1; j++) {
					group[j] = j;
				}
				
				for (int j = A; j < B; j++) {
					for (int k = j + 1; k < B+1; k++) {
						if (join(j, k, primes)) {
							for (int r = 0; r < B-A+1; r++) {
								if (group[r] == group[k-A])
									group[r] = group[j-A];
							}
						}
					}
				}
				
				int cont = 0;
				for (int j = 0; j < B-A+1;j++) {
					if (group[j] != -1) {
						cont++;
						for (int k = j+1; k < B-A+1;k++) {
							if (group[k] == group[j])
								group[k] = -1;
						}
						group[j] = -1;
					}
				}
				
				result += cont;
				
				result += System.getProperty("line.separator");
				fw.write(result);
			}
			fw.close();
			fr.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	
	static boolean join(int j, int k, ArrayList<Integer> primes) {
		Iterator<Integer> a = primes.iterator();
		while (a.hasNext()) {
			int temp = a.next().intValue();
			if (j % temp == 0 && k % temp == 0)
				return true;
		}
		
		return false;
	}
	
	static ArrayList<Integer> getPrimes(int P, int B) {
		ArrayList<Integer> a = new ArrayList<Integer>();
		boolean[] temp = new boolean[B + 1];
		for (int i = 2; i < B + 1; i++) {
			if (!temp[i] && i >= P)
				a.add(new Integer(i));
			if (!temp[i])
				for (int j = i+i; j < B+1; j+=i) {
					temp[j] = true;
				}
		}
		return a;
	}
	
	
	
}
