import java.awt.Point;
import java.awt.geom.Point2D;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class Problem1 {

	public static void main(String[] args) {
		File file = new File(args[0]);
		File out;
		if (args.length > 1)
			out = new File(args[1]);
	    else
			out = new File("A-small.out");
		FileReader fr = null;
		FileWriter fw = null;
		try {
			fw = new FileWriter(out);
			fr = new FileReader(file);
		} catch (FileNotFoundException e) {
			file = new File(System.getProperty("user.dir"));
			try {
				fr = new FileReader(file);
			} catch (FileNotFoundException e1) {
				e1.printStackTrace();
				return;
			}
		} catch (IOException e) {
			e.printStackTrace();
			return;
		}
		BufferedReader br = new BufferedReader(fr);
		
		try {
			String line = br.readLine();
			int n = Integer.parseInt(line);
			for (int i = 0; i < n; i++) {
				String result = "Case #" + (i+1) + ": ";
				line = br.readLine();
				int nEngines = Integer.parseInt(line);
				Map<String, Integer> enginesMap = new HashMap<String, Integer>();
				for (int j = 0; j < nEngines; j++) {
					line = br.readLine();
					enginesMap.put(line, j);
				}
				line = br.readLine();
				int nSearches = Integer.parseInt(line);
				int[] searches = new int[nSearches];
				for (int j = 0; j< nSearches; j++) {
					line = br.readLine();
					searches[j] = enginesMap.get(line);
				}
				
				int pos = 0;
				int switches = 0;
				int value = 0;
				
				for (int j = 0; j < nEngines; j++) {
					int temp = appears(j, 0, searches, nSearches);
					if (temp > pos) {
						pos = temp;
						value = j;
					}
				}
				
				while (pos < nSearches) {
					int max = pos;
					for (int j = 0; j < nEngines; j++) {
						int temp = appears(j, pos, searches, nSearches);
						if (temp > max) {
							max = temp;
							value = j;
						}
					}
					pos = max;
					switches ++;
				}
	
				
				
				result += switches;
				result += System.getProperty("line.separator");
				fw.write(result);
			}
			fw.close();
			fr.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	
	private static int appears(int value, int from, int[] list, int size) {
		while (from < size) {
			if (list[from] == value)
				break;
			from++;
		}
		return from;
	}
}
