package google.code.jam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.StringTokenizer;

public class TrainTimeTable {
    public static void main(String[] args) throws FileNotFoundException,
            IOException, ParseException {
        FileInputStream fis = new FileInputStream("C:\\B-large.in");
        FileOutputStream fos = new FileOutputStream("C:\\B-large.out");

        InputStreamReader isr = new InputStreamReader(fis);
        OutputStreamWriter osw = new OutputStreamWriter(fos);
        BufferedReader br = new BufferedReader(isr);
        BufferedWriter wr = new BufferedWriter(osw);

        int numOfCase = Integer.parseInt(br.readLine());

        for (int i = 0; i < numOfCase; i++) {
            String text;
            StringTokenizer token;
            SimpleDateFormat sdf = new SimpleDateFormat("HH:mm");

            // load file data
            int turnaround = Integer.parseInt(br.readLine());

            text = br.readLine();
            token = new StringTokenizer(text);
            int numOfA2B = Integer.parseInt(token.nextToken());
            int numOfB2A = Integer.parseInt(token.nextToken());

            ArrayList<Date[]> scheduleOfA2B = new ArrayList<Date[]>();
            for (int j = 0; j < numOfA2B; j++) {
                text = br.readLine();
                token = new StringTokenizer(text);
                Date depart = sdf.parse(token.nextToken());
                Date arrive = sdf.parse(token.nextToken());
                scheduleOfA2B.add(new Date[] { depart, arrive });
            }

            ArrayList<Date[]> scheduleOfB2A = new ArrayList<Date[]>();
            for (int j = 0; j < numOfB2A; j++) {
                text = br.readLine();
                token = new StringTokenizer(text);
                Date depart = sdf.parse(token.nextToken());
                Date arrive = sdf.parse(token.nextToken());
                scheduleOfB2A.add(new Date[] { depart, arrive });
            }

            // processing
            int numOfTrainA2B = 0;
            int numOfTrainB2A = 0;
            Collections.sort(scheduleOfA2B, new ScheduleComparator());
            Collections.sort(scheduleOfB2A, new ScheduleComparator());
            while (scheduleOfA2B.size() > 0 || scheduleOfB2A.size() > 0) {
                if (scheduleOfA2B.size() == 0) {
                    numOfTrainB2A += scheduleOfB2A.size();
                    scheduleOfB2A.clear();
                } else if (scheduleOfB2A.size() == 0) {
                    numOfTrainA2B += scheduleOfA2B.size();
                    scheduleOfA2B.clear();
                } else {
                    if (scheduleOfA2B.get(0)[0].getTime() < scheduleOfB2A
                            .get(0)[0].getTime()) {
                        numOfTrainA2B++;
                        remove(scheduleOfA2B.get(0), scheduleOfA2B,
                                scheduleOfB2A, turnaround);
                    } else {
                        numOfTrainB2A++;
                        remove(scheduleOfB2A.get(0), scheduleOfB2A,
                                scheduleOfA2B, turnaround);
                    }
                }
            }

            // output
            wr.write("Case #" + (i + 1) + ": " + numOfTrainA2B + " "
                    + numOfTrainB2A + "\r\n");
            wr.flush();
        }
        fis.close();
        fos.close();
    }

    private static void remove(Date[] d, ArrayList<Date[]> schedule1,
            ArrayList<Date[]> schedule2, int turnaround) {
        schedule1.remove(d);
        for (Date[] schedule : schedule2) {
            if (d[1].getTime() + turnaround * 60 * 1000 <= schedule[0]
                    .getTime()) {
                remove(schedule, schedule2, schedule1, turnaround);
                return;
            }
        }
    }
}

class ScheduleComparator implements Comparator<Date[]> {
    @Override
    public int compare(Date[] o1, Date[] o2) {
        if (o1[0].getTime() < o2[0].getTime()) {
            return -1;
        } else if (o1[0].getTime() == o2[0].getTime()) {
            return 0;
        } else {
            return 1;
        }
    }
}