package infinitehouseofpancakes;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;
import java.util.TreeMap;

public class Main {

	
	
	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new FileInputStream("../A-small-attempt1.in"));
		
		int numofcases = Integer.parseInt(sc.nextLine());
		
		for(int i = 0; i < numofcases; i++) {
			// tree
			List<Case> tree = new LinkedList<>();
			
			// all the ones already seen
			TreeMap<Integer, Integer> seen = new TreeMap<>();
			
			String s = sc.nextLine();
			String[] parts = s.split(" ", 2);
			
			String pancakes = parts[0];
			int size = Integer.parseInt(parts[1]);
			
			Case c = new Case(Case.getBoolsFromStr(pancakes), size, 0);
			tree.add(c);
			
			Case solution = null;
			
//			System.out.println(s);
			
			if(size == 1) {
				System.out.println("Case #" + (i + 1) + ": " + c.getUpCount()); 
			}
				
			outer:
			for(int j = 0; j < size * 3; j ++) {
				LinkedList<Case> toadd =  new LinkedList<>();
				for(Case ch : tree) {
					if(ch.isSolved()) {
						solution = ch;
						break outer;
					}
					
					if(ch.getUpCount() == ch.sides.length - 1)
						break outer;
					
					ch.addPermutationsTo(toadd);
				}
				tree.addAll(toadd);
		//		System.out.println(tree);
				
				
				// inefficient /shrug
				Collections.sort(tree);
				
				// prevent concurrent modification
				LinkedList<Case> toremove = new LinkedList<>();
				
				for(Case cs : tree) {
					if(seen.containsKey(cs.hashCode())) {
						if(seen.get(cs.hashCode()).intValue() < cs.flips)
							toremove.add(cs);
					} else seen.put(cs.hashCode(), cs.flips);
				}
				
				tree.removeAll(toremove);
				
				if(tree.size() > size * 10)
					tree = tree.subList(0, size * 10);
				
	//			System.out.println(tree);
			}
			
			if(solution == null) {
				System.out.println("Case #" + (i + 1) + ": IMPOSSIBLE"); 
			} else {
				System.out.println("Case #" + (i + 1) + ": " + solution.flips); 
			}
		}
		
		sc.close();
	}

}
