import java.util.*;

public class Solution {
    private static Map<String, Integer> map;
    private static Map<String, Integer> cache;

    // 비트연산
    public static void main(String args[]) {
        Scanner s = new Scanner(System.in);
        int t = s.nextInt();
        for(int i = 0; i < t; i++) {
            cache = new HashMap<>();
            map = new HashMap<>();
            Integer answer = solve(s.next(), s.nextInt(), 0);
            if (answer == null) {
                System.out.printf("Case #%d: IMPOSSIBLE%n", i + 1);
            } else {
                System.out.printf("Case #%d: %d%n", i + 1,  answer);
            }
        }
    }

    static int cnt = 0;
    public static Integer solve(String line, int k, int depth) {
        String indent = indent(depth);

        System.err.println(indent + "Solving: " + line);

        if (cache.containsKey(line)) {
            return cache.get(line);
        }

        if (isHappy(line)) {
            return 0;
        }

        Integer lastDepth = map.get(line);
        if (lastDepth != null && lastDepth < depth) {
            return null;
        }
        map.put(line, depth);

        Integer min = null;
        for(int j = 0; j <= line.length() - k; j++){
            Integer value = solve(flip(line, j, k), k, depth + 1);

            if (value == null) continue;

            if (min == null) {
                min = value + 1;
            } else {
                System.err.printf(indent + "Comparing: %d %d%n", min, value + 1);
                min = Math.min(min, value + 1);
            }
        }

        System.err.println(indent + "Solved: " + min + " " + line);

        cache.put(line, min);

        return min;
    }

    private static String indent(int depth) {
        StringBuilder indentBuilder = new StringBuilder();
        for(int i = 0; i < depth; i++){
            indentBuilder.append(' ');
        }
        return indentBuilder.toString();
    }

    private static boolean isHappy(String line) {
        char[] chars = line.toCharArray();
        int i = 0;
        for(i = 0; i < chars.length; i++){
            if (chars[i] == '-') break;
        }
        if (i == chars.length) {
            return true;
        }
        return false;
    }

    // 한번 뒤집은 것과 세번 뒤집은 것은 같다.
    // 같은 위치를 두번 뒤집는 것은 아무 의미가 없다.
    // 순서를 거꾸로 돌아갈 필요가 있나 없나
    // loop detection?
    // graph
    // 최단거리
    public static String flip(String line, int index, int flipSize) {
        // System.err.printf("flip start: %s %d %d%n", line, index, flipSize);
        char[] chars = line.toCharArray();
        for(int i = index; i < index + flipSize; i++) {
            if (chars[i] == '+') {
                chars[i] = '-';
            } else {
                chars[i] = '+';
            }
        }
        String result = new String(chars);
        // System.err.printf("flip   end: %s %d %d%n", result, index, flipSize);
        return result;
    }
}
