import java.util.*;
import java.math.BigDecimal;
import java.math.RoundingMode;

public class Solution {
    private static boolean[] occupies;

    private static class Answer {
        public int max;
        public int min;
    }

    public static void main(String args[]) {
        Scanner s = new Scanner(System.in);
        int t = s.nextInt();
        for(int i = 0; i < t; i++) {
            Answer answer = solve3(s.nextInt(), s.nextInt());
            System.out.printf("Case #%d: %d %d%n", i + 1,  answer.max, answer.min);
        }
    }

    public static Answer solve3(int n, int k) {
        Map<Integer, Integer> spaces = new HashMap<>();
        spaces.put(n, 1);
        System.err.printf("Solving %d %d%n", n, k);
        while(k >= 0) {
            List<Integer> keys = new ArrayList<Integer>(spaces.keySet());
            Collections.sort(keys);
            Collections.reverse(keys);
            System.err.println("Trying.... size: " + spaces.size());
            for(Integer space : keys) {
                int count = spaces.get(space);

                System.err.printf("k %d space %d count %d%n", k, space, count);

                // count개 놓기
                spaces.remove(space);
                k -= count;
                if (k <= 0) {
                    return solve(space);
                }
                int a = (space - 1) / 2;
                int b = (space - 1) - a;
                addSpace(spaces, a, count);
                addSpace(spaces, b, count);
            }
        }
        throw new RuntimeException("계산 실패");
    }

    private static void addSpace(Map<Integer, Integer> spaces, int space, int count) {
        Integer oldCount = spaces.get(space);
        Integer totalCount = count;
        if (oldCount != null) {
            totalCount += oldCount;
        }
        spaces.put(space, totalCount);
    }

    // 반드시 반씩일 수 밖에 없다.
    // binary search
    // 매우 단순하게 생각해보자
    // 홀수: 3
    // 짝수: 4
    // 될 리가 없다...
    // 500 255일때
    // 1 0 이어야하는데 0 0이 나온다.
    public static Answer solve2(int n, int k) {
        int x = 1;
        int i = 1;
        // 최대 공간이 점점 줄어드는 것이다.
        // n=4, k=0일때 최대 공간은 4다.
        // n=4, k=1에서는 최대 공간 2
        // n=4, k=2에서는 최대 공간 1
        // n=4, k=3에서는 최대 공간 1
        // sqrt로 나눈것과 비슷한 값이다.
        /*
        while(x <= k) {
            x *= 2;
            i++;
        }
        */
        // n=5, k=0일때 5 .....
        // n=5, k=1일때 2 ..o..
        // n=5, k=2일때 2 o.o..
        // n=5, k=3일때 1 o.o.o
        // n=5, k=4일때 1 ooo.o
        // n=5, k=5일때 0 ooooo
        int space = n;
        while(x < k) {
            x *= 2;
            space /= 2; // space가 버림이라는 것에 따른 문제가 있다. 올림도 있고 버림도 있어야함
            i++;
        }
        Answer answer = solve(space);
        return answer;
    }

    public static Answer solve(int n, int k) {
        occupies = new boolean[n];
        Answer last = new Answer();
        for(int a = 0; a < k; a++) {
            Answer best = new Answer();

            int bestPos = 0;
            int start = -1;
            int i = 0;

            for(; i < occupies.length; i++) {
                boolean o = occupies[i];
                if (o) {
                    Answer answer = solve(i - 1 - start);
                    if (answer.min > best.min || (answer.min == best.min && answer.max > best.max)) {
                        best = answer;
                        bestPos = start + answer.min + 1;
                    }
                    start = i;
                }
            }

            // The last one
            System.err.printf("the last one: %d %d%n", occupies.length, start);
            Answer answer = solve(occupies.length - 1 - start);
            if (answer.min > best.min || (answer.min == best.min && answer.max > best.max)) {
                best = answer;
                bestPos = start + answer.min + 1;
            }

            occupies[bestPos] = true;
            // System.err.println(renderOccupies(occupies));
            System.err.println("bestPos: " + bestPos);
            System.err.printf("best: max: %d min: %d%n", best.max, best.min);
            last = best;
        }
        return last;
    }

    public static String renderOccupies(boolean[] occupies) {
        StringBuilder result = new StringBuilder();
        for(boolean o : occupies) {
            if (o) {
                result.append('O');
            } else {
                result.append('.');
            }
        }
        return result.toString();
    }

    // 굳이 필요없을것 같기도
    private static Map<Integer, Answer> cache = new HashMap<>();
    public static Answer solve(int consecutiveEmpties) {
        System.err.println("solve: consecutive: " + consecutiveEmpties);

        Answer cached = cache.get(consecutiveEmpties);
        if (cached != null) return cached;

        Answer answer = new Answer();

        if (consecutiveEmpties == 0) {
            answer.min = 0;
            answer.max = 0;
        } else {
            answer.min = (consecutiveEmpties - 1) / 2;
            answer.max = (consecutiveEmpties - 1) - answer.min;
        }

        System.err.printf("answer: consecutive: %d max: %d min: %d%n",
                consecutiveEmpties, answer.max, answer.min);

        cache.put(consecutiveEmpties, answer);

        return answer;
    }
}
