import java.util.*;

public class Solution {
    public static List<Integer> solve(Integer n, List<List<Integer>> ls) {
        Collections.sort(ls, new Comparator<List<Integer>>() {
            public int compare(List<Integer> a, List<Integer> b) {
                for(int i = 0; i < a.size(); i++) {
                    if (a.get(i) > b.get(i)) {
                        return 1;
                    } else if (b.get(i) > a.get(i)) {
                        return -1;
                    }
                }
                return 0;
            }
        });

        // debug
        // n이거나 n-1로 나올 것이다. n-1이라면 빠져있는쪽이다.
        List<List<Integer>> as = new ArrayList<>();
        List<List<Integer>> bs = new ArrayList<>();
        for(List<Integer> l : ls) {
            if (as.size() == 0) {
                as.add(l);
            } else {
                List<Integer> last = as.get(as.size() - 1);
                boolean add = true;
                for(int i = 0; i < last.size(); i++) {
                    if (last.get(i) >= l.get(i)) {
                        add = false;
                        break;
                    }
                }
                if (add) {
                    as.add(l);
                } else {
                    bs.add(l);
                }
            }
        }

        List<List<Integer>> rs;
        List<List<Integer>> cs;
        if (as.size() > bs.size()) {
            rs = as;
            cs = bs;
        } else {
            rs = bs;
            cs = as;
        }

        // debug
        System.err.println("debug1");
        for(List<Integer> r : rs) {
            System.err.println(r);
        }

        // Find the missing one
        Set<List<Integer>> set = new HashSet<>(cs);
        for(int i = 0; i < n; i++) {
            List<Integer> v = new ArrayList<>();
            for(int j = 0; j < n; j++) {
                v.add(rs.get(j).get(i));
            }
            if (!set.contains(v)) {
                return v;
            }
        }

        throw new RuntimeException("error!");
    }

    public static void main(String args[]) {
        Scanner sc = new Scanner(System.in);
        // 전체에서 n개를 뽑아 맞는지 확인한다. 기껏해야 O(2^n)
        // 맞는지 확인하는 법: 나머지는 column들이거나 row들일 것이므로 90도 돌려본다.
        // 그냥 복원된 리스트를 row들로 간주하고, column들 리스트를 생성해낸뒤 빠진 것이 뭔지 확인한다.
        // 걍 정렬해도 되지 않나? -> 안된다. colum과 row가 섞인다.
        // 정렬은 하고 조건에 안 맞으면 skip하면 되지 않을까

        int t = sc.nextInt();
        for(int k = 0; k < t; k++) {
            int n = sc.nextInt();
            List<List<Integer>> ls = new ArrayList<>();
            for(int i = 0; i < n * 2 - 1; i++) {
                List<Integer> l = new ArrayList<>();
                for(int j = 0; j < n; j++) {
                    l.add(sc.nextInt());
                }
                ls.add(l);
            }

            List<Integer> ans = solve(n, ls);
            System.out.printf("Case #%d:", k + 1);
            for(Integer a : ans) {
                System.out.print(" " + a);
            }
            System.out.println("");
        }
    }
}
