import java.util.*;
import java.math.BigDecimal;
import java.math.RoundingMode;

public class Solution {
    private static boolean[] occupies;

    private static class Answer {
        public BigDecimal max;
        public BigDecimal min;
    }

    public static void main(String args[]) {
        Scanner s = new Scanner(System.in);
        int t = s.nextInt();
        for(int i = 0; i < t; i++) {
            Answer answer = solve4(new BigDecimal(s.next()), new BigDecimal(s.next()));
            System.out.printf("Case #%d: %s %s%n", i + 1,  answer.max, answer.min);
        }
    }

    public static Answer solve4(BigDecimal n, BigDecimal k) {
        Map<BigDecimal, BigDecimal> spaces = new HashMap<>();
        spaces.put(n, BigDecimal.valueOf(1));
        System.err.printf("Solving %s %s%n", n, k);

        BigDecimal one = BigDecimal.valueOf(1);
        BigDecimal two = BigDecimal.valueOf(2);

        while(k.compareTo(BigDecimal.valueOf(0)) >= 0) {
            List<BigDecimal> keys = new ArrayList<BigDecimal>(spaces.keySet());
            Collections.sort(keys);
            Collections.reverse(keys);
            System.err.println("Trying.... size: " + spaces.size());
            for(BigDecimal space : keys) {
                BigDecimal count = spaces.get(space);

                System.err.printf("k %s space %s count %s%n", k, space, count);

                // count개 놓기
                spaces.remove(space);
                k = k.subtract(count);
                BigDecimal a = space.subtract(one).divide(two, 0, RoundingMode.FLOOR);
                BigDecimal b = space.subtract(one).subtract(a);
                if (k.compareTo(BigDecimal.valueOf(0)) <= 0) {
                    Answer answer = new Answer();
                    answer.min = a.min(a);
                    answer.max = a.max(b);
                    return answer;
                }
                addSpace(spaces, a, count);
                addSpace(spaces, b, count);
            }
        }

        throw new RuntimeException("계산 실패");
    }

    private static void addSpace(Map<BigDecimal, BigDecimal> spaces, BigDecimal space, BigDecimal count) {
        BigDecimal oldCount = spaces.get(space);
        BigDecimal totalCount = count;
        if (oldCount != null) {
            totalCount = totalCount.add(oldCount);
        }
        spaces.put(space, totalCount);
    }
}
