import java.util.*;

public class Solution {
    private static boolean[] occupies;

    private static class Answer {
        public int max;
        public int min;
    }

    public static void main(String args[]) {
        Scanner s = new Scanner(System.in);
        int t = s.nextInt();
        for(int i = 0; i < t; i++) {
            Answer answer = solve(s.nextInt(), s.nextInt());
            System.out.printf("Case #%d: %d %d%n", i + 1,  answer.max, answer.min);
        }
    }

    public static Answer solve(int n, int k) {
        occupies = new boolean[n];
        Answer last = new Answer();
        for(int a = 0; a < k; a++) {
            Answer best = new Answer();

            int bestPos = 0;
            int start = -1;
            int i = 0;

            for(; i < occupies.length; i++) {
                boolean o = occupies[i];
                if (o) {
                    Answer answer = solve(i - 1 - start);
                    if (answer.min > best.min || (answer.min == best.min && answer.max > best.max)) {
                        best = answer;
                        bestPos = start + answer.min + 1;
                    }
                    start = i;
                }
            }

            // The last one
            System.err.printf("the last one: %d %d%n", occupies.length, start);
            Answer answer = solve(occupies.length - 1 - start);
            if (answer.min > best.min || (answer.min == best.min && answer.max > best.max)) {
                best = answer;
                bestPos = start + answer.min + 1;
            }

            occupies[bestPos] = true;
            System.err.println(renderOccupies(occupies));
            System.err.println("bestPos: " + bestPos);
            System.err.printf("best: max: %d min: %d%n", best.max, best.min);
            last = best;
        }
        return last;
    }

    public static String renderOccupies(boolean[] occupies) {
        StringBuilder result = new StringBuilder();
        for(boolean o : occupies) {
            if (o) {
                result.append('O');
            } else {
                result.append('.');
            }
        }
        return result.toString();
    }

    public static Answer solve(int consecutiveEmpties) {
        System.err.println("solve: consecutive: " + consecutiveEmpties);
        Answer answer = new Answer();
        if (consecutiveEmpties == 0) {
            answer.min = 0;
            answer.max = 0;
        } else {
            answer.min = (consecutiveEmpties - 1) / 2;
            answer.max = (consecutiveEmpties - 1) - answer.min;
        }
        System.err.printf("answer: consecutive: %d max: %d min: %d%n",
                consecutiveEmpties, answer.max, answer.min);
        return answer;
    }
}
