package ru.eustas;

import sun.plugin.javascript.navig.Array;

import java.io.*;
import java.nio.channels.NonReadableChannelException;
import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: 07.05.11
 * Time: 14:50
 */

public class ProblemB {
    private BufferedReader in;
    private BufferedWriter out;

    public static void main(String[] args) throws IOException {
        new ProblemB().run();
    }

    private void run() throws IOException {
        FileReader reader = new FileReader("b.in");
        in = new BufferedReader(reader);
        FileWriter writer = new FileWriter("b.out");
        out = new BufferedWriter(writer);

        Locale.setDefault(Locale.ENGLISH);

        int n = Integer.parseInt(in.readLine());
        for (int i = 0; i < n; i++) {
            out.write("Case #" + (i + 1) + ": ");
            runCase();
        }

        in.close();
        out.close();
    }

    private void runCase() throws IOException {
        String line = in.readLine();
        String[] split = line.split(" ");
        ArrayList<String> spl = new ArrayList<String>();
        Collections.addAll(spl, split);
        Iterator<String> iterator = spl.iterator();
        int L = Integer.parseInt(iterator.next());
        long t = Long.parseLong(iterator.next());
        int N = Integer.parseInt(iterator.next());
        int C = Integer.parseInt(iterator.next());

        final long dist[] = new long[C];
        final long boost[] = new long[C + 1];
        int cnt1[] = new int[C + 1];
        int cnt2[] = new int[C + 1];
        int cnt3[] = new int[C + 1];

        PriorityQueue<Integer> best = new PriorityQueue<Integer>(C, new Comparator<Integer>() {
            @Override
            public int compare(Integer o1, Integer o2) {
                if (boost[o1] < boost[o2]) {
                    return 1;
                } else if (boost[o1] == boost[o2]) {
                    return 0;
                }
                return -1;
            }
        });
        for (int i = 0; i < C; i++) {
            dist[i] = Long.parseLong(iterator.next());
            boost[i] = dist[i];
        }

        long tNow = 0;
        int j = 0;
        boolean canBoost = false;
        for (int i = 0; i < N; i++) {
            cnt1[j]++;
            if (canBoost) {
                cnt2[j]++;
            }
            long diff = t - tNow;
            long delta = dist[j] + dist[j];
            if (!canBoost) {
                if (diff < delta) {
                    cnt2[C] = 1;
                    boost[C] = dist[j] - (diff / 2);
                    canBoost = true;
                } else if (diff == delta) {
                    canBoost = true;
                } else {
                    tNow = tNow + delta;
                }
            }
            j++;
            if (j == C) {
                j = 0;
            }
        }

        for (int i = 0; i < C + 1; i++) {
            best.add(i);
        }

        while ((L > 0) && !best.isEmpty()) {
            Integer poll = best.poll();
            int minus = Math.min(L, cnt2[poll]);
            cnt3[poll] = minus;
            L = L - minus;
        }
        long sum = 0;
        for (int i = 0; i < C; i++) {
            long k = cnt1[i] + cnt1[i];
            long l = dist[i];
            sum = sum + k * l;
        }
        for (int i = 0; i < C + 1; i++) {
            long k = cnt3[i];
            long l = boost[i];
            sum = sum - k * l;
        }

        out.append(Long.toString(sum));
        out.newLine();
    }
}