package ru.eustas;

import sun.java2d.ScreenUpdateManager;

import java.io.*;
import java.lang.management.ThreadInfo;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Locale;

/**
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: 07.05.11
 * Time: 14:50
 */

public class ProblemA {
    private BufferedReader in;
    private BufferedWriter out;

    public static void main(String[] args) throws IOException {
        new ProblemA().run();
    }

    private void run() throws IOException {
        FileReader reader = new FileReader("a.in");
        in = new BufferedReader(reader);
        FileWriter writer = new FileWriter("a.out");
        out = new BufferedWriter(writer);

        Locale.setDefault(Locale.ENGLISH);

        int n = Integer.parseInt(in.readLine());
        for (int i = 0; i < n; i++) {
            out.write("Case #" + (i + 1) + ": ");
            runCase();
        }

        in.close();
        out.close();
    }

    private static class BEw {
        int B;
        int E;
        int w;

        private BEw(int b, int e, int w) {
            B = b;
            E = e;
            this.w = w;
        }
    }

    private void runCase() throws IOException {
        String line = in.readLine();
        String[] split = line.split(" ");

        int X = Integer.parseInt(split[0]);
        int S = Integer.parseInt(split[1]);
        int R = Integer.parseInt(split[2]);
        double t = Integer.parseInt(split[3]);
        int N = Integer.parseInt(split[4]);

        ArrayList<BEw> bew = new ArrayList<BEw>();
        for (int i = 0; i < N; i++) {
            line = in.readLine();
            split = line.split(" ");
            int B = Integer.parseInt(split[0]);
            int E = Integer.parseInt(split[1]);
            int w = Integer.parseInt(split[2]);
            bew.add(new BEw(B,E,w));
        }
        Collections.sort(bew, new Comparator<BEw>() {
            @Override
            public int compare(BEw o1, BEw o2) {
                if (o1.B > o2.B) {
                    return 1;
                } else {
                    return -1;
                }
            }
        });
        double sum = 0.0;
        int now = 0;
        for (BEw item : bew) {
            int b = item.B;
            if (b > now) {
                int diff = b - now;
                if (t > 0) {
                    if (t * R >= diff) {
                        double ti = diff / (R + 0.0);
                        t -= ti;
                        sum += ti;
                    } else {
                        sum += t;
                        sum += (diff - t * R) / (S + 0.0);
                        t = 0;
                    }
                } else {
                    sum += diff / (S + 0.0);
                }
            }
            int e = item.E;
            int diff = e - b;
            now = e;
            int w = item.w;
            if (t > 0) {
                if (t * (R + w) >= diff) {
                    double ti = diff / (R + w + 0.0);
                    t -= ti;
                    sum += ti;
                } else {
                    sum += t;
                    sum += (diff - t * (R + w)) / (S + w + 0.0);
                    t = 0;
                }
            } else {
                sum += diff / (S + w + 0.0);
            }
        }

        if (X > now) {
            int diff = X - now;
            if (t > 0) {
                if (t * R > diff) {
                    double ti = diff / (R + 0.0);
                    t -= ti;
                    sum += ti;
                } else {
                    t = 0;
                    sum += t;
                    sum += (diff - t * R) / (S + 0.0);
                }
            } else {
                sum += diff / (S + 0.0);
            }
        }

        out.append(String.format("%.9f", sum));
        out.newLine();
    }
}