package ru.eustas;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;

public class ProbB {
    private static int[][] maps;

    private static class XY {
        int x;
        int y;

        public XY(int x, int y) {
            this.x = x;
            this.y = y;
        }
    }

    public static void main(String[] args) throws IOException {
        FileReader reader = new FileReader(new File("B-small.in"));
        FileWriter writer = new FileWriter(new File("B-small.out"));
        BufferedReader in = new BufferedReader(reader);
        int N = Integer.valueOf(in.readLine());
        for (int n = 0; n < N; n++) {
            String[] split = in.readLine().split(" ");
            int H = Integer.valueOf(split[0]);
            int W = Integer.valueOf(split[1]);
            maps = new int[W + 2][H + 2];
            char[][] basins = new char[W + 2][H + 2];
            for (int w = 0; w < W + 2; w++) {
                for (int h = 0; h < H + 2; h++) {
                    maps[w][h] = 10000000;
                    basins[w][h] = ' ';
                }
            }
            for (int h = 1; h < H + 1; h++) {
                split = in.readLine().split(" ");
                for (int w = 1; w < W + 1; w++) {
                    maps[w][h] = Integer.parseInt(split[w - 1]);
                }
            }
            char basin = 'a';
            for (int h = 1; h < H + 1; h++) {
                for (int w = 1; w < W + 1; w++) {
                    if (basins[w][h] != ' ') {
                        continue;
                    }
                    XY xy = new XY(w, h);
                    while (true) {
                        XY nxt = drain(xy);
                        if (nxt == null) {
                            break;
                        }
                        xy = nxt;
                    }
                    LinkedList<XY> q = new LinkedList<XY>();
                    basins[xy.x][xy.y] = basin;
                    q.addLast(xy);
                    while (!q.isEmpty()) {
                        xy = q.pollFirst();
                        if (xy.y > 1) {
                            if (basins[xy.x][xy.y - 1] == ' ') {
                                XY tr = new XY(xy.x, xy.y - 1);
                                XY drain = drain(tr);
                                if (drain != null) {
                                    if ((drain.x == xy.x) && (drain.y == xy.y)) {
                                        basins[tr.x][tr.y] = basin;
                                        q.addLast(tr);
                                    }
                                }
                            }
                        }
                        if (xy.x > 1) {
                            if (basins[xy.x - 1][xy.y] == ' ') {
                                XY tr = new XY(xy.x - 1, xy.y);
                                XY drain = drain(tr);
                                if (drain != null) {
                                    if ((drain.x == xy.x) && (drain.y == xy.y)) {
                                        basins[tr.x][tr.y] = basin;
                                        q.addLast(tr);
                                    }
                                }
                            }
                        }
                        if (xy.y < H) {
                            if (basins[xy.x][xy.y + 1] == ' ') {
                                XY tr = new XY(xy.x, xy.y + 1);
                                XY drain = drain(tr);
                                if (drain != null) {
                                    if ((drain.x == xy.x) && (drain.y == xy.y)) {
                                        basins[tr.x][tr.y] = basin;
                                        q.addLast(tr);
                                    }
                                }
                            }
                        }
                        if (xy.x < W) {
                            if (basins[xy.x + 1][xy.y] == ' ') {
                                XY tr = new XY(xy.x + 1, xy.y);
                                XY drain = drain(tr);
                                if (drain != null) {
                                    if ((drain.x == xy.x) && (drain.y == xy.y)) {
                                        basins[tr.x][tr.y] = basin;
                                        q.addLast(tr);
                                    }
                                }
                            }
                        }
                    }
                    basin++;
                }
            }

            writer.append("Case #" + String.valueOf(n + 1) + ":\n");
            for (int h = 1; h < H + 1; h++) {
                for (int w = 1; w < W + 1; w++) {
                    if (w != 1) {
                        writer.append(" ");
                    }
                    writer.append(basins[w][h]);
                }
                writer.append("\n");
            }
        }
        reader.close();
        writer.close();
    }

    private static XY drain(XY from) {
        int best = maps[from.x][from.y];
        XY result = null;
        int nxt = maps[from.x][from.y - 1];
        if (nxt < best) {
            result = new XY(from.x, from.y - 1);
            best = nxt;
        }
        nxt = maps[from.x - 1][from.y];
        if (nxt < best) {
            result = new XY(from.x - 1, from.y);
            best = nxt;
        }
        nxt = maps[from.x + 1][from.y];
        if (nxt < best) {
            result = new XY(from.x + 1, from.y);
            best = nxt;
        }
        nxt = maps[from.x][from.y + 1];
        if (nxt < best) {
            result = new XY(from.x, from.y + 1);
            best = nxt;
        }
        return result;
    }
}