import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Locale;
import java.util.Scanner;

public abstract class Template {

	public void start() {
		try {
			Locale.setDefault(Locale.US);

			BufferedReader in = new BufferedReader(new FileReader(getStorage()
					+ getTask() + getInSuffix()));
			Scanner ins = new Scanner(in);
			BufferedWriter out = new BufferedWriter(new FileWriter(getStorage()
					+ getTask() + getOutSuffix()));
			int n = Integer.parseInt(in.readLine());
			for (int i = 0; i < n; i++) {
				String caseN = "Case #" + String.valueOf(i + 1) + ":";
				System.out.println(caseN);
				out.append(caseN);
				runCase(ins, out);
			}
			out.flush();
			out.close();
			in.close();
		} catch (IOException e) {
			e.printStackTrace(System.out);
		}
	}

	public abstract void runCase(Scanner in, BufferedWriter out) throws IOException;

	public String getStorage() {
		//return "c:\\";
		return "/workspace/work/eclipse.workspace/Google/src/";
	}

	public String getTask() {
		return "current";
	}

	public String getInSuffix() {
		return ".in";
	}

	public String getOutSuffix() {
		return ".out";
	}

}
