package rueustas;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Locale;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class ProbB {
    private FileReader reader;
    private FileWriter writer;
    private BufferedReader in;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.ENGLISH);
        new ProbB().run();
    }

    private void run() throws IOException {
        reader = new FileReader(new File("b.in"));
        writer = new FileWriter(new File("b.out"));
        in = new BufferedReader(reader);
        solve();
        reader.close();
        writer.close();
    }

    private void solve() throws IOException {
        String tStr = in.readLine();
        int T = Integer.parseInt(tStr);
        for (int t = 1; t <= T; t++) {
            String str = in.readLine();
            StringTokenizer tokenizer = new StringTokenizer(str);
            tokenizer.nextToken();
            TreeSet<BigInteger> numbers = new TreeSet<BigInteger>();
            while (tokenizer.hasMoreTokens()) {
				String token = tokenizer.nextToken();
				numbers.add(new BigInteger(token));
			}
            BigInteger globalMin = numbers.first();
            TreeSet<BigInteger> newNumbers = new TreeSet<BigInteger>();            
            for (BigInteger curr : numbers) {
				if (!curr.equals(globalMin)) {
					newNumbers.add(curr.subtract(globalMin));
				}
			}
            BigInteger gcd = newNumbers.first();
            for (BigInteger curr : newNumbers) {
				gcd = gcd.gcd(curr);
			}
            BigInteger diff = globalMin.mod(gcd);
            if (!diff.equals(BigInteger.ZERO)) {
            	diff = gcd.subtract(diff);
            }
            
            writer.append("Case #" + String.valueOf(t) + ": " + diff + "\r\n");
        }
    }
}