package ru.eustas;

import java.io.*;
import java.util.Locale;

/**
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: 07.05.11
 * Time: 14:50
 */

public class ProblemA {
    private BufferedReader in;
    private BufferedWriter out;

    public static void main(String[] args) throws IOException {
        new ProblemA().run();
    }

    private void run() throws IOException {
        FileReader reader = new FileReader("a.in");
        in = new BufferedReader(reader);
        FileWriter writer = new FileWriter("a.out");
        out = new BufferedWriter(writer);

        Locale.setDefault(Locale.ENGLISH);

        int n = Integer.parseInt(in.readLine());
        for (int i = 0; i < n; i++) {
            out.write("Case #" + (i + 1) + ": ");
            runCase();
        }

        in.close();
        out.close();
    }

    private void runCase() throws IOException {
        String line = in.readLine();
        String[] split = line.split(" ");

        int r = Integer.parseInt(split[0]);
        int c = Integer.parseInt(split[1]);

        char map[][] = new char[r + 2][c + 2];

        for (int i = 0; i < r + 2; i++) {
            for (int j = 0; j < c + 2; j++) {
                map[i][j] = '+';
            }
        }

        for (int i = 1; i <= r; i++) {
            line = in.readLine();
            for (int j = 1; j <= c; j++) {
                map[i][j] = line.charAt(j - 1);
            }
        }
        boolean bad = false;
        outer:
        for (int i = 1; i <= r; i++) {
            for (int j = 1; j <= c; j++) {
                if (map[i][j] != '#') {
                    continue;
                }
                if ((map[i+1][j] != '#') || (map[i][j+1] != '#') || (map[i+1][j +1] != '#')) {
                    bad = true;
                    break outer;
                }
                map[i][j] = '/';
                map[i+1][j+1] = '/';
                map[i][j+1] = '\\';
                map[i+1][j] = '\\';
            }
        }
        out.newLine();
        if (bad) {
            out.append("Impossible");
            out.newLine();
        } else {
            for (int i = 1; i <=r; i++) {
                for (int j = 1; j <=c; j++) {
                    out.append(map[i][j]);
                }
                out.newLine();
            }
        }
    }
}