package qualification;

import java.io.*;
import java.util.*;
import java.math.*;
import java.text.*;

public class CandySplitting
{
	static DecimalFormat DF = new DecimalFormat("0.000",
			new DecimalFormatSymbols(Locale.ENGLISH));

	// find smallest element in int array
	public static int min(int[] a, int... reject) {
	    int res = Integer.MAX_VALUE;
	    for (int i = 0; i < a.length; i++) {
	        boolean skip = false;
	        for (int r : reject) {
	            if (i == r) {
	                skip = true;
	                break;
	            }
	        }
	        if (!skip) {
	            res = Math.min(a[i], res);
	        }
	    }
	    return res;
	}

	public static void run() throws Exception
	{
		init("C-large");

		// small: 1 <= T <= 100
		int cases = INT();
		for (int cc = 1; cc <= cases; cc++)
		{
			/* INPUT */
			// for each case/row
			int N = INT(); // number of candies in bag
			int[] row = new int[N];
			int result = 0, total = 0;
			for (int i = 0; i < N; i++)
			{
				row[i] = INT();
				result ^= row[i];
				total += row[i];
			}

			if (result != 0)
			{
				/* OUTPUT */
				println("Case #" + cc + ": " + "NO");
				continue;
			}
			else if (result == 0)
			{
				/* OUTPUT */
				println("Case #" + cc + ": " + (total - min(row)));
				continue;
			}
		}
	}

	// *************************************************************************************
	// *********************************** FRAMEWORK
	// ***************************************
	// *************************************************************************************

	public static String printStringOrNo(int n)
	{
		return Integer.toString(n);
	}
	
	public static String printStringOrNo(String s)
	{
		return s;
	}

	public static BufferedReader stdin = new BufferedReader(
			new InputStreamReader(System.in));
	public static boolean isStandardInput = false;

	public static File input;
	public static FileReader inputreader;
	public static BufferedReader in;

	public static File output;
	public static FileWriter outputwriter;
	public static BufferedWriter out;

	public static StringTokenizer st;

	public static void main(String[] args) throws Exception
	{
		doSTDIN(true);
		setOutput("test.out");
		run();
		close();
	}

	public static void init(String problemName) throws Exception
	{
		doSTDIN(false);
		setInput(problemName + ".in");
		setOutput(problemName + ".out");
	}

	// **************** PRINT METHODS **********************

	public static void println() throws IOException
	{
		out.write("\n");
		System.out.println();
	}

	public static void println(Object obj) throws IOException
	{
		out.write(obj.toString());
		out.write("\n");
		System.out.println(obj.toString());
	}

	public static void print(Object obj) throws IOException
	{
		out.write(obj.toString());
		System.out.print(obj.toString());
	}

	public static void println(long number) throws IOException
	{
		out.write(Long.toString(number));
		out.write("\n");
		System.out.println(number);
	}

	public static void print(long number) throws IOException
	{
		out.write(Long.toString(number));
		System.out.print(number);
	}

	public static void println(char c) throws IOException
	{
		out.write(Character.toString(c));
		out.write("\n");
		System.out.println(c);
	}

	public static void print(char c) throws IOException
	{
		out.write(Character.toString(c));
		System.out.print(c);
	}

	public static void println(String line) throws IOException
	{
		out.write(line);
		out.write("\n");
		System.out.println(line);
	}

	public static void print(String line) throws IOException
	{
		out.write(line);
		System.out.print(line);
	}

	// ******************** INPUT DECLARATION ******************

	public static void doSTDIN(boolean standard)
	{
		isStandardInput = standard;
	}

	public static void setInput(String filename) throws IOException
	{
		input = new File(filename);
		inputreader = new FileReader(input);
		in = new BufferedReader(inputreader);
	}

	public static void setOutput(String filename) throws IOException
	{
		output = new File(filename);
		outputwriter = new FileWriter(output);
		out = new BufferedWriter(outputwriter);
	}

	public static void close() throws IOException
	{
		if (in != null)
			in.close();
		if (inputreader != null)
			inputreader.close();

		if (out != null)
			out.flush();
		if (out != null)
			out.close();
		if (outputwriter != null)
			outputwriter.close();
	}

	// ************************** INPUT READING *****************

	static String LINE() throws IOException
	{
		return isStandardInput ? stdin.readLine() : in.readLine();
	}

	static String TOKEN() throws IOException
	{
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(LINE());
		return st.nextToken();
	}

	static char SINGLE_FIRST_CHAR() throws IOException
	{
		String s = TOKEN();
		return s.charAt(0);
	}

	static int INT() throws IOException
	{
		return Integer.parseInt(TOKEN());
	}

	static long LONG() throws IOException
	{
		return Long.parseLong(TOKEN());
	}

	static double DOUBLE() throws IOException
	{
		return Double.parseDouble(TOKEN());
	}

	static BigInteger BIGINT() throws IOException
	{
		return new BigInteger(TOKEN());
	}

}
