import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class C_Large_2
{
    private static String[] precompute = new String[] { "1", "4", "9", "121",
                    "484", "10201", "12321", "14641", "40804", "44944",
                    "1002001", "1234321", "4008004", "100020001", "102030201",
                    "104060401", "121242121", "123454321", "125686521",
                    "400080004", "404090404", "10000200001", "10221412201",
                    "12102420121", "12345654321", "40000800004",
                    "1000002000001", "1002003002001", "1004006004001",
                    "1020304030201", "1022325232201", "1024348434201",
                    "1210024200121", "1212225222121", "1214428244121",
                    "1232346432321", "1234567654321", "4000008000004",
                    "4004009004004", "100000020000001", "100220141022001",
                    "102012040210201", "102234363432201", "121000242000121",
                    "121242363242121", "123212464212321", "123456787654321",
                    "400000080000004" };

    public static void main(String[] args)
        throws Exception
    {
        new C_Large_2().run();
    }

    public void solve(Scanner sc, PrintWriter pw)
    {
        BigInteger A = sc.nextBigInteger();
        BigInteger B = sc.nextBigInteger();
        BigInteger precomputeLast = new BigInteger(
                        precompute[precompute.length - 1]);
        BigInteger answer = BigInteger.ZERO;

        for (String no : precompute) {
            BigInteger precomputeNo = new BigInteger(no);
            if (precomputeNo.compareTo(A) >= 0
                            && precomputeNo.compareTo(B) <= 0) {
                answer = answer.add(BigInteger.ONE);
            }
        }
        A = A.max(precomputeLast.add(BigInteger.ONE));
        if (B.compareTo(A) <= 0) {
            System.out.println(answer);
            pw.println(answer);
            return;
        }

        int noDigitsA = A.toString().length();
        int noDigitsB = B.toString().length();

        int startN = -1;
        if (noDigitsA % 2 == 1) {
            answer = answer.add(check((noDigitsA / 2) + 1, A, B));
            startN = (noDigitsA / 2) + 2;
        } else {
            startN = (noDigitsA / 2) + 1;
        }

        if (noDigitsB % 2 == 1) {
            answer = answer.add(check((noDigitsB / 2) + 1, A, B));
        }
        int endN = noDigitsB / 2;

        BigInteger two = BigInteger.ONE.add(BigInteger.ONE);
        BigInteger three = two.add(BigInteger.ONE);
        for (int i = startN; i <= endN; i++) {
            BigInteger thisI = new BigInteger("" + i);
            BigInteger temp = BigInteger.ZERO;
            if (i % 2 == 1) { // odd
                BigInteger part2 = (thisI.subtract(BigInteger.ONE)).divide(two);

                int part3a = (thisI.subtract(three)).divide(two).intValue();
                BigInteger part3b = nCk(part3a, 0);
                BigInteger part3c = nCk(part3a, 1);
                BigInteger part3d = nCk(part3a, 2);
                BigInteger part3e = nCk(part3a, 3);
                BigInteger part3 = part3b.add(part3c);
                part3 = part3.add(part3d);
                part3 = part3.add(part3e);
                part3 = part3.multiply(two);

                temp = two.add(part2).add(part3);
            } else { // even
                int part3a = (thisI.subtract(two)).divide(two).intValue();
                BigInteger part3b = nCk(part3a, 0);
                BigInteger part3c = nCk(part3a, 1);
                BigInteger part3d = nCk(part3a, 2);
                BigInteger part3e = nCk(part3a, 3);
                BigInteger part3 = part3b.add(part3c);
                part3 = part3.add(part3d);
                part3 = part3.add(part3e);

                temp = BigInteger.ONE.add(part3);
            }

            // System.out.println("[nCk] length = " + i
            // + " total for this length = " + temp);
            answer = answer.add(temp);
        }

        System.out.println(answer);
        pw.println(answer);
    }

    public BigInteger nCk(final int N, final int K)
    {
        BigInteger ret = BigInteger.ONE;
        for (int k = 0; k < K; k++) {
            ret = ret.multiply(BigInteger.valueOf(N - k)).divide(
                BigInteger.valueOf(k + 1));
        }
        return ret;
    }

    public BigInteger check(int N, BigInteger start, BigInteger end)
    {
        BigInteger answer = BigInteger.ZERO;

        // case involving 2
        BigInteger fst = new BigInteger("2");
        fst = fst.multiply(BigInteger.TEN.pow(N - 1));
        fst = fst.add(new BigInteger("2"));
        // System.out.println("first = " + fst);

        if (N >= 2) {
            BigInteger fstSq = fst.multiply(fst);
            if (fstSq.compareTo(start) >= 0 && fstSq.compareTo(end) <= 0) {
                answer = answer.add(BigInteger.ONE);
            }
        }

        if (N >= 3 && N % 2 == 1) {
            BigInteger snd = fst.add(BigInteger.TEN.pow(N / 2));
            // System.out.println("[odd length root] second = " + snd);
            BigInteger sndSq = snd.multiply(snd);
            if (sndSq.compareTo(start) >= 0 && sndSq.compareTo(end) <= 0) {
                answer = answer.add(BigInteger.ONE);
            }
        }

        // case involving 0/1

        // 1...[2]...1 - at most 01x'1' in '...'
        // pre: N ≥ 4
        if (N >= 4) {
            if (N % 2 == 1) { // odd
                StringBuffer sb = new StringBuffer();
                for (int i = 0; i < ((N / 2) - 1); i++) {
                    sb.append("0");
                }
                String initial = sb.toString();
                BigInteger third = new BigInteger("1" + initial + "2" + initial
                                + "1");
                BigInteger thirdSq = third.multiply(third);
                if (thirdSq.compareTo(start) >= 0
                                && thirdSq.compareTo(end) <= 0) {
                    answer = answer.add(BigInteger.ONE);
                }
                for (int pos = 0; pos < initial.length(); pos++) {
                    StringBuilder next = new StringBuilder(initial);
                    next.setCharAt(pos, '1');
                    String n1 = next.toString();
                    String rev = next.reverse().toString();
                    third = new BigInteger("1" + n1 + "2" + rev + "1");
                    thirdSq = third.multiply(third);
                    if (thirdSq.compareTo(start) >= 0
                                    && thirdSq.compareTo(end) <= 0) {
                        answer = answer.add(BigInteger.ONE);
                    }
                }
            } else { // even
                StringBuffer sb = new StringBuffer();
                for (int i = 0; i < ((N / 2) - 1); i++) {
                    sb.append("0");
                }
                String initial = sb.toString();
                BigInteger third = new BigInteger("1" + initial + initial + "1");
                BigInteger thirdSq = third.multiply(third);
                if (thirdSq.compareTo(start) >= 0
                                && thirdSq.compareTo(end) <= 0) {
                    answer = answer.add(BigInteger.ONE);
                }

                for (int pos = 0; pos < initial.length(); pos++) {
                    StringBuilder next = new StringBuilder(initial);
                    next.setCharAt(pos, '1');
                    String n1 = next.toString();
                    String rev = next.reverse().toString();
                    third = new BigInteger("1" + n1 + rev + "1");
                    thirdSq = third.multiply(third);
                    if (thirdSq.compareTo(start) >= 0
                                    && thirdSq.compareTo(end) <= 0) {
                        answer = answer.add(BigInteger.ONE);
                    }
                }
            }
        }

        // 1...[0/1]...1 - at most 03x'1' in '...'
        // pre: N ≥ 9
        if (N >= 9) {
            // 3 1's
            List<String> threes = generate1((N / 2) - 1, 3);
            // System.out.println(threes.size() + "/" + threes);
            for (String between : threes) {
                if (N % 2 == 1) { // odd
                    String rev = new StringBuilder(between).reverse()
                                    .toString();
                    BigInteger fourth = new BigInteger("1" + between + "0"
                                    + rev + "1");
                    BigInteger fourthSq = fourth.multiply(fourth);
                    if (fourthSq.compareTo(start) >= 0
                                    && fourthSq.compareTo(end) <= 0) {
                        answer = answer.add(BigInteger.ONE);
                    }

                    BigInteger fifth = new BigInteger("1" + between + "1" + rev
                                    + "1");
                    BigInteger fifthSq = fifth.multiply(fifth);
                    if (fifthSq.compareTo(start) >= 0
                                    && fifthSq.compareTo(end) <= 0) {
                        answer = answer.add(BigInteger.ONE);
                    }
                } else { // even
                    String rev = new StringBuilder(between).reverse()
                                    .toString();
                    BigInteger fourth = new BigInteger("1" + between + rev
                                    + "1");
                    BigInteger fourthSq = fourth.multiply(fourth);
                    if (fourthSq.compareTo(start) >= 0
                                    && fourthSq.compareTo(end) <= 0) {
                        answer = answer.add(BigInteger.ONE);
                    }
                }
            }

            // 2 1's
            List<String> twos = generate1((N / 2) - 1, 2);
            // System.out.println(twos.size() + "/" + twos);
            for (String between : twos) {
                if (N % 2 == 1) { // odd
                    String rev = new StringBuilder(between).reverse()
                                    .toString();
                    BigInteger fourth = new BigInteger("1" + between + "0"
                                    + rev + "1");
                    BigInteger fourthSq = fourth.multiply(fourth);
                    if (fourthSq.compareTo(start) >= 0
                                    && fourthSq.compareTo(end) <= 0) {
                        answer = answer.add(BigInteger.ONE);
                    }

                    BigInteger fifth = new BigInteger("1" + between + "1" + rev
                                    + "1");
                    BigInteger fifthSq = fifth.multiply(fifth);
                    if (fifthSq.compareTo(start) >= 0
                                    && fifthSq.compareTo(end) <= 0) {
                        answer = answer.add(BigInteger.ONE);
                    }
                } else { // even
                    String rev = new StringBuilder(between).reverse()
                                    .toString();
                    BigInteger fourth = new BigInteger("1" + between + rev
                                    + "1");
                    BigInteger fourthSq = fourth.multiply(fourth);
                    if (fourthSq.compareTo(start) >= 0
                                    && fourthSq.compareTo(end) <= 0) {
                        answer = answer.add(BigInteger.ONE);
                    }
                }
            }

            int between_length = (N / 2) - 1;
            StringBuilder sb = new StringBuilder();
            // 1 1's
            for (int onePos = 0; onePos < between_length; onePos++) {
                sb = new StringBuilder();
                for (int i = 0; i < onePos; i++) {
                    sb.append("0");
                }
                sb.append("1");
                for (int i = onePos + 1; i < between_length; i++) {
                    sb.append("0");
                }
                String between = sb.toString();
                String rev = sb.reverse().toString();

                if (N % 2 == 1) { // odd
                    BigInteger fourth = new BigInteger("1" + between + "0"
                                    + rev + "1");
                    BigInteger fourthSq = fourth.multiply(fourth);
                    if (fourthSq.compareTo(start) >= 0
                                    && fourthSq.compareTo(end) <= 0) {
                        answer = answer.add(BigInteger.ONE);
                    }

                    BigInteger fifth = new BigInteger("1" + between + "1" + rev
                                    + "1");
                    BigInteger fifthSq = fifth.multiply(fifth);
                    if (fifthSq.compareTo(start) >= 0
                                    && fifthSq.compareTo(end) <= 0) {
                        answer = answer.add(BigInteger.ONE);
                    }
                }
            }

            // 0 1's
            sb = new StringBuilder();
            for (int i = 0; i < between_length; i++) {
                sb.append("0");
            }
            String between = sb.toString();
            String rev = sb.reverse().toString();
            if (N % 2 == 1) { // odd
                BigInteger fourth = new BigInteger("1" + between + "0" + rev
                                + "1");
                BigInteger fourthSq = fourth.multiply(fourth);
                if (fourthSq.compareTo(start) >= 0
                                && fourthSq.compareTo(end) <= 0) {
                    answer = answer.add(BigInteger.ONE);
                }
                BigInteger fifth = new BigInteger("1" + between + "1" + rev
                                + "1");
                BigInteger fifthSq = fifth.multiply(fifth);
                if (fifthSq.compareTo(start) >= 0
                                && fifthSq.compareTo(end) <= 0) {
                    answer = answer.add(BigInteger.ONE);
                }
            }
        }
        return answer;
    }

    public List<String> generate1(int between_length, int noOfOnes)
    {
        List<String> result = new ArrayList<>();
        StringBuilder sb = new StringBuilder();
        // length > 3
        for (int i = 0; i < between_length - noOfOnes; i++) {
            sb.append('0');
        }
        sb.append("AB");
        if (noOfOnes == 3) {
            sb.append("C");
        }
        String current = sb.toString();

        result.add(current.replaceAll("[A|B|C]", "1"));
        // System.out.println(current);

        int posA = current.indexOf("A");
        sb.setCharAt(posA, '0');
        current = sb.toString();
        posA--;
        while (posA >= 0) {
            sb = new StringBuilder(current);
            sb.setCharAt(posA, 'A');

            String output = sb.toString();
            // System.out.println(output);
            result.add(output.replaceAll("[A|B|C]", "1"));

            posA--;
        }
        // posA == 0
        current = sb.toString();
        int posB = current.indexOf("B") - 1;
        while (posB >= 1) {
            sb.setCharAt(0, '0');
            current = sb.toString();
            posB = current.indexOf("B");
            sb.setCharAt(posB, '0');
            posB--;
            sb.setCharAt(posB, 'B');
            current = sb.toString();
            posA = posB - 1;
            while (posA >= 0) {
                sb = new StringBuilder(current);
                sb.setCharAt(posA, 'A');

                String output = sb.toString();
                // System.out.println(output);
                result.add(output.replaceAll("[A|B|C]", "1"));

                posA--;
            }
            current = sb.toString();
            posB = current.indexOf("B") - 1;
        }
        // posA == 0, posB == 1
        sb.setCharAt(0, '0');
        sb.setCharAt(1, '0');
        current = sb.toString();
        int posC = current.indexOf("C");
        while (posC > 2) {
            sb.setCharAt(posC, '0');
            posC--;
            sb.setCharAt(posC, 'C');
            sb.setCharAt(posC - 1, 'B');
            sb.setCharAt(posC - 2, 'A');
            current = sb.toString();

            result.add(current.replaceAll("[A|B|C]", "1"));
            // System.out.println(current);

            posA = current.indexOf("A");
            sb.setCharAt(posA, '0');
            current = sb.toString();
            posA--;
            while (posA >= 0) {
                sb = new StringBuilder(current);
                sb.setCharAt(posA, 'A');

                String output = sb.toString();
                // System.out.println(output);
                result.add(output.replaceAll("[A|B|C]", "1"));

                posA--;
            }
            // posA == 0
            current = sb.toString();
            posB = current.indexOf("B") - 1;
            while (posB >= 1) {
                sb.setCharAt(0, '0');
                current = sb.toString();
                posB = current.indexOf("B");
                sb.setCharAt(posB, '0');
                posB--;
                sb.setCharAt(posB, 'B');
                current = sb.toString();
                posA = posB - 1;
                while (posA >= 0) {
                    sb = new StringBuilder(current);
                    sb.setCharAt(posA, 'A');

                    String output = sb.toString();
                    // System.out.println(output);
                    result.add(output.replaceAll("[A|B|C]", "1"));

                    posA--;
                }
                current = sb.toString();
                posB = current.indexOf("B") - 1;
            }
            sb.setCharAt(0, '0');
            sb.setCharAt(1, '0');
            current = sb.toString();
            posC = current.indexOf("C");
        }

        Collections.reverse(result);
        return result;
    }

    public boolean isPerfectPow10(String szBigInt)
    {
        boolean perfectPow10A = szBigInt.charAt(0) == '1';
        if (perfectPow10A) {
            for (int i = 1; i < szBigInt.length(); i++) {
                if (szBigInt.charAt(i) != '0') {
                    return false;
                }
            }
        } else {
            return false;
        }
        return true;
    }

    public void run()
        throws Exception
    {
        Scanner sc = new Scanner(new FileReader("C-large-2.in.txt"));
        PrintWriter pw = new PrintWriter(new FileWriter("C-large-2.out.txt"));
        int caseCnt = sc.nextInt();
        for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
            System.out.print("Case #" + (caseNum + 1) + ": ");
            pw.print("Case #" + (caseNum + 1) + ": ");
            solve(sc, pw);
        }
        pw.flush();
        pw.close();
        sc.close();
    }

    public void generate()
    {
        BigInteger i = new BigInteger("1234323468643234321"); // BigInteger.ONE;
        BigInteger googol = new BigDecimal(Math.pow(10, 100) + "")
                        .toBigInteger();
        assert googol.toString().length() == 101 : "incorrect length of googol";
        BigInteger last = BigInteger.TEN.pow(20);
        int count = 0;

        System.out.println("Generating from " + i + " to " + last + "...");
        while (i.compareTo(last/* googol */) <= 0) {
            if ((i.multiply(i)).compareTo(googol) > 0) break;
            if (isPalindrome(i) && isPalindrome(i.multiply(i))) {
                System.out.println(i.multiply(i));
                count++;
            }
            i = i.add(BigInteger.ONE);
        }
        System.out.println("Total: " + count + " answers");
    }

    private static final int MAX_DIGITS = 100;

    // Check if a number is palindromic
    public static boolean isPalindrome(BigInteger num)
    {
        String digits = num.toString();
        int numDigits = digits.length();
        if (numDigits >= MAX_DIGITS) {
            throw new IllegalStateException("too big");
        }
        if (numDigits == 1) return true;
        for (int i = 0; i < numDigits / 2; i++) {
            if (digits.charAt(i) != digits.charAt(numDigits - i - 1))
                return false;
        }
        return true;
    }
}
