import com.sun.deploy.util.ArrayUtil;
import com.sun.org.apache.xpath.internal.operations.Bool;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.PrintStream;
import java.util.*;
import java.lang.*;

import static java.lang.Long.max;

/**
 * Created by Emil on 2016-12-17.
 */

 // Definition for a binary tree node.

public class Main {

    long snabbExponering(long b, long n, int mod) {
        int ans = 1;
        while(n!=0){
            if (n % 2 == 0) {
                b = b * b % mod;
                n = n / 2;
            } else {
                ans *= b;
                ans %= mod;
                n = n - 1;
            }
        }
        return ans;
    }

    void printArray(int[][] array) {
        for (int i = 0; i < array.length; i++) {
            for (int j = 0; j < array[i].length; j++) {
                System.out.print(array[i][j]);
                System.out.print(" ");
            }
            System.out.println();
        }
    }

    void printArray(int[] array) {
        for (int i = 0; i < array.length; i++) {
            System.out.print(array[i]);
            System.out.print(" ");
        }
        System.out.println();
    }

    void printArray(ArrayList array) {
        for (int i = 0; i < array.size(); i++) {
            System.out.print(array.get(i));
            System.out.print(" ");
        }
        System.out.println();
    }

    Boolean[] strTobools(String input){
        Boolean[] out = new Boolean[input.length()];
        for (int i = 0; i < input.length(); i++) {
            out[i] = ( (input.charAt(i)=='+')?true:false );
        }
        return out;
    }

    String solvePancakes(String input, int K){
        Boolean[] order = strTobools(input);
        int counter = 0;
        for (int i = 0; i < input.length()-K+1; i++) {
            if(!order[i]) {
                counter++;
                for (int j = 0; j < K; j++) {
                    order[i+j]=!order[i+j];
                }
            }
        }
        for (int i = input.length()-K+1; i < input.length(); i++) {
            if(!order[i]) {
                return "IMPOSSIBLE";
            }
        }
        return Integer.toString(counter);
    }

    String solveTidy(long K){

        String str = String.valueOf(K);
        if (str.length()==1){
            return str;
        }
        StringBuilder sb = new StringBuilder(str);

        int breakpoint = 0;
        for (int i = 1; i < sb.length(); i++) {
            while ( Character.getNumericValue(sb.charAt(i)) < Character.getNumericValue(sb.charAt(i-1)) ) {
                int temp = Character.getNumericValue(sb.charAt(i-1))-1;
                sb.setCharAt(i-1,(char)(temp + '0'));
                breakpoint = i;
                i--;
                if (i<1) {
                    breakpoint = 1;
                    break;
                }
            }
            if (breakpoint!=0) {
                for (int j = breakpoint; j < sb.length(); j++) {
                    sb.setCharAt(j,'9');
                }
                break;
            }
        }

        while(sb.length() > 1 && sb.charAt(0) == '0') {
            sb.deleteCharAt(0);
        }
        return sb.toString();
    }

    private static class LinkedListNode{
        long width;
        long nr;
        LinkedListNode next = null;
        LinkedListNode prev = null;
        LinkedListNode(long w, long nr) {
            this.width = w;
            this.nr = nr;
        }
    }

    void addNode(LinkedListNode temp, LinkedListNode tail) { //can not add new node as head, but it should not be needed
        LinkedListNode current=tail;
        while (current != null) {
            if (temp.width == current.width){
                current.nr = current.nr + temp.nr;
                break;
            } else if (temp.width < current.width){
                temp.prev = current;
                if (current.next != null) {
                    temp.next = current.next;
                    temp.next.prev = temp;
                }
                current.next = temp;
                break;
            }
            current=current.prev;
        }
    }

    LinkedListNode[] splitNode(LinkedListNode node) {
        if(node.width==1){
            return new LinkedListNode[0];
        }else if(node.width==2){
            LinkedListNode[] nodes = new LinkedListNode[1];
            nodes[0]= new LinkedListNode(1,node.nr);
            return nodes;
        }

        LinkedListNode[] nodes = new LinkedListNode[2];
        long w1=(node.width)/2;
        long w2=(node.width-1)/2;
//        long w1=(node.width-1)/2;
//        long w2=(node.width-1)/2;
//        if(node.width % 2 == 0) {
//            w1=(node.width)/2-1;
//            w2=(node.width)/2;
//        }
        //long offset1 = w1/2+1;
        //long offset2 = (w2+1)/2;
        nodes[0]= new LinkedListNode(w1,node.nr);
        nodes[1]= new LinkedListNode(w2,node.nr);
        return nodes;
    }

    String solveStalls(long N, long K){

        LinkedListNode head = new LinkedListNode(N,1);
        LinkedListNode tail = head;
        long processed = 1;
        while (K>processed) {
            LinkedListNode[] nodes = splitNode(head);
            for (int j = 0; j < nodes.length; j++) {
                addNode(nodes[j], tail);
                if (tail.next != null) {
                    tail = tail.next;
                }
            }
            head = head.next;
            head.prev=null;
            processed+=head.nr;
        }

        return (head.width)/2 + " " + (head.width-1)/2;
    }


    void solve (InputStream is, PrintStream ps) {
        Scanner input = new Scanner(is);;
        int n = input.nextInt();
        long[] N = new long[n];
        long[] K = new long[n];
        for (int i = 0; i < n; i++) {
            N[i]=input.nextLong();
            K[i]=input.nextLong();
        }
        long start =System.currentTimeMillis();
        for (int i = 0; i < n; i++) {
            ps.println("Case #" + (i+1) + ": " + solveStalls(N[i],K[i]));
            //System.out.println(N[i] + " " + K[i]);
            //System.out.println(System.currentTimeMillis() - start);
        }

    }


    public static void main(String[] args) throws FileNotFoundException {
        InputStream instream = new FileInputStream("C-small-2-attempt1.in");
        Main obj = new Main();
        PrintStream outstream = new PrintStream("output");
        new Main().solve(instream, outstream);

    }

    private List<String> bolToString(boolean[][] board) {
        List<String> ans = new ArrayList<>();
        for (int i = 0; i < board.length; i++) {
            StringBuilder sb = new StringBuilder();
            for (int j = 0; j < board.length; j++) {
                sb.append((board[i][j])?'Q':'.');
            }
            ans.add(sb.toString());
        }
        return  ans;
    }

    public static boolean[][] deepCopy(boolean[][] original) {
        if (original == null) {
            return null;
        }

        final boolean[][] result = new boolean[original.length][];
        for (int i = 0; i < original.length; i++) {
            result[i] = Arrays.copyOf(original[i], original[i].length);
        }
        return result;
    }


}
