package codejam.google;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

/**
 *
 * @author evolplus
 */
public class QualD {

	private static final String INPUT_FILENAME = "D-small-attempt0.in";
	private static final String OUTPUT_FILENAME = "D-small-attempt0.out";

	/**
	 * @param args the command line arguments
	 * @throws java.io.IOException
	 */
	public static void main(String[] args) throws IOException {
		BufferedWriter bw;
		try (BufferedReader br = new BufferedReader(new FileReader(INPUT_FILENAME))) {
			bw = new BufferedWriter(new FileWriter(OUTPUT_FILENAME));
			String line;
			line = br.readLine();
			int count = Integer.parseInt(line);
			for (int caseNo = 1; caseNo <= count; caseNo++) {
				line = br.readLine();
				String[] a = line.split("\\s");
				int k = Integer.parseInt(a[0]);
				int c = Integer.parseInt(a[1]);
				int s = Integer.parseInt(a[2]);
				bw.append("Case #");
				bw.append(String.valueOf(caseNo));
				bw.append(":");
				solve(k, c, s, bw);
				bw.newLine();
			}
			bw.close();
		}
	}

	public static void solve(int k, int c, int s, BufferedWriter bw) throws IOException {
		long len = pow(k, c);
		Map<Long, Set<Integer>> check = new HashMap<>();
		Set<Long> remove = new HashSet<>();
		boolean found = false;
		boolean full = false;
		for (long i = 0; i < len; i++) {
			Set<Integer> set = new HashSet<>();
			for (int j = 0; j < k; j++) {
				if (isGold(k, c, j, i)) {
					set.add(j);
				}
			}
			remove.clear();
			boolean skip = false;
			for (Entry<Long, Set<Integer>> e : check.entrySet()) {
				if (set.containsAll(e.getValue())) {
					remove.add(e.getKey());
				} else if (e.getValue().containsAll(set)) {
					skip = true;
					break;
				}
			}
			if (!skip) {
				for (Long key : remove) {
					check.remove(key);
				}
				check.put(i, set);
			}
			if (!full) {
				Set<Integer> test = new HashSet<>();
				for (Entry<Long, Set<Integer>> e : check.entrySet()) {
					test.addAll(e.getValue());
				}
				if (test.size() == k) {
					full = true;
				}
			}
			if (full && check.size() <= s) {
				found = true;
				break;
			}
		}
		if (!found) {
			bw.append(" IMPOSSIBLE");
		} else {
			for (Long key : check.keySet()) {
				bw.append(" ");
				bw.append(String.valueOf(key + 1));
			}
		}

	}

	public static long pow(long x, long n) {
		if (n == 0) {
			return 1;
		}
		long exp = n;
		long m = 1;
		while (exp > 1) {
			if (exp % 2 == 1) {
				m *= x;
			}
			x *= x;
			exp /= 2;
		}
		return x * m;
	}

	public static boolean isGold(int k, int c, int orgPos, long pos) {
		long len0 = pow(k, c - 1);
		for (int i = 0; i < c; i++) {
			if (len0==0) {
				System.out.println(k + "^" + c);
			}
			if (pos / len0 == orgPos) {
				return true;
			}
			pos %= len0;
			len0 /= k;
		}
		return false;
	}

}
