package codejam.google;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Arrays;

/**
 *
 * @author evolplus
 */
public class QualC {

	private static final BigInteger TWO = new BigInteger("2");
	private static final BigInteger THREE = new BigInteger("3");
	private static final String INPUT_FILENAME = "C-small-attempt1.in";
	private static final String OUTPUT_FILENAME = "C-small-attempt1.out";

	/**
	 * @param args the command line arguments
	 * @throws java.io.IOException
	 */
	public static void main(String[] args) throws IOException {
		BufferedWriter bw;
		try (BufferedReader br = new BufferedReader(new FileReader(INPUT_FILENAME))) {
			bw = new BufferedWriter(new FileWriter(OUTPUT_FILENAME));
			String line;
			line = br.readLine();
			int count = Integer.parseInt(line);
			for (int caseNo = 1; caseNo <= count; caseNo++) {
				line = br.readLine();
				String[] a = line.split("\\s");
				int n = Integer.parseInt(a[0]);
				int found = 0;
				int j;

				j = Integer.parseInt(a[1]);
				byte[] bits = new byte[1 << (n - 3)];
				long last = bits.length * 8;

				Arrays.fill(bits,
					0, bits.length, (byte) 0);
				int root = Math.round(1 << (n / 2));
				for (int i = 2;
					i < root;
					i++) {
					if (((bits[i / 8] >> (i % 8)) & 1) == 0) {
						for (long k = 2 * i; k < last; k += i) {
							bits[(int) (k / 8)] |= (byte) (1 << (k % 8));
						}
					}
				}

				bw.write("Case #" + caseNo + ":");
				bw.newLine();
				long first = 1L << (n - 1);
				for (long x = first + 1;
					x < last;
					x += 2) {
					if (((bits[(int) (x / 8)] >> (x % 8)) & 1) == 1) {
						String test = Long.toBinaryString(x);
						boolean check = true;
						BigInteger[] primes = new BigInteger[11];
						for (int i = 3; i <= 10; i++) {
							BigInteger val = new BigInteger(test, i);
							primes[i] = isprime(val);
							if (primes[i].compareTo(val) == 0) {
								check = false;
								break;
							}
						}
						if (check) {
							System.out.println(x);
							found++;
							bw.append(test);
							int mod2 = 3;
							while ((x % mod2) != 0) {
								mod2 += 2;
							}
							bw.append(" ");
							bw.append(String.valueOf(mod2));
							for (int i = 3; i <= 10; i++) {
								bw.append(" ");
								bw.append(primes[i].toString());
							}
							bw.newLine();
							if (found == j) {
								break;
							}
						}
					}
				}
			}
		}
		bw.close();
	}

	public static BigInteger isprime(BigInteger n) {
		if (n.compareTo(BigInteger.ONE) == 0 || n.compareTo(TWO) == 0) {
			return n;
		}
		BigInteger root = appxRoot(n);

		for (BigInteger i = THREE; i.compareTo(root) <= 0; i = i.nextProbablePrime()) {
			if (n.mod(i).equals(BigInteger.ZERO)) {
				return i;
			}
		}
		return n;
	}

	private static BigInteger appxRoot(final BigInteger n) {
		BigInteger half = n.shiftRight(1);
		while (half.multiply(half).compareTo(n) > 0) {
			half = half.shiftRight(1);
		}
		return half.shiftLeft(1);
	}
	
}
