package com.google.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Set;

/**
 *
 * @author evolplus
 */
public class Round1AProblemB {

	private static final String FILENAME_INPUT = "B-large.in";
	private static final String FILENAME_OUTPUT = "B-large.out";

	/**
	 * @param args the command line arguments
	 * @throws java.io.IOException
	 */
	public static void main(String[] args) throws IOException {
		try (BufferedWriter bw = new BufferedWriter(new FileWriter(FILENAME_OUTPUT)); BufferedReader br = new BufferedReader(new FileReader(FILENAME_INPUT))) {
			String line = br.readLine();
			int t = Integer.parseInt(line);
			for (int caseIndex = 1; caseIndex <= t; caseIndex++) {
				line = br.readLine();
				int n = Integer.parseInt(line);
				int[][] data = new int[2 * n - 1][n];
				for (int i = 0; i < n * 2 - 1; i++) {
					line = br.readLine();
					String[] a = line.split("\\s");
					for (int j = 0; j < n; j++) {
						data[i][j] = Integer.parseInt(a[j]);
					}
				}
				int[] result = new int[n];
				Arrays.sort(data, new Comparator<int[]>() {
					@Override
					public int compare(int[] o1, int[] o2) {
						for (int i = 0; i < o1.length && i < o2.length; i++) {
							if (o1[i] < o2[i]) {
								return -1;
							}
							if (o1[i] > o2[i]) {
								return 1;
							}
						}
						if (o1.length < o2.length) {
							return -1;
						}
						if (o1.length > o2.length) {
							return 1;
						}
						return 0;
					}
				});
				int[] row0 = data[0];
				int[] col0 = data[1];
				result[0] = row0[0];
				if (row0[0] == col0[0]) { // not missing 1st column or 1st row
					Set<Integer> removed = new HashSet<>();
					for (int k = 0; k < n; k++) {
						int sum = 0;
						for (int[] a : data) {
							sum += a[k];

						}
						int col;
						int row = 0;
						int sumCol = 0;
						int sumRow = 0;
						boolean found = false;
						for (col = 0; col < data.length; col++) {
							if (data[col][0] == col0[k] && !removed.contains(col)) {
								for (int h : data[col]) {
									sumCol += h;
								}
								for (row = 0; row < data.length; row++) {
									if (row != col && data[row][0] == row0[k] && !removed.contains(row)) {
										found = true;
										for (int h : data[row]) {
											sumRow += h;
										}
										break;
									}
								}
							}
							if (found) {
								break;
							}
						}
						if (found) {
							removed.add(col);
							removed.add(row);
							result[k] = sumRow + sumCol - sum;
						} else {
							row = 0;
							int min = 2501;
							for (int r = 0; r < data.length; r++) {
								if (data[r][k] < min && !removed.contains(r)) {
									row = r;
									min = data[r][k];
								}
							}
							removed.add(row);
							result[k] = data[row][k];
							int x = k + 1;
							int y = k + 1;
							for (int z = 1; z < data.length && y < n; z++) {
								if (removed.contains(z)) {
									continue;
								}
								if (x < n && data[z][k] == data[row][x]) {
									x++;
								} else {
									result[y++] = data[z][k];
								}
							}
							break;
						}
					}
				} else {
					int x = 1;
					int y = 1;
					for (int k = 1; k < data.length && y < n; k++) {
						if (x < n && data[k][0] == row0[x]) {
							x++;
						} else {
							result[y++] = data[k][0];
						}
					}
				}
				bw.append("Case #" + caseIndex + ":");
				for (int h : result) {
					bw.append(" ");
					bw.append(String.valueOf(h));
				}
				bw.newLine();
			}
		}
	}

}
