package com.google.codejam.round1c;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;

/**
 *
 * @author evolplus
 */
public class ProblemB {

	private static final String FILENAME_INPUT = "B-small-attempt0.in";
	private static final String FILENAME_OUTPUT = "B-small-attempt0.out";

	/**
	 * @param args the command line arguments
	 * @throws java.io.IOException
	 */
	public static void main(String[] args) throws IOException {
		try (BufferedReader br = new BufferedReader(new FileReader(FILENAME_INPUT));
			BufferedWriter bw = new BufferedWriter(new FileWriter(FILENAME_OUTPUT))) {
			String line = br.readLine();
			int t = Integer.parseInt(line);
			for (int caseNo = 1; caseNo <= t; caseNo++) {
				line = br.readLine();
				String[] a = line.split(" ");
				int b = Integer.parseInt(a[0]);
				long m = Long.parseLong(a[1]);

				bw.append("Case #");
				bw.append(String.valueOf(caseNo));
				bw.append(": ");
				long[][] matrix = new long[b][b];
				for (int i = 0; i < b; i++) {
					Arrays.fill(matrix[i], 0L);
				}
				if (traverse(matrix, b, 0, m)) {
					bw.append("POSSIBLE");
					for (int i = 0; i < b; i++) {
						bw.newLine();
						for (int j = 0; j < b; j++) {
							bw.append(matrix[i][j] == 1 ? '1' : '0');
						}
					}
				} else {
					bw.append("IMPOSSIBLE");
				}
				bw.newLine();
			}
		}
	}

	private static boolean traverse(long[][] matrix, int n, int u, long m) {
		if (matrix[0][n - 1] == m) {
			return true;
		}
		if (u == n - 1) {
			return false;
		}
		long[][] a = new long[n][n];
		for (int v = 0; v < n; v++) {
			if (u != v && matrix[v][u] == 0) {
				matrix[u][v] = 1;
				copyMatrix(matrix, a, n);
				for (int w = 0; w < n; w++) {
					if (matrix[w][u] > 0) {
						a[w][v] += matrix[w][u];
					}
				}
				if (traverse(a, n, u + 1, m)) {
					copyMatrix(a, matrix, n);
					return true;
				}
			}
		}
		return false;
	}

	private static void copyMatrix(long[][] src, long[][] dest, int n) {
		for (int i = 0; i < n; i++) {
			System.arraycopy(src[i], 0, dest[i], 0, n);
		}

	}

}
