package com.google.codejam.round1b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;

/**
 *
 * @author evolplus
 */
public class ProblemA {

	private static final String FILENAME_INPUT = "A-small-attempt0.in";
	private static final String FILENAME_OUTPUT = "A-small-attempt0.out";

	private static final String[] LETTERS = {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
	private static final int[][] LETTER_COUNT = new int[10][26];

	/**
	 * @param args the command line arguments
	 * @throws java.io.IOException
	 */
	public static void main(String[] args) throws IOException {
		for (int i = 0; i < 10; i++) {
			Arrays.fill(LETTER_COUNT[i], 0);
			for (int j = 0; j < LETTERS[i].length(); j++) {
				LETTER_COUNT[i][LETTERS[i].charAt(j) - 'A']++;
			}
		}

		try (BufferedReader br = new BufferedReader(new FileReader(FILENAME_INPUT));
			BufferedWriter bw = new BufferedWriter(new FileWriter(FILENAME_OUTPUT))) {
			String line = br.readLine();
			int t = Integer.parseInt(line);
			int[] count = new int[26];
			int[] prefix = new int[10];
			for (int caseNo = 1; caseNo <= t; caseNo++) {
				line = br.readLine();
				Arrays.fill(count, 0);
				for (int i = 0; i < line.length(); i++) {
					count[line.charAt(i) - 'A']++;
				}
				String output = traverse(0, line.length(), prefix, count);
				bw.append("Case #");
				bw.append(String.valueOf(caseNo));
				bw.append(": ");
				bw.append(output);
				bw.newLine();
			}
		}
	}

	private static String traverse(int digit, int max, int[] prefix, int[] count) {
		if (digit == 10) {
			if (max == 0) {
				StringBuilder sb = new StringBuilder();
				for (int d = 0; d < 10; d++) {
					for (int i = 0; i < prefix[d]; i++) {
						sb.append((char)('0' + d));
					}
				}
				return sb.toString();
			}
			return null;
		}
		int[] c = LETTER_COUNT[digit];
		int min = max;
		for (int i = 0; i < 26; i++) {
			if (c[i] != 0) {
				int test = count[i] / c[i];
				if (test < min) {
					min = test;
				}
			}
		}
		int[] cc = Arrays.copyOf(count, count.length);
		int dl = LETTERS[digit].length();
		for (int i = 0; i <= min; i++) {
			prefix[digit] = i;
			String output = traverse(digit + 1, max - i * dl, prefix, cc);
			if (output != null) {
				return output;
			}
			for (int j = 0; j < 26; j++) {
				cc[j] -= c[j];
			}
		}
		return null;
	}

}
