import java.util.*;
import java.io.*;
public class C {
    public class Choice {
        int r, c;
        HashSet<Integer> v, h;
        public Choice(int r, int c) {
            this.r = r; this.c = c;
        }
    }
    static char[][] b;
    static int R,C;
    void solve(BufferedReader in) throws Exception {
        int T = toInt(in.readLine());
        for(int t = 1; t<=T; t++) {
            int[] xx = toInts(in.readLine());
            R = xx[0]; C = xx[1];
            b = new char[R][C];
            for(int i = 0; i<R; i++) b[i] = in.readLine().toCharArray(); 
            HashSet<Choice> choices = new HashSet<>();
            HashSet<Integer> fixed = new HashSet<>();
            boolean ok = true;
            for(int i = 0; i<R; i++) for(int j = 0; j<C; j++) {
                if(!(b[i][j] == '|' || b[i][j] == '-')) continue;
                int p = i*C + j;
                HashSet<Integer> v = bfs(i, j, true);
                HashSet<Integer> h = bfs(i, j, false);
                if(v == null && h == null) {
                    ok = false;
                    break;
                }
                if(v == null || h == null) {
                    if(v == null) {
                        b[i][j] = '|';
                        fixed.addAll(h);
                    } else {
                        b[i][j] = '-';
                        fixed.addAll(v);
                    }
                } else {
                    Choice c = new Choice(i, j);
                    c.h = h; c.v = v;
                    choices.add(c);
                }
            }
            
            if(!ok) {
                e("no possible assignment");
                System.out.printf("Case #%d: IMPOSSIBLE\n", t);
                continue;
            }
            HashMap<Integer, Integer> lasers = new HashMap<>();
            for(int i = 0; i<R; i++) for(int j = 0; j<C; j++) {
                if(b[i][j] == '.') lasers.put(i*C + j, 0);
            }
            for(int i: fixed) {
                lasers.remove(i);
            }
            for(Choice c: choices) {
                for(int i: c.v) {
                    inc(lasers, i);
                }
                for(int i: c.h) {
                    inc(lasers, i);
                    
                }
            }
            while(!lasers.isEmpty()) {
                int min = getMin(lasers);
                if(lasers.get(min) == 0) {
                    e("Can't reach: " + min + " " + min/C + " " + min%C);
                    ok = false;
                    break;
                }
                for(Choice c: choices) {
                    boolean doit = false;
                    HashSet<Integer> use = null, nouse = null;
                    if(c.v.contains(min)) {
                        use = c.v;
                        nouse = c.h;
                        b[c.r][c.c] = '-';
                        doit = true;
                    } else if(c.h.contains(min)) {
                        use = c.h;
                        nouse = c.v;
                        b[c.r][c.c] = '|';
                        doit = true;
                    }
                    if(doit) {
                        for(int i: use) {
                            lasers.remove(i);
                        }
                        for(int i : nouse) {
                            dec(lasers, i);
                        }
                        break;
                    }
                }
            }
            if(!ok) {
                System.out.printf("Case #%d: IMPOSSIBLE\n", t);
                continue;
            }
            System.out.printf("Case #%d: POSSIBLE\n", t);
            for(int i = 0; i<R; i++) {
                System.out.println(new String(b[i]));
            }
            
        }
    }
    public int getMin(HashMap<Integer,Integer> l) {
        int min = Integer.MAX_VALUE;
        int o = -1;
        for(int i: l.keySet()) {
            if(l.get(i) < min) {
                min = l.get(i);
                o = i;
            }
        }
        return o;
    }
    public void inc(HashMap<Integer, Integer> lasers, int i) {
        if(lasers.containsKey(i)) lasers.put(i, lasers.get(i) + 1);
    }
    public void dec(HashMap<Integer, Integer> lasers, int i) {
        if(lasers.containsKey(i)) lasers.put(i, lasers.get(i) - 1);
    }
    HashSet<Integer> bfs(int ox, int oy, boolean ov) {
        HashSet<Integer> out = new HashSet<>();
        HashSet<Integer> vis = new HashSet<>();
        boolean v = ov;
        int x = ox;
        int y = oy;
        boolean fac = true;
        while(true) {
            if(v) y += fac? 1:-1;
            else x += fac? 1: -1;
            if(x == R || y == C || x < 0 || y < 0) break;
            if(b[x][y] == '|' || b[x][y] == '-') return null;
            if(b[x][y] == '#') break;
            int p = (x*C + y)*4 + (fac?2:0) + (v?1:0);
            if(vis.contains(p)) break;
            vis.add(p);
            if(b[x][y] == '/') {
                v = !v;
                fac = !fac;
            } else if(b[x][y] == '\\') {
                v = !v;
            } else {
                out.add(x*C + y);;
            }
        } 
        x = ox;
        y = oy;
        fac = false;
        v = ov;
        vis = new HashSet<>();
        while(true) {
            if(v) y += fac? 1:-1;
            else x += fac? 1: -1;
            if(x == R || y == C || x < 0 || y < 0) break;
            if(b[x][y] == '|' || b[x][y] == '-') return null;
            int p = (x*C + y)*4 + (fac?2:0) + (v?1:0);
            if(vis.contains(p)) break;
            vis.add(p);
            if(b[x][y] == '/') {
                v = !v;
                fac = !fac;
            } else if(b[x][y] == '\\') {
                v = !v;
            } else {
                out.add(x*C + y);;
            }
        } 
        return out;
    }
    int toInt(String s) {return Integer.parseInt(s);}
    int[] toInts(String s) {
        String[] a = s.split(" ");
        int[] o = new int[a.length];
        for(int i = 0; i<a.length; i++) o[i] = toInt(a[i]);
        return o;
    }
    void e(Object o) {
        System.err.println(o);
    }
    public static void main(String[] args) throws Exception{
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        (new C()).solve(in);
    }
}
