package round2;
import java.io.File;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;


public class GCJMall {
	
	private static class WW {
		int B;
		int E;
		int W;
		int id;
		public WW(int B, int E, int W, int id) { this.B = B; this.E = E; this.W = W; this.id = id; }
	}

	private static class OrderComparator implements Comparator<WW> {
		@Override
		public int compare(WW o1, WW o2) {
			return o1.B - o2.B;
		}
	}
	private static class SpeedComparator implements Comparator<WW> {
		@Override
		public int compare(WW o1, WW o2) {
			return o1.W - o2.W;
		}
	}
	
	private void solve(Scanner s) throws Exception {
		int[] B = new int[1000];
		int[] E = new int[1000];
		int[] W = new int[1000];
		
		
		int X = s.nextInt();
		int S = s.nextInt();
		int R = s.nextInt();
		double t = s.nextInt();

		int N = s.nextInt();
		WW[] WWs = new WW[N];
		for (int i = 0; i < N; i++) {
			B[i] = s.nextInt();
			E[i] = s.nextInt();
			W[i] = s.nextInt();
			
			WWs[i] = new WW(B[i], E[i], W[i], i);
		}
		
		Arrays.sort(WWs, new OrderComparator());
		long unused = 0;
		int lastEnd = 0;
		for (int i = 0; i < N; i++) {
			unused += (B[i]-lastEnd);
			lastEnd = E[i];
		}
		unused += X - lastEnd;
	
		
		double totTime = 0;
		
		/* run all the unused */
		if (unused / (double)R > t) {
			// deplete runtime
			totTime += t + (unused - t*R)/(double)S;
			t = 0;
		} else {
			totTime += unused / (double)R;
			t -= totTime;
		}
		
//		System.out.println("unused takes " + totTime);
		
		// the rest
		Arrays.sort(WWs, new SpeedComparator());
		for (int i = 0; i < N; i++) {
			final int L = WWs[i].E - WWs[i].B; 
			double time;
			
			if (L / ((double)R+WWs[i].W) >= t) {
				// deplete runtime
				time = t + (L - t*(R+WWs[i].W))/((double)S+WWs[i].W);
				t = 0;
			} else {
				time = L / ((double)R+WWs[i].W);
				t -= time;
			}
//			System.out.println(WWs[i].id + " takes " + time);
			totTime += time;
		}
		
		
//		System.out.println("totTime=" +totTime);
		out.print(" ");
		out.println(totTime);
		
	}
	
	
	final String INPUT_FILE_NAME = "A-small-attempt0.in";
	final String OUTPUT_FILE_NAME = "OUTA_0.txt";
	private PrintWriter out;
	
	private void run() throws Exception {
//		Scanner s = new Scanner(System.in);
		Scanner s = new Scanner(new File("C:\\gcj\\" + INPUT_FILE_NAME));
		
		out = new PrintWriter(new File("C:\\gcj\\" + OUTPUT_FILE_NAME));
//		System.setOut(null);
				
		int T = s.nextInt();
		for (int TEST = 1; TEST <= T; TEST++) {
			out.print(String.format("Case #%d:", TEST));
			solve(s);
		}
		s.close();
		out.flush();
		out.close();		
	}
	
	public static void main(String[] args) throws Exception {
		new GCJMall().run();
	}
}
