/*
 * Przemysław Horban (nr. albumu: 262940)
 * Uniwersystet Warszawski
 */

package codejam;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.util.HashSet;
import java.util.HashSet;
import java.util.Set;
import java.util.Scanner;
import java.util.Set;
import java.util.StringTokenizer;

/**
 *
 * @author Przemysław Horban <p.horban@mimuw.edu.pl>
 */

class Pt {
    int x, y;

    public Pt(int x, int y) {
        this.x = x;
        this.y = y;
    }


    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Pt other = (Pt) obj;
        if (this.x != other.x) {
            return false;
        }
        if (this.y != other.y) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 29 * hash + this.x;
        hash = 29 * hash + this.y;
        return hash;
    }

}

public class Main {

    /**
     * @param args the command line arguments
     */
    static Scanner in = new Scanner(new BufferedInputStream(System.in));

    public static void main(String[] args) {
        int tests = in.nextInt();
        for (int i = 0; i < tests; i++) {
            solve(i+1);
        }
    }

    private static void solve(int t) {
        Set<Pt> bacSet = new HashSet<Pt>();
        Set<Pt> addCand = new HashSet<Pt>(bacSet);
        int k = in.nextInt();

        for (int i = 0; i < k; i++) {
            int x1 = in.nextInt(),
                y1 = in.nextInt(),
                x2 = in.nextInt(),
                y2 = in.nextInt();

            for (int y = y1; y <= y2; y++) {
                for (int x = x1; x <= x2; x++) {
                    bacSet.add(new Pt(x, y));
                    addCand.add(new Pt(x-1, y));
                    addCand.add(new Pt(x, y+1));
                    addCand.add(new Pt(x, y-1));
                    addCand.add(new Pt(x+1, y));
                }
            }
        }

        Set<Pt> remCand = new HashSet<Pt>(bacSet);

        int phaseCount = 0;
        while (!bacSet.isEmpty()) {
            //printBacSet(bacSet);
            phaseCount++;
            Set<Pt> newRemCand = new HashSet<Pt>();
            Set<Pt> toRemove = new HashSet<Pt>();
            for (Pt p : remCand) {
                if (bacSet.contains(p)) {
                    if (!bacSet.contains(new Pt(p.x - 1, p.y)) && !bacSet.contains(new Pt(p.x, p.y - 1))) {
                        toRemove.add(p);
                        newRemCand.add(new Pt(p.x + 1, p.y));
                        newRemCand.add(new Pt(p.x, p.y + 1));
                    }
                }
            }

            Set<Pt> newAddCand = new HashSet<Pt>();
            Set<Pt> toAdd = new HashSet<Pt>();
            for (Pt p : addCand) {
                if (!bacSet.contains(p)) {
                    if (bacSet.contains(new Pt(p.x - 1, p.y)) && bacSet.contains(new Pt(p.x, p.y - 1))) {
                        toAdd.add(p);
                        newAddCand.add(new Pt(p.x + 1, p.y));
                        newAddCand.add(new Pt(p.x, p.y + 1));
                    }
                }
            }
            addCand = newAddCand;
            remCand = newRemCand;
            for (Pt p : toAdd) {
                bacSet.add(p);
            }
            for (Pt p : toRemove) {
                bacSet.remove(p);
            }
        }

        System.out.println("Case #" + t + ": " + phaseCount);
    }

    private static void printBacSet(Set<Pt> bacSet) {
        int n = 6;
        char[][] m = new char[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                m[i][j] = '0';
            }
        }
        for (Pt pt : bacSet) {
            m[pt.y][pt.x] = '1';
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                System.out.print(m[i][j]);
            }
            System.out.println("");
        }
            System.out.println("");
    }

}
