package eyal;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;

public class CJ2011QB {

	public static void main(String[] args) {
		BufferedReader bf = null;
		BufferedWriter bw = null;
		
		try {
			bf = new BufferedReader(new FileReader("./src/eyal/" + args[0] + ".in"));
			bw = new BufferedWriter(new FileWriter("./src/eyal/" + args[0] + ".out"));
			
			int N = Integer.valueOf(bf.readLine());

			for (int n=0; n < N; n++) {
				magicka(bf, bw, n);
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (bw != null) bw.close();
				if (bf != null) bf.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	/**
	 * http://code.google.com/codejam/contest/dashboard?c=975485#s=p1
	 */
	private static void magicka(BufferedReader bf, BufferedWriter bw, int caseNum) throws NumberFormatException, IOException {
		String[] ia = bf.readLine().split(" ");
		
		int nC = Integer.valueOf(ia[0]);
		HashMap<String, String> C = new HashMap<String, String>();
		
		for (int i = 0; i < nC; i++ ) {
			String[] rule = ia[i+1].split("");
			
			C.put(rule[1] + rule[2], rule[3]);
			C.put(rule[2] + rule[1], rule[3]);
		}
		
		int nD = Integer.valueOf(ia[nC+1]);
		String[] D = new String[nD];
		
		for (int i = 0; i < nD; i++ ) {
			D[i] = ia[i+nC+2];
		}
		
		int nT = Integer.valueOf(ia[nC + nD + 2]);
		
		String T = ia[ia.length - 1];

		StringBuffer res = new StringBuffer();
		
		HashMap<String, Integer> delCheck = new HashMap<String, Integer>();
		
		for (int i = 0; i < nT; i++) {
			String cur = String.valueOf(T.charAt(i));
			
			// add new letter
			res.append(cur);

			// update deletion map
			if (delCheck.containsKey(cur)) {
				delCheck.put(cur, delCheck.get(cur) + 1);
			} else {
				delCheck.put(cur, 1);
			}
			
			// perform substitutions
			while (true) {
				if (res.length() < 2) break;
				
				int lastTwoPlace = res.length()-2;
				String lastTwo = res.substring(lastTwoPlace);
				String newEnd = C.get(lastTwo);
				
				if (newEnd != null) {
					res.replace(lastTwoPlace, res.length(), newEnd);
					
					// update deletion map
					delCheck.put(lastTwo.substring(0,1), delCheck.get(lastTwo.substring(0,1)) - 1);
					delCheck.put(lastTwo.substring(1,2), delCheck.get(lastTwo.substring(1,2)) - 1);
				}
				
				break;				
			}
			
			// check opposing elements
			for (int j = 0; j < nD; j++) {
				if (	delCheck.containsKey(D[j].substring(0,1)) &&
						delCheck.get(D[j].substring(0,1)) > 0 &&
						delCheck.containsKey(D[j].substring(1,2)) &&
						delCheck.get(D[j].substring(1,2)) > 0) {
					
					delCheck.clear();
					res.delete(0, res.length());
				}
			}
		}
		
		bw.write("Case #" + (caseNum+1) + ": [");
		
		for (int i = 0; i < res.length() - 1; i++) {
			bw.write(res.charAt(i) + ", ");
		}
		
		if (res.length() > 0) {
			bw.write(res.charAt(res.length()-1));
		}
		
		bw.write("]\n");
	}
}
