package cj2014_q;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class CJ2014_q_c {

	public final static String LOC = "./cj2014_q/"; // the package name, cj, is where you should put input files

	public static void main(String[] args) {
		try (	BufferedReader bf = new BufferedReader(new FileReader(LOC + args[0] + ".in"));
				BufferedWriter bw = new BufferedWriter(new FileWriter(LOC + args[0] + ".out"));) {
			
			int numberOfCases = Integer.valueOf(bf.readLine());

			for (int caseNum=1; caseNum <= numberOfCases; caseNum++) {
				String result = solve(bf);
				
				bw.write("Case #" + (caseNum) + ": "  + result + "\n");
				
				System.out.println("Case #" + (caseNum) + ": " + result); // for your convenience

			}
		} catch (NumberFormatException | IOException e) {
			e.printStackTrace();
		}
	}
	
	private static String solve(BufferedReader bf) throws NumberFormatException, IOException {
		String[] s = bf.readLine().split(" ");
		
		int R = Integer.valueOf(s[0]);
		int C = Integer.valueOf(s[1]);
		int M = Integer.valueOf(s[2]);
		
		if ((R != 1 && C != 1) && ((M == R*C - 2 || (M == R*C - 3 && R*C != 6)))) {
			return "\nImpossible";
		}
		
		boolean special = R*C == 6 && M == 3;
		
		String spares = M == R*C - 1 || special ? "*" : ".";
	
		StringBuilder sb = new StringBuilder("\nc");
		
		if (R == 1) {
			int f = R*C - M - 1;
			
			for (int i=1; i<C; i++) {
				if (f > 0) {
					sb.append(".");
					f--;
				} else {
					sb.append("*");
				}
			}
		} else if (C == 1) {
			int f = R*C - M - 1;
			
			for (int i=1; i<R; i++) {
				if (f > 0) {
					sb.append("\n.");
					f--;
				} else {
					sb.append("\n*");
				}
			}
		} else {
			int f = special ? 2 : R*C - M - 4;
			
			sb.append(spares);
			
			for (int i=2; i<C; i++) {
				if (f > 0) {
					sb.append(".");
					f--;
				} else {
					sb.append("*");
				}
			}
			
			sb.append("\n" + spares + spares);
			
			for (int i=2; i<C; i++) {
				if (f > 0) {
					sb.append(".");
					f--;
				} else {
					sb.append("*");
				}
			}

			for (int i=2; i<R; i++) {
				sb.append("\n");

				for (int j=0; j<C; j++) {
					if (f > 0) {
						sb.append(".");
						f--;
					} else {
						sb.append("*");
					}
				}
			}
		}
		
		return sb.toString();
	}
}
