package cj2013;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

// https://code.google.com/codejam/contest/2270488/dashboard#s=p0
public class CJ2013_Q_A {

	public final static String LOC = "./src/cj2013/";

	public static void main(String[] args) {
		try (	BufferedReader bf = new BufferedReader(new FileReader(LOC + args[0] + ".in"));
				BufferedWriter bw = new BufferedWriter(new FileWriter(LOC + args[0] + ".out"));) {
			
			int N = Integer.valueOf(bf.readLine());

			for (int n=1; n <= N; n++) {
				String result = solve(bf, bw);
				
				bw.write("Case #" + n + ": "  + result + "\n");
				
				System.out.println("Case #" + n + ": " + result);

			}
		} catch (NumberFormatException | IOException e) {
			e.printStackTrace();
		}
	}
	
	private static String solve(BufferedReader bf, BufferedWriter bw) throws NumberFormatException, IOException {
		char[][] board = new char[4][4];

		boolean done = true;
		
		for (int i=0; i<4; i++) {
			String row = bf.readLine();
			
			for (int j=0; j<4; j++) {
				board[i][j] = row.charAt(j);
				
				if (board[i][j] == '.') done = false;
			}
		}

		bf.readLine();
		
		char[] players = {'O', 'X'};
		
		for (char i : players) {
			if (checkRow(board, i) || checkColumn(board, i) || checkDiagonal(board, i)) {
				return i + " won";
			}
		}
		
		if (done)
			return "Draw";
		else
			return "Game has not completed";
		
	}
	
	private static boolean checkRow(char[][] board, char p) {
		for (int i=0; i<4; i++) {
			boolean success = true;
			for (int j=0;j<4;j++) {
				if (board[i][j] != p && board[i][j] != 'T' ) success = false;
			}
			if (success) return true;
		}
		
		return false;
	}
	
	private static boolean checkColumn(char[][] board, char p) {
		for (int i=0; i<4; i++) {
			boolean success = true;
			for (int j=0;j<4;j++) {
				if (board[j][i] != p && board[j][i] != 'T' ) success = false;
			}
			if (success) return true;
		}
		
		return false;
	}
	
	private static boolean checkDiagonal(char[][] board, char p) {
		boolean success = true;
		for (int i=0; i<4; i++) {
			if (board[i][i] != p && board[i][i] != 'T' ) success = false;
		}

		if (success)
			return true;

		success = true;

		for (int i=0; i<4; i++) {
			if (board[i][3-i] != p && board[i][3-i] != 'T' ) success = false;
		}

		return success;
	}
}
