package cj2014_q;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Arrays;

public class CJ2014_q_b {

	public final static String LOC = "./cj2014_q/"; // the package name, cj, is where you should put input files

	public final static NumberFormat FORMATTER = new DecimalFormat("#0.0000000");
	
	public static void main(String[] args) {
		try (	BufferedReader bf = new BufferedReader(new FileReader(LOC + args[0] + ".in"));
				BufferedWriter bw = new BufferedWriter(new FileWriter(LOC + args[0] + ".out"));) {
			
			int numberOfCases = Integer.valueOf(bf.readLine());

			for (int caseNum=1; caseNum <= numberOfCases; caseNum++) {
				String result = solve(bf);
				
				bw.write("Case #" + (caseNum) + ": "  + result + "\n");
				
				System.out.println("Case #" + (caseNum) + ": " + result); // for your convenience

			}
		} catch (NumberFormatException | IOException e) {
			e.printStackTrace();
		}
	}
	
	private static String solve(BufferedReader bf) throws NumberFormatException, IOException {
		String[] first = bf.readLine().split(" ");
		
		double C = Double.valueOf(first[0]);
		
		double F = Double.valueOf(first[1]);
		
		double X = Double.valueOf(first[2]);
		
		double time = 0;
		double rate = 2;
		
		while (true) {
		
			double doNothing = X / rate;
			
			double nextFactory = C / rate;
			
			double getAFactory = (nextFactory) + (X / (rate + F));
			
			if (doNothing <= getAFactory) {
				return FORMATTER.format(time + doNothing);
			} else {
				time += nextFactory;
				rate += F;
			}
		}
	}
}
