package cj2013;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

// https://code.google.com/codejam/contest/2270488/dashboard#s=p1
public class CJ2013_Q_B {

	public final static String LOC = "./src/cj2013/";

	public static void main(String[] args) {
		try (	BufferedReader bf = new BufferedReader(new FileReader(LOC + args[0] + ".in"));
				BufferedWriter bw = new BufferedWriter(new FileWriter(LOC + args[0] + ".out"));) {
			
			int N = Integer.valueOf(bf.readLine());

			CJ2013_Q_B instance = new CJ2013_Q_B();
			
			for (int n=1; n <= N; n++) {
				String result = instance.solve(bf, bw);
				
				bw.write("Case #" + n + ": "  + result + "\n");
				
				System.out.println("Case #" + n + ": " + result);

			}
		} catch (NumberFormatException | IOException e) {
			e.printStackTrace();
		}
	}
	
	private String solve(BufferedReader bf, BufferedWriter bw) throws NumberFormatException, IOException {
		String[] dims = bf.readLine().split(" ");
		
		short n = Short.valueOf(dims[0]);
		short m = Short.valueOf(dims[1]);
		
		short[][] lawn = new short[n][m];

		for (int i=0; i<n; i++) {
			String row[] = bf.readLine().split(" ");
			
			for (int j=0; j<m; j++) {
				lawn[i][j] = Short.valueOf(row[j]);
			}
		}
		
		for (int i=0; i<n; i++) {
			for (int j=0; j<m; j++) {
				if (cantRow(lawn, i, j) && cantColumn(lawn, i, j))
					return "NO";
			}
		}
		
		return "YES";
	}

	private boolean cantRow(short[][] lawn, int i, int j) {
		for (int x=0; x<lawn[i].length;x++) {
			if (lawn[i][x] > lawn[i][j]) return true;
		}
		
		return false;
	}
	
	private boolean cantColumn(short[][] lawn, int i, int j) {
		for (int x=0; x<lawn.length;x++) {
			if (lawn[x][j] > lawn[i][j]) return true;
		}
		
		return false;
	}
}
