package cj2015_q;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Arrays;
import java.util.Comparator;
import java.util.PriorityQueue;

public class CJ2015_q_b {

	public final static String LOC = "./cj2015_q/"; // the package name, cj, is where you should put input files

	public final static NumberFormat FORMATTER = new DecimalFormat("#0.0000000");
	
	public static void main(String[] args) {
		try (	BufferedReader bf = new BufferedReader(new FileReader(LOC + args[0] + ".in"));
				BufferedWriter bw = new BufferedWriter(new FileWriter(LOC + args[0] + ".out"));) {
			
			int numberOfCases = Integer.valueOf(bf.readLine());

			for (int caseNum=1; caseNum <= numberOfCases; caseNum++) {
				String result = solve(bf);
				
				bw.write("Case #" + (caseNum) + ": "  + result + "\n");
				
				System.out.println("Case #" + (caseNum) + ": " + result); // for your convenience

			}
		} catch (NumberFormatException | IOException e) {
			e.printStackTrace();
		}
	}
	
	private static String solve(BufferedReader bf) throws NumberFormatException, IOException {
		int D = Integer.valueOf(bf.readLine());
		
		String[] people = bf.readLine().split(" ");
		
		PriorityQueue<Integer> pq = new PriorityQueue<>(people.length, new ReverseIntComp());
		
		for (String s : people) { pq.add(Integer.valueOf(s)); }

		return Integer.toString(pancake(pq));
	}

	private static int pancake(PriorityQueue<Integer> pq) {
		
		int max = pq.peek();
		
		if (max <= 3) return max;

		PriorityQueue<Integer> npq = new PriorityQueue<>(pq);
		
		npq.remove();
		npq.add(max / 2);
		npq.add((max / 2) + (max % 2));

		pq.remove();
		pq.add(max - 3);
		pq.add(3);
		
		return Math.min(max, (max < 9 ? 1 + pancake(npq) : 1 + Math.min(pancake(pq), pancake(npq))));
	}
	
	public static class ReverseIntComp implements Comparator<Integer> {

		@Override
		public int compare(Integer o1, Integer o2) {
			return o1.compareTo(o2) * -1;
		}
		
	}
}
