package cj2012;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

public class CJ2012QA {

	public static void main(String[] args) {
		BufferedReader bf = null;
		BufferedWriter bw = null;
		
		try {
			bf = new BufferedReader(new FileReader("./src/cj2012/" + args[0] + ".in"));
			bw = new BufferedWriter(new FileWriter("./src/cj2012/" + args[0] + ".out"));
			
			int N = Integer.valueOf(bf.readLine());

			for (int n=0; n < N; n++) {
				translate(bf, bw, n);
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (bw != null) bw.close();
				if (bf != null) bf.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	final static Map letters = new HashMap<String, String>(27);
	
	static {
		letters.put(" ", " ");
		letters.put("a", "y");
		letters.put("b", "h");
		letters.put("c", "e");
		letters.put("d", "s");
		letters.put("e", "o");
		letters.put("f", "c");
		letters.put("g", "v");
		letters.put("h", "x");
		letters.put("i", "d");
		letters.put("j", "u");
		letters.put("k", "i");
		letters.put("l", "g");
		letters.put("m", "l");
		letters.put("n", "b");
		letters.put("o", "k");
		letters.put("p", "r");
		letters.put("q", "z");
		letters.put("r", "t");
		letters.put("s", "n");
		letters.put("t", "w");
		letters.put("u", "j");
		letters.put("v", "p");
		letters.put("w", "f");
		letters.put("x", "m");
		letters.put("y", "a");
		letters.put("z", "q");
	}
	
	/**
	 * https://code.google.com/codejam/contest/1460488/dashboard#s=p0
	 */
	private static void translate(BufferedReader bf, BufferedWriter bw, int caseNum) throws NumberFormatException, IOException {
		String line = bf.readLine();
		
		String output = "";
		
		for (int i = 0; i < line.length(); i++) {
			output = output + letters.get(line.substring(i, i+1));
		}
		
		bw.write("Case #" + (caseNum+1) + ": " + output + "\n");
	}
}
