package cj2014_1b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class CJ2014_1b_a {

	public final static String LOC = "./cj2014_1b/"; // the package name, cj, is where you should put input files

	public static void main(String[] args) {
		try (	BufferedReader bf = new BufferedReader(new FileReader(LOC + args[0] + ".in"));
				BufferedWriter bw = new BufferedWriter(new FileWriter(LOC + args[0] + ".out"));) {
			
			int numberOfCases = Integer.valueOf(bf.readLine());

			for (int caseNum=1; caseNum <= numberOfCases; caseNum++) {
				String result = solve(bf);
				
				bw.write("Case #" + (caseNum) + ": "  + result + "\n");
				
				System.out.println("Case #" + (caseNum) + ": " + result); // for your convenience

			}
		} catch (NumberFormatException | IOException e) {
			e.printStackTrace();
		}
	}
	
	private static String solve(BufferedReader bf) throws NumberFormatException, IOException {
		int N = Integer.valueOf(bf.readLine());
		
		String[] words = new String[N];
		
		for (int i=0; i< N; i++) {
			words[i]= bf.readLine();
		}
		
		String canonical = canonize(words[0], null, 0, null);
		
		int[][] letters = new int[N][canonical.length()];
		int[] totals = new int[canonical.length()];
		
		for (int i=0; i< N; i++) {
			if (! canonical.equals(canonize(words[i], letters, i, totals))) {
				return "Fegla Won";
			}
		}

		int total = 0;

		for (int i=0; i< canonical.length();i++) {
			int avg = totals[i] / N;
	
			for (int j=0; j < N; j++) {
				total = total + Math.abs(letters[j][i] - avg);
			}
		}
		
		return "" + total;
	}
	
	private static String canonize(String s, int[][] letters, int j, int[] totals) {
		String canonical = "" + s.charAt(0);
		
		for (int i=1; i< s.length(); i++) {
			if (s.charAt(i) != s.charAt(i-1)) {
				canonical += s.charAt(i);
			} else {
				if (letters != null) {
					
					int p = canonical.length() - 1;
					
					if (letters[j].length <= p) return "";
					
					letters[j][p] ++;
					totals[p] ++;
				}
			}
		}
		
		return canonical;
	}
}
