package cj2011;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class CJ2011QA {

	public static void main(String[] args) {
		BufferedReader bf = null;
		BufferedWriter bw = null;
		
		try {
			bf = new BufferedReader(new FileReader("./src/cj2011/" + args[0] + ".in"));
			bw = new BufferedWriter(new FileWriter("./src/cj2011/" + args[0] + ".out"));
			
			int N = Integer.valueOf(bf.readLine());

			for (int n=0; n < N; n++) {
				robots(bf, bw, n);
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (bw != null) bw.close();
				if (bf != null) bf.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	/**
	 * http://code.google.com/codejam/contest/dashboard?c=975485#s=p0
	 */
	private static void robots(BufferedReader bf, BufferedWriter bw, int caseNum) throws NumberFormatException, IOException {
		String[] ia = bf.readLine().split(" ");
		
		int n = Integer.valueOf(ia[0]);
		
		int[] H = new int[n];
		int[] B = new int[n];
		
		int c = 1;
		
		for (int i = 0; i < n; i++) {
			H[i] = ia[c].equals("O") ? 0 : 1; // O = 0, B = 1
			B[i] = Integer.valueOf(ia[c+1]);
			c = c + 2;
		}
		
		int t[] = {0, 0}; // starting time
		int p[] = {1, 1}; // starting places
		
		for (int i=0 ;i < n; i++) {
			int who = H[i];
			int other = who == 0 ? 1 : 0;
			
			int toMove = Math.abs(B[i] - p[who]);
			
			// move
			t[who] = t[who] + toMove;

			boolean waited = false;
			
			// waiting for the other robot
			if (t[other] > t[who]) {
				waited = true;
				t[who] = t[other] + 1; // wait as much as necessary, then push the button
			} else {
				t[who]++; // push the button;
			}
			
			System.out.println(who + " moved from " + p[who] + " to " + B[i] + " in " + toMove + (waited ? " and waited" : "") + " finishing at " + t[who]);

			p[who] = B[i]; // update position

		}
		
		bw.write("Case #" + (caseNum+1) + ": " + Math.max(t[0], t[1]) + "\n");
		
		System.out.println ("--- Case #" + (caseNum+1) + ": " + Math.max(t[0], t[1]) + " ---");
	}
}
