import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class Dijkstra {
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader("/home/e/Downloads/C-small-attempt0.in"));
		BufferedWriter bw = new BufferedWriter(new FileWriter("/home/e/Documents/Dijkstra.out"));
		int times = Integer.parseInt(br.readLine());
		for(int time = 1; time <= times; time++) {
			StringTokenizer st = new StringTokenizer(br.readLine());
			st.nextToken();
			int repeat = Integer.parseInt(st.nextToken());
			String stem = br.readLine();
			String completed = "";
			for(int i = 0; i < repeat; i++) {
				completed += stem;
			}
			if(reduce(completed)) {
				bw.write("Case #" + time + ": YES\n");
			}
			else {
				bw.write("Case #" + time + ": NO\n");
			}
		}
		br.close();
		bw.close();
	}
	
	public static boolean reduce(String s) {
		int letters = 0;
		while(s.length() > 0) {
			if(s.charAt(0) == '-') {
				if(s.charAt(1) == '-') {
					s = s.substring(2);
					continue;
				}
				else if (s.length() > 2){
					s = "-" + multiply(s.charAt(1), s.charAt(2)) + s.substring(3);
					continue;
				}
				else {
					break;
				}
			}
			if(s.charAt(0) == (char) (letters + (int) 'i')) {
				if(letters < 2) {
					s = s.substring(1);
					letters++;
					continue;
				}
				else {
					if(s.length() == 1) {
						letters++;
						break;
					}
				}
			}
			if(s.length() > 2) {
				s = multiply(s.charAt(0), s.charAt(1)) + s.substring(2);
			}
			else if(s.length() == 2){
				s = multiply(s.charAt(0), s.charAt(1));
			}
			else {
				break;
			}
		}
		if(s.equals("ijk") || letters == 3) {
			return true;
		}
		return false;
		
	}
	
	public static String multiply(char a, char b) {
		switch(a) {
		case '1':
			return String.valueOf(b);
		case 'i':
			switch(b) {
			case '1':
				return "i";
			case 'i':
				return "-1";
			case 'j':
				return "k";
			case 'k':
				return "-j";
			}
		case 'j':
			switch(b) {
			case '1':
				return "j";
			case 'i':
				return "-k";
			case 'j':
				return "-1";
			case 'k': 
				return "i";
			}
		case 'k':
			switch(b) {
			case '1':
				return "k";
			case 'i':
				return "j";
			case 'j':
				return "-i";
			case 'k':
				return "-1";
			}
		}
		return null;
	}
}
