package quaternion;

import java.io.File;
import java.io.IOException;

import org.apache.commons.io.FileUtils;

public class CopyOfQuaternion {

	private static String multiply(String first, String second) {
		if ("1".equals(first)) {
			return second;
		}
		if ("1".equals(second)) {
			return first;
		}
		switch (first) {
		case "i":

			switch (second) {
			case "i":
				return "-1";
			case "j":
				return "k";
			case "k":
				return "-j";
			}

			break;
		case "j":
			switch (second) {
			case "i":
				return "-k";
			case "j":
				return "-1";
			case "k":
				return "i";
			}
			break;
		case "k":
			switch (second) {
			case "i":
				return "j";
			case "j":
				return "-i";
			case "k":
				return "-1";
			}
			break;
		}
		return null;
	}

	private static String multiplyWithSign(String first, String second) {
		int firstSign = computeSign(first);
		int secondSign = computeSign(second);

		String tempMult = multiply(positive(first), positive(second));

		int tempMultSign = computeSign(tempMult);

		String tempMultNoSign = positive(tempMult);

		if (firstSign * secondSign * tempMultSign == -1) {
			return "-" + tempMultNoSign;
		} else {
			return tempMultNoSign;
		}
	}

	private static String positive(String figure) {
		if (computeSign(figure) == -1) {
			return figure.substring(1);
		}
		return figure;
	}

	private static int computeSign(String figure) {
		if (figure.startsWith("-")) {
			return -1;
		} else {
			return 1;
		}
	}

	private static boolean allTheSame(String toSplit) {
		String charOne = "" + toSplit.charAt(0);
		for (int i = 0; i < toSplit.length(); i++) {
			if (!charOne.equals("" + toSplit.charAt(i))) {
				return false;
			}
		}
		return true;
	}

	public static void main(String[] args) throws IOException {
		boolean firstLine = true;
		boolean isOddLine = true;
		int caseNumber = 0;
		FileUtils.writeStringToFile(new File("result.txt"), "", false);
		int number = 0;
		for (String oneLine : FileUtils.readLines(new File("C-small-attempt2.in"))) {
			if (firstLine) {
				firstLine = false;
			} else {
				if (isOddLine) {

					number = Integer.valueOf(oneLine.split(" ")[1]);
					isOddLine = false;
					caseNumber++;

				} else {
					isOddLine = true;

					String toSplit = "";
					for (int i = 0; i < number; i++) {
						toSplit += oneLine;
					}
					if (allTheSame(oneLine)) {
						System.out.println("Case #" + caseNumber + ": NO");
						FileUtils.writeStringToFile(new File("result.txt"),
								"Case #" + caseNumber + ": NO\n", true);
						continue;
					}

					int index1 = 0;
					String product1 = "1";
					String product2 = "1";
					String product3 = "1";
					String subString1 = "";
					String subString2 = "";
					String subString3 = "";
					do {
						do {
							product1 = multiplyWithSign(product1,
									"" + toSplit.charAt(index1));
							subString1 += ("" + toSplit.charAt(index1));
							index1++;
						} while (!"i".equals(product1)
								&& index1 + 2 < toSplit.length());
						if ("i".equals(product1)) {
							int index2 = index1;

							do {
								product2 = multiplyWithSign(product2, ""
										+ toSplit.charAt(index2));
								subString2 += ("" + toSplit.charAt(index2));
								index2++;
							} while (!"j".equals(product2)
									&& index2 + 1 < toSplit.length());
							if ("j".equals(product2)) {
								int index3 = index2;
								do {
									product3 = multiplyWithSign(product3, ""
											+ toSplit.charAt(index3));
									subString3 += ("" + toSplit.charAt(index3));
									index3++;
								} while (!"k".equals(product3)
										&& index3 < toSplit.length());
								// if ("k".equals(product3)) {
								// System.out.println("OK");
								// System.out.println("split: " + subString1 +
								// "/"
								// + subString2 + "/" + subString3);
								// }
							}
						}
					} while ((!"i".equals(product1) || !"j".equals(product2) || !"k"
							.equals(product3))
							&& (index1 + 2 < toSplit.length()));

					if ("i".equals(product1) && "j".equals(product2)
							&& "k".equals(product3)) {
						System.out.println("Case #" + caseNumber + ": YES");
						FileUtils.writeStringToFile(new File("result.txt"),
								"Case #" + caseNumber + ": YES\n", true);
						System.out.println("\tsplit: " + subString1 + "/"
								+ subString2 + "/" + subString3);
					} else {
						System.out.println("Case #" + caseNumber + ": NO");
						FileUtils.writeStringToFile(new File("result.txt"),
								"Case #" + caseNumber + ": NO\n", true);
					}
				}
			}
		}

	}
}
