package exo2;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.apache.commons.io.FileUtils;

public class App2 {

	private static List<Integer> primes;

	static {
		int status = 1;
		int num = 3;
		primes = new LinkedList<>();
		primes.add(2);
		for (int i = 2; i <= 1000;) {
			for (int j = 2; j <= Math.sqrt(num); j++) {
				if (num % j == 0) {
					status = 0;
					break;
				}
			}
			if (status != 0) {
				primes.add(num);
				i++;
			}
			status = 1;
			num++;
		}
		

	}

	public static void main(String[] args) throws IOException {

		int N = 16;
		String maskRepresentation = "1";
		for (int i = 1; i < N - 1; i++) {
			maskRepresentation = maskRepresentation + "0";
		}
		maskRepresentation = maskRepresentation + "1";
		int j = 50;
		BigInteger numberInBase2 = new BigInteger(maskRepresentation, 2);
		StringBuilder output = new StringBuilder("Case #1:\n");
		while (j != 0) {

			maskRepresentation = numberInBase2.toString(2);
			// System.out.println("before");
			while (!(maskRepresentation.startsWith("1") && maskRepresentation.endsWith("1"))) {
				numberInBase2 = numberInBase2.add(new BigInteger("1"));
				maskRepresentation = numberInBase2.toString(2);
			}
			// System.out.println("trying: "+maskRepresentation);
			boolean notFound = false;
			Map<Integer, Integer> dividers = new HashMap<>();
			for (int currentBase = 2; currentBase <= 10; currentBase++) {
				BigInteger inAnotherBase = new BigInteger(maskRepresentation, currentBase);
				Integer divider = numberGotAnEasyDivider(inAnotherBase);
				if (divider != null) {
					// System.out.println("base: " + currentBase +
					// ";easydivider: " + divider);
					dividers.put(currentBase, divider);
				} else {
					// System.out.println("no divider in base: " + currentBase);
					notFound = true;
					break;
				}

			}
			if (!notFound) {
				String result = maskRepresentation;
				for (int i = 2; i <= 10; i++) {
					result += (" " + dividers.get(i));
				}
				output.append(result);
				j--;
				if (j > 0) {
					output.append("\n");
				}
			}
			numberInBase2 = numberInBase2.add(new BigInteger("1"));
		}
		System.out.println(output.toString());
		FileWriter fw = new FileWriter("coins_16.out");
		fw.write(output.toString());
		fw.close();

	}

	private static Integer numberGotAnEasyDivider(BigInteger inbase3) {
		for (int onePrime : primes) {
			if (inbase3.mod(new BigInteger("" + onePrime)).intValue() == 0) {
				return onePrime;
			}
		}
		return null;
	}

}
