package exo1;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class App {

	
	public static void main(String[] args) throws FileNotFoundException, IOException {
		int caseNumber = 0;
		FileWriter fw = new FileWriter("A-large.out");
		try(BufferedReader br = new BufferedReader(new FileReader(new File("A-large.in")))) {
		    for(String line; (line = br.readLine()) != null; ) {
		        if (caseNumber >0){
		        	fw.write(processNumber(line,caseNumber));
		        }
		        caseNumber++;
		    }
		}
		fw.close();
		
		
	}

	private static String processNumber(String number,int caseNumber) {
		List<String> missingDigits = Arrays.asList(new String[]{"0","1","2","3","4","5","6","7","8","9"});
		String current = number;
		missingDigits = checkMissing(missingDigits,current);
		if (missingDigits.isEmpty()) {
			return "Case #"+caseNumber+": "+current+"\n";
		}
		current = new StringBuilder(current).reverse().toString();
		if (current.replaceAll("0", "").isEmpty()) {
			return "Case #"+caseNumber+": INSOMNIA\n";
		}
		int[] base = generateBase(current);
		while(!missingDigits.isEmpty()) {
			current = add(base,current);
			missingDigits = checkMissing(missingDigits, current);
		}
		return "Case #"+caseNumber+": "+((new StringBuilder(current)).reverse().toString()+"\n");
	}

	private static String add(int[] base, String current) {
		int overflow = 0;
		StringBuilder result = new StringBuilder();
		for (int i = 0; i<current.length();i++) {
			int mult = Character.getNumericValue(current.charAt(i))+overflow;
			if (i<base.length) {
				mult += base[i];
			} 
			int value = mult;
			if (mult > 9) {
				overflow = 1;
				value = mult-10;
			}
			else {
				overflow = 0;
			}
			result.append(value);
		}
		if (overflow>0) {
			result.append(overflow);
		}
		return result.toString();
	}

	private static int[] generateBase(String current) {
		int[] result = new int[current.length()];
		for (int i = 0; i<current.length();i++) {
			result[i] = Character.getNumericValue(current.charAt(i));
		}
		return result;
	}

	private static List<String> checkMissing(List<String> missingDigits, String current) {
		List<String> newMissing = new ArrayList<String>();
		for(String oneDigit:missingDigits) {
			if (!current.contains(oneDigit)) {
				newMissing.add(oneDigit);
			}
		}
		return newMissing;
	}
}
