import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;

public class Matrix {

	public static void main(String[] args) throws NumberFormatException,
	IOException {
		File f = new File("B-large.in");
		FileInputStream fos = new FileInputStream(f);
		BufferedReader br = new BufferedReader(new InputStreamReader(fos));

		File result = new File("result");
		BufferedWriter bw = new BufferedWriter(new FileWriter(result,false));

		int numberOfTest = Integer.valueOf(br.readLine());

		int testIndex = 0;
		while (testIndex <numberOfTest)
		{
			String[] size = br.readLine().split(" ");
			int matrixRow = Integer.valueOf(size[0]);
			int matrixCol = Integer.valueOf(size[1]);
			bw.write("Case #"+(testIndex+1)+": "+analyzeOneMatrix(matrixRow,matrixCol,br));
			bw.newLine();
			testIndex++;
		}
		
		bw.close();

	}

	private static String analyzeOneMatrix(int matrixRow, int matrixCol,
			BufferedReader br) throws IOException {
		int[][] matrix = new int[matrixRow][matrixCol];
		for (int indexOnRow = 0; indexOnRow < matrixRow; indexOnRow++)
		{
			String[] lineContent = br.readLine().split(" ");
			for (int indexOnCol = 0; indexOnCol < matrixCol; indexOnCol++)
			{
				matrix[indexOnRow][indexOnCol] = Integer.valueOf(lineContent[indexOnCol]);
			}
		}
		
		for (int indexOnRow = 0; indexOnRow < matrixRow; indexOnRow++)
		{
			for (int indexOnCol = 0; indexOnCol < matrixCol; indexOnCol++)
			{
				if (hasBiggerElementHorizontal(matrix,indexOnRow,indexOnCol,matrixRow) &&
						hasBiggerElementVertical(matrix,indexOnRow,indexOnCol)) {
					return "NO";
				}
			}
		}
		
		
		return "YES";
		
	}

	private static boolean hasBiggerElementVertical(int[][] matrix,
			int indexOnRow, int indexOnCol) {
		int value = matrix[indexOnRow][indexOnCol];
		for(int element:matrix[indexOnRow])
		{
			if (element > value) {
				return true;
			}
		}
		return false;
	}

	private static boolean hasBiggerElementHorizontal(int[][] matrix,
			int indexOnRow, int indexOnCol,int maxRow) {
		int value = matrix[indexOnRow][indexOnCol];
		for(int index = 0; index < maxRow;index++)
		{
			int element = matrix[index][indexOnCol];
			if (element > value) {
				return true;
			}
		}
		return false;
	}


}
