package com.company;

import com.company.entity.PancakeFlipper;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Scanner;
import java.util.stream.Collectors;

public class Main {

    public String[] pancakeLines;

    public static void main(String[] args) {

        String[] inFiles = new String[]{
                "A-large.in"
        };

        for (String files : inFiles) {
            try {
                System.out.println(files);
                loadData("in" + File.separator + files);
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }

        }
    }

    public static void loadData(String path) throws FileNotFoundException {
        Scanner sc = new Scanner(new File(path));
        int numberOfCases = Integer.parseInt(sc.nextLine());
        PrintWriter writer = null;
        try {
            writer = new PrintWriter(path + ".out", "UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        for(int i = 1; i< numberOfCases+1; i++)
        {
            String line = sc.nextLine();
            String[] parts = line.split(" ");
            int output = processPancake(parts[0].toCharArray(),Integer.parseInt(parts[1]));
            if (output >= 0)
                writer.println("CASE #" + i + ": " + output);
            else
                writer.println("CASE #" + i + ": IMPOSSIBLE");
        }
        writer.close();

    }

    private static int processPancake(char[] line, int size) {
        int amountOfFlips = 0;
        for(int i=0; i< line.length-size+1;i++)
        {
            if(line[i]=='-')
            {
                for (int j = i; j < i+size; j++) {
                    if(line[j]=='-')
                        line[j]='+';
                    else
                        line[j]='-';
                }
                amountOfFlips++;
            }
        }

        for (int i = line.length-size; i < line.length; i++) {
            if(line[i]=='-')
                amountOfFlips=-1;
        }
        return amountOfFlips;
    }

}
