package com.company;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;

public class ex3 {

    public String[] pancakeLines;

    public static void main(String[] args) {

        String[] inFiles = new String[]{
                "C-small-1-attempt0.in"
        };

        for (String files : inFiles) {
            try {
                System.out.println(files);
                loadData("in" + File.separator + files);
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }

        }
    }

    public static void loadData(String path) throws FileNotFoundException {
        Scanner sc = new Scanner(new File(path));
        int numberOfCases = Integer.parseInt(sc.nextLine());
        PrintWriter writer = null;
        try {
            writer = new PrintWriter(path + ".out", "UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        for(int i = 1; i< numberOfCases+1; i++)
        {
            String[] parts = sc.nextLine().split(" ");
            int numberOfStalls = Integer.parseInt(parts[0]);
            int numberOfPeople = Integer.parseInt(parts[1]);
            StallSettings output = processStalls(numberOfStalls,numberOfPeople);
            writer.println("CASE #" + i + ": " + output.getMax() + " " + output.getMin());
        }
        writer.close();

    }

    private static StallSettings processStalls(int numberOfStalls, int numberOfPeople) {
        ArrayList<Integer> arr = new ArrayList<>();
        arr.add(numberOfStalls);

        int current = -1;
        int pos = -1;
        for (int i = 0; i < numberOfPeople; i++) {
            Collections.sort(arr, Collections.reverseOrder());
            current = arr.get(0);
            arr.remove(0);
            pos = (int) (current+1)/2;
            if(pos>1) {
                arr.add(pos - 1);
            }
            if((current-pos)>0)
            {
                arr.add(current-pos);
            }
        }

        return new StallSettings(pos-1,current-pos);
    }
}
