import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.math.BigInteger;

public class FairAndSquare {
    public static void main(String[] args) throws FileNotFoundException {
        In in = new In(args[0]);
        PrintWriter pw = new PrintWriter(args[0] + ".out");
        int cases = in.readInt();
        in.readLine();
        for (int c = 0; c < cases; c++) {
            String line = in.readLine();
            String[] numbers = line.split(" ");
            BigInteger a = new BigInteger(numbers[0], 10);
            BigInteger b = new BigInteger(numbers[1], 10);
            pw.println("Case #" + (c + 1) + ": " + count(a, b));
        }
        pw.close();
    }

    private static int count(BigInteger a, BigInteger b) {
        BigInteger start = BigInteger.valueOf((long) Math.floor(Math.sqrt(a.doubleValue()))).subtract(BigInteger.ONE);
        int count = 0;
        BigInteger i = nextPalindrome(start);
        BigInteger sq = i.multiply(i);
        while (sq.compareTo(b) <= 0) {
            if (sq.compareTo(a) >= 0) {
                if (palindrome(sq)) {
                    count++;
                }
            }
            i = nextPalindrome(i);
            sq = i.multiply(i);
        }

        return count;
    }

    private static boolean palindrome(BigInteger sq) {
        return isPalindrome(sq.toString(10));
    }

    private static BigInteger nextPalindrome(BigInteger val) {
        return new BigInteger(genNextPalin(val.toString(10)), 10);
    }

    public static String genNextPalin(String base){
        if(base.length()==1){
            if(Integer.parseInt(base)==9)
                return "11";
            else
                return (Integer.parseInt(base)+1)+"";
        }
        boolean check = true;
        //check if it is all 9s
        for(char a: base.toCharArray()){
            if(a!='9')
                check = false;
        }
        if(check){
            String num = "1";
            for(int i=0; i<base.length()-1; i++)
                num+="0";
            num+="1";
            return num;
        }

        boolean isBasePalin = isPalindrome(base);
        int mid = base.length()/2;
        if(isBasePalin){
            //if base is palin and it is odd increase mid and return
            if(base.length()%2==1){
                BigInteger leftHalf = new BigInteger(base.substring(0,mid+1));
                String newLeftHalf = leftHalf.add(BigInteger.ONE).toString();
                String newPalin = genPalin2(newLeftHalf.substring(0,mid),newLeftHalf.charAt(mid));
                return newPalin;
            }
            else{
                BigInteger leftHalf = new BigInteger(base.substring(0,mid));
                String newLeftHalf = leftHalf.add(BigInteger.ONE).toString();
                String newPalin = genPalin(newLeftHalf.substring(0,mid));
                return newPalin;
            }
        }
        else{
            if(base.length()%2==1){
                BigInteger leftHalf = new BigInteger(base.substring(0,mid));
                BigInteger rightHalf = new BigInteger(reverse(base.substring(mid+1,base.length())));

                //check if leftHalf is greater than right half
                if(leftHalf.compareTo(rightHalf)==1){
                    String newPalin = genPalin2(base.substring(0,mid),base.charAt(mid));
                    return newPalin;
                }
                else{
                    BigInteger leftHalfMid = new BigInteger(base.substring(0,mid+1));
                    String newLeftHalfMid = leftHalfMid.add(BigInteger.ONE).toString();
                    String newPalin = genPalin2(newLeftHalfMid.substring(0,mid),newLeftHalfMid.charAt(mid));
                    return newPalin;
                }
            }
            else{
                BigInteger leftHalf = new BigInteger(base.substring(0,mid));
                BigInteger rightHalf = new BigInteger(reverse(base.substring(mid,base.length())));

                //check if leftHalf is greater than right half
                if(leftHalf.compareTo(rightHalf)==1){
                    return genPalin(base.substring(0,mid));
                }
                else{
                    BigInteger leftHalfMid = new BigInteger(base.substring(0,mid));
                    String newLeftHalfMid = leftHalfMid.add(BigInteger.ONE).toString();
                    return genPalin(newLeftHalfMid);
                }
            }
        }
    }

    public static String genPalin(String base){
        return base + new StringBuffer(base).reverse().toString();
    }
    public static String genPalin2(String base, char middle){
        return base + middle +new StringBuffer(base).reverse().toString();
    }

    public static String reverse(String in){
        return new StringBuffer(in).reverse().toString();
    }

    static boolean isPalindrome(String str) {
        int n = str.length();
        for( int i = 0; i < n/2; i++ )
            if (str.charAt(i) != str.charAt(n-i-1))
                return false;
        return true;
    }
}
