import java.io.FileNotFoundException;
import java.io.PrintWriter;

public class Lawnmover {
    public static void main(String[] args) throws FileNotFoundException {
        In in = new In(args[0]);
        PrintWriter pw = new PrintWriter(args[0] + ".out");
        int cases = in.readInt();
        in.readLine();
        for (int c = 0; c < cases; c++) {
            int n = in.readInt();
            int m = in.readInt();
            in.readLine();
            int[][] lawn = new int[n][m];
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    lawn[i][j] = in.readInt();
                }
                in.readLine();
            }
            if (test(n, m, lawn)) {
                pw.println("Case #" + (c + 1) + ": YES");
            } else {
                pw.println("Case #" + (c + 1) + ": NO");
            }

        }
        pw.close();
    }

    private static boolean test(int n, int m, int[][] lawn) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (!horizontal(n, m, lawn, i, j) && !vertical(n, m, lawn, i, j)) {
                    return false;
                }
            }
        }
        return true;
    }

    private static boolean horizontal(int n, int m, int[][] lawn, int i, int j) {
        for (int k = 0; k < m; k++) {
            if (lawn[i][k] > lawn[i][j]) {
                return false;
            }
        }
        return true;
    }

    private static boolean vertical(int n, int m, int[][] lawn, int i, int j) {
        for (int k = 0; k < n; k++) {
            if (lawn[k][j] > lawn[i][j]) {
                return false;
            }
        }
        return true;
    }

}