import java.io.FileNotFoundException;
import java.io.PrintWriter;

public class TicTacToeTomek {
    public static void main(String[] args) throws FileNotFoundException {
        In in = new In(args[0]);
        PrintWriter pw = new PrintWriter(args[0] + ".out");
        int cases = in.readInt();
        in.readLine();
        for (int c = 0; c < cases; c++) {
            char[][] board = new char[4][4];
            for (int i = 0; i < 4; i++) {
                for (int j = 0; j < 4; j++) {
                    board[i][j] = in.readChar();
                }
                in.readLine();
            }
            in.readLine();
            if (test(board, 'X')) {
                pw.println("Case #" + (c + 1) + ": X won");
            } else if (test(board, 'O')) {
                pw.println("Case #" + (c + 1) + ": O won");
            } else if (emptySquare(board)) {
                pw.println("Case #" + (c + 1) + ": Game has not completed");
            } else {
                pw.println("Case #" + (c + 1) + ": Draw");
            }

        }
        pw.close();
    }

    private static boolean test(char[][] board, char x) {
        for (int i = 0; i < 4; i++) {
            int c = 0;
            for (int j = 0; j < 4; j++) {
                if (board[i][j] == x || board[i][j] == 'T') {
                    c++;
                }
            }
            if (c == 4) {
                return true;
            }
        }
        for (int j = 0; j < 4; j++) {
            int c = 0;
            for (int i = 0; i < 4; i++) {
                if (board[i][j] == x || board[i][j] == 'T') {
                    c++;
                }
            }
            if (c == 4) {
                return true;
            }
        }
        {
            int c = 0;
            for (int i = 0; i < 4; i++) {
                if (board[i][i] == x || board[i][i] == 'T') {
                    c++;
                }
            }
            if (c == 4) {
                return true;
            }
        }
        {
            int c = 0;
            for (int i = 0; i < 4; i++) {
                if (board[i][3-i] == x || board[i][3-i] == 'T') {
                    c++;
                }
            }
            if (c == 4) {
                return true;
            }
        }
        return false;
    }

    private static boolean emptySquare(char[][] board) {
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                if (board[i][j] == '.') {
                    return true;
                }
            }
        }
        return false;
    }
}
