import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Queue;

public class RevengeOfThePancakes {

	static HashMap<String, Integer> map;
	static HashSet<String> send;

	static String reverse(String s) {
		char[] l = s.toCharArray();
		StringBuilder r = new StringBuilder(l.length);
		for (int i = l.length - 1; i >= 0; i--) {
			l[i] = l[i] == '-' ? '+' : '-';
			r.append(l[i]);
		}
		String rev = r.toString();
		if (rev.equals(s))
			return "";
		return r.toString();
	}

	static boolean check(String s) {
		char[] l = s.toCharArray();
		for (int i = 0; i < l.length; i++) {
			if (l[i] == '-')
				return false;
		}
		return true;
	}

	static boolean check2(String s) {
		char[] l = s.toCharArray();
		for (int i = 0; i < l.length; i++) {
			if (l[i] == '+')
				return false;
		}
		return true;
	}

	static int INF = Integer.MAX_VALUE / 2;

	static class State {
		String s;
		int c;

		public State(String s, int c) {
			this.s = s;
			this.c = c;
		}

	}

	static int solve(String s) {
		Queue<State> q = new LinkedList<>();
		State cur = new State(s, 0);
		q.add(cur);
		String all, rev;
		while (!q.isEmpty()) {
			cur = q.poll();
			s = cur.s;
			if (check(s))
				return cur.c;
			for (int i = 0; i < s.length(); i++) {
				rev = reverse(s.substring(0, i + 1));
				if (rev.length() == 0)
					continue;
				all = rev;
				if (i + 1 != s.length())
					all += s.substring(i + 1);
				if (!send.contains(all)) {
					send.add(all);
					q.add(new State(all, cur.c + 1));
				}
			}
		}
		return INF;
	}

	public static void main(String[] args) throws IOException {
		System.setOut(new PrintStream("salidaB"));
		File inputFile = new File("B-small-attempt0.in");
		if (inputFile.exists())
			System.setIn(new FileInputStream(inputFile));
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		StringBuilder out = new StringBuilder();
		String line;
		int testCases = Integer.parseInt(in.readLine());
		for (int testCase = 1; testCase <= testCases; testCase++) {
			map = new HashMap<>();
			send = new HashSet<>();
			line = in.readLine();
			out.append("Case #" + testCase + ": " + solve(line) + "\n");
		}
		System.out.print(out);
	}

	public static int[] readInts(String line) {
		String[] w = line.trim().split("\\s+");
		int[] a = new int[w.length];
		for (int i = 0; i < a.length; i++)
			a[i] = Integer.parseInt(w[i]);
		return a;
	}

	public static long[] readLongs(String line) {
		String[] w = line.trim().split("\\s+");
		long[] a = new long[w.length];
		for (int i = 0; i < a.length; i++)
			a[i] = Long.parseLong(w[i]);
		return a;
	}
}
