import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;
import java.util.Queue;
import java.util.StringTokenizer;

public class C {

	static void update(Queue<Long> q, Map<Long, Long> map, long id, long cnt) {
		if (!map.containsKey(id)) {
			map.put(id, 0L);
			q.add(id);
		}
		map.put(id, map.get(id) + cnt);
	}

	static long[] getLR(long n) {
		long mid = n / 2;
		if ((n & 1L) == 1L)
			return new long[] { mid, mid };
		return new long[] { mid, mid - 1 };
	}

	static long[] solve(long n, long k) {
		long[] ans = new long[2];
		Queue<Long> q = new LinkedList<>();
		Map<Long, Long> map = new HashMap<>();
		long sum = 0, id, mid, cnt;
		q.add(n);
		map.put(n, 1L);
		while (sum < k && !q.isEmpty()) {
			id = q.poll();
			mid = id / 2L;
			cnt = map.get(id);
			if (cnt + sum >= k) {
				ans = getLR(id);
				break;
			}
			sum += cnt;
			if ((id & 1L) == 1L)
				update(q, map, mid, cnt * 2);
			else {
				update(q, map, mid, cnt);
				update(q, map, mid - 1, cnt);
			}
		}
		return ans;
	}

	public static void main(String[] args) throws IOException {
		System.setOut(new PrintStream("salidaC"));
		File inputFile = new File("entrada");
		if (inputFile.exists())
			System.setIn(new FileInputStream(inputFile));
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		StringBuilder out = new StringBuilder();
		int n = Integer.parseInt(in.readLine().trim());
		for (int t = 0; t < n; t++) {
			Long[] nk = readLongs(in.readLine());
			long[] ans = solve(nk[0], nk[1]);
			out.append("Case #").append(t + 1).append(": ").append(ans[0]).append(' ').append(ans[1]).append('\n');
		}
		System.out.print(out);
	}

	public static Long[] readLongs(String line) {
		StringTokenizer st = new StringTokenizer(line.trim());
		Long a[] = new Long[st.countTokens()];
		int index = 0;
		while (st.hasMoreTokens())
			a[index++] = Long.parseLong(st.nextToken());
		return a;
	}

}
