import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashSet;

public class CoinJam {

	static ArrayList<Integer> results;

	public static void numerosPrimos(int n) {
		char[] is_composite = new char[(n - 2 >> 5) + 1];
		final int limit_i = n - 2 >> 1, limit_j = 2 * limit_i + 3;
		results = new ArrayList<>((int) Math.ceil(1.25506 * n / Math.log(n)));
		results.add(2);
		for (int i = 0; i < limit_i; ++i)
			if ((is_composite[i >> 4] & 1 << (i & 0xF)) == 0) {
				results.add(2 * i + 3);
				for (long j = 4L * i * i + 12L * i + 9; j < limit_j; j += 4 * i + 6)
					is_composite[(int) (j - 3L >> 5)] |= 1 << (j - 3L >> 1 & 0xF);
			}
	}

	static boolean check(String num) {
		BigInteger big;
		for (int base = 2; base <= 10; base++) {
			big = new BigInteger(num, base);
			if (big.isProbablePrime(40))
				return false;
		}
		return true;
	}

	static String firstDivisor(BigInteger num) {
		BigInteger ZERO = BigInteger.ZERO;
		int r;
		for (int i = 0; i < results.size(); i++) {
			r = results.get(i);
			if (num.mod(BigInteger.valueOf(r)).equals(ZERO))
				return Integer.toString(r);
		}
		return "";
	}

	static String toString(String num) {
		BigInteger big;
		StringBuilder r = new StringBuilder();
		String ans;
		for (int base = 2; base <= 10; base++) {
			ans = firstDivisor(new BigInteger(num, base));
			if (ans.length() == 0)
				System.out.println(3 / 0);
			r.append(" " + ans);
		}
		return r.toString();
	}

	public static void main(String[] args) throws IOException {
		System.setOut(new PrintStream("salidaC"));
		File inputFile = new File("C-small-attempt1.in");
		if (inputFile.exists())
			System.setIn(new FileInputStream(inputFile));
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		StringBuilder out = new StringBuilder();
		numerosPrimos(1 << 22);
		int testCases = Integer.parseInt(in.readLine());
		for (int testCase = 1; testCase <= testCases; testCase++) {
			out.append("Case #" + testCase + ":\n");
			int[] nj = readInts(in.readLine());
			int n = nj[0], j = nj[1];
			int num = (1 << (n - 1)) + 1;
			int lim = (1 << n) - 1;
			int count = 0;
			String binaryString;
			for (int i = num; i <= lim && count < j; i++) {
				binaryString = Integer.toBinaryString(i);
				if (check(binaryString)) {
					out.append(binaryString);
					out.append(toString(binaryString));
					out.append('\n');
					count++;
				}
			}

		}
		System.out.print(out);
	}

	public static int[] readInts(String line) {
		String[] w = line.trim().split("\\s+");
		int[] a = new int[w.length];
		for (int i = 0; i < a.length; i++)
			a[i] = Integer.parseInt(w[i]);
		return a;
	}
}
