/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codejam.y11.round1;

import utils.Jam;
import utils.JamCase;

/**
 *
 * @author fabien
 */
public class RPI extends Jam {

  private int offset;

  public RPI(String filename) {
    super(filename);
    this.offset = 1;
  }

  @Override
  public JamCase getJamCase(int number) {
    Tournament c = new Tournament(this, number, lines, offset);
    this.offset += c.getNumberOfLines() + 1;
    return c;
  }

  private class Tournament extends JamCase {

    private int n;
    private int offset;
    private String[] lines;
    private int[][] table;

    public Tournament(Jam parent, int number, String[] lines, int offset) {
      super(parent, number);
      n = Integer.parseInt(lines[offset]);
      this.offset = offset + 1;
      this.lines = lines;
    }

    public int getNumberOfLines() {
      return n;
    }

    @Override
    public void parse() {
      char c;
      this.table = new int[n][];
      for (int i = 0; i < n; i++) {
        this.table[i] = new int[n];
        String line = lines[this.offset++];
        for (int j = 0; j < line.length(); j++) {
          c = line.charAt(j);
          if (c == '1') {
            table[i][j] = 1;
          } else if (c == '0') {
            table[i][j] = 0;
          } else if (c == '.') {
            table[i][j] = -1;
          }
        }
      }
    }

    @Override
    public void solve() {
      double[] wps = new double[n];
      double[] owps = new double[n];
      double[] oowps = new double[n];
      // Calculates WP
      for (int i = 0; i < n; i++) {
        double count = 0, wp = 0;
        for (int j = 0; j < n; j++) {
          if (table[i][j] != -1) {
            wp += table[i][j];
            count++;
          }
        }
        wps[i] = wp / count;
      }

      for (int i = 0; i < n; i++) {
        double count = 0, owp = 0;
        for (int j = 0; j < n; j++) {
          if (j != i && table[i][j] != -1) {
            double count2 = 0, wp2 = 0;
            for (int k = 0; k < n; k++) {
              if (k != i && table[j][k] != -1) {
                wp2 += table[j][k];
                count2++;
              }
            }
            owp += wp2 / count2;
            count++;
          }
        }
        owps[i] = owp / count;
      }

      for (int i = 0; i < n; i++) {
        double count = 0, oowp = 0;
        for (int j = 0; j < n; j++) {
          if (table[i][j] != -1) {
            oowp += owps[j];
            count++;
          }
        }
        oowps[i] = oowp / count;
      }

      StringBuilder sb = new StringBuilder();
      for (int i = 0; i < n; i++) {
        sb.append("\n");
        sb.append(applyRPI(wps[i], owps[i], oowps[i]));
      }
      result = sb.toString();
    }

    private double applyRPI(double wp, double owp, double oowp) {
      double r = .25 * wp + .5 * owp + .25 * oowp;
      return r;
    }
  }
}
