/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cgjam11;

import java.lang.Integer;
import java.util.ArrayList;
import java.util.List;
import utils.File;

/**
 *
 * @author fabien
 */
public class CandySplitting implements Runnable {
  private final String filename;
  private final String[] lines;
  private final int nCases;
  private Result[] results;
  StringBuilder sb = new StringBuilder();
  private int countOfResults;
  
  public CandySplitting(String filename) {
    this.filename = filename;
    lines = File.readAllLines(filename);
    nCases = Integer.parseInt(lines[0]);
    results = new Result[nCases];
  }

  @Override
  public void run() {
    countOfResults = 0;
    int nLine = 1;
    for (int i = 1; i <= nCases; i++) {
      SearchCase sc = new SearchCase(i, lines[nLine], lines[nLine + 1]);
      new Thread(sc).start();
      nLine += 2;
    }
    
  }
  
  private synchronized void addResult(int no, String r) {
    results[no - 1] = new Result(no, r);
    countOfResults++;
//    System.out.println(countOfResults);
    
    if (countOfResults == results.length) {
      StringBuilder sb = new StringBuilder();
      String lf = System.getProperty("line.separator");
      for (Result re : results) {
        sb.append(re.toString());
        sb.append(lf);
      }
      System.out.println(sb.toString());
      File.writeAllText(filename.replace(".in", ".out"), sb.toString());
    }
  }
  
  private class Result {
    private final String r;
    private final int no;
    
    public Result(int no, String r) {
      this.no = no;
      this.r = r;
    }
    
    @Override
    public String toString() {
      return "Case #" + no + ": " + r;
    }
  }
  
  private class SearchCase implements Runnable {
    private int nCandy;
    private int[] vCandy;
    private List<Integer> maxSean = new ArrayList<Integer>();
    private int no;
    
    public SearchCase(int no, String line1, String line2) {
      this.no = no;
      nCandy = Integer.parseInt(line1);
      String[] values = line2.split(" ");
      vCandy = new int[nCandy];
      for (int i = 0; i < nCandy; i++) {
        vCandy[i] = Integer.parseInt(values[i]);
      }
    }
    
    public String getResult() {
      if (maxSean.size() > 0) {
        return Integer.toString(max(maxSean));
      }
      return "NO";
    }

    @Override
    public void run() {
      int sumP = sum(vCandy);
      int sumS = 0;
      int xorS = 0;
      String dbg = "";
      for (int i = 0; i < vCandy.length; i++) {
        addSean(i, sumS, sumP, xorS, dbg);
      }
      addResult(no, getResult());
    }
    
    private void addSean(int i, int sumS, int sumP, int xorS, String dbg) {
      sumP -= vCandy[i];
      sumS += vCandy[i];
      xorS ^= vCandy[i];
      dbg += vCandy[i] + " + ";
      if (sumS >= sumP && sumP > 0) {
        if (sumP == xorS) {
          maxSean.add(sumS);
//          System.out.println(sumS + " = " + dbg);
  //        return;
        }
      }
//      System.out.println(dbg);
      for (int j = i + 1; j < vCandy.length; j++) {
        addSean(j, sumS, sumP, xorS, dbg);
      }
    }
    
    private int sum(int[] l) {
      int s = 0;
      for (int i : l) {
        s += i;
      }
      return s;
    }

    private int max(List<Integer> maxSean) {
      int max = 0;
      for (int i : maxSean) {
        if (max < i) {
          max = i;
        }
      }
      return max;
    }
  }
}
