/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cgjam11;
import utils.File;

/**
 *
 * @author fabien
 */
public class Magicka implements Runnable {
  
  private final String[] lines;
  private final int nCases;
  private final String filename;
  
  public Magicka(String filename) {
    this.filename = filename;
    lines = File.readAllLines(filename);
    nCases = Integer.parseInt(lines[0]);
  }
  
  public static void generateLarge(String filename) {
    StringBuilder content = new StringBuilder();
    
    char[] base = new char[] { 'Q', 'W', 'E', 'R', 'A', 'S', 'D', 'F' };
    char[] rest = new char[] { 'B', 'C', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'T', 'U', 'V', 'X', 'Y', 'Z' };
    content.append("100\n");
    for (int i = 0; i < 100; i++) {
      int c = (int) (26 + Math.random() * 10);
      int d = (int) (18 + Math.random() * 10);
      int n = (int) (90 + Math.random() * 10);
      
      content.append(c);
      content.append(" ");
      int r1, r2;
      for (int j = 0; j < c; j++) {
        r1 = (int) (Math.random() * 8);
        r2 = (int) (Math.random() * 8);
        content.append(base[r1]);
        content.append(base[r2]);
        content.append(rest[j % rest.length]);
        content.append(" ");
      }
      
      content.append(d);
      content.append(" ");
      for (int j = 0; j < d; j++) {
        r1 = (int) (Math.random() * 8);
        r2 = r1;
        while (r2 == r1) {
          r2 = (int) (Math.random() * 8);
        }
        content.append(base[r1]);
        content.append(base[r2]);
        content.append(" ");
      }
      
      content.append(n);
      content.append(" ");
      for (int j = 0; j < n; j++) {
        r1 = (int) (Math.random() * 8);
        content.append(base[r1]);
      }
      content.append("\n");
    }
    
    File.writeAllText(filename, content.toString());
  }

  @Override
  public void run() {
    StringBuilder sb = new StringBuilder();
    String lf = System.getProperty("line.separator");
    
    for (int i = 1; i <= nCases; i++) {
      Line l = new Line(lines[i]);
      l.run();
      sb.append("Case #");
      sb.append(i);
      sb.append(": ");
      sb.append(l.getResult());
      sb.append(lf);
    }
    
    System.out.println(sb.toString());
    File.writeAllText(filename.replace(".in", ".out"), sb.toString());
  }
  
  private class Line implements Runnable {
    private String line;
    private int c, d, n;
    
    private Combination[] combinations;
    private Opposed[] opps;
    private char[] invocation;
    
    public Line(String line) {
      this.line = line;
    }
    
    public String getResult() {
      StringBuilder sb = new StringBuilder();
      sb.append("[");
      for (int i = 0; i < invocation.length; i++) {
        if (i > 0) {
          sb.append(", ");
        }
        sb.append(invocation[i]);
      }
      sb.append("]");
      return sb.toString();
    }

    @Override
    public void run() {
      parse();
      solve(new char[0], invocation);
    }
    
    private void solve(char[] head, char[] tail) {
      if (tail.length == 0) {
        invocation = head;
        return;
      }
      char[] head2 = new char[0];
      char c1 = tail[0];
      if (head.length == 0) {
        head2 = new char[1];
        head2[0] = c1;
      } else {
        
        char c0 = head[head.length - 1];
        
        boolean found = false;
        char comb = getCombination(c1, c0);
        if (comb != 0) {
          found = true;
          head2 = head;
          head2[head.length - 1] = comb;
        }
        
        if (!found) {
          char opp = getOpposite(c1);
          int counter = 0;
          for (int i = 0; i < head.length && !found; i++) {
            found = head[i] == opp;
            if (!found) {
              counter++;
            }
          }
          if (found) {
            head2 = new char[0];
          }
        }
        if (!found) {
          head2 = new char[head.length + 1];
          for (int i = 0; i < head.length; i++) {
            head2[i] = head[i];
          }
          head2[head.length] = c1;
        }
      }
      
      char[] tail2 = new char[tail.length - 1];
      for (int i = 0; i < tail.length - 1; i++) {
        tail2[i] = tail[i + 1];
      }
      solve(head2, tail2);
    }
    
    private char getCombination(char a1, char a2) {
      for (Combination c : combinations) {
        if (c.contains(a1, a2)) {
          return c.newValue();
        }
      }
      return 0;
    }
    
    private char getOpposite(char a) {
      for (Opposed o : opps) {
        if (o.contains(a)) {
          return o.getOppositeTo(a);
        }
      }
      return 0;
    }

    private void parse() {
      String[] all = line.split(" ");
      
      int off = 0;
      
      c = Integer.parseInt(all[off++]);
      combinations = new Combination[c];
      for (int i = 0; i < c; i++) {
        String l = all[i + off];
        combinations[i] = new Combination(l.charAt(0), l.charAt(1), l.charAt(2));
      }
      off += c;
      
      d = Integer.parseInt(all[off++]);
      opps = new Opposed[d];
      for (int i = 0; i < d; i++) {
        String l = all[i + off];
        opps[i] = new Opposed(l.charAt(0), l.charAt(1));
      }
      off += d;
      
      n = Integer.parseInt(all[off++]);
      String l = all[off];
      invocation = new char[n];
      for (int i = 0; i < n; i++) {
        invocation[i] = l.charAt(i);
      }
    }
  }
  
  private class Opposed {
    private char a;
    private char b;
    
    public Opposed(char a, char b) {
      this.a = a;
      this.b = b;
    }
    
    public boolean contains(char z) {
      return z == b || z == a;
    }
    
    public char getOppositeTo(char z) {
      if (z == a) return b;
      if (z == b) return a;
      return 0;
    }
  }
  
  private class Combination {
    private final char a1;
    private final char a2;
    private final char b;
    
    public Combination(char a1, char a2, char b) {
      this.a1 = a1;
      this.a2 = a2;
      this.b = b;
    }
    
    public boolean contains(char x, char y) {
      return (a1 == x && a2 == y) || (a1 == y && a2 == x);
    }
    
    public char newValue() {
      return b;
    }
  }
}
