import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class Magicka {

	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File("inputB.txt"));
		int casi = sc.nextInt();
		PrintWriter pw = new PrintWriter(new File("outputB.txt"));
		for (int caso = 1; caso <= casi; caso++) {
			String[] combs = new String[sc.nextInt()];
			for (int i = 0; i < combs.length; i++) {
				combs[i] = sc.next();
			}
			String[] opps = new String[sc.nextInt()];
			for (int i = 0; i < opps.length; i++) {
				opps[i] = sc.next();
			}
			sc.next(); //numero caratteri invoke
			String el = new Magicka().getElList(combs, opps, sc.next());
			pw.println("Case #" + caso + ": " + el);
		}
		pw.flush();
		pw.close();
	}

	private String getElList(String[] combs, String[] opps, String invoke) {
		Map<Comb, Character> combsMap = new HashMap<Comb, Character>();
		for (String comb : combs) {
			char[] combChars = comb.substring(0, 2).toCharArray();
			combsMap.put(new Comb(combChars), comb.charAt(2));
		}

		Set<Comb> oppsSet = new HashSet<Comb>();
		for (String opp : opps) {
			oppsSet.add(new Comb(opp.toCharArray()));
		}

		List<Character> currentInvoke = new ArrayList<Character>();
		Map<Character, Integer> elInvoked = new HashMap<Character, Integer>();

		for (int i = 0; i < invoke.length(); i++) {
			char c = invoke.charAt(i);
			currentInvoke.add(c);
			put(c, elInvoked);
			while (currentInvoke.size() >= 2) {
				Character last = currentInvoke.get(currentInvoke.size() - 1);
				Character beforeLast = currentInvoke.get(currentInvoke.size() - 2);
				Comb lastComb = new Comb(new char[] { last, beforeLast });
				Character replace = combsMap.get(lastComb);
				if (replace == null) {
					break;
				}
				currentInvoke.remove(currentInvoke.size() - 1);
				currentInvoke.set(currentInvoke.size() - 1, replace);

				remove(last, elInvoked);
				remove(beforeLast, elInvoked);
				put(replace, elInvoked);
			}

			if (currentInvoke.size() >= 2) {
				for (Comb comb : oppsSet) {
					if (elInvoked.containsKey(comb.comb[0]) && elInvoked.containsKey(comb.comb[1])) {
						currentInvoke.clear();
						elInvoked.clear();
						break;
					}
				}
			}

		}
		String result = "[";
		for (Character character : currentInvoke) {
			result += character + ", ";
		}
		if (result.length() > 1) {
			result = result.substring(0, result.length() - 2);
		}
		result += "]";
		return result;
	}

	private void remove(Character last, Map<Character, Integer> elInvoked) {
		Integer occs = elInvoked.get(last);
		if (occs == 1) {
			elInvoked.remove(last);
		} else {
			elInvoked.put(last, occs - 1);
		}
	}

	private void put(Character c, Map<Character, Integer> elInvoked) {
		Integer occs = elInvoked.get(c);
		elInvoked.put(c, occs == null ? 1 : occs + 1);

	}

	static class Comb {
		char[] comb;

		public Comb(char[] comb) {
			this.comb = comb;
			Arrays.sort(comb);
		}

		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + Arrays.hashCode(comb);
			return result;
		}

		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			Comb other = (Comb) obj;
			if (!Arrays.equals(comb, other.comb))
				return false;
			return true;
		}

	}
}
