package googlejam.g2013;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class TicTacToeTomek {

	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File("inputA.txt"));
		PrintWriter pw = new PrintWriter(new File("outputA.txt"));
		int T = sc.nextInt();
		for (int i = 1; i <= T; i++) {
			String[] board = new String[4];
			for (int j = 0; j < 4; j++) {
				board[j] = sc.next();
			}
			pw.println("Case #" + i + ": " + getState(board));
		}
		pw.flush();
		pw.close();
	}

	private static String getState(String[] board) {
		// row
		for (String row : board) {
			String res = getResult(row);
			if (res != null) {
				return res;
			}
		}

		// col
		for (int i = 0; i < 4; i++) {
			String r = "";
			for (int j = 0; j < 4; j++) {
				r += board[j].charAt(i);
			}

			String res = getResult(r);
			if (res != null) {
				return res;
			}
		}

		// diag 1
		String r = "";
		for (int i = 0; i < 4; i++) {
			r += board[i].charAt(i);
		}

		String res = getResult(r);
		if (res != null) {
			return res;
		}

		// diag 2
		r = "";
		for (int i = 0; i < 4; i++) {
			r += board[i].charAt(4 - 1 - i);
		}

		res = getResult(r);
		if (res != null) {
			return res;
		}

		boolean notCompleted = false;
		out: for (String row : board) {
			for (char c : row.toCharArray()) {
				if (c == '.') {
					notCompleted = true;
					break out;
				}
			}
		}
		return notCompleted ? "Game has not completed" : "Draw";
	}

	private static String getResult(String row) {
		int t = 0;
		int x = 0;
		int o = 0;

		for (int i = 0; i < 4; i++) {
			char c = row.charAt(i);
			switch (c) {
			case 'X':
				++x;
				break;
			case 'O':
				++o;
				break;
			case 'T':
				++t;
				break;
			default:
				break;
			}
		}
		if (x == 4 || (x == 3 && t == 1)) {
			return "X won";
		}
		if (o == 4 || (o == 3 && t == 1)) {
			return "O won";
		}
		return null;
	}
}
