import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.TreeSet;

public class SpaceEmergency {

	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File("inputB.txt"));
		PrintWriter pw = new PrintWriter("outputB.txt");
		int T = sc.nextInt();
		for (int caso = 1; caso <= T; caso++) {
			int L = sc.nextInt();
			long t = sc.nextLong();
			int N = sc.nextInt();
			int C = sc.nextInt();
			int[] as = new int[C];
			for (int i = 0; i < as.length; i++) {
				as[i] = sc.nextInt();
			}
			pw.println("Case #" + caso + ": " + new SpaceEmergency().getTime(L, t, N, as));
		}
		pw.flush();
		pw.close();
	}

	public long getTime(int L, long t, int N, int[] as) {
		return getTime(L, t, N, as, new TreeSet<Integer>());
	}

	private long getTime(int l, double t, int n, int[] as, TreeSet<Integer> pos) {
		if (l == 0) {
			double res = 0;
			for (int i = 0; i < n; i++) {
				double distance = as[i % as.length];
				if (pos.contains(i)) {
					if (t <= res) { // costruito
						res += distance;
					} else {
						if (t >= res + distance * 2) { // non costruito
							res += distance * 2;
						} else {
							res = t + distance - (t - res); // costruito in mezzo
						}
					}
				} else {
					res+=distance*2;
				}
			}
			return (long) res;
		}
		int maxPos = pos.size() == 0 ? -1 : pos.last();
		long min = Integer.MAX_VALUE;
		for (int i = maxPos + 1; i < n - l; i++) {
			pos.add(i);
			min = Math.min(min, getTime(l-1, t, n, as, pos));
			pos.remove(i);
		}
		return min;
	}
}
