import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class RPI {

	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File("inputA.txt"));
		int T = sc.nextInt();
		PrintWriter pw = new PrintWriter("outputA.txt");
		for (int caso = 1; caso <= T; caso++) {
			int N = sc.nextInt();
			int[][] m = new int[N][N];
			for (int i = 0; i < m.length; i++) {
				String line = sc.next();
				for (int j = 0; j < line.length(); j++) {
					char c = line.charAt(j);
					if (c == '.') {
						m[i][j] = -1;
					} else if (c == '1') {
						m[i][j] = 1;
					}
				}
			}
			pw.println("Case #" + caso + ":");
			double[] res = new RPI().getRPI(m);
			for (double d : res) {
				pw.println(d);
			}
		}
		pw.flush();
		pw.close();
	}

	public double[] getRPI(int[][] m) {
		int N = m.length;
		double[] wp = new double[N];
		for (int i = 0; i < wp.length; i++) {
			double sum = 0;
			double c = 0;
			for (int j = 0; j < wp.length; j++) {
				if (m[i][j] >= 0) {
					++c;
					if (m[i][j] == 1) {
						++sum;
					}
				}
			}
			wp[i] = c == 0 ? 0 : sum / c;
		}

		double[] owp = new double[N];
		for (int k = 0; k < owp.length; k++) {
			double count = 0;
			for (int i = 0; i < wp.length; i++) {
				if (i == k || m[k][i] < 0) {
					continue;
				}
				count++;
				double sum = 0;
				double c = 0;
				for (int j = 0; j < wp.length; j++) {
					if (j != k && m[i][j] >= 0) {
						++c;
						if (m[i][j] == 1) {
							++sum;
						}
					}
				}
				owp[k] += c == 0 ? 0 : (sum / c);
			}
			owp[k] /= count == 0 ? 1 : count;
		}

		double[] oowp = new double[N];
		for (int i = 0; i < oowp.length; i++) {
			double count = 0;
			for (int j = 0; j < oowp.length; j++) {
				if (i != j && m[i][j] >= 0) {
					++count;
					oowp[i] += owp[j];
				}
			}
			oowp[i] /= count == 0 ? 1 : count;
		}

		double[] res = new double[N];
		for (int i = 0; i < res.length; i++) {
			res[i] = 0.25 * wp[i] + 0.5 * owp[i] + 0.25 * oowp[i];
		}
		return res;
	}
}
