
import java.io.BufferedReader;
import java.io.FileReader;

public class CookieClickerAlpha {

    private static final int BASE_COOKIES_PER_SECOND = 2;

    public static void main(String[] args) throws Exception {
        BufferedReader reader = new BufferedReader(new FileReader(args[0]));
        int cases = Integer.valueOf(reader.readLine());
        for (int caseNum = 1; caseNum <= cases; caseNum++) {
            System.out.print("Case #" + caseNum + ": ");
            String[] caseLine = reader.readLine().split(" ");
            double farmCost = Double.valueOf(caseLine[0]);
            double farmRate = Double.valueOf(caseLine[1]);
            double target = Double.valueOf(caseLine[2]);
            double acum = 0;
            for (int i = 0; true; i++) {
                double timeToTargetIFarms = acum + calculateTimeToTarget(target, i, farmRate);
                acum += calculateTimeToTarget(farmCost, i, farmRate);
                double timeToTargetIPlusOneFarms = acum + calculateTimeToTarget(target, i + 1, farmRate);
                if (timeToTargetIFarms < timeToTargetIPlusOneFarms) {
                    System.out.println(timeToTargetIFarms);
                    break;
                }
            }
        }
    }

    /**
     * Calculates how many time will spend to get to target.
     *
     * @param target
     * @param farms
     * @param farmRate
     * @return
     */
    public static double calculateTimeToTarget(double target, int farms, double farmRate) {
        return target / (BASE_COOKIES_PER_SECOND + farms * farmRate);
    }
}
