
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Scanner;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class RevengeOfThePancakes {

    private static String[] results;

    public static void main(String[] args) throws Exception {
        Scanner scanner = new Scanner(new BufferedReader(new FileReader(args[0])));
        int cases = scanner.nextInt();
        results = new String[cases];
        ExecutorService pool = Executors.newFixedThreadPool(cases);
        final Pattern pattern = Pattern.compile("(-+)");
        for (int caseNum = 1; caseNum <= cases; caseNum++) {
            final int casenumber = caseNum;
            final String s = scanner.next();
            pool.submit(new Runnable() {
                @Override
                public void run() {
                    try {
                        int count = s.split("\\++").length;
                        if(count > 1 && s.startsWith("-")) count++;
                        results[casenumber - 1] = count + "";
                    } catch (Throwable t) {
                        System.out.println("# " + casenumber);
                        System.out.println(s);
                        t.printStackTrace();
                        System.exit(1);
                    }
                }
            });
        }
        pool.shutdown();
        while (!pool.isTerminated()) {
            pool.awaitTermination(10, TimeUnit.SECONDS);
        }
        for (int i = 0; i < results.length; i++) {
            System.out.printf("Case #%d: %s\n", (i + 1), results[i]);
        }
    }
}
