
import java.io.BufferedReader;
import java.io.FileReader;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.List;

public class TheRepeater {

    public static void main(String[] args) throws Exception {
        BufferedReader reader = new BufferedReader(new FileReader(args[0]));
        int cases = Integer.valueOf(reader.readLine());
        for (int caseNum = 1; caseNum <= cases; caseNum++) {
            int numberOfStrings = Integer.valueOf(reader.readLine());
            List<String> strings = new ArrayList<String>(numberOfStrings);
            for (int i = 0; i < numberOfStrings; i++) {
                strings.add(reader.readLine());
            }
            String result;
            try {
                result = process(strings);
            } catch (RuntimeException re) {
                result = "Fegla Won";
            }

            System.out.println("Case #" + caseNum + ": " + result);
        }
    }

    private static String process(List<String> strings) {
        List<List<Integer>> letters = new ArrayList<List<Integer>>();
        List<Character> template = null;
        for (String string : strings) {
            List<Integer> count = new ArrayList<Integer>();
            char[] toCharArray = string.toCharArray();
            List<Character> thisTemplate = new ArrayList<Character>();
            for (char c : toCharArray) {
                if (thisTemplate.isEmpty()) {
                    thisTemplate.add(c);
                } else if (!thisTemplate.get(thisTemplate.size() - 1).equals(c)) {
                    thisTemplate.add(c);
                }
            }
            if(template == null) {
                template = thisTemplate;
            } else if(!template.equals(thisTemplate)) {
                throw new RuntimeException("Fegla Won");
            }
            char c = 0;
            for (char d : toCharArray) {
                if (d == c) {
                    count.set(count.size() - 1, count.get(count.size() - 1) + 1);
                } else {
                    c = d;
                    count.add(1);
                }
            }
            letters.add(count);
            if (count.size() != template.size()) {
                throw new RuntimeException("Fegla Won");
            }
        }
        int moves = 0;
        for (int i = 0; i < template.size(); i++) {
            int avg = 0;
            for (List<Integer> list : letters) {
                avg += list.get(i);
            }
            avg = avg / strings.size();
            for (List<Integer> list : letters) {
                moves += Math.abs(avg - list.get(i));
            }
        }
        return String.valueOf(moves);
    }
}
