import java.io.BufferedReader;
import static java.lang.Math.*;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

public class problemC implements Runnable {
	public static final String taskname = "A";
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok;
	
	static class Board implements Comparable<Board> {
		int x, y, side;
		Board(int x, int y, int side) {
			this.x = x;
			this.y = y;
			this.side = side;
		}
		
		Board(int[][] a, int x, int y) {
			this.x = x;
			this.y = y;
			int i = 0;
			while(x + i < a.length && y + i < a[0].length && isOk(a, x, y, x + i, y + i))
				++i;
			side = i;
		}
		
		boolean isOk(int[][] a, int x1, int y1, int x2, int y2) {
			int bit = a[x1][y1] ^ 1;
			for(int i = x1; i <= x2; ++i) {
				int prev = a[i][y1];
				for(int j = y1; j <= y2; ++j) {
					if(a[i][j] == -1) return false;
					if((a[i][j] ^ bit) != 1) return false;
					bit ^= 1;
				}
				bit = prev;
			}
			return true;
		}
		@Override
		public int compareTo(Board o) {
			if(side != o.side) return side - o.side;
			else if(x != o.x) return o.x - x;
			return o.y - y;
		}
		
		public String toString() {
			return "(" + x + ", " + y + ") " + side;
		}
	}

	public static void main(String[] args) {
		new Thread(new problemC()).start();
	}
	
	ArrayList<Board> l;
	
	void generate(int[][] a, int m, int n) {
		l = new ArrayList<Board>();
		for(int i = 0; i < m; ++i)
			for(int j = 0; j < n; ++j)
				if(a[i][j] != -1)
					l.add(new Board(a, i, j));
	}
	
	void solve(int test) throws IOException {
		int[] res = new int[1000];
		int m = nextInt(), n = nextInt();
		int[][] a = new int[m][n];
		for(int i = 0; i < m; ++i) {
			String s = nextLine();
			int j = 0;
			for(char ch : s.toCharArray()) {
				String str = Integer.toBinaryString(Integer.valueOf(Character.toString(ch), 16));
				while(str.length() < 4) str = "0" + str;
				for(char c : str.toCharArray())
					a[i][j++] = (c - '0');
			}
		}
		do {
			generate(a, m, n);
			Collections.sort(l);
			if(l.isEmpty()) break;
			Board cur = l.get(l.size() - 1);
			if(cur != null) {
				res[cur.side]++;
				for(int i = cur.x; i < cur.x + cur.side; ++i)
					for(int j = cur.y; j < cur.y + cur.side; ++j)
						a[i][j] = -1;
			}
		} while(l.size() > 0);
		int kol = 0;
		for(int i = res.length - 1; i >= 1; --i)
			if(res[i]!=0) ++kol;
		out.println("Case #" + test + ": " + kol);
		for(int i = res.length - 1; i >= 1; --i)
			if(res[i] != 0)
				out.println(i + " " + res[i]);
				
	}

	void solve() throws IOException {
		int t = nextInt();
		for(int i = 0; i < t; ++i)
			solve(i + 1);
	}

	@Override
	public void run() {
		try {
			// in = new BufferedReader(new InputStreamReader(System.in));
			in = new BufferedReader(new FileReader(new File(taskname + ".in")));
			// out = new PrintWriter(System.out);
			out = new PrintWriter(new File(taskname + ".out"));
			solve();
			out.flush();
			out.close();
			in.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	String nextLine() throws IOException {
		tok = null;
		return in.readLine();
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	String nextToken() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

}
