import java.io.BufferedReader;
import static java.lang.Math.*;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

public class problemA implements Runnable {
	public static final String taskname = "A";
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok;

	public static void main(String[] args) {
		new Thread(new problemA()).start();
	}
	
	void solve(int test) throws IOException {
		int n = nextInt(), k = nextInt();
		char[][] ch = new char[n][];
		for(int i = 0; i < n; ++i)
			ch[i] = nextLine().toCharArray();
		for(int i = 0; i < n; ++i) {
			List<Character> l = new LinkedList<Character>();
			for(int j = n - 1; j >=0; --j)
				if(ch[i][j] != '.') {
					l.add(ch[i][j]);
					ch[i][j] = '.';
				}
			int j = n - 1;
			for(char temp : l)
				ch[i][j--] = temp;
		}
		boolean red = false, blue = false;
		
		StringBuilder sb = new StringBuilder();
		for(int i = 0; i < k; ++i)
			sb.append('B');
		String BLUE = sb.toString();
		sb = new StringBuilder();
		for(int i = 0; i < k; ++i)
			sb.append('R');
		String RED = sb.toString();
		for(int i = 0; i < n; ++i) {
			String s = new String(ch[i]);
			red |= s.contains(RED);
			blue |= s.contains(BLUE);
			sb = new StringBuilder();
			for(int j = 0; j < n; ++j)
				sb.append(ch[j][i]);
			s = sb.toString();
			red |= s.contains(RED);
			blue |= s.contains(BLUE);
		}
		/*char[][] ct = new char[n][n];
		for(int i = 0; i < n; ++i)
			for(int j = 0; j < n; ++j)
				ct[j][n - 1 - i] = ch[i][j];
		ch = ct;
		for(int i = 0; i < n; ++i) {
			for(int j = 0; j < n; ++j)
				System.out.print(ch[i][j]);
			System.out.println();
		}*/
		for(int i = 0; i < 2 * n; ++i) {
			int j = 0, i1 = i;
			if(i1 >= n) {
				j = i1 - n;
				i1 = n - 1;
			}
			sb = new StringBuilder();
			while(i1 >= 0 && j < n) {
				sb.append(ch[i1][j]);
				i1--; j++;
			}
			String s = sb.toString();
			red |= s.contains(RED);
			blue |= s.contains(BLUE);
		}
		for(int j = 0; j < 2 * n; ++j) {
			int i = 0, j1 = j;
			if(j1 < n) { 
				i = n - j1 - 1;
				j1 = 0;
			} else {
				j1 = j1 - n;
			}
			sb = new StringBuilder();
			while(i < n && j1 < n) {
				sb.append(ch[i][j1]);
				i++; j1++;
			}
			String s = sb.toString();
			red |= s.contains(RED);
			blue |= s.contains(BLUE);
		}
		if(red && blue) out.println("Case #" + test + ": Both");
		else if(red && !blue) out.println("Case #" + test + ": Red");
		else if(!red && blue) out.println("Case #" + test + ": Blue");
		else out.println("Case #" + test + ": Neither");
	}

	void solve() throws IOException {
		int t = nextInt();
		for(int i = 1; i <= t; ++i)
			solve(i);
	}

	@Override
	public void run() {
		try {
			// in = new BufferedReader(new InputStreamReader(System.in));
			in = new BufferedReader(new FileReader(new File(taskname + ".in")));
			// out = new PrintWriter(System.out);
			out = new PrintWriter(new File(taskname + ".out"));
			solve();
			out.flush();
			out.close();
			in.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	String nextLine() throws IOException {
		tok = null;
		return in.readLine();
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	String nextToken() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

}
