import java.io.BufferedReader;
import static java.lang.Math.*;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

public class problemA implements Runnable {
	public static final String taskname = "A";
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok;

	public static void main(String[] args) {
		new Thread(new problemA()).start();
	}
	
	void solve(int test) throws IOException { 
		int n = nextInt(), k = nextInt();
		boolean[] on = new boolean[n];
		Arrays.fill(on, false);
		for(int j = 0; j < k; ++j) {
			boolean[] temp = new boolean[n];
			System.arraycopy(on, 0, temp, 0, n);
			if(!on[0]) {
				on[0] = true;
				continue;
			}
			temp[0] = false;			
			for(int i = 1; i < n; ++i) {
					if(on[i]) temp[i] = false;
					else {
						temp[i] = true;
						break;
					}
			}
			System.arraycopy(temp, 0, on, 0, n);
		}
		boolean ok = true;
		for(boolean b : on)
			ok = ok && b;
		if(ok) out.format("Case #%d: ON\n", test);
		else out.format("Case #%d: OFF\n", test);
	}

	void solve() throws IOException {
		int tests = nextInt();
		for(int i = 1; i <= tests; ++i)
			solve(i);
	}

	@Override
	public void run() {
		try {
			// in = new BufferedReader(new InputStreamReader(System.in));
			in = new BufferedReader(new FileReader(new File(taskname + ".in")));
			// out = new PrintWriter(System.out);
			out = new PrintWriter(new File(taskname + ".out"));
			solve();
			out.flush();
			out.close();
			in.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	String nextLine() throws IOException {
		tok = null;
		return in.readLine();
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	String nextToken() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

}
