package r1a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Arrays;

public class Q3 {

	public static void main(String[] args) {
		BufferedReader in;
		BufferedWriter out;
		
		try
		{
			in = new BufferedReader(new FileReader("in.txt"));
			out = new BufferedWriter(new FileWriter("out.txt"));
			
			int cases = Integer.parseInt(in.readLine());
			if (cases < 1)
			{
				in.close();
				out.close();
				return;
			}
			
			for (int caseNumber = 1; caseNumber <= cases; caseNumber++)
			{
				String input = in.readLine();
				String result = solve(input);
				out.write("Case #" + caseNumber + ": " + result);
				out.newLine();
			}
			in.close();
			out.close();

		}
		catch (Exception e)
		{
			return;
		}
	}
	
	public static String solve(String s)
	{
		return solveHelper(s.toCharArray());
	}
	
	public static String solveHelper(char[] chars)
	{
		afdclass myChar = new afdclass();
		ArrayList<Integer> letters = getLastAlphaLetter(chars, myChar);
		
		String middle;
		if (letters.get(0) == 0)
		{
			middle = "";
		}
		else
		{
			middle = solveHelper(Arrays.copyOfRange(chars, 0, letters.get(0)));
		}
		String first = AllLasts(letters.size(), myChar.lastAlphaChar);
		String last = RemoveAllLasts(Arrays.copyOfRange(chars, letters.get(0)+1, chars.length), myChar.lastAlphaChar);
		return first + middle + last;
	}
	
	public static ArrayList<Integer> getLastAlphaLetter(char[] chars, afdclass myChar)
	{
		ArrayList<Integer> ret = new ArrayList<Integer>();
		if ((chars == null) || (chars.length == 0)) { return null; }
		
		for (int i = 0; i < chars.length; i++)
		{
			Character t = new Character(chars[i]);
			int compResult = t.compareTo(myChar.lastAlphaChar); 
			if (compResult > 0)
			{
				myChar.lastAlphaChar = new Character(chars[i]);
				ret.clear();
				ret.add(i);
			}
			else if (compResult == 0)
			{
				ret.add(i);
			}
		}
		return ret;
	}
	
	public static String AllLasts(int n, Character c)
	{
		char[] chars = new char[n];
		Arrays.fill(chars, c);
		String s = new String(chars);
		return s;
	}
	
	public static String RemoveAllLasts(char[] chars, Character c)
	{
		if (chars.length == 0) { return ""; }
		char[] newChars = new char[chars.length];
		int newCharsCounter = 0;
		for (int i = 0; i < chars.length; i++)
		{
			
			Character newC = new Character(chars[i]);
			if (newC.compareTo(c) == 0)
			{ 
				continue; 
			}
			// Add the char to the array
			newChars[newCharsCounter] = chars[i];
			newCharsCounter++;
		}
		char[] finalChars = Arrays.copyOfRange(newChars, 0, newCharsCounter);
		return new String(finalChars);
	}

}
