package r1a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Arrays;

public class Q2 {

	public static void main(String[] args) {
		BufferedReader in;
		BufferedWriter out;
		
		try
		{
			in = new BufferedReader(new FileReader("in.txt"));
			out = new BufferedWriter(new FileWriter("out.txt"));
			
			int cases = Integer.parseInt(in.readLine());
			if (cases < 1)
			{
				in.close();
				out.close();
				return;
			}
			
			for (int caseNumber = 1; caseNumber <= cases; caseNumber++)
			{
				String input = in.readLine();
				Integer n = Integer.parseInt(input);
				String result = solve(in, n);
				out.write("Case #" + caseNumber + ": " + result);
				out.newLine();
			}
			in.close();
			out.close();

		}
		catch (Exception e)
		{
			return;
		}
	}
	
	public static String solve(BufferedReader in, Integer n)
	{
		Integer[] heightCount = new Integer[2500];
		Arrays.fill(heightCount, 0);
		String[] oddities = new String[n];
		String ret;
		try
		{
			String input;
			for (int i = 0; i < 2*n-1; i++)
			{
				input = in.readLine();
				String parts[] = input.split(" ");
				for (int j = 0; j < n; j++)
				{
					Integer h = Integer.parseInt(parts[j]);
					heightCount[h]++;
				}
			}
			
			int oddCount = 0;
			for (int k = 0; k < 2500; k++)
			{
				if (heightCount[k] % 2 == 1)
				{
					oddities[oddCount] = Integer.toString(k);
					oddCount++;
				}
				if (oddCount == n) { break; }
			}
			ret = String.join(" ", oddities);
			return ret;
		}
		catch (Exception e)
		{
			return "FAIL";
		}
	}

}
