package qr;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;

public class CountingSheep {

	public static void main(String[] args) {
		BufferedReader in;
		BufferedWriter out;
		
		try
		{
			in = new BufferedReader(new FileReader("in.txt"));
			out = new BufferedWriter(new FileWriter("out.txt"));
			
			int cases = Integer.parseInt(in.readLine());
			if (cases < 1)
			{
				in.close();
				out.close();
				return;
			}
			
			for (int caseNumber = 1; caseNumber <= cases; caseNumber++)
			{
				long n = Long.parseLong(in.readLine());
				String substring = solve(n);
				out.write("Case #" + caseNumber + ": " + substring);
				out.newLine();
			}
			in.close();
			out.close();

		}
		catch (Exception e)
		{
			return;
		}
	}
	
	public static String solve(long n)
	{
		if (n == 0)
		{
			return "INSOMNIA";
		}
		
		ArrayList<Long> tenDigits = new ArrayList<Long>();
		tenDigits.add((long) 0);
		tenDigits.add((long) 1);
		tenDigits.add((long) 2);
		tenDigits.add((long) 3);
		tenDigits.add((long) 4);
		tenDigits.add((long) 5);
		tenDigits.add((long) 6);
		tenDigits.add((long) 7);
		tenDigits.add((long) 8);
		tenDigits.add((long) 9);
		int size = 10;
		ArrayList<Long> remaining = tenDigits;
		
		int count = 0; 
		while (size > 0)
		{
			count++;
			long next = count * n;
			remaining = trackDigits(remaining, next);
			size = remaining.size();
		}
		return String.valueOf(count * n);
	}
	
	public static ArrayList<Long> trackDigits(ArrayList<Long> remaining, long n)
	{
		if (remaining == null || remaining.size() == 0 || n < 1)
		{
			return remaining;
		}
		
		long reducedN = n;
		long digit = 0;
		while (reducedN > 0)
		{
			digit = reducedN % 10;
			reducedN = (reducedN - digit) / 10;
			remaining.remove(Long.valueOf(digit));
		}
		return remaining;
	}

}
