package qr;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.LinkedList;
import java.util.ListIterator;

public class FlippingPancakes {

	public static void main(String[] args) {
		BufferedReader in;
		BufferedWriter out;
		
		try
		{
			in = new BufferedReader(new FileReader("in.txt"));
			out = new BufferedWriter(new FileWriter("out.txt"));
			
			int cases = Integer.parseInt(in.readLine());
			if (cases < 1)
			{
				in.close();
				out.close();
				return;
			}
			
			for (int caseNumber = 1; caseNumber <= cases; caseNumber++)
			{
				String input = in.readLine();
				int result = solve(input);
				out.write("Case #" + caseNumber + ": " + result);
				out.newLine();
			}
			in.close();
			out.close();

		}
		catch (Exception e)
		{
			return;
		}
	}
	
	
	public static int solve(String pancakes)
	{
		// The idea is that you keep the last "+'s" no matter what, and just flip at the last "-".
		// It's easier if we reverse the initial string though.
		LinkedList<Character> revPancakes = new LinkedList<Character>();
		// Note that this reverses "the string". Efficiency.
		for (char c : pancakes.toCharArray()) {
			revPancakes.addFirst(c);
		}
		return revSolve(new LinkedList<Character>(revPancakes));
	}
	
	public static int revSolve(LinkedList<Character> revPancakes)
	{
		if (revPancakes == null || revPancakes.size() == 0)
		{
			return 0;
		}
		Boolean isHappy = (revPancakes.removeFirst() == '+');
		if (isHappy)
		{
			return revSolve(revPancakes);
		}
		else
		{
			flip(revPancakes);
			return 1 + revSolve(revPancakes);
		}
	}
	
	public static void flip(LinkedList<Character> pancakes)
	{
		ListIterator<Character> iter = pancakes.listIterator();
		while (iter.hasNext())
		{
			Boolean isHappy = (iter.next() == '+');
			if (isHappy)
			{
				iter.set('-');
			}
			else
			{
				iter.set('+');
			} 
		}
	}
}
