import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

public class CandySplitting {
	public static void main(String[] args) throws ParseException {
		Scanner scanner = new Scanner(System.in);
		PrintWriter out = null;
		try {
			out = new PrintWriter(new FileWriter("C:\\Users\\Admin\\Documents\\codejam\\outputfile3.txt"));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 

		int numCases = Integer.parseInt(scanner.nextLine());
		for(int i = 0; i < numCases; i++) {
			int numCandies = Integer.parseInt(scanner.nextLine());
			int[] candyValues = convertStringArraytoIntArray(scanner.nextLine().split(" "));

			int[] allValues = new int[numCandies];
			for(int z= 0; z < numCandies; z++) {
				allValues[z]=z;
			}

			int max = -1;
			for(int j = 1; j < candyValues.length/2 + 1; j++) {
				CombinationGenerator x = new CombinationGenerator (numCandies, j);
				while (x.hasMore ()) {
					int[] indices = x.getNext();
					int[] remaining = convertIntegers(removeAll(allValues, indices));
					Arrays.sort(indices); 
					Arrays.sort(remaining);
					int binarySumIndices = getBinarySum(indices, candyValues);
					int binarySumRemaining = getBinarySum(remaining, candyValues);
					if(binarySumIndices == binarySumRemaining) {
						int pile1 = getDecimalSum(indices, candyValues);
						int pile2 = getDecimalSum(remaining, candyValues);
						int temp = Math.max(pile1,pile2);
						max = Math.max(max, temp);
					}
				}
			}
			String outputValue;
			if(max == -1) {
				outputValue = "NO";
			}
			else {
				outputValue = max +"";
			}
			out.printf("Case #%d: %s\n",i+1,outputValue);
		}
		out.close();
		System.out.println("done");
	}

	public static int[] convertIntegers(List<Integer> integers)
	{
		int[] ret = new int[integers.size()];
		for (int i=0; i < ret.length; i++)
		{
			ret[i] = integers.get(i).intValue();
		}
		return ret;
	}

	private static int getBinarySum(int[] indices, int[] candyValues) {
		int sum = 0;
		for(int i : indices) {
			sum = xor(sum, candyValues[i]);
		}
		return sum;
	}

	public static int xor(int a, int b) {
		return a ^ b;
	}

	private static int getDecimalSum(int[] indices, int[] candyValues) {
		int sum = 0;
		for(int i : indices) {
			sum += candyValues[i];
		}
		return sum;
	}

	public static int[] convertStringArraytoIntArray(String[] sarray){
		if (sarray != null) {
			int intarray[] = new int[sarray.length];
			for (int i = 0; i < sarray.length; i++) {
				intarray[i] = Integer.parseInt(sarray[i]);
			}
			return intarray;
		}
		return null;
	}
	
	public static ArrayList<Integer> removeAll(int[] a, int[] b) {
		ArrayList<Integer> removed = new ArrayList<Integer>();
		for(int p : a) {
			boolean found = false;
			for(int q : b) {
				if(p == q) {
					found = true;
					break;
				}
			}
			if(!found)
				removed.add(p);
		}
		return removed;
	}

}
