import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Scanner;


public class Round1 {
	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		PrintWriter out = null;
		try {
			out = new PrintWriter(new FileWriter("C:\\Users\\Admin\\Documents\\codejam\\outputfile2.txt"));
		} catch (IOException e) {
			e.printStackTrace();
		} 

		int numCases = Integer.parseInt(scanner.nextLine());
		for(int i = 0; i < numCases; i++) {
			ArrayList<String> teamResults = new ArrayList<String>();
			int numTeams = Integer.parseInt(scanner.nextLine());
			for(int j = 0; j < numTeams; j++) {
				teamResults.add(scanner.nextLine());
			}
			ArrayList<Double> wp = new ArrayList<Double>();
			ArrayList<Double> owp = new ArrayList<Double>();
			ArrayList<Double> oowp = new ArrayList<Double>();
			for(String team : teamResults) {
				wp.add(getWP(team));
			}


			for(int j = 0; j < teamResults.size(); j++) {
				owp.add(getOWP(teamResults.get(j), j, teamResults));
			}

			for(int j = 0; j < teamResults.size(); j++) {
				oowp.add(getOOWP(teamResults.get(j), j, owp));
			}


			out.printf("Case #%d:\n",i+1);
			for(int j = 0; j < wp.size(); j++) {
				out.println(rpi(wp.get(j),owp.get(j),oowp.get(j)));
			}
		}
		out.close();
		System.out.println("done");
	}

	private static Double getOWP(String team, int position, ArrayList<String> teamResults) {
		double total = 0;
		double num = 0;
		for(int i = 0; i < team.length(); i++) {
			if(team.charAt(i) != '.' && i != position) {
				total += getSpecial(teamResults.get(i), position);
				num++;
			}
		}
		return total/num;
	}

	private static double getOOWP(String team, int position, ArrayList<Double> owp) {
		double total = 0;
		double num = 0;
		for(int i = 0; i < team.length(); i++) {
			if(team.charAt(i) != '.' && i != position) {
				total += owp.get(i);
				num++;
			}
		}
		return total/num;
	}

	private static double getSpecial(String team, int position) {
		double won = 0;
		double played = 0;
		for(int i = 0; i < team.length(); i++) {
			if(i != position) {
				if(team.charAt(i) == '1') {
					won++;
					played++;
				}
				else if(team.charAt(i) == '0') {
					played++;
				}
			}
		}

		return won/played;
	}

	private static double getWP(String team) {
		double won = 0;
		double played = 0;
		for(int i = 0; i < team.length(); i++) {
			if(team.charAt(i) == '1') {
				won++;
				played++;
			}
			else if(team.charAt(i) == '0') {
				played++;
			}
		}
		return won/played;
	}

	public static double rpi(double wp, double owp, double oowp) {
		return 0.25 * wp + 0.50 * owp + 0.25 * oowp;
	}
}