package google;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Arrays;

public class Minesweeper {

	static int emptyCells = 0;

	public static void main(String[] args) {

		try {
			String fileName = "C-small-attempt0.in";
			// String fileName = "cockies.txt";
			FileWriter fw = new FileWriter("out-" + fileName);
			BufferedWriter bw = new BufferedWriter(fw);
			FileReader fr = new FileReader(new File(fileName));
			BufferedReader br = new BufferedReader(fr);
			int tests = Integer.parseInt(br.readLine());
			for (int i = 0; i < tests; i++) {
				String[] arr = br.readLine().split(" ");
				int r = Integer.parseInt(arr[0]);
				int c = Integer.parseInt(arr[1]);
				int m = Integer.parseInt(arr[2]);
				String res = solve(r, c, m);
				bw.write("Case #" + (i + 1) + ":");
				bw.write("\n" + res + "\n");
			}
			// System.out.println("Total time : " + total);

			bw.flush();
			br.close();
			bw.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private static String solve(int r, int c, int m) {
		// System.out.println("r=" + r + " c=" + c + " m=" + m);
		int total = r * c;
		boolean valid = false;
		char[][] output = null;
		for (int i = 0; i < r; i++) {
			for (int j = 0; j < c; j++) {
				emptyCells = total - m - 1;
				char[][] b = createBoard(r, c, i, j, empty);
				valid = isValidBoard(b, i, j);
				if (valid) {
					output = b;
					break;
				}
			}
		}
		String abc = "";
		if (valid) {
			abc = formatBoard(output);
			System.out.println(abc);
		} else {
			abc = "Impossible";
			System.out.println(abc);
		}
		return abc;
	}

	private static char[][] createBoard(int r, int c, int startX, int startY, int empty) {
		char[][] board = new char[r][c];
		for (int i = 0; i < board.length; i++) {
			for (int j = 0; j < board[i].length; j++) {
				board[i][j] = mine;
			}
		}
		board[startX][startY] = click;
		fillBoard(board, startX, startY);
		return board;
	}

	private static void fillBoard(char[][] board, int x, int y) {
		ArrayList<int[]> list = new ArrayList<int[]>();
		for (int i = 0; i < deltas.length; i++) {
			if (emptyCells == 0)
				return;
			int row = x + deltas[i][0];
			int col = y + deltas[i][1];
			try {
				if (board[row][col] == mine) {
					board[row][col] = empty;
					emptyCells--;
					list.add(new int[] { row, col });
				}
			} catch (Exception e) {
			}
		}
		for (int i = 0; i < list.size(); i++) {
			int[] arr = list.get(i);
			fillBoard(board, arr[0], arr[1]);
		}
		// for (int i = 0; i < deltas.length; i++) {
		// int row = x + deltas[i][0];
		// int col = y + deltas[i][1];
		// try {
		// if (board[row][col] == mine) {
		// fillBoard(board, emptyCells, row, col);
		// }
		// } catch (Exception e) {
		// }
		//
		// }
	}

	private static boolean isValidBoard(char[][] board, int r, int c) {
		for (int i = 0; i < deltas.length; i++) {
			int row = r + deltas[i][0];
			int col = c + deltas[i][1];
			try {
				if (board[row][col] == mine)
					return false;
			} catch (Exception e) {
			}
		}
		return true;
	}

	private static void printBoard(char[][] board) {
		for (int i = 0; i < board.length; i++) {
			System.out.println(Arrays.toString(board[i]));
		}
	}

	private static String formatBoard(char[][] board) {
		String srt = "";
		for (int i = 0; i < board.length; i++) {
			for (int j = 0; j < board[i].length; j++) {
				srt += board[i][j];
				if (j < board[i].length - 1)
					srt += " ";
			}
			if (i < board.length - 1)
				srt += "\n";
		}
		return srt;
	}

	private static char click = 'c';
	private static char mine = '*';
	private static char empty = '.';
	static int[][] deltas = { { -1, 0 },// up
			{ -1, -1 }, // up-left
			{ 0, -1 },// left
			{ 1, -1 }, // down-left
			{ 1, 0 },// down
			{ 1, 1 }, // down-right
			{ 0, 1 },// right
			{ -1, 1 } // up-right
	};

}