import java.io.*;
import java.util.Arrays;

/**
 * Created by frakhman on 3/15/2016.
 */
public class MainRevengeOfThePancake {

    public static void main(String[] args) {
        String path = "D:\\experiment\\googlecodejam\\src\\main\\resources\\revengeofthepancake";
        String inputFileName = path + "\\B-large.in";
        String outputFileName = path + "\\B-large.out";
        BufferedReader bufferedReader;
        try {
            bufferedReader = new BufferedReader(new FileReader(inputFileName));
            String line = bufferedReader.readLine();
            StringBuilder result = new StringBuilder();

            int count = Integer.parseInt(line);
            line = bufferedReader.readLine();

            for (int  i = 0; i < count ; i++) {
                int countToFlip = 0;
                result.append("Case #").append(i + 1).append(": ");
                String pancake = line;

                while (pancake.contains("-")) {
                    if (pancake.startsWith("-") && pancake.endsWith("-")) {
                        pancake = flipAll(pancake);
                        countToFlip++;
                    }
                    if (!pancake.contains("-")) break;

                    if (pancake.startsWith("-") && pancake.endsWith("+")) {
                        pancake = flipTop(pancake, "-");
                        countToFlip++;
                    }
                    if (!pancake.contains("-")) break;

                    if (pancake.startsWith("+")) {
                        pancake = flipTop(pancake, "+"); countToFlip++;
                        pancake = flipTop(pancake, "-"); countToFlip++;
                    }

                }
                result.append(String.valueOf(countToFlip));
                result.append(System.lineSeparator());

                line = bufferedReader.readLine();
            }

            bufferedReader.close();

            File file = new File(outputFileName);
            if (!file.exists()) {
                file.createNewFile();
            }

            BufferedWriter bufferedWriter = new BufferedWriter(new FileWriter(file.getAbsoluteFile()));
            bufferedWriter.write(result.toString());
            bufferedWriter.close();

        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static String flipAll(String pancake) {
        char[] pancakeArray = pancake.toCharArray();
        char[] pancakeArrayTemp = pancakeArray.clone();
        for (int i = 0; i < pancakeArray.length; i++) {
            char result;
            if (pancakeArray[i] == '+') result = '-';
            else result = '+';
            pancakeArrayTemp[pancakeArray.length - i - 1] = result;
        }
        return String.valueOf(pancakeArrayTemp);
    }

    public static void main2(String[] args) {
        String test = "++--";
        String result = flipTop(test, "+");
    }

    public static String flipTop(String pancake, String toFlip) {
        char[] pancakeArray = pancake.toCharArray();
        int countToFlip = 0;
        while (String.valueOf(pancakeArray[countToFlip]).equals(toFlip)) {
            countToFlip++;
            if (countToFlip >= pancake.length()) break;
        }

        String pancake1 = flipAll(pancake.substring(0, countToFlip));
        String pancake2 = pancake.substring(countToFlip, pancake.length());
        return pancake1 + pancake2;
    }



}
