import java.io.*;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Created by frakhman on 3/15/2016.
 */
public class MainCoinJam {

    public static void main(String[] args) {
        String path = "D:\\experiment\\googlecodejam\\src\\main\\resources\\coinjam";
        String inputFileName = path + "\\C-small-attempt0.in";
        String outputFileName = path + "\\C-small-attempt0.out";
        BufferedReader bufferedReader;
        try {
            bufferedReader = new BufferedReader(new FileReader(inputFileName));
            String line = bufferedReader.readLine();
            StringBuilder result = new StringBuilder();

            int count = Integer.parseInt(line);
            line = bufferedReader.readLine();

            System.out.println(new Date());
            for (int  i = 0; i < count ; i++) {
                result.append("Case #").append(i + 1).append(":").append(System.lineSeparator());

                String[] data = line.split(" ");
                int digitLen = Integer.parseInt(data[0]);
                int limit = Integer.parseInt(data[1]);

                Long lowMarginInt = convertBinary(getLowMargin(digitLen), 2);
                Long highMarginInt = convertBinary(getHighMargin(digitLen), 2);

                List<Long> listOfPrime = getListPrime(highMarginInt);

                int correctValue = 0;

                StringBuilder stringBuilder = new StringBuilder();
                for (Long binaryCount = lowMarginInt; binaryCount <= highMarginInt; binaryCount++) {

                    StringBuilder singleList = new StringBuilder();

                    String binary = Long.toString(binaryCount, 2);
                    if (binary.endsWith("0")) {
                        continue;
                    }
                    singleList.append(binary).append(" ");
                    System.out.print(binary + " ");

                    for (int base = 2; base <= 9; base++) {
                        Long number = convertBinary(binary, base);
                        Long divisor = getDivisor(number, listOfPrime);

                        if (divisor == 0) {
                            singleList = new StringBuilder();
                            break;
                        } else {
                            singleList.append(divisor).append(" ");
                            System.out.print(divisor + " ");
                            continue;
                        }
                        }

                    if (!singleList.toString().equals("")) {
                        singleList.append(System.lineSeparator());
                        System.out.println();
                        correctValue++;
                        if (correctValue >= limit) {
                            break;
                        }
                    }
                    stringBuilder.append(singleList.toString());
                }
                result.append(String.valueOf(stringBuilder.toString()));
                result.append(System.lineSeparator());
                line = bufferedReader.readLine();
            }

            bufferedReader.close();

            File file = new File(outputFileName);
            if (!file.exists()) {
                file.createNewFile();
            }

            BufferedWriter bufferedWriter = new BufferedWriter(new FileWriter(file.getAbsoluteFile()));
            bufferedWriter.write(result.toString());
            bufferedWriter.close();
            System.out.println(new Date());
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static String getHighMargin(int digitLen) {
        StringBuilder highMargin = new StringBuilder();
        for (int iterMargin = 1; iterMargin <= digitLen; iterMargin++) {
            highMargin.append("1");
        }
        return highMargin.toString();
    }

    private static String getLowMargin(int digitLen) {
        StringBuilder lowMargin = new StringBuilder();
        lowMargin.append("1");
        for (int iterMargin = 1; iterMargin <= digitLen - 2; iterMargin++) {
            lowMargin.append("0");
        }
        lowMargin.append("1");
        return lowMargin.toString();
    }

    private static Long convertBinary(String binary, int base){
        char[] binarylist = binary.toCharArray();
        Long result = 0l;
        Long count = 0l;
        for (int i = binarylist.length - 1; i >= 0; i--) {
            if (binarylist[i] == '1') {
                result += (long) Math.pow(base, count);
            }
            count++;
        }
        return result;
    }

    private static Long getDivisor(Long integer, List<Long> listOfPrime) {
        for (Long divisorPrime : listOfPrime) {
            if (integer % divisorPrime == 0) {
                return divisorPrime;
            }
        }
        return 0l;
    }

    private static List<Long> getListPrime(Long limit) {
        List<Long> list = new ArrayList<Long>();
        for (Long i = 1l; i <= limit; i++) {
            int counter=0;
            for (Long num = i; num >= 1; num--) {
                if (i%num==0) {
                    counter = counter + 1;
                }
            }
            if (counter ==2) {
                list.add(i);
            }
        }
        return list;
    }

}
