
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class TicTacToe {

    /**
     * @param args
     */
    public static final int MAGIC_NO = 34;
    public static final int SQUARE = 4;
    int magicSqaure[][] = {{16, 3, 2, 13},
                       {5, 10, 11, 8},
                       {9, 6, 7, 12},
                       {4, 15, 14, 1}};
    
    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new File("A.in"));
        PrintWriter out = new PrintWriter("A.out");
        
        int nc = in.nextInt();
        in.nextLine();
        
        for (int c = 0; c < nc; c++) {
            char ttt[][] = new char[SQUARE][SQUARE];

            for (int i = 0; i < SQUARE; i++) {
                ttt[i] = in.nextLine().toCharArray();
            }
            
            System.out.printf("Case #%d: %s\n", c+1, new TicTacToe().solve(ttt));
            out.printf("Case #%d: %s\n", c+1, new TicTacToe().solve(ttt));
            //skip empty line
            in.nextLine();
        }
        
//        in.nextLine();

//        int cs = 1;
//        while (in.hasNext()) {
//            int amount = in.nextInt();
//            in.nextLine();
//            int ni = in.nextInt();
//            in.nextLine();
//
//            int arr[] = new int[ni];
//            for (int i = 0; i < ni; i++) {
//                arr[i] = in.nextInt();
//            }
//            in.nextLine();
//
//            //print ans
//            int ans[] = new StoreCredit().solve(amount, arr);
//            //System.out.println("Case #" + cs++ + ": " + ans[0] + " " + ans[1]);
//            out.println("Case #" + cs++ + ": " + ans[0] + " " + ans[1]);
//        }

        //new TicTacToe().won();
        
        out.close();
    }

    private String solve(char[][] arr) {
        if (won(arr, 'X')) return "X won";
        else if (won(arr, 'O')) return "O won";
        else if (isGameNotComplete(arr)) return "Game has not completed";
        else return "Draw";
    }
        
    private boolean won(char arr[][], char player) {     
        int mn[][] = toMagicNo(arr, player);
        
        int ver[] = new int[mn.length];
        int diag1 = 0;
        int diag2 = 0;
        
        for (int i = 0; i < mn.length; i++) {
            int hor = 0;
            for (int j = 0; j < mn.length; j++) {
                hor += mn[i][j];
                ver[j]+=mn[i][j];
                if (i == j)
                    diag1+=mn[i][j];
                if ((i+j) == mn.length-1) {
                    diag2+=mn[i][j];
                }
            }
            if (hor == MAGIC_NO) return true;
        }
        
        //if any vertical sum is true
        for (int i = 0; i < ver.length; i++) {
            if (ver[i] == MAGIC_NO) return true;
        }
        //if any main diagonal sum is true
        if (diag1 == MAGIC_NO || diag2 == MAGIC_NO) return true;
        
        return false; //not won
    }
    
    private int[][] toMagicNo(char[][] arr, char player) {
        int[][] mn = new int[arr.length][arr.length];
        for (int i = 0; i < arr.length; i++) {
            for (int j = 0; j < arr.length; j++) {
                if (arr[i][j] == player || arr[i][j] == 'T')
                    mn[i][j] = magicSqaure[i][j];
            }
        }
        
        return mn;
    }
    
    private boolean isGameNotComplete(char[][] arr) {
        for (int i = 0; i < arr.length; i++) {
            for (int j = 0; j < arr.length; j++) {
                if (arr[i][j] == '.') return true;
            }
        }
        
        return false;
    }
}