
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class FairAndSquare {

    /**
     * @param args
     */
    
    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new File("C.in"));
        PrintWriter out = new PrintWriter("C.out");
        
        int nc = in.nextInt();
        in.nextLine();
        
        FairAndSquare fas = new FairAndSquare();
        for (int c = 0; c < nc; c++) {
            int n1 = in.nextInt(); int n2 = in.nextInt();
            System.out.printf("Case #%d: %d\n", c+1, fas.solve(n1, n2));
            out.printf("Case #%d: %d\n", c+1, fas.solve(n1, n2));
        }
        
        out.close();
    }

    private int solve(int n1, int n2) {        
        FairAndSquare fas = new FairAndSquare();
        
        int count = 0;
        for (int i = n1; i <= n2; i++) {
            if (fas.isSquareAndPalindrome(i))
                count++;
        }
        
        return count;
    }
    
    private boolean isSquareAndPalindrome(int n) {
        if (!isPalindrome(n))
            return false;
        
        double sq = Math.sqrt(n);
        if (isWholeNumber(sq) && isPalindrome((int)sq))
            return true;
        
        return false;
    }
    
    private boolean isWholeNumber(double n) {
        if (n == Math.floor(n))
            return true;
        
        return false;
    }
    
    private boolean isPalindrome(int n) {
        String s = String.valueOf(n);
        
        StringBuilder buf = new StringBuilder();
        for (int i = s.length() - 1; i >= 0; i--) {
            buf.append(s.charAt(i));
        }
        if (buf.toString().equals(s)) return true;
        
        return false;
    }
}