import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.nio.CharBuffer;
import java.util.Arrays;
import java.util.Scanner;

public class FileProcessing {	
	public static Scanner getScanner() {
		Scanner scanner;
		try {
			scanner = new Scanner(new File("input.in"));
			return scanner;
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			throw new RuntimeException(e);
		}
	}
	
	public static PrintWriter getPrintWriter() {
		PrintWriter fw;
		try {
			fw = new PrintWriter(new BufferedWriter(new FileWriter("output.out")));
			return fw;
		} catch (IOException e) {
			e.printStackTrace();
			throw new RuntimeException(e);
		}	
	}
	
	public static void closeWriter(PrintWriter writer) {
		writer.flush();
		writer.close();
	}
	
	public static void main(String args[]) {
		PrintWriter fw;
			try {
				fw = new PrintWriter(new BufferedWriter(new FileWriter("output.out")));
				fw.println("test");
				fw.flush();
				fw.close();
			} catch (IOException e) {
				System.out.println(e.getMessage());
			} // create an actual file
			// & a FileWriter obj
	
	}
	
	public static void writeOutput(String name, String contents) {
		try {
			FileWriter fw = new FileWriter(new File(name + ".out")); // create an actual file
			// & a FileWriter obj
			fw.write(contents); // write characters to
			// the file
			fw.flush(); // flush before closing
			fw.close();
		}
		catch (IOException e) {
			System.out.println(e);
		}
	}
	
	public static String readFileAsString(String name) {		
		char[] in = new char[10000000]; // to store input
		int size = 0;

		try {
			File file = new File( // just an object
					name + ".in");
			
			FileReader fr = new FileReader(file); // create a FileReader
			
			// object
			size = fr.read(in); // read the whole file!
			
			String s = new String(in);
			String str[] = s.split("\n");
			fr.close();
						
			return s.trim();
		} 
		catch (IOException e) {
			System.out.println(e);
			throw new RuntimeException();
		}
	}
}
