package qualificationRound;

import java.util.Scanner;

public class PancakeFlip {
	
	Scanner sc = new Scanner(System.in);
	String S[]; 
	char temp[];
	int K[], T;
	int count[], plusCount[];
	int flips[];
	int prev_index;
	
	public static void main(String args[]) {
		new PancakeFlip();
	}
	
	public PancakeFlip() {
		begin();
	}
	
	void init() {
		for (int i = 0; i < count.length; i++) {
			count[i] = 0;
			plusCount[i] = 0;
		}
	}
	
	void begin() {
		
		T = sc.nextInt();
		S = new String[T];
		K = new int[T];
		flips = new int[T];
		int xx=0;
		int index;
		
		for (int i = 0; i < T; i++) {
			S[i] = sc.next();
			K[i] = sc.nextInt();
 		}
		
		for (int i = 0; i < T; i++) {
			
			temp = S[i].toCharArray();
			count = new int[S[i].length()];
			plusCount = new int[S[i].length()];
			prev_index = -1;
					
			while(true) {
				xx++;
				init();
				if(checkPancakes()) {
					break;
				}
				index = calculateCount(K[i]);
				prev_index = index;
				for (int j = 0; j < K[i]; j++) {
					if(temp[index+j]=='+') {
						temp[index+j] ='-';
					}
					else if(temp[index+j]=='-') {
						temp[index+j] = '+';
					}
				}
				flips[i]++;
				if(checkInfinite(S[i]) || xx==1000) {
					flips[i] = -1;
					break;
				}
			}
			xx=0;
		}
		System.out.println();
		for (int i = 0; i < T; i++) {
			if(flips[i]==-1) {
				System.out.println("Case #"+(i+1)+": IMPOSSIBLE");
			}
			else {
				System.out.println("Case #"+(i+1)+": "+flips[i]);
			}
		}
	}
	
	boolean checkInfinite(String str) {
		boolean eq_flag=true;
		char newArray[] = str.toCharArray();
		for (int i = 0; i < temp.length; i++) {
			if(temp[i] != newArray[i]) {
				eq_flag = false;
				break;
			}
		}
		return eq_flag;
	}
	
	boolean checkPancakes() {
		boolean flag=true;
		for (int i = 0; i < temp.length; i++) {
			if(temp[i]=='-') {
				flag = false;
				break;
			}
		}		
		return flag;
	}
	
	int calculateCount(int k) {
		
		int index=0, max=-1;
		int buffer=0;
		int p_max=0;
		boolean zeroFlag=false;
		
		for (int j = 0; j <= count.length-k; j++) {
			for (int l = 0; l < k; l++) {
				if(temp[j+l]=='-') {
					if(buffer<plusCount[j]) {
						buffer = plusCount[j];
					}
					plusCount[j] = 0;
					count[j]++;
				}
				else if(temp[j+l]=='+') {
					plusCount[j]++;
				}
			}
			if(buffer>plusCount[j]) {
				buffer = plusCount[j];
			}
			buffer=0;
		}
		
		for (int i = 0; i <= count.length-k; i++) {
			if(count[i] > max && prev_index != i) {
					index = i;
					max = count[i];
					p_max = plusCount[i];
					if(plusCount[i]==0) {
						zeroFlag = true;
					}
			}
			else if (count[i] == max && prev_index != i) {
				if(plusCount[i]==0) {
					index = i;
					max = count[i];
				}
				else if(plusCount[i] >= p_max && zeroFlag==false) {
					index = i;
					max = count[i];
					p_max = plusCount[i];
				}
			}
		}
		return index;
	}
}