package qualificationRound;

import java.util.ArrayList;
import java.util.Scanner;

public class BathroomStalls {
	
	Scanner sc = new Scanner(System.in);
	int T;
	int N[], K[];
	int stalls[];
	int mid, addr, last_loc, l, r;
	int largeIndex=0;
	ArrayList<Integer> track;
	ArrayList<Integer> address;
	
	public static void main(String args[]) {
		new BathroomStalls();
	}
	
	public BathroomStalls() {
		track = new ArrayList<Integer>();
		address = new ArrayList<Integer>();
		begin();
	}
	
	void init() {
		for (int i = 0; i < stalls.length; i++) {
			stalls[i] = 0;
		}
	}
	
	void begin() {
		
		T = sc.nextInt();
		N = new int[T];
		K = new int[T];
		
		for (int i = 0; i < T; i++) {
			N[i] = sc.nextInt();
			K[i] = sc.nextInt();
		}
		
		for (int i = 0; i < T; i++) {
			stalls = new int[(N[i]+2)];
			init();
			stalls[0] = 1;
			stalls[stalls.length-1] = 1;
			
			if(K[i]>0) {
				mid = N[i]/2;
				if(N[i]%2!=0) {
					last_loc = mid+1;
					stalls[mid+1] = 1;
				}
				else{
					last_loc = mid;
					stalls[mid] = 1;
				}
			}
			for (int j = 0; j < K[i]-1; j++) {
				generateTrack();
				largeIndex = findLargest();
				//System.out.println("\nLargeIndex: "+largeIndex);
				mid = track.get(largeIndex)/2;
				addr = address.get(largeIndex);
				//System.out.println("\nAddr: "+addr+" Mid: "+mid);
				if(track.get(largeIndex)%2!=0) {
					last_loc = addr+mid;
					stalls[last_loc] = 1;
				}
				else {
					last_loc = addr+mid-1;
					stalls[last_loc] = 1;
				}
				/*for(int j2 = 0; j2 < track.size(); j2++) {
					track.remove(j2);
					address.remove(j2);
				}*/
				track.clear();
				address.clear();
				
				if(j==K[i]-2) {
					l = calculateLeft();
					r = calculateRight();
					System.out.println("Case #"+(i+1)+": "+Math.max(l, r)+" "+Math.min(l, r));
					/*System.out.println(calculateLeft());
					System.out.println(calculateRight());*/
				}
				//System.out.println(j);
			}
			if(K[i]==1) {
				l = calculateLeft();
				r = calculateRight();
				System.out.println("Case #"+(i+1)+": "+Math.max(l, r)+" "+Math.min(l, r));
			}
		}
		//printStalls();
	}
	
	int calculateLeft() {
		int left=0, xx=last_loc-1;
		while(true) {
			if(stalls[xx]==1)
				break;
			else
				left++;
			
			xx--;
		}
		return left;
	}
	int calculateRight() {
		int right=0, xx=last_loc+1;
		while(true) {
			if(stalls[xx]==1)
				break;
			else
				right++;
			
			xx++;
		}
		return right;
	}
	
	int findLargest() {
		//System.out.println("\nInside findLargest() !");
		int max=-999, index=0;
		//System.out.println();
		//System.out.println("\ntrack.size(): "+track.size());
		//System.out.println("\naddress.size(): "+address.size());
		for (int k = 0; k < track.size(); k++) {
			//System.out.println("track.get(i): "+track.get(k)+"  ");
			if(max < track.get(k)) {
				max = track.get(k);
				index = k;
			}
		}
		//System.out.println("Returning index: "+index+" track(index): "+track.get(index));
		return index;
	}

	void generateTrack() {
		boolean flag=false, start=false;
		int m = 0, cnt=0;
		while(m<stalls.length) {
			if(stalls[m]==0) {
				if(flag==false) {
					address.add(m);
					flag = true;
				}
				if(start==false) {
					start = true;
				}
				cnt++;
			}
			else if(stalls[m]==1 && start) {
				track.add(cnt);
				cnt=0;
				flag = false;
				start = false;
			}
			m++;
		}
	}
}
