import java.util.Arrays;
import java.util.Scanner;

public class RPI {
    public static void main(String[] args) {
        Scanner reader = new Scanner(System.in);
        int T = Integer.parseInt(reader.nextLine());
        for (int nc = 1; nc <= T; nc++) {
            int n = Integer.parseInt(reader.nextLine());
            char[][] map = new char[n][n];
            for (int i = 0; i < n; i++) {
                map[i] = reader.nextLine().toCharArray();
            }
            System.out.println("Case #" + nc + ":");
            calc(map);
        }
    }

    static char[][] table;

    private static void calc(char[][] map) {
        table = map;
        int n = table.length;
        int[] nwin = new int[n];
        int[] nlose = new int[n];
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (table[i][j] == '1') {
                    nwin[i]++;
                    nlose[j]++;
                } else if (table[i][j] == '0') {
                    nlose[i]++;
                    nwin[j]++;
                }
            }
        }
        // System.out.println(Arrays.toString(nwin));
        // System.out.println(Arrays.toString(nlose));
        double[] wp = new double[n];
        for (int i = 0; i < n; i++)
            wp[i] = 1.0 * nwin[i] / (nwin[i] + nlose[i]);
        // System.out.println(Arrays.toString(wp));
        double[] owp = new double[n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (table[i][j] == '1') {
                    owp[i] += 1.0 * (nwin[j]) / (nwin[j] + nlose[j] - 1);
                } else if (table[i][j] == '0') {
                    owp[i] += 1.0 * (nwin[j] - 1) / (nwin[j] + nlose[j] - 1);
                }
            }
            owp[i] /= (nwin[i] + nlose[i]);
        }
        // System.out.println(Arrays.toString(owp));
        double[] oowp = new double[n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (table[i][j] != '.') {
                    oowp[i] += owp[j];
                }
            }
            oowp[i] /= (nwin[i] + nlose[i]);
        }
        // System.out.println(Arrays.toString(oowp));
        double[] rpi = new double[n];
        for (int i = 0; i < n; i++) {
            rpi[i] = wp[i] / 4.0 + owp[i] / 2.0 + oowp[i] / 4.0;
            System.out.println(rpi[i]);
        }
    }
}
