import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Scanner;

public class Chess {

	public static void main(String[] args) throws IOException {
		new Chess().doit();
	}

	char[][] board;
	int[][] right, bottom;

	private void doit() throws IOException {
		Scanner reader = new Scanner(System.in);
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.txt"));
		int ncase = reader.nextInt();
		for (int c = 1; c <= ncase; c++) {
			int m = reader.nextInt(), n = reader.nextInt();
			reader.nextLine();
			board = new char[m][n];
			right = new int[m][n];
			bottom = new int[m][n];
			for (int i = 0; i < m; i++) {
				Long temp = Long.parseLong(reader.nextLine(), 16);
				String t = Long.toBinaryString(temp);
				while (t.length() < n)
					t = "0" + t;
				board[i] = t.toCharArray();
			}
			HashMap<Integer, Integer> result = new HashMap<Integer, Integer>();

			for (int len = Math.min(m, n); len >= 1; len--) {
				for (int i = 0; i < m; i++) {
					for (int j = 0; j < n; j++) {
						if (i + len > m || j + len > n)
							continue;
						boolean ok = true;
						for (int a = i; ok && a < i + len; a++) {
							for (int b = j; b < j + len; b++) {
								if (board[a][b] == 0) {
									ok = false;
									break;
								}
								int diff = (a - i) + (b - j);
								if (diff % 2 == 0 && board[a][b] != board[i][j]) {
									ok = false;
									break;
								}
								if (diff % 2 == 1 && board[a][b] == board[i][j]) {
									ok = false;
									break;
								}
							}
						}
						if (ok) {
							if (result.containsKey(len) == false)
								result.put(len, 0);
							result.put(len, result.get(len) + 1);
							for (int a = i; a < i + len; a++) {
								for (int b = j; b < j + len; b++) {
									board[a][b] = 0;
								}
							}
						}
					}
				}

			}

			System.out.println("Case #" + c + ": " + result.keySet().size());
			writer.write("Case #" + c + ": " + result.keySet().size() + "\n");
			ArrayList<Integer> set = new ArrayList<Integer>(result.keySet());
			Collections.sort(set);
			for (int i = set.size() - 1; i >= 0; i--) {
				System.out.println(set.get(i) + " " + result.get(set.get(i)));
				writer.write(set.get(i) + " " + result.get(set.get(i)) + "\n");
			}
		}
		reader.close();
		writer.close();
	}

}
