import java.util.Scanner;

class ProblemA {
	public static void main (String args []) {
		Scanner read = new Scanner(System.in);
		int N = Integer.parseInt(read.nextLine());
		
		for (int i = 1; i <=N; i++) {
			String input [] = read.nextLine().split(" ");
			
			String pancake = input[0];
			int flipper = Integer.parseInt(input[1]);
			
			int result = findMinimumProcess(0, pancake, flipper);
			String output = "IMPOSSIBLE";
			if (result != -1) {
				output = result + "";	
			}
			System.out.println("Case #"+i+": "+output);		
		}
	}
	
	static int findMinimumProcess(int count, String pancake, int flipper){
		pancake = cleanSide(pancake);
		//System.out.println(pancake);
		if (pancake.length() == 0) {
			return count;
		} else if (pancake.length() < flipper) {
			return -1;	
		} else if (pancake.length() == flipper) {
			pancake = singleFlip(pancake);
			count ++;
		} else {
			pancake = doubleFlip(pancake, flipper);
			count += 2;
		}
		return findMinimumProcess(count, pancake, flipper);
	}
	
	static String singleFlip(String pancake) {
		String res = "";
		for (int i = 0; i < pancake.length(); i++) {
			if (pancake.charAt(i)=='+') {
				res += "-";
			} else {
				res += "+";
			}
		}
		return res;
	}
	
	static String doubleFlip(String pancake, int flipper) {
		StringBuilder p = new StringBuilder(pancake);
		for (int i = 0; i < flipper; i++){
			if (pancake.charAt(i)=='+') {
				p.setCharAt(i, '-');
			} else {
				p.setCharAt(i, '+');
			}			
		}
		int size = pancake.length();
		pancake = p.toString();
		p = new StringBuilder(pancake);
		for (int i = size-1; i >= size-flipper; i--){
			if (pancake.charAt(i)=='+') {
				p.setCharAt(i, '-');
			} else {
				p.setCharAt(i, '+');
			}			
		}
		return p.toString();
	}
	
	static String cleanSide(String pancake) {
		if (pancake.equals("")){
			return "";	
		}
		
		int change = 0;
		if (pancake.charAt(0) == '+' )  {
			pancake = pancake.substring(1, pancake.length());
			change++;
		}
		
		int last = pancake.length()-1;
		if (last >=0 && pancake.charAt(last) == '+') {
			pancake = pancake.substring(0, last);			
			change++;
		}
		
		if (change==0) {
			return pancake;
		}
		return cleanSide(pancake);
	}


}