import java.util.*;
import java.io.*;

public class C implements Runnable {
	private final String problemID = getClass().getName().toLowerCase();
	private final String problemType = "small";
	private BufferedReader in;
	private PrintWriter out;
	private StringTokenizer st;
	
	private void solveSingleTest(int testNumber) throws IOException {
		int r = nextInt();
		int k = nextInt();
		int n = nextInt();
		
		int[] g = new int[n];
		long gSum = 0;
		for (int i = 0; i < n; i++) {
			g[i] = nextInt();
			gSum += g[i];
		}
		
		long[] money = new long[n];
		int[] next = new int[n];
		for (int i = 0; i < n; i++) {
			long curMoney = 0;
			int kLeft = k;
			
			int j = i;
			while (kLeft >= g[j]) {
				curMoney += g[j];
				kLeft -= g[j];
				if (j == n - 1) {
					j = 0;
				} else {
					j = j + 1;
				}
				if (j == i) {
					break;
				}
			}
			
			money[i] = curMoney;
			next[i] = j;
		}
		
		int[] visited = new int[n];
		long[] visitedMoney = new long[n];
		Arrays.fill(visited, -1);
		int rLeft = r;
		int curPos = 0;
		long answer = 0;
		int visitedCount = 0;
		boolean cycleFound = false;
		while (rLeft > 0) {
			if (!cycleFound && visited[curPos] != -1) {
				long cycleMoney = answer - visitedMoney[curPos];
				int cycleLength = visitedCount - visited[curPos];
				
				int cycles = rLeft / cycleLength;
				answer += cycleMoney * cycles;
				rLeft -= cycleLength * cycles;
				cycleFound = true;
				continue;
			}
			visited[curPos] = visitedCount++;
			visitedMoney[curPos] = answer;
			
			answer += money[curPos];
			curPos = next[curPos];
			rLeft--;
		}
		
		out.println("Case #" + testNumber + ": " + answer);
	}
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	public static void main(String[] args) {
		new Thread(new C()).start();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void solve() throws IOException {
		in = new BufferedReader(new FileReader(new File(problemID + "-" + problemType + ".in")));
		out = new PrintWriter(new File(problemID + "-" + problemType + ".out"));
		
		int testsNumber = nextInt();
		for (int i = 0; i < testsNumber; i++) {
			solveSingleTest(i + 1);
		}
		
		in.close();
		out.close();
	}
}
