import java.util.*;
import java.io.*;

public class ASmall implements Runnable {
	private BufferedReader in;
	private PrintWriter out;
	private String problemID = getClass().getName().toLowerCase().split("_")[0];
	private StringTokenizer st;
	
	private int[][] p;
	private int n;
	
	private int encode(int[] pp) {
		int result = 0;
		for (int i = 0; i < n; i++) {
			result = 10 * result + pp[i];
		}
		return result;
	}
	
	private void solveSingleTest(int testNumber) throws IOException {
		n = nextInt();
		int[] a = new int[n];
		for (int i = 0; i < n; i++) {
			String line = nextToken();
			for (int j = 0; j < line.length(); j++) {
				if (line.charAt(j) == '1') {
					a[i] = j;
				}
			}
		}
		
		p = new int[50000][n];
		for (int i = 0; i < n; i++) {
			p[0][i] = i;
		}
		int low = 0;
		int hi = 1;
		int[] pp = new int[n];
		Map<Integer, Integer> d = new HashMap<Integer, Integer>();
		d.put(encode(p[0]), 0);
		while (low < hi) {
			int cur = encode(p[low]);
			for (int i = 0; i < n; i++) {
				pp[i] = p[low][i];
			}
			low++;
			
			boolean bad = false;
			for (int i = 0; i < n; i++) {
				if (a[pp[i]] > i) {
					bad = true;
					break;
				}
			}
			if (!bad) {
				out.println("Case #" + testNumber + ": " + d.get(cur));
				break;
			}
			
			for (int i = 0; i + 1 < n; i++) {
				int tmp = pp[i];
				pp[i] = pp[i + 1];
				pp[i + 1] = tmp;
				int code = encode(pp);
				if (d.containsKey(code)) {
					tmp = pp[i];
					pp[i] = pp[i + 1];
					pp[i + 1] = tmp;
					continue;
				}
				d.put(code, d.get(cur) + 1);
				for (int j = 0; j < n; j++) {
					p[hi][j] = pp[j];
				}
				hi++;
				tmp = pp[i];
				pp[i] = pp[i + 1];
				pp[i + 1] = tmp;
			}
		}
	}

	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	private void solve() throws IOException {
		int tests = nextInt();
		for (int i = 0; i < tests; i++) {
			solveSingleTest(i + 1);
		}
	}
	
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader(new File(problemID + ".in")));
			out = new PrintWriter(new File(problemID + ".out"));
			solve();
			in.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	public static void main(String[] args) {
		new Thread(new ASmall()).start();
	}
}
