import java.util.*;
import java.io.*;

public class B implements Runnable {
	private final String problemID = getClass().getName().toUpperCase();
	private final String problemType = "large";
	private BufferedReader in;
	private PrintWriter out;
	private StringTokenizer st;
	
	private long C;
	
	private long calcPBound(long L, int iter) {
		if (iter == 0) {
			return L * C;
		}
		
		long r = calcPBound(L, iter - 1);
		
		long low = L * C;
		long hi = (long) 1e10;
		while (low + 1 < hi) {
			long middle = (low + hi) / 2;
			if (r >= calcLBound(middle, iter - 1)) {
				low = middle;
			} else {
				hi = middle;
			}
		}
		return low;
	}
	
	private long calcLBound(long P, int iter) {
		if (iter == 0) {
			return (P + C - 1) / C;
		}
		
		long r = calcLBound(P, iter - 1);
		
		long low = 0;
		long hi = (P + C - 1) / C;
		while (low + 1 < hi) {
			long middle = (low + hi) / 2;
			if (calcPBound(middle, iter - 1) >= r) {
				hi = middle;
			} else {
				low = middle;
			}
		}
		return hi;
	}
	
	private int calc(long l, long p) {
		for (int answer = 0; ; answer++) {
			if (calcPBound(l, answer) >= p) {
				return answer;
			}
		}
	}
	
	private void solveSingleTest(int testNumber) throws IOException {
		long l = nextInt();
		long p = nextInt();
		C = nextInt();
		
		System.out.println(testNumber);
		
		out.println("Case #" + testNumber + ": " + calc(l, p));
	}
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	public static void main(String[] args) {
		new Thread(new B()).start();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void solve() throws IOException {
		in = new BufferedReader(new FileReader(new File(problemID + "-" + problemType + ".in")));
		out = new PrintWriter(new File(problemID + "-" + problemType + ".out"));
		
		int testsNumber = nextInt();
		for (int i = 0; i < testsNumber; i++) {
			solveSingleTest(i + 1);
		}
		
		in.close();
		out.close();
	}
}
