import java.io.*;
import java.util.*;

public class Water implements Runnable {
	private BufferedReader in;
	private PrintWriter out;
	private String problemID = getClass().getName().split("_")[0].toLowerCase() + "_large";
	private StringTokenizer st = null;
	private static final int[] dx = { -1, 0, 0, 1 };
	private static final int[] dy = { 0, -1, 1, 0 };
	private static final int[] dr = { 3, 2, 1, 0 };
	
	private int[][] f, col;
	private boolean[][][] go;
	private int curColor;
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	private void sovleSingleTest(int testNum) throws IOException {
		int h = nextInt();
		int w = nextInt();
		f = new int[h][w];
		col = new int[h][w];
		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				f[i][j] = nextInt();
				col[i][j] = -1;
			}
		}
		go = new boolean[h][w][4];
		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				int min = f[i][j];
				int mind = -1;
				for (int dir = 0; dir < 4; dir++) {
					int ii = i + dx[dir];
					int jj = j + dy[dir];
					if (ii < 0 || ii >= h || jj < 0 || jj >= w) {
						continue;
					}
					if (f[ii][jj] < min) {
						min = f[ii][jj];
						mind = dir;
					}
				}
				if (mind < 0) {
					continue;
				}
				int ii = i + dx[mind];
				int jj = j + dy[mind];
				go[ii][jj][dr[mind]] = true;
				go[i][j][mind] = true;
			}
		}
		curColor = 0;
		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				if (col[i][j] != -1) {
					continue;
				}
				dfs(i, j);
				curColor++;
			}
		}
		out.println("Case #" + testNum + ":");
		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				out.print((char) (col[i][j] + 'a'));
				if (j < w - 1) {
					out.print(" ");
				}
			}
			out.println();
		}
	}

	private void dfs(int i, int j) {
		col[i][j] = curColor;
		for (int dir = 0; dir < 4; dir++) {
			if (!go[i][j][dir]) {
				continue;
			}
			int ii = i + dx[dir];
			int jj = j + dy[dir];
			if (col[ii][jj] == -1) {
				dfs(ii, jj);
			}
		}
	}

	private void solve() throws IOException {
		int t = nextInt();
		for (int i = 0; i < t; i++) {
			sovleSingleTest(i + 1);
		}
	}
	
	public static void main(String[] args) {
		new Thread(new Water()).start();
	}

	public void run() {
		try {
			in = new BufferedReader(new FileReader(new File(problemID + ".in")));
			out = new PrintWriter(new File(problemID + ".out"));
			solve();
			in.close();
			out.close();
		} catch (IOException e) {
			
		}
	}
}
