import java.util.*;
import java.io.*;

public class B implements Runnable {
	private BufferedReader in;
	private PrintWriter out;
	private String problemID = getClass().getName().toLowerCase().split("_")[0] + "-small-attempt3";
//	private String problemID = getClass().getName().toLowerCase().split("_")[0] + "";
	private StringTokenizer st;
	private final int inf = Integer.MAX_VALUE / 3;
	
	private int[] d, h, p;
	private int hs;
	
	private void add(int u) {
		h[++hs] = u;
		p[h[hs]] = hs;
		siftUp(hs);
	}
	
	private void swap(int u, int v) {
		int tmp = h[u];
		h[u] = h[v];
		h[v] = tmp;
		p[h[u]] = u;
		p[h[v]] = v;
	}

	private void siftUp(int u) {
		while (u > 1) {
			int uu = u / 2;
			if (d[h[uu]] > d[h[u]]) {
				swap(uu, u);
				u = uu;
			} else {
				break;
			}
		}
	}

	private int emin() {
		int result = h[1];
		
		swap(1, hs);
		p[h[hs]] = -1;
		hs--;
		
		siftDown(1);
		return result;
	}

	private void siftDown(int u) {
		while (u <= hs) {
			int left = 2 * u;
			int right = left + 1;
			int min = u;
			if (left <= hs && d[h[left]] < d[h[min]]) {
				min = left;
			}
			if (right <= hs && d[h[right]] < d[h[min]]) {
				min = right;
			}
			if (min != u) {
				swap(min, u);
				u = min;
			} else {
				break;
			}
		}
	}

	private void solveSingleTest(int testNumber) throws IOException {
		int r = nextInt();
		int c = nextInt();
		int f = nextInt();
		boolean[][] field = new boolean[r][c];
		int[][] goDown = new int[r][c];
		for (int i = 0; i < r; i++) {
			String line = nextToken();
			for (int j = 0; j < c; j++) {
				field[i][j] = (line.charAt(j) == '.');
			}
		}
		for (int i = r - 1; i >= 0; i--) {
			for (int j = 0; j < c; j++) {
				if (!field[i][j]) {
					if (i == r - 1) {
						goDown[i][j] = i;
						continue;
					}
					if (field[i + 1][j]) {
						goDown[i][j] = goDown[i + 1][j];
					} else {
						goDown[i][j] = i;
					}
					continue;
				}
				if (i == r - 1 || !field[i + 1][j]) {
					goDown[i][j] = i;
					continue;
				}
				goDown[i][j] = goDown[i + 1][j];
			}
		}
		boolean[][][] stoneLeft = new boolean[r][c][c];
		boolean[][][] stoneRight = new boolean[r][c][c];
		for (int step = 1; step < c; step++) {
			for (int u = r - step; u >= 0; u--) {
				for (int v = step - 1; v < c; v++) {
					if (step == 1) {
						stoneLeft[u][v][step] = (!field[u][v]);
						continue;
					} else if (step == 2) {
						stoneLeft[u][v][step] = (!field[u][v]) && (!field[u][v - 1]) && (!field[u + 1][v]) && (!field[u + 1][v - 1]);
						continue;
					}
					stoneLeft[u][v][step] = stoneLeft[u][v - 1][step - 1] && stoneLeft[u + 1][v][step - 1];
				}
			}
			for (int u = r - step; u >= 0; u--) {
				for (int v = c - step; v >= 0; v--) {
					if (step == 1) {
						stoneRight[u][v][step] = (!field[u][v]);
						continue;
					} else if (step == 2) {
						stoneRight[u][v][step] = (!field[u][v]) && (!field[u][v + 1]) && (!field[u + 1][v]) && (!field[u + 1][v + 1]);
						continue;
					}
					stoneRight[u][v][step] = stoneRight[u][v + 1][step - 1] && stoneRight[u + 1][v][step - 1];
				}
			}
		}
		int[][] freeRight = new int[r][c];
		int[][] freeLeft = new int[r][c];
		for (int i = 0; i < r; i++) {
			for (int j = c - 1; j >= 0; j--) {
				if (!field[i][j]) {
					freeRight[i][j] = j - 1;
				} else {
					if (j == c - 1) {
						freeRight[i][j] = j;
					} else {
						freeRight[i][j] = freeRight[i][j + 1];
					}
				}
			}
			for (int j = 0; j < c; j++) {
				if (!field[i][j]) {
					freeLeft[i][j] = j + 1;
				} else {
					if (j == 0) {
						freeLeft[i][j] = j;
					} else {
						freeLeft[i][j] = freeLeft[i][j - 1];
					}
				}
			}
		}
		
		d = new int[r * c];
		for (int i = 0; i < r * c; i++) {
			d[i] = inf;
		}
		h = new int[r * c + 1];
		p = new int[r * c];
		Arrays.fill(p, -1);
		
		d[0] = 0;
		add(0);
		int answer = inf;
		while (hs > 0) {
			int pos = emin();
			int u = pos / c;
			int v = pos % c;
			if (u == r - 1) {
				answer = Math.min(answer, d[pos]);
			}
			for (int dir = -1; dir <= 1; dir += 2) {
				int uu = u;
				int vv = v + dir;
				if (vv < 0 || vv >= c || !field[uu][vv]) {
					continue;
				}
				if (goDown[uu][vv] - uu > f) {
					continue;
				}
				uu = goDown[uu][vv];
				int newPos = uu * c + vv;
				if (d[pos] < d[newPos]) {
					d[newPos] = d[pos];
					if (p[newPos] == -1) {
						add(newPos);
					}
					siftUp(p[newPos]);
				}
			}
			for (int dir = -1; dir <= 1; dir += 2) {
				if (u == r - 1) {
					continue;
				}
				for (int step = 1; step < c; step++) {
					if (dir == 1) {
						if (v + step >= c) {
							continue;
						}
						if (!stoneLeft[u + 1][v + step][step]) {
							continue;
						}
					} else {
						if (v - step < 0) {
							continue;
						}
						if (!stoneRight[u + 1][v - step][step]) {
							continue;
						}
					}
					if (dir == 1) {
						if (freeRight[u][v + 1] < v + step) {
							continue;
						}
					} else {
						if (freeLeft[u][v - 1] > v - step) {
							continue;
						}
					}
					int uu = u + step;
					int vv = v + dir * step;
					if (uu >= r || vv < 0 || vv >= c) {
						continue;
					}
					int dist = goDown[uu][vv] - uu;
					if (dist > f) {
						continue;
					}
					uu = goDown[uu][vv];
					int addon = step * (step + 1) / 2;
					
					int newPos = uu * c + vv;
					if (d[pos] + addon < d[newPos]) {
						d[newPos] = d[pos] + addon;
						if (p[newPos] == -1) {
							add(newPos);
						}
						siftUp(p[newPos]);
					}
				}
			}
		}
		if (answer == inf) {
			out.println("Case #" + testNumber + ": No");
		} else {
			out.println("Case #" + testNumber + ": Yes " + answer);
		}
	}

	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	private void solve() throws IOException {
		int tests = nextInt();
		for (int i = 0; i < tests; i++) {
			solveSingleTest(i + 1);
		}
	}
	
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader(new File(problemID + ".in")));
			out = new PrintWriter(new File(problemID + ".out"));
			solve();
			in.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	public static void main(String[] args) {
		new Thread(new B()).start();
	}
}
