import java.io.*;

public class Welcome implements Runnable {
	private BufferedReader in;
	private PrintWriter out;
	private String problemID = getClass().getName().split("_")[0].toLowerCase() + "_large";
	
	private void solve() throws IOException {
		int n = Integer.parseInt(in.readLine());
		for (int i = 0; i < n; i++) {
			String line = in.readLine();
			String msg = "welcome to code jam";
			int ans = calc(line, msg);
			String result = "" + ans;
			while (result.length() < 4) {
				result = "0" + result;
			}
			out.println("Case #" + (i + 1) + ": " + result);
		}
	}
	
	private int calc(String a, String b) {
		int n = a.length();
		int m = b.length();
		int[][] ans = new int[n][m];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				ans[i][j] = (i > 0) ? ans[i - 1][j] : 0;
				if (a.charAt(i) == b.charAt(j)) {
					if (j == 0) {
						ans[i][j]++;
					} else if (i > 0) {
						ans[i][j] += ans[i - 1][j - 1];
					}
				}
				while (ans[i][j] >= 10000) {
					ans[i][j] -= 10000;
				}
			}
		}
		return ans[n - 1][m - 1];
	}

	public static void main(String[] args) {
		new Thread(new Welcome()).start();
	}

	public void run() {
		try {
			in = new BufferedReader(new FileReader(new File(problemID + ".in")));
			out = new PrintWriter(new File(problemID + ".out"));
			solve();
			in.close();
			out.close();
		} catch (IOException e) {
			
		}
	}
}
