import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class goro_rs implements Runnable {
	private final String problemId = getClass().getName().split("_")[0];
	private BufferedReader in;
	private PrintWriter out;
	private StringTokenizer st;
	
	private void solveSingleTest(int testNumber) throws IOException {
		int n = nextInt();
		int count = 0;
		for (int i = 0; i < n; i++) {
			if (nextInt() - 1 != i) {
				count++;
			}
		}
		out.println("Case #" + testNumber + ": " + count);
	}

	public static void main(String[] args) {
		new Thread(new goro_rs()).start();
	}

	@Override
	public void run() {
		try {
			in = new BufferedReader(new FileReader(new File(problemId + ".in")));
			out = new PrintWriter(new File(problemId + ".out"));
			int tests = nextInt();
			for (int i = 0; i < tests; i++) {
				solveSingleTest(i + 1);
			}
			in.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
}
