import java.util.*;
import java.io.*;

public class A implements Runnable {
	private final String problemID = getClass().getName().toUpperCase();
	private final String problemType = "small";
	private BufferedReader in;
	private PrintWriter out;
	private StringTokenizer st;
	
	private void solveSingleTest(int testNumber) throws IOException {
		int n = nextInt();
		int[] a = new int[n];
		int[] b = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = nextInt();
			b[i] = nextInt();
		}
		int answer = 0;
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				if ((a[i] < a[j]) != (b[i] < b[j])) {
					answer++;
				}
			}
		}
		out.println("Case #" + testNumber + ": " + answer);
	}
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	public static void main(String[] args) {
		new Thread(new A()).start();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void solve() throws IOException {
		in = new BufferedReader(new FileReader(new File(problemID + "-" + problemType + ".in")));
		out = new PrintWriter(new File(problemID + "-" + problemType + ".out"));
		
		int testsNumber = nextInt();
		for (int i = 0; i < testsNumber; i++) {
			solveSingleTest(i + 1);
		}
		
		in.close();
		out.close();
	}
}
