import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class candy_rs implements Runnable {
	private final String problemId = getClass().getName().split("_")[0];
	private BufferedReader in;
	private PrintWriter out;
	private StringTokenizer st;
	
	private void solveSingleTest(int testNumber) throws IOException {
		int n = nextInt();
		long sum = 0;
		long min = Long.MAX_VALUE;
		int xor = 0;
		for (int i = 0; i < n; i++) {
			int cur = nextInt();
			xor ^= cur;
			min = Math.min(min, cur);
			sum += cur;
		}
		if (xor != 0) {
			out.println("Case #" + testNumber + ": NO");
		} else {
			out.println("Case #" + testNumber + ": " + (sum - min));
		}
	}

	public static void main(String[] args) {
		new Thread(new candy_rs()).start();
	}

	@Override
	public void run() {
		try {
			in = new BufferedReader(new FileReader(new File(problemId + ".in")));
			out = new PrintWriter(new File(problemId + ".out"));
			int tests = nextInt();
			for (int i = 0; i < tests; i++) {
				solveSingleTest(i + 1);
			}
			in.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
}
