import java.util.*;
import java.io.*;
import java.math.BigInteger;

public class B implements Runnable {
	private final String problemID = getClass().getName().toLowerCase();
	private final String problemType = "large";
	private BufferedReader in;
	private PrintWriter out;
	private StringTokenizer st;
	
	private void solveSingleTest(int testNumber) throws IOException {
		int n = nextInt();
		BigInteger[] t = new BigInteger[n];
		for (int i = 0; i < n; i++) {
			t[i] = new BigInteger(nextToken());
		}
		BigInteger g = BigInteger.ZERO;
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				g = g.gcd(t[i].subtract(t[j]));
			}
		}
		
		BigInteger y = g.subtract(t[0].mod(g));
		if (y.equals(g)) {
			y = BigInteger.ZERO;
		}
		
		out.println("Case #" + testNumber + ": " + y);
		System.out.println("Case #" + testNumber + ": " + y);
	}
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	public static void main(String[] args) {
		new Thread(new B()).start();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void solve() throws IOException {
//		{
//			Random rnd = new Random(82834);
//			int n = 1000;
//			for (int i = 0; i < n; i++) {
//				System.out.println(new BigInteger(166, rnd));
//			}
//		}
		
		in = new BufferedReader(new FileReader(new File(problemID + "-" + problemType + ".in")));
		out = new PrintWriter(new File(problemID + "-" + problemType + ".out"));
		
		int testsNumber = nextInt();
		for (int i = 0; i < testsNumber; i++) {
			solveSingleTest(i + 1);
		}
		
		in.close();
		out.close();
	}
}
