import java.io.*;
import java.util.*;

public class MouseTrap implements Runnable {
	private final String problemID = getClass().getName() + "_small";
	private BufferedReader in;
	private PrintWriter out;
	private int[] ans;
	private boolean[] mark;
	
	private void solveSingleTest(int testNumber) throws IOException {
		int k = Integer.parseInt(in.readLine());
		Scanner sc = new Scanner(in.readLine());
		int n = sc.nextInt();
		int[] d = new int[n];
		for (int i = 0; i < n; i++) {
			d[i] = sc.nextInt();
		}
		
		System.out.println("Running on test " + testNumber);
		
//		int[] ans = new int[k];
		int pos = 0;
//		boolean[] mark = new boolean[k];
		Arrays.fill(mark, false);
		for (int i = 1; i <= k; i++) {
			ans[pos] = i;
			mark[pos] = true;
			if (i == k) {
				break;
			}
			for (int j = 0; j <= i; j++) {
				while (true) {
					pos = pos + 1;
					if (pos == k) {
						pos = 0;
					}
					if (!mark[pos]) {
						break;
					}
				}
			}
		}
		out.print("Case #" + testNumber + ":");
		for (int i = 0; i < n; i++) {
			out.print(" " + ans[d[i] - 1]);
		}
		out.println();
	}

	private void solve() throws IOException {
		in = new BufferedReader(new FileReader(new File(problemID + ".in")));
		out = new PrintWriter(new File(problemID + ".out"));
		
		mark = new boolean[10000];
		ans = new int[10000];
		int testsNumber = Integer.parseInt(in.readLine());
		for (int testNumber = 1; testNumber <= testsNumber; testNumber++) {
			solveSingleTest(testNumber);
		}
		
		in.close();
		out.close();
	}
	
	public static void main(String[] args) {
		new Thread(new MouseTrap()).start();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
