import java.util.*;
import java.io.*;

public class Universe implements Runnable {
	private final String problemName = getClass().getName().toLowerCase() + "_1";
	private BufferedReader in;
	private PrintWriter out;
	
	private void solveSingleTest(int testNumber) throws IOException {
		int s = Integer.parseInt(in.readLine());
		String[] words = new String[s];
		for (int i = 0; i < s; i++) {
			words[i] = in.readLine();
		}
		int q = Integer.parseInt(in.readLine());
		String[] queries = new String[q];
		for (int i = 0; i < q; i++) {
			queries[i] = in.readLine();
		}
		int[][] ans = new int[q][s];
		for (int i = 0; i < q; i++) {
			for (int j = 0; j < s; j++) {
				if (queries[i].equals(words[j])) {
					ans[i][j] = -1;
					continue;
				}
				if (i == 0) {
					ans[i][j] = 0;
					continue;
				}
				ans[i][j] = Integer.MAX_VALUE;
				for (int k = 0; k < s; k++) {
					if (ans[i - 1][k] == -1) {
						continue;
					}
					ans[i][j] = Math.min(ans[i][j], ans[i - 1][k] + ((k == j) ? 0 : 1));
				}
			}
		}
		int answer = Integer.MAX_VALUE;
		if (q > 0) {
			for (int j = 0; j < s; j++) {
				if (ans[q - 1][j] == -1) {
					continue;
				}
				answer = Math.min(answer, ans[q - 1][j]);
			}
		} else {
			answer = 0;
		}
		out.println("Case #" + testNumber + ": " + answer);
	}
	
	public static void main(String[] args) {
		new Thread(new Universe()).start();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void solve() throws IOException {
		in = new BufferedReader(new FileReader(new File(problemName + ".in")));
		out = new PrintWriter(new File(problemName + ".out"));
		
		int tests = Integer.parseInt(in.readLine());
		for (int test = 1; test <= tests; test++) {
			solveSingleTest(test);
		}
		
		in.close();
		out.close();
	}
}
