import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class bot_rs implements Runnable {
	private final String problemId = getClass().getName().split("_")[0];
	private BufferedReader in;
	private PrintWriter out;
	private StringTokenizer st;
	
	private int dist(int x0, int x1, int x2) {
		if (x0 < x1) {
			return x1 - x0;
		} else if (x0 <= x2) {
			return 0;
		} else {
			return x0 - x2;
		}
	}
	
	private void solveSingleTest(int testNumber) throws IOException {
		int n = nextInt();
		int x1 = 1, x2 = 1;
		int y1 = 1, y2 = 1;
		int answer = 0;
		for (int i = 0; i < n; i++) {
			char cur = nextToken().charAt(0);
			int pos = nextInt();
			if (cur == 'O') {
				int d = dist(pos, x1, x2) + 1;
				answer += d;
				y1 = Math.max(y1 - d, 1);
				y2 = Math.min(y2 + d, 100);
				x1 = pos;
				x2 = pos;
			} else {
				int d = dist(pos, y1, y2) + 1;
				answer += d;
				x1 = Math.max(x1 - d, 1);
				x2 = Math.min(x2 + d, 100);
				y1 = pos;
				y2 = pos;
			}
		}
		out.println("Case #" + testNumber + ": " + answer);
	}

	public static void main(String[] args) {
		new Thread(new bot_rs()).start();
	}

	@Override
	public void run() {
		try {
			in = new BufferedReader(new FileReader(new File(problemId + ".in")));
			out = new PrintWriter(new File(problemId + ".out"));
			int tests = nextInt();
			for (int i = 0; i < tests; i++) {
				solveSingleTest(i + 1);
			}
			in.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
}
