import java.io.*;
import java.util.*;

public class Triangles implements Runnable {
	private final String problemID = getClass().getName() + "_small";
	private BufferedReader in;
	private PrintWriter out;
	
	private class Point {
		public long x, y;
		
		public Point(long x, long y) {
			this.x = x;
			this.y = y;
		}
		
		@Override
		public int hashCode() {
			return (int) (x ^ y);
		}
		
		public boolean equals(Object z) {
			Point that = (Point) z;
			return (x == that.x) && (y == that.y);
		}
	}
	
	private void solveSingleTest(int testNumber) throws IOException {
		Scanner sc = new Scanner(in.readLine());
		int n = sc.nextInt();
		long a = sc.nextLong();
		long b = sc.nextLong();
		long c = sc.nextLong();
		long d = sc.nextLong();
		long x0 = sc.nextLong();
		long y0 = sc.nextLong();
		long m = sc.nextLong();
		
		long[] x = new long[n];
		long[] y = new long[n];
		x[0] = x0;
		y[0] = y0;
		for (int i = 1; i < n; i++) {
			x0 = (a * x0 + b) % m;
			y0 = (c * y0 + d) % m;
			x[i] = x0;
			y[i] = y0;
		}
		int count = 0;
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				for (int k = j + 1; k < n; k++) {
					long xx = x[i] + x[j] + x[k];
					long yy = y[i] + y[j] + y[k];
					if (xx % 3 != 0 || yy % 3 != 0) {
						continue;
					}
					count++;
				}
			}
		}
		out.println("Case #" + testNumber + ": " + count);
	}

	private void solve() throws IOException {
		in = new BufferedReader(new FileReader(new File(problemID + ".in")));
		out = new PrintWriter(new File(problemID + ".out"));
		
		int testsNumber = Integer.parseInt(in.readLine());
		for (int testNumber = 1; testNumber <= testsNumber; testNumber++) {
			solveSingleTest(testNumber);
		}
		
		in.close();
		out.close();
	}
	
	public static void main(String[] args) {
		new Thread(new Triangles()).start();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
