import java.io.*;
import java.util.*;

public class Alien implements Runnable {
	private BufferedReader in;
	private PrintWriter out;
	private String problemID = getClass().getName().split("_")[0].toLowerCase() + "_small";
	private StringTokenizer st = null;
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	private void readPattern(boolean[][] w) throws IOException {
		String p = nextToken();
		int cur = 0;
		for (int i = 0; i < w.length; i++) {
			if (p.charAt(cur) != '(') {
				Arrays.fill(w[i], false);
				w[i][p.charAt(cur) - 'a'] = true;
				cur++;
				continue;
			}
			cur++;
			Arrays.fill(w[i], false);
			while (p.charAt(cur) != ')') {
				w[i][p.charAt(cur) - 'a'] = true;
				cur++;
			}
			cur++;
		}
	}
	
	private void solve() throws IOException {
		int l = nextInt();
		int d = nextInt();
		int n = nextInt();
		
		String[] words = new String[d];
		for (int i = 0; i < d; i++) {
			words[i] = nextToken();
		}
		
		boolean[][] w = new boolean[l][26];
		for (int i = 0; i < n; i++) {
			readPattern(w);
			int count = 0;
			for (int j = 0; j < d; j++) {
				boolean good = true;
				for (int k = 0; k < l; k++) {
					if (!w[k][words[j].charAt(k) - 'a']) {
						good = false;
						break;
					}
				}
				if (good) {
					count++;
				}
			}
			out.println("Case #" + (i + 1) + ": " + count);
		}
	}
	
	public static void main(String[] args) {
		new Thread(new Alien()).start();
	}

	public void run() {
		try {
			in = new BufferedReader(new FileReader(new File(problemID + ".in")));
			out = new PrintWriter(new File(problemID + ".out"));
			solve();
			in.close();
			out.close();
		} catch (IOException e) {
			
		}
	}
}
