import java.io.*;
import java.util.*;

public class Number implements Runnable {
	private final String problemID = getClass().getName() + "_small";
	private BufferedReader in;
	private PrintWriter out;
	
	private void solveSingleTest(int testNumber) throws IOException {
		Scanner sc = new Scanner(in.readLine());
		int a = sc.nextInt();
		int b = sc.nextInt();
		int p = sc.nextInt();
		
		int[] colour = new int[b - a + 1];
		for (int i = 0; i < colour.length; i++) {
			colour[i] = i + 1;
		}
		int sets = b - a + 1;
		while (true) {
			boolean changed = false;
			for (int i = a; i <= b; i++) {
				for (int j = i + 1; j <= b; j++) {
					if (colour[i - a] == colour[j - a]) {
						continue;
					}
					if (maxPrime(gcd(i, j)) >= p) {
						changed = true;
						int col = colour[j - a];
						for (int k = a; k <= b; k++) {
							if (colour[k - a] == col) {
								colour[k - a] = colour[i - a];
							}
						}
						sets--;
					}
				}
			}
			if (!changed) {
				break;
			}
		}
		out.println("Case #" + testNumber + ": " + sets);
	}

	private int gcd(int a, int b) {
		while (b > 0) {
			int tmp = a % b;
			a = b;
			b = tmp;
		}
		return a;
	}
	
	private int maxPrime(int a) {
		int prime = 1;
		for (int i = 2; i <= a; i++) {
			if (a % i == 0) {
				prime = Math.max(prime, i);
				while (a % i == 0) {
					a = a / i;
				}
			}
		}
		return prime;
	}

	private void solve() throws IOException {
		in = new BufferedReader(new FileReader(new File(problemID + ".in")));
		out = new PrintWriter(new File(problemID + ".out"));
		
		int testsNumber = Integer.parseInt(in.readLine());
		for (int testNumber = 1; testNumber <= testsNumber; testNumber++) {
			solveSingleTest(testNumber);
		}
		
		in.close();
		out.close();
	}
	
	public static void main(String[] args) {
		new Thread(new Number()).start();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
