import java.util.*;
import java.io.*;

public class Trains implements Runnable {
	private final String problemName = getClass().getName().toLowerCase() + "_1";
	private BufferedReader in;
	private PrintWriter out;
	
	private int parseTime(String time) {
		int minute = (time.charAt(0) - '0') * 10 + (time.charAt(1) - '0');
		int second = (time.charAt(3) - '0') * 10 + (time.charAt(4) - '0');
		return minute * 60 + second;
	}

	private void solveSingleTest(int testNumber) throws IOException {
		int idleTime = Integer.parseInt(in.readLine());
		String[] tmp1 = in.readLine().split(" ");
		int na = Integer.parseInt(tmp1[0]);
		int nb = Integer.parseInt(tmp1[1]);
		
		int[] s1 = new int[na];
		int[] f1 = new int[na];
		for (int i = 0; i < na; i++) {
			String[] tmp = in.readLine().split(" ");
			s1[i] = parseTime(tmp[0]);
			f1[i] = parseTime(tmp[1]) + idleTime;
		}
		int[] s2 = new int[nb];
		int[] f2 = new int[nb];
		for (int i = 0; i < nb; i++) {
			String[] tmp = in.readLine().split(" ");
			s2[i] = parseTime(tmp[0]);
			f2[i] = parseTime(tmp[1]) + idleTime;
		}
		int x = 0;
		int y = 0;
		for (int time = 0; time < 24 * 60 * 60; time++) {
			int trains = 0;
			for (int i = 0; i < na; i++) {
				if (s1[i] <= time) {
					trains--;
				}
			}
			for (int i = 0; i < nb; i++) {
				if (f2[i] <= time) {
					trains++;
				}
			}
			x = Math.max(x, -trains);
			
			trains = 0;
			for (int i = 0; i < nb; i++) {
				if (s2[i] <= time) {
					trains--;
				}
			}
			for (int i = 0; i < na; i++) {
				if (f1[i] <= time) {
					trains++;
				}
			}
			y = Math.max(y, -trains);
		}
		out.println("Case #" + testNumber + ": " + x + " " + y);
	}
	
	public static void main(String[] args) {
		new Thread(new Trains()).start();
	}

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void solve() throws IOException {
		in = new BufferedReader(new FileReader(new File(problemName + ".in")));
		out = new PrintWriter(new File(problemName + ".out"));
		
		int tests = Integer.parseInt(in.readLine());
		for (int test = 1; test <= tests; test++) {
			solveSingleTest(test);
		}
		
		in.close();
		out.close();
	}
}
