import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class magicka_rs implements Runnable {
	private final String problemId = getClass().getName().split("_")[0];
	private BufferedReader in;
	private PrintWriter out;
	private StringTokenizer st;
	
	private void solveSingleTest(int testNumber) throws IOException {
		int c = nextInt();
		int[][] combine = new int[26][26];
		for (int i = 0; i < combine.length; i++) {
			Arrays.fill(combine[i], -1);
		}
		boolean[][] opposed = new boolean[26][26];
		for (int i = 0; i < c; i++) {
			String seq = nextToken();
			combine[seq.charAt(0) - 'A'][seq.charAt(1) - 'A'] = seq.charAt(2) - 'A';
			combine[seq.charAt(1) - 'A'][seq.charAt(0) - 'A'] = seq.charAt(2) - 'A';
		}
		int d = nextInt();
		for (int i = 0; i < d; i++) {
			String seq = nextToken();
			opposed[seq.charAt(0) - 'A'][seq.charAt(1) - 'A'] = true;
			opposed[seq.charAt(1) - 'A'][seq.charAt(0) - 'A'] = true;
		}
		int n = nextInt();
		String cmd = nextToken();
		int[] seq = new int[n];
		int len = 0;
		for (int i = 0; i < cmd.length(); i++) {
			seq[len++] = cmd.charAt(i) - 'A';
			while (len > 1 && combine[seq[len - 2]][seq[len - 1]] != -1) {
				seq[len - 2] = combine[seq[len - 2]][seq[len - 1]];
				len--;
			}
			for (int j = 0; j < len - 1; j++) {
				if (opposed[seq[j]][seq[len - 1]]) {
					len = 0;
					break;
				}
			}
		}
		out.print("Case #" + testNumber + ": [");
		if (len == 0) {
			out.println("]");
			return;
		}
		out.print((char) (seq[0] + 'A'));
		for (int i = 1; i < len; i++) {
			out.print(", " + (char) (seq[i] + 'A'));
		}
		out.println("]");
	}

	public static void main(String[] args) {
		new Thread(new magicka_rs()).start();
	}

	@Override
	public void run() {
		try {
			in = new BufferedReader(new FileReader(new File(problemId + ".in")));
			out = new PrintWriter(new File(problemId + ".out"));
			int tests = nextInt();
			for (int i = 0; i < tests; i++) {
				solveSingleTest(i + 1);
			}
			in.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
}
