import java.util.Arrays;

import util.InputProcessor;


public class MakeItSmooth 
{
	private int D;
	private int I;
	private int M;
	private int N;
	private int[] pixels;
	
	private int[][] memo;
	
	private boolean check(int i,int j)
	{
		if(i==256 || j==256)
			return true;
		return Math.abs(i-j)<=M;
	}
	private int solve(int idx,int prevPixel)
	{
		if(memo[idx][prevPixel]!=-1)
			return memo[idx][prevPixel];
		else
		{
			int ret=Integer.MAX_VALUE;
			
			//check for change of pixel
			for(int i=1;i<=255;++i)
			{
				if(idx!=0 && check(prevPixel,i) && check(i,pixels[idx+1]))
					ret=Math.min(ret,Math.abs(pixels[idx]-i)+solve(idx+1,i));
			}
			
			//check for pixel appropriate pixel insertion after idx
			if(idx!=0 && idx!=N && M>0)
			{
				int diff=Math.abs(pixels[idx+1]-pixels[idx]);
				int req=diff/M;
				if(diff%M==0)
					--req;
				int insertionCost=req*I;
				int lastPixel=-1;
				if(pixels[idx+1]>pixels[idx])
					lastPixel=pixels[idx+1]-M;
				else
					lastPixel=pixels[idx+1]+M;
				if(insertionCost>0)
					ret=Math.min(ret,insertionCost+solve(idx+1,lastPixel));
			}
					
			//check for deletion
			if(idx!=0 && idx!=N+1 && check(prevPixel,pixels[idx+1]))
				ret=Math.min(ret, D+solve(idx+1,prevPixel));
			
			//do nothing
			if(check(pixels[idx],pixels[idx+1]))
				ret=Math.min(ret,solve(idx+1,pixels[idx]));
			memo[idx][prevPixel]=ret;
			return ret;
		}		
	}
	public int smooth(int D,int I,int M,int N,int[] pixels)
	{
		this.D=D;
		this.I=I;
		this.M=M;
		this.N=N;
		
		this.pixels=new int[this.N+2];
		this.pixels[0]=256;
		this.pixels[N+1]=256;
		for(int i=1;i<=N;++i)
			this.pixels[i]=pixels[i-1];
		
		this.memo=new int[N+2][257];
		for(int i=0;i<memo.length;++i)
			Arrays.fill(this.memo[i],-1);
		Arrays.fill(this.memo[N+1],0);
		return solve(0,pixels[0]);
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) 
	{
		InputProcessor ip=new InputProcessor();
		MakeItSmooth obj=new MakeItSmooth();
		int T=ip.getNextInteger();
		for(int i=1;i<=T;++i)
		{
			int[] values=ip.getIntegers(ip.getNextLine());
			int D=values[0],I=values[1],M=values[2],N=values[3];
			int[] pixels=ip.getIntegers(ip.getNextLine());
			int ret=obj.smooth(D, I, M, N, pixels);
			ip.output(i, ret);
		}

	}

}
