import util.InputProcessor;


public class Rotate 
{
	private boolean debug=false;
	private boolean check(char[][] after,char inp,int K)
	{
		String target="";
		for(int i=1;i<=K;++i)
			target+=""+inp;
		int N=after.length;
		for(int i=0;i<N;++i)
		{
			String temp=new String(after[i]);
			if(temp.indexOf(target)>=0)
				return true;
		}
		for(int j=0;j<N;++j)
		{
			String temp="";
			for(int i=0;i<N;++i)
				temp+=""+after[i][j];
			if(temp.indexOf(target)>=0)
				return true;			
		}
		for(int i=0;i+K<=N;++i)
		{
			for(int j=0;j+K<=N;++j)
			{
				String temp="";
				for(int k=0;k<K;++k)
					temp+=after[i+k][j+k];
				if(temp.equals(target))
					return true;
			}
		}
		for(int i=0;i+K<=N;++i)
		{
			for(int j=0;j+1-K>=0;++j)
			{
				String temp="";
				for(int k=0;k<K;++k)
					temp+=after[i+k][j-k];
				if(temp.equals(target))
					return true;
			}
		}
		return false;
	}
	public String rotate(String[] G,int K)
	{
		int N=G.length;
		String[] after=new String[N];
		
		if(debug)
		{
			for(int i=0;i<N;++i)
				System.out.println(G[i]);
		}
		
		for(int j=0;j<N;++j)
		{
			String cur="";
			for(int i=N-1;i>=0;--i)	
				cur+=""+G[i].charAt(j);
			after[j]=cur;
		}
		if(debug)
		{
			System.out.println("--------------------");
			for(int i=0;i<N;++i)
				System.out.println(after[i]);
		}
		
		char[][] A=new char[N][N];
		for(int i=0;i<N;++i)
			A[i]=after[i].toCharArray();
		
		while(true)
		{
			boolean none=true;
			for(int i=N-2;i>=0;--i)
			{
				for(int j=0;j<N;++j)
				{
					if(A[i][j]!='.' && A[i+1][j]=='.')
					{
						A[i+1][j]=A[i][j];
						A[i][j]='.';
						none=false;
					}
				}
			}
			if(none)
				break;
		}
		
		if(debug)
		{
			System.out.println("--------------------");
			for(int i=0;i<N;++i)
				System.out.println(new String(A[i]));
		}
		
		boolean blue=check(A,'B',K),red=check(A,'R',K);
		if(blue && red)
			return "Both";
		else if(blue && !red)
			return "Blue";
		else if(!blue && red)
			return "Red";
		else 
			return "Neither";	
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) 
	{
		Rotate obj=new Rotate();
		InputProcessor ip=new InputProcessor();		
		int T=ip.getNextInteger();
		for(int i=1;i<=T;++i)
		{
			int[] temp=ip.getIntegers(ip.getNextLine());
			int N=temp[0];
			int K=temp[1];
			String[] grid=ip.getNextLines(N);
			String ret=obj.rotate(grid, K);
			ip.output(i, ret);			
		}
	}

}
