package g2011.r1c;

import java.io.InputStreamReader;
import java.util.Scanner;

public class SpaceEmergency 
{
	public long getMinTime(int L,long T,int N,int C,int[] A)
	{
		int[] dist=new int[N];
		for(int i=0;i<N;++i)
			dist[i]=A[i%C];
		if(L==0)
		{
			long ret=0L;
			for(int i=0;i<N;++i)
				ret+=(2L*(long)dist[i]);
			return ret;
		}
		else if(L==1)
		{
			long ret=Long.MAX_VALUE;
			for(int booster=0;booster<N;++booster)
			{
				long totalTimeTaken=0L;
				for(int i=0;i<N;++i)
				{
					if(booster==i)
					{
						if(totalTimeTaken>=T)
							totalTimeTaken+=dist[i];
						else if(totalTimeTaken<T && T<=totalTimeTaken+(2L*dist[i]))
						{
							long temp=(T-totalTimeTaken)/2L;
							long t2=dist[i]-temp;
							totalTimeTaken+=(T-totalTimeTaken)+t2;
						}
					}
					else
						totalTimeTaken+=(2L*dist[i]);
				}
				ret=Math.min(ret,totalTimeTaken);
			}
			return ret;
		}
		else
		{
			long maxPossibleTime=0L;
			for(int i=0;i<N;++i)
				maxPossibleTime+=(2L*dist[i]);
			long[] normalTimeToGo=new long[N+1];
			normalTimeToGo[0]=0L;
			for(int i=0;i<N;++i)
				normalTimeToGo[i+1]=normalTimeToGo[i]+(2L*dist[i]);
			long[][] normalTime=new long[N+1][N+1];
			for(int i=0;i<=N;++i)
				for(int j=i;j<=N;++j)
					normalTime[i][j]=normalTimeToGo[j]-normalTimeToGo[i];
			long ret=maxPossibleTime;
			for(int i=0;i<N;++i)
			{
				for(int j=i+1;j<N;++j)
				{
					//booster at (i,j)
					long timeSoFar=normalTime[0][i];
					
					if(timeSoFar>=T)
						timeSoFar+=dist[i];
					else if(timeSoFar<T && T<=timeSoFar+(2L*dist[i]))
					{
						long temp=(T-timeSoFar)/2L;
						long t2=dist[i]-temp;
						timeSoFar+=(T-timeSoFar)+t2;
					}
					else
						timeSoFar+=(2L*dist[i]);
					
					timeSoFar+=normalTime[i+1][j];
					
					if(timeSoFar>=T)
						timeSoFar+=dist[j];
					else if(timeSoFar<T && T<=timeSoFar+(2L*dist[j]))
					{
						long temp=(T-timeSoFar)/2L;
						long t2=dist[j]-temp;
						timeSoFar+=(T-timeSoFar)+t2;
					}
					else
						timeSoFar+=(2L*dist[j]);
						
					timeSoFar+=normalTime[j+1][N];
//					if(timeSoFar<ret)
//						System.err.println(i+" "+j);
					
					ret=Math.min(ret,timeSoFar);
				}
			}
			return ret;
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) 
	{
		SpaceEmergency obj=new SpaceEmergency();
		Scanner sc=new Scanner(new InputStreamReader(System.in));
		int Te=sc.nextInt();
		for(int t=1;t<=Te;++t)
		{
			int L=sc.nextInt();
			long T=sc.nextLong();
			int N=sc.nextInt();
			int C=sc.nextInt();
			int[] A=new int[C];
			for(int i=0;i<C;++i)
				A[i]=sc.nextInt();
			long ret=obj.getMinTime(L, T, N, C, A);
			System.out.println("Case #"+t+": "+ret);
				
			
		}

	}

}
