package g2010.qualifiers;

import java.util.LinkedList;
import java.util.Queue;

import util.InputProcessor;

public class ThemePark
{
	private boolean check(int start,int size,long[] rev)
	{
		for(int i=start;i<start+size;++i)
		{
			if(rev[i]!=rev[i+size])
				return false;			
		}
		return true;
	}
	public long simulate(int R,int K,int N,int[] groups)
	{
		Queue<Integer> q=new LinkedList<Integer>();
		Queue<Integer> temp=new LinkedList<Integer>();
		for(int i=0;i<groups.length;++i)
			q.add(groups[i]);
		int limit=Math.min(3*N, R);
		long[] rev=new long[limit+1];
		long ret=0L;
		for(int i=1;i<=limit;++i)
		{
			long cap=0L;
			while(true)
			{
				if(q.isEmpty())
					break;
				int val=q.peek();
				if(cap+val>K)
					break;
				cap+=(long)(val);
				q.poll();
				temp.add(val);
			}
			while(!temp.isEmpty())
				q.add(temp.poll());
			rev[i]=cap;
			ret+=cap;
			//System.err.println(i+" "+cap);
		}
		if(R<=limit)
		{
			ret=0L;
			for(int i=1;i<=R;++i)
				ret+=rev[i];
			return ret;
		}
		boolean done=false;
		int sz=-1,start=-1;
		for(int size=N;size>=1;--size)
		{
			if(done)
				break;
			for(int s=1;s<=N;++s)
			{
				done|=(check(s, size, rev));
				if(done)
				{
					sz=size;
					start=s;
					break;
				}	
			}
		}
		long once=0;
		for(int i=start;i<start+sz;++i)
			once+=rev[i];
		int quo=(R-start)/sz;
		long v=((long)quo*once);
		for(int i=1;i<start;++i)
			v+=rev[i];
		int last=(quo*sz)+start;
		for(int i=last,j=start;i<=R;++i,++j)
			v+=rev[j];
		return v;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		InputProcessor ip=new InputProcessor();
		int T=ip.getNextInteger();
		ThemePark obj=new ThemePark();
		for(int test=1;test<=T;++test)
		{
			int[] temp=ip.getIntegers(ip.getNextLine());
			int R=temp[0];
			int K=temp[1];
			int N=temp[2];
			int[] groups=ip.getIntegers(ip.getNextLine());
			long out=obj.simulate(R, K, N, groups);
			ip.output(test, out);
		}

	}

}
