package jam;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class JamOne {

	/**
	 * @param args
	 * @throws FileNotFoundException 
	 */
	public static void main(String[] args) throws FileNotFoundException {
		Map<String, String> refDict = loadRefDict();
		
		/*for (String string : refDict.keySet()) {
			System.out.println(String.format("%s -> %s", string, refDict.get(string)));
		}*/
		
		//String enc = "ejp mysljylc kd kxveddknmc re jsicpdrysi";
		//String dec = decode(refDict, enc);
		
		//
		try {
			
			FileInputStream fstream = new FileInputStream("/Users/icrisanto/Desktop/input.txt");
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			String strLine;
			
			FileWriter outFile = new FileWriter("/Users/icrisanto/Desktop/output1.txt");
			PrintWriter out = new PrintWriter(outFile);
		
			int i = 1;
			while ((strLine = br.readLine()) != null)   {
			  // Print the content on the console
			  //System.out.println (String.format("Case #%s: %s", i++, decode(refDict, strLine)));
			  out.println(String.format("Case #%s: %s", i++, decode(refDict, strLine)));
			}
			
			//Close the input stream
			  in.close();
			  out.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		System.out.println ("done");
	}
	
	private static String decode(Map<String, String> dict, String enc) {
		StringBuilder out = new StringBuilder();
		
		for (int i = 0; i < enc.length(); i++) {
			if(!dict.containsKey(Character.toString(enc.charAt(i)))) {
				System.out.println("Caracter nao encontrado: " + Character.toString(enc.charAt(i)));
				out.append("%" + Character.toString(enc.charAt(i)));
				continue;
			}
			
			out.append(dict.get(Character.toString(enc.charAt(i))));
		}
		
		return out.toString();
	}
	
	private static HashMap<String, String> loadRefDict()
	{
		String enc = "ejp mysljylc kd kxveddknmc re jsicpdrysi rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd de kr kd eoya kw aej tysr re ujdr lkgc jv";
		String dec = "our language is impossible to understand there are twenty six factorial possibilities so it is okay if you want to just give up";
		
		HashMap<String, String> dict = new HashMap<String, String>();
		dict.put("q", "z");
		dict.put("y", "a");
		dict.put("e", "o");
		dict.put("z", "q");
		
		for (int i = 0; i < enc.length(); i++) {
			String key = Character.toString(enc.charAt(i));
			if(!dict.containsKey(key))
				dict.put(key, Character.toString(dec.charAt(i)));
		}
		
		return dict;
	}
}
