import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;


public class Rotate {
	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new File("C:/Users/Chris/Documents/Downloads/A-large.in"));
		BufferedWriter out;
		FileWriter fstream = new FileWriter("C:/Users/Chris/Documents/out.txt", false);
		out = new BufferedWriter(fstream);

		int num = sc.nextInt();
		for (int i = 0; i < num; i++) {
			int N = sc.nextInt();
			int K = sc.nextInt();
			sc.nextLine();
			char[][] board = new char[N][N];
			for (int j = 0; j < N; j++) {
				String line = sc.nextLine();
				for (int j2 = 0; j2 < N; j2++) {
					board[j][j2] = line.charAt(j2);
				}

			}
			out.write("Case #"+(i+1)+": "+solve(board,K)+"\n");
			System.out.println(i);
		}
		out.close();
		System.out.println("Done: "+num+ " cases");

	}

	private static String solve(char[][] board, int k) {
		//for each row
		for (int i = 0; i < board.length; i++) {
			//start with last pieces
			boolean ontop = false;
			for (int j = 0; j < board.length; j++) {
				if (board[i][j] != '.'){
					ontop=true;
				}
				if (ontop){
					while (board[i][j] == '.'){
						//everything to the left shifts right
						for (int j2 = j; j2 > 0; j2--) {
							board[i][j2] = board[i][j2-1];
						}
						board[i][0] = '.';
					}
				}
			}
		//	System.out.println(Arrays.toString(board[i]));
		}

		boolean red = false;
		boolean blue = false;

		//find columns
		int in_a_row = 1;
		for (int i = 0; i < board.length; i++) {
			for (int j = 1; j < board.length; j++) {
				if (board[i][j] == board [i][j-1] && board[i][j] != '.'){
					in_a_row++;
				}else{
					in_a_row = 1;
				}
				if (in_a_row == k && board[i][j] =='R'){
					red = true;
				}else if(in_a_row == k && board[i][j] =='B'){
					blue = true;
				}
			}
			in_a_row = 1;
		}

		//rows
		for (int j = 0; j < board.length; j++) {
			for (int i = 1; i < board.length; i++) {
				if (board[i][j] == board [i-1][j] && board[i][j] != '.'){
					in_a_row++;
				}else{
					in_a_row = 1;
				}
				if (in_a_row == k && board[i][j] =='R'){
					red = true;
				}else if(in_a_row == k && board[i][j] =='B'){
					blue = true;
				}
			}
			in_a_row = 1;
		}
		
		//System.out.println("Diag");

		//diagonal
		int j_start = 0;
		int i_start = board.length;
		while (true){
			if (i_start > 0){
				i_start--;
			}else{
				j_start++;
			}
			int i = i_start;
			int j = j_start;
			while(i < board.length-1 && j < board.length-1){
				if (board[i][j] == board [i+1][j+1] && board[i][j] != '.'){
					in_a_row++;
				}else{
					in_a_row = 1;
				}
				if (in_a_row == k && board[i][j] =='R'){
					red = true;
				}else if(in_a_row == k && board[i][j] =='B'){
					blue = true;
				}
				i++;
				j++;
			}
			in_a_row = 1;
			//System.out.println(i_start+" "+j_start);
			if (i_start==0 && j_start == board.length-1){
				break;
			}
		}
		
		//System.out.println("Other Diag");

		//diagonal
		j_start = -1;
		i_start = 0;
		while (true){
			if (j_start < board.length-1){
				j_start++;
			}else{
				i_start++;
			}
			int i = i_start;
			int j = j_start;
			while(i < board.length-1 && j > 0){
				if (board[i][j] == board [i+1][j-1] && board[i][j] != '.'){
					in_a_row++;
				}else{
					in_a_row = 1;
				}
				if (in_a_row == k && board[i][j] =='R'){
					red = true;
				}else if(in_a_row == k && board[i][j] =='B'){
					blue = true;
				}
				i++;
				j--;
			}
			in_a_row = 1;
			//System.out.println(i_start+" "+j_start);
			if (i_start==board.length-1 && j_start == board.length-1){
				break;
			}
		}

		if (red && blue){
			return "Both";
		}else if (red){
			return "Red";
		}else if (blue){
			return "Blue";
		}else{
			return "Neither";
		}
	}
}
