import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;


public class Watersheds {
	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File("B-large.in"));
		dostuff(sc);
	}

	public static void dostuff(Scanner sc){
		int numberofmaps = sc.nextInt();
		for (int i = 1;i <= numberofmaps;i++){
			letterspot = -1;
			int rows = sc.nextInt();
			int cols = sc.nextInt();
			int[][] map = new int[rows][cols];
			char[][] basins = new char[rows][cols];
			for (int j = 0;j<rows;j++){
				for (int k =0;k<cols;k++){
					map[j][k] = sc.nextInt();
					basins[j][k] = ' ';
				}
			}
			System.out.println("Case #"+i+":");
			for (int j = 0;j<rows;j++){
				for (int k =0;k<cols;k++){
					System.out.print(getBasin(j,k,map,basins));
					if (k != cols-1){
						System.out.print(" ");
					}
				}
				System.out.println();
			}
		}
	}

	public static char getBasin(int row, int col, int[][] map, char[][] basins){
		int lrow = row;
		int lcol = col;
		if (isLower(lrow,lcol,row-1,col,map)){
			lrow = row-1;
			lcol = col;
		}
		if (isLower(lrow,lcol,row,col-1,map)){
			lrow = row;
			lcol = col -1 ;
		}
		if (isLower(lrow,lcol,row,col+1,map)){
			lrow = row;
			lcol = col +1 ;
		}
		if (isLower(lrow,lcol,row+1,col,map)){
			lrow = row + 1;
			lcol = col;
		}
		if (lrow != row || lcol != col){
			return getBasin(lrow,lcol,map,basins);
		}
		if (basins[row][col] != ' '){
			return basins[row][col];
		}
		basins[row][col] = nextLetter();
		return basins[row][col];
	}

	public static boolean isLower(int row1,int col1,int row2,int col2,int[][] map){
		try{
			if (map[row1][col1] > map[row2][col2]){
				return true;
			}else{
				return false;
			}
		}catch(ArrayIndexOutOfBoundsException e){
			return false;
		}
	}

	public static StringBuilder letters = new StringBuilder("abcdefghijklmnopqrstuvwxyz");
	public static int letterspot = -1;
	public static char nextLetter(){
		letterspot++;
		return letters.charAt(letterspot);
	}
}
