import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class RPI {

	Team[] teams;

	class Team{
		private int id;
		public Team(int me){
			this.id = me;
		}
		boolean[] wingames = new boolean[20];
		int wins;
		int games;
		boolean[] opps = new boolean[20];
		public void addgame(char won, int team){
			if (opps[team])System.out.println("Error!");
			if (won == '1'){
				wingames[team] = true;
				wins++;
				games++;
				opps[team] = true;
			}else if (won == '0'){
				games++;
				opps[team] = true;
			}
		}

		public double WP(int id){
			if (id > -1){
				if (wingames[id]){
					return (double)(wins-1)/(double)(games-1);
				}
				return (double)wins/(double)(games-1);
			}
			return (double)wins/(double)games;
		}
		
		public double OWP(){
			double result = 0;
			int num = 0;
			for (int i = 0; i < 20; i++) {
				if (opps[i]){
					num++;
					result += teams[i].WP(id); 
					//System.out.println(teams[i].WP(id2));
				}
			}
			return result/(double)num;
		}

		public double OOWP(){
			double result = 0;
			int num = 0;
			for (int i = 0; i < 20; i++) {
				if (opps[i]){
					num++;
					result += teams[i].OWP(); 
				}
			}
			return result/(double)num;
		}

		public double RPI(){
			//System.out.println(WP(-1)+" "+OWP()+" "+OOWP());
			return 0.25 * this.WP(-1) + 0.50 * this.OWP() + 0.25 * this.OOWP();
		}
	}

	public static void main(String[] args) throws FileNotFoundException {
		new RPI().start();
	}

	private void start() throws FileNotFoundException {
		Scanner sc = new Scanner(new File("input.in"));
		int num = sc.nextInt();
		sc.nextLine();
		for (int i = 0; i < num; i++) {
			int numteams = sc.nextInt();
			sc.nextLine();
			teams = new Team[numteams];
			for (int j = 0; j < numteams; j++) {
				String line = sc.nextLine();
				teams[j] = new Team(j);
				for (int j2 = 0; j2 < numteams; j2++) {
					teams[j]
					      .addgame(
					    		  line.charAt(j2)
					    		  , j2);
				}
			}
			System.out.println("Case #"+(i+1)+":");
			for (int j = 0; j < numteams; j++) {
				System.out.println(teams[j].RPI());
			}
		}
	}
}
