import java.io.*;
import java.util.ArrayList;
class Sesame{
  public static ArrayList <String> openAsArrayList(String fileName){
    String line = null;
    ArrayList <String> a = new ArrayList <String> ();
    try{
      FileReader fReader = new FileReader(fileName);
      BufferedReader bReader = new BufferedReader(fReader);
      
      while((line = bReader.readLine()) != null){
        a.add(line);
      }
      bReader.close();
    }
    catch(FileNotFoundException ex){
      System.out.println("Unable to open \"" +fileName + "\"");
    }
    catch(IOException ex){
      ex.printStackTrace();
    }
    return a;
  }
  public static void saveArrayList(ArrayList <String> a, String fileName){
    /**
     * @param a an array of strings representing the lines of the file
     * @param fileName the name of the file to be saved
     **/
    try{
      FileWriter fWriter = new FileWriter(fileName);
      BufferedWriter bWriter = new BufferedWriter(fWriter);
      for(String line : a){
        bWriter.write(line);
        bWriter.newLine();
        
      }
      bWriter.close();
    }
    catch(IOException ex){
      ex.printStackTrace();
    }
  }
  public static void compareArrayList(ArrayList<String> a, ArrayList<String> b){
    int differences = 0;
    int simmilarities = 0;
    if(a.size() != b.size()){
      System.out.println("The arrays are of unequal size:\na: " + a.size() + "\nb: " + b.size());
    }
    int small = (a.size() < b.size()) ? a.size() : b.size();
    for(int i = 0; i < small; i ++){
      if(!a.get(i).equals(b.get(i))){
        System.out.println("Mistake on line " + (i + 1)+ "\nb: " + b.get(i) + "\na: "+ a.get(i));
        differences ++;
      }
      else simmilarities ++;
    }
    System.out.println("There were " + simmilarities + " simmilarities and " + differences + " differences.");
  }
  public static void compareFiles(String fNameA, String fNameB){
    compareArrayList(openAsArrayList(fNameA), openAsArrayList(fNameB));
  }

}