import java.util.ArrayList;
import java.lang.Math;

class Fractile{
  /**
  public static String toClean(int complexity, int size, int students){
    String out = "";
    if(students < size) return "IMPOSSIBLE";
    for(int i = 1; i <= students; i ++) out += i + " ";
    return out;
  }
  **/
  public static int clip(int in, int min, int max){
    int out;
    if( in > max){
      return max;
    }
    else if (in < min){
      return min;
    }
    else{
      return in;
    }
  }
  public static String toClean( int size, int complexity, int students){
    int checks = (int)(Math.ceil(((double) size) / complexity));
    //System.out.println("Checking " + checks + " times");
    if(students < checks){
      return "IMPOSSIBLE";
    }
    String out = "";
    //for each check
    for(int check = 0; check < checks; check ++){
      //determine the location to look
      int look = 0; //assume first space
      // for the each layer of complexity
      for(int c = 0; c < complexity; c ++){
        // add 
        //the layer of complexity, 0 indexed
        int increase = c;
        //plus the check number, 0 indexed
        increase += check;
        //reduced to the max value, the size - 1
        increase = clip(increase, 0, size - 1);
        //multiplied by the size
        int coefficient = size;
        //to the power of complexity - (current layer of complexity + 1);
        int power = complexity - (c + 1);
        
        look += increase * (int)Math.pow(coefficient, power);
      }
      look ++; //because the answer needs to be 1 indexed
      out += look + " ";
    }
    return out;
  }
  /**
  public static String generateFractile(String seed, int complexity){
    String currentOut = "L";
    String goldBlock = "";
    for(int i =0; i < seed.length(); i ++) goldBlock += 'G';
    
    for(int i = 0; i < complexity; i++){
      String newOut = "";
      for(int j = 0; j < currentOut.length(); j ++){
        newOut += (currentOut.charAt(j) == 'L') ? seed : goldBlock;
      }
      currentOut = newOut;
    }
    return currentOut;
  }
  **/
  public static String toClean(String in){
    String[] input = in.split(" ");
    return toClean(Integer.parseInt(input[0]), Integer.parseInt(input[1]), Integer.parseInt(input[2]));
  }
  public static void main(String[] args){
    String inFileName = "D-large.in";
    String outFileName = "D-large.out";
    String compareFileName = "D-small-output.out";
    
    ArrayList<String> in = Sesame.openAsArrayList(inFileName);
    ArrayList<String> out = new ArrayList<String>();
    for(int i = 1; i < in.size(); i ++){
      out.add("Case #"+i+": "+toClean(in.get(i)));
    }
    
    Sesame.saveArrayList(out, outFileName);
    //Sesame.compareFiles(compareFileName, outFileName);
  }
}