import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.BitSet;
import java.util.Scanner;

public class Main{
	
	static Scanner s;
	
	public static void main(String[] __){
		IOInit();
		solve();
	}
	
	private static void solve(){
		final int loop=s.nextInt();
		for(int l=1; l<=loop; l++){
			
			final int n=s.nextInt(), k=s.nextInt();
			
			long min=0, max=0;
			int index=0;
			
			BitSet used = new BitSet(n+2);
			
			SegmentTreeL stmin=new SegmentTreeL(n+2);
			SegMentTreeL_MAX stmax=new SegMentTreeL_MAX(n+2);
			
			stmin.update(0,0);
			stmax.update(0,0);
			stmin.update(n+1,n+1);
			stmax.update(n+1,n+1);
			
			for(int i=0; i<k; i++){
				min=Integer.MIN_VALUE;
				max=Integer.MIN_VALUE;
				index=-1;
				for(int j=used.nextClearBit(1);j<=n;j=used.nextClearBit(j+1)){
					long left=j-stmax.query(0,j)-1, right=stmin.query(j+1,n+2)-j-1;
					if(min<Math.min(left,right)||
							(min==Math.min(left,right)&&max<Math.max(left,right))){
						min=Math.min(left,right);
						max=Math.max(left,right);
						index=j;
					}
				}
				stmin.update(index,index);
				stmax.update(index,index);
				used.set(index);
			}
			System.err.println(index);
			System.out.printf("Case #%d: ",l);
			System.out.printf("%d %d\n",max,min);
		}
	}
	
	private static void IOInit(){
		try{
			s=new Scanner(new File("C-small-1-attempt0.in"));
			System.setOut(new PrintStream(new File("out.txt")));
		}catch(FileNotFoundException e){
			e.printStackTrace();
		}
	}
}

class SegmentTreeL{	//ARIHON
	
	protected long[]	array;
	protected int		contains;
	
	public SegmentTreeL(int size, long init){
		this.contains=binarySeil(size);
		array=new long[this.contains*2-1];
		Arrays.fill(array,init);
	}
	
	public SegmentTreeL(int size){
		this(size,Long.MAX_VALUE);
	}
	
	public int getBeginIndex(){
		return contains-1;
	}
	
	public int getEndIndex(){
		return contains*2-1;
	}
	
	public long[] getArray(){	//uncopied
		return this.array;
	}
	
	public int getContains(){
		return contains;
	}
	
	//default : RMQ
	//@Override
	public void update(int index, long value){
		index+=contains-1;
		
		array[index]=value;
		while(index>0){
			index=(index-1)/2;
			/////////////////////////////////
			array[index]=Math.min(array[index*2+1],array[index*2+2]);
			/////////////////////////////////
		}
	}
	
	public long query(int l, int r){//[l.r)
		return __q(l,r,0,0,contains);
	}
	
	//@Override
	protected long __q(int l, int r, int node, int nl, int nr){
		/////////////////////////////////////
		if(r<=nl||nr<=l) return Long.MAX_VALUE;
		/////////////////////////////////////
		if(l<=nl&&nr<=r) return array[node];
		long vl=__q(l,r,node*2+1,nl,(nl+nr)/2),
				vr=__q(l,r,node*2+2,(nl+nr)/2,nr);
		/////////////////////////////////////
		return Math.min(vl,vr);
	}
	
	public static int binarySeil(int i){
		int a=1;
		while(a<i)
			a*=2;
		return a;
	}
}

class SegMentTreeL_MAX extends SegmentTreeL{
	
	public SegMentTreeL_MAX(int size){
		super(size,Long.MIN_VALUE);
	}
	
	@Override
	public void update(int index, long value){
		index+=contains-1;
		
		array[index]=value;
		while(index>0){
			index=(index-1)/2;
			/////////////////////////////////
			array[index]=Math.max(array[index*2+1],array[index*2+2]);
			/////////////////////////////////
		}
	}
	
	@Override
	protected long __q(int l, int r, int node, int nl, int nr){
		/////////////////////////////////////
		if(r<=nl||nr<=l) return Long.MIN_VALUE;
		/////////////////////////////////////
		if(l<=nl&&nr<=r) return array[node];
		long vl=__q(l,r,node*2+1,nl,(nl+nr)/2),
				vr=__q(l,r,node*2+2,(nl+nr)/2,nr);
		/////////////////////////////////////
		return Math.max(vl,vr);
	}
}
