import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;

public class DeceitfulWar_D {

	private int	   cnt;
	private List<Double> blocks[];

	public DeceitfulWar_D( BufferedReader in ) throws IOException{
		
		cnt = Integer.parseInt( in.readLine() );
		
		blocks = new List[2];
		blocks[0] = new ArrayList<Double>();
		blocks[1] = new ArrayList<Double>();
		
		for( int i = 0 ; i < 2; ++ i ){
			
			String read[] = in.readLine().split(" ");
			for( int j = 0 ; j < cnt ; ++ j ){
				blocks[i].add( Double.parseDouble( read[j] ) );
			}

		}
		
	}
	
	
	/**
	 * Kan choose number
	 * @param myNumber
	 * @param canNumber
	 * @return
	 */
	private double pickNumber( double myNumber, List<Double> Numbers ){
		
		double picked_number = Numbers.get(0);
		int picked_idx = 0;
		int i = 1;
		
		// 나오미가 내놓은 숫자 보다 크지만 가장 작은 값을 찾는다.
		while( picked_number < myNumber && Numbers.size() > i ){
			picked_number = Numbers.get(i);
			picked_idx = i;
			++i;
		}
		
		if( picked_number < myNumber ){
			picked_number = Numbers.get(0);
			picked_idx = 0;
		}
		
		Numbers.remove( picked_idx );
		
		return picked_number;
	}
	
	
	public String check() throws NumberFormatException, IOException{
		
		int default_war = 0;
		int fake_war = 0;
		
		blocks[0].sort(null);
		blocks[1].sort(null);
		
		List<Double> kenNumbers = new ArrayList<Double>( blocks[1] );
		
		// default game
		for( int i = 0 ; i < blocks[0].size() ; ++ i ){
			double now_choose_number = blocks[0].get(i);
			if( now_choose_number > pickNumber(now_choose_number, kenNumbers))
			{
				++ default_war;
			}
		}
		
		// trick game
		for( int i = blocks[1].size() -1 ; i >= 0 ; --i ){
			double picked = pickNumber( blocks[1].get(i), blocks[0] ) ;
			if( picked > blocks[1].get(i) ){
				++ fake_war;
			}
		}
		
			
		return fake_war + " " + default_war;
		
	}

	public static void main(String[] args) throws NumberFormatException, IOException {

		//Read
		File in_file = new File( "./track_d/D-small-attempt0.in" );
		File out_file = new File("./track_d/track_d.out");
		BufferedReader in = new BufferedReader( new FileReader(in_file) );
		BufferedWriter out = new BufferedWriter(new FileWriter( out_file, false ) );

			// read total count
		int totcnt = Integer.parseInt( in.readLine() );
		
		for( int c = 1 ; c <= totcnt ; ++ c ){
			String ret = "Case #" + c + ": " + ( new DeceitfulWar_D( in ).check() ) + "\n"; 
			out.write( ret );
			
			System.out.print( ret );
		}
		
		
		out.close();
		

	}
}
