import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class MineSweeperMaster_C {

	private static 		
	int cntbox[][] = {  {-1,-1}, {0,-1}, {1, -1},
						{-1, 0},         {1, 0},
						{-1, 1}, {0, 1}, {1, 1}};
	
	private int 	R, C, M;

	public MineSweeperMaster_C( BufferedReader in ) throws IOException{
		
		String read[] = in.readLine().split(" ");
		
		R = Integer.parseInt( read[0] );
		C = Integer.parseInt( read[1] );
		M = Integer.parseInt( read[2] );
		
	}
	
	private String mineboardToString( char board[][] ){
		
		String ret = "";
		
		for(int r = 0 ; r < R ; ++ r ){
			for( int c = 0; c < C ; ++ c ){
				ret += board[r][c];
			}
			ret += "\n";
		}
		return ret;
	}
	
	
	private boolean makeboard_shell_check( char mineboard[][], int current_mine_cnt, int shell_depth ){
		
		// 마인 수가 지금의 외곽선을 채울 수 있는 수보다 많다면 외곽선 채우기를 수행 한다.
		int d_c = C - shell_depth;
		int d_r = R - shell_depth;
		int need_sheel_cnt = (2 * d_c) + (2 * d_r) - 4;
		
		/*
		if( d_c >= 3 && d_r >= 3 && ( current_mine_cnt + need_sheel_cnt ) <= M ){
			
			// 외곽선을 그릴 수 있다면 ~!!
			for( int r = 0 ; r < d_r ; ++ r ){
				mineboard[ r + shell_depth ][ shell_depth ] = '*';
				mineboard[ r + shell_depth ][ C - shell_depth - 1 ] = '*';
			}
			for( int c = 0 ; c < d_c ; ++ c ){
				mineboard[ shell_depth ][ c + shell_depth ] = '*';
				mineboard[ R - shell_depth - 1 ][ c + shell_depth ] = '*';
			}
			
			System.out.println( "outline \n" + mineboardToString(mineboard));
			
			return makeboard_shell_check(mineboard, current_mine_cnt + need_sheel_cnt, shell_depth + 1  );
			
		}else*/
		if( d_c + current_mine_cnt <= M || d_r + current_mine_cnt <= M ){
			
			int c_depth = shell_depth;
			int r_depth = shell_depth;
			
			while( d_c + current_mine_cnt <= M || d_r + current_mine_cnt <= M ){
				
				// 작은 쪽 부터 없애 간다.
				if( d_r > d_c ){
					
					for( int c = 0 ; c < d_c ; ++ c ){
						mineboard[ r_depth ][ c + c_depth ] = '*';
					}
					current_mine_cnt += d_c;
					-- d_r;
					++ r_depth;
					
				}else{
					for( int r = 0 ; r < d_r ; ++ r ){
						mineboard[ r + r_depth ][ c_depth ] = '*';
					}
					current_mine_cnt += d_r;
					-- d_c;
					++ c_depth;
				}
				
				//System.out.println( "outline onedir \n" + mineboardToString(mineboard));
			}
			
			return makeboard_recu( mineboard, current_mine_cnt ) ;
			
			
		}else{
			
			return makeboard_recu( mineboard, current_mine_cnt );
		}		
	}
	
	private boolean makeboard_recu( char mineboard[][], int current_mine_cnt ){
		
		// 현재의 보드의 마인 수가 몇개인지 확인 한다.
		// 마인 수가 지정한 수와 동일 하다면 검사를 수행 한다.
		if( M == current_mine_cnt ){
			boolean ret = true;
			// 이것은 확인 로직 ~!!
			if( !putinNumber(mineboard) ){ ret = false; }
			else if( !checkMineboard( mineboard ) ){ ret = false; }
			if( !ret ){
				for( int r = 0; r < R ; ++ r ){
					for( int c = 0; c < C ; ++ c ){
						if( '*' != mineboard[r][c] ){
							mineboard[r][c] = '.';
						}
					}
				}
			}
			return ret;
		}
		
		// 전체 빈공간에 대한 반복문을 돌려서, 마인을 심을 수 있는 곳을 모두 표시한 뒤, 각 함수를 호출
		for( int r = 0; r < R ; ++ r ){
			for( int c = 0; c < C ; ++ c ){
				if( '.' == mineboard[r][c] ){
					mineboard[r][c] = '*';
					if( makeboard_recu( mineboard, current_mine_cnt + 1 ) ){
						return true;
					}
					mineboard[r][c] = '.';
				}
			}
		}
		
		return false;
		
	}
	
	public boolean putinNumber( char mineboard[][] ){
		// put in number
		
		boolean blankenabled = false;
		int		numbercnt	 = 0;
		int 	lastnumberxy[] 	= new int[2];
		int		firstblank[]	= new int[2];
				
		for( int r = 0; r < R ; r ++ ){
			for( int c = 0 ; c < C ; c ++ ){
				int cnt = 0;
				if( mineboard[r][c] == '.' ){
					for( int i = 0; i < cntbox.length ; ++ i ){
						
						if( ( r + cntbox[i][0] ) >= 0 && ( r + cntbox[i][0] ) < R &&
							( c + cntbox[i][1] ) >= 0 && ( c + cntbox[i][1] ) < C &&
							mineboard[r + cntbox[i][0]][c+cntbox[i][1]] == '*' )
						{
							++ cnt;
						}		
					}
					
					if( cnt > 0 ){
						mineboard[r][c] = ("" + cnt).charAt(0);
						++ numbercnt;
						lastnumberxy[0] = r;
						lastnumberxy[1] = c;
						
					}else{
						if( !blankenabled) {
							firstblank[0] = r;
							firstblank[1] = c;
						}
						blankenabled = true;
					}
				}
			}
		}
		
		if( !blankenabled ){
			//if( numbercnt == 1 ){
				mineboard[lastnumberxy[0]][lastnumberxy[1]] = 'c';
			//}else{ 
				return false;
			//}
		}else{ 
			mineboard[firstblank[0]][firstblank[1]] = 'c';
		}
		
		return true;
	}
	
	private void removeNumber( char mineboard[][] ){
		
		// remove number
		for( int r = 0; r < R ; r ++ ){
			for( int c = 0 ; c < C ; c ++ ){
				int cnt = 0;
				if( mineboard[r][c] != '*' &&
					mineboard[r][c] != '.' &&
					mineboard[r][c] != 'c'){
					
					mineboard[r][c] = '.';
				}
			}
		}
		
	}
	
	private boolean isNumber( char ch ){
		return ch >= '1' && ch <= '9';
	}
	

	/**
	 * Number 근처에 blank가 없으면 실패 ~!!
	 * @param mineboard
	 * @return
	 */
	private boolean checkMineboard(char[][] mineboard) {
		
		for( int r = 0; r < R ; r ++ ){
			for( int c = 0 ; c < C ; c ++ ){
				int cnt = 0;
				if( isNumber( mineboard[r][c]) ){
					
					boolean now_fined = false;
					for( int i = 0; i < cntbox.length ; ++ i ){
						
						if( ( r + cntbox[i][0] ) >= 0 && ( r + cntbox[i][0] ) < R &&
							( c + cntbox[i][1] ) >= 0 && ( c + cntbox[i][1] ) < C &&
							( mineboard[r + cntbox[i][0]][c+cntbox[i][1]] == '.' || 
							  mineboard[r + cntbox[i][0]][c+cntbox[i][1]] == 'c' ) )
						{
							now_fined = true;
							break; // check is success
						}		
					}
					if( !now_fined )
						return false; // no blank is impossible
					
				}
			}
		}
		
		return true;
	}
	
	public String check() throws NumberFormatException, IOException{
		
		char mineboard[][] = new char[R][C];
		
		// board init
		for(int r = 0 ; r < R ; ++ r ){
			for( int c = 0; c < C ; ++ c ){
				mineboard[r][c] = '.';
			}
		}
		
		// 보드를 만들고 ~!
		if( !makeboard_shell_check(mineboard, 0, 0) ) return "Impossible\n";
		
		// 출력용 로직
		removeNumber( mineboard );
		
		return mineboardToString( mineboard );
		
		
	}


	public static void main(String[] args) throws NumberFormatException, IOException {

		//Read
		File in_file = new File( "./track_c/C-small-attempt4.in" );
		File out_file = new File("./track_c/track_c-attempt4.out");
		BufferedReader in = new BufferedReader( new FileReader(in_file) );
		BufferedWriter out = new BufferedWriter(new FileWriter( out_file, false ) );

			// read total count
		int totcnt = Integer.parseInt( in.readLine() );
		
		for( int c = 1 ; c <= totcnt ; ++ c ){
			String ret = "Case #" + c + ":\n" + ( new MineSweeperMaster_C( in ).check() ); 
			out.write( ret );
			
			System.out.print( ret );
		}
		out.close();
	}
}
