package q2015;

import com.google.common.base.Splitter;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;

import static com.google.common.base.Preconditions.checkArgument;

public class C {

    public static void main(String[] args) throws IOException {
        BufferedReader in = new BufferedReader(new FileReader("C-small-attempt0.in"));
        //BufferedReader in = new BufferedReader(new FileReader("C-small.in"));
        FileWriter fw = new FileWriter("C.out");

        int T = new Integer(in.readLine());
        for (int cases = 1; cases <= T; cases++) {
            Iterator<String> line = Splitter.on(' ').split(in.readLine()).iterator();
            int L = Integer.parseInt(line.next());
            int X = Integer.parseInt(line.next());
            String string = in.readLine();

            checkArgument(string.length() == L, "Expected string.length() = L, but %s != %s", string.length(), L);

            String res = solve(X, string) ? "YES" : "NO";
            fw.write("Case #" + cases + ": " + res + "\n");
            System.out.print("Case #" + cases + ": " + res + "\n");

        }

        fw.flush();
        fw.close();
    }

    enum Sym {
        one, i, j, k;
    }

    static class Value {
        public final boolean isneg;
        public final C.Sym symbol;

        public Value(C.Sym w, boolean q) {
            isneg = q;
            symbol = w;
        }

        public Value(char q) {
            isneg = false;
            switch (q) {
                case 'i':
                    symbol = Sym.i;
                    break;
                case 'j':
                    symbol = Sym.j;
                    break;
                case 'k':
                    symbol = Sym.k;
                    break;
                default:
                    symbol = Sym.one;
                    break;
            }
        }

        @Override
        public String toString() {
            if (isneg) {
                return '-' + symbol.toString();
            }
            return symbol.toString();
        }

        @Override
        public boolean equals(Object other) {
            boolean result = false;
            if (other instanceof Value) {
                Value that = (Value) other;
                result = this.symbol == that.symbol && this.isneg == that.isneg;
            }
            return result;
        }

        public Value neg() {
            return new Value(symbol, !isneg);
        }

        public Value pow(int n) {
            checkArgument(n > 0, "Argument was %s but expected > 0", n);
            if (n == 1) {
                return this;
            }
            if (symbol == Sym.one) {
                if (isneg) {
                    return new Value(Sym.one, !(n % 2 == 0));
                } else {
                    return this;
                }
            } else {
                switch (n % 4) {
                    case 0:
                        return new Value(Sym.one, false);
                    case 1:
                        return this;
                    case 2:
                        return new Value(Sym.one, true);
                    case 3:
                        return this.neg();
                }
            }
            System.out.println("\n\n\n\n\nwrong");
            return this;
        }

        public Value mul(Value other) {
            boolean sign = isneg != other.isneg;
            switch (symbol) {
                case one:
                    return other;
                case i:
                    switch (other.symbol) {
                        case one:
                            return new Value(Sym.i, sign);
                        case i:
                            return new Value(Sym.one, !sign);
                        case j:
                            return new Value(Sym.k, sign);
                        case k:
                            return new Value(Sym.j, !sign);
                        default:
                            System.out.println("\n\n\n\n\nwrong");
                            break;
                    }
                    break;
                case j:
                    switch (other.symbol) {
                        case one:
                            return new Value(Sym.j, sign);
                        case i:
                            return new Value(Sym.k, !sign);
                        case j:
                            return new Value(Sym.one, !sign);
                        case k:
                            return new Value(Sym.i, sign);
                        default:
                            System.out.println("\n\n\n\n\nwrong");
                            break;
                    }
                    break;
                case k:
                    switch (other.symbol) {
                        case one:
                            return new Value(Sym.k, sign);
                        case i:
                            return new Value(Sym.j, sign);
                        case j:
                            return new Value(Sym.i, !sign);
                        case k:
                            return new Value(Sym.one, !sign);
                        default:
                            System.out.println("\n\n\n\n\nwrong");
                            break;
                    }
                    break;
                default:
                    System.out.println("\n\n\n\n\nwrong");
                    break;
            }
            System.out.println("\n\n\n\n\nwrong");
            return new Value(Sym.one, false);
        }

    }

    public static boolean solve(int X, String inp) {
        if (inp.length() * X < 3) {
            return false;
        }
        if (inp.length() * X == 3) {
            return inp.charAt(0) == 'i' && inp.charAt(1) == 'j' && inp.charAt(2) == 'k';
        }

        Value init = new Value(inp.charAt(0));

        for (int i = 1; i < inp.length(); i++) {
            init = init.mul(new Value(inp.charAt(i)));
        }

        Value i = new Value('i');
        Value j = new Value('j');
        Value k = new Value('k');

        Value ijk = i.mul(j).mul(k);

        return init.pow(X).equals(ijk);

    }
}
