package q2015;

import com.google.common.base.Splitter;
import com.google.common.collect.Lists;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import static com.google.common.base.Preconditions.checkArgument;

public class B {

    public static void main(String[] args) throws IOException {
        BufferedReader in = new BufferedReader(new FileReader("B-small-attempt1.in"));
        //BufferedReader in = new BufferedReader(new FileReader("B.in"));
        FileWriter fw = new FileWriter("B.out");

        int T = new Integer(in.readLine());
        for (int cases = 1; cases <= T; cases++) {
            int D = Integer.parseInt(in.readLine());
            String line = in.readLine();

            List<String> split = Lists.newArrayList(Splitter.on(' ').split(line));
            List<Integer> persons = new ArrayList<Integer>();

            for (String s : split) {
                persons.add(Integer.parseInt(s));
            }
            checkArgument(persons.size() == D, "Expected split.size() = D, but %s != %s", persons.size(), D);

            int res = solve(0, persons, Integer.MAX_VALUE);
            fw.write("Case #" + cases + ": " + res + "\n");
            System.out.println("Case #" + cases + ": " + res + "\n");
        }
        fw.flush();
        fw.close();
    }

    public static int solve(int time, List<Integer> P, int best) {
        int longest = Collections.max(P);
        if (longest == 1) {
            return time + 1;
        }
        if (best < longest) {
            return time + longest;
        }
        List<Integer> sols = new ArrayList<Integer>();
        sols.add(longest + time);

        for (int i = 2; i < longest / 2 + 1; i++) {
            List<Integer> copy = new ArrayList<Integer>();
            for (Integer n : P) {
                copy.add(n.intValue());
            }
            int index = copy.indexOf(longest);
            copy.remove(index);
            copy.add(i);
            copy.add(longest - i);

            sols.add(solve(time + 1, copy, Math.min(longest + time, best)));
        }

        return Collections.min(sols);
    }
}
