package main;

import java.io.*;
import java.util.*;

public class R2_B_Main {

    static int map[][];
    static int R, C, D;
    static long com_h[][];
    static long sum_h[][];
    static long com_v[][];
    static long sum_v[][];

    static boolean solve(int k) {
        for (int r=0; r<=R-k; r++) {
            for (int c=0; c<C; c++) {
                com_h[r][c] += k * map[r+k-1][c];
                sum_h[r][c] += map[r+k-1][c];
            }
        }
        for (int r=0; r<R; r++) {
            for (int c=0; c<=C-k; c++) {
                com_v[r][c] += k * map[r][c+k-1];
                sum_v[r][c] += map[r][c+k-1];
            }
        }
        long he[][] = new long[R][C];
        long ve[][] = new long[R][C];
        for (int r=0; r<R; r++) {
            for (int c=0; c<C; c++) {
                he[r][c] = 2*com_h[r][c] - (k+1)*sum_h[r][c];
                ve[r][c] = 2*com_v[r][c] - (k+1)*sum_v[r][c];
            }
        }
        long hm[][] = new long[R][C];
        long vm[][] = new long[R][C];
        for (int r=0; r<R; r++) {
            for (int c=0; c<=0; c++) {
                hm[r][c] = 0;
                for (int l=0; l<k; l++) {
                    hm[r][c] += he[r][c+l];
                }
            }
        }
        for (int r=0; r<=0; r++) {
            for (int c=0; c<C; c++) {
                vm[r][c] = 0;
                for (int l=0; l<k; l++) {
                    vm[r][c] += ve[r+l][c];
                }
            }
        }
        for (int r=0; r<=R-k; r++) {
            for (int c=1; c<=C-k; c++) {
                hm[r][c] = hm[r][c-1] - he[r][c-1] + he[r][c+k-1];
            }
        }
        for (int r=1; r<=R-k; r++) {
            for (int c=0; c<=C-k; c++) {
                vm[r][c] = vm[r-1][c] - ve[r-1][c] + ve[r+k-1][c];
            }
        }
        for (int r=0; r<=R-k; r++) {
            for (int c=0; c<=C-k; c++) {
                long h = 0;
                long v = 0;
//                for (int l=0; l<k; l++) {
//////                    h += 2*com_h[r][c+l] - (k+1)*sum_h[r][c+l];
//                    h += he[r][c+l];
//                    v += 2*com_v[r+l][c] - (k+1)*sum_v[r+l][c];
//                }

                h = hm[r][c];
                v = vm[r][c];
                long h_corners = +map[r][c] + map[r][c+k-1]
                        - map[r+k-1][c] - map[r+k-1][c+k-1];
                long v_corners = +map[r][c] - map[r][c+k-1]
                        + map[r+k-1][c] - map[r+k-1][c+k-1];
                h += (k-1)*h_corners;
                v += (k-1)*v_corners;
//                System.err.println("K" + k + " " + r + "," + c + " -> " + h + "," + v);
                if ((h == 0) && (v == 0)) {
//                System.err.println("K" + k + " " + r + "," + c + " -> " + h + "," + v);
                    return true;
                }
            }
        }
        return false;
    }

    public static void main(String[] args) throws IOException {
        Reader reader;
        if (args.length > 0) {
            reader = new FileReader(args[0]);
        } else {
            reader = new InputStreamReader(System.in);
        }
        BufferedReader inp = new BufferedReader(reader);
        final int T = Integer.parseInt(inp.readLine());
        for (int t = 1; t <= T; t++) {
            System.err.println(t);
            Queue<String> problem = new LinkedList<String>(
                    Arrays.asList(inp.readLine().split(" ")));

            R = Integer.parseInt(problem.poll());
            C = Integer.parseInt(problem.poll());
            D = Integer.parseInt(problem.poll());

            map = new int[R][C];
            com_h = new long[R][C];
            com_v = new long[R][C];
            sum_h = new long[R][C];
            sum_v = new long[R][C];

            for (int r=0; r<R; r++) {
                String line = inp.readLine();
                for (int c=0; c<C; c++) {
                    map[r][c] = (byte)(line.charAt(c) - '0');
                    com_h[r][c] = map[r][c];
                    com_v[r][c] = map[r][c];
                    sum_h[r][c] = map[r][c];
                    sum_v[r][c] = map[r][c];
                }
            }

            final int maxK = Math.min(R, C);
            Integer solution = null;
            for (int k=2; k<=maxK; k++) {
                if (solve(k) && (k >= 3)) {
                    solution = k;
                }
            }

            if (solution != null) {
                System.out.println("Case #" + t + ": " + solution);
            } else {
                System.out.println("Case #" + t + ": IMPOSSIBLE");
            }
        }
    }
}
