package r1_b;

import java.io.*;
import java.util.*;

public class R1_B_Main {

    static class Intervals {
        TreeMap<Integer, Integer> m = new TreeMap<Integer, Integer>();

        void add(int length, int count) {
            //System.err.println("add " + length + " x" + count);
            if (length == 0) {
                return;
            }
            Integer oldValue = m.get(length);
            m.put(length,
                    oldValue == null ? count : oldValue + count);
        }

        void print() {
            //System.err.println("Intervals:");
            for (Integer length : m.descendingKeySet()) {
                //System.err.println("  " + length + " x" + m.get(length));
            }
        }
    }

    public static void main(String[] args) throws IOException {
        BufferedReader inp = new BufferedReader(new InputStreamReader(System.in));
        final int T = Integer.parseInt(inp.readLine());
        for (int test = 1; test <= T; test++) {
            Queue<String> problem = new LinkedList<String>(
                    Arrays.asList(inp.readLine().split(" ")));

            final int L = Integer.parseInt(problem.poll());
            final long t = Long.parseLong(problem.poll());
            final int N = Integer.parseInt(problem.poll());
            final int C = Integer.parseInt(problem.poll());

            int a[] = new int[C];
            long sum = 0;
            for (int i=0; i<C; i++) {
                a[i] = Integer.parseInt(problem.poll());
                sum += a[i];
            }

            final int fullRounds = N / C;
            final int endBroken = N % C;
            Intervals intv = new Intervals();
            for (int i=0; i<C; i++) {
                intv.add(a[i], fullRounds);
            }
            long worstTime = fullRounds * sum * 2;
            for (int i=0; i<endBroken; i++) {
                intv.add(a[i], 1);
                worstTime += a[i] * 2;
            }
            intv.print();
            final long t2 = Math.min(t, worstTime);

            final int slowRounds = (int)((t2/2) / sum);
            final int slowBroken = (int)((t2/2) % sum);
            for (int i=0; i<C; i++) {
                intv.add(a[i], -slowRounds);
            }
            intv.print();
            int res = slowBroken;
            for (int i=0; i<C; i++) {
                if (res >= a[i]) {
                    intv.add(a[i], -1);
                    res -= a[i];
                } else {
                    intv.add(a[i], -1);
                    intv.add(a[i]-res, 1);
                    break;
                }
            }
            intv.print();

            long time = t2;
            int boosters = L;
            //System.err.println("time=" + time + "  boosters=" + boosters);
            for (Integer length : intv.m.descendingKeySet()) {
                int count = intv.m.get(length);
                if (count == 0) {
                    continue;
                }
                if (boosters >= count) {
                    time += length * count;
                    boosters -= count;
                    //System.err.println(length + " fast x" + count);
                } else if (boosters > 0) {
                    time += length * boosters + length * (count-boosters)*2;
                    //System.err.println(length + " fast x" + boosters + " slow x" + (count-boosters));
                    boosters = 0;
                } else {
                    time += length * count * 2;
                    //System.err.println(length + " slow x" + count);
                }
                //System.err.println("time=" + time + "  boosters=" + boosters);
            }

            // TEST: nem készül el a kütyü, pont a végére kész, uccsó int-ba belemetsz, ...
            System.out.println("Case #" + test + ": " + time);
        }
    }
}
