package a;

import java.io.*;
import java.util.*;

public class A_Main {

    public static void main(String[] args) throws IOException {
        if (args.length != 1) {
            System.err.println("Usage!");
            System.exit(1);
        }
        BufferedReader inp = new BufferedReader(new FileReader(args[0]));
        final int problemCount = Integer.parseInt(inp.readLine());
        for (int p = 1; p <= problemCount; p++) {
            Queue<String> problem = new LinkedList<String>(
                    Arrays.asList(inp.readLine().split(" ")));

            final int buttons = Integer.parseInt(problem.poll());

            List<Integer> o = new ArrayList<Integer>();
            List<Integer> b = new ArrayList<Integer>();
            int oPos = 1, oTime = 0, bPos = 1, bTime = 0;
            for (int i = 0; i < buttons; i++) {
                char type = problem.poll().charAt(0);
                int button = Integer.parseInt(problem.poll());
                int distance;
                switch (type) {
                case 'O':
                    distance = Math.abs(oPos - button);
                    oTime = Math.max(bTime + 1, oTime + distance + 1);
                    oPos = button;
                    break;
                case 'B':
                    distance = Math.abs(bPos - button);
                    bTime = Math.max(oTime + 1, bTime + distance + 1);
                    bPos = button;
                    break;
                default:
                    System.err.println("Problem #" + p + ": button #" + i + " type unknown.");
                    System.exit(1);
                }
            }
            System.out.println("Case #" + p + ": " + Math.max(oTime, bTime));
        }
    }
}
