package savingtheuniverse;

import java.io.*;

public class Main {
    static String[] engines;
    static String[] queries;
    static int[][] solution;
    //Vector<Vector<Integer>> solution;
    
    static int solve() {
        solution = new int[queries.length+1][engines.length];
        
        // 0 queries
        for (int e=0; e<engines.length; e++) 
            solution[0][e] = 0;
        
        // q queries when q-1 is solved
        for (int q=1; q<=queries.length; q++) {
            for (int e=0; e<engines.length; e++) {
                int min = Integer.MAX_VALUE;
                for (int ep=0; ep<engines.length; ep++) {
                    // how many switches to finish "q" queries 
                    // being at "e" engine, when we was at "ep" engine the last time
                    if (engines[ep].equals(queries[q-1])) 
                        continue; // not possible
                    int new_min = solution[q-1][ep] + ((e == ep) ? 0 : 1);
                    if (new_min < min) {
                        min = new_min;
                    }
                }
                solution[q][e] = min;
            }
        }
        int min = Integer.MAX_VALUE;
        for (int e=0; e<engines.length; e++) {
            if (solution[queries.length][e] < min) {
                min = solution[queries.length][e];
            }
        }
        return min;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws Exception {
        if (args.length != 1) {
            System.err.println("Usage: java savingtheuniverse.Main filename");
            System.exit(-1);
        }
        final String fileName = args[0];
        BufferedReader br = new BufferedReader(new FileReader(fileName));
        int cases = new Integer(br.readLine());
        for (int c=0; c<cases; c++) {
            int eno = new Integer(br.readLine());
            engines = new String[eno];
            for (int e=0; e<eno; e++) {
                engines[e] = br.readLine();
                //System.out.println("Engine #" + e + " = " + engines[e]);
            }
            
            int qno = new Integer(br.readLine());
            queries = new String[qno];
            for (int q=0; q<qno; q++) {
                queries[q] = br.readLine();
                //System.out.println("Queries #" + q + " = " + queries[q]);
            }
            
            System.out.print("Case #" + (c+1) + ": ");
            System.out.flush();
            System.out.println(solve());
        }
    }
}
