package main;

import java.io.*;
import java.util.*;

public class R2_A_Main {

    static class Intervals {
        TreeMap<Integer, Integer> m = new TreeMap<Integer, Integer>();

        void add(int w, int length) {
            //System.err.println("add " + length + " x" + count);
            Integer oldValue = m.get(w);
            m.put(w,
                    oldValue == null ? length : oldValue + length);
        }

        void print() {
            System.err.println("Intervals:");
            for (Integer length : m.descendingKeySet()) {
                System.err.println("  " + length + " x" + m.get(length));
            }
        }
    }

    public static void main(String[] args) throws IOException {
        Reader r;
        if (args.length > 0) {
            r = new FileReader(args[0]);
        } else {
            r = new InputStreamReader(System.in);
        }
        BufferedReader inp = new BufferedReader(r);
        final int T = Integer.parseInt(inp.readLine());
        for (int tNo = 1; tNo <= T; tNo++) {
            Queue<String> problem = new LinkedList<String>(
                    Arrays.asList(inp.readLine().split(" ")));

            final int X = Integer.parseInt(problem.poll());
            final int S = Integer.parseInt(problem.poll());
            final int R = Integer.parseInt(problem.poll());
            final int t = Integer.parseInt(problem.poll());
            final int N = Integer.parseInt(problem.poll());

            Intervals ww2 = new Intervals();
            int sumWwLength = 0;
            for (int i=0; i<N; i++) {
                Queue<String> wwl = new LinkedList<String>(
                        Arrays.asList(inp.readLine().split(" ")));
                int B = Integer.parseInt(wwl.poll());
                int E = Integer.parseInt(wwl.poll());
                int w = Integer.parseInt(wwl.poll());

                int length = E-B;
                ww2.add(w, length);
                sumWwLength += length;
            }
            ww2.add(0, X-sumWwLength);

//            System.err.println("T: " + tNo);
            double runTimeLeft = t;
            double fullTime = 0;
            for (Map.Entry<Integer, Integer> e : ww2.m.entrySet()) {
                final int w = e.getKey();
                final int l = e.getValue();
//                System.err.println("W: " + w + ", L=" + l);
                if (runTimeLeft <= 0) {
                    fullTime += (double)l / (w + S);
                } else {
                    double runTime = (double)l / (w + R);
                    double nowRunTime = Math.min(runTime, runTimeLeft);
                    fullTime += nowRunTime +
                            ((double)l - nowRunTime * (w + R)) / (w + S);
                    runTimeLeft -= nowRunTime;
                }
//                System.err.println("fT: " + fullTime + ", rL=" + runTimeLeft);
            }
            System.out.println("Case #" + tNo + ": " + fullTime);
        }
    }
}
