package b;

import com.google.common.collect.HashMultimap;
import com.google.common.collect.Multimap;
import java.io.*;
import java.util.*;

public class Main {

    public static String join(Collection seq, String delimiter) {
        StringBuilder sb = new StringBuilder();
        boolean first = true;
        for (Object o : seq) {
            if (first) {
                first = false;
            } else {
                sb.append(delimiter);
            }
            sb.append(o.toString());
        }
        return sb.toString();
    }

    public static void main(String[] args) throws IOException {
        if (args.length != 1) {
            System.err.println("Usage!");
            System.exit(1);
        }
        BufferedReader inp = new BufferedReader(new FileReader(args[0]));
        final int problemCount = Integer.parseInt(inp.readLine());
        for (int p = 1; p <= problemCount; p++) {
            Queue<String> problem = new LinkedList<String>(
                    Arrays.asList(inp.readLine().split(" ")));

            Map<String, Character> combining = new HashMap<String, Character>();
            final int combiningPairs = Integer.parseInt(problem.poll());
            for (int i=0; i<combiningPairs; i++) {
                String cp = problem.poll();
                combining.put("" + cp.charAt(0) + cp.charAt(1), cp.charAt(2));
                combining.put("" + cp.charAt(1) + cp.charAt(0), cp.charAt(2));
            }

            Multimap<Character, Character> opposing = HashMultimap.create();
            final int opposingPairs = Integer.parseInt(problem.poll());
            for (int i=0; i<opposingPairs; i++) {
                String op = problem.poll();
                opposing.put(op.charAt(0), op.charAt(1));
                opposing.put(op.charAt(1), op.charAt(0));
            }

            final int length = Integer.parseInt(problem.poll());
            final String sequence = problem.poll();

            List<Character> seq = new ArrayList<Character>();
            Set<Character> seqs = new HashSet<Character>();
            Character last = null;
            for (int i=0; i<length; i++) {
                Character act = sequence.charAt(i);
                if (last != null) {
                    // try to combinate
                    Character comb = combining.get("" + last + act);
                    if (comb != null) {
                        seq.add(comb);
                        last = null;
                        continue;
                    } else {
                        seq.add(last);
                        last = null;
                    }
                }
                // try to oppose
                if (seqs.removeAll(opposing.get(act))) {
                    // reset bag
                    seq.clear();
                    seqs.clear();
                    last = null;
                } else {
                    // add new element
                    if (last != null) {
                        seq.add(last);
                    }
                    last = act;
                    seqs.add(act);
                }
            }
            if (last != null) {
                seq.add(last);
            }
            System.out.println("Case #" + p + ": [" + join(seq, ", ") + "]");
        }
    }
}
