import java.util.Locale;
import java.util.Scanner;
import java.io.OutputStream;
import java.io.IOException;
import java.io.FileOutputStream;
import java.math.MathContext;
import java.math.BigDecimal;
import java.io.PrintWriter;
import java.math.RoundingMode;
import java.io.FileInputStream;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream;
		try {
			inputStream = new FileInputStream("test/task_b.in");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("test/task_b.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		Scanner in = new Scanner(inputStream);
                in.useLocale(Locale.ENGLISH);
		PrintWriter out = new PrintWriter(outputStream);
		Task_B solver = new Task_B();
		solver.solve(1, in, out);
		out.close();
	}
}

class Task_B {
    public void solve(int testNumber, Scanner in, PrintWriter out) {
        MathContext mc = new MathContext(20, RoundingMode.HALF_UP);
        int tc = in.nextInt();
        for (int test = 1; test <= tc; ++test) {
            BigDecimal c = new BigDecimal(in.nextDouble(), mc);
            BigDecimal f = new BigDecimal(in.nextDouble(), mc);
            BigDecimal x = new BigDecimal(in.nextDouble(), mc);

            BigDecimal best = new BigDecimal(100000000, mc);
            BigDecimal dcurr = new BigDecimal(2, mc);
            BigDecimal currt = new BigDecimal(0, mc);

            for (; currt.compareTo(best) < 0; ) {
                BigDecimal curr = currt.add(x.divide(dcurr, mc), mc);
                best = best.min(curr);

                currt = currt.add(c.divide(dcurr, mc), mc);
                dcurr = dcurr.add(f, mc);
            }

            out.printf("Case #%d: %s\n", test, best.setScale(10, BigDecimal.ROUND_HALF_UP));
        }
    }
}

