import java.io.*;
import java.util.*;

public class Main {
    /**
     * author geshpaniec
     * 23.10.2014
     */

    StringTokenizer in;
    BufferedReader inb;
    PrintWriter out;
    static boolean local;
    final String problemname = "Bsmall";
    final static String _localArg="ageshpaniecz";
    final static byte IO=3;
        /* IO:
         * 1 - standard I/O
         * 2 - input.txt/output.txt
         * 3 - problemname.in/problemname.out
         */

    int[][] m;
    int n;

    boolean check(int[][]c,boolean[] used){
        boolean[] columns = new boolean[n];
        Arrays.fill(columns,false);
        for (int i = 0; i < 2*n-1; i++) {
            if (!used[i])
                B:for (int j = 0; j < n; j++) {
                    if (!columns[j]){
                        boolean ge = true;
                        A:for (int k = 0; k < n; k++) {
                            if (m[i][k] != c[k][j]){
                                ge = false;
                                break A;
                            }

                        }
                        if (ge) {
                            columns[j] = true;
                            break B;
                        }
                    }
                }
        }
        int index = -1;
        for (int i = 0; i < n; i++) {
            if (!columns[i]){
                if (index != -1)
                    return false;
                index = i;

            }
        }
        for (int j = 0; j < n; j++) {
            out.print(c[j][index]+" ");
        }
        return true;
    }

    boolean greater(int[] a,int[] b){
        boolean res = true;
        for (int i = 0; i < a.length; i++) {
            if (a[i]<=b[i]){
                res = false;
                break;
            }
        }
        return res;
    }

    boolean rec(int[][] c, int len, int i,boolean[] used){
        if (len == n)
            return check(c,used);
        if (i == 2*n-1)
            return false;
        if (greater(m[i],c[len-1])){
                used[i] = true;
                c[len++] = m[i];
                if (!rec(c,len,i+1,used)){
                    used[i] = false;
                    len--;
                }
                else
                    return true;
        }

        return rec(c,len,i+1,used);
    }

    public void solveCase(int Case) throws Exception{
        out.print("Case #"+Case+": ");
        n = nextInt();
        m = new int[2*n-1][n];
        for (int i = 0; i < 2 * n - 1; i++) {
            for (int j = 0; j < n; j++) {
                m[i][j] = nextInt();
            }
        }
        Arrays.sort(m,(int[] a,int[] b)->{

            return Integer.compare(a[0],b[0]);
        });
        boolean[] used = new boolean[2*n-1];
        Arrays.fill(used,false);
        for (int i = 0; i < 2 * n - 1; i++) {
            Arrays.fill(used,false);
            int[][] c = new int[n][];
            used[i] = true;
            c[0] = m[i];
            if (rec(c,1,i+1,used)){
                break;
            }
        }
        out.println();
    }


    public void solve() throws Exception {
        int T = nextInt();
        for (int q = 1; q <= T; q++) {
            solveCase(q);
        }

//        System.out.println((long)Math.pow(29,11));
//        long L = 12200509765705828L;
//        L/=29L;
//        System.out.println(L);
    }

    public static void main(String[] args) throws Exception {
        local = false;
        if (args.length == 1 && args[0].equals(_localArg))
            local = true;
        new Main().run();

    }

    public void run() throws Exception {
        if (local) {
            inb = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter(new OutputStreamWriter(System.out));
        } else {
            switch (IO){
                case 1:
                    inb = new BufferedReader(new InputStreamReader(System.in));
                    out = new PrintWriter(new OutputStreamWriter(System.out));
                    break;
                case 2:
                    inb = new BufferedReader(new FileReader("input.txt"));
                    out = new PrintWriter(new FileWriter("output.txt"));
                    break;
                case 3:
                    inb = new BufferedReader(new FileReader(problemname+".in"));
                    out = new PrintWriter(new FileWriter(problemname+".out"));
                    break;
            }
        }
        in = new StringTokenizer("");
        double Time=System.nanoTime();
        solve();
        if (local){
            Time=System.nanoTime()-Time;
            out.println();
            out.println(" Time work: "+Time/(1e9)+" seconds");
        }
        out.flush();
    }

    int nextInt() throws Exception {
        return Integer.parseInt(next());
    }

    long nextLong() throws Exception{
        return Long.parseLong(next());
    }

    double nextDouble() throws Exception {
        return Double.parseDouble(next());
    }

    String next() throws Exception {
        if (!in.hasMoreTokens())
            in=new StringTokenizer(inb.readLine());
        return in.nextToken();
    }

    int[] nextArray(int n) throws Exception{
        int[] a=new int[n];
        for (int i=0;i<n;i++)
            a[i]=nextInt();
        return a;
    }

    long[] nextLArray(int n) throws Exception{
        long[] a=new long[n];
        for (int i=0;i<n;i++)
            a[i]=nextLong();
        return a;
    }

    double[] nextDArray(int n) throws Exception{
        double[] a=new double[n];
        for (int i=0;i<n;i++)
            a[i]=nextDouble();
        return a;
    }

    String[] nextSArray(int n) throws Exception{
        String[] a=new String[n];
        for (int i=0;i<n;i++)
            a[i]=next();
        return a;
    }


}