import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

public class Pancakes {
    public static int solve(List<Integer> pancakeCounts) {
        int counter = 0;
        int toSplit = upperBoundSpecial(pancakeCounts);
        int normal = normalCount(pancakeCounts, toSplit);
        while (pancakeCounts.get(pancakeCounts.size() - 1) > toSplit + normal) {
            counter += toSplit;
            for (int i = 0; i < toSplit; i++) {
                specialSplit(pancakeCounts);
            }
            toSplit = upperBoundSpecial(pancakeCounts);
            normal = normalCount(pancakeCounts, toSplit);
        }
        return pancakeCounts.get(pancakeCounts.size() - 1) + counter;
    }

    private static int upperBoundSpecial(List<Integer> pancakeCounts) {
        int max = Integer.MIN_VALUE;
        for (Integer i : pancakeCounts) {
            max = Math.max(max, i);
        }

        int toSplit = 0;
        for (int i = pancakeCounts.size() - 1; i >= 0; i--) {
            if (pancakeCounts.get(i) >= (max - toSplit)) {
                toSplit++;
            }
        }

        return toSplit;
    }

    private static int normalCount(List<Integer> pancakeCounts, int toSplit) {
        int max = pancakeCounts.get(pancakeCounts.size() - 1);
        int halfMax = (max + 1) / 2;
        int nextMax = 0;
        if (pancakeCounts.size() - 1 - toSplit >= 0)
            nextMax = pancakeCounts.get(pancakeCounts.size() - 1 - toSplit);
        return Math.max(halfMax, nextMax);
    }

    public static void specialSplit(List<Integer> pancakeCounts) {
        int max = pancakeCounts.get(pancakeCounts.size() - 1);
        int a = max / 2;
        int b = (max + 1) / 2;
        int i;
        for (i = 0; i < pancakeCounts.size(); i++) {
            if (pancakeCounts.get(i) >= a) {
                pancakeCounts.add(i, a);
                break;
            }
        }
        for (; i < pancakeCounts.size(); i++) {
            if (pancakeCounts.get(i) >= b) {
                pancakeCounts.add(i, b);
                break;
            }
        }
        pancakeCounts.remove(pancakeCounts.size() - 1);
    }

    public static void main(String[] args) throws Exception {
        File inputFile = new File(args[0]);
        Scanner s = new Scanner(inputFile);
        int numProblems = Integer.parseInt(s.nextLine());
        for (int i = 0; i < numProblems; i++) {
            s.nextLine();
            String[] line = s.nextLine().split(" ");
            int[] intLine = new int[line.length];
            for (int j = 0; j < line.length; j++) {
                intLine[j] = Integer.parseInt(line[j]);
            }
            Arrays.sort(intLine);

            List<Integer> pancakeCounts = new ArrayList<Integer>();
            for (int j : intLine) {
                pancakeCounts.add(new Integer(j));
            }

            System.out.printf("Case #%d: %s\n", i + 1, solve(pancakeCounts));
        }
        s.close();
    }
}
