
public class Stall implements Comparable<Stall>{

	int freeLeft = 0;
	int freeRight = 0;
	int index = 0;
	boolean busy = false;
	public Stall(int freeLeft, int freeRight, int index, boolean busy) {
		super();
		this.freeLeft = freeLeft;
		this.freeRight = freeRight;
		this.index = index;
		this.busy = busy;
	}
	
	
	public boolean isBusy() {
		return busy;
	}


	public void setBusy(boolean busy) {
		this.busy = busy;
	}


	public int getMinFree() {
		return freeLeft < freeRight ? freeLeft : freeRight; 
	}
	public int getMaxFree() {
		return freeLeft > freeRight ? freeLeft : freeRight;
	}
	
	
	
	public int getFreeLeft() {
		return freeLeft;
	}

	public void setFreeLeft(int freeLeft) {
		this.freeLeft = freeLeft;
	}

	public int getFreeRight() {
		return freeRight;
	}

	public void setFreeRight(int freeRight) {
		this.freeRight = freeRight;
	}

	public int getIndex() {
		return index;
	}

	public void setIndex(int index) {
		this.index = index;
	}

	@Override
	public int compareTo(Stall s) {
		if (busy) {
			if (!s.busy) {
				return -1;
			} else {
				return s.getIndex() - index;
			}
		}
		
		if (s.busy) {
			if (!busy) {
				return 1;
			}else {
				return s.getIndex() - index;
			}
		}
		if (getMinFree() > s.getMinFree()) {
			return 1;
		}
		if (getMinFree() < s.getMinFree()) {
			return -1;
		}
		if (getMaxFree() > s.getMaxFree()) {
			return 1;
		}
		if (getMaxFree() < s.getMaxFree()) {
			return -1;
		}
		return s.getIndex() - index;
	}
	
	@Override
	public String toString() {
		return "stall "+ index + " busy = " + busy +
				" rightFree = " + freeRight + " leftFree : " + freeLeft;
	}
	
}
