/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package q2;


import java.util.Arrays;
import java.util.LinkedList;

/**
 *
 * @author FARHAN
 */
public class PQ {
    
    private LinkedList<Node> Queue;
    
    public PQ(){
        Queue = new LinkedList<>();
    }
    
    /**
     * This function will make the given node a head node.
     * @param node
     * @return 
     */
    public boolean AddHeadOfPQ(Node node) {
        try {
            if (this.Queue.isEmpty()) {
                this.Queue.addFirst(node);
                
                return true;
                
            }
            return false;
        } catch (Exception ex) {
            return false;
        }
    }
    
    /**
     * This function will Add Nodes in Queue on basis of their priority given by only heuristic.
     * @param node
     * @return 
     */
    public boolean AddByHeuristic(Node node) {

        int newvalue = node.GetMisPlacedTile();

        int i = 0;
        for (Node ANode : Queue) {
            int oldvalue = ANode.GetMisPlacedTile();
            
            if ((newvalue < oldvalue )&& !(Arrays.toString(node.GetNode()).equals(Arrays.toString(ANode.GetNode())))) {
                if (i > 0) {
                    Queue.set(i, node);
                } else {
                    Queue.addFirst(node);
                }
                return true;
            }
               
            
            i++;
        }
        
        if (!Queue.isEmpty()) {
            Queue.addLast(node);
            return true;
        }
        Queue.addFirst(node);
        return true;

    }
    
    /**
     * This function will Add the given node to queue on basis of their priority + cost to reach them 
     * from initial node.
     * @param node
     * @return 
     */
    public boolean AddByHeuristicAndPathCost(Node node){
        int newvalue = node.GetMisPlacedTile() + node.GetLevel();

        int i = 0;
        for (Node QueueNode : Queue) {
            int oldvalue = QueueNode.GetMisPlacedTile()+ QueueNode.GetLevel();
            
            if ((newvalue < oldvalue) && !(Arrays.toString(node.GetNode()).equals(Arrays.toString(QueueNode.GetNode())))) {
                if (i > 0) {
                    Queue.set(i, node);
                    
                } else {
                    Queue.addFirst(node);
                }
                return true;
            }
               
            
            i++;
        }
        
        if (!Queue.isEmpty()) {
            Queue.addLast(node);
            return true;
        }
        Queue.addFirst(node);
        return true;   
    }
    
    /**
     * This function will remove first node from queue.
     * @return 
     */
    public Node remove() {
        try {
            return Queue.removeFirst();
        } catch (Exception ex) {
            return null;
        }
    }
    
    /**
     * This function will checks that given node exist in Queue or not. 
     * @param node
     * @return 
     */
    public boolean contains(Node node) {
        try {
            for (Node QueueNode : Queue) {
                if((Arrays.toString(node.GetNode()).equals(Arrays.toString(QueueNode.GetNode()))))
                    return true;
            }
            return false;
        } catch (Exception ex) {
            return false;
        }
    }
    
    /**
     * This function will check that Queue is empty or not.
     * @return 
     */
    public boolean isEmpty() {
        try {
            return Queue.isEmpty();
        } catch (Exception ex) {
            return false;
        }
    }
    
    /**
     * This function will print the queue.
     */
    public void PrintPriorityQueue() {
        
        for (Node Queue1 : Queue) {
         
            Queue1.PrintNode();
            
        }

    }
    
    /**
     * This function will set the queue to null.
     */
    public void SetNull(){
        this.Queue = null;
    }

}


