import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class TicTac
{

	public void Execute(String aFileName)
	{
		List<String> output = new ArrayList<String>();
		List<WinState> res = new ArrayList<WinState>();
		Scanner in;
		char[][] board = null;
		String line;
		try
		{
			in = new Scanner(new FileReader(aFileName));

			int n = Integer.parseInt(in.nextLine());
			board = new char[4][4];
			for (int k = 1; k < n; k++)
			{
				for (int i = 0; i <= 3; i++)
				{
					line = in.nextLine();
					for (int j = 0; j <= 3; j++)
						board[i][j] = line.charAt(j);

				}
				// printBoard(board);
				res.add(Evaluate(board));
				line = in.nextLine();
			}

			for (int i = 0; i <= 3; i++)
			{
				line = in.nextLine();
				for (int j = 0; j <= 3; j++)
					board[i][j] = line.charAt(j);

			}
			// printBoard(board);
			res.add(Evaluate(board));

		}
		catch (FileNotFoundException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		for (int i = 0; i < res.size(); i++)
			output = Submit(output, res.get(i), i + 1);

		try
		{
			PrintWriter out = new PrintWriter("D:\\GoogleJam\\res1.in");
			for (int i = 0; i < res.size(); i++)
			{
				out.println(output.get(i));
			}
			out.flush();
		}
		catch (FileNotFoundException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	List<String> Submit(List list, WinState state, int n)
	{
		String s = "Case #" + n + ": ";
		switch (state)
			{
				case O_WON:
					s = s + "O won";
					break;
				case X_WON:
					s = s + "X won";
					break;
				case DRAW:
					s = s + "Draw";
					break;
				case NOT_COMPLETED:
					s = s + "Game has not completed";
					break;

			}
		list.add(s);
		return list;
	}

	public WinState Evaluate(char[][] board)
	{
		for (int i = 0; i <= 3; i++)
		{
			if (CheckRow(board, i, Player.O))
				return WinState.O_WON;
			if (CheckRow(board, i, Player.X))
				return WinState.X_WON;
		}
		for (int i = 0; i <= 3; i++)
		{
			if (CheckClmn(board, i, Player.O))
				return WinState.O_WON;
			if (CheckClmn(board, i, Player.X))
				return WinState.X_WON;
		}
		if (CheckDiagonal(board, 1, Player.O))
			return WinState.O_WON;
		if (CheckDiagonal(board, 1, Player.X))
			return WinState.X_WON;

		if (CheckDiagonal(board, 2, Player.O))
			return WinState.O_WON;
		if (CheckDiagonal(board, 2, Player.X))
			return WinState.X_WON;

		if (CheckNotCompleted(board))
			return WinState.NOT_COMPLETED;
		return WinState.DRAW;

	}

	void printBoard(char[][] board)
	{
		for (int i = 0; i <= 3; i++)
		{
			for (int j = 0; j <= 3; j++)
				System.out.print(board[i][j]);
			System.out.println("");
		}
	}

	boolean CheckRow(char[][] board, int row, Player p)
	{
		char playerFlag = 'X';
		if (p == Player.O)
			playerFlag = 'O';
		for (int clmn = 0; clmn <= 3; clmn++)
			if (board[row][clmn] != playerFlag && board[row][clmn] != 'T')
				return false;
		return true;
	}

	boolean CheckClmn(char[][] board, int clmn, Player p)
	{
		char playerFlag = 'X';
		if (p == Player.O)
			playerFlag = 'O';
		for (int row = 0; row <= 3; row++)
			if (board[row][clmn] != playerFlag && board[row][clmn] != 'T')
				return false;
		return true;
	}

	boolean CheckDiagonal(char[][] board, int diagonal, Player p)
	{
		char playerFlag = 'X';
		if (p == Player.O)
			playerFlag = 'O';
		if (diagonal == 1)
			for (int i = 0; i <= 3; i++)
				if (board[i][i] != playerFlag && board[i][i] != 'T')
					return false;
		if (diagonal == 2)
			for (int i = 0; i <= 3; i++)
				if (board[i][3 - i] != playerFlag && board[i][3 - i] != 'T')
					return false;
		return true;
	}

	boolean CheckNotCompleted(char[][] board)
	{
		for (int i = 0; i <= 3; i++)
			for (int j = 0; j <= 3; j++)
				if (board[i][j] == '.')
					return true;
		return false;
	}

}
