import static java.lang.Math.*;
import static java.util.Arrays.*;
import static java.util.Collections.*;
import java.io.*;
import java.util.*;
import java.math.*;
// The 'jgrapht' package could be downloaded from: http://www.jgrapht.org/
// If this problem is not a graph-related problem, it should be safe to comment out the following three lines to pass compiliation.
import org.jgrapht.*;
import org.jgrapht.graph.*;
import org.jgrapht.alg.*;

class C
{
	private static final String CLASS_NAME = C.class.getName();

	private static final boolean DEBUG_ON = true;
	private static final boolean ECHO_ON = true;

	private static BufferedReader input;
	private static BufferedWriter output;

	private static final double PINF = Double.POSITIVE_INFINITY;
	private static final double NINF = Double.NEGATIVE_INFINITY;
	private static final double EPS = 1e-12;
	private static final int INF = 1000000000;
	private static final int MOD = 10007;

/*
	public static int cost(HM<String, Integer> map)
	{
		String key;
		{
			SB buffer = new SB();
			buffer.as();
			key = buffer.toString();
		}

		if (map.containsKey(key)) {return map.get(key);}

		int result = INF;

		map.put(key, result); return result;

		int[] dx = {-1, 0, 0, 1}; int[] dy = {0, -1, 1, 0};
		for (int z = 0; z < 4; z++)
		{
			int x = i + dx[z]; int y = j + dy[z];
			if (x < 0 || x >= R || y < 0 || y >= C) {continue;}
		}
	}
*/

	public static void main(String[] args)
	{
		try
		{
			String FILE_NAME = args[0];
			String[] ABBREVIATION = {"SP", "LP", "S", "L", "S0", "S1", "S2", "S3", "S4", "S5", "S6", "S7", "S8", "S9"};
			String[] FULL_NAME =
			{
				"-small-practice", "-large-practice", "-small-attempt0", "-large", "-small-attempt0", "-small-attempt1", "-small-attempt2",
				"-small-attempt3", "-small-attempt4", "-small-attempt5", "-small-attempt6", "-small-attempt7", "-small-attempt8", "-small-attempt9"
			};
			for (int i = 0; i < ABBREVIATION.length; i++)
			{
				if (FILE_NAME.equals(ABBREVIATION[i])) {FILE_NAME = CLASS_NAME + FULL_NAME[i]; break;}
			}

			input = new BufferedReader(new FileReader(FILE_NAME  + ".in"));
			output = new BufferedWriter(new FileWriter(FILE_NAME + ".out"));

			String line = input.readLine();
			int testcases = getInt(line, 0);

			for (int testcase = 1; testcase <= testcases; testcase++)
			{
				line = input.readLine();
				int N = getInt(line, 0);

				line = input.readLine();
				int[] X = getIntArray(line); for (int i = 0; i < X.length; i++) {X[i]--;}

				int[] min = new int[N]; fill(min, 0);
				int[] max = new int[N]; fill(max, INF);
				int[] H = new int[N]; fill(H, -1);
				boolean impossible = false;

				H[0] = INF; H[X[0]] = min[X[0]] = max[X[0]] = INF;
				for (int i = 1; i < X[0]; i++) {max[i] = INF - 1;}
B1:
				for (int i = 1; i < X.length; i++)
				{
					H[X[i]] = min[X[i]] = max[X[i]];

					for (int j = i + 1; j < N; j++) if (-1 != H[j] && j != X[i])
					{
						if (j > X[i]) {max[i] = min(max[i], H[j] + ((H[X[i]] - H[j]) * (j - i) / (j - X[i])));}
						if (j < X[i]) {min[i] = max(min[i], H[X[i]] + ((H[j] - H[X[i]]) * (X[i] - i) / (j - i)));}
					}
					if (min[i] > max[i]) {impossible = true; break B1;}

					H[i] = max[i];

					for (int j = i + 1; j < N; j++)
					{
						if (j != X[i]) {max[j] = min(max[j], H[i] + ((H[X[i]] - H[i]) * (j - i) / (X[i] - i)));}
					}
				}

				H[X.length] = max[X.length];

				debug(H);

				SB result = new SB("Case #" + testcase + ": ");
				if (impossible) {result.a("Impossible");}
				else {for (int h : H) {result.a(h + " ");}}
				output(result.toS());
			}

			input.close();
			output.close();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	private static final BI BI0 = BI.v(0);
	private static final BI BI1 = BI.v(1);
	private static final BI BI2 = BI.v(2);
	private static final BI BI3 = BI.v(3);
	private static final BI BI4 = BI.v(4);
	private static final BI BI5 = BI.v(5);
	private static final BI BI6 = BI.v(6);
	private static final BI BI7 = BI.v(7);
	private static final BI BI8 = BI.v(8);
	private static final BI BI9 = BI.v(9);
	private static final BI BI10 = BI.v(10);

	private static final BD BD0 = BD.v(0);
	private static final BD BD1 = BD.v(1);
	private static final BD BD2 = BD.v(2);
	private static final BD BD3 = BD.v(3);
	private static final BD BD4 = BD.v(4);
	private static final BD BD5 = BD.v(5);
	private static final BD BD6 = BD.v(6);
	private static final BD BD7 = BD.v(7);
	private static final BD BD8 = BD.v(8);
	private static final BD BD9 = BD.v(9);
	private static final BD BD10 = BD.v(10);

	public static int getInt(String line, int index) {return Integer.parseInt(getString(line, index));}
	public static long getLong(String line, int index) {return Long.parseLong(getString(line, index));}
	public static double getDouble(String line, int index) {return Double.parseDouble(getString(line, index));}
	public static String getString(String line, int index)
	{
		line = line.trim();
		while (index > 0) {line = line.substring(line.indexOf(' ') + 1); index--;}

		if ((-1) == line.indexOf(' ')) {return line;}
		else {return line.substring(0, line.indexOf(' '));}
	}

	public static int[] getIntArray(String line)
	{
		String[] strings = getStringArray(line);
		int[] numbers = new int[strings.length];
		for (int i = 0; i < strings.length; i++) {numbers[i] = Integer.parseInt(strings[i]);}
		return numbers;
	}
	public static long[] getLongArray(String line)
	{
		String[] strings = getStringArray(line);
		long[] numbers = new long[strings.length];
		for (int i = 0; i < strings.length; i++) {numbers[i] = Long.parseLong(strings[i]);}
		return numbers;
	}
	public static double[] getDoubleArray(String line)
	{
		String[] strings = getStringArray(line);
		double[] numbers = new double[strings.length];
		for (int i = 0; i < strings.length; i++) {numbers[i] = Double.parseDouble(strings[i]);}
		return numbers;
	}
	public static String[] getStringArray(String line) {return line.trim().split("(\\s)+", 0);}

	public static int[] getIntArray(String line, int begin, int end)
	{
		String[] strings = getStringArray(line, begin, end);
		int[] numbers = new int[end - begin];
		for (int i = begin; i < end; i++) {numbers[i - begin] = Integer.parseInt(strings[i - begin]);}
		return numbers;
	}
	public static long[] getLongArray(String line, int begin, int end)
	{
		String[] strings = getStringArray(line, begin, end);
		long[] numbers = new long[end - begin];
		for (int i = begin; i < end; i++) {numbers[i - begin] = Long.parseLong(strings[i - begin]);}
		return numbers;
	}
	public static double[] getDoubleArray(String line, int begin, int end)
	{
		String[] strings = getStringArray(line, begin, end);
		double[] numbers = new double[end - begin];
		for (int i = begin; i < end; i++) {numbers[i - begin] = Double.parseDouble(strings[i - begin]);}
		return numbers;
	}
	public static String[] getStringArray(String line, int begin, int end)
	{
		String[] lines = line.trim().split("(\\s)+", 0);
		String[] results = new String[end - begin];
		for (int i = begin; i < end; i++) {results[i - begin] = lines[i];}
		return results;
	}

	public static String[] getStringArray(BufferedReader input, int N) throws Exception
	{
		String[] results = new String[N];
		for (int i = 0; i < N; i++) {results[i] = input.readLine();}
		return results;
	}

	public static char[][] getCharMatrix(BufferedReader input, int N) throws Exception {return getCharMatrix(input, N, N);}
	public static char[][] getCharMatrix(BufferedReader input, int R, int C) throws Exception
	{
		char[][] matrix = new char[R][C];
		for (int i = 0; i < R; i++)
		{
			String line = input.readLine();
			for (int j = 0; j < C; j++) {matrix[i][j] = line.charAt(j);}
		}
		return matrix;
	}
	public static int[][] getIntMatrix(BufferedReader input, int N) throws Exception {return getIntMatrix(input, N, N);}
	public static int[][] getIntMatrix(BufferedReader input, int R, int C) throws Exception
	{
		int[][] matrix = new int[R][C];
		for (int i = 0; i < R; i++)
		{
			String line = input.readLine();
			for (int j = 0; j < C; j++) {matrix[i][j] = getInt(line, j);}
		}
		return matrix;
	}
	public static long[][] getLongMatrix(BufferedReader input, int N) throws Exception {return getLongMatrix(input, N, N);}
	public static long[][] getLongMatrix(BufferedReader input, int R, int C) throws Exception
	{
		long[][] matrix = new long[R][C];
		for (int i = 0; i < R; i++)
		{
			String line = input.readLine();
			for (int j = 0; j < C; j++) {matrix[i][j] = getLong(line, j);}
		}
		return matrix;
	}
	public static double[][] getDoubleMatrix(BufferedReader input, int N) throws Exception {return getDoubleMatrix(input, N, N);}
	public static double[][] getDoubleMatrix(BufferedReader input, int R, int C) throws Exception
	{
		double[][] matrix = new double[R][C];
		for (int i = 0; i < R; i++)
		{
			String line = input.readLine();
			for (int j = 0; j < C; j++) {matrix[i][j] = getDouble(line, j);}
		}
		return matrix;
	}

	public static boolean[][] newBooleanMatrix(int R, int C, boolean value)
	{
		boolean[][] matrix = new boolean[R][C];
		for (int i = 0; i < R; i++) for(int j = 0; j < C; j++) {matrix[i][j] = value;}
		return matrix;
	}
	public static char[][] newCharMatrix(int R, int C, char value)
	{
		char[][] matrix = new char[R][C];
		for (int i = 0; i < R; i++) for(int j = 0; j < C; j++) {matrix[i][j] = value;}
		return matrix;
	}
	public static int[][] newIntMatrix(int R, int C, int value)
	{
		int[][] matrix = new int[R][C];
		for (int i = 0; i < R; i++) for(int j = 0; j < C; j++) {matrix[i][j] = value;}
		return matrix;
	}
	public static long[][] newLongMatrix(int R, int C, long value)
	{
		long[][] matrix = new long[R][C];
		for (int i = 0; i < R; i++) for(int j = 0; j < C; j++) {matrix[i][j] = value;}
		return matrix;
	}
	public static double[][] newDoubleMatrix(int R, int C, double value)
	{
		double[][] matrix = new double[R][C];
		for (int i = 0; i < R; i++) for(int j = 0; j < C; j++) {matrix[i][j] = value;}
		return matrix;
	}

	public static void swap(boolean[] a, int i, int j) {boolean temp = a[i]; a[i] = a[j]; a[j] = temp;}
	public static void swap(char[] a, int i, int j) {char temp = a[i]; a[i] = a[j]; a[j] = temp;}
	public static void swap(int[] a, int i, int j) {int temp = a[i]; a[i] = a[j]; a[j] = temp;}
	public static void swap(long[] a, int i, int j) {long temp = a[i]; a[i] = a[j]; a[j] = temp;}
	public static void swap(double[] a, int i, int j) {double temp = a[i]; a[i] = a[j]; a[j] = temp;}
	public static void reverse(boolean[] array) {for (int i = 0; i < array.length / 2; i++) {swap(array, i, array.length - 1 - i);}}
	public static void reverse(char[] array) {for (int i = 0; i < array.length / 2; i++) {swap(array, i, array.length - 1 - i);}}
	public static void reverse(int[] array) {for (int i = 0; i < array.length / 2; i++) {swap(array, i, array.length - 1 - i);}}
	public static void reverse(long[] array) {for (int i = 0; i < array.length / 2; i++) {swap(array, i, array.length - 1 - i);}}
	public static void reverse(double[] array) {for (int i = 0; i < array.length / 2; i++) {swap(array, i, array.length - 1 - i);}}

	public static void output(String s) throws Exception
	{
		if (ECHO_ON) {System.out.println(s);}
		output.write(s);
		output.newLine();
	}
	public static void output(char[][] array, String separator) throws Exception
	{
		for (int i = 0; i < array.length; i++)
		{
			StringBuffer buffer = new StringBuffer();

			for (int j = 0; j < array[0].length - 1; j++)
			{
				buffer.append(array[i][j] + separator);
			}

			buffer.append(array[i][array[0].length - 1]);

			output(buffer.toString());
		}
	}
	public static void output(int[][] array, String separator) throws Exception
	{
		for (int i = 0; i < array.length; i++)
		{
			StringBuffer buffer = new StringBuffer();

			for (int j = 0; j < array[0].length - 1; j++)
			{
				buffer.append(array[i][j] + separator);
			}

			buffer.append(array[i][array[0].length - 1]);

			output(buffer.toString());
		}
	}

	public static String toKey(boolean[] array)
	{
		StringBuffer buffer = new StringBuffer(array.length + ",");
		for (int i = 0; i < array.length / 16; i++)
		{
			char c = 0;
			for (int j = 0; j < 16; j++)
			{
				c <<= 1; if (array[i * 16 + j]) {c += 1;}
			}
			buffer.append(c + "");
		}
		char c = 0;
		for (int j = 0; j < (array.length % 16); j++)
		{
			c <<= 1; if (array[(array.length / 16) * 16 + j]) {c += 1;}
		}
		buffer.append(c + "");
		return buffer.toString();
	}
	public static String toKey(int[] array, int bit)
	{
		StringBuffer buffer = new StringBuffer(array.length + ",");
		if (bit > 16)
		{
			for (int i = 0; i < array.length; i++)
			{
				char c1 = (char)(array[i] >> 16);
				char c2 = (char)(array[i] & 0xFFFF);
				buffer.append("" + c1 + c2);
			}
		}
		else
		{
			int n = 16 / bit;
			for (int i = 0; i < array.length / n; i++)
			{
				char c = 0;
				for (int j = 0; j < n; j++)
				{
					c <<= bit; c += array[i * n + j];
				}
				buffer.append(c + "");
			}
			char c = 0;
			for (int j = 0; j < (array.length % n); j++)
			{
				c <<= bit; c += array[(array.length / n) * n + j];
			}
			buffer.append(c + "");
		}
		return buffer.toString();
	}

	public static boolean[] booleanListToArray(ArrayList<Boolean> list)
	{
		boolean[] result = new boolean[list.size()];
		for (int i = 0; i < list.size(); i++) {result[i] = list.get(i);}
		return result;
	}
	public static char[] charListToArray(ArrayList<Character> list)
	{
		char[] result = new char[list.size()];
		for (int i = 0; i < list.size(); i++) {result[i] = list.get(i);}
		return result;
	}
	public static int[] intListToArray(ArrayList<Integer> list)
	{
		int[] result = new int[list.size()];
		for (int i = 0; i < list.size(); i++) {result[i] = list.get(i);}
		return result;
	}
	public static long[] longListToArray(ArrayList<Long> list)
	{
		long[] result = new long[list.size()];
		for (int i = 0; i < list.size(); i++) {result[i] = list.get(i);}
		return result;
	}
	public static double[] doubleListToArray(ArrayList<Double> list)
	{
		double[] result = new double[list.size()];
		for (int i = 0; i < list.size(); i++) {result[i] = list.get(i);}
		return result;
	}

	public static void putMin(HM map, Object key, Comparable value)
	{
		if (!map.c(key)) {map.p(key, value);}
		else if (value.compareTo(map.g(key)) < 0) {map.p(key, value);}
	}

	public static void putMax(HM map, Object key, Comparable value)
	{
		if (!map.c(key)) {map.p(key, value);}
		else if (value.compareTo(map.g(key)) > 0) {map.p(key, value);}
	}

	public static int gcd(int n, int m) {return (0 == m) ? (n) : gcd(m, n % m);}
	public static long gcd(long n, long m) {return (0 == m) ? (n) : gcd(m, n % m);}

	public static int[] divisors(int X)
	{
		HashSet<Integer> set = new HashSet<Integer>();
		for (int i = 1; (i * i) <= X; i++)
		{
			if (0 == (X % i)) {set.add(i); set.add(X / i);}
		}
		int[] result = new int[set.size()]; int i = 0;
		for (Integer I : set) {result[i++] = I;} Arrays.sort(result);
		return result;
	}

	public static long[] divisors(long X)
	{
		HashSet<Long> set = new HashSet<Long>();
		for (long i = 1; (i * i) <= X; i++)
		{
			if (0 == (X % i)) {set.add(i); set.add(X / i);}
		}
		long[] result = new long[set.size()]; int i = 0;
		for (Long L : set) {result[i++] = L;} Arrays.sort(result);
		return result;
	}

	public static long[] primeDivisors(long X)
	{
		HashSet<Long> set = new HashSet<Long>();
		for (long i = 1; (i * i) <= X; i++)
		{
			if (0 == (X % i))
			{
				long multiple = X / i;
				if (nextPrime(i - 1) == i) {set.add(i);}
				if (nextPrime(multiple - 1) == multiple) {set.add(multiple);}
			}
		}
		long[] result = new long[set.size()]; int i = 0;
		for (Long L : set) {result[i++] = L;} Arrays.sort(result);
		return result;
	}

	public static int[] divisorOrders(long X, long[] divisor)
	{
		int[] order = new int[divisor.length];
		for (int i = 0; i < divisor.length; i++)
		{
			if (0 != X % divisor[i]) {return null;}
			long temp = X / divisor[i];
			order[i] = 1;
			while (temp % divisor[i] == 0)
			{
				temp /= divisor[i];
				order[i]++;
			}
		}
		return order;
	}

	// Java analog for C++ prev_permutation()
	public static boolean prev_permutation(char[] a)
	{
		int n = a.length;
		for (int i = n - 2; i >= 0; i--) if (a[i] > a[i + 1])
		for (int j = n - 1; j >= 0; j--) if (a[i] > a[j])
		{
			swap(a, i, j);
			for (int k = 1; k <= (n - i) / 2; k++) {swap(a, i + k, n - k);}
			return true;
		}
		return false;
	}

	public static boolean prev_permutation(int[] a)
	{
		int n = a.length;
		for (int i = n - 2; i >= 0; i--) if (a[i] > a[i + 1])
		for (int j = n - 1; j >= 0; j--) if (a[i] > a[j])
		{
			swap(a, i, j);
			for (int k = 1; k <= (n - i) / 2; k++) {swap(a, i + k, n - k);}
			return true;
		}
		return false;
	}

	// Java analog for C++ next_permutation()
	public static boolean next_permutation(char[] a)
	{
		int n = a.length;
		for (int i = n - 2; i >= 0; i--) if (a[i] < a[i + 1])
		for (int j = n - 1; j >= 0; j--) if (a[i] < a[j])
		{
			swap(a, i, j);
			for (int k = 1; k <= (n - i) / 2; k++) {swap(a, i + k, n - k);}
			return true;
		}
		return false;
	}

	public static boolean next_permutation(int[] a)
	{
		int n = a.length;
		for (int i = n - 2; i >= 0; i--) if (a[i] < a[i + 1])
		for (int j = n - 1; j >= 0; j--) if (a[i] < a[j])
		{
			swap(a, i, j);
			for (int k = 1; k <= (n - i) / 2; k++) {swap(a, i + k, n - k);}
			return true;
		}
		return false;
	}

	public static boolean next_iteration(char[] a, char min, char max)
	{
		int n = a.length;
		for (int i = n - 1; i >= 0; i--)
		{
			if (a[i] < max) {a[i]++; return true;}
			a[i] = min;
		}
		return false;
	}

	public static boolean next_iteration(int[] a, int min, int max)
	{
		int n = a.length;
		for (int i = n - 1; i >= 0; i--)
		{
			if (a[i] < max) {a[i]++; return true;}
			a[i] = min;
		}
		return false;
	}

	private static ArrayList<Long> PRIME = new ArrayList<Long>();
	public static long nextPrime(long number)
	{
		if (0 == PRIME.size()) {PRIME.add(new Long(2));}

		if (number >= PRIME.get(PRIME.size() - 1))
		{
			long i = PRIME.get(PRIME.size() - 1) + 1;
			while (number >= PRIME.get(PRIME.size() - 1))
			{
				boolean isPrime = true;
				for (int j = 0; j < PRIME.size(); j++) if (0 == (i % PRIME.get(j))) {isPrime = false; break;}
				if (isPrime)
				{
					PRIME.add(i);
					System.out.println("last prime = " + i);
				}
				i++;
			}
		}

		int begin = 0, end = PRIME.size() - 1, middle = (begin + end) / 2;
		while (begin != end)
		{
			if (number >= PRIME.get(middle)) {begin = middle + 1;}
			else {end = middle;}
			middle = (begin + end) / 2;
		}
		return PRIME.get(middle);
	}

	public static int sqrt(int X)
	{
		int answer = 1, interval = 1;
		for (int i = String.valueOf(X).length() / 2; i > 0; i--) {interval *= 10;}
		while (interval >= 1)
		{
			while ((answer * answer) <= X) {answer += interval;}
			answer -= interval;
			interval /= 10;
		}
		return answer;
	}

	public static long sqrt(long X)
	{
		long answer = 1, interval = 1;
		for (int i = String.valueOf(X).length() / 2; i > 0; i--) {interval *= 10;}
		while (interval >= 1)
		{
			while ((answer * answer) <= X) {answer += interval;}
			answer -= interval;
			interval /= 10;
		}
		return answer;
	}

	public static BI sqrt(BI X)
	{
		BI answer = BI.ONE;
		BI interval = BI.ONE;

		for (int i = X.toString().length() / 2; i > 0; i--)
		{
			interval = interval.multiply(BI.TEN);
		}

		while (interval.compareTo(BI.ONE) >= 0)
		{
			while (answer.multiply(answer).compareTo(X) <= 0)
			{
				answer = answer.add(interval);
			}
			answer = answer.subtract(interval);

			interval = interval.divide(BI.TEN);
		}

		return answer;
	}

	public static void debug(String s)
	{if (DEBUG_ON) {System.out.println(s);}}
	public static void debug(String s0, double l0)
	{if (DEBUG_ON) {System.out.println(s0+" = "+l0);}}
	public static void debug(String s0, double l0, String s1, double l1)
	{if (DEBUG_ON) {System.out.println(s0+" = "+l0+"; "+s1+" = "+l1);}}
	public static void debug(String s0, double l0, String s1, double l1, String s2, double l2)
	{if (DEBUG_ON) {	System.out.println(s0+" = "+l0+"; "+s1+" = "+l1+"; "+s2+" = "+l2);}}
	public static void debug(String s0, double l0, String s1, double l1, String s2, double l2, String s3, double l3)
	{if (DEBUG_ON) {System.out.println(s0+" = "+l0+"; "+s1+" = "+l1+"; "+s2+" = "+l2+"; "+s3+" = "+l3);}}
	public static void debug(String s0, double l0, String s1, double l1, String s2, double l2, String s3, double l3, String s4, double l4)
	{if (DEBUG_ON) {System.out.println(s0+" = "+l0+"; "+s1+" = "+l1+"; "+s2+" = "+l2+"; "+s3+" = "+l3+"; "+s4+" = "+l4);}}

	public static void debug(boolean[] array) {if (DEBUG_ON) {debug(array, " ");}}
	public static void debug(boolean[] array, String separator)
	{
		if (DEBUG_ON)
		{
			StringBuffer buffer = new StringBuffer();
			for (int i = 0; i < array.length - 1; i++) {buffer.append((array[i] == true ? "1" : "0") + separator);}
			if (array.length > 0) {buffer.append((array[array.length - 1] == true) ? "1" : "0");}
			System.out.println(buffer.toString());
		}
	}
	public static void debug(boolean[][] array) {if (DEBUG_ON) {debug(array, " ");}}
	public static void debug(boolean[][] array, String separator)
	{if (DEBUG_ON) {for (int i = 0; i < array.length; i++) {debug(array[i], separator);}}}

	public static void debug(char[] array) {if (DEBUG_ON) {debug(array, " ");}}
	public static void debug(char[] array, String separator)
	{
		if (DEBUG_ON)
		{
			StringBuffer buffer = new StringBuffer();
			for (int i = 0; i < array.length - 1; i++) {buffer.append(array[i] + separator);}
			if (array.length > 0) {buffer.append(array[array.length - 1]);}
			System.out.println(buffer.toString());
		}
	}
	public static void debug(char[][] array) {if (DEBUG_ON) {debug(array, " ");}}
	public static void debug(char[][] array, String separator)
	{if (DEBUG_ON) {for (int i = 0; i < array.length; i++) {debug(array[i], separator);}}}

	public static void debug(int[] array) {if (DEBUG_ON) {debug(array, " ");}}
	public static void debug(int[] array, String separator)
	{
		if (DEBUG_ON)
		{
			StringBuffer buffer = new StringBuffer();
			for (int i = 0; i < array.length - 1; i++) {buffer.append(array[i] + separator);}
			if (array.length > 0) {buffer.append(array[array.length - 1]);}
			System.out.println(buffer.toString());
		}
	}
	public static void debug(int[][] array) {if (DEBUG_ON) {debug(array, " ");}}
	public static void debug(int[][] array, String separator)
	{if (DEBUG_ON) {for (int i = 0; i < array.length; i++) {debug(array[i], separator);}}}

	public static void debug(long[] array) {if (DEBUG_ON) {debug(array, " ");}}
	public static void debug(long[] array, String separator)
	{
		if (DEBUG_ON)
		{
			StringBuffer buffer = new StringBuffer();
			for (int i = 0; i < array.length - 1; i++) {buffer.append(array[i] + separator);}
			if (array.length > 0) {buffer.append(array[array.length - 1]);}
			System.out.println(buffer.toString());
		}
	}
	public static void debug(long[][] array) {if (DEBUG_ON) {debug(array, " ");}}
	public static void debug(long[][] array, String separator)
	{if (DEBUG_ON) {for (int i = 0; i < array.length; i++) {debug(array[i], separator);}}}

	public static void debug(double[] array) {if (DEBUG_ON) {debug(array, " ");}}
	public static void debug(double[] array, String separator)
	{
		if (DEBUG_ON)
		{
			StringBuffer buffer = new StringBuffer();
			for (int i = 0; i < array.length - 1; i++) {buffer.append(array[i] + separator);}
			if (array.length > 0) {buffer.append(array[array.length - 1]);}
			System.out.println(buffer.toString());
		}
	}
	public static void debug(double[][] array) {if (DEBUG_ON) {debug(array, " ");}}
	public static void debug(double[][] array, String separator)
	{if (DEBUG_ON) {for (int i = 0; i < array.length; i++) {debug(array[i], separator);}}}

	public static void debug(Object[] array) {if (DEBUG_ON) {debug(array, " ");}}
	public static void debug(Object[] array, String separator)
	{
		if (DEBUG_ON)
		{
			StringBuffer buffer = new StringBuffer();
			for (int i = 0; i < array.length - 1; i++) {buffer.append(array[i] + separator);}
			if (array.length > 0) {buffer.append(array[array.length - 1]);}
			System.out.println(buffer.toString());
		}
	}
	public static void debug(Object[][] array) {if (DEBUG_ON) {debug(array, " ");}}
	public static void debug(Object[][] array, String separator)
	{if (DEBUG_ON) {for (int i = 0; i < array.length; i++) {debug(array[i], separator);}}}

	public static void debug(ArrayList array) {if (DEBUG_ON) {debug(array, " ");}}
	public static void debug(ArrayList array, String separator)
	{
		if (DEBUG_ON)
		{
			StringBuffer buffer = new StringBuffer();
			for (Object o : array) {buffer.append(o.toString() + separator);}
			System.out.println(buffer.toString());
		}
	}
}

class HS<Type> extends HashSet<Type>
{
	public HS() {super();}
	public HS(Collection<? extends Type> c) {super(c);}
	public HS(int initialCapacity) {super(initialCapacity);}
	public HS(int initialCapacity, float loadFactor) {super(initialCapacity, loadFactor);}
	public boolean a(Type e) {return super.add(e);}
	public boolean c(Object o) {return super.contains(o);}
	public boolean r(Object o) {return super.remove(o);}
	public int s() {return super.size();}
	public String toS() {return super.toString();}
}

class HM<Key, Value> extends HashMap<Key, Value>
{
	public HM() {super();}
	public HM(int initialCapacity) {super(initialCapacity);}
	public HM(int initialCapacity, float loadFactor) {super(initialCapacity, loadFactor);}
	public HM(Map<? extends Key, ? extends Value> m) {super(m);}
	public boolean c(Object key) {return super.containsKey(key);}
	public Value g(Object key) {return super.get(key);}
	public Set<Key> ks() {return super.keySet();}
	public Value p(Key key, Value value) {return super.put(key, value);}
	public Value r(Object key) {return super.remove(key);}
	public int s() {return super.size();}
	public String toS() {return super.toString();}
}

class AL<Type> extends ArrayList<Type>
{
	public AL() {super();}
	public AL(Collection<? extends Type> c) {super(c);}
	public AL(int initialCapacity) {super(initialCapacity);}
	public boolean a(Type e) {return super.add(e);}
	public void a(int index, Type element) {super.add(index, element);}
	public boolean c(Object o) {return super.contains(o);}
	public Type g(int index) {return super.get(index);}
	public Type r(int index) {return super.remove(index);}
	public boolean r(Object o) {return super.remove(o);}
	public int s() {return super.size();}
	public String toS() {return super.toString();}
}

class BI extends BigInteger
{
	public static BI ONE = BI.v(1);
	public static BI TEN = BI.v(10);
	public static BI ZERO = BI.v(0);
	public BI(byte[] val) {super(val);}
	public BI(int signum, byte[] magnitude) {super(signum, magnitude);}
	public BI(int bitLength, int certainty, Random rnd) {super(bitLength, certainty, rnd);}
	public BI(int numBits, Random rnd) {super(numBits, rnd);}
	public BI(String val) {super(val);}
	public BI(String val, int radix) {super(val, radix);}
	public BI abs() {if (super.compareTo(super.ZERO) < 0) {return new BI(super.negate().toString());} return this;}
	public BI add(BI val) {return new BI(super.add(val).toString());}
	public BI a(BI val) {return new BI(super.add(val).toString());}
	public BI and(BI val) {return new BI(super.and(val).toString());}
	public BI andNot(BI val) {return new BI(super.andNot(val).toString());}
	public BI clearBit(int n) {return new BI(super.clearBit(n).toString());}
	public int compareTo(BI val) {return super.compareTo(val);}
	public int c(BI val) {return super.compareTo(val);}
	public BI divide(BI val) {return new BI(super.divide(val).toString());}
	public BI d(BI val) {return new BI(super.divide(val).toString());}
	public BI[] divideAndRemainder(BI val)
	{
		BI[] result = new BI[2];
		BigInteger[] bi = super.divideAndRemainder(val);
		result[0] = new BI(bi[0].toString()); result[1] = new BI(bi[1].toString());
		return result;
	}
	public BI flipBit(int n) {return new BI(super.flipBit(n).toString());}
	public BI gcd(BI val) {return new BI(super.gcd(val).toString());}
	public BI lcm(BI val) {return new BI(super.divide(super.gcd(val)).multiply(val).toString());}
	public BI max(BI val) {if (super.compareTo(val) > 0) {return this;} else {return val;}}
	public BI min(BI val) {if (super.compareTo(val) < 0) {return this;} else {return val;}}
	public BI mod(BI m) {return new BI(super.mod(m).toString());}
	public BI modInverse(BI m) {return new BI(super.modInverse(m).toString());}
	public BI modPow(BI exponent, BI m) {return new BI(super.modPow(exponent, m).toString());}
	public BI multiply(BI val) {return new BI(super.multiply(val).toString());}
	public BI m(BI val) {return new BI(super.multiply(val).toString());}
	public BI negate() {return new BI(super.negate().toString());}
	public BI nextProbablePrime() {return new BI(super.nextProbablePrime().toString());}
	public BI not() {return new BI(super.not().toString());}
	public BI or(BI val) {return new BI(super.or(val).toString());}
	public BI pow(int exponent) {return new BI(super.pow(exponent).toString());}
	public static BI probablePrime(int bitLength, Random rnd) {return new BI(BigInteger.probablePrime(bitLength, rnd).toString());}
	public BI remainder(BI val) {return new BI(super.remainder(val).toString());}
	public BI setBit(int n) {return new BI(super.setBit(n).toString());}
	public BI shiftLeft(int n) {return new BI(super.shiftLeft(n).toString());}
	public BI shiftRight(int n) {return new BI(super.shiftRight(n).toString());}
	public BI subtract(BI val) {return new BI(super.subtract(val).toString());}
	public BI s(BI val) {return new BI(super.subtract(val).toString());}
	public String toS() {return super.toString();}
	public String toS(int radix) {return super.toString(radix);}
	public static BI valueOf(long val) {return new BI(Long.toString(val));}
	public static BI v(long val) {return new BI(Long.toString(val));}
	public BI xor(BI val) {return new BI(super.xor(val).toString());}
}

class BD extends BigDecimal
{
	public static BD ONE = BD.v(1);
	public static BD TEN = BD.v(10);
	public static BD ZERO = BD.v(0);
	public BD(BI val) {super(val);}
	public BD(BI unscaledVal, int scale) {super(unscaledVal, scale);}
	public BD(BI unscaledVal, int scale, MathContext mc) {super(unscaledVal, scale, mc);}
	public BD(BI val, MathContext mc) {super(val, mc);}
	public BD(char[] in) {super(in);}
	public BD(char[] in, int offset, int len) {super(in, offset, len);}
	public BD(char[] in, int offset, int len, MathContext mc) {super(in, offset, len, mc);}
	public BD(char[] in, MathContext mc) {super(in, mc);}
	public BD(double val) {super(val);}
	public BD(double val, MathContext mc) {super(val, mc);}
	public BD(int val) {super(val);}
	public BD(int val, MathContext mc) {super(val, mc);}
	public BD(long val) {super(val);}
	public BD(long val, MathContext mc) {super(val, mc);}
	public BD(String val) {super(val);}
	public BD(String val, MathContext mc) {super(val, mc);}
	public BD abs() {if (super.compareTo(super.ZERO) < 0) {return new BD(super.negate().toString());} return this;}
	public BD abs(MathContext mc) {if (super.compareTo(super.ZERO) < 0) {return new BD(super.negate().toString(), mc);} return this.round(mc);}
	public BD add(BigDecimal augend) {return new BD(super.add(augend).toString());}
	public BD a(BigDecimal augend) {return new BD(super.add(augend).toString());}
	public BD add(BigDecimal augend, MathContext mc) {return new BD(super.add(augend, mc).toString());}
	public BD a(BigDecimal augend, MathContext mc) {return new BD(super.add(augend, mc).toString());}
	public int compareTo(BD val) {return super.compareTo(val);}
	public int c(BD val) {return super.compareTo(val);}
	public BD divide(BD divisor) {return new BD(super.divide(divisor).toString());}
	public BD d(BD divisor) {return new BD(super.divide(divisor).toString());}
	public BD divide(BD divisor, int roundingMode) {return new BD(super.divide(divisor, roundingMode).toString());}
	public BD d(BD divisor, int roundingMode) {return new BD(super.divide(divisor, roundingMode).toString());}
	public BD divide(BD divisor, int scale, int roundingMode) {return new BD(super.divide(divisor, scale, roundingMode).toString());}
	public BD d(BD divisor, int scale, int roundingMode) {return new BD(super.divide(divisor, scale, roundingMode).toString());}
	public BD divide(BD divisor, int scale, RoundingMode roundingMode) {return new BD(super.divide(divisor, scale, roundingMode).toString());}
	public BD d(BD divisor, int scale, RoundingMode roundingMode) {return new BD(super.divide(divisor, scale, roundingMode).toString());}
	public BD divide(BD divisor, MathContext mc) {return new BD(super.divide(divisor, mc).toString());}
	public BD d(BD divisor, MathContext mc) {return new BD(super.divide(divisor, mc).toString());}
	public BD divide(BD divisor, RoundingMode roundingMode) {return new BD(super.divide(divisor, roundingMode).toString());}
	public BD d(BD divisor, RoundingMode roundingMode) {return new BD(super.divide(divisor, roundingMode).toString());}
	public BD[] divideAndRemainder(BD divisor)
	{
		BD[] result = new BD[2];
		BigDecimal[] bd = super.divideAndRemainder(divisor);
		result[0] = new BD(bd[0].toString()); result[1] = new BD(bd[1].toString());
		return result;
	}
	public BD[] divideAndRemainder(BD divisor, MathContext mc)
	{
		BD[] result = new BD[2];
		BigDecimal[] bd = super.divideAndRemainder(divisor, mc);
		result[0] = new BD(bd[0].toString()); result[1] = new BD(bd[1].toString());
		return result;
	}
	public BD divideToIntegralValue(BD divisor) {return new BD(super.divideToIntegralValue(divisor).toString());}
	public BD divideToIntegralValue(BigDecimal divisor, MathContext mc) {return new BD(super.divideToIntegralValue(divisor, mc).toString());}
	public BD max(BD val) {if (super.compareTo(val) > 0) {return this;} else {return val;}}
	public BD min(BD val) {if (super.compareTo(val) < 0) {return this;} else {return val;}}
	public BD movePointLeft(int n) {return new BD(super.movePointLeft(n).toString());}
	public BD movePointRight(int n) {return new BD(super.movePointRight(n).toString());}
	public BD multiply(BD multiplicand) {return new BD(super.multiply(multiplicand).toString());}
	public BD m(BD multiplicand) {return new BD(super.multiply(multiplicand).toString());}
	public BD multiply(BD multiplicand, MathContext mc) {return new BD(super.multiply(multiplicand, mc).toString());}
	public BD m(BD multiplicand, MathContext mc) {return new BD(super.multiply(multiplicand, mc).toString());}
	public BD negate() {return new BD(super.negate().toString());}
	public BD negate(MathContext mc) {return new BD(super.negate(mc).toString());}
	public BD plus() {return new BD(super.plus().toString());}
	public BD plus(MathContext mc) {return new BD(super.plus(mc).toString());}
	public BD pow(int n) {return new BD(super.pow(n).toString());}
	public BD pow(int n, MathContext mc) {return new BD(super.pow(n, mc).toString());}
	public BD remainder(BigDecimal divisor) {return new BD(super.remainder(divisor).toString());}
	public BD remainder(BigDecimal divisor, MathContext mc) {return new BD(super.remainder(divisor, mc).toString());}
	public BD round(MathContext mc) {return new BD(super.round(mc).toString());}
	public BD scaleByPowerOfTen(int n) {return new BD(super.scaleByPowerOfTen(n).toString());}
	public BD setScale(int newScale) {return new BD(super.setScale(newScale).toString());}
	public BD setScale(int newScale, int roundingMode) {return new BD(super.setScale(newScale, roundingMode).toString());}
	public BD setScale(int newScale, RoundingMode roundingMode) {return new BD(super.setScale(newScale, roundingMode).toString());}
	public BD stripTrailingZeros() {return new BD(super.stripTrailingZeros().toString());}
	public BD subtract(BD subtrahend) {return new BD(super.subtract(subtrahend).toString());}
	public BD s(BD subtrahend) {return new BD(super.subtract(subtrahend).toString());}
	public BD subtract(BD subtrahend, MathContext mc) {return new BD(super.subtract(subtrahend, mc).toString());}
	public BD s(BD subtrahend, MathContext mc) {return new BD(super.subtract(subtrahend, mc).toString());}
	public BI toBI() {return new BI(super.toBigInteger().toString());}
	public BI toBIExact() {return new BI(super.toBigIntegerExact().toString());}
	public String toS() {return super.toString();}
	public BD ulp() {return new BD(super.ulp().toString());}
	public BI unscaledValue() {return new BI(super.unscaledValue().toString());}
	public static BD valueOf(double val) {return new BD(val);}
	public static BD v(double val) {return new BD(val);}
	public static BD valueOf(long val) {return new BD(val);}
	public static BD v(long val) {return new BD(val);}
	public static BD valueOf(long unscaledVal, int scale) {return new BD(BigDecimal.valueOf(unscaledVal, scale).toString());}
	public static BD v(long unscaledVal, int scale) {return new BD(BigDecimal.valueOf(unscaledVal, scale).toString());}
}

class SB
{
	private StringBuffer buffer;
	public SB() {buffer = new StringBuffer();}
	public SB(CharSequence seq) {buffer = new StringBuffer(seq);}
	public SB(int capacity) {buffer = new StringBuffer(capacity);}
	public SB(String str) {buffer = new StringBuffer(str);}
	public SB append(boolean b) {buffer.append(b); return this;}
	public SB a(boolean b) {buffer.append(b); return this;}
	public SB as(boolean b) {buffer.append(b); buffer.append(','); return this;}
	public SB append(char c) {buffer.append(c); return this;}
	public SB a(char c) {buffer.append(c); return this;}
	public SB as(char c) {buffer.append(c); buffer.append(','); return this;}
	public SB append(char[] str) {buffer.append(str); return this;}
	public SB a(char[] str) {buffer.append(str); return this;}
	public SB as(char[] str) {buffer.append(str); buffer.append(','); return this;}
	public SB append(char[] str, int offset, int len) {buffer.append(str, offset, len); return this;}
	public SB a(char[] str, int offset, int len) {buffer.append(str, offset, len); return this;}
	public SB as(char[] str, int offset, int len) {buffer.append(str, offset, len); buffer.append(','); return this;}
	public SB append(CharSequence s) {buffer.append(s); return this;}
	public SB a(CharSequence s) {buffer.append(s); return this;}
	public SB as(CharSequence s) {buffer.append(s); buffer.append(','); return this;}
	public SB append(CharSequence s, int start, int end) {buffer.append(s, start, end); return this;}
	public SB a(CharSequence s, int start, int end) {buffer.append(s, start, end); return this;}
	public SB as(CharSequence s, int start, int end) {buffer.append(s, start, end); buffer.append(','); return this;}
	public SB append(double d) {buffer.append(d); return this;}
	public SB a(double d) {buffer.append(d); return this;}
	public SB as(double d) {buffer.append(d); buffer.append(','); return this;}
	public SB append(float f) {buffer.append(f); return this;}
	public SB a(float f) {buffer.append(f); return this;}
	public SB as(float f) {buffer.append(f); buffer.append(','); return this;}
	public SB append(int i) {buffer.append(i); return this;}
	public SB a(int i) {buffer.append(i); return this;}
	public SB as(int i) {buffer.append(i); buffer.append(','); return this;}
	public SB append(long l) {buffer.append(l); return this;}
	public SB a(long l) {buffer.append(l); return this;}
	public SB as(long l) {buffer.append(l); buffer.append(','); return this;}
	public SB append(Object obj) {buffer.append(obj); return this;}
	public SB a(Object obj) {buffer.append(obj); return this;}
	public SB as(Object obj) {buffer.append(obj); buffer.append(','); return this;}
	public SB append(String str) {buffer.append(str); return this;}
	public SB a(String str) {buffer.append(str); return this;}
	public SB as(String str) {buffer.append(str); buffer.append(','); return this;}
	public SB append(SB sb) {buffer.append(sb.buffer); return this;}
	public SB a(SB sb) {buffer.append(sb.buffer); return this;}
	public SB as(SB sb) {buffer.append(sb.buffer); buffer.append(','); return this;}
	public String toString() {return buffer.toString();}
	public String toS() {return buffer.toString();}
}

class Color
{
	Color parent = null;

	public Color getColor()
	{
		Color n = this;

		LinkedList<Color> list = new LinkedList<Color>();

		while (null != n.parent)
		{
			list.addLast(n);

			if (10000 == list.size())
			{
				while (list.size() > 0)
				{
					Color c = list.removeFirst();
					c.parent = n.parent;
				}
			}

			n = n.parent;
		}

		while (list.size() > 0)
		{
			Color c = list.removeFirst();
			c.parent = n;
		}

		return n;
	}

	public void setColor(Color c)
	{
		Color a = this.getColor();
		Color b = c.getColor();
		if (a == b) return;

		Color n = this;

		while (null != n.parent)
		{
			Color p = n.parent;
			n.parent = b;
			n = p;
		}

		n.parent = b;
	}
}
